//Back Button Template
angularApp.directive('backButtonTmpl',function(utilityService){
    'use strict';
    return{
        restrict: 'E',
        scope: {
            goback:"&"          
        },
        require: '?ngModel',
        transclude : false,
        replace: false,
        templateUrl:'common/directives/templates/backButtonTmpl.html',
        link:function (scope, element, attrs,ngModel) {
        	if(utilityService.isUndefined(attrs.module)){
        		scope.module="back-page";
        	}else{        		
            	switch(attrs.module){
            	case 'omp' :
            		scope.module="backBtnRed";
    				break;
            	case 'ft' :
            		scope.module="backBtnPurple";
    				break;
            	case 'aov' :
            		scope.module="backBtnPurple";
    				break;
            	case 'ao' :
            		scope.module="backBtnPurple";
    				break;
            	case 'fd' :
            		scope.module="backBtnPurple";
    				break;
                case 'fss' :
                    scope.module="backBtnRed";
                    break;
            	default:
            		scope.module="back-page";
            	}
        	}
        	
            scope.goBack=function(){
            scope.goback();
         }
         
     },    
 };
});