//Back Button Template
angularApp.directive('crossButtonTmpl',function(homeScreenService,utilityService,$state,homeLoanService,getAccountDetailsService,serviceRequestService,clickStreamService, $stateParams){
    'use strict';
    return{
        restrict: 'E',
        scope: {
            goHome:"&",
            color : "@",
            redirect : "@"      
        },
        require: '?ngModel',
        transclude : false,
        replace: false,
        templateUrl:'common/directives/templates/crossButtonTmpl.html',
        link:function (scope, element, attrs,ngModel) {
            if(scope.color && scope.color == "purple"){
                scope.imgSource = "img/FSS/Close_Purple.svg";
            }else if(scope.color && scope.color == "gradient-Registered"){
                scope.imgSource = "img/FSS/Close_Purple.svg";
            }else if(scope.color && scope.color == "gradient-Unregistered"){
                scope.imgSource = "img/FSS/Close_Purple.svg";
            }else if(scope.color && (scope.color == "purpleClose" || scope.color == "purpleEStmtClose" || scope.color == "purpleSettingClose")){
                scope.imgSource = "img/nfs_close.png";
            }else if(scope.color && scope.color == "inbClose"){
                scope.imgSource = "img/nfs_close.png";
            }else if(scope.color && scope.color == "eduClose"){
                scope.imgSource = "img/nfs_close.png";
            }
            else if(scope.color && scope.color == "agriClose"){
                scope.imgSource = "img/nfs_close.png";
            }
            else if(scope.color && scope.color == "fdMaturityClose"){
                scope.imgSource = "img/FSS/Close_Purple.svg";
            }
            else if(scope.color && scope.color == "fdMaturityIntClose"){
                scope.imgSource = "img/FSS/Close_Purple.svg";
            }
            else{
                scope.imgSource = "img/Menu/crossTmpl.svg";
            }
            scope.goHome = function(){
                if(scope.color && scope.color == "purple"){
                  var generalParams = $stateParams.lifeGeneInsure;
                    if(generalParams == true){
                        $state.go('menu.generalInsurance', {lifeGeneInsure : false})
                    }else{
                        getAccountDetailsService.tabIndex.tabIndex = 4;
                        $state.go('menu.accountOverviewMyBalance');
                    }
                }else if(scope.color && scope.color == "gradient-Registered"){
                    $state.go('menu.fundtrans');
                }else if(scope.color && scope.color == "gradient-Unregistered"){
                    $state.go('menu.fundsTransferLanding');
                }else if(scope.color && scope.color == "purpleClose"){
                    $state.go('menu.homeScreen');
                }else if(scope.color && scope.color == "inbClose"){
                    $state.go('menu.userLogin');
                }else if(scope.color && scope.color == "eduClose" && scope.redirect && scope.redirect == "accountBalance"){
                    getAccountDetailsService.tabIndex.tabIndex = 4;
                    if($state.current.data.pageId == "LI_SSRENW_SUC"){
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "CRS_BTN"));
                    }
                    homeScreenService.isInsuranceFlag=true;
                    $state.go('menu.accountOverviewMyBalance');
                }else if(scope.color && scope.color == "eduClose" && scope.redirect && scope.redirect == "onlineDemat"){
                    homeScreenService.isInvestmentFlag = true;
                    getAccountDetailsService.tabIndex.tabIndex = 3;
                    $state.go('menu.accountOverviewMyBalance');
                }else if(scope.color && scope.color == "eduClose"){
                    $state.go('menu.loans');
                }
                else if(scope.color && scope.color == "agriClose"){
                  $state.go('menu.agriLanding');
            }
            else if(scope.color && scope.color == "fdMaturityClose"){
                $state.go("menu.fixedDepositDetails");
            }
            else if(scope.color && scope.color == "fdMaturityIntClose"){
                $state.go("menu.FDChangeMaturity");
            }
            else if(scope.color && scope.color == "purpleEStmtClose"){
                serviceRequestService.innerpageHeader = "Account";
              serviceRequestService.imageIcon='img/serviceRequest/Account.svg';
              serviceRequestService.innerLinks=serviceRequestService.getAccountOptions();
               $state.go('menu.innerPage');
            }
            else if(scope.color && scope.color == "purpleSettingClose"){
                
               $state.go('menu.settings');
            }
                else{
                  $state.go('menu.homeScreen');
                  homeLoanService.clearAll();                    
                }
            }
         
     },    
 };
});
