angularApp.directive('ycFooterTmpl', function(constantConfig) {
    'use strict';
    return {
        restrict: 'E',
        scope: {
            goback: "&",
            gonext: "&",
            goconfirm: "&",
            showback: '=',
            shownext: '=',
            showconfirm: '=',
            disableback: "=",
            disablenext: "=",
            disableconfirm: "=",
            aofooter: "=",
            backenabled: "="


        },
        require: '?ngModel',
        transclude: false,
        replace: false,
        templateUrl: constantConfig.templateUrl.ycFooterTmpl,
        link: function(scope, element, attrs, ngModel) {
            scope.nextText = (attrs.nexttext) ? attrs.nexttext : 'NEXT';
			scope.backText = (attrs.backtext) ? attrs.backtext : 'BACK';
            scope.goBack = function() {
                scope.goback();
            }
            scope.goNext = function() {
                scope.gonext();
            }
            scope.goConfirm = function() {
                scope.goconfirm();
            }
        },
    };
});