'use strict';
angularApp.service('cameraService',
	function($cordovaCamera,$q){
       

var getnewImage=function(){
	 var options = {
             quality: 50,
             destinationType: Camera.DestinationType.DATA_URL,
             sourceType: Camera.PictureSourceType.CAMERA,
             allowEdit: false,
             encodingType: Camera.EncodingType.JPEG,
             popoverOptions: CameraPopoverOptions,
             saveToPhotoAlbum: false,
             correctOrientation:true
             }; 
           var q =  $q.defer();
                    $cordovaCamera.getPicture(options).then(function(imageData) {
                    	q.resolve( "data:image/jpeg;base64," + imageData)
                    }, function(err) {
                    	q.reject("error");
                    });
            return q.promise;
}

var getnewSignatureAoNps=function(){
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.DATA_URL,
            sourceType: Camera.PictureSourceType.CAMERA,
            allowEdit: false,
            encodingType: Camera.EncodingType.JPEG,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation:true
            }; 
          var q =  $q.defer();
                   $cordovaCamera.getPicture(options).then(function(imageData) {
                           q.resolve( "data:image/jpeg;base64," + imageData)
                   }, function(err) {
                       if(err == "No Image Selected" || err == "no image selected"){
                               q.reject("No Image Captured")
                       }else if(err == "20"){
                               q.reject("Permission Denied");
                       }else{
                           q.reject("error");
                       }
                   });
           return q.promise;
}

var getSignatureFromGalleryAoNps=function(){
        var options = {
            quality: 100,
            destinationType: Camera.DestinationType.DATA_URL,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            allowEdit: true,
            popoverOptions: CameraPopoverOptions,
            correctOrientation:true
            }; 
          var q =  $q.defer();
                   $cordovaCamera.getPicture(options).then(function(imageData) {
                           q.resolve( "data:image/jpeg;base64," + imageData)
                   }, function(err) {
                        if(err == "No Image Selected" || err == "no image selected" || err == "has no access to assets"){
                                q.reject("No Image Selected")
                        }else if(err == "20"){
                                q.reject("Permission Denied");
                        }else{
                            q.reject("error");
                        }
                   });
           return q.promise;
}

var getnewImageAoNps=function(){
	 var options = {
             quality: 50,
             destinationType: Camera.DestinationType.DATA_URL,
             sourceType: Camera.PictureSourceType.CAMERA,
             allowEdit: false,
             encodingType: Camera.EncodingType.JPEG,
             popoverOptions: CameraPopoverOptions,
             saveToPhotoAlbum: false,
             correctOrientation:true,
             targetWidth:300,
             targetHeight:300
             }; 
           var q =  $q.defer();
                    $cordovaCamera.getPicture(options).then(function(imageData) {
                    	q.resolve( "data:image/jpeg;base64," + imageData)
                    }, function(err) {
                        if(err == "No Image Selected" || err == "no image selected"){
                                q.reject("No Image Captured")
                        }else if(err == "20"){
                                q.reject("Permission Denied");
                        }else{
                            q.reject("error");
                        }
                    });
            return q.promise;
}

var getImageFromGalleryAoNps=function(){
        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.DATA_URL,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            allowEdit: true,
            popoverOptions: CameraPopoverOptions,
            correctOrientation:true,
            targetWidth:300,
            targetHeight:300
            }; 
          var q =  $q.defer();
                   $cordovaCamera.getPicture(options).then(function(imageData) {
                           q.resolve( "data:image/jpeg;base64," + imageData)
                   }, function(err) {
                        if(err == "No Image Selected" || err == "no image selected" || err == "has no access to assets"){
                                q.reject("No Image Selected")
                        }else if(err == "20"){
                                q.reject("Permission Denied");
                        }else{
                            q.reject("error");
                        }
                   });
           return q.promise;
}



var getnewDreamImage=function(){
	 var options = {
             quality: 70,
             destinationType: Camera.DestinationType.DATA_URL,
             sourceType: Camera.PictureSourceType.CAMERA,
             allowEdit: true,
             encodingType: Camera.EncodingType.JPEG,
             targetWidth: 100,
             targetHeight:100,
             popoverOptions: CameraPopoverOptions,
             saveToPhotoAlbum: false,
             correctOrientation:true
             }; 
           var q =  $q.defer();
                    $cordovaCamera.getPicture(options).then(function(imageData) {
                    	q.resolve( "data:image/jpeg;base64," + imageData)
                    }, function(err) {
                    	q.reject("error");
                    });
            return q.promise;
}


        var getImageFromGallery=function(){
        	 var options = {
                     quality: 50,
                     destinationType: Camera.DestinationType.DATA_URL,
                     sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                     allowEdit: false,
                     popoverOptions: CameraPopoverOptions,
                     correctOrientation:true
                     }; 
                   var q =  $q.defer();
                            $cordovaCamera.getPicture(options).then(function(imageData) {
                            	q.resolve( "data:image/jpeg;base64," + imageData)
                            }, function(err) {
                            	q.reject("error");
                            });
                    return q.promise;
        }

        var getSmallImageFromGallery=function(){
        	 var options = {
                     quality: 90,
                     destinationType: Camera.DestinationType.DATA_URL,
                     sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                     allowEdit: true,
                     popoverOptions: CameraPopoverOptions,
                     correctOrientation:true,
                     targetWidth: 100,
                     targetHeight:100
                     }; 
                   var q =  $q.defer();
                            $cordovaCamera.getPicture(options).then(function(imageData) {
                            	q.resolve( "data:image/jpeg;base64," + imageData)
                            }, function(err) {
                            	q.reject("error");
                            });
                    return q.promise;
        }
        var getImageFromGalleryMF=function(){
             var options = {
                     quality: 50,
                     destinationType: Camera.DestinationType.DATA_URL,
                     sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                     allowEdit: true,
                     popoverOptions: CameraPopoverOptions,
                     correctOrientation:true,
                     targetWidth: 1000,
                     targetHeight: 0,
                     }; 
                   var q =  $q.defer();
                            $cordovaCamera.getPicture(options).then(function(imageData) {
                                q.resolve( "data:image/jpeg;base64," + imageData)
                            }, function(err) {
                                q.reject("error");
                            });
                    return q.promise;
        }
        var getnewImageMF=function(){
         var options = {
                 quality: 50,
                 destinationType: Camera.DestinationType.DATA_URL,
                 sourceType: Camera.PictureSourceType.CAMERA,
                 allowEdit: true,
                 encodingType: Camera.EncodingType.JPEG,
                 popoverOptions: CameraPopoverOptions,
                 saveToPhotoAlbum: false,
                 correctOrientation:true,
                 targetWidth: 1000,
                 targetHeight: 0,
                 }; 
               var q =  $q.defer();
                        $cordovaCamera.getPicture(options).then(function(imageData) {
                            q.resolve( "data:image/jpeg;base64," + imageData)
                        }, function(err) {
                            q.reject("error");
                        });
                return q.promise;
        }

        var getImageFromGalleryWithoutCompress=function(){
        	 var options = {
                     quality: 90,
                     destinationType: Camera.DestinationType.DATA_URL,
                     sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                     allowEdit: true,
                     popoverOptions: CameraPopoverOptions,
                     correctOrientation:true,
                     //targetWidth: 2000
                     }; 
                   var q =  $q.defer();
                            $cordovaCamera.getPicture(options).then(function(imageData) {
                            	q.resolve( "data:image/jpeg;base64," + imageData)
                            }, function(err) {
                            	q.reject("error");
                            });
                    return q.promise;
        }


return {
    getnewImage : getnewImage,
    getnewSignatureAoNps : getnewSignatureAoNps,
    getSignatureFromGalleryAoNps : getSignatureFromGalleryAoNps,
    getnewImageAoNps:getnewImageAoNps,
    getImageFromGalleryAoNps:getImageFromGalleryAoNps,
    getnewDreamImage : getnewDreamImage,
    getImageFromGallery:getImageFromGallery,
    getSmallImageFromGallery:getSmallImageFromGallery,
    getImageFromGalleryMF:getImageFromGalleryMF,
    getnewImageMF:getnewImageMF,
    getImageFromGalleryWithoutCompress:getImageFromGalleryWithoutCompress
}; 
}); 
