
angularApp.service('validateService', validateService);

validateService.$inject = ["$translate", "$filter"];

function validateService($translate, $filter) {
    var isValidYesNo = function(agree) {
        if (agree == undefined) {
            return $translate.instant('Please slide to choose yes or no  to continue');
        }
        return false;
    };

    var isValidSign = function(sign) {
        if (!sign) {
            return "Please sign to continue";
        }
        return false;
    };

    var isPuccaHouse = function(puccaHouse) {
        if (!puccaHouse) {
            return "Please enter pucca house";
        }
        return false;
    };

    var isGahi = function(gahi) {
        if (!gahi) {
            return "Please enter Gross Annual Household Income";
        }
        return false;
    };

    var isHouseCarpet = function(houseCarpet) {
        if (!houseCarpet) {
            return "Please enter House Carpet Area";
        }
        return false;
    };

    var isPropertyLocation = function(propertyLocation) {
        if (!propertyLocation) {
            return "Please enter property location";
        }
        return false;
    };

    var isValidMotherName = function(MotherName) {
        if ((!MotherName) || (MotherName == "")) {
            return $translate.instant('Please Enter Mother Name');
        }
        var pattern = /^[A-Za-z ]*$/;
        if (!pattern.test(MotherName)) {
            return "Please Enter alphabets only"
        }
        return false;
    };
    var isAgree = function(agree) {
        if (!agree) {
            return $translate.instant('Please Agree to continue');
        }
        return false;
    };

    var isValidSpouseName = function(SpouseName) {
        if ((!SpouseName) || (SpouseName == "")) {
            return false;
        }
        var pattern = /^[A-Za-z ]*$/;
        if (!pattern.test(SpouseName)) {
            return "Please Enter alphabets only"
        }
        return false;
    };

    var isValidCountryOfBirth = function(CountryOfBirth) {
        if (!CountryOfBirth) {
            return $translate.instant('Please Select Country Of Birth');
        }
        return false;
    };

    var isValidResedentialStatus = function(ResedentialStatus) {
        if (!ResedentialStatus) {
            return $translate.instant('Please Select Resedential status');
        }
        return false;
    };

    var isValidNatureOfOrganization = function(NatureOfOrganization) {
        if (!NatureOfOrganization) {
            return $translate.instant('Please Select nature of Organization');
        }
        return false;
    };

    var isValidCKYCNumber = function(KYCNumber) {
        if (!KYCNumber || KYCNumber == "") {
            return false; 
        } 
        var pattern = /^\d{14}$/;
        if(!pattern.test(KYCNumber)) {
            return 'Please enter valid CKYC Number';
        }
        return false;
    };

    var isValidGSTNumber = function(pat,gstNumber) {
        if (!gstNumber || gstNumber == "") {
            return false; 
        } 
        var pattern = new RegExp(pat);
        if(!pattern.test(gstNumber)) {
            return false;
        }else{
            return true;
        }
        return false;
    };

    var isValidCountryOfTaxResident = function(CountryOfTaxResident) {
        if (!CountryOfTaxResident) {
            return $translate.instant('Please enter Country Of Tax Resident');
        }
        return false;
    };

    var isValidTINNumber = function(TINNumber) {
        if (!TINNumber) {
            return $translate.instant('Please enter Tin Number');
        }
        return false;
    };

    var isValidIdentifyType = function(IdentifyType) {
        if (!IdentifyType) {
            return $translate.instant('Please enter Identity Type');
        }
        return false;
    };

    var isValidResidentialadress = function(Residentialadress) {
        if (!Residentialadress) {
            return $translate.instant('Please enter Residential adress');
        }
        return false;
    };

    var isValidResidentType = function(ResidentialType) {
        if (!ResidentialType) {
            return $translate.instant('Please Select Residence type');
        }
        return false;
    };

    var isMarritialStatus = function(ResidentialType) {
        if (!ResidentialType) {
            return $translate.instant('Please Select Marital Status');
        }
        return false;
    };

    var isValidMonthsInResidence = function(Residentialmonths) {
        if (!Residentialmonths || Residentialmonths == undefined) {
            return $translate.instant('Please enter months in residence');
        }
        if(parseInt(Residentialmonths) == 0){
            return 'Please enter valid months in residence';
        }
        return false;
    };

    var isValidMonthsInWork = function(Residentialmonths) {
        if (!Residentialmonths || Residentialmonths == undefined) {
            return $translate.instant('Please enter work experience in months');
        }
        if(parseInt(Residentialmonths) == 0){
            return 'Please enter valid months in work experience';
        }
        return false;
    };

    var isValidMonthsInWorkCar = function(Residentialmonths) {
        if (!Residentialmonths || Residentialmonths == undefined) {
            return $translate.instant('Please enter work experience in months');
        }
        if(parseInt(Residentialmonths) > 11){
            return 'Please enter valid months in work experience';
        }
        return false;
    };

    var isValidYearsInWorkCar = function(Residentialmonths) {
        if (!Residentialmonths || Residentialmonths == undefined) {
            return $translate.instant('Please enter work experience in years');
        }
        return false;
    };

    var isValidMonthsInJob = function(Residentialmonths) {
        if (!Residentialmonths || Residentialmonths == undefined) {
            return $translate.instant('Please enter months in current job');
        }
        if(parseInt(Residentialmonths) == 0){
            return 'Please enter valid months';
        }
        return false;
    };

    var isValidMonthsInJobProfession = function(Residentialmonths) {
        if (!Residentialmonths || Residentialmonths == undefined) {
            return $translate.instant('Please enter months in current Profession');
        }
        if(parseInt(Residentialmonths) == 0){
            return 'Please enter valid months';
        }
        return false;
    };

    // var isValidMonthsInResidence = function(Residentialmonths) {
    //     if (!Residentialmonths || Residentialmonths == undefined) {
    //         return $translate.instant('Please enter months in residence');
    //     }
    //     return false;
    // };


    var isValidIdBuisness = function(Buisness) {
        if (!Buisness) {
            return $translate.instant('Please enter Buisness');
        }
        return false;
    };

    var getCurrentDate = function() {
        return new Date();
    };

    var getFutureDate = function(date, future) {
        date = new Date(date);
        date.setDate(date.getDate() + future);
        return $filter('chosenDate')(date);
    };
    var getFutureYear = function(date, year) {
        date = new Date(date);
        var futureYear = date.setFullYear(date.getFullYear() + year);
        var days = new Date(date);
        days.setDate(days.getDate() + -1);
        return $filter('chosenDate')(days);
    }

    var calcAge = function(bday) {

        var today = new Date();
        var birthDate = new Date(bday);
        var age = Number(today.getFullYear() - birthDate.getFullYear());
        var m = today.getMonth() - birthDate.getMonth();
        if (m < 0 || (m === 0 && today.getDate() < birthDate.getDate())) {
            age--;
        }

        return age;

    }


    var isValidBDayRS = function(bday) {
        var age = calcAge(bday);
        if (age > 70 || age < 30) {
            return $translate.instant('isValidBDayRS');
        }
        return false;
    };

    var isValidBDaySS = function(bday) {
        var age = calcAge(bday);
        if (age > 55 || age < 18) {
            return $translate.instant('isValidBDaySS');
        }
        return false;
    };

    var isValidBDaySC = function(bday) {
        var age = calcAge(bday);
        if (age > 50 || age < 21) {
            return $translate.instant('isValidBDaySC');
        }
        return false;
    };

    var isValidBDaySN = function(bday, pt, freq) {
        var age = calcAge(bday);

        if (age < 18) {
            return $translate.instant('isValidBDaySNMIN');

        }
        if (!(pt)) {
            return '';
        }

        if (!(freq)) {
            return $translate.instant('isValidPremiumFrequency');

        }
        
        if (freq == "Single" &&
            pt !== "Endowment with Whole Life Option") {
            if (age > 60) {
                return $translate.instant('isValidBDaySNS');

            }
        }
        if (freq !== "Single" && pt !== "Endowment with Whole Life Option") {
            if (age > 58) {
                return $translate.instant('isValidBDaySNR');

            }
        }
        if (pt == "Endowment with Whole Life Option") {
            if (age > 50) {
                return $translate.instant('isValidBDaySNW');
            }
        }
        return false;
    };


    var isValidBirthDateForPlanPolicy = function(birthDate, plan) {

        var age = calcAge(birthDate);

        if (plan == undefined) {
            return '';
        }

        if (plan == "Single") {

            if (age > 65 || age < 7) {
                return $translate.instant('validBirthdayForPlanPolicyB');
            }

            return false;

        } else if (plan == "Regular") {

            if (age > 60 || age < 7) {
                return $translate.instant('validBirthdayForPlanPolicyC');
            }
            return false;
        } else if (plan == "Limited") {

            if (age > 60 || age < 7) {
                return $translate.instant('validBirthdayForPlanPolicyD');
            }
            return false;
        }
    };


    var isPTARiderSumAssuredADBRider = function(sum, total, checked) {
        var rupee = String.fromCharCode(8377);
        if (((!(sum)) || (sum == rupee) || (sum == "")) && checked) {

            return $translate.instant('PTARiderSumAssuredPreferred');

        }
       
        sum = $filter('formatAmount')(sum);

        if (((Number(sum) > Number(total)) && checked)) {
            return $translate.instant('PTARiderSumAssuredPreferredLess');
        }
        if (((Number(sum) > 5000000) && checked)) {
            return $translate.instant('PTARiderSumAssuredPreferredMax');
        }
        if (((Number(sum) < 25000) && checked)) {
            return $translate.instant('PTARiderSumAssuredPreferredMin');
        }
        if (((Number(sum)) % 1000) !== 0 && checked) {
            return $translate.instant("isValidSumAssuredSNM");
        }
        return false;
    };

    var isPTARiderSumAssuredADBRiderSM = function(sum, total, checked, age) {
        var rupee = String.fromCharCode(8377);

        if (((!(sum)) || (sum == rupee) || (sum == "")) && checked) {

            return $translate.instant('PTARiderSumAssuredPreferred');

        }

        if ((age > 65 || age < 18) && checked) {

            return $translate.instant('isAgePTAN');
        }

        sum = $filter('formatAmount')(sum);

        if (((Number(sum) > Number(total)) && checked)) {

            return $translate.instant('PTARiderSumAssuredPreferredLess');
        }

        if (((Number(sum) > 5000000) && checked)) {
            return $translate.instant('PTARiderSumAssuredPreferredMax');
        }

        if (((Number(sum) < 25000) && checked)) {
            return $translate.instant('PTARiderSumAssuredPreferredMin');
        }

        if (((Number(sum)) % 1000) !== 0 && checked) {
            return $translate.instant("isValidSumAssuredSNM");
        }

        return false;
    };

    var isPTARiderSumAssuredCC = function(sum, total, checked, age, plan) {
        var rupee = String.fromCharCode(8377);

        if (((!(sum)) || (sum == rupee) || (sum == "")) && checked) {

            return $translate.instant('PTARiderSumAssuredPreferred');
        }

        if ((age > 55 || age < 18) && checked) {
            return $translate.instant('isAgePTACC');
        }

        sum = $filter('formatAmount')(sum);

        if (((Number(sum) > Number(total)) && checked)) {
            return $translate.instant('PTARiderSumAssuredPreferredLess');
        }
        if (((Number(sum) > 2000000) && checked)) {
            return $translate.instant('PTARiderSumAssuredPreferredMaxCC');
        }
        if (((Number(sum) < 25000) && checked)) {
            return $translate.instant('PTARiderSumAssuredPreferredMin');
        }
        if (((Number(age) + Number(plan) > 64) && checked)) {
            return $translate.instant('CRITIRIDMAT');
        }

        if (((Number(sum)) % 1000) !== 0 && checked) {
            return $translate.instant("isValidSumAssuredSNM");
        }
        return false;
    };

    var isValidMaturitySC = function(lifeAssuredAge, policyTerm) {
        if(parseInt(lifeAssuredAge) + parseInt(policyTerm) < 42) {
            return 'Minimum age of Maturity should be 42 years';
        } 
        return false;
    };

    var isValidBirthDateForPolicy = function(birthDate, term) {
        var age = calcAge(birthDate);

        if (term == undefined) {
            return '';
        }
        var newTerm = parseInt(term);
        if (newTerm == 20) {

            if ((age < 14) || (age > 50)) {
                return $translate.instant('validBirthdayForPolicyA');

            }
            return false;

        } else if (newTerm == 12 || newTerm == 15) {


            if ((age < 15) || (age > 55)) {

                return $translate.instant('validBirthdayForPolicyB');
            }
            return false;
        } else if (newTerm == 25) {


            if ((age < 14) || (age > 45)) {


                return $translate.instant('validBirthdayForPolicyC');
            }
        }
    };


    var isPTARiderTerm = function(policyterm, checkBox, term) {

        if (!policyterm && checkBox) {
            return "Please input the term in years";
        }

        var newTerm = parseInt(term);

        var subTerm = parseInt(policyterm);

        if ((subTerm < 5) && checkBox) {

            return ("The term should be greater than or equal to 5 years");

        }

        if (newTerm < subTerm && checkBox) {

            return ("The term should be less than or equal to " + newTerm + " years");

        }
        return false;

    };
    var isPTARiderTermAD = function(policyterm, checkBox, term) {

        if (!policyterm && checkBox) {

            return "Please input the term in years";
        }

        var newTerm = parseInt(term);
        var subTerm = parseInt(policyterm);

        if ((subTerm < 5) && checkBox) {

            return ("The term should be greater than or equal to 5 years");

        }

        if (newTerm < subTerm && checkBox) {
            return ("The term should be less than or equal to " + newTerm + " years");
        }
        return false;
    };

    var isPTARiderTermADis = function(policyterm, checkBox, term) {

        if (!policyterm && checkBox) {

            return "Please input the term in years";
        }

        var newTerm = parseInt(term);
        var subTerm = parseInt(policyterm);

        if ((subTerm < 5) && checkBox) {

            return ("The term should be greater than or equal to  5 years");

        }

        if (newTerm < subTerm && checkBox) {
            return ("The term should be less than or equal to " + newTerm + " years");
        }
        return false;
    };

    var isValidHomePolicyTenure = function(HomePolicyTenure) {
        if (!HomePolicyTenure) {
            return $translate.instant('enterTenure');
        } else if (Number(HomePolicyTenure) < 3) {
            return $translate.instant('tenuremmin');
        } else if (Number(HomePolicyTenure) > 30) {
            return $translate.instant('tenuremax');
        }
        return false;
    };

    var isValidPreferedLocation = function(location) {
        if (!location) {
            return $translate.instant('PleaseSelectLocation');
        }
        return false;
    };


    var isValidPPT = function(ppt) {


        if (((!(ppt)) || (ppt == ""))) {

            return $translate.instant('isValidPPT');

        }
    };

    var isValidPremiumAmountRS = function(sum, freq, plan) {
        var rupee = String.fromCharCode(8377);

        if (((!(sum)) || (sum == rupee) || (sum == ""))) {
            return $translate.instant('isValidPremiumAmountNull');
        }
        
        sum = $filter('formatAmount')(sum);

        if ((Number(sum) % 100) !== 0) {
            return $translate.instant('isValidPremiumAmountMul');
        }
        if (!freq) {
            return $translate.instant('isValidPremiumFrequency');
        }

        if (!plan) {
            return $translate.instant('Please select the plan option');
        }

        if (plan == "Regular") {
            if ((Number(sum) < 24000 && freq == "Yearly")) {
                return $translate.instant('isValidPremiumAmtRPY');
            }
            if ((Number(sum) < 15000 && freq == "Half Yearly")) {
                return $translate.instant('isValidPremiumAmtRPHY');
            }
            if ((Number(sum) < 7500 && freq == "Quarterly")) {
                return $translate.instant('isValidPremiumAmtRPQ');
            }
            if ((Number(sum) < 2500 && freq == "Monthly")) {
                return $translate.instant('isValidPremiumAmtRPM');
            }
        }

        if (plan == "LPPT") {
            if ((Number(sum) < 40000 && freq == "Yearly")) {
                return $translate.instant('isValidPremiumAmtLPY');
            }
            if ((Number(sum) < 20000 && freq == "Half Yearly")) {
                return $translate.instant('isValidPremiumAmtLPHY');
            }
            if ((Number(sum) < 10000 && freq == "Quarterly")) {
                return $translate.instant('isValidPremiumAmtLPQ');
            }
            if ((Number(sum) < 5000 && freq == "Monthly")) {
                return $translate.instant('isValidPremiumAmtLPM');
            }
        }

        return false;
    };



    var isValidPremiumAmount = function(sum, freq, plan) {

        var rupee = String.fromCharCode(8377);
        if (((!(sum)) || (sum == rupee) || (sum == ""))) {

            return $translate.instant('isValidPremiumAmountNull');

        }
        sum = $filter('formatAmount')(sum);

        if ((Number(sum) % 100) !== 0) {

            return $translate.instant('isValidPremiumAmountMul');

        }
        if (!freq && plan != "Single") {

            return $translate.instant('isValidPremiumFrequency');

        }
        if (!plan) {
            return $translate.instant('Please enter the plan option');
        }

        if ((Number(sum) < 30000 && plan == "Regular")) {
            return $translate.instant('isValidPremiumFrequencyRLess');
        }

        if ((Number(sum) > 300000 && (plan == "Limited" || plan == "Regular"))) {
            return $translate.instant('isValidPremiumFrequencyMore');
        }

        if ((Number(sum) > 300000 && plan == "Single")) {
            return $translate.instant('isValidPremiumFrequencyMore');
        }

        if ((Number(sum) < 40000 && plan == "Limited")) {
            return $translate.instant('isValidPremiumFrequencyLLess');
        }
        if ((Number(sum) < 65000 && plan == "Single")) {
            return $translate.instant('isValidPremiumFrequencySLess');
        }


        return false;
    };


    var isValidAmount = function(amount) {
        if (!amount || amount < 1) {
            return "Please enter amount.";
        }
        return false;
    }
    var isValidPANNo = function(panNo) {
        var panPattern = /^[a-zA-Z]{3}P[a-zA-Z]{1}[0-9]{4}[a-zA-Z]{1}$/;
        var isValidPAN = false;


        if (!panNo) {
            return "Required Field";
        } else {

            var panNoU = panNo.toUpperCase();
        }

        if (!panPattern.test(panNoU)) {
            return "Enter a valid PAN number";
        }
        return false;
    };
     var isValidPanNumber = function(panNo) {
        var panPattern = /^[a-zA-Z]{5}[0-9]{4}[a-zA-Z]{1}$/;
        if (!panNo) {
            return "PAN Number is required";
        } else {

            var panNoU = panNo.toUpperCase();
        }

        if (!panPattern.test(panNoU)) {
            return "Enter a valid PAN number";
        }
        return false;
    };
    var isValidPassportNo = function(passportNo) {
        //var passportPattern = /^[A-PR-WY][1-9]\d\s?\d{4}[1-9]$/ig;
        var passportPattern = /^[A-Z]\d{7}$/ig;
        if (!passportNo) {
            return "Please enter passport no.";
        }
        passportNo = passportNo.toUpperCase();
        if (!passportPattern.test(passportNo)) {
            return "Please enter valid passport no.";
        }
        return false;
    };
    var isValidPincode = function(pinCode) {
        if (!pinCode) {
            return $translate.instant('PlesseEnterPinCode');
        }
        if (pinCode.length < 6) {
            return "Please enter valid PIN Code";
        }
        return false;
    };
    var isValidPincodeNonMandatory = function(pinCode) {
        if(pinCode != undefined){

            if (pinCode.length < 6) {
                return "Please enter valid PIN Code";
            }

        }
        return false;
    };
    var isValidDOB = function(dob) {
        if (!dob) {
            return "Please select DOB";
        }
        return false;
    };

    var isValidTitle = function(ttl) {
        if (!ttl) {
            return "Please select Name Title";
        }
        return false;
    };

    var checkMaxSamf = function(dob, plo) {
        var age = calcAge(dob);

        if (age > 45 || age == 45) {
            if (plo == "Regular") {
                var maxSamf = 20;
                return maxSamf;
            }

            if (plo == "Limited") {
                var maxSamf = 15;
                return maxSamf;

            }

            if (plo == "Single") {
                var maxSamf = 1.25;
                return maxSamf;

            }
        } else if (age < 45) {

            if (plo == "Regular") {
                var maxSamf = 20;
                return maxSamf;
            }

            if (plo == "Limited") {
                var maxSamf = 15;
                return maxSamf;

            }
            if (plo == "Single") {
                var maxSamf = 3;
                return maxSamf;
            }


        }

    }

    var checkMinSamf = function(dob, plo, term, amt) {
        var age = calcAge(dob);


        if (age > 45 || age == 45) {

            if (plo == "Single") {
                var minSamf = 1.1;
                return minSamf;
            }
            if (plo == "Limited" || plo == "Regular") {
                var term = parseInt(term);
                var amt = $filter('formatAmount')(amt);
                var p1 = Number(7 * amt);
                var p2 = Number(0.25 * term * amt);
                if (p1 > p2) {
                    var minSamf = 7;
                    return minSamf;
                } else {
                    var minSamf = 0.25 * term;
                    return minSamf;
                }
            }
        } else if (age < 45) {
            if (plo == "Single") {
                var minSamf = 1.25;
                return minSamf;
            }
            if (plo == "Limited" || plo == "Regular") {
                var term = parseInt(term);
                var amt = $filter('formatAmount')(amt);
                var p1 = Number(10 * amt);
                var p2 = Number(0.5 * term * amt);

                if (p1 > p2) {
                    var minSamf = 10;
                    return minSamf;

                } else {
                    var minSamf = 0.5 * term;
                    return minSamf;
                }
            }
        }

    };

    var isValidSamf = function(dob, plo, term, amt, samp) {
        var plo = plo.key;
        var maxS = checkMaxSamf(dob, plo);
        var minS = checkMinSamf(dob, plo, term, amt);

        if (!samp) {    
            return $translate.instant("isValidSamf");
        }
        if (Number(samp) > Number(maxS)) {
            return $translate.instant("isValidSamfBet") + minS + ' to ' + maxS;
        }
        if (Number(samp) < Number(minS)) {

            return $translate.instant("isValidSamfBet") + minS + ' to ' + maxS;
        }
        return false;
    };

    var isValidperequity = function(eqt) {
        if (!eqt) {
            return $translate.instant("isValidperequity");
        }
        var eqt = parseInt(eqt);
        if (eqt > 100) {
            return $translate.instant("isValidperequity100");
        }
        return false;
    };

    var isValidperequityopt = function(eqt) {
        if (!eqt) {
            return $translate.instant("isValidperequityopt");
        }
        var eqt = parseInt(eqt);
        if (eqt > 100) {
            return $translate.instant("isValidperequity100");
        }
        return false;
    };

    var isValidperGrowth = function(gwt) {
        if (!gwt) {
            return $translate.instant("isValidperGrowth");
        }
        var eqt = parseInt(gwt);
        if (eqt > 100) {
            return $translate.instant("isValidperequity100");
        }
        return false;
    };

    var isValidperBalanced = function(blc) {
        if (!blc) {
            return $translate.instant("isValidperBalanced");
        }
        var eqt = parseInt(blc);
        if (eqt > 100) {
            return $translate.instant("isValidperequity100");
        }
        return false;
    };

    var isValidperBond = function(bnd) {
        if (!bnd) {
            return $translate.instant("isValidperBond");
        }
        var eqt = parseInt(bnd);
        if (eqt > 100) {
            return $translate.instant("isValidperequity100");
        }
        return false;
    };

    var isValidperMoneyMarket = function(mkt) {
        if (!mkt) {
            return $translate.instant("isValidperMoneyMarket");
        }
        var eqt = parseInt(mkt);
        if (eqt > 100) {
            return $translate.instant("isValidperequity100");
        }
        return false;
    };

    var isValidperTop300 = function(top) {
        if (!top) {
            return $translate.instant("isValidperTop300");
        }
        var eqt = parseInt(top);
        if (eqt > 100) {
            return $translate.instant("isValidperequity100");
        }
        return false;
    };

    var isValidnoOfYears = function(yrs) {
        if (!yrs) {
            return $translate.instant("isValidnoOfYears");
        }
        return false;
    };



    var isValidGender = function(gender) {
        if (!gender) {
            return "Please select Gender";
        }
        return false;
    };

    var isValidPolicyTenure = function(policyTenure) {
        if (!policyTenure) {
            return "Please select Policy Tenure";
        }
        return false;
    };
    var isValidPolicyStartDate = function(policyStartDate) {
        if (!policyStartDate) {
            return "Please select Policy Start Date";
        }
        return false;
    };
    var isValidPolicyEndDate = function(policyEndDate) {
        if (!policyEndDate) {
            return "Please select Policy End Date";
        }
        return false;
    };
    var isValidName = function(name) {
        if ((!name) || (name == "")) {
            return "Please Enter Name";
        }
        var pattern = /^[A-Za-z ]*$/;
        if (!pattern.test(name)) {
            return "Please Enter alphabets only"
        }
        return false;
    };

    var isValidMiddleLastName = function(name) {
        if ((!name || (name == ""))) {
            return false;
        }
        var pattern = /^[A-Za-z ]*$/;
        if (!pattern.test(name)) {
            return "Please Enter alphabets only"
        }
    };

    var isValidNomineeLastName = function(name) {
        if ((!name || (name == ""))) {
            return "Please Enter Last Name";
        }
        var pattern = /^[A-Za-z ]*$/;
        if (!pattern.test(name)) {
            return "Please Enter alphabets only"
        }
        return false;
    };

    var isValidAlphabets = function(value) {
        if ((!value || (value == ""))) {
            return "Please enter the field";
        }
        var pattern = /^[A-Za-z ]*$/;
        if (!pattern.test(value)) {
            return 'Please enter alphabets only';
        }
        return false;
    }

    var isValidPhoneNo = function(phoneNo) {
        if (!phoneNo) {
            return "Please Enter Phone Number";
        }

        var pattern =  /^[0-9]{10}$/;
        if(!pattern.test(phoneNo)) {
            return "Please Enter valid Phone Number";
        }
        return false;
    };

    var isValidPhoneMandatory = function(phoneNo) {
        if (!phoneNo) {
            return "Please Enter Phone Number";
        }
        return false;
    };

    var isValidMobileNo = function(phoneNo) {
        var regexp = new RegExp("^[789][0-9]{9}$");
        if (!phoneNo) {
            return "Required Field";
        }
        if (!regexp.test(phoneNo)) {
            return "Enter a valid Mobile number";
        }
        return false;
    };
    var isValidAlternateContact = function(phoneNo) {
        var regexp = new RegExp("^[789][0-9]{9}$");
        if (!phoneNo) {
            return "Please Enter alternate contact";
        }
        if (!regexp.test(phoneNo)) {
            return "Enter a valid Mobile number";
        }
        return false;
    };


    var isValidSumAssuredSS = function(sumAssuredss) {
        if (!sumAssuredss) {
            return $translate.instant('PREMIUM_REQ');

        }
        sumAssuredss = $filter('formatAmount')(sumAssuredss);

        if (Number(sumAssuredss) < 1500 || Number(sumAssuredss) > 5000) {
            return $translate.instant('PREMIUM_LESS');

        }
        if (Number(sumAssuredss) % 500 != 0) {
            return $translate.instant('PREMIUM_MULTIPLE');

        }

        return false;
    };


    var isValidMonthlyIncome = function(monthlyIncome) {
        var rupee = String.fromCharCode(8377);
        if ((!monthlyIncome) || (monthlyIncome == rupee) || (monthlyIncome == "")) {
            return "Please Enter your Monthly Income";
        }
		
		if (Number(monthlyIncome) == "0") {
            return "Monthly Income cannot be zero";
        }
		
        monthlyIncome = $filter('formatAmount')(monthlyIncome);

        if (Number(monthlyIncome) == 0) {
            return "Monthly Income cannot be zero";
        }

        if (Number(monthlyIncome) < 0) {
            return "Please Enter your Monthly Income";
        }

        return false;
    };

    var isValidAnnualIncomeHL = function(monthlyIncome) {
        var rupee = String.fromCharCode(8377);
        if ((!monthlyIncome) || (monthlyIncome == rupee) || (monthlyIncome == "")) {
            return "Please Enter your Annual Income";
        }
        monthlyIncome = $filter('formatAmount')(monthlyIncome);

        if (Number(monthlyIncome) == 0) {
            return "Annual Income cannot be zero";
        }

        if (Number(monthlyIncome) < 0) {
            return "Please Enter your Annual Income";
        }else if(Number(monthlyIncome) > 1199999988){
            return "Please Enter amount less than 1,19,99,99,989";
        }

        return false;
    };


    var isValidSumAssuredSN = function(sumAssuredsn) {
        if (!sumAssuredsn) {
            return $translate.instant("isValidSumAssuredSN");
        }
        sumAssuredsn = $filter('formatAmount')(sumAssuredsn);

        if (Number(sumAssuredsn) < 75000) {
            return $translate.instant("isValidSumAssuredSN");
        }
        if (((Number(sumAssuredsn)) % 1000) !== 0) {
            return $translate.instant("isValidSumAssuredSNM");
        }

        return false;
    };

    var isValidSumAssuredSC = function(sumAssuredsn) {
        var rupee = String.fromCharCode(8377);
        if (!sumAssuredsn || (sumAssuredsn == rupee) || sumAssuredsn == "") {
            return $translate.instant("isValidSumAssuredSCM");
        }
        sumAssuredsn = $filter('formatAmount')(sumAssuredsn);

        if ((Number(sumAssuredsn) < 100000) || (Number(sumAssuredsn) > 10000000)) {
            return $translate.instant("isValidSumAssuredSC");
        }
        if (((Number(sumAssuredsn)) % 1000) !== 0) {
            return $translate.instant("isValidSumAssuredSNM");
        }

        return false;
    };


    var isValidEmail = function(email) {

        var emailValidExpr = /^([0-9a-zA-Z]([-_\\.]*[0-9a-zA-Z]+)*)@([0-9a-zA-Z]([-_\\.]*[0-9a-zA-Z]+)*)[\\.]([a-zA-Z]{2,9})$/;
        if (!email) {
            return "Required Field";
        }
        if (!emailValidExpr.test(email)) {
            return "Enter a valid e-mail address";
        }
        return false;
    };

    var isValidEmailHL = function(email) {

        var emailValidExpr = /^([0-9a-zA-Z]([-_\\.]*[0-9a-zA-Z]+)*)@([0-9a-zA-Z]([-_\\.]*[0-9a-zA-Z]+)*)[\\.]([a-zA-Z]{2,9})$/;
        if (!email) {
            return "Please Enter a valid e-mail address";
        }
        if (!emailValidExpr.test(email)) {
            return " Please Enter a valid e-mail address";
        }
        return false;
    };

    var isValidEmailHLNonMandatory = function(email) {

        var emailValidExpr = /^([0-9a-zA-Z]([-_\\.]*[0-9a-zA-Z]+)*)@([0-9a-zA-Z]([-_\\.]*[0-9a-zA-Z]+)*)[\\.]([a-zA-Z]{2,9})$/;

        if (email && !emailValidExpr.test(email)) {
            return " Please Enter a valid e-mail address";
        }
        return false;
    };


    var isValidProductType = function(productType) {

        if (!productType) {
            return $translate.instant('Producttype');
        }
        return false;
    };




    var isValidbirthDate = function(birthDate) {

        if (!birthDate) {
            return $translate.instant('validBirthday');
        }
        return false;
    };

    var isValidAgeProposer = function(birthDate) {

        if (!birthDate) {
            return $translate.instant('isValidAgeProposer');
        }
        return false;
    };


    var isValidSumInsured = function(sumINsured) {

        if (!sumINsured || angular.equals({}, sumINsured)) {
            return $translate.instant('validSumEnsured');
        }
        return false;
    };

    var isValidSumInsuredHDC = function(sumINsured) {

        if (!sumINsured) {
            return $translate.instant('validSumEnsured');
        }
        sumINsured = sumINsured.replace(String.fromCharCode(8377), "").replace(/,/g, "");
        if (sumINsured < 1000) {
            return $translate.instant('MINIMUM_SUM_INSURED');
        }
        return false;
    };


    var isValidRelationship = function(Relationship) {

        if (!Relationship || angular.equals({}, Relationship)) {
            return $translate.instant('validRelationship');
        }
        return false;
    };

    var isValidDomicile = function(domicile) {

        if (!domicile) {
            return $translate.instant('SELECT_DOMICILE');
        }
        return false;
    };


    var isValidVerifyCall = function(verify) {

        if (!verify) {
            return $translate.instant('validateCompleteCall');
        }
        return false;
    };

    var isValidPolicyNum = function(PolicyNum) {

        if (!PolicyNum) {
            return $translate.instant('Please Enter Policy Number');
        }
        if (PolicyNum.length < 11) {
            return $translate.instant('Please Enter Valid Policy Number');
        }
        return false;
    };

    var isValidFinancialyear = function(Financialyear) {

        if (!Financialyear) {
            return $translate.instant('LISelectValidFinancialyear');
        }
        return false;
    };

    var isValidOTPNum = function(enterOTP) {

        if (!enterOTP) {
            return $translate.instant('Please Enter OTP Number');
        }
        if (enterOTP.length < 6) {
            return $translate.instant('Please Enter Valid OTP Number');
        }
        return false;
    };


    var isValidAdress = function(adress) {
        var validChar = /^[A-z().,-/0-9 #']*$/;
        if (!adress) {
            return $translate.instant('Please enter the address');
        }
        if (!validChar.test(adress)) {
            return $translate.instant('PlesseEnterValidAdress');
        }

        return false;
    };

    var isValidAdressNonMandatory = function(adress) {
        var validChar = /^[A-z().,-/0-9 #']*$/;

        if (!validChar.test(adress)) {
            return $translate.instant('PlesseEnterValidAdress');
        }

        return false;
    };

    var isValidBuilding = function(building) {
        var validChar = /^[A-Za-z()\.,\-/0-9 #']*$/;
        var validCharAddress = /[a-zA-Z]/;
        if (!building) {
            return $translate.instant('PlesseEnterAdress');
        }
        if ((!validChar.test(building)) || (!validCharAddress.test(building))) {
            return $translate.instant('PlesseEnterValidAdress');
        }

        return false;
    }   ;

    var isValidStreet = function(street) {
        var validChar = /^[A-z().,-/0-9 #']*$/;
        var validCharStreet = /[a-zA-Z]/;
        if (!street) {
            return $translate.instant('PlesseEnterAdress');
        }
        if ((!validChar.test(street)) || (!validCharStreet.test(street))) {
            return $translate.instant('PlesseEnterValidAdress');
        }

        return false;
    };

    var isValidExistingPolicy = function(existingPolicyDetails) {
        if (!existingPolicyDetails) {
            return $translate.instant('Please Enter Policy Details');
        }
        return false;
    };

    var isValidIdenNum = function(id) {
        if (!id) {
            return $translate.instant('Please Enter Chosen Id Number');
        }
        return false;
    };
    var isValidIdenChoose = function(id) {
        if (!id) {
            return $translate.instant('Please Enter Chosen Id');
        }
        return false;
    };

    var isValidCity = function(city) {
        var validChar = /^[A-z().,-/0-9 #']*$/;
        if (!city) {
            return $translate.instant('PlesseEnterCity');
        }
        if (!validChar.test(city)) {
            return "Enter Valid City";
        }
        return false;
    };


    var isValidRelationshipProposer = function(relationship) {
        if (!relationship) {
            return $translate.instant('PlesseEnterrelationproposer');
        }
        return false;
    };

    var isValidRelationshipNominee = function(relationship) {
        if (!relationship) {
            return $translate.instant('PlesseEnterrelationnominee');
        }
        return false;
    };

    var isValidMember = function(member) {
        if (!member) {
            return $translate.instant('PleaseSelectMember');
        }
        return false;
    };
    var isValidLocatiom = function(location) {
        if (!location) {
            return $translate.instant('PleaseSelectLocation');
        }
        return false;
    };
    var isValidOccupation = function(occupation) {
        if (!occupation) {
            return $translate.instant('VALID_OCCUPATION');
        }
        return false;
    };

    var isValidOccupationArsa = function(occupation) {
        if (!occupation) {
            return $translate.instant('VALID_OCCUPATION_ARSA');
        }
        return false;
    };

    var isValidQualification = function(qualification) {
        if (!qualification) {
            return $translate.instant('VALID_QUALIFICATION');
        }
        return false;
    };

    var isValidIncome = function(income) {
        if (!income) {
            return $translate.instant('PleaseEnterIncome');
        }
        return false;
    };
    //Function to validate Aadhar Number
    var isValidAadharCardNum = function(aadharCardNum) {
    var validChar = /^[2-9]{1}[0-9]{11}$/;
        
        if (!aadharCardNum) {
            return $translate.instant('PlesseEnterAadharCardNum');
        }
        if (aadharCardNum.length != 12) {
            return $translate.instant('PlesseEnterValidAadharCardNum');
        }
        if (!validChar.test(aadharCardNum)) {
            return $translate.instant('Please Enter a Valid Aadhar Card Number');
        }
        return false;
    };

    var isValidDate = function(date) {
        if(!date) {
            return 'Please enter the details';
        }
        return false;
    };


    var isValidMonthlyExpense = function(monthlyExpense) {
        var rupee = String.fromCharCode(8377);
        if ((!monthlyExpense) || (monthlyExpense == rupee) || (monthlyExpense == "")) {
            return "Please Enter your Monthly Expense";
        }
        monthlyExpense = $filter('formatAmount')(monthlyExpense);

        if (Number(monthlyExpense) == 0) {
            return "Monthly Expense cannot be zero";
        }

        if (Number(monthlyExpense) < 0) {
            return "Please Enter your Monthly Expense";
        }

        return false;
    };


    var isValidMI = function(monthlyIncome) {
        if (!monthlyIncome) {
            return $translate.instant('monthlyIncome');
        }
        return false;
    };





    var isValidOutstandingHomeLoan = function(outstandinghomeloan) {
        var rupee = String.fromCharCode(8377);
        if ((!outstandinghomeloan) || (outstandinghomeloan == rupee) || (outstandinghomeloan == "")) {
            return $translate.instant('Please enter outstanding home loan amount');
        }
        return false;
    };

    var isValidOutstandingOtherLoan = function(outstandingotherloan) {
        var rupee = String.fromCharCode(8377);
        if ((!outstandingotherloan) || (outstandingotherloan == rupee) || (outstandingotherloan == "")) {
            return $translate.instant('Please enter outstanding other loan amount');
        }
        return false;
    };

    var isValidExistingPolicyDetails = function(existingPolicyDetails) {
        var rupee = String.fromCharCode(8377);
        if ((!existingPolicyDetails) || (existingPolicyDetails == rupee) || (existingPolicyDetails == "")) {
            return $translate.instant('Please enter existing policy details');
        }
        return false;
    };



    var isValidMstatus = function(mstatus) {
        if (!mstatus) {
            return "Please select Marital Status";
        }
        return false;
    };

    var isValidRetire = function(retire,type) {
        if (!retire) {
            return "Please select Retirement age";
        }

        if(retire < 18){
            return "Retirement age must be greater than 18";
        }else{
            if(type == 'MNC' || type == 'LIST' || type == 'ULST'){
                if(retire > 60){
                    return "Retirement age must be 60 or less ";
                }
                
            }else{
                if(retire > 65){
                    return "Retirement age must be 65 or less ";
                }
                
            }
        }

        
        return false;
    };

    var isValidSavings = function(saving) {
        var rupee = String.fromCharCode(8377);
        if ((!saving) || (saving == rupee) || (saving == "")) {
            return "Please enter your Savings";
        }
        return false;
    };

    var isValidSavingsMarr = function(savingmarr) {
        var rupee = String.fromCharCode(8377);
        if ((!savingmarr) || (savingmarr == rupee) || (savingmarr == "")) {
            return "Please enter your Savings";
        }
        return false;
    };

    var isValidPostretire = function(retire) {
        if (!retire) {
            return "Please select Post Retirement Lifestyle";
        }
        return false;
    };

    var isValidEducationQualification = function(eduQual) {
        if (!eduQual) {
            return "Please select Educational Qualification";
        }
        return false;
    };

    var isValidInflation = function(inflation) {
        if (!inflation) {
            return $translate.instant('Select Inflation Value');
        }
        return false;
    };

    var isValidRisk = function(risk) {
        if (!risk) {
            return $translate.instant('Select Risk Value');
        }
        return false;
    };


    var isValidBuyHomeBy = function(year) {
        if (!year) {
            return $translate.instant('Please select the Year you want to buy');
        }
        return false;
    };

    var isValidCurrentCost = function(currentCost, savings) {
        var rupee = String.fromCharCode(8377);
        if ((!currentCost) || (currentCost == rupee) || (currentCost == "")) {
            return $translate.instant('Please enter the Current Cost');
        }
        var current = parseInt(currentCost);
        var saving = parseInt(savings);
        if (saving >= current) {
            return $translate.instant('Current cost should be greater than saved cost');
        }
        return false;
    };

    var isValidCurrentCostMarr = function(currentcostmarr, savings) {
        var rupee = String.fromCharCode(8377);
        if ((!currentcostmarr) || (currentcostmarr == rupee) || (currentcostmarr == "")) {
            return $translate.instant('Please enter the Marriage Cost');
        }
        var current = parseInt(currentcostmarr);
        var saving = parseInt(savings);
        if (saving >= current) {
            return $translate.instant('Current cost should be greater than saved cost');
        }
        return false;
    };



    var isValidPolicyType = function(policyType) {
        if (!policyType) {
            return $translate.instant('Please select the Policy type');
        }

        return false;
    };

    var isValidPolicyNumber = function(policyNumber) {
        if (!policyNumber) {
            return $translate.instant('POLICY_NUMBER_VALIDATION');
        }

        return false;
    };

    var isValidPreviousCompanyName = function(PreviousCompanyName) {
        if (!PreviousCompanyName) {
            return $translate.instant('PleaseSelectPreviousCompanyName');
        }

        return false;
    };

    var isValidPreviousCompanyAdress = function(PreviousCompanyAdress) {
        if (!PreviousCompanyAdress) {
            return $translate.instant('PleaseSelectPreviousCompanyAdress');
        }

        return false;
    };

    var isValidPreviousPolicyNumber = function(PreviousPolicyNumber) {
        if (!PreviousPolicyNumber) {
            return $translate.instant('PleaseSelectPreviousPolicyNumber');
        }

        return false;
    };


    var isValidPreviousProofOfNCB = function(PreviousProofOfNCB) {
        if (!PreviousProofOfNCB) {
            return $translate.instant('PleaseSelectProofOfNCB');
        }

        return false;
    };


    var isValidNCBOnPreviousPolicy = function(NCBOnPreviousPolicy) {
        if (!NCBOnPreviousPolicy) {
            return $translate.instant('PleaseSelectNCBONPreviouspOLICY');
        }

        return false;
    };


    var isValidTranferOfNCB = function(TranferOfNCB) {
        if (!TranferOfNCB) {
            return $translate.instant('PleaseEnterTransferOfNcb');
        }

        return false;
    };

    var isValidNatureOfLoss = function(NatureOfLoss) {
        if (!NatureOfLoss) {
            return $translate.instant('PleaseEnterNatureOfLoss');
        }

        return false;
    };

    var isValidVhicleMake = function(VhicleMake) {
        if (!VhicleMake) {
            return $translate.instant('PleaseSelectVehicleMake');
        }

        return false;
    };

    var isValidVhicleModel = function(VhicleModel) {
        if (!VhicleModel) {
            return $translate.instant('PleaseSelectVehicleModel');
        }

        return false;
    };

    var isValidVhicleFuelType = function(FuelType) {
        if (!FuelType) {
            return $translate.instant('PleaseSelectFuelType');
        }

        return false;
    };

    var isValidVhicleVarient = function(VhicleVarient) {
        if (!VhicleVarient) {
            return $translate.instant('PleaseSelectVehicleVarient');
        }

        return false;
    };


    var isValidYearOfManufacture = function(YearOfManufacture) {
        if (!YearOfManufacture) {
            return $translate.instant('PleaseSelectYearOfManufacture');
        }

        return false;
    };

    var isValidPANTANNo = function(panNo) {
        var panPattern = /^[a-zA-Z]{3}P[a-zA-Z]{1}[0-9]{4}[a-zA-Z]{1}$/;
        var tanPattern = /^[a-zA-Z]{4}[0-9]{5}[a-zA-Z]{1}$/;
        var isValidPAN = false;


        if (!panNo) {
            return "Please Enter a valid PAN / TAN number";
        } else {

            var panNoU = panNo.toUpperCase();
             if (!panPattern.test(panNoU) && !tanPattern.test(panNoU) )
             {
                return "Please Enter a valid PAN / TAN number";
             }
        }

    
        return false;
    };

    var isValidDateOfRegistration = function(DateOfRegistration) {
        if (!DateOfRegistration) {
            return $translate.instant('PleaseSelectDateOfRegistraion');
        }

        return false;
    };


    var isValidRTOLocation = function(VhicleVarient) {
        if (!VhicleVarient) {
            return $translate.instant('PleaseEnterRTOLocation');
        }

        return false;
    };


    var isValidSugesstedIDV = function(SugesstedIDV, minvalue, maxvalue, idvvalue) {

        if (!SugesstedIDV) {
            return $translate.instant('PleaseEnterSugesstedIDV');
        }

        if (Number(SugesstedIDV) < minvalue) {
            return $translate.instant('please enter + or - 20% of suggested IDV');
        } else if (Number(SugesstedIDV) > maxvalue) {
            return $translate.instant('please enter + or - 20% of suggested IDV');
        }


        return false;
    };


    var isValidNightPaerkingPinCode = function(NightPaerkingPinCode) {
        if (!NightPaerkingPinCode) {
            return $translate.instant('PleaseEnterParkingPinCode');
        }

        return false;
    };


    var isValidVehiclePurchasedAS = function(VehiclePurchasedAS) {
        if (!VehiclePurchasedAS) {
            return $translate.instant('PleaseSelectVehciclePurchase');
        }

        return false;
    };

    var isValidDateOfRegistrationNumber = function(DateOfRegistrationNumber) {
        if (!DateOfRegistrationNumber) {
            return $translate.instant('PleaseEnterRegistrationNumber');
        }


        return false;
    };

    var isValidEngineNumber = function(EngineNumber) {
        if (!EngineNumber) {
            return $translate.instant('PleaseEnterEngineNumber');
        }

        if (EngineNumber.length < 5) {
            return $translate.instant('PleaseEnterEngineNumberminimum5');
        }

        return false;
    };

    var isValidChassisNumber = function(ChassisNumber) {
        if (!ChassisNumber) {
            return $translate.instant('PleaseEnterChassisNumber');
        }

        if (ChassisNumber.length < 5) {
            return $translate.instant('PleaseEnterChassisNumberminimum5');
        }

        return false;
    };

    var isValidDriverExperience = function(DriverExperience) {
        if (!DriverExperience) {
            return $translate.instant('PleaseSelectDriverExperience');
        }

        return false;
    };


    var isValidFinaceType = function(FinaceType) {
        if (!FinaceType) {
            return $translate.instant('PleaseSelectFinanceType');
        }

        return false;
    };

    var isValidFinaceCompanyName = function(FinaceCompanyName) {
        if (!FinaceCompanyName) {
            return $translate.instant('PleaseEnterFinanceCompanyName');
        }

        return false;
    };

    var isValidFinaceCompanyCity = function(FinaceCompanyCity) {
        if (!FinaceCompanyCity) {
            return $translate.instant('PleaseEnterFinanceCompanyCity');
        }

        return false;
    };

    var isValidAchieveBy = function(year) {
        if (!year) {
            return $translate.instant('Please enter the year');
        }

        return false;


    };

    var isValidChildEduFund = function(eduAge) {
        if (!eduAge) {
            return $translate.instant('Please enter the age');
        }
        return false;
    };

    var isValidMarriageEduFund = function(fundRequired) {
        if (!fundRequired) {
            return $translate.instant('Please enter the age');
        }
        return false;
    };

    var isValidFatherName = function(fatherName) {
        if ((!fatherName) || (fatherName == "")) {
            return $translate.instant("Please enter your Father's name");
        }
        var pattern = /^[A-Za-z ]*$/;
        if (!pattern.test(fatherName)) {
            return "Please Enter alphabets only"
        }
        return false;
    };

    var isValidMaidenName = function(maidenname) {
        if ((!maidenname) || (maidenname == "")) {
            return $translate.instant('Please enter Maiden name');
        }
        var pattern = /^[A-Za-z ]*$/;
        if (!pattern.test(maidenname)) {
            return "Please Enter alphabets only"
        }
        return false;
    };

    var isValidNationality = function(nationality) {
        if (!nationality) {
            return $translate.instant('Please enter your nationality');
        }

        return false;
    };


    var isValidCountryOfResidence = function(countryofresidence) {
        if (!countryofresidence) {
            return $translate.instant('Please enter your country of residence');
        }

        return false;
    };

    var isValidNameOfEmployer = function(nameofemployer) {
        if (!nameofemployer) {
            return $translate.instant('Please enter name of employeer');
        }

        return false;
    };
    var isValidAddressOfEmployer = function(addressofemployer) {
        if (!addressofemployer) {
            return $translate.instant('Please enter the address of employer');
        }

        return false;
    };

    var isValidPoliticallyExposed = function(politicalHistory) {
        if (!politicalHistory) {
            return $translate.instant('Please select appropriate option');
        }

        return false;
    };


    var isValidConvictionHistory = function(convictionHistory) {
        if (!convictionHistory) {
            return $translate.instant('Please select appropriate option');
        }

        return false;
    };


    var isValidInsuranceCompany = function(insuranceCompany) {
        if (!insuranceCompany) {
            return $translate.instant('Please enter the insurance Company');
        }
        return false;
    };


    var isValidYearOfIssue = function(yearOfIssue) {
        if (!yearOfIssue) {
            return $translate.instant('Please enter the year of issue');
        }
        var currentYear = getCurrentDate().getFullYear();
        if ((currentYear - yearOfIssue < 30) && (currentYear - yearOfIssue >= 0)) {
            return false;
        } else {
            return $translate.instant('Can have maximum 30 years old');
        }
    };

    var isValidProductName = function(productName) {
        if (!productName) {
            return $translate.instant('Please enter the product name');
        }
        return false;
    };

    var isValidUndergoneMedical = function(undergoneMedical) {
        if (!undergoneMedical) {
            return $translate.instant('Please select appropriate option');
        }
        return false;
    };

    var isValidYearlyPremiumRS = function(yearlyPremiumRs) {
        var rupee = String.fromCharCode(8377);
        if ((!yearlyPremiumRs) || (yearlyPremiumRs == rupee) || (yearlyPremiumRs == "")) {
            return $translate.instant('Please enter the amount');
        }

        return false;
    };

    var isValidSumAssuredRS = function(sumAssuredRs) {
        var rupee = String.fromCharCode(8377);
        if ((!sumAssuredRs) || (sumAssuredRs == rupee) || (sumAssuredRs == "")) {
            return $translate.instant('Please enter the amount');
        }

        return false;
    };

    var isValidPremiumPaidForRS = function(premiumPaidForRs) {
        if (!premiumPaidForRs) {
            return $translate.instant('Please enter the amount');
        }

        return false;
    };

    var isValidPolicyStatus = function(policyStatus) {
        if (!policyStatus) {
            return $translate.instant('Please enter the status');
        }

        return false;
    };

  

    var isValidSumAssured = function(sumAssured) {
        var rupee = String.fromCharCode(8377);
        if (!(sumAssured) || (sumAssured == rupee)) {
            return $translate.instant('Please enter the sum assured');
        }

        sumAssured = $filter('formatAmount')(sumAssured);

        if (Number(sumAssured) < 75000) {
            return "Sum assured should be greater than Rs.75000";
        }

        if ((Number(sumAssured) % 1000) !== 0) {
            return "Sum assured should be multiple of 1000";
        }
        return false;
    };
    var isValidChildAge = function(policyTerm) {
        if (!policyTerm) {
            return $translate.instant('Please enter the Child Age');
        }

        return false;
    };
    var isValidPlanOption = function(policyTerm) {
        if (!policyTerm) {
            return 'Please select plan option';
        }

        return false;
    };

    var isValidPolicyTermSN = function(policyTerm, age, option) {

        if (!policyTerm) {
            return $translate.instant('Please enter the policy term');
        }

        if (!option) {
            return $translate.instant('Please select valid plan option');
        }

        var policyTermSN = parseInt(policyTerm);
        var ageSN = parseInt(age);

        var totalSN = policyTermSN + ageSN;
        if (option == "Endowment with Whole Life Option") {
            if (totalSN > 100) {

                return $translate.instant('isValidPolicyTermSNE');

            }
        } else {
            if (totalSN > 65) {

                return $translate.instant('isValidPolicyTermSN');

            }
        }

        return false;
    };

    var isValidPolicyTermSS = function(policyTerm, age) {

        if (!policyTerm) {
            return $translate.instant('Please enter the policy term');
        }

        var policyTermSS = parseInt(policyTerm);
        var ageSS = parseInt(age);
        var totalSS = policyTermSS + ageSS;

        if (totalSS > 70) {

            return $translate.instant('isValidPolicyTermSS');

        }


        return false;
    };


    var isValidPolicyTermSM = function(policyTerm, age) {

        if (!policyTerm) {
            return $translate.instant('Please enter the policy term');
        }

        var policyTermSM = parseInt(policyTerm);
        var ageSM = parseInt(age);
        var totalSM = policyTermSM + ageSM;

        if (totalSM > 70) {

            return $translate.instant('isValidPolicyTermSM');

        }


        return false;
    };

    var isValidPolicyTermSW = function(policyTerm, age) {

        if (!policyTerm) {
            return $translate.instant('Please enter the policy term');
        }

        var policyTermSW = parseInt(policyTerm);
        var ageSW = parseInt(age);
        var totalSW = policyTermSW + ageSW;

        if (totalSW > 70) {

            return $translate.instant('isValidPolicyTermSW');

        }


        return false;
    };


    var isValidPolicyTermRS = function(policyTerm, age) {

        if (!policyTerm) {
            return $translate.instant('Please enter the policy term');
        }

        var policyTermRS = parseInt(policyTerm);
        var ageRS = parseInt(age);
        var totalRS = policyTermRS + ageRS;

        if (totalRS > 80) {

            return $translate.instant('isValidPolicyTermRS');

        }


        return false;
    };

    var isValidPolicyTerm = function(policyTerm) {
        if (!policyTerm) {
            return $translate.instant('Please enter the policy term');
        }

        return false;
    };

    var isValidchildAge = function(planOption) {
        if (!planOption) {
            return $translate.instant('Please select Child Age');
        }

        return false;
    };

    var isValidRS_Q1 = function(RS_Q1) {
        if (!RS_Q1) {
            return $translate.instant('Please enter Identification Mark');
        }

        return false;
    };

    var isValidRS_Q8 = function(RS_Q2) {
        if (!RS_Q2) {
            return $translate.instant('Please enter details');
        }

        return false;
    };

    var isValidRS_Q11 = function(RS_Q11) {
        if (!RS_Q11) {
            return $translate.instant('Please enter Details');
        }

        return false;
    };

    var isValidRS_Q12 = function(RS_Q12) {
        if (!RS_Q12) {
            return $translate.instant('Please enter Details');
        }

        return false;
    };


    var isValidPremiumFrequency = function(premiumFrequency) {
        if (!premiumFrequency) {
            return $translate.instant('isValidPremiumFrequency');
        }

        return false;
    };

    var isValidJkResident = function(jkResident) {
        if (!jkResident) {
            return $translate.instant('Please enter appropriate option');
        }

        return false;
    };


    var isValidWeight = function(weight) {
        if (!weight) {
            return $translate.instant('Please enter your weight');
        }

        if (parseInt(weight) == 0) {
            return 'Weight should be greater than 0';
        }

        return false;
    };


    var isValidHeight = function(height) {
        if (height == undefined || height == "") {
            return $translate.instant('Please enter your Height');
        }
        if (parseInt(height) == 0) {
            return 'Height should be greater than 0';
        }

        return false;
    };
    var isValidRinInches = function(inches) {
         if (inches == undefined || inches == "") {
            return $translate.instant('Please enter inches');
        }
        if(parseInt(inches) > 11){
            return 'Please enter inches(0-11)';
        }
        return false;
    };

    var isValidPolicyObjective = function(objective) {
        if (!objective) {
            return $translate.instant('Please select the objective');
        }

        return false;
    };

    var isValidLanguageOfCommu = function(language) {
        if (!language) {
            return $translate.instant('Please select the language of communication');
        }

        return false;
    };

    var isValidAddressProof = function(activityName) {
        if (!activityName) {
            return $translate.instant('Please select the Address Proof');
        }

        return false;
    };
    var isValidActivityName = function(activityName) {
        if (!activityName) {
            return $translate.instant('Please select Nature of Duty');
        }

        return false;
    };

    var isValidAnnualIncome = function(annualIncome) {
        if (!annualIncome) {
            return $translate.instant('VALID_ANNUAL_INCOME');
        }

        return false;
    };

    var isValidIdentityProof = function(identityProof) {
        if (!identityProof) {
            return $translate.instant('Please select Identity Proof');
        }

        return false;
    };

    var isValidIncomeProof = function(incomeProof) {
        if (!incomeProof) {
            return $translate.instant('Please select Income Proof');
        }

        return false;
    };

    var isValidAgeProof = function(ageProof) {
        if (!ageProof) {
            return $translate.instant('Please select Age Proof');
        }

        return false;
    };

    var isValidState = function(state) {
        if (!state) {
            return $translate.instant('Please enter State');
        }

        return false;
    };


    var isValidOfficeNo = function(number) {
        var regexp = new RegExp("^[1-9][0-9]*$");
      if (number.length>0) {
         if(number.length < 6) {
             return $translate.instant('Please enter valid number');
        }

        if (!regexp.test(number)) {
            return $translate.instant('Please enter valid number');
        }
	  }
        return false;
    };


    var isValidLandlineNo = function(number) {
        var regexp = new RegExp("^[1-9][0-9]*$");
        if (number.length>0) {
          
        

        if(number.length < 6) {
             return $translate.instant('Please enter valid number');
        }

        
        if (!regexp.test(number)) {
            return $translate.instant('Please enter valid number');
        }
		}

        return false;
    };


    var isValidPolicyOption = function(PolicyOption) {
        if (!PolicyOption) {
            return $translate.instant('PleaseEnterNatureOfLoss');
        }

        return false;
    };
    var isValidNomineeRelationWithInsured = function(NomineeRelation) {
        if (!NomineeRelation) {
            return $translate.instant('Please enter Nominee Relationship with Insured');
        }
        return false;
    };
    var isValidAppointeeRelationshipwithNominee = function(AppointeeRelationNominee) {
        if (!AppointeeRelationNominee) {
            return $translate.instant('Please Enter Relationship with Nominee');
        }
        return false;
    };
    var isValidAppointeeRelationshipwithInsured = function(AppointeeRelationInsured) {
        if (!AppointeeRelationInsured) {
            return $translate.instant('PleaseEnterNatureOfLoss');
        }
        return false;
    };
    var isValidAddress = function(Address) {
        var validChar = /^[A-z().,-/0-9 #']*$/;
        if (!Address) {
            return $translate.instant('Please enter the address');
        }
        if (!validChar.test(Address)) {
            return $translate.instant('PlesseEnterValidAdress');
        }
        return false;
    };
    var isValidForceNumber = function(forceNumber){
        if(!forceNumber){
         return $translate.instant('Please enter the Force Number');   
        }
        return false;
    }

    var isValidMonthlyIncomeFD = function(monthlyIncome) {
        if (!monthlyIncome) {
            return $translate.instant('Please enter the monthly income');
        }
        return false;
    };

    var isValidAccountNum = function(accountNum) {
        if (!accountNum) {
            return $translate.instant('Please Select Account Number');
        }
        return false;
    };

    var isValidAccountNumber = function(accountNum) {
        if (!accountNum) {
            return $translate.instant('Please Enter SBI Account Number');
        }else if(accountNum.length != 11){
            return $translate.instant('Please Enter valid SBI Account Number');
        }
        return false;
    };

    var isValideInsuranceAccNum = function(eInsuranceAccNum) {
        if (!eInsuranceAccNum) {
            return $translate.instant('Please Enter eInsuranceAccNum');
        }
        return false;
    };

    var isValidInsuranceAccountNumber = function(accountNum) {
        if (!accountNum) {
            return $translate.instant('VALID_INSURANCE_NO');
        }
        var pattern = /^[1,2,4,5]{1}([0-9]{12})$/;
        var result = accountNum.match(pattern);
        if (result == null) {
            return $translate.instant('VALID_INSURANCE_NO');
        }
        return false;
    };

    var isValidPlaceName = function(place){
        if((!place) || (place == "")) {
            return $translate.instant('PLACE_ERR');   
        }
        var pattern = /^[A-Za-z ]*$/;
        if (!pattern.test(place)) {
            return $translate.instant('ALPHABET_ONLY');
        }
        return false;
    }

    var isValidDepositoryName = function(depositoryName) {
        if (!depositoryName) {
            return "Please Select Repository Name";
        }
        return false;
    };

    var isValidLocality = function(locality) {

        var validChar = /^[A-Za-z()\.,\-/0-9 #']*$/;
        var validCharAddress = /[a-zA-Z]/;

        if ((!locality || (locality == ""))) {
            return false;
        }
        if ((!validChar.test(locality)) || (!validCharAddress.test(locality))) {
            return "Enter a valid Locality"
        }
        return false;
    };

    var isValidNatureOfCompany = function(compNature) {
        if (!compNature) {
            return $translate.instant('VALID_NATURE_COMPANY');
        }
        return false;
    };

    var isValidDesignation = function(designation) {
        if (!designation) {
            return $translate.instant('VALID_DESIGNATION');
        }
        return false;
    };

    var isValidYears = function(years) {
        if (!years) {
            return $translate.instant('VALID_YEARS_EMP');
        }
        return false;
    };
    var isValideTravelPurpose = function(travelPurpose) {
        if (!travelPurpose) {
            return $translate.instant('Please Enter Purpose of Travel');
        }
        return false;
    }
    var isValidCountryStay = function(countrystay) {
        if (!countrystay) {
            return $translate.instant('Please enter Country Stay');
        }

        return false;
    };

    var isValidStreetName = function(StreetName) {
        var regex = /^[a-zA-Z0-9 .,/-]{1,60}$/;
        if (!StreetName) {
            return $translate.instant('enterStreetname');
        }else if(!regex.test(StreetName)){
            return $translate.instant('INVALID_STREETNAME');
        }
        return false;
    };

    var isValidBuildingName = function(BuildingName) {
        var regex = /^[a-zA-Z0-9 .,/-]{1,40}$/;
        if (!BuildingName) {
            return $translate.instant('enterBuildingName');
        }else if(!regex.test(BuildingName)){
            return $translate.instant('INVALID_BUILDINGNAME');
        }

        return false;
    };

    var isValidplotNO = function(plotNO) {
        var regex = /^[a-zA-Z0-9 .,/-]{1,50}$/;
        if (!plotNO) {
            return $translate.instant('enterplotNO');
        }else if(!regex.test(plotNO)){
            return $translate.instant('INVALID_PLOTNO');
        }

        return false;
    };

    var isValidNumberofFloor = function(NumberofFloor) {
        if (!NumberofFloor) {
            return $translate.instant('enterNumberoffloor');
        }

        return false;
    };

    var isValidYourFloor = function(YourFloor) {
        if (!YourFloor) {
            return $translate.instant('isValidYourFloor');
        }

        return false;
    };


    var isValidTypeOfBuilding = function(TypeOfBuilding) {
        if (!TypeOfBuilding) {
            return $translate.instant('isValidTypeOfBuilding');
        }

        return false;
    };

    var isValidYearOfConstruction = function(YearOfConstruction) {
        if (!YearOfConstruction) {
            return $translate.instant('isValidYearOfConstruction');
        }

        return false;
    };


    var isValidAreadofProperty = function(AreadofProperty) {
        if (!AreadofProperty) {
            return $translate.instant('isValidAreadofProperty');
        }

        return false;
    };

    var isValidFinanceInstruct = function(FinanceInstruct) {
        if (!FinanceInstruct) {
            return $translate.instant('isValidFinanceInstruct');
        }

        return false;
    };

    var isValidFinancebranch = function(Financebranch) {
        if (!Financebranch) {
            return $translate.instant('isValidFinancebranch');
        }

        return false;
    };

    var isValidloanaccount = function(loanaccount) {
        if (!loanaccount) {
            return $translate.instant('isValidloanaccount');
        }

        return false;
    };

    var isValidDeseaseList = function(name) {
       
        if(name.isHypertension || name.isAIDS || name.isDiabetes || name.isCancer || name.isAsthma || name.isHepatits || name.isStroke){
            return false;
        }else{
            return "Please Select Desease list";
        }
        
    };


    var isValidDesease = function(desease) {
        if (!desease) {
            return $translate.instant('Please Enter Desease Name');
        }

        return false;
    };

    var isValidTreatmentDetail = function(desease, dis) {
        if (!desease && dis) {
            return $translate.instant('Please Enter Treatment Detail');
        }

        return false;
    };

    var isValidCompanyName = function(company) {
        var validChar = /^[A-z.,-/0-9 ]*$/;
        if (!company) {
            return "Enter a Company name";
        }
        if (!validChar.test(company)) {
            return "Enter a valid Company name";
        }

        return false;
    };

    var isValidEmployerName = function(employer) {
        var validChar = /^[A-z.,-/0-9 ]*$/;
        if (!employer) {
            return "Please enter Employer name";
        }
        if (!validChar.test(employer)) {
            return "Enter a valid Employer name";
        }
        return false;
    };

    var isValidTreatmentDetail = function(company) {
        if (!company) {
            return $translate.instant('Please Enter Treatment Details');
        }

        return false;
    };


    var isValidCurrentStatus = function(company) {
        if (!company) {
            return $translate.instant('Please Enter Current Status of Desease');
        }

        return false;
    };

    var isValidTreatmentStartDate = function(treatmentstartdate) {
        if (!treatmentstartdate) {
            return $translate.instant('TREATMENTSTARTDATE');
        }

        return false;
    };
    var isValidInsuranceInsuredSince = function(InsuranceSince) {
        if (!InsuranceSince) {
            return $translate.instant('insurancesincedate');
        }

        return false;
    };
    var isValidInsuranceInsuredFrom = function(InsuranceSince) {
        if (!InsuranceSince) {
            return $translate.instant('insuranceFrom');
        }

        return false;
    };

     var isValidInsuranceInsuredTo = function(InsuranceSince,policyType) {
        if (!InsuranceSince) {
            return $translate.instant('insuranceTo');
        }

        if(policyType == "Previous"){
            var insuredSinceDate = new Date(InsuranceSince).getTime();
            var currentDate = new Date().getTime();
            if(parseInt(currentDate) < parseInt(insuredSinceDate)){
                return $translate.instant('POLICY_END_DATE_VALIDATION');
            }
        }

        return false;
    };

    var isValidInsuranceInsuredToFrom = function(InsuranceSince , InsuredTo) {
        if (!InsuredTo) {
            return $translate.instant('insuranceTo');
        }
        var InsuranceSince = new Date(InsuranceSince);
        var InsuredTo = new Date(InsuredTo);
        var diff = Math.floor(InsuredTo.getTime() - InsuranceSince.getTime());
        var day = 1000*60*60*24;
        var days = Math.floor(diff/day);
        var months = Math.floor(days/30.41);
        var years = Math.floor(months/12);

        if(years > 2 || years < 1){
            return $translate.instant('END_START_VALIDATION');
        }

        return false;
    };

    var isValidAgeGroup = function(ageGroup) {
        if (angular.equals({}, ageGroup)) {
            return $translate.instant('AGE_GROUP_ERROR_MSG');
        }

        return false;
    };

    var isValidCashLimit = function(cashLimit) {
        if (angular.equals({}, cashLimit)) {
            return $translate.instant('HOSPITALIZATION_CASH_LIMIT_ERROR_MSG');
        }

        return false;
    };

    var isValidExistingSBILifeCustomer = function(check) {

        if (!check) {
            return $translate.instant('Please enter policy number');
        }

        return false;
    };

    var isValidAssuredrel = function(AssuredRelation) {
        if (!AssuredRelation) {
            return $translate.instant('Please select the Assured relation');
        }
        return false;
    };

    var isValidDiagnosisDate = function(diagnosisDate, dis) {
        if (!diagnosisDate && dis) {
            return $translate.instant('DATEOFDIAGNOSIS');
        }

    };

    var isValidNatureDisease = function(diseaseNature, dis) {
        if (!diseaseNature && dis) {
            return $translate.instant('DISEASENAME');
        }
        var pattern = /^[A-Za-z ]*$/;
        if (!pattern.test(diseaseNature)) {
            return "Please enter alphabets only"
        }
        return false;
    }
    var isValidNomineerel = function(NomineeRelation) {
        if (!NomineeRelation) {
            return $translate.instant('Please select the Nominee relation');
        }
        return false;
    };

    var isValidInfoDoctorHospital = function(info, dis) {
        if (!info && dis) {
            return $translate.instant('INFODOCTOR');
        }

        return false;
    };

    var isValiddetails = function(subQuestion1) {
        if (!subQuestion1 || (subQuestion1 == '')) {
            return $translate.instant('Please enter the details');
        }

        return false;
    };

    var isHivpresent = function(RS_Q9Y) {
        if (!RS_Q9Y) {
            return $translate.instant('Please enter yes/no');
        }

        return false;
    };

    var isHepapresent = function(RS_Q10Y) {
        if (!RS_Q10Y) {
            return $translate.instant('Please enter appropriate answer');
        }

        return false;
    };


    var isValidHusincome = function(husincome) {
        if (!husincome) {
            return $translate.instant('Please Enter Income');
        }
        return false;
    };

    var isValidinsdetails = function(insdetails) {
        if (!insdetails) {
            return $translate.instant('Please Enter Insurance details');
        }
        return false;
    };


    var isValidHazardOccup = function(occupationHazardO) {
        if (!(occupationHazardO && occupationHazardO.key)) {
            return $translate.instant('Please select appropriate option');
        }

        return false;
    };


    var isValidhealthStatus = function(healthStatus) {
        if (!healthStatus) {
            return $translate.instant('selectHealthStatus');
        }

        return false;
    };
    //function: To validate for age at death
    var isValidDeathAge = function(age) {
        if (!age) {
            return $translate.instant('enterDeathAge');
        }
        return false;
    };

    var isValidAge = function(age) {
        if (!age) {
            return $translate.instant('enterAge');
        }

        return false;
    };

    var isValidPresentHealthState = function(presentHealthState) {
        if (!presentHealthState) {
            return $translate.instant('selectPresentHealthState');
        }else if(presentHealthState){
            if(!presentHealthState.key){
                return $translate.instant('selectPresentHealthState');
            }
        }
        return false;
    };

    var isValidifDeadCauseOfDeath = function(ifDeadCauseOfDeath) {
        if (!ifDeadCauseOfDeath) {
            return $translate.instant('selectCauseofDeath');
        }else if(ifDeadCauseOfDeath){
            if (!ifDeadCauseOfDeath.key) {
            return $translate.instant('selectCauseofDeath');
        }
        }
        return false;
    };
    var isValidNatureofIll = function(specificNatureOfIllness) {
        if (!specificNatureOfIllness) {
            return $translate.instant('selectNatureOfIllness');
        }

        return false;
    };

    var isValidPreviousCurrent = function(insurancetype) {
        if (!insurancetype) {
            return $translate.instant('Please select appropriate option');
        }
    };

    var isValidPlaceOfBirth = function(placeOfbirth) {
        if (!placeOfbirth) {
            return $translate.instant('selectPlaceOfbirth');
        }
        return false;
    };
    var isValidInstructions = function(instructionsValid) {
        if (!instructionsValid) {
            return $translate.instant('selectInstructions');
        }
        return false;
    };
    var isValidOtherCountryTaxPayer = function(taxPayerValid) {
        if (!taxPayerValid) {
            return $translate.instant('selectInstructions');
        }
        return false;
    };

    var isValidMaritalStatus = function(maritalstatus) {
        if (!maritalstatus) {
            return $translate.instant('Please select marital status');
        }
    };

    var isValidFirstName = function(FirstName) {
        if (!FirstName) {
            return $translate.instant('enterFirstName');
        }
    };

    var isValidLastName = function(LastName) {
        if (!LastName) {
            return $translate.instant('enterLastName');
        }
    };

     var isValidLastNameGI = function(LastName,is_CBS_LastName) {

         if(is_CBS_LastName){
            var validChars = /[^A-Za-z.\s]/;         
            if (validChars.test(LastName)==true) {           
            return $translate.instant("Invalid First Name/Last Name ("+LastName +").First Name/Last Name cannot have special characters or numeric (e.g. #,-,@,2). Please visit your nearest SBI branch");
            }
            if (!LastName) {
                return $translate.instant('Please enter Last Name');
            }
         }else{
            var validChars = /[^A-Za-z\s]/;         
            if (validChars.test(LastName)==true) {           
            return $translate.instant("Invalid First Name/Last Name ("+LastName +").First Name/Last Name cannot have special characters or numeric (e.g. #,-,@,2). Please visit your nearest SBI branch");
            }
            if (!LastName) {
                return $translate.instant('Please enter Last Name');
            }
         }
        
    };
    var isValidlocality = function(locality) {
        if (!locality) {
            return $translate.instant('ENTER LOCALITY');
        }
    };

    var isValidPlotNo = function(plotno) {
        if (!plotno) {
            return $translate.instant('enterplotno');
        }
    };

    var isValidEmployment = function(employment) {
        if (!employment) {
            return $translate.instant('enteremploymentdetail');
        }
    };

    var isValidGrossSalary = function(gross) {
        if (!gross) {
            return $translate.instant('entergrosssalaryno');
        }
        gross = gross.replace(String.fromCharCode(8377), "").replace(/,/g, "");
        if (gross < 1000) {
            return $translate.instant('MINIMUM_GROSS_INCOME');
        }
    };

    var isValidAilmentDetails = function(ailmentDetails) {
        if (!ailmentDetails) {
            return $translate.instant('enterailmentdetails');
        }
    };
    var isValidSmokeStatus = function(smokestatus) {
        if (!smokestatus) {
            return $translate.instant('entersmokestatus');
        }
    };
    var isValidInsuredPerson = function(insuredPerson) {
        if (!insuredPerson) {
            return $translate.instant('enterinsuredperson');
        }
    };

    var isValidDocAge = function(denialDetail) {
        if (!denialDetail) {
            return $translate.instant('isValidDocAge');
        }
    };
    var isValidDocInc = function(denialDetail) {
        if (!denialDetail) {
            return $translate.instant('isValidDocInc');
        }
    };
    var isValidDocId = function(denialDetail) {
        if (!denialDetail) {
            return $translate.instant('isValidDocId');
        }
    };
    var isValidDocAdd = function(denialDetail) {
        if (!denialDetail) {
            return $translate.instant('isValidDocAdd');
        }
    };
    var isValidDocPhoto = function(denialDetail) {
        if (!denialDetail) {
            return $translate.instant('isValidDocPhoto');
        }
    };
    var isValidNoOfYearsEmployement = function(yrs) {
        var validChar = /^[1-9][0-9]*$/;
        if (!validChar.test(yrs)) {
            return $translate.instant("Enter valid no of years");
        }
        if (!yrs) {
            return $translate.instant("Field Required");
        }
        return false;
    };

    var isValidDenialDetail = function(deniel) {
        if (!deniel) {
            return $translate.instant('enter deniel detail');
        }
    };

    var isValidOTPNumCards = function(getOTPNumber) {

        if (!getOTPNumber) {
            return $translate.instant('Please Enter the OTP');
        }
        if (getOTPNumber.length < 6) {
            return $translate.instant('Please enter 6 digits OTP');
        }
        return false;
    };

    var isValidAvailDiscount = function(Availdiscount) {

        if (!Availdiscount) {
            return $translate.instant('Please Select Avail Discount');
        }
        return false;

    };
    var isValidAreaCode = function(areaCode) {
        if (!areaCode) {
            return $translate.instant('Please Enter Area Code');
        }
        return false;
    }

     var isValidProffStreet = function(street) {

        var validChar = /^[A-Za-z()\.,\-/0-9 #']*$/;
        var validCharAddress = /[a-zA-Z]/;

        if ((!street || (street == ""))) {
            return false;
        }
      
        if ((!validChar.test(street)) || (!validCharAddress.test(street))) {
            return "Enter a valid Address"
        }
        return false;
    };

    var isValidCityCards = function(selectedCity) {
        if (!selectedCity) {
           return "Please select a city"
        }
        return false;
    };

    var isValidLocalityProff = function(locality) {

        var validChar = /^[A-Za-z()\.,\-/0-9 #']*$/;
        var validCharAddress = /[a-zA-Z]/;

        if ((!locality || (locality == ""))) {
            return false;
        }
        
        if ((!validChar.test(locality)) || (!validCharAddress.test(locality))) {
            return "Enter a valid Locality"
        }
        
        return false;
    };


    var isValidRegistraionNumber = function(RegistrationNumber) {

        var validChar = /^[a-zA-Z]{2} \d{1,2}( [a-zA-Z0-9]{1,3})? \d{1,4}$/;
        var validCharAddress = /^[a-zA-Z]{3} \d{1,4}$/;

        if ((!RegistrationNumber || (RegistrationNumber == ""))) {
           return "Enter Registration Number"
        }

        console.log(validChar.test(RegistrationNumber));
        console.log(validCharAddress.test(RegistrationNumber));

        
        if ((validChar.test(RegistrationNumber)) || (validCharAddress.test(RegistrationNumber))) {
         return false;
        }else{
            return "Enter valid Registration Number"
        }
        return false;
    };



   




    var isValidRiderPremium = function(enterAmount,total,percentage) {
        return true;  
    };


    var isValidAdult = function(dateOfBirth) {
        var age = calcAge(dateOfBirth);
        if(Number(age) < 18) {
            return 'Age should be greater than or equal to 18 Years';
        }
        return false;
    }
    var isvalidDateForRelationship = function(relationship,age){
        if(age && relationship){
                    if(relationship.key == "3" || relationship.key == "4"){
                }else{
                     var currentAge = calcAge(age)
                     if(Number(currentAge) < 18) {
                      return $translate.instant('MAJOR_DATE_VALIDATION');
                   }
                }
            
        }else{
          if(!age){
                  return $translate.instant('PLEASE_ENTER_DATE_OF_BIRTH');
          }
        }
      return false;
    }


    var isValidGrossIncome = function(grossIncome) {
        if (!grossIncome) {
            return $translate.instant('PleaseEnterIncome');
        }
        return false;
    };

    var isValidDateGI = function(selectedDate,minDate,maxDate) {
       selectedDate = new Date(selectedDate);
       minDate  = new Date(minDate);
       maxDate = new Date(maxDate);
      if((selectedDate.getTime()) < (minDate).getTime()){
         return $translate.instant('SELECT_VALID_DATE');
      }else if((selectedDate.getTime()) > (maxDate).getTime()){
         return $translate.instant('SELECT_VALID_DATE');
      }
        return false;
    };

    var isValidEInsurance = function(accountNum) {
        if (!accountNum) {
            return $translate.instant('Please Enter Account Number');
        }
        var validAccountNumber = /^[1-2][a-zA-Z0-9]*$/;
        var alphaNumeric = /^[a-zA-Z0-9]*$/;
        if(!alphaNumeric.test(accountNum)){
            return $translate.instant('ALPHANUMERIC_ONLY');
        }
        if(!validAccountNumber.test(accountNum) || accountNum.length != 13){
            return $translate.instant('E_INSURANCE_ERROR');
        }
        return false;
    };

    var calculateAgeOfVehicle = function(policyStartDate, dateOfRegistraion) {
        var age = "0";
        var diff = new Date(policyStartDate).getTime() - new Date(dateOfRegistraion).getTime();
        age = diff / (24 * 1000 * 60 * 60);
        age = (age / 365) + "";
        var fraction = age.split(".");
        if (fraction && fraction.length > 1) {
            var decimal = fraction[1];
            if(decimal.length > 3){
                age = (+age).toFixed(3);
                fraction = age.split(".");
                if (+fraction[1][2] < 5) {
                    age = +(+age + 0.001).toFixed(3);
                }
            }
        }
        return parseInt(age).toFixed(3);
    };

     var isValidDateOfBirth = function(birthDate) {
        if (!birthDate) {
            return $translate.instant('Please Enter Date Of Birth');
        }
        return false;
    };

    var isValidEmploymentType = function(employmentType) {
        if (!employmentType) {
            return 'Please Select Employment Type';
        }
        return false;
    };

    var isValidProfessionType = function(employmentType) {
        if (!employmentType) {
            return 'Please Select Profession Type';
        }
        return false;
    };

    var isValidProfession = function(employmentType) {
        if (!employmentType) {
            return 'Please Enter Profession';
        }
        return false;
    };

    var isValidResidanceType = function(resiType){
        if (!resiType || resiType == undefined) {
            return 'Please Select Residence Type';
        }
        return false;
    }

    var isValidEmployerType = function(employerType) {
        if (!employerType) {
            return 'Please Select Employer Type';
        }
        return false;
    };

    var hlValidState = function(employerType) {
        if (!employerType) {
            return 'Please select state';
        }
        return false;
    };

    var hlValidDistrict = function(employerType) {
        if (!employerType) {
            return 'Please select district';
        }
        return false;
    };

    var hlValidSubDistrict = function(employerType) {
        if (!employerType) {
            return 'Please select sub-district';
        }
        return false;
    };

    var hlValidVillage = function(employerType) {
        if (!employerType) {
            return 'Please select village/town';
        }
        return false;
    };

    var hlValidCity = function(employerType) {
        if (!employerType) {
            return 'Please select city';
        }
        return false;
    };

    var isValidLoanPurpose = function(employerType) {
        if (!employerType) {
            return 'Please select Loan purpose';
        }
        return false;
    };

    var isValidLoanRepayment = function(employerType) {
        if (!employerType) {
            return 'Please select Loan repayment';
        }
        return false;
    };
    
     var isValidAlphaWithoutSpecial = function(text) {
        var alphaNumeric = /^[a-zA-Z0-9]*$/;
        text = text.replace(" ",'')
        if(!alphaNumeric.test(text)){
            return $translate.instant('ALPHANUMERIC_ONLY');
        }
        return false;
    };

    var isValidSSHeight = function(height) {
        if(parseInt(height) > 11){
            return 'Please enter inches(0-11)';
        }
        return false;
    };

    var renewalIsPolicyValid = function(PolicyNum) {
        if (!PolicyNum) {
            return  $translate.instant('Policy No.is required ');
        }
        if (PolicyNum.length < 11) {
            return  $translate.instant('Policy No.is not valid ');
        }
        return false;
    };
    var renewalIsSumAssuredValid = function(PolicyNum) {
        if (!PolicyNum) {
            return  $translate.instant('Sum assured is required');
        }        
        return false;
    };
    var renewalIsPremiumDueValid = function(PolicyNum) {
        if (!PolicyNum) {
            return  $translate.instant('Premium due is required');
        }        
        return false;
    };
    var renewalIsProductValid = function(Policy) {
        if (!Policy) {
            return  $translate.instant('Product name is required ');
        }        
        return false;
    };
    var isValidOfficeName = function(officeName) {
        if (!officeName) {
            return $translate.instant('Please enter office name');
        }
        var pattern = /^[A-Za-z ]*$/;
        if (!pattern.test(officeName)) {
            return "Please Enter alphabets only"
        }

        return false;
    };

    var isValidDestPinCode = function(pinCode) {
        var validPin= /^[1-9][0-9]{5}$/;
        if(pinCode && validPin.test(pinCode)) {
            return true;
        }else{
            return false;
        }
        
    };
    var isValidDestAddress = function(address) {
        var validChar = /^[A-Za-z().,-/0-9 #]*$/;
        if (address && validChar.test(address)) {
            return true;
        }else{
            return false;
        }
       
    };
    var makeValidPlotNo = function(text) {
        var validPlotNo = /^[A-Za-z0-9 \.,\/\-]*$/;
        if(!validPlotNo.test(text)){           
            return text.replace(/[^A-Za-z0-9./,-\s]/g, '');
        }else{
            return text;
        } 
    };
  var isValidEAccount = function(eAcc){
        if(!eAcc){
            return "Please enter e-Insurance Account Number";
        }else if(eAcc.length != 13){
             return "Please enter valid e-Insurance Account Number";
        }
    }

    var isValidRepo = function(repo){
        if(!repo){
            return "Please select Repository Name";
        }
        return false;
    }
    var isValidCKYC = function(KYCNumber) {
        if (!KYCNumber || KYCNumber == "") {
            return 'Please enter CKYC Number';
        } 
        var pattern = /^\d{14}$/;
        if(!pattern.test(KYCNumber)) {
            return 'Please enter valid CKYC Number';
        }
        return false;
    };

    var isValidIrctcMobileNo = function(phoneNo) {
        var regexp = new RegExp("^((?!0)\\d{10})$");
        var errMessage = !phoneNo || phoneNo.length < 10 ? "Enter valid mobile number" : !regexp.test(phoneNo) ? "Enter valid mobile number" : false;
        return errMessage;
    };

    return {
        isValidSign: isValidSign,
        isPuccaHouse: isPuccaHouse,
        isGahi: isGahi,
        isHouseCarpet: isHouseCarpet,
        isPropertyLocation: isPropertyLocation,
        isValidDocAge: isValidDocAge,
        isValidDocInc: isValidDocInc,
        isValidlocality: isValidlocality,
        isValidDocId: isValidDocId,
        isValidDocAdd: isValidDocAdd,
        isValidDocPhoto: isValidDocPhoto,
        isValidhealthStatus: isValidhealthStatus,
        isValidMotherName: isValidMotherName,
        isValidSpouseName: isValidSpouseName,
        isValidCountryOfBirth: isValidCountryOfBirth,
        isValidResedentialStatus: isValidResedentialStatus,
        isValidNatureOfOrganization: isValidNatureOfOrganization,
        isValidCKYCNumber: isValidCKYCNumber,
        isValidGSTNumber:isValidGSTNumber,
        isValidCountryOfTaxResident: isValidCountryOfTaxResident,
        isValidTINNumber: isValidTINNumber,
        isValidIdentifyType: isValidIdentifyType,
        isValidResidentialadress: isValidResidentialadress,
        isValidResidentType : isValidResidentType,
        isMarritialStatus : isMarritialStatus,
        isValidMonthsInResidence : isValidMonthsInResidence,
        isValidMonthsInWork : isValidMonthsInWork,
        isValidMonthsInWorkCar:isValidMonthsInWorkCar,
        isValidYearsInWorkCar:isValidYearsInWorkCar,
        isValidMonthsInJob : isValidMonthsInJob,
        isValidMonthsInJobProfession:isValidMonthsInJobProfession,
        isValidIdBuisness: isValidIdBuisness,
        isValidExistingSBILifeCustomer: isValidExistingSBILifeCustomer,
        isValidBirthDateForPolicy: isValidBirthDateForPolicy,
        isPTARiderTerm: isPTARiderTerm,
        isValidHomePolicyTenure: isValidHomePolicyTenure,
        isValidAmount: isValidAmount,
        isValidPassportNo: isValidPassportNo,
        isValidPANNo: isValidPANNo,
        isValidPanNumber : isValidPanNumber,
        isValidGender: isValidGender,
        isValidPolicyTenure: isValidPolicyTenure,
        isValidPolicyEndDate: isValidPolicyEndDate,
        isValidPolicyStartDate: isValidPolicyStartDate,
        isValidDOB: isValidDOB,
        isValidPincode: isValidPincode,
        isValidPincodeNonMandatory : isValidPincodeNonMandatory,
        isValidName: isValidName,
        isValidMiddleLastName: isValidMiddleLastName,
        isValidNomineeLastName: isValidNomineeLastName,
        isValidPhoneNo: isValidPhoneNo,
        isValidPhoneMandatory : isValidPhoneMandatory,
        isValidEmail: isValidEmail,
        isValidEmailHL:isValidEmailHL,
        isValidEmailHLNonMandatory : isValidEmailHLNonMandatory,
        isValidProductType: isValidProductType,
        isValidbirthDate: isValidbirthDate,
        isValidSumInsured: isValidSumInsured,
        isValidSumInsuredHDC: isValidSumInsuredHDC,
        isValidRelationship: isValidRelationship,
        isValidVerifyCall: isValidVerifyCall,
        isValidPolicyNum: isValidPolicyNum,
        isValidDepositoryName: isValidDepositoryName,
        isValidFinancialyear: isValidFinancialyear,
        isValidOTPNum: isValidOTPNum,
        isValidAdress: isValidAdress,
        isValidAdressNonMandatory : isValidAdressNonMandatory,
        isValidCity: isValidCity,
        isValidRelationshipProposer: isValidRelationshipProposer,
        isValidRelationshipNominee: isValidRelationshipNominee,
        isValidMember: isValidMember,
        isValidLocatiom: isValidLocatiom,
        isValidOccupation: isValidOccupation,
        isValidOccupationArsa : isValidOccupationArsa,
        isValidIncome: isValidIncome,
        isValidMonthlyIncome: isValidMonthlyIncome,
        isValidAnnualIncomeHL:isValidAnnualIncomeHL,
        isValidMonthlyExpense: isValidMonthlyExpense,
        isValidMstatus: isValidMstatus,
        isValidRetire: isValidRetire,
        isValidSavings: isValidSavings,
        isValidPostretire: isValidPostretire,
        isValidOutstandingHomeLoan: isValidOutstandingHomeLoan,
        isValidOutstandingOtherLoan: isValidOutstandingOtherLoan,
        isValidExistingPolicyDetails: isValidExistingPolicyDetails,
        isValidInflation: isValidInflation,
        isValidRisk: isValidRisk,
        isValidBuyHomeBy: isValidBuyHomeBy,
        isValidDate: isValidDate,
        isValidCurrentCost: isValidCurrentCost,
        isValidAadharCardNum: isValidAadharCardNum,
        isValidPolicyType: isValidPolicyType,
        isValidPreviousCompanyName: isValidPreviousCompanyName,
        isValidPreviousCompanyAdress: isValidPreviousCompanyAdress,
        isValidPreviousPolicyNumber: isValidPreviousPolicyNumber,
        isValidPreviousProofOfNCB: isValidPreviousProofOfNCB,
        isValidNCBOnPreviousPolicy: isValidNCBOnPreviousPolicy,
        isValidPolicyOption: isValidPolicyOption,
        isValidTranferOfNCB: isValidTranferOfNCB,
        isValidNatureOfLoss: isValidNatureOfLoss,
        isValidVhicleMake: isValidVhicleMake,
        isValidVhicleModel: isValidVhicleModel,
        isValidVhicleVarient: isValidVhicleVarient,
        isValidVhicleFuelType: isValidVhicleFuelType,
        isValidYearOfManufacture: isValidYearOfManufacture,
        isValidPANTANNo:isValidPANTANNo,
        isValidDateOfRegistration: isValidDateOfRegistration,
        isValidRTOLocation: isValidRTOLocation,
        isValidSugesstedIDV: isValidSugesstedIDV,
        isValidVehiclePurchasedAS: isValidVehiclePurchasedAS,
        isValidDateOfRegistrationNumber: isValidDateOfRegistrationNumber,
        isValidEngineNumber: isValidEngineNumber,
        isValidChassisNumber: isValidChassisNumber,
        isValidDriverExperience: isValidDriverExperience,
        isValidFinaceType: isValidFinaceType,
        isValidFinaceCompanyName: isValidFinaceCompanyName,
        isValidFinaceCompanyCity: isValidFinaceCompanyCity,
        isValidNomineeRelationWithInsured: isValidNomineeRelationWithInsured,
        isValidAppointeeRelationshipwithNominee: isValidAppointeeRelationshipwithNominee,
        isValidAppointeeRelationshipwithInsured: isValidAppointeeRelationshipwithInsured,
        isValidAddress: isValidAddress,
        isValidForceNumber : isValidForceNumber,
        isValidDomicile: isValidDomicile,
        isValidNightPaerkingPinCode: isValidNightPaerkingPinCode,
        isValidAchieveBy: isValidAchieveBy,
        isValidChildEduFund: isValidChildEduFund,
        isValidFatherName: isValidFatherName,
        isValidMaidenName: isValidMaidenName,
        isValidJkResident: isValidJkResident,
        isValidNationality: isValidNationality,
        isValidCountryOfResidence: isValidCountryOfResidence,
        isValidNameOfEmployer: isValidNameOfEmployer,
        isValidAddressOfEmployer: isValidAddressOfEmployer,
        isValidPoliticallyExposed: isValidPoliticallyExposed,
        isValidConvictionHistory: isValidConvictionHistory,
        isValidInsuranceCompany: isValidInsuranceCompany,
        isValidYearOfIssue: isValidYearOfIssue,
        isValidProductName: isValidProductName,
        isValidUndergoneMedical: isValidUndergoneMedical,
        isValidAccountNum: isValidAccountNum,
        isValidAccountNumber : isValidAccountNumber,
        isValidCurrentCostMarr: isValidCurrentCostMarr,
        isValidMarriageEduFund: isValidMarriageEduFund,
        isValidSavingsMarr: isValidSavingsMarr,
        isValideInsuranceAccNum: isValideInsuranceAccNum,
        isValidInsuranceAccountNumber: isValidInsuranceAccountNumber,
        isValidPlaceName : isValidPlaceName,
        isValidSumAssured: isValidSumAssured,
        isValidPolicyTerm: isValidPolicyTerm,
        isValidPremiumFrequency: isValidPremiumFrequency,
        isValidExistingPolicy: isValidExistingPolicy,
        isValidHeight: isValidHeight,
        isValidWeight: isValidWeight,
        isValidMonthlyIncomeFD: isValidMonthlyIncomeFD,
        isValidRS_Q1: isValidRS_Q1,
        isValidRS_Q11: isValidRS_Q11,
        isValidRS_Q8: isValidRS_Q8,
        isValidRS_Q12: isValidRS_Q12,
        isValidchildAge: isValidchildAge,
        isValidPlanOption: isValidPlanOption,
        isValidSumAssuredSS: isValidSumAssuredSS,
        isValidSumAssuredSN: isValidSumAssuredSN,
        isValidPolicyObjective: isValidPolicyObjective,
        isValidLanguageOfCommu: isValidLanguageOfCommu,
        isValidActivityName: isValidActivityName,
        isValidAddressProof: isValidAddressProof,
        isValidAnnualIncome: isValidAnnualIncome,
        isValidIdentityProof: isValidIdentityProof,
        isValidIncomeProof: isValidIncomeProof,
        isValidAgeProof: isValidAgeProof,
        isValidQualification: isValidQualification,
        isValidBuilding: isValidBuilding,
        isValidStreet: isValidStreet,
        isValidLocality: isValidLocality,
        isValidNatureOfCompany: isValidNatureOfCompany,
        isValidDesignation: isValidDesignation,
        isValidYears: isValidYears,
        isValidMobileNo: isValidMobileNo,
        isValidOfficeNo: isValidOfficeNo,
        isValidState: isValidState,
        isValideTravelPurpose: isValideTravelPurpose,
        isValidCountryStay: isValidCountryStay,
        isValidYearlyPremiumRS: isValidYearlyPremiumRS,
        isValidSumAssuredRS: isValidSumAssuredRS,
        isValidPremiumPaidForRS: isValidPremiumPaidForRS,
        isValidPolicyStatus: isValidPolicyStatus,
        isValidStreetName: isValidStreetName,
        isValidBuildingName: isValidBuildingName,
        isValidplotNO: isValidplotNO,
        isValidNumberofFloor: isValidNumberofFloor,
        isValidYourFloor: isValidYourFloor,
        isValidTypeOfBuilding: isValidTypeOfBuilding,
        isValidYearOfConstruction: isValidYearOfConstruction,
        isValidAreadofProperty: isValidAreadofProperty,
        isValidFinanceInstruct: isValidFinanceInstruct,
        isValidFinancebranch: isValidFinancebranch,
        isValidloanaccount: isValidloanaccount,
        isValidPreferedLocation: isValidPreferedLocation,
        isValidDeseaseList: isValidDeseaseList,
        isValidDesease: isValidDesease,
        isValidCompanyName: isValidCompanyName,
        isValidTreatmentDetail: isValidTreatmentDetail,
        isValidCurrentStatus: isValidCurrentStatus,
        isValidTreatmentStartDate: isValidTreatmentStartDate,
        isValidInsuranceInsuredSince: isValidInsuranceInsuredSince,
        isValidInsuranceInsuredTo: isValidInsuranceInsuredTo,
        isValidInsuranceInsuredToFrom: isValidInsuranceInsuredToFrom,
        isValidInsuranceInsuredFrom: isValidInsuranceInsuredFrom,
        isPTARiderTermAD: isPTARiderTermAD,
        isPTARiderTermADis: isPTARiderTermADis,
        isValidAgeGroup: isValidAgeGroup,
        isValidCashLimit: isValidCashLimit,
        getCurrentDate: getCurrentDate,
        getFutureDate: getFutureDate,
        getFutureYear: getFutureYear,
        isPTARiderSumAssuredADBRider: isPTARiderSumAssuredADBRider,
        isPTARiderSumAssuredADBRiderSM: isPTARiderSumAssuredADBRiderSM,
        isValidBirthDateForPlanPolicy: isValidBirthDateForPlanPolicy,
        isValidPremiumAmount: isValidPremiumAmount,
        isValidPremiumAmountRS: isValidPremiumAmountRS,
        isValidAgeProposer: isValidAgeProposer,
        isValidSamf: isValidSamf,
        isValidperequity: isValidperequity,
        isValidperequityopt: isValidperequityopt,
        isValidperGrowth: isValidperGrowth,
        isValidperBalanced: isValidperBalanced,
        isValidperBond: isValidperBond,
        isValidperMoneyMarket: isValidperMoneyMarket,
        isValidperTop300: isValidperTop300,
        isValidnoOfYears: isValidnoOfYears,
        isValidTitle: isValidTitle,
        isValidChildAge: isValidChildAge,
        isValidAssuredrel: isValidAssuredrel,
        isValidNomineerel: isValidNomineerel,
        isValidDiagnosisDate: isValidDiagnosisDate,
        isValidNatureDisease: isValidNatureDisease,
        isValidInfoDoctorHospital: isValidInfoDoctorHospital,
        isValidFirstName: isValidFirstName,
        isValidLastName: isValidLastName,
        isValiddetails: isValiddetails,
        isHivpresent: isHivpresent,
        isHepapresent: isHepapresent,
        isValidHusincome: isValidHusincome,
        isValidinsdetails: isValidinsdetails,
        isValidHazardOccup: isValidHazardOccup,
        calcAge: calcAge,
        isValidAge: isValidAge,
        isValidDeathAge : isValidDeathAge,
        isValidMaturitySC: isValidMaturitySC,
        isValidPresentHealthState: isValidPresentHealthState,
        isValidifDeadCauseOfDeath: isValidifDeadCauseOfDeath,
        isValidNatureofIll: isValidNatureofIll,
        isValidPreviousCurrent: isValidPreviousCurrent,
        isValidPlaceOfBirth: isValidPlaceOfBirth,
        isValidInstructions: isValidInstructions,
        isValidOtherCountryTaxPayer: isValidOtherCountryTaxPayer,
        isValidMaritalStatus: isValidMaritalStatus,
        isValidLandlineNo: isValidLandlineNo,
        isValidPPT: isValidPPT,
        isAgree: isAgree,
        isValidAlphabets: isValidAlphabets,
        isValidIdenNum: isValidIdenNum,
        isValidIdenChoose: isValidIdenChoose,
        isValidBDayRS: isValidBDayRS,
        isValidBDaySC: isValidBDaySC,
        isValidBDaySN: isValidBDaySN,
        isValidPlotNo: isValidPlotNo,
        isValidSumAssuredSC: isValidSumAssuredSC,
        isValidEmployment: isValidEmployment,
        isValidGrossSalary: isValidGrossSalary,
        isValidAilmentDetails: isValidAilmentDetails,
        isValidSmokeStatus: isValidSmokeStatus,
        isValidInsuredPerson: isValidInsuredPerson,
        isValidNoOfYearsEmployement: isValidNoOfYearsEmployement,
        isValidDenialDetail: isValidDenialDetail,
        isValidYesNo: isValidYesNo,
        isValidBDaySS: isValidBDaySS,
        isPTARiderSumAssuredCC: isPTARiderSumAssuredCC,
        checkMaxSamf: checkMaxSamf,
        checkMinSamf: checkMinSamf,
        isValidOTPNumCards: isValidOTPNumCards,
        isValidPolicyTermRS: isValidPolicyTermRS,
        isValidPolicyTermSS: isValidPolicyTermSS,
        isValidPolicyTermSN: isValidPolicyTermSN,
        isValidPolicyTermSM: isValidPolicyTermSM,
        isValidPolicyTermSW: isValidPolicyTermSW,
        isValidAvailDiscount: isValidAvailDiscount,
        isValidPolicyNumber: isValidPolicyNumber,
        isValidAreaCode: isValidAreaCode,
        isValidProffStreet : isValidProffStreet,
        isValidCityCards : isValidCityCards,
        isValidLocalityProff : isValidLocalityProff,
        isValidRiderPremium : isValidRiderPremium,
        isValidAdult : isValidAdult,
        isvalidDateForRelationship : isvalidDateForRelationship,
        isValidGrossIncome : isValidGrossIncome,
        isValidEmployerName : isValidEmployerName,
        isValidDateGI : isValidDateGI,
        isValidRegistraionNumber : isValidRegistraionNumber,
        isValidEInsurance : isValidEInsurance,
        calculateAgeOfVehicle : calculateAgeOfVehicle,
        isValidDateOfBirth : isValidDateOfBirth,
        isValidEmploymentType : isValidEmploymentType,
        isValidProfessionType : isValidProfessionType,
        isValidProfession : isValidProfession,
        isValidResidanceType: isValidResidanceType,
        isValidEmployerType : isValidEmployerType,
        hlValidState:hlValidState,
        hlValidDistrict:hlValidDistrict,
        hlValidSubDistrict : hlValidSubDistrict,
        hlValidVillage : hlValidVillage,
        hlValidCity:hlValidCity,
        isValidLoanPurpose : isValidLoanPurpose,
        isValidLoanRepayment : isValidLoanRepayment,
        isValidAlphaWithoutSpecial : isValidAlphaWithoutSpecial,
        isValidSSHeight : isValidSSHeight,
        isValidEducationQualification : isValidEducationQualification,
        isValidOfficeName : isValidOfficeName,
        isValidAlternateContact : isValidAlternateContact,
        isValidRinInches:isValidRinInches,
        renewalIsPolicyValid:renewalIsPolicyValid,
        renewalIsProductValid:renewalIsProductValid,
        renewalIsSumAssuredValid:renewalIsSumAssuredValid,
        renewalIsPremiumDueValid:renewalIsPremiumDueValid,
        makeValidPlotNo:makeValidPlotNo,
        isValidDestPinCode:isValidDestPinCode,
        isValidDestAddress:isValidDestAddress,

        isValidLastNameGI: isValidLastNameGI,
        isValidEAccount:isValidEAccount,
        isValidRepo:isValidRepo,
        isValidCKYC:isValidCKYC,
	isValidIrctcMobileNo:isValidIrctcMobileNo
    };
}

