'use strict';

angularApp.service('VIDDataService',
    function($q, AdapterUtils, constantConfig) {
        var VIDDataService = this;
        VIDDataService.generateAadharOtp = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.generateAadharOtp, requestData, true).then(
                
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        VIDDataService.getEKycOTPSecure = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getEKycOTPSecure, requestData, true).then(
                
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        }; 
		VIDDataService.aadhrOTPattempt = 0;
          
        return VIDDataService;
    });
