'use strict';

angularApp.controller('addFundsToYourAccountController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",


    function($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var addFundsToYourAccountVm = this;

        function initPage() {
            addFundsToYourAccountVm.showBack = true;
            addFundsToYourAccountVm.showNext = false;
            addFundsToYourAccountVm.aofooter = true;
        }

        addFundsToYourAccountVm.goBacktoPrevious = function() {
            $state.go('menu.addFundsOptions');
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }
        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
