'use strict';

angularApp.controller('applyNewOrResumeController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var applyNewOrResumeVm = this;

        function initPage() {
            applyNewOrResumeVm.showBack = false;
            applyNewOrResumeVm.showNext = false;
        }

        applyNewOrResumeVm.createNewAccount = function() {
            aoService.isResumeJourney = false;
            $state.go("menu.accountOpening");
        }

        applyNewOrResumeVm.resumeCreateAccount = function() {
            aoService.isResumeJourney = true;
            $state.go("menu.resumeJourney");
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
