'use strict';

angularApp.service('detailsExistService',
    function($q, AdapterUtils, constantConfig) {
        var detailsExistService = this;
        detailsExistService.getDetailsExistContent = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.detailsExist, true).then(

                function(response) {
                    q.resolve(response.data.details);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return detailsExistService;
    });
