'use strict';

angularApp.controller('homePageController', ["$state",
    "$scope","$ionicHistory","aoService","$timeout","$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $ionicHistory,
        aoService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var homePageVm = this;

        function initPage() {
            homePageVm.hideBtn = true;
         //   window.addEventListener('native.showkeyboard', homePageVm.keyboardShowHandler);
         //   window.addEventListener('native.hidekeyboard', homePageVm.keyboardHideHandler);
        }

        homePageVm.goToYourAccount = function() {
            $state.go('menu.sbiInTouchRegisterOptions');
        }

        homePageVm.openDigitalAccount = function(){
            //$state.go("menu.applyNewOrResume");
			$state.go("menu.ao_landing");
        }

        homePageVm.goToShoppingPage = function(){
            $state.go("menu.ompMerchants");
        }

        //Show the footer when keypad is hidden
        // homePageVm.keyboardHideHandler = function(e) {
        //     var j;
        //     var footer = document.getElementsByClassName("app-footer");
        //     for (j = 0; j < footer.length; j++) {
        //         footer[j].style.display = 'block';
        //     }
        // }

        // //Hide the footer when keypad is shown
        // homePageVm.keyboardShowHandler = function(e) {
        //     var j;
        //     var footer = document.getElementsByClassName("app-footer");
        //     for (j = 0; j < footer.length; j++) {
        //         footer[j].style.display = 'none';
        //     }
        // }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

         //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);  
            $timeout(function () {
                $ionicHistory.clearCache();
                $ionicHistory.clearHistory();
            }, 1500)         
        });
        return this;
    }
]);
