'use strict';

angularApp.service('mapService',
    function($q, AdapterUtils, constantConfig) {

        var mapService = this;

        mapService.getBranchesForGeo = function(params) {

            var q = $q.defer(); 
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getBranchesForGeo + params.longitude + "&latitude=" + params.latitude, true).then(

                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return mapService;
    });
