'use strict';

angularApp.service('netBankingRegisterService',
    function($q, AdapterUtils, constantConfig) {
        var netBankingRegisterService = this;

        netBankingRegisterService.registerInternetBanking = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.registerInternetBanking, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };
        
        return netBankingRegisterService;
    });
