'use strict';

angularApp.service('passwordRecoveryService',
    function($q, AdapterUtils, constantConfig) {
        var passwordRecoveryService = this;

        passwordRecoveryService.checkUser = function(requestData) {
            
            var q = $q.defer();
           
           AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.passwordRecoveryRequest, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return passwordRecoveryService;

    });
