'use strict';

angularApp.service('personalDetailsService',
    function($q, AdapterUtils, constantConfig) {
        var personalDetailsService = this;
        personalDetailsService.updateAadhaarDetails = function(requestParams) {
            var q = $q.defer(); 

            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.adharcard, requestParams, true).then(
                function(response){ 
                    q.resolve(response);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return personalDetailsService;
}); 