'use strict';

angularApp.service('pdetailsCAddressService',
    function($q, AdapterUtils, constantConfig) {
        var pdetailsCAddressService = this;
        pdetailsCAddressService.updateCorrespondenceAddress = function(requestData) {
            var q = $q.defer();
             AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.updateCorrespondenceAddress,requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        pdetailsCAddressService.updateAadhaarDetails = function(requestData) {
            var q = $q.defer();
             AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.adharcard, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        pdetailsCAddressService.getAreaDetailForPincode = function(inputparams) {
            var q = $q.defer();
           AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getPostalDetailByPinCode  ,inputparams, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return pdetailsCAddressService;
    });
