
'use strict';

angularApp.service('resumeJourneyService',
    function($q, AdapterUtils, constantConfig) {
        var resumeJourneyService = this;

        resumeJourneyService.getPageDetails = function(requestData) {
            var q = $q.defer();
             AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.pageDetails + requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        resumeJourneyService.getCustomerDetails = function(requestData) {
            
            var q = $q.defer();
           
           AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.customerDocumentDetails, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return resumeJourneyService;
    });
