'use strict';

angularApp.service('taxService',
    function($q, AdapterUtils, constantConfig) {
        var taxService = this;

        taxService.setFactaFlag = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.setFactaFlag, requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        taxService.getFatcaDeclaration = function(){
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getFatcaDeclaration, true).then(

                function(response) {
                    q.resolve(response.data.fatcaDeclaration);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return taxService;
    });
