'use strict';

angularApp.service('updateAadhaarService',
    function($q, AdapterUtils, constantConfig) {
        var updateAadhaarService = this;
        updateAadhaarService.getLocateBranchAadharContent = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.locateBranchAadhar, true).then(

                function(response) {
                    q.resolve(response.data.locateBranchUpdateAadhar);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return updateAadhaarService;
    });
