angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.aglPersonalDetails', {
                    url: '/agriPersonalDetails',
                    params: { 'agri': 'true' },
                    data: {
                        pageId: 'AGL_PD'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/aglPersonalDetails.html',
                            controller: 'aglPersonalDetailsController',
                            controllerAs: 'aglPersonalDetailsVm'
                        }
                    }
                })

                .state('menu.aglLoanDetails', {
                    url: '/aglLoanDetails',
                    params: { 'agri': 'true' },
                    data: {
                        pageId: 'AGL_LD'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/aglLoanDetails.html',
                            controller: 'aglLoanDetailsController',
                            controllerAs: 'aglLoanDetailsVm'
                        }
                    }
                })
                .state('menu.aglAdditionalDetails', {
                    url: '/aglAdditionalDetails',
                    params: { 'agri': 'true' },
                    data: {
                        pageId: 'AGL_AD'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/aglAdditionalDetails.html',
                            controller: 'aglAdditionalDetailsController',
                            controllerAs: 'aglAdditionalDetailsVm'
                        }
                    }
                })

                .state('menu.aglLoanSummary', {
                    url: '/aglLoanSummary',
                    params: { 'agri': 'true' },
                    data: {
                        pageId: 'AGL_LS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/aglLoanSummary.html',
                            controller: 'aglLoanSummaryController',
                            controllerAs: 'aglLoanSummaryVm'
                        }
                    }
                })

                .state('menu.agriSelectLanguage', {
                    url: '/agriSelectLanguage',
                    params: { 'agri': 'true' },
                    data: {
                        pageId: 'AGL_SELLANG'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/selectLanguage.html',
                            controller: 'selectLanguageController',
                            controllerAs: 'selectLanguageVm'
                        }
                    }
                })


                .state('menu.aglKnowMore', {
                    url: '/aglKnowMore',
                    params: { 'agri': 'true' },
                    data: {
                        pageId: 'AGL_KM'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/aglKnowMore.html',
                            controller: 'aglKnowMoreController',
                            controllerAs: 'aglKnowMoreVm'
                        }
                    }
                })
                .state('menu.aglError', {
                    url: '/aglError',
                    params: { 'agri': 'true' },
                    data: {
                        pageId: 'AGL_ERR'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/aglError.html',
                            controller: 'aglErrorController',
                            controllerAs: 'aglErrorVm'
                        }
                    }
                })

                .state('menu.aglResume', {
                    url: '/aglResume',
                    params: { 'agri': 'true' },
                    data: {
                        pageId: 'AGL_RESUME'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/aglResume.html',
                            controller: 'aglResumeController',
                            controllerAs: 'aglResumeVm'
                        }
                    }
                })




                .state('menu.agriLanding', {
                    url: '/agriLanding',
                    params: { 'agri': 'true' },

                    data: {
                        pageId: 'AGL_AL'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/agriLanding.html',
                            controller: 'agriLandingController',
                            controllerAs: 'agriLandingVm'
                        }
                    }
                })

                .state('menu.agriMandiLanding', {
                    url: '/agriLandingMandi',
                    params: { 'agri': 'true' },
                    data: {
                        pageId: 'AGL_ML'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/agriMandiLanding.html',
                            controller: 'agriMandiLandingController',
                            controllerAs: 'agriMandiLandingVm'
                        }
                    }
                })

                .state('menu.agriMandiMitraMerchant', {
                    url: '/agriMandiMitraMerchant',
                    params: { 'agri': 'true' },
                    data: {
                        pageId: 'AGL_MM_MERCHANT'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/agriMandiMitraMerchant.html',
                            controller: 'agriMandiMitraMerchantController',
                            controllerAs: 'agriMandiMitraMerchantVm'
                        }
                    }
                })

                .state('menu.aglRefNo', {
                    url: '/aglRefNo',
                    params: { 'agri': 'true' },
                    data: {
                        pageId: 'AGL_REF'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/aglrefNumber.html',
                            controller: 'aglrefNumberController',
                            controllerAs: 'aglrefNumberVm'
                        }
                    }
                })

                .state('menu.selectLanguage', {
                    url: '/selectLanguage',
                    data: {
                        pageId: 'AGL_SL'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/selectLanguage.html',
                            controller: 'selectLanguageController',
                            controllerAs: 'selectLanguageVm'
                        }
                    }
                })


                .state('menu.kccPersonalDetails', {
                    url: '/kccPersonalDetails',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KCC_PD'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/kccPersonalDetails.html',
                            controller: 'kccPersonalDetailsController',
                            controllerAs: 'kccPersonalDetailsVm'
                        }
                    }
                })
       



                .state('menu.kccLandholding', {
                    url: '/kccLandholding',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KCC_LH'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/kccLandholding.html',
                            controller: 'kccLandholdingController',
                            controllerAs: 'kccLandholdingVm'
                        }
                    }
                })





                .state('menu.kccCroppingPattern', {
                    url: '/kccCroppingPattern',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KCC_CP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/kccCroppingPattern.html',
                            controller: 'kccCroppingPatternController',
                            controllerAs: 'kccCroppingPatternVm'
                        }
                    }
                })




                .state('menu.kccKhataLanding', {
                    url: '/menu.kccKhataLanding',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KCC_KL'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/kccKhataLanding.html',
                            controller: 'kccKhataLandingController',
                            controllerAs: 'kccKhataLandingVm'
                        }
                    }
                })





                .state('menu.kccReview', {
                    url: '/kccReview',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KCC_RW'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/kccReview.html',
                            controller: 'kccReviewController',
                            controllerAs: 'kccReviewVm'
                        }
                    }
                })

                .state('menu.kccrefNumber', {
                    url: '/kccRefNo',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KCC_REF'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/kccrefNumber.html',
                            controller: 'kccrefNumberController',
                            controllerAs: 'kccrefNumberVm'
                        }
                    }
                })

                .state('menu.kccApproved', {
                    url: '/kccApproved',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KCC_APPROVED'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/kccApproved.html',
                            controller: 'kccApprovedController',
                            controllerAs: 'kccApprovedVm'
                        }
                    }
                })

                .state('menu.kccOtp', {
                    url: '/kccOtp',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KCC_OTP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/kccOtp.html',
                            controller: 'kccOtpController',
                            controllerAs: 'kccOtpVm'
                        }
                    }
                })


                .state('menu.kccKnowMore', {
                    url: '/kccKnowMore',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KCC_KM'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/kccKnowMore.html',
                            controller: 'kccKnowMoreController',
                            controllerAs: 'kccKnowMoreVm'
                        }
                    }
                })



               

               

                .state('menu.kccCroppingPopup', {
                    url: '/kccCroppingPopup',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KCC_CPP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/kccCroppingPopup.html',
                            controller: 'kccCroppingPatternController',
                            controllerAs: 'kccCroppingPatternVm'
                        }
                    }
                })

                .state('menu.kccLandholdingPopup', {
                    url: '/kccLandholdingPopup',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KCC_LHP'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/kccLandholdingPopup.html',
                            controller: 'kccLandholdingController',
                            controllerAs: 'kccLandholdingVm'
                        }
                    }
                })

                .state('menu.kccError', {
                    url: '/kccError',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KCC_ERR'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/kccError.html',
                            controller: 'kccErrorController',
                            controllerAs: 'kccErrorVm'
                        }
                    }
                })




                .state('menu.bachat', {
                    url: '/bachat',
                    data: {
                        pageId: 'KCC_RE'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/bachat.html',
                            controller: 'bachatController',
                            controllerAs: 'bachatVm'
                        }
                    }
                })
                /* KUC route config starts here */
                .state('menu.kucLanding', {
                    url: '/kucLanding',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KUC_LAND'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/KUC/kucLanding.html',
                            controller: 'kucLandingController',
                            controllerAs: 'kucLandingVm'
                        }
                    }
                })
                .state('menu.kucKnowMore', {
                    url: '/kucKnowMore',
                    params: {'agri':'true'},
                    data: {
                        pageId: 'KUC_KM'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/Agl/KUC/kucKnowMore.html',
                            controller: 'kucLandingController',
                            controllerAs: 'kucLandingVm'
                        }
                    }
                })
		//SAFAL AGL Journey Starts
		.state('menu.safalIntroduction', {
			url: '/safalIntroduction',
			params: {'agri':'true'},
			cache: false,
			data: {
				pageId: 'AGL_SAFAL'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/Agl/safal/safalIntroduction.html',
					controller: 'safalIntroductionController',
					controllerAs: 'safalIntroductionVm'
				}
			}
		})
		.state('menu.safalError', {
			url: '/safalError',
			params: {'agri':'true'},
			cache: false,
			data: {
				pageId: 'AGL_SAFALERROR'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/Agl/safal/safalError.html',
					controller: 'safalErrorController',
					controllerAs: 'safalErrorVm'
				}
			}
		})
		.state('menu.safalPersonalDetails', {
			url: '/safalPersonalDetails',
			params: {'agri':'true'},
			cache: false,
			data: {
				pageId: 'AGL_SAFAL_PERSONAL_DETAILS'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/Agl/safal/safalPersonalDetails.html',
					controller: 'safalPersonalDetailsController',
					controllerAs: 'safalPersonalDetailsVm'
				}
			}
		})
		.state('menu.safalAdditionalDetails', {
			url: '/safalAdditionalDetails',
			params: {'agri':'true'},
			cache: false,
			data: {
				pageId: 'AGL_SAFAL_ADDITIONAL_DETAILS'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/Agl/safal/safalAdditionalDetails.html',
					controller: 'safalAdditionalDetailsController',
					controllerAs: 'safalAdditionalDetailsVm'
				}
			}
		})
		.state('menu.safalLoanDetails', {
			url: '/safalLoanDetails',
			params: {'agri':'true'},
			cache: false,
			data: {
				pageId: 'AGL_SAFAL_LOAN_DETAILS'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/Agl/safal/safalLoanDetails.html',
					controller: 'safalLoanDetailsController',
					controllerAs: 'safalLoanDetailsVm'
				}
			}
		})
		.state('menu.safalSuccess', {
			url: '/safalSuccess',
			params: {'agri':'true'},
			cache: false,
			data: {
				pageId: 'AGL_SAFAL_SUCCESS'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/Agl/safal/safalSuccess.html',
					controller: 'safalSuccessController',
					controllerAs: 'safalSuccessVm'
				}
			}
		})
		.state('menu.safalOTP', {
			url: '/safalOTP',
			params: {'agri':'true'},
			cache: false,
			data: {
				pageId: 'AGL_SAFAL_OTP'
			},
			views: {
				'menuContent': {
					templateUrl: 'pages/Agl/safal/safalOTP.html',
					controller: 'safalOTPController',
					controllerAs: 'safalOTPVm'
				}
			}
		})
		//SAFAL AGL Journey ends




        }
    ]);