'use strict';

angularApp.controller('kccCroppingPatternController', [
    "$state",
    "$scope",
    "$filter",
    "$ionicPopup",
    "AdapterUtils",
    "$ionicViewSwitcher",
    function ($state, $scope,$filter,$ionicPopup,AdapterUtils,$ionicViewSwitcher ) {
        var kccCroppingPatternVm = this;
        kccCroppingPatternVm.closeView = function () {
            $state.go('menu.kccKhataLanding');
        }
        kccCroppingPatternVm.goBack = function () {
            $state.go("menu.kccLandholding");
        }
        kccCroppingPatternVm.goToPopUp = function () {
            kccCroppingPatternVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'new-purp-popup yono-kcc-popup',
                templateUrl: 'pages/Agl/kccCroppingPopup.html',
                scope: $scope
            })
        }
        kccCroppingPatternVm.OK = function () {
            kccCroppingPatternVm.myPopup.close();
             $ionicViewSwitcher.nextDirection('back');
             $state.go("menu.agriLanding");
        }
        kccCroppingPatternVm.Cancel = function () {
            kccCroppingPatternVm.myPopup.close();
        }
        kccCroppingPatternVm.goToNextPage = function () {
            $state.go("menu.kccReview");
        };
        return this;
    }
]);