angularApp.service('kccService',
    function($q, AdapterUtils, utilityService, constantConfig, $ionicPopup, $state) {
        var kccService = this;
         kccService.getLandAndCropDetails = function(request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/KCCReview/getLandAndCropDetails", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
         kccService.submitApplication = function(request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/KCCReview/submitApplication", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
       kccService.executeBusinessEligibility = function(request) { 
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/KCCReview/executeBusinessEligibility", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }
       kccService.executeYonoDedup = function() {
            var request = {};
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/KCCReview/executeYonoDedup", request, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }
        return kccService;
    });