'use strict';
angularApp.controller('kccrefNumberController', [
    "$state",    
    "$scope",
    "kccService", "agriMandiService","AdapterUtils",
    function ($state, $scope, kccService, agriMandiService,AdapterUtils) {
        var kccrefNumberVm = this;
        kccrefNumberVm.goBack = function () {
            state.go('menu.homeScreen')
        }
        kccrefNumberVm.closeView = function () {
            $state.go('menu.kccKhataLanding');
        }
        $scope.$on('$ionicView.beforeEnter', function () {
            kccrefNumberVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
            kccrefNumberVm.ref = kccService.kccDetails.yonoRef;
            kccrefNumberVm.aadhaarSeeded = kccService.kccDetails.aadhaarSeeded ? kccService.kccDetails.aadhaarSeeded.toLowerCase() : "false";
            kccrefNumberVm.rupayKissanCard = kccService.kccDetails.rupayKissanCard ? kccService.kccDetails.rupayKissanCard.toLowerCase() : "false";
            kccrefNumberVm.kccBranchName = kccService.masterdata.kccBranchName;
        });
        kccrefNumberVm.goToAgri = function () {
            $state.go('menu.agriLanding');
        }
        return this;
    }
]);
