'use strict';

angularApp.controller('safalPersonalDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter","safalService","agriMandiService",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter,safalService,agriMandiService) {

        var safalPersonalDetailsVm = this;
        

        $scope.$on('$ionicView.beforeEnter', function() {

            safalPersonalDetailsVm.isMaskAccNum = true;
            safalPersonalDetailsVm.isMaskAadharNum = true;
        safalPersonalDetailsVm.permanentAddress = "";
        safalPersonalDetailsVm.detail = {};
            if (utilityService.isIOSPlatform()) {
                safalPersonalDetailsVm.scroll = false;
            } else {
                safalPersonalDetailsVm.scroll = true;
            }

          

                safalPersonalDetailsVm.masterdata = angular.copy(safalService.masterdata);
        
                 safalPersonalDetailsVm.detail = angular.copy(safalPersonalDetailsVm.masterdata);
                
            safalPersonalDetailsVm.maskaccNum();
            safalPersonalDetailsVm.MaskAadharNum();

        
            if (!safalPersonalDetailsVm.detail.addressLine1) {
                safalPersonalDetailsVm.detail.addressLine1 = "";
            } else {
                if (safalPersonalDetailsVm.detail.addressLine1.indexOf(',') == -1) {
                    safalPersonalDetailsVm.detail.addressLine1 = safalPersonalDetailsVm.detail.addressLine1 + ", ";
                } else {
                    safalPersonalDetailsVm.detail.addressLine1 = safalPersonalDetailsVm.detail.addressLine1;
                }

            }
            if (!safalPersonalDetailsVm.detail.addressLine2) {
                safalPersonalDetailsVm.detail.addressLine2 = "";
            } else {

                if (safalPersonalDetailsVm.detail.addressLine2.indexOf(',') == -1) {
                    safalPersonalDetailsVm.detail.addressLine2 = safalPersonalDetailsVm.detail.addressLine2 + ", ";
                } else {
                    safalPersonalDetailsVm.detail.addressLine2 = safalPersonalDetailsVm.detail.addressLine2;
                }
            }


            if (!safalPersonalDetailsVm.detail.addressLine3) {
                safalPersonalDetailsVm.detail.addressLine3 = "";
            } else {

                if (safalPersonalDetailsVm.detail.addressLine3.indexOf(',') == -1) {
                    safalPersonalDetailsVm.detail.addressLine3 = safalPersonalDetailsVm.detail.addressLine3 + ", ";
                } else {
                    safalPersonalDetailsVm.detail.addressLine3 = safalPersonalDetailsVm.detail.addressLine3;
                }
            }
            if (!safalPersonalDetailsVm.detail.district) {
                safalPersonalDetailsVm.detail.district = "";
            } else {
                if (safalPersonalDetailsVm.detail.district.indexOf('-') == -1) {
                    safalPersonalDetailsVm.detail.district = safalPersonalDetailsVm.detail.district + " ";
                } else {
                    safalPersonalDetailsVm.detail.district = safalPersonalDetailsVm.detail.district;
                }

            }
            if (!safalPersonalDetailsVm.detail.pincode) {
                safalPersonalDetailsVm.detail.pincode = "";
            } else {
                if (safalPersonalDetailsVm.detail.pincode.indexOf('-') == -1) {
                    safalPersonalDetailsVm.detail.pincode = "- " + safalPersonalDetailsVm.detail.pincode;
                } else {
                    safalPersonalDetailsVm.detail.pincode = safalPersonalDetailsVm.detail.pincode;
                }

            }

            safalPersonalDetailsVm.permanentAddress = safalPersonalDetailsVm.detail.addressLine1 + safalPersonalDetailsVm.detail.addressLine2 + safalPersonalDetailsVm.detail.addressLine3 + safalPersonalDetailsVm.detail.district + safalPersonalDetailsVm.detail.pincode;

      

        });

        safalPersonalDetailsVm.goBack = function() {
            $ionicHistory.goBack(-1);;
        }

        safalPersonalDetailsVm.goToAdditionalDetails = function() {
             $state.go('menu.safalAdditionalDetails')
        }


        safalPersonalDetailsVm.maskaccNum= function () {
            safalPersonalDetailsVm.isMaskAccNum = true;
            var accNo = safalPersonalDetailsVm.detail.accountNumber.trim();
            safalPersonalDetailsVm.detail.accountNumber = utilityService.maskData(accNo, "front", 4);
            console.log("masked account"+safalPersonalDetailsVm.detail.accountNumber);
        }

        safalPersonalDetailsVm.unmaskaccNum = function () {
            safalPersonalDetailsVm.isMaskAccNum = false;
            
            safalPersonalDetailsVm.detail.accountNumber = safalService.masterdata.accountNumber;
        }


        safalPersonalDetailsVm.MaskAadharNum = function () {
            safalPersonalDetailsVm.isMaskAadharNum = true;
            safalPersonalDetailsVm.detail.aadhaarNumber = utilityService.maskData(safalService.masterdata.aadhaarNumber, "front", 4);
            console.log("masked aadhar"+safalPersonalDetailsVm.detail.aadhaarNumber);
           
        }

        safalPersonalDetailsVm.unMaskAadharNum = function () {
            safalPersonalDetailsVm.isMaskAadharNum = false;
            safalPersonalDetailsVm.detail.aadhaarNumber = safalService.masterdata.aadhaarNumber;
        }
    }
]);