'use strict';

angularApp.controller('automallCompareCarsController', ["$state", "$scope", "$ionicHistory", "utilityService", "clickStreamService", "$ionicSideMenuDelegate", "$ionicSlideBoxDelegate", "$ionicScrollDelegate", "loggedInUserService", "cryptoService", "$filter", "automallService",
    function ($state, $scope, $ionicHistory, utilityService, clickStreamService, $ionicSideMenuDelegate, $ionicSlideBoxDelegate, $ionicScrollDelegate, loggedInUserService, cryptoService, $filter, automallService) {
        var automallCompareCarsVm = this;


        var init = function () {
            automallCompareCarsVm.comparisonData = automallService.getComparisonData().data;
        };

        $scope.isNumber = function (value) {
            value = parseFloat(value);
            return typeof (value) === 'number';
        };

        $scope.$on('$ionicView.beforeEnter', function () {
            init();

        }, false);

        $scope.$on('$ionicView.afterEnter', function () {
            setTimeout(function () {
                var topBar = document.querySelectorAll('.app-header');
                if (topBar) {
                    topBar[1].classList.add('automall-header');
                }
            }, 500);
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            var topBar = document.querySelectorAll('.app-header');
            if (topBar) {
                topBar[1].classList.remove('automall-header');
            }
        });
        return this;
    }]);