'use strict';
angularApp.controller('filterController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"utilityService",
		"filterService",
		"searchListServices",
		"ompMerchantsService",
		"productDescriptionServices",
		"$timeout",
		"mPinLoginService",
		"clickStreamService",
		"$ionicSideMenuDelegate",
		function($state, $scope, $ionicPopup, utilityService, filterService, searchListServices, ompMerchantsService,productDescriptionServices,$timeout,mPinLoginService,clickStreamService,$ionicSideMenuDelegate) {
			var filterControllerVm = this;
			$scope.data = {
				cf : ''
			};
			
			var filterVm = this;
			filterVm.addedFilterData = [];
			filterVm.addedFilterFullData = [];
			$scope.selectedColour = [];
			$scope.priceMin = '';
			$scope.priceMax = '';
			$scope.isColourApplied = false;
			$scope.isfilterApplied = false;
			$scope.toggleGroupLevelTwo = function(groupSub) {
				$scope.isDisabledButton = false;
				if ($scope.isGroupShownLevelTwo(groupSub)) {
					$scope.shownGroupSub2 = null;
				} else {
					$scope.shownGroupSub2 = groupSub;
				}
			};
			$scope.isGroupShownLevelTwo = function(groupSub) {
				return $scope.shownGroupSub2 === groupSub;
			};
			$scope.toggleGroupSubOne = function(groupSub) {
				$scope.isDisabledButton = false;
				if ($scope.isGroupShownSub(groupSub)) {
					$scope.shownGroupSub = null;
				} else {
					$scope.shownGroupSub = groupSub;
				}
			};
			$scope.isGroupShownSub = function(groupSub) {
				return $scope.shownGroupSub === groupSub;
			};
			$scope.toggleGroup = function(group) {
				$scope.isDisabledButton = false;
				if (group.code === "category") {
					if(searchListServices.serviceFrom === 'getSelectedCategoryProduct'){
						if( (filterService.selectedLevelOneData === '') || ( filterService.selectedLevelTwoData === '') ||
						     (filterService.selectedLevelOneData == undefined) || ( filterService.selectedLevelTwoData == undefined)){
						   return "";
						}
						$state.go('menu.filterCategory');
					}else{
						$state.go('menu.filterCategoryList');
					}
					
				} else {
					if(group.code === "price"){
						$timeout(function() {
						      $scope.$broadcast('reCalcViewDimensions');
						    });
					}
						
					if ($scope.isGroupShown(group.code)) {
						$scope.shownGroup = null;
					} else {
						$scope.shownGroup = group.code;
					}
				}
			};
			$scope.isGroupShown = function(group) {
				return $scope.shownGroup === group;
			};
			$scope.selectesColour = function(isSelected, data, childIndex, parentIndex) {
				$scope.isColourApplied = true;
				if (isSelected === true) {
					filterService.selectedColour.push(data);
					filterService.filterOldData.categoryList.filters[parentIndex].data[childIndex].isSelected = true;
					$scope.filterOption = "apply";
				} else {
					var colorLen = filterService.selectedColour.length;
					for (var i = 0; i < colorLen; i++) {
						if (data.value === filterService.selectedColour[i].value) {
							filterService.selectedColour.splice(i, 1);
							break;
						}
					}
					filterService.filterOldData.categoryList.filters[parentIndex].data[childIndex].isSelected = false;
				}
				$scope.selectedColour = filterService.selectedColour;
				var a = $scope.slider.minValue;
								var b = $scope.slider.maxValue;
								var c  = $scope.slider.minValueTemp;
								var d =  $scope.slider.maxValueTemp;
								 if((a == c) && (b == d) && (filterService.addedFilterData.length == 0)
								 && (filterService.selectedColour.length == 0 )){
														$scope.isApplyButtonDisabled  = true;	
														$scope.isClearButtonDisabled = true;
														}else{
														$scope.isApplyButtonDisabled  = false;	
														$scope.isClearButtonDisabled = false;
														}
			};
			function initPage() {
				$scope.searchbrand = "Search"
				$scope.selectedFiltertype = null;
			};
			filterControllerVm.goBack = function() {
				if(!$scope.slider){
					$scope.slider = {};
					$scope.slider.minValue = 0;
					$scope.slider.maxValue = 0;
				}
				if($scope.isColourApplied || $scope.isfilterApplied || $scope.priceMin != $scope.slider.minValue || $scope.priceMax != $scope.slider.maxValue){
					$scope.backClickPop = $ionicPopup.show({
						title: '',
						cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter ftpopup-body',
						templateUrl: 'pages/OMP/filter/conifrmPopup.html',
						scope: $scope
					});
				}else{
					$state.go('menu.searchList');
				}
			};
			
			this.exit = function(){
				searchListServices.isCompareAvailable = true;
				$scope.backClickPop.close();
				$state.go('menu.searchList');
			}
			this.applyPop = function(){
				$scope.backClickPop.close();
				this.apply();
			}
			this.clear = function() {
				$scope.isDisabledButton = true;
				$scope.filterOption = "clear";
				$scope.selectedLevelOneData = filterService.selectedLevelOneData;
				$scope.selectedLevelTwoData = filterService.selectedLevelTwoData;
				$scope.selectedLevelThreeData = filterService.selectedLevelThreeData;
				$scope.data.categories = false;
				$scope.slider.minValue = parseInt(filterService.filterOldData.priceList[0].min);
				$scope.slider.maxValue = parseInt(filterService.filterOldData.priceList[0].max);
				$scope.data.cf = '';
				filterService.selectedColour = [];
				filterService.addedFilterData = [];
				filterService.addedFilterFullData = [];
				this.brand = '';
				angular.forEach($scope.brandTypes, function(item) {
					item.selected = false;
				});
				angular.forEach($scope.filterColorList, function(item) {
					item.selected = false;
				});
				
				
				
				if (searchListServices.serviceFrom === 'getSelectedCategoryProduct') {
					var obj = {
						"category" : filterService.selectedCategoryId,
						"websiteId" : ompMerchantsService.listName.websiteId,
						"filters" : [],
						"sort" : {},
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getSelectedCategoryProduct(obj).then(function(data) {
						searchListServices.allProductsList = data;
						filterService.addedFilterFullData.length = 0
						filterService.addedFilterData.length = 0
						filterService.selectedColour.length = 0
						searchListServices.isCompareAvailable = true;
						searchListServices.serviceFrom = 'getSelectedCategoryProduct';
						searchListServices.serviceFromObj = obj;
						filterService.isFilterApplied = false;
						searchListServices.isSortApplied = false;
						filterService.filterNewData = {
						                	          		categoryList : [],
						                	          		subCategoryList : [],
						                	          		colorList : [],
						                	          		priceList : [],
						                	          		callFunctionsList : []
						                	          	};
						$state.go('menu.searchList');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else if (searchListServices.serviceFrom === 'getSearchProductsList') {
					var obj = {
						"websiteId" : ompMerchantsService.listName.websiteId,
						"keyword" : searchListServices.serviceFromObj.keyword,
						"filters" : [],
						"sort" : {},
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getSearchProductsList(obj).then(function(data) {
						searchListServices.allProductsList = data;
						filterService.selectedLevelOneData = '';
						filterService.selectedLevelTwoData = "";
						filterService.selectedLevelThreeData = "";
						filterService.addedFilterFullData.length = 0
						filterService.addedFilterData.length = 0
						filterService.selectedColour.length = 0
						searchListServices.isCompareAvailable = true;
						filterService.isFilterApplied = false;
						searchListServices.isSortApplied = false;
						filterService.filterNewData = {
						                	          		categoryList : [],
						                	          		subCategoryList : [],
						                	          		colorList : [],
						                	          		priceList : [],
						                	          		callFunctionsList : []
						                	          	};
						$state.go('menu.searchList');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else if (searchListServices.serviceFrom === 'getRecentlyViewedListing') {
					var recentProductsList = {
						"websiteId" : ompMerchantsService.listName.websiteId,
						"filters" : [],
						"sort" : {},
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getRecentlyViewedListing(recentProductsList).then(function(data) {
						searchListServices.allProductsList = data;
						filterService.selectedLevelOneData = '';
						filterService.selectedLevelTwoData = "";
						filterService.selectedLevelThreeData = "";
						filterService.addedFilterFullData.length = 0
						filterService.addedFilterData.length = 0
						filterService.selectedColour.length = 0
						searchListServices.isCompareAvailable = false;
						filterService.isFilterApplied = false;
						searchListServices.isSortApplied = false;
						filterService.filterNewData = {
						                	          		categoryList : [],
						                	          		subCategoryList : [],
						                	          		colorList : [],
						                	          		priceList : [],
						                	          		callFunctionsList : []
						                	          	};
						$state.go('menu.searchList');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else if (searchListServices.serviceFrom === 'getSimilarProductList') {
					var similarProductsList = {
						"websiteId" : ompMerchantsService.listName.websiteId,
						"productId" : searchListServices.serviceFromObj.productId,
						"price" : searchListServices.serviceFromObj.price,
						"filters" : [],
						"sort" : {},
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					};
					productDescriptionServices.getSimilarProductList(similarProductsList).then(function(data) {
						searchListServices.allProductsList = data;
						filterService.selectedLevelOneData = '';
						filterService.selectedLevelTwoData = "";
						filterService.selectedLevelThreeData = "";
						filterService.addedFilterFullData.length = 0
						filterService.addedFilterData.length = 0
						filterService.selectedColour.length = 0
						searchListServices.isCompareAvailable = true;
						filterService.isFilterApplied = false;
						searchListServices.isSortApplied = false;
						filterService.filterNewData = {
						                	          		categoryList : [],
						                	          		subCategoryList : [],
						                	          		colorList : [],
						                	          		priceList : [],
						                	          		callFunctionsList : []
						                	          	};
						$state.go('menu.searchList');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					var dealList = {
						"type" : searchListServices.serviceFromObj.type,
						"websiteId" : ompMerchantsService.listName.websiteId,
						"filters" : [],
						"sort" : {},
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getDealList(dealList).then(function(data) {
						searchListServices.allProductsList = data;
						filterService.selectedLevelOneData = '';
						filterService.selectedLevelTwoData = "";
						filterService.selectedLevelThreeData = "";
						filterService.addedFilterFullData.length = 0
						filterService.addedFilterData.length = 0
						filterService.selectedColour.length = 0
						searchListServices.isCompareAvailable = false;
						filterService.isFilterApplied = false;
						searchListServices.isSortApplied = false;
						filterService.filterNewData ={
						                	          		categoryList : [],
						                	          		subCategoryList : [],
						                	          		colorList : [],
						                	          		priceList : [],
						                	          		callFunctionsList : []
						                	          	};;
						$state.go('menu.searchList');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
				
				
				
				
				
			};
			
			$scope.selectedFilterData = function(isChecked, data, code, childIndex, parentIndex) {
				$scope.isfilterApplied = true;
				if (isChecked === true) {
					if (containsObj(filterVm.addedFilterData, code)) {
						var addFltDataLen = filterVm.addedFilterData.length;
						for (var i = 0; i < addFltDataLen; i++) {
							if (filterVm.addedFilterData[i].value === code) {
								filterVm.addedFilterData[i].data.push(data.value)
								filterVm.addedFilterFullData[i].data.push({
									"label" : data.label,
									'value' : data.value
								});
							}
						}
					} else {
						var obj = {
							"value" : code,
							"data" : [
								data.value
							]
						}
						filterVm.addedFilterData.push(obj);
						var objFull = {
							"code" : code,
							"data" : [
								{
									"label" : data.label,
									'value' : data.value
								}
							]
						}
						filterVm.addedFilterFullData.push(objFull);
					}
					if (!containsData(filterService.addedFilterNewFullData, code)){
						filterService.addedFilterNewFullData.push(code);
					}
					filterService.filterOldData.categoryList.filters[parentIndex].data[childIndex].isSelected = true;
					$scope.filterOption = "apply";
				} else {
					var addFltDataLen = filterVm.addedFilterData.length;
					for (var j = 0; j < addFltDataLen; j++) {
						if (filterVm.addedFilterData[j].value === code) {
							var dataArrLength = filterVm.addedFilterData[j].data.length;
							for (var i = 0; i < dataArrLength; i++) {
								if (filterVm.addedFilterData[j].data[i] === data.value) {
									filterVm.addedFilterData[j].data.splice(i, 1)
									filterVm.addedFilterFullData[j].data.splice(i, 1);
									break;
								}
							}
							if (filterVm.addedFilterData[j].data.length <= 0) {
								filterVm.addedFilterData.splice(j, 1);
								filterVm.addedFilterFullData.splice(j, 1);
								var addedFilterNewFullDataLen = filterService.addedFilterNewFullData.length;
								for(var l = 0; l < addedFilterNewFullDataLen; l++) {
								    if(filterService.addedFilterNewFullData[l] === code) {
								    	filterService.addedFilterNewFullData.splice(l, 1);
								    }
								}
								break;
							}
						}
					}

					filterService.filterOldData.categoryList.filters[parentIndex].data[childIndex].isSelected = false;
				}
				
				var a = $scope.slider.minValue;
								var b = $scope.slider.maxValue;
								var c  = $scope.slider.minValueTemp;
								var d =  $scope.slider.maxValueTemp;
								 if((a == c) && (b == d) && (filterService.addedFilterData.length == 0)
								 && (filterService.selectedColour.length == 0 )){
														$scope.isApplyButtonDisabled  = true;	
														$scope.isClearButtonDisabled = true;
														}else{
														$scope.isApplyButtonDisabled  = false;	
														$scope.isClearButtonDisabled = false;
														}
				
			};
			function containsObj(filterArray, code) {
				var filterArrayLen = filterArray.length;
				for (var i = 0; i < filterArrayLen; i++) {
					if (filterArray[i].value === code) {
						return true;
					}
				}
				return false;
			};
			function containsData(filterArray, code) {
				var filterArrayLength = filterArray.length;
				for (var i = 0; i < filterArrayLength; i++) {
					if (filterArray[i] === code) {
						return true;
					}
				}
				return false;
			};
					
			$scope.removeSelectedFilterData = function(data, code, childIndex, parentIndex) {

				var addFltDataArrLen = filterVm.addedFilterData.length;
				for (var j = 0; j < addFltDataArrLen; j++) {
					if (filterVm.addedFilterData[j].value === code) {
						var addedFilterDataArrLen = filterVm.addedFilterData[j].data.length;
						for (var i = 0; i < addedFilterDataArrLen; i++) {
							if (filterVm.addedFilterData[j].data[i] === data.value) {
								filterVm.addedFilterData[j].data.splice(i, 1)
								filterVm.addedFilterFullData[j].data.splice(i, 1);
								angular.forEach($scope.filterItems.filters, function(item) {
									if (item.code === code) {
										angular.forEach(item.data, function(removeItem) {
											if (removeItem.value === data.value)
												removeItem.selected = false;
										});
									}
								});
								break;
							}
						}
						if (filterVm.addedFilterData[j].data.length <= 0) {
							filterVm.addedFilterData.splice(j, 1)
							filterVm.addedFilterFullData.splice(j, 1);
							break;
						}
					}
				}
				var oldDataLen = filterService.filterOldData.categoryList.filters.length
				for (var j = 0; j < oldDataLen; j++) {
					if (filterService.filterOldData.categoryList.filters[j].code === code) {
						var subOldDataLen = filterService.filterOldData.categoryList.filters[j].data.length;
						for (var i = 0; i < subOldDataLen; i++) {
							if (filterService.filterOldData.categoryList.filters[j].data[i].value === data.value) {
								filterService.filterOldData.categoryList.filters[j].data[i].isSelected = false;
							}
						}
					}
				}

			};
			
			this.apply = function() {

				filterService.addedFilterData = filterVm.addedFilterData;
				filterService.addedFilterFullData = filterVm.addedFilterFullData;
				$scope.filterOption = "apply";
				if(utilityService.isUndefined($scope.selectedLevelThreeData)){
					if(utilityService.isUndefined($scope.selectedLevelTwoData)){
						searchListServices.searchFor =  searchListServices.searchFor;
					}else{
						searchListServices.searchFor =  filterService.selectedLevelTwoData
					}
					
				}else{
					searchListServices.searchFor =  $scope.selectedLevelThreeData;
				}
				if (filterService.selectedColour.length > 0) {
					if (containsObj(filterService.addedFilterData, 'color')) {

						var addFltDataLen = filterService.addedFilterData.length;
						for (var i = 0; i < addFltDataLen; i++) {
							if (filterService.addedFilterData[i].value === 'color') {
								var colorValues = [];
								var selectedColourLen = filterService.selectedColour.length;
								for (var j = 0; j < selectedColourLen; j++) {
									colorValues.push(filterService.selectedColour[j].value)
								}
								filterService.addedFilterData[i].data = colorValues;
							}
						}
					} else {
						var colorValues = [];
						var addColorDataLen = filterService.selectedColour.length;
						for (var i = 0; i < addColorDataLen; i++) {
							colorValues.push(filterService.selectedColour[i].value)
						}
						filterService.addedFilterData.push({
							"value" : "color",
							"data" : colorValues
						})
						
						
						var objFull = {
							"code" : "color",
							"data" : colorValues
						}
						filterService.addedFilterFullData.push(objFull);
						
						if (!containsData(filterService.addedFilterNewFullData, "color")){
							filterService.addedFilterNewFullData.push("color");
						}
					}
				} else {
					if (containsObj(filterService.addedFilterData, 'color')) {
						var addFltDataLen = filterService.addedFilterData.length;
						for (var j = 0; j < addFltDataLen; j++) {
							if (filterService.addedFilterData[j].value === 'color') {
								filterService.addedFilterData.splice(j, 1);
								var addedFilterNewFullDataLength = filterService.addedFilterNewFullData.length;
								for(var l = 0; l < addedFilterNewFullDataLength; l++) {
								    if(filterService.addedFilterNewFullData[l] === 'color') {
								    	filterService.addedFilterNewFullData.splice(l, 1);
								    }
								}
								break;
							}
						}
					}
				}
				var oldmin = $scope.slider.minValue;
	            var oldmax = $scope.slider.maxValue;
	            var newmin  = $scope.slider.minValueTemp;
	            var newmax =  $scope.slider.maxValueTemp;
               	if((oldmin != newmin) || (oldmax != newmax)){
               		
				if (containsObj(filterService.addedFilterData, 'price')) {
				
					var addFltDataLen = filterService.addedFilterData.length;
					for (var j = 0; j < addFltDataLen; j++) {
						if (filterService.addedFilterData[j].value === 'price') {
							filterService.addedFilterData[j].data=[$scope.slider.minValue+"-"+$scope.slider.maxValue]
							filterService.addedFilterFullData[j].data=[{
								"label" : $scope.slider.minValue+"-"+$scope.slider.maxValue,
								'value' : $scope.slider.minValue+"-"+$scope.slider.maxValue
							}]
						}
					}
				}else{
					filterService.addedFilterData.push({
						"value" : "price",
						"data" : [$scope.slider.minValue+"-"+$scope.slider.maxValue]
					})
					filterService.addedFilterFullData.push({
								"code" : "price",
								"data" : [
									{
										"label" : $scope.slider.minValue+"-"+$scope.slider.maxValue,
										'value' : $scope.slider.minValue+"-"+$scope.slider.maxValue
									}
								]
							});
				}
				}
				
				var fltSortObj={};
				if(filterService.isFilterApplied){
					fltSortObj = searchListServices.sortObjectData;
				}else{
					fltSortObj={};
				}
				if (searchListServices.serviceFrom === 'getSelectedCategoryProduct') {
					var obj = {
						"category" : filterService.selectedCategoryId,
						"websiteId" : ompMerchantsService.listName.websiteId,
						"filters" : filterService.addedFilterData,
						"sort" : fltSortObj,
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getSelectedCategoryNewProduct(obj).then(function(data) {
						searchListServices.allProductsList = data;
						searchListServices.isCompareAvailable = true;
						searchListServices.serviceFrom = 'getSelectedCategoryProduct';
						searchListServices.serviceFromObj = obj;
						filterService.isFilterApplied = true;
						$state.go('menu.searchList');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else if (searchListServices.serviceFrom === 'getSearchProductsList') {
					var obj = {
						"websiteId" : ompMerchantsService.listName.websiteId,
						"keyword" : searchListServices.serviceFromObj.keyword,
						"filters" : filterService.addedFilterData,
						"sort" : fltSortObj,
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getSearchNewProductsList(obj).then(function(data) {
						searchListServices.allProductsList = data;
						filterService.selectedLevelOneData = '';
						filterService.selectedLevelTwoData = "";
						filterService.selectedLevelThreeData = "";
						searchListServices.isCompareAvailable = true;
						filterService.isFilterApplied = true;
						$state.go('menu.searchList');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else if (searchListServices.serviceFrom === 'getRecentlyViewedListing') {
					var recentProductsList = {
						"websiteId" : ompMerchantsService.listName.websiteId,
						"filters" : filterService.addedFilterData,
						"sort" : fltSortObj,
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getRecentlyViewedNewListing(recentProductsList).then(function(data) {
						searchListServices.allProductsList = data;
						filterService.selectedLevelOneData = '';
						filterService.selectedLevelTwoData = "";
						filterService.selectedLevelThreeData = "";
						searchListServices.isCompareAvailable = false;
						filterService.isFilterApplied = true;
						$state.go('menu.searchList');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else if (searchListServices.serviceFrom === 'getSimilarProductList') {
					var similarProductsList = {
						"websiteId" : ompMerchantsService.listName.websiteId,
						"productId" : searchListServices.serviceFromObj.productId,
						"price" : searchListServices.serviceFromObj.price,
						"filters" : filterService.addedFilterData,
						"sort" : fltSortObj,
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					};
					productDescriptionServices.getSimilarProductNewList(similarProductsList).then(function(data) {
						searchListServices.allProductsList = data;
						filterService.selectedLevelOneData = '';
						filterService.selectedLevelTwoData = "";
						filterService.selectedLevelThreeData = "";
						searchListServices.isCompareAvailable = true;
						filterService.isFilterApplied = true;
						$state.go('menu.searchList');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					var dealList = {
						"type" : searchListServices.serviceFromObj.type,
						"websiteId" : ompMerchantsService.listName.websiteId,
						"filters" : filterService.addedFilterData,
						"sort" : fltSortObj,
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getDealNewList(dealList).then(function(data) {
						searchListServices.allProductsList = data;
						filterService.selectedLevelOneData = '';
						filterService.selectedLevelTwoData = "";
						filterService.selectedLevelThreeData = "";
						searchListServices.isCompareAvailable = false;
						filterService.isFilterApplied = true;
						$state.go('menu.searchList');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
			};
			$scope.$on('$ionicView.loaded', function() {
				initPage();
			});
			$scope.$on('$ionicView.beforeLeave', function(){
				   ompMerchantsService.endTimer();
				});
				$scope.$on('$ionicView.afterEnter', function() {
					ompMerchantsService.startTimer();
				});
			$scope.$on('$ionicView.beforeEnter',
					function() {
				        var maxVal = searchListServices.getMax();
						var minVal = searchListServices.getMin();
						if((maxVal != -1) && (maxVal)){
							filterService.filterNewData.priceList = [{"max":maxVal,"min":minVal,"value":null,"count":0,"label":null,"parentId":null,"level":null,"childrenData":[]}];
							searchListServices.setMax(-1);
							searchListServices.setMin(-1);
						}
						$scope.slider = {
							minValue : parseInt(filterService.filterOldData.priceList[0].min),
							maxValue : parseInt(filterService.filterOldData.priceList[0].max),
							options : {
								floor : parseInt(filterService.filterOldData.priceList[0].min),
								ceil : parseInt(filterService.filterOldData.priceList[0].max),
								hideLimitLabels : true,
								hidePointerLabels : true,
								onChange : function(id , data){
									var a = $scope.slider.minValue;
						            var b = $scope.slider.maxValue;
						            var c  = $scope.slider.minValueTemp;
						            var d =  $scope.slider.maxValueTemp;
						            if((a == c) && (b == d) && (filterService.addedFilterData.length == 0)
						            && (filterService.selectedColour.length == 0 )){
										$scope.isApplyButtonDisabled  = true;	
										$scope.isClearButtonDisabled = true;
										}else{
									    $scope.isApplyButtonDisabled  = false;	
										$scope.isClearButtonDisabled = false;
										}
						            
									},
							}
						};
						$scope.slider.minValue = (filterService.filterNewData.priceList.length > 0)?parseInt(filterService.filterNewData.priceList[0].min):parseInt(filterService.filterOldData.priceList[0].min);
						$scope.slider.maxValue = (filterService.filterNewData.priceList.length > 0)?parseInt(filterService.filterNewData.priceList[0].max):parseInt(filterService.filterOldData.priceList[0].max);
						$scope.slider.minValueTemp = (filterService.filterNewData.priceList.length > 0)?parseInt(filterService.filterNewData.priceList[0].min):parseInt(filterService.filterOldData.priceList[0].min);
						$scope.slider.maxValueTemp = (filterService.filterNewData.priceList.length > 0)?parseInt(filterService.filterNewData.priceList[0].max):parseInt(filterService.filterOldData.priceList[0].max);
						
						$scope.priceMin = $scope.slider.minValue;
						$scope.priceMax = $scope.slider.maxValue;
						
						
						if(!filterService.selectedLevelOneData){
							filterService.selectedLevelOneData = "";
						}
						if(!filterService.selectedLevelTwoData){
							filterService.selectedLevelTwoData = "";
						}
						if(!filterService.selectedLevelThreeData){
							filterService.selectedLevelThreeData = "";
						}
						if(filterService.selectedLevelTwoData == filterService.selectedLevelThreeData){
							filterService.selectedLevelThreeData = "";
						}
						$scope.selectedLevelOneData = filterService.selectedLevelOneData;
						$scope.selectedLevelTwoData = filterService.selectedLevelTwoData;
						$scope.selectedLevelThreeData = filterService.selectedLevelThreeData;
						
						
						filterVm.addedFilterData = filterService.addedFilterData;
						filterVm.addedFilterFullData = filterService.addedFilterFullData;
						
						$scope.selectedColour = filterService.selectedColour;
						filterService.addedFilterNewFullData = [];
						
						filterService.beforeAppliedFilter = filterService.filterOldData;
						$scope.data.categories = (!utilityService.isUndefined(filterService.selectedLevelOneData) || !utilityService.isUndefined(filterService.selectedLevelTwoData) || !utilityService
								.isUndefined(filterService.selectedLevelThreeData)) ? true : false;
						$scope.filterItems = filterService.filterOldData.categoryList;
						filterService.beforeAppliedFilter = filterService.filterOldData;
						if (searchListServices.serviceFrom === 'getSelectedCategoryProduct') {
							var obj = {
								"code" : "category",
								"label" : "Categories",
								"data" : []
							}
							if ($scope.filterItems.filters[0].code !== 'category')
								$scope.filterItems.filters.unshift(obj)
						}
						$scope.filterColorList = filterService.filterOldData.colorList;
						$scope.callFunctionsData = filterService.filterOldData.callFunctionsList;
						$scope.selectedCategoriesName = "";
						$scope.selectedSubCategoriesName = "";
						$scope.filterOption = "clear";
						
						
						var a = $scope.slider.minValue;
						var b = $scope.slider.maxValue;
						var c  = $scope.slider.minValueTemp;
						var d =  $scope.slider.maxValueTemp;
						$scope.isApplyButtonDisabled  = true;
						

						var a = $scope.slider.minValue;
								var b = $scope.slider.maxValue;
								var c  = $scope.slider.minValueTemp;
								var d =  $scope.slider.maxValueTemp;
								 if((a == c) && (b == d) && (filterService.addedFilterData.length == 0)
								 && (filterService.selectedColour.length == 0 )){
														$scope.isApplyButtonDisabled  = true;	
														$scope.isClearButtonDisabled = true;
														}else{
														$scope.isApplyButtonDisabled  = true;	
														$scope.isClearButtonDisabled = false;
														}
														$scope.addDataToClickStream();
														$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
					});
					$scope.addDataToClickStream = function() {
									if(ompMerchantsService){
										if(ompMerchantsService.listName){
											clickStreamService.clickStreamData = "websiteId,"+ompMerchantsService.listName.affiliateId;
									 }	
									};	
							};
			$scope.$on('$ionicView.afterLeave', function() {
				
			});
			return this;
		}
]);
