'use strict';

angularApp.controller('productDescriptionController',
	["$timeout",
	"$state",
	"$scope",
	"$translate",
	"$ionicScrollDelegate",
	"$ionicSlideBoxDelegate",
	"$ionicPopup",
	"$ionicLoading",
	"productDescriptionServices",
	"ompShopService",
	"$cordovaSocialSharing",
	"ionicToast",
	"$location",
	"ompMerchantsService",
	"$ionicHistory",
	"mPinLoginService",
	"utilityService",
	"constantConfig",
	"searchListServices",
	"closePopupService",
	"filterService",
	"wishListService",
    "$rootScope",
    "$ionicModal",
    "clickStreamService",
    "$ionicSideMenuDelegate",
    "homeScreenService",
		"personalLoanService","loggedInUserService","cryptoService",
	function ($timeout,
		$state,
		$scope,
		$translate,
		$ionicScrollDelegate,
		$ionicSlideBoxDelegate,
		$ionicPopup,
		$ionicLoading,
		productDescriptionServices,
		ompShopService,
		$cordovaSocialSharing,
		ionicToast,
		$location,
		ompMerchantsService,
		$ionicHistory,
		mPinLoginService,
		utilityService,
		constantConfig,
		searchListServices,
		closePopupService,
		filterService,
		wishListService,
		$rootScope,
		$ionicModal,
		clickStreamService,
		$ionicSideMenuDelegate,
		homeScreenService,
			personalLoanService,loggedInUserService,cryptoService) {
                           var isWebviewLoadingCanceled = false;
                           var productRedirectUrl="";
							var productDescriptionVm = this;
							function initPage() {
								$scope.showbankOffersFlag = false;
								productDescriptionVm.dataForPAPLFlag = false;
								productDescriptionVm.checkPAPLOffer();
								$scope.showbankSpecificationFlag = false;
								productDescriptionVm.offers = [];
								productDescriptionVm.filterTypes = [
										"Categories", "Brand", "Call Functions", "Colour", "Price"
								];
								productDescriptionVm.callFunctions = [
										"With call Function", "Without call Function"
								];
								productDescriptionVm.selectedFiltertype = null;
								productDescriptionVm.showBack = true;
								productDescriptionVm.showNext = true;
								$translate([
										'SIMILAR_PRODUCTS', 'RECENTLY', 'EXTRA', 'OFFER_PERIOD', 'ADD_ON_CARD', 'ONLY_ONCE', 'EMI_TRANS', 'SBI_PROD', 'TRANSC_QUICKLY', 'XCLUSIVE_OFFERS'
								]).then(function(translations) {
									productDescriptionVm.rec_lbl = translations['RECENTLY'];
									productDescriptionVm.si_lbl = translations['SIMILAR_PRODUCTS'];
									productDescriptionVm.offers.push(translations['EXTRA']);
									productDescriptionVm.offers.push(translations['OFFER_PERIOD']);
									productDescriptionVm.offers.push(translations['ADD_ON_CARD']);
									productDescriptionVm.offers.push(translations['ONLY_ONCE']);
									productDescriptionVm.offers.push(translations['EMI_TRANS']);


									productDescriptionVm.l_one = translations['SBI_PROD'];
									productDescriptionVm.l_two = translations['TRANSC_QUICKLY'];
									productDescriptionVm.l_three = translations['XCLUSIVE_OFFERS'];
									$scope.records = [
											        productDescriptionVm.l_one,
											        productDescriptionVm.l_two,
									                productDescriptionVm.l_three
											    ];
								});
								$timeout(function() {
									var sv = $ionicScrollDelegate.$getByHandle('horizontalFeaturedCategories').getScrollView();
									var container = sv.__container;
									var originaltouchStart = sv.touchStart;
									var originaltouchMove = sv.touchMove;
									container.removeEventListener('touchstart', sv.touchStart);
									document.removeEventListener('touchmove', sv.touchMove);
									sv.touchStart = function(e) {
										e.preventDefault = function() {
										}
										originaltouchStart.apply(sv, [
											e
										]);
									}
									sv.touchMove = function(e) {
										e.preventDefault = function() {
										}
										originaltouchMove.apply(sv, [
											e
										]);
									}
									container.addEventListener("touchstart", sv.touchStart, false);
									document.addEventListener("touchmove", sv.touchMove, false);
								});
								$timeout(function() {
									var fc = $ionicScrollDelegate.$getByHandle('horizontalSimilarProducts').getScrollView();
									var container = fc.__container;
									var originaltouchStart = fc.touchStart;
									var originaltouchMove = fc.touchMove;
									container.removeEventListener('touchstart', fc.touchStart);
									document.removeEventListener('touchmove', fc.touchMove);
									fc.touchStart = function(e) {
										e.preventDefault = function() {
										}
										originaltouchStart.apply(fc, [
											e
										]);
									}
									fc.touchMove = function(e) {
										e.preventDefault = function() {
										}
										originaltouchMove.apply(fc, [
											e
										]);
									}
									container.addEventListener("touchstart", fc.touchStart, false);
									document.addEventListener("touchmove", fc.touchMove, false);
								});
								if(productDescriptionVm.merchantData.offers.bankOffers.length > 0){
									$scope.showbankOffersFlag = true;
								}
								if(productDescriptionVm.merchantData.specifications.length > 0){
									$scope.showbankSpecificationFlag = true;
								}

										if (productDescriptionServices.productData.productDescription[0].isWishlist){

										productDescriptionVm.isClickWishlistAdded = 'S';
									}
									else{
										productDescriptionVm.isClickWishlistAdded = 'N';
									}

							};

							productDescriptionVm.checkPAPLOffer = function() {

								productDescriptionVm.dataForPAPL = homeScreenService.offersData;
					            console.log('hscreenData 3 :' + JSON.stringify(productDescriptionVm.dataForPAPL));
					            angular.forEach(productDescriptionVm.dataForPAPL, function(value, key) {
					                if (value.category == "PAPL") {
					                    productDescriptionVm.dataForPAPLFlag = true;
					                    productDescriptionVm.textForPAPL = value.palAmount;
					                }

					            });
							};

			productDescriptionVm.loadPAPL = function () {
				personalLoanService.clearAll();
				personalLoanService.getLoanDetails().then(function (data) {

					personalLoanService.personalLoanData = data;
					personalLoanService.minDuration = data.minTenure;
					personalLoanService.maxDuration = data.maxTenure;
					personalLoanService.interestRate = data.interestRate;
					personalLoanService.product = data.productCode;
					personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
					personalLoanService.processingFee = data.processingFee;
					personalLoanService.minBestOffer = data.minPalAmount;
					personalLoanService.activityCode = data.activityCode;
					personalLoanService.schemeCode = data.schemeCode;


					$state.go('menu.personalLoan');

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

							productDescriptionVm.goBack = function() {
								$ionicHistory.clearCache().then(function() {
									$ionicHistory.goBack(-1);
								})
							};
							productDescriptionVm.productDescription = function(data) {
								var product = {
									"websiteId" : ompMerchantsService.listName.websiteId,
									"productId" : data.id,
									"isLoggedIn":mPinLoginService.isLoggedIn
								};
								productDescriptionServices.getProductDetails(product).then(function(data) {
									productDescriptionServices.productData = data;
									$state.reload();
									productDescriptionVm.merchantData = productDescriptionServices.productData;
									if (productDescriptionServices.productData.productDescription[0].isWishlist)
										productDescriptionVm.isClickWishlistAdded = 'S';
									else
										productDescriptionVm.isClickWishlistAdded = 'N';
									productDescriptionVm.ratings = productDescriptionServices.productData.rating;
									productDescriptionVm.id = productDescriptionServices.productData.id;
									productDescriptionVm.price = productDescriptionServices.productData.price;

								}, function(error) {
									utilityService.showErrorMessage(error.responseMessage);
								});
							};
							productDescriptionVm.next = function() {
								$ionicSlideBoxDelegate.next();
							};
							productDescriptionVm.previous = function() {
								$ionicSlideBoxDelegate.previous();
							};
							$scope.slideChanged = function(index) {
								$scope.slideIndex = index;
							};
							productDescriptionVm.shareData = function() {
								$cordovaSocialSharing.share(productDescriptionVm.merchantData.name, "Product", null, "https://www.sbicard.com") 								.then(function(result) {

								}, function(err) {
																	});
							}
							productDescriptionVm.toggleShowAll = function() {
								$location.hash('productSpecification');
								$ionicScrollDelegate.anchorScroll();
								$scope.showAll = !$scope.showAll;
							};

							$scope.registerSkip = function() {
								productDescriptionVm.rPopup.close();
							};
							$scope.regPopup = function() {
								productDescriptionVm.rPopup.close();
								$state.go('menu.openNewDigitalAccount');
							};
							productDescriptionVm.gotoSearch = function() {
								$state.go('menu.ompSearch');
							};
							productDescriptionVm.gotowishList = function() {
								if(mPinLoginService.isLoggedIn){
									searchListServices.localWish = true;
									$state.go('menu.localWishlist');
								}else{
									productDescriptionVm.loginPopup();
								}

							};
							productDescriptionVm.gotoSpec = function() {
								$state.go("menu.specifications");
							};
							productDescriptionVm.gotoTerms = function(offrTc) {

								productDescriptionVm.terms = $ionicPopup.show({
									title:"Terms and conditions",
									cssClass : 'ftandcpopup-body popupBackgroundWhite popupWidth90  popupBackgroundDark',
									template : offrTc,
									scope : $scope,
									buttons: [

									          {
									            text: '<b>Ok</b>',
									            type: 'button-positive',
									            onTap: function(e) {
									            	productDescriptionVm.terms.close();
									            }
									          }
									        ]
								});
							};
							productDescriptionVm.tcClose = function() {
								productDescriptionVm.terms.close();
							}
							productDescriptionVm.gotoSelectedFeature = function(feature) {
								searchListServices.searchFor = feature;
								if (feature === productDescriptionVm.si_lbl) {
									var similarProductsList = {
										"websiteId" : productDescriptionVm.merchantName.websiteId,
										"productId" : productDescriptionVm.id,
										"price" : productDescriptionVm.price,
										"filters" : [],
										"isLoggedIn":mPinLoginService.isLoggedIn
									};
									productDescriptionServices.getSimilarProductList(similarProductsList).then(function(data) {
										filterService.filterOldData = searchListServices.filterData;
										searchListServices.allProductsList = data;
										filterService.selectedLevelOneData = '';
										filterService.selectedLevelTwoData = "";
										filterService.selectedLevelThreeData = "";
										searchListServices.products.length = 0
										filterService.addedFilterFullData.length = 0
										filterService.addedFilterData.length = 0
										filterService.selectedColour.length = 0
										searchListServices.isCompareAvailable = true;
										searchListServices.serviceFrom = 'getSimilarProductList';
										searchListServices.serviceFromObj = similarProductsList;
										filterService.isFilterApplied = false;
										searchListServices.isSortApplied = false;
										searchListServices.filterNewData = {
										                	          		categoryList : [],
										                	          		subCategoryList : [],
										                	          		colorList : [],
										                	          		priceList : [],
										                	          		callFunctionsList : []
										                	          	};
										$state.go('menu.searchList');
									}, function(error) {
										utilityService.showErrorMessage(error.responseMessage);
									});
								} else {
									var recentProductsList = {
										"websideId" : ompMerchantsService.listName.websiteId,
										"filters" : [],
										"sort" : {},
										"isLoggedIn":mPinLoginService.isLoggedIn
									}
									searchListServices.getRecentlyViewedListing(recentProductsList).then(function(data) {
										filterService.filterOldData = searchListServices.filterData;
										searchListServices.allProductsList = data;
										filterService.selectedLevelOneData = '';
										filterService.selectedLevelTwoData = "";
										filterService.selectedLevelThreeData = "";
										searchListServices.products.length = 0
										filterService.addedFilterFullData.length = 0
										filterService.addedFilterData.length = 0
										filterService.selectedColour.length = 0
										searchListServices.isCompareAvailable = false;
										searchListServices.serviceFrom = 'getRecentlyViewedListing';
										searchListServices.serviceFromObj = recentProductsList;
										filterService.isFilterApplied = false;
										searchListServices.isSortApplied = false;
										searchListServices.filterNewData = {
										                	          		categoryList : [],
										                	          		subCategoryList : [],
										                	          		colorList : [],
										                	          		priceList : [],
										                	          		callFunctionsList : []
										                	          	};
										$state.go('menu.searchList');
									}, function(error) {
										utilityService.showErrorMessage(error.responseMessage);
									});
								}
							};
							productDescriptionVm.gotoSubCat = function(category) {
								ompShopService.subCategory = category;
								$state.go('menu.electronics');
							};
							productDescriptionVm.cancel = function() {
								clickStreamService.clickStreamData = "websiteId,"+productDescriptionVm.merchantData.affiliateId;
								productDescriptionVm.myPopup.close();
							};
							productDescriptionVm.agree = function() {
								clickStreamService.clickStreamData = "websiteId,"+productDescriptionVm.merchantData.affiliateId;
								if(!productDescriptionVm.merchantData){ productDescriptionVm.merchantData = {}}
				var mobileRedirectKey= cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + productDescriptionVm.merchantData.mobileRedirectUrl).toString();
								var saveLeadObj ={
								  	"leadId": "",
								  	"websiteId": productDescriptionVm.merchantName.websiteId,
								  	"affiliateId": productDescriptionVm.merchantData.affiliateId,
								  	"request": {
											    "ompCcustToken": "",
											    "loggedIn": productDescriptionVm.isLoggedIn,
											    "channel": "",
											    "segId": "",
											    "ompTokenId": "",
											    "merchantSku": productDescriptionVm.merchantData.sku,
											    "prdPrice": productDescriptionVm.merchantData.price,
											    "wishlistSkus": "",
											    "ompDisValue": productDescriptionVm.merchantData.discount,
											    "ompDisPct": "",
											    "ompDisType": ""
										  },
								        "leadParam": productDescriptionVm.merchantData.leadParam,
								        "segmentParam": productDescriptionVm.merchantData.segmentParam,
					"affiliateIdParam": productDescriptionVm.merchantData.affiliateIdParam,
					"mobileRedirectUrl" : productDescriptionVm.merchantData.mobileRedirectUrl,
					"mobileRedirectKey" : mobileRedirectKey 
				                  
				};


								productDescriptionVm.myPopup.close();
								productDescriptionVm.loadPopup = $ionicPopup.show({
									title : '',
									cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
									templateUrl : "pages/OMP/productDescription/loading.html",
									scope : $scope
								})
								 productDescriptionVm.timer = $timeout(function() {
								 	ompMerchantsService.saveLead(saveLeadObj).then(function(data) {
										productDescriptionVm.loadPopup.close();
										if(isWebviewLoadingCanceled == true){ return "";}
										isWebviewLoadingCanceled = true;
										 if(productRedirectUrl.indexOf('?') != -1){
										 	if(mPinLoginService.isLoggedIn){	
											 ompMerchantsService.inAppBrowser(data.data.mobileUrl);
											 		 //logoutChallangeHandler();
											 		}
										}else{
											if(mPinLoginService.isLoggedIn){	
											ompMerchantsService.inAppBrowser(data.data.mobileUrl);
													// logoutChallangeHandler();
													}
										}

									}, function(error) {
										utilityService.showErrorMessage(error.responseMessage);
									});
								}, 5000)
							};
							productDescriptionVm.tapCancel = function() {
								productDescriptionVm.loadPopup.close();
								 $timeout.cancel(productDescriptionVm.timer);
								isWebviewLoadingCanceled = true;
							};
							productDescriptionVm.buyNow = function() {
								$scope.addDataToClickStream();
								productDescriptionVm.myPopup = $ionicPopup.show({
									title : '',
									cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head popupBackgroundDark',
									templateUrl : "pages/OMP/productDescription/disclaimerPopup.html",
									scope : $scope
								});
								isWebviewLoadingCanceled = false;
							};
							productDescriptionVm.registerPopup = function() {
								productDescriptionVm.rPopup = $ionicPopup.show({
									cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head popupBackgroundDark',
									templateUrl : 'pages/OMP/productDescription/registerPopup.html',
									scope : $scope
								});
							};
							productDescriptionVm.regPopup = function() {
								productDescriptionVm.rPopup.close();
								$state.go('menu.userLogin');
							};
							productDescriptionVm.registerSkip = function() {
								productDescriptionVm.rPopup.close();
							};

							productDescriptionVm.loginPopup = function() {

								if((!mPinLoginService.userLoginStatus.isRegistered)){
									productDescriptionVm.rPopup = $ionicPopup.show({
										title: '',
										cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head popupBackgroundDark',
										templateUrl: 'pages/OMP/productDescription/registerPopup.html',
										scope: $scope
									});
								}
								else if((!mPinLoginService.isLoggedIn)){
										productDescriptionVm.lPopup = $ionicPopup.show({
										cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head popupBackgroundDark',
										templateUrl : 'pages/OMP/productDescription/loginPopup.html',
										scope : $scope
									  });
								}
							};
							 $scope.resumeSession=function(mpin){
							 	var myState = $state;
							 	var myScope =  $scope;
							    mPinLoginService;
							    var productData = productDescriptionServices.productData;
							 	ompMerchantsService.loginAuthChallengeHandler(mpin, myState  , mPinLoginService , myScope, productData ,productDescriptionServices , ompShopService ,ompMerchantsService);
					       },
							productDescriptionVm.logPopup = function() {
								productDescriptionVm.lPopup.close();
								 $ionicModal.fromTemplateUrl( 'pages/mPinLogin/mpinLoginModel.html',{
							            scope: $scope,
							            animation: 'slide-in-up',
							            focusFirstInput: true
							        }).then(function(modal) {
							            $scope.modal = modal;
							            $scope.modal.show();
							        });
							  };
							productDescriptionVm.loginSkip = function() {
								productDescriptionVm.lPopup.close();
							};
							productDescriptionVm.goToNextPage = function() {
								$state.go("menu.fixedDuration");
							}
							productDescriptionVm.wishList = function() {
								if(mPinLoginService.isLoggedIn){

								if (productDescriptionVm.isClickWishlistAdded === "N") {
									var addWishList = {
										"websiteId" : productDescriptionVm.merchantName.websiteId,
										"productId" : productDescriptionVm.id,
										"isLoggedIn":mPinLoginService.isLoggedIn
									};

									if(ompMerchantsService.merchantWishlistCount> 19)
									{
										ionicToast.show("Wishlist Full", 'bottom', false, 3000);
										return;

									}
									productDescriptionServices.saveProductWishList(addWishList).then(function(data) {
										wishListService.wishCount = data.globalWishlistCount;
										productDescriptionVm.isClickWishlistAdded = "S";
										productDescriptionVm.isMerchantsWishListAvl = 'S';
										ompMerchantsService.isMerchantsWishListAvl = 'S';
										productDescriptionServices.productData.productDescription[0].isWishlist = true;
										ompMerchantsService.merchantWishlistCount = data.merchantWishlistCount;

										ionicToast.show("Added to wishlist", 'bottom', false, 3000);
									}, function(error) {
										utilityService.showErrorMessage(error.responseMessage);
									});
								} else {
									var clearWishList = {
										"websiteId" : productDescriptionVm.merchantName.websiteId,
										"productId" : productDescriptionVm.id,
										"isLoggedIn":mPinLoginService.isLoggedIn
									};
									productDescriptionServices.clearProductWishList(clearWishList).then(function(data) {
										wishListService.wishCount = data.globalWishlistCount;
										if (data.merchantWishlistCount > 0) {
											ompMerchantsService.isMerchantsWishListAvl = 'S';
											productDescriptionVm.isMerchantsWishListAvl = 'S';
											productDescriptionVm.isClickWishlistAdded = "N";
										} else {
											ompMerchantsService.isMerchantsWishListAvl = 'N';
											productDescriptionVm.isClickWishlistAdded = "N";
											productDescriptionVm.isMerchantsWishListAvl = 'N';
										}
										productDescriptionServices.productData.productDescription[0].isWishlist = false;
										ionicToast.show("Removed from wishlist", 'bottom', false, 3000);
										ompMerchantsService.merchantWishlistCount = data.merchantWishlistCount;
									}, function(error) {
										utilityService.showErrorMessage(error.responseMessage);
									});
								}
							}else{
								productDescriptionVm.loginPopup();
							}
							};


							productDescriptionVm.applyNow = function(rating) {
								$state.go('menu.cardIntroduction');
							};
							productDescriptionVm.getStars = function(rating) {
								var val = parseFloat(rating);
								var size = val / 5 * 100;
								return size + '%';
							};
							$scope.$on('$ionicView.beforeEnter', function() {

							$scope.buytext="BUY";
								productDescriptionVm.isbuyNowDisabled=false;
								productDescriptionVm.isMerchantsWishListAvl = ompMerchantsService.isMerchantsWishListAvl;
								productDescriptionVm.registerStatus = mPinLoginService.userLoginStatus.isRegistered;
								productDescriptionVm.loginStatus = mPinLoginService.isLoggedIn;
								productDescriptionVm.merchantName = ompMerchantsService.listName;
								productDescriptionVm.isRecentAvailable = false;
								productDescriptionVm.isSimProAvailable = false;

								productDescriptionVm.showRecent = true;
								productDescriptionVm.showSimPro = true;

								productDescriptionVm.dealImg = constantConfig.omp.dealImg;
								productDescriptionVm.disc = constantConfig.omp.discount;
								productDescriptionVm.merchantData = productDescriptionServices.productData.productDescription[0];



								if(productDescriptionVm.merchantData.inventoryStatus=="false")
									{


									$scope.buytext="OUT OF STOCK";
									$scope.isbuyNowDisabled=true;

									}
								
								productRedirectUrl = productDescriptionVm.merchantData.mobileRedirectUrl;
								
								if(productDescriptionServices.productData.recentProduct.length>0)
								{
								productDescriptionVm.recentData = productDescriptionServices.productData.recentProduct[0];
								}else{
									productDescriptionServices.showRecent = false;
									productDescriptionVm.recentData = {};
									productDescriptionVm.recentData.products =[];
								}




									if(productDescriptionVm.recentData.products.length > 0){
										productDescriptionVm.recent = productDescriptionVm.recentData.products;
										productDescriptionVm.isRecentAvailable = true;
										productDescriptionServices.showRecent = true;
									}
									else{
										productDescriptionServices.showRecent = false;
										productDescriptionVm.showRecent = false;
									}

								if (productDescriptionServices.productData.productDescription[0].isWishlist)
									productDescriptionVm.isClickWishlistAdded = 'S';
								else
									productDescriptionVm.isClickWishlistAdded = 'N';
								productDescriptionVm.ratings = productDescriptionServices.productData.productDescription[0].rating;
								productDescriptionVm.id = productDescriptionServices.productData.productDescription[0].id;
								productDescriptionVm.price = productDescriptionServices.productData.productDescription[0].price;
								productDescriptionVm.persentageValue = productDescriptionServices.productData.productDescription[0].discount;
								productDescriptionVm.recentIds = ompShopService.recentIds;
								var similarProduct = {
									"websiteId" : ompMerchantsService.listName.websiteId,
									"productId" : productDescriptionVm.id,
									"price" : productDescriptionVm.price,
									"isLoggedIn":mPinLoginService.isLoggedIn
								};
								productDescriptionServices.getSimilarProducts(similarProduct).then(function(data) {
									productDescriptionVm.isSimProAvailable = true;
									productDescriptionVm.similarProducts = data;
									if(data.count > 0)
										productDescriptionServices.showSimPro = true;
									else
										productDescriptionServices.showSimPro = false;
								}, function(error) {
									productDescriptionVm.isSimProAvailable = false;
									productDescriptionVm.showSimPro = false;
									utilityService.showErrorMessage(error.responseMessage);
								});

								initPage();
								$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
							});

							$scope.addDataToClickStream = function() {
									if(ompMerchantsService){
										if(productDescriptionVm.merchantData){
											clickStreamService.clickStreamData = "websiteId,"+productDescriptionVm.merchantData.affiliateId+",productId,"+productDescriptionVm.id;
									 }
									};
							};

							$scope.$on('$ionicView.beforeLeave', function(){
							   ompMerchantsService.endTimer();
							});
							$scope.$on('$ionicView.afterEnter', function() {
								ompMerchantsService.startTimer();
							});
							$scope.$on('$ionicView.enter', function(e) {
							      $timeout(function() {
									  ompMerchantsService.showHeader();
								  }, 1000);


								});
							return this;
						}
				]);

