'use strict';

angularApp.service('POCADetailsService',
    function($q, AdapterUtils, constantConfig) {
        var POCADetailsService = this;

        POCADetailsService.fetchProofList = function() {
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.fetchIdAndAddressProofDropdownOVD, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	
	
	  POCADetailsService.savePoiOrPoaInfoOVD = function(requestData) {
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.savePoiOrPoaInfoOVD,requestData, true).then(function(response) {
			q.resolve(response);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};

        return POCADetailsService;
    });
