'use strict';
angularApp.service('personalDetailsAOService',
    function($q, AdapterUtils, constantConfig) {
    	
        var personalDetailsAOService = this;
        //Load Title List
        personalDetailsAOService.getTitleList = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.fetchDropDownListOVD + requestData, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //Load gender
        personalDetailsAOService.getGenderList = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.fetchDropDownListOVD + requestData, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return personalDetailsAOService;
    });