'use strict';

angularApp.controller('VIDDetailsAOController', ["$state",
    "$scope",
    "VIDDataService",
    "accountOpeningHomeService",
    "$translate",
    "enterOTPAOService",
    "citizenshipDetailsAOService",
    function($state,
        $scope,
        VIDDataService,
        accountOpeningHomeService,
        $translate,
        enterOTPAOService,
        citizenshipDetailsAOService) {

        var VIDDetailsAOVm = this;

        function initPage() {
            VIDDetailsAOVm.showBack = true;
            VIDDetailsAOVm.showNext = true;
            VIDDetailsAOVm.disableNext = true;
            VIDDetailsAOVm.aofooter = true;
            VIDDetailsAOVm.otpNumberInput = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                VIDDetailsAOVm.okBtntext = translatedvalue;
            });
            VIDDetailsAOVm.isSubmitNotTapped  = true;    
        }

        VIDDetailsAOVm.goBacktoPrevious = function() {
            $state.go('menu.aadhaarOption');         
        }

        VIDDetailsAOVm.goToNextPage = function() {
            VIDDetailsAOVm.goToVidOtp();
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        // VIDDetailsAOVm.updateAadhaarNumber = function(){
        //     if(accountOpeningHomeService.customerManualEntryDetails.vid){
        //         VIDDetailsAOVm.vidnumber = accountOpeningHomeService.customerManualEntryDetails.vid;
        //     }
        // }

        // VIDDetailsAOVm.checkFormValid = function(isValid){
        //     if(isValid){
        //         VIDDetailsAOVm.disableNext = false;
        //     }
        //     else{
        //         VIDDetailsAOVm.disableNext = true;
        //     }
        // }

        VIDDetailsAOVm.goToVidOtp = function(){
            if(citizenshipDetailsAOService.customerManualEntryDetails){
                citizenshipDetailsAOService.customerManualEntryDetails.vid = VIDDetailsAOVm.vidnumber;
            }else{
                citizenshipDetailsAOService.customerManualEntryDetails = {};
                citizenshipDetailsAOService.customerManualEntryDetails.vid = VIDDetailsAOVm.vidnumber;
            }
            
            $state.go('menu.vidOTP');
        }
	
		// VIDDetailsAOVm.autoReadAadharOtp = function(isResendClicked) {
		// 			VIDDetailsAOVm.getOTPNumber = "";
		// 			var requestParams = {
		// 				"vidNumber" : VIDDetailsAOVm.vidnumber ? VIDDetailsAOVm.vidnumber : "",
		// 				"aadharNumber" : "",
		// 				"udiType" : "2"
		// 			};
		// 			VIDDataService.generateAadharOtp(requestParams).then(function(response) {
		// 				if (response.data.status == "0") {
		// 					var title = '';
		// 					var template = '{{"OTP_SUCCESS" | translate}}';
		// 					var onTap = '';
		// 					var buttontext = '<b>' + VIDDetailsAOVm.okBtntext + '</b>';
		// 					utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		// 					VIDDetailsAOVm.otpNumberInput = false;
		// 				} else if (response.data.status == "-1" || response.data.status == "-2") {
		// 					var title = '';
		// 					var template = response.data.details;
		// 					//'{{"SERVICE_ERR_MSG" | translate}}';
		// 					var onTap = '';
		// 					var buttontext = '<b>' + VIDDetailsAOVm.okBtntext + '</b>';
		// 					utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		// 				} else {
		// 					var title = '';
		// 					var template = '{{"SERVICE_ERR_MSG" | translate}}';
		// 					var onTap = '';
		// 					var buttontext = '<b>' + VIDDetailsAOVm.okBtntext + '</b>';
		// 					utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		// 				}
		// 				if (utilityService.isAndroidPlatform()) {
		// 						autoOtpReadService.startOtpReading().then(function(result) {
		// 							VIDDetailsAOVm.getOTPNumber = result;
		// 							VIDDetailsAOVm.disableNext = false;
		// 						}, function(error) {
		// 						}, function(watchStatus) {
		// 						});
		// 					}
		// 			}, function(error) {
		// 				utilityService.showErrorMessage(error.responseMessage);
		// 			});
		// }; 

        // VIDDetailsAOVm.generateAadharOtp = function(isResendClicked) {
        // 	if(!isResendClicked){
 		//        	VIDDetailsAOVm.isSubmitNotTapped = false;	
        // 	}
		// 	VIDDataService.aadhrOTPattempt = VIDDataService.aadhrOTPattempt  +1 ;
        // 	if(VIDDataService.aadhrOTPattempt > 5 && isResendClicked){
        // 		return true;
        // 	}
            
	    // 		 VIDDetailsAOVm.autoReadAadharOtp(isResendClicked);
			
        // };



        // AFTER OTP

        // VIDDetailsAOVm.getAadharDetails = function() {
        // 	var requestParams = {
        //         "aadharNumber": "",//VIDDetailsAOVm.aadhaarnumber,
        //         "vidNumber": VIDDetailsAOVm.vidnumber,
        //         "otp": VIDDetailsAOVm.getOTPNumber,
        //         "uidType" : "2"
        //     }
        //     VIDDataService.getEKycOTPSecure(requestParams).then(function(response) {
        //         var aadharDetails = response.data;
        //         if(!utilityService.isUndefined(response.data)){
        //                 accountOpeningHomeService.isAadharManualEntry = true;
	    //                 accountOpeningHomeService.customerAadhaarCardDetails = {
		// 		                uid: "",
		// 		                name: "",
		// 		                firstName: "",
		// 		                middleName: "",
		// 		                lastName: "",
		// 		                gender: "",
		// 		                title: "",
		// 		                yob: "",
		// 		                co: "",
		// 		                house: "",
		// 		                street: "",
		// 		                lm: "",
		// 		                loc: "",
		// 		                vtc: "",
		// 		                po: "",
		// 		                dist: "",
		// 		                subdist: "",
		// 		                state: "",
		// 		                pc: "",
		// 		                dob: "",
		// 		                isAadharScanned: false,
		// 		                locality: "",
		// 		                addressLine1: "",
		// 		                addressLine2: ""
		// 		            }
		// 		            enterOTPAOService.isVID = true;
		// 		            accountOpeningHomeService.customerAadhaarCardDetails.uid = response.data.kycResponse.uidData.aadharNumber;
		// 		            $state.go('menu.aadhaarManualEntry');
        //         }
        //         else{
        //             var title = '';
        //             var template = '{{"INVALID_OTP" | translate}}';
        //             var onTap = '';
        //             var buttontext = '<b>' + VIDDetailsAOVm.okBtntext + '</b>';
        //             utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        //         }              
        //     }, function(error) {
        //         utilityService.showErrorMessage(error.responseMessage); 
        //     });
        // };

             
               
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
      //      VIDDetailsAOVm.updateAadhaarNumber();

            if (enterOTPAOService.isResumeJourney == true) {
                VIDDetailsAOVm.vidnumber = citizenshipDetailsAOService.customerManualEntryDetails.vid;
            }

            //$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        return VIDDetailsAOVm;
    }
]);