'use strict';

angularApp.controller('vidOTPPageAOController', ["$state",
    "$scope",
    "$translate",
    "utilityService",
    // "autoOtpReadService",
    "enterOTPAOService",
    "userLoginDetailsService",
    "loggedInUserService",
    "cryptoService",
    "encryptionService",
	"AdapterUtils",
	"accountOpeningHomeService",
	"VIDDataServiceAO",
	"citizenshipDetailsAOService",
    function($state,
        $scope,
        $translate,
        utilityService,
        // autoOtpReadService,
        enterOTPAOService,
        userLoginDetailsService,
        loggedInUserService,
        cryptoService,
        encryptionService,
		AdapterUtils,
		accountOpeningHomeService,
		VIDDataServiceAO,
		citizenshipDetailsAOService) {

        var vidOTPAOVm = this;


        function initPage() {
            vidOTPAOVm.showBack = true;
            vidOTPAOVm.showNext = true;
            vidOTPAOVm.showOtpView = true;
            vidOTPAOVm.otpvalue = "";
            vidOTPAOVm.disableNext = true;
            vidOTPAOVm.aofooter = true;
            //vidOTPAOVm.requestOtpCall();
            //vidOTPAOVm.isDisabledOTP = false;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                vidOTPAOVm.okBtntext = translatedvalue;  
            });
            
        }

        vidOTPAOVm.goBacktoPrevious = function() {
        	$state.go('menu.vidDetailsAO');
        }

        $scope.goToHome = function() {
			accountOpeningHomeService.homeNav();
        }

        vidOTPAOVm.validateOTP = function(isValid) {
            vidOTPAOVm.disableNext = !isValid;
        }

		vidOTPAOVm.invokeGetOTPService = function () {
					var requestParams = {
								"vidNumber" : vidOTPAOVm.vidnumber ? vidOTPAOVm.vidnumber : "",
								"aadharNumber" : "",
								"udiType" : "2"
							};
					VIDDataServiceAO.generateAadharOtp(requestParams).then(function(response) {
		             
		                //.customer.otpNo = utilityService.getValue(response.data.otp);
		                var title = '';
		                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
		                var onTap = '';
		                var buttontext = '<b>' + vidOTPAOVm.okBtntext + '</b>';
		                //utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		                // if (utilityService.isAndroidPlatform()) {
						// 		autoOtpReadService.startOtpReading().then(function(result) {
						// 			vidOTPAOVm.otpvalue = result;
						// 			vidOTPAOVm.disableNext = false;
						// 		}, function(error) {
						// 		}, function(watchStatus) {
						// 		});
						// 	}
		
		                //vidOTPAOVm.getOtpFromEmail(mobilenumber);
		            }, function (error) {
		                utilityService.showErrorMessage(error.responseMessage);
		            });
				}

				/* resend OTP */
				
				vidOTPAOVm.requestOtpCallOnce = function() {
					//vidOTPAOVm.resendOtp();
					vidOTPAOVm.invokeGetOTPService();
				};

				// vidOTPAOVm.resendOtp = function () {
		        //     var requestParams = {
		        //         "id": userLoginDetailsService.mobile,
				// 		"recipientMailId":  userLoginDetailsService.emailId ? userLoginDetailsService.emailId : "",
				// 		"sendOTPFlg": "mobileOnly" 
		        //     }
		        //     enterOTPAOService.getOtp(requestParams).then(function (response) {
		             
		        //         //.customer.otpNo = utilityService.getValue(response.data.otp);
		        //         var title = '';
		        //         var template = '{{"OTP_SENT_SUCCESS" | translate}}';
		        //         var onTap = '';
		        //         var buttontext = '<b>' + vidOTPAOVm.okBtntext + '</b>';
		        //         //utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
		        //         if (utilityService.isAndroidPlatform()) {
				// 				autoOtpReadService.startOtpReading().then(function(result) {
				// 					vidOTPAOVm.otpvalue = result;
				// 					vidOTPAOVm.disableNext = false;
				// 				}, function(error) {
				// 				}, function(watchStatus) {
				// 				});
				// 			}
		
		        //         //vidOTPAOVm.getOtpFromEmail(mobilenumber);
		        //     }, function (error) {
		        //         utilityService.showErrorMessage(error.responseMessage);
		        //     });
				// }

				/* resend OTP END */


	      vidOTPAOVm.goToNextPage = function () {

        	var requestParams = {
                "aadharNumber": "",//vidOTPAOVm.aadhaarnumber,
                "vidNumber": vidOTPAOVm.vidnumber,
                "otp": vidOTPAOVm.otpvalue,
                "uidType" : "2"
            }
            VIDDataServiceAO.getEKycOTPSecure(requestParams).then(function(response) {
                var aadharDetails = response.data;
                if(!utilityService.isUndefined(response.data)){
	                    // citizenshipDetailsAOService.customerManualEntryDetails = {
				        //         uid: "",
				        //         name: "",
				        //         firstName: "",
				        //         middleName: "",
				        //         lastName: "",
				        //         gender: "",
				        //         title: "",
				        //         yob: "",
				        //         co: "",
				        //         house: "",
				        //         street: "",
				        //         lm: "",
				        //         loc: "",
				        //         vtc: "",
				        //         po: "",
				        //         dist: "",
				        //         subdist: "",
				        //         state: "",
				        //         pc: "",
				        //         dob: "",
				        //         isAadharScanned: false,
				        //         locality: "",
				        //         addressLine1: "",
				        //         addressLine2: ""
						//     }
						
						accountOpeningHomeService.customerAadhaarCardDetails = {
                            uid: "",
                            name: "",
                            firstName: "",
                            middleName: "",
                            lastName: "",
                            gender: "",
                            title: "",
                            yob: "",
                            co: "",
                            house: "",
                            street: "",
                            lm: "",
                            loc: "",
                            vtc: "",
                            po: "",
                            dist: "",
                            subdist: "",
                            state: "",
                            pc: "",
                            dob: "",
                            isAadharScanned: false,
                            locality: "",
                            addressLine1: "",
                            addressLine2: ""
                        }
				            enterOTPAOService.isVID = true;
							// citizenshipDetailsAOService.customerManualEntryDetails.uid = response.data.kycResponse.uidData.aadharNumber;
							// citizenshipDetailsAOService.customerManualEntryDetails.name = response.data.kycResponse.uidData.name;
							// citizenshipDetailsAOService.customerManualEntryDetails.firstName = response.data.kycResponse.uidData.aadharDetails.firstName;
							// citizenshipDetailsAOService.customerManualEntryDetails.middleName = response.data.kycResponse.uidData.aadharDetails.middleName;
							// citizenshipDetailsAOService.customerManualEntryDetails.lastName = response.data.kycResponse.uidData.aadharDetails.lastName;
							// citizenshipDetailsAOService.customerManualEntryDetails.gender = response.data.kycResponse.uidData.aadharDetails.gender;
							// citizenshipDetailsAOService.customerManualEntryDetails.title = response.data.kycResponse.uidData.title;
							// citizenshipDetailsAOService.customerManualEntryDetails.yob = response.data.kycResponse.uidData.yob;
							// citizenshipDetailsAOService.customerManualEntryDetails.dist = response.data.kycResponse.uidData.aadharDetails.addresses[0].dist;
							// citizenshipDetailsAOService.customerManualEntryDetails.subdist = response.data.kycResponse.uidData.aadharDetails.addresses[0].subdist;
							// citizenshipDetailsAOService.customerManualEntryDetails.state = response.data.kycResponse.uidData.aadharDetails.addresses[0].state;
							// citizenshipDetailsAOService.customerManualEntryDetails.pc = response.data.kycResponse.uidData.aadharDetails.addresses[0].pc;
							// citizenshipDetailsAOService.customerManualEntryDetails.dob = response.data.kycResponse.uidData.aadharDetails.dob;
							// citizenshipDetailsAOService.customerManualEntryDetails.locality = response.data.kycResponse.uidData.aadharDetails.addresses[0].locality;
							// citizenshipDetailsAOService.customerManualEntryDetails.addressLine1 = response.data.kycResponse.uidData.aadharDetails.addresses[0].addressLine1;
							// citizenshipDetailsAOService.customerManualEntryDetails.addressLine2 = response.data.kycResponse.uidData.aadharDetails.addresses[0].addressLine2;

								accountOpeningHomeService.customerAadhaarCardDetails.uid = response.data.kycResponse.uidData.aadharNumber;
                                accountOpeningHomeService.customerAadhaarCardDetails.name = response.data.kycResponse.uidData.aadharDetails.name;
                                accountOpeningHomeService.customerAadhaarCardDetails.gender = response.data.kycResponse.uidData.aadharDetails.gender;
                                accountOpeningHomeService.customerAadhaarCardDetails.yob = response.data.kycResponse.uidData.aadharDetails.yearOfBirth;
                                //accountOpeningHomeService.customerAadhaarCardDetails.house = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._house);
                                //accountOpeningHomeService.customerAadhaarCardDetails.street = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._street);
                                //accountOpeningHomeService.customerAadhaarCardDetails.lm = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._lm);
                                accountOpeningHomeService.customerAadhaarCardDetails.loc = response.data.kycResponse.uidData.aadharDetails.addresses[0].locality;
                                //accountOpeningHomeService.customerAadhaarCardDetails.vtc = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._vtc);
                                //accountOpeningHomeService.customerAadhaarCardDetails.po = accountOpeningHomeService.checkSecuredData(addressRegex, securedScannedData._po);
                                accountOpeningHomeService.customerAadhaarCardDetails.dist = response.data.kycResponse.uidData.aadharDetails.addresses[0].district;
                                accountOpeningHomeService.customerAadhaarCardDetails.subdist = response.data.kycResponse.uidData.aadharDetails.addresses[0].subdist;
                                accountOpeningHomeService.customerAadhaarCardDetails.state = response.data.kycResponse.uidData.aadharDetails.addresses[0].state;
                                accountOpeningHomeService.customerAadhaarCardDetails.pc = response.data.kycResponse.uidData.aadharDetails.addresses[0].pincode;
								accountOpeningHomeService.customerAadhaarCardDetails.dob = response.data.kycResponse.uidData.aadharDetails.dob;
								accountOpeningHomeService.customerAadhaarCardDetails.addressLine1 = response.data.kycResponse.uidData.aadharDetails.addresses[0].addressLine1;
								accountOpeningHomeService.customerAadhaarCardDetails.addressLine2 = response.data.kycResponse.uidData.aadharDetails.addresses[0].addressLine2;

								if(response.data.kycResponse.uidData.aadharDetails.dob){
                                    accountOpeningHomeService.showAadhaarAgeProofFlag = false;
                                }else{
                                    accountOpeningHomeService.showAadhaarAgeProofFlag = true;
                                }

				            $state.go('menu.personalDetailsAO');
                }
                else{
                    var title = '';
                    var template = '{{"INVALID_OTP" | translate}}';
                    var onTap = '';
                    var buttontext = '<b>' + vidOTPAOVm.okBtntext + '</b>';
                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                }              
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage); 
            });

	        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
			// $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			vidOTPAOVm.vidnumber = citizenshipDetailsAOService.customerManualEntryDetails.vid;
            vidOTPAOVm.invokeGetOTPService();
			vidOTPAOVm.otpvalue = "";
        });

        return this;
    }
]);
