'use strict';

angularApp.controller('getPictureAOController', ["$state",
    "$scope",
    "$translate",
    "cameraService",
    "utilityService",
    "additionalDetailsAOService",
    "$ionicPopover",
    "$ionicSideMenuDelegate",
    "accountOpeningHomeService",
    "enterOTPAOService",
    "constantConfig",
       function($state,
        $scope,
        $translate,
        cameraService,
        utilityService,
        additionalDetailsAOService,
        $ionicPopover,
        $ionicSideMenuDelegate,
        accountOpeningHomeService,
        enterOTPAOService,
        constantConfig) {

        var getPictureAOVm = this;

        getPictureAOVm.showBack = true;
        getPictureAOVm.showNext = false;
        getPictureAOVm.aofooter = true;

        function initPage() {
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                getPictureAOVm.okBtntext = translatedvalue;  
            });
        }

        getPictureAOVm.goBacktoPrevious = function() {
            if((getPictureAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && enterOTPAOService.isAadhaarScanEntry) || (getPictureAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && enterOTPAOService.isVID)){
				$state.go('menu.aadharScanAddress');
            }else if(getPictureAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && enterOTPAOService.isAadhaarManualEntry){
                $state.go('menu.citizenshipDetailsAO');
            }else{
                $state.go('menu.currentAddressPDAO');
            } 
        }

        $scope.goToHome = function() {
            //additionalDetailsAOService.homeNav();
            accountOpeningHomeService.homeNav();
        }

        getPictureAOVm.takeSelfie = function() {
            $state.go('menu.takeSelfieAO');
        }

        /* Fetch image from gallery */
        getPictureAOVm.imageFromGallery = function() {
            cameraService.getImageFromGallery().then(function(data) {
                additionalDetailsAOService.customer.photo = data;
                $state.go('menu.looksGreatAO');
            }, function(error) {
                // var title = '';
                // var template = '{{"SERVICE_ERR_MSG" | translate}}';
                // var onTap = '';
                // var buttontext = '<b>' + getPictureAOVm.okBtntext + '</b>';
                // utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        /* Info Popup */
        // var template = '<ion-popover-view class="ao-tooltip ao-popupInfo roboto-regular ao-twoLinesHt">' + '<ion-content>' +
        //                 '<div class="" translate="CLEAR_PICTURE"></div>' + '</ion-content>' + '</ion-popover-view>';

        // $scope.popover = $ionicPopover.fromTemplate(template, {
        //     scope: $scope
        // });

        // getPictureAOVm.infoPopup = function($event) {
        //     $scope.popover.show($event);
        // };

        // getPictureAOVm.closePopover = function() {
        //     $scope.popover.hide();
        // };
       /* Info Popup */
        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
       initPage();
       if (enterOTPAOService.isResumeJourney == true) {
            getPictureAOVm.journeyType = enterOTPAOService.taxPage.journeyType;
            }else{
            getPictureAOVm.journeyType = accountOpeningHomeService.journeyType;
            }
        });
        
        return this;
    }
]);
