'use strict';

angularApp.controller('occupationDetailsAOController', ["$state",
    "$scope",
    "$translate",
    "additionalDetailsAOService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
	"userLoginDetailsService",
    "constantConfig",
    "accountOpeningHomeService",
    "enterOTPAOService",
    function($state,
        $scope,
        $translate,
        additionalDetailsAOService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        constantConfig,
        accountOpeningHomeService,
        enterOTPAOService) {

        var occupationDetailsVm = this;

        function initPage() {
            occupationDetailsVm.showBack = true;
            occupationDetailsVm.showNext = false;
            occupationDetailsVm.aofooter = true;
            occupationDetailsVm.loadOccupation();
            occupationDetailsVm.showNext =  additionalDetailsAOService.customerAdditionalDetails.showNext;
            occupationDetailsVm.showNotCatField = false;

            if(additionalDetailsAOService.isResumeJourney == true){
                occupationDetailsVm.populateResumeData();
           }

           if(occupationDetailsVm.annualIncomeValue && additionalDetailsAOService.activeAdditionalDetails && additionalDetailsAOService.activeAdditionalDetails.subOccupation){
               if((additionalDetailsAOService.activeAdditionalDetails.subOccupation !="0700" && additionalDetailsAOService.activeAdditionalDetails.subOccupation !="0600" && additionalDetailsAOService.activeAdditionalDetails.subOccupation != "0500" && additionalDetailsAOService.activeAdditionalDetails.subOccupation != "0493") && (occupationDetailsVm.annualIncomeValue == "0" || occupationDetailsVm.annualIncomeValue == 0)){
                   occupationDetailsVm.annualIncomeError  = true;
               }else{
                   occupationDetailsVm.annualIncomeError = false;
               }
           }

           if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0999" && additionalDetailsAOService.customerAdditionalDetails.subOccupation){
               occupationDetailsVm.searchLabel =  additionalDetailsAOService.customerAdditionalDetails.subOccupation;
                 occupationDetailsVm.showNotCatField = true;
           }
           
        }

        occupationDetailsVm.populateResumeData = function(){
                  if (enterOTPAOService.isResumeJourney == true) {
           
                occupationDetailsVm.activeStatus = additionalDetailsAOService.getIdByValue(occupationDetailsVm.occupationList, additionalDetailsAOService.customerAdditionalDetails.occupation);
           } 
        }

        occupationDetailsVm.loadOccupation = function(){
			occupationDetailsVm.isErorr = false;
			 utilityService.showSpinner();
            var requestParam = "OccupationLotusLevel1";
            additionalDetailsAOService.getOccupation(requestParam).then(function(data) {
               occupationDetailsVm.isErorr = false;
			    utilityService.hideSpinner();
                occupationDetailsVm.occupationList = data;
                occupationDetailsVm.populateResumeData();
            }, function(error) {
				 utilityService.hideSpinner();
				occupationDetailsVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        occupationDetailsVm.selectedObj = function(selectedItem){
            occupationDetailsVm.searchLabel = selectedItem.description;
            occupationDetailsVm.searchLabelTemp = selectedItem.description;
            additionalDetailsAOService.customerAdditionalDetails.subOccupation  = selectedItem.description;
            additionalDetailsAOService.activeAdditionalDetails.subOccupation = selectedItem.value;
            occupationDetailsVm.isSearched = false;
            // if(document.getElementById('angucomplete-dropdown').scrollIntoView()!=undefined){
            //     document.getElementById('angucomplete-dropdown').scrollIntoView();
            // }
			cordova.plugins.Keyboard.close();
		}

        occupationDetailsVm.getReligion = function() {
            
        }

        occupationDetailsVm.getOService = function() {
           
        }

        occupationDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.familyDetailsAO"); 
        }

        occupationDetailsVm.nonCatValueExist = function(username) {
            return occupationDetailsVm.searchedList.some(function(el) {
              return el.description === username;
            }); 
        }

        occupationDetailsVm.goToNextPage = function() {
            if(occupationDetailsVm.searchLabel){
                if((occupationDetailsVm.nonCatValueExist(occupationDetailsVm.searchLabel) == true) && (occupationDetailsVm.nonCatValueExist(occupationDetailsVm.searchLabelTemp) == true)){
                    additionalDetailsAOService.customerAdditionalDetails.showNext = true;
                    $state.go("menu.annualIncomeNew");
                }else{
                    //alert('Please enter the correct value of category.');
                }
             }   
        }

        $scope.goToHome = function() {
            //additionalDetailsAOService.homeNav();
            accountOpeningHomeService.homeNav();
        }

        

        occupationDetailsVm.getSearchJSONData = function(){
			utilityService.showSpinner();
                var requestParam = "OccupationLotusNonCat";
                additionalDetailsAOService.getOccupation(requestParam).then(function(data) { 
                    occupationDetailsVm.isErorr = false;
                    utilityService.hideSpinner();		
                    occupationDetailsVm.searchedList = data;
                }, function(error) {
                    occupationDetailsVm.isErorr = true;
                    utilityService.hideSpinner();	
                    utilityService.showErrorMessage(error.responseMessage);
                });
		};

        /* Based on main occupation, redirect to respective sub occupation pages */
        occupationDetailsVm.showHideSubOcc = function(param) {
            additionalDetailsAOService.activeAdditionalDetails.occupation = param.value;
            additionalDetailsAOService.customerAdditionalDetails.service = occupationDetailsVm.selectedOccupation;
            additionalDetailsAOService.customerAdditionalDetails.occupation = param.description; 
            occupationDetailsVm.activeStatus = param.value;
            additionalDetailsAOService.customerAdditionalDetails.annualIncomeValue = utilityService.resetAmountFormat(occupationDetailsVm.annualIncomeValue);
            if (param.value === "0001") {
                occupationDetailsVm.showNotCatField = false;
                $state.go("menu.subOccupationServiceDetailsAO");
            } 
            else if (param.value === "0002") {
                occupationDetailsVm.showNotCatField = false;
                $state.go("menu.subOccupationOthersDetailsAO");
            }
            else if (param.value === "0303") {
                occupationDetailsVm.showNotCatField = false;
                $state.go("menu.subOccupationBusinessDetailsAO");
            }
            else{
                occupationDetailsVm.showNotCatField = true;
                //$state.go("menu.instaKit_annualIncomeNew");
            } 
            
        }
        
        
        
        //Service to update additional detail
        occupationDetailsVm.updateAdditionalDetailsCall = function() {
        	additionalDetailsAOService.customerAdditionalDetails.subOccupation = "";
        	additionalDetailsAOService.activeAdditionalDetails.subOccupation = "";
            var requestParams = {
                "id": userLoginDetailsService.mobile,
                "type":"AO",
                "data":{
                    "additionalDetails":{
                        "maidenName": additionalDetailsAOService.customerAdditionalDetails.maidenName,
                        "fatherName": additionalDetailsAOService.customerAdditionalDetails.fatherName,
                        "maritalStatus": additionalDetailsAOService.customerAdditionalDetails.maritalStatus,
                        "maritalStatusCode":additionalDetailsAOService.activeAdditionalDetails.marital,
                        "annualIncome": additionalDetailsAOService.customerAdditionalDetails.annualIncome,
                        "annualIncomeCode":additionalDetailsAOService.activeAdditionalDetails.annualIncome,
                        "religion": additionalDetailsAOService.customerAdditionalDetails.religion,
                        "religionCode":additionalDetailsAOService.activeAdditionalDetails.religion,
                        "education": additionalDetailsAOService.customerAdditionalDetails.education,
                        "educationCode":additionalDetailsAOService.activeAdditionalDetails.education,
                        "occupation": additionalDetailsAOService.customerAdditionalDetails.occupation,
                        "occupationCode":additionalDetailsAOService.activeAdditionalDetails.occupation,
                        "subOccupation": additionalDetailsAOService.customerAdditionalDetails.subOccupation,
                        "subOccupationCode": additionalDetailsAOService.activeAdditionalDetails.subOccupation,
                        "annualIncomeValue":additionalDetailsAOService.customerAdditionalDetails.annualIncomeValue,
                    
                         "thresholdLimitAmount": "",
                        "motherFirstName":additionalDetailsAOService.customerAdditionalDetails.motherFirstname,
                        "motherMiddleName":additionalDetailsAOService.customerAdditionalDetails.motherMiddlename,
                        "motherLastName":additionalDetailsAOService.customerAdditionalDetails.motherLastname,
                        
                        "motherTitle":additionalDetailsAOService.customerAdditionalDetails.motherTitle,
                        "motherTitleCode":additionalDetailsAOService.customerAdditionalDetails.motherTitleCode, 
                        
                        "motherMaidenName": additionalDetailsAOService.customerAdditionalDetails.motherMaidenName,
                        "spouseName": additionalDetailsAOService.customerAdditionalDetails.spouseName,
                        
                        "fatherFirstName": additionalDetailsAOService.customerAdditionalDetails.fatherFirstName,
                        "fatherMiddleName":additionalDetailsAOService.customerAdditionalDetails.fatherMiddleName,
                        "fatherLastName":additionalDetailsAOService.customerAdditionalDetails.fatherLastName,
                        
                        "fatherTitle":additionalDetailsAOService.customerAdditionalDetails.fatherTitle,
                        "fatherTitleCode":additionalDetailsAOService.customerAdditionalDetails.fatherTitleCode
                    },
                    "commonId":$state.$current.data.commonId
                }             
            }
            additionalDetailsAOService.updateAdditionalDetails(requestParams).then(function(response) {
                var responseCode = response.responseCode;
                if (responseCode === constantConfig.successCode) {
                   $state.go("menu.optionalAdditionalDetails"); 
                }
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            occupationDetailsVm.annualIncomeValue = additionalDetailsAOService.customerAdditionalDetails.annualIncomeValue;
            occupationDetailsVm.activeStatus = additionalDetailsAOService.activeAdditionalDetails.occupation;
            if(occupationDetailsVm.annualIncomeValue){
                occupationDetailsVm.annualIncomeValue = utilityService.amountFormat(occupationDetailsVm.annualIncomeValue);
            }
            if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0999" && additionalDetailsAOService.customerAdditionalDetails.subOccupation){
                  occupationDetailsVm.searchLabelTemp =  additionalDetailsAOService.customerAdditionalDetails.subOccupation;
                  occupationDetailsVm.showNotCatField = true;
            }
            occupationDetailsVm.getSearchJSONData();
            //occupationDetailsVm.populateResumeData();
            //}
        });

        occupationDetailsVm.yonoSearch = function(inputItem){
			var arrForinputItem = [];
			var regExpInput = "";
			var str = '';
			occupationDetailsVm.filteredList = [];
			occupationDetailsVm.isSearched = false;
			var arr = [];
			if(inputItem && inputItem.length >= 2){
                if(inputItem.length==3){
                    cordova.plugins.Keyboard.close();
                }
           
				arrForinputItem = (inputItem.toLowerCase()).split(/[,\s]+/g);
				for(var i=0;i<arrForinputItem.length;i++){
					str += "(?=.*"+arrForinputItem[i]+")";
				}
				regExpInput = new RegExp("^"+str+".*$");
				angular.forEach(occupationDetailsVm.searchedList,function(v1,k1){
					if(occupationDetailsVm.searchedList[k1]["description"].toString().toLowerCase().match(regExpInput)){
						arr.push(v1);
						occupationDetailsVm.filteredList = removedDuplicateObjects(arr);
						occupationDetailsVm.isSearched = true;
						//$ionicScrollDelegate.$getByHandle('search-functionality-handle').scrollTop();
					}
				});
			}
			else{
				occupationDetailsVm.isSearched = false;
				occupationDetailsVm.filteredList = [];
			}
		}
		var removedDuplicateObjects = function (arr) {
			return arr.filter(function(item, index){
				return arr.indexOf(item) >= index;
			});
		};

        return this;
    }
]);
