'use strict';

angularApp.service('accountOpeningHomeService', ['$state',
 "utilityService",
 "mPinLoginService",
 "userLoginDetailsService",
 "enterOTPAOService",
 "POCADetailsService",
 "citizenshipDetailsAOService",
 "additionalDetailsAOService",
 "nomineeDetailsAOService",
 "chequeBookServiceDetailsService",
 "loggedInUserService",
    function($state, utilityService, mPinLoginService, 
    	userLoginDetailsService,enterOTPAOService,POCADetailsService,citizenshipDetailsAOService
    	,additionalDetailsAOService,nomineeDetailsAOService
    	,chequeBookServiceDetailsService,loggedInUserService) {
        var accountOpeningHomeService = this;

        accountOpeningHomeService.customer = {
            aadharNumber: '',
            title: '',
            name: '',
            gender: '',
            dateOfYear: '',
            address: '',
            pincode: '',
            city: '',
            state: '',
            emailId: '',
            mobileNo: '',
            panNumber: '',
            lotusId: '1234',
            image: 'abc',
            deviceUid: '',
            deviceOS: '',
            referenceCode: '',
            photo: '',
            proofFrontPagePhoto: '',
            proofLastPagePhoto: '',
            proofFrontPagePhotoTemp: '',
            proofLastPagePhotoTemp: '',
            proofFrontPagePhotoId: '',
            proofLastPagePhotoId: '',
            isproofLastPagePhoto: '',
            guardian: '',
            latitude: '',
            longitude: '',
            encodephoto: ''
        }

        accountOpeningHomeService.customerAdditionalDetails = {
            "maidenName": "",
            "fatherName": "",
            "fatherFirstName": "",
            "fatherMiddleName": "",
            "fatherLastName": "",
            "spouseName": "",
            "motherMaidenName": "",
            "maritalStatus": "",
            "category":"",
            "annualIncome": "",
            "annualIncomeValue": "",
            "occupation": "",
            "subOccupation": "",
            "religion": "",
            "education": "",
            "cityOfBirth": "",
            "countryOfBirth": "",
            "nationality":"",
            "nationalityID":"",
            "citizenship":"",
            "citizenshipID":"",
            "motherFirstname":"",
            "motherMiddlename":"",
            "motherLastname":"",
            "motherTitle":"",
            "motherTitleCode":"",
            "fatherTitle":"",
            "fatherTitleCode":""
        }

        accountOpeningHomeService.mapCoords = {
            latitude:'',
            longitude:''
        }

        accountOpeningHomeService.mapGPS = [];

        accountOpeningHomeService.debitCardDetails = {
            "firstName": '',
            "lastName": ''
        }

        accountOpeningHomeService.selectByGPS = [];
        accountOpeningHomeService.locateByGPS = [];


        accountOpeningHomeService.customerCorrespondenceAddress = {
            address1: "",
            address2: "",
            state: "",
            stateCode: "",
            city: "",
            cityCode: "",
            pincode: "",
            isAadharScanned: false,
            locality: ""
        }

        accountOpeningHomeService.customerManualEntryDetails = {
            aadharNumber: "",
            firstName: "",
            lastName: "",
            middleName: "",
            fullName: "",
            gender: "",
            genderCode:"",
            title: "",
            titleCode:"",
            dob: "",
            address1: "",
            address2: "",
            city: "",
            cityCode: "",
            state: "",
            stateCode: "",
            pincode: "",
            isAadharScanned: false,
            locality: "",
            addressLine1: "",
            addressLine2: ""

        }

        accountOpeningHomeService.customerAadhaarCardDetails = {
            uid: "",
            name: "",
            firstName: "",
            middleName: "",
            lastName: "",
            gender: "",
            genderCode:"",
            title: "",
            titleCode:"",
            yob: "",
            co: "",
            house: "",
            street: "",
            lm: "",
            loc: "",
            vtc: "",
            po: "",
            dist: "",
            distCode:"",
            subdist: "",
            state: "",
            stateCode:"",
            pc: "",
            dob: "",
            isAadharScanned: false,
            locality: "",
            addressLine1: "",
            addressLine2: ""
        }

        accountOpeningHomeService.nomineeAadhaarCardDetails = {
            uid: "",
            name: "",
            gender: "",
            yob: "",
            co: "",
            house: "",
            street: "",
            lm: "",
            loc: "",
            vtc: "",
            po: "",
            dist: "",
            distCode:"",
            subdist: "",
            state: "",
            stateCode: "",
            pc: "",
            dob: "",
            relationship: "",
            guardianName: "",
            guardianAge:"",
            age: "",
            address1: "",
            address2: ""
        }

        accountOpeningHomeService.activeAdditionalDetails = {

        }

        accountOpeningHomeService.selectedBranch = {
            branchname: "",
            branchaddress: ""
        }

        accountOpeningHomeService.iibCall = false;

        accountOpeningHomeService.nominee = {
            uid: '',
            name: '',
            firstName: '',
            middleName: '',
            lastName: '',
            relationship: '',
            guardianName: '',
            guardianAge:'',
            age: '',
            address1: '',
            address2: '',
            pincode: '',
            dob: '',
            city: '',
            cityCode: '',
            state: '',
            stateCode: '',
            guardianAddressFlag: ''
        }

        accountOpeningHomeService.branches = [];

        accountOpeningHomeService.nomineeGuardianDetails = {
            address1: '',
            address2: '',
            pincode: '',
            city: '',
            cityCode: '',
            state: '',
            stateCode: '',
            locality: '',
            guardianConsent:''
        }

        accountOpeningHomeService.direction = {
            latitude: '',
            longitude: '',
            branchname: '',
            address: '',
            state: ''
        }

        accountOpeningHomeService.aadhaarManualPermanentAddress = {
            address1: "",
            address2: "",
            state: "",
            stateCode: "",
            city: "",
            cityCode:"",
            pincode: "",
            isAadharScanned: false,
            locality: ""
        }

        accountOpeningHomeService.aadhaarManualCorrespondenceAddress = {
            address1: "",
            address2: "",
            state: "",
            stateCode: "",
            city: "",
            cityCode: "",
            pincode: "",
            isAadharScanned: false,
            locality: ""
        }

        accountOpeningHomeService.localityNav = "";
        accountOpeningHomeService.isNomineeAddress1Changed = false;
        accountOpeningHomeService.isNomineeAddress2Changed = false;
        accountOpeningHomeService.nomineeNav = "";
        accountOpeningHomeService.isNomineeScanned = false;
        accountOpeningHomeService.localityNextDisable = "";
        accountOpeningHomeService.isResumeJourney = false;
        accountOpeningHomeService.isAadharManualEntry = false;
        accountOpeningHomeService.panAuthorizeFlag = false;
        accountOpeningHomeService.cardReadyForCollection = "";
        accountOpeningHomeService.isCustManualCorresChkBox = false;
        accountOpeningHomeService.fatcaFlag;
        accountOpeningHomeService.termsAndConditionsFlag = false;
        accountOpeningHomeService.productOfferingFlag = true;
        accountOpeningHomeService.homeBranchLocalityCity = "";
        accountOpeningHomeService.homeBranchLocalityId = "";
        accountOpeningHomeService.homeBranchGpsId = "";
        accountOpeningHomeService.picId = '';
        accountOpeningHomeService.picIdFirstPage = '';
        accountOpeningHomeService.picIdSecondPage= '';
        accountOpeningHomeService.appPassword = '';
        accountOpeningHomeService.cifNumber = '';
        accountOpeningHomeService.acNumber = '';
        accountOpeningHomeService.debitNumber = '';
        accountOpeningHomeService.tncOtpValue = '';


        accountOpeningHomeService.maritalStatusList = [];
        accountOpeningHomeService.categoryList = [];

        accountOpeningHomeService.getIdByValue = function(obj, selectedValue) {
            var selectedId;
            for (var i = 0; i < obj.length; i++) {
                if (obj[i].description == selectedValue) {
                    selectedId = obj[i].value;
                }
            }
            return selectedId;
        }

        accountOpeningHomeService.getValueById = function(obj, selectedId) {
        	
            var selectedValue = "";
            try{
            for (var i = 0; i < obj.length; i++) {
                if (obj[i].value == selectedId) {
                    selectedValue = obj[i].description;
                }
            }
            }catch(err){}
            return selectedValue;
        }

        //Method to check null / undefined values and append commas
        accountOpeningHomeService.nullCheck = function(value) {
            var checkedVal = "";
            if (value != undefined && value != "") {
                checkedVal = value + ', ';
            }
            return checkedVal;
        }

        //Method to check for html tags
        accountOpeningHomeService.checkHtmlTags = function(data) {
            var validData;
            if ((/<(.|\n)*?>/g).test(data) == false) {
                validData = data;
            } else {
                validData = '';
            }
            return validData;
        }

        //Method to pass regular expression and values for secured data
        accountOpeningHomeService.checkSecuredData = function(regex, value) {
            var validValue;
            if (!utilityService.isUndefined(value)) {
                if (regex.test(value) == true) {
                    validValue = value;
                }
            } else {
                validValue = '';
            }
            return validValue;
        }

        /* ----------Click on cross icon - reset all data and redirect to homepage-------------*/
        accountOpeningHomeService.homeNav = function() {
	          
			userLoginDetailsService.mobile = "";
			userLoginDetailsService.pannumber = "";
			userLoginDetailsService.mobile = "";
			userLoginDetailsService.emailId = "";
			userLoginDetailsService.reffCode = "";
			enterOTPAOService.isResumeJourney = false;
			chequeBookServiceDetailsService.CBPage = {};
			nomineeDetailsAOService.guardian = {};
			nomineeDetailsAOService.nominee = {};
			additionalDetailsAOService.activeAdditionalDetails = {};
			additionalDetailsAOService.customerAdditionalDetails = {}
			citizenshipDetailsAOService.customerAdditionalDetails = {};
			citizenshipDetailsAOService.customerManualEntryDetails = {};
			POCADetailsService.docNumber = "";
			POCADetailsService.expiryCompleteDate = "";
			POCADetailsService.issuedCompleteDate = "";
			POCADetailsService.type = "";
			POCADetailsService.issuedAt = "";
			POCADetailsService.issuedBy = "";
			POCADetailsService.proofSelValue = "";

            	
        	
            accountOpeningHomeService.customerManualEntryDetails = {
                aadharNumber: "",
                firstName: "",
                lastName: "",
                middleName: "",
                fullName: "",
                gender: "",
                genderCode:"",
                title: "",
                titleCode:"",
                dob: "",
                address1: "",
                address2: "",
                city: "",
                cityCode: "",
                state: "",
                stateCode: "",
                pincode: "",
                isAadharScanned: false,
                locality: "",
                addressLine1: "",
                addressLine2: ""

            }
            accountOpeningHomeService.tncOtpValue = '';
            accountOpeningHomeService.branches = [];
            accountOpeningHomeService.customer.photo = "";
            accountOpeningHomeService.picId = '';

            accountOpeningHomeService.nomineeGuardianDetails = {
                address1: '',
                address2: '',
                pincode: '',
                city: '',
                cityCode: '',
                state: '',
                stateCode: '',
                locality: ''
            }

            accountOpeningHomeService.direction = {
                latitude: '',
                longitude: '',
                branchname: '',
                address: '',
                state: ''
            }

            accountOpeningHomeService.iibCall = false;

            accountOpeningHomeService.nominee = {
                uid: '',
                name: '',
                firstName: '',
                middleName: '',
                lastName: '',
                relationship: '',
                guardianName: '',
                guardianAge:'',
                age: '',
                address1: '',
                address2: '',
                pincode: '',
                dob: '',
                city: '',
                cityCode: '',
                state: '',
                stateCode: '',
                guardianAddressFlag: ''
            }

            accountOpeningHomeService.customer = {
                aadharNumber: '',
                title: '',
                name: '',
                gender: '',
                dateOfYear: '',
                address: '',
                pincode: '',
                city: '',
                state: '',
                emailId: '',
                mobileNo: '',
                panNumber: '',
                lotusId: '1234',
                image: 'abc',
                deviceUid: '',
                deviceOS: '',
                referenceCode: '',
                photo: '',
                guardian: '',
                latitude: '',
                longitude: '',
                encodephoto: ''
            }

            accountOpeningHomeService.customerAdditionalDetails = {
                "maidenName": "",
                "fatherName": "",
                "fatherFirstName": "",
                "fatherMiddleName": "",
                "fatherLastName": "",
                "spouseName": "",
                "motherMaidenName": "",
                "maritalStatus": "",
                "annualIncome": "",
                "occupation": "",
                "subOccupation": "",
                "religion": "",
                "education": "",
                "cityOfBirth": "",
                "countryOfBirth": "",
                "nationality":"",
                "nationalityID":"",
                "citizenship":"",
                "citizenshipID":"",
                "motherFirstname":"",
                "motherMiddlename":"",
                "motherLastname":"",
                "motherTitle":"",
                "motherTitleCode":"",
                "fatherTitle":"",
                "fatherTitleCode":""
            }

            accountOpeningHomeService.customerCorrespondenceAddress = {
                address1: "",
                address2: "",
                state: "",
                stateCode: "",
                city: "",
                cityCode: "",
                pincode: "",
                isAadhaarScanned: false,
                locality: ""

            }

            accountOpeningHomeService.customerAadhaarCardDetails = {
                uid: "",
                name: "",
                firstName: "",
                middleName: "",
                lastName: "",
                gender: "",
                genderCode:"",
                title: "",
                titleCode:"",
                yob: "",
                co: "",
                house: "",
                street: "",
                lm: "",
                loc: "",
                vtc: "",
                po: "",
                dist: "",
                subdist: "",
                state: "",
                pc: "",
                dob: "",
                isAadharScanned: false,
                locality: "",
                addressLine1: "",
                addressLine2: ""
            }

            accountOpeningHomeService.nomineeAadhaarCardDetails = {
                uid: "",
                name: "",
                gender: "",
                yob: "",
                co: "",
                house: "",
                street: "",
                lm: "",
                loc: "",
                vtc: "",
                po: "",
                dist: "",
                subdist: "",
                state: "",
                pc: "",
                dob: "",
                relationship: "",
                guardianName: "",
                guardianAge:'',
                age: "",
                address1: "",
                address2: ""
            }

            accountOpeningHomeService.activeAdditionalDetails = {

            }

            accountOpeningHomeService.selectedBranch = {
                branchname: "",
                branchaddress: ""
            }
            accountOpeningHomeService.aadhaarManualPermanentAddress = {
                address1: "",
                address2: "",
                state: "",
                stateCode: "",
                city: "",
                cityCode: "",
                pincode: "",
                isAadharScanned: false,
                locality: ""
            }

            accountOpeningHomeService.aadhaarManualCorrespondenceAddress = {
                address1: "",
                address2: "",
                state: "",
                stateCode: "",
                city: "",
                cityCode:"",
                pincode: "",
                isAadharScanned: false,
                locality: ""
            }

            accountOpeningHomeService.debitCardDetails = {
                firstName: "",
                lastName: ""
            }

            accountOpeningHomeService.localityNav = "";
            accountOpeningHomeService.isNomineeAddress1Changed = false;
            accountOpeningHomeService.isNomineeAddress2Changed = false;
            accountOpeningHomeService.nomineeNav = "";
            accountOpeningHomeService.isNomineeScanned = false;
            accountOpeningHomeService.localityNextDisable = "";
            accountOpeningHomeService.isResumeJourney = false;
            accountOpeningHomeService.isAadharManualEntry = false;
            accountOpeningHomeService.panAuthorizeFlag = false;
            accountOpeningHomeService.cardReadyForCollection = "";
            accountOpeningHomeService.isCustManualCorresChkBox = false;
            accountOpeningHomeService.fatcaFlag;
            accountOpeningHomeService.termsAndConditionsFlag = false;
            accountOpeningHomeService.productOfferingFlag = true;
            accountOpeningHomeService.homeBranchLocalityCity = "";
            accountOpeningHomeService.homeBranchLocalityId = "";
            accountOpeningHomeService.homeBranchGpsId = "";
            accountOpeningHomeService.appPassword = "";
            accountOpeningHomeService.cifNumber = "";
            accountOpeningHomeService.acNumber = '';
            accountOpeningHomeService.debitNumber = '';
            if(mPinLoginService.isLoggedIn == true){
			    $state.go('menu.accountOverviewMyBalance');
            }
            else{
                $state.go('menu.landingWithOptions');
            }

            userLoginDetailsService.mobile = "";
            userLoginDetailsService.emailId = "";
            loggedInUserService.logoutAOUser();
        }


        //Common method for resuming the data in resume/omnichannel/dedupe journey
        accountOpeningHomeService.getResumeDocument = function(customerDetails) {
            var addressCount = 0;
     
            accountOpeningHomeService.customer.panNumber = utilityService.getValue(customerDetails.personalDetails.pan);
            accountOpeningHomeService.cifNumber = utilityService.getValue(customerDetails.personalDetails.cifStatus);
            accountOpeningHomeService.fatcaFlag = customerDetails.fatcaFlag;
			accountOpeningHomeService.fatcaResumeStatus = customerDetails.fatcaResumeStatus ? customerDetails.fatcaResumeStatus : "";
            accountOpeningHomeService.panAuthorizeFlag = customerDetails.panAuthorizeFlag;
            accountOpeningHomeService.customer.mobileNo = utilityService.getValue(customerDetails.personalDetails.mobileNumber);
            //accountOpeningHomeService.appPassword = utilityService.getValue(customerDetails.auth.password);
            accountOpeningHomeService.customer.emailId = utilityService.getValue(customerDetails.personalDetails.emailId);
            if (!utilityService.isUndefined(customerDetails.additionalDetails)) {
                
                accountOpeningHomeService.customerAdditionalDetails.annualIncome = utilityService.getValue(customerDetails.additionalDetails.annualIncome);
                accountOpeningHomeService.activeAdditionalDetails.income = utilityService.getValue(customerDetails.additionalDetails.annualIncomeCode);
                accountOpeningHomeService.customerAdditionalDetails.education = utilityService.getValue(customerDetails.additionalDetails.education);
                accountOpeningHomeService.activeAdditionalDetails.education = utilityService.getValue(customerDetails.additionalDetails.educationCode);
                accountOpeningHomeService.customerAdditionalDetails.maritalStatus = utilityService.getValue(customerDetails.additionalDetails.maritalStatus);
                accountOpeningHomeService.activeAdditionalDetails.marital = utilityService.getValue(customerDetails.additionalDetails.maritalStatusCode);
                accountOpeningHomeService.customerAdditionalDetails.category = utilityService.getValue(customerDetails.additionalDetails.category);
                accountOpeningHomeService.activeAdditionalDetails.category = utilityService.getValue(customerDetails.additionalDetails.categoryCode);
                accountOpeningHomeService.customerAdditionalDetails.annualIncomeValue = utilityService.getValue(customerDetails.additionalDetails.annualIncomeValue);
                accountOpeningHomeService.customerAdditionalDetails.occupation = utilityService.getValue(customerDetails.additionalDetails.occupation);
                accountOpeningHomeService.activeAdditionalDetails.occupation = utilityService.getValue(customerDetails.additionalDetails.occupationCode);
                accountOpeningHomeService.customerAdditionalDetails.religion = utilityService.getValue(customerDetails.additionalDetails.religion);
                accountOpeningHomeService.activeAdditionalDetails.religion = utilityService.getValue(customerDetails.additionalDetails.religionCode);
                accountOpeningHomeService.customerAdditionalDetails.subOccupation = utilityService.getValue(customerDetails.additionalDetails.subOccupation);
                accountOpeningHomeService.activeAdditionalDetails.suboccupation = utilityService.getValue(customerDetails.additionalDetails.subOccupationCode);
                
                accountOpeningHomeService.customerAdditionalDetails.fatherFirstName = utilityService.getValue(customerDetails.additionalDetails.fatherFirstName);
                accountOpeningHomeService.customerAdditionalDetails.fatherMiddleName = utilityService.getValue(customerDetails.additionalDetails.fatherMiddleName);
                accountOpeningHomeService.customerAdditionalDetails.fatherLastName = utilityService.getValue(customerDetails.additionalDetails.fatherLastName);
                accountOpeningHomeService.customerAdditionalDetails.spouseName = utilityService.getValue(customerDetails.additionalDetails.spouseName);
                accountOpeningHomeService.customerAdditionalDetails.motherMaidenName = utilityService.getValue(customerDetails.additionalDetails.motherMaidenName);
                accountOpeningHomeService.customerAdditionalDetails.maidenName = utilityService.getValue(customerDetails.additionalDetails.maidenName);
                accountOpeningHomeService.customerAdditionalDetails.motherFirstname = utilityService.getValue(customerDetails.additionalDetails.motherFirstName);
                accountOpeningHomeService.customerAdditionalDetails.motherMiddlename = utilityService.getValue(customerDetails.additionalDetails.motherMiddleName);
                accountOpeningHomeService.customerAdditionalDetails.motherLastname = utilityService.getValue(customerDetails.additionalDetails.motherLastName);
                accountOpeningHomeService.customerAdditionalDetails.motherTitle = utilityService.getValue(customerDetails.additionalDetails.motherTitle);
                accountOpeningHomeService.customerAdditionalDetails.motherTitleCode = utilityService.getValue(customerDetails.additionalDetails.motherTitleCode);
                accountOpeningHomeService.customerAdditionalDetails.fatherTitle = utilityService.getValue(customerDetails.additionalDetails.fatherTitle);
                accountOpeningHomeService.customerAdditionalDetails.fatherTitleCode = utilityService.getValue(customerDetails.additionalDetails.fatherTitleCode);
            }

            if(customerDetails.personalDetails.isAadhaarScanned == true){
                accountOpeningHomeService.customerAadhaarCardDetails.title = utilityService.getValue(customerDetails.personalDetails.title);
                accountOpeningHomeService.customerAadhaarCardDetails.titleCode = utilityService.getValue(customerDetails.personalDetails.titleCode);
                accountOpeningHomeService.customerAadhaarCardDetails.name = utilityService.getValue(customerDetails.personalDetails.name);
                accountOpeningHomeService.customerAadhaarCardDetails.firstName = utilityService.getValue(customerDetails.personalDetails.firstName);
                accountOpeningHomeService.customerAadhaarCardDetails.middleName = utilityService.getValue(customerDetails.personalDetails.middleName);
                accountOpeningHomeService.customerAadhaarCardDetails.lastName = utilityService.getValue(customerDetails.personalDetails.lastName);
                accountOpeningHomeService.customerAadhaarCardDetails.gender = utilityService.getValue(customerDetails.personalDetails.gender);
                accountOpeningHomeService.customerAadhaarCardDetails.genderCode = utilityService.getValue(customerDetails.personalDetails.genderCode);
                accountOpeningHomeService.customerAadhaarCardDetails.uid = utilityService.getValue(customerDetails.personalDetails.uid);
                accountOpeningHomeService.customerAadhaarCardDetails.dob = utilityService.getValue(customerDetails.personalDetails.dob);
                accountOpeningHomeService.customerAdditionalDetails.cityOfBirth = utilityService.getValue(customerDetails.personalDetails.cityOfBirth);
                accountOpeningHomeService.customerAdditionalDetails.countryOfBirth = utilityService.getValue(customerDetails.personalDetails.countryOfBirth);
                accountOpeningHomeService.customerAdditionalDetails.nationality = utilityService.getValue(customerDetails.personalDetails.nationality);
                accountOpeningHomeService.customerAdditionalDetails.nationalityID = utilityService.getValue(customerDetails.personalDetails.nationalityCode);
                accountOpeningHomeService.customerAdditionalDetails.citizenship = utilityService.getValue(customerDetails.personalDetails.citizenship);
                accountOpeningHomeService.customerAdditionalDetails.citizenshipID = utilityService.getValue(customerDetails.personalDetails.citizenshipCode);
            }

            else if(customerDetails.personalDetails.isAadhaarScanned == false){
                accountOpeningHomeService.customerManualEntryDetails.title = utilityService.getValue(customerDetails.personalDetails.title);
                accountOpeningHomeService.customerManualEntryDetails.titleCode = utilityService.getValue(customerDetails.personalDetails.titleCode);
                accountOpeningHomeService.customerManualEntryDetails.fullName = utilityService.getValue(customerDetails.personalDetails.name);
                accountOpeningHomeService.customerManualEntryDetails.firstName = utilityService.getValue(customerDetails.personalDetails.firstName);
                accountOpeningHomeService.customerManualEntryDetails.middleName = utilityService.getValue(customerDetails.personalDetails.middleName);
                accountOpeningHomeService.customerManualEntryDetails.lastName = utilityService.getValue(customerDetails.personalDetails.lastName);
                accountOpeningHomeService.customerManualEntryDetails.gender = utilityService.getValue(customerDetails.personalDetails.gender);
                accountOpeningHomeService.customerManualEntryDetails.genderCode = utilityService.getValue(customerDetails.personalDetails.genderCode);
                accountOpeningHomeService.customerManualEntryDetails.aadharNumber = utilityService.getValue(customerDetails.personalDetails.uid);
                accountOpeningHomeService.customerManualEntryDetails.dob = utilityService.getValue(customerDetails.personalDetails.dob);
                accountOpeningHomeService.customerAdditionalDetails.cityOfBirth = utilityService.getValue(customerDetails.personalDetails.placeOfBirth);
                accountOpeningHomeService.customerAdditionalDetails.placeOfBirth = utilityService.getValue(customerDetails.personalDetails.placeOfBirth);
                accountOpeningHomeService.customerAdditionalDetails.countryOfBirth = utilityService.getValue(customerDetails.personalDetails.countryOfBirth);
                accountOpeningHomeService.customerAdditionalDetails.nationality = utilityService.getValue(customerDetails.personalDetails.nationality);
                accountOpeningHomeService.customerAdditionalDetails.nationalityID = utilityService.getValue(customerDetails.personalDetails.nationalityCode);
                accountOpeningHomeService.customerAdditionalDetails.citizenship = utilityService.getValue(customerDetails.personalDetails.citizenship);
                accountOpeningHomeService.customerAdditionalDetails.citizenshipID = utilityService.getValue(customerDetails.personalDetails.citizenshipCode);
				accountOpeningHomeService.isAadharManualEntry = true;
            }

            

            if (!utilityService.isUndefined(customerDetails.personalDetails.address) && customerDetails.personalDetails.address.length > 0) {
                for (var i = 0; i < customerDetails.personalDetails.address.length; i++) {
                    if (customerDetails.personalDetails.isAadhaarScanned == true) {
                        //.correspondenceCheckStatus = customerDetails.personalDetails.scannedCorrespondenceAddFlag;
                        if (customerDetails.personalDetails.address[i].type == "CORRESPONDENCE") {
                            accountOpeningHomeService.customerCorrespondenceAddress.address1 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine1);
                            accountOpeningHomeService.customerCorrespondenceAddress.address2 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine2);
                            accountOpeningHomeService.customerCorrespondenceAddress.pincode = utilityService.getValue(customerDetails.personalDetails.address[i].pincode);
                            accountOpeningHomeService.customerCorrespondenceAddress.city = utilityService.getValue(customerDetails.personalDetails.address[i].city);
                            accountOpeningHomeService.customerCorrespondenceAddress.state = utilityService.getValue(customerDetails.personalDetails.address[i].state);
                            accountOpeningHomeService.customerCorrespondenceAddress.cityCode = utilityService.getValue(customerDetails.personalDetails.address[i].cityCode);
                            accountOpeningHomeService.customerCorrespondenceAddress.stateCode = utilityService.getValue(customerDetails.personalDetails.address[i].stateCode);
                            accountOpeningHomeService.customerCorrespondenceAddress.locality = utilityService.getValue(customerDetails.personalDetails.address[i].locality);
                            addressCount++;
                        } else if (customerDetails.personalDetails.address[i].type == "aadhaar") {
                            accountOpeningHomeService.customerAadhaarCardDetails.addressLine1 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine1);
                            accountOpeningHomeService.customerAadhaarCardDetails.addressLine2 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine2);
                            accountOpeningHomeService.customerAadhaarCardDetails.dist = utilityService.getValue(customerDetails.personalDetails.address[i].city);
                            accountOpeningHomeService.customerAadhaarCardDetails.state = utilityService.getValue(customerDetails.personalDetails.address[i].state);
                            accountOpeningHomeService.customerAadhaarCardDetails.distCode = utilityService.getValue(customerDetails.personalDetails.address[i].cityCode);
                            accountOpeningHomeService.customerAadhaarCardDetails.stateCode = utilityService.getValue(customerDetails.personalDetails.address[i].stateCode);
                            accountOpeningHomeService.customerAadhaarCardDetails.pc = utilityService.getValue(customerDetails.personalDetails.address[i].pincode);
                            accountOpeningHomeService.customerAadhaarCardDetails.locality = utilityService.getValue(customerDetails.personalDetails.address[i].locality);
                        }
                        accountOpeningHomeService.isAadharManualEntry = false;
                        accountOpeningHomeService.customerCorrespondenceAddress.isAadhaarScanned = true;
                        if (addressCount == 1) {
                            accountOpeningHomeService.correspondenceCheckStatus = true;

                        } else {
                            accountOpeningHomeService.correspondenceCheckStatus = false;
                        }

                    } else if (customerDetails.personalDetails.isAadhaarScanned == false) {
                        if (customerDetails.personalDetails.address[i].type == "aadhaar") {
                            accountOpeningHomeService.aadhaarManualPermanentAddress.address1 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine1);
                            accountOpeningHomeService.aadhaarManualPermanentAddress.address2 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine2);
                            accountOpeningHomeService.aadhaarManualPermanentAddress.pincode = utilityService.getValue(customerDetails.personalDetails.address[i].pincode);
                            accountOpeningHomeService.aadhaarManualPermanentAddress.city = utilityService.getValue(customerDetails.personalDetails.address[i].city);
                            accountOpeningHomeService.aadhaarManualPermanentAddress.state = utilityService.getValue(customerDetails.personalDetails.address[i].state);
                            accountOpeningHomeService.aadhaarManualPermanentAddress.cityCode = utilityService.getValue(customerDetails.personalDetails.address[i].cityCode);
                            accountOpeningHomeService.aadhaarManualPermanentAddress.stateCode = utilityService.getValue(customerDetails.personalDetails.address[i].stateCode);
                            accountOpeningHomeService.aadhaarManualPermanentAddress.locality = utilityService.getValue(customerDetails.personalDetails.address[i].locality);
                            accountOpeningHomeService.aadhaarManualPermanentAddress.isAadhaarScanned = false;
                            //.isCustManualCorresChkBox = customerDetails.personalDetails.scannedCorrespondenceAddFlag;
                        } else if (customerDetails.personalDetails.address[i].type == "CORRESPONDENCE") {
                            accountOpeningHomeService.aadhaarManualCorrespondenceAddress.address1 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine1);
                            accountOpeningHomeService.aadhaarManualCorrespondenceAddress.address2 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine2);
                            accountOpeningHomeService.aadhaarManualCorrespondenceAddress.pincode = utilityService.getValue(customerDetails.personalDetails.address[i].pincode);
                            accountOpeningHomeService.aadhaarManualCorrespondenceAddress.city = utilityService.getValue(customerDetails.personalDetails.address[i].city);
                            accountOpeningHomeService.aadhaarManualCorrespondenceAddress.state = utilityService.getValue(customerDetails.personalDetails.address[i].state);
                            accountOpeningHomeService.aadhaarManualCorrespondenceAddress.cityCode = utilityService.getValue(customerDetails.personalDetails.address[i].cityCode);
                            accountOpeningHomeService.aadhaarManualCorrespondenceAddress.stateCode = utilityService.getValue(customerDetails.personalDetails.address[i].stateCode);
                            accountOpeningHomeService.aadhaarManualCorrespondenceAddress.locality = utilityService.getValue(customerDetails.personalDetails.address[i].locality);
                            accountOpeningHomeService.aadhaarManualCorrespondenceAddress.isAadhaarScanned = false;
                            //.isCustManualCorresChkBox = customerDetails.personalDetails.scannedCorrespondenceAddFlag;
                        }
                        accountOpeningHomeService.isAadharManualEntry = true;
                        accountOpeningHomeService.isCustManualCorresChkBox = customerDetails.personalDetails.scannedCorrespondenceAddFlag;
                    }
            
                }
            } else if (!utilityService.isUndefined(customerDetails.personalDetails.address) && customerDetails.personalDetails.address.length == 0) {
                if (customerDetails.personalDetails.isAadhaarScanned == true) {
                    accountOpeningHomeService.isAadharManualEntry = false;
                    accountOpeningHomeService.customerCorrespondenceAddress.isAadhaarScanned = true;
                } else if (customerDetails.personalDetails.isAadhaarScanned == false) {
                    accountOpeningHomeService.isAadharManualEntry = true;
                }
            }

            if (!utilityService.isUndefined(customerDetails.doc) && customerDetails.doc.length > 0) {
                for (var i = 0; i < customerDetails.doc.length; i++) {
                    if (customerDetails.doc[i].docType.toLowerCase() == "photograph") {
                        accountOpeningHomeService.picId = customerDetails.doc[i].docRef;
                    }
                }
            }

            if (!utilityService.isUndefined(customerDetails.nominees) && customerDetails.nominees.length > 0) {
                accountOpeningHomeService.isNomineeScanned = customerDetails.nominees[0].isNomineeAadhaarScanned;

                if (accountOpeningHomeService.isNomineeScanned === true) {
                    accountOpeningHomeService.nomineeAadhaarCardDetails.uid = utilityService.getValue(customerDetails.nominees[0].uid);
                    accountOpeningHomeService.nomineeAadhaarCardDetails.name = utilityService.getValue(customerDetails.nominees[0].name);
                    accountOpeningHomeService.nomineeAadhaarCardDetails.relationship = utilityService.getValue(customerDetails.nominees[0].relationship);
                    accountOpeningHomeService.nomineeAadhaarCardDetails.age = utilityService.getValue(customerDetails.nominees[0].age);
                    accountOpeningHomeService.nomineeAadhaarCardDetails.dob = utilityService.getValue(customerDetails.nominees[0].dob);
                    accountOpeningHomeService.nomineeAadhaarCardDetails.sameAsApplicantAddress = customerDetails.nominees[0].sameAsApplicantAddress;
                    if (!utilityService.isUndefined(customerDetails.nominees[0].address)) {
                        accountOpeningHomeService.nomineeAadhaarCardDetails.address1 = utilityService.getValue(customerDetails.nominees[0].address.addressLine1);
                        accountOpeningHomeService.nomineeAadhaarCardDetails.address2 = utilityService.getValue(customerDetails.nominees[0].address.addressLine2);
                        accountOpeningHomeService.nomineeAadhaarCardDetails.pc = utilityService.getValue(customerDetails.nominees[0].address.pincode);
                        accountOpeningHomeService.nomineeAadhaarCardDetails.dist = utilityService.getValue(customerDetails.nominees[0].address.city);
                        accountOpeningHomeService.nomineeAadhaarCardDetails.state = utilityService.getValue(customerDetails.nominees[0].address.state);
                        accountOpeningHomeService.nomineeAadhaarCardDetails.distCode = utilityService.getValue(customerDetails.nominees[0].address.cityCode);
                        accountOpeningHomeService.nomineeAadhaarCardDetails.stateCode = utilityService.getValue(customerDetails.nominees[0].address.stateCode);
                    }
                    if (!utilityService.isUndefined(customerDetails.nominees[0].guardian)){
                        accountOpeningHomeService.nomineeAadhaarCardDetails.guardianName = utilityService.getValue(customerDetails.nominees[0].guardian.name);
                        accountOpeningHomeService.nomineeAadhaarCardDetails.guardianAge = utilityService.getValue(customerDetails.nominees[0].guardian.guardianAge);
                    }

                } else if (accountOpeningHomeService.isNomineeScanned === false) {
                    accountOpeningHomeService.nominee.name = utilityService.getValue(customerDetails.nominees[0].name);
                    accountOpeningHomeService.nominee.relationship = utilityService.getValue(customerDetails.nominees[0].relationship);
                    accountOpeningHomeService.nominee.age = utilityService.getValue(customerDetails.nominees[0].age);
                    accountOpeningHomeService.nominee.sameAsApplicantAddress = customerDetails.nominees[0].sameAsApplicantAddress;
                    
                    if (!utilityService.isUndefined(customerDetails.nominees[0].address)) {
                        accountOpeningHomeService.nominee.address1 = utilityService.getValue(customerDetails.nominees[0].address.addressLine1);
                        accountOpeningHomeService.nominee.address2 = utilityService.getValue(customerDetails.nominees[0].address.addressLine2);
                        accountOpeningHomeService.nominee.pincode = utilityService.getValue(customerDetails.nominees[0].address.pincode);
                        accountOpeningHomeService.nominee.city = utilityService.getValue(customerDetails.nominees[0].address.city);
                        accountOpeningHomeService.nominee.state = utilityService.getValue(customerDetails.nominees[0].address.state);
                        accountOpeningHomeService.nominee.cityCode = utilityService.getValue(customerDetails.nominees[0].address.cityCode);
                        accountOpeningHomeService.nominee.stateCode = utilityService.getValue(customerDetails.nominees[0].address.stateCode);
                    }

                    accountOpeningHomeService.nominee.dob = utilityService.getValue(customerDetails.nominees[0].dob);
                    if (!utilityService.isUndefined(customerDetails.nominees[0].guardian)){
                        accountOpeningHomeService.nominee.guardianName = utilityService.getValue(customerDetails.nominees[0].guardian.name);
                        accountOpeningHomeService.nominee.guardianAge = utilityService.getValue(customerDetails.nominees[0].guardian.guardianAge);
                    }
                }

                if (!utilityService.isUndefined(customerDetails.nominees[0].guardian)) {
                    accountOpeningHomeService.nominee.guardianAddressFlag = utilityService.getValue(customerDetails.nominees[0].guardian.guardianAddressFlag);
                    if (!utilityService.isUndefined(accountOpeningHomeService.nominee.guardianAddressFlag)) {
                        accountOpeningHomeService.nomineeGuardianDetails.address1 = utilityService.getValue(customerDetails.nominees[0].guardian.address.addressLine1);
                        accountOpeningHomeService.nomineeGuardianDetails.address2 = utilityService.getValue(customerDetails.nominees[0].guardian.address.addressLine2);
                        accountOpeningHomeService.nomineeGuardianDetails.locality = utilityService.getValue(customerDetails.nominees[0].guardian.address.locality);
                        accountOpeningHomeService.nomineeGuardianDetails.city = utilityService.getValue(customerDetails.nominees[0].guardian.address.city);
                        accountOpeningHomeService.nomineeGuardianDetails.state = utilityService.getValue(customerDetails.nominees[0].guardian.address.state);
                        accountOpeningHomeService.nomineeGuardianDetails.cityCode = utilityService.getValue(customerDetails.nominees[0].guardian.address.cityCode);
                        accountOpeningHomeService.nomineeGuardianDetails.stateCode = utilityService.getValue(customerDetails.nominees[0].guardian.address.stateCode);
                        accountOpeningHomeService.nomineeGuardianDetails.pincode = utilityService.getValue(customerDetails.nominees[0].guardian.address.pincode);
                        accountOpeningHomeService.nomineeGuardianDetails.guardianConsent = customerDetails.nominees[0].guardian.guardianConsent;
                        //accountOpeningHomeService.nominee.guardianName = utilityService.getValue(customerDetails.nominees[0].guardian.name);
                        //accountOpeningHomeService.nominee.guardianAge = utilityService.getValue(customerDetails.nominees[0].guardian.guardianAge);
                    }
                }
            }
   
            if (!utilityService.isUndefined(customerDetails.homeBranch)) {
                accountOpeningHomeService.homeBranchLocalityCity = utilityService.getValue(customerDetails.homeBranch.city);
                accountOpeningHomeService.homeBranchLocalityId = utilityService.getValue(customerDetails.homeBranch.branchId);
            }

            if (!utilityService.isUndefined(accountOpeningHomeService.homeBranchLocalityCity)) {
                accountOpeningHomeService.isGpsClicked = false;
            } else if (utilityService.isUndefined(accountOpeningHomeService.homeBranchLocalityCity)) {
                accountOpeningHomeService.isGpsClicked = true;
            }

            accountOpeningHomeService.cardReadyForCollection = utilityService.getValue(customerDetails.cardReadyForCollection);
            accountOpeningHomeService.debitCardDetails.firstName = utilityService.getValue(customerDetails.debitCardFirstName);
            accountOpeningHomeService.debitCardDetails.lastName = utilityService.getValue(customerDetails.debitCardLastName);
            accountOpeningHomeService.customer.referenceCode = utilityService.getValue(customerDetails.refNo);
            accountOpeningHomeService.termsAndConditionsFlag = customerDetails.termsAndConditionsFlag;
            //accountOpeningHomeService.productOfferingFlag = customerDetails.productOfferingFlag;
			if(customerDetails.personalDetails.scannedCorrespondenceAddFlag){
							accountOpeningHomeService.isresumeCustManualCorresChkBox = customerDetails.personalDetails.scannedCorrespondenceAddFlag;
			}
			
			if(customerDetails.kyc){
				accountOpeningHomeService.kyc.docNo = utilityService.getValue(customerDetails.kyc.docNo);
				accountOpeningHomeService.kyc.expiryDate = utilityService.getValue(customerDetails.kyc.expiryDate);
				accountOpeningHomeService.kyc.issuedAt = utilityService.getValue(customerDetails.kyc.issuedAt);
				accountOpeningHomeService.kyc.issuedBy = utilityService.getValue(customerDetails.kyc.issuedBy);
				accountOpeningHomeService.kyc.issuedDate = utilityService.getValue(customerDetails.kyc.issuedDate);
				accountOpeningHomeService.kyc.type = utilityService.getValue(customerDetails.kyc.type);
			}
			if(customerDetails.doc){
			    for (var i = 0; i < customerDetails.doc.length; i++) {
                   if (customerDetails.doc[i].docType == "poa-firstCopy") {
                        accountOpeningHomeService.picIdFirstPage = customerDetails.doc[i].docRef;
                    }
                    if (customerDetails.doc[i].docType == "poa-secondCopy") {
                        accountOpeningHomeService.picIdSecondPage = customerDetails.doc[i].docRef;
                    }
                   }
            }
        }

        accountOpeningHomeService.getCommonId = function(commonId, flag){
   
            if(commonId == "OIOO" || commonId == "DebitCard" || commonId == "tncOtp"){
                accountOpeningHomeService.productOfferingFlag = flag;
            }
            else{
                accountOpeningHomeService.productOfferingFlag = true;
            }
        }
		
		 accountOpeningHomeService.setDateFormatDDMMYYY = function(data) {
            if(data){
            	data = data.replace(/-/g, '/');
            	data =data.replace(/\:/g, '/');
            	data =data.replace(/\./g, '/');
            	
            	data =data.replace(/ /g, '');
            	data =data.replace(/Jan/g, '01');
            	data =data.replace(/Feb/g, '02');
            	data =data.replace(/Mar/g, '03');
            	data =data.replace(/Apr/g, '04');
            	data =data.replace(/May/g, '05');
            	data =data.replace(/Jun/g, '06');
            	data =data.replace(/Jul/g, '07');
            	data =data.replace(/Aug/g, '08');
            	data =data.replace(/Sep/g, '09');
            	data =data.replace(/Oct/g, '10');
            	data =data.replace(/Nov/g, '11');
            	data =data.replace(/Dec/g, '12');
            }
            return data;
       };
       
    
	
      
	 accountOpeningHomeService.kyc = {}; 
	 accountOpeningHomeService.doc = {}; 	
	
     return accountOpeningHomeService;

    }
]);
