'use strict';

angularApp.service('appPasswordServiceAO',
    function($q, AdapterUtils, constantConfig) {
        var appPasswordService = this;
        
        appPasswordService.registerCustomer = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.registerCustomerOVD, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };

        appPasswordService.loadSecurityQuestions = function() {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getSecurityQuestions, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };
        return appPasswordService;

    });
