'use strict';

angularApp.controller('employerDetailsController',
	["$timeout", "$state", "$scope", "$translate", "$ionicSideMenuDelegate", "ionicToast", "$ionicScrollDelegate", "needHelpService", "utilityService", "$ionicSlideBoxDelegate", "loggedInUserService", "constantConfig", "cryptoService", "encryptionService", "AdapterUtils", "regProcessWithAccNoService", "ompMerchantsService", "preHomeLoginService", "$ionicPopup", "$sce", "employerDetailsService","instaService",
		function ($timeout, $state, $scope, $translate, $ionicSideMenuDelegate, ionicToast, $ionicScrollDelegate, needHelpService, utilityService, $ionicSlideBoxDelegate, loggedInUserService, constantConfig, cryptoService, encryptionService, AdapterUtils, regProcessWithAccNoService, ompMerchantsService, preHomeLoginService, $ionicPopup, $sce, employerDetailsService,instaService) {

			var employerDetailsVm = this;

			employerDetailsVm.showNext = true;
			
			

			employerDetailsVm.initPage = function () {
				
				employerDetailsVm.showDropdwn = false;
				employerDetailsVm.emp = "";
				employerDetailsVm.isChecked = instaService.employerNotListed;
				employerDetailsVm.nextBtn = true;
				employerDetailsVm.EmpConfDet = "Your salary package account is subject to verification of the documents by Bank official.";
				employerDetailsVm.empList = [];
				 employerDetailsVm.getEmployer();
				 employerDetailsVm.authoriseUser();
				
			}

			

			// employerDetailsVm.EmpConfDetData = function(){
			// 	employerDetailsVm.EmpConfDet = "Your salary package account is subject to varification of the documents by Bank Official.";
			// }

			
			employerDetailsVm.getEmployer = function () {
					if(employerDetailsVm.empList.length == 0){
						employerDetailsService.getEmployerList().then(function(body) {
							if(!utilityService.isUndefined(body)){
								for (var i = 0; i < body.length; i++) {
									employerDetailsVm.empList = body;
								}
							  } 

							}, function(error) {
								utilityService.showErrorMessage(error.responseMessage);
						});
					}
				}

				employerDetailsVm.showHidEemp = function() {
					if (!utilityService.isUndefined(employerDetailsVm.emp)) {
						employerDetailsVm.tEmpList = true;
						
					} 
				else {
						employerDetailsVm.tEmpList = false;
						
					}
				}


				employerDetailsVm.abortEmp = function(param) {
					employerDetailsVm.emp = param.description;
					instaService.emp = employerDetailsVm.emp;
					employerDetailsVm.empId = param.value;
					employerDetailsVm.tEmpList = false;
					employerDetailsVm.isChecked = false;
					employerDetailsVm.nextBtn = false;

				}


				employerDetailsVm.authoriseUser = function () {
				
					if(employerDetailsVm.isChecked){
						// if(employerDetailsVm.emp == ""){
						// 	employerDetailsVm.nextBtn = true;
						// }
						employerDetailsVm.isChecked = true;
						employerDetailsVm.emp = "";
						// employerDetailsVm.emp = "";
						// employerDetailsVm.isChecked = true;
						employerDetailsVm.nextBtn = false;
					}
					else{
						if(employerDetailsVm.emp !== ""){
							employerDetailsVm.nextBtn = false;
							employerDetailsVm.emp = instaService.emp;
						}
						employerDetailsVm.isChecked = false;
						//employerDetailsVm.emp = instaService.emp;
						employerDetailsVm.nextBtn = true;
					}
    			}


				employerDetailsVm.getEmplConf = function () {
				
				//instaService.journeyType =  constantConfig.acOpeningAdapterOVDConstant.salaryAcc;
					if(employerDetailsVm.isChecked){
						instaService.employerNotListed = employerDetailsVm.isChecked;
						instaService.journeyType = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
						$state.go("menu.instaKit_accountOpening");
					}else{
						instaService.journeyType =  constantConfig.acOpeningAdapterOVDConstant.salaryAcc;
						employerDetailsService.showAlertPopup("", employerDetailsVm.EmpConfDet, employerDetailsVm.EmpConfDet,
						"menu.instaKit_accountOpening", "OK", "", "", "");
					}
					
				}

				

				

			
				$scope.goToHome = function() {
					instaService.homeNav();
				}

				//one time initialization to be done when the controller is loaded
				$scope.$on('$ionicView.loaded', function () {
					$ionicSideMenuDelegate.canDragContent(false);
					//employerDetailsVm.EmpConfDetData();
					employerDetailsVm.initPage();
				});


				//actions to done everytime the view is shown
				$scope.$on('$ionicView.beforeEnter', function () {
					$ionicSideMenuDelegate.canDragContent(false);
					
				});

				//any cleanup needs to be done here: executes everytime when page is left
				$scope.$on('$ionicView.afterLeave', function () {
					$ionicSideMenuDelegate.canDragContent(false);
				});
		
		}]);
