'use strict';

angularApp.controller('enterOTPResumeAccountAOController', ["$state",
    "$scope",
    "$translate",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "customerInfoService",
    // "autoOtpReadService",
    "enterOTPAOService",
    "userLoginDetailsService",
    "loggedInUserService",
    "cryptoService",
    "encryptionService",
	"AdapterUtils",
	"accountOpeningHomeService",
	"additionalDetailsAOService",
	"nomineeDetailsAOService",
	"chequeBookServiceDetailsService",
	"currentAddressPDCService",
	"citizenshipDetailsAOService",
	"constantConfig",
    function($state,
        $scope,
        $translate,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        customerInfoService,
        // autoOtpReadService,
        enterOTPAOService,
        userLoginDetailsService,
        loggedInUserService,
        cryptoService,
        encryptionService,
		AdapterUtils,
		accountOpeningHomeService,
		additionalDetailsAOService,
		nomineeDetailsAOService,
		chequeBookServiceDetailsService,
		currentAddressPDCService,
		citizenshipDetailsAOService,
		constantConfig) {

        var enterOTPenterOTPResumeAccountAOVm = this;
        var isCustInfoAvailable = false;
        var isPageNavAvailable = false;

  		enterOTPenterOTPResumeAccountAOVm.isChallenged = false;
        enterOTPenterOTPResumeAccountAOVm.securityCheckName = "AOSecurityCheck";
        enterOTPenterOTPResumeAccountAOVm.aoAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(enterOTPenterOTPResumeAccountAOVm.securityCheckName);
        enterOTPenterOTPResumeAccountAOVm.aoAuthChallengeHandler.securityCheckName = enterOTPenterOTPResumeAccountAOVm.securityCheckName;


        function initPage() {
            enterOTPenterOTPResumeAccountAOVm.showBack = true;
            enterOTPenterOTPResumeAccountAOVm.showNext = true;
            enterOTPenterOTPResumeAccountAOVm.showOtpView = true;
            enterOTPenterOTPResumeAccountAOVm.otpvalue = "";
            enterOTPenterOTPResumeAccountAOVm.disableNext = true;
            enterOTPenterOTPResumeAccountAOVm.aofooter = true;
            //enterOTPenterOTPResumeAccountAOVm.requestOtpCall();
            //enterOTPenterOTPResumeAccountAOVm.isDisabledOTP = false;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                enterOTPenterOTPResumeAccountAOVm.okBtntext = translatedvalue;  
            });
            
        }

        enterOTPenterOTPResumeAccountAOVm.goBacktoPrevious = function() {
        	$state.go('menu.resumeAccountPageAO');
        }

       
        $scope.goToHome = function() {
			accountOpeningHomeService.homeNav();
        }

        enterOTPenterOTPResumeAccountAOVm.validateOTP = function(isValid) {
            enterOTPenterOTPResumeAccountAOVm.disableNext = !isValid;
        }

		enterOTPenterOTPResumeAccountAOVm.invokeGetOTPService = function () {
		            var requestParams = {
		                "id": userLoginDetailsService.mobile,
						"recipientMailId":  userLoginDetailsService.emailId ? userLoginDetailsService.emailId : "",
						"sendOTPFlg": "mobileOnly" 
		            }
		            enterOTPAOService.getOtp(requestParams).then(function (response) {
		             
		                //.customer.otpNo = utilityService.getValue(response.data.otp);
		                var title = '';
		                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
		                var onTap = '';
		                var buttontext = '<b>' + enterOTPenterOTPResumeAccountAOVm.okBtntext + '</b>';
						//utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
						

		                // if (utilityService.isAndroidPlatform()) {
						// 		autoOtpReadService.startOtpReading().then(function(result) {
						// 			enterOTPenterOTPResumeAccountAOVm.getOTPNumber = result;
						// 			enterOTPenterOTPResumeAccountAOVm.disableNext = false;
						// 		}, function(error) {
						// 		}, function(watchStatus) {
						// 		});
						// 	}


		
		                //enterOTPenterOTPResumeAccountAOVm.getOtpFromEmail(mobilenumber);
		            }, function (error) {
		                utilityService.showErrorMessage(error.responseMessage);
		            });
				}

				/* resend OTP */
				
				enterOTPenterOTPResumeAccountAOVm.requestOtpCallOnce = function() {
					//if(enterOTPenterOTPResumeAccountAOVm.isDisabledOTP){return true}
					enterOTPenterOTPResumeAccountAOVm.resendOtp();
					//enterOTPenterOTPResumeAccountAOVm.isDisabledOTP = true;
				};

				enterOTPenterOTPResumeAccountAOVm.resendOtp = function () {
		            var requestParams = {
		                "id": userLoginDetailsService.mobile,
						"recipientMailId":  userLoginDetailsService.emailId ? userLoginDetailsService.emailId : "",
						"sendOTPFlg": "mobileOnly" 
		            }
		            enterOTPAOService.getOtp(requestParams).then(function (response) {
		             
		                //.customer.otpNo = utilityService.getValue(response.data.otp);
		                var title = '';
		                var template = '{{"OTP_SENT_SUCCESS" | translate}}';
		                var onTap = '';
		                var buttontext = '<b>' + enterOTPenterOTPResumeAccountAOVm.okBtntext + '</b>';
						//utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
						


		                // if (utilityService.isAndroidPlatform()) {
						// 		autoOtpReadService.startOtpReading().then(function(result) {
						// 			enterOTPenterOTPResumeAccountAOVm.getOTPNumber = result;
						// 			enterOTPenterOTPResumeAccountAOVm.disableNext = false;
						// 		}, function(error) {
						// 		}, function(watchStatus) {
						// 		});
						// 	}



		
		                //enterOTPenterOTPResumeAccountAOVm.getOtpFromEmail(mobilenumber);
		            }, function (error) {
		                utilityService.showErrorMessage(error.responseMessage);
		            });
				}

				/* resend OTP END */


	      enterOTPenterOTPResumeAccountAOVm.goToNextPage = function () {
	            utilityService.showSpinner();
	            enterOTPenterOTPResumeAccountAOVm.aoAuthChallengeHandler.handleChallenge = function (challenge) {
	                enterOTPenterOTPResumeAccountAOVm.isChallenged = true;
	                utilityService.hideSpinner();
	                if (challenge.errorMsg !== null) {
	                    utilityService.showErrorMessage(utilityService.getServerExceptionMessage(challenge));
	                } else {
	                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
	                }
	            };
	
	            enterOTPenterOTPResumeAccountAOVm.aoAuthChallengeHandler.handleSuccess = function (data) {
	                utilityService.hideSpinner();
	                enterOTPenterOTPResumeAccountAOVm.isChallenged = false;
	                if (data.user) {
	                    loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
	                    loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
	                }
	            };
	
	            enterOTPenterOTPResumeAccountAOVm.aoAuthChallengeHandler.handleFailure = function (error) {
	                enterOTPenterOTPResumeAccountAOVm.aoAuthChallengeHandler.cancel();
	                enterOTPenterOTPResumeAccountAOVm.isChallenged = false;
	                utilityService.hideSpinner();
	                if (error.failure) {
	                    utilityService.showErrorMessage(error.failure);
	                } else {
	                    utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
	                }
	            }
	
	            var payload = {};
	            var requestParams = {
	                "mobileOTPKey": userLoginDetailsService.mobile,
	                "passOTPKey": enterOTPenterOTPResumeAccountAOVm.otpvalue,
					"mfDeviceId": loggedInUserService.deviceIdForMpin,
					"deviceId": device.uuid,
					"journeyName": enterOTPAOService.taxPage.journeyType,
				    "reqTimeStamp" : (new Date()).toString()
	            }
	            var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
	            payload = {
	                "data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
	                "src": src
	            }
	
	            payload = AdapterUtils.secretData == "" ? requestParams : payload;
	
	            if (enterOTPenterOTPResumeAccountAOVm.isChallenged) {
	                enterOTPenterOTPResumeAccountAOVm.aoAuthChallengeHandler.submitChallengeAnswer(payload);
	            } else {
	                WLAuthorizationManager.login(enterOTPenterOTPResumeAccountAOVm.aoAuthChallengeHandler.securityCheckName, payload).then(
	                    function (data) {
	                        utilityService.accessRestricted = utilityService.AOAuthRequired;
							//utilityService.hideSpinner();
							utilityService.showSpinner();
	                       enterOTPenterOTPResumeAccountAOVm.getPageDetails();
	                       enterOTPenterOTPResumeAccountAOVm.resumeDocument();
	                    },
	                    function (error) {
	                        utilityService.accessRestricted = "";
	                        utilityService.hideSpinner();
	                        if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
	                            return;
	                        }
	                        if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
	                            enterOTPenterOTPResumeAccountAOVm.aoAuthChallengeHandler.cancel();
	                        }
	                        utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
	                    });
	            }
	
	        }
	        
		        
		// enterOTPenterOTPResumeAccountAOVm.navigateToPage = function(response) {
		// 	// if(!data)
		// 	switch(response.payLoad.commonId) {
		// 		case "FatcaDetails":
		// 			if(enterOTPAOService.taxPage.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
		// 				$state.go('menu.aadhaarOption');
		// 			}else{
		// 				$state.go(response.payLoad.mobileURL);
		// 			}
		// 			//$state.go("menu.taxDetailsAO");
		// 			break;
		// 		case "proofOfAddress":
		// 			$state.go(response.payLoad.mobileURL);
		// 			//$state.go("menu.POCADetailsAO");
		// 			break;
		// 		case "personalDetails":
		// 			if(enterOTPAOService.taxPage.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
		// 				if("menu.currentAddressPDAO" == response.payLoad.mobileURL &&
		// 				chequeBookServiceDetailsService.isPasswordSet !== true && !currentAddressPDCService.isCustomerCorrespondenceAddressSet){
		// 				 $state.go("menu.aadhaarOption");
		// 				 }else if("menu.currentAddressPDAO" == response.payLoad.mobileURL &&
		// 		       chequeBookServiceDetailsService.isPasswordSet !== true){
		// 		    	$state.go("menu.tempLoginAO");
		// 		    	}else{
		// 					$state.go('menu.getPictureAO'); 
		// 				}
		// 			}else{
		// 				if("menu.currentAddressPDAO" == response.payLoad.mobileURL &&
		// 		       chequeBookServiceDetailsService.isPasswordSet !== true){
		// 		    	$state.go("menu.tempLoginAO");
		// 		    }else{
		// 		    	$state.go(response.payLoad.mobileURL);	
		// 		    }
		// 			}
					
		// 			//$state.go("menu.citizenshipDetailsAO");
		// 			break;
		// 		case "currentAddress":
		// 		if(enterOTPAOService.taxPage.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
		// 			if("menu.getPictureAO" == response.payLoad.mobileURL &&
		// 			chequeBookServiceDetailsService.isPasswordSet !== true){
		// 			$state.go("menu.tempLoginAO");
		// 			}else{
		// 				$state.go(response.payLoad.mobileURL);
		// 			}
		// 		}else{
		// 			$state.go(response.payLoad.mobileURL);
		// 		}				
		// 			//$state.go("menu.currentAddressPDAO");
		// 			break;
		// 		case "customerPhoto":
		// 			$state.go(response.payLoad.mobileURL);
		// 			//$state.go("menu.looksGreatAO");
		// 			break;
		// 		case "additionalDetails":
		// 			if (additionalDetailsAOService.activeAdditionalDetails.subOccupation) {
		// 				$state.go(response.payLoad.mobileURL);
		// 				//$state.go("menu.subOccupationServiceDetailsAO");
		// 			} else {
		// 				$state.go(response.payLoad.mobileURL);
		// 				//$state.go("menu.occupationDetailsAO");
		// 			}
		// 			break;
		// 		case "nomineeDetails":
		// 		if(nomineeDetailsAOService.nominee){
		// 			if(parseInt(nomineeDetailsAOService.nominee.age) > 18){
		// 				$state.go(response.payLoad.mobileURL);
		// 			}
		// 			else{
		// 				if(!nomineeDetailsAOService.nominee.guardianName && !nomineeDetailsAOService.nominee.guardianAge){
		// 					$state.go("menu.nomineeDetailsAO");
		// 				}
		// 				else{
		// 					$state.go("menu.nomineeDetailsAddressOptionAO");
		// 				}
		// 			}
		// 		}
				
					
		// 			//$state.go("menu.nomineeAddressDetailsAO");
		// 			break;
	
		// 		case "GuardianDetails":
		// 			if (nomineeDetailsAOService.nominee.guardianAddressFlag == "nomineeAddress") {
		// 				$state.go(response.payLoad.mobileURL);
		// 				//$state.go("menu.nomineeGuardianSameAddressAO");
		// 			} else if (nomineeDetailsAOService.nominee.guardianAddressFlag == "applicantAddress") {
		// 				$state.go(response.payLoad.mobileURL);
		// 				//$state.go("menu.guardianApplicantSameAddressAO");
		// 			} else if (nomineeDetailsAOService.nominee.guardianAddressFlag == "newAddress") {
		// 				$state.go(response.payLoad.mobileURL);
		// 				//$state.go("menu.nomineeEnterNewAddressAO");
		// 			}
		// 			break;
		// 		case "guardianDetails":
		// 			if (nomineeDetailsAOService.guardian.guardianAddressFlag == "nomineeAddress") {
		// 				$state.go(response.payLoad.mobileURL);
		// 				//$state.go("menu.nomineeGuardianSameAddressAO");
		// 			} else if (nomineeDetailsAOService.guardian.guardianAddressFlag == "applicantAddress") {
		// 				$state.go(response.payLoad.mobileURL);
		// 				//$state.go("menu.guardianApplicantSameAddressAO");
		// 			} else if (nomineeDetailsAOService.guardian.guardianAddressFlag == "newAddress") {
		// 				$state.go(response.payLoad.mobileURL);
		// 				//$state.go("menu.nomineeEnterNewAddressAO");
		// 			}
		// 			break;
		// 		case "servicesRequired":
		// 			$state.go(response.payLoad.mobileURL);
		// 			//$state.go("menu.chequeBookServiceDetailsAO");
		// 			break;
		// 		case "personalisedKit":
		// 			$state.go(response.payLoad.mobileURL);
		// 			//$state.go("menu.personalisedKitAO");
		// 			break;
		// 		case "customerTnC":
		// 			$state.go(response.payLoad.mobileURL);
		// 			//$state.go("menu.termsAndConditionsAO");
		// 			break;
		// 		case "productOffer":
		// 			$state.go(response.payLoad.mobileURL);
		// 			//$state.go("menu.productOfferingAO");
		// 			break;
		// 		case "RefNumber":
		// 			$state.go(response.payLoad.mobileURL);
		// 			//$state.go("menu.refPageAO");
		// 			break;
		// 		default:
		// 			$state.go(response.payLoad.mobileURL);
		// 	}
	
		// };

			enterOTPenterOTPResumeAccountAOVm.resumeDocument = function () {
				//var requestParams = {"id":userLoginDetailsService.mobile};
            	enterOTPAOService.resumeDocument(userLoginDetailsService.mobile).then(function (response) {
				utilityService.showSpinner();
                console.log(response);
                console.log("response============================>>");
                isPageNavAvailable = true;
                enterOTPAOService.resumeDocumentData = response;
               if(isCustInfoAvailable && isPageNavAvailable){
				   utilityService.hideSpinner();
				   if(enterOTPAOService.taxPage.journeyType){
						if(chequeBookServiceDetailsService.refNo){
							enterOTPAOService.navigateToPage(enterOTPAOService.resumeDocumentData);
						}else{
							$state.go('menu.applicationExists');
						}
				   }
                //enterOTPenterOTPResumeAccountAOVm.navigateToPage(enterOTPenterOTPResumeAccountAOVm.resumeDocumentData);
               }
               
            }, function (error) {
            	utilityService.hideSpinner();
                var title = '';
                var template = error.responseMessage;
                var onTap = '';
                var buttontext = '<b>' + enterOTPenterOTPResumeAccountAOVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }
	      enterOTPenterOTPResumeAccountAOVm.getPageDetails = function () {
            var requestParams = { "id" : userLoginDetailsService.mobile};
            enterOTPAOService.getCustomerDocument(requestParams).then(function (response) {
				utilityService.showSpinner();
                isCustInfoAvailable = true;
                enterOTPAOService.setResumeDocumentData(response.data);
                console.log(response);
				console.log("response  2  ============================>>");
                if(isPageNavAvailable && isCustInfoAvailable){
					utilityService.hideSpinner();
					if(enterOTPAOService.taxPage.journeyType){
							if(chequeBookServiceDetailsService.refNo){
								enterOTPAOService.navigateToPage(enterOTPAOService.resumeDocumentData);
							}else{
								$state.go('menu.applicationExists');
							}
					   }
                	//enterOTPenterOTPResumeAccountAOVm.navigateToPage(enterOTPenterOTPResumeAccountAOVm.resumeDocumentData);
                }

                

            }, function (error) {
            	utilityService.hideSpinner();
                var title = '';
                var template = error.responseMessage;
                var onTap = '';
                var buttontext = '<b>' + enterOTPenterOTPResumeAccountAOVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            });
        }

        enterOTPenterOTPResumeAccountAOVm.getCommonId = function (commonId, proFlag) {
            accountOpeningHomeService.getCommonId(commonId, proFlag);
        }
		
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            enterOTPenterOTPResumeAccountAOVm.invokeGetOTPService();
			enterOTPenterOTPResumeAccountAOVm.otpvalue = "";
        });

        return this;
    }
]);
