'use strict';

angularApp.service('enterOTPReferenceCodeAOService',
    function($q, AdapterUtils, constantConfig) {
        var enterOTPReferenceCodeAOService = this;

        //ref no. replacement from adapter added requestData
        
        enterOTPReferenceCodeAOService.getRefContent = function(requestData) {
            var q = $q.defer();
            var url = constantConfig.acOpeningAdapterOVDUrl.justStepOVD;
            
            AdapterUtils.postData(url, requestData,true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

		enterOTPReferenceCodeAOService.getReferenceNo = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.jTSixOpeningAdapterUrl.getRefNo, requestData,true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return enterOTPReferenceCodeAOService;
    });
