'use strict';

angularApp.controller('multipleCustomerAOController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
	"enterOTPAOService",
    "accountOpeningHomeService",
    "applicationExistsAOService",
    "utilityService",
    "userLoginDetailsService",
    "constantConfig",
    function($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        enterOTPAOService,
        accountOpeningHomeService,
        applicationExistsAOService,
        utilityService,
        userLoginDetailsService,
        constantConfig) {

        var multipleCustomerAOVm = this;

        function initPage() {
            multipleCustomerAOVm.showBack = true;
            multipleCustomerAOVm.showNext = false;
        }

        multipleCustomerAOVm.goBacktoPrevious = function() {
            //$state.go('menu.citizenshipDetailsAO');

            var requestParams = {
                "id" : userLoginDetailsService.mobile
            }

            applicationExistsAOService.removeCustomerDocument(requestParams).then(function(response) {
                applicationExistsAOService.journeyRedirectOption = constantConfig.acOpeningAdapterOVDConstant.digitalOVD;
				
				enterOTPAOService.clearResumeData();
                //$state.go('menu.ovdAadhaarSplitAO');
                $state.go('menu.homePageAO');
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        multipleCustomerAOVm.goToNextPage = function() {
            //$state.go('menu.aadhaarManualEntry');
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        multipleCustomerAOVm.displaymap = function() {
        	$state.go('menu.locateNearestBranchAO');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);   
        });
        
        return this;
    }
]);
