'use strict';

angularApp.controller('newToSbiLandingController',
	["$timeout", "$state", "$scope", "$translate", "$ionicSideMenuDelegate", "ionicToast", "$ionicScrollDelegate", "needHelpService", "utilityService", "$ionicSlideBoxDelegate", "loggedInUserService", "constantConfig", "cryptoService", "encryptionService", "AdapterUtils", "regProcessWithAccNoService", "ompMerchantsService", "preHomeLoginService", "$ionicPopup", "$sce", "newToSbiService","hlNTBCalculatorService","clNTBCalculatorService","instaService",
		function ($timeout, $state, $scope, $translate, $ionicSideMenuDelegate, ionicToast, $ionicScrollDelegate, needHelpService, utilityService, $ionicSlideBoxDelegate, loggedInUserService, constantConfig, cryptoService, encryptionService, AdapterUtils, regProcessWithAccNoService, ompMerchantsService, preHomeLoginService, $ionicPopup, $sce, newToSbiService,hlNTBCalculatorService,clNTBCalculatorService,instaService) {

			var newToSbiLandingVm = this;
			ompMerchantsService.NtbBestOfferClicked = false;

			newToSbiLandingVm.goBack = function () {
				$state.go('menu.landingWithOptions');
			}

			newToSbiLandingVm.openSavingsAccount = function () {
				$state.go('menu.openDSA');
			}
			newToSbiLandingVm.lanVideo = function(){
				instaService.journeyType = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
				var requestParams = {}
					newToSbiService.getInstaPlusDetailFn(requestParams).then(function (response) {
						newToSbiService.getInstaPlusDetail = response.data.getINSTAPlusDeatail;
						$state.go('menu.openDsaWithoutVisit');
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
			}

			// newToSbiLandingVm.withBranchVisit = function () {
			// 	$state.go('menu.homePageAO');
			// }

			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {
				$ionicSideMenuDelegate.canDragContent(false);
			});


			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {
				$ionicSideMenuDelegate.canDragContent(false);
			});

			//any cleanup needs to be done here: executes everytime when page is left
			$scope.$on('$ionicView.afterLeave', function () {
				$ionicSideMenuDelegate.canDragContent(false);
			});

			// for NTB HL journey
			newToSbiLandingVm.exploreHomeLoan = function () {
				hlNTBCalculatorService.isFromHamburger = false;
				hlNTBCalculatorService.isFromNTB = true;
				$state.go('menu.hlNTBExploreHomeLoan');
				if (!$scope.$$phase)
                $scope.$apply();
			}

			// for NTB Carloan journey
			newToSbiLandingVm.exploreCarLoan = function () {
				clNTBCalculatorService.isFromHamburger = false;
				clNTBCalculatorService.isFromNTB = true;
				$state.go('menu.clNTBExploreCarLoan');
			}
			
			//for FLPC Content
			newToSbiLandingVm.flpcLanding = function () {
				$state.go('menu.flpcLanding');
			};
			
			// for NTB best offers journey
			newToSbiLandingVm.goToBestOffers = function(){
				ompMerchantsService.NtbBestOfferClicked = true; 
				$state.go('menu.NTBBestOffer');
			}

			
		}]);
