'use strict';

angularApp.controller('openDSAController',
	["$timeout", "$state", "$scope", "$translate", "$ionicSideMenuDelegate", "ionicToast", "$ionicScrollDelegate", "needHelpService", "utilityService", "$ionicSlideBoxDelegate", "loggedInUserService", "constantConfig", "cryptoService", "encryptionService", "AdapterUtils", "regProcessWithAccNoService", "ompMerchantsService", "preHomeLoginService", "$ionicPopup", "$sce", "newToSbiService",
		function ($timeout, $state, $scope, $translate, $ionicSideMenuDelegate, ionicToast, $ionicScrollDelegate, needHelpService, utilityService, $ionicSlideBoxDelegate, loggedInUserService, constantConfig, cryptoService, encryptionService, AdapterUtils, regProcessWithAccNoService, ompMerchantsService, preHomeLoginService, $ionicPopup, $sce, newToSbiService) {

			var openDSAVm = this;


			openDSAVm.goBack = function () {
				if(ompMerchantsService.NtbBestOfferClicked){
					ompMerchantsService.NtbBestOfferClicked = false;
					$state.go('menu.NTBBestOffer');
				}else{
					$state.go('menu.newToSbiLanding');
				}
			}

			openDSAVm.withoutBranchVisit = function () {
				if (!newToSbiService.getInstaPlusDetail) {
					var requestParams = {}
					newToSbiService.getInstaPlusDetailFn(requestParams).then(function (response) {
						newToSbiService.getInstaPlusDetail = response.data.getINSTAPlusDeatail;
						$state.go('menu.openDsaWithoutVisit');
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}else{
					$state.go('menu.openDsaWithoutVisit');
				}

			}

			openDSAVm.withBranchVisit = function () {
				$state.go('menu.homePageAO');
			}

			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {
				$ionicSideMenuDelegate.canDragContent(false);
			});


			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {
				$ionicSideMenuDelegate.canDragContent(false);
			});

			//any cleanup needs to be done here: executes everytime when page is left
			$scope.$on('$ionicView.afterLeave', function () {
				$ionicSideMenuDelegate.canDragContent(false);
			});
		
		}]);
