'use strict';

angularApp.controller('openDsaWithoutVisitController',
	["$timeout", "$state", "$scope", "$translate", "$ionicSideMenuDelegate", "ionicToast", "$ionicScrollDelegate", "needHelpService", "utilityService", "$ionicSlideBoxDelegate", "loggedInUserService", "constantConfig", "cryptoService", "encryptionService", "AdapterUtils", "regProcessWithAccNoService", "ompMerchantsService", "preHomeLoginService", "$ionicPopup", "$sce", "instaService", "newToSbiService","employerDetailsService",
		function ($timeout, $state, $scope, $translate, $ionicSideMenuDelegate, ionicToast, $ionicScrollDelegate, needHelpService, utilityService, $ionicSlideBoxDelegate, loggedInUserService, constantConfig, cryptoService, encryptionService, AdapterUtils, regProcessWithAccNoService, ompMerchantsService, preHomeLoginService, $ionicPopup, $sce, instaService, newToSbiService, employerDetailsService) {

			var openDsaWithoutVisitVm = this;
			openDsaWithoutVisitVm.salaryAccSelected = false;
			openDsaWithoutVisitVm.savingAccSelected = false;


			openDsaWithoutVisitVm.goBack = function () {
				$state.go('menu.openDSA');
			}

			
			

			openDsaWithoutVisitVm.idsa = function () {
				instaService.journeyType = constantConfig.acOpeningAdapterOVDConstant.insta;

				var alertParams = {
					icon : true,
					message : "{{'LIMITED_KYC_INFO'| translate}}",
					buttonText : "Submit",
					redirectUrl : "menu.instaKit_applyNewOrResume"
				} 
				utilityService.customAlertPopup(alertParams);

			}

			openDsaWithoutVisitVm.authoriseUser = function(){
				if(openDsaWithoutVisitVm.isChecked){
					// openDsaWithoutVisitVm.disableNext = false;
					openDsaWithoutVisitVm.salaryAccSelected = true;
					openDsaWithoutVisitVm.savingAccSelected = false;
				}
				else{
					// openDsaWithoutVisitVm.disableNext = true;
					openDsaWithoutVisitVm.salaryAccSelected = false;
					openDsaWithoutVisitVm.savingAccSelected = true;
				}
        	}

			openDsaWithoutVisitVm.checkAccnt = function () {
				//newToSbiService.salAccnt = true;
				if(openDsaWithoutVisitVm.salaryAccSelected == true){
					instaService.journeyType =  constantConfig.acOpeningAdapterOVDConstant.salaryAcc;
					$state.go('menu.instaKit_applyNewOrResume');
				}else{
					instaService.journeyType = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
				    $state.go('menu.instaKit_applyNewOrResume');
				}
			}



			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {
				$ionicSideMenuDelegate.canDragContent(false);
			});


			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {
				$ionicSideMenuDelegate.canDragContent(false);
				openDsaWithoutVisitVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);
			});

			//any cleanup needs to be done here: executes everytime when page is left
			$scope.$on('$ionicView.afterLeave', function () {
				$ionicSideMenuDelegate.canDragContent(false);
			});


		}]);
