'use strict';

angularApp.controller('nomineeDetailsAOController', ["$state",
    "$scope",
    "utilityService",
    "nomineeDetailsRelatedAOService",
    "nomineeDetailsAOService",
    "$translate",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
	"userLoginDetailsService",
    "currentAddressPDCService",
    "accountOpeningHomeService",
    "additionalDetailsAOService",
    function($state,
        $scope,
        utilityService,
        nomineeDetailsRelatedAOService,
        nomineeDetailsAOService,
        $translate,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        currentAddressPDCService,
        accountOpeningHomeService,
        additionalDetailsAOService) {

        var nomineeDetailsAOVm = this;

        function initPage() {
            nomineeDetailsAOVm.showBack = true;
            nomineeDetailsAOVm.showNext = true;
            nomineeDetailsAOVm.nomineeAge;
            nomineeDetailsAOVm.dob;
            nomineeDetailsAOVm.nomineeGuardianName = "";
            nomineeDetailsAOVm.guardianAge = "";
            nomineeDetailsAOVm.aofooter = true;
            nomineeDetailsAOVm.invalid = false;
            nomineeDetailsAOVm.properDate = false;
            nomineeDetailsAOService.nomineeNav = "nomineedetails";
            nomineeDetailsAOVm.validCityState = false;
            nomineeDetailsAOVm.isAddress1Modified = false;
            nomineeDetailsAOVm.isAddress2Modified = false;
            nomineeDetailsAOVm.isCityModified = false;
            nomineeDetailsAOVm.isStateModified = false;
            nomineeDetailsAOVm.isPincodeModified = false;
            nomineeDetailsAOVm.disableAddress1 = false;
            nomineeDetailsAOVm.disableAddress2 = false;
            nomineeDetailsAOVm.disableCity = true;
            nomineeDetailsAOVm.disablePincode = false;
            nomineeDetailsAOVm.disableState = true;
            nomineeDetailsAOVm.nomineeStateShow=true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                nomineeDetailsAOVm.okBtntext = translatedvalue;
            });
        }

        nomineeDetailsAOVm.goBacktoPrevious = function() {
                nomineeDetailsAOService.nominee.name = nomineeDetailsAOVm.nomineeName;
                nomineeDetailsAOService.nominee.guardianName = nomineeDetailsAOVm.nomineeGuardianName;
                nomineeDetailsAOService.nominee.guardianAge = nomineeDetailsAOVm.guardianAge;
                nomineeDetailsAOService.nominee.relationship = nomineeDetailsAOVm.nomineeRelationship;
                nomineeDetailsAOService.nominee.dob = nomineeDetailsAOVm.dob;
                
            	// if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0001"){
                //     $state.go("menu.subOccupationServiceDetailsAO");
                //     }
                //     else if(additionalDetailsAOService.activeAdditionalDetails.occupation == "0002"){
                //         $state.go("menu.subOccupationOthersDetailsAO");
				//     }
                //     else{
				//     	$state.go("menu.occupationDetailsAO");	
                //     }
                
                //$state.go("menu.optionalAdditionalDetails");
                $state.go("menu.annualIncomeNew");

        }



        $scope.goToHome = function() {
            //nomineeDetailsAOService.homeNav();
            accountOpeningHomeService.homeNav();
        }


        nomineeDetailsAOVm.goNext = function() {
					nomineeDetailsAOService.nominee.name = nomineeDetailsAOVm.nomineeName;
                    nomineeDetailsAOService.nominee.relationship = nomineeDetailsAOVm.nomineeRelationship;
                    nomineeDetailsAOService.nominee.age = nomineeDetailsAOVm.nomineeAge;
                    nomineeDetailsAOService.nominee.dob = nomineeDetailsAOVm.dob;
                    nomineeDetailsAOService.nominee.guardianName = nomineeDetailsAOVm.nomineeGuardianName;
                    nomineeDetailsAOService.nominee.guardianAge = nomineeDetailsAOVm.guardianAge;
                	$state.go("menu.nomineeAddressDetailsAO");
                
            };


        /* Display Nominee details after scan or manual entry */
        nomineeDetailsAOVm.displayNomineeAdharDetails = function() {
                nomineeDetailsAOVm.nomineeName = nomineeDetailsAOService.nominee.name;
                nomineeDetailsAOVm.nomineeGuardianName = nomineeDetailsAOService.nominee.guardianName;
                nomineeDetailsAOVm.guardianAge = nomineeDetailsAOService.nominee.guardianAge;
                nomineeDetailsAOVm.nomineeRelationship = nomineeDetailsAOService.nominee.relationship;
                nomineeDetailsAOVm.dob = nomineeDetailsAOService.nominee.dob;
                nomineeDetailsAOVm.addressAboveData = nomineeDetailsAOService.nominee.address1;
                nomineeDetailsAOVm.addressBelowData = nomineeDetailsAOService.nominee.address2;
                nomineeDetailsAOVm.applicantChecked = nomineeDetailsAOService.nominee.sameAsApplicantAddress;
                if(!utilityService.isUndefined(nomineeDetailsAOService.nominee.pincode))
                nomineeDetailsAOVm.pincodeData = parseInt(nomineeDetailsAOService.nominee.pincode);
                nomineeDetailsAOVm.cityData = nomineeDetailsAOService.nominee.city;
                nomineeDetailsAOVm.stateData = nomineeDetailsAOService.nominee.state;
            

        }

        /* Method to calculate age */
        nomineeDetailsAOVm.calculateAge = function() {
            var todayDateAge = new Date();
            var bornNewDate = new Date(nomineeDetailsAOVm.nomineeDobYear, nomineeDetailsAOVm.nomineeDobMonth - 1, nomineeDetailsAOVm.nomineeDobDay);
            var age = Math.floor((todayDateAge.getTime() - bornNewDate.getTime()) / (365.25 * 24 * 60 * 60 * 1000));
            return age;
        }

       
        nomineeDetailsAOVm.populateDobAadhaar = function(dateValue) {
            if (utilityService.isUndefined(nomineeDetailsAOVm.nomineeDobYear) || utilityService.isUndefined(nomineeDetailsAOVm.nomineeDobMonth) || utilityService.isUndefined(nomineeDetailsAOVm.nomineeDobDay)) {
                if (!utilityService.isUndefined(dateValue)) {
                    dateValue = moment(dateValue, ["DD/MM/YYYY", "MM/DD/YYYY", "DD-MM-YYYY", "MM-DD-YYYY", "YYYY-MM-DD", "YYYY-DD-MM","YYYY/MM/DD", "YYYY/DD/MM"]);
                    var dateFormat = new Date(dateValue);
                    var day = dateFormat.getDate();
                    var month = dateFormat.getMonth() + 1;
                    var year = dateFormat.getFullYear();
                    var formattedDate = day.toString();
                    if (formattedDate.length == 1) {
                        formattedDate = "0" + formattedDate;
                        nomineeDetailsAOVm.nomineeDobDay = formattedDate;
                    } else {
                        nomineeDetailsAOVm.nomineeDobDay = parseInt(day);
                    }
                    var formattedMonth = month.toString();
                    if (formattedMonth.length == 1) {
                        formattedMonth = "0" + formattedMonth;
                        nomineeDetailsAOVm.nomineeDobMonth = formattedMonth;
                    } else {
                        nomineeDetailsAOVm.nomineeDobMonth = parseInt(month);
                    }
                    nomineeDetailsAOVm.nomineeDobYear = parseInt(year);
                    var fullDate = nomineeDetailsAOVm.nomineeDobMonth + '-' + nomineeDetailsAOVm.nomineeDobDay + '-' + nomineeDetailsAOVm.nomineeDobYear;

                    var formattedNewDate = new Date();
                    formattedNewDate.setFullYear(nomineeDetailsAOVm.nomineeDobYear, nomineeDetailsAOVm.nomineeDobMonth - 1, nomineeDetailsAOVm.nomineeDobDay);

                    var todayDate = new Date();
                    var currentYear = todayDate.getFullYear();
                    var validYear = todayDate.setFullYear(currentYear - constantConfig.acOp.nomineeAge);
                    nomineeDetailsAOVm.nomineeAge = nomineeDetailsAOVm.calculateAge();


                } else if (!utilityService.isUndefined(nomineeDetailsAOService.nomineeAadhaarCardDetails.yob) && utilityService.isUndefined(nomineeDetailsAOService.nomineeAadhaarCardDetails.dob)) {
                    nomineeDetailsAOVm.nomineeDobDay = "";
                    nomineeDetailsAOVm.nomineeDobMonth = "";
                    nomineeDetailsAOVm.nomineeDobYear = parseInt(nomineeDetailsAOService.nomineeAadhaarCardDetails.yob);
                }
            }
        }


        nomineeDetailsAOVm.validateInputs = function(isValid) {
            if (nomineeDetailsAOVm.validDate === true && isValid === true) {
                nomineeDetailsAOVm.disableNext = !isValid;
            } else if (nomineeDetailsAOVm.validDate === true && isValid === false) {
                nomineeDetailsAOVm.disableNext = true;
            } else if (nomineeDetailsAOVm.validDate === false && isValid === false) {
                nomineeDetailsAOVm.disableNext = true;
            }
            return nomineeDetailsAOVm.disableNext;
        }

        /* Date Validation */
        nomineeDetailsAOVm.dateValidation = function(isValid) {
            var fullDate = nomineeDetailsAOVm.nomineeDobMonth + '/' + nomineeDetailsAOVm.nomineeDobDay + '/' + nomineeDetailsAOVm.nomineeDobYear;
            var dobMonth = nomineeDetailsAOVm.nomineeDobMonth;
            var dobDay = nomineeDetailsAOVm.nomineeDobDay;
            var dobYr = nomineeDetailsAOVm.nomineeDobYear;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            var formattedDateYr = formattedDate.getFullYear();
            var currDate = new Date();
            var curYear = currDate.getFullYear();
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ["04", "06", "09", "11", "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            if (fullDateInMilliSeconds > curDateInMilliSeconds) {
                nomineeDetailsAOVm.disableNext = true;
                nomineeDetailsAOVm.invalid = true;
                nomineeDetailsAOVm.properDate = false;
            } else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if (dobMonth == 2 && dobDay > 29) {
                    nomineeDetailsAOVm.disableNext = true;
                    nomineeDetailsAOVm.invalid = true;
                    nomineeDetailsAOVm.properDate = false;
                } else if (monthIndex != -1 && dobDay == 31) {
                    nomineeDetailsAOVm.disableNext = true;
                    nomineeDetailsAOVm.invalid = true;
                    nomineeDetailsAOVm.properDate = false;
                } else {
                    nomineeDetailsAOVm.disableNext = !isValid;
                    nomineeDetailsAOVm.invalid = false;
                    nomineeDetailsAOVm.properDate = true;
                }

            } else if (dobMonth == 2 && dobDay >= 29) {
                nomineeDetailsAOVm.disableNext = true;
                nomineeDetailsAOVm.invalid = true;
                nomineeDetailsAOVm.properDate = false;
            } else if (monthIndex != -1 && dobDay == 31) {
                nomineeDetailsAOVm.disableNext = true;
                nomineeDetailsAOVm.invalid = true;
                nomineeDetailsAOVm.properDate = false;

            } else {
                nomineeDetailsAOVm.disableNext = !isValid;
                nomineeDetailsAOVm.invalid = false;
                nomineeDetailsAOVm.properDate = true;

            }
             if(dobDay  < 10  && dobDay.length == 1 ){
            	nomineeDetailsAOVm.disableNext = true;
                nomineeDetailsAOVm.invalid = true;
                nomineeDetailsAOVm.properDate = false;
            }
            if(dobMonth  < 10 && dobMonth.length == 1 ){
            	nomineeDetailsAOVm.disableNext = true;
                nomineeDetailsAOVm.invalid = true;
                nomineeDetailsAOVm.properDate = false;
            }
            return nomineeDetailsAOVm.properDate; 
        }

        /* Date Validation */
        nomineeDetailsAOVm.checkValidDate = function(isValid) {

            nomineeDetailsAOVm.validDateFormat = nomineeDetailsAOVm.dateValidation();

            if (nomineeDetailsAOVm.validDateFormat == true) {
                var fullDate = nomineeDetailsAOVm.nomineeDobMonth + '/' + nomineeDetailsAOVm.nomineeDobDay + '/' + nomineeDetailsAOVm.nomineeDobYear;
                var dateDMY = nomineeDetailsAOVm.nomineeDobDay + '-' + nomineeDetailsAOVm.nomineeDobMonth + '-' + nomineeDetailsAOVm.nomineeDobYear;
                var formattedDate = new Date();
                formattedDate.setFullYear(nomineeDetailsAOVm.nomineeDobYear, nomineeDetailsAOVm.nomineeDobMonth - 1, nomineeDetailsAOVm.nomineeDobDay);
                var todayDate = new Date();
                var currentYear = todayDate.getFullYear();
                var validYear = todayDate.setFullYear(currentYear - constantConfig.acOp.nomineeAge);
                nomineeDetailsAOVm.nomineeAge = nomineeDetailsAOVm.calculateAge();

                nomineeDetailsAOVm.dob = dateDMY;
                if (isNaN(nomineeDetailsAOVm.nomineeAge) === false && nomineeDetailsAOVm.nomineeAge >= constantConfig.acOp.nomineeAge || nomineeDetailsAOVm.nomineeAge < constantConfig.acOp.nomineeAge) {
                    nomineeDetailsAOVm.validDate = true;
                } else if (isNaN(nomineeDetailsAOVm.nomineeAge) === true) {
                    nomineeDetailsAOVm.validDate = false;
                }
                if (nomineeDetailsAOVm.validDate === true && isValid === true) {
                    nomineeDetailsAOVm.disableNext = false;
                } else if (nomineeDetailsAOVm.validDate === false && isValid === false) {
                    nomineeDetailsAOVm.disableNext = true;
                } else if (nomineeDetailsAOVm.validDate === true && isValid === false) {
                    nomineeDetailsAOVm.disableNext = true;
                }

            } else if (nomineeDetailsAOVm.validDateFormat === false) {
                nomineeDetailsAOVm.disableNext = true;
            }
            return nomineeDetailsAOVm.disableNext;
        }

        nomineeDetailsAOVm.checkGuardian = function() {
            var required = false;

            if (isNaN(nomineeDetailsAOVm.nomineeAge) === false && !utilityService.isUndefined(nomineeDetailsAOVm.nomineeAge)) {
                if (nomineeDetailsAOVm.nomineeAge >= constantConfig.acOp.nomineeAge) {
                    required = false;
                } else {
                    required = true;
                }
            }
            return required;
        }

        nomineeDetailsAOVm.disableGuardian = function() {
            var disable = true;
            if (isNaN(nomineeDetailsAOVm.nomineeAge) === false && !utilityService.isUndefined(nomineeDetailsAOVm.nomineeAge)) {
                if (nomineeDetailsAOVm.nomineeAge >= constantConfig.acOp.nomineeAge) {
                    disable = true;
                    nomineeDetailsAOVm.nomineeGuardianName = "";
                    nomineeDetailsAOVm.guardianAge = "";
                } else {
                    disable = false;
                }
            }
            return disable;
        }

        $scope.ageAbove18Pattern = (function() {
            var regexp = /^(1[89]|[2-9][0-9])$/;
            return {
                test: function(value) {
                    if (nomineeDetailsAOVm.checkGuardian() === false) {
                        return true;
                    }
                    return regexp.test(value);
                }
            };
        })();

        $scope.namePattern = (function() {
            var regexp = /^([ \.]?[a-zA-Z]+)+$/;
            return {
                test: function(value) {
                    if (nomineeDetailsAOVm.checkGuardian() === false) {
                        return true;
                    }
                    return regexp.test(value);
                }
            };
        })();



        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
        	if(!nomineeDetailsAOService.nominee){
        		nomineeDetailsAOService.nominee = {};
        	}
        	if(!nomineeDetailsAOService.nomineeAadhaarCardDetails){
        		nomineeDetailsAOService.nomineeAadhaarCardDetails = {};
        	}
            nomineeDetailsAOVm.showBack = true;
            nomineeDetailsAOVm.showNext = true;
            nomineeDetailsAOVm.isAddress1 = false;
            nomineeDetailsAOVm.isAddress2 = false;
            nomineeDetailsAOVm.validDateFormat = false;
            nomineeDetailsAOVm.isMName = false;
            nomineeDetailsAOVm.isNomineeScanned = nomineeDetailsAOService.isNomineeScanned;
            
            nomineeDetailsAOVm.displayNomineeAdharDetails();

               nomineeDetailsAOVm.nomineeAge = nomineeDetailsAOService.nominee.age;
                nomineeDetailsAOVm.populateDobAadhaar(nomineeDetailsAOService.nominee.dob);
            //}
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            nomineeDetailsAOVm.checkValidDate(true);
        });

        return this;
    }
]);
