'use strict';

angularApp.service('aadhaarAddressService',
    function($q, AdapterUtils, constantConfig) {
        var aadhaarAddressService = this;
        aadhaarAddressService.updateAadhaarDetails = function(requestParams) {
            var q = $q.defer(); 

            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.adharcard, requestParams, true).then(
                function(response){ 
                    q.resolve(response);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return aadhaarAddressService;
}); 