
'use strict';

angularApp.service('currentAddressPDCService',
    function($q, AdapterUtils, constantConfig) {
        var currentAddressPDCService = this;

         currentAddressPDCService.getCustomerDetails = function(requestData) {
            
            var q = $q.defer();
           
           AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.customerDocumentOVD, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };
        
        
        currentAddressPDCService.savePersonalDetailsOVD = function(requestData) {
            
            var q = $q.defer();
           
           AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.updateCorrespondenceAddressOVD, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };
        
         currentAddressPDCService.getAreaDetailForPincode = function(requestData) {
            var q = $q.defer();
           AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.getPostalDetailByPinCodeOVD, requestData, true).then(
				 function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        
        currentAddressPDCService.updateCorrespondenceAddress = function(requestData) {
            var q = $q.defer();
             AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.updateCorrespondenceAddress,requestData, true).then(
                function(response) {
                    q.resolve(response);
                },
               function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
            
        return currentAddressPDCService;
    });