'use strict';

angularApp.controller('resemblanceAOController', ["$state",
    "$scope",
    "$translate",
    "utilityService",
    "$ionicSideMenuDelegate",
    "accountOpeningHomeService",
       function($state,
        $scope,
        $translate,
        utilityService,
        $ionicSideMenuDelegate,
        accountOpeningHomeService) {

        var resemblanceAOVm = this;

        resemblanceAOVm.showBack = true;
        resemblanceAOVm.showNext = false;
        resemblanceAOVm.aofooter = true;

        function initPage() {
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                resemblanceAOVm.okBtntext = translatedvalue;  
            });
        }

        resemblanceAOVm.goBacktoPrevious = function() {
            $state.go('menu.aadharScanAddress');
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        resemblanceAOVm.goToNextPage = function() {
            //$state.go('menu.takeSelfieAO');
        }

        resemblanceAOVm.openWithOvd = function(){
            $state.go('menu.homePageAO');
        }

        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
       //     $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        
        return this;
    }
]);
