'use strict';

angularApp.service('knowMoreAOService',
    function($q, AdapterUtils, constantConfig) {
        var knowMoreAOService = this;
        knowMoreAOService.productKnowMore = function() {
            var q = $q.defer();

            //Get product features additional information
            AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.getProductFeaturesKnowMoreOVD, true).then(

                function(response) {
                    q.resolve(response.data.productFeaturesKnowMore);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return knowMoreAOService;
    });