'use strict';

angularApp.service('productInformationService',
    function($q, AdapterUtils, constantConfig) {
        var productInformationService = this;

       productInformationService.getProductFeatures = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.getProductFeaturesOVD, requestData, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };  
        
        
         productInformationService.knowmoreLinkFeatures = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.getProductFeaturesKnowMoreOVD, requestData, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };  
	
       return productInformationService;

    }
);
