'use strict';

angularApp.service('tempLoginServiceAO',
    function($q, AdapterUtils, constantConfig) {
        var tempLoginServiceAO = this;

        tempLoginServiceAO.checkInbUser = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.checkUserAvailability, requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        tempLoginServiceAO.saveInbUser = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.registerCustomerInINB, requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        tempLoginServiceAO.getUsernamePasswordFormat = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.getUsernamePasswordFormat, requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return tempLoginServiceAO;
    });
