
'use strict';

angularApp.service('userLoginDetailsService',
    function($q, AdapterUtils, constantConfig) {
        var userLoginDetailsService = this;

         userLoginDetailsService.getCustomerDetails = function(requestData) {
            
            var q = $q.defer();
           
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.customerDocumentCheckOVD, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };


        userLoginDetailsService.getFeatureComparison = function() {
			var q = $q.defer();
			//AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getFeatureComparison, true).then(function(response) {
                AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.getPolicyContentOVD, true).then(function(response) {
				q.resolve(response.data);
			}, function(error) {
				q.reject(error);
			});
			return q.promise;
		};

        return userLoginDetailsService;
    });
