'use strict';

angularApp.controller('otherBankTransactionsController', ["$state",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$ionicPlatform",
    "$scope",
    "$interval",
    "$filter",
    "$timeout",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicPopup",
    "accountOverviewService",

    function ($state,
        $rootScope,
        utilityService,
        constantConfig,
        $ionicPlatform,
        $scope,
        $interval,
        $filter,
        $timeout,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicPopup,
        accountOverviewService) {

        var otherBankTransactionsVm = this;

        otherBankTransactionsVm.goBack = function () {
            $state.go('menu.accountOverviewMyBalance');
        }

        otherBankTransactionsVm.toggleCollectOptions = function (collectOption) {
            if (collectOption == 'TRANSHISTORY') {
                otherBankTransactionsVm.transactionType = 'TRANSHISTORY';
                otherBankTransactionsVm.classForTransactionOpt = 'tab-item tabs-style div-bottom bor-bot-active';
                otherBankTransactionsVm.classForSpendAnOpt = 'tab-item tabs-style div-bottom';
            }
            if (collectOption == 'SPENDANALISYS') {
                otherBankTransactionsVm.transactionType = 'SPENDANALYSIS';
                otherBankTransactionsVm.classForTransactionOpt = 'tab-item tabs-style div-bottom';
                otherBankTransactionsVm.classForSpendAnOpt = 'tab-item tabs-style div-bottom bor-bot-active';
            }
        };

        $scope.$on('$ionicView.beforeEnter', function () {
            otherBankTransactionsVm.transactionType = 'TRANSHISTORY';
            otherBankTransactionsVm.classForTransactionOpt = 'tab-item tabs-style div-bottom bor-bot-active';
            otherBankTransactionsVm.classForSpendAnOpt = 'tab-item tabs-style div-bottom';

            otherBankTransactionsVm.transactionDetails = accountOverviewService.transactionDetails;
        });

    }
]);
