angularApp.service('mutualFundsService',
	function ($q, AdapterUtils, $translate, getAccountDetailsService,loggedInUserService) {
		var mutualFundsService = this;
		var fundDetailsObj = '';
		var fundListObj = '';
		var checkAllStatusObj = '';
		var userDetailsObj = '';
		var accountFetchFlag = '';
		var accountList;
		var fundToInvestObj = '';
		var folioToInvestObj = '';
		var accountDetailsInOpenAc = '';
		var pageIdForMf = '';
		var InfoList = '';
		var ekycInfoList = '';
		var videoList = '';
		var multiFolio = '';
		var AOFAllData = '';
		var riskProfileData = '';
		var calculatedKey;
		var amountforInvest = '';
		var accountListData = '';
		var userPanDetails = '';
		var newFundDetails ='';
		var kycPanDetails = '';
		var addTotalvalue = '';
		var addTotalSecuritiesvalue = '';
		var mostTrendingFunds;
		var taxSaverFunds;
		mutualFundsService.finalReqObj = '';

		mutualFundsService.getTermsAndConditions = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getTermsAndConditionsorDisclaimer", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		
		//prelogin termsncondition api 
		mutualFundsService.getTermsAndConditionsPre = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/getTermsAndConditionsorDisclaimer", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};


		mutualFundsService.getEkycTermsAndConditions = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getEkycContent", true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};


		/******Get video list from service start*****/
		mutualFundsService.getVideoList = function () {
			var reqParams = {};
			var q = $q.defer();

			AdapterUtils.postData("adapters/MutualFundAdapter/getAssistVideo", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		mutualFundsService.addTotalMyInvetmentAmount = function (amt) {
			addTotalvalue = amt;
		}
		mutualFundsService.getTotalMyInvetmentAmount = function () {
			return addTotalvalue;
		}
		mutualFundsService.addTotalSecurities = function (amt) {
			addTotalSecuritiesvalue = amt;
		}
		mutualFundsService.getTotalSecurities = function () {
			return addTotalSecuritiesvalue;
		}

		/******video list function end*****/

		/******Get city list from service start*****/
		mutualFundsService.getCity = function () {

			var q = $q.defer();

			AdapterUtils.getData("adapters/MutualFundAdapter/getLocationDetails", true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};


		/******city list function end*****/

		/******Get state list from service start*****/
		mutualFundsService.getState = function () {

			var q = $q.defer();

			AdapterUtils.getData("adapters/MutualFundAdapter/getStateDetails", true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******state list function end*****/

		/******Get occupation list from service start*****/
		mutualFundsService.getOccupation = function () {

			var q = $q.defer();

			AdapterUtils.getData("adapters/MutualFundAdapter/getFatcaOccupationDetails", true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******occupation list function end*****/

		/******Get FATCA occupation list from service start*****/
		mutualFundsService.getFATCAOccupation = function () {

			var q = $q.defer();

			AdapterUtils.getData("adapters/MutualFundAdapter/getFatcaOccupationDetails", true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******occupation list function end*****/

		/******Get Country list from service start*****/
		mutualFundsService.getCountry = function () {

			var q = $q.defer();

			AdapterUtils.getData("adapters/MutualFundAdapter/getCountryDetails", true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******Country list function end*****/

		/******Get getTaxStatus list from service start*****/
		mutualFundsService.getTaxStatus = function () {

			var q = $q.defer();

			AdapterUtils.getData("adapters/MutualFundAdapter/getTaxStatusDetails", true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******getTaxStatus list function end*****/

		/******Get getGrossIncomeList list from service start*****/
		mutualFundsService.getGrossIncomeList = function () {

			var q = $q.defer();

			AdapterUtils.getData("adapters/MutualFundAdapter/getFatcaAppIncomeDetails", true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******Country list function end*****/

		/******Get Risk profile function start*****/
		mutualFundsService.getRiskProfileQA = function () {
			var reqParams = {};
			var q = $q.defer();

			AdapterUtils.postData("adapters/MutualFundAdapter/getRiskProfileQuestion", reqParams, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/******Risk profile function end*****/

		//pre login question
		mutualFundsService.getRiskProfileQAPre = function () {
			var reqParams = {};
			var q = $q.defer();

			AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/getRiskProfileQuestion", reqParams, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******Get User profile function start*****/
		mutualFundsService.getUserProfile = function (reqParams) {

			var q = $q.defer();

			AdapterUtils.postData("adapters/MutualFundAdapter/getUserProfile", reqParams, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/******Risk profile function end*****/

		//for prelogin 
		mutualFundsService.getGoalPlanPre = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/getInflationOfGoals", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};


		/******Get Goal plan profile function start*****/
		mutualFundsService.getGoalPlan = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getInflationOfGoals", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/******Goal plan function end*****/

		//for prelogin setgoalplan
		mutualFundsService.getGoalPlanListPre = function () {
			var q = $q.defer();
			var reqParams = {};
			AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/getGoalPlanList", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******Get Goal plan list profile function start*****/
		mutualFundsService.getGoalPlanList = function () {
			var q = $q.defer();
			var reqParams = {};
			AdapterUtils.postData("adapters/MutualFundAdapter/getGoalPlanList", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/******Goal plan list function end*****/

		//get suggestion for prelogin
		mutualFundsService.getSuggestionPre = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/getSuggestion", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******Get Goal Suggestion function start*****/
		mutualFundsService.getSuggestion = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getSuggestion", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/******Goal Suggestion  function end*****/

		//for prelogin setRiskProfileQuestion
		mutualFundsService.setRiskProfileQuesPre = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/setRiskProfileQuestion", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******set Risk Profile Questions  start*****/
		mutualFundsService.setRiskProfileQues = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/setRiskProfileQuestion", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/******Risk Profile Questions  end*****/
		
		//for prelogin
		mutualFundsService.getAllMutualFundsPre = function () {
		var reqParams = {};					
			var reqParams = {
                    "isNFORequest": "Y"
                };
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/getAllMutualFunds",reqParams , true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******get mutualFunds  start*****/
		mutualFundsService.getAllMutualFunds = function () {
		var reqParams = {};					
			var reqParams = {
                    "isNFORequest": "Y"
                };
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getAllMutualFunds",reqParams , true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/****** mutualFunds list  end*****/

		/******get mutualFunds PreLogin  start*****/
		mutualFundsService.getAllMutualFundsPreLogin = function () {
		var reqParams = {};					
			var reqParams = {
                    "isNFORequest": "Y"
                };
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/getAllMutualFunds",reqParams , true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/****** mutualFunds list  end*****/

		/******::START:: GET MF POPULAR FUNDS IMAGES*****/
		mutualFundsService.GetMFPopularImageResponse = function (reqParams) {
			var reqParams = {};
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getPopularFundImage", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/******::END:: GET MF POPULAR FUNDS IMAGES*****/

		/******get FrequencyDetails  start*****/
		mutualFundsService.getFrequercyDetails = function () {
			var q = $q.defer();
			AdapterUtils.getData("adapters/MutualFundAdapter/getFrequencyDetails", true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/****** get FrequencyDetails list  end*****/

		/******get mutualFunds post list start*****/
		mutualFundsService.submitLumpsumRequest = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/submitRequest", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******get check OTP required or not*****/
		mutualFundsService.payDuesRequest = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getPayDues", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/******get encryptString*****/
		mutualFundsService.getEncryptString = function (reqParams) {
			var q = $q.defer();
			//reqParams = { plainString: reqParams };
			AdapterUtils.postData("adapters/MutualFundAdapter/encryptString", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		mutualFundsService.getDecryptString = function (reqParams) {
			var q = $q.defer();
			reqParams = { encryptString: reqParams };
			AdapterUtils.postData("adapters/MutualFundAdapter/decryptString", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/****** mutualFunds post list  end*****/

		/****** Add Account List Start*****/
		mutualFundsService.addAccoutDetails = function (newObj) {
			accountList = newObj;

		};
		/******get FundDetails  start*****/
		mutualFundsService.getFundDetails = function (reqParams) {
			if(loggedInUserService.isLoggedInDetails.isLoggedIn){
				var q = $q.defer();
				AdapterUtils.postData("adapters/MutualFundAdapter/getFundDetails", reqParams, true).then(
					function (response) {
						q.resolve(response.data);
					},
					function (error) {
						q.reject(error);
					}
				);
				return q.promise;
			}else{
				var q = $q.defer();
				AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/getFundDetails", reqParams, true).then(
					function (response) {
						q.resolve(response.data);
					},
					function (error) {
						q.reject(error);
					}
				);
				return q.promise;
			}
		};

		/******get TransactionNotes  start*****/
		mutualFundsService.getTransactionNotes = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getWcmContentForCutOffTime", {}, true).then(
				function (response) {
					var data = {};
					if(response.data){
						data.nfo = "*"+response.data.nfo;
						data.nonNfo = "*"+response.data.nonNfo;
						data.common = "*"+response.data.common;
					} else{
						data.nfo = "";
						data.nonNfo = "";
						data.common = ""; 
					}
					q.resolve(data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/******get TransactionNotes  ends*****/

		/******get FundDetails  start*****/
		mutualFundsService.getFundDetailsNfo = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getFundDetailsNfo", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/****** FundDetails list  end*****/

		/******get FundDetails  start*****/
		mutualFundsService.getFundDetailsNfoPreLogin = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/getFundDetailsNfo", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/****** FundDetails list  end*****/

		/******get FundDetails  start*****/
		mutualFundsService.fetchUserDetails = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getUserProfile", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******get Cancellltion list  start*****/
		mutualFundsService.getFundListForCancellation = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getMandateForCancellation", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/****** get Cancellltion end*****/


		/******submit Cancel    start*****/
		mutualFundsService.submitCancelFund = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/cancelMandate", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/******cancelFundsOTP    start*****/
		mutualFundsService.getCancelFundOTP = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/cancelFundsOTP", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/****** get Cancel end*****/

		/******get FundDetails  start*****/
		mutualFundsService.fetchUserDetailsFromCloudant = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getMFApplicationDetails", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/****** get user details from CBS list  end*****/

		/******get submitAOFormToCloudant  start*****/
		mutualFundsService.submitAOFormToCloudant = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/setUserAccountProfile", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/****** submitAOFormToCloudant   end*****/

		/******get submitAOFormToCloudant  start*****/
		mutualFundsService.finalSubmitAOForm = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/submitMFAOFDetails", reqParams, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/****** submitAOFormToCloudant   end*****/

		/******set mutual Funds List  start*****/

		mutualFundsService.addFundList = function (fund) {
			fundListObj = fund;
		};

		/******set mutual Funds List  ends*****/

		/******get mutual Funds List  start*****/

		mutualFundsService.getFundList = function (fundList) {
			return fundListObj;
		};

		/******get mutual Funds List  ends*****/

		/******set mutual Funds details  start*****/

		mutualFundsService.addFundId = function (fundDetails) {
			fundDetailsObj = fundDetails;
		};
		/****** set mutual Funds details  end*****/

		/******get  mutual Funds details start*****/

		mutualFundsService.getFundId = function () {
			return fundDetailsObj;
		};

		/****** get mutual Funds details  end*****/


		/******set addUserDetails   start*****/

		mutualFundsService.addUserDetails = function (userDetails, flag) {

			userDetailsObj = userDetails;
			accountFetchFlag = flag;
		};
		/****** set addUserDetails  end*****/


		/******get addUserDetails   start*****/

		mutualFundsService.getUserDetails = function () {
			return userDetailsObj;
		};
		mutualFundsService.addUserPanDetails = function (userDetails) {
			userPanDetails = userDetails;
		};
		mutualFundsService.getUserPanDetails = function () {
			return userPanDetails;
		};
		mutualFundsService.addeKycPanDetails = function (_kycPanDetails) {
			kycPanDetails = _kycPanDetails;
		};
		mutualFundsService.geteKycPanDetails = function () {
			return kycPanDetails;
		};


		mutualFundsService.addNewFundDetails = function (newFundOfferDetails) {
			newFundDetails = newFundOfferDetails;
		};
		mutualFundsService.getNewFundDetails = function () {
			return newFundDetails;
		};
		/****** get addUserDetails  end*****/

		/******set add selected account   start*****/

		mutualFundsService.addSelectedAccount = function (accntDetails) {
			accountDetailsInOpenAc = accntDetails;

		};
		/****** set selected account  end*****/

		/******get selected account   start*****/

		mutualFundsService.getSelectedAccount = function () {
			return accountDetailsInOpenAc;
		};
		/****** get selected account  end*****/

		/******get fetch accountDetails flag   start*****/

		mutualFundsService.accountFetch = function () {
			return accountFetchFlag;
		};
		/****** get fetch accountDetails  end*****/



		/******  getCheckedStatus start*****/

		mutualFundsService.getCheckedStatus = function () {
			return checkAllStatusObj;
		};

		/******  getCheckedStatus  end*****/

		/******Check checkAllStatus function start*****/
		mutualFundsService.checkAllStatus = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getKYCAndAccountOpenStatus", reqParams, true).then(
				function (response) {
					checkAllStatusObj = response.data;
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/****** checkAllStatus function end*****/

		/******Check uploadPanCardToServer function start*****/
		mutualFundsService.uploadPanCardToServer = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/uploadImage", reqParams, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/****** checkAllStatus function end*****/


		/****** Get Account List Start*****/
		mutualFundsService.getDetails = function () {
			return accountList;
		};

		/****** set PAge Id*****/
		mutualFundsService.setPageId = function (pageId) {
			pageIdForMf = pageId;
		};

		/****** get PageID*****/
		mutualFundsService.getPageId = function () {
			return pageIdForMf;
		};

		/****** Get Account List end*****/

		/****** CAMS Call function start*****/
		mutualFundsService.CAMPSeKYCCall = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getKYCAndAccountOpenStatus", reqParams, true).then(
				function (response) {
					checkAllStatusObj = response.data;
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/****** CAMS function end*****/

		/** Masters Data List **/

		mutualFundsService.getMasters = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getMasterDetail", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/** Masters Data List ends**/

		/** Common Masters Data List **/

		mutualFundsService.getMasterCommon = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getMasterCommonData", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/** Common Masters Data List ends**/

		/**KYC Status Check **/

		mutualFundsService.checkKYCStatus = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/createOrupdateMFNeedAnalysis", reqParams, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/** Masters Data List ends**/

		/**Submit open accountForm**/
		mutualFundsService.submitAccountOpenningForm = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/setUserProfile", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/** Submit open accountForm ends**/

		/**get Portfolio **/
		mutualFundsService.getPortfolio = function () {

			var q = $q.defer();
			AdapterUtils.postDataWithTimeOut("adapters/MutualFundAdapter/getCustomerFundPortfolio", {}, false, 180000).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/**get Zero Folio **/
		mutualFundsService.getZeroFolio = function (reqParams) {

			var q = $q.defer();
			AdapterUtils.postDataWithTimeOut("adapters/MutualFundAdapter/zeroBalanceFolio", reqParams, false, 180000).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/** Submit open accountForm ends**/

		/**get Pan **/
		mutualFundsService.getPanCardNumber = function (reqParams) {
			var reqParams = {};
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getMFNeedAnaLysis", reqParams, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/**get DistributorCode **/
		mutualFundsService.getDistributor = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getMasterDataDistributer", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/**get Risk Image **/
		mutualFundsService.getRiskImgList = function (reqParams) {
			var reqParams = {};
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getRiskMeterImage", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		mutualFundsService.getRiskImgListPrelogin = function (reqParams) {
			var reqParams = {};
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter//oa/v1/getRiskMeterImage", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		//get userConsent 
		mutualFundsService.getEKYCStatus = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/EkycAdapter/getEKYCStatus", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;

		};

		//get statement 
		mutualFundsService.getStatement = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getAccountStatement", reqParams, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		mutualFundsService.getServerUrl = function () {
			if(loggedInUserService.isLoggedInDetails.isLoggedIn){
				var q = $q.defer();
				AdapterUtils.postData("adapters/MutualFundAdapter/getServerUrl", {}, true).then(
					function (response) {
						q.resolve(response.data);
					},
					function (error) {
						q.reject(error);
					}
				);
				return q.promise;
			}else{
				var q = $q.defer();
				AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/getServerUrl", {}, true).then(
					function (response) {
						q.resolve(response.data);
					},
					function (error) {
						q.reject(error);
					}
				);
				return q.promise;
			}
			
		};

		mutualFundsService.addFolioToInvest = function (folioToInvest) {
			folioToInvestObj = folioToInvest;
		};

		mutualFundsService.getFolioToInvest = function () {
			return folioToInvestObj;
		};

		/******set Funds For Invest now  start*****/
		mutualFundsService.addFundToInvest = function (fundDetails) {
			fundToInvestObj = fundDetails;
		};
		/****** set  Funds  For Invest now  end*****/

		/******get Funds For Invest now  start*****/

		mutualFundsService.getFundToInvest = function () {
			return fundToInvestObj;
		};
		/****** set  Funds  For Invest now  end*****/

		// banner for investment prelogin 
		mutualFundsService.getInvestmentPreLoginBanners = function (reqParams) {
			var reqParams = {};
			var q = $q.defer();
			AdapterUtils.postData("adapters/FSSCommonAdapter/oa/v1/getInvestmentPreLoginBanners", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		// banners for investment postlogin 
		
		mutualFundsService.getInvestmentPostLoginBanners = function (reqParams) {
			var reqParams = {};
			var q = $q.defer();
			AdapterUtils.postData("adapters/FSSCommonAdapter/oa/v1/getInvestmentPostLoginBanners", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};


		//for pre login - getinfolist
		mutualFundsService.getAllInfoListsPre = function (reqParams) {
			var reqParams = {};
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/getInfoList", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/**get info list**/
		mutualFundsService.getAllInfoLists = function (reqParams) {
			var reqParams = {};
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getInfoList", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		mutualFundsService.getEkycInfoLists = function (reqParams) {
			var reqParams = {};
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getEkycInfoList", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/**get WhiteListed list**/
		mutualFundsService.getUserWhiteListed = function (reqParams) {
			var reqParams = {};
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getUserWhiteListedDetails", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/*** Get OTPToken****/

		/**get info list**/
		mutualFundsService.getOTPTokenSecure = function (reqParams) {
			var reqParams = {};
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/ReSendOTP", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/*** Get OTPToken****/
        mutualFundsService.generateOTP = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", requestData, true).then(function (response) {
                q.resolve(response.data);
            },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };
        mutualFundsService.validateOTP = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", requestData, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };

		/**get info list**/
		mutualFundsService.getResendOTPTokenSecureCancel = function (reqParams) {
			var reqParams = {};
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/ReSendOTPCancellation", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		mutualFundsService.validateOTPForPayment = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postDataWithTimeOut("adapters/MutualFundAdapter/validateOTPForPayment", reqParams, true, 180000).then(
				function (response) {
					q.resolve(response);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		mutualFundsService.cancelMandateOTPValidate = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/cancelMandateOTPValidate", reqParams, true).then(
				function (response) {
					q.resolve(response);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		mutualFundsService.getSBIBankAccounts = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FSSCommonAdapter/getOwnAccounts", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		/******set InfoList  start*****/

		mutualFundsService.addInfoList = function (InfoL) {
			InfoList = InfoL;
		};
		/****** set  InfoList  end*****/

		/******get InfoList  start*****/

		mutualFundsService.getInfoList = function () {
			return InfoList;
		};
		mutualFundsService.addekycInfoList = function (ekycInfoL) {
			ekycInfoList = ekycInfoL;
		};

		mutualFundsService.getekycInfoList = function () {
			return ekycInfoList;
		};
		/****** set InfoList  end*****/
		/******add video  start*****/

		mutualFundsService.addVideo = function (videoL) {
			videoList = videoL;
		};
		/****** set  InfoList  end*****/


		/******get video  start*****/

		mutualFundsService.getVideoListFromService = function () {
			return videoList;
		};
		/****** set InfoList  end*****/

		/******set riskProfile  start*****/
		mutualFundsService.addRiskProfile = function (riskProfile) {
			riskProfileData = riskProfile;
		};
		/****** set riskProfile  end*****/

		/******get riskProfile  start*****/
		mutualFundsService.getRiskProfile = function () {
			return riskProfileData
		};
		/****** get  riskProfile  end*****/

		/** Function for verifying secKey from response**/
		mutualFundsService.verifySecKey = function (secKey) {
			return calculatedKey = ((secKey / 2) - 1) / 99;
		}

		mutualFundsService.isValidOTPNum = function (enterOTP) {
			if (!enterOTP) {
				return $translate.instant('Please Enter OTP Number');
			}
			if (enterOTP.length < 6) {
				return $translate.instant('Please Enter Valid OTP Number');
			}
			return false;
		}

		mutualFundsService.addInvedtedAmount = function (amt) {
			amountforInvest = amt;
		}
		mutualFundsService.getInvedtedAmount = function () {
			return amountforInvest;
		}
		mutualFundsService.addActionListData = function (data) {
			accountListData = data;
		}
		mutualFundsService.getActionListData = function () {
			return accountListData;
		}
		mutualFundsService.clearOTP = function (enterOTP) {
			return enterOTP = '';
		}
		mutualFundsService.fetchAccountList = function () {
			var q = $q.defer();
			var accountList = mutualFundsService.getDetails();
			if (accountList && accountList.length > 0) {
				q.resolve(true);
			}
			else {
				getAccountDetailsService.getAccountDetails().then(function (data) {
					if (data && data.accounts && data.accounts.length > 0) {
						mutualFundsService.addAccoutDetails(data.accounts);
						q.resolve(true);
					} else {
						q.reject({ responseMessage: "Account List fetch error. Please try again." });
					}
				}, function (error) {
					q.reject(error);
				});
			}

			return q.promise;
		}

		/**Check for trending Funds **/
		mutualFundsService.trendingFunds = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getDataOfTrendingFunds", {}, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/**Check for trending Funds PreHomeLogin**/
		mutualFundsService.trendingFundsPre = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/trendingFunds", {}, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/**Check for ELSS Funds **/
		mutualFundsService.taxSaver = function () {

			if(loggedInUserService.isLoggedInDetails.isLoggedIn){
				var q = $q.defer();
				AdapterUtils.postData("adapters/MutualFundAdapter/getAllElssMutualFundList", {}, true).then(
					function (response) {
						q.resolve(response.data);
					},
					function (error) {
						q.reject(error);
					}
				);
				return q.promise;
			}else{
				var q = $q.defer();
				AdapterUtils.postData("adapters/MutualFundAdapter/oa/v1/getAllElssMutualFundList", {}, true).then(
					function (response) {
						q.resolve(response.data);
					},
					function (error) {
						q.reject(error);
					}
				);
				return q.promise;
			}

			 
		};

		/**Get Master data from cloudent for relationship with nominee/appointee **/
		mutualFundsService.getRelMaster = function () {
			 var q = $q.defer();
			AdapterUtils.postData("adapters/MutualFundAdapter/getMfAofRelationshipMaster", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		return mutualFundsService;
	});  
