/******* Start investing Controller ******/
'use strict';

angularApp.controller('startInvestingController',
						["$timeout",
						 "$state",
						 "$scope",
						 "$translate",
						 "$location",
						 "$ionicScrollDelegate","mutualFundsService","constantConfig","utilityService","homeScreenService","mPinLoginService",
				 
function ($timeout,
		 $state,
		 $scope,
		 $translate,
		 $location,
		 $ionicScrollDelegate,mutualFundsService,constantConfig,utilityService,homeScreenService,mPinLoginService) {
	
	
	var startInvestingVm = this;
	
	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		startInvestingVm.isBackCheck=homeScreenService.isBackCheck;
		homeScreenService.isBackCheck	=false;
		$scope.isLoggedIn = mPinLoginService.isLoggedIn;
		startInvestingVm.showIntroductionText();
	}
	/**
	*Fetch Start Investing Introduction of Risk profile page
	@params {action:'helpMeInvest'}
	**/
	
			startInvestingVm.showIntroductionText=function(){
			//Call service to fetch termsConditionsMessage
			startInvestingVm.reqParams={};
			startInvestingVm.reqParams['action']=constantConfig.mfAndsecConst.helpMeInvest;
			if($scope.isLoggedIn){
				mutualFundsService.getTermsAndConditions(startInvestingVm.reqParams).then(function(data) {
				startInvestingVm.startInvestingIntroduction=data.message;

				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}else{
				mutualFundsService.getTermsAndConditionsPre(startInvestingVm.reqParams).then(function(data) {
				startInvestingVm.startInvestingIntroduction=data.message;

				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			
		}
	
	
	/***Function to open risk profile questions page***/
	startInvestingVm.riskProfileQA=function (){
		$state.go('menu.riskProfileQA');
	}
	
	/*** one time initialization to be done when the controller is loaded***/
	$scope.$on('$ionicView.loaded', function() {
		
	});
	
	/*** actions to done everytime the view is shown***/
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
		
	});
	
	 /***any cleanup needs to be done here: executes everytime when page is left***/
	$scope.$on('$ionicView.afterLeave', function() {
		
	});
	return this;
}]);

