'use strict';

angularApp.controller('myBalanceController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "accountOverviewService",
    "fixedDepositService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "myDreamsServices",
    "mySecurityProfileService",
    "mutualFundsService",
    "linkCardService",
    "cardsService",
    "linkingLIPolicyService",
    "cardConfig",
    "applyNowService",
    "generalInsurenceHomeService",
    "payNowServices",
    "openAccountService",
    "cardCompareService",
    "personalLoanService",
    "$filter",
    "floatingMenuService",
    "homeScreenService",
    "rdService",
    "instaHomeService",
    "wealthService",
    "JTSixService",
    "aoService",
    "customerInfoService",
    "$ionicLoading",
    "ionicDatePicker",
    "$q",
    "sampoornSurakshaService",
    "fTBeneficiaryService",
    "lifeInsuranceBasicApplicationService",
    "myBalanceService",
    "loggedInUserService",
    "myDreamsService",
    "cryptoService",
    "clickStreamService",
    "$ionicPopover",
    "wearableServices",
    "openUrlInAppbroswerService",
    "requestYCService",
    "npsServices",	
    "rrService",
    "pailinkingRenwalService",
    "ppfExtService","newCardService",
    "dematService","leadGenerationService",
    "OBADServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        accountOverviewService,
        fixedDepositService,
        $ionicSlideBoxDelegate,
        utilityService,
        myDreamsServices,
        mySecurityProfileService,
        mutualFundsService,
        linkCardService,
        cardsService,
        linkingLIPolicyService,
        cardConfig,
        applyNowService,
        generalInsurenceHomeService,
        payNowServices,
        openAccountService,
        cardCompareService,
        personalLoanService,
        $filter,
        floatingMenuService,
        homeScreenService,
        rdService,
        instaHomeService,
        wealthService,
        JTSixService,
        aoService,
        customerInfoService,
        $ionicLoading,
        ionicDatePicker,
        $q,
        sampoornSurakshaService,
        fTBeneficiaryService,
        lifeInsuranceBasicApplicationService,
	myBalanceService,
        loggedInUserService,
        myDreamsService,
        cryptoService,
	clickStreamService,
        $ionicPopover,
        wearableServices,
       openUrlInAppbroswerService,
        requestYCService,
        npsServices,
        rrService,
        pailinkingRenwalService,
        ppfExtService,newCardService,dematService,leadGenerationService,
        OBADServices) {

        var Vm = this;
        Vm.savingDisplay = getAccountDetailsService.dataDisplay.savingDisplay;
        Vm.currentDisplay = getAccountDetailsService.dataDisplay.currentDisplay;
        Vm.overdraftDisplay = getAccountDetailsService.dataDisplay.overdraftDisplay;
        Vm.graphDisplay = getAccountDetailsService.dataDisplay.graphDisplay;
        Vm.myLoyalityRewards = '';
        Vm.registrationStatus = false;
        Vm.MyBalanceAmount = 0;
        Vm.MyDepositsAmount = 0;
        Vm.MyBorrowingsAmount = 0;
        Vm.MyInvestmentsAmount = 0;
        Vm.lineGraphData = "";
        Vm.picDocImages = "";
        var isStaffCustomer = mutualFundsService.getUserDetails().isStaffFlag;
        Vm.custResidentialStatus = "";

        $scope.isiPhone = utilityService.isIOSPlatform();

        var valueOfPortfolio = mutualFundsService.getTotalMyInvetmentAmount();
        var valueofSecurities = mutualFundsService.getTotalSecurities();
        $rootScope.linkAccountFlag = 0;
        $rootScope.openAccountFlag = 0;
        Vm.noAccountLinked = false;
        Vm.isAccountTransactional = false;
        Vm.unableFetchAccountTransactional = false;
        Vm.unableFetchAccountMOPTransactional = false;
        //Vm.wearableListlength = 1;
        $rootScope.wearableDisplayname = '';
        Vm.checkPMJDYflag = false;

        $scope.hideSA = true;
        $scope.hideCA = true;
        $scope.hideOD = true;
        $scope.hideFCNR = true;
        $scope.hideBorrowingOD = true;
        $scope.hideBorrowingLoan = true;
        $scope.hideReccuringDeposit = true;
        $scope.hideOtherDeposit = true;
        $scope.hideFixedDeposit = true;
        $scope.hideCreditCard = true;

        $scope.sliderOptions = {
            slidesPerView: 1.2,
            spaceBetween: 2,
            loop: true,
            breakpointsBase: 'container',
            breakpoints: {
                // when window width is <= 720px
                720: {
                    slidesPerView: 1.2,
                    spaceBetween: 4
                },
                // when window width is <= 640px
                640: {
                    slidesPerView: 1.2,
                    spaceBetween: 4
                },
                // when window width is <= 480px
                480: {
                    slidesPerView: 1.2,
                    spaceBetween: 4
                },
                // when window width is <= 320px
                320: {
                    slidesPerView: 1.2,
                    spaceBetween: 2
                }
            },
            pager: true
        };

        //private methods section start
        function initPage() {
            Vm.myDepositTabClick(1);
            var today = new Date();
            var maxDate = new Date(today.getFullYear(),today.getMonth() , today.getDate() - 1);
            $scope.dateobj = {};
            $scope.dateobj.dt = maxDate; 

            //Vm.getAboutWearableContent();
            if (homeScreenService.ishamburgerMenuRO) {
                Vm.isHamCheck = true;
                Vm.isBackCheck = true;
            } else {
                Vm.isBackCheck = false;
                Vm.isHamCheck = false;
            }
            $scope.currentDate = new Date();
            Vm.showRetryMyBalance = false;
            utilityService.doNotHideSpinner(true);
            getAccountDetailsService.accType.accno = '';
            getAccountDetailsService.accType.typeId = '';
            getAccountDetailsService.accType.indexId = '';
            Vm.grapLable = [];
            Vm.grapAmount = [];
            applyNowService.currentState = "";
            Vm.showLinkCards = false;
            Vm.showNoCardsMsg = false;
            Vm.showDelinkCards = false;
            Vm.showPendingApplication = false;
            Vm.showIncompleteApplication = false;
            Vm.img2 = getAccountDetailsService.img2;
            Vm.img3 = getAccountDetailsService.img3;
            Vm.img = getAccountDetailsService.img;
            Vm.img1 = getAccountDetailsService.img1;
            Vm.handimg = getAccountDetailsService.handimg;
            Vm.overdraft = getAccountDetailsService.overdraft;
            myBalanceService.dummymenuCheck=true;
            Vm.isPaiPolicyAvailable = false; //Boolean for GI-PAI Banner
            if (applyNowService.isCardFlag) {
                $ionicScrollDelegate.anchorScroll();
                $ionicSlideBoxDelegate.slide(getAccountDetailsService.tabIndex.tabIndex);
                applyNowService.isCardFlag = false;
            }
                      /*
                Redirection from other controllers to the relationship page menu spinner
            */
            if (homeScreenService.isAccountsFlag) {
                $ionicScrollDelegate.anchorScroll();
                $ionicSlideBoxDelegate.slide(getAccountDetailsService.tabIndex.tabIndex);
                homeScreenService.isAccountsFlag = false;
                Vm.showPFMButton = true;
                //Vm.loadMyBalance();
            }
            if (fTBeneficiaryService.isCreditCardFlag || homeScreenService.isCreditCardFlag) {
                Vm.showPFMButton = false;
                $ionicScrollDelegate.anchorScroll();
                $ionicSlideBoxDelegate.slide(getAccountDetailsService.tabIndex.tabIndex);
                fTBeneficiaryService.isCreditCardFlag = false;
                Vm.cardsApiCall();
            }
            if (homeScreenService.isInsuranceFlag) {
                Vm.showPFMButton = false;
                $ionicScrollDelegate.anchorScroll();
                $ionicSlideBoxDelegate.slide(getAccountDetailsService.tabIndex.tabIndex);
                homeScreenService.isInsuranceFlag = false;
                generalInsurenceHomeService.setGIProductList([]);
                Vm.loadGI();
                Vm.liRenewalBanner = homeScreenService.offersData.filter(function(offer){
                    return offer.category == "LI-RENEWAL";
                });
            }

            if (homeScreenService.isInvestmentFlag) {
                Vm.showPFMButton = false;
                $ionicScrollDelegate.anchorScroll();
                $ionicSlideBoxDelegate.slide(getAccountDetailsService.tabIndex.tabIndex);
                homeScreenService.isInvestmentFlag = false;
                Vm.getMFPortfolio();
                Vm.getSecurityProfile();
                Vm.getWealthTrackFlag();
            }

            if (homeScreenService.isDepositsFlag) {
                Vm.showPFMButton = false;
                $ionicScrollDelegate.anchorScroll();
                $ionicSlideBoxDelegate.slide(getAccountDetailsService.tabIndex.tabIndex);
                homeScreenService.isDepositsFlag = false;
                //Vm.getDreamImage();
            }

            if (homeScreenService.isLoansFlag) {
                Vm.showPFMButton = false;
                $ionicScrollDelegate.anchorScroll();
                $ionicSlideBoxDelegate.slide(getAccountDetailsService.tabIndex.tabIndex);
                homeScreenService.isLoansFlag = false;
            }

            if (homeScreenService.isMyRewardsFlag) {
                Vm.showPFMButton = false;
                $ionicScrollDelegate.anchorScroll();
                $ionicSlideBoxDelegate.slide(getAccountDetailsService.tabIndex.tabIndex);
                homeScreenService.isMyRewardsFlag = false;
                Vm.getMyRewards();
            }

            if (homeScreenService.isMyWearableFlag) {
                Vm.showPFMButton = false;
                $ionicScrollDelegate.anchorScroll();
                $ionicSlideBoxDelegate.slide(getAccountDetailsService.tabIndex.tabIndex);
                homeScreenService.isMyWearableFlag = false;

            }

            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.lifeInsurance)) {
                // if data is not null
                Vm.liLinkedPolices = getAccountDetailsService.accountOverviewData.lifeInsurance;
            }
            if (!utilityService.isUndefined(homeScreenService.offersData)) {
                // if data is not null                
                 Vm.renewalPolicyList = homeScreenService.offersData;                  
            }
            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy)) {
                // if data is not null
                Vm.ssPolicyDetails = getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy;
            }
            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.rinnRakshaPolicy)) {
                // if data is not null
                Vm.rrPolicyDetails = getAccountDetailsService.accountOverviewData.rinnRakshaPolicy;
            }
            if(getAccountDetailsService.accountOverviewData.generalInsurance==undefined){
                var giData=generalInsurenceHomeService.getGIProductList();
                if(giData!= undefined) {
                   getAccountDetailsService.accountOverviewData.generalInsurance = giData;
                } 

            }
           if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.generalInsurance)) {
                // if data is not null
                Vm.genralliLinkedPolices = getAccountDetailsService.accountOverviewData.generalInsurance;
            }

            if (mutualFundsService.multiFolio) {
                Vm.investmentSpinner = false;
                Vm.folioNumber = true;
                Vm.totalMFCurrent = mutualFundsService.multiFolio.totalCurrentValue;
                angular.forEach(mutualFundsService.multiFolio.portFolio, function (value, key) {
                    if (value.isLotusfolio.toLowerCase() == "yes") {
                        Vm.isLotusFolio = 1;
                    }
                })
            }
             if (mutualFundsService.totalSecurities || mutualFundsService.multiFolio) {  
                 Vm.securities = mutualFundsService.totalSecurities;            
                 Vm.MyInvestmentsAmount= parseFloat(valueOfPortfolio) + parseFloat(valueofSecurities);
            }
			
			Vm.readmore = false;   
			Vm.isClicked = false;
			Vm.firstslide = true;
			$scope.slideIndex = 0;
			$scope.myActiveSlide = 0;
           
        }
		
		Vm.myDepositTabClick = function(tabIndex){
            Vm.myDepositTab = tabIndex;
        }
		
		Vm.cardslideChanged =  function(index){
            //alert(index);
            Vm.carddetailsUpdate(index);
        };
		
		 Vm.carddetailsUpdate = function(index){
            if(Vm.cardList && Vm.cardList.length > 0){
				var today = new Date(); 
				var dd = today.getDate();
				var mm = today.getMonth();
				var monthlist = ['JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN', 'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'];
				var yyyy = today.getFullYear();
				if (dd < 10) {
					dd = '0' + dd;
				}
				var OutstandingDate = dd + ' ' + monthlist[mm] + ' ' + yyyy;
				$scope.currentOutStandingDate = OutstandingDate;
                $scope.lastStatementDate = Vm.cardList[index].lastStatementDate.replace(/-/g," ");
                if(Vm.cardList[index].dueDate && Vm.cardList[index].dueDate != ""){
                    $scope.dueDate = Vm.cardList[index].dueDate.replace(/-/g," ");
                }
                else{
                    $scope.dueDate = "";
                }
                
                $scope.minimumDue = Vm.cardList[index].minimumDue;
                if(Vm.cardList[index].paymentDue < 0){
                    $scope.totalBill = 0;
                }else{
                    $scope.totalBill = Vm.cardList[index].paymentDue;
                }
                //cards corousel - addopacity and height adjust
                setTimeout(function(){ 
                    var classAdd = document.getElementsByClassName('card-baner')[0];
                    if(classAdd){
                        if(classAdd.getElementsByClassName('removeOpacity')[0]){                         
                            var temp = classAdd.getElementsByClassName('removeOpacity')[0];
                            temp.getElementsByClassName('subcontentcard-slide')[0].classList.remove("removeSliderCss");
                            classAdd.getElementsByClassName('removeOpacity')[0].classList.remove("removeOpacity");
                        } 
                        classAdd.querySelectorAll("[data-index]")[index].classList.add("removeOpacity");
                        var tempclass = document.getElementsByClassName('removeOpacity')[0];
                        tempclass.getElementsByClassName('subcontentcard-slide')[0].classList.add("removeSliderCss");
                       
                    }   
                }, 500);          
            }           
        };

         // go to card payment page
       Vm.goToCardPayment = function(index) {
             utilityService.showSpinner();
            payNowServices.getUserAccounts({}).then(function(response) {

                cardsService.errorLogger(response);
                if (response.data && response.data.beneficiaryList && response.data.beneficiaryList.ownAccounts) {
                    cardsService.setParams({ "paymentAccounts": response.data.beneficiaryList.ownAccounts });
                    utilityService.hideSpinner();
					cardsService.getSetCardDetail(Vm.cardList[index], index);
                    $state.go('menu.cardPayment');
                }
            }, function(error) {
                  utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });

        };

        Vm.gotransactions = function(index){
            var responseData = {
                primaryCardSelected: index
            }
            cardsService.setParams(responseData);
            cardCompareService.policyWrapper = Vm.cardList[index].policyWrapper;
            if (cardCompareService.policyWrapper.accountInformation !== 'Approved' && cardCompareService.policyWrapper.cardStatement !== 'Approved' && cardCompareService.policyWrapper.login !== 'Approved') {
                var loginError = {
                    cssClass: 'sbi-alert-popup',
                    template: '<div class="text-align-center font-content roboto-regular" translate="LOGIN_FAILED_WRAPPER" ></div>',
                    buttons: [{
                        text: cardConfig.buttons.OK_LABEL,
                        type: 'button-positive'
                    }]
                };
                cardsService.alertModal(loginError, null);
            } else {
                var addOnCardPayload = {
                    "cardNumber": Vm.cardList[index].cardNumber
                };
                utilityService.showSpinner();
                payNowServices.getAddOnCards(addOnCardPayload).then(function (response) {
                    if (response.data && response.data.cards) {
                        cardsService.setParams({
                            "addOnCards": response.data.cards || []
                        });
                        utilityService.hideSpinner();
                        cardsService.getSetCardDetail(Vm.cardList[index], index);
                        $state.go('menu.cardTransactions'); 
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

        };

        Vm.goCardServices = function(index){
            
            var responseData = {
                primaryCardSelected: index
            }
            cardsService.setParams(responseData);

            cardCompareService.policyWrapper = Vm.cardList[index].policyWrapper;
            if (cardCompareService.policyWrapper.accountInformation !== 'Approved' && cardCompareService.policyWrapper.cardStatement !== 'Approved' && cardCompareService.policyWrapper.login !== 'Approved') {
                var loginError = {
                    cssClass: 'sbi-alert-popup',
                    template: '<div class="text-align-center font-content roboto-regular" translate="LOGIN_FAILED_WRAPPER" ></div>',
                    buttons: [{
                        text: cardConfig.buttons.OK_LABEL,
                        type: 'button-positive'
                    }]
                };
                cardsService.alertModal(loginError, null);
            } else {
                var addOnCardPayload = {
                    "cardNumber": Vm.cardList[index].cardNumber
                };
                utilityService.showSpinner();
                payNowServices.getAddOnCards(addOnCardPayload).then(function (response) {
                    if (response.data && response.data.cards) {
                        cardsService.setParams({
                            "addOnCards": response.data.cards || []
                        });
                        utilityService.hideSpinner();
                        $state.go('menu.cardServices');
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        };

         Vm.myFunction = function() {
            var dots = document.getElementById("dots");
            var moreText = document.getElementById("more");
            var btnText = document.getElementById("myBtn");

            if (dots.style.display === "none") {
                dots.style.display = "inline";
                btnText.innerHTML = "Show More"; 
                moreText.style.display = "none";
            } else {
                dots.style.display = "none";
                btnText.innerHTML = "Show Less"; 
                moreText.style.display = "inline";
            }
        };

        Vm.goToCard = function(card) {
            cardsService.setParams({ "cardName": card.cardName });
            $state.go('menu.cardPlatinum');
        };

        Vm.applyNow = function (card) {
            //Added below code added for Centralized consent Sprint 2 to check consent and redirect to TnC if consent doesn't exist & to Cards journey if it exists
            leadGenerationService.checkConsent().then(function (data) {
                utilityService.hideSpinner();
                if (data.customerRecordExists == "false") {
                    newCardService.setPostLoginSelectedMenu('cards');
                    $state.go('menu.termsAndConditionsOutboundAnalytics', { data: card });
                } else {
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "CC_START_NXT_BTN"));
                    $state.go('menu.cardPersonalDetails1');
                }
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        };


        //Get Status of submitted application
        Vm.getPendingApplicationsStatus = function() { 
            linkCardService.getPendingApplicationStatus({})
            .then(function(response) {
                    cardsService.errorLogger(response);
                    if (response.data) {
                        //if (response.data.responseMessage) {
                            if ((response.data.applicationNumber || response.data.applicationNumber == "") && (response.data.leadReferNo || response.data.remark)){
                                linkCardService.setAllowAppStatus(response.data);
                                $scope.ApplliedOn = response.data.applicationDate;
                                $scope.Remark = response.data.remark;
                                if($scope.Remark.split(' ').length > 13){
                                    Vm.readmore = true;
                                    $scope.Remark1 = $scope.Remark.split(" ").splice(0,13).join(" ");
                                    $scope.Remark2 = " "+$scope.Remark.split(" ").splice(13).join(" ");
                                }
                                else{
                                    $scope.Remark1 = $scope.Remark;
                                    Vm.readmore = false;
                                }
                                $scope.Status = response.data.status;
                                Vm.showPendingApplication = true;
                            }
                        //}
                    }
                },
                function(error) {
                        Vm.showPendingApplication = false;
                });
        };

        Vm.getRecommendedCards = function() {
            var data = {};
            newCardService.getRecommendedCards(data).then(function(response) {
                cardsService.errorLogger(response);
                $timeout(function() {
                    Vm.getRecommendedCardList = response.data.recommendedCards || [];
                    if(Vm.getRecommendedCardList.length == 0){
                        Vm.getRecommendedCardList = [{"cardName":"SimplyCLICK SBI Card","description":"Get upto 10X reward points every time you spend online","pictureURL":"https://www.sbicard.com/sbi-card-en/assets/media/images/personal/credit-cards/value-savings/card-faces/simplyclick-card-face.png","number":"3"}];
                    }
                    angular.forEach(Vm.getRecommendedCardList, function(value, key) {
                        value.pictureURL = value.pictureURL.replace(cardConfig.cardUrl.other_card, "https://www");
                         value.pictureURL = value.pictureURL.replace(cardConfig.cardUrl.tata_card, "https://www.tatacard.com");

                    });
                    Vm.lastslide = (Vm.getRecommendedCardList.length == 1) ? false : true;
                    $timeout(function() {
                        $ionicSlideBoxDelegate.update();
                        $ionicSlideBoxDelegate.loop(true);
                     }, 1000);
                });

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        Vm.slideChanged = function(index) {
            $scope.slideIndex = index;
            if (index == 0) {
                Vm.firstslide = true;
            } else {
                Vm.firstslide = false;
            }

            if (index == (Vm.getRecommendedCards.length - 1)) {
                Vm.lastslide = true;
            } else {
                Vm.lastslide = false;
            }

        };

        Vm.KnowMoreClick = function(){
            var comingsoonPopup = $ionicPopup.alert({
                template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                    + "Coming Soon" + '</div></div></div></div></div></div>',
                cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                buttons: [
                    {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (e) {
                            comingsoonPopup.close();
                        }
                    }
                ]
            });
        };
        
        //new toggle added
        Vm.toggleGroup = function () {
            Vm.isClicked = !Vm.isClicked;
            if(!Vm.isClicked){     
                document.getElementsByClassName('pendingapp')[0].style.setProperty('height', '50%', 'important');
            }
            if(Vm.isClicked){
                document.getElementsByClassName('pendingapp')[0].style.setProperty('height', '150%', 'important');
            }           
        };

        Vm.getRecommendedCardsTopPickBanner = function() {
            $timeout(function() {
                Vm.getRecommendedCardListTop = [];
                     angular.forEach(Vm.getAllCardList, function(value, key) {
                       Vm.getRecommendedCardListTop[key]=value;
                    });
            });
        }    

        //top picks for you - cards
         Vm.getRecommendedCardsTopPick = function() {
            $ionicSlideBoxDelegate.$getByHandle('creditCardCommonOutbound').update(); 
            var data = {};
            newCardService.getCardsTopPicksForPostLogin(data).then(function(response) {
                    Vm.getAllCardList = response.data[0].banners || [];
                    Vm.getRecommendedCardsTopPickBanner();
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        Vm.updateSlider= function() {
             $ionicSlideBoxDelegate.update();
        };

        Vm.applyNowPick = function(card){
            $state.go('menu.termsAndConditionsOutboundAnalytics')
            newCardService.setPostLoginSelectedMenu('cards');
            newCardService.setTermsAndConditionsOutboundAnalyticsData(card);
        
      }

        Vm.cardsApiCall = function () {
            utilityService.showSpinner();
            Vm.getLinkedCards();
            Vm.getRecommendedCardsTopPick();
            Vm.getPendingApplicationsStatus();
            Vm.carddetailsUpdate($scope.myActiveSlide);            
            Vm.getRecommendedCards();
        };

        Vm.browseAllCards = function(tabname){
            newCardService.browseCardsTabs(tabname);
        };

        function checkResidentialStatus(){
            if(getAccountDetailsService.accountOverviewData){
                if(getAccountDetailsService.accountOverviewData.customerInformation){
                    Vm.custResidentialStatus = getAccountDetailsService.accountOverviewData.customerInformation.residentialStatus;
                    var CREATE_FD_BTN = document.getElementById('CREATE_FD_BTN');
                    var CREATE_RD_BTN = document.getElementById('CREATE_RD_BTN');
                    var CREAT_DREAM_BTN = document.getElementById('CREAT_DREAM_BTN');

                    if(CREATE_FD_BTN.classList.value.search('actOverview-button-selected') >= 0){
                        CREATE_FD_BTN.removeAttribute('disabled');
                    }
                    else{
                        CREATE_FD_BTN.setAttribute('ng-disabled',true);
                    }
                    if(CREATE_RD_BTN.classList.value.search('actOverview-button-selected') >= 0){
                        CREATE_RD_BTN.removeAttribute('disabled');
                    }
                    else{
                        CREATE_RD_BTN.setAttribute('ng-disabled',true);
                    }
                    if(CREAT_DREAM_BTN.classList.value.search('actOverview-button-selected') >= 0){
                        CREAT_DREAM_BTN.removeAttribute('disabled');
                    }
                    else{
                        CREAT_DREAM_BTN.setAttribute('ng-disabled',true);
                    }
                }
            }
                
               
        }

		
      
        Vm.createFD = function () {
            /*fixedDepositService.customer = {
                amountData: '',
                years: '',
                months: '',
                days: '',
                maturityDate: '',
                interestRate: '',
                maturityAmount: '',
                interestPayout: '',
                maturityInstruction: '',
                diffDays: '',
                maturityDateFull: '',
                isvalidDays: '',
                isTaxable: false,
                accountNo: '',
                fdAccountNumber: '',
                loanEligibility: '',
                receiptLink: '',
                nomineeClick: '',
                selectedItem: '',
                ODLimit: '',
                ODIntRate: '',
                ODExyDate: '',
                isSenior: false,
                custName: '',
                custDOB: '',
                nominee: '',
                age: '',
                relation: '',
                guardian: '',
                address1: '',
                address2: '',
                dob: '',
                showNominee: false,
                viewInterest: false,
                isPanAvailable: '',
                fdnumber: '',
                AODclick: '',
                intpayoutMD: '',
                intpayoutAMT: '',
                maturitydateRequest: '',
                nameToBePrintedFlag: '',
                minorFlag: '',
                custype: '',
                intpayoutservice: '',
                matInstService: '',
                indexId: 0,
                amountCredited: '',
                effectiveInterestRates: '',
                clickback: '',
                intpaycheck: '',
                nomIndexid: '',
                checkPAL: '',
                preApprovedLoanAmount: '',
                product: '',
                principalAmount: '',
                checkPage: '',
                maturitydateFD: '',
                maturitydateFDRequest: '',
                branchCode: '',
                branchName: '',
                intpayamount: '',
                intpaystring: '',
                checkNominee: false,
                fdCloseClick: '',
                intpayoutACCT: '',
                intCategory: '',
                accountTypeCode: '',
                nightMode: ''
            };

            fixedDepositService.selectedDetails = {
                accountType: '',
                accountNumber: '',
                accountBalance: '',
                isActive: '',
                isTransactional: '',
                branchCode: '',
                branchName: '',
                intCategory: '',
                accountTypeCode: ''
            };*/
            homeScreenService.ishamburgerMenuFD=false;
            if(Vm.custResidentialStatus){
                fixedDepositService.initializeFDvariables();//calling fd service to initialize fd variables
                getAccountDetailsService.tabIndex.tabIndex = 1;
                $state.go('menu.fixedDeposit');
            }
            else {
                $ionicPopup.show({
                    template: '<p>Please contact your Home Branch for updation of Resident Status.</p>',
                    title: '',
                    cssClass: 'dialog',
                    scope: '',
                    buttons: [{
                        text: 'OK',
                        type: 'button-positive'
                    }]
                });
            }
        }
        Vm.calculateFDRD = function () {
            $state.go('menu.calculateFDRD');
        }

        Vm.lifeInsurancePolicyDetails = function (index) {
            linkingLIPolicyService.setSelectedPolicy(Vm.liLinkedPolices[index]);
            linkingLIPolicyService.getPolicyDetails(Vm.liLinkedPolices[index].policyNumber).then(function (data) {
                linkingLIPolicyService.setSelectedPolicyDetails(data);
                $state.go('menu.myPolicyDetails');
            }, function () {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                utilityService.disableShowErrorMessage();
            });
        };

        Vm.lifeInsuranceSSPolicyDetails = function (index) {
            sampoornSurakshaService.setSSPolicyDetails(Vm.ssPolicyDetails[index]);
            $state.go('menu.ssPolicySummary');
        };
        Vm.lifeInsuranceRRPolicyDetails = function (index) {
            rrService.setRRPolicyDetails(Vm.rrPolicyDetails[index]);
            $state.go('menu.rrPolicySummary');
        };

         Vm.ssRenewClicked = function ($event,index){
            sampoornSurakshaService.clearAll();
            var renewalDetails = {};
            renewalDetails.policyDetails = Vm.ssPolicyDetails[index];
            if(Vm.ssPolicyDetails[index].policyPaymentFlag == 'schedulePay'){
                renewalDetails.isScheduled = true;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "SCHE_PAY"));
            }else if(Vm.ssPolicyDetails[index].policyPaymentFlag == 'pay'){
                renewalDetails.isScheduled = false;
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PAY_NOW"));
            }
            var request = {
                "amount" : Vm.ssPolicyDetails[index].sumAssured,
                "isRenew" : true,
                "renewalDate" : Vm.ssPolicyDetails[index].renewalDate
            }
            sampoornSurakshaService.getFundTransferAccounts(request).then(function(data) {
                renewalDetails.accountDetails = data;
                sampoornSurakshaService.setRenewalDetails(renewalDetails);
                $state.go('menu.ssRenewal');
            }, function(error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                utilityService.disableShowErrorMessage();
            });
            $event.stopPropagation();
        }

        Vm.gotoLinkPolicy = function () {
            $state.go('menu.linkingLIPolicy');
        };

        Vm.gotoInsurance = function () {
            $state.go('menu.generalInsurance');
        };
        Vm.gotoHome = function () {
            $state.go('menu.homeScreen');
        };

        Vm.ssBuy = function () {
            sampoornSurakshaService.getPremiumAndNomineeInfo().then(function (data) {
                sampoornSurakshaService.clearAll();
                sampoornSurakshaService.setPremiumDetails(data);
                $state.go('menu.ssPremiumCalculation');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        Vm.ssKnowMore = function () {
            sampoornSurakshaService.getPolicyFeatures().then(function (data) {
                sampoornSurakshaService.setPolicyDetails(data);
                sampoornSurakshaService.setBuyNow(true);
                $state.go('menu.ssPolicyFeatures');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        Vm.createRD = function () {
            if(Vm.custResidentialStatus){
                rdService.initialValueStage();
                $state.go('menu.createRd');
            }
            else {
                $ionicPopup.show({
                    template: '<p>Please contact your Home Branch for updation of Resident Status.</p>',
                    title: '',
                    cssClass: 'dialog',
                    scope: '',
                    buttons: [{
                        text: 'OK',
                        type: 'button-positive'
                    }]
                });
            }
        };

        Vm.createWealth = function () {
            // $state.go('menu.verifyDetails');
            if (wealthService.wcmContentAppIntegration != "") {
                Vm.createWealthUrl(wealthService.wcmContentAppIntegration);
            } else {
                var obj = {
                    "type": "wealthLinkToSbiExclusif"
                }
                wealthService.WealthLinkToSbiExclusif(obj).then(function (data) {
                    wealthService.wcmContentAppIntegration = data;
                    Vm.createWealthUrl(data);
                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
                });
            }
        }

        Vm.createWealthUrl = function (contentWcm) {
            var template = '';
            template = '<div class ="exclusif_know_more">' + contentWcm + '</div>';
            $ionicPopup.show({
                title: '',
                template: template,
                scope: $scope,
                cssClass: 'my-custom-popup',
                buttons: [{
                    text: 'OK',
                    type: 'button-assertive',
                    onTap: function () {
                        wealthService.WealthRedirectUrl().then(function (data) {
                            console.log("wealthTokenGeneration", data)
                            if (utilityService.isAndroidPlatform()) {
                                appAvailability.check('com.moneyware.SBIExclusif',
                                    function () {
                                        var url = data.url;
                                        wealthService.inChromeBrowser(url);
                                    },
                                    function () {
                                        var url = "https://play.google.com/store/apps/details?id=com.moneyware.SBIExclusif&hl=us";
                                        wealthService.inChromeBrowser(url);

                                    });
                            } else {
                                appAvailability.check('sbiexclusif://', function () {
                                    var url = data.url;
                                    wealthService.inChromeBrowser(url);
                                }, function () {
                                    var url = "https://itunes.apple.com/in/app/sbi-exclusif/id1072340833?mt=8";
                                    wealthService.inChromeBrowser(url);
                                });
                            }
                        }, function (error) {
                            console.log("error", error)
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                }],
            });
        }

        Vm.transaction = function(accountObj,accno, typeId, indexId, type, amount, transactionFlag, branchName) {
            //$state.go('menu.transaction');
            getAccountDetailsService.accType.accno = '';
            getAccountDetailsService.accType.typeId = '';
            getAccountDetailsService.accType.indexId = '';
            getAccountDetailsService.accType.type = '';
            getAccountDetailsService.accType.amount = '';
            getAccountDetailsService.accType.accno = accno;
            getAccountDetailsService.accType.typeId = typeId;
            getAccountDetailsService.accType.indexId = indexId;
            getAccountDetailsService.accType.type = type;
            getAccountDetailsService.accType.amount = amount;
            getAccountDetailsService.accType.transactionFlag = transactionFlag;
            getAccountDetailsService.accType.branchName = branchName;
            getAccountDetailsService.currency = (accountObj.currency != undefined || accountObj.currency != null) ? accountObj.currency : "" ;
            $state.go('menu.spendAnalysis');
        }

        Vm.applyBorder = function (index) {
            for (var i = 0; i <= 5; i++) {
                if (i == index) {
                    angular.element(document.querySelector('#underline_' + i)).addClass('TopTabs');
                    angular.element(document.querySelector('#blue_lbl_' + i)).addClass('font-link-blue');
                } else {
                    angular.element(document.querySelector('#underline_' + i)).removeClass('TopTabs');
                    angular.element(document.querySelector('#blue_lbl_' + i)).removeClass('font-link-blue');
                }
            }
            $location.hash('underline_' + index);
            $ionicScrollDelegate.anchorScroll();
            $ionicSlideBoxDelegate.slide(index);
            $ionicScrollDelegate.$getByHandle('mybalance').scrollTop(true);
        }
        /* Vm.slideChanged = function (index) {
            for (var i = 0; i <= 5; i++) {
                if (i == index) {
                    angular.element(document.querySelector('#underline_' + i)).addClass('TopTabs');
                    angular.element(document.querySelector('#blue_lbl_' + i)).addClass('font-link-blue');
                } else {
                    angular.element(document.querySelector('#underline_' + i)).removeClass('TopTabs');
                    angular.element(document.querySelector('#blue_lbl_' + i)).removeClass('font-link-blue');
                }
            }
            $location.hash('underline_' + index);
            $ionicScrollDelegate.anchorScroll();
        } */
		
        Vm.accountOpening = function () {
            $state.go('menu.applyNewOrResume');
        }

        Vm.overdraftAcc = function (data, accountCategory, loanAmount, interest) {
            accountOverviewService.customer.ODaccount = data;
            accountOverviewService.customer.accountCategory = accountCategory;
            accountOverviewService.customer.loanAmount = loanAmount;
            accountOverviewService.customer.interest = interest;
            $state.go('menu.overdraftAcc');
        }

        Vm.autoLoanFun = function (autoLoanAccNo, label, branchCode, loanType, index, currency, accountTypeCode, intCategory) {
            getAccountDetailsService.currency = (currency != undefined || currency != null) ? currency : "";
            if (loanType != "" && loanType == "INSTA HOME LOAN") {
                     getAccountDetailsService.autoLoanAccNo = autoLoanAccNo;
                     getAccountDetailsService.autoLoanAccType = loanType;
                     getAccountDetailsService.branchCode = branchCode;     
                    if((accountTypeCode && accountTypeCode == "6400") && (intCategory && intCategory == "2609"))
                    {                     
                        getAccountDetailsService.loanLabel = loanType;                                     
                        getAccountDetailsService.accountTypeCode = accountTypeCode;
                        getAccountDetailsService.intCategory = intCategory;
                        $state.go('menu.autoLoan');
                    }
                    else{
                     var obj = {
                    "accountNumber": getAccountDetailsService.autoLoanAccNo,
                    "type": "loan"
                     };
                instaHomeService.viewInstaHomeLoan(obj).then(function (data) {
    
                    instaHomeService.initialCloseValueStage();
                    if (data) {
                        instaHomeService.viewInstaData.productDescription = data.productDescription;
                        instaHomeService.viewInstaData.customerName = data.customerName;
                        instaHomeService.viewInstaData.accountNumber = data.accountNumber;
                        instaHomeService.viewInstaData.outstandingAmount = data.outstanding;
                        instaHomeService.viewInstaData.remainingDuration = data.remainingDuration;
                        instaHomeService.viewInstaData.emiInterestrates = data.effectiveInterestRates;
                        instaHomeService.viewInstaData.emiAmount = data.emi;
                        instaHomeService.viewInstaData.limitAmount = data.limitAmount;
                        instaHomeService.viewInstaData.currentYearInterest = data.currentYearInterest;
                        instaHomeService.viewInstaData.previousYearInterest = data.previousYearInterest;
                    }
                    $state.go('menu.instaClosure');
                }, function (error) {                   
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });
             }
            } else {
                if (label !== "Pre Approved Personal Loan") {
                    getAccountDetailsService.autoLoanAccNo = autoLoanAccNo;
                    getAccountDetailsService.loanLabel = label;
                    getAccountDetailsService.branchCode = branchCode;
                    getAccountDetailsService.autoLoanAccType = loanType;
                    getAccountDetailsService.accountTypeCode = accountTypeCode;
                    getAccountDetailsService.intCategory = intCategory;
                    $state.go('menu.autoLoan');
                } else {
                    personalLoanService.loanAmount = loanAmount;
                    personalLoanService.duration = remainingEmis;
                    personalLoanService.emiDate = nexteEmiDueDate;
                    personalLoanService.emiAmount = emiAmount;
                    personalLoanService.accountNumber = autoLoanAccNo;
                    personalLoanService.interest = interest;
                    getAccountDetailsService.autoLoanAccType = loanType;
                    $state.go('menu.borrowingsDetails');
                }
            }
        }

        Vm.odDetailsFun = function (AccNo, availableBalance, branchCode, loanType, branchName, accountType, index, currency) {
            getAccountDetailsService.currency = (currency != undefined || currency != null) ? currency : "";
            if (loanType != "" && loanType == "INSTA HOME LOAN") {
                instaHomeService.accountDetailsCloser = [];
                getAccountDetailsService.autoLoanAccNo = AccNo;
                getAccountDetailsService.branchCode = branchCode;
                var acc_number = getAccountDetailsService.autoLoanAccNo;
                var branch_code = getAccountDetailsService.branchCode;
                var obj = {
                    "accountNumber": acc_number,
                    "type": "od"
                };
                instaHomeService.viewInstaHomeLoan(obj).then(function (data) {
                    console.log("viewrdcalldata", data)
                    instaHomeService.initialCloseValueStage();
                    if (data) {
                        instaHomeService.viewInstaData.productDescription = data.productDescription;
                        instaHomeService.viewInstaData.customerName = data.customerName;
                        instaHomeService.viewInstaData.accountNumber = data.accountNumber;
                        instaHomeService.viewInstaData.outstandingAmount = data.outstanding;
                        instaHomeService.viewInstaData.remainingDuration = data.remainingDuration;
                        instaHomeService.viewInstaData.emiInterestrates = data.effectiveInterestRates;
                        instaHomeService.viewInstaData.emiAmount = data.emi;
                        instaHomeService.viewInstaData.limitAmount = data.limitAmount;
                        instaHomeService.viewInstaData.currentYearInterest = data.currentYearInterest;
                        instaHomeService.viewInstaData.previousYearInterest = data.previousYearInterest;
                        instaHomeService.viewInstaData.nightMode = data.nightMode;
                        instaHomeService.viewInstaData.branchName = branchName;
                        instaHomeService.viewInstaData.accountType = accountType;
                    }
                    $state.go('menu.instaClosure');
                }, function (error) {
                    console.log("error", error)
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                 getAccountDetailsService.autoLoanAccNo = AccNo;
            getAccountDetailsService.availableBalance = availableBalance;
            getAccountDetailsService.branchCode = branchCode;
               $state.go('menu.odDetails');
            }

        }
        Vm.recurringDetailsFun = function (AccNo, branchCode, currency) {
            getAccountDetailsService.autoLoanAccNo = AccNo;
            getAccountDetailsService.currency = (currency != undefined || currency != null) ? currency : "";
            var acc_number = getAccountDetailsService.autoLoanAccNo
            rdService.viewRdFullRd(acc_number).then(function (data) {
                rdService.initialCloseValueStage();
                if (data) {
                    rdService.viewRdData.maturityAmount = data.maturityValue;
                    rdService.viewRdData.maturityDate = data.maturityDate;
                    rdService.viewRdData.days = data.termDays;
                    rdService.viewRdData.months = data.termMonths;
                    rdService.viewRdData.years = data.termYears;
                    rdService.viewRdData.iRate = data.interestRate;
                    rdService.viewRdData.mIntruction = data.maturityInstruction;
                    rdService.viewRdData.mop = data.mop;
                    rdService.viewRdData.currentBalance = data.currentBalance;
                    rdService.viewRdData.holdValue = data.holdValue;
                    rdService.viewRdData.accountOpeningDate = data.accountOpeningDate;
                    rdService.viewRdData.rdOutAmount = data.termValue;
                    rdService.viewRdData.accumulatedInterest = data.interestAvailable;
                    rdService.viewRdData.productDescription = data.productDescription;
                    rdService.viewRdData.accountNumber = data.accountNumber;
                    rdService.viewRdData.accountName = data.accountName;
                    // rdService.viewRdData.accountName = data.customerDetails.customerName;
                    rdService.viewRdData.termValue = data.termValue;
                    rdService.viewRdData.transactionDetails = data.transactions;
                    rdService.viewRdData.nightModeFlag = data.nightMode;
                }
                $state.go('menu.rdDetailsClosure');
            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });

        }
        Vm.otherDepositsFun = function (AccNo, branchCode, loanLabel, lienAmount,otherDepos) {
            getAccountDetailsService.autoLoanAccNo = AccNo;
            getAccountDetailsService.branchCode = branchCode;
            getAccountDetailsService.loanLabel = loanLabel;
            getAccountDetailsService.lienAmount = lienAmount;
            ppfExtService.ppfAccDetails = otherDepos;
            $state.go('menu.otherDeposits');
        }

        Vm.openPal = function () {
            personalLoanService.clearAll();
            personalLoanService.getLoanDetails().then(function (data) {

                personalLoanService.personalLoanData = data;
                personalLoanService.minDuration = data.minTenure;
                personalLoanService.maxDuration = data.maxTenure;
                personalLoanService.interestRate = data.interestRate;
                personalLoanService.product = data.productCode;
                personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
                personalLoanService.processingFee = data.processingFee;
                personalLoanService.minBestOffer = data.minPalAmount;
                personalLoanService.activityCode = data.activityCode;
                personalLoanService.schemeCode = data.schemeCode;


                $state.go('menu.personalLoan');

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        // My Deposits Start

        /***Open my dream Detail Page by passing  dream object ***/
        Vm.myDreams = function (dreamObj) {
            myDreamsServices.dreamsObj = {
                dreamsObj: dreamObj
            };
            $state.go('menu.myDreams');
        }

        Vm.createMyDream = function () {
            if(Vm.custResidentialStatus){
                $state.go('menu.createMyDream');
            }
            else {
                $ionicPopup.show({
                    template: '<p>Please contact your Home Branch for updation of Resident Status.</p>',
                    title: '',
                    cssClass: 'dialog',
                    scope: '',
                    buttons: [{
                        text: 'OK',
                        type: 'button-positive'
                    }]
                });
            }
            
        }

        Vm.addFundInMyDreams = function (dreamsData, $event) {
            $event.stopPropagation();
            Vm.dreamID = dreamsData.dreamId;
            var currDreamDetails = {
                "dreamName": dreamsData.label,
                "goalAmount": dreamsData.totalAmount,
                "dreamImage": dreamsData.image,
                "dreamID": Vm.dreamID
            };
            myDreamsServices.addDetails(currDreamDetails);
            $timeout(function () {
                $state.go("menu.dreamAddFund");
            }, 200);
        }

        Vm.myDepostDetailedView = function (selectedFDaccount) {
            fixedDepositService.selectedDetails = {
                accountType: '',
                accountNumber: '',
                accountBalance: '',
                isActive: '',
                isTransactional: '',
                branchCode: '',
                branchName: '',
                intCategory: '',
                accountTypeCode: ''
            };
            fixedDepositService.initializeFDvariables();
            fixedDepositService.customer.indexId = 0;
            fixedDepositService.customer.fdAccountNumber = selectedFDaccount.fdAccountNumber;
            fixedDepositService.customer.startDate = selectedFDaccount.startDate;
            fixedDepositService.customer.modeOfOperation = selectedFDaccount.operational;
            fixedDepositService.customer.lienAmount = selectedFDaccount.lienAmount;
            fixedDepositService.customer.branchCode = selectedFDaccount.branchCode;
            fixedDepositService.customer.branchName = selectedFDaccount.branchName;
            fixedDepositService.customer.scheme = selectedFDaccount.accountType;
            fixedDepositService.customer.intCategory = selectedFDaccount.intCategory;
            fixedDepositService.customer.accountTypeCode = selectedFDaccount.accountTypeCode;
            getAccountDetailsService.currency = (selectedFDaccount.currency != undefined || selectedFDaccount.currency != null) ? selectedFDaccount.currency : "";
            $state.go('menu.fixedDepositDetails');
        }

        $timeout(function () {
            var aov = $ionicScrollDelegate.$getByHandle('horizontalAOV').getScrollView();
            if (!aov) {
                return true;
            }
            var container = aov.__container;
            var originaltouchStart = aov.touchStart;
            var originaltouchMove = aov.touchMove;
            container.removeEventListener('touchstart', aov.touchStart);
            document.removeEventListener('touchmove', aov.touchMove);
            aov.touchStart = function (e) {
                e.preventDefault = function () { }
                originaltouchStart.apply(aov, [e]);
            }
            aov.touchMove = function (e) {
                e.preventDefault = function () { }
                originaltouchMove.apply(aov, [e]);
            }
            container.addEventListener("touchstart", aov.touchStart, false);
            document.addEventListener("touchmove", aov.touchMove, false);
        });
        // My Deposits End

        // My Investmets Start

        Vm.mutualFundsFun = function () {
            $state.go('menu.mutualFunds');
        }
        Vm.linkAccount = function () {
            $state.go('menu.linkAccount');
        }
        Vm.sbiCAPSecurities = function () {
            $state.go("menu.securitiesPortfolio");
        }
        Vm.dematAccountHome = function (dpId) {

            mySecurityProfileService.addDPId(dpId);
            $state.go("menu.dematAccountHome");
        }

        Vm.openAccountAgree = function () {
           Vm.userDetails= mutualFundsService.getUserDetails();           
            openAccountService.setStatusOfOpenAccount(0);
            if(getAccountDetailsService.accountOverviewData.accounts==null || getAccountDetailsService.accountOverviewData.accounts==undefined || getAccountDetailsService.accountOverviewData.accounts==''){
                 homeScreenService.getCustomerInfo().then(function (data) {
	                mutualFundsService.addUserDetails(data.customerInformation, true);
	                mutualFundsService.addUserPanDetails(data.customerInformation);
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "ONLINE_DEMAT_OPEN_NOW"));
            	    $state.go('menu.dematAndTradingAccount');
            },function(error){
                utilityService.enableShowErrorMessage();
            	utilityService.showErrorMessage(error.responseMessage);	
            });
        }else{
            var mobileValidation = /^\d{10}$/;
			if (!mobileValidation.test(Vm.userDetails.mobile)) {
                utilityService.enableShowErrorMessage();
                var errorMsg=$translate.instant("CAP_INVALID_MOBILE");
            	utilityService.showErrorMessage(errorMsg);				
			}else{
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "ONLINE_DEMAT_OPEN_NOW"));
                $state.go('menu.dematAndTradingAccount');
            }
               
            }            

        }
        Vm.openDemat = function () {
            openAccountService.setStatusOfOpenAccount(0);
            utilityService.showSpinner();
            // code added for centralized consent Check
            leadGenerationService.checkConsent().then(function (data) {
                utilityService.hideSpinner();
                if (data.customerRecordExists == "false") {
                    newCardService.setPreLoginSelectedMenu('open');
                    loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
                    $state.go('menu.termsAndConditionsOutboundAnalytics');

                } else {
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "DM_START_NXT_BTN"));
                    $state.go('menu.dematAndTradingAccount');
                }
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        Vm.retrieveOpenAccount = function () {
            openAccountService.setStatusOfOpenAccount(1);
            $state.go('menu.openSecurityAccount');

        }
        // My Investments End

        // My Insurance start
        Vm.gotohomeInsurance = function (data, productID) {
            generalInsurenceHomeService.setLinkedpolicyDetailDetails(data);
            generalInsurenceHomeService.setLinkedpolicyDetailDetailsNew(productID);
            $state.go('menu.myPolicies');
        }

        Vm.myInsurance = function () {
            $state.go('menu.transaction');
        }
        // My Insurance End

        //My Cards

        Vm.showPendingApplication = function () {
            return myCardsVm.showPendingApplication;
        }

        Vm.showIncompleteApplication = function () {
            return myCardsVm.showIncompleteApplication;
        }

        Vm.showLinkCards = function () {
            return !myCardsVm.showLinkCards;
        }

        Vm.showDelinkCards = function () {
            return myCardsVm.showDelinkCards;
        }
        Vm.loadSwarnaGanga = function (index) {
            Vm.SwarnaGangaShowPopup();


        }
        Vm.loadRenewalnewLife = function () {
           Vm.renewalPolicyList= homeScreenService.offersData;
            lifeInsuranceBasicApplicationService.getSbiLifeSmbPolicyRenewalDetails().then(function (response) {
               // Vm.renewalPolicyList = response.record;
                getAccountDetailsService.accountOverviewData.newRenewalPolicy = response.record;
            }, function (error) {

            })
        }
        Vm.loadSwarnaGangaWCMContent = function (index) {
            Vm.insuranceSpinner = true;
            sampoornSurakshaService.loadSwarnaGangaWCMContent().then(function (response) {
                $rootScope.disclaimer = '<p>' + response.message + '</p>';
                Vm.getSwarnaGangaURL();
            }, function (error) {
                Vm.insuranceSpinner = false;
            })

        }
        Vm.getSwarnaGangaURL = function () {
            if (isStaffCustomer.toLowerCase() == 'y') {
                //load suvrna ganga
                sampoornSurakshaService.getSwarnaGangaUrl().then(function (response) {
                    Vm.isStaffCustomer = true;

                    Vm.insuranceSpinner = false;
                    Vm.swarnaGangaUrl = response.url;
                    getAccountDetailsService.accountOverviewData.swarnaGangaUrl = response.url;
                }, function (error) {
                    Vm.emptySSpolicy = true;
                    Vm.insuranceSpinner = false;
                    Vm.insuranceSpinnerError = true;
                })
            }

        }

        Vm.SwarnaGangaShowPopup = function () {
            //if(form.$valid){
            Vm.confirmPopup = $ionicPopup.confirm({
                cssClass: 'dialog',
                title: 'Disclaimer',
                templateUrl: 'pages/lifeInsurance/sampoornSuraksha/swarnaGangaPopUp.html',
                scope: $scope,
                buttons: [
                    { text: '<span class="txt-black">Cancel</span>', onTap: function (e) { $state.go('menu.accountOverviewMyBalance'); } }, {
                        text: 'I Agree',
                        type: 'button-positive',
                        onTap: function (e) {
                            Vm.confirmPopup.then(function (res) {
                                if (res) {
                                } else {
                                    openUrlInAppbroswerService.openUrl(Vm.swarnaGangaUrl, "");


                                }
                            });
                        }
                    }
                ],
            });
            //}

            Vm.confirmPopup.then(function (res) {

            });
        }
        //Renewal
        Vm.newLifeRenewal = function () {
            $state.go('menu.newRenewalHome');
        }
        //Method to load LI linked policies in MyInsurance Tab
        Vm.loadLI = function () {


             Vm.loadSwarnaGangaWCMContent();
            getAccountDetailsService.accountOverviewData.isPolicyRenewal=false;
            linkingLIPolicyService.getLinkedPolicies().then(function (response) {
                Vm.loadSS();
                Vm.loadRR();
                Vm.insuranceSpinner = false;
                if (!utilityService.isUndefined(response.linkedPolicies)) {
                    getAccountDetailsService.accountOverviewData.lifeInsurance=response.linkedPolicies;
                    Vm.liLinkedPolices = response.linkedPolicies;
                    if (response.linkedPolicies.length <= 0) {
                        Vm.emptyLIpolicy = true;
                    }
                } else {
                    Vm.insuranceSpinnerError = true;
                }
            }, function (error) {
                Vm.loadSS();
                Vm.loadRR();
                Vm.emptyLIpolicy = true;
                Vm.insuranceSpinnerError = true;
            });
        }

        Vm.loadSS = function () {
            sampoornSurakshaService.getSsPolicyDetails().then(function (response) {
                Vm.insuranceSpinner = false;
                Vm.ssPolicyDetails = response.sampoornaSurakshaPolicy;
                getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy=response.sampoornaSurakshaPolicy;
                if (response.sampoornaSurakshaPolicy.length == 0) {
                    Vm.emptySSpolicy = true;
                }
            }, function (error) {
                Vm.emptySSpolicy = true;
                Vm.insuranceSpinner = false;
                Vm.insuranceSpinnerError = true;
            });
        }

        Vm.loadRR = function () {
            rrService.getRrPolicyDetails().then(function (response) {
                Vm.insuranceSpinner = false;
                Vm.rrPolicyDetails=[];
                if (response.length == 0) {
                    Vm.emptyRRpolicy = true;
                }else{
                    angular.forEach(response, function (value, key) {
                        if (value.status == 'POLICY ISSUED') {
                            value.status ='Active';
                            Vm.rrPolicyDetails.push(value);
                        }else{
                            Vm.rrPolicyDetails.push(value);
                        }
                    });
               }                                
            }, function (error) {
                Vm.emptyRRpolicy = true;
                Vm.insuranceSpinner = false;
                Vm.insuranceSpinnerError = true;
            });
        }

        Vm.loadForSSEligible = function () {
            sampoornSurakshaService.checkCustomerStatus().then(function (data) {
                Vm.ssProduct = data;
                if (Vm.ssProduct && Vm.ssProduct.customerFlag == 'true') {
                    lifeInsuranceBasicApplicationService.getFSSBannerImages().then(function (response) {
                        if (response.subCategory.length > 0) {
                            for (var i = 0; i < response.subCategory.length; i++) {
                                if (response.subCategory[i].subCode == "sampoorna") {
                                    Vm.ssContent = response.subCategory[i];
                                    if (Vm.ssContent) {
                                        var eligibleSumAssured = String.fromCharCode(8377) + $filter('INR')(Vm.ssProduct.eligibleSumAssured);
                                        Vm.ssContent.message = Vm.ssContent ? Vm.ssContent.message.replace("FIELD_1}}", eligibleSumAssured).replace("Rs. ", String.fromCharCode(8377)) : eligibleSumAssured;
                                    }
                                }
                            }
                        }
                    }, function (error) {
                    });
                }
            }, function (error) {
            });
        }

        //my insurance page for more products
           Vm.browseMoreProductsBanner = function(){
                    $timeout(function() {
                          Vm.bannersInsAfterLoad = "";  
                          Vm.bannersInsAfterLoad= Vm.bannersIns
                        $timeout(function() {                        
                            $ionicSlideBoxDelegate.loop(true);                                                     
                            $ionicSlideBoxDelegate.$getByHandle('insuranceContent').update();                        
                            $ionicSlideBoxDelegate.$getByHandle('insuranceOutbound').enableSlide(true);  
                            $ionicSlideBoxDelegate.$getByHandle('insuranceOutbound').update();
                        }, 1000);
                    });
                }

            Vm.browseMoreProducts = function () {
                $ionicSlideBoxDelegate.$getByHandle('insuranceOutbound').enableSlide(true);  
                $ionicSlideBoxDelegate.$getByHandle('insuranceOutbound').update();
               Vm.bannersIns = [];
                Vm.isAnalyticBanner = [];
                Vm.isNotAnalyticBanner = [];
                generalInsurenceHomeService.browseMoreProducts().then(function(body) {
                   
                        utilityService.showSpinner();
                        if(!utilityService.isUndefined(body)){
                            
                            console.log("bannersnew", Vm.bannersIns);
                            for (var i = 0; i < body.length; i++) {
                                Vm.browseData = body;
                                utilityService.hideSpinner();
                                generalInsurenceHomeService.browseData = Vm.browseData;
                                Vm.yonotCat = Vm.browseData[i].category;
                                Vm.yonoBanners = Vm.browseData[i].banners;
                                if(Vm.yonotCat == 'NON_YONO'){
                                    generalInsurenceHomeService.yonoCat = Vm.yonotCat;
                                }


                                //for banners
                                if (Vm.yonotCat == 'GI') {

                                    angular.forEach(Vm.yonoBanners, function (gi) {
                                        if (gi.isAnalyticsBanner === 'true') {
                                            Vm.isAnalyticBanner.push(gi);
                                            console.log("isAnalyticBanner", Vm.isAnalyticBanner);
                                        } else {
                                            Vm.isNotAnalyticBanner.push(gi);
                                            console.log("isNotAnalyticBanner", Vm.isNotAnalyticBanner);

                                        }
                                    })
                                }

                                //starts LI
                                if (Vm.yonotCat == 'LI') {

                                    angular.forEach(Vm.yonoBanners, function (li) {
                                        if (li.isAnalyticsBanner === 'true') {
                                            Vm.isAnalyticBanner.push(li);
                                            console.log("isAnalyticBanner", Vm.isAnalyticBanner);
                                        } else {
                                            Vm.isNotAnalyticBanner.push(li);
                                            console.log("isNotAnalyticBanner", Vm.isNotAnalyticBanner);

                                        }
                                    })
                                }
                                
                            }

                            //check isNotAnalyticBanner length
                            if (Vm.isAnalyticBanner.length == 2 && (Vm.isNotAnalyticBanner.length >= 1)) {

                                Vm.isNotAnalyticBanner.splice(1);
                               
                            }

                            if (Vm.isAnalyticBanner.length == 1 && Vm.isNotAnalyticBanner.length >= 2) {
                                Vm.isNotAnalyticBanner.splice(2);
                                
                            }

                            if (Vm.isAnalyticBanner.length == 0 && Vm.isNotAnalyticBanner.length >= 2) {

                                Vm.isNotAnalyticBanner.splice(3);
                               
                            }

                            Vm.bannersIns = Vm.isAnalyticBanner.concat(Vm.isNotAnalyticBanner);
                           
                            Vm.browseMoreProductsBanner();
                        }
                
                }, function(error) {
                    
                    utilityService.showErrorMessage(error.responseMessage);

                });

            }

           
            //for insurance banner
            Vm.myInsurBanners = function(){
                if(!$scope.bannerData){
                    generalInsurenceHomeService.getInsuranceBannerPage().then(function(data){
                        $scope.bannerData = data; 
                        var delegate = $ionicSlideBoxDelegate.$getByHandle('banner');
                        delegate.start();
                    }, function(error) {
                        $scope.bannerData = '';
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }

            // Redirect to life insurance after clicking on banner
            Vm.redirectToLifeInsurance = function(value){ 
                if(value == "GI_HOM"){
                    generalInsurenceHomeService.setGIProductsID('health-insurance');
                    newCardService.setPostLoginSelectedMenu('insure');
                    $state.go('menu.declaimer');
                }else if(value == "LI_HOM"){
                    generalInsurenceHomeService.setGIProductsID('personal-accident-insurance');
                    newCardService.setPostLoginSelectedMenu('insure');
                    $state.go('menu.declaimer');
                }else if(value.bannerTitle.indexOf("Sampoorn Suraksha")!=-1){
                    sampoornSurakshaService.getPremiumAndNomineeInfo().then(function(data) {
                        sampoornSurakshaService.clearAll();
                        sampoornSurakshaService.setPremiumDetails(data);
                        $state.go('menu.ssPremiumCalculation', {lifeGeneInsure : true});  
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }else if(value.bannerTitle.indexOf("Rinn Raksha")!=-1){
                    rrService.addRetrive(false);
                    newCardService.setPostLoginSelectedMenu('goRinnRaksha');
                    $state.go('menu.termsAndConditionsOutboundAnalytics');
                }else if(value.bannerTitle.indexOf("Group Health Insurance")!=-1){
                    generalInsurenceHomeService.setGIProductsID('health-insurance');
                    $state.go('menu.declaimer');
                }else if(value.bannerTitle.indexOf("Personal Accident Insurance")!=-1){
                    generalInsurenceHomeService.setGIProductsID('personal-accident-insurance');
                    $state.go('menu.declaimer');
                }
            }

            //for redirect to generalinsurance page from myinsurance banner
            Vm.insurPage = function(){
                $state.go('menu.generalInsurance');
            }
           

        //end GI more browse


        Vm.loadGI = function () {
            //Vm.loadRenewalnewLife();
            // to get GI PAI Policy List
            $ionicSlideBoxDelegate.update();
            Vm.myInsurBanners();
            Vm.browseMoreProducts();
            if (!Vm.isPaiPolicyAvailable) {
                Vm.loadPaiPolicy();
            }
            Vm.loadForSSEligible();
            Vm.renewalPolicyList = homeScreenService.offersData ? homeScreenService.offersData : "";
            Vm.insuranceSpinner = true;
            Vm.insuranceSpinnerError = false;
            Vm.insuranceAvailable = "false";
            Vm.emptyLIpolicy = false;
            Vm.liLinkedPolices = [];
            Vm.emptyGIpolicy = false;
            Vm.emptySSpolicy = false;
            Vm.emptyRRpolicy = false;
            var currentDate = generalInsurenceHomeService.getCurrentDate();
            generalInsurenceHomeService.getLinkedpolicies().then(function (response) {
                pailinkingRenwalService.isGiEmpty = false;
                if (response.products && response.products.length > 0) {
                    if(getAccountDetailsService.accountOverviewData) getAccountDetailsService.accountOverviewData.generalInsurance = response.products;
                    generalInsurenceHomeService.setGIProductList(response.products);
                } else {
                    Vm.genralliLinkedPolices = [];
                }
                Vm.loadLI();
                try {
                    if (!utilityService.isUndefined(response.products)) {
                        Vm.genralliLinkedPolices = response.products;
                        if (response.products.length <= 0) {
                            Vm.emptyGIpolicy = true;
                            Vm.insuranceAvailable = "false";
                        }
                        for (var i = 0; i < Vm.genralliLinkedPolices.length; i++) {
                            Vm.genralliLinkedPolices[i].productName = Vm.genralliLinkedPolices[i].productId;
                            for (var j = 0; j < Vm.genralliLinkedPolices[i].policies.length; j++) {
                                Vm.genralliLinkedPolices[i].policies[j].policyExpireNotificationFlag = false;
                                if(Vm.genralliLinkedPolices[i].policies[j].uin =="15" || Vm.genralliLinkedPolices[i].policies[j].uin =="44"){
                                    var policyEndDate = new Date(Vm.genralliLinkedPolices[i].policies[j].policyValidUntil);
                                    var  todaysDate = new Date();
                                    var diffTime = Math.abs(todaysDate - policyEndDate);
                                    var diffDays = Math.ceil(diffTime / (1000 * 60 * 60 * 24)); 
                                    if(diffDays <= 30){
                                        Vm.genralliLinkedPolices[i].policies[j].policyExpireNotificationFlag = true;
                                    }
                                }
                                if (new Date(currentDate).getTime() >= new Date(Vm.genralliLinkedPolices[i].policies[j].policyValidUntil).getTime()) {
                                    Vm.genralliLinkedPolices[i].policies[j].status = $translate.instant("Expired");
                                } else {
                                    Vm.genralliLinkedPolices[i].policies[j].status = $translate.instant("Active");
                                }
                            }
                        }
                        generalInsurenceHomeService.getAllGIProducts().then(function (data) {
                            for (var i = 0; i < Vm.genralliLinkedPolices.length; i++) {
                                for (var count = 0; count < data.products.length; count++) {
                                    if (data.products[count].productId == Vm.genralliLinkedPolices[i].productId) {
                                        Vm.genralliLinkedPolices[i].productName = data.products[count].productName;
                                        break;
                                    }
                                }
                            }
                        }, function (error) {

                        });
                        if (response.products.length > 0) {
                            Vm.insuranceSpinner = false;
                            Vm.insuranceAvailable = "true";
                        }
                    }
                } catch (err) { }
            }, function (error) {
                Vm.loadLI();
                Vm.emptyGIpolicy = true;
                Vm.insuranceSpinner = false;
                Vm.insuranceSpinnerError = true;
            });
        }

        Vm.gotoLiGiRetreiveApplication = function () {
            $state.go('menu.retreiveApplication');
        };

        Vm.getLinkedCards = function () {
            Vm.cardsSpinner = true;
            if (Vm.showLinkedSection === true) {
                Vm.cardsSpinner = false;
            }
            Vm.showNoCardsMsg = false;
            linkCardService.getLinkedCards({})
                .then(function (response) {
                    cardsService.errorLogger(response);
                    switch (response.responseCode) {
                        case cardConfig.responseCode["success"]:
                            if (response) {
                                Vm.cardList = (response.data.cards) ? response.data.cards : [];
                                for (var i = 0; i < Vm.cardList.length; i++) {
                                    Vm.cardList[i].oldCardNumber = Vm.cardList[i].cardNumber.match(new RegExp('.{1,4}', 'g')).join("-");
                                    if(Vm.cardList[i].dueDate){
                                         Vm.cardList[i].dueDate = Vm.cardList[i].dueDate.replace(/-/g," ");
                                    }
                                    else{
                                         Vm.cardList[i].dueDate = "";
                                    }       
                                }
                                getAccountDetailsService.accountOverviewData.cards = response.data;
                                cardsService.setCardList(Vm.cardList);
                                Vm.showLinkCards = (Vm.cardList.length) ? false : true;
                                Vm.showLinkedSection = (Vm.cardList.length) ? true : false;
                                Vm.showNoCardsMsg = (Vm.cardList.length) ? false : true;
                                Vm.showDelinkCards = (Vm.cardList.length) ? true : false;
                                Vm.cardsSpinner = false;
                                getAccountDetailsService.responseData = true;
                                getAccountDetailsService.response = response;
                                if(Vm.cardList && Vm.cardList.length > 0){
                                    $ionicSlideBoxDelegate.update();
                                    $ionicSlideBoxDelegate.loop(true);
                                    Vm.carddetailsUpdate($scope.myActiveSlide);
                                }
                                //$ionicSlideBoxDelegate.start();
                                //cards corousel - addopacity and height adjust
                                if(Vm.cardList && Vm.cardList.length > 0){
                                    setTimeout(function(){ 
                                        var classAdd = document.getElementsByClassName('card-baner')[0];
                                        if(classAdd.getElementsByClassName('removeOpacity')[0]){
                                            var temp = classAdd.getElementsByClassName('removeOpacity')[0];
                                            temp.getElementsByClassName('subcontentcard-slide')[0].classList.remove("removeSliderCss")
                                            classAdd.getElementsByClassName('removeOpacity')[0].classList.remove("removeOpacity");
                                        }                                
                                        classAdd.querySelectorAll("[data-index]")[$scope.myActiveSlide].classList.add("removeOpacity");
                                        var tempclasspath = classAdd.getElementsByClassName('removeOpacity')[0];
                                        tempclasspath.getElementsByClassName('subcontentcard-slide')[0].classList.add("removeSliderCss");
                                       
                                        
                                    }, 500);
                                }
                                 utilityService.hideSpinner();  
                            }
                            break;
                    }
                    
                }, function (error) {
                    utilityService.hideSpinner();
                    Vm.cardsSpinner = false;
                    Vm.showLinkCards = false;

                    if (Vm.showLinkedSection == false) {
                        Vm.showDelinkCards = false;
                    }                    
                });
        };

      Vm.goCardsOverview = function (index) {
            var responseData = {
                primaryCardSelected: index
            }
            cardsService.setParams(responseData);

            cardCompareService.policyWrapper = Vm.cardList[index].policyWrapper;
            if (cardCompareService.policyWrapper.accountInformation !== 'Approved' && cardCompareService.policyWrapper.cardStatement !== 'Approved' && cardCompareService.policyWrapper.login !== 'Approved') {
                var loginError = {
                    cssClass: 'sbi-alert-popup',
                    template: '<div class="text-align-center font-content roboto-regular" translate="LOGIN_FAILED_WRAPPER" ></div>',
                    buttons: [{
                        text: cardConfig.buttons.OK_LABEL,
                        type: 'button-positive'
                    }]
                };
                cardsService.alertModal(loginError, null);
            } else {
                var addOnCardPayload = {
                    "cardNumber": Vm.cardList[index].cardNumber
                };
                utilityService.showSpinner();
                payNowServices.getAddOnCards(addOnCardPayload).then(function (response) {
                    if (response.data && response.data.cards) {
                        cardsService.setParams({
                            "addOnCards": response.data.cards || []
                        });
                        utilityService.hideSpinner();
                        $state.go('menu.cardOverview');
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        };

        Vm.retreiveTrack = function () {
            $state.go('menu.retrieveTrackApplication');
        }

        Vm.LinkCreditCards = function () {
            // linkCardService.LinkCreditCards({}).then(
            //     function (response) {
            //         cardsService.errorLogger(response);
            //         floatingMenuService.getRedirectionMessage().then(function (response) {
            //             cardsService.errorLogger(response);
            //             if (response.data && response.data.message) {
            //                 cardsService.setParams({
            //                     "rewardsAgreeContent": response.data.message
            //                 });
            //                 $state.go("menu.rewardsAgree");
            //             }
            //         }, function (error) {
            //             utilityService.showErrorMessage(error.responseMessage);
            //         });
            //         floatingMenuService.setParams({
            //             "sourceRedirect": "linkCard"
            //         });
            //     },
            //     function (error) {
            //     });
            myBalanceService.LinkCreditCards();
        }

        

        Vm.showAmountforGI = function (data) {
            if (data.uin == '55') {
                return $filter('currency')(data.sumInsured, '$', 0);
            } else {
                return $filter('rupeeSymbol')(data.sumInsured);
            }

        }
		
		Vm.needAnalysis = function () {			
			if (cardCompareService.shikharFlag == true || cardCompareService.shikharFlag == "true") {
				$state.go('menu.shikharCards');
			} else if (cardCompareService.shikharFlag == false || cardCompareService.shikharFlag == "false") {
				newCardService.needAnalysis();
			} else {
				utilityService.showErrorMessage("Unable to connect. Please try after some time");
			}
		};

        Vm.getNewCreditCard = function () {
            homeScreenService.ishamburgerMenuApplyNewCard = false;
            if (!cardCompareService.shikharFlag) {
                cardCompareService.getShikharEligibilityCheck().then(function (response) {
                    cardCompareService.shikharFlag = response.data.shikharFlag;
                    if (cardCompareService.shikharFlag == true || cardCompareService.shikharFlag == "true") {
                        //$state.go('menu.shikharCards');
						newCardService.browseCards();
                    } else if (cardCompareService.shikharFlag == false || cardCompareService.shikharFlag == "false") {
                        //$state.go('menu.cardIntroduction');
                        newCardService.browseCards();
                    } else {
                        utilityService.showErrorMessage("Unable to connect. Please try after some time");
                    }
                }, function (error) {
                    cardCompareService.shikharFlag = "";
                });
            } else {
                if (cardCompareService.shikharFlag == true || cardCompareService.shikharFlag == "true") {
                    //$state.go('menu.shikharCards');
					newCardService.browseCards();
                } else if (cardCompareService.shikharFlag == false || cardCompareService.shikharFlag == "false") {
                    //$state.go('menu.cardIntroduction');
                    newCardService.browseCards();
                } else {
                    utilityService.showErrorMessage("Unable to connect. Please try after some time");
                }
            }
        };

        // My cards end

        //Track application in security

        Vm.trackSecurityApplication = function () {
           utilityService.showSpinner();
            dematService.trackApplicationDematAO().then(function(data){
				utilityService.hideSpinner();
                dematService.trackStatusData = data;
                $state.go('menu.appStatus');
			},function(error){
				utilityService.hideSpinner();
                utilityService.enableShowErrorMessage();
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
                utilityService.disableShowErrorMessage();
			})
        }

         Vm.ClosePopup = function () {
             Vm.SuccessPop.close();
         }
        /** Open account form in MF**/
        Vm.openMFAccount = function () {
            $state.go('menu.portfolio');
        }


         Vm.getAllMFPortfolioData=function(){
            if (!mutualFundsService.multiFolio) {
                var reqParams = {};
                utilityService.showSpinner();
                mutualFundsService.getPortfolio().then(function (data) {
                    Vm.whiteListedUser = true;
                    Vm.investmentSpinner = false;
                    data = data.multiFolio;
                    Vm.folioNumber = true;
                    mutualFundsService.multiFolio = data;
                    angular.forEach(mutualFundsService.multiFolio.portFolio, function (value, key) {
                        if (value.isLotusfolio.toLowerCase() == "yes") {
                            Vm.isLotusFolio = 1;
                        }
                    });
                    if (!Vm.MyInvestmentsAmount) {
                        Vm.MyInvestmentsAmount = "";
                    }
                    if (Vm.totalMFCurrent) {
                        if (valueofSecurities != '') {
                            Vm.MyInvestmentsAmount = parseFloat(valueofSecurities) + parseFloat(Vm.totalMFCurrent);
                        } else {
                            Vm.MyInvestmentsAmount = parseFloat(Vm.MyInvestmentsAmount) + parseFloat(Vm.totalMFCurrent);
                        }
                    } else {
                        Vm.MyInvestmentsAmount = Vm.MyInvestmentsAmount + 0;
                    }
                    Vm.totalMFCurrent = data.totalCurrentValue;
                   var secTotal= mutualFundsService.getTotalSecurities();
                   if(secTotal != null || secTotal != undefined || secTotal !=""){
                       Vm.MyInvestmentsAmount= (Vm.totalMFCurrent?parseFloat(Vm.totalMFCurrent):0) + (secTotal?parseFloat(secTotal):0);
                   }
                    mutualFundsService.addTotalMyInvetmentAmount(Vm.totalMFCurrent);
                    utilityService.hideSpinner();
                }, function (error) {
                    utilityService.hideSpinner();
                    Vm.investmentSpinner = false;
                    Vm.investmentTryAgain = false;
                });
            } else {
                Vm.investmentSpinner = false;
                Vm.folioNumber = true;
                Vm.totalMFCurrent = mutualFundsService.multiFolio.totalCurrentValue;
                angular.forEach(mutualFundsService.multiFolio.portFolio, function (value, key) {
                    if (value.isLotusfolio.toLowerCase() == "yes") {
                        Vm.isLotusFolio = 1;
                    }
                });
                utilityService.hideSpinner();
            }
         }
        //Get Mutual fund current Value
        Vm.getMFPortfolio = function () {
            Vm.totalMFCurrent = '';

            Vm.whiteListedUser = false;
            Vm.investmentSpinner = true;
            Vm.investmentTryAgain = false;
            Vm.folioNumber = false;
            Vm.cbsPan = mutualFundsService.getUserDetails().panNumber;
            Vm.panCard = Vm.cbsPan;
            utilityService.showSpinner();

            var reqPara = {};
            reqPara['id'] = '';
            mutualFundsService.getPanCardNumber(reqPara).then(function (data) {
                Vm.getAllMFPortfolioData();
            }, function (error) {
                Vm.getAllMFPortfolioData();
            });

        }

        Vm.checkDematApplicationExists=function(){
            openAccountService.checkDematApplicationExists().then(function(data){
                (data.applicationStatus == null || data.applicationStatus.trim() == "" || data.applicationStatus.toLowerCase() == "initiated") ? Vm.appStatus = "initiated" : Vm.appStatus = data.applicationStatus;
            },function(error){
                Vm.appStatus = "error";
            })
        }

        //Get security Current value and DPLIST
        Vm.getSecurityProfile = function () {
            Vm.displaySettingsSpinner = true;
            Vm.displaySettingsTryAgain = false;
            Vm.checkDematApplicationExists();
            mySecurityProfileService.getSecProfile().then(function (data) {
                Vm.securities = data.securities;
                 mutualFundsService.totalSecurities=Vm.securities;
                if (!Vm.MyInvestmentsAmount) {
                    Vm.MyInvestmentsAmount = "";
                }
                if (!Vm.securities.currentValue) {
                    Vm.securities.currentValue = data.securities.currentValue
                }
                if (!parseFloat(valueOfPortfolio)) {
                    Vm.MyInvestmentsAmount = 0;
                }
                if (Vm.securities.currentValue) {
                    if (valueOfPortfolio != '') {
                        Vm.MyInvestmentsAmount = parseFloat(valueOfPortfolio) + parseFloat(Vm.securities.currentValue);
                    } else {
                        Vm.MyInvestmentsAmount = parseFloat(Vm.MyInvestmentsAmount) + parseFloat(Vm.securities.currentValue);
                    }
                } else {
                    Vm.MyInvestmentsAmount = parseFloat(valueOfPortfolio) + 0;
                }
                var mfInvestedValue=mutualFundsService.getTotalMyInvetmentAmount();
                if(mfInvestedValue != null || mfInvestedValue != undefined || mfInvestedValue != ''){
                    //Vm.MyInvestmentsAmount = parseFloat(mfInvestedValue)? + parseFloat(Vm.securities.currentValue);
                    Vm.MyInvestmentsAmount = (mfInvestedValue ? parseFloat(mfInvestedValue):0 ) + (Vm.securities.currentValue?parseFloat(Vm.securities.currentValue):0);
                }
                mutualFundsService.addTotalSecurities(parseFloat(Vm.securities.currentValue));
                Vm.displaySettingsSpinner = false;
            }, function (error) {
                Vm.getMFPortfolio();
                Vm.displaySettingsSpinner = false;
                Vm.displaySettingsTryAgain = true;
                if (!Vm.MyInvestmentsAmount) {
                    Vm.MyInvestmentsAmount = "";
                }
            });
        }

        /*** Function to go to Mutual Funds List Page  ***/
        Vm.quickBuy = function (newFundPara) {
            
            var nfoArray=[];
            var filterArray=[];
            $ionicLoading.show({
                template: '<ion-spinner icon="android"></ion-spinner>'
            });

            Vm.fundsListInMF = mutualFundsService.getFundList();
            if(newFundPara==1){                   
                    mutualFundsService.addNewFundDetails("true");
                }else{
                     mutualFundsService.addNewFundDetails("false");
                }

            if (!Vm.fundsListInMF) {                
                mutualFundsService.getAllMutualFunds().then(function (data) {
                    if(data.fundList.length > 5){
                    angular.forEach(data, function (value, key) {
                        for(var i in value){
                          if (value[i].fundSchemeName == "NFO") {
                           nfoArray.push(data.fundList[i]);
                           data.fundList.splice(i,1);
                           data.fundList.splice(1,0,nfoArray[0]);
                        }  
                    }                    
                });
                }
                    
                    //data.fundList.splice(1,0,data.fundList[4])
                    Vm.popularFunds = data.fundList;
                    mutualFundsService.addFundList(Vm.popularFunds);
                    $ionicLoading.hide();
                    mutualFundsService.setPageId('quickBuy');
                    $state.go('menu.mutualFundsList');
                }, function (error) {
                    $ionicLoading.hide();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                $ionicLoading.hide();
                mutualFundsService.setPageId('quickBuy');
                $state.go('menu.mutualFundsList');
            }
        }


        Vm.npsLanding = function () {



            var requestData = {};

            if (!npsServices.NPSDetails) {

                $q.all([npsServices.checkNPSApplication(requestData), npsServices.getNPSDetails(requestData)]).then(function (response) {
                    npsServices.setResumeData(response[0]);
                    npsServices.NPSDetails = response[1].data;
                    $state.go('menu.landingNPSView');
    
                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                
                npsServices.checkNPSApplication(requestData).then(function (response) {

                    npsServices.setResumeData(response);
                    $state.go('menu.landingNPSView');

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });

            }

        }

        Vm.getPanCard = function () {
            var reqParams = {};
            reqParams['id'] = '';
            mutualFundsService.getPanCardNumber(reqParams).then(function (data) {
            }, function (error) {
            });
        }

        Vm.getServerUrl = function () {
            var q = $q.defer();
            mutualFundsService.getServerUrl().then(function (data) {
                q.resolve(data);
            }, function (error) {
                q.reject(error);
            });
            return q.promise;
        }

         Vm.createFolio = function () {
            if(!getAccountDetailsService.accountOverviewData.customerInformation.panNumber){
                 utilityService.enableShowErrorMessage();   
                 utilityService.showErrorMessage($translate.instant('MF_NEW_PAN__MAN_ERR'));
                 utilityService.disableShowErrorMessage();
            }else{
            Vm.getServerUrl().then(function (data) {
                Vm.URL = data;
                Vm.panCard = Vm.URL.kycNo;
                if (Vm.panCard == '' || Vm.panCard == null || Vm.panCard == undefined) {
                    $rootScope.isCreateFolio = 1;
                    $rootScope.checkStatusPage = 1;
                    $rootScope.kycCompliant = 0;
                    $rootScope.kycNonCompliant = 0;
                    $state.go('menu.KYC');
                } else {
                    Vm.checkKycStatus();
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        }

        //kyc check for create folio user
        /***Function to check KYC Status***/
        Vm.checkKycStatus = function (formData) {
            var pageContent = "";
            var pageContentUrl = "";
            $rootScope.isCreateFolio = 1;
            // $rootScope.ekycPan=Vm.panCard.toUpperCase();
            Vm.sessionId = utilityService.getRandomNumber();
            //clickStreamService.clickStreamData=Vm.sessionId;
            // Vm.kycData = Vm.panCard.toUpperCase() + '|' + Vm.emailId + '|' + Vm.mobile + '|sbiApp|' + Vm.URL.camsUserId + '|' + Vm.URL.camsPwd + '|L||sess_id';

            var reqPara = {};
            reqPara['panId'] = Vm.panCard.toUpperCase();
            mutualFundsService.getEncryptString(reqPara).then(function (data) {
                Vm.encKycData = JSON.parse(data.encryptedString).data.responseString;

                pageContent = '<html><head></head><body><form id="form_Id" enctype="application/x-www-form-urlencoded" name="cbsulogin" action="' + Vm.URL.camsUrl + '" method="POST">' +
                    '<input type="hidden" name="url" value="' + Vm.URL.mobileUrl + '">' +
                    '<input type="hidden" name="ekyctype" value="E">' +
                    '<input type="hidden" name="kyc_data" value="' + Vm.encKycData + '">' +
                    '</form> <script type="text/javascript">document.getElementById("form_Id").submit();</script></body></html>';

                pageContentUrl = 'data:text/html;base64,' + btoa(pageContent);
                var ref = cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
                    statusbar: { color: '#ffffffff' },
                    toolbar: {
                        height: 37,
                        color: '#ffffffff',
                        image: 'share'
                    }, closeButton: {
                        image: 'back',
                        height: 37,
                        width: 32,
                        align: 'left',
                        event: 'closePressed'
                    }, backButtonCanClose: true
                });

                ref.addEventListener('loadstart', function (event) {
                    var URL = event.url;
                    var n = URL.indexOf("result");
                    if (n == -1) {
                        return;
                    }
                    if (n) {
                        var sessId = '';
                        var result = URL.split('?')[1];
                        result = result.split("=")[1];
                        result = decodeURIComponent(result).toString();
                    }
                    mutualFundsService.getDecryptString(result).then(function (data) {
                        try {
                            var resultData = JSON.parse(data.plainString);
                            resultData = resultData.data.responseString.split("|")[2];
                            resultData = resultData.replace('&sess_id', '');
                            Vm.todayDate = $scope.currentDate.setDate($scope.currentDate.getDate());
                            Vm.ekycType = JSON.parse(data.plainString).data.responseString.split("|")[0];
                        } catch (e) {
                            ref.close();
                        }
                        if (n != -1) {
                            if (Vm.ekycType == 'Y' || resultData == 'KS100') {
                                Vm.reqParams = {
                                    "mfKyc": {
                                        "panNo": Vm.panCard,
                                        "aadharNo": Vm.aadhaarCard,
                                        "gender": Vm.gender,
                                        "dob": Vm.dob,
                                        "ekycStatus": "Submitted",
                                        "aofStatus": "",
                                        "ekycType": Vm.ekycType,
                                        "ekycTimeStamp": Vm.todayDate,
                                        "ekycMaxInvestmentLimit": ""
                                    }
                                };
                                utilityService.showSpinner();
                                mutualFundsService.checkKYCStatus(Vm.reqParams).then(function (data) {
                                    if (data.id) {
                                        var reqParams = {};
                                        reqParams['id'] = '';
                                        mutualFundsService.getPanCardNumber(reqParams).then(function (data) {
                                            Vm.divPayOutMechanism = data.mfKyc.divPayOutMechanism;
                                            Vm.redPayOutMechanism = data.mfKyc.redPayOutMechanism;
                                            Vm.applicationStatus = data.mfKyc.aofStatus;
                                            mutualFundsService.addeKycPanDetails(Vm.URL.kycNo);
                                            $rootScope.kycCompliant = 1;
                                            $rootScope.checkStatusPage = 0;
                                            $rootScope.kycNonCompliant = 0;
                                            utilityService.hideSpinner();
                                            $state.go('menu.KYC');
                                        }, function (error) {
                                            utilityService.hideSpinner();
                                            utilityService.showErrorMessage(error.responseMessage);
                                        });
                                    }
                                }, function (error) {
                                    utilityService.hideSpinner();
                                    utilityService.showErrorMessage(error.responseMessage);
                                });
                            } else if (Vm.ekycType == 'N' || resultData == 'KS101') {
                                $rootScope.kycCompliant = 0;
                                $rootScope.checkStatusPage = 0;
                                $rootScope.kycNonCompliant = 1;
                                $state.go('menu.KYC');
                            } else {
                                if (resultData == 'KS102') {
                                    Vm.showInformationPopup("KYC status is incomplete, please update KYC with your current KRA through Point of Service of any Intermediary");
                                } else if (resultData == 'EK-999') {
                                    Vm.showInformationPopup("Internal Error.Retry after some time");
                                } else {
                                    Vm.showInformationPopup("Internal Error.Retry after some time");
                                }
                            }
                            ref.close();
                        }
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    })
                });
                ref.addEventListener('loadstop', function (event) {

                });
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            })
        }

        /***Function to show alert POP UP***/
        Vm.showInformationPopup = function (message) {
            var infoPopup = $ionicPopup.show({
                template: '<p>' + message + '</p>',
                title: 'Alert',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'Ok',
                    onTap: function (e) {
                        $state.go('menu.accountOverviewMyBalance');
                    }
                }]
            });
        }
        //My investment ends

        //one time initialization to be done when the controller is loaded
        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSlideBoxDelegate.update();
            try{
            utilityService.doNotShowSpinner();
            utilityService.hideSpinner();
            utilityService.disableShowErrorMessage();
            $ionicSlideBoxDelegate.enableSlide(false);
            initPage();
            Vm.showloadMyNewAccountLink();
			}catch(err){}
			$ionicSlideBoxDelegate.$getByHandle('slideContent').update();
			if(getAccountDetailsService.responseData){
        		var response = getAccountDetailsService.response;
                Vm.cardList = (response.data.cards) ? response.data.cards : [];
                cardsService.setCardList(Vm.cardList);
                Vm.showLinkCards = (Vm.cardList.length) ? false : true;
                Vm.showLinkedSection = (Vm.cardList.length) ? true : false;
                Vm.showNoCardsMsg = (Vm.cardList.length) ? false : true;
                Vm.showDelinkCards = (Vm.cardList.length) ? true : false;
                Vm.cardsSpinner = false;
                if (getAccountDetailsService.accountOverviewData) {
                    getAccountDetailsService.accountOverviewData.cards = response.data;
                }
                                
           }
        });

        $scope.$on('$ionicView.afterEnter', function () {
            if(getAccountDetailsService.tabIndex.tabIndex === 6){
                Vm.getAccountList();
                Vm.getAboutWearableContent();
            }
            checkResidentialStatus();

        });

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function () {
            utilityService.doNotShowSpinner();
            utilityService.enableShowErrorMessage();
        });

        Vm.getAvgBalance = function () {
            if (Vm.lineGraphData) {
                return;
            }
            getAccountDetailsService.getAvgBalance().then(function (lineGraphData) {
                Vm.lineGraphData = lineGraphData;
                if (lineGraphData.grapLable.length > 0) {
                    Vm.graphDisplay = true;
                    getAccountDetailsService.dataDisplay.graphDisplay = Vm.graphDisplay;
                    var lineChartData = {
                        labels: lineGraphData.grapLable,
                        datasets: [{
                            fillColor: "rgba(220,220,220,0)",
                            strokeColor: "#0095da",
                            pointColor: "#0095da",
                            data: lineGraphData.grapAmount,
                        }],
                    }

                    ChartNewObject.defaults.global.animationSteps = 30;
                    ChartNewObject.defaults.global.tooltipYPadding = 8;
                    ChartNewObject.defaults.global.tooltipCornerRadius = 0;
                    ChartNewObject.defaults.global.tooltipTitleFontStyle = "normal";
                    ChartNewObject.defaults.global.tooltipFillColor = "rgba(0,160,0,0.8)";
                    ChartNewObject.defaults.global.animationEasing = "easeOutBounce";
                    ChartNewObject.defaults.global.responsive = true;
                    ChartNewObject.defaults.global.scaleLineColor = "#bebcbf";
                    ChartNewObject.defaults.global.scaleFontSize = 14;

                    var ctx = document.getElementById('averageMonthlyBalanceChart').getContext('2d');

                    var LineChartDemo = new ChartNewObject(ctx).Line(lineChartData, {
                        pointDotRadius: 3,
                        bezierCurve: false,
                        scaleShowVerticalLines: true,
                        scaleGridLineColor: "#e3e4e4",
                        scaleShowLabels: true,
                        showTooltips: false,
                        scaleOverride: true,
                        datasetStrokeWidth: 1,
                        scaleSteps: lineGraphData.grapAmount.length, //noof steps
                        scaleStepWidth: lineGraphData.stepSize, //stepsize
                        scaleStartValue: lineGraphData.min, //min
                        onAnimationComplete: function () {
                            var ctx = this.chart.ctx;
                            ctx.font = this.scale.font;
                            ctx.fillStyle = this.scale.textColor
                            ctx.textAlign = "center";
                            ctx.textBaseline = "bottom";

                            this.datasets.forEach(function (dataset) {
                                dataset.points.forEach(function (points) {
                                    var coordinateData = "\u20B9\u0020" + points.value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
                                    ctx.fillText(coordinateData, points.x + 33, points.y + 5);
                                });
                            })
                        }
                    });
                }
            }, function (error) {
                //utilityService.showErrorMessage(error.responseMessage);
            });
        }

        Vm.redirect = function () {
            getAccountDetailsService.getTermsAndConditions().then(function (data) {
                Vm.disclaimer(data.contentMessage);
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        Vm.disclaimer = function (rewardsTnC) {
            Vm.rewardsTnC = rewardsTnC;
            Vm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/accountOverview/headerTabs/disclaimerPopup.html",
                scope: $scope
            });
        };

        Vm.cancel = function () {
            Vm.myPopup.close();
        };

        Vm.agree = function () {
            Vm.myPopup.close();
            var tokenContent="";
            var tokenContentUrl="";
            getAccountDetailsService.generateToken().then(function (data) {
                tokenContent = '<html>' +
                    '<head></head>' +
                    '<body>' +
                    '<form id="myRewardTokenForm" enctype="application/x-www-form-urlencoded" name="myRewardTokenForm" action="'+data.RedirectUrl+'" method="POST">' +
                    '<input type="hidden" name="token" value="'+data.Token+'">' +
                    '</form>' +
                    '<script type="text/javascript">document.getElementById("myRewardTokenForm").submit();</script>' +
                    '</body>' +
                    '</html>';

                tokenContentUrl = 'data:text/html;base64,' + btoa(tokenContent);

                var refInAppBrowser = cordova.ThemeableBrowser.open(tokenContentUrl, '_blank', {
                    statusbar: {
                        color: '#ffffffff'
                    },
                    toolbar: {
                        height: 37,
                        color: '#ffffffff',
                        image: 'share'
                    },

                    closeButton: {
                        image: 'back',
                        height: 37,
                        width: 32,
                        align: 'left',
                        event: 'closePressed'
                    },
                    backButtonCanClose: true
                });

                refInAppBrowser.addEventListener('loadstart', function (event) {});
                refInAppBrowser.addEventListener('loadstop', function (event) {});
                refInAppBrowser.addEventListener('closePressed', closePressedcallback);
            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });
        };
        function closePressedcallback() {

        }

        Vm.startDatePicker = {
            callback: function (val) {
                var date = new Date(val);
                Vm.startDate = date;
                Vm.disableEndDate = false;
                Vm.endDate = "to";
            },
            closeLabel: 'Close',
            dateFormat: 'dd MMM yyyy',
            monthsList: ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"],
            inputDate: new Date(),
            //from : new Date().setFullYear(new Date().getFullYear() - 2),
            to: new Date(),
            mondayFirst: true,
            closeOnSelect: true,
            templateType: 'popup'
        };

        Vm.endDatePicker = {
            callback: function (val) {
                var date = new Date(val);
                Vm.endDate = date;
                Vm.getDateRangeSummary();
            },
            closeLabel: 'Close',
            dateFormat: 'dd MMM yyyy',
            monthsList: ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"],
            inputDate: new Date(),
            from: new Date(),
            to: new Date(),
            mondayFirst: true,
            closeOnSelect: true,
            templateType: 'popup'
        };

        /* Open the date picker popup */
        Vm.openStartDatePicker = function () {
            if (utilityService.isAndroidPlatform()) {
                if (Vm.startDate instanceof Date) {
                    Vm.startDatePicker.inputDate = new Date(Vm.startDate.getFullYear(), Vm.startDate.getMonth(), Vm.startDate.getDate());
                }
                ionicDatePicker.openDatePicker(Vm.startDatePicker);
            } else {
                var todayInPicker = new Date();
                var maxDateInPicker = todayInPicker;
                var minDateInPicker = new Date(todayInPicker.getFullYear() - 2,todayInPicker.getMonth(),todayInPicker.getDate());        
                $scope.dateOptions = {
                    maxDate: maxDateInPicker,
                    minDate: minDateInPicker,
                    formatYear: 'yy',
                    startingDay: 1
                }
                var datePickerPopup = $ionicPopup.show({
                    cssClass: 'rewards-datepicker-popup',
                    template: '<div class="datePickerBlock font-size-14">'+
                        '<input type="text" datepicker="dd MMM yyyy" ng-model="dateobj.dt" max-date="dateOptions.maxDate" min-date="dateOptions.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>'+
                        '</div>',
                    scope: $scope, 
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (res) {
                            datePickerPopup.close();
                        }
                    },{
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (res) {
                            Vm.startDate = $scope.dateobj.dt;
                            Vm.disableEndDate = false;
                            Vm.endDate = '';
                            datePickerPopup.close();
                        }
                    }],
                })
            }
        };

        Vm.openEndDatePicker = function () {
            if (utilityService.isAndroidPlatform()) {
                if (Vm.startDate instanceof Date) {
                    Vm.endDatePicker.inputDate = new Date(Vm.startDate.getFullYear(), Vm.startDate.getMonth(), Vm.startDate.getDate());
                    Vm.endDatePicker.from = new Date(Vm.startDate.getFullYear(), Vm.startDate.getMonth(), Vm.startDate.getDate());
                    var todaysDate = new Date();
                    var afterSixMonthDate = new Date(Vm.startDate.getFullYear(), Vm.startDate.getMonth() + 6, Vm.startDate.getDate());
                    Vm.endDatePicker.to = (todaysDate < afterSixMonthDate) ? todaysDate : afterSixMonthDate;
                }
                if (Vm.endDate instanceof Date) {
                    Vm.endDatePicker.inputDate = new Date(Vm.endDate.getFullYear(), Vm.endDate.getMonth(), Vm.endDate.getDate());
                }
                ionicDatePicker.openDatePicker(Vm.endDatePicker);
            } else {
                if(Vm.startDate){
                var todaysDate = new Date();
                var minDateInPicker = new Date(Vm.startDate);
                var maxDateInPicker = new Date(minDateInPicker.getFullYear(),minDateInPicker.getMonth() + 6, minDateInPicker.getDate());        
                $scope.dateOptions = {
                    maxDate: (todaysDate < maxDateInPicker) ? todaysDate : maxDateInPicker,
                    minDate: minDateInPicker,
                    formatYear: 'yy',
                    startingDay: 1
                }
                var datePickerPopup = $ionicPopup.alert({
                    cssClass: 'rewards-datepicker-popup',
                    template: '<div class="datePickerBlock font-size-14">'+
                        '<input type="text" datepicker="dd MMM yyyy" ng-model="dateobj.dt" max-date="dateOptions.maxDate" min-date="dateOptions.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>'+
                        '</div>',
                        scope: $scope, 
                        buttons: [{
                            text: 'Cancel',
                            type: 'button-negative',
                            onTap: function (res) {
                                datePickerPopup.close();
                            }
                        },{
                            text: 'OK',
                            type: 'button-positive',
                            onTap: function (res) {
                                Vm.endDate = $scope.dateobj.dt;
                                datePickerPopup.close();
                                Vm.getDateRangeSummary();
                            }
                        }],
                    })
                } else {
                    Vm.disableEndDate = true;
                }
            }
        };

        Vm.getDateRangeSummary = function () {
            Vm.disableStartDate = true;
            Vm.disableEndDate = true;
            Vm.transactionSummary = [];
            Vm.transactionStmtErrorMsg = "";
            utilityService.showSpinner();
            var requestParams = {
                "startDate": $filter('date')(new Date(Vm.startDate), 'yyyy-MM-dd'),
                "endDate": $filter('date')(new Date(Vm.endDate), 'yyyy-MM-dd')
            };
            getAccountDetailsService.getDateRangeSummary(requestParams).then(function (data) {
                Vm.transactionSummary = data.stateMentLists;
                utilityService.hideSpinner();
                Vm.disableStartDate = false;
                Vm.disableEndDate = false;
            }, function (error) {
                utilityService.hideSpinner();
                Vm.disableStartDate = false;
                Vm.disableEndDate = false;
                Vm.transactionSummary = [];
                Vm.transactionStmtErrorMsg = error.responseMessage;
            });
        };

        Vm.dateReset = function () {
            Vm.startDate = "from";
            Vm.endDate = "to";
            Vm.startDatePicker.inputDate = new Date();
            Vm.endDatePicker.inputDate = new Date();
            Vm.disableStartDate = false;
            Vm.disableEndDate = true;
            Vm.transactionStmtErrorMsg = "";
            Vm.transactionSummary = Vm.miniStatementSummary;
        }

        Vm.getRewardsContent = function () {
            Vm.contentFlag = true;
            Vm.callNumberMobile = "<div class=\"col-xs-3\"> <p class=\"RobotoRegular16px text-center\">Call</p> <p class=\"RobotoRegular16px text-center\"><b>022-6000-8500</b></p> <p class=\"RobotoLight16px text-center\">(Local call charges apply)</p> </div> <div class=\"col-xs-3\"> <p class=\"RobotoRegular16px text-center\"><b>1800-209-8500</b></p> <p class=\"RobotoLight16px text-center\">(Toll Free from BSNL & MTNL)</p> </div>";

            Vm.emailMobile = "<div class=\"col-xs-3\"> <p class=\"RobotoRegular16px text-center\">Email</p> <p class=\"RobotoRegular16px word-wrap\"><b>info@statebankrewardz.com</b></p> <p class=\"RobotoRegular16px word-wrap\"><b>membersupport@<span style=\"font-family: 'Times New Roman';\">statebankrewardz</span>.com</b></p> </div>";

            Vm.errorMessageMobile = "<div class=\"row\"> <div class=\"col-xs-12\"> <p class=\"RobotoLight16px\"> Your reward points have been credited. Please check again later.</p> </div> </div>";

            Vm.websiteMobile = "<div class=\"row\"> <div class=\"col-xs-3\"> <p class=\"RobotoLight16px\">For any queries or issues, Please visit www.statebankrewardz.com</p> <br /> <p class=\"RobotoLight16px\">OR</p> <br /> <p><b>Contact customer care</b></p> </div> </div>";

            // Vm.contentFlag = false;
            // getAccountDetailsService.getRewardsContent().then(function (data) {
            //     Vm.contentFlag = true;
            //     Vm.errorMessageMobile = data.getRewardz[0].errorMessageMobile;
            //     Vm.websiteMobile = data.getRewardz[0].websiteMobile;
            //     Vm.callNumberMobile = data.getRewardz[0].callNumberMobile;
            //     Vm.emailMobile = data.getRewardz[0].emailMobile;
            // }, function (error) {
            //     Vm.contentFlag = false;
            //     utilityService.showErrorMessage(error.responseMessage);
            // });
        }

        Vm.getRewardsInfoContent = function ($event) {
            getAccountDetailsService.getRewardsInfoContent().then(function (data) {
                Vm.infoMessage = data.infoMessage;
                Vm.infoPopup($event);
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        Vm.infoPopup = function ($event) {
            var infoPopUp = $ionicPopup.show({
                title: "",
                cssClass: 'my-custom-popup',
                template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey textAlignjustified">' + Vm.infoMessage + '</div>',
                scope: '',
                buttons: [{
                    text: 'OK',
                    type: 'button-assertive',
                    onTap: function () {
                        infoPopUp.close();
                    }
                }],
            });
        };

        Vm.getMyRewards = function () {
            Vm.rewadsFlag = false;
            Vm.rewardsSpinner = true;
            Vm.contentFlag = false;
            Vm.dateReset();

            var q = $q.defer();
            getAccountDetailsService.getPointsSummary().then(function (value) {

                Vm.myLoyalityRewards = parseFloat(value.points) ? (parseFloat(value.points) + " " + "points") : "0 points";
                Vm.rewardsPoint = parseFloat(value.points) ? parseFloat(value.points) : 0;
                Vm.status = value.status;
                Vm.url = value.url;
                Vm.totalAccruedPoints = parseFloat(value.totalAccruedPoints) ? (parseFloat(value.totalAccruedPoints) + " " + "points") : "0 points";
                Vm.totalExpiredPoints = parseFloat(value.totalExpiredPoints) ? (parseFloat(value.totalExpiredPoints) + " " + "points") : "0 points";
                Vm.totalRedeemedPoints = parseFloat(value.totalRedeemedPoints) ? (parseFloat(value.totalRedeemedPoints) + " " + "points") : "0 points";
                Vm.registrationStatus = true;//(value.registrationStatus && value.registrationStatus == 'YES') ? true : false;

                getAccountDetailsService.getUpcomingExpirySummary().then(function (value) {

                    Vm.UpcomingExpiryDatesPoints = value.expiryDatePoints;
                    if (value.expiryDatePoints && value.expiryDatePoints.length > 0) {
                        Vm.UpcomingExpiryDatesPoints.forEach(function (expiryDatesPoints) {
                            expiryDatesPoints.expiryDate = $filter('date')(new Date(expiryDatesPoints.expiryDate), 'dd MMM yyyy').toUpperCase();
                            expiryDatesPoints.expiryPoint = expiryDatesPoints.expiryPoint + " " + "points";
                        });
                    }

                    getAccountDetailsService.getMiniStatement().then(function (value) {
                        Vm.rewadsFlag = true;
                        Vm.rewardsSpinner = false;
                        Vm.miniStatementSummary = value.stateMentLists;
                        Vm.transactionSummary = Vm.miniStatementSummary;

                    }, function (error) {

                        Vm.rewadsFlag = true;
                        Vm.rewardsSpinner = false;
                        Vm.transactionSummary = [];
                        Vm.transactionStmtErrorMsg = error.responseMessage;

                    });

                }, function (error) {

                    getAccountDetailsService.getMiniStatement().then(function (value) {
                        Vm.rewadsFlag = true;
                        Vm.rewardsSpinner = false;
                        Vm.miniStatementSummary = value.stateMentLists;
                        Vm.transactionSummary = Vm.miniStatementSummary;

                    }, function (error) {

                        Vm.rewadsFlag = true;
                        Vm.rewardsSpinner = false;
                        Vm.transactionSummary = [];
                        Vm.transactionStmtErrorMsg = error.responseMessage;

                    });

                });

            }, function (error) {

                getAccountDetailsService.getUpcomingExpirySummary().then(function (value) {

                    Vm.UpcomingExpiryDatesPoints = value.expiryDatePoints;
                    if (value.expiryDatePoints && value.expiryDatePoints.length > 0) {
                        Vm.UpcomingExpiryDatesPoints.forEach(function (expiryDatesPoints) {
                            expiryDatesPoints.expiryDate = $filter('date')(new Date(expiryDatesPoints.expiryDate), 'dd MMM yyyy').toUpperCase();
                            expiryDatesPoints.expiryPoint = expiryDatesPoints.expiryPoint + " " + "points";
                        });
                    }

                    getAccountDetailsService.getMiniStatement().then(function (value) {
                        Vm.rewadsFlag = true;
                        Vm.rewardsSpinner = false;
                        Vm.miniStatementSummary = value.stateMentLists;
                        Vm.transactionSummary = Vm.miniStatementSummary;

                    }, function (error) {

                        Vm.rewadsFlag = true;
                        Vm.rewardsSpinner = false;
                        Vm.transactionSummary = [];
                        Vm.transactionStmtErrorMsg = error.responseMessage;

                    });

                }, function (error) {

                    getAccountDetailsService.getMiniStatement().then(function (value) {
                        Vm.rewadsFlag = true;
                        Vm.rewardsSpinner = false;
                        Vm.miniStatementSummary = value.stateMentLists;
                        Vm.transactionSummary = Vm.miniStatementSummary;

                    }, function (error) {

                        Vm.rewadsFlag = false;
                        Vm.rewardsSpinner = false;
                        Vm.getRewardsContent();
                    });

                });


            });
        }

        Vm.setAccountsAndHeaderLabel = function () {
            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.accounts)) {
                // if data is not null
                Vm.accounts = getAccountDetailsService.accountOverviewData.accounts;
                var accLength = Vm.accounts.length;
                var savingAccLength = 0;
                var currAccLength = 0;
                var odAccLength = 0;
                Vm.fcnrAccLength = 0;
                for (var i = 0; i < accLength; i++) {
                    if (Vm.accounts[i].accountType === "Savings A/c") {

                        if(Vm.accounts[i].currency === 'INR'){savingAccLength++;}
                        if(savingAccLength>0){Vm.savingDisplay = true;}
                        
                        getAccountDetailsService.dataDisplay.savingDisplay = Vm.savingDisplay;
                        Vm.accounts[i].oldAccountValue = Vm.accounts[i].accountNumber;

                    } else if (Vm.accounts[i].accountType === "Current A/c") {

                        if(Vm.accounts[i].currency === 'INR'){currAccLength++;}
                        if(currAccLength>0){Vm.currentDisplay = true;}

                        getAccountDetailsService.dataDisplay.currentDisplay = Vm.currentDisplay;
                        Vm.accounts[i].oldAccountValue = Vm.accounts[i].accountNumber;

                    } else if (Vm.accounts[i].accountType === "Overdraft A/c" || Vm.accounts[i].accountType === "Overdraft") {

                        if(Vm.accounts[i].currency === 'INR'){odAccLength++;}
                        if(odAccLength>0){Vm.overdraftDisplay = true;}
                        
                        getAccountDetailsService.dataDisplay.overdraftDisplay = Vm.overdraftDisplay;
                        Vm.accounts[i].oldAccountValue = Vm.accounts[i].accountNumber;
                    }

                    if(Vm.accounts[i].currency !== 'INR'){
                        Vm.fcnrAccLength++;
                    }
                }
                fixedDepositService.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                //Account list for securities Need to check accountList
                mySecurityProfileService.addDetails(Vm.accounts);
                //Account list for dreams
                myDreamsServices.addAccountDetails(Vm.accounts);
                //Account list for MF
                mutualFundsService.addAccoutDetails(Vm.accounts);
            }

            Vm.headerList = getAccountDetailsService.accountOverviewData.headerList;
            angular.forEach(Vm.headerList, function (value, key) {
                if (value.label == "My Balance") {
                    Vm.MyBalanceAmount = value.accountBalance;
                } else if (value.label == "My Deposits") {
                    Vm.MyDepositsAmount = value.accountBalance;
                } else if (value.label == "My Borrowings") {
                    Vm.MyBorrowingsAmount = value.accountBalance;
                }
            });
        }

        Vm.setModulesData = function () {
            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.odDetails)) {
                // if data is not null
                getAccountDetailsService.accountOverviewData.odDetails.forEach(function (odData) {
                    if (odData.loanAmountSign) {
                        odData.loanAmountSign = odData.loanAmountSign.trim();
                    } else {
                        odData.loanAmountSign = "";
                    }
                });
                Vm.odDetails = getAccountDetailsService.accountOverviewData.odDetails;
                Vm.odDetailsFcrRows = 0;
                for (var i = 0; i < Vm.odDetails.length; i++) {
                    Vm.odDetails[i].oldAccountValue = Vm.odDetails[i].accountNumber;

                    if(Vm.odDetails[i].currency !== 'INR'){
                        Vm.odDetailsFcrRows++;
                    }
                }
                Vm.odDetailsRows = getAccountDetailsService.accountOverviewData.odDetails.length;
            }

            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.myDreams)) {
                // if data is not null


                Vm.dreamData = angular.copy(getAccountDetailsService.accountOverviewData.myDreams);
                Vm.rDFcrCount = 0;
                for (var i = 0; i < Vm.dreamData.length; i++) {
                    Vm.dreamData[i].oldAccountNumberValue = Vm.dreamData[i].accountNumber;
                    if(Vm.dreamData[i].currency != 'INR'){
                        Vm.rDFcrCount++;
                    }
                }
                Vm.dreamData = Vm.dreamData.filter(function (dream) {
                    //return dream.fundStatus.toLowerCase() != 'closed';
                   return (dream.fundStatus.toLowerCase() != 'closed' && dream.accountNumber != null);
                })
                Vm.dreamsLength = Vm.dreamData.length == "undefined" ? 0 : Vm.dreamData.length;
               

            }

           if (getAccountDetailsService.tabIndex.tabIndex === 1) {
                    Vm.loadDreams();
            }
            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.fixedDeposits)) {
                // if data is not null
                Vm.fixedDepositFcrCount = 0;
                Vm.fixedDeposits = getAccountDetailsService.accountOverviewData.fixedDeposits;
                for (var i = 0; i < Vm.fixedDeposits.length; i++) {
                    Vm.fixedDeposits[i].oldAccountNumberValue =  Vm.fixedDeposits[i].fdAccountNumber;
                    if(Vm.fixedDeposits[i].currency != 'INR'){Vm.fixedDepositFcrCount++;}
                  }
                Vm.fixedRows = Vm.fixedDeposits.length;
            }

            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.loanDetails)) {
                // if data is not null
                Vm.loanDetails = getAccountDetailsService.accountOverviewData.loanDetails;
                Vm.loanDetailsFcnrRows = 0;
                for (var i = 0; i < Vm.loanDetails.length; i++) {
                    Vm.loanDetails[i].oldLoanNumberValue =  Vm.loanDetails[i].loanNumber;
                    if(Vm.loanDetails[i].currency !== 'INR'){
                        Vm.loanDetailsFcnrRows++;
                    }
                  }
                Vm.loanDetailsRows = getAccountDetailsService.accountOverviewData.loanDetails.length;
            }

            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.preApprovedLoanAmount)) {
                // if data is not null
                Vm.preApprovedLoanAmount = getAccountDetailsService.accountOverviewData.preApprovedLoanAmount;
                fixedDepositService.customer.preApprovedLoanAmount = Vm.preApprovedLoanAmount;
            }

            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.mutualFunds)) {
                // if data is not null
                Vm.mutualFunds = getAccountDetailsService.accountOverviewData.mutualFunds;
            }

            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.lifeInsurance)) {
                // if data is not null
                getAccountDetailsService.accountOverviewData.isPolicyRenewal=false;
                Vm.liLinkedPolices = getAccountDetailsService.accountOverviewData.lifeInsurance;
            }
            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy)) {
                // if data is not null
                Vm.ssPolicyDetails = getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy;
            }
            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.rinnRakshaPolicy)) {
                // if data is not null
                Vm.rrPolicyDetails = getAccountDetailsService.accountOverviewData.rinnRakshaPolicy;
            }
            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.generalInsurance)) {
                // if data is not null
                Vm.genralliLinkedPolices = getAccountDetailsService.accountOverviewData.generalInsurance;
            }

            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.homeInsurance)) {
                // if data is not null
                Vm.homeInsurance = getAccountDetailsService.accountOverviewData.homeInsurance;
            }
            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.swarnaGangaUrl)) {
                if (isStaffCustomer.toLowerCase() == 'y') {
                    Vm.isStaffCustomer = true;
                    Vm.swarnaGangaUrl = getAccountDetailsService.accountOverviewData.swarnaGangaUrl;
                }
            }

            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.cards)) {
                // if data is not null
                //Vm.creditCards = getAccountDetailsService.accountOverviewData.creditCards;
                Vm.cardList = (getAccountDetailsService.accountOverviewData.cards) ? getAccountDetailsService.accountOverviewData.cards : [];

                Vm.showLinkCards = (Vm.cardList.length) ? false : true;
                Vm.showLinkedSection = (Vm.cardList.length) ? true : false;
                Vm.showNoCardsMsg = (Vm.cardList.length) ? false : true;
                Vm.showDelinkCards = (Vm.cardList.length) ? true : false;
                Vm.cardsSpinner = false;
				
				if(Vm.cardList && Vm.cardList.cards.length > 0){
					setTimeout(function(){
						var today = new Date(); 
						var dd = today.getDate();
						var mm = today.getMonth();
						var monthlist = ['JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN', 'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC'];
						var yyyy = today.getFullYear();
						if (dd < 10) {
							dd = '0' + dd;
						}
						var OutstandingDate = dd + ' ' + monthlist[mm] + ' ' + yyyy;
						$scope.currentOutStandingDate = OutstandingDate;
                        $scope.lastStatementDate = Vm.cardList[0].lastStatementDate.replace(/-/g," ");
                        if(Vm.cardList[0].dueDate && Vm.cardList[0].dueDate != ""){
                            $scope.dueDate = Vm.cardList[0].dueDate.replace(/-/g," ");
                        }
                        else{
                            $scope.dueDate = "";
                        }
                        
                        $scope.minimumDue = Vm.cardList[0].minimumDue;
                        if(Vm.cardList[0].paymentDue < 0){
                            $scope.totalBill = 0;
                        }else{
                            $scope.totalBill = Vm.cardList[0].paymentDue;
                        } 
						var classAdd = document.getElementsByClassName('card-baner')[0];
						if(classAdd.getElementsByClassName('removeOpacity')[0]){
							var temp = classAdd.getElementsByClassName('removeOpacity')[0];
							temp.getElementsByClassName('subcontentcard-slide')[0].classList.remove("removeSliderCss")
							classAdd.getElementsByClassName('removeOpacity')[0].classList.remove("removeOpacity");
						}                                
						classAdd.querySelectorAll("[data-index]")[$scope.myActiveSlide].classList.add("removeOpacity");
						var tempclasspath = classAdd.getElementsByClassName('removeOpacity')[0];
						tempclasspath.getElementsByClassName('subcontentcard-slide')[0].classList.add("removeSliderCss");
					   
						
					}, 500);
				}
               
            }

            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.otherDeposits)) {
                // if data is not null
                Vm.otherDeposits = getAccountDetailsService.accountOverviewData.otherDeposits;
                for (var i = 0; i < Vm.otherDeposits.length; i++) {
                    Vm.otherDeposits[i].oldAccountNumberValue =  Vm.otherDeposits[i].otherAccountNumber;
                  }
                Vm.otherDepoRows = Vm.otherDeposits.length;
            }
            if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.otherAccounts)) {
                //code to display OD account with code 65014019
                if(getAccountDetailsService.accountOverviewData.otherAccounts.length > 0)
                {
                    Vm.odProductForEnquiryOnly = getAccountDetailsService.accountOverviewData.otherAccounts;
                for (var m = 0; m < Vm.odProductForEnquiryOnly.length; m++) {
                    Vm.odProductForEnquiryOnly[m].oldAccountValue = Vm.odProductForEnquiryOnly[m].accountNumber;
                    if (Vm.odProductForEnquiryOnly[m].loanAmountSign) {
                        Vm.odProductForEnquiryOnly[m].loanAmountSign = Vm.odProductForEnquiryOnly[m].loanAmountSign.trim();
                    } else {
                        Vm.odProductForEnquiryOnly[m].loanAmountSign = "";
                    }
                    
                    Vm.odProductForEnquiryOnly[m].odProductForEnquiryOnly = true;
                    Vm.overdraftDisplay = true;
                }
                
                }
            }
        }
        Vm.getWealthTrackFlag = function(){
            Vm.wealthCardsSpinner = true;
            if (!getAccountDetailsService.accountOverviewData) {
                Vm.displaySpinner = true;
                Vm.wealthCardsSpinner = true;
                getAccountDetailsService.getAccountDetails().then(function (data) {
                    getAccountDetailsService.accountOverviewData = data;
                    Vm.displaySpinner = false;
                    Vm.wealthCardsSpinner = false;
                    Vm.tryAgainWealthMsg=false;
                    if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.customerInformation)) {

                if(getAccountDetailsService.accountOverviewData.customerInformation.wealthFlag == 'Y'){
                    Vm.wealthFlag = getAccountDetailsService.accountOverviewData.customerInformation.wealthFlag;
                }
                else
                {
                    Vm.WealthTrackApplicationFlag = wealthService.bannerFlag;
                }
            }
                }, function (error) {
                    Vm.tryAgainWealthMsg=true;
                   Vm.wealthCardsSpinner = false;
                    Vm.displaySpinner = false;

                });
            } else {
                Vm.displaySpinner = false;
                Vm.wealthCardsSpinner = false;
                Vm.tryAgainWealthMsg=false;
                if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.customerInformation)) {
                if(getAccountDetailsService.accountOverviewData.customerInformation.wealthFlag == 'Y'){
                    Vm.wealthFlag = getAccountDetailsService.accountOverviewData.customerInformation.wealthFlag;
                } else {
                    Vm.WealthTrackApplicationFlag = wealthService.bannerFlag;
                }
            }
            }
        }

        Vm.getMyDreamDetails = function (dream) {
            var requestParam = {
                "dreamId": dream.dreamId
            }
            myDreamsService.getMyDreamDetails(requestParam).then(function (response) {
                myDreamsService.selectedDreamDetails = response;
                if (response.status == 'ARCHIVED' || response.status == 'COMPLETED') {
                    $state.go('menu.viewDream');
                } else {
                    $state.go('menu.selectedDream');
                }
            }, function (error) {
                utilityService.showBhimUpiAlert("error", error.responseMessage);
            })
        }

        Vm.createNewDream = function () {
            myDreamsService.getDefaultDreams().then(function (response) {
                myDreamsService.defaultDreamsData = response;
                $state.go('menu.createNewDream');
            }, function (error) {
                utilityService.showBhimUpiAlert("error", error.responseMessage);
            })
        }

        Vm.loadDreams = function () {
            myDreamsService.getDreamList().then(function (response) {
                Vm.activeDreamList = response.active;
                Vm.archivedDreamList = response.archived;
                Vm.completedDreamList = response.completed;
            }, function (error) {
                //utilityService.showBhimUpiAlert("error", error.responseMessage);
            })
        }

        Vm.showAllActiveDreams = function (count) {
            Vm.activeDreamCount = count;
        }

        Vm.showAllArchivedDreams = function (count) {
            Vm.archivedDreamCount = count;
        }

        Vm.showAllCompletedDreams = function (count) {
            Vm.completedDreamCount = count;
        }

        Vm.checkColorCondition = function (achivedAmount, dreamAmount) {
            if (parseFloat(achivedAmount) >= parseFloat(dreamAmount))
                return true;
            else
                return false;
        }

        Vm.loadMyBalance = function () {
            Vm.MyBalanceAmount = 0;
            Vm.MyDepositsAmount = 0;
            Vm.MyBorrowingsAmount = 0;
            Vm.MyInvestmentsAmount = 0;
            myDreamsService.dreamImage = "";
            Vm.activeDreamCount = 1;
            Vm.archivedDreamCount = 1;
            Vm.completedDreamCount = 1;
            myDreamsService.selectedDreamDetails = "";
            if (!getAccountDetailsService.accountOverviewData) {
                Vm.displaySpinner = true;
                Vm.showRetryMyBalance = false;
                getAccountDetailsService.getAccountDetails().then(function (data) {
                    getAccountDetailsService.accountOverviewData = data;
                    Vm.setAccountsAndHeaderLabel();
                    Vm.setModulesData();
                    Vm.displaySpinner = false;
                    Vm.showloadMyNewAccountLink();
                    
                    if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
                        getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
                            getAccountDetailsService.accessRightsData = data;
                            console.log(data);
                        }, function (error) {
                            // Failure block
                            console.log(error);
                        });
                    }
                    Vm.getAvgBalance();
                    checkResidentialStatus();
                }, function (error) {
                    Vm.setAccountsAndHeaderLabel();
                    Vm.displaySpinner = false;
                    Vm.showRetryMyBalance = true;
                });
            } else {
                Vm.displaySpinner = false;
                Vm.showRetryMyBalance = false;
                Vm.custResidentialStatus = getAccountDetailsService.accountOverviewData.customerInformation.residentialStatus;
                Vm.setAccountsAndHeaderLabel();
                Vm.setModulesData();
                Vm.getAvgBalance();
                checkResidentialStatus();
            }
        }

        Vm.loadMyNewAccount = function () {
            aoService.isJTSixPostLoginData.newMobile = customerInfoService.customer.mobile ? customerInfoService.customer.mobile : "";
            aoService.isJTSixPostLoginData.newMail = customerInfoService.customer.emailID ? customerInfoService.customer.emailID : "";
            aoService.isJTSixPostLoginStarted = true;
            aoService.isJTSixPostLoginStarted = true;
            aoService.isResumeJourney = false;
            if (aoService.isJTSixPostLoginData.newMobile) {
                var obj = {
                    "id": customerInfoService.customer.mobile ? customerInfoService.customer.mobile : "",
                    "email": customerInfoService.customer.emailID ? customerInfoService.customer.emailID : ""
                };
                utilityService.showSpinner();
                JTSixService.checkPasswordAvailability(obj).then(function (response) {
                    utilityService.hideSpinner();
                    if (response.data) {
                        if (response.data.cloudStatusFlag === true) {
                            var title = '';
                            var template = response.responseMessage;
                            var onTap = '';
                            var buttontext = '<b>' + 'OK' + '</b>';
                            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                            return true;
                        } else {
                            $state.go('menu.mobileEntryPage');
                        }
                    }
                }, function (error) {
                    utilityService.hideSpinner();
                });
            }
        };

        Vm.loadMyNewAccountPre = function () {
            if (customerInfoService.customer.mobile) {
                Vm.loadMyNewAccount();
            } else {
                utilityService.showSpinner();
                homeScreenService.getCustomerInfo().then(function (data) {
                    utilityService.hideSpinner();
                    customerInfoService.customer.emailID = data.emailID;
                    customerInfoService.customer.mobile = data.mobile;
                    aoService.isJTSixPostLoginData.newMobile = data.mobile;
                    aoService.isJTSixPostLoginData.newMail = data.emailID;
                    Vm.loadMyNewAccount();
                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        };

        Vm.showloadMyNewAccountLink = function () {
            Vm.showAccountLink = false;
            if (getAccountDetailsService.accountOverviewData) {
                var arr = getAccountDetailsService.accountOverviewData.accounts;
                for (var i = 0; i < arr.length; i++) {
                    if (arr[i].intCategory == "1701" && arr[i].accountTypeCode == "1111") {
                        Vm.showAccountLink = false;
                        return true;
                    }
                    if ((arr.length - 1) == i) {
                        Vm.showAccountLink = true;
                    }
                }
                if (getAccountDetailsService.accountOverviewData.customerInformation.customerType == "010224") {
                    Vm.showAccountLink = false;
                }
            }
        };


        // Account Aggregator Start
        Vm.getOtherBankRelationship = function () {
			utilityService.enableShowErrorMessage();
            Vm.sbiRelationshipActive = false;
            var reqParams = {}
            accountOverviewService.getConsentList().then(function (data) {
                Vm.aggConsentList = data.details;
                accountOverviewService.aggConsentList = Vm.aggConsentList;
            }, function (error) {
                utilityService.hideSpinner();
                //utilityService.showErrorMessage(error.responseMessage);
            });
        }

        Vm.getSBIRelationship = function () {
			utilityService.disableShowErrorMessage();
            Vm.sbiRelationshipActive = true;
        }

        Vm.getOtherBankData = function (account) {
            var reqParams = {
                linkReferenceNumber: account.linkReferenceNumber,
                hash: cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + account.linkReferenceNumber).toString()
            }
            accountOverviewService.getOtherBankData(reqParams).then(function (data) {
                console.log(data);
                accountOverviewService.transactionDetails = data.details;
                $state.go('menu.otherBankTransactions');
            }, function (error) {
                utilityService.hideSpinner();
                //utilityService.showErrorMessage(error.responseMessage);
            });
        }

        Vm.manageAggregatorAcc = function () {
            $state.go('menu.manageAggregators');
        }

        Vm.toggleCollectOptions = function (collectOption) {
            if (collectOption == 'BALANCE') {
                Vm.transactionType = 'BALANCE';
                Vm.classForTransactionOpt = 'tab-item tabs-style div-bottom bor-bot-active';
                Vm.classForSpendAnOpt = 'tab-item tabs-style div-bottom';
            }
            if (collectOption == 'DEPOSITS') {
                Vm.transactionType = 'DEPOSITS';
                Vm.classForTransactionOpt = 'tab-item tabs-style div-bottom';
                Vm.classForSpendAnOpt = 'tab-item tabs-style div-bottom bor-bot-active';
            }
        };

        Vm.getAggregatorBanner = function () {
            if (localStorage.getItem("aggBannerFlag")) {
                Vm.aggBannerFlag = localStorage.getItem("aggBannerFlag");
            } else {
                var reqParams = {}
                accountOverviewService.getAggregatorBanner(reqParams).then(function (data) {
                    Vm.aggBannerFlag = data.flag.toLowerCase();
                    localStorage.setItem('aggBannerFlag', Vm.aggBannerFlag);
                }, function (error) {
                    utilityService.hideSpinner();
                });
            }
        }

        Vm.setAggregatorBanner = function () {
            var reqParams = {}
            accountOverviewService.setAggregatorBanner(reqParams).then(function (data) {
                Vm.aggBannerFlag = 'true';
                localStorage.setItem('aggBannerFlag', Vm.aggBannerFlag);
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showBhimUpiAlert("error", error.responseMessage);
            });
        }
        // Account Aggregator End

        $scope.$on('$ionicView.loaded', function () {
            ////////This commented code is used for Account Aggregator Demo.Please do not remove.//////
	        // Vm.sbiRelationshipActive = true;
            // Vm.aggBannerFlag = '';
            // Vm.getAggregatorBanner();
            // Vm.transactionType = 'BALANCE';
            // Vm.classForTransactionOpt = 'tab-item tabs-style div-bottom bor-bot-active';
            // Vm.classForSpendAnOpt = 'tab-item tabs-style div-bottom';
            // if (accountOverviewService.aggConsentList) {
            //     Vm.aggConsentList = accountOverviewService.aggConsentList;
            // }
	    
            Vm.loadMyBalance();
            if (getAccountDetailsService.tabIndex.tabIndex == 4) {
                Vm.loadGI();
            }
        });
        /*Wearable*/

        Vm.gotoApplyWearable = function () {
            utilityService.showSpinner();
            wearableServices.getRedirectLink().then(function(response) {
                utilityService.hideSpinner();
                wearableServices.targetURL = response.url;
                $state.go("menu.applyNewWearable");
            }, function(error) {
                    utilityService.hideSpinner();
                    var msg = error.responseMessage ? error.responseMessage : error;
                    utilityService.showBhimUpiAlert("error",msg,"","OK", $scope);
            });
        }

        Vm.showDropdown = function () {
            document.getElementById("myDropdown").classList.toggle("show");
        }

        window.onclick = function (event) {
            if (!event.target.matches('.dropbtn')) {
                var dropdowns = document.getElementsByClassName("dropdown-content");
                var i;
                for (i = 0; i < dropdowns.length; i++) {
                    var openDropdown = dropdowns[i];
                    if (openDropdown.classList.contains('show')) {
                        openDropdown.classList.remove('show');
                    }
                }
            }
        }

        $ionicPopover.fromTemplateUrl('pages/yonoWearable/landing/blockcardPopover.html', {
            scope: $scope
        }).then(function (popover) {
            $scope.popover = popover;
        });

        Vm.openPopOver = function ($event, index) {
            $scope.index = index;
            $rootScope.wearableDisplayname = Vm.wearableCardList[index].displayName;
            console.log("$rootScope.wearableDisplayname" + $rootScope.wearableDisplayname);
            $scope.popover.show($event);
        }

        Vm.permanentBlock = function () {
            $scope.popover.hide();

            Vm.blockPopupMain = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                templateUrl: 'pages/yonoWearable/landing/blockCardCheckPopup.html',
                scope: $scope
            });
            /*Vm.blockPopupName = $ionicPopup.show({
                title: '',
                cssClass: 'email-custom-popup',
                template: '<img src="img/errorImage.png" alt="Disable sure"><p>Are you sure you wish to block your Wearable '+"'"+ $rootScope.wearableDisplayname +"'"+' permanently ?</p> <p style="font-weight: 700;" translate="CANNOT_REVERSE_NOTE"></p>',
                scope: $scope,
                buttons: [
                    {
                        text: 'Cancel',
                        type: 'button-assertive',
                        onTap: function () {
                            Vm.blockPopupName.close();
                        }
                    },
                    {
                        text: 'Block',
                        type: 'button-positive',
                        onTap: function () {
                            Vm.blockPopupName.close();

                            try {
                                 wearableServices.cardNumber = Vm.wearableCardList[$scope.index].cardNumber;
                                $state.go("menu.blockingWearableReason");
                            } catch (e) { }
                        }
                    }
                ],
            });*/

        }

        Vm.closeBlockPopup = function () {
            Vm.blockPopupMain.close();
        }
        Vm.gotoBlockPopup = function () {
            Vm.blockPopupMain.close();
            wearableServices.cardNumber = Vm.wearableCardList[$scope.index].cardNumber;
            $state.go("menu.blockingWearableReason");

        }

        Vm.getCheckedVAl = function ($event) {

        }

        Vm.linkWearable = function () {
            //did not receive service  to check for 3 wearables 
            wearableServices.linkWearable.nickName = "";
            wearableServices.linkWearable.enterUrn = "";
            utilityService.showSpinner();
            wearableServices.checkKYC().then(function (data) {
                utilityService.hideSpinner();
                $state.go("menu.linkWearable");

            }, function (error) {
                utilityService.hideSpinner();
                if(error.responseCode == '0005'){
                    Vm.popUpKyc = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                    templateUrl: 'pages/yonoWearable/landing/kycPopup.html',
                    scope: $scope
                });
            }else{
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
                }
                
            });

        }

        Vm.goToViewTransaction = function (selectedAccountNumber) {
            wearableServices.selectedAccountNumber = selectedAccountNumber;
            $state.go("menu.wearableTransactionList");
        }

        Vm.checkClick = function (value, index) {
            // alert("this is selected" + value);
            $scope.flagindex = index;
            $rootScope.wearableDisplayname = Vm.wearableCardList[index].displayName;
            console.log("$rootScope.wearableDisplayname" + $rootScope.wearableDisplayname);
            if (value) {
                wearableServices.cardNumber = Vm.wearableCardList[index].cardNumber;
                wearableServices.accountNumber = wearableServices.selectedDetailslanding.accountNumber;
                wearableServices.wearableName = Vm.wearableCardList[index].displayName;
                wearableServices.ncmcFlag = Vm.wearableCardList[index].setStatus == true ? 'Y' : 'N';
                /* $state.go("menu.linkSuccess");*/
                $state.go("menu.wearableProfilePassword");


            } else {

                Vm.disablePopupMain = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                    templateUrl: 'pages/yonoWearable/landing/disableCheckPopup.html',
                    scope: $scope
                });





            }
        }

        Vm.closeDisablePopup = function () {
            Vm.wearableCardList[$scope.flagindex].setStatus = true;
            Vm.disablePopupMain.close();
        }
        Vm.successDisable = function () {
            Vm.disablePopupMain.close();
            wearableServices.cardNumber = Vm.wearableCardList[$scope.flagindex].cardNumber;
            wearableServices.accountNumber = wearableServices.selectedDetailslanding.accountNumber;;
            wearableServices.wearableName = Vm.wearableCardList[$scope.flagindex].displayName;
            wearableServices.ncmcFlag = Vm.wearableCardList[$scope.flagindex].setStatus == true ? 'Y' : 'N';
            wearableServices.wearableFlagUpdate(wearableServices.cardNumber, wearableServices.accountNumber, wearableServices.ncmcFlag).then(function (data) {

                Vm.disableSuccess = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin ftpopup-body popupBackgroundWhite removePopup-head textAlignCenter yonoWeableBackdrop',
                    templateUrl: "pages/yonoWearable/landing/disableSuccessPopup.html",
                    scope: $scope
                });
                Vm.wearableCardList[$scope.flagindex].setStatus = false;


            }, function (error) {
                Vm.wearableCardList[$scope.flagindex].setStatus = true;
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                utilityService.disableShowErrorMessage();
            });

        }




        Vm.getAccountList = function () {
            if (!getAccountDetailsService.accountOverviewData) {
                utilityService.showSpinner();
                homeScreenService.getCustomerInfo().then(function (data) {
                    utilityService.hideSpinner();
                    getAccountDetailsService.accountOverviewData = data;
                    // wearableServices.accDetails = getAccountDetailsService.accountOverviewData.accounts
                    Vm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                    if (Vm.accDetails.length == 0) {
                        wearableServices.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                            $state.go('menu.homeScreen');
                        });
                    }
                    Vm.setPrimaryAccount();
                    //Vm.wearableEnquiryByAccNo(); 
                }, function (error) {
                    utilityService.hideSpinner();
                });
            } else {
                //wearableServices.accDetails = getAccountDetailsService.accountOverviewData.accounts
                Vm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
                if (Vm.accDetails.length == 0) {
                    wearableServices.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                        $state.go('menu.homeScreen');
                    });
                }
                Vm.showSelect = false;
                if (wearableServices.selectedDetails.selIndex == "") {
                    Vm.setPrimaryAccount();
                } else {
                    Vm.close(wearableServices.selectedDetails.selIndex);

                }
            }

        }

        Vm.setPrimaryAccount = function () {

            if (getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                var arr = Vm.accDetails;

                for (var i = 0, j = arr.length; i < j; i++) {
                    if (arr[i].accountNumber == getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                        var topElement = Vm.accDetails[i];
                        Vm.close(i);
                        if (Vm.accDetails.indexOf(topElement) > 0) {
                            Vm.accDetails.splice(Vm.accDetails.indexOf(topElement), 1);
                            Vm.accDetails.unshift(topElement);
                        }
                    }
                };
            } else {

                Vm.close(0);
            }



        };

        Vm.showPop = function () {
            Vm.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                templateUrl: 'pages/yonoWearable/landing/dropdownModal.html',
                scope: $scope
            });
        }


        Vm.close = function (index) {
            var title = '';
            var onTap = '';
            if (Vm.popUp) {
                Vm.popUp.close();
            }

            Vm.balance = Vm.accDetails[index].accountBalance;
            Vm.accType = Vm.accDetails[index].accountType;
            Vm.accountNumber = Vm.accDetails[index].accountNumber;
            Vm.isActive = Vm.accDetails[index].isActive;
            Vm.isTransactional = Vm.accDetails[index].isTransactional;
            wearableServices.selectedDetailslanding.selIndex = index;
            wearableServices.selectedDetailslanding.accountNumber = Vm.accDetails[index].accountNumber;
            wearableServices.selectedDetailslanding.accountBalance = Vm.accDetails[index].accountBalance;
            Vm.showSelect = false;
            Vm.isAccountTransactional = false;
            Vm.unableFetchAccountTransactional = false;
            Vm.unableFetchAccountMOPTransactional = false;
            Vm.checkPMJDYflag = false;

            Vm.checkPMJDY();
            //Vm.accessRightsMOD();
        }

        Vm.checkPMJDY =function (){
            var accList = getAccountDetailsService.accountOverviewData.accounts;

            for (var i in accList) {

                if (accList[i].accountNumber == Vm.accountNumber) {
                    var pmjdycode = accList[i].accountTypeCode + " " + accList[i].intCategory;

                    console.log(pmjdycode);

                    if( pmjdycode == '1611 1411' || pmjdycode == '1011 1701' || pmjdycode == '1011 1601' || pmjdycode == '1611 1401'){

                        Vm.checkPMJDYflag = true;
                        /*Vm.popUpPMJDY = $ionicPopup.show({
                        title: '',
                        cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                        templateUrl: 'pages/yonoWearable/landing/pmjdyPopup.html',
                        scope: $scope
                        }); */

                    }else{
                        Vm.checkPMJDYflag = false;
                        Vm.accessRightsMOD();
                    }

                }
            }


        }

        Vm.closePMJDY = function(){
            Vm.popUpPMJDY.close();
            //$state.go('menu.homeScreen');
        }


        Vm.accessRightsMOD = function () {
            if (!getAccountDetailsService.accessRightsData.accounts) {
                getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
                    getAccountDetailsService.accessRightsData = data;
                    Vm.unableFetchAccountTransactional = false;
                    Vm.getAccessRights();
                }, function (error) {
                    Vm.unableFetchAccountTransactional = true;
                    // Failure block
                });
            } else {
                Vm.getAccessRights();
            }
        }

        Vm.getAccessRights = function () {

            for (var i in getAccountDetailsService.accessRightsData.accounts) {

                if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber == Vm.accountNumber) {
                    if (parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) == 1) {
                        Vm.isAccountTransactional = false;
                        Vm.checkAccountOperation();
                    } else {
                        Vm.isAccountTransactional = true;
                    }
                }
            }
        }


        Vm.checkAccountOperation = function () {

            wearableServices.checkAccountOperation(wearableServices.selectedDetailslanding.accountNumber).then(function (data) {

                utilityService.hideSpinner();
                if (data.operationAllowed == 'Y') {
                    Vm.wearableEnquiryByAccNo();
                    Vm.unableFetchAccountMOPTransactional = false;
                }
                if (data.operationAllowed == 'N') {
                    Vm.unableFetchAccountMOPTransactional = true;
                }
            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
                utilityService.disableShowErrorMessage();
            });

        }

        // wearable details
        Vm.wearableEnquiryByAccNo = function () {
            utilityService.showSpinner();
            wearableServices.wearableEnquiryByAccNo(wearableServices.selectedDetailslanding.accountNumber).then(function (data) {

                utilityService.hideSpinner();
               // Vm.noAccountLinked = false;
                Vm.wearableCardList = $filter('filter')(data.cardDetails, { cardStatus : 'ACTIVE' });

                if(Vm.wearableCardList.length <= 0){
                    Vm.noAccountLinked = true;
                }else{
                    Vm.noAccountLinked = false;
                }

                angular.forEach(Vm.wearableCardList, function (value, key) {
                    if (value.secondaryAcct == 'Y') {
                        value.setStatus = true;
                    }

                    if (value.secondaryAcct == 'N') {
                        value.setStatus = false;
                    }
                });

            }, function (error) {
                if (error.responseCode == "0001") {
                    Vm.wearableCardList = [];
                    Vm.noAccountLinked = true;
                } else {
                    Vm.wearableCardList = [];
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
                }

            });

            
        }


        Vm.disableSuccessPopup = function () {
            Vm.disableSuccess.close();
        }

        Vm.getMyWearable = function () {
           
            if (getAccountDetailsService.accountOverviewData.customerInformation && (getAccountDetailsService.accountOverviewData.customerInformation.residentialStatus && getAccountDetailsService.accountOverviewData.customerInformation.residentialStatus != "1")) {

				Vm.popUpNRI = $ionicPopup.show({
					title: '',
					cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
					templateUrl: 'pages/yonoWearable/landing/nriCheckPopupInHeader.html',
					scope: $scope
				});
			} else {
				//Vm.checkValidAccounts();
                Vm.checkWhiteListedUsers();

			}
        }

        Vm.checkWhiteListedUsers = function(){
                    wearableServices.isUserWhiteListed().then(function(response) {
                       
                    if (response.isUserWhiteListed == true) {
						 if(getAccountDetailsService.tabIndex.tabIndex === 6){
                            Vm.getAboutWearableContent();
                            Vm.getAccountList();
                        }
                    }else{
			 		var comingsoonPopup = $ionicPopup.alert({
                     template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                     + "Coming Soon" + '</div></div></div></div></div></div>',
                     cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                     buttons: [
                         {
                             text: 'OK',
                             type: 'button-positive',
                             onTap: function (e) {
                                 comingsoonPopup.close();
                                  $state.go('menu.homeScreen');
                             }
                         }
                     ]
                 });
			 	} 
    
                }, function(error) {
                     var message = error.responseMessage;
                    $ionicPopup.alert({
                        title: "",
                        template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/yonoWearable/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                        + message + '</span></div></div></div>',
                        cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup'
                    }).then(function (res) {
                        $state.go('menu.homeScreen');
                    });
					
            });
        }

        Vm.closeNRI = function(){
            Vm.popUpNRI.close();
            $state.go('menu.homeScreen');
        }

        

        Vm.goToHomeFromKyc = function () {
            Vm.popUpKyc.close();
        }

        Vm.getAboutWearableContent = function(){
            if(!wearableServices.wcmContent){
                // utilityService.showSpinner();
                 wearableServices.getAboutWearableContent().then(function(response) {
                     // utilityService.hideSpinner();
                    
                    if (response.content) {
                        var rupees  = response.content.replace("?","&#8377;");
                        Vm.aboutInfo = rupees;
                        wearableServices.wcmContent = rupees;
                    }
    
                }, function(error) {
                    //utilityService.hideSpinner();
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
                });
            }
            else{
                Vm.aboutInfo = wearableServices.wcmContent;
            }
        }




        /*********Function of GI-PAI Starts ***********/
        Vm.loadPaiPolicy = function() {
            if(!pailinkingRenwalService.cloudantPai){
                pailinkingRenwalService.getPaiPolicyByCif().then(function(result) {
                    pailinkingRenwalService.cloudantPai = result.data;
                    Vm.paiCheck();
                }, function(error) {
                    Vm.isPaiPolicyAvailable = false;
                });
            }else{
                Vm.paiCheck();
            }
            
        }

        Vm.paiCheck = function(){
           if (pailinkingRenwalService.cloudantPai &&
                pailinkingRenwalService.cloudantPai.noOfDaysRemaining <= 30 && 
                (pailinkingRenwalService.cloudantPai.autoRenew.toLowerCase() == "false" || pailinkingRenwalService.cloudantPai.autoRenew.toLowerCase() == "n") && 
                pailinkingRenwalService.cloudantPai.docStatus &&
                pailinkingRenwalService.cloudantPai.docStatus.toLowerCase() != "deleted") {
                Vm.isPaiPolicyAvailable = true;
            } else {
                Vm.isPaiPolicyAvailable = false;
            }
        }

         //Renewal
        Vm.newLifeRenewal = function () {
            if(Vm.isPaiPolicyAvailable) {
                pailinkingRenwalService.paiPolicyData = [];
                pailinkingRenwalService.paiLiPolicyList= [];
                var param = {
                    "flow" : "P"
                }
                pailinkingRenwalService.getPaiValidatePolicyWhitelist(param).then(function(res) {
                    if(res.journalNo) {
                        pailinkingRenwalService.paiPolicyData.push(res);
                        pailinkingRenwalService.paiLiPolicyList.push(res);
                    } 
                    $state.go('menu.newRenewalHome');
                    
                }, function(error) {
                    if(Vm.liRenewalBanner.length > 0){
                            $state.go('menu.newRenewalHome');
                    }else{
                        utilityService.enableShowErrorMessage();
                        utilityService.showErrorMessage(error.responseMessage);
                        utilityService.disableShowErrorMessage();
                    }
                }); 
            } else {
                $state.go('menu.newRenewalHome');
            } 
        }
        /*********Function of GI-PAI Ends ***********/


        // Outbound Analytics
        Vm.gotoMoreProducts = function () {
            $state.go('menu.moreProducts');
        }


        Vm.updateNewOAInsuranceSlider = function (index) {
            $ionicSlideBoxDelegate.loop(true);
            $ionicSlideBoxDelegate.update();
        }

        // Calling Consent Account List API to get all accounts linked at Account Aggregator
        Vm.callGetLinkedAccounts = function () {
            utilityService.showSpinner();
            OBADServices.getConsentAccountList().then(function (response) {
                utilityService.hideSpinner();
                OBADServices.OBADdisclaimer = response.disclaimer;
                if (response.data.accounts.length == 0) {
                    OBADServices.accountDetailsAvail = false;
                    $state.go("menu.otherBankAAlanding");
                } else {
                    OBADServices.accountDetailsAvail = true;
                    OBADServices.accountBasicDetailsList = response;
                    $state.go('menu.otherBankAccList');
                }
            }, function (error) {
                utilityService.hideSpinner();
                OBADServices.accountDetailsAvail = false;
                OBADServices.OBADdisclaimer = error.disclaimer;
                if (error.responseCode == "0404") {
                    $state.go("menu.otherBankAAlanding");
                } else {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
                }

            });
        }
        
        // capturing tab index to show or hide PFM button / entry point 
        $scope.slideChanged = function(index){
            if(index === 0){
                Vm.showPFMButton = true;
            }else{
                Vm.showPFMButton = false;
            }

          };
        // Calling Consent Account List API to get all accounts linked at Account Aggregator -- END
        
        return this;
    }
]);
