'use strict';
angularApp.service('myCardsService',
	function ($q, utilityService, AdapterUtils) {
		var getCreditCardDetails = function (cardNumber) {
			var q = $q.defer();
			var payload = {
				"creditCardNumber": cardNumber
			};
			AdapterUtils.postData("adapters/AccountOverViewAdapter/getCreditCardDetails", payload, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		return {
			getCreditCardDetails: getCreditCardDetails
		};
	}); 