'use strict';

angularApp.controller('dreamAddFundController',["$timeout",
		"$state",
		"$location",
		"$scope",
		"$ionicPopup",
		"myDreamsServices", 
    	"$filter",
		"closePopupService",
		"utilityService",
		"getAccountDetailsService",
		"$translate",
		"$ionicPopover",
		function ($timeout,
			$state,
			$location,
			$scope,
			$ionicPopup,
			myDreamsServices, 
      		$filter,
			closePopupService,
			utilityService,
			getAccountDetailsService,
			$translate,
			$ionicPopover) {

			//functions, variables that can be accessed from the HTML come here
			var dreamAddFundVm = this;
			var currData = '';
			dreamAddFundVm.isValidAccount =  false;
			dreamAddFundVm.validAccountMessage = "";
			dreamAddFundVm.disablenext = false;

			//private methods section start
			function initPage() {
				currData = '';
				currData = myDreamsServices.getDetails();
				dreamAddFundVm.emiPeriod = '';
				dreamAddFundVm.emiAmount = '';
				dreamAddFundVm.dreamName = currData.dreamName;
				dreamAddFundVm.dreamImage = currData.dreamImage;
				dreamAddFundVm.goalAmount = currData.goalAmount;
				dreamAddFundVm.picId = currData.picId;
				dreamAddFundVm.payingFrom = myDreamsServices.getAccountDetails();
				dreamAddFundVm.multipleOf10 = 1;
				dreamAddFundVm.rangeError = 1;
				dreamAddFundVm.showBack = true;
				dreamAddFundVm.showNext = true;
				dreamAddFundVm.date = '';
				$scope.selectedDate = $filter('date')(new Date(), 'dd');
				if($scope.selectedDate > 28){
					$scope.selectedDate = 28;
				}
				
				dreamAddFundVm.accDetails = [];
				dreamAddFundVm.accDetails = dreamAddFundVm.payingFrom;

				var title = '';
				var onTap = '';

				if (myDreamsServices.selectedDetails.accountType === '') {
					var selIndex;
					var selDream = getAccountDetailsService.displayPrimaryAccountAsDefaultDreams(dreamAddFundVm.accDetails , getAccountDetailsService.accountOverviewData.customerInformation.accountNumber);
					selIndex = selDream.index;
					dreamAddFundVm.selectedValue = dreamAddFundVm.accDetails[selIndex].accountType + "," + dreamAddFundVm.accDetails[selIndex].accountNumber + "," + dreamAddFundVm.accDetails[selIndex].accountBalance + "," + dreamAddFundVm.accDetails[selIndex].isActive + "," + dreamAddFundVm.accDetails[selIndex].isTransactional + "," + dreamAddFundVm.accDetails[selIndex].intCategory + "," + dreamAddFundVm.accDetails[selIndex].accountTypeCode + ","+selIndex.toString();
					dreamAddFundVm.indexId = selIndex;
					myDreamsServices.customer.indexId = selIndex; 
					dreamAddFundVm.isActive = dreamAddFundVm.accDetails[selIndex].isActive;
					dreamAddFundVm.isTransactional = dreamAddFundVm.accDetails[selIndex].isTransactional;
					myDreamsServices.customer.selectedItem = dreamAddFundVm.accDetails[selIndex].accountNumber;
					dreamAddFundVm.selectedAccountType = dreamAddFundVm.accDetails[selIndex].accountType;
					dreamAddFundVm.selectedAccountNumber = dreamAddFundVm.accDetails[selIndex].accountNumber;
					dreamAddFundVm.selectedAccountAmount = dreamAddFundVm.accDetails[selIndex].accountBalance;
					dreamAddFundVm.selectedIntCategory = dreamAddFundVm.accDetails[selIndex].intCategory;
					dreamAddFundVm.selectedAccountTypeCode = dreamAddFundVm.accDetails[selIndex].accountTypeCode;
          dreamAddFundVm.selectedNriFlag = dreamAddFundVm.accDetails[selIndex].nriFlag;
					myDreamsServices.selectedDetails.accountType = dreamAddFundVm.selectedAccountType;
					myDreamsServices.selectedDetails.accountNumber = dreamAddFundVm.selectedAccountNumber;
					myDreamsServices.selectedDetails.accountBalance = dreamAddFundVm.selectedAccountAmount;
					myDreamsServices.selectedDetails.intCategory = dreamAddFundVm.selectedIntCategory;
					myDreamsServices.selectedDetails.accountTypeCode = dreamAddFundVm.selectedAccountTypeCode;
          myDreamsServices.selectedDetails.nriFlag = dreamAddFundVm.selectedNriFlag;
				}
				else {
					dreamAddFundVm.indexId = myDreamsServices.customer.indexId;
					dreamAddFundVm.selectedAccountType = myDreamsServices.selectedDetails.accountType;
					dreamAddFundVm.selectedAccountNumber = myDreamsServices.selectedDetails.accountNumber;
					dreamAddFundVm.selectedAccountAmount = myDreamsServices.selectedDetails.accountBalance;
					dreamAddFundVm.selectedIntCategory = myDreamsServices.selectedDetails.intCategory;
					dreamAddFundVm.selectedAccountTypeCode = myDreamsServices.selectedDetails.accountTypeCode;
          dreamAddFundVm.selectedNriFlag = myDreamsServices.selectedDetails.nriFlag;
					dreamAddFundVm.selectedValue = dreamAddFundVm.selectedAccountType + "," + dreamAddFundVm.selectedAccountNumber + "," + dreamAddFundVm.selectedAccountAmount + "," + dreamAddFundVm.accDetails[dreamAddFundVm.indexId].isActive + "," + dreamAddFundVm.accDetails[dreamAddFundVm.indexId].isTransactional + "," + dreamAddFundVm.selectedIntCategory + "," + dreamAddFundVm.selectedAccountTypeCode + ","+dreamAddFundVm.indexId;
				}
				
				if (dreamAddFundVm.isActive === "false" || dreamAddFundVm.isActive === false) {
					dreamAddFundVm.disablenext = true;
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SELECT_ACTIVE_ACC_DREAM"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="ACTIVE_OR"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="CONTACT_NEAREST"></div>';
					myDreamsServices.showAlertModal(title, template, onTap, $scope, $state);
				}

				if (dreamAddFundVm.isTransactional === "false" || dreamAddFundVm.isTransactional === false) {
					dreamAddFundVm.disablenext = true;
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="USE_TRANS_RIGHTS"></div>';
					myDreamsServices.showAlertModal(title, template, onTap, $scope, $state);
				}

				$translate(['ACC_TRANS_RIGHTS','FETCH_TRANS_RGTS']).then(function (translations) {
					dreamAddFundVm.accTransRights = translations['ACC_TRANS_RIGHTS'];
					dreamAddFundVm.fetchTransRights = translations['FETCH_TRANS_RGTS'];
				});
			}

			$scope.getSelectedDate = function (date) {
				dreamAddFundVm.date = date;
				$scope.selectedDate = date;
				dreamAddFundVm.confirmPopup.close();
			}
			/****************   call emi period function start**************/
			dreamAddFundVm.callEMIPeriod = function () {
				var period = 0;
				var emiAmount = parseInt(dreamAddFundVm.emiAmount);
				if (emiAmount % 10 != 0) {
					dreamAddFundVm.multipleOf10 = 0;
				} else {
					dreamAddFundVm.multipleOf10 = 1;
					var totalAmount = currData.goalAmount;
					period = parseInt(totalAmount / emiAmount);
					if ((totalAmount % emiAmount) > 0) {
						period++;
					}
					if (period >= 12 && period <= 120) {
						currData.period = period;
						dreamAddFundVm.emiPeriod = period + " Months";
						dreamAddFundVm.rangeError = 1;
						dreamAddFundVm.rangeErrorMessage = "";
					} else {
						currData.period = period;
						dreamAddFundVm.emiPeriod = period + " Months";
						dreamAddFundVm.rangeError = 0;
						dreamAddFundVm.minAmount = parseInt((totalAmount / 12));
						dreamAddFundVm.maxAmount = parseInt((totalAmount / 120));
					}
				}

			}
			/****************   call emi period function start**************/

			//dreamAddFundVm.changeEmiFlag
			dreamAddFundVm.changeEmiFlag = function () {
				dreamAddFundVm.isAccBalMoreThanEmiFlag = false;
			}

			//open date popup
			dreamAddFundVm.openDatePopup = function () {
				dreamAddFundVm.confirmPopup = $ionicPopup.confirm({
					title: "<b>Selected Date - " + $scope.selectedDate + "</b>",
					templateUrl: 'pages/accountOverview/myDeposits/myDreams/addFund/datePickerPopup.html',
					scope: $scope,
					buttons: []
				});

			}
			//go to review dream page
			dreamAddFundVm.reviewDream = function () {
				$state.go('menu.reviewDream');
			}

			dreamAddFundVm.selectedFromAcc = function (curr) {
				dreamAddFundVm.currFromAcc = curr
			}
			/****************   call review your dream function start**************/

			dreamAddFundVm.computeMyDream = function () {
				dreamAddFundVm.isAccBalMoreThanEmiFlag = false;
				if(getAccountDetailsService.accessRightsData.accounts) {
					for (var i in getAccountDetailsService.accessRightsData.accounts) {
						if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === myDreamsServices.selectedDetails.accountNumber && getAccountDetailsService.accessRightsData.accounts[i].modBalance) {
							dreamAddFundVm.sumModAccountAmount = parseFloat(dreamAddFundVm.selectedAccountAmount) + parseFloat(getAccountDetailsService.accessRightsData.accounts[i].modBalance);
							break;
						}
					}
				} else {
					dreamAddFundVm.sumModAccountAmount = parseFloat(dreamAddFundVm.selectedAccountAmount);
				}
				if (dreamAddFundVm.sumModAccountAmount >= dreamAddFundVm.emiAmount) {
					var reqParams = {
						// "dreamImage":currData.picId,
						"dreamID": currData.dreamID,
						"timeToAchieveDream": currData.period,
						"monthlyContribution": dreamAddFundVm.emiAmount,
						"scheduleMonthlytransfer": dreamAddFundVm.date,
						"startDate": "",
						"siday": dreamAddFundVm.date,
						"intCategory": dreamAddFundVm.selectedIntCategory,
						"accountTypeCode": dreamAddFundVm.selectedAccountTypeCode,
						"debitNriflag":  myDreamsServices.selectedDetails.nriFlag
					};
					utilityService.showSpinner();
					/****************   call compute my dream function start **************/
					myDreamsServices.computeMyDream(reqParams).then(function (data) {

						// ----------------------------------------------------------------------

					// console.log(data);

					if (data.messageCode == "01") {

						dreamAddFundVm.cancelPopupName = $ionicPopup.show({
							title: "",
							cssClass: 'my-custom-popup',
							template: data.message,
							scope: $scope,
							buttons: [
								{
									text: 'OK',
									type: 'button-assertive',
									onTap: function () {
										dreamAddFundVm.cancelPopupName.close();

										// call after NRI check

										dreamAddFundVm.calculateDreamInterestDetails = data.calculateDreamInterest;
							dreamAddFundVm.dreamName = dreamAddFundVm.calculateDreamInterestDetails.dreamName;
							dreamAddFundVm.monthlyContribution = dreamAddFundVm.calculateDreamInterestDetails.monthlyContribution;
							dreamAddFundVm.monthlyContributionDate = dreamAddFundVm.calculateDreamInterestDetails.monthlyContributionDate;
							dreamAddFundVm.totalAmount = dreamAddFundVm.calculateDreamInterestDetails.totalAmount;
							dreamAddFundVm.interestRate = dreamAddFundVm.calculateDreamInterestDetails.intrestRate;
							dreamAddFundVm.startDateNew = dreamAddFundVm.calculateDreamInterestDetails.startDate;
							var monthNew = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
							if (dreamAddFundVm.startDateNew) {
								dreamAddFundVm.startDateNew = new Date(dreamAddFundVm.startDateNew);
								dreamAddFundVm.startDate = "" + dreamAddFundVm.startDateNew.getDate() + " " + monthNew[(dreamAddFundVm.startDateNew.getMonth())] + " " + dreamAddFundVm.startDateNew.getFullYear();
								var year, month, days;
								year = dreamAddFundVm.startDateNew.getFullYear();
								month = dreamAddFundVm.startDateNew.getMonth() + 1;
								days = dreamAddFundVm.startDateNew.getDate();
								if (month < 9) {
									month = "0" + month;
								}
								if (days < 9) {
									days = "0" + days;
								}
								dreamAddFundVm.startDateRequest = "" + days + month + year;
							}
							else {
								dreamAddFundVm.startDate = "";
								dreamAddFundVm.startDateRequest = "";
							}
							dreamAddFundVm.endDateNew = dreamAddFundVm.calculateDreamInterestDetails.endDate;
							if (dreamAddFundVm.endDateNew) {
								dreamAddFundVm.endDateNew = new Date(dreamAddFundVm.endDateNew);
								dreamAddFundVm.endDate = "" + dreamAddFundVm.endDateNew.getDate() + " " + monthNew[(dreamAddFundVm.endDateNew.getMonth())] + " " + dreamAddFundVm.endDateNew.getFullYear();
								var years, months, daysNew;
								years = dreamAddFundVm.endDateNew.getFullYear();
								months = dreamAddFundVm.endDateNew.getMonth() + 1;
								daysNew = dreamAddFundVm.endDateNew.getDate();
								if (months < 9) {
									months = "0" + months;
								}
								if (daysNew < 9) {
									daysNew = "0" + daysNew;
								}
								dreamAddFundVm.endDateRequest = "" + daysNew + months + years;
							}
							else {
								dreamAddFundVm.endDate = "";
								dreamAddFundVm.endDateRequest = "";
							}
							$scope.totalAmount = dreamAddFundVm.calculateDreamInterestDetails.totalAmount;
							var currObj = {
								"picId": currData.picId,
								"dreamName": currData.dreamName,
								"goalAmount": currData.goalAmount,
								"dreamImage": currData.dreamImage,
								"period": currData.period,
								"emiAmount": dreamAddFundVm.emiAmount,
								"accountType": dreamAddFundVm.selectedAccountType,
								"accountNo": dreamAddFundVm.selectedAccountNumber,
								"balance": dreamAddFundVm.selectedAccountAmount,
								"dreamID": currData.dreamID,
								"scheduleMonthlytransfer": dreamAddFundVm.date,
								"calculateDreamInterestDetails": dreamAddFundVm.calculateDreamInterestDetails,
								"startDate": dreamAddFundVm.startDate,
								"endDate": dreamAddFundVm.endDate,
								"intCategory": dreamAddFundVm.selectedIntCategory,
								"accountTypeCode": dreamAddFundVm.selectedAccountTypeCode
							};
							myDreamsServices.addDetails(currObj);
							utilityService.hideSpinner();
							$state.go('menu.reviewYourDream');
										// call after NRI check END

									}
								},
								{
									text: 'Cancel',
									type: 'button-assertive',
									onTap: function () {
										dreamAddFundVm.cancelPopupName.close();
									}
								}
							],
						});

					}
					else {

						// call after NRI check

						dreamAddFundVm.calculateDreamInterestDetails = data.calculateDreamInterest;
							dreamAddFundVm.dreamName = dreamAddFundVm.calculateDreamInterestDetails.dreamName;
							dreamAddFundVm.monthlyContribution = dreamAddFundVm.calculateDreamInterestDetails.monthlyContribution;
							dreamAddFundVm.monthlyContributionDate = dreamAddFundVm.calculateDreamInterestDetails.monthlyContributionDate;
							dreamAddFundVm.totalAmount = dreamAddFundVm.calculateDreamInterestDetails.totalAmount;
							dreamAddFundVm.interestRate = dreamAddFundVm.calculateDreamInterestDetails.intrestRate;
							dreamAddFundVm.startDateNew = dreamAddFundVm.calculateDreamInterestDetails.startDate;
							var monthNew = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
							if (dreamAddFundVm.startDateNew) {
								dreamAddFundVm.startDateNew = new Date(dreamAddFundVm.startDateNew);
								dreamAddFundVm.startDate = "" + dreamAddFundVm.startDateNew.getDate() + " " + monthNew[(dreamAddFundVm.startDateNew.getMonth())] + " " + dreamAddFundVm.startDateNew.getFullYear();
								var year, month, days;
								year = dreamAddFundVm.startDateNew.getFullYear();
								month = dreamAddFundVm.startDateNew.getMonth() + 1;
								days = dreamAddFundVm.startDateNew.getDate();
								if (month < 9) {
									month = "0" + month;
								}
								if (days < 9) {
									days = "0" + days;
								}
								dreamAddFundVm.startDateRequest = "" + days + month + year;
							}
							else {
								dreamAddFundVm.startDate = "";
								dreamAddFundVm.startDateRequest = "";
							}
							dreamAddFundVm.endDateNew = dreamAddFundVm.calculateDreamInterestDetails.endDate;
							if (dreamAddFundVm.endDateNew) {
								dreamAddFundVm.endDateNew = new Date(dreamAddFundVm.endDateNew);
								dreamAddFundVm.endDate = "" + dreamAddFundVm.endDateNew.getDate() + " " + monthNew[(dreamAddFundVm.endDateNew.getMonth())] + " " + dreamAddFundVm.endDateNew.getFullYear();
								var years, months, daysNew;
								years = dreamAddFundVm.endDateNew.getFullYear();
								months = dreamAddFundVm.endDateNew.getMonth() + 1;
								daysNew = dreamAddFundVm.endDateNew.getDate();
								if (months < 9) {
									months = "0" + months;
								}
								if (daysNew < 9) {
									daysNew = "0" + daysNew;
								}
								dreamAddFundVm.endDateRequest = "" + daysNew + months + years;
							}
							else {
								dreamAddFundVm.endDate = "";
								dreamAddFundVm.endDateRequest = "";
							}
							$scope.totalAmount = dreamAddFundVm.calculateDreamInterestDetails.totalAmount;
							var currObj = {
								"picId": currData.picId,
								"dreamName": currData.dreamName,
								"goalAmount": currData.goalAmount,
								"dreamImage": currData.dreamImage,
								"period": currData.period,
								"emiAmount": dreamAddFundVm.emiAmount,
								"accountType": dreamAddFundVm.selectedAccountType,
								"accountNo": dreamAddFundVm.selectedAccountNumber,
								"balance": dreamAddFundVm.selectedAccountAmount,
								"dreamID": currData.dreamID,
								"scheduleMonthlytransfer": dreamAddFundVm.date,
								"calculateDreamInterestDetails": dreamAddFundVm.calculateDreamInterestDetails,
								"startDate": dreamAddFundVm.startDate,
								"endDate": dreamAddFundVm.endDate,
								"intCategory": dreamAddFundVm.selectedIntCategory,
								"accountTypeCode": dreamAddFundVm.selectedAccountTypeCode
							};
							myDreamsServices.addDetails(currObj);
							utilityService.hideSpinner();
							$state.go('menu.reviewYourDream');

						// call after NRI check END

					}


					// -------------------------------------------------------------------------


						},
						function (error) {
							utilityService.hideSpinner();
							utilityService.showErrorMessage(error.responseMessage);
						});
					/****************   call compute my dream function end**************/
				}
				else {
					dreamAddFundVm.isAccBalMoreThanEmiFlag = true;
				}
			}

			dreamAddFundVm.reviewYourDream = function () {
				if(getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
					dreamAddFundVm.disablenext = true;
					dreamAddFundVm.isValidAccount =  true;
					dreamAddFundVm.validAccountMessage = dreamAddFundVm.fetchTransRights;
				} else {
					var isAccountTransactional = false;
					for (var i in getAccountDetailsService.accessRightsData.accounts) {
						if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === myDreamsServices.selectedDetails.accountNumber && parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) != 0) {
							isAccountTransactional = true;
						}
					}
					if(isAccountTransactional) {
						dreamAddFundVm.computeMyDream();
					} else {
						dreamAddFundVm.disablenext = true;
						dreamAddFundVm.isValidAccount =  true;
						dreamAddFundVm.validAccountMessage = dreamAddFundVm.accTransRights;
					}
				}
			}

			/****************   call review your dream function end**************/

			/****************   show account popup dream function start**************/

			/* change event for selecting account*/
			dreamAddFundVm.selectedAccountFun = function () {
				var data = dreamAddFundVm.selectedValue.split(",");
				var e = [];
				e.accountType = data[0];
				e.accountNumber = data[1];
				e.accountBalance = data[2];
				e.isActive = data[3];
				e.isTransactional = data[4];
				e.intCategory = data[5];
				e.accountTypeCode = data[6];
				e.indexId = data[7];
				e.nriFlag = data[8];
				dreamAddFundVm.indexId = e.indexId;
				myDreamsServices.customer.indexId = dreamAddFundVm.indexId;
				dreamAddFundVm.isActive = e.isActive;
				dreamAddFundVm.isTransactional = e.isTransactional;
				var title = '';
				var onTap = '';

				if (dreamAddFundVm.isActive === "true" && dreamAddFundVm.isTransactional === "true") {
					dreamAddFundVm.selectedAccountType = e.accountType;
					dreamAddFundVm.selectedAccountNumber = e.accountNumber;
					dreamAddFundVm.selectedAccountAmount = e.accountBalance;
					myDreamsServices.customer.selectedItem = e.accountNumber;
					myDreamsServices.selectedDetails.accountType = e.accountType;
					myDreamsServices.selectedDetails.accountNumber = e.accountNumber;
					myDreamsServices.selectedDetails.accountBalance = e.accountBalance;
					myDreamsServices.selectedDetails.intCategory = e.intCategory;
					myDreamsServices.selectedDetails.accountTypeCode = e.accountTypeCode;
					myDreamsServices.selectedDetails.nriFlag = e.nriFlag;
					dreamAddFundVm.disablenext = false;
				} else {
					if (dreamAddFundVm.isActive === "false" || dreamAddFundVm.isActive === false) {
						dreamAddFundVm.disablenext = true;
						var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SELECT_ACTIVE_ACC_DREAM"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="ACTIVE_OR"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="CONTACT_NEAREST"></div>';
						myDreamsServices.showAlertModal(title, template, onTap, $scope, $state);
					}

					if (dreamAddFundVm.isTransactional === "false" || dreamAddFundVm.isTransactional === false) {
						dreamAddFundVm.disablenext = true;
						var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="USE_TRANS_RIGHTS"></div>';
						myDreamsServices.showAlertModal(title, template, onTap, $scope, $state);
					}
				}
				dreamAddFundVm.isValidAccount =  false;
				dreamAddFundVm.validAccountMessage = "";
			};

			/****************   show account popup dream function end**************/

			//private methods section end

			//public functions start

			//public functions end

			//back to prev page
			dreamAddFundVm.goBacktoPrevious = function () {
				//To do
			}

			dreamAddFundVm.addFundsView = function () {
				$state.go("menu.accountOverviewMyBalance");
			}

			dreamAddFundVm.goToHome = function () {
				$state.go("menu.accountOverviewMyBalance");
			}

			//go to next page
			dreamAddFundVm.goToNextPage = function () {
				$state.go('menu.accountOverviewPopup');
			}

			dreamAddFundVm.dreamTransDetails = function () {
				$state.go('menu.dreamTransDetails');
			}
			
			dreamAddFundVm.infoPopup = function($event) {
			utilityService.showSpinner();	
			myDreamsServices.getContribution().then(function(data) {
				dreamAddFundVm.infoData = data;
				var template = '<ion-popover-view class="dreams-popup-tooltip derams-popup-info roboto-regular line-ht-popup-dreams">' + '<ion-content>' + '<div  class="info-container-dreams"  ng-bind-html="dreamAddFundVm.infoData"></div>' + '</ion-content>' +'</ion-popover-view>';
				$scope.popover = $ionicPopover.fromTemplate(template, {
					scope : $scope
				});
				$scope.popover.show($event);
				utilityService.hideSpinner();
			}, function(error) {
				utilityService.hideSpinner();
				utilityService.showErrorMessage(error.responseMessage);
			}); 
		}; 

			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {
				if(getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
					getAccountDetailsService.getAccountsAccessRights('').then( function(data) {
                    getAccountDetailsService.accessRightsData = data;
					}, function(error) {
						// Failure block
					});
				}
			});

			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			//actions to done everytime the view is hidden
			$scope.$on('$ionicView.afterLeave', function () {
				//any cleanup needs to be done here: executes everytime when page is left
			});

			return this;

		}]);