'use strict';

angularApp.controller('viewTransactionsController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope",
						 "$stateParams",
						 "myDreamsServices",
				 
function ($timeout,
		 $state,
		 $location,
		 $scope,
		 $stateParams,
		 myDreamsServices) {
	
	//functions, variables that can be accessed from the HTML come here
	var viewTransactionsVm = this;
	
	//private methods section start
	function initPage(){
		viewTransactionsVm.showBack = true;
		viewTransactionsVm.showNext = true;
	}
	//private methods section end
	
	//public functions start
	
	//public functions end
	
	//back to prev page
	viewTransactionsVm.goBacktoPrevious = function(){
		//To do
	}
	
	//go to next page
	viewTransactionsVm.goToNextPage = function(){
		$state.go('menu.accountOverviewPopup');
	}
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		initPage();
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		//fetch dreams details objects
		viewTransactionsVm.dreamsObj = myDreamsServices.dreamsObj;
		viewTransactionsVm.dreamDetailsObj = $stateParams.dreamDetailsObj;
		viewTransactionsVm.transDetObj = $stateParams.transDetObj;
		myDreamsServices.dreamId=viewTransactionsVm.dreamsObj.dreamId;
		
		$stateParams.dreamsObj="";
		$stateParams.dreamDetailsObj="";
		$stateParams.transDetObj="";
		
	});
	
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);