	angularApp.service('myDreamsServices',
	function($q,AdapterUtils,$ionicPopup){
		var myDreamsService =this;
		
		myDreamsService.accDetails =[];
		
		myDreamsService.selectedDetails ={
			accountType:'',
			accountNumber:'',
			accountBalance:'',
			intCategory:'',
			accountTypeCode:''
		};
		
		myDreamsService.customer = {
			selectedItem : '',
			indexId :0
		}
		
		myDreamsService.dreamId="";
		myDreamsService.dreamsObj="";
		
		//service call to get dream details
		myDreamsService.getDreaminfo =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/getMyDreamDetail", reqData, false).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		//service call to create My Dream
		myDreamsService.createDream =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/createDream", reqData, false).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
	
		//service is used to upload Dream Image
		myDreamsService.uploadDreamImage =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/uploadImage", reqData, false).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		//service is used to retrive Dream Image
		myDreamsService.retriveDreamImage =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/CommonAdapter/getImagesByIds", reqData, false).then(
				function(response){
					q.resolve(response);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		// myDreamsService.retriveDreamImage =function(reqData) {
		// 	var q = $q.defer();	
		// 	AdapterUtils.postData("adapters/CommonAdapter/getAllImages", reqData, false).then(
		// 		function(response){
		// 			q.resolve(response);
		// 		},
		// 		function(error){
		// 			q.reject(error);
		// 		}
		// 		); 
		// 	return q.promise;
			
		// };
		//service call to get My Dream Transactions details
		myDreamsService.getMyDreamTransactions =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/getMyDreamTransactions", reqData, false).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		//service call to get dream details
		myDreamsService.getDreamDetailsForClosuer =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/getDreamDetailsForClosuer", reqData, false).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		//service call to close dream
		myDreamsService.closeDreams =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/closeDreams", reqData, false).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		//service is used to computeMyDream
		myDreamsService.computeMyDream =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/computeMyDream", reqData, false).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		//service is used to addFundsToMyDreams
		myDreamsService.addFundsToMyDreams =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/addFundsToMyDreams", reqData, false).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		//service is used to call terms ans conditions
		myDreamsService.getTermsAndConditions =function() {
			var q = $q.defer();	
			AdapterUtils.getData("adapters/MyDreamsAdapter/getTermsAndConditions", false).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		myDreamsService.selectedItem = null;
		var myDreamsList = {};
		var accountList = [];
		myDreamsService.addDetails = function(newObj) {
			 myDreamsList = newObj;
		};

		myDreamsService.getDetails = function(){
			return myDreamsList;
		};
		
		myDreamsService.addAccountDetails = function(accListObj){
			accountList = accListObj;
		};
		
		myDreamsService.getAccountDetails = function(){
			return accountList;
		}
		
		myDreamsService.showAlertModal = function(title,template,onTapgo,$scope,$state) {
			var alertPopup = $ionicPopup.show({
				title: title,
				template: template,
				scope: $scope,
				cssClass: 'my-custom-popup',
				buttons: [{
					text:'OK',
					type: 'button-assertive',
					onTap: function() { 
						if(onTapgo !== '' && onTapgo !== null){
							$state.go(onTapgo);
						}
					}
				}],
			});
		 }
		 
		 //service call to create My Dream
		myDreamsService.effectiveInterestEarnedInfo =function() {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/getInfoList", "{}", false).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};

		//service call to close dream
		myDreamsService.closeUnfundedDream =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/closeUnfundedDream", reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		//service call to close dream
		myDreamsService.closeUnfundedDream =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/closeUnfundedDream", reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		//service call to close dream
		myDreamsService.savingFor =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/savingsFor", reqData, true).then(
				function(response){
					q.resolve(response.data.infoList);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		//service call to close dream
		myDreamsService.getContribution =function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/MyDreamsAdapter/savingsFor", reqData, true).then(
				function(response){
					q.resolve(response.data.infoList);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		return myDreamsService;
	});  
