'use strict';

angularApp.controller('createNewDreamSuccessController', ["$state",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$ionicPlatform",
    "$scope",
    "$interval",
    "$filter",
    "myDreamsService",
    "$timeout",

    function ($state,
        $rootScope,
        utilityService,
        constantConfig,
        $ionicPlatform,
        $scope,
        $interval,
        $filter,
        myDreamsService,
        $timeout) {

        var createNewDreamSuccessVm = this;

        createNewDreamSuccessVm.close = function(){
            $state.go('menu.accountOverviewMyBalance');
        }

        createNewDreamSuccessVm.investFunds = function () {
            var reqParams = {
                "dreamId": myDreamsService.selectedDreamDetails.dreamId
            };
            myDreamsService.getEligibleLinkingAccounts(reqParams).then(function (data) {
                myDreamsService.eligibleLinkingAccounts = data;
                $state.go('menu.linkDream');
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            createNewDreamSuccessVm.createdDreamDetails = myDreamsService.selectedDreamDetails
        });

        return this;
    }

]);

