'use strict';

angularApp.controller('delinkSuccessController', ["$state",
    "$rootScope",
    "utilityService",
    "constantConfig",
    "$ionicPlatform",
    "$scope",
    "$interval",
    "$filter",
    "myDreamsService",
    "$timeout",

    function ($state,
        $rootScope,
        utilityService,
        constantConfig,
        $ionicPlatform,
        $scope,
        $interval,
        $filter,
        myDreamsService,
        $timeout) {

        var delinkSuccessVm = this;

        delinkSuccessVm.close = function(){
            $state.go('menu.accountOverviewMyBalance');
        }

        delinkSuccessVm.goToSelectedDream = function () {
            if(delinkSuccessVm.selectedAccount.accountType == 'FD'){
                for(var i = 0; i < myDreamsService.selectedDreamDetails.fixedDeposits.length; i++){
                    if(delinkSuccessVm.selectedAccount.accountNumber == myDreamsService.selectedDreamDetails.fixedDeposits[i].accountNumber && 
                    myDreamsService.selectedAccount.$$hashKey == myDreamsService.selectedDreamDetails.fixedDeposits[i].$$hashKey){
                        myDreamsService.selectedDreamDetails.fixedDeposits.splice(i, 1);
                    }
                }
            }
            if(delinkSuccessVm.selectedAccount.accountType == 'RD'){
                for(var i = 0; i < myDreamsService.selectedDreamDetails.recurringDeposits.length; i++){
                    if(delinkSuccessVm.selectedAccount.accountNumber == myDreamsService.selectedDreamDetails.recurringDeposits[i].accountNumber && 
                    myDreamsService.selectedAccount.$$hashKey == myDreamsService.selectedDreamDetails.recurringDeposits[i].$$hashKey){
                        myDreamsService.selectedDreamDetails.recurringDeposits.splice(i, 1);
                    }
                }
            }
             if(delinkSuccessVm.selectedAccount.accountType == 'MF'){
                for(var i = 0; i < myDreamsService.selectedDreamDetails.mutualFunds.length; i++){
                     for (var j = 0; j < delinkSuccessVm.selectedDreamDetails.mutualFunds[i].fundList.length; j++) {
                    if(delinkSuccessVm.selectedAccount.amfiCode == delinkSuccessVm.selectedDreamDetails.mutualFunds[i].fundList[j].amfiCode &&
                     delinkSuccessVm.selectedAccount.folioNo == delinkSuccessVm.selectedDreamDetails.mutualFunds[i].fundList[j].folioNo && 
                     delinkSuccessVm.selectedAccount.schemeCode == delinkSuccessVm.selectedDreamDetails.mutualFunds[i].fundList[j].schemeCode){ 
                       myDreamsService.selectedDreamDetails.mutualFunds[i].fundList.splice(i,1)
                        // delete myDreamsService.selectedDreamDetails.mutualFunds[i].fundList[j];
                    }
                     }
                }
            }

            $state.go('menu.selectedDream');
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            delinkSuccessVm.selectedDreamDetails = myDreamsService.selectedDreamDetails;
            delinkSuccessVm.selectedAccount = myDreamsService.selectedAccount;
        });

        return this;
    }

]);

