'use strict';

angularApp.controller('otherBankAALandingPageController', [
    "$state",
    "$scope",
    "$ionicHistory",
    "OBADServices",
    "homeScreenService",
    function (
        $state,
        $scope,
        $ionicHistory,
        OBADServices,
        homeScreenService) {
        var otherBankAALandVm = this;


        // Saving customer choice for VUA
        otherBankAALandVm.goToAAListPage = function (isIdAvailiable) {
            if (isIdAvailiable == 'yes') {
                OBADServices.isIdAvailiable = true;
            } else {
                OBADServices.isIdAvailiable = false;
            }
            $state.go('menu.otherBankselectAA');
        }

        // Navigate to previous page
        otherBankAALandVm.goBack = function () {
            homeScreenService.isAccountsFlag = true;
            $ionicHistory.goBack()
        }

        // before leaving page removing hidden buttons like logout, support etc
        $scope.$on('$ionicView.beforeLeave', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.remove('hiddenExtraButton');
            }
        });

        // adding css after entering page hidding buttons like logout, support etc
        $scope.$on('$ionicView.afterEnter', function () {
            var headerElem = document.querySelector('body');
            if (headerElem) {
                headerElem.classList.add('hiddenExtraButton');
            }

        });


        return this;

    }

])