'use strict';

angularApp.service('OBADServices',
	function ($q, utilityService, AdapterUtils) {

		var OBADServices = this;
		this.isIdAvailiable = false;
		this.selectedAccAggr = {};
        this.transList = {};

		OBADServices.getConsentAccountList = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/AccountOverViewAdapter/Aggregator/getConsentAccountList", {}, true).then(
                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

		OBADServices.getAAUrl = function (reqData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/AccountOverViewAdapter/Aggregator/getAAUrl", reqData, true).then(
                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

		OBADServices.getFiData = function (reqData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/AccountOverViewAdapter/Aggregator/getFiData", reqData, true).then(
                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


		return OBADServices;
	});
