'use strict';

angularApp.controller('bqrLoginController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"$cordovaBarcodeScanner",
	"cameraService",
	"utilityService",
	"fTBeneficiaryService",
	"$rootScope",
	"cryptoService",
	"constantConfig",
	"bQRService",

	function ($state,
		$scope,
		$ionicPopup,
		$cordovaBarcodeScanner,
		cameraService,
		utilityService,
		fTBeneficiaryService,
		$rootScope,
		cryptoService,
		constantConfig,
		bQRService) {

		var bqrLoginVm = this;
		bqrLoginVm.scannedImage = "img/FT/PayQRCode.svg";
		bqrLoginVm.headerImage = "img/bharatQR/Bharat_QR.svg";
		
		
		
		

		//Toggle QR
		bqrLoginVm.classForMpinLoginOpt = 'tab-item border-left tabs-style div-bottom bor-bot-active';
		bqrLoginVm.classForUserLoginOpt = 'tab-item border-left tabs-style div-bottom';

		bqrLoginVm.MPINFlag = true;
		bqrLoginVm.UserIdFlag = false;
		bqrLoginVm.toggleLoginMenu = function (loginOption) {
			if (loginOption === 'mPin') {
				bqrLoginVm.MPINFlag = true;
				bqrLoginVm.UserIdFlag = false;
				bqrLoginVm.classForMpinLoginOpt = 'tab-item border-left tabs-style div-bottom bor-bot-active';
				bqrLoginVm.classForUserLoginOpt = 'tab-item border-left tabs-style div-bottom';
			}
			if (loginOption === 'userId') {
				bqrLoginVm.MPINFlag = false;
				bqrLoginVm.UserIdFlag = true;
				bqrLoginVm.classForMpinLoginOpt = 'tab-item border-left tabs-style div-bottom';
				bqrLoginVm.classForUserLoginOpt = 'tab-item border-left tabs-style div-bottom bor-bot-active';
			}
		};
		
		
		
		
		
		 //Close and Navigate to Login Page
		$scope.goToHome = function () {
			$state.go('menu.userLogin');
		}                                                                                    
		
		
	

		$scope.$on('$ionicView.beforeEnter', function () {
			bqrLoginVm.isBarcodeScanned = false;
		});
		
		return this;
	}]);