'use strict';

angularApp.controller('bookingsController', ["$timeout",
	"$state",
	"$scope",
	"bookingsService",
	"$translate",
	"$ionicScrollDelegate",
	"$ionicSlideBoxDelegate",
	"$interval",
	"utilityService",
	"$ionicPopup",
	"ompMerchantsService",
	"filterService",
	"searchListServices",
	"mPinLoginService",
	"personalLoanService",
	"clickStreamService",
	"homeScreenService",
	"generalInsurenceHomeService",
	"irctcService",
	"cardsService",

	function ($timeout,
		$state,
		$scope,
		bookingsService,
		$translate,
		$ionicScrollDelegate,
		$ionicSlideBoxDelegate,
		$interval,
		utilityService,
		$ionicPopup,
		ompMerchantsService,
		filterService,
		searchListServices,
		mPinLoginService,
		personalLoanService,
		clickStreamService,
		homeScreenService,
	        generalInsurenceHomeService, irctcService, cardsService
	) {

		var bookingsVm = this;
		var isWebviewLoadingCanceled = false;
			var isBannerClicked = false;
		function initPage() {
          if(homeScreenService.ishamburgerMenuBookMain){
            bookingsVm.isHamCheck = true;
            bookingsVm.isBackCheck = true;
          }else {
            bookingsVm.isBackCheck = false;
          }
			$scope.scrollEvent = function (id) {
				var handler = id.replace(/[\s]/g, '');
				$timeout(function () {
					var sv = $ionicScrollDelegate.$getByHandle(handler).getScrollView();
					var container = sv.__container;
					var originaltouchStart = sv.touchStart;
					var originaltouchMove = sv.touchMove;
					container.removeEventListener('touchstart', sv.touchStart);
					document.removeEventListener('touchmove', sv.touchMove);
					sv.touchStart = function (e) {
						e.preventDefault = function () { }
						originaltouchStart.apply(sv, [e]);
					}
					sv.touchMove = function (e) {
						e.preventDefault = function () { }
						originaltouchMove.apply(sv, [e]);
					}
					container.addEventListener("touchstart", sv.touchStart, false);
					document.addEventListener("touchmove", sv.touchMove, false);

				});
			}
		}




		bookingsVm.disclaimer = function (data) {
			bookingsVm.merchantsList = data;

			if (bookingsVm.merchantsList.merchantType != 'Custom') {
				bookingsVm.myPopup = $ionicPopup.show({
					title: '',
					cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
					templateUrl: "pages/bookAndOrder/bookings/disclaimerPopup.html",
					scope: $scope
				});
				isWebviewLoadingCanceled = false;
				if (ompMerchantsService) {
					if (data.affiliateId) {
						clickStreamService.clickStreamData = "websiteId," + data.affiliateId;
					}
				};
			}
			else {
				irctcService.searchTrainObj = "";
				irctcService.myList = "";
				irctcService.masterData = "";
				irctcService.selectedTrainData = "";
				irctcService.myListFullData = "";
                homeScreenService.ishamburgerMenuIRCTC=true;
				$state.go('menu.irctcBookTicketSearch');
			}

		};

		bookingsVm.cancel = function () {
				isBannerClicked = false;
			clickStreamService.clickStreamData = "websiteId," + bookingsVm.merchantsList.affiliateId;
			bookingsVm.myPopup.close();
		};

        bookingsVm.agree = function () {
        	isWebviewLoadingCanceled = false;
            bookingsVm.myPopup.close();

			if(isBannerClicked){
        		isBannerClicked = false;
        		bookingsVm.gotoSelBanner(bookingsVm.merchantsList);
        		return true;
        	}
            /*if(bookingsVm.merchantsList.merchantCode == "ola"){
            	ompMerchantsService.inChromeBrowser(bookingsVm.merchantsList.redirectUrl);
            	bookingsVm.myPopup.close();		 
            	return true;
            }	*/
            
            if (bookingsVm.merchantsList.merchantType === 'Redirection') {
                bookingsVm.loadPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
                    templateUrl: "pages/bookAndOrder/bookings/loading.html",
                    scope: $scope
                })

				$timeout(function () {

					if (bookingsVm.merchantsList.merchantType === 'Redirection') {
						var myArr = bookingsVm.stores[0];
						var saveLeadObj = {
							"leadId": "",
							"websiteId": bookingsVm.merchantsList.websiteId,
							"affiliateId": bookingsVm.merchantsList.affiliateId,
							"request": {
								"ompCcustToken": "",
								"loggedIn": "",
								"channel": "",
								"segId": "",
								"ompTokenId": "",
								"merchantSku": "",
								"prdPrice": "",
								"wishlistSkus": "",
								"ompDisValue": "",
								"ompDisPct": "",
								"ompDisType": "",
								"isLoggedIn": mPinLoginService.isLoggedIn
							},
							"leadParam": bookingsVm.merchantsList.leadParam,
							"segmentParam": bookingsVm.merchantsList.segmentParam,
                        "affiliateIdParam": bookingsVm.merchantsList.affiliateIdParam,
                        "mobileRedirectUrl" : bookingsVm.merchantsList.mobileRedirectUrl

						}
						ompMerchantsService.saveLead(saveLeadObj).then(function (data) {
							bookingsVm.loadPopup.close();
							if (isWebviewLoadingCanceled == true) {
								return "";
							}
							isWebviewLoadingCanceled = true;
							if (bookingsVm.merchantsList.redirectUrl.indexOf('?') != -1) {
								if (mPinLoginService.isLoggedIn) {
                                if (bookingsVm.merchantsList.merchantCode == "ubr") {
										if (utilityService.isAndroidPlatform()) {
											appAvailability.check('com.ubercab',
												function () {
                                                var url = data.data.mobileUrl;;
                                                ompMerchantsService.inChromeBrowser(url);

												},
												function () {
													var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
													ompMerchantsService.inChromeBrowser(url);

												});

										} else {
											appAvailability.check('uber://', function () {
                                                var url = data.data.mobileUrl;
                                                
                                                ompMerchantsService.inChromeBrowser(url);

											}, function () {
                                                var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
                                                ompMerchantsService.inChromeBrowser(url);

											});
										}

										bookingsVm.myPopup.close();
										return true;
                                } else if (bookingsVm.merchantsList.browserType === 'inApp') {
                                    ompMerchantsService.inAppBrowser(data.data.mobileUrl);
                                    } else if (bookingsVm.merchantsList.browserType === 'default') {
                                    ompMerchantsService.inChromeBrowser(data.data.mobileUrl);
                                    } else if (bookingsVm.merchantsList.browserType === 'chrome_tab') {
                                    ompMerchantsService.inChromeTabBrowser(data.data.mobileUrl);
                                    }
                            }
							} else {
                            if (mPinLoginService.isLoggedIn) {
                                if (bookingsVm.merchantsList.merchantCode == "ubr") {
										if (utilityService.isAndroidPlatform()) {
											appAvailability.check('com.ubercab',
												function () {
                                                var url = data.data.mobileUrl;
                                                ompMerchantsService.inChromeBrowser(url);

												},
												function () {
													var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
													ompMerchantsService.inChromeBrowser(url);

												});

										} else {
                                        appAvailability.check('uber://', function() {
                                            var url = data.data.mobileUrl;
												ompMerchantsService.inChromeBrowser(url);

											}, function () {
												var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
												ompMerchantsService.inChromeBrowser(url);

											});
										}

										bookingsVm.myPopup.close();
										return true;
                                } else if (bookingsVm.merchantsList.browserType === 'inApp') {
                                    ompMerchantsService.inAppBrowser(data.data.mobileUrl);
                                    } else if (bookingsVm.merchantsList.browserType === 'default') {
                                    ompMerchantsService.inChromeBrowser(data.data.mobileUrl);
                                    } else if (bookingsVm.merchantsList.browserType === 'chrome_tab') {
                                    ompMerchantsService.inChrometabBrowser(data.data.mobileUrl);
                                    }
                            }
                        }

						}, function (error) {
							bookingsVm.loadPopup.close();
							utilityService.showErrorMessage(error.responseMessage);
						});

					}


				}, 5000);
			}




		};

		bookingsVm.tapCancel = function () {
			bookingsVm.loadPopup.close();
			isWebviewLoadingCanceled = true;
			$state.go('menu.bookings');
		};

		bookingsVm.gotoSelectedFeature = function (data) {
            homeScreenService.ishamburgerMenuBook=false;
			bookingsService.moreScore = data;
			bookingsService.store = bookingsVm.stores;
			utilityService.clearHistoryExceptCurrentView();
			$state.go('menu.bookingList');
		}

		bookingsVm.next = function () {
			$ionicSlideBoxDelegate.next();
		};

		bookingsVm.previous = function () {
			$ionicSlideBoxDelegate.previous();
		};

		$scope.$on('$ionicView.loaded', function () {
			initPage();
		});

		$scope.slideChanged = function (index) {
			$scope.slideIndex = index;
		};

		bookingsVm.gotoSelBannerPre = function (img) {
			if (img.redirectionType == "External") {
			isBannerClicked = true;
        	bookingsVm.merchantsList = img;
        	bookingsVm.disclaimer(bookingsVm.merchantsList);
        	}else{
        		bookingsVm.gotoSelBanner(img);		
        	}
		}
		bookingsVm.gotoSelBanner = function (img) {
			if (ompMerchantsService) {
				if (img.affiliateId) {
					clickStreamService.clickStreamData = "websiteId," + img.affiliateId;
				} else {
					clickStreamService.clickStreamData = "websiteId," + "";
					img.affiliateId = "";
				}
			};
			isWebviewLoadingCanceled = false;
			var redirectUrl = img.redirectUrl;

			if (img.redirectionType == "External") {

				bookingsVm.loadPopup = $ionicPopup.show({
					title: '',
					cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
					templateUrl: "pages/bookAndOrder/bookings/loading.html",
					scope: $scope
				});

				var obj = {
					"sessionId": img.sessionId,
					"merchantName": img.merchantName,
					"type": "accept",
					"treatmentCode": img.treatmentCode,
					"isLoggedIn": mPinLoginService.isLoggedIn,
					"affiliateId": img.affiliateId,
					"websiteId": ""

				};
				ompMerchantsService.submitBannerAction(obj).then(function (data) {
					bookingsVm.loadPopup.close();
                    if (isWebviewLoadingCanceled == true) {
                        return "";
                    }
					isWebviewLoadingCanceled = true;
					if (img.redirectUrl.indexOf('?') != -1) {
						if (mPinLoginService.isLoggedIn) {
							ompMerchantsService.inAppBrowser(img.redirectUrl + "&" + data.data.parameter);
							// logoutChallangeHandler();
						}
					} else {
						if (mPinLoginService.isLoggedIn) {
							ompMerchantsService.inAppBrowser(img.redirectUrl + "?" + data.data.parameter);
							// logoutChallangeHandler();
						}
					}
				}, function (error) {
					bookingsVm.loadPopup.close();
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				var bannerinfoobj = JSON.parse(redirectUrl);
				if (!ompMerchantsService.listName.websiteId) {
					ompMerchantsService.listName = {};
					ompMerchantsService.listName.websiteId = "";
				}
				ompMerchantsService.listName.websiteId = bannerinfoobj.WebsiteId;

				if (bannerinfoobj.pageId.toLowerCase() == "shop") {
					var merchantobj = "";
					for (var i = 0; i < bookingsVm.stores.length; i++) {
						var merchantTotalData = bookingsVm.stores[i].data
						for (var j = 0; j < merchantTotalData.length; j++)
							if (merchantTotalData[j].websiteId == bannerinfoobj.WebsiteId) {
								if (merchantTotalData[0].merchantType === "Native") {
									merchantobj = merchantTotalData[j];
									break;
								}
							}

						if (merchantobj != "") {
							break;
						}
					}
					ompMerchantsService.listName = merchantobj
                    $state.go('menu.ompShop');
                } else if (bannerinfoobj.pageId.toLowerCase() == "productdescription") {

                    var product = {
                        "websiteId": bannerinfoobj.WebsiteId,
                        "productId": bannerinfoobj.productId,
                        "isLoggedIn": mPinLoginService.isLoggedIn
                    };
                    productDescriptionServices.getProductDetails(product).then(function(data) {
                        productDescriptionServices.productData = data;
                        $state.go('menu.productDescription');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                } else if (bannerinfoobj.pageId == 'menu.creditCards') {
                        cardsService.setParams({ "cardName": bannerinfoobj.productId });
                        $state.go('menu.cardPlatinum');
                } else if (bannerinfoobj.pageId.toLowerCase() == "list") {

					if (bannerinfoobj.listType.toLowerCase() == "deal") {


						var dealList = {
							"type": "deal",
							"websiteId": bannerinfoobj.WebsiteId,
							"filters": [],
							"sort": {},
							"isLoggedIn": mPinLoginService.isLoggedIn
						}
						searchListServices.getDealList(dealList).then(function (data) {
							filterService.filterOldData = searchListServices.filterData;
							searchListServices.allProductsList = data;
							filterService.selectedLevelOneData = '';
							filterService.selectedLevelTwoData = "";
							filterService.selectedLevelThreeData = "";
							searchListServices.products.length = 0
							filterService.addedFilterFullData.length = 0
							filterService.addedFilterData.length = 0
							filterService.selectedColour.length = 0
							searchListServices.isCompareAvailable = false;
							searchListServices.serviceFrom = 'deal';
							searchListServices.serviceFromObj = dealList;
							searchListServices.searchFor = "Deals for You";
							filterService.isFilterApplied = false;
							searchListServices.isSortApplied = false;
							searchListServices.filterNewData = {
								categoryList: [],
								subCategoryList: [],
								colorList: [],
								priceList: [],
								callFunctionsList: []
							};
							$state.go('menu.searchList');
						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});






					}

					else if (bannerinfoobj.listType.toLowerCase() == "category") {
						var obj = {
							"category": bannerinfoobj.categoryId,
							"websiteId": bannerinfoobj.WebsiteId,
							"filters": [],
							"sort": {},
							"isLoggedIn": mPinLoginService.isLoggedIn
						}
						searchListServices.getSelectedCategoryProduct(obj).then(function (data) {
							filterService.filterOldData = searchListServices.filterData;
							searchListServices.allProductsList = data;
							filterService.selectedLevelOneData = '';
							filterService.selectedLevelTwoData = "";
							filterService.selectedLevelThreeData = "";
							searchListServices.products.length = 0
							filterService.addedFilterFullData.length = 0
							filterService.addedFilterData.length = 0
							filterService.selectedColour.length = 0
							searchListServices.isCompareAvailable = true;
							searchListServices.serviceFrom = 'getSelectedCategoryProduct';
							searchListServices.serviceFromObj = obj;
							filterService.isFilterApplied = false;
							searchListServices.isSortApplied = false;
							searchListServices.filterNewData = {
								categoryList: [],
								subCategoryList: [],
								colorList: [],
								priceList: [],
								callFunctionsList: []
							};
							$state.go('menu.searchList');
						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});


					}

					else if (bannerinfoobj.listType.toLowerCase() == "whatsnew") {

						var newList = {
							"type": "whatsnew",
							"websiteId": bannerinfoobj.WebsiteId,
							"filters": [],
							"sort": {},
							"isLoggedIn": mPinLoginService.isLoggedIn
						}
						searchListServices.getDealList(newList).then(function (data) {
							filterService.filterOldData = searchListServices.filterData;
							searchListServices.allProductsList = data;
							filterService.selectedLevelOneData = '';
							filterService.selectedLevelTwoData = "";
							filterService.selectedLevelThreeData = "";
							searchListServices.products.length = 0
							filterService.addedFilterFullData.length = 0
							filterService.addedFilterData.length = 0
							filterService.selectedColour.length = 0
							searchListServices.isCompareAvailable = false;
							searchListServices.serviceFrom = 'whatsnew';
							searchListServices.searchFor = "Whats New";
							searchListServices.serviceFromObj = newList;
							filterService.isFilterApplied = false;
							searchListServices.isSortApplied = false;
							searchListServices.filterNewData = {
								categoryList: [],
								subCategoryList: [],
								colorList: [],
								priceList: [],
								callFunctionsList: []
							};
							$state.go('menu.searchList');
						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});


					}

					else if (bannerinfoobj.listType.toLowerCase() == "trending") {
						var trendList = {
							"type": "trending",
							"websiteId": bannerinfoobj.WebsiteId,
							"filters": [],
							"sort": {},
							"isLoggedIn": mPinLoginService.isLoggedIn
						}
						searchListServices.getDealList(trendList).then(function (data) {
							filterService.filterOldData = searchListServices.filterData;
							searchListServices.allProductsList = data;
							filterService.selectedLevelOneData = '';
							filterService.selectedLevelTwoData = "";
							filterService.selectedLevelThreeData = "";
							searchListServices.products.length = 0
							filterService.addedFilterFullData.length = 0
							filterService.addedFilterData.length = 0
							filterService.selectedColour.length = 0
							searchListServices.isCompareAvailable = false;
							searchListServices.serviceFrom = 'trending';
							searchListServices.searchFor = "Trending";
							searchListServices.serviceFromObj = trendList;
							filterService.isFilterApplied = false;
							searchListServices.isSortApplied = false;
							searchListServices.filterNewData = {
								categoryList: [],
								subCategoryList: [],
								colorList: [],
								priceList: [],
								callFunctionsList: []
							};
							$state.go('menu.searchList');
						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
						});



					}





                } else if (bannerinfoobj.pageId.toLowerCase() == "menu.personalloan") {
                    personalLoanService.clearAll();
                    personalLoanService.getLoanDetails().then(function (data) {

                        personalLoanService.personalLoanData = data;
                        personalLoanService.minDuration = data.minTenure;
                        personalLoanService.maxDuration = data.maxTenure;
                        personalLoanService.interestRate = data.interestRate;
                        personalLoanService.product = data.productCode;
                        personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
                        personalLoanService.processingFee = data.processingFee;
                        personalLoanService.minBestOffer = data.minPalAmount;
                        personalLoanService.activityCode = data.activityCode;
                        personalLoanService.schemeCode = data.schemeCode;


                        $state.go('menu.personalLoan');

                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });

				}
				else if (bannerinfoobj.pageId == "menu.declaimer") {
					generalInsurenceHomeService.setGIProductsID(bannerinfoobj.productId)
					$state.go(bannerinfoobj.pageId);

				}



				else {
					$state.go(bannerinfoobj.pageId);
				}




			}
		}
		$scope.$on('$ionicView.beforeLeave', function () {
			ompMerchantsService.endTimer();
		});
		$scope.$on('$ionicView.beforeEnter', function () {
			bookingsVm.showAll = false;
			bookingsVm.images = [];
			var bannerobj = {
				"type": "bookandorder",
				"sessionId": "",
				"isLoggedIn": mPinLoginService.isLoggedIn,
				"affiliateId": "",
			};
			ompMerchantsService.getBannerInformation(bannerobj).then(function (data) {

				bookingsVm.images = data.data.bannerInformations;

				$ionicSlideBoxDelegate.update();
				$ionicSlideBoxDelegate.loop(true);
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			$interval(function () {
				if ($ionicSlideBoxDelegate.currentIndex() == bookingsVm.images.length - 1)
					$ionicSlideBoxDelegate.$getByHandle('landingPageSlide').slide(0);
				else
					$ionicSlideBoxDelegate.$getByHandle('landingPageSlide').start();
			}, 8000);
			var obj = {
				"type": "book",
				"isLoggedIn": mPinLoginService.isLoggedIn
			};
			ompMerchantsService.getStores(obj).then(function (data) {
				bookingsVm.isMerchAvailable = true;
				bookingsVm.stores = data.merchants;
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
			bookingsVm.dataForPAPLFlag = false;

			bookingsVm.dataForPAPL = homeScreenService.offersData;
			console.log('hscreenData 2 :' + JSON.stringify(bookingsVm.dataForPAPL));
			angular.forEach(bookingsVm.dataForPAPL, function (value, key) {
				if (value.category == "PAPL") {
					bookingsVm.dataForPAPLFlag = true;
					bookingsVm.textForPAPL = value.palAmount;
				}
			});
		});

		$scope.footerExpand = function () {
			console.log('Footer expanded');
			bookingsVm.showAll = true;
		};

		$scope.isEnergized = true;

		$scope.toggleEnergized = function () {
			$scope.isEnergized = !$scope.isEnergized;
		}

		$scope.footerCollapse = function () {
			console.log('Footer collapsed');
			bookingsVm.showAll = false;
            };
        bookingsVm.goToPrevious = function() {
          $state.go('menu.homeScreen');
        }

        bookingsVm.loadPAPL = function () {
            personalLoanService.clearAll();
            personalLoanService.getLoanDetails().then(function (data) {

                personalLoanService.personalLoanData = data;
                personalLoanService.minDuration = data.minTenure;
                personalLoanService.maxDuration = data.maxTenure;
                personalLoanService.interestRate = data.interestRate;
                personalLoanService.product = data.productCode;
                personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
                personalLoanService.processingFee = data.processingFee;
                personalLoanService.minBestOffer = data.minPalAmount;
                personalLoanService.activityCode = data.activityCode;
                personalLoanService.schemeCode = data.schemeCode;


                $state.go('menu.personalLoan');

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.$on('$ionicView.afterEnter', function () {
            ompMerchantsService.startTimer();
        });
        return this;
    }
]);

