

'use strict';

angularApp.controller('cardLinkAccountController', ["$state",
    "$scope",
    "applyNowService",
    "payNowServices",
    "$ionicHistory",
    "cardConfig",
    "cardsService", "utilityService","clickStreamService",



    function($state,
        $scope,
        applyNowService,
        payNowServices,
        $ionicHistory,
        cardConfig,
        cardsService, utilityService,clickStreamService) {
        var linkAccountVm = this;
        //load all accounts on page loads
        function initPage() {
            linkAccountVm.getUserAccounts();
        }
        
        linkAccountVm.getUserAccounts = function() {
                linkAccountVm.userAccounts = cardsService.getParams().userAccounts;
                linkAccountVm.account = linkAccountVm.userAccounts[0].benAccntNo;
                if (linkAccountVm.userAccounts.length <= 0) {
                    var erroObj = {
                        cssClass: 'sbi-alert-popup',
                        template: '<div class="text-align-center font-content roboto-regular"> Sorry! There is no account found, please contact SBI Customer Care</div>',
                        buttons: [{
                            text: cardConfig.buttons.OK_LABEL,
                            type: 'button-positive'
                        }]
                    };
                    cardsService.alertModal(erroObj, null);
                }
            }
           
        linkAccountVm.agree = function(val) {
          clickStreamService.clickStreamData = cardsService.getParams().cardName;
            applyNowService.setParams({ agree: val, accountNumber: linkAccountVm.accountNumber });
               applyNowService.setParams({"accountNum": linkAccountVm.account });
            applyNowService.setEapplyForm({
                "bankAccountNo": linkAccountVm.account
            }).then(function(response) {
                if (response.responseCode == cardConfig.responseCode.success) {
                    //$ionicHistory.clearHistory();
                    //$ionicHistory.clearCache().then(function() {
                        applyNowService.getPersonalDetails().then(function(response) {
                            cardsService.errorLogger(response);
                            if (response.responseCode == cardConfig.responseCode.success) {
                                if (response.data && response.data.qualifications.length > 0 && response.data.occupations.length > 0 && response.data.annualIncomes.length > 0 && response.data.salutations.length > 0 && response.data.genders.length > 0) {
                                    cardsService.setParams({ "masterData": response.data });
                                    $state.go('menu.cardPersonalDetails1');
                                }

                            }
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });

                    //});
                } else {}
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });



        }

        linkAccountVm.goBack=function()
        {
           $state.go('menu.cardCitySelection');
    
        }

	        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });
    }
]);
