

 'use strict';

 angularApp.controller('cardPersonalDetails1Controller', ["$filter", "$state", "$scope", "validateService", "applyNowService", "cardsService", "cardConfig", "utilityService", "floatingMenuService","clickStreamService","$ionicHistory","payNowServices","$ionicPopup","fTBeneficiaryService","homeScreenService","getAccountDetailsService",
     function($filter, $state, $scope, validateService, applyNowService, cardsService, cardConfig, utilityService, floatingMenuService,clickStreamService,$ionicHistory,payNowServices,$ionicPopup,fTBeneficiaryService,homeScreenService,getAccountDetailsService) {
         //functions, variables that can be accessed from the HTML come here
         var step1Vm = this;
         var pendingApplication;
         var resetOccupationFeild;

         // Entry point

         function initPage() {
            // $state.go('menu.cardRequestApprove');
             //$state.go('menu.cardPersonalDetails2');
             step1Vm.prevTwoPageDetails();
             step1Vm.prevData = true;
             step1Vm.step1Form = {};
             step1Vm.personalDetails = {};
             step1Vm.personalDetails.name = {};
             step1Vm.personalDetails.address={};
             step1Vm.validateService = validateService;
             
             floatingMenuService.isResendExhaust = false;
             floatingMenuService.isTextExhaust = false;

             var currentDate = Date();
             step1Vm.minDate = cardsService.getFutureYear(currentDate, -110);
             step1Vm.maxDate = cardsService.getFutureYear(currentDate, -18);
             
             step1Vm.isMaskedMob = true;
             step1Vm.isMaskedDOB = true;
             step1Vm.isMaskedPAN = true;
             step1Vm.isMaskedCkyc = true;
             
             step1Vm.inputImgMob = "img/Visibility_off.svg";
             step1Vm.inputImgDOB = "img/Visibility_off.svg";
             step1Vm.inputImgPAN = "img/Visibility_off.svg";
             step1Vm.inputImgCkyc = "img/Visibility_off.svg";

             
             if (!applyNowService.getParams().applyCardMobileVerify) {
                 step1Vm.sendOTP = true;
                 step1Vm.next = false;


             } else {
                 step1Vm.next = true;
                 step1Vm.sendOTP = false;
                 var oldMobileNumber = applyNowService.getParams().personalDetails1.mobileNumber;
                 //applyNowService.setParams("oldMobileNumber" : oldMobileNumber);
                 applyNowService.setParams({ "oldMobileNumber": oldMobileNumber });

             }

             



         }


         step1Vm.prevTwoPageDetails  = function() {
             payNowServices.getUserAccounts({}).then(function (response) {
                 cardsService.errorLogger(response);
                 if (response.responseCode == cardConfig.responseCode.success) {

                     if (response.data.beneficiaryList && response.data.beneficiaryList.ownAccounts) {
                         cardsService.setParams({ "userAccounts": response.data.beneficiaryList.ownAccounts });
                         //$state.go('menu.cardLinkAccount');
                         //step1Vm.getUserAccounts();
                         step1Vm.getAccountsAccessRights();
                     }
                 }
             }, function (error) {
                 utilityService.showErrorMessage(error.responseMessage);
             });
         }
         step1Vm.getUserAccounts = function () {
                 step1Vm.userAccounts = cardsService.getParams().userAccounts;
                 step1Vm.userAccountsAccesRights = cardsService.getParams().getAccountsAccessRights;
                 step1Vm.account = step1Vm.userAccounts[0].benAccntNo;
                 if (step1Vm.userAccounts.length <= 0) {
                     var erroObj = {
                         cssClass: 'sbi-alert-popup',
                         template: '<div class="text-align-center font-content roboto-regular"> Sorry! There is no account found, please contact SBI Customer Care</div>',
                         buttons: [{
                             text: cardConfig.buttons.OK_LABEL,
                             type: 'button-positive'
                         }]
                     };
                     cardsService.alertModal(erroObj, null);
                 } else {
                     if(getAccountDetailsService.accountOverviewData.customerInformation.accountNumber){
                         step1Vm.account = getAccountDetailsService.accountOverviewData.customerInformation.accountNumber
                     }
                     var Acntobj = $filter('filter')(step1Vm.userAccounts, { benAccntNo: step1Vm.account });
                     var acntAccessInfo = $filter('filter')(step1Vm.userAccountsAccesRights, { accountNumber: step1Vm.account });
                     if((Acntobj[0].benAccntType != "Savings") && (acntAccessInfo[0].modOfOperation != "SINGLE" && acntAccessInfo[0].modOfOperation != "EITHER OR SURVIVOR" && acntAccessInfo[0].modOfOperation != "FORMER OR SURVIVOR" && acntAccessInfo[0].modOfOperation != "ANYONE OR SURVIVOR")){
                        step1Vm.showAcntPopup();
                        return false;
                     }
                     else{
                        step1Vm.agree(true);
                     }
                 }
             }

            step1Vm.getAccountsAccessRights = function () {
                payNowServices.getAccountsAccessRights({}).then(function (response) {
                    cardsService.errorLogger(response);
                    if (response.responseCode == cardConfig.responseCode.success) {
                        if (response.data && response.data.accounts) {
                            //cardsService.setParams({ "userAccounts": response.data.beneficiaryList.ownAccounts });
                            //$state.go('menu.cardLinkAccount');
                            cardsService.setParams({ "getAccountsAccessRights": response.data.accounts});
                            step1Vm.getUserAccounts();
                        }
                    }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            };

             step1Vm.agree = function (val) {
                 val = true;
                 clickStreamService.clickStreamData = cardsService.getParams().cardName;
                 applyNowService.setParams({ agree: val, accountNumber: step1Vm.accountNumber });
                 applyNowService.setParams({ "accountNum": step1Vm.account });
                 applyNowService.setEapplyForm({
                     "bankAccountNo": step1Vm.account
                 }).then(function (responsedata) {
                     if (responsedata.responseCode == cardConfig.responseCode.success) {

                         applyNowService.getPersonalDetails().then(function (response) {
                             cardsService.errorLogger(response);
                             if (response.responseCode == cardConfig.responseCode.success) {
                                 if (response.data && response.data.qualifications.length > 0 && response.data.occupations.length > 0 && response.data.annualIncomes.length > 0 && response.data.salutations.length > 0 && response.data.genders.length > 0) {
                                     cardsService.setParams({ "masterData": response.data });
                                       getMasterData();     
                                 }

                             }
                         }, function (error) {
                             utilityService.showErrorMessage(error.responseMessage);
                         });


                     } 
                 }, function (error) {
                     utilityService.showErrorMessage(error.responseMessage);
                 });



             }

             
             
      
        






         //get master data
         function getMasterData() {
             var masterData = cardsService.getParams().masterData;
             step1Vm.qualifications = masterData.qualifications;
             step1Vm.occupations = masterData.occupations;
             applyNowService.creditCardOccupationlist = masterData.occupations;
             step1Vm.annualIncomes = masterData.annualIncomes;
             step1Vm.salutation = masterData.salutations;
             step1Vm.genders = masterData.genders;

             step1Vm.getAccountDetails();
         }

         function setSalutation(genderCode) {
             if (genderCode == "M") {
                 step1Vm.personalDetails.salutation = step1Vm.salutation[0].key;
             } else if (genderCode == "F") {
                 step1Vm.personalDetails.salutation = step1Vm.salutation[1].key;
             }
             step1Vm.setSalutation();
         }


step1Vm.goBack=function()
{
    if(applyNowService.currentState=="Retrieve")
    {
         $state.go('menu.retrieveTrackApplication');

    }else{
        $ionicHistory.goBack(-1);      
    }
   

}

         step1Vm.showNRIPopup = function () {
             var showNRIPopup = $ionicPopup.confirm({
                 template: '<p><div class=""><img class="rrpopupStyleM5" src="img/yc_Group.svg"</div> <div class ="rrwidth90" translate="GI_NEW_CRD_POP_MSG_NRI" ></div>   </p>',
                 cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogRR',
                 scope: $scope,
                 buttons: [
                 {
                     text: 'OK',
                     type: 'button-positive',
                     onTap: function (e) {
                         showNRIPopup.close();
                        
                        homeScreenService.ishamburgerMenuRO=false;
                        fTBeneficiaryService.isCreditCardFlag=true;
                        getAccountDetailsService.setRewTab = true;
                        getAccountDetailsService.tabIndex.tabIndex=5;
                        $state.go('menu.accountOverviewMyBalance');
                         e.preventDefault();
                     }
                 }]
             });
         }

         step1Vm.showPANPopup = function () {
             var showPANPopup = $ionicPopup.confirm({
                 template: '<p><div class=""><img class="rrpopupStyleM5" src="img/yc_Group.svg"</div> <div class ="rrwidth90" translate="GI_NEW_CRD_POP_MSG_PAN" ></div>   </p>',
                 cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogRR',
                 scope: $scope,
                 buttons: [
                 {
                     text: 'OK',
                     type: 'button-positive',
                     onTap: function (e) {
                         showPANPopup.close();
                        
                        homeScreenService.ishamburgerMenuRO=false;
                        fTBeneficiaryService.isCreditCardFlag=true;
                        getAccountDetailsService.setRewTab = true;
                        getAccountDetailsService.tabIndex.tabIndex=5;
                        $state.go('menu.accountOverviewMyBalance');
                         e.preventDefault();
                     }
                 }]
             });
         }

          step1Vm.showAcntPopup = function () {
             var showPANPopup = $ionicPopup.confirm({
                 template: '<p><div class=""><img class="rrpopupStyleM5" src="img/yc_Group.svg"</div> <div class ="rrwidth90" translate="GI_NEW_CRD_POP_MSG_ACNT" ></div>   </p>',
                 cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogRR',
                 scope: $scope,
                 buttons: [
                 {
                     text: 'OK',
                     type: 'button-positive',
                     onTap: function (e) {
                         showPANPopup.close();
                        
                        homeScreenService.ishamburgerMenuRO=false;
                        fTBeneficiaryService.isCreditCardFlag=true;
                        getAccountDetailsService.setRewTab = true;
                        getAccountDetailsService.tabIndex.tabIndex=5;
                        $state.go('menu.accountOverviewMyBalance');
                         e.preventDefault();
                     }
                 }]
             });
         }

         // Get account details info from service
         step1Vm.getAccountDetails = function() {
             pendingApplication = cardsService.getParams().pendingApplication;
             if (pendingApplication) {
                 /*saved application details fetching to complete application*/
                 var trackPersonalDetails = cardsService.getApplicationDetail();
                 if (trackPersonalDetails) {

                     step1Vm.personalDetails.salutation = trackPersonalDetails.applicantDetails.personalDetails.salutation;
                     step1Vm.setSalutation();
                     step1Vm.personalDetails.name.first = trackPersonalDetails.applicantDetails.personalDetails.name.first;
                     step1Vm.personalDetails.address = trackPersonalDetails.applicantDetails.personalDetails.address || {};
                     step1Vm.personalDetails.landLineNumber = trackPersonalDetails.applicantDetails.personalDetails.landLineNumber || {};
                     step1Vm.personalDetails.address.city= cardsService.getParams().citySelected;
                     step1Vm.personalDetails.name.last = trackPersonalDetails.applicantDetails.personalDetails.name.last;
                     step1Vm.personalDetails.name.middle = trackPersonalDetails.applicantDetails.personalDetails.name.middle;
                     step1Vm.personalDetails.dob = trackPersonalDetails.applicantDetails.personalDetails.dob;
                     step1Vm.personalDetails.gender = trackPersonalDetails.applicantDetails.personalDetails.gender;
                     step1Vm.personalDetails.qualification = trackPersonalDetails.applicantDetails.personalDetails.qualification;
                     step1Vm.personalDetails.occupation = trackPersonalDetails.applicantDetails.personalDetails.occupation;
                     step1Vm.personalDetails.grossIncome = trackPersonalDetails.applicantDetails.personalDetails.grossIncome;
                     step1Vm.personalDetails.panCardNumber = trackPersonalDetails.applicantDetails.personalDetails.panCardNumber;
                     step1Vm.personalDetails.email = trackPersonalDetails.applicantDetails.personalDetails.email;
                     step1Vm.personalDetails.mobileNumber = trackPersonalDetails.applicantDetails.personalDetails.mobileNumber;
                     step1Vm.personalDetails.mothersName = trackPersonalDetails.applicantDetails.personalDetails.motherName;
                     step1Vm.personalDetails.mothersName = trackPersonalDetails.applicantDetails.personalDetails.motherName;
                     step1Vm.personalDetails.ckycDetails = trackPersonalDetails.applicantDetails.personalDetails.ckyc
                     step1Vm.personalDetails.cbsCkycDetails = step1Vm.personalDetails.ckycDetails ? true: false;
                     if (trackPersonalDetails.applicantDetails.personalDetails.address.address.length > 3) {
                         step1Vm.sendOTP = false;
                     }

                 }

             }

             var personalDetails = applyNowService.getParams().personalDetails1;
             step1Vm.hasAgreed = applyNowService.getParams().agree;
             if (personalDetails == undefined) {


                 /*populate from core bank data*/

                 applyNowService.getEapplyForm(function(response) {
                     
                         setSalutation(response.genderCode);
                         response.firstName = response.firstName.substring(0, 12);
                         response.lastName = response.lastName.substring(0, 16);
                         response.middleName = response.middleName.substring(0, 10);
                         step1Vm.personalDetails.name.first = response.firstName;
                         step1Vm.personalDetails.name.last = response.lastName;
                         step1Vm.personalDetails.name.middle = response.middleName;
                         step1Vm.personalDetails.dob = $filter('formatCbsDate')(response.dateOfBirth);
                         step1Vm.personalDetails.gender = response.genderCode;
                         step1Vm.personalDetails.qualification = response.qualification;  
                         step1Vm.personalDetails.cityCode = response.city; 
                         step1Vm.cityList = cardsService.getParams().city
                         step1Vm.personalDetails.residentialStatus = response.residentialStatus;
                         
                        
                         if(step1Vm.personalDetails.cityCode){

                             angular.forEach(step1Vm.cityList, function (value, key) {
                                        if (value.key == step1Vm.personalDetails.cityCode) {
                                            cardsService.setParams({ "citySelected": value.value });
                                        }
                                    });

                         }
                          if(step1Vm.personalDetails.gender.toLowerCase() == 'f'){
                                step1Vm.personalDetails.displayGender = 'Female';
                            }else{
                                step1Vm.personalDetails.displayGender = 'Male';
                            }
                        

                           
                         //                       
                         // if(response.occupancy!="string"){
                         //     step1Vm.personalDetails.occupation = response.occupancy;
                         // }
                         step1Vm.personalDetails.grossIncome = response.grossIncome;
                         step1Vm.personalDetails.panCardNumber = response.panNumber;
                         step1Vm.personalDetails.email = response.email1;
                         step1Vm.personalDetails.mobileNumber = response.mobileNumber;
                         step1Vm.personalDetails.mothersName = response.motherName;
                         step1Vm.personalDetails.ckycDetails = response.ckyc
                         step1Vm.personalDetails.cbsCkycDetails = step1Vm.personalDetails.ckycDetails ? true: false;
                          step1Vm.personalDetails.address.pinCode = response.pinCode;
                         //step1Vm.personalDetails.landLineNumber = response.landLineNumber;
                         if(step1Vm.personalDetails.panCardNumber){
                            step1Vm.panMaskCheck(step1Vm.personalDetails.panCardNumber)
                         }else{
                            step1Vm.showPANPopup();
                            return false;
                         }
                         if(step1Vm.personalDetails.dob){
                            step1Vm.dobMaskCheck()
                         }
						step1Vm.checkMinor();

                 });


             } else if (personalDetails) {

                 step1Vm.personalDetails = personalDetails;
                  if(step1Vm.personalDetails.panCardNumber){
                            step1Vm.panMaskCheck(step1Vm.personalDetails.panCardNumber)
                    }else{
                            step1Vm.showPANPopup();
                             return false;
                         }
                  if(step1Vm.personalDetails.dob){
                            step1Vm.dobMaskCheck();
                         }  
				step1Vm.checkMinor();
             }
             if(step1Vm.personalDetails.residentialStatus != '1'){
                        step1Vm.showNRIPopup();
                        return false;
             }
             
            
             
         }

         // Next button click
         step1Vm.goNext = function() {
             if (validateForm()) {
                 
                 clickStreamService.clickStreamData = cardsService.getParams().cardName;
                 applyNowService.setParams({ pageNo: "1" });
                 applyNowService.setPersonalData1(step1Vm.personalDetails);
                 applyNowService.setParams({ personalDetails1: step1Vm.personalDetails });


                 //applyNowService.setParams({ occupation: step1Vm.personalDetails.occupation });

                if(Object.getOwnPropertyNames(step1Vm.personalDetails.address).length==0)
                {
                    applyNowService.setCity();

                }

                // applyNowService.saveApplication().then(function(response) {
                //     cardsService.errorLogger(response);

                //     }, function(error) {
                //         utilityService.showErrorMessage(error.responseMessage);
                //     });
                
                $state.go('menu.cardPersonalDetails2');
                //  if (step1Vm.personalDetails.occupation == 'H' || step1Vm.personalDetails.occupation == 'T') {
                //      var alertObj = {
                //          template: '<div class="text-align-center font-content roboto-regular" translate="HOUSEWIFE_MSG1"></div><div class="text-align-center font-content roboto-regular" translate="HOUSEWIFE_MSG2"></div>',
                //          cssClass: 'sbi-alert-popup',
                //          buttons: [{
                //              text: cardConfig.buttons.OK_LABEL,
                //              type: 'button-positive',
                //              onTap: function(e) {
                //                  $state.go('menu.accountOverviewMyBalance');
                //              }
                //          }]
                //      }
                //      cardsService.alertModal(alertObj, function(res) {

                //      });

                //      applyNowService.applyCard(function(response) {
                //          cardsService.errorLogger(response);
                //          switch (response.responseJSON.responseCode) {
                //              case cardConfig.responseCode.success:
                //                  //$state.go('menu.cardRequestApprove');
                //                  //$state.go('menu.accountOverviewMyBalance');
                //                  break;
                //              case cardConfig.responseCode.failed:
                //                  break;
                //              default:
                //                  break;
                //          }
                //      });
                //  } else {
                //      if (step1Vm.sendOTP) {
                //          applyNowService.setParams({ eapplySentOTP: true });
                //          applyNowService.setParams({ eapplyMobileNumber: step1Vm.personalDetails.mobileNumber });
                //          applyNowService.sendEapplyOTP({
                //              "mobileNumber": step1Vm.personalDetails.mobileNumber,
                //              "isResend": "false"
                //          }).then(function(response) {
                //                  cardsService.errorLogger(response);
                //                  if (response.data.responseCode == cardConfig.responseCode.dataSuccess) {
                //                      applyNowService.getDisclaimer17().then(function(response) {
                //                          cardsService.errorLogger(response);
                //                          if (response.data && response.data.message) {
                //                              cardsService.setParams({ "getDisclaimer17": response.data.message });
                //                              $state.go('menu.resendOTPPin');
                //                          }
                //                      }, function(error) {
                //                          utilityService.showErrorMessage(error.responseMessage);
                //                      });


                //                  }
                //              },
                //              function(error) {
                //                  utilityService.showErrorMessage(error.responseMessage);
                //              });

                //      } else {
                //          applyNowService.getDisclaimer17().then(function(response) {
                //              cardsService.errorLogger(response);
                //              if (response.data && response.data.message) {
                //                  cardsService.setParams({ "getDisclaimer17": response.data.message });
                //                  $state.go('menu.cardPersonalDetails2');
                //              }
                //          }, function(error) {
                //              utilityService.showErrorMessage(error.responseMessage);
                //          });

                //      }
                //  }
             }
         };

         // function to close the application form and take user to the account overview page
         step1Vm.closeJourney = function() {

             applyNowService.setPersonalData1(step1Vm.personalDetails);
             applyNowService.setParams({ personalDetails1: step1Vm.personalDetails });
             //applyNowService.setParams({ occupation: step1Vm.personalDetails.occupation });
             applyNowService.setParams({ pageNo: "1" });
           
          if(Object.getOwnPropertyNames(step1Vm.personalDetails.address).length==0)
             {
                applyNowService.setCity();

             }
             


             var journeyConfirmation = {
                 cssClass: 'sbi-alert-popup',
                 buttons: [{
                     text: cardConfig.buttons.OK_LABEL,
                     type: 'button-positive',
                     onTap: function(e) {
                         cardsService.setParams({ 'pendingApplication': false });
                         $state.go('menu.accountOverviewMyBalance');
                     }
                 }]
             };
             var alertObj = {
                 template: '<div class="text-align-center font-content roboto-regular" translate="JOURNEY_CLOSE"></div>',
                 cssClass: 'sbi-alert-popup',
                 buttons: [{
                     text: cardConfig.buttons.CANCEL_LABEL,
                     type: 'button-positive'
                 }, {
                     text: cardConfig.buttons.YES_LABEL,
                     type: 'button-positive',
                     onTap: function(e) {
                         journeyConfirmation.template = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><div class="text-align-center font-content sbi-sub-label roboto-regular" translate="JOURNEY_CLOSE_CONFIRM"></div>';
                         applyNowService.saveApplication().then(function(response) {
                             cardsService.errorLogger(response);
                             if (response.responseCode == cardConfig.responseCode.success) {
                                 cardsService.alertModal(journeyConfirmation, null);
                             }
                         }, function(error) {
                             utilityService.showErrorMessage(error.responseMessage);
                         });
                     }
                 }]
             };
             cardsService.alertModal(alertObj, function(res) {

             });

         };

         // validate function on form submit

         function validateForm() {
             step1Vm.step1Form = {};
            //  if (step1Vm.validateService.isValidQualification(step1Vm.personalDetails.qualification)) {
            //      step1Vm.step1Form.qualification = step1Vm.validateService.isValidQualification(step1Vm.personalDetails.qualification);
            //  }
            //  if (step1Vm.validateService.isValidOccupation(step1Vm.personalDetails.occupation)) {
            //      step1Vm.step1Form.occupation = step1Vm.validateService.isValidOccupation(step1Vm.personalDetails.occupation);
            //      if (step1Vm.personalDetails.occupation == 'H' || step1Vm.personalDetails.occupation == 'T') {

            //          var alertObj = {
            //              template: '<div class="text-align-center font-content roboto-regular" translate="HOUSEWIFE_MSG1"></div><div class="text-align-center font-content roboto-regular" translate="HOUSEWIFE_MSG2"></div>',
            //              cssClass: 'sbi-alert-popup',
            //              buttons: [{
            //                  text: cardConfig.buttons.OK_LABEL,
            //                  type: 'button-positive',
            //                  onTap: function(e) {


            //                      cardsService.alertModal(alertObj, function(res) {

            //                      });
            //                  }
            //              }]
            //          }
            //      }
            //  }

            //  if (step1Vm.validateService.isValidGrossIncome(step1Vm.personalDetails.grossIncome)) {
            //     step1Vm.step1Form.grossIncome = step1Vm.validateService.isValidGrossIncome(step1Vm.personalDetails.grossIncome);
            //  }

            if(step1Vm.personalDetails.panCardNumber){
                if (step1Vm.validateService.isValidPANNo(step1Vm.personalDetails.panCardNumber)) {
                    step1Vm.step1Form.panCardNumber = step1Vm.validateService.isValidPANNo(step1Vm.personalDetails.panCardNumber);
                }
            }
             

            //  if (step1Vm.validateService.isValidEmail(step1Vm.personalDetails.email)) {
            //      step1Vm.step1Form.email = step1Vm.validateService.isValidEmail(step1Vm.personalDetails.email);
            //  }

            

            if (step1Vm.validateService.isValidMotherName(step1Vm.personalDetails.mothersName)) {
                 step1Vm.step1Form.mothersName = step1Vm.validateService.isValidMotherName(step1Vm.personalDetails.mothersName);
             }
             if(step1Vm.personalDetails.ckycDetails){
                if (step1Vm.validateService.isValidCKYCNumber(step1Vm.personalDetails.ckycDetails)) {
                 step1Vm.step1Form.Ckyc = step1Vm.validateService.isValidCKYCNumber(step1Vm.personalDetails.ckycDetails);
                }
             }
             

             if (step1Vm.validateService.isValidMobileNo(step1Vm.personalDetails.mobileNumber)) {
                 step1Vm.step1Form.mobileNumber = step1Vm.validateService.isValidMobileNo(step1Vm.personalDetails.mobileNumber);
             }

             return (angular.equals({}, step1Vm.step1Form)) ? true : false;
         }

         step1Vm.validateMobileNumber = function() {
             applyNowService.setParams({ "applyCardMobileVerify": false });
             step1Vm.step1Form.mobileNumber = step1Vm.validateService.isValidMobileNo(step1Vm.personalDetails.mobileNumber);
             if (!step1Vm.step1Form.mobileNumber) {
                 step1Vm.sendOTP = true;
             }
         };

         step1Vm.checkMobileNumber = function(newMobileNumber) {
             if (newMobileNumber.length == 10) {
                 var oldMobileNumber = applyNowService.getParams().oldMobileNumber;

                 if (newMobileNumber != oldMobileNumber) {
                     step1Vm.sendOTP = true;
                     step1Vm.next = false;
                 } else {
                     step1Vm.next = true;
                     step1Vm.sendOTP = false;
                 }

             }


         }

         step1Vm.setSalutation = function() {
             if (step1Vm.personalDetails.salutation == "Mr" || step1Vm.personalDetails.salutation == "MR" || step1Vm.personalDetails.salutation == "1") {
                 step1Vm.personalDetails.gender = "M";
                 //to remove Housewife from Occupation
                 for (var index = 0; index < step1Vm.occupations.length; index++) {
                     if (step1Vm.occupations[index].key == "H" || step1Vm.occupations[index].key == "h") {
                         resetOccupationFeild = step1Vm.occupations[index];
                        // step1Vm.occupations.splice(index, 1);
                     }
                 }
             } else if (step1Vm.personalDetails.salutation == "Ms" || step1Vm.personalDetails.salutation == "MS" || step1Vm.personalDetails.salutation == "2" || step1Vm.personalDetails.salutation == "Mrs" || step1Vm.personalDetails.salutation == "MRS") {
                 step1Vm.personalDetails.gender = "F";
                 if (step1Vm.occupations.length == 4) {
                     step1Vm.occupations.push(resetOccupationFeild);

                 }

             }
         };
         step1Vm.setGender = function() {
             if (step1Vm.personalDetails.gender == step1Vm.genders[0]) {
                 for (var index = 0; index < step1Vm.occupations.length; index++) {
                     if (step1Vm.occupations[index].key == "H" || step1Vm.occupations[index].key == "h") {
                         resetOccupationFeild = step1Vm.occupations[index];
                        // step1Vm.occupations.splice(index, 1);
                     }
                 }

             } else if (step1Vm.personalDetails.gender == step1Vm.genders[1]) {
                 if (step1Vm.occupations.length == 4) {
                     step1Vm.occupations.push(resetOccupationFeild);

                 }
             }
         };
        step1Vm.panMaskCheck = function (pan) {
            step1Vm.panMask = "X".repeat(pan.length - 5) + pan[5] + pan[6] + pan[7] + pan[8] + "X";
        }

         step1Vm.dobMaskCheck = function () {
            
                if(step1Vm.personalDetails.dob){
                var str = step1Vm.personalDetails.dob.split(' ');
                var year = str[2];
                var Mask = year.replace(year,'XXXX');
                step1Vm.MSKdob = str[0] + ' ' + str[1] + ' '+ Mask;
                }   
             
        }
       

         step1Vm.maskUnmaskMob = function () {
             if(step1Vm.isMaskedMob == true){
                step1Vm.isMaskedMob = false;
                step1Vm.inputImgMob = "img/Visibility_on.svg";
             }
             else{
                 step1Vm.isMaskedMob = true;
                step1Vm.inputImgMob = "img/Visibility_off.svg";
             }
         };
         step1Vm.maskUnmaskDOB = function () {
             if(step1Vm.isMaskedDOB == true){
                step1Vm.isMaskedDOB = false;
                step1Vm.inputImgDOB = "img/Visibility_on.svg";
             }
             else{
                step1Vm.isMaskedDOB = true;
                step1Vm.inputImgDOB = "img/Visibility_off.svg";
             }
             if (step1Vm.isMaskedDOB == true) {
                 step1Vm.dobMaskCheck();
             } else {
                 step1Vm.MSKdob = step1Vm.personalDetails.dob;
             }

         };
         step1Vm.maskUnmaskPAN = function () {
             if(step1Vm.isMaskedPAN == true){
                step1Vm.isMaskedPAN = false;
                step1Vm.inputImgPAN = "img/Visibility_on.svg";
             }
             else{
                step1Vm.isMaskedPAN = true;
                step1Vm.inputImgPAN = "img/Visibility_off.svg";
             }
             if (step1Vm.isMaskedPAN == true) {
                 step1Vm.panMaskCheck(step1Vm.personalDetails.panCardNumber)
             } else {
                 step1Vm.panMask = step1Vm.personalDetails.panCardNumber;
             }
         };
         step1Vm.maskUnmaskCkyc = function () {
             if(step1Vm.isMaskedCkyc == true){
                step1Vm.isMaskedCkyc = false;
                step1Vm.inputImgCkyc = "img/Visibility_on.svg";
             }
             else{
                step1Vm.isMaskedCkyc = true;
                step1Vm.inputImgCkyc = "img/Visibility_off.svg";
             }
         };


        step1Vm.checkMinor = function () {
                    if (step1Vm.personalDetails.dob) {
                        step1Vm.noOfYearDiffernce = (new Date().getFullYear() - new Date(step1Vm.personalDetails.dob).getFullYear()) * 12;
                        step1Vm.noOfYearDiffernce -= new Date(step1Vm.personalDetails.dob).getMonth() + 1;
                        step1Vm.noOfYearDiffernce += (new Date().getMonth() + 1);
                        step1Vm.noOfMonths = step1Vm.noOfYearDiffernce;
                        if (step1Vm.noOfMonths < 216) {
                            step1Vm.minorFlag1 = 1;
                            step1Vm.showNRIPopup();
							return false;

                        } else {
                            step1Vm.minorFlag1 = 0;
                        }
                    }
                }

         //actions to done everytime the view is shown
         $scope.$on('$ionicView.beforeEnter', function() {
             initPage();
         });



     }
 ]);
