
angularApp.filter('cardmask', function(utilityService) {
    try {
        return function(value, symbol, count, separator) {
            if (!utilityService.isUndefined(value)) {
                !isNaN(value) ? value = value.toString() : value;
                if (value.length > 0) {
                    var count = count || value.length;
                    var symbol = symbol || "*";
                    var symbols = [];
                    var temp = "";
                    for (var i = 0; i < value.length - count; i++) {
                        symbols.push(symbol);
                        if (separator) {
                            if ((i + 1) % count == 0) symbols.push(separator);
                        }
                    }
                    symbol = symbols.join("");
                    value = symbol + value.substring(value.length - count);
                    return value;
                }
            }
        }
    } catch (e) {}
});

