
'use strict';

angularApp.controller('selectCardBlockHotlistController', ["$state",
    "$scope",
    "$stateParams",
    "cardsService",
    "floatingMenuService", "utilityService", "cardCompareService",
    function($state,
        $scope,
        $stateParams,
        cardsService,
        floatingMenuService, utilityService,
        cardCompareService) {

        //functions, variables that can be accessed from the HTML come here
        var selectCardBlockHotlistVm = this;
        //Entry point
        function initPage(stateParams) {
            selectCardBlockHotlistVm.cardList = [];
            selectCardBlockHotlistVm.card = cardsService.getSetCardDetail().cardNumber;
            selectCardBlockHotlistVm.cardData = cardsService.getSetCardDetail()
            selectCardBlockHotlistVm.cardData.cardRank = "Primary Card";
            selectCardBlockHotlistVm.clicked = 0;

            
                if(selectCardBlockHotlistVm.cardData.isBlockEnabled)
                {
                    selectCardBlockHotlistVm.cardList.push(selectCardBlockHotlistVm.cardData);

                }

          var addonCards = cardsService.getParams().addOnCards;
            //if (cardsService.getSetCardDetail().hasOwnProperty('cardDetails')) {
                for (var i = 0; i < addonCards.length; i++) {
                    if(addonCards[i].isBlockEnabled)
                    {
                    addonCards[i].cardRank = "Add on Card"
                    selectCardBlockHotlistVm.cardList.push(addonCards[i]);
                }
                }
           // }
            // selectCardBlockHotlistVm.counter = 0;
            // for (var k = 0; k < selectCardBlockHotlistVm.cardList.length; k++) {
            //     if (selectCardBlockHotlistVm.cardList[k].isBlockEnabled === true) {
            //         selectCardBlockHotlistVm.counter = selectCardBlockHotlistVm.counter + 1;
            //     }
            // }


        }
        // go to home
        selectCardBlockHotlistVm.goBackHome = function() {
                $state.go('menu.cardOverview');
            }


        selectCardBlockHotlistVm.selectRadio = function(index){
            selectCardBlockHotlistVm.clicked = index;


        }

            // go to confirm block card page
        selectCardBlockHotlistVm.goToBlockHotlist = function() {
           var selectedCardIndex = selectCardBlockHotlistVm.clicked;
           var selectedCardNumber =  selectCardBlockHotlistVm.cardList[selectedCardIndex].cardNumber;
            floatingMenuService.setParams({
                floatingCard: selectedCardNumber
            });
            floatingMenuService.getCardHolderDetails({
               // accountId: cardCompareService.accountId,
                cardNumber: selectedCardNumber
            }).then(function(response) {
                    cardsService.errorLogger(response);
                    if (response.data && response.data.address1 && response.data.pinCode) {
                        var reissueAddress = response.data.address1 + "," + response.data.address2 + "," + response.data.city + "," + response.data.pinCode + "," + response.data.state;
                        cardsService.setParams({ "reissueAddress": reissueAddress });
                        $state.go('menu.confirmCardBlockHotlist');
                    }
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });

        }


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function(event, data) {
            initPage();
        });

    }
]);
