'use strict';

angularApp.controller('resetPinController', ["$state",
    "$scope",
    "cardsService",
    "floatingMenuService",
    "cardConfig","utilityService","cardCompareService",

    function($state,
        $scope,
        cardsService,
        floatingMenuService,
        cardConfig,utilityService,cardCompareService) {

        //functions, variables that can be accessed from the HTML come here
        var resetPinVm = this;

        //Entry point   
        function initPage() {
            resetPinVm.cardList = [];
            resetPinVm.selectedCard = "0";
            resetPinVm.card = cardsService.getSetCardDetail();
            resetPinVm.card.cardRank="Primary Card";
            resetPinVm.clicked = 0;
            
            floatingMenuService.isResendExhaust = false;
            floatingMenuService.isTextExhaust = false;
            // resetPinVm.cardNum = resetPinVm.card;

                 if(resetPinVm.card.isManagePinEnabled)
                {
                     resetPinVm.cardList.push( resetPinVm.card);

                }
          
            //var addonCards = resetPinVm.card.cardDetails['addonCards'];
             var addonCards = cardsService.getParams().addOnCards;

            //if (cardsService.getSetCardDetail().hasOwnProperty('cardDetails')) {
                for (var i = 0; i < addonCards.length; i++) {

                    if(addonCards[i].isManagePinEnabled){
                    addonCards[i].cardRank="Add on Card"

                    resetPinVm.cardList.push(addonCards[i]);
                }
                }
           // }

           // resetPinVm.counter =0 ;
            // for(var k=0; k< resetPinVm.cardList.length;k++){
            //     if(resetPinVm.cardList[k].isManagePinEnabled === true){
            //         //resetPinVm.counter = resetPinVm.counter + 1;
            //     }
            // }

        }

        resetPinVm.selectRadio = function(index){
            resetPinVm.clicked = index;

        }

        // go to home
        resetPinVm.goBackHome = function() {
            $state.go('menu.cardOverview');
        }

        resetPinVm.sendOTP = function() {

            resetPinVm.translationData = {
                cardNumber: resetPinVm.cardList[resetPinVm.clicked].cardNumber,
                cardType: resetPinVm.card.cardName
            }

            
             floatingMenuService.setIsResend(false);

            var sendOTPPayload = {
                "cardNumber": resetPinVm.cardList[resetPinVm.clicked].cardNumber,
                // "mobileNumber": resetPinVm.cardList[0].regMobileNumber,
                // "email": resetPinVm.cardList[0].regEmail,
                "isResend" : "false"
                //"accountId" : cardCompareService.accountId      

            };
            floatingMenuService.setParams(sendOTPPayload);

            floatingMenuService.sendOTP(sendOTPPayload)
                .then(function(response) {
                        cardsService.errorLogger(response);
                        switch (response.data.responseCode) {
                            case cardConfig.responseCode.dataSuccess:
                                $state.go("menu.resendOTPPin");
                                break;
                        }
                    },
                    function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });

        }


        $scope.$on('$ionicView.beforeEnter', function(event, data) {
            initPage();
        });

    }
]);
