/*
    Module Name  : Cards,
    File Name    : rewardsTermsConditionController.js,
    Description  : Terms and condition for rewards
*/

'use strict';

angularApp.controller('rewardsTermsConditionController', ["$state", "$scope", "$translate", "$filter", "$ionicScrollDelegate", "$timeout", "cardConfig", "cardsService", "utilityService",
    function($state, $scope, $translate, $filter, $ionicScrollDelegate, $timeout, cardConfig, cardsService, utilityService) {

        //functions, variables that can be accessed from the HTML come here

        //Entry point
        var rewardsTermsConditionVm = this;

        function initPage() {
            termsAndCondition();
        }

        function termsAndCondition() {

            rewardsTermsConditionVm.consentText = cardsService.getParams().termsAndConditionContent;
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function(event, data) {
            initPage();
        });
    }
]);
