'use strict';

angularApp.controller('chatBotFeedbackController', 
					["$timeout",
					 "$state",
					 "$location",
					 "$scope",
					 "$rootScope",
					 "utilityService",
					 "$ionicPopup",
					 "$ionicSideMenuDelegate",
					 "$sce",
					 "$compile",
					 "chatBotService",
					 "$ionicScrollDelegate",
					 function ($timeout,
					 $state,
					 $location,
					 $scope,
					 $rootScope,
					 utilityService,
					 $ionicPopup,
					 $ionicSideMenuDelegate,
					 $sce,
					 $compile,
					 chatBotService,
					 $ionicScrollDelegate
					) {
	
	//functions, variables that can be accessed from the HTML come here
	var chatBotFeedbackVm = this;	
	//private methods section start
						
	function initPage(){
						
		chatBotFeedbackVm.showBack = false;
		chatBotFeedbackVm.showNext = true;	
		chatBotFeedbackVm.displaySpinner = false;	
		
	}
	chatBotFeedbackVm.sendFeedback=function(feedback){
		//alert(feedback);
		chatBotFeedbackVm.displaySpinner=true;
		var thumbRating=feedback;
		var starRating=0;
		chatBotService.submitChatBotFeedback(thumbRating,starRating).then(
			function(data) {
				
				//alert(data.);
			chatBotFeedbackVm.displaySpinner=false;
			var chatBotPopUp = $ionicPopup.show({       
		template: data.responseMesssage,
        title: '',
        cssClass: 'dialog',
        scope: $scope,			
        buttons: [{
            text: 'OK',
            type: 'button-positive',
			onTap: function() { 
    					$state.go('menu.support');

    					}
            }]
		});
	
				
			},
			function(error) {
				chatBotFeedbackVm.displaySpinner=false;
				utilityService.showErrorMessage(error.responseMessage);
					$state.go('menu.support');
			}
		);
		
		//$state.go('menu.homescreen');
	}
	
	
		
	//back to prev page
	chatBotFeedbackVm.goBacktoPrevious = function(){		
		//$state.go('menu.settings');
	}	
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		//$ionicSideMenuDelegate.canDragContent(false);		
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		//$ionicSideMenuDelegate.canDragContent(false);		
		initPage();
	});
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		//$ionicSideMenuDelegate.canDragContent(true);
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);