'use strict';

angularApp.controller('chatBotWhatCanIDotController', ["$timeout",
     "$state",
     "$location",
     "$scope",
     "$rootScope",
     "utilityService",
     "$ionicPopup",
     "$ionicSideMenuDelegate",
     "$sce",
     "$compile",
     "chatBotService",
     "$ionicScrollDelegate",
     "homeScreenService",

     function ($timeout,
     $state,
     $location,
     $scope,
     $rootScope,
     utilityService,
     $ionicPopup,
     $ionicSideMenuDelegate,
     $sce,
     $compile,
     chatBotService,
     $ionicScrollDelegate,
     homeScreenService
       ) {
         var chatBotWhatCanIDoVm = this;
         //actions to done everytime the view is shown
         function initPage(){
           chatBotWhatCanIDoVm.sttButton=false;
           chatBotWhatCanIDoVm.displaySpinner=true;
           chatBotWhatCanIDoVm.chatResponse="";
           chatBotWhatCanIDoVm.isWaitingForResponse = false;
           chatBotWhatCanIDoVm.chatMsg = "";
           chatBotWhatCanIDoVm.chatServiceList = chatBotService.getChatResponse();
           var welcomeMsg="Hi, I am YONO ChatBot , your personal digital assistant.";
           chatBotWhatCanIDoVm.displayFAQResponse(welcomeMsg,'');
           chatBotWhatCanIDoVm.chatSend("First");
         }
         chatBotWhatCanIDoVm.gotoLevel2=function(id){
           chatBotWhatCanIDoVm.id=id;
            for(var i=0;i<chatBotWhatCanIDoVm.chatServiceList.children.length;i++){
              if(chatBotWhatCanIDoVm.id==chatBotWhatCanIDoVm.chatServiceList.children[i].id){
                  var msg=chatBotWhatCanIDoVm.chatServiceList.children[i].request;
                  var resp=chatBotWhatCanIDoVm.chatServiceList.children[i].response;
                  var btnResp=chatBotWhatCanIDoVm.chatServiceList.children[i].btnResponse;
                  chatBotService.msg=msg;
                  chatBotService.resp=resp;
                  chatBotService.btnResp=btnResp;
                  $state.go("menu.chatbotwhatcanidoDetail");
            }
          }
        };

         chatBotWhatCanIDoVm.chatSend=function(id) {
          chatBotWhatCanIDoVm.id=id;
            if(chatBotWhatCanIDoVm.id==chatBotWhatCanIDoVm.chatServiceList.id){
            //  var msg=chatBotWhatCanIDoVm.chatServiceList.children[i].request;
              var resp=chatBotWhatCanIDoVm.chatServiceList.response;
              var btnsResp=chatBotWhatCanIDoVm.chatServiceList.btnResponse;
            }
       		var d = new Date();
       		var time = d.toLocaleString([],{hour:'2-digit',minute:'2-digit'});
          chatBotWhatCanIDoVm.displayFAQResponse(resp,btnsResp);
       		};
          /**
          * Display FAQ responses
          */
          chatBotWhatCanIDoVm.displayFAQResponse = function(response, btnsResp) {

            chatBotWhatCanIDoVm.isWaitingForResponse = false;
            var d = new Date();
            var time = d.toLocaleString([],{hour:'2-digit',minute:'2-digit'});

            chatBotWhatCanIDoVm.inTransaction = false;

            var outputResponse ='<div class="receiver"><div class="row "><div class="col col-80 bg-color-white border-radius5 roboto-regular">' + response + btnsResp+ '</div>'
       			+'<div class="col col-20 chatbot_txtRight"><div><img src="img/ChatBot_Icon.svg" style="width:50px;"></div></div></div>'
            +'<div class="row"><div class="col col-100"><span class="roboto-regular lowerCase">' + time + '</span></div></div>';

            chatBotWhatCanIDoVm.chatResponse=$sce.trustAsHtml(chatBotWhatCanIDoVm.chatResponse + outputResponse );

            $timeout(function() {
              $ionicScrollDelegate.$getByHandle('homeScroll').scrollBottom();
            }, 0);

          }

          chatBotWhatCanIDoVm.goBack =function(){
            if(homeScreenService.isRedirectionFromHomeScreen==true){
            $state.go('menu.homeScreen');

           }
           else{
             $state.go('menu.chatbotlanding');
           }
          }
          chatBotWhatCanIDoVm.goHome =function(){
             $state.go('menu.homeScreen');
          }
          chatBotWhatCanIDoVm.getScrollPosition = function() {
            //monitor the scroll
            var moveData = $ionicScrollDelegate.$getByHandle('homeScroll').getScrollPosition().top;
            // console.log(moveData);
            if(moveData>150){
                $scope.$apply(function(){
                chatBotWhatCanIDoVm.sttButton=true;
             });//apply
            }else{
              $scope.$apply(function(){
              chatBotWhatCanIDoVm.sttButton=false;
            });//apply
          }
          };
    chatBotWhatCanIDoVm.scrollToTop = function() {
      $ionicScrollDelegate.$getByHandle('homeScroll').scrollTop();
      chatBotWhatCanIDoVm.sttButton=false;
    };

         $scope.$on('$ionicView.beforeEnter', function () {
           	initPage();
         });

         $scope.$on('$ionicView.beforeLeave', function () {

         });

         return this;
     }
 ]);
