'use strict';

angularApp.controller('chatBotWhatsNewController', ["$state",
    "$scope",
    "$timeout",
    "$ionicHistory",
    "$sce",
    "$ionicScrollDelegate",
    "chatBotService",
    "utilityService",

    function ($state,
        $scope,
        $timeout,
        $ionicHistory,
        $sce,
        $ionicScrollDelegate,
        chatBotService,
        utilityService
       ) {
         var chatBotWhatsNewVm = this;

         chatBotWhatsNewVm.goBack =function(){
            $state.go('menu.chatbotlanding');
         }
         chatBotWhatsNewVm.displaySecurityResponse = function(resp) {

           var d = new Date();
           var time = d.toLocaleString([],{hour:'2-digit',minute:'2-digit'});
           var response=resp;
           var outputResponse ='<div class="receiver"><div class="row "><div class="col col-100 bg-color-white border-radius5 padding16">' + response +  '</div></div></div>';
           chatBotWhatsNewVm.chatResponse=$sce.trustAsHtml(outputResponse);


         }
         chatBotWhatsNewVm.scrollToTop = function() {
           $ionicScrollDelegate.$getByHandle('whatsNewScroll').scrollTop();
         };
         chatBotWhatsNewVm.loadWhatsNewContent = function() {
             chatBotService.getChatbotWhatsNew().then(function(data) {
                 chatBotWhatsNewVm.response = data;
                 chatBotWhatsNewVm.displaySecurityResponse(chatBotWhatsNewVm.response);
             }, function(error) {
                 utilityService.showErrorMessage(error.responseMessage);
             });
         };
         //actions to done everytime the view is shown
         $scope.$on('$ionicView.beforeEnter', function () {
         chatBotWhatsNewVm.loadWhatsNewContent();
         chatBotWhatsNewVm.scrollToTop();
           });

         $scope.$on('$ionicView.beforeLeave', function () {

         });

         return this;
     }
 ]);
