'use strict';

angularApp.controller('eTaxController', [
    "$state",
    "$q",
    "$scope",
    "$translate",
    "$ionicHistory",
    "eTaxService",
    function ($state,
        $q,
        $scope,
        $translate,
        $ionicHistory,
        eTaxService
        ) {

        var eTaxVm = this;
        
        

        eTaxVm.goToBack = function () {
            $ionicHistory.goBack();
        };
        eTaxVm.goToDirectTax = function () {
            $state.go('menu.directTaxLanding');
        };
        eTaxVm.goToStateTax = function () {
            $state.go('menu.stateTaxLanding');
        };
        eTaxVm.goToPrevious = function () {
            $ionicHistory.goBack();
        };

       
        
        
        /*actions to done everytime the view is shown*/
        $scope.$on('$ionicView.beforeEnter', function () {
            eTaxService.selectedState = {};
        });

        
        return this;
    }
]);
