'use strict';
angularApp.controller('fasTagRecharge_UPIController', [
	"$state",
	"$scope",
	"utilityService",
	"bhimUpiService",
	"$ionicPopover",
	"fasTagService",
	"mPinLoginService",
	function ($state, $scope, utilityService, bhimUpiService,$ionicPopover,fasTagService,mPinLoginService) {

		var fasTagRecharge_UPIVm = this;


		fasTagRecharge_UPIVm.goBack = function () {
			if(mPinLoginService.isLoggedIn == true){

				$state.go('menu.fundsTransferLanding');
			}
			else{

				$state.go('menu.userLogin');
			}
		}


		fasTagRecharge_UPIVm.gotoUPIVerifyPage = function (selectedBank) {
				fasTagService.fasTagUPIId="netc." + fasTagRecharge_UPIVm.vehicleNumber+selectedBank ;
				$state.go('menu.fasTagRechargeVerify_UPI');
		}


	var template =     '<ion-popover-view class="quickpay loginnewarrow hmbr-info fastag-hint-popover" id="runtimeHeight" style="{{fasTagRecharge_UPIVm.topStyle}}">' + '<div class="username-hint-arrow-upnew" style="right :2%;"></div>' +
																	'<ion-content class="nfs-popover" style="margin: 0px !important;">' +
																	'<div id="renderHeight" class="padding-right-10 font-size-12" style="padding-left: 14px !important;">' +
																	'<div class="roboto-regular font-sixe-12 color3f3f3f" translate="FASTAG_VEHICLE_FORMAT" style="text-align:justify !important;"></div>' +
																	'</div>' + '</ion-content>' + '</ion-popover-view>';

$scope.popover = $ionicPopover.fromTemplate(template, {
			scope: $scope
	});
	fasTagRecharge_UPIVm.infoDetails = function($event) {
			fasTagRecharge_UPIVm.showIndicator=false;
			$scope.popover.show($event);
	}
	fasTagRecharge_UPIVm.goToPenslip = function(){
			fasTagRecharge_UPIVm.showIndicator=false;
			 $scope.popover.hide();
	}

	$scope.$on('popover.hidden', function() {
			fasTagRecharge_UPIVm.showIndicator=false;
	});

	$scope.$on('popover.removed', function() {
			fasTagRecharge_UPIVm.showIndicator=false;
	});

	$scope.$on('$ionicView.beforeEnter', function () {
		fasTagRecharge_UPIVm.bankList=[{"bankName":"State Bank of India","bankUPIHandle":"@sbi"},
																	 {"bankName":"Airtel Payment Bank","bankUPIHandle":"@mairtel"},
																	 {"bankName":"Axis Bank","bankUPIHandle":"@axisbank"},
																	 {"bankName":"Bank Of Baroda","bankUPIHandle":"@barodampay"},
																	 {"bankName":"City Union Bank","bankUPIHandle":"@cub"},
																	 {"bankName":"Equitas Small Finance Bank","bankUPIHandle":"@equitas"},
																	 {"bankName":"Federal Bank","bankUPIHandle":"@fbl"},
																	 {"bankName":"HDFC Bank","bankUPIHandle":"@hdfcbank"},
																	 {"bankName":"ICICI Bank","bankUPIHandle":"@icici"},
																	 {"bankName":"IDFC Bank","bankUPIHandle":"@Idfcnetc"},
																	 {"bankName":"Indusind Bank","bankUPIHandle":"@Indus"},
																	 {"bankName":"KVB Bank","bankUPIHandle":"@Kvb"},
																	 {"bankName":"Kotak Mahindra Bank","bankUPIHandle":"@Kotak"},
																	 {"bankName":"Paytm Bank","bankUPIHandle":"@paytm"},
																	 {"bankName":"Punjab National Bank","bankUPIHandle":"@pnb"},
																	 {"bankName":"South Indian Bank","bankUPIHandle":"@sib"},
																	 {"bankName":"NHAI Pre-paid Wallet","bankUPIHandle":"@indus"}];

		if (utilityService.isIOSPlatform()) {
			fasTagRecharge_UPIVm.topStyle = "margin-top : 5px !important;";
		}
		else {
			fasTagRecharge_UPIVm.topStyle = "margin-top : 5px !important;";
		}
		});

	return this;
	}
]);
