/**
 *   @ngdoc config
 *   @name angularApp.config : cardConfig
 *   @description
 *  configuration file for cards module
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
   

/*State defination with respective names, urls, controllers and templates */

.config([
    '$stateProvider',
    function($stateProvider) {

        //Cards start
        $stateProvider
            .state('menu.FDChangeMaturity', {
                url: '/FDChangeMaturity',
                data: {
                    pageId: 'FD_CHNGMTRTY'
                },
                cache: true,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/fixedDeposit/changeMaturity/changeMaturityDetails.html',
                        controller: 'changeMaturityDetailsController',
                        controllerAs: 'changeMaturityDetailsVm'
                    }
                }
            })
            .state('menu.FDReviewChangeMaturity', {
                url: '/FDReviewChangeMaturity',
                data: {
                    pageId: 'FD_REVIEWCHNGMTRTY'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/fixedDeposit/changeMaturity/reviewFDChangeMaturity.html',
                        controller: 'reviewFDChangeMaturityController',
                        controllerAs: 'reviewFDChangeMaturityDetailsVm'
                    }
                }
            })
            .state('menu.changeMaturitySuccess', {
                url: '/changeMaturitySuccess',
                data: {
                    pageId: 'FD_CHNGMATSUCCESS'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/fixedDeposit/changeMaturity/changeMaturitySuccess.html',
                        controller: 'changeMaturitySuccessController',
                        controllerAs: 'changeMaturitySuccessVm'
                    }
                }
            })
            .state('menu.cminterestrate', {
                url: '/cminterestrate',
                cache: false,
                data: {
                    pageId: 'CM_INSTR'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/fixedDeposit/changeMaturity/cminterestrate.html',
                        controller: 'cminterestrateController',
                        controllerAs: 'cminterestrateVm',
                    }
                }
            })
            
                   

    }
]);
