angularApp.service('fTNewBeneficiaryService', function($q, AdapterUtils, constantConfig) {
	var selectedDiv = "";
	var addBeneficiary = function(beneficiary,remAccntNo,benName,amount,charges,remarks, 
		timeStamp,checkTnC ,branchCodeFromAcc ,
		remName , remAdd1) {
		var q = $q.defer();
		
		var obj = {
				  "inbUserID":"",
				  "benName": beneficiary.nameData,
				  "benNickName": beneficiary.nickName,
				  "benBankName": beneficiary.bankData,
				  "benType": "account",
				  "transferLimit": beneficiary.maxLimit,
				  "benAccntNo": beneficiary.accountNoData,
				  "benIfscCode": beneficiary.ifsc,
				  "intraBankFlag": beneficiary.intraBankFlag,
				  "benMMID": "",
				  "remMMID": "",
				  "benMobileNo": beneficiary.mobileNo,
				  "remAccntNo": remAccntNo,
				  "amount": amount,
				  "transactionFee": charges,
				  "remarks": remarks,
				  "txnType":"",
				  "otpTimeStamp": timeStamp,
				  "benPicDocId": beneficiary.picDocId,
				  "termsNcondition":checkTnC,
				  "remBranchCode": branchCodeFromAcc,
				  "remName" : remName ? remName :"",
				  "remAdd1" : remAdd1 ? remAdd1 : "",
				  "remAdd2" :  "",
				  "remAdd3" : "",
				  "benCountryCode" : "91",
				  "remMobileNo" : "",
				  "remEmail" : "",
				  "benStatus" : ""
		};
		
		AdapterUtils.postData(constantConfig.ftAdapterUrl.addBeneficiary,obj,true).then(
			function(response){	
				q.resolve(response.data);
			},
			function(error){	
				q.reject(error);
			}
			); 
		return q.promise;
	};
	return {
		addBeneficiary : addBeneficiary,
		selectedDiv : selectedDiv
	};
});
