angularApp.service('qrCodeService', function ($q, utilityService, constantConfig, AdapterUtils) {
	var resolveQRCode = function (accNo, vpa, amount, remark) {
		var payload = {
			"sourceAccountNumber": accNo,
			"vpa": vpa,
			"amount": amount,
			"remark": remark
		}
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.ftAdapterUrl.resolveQRCode, payload, true).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			}
		);
		return q.promise;
	};
	return {
		resolveQRCode: resolveQRCode
	}
});
