angularApp.service('fTReviewDetails_VPAService',
	function ($q, utilityService, constantConfig, AdapterUtils) {
		var VPAService = this;
		VPAService.transferFunds = function (accountNo, name, tamount, fee) {
			var q = $q.defer();
			var payload = {
				sourceAccount: accountNo,
				beneficiaryName: name,
				amount: tamount,
				transactionFee: fee
			};
			AdapterUtils.postData(constantConfig.ftAdapterUrl.transferFunds, payload, true).then(
				function (response) {
					q.resolve(response.data.remainingBaLance);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		
		VPAService.getAuditLogs = function(payload) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/CommonAdapter/saveAuditLogs", payload, false).then(function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}); 
			return q.promise;
		};
		
		return VPAService;
	});
