'use strict';
angularApp.service('cancelScheduledPaymentService', function($q, AdapterUtils, constantConfig) {
    var cancelData = function(siId) {
        var q = $q.defer();
        var obj = {
            siId: siId
        };

        AdapterUtils.postData(constantConfig.ftAdapterUrl.cancelScheduleddPayment, obj, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            });
        return q.promise;
    };
    return {
        cancelData: cancelData
    };
});
