'use strict';

angularApp.controller('fundsTransferController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "requestYCService",
    "billDeskService",
    "personalLoanService",
   "$rootScope",
    "sampoornSurakshaService",
    "$filter",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
		requestYCService,
        billDeskService,
        personalLoanService,
        $rootScope,
        sampoornSurakshaService,
        $filter
    ) {

        var fundsTransferVm = this;
        fundsTransferVm.isTextReadable = false;
        fundsTransferVm.isTextReadablereEnter = false;
        fundsTransferVm.offersData = [];
        var accOverviewData = getAccountDetailsService.accountOverviewData;
        var profPassObj = {};

        fundsTransferVm.initPage = function() {
            //fundsTransferVm.isBackCheck = homeScreenService.isBackCheck;
if(homeScreenService.ishamburgerMenuFT){
                fundsTransferVm.isHamCheck = true;
                fundsTransferVm.isBackCheck = true;
}else {
                fundsTransferVm.isBackCheck = false;
}
            //homeScreenService.isBackCheck = false;
            fundsTransferVm.retry(false);
        };

        fundsTransferVm.retry = function (bool) {
            if(bool == true) {
            fundsTransferVm.beneficiariesStatus = false;
            fundsTransferVm.schTransItemsStatus = false;
            fundsTransferVm.ownAccountList = false;
            } else {
            fundsTransferVm.beneficiariesStatus = true;
            fundsTransferVm.schTransItemsStatus = true;
            fundsTransferVm.ownAccountList = true;
            }
            $ionicScrollDelegate.scrollTop(true);
            fundsTransferVm.searchText = "";
            $translate('BEN_NAME').then(function(transValue) {
                fundsTransferVm.ben_name = transValue;
            });
            fundsTransferVm.selectedAcctype = null;
            fundsTransferVm.accountTypes = [];
            if (!fTBeneficiaryService.beneficiaries) {
                fundsTransferVm.fetchBeneficiaryList();
            } else {
                fundsTransferVm.beneficiariesStatus = true;
                var data = fTBeneficiaryService.beneficiaries;
                fundsTransferVm.freqTransItems = data.freqTransItems;
                fundsTransferVm.otherAccItems = data.otherAccItems;
                fundsTransferVm.searchItems = fundsTransferVm.otherAccItems;
                $scope.toggleGroup(constantConfig.ft.ftText);
                setTransferTypes();
                if(bool == true) {
                fundsTransferVm.fetchOwnAccountDetails();
                }
                fundsTransferVm.manageScheduleTransfer();
            }
        };

        fundsTransferVm.manageScheduleTransfer = function() {
            if (!fTBeneficiaryService.schTransItems) {
                utilityService.showSpinner();
                fTBeneficiaryService.getScheduledPayment(false).then(function (data) {
                    utilityService.hideSpinner();
                    fTBeneficiaryService.schTransItems = data;
                    fundsTransferVm.schTransItems = data;
                    if (fundsTransferVm.schTransItems && fundsTransferVm.schTransItems.length > 0) {
                        fundsTransferVm.accountTypes.splice(1, 0, constantConfig.ft.scheduledTracsfText);
                    }
                    fundsTransferVm.schTransItemsStatus = true;
                    setTransferTypes();
                    //fundsTransferVm.fetchOwnAccountDetails();
                }, function(error) {
                    utilityService.hideSpinner();
                    fundsTransferVm.schTransItemsStatus = false;
                });
            } else {
                utilityService.hideSpinner();
                fundsTransferVm.schTransItemsStatus = true;
                fundsTransferVm.accountTypes = [];
                fundsTransferVm.schTransItems = fTBeneficiaryService.schTransItems;
                if (fundsTransferVm.schTransItems && fundsTransferVm.schTransItems.length > 0) {
                    fundsTransferVm.accountTypes.splice(1, 0, constantConfig.ft.scheduledTracsfText);
                }
                setTransferTypes();
            }
        };

        fundsTransferVm.fetchBeneficiaryList = function() {
            utilityService.showSpinner();
            fTBeneficiaryService.getBeneficiaryList(false).then(function(data) {
                data.ownAccItems = [];
                utilityService.hideSpinner();
                fTBeneficiaryService.beneficiaries = data;
                fundsTransferVm.freqTransItems = data.freqTransItems;
                fundsTransferVm.otherAccItems = data.otherAccItems;
                fundsTransferVm.searchItems = fundsTransferVm.otherAccItems;
                $scope.toggleGroup(constantConfig.ft.ftText);
                fundsTransferVm.beneficiariesStatus = true;
                setTransferTypes();
                fundsTransferVm.manageScheduleTransfer();
                fundsTransferVm.fetchOwnAccountDetails();
            }, function(error) {
                utilityService.hideSpinner();
                fundsTransferVm.beneficiariesStatus = false;
            });
        };
        fundsTransferVm.fetchOwnAccountName = function (data) {
            fundsTransferVm.ownAccountName = true;
            customerInfoService.customer.name = data.customerInformation.customerName;
            customerInfoService.customer.DOB = data.customerInformation.dob;
            customerInfoService.customer.type = data.customerInformation.customerType;
            customerInfoService.customer.address = data.customerInformation.address;
            // if (!customerInfoService.customer.name) {
            //     utilityService.showSpinner();
            //     homeScreenService.getCustomerInfo().then(function (data) {
            //         utilityService.hideSpinner();
            //         fundsTransferVm.ownAccountName = true;
            //         customerInfoService.customer.name = data.customerInformation.customerName;
            //         customerInfoService.customer.DOB = data.customerInformation.dob;
            //         customerInfoService.customer.type = data.customerInformation.customerType;
            //         customerInfoService.customer.address = data.customerInformation.address;
            //     }, function (error) {
            //         utilityService.hideSpinner();
            //     });
            // }
        };
        //Function for fetch All own account list
        fundsTransferVm.fetchOwnAccountDetails = function() {
            if (!fTBeneficiaryService.beneficiaries) {
                return true;
            };

            if (getAccountDetailsService.accountOverviewData) {
                fundsTransferVm.ownAccountList = true;
                fundsTransferVm.processOwnAccountDetails(getAccountDetailsService.accountOverviewData);
                fundsTransferVm.fetchOwnAccountName(getAccountDetailsService.accountOverviewData);
            } else {
                utilityService.showSpinner();
                getAccountDetailsService.getAccountDetails().then(function (data) {
                    utilityService.hideSpinner();
                    //AMS-646 starts
                    $rootScope.customerInfoForProfile = data.customerInformation; //changed by lalita
                    customerInfoService.customer.mobile = data.customerInformation.mobile;//changed by lalita
                    $rootScope.mobileNo = data.customerInformation.mobile;//changed by lalita AMS-646 ends
                    fundsTransferVm.ownAccountList = true;
                    getAccountDetailsService.accountOverviewData = data;
					accOverviewData = getAccountDetailsService.accountOverviewData;
                    fundsTransferVm.fetchOwnAccountName(data);
                    fundsTransferVm.processOwnAccountDetails(data);
                }, function(error) {
                    utilityService.hideSpinner();
                    fundsTransferVm.ownAccountList = false;
                    fundsTransferVm.ownAccountName = false;
                });
            }
        };

        fundsTransferVm.processOwnAccountDetails = function(ownAccData) {
            fTBeneficiaryService.payingFrom = [];
            var ownAccLength = ownAccData.accounts.length;
            for (var i = 0; i < ownAccLength; i++) {
                if ((ownAccData.accounts[i].accountType.toLowerCase().indexOf('savings') != -1) ||
                    (ownAccData.accounts[i].accountType.toLowerCase().indexOf('current') != -1)) {
                    var obj = {
                        img: constantConfig.SBILogo,
						accountCategory : ownAccData.accounts[i].accountCategory,
                        accountType: ownAccData.accounts[i].accountType,
                        accountNo: ownAccData.accounts[i].accountNumber,
                        balance: ownAccData.accounts[i].accountBalance,
                        branchCode: ownAccData.accounts[i].branchCode,
                        isActive: ownAccData.accounts[i].isActive,
                        isTransactional: ownAccData.accounts[i].isTransactional,
                        intCategory: ownAccData.accounts[i].intCategory ? ownAccData.accounts[i].intCategory : "",
                        accountTypeCode: ownAccData.accounts[i].accountTypeCode ? ownAccData.accounts[i].accountTypeCode : "",
                        branchName: ownAccData.accounts[i].branchName ? ownAccData.accounts[i].branchName : "",
                        debitNriflag: ownAccData.accounts[i].nriFlag ? ownAccData.accounts[i].nriFlag : ""
                    };
                    fTBeneficiaryService.payingFrom.push(obj);
                } else {
                    var obj = {
                        img: constantConfig.SBILogo,
						accountCategory : ownAccData.accounts[i].accountCategory,
                        accountType: ownAccData.accounts[i].accountType,
                        accountNo: ownAccData.accounts[i].accountNumber,
                        balance: ownAccData.accounts[i].accountBalance,
                        branchCode: ownAccData.accounts[i].branchCode,
                        isActive: ownAccData.accounts[i].isActive,
                        isTransactional: ownAccData.accounts[i].isTransactional,
                        doNotShowInBenList: 'true',
                        intCategory: ownAccData.accounts[i].intCategory ? ownAccData.accounts[i].intCategory : "",
                        accountTypeCode: ownAccData.accounts[i].accountTypeCode ? ownAccData.accounts[i].accountTypeCode : "",
                        branchName: ownAccData.accounts[i].branchName ? ownAccData.accounts[i].branchName : "",
                        debitNriflag: ownAccData.accounts[i].nriFlag ? ownAccData.accounts[i].nriFlag : ""
                    };
                    fTBeneficiaryService.payingFrom.push(obj);
                }
            }

            fundsTransferVm.myDreamsAcc = [];
            var ownDreamAccLength = ownAccData.myDreams.length;
            for (var i = 0; i < ownDreamAccLength; i++) {
                if (ownAccData.myDreams[i].accountNumber) {
                    var obj = {
                        img: constantConfig.SBILogo,
                        accountType: 'Recurring Deposit A/c',
                        accountCategory: ownAccData.myDreams[i].accountCategory ? ownAccData.myDreams[i].accountCategory : "",
                        accountNo: ownAccData.myDreams[i].accountNumber,
                        balance: ownAccData.myDreams[i].totalAmount,
                        branchName: ownAccData.myDreams[i].branchName ? ownAccData.myDreams[i].branchName : ""
                    };
                    fundsTransferVm.myDreamsAcc.push(obj);
                }
            };

            fundsTransferVm.otherDepositsAcc = [];
            var ownOtherDepositLen = ownAccData.otherDeposits.length;
            for (var i = 0; i < ownOtherDepositLen; i++) {
                if (ownAccData.otherDeposits[i].otherAccountNumber) {
                    var obj = {
                        img: constantConfig.SBILogo,
                        accountType: 'Other Deposits A/c',
                        accountCategory: ownAccData.otherDeposits[i].accountCategory ? ownAccData.otherDeposits[i].accountCategory : "",
                        accountNo: ownAccData.otherDeposits[i].otherAccountNumber,
                        balance: ownAccData.otherDeposits[i].otherAmount,
                        branchName: ownAccData.otherDeposits[i].branchName ? ownAccData.otherDeposits[i].branchName : "",
                        accountTypeCode: ownAccData.otherDeposits[i].accountTypeCode,// added for PPF validation
                        intCategory: ownAccData.otherDeposits[i].intCategory //added for PPF valdiation
                    };
                    fundsTransferVm.otherDepositsAcc.push(obj);
                    fTBeneficiaryService.otherDepositsObj = obj;    //added for PPF valdiation
                    
                }
            }

            fundsTransferVm.otherLoansAcc = [];
            var ownOtherLoanDtlsLen = ownAccData.loanDetails.length;
            for (var i = 0; i < ownOtherLoanDtlsLen; i++) {
                if (ownAccData.loanDetails[i].loanNumber) {
                    var obj = {
                        img: constantConfig.SBILogo,
                        accountType: ownAccData.loanDetails[i].accountType ? ownAccData.loanDetails[i].accountType : ownAccData.loanDetails[i].loanLabel,
                        accountCategory: ownAccData.loanDetails[i].accountCategory ? ownAccData.loanDetails[i].accountCategory : "",
                        accountNo: ownAccData.loanDetails[i].loanNumber,
                        balance: ownAccData.loanDetails[i].loanAmount,
                        branchName: ownAccData.loanDetails[i].branchName ? ownAccData.loanDetails[i].branchName : ""
                    };
                    fundsTransferVm.otherLoansAcc.push(obj);
                }
            }

            fundsTransferVm.odDetails = [];
            var odAccLength = ownAccData.odDetails.length;
            for (var i = 0; i < odAccLength; i++) {
                if (ownAccData.odDetails[i].accountNumber) {
                    var obj = {
                        img: constantConfig.SBILogo,
                        accountType: ownAccData.odDetails[i].accountType ? ownAccData.odDetails[i].accountType : "",
                        accountNo: ownAccData.odDetails[i].accountNumber ? ownAccData.odDetails[i].accountNumber : "",
                        availableBalance: ownAccData.odDetails[i].availableBalance ? ownAccData.odDetails[i].availableBalance : "",
                        loanAmount: ownAccData.odDetails[i].loanAmount ? ownAccData.odDetails[i].loanAmount : "",
                        sanctionedAmount: ownAccData.odDetails[i].sanctionedAmount ? ownAccData.odDetails[i].sanctionedAmount : "",
                        interest: ownAccData.odDetails[i].interest ? ownAccData.odDetails[i].interest : "",
                        branchName: ownAccData.odDetails[i].branchName ? ownAccData.odDetails[i].branchName : "",
                        branchCode: ownAccData.odDetails[i].branchCode ? ownAccData.odDetails[i].branchCode : "",
                        status: ownAccData.odDetails[i].status ? ownAccData.odDetails[i].status : "",
                        operational: ownAccData.odDetails[i].availableBalance ? ownAccData.odDetails[i].availableBalance : "",
                        accountCategory: ownAccData.odDetails[i].accountCategory ? ownAccData.odDetails[i].accountCategory : "",
                        tenure: ownAccData.odDetails[i].tenure ? ownAccData.odDetails[i].tenure : ""
                    };
                    fundsTransferVm.odDetails.push(obj);
                }
            };

            var allOwnAccounts = (fTBeneficiaryService.payingFrom.concat(fundsTransferVm.myDreamsAcc));
            allOwnAccounts = allOwnAccounts.concat(fundsTransferVm.otherDepositsAcc);
            allOwnAccounts = allOwnAccounts.concat(fundsTransferVm.odDetails);
            allOwnAccounts = allOwnAccounts.concat(fundsTransferVm.otherLoansAcc);
            var allOwnAccountsLen = allOwnAccounts.length;
            for (var i = 0; i < allOwnAccountsLen; i++) {
                allOwnAccounts[i].accountID = i;
                allOwnAccounts[i].ownAccount = 'Y';
                allOwnAccounts[i].bank = 'SBI';
                allOwnAccounts[i].intraBankFlag = "Y";
            }

            fTBeneficiaryService.beneficiaries.ownAccItems = allOwnAccounts;
            fundsTransferVm.ownAccItems = allOwnAccounts;
            setTransferTypes();
        };

        fundsTransferVm.setSearchImages = function() {
            var listType = fTBeneficiaryService.beneficiaries.otherAccItems;
            for (var i in listType) {
                loop2: for (var j in fundsTransferVm.picDocImages) {
                    var picInList = fundsTransferVm.picDocImages[j]["id"];
                    if ((listType[i]["picDocId"].toString()) && (picInList.indexOf(listType[i]["picDocId"].toString()) != -1)) {
                        fTBeneficiaryService.beneficiaries.otherAccItems[i].img = "data:image/jpeg;base64," + fundsTransferVm.picDocImages[j]["data"];
                        break loop2;
                    }
                }
            }

            var listType = fTBeneficiaryService.beneficiaries.freqTransItems;
            for (var i in listType) {
                loop2: for (var j in fundsTransferVm.picDocImages) {
                    var picInList = fundsTransferVm.picDocImages[j]["id"];
                    if ((listType[i]["picDocId"].toString()) && picInList.indexOf(listType[i]["picDocId"].toString()) != -1) {
                        fTBeneficiaryService.beneficiaries.freqTransItems[i].img = "data:image/jpeg;base64," + fundsTransferVm.picDocImages[j]["data"];
                        break loop2;
                    }
                }
            }
            fTBeneficiaryService.imagesLoaded = true;
        };

        //get all picDocId and beneficiary image data
        fundsTransferVm.searchImage = function() {
            if ((!fTBeneficiaryService.beneficiaries)) {
                return true;
            }
            if (fTBeneficiaryService.imagesLoaded) {
                fundsTransferVm.setSearchImages();
                return true;
            }
            var updatePicData = {};
            fTBeneficiaryService.searchBeneficiaryPicture(updatePicData, false).then(function(response) {
                                        fundsTransferVm.picDocImages = response;
                                        fundsTransferVm.setSearchImages();
            }, function(error) {
                                        console.log(error);
                                    });
                                };
        /* Clear the Search field */
        $scope.clearSearch = function() {
            fundsTransferVm.searchText = "";
        };

        /**
         * Edit Beneficiary
         *
         * @param {object}
         *        account
         * @param {string}
         *        accountType
         */
        $scope.editAccount = function(account, accountType) {
            fTBeneficiaryService.customer.nameData = account.name;
            fTBeneficiaryService.customer.selectedBank = account.bank;
            if (accountType === constantConfig.ft.scheduledTracsfText) {
                fTBeneficiaryService.customer.conImg = account.picDocId;
                fTBeneficiaryService.customer.siId = account.siId;
                fTBeneficiaryService.customer.nickName = account.nickName;
                fTBeneficiaryService.customer.benType = account.type;
                fTBeneficiaryService.customer.accountNoData = account.accountNo;
                fTBeneficiaryService.customer.fromAccNumber = account.fromAccNumber;
                fTBeneficiaryService.customer.mmid = account.mmid;
                fTBeneficiaryService.customer.mobileNo = account.mobileNumber;
                fTBeneficiaryService.customer.remMMID = account.remMMID;
                fTBeneficiaryService.customer.intraBankFlag = account.intraBankFlag;
                fTBeneficiaryService.customer.remarks = account.remarks;
                fTBeneficiaryService.customer.scheduleDate = account.scheduledDate;
                fTBeneficiaryService.customer.scheduledTransferAmount = account.scheduledTransferAmount.toFixed(2);
                fTBeneficiaryService.customer.siFrequency = account.siFrequency;
                fTBeneficiaryService.customer.siCount = account.siCount;
                fTBeneficiaryService.customer.transFee = account.charges;
                fTBeneficiaryService.customer.isOwnAccntFlag = account.isOwnAccntFlag;
                fTBeneficiaryService.customer.maxLimit = account.maxLimit;
                fTBeneficiaryService.customer.benStatus = account.benStatus;
                
                $state.go('menu.fTEditScheduleDetails');
            } else {
                if (account.isActive == 'Y') {
                    fTBeneficiaryService.customer.imgData = (account.img === constantConfig.ft.defaultBenImg) ? constantConfig.ft.defaultEditBenImg : account.img;
                    fTBeneficiaryService.customer.accountNoData = account.accountNo;
                    fTBeneficiaryService.customer.mobileNo = account.mobileNumber;
                    fTBeneficiaryService.customer.nickName = utilityService.isUndefined(account.nickName) ? account.name : account.nickName;
                    fTBeneficiaryService.customer.mmid = account.mmid;
                    fTBeneficiaryService.customer.ifsc = account.ifscCode;
                    fTBeneficiaryService.customer.benType = account.benType;
                    fTBeneficiaryService.customer.intraBankFlag = account.intraBankFlag;
                    fTBeneficiaryService.customer.maxLimit = account.maxLimit;
                    fTBeneficiaryService.customer.conImg = account.picDocId;
                    fTBeneficiaryService.customer.benStatus = account.benStatus;
                    //Common function to check profile password is set or not.
                    fundsTransferVm.checkProfilePasswordFlag("menu.ftEditProfilePassword");
                } else {
                    var title = '';
                    var onTap = '';
                    var message = '<span translate="BEN_NOT_ACTIVE"></span>';
                    fTBeneficiaryService.showErrorModal(title, null, onTap, $scope, $state, message);
                }
            }
        };

        /* Get benificiery for Selected Transfer Type */
        var setTransferTypes = function() {
            if (fundsTransferVm.freqTransItems && fundsTransferVm.freqTransItems.length > 0) {
                fundsTransferVm.accountTypes.push(constantConfig.ft.ftText);
                fundsTransferVm.accountTypes = removeDuplicates(fundsTransferVm.accountTypes);
            }
            if (fundsTransferVm.otherAccItems && fundsTransferVm.otherAccItems.length > 0) {
                fundsTransferVm.accountTypes.push(constantConfig.ft.otherAccText);
                fundsTransferVm.accountTypes = removeDuplicates(fundsTransferVm.accountTypes);
            }
            if (fundsTransferVm.ownAccItems && fundsTransferVm.ownAccItems.length > 0) {
                fundsTransferVm.accountTypes.push(constantConfig.ft.ownAccText);
                fundsTransferVm.accountTypes = removeDuplicates(fundsTransferVm.accountTypes);
            }
        };

        function removeDuplicates(arr) {
            return arr.filter(
                function(item, index, inputArray) {
                    return inputArray.indexOf(item) == index;
                }
            );
        }

        //set base64 image to beneficiary
        var setBitImg = function(listType) {
            for (var i in listType) {
                for (var j in fundsTransferVm.picDocImages) {
                    var picInList = fundsTransferVm.picDocImages[j]["id"].replace('{', '').replace('}', '');
                    if (picInList == listType[i]["picDocId"]) {
                        fundsTransferVm.selectedAcctype[i]["img"] = "data:image/jpeg;base64," + fundsTransferVm.picDocImages[j]["data"];
                    }
                }
            }
        }

        /**
         * toggle Selected Transfer Type
         */
        $scope.toggleGroup = function(accountType, account) {
            if (account) {
                if ((account.ownAccount == 'Y') && ((account.isActive === false || account.isTransactional === false ||
                    (account.status == "")))) {
                    return true;
                }
            }
            if ($scope.isGroupShown(accountType)) {
                $scope.shownGroup = null;
            } else {
                $scope.shownGroup = accountType;
            }
            if ($scope.shownGroup === constantConfig.ft.ftText) {
                var listType = fundsTransferVm.freqTransItems;
                fundsTransferVm.selectedAcctype = fundsTransferVm.freqTransItems;

            } else if ($scope.shownGroup === constantConfig.ft.otherAccText) {
                fundsTransferVm.selectedAcctype = fundsTransferVm.otherAccItems;

            } else if ($scope.shownGroup === constantConfig.ft.scheduledTracsfText) {
                fundsTransferVm.selectedAcctype = fundsTransferVm.schTransItems;

            } else if ($scope.shownGroup === constantConfig.ft.ownAccText) {
                fundsTransferVm.selectedAcctype = fundsTransferVm.ownAccItems;
            } else {
                fundsTransferVm.selectedAcctype = null;
            }
        };

        /**
         * show the Select transfer type
         */
        $scope.isGroupShown = function(accountType) {
            return ($scope.shownGroup === accountType);
        };

        /**
         * Delete Selected Beneficiary
         */
        $scope.deleteAccount = function(account, array, index) {
            account.benStatus = "";
            if (account.isActive == 'Y') {
                account.benStatus = "ACTIVATED";
                $scope.arrayIndex = index;
                $scope.arrayDel = array;
                $scope.siId = account.siId;
                $scope.name = account.name || '';
                fundsTransferVm.deletBenAccount = account;
                fundsTransferVm.deletBenArray = array;
                fundsTransferVm.deletBenIndex = index;

                $scope.scheduledTransferAmount = account.scheduledTransferAmount || 0;
                if (array == fundsTransferVm.schTransItems) {
                    fundsTransferVm.cancelPopup();
                } else {

                    fundsTransferVm.detletBeneficieryPopup = $ionicPopup.show({
                        title: '',
                        cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
                        templateUrl: 'pages/fundTransfer/fundsTransfer/delBenPopup.html',
                        scope: $scope
                    });
                }
            } else {
                var title = '';
                var onTap = '';
                var message = '<span translate="BEN_NOT_ACTIVE"></span>';
                fTBeneficiaryService.showErrorModal(title, null, onTap, $scope, $state, message);
            }
        };

        fundsTransferVm.deteleBeneficieryData = function() {
            fundsTransferVm.detletBeneficieryPopup.close();
            var accountData = fundsTransferVm.deletBenAccount;
            var arrayData = fundsTransferVm.deletBenArray;
            var indexData = fundsTransferVm.deletBenIndex;

            fTBeneficiaryService.deleteBeneficiary(accountData).then(function(data) {
                try {
                    var deletePicData = {
                        "id": accountData.picDocId.slice(1, -1) || ''
                    }
                    fTBeneficiaryService.deleteBeneficiaryPicture(deletePicData).then(function(response) {}, function(error) {});
                    fundsTransferVm.deleteConfirmationPopup();
                } catch (e) {}
            }, function(error) {
                fundsTransferVm.detletBeneficieryPopup.close();
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        /* To cancel Scheduled Payment */
        fundsTransferVm.goCancel = function() {
            fundsTransferVm.cancelPopupName.close();
            fundsTransferVm.cancelName = $scope.name;
            fundsTransferVm.cancelAmount = $scope.scheduledTransferAmount;

            cancelScheduledPaymentService.cancelData($scope.siId).then(function(data) {
                try {
                    fundsTransferVm.cancelconfirmPopup();
                } catch (e) {}
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        /* To Delete beneficiary confirmation popup */
        fundsTransferVm.deleteConfirmationPopup = function() {
            fTBeneficiaryService.schTransItems = "";
            fTBeneficiaryService.beneficiaries = "";
            fundsTransferVm.delName = $scope.name;
            fundsTransferVm.deleteConfirmationPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
                templateUrl: 'pages/fundTransfer/fundsTransfer/delBenConfirmPopup.html',
                scope: $scope
            });
        };
        /* To cancel Scheduled Payment popup */
        fundsTransferVm.cancelPopup = function() {
            fundsTransferVm.cancelPopupName = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
                templateUrl: 'pages/fundTransfer/fundsTransfer/fTCancelPopup.html',
                scope: $scope
            });
        };

        //Function for close view
        fundsTransferVm.closeView = function() {
            $state.go('menu.homeScreen');
        }

        fundsTransferVm.closeProfilePwdView = function() {
            $state.go('menu.fundsTransfer');
        }

        /* To Confirm the Cancel Scheduled Payment popup*/
        fundsTransferVm.cancelconfirmPopup = function() {
            fundsTransferVm.cancelConfirmPopupName = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
                templateUrl: 'pages/fundTransfer/fundsTransfer/fTCancelConfirmPopup.html',
                scope: $scope
            });
        };


        fundsTransferVm.cancelConfirm = function() {
            fTBeneficiaryService.schTransItems = "";
            fTBeneficiaryService.beneficiaries = "";
            fundsTransferVm.cancelConfirmPopupName.close();
            fundsTransferVm.initPage();
            $state.go('menu.fundsTransfer');
        };

        fundsTransferVm.goToBack = function() {
            fundsTransferVm.cancelPopupName.close();
            $state.go('menu.fundsTransfer');
        };
        fundsTransferVm.goToPrevious = function() {
            $ionicHistory.goBack();
        };

        fundsTransferVm.goToHome = function() {
          if(homeScreenService.ishamMenu===true){
                //$state.go("menu.homeScreen");
                $ionicHistory.goBack();
      			homeScreenService.ishamMenu=false;
      		}else{
                $state.go('menu.fundsTransferLanding');
            }
        }

        fundsTransferVm.closePopup = function() {
            fundsTransferVm.detletBeneficieryPopup.close();
        };
        fundsTransferVm.deleteConfirm = function() {
            fundsTransferVm.deleteConfirmationPopup.close();
            fTBeneficiaryService.schTransItems = "";
            fTBeneficiaryService.beneficiaries = "";
            fundsTransferVm.initPage();
            $state.go('menu.fundsTransfer');
        };


        /**
         * Navigate to Payment Page
         */
        fundsTransferVm.goToPay = function (accountType, img, name, bank, accountNo, account) {
        fTBeneficiaryService.customer.accountType = accountType;
	    fTBeneficiaryService.customer.credAcType =account.accountType;
            //YonoIt- 1966 if condition added
             //YonoIt- 1966 if condition added
            var onlyAlphaNumericForInterBank = /^[a-zA-Z0-9\s]+$/;
            var accountNickName = account.nickName;
            if (accountType === constantConfig.ft.ownAccText && fundsTransferVm.ownAccItems.length < 2) {
                return false;
            } else {
                if (account.ownAccount && account.ownAccount == 'Y') {
                    account.name = customerInfoService.customer.name;
                    name = customerInfoService.customer.name;
                    if ((fTBeneficiaryService.payingFrom.length) == 1 ||
                        (fTBeneficiaryService.payingFrom.length) == 0) {
                        for (var acc in fTBeneficiaryService.payingFrom) {
                            if (fTBeneficiaryService.payingFrom[acc]["accountNo"] === account.accountNo) {
                                utilityService.showErrorMessage("The From and To account can not be same.");
                                return true;
                            }
                        }
                    }
                    if (account.isActive === false || account.isTransactional === false ||
                        (account.status == "")) {
                        $translate('INACTIVE_ACCOUNT').then(function (transValue) {
                            utilityService.showErrorMessage(transValue);
                        });
                        return true;
                    }
                   
                    if(name && !name.match(onlyAlphaNumericForInterBank))
                       {
                        utilityService.showErrorMessage(constantConfig.ft.ownAccValidationError);
                        return true;
                       } 

                } else {
                    if (account.isActive && account.isActive === 'N') {
                        $translate('INACTIVE_ACCOUNT').then(function (transValue) {
                            utilityService.showErrorMessage(transValue);
                        });
                        return true;
                    }
                   
                    if((accountNickName && !accountNickName.match(onlyAlphaNumericForInterBank)))
                    {
                        utilityService.showErrorMessage("It appears the beneficiary name / nickname contains some special characters. Please remove the same and retry.");
                        return true;
                    }
           
                }
                fTBeneficiaryService.customer.conImg = img;
                fTBeneficiaryService.customer.accountCategory = account.accountCategory ? account.accountCategory : "";
                fTBeneficiaryService.customer.nameData = name;
                fTBeneficiaryService.customer.accountTypeData = accountType;
                fTBeneficiaryService.customer.transAmount = fTBeneficiaryService.minAmount;
                fTBeneficiaryService.customer.mobileNo = account.mobileNumber;
                fTBeneficiaryService.customer.nickName = account.nickName;
                fTBeneficiaryService.customer.benType = account.benType;
                fTBeneficiaryService.customer.ifsc = account.ifscCode;
                fTBeneficiaryService.customer.maxLimit = account.maxLimit;
                fTBeneficiaryService.customer.intraBankFlag = account.intraBankFlag;
                fTBeneficiaryService.customer.ownAccount = account.ownAccount;
                fTBeneficiaryService.customer.mmid = account.mmid;
                fTBeneficiaryService.customer.isActive = account.isActive;
                fTBeneficiaryService.customer.creditTypeCode = account.accountTypeCode;
                fTBeneficiaryService.customer.creditIntCategory = account.intCategory;
                fTBeneficiaryService.customer.benStatus = account.benStatus;
                if (accountType === constantConfig.ft.ftText) {
                    fTBeneficiaryService.customer.remarks = account.remarks;
                    fTBeneficiaryService.customer.frequentAmount = account.frequentAmount;
                } else {
                    fTBeneficiaryService.customer.remarks = "";
                    fTBeneficiaryService.customer.frequentAmount = "";
                }
                if (accountType === constantConfig.ft.scheduledTracsfText) {
                    fTBeneficiaryService.customer.bankData = account.bank;
                    fTBeneficiaryService.customer.accountNoData = account.accountNo;
                    fTBeneficiaryService.customer.scheduleDate = account.scheduledDate;
                    fTBeneficiaryService.customer.scheduledTransferAmount = account.scheduledTransferAmount;
                    fTBeneficiaryService.customer.fromAccType = account.fromAccType;
                    fTBeneficiaryService.customer.fromAccNumber = account.fromAccNumber;
                    fTBeneficiaryService.customer.fromAccBalance = account.fromAccBalance;
                    fTBeneficiaryService.customer.transFee = account.charges;
                    fTBeneficiaryService.customer.transactionId = account.transactionId;
                    fTBeneficiaryService.customer.remarks = account.remarks;
                    fTBeneficiaryService.customer.ownAccItems = fundsTransferVm.ownAccItems;
                    $state.go('menu.fTEditScheduleDetails');
                } else {
                    fTBeneficiaryService.customer.bankData = bank;
                    fTBeneficiaryService.customer.accountNoData = accountNo;
                    $state.go('menu.fTPaymentDetails');
                }
                fTBeneficiaryService.checkBox = "";
            }
           
        };

        /* Navigate to QRCode Page */
        fundsTransferVm.goToUpiPay = function() {
            if (device.platform.toLowerCase() == 'android') {
                $state.go('menu.upiPay');
            } else if (device.platform.toLowerCase() == 'windows') {
                ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
            } else {
                //ionicToast.show("The functionality is not available in iOS currently.", 'bottom', false, 3000);
                var comingsoonPopup = $ionicPopup.alert({
                    template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                               +"Coming Soon"+ '</div></div></div></div></div></div>',
                    cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                    buttons: [
                        {
                            text: 'OK',
                            type: 'button-positive',
                                               onTap: function(e) {
                                comingsoonPopup.close();
                                $state.go("menu.fundsTransferLanding");
                            }
                        }
                    ]
                });
            }
        };

        fundsTransferVm.checkProfilePasswordFlag = function(page){
            profPassObj = {
                prevPage:"menu.fundsTransfer",
                nextPage:page,
                goto:"menu.setProfilePassword",
                ionicPopup:$ionicPopup,
                accOverviewData:accOverviewData
            };
            getAccountDetailsService.commonfunForProfilePassCheck(profPassObj);
            }

        /* Navigate to New Beneficiary Page */
        fundsTransferVm.goToNewBeneficiary = function() {
            fundsTransferVm.checkProfilePasswordFlag("menu.ftProfilePassword");
        };
 

        	fundsTransferVm.toggleSecretAns = function () {
			fundsTransferVm.isTextReadable == true ? fundsTransferVm.isTextReadable = false : fundsTransferVm.isTextReadable = true;
		};
		fundsTransferVm.toggleReEnter = function () {
			fundsTransferVm.isTextReadablereEnter == true ? fundsTransferVm.isTextReadablereEnter = false : fundsTransferVm.isTextReadablereEnter = true;
		};
   
	     fundsTransferVm.forgotpassPopup = function (){
            	var havingMPINPrblmPopUp = $ionicPopup.show({
				template: "<p> If you have forgotton your profile password, you can reset the same yourself. You need to  authenticate yourself either with the hint question and answer that you had set for the Profile password or ATM Card details & PIN. You can approach branch in case you don't remember Hint Question/answer or ATM card details & PIN </p>",
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive'
				}]
			});
        };
            fundsTransferVm.profilePopup = function () {
        			fundsTransferVm.myPopup = $ionicPopup.show({
        				title: '',
        				cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
        				templateUrl: 'pages/fundTransfer/fundsTransfer/pwdPopup.html',
        				scope: $scope
        			});
        		}
            fundsTransferVm.ok = function () {
              fundsTransferVm.myPopup.close();
            };
       fundsTransferVm.forgotPass = function (){
             $state.go('menu.forgotProfilePwd');
        }
           fundsTransferVm.validateProfilePwd = function() {
            var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
            if (fundsTransferVm.newProfilePassword) {
                fTReviewService.getProfilePassAndSerKey().then(function (response) {
                     var options = {
						inbUserName:loggedInUserDetails.inbUsername,
						strPass:fundsTransferVm.newProfilePassword,
						keyId:response.keyId,
						serviceId:response.serviceId,
						osName:device.platform
					};
					var reqParams = utilityService.commonRequestForValidateProfilePass(options);
                    fTReviewService.getProfilePassAuth(reqParams).then(function (data) {
                        $state.go('menu.fTHowToPayTheBeneficiary');
                    }, function(error) {
                        //utilityService.showErrorMessage(error.responseMessage);
                        if (error.responseCode == "INB.AUTH.016") {
                            fundsTransferVm.myPopup = $ionicPopup.show({
                                title: '',
                                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
                                templateUrl: 'pages/fundTransfer/fundsTransfer/profilePassUnblockPopUp.html',
                                scope: $scope
                            })
                        } else {
                            utilityService.showErrorMessage(error.responseMessage);
                        }
                    });
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                utilityService.showErrorMessage('Please enter your Internet Banking Profile Password.')
            }
        };
        // New Access rights changes
        $scope.$on('$ionicView.loaded', function () {
            if (!getAccountDetailsService.accessRightsData.accounts) {
                getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
                    getAccountDetailsService.accessRightsData = data;
                }, function (error) {
                    // Failure block
                });
            }
        });
         // New Access rights changes End
        /*actions to done everytime the view is shown*/
        $scope.$on('$ionicView.beforeEnter', function() {
            fTBeneficiaryService.savedImg = "";
            
             fTBeneficiaryService.remarkPurpose="";
             fTBeneficiaryService.remarkOther="";
             
             
            fundsTransferVm.initPage();
            if (fTBeneficiaryService.beneficiaries) {
                fundsTransferVm.fetchOwnAccountDetails();
                if (!fundsTransferVm.picDocImages) {
                    fundsTransferVm.searchImage();
                }
            }
            fTReviewService.isComingFromFTHomePage = true;

            if(!fTBeneficiaryService.config.quickTransferLimit) {
                requestYCService.getWelcomeMessages().then(function (response) {
                    fTBeneficiaryService.config.quickTransferLimit = response.fundsTransfer.benAmountLimit;
                    fundsTransferVm.transferLimit = response.fundsTransfer.benAmountLimit;
                });
            }
            else fundsTransferVm.transferLimit = fTBeneficiaryService.config.quickTransferLimit;
            
        });
	  fundsTransferVm.unblockProfilePassword = function (){
            fundsTransferVm.myPopup.close();
            $state.go('menu.forgotProfilePwd');
        }

        fundsTransferVm.cancel = function (){
            fundsTransferVm.myPopup.close();
            $state.go('menu.homeScreen');
        }
        return this;
    }
]);
