angularApp.controller('delinkPolicyController', [
    "$state",
    "$scope",
    "$ionicPopup",

    function(
        $state,
        $scope,
        $ionicPopup) {

        var delinkPolicyVm = this;

        function initPage() {
            delinkPolicyVm.showBack = false;
            delinkPolicyVm.showNext = true;
            delinkPolicyVm.policyNumber = '72568837';
        } 

        delinkPolicyVm.goBacktoPrevious = function() {
            $state.go("menu.myPolicies");
        }

        delinkPolicyVm.confirmDelink = function() {
                var delinkConfirmationPopup = $ionicPopup.confirm({
                    title: '',
                    templateUrl: 'pages/generalInsurance/common/delinkConfirmation.html',
                    okText: 'Yes',
                    cancelText: 'No',
                    scope: $scope,
                });

                delinkConfirmationPopup.then(function(res) {
                    if (res) {
                        $state.go("menu.myPolicies");
                    } else {
                        delinkConfirmationPopup.close()
                    }
                });
            }
            
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        
        $scope.$on('$ionicView.beforeEnter', function() {
        });

        $scope.$on('$ionicView.afterLeave', function() {
        });
        return this;
    }
]);
