angularApp.controller('myPoliciesController', [
    "$state",
    "$scope",
    "$translate", "$ionicPopup", "$filter", "generalInsurenceHomeService", "utilityService", "generalInsurenceHealthService","openUrlInAppbroswerService",
    "arogyaSanjeevaniService","homeScreenService","GIconstant","pailinkingRenwalService","irctcService",


    function(
        $state,
        $scope,
        $translate, $ionicPopup, $filter, generalInsurenceHomeService, utilityService, generalInsurenceHealthService,openUrlInAppbroswerService,
        arogyaSanjeevaniService,homeScreenService,GIconstant,pailinkingRenwalService,irctcService) {

        var myPoliciesVm = this;
        myPoliciesVm.showRenew = false;

        function initPage() {
            myPoliciesVm.constant = GIconstant;
            myPoliciesVm.isArogyaSanjPDFDownloaded = false;
            myPoliciesVm.showStatus = $translate.instant("Active");
            myPoliciesVm.accountDetail = generalInsurenceHomeService.getLinkedpolicyDetailDetails();
            myPoliciesVm.newAccountDetail={};
			myPoliciesVm.newAccountDetail.productId = generalInsurenceHomeService.getProductID() ? generalInsurenceHomeService.getProductID(): generalInsurenceHomeService.getLinkedpolicyDetailDetailsNew() ? generalInsurenceHomeService.getLinkedpolicyDetailDetailsNew().productId : "";
            var currentDate = generalInsurenceHomeService.getCurrentDate();
            var getPastMonth = generalInsurenceHomeService.getFutureMonth(currentDate, -1);
            var policyEndDatePastMonth = generalInsurenceHomeService.getFutureMonth(new Date(myPoliciesVm.accountDetail.policyValidUntil), -1);
            var policyValidTill = new Date(myPoliciesVm.accountDetail.policyValidUntil);
            myPoliciesVm.accountDetail.displayDob = $filter('chosenDate')(myPoliciesVm.accountDetail.dob);
            myPoliciesVm.accountDetail.displayRenewalDate = $filter('chosenDate')(myPoliciesVm.accountDetail.policyValidUntil);
            myPoliciesVm.accountDetail.displayRenewalDueDate = $filter('chosenDate')(myPoliciesVm.accountDetail.renewalDate);
            

            if (myPoliciesVm.accountDetail.uin) {
                myPoliciesVm.productType = myPoliciesVm.accountDetail.uin;
            } else {
                myPoliciesVm.productType = generalInsurenceHomeService.getProductDetail().uin;

            }

            if (new Date(currentDate).getTime() >= new Date(policyEndDatePastMonth).getTime() && myPoliciesVm.productType !='22' && myPoliciesVm.productType !='55') {
                myPoliciesVm.showRenew = true;
            } else {
                myPoliciesVm.showRenew = false;
            }
			
			 // if (new Date(currentDate).getTime() > new Date(myPoliciesVm.accountDetail.policyValidUntil).getTime()){
				//  myPoliciesVm.showStatus = "Expired";
			 // }else{
				//  myPoliciesVm.showStatus = "Active";
			 // }
            myPoliciesVm.showStatus=myPoliciesVm.accountDetail.realTimeStatus;
            switch (myPoliciesVm.productType) {
                case '12':
                    myPoliciesVm.policyTitle = $translate.instant("CI_PURCHASE_SUIMMARY");
                    myPoliciesVm.productName = $translate.instant("CI_PRODUCT");
                    break;
                case '11':
                    myPoliciesVm.policyTitle = $translate.instant("AP_PURCHASE_SUIMMARY");
                    myPoliciesVm.productName = $translate.instant("AP_PRODUCT");
                    break;
                case '14':
                    myPoliciesVm.policyTitle = $translate.instant("SH_PURCHASE_SUIMMARY");
                    myPoliciesVm.productName = $translate.instant("SH_PRODUCT");
                    break;
                case '13':
                    myPoliciesVm.policyTitle = $translate.instant("HDC_PURCHASE_SUIMMARY");
                    myPoliciesVm.productName = $translate.instant("HDC_PRODUCT");
                    break;
                case '22':
                    myPoliciesVm.policyTitle = $translate.instant("LTH_PURCHASE_SUIMMARY");
                    myPoliciesVm.productName = $translate.instant("LTH_PRODUCT");
                    break;
                case '31':
                    myPoliciesVm.policyTitle = $translate.instant("M4W_PURCHASE_SUIMMARY");
                    myPoliciesVm.productName = $translate.instant("M4W_PRODUCT");
                    break;
                case '32':
                    myPoliciesVm.policyTitle = $translate.instant("M2W_PURCHASE_SUIMMARY");
                    myPoliciesVm.productName = $translate.instant("M2W_PRODUCT");
                    break;
                case '44':
                    myPoliciesVm.policyTitle = $translate.instant("PAI_PURCHASE_SUIMMARY");
                    myPoliciesVm.productName = $translate.instant("PAI_PRODUCT");
                    break;
                case '55':
                    myPoliciesVm.policyTitle = $translate.instant("TI_PURCHASE_SUIMMARY");
                    myPoliciesVm.productName = $translate.instant("TI_PRODUCT");
                    break;
                case '15':
                    myPoliciesVm.policyTitle = $translate.instant("ARSA_PURCHASE_SUIMMARY");
                    myPoliciesVm.productName = $translate.instant("ARSA_PRODUCT");
                    break;
                case '16':
                    myPoliciesVm.policyTitle = $translate.instant("SA_PURCHASE_SUMMARY");
                    myPoliciesVm.productName = $translate.instant("SA_PRODUCT");
                    break;
                case '23':
                    myPoliciesVm.policyTitle = $translate.instant("GI_BGR_POLICY_TITLE");
                    myPoliciesVm.productName = $translate.instant("GI_BGR_PRODUCT_NAME");
                    break;
            }
        }


        function showPopUp() {
            var alertPopup = $ionicPopup.alert({
                title: '',
                templateUrl: 'pages/generalInsurance/common/delinkpopup.html',
                scope: $scope
            });
            alertPopup.then(function(res) {
                homeScreenService.isInsuranceFlag=true;
                 pailinkingRenwalService.cloudantPai = "";
                $state.go("menu.accountOverviewMyBalance");
            });
        }

        myPoliciesVm.delink = function() {
            var templates = 'Do you want to Delink a Policy ?';
            var alertPopup = $ionicPopup.alert({
                title: 'Delink',
                template: templates,
                scope: $scope,
                cssClass: 'sbi-alert-popup',
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function(e) {
                        return false;
                    }

                }, {
                    text: 'Delink',
                    type: 'button-positive',
                    onTap: function(e) {
                        return true;
                    }
                }]

            });
            alertPopup.then(function(res) {
                if (res) {
                    var getDelink = {
                        "policyNumber": myPoliciesVm.accountDetail.policyNo,
                        "productId": myPoliciesVm.newAccountDetail.productId.toString()
                    }
                    generalInsurenceHealthService.getDelink(getDelink).then(function(data) {
                            myPoliciesVm.popupdata = "Your policy has been delinked";
                            showPopUp();
                        },function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                }
            });
        }

        myPoliciesVm.goBack = function() {
            homeScreenService.isInsuranceFlag = true;
            $state.go("menu.accountOverviewMyBalance");
        }

        myPoliciesVm.claimStatus = function() {
            utilityService.hideSpinner();
            var policyNo = generalInsurenceHomeService.getOnlinePolicy();
            var claimstatus = {
                "dbUtilsIORequest": {
                    "request": {
                        "action": "CLAIMINTIMATION",
                        "productType": myPoliciesVm.accountDetail.policyNo
                    }
                }
            }

            generalInsurenceHealthService.getClaimStatus(claimstatus).then(function(data) {
                    if (data && data.dbUtilsIOResponse && data.dbUtilsIOResponse.length > 0) {
                        myPoliciesVm.popupdata = data.dbUtilsIOResponse[0].policyStatus;
                        showPopUp();
                    }
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
        }


        myPoliciesVm.showModal = function() {
            $scope.modal.show();
        }
        myPoliciesVm.showClaimIntimation = function() {
            $scope.modal.hide();
            $state.go("menu.claimIntimation");
        }

        function b64toBlob(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        }


        function savebase64AsPDF(filepath, filename, content, contentType) {
            var DataBlob = b64toBlob(content, contentType);
            var errorInvalidSize = "Invalid File Size";
            if(utilityService.isAndroidPlatform()) {
                if(device.version==10){
                    const folderpath = cordova.file.externalDataDirectory;
                    myPoliciesVm.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory,"") + filename;
                    window.resolveLocalFileSystemURL(folderpath, function(dir) {
                        dir.getFile(filename, { create: true }, function(file) {
                            file.createWriter(function(fileWriter) {
                                if (DataBlob.size >= myPoliciesVm.constant.ArogyaSanjeevani.MIN_FILE_LENGTH && DataBlob.size <= myPoliciesVm.constant.ArogyaSanjeevani.MAX_FILE_LENGTH) {
                                    fileWriter.write(DataBlob);
                                    myPoliciesVm.showDownloadPopUp();
                                } else {
                                    arogyaSanjeevaniService.displayPopUp("", "padBtm25 top-padding26", errorInvalidSize, "OK",
                                        function () { }
                                    );
                                }
                            }, function() {});
                        });
                    });
                }
                else{
                    //for Android below 10 and Android 11 not for 10
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
                        fileSystem.root.getDirectory("Download", {create: true, exclusive: false},function(dir) {
                            myPoliciesVm.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true, exclusive: false }, function(file) {
                                file.createWriter(function(fileWriter) {
                                    if (DataBlob.size >= myPoliciesVm.constant.ArogyaSanjeevani.MIN_FILE_LENGTH && DataBlob.size <= myPoliciesVm.constant.ArogyaSanjeevani.MAX_FILE_LENGTH) {
                                        fileWriter.write(DataBlob);
                                        myPoliciesVm.showDownloadPopUp();
                                    } else {
                                        arogyaSanjeevaniService.displayPopUp("", "padBtm25 top-padding26", errorInvalidSize, "OK",
                                            function () { }
                                        );
                                    }
                                }, function() {});
                            });
                        });
                    });
                }

                
            }
        }

        myPoliciesVm.showDownloadPopUp = function() {
            //Show popup 
                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PAI_DOWNLOAD_RECEIPT" translate-values="{filePath:myPoliciesVm.popupFolderpath}"></div>';
                myPoliciesVm.downloadPopup = $ionicPopup.show({
                    title: '',
                    template: template,
                    scope: $scope,
                    cssClass: 'my-custom-popup',
                    buttons: [{
                        text:'OK',
                        type: 'button-assertive',
                        onTap: function() { 
                            myPoliciesVm.downloadPopup.close();

                        }
                    }],
                });
        }

        myPoliciesVm.viewAndDownload = function() {
			utilityService.hideSpinner();
            if (myPoliciesVm.accountDetail.uin == "44") {
                var PAIpdf = {
                    "id": "",
                    "policyNo": myPoliciesVm.accountDetail.policyNo,
                    "productId": myPoliciesVm.newAccountDetail.productId
                }				
                generalInsurenceHomeService.getPlan(PAIpdf).then(function(detail) {
					utilityService.showSpinner();
                    pdfGenration(detail.base64, "PersonalAccidentInsurance.pdf");
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else if(myPoliciesVm.accountDetail.uin == "15" || myPoliciesVm.accountDetail.uin == "16" || myPoliciesVm.accountDetail.uin == "23"){
                var request = {
                    "policyNumber" : myPoliciesVm.accountDetail.policyNo,
                    "isEmail" : false
                };
                arogyaSanjeevaniService.getPaymentAcknowledgeSlip(request).then(function(res){
                    myPoliciesVm.isArogyaSanjPDFDownloaded = true;
                    utilityService.showSpinner();
                    pdfGenration(res.arogyaSanjeevani.base64Pdf,res.arogyaSanjeevani.name);
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);             
                })
            } else {
                var data = {
                    "docSearchRequest": {
                        "strValue": myPoliciesVm.accountDetail.policyNo
                    }
                }
                generalInsurenceHomeService.getDocSearch(data).then(function(detail) {
                    if (detail.docSearchResponse && detail.docSearchResponse.url) {
                        var downloadUrl = detail.docSearchResponse.url[0].value.split(';');
                        if (detail.docSearchResponse.url.length == 1) {

                            var title = $translate.instant('Record Not avalabile now');
                            var buttontext = "OK";
                            var blankdata = null;
                            var detail = $translate.instant('SelectVity');
                            utilityService.showAlertModal(title, downloadUrl[0], blankdata, blankdata, $state, buttontext)


                        } else {
                            var content = detail.docSearchResponse.url[1].value;
                            var filename = detail.docSearchResponse.url[0].value;
                            pdfGenration(content, filename);
                        }
                    }

                    
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        function pdfGenration(content, filename) {
			utilityService.hideSpinner();
            var contentType = "application/pdf";
            if (utilityService.isAndroidPlatform()) {
                myPoliciesVm.android = true;
                myPoliciesVm.folderpath = cordova.file.externalRootDirectory;
                savebase64AsPDF(myPoliciesVm.folderpath, filename, content, contentType);
            }
            
            if (utilityService.isIOSPlatform()) {
                myPoliciesVm.folderpath = cordova.file.applicationDirectory;
                irctcService.savebase64AsPDF(myPoliciesVm.folderpath,filename,content,contentType);
                openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
            }
            
        }

      

        myPoliciesVm.showDelinkPolicy = function() {
            $scope.modal.hide();
            $state.go("menu.delinkPolicy");
        }

        /*function renewPolicys(detailvalue) {
            var detail = {
                "quoteDetailRequest": {
                    "request": {
                        "quoteNo": detailvalue.renewalService.renewalQuoteNumber
                    }
                }
            }
            generalInsurenceHomeService.getQuoteDetail(detail).then(function(data) {
                generalInsurenceHomeService.setRenewDetail(data);
                $state.go('menu.basicInformation');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }*/



        myPoliciesVm.renewPolicy = function() {
            utilityService.hideSpinner();
			generalInsurenceHomeService.renewClickedFlag = true;
			if(myPoliciesVm.productType == '44'){
				var renewDetail = {
					"policyNo": myPoliciesVm.accountDetail.policyNo
				}
				generalInsurenceHomeService.getPAIRenewalDetails(renewDetail).then(function(data) {
					generalInsurenceHomeService.setRenewDetail(data);
					$state.go('menu.basicInformation');
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}else{
				var renewDetail = {
					"renewalService": {
						"policyNumber": myPoliciesVm.accountDetail.policyNo
					}
				}
				generalInsurenceHomeService.getRenewalPolicy(renewDetail).then(function(data) {
					//renewPolicys(data);
					generalInsurenceHomeService.setRenewDetail(data);
					$state.go('menu.basicInformation');
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			
            
        }

        myPoliciesVm.showDetailYears = function(years) {
            if (myPoliciesVm.productType == '55') {
                return ": " + years + "days";
            } else {
                return ": " + years + " Year";
            }
        }

        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        $scope.$on('floating-menu:open', function(event) {
			generalInsurenceHomeService.renewClickedFlag = false;
            var elem = document.querySelectorAll('#floating-backdrop');
            for (var j = 0; j < elem.length; j++) {
                elem[j].className = '';
                elem[j].className = 'backdrop visible active';
            }

        });

        $scope.$on('floating-menu:close', function(event) {
            var elem = document.querySelectorAll('#floating-backdrop');
            for (var j = 0; j < elem.length; j++) {
                elem[j].className = '';
                elem[j].className = 'backdrop';
            }
        });

        myPoliciesVm.cancelPAI = function(){
            var wcmContent;
            if(myPoliciesVm.productType == "44"){
                if(!pailinkingRenwalService.cancelStructure){
                    wcmContent = {
                        "product": "PAI"
                    }
                    pailinkingRenwalService.cancelStructureWCM(wcmContent).then(function(data) {
                        pailinkingRenwalService.cancelStructure = data;
                        $state.go("menu.cancelStructure");
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }else{
                    $state.go("menu.cancelStructure");
                }  
            }else if(myPoliciesVm.productType == "15"){
                if(!pailinkingRenwalService.cancelStructure){
                    wcmContent = {
                        "product": "AS"
                    }
                    pailinkingRenwalService.cancelStructureWCM(wcmContent).then(function(data) {
                        pailinkingRenwalService.cancelStructure = data;
                        $state.go("menu.cancelStructure");
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }else{
                    $state.go("menu.cancelStructure");
                } 
            }
                     
        }

        myPoliciesVm.updatePAI = function(){
            if(myPoliciesVm.accountDetail.uin == "44") {
                if(myPoliciesVm.accountDetail.cancellationRefNo) {
                    var currentDate = new Date();
                    var newCancellationDate = myPoliciesVm.accountDetail.cancellationDate.split(" ")[0];
                    var cancelDate = new Date(newCancellationDate);
                    var Difference_In_Time = currentDate.getTime() - cancelDate.getTime();
                    var Difference_In_Days = Difference_In_Time / (1000 * 3600 * 24);
                    if(Difference_In_Days <= 7) {
                       var errorMssgLine1 = $translate.instant('PCE_UPDATE_ERROR');
                        var errorMssgLine2 = $translate.instant('PCE_CANC_REQ_LODGED');
                        pailinkingRenwalService.errorPopUp(errorMssgLine1, errorMssgLine2, 'menu.myPolicies', '', function () { });   
                    } else {
                        myPoliciesVm.callPAIValidate();
                    }
                } else if(myPoliciesVm.accountDetail.policyStartDate){
                    var currentDateChk = new Date();
                    var policyStartDateChk = new Date(myPoliciesVm.accountDetail.policyStartDate.split(" ")[0]);
                    var Difference_In_TimeChk = policyStartDateChk.getTime() - currentDateChk.getTime();
                    var Difference_In_DaysChk = Difference_In_TimeChk / (1000 * 3600 * 24);
                    if(Difference_In_DaysChk > 1)
                    {
                        pailinkingRenwalService.showError($translate.instant('PCE_ERROR_FUTURE_DATED_POLICY')+myPoliciesVm.getDateFormat(policyStartDateChk));
                    }else{
                        myPoliciesVm.callPAIValidate();
                    }                   
                    
                }else{
                    myPoliciesVm.callPAIValidate();
                }
            }
        }

        myPoliciesVm.callPAIValidate = function() {
            var param = {
                "flow" : "E"
            }
            pailinkingRenwalService.getPaiValidatePolicy(param).then(function(res) {
                var statusCode = res.message.toUpperCase(); 
                 var currentDate = new Date();
                if (res.renewedPolicyinfo && (res.renewedPolicyinfo.journalNo == myPoliciesVm.accountDetail.policyNo)) {
                    var getDateValue = res.renewedPolicyinfo.startDate.split(" ")[0];
                    var futurePolicyDate = getDateObj(getDateValue);
                    if(futurePolicyDate && futurePolicyDate.getTime() >= currentDate.getTime()) {
                        myPoliciesVm.endorsePolicy(res,statusCode);
                    } else { 
                        pailinkingRenwalService.errorPopUp($translate.instant('PCE_UPDATE_ERROR'), '', '', '');
                    }
                } else {
                    myPoliciesVm.endorsePolicy(res,statusCode);
                }              
                }, function(error) {
                    pailinkingRenwalService.paiCanEndPolicyData = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
        }

        myPoliciesVm.endorsePolicy =  function(res, statusCode) {
            if(statusCode == "SE003") {
                if(res.journalNo == myPoliciesVm.accountDetail.policyNo) {
                    pailinkingRenwalService.paiCanEndPolicyData = res;
                    $state.go("menu.paiEndorseDetails");
                } else{
                    pailinkingRenwalService.showError($translate.instant('PCE_TECHICAL_ERROR'));
                }
            } else {
                var errorMssgLine1 = $translate.instant('PCE_UPDATE_ERROR');
                var errorMssgLine2;
                switch (statusCode) {
                    case "EE001":
                        errorMssgLine2 = $translate.instant('PCE_ERROR_001');
                        break;
                    case "EE002":
                        errorMssgLine2 = $translate.instant('PCE_ERROR_002');
                        break;
                    case "EE004":
                        errorMssgLine2 = $translate.instant('PCE_ERROR_004_OR_008');
                        break;  
                    case "EE005":
                        errorMssgLine2 = $translate.instant('PCE_ERROR_005');
                        break;
                    default:
                        errorMssgLine2 = "";
                }
                pailinkingRenwalService.errorPopUp(errorMssgLine1,errorMssgLine2,'menu.myPolicies','', function () { });
            } 
        }

        myPoliciesVm.getDateFormat = function(date) {
            if(date){
                var strArray=['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
                var d = date.getDate();
                var m = strArray[date.getMonth()];
                var y = date.getFullYear();
                return '' + (d <= 9 ? '0' + d : d) + ' ' + m + ' ' + y;
            }else{
                return date;
            }
        }

        myPoliciesVm.displayInfo = function($event, prodType){
            if(prodType == '16' || prodType == '23') {
                pailinkingRenwalService.showPassHintPopUpBGRANDSAR();
            } else {
                pailinkingRenwalService.showPassHintPopUp();
            }
            
        }

        // Converts date string to date object. Only supports ddmmyyyy format
        function getDateObj(dateStr) {
            if(!dateStr || dateStr.length != 8) {
                return null;
            }

            var day = dateStr.substring(0,2);
            var month = dateStr.substring(2,4);
            var year = dateStr.substring(4);

            return new Date(year, month - 1, day);
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
