angularApp.controller('paymentSuccessController', ["$filter",
    "$state",
    "$scope",
    "$stateParams", "generalInsurenceTravelService", "generalInsurenceAccidentService","generalInsurenceHealthService","generalInsurenceHomeService","generalInsurenceMotorService","generalInsurenceHomeDetailService","$translate","clickStreamService",


    function($filter,
        $state,
        $scope,
        $stateParams, generalInsurenceTravelService, generalInsurenceAccidentService,generalInsurenceHealthService,generalInsurenceHomeService,generalInsurenceMotorService,generalInsurenceHomeDetailService,$translate,clickStreamService) {

        var paymentSuccessVm = this;
        var personalDetail,quoteDetail,productUid,policyNumber,sumInsured ;
        var rupeeSymbol = String.fromCharCode(8377);
        var dollarSymbol = String.fromCharCode(36);
        var previousProductDetail,premium;
        paymentSuccessVm.uin = "";

        function initPage() {
           personalDetail = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
           productUid = generalInsurenceHomeService.getProductDetail().uin;
           paymentSuccessVm.productUid = productUid;

           if(productUid =='31' || productUid =='32'){
               clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("GI_MTRPYMTSUC" + "_" + "GIM_MP_END_NXT_BTN")); // motor
                var applicationNumber = generalInsurenceHomeService.getapplicationNumber(); 
                    removeGiApplication(applicationNumber);
           }else if(productUid =='22'){
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("GI_HOMPYMTSUC" + "_" + "GI_LTH_END_NXT_BTN"));//home
                 var applicationNumber = generalInsurenceHomeService.getapplicationNumber(); 
                removeGiApplication(applicationNumber);
           }else if(productUid =='44'){
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("GI_HLTHPYMTSUC" + "_" + "GIH_HI_END_NXT_BTN")); // pai
                    var applicationNumber = generalInsurenceHomeService.getapplicationNumber(); 
                    removeGiApplication(applicationNumber);
           }else if(productUid =='55'){
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("GI_ACDTPYMTSUC" + "_" + "GIH_END_NXT_BTN")); // travel
                    var applicationNumber = generalInsurenceHomeService.getapplicationNumber(); 
                    removeGiApplication(applicationNumber);
           }else if(productUid =='11'){
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("GI_HLTHPYMTSUC" + "_" + "GIH_HI_END_NXT_BTN"));
                    var applicationNumber =    generalInsurenceHomeService.getSaveApplicationArogyaStructure() ? generalInsurenceHomeService.getSaveApplicationArogyaStructure().applicationNumber : "";
                   removeGiApplication(applicationNumber);
           }else if(productUid =='12'){
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("GI_HLTHPYMTSUC" + "_" + "GIH_HI_END_NXT_BTN"));
                    var applicationNumber =     generalInsurenceHomeService.getSaveApplicationCriticalStructure() ? generalInsurenceHomeService.getSaveApplicationCriticalStructure().applicationNumber : "";
                    removeGiApplication(applicationNumber);
           }else if(productUid =='13'){
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("GI_HLTHPYMTSUC" + "_" + "GIH_HI_END_NXT_BTN"));
                    var applicationNumber =    generalInsurenceHomeService.getSaveApplicationHDCStructure() ? generalInsurenceHomeService.getSaveApplicationHDCStructure().applicationNumber : "";
                    removeGiApplication(applicationNumber);
           }else if(productUid =='14'){
                clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("GI_HLTHPYMTSUC" + "_" + "GIH_HI_END_NXT_BTN"));
                var applicationNumber =    generalInsurenceHomeService.getSaveApplicationHealthStructure() ? generalInsurenceHomeService.getSaveApplicationHealthStructure().applicationNumber : "";
                removeGiApplication(applicationNumber);
           }

           

            

           paymentSuccessVm.uin = productUid;
           quoteDetail =  generalInsurenceHealthService.getQuotecalculation();
           

          previousProductDetail =   generalInsurenceHomeService.getLinkedpolicyDetailDetails();
		if(generalInsurenceHomeService.getRenewDetail() && generalInsurenceHomeService.getRenewDetail().isRenewal){
			premium = $filter('rupeeSymbol')(generalInsurenceHomeService.getLinkedpolicyDetailDetails().premiumPaid);
		}else{
			premium = $filter('rupeeSymbol')(quoteDetail.quoteCreation.actualPremiumPayable);
		}
          
          if (productUid == "44"){
              policyNumber = generalInsurenceHomeService.getOnlinePolicy().journalNo;
          }else{
            policyNumber = generalInsurenceHomeService.getOnlinePolicy().onlinePolicy.policyNumber;
          }
          
          if(productUid == '55'){
             sumInsured  =   $filter('currency')(generalInsurenceHomeService.getpolicySumInsured().toString(),'$',0);
          }else{
			    if(generalInsurenceHomeService.getRenewDetail() && generalInsurenceHomeService.getRenewDetail().isRenewal){
					sumInsured = $filter('rupeeSymbol')(generalInsurenceHomeService.getLinkedpolicyDetailDetails().sumInsured.toString());
				}else{
					sumInsured  = $filter('rupeeSymbol')(generalInsurenceHomeService.getpolicySumInsured().toString());
				}
              
          }
           
            paymentSuccessVm.uniqueID =   $stateParams.page;
                switch(productUid){

                    case "11" :  healthBodyMessage($translate.instant("AP_PRODUCT"),"http://www.sbigenral.in/SBIG/");
                                 break;
                    case "12" :  healthBodyMessage($translate.instant("CI_PRODUCT"),"http://www.sbigenral.in/SBIG/");
                                 break;
                    case "13" :  healthBodyMessage($translate.instant("HDC_PRODUCT"),"http://www.sbigenral.in/SBIG/");
                                 break;
                    case "14" :  healthBodyMessage($translate.instant("SH_PRODUCT"),"http://www.sbigenral.in/SBIG/");
                                 break;
                    case "31" :  healthBodyMessage($translate.instant("M4W_PRODUCT"),"http://www.sbigenral.in/SBIG/");
                                 break;
                    case "32" :  healthBodyMessage($translate.instant("M2W_PRODUCT"),"http://www.sbigenral.in/SBIG/");
                                 break;
                    case "22" :  healthBodyMessage($translate.instant("LTH_PRODUCT"));
                                 break;
                    case "44" :  healthBodyMessage($translate.instant("PAI_PRODUCT"));
                                 break;
                    case "55" :  healthBodyMessage($translate.instant("TI_PRODUCT"));
                                 break;

                }
            function healthBodyMessage(product,urlList){

                var policyNameType; 
                if(productUid == '14' || productUid == '44' ){
                    policyNameType = 'certificate number';
                }else{
                    policyNameType = 'policy number';
                }
                paymentSuccessVm.congratsUser = 'Congrats ' + previousProductDetail.customerName + '!!'; 
                paymentSuccessVm.msg = 'Your transaction is successful.';

                paymentSuccessVm.bodyData = "Your "+policyNameType +" is " + policyNumber + ". We have received a sum of "  +
                 premium + " towards the premium for " + product +" with sum insured of "  +
                  sumInsured + ".";
                paymentSuccessVm.url = urlList;
            }
        }




        function  removeGiApplication(applicationNumber) {
            if(applicationNumber && applicationNumber!=""){
                var req = {};
              req.applicationNumber = applicationNumber;
              generalInsurenceHomeDetailService.deleteApplication(req).then(function(giData) {
              }, function(error) {
              });
            }
        };

        paymentSuccessVm.loadMyPolicies = function() {
            switch ($stateParams.page) {
                case "motor":
                    $state.go("menu.myPolicies", { page: $stateParams.page });
                    break;
                case "travel":
                    $state.go("menu.myPolicies", { page: $stateParams.page });
                    break;
                case "health":
                    $state.go("menu.myPolicies", { page: $stateParams.page });
                    break;
                case "accident":
                    $state.go("menu.myPolicies", { page: $stateParams.page });
                    break;
                case "home":
                    $state.go("menu.myPolicies", { page: $stateParams.page });
                    break;

            }
        }

        paymentSuccessVm.openInsurancePage = function(){
             $state.go("menu.eInsurance");
        }

        paymentSuccessVm.openUrl = function(url) {
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
