// 'use strict';

angularApp.controller('requestSubmitController', [
    "$state",
    "$scope",
    "$translate", "$ionicPopup", "generalInsurenceHomeService", "utilityService","GIconstant",


    function(
        $state,
        $scope,
        $translate, $ionicPopup, generalInsurenceHomeService, utilityService, GIconstant) {

        var requestSubmitVm = this;


        function initPage() {
           var planDetail = generalInsurenceHomeService.getPlanDetail();
           if(planDetail.accNumber){
                requestSubmitVm.content = "Your policy data will be credited to your e-Insurance Account number " + planDetail.accNumber;
           }else{
                if(planDetail.uin == GIconstant.common.motorFour || planDetail.uin == GIconstant.common.motorTwo){
                    generalInsurenceHomeService.requestSubmitMotor().then(function(detail) {
                        requestSubmitVm.content = detail.msg;
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }else{
                    generalInsurenceHomeService.requestSubmitNonMotor().then(function(detail) {
                        requestSubmitVm.content = detail.msg;
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
           }
           
        }

        requestSubmitVm.clicked = function(){
            
        }
        requestSubmitVm.goBack = function() {

        }

        requestSubmitVm.submit = function(){

        }
        
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


    }
]);
