//'use strict';

angularApp.controller('sbiInsuranceRecommendationsController', [
    "$state",
    "$scope",
    "$stateParams", "generalInsurenceHomeService","utilityService",

    function(
        $state,
        $scope,
        $stateParams, generalInsurenceHomeService,utilityService) {

        var sbiInsuranceRecommendationsVm = this;

        function initPage() {
          
        }


        sbiInsuranceRecommendationsVm.goToDetails = function() {
            if ($stateParams.page == "health") {
                $state.go('menu.healthInsuranceProductDetails');
            } else if ($stateParams.page == "accident") {
                $state.go("menu.accidentInsuranceProductDetails");
            } else if ($stateParams.page == "home") {
                $state.go("menu.homeInsuranceProductDetails");
            } else if ($stateParams.page == "travel") {
                $state.go("menu.travelInsuranceProductDetails");
            } else if ($stateParams.page == "motor") {
                $state.go("menu.motorInsuranceProductDetails");
            }

        }

        sbiInsuranceRecommendationsVm.goToProductFeatures = function(Detail) {
            generalInsurenceHomeService.setDidYouKnowDetail(Detail);

            if ($stateParams.page == "health") {
                $state.go('menu.sbiHealthType');
            } else if ($stateParams.page == "accident") {
                $state.go("menu.accidentRecommendedPolicyFeatures");
            } else if ($stateParams.page == "home") {
                $state.go("menu.homeRecommendedPolicyFeatures");
            } else if ($stateParams.page == "travel") {
                $state.go("menu.travelRecommendedPolicyFeatures");
            } else if ($stateParams.page == "motor") {
                $state.go("menu.motorRecommendedPolicyFeatures");
            }
        }

        sbiInsuranceRecommendationsVm.buyAnotherPolicy = function() {
            if ($stateParams.page == "health") {
                $state.go("menu.healthInsurance");
            } else if ($stateParams.page == "accident") {
                $state.go("menu.accidentInsurance");
            } else if ($stateParams.page == "home") {
                $state.go("menu.homeInsurance");
            } else if ($stateParams.page == "travel") {
                $state.go("menu.travelInsurance");
            } else if ($stateParams.page == "motor") {
                $state.go("menu.motorInsurance");
            }
        }


        function recomendedDetail(){

              generalInsurenceHomeService.getRecomendedDetail().then(function(response) {
                 sbiInsuranceRecommendationsVm.recomendedLists =  response.plans;
                }, function(error) {
                });

        }

        function didyouknowlist(){
            var data = {
                 "uin": "11"
            }
            generalInsurenceHomeService.getDidYouKnowList(data).then(function(response) {
                recomendedDetail();  
                sbiInsuranceRecommendationsVm.didyouknowlists =  response.items;   
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        sbiInsuranceRecommendationsVm.showdetails = function(data) {
            generalInsurenceHomeService.setProductDetail(data);
            $state.go("menu.recommendedPolicyDetails");
        }


        sbiInsuranceRecommendationsVm.goBack = function() {
            $state.go('menu.declaimer');
        };

        
        sbiInsuranceRecommendationsVm.goToNextPage = function() {

        }
           
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            didyouknowlist();
        });

        $scope.$on('$ionicView.afterLeave', function() {
        });
    }
]);
