angularApp.value(
    'genralInsurenceConfig', {
        "adapterURL": {
            "getPolicyFeature": ['adapters/GeneralInsuranceAdapter/getPolicyFeature'],
            "didYouKnowList": ['adapters/GeneralInsuranceAdapter/getDidYouKnowList', 'post'],
            "recomendedDetail": ['adapters/GeneralInsuranceAdapter/getRecommendedPlans', 'get'],
            "recomendedDetailPage": ['adapters/GeneralInsuranceAdapter/getRecommendedPlanDetails', 'post'],
            "getAllPlans": ['adapters/GeneralInsuranceAdapter/getAllPlans', 'get'],
            "postPAIPremium": ['adapters/GeneralInsuranceAdapter/getPAIQuote'],
            "getTIQuoteCalculation": ['adapters/GeneralInsuranceAdapter/getTravelMaster', 'get'],
            "postTravelPremium": ['adapters/GeneralInsuranceAdapter/getTIQuote'],
            "postVehicleType": ['adapters/GeneralInsuranceAdapter/getMIVehicleMake'],
            "getVehicleModel": ['adapters/GeneralInsuranceAdapter/getMIVehicleModel'],
            "getMIVehicleVariant": ['adapters/GeneralInsuranceAdapter/getMIVehicleVariant'],
            "getMIFuelType": ['adapters/GeneralInsuranceAdapter/getMIFuelType'],
            "getSBIBankAccounts": ['adapters/FSSCommonAdapter/getOwnAccounts'],
            "getAllPolicyTerms": ['adapters/GeneralInsuranceAdapter/getAllPolicyTerms'],
            "getHomeIQuote": ['adapters/GeneralInsuranceAdapter/getHomeIQuote'],
            "applyHomeIProduct": ['adapters/GeneralInsuranceAdapter/applyHomeIProduct'],
            "applyPAIProduct": ['adapters/GeneralInsuranceAdapter/applyPAIProduct'],
            "getSBIBankAccountDetails": ['adapters/FSSCommonAdapter/getBankAccountHolderDetails'],
            "getPlanDetails": ['adapters/GeneralInsuranceAdapter/getPlanDetails'],
            "getHICriticalIllnessQuote": ['adapters/GeneralInsuranceAdapter/getHICriticalIllnessQuote'],
            "createParty": ['adapters/GeneralInsuranceAdapter/createParty'],
            "createPartyInsured": ['adapters/GeneralInsuranceAdapter/createPartyInsured'],
            "getIDV": ['adapters/GeneralInsuranceAdapter/getIDV'],
            "applyHICriticalIllnessProduct": ['adapters/GeneralInsuranceAdapter/applyHICriticalIllnessProduct'],
            "getMIQuote": ['adapters/GeneralInsuranceAdapter/getMIQuote'],
            "applyMIProduct": ['adapters/GeneralInsuranceAdapter/applyMIProduct'],
            "getAgentReceipt": ['adapters/GeneralInsuranceAdapter/getAgentReceipt', '120000'],
            "getHDCPremiumCalculation": ['adapters/GeneralInsuranceAdapter/getHDCPremiumCalculation'],
            "getHIArogyaQuote": ['adapters/GeneralInsuranceAdapter/getHIArogyaQuote'],
            "applyHIArogyaProduct": ['adapters/GeneralInsuranceAdapter/applyHIArogyaProduct'],
            "getMIQuoteFourWheeler": ['adapters/GeneralInsuranceAdapter/getMIQuoteFourWheeler'],
            "getOnlinePolicy": ['adapters/GeneralInsuranceAdapter/getOnlinePolicy', '120000'],
            "getSimpleHealthPremium": ['adapters/GeneralInsuranceAdapter/getSimpleHealthPremium'],
            "getHDCMaster": ['adapters/GeneralInsuranceAdapter/getHospitalCommonMaster'],
            "getDisclaimer": ['adapters/GeneralInsuranceAdapter/getDisclaimer'],
            "getLongTermMasters": ['adapters/GeneralInsuranceAdapter/getLongTermMasters'],
            "getArogyaMaster": ['adapters/GeneralInsuranceAdapter/getArogyaCommonMaster'],
            "getCriticalMaster": ['adapters/GeneralInsuranceAdapter/getCriticalIllnessMaster'],
            "getMICommonMasters": ['adapters/GeneralInsuranceAdapter/getMICommonMasters'],
            "applySimpleHealthQuote": ['adapters/GeneralInsuranceAdapter/applySimpleHealth'],
            "applyHDCQuote": ['adapters/GeneralInsuranceAdapter/applyHDCQuote'],
            "applyMIFourWheelerProduct": ['adapters/GeneralInsuranceAdapter/applyMIFourWheelerProduct'],
            "getLocation": ['adapters/GeneralInsuranceAdapter/getLocationByPincode'],
            "getGILinkedPolicies": ['adapters/GeneralInsuranceAdapter/getLinkedPolicies'],
            "getDocSearch": ['adapters/GeneralInsuranceAdapter/getDocSearch'],
            "getTravelMaster": ['adapters/GeneralInsuranceAdapter/getTravelMaster'],
            "getPolicyCreate": ['adapters/GeneralInsuranceAdapter/createPolicy', '120000'],
            "applyTIProduct": ['adapters/GeneralInsuranceAdapter/applyTIProduct'],
            "getSimpleMaster": ['adapters/GeneralInsuranceAdapter/getSHCommonMasters'],
            "getDelink": ['adapters/GeneralInsuranceAdapter/deLinkPolicy'],
            "getClaimStatus": ['adapters/GeneralInsuranceAdapter/getClaimStatus'],
            "getAllGIProducts": ['adapters/GeneralInsuranceAdapter/getAllGIProducts'],
            "getRTOLocation": ['adapters/GeneralInsuranceAdapter/getLocationByRTO'],
            "getTermsAndCondtion": ['adapters/GeneralInsuranceAdapter/getTermsAndCondtion'],
            "saveApplication": ['adapters/GeneralInsuranceAdapter/saveApplication'],
            "getSavedApplication": ['adapters/GeneralInsuranceAdapter/getSavedApplication'],
            "getPersonalAccidentMasters": ['adapters/GeneralInsuranceAdapter/getPersonalAccidentMasters'],
            "getSavedApplications": ['adapters/GeneralInsuranceAdapter/getSavedApplications'],
            "getRecommend": ['adapters/GeneralInsuranceAdapter/getRecommendedAnalytics', 'get'],
            "payForPAIPurchase": ['adapters/GeneralInsuranceAdapter/payForPAIPurchase'],
            "payForPAIRenew": ['adapters/GeneralInsuranceAdapter/payForPAIRenew'],
            "validateOTPForPAIRenewal": ['adapters/GeneralInsuranceAdapter/validateOTPForPAIRenewal'],
            "saveFinance": ['adapters/GeneralInsuranceAdapter/saveFinance'],
            "deleteFinance": ['adapters/GeneralInsuranceAdapter/deleteFinance'],
            "getFinance": ['adapters/GeneralInsuranceAdapter/getFinance'],
            "payForOtherPurchase": ['adapters/GeneralInsuranceAdapter/payForOtherPurchase'],
            "deleteApplication": ['adapters/GeneralInsuranceAdapter/deleteApplication'],
            "getQuoteDetails": ['adapters/GeneralInsuranceAdapter/getQuoteDetails'],
            "getRenewalPolicy": ['adapters/GeneralInsuranceAdapter/getRenewalPolicy'],
            "getPAIRenewalDetails": ['adapters/GeneralInsuranceAdapter/getPAIRenewalDetails'],
            "payForSHPurchase": ['adapters/GeneralInsuranceAdapter/payForSHPurchase'],
            "getDiclaration": ['adapters/GeneralInsuranceAdapter/getDiclaration'],
            "getJourneyMaster": ['adapters/FSSCommonAdapter/getJourneyMaster'],
            "saveJourney": ['adapters/FSSCommonAdapter/saveJourney'],
            "getSavedJourney": ['adapters/FSSCommonAdapter/getSavedJourney'],
            "getPlan": ['adapters/GeneralInsuranceAdapter/getPAIPolicyPDF'],
            "getClaimIntimation": ['adapters/GeneralInsuranceAdapter/getClaimIntimation'],
            "eInsuranceAccount": ['adapters/GeneralInsuranceAdapter/getInsurance'],
            "requestSubmitMotor": ['adapters/GeneralInsuranceAdapter/getRequestSubmitedMotor'],
            "requestSubmitNonMotor": ['adapters/GeneralInsuranceAdapter/getRequestSubmitedNonMotor'],
            "getEInsuranceData": ['adapters/GeneralInsuranceAdapter/getEInsuranceData'],
            "getDocumentList": ['adapters/GeneralInsuranceAdapter/getDocumentList'],
            "validateOTPForSHPayment": ['adapters/GeneralInsuranceAdapter/validateOTPForSHPayment'],
            "resendOTPForSH": ['adapters/GeneralInsuranceAdapter/resendOTPForSHPayment'],
            "validateOTPForPAIPayment": ['adapters/GeneralInsuranceAdapter/validateOTPForPAIPayment'],
            "resendOTPForPAI": ['adapters/GeneralInsuranceAdapter/resendOTPForPAIPayment'],
            "resendOTPForPAIRenewal": ['adapters/GeneralInsuranceAdapter/resendOTPForPAIRenewalPayment'],
            "validateOTPForOtherPayment": ['adapters/GeneralInsuranceAdapter/validateOTPForOtherPayment'],
            "resendOTPForOthers": ['adapters/GeneralInsuranceAdapter/resendOTPForOtherPayment'],
            "getTooltipContent": ['adapters/GeneralInsuranceAdapter/getInfoContent'],
            "getBannerInfo": ['adapters/HomeAdapter/getNotificationContent'],
            "getQuickQuotes" : ['adapters/GeneralInsuranceAdapter/getASQuickQuote'],
            "paiValidatePolicyPurchase" : ['adapters/GeneralInsuranceAdapter/paiValidatePolicyPurchase']
        }
    });

/*State defination with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
    '$urlRouterProvider',
    '$controllerProvider',
    '$translateProvider',
    '$ionicConfigProvider',

    function ($stateProvider,
        $urlRouterProvider,
        $controllerProvider,
        $translateProvider,
        $ionicConfigProvider) {

        //General Insurance start
        $stateProvider
            .state('menu.generalInsurance', {
                url: '/generalInsurance',
                data: {
                    pageId: 'GI_HOM'
                },
                params: { backInsurance : null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/generalInsurance.html',
                        controller: 'sbiGeneralInsuranceController',
                        controllerAs: 'sbiGeneralInsuranceVm',
                    }
                }
            })
            .state('menu.sbiHealthRecommendations', {
                url: '/sbiHealthRecommendations',
                data: {
                    pageId: 'GI_SBIINSREC'
                },
                params: { page: 'health' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/sbiInsuranceRecommendations.html',
                        controller: 'sbiInsuranceRecommendationsController',
                        controllerAs: 'sbiInsuranceRecommendationsVm',
                    }
                }
            })
            .state('menu.sbiHealthType', {
                url: '/sbiHealthType',
                data: {
                    pageId: 'GI_HLTHTYP'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/healthtype.html',
                        controller: 'sbiInsurancehealthController',
                        controllerAs: 'sbiInsurancehealthVm',
                    }
                }
            })
            .state('menu.healthInsuranceProductDetails', {
                url: '/insuranceProductDetails',
                data: {
                    pageId: 'GI_INSPRDTDETL'
                },
                params: { page: 'health' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/productDetails.html',
                        controller: 'productDetailsController',
                        controllerAs: 'productDetailsVm',
                    }
                }
            })
            .state('menu.healthInsurance', {
                url: '/sbihealthInsurance',
                data: {
                    pageId: 'GI_HLTHINS'
                },
                params: { page: 'health-insurance' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/healthHome.html',
                        controller: 'generalInsurenceHomeController',
                        controllerAs: 'healthInsuranceVm',
                    }
                }
            })
            .state('menu.travelInsurance', {
                url: '/travelInsurance',
                data: {
                    pageId: 'GI_TRVLINS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/travel/travel.html',
                        controller: 'travelController',
                        controllerAs: 'travelInsuranceVm',
                    }
                }
            })
            .state('menu.motorInsuranceDetail', {
                url: '/motorInsuranceDetail',
                data: {
                    pageId: 'GI_MTRINSDETL'
                },
                params: { page: 'motor-insurance' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/healthHome.html',
                        controller: 'generalInsurenceHomeController',
                        controllerAs: 'healthInsuranceVm',
                    }
                }
            })
            .state('menu.travelInsuranceDetail', {
                url: '/travelInsuranceDetail',
                data: {
                    pageId: 'GI_TRVLINSDETL'
                },
                params: { page: 'travel-insurance' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/healthHome.html',
                        controller: 'generalInsurenceHomeController',
                        controllerAs: 'healthInsuranceVm',
                    }
                }
            })
            .state('menu.homeInsuranceDetail', {
                url: '/homeInsuranceDetail',
                data: {
                    pageId: 'GI_HOMINSDETL'
                },
                params: { page: 'home-insurance' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/healthHome.html',
                        controller: 'generalInsurenceHomeController',
                        controllerAs: 'healthInsuranceVm',
                    }
                }
            })
            .state('menu.personalaccidentdetail', {
                url: '/personalaccidentdetail',
                data: {
                    pageId: 'GI_PRSLACDTDETL'
                },
                params: { page: 'personal-accident-insurance' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/healthHome.html',
                        controller: 'generalInsurenceHomeController',
                        controllerAs: 'healthInsuranceVm',
                    }
                }
            })
            .state('menu.helpMeChoose', {
                url: '/helpMeChoose',
                data: {
                    pageId: 'GI_HLPMECHSE'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/helpMeChoose.html',
                        controller: 'helpMeChooseController',
                        controllerAs: 'sbiGeneralInsuranceVm',
                    }
                }
            })
            .state('menu.basicInformation', {
                url: '/basicInformation',
                data: {
                    pageId: 'GI_BSCINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/basicInformation.html',
                        controller: 'basicInformationController',
                        controllerAs: 'renewDetailVm',
                    }
                }
            })
            .state('menu.recommendedPolicies', {
                url: '/recommendedPolicies',
                data: {
                    pageId: 'GI_RECPLCS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/recommendedPolicies.html',
                        controller: 'recommendedPoliciesController',
                        controllerAs: 'recommendedPoliciesVm',
                    }
                }
            })
            .state('menu.recommendedPolicyDetails', {
                url: '/recommendedPolicyDetails',
                data: {
                    pageId: 'GI_RECPLCSDETL'
                },
                params: { page: 'health' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/recommendedPolicyDetails.html',
                        controller: 'recommendedPolicyDetailsController',
                        controllerAs: 'recommendedPolicyDetailsVm',
                    }
                }
            })
            .state('menu.quoteCalculation', {
                url: '/quoteCalculation',
                data: {
                    pageId: 'GI_QUTECALC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/quotes/quoteCalculation.html',
                        controller: 'quoteCalculationController',
                        controllerAs: 'quoteCalcVm',
                    }
                }
            })
            .state('menu.quotesList', {
                url: '/quotesList',
                data: {
                    pageId: 'GI_QUTELST'
                },
                params: { pages: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/quotes/quotesList.html',
                        controller: 'quotesListController',
                        controllerAs: 'quotesListVm',
                    }
                }
            })
            .state('menu.quoteIRDAIOtp', {
                url: '/quoteIRDAIOtp',
                data: {
                    pageId: 'GI_QUTEIRDAOTP'
                },
                params: { page: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/quotes/quoteIRDAIOtp.html',
                        controller: 'quoteIRDAIOtpController',
                        controllerAs: 'quoteIRDAIOtpVm',
                    }
                }
            })
            .state('menu.paymentAccountDetails', {
                url: '/paymentAccountDetails',
                data: {
                    pageId: 'GI_PYMTACCTDETL'
                },
                params: { page: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/quotes/paymentAccountDetails.html',
                        controller: 'paymentAccountDetailsController',
                        controllerAs: 'paymentAccountDetailsVm',
                    }
                }
            })
            .state('menu.paymentAccountDetailsMotor', {
                url: '/paymentAccountDetailsMotor',
                data: {
                    pageId: 'GI_PYMTACCTDETLMTR'
                },
                params: { page: 'Motor' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/quotes/paymentAccountDetails.html',
                        controller: 'paymentAccountDetailsController',
                        controllerAs: 'paymentAccountDetailsVm',
                    }
                }
            })
            .state('menu.healthApplicationPersonalDetails', {
                url: '/healthApplicationPersonalDetails',
                data: {
                    pageId: 'GI_HLTHAPPPRSLDETL'
                },
                params: { agree: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/healthApplicationPersonalDetails.html',
                        controller: 'healthApplicationPersonalDetailsController',
                        controllerAs: 'healthApplicationPersonalDetailsVm',
                    }
                }
            })
            .state('menu.healthApplicationNomineeDetails', {
                url: '/healthApplicationNomineeDetails',
                data: {
                    pageId: 'GI_HLTHAPPNOMDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/healthApplicationNomineeDetails.html',
                        controller: 'healthApplicationNomineeDetailsController',
                        controllerAs: 'healthApplicationNomineeDetailsVm',
                    }
                }
            })
            .state('menu.healthApplicationHealthInformation', {
                url: '/healthApplicationHealthInformation',
                data: {
                    pageId: 'GI_HLTHAPPHLTHINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/healthApplicationHealthInformation.html',
                        controller: 'healthApplicationHealthInformationController',
                        controllerAs: 'healthApplicationHealthInformationVm',
                    }
                }
            })
            .state('menu.healthPurchaseSummary', {
                url: '/healthPurchaseSummary',
                data: {
                    pageId: 'GI_HLTHPUCHSUMY'
                },
                params: { page: 'health' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/purchaseSummary.html',
                        controller: 'purchaseSummaryController',
                        controllerAs: 'purchaseSummaryVm',
                    }
                }
            })
            .state('menu.healthPremiumSummary', {
                url: '/healthPremiumSummary',
                data: {
                    pageId: 'GI_HLTHPRMSUMY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/healthPremiumSummary.html',
                        controller: 'healthPremiumSummaryController',
                        controllerAs: 'healthPremiumSummaryVm',
                    }
                }
            })
            .state('menu.travelPurchaseSummary', {
                url: '/travelPurchaseSummary',
                data: {
                    pageId: 'GI_TRVLPUCHSUMY'
                },
                params: { page: 'travel' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/purchaseSummary.html',
                        controller: 'purchaseSummaryController',
                        controllerAs: 'purchaseSummaryVm',
                    }
                }
            })
            .state('menu.healthPaymentSuccess', {
                url: '/healthPaymentSuccess',
                data: {
                    pageId: 'GI_HLTHPYMTSUC'
                },
                params: { page: 'health' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/paymentSuccess.html',
                        controller: 'paymentSuccessController',
                        controllerAs: 'paymentSuccessVm',
                    }
                }
            })
            .state('menu.eInsurance', {
                url: '/eInsurance',
                data: {
                    pageId: 'GI_EINC'
                },
                params: { page: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/eInsurance.html',
                        controller: 'eInsuranceController',
                        controllerAs: 'eInsuranceVm',
                    }
                }
            })
            .state('menu.paymentOtp', {
                url: '/paymentOtp',
                data: {
                    pageId: 'GI_PAYOTP'
                },
                params: { page: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/paymentOtp.html',
                        controller: 'paymentOtpController',
                        controllerAs: 'paymentOtpVm',
                    }
                }
            })
            .state('menu.requestSubmit', {
                url: '/requestSubmit',
                data: {
                    pageId: 'GI_REQSUB'
                },
                params: { page: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/requestSubmit.html',
                        controller: 'requestSubmitController',
                        controllerAs: 'requestSubmitVm',
                    }
                }
            })
            .state('menu.myPolicies', {
                url: '/myPolicies',
                data: {
                    pageId: 'GI_MYPLCS'
                },
                params: { page: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/myPolicies.html',
                        controller: 'myPoliciesController',
                        controllerAs: 'myPoliciesVm',
                    }
                }
            })
            .state('menu.claimIntimation', {
                url: '/claimIntimation',
                data: {
                    pageId: 'GI_CLAMINTI'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/claimIntimation.html',
                        controller: 'claimIntimationController',
                        controllerAs: 'claimIntimationVm',
                    }
                }
            })
            .state('menu.delinkPolicy', {
                url: '/delinkPolicy',
                data: {
                    pageId: 'GI_DLNKPLCY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/delinkPolicy.html',
                        controller: 'delinkPolicyController',
                        controllerAs: 'delinkPolicyVm',
                    }
                }
            })

            //Motor GI
            .state('menu.motorInsuranceProductDetails', {
                url: '/motorInsuranceProductDetails',
                data: {
                    pageId: 'GI_MTRINSPRDTDETL'
                },
                params: { page: 'motor' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/productDetails.html',
                        controller: 'productDetailsController',
                        controllerAs: 'productDetailsVm',
                    }
                }
            })
            .state('menu.motorRecommendedPolicyFeatures', {
                url: '/motorRecommendedPolicyFeatures',
                data: {
                    pageId: 'GI_MTRRECPLCYFETU'
                },
                params: { page: 'motor', type: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/recommendedPolicyDetails.html',
                        controller: 'recommendedPolicyDetailsController',
                        controllerAs: 'recommendedPolicyDetailsVm',
                    }
                }
            })
            .state('menu.motorGetQuote', {
                url: '/motorGetQuote',
                data: {
                    pageId: 'GI_MTRGETQUTE'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/motor/motorGetQuote.html',
                        controller: 'motorGetQuoteController',
                        controllerAs: 'motorGetQuoteVm',
                    }
                }
            })
            .state('menu.motorNewCarGetCarInfo', {
                url: '/motorNewCarGetCarInfo',
                data: {
                    pageId: 'GI_MTRNEWCARGETINFO'
                },
                params: { page: "newcar" },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/motor/motorNewCarGetCarInfo.html',
                        controller: 'motorNewCarGetCarInfoController',
                        controllerAs: 'motorNewCarGetCarInfoVm',
                    }
                }
            })
            .state('menu.motorOldCarGetCarInfo', {
                url: '/motorOldCarGetCarInfo',
                data: {
                    pageId: 'GI_MTROLDCARGETINFO'
                },
                params: { page: "rollover" },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/motor/motorNewCarGetCarInfo.html',
                        controller: 'motorNewCarGetCarInfoController',
                        controllerAs: 'motorNewCarGetCarInfoVm',
                    }
                }
            })
            .state('menu.motorNewCarGetMoreCarInfo', {
                url: '/motorNewCarGetMoreCarInfo',
                data: {
                    pageId: 'GI_MTRNEWCARGETMREINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/motor/motorNewCarGetMoreCarInfo.html',
                        controller: 'motorNewCarGetMoreCarInfoController',
                        controllerAs: 'motorNewCarGetMoreCarInfoVm',
                    }
                }
            })
            .state('menu.motorNewCarGetIDVDetails', {
                url: '/motorNewCarGetIDVDetails',
                data: {
                    pageId: 'GI_MTRNEWCARGETIDVDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/motor/motorNewCarGetIDVDetails.html',
                        controller: 'motorNewCarGetIDVDetailsController',
                        controllerAs: 'motorNewCarGetIDVDetailsVm',
                    }
                }
            })

            .state('menu.motorPremiumCalculation', {
                url: '/motorPremiumCalculation',
                data: {
                    pageId: 'GI_MTRPRMCALC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/motor/motorPremiumCalculation.html',
                        controller: 'motorPremiumCalculationController',
                        controllerAs: 'motorPremiumCalculationVm',
                    }
                }
            })
            .state('menu.quoteIRDAIOtpMotor', {
                url: '/quoteIRDAIOtp',
                data: {
                    pageId: 'GI_QUTEIRDAOTP'
                },
                params: { page: 'Motor' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/quotes/quoteIRDAIOtp.html',
                        controller: 'quoteIRDAIOtpController',
                        controllerAs: 'quoteIRDAIOtpVm',
                    }
                }
            })
            .state('menu.motorInsurerPersonalDetails', {
                url: '/motorInsurerPersonalDetails',
                data: {
                    pageId: 'GI_MTRINSPRSLDETL'
                },
                params: { page: 'Motor', agree: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/motor/motorInsurerPersonalDetails.html',
                        controller: 'motorInsurerPersonalDetailsController',
                        controllerAs: 'motorInsurerPDVm',
                    }
                }
            })
            .state('menu.motorInsurerAddressDetails', {
                url: '/motorInsurerAddressDetails',
                data: {
                    pageId: 'GI_MTRINSADRSDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/motor/motorInsurerAddressDetails.html',
                        controller: 'motorInsurerAddressDetailsController',
                        controllerAs: 'motorInsurerAddressDetailsVm',
                    }
                }
            })
            .state('menu.motorInsurerVehicleInfo', {
                url: '/motorInsurerVehicleInfo',
                data: {
                    pageId: 'GI_MTRINSVHCLINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/motor/motorInsurerVehicleInfo.html',
                        controller: 'motorInsurerVehicleInfoController',
                        controllerAs: 'motorInsurerVehicleInfoVm',
                    }
                }
            })
            .state('menu.motorInsurerFinancialDetails', {
                url: '/motorInsurerFinancialDetails',
                data: {
                    pageId: 'GI_MTRINSFNCLDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/motor/motorInsurerFinancialDetails.html',
                        controller: 'motorInsurerFinancialDetailsController',
                        controllerAs: 'motorInsurerFinancialDetailsVm',
                    }
                }
            })
            .state('menu.motorPurchaseSummary', {
                url: '/motorPurchaseSummary',
                data: {
                    pageId: 'GI_MTRPUCHSUMY'
                },
                params: { page: 'motor' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/purchaseSummary.html',
                        controller: 'purchaseSummaryController',
                        controllerAs: 'purchaseSummaryVm',
                    }
                }
            })
            .state('menu.motorPaymentSuccess', {
                url: '/menu.motorPaymentSuccess',
                data: {
                    pageId: 'GI_MTRPYMTSUC'
                },
                params: { page: 'motor' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/paymentSuccess.html',
                        controller: 'paymentSuccessController',
                        controllerAs: 'paymentSuccessVm',
                    }
                }
            })
            .state('menu.sbiMotorRecommendations', {
                url: '/sbiMotorRecommendations',
                data: {
                    pageId: 'GI_SBIMTRREC'
                },
                params: { page: 'motor' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/sbiInsuranceRecommendations.html',
                        controller: 'sbiInsuranceRecommendationsController',
                        controllerAs: 'sbiInsuranceRecommendationsVm',
                    }
                }
            })
            .state('menu.motorCarInsuredWithOtherCompany', {
                url: '/motorCarInsuredWithOtherCompany',
                data: {
                    pageId: 'GI_MTRCARINSDOTHRCMPY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/motor/motorCarInsuredWithOtherCompany.html',
                        controller: 'motorCarInsuredWithOtherCompanyController',
                        controllerAs: 'motorCarInsuredWithOtherCompanyVm',
                    }
                }
            })

            //Travel GI
            .state('menu.travelInsuranceProductDetails', {
                url: '/travelInsuranceProductDetails',
                data: {
                    pageId: 'GI_TRVLINSPRDTDETL'
                },
                params: { page: 'travel' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/productDetails.html',
                        controller: 'productDetailsController',
                        controllerAs: 'productDetailsVm',
                    }
                }
            })
            .state('menu.travelRecommendedPolicyFeatures', {
                url: '/travelRecommendedPolicyFeatures',
                data: {
                    pageId: 'GI_TRVLRECPOLYFETU'
                },
                params: { page: 'travel' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/recommendedPolicyDetails.html',
                        controller: 'recommendedPolicyDetailsController',
                        controllerAs: 'recommendedPolicyDetailsVm',
                    }
                }
            })
            .state('menu.travelQuotePolicyInfo', {
                url: '/travelQuotePolicyInfo',
                data: {
                    pageId: 'GI_TRVLQUTEPLCYINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/travel/travelQuotePolicyInfo.html',
                        controller: 'travelQuotePolicyInfoController',
                        controllerAs: 'travelQuotePolicyInfoVm',
                    }
                }
            })
            .state('menu.travelQuoteTravellerInfo', {
                url: '/travelQuoteTravellerInfo',
                data: {
                    pageId: 'GI_TRVLQUTETVLRINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/travel/travelQuoteTravellerInfo.html',
                        controller: 'travelQuoteTravellerInfoController',
                        controllerAs: 'travelQuoteTravellerInfoVm',
                    }
                }
            })
            .state('menu.travelQuotePersonalInfo', {
                url: '/travelQuotePersonalInfo',
                data: {
                    pageId: 'GI_TRVLQUTEPRSLINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/travel/travelQuotePersonalInfo.html',
                        controller: 'travelQuotePersonalInfoController',
                        controllerAs: 'travelQuotePersonalInfoVm',
                    }
                }
            })
            .state('menu.travelPremiumSummary', {
                url: '/travelPremiumSummary',
                data: {
                    pageId: 'GI_TRVLPRMSUMY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/travel/travelPremiumSummary.html',
                        controller: 'travelPremiumSummaryController',
                        controllerAs: 'travelPremiumSummaryVm',
                    }
                }
            })
            .state('menu.quoteIRDAIOtpTravel', {
                url: '/quoteIRDAIOtpTravel',
                data: {
                    pageId: 'GI_QUTEIRDAOTPTRVL'
                },
                params: { page: 'Travel' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/quotes/quoteIRDAIOtp.html',
                        controller: 'quoteIRDAIOtpController',
                        controllerAs: 'quoteIRDAIOtpVm',
                    }
                }
            })
            .state('menu.paymentAccountDetailsTravel', {
                url: '/paymentAccountDetailsTravel',
                data: {
                    pageId: 'GI_PYMTACCTDETLTRVL'
                },
                params: { page: 'Travel' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/quotes/paymentAccountDetails.html',
                        controller: 'paymentAccountDetailsController',
                        controllerAs: 'paymentAccountDetailsVm',
                    }
                }
            })
            .state('menu.travelApplicationTravellerInfo', {
                url: '/travelApplicationTravellerInfo',
                data: {
                    pageId: 'GI_TRVLAPPTVLRINFO'
                },
                params: { agree: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/travel/travelApplicationTravellerInfo.html',
                        controller: 'travelApplicationTravellerInfoController',
                        controllerAs: 'travelApplicationTravellerInfoVm',
                    }
                }
            })
            .state('menu.travelProposerContactInfo', {
                url: '/travelProposerContactInfo',
                data: {
                    pageId: 'GI_TRVLPRSRCNTINFO'
                },
                params: { page: 'Travel' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/travel/travelProposerContactInfo.html',
                        controller: 'travelProposerContactInfoController',
                        controllerAs: 'travelProposerContactInfoVm',
                    }
                }
            })
            .state('menu.travelProposerphysiocalInfo', {
                url: '/travelProposerphysicalInfo',
                data: {
                    pageId: 'GI_TRVLPRSRPHYLINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/travel/travelphysicalInfo.html',
                        controller: 'travelProposerContactInfoController',
                        controllerAs: 'travelProposerContactInfoVm',
                    }
                }
            })
            .state('menu.travelProposerPersonalInfo', {
                url: '/travelProposerPersonalInfo',
                data: {
                    pageId: 'GI_TRVLPRSRPRSLINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/travel/travelProposerPersonalInfo.html',
                        controller: 'travelProposerPersonalInfoController',
                        controllerAs: 'travelProposerPersonalInfoVm',
                    }
                }
            })
            .state('menu.travelNomineeDetails', {
                url: '/travelNomineeDetails',
                data: {
                    pageId: 'GI_TRVLNOMDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/travel/travelNomineeDetails.html',
                        controller: 'travelNomineeDetailsController',
                        controllerAs: 'travelNomineeDetailsVm',
                    }
                }
            })
            .state('menu.travelPaymentSuccess', {
                url: '/menu.travelPaymentSuccess',
                data: {
                    pageId: 'GI_TRVLPYMTSUC'
                },
                params: { page: 'travel' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/paymentSuccess.html',
                        controller: 'paymentSuccessController',
                        controllerAs: 'paymentSuccessVm',
                    }
                }
            })
            .state('menu.sbiTravelRecommendations', {
                url: '/sbiTravelRecommendations',
                data: {
                    pageId: 'GI_SBITRVLREC'
                },
                params: { page: 'travel' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/sbiInsuranceRecommendations.html',
                        controller: 'sbiInsuranceRecommendationsController',
                        controllerAs: 'sbiInsuranceRecommendationsVm',
                    }
                }
            })

            //Personal Accident GI
            .state('menu.accidentInsuranceProductDetails', {
                url: '/accidentInsuranceProductDetails',
                data: {
                    pageId: 'GI_ACDTINSPRDTDETL'
                },
                params: { page: 'accident' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/productDetails.html',
                        controller: 'productDetailsController',
                        controllerAs: 'productDetailsVm',
                    }
                }
            })
            .state('menu.accidentRecommendedPolicyFeatures', {
                url: '/accidentRecommendedPolicyFeatures',
                data: {
                    pageId: 'GI_ACDTRECPLCYFETU'
                },
                params: { page: 'accident' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/recommendedPolicyDetails.html',
                        controller: 'recommendedPolicyDetailsController',
                        controllerAs: 'recommendedPolicyDetailsVm',
                    }
                }
            })
            .state('menu.accidentQuoteMemberInfo', {
                url: '/accidentQuoteMemberInfo',
                data: {
                    pageId: 'GI_ACDTQUTEMEBRINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/personalAccident/accidentQuoteMemberInfo.html',
                        controller: 'accidentQuoteMemberInfoController',
                        controllerAs: 'accidentQuoteMemberInfoVm',
                    }
                }
            })
            .state('menu.paymentAccountDetailsAccident', {
                url: '/paymentAccountDetailsAccident',
                data: {
                    pageId: 'GI_PYMTACCTDETLACDT'
                },
                params: { page: 'Accident' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/quotes/paymentAccountDetails.html',
                        controller: 'paymentAccountDetailsController',
                        controllerAs: 'paymentAccountDetailsVm',
                    }
                }
            })
            .state('menu.accidentApplicationPolicyInfo', {
                url: '/accidentApplicationPolicyInfo',
                data: {
                    pageId: 'GI_ACDTAPPPLCYINFO'
                },
                params: { agree: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/personalAccident/accidentApplicationPolicyInfo.html',
                        controller: 'accidentApplicationPolicyInfoController',
                        controllerAs: 'accidentApplicationPolicyInfoVm',
                    }
                }
            })
            .state('menu.accidentApplicationInsurerInfo', {
                url: '/accidentApplicationInsurerInfo',
                data: {
                    pageId: 'GI_ACDTAPPINSRINFO'
                },
                params: { agree: null },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/personalAccident/accidentApplicationInsurerInfo.html',
                        controller: 'accidentApplicationInsurerInfoController',
                        controllerAs: 'accidentAppvm',
                    }
                }
            })
            .state('menu.accidentPurchaseSummary', {
                url: '/accidentPurchaseSummary',
                data: {
                    pageId: 'GI_ACDTPUCHSUMY'
                },
                params: { page: 'accident' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/purchaseSummary.html',
                        controller: 'purchaseSummaryController',
                        controllerAs: 'purchaseSummaryVm',
                    }
                }
            })
            .state('menu.accidentPaymentSuccess', {
                url: '/accidentPaymentSuccess',
                data: {
                    pageId: 'GI_ACDTPYMTSUC'
                },
                params: { page: 'accident' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/paymentSuccess.html',
                        controller: 'paymentSuccessController',
                        controllerAs: 'paymentSuccessVm',
                    }
                }
            })
            .state('menu.sbiAccidentRecommendations', {
                url: '/sbiAccidentRecommendations',
                data: {
                    pageId: 'GI_SBIACDTREC'
                },
                params: { page: 'accident' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/sbiInsuranceRecommendations.html',
                        controller: 'sbiInsuranceRecommendationsController',
                        controllerAs: 'sbiInsuranceRecommendationsVm',
                    }
                }
            })

            //Home GI
            .state('menu.homeInsuranceProductDetails', {
                url: '/homeInsuranceProductDetails',
                data: {
                    pageId: 'GI_HOMINSPRDTDETL'
                },
                params: { page: 'home' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/productDetails.html',
                        controller: 'productDetailsController',
                        controllerAs: 'productDetailsVm',
                    }
                }
            })
            .state('menu.homeRecommendedPolicyFeatures', {
                url: '/homeRecommendedPolicyFeatures',
                data: {
                    pageId: 'GI_HOMRECPLCYFETU'
                },
                params: { page: 'home' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/recommendedPolicyDetails.html',
                        controller: 'recommendedPolicyDetailsController',
                        controllerAs: 'recommendedPolicyDetailsVm',
                    }
                }
            })
            .state('menu.homeQuotePolicyInfo', {
                url: '/homeQuotePolicyInfo',
                data: {
                    pageId: 'GI_HOMQUTEPLCYINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/home/homeQuotePolicyInfo.html',
                        controller: 'homeQuotePolicyInfoController',
                        controllerAs: 'homeQuotePolicyInfoVm',
                    }
                }
            })
            .state('menu.homeQuoteOwnerInfo', {
                url: '/homeQuoteOwnerInfo',
                data: {
                    pageId: 'GI_HOMQUTEOWNRINFO'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/home/homeQuoteOwnerInfo.html',
                        controller: 'homeQuoteOwnerInfoController',
                        controllerAs: 'homeQuoteOwnerInfoVm',
                    }
                }
            })
            .state('menu.homeQuoteSummary', {
                url: '/homeQuoteSummary',
                data: {
                    pageId: 'GI_HOMQUTESUMY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/home/homeQuoteSummary.html',
                        controller: 'homeQuoteSummaryController',
                        controllerAs: 'homeQuoteSummaryVm',
                    }
                }
            })
            .state('menu.paymentAccountDetailsHome', {
                url: '/paymentAccountDetailsHome',
                data: {
                    pageId: 'GI_PYMTACCTDETLHOM'
                },
                params: { page: "Home" },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/quotes/paymentAccountDetails.html',
                        controller: 'paymentAccountDetailsController',
                        controllerAs: 'paymentAccountDetailsVm',
                    }
                }
            })
            .state('menu.homeApplicationOwnerDetails', {
                url: '/homeApplicationOwnerDetails',
                data: {
                    pageId: 'GI_HOMAPPOWNRDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/home/homeApplicationOwnerDetails.html',
                        controller: 'homeApplicationOwnerDetailsController',
                        controllerAs: 'homeApplicationOwnerDetailsVm',
                    }
                }
            })
            .state('menu.homeInsuredLocationDetails', {
                url: '/homeInsuredLocationDetails',
                data: {
                    pageId: 'GI_HOMINSDLOCDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/home/homeInsuredLocationDetails.html',
                        controller: 'homeInsuredLocationDetailsController',
                        controllerAs: 'homeInsuredLocationDetailsVm',
                    }
                }
            })
            .state('menu.homeInsuredBuildingDetails', {
                url: '/homeInsuredBuildingDetails',
                data: {
                    pageId: 'GI_HOMINSDBLDGDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/home/homeInsuredBuildingDetails.html',
                        controller: 'homeInsuredBuildingDetailsController',
                        controllerAs: 'homeInsuredBuildingDetailsVm',
                    }
                }
            })
            .state('menu.homeOwnerContactDetails', {
                url: '/homeOwnerContactDetails',
                data: {
                    pageId: 'GI_HOMOWNRCNTDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/home/homeOwnerContactDetails.html',
                        controller: 'homeOwnerContactDetailsController',
                        controllerAs: 'homeOwnerContactDetailsVm',
                    }
                }
            })
            .state('menu.homeApplicationContactDetails', {
                url: '/homeApplicationContactDetails',
                data: {
                    pageId: 'GI_HOMAPPCNTDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/home/homeApplicationContactDetails.html',
                        controller: 'homeApplicationContactDetailsController',
                        controllerAs: 'homeApplicationContactDetailsVm',
                    }
                }
            })
            .state('menu.homePurchaseSummary', {
                url: '/homePurchaseSummary',
                data: {
                    pageId: 'GI_HOMPUCHSUMY'
                },
                params: { page: 'home' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/purchaseSummary.html',
                        controller: 'purchaseSummaryController',
                        controllerAs: 'purchaseSummaryVm',
                    }
                }
            })
            .state('menu.homePaymentSuccess', {
                url: '/homePaymentSuccess',
                data: {
                    pageId: 'GI_HOMPYMTSUC'
                },
                params: { page: 'home' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/paymentSuccess.html',
                        controller: 'paymentSuccessController',
                        controllerAs: 'paymentSuccessVm',
                    }
                }
            })
            .state('menu.sbiHomeRecommendations', {
                url: '/sbiHomeRecommendations',
                data: {
                    pageId: 'GI_SBIHOMREC'
                },
                params: { page: 'home' },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/sbiInsuranceRecommendations.html',
                        controller: 'sbiInsuranceRecommendationsController',
                        controllerAs: 'sbiInsuranceRecommendationsVm',
                    }
                }
            })
            .state('menu.criticalIlnessPremiumCalulation', {
                url: '/criticalIlnessPremiumCalulation',
                data: {
                    pageId: 'GI_CRTLPRMCALC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/criticalIlnessPremiumCalulation.html',
                        controller: 'criticalIlnessPremiumCalulationController',
                        controllerAs: 'criticalIlnessPremiumCalulationVm',
                    }
                }
            })
            .state('menu.simpleHealthPremiumCalulation', {
                url: '/simpleHealthPremiumCalulation',
                data: {
                    pageId: 'GI_SMPHLTHPRMCALC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/simpleHealthPremiumCalulation.html',
                        controller: 'simpleHealthPremiumCalulationController',
                        controllerAs: 'simpleHealthPremiumCalulationVm',
                    }
                }
            })
            .state('menu.healthInsureDetail', {
                url: '/healthInsureDetail',
                data: {
                    pageId: 'GI_HLTHINSRDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/healthInsureDetail.html',
                        controller: 'healthInsureDetailController',
                        controllerAs: 'healthInsureDetailVm',
                    }
                }
            })
            .state('menu.simpleHealthadditnolDetail', {
                url: '/simpleHealthadditnolDetail',
                data: {
                    pageId: 'GI_SMPHLTHADDLDETL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/simplehealthadditionDetail.html',
                        controller: 'simpleHealthadditnolDetailController',
                        controllerAs: 'simpleHealthadditnolDetailVm',
                    }
                }
            })
            .state('menu.simpleHealthQuestionarie', {
                url: '/simpleHealthQuestionarie',
                data: {
                    pageId: 'GI_SMPHLTHQTNE'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/simplehealthquestionaire.html',
                        controller: 'simpleHealthQuestionaireController',
                        controllerAs: 'simpleHealthQuestionaireInformationVm',
                    }
                }
            })
            .state('menu.simpleHealthPreExistingDesease', {
                url: '/simpleHealthPreExistingDesease',
                data: {
                    pageId: 'GI_SMPHLTHPREEXTGDISE'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/simplePreExistingDesease.html',
                        controller: 'simplePreExistingDeseaseController',
                        controllerAs: 'simplePreExistingDeseaseVm',
                    }
                }
            })
            .state('menu.hospitalDailyCashPremiumCalculation', {
                url: '/hospitalDailyCashPremiumCalculation',
                data: {
                    pageId: 'GI_HSPLDLYCSHPRMCALC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/hospitalDailyCashPremiumCalculation.html',
                        controller: 'hospitalDailyCashPremiumCalculationController',
                        controllerAs: 'hospitalDailyCashPremiumCalculationVm',
                    }
                }
            })
            .state('menu.declaimer', {
                url: '/declaimer',
                data: {
                    pageId: 'GI_DISCLAIMER'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/declaimer.html',
                        controller: 'declaimerController',
                        controllerAs: 'declaimerVm',
                    }
                }
            })
            .state('menu.renewpayment', {
                url: '/renewpayment',
                data: {
                    pageId: 'GI_RENEWPAY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/common/renewpayment.html',
                        controller: 'renewpaymentController',
                        controllerAs: 'renewpaymentVm',
                    }
                }
            })
            .state('menu.healthInsHome', {
                url: '/healthInsHome',
                data: {
                    pageId: 'GI_HLTHINSHOME'
                },                
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/healthINS/healthInsHome.html',
                        controller: 'healthInsHomeController',
                        controllerAs: 'healthInsHomeVm',
                    }
                }
            })
            .state('menu.healthInsIndividual', {
                url: '/healthInsIndividual',
                data: {
                    pageId: 'GI_HLTHINSINDVL'
                },                
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/healthINS/healthInsIndividual.html',
                        controller: 'healthInsIndividualController',
                        controllerAs: 'healthInsIndividualVm',
                    }
                }
            })

            // Arogya Sanjeevani States
            .state('menu.arsaQuoteCalculation', {
                url: '/arsaQuoteCalculation',
                data: {
                    pageId: 'GI_AROGYA_SANJEEVANI'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/arogyaSanjeevani/quoteCalculation.html',
                        controller: 'sanjeevaniQuoteCalculationController',
                        controllerAs: 'quoteCalculationControllerVm',
                    }
                }
            })
            .state('menu.arsaProposerDetails', {
                url: '/arsaProposerDetails',
                data: {
                    pageId: 'ARSA_PROPO_DET'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/arogyaSanjeevani/arsaProposerDetails.html',
                        controller: 'arsaProposerDetailsController',
                        controllerAs: 'arsaProposerDetailsVm',
                    }
                }
            })
             .state('menu.arsaMembersDetails', {
                url: '/arsaMembersDetails',
                data: {
                    pageId: 'ARSA_MEMBERS_DETAILS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/arogyaSanjeevani/membersDetails.html',
                        controller: 'arsaMemberDetailsController',
                        controllerAs: 'memberDetailsControllerVm',
                    }
                }
            })
            .state('menu.arsaPolicyHolder', {
                url: '/arsaPolicyHolder',
                data: {
                    pageId: 'ARSA_PLYHOL'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/arogyaSanjeevani/arsaPolicyHolder.html',
                        controller: 'arsaPolicyHolderController',
                        controllerAs: 'arsaPolicyHolderVm',
                    }
                }
            })
            .state('menu.arsaEinsurance', {
                url: '/arsaEinsurance',
                data: {
                    pageId: 'ARSA_EINC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/arogyaSanjeevani/arsaEinsurance.html',
                        controller: 'arsaEinsuranceController',
                        controllerAs: 'arsaEinsuranceVm',
                    }
                }
            })
            .state('menu.arsaMedicalQuestion', {
                url: '/arsaMedicalQuestion',
                data: {
                    pageId: 'ARSA_EINC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/arogyaSanjeevani/arsaMedicalQuestion.html',
                        controller: 'arsaMedicalQuestionController',
                        controllerAs: 'arsaMedicalQuestionVm',
                    }
                }
            })
            .state('menu.arsaNomineeDetails', {
                url: '/arsaNomineeDetails',
                data: {
                    pageId: 'ARSA_NOMNEE_DETLS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/arogyaSanjeevani/arsaNomineeDetails.html',
                        controller: 'arsaNomineeDetailsController',
                        controllerAs: 'arsaNomineeDetailsVm',
                    }
                }
            })
             .state('menu.arsaPayment', {
                url: '/arsaPayment',
                data: {
                    pageId: 'ARSA_PAY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/arogyaSanjeevani/arsaPayment.html',
                        controller: 'arsaPaymentController',
                        controllerAs: 'arsaPaymentVm',
                    }
                }
            })
            .state('menu.arsaQuoteSummary', {
                url: '/arsaQuoteSummary',
                data: {
                    pageId: 'ARSA_QUOTE_SUMMARY'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/arogyaSanjeevani/arsaQuoteSummary.html',
                        controller: 'arsaQuoteSummaryController',
                        controllerAs: 'quoteSummaryControllerVm',
                    }
                }
            })
            .state('menu.arsaOTPPayment', {
                url: '/arsaOTPPayment',
                data: {
                    pageId: 'ARSA_OTP_PAYMENT'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/arogyaSanjeevani/arsaOTPPayment.html',
                        controller: 'arsaOTPPaymentController',
                        controllerAs: 'OTPPaymentControllerVm',
                    }
                }
            })
             .state('menu.arsaPaymentSuceess', {
                url: '/arsaPaymentSuceess',
                data: {
                    pageId: 'ARSA_PAYMENT_SUCCESS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/health/arogyaSanjeevani/arsaPaymentSuccess.html',
                        controller: 'arsaPaymentSuceessController',
                        controllerAs: 'paymentSuccessVm',
                    }
                }
            })
            .state('menu.paiLinkingSuccess', {
                url: '/paiLinkingSuccess',
                data: {
                    pageId: 'PAI_LINKING_SUCCESS'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/personalAccident/linkingRenewal/linkingSuccess.html',
                        controller: 'paiLinkingSuccessController',
                        controllerAs: 'paiLinkingSuccessVm',
                    }
                }
            })
            .state('menu.paiLinkingFAQ', {
                url: '/paiLinkingFAQ',
                data: {
                    pageId: 'PAI_LINKING_FAQ'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/personalAccident/linkingRenewal/linkingFAQ.html',
                        controller: 'paiLinkingFAQController',
                        controllerAs: 'paiLinkingFAQVm',
                    }
                }
            })
            .state('menu.cancelStructure', {
                url: '/cancelStructure',
                data: {
                    pageId: 'PAI_CAN_STRUT'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/personalAccident/cancelAndEndorse/cancelDetails.html',
                        controller: 'cancelDetailsController',
                        controllerAs: 'cancelDetailsVm',
                    }
                }
            })
            .state('menu.consentPage', {
                url: '/consentPage',
                data: {
                    pageId: 'PAI_CAN_CON'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/personalAccident/cancelAndEndorse/consentPage.html',
                        controller: 'consentPageController',
                        controllerAs: 'consentPageVm',
                    }
                }
            })
            .state('menu.paiCancelSucces', {
                url: '/paiCancelSucces',
                data: {
                    pageId: 'PAI_CAN_SUCC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/personalAccident/cancelAndEndorse/paiCancelSucccess.html',
                        controller: 'paiCancelSucccessController',
                        controllerAs: 'paiCancelSucccessVm',
                    }
                }
            })
            .state('menu.paiEndorseDetails', {
                url: '/paiEndorseDetails',
                data: {
                    pageId: 'PAI_CAN_SUCC'
                },
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/personalAccident/cancelAndEndorse/paiEndorseDetails.html',
                        controller: 'paiEndorseDetailsController',
                        controllerAs: 'paiEndorseDetailsVm',
                    }
                }
            })
             .state('menu.leadGenerationInsurance', {
                url: '/leadGenerationInsurance',
                data: {
                    pageId: 'LEAD_GEN_INSURANCE'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/leadGenerationInsurance.html',
                        controller: 'leadGenerationInsuranceController',
                        controllerAs: 'leadGenerationInsuranceVm'
                    }
                }
            })
            .state('menu.moreProducts', {
                url: '/moreProducts',
                data: {
                    pageId: 'INS_MORE_PRODUCTS'
                },
                cache: false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/generalInsurance/moreProducts.html',
                        controller: 'moreProductsController',
                        controllerAs: 'moreProductsControllerVm'
                    }
                }
            })
    }
]);
