angularApp.controller('arsaMedicalQuestionController',
 ["$state", "$scope", "$filter",
    "validateService", "generalInsurenceHealthService",
    "generalInsurenceHomeService", "GIconstant", "utilityService",
    "$translate","arogyaSanjeevaniService",


    function ( $state, $scope, $filter, validateService,
        generalInsurenceHealthService, generalInsurenceHomeService,
        GIconstant, utilityService, $translate, arogyaSanjeevaniService) {

        var arsaMedicalQuestionVm = this;
        arsaMedicalQuestionVm.validateService = validateService;
        arsaMedicalQuestionVm.data = {};
        arsaMedicalQuestionVm.medicalDetails = {};
        var arogyaData='';

        /* Function to display the necessary information
         & put validation on Page load*/
        arsaMedicalQuestionVm.initPage = function (){
            arsaMedicalQuestionVm.selectedNo=true;
            arsaMedicalQuestionVm.member=arogyaSanjeevaniService.getbasicHealthDetail().familySize;
            arsaMedicalQuestionVm.premium = arogyaSanjeevaniService.getPremiumData() ? arogyaSanjeevaniService.getPremiumData().estPremium : "";            
            arsaMedicalQuestionVm.question = generalInsurenceHealthService.getArogyaMasterList() ? generalInsurenceHealthService.getArogyaMasterList().arogyaSanjeevaniQuestions  : [{'key':'1','value':'1'}];
            arsaMedicalQuestionVm.healthDetails=arogyaSanjeevaniService.getHealthAdditionalDetails();

            arsaMedicalQuestionVm.questionAns = [];
            arsaMedicalQuestionVm.finalSetQuetions=[];
            arsaMedicalQuestionVm.qList = [];            
            
            arsaMedicalQuestionVm.data.questions = [];
            
            for(var count = 0; count < arsaMedicalQuestionVm.member; count++) {        
                arsaMedicalQuestionVm.qList.push(arsaMedicalQuestionVm.healthDetails.title[count].value+'.'+arsaMedicalQuestionVm.healthDetails.name[count] +' '+ arsaMedicalQuestionVm.healthDetails.lastName[count]);                      
                if(arogyaSanjeevaniService.getArogyaQuestion()){
                    //if value  present in arogyaData
                    arsaMedicalQuestionVm.getRetrive(count);
                }else{
                    //if value not present in arogyaData
                    arsaMedicalQuestionVm.healthDefaultQuestions(count);
                }
            }
                                
      }

      /* Function to retrieve the questions */
        arsaMedicalQuestionVm.getRetrive = function(i){ 
            arsaMedicalQuestionVm.questionAns=arogyaSanjeevaniService.getArogyaQuestion().insuredQuestions; 
            arogyaData=arogyaSanjeevaniService.getArogyaQuestion();                 
            if(arogyaData.insuredQuestions[i].selectedSmoke == true){
                arsaMedicalQuestionVm["selectedSmoke"+[i].toString()] =true;
            }else{
                arsaMedicalQuestionVm["selectedSmoke"+[i].toString()] =false;
            }  

            if(arogyaData.insuredQuestions[i].selectedTobaco == true){
                arsaMedicalQuestionVm["selectedTobaco"+[i].toString()] =true;
            }else{
                arsaMedicalQuestionVm["selectedTobaco"+[i].toString()] =false;
            } 

            if(arogyaData.insuredQuestions[i].selectedAlcohol == true){
                arsaMedicalQuestionVm["selectedAlcohol"+[i].toString()] =true;
            }else{
                arsaMedicalQuestionVm["selectedAlcohol"+[i].toString()] =false;
            }
               
        }

        //on Back btn operation
        arsaMedicalQuestionVm.goBacktoPrevious = function () {
             $state.go("menu.arsaPolicyHolder");
        }

       //on Next btn operation
        arsaMedicalQuestionVm.goToNextPage = function () {
            arsaMedicalQuestionVm.medicalDetails.existingIllness=false;
            arsaMedicalQuestionVm.medicalDetails.deniedInsurance=false;
            arsaMedicalQuestionVm.medicalDetails.insuredQuestions=arsaMedicalQuestionVm.questionAns;
            arsaMedicalQuestionVm.saveApplicationArogya();
            arogyaSanjeevaniService.setArogyaQuestion(arsaMedicalQuestionVm.medicalDetails);
        }

        //on btn Yes click opration first 2 btn
        arsaMedicalQuestionVm.healthYesAns = function(){
           var healthMsg=$translate.instant("AOGYA_YESMSG");
           arogyaSanjeevaniService.showErrorCaution(healthMsg, "", "OK");
        }

       //on btn Yes click opration
       arsaMedicalQuestionVm.healthSubYesAns = function(keyValue,secondValue){
              if(secondValue=="selectedSmoke"+keyValue) {
                    arsaMedicalQuestionVm["selectedSmoke"+keyValue.toString()] =true;                
                    arsaMedicalQuestionVm.addQuestionToList(arsaMedicalQuestionVm.questionAns,"selectedSmoke",arsaMedicalQuestionVm["selectedSmoke"+keyValue.toString()],keyValue);                    
               }
                if(secondValue=="selectedTobaco"+keyValue){
                    arsaMedicalQuestionVm["selectedTobaco"+keyValue.toString()] =true;                  
                    arsaMedicalQuestionVm.addQuestionToList(arsaMedicalQuestionVm.questionAns,"selectedTobaco",arsaMedicalQuestionVm["selectedTobaco"+keyValue.toString()],keyValue);                 
               }
                if(secondValue=="selectedAlcohol"+keyValue){    
                    arsaMedicalQuestionVm["selectedAlcohol"+keyValue.toString()] =true;                  
                    arsaMedicalQuestionVm.addQuestionToList(arsaMedicalQuestionVm.questionAns,"selectedAlcohol",arsaMedicalQuestionVm["selectedAlcohol"+keyValue.toString()],keyValue);              
                   
               }         
       }

       //on btn No click opration
       arsaMedicalQuestionVm.healthSubNoAns = function(keyValue,secondValue){
            if(secondValue=="selectedSmoke"+keyValue){          
                arsaMedicalQuestionVm["selectedSmoke"+keyValue.toString()] =false;                 
                arsaMedicalQuestionVm.addQuestionToList(arsaMedicalQuestionVm.questionAns,"selectedSmoke",arsaMedicalQuestionVm["selectedSmoke"+keyValue.toString()],keyValue);                           
            }              
            if(secondValue=="selectedTobaco"+keyValue){
                    arsaMedicalQuestionVm["selectedTobaco"+keyValue.toString()] =false;                  
                    arsaMedicalQuestionVm.addQuestionToList(arsaMedicalQuestionVm.questionAns,"selectedTobaco",arsaMedicalQuestionVm["selectedTobaco"+keyValue.toString()],keyValue);

            }
            if(secondValue=="selectedAlcohol"+keyValue){   
                arsaMedicalQuestionVm["selectedAlcohol"+keyValue.toString()] =false;  
                arsaMedicalQuestionVm.addQuestionToList(arsaMedicalQuestionVm.questionAns,"selectedAlcohol",arsaMedicalQuestionVm["selectedAlcohol"+keyValue.toString()],keyValue);                    
                                    
            }
        
       }
       //default question to be loaded on page load
       arsaMedicalQuestionVm.healthDefaultQuestions = function(keyValue){          
            arsaMedicalQuestionVm["selectedSmoke"+keyValue.toString()] =false;                       
            arsaMedicalQuestionVm["selectedTobaco"+keyValue.toString()] =false;                  
            arsaMedicalQuestionVm["selectedAlcohol"+keyValue.toString()] =false;                                                
            //below 2 scenario is for default selected questions
            arsaMedicalQuestionVm["existingIllness"+keyValue.toString()] =false;                                     
            arsaMedicalQuestionVm["deniedInsurance"+keyValue.toString()] =false;                                     
            arsaMedicalQuestionVm.questionAns.push({selectedSmoke: arsaMedicalQuestionVm["selectedSmoke"+keyValue.toString()], selectedTobaco: arsaMedicalQuestionVm["selectedTobaco"+keyValue.toString()], selectedAlcohol: arsaMedicalQuestionVm["selectedAlcohol"+keyValue.toString()]}); 
       }
      
      //to Add into ArrayList of question selected wheather true or false  
       arsaMedicalQuestionVm.addQuestionToList = function(arrayValue,value1,value2,index) {
              
          if(value1=='selectedSmoke'){
            if(arsaMedicalQuestionVm.questionAns[index].selectedSmoke==false)
                 arsaMedicalQuestionVm.questionAns[index].selectedSmoke=true;
            else
                arsaMedicalQuestionVm.questionAns[index].selectedSmoke=false;
            
          }else if(value1=='selectedTobaco'){
            if(arsaMedicalQuestionVm.questionAns[index].selectedTobaco==false)
                 arsaMedicalQuestionVm.questionAns[index].selectedTobaco=true;
            else
                arsaMedicalQuestionVm.questionAns[index].selectedTobaco=false;

          }else if(value1=='selectedAlcohol'){
            if(arsaMedicalQuestionVm.questionAns[index].selectedAlcohol==false)
                 arsaMedicalQuestionVm.questionAns[index].selectedAlcohol=true;
            else
                arsaMedicalQuestionVm.questionAns[index].selectedAlcohol=false;
          }

         }

        /* save application for Arogya Sanjeevani  */
        arsaMedicalQuestionVm.saveApplicationArogya = function() {           
            var stringifyStructure1 = arogyaSanjeevaniService.getSaveApplicationArogyaStructure();
            var structure = stringifyStructure1;
            if(typeof(structure.quoteData)=='string'){
                structure.quoteData = JSON.parse(structure.quoteData);
            }
            var firstPageDetail = arogyaSanjeevaniService.getSaveQuoteRequestForArogya();
            var applicationNo = arogyaSanjeevaniService.getSaveApplicationArogyaResponse();
            firstPageDetail.quoteData = structure.quoteData;
            firstPageDetail.quoteData.premiumCalculation.request.medicalQuestions = {};
            firstPageDetail.quoteData.premiumCalculation.request.medicalQuestions = arsaMedicalQuestionVm.medicalDetails;   
            structure.applicationNumber = applicationNo.applicationNumber;
            structure.sumInsured =  arogyaSanjeevaniService.getpolicySumInsured() ?  arogyaSanjeevaniService.getpolicySumInsured() : "";   
            structure.policyStartDate =   arogyaSanjeevaniService.getpolicyStartdate() ?   arogyaSanjeevaniService.getpolicyStartdate() : "";
            structure.quoteData = firstPageDetail.quoteData;
            structure.applicationData = GIconstant.OmniChannel.ArogyaSanjeevani.AP_HEALTH_QA;
            var stringified = structure;
            if(typeof(stringified.quoteData)=='object'){
                stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            arogyaSanjeevaniService.setSaveApplicationArogyaStructure(structure);
            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.ArogyaSanjeevani.AP_HEALTH_QA).then(function(data) {
                arogyaSanjeevaniService.setSaveApplicationArogyaResponse(data);
                $state.go("menu.arsaNomineeDetails");
            }, function(error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
        }
        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            arsaMedicalQuestionVm.initPage();
        });

    }
]);
