angularApp.controller('arsaQuoteSummaryController', 
    ["$state","$scope", "$filter", "generalInsurenceHomeService", "GIconstant", "utilityService", 
    "$translate","arogyaSanjeevaniService",


    function($state, $scope, 
        $filter, generalInsurenceHomeService, 
        GIconstant, utilityService, $translate, arogyaSanjeevaniService) {

        var quoteSummaryControllerVm = this;
        quoteSummaryControllerVm.constant = GIconstant;
        quoteSummaryControllerVm.showBack = true;
        quoteSummaryControllerVm.showNext = true;
        quoteSummaryControllerVm.showterms = true;

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            quoteSummaryControllerVm.initPage();
        });

        /* Function to display the necessary information
         & put validation on Page load*/
        quoteSummaryControllerVm.initPage = function() {
            quoteSummaryControllerVm.product = {};
            quoteSummaryControllerVm.product.isChecked = arogyaSanjeevaniService.getPremiumData().isChecked ? arogyaSanjeevaniService.getPremiumData().isChecked : false;
            quoteSummaryControllerVm.product.SumInsured  = arogyaSanjeevaniService.getpolicySumInsured();
            quoteSummaryControllerVm.product.policyTerm = quoteSummaryControllerVm.constant.ArogyaSanjeevani.PolicyTerm;
            quoteSummaryControllerVm.product.estPremium = arogyaSanjeevaniService.getPremiumData() ? arogyaSanjeevaniService.getPremiumData().estPremium : "";
            if(quoteSummaryControllerVm.product.isChecked) {
                quoteSummaryControllerVm.product.quoteSummaryTCTime = arogyaSanjeevaniService.getPremiumData().quoteSummaryTCTime ? arogyaSanjeevaniService.getPremiumData().quoteSummaryTCTime : "";
            } else {
                quoteSummaryControllerVm.product.quoteSummaryTCTime = "";
            }
    }

        /* fuction to save time on T&C Click  */
        quoteSummaryControllerVm.onTnCondClick = function(isChecked) {
            if(isChecked) {
                var presentDate = new Date();
                var timeInMilliSec = presentDate.getTime();
                quoteSummaryControllerVm.product.quoteSummaryTCTime = timeInMilliSec;
            }
        }


        /* save application for Arogya Premium  */
        quoteSummaryControllerVm.saveApplicationArogya = function () {
            var stringifyStructure1 = arogyaSanjeevaniService.getSaveApplicationArogyaStructure();
            var structure = stringifyStructure1;
            if(typeof(structure.quoteData)=='string'){
                structure.quoteData = JSON.parse(structure.quoteData);
            }
            var firstPageDetail = arogyaSanjeevaniService.getSaveQuoteRequestForArogya();
            var premiumDetail = arogyaSanjeevaniService.getPremiumcalculationForArogyaPremium();
            var applicationNo = arogyaSanjeevaniService.getSaveApplicationArogyaResponse();
            firstPageDetail.quoteData = structure.quoteData;
            firstPageDetail.quoteData.premiumCalculation.request.premiumCalc = {};
            firstPageDetail.quoteData.premiumCalculation.request.premiumCalc = quoteSummaryControllerVm.product;
            firstPageDetail.quoteData.premiumCalculation.response = premiumDetail;
            structure.quoteData = firstPageDetail.quoteData;
            structure.sumInsured =  arogyaSanjeevaniService.getpolicySumInsured() ?  arogyaSanjeevaniService.getpolicySumInsured() : "";   
            structure.policyStartDate =   arogyaSanjeevaniService.getpolicyStartdate() ?   arogyaSanjeevaniService.getpolicyStartdate() : "";
            firstPageDetail.quoteData.premiumCalculation.quotes = {};
            firstPageDetail.quoteData.premiumCalculation.quotes.amount = quoteSummaryControllerVm.product.estPremium;   
            structure.applicationNumber = applicationNo.applicationNumber;
            structure.applicationData = GIconstant.OmniChannel.ArogyaSanjeevani.AP_PREMIUM_RESULT;
            var stringified = structure;
            if(typeof(stringified.quoteData)=='object'){
              stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            arogyaSanjeevaniService.setSaveApplicationArogyaStructure(structure);
            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.ArogyaSanjeevani.AP_PREMIUM_RESULT).then(function(data) {
                arogyaSanjeevaniService.setPremiumData(quoteSummaryControllerVm.product);
                $state.go("menu.arsaProposerDetails");
            }, function(error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
        }

        /* Function to show Declaration Popup*/
        quoteSummaryControllerVm.clickDeclaration =  function(){
            generalInsurenceHomeService.getDiclaration().then(function(data) {   
            }, function(error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
         }

        /*  go to Previous page */
        quoteSummaryControllerVm.goBacktoPrevious = function() {
            $state.go("menu.arsaMembersDetails");
        }

         /*  go to next page */
        quoteSummaryControllerVm.goToNextPage = function() {
            quoteSummaryControllerVm.saveApplicationArogya();
        }

    }
]);
