angularApp.controller('healthApplicationNomineeDetailsController', [
    "$state",
    "$scope", "validateService", "$filter","generalInsurenceHealthService","generalInsurenceHomeService",


    function(
        $state,
        $scope, validateService,$filter,generalInsurenceHealthService,generalInsurenceHomeService) {

        var healthApplicationNomineeDetailsVm = this;

        function initPage() {
            healthApplicationNomineeDetailsVm.healthtype = generalInsurenceHealthService.gethealthType();
            healthApplicationNomineeDetailsVm.Relationships = [
                { "relation": "Wife" },
                { "relation": "Son" }, { "relation": "Daughter" },
            ];
            healthApplicationNomineeDetailsVm.showBack = true;
            healthApplicationNomineeDetailsVm.showNext = true;
            healthApplicationNomineeDetailsVm.disableBack = false;
            healthApplicationNomineeDetailsVm.disableNext = false;
                 healthApplicationNomineeDetailsVm.maxEndDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());

                
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });


         $scope.$on('$ionicView.beforeEnter', function() {
              initPage();
        });




        //validation function starts
        healthApplicationNomineeDetailsVm.detailsPage = {};

        //onkeyup validate fields if required
        healthApplicationNomineeDetailsVm.validateService = validateService;






        //validation for for,

        function validateForm() {
            healthApplicationNomineeDetailsVm.detailsPage = {};
            if (healthApplicationNomineeDetailsVm.validateService.isValidName(healthApplicationNomineeDetailsVm.name)) {
                healthApplicationNomineeDetailsVm.detailsPage.name = healthApplicationNomineeDetailsVm.validateService.isValidName(healthApplicationNomineeDetailsVm.name);
            }

            if (healthApplicationNomineeDetailsVm.validateService.isValidbirthDate(healthApplicationNomineeDetailsVm.Birthdate)) {
                healthApplicationNomineeDetailsVm.detailsPage.Birthdate = healthApplicationNomineeDetailsVm.validateService.isValidbirthDate(healthApplicationNomineeDetailsVm.Birthdate);
            }


            if (healthApplicationNomineeDetailsVm.validateService.isValidRelationship(healthApplicationNomineeDetailsVm.relationship)) {
                healthApplicationNomineeDetailsVm.detailsPage.relationship = healthApplicationNomineeDetailsVm.validateService.isValidRelationship(healthApplicationNomineeDetailsVm.relationship);
            }

            if (!healthApplicationNomineeDetailsVm.nomineeaddress) {
                if (healthApplicationNomineeDetailsVm.validateService.isValidAdress(healthApplicationNomineeDetailsVm.address)) {
                    healthApplicationNomineeDetailsVm.detailsPage.address = healthApplicationNomineeDetailsVm.validateService.isValidAdress(healthApplicationNomineeDetailsVm.address);
                }

                if (healthApplicationNomineeDetailsVm.validateService.isValidPincode(healthApplicationNomineeDetailsVm.pincode)) {
                    healthApplicationNomineeDetailsVm.detailsPage.pincode = healthApplicationNomineeDetailsVm.validateService.isValidPincode(healthApplicationNomineeDetailsVm.pincode);
                }

            }
            if (healthApplicationNomineeDetailsVm.minor) {
                if (healthApplicationNomineeDetailsVm.validateService.isValidName(healthApplicationNomineeDetailsVm.AppointeeName)) {
                    healthApplicationNomineeDetailsVm.detailsPage.AppointeeName = healthApplicationNomineeDetailsVm.validateService.isValidName(healthApplicationNomineeDetailsVm.AppointeeName);
                }

                if (healthApplicationNomineeDetailsVm.validateService.isValidbirthDate(healthApplicationNomineeDetailsVm.AppointeeBirthdate)) {
                    healthApplicationNomineeDetailsVm.detailsPage.AppointeeBirthdate = healthApplicationNomineeDetailsVm.validateService.isValidbirthDate(healthApplicationNomineeDetailsVm.AppointeeBirthdate);
                }



                if (healthApplicationNomineeDetailsVm.validateService.isValidRelationshipProposer(healthApplicationNomineeDetailsVm.EnsureRelationship)) {
                    healthApplicationNomineeDetailsVm.detailsPage.EnsureRelationship = healthApplicationNomineeDetailsVm.validateService.isValidRelationshipProposer(healthApplicationNomineeDetailsVm.EnsureRelationship);
                }

                if (healthApplicationNomineeDetailsVm.validateService.isValidRelationshipNominee(healthApplicationNomineeDetailsVm.RelationshipwithNominee)) {
                    healthApplicationNomineeDetailsVm.detailsPage.RelationshipwithNominee = healthApplicationNomineeDetailsVm.validateService.isValidRelationshipNominee(healthApplicationNomineeDetailsVm.RelationshipwithNominee);
                }
            }



            return (angular.equals({}, healthApplicationNomineeDetailsVm.detailsPage)) ? true : false;
        }





        healthApplicationNomineeDetailsVm.goBacktoPrevious = function() {
            //To do
            $state.go("menu.healthApplicationPersonalDetails");
        }

        healthApplicationNomineeDetailsVm.goToNextPage = function() {
            if (validateForm()) {
                $state.go("menu.healthApplicationHealthInformation");
            }


            //To do
        }
    }
]);
