angularApp.controller('simpleHealthQuestionaireController', [
    "$state",
    "$scope",
    "$translate", "$ionicPopup", "generalInsurenceHealthService", "validateService", "generalInsurenceHomeService", "utilityService","GIconstant","clickStreamService",


    function(
        $state,
        $scope,
        $translate, $ionicPopup, generalInsurenceHealthService, validateService, generalInsurenceHomeService, utilityService,GIconstant,clickStreamService) {

        var simpleHealthQuestionaireInformationVm = this;
        simpleHealthQuestionaireInformationVm.simpleHealthQuestionary = {};
        simpleHealthQuestionaireInformationVm.data = [];
        // simpleHealthQuestionaireInformationVm.data.insuredName = {};
        var member;

        function initPage() {
        
             simpleHealthQuestionaireInformationVm.constant = GIconstant;
              var  healthType = generalInsurenceHomeService.getProductDetail().uin;
             if (healthType == simpleHealthQuestionaireInformationVm.constant.Health.arogya) {
                simpleHealthQuestionaireInformationVm.healthtype = $translate.instant('AROGYAPREMIER');
            } else if (healthType == simpleHealthQuestionaireInformationVm.constant.Health.hdc) {
                simpleHealthQuestionaireInformationVm.healthtype = $translate.instant('HOSPITAL_DAILY_CASH');
            } else if (healthType == simpleHealthQuestionaireInformationVm.constant.Health.simple) {
                simpleHealthQuestionaireInformationVm.healthtype = $translate.instant('simpleHealth');
            } else if (healthType == simpleHealthQuestionaireInformationVm.constant.Health.critical) {
                simpleHealthQuestionaireInformationVm.healthtype =$translate.instant('CRITICAL_ILLNESS');
            }



            simpleHealthQuestionaireInformationVm.insuredDeseaseList = [];
            var previouspageData = generalInsurenceHealthService.getHealthQuestionaire();

            if (previouspageData) {
                simpleHealthQuestionaireInformationVm.data = previouspageData;
                simpleHealthQuestionaireInformationVm.insuredDeseaseList = [];
                for(var count =0; count < simpleHealthQuestionaireInformationVm.data.length;count++){
                    if(count == 0){
                        simpleHealthQuestionaireInformationVm.insuredDeseaseList[count] = 0;
                    }else{
                         simpleHealthQuestionaireInformationVm.insuredDeseaseList.push(Math.max.apply(null, simpleHealthQuestionaireInformationVm.insuredDeseaseList) + 1);
                    }
                }
            }

            simpleHealthQuestionaireInformationVm.showBack = true;
            simpleHealthQuestionaireInformationVm.showNext = true;
            simpleHealthQuestionaireInformationVm.disableBack = false;
            simpleHealthQuestionaireInformationVm.disableNext = false;
            member = generalInsurenceHealthService.getbasicHealthDetail().familySize;
            simpleHealthQuestionaireInformationVm.member = member;

            var insuredDetails = [];
            insuredDetails = generalInsurenceHealthService.getHealthAdditionalDetails().name;
            var insuredAllDetails = generalInsurenceHealthService.getHealthAdditionalDetails();

            simpleHealthQuestionaireInformationVm.memeberList = [];
            
            for (var count = 0; count < member; count++) {
                simpleHealthQuestionaireInformationVm.memeberList.push(count);
                insuredDetails[count] =  insuredDetails[count] + " " + insuredAllDetails.lastName[count];
             }


            if (!previouspageData) {
                for (var i = 0; i < member; i++) {
                    simpleHealthQuestionaireInformationVm.data[i] = {};
                    simpleHealthQuestionaireInformationVm.data[i].insuredName = insuredDetails[i];
                }
            }else{
                for (var i = 0; i < member; i++) {
                    if(simpleHealthQuestionaireInformationVm.data && simpleHealthQuestionaireInformationVm.data[i]){
                        if(!simpleHealthQuestionaireInformationVm.data[i].insuredName){
                             simpleHealthQuestionaireInformationVm.data[i].insuredName = insuredDetails[i];
                        }
                    }
                }

            }

            if (!previouspageData) {
                /* set name of insured person  */
                simpleHealthQuestionaireInformationVm.nameList = [];
                for (var i = 0; i < member; i++) {
                    simpleHealthQuestionaireInformationVm.data[i].insuredNameList = insuredDetails[i];
                    simpleHealthQuestionaireInformationVm.nameList.push(simpleHealthQuestionaireInformationVm.data[i].insuredNameList);
                }
            }else{

                if(!simpleHealthQuestionaireInformationVm.nameList){
                    simpleHealthQuestionaireInformationVm.nameList = [];
                    for (var i = 0; i < member; i++) {
                    simpleHealthQuestionaireInformationVm.data[i].insuredNameList = insuredDetails[i];
                    simpleHealthQuestionaireInformationVm.nameList.push(simpleHealthQuestionaireInformationVm.data[i].insuredNameList);
                }

              }
            }
        }

        simpleHealthQuestionaireInformationVm.addMemberDeseaseInfo = function() {
            if (simpleHealthQuestionaireInformationVm.insuredDeseaseList.length < member) {

                simpleHealthQuestionaireInformationVm.insuredDeseaseList.push(Math.max.apply(null, simpleHealthQuestionaireInformationVm.insuredDeseaseList) + 1);
                simpleHealthQuestionaireInformationVm.data[Math.max.apply(null, simpleHealthQuestionaireInformationVm.insuredDeseaseList)] = {};

            }
        }

        simpleHealthQuestionaireInformationVm.deleteMemberDeseaseInfo = function(index) {
            simpleHealthQuestionaireInformationVm.insuredDeseaseList.splice(index, 1);
        }


        simpleHealthQuestionaireInformationVm.chkForDeseaseList = function() {
            if (simpleHealthQuestionaireInformationVm.data[0].individualDeseaseList) {
                simpleHealthQuestionaireInformationVm.insuredDeseaseList = [0];
            } else {
                simpleHealthQuestionaireInformationVm.insuredDeseaseList = [];
            }
        }



        /* save application for simple health  */
        function saveApplicationSH() {
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationHealthStructure();
            var structure = stringifyStructure1;

             if(typeof(structure.applicationData)=='string'){
               structure.applicationData = JSON.parse(structure.applicationData);
            }


            var insuredDetail = generalInsurenceHealthService.getSaveApplicationRequestForSimpleHealth();
            insuredDetail.applicationData.createquoterequest.otherTreatment = simpleHealthQuestionaireInformationVm.data[0].accident ? simpleHealthQuestionaireInformationVm.data[0].accident : "false";
            insuredDetail.applicationData.createquoterequest.healthInformation = simpleHealthQuestionaireInformationVm.data[0].smoke ? simpleHealthQuestionaireInformationVm.data[0].smoke : "false";
            if (insuredDetail.applicationData.createquoterequest.healthInformation != "false") {
                for (var count = 0; count < member; count++) {
                    insuredDetail.applicationData.createquoterequest.healthInformationDetails[count] = {};
                    insuredDetail.applicationData.createquoterequest.healthInformationDetails[count].name = simpleHealthQuestionaireInformationVm.data[count].insuredName;
                    insuredDetail.applicationData.createquoterequest.healthInformationDetails[count].doYouSmoke = simpleHealthQuestionaireInformationVm.data[count].smokestatus ? simpleHealthQuestionaireInformationVm.data[count].smokestatus : "false";
                    insuredDetail.applicationData.createquoterequest.healthInformationDetails[count].doYouConsumeTobacco = simpleHealthQuestionaireInformationVm.data[count].tobacco ? simpleHealthQuestionaireInformationVm.data[count].tobacco : "false";
                    insuredDetail.applicationData.createquoterequest.healthInformationDetails[count].alcoholStatus = simpleHealthQuestionaireInformationVm.data[count].alcoholstatus ? simpleHealthQuestionaireInformationVm.data[count].alcoholstatus : "false";

                }
            }
            insuredDetail.applicationData.createquoterequest.sufferedFromDiseases = simpleHealthQuestionaireInformationVm.data[0].individualDeseaseList ? simpleHealthQuestionaireInformationVm.data[0].individualDeseaseList : "false";
            if (insuredDetail.applicationData.createquoterequest.sufferedFromDiseases != "false") {
                for (var count = 0; count < member; count++) {
                    insuredDetail.applicationData.createquoterequest.insuredPersonDiseasesDetails[count] = {};
                    insuredDetail.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].name = simpleHealthQuestionaireInformationVm.data[count].insuredNameList;
                    insuredDetail.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].hypertension = simpleHealthQuestionaireInformationVm.data[count].isHypertension ? simpleHealthQuestionaireInformationVm.data[count].isHypertension : "false";
                    insuredDetail.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].diabetes = simpleHealthQuestionaireInformationVm.data[count].isDiabetes ? simpleHealthQuestionaireInformationVm.data[count].isDiabetes : "false";
                    insuredDetail.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].asthma = simpleHealthQuestionaireInformationVm.data[count].isAsthma ? simpleHealthQuestionaireInformationVm.data[count].isAsthma : "false";
                    insuredDetail.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].stroke = simpleHealthQuestionaireInformationVm.data[count].isStroke ? simpleHealthQuestionaireInformationVm.data[count].isStroke : "false";
                    insuredDetail.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].hepatits = simpleHealthQuestionaireInformationVm.data[count].isHepatits ? simpleHealthQuestionaireInformationVm.data[count].isHepatits : "false";
                    insuredDetail.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].aids = simpleHealthQuestionaireInformationVm.data[count].isAIDS ? simpleHealthQuestionaireInformationVm.data[count].isAIDS : "false";
                    insuredDetail.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].cancer = simpleHealthQuestionaireInformationVm.data[count].isCancer ? simpleHealthQuestionaireInformationVm.data[count].isCancer : "false";
                }
            }
            structure.applicationData.createquoterequest.otherTreatment = JSON.parse(insuredDetail.applicationData.createquoterequest.otherTreatment);
            structure.applicationData.createquoterequest.healthInformation = JSON.parse(insuredDetail.applicationData.createquoterequest.healthInformation);
            structure.applicationData.createquoterequest.sufferedFromDiseases = JSON.parse(insuredDetail.applicationData.createquoterequest.sufferedFromDiseases);
            structure.applicationData.createquoterequest.healthInformationDetails = [];
            structure.applicationData.createquoterequest.insuredPersonDiseasesDetails = [];
            structure.applicationData.createquoterequest.healthInformationDetails = insuredDetail.applicationData.createquoterequest.healthInformationDetails;
            structure.applicationData.createquoterequest.insuredPersonDiseasesDetails = insuredDetail.applicationData.createquoterequest.insuredPersonDiseasesDetails;
            structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";


            var stringified = structure;
            if(typeof(stringified.applicationData)=='object'){
               stringified.applicationData = JSON.stringify(stringified.applicationData);
            }
            if(typeof(stringified.quoteData)=='object'){
               stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            generalInsurenceHomeService.setSaveApplicationHealthStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.SimpleHealth.SH_HEALTH_QA).then(function(data) {
                $state.go("menu.simpleHealthPreExistingDesease");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);

            });
        }


        //validation function starts
        simpleHealthQuestionaireInformationVm.simpleHealthQuestionaire = {};
        //onkeyup validate fields if required
        simpleHealthQuestionaireInformationVm.validateService = validateService;


        /*  check all field validation  */
        function validateForm() {
            simpleHealthQuestionaireInformationVm.simpleHealthQuestionaire = {};
            if (simpleHealthQuestionaireInformationVm.data && simpleHealthQuestionaireInformationVm.data[0] && simpleHealthQuestionaireInformationVm.data[0].individualDeseaseList) {
                var dataDetail = angular.copy(simpleHealthQuestionaireInformationVm.data);

                for (var i = 0; i < simpleHealthQuestionaireInformationVm.insuredDeseaseList.length; i++) {
                    delete dataDetail[i].insuredNameList;
                    simpleHealthQuestionaireInformationVm.simpleHealthQuestionaire[i] = {};
                    if (simpleHealthQuestionaireInformationVm.validateService.isValidDeseaseList(dataDetail[i])) {
                        simpleHealthQuestionaireInformationVm.simpleHealthQuestionaire[i].error = simpleHealthQuestionaireInformationVm.validateService.isValidDeseaseList(dataDetail[i]);
                    }
                    if (simpleHealthQuestionaireInformationVm.validateService.isValidName(simpleHealthQuestionaireInformationVm.data[i].insuredNameList)) {
                        simpleHealthQuestionaireInformationVm.simpleHealthQuestionaire[i].insuredNameList = simpleHealthQuestionaireInformationVm.validateService.isValidName(simpleHealthQuestionaireInformationVm.data[i].insuredNameList);
                    }
                }
                for (var i = 0; i < simpleHealthQuestionaireInformationVm.insuredDeseaseList.length; i++) {
                    if (simpleHealthQuestionaireInformationVm.simpleHealthQuestionaire[i].error) {
                        return false;
                    }
                    if (simpleHealthQuestionaireInformationVm.simpleHealthQuestionaire[i].insuredNameList) {
                        return false;
                    }
                }
            }
            simpleHealthQuestionaireInformationVm.healthQuestionSelection =  false;
            if(simpleHealthQuestionaireInformationVm.data && simpleHealthQuestionaireInformationVm.data[0] &&simpleHealthQuestionaireInformationVm.data[0].smoke){
                simpleHealthQuestionaireInformationVm.healthQuestionSelection = true;
                 for(var count = 0; count < simpleHealthQuestionaireInformationVm.data.length;count++){
                if(simpleHealthQuestionaireInformationVm.data[count].tobacco || simpleHealthQuestionaireInformationVm.data[count].smokestatus || simpleHealthQuestionaireInformationVm.data[count].alcoholstatus){
                        simpleHealthQuestionaireInformationVm.healthQuestionSelection =  false;
                }
               }
            }
           if(simpleHealthQuestionaireInformationVm.healthQuestionSelection){
                    return false;
           }
            return true;
        }


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        simpleHealthQuestionaireInformationVm.deniedbymainQuestion = function(){
             var alertPopup = $ionicPopup.alert({
                    title: '',
                    templateUrl: 'pages/generalInsurance/health/simpleHealthAccidentPopup.html'
                });
               simpleHealthQuestionaireInformationVm.data[0].accident = false;
        }

        simpleHealthQuestionaireInformationVm.goBacktoPrevious = function() {
            $state.go("menu.simpleHealthadditnolDetail");
        }

        simpleHealthQuestionaireInformationVm.goToNextPage = function() {
            //$state.go("menu.healthPurchaseSummary");
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                generalInsurenceHealthService.setHealthQuestionaire(simpleHealthQuestionaireInformationVm.data);
                saveApplicationSH();

            }
        }
    }
]);
