angularApp.service('generalInsurenceHomeDetailService', ["$filter", "$q", "AdapterUtils", "genralInsurenceConfig", "GIconstant", "generalInsurenceHomeService",
    function($filter, $q, AdapterUtils, genralInsurenceConfig, GIconstant, generalInsurenceHomeService) {
        var generalInsurenceHome = this;
        var QuoteFirstpageDetail, QuoteSecondpageDetail, personalFirstpageDetail, personalSecondpageDetail, personalThirdpageDetail, personalForthpageDetail, personalFifthpageDetail;
        var QuoteNumberDetail, premiumAmountDetail, masters, Tenure, homeOffer, savedData, financeData, partyData, partyResponseData;
        // var generalInsurenceHomeService = $injector.get('generalInsurenceHomeService');

        generalInsurenceHome.clearAll = function(){
             QuoteFirstpageDetail= null; QuoteSecondpageDetail= null; personalFirstpageDetail= null; personalSecondpageDetail= null; personalThirdpageDetail= null; personalForthpageDetail= null; personalFifthpageDetail = null;
             QuoteNumberDetail= null; premiumAmountDetail= null; masters= null; Tenure= null; homeOffer= null; savedData= null; financeData =  null; partyData=null;partyResponseData = null;
        }

        generalInsurenceHome.saveFinance = function(homeDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.saveFinance[0], homeDetail, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.deleteFinance = function(homeDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.deleteFinance[0], homeDetail, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getSavedApplications = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getSavedApplications[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.deleteApplication = function(deleteDetail,Loaderstatus) {
            var q = $q.defer();
            Loaderstatus ? true : false;
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.deleteApplication[0], deleteDetail, Loaderstatus).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getLongTermMasters = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getLongTermMasters[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getAllPolicyTerms = function(homeDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getAllPolicyTerms[0], homeDetail, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getHomeMaster = function(homeDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getHomeIQuote[0], homeDetail, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getHomeIQuote = function(homeDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getHomeIQuote[0], homeDetail, true).then(
                function(response) {

                 if(response.data){
                        generalInsurenceHomeService.setQuoteNumber(response.data.premiumCalculation.quoteNumber);
                    } 
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getHomeIQuoteWithoutOverlay = function(homeDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getHomeIQuote[0], homeDetail, false).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.sendProductDetailQuote = function(homeDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.applyHomeIProduct[0], homeDetail, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.setQuoteNumberDetail = function(data) {
            QuoteNumberDetail = data;
        }

        generalInsurenceHome.getQuoteNumberDetail = function() {
            return QuoteNumberDetail;
        }


        generalInsurenceHome.setHomePrimiumForOffer = function(data) {
            homeOffer = data;
        }

        generalInsurenceHome.getHomePrimiumForOffer = function() {
            return homeOffer;
        }

        generalInsurenceHome.setMasterDetail = function(data) {
            masters = data;
        }

        generalInsurenceHome.getMasterDetail = function() {
            return masters;
        }

        generalInsurenceHome.setQuoteFirstpageDetail = function(data) {
            QuoteFirstpageDetail = data;
        }

        generalInsurenceHome.getQuoteFirstpageDetail = function(data) {
            return QuoteFirstpageDetail;
        }

        generalInsurenceHome.setQuoteSecondpageDetail = function(data) {
            QuoteSecondpageDetail = data;
        }

        generalInsurenceHome.getQuoteSecondpageDetail = function(data) {
            return QuoteSecondpageDetail;
        }


        generalInsurenceHome.setPersonalFirstpageDetail = function(data) {
            personalFirstpageDetail = data;
        }

        generalInsurenceHome.getPersonalFirstpageDetail = function() {
            return personalFirstpageDetail;
        }

        generalInsurenceHome.setPersonalSecondpageDetail = function(data) {
            personalSecondpageDetail = data;
        }

        generalInsurenceHome.getPersonalSecondpageDetail = function() {
            return angular.copy(personalSecondpageDetail);
        }

        generalInsurenceHome.setPersonalThirdpageDetail = function(data) {
            personalThirdpageDetail = data;
        }

        generalInsurenceHome.getPersonalThirdpageDetail = function() {
            return personalThirdpageDetail;
        }


        generalInsurenceHome.setPersonalForthpageDetail = function(data) {
            personalForthpageDetail = data;
        }

        generalInsurenceHome.getPersonalForthpageDetail = function() {
            return personalForthpageDetail;
        }


        generalInsurenceHome.setPersonalFifthpageDetail = function(data) {
            personalFifthpageDetail = data;
        }

        generalInsurenceHome.getPersonalFifthpageDetail = function() {
            return personalFifthpageDetail;
        }


        generalInsurenceHome.setpremiumAmountDetail = function(data) {
            premiumAmountDetail = data;
        }

        generalInsurenceHome.getpremiumAmountDetail = function() {
            return premiumAmountDetail;
        }

        generalInsurenceHome.setTenure = function(data) {
            Tenure = data;
        }

        generalInsurenceHome.getTenure = function() {
            return Tenure;
        }

        generalInsurenceHome.setSavedData = function(savedDetail) {
            savedData = savedDetail;
        }

        generalInsurenceHome.getSavedData = function() {
            return savedData;
        }

        generalInsurenceHome.setFinance = function(savedDetail) {
            financeData = savedDetail;
        }

        generalInsurenceHome.getFinance = function() {
            return financeData;
        }

        generalInsurenceHome.setPartyDetails = function(data) {
            partyData = data;
        }

        generalInsurenceHome.getPartyDetails = function() {
            return partyData;
        }

        generalInsurenceHome.setPartyResponse = function(data) {
            partyResponseData = data;
        }

        generalInsurenceHome.getPartyResponse = function() {
            return partyResponseData;
        }



        generalInsurenceHome.getBasicStructureForHome = function() {
            var structureForHome = {
                "cif": "",
                "applicationNumber": "1122",
                "productCode": "string",
                "uin": "string",
                "planName": "string",
                "quoteData": {},
                "applicationData": "string",
                "mobileNumber": "95911816612"
            }
            return structureForHome;
        }


        generalInsurenceHome.getBasicStructureForHomeApplication = function() {
            var structureForApplication = {
                "payload": {
                    "createQuoteRequest": {
                        "ownerDetails": [],
                        "locationDetails": {},
                        "buildingDetails": {},
                        "ownerContactDetails": {}
                    },
                    "PartResponce": {},
                }
            }
            return structureForApplication;
        }

        generalInsurenceHome.getSavedApplication = function() {
            var saved = null;
            return saved;
        }

        generalInsurenceHome.assignvalueForHome = function() {
            var pagelength = 7;
            var savedApplication = {}
            var services = [GIconstant.saveForHome.firstPageDetail, "quotesave", "ownerSave", GIconstant.saveForHome.locationDetail, GIconstant.saveForHome.buildingDetail, GIconstant.saveForHome.personalOwnerDetail, GIconstant.saveForHome.personalOwnerContactDetail];

            for (var serCount = 0; serCount < pagelength; serCount++) {
                var SavePageDetail = services[serCount];
                if (SavePageDetail == "quotesave") {
                    if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.response) {
                        var quoteDetail = {};
                        quoteDetail.premiumCalculation = savedData.quoteData.premiumCalculation.response;
                        QuoteNumberDetail = quoteDetail;
                    } else {
                        QuoteNumberDetail = "";
                    }
                } else if (SavePageDetail == "ownerSave") {
                    if (savedData.applicationData && savedData.applicationData.createQuoteRequest && savedData.applicationData.createQuoteRequest.ownerDetails && savedData.applicationData.createQuoteRequest.ownerDetails.length) {
                        var ownerlength = savedData.applicationData.createQuoteRequest.ownerDetails.length;
                        var owners = savedData.applicationData.createQuoteRequest.ownerDetails;
                        for (var count = 0; count < ownerlength; count++) {
                            owners[count].dob = $filter('chosenDate')(owners[count].dob);
                        }
                        personalFirstpageDetail = owners;
                    } else {
                        personalFirstpageDetail = null;
                    }

                } else {
                    if (validateSerCount(serCount)) {
                        for (var count = 0; count < SavePageDetail.length; count++) {
                            var cloudname = SavePageDetail[count].cloudName;
                            var modelname = SavePageDetail[count].modelName;
                            savedApplication = generalInsurenceHomeService.setObjectForService(savedData, cloudname, savedApplication, modelname, SavePageDetail[count].type);
                        }
                    }
                }
                if (serCount == 0) {
                    QuoteFirstpageDetail = savedApplication;
                } else if (serCount == 3) {
                    personalSecondpageDetail = savedApplication;
                    if(personalSecondpageDetail.state && personalSecondpageDetail.city){
                        personalSecondpageDetail.state = personalSecondpageDetail.state.value;
                        personalSecondpageDetail.city = personalSecondpageDetail.city.cityName;
                    }
                    if(savedData.applicationData && savedData.applicationData.createQuoteRequest && savedData.applicationData.createQuoteRequest.locationDetails && savedData.applicationData.createQuoteRequest.locationDetails.locationSource){
                         generalInsurenceHomeService.setLocatiopnBasedPincode(savedData.applicationData.createQuoteRequest.locationDetails.locationSource);
                    }
                } else if (serCount == 4) {
                    personalThirdpageDetail = savedApplication;
                    if(personalThirdpageDetail.buildingType){ 
                        personalThirdpageDetail.buildingType = $filter('selectBoxFilter')(masters.typeOfbuilding,personalThirdpageDetail.buildingType);
                    }
					partyResponseData = {};
					partyResponseData.partyCreate = savedData.applicationData.partyDetails;
                } else if (serCount == 5) {
                    personalForthpageDetail = savedApplication;
                } else if (serCount == 6) {
                    personalFifthpageDetail = savedApplication;
                }

                savedApplication = {};
            }
        }



        function validateSerCount(count) {

            switch (count) {

                case 0:
                    if (savedData.quoteData && savedData.quoteData.premiumCalculation  && savedData.quoteData.premiumCalculation.policydetails) {
                        return true
                    } else {
                        return false;
                    }
                    break;
               case 3:
               
                    if (savedData.applicationData && savedData.applicationData.createQuoteRequest && savedData.applicationData.createQuoteRequest.locationDetails) {
                        return true
                    } else {
                        return false;
                    }
                    break;
                 case 4:
             
                    if (savedData.applicationData && savedData.applicationData.createQuoteRequest && savedData.applicationData.createQuoteRequest.buildingDetails ) {
                        return true
                    } else {
                        return false;
                    }
                    break;
                 case 5:
                    if (savedData.applicationData && savedData.applicationData.createQuoteRequest && savedData.applicationData.createQuoteRequest.ownerContactDetails ) {
                        return true
                    } else {
                        return false;
                    }
                    break;
                 case 6:
               
                    if (savedData.applicationData && savedData.applicationData.createQuoteRequest && savedData.applicationData.createQuoteRequest.ownerContactDetails) {
                        return true
                    } else {
                        return false;
                    }
                    break;

            }
        }

        return generalInsurenceHome;
    }
]);
