angularApp.controller('homeApplicationContactDetailsController', [
    "$state",
    "$scope","$filter", "validateService", "generalInsurenceHomeDetailService","generalInsurenceHomeService","generalInsurenceHealthService","utilityService","GIconstant","clickStreamService",

    function(
        $state,
        $scope, $filter,validateService, generalInsurenceHomeDetailService,generalInsurenceHomeService,generalInsurenceHealthService,utilityService,GIconstant,clickStreamService
    ) {

        var homeApplicationContactDetailsVm = this;
        var savedApplication,GenderValue;
        homeApplicationContactDetailsVm.homeQuoteOwnerInfoForm = {};
        homeApplicationContactDetailsVm.showNext = true;
         homeApplicationContactDetailsVm.showBack = true;
        homeApplicationContactDetailsVm.validateService = validateService;
        homeApplicationContactDetailsVm.product = {};
        var currentDate = generalInsurenceHomeService.getCurrentDate();
        homeApplicationContactDetailsVm.dobMinDate = generalInsurenceHomeService.getFutureYear(currentDate, -70);
        homeApplicationContactDetailsVm.dobMaxDate = generalInsurenceHomeService.getFutureYear(currentDate, -18);
        var firstPageFetail,secondPageDetail,thirdPageDetail,forthPageDetail,fifthPageDetail;
        


       



        function SetSaveApplicationForHome() {
            var SavePageDetail = GIconstant.saveForHome.personalOwnerContactDetail;
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, homeApplicationContactDetailsVm.product, modelname, SavePageDetail[count].type);
            }
            var JsonStingedData = angular.copy(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
            JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";


            generalInsurenceHomeService.saveApplication(JsonStingedData).then(function(data) {
              //createPartyIdJson();
                $state.go('menu.homeOwnerContactDetails');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
              
        function validateForm() {
            homeApplicationContactDetailsVm.homeQuoteOwnerInfoForm = {};
            if (homeApplicationContactDetailsVm.validateService.isValidbirthDate(homeApplicationContactDetailsVm.product.birthDate)) {
                homeApplicationContactDetailsVm.homeQuoteOwnerInfoForm.birthDate = homeApplicationContactDetailsVm.validateService.isValidbirthDate(homeApplicationContactDetailsVm.product.birthDate);
            }

            if (homeApplicationContactDetailsVm.validateService.isValidDateGI(homeApplicationContactDetailsVm.product.birthDate,homeApplicationContactDetailsVm.dobMinDate,homeApplicationContactDetailsVm.dobMaxDate)) {
                homeApplicationContactDetailsVm.homeQuoteOwnerInfoForm.birthDate = homeApplicationContactDetailsVm.validateService.isValidDateGI(homeApplicationContactDetailsVm.product.birthDate,homeApplicationContactDetailsVm.dobMinDate,homeApplicationContactDetailsVm.dobMaxDate);
            }

            if (homeApplicationContactDetailsVm.validateService.isValidEmail(homeApplicationContactDetailsVm.product.emailID)) {
                homeApplicationContactDetailsVm.homeQuoteOwnerInfoForm.emailID = homeApplicationContactDetailsVm.validateService.isValidEmail(homeApplicationContactDetailsVm.product.emailID);
            }

            if (homeApplicationContactDetailsVm.validateService.isValidPhoneNo(homeApplicationContactDetailsVm.product.mobileNo)) {
                homeApplicationContactDetailsVm.homeQuoteOwnerInfoForm.mobileNo = homeApplicationContactDetailsVm.validateService.isValidPhoneNo(homeApplicationContactDetailsVm.product.mobileNo);
            }

            if (homeApplicationContactDetailsVm.validateService.isValidFirstName(homeApplicationContactDetailsVm.product.firstName)) {
                homeApplicationContactDetailsVm.homeQuoteOwnerInfoForm.firstName = homeApplicationContactDetailsVm.validateService.isValidFirstName(homeApplicationContactDetailsVm.product.firstName);
            }
            if (homeApplicationContactDetailsVm.validateService.isValidLastName(homeApplicationContactDetailsVm.product.LastName)) {
                homeApplicationContactDetailsVm.homeQuoteOwnerInfoForm.LastName = homeApplicationContactDetailsVm.validateService.isValidLastName(homeApplicationContactDetailsVm.product.LastName);
            }
            if (homeApplicationContactDetailsVm.validateService.isValidTitle(homeApplicationContactDetailsVm.product.title)) {
                homeApplicationContactDetailsVm.homeQuoteOwnerInfoForm.title = homeApplicationContactDetailsVm.validateService.isValidTitle(homeApplicationContactDetailsVm.product.title);
            }
            return (angular.equals({}, homeApplicationContactDetailsVm.homeQuoteOwnerInfoForm)) ? true : false;
        }

  /*  go to back button */
        homeApplicationContactDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.homeApplicationOwnerDetails");
        }

          function initpage(){
            var CBSPersonalData =   generalInsurenceHomeService.getIIBaccountDetail();
               savedApplication = generalInsurenceHomeDetailService.getSavedData();
               homeApplicationContactDetailsVm.titles =   generalInsurenceHomeDetailService.getMasterDetail().salutation;
                 var savedForApplicationPage = generalInsurenceHomeDetailService.getPersonalFifthpageDetail();
               if(!angular.equals(savedForApplicationPage,{}) && savedForApplicationPage){
                    homeApplicationContactDetailsVm.product =   savedForApplicationPage;
               }else{
                  homeApplicationContactDetailsVm.product = {};
                   homeApplicationContactDetailsVm.titles = generalInsurenceHomeDetailService.getMasterDetail().salutation;
                  if(CBSPersonalData){
                    if(CBSPersonalData.cbsData.genderCode == 'M'){
                      homeApplicationContactDetailsVm.product.title = $filter('selectBoxFilter')(homeApplicationContactDetailsVm.titles,"9000000001");  
                    }else{
                      homeApplicationContactDetailsVm.product.title = $filter('selectBoxFilter')(homeApplicationContactDetailsVm.titles,"9000000004");  
                    }
                     // homeApplicationContactDetailsVm.product.title =     $filter('selectBoxFilter')(homeApplicationContactDetailsVm.titles,CBSPersonalData.cbsData.salutation,"cbsKey"),
                      homeApplicationContactDetailsVm.product.firstName =     CBSPersonalData.cbsData.firstName;
                      homeApplicationContactDetailsVm.product.LastName =    CBSPersonalData.cbsData.lastName;
                      homeApplicationContactDetailsVm.product.birthDate =     $filter('formatCbsDate')(CBSPersonalData.cbsData.dateOfBirth);
                      homeApplicationContactDetailsVm.product.emailID =    CBSPersonalData.cbsData.email1;
                      homeApplicationContactDetailsVm.product.mobileNo =    CBSPersonalData.cbsData.mobileNumber;

                  }
               } 

          }


        function  applyhomeproduct(data){
                  var ownerDetails = [];
                 for (var count = 0; count < firstPageFetail.length; count++) {
                    ownerDetails[count] = {};
                   ownerDetails[count] = {
                        "title": firstPageFetail[count].title.value,
                        "firstName": firstPageFetail[count].firstName,
                        "lastName": firstPageFetail[count].LastName,
                        "dob": $filter('dateFormat')(firstPageFetail[count].dob),
                    };
                }

                var quoteDetail =  generalInsurenceHomeDetailService.getQuoteNumberDetail();
               
                 var homeDetail =  {
                  "createQuoteRequest": {
                    "quoteNo": quoteDetail.premiumCalculation.quoteNumber,
                    "sumInsured": quoteDetail.premiumCalculation.sumInsured,
                    "policyID": quoteDetail.premiumCalculation.policyTerms.policyID,
                    "startDate": quoteDetail.premiumCalculation.policyTerms.effectDate,
                    "endDate": quoteDetail.premiumCalculation.policyTerms.expiryDate,
                    "quotedate": quoteDetail.premiumCalculation.policyTerms.quotedate,
                    "tenure": 1 + generalInsurenceHomeService.calculateAge(quoteDetail.premiumCalculation.policyTerms.expiryDate,quoteDetail.premiumCalculation.policyTerms.effectDate),
                    "ppId": quoteDetail.premiumCalculation.policyTerms.ppId,
                    "partyId": data.partyCreate.partyID,
                     "insuredDetails": quoteDetail.premiumCalculation.insuredDetails,
                    // "insuredId": quoteDetail.premiumCalculation.policyTerms.insuredId,
                    // "policyCtId": quoteDetail.premiumCalculation.policyTerms.policyCtId,
                    "ownerDetails": ownerDetails,
                    "locationDetails": [
                      {
                        "plotNo": secondPageDetail.ploatNo,
                        "buildingNumber": secondPageDetail.buildingName,
                        "streetName": secondPageDetail.streetName,
                        "locality": secondPageDetail.locality.loc,
                        "state": secondPageDetail.stateObject ? secondPageDetail.stateObject.key  : "",
                        "city": secondPageDetail.cityObject ? secondPageDetail.cityObject.cityCode : "",
                        "pincode": secondPageDetail.pinCode,
                      }
                    ],

                    "buildingDetails" : {
                    "noofFloors": thirdPageDetail.numberOfFloors,
                    "yourFloor": thirdPageDetail.floorNumber,
                    "buildingtype": thirdPageDetail.buildingType.key.toString(),
                    "contructionType": thirdPageDetail.numberOfFloors,
                    "underConstruction": "",
                    "yearOfConstruction": thirdPageDetail.yearOfConstruction,
                    "area": thirdPageDetail.areaOfProperty,
                    "isGoodCondition": thirdPageDetail.isInGoodCondition ? "yes" : "no",
                    "isHypothecated": thirdPageDetail.isHypothecated ? true : false,
                    "financialInstitutionalDetails": {
                        "loanAmmount": "",
                        "name": thirdPageDetail.nameFinancialInstitution ? thirdPageDetail.nameFinancialInstitution : "" ,
                        "branch":  thirdPageDetail.branchFinancialInstitution ? thirdPageDetail.branchFinancialInstitution : "" ,
                        "loanAccountNumber":  thirdPageDetail.loanAccountNo ? thirdPageDetail.loanAccountNo : "" ,
                        "address": thirdPageDetail.addressoFinancialInstitution ? thirdPageDetail.addressoFinancialInstitution : "" 
                    }
                },
                   "ownerContactDetails": {
                      "isSameAddress": forthPageDetail.previousDetail ?"yes" : "no",
                      "title": fifthPageDetail.title.cbsKey,
                      "firstName": fifthPageDetail.firstName,
                      "lastName": fifthPageDetail.LastName,
                        "city": secondPageDetail.cityObject ? secondPageDetail.cityObject.cityCode : "",
                      "address": forthPageDetail.locality.loc+","+forthPageDetail.ploatNo + ","+forthPageDetail.buildingName+","+forthPageDetail.streetName + "," + secondPageDetail.stateObject.key + "," + secondPageDetail.cityObject.cityCode + "," + secondPageDetail.pinCode,
                      "gender": GenderValue ? GenderValue : "M",
                      "dob": $filter('dateFormat')(fifthPageDetail.birthDate),
                      "emailId": fifthPageDetail.emailID,
                      "mobileNumber": fifthPageDetail.mobileNo
                    }
                  }
                }
               
                generalInsurenceHomeDetailService.sendProductDetailQuote(homeDetail).then(function(data) {
                        generalInsurenceHealthService.setQuotecalculation(data);
                        generalInsurenceHomeDetailService.setpremiumAmountDetail(data);
                        $state.go("menu.homePurchaseSummary");


                }, function(error) {
                   utilityService.showErrorMessage(error.responseMessage);
                });
        }


          function createPartyIdJson(){

            if(homeApplicationContactDetailsVm.product.title.pkey == '9000000001'){
                GenderValue = 'M'
              }else{
                GenderValue = 'F'
              }

           var locationDetail =  generalInsurenceHomeService.getLocatiopnBasedPincode();
            var personalDetail =   {
                  "partyCreate": {
                  "salutation": homeApplicationContactDetailsVm.product.title.pkey,
                  "firstName":fifthPageDetail.firstName,
                  "middleName":"",
                  "lastName": fifthPageDetail.LastName,
                  "dob":  $filter('dateFormat')(homeApplicationContactDetailsVm.product.birthDate),
                  "gender":  GenderValue ? GenderValue : 'M',
                  "emailID": fifthPageDetail.emailID,
                  "mobile": fifthPageDetail.mobileNo,
                  "plotNo":forthPageDetail.ploatNo,
                  "buildingName":forthPageDetail.buildingName, 
                  "streetName":forthPageDetail.streetName,
                  "cityName": locationDetail.city.cityCode,
                  "stateName": locationDetail.state.key,
                  "pinCode": secondPageDetail.locality.pinId,
                  "districtName": locationDetail.district.districtCode,
                  "locality": forthPageDetail.locality.loc,
                  "addressType":"CurrentAddress"
                }
              }
              generalInsurenceHomeService.getPartyCreation(personalDetail).then(function(data) {
                generalInsurenceHomeDetailService.setPartyDetails(personalDetail);
                generalInsurenceHomeDetailService.setPartyResponse(data);
                 applyhomeproduct(data);
                }, function(error) {
                   utilityService.showErrorMessage(error.responseMessage);
            });
         }


         homeApplicationContactDetailsVm.clickTerm = function() {
                generalInsurenceHomeService.getTermsAndCondtion();

                // .then(function(data) {}, function(error) {
                //     utilityService.showErrorMessage(error.responseMessage);
                // });
            }

            /*homeApplicationContactDetailsVm.clickDeclaration = function(){

                generalInsurenceHomeService.getDiclaration().then(function(data) {
               
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            }*/

        homeApplicationContactDetailsVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                generalInsurenceHomeDetailService.setPersonalFifthpageDetail(homeApplicationContactDetailsVm.product);

                var applyHomeProduct = {
                    "quoteNumber": "string",
                }

                applyHomeProduct.ownerDetails = [];
                 firstPageFetail = generalInsurenceHomeDetailService.getPersonalFirstpageDetail();
                // secondPageDetail = generalInsurenceHomeDetailService.getPersonalSecondpageDetail();
                // thirdPageDetail = generalInsurenceHomeDetailService.getPersonalThirdpageDetail();
                 //forthPageDetail = generalInsurenceHomeDetailService.getPersonalForthpageDetail();
                 fifthPageDetail = generalInsurenceHomeDetailService.getPersonalFifthpageDetail();
                 SetSaveApplicationForHome();
            }
        }
         //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initpage();
        });

        return this;
    }
]);
