angularApp.controller('homeApplicationOwnerDetailsController', ["$state", "$scope", "$filter",  "validateService", "generalInsurenceHomeService", "generalInsurenceHomeDetailService","GIconstant","clickStreamService","utilityService",
    function($state, $scope,  $filter, validateService, generalInsurenceHomeService, generalInsurenceHomeDetailService,GIconstant,clickStreamService,utilityService) {

        var homeApplicationOwnerDetailsVm = this;
        homeApplicationOwnerDetailsVm.showNext = true;
        homeApplicationOwnerDetailsVm.showBack = true;
        homeApplicationOwnerDetailsVm.memberList = [0];

        homeApplicationOwnerDetailsVm.test = true;
        var curentDate = generalInsurenceHomeService.getCurrentDate();
        var savedList = {};
        homeApplicationOwnerDetailsVm.minDate = generalInsurenceHomeService.getFutureYear(curentDate, -110);
        homeApplicationOwnerDetailsVm.maxData = generalInsurenceHomeService.getFutureYear(curentDate, -18);

        function initPage() {

            homeApplicationOwnerDetailsVm.name = {};
            homeApplicationOwnerDetailsVm.Birthday = {};
            homeApplicationOwnerDetailsVm.data = [];
            homeApplicationOwnerDetailsVm.data[0] = {};
            savedList = generalInsurenceHomeDetailService.getSavedData();
            var firstpageDetailForHomePremier = generalInsurenceHomeDetailService.getPersonalFirstpageDetail();
            if (firstpageDetailForHomePremier) {
                homeApplicationOwnerDetailsVm.data = firstpageDetailForHomePremier;
            }else{
                var accountNumber = generalInsurenceHomeService.getaccountDetail();
                if (accountNumber) {
                    var account = {
                        "bankAccountNo": accountNumber.benAccntNo
                    }
                    generalInsurenceHomeService.getSBIBankAccoutDetails(account).then(function(data) {
                        if (data) {
                            if(data.cbsData.genderCode == 'M'){
                                homeApplicationOwnerDetailsVm.data[0].title = $filter('selectBoxFilter')(homeApplicationOwnerDetailsVm.titles,"9000000001");  
                            }else{
                                homeApplicationOwnerDetailsVm.data[0].title = $filter('selectBoxFilter')(homeApplicationOwnerDetailsVm.titles,"9000000004");  
                            }
                            
                            homeApplicationOwnerDetailsVm.data[0].firstName =  data.cbsData.firstName;
                            homeApplicationOwnerDetailsVm.data[0].lastName = data.cbsData.lastName;
                            homeApplicationOwnerDetailsVm.data[0].dob =  $filter('formatCbsDate')(data.cbsData.dateOfBirth); 
                            generalInsurenceHomeService.setIIBaccountDetail(data);
                        }
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }
            }

        }
        homeApplicationOwnerDetailsVm.titles = generalInsurenceHomeDetailService.getMasterDetail().salutation;

        homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm = {};
        homeApplicationOwnerDetailsVm.validateService = validateService;
        homeApplicationOwnerDetailsVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                generalInsurenceHomeDetailService.setPersonalFirstpageDetail(homeApplicationOwnerDetailsVm.data);
                if (savedList.applicationData && savedList.applicationData !="string") {
                    if (savedList.applicationData.createQuoteRequest) {} else {
                        savedList.applicationData.createQuoteRequest = {};
                        savedList.applicationData.createQuoteRequest.ownerDetails = [];
                    }
                } else {
                    savedList.applicationData = {};
                    savedList.applicationData.createQuoteRequest = {};
                    savedList.applicationData.createQuoteRequest.ownerDetails = [];
                }
                var tempVarForSave = angular.copy(homeApplicationOwnerDetailsVm.data);
                for (var count = 0; count < homeApplicationOwnerDetailsVm.data.length; count++) {
                    tempVarForSave[count].dob = new Date(tempVarForSave[count].dob);
                }
                savedList.applicationData.createQuoteRequest.ownerDetails = tempVarForSave;
                generalInsurenceHomeDetailService.setSavedData(savedList);
                var JsonStingedData = angular.copy(savedList);
                JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
                JsonStingedData.cif = "";
                JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
                JsonStingedData.mobileNumber = "";
                JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
                 JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
                generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Home.LTH_OWNER_DETAILS_1).then(function(data) {
                    $state.go('menu.homeApplicationContactDetails');
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        //common validation function
        function validateForm() {
            homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm = {};
            homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data = [];
            for (var count = 0; count < homeApplicationOwnerDetailsVm.data.length; count++) {
                homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data[count] = {};
                if (homeApplicationOwnerDetailsVm.validateService.isValidTitle(homeApplicationOwnerDetailsVm.data[count].title)) {
                    homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data[count].title = homeApplicationOwnerDetailsVm.validateService.isValidTitle(homeApplicationOwnerDetailsVm.data[count].title);
                }
                if (homeApplicationOwnerDetailsVm.validateService.isValidFirstName(homeApplicationOwnerDetailsVm.data[count].firstName)) {
                    homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data[count].firstName = homeApplicationOwnerDetailsVm.validateService.isValidFirstName(homeApplicationOwnerDetailsVm.data[count].firstName);
                }
                if(count > 0){
                    if (homeApplicationOwnerDetailsVm.validateService.isValidLastNameGI(homeApplicationOwnerDetailsVm.data[count].lastName,false)) {
                        homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data[count].lastName = homeApplicationOwnerDetailsVm.validateService.isValidLastNameGI(homeApplicationOwnerDetailsVm.data[count].lastName,false);
                    }
               }else{
                  if (homeApplicationOwnerDetailsVm.validateService.isValidLastNameGI(homeApplicationOwnerDetailsVm.data[count].lastName,true)) {
                    homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data[count].lastName = homeApplicationOwnerDetailsVm.validateService.isValidLastNameGI(homeApplicationOwnerDetailsVm.data[count].lastName,true); 
                    }
                }
                if (homeApplicationOwnerDetailsVm.validateService.isValidDOB(homeApplicationOwnerDetailsVm.data[count].dob)) {
                    homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data[count].dob = homeApplicationOwnerDetailsVm.validateService.isValidDOB(homeApplicationOwnerDetailsVm.data[count].dob);
                }
            }
            for (var count = 0; count < homeApplicationOwnerDetailsVm.data.length; count++) {
                if ((angular.equals({}, homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data[count])) ? true : false) {} else {
                    return false;
                }
            }
            return true;
        }

        homeApplicationOwnerDetailsVm.chkValidLastName = function() {
           homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm = {};
            homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data = [];
            for (var count = 0; count < homeApplicationOwnerDetailsVm.data.length; count++) {
                homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data[count] = {};
               
              if(count > 0){
                if (homeApplicationOwnerDetailsVm.validateService.isValidLastNameGI(homeApplicationOwnerDetailsVm.data[count].lastName,false)) {
                    homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data[count].lastName = homeApplicationOwnerDetailsVm.validateService.isValidLastNameGI(homeApplicationOwnerDetailsVm.data[count].lastName,false);
                }
               }else{
                  if (homeApplicationOwnerDetailsVm.validateService.isValidLastNameGI(homeApplicationOwnerDetailsVm.data[count].lastName,true)) {
                    homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data[count].lastName = homeApplicationOwnerDetailsVm.validateService.isValidLastNameGI(homeApplicationOwnerDetailsVm.data[count].lastName,true); 
                    }
                }
            }
            for (var count = 0; count < homeApplicationOwnerDetailsVm.data.length; count++) {
                if ((angular.equals({}, homeApplicationOwnerDetailsVm.homeApplicationOwnerDetailsForm.data[count])) ? true : false) {} else {
                    return false;
                }
            }
            return true;
        }
        

        homeApplicationOwnerDetailsVm.addMembersInfo = function() {
            if (homeApplicationOwnerDetailsVm.memberList.length < 3) {
                homeApplicationOwnerDetailsVm.data.push(Math.max.apply(null, homeApplicationOwnerDetailsVm.data) + 1);
            }
        }

        homeApplicationOwnerDetailsVm.deleteMembersInfo = function(index) {
            homeApplicationOwnerDetailsVm.data.splice(index, 1);

        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        homeApplicationOwnerDetailsVm.goBacktoPrevious = function() {
            $state.go('menu.paymentAccountDetailsHome');
            //$state.go('menu.homeInsuredBuildingDetails');
        }
    }
]);

