
angularApp.controller('homeQuotePolicyInfoController', ["$state", "$scope", "$translate", "$filter", "validateService", "generalInsurenceHomeDetailService", "generalInsurenceHomeService", "utilityService", "GIconstant","clickStreamService",
    function($state, $scope, $translate, $filter, validateService, generalInsurenceHomeDetailService, generalInsurenceHomeService, utilityService, GIconstant,clickStreamService) {

        var homeQuotePolicyInfoVm = this;
        homeQuotePolicyInfoVm.showNext = true;
        homeQuotePolicyInfoVm.showBack = true;
        homeQuotePolicyInfoVm.product = {};
        var todaysDate = generalInsurenceHomeService.getCurrentDate();
        var savedApplication;
        homeQuotePolicyInfoVm.mindate = $filter('chosenDate')(todaysDate);
        homeQuotePolicyInfoVm.maxdate = generalInsurenceHomeService.getFutureDate(todaysDate, 7);
        homeQuotePolicyInfoVm.insuranceType = $translate.instant('Btn_Lbl_HOME');
        homeQuotePolicyInfoVm.policyInfo = $translate.instant('POLICY_INFO');






        function SetSaveApplicationForHomeQuote(detail) {
            savedApplication.quoteData.premiumCalculation.response = detail.premiumCalculation;
            var JsonStingedData = angular.copy(savedApplication);

            generalInsurenceHomeDetailService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.applicationData = JsonStingedData.applicationData ? JSON.stringify(JsonStingedData.applicationData) : "";
            JsonStingedData.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            JsonStingedData.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";





            //quoteData.premiumCalculation.request
            generalInsurenceHomeService.saveApplication(JsonStingedData, GIconstant.OmniChannel.Home.LTH_PREMIUM).then(function(data) {
                $state.go("menu.quotesList");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        function callMasterforHome() {
            generalInsurenceHomeDetailService.getLongTermMasters().then(function(data) {
                if (data) {
                    generalInsurenceHomeDetailService.setMasterDetail(data);
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        function retriewSaveData() {
            var previouspageData = generalInsurenceHomeDetailService.getQuoteFirstpageDetail();
            if (previouspageData) {
                homeQuotePolicyInfoVm.product = previouspageData;

            }else{
                homeQuotePolicyInfoVm.product = {};
                 homeQuotePolicyInfoVm.product.startDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());;
            }
        }



        function initPage() {
            retriewSaveData();
            callMasterforHome();
            
        }



        //Validation
        homeQuotePolicyInfoVm.quoteCalculationForm = {};
        homeQuotePolicyInfoVm.validateService = validateService;
        //on click of next button
        homeQuotePolicyInfoVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                generalInsurenceHomeService.setpolicyStartdate(new Date(homeQuotePolicyInfoVm.product.startDate));
                generalInsurenceHomeService.setpolicySumInsured($filter('formatAmount')(homeQuotePolicyInfoVm.product.buildingSumInsured));

                generalInsurenceHomeDetailService.setQuoteFirstpageDetail(homeQuotePolicyInfoVm.product);
                if (savedApplication) {
                    SetSaveApplicationForHome();
                } else {
                    var basicStructure = generalInsurenceHomeDetailService.getBasicStructureForHome();
                    basicStructure.applicationNumber = generalInsurenceHomeService.getapplicationNumber() ? generalInsurenceHomeService.getapplicationNumber() : "";
                    basicStructure.uin = generalInsurenceHomeService.getProductDetail().uin;
                    basicStructure.productCode = generalInsurenceHomeService.getGIProductsID();
                    basicStructure.planName = generalInsurenceHomeService.getProductDetail().policyName;
                    savedApplication = basicStructure;
                    SetSaveApplicationForHome();
                }
                var pagesParams = "home";
            }
        }



        //common validation function
        function validateForm() {

            homeQuotePolicyInfoVm.quoteCalculationForm = {};
            if (homeQuotePolicyInfoVm.validateService.isValidHomePolicyTenure(homeQuotePolicyInfoVm.product.tenure)) {
                homeQuotePolicyInfoVm.quoteCalculationForm.tenure = homeQuotePolicyInfoVm.validateService.isValidHomePolicyTenure(homeQuotePolicyInfoVm.product.tenure);
            }
            
            if (homeQuotePolicyInfoVm.validateService.isValidPolicyStartDate(homeQuotePolicyInfoVm.product.startDate)) {
                homeQuotePolicyInfoVm.quoteCalculationForm.startDate = homeQuotePolicyInfoVm.validateService.isValidPolicyStartDate(homeQuotePolicyInfoVm.product.startDate);
            }
            if (homeQuotePolicyInfoVm.validateService.isValidDateGI(homeQuotePolicyInfoVm.product.startDate,homeQuotePolicyInfoVm.mindate,homeQuotePolicyInfoVm.maxdate)) {
                homeQuotePolicyInfoVm.quoteCalculationForm.startDate = homeQuotePolicyInfoVm.validateService.isValidDateGI(homeQuotePolicyInfoVm.product.startDate,homeQuotePolicyInfoVm.mindate,homeQuotePolicyInfoVm.maxdate);
            } 
            if (homeQuotePolicyInfoVm.validateService.isValidPolicyEndDate(homeQuotePolicyInfoVm.product.endDate)) {
                homeQuotePolicyInfoVm.quoteCalculationForm.endDate = homeQuotePolicyInfoVm.validateService.isValidPolicyEndDate(homeQuotePolicyInfoVm.product.endDate);
            }
            if (homeQuotePolicyInfoVm.validateService.isValidSumInsured(homeQuotePolicyInfoVm.product.buildingSumInsured)) {
                homeQuotePolicyInfoVm.quoteCalculationForm.buildingSumInsured = homeQuotePolicyInfoVm.validateService.isValidSumInsured(homeQuotePolicyInfoVm.product.buildingSumInsured);
            }
            if (homeQuotePolicyInfoVm.validateService.isValidPincode(homeQuotePolicyInfoVm.product.pinCode)) {
                homeQuotePolicyInfoVm.quoteCalculationForm.pinCode = homeQuotePolicyInfoVm.validateService.isValidPincode(homeQuotePolicyInfoVm.product.pinCode);
            }
            if (Number($filter('formatAmount')(homeQuotePolicyInfoVm.product.buildingSumInsured)) > 25000000) {
                homeQuotePolicyInfoVm.quoteCalculationForm.buildingSumInsured = $translate.instant('suminsured25crore');;
            }
            return (angular.equals({}, homeQuotePolicyInfoVm.quoteCalculationForm)) ? true : false;
        }



        //function will call when user changes the year
        homeQuotePolicyInfoVm.changeYear = function() {
            if (homeQuotePolicyInfoVm.product.startDate) {
                homeQuotePolicyInfoVm.product.endDate = generalInsurenceHomeService.getFutureYear(todaysDate, Number(homeQuotePolicyInfoVm.product.tenure));
            }
        }
        homeQuotePolicyInfoVm.changeEnddate = function() {
            if (homeQuotePolicyInfoVm.product.tenure && homeQuotePolicyInfoVm.product.startDate && !homeQuotePolicyInfoVm.quoteCalculationForm.tenure) {
                homeQuotePolicyInfoVm.product.endDate = generalInsurenceHomeService.getFutureYear(homeQuotePolicyInfoVm.product.startDate, Number(homeQuotePolicyInfoVm.product.tenure));
            } else {
                homeQuotePolicyInfoVm.product.endDate = "";
            }
        }


        function SetSaveApplicationForHome() {
            var SavePageDetail = GIconstant.saveForHome.firstPageDetail;
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, homeQuotePolicyInfoVm.product, modelname, SavePageDetail[count].type);
            }
            var JsonStingedData = angular.copy(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber() ? generalInsurenceHomeService.getapplicationNumber() : "";
            JsonStingedData.mobileNumber = "";
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
            JsonStingedData.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            JsonStingedData.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";
            generalInsurenceHomeService.saveApplication(JsonStingedData, GIconstant.OmniChannel.Home.LTH_PREMIUM).then(function(data) {
                generalInsurenceHomeService.setapplicationNumber(data.applicationNumber);
                getJsonForHome();
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        function getJsonForHome() {
            var quoteDetails = generalInsurenceHomeDetailService.getQuoteNumberDetail();
            var year = homeQuotePolicyInfoVm.product.tenure;
            var tempData = {
                "key": year,
                "value": year
            }
            generalInsurenceHomeDetailService.setTenure(tempData);
            var policydetails = {
                "premiumCalculation": {
                    "quoteDetails": {
                        "quoteNo": quoteDetails ? quoteDetails.premiumCalculation.quoteNumber : null,
                        "policyID": quoteDetails ? quoteDetails.premiumCalculation.policyTerms.policyID : null,
                        "ppId": quoteDetails ? quoteDetails.premiumCalculation.policyTerms.ppId : null,
                        "insuredDetails": quoteDetails ? quoteDetails.premiumCalculation.insuredDetails : null
                    },
                    "policydetails": {
                        "tenure": year.toString(),
                        "startDate": $filter('startDateWithTimezone')(homeQuotePolicyInfoVm.product.startDate),
                        "endDate": $filter('endDateWithTimezone')(homeQuotePolicyInfoVm.product.endDate),
                        "insuredPincode": homeQuotePolicyInfoVm.product.pinCode,
                        "insuredBuildingSum": $filter('formatAmount')(homeQuotePolicyInfoVm.product.buildingSumInsured)
                    }
                }
            }

            generalInsurenceHomeDetailService.getHomeIQuote(policydetails).then(function(data) {
                generalInsurenceHomeDetailService.setQuoteNumberDetail(data);
                generalInsurenceHomeDetailService.setHomePrimiumForOffer(data);
                generalInsurenceHomeService.setQuoteListDetails(null);
                SetSaveApplicationForHomeQuote(data)

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        homeQuotePolicyInfoVm.goBackToPreviousPage = function() {
            $state.go('menu.homeRecommendedPolicyFeatures')
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
