angularApp.controller('homeQuoteSummaryController', ["$filter", "$state", "$scope", "$translate", "generalInsurenceHomeDetailService","clickStreamService","generalInsurenceHomeService",
    function($filter, $state, $scope, $translate, generalInsurenceHomeDetailService,clickStreamService,generalInsurenceHomeService) {


        var homeQuoteSummaryVm = this;

        function initPage() {
            homeQuoteSummaryVm.insuranceType = $translate.instant('Btn_Lbl_HOME');
            homeQuoteSummaryVm.showNext = true;
            homeQuoteSummaryVm.showBack = true;

            var PreviousPagdetails = generalInsurenceHomeDetailService.getQuoteNumberDetail()
            homeQuoteSummaryVm.data = {
                sumAssured: $filter('INR')(PreviousPagdetails.premiumCalculation.sumInsured),
                quoteNumber: PreviousPagdetails.premiumCalculation.quoteNumber,
                premiumAmount: $filter('INR')(PreviousPagdetails.premiumCalculation.actualPremiumPayable)
            };
        }
        homeQuoteSummaryVm.goToNextPage = function() {
            clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
            $state.go('menu.paymentAccountDetailsHome');
        }
        homeQuoteSummaryVm.goBackToPreviousPage = function() {
            $state.go('menu.quotesList', { pages: 'home' });
        }
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);

