angularApp.controller('moreProductsController', ["$state", "$scope", "generalInsurenceHomeService", "$ionicSlideBoxDelegate", "utilityService", "$ionicPopup","homeScreenService","getAccountDetailsService",
    function ($state, $scope, generalInsurenceHomeService, $ionicSlideBoxDelegate, utilityService, $ionicPopup, homeScreenService, getAccountDetailsService) {


        var moreProductsControllerVm = this;
        moreProductsControllerVm.customerRecordExists = false;
        moreProductsControllerVm.disableSubmit = true;
        moreProductsControllerVm.insureChecked = false;
        moreProductsControllerVm.disableCheck = true;
        

        function initPage() {

        moreProductsControllerVm.browseData = generalInsurenceHomeService.browseData;
        moreProductsControllerVm.yonoCat = generalInsurenceHomeService.yonoCat;
            moreProductsControllerVm.browseMoreProducts();
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            initPage();
        });

      moreProductsControllerVm.browseMoreProducts = function () {
       // for check and add non-yono products
        moreProductsControllerVm.productList = [];
        
        angular.forEach(moreProductsControllerVm.browseData, function(value, key) {
			$scope.detailsPro = value;
            $scope.yonoCat = $scope.detailsPro.category;
            if($scope.yonoCat == moreProductsControllerVm.yonoCat){
                 angular.forEach($scope.detailsPro.products, function(value1, key1) {
                moreProductsControllerVm.productList.push(value1);
               console.log('brw', JSON.stringify(moreProductsControllerVm.productList));

             });
            }
           
        });
           
    }

        moreProductsControllerVm.insureAddCheck = function (index, ProdCode, ProdCat) {
         
           moreProductsControllerVm.index = index;
           moreProductsControllerVm.crmProductCode = ProdCode;
           moreProductsControllerVm.crmProductCat = ProdCat;
           moreProductsControllerVm.insureChecked = true;
            if(moreProductsControllerVm.insureChecked) {
               moreProductsControllerVm.disableCheck= false;
               
           }
        }

        moreProductsControllerVm.agreeChkBox = function () {
            
          if (moreProductsControllerVm.isChecked && moreProductsControllerVm.insureChecked) {
                moreProductsControllerVm.disableSubmit = false;
            } else {
                moreProductsControllerVm.disableSubmit = true;
            }
           
        }


        moreProductsControllerVm.goNext = function () {
            generalInsurenceHomeService.crmProductCat = moreProductsControllerVm.crmProductCat;
            generalInsurenceHomeService.crmProductCode = moreProductsControllerVm.crmProductCode;
            let req = {
                "productCat": generalInsurenceHomeService.crmProductCat,
                "productName": generalInsurenceHomeService.crmProductCode
            }
            generalInsurenceHomeService.insurLeadGenerate(req).then(function (body) {
                
                if (!utilityService.isUndefined(body)) {
                    $scope.result = body.result
                    moreProductsControllerVm.insurLead = $scope.result.leadID;
                    console.log("moreproducts", moreProductsControllerVm.insurLead);

                        $ionicPopup.alert({
                        template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/AO/successSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><p class="popUp-msg-color insureMorePro">' + 'Your request has been submitted successfully!' + '</p><p>' + 'Reference Number</p>' + '<p>' + '{{moreProductsControllerVm.insurLead}}' + '</p></div></div></div>',
                        scope: $scope,
                        cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup moreProBtn ',
                        buttons: [
                            {
                                text: "Ok",
                                type: 'button-positive',
                                onTap: function () {
                                    
                                    homeScreenService.ishamburgerMenuRO = false;
                                    homeScreenService.isInsuranceFlag = true;
                                    getAccountDetailsService.tabIndex.tabIndex = 4;
                                    
                                    $state.go('menu.accountOverviewMyBalance');

                                }
                            }
                        ],
                    })

                }

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        } // gonext function closed

    }]);
