angularApp.service('generalInsurenceMotorService', ["$filter","genralInsurenceConfig","commonAPIService","$q","AdapterUtils","GIconstant","generalInsurenceHomeService","generalInsurenceTravelService",
     function($filter,genralInsurenceConfig,commonAPIService,$q,AdapterUtils,GIconstant,generalInsurenceHomeService,generalInsurenceTravelService) {

             var generalInsurenceMotor = this;
        var motorType, MotorTypeDetail;
        var MotorQuoteFirstPageDetail, MotorQuoteSecondPageDetail, MotorQuoteThirdPageDetail, MotorQuoteFourthPageDetail;
        var MotorPersonalFirstPageDetail, MotorPersonalSecondPageDetail, MotorPersonalThirdPageDetail, MotorPersonalFourthPageDetail;
        var prepopulatePersonalDetail,QuoteDetail,commonMaster,savedData,financeDetails,partyDetail;

        generalInsurenceMotor.UserSelectionLastName="false";

        generalInsurenceMotor.clearAll = function(){
             motorType= null; MotorTypeDetail = null;
             MotorQuoteFirstPageDetail= null; MotorQuoteSecondPageDetail= null; MotorQuoteThirdPageDetail= null; MotorQuoteFourthPageDetail = null;
             MotorPersonalFirstPageDetail= null; MotorPersonalSecondPageDetail= null; MotorPersonalThirdPageDetail= null; MotorPersonalFourthPageDetail = null;
             prepopulatePersonalDetail= null;QuoteDetail= null;commonMaster= null;savedData= null;financeDetails = null;partyDetail=null;
        }

        //added the function to set motor  type like two wheeler or four wheeler 
        generalInsurenceMotor.setMotorType = function(type) {
            motorType = type;
        }

        //added the function to get motor  type like two wheeler or four wheeler 
        generalInsurenceMotor.getMotorType = function(type) {
            return motorType;
        }

        //added the function to get motor  type in master 
        generalInsurenceMotor.getpolicyType = function(callback) {
            var response = {
                "data": {
                    "policyTypes": [{
                        "key": "0",
                        "value": "Liability",
                    }, {
                        "key": "1",
                        "value": "Package Policy",
                    }]
                },
                "responseCode": "200",
                "responseMessage": "success",
                "errorLog": "string"
            };
            callback(response);
            //commonAPIService.invokeAdapter(genralInsurenceConfig.adapterURL.browseAllGIPlans[0],genralInsurenceConfig.adapterURL.browseAllGIPlans[1],'',callback)         
        }

        //added the function to get proof of ncb  in master 
        generalInsurenceMotor.getProofOfNCB = function(callback) {
            var response = {
                "data": {
                    "NcbTypes": [{
                        "key": "0",
                        "value": "Renewal Notice",
                    }, {
                        "key": "1",
                        "value": "NCB Declaration",
                    }, {
                        "key": "2",
                        "value": "NCB Reserving Letter",
                    }]
                },
                "responseCode": "200",
                "responseMessage": "success",
                "errorLog": "string"
            };
            callback(response);
            //commonAPIService.invokeAdapter(genralInsurenceConfig.adapterURL.browseAllGIPlans[0],genralInsurenceConfig.adapterURL.browseAllGIPlans[1],'',callback)         
        }

        //added the function to get get Nature Of Loss   in master 
        generalInsurenceMotor.getNatureOfLoss = function(callback) {
            var response = {
                "data": {
                    "natureOfLoss": [{
                            "key": "0",
                            "value": "Own Damage",
                        }, {
                            "key": "1",
                            "value": "Liability/Third Party",
                        }

                    ]
                },
                "responseCode": "200",
                "responseMessage": "success",
                "errorLog": "string"
            };
            callback(response);
            //commonAPIService.invokeAdapter(genralInsurenceConfig.adapterURL.browseAllGIPlans[0],genralInsurenceConfig.adapterURL.browseAllGIPlans[1],'',callback)         
        }


        //added the function to get Ncb on previous policy   in master 
        generalInsurenceMotor.getNCBPreviousPolicy = function(callback) {
            var response = {
                "data": {
                    "NCBPreviousPolicy": [{
                            "key": "0",
                            "value": "0%",
                        }, {
                            "key": "1",
                            "value": "25%",
                        }, {
                            "key": "2",
                            "value": "35%",
                        }, {
                            "key": "3",
                            "value": "45%",
                        }, {
                            "key": "4",
                            "value": "50%",
                        }

                    ]
                },
                "responseCode": "200",
                "responseMessage": "success",
                "errorLog": "string"
            };
            callback(response);
            //commonAPIService.invokeAdapter(genralInsurenceConfig.adapterURL.browseAllGIPlans[0],genralInsurenceConfig.adapterURL.browseAllGIPlans[1],'',callback)         
        }


        //added the function to get PersonalDetail  in master 
        generalInsurenceMotor.getPersonalDetail = function(callback) {
            var response = {
                "data": {
                    "PersonalDetail": {
                        "name": "Ravi",
                        "birthday": "14-OCT-2014",
                        "gender": "male",
                        "emailID": "sbi@co.in",
                        "mobileNumber": "9876543210",
                        "address": "Sanpadan Mumbai",
                        "city": "Udupi",
                        "pin": "5761213",


                    }

                },
                "responseCode": "200",
                "responseMessage": "success",
                "errorLog": "string"
            };
            callback(response);
            //commonAPIService.invokeAdapter(genralInsurenceConfig.adapterURL.browseAllGIPlans[0],genralInsurenceConfig.adapterURL.browseAllGIPlans[1],'',callback)         
        }


        //added the function to set PersonalDetail  in master 
        generalInsurenceMotor.setMotorTypeDetail = function(data) {
            MotorTypeDetail = data;
        }

        generalInsurenceMotor.getMotorTypeDetail = function() {
            return MotorTypeDetail;
        }

      


        generalInsurenceMotor.setMotorQuoteFirstPageDetail = function(data) {
            MotorQuoteFirstPageDetail = data;
        }

        generalInsurenceMotor.getMotorQuoteFirstPageDetail = function() {
            return MotorQuoteFirstPageDetail;
        }


        generalInsurenceMotor.setMotorQuoteSecondPageDetail = function(data) {
            MotorQuoteSecondPageDetail = data;
        }

        generalInsurenceMotor.getMotorQuoteSecondPageDetail = function(data) {
            return MotorQuoteSecondPageDetail;
        }

        generalInsurenceMotor.setMotorQuoteThirdPageDetail = function(data) {
            MotorQuoteThirdPageDetail = data;
        }

        generalInsurenceMotor.getMotorQuoteThirdPageDetail = function(data) {
            return MotorQuoteThirdPageDetail;
        }

        generalInsurenceMotor.setMotorQuoteFourthPageDetail = function(data) {
            MotorQuoteFourthPageDetail = data;
        }

        generalInsurenceMotor.getMotorQuoteFourthPageDetail = function(data) {
            return MotorQuoteFourthPageDetail;
        }



        generalInsurenceMotor.setMotorPersonalFirstPageDetail = function(data) {
            MotorPersonalFirstPageDetail = data;
        }

        generalInsurenceMotor.getMotorPersonalFirstPageDetail = function(data) {
            return MotorPersonalFirstPageDetail;
        }


        generalInsurenceMotor.setMotorPersonalSecondPageDetail = function(data) {
            MotorPersonalSecondPageDetail = data;
        }

        generalInsurenceMotor.getMotorPersonalSecondPageDetail = function(data) {
            return MotorPersonalSecondPageDetail;
        }

        generalInsurenceMotor.setMotorPersonalThirdPageDetail = function(data) {
            MotorPersonalThirdPageDetail = data;
        }

        generalInsurenceMotor.getMotorPersonalThirdPageDetail = function(data) {
            return MotorPersonalThirdPageDetail;
        }

        generalInsurenceMotor.setMotorPersonalFourthPageDetail = function(data) {
            MotorPersonalFourthPageDetail = data;
        }

        generalInsurenceMotor.getMotorPersonalFourthPageDetail = function(data) {
            return MotorPersonalFourthPageDetail;
        }

        

        generalInsurenceMotor.setprepopulatePersonalDetail = function(data) {
            prepopulatePersonalDetail = data;
        }

        generalInsurenceMotor.getprepopulatePersonalDetail = function(data) {
            return prepopulatePersonalDetail;
        }

        generalInsurenceMotor.setQuoteDetail = function(data) {
             QuoteDetail =  data;
        }

        generalInsurenceMotor.getQuoteDetail = function(data) {
            return QuoteDetail;
        }

        generalInsurenceMotor.setMIcommonMaster = function(data) {
             commonMaster =  data;
        }

        generalInsurenceMotor.getMIcommonMaster = function(data) {
            return commonMaster;
        }


        generalInsurenceMotor.setSavedData = function(data) {
             savedData =  data;
        }

        generalInsurenceMotor.getSavedData = function(data) {
            return savedData;
        }


        generalInsurenceMotor.setSavedFinance = function(data) {
             financeDetails =  data;
        }

        generalInsurenceMotor.getSavedFinance = function(data) {
            return financeDetails;
        }

        generalInsurenceMotor.setPartyDetails = function(data) {
             partyDetail =  data;
        }

        generalInsurenceMotor.getPartyDetails = function() {
            return partyDetail;
        }




        //   generalInsurenceMotor.getTIQuoteCalculation = function(callback) {
        //         commonAPIService.invokeAdapter(genralInsurenceConfig.adapterURL.getTIQuoteCalculation[0],
        //         genralInsurenceConfig.adapterURL.getTIQuoteCalculation[1],null,callback);
        // };








        generalInsurenceMotor.getVehicleVarient = function(callback) {
            var response = {
                "data": {
                    "vehicleVarient": [{
                            "key": "0",
                            "value": "Lsi",
                        }, {
                            "key": "1",
                            "value": "Package Policy",
                        }

                    ]
                },
                "responseCode": "200",
                "responseMessage": "success",
                "errorLog": "string"
            };
            callback(response);
            //commonAPIService.invokeAdapter(genralInsurenceConfig.adapterURL.browseAllGIPlans[0],genralInsurenceConfig.adapterURL.browseAllGIPlans[1],'',callback)         
        }



        generalInsurenceMotor.getVehicleFuelType = function(callback) {
            var response = {
                "data": {
                    "vehicleFuelType": [{
                            "key": "0",
                            "value": "Petrol",
                        }, {
                            "key": "1",
                            "value": "Diesel",
                        }

                    ]
                },
                "responseCode": "200",
                "responseMessage": "success",
                "errorLog": "string"
            };
            callback(response);
            //commonAPIService.invokeAdapter(genralInsurenceConfig.adapterURL.browseAllGIPlans[0],genralInsurenceConfig.adapterURL.browseAllGIPlans[1],'',callback)         
        }


         generalInsurenceMotor.getMICommonMasters = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getMICommonMasters[0],true).then(
                function(response){ 

                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
                ); 
            return q.promise;
        };



        /*  get vehicle make based on vehicle type */
       generalInsurenceMotor.postVehicleType = function(vehicleType) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.postVehicleType[0],vehicleType,true).then(
                function(response){ 

                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
                ); 
            return q.promise;
        };

         /*  get vehicle make based on vehicle type */
       generalInsurenceMotor.getVehicleModel = function(vehicleMake) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getVehicleModel[0],vehicleMake,true).then(
                function(response){ 

                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
                ); 
            return q.promise;
        };

           /*  get vehicle make based on vehicle type */
       generalInsurenceMotor.getMIVehicleVariant = function(postDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getMIVehicleVariant[0],postDetail,true).then(
                function(response){ 

                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
                ); 
            return q.promise;
        };


         generalInsurenceMotor.getIDV = function(postDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getIDV[0],postDetail,true).then(
                function(response){ 

                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
                ); 
            return q.promise;
        };
        

         generalInsurenceMotor.getMIQuote = function(postDetail,data) {
            var urls;
            if(data=='31'){
                 urls =  genralInsurenceConfig.adapterURL.getMIQuoteFourWheeler[0];
            }else{
                urls =  genralInsurenceConfig.adapterURL.getMIQuote[0];
            }
            var q = $q.defer();
            AdapterUtils.postData(urls,postDetail,true).then(
                function(response){ 

                     if(response.data){
                        generalInsurenceHomeService.setQuoteNumber(response.data.premiumCalculation.quoteNumber);
                    } 

                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
                ); 
            return q.promise;
        };


        generalInsurenceMotor.applyMIProduct = function(postDetail,vheicalID) {

             var urls;
            if(vheicalID=='31'){
                 urls =  genralInsurenceConfig.adapterURL.applyMIFourWheelerProduct[0];
            }else{
                urls =  genralInsurenceConfig.adapterURL.applyMIProduct[0];
            }
            var q = $q.defer();
            AdapterUtils.postData(urls,postDetail,true).then(
                function(response){ 

                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
                ); 
            return q.promise;
        };


         generalInsurenceMotor.getRTOLocation = function(postDetail) {

          
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getRTOLocation[0],postDetail,true).then(
                function(response){ 

                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
                ); 
            return q.promise;
        };



            generalInsurenceMotor.saveFinance = function(postDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.saveFinance[0],postDetail,true).then(
                function(response){ 
                       
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
                ); 
            return q.promise;
        };

        generalInsurenceMotor.deleteFinance = function(postDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.deleteFinance[0],postDetail,true).then(
                function(response){ 
                     
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
                ); 
            return q.promise;
        };

        


        // generalInsurenceMotor.getVehicleModel = function(callback) {
        //     var response = {
        //         "data": {
        //             "vehicleModel": [{
        //                     "key": "0",
        //                     "value": "Indica",
        //                 }, {
        //                     "key": "1",
        //                     "value": "Maruthi",
        //                 }

        //             ]
        //         },
        //         "responseCode": "200",
        //         "responseMessage": "success",
        //         "errorLog": "string"
        //     };
        //     callback(response);
        //     //commonAPIService.invokeAdapter(genralInsurenceConfig.adapterURL.browseAllGIPlans[0],genralInsurenceConfig.adapterURL.browseAllGIPlans[1],'',callback)         
        // }


        generalInsurenceMotor.getVehicleType = function(callback) {

            var response = {
                "data": {
                    VehicleType: [{
                        'data': "New Vehicle",
                        selected: "true"
                    }, {
                        data: "Old Vehicle",
                        selected: "false"
                    }],


                }

            }


            callback(response);
        }





        generalInsurenceMotor.getDriverDetail = function(callback) {
            var response = {
                "data": {
                    "DriverDetail": [{
                            "key": "0",
                            "value": "3 Years to <5 Years",
                        }, {
                            "key": "1",
                            "value": "5 Years to <10 Years",
                        }, {
                            "key": "2",
                            "value": "10 Years to <15 Years",
                        }, {
                            "key": "3",
                            "value": "15 Years and above",
                        }

                    ]
                },
                "responseCode": "200",
                "responseMessage": "success",
                "errorLog": "string"
            };
            callback(response);
            //commonAPIService.invokeAdapter(genralInsurenceConfig.adapterURL.browseAllGIPlans[0],genralInsurenceConfig.adapterURL.browseAllGIPlans[1],'',callback)         
        }


        generalInsurenceMotor.getMIFuelType = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getMIFuelType[0],true).then(
                function(response){ 

                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
                ); 
            return q.promise;
        };

       generalInsurenceMotor.assignvalueForMotor = function() {
            var pagelength = 9;
            var savedApplication = {}   
            var services = [GIconstant.saveForMotor.motorInsuredWithOtherCompany,GIconstant.saveForMotor.motorVheicleDetail,GIconstant.saveForMotor.RtoDetail,GIconstant.saveForMotor.IDVDetail,GIconstant.saveForMotor.PersonalDetails,GIconstant.saveForMotor.PersonalAddressDetails,GIconstant.saveForMotor.motorVheicleAdditinolDetail,GIconstant.saveForMotor.motorVheicleFinanceDetail,"nominee"];
            for(var serCount = 0;serCount<pagelength;serCount++){
                var SavePageDetail = services[serCount];
                    

                    if(services[serCount] !="nominee"){
                        for (var count = 0; count < SavePageDetail.length; count++) {
                     if(validateSerCount(serCount)){
                        var cloudname = SavePageDetail[count].cloudName;
                        var modelname = SavePageDetail[count].modelName;
                        savedApplication = generalInsurenceHomeService.setObjectForService(savedData,cloudname,savedApplication,modelname,SavePageDetail[count].type);
                    }
                }
                    }

                
              
                if(serCount == 0){
                    if(validateSerCount(0)){
                      MotorQuoteFirstPageDetail = savedApplication;

                      MotorQuoteFirstPageDetail.productType =  savedData.uin;
                      MotorQuoteFirstPageDetail.policyType = savedData.quoteData.motorDetails.previousPolicyDetails.policyType ? $filter('selectBoxFilter')(commonMaster.policyType, savedData.quoteData.motorDetails.previousPolicyDetails.policyType) : "";
                      MotorQuoteFirstPageDetail.proofOfNCB = savedData.quoteData.motorDetails.previousPolicyDetails.proofOfNcb ? $filter('selectBoxFilter')(commonMaster.proofOFNcb, savedData.quoteData.motorDetails.previousPolicyDetails.proofOfNcb) : "";
                      MotorQuoteFirstPageDetail.companyName = savedData.quoteData.motorDetails.previousPolicyDetails.companyName ? $filter('selectBoxFilter')(commonMaster.insuranceCompany, savedData.quoteData.motorDetails.previousPolicyDetails.companyName) : "";
                      MotorQuoteFirstPageDetail.NCBOnPreviousPolicy = savedData.quoteData.motorDetails.previousPolicyDetails.ncb ? $filter('selectBoxFilter')(commonMaster.ncbOnPrevious, savedData.quoteData.motorDetails.previousPolicyDetails.ncb) : "";
                      MotorQuoteFirstPageDetail.natureOfLoss = savedData.quoteData.motorDetails.previousPolicyDetails.natureOfLoss ? $filter('selectBoxFilter')(commonMaster.natureOfLoss, savedData.quoteData.motorDetails.previousPolicyDetails.natureOfLoss) : "";
                    }
                }

                else if(serCount == 1){

                    if(MotorQuoteFirstPageDetail && MotorQuoteFirstPageDetail.policyType){
                        MotorTypeDetail ="old";
                      }else{
                        MotorTypeDetail ="new";
                      }

                 if(validateSerCount(1)){
                    MotorQuoteSecondPageDetail = savedApplication;
                    MotorQuoteSecondPageDetail.productType =  savedData.uin;

                  }
                }
                else if(serCount == 2){
                    if(validateSerCount(2)){
                    MotorQuoteThirdPageDetail = savedApplication;
                    MotorQuoteThirdPageDetail.rtoCity = savedData.quoteData.motorDetails.vehicleDetails.rtoLocation.rtoCity;
                    MotorQuoteThirdPageDetail.rtoLocation = savedData.quoteData.motorDetails.vehicleDetails.rtoLocation.rtoLocation;
                    MotorQuoteThirdPageDetail.productType =  savedData.uin;
                    MotorQuoteThirdPageDetail.selectedRTO =  savedData.quoteData.motorDetails.vehicleDetails.rtoLocation;
                   }
                }else if(serCount == 3){
                    MotorQuoteFourthPageDetail = {};
                    MotorQuoteFourthPageDetail.nomineeRequired = false;
                    if(validateSerCount(3)){
                    MotorQuoteFourthPageDetail = savedApplication;
                    MotorQuoteFourthPageDetail.productType =  savedData.uin;
                    MotorQuoteFourthPageDetail.addtionalcoverage = [];
                     MotorQuoteFourthPageDetail.Description = [];
                     if( savedData.quoteData.additonalCoverage){
                             if(savedData.uin == '32'){
                        for(var count = 0; count <  savedData.quoteData.additonalCoverage.length; count++){
                                 for(var i = 0; i <  commonMaster.additionCoverageForTwo.length; i++){
                                          if(savedData.quoteData.additonalCoverage[count].type == commonMaster.additionCoverageForTwo[i].qname){


                                             if (commonMaster.additionCoverageForTwo[i].nomineeRequired) {
                                                          MotorQuoteFourthPageDetail.nomineeRequired = true;
                                              } 

                                            var questionID = commonMaster.additionCoverageForTwo[i].qid;
                                                MotorQuoteFourthPageDetail.addtionalcoverage[questionID] = true;
                                                MotorQuoteFourthPageDetail.Description[questionID] = {};
                                                 MotorQuoteFourthPageDetail.Description[questionID].desc = [];
                                                for(var field = 0; field<commonMaster.additionCoverageForTwo[i].fields.length; field ++){
                                                    if(field == 0){
                                                        if(commonMaster.additionCoverageForTwo[i].fields[field].type == 'text' ){
                                                            MotorQuoteFourthPageDetail.Description[questionID].desc[field] = savedData.quoteData.additonalCoverage[count].value;
                                                        }
                                                        if( commonMaster.additionCoverageForTwo[i].fields[field].type == 'number'){
                                                            MotorQuoteFourthPageDetail.Description[questionID].desc[field] = Number(savedData.quoteData.additonalCoverage[count].value);
                                                        }

                                                        if(commonMaster.additionCoverageForTwo[i].fields[field].type == 'select'){
                                                            MotorQuoteFourthPageDetail.Description[questionID].desc[field] = $filter('selectBoxFilter')(commonMaster.additionCoverageForTwo[i].fields[field].values, savedData.quoteData.additonalCoverage[count].value,"value");
                                                        }
                                                    }else{
                                                        if(commonMaster.additionCoverageForTwo[i].fields[field].type == 'text'){
                                                            MotorQuoteFourthPageDetail.Description[questionID].desc[field] = savedData.quoteData.additonalCoverage[count].desc;
                                                        }
                                                         if( commonMaster.additionCoverageForTwo[i].fields[field].type == 'number'){
                                                            MotorQuoteFourthPageDetail.Description[questionID].desc[field] = Number(savedData.quoteData.additonalCoverage[count].value);
                                                        }
                                                        if(commonMaster.additionCoverageForTwo[i].fields[field].type == 'select'){
                                                            MotorQuoteFourthPageDetail.Description[questionID].desc[field] = $filter('selectBoxFilter')(commonMaster.additionCoverageForTwo[i].fields[field].values, savedData.quoteData.additonalCoverage[count].desc,"value");
                                                        }
                                                    }
                                            }
                                        }
                                }
                            }
                    }else{
                        for(var count = 0; count <  savedData.quoteData.additonalCoverage.length; count++){
                                 for(var i = 0; i <  commonMaster.additionCoverageForFour.length; i++){
                                          if(savedData.quoteData.additonalCoverage[count].type == commonMaster.additionCoverageForFour[i].qname){

                                             if (commonMaster.additionCoverageForFour[i].nomineeRequired) {
                                                          MotorQuoteFourthPageDetail.nomineeRequired = true;
                                              } 
                                              var questionID = commonMaster.additionCoverageForFour[i].qid;
                                                MotorQuoteFourthPageDetail.addtionalcoverage[questionID] = true;
                                                 MotorQuoteFourthPageDetail.Description[questionID] = {};
                                                 MotorQuoteFourthPageDetail.Description[questionID].desc = [];
                                                for(var field = 0; field<commonMaster.additionCoverageForFour[i].fields.length; field ++){
                                                    if(field == 0){
                                                        if(commonMaster.additionCoverageForFour[i].fields[field].type == 'text'){
                                                            MotorQuoteFourthPageDetail.Description[questionID].desc[field] = savedData.quoteData.additonalCoverage[count].value;
                                                        }
                                                        if(commonMaster.additionCoverageForFour[i].fields[field].type == 'number'){
                                                             MotorQuoteFourthPageDetail.Description[questionID].desc[field] = Number(savedData.quoteData.additonalCoverage[count].value);
                                                        }
                                                        if(commonMaster.additionCoverageForFour[i].fields[field].type == 'select'){
                                                            MotorQuoteFourthPageDetail.Description[questionID].desc[field] = $filter('selectBoxFilter')(commonMaster.additionCoverageForFour[i].fields[field].values, savedData.quoteData.additonalCoverage[count].value,"value");
                                                        }
                                                    }else{
                                                        if(commonMaster.additionCoverageForFour[i].fields[field].type == 'text' || commonMaster.additionCoverageForFour[i].fields[field].type == 'number'){
                                                            MotorQuoteFourthPageDetail.Description[questionID].desc[field] = savedData.quoteData.additonalCoverage[count].desc;
                                                        }
                                                        if(commonMaster.additionCoverageForFour[i].fields[field].type == 'number'){
                                                             MotorQuoteFourthPageDetail.Description[questionID].desc[field] = Number(savedData.quoteData.additonalCoverage[count].value);
                                                        }
                                                        if(commonMaster.additionCoverageForFour[i].fields[field].type == 'select'){
                                                            MotorQuoteFourthPageDetail.Description[questionID].desc[field] = $filter('selectBoxFilter')(commonMaster.additionCoverageForFour[i].fields[field].values, savedData.quoteData.additonalCoverage[count].desc,"value");
                                                        }
                                                    }
                                            }
                                        }
                                }
                            }

                    }
                }

                if(savedData.quoteData && savedData.quoteData.premiumCalculation &&  savedData.quoteData.premiumCalculation.response){
                    QuoteDetail = savedData.quoteData.premiumCalculation.response;
                }
               
                    // savedData.quoteData.additonalCoverage

                }
                   
                }else if(serCount == 4){
                    if(validateSerCount(4)){
                      MotorPersonalFirstPageDetail = savedApplication;
                      MotorPersonalFirstPageDetail.gender = $filter('selectBoxFilter')(commonMaster.gender, MotorPersonalFirstPageDetail.gender);
                      MotorPersonalFirstPageDetail.productType =  savedData.uin;
                  }
                }

                else if(serCount == 5){
                    if(validateSerCount(5)){
                      MotorPersonalSecondPageDetail = savedApplication;
                      prepopulatePersonalDetail = true;
                      var detailforParty = {};
                      detailforParty.partyCreate = savedData.applicationData.partyDetails;
                      generalInsurenceHomeService.setCreatePartyCI(detailforParty);
                      generalInsurenceHomeService.setIIBaccountDetail("test");
                      generalInsurenceHomeService.setLocatiopnBasedPincode(savedData.applicationData.createquoterequest.insuredDetails.locationSource);
                      MotorPersonalSecondPageDetail.productType =  savedData.uin;
                  }
                    
                }
                 else if(serCount == 6){
                    if(validateSerCount(6)){
                      MotorPersonalThirdPageDetail = savedApplication;
                      MotorPersonalThirdPageDetail.DriverExperience = $filter('selectBoxFilter')(commonMaster.driverExperience, MotorPersonalThirdPageDetail.DriverExperience);
                       MotorPersonalThirdPageDetail.vehiclePurchaseAs = $filter('selectBoxFilter')(commonMaster.driverExperience, MotorPersonalThirdPageDetail.vehiclePurchaseAs);
                      MotorPersonalThirdPageDetail.productType =  savedData.uin;
                  }
                    
                }else if(serCount == 7){
                    if(validateSerCount(7)){
                     MotorPersonalFourthPageDetail = savedApplication;
                      MotorPersonalFourthPageDetail.financeType =  $filter('selectBoxFilter')(commonMaster.financeType, MotorPersonalFourthPageDetail.financeType);
                      MotorPersonalFourthPageDetail.productType =  savedData.uin;
                      financeDetails = "save#"+ savedApplication.listId;
                  }
                    
                }else  if(serCount == 8){


                     if (savedData && savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.nomineeDetails) {

                        var nomineeDetail = {};
                        nomineeDetail.uin  = savedData.uin;
                        nomineeDetail.nomineeTitle = savedData.applicationData.createquoterequest.nomineeDetails.name.salutation;
                        nomineeDetail.name1 = savedData.applicationData.createquoterequest.nomineeDetails.name.firstName;
                        nomineeDetail.nomineeLastName = savedData.applicationData.createquoterequest.nomineeDetails.name.lastName;
                       // nomineeDetail.relationship = $filter('selectBoxFilter')(commonMaster.nomineeRelation,savedData.applicationData.createquoterequest.nomineeDetails.relationship); 
                        nomineeDetail.birthDate =  $filter('chosenDate')(savedData.applicationData.createquoterequest.nomineeDetails.dob);
                       if(savedData.applicationData.createquoterequest.appointeeDetails){
                        nomineeDetail.appointeeTitle =  savedData.applicationData.createquoterequest.appointeeDetails.appointeeTitle;
                        nomineeDetail.name = savedData.applicationData.createquoterequest.appointeeDetails.name;
                        nomineeDetail.appointeeLastName =  savedData.applicationData.createquoterequest.appointeeDetails.lastName;
                        //nomineeDetail.relationshipWithNominee = $filter('selectBoxFilter')(commonMaster.appointeeRelation,savedData.applicationData.createquoterequest.appointeeDetails.appointeeRelationship);
                        nomineeDetail.proposerBirthday =  $filter('chosenDate')(savedData.applicationData.createquoterequest.appointeeDetails.dob);
                       }
                    generalInsurenceTravelService.setTravelNomineeDetail(nomineeDetail);
                        

                     }
                }
                
               

                  savedApplication = {};
             }
   };



        function validateSerCount(count) {

            switch (count) {

                case 0:
                    if (savedData.quoteData && savedData.quoteData.motorDetails && savedData.quoteData.motorDetails.previousPolicyDetails) {
                        return true
                    } else {
                        return false;
                    }
                    break;

                case 1:
                    if (savedData.quoteData && savedData.quoteData.motorDetails && savedData.quoteData.motorDetails.vehicleDetails) {
                        return true
                    } else {
                        return false;
                    }
                    break;
                case 2:
                    if (savedData.quoteData && savedData.quoteData.motorDetails && savedData.quoteData.motorDetails.vehicleDetails && savedData.quoteData.motorDetails.vehicleDetails.rtoLocation  ) {
                        return true
                    } else {
                        return false;
                    }
                    break;
                 case 3:
                    if (savedData.quoteData && savedData.quoteData.motorDetails && savedData.quoteData.motorDetails.vehicleDetails) {
                        return true
                    } else {
                        return false;
                    }
                    break;
                  case 4:
                    if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.insuredDetails) {
                        return true
                    } else {
                        return false;
                    }
                    break;
                case 5:
                    if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.insuredDetails) {
                        return true
                    } else {
                        return false;
                    }
                    break;
                 case 6:
                    if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.vehicleDetails) {
                        return true
                    } else {
                        return false;
                    }
                    break;
                case 7:
                    if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.vehicleDetails) {
                        return true
                    } else {
                        return false;
                    }
                    break;
            

            }
        }


         




       





        


        return generalInsurenceMotor;
        }
    ]);





// })();
