angularApp.controller('motorGetQuoteController', ["$translate", "$scope", "$state", "generalInsurenceMotorService","generalInsurenceHomeService","utilityService","clickStreamService",
    function($translate, $scope, $state, generalInsurenceMotorService,generalInsurenceHomeService,utilityService,clickStreamService) {

        var motorGetQuoteVm = this;

        //function will load when page load  
        function initPage() {
            var motorTypes = generalInsurenceMotorService.getMotorType();
           var uin = generalInsurenceHomeService.getProductDetail();
         
            if (uin.uin != '32') {
                motorGetQuoteVm.New = $translate.instant('MY_NEW_CAR');
                motorGetQuoteVm.Insured = $translate.instant('ROLLOVER_CAR_LBL');
            } else {
                motorGetQuoteVm.New = $translate.instant('MY_NEW_TWO_WHEELER');
                motorGetQuoteVm.Insured = $translate.instant('ROLLOVER_TWO_WHEELER_LBL');
            }

            generalInsurenceMotorService.getMICommonMasters().then(function(response) {
              generalInsurenceMotorService.setMIcommonMaster(response);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

          



        //function to call dunction when page load  
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });


        function clearMotorService(){
            generalInsurenceMotorService.setMotorQuoteFirstPageDetail(null);
            generalInsurenceMotorService.setMotorQuoteSecondPageDetail(null);
            generalInsurenceMotorService.setMotorQuoteThirdPageDetail(null);
            generalInsurenceMotorService.setMotorQuoteFourthPageDetail(null);
            generalInsurenceMotorService.setMotorPersonalFirstPageDetail(null);
            generalInsurenceMotorService.setMotorPersonalSecondPageDetail(null);
            generalInsurenceMotorService.setMotorPersonalThirdPageDetail(null);
            generalInsurenceMotorService.setMotorPersonalFourthPageDetail(null);
        }


        //function to show new vheicle detail
        motorGetQuoteVm.newCarApplication = function() {
            clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
            if(generalInsurenceMotorService.getMotorTypeDetail()){
                if( generalInsurenceMotorService.getMotorTypeDetail() !="new"){
                    clearMotorService();
                }
            }


            generalInsurenceMotorService.setMotorTypeDetail("new");
             utilityService.showErrorMessage($translate.instant('NEW_CAR_COMING_SOON'));

        }

        //function to show old vheicle detail
        motorGetQuoteVm.rollOverInsurance = function() {
            clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
            if(generalInsurenceMotorService.getMotorTypeDetail()){
                if( generalInsurenceMotorService.getMotorTypeDetail() !="old"){
                    clearMotorService();
                }
            }

            generalInsurenceMotorService.setMotorTypeDetail("old");
            $state.go("menu.motorCarInsuredWithOtherCompany");
        }
        motorGetQuoteVm.goBack = function(){
                 $state.go("menu.motorRecommendedPolicyFeatures");
        }


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);


// })();
