angularApp.controller('motorInsurerPersonalDetailsController', ["$filter", "$state", "$scope", "$translate", "validateService", "generalInsurenceMotorService", "$stateParams", "generalInsurenceHomeService","utilityService","GIconstant","clickStreamService",
    function($filter, $state, $scope, $translate, validateService, generalInsurenceMotorService, $stateParams, generalInsurenceHomeService,utilityService,GIconstant,clickStreamService) {
        
        var motorInsurerPDVm = this;
        motorInsurerPDVm.motorInsurerPDForm = {};
        motorInsurerPDVm.bascicPersonalDetails = {};
        motorInsurerPDVm.validateService = validateService;
        var productType;
        var savedApplication;



        motorInsurerPDVm.titles =  generalInsurenceMotorService.getMIcommonMaster().salutation;
       


         function SetSaveApplicationForMotor(dataDetail) {
            if(savedApplication.applicationData){
                if(savedApplication.applicationData.createquoterequest){
                    if(savedApplication.applicationData.createquoterequest.insuredDetails){
                    }else{
                         savedApplication.applicationData.createquoterequest.insuredDetails =  {};
                    }
                }else{
                      savedApplication.applicationData.createquoterequest =  {};
                      savedApplication.applicationData.createquoterequest.insuredDetails = {};
                }
            }else{
                savedApplication.applicationData =  {};
                savedApplication.applicationData.createquoterequest =  {};
               
                savedApplication.applicationData.createquoterequest.insuredDetails = {};
            }

             var SavePageDetail = GIconstant.saveForMotor.PersonalDetails;
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, motorInsurerPDVm.bascicPersonalDetails, modelname, SavePageDetail[count].type);
            }            
           
            var JsonStingedData = angular.copy(savedApplication);
            generalInsurenceMotorService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
             JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
            generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Motor.MI_OWNER_DETAILS_1).then(function(data) {
             $state.go("menu.motorInsurerAddressDetails");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
          


        //function will call when page load
        function initPage() {
            if(generalInsurenceMotorService.getMotorQuoteFourthPageDetail().nomineeRequired){
                motorInsurerPDVm.totalLength = true;
            }else{
                motorInsurerPDVm.totalLength = false;
            }
             savedApplication = generalInsurenceMotorService.getSavedData();
              productType = generalInsurenceHomeService.getProductDetail().uin;

                 if (productType == '31') {
                motorInsurerPDVm.title = $translate.instant('motorprivatecar');
            } else if (productType == '32') {
                motorInsurerPDVm.title = $translate.instant('motortwowheeler');
            }


            motorInsurerPDVm.showBack = true;
            motorInsurerPDVm.showNext = true;
            motorInsurerPDVm.genders =   generalInsurenceMotorService.getMIcommonMaster().gender;
            //if ($stateParams.agree) {
            if (generalInsurenceMotorService.UserSelectionLastName == 'true') {
                 motorInsurerPDVm.readonlyValue =  true; 
                 generalInsurenceMotorService.setprepopulatePersonalDetail(true);
                 var accountNumber = generalInsurenceHomeService.getaccountDetail();

            if(accountNumber){
                var account = {
                    "bankAccountNo" : accountNumber.benAccntNo
                }
                 generalInsurenceHomeService.getSBIBankAccoutDetails(account).then(function(data) {

                    if(data){
                        generalInsurenceHomeService.setIIBaccountDetail(data);
                        motorInsurerPDVm.bascicPersonalDetails.name  = data.cbsData.firstName;
                        motorInsurerPDVm.bascicPersonalDetails.birthday = $filter('formatCbsDate')(data.cbsData.dateOfBirth); 
                        motorInsurerPDVm.bascicPersonalDetails.mobileNumber = data.cbsData.mobileNumber;
                        if(data.cbsData.email1){ 
                           motorInsurerPDVm.bascicPersonalDetails.emailID = data.cbsData.email1;
                        }else{
                            motorInsurerPDVm.bascicPersonalDetails.emailID = data.cbsData.email1;
                        }
                        if(data.cbsData.genderCode=="F"){
                             motorInsurerPDVm.bascicPersonalDetails.gender = motorInsurerPDVm.genders[1];
                        }else{
                             motorInsurerPDVm.bascicPersonalDetails.gender = motorInsurerPDVm.genders[0];
                        }  

                        motorInsurerPDVm.bascicPersonalDetails.firstName = data.cbsData.firstName;
                        motorInsurerPDVm.bascicPersonalDetails.LastName =  data.cbsData.lastName;
                        motorInsurerPDVm.chkValidLastName();

                          if(data.cbsData.genderCode=='F'){
                          
                        for(var count =0; count < motorInsurerPDVm.titles.length;count++){
                            if("02" == motorInsurerPDVm.titles[count].cbsKey){
                              motorInsurerPDVm.bascicPersonalDetails.title =   motorInsurerPDVm.titles[count];
                            }
                          }
                        }else{
                          
                            for(var count =0; count < motorInsurerPDVm.titles.length;count++){
                            if("01" == motorInsurerPDVm.titles[count].cbsKey){
                              motorInsurerPDVm.bascicPersonalDetails.title =   motorInsurerPDVm.titles[count];
                            }
                        }
                    }



                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
             });
            }

       }else{
        motorInsurerPDVm.readonlyValue =  false;
       }
                if( generalInsurenceMotorService.getMotorPersonalFirstPageDetail()){
                     motorInsurerPDVm.bascicPersonalDetails  =  generalInsurenceMotorService.getMotorPersonalFirstPageDetail();
                     motorInsurerPDVm.chkValidLastName();
                }else{
                    motorInsurerPDVm.bascicPersonalDetails  = {};
                }
                     

                    var todaysDate = generalInsurenceHomeService.getCurrentDate();
                    motorInsurerPDVm.minBirthdate = generalInsurenceHomeService.getFutureYear(todaysDate, -18);
                    motorInsurerPDVm.bascicPersonalDetails.defaultvalue  = motorInsurerPDVm.minBirthdate;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });
        motorInsurerPDVm.goToBackPage = function() {
             $state.go("menu.paymentAccountDetailsMotor");
        }



        //onclick of submit button
        motorInsurerPDVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                generalInsurenceMotorService.setMotorPersonalFirstPageDetail(motorInsurerPDVm.bascicPersonalDetails);
                SetSaveApplicationForMotor();
               
            }
        }


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        motorInsurerPDVm.chkValidLastName = function() {
            motorInsurerPDVm.motorInsurerPDForm = {};            

            if(generalInsurenceMotorService.UserSelectionLastName == 'true'){
                if (motorInsurerPDVm.validateService.isValidLastNameGI(motorInsurerPDVm.bascicPersonalDetails.LastName)) {
                motorInsurerPDVm.motorInsurerPDForm.LastName = motorInsurerPDVm.validateService.isValidLastNameGI(motorInsurerPDVm.bascicPersonalDetails.LastName,true);
                }
                
            }else{
                if (motorInsurerPDVm.validateService.isValidLastNameGI(motorInsurerPDVm.bascicPersonalDetails.LastName)) {
                motorInsurerPDVm.motorInsurerPDForm.LastName = motorInsurerPDVm.validateService.isValidLastNameGI(motorInsurerPDVm.bascicPersonalDetails.LastName,false);
                }
            }
            return (angular.equals({}, motorInsurerPDVm.motorInsurerPDForm)) ? true : false;
        }


        //conmmon validation function
        function validateForm() {
            motorInsurerPDVm.motorInsurerPDForm = {};
            

            if (motorInsurerPDVm.validateService.isValidTitle(motorInsurerPDVm.bascicPersonalDetails.title)) {
                motorInsurerPDVm.motorInsurerPDForm.title = motorInsurerPDVm.validateService.isValidTitle(motorInsurerPDVm.bascicPersonalDetails.title);
            }



            if (motorInsurerPDVm.validateService.isValidFirstName(motorInsurerPDVm.bascicPersonalDetails.firstName)) {
                motorInsurerPDVm.motorInsurerPDForm.firstName = motorInsurerPDVm.validateService.isValidFirstName(motorInsurerPDVm.bascicPersonalDetails.firstName);
            }

            if(generalInsurenceMotorService.UserSelectionLastName == 'true'){
                if (motorInsurerPDVm.validateService.isValidLastNameGI(motorInsurerPDVm.bascicPersonalDetails.LastName)) {
                motorInsurerPDVm.motorInsurerPDForm.LastName = motorInsurerPDVm.validateService.isValidLastNameGI(motorInsurerPDVm.bascicPersonalDetails.LastName,true);
                }
                
            }else{
                if (motorInsurerPDVm.validateService.isValidLastNameGI(motorInsurerPDVm.bascicPersonalDetails.LastName)) {
                motorInsurerPDVm.motorInsurerPDForm.LastName = motorInsurerPDVm.validateService.isValidLastNameGI(motorInsurerPDVm.bascicPersonalDetails.LastName,false);
                }
            }


            


            // if (motorInsurerPDVm.validateService.isValidName(motorInsurerPDVm.bascicPersonalDetails.name)) {
            //     motorInsurerPDVm.motorInsurerPDForm.name = motorInsurerPDVm.validateService.isValidName(motorInsurerPDVm.bascicPersonalDetails.name);
            // }
            if (motorInsurerPDVm.validateService.isValidDOB(motorInsurerPDVm.bascicPersonalDetails.birthday)) {
                motorInsurerPDVm.motorInsurerPDForm.birthday = motorInsurerPDVm.validateService.isValidDOB(motorInsurerPDVm.bascicPersonalDetails.PolicyStartDate);
            }
            if (motorInsurerPDVm.validateService.isValidGender(motorInsurerPDVm.bascicPersonalDetails.gender)) {
                motorInsurerPDVm.motorInsurerPDForm.gender = motorInsurerPDVm.validateService.isValidGender(motorInsurerPDVm.bascicPersonalDetails.gender);
            }
            if (motorInsurerPDVm.validateService.isValidEmail((motorInsurerPDVm.bascicPersonalDetails.emailID).trim())) {
                motorInsurerPDVm.motorInsurerPDForm.emailID = motorInsurerPDVm.validateService.isValidEmail((motorInsurerPDVm.bascicPersonalDetails.emailID).trim());
            }
            if (motorInsurerPDVm.validateService.isValidPhoneNo(motorInsurerPDVm.bascicPersonalDetails.mobileNumber)) {
                motorInsurerPDVm.motorInsurerPDForm.mobileNumber = motorInsurerPDVm.validateService.isValidPhoneNo(motorInsurerPDVm.bascicPersonalDetails.mobileNumber);
            }

            return (angular.equals({}, motorInsurerPDVm.motorInsurerPDForm)) ? true : false;
        }

        motorInsurerPDVm.setGender = function(_data) {
            if(_data){
                console.log("chk gender" + _data);
                if(_data.value == 'Mr'){
                     motorInsurerPDVm.bascicPersonalDetails.gender = motorInsurerPDVm.genders[0];
                }else if(_data.value == 'Mrs'){
                     motorInsurerPDVm.bascicPersonalDetails.gender = motorInsurerPDVm.genders[1];
                }else if(_data.value == 'Miss'){
                     motorInsurerPDVm.bascicPersonalDetails.gender = motorInsurerPDVm.genders[1];
                }

            }
            
        }

    }
   ]);


 
// })();
