angularApp.controller('motorInsurerVehicleInfoController', [
        "$state",
        "$scope",
        "$translate", "validateService", "generalInsurenceMotorService","generalInsurenceHomeService","GIconstant","utilityService","clickStreamService",


        function(
            $state,
            $scope,
            $translate, validateService, generalInsurenceMotorService,generalInsurenceHomeService,GIconstant,utilityService,clickStreamService
        ) {

            //functions, variables that can be accessed from the HTML come here
            var motorInsurerVehicleInfoVm = this;
            var savedApplication;
            //private methods section start
            motorInsurerVehicleInfoVm.showBack = true;
            motorInsurerVehicleInfoVm.showNext = true;
            motorInsurerVehicleInfoVm.insuredVehicleDetail = {};
            motorInsurerVehicleInfoVm.VehicleEngine = {};




            function SetSaveApplicationForMotor() {
            var SavePageDetail = GIconstant.saveForMotor.motorVheicleAdditinolDetail;
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname,motorInsurerVehicleInfoVm.VehicleEngine,modelname, SavePageDetail[count].type);
            }
            var JsonStingedData = angular.copy(savedApplication);
            generalInsurenceMotorService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
             JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
            generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Motor.MI_INSURED_DETAILS_1).then(function(data) {
             $state.go("menu.motorInsurerFinancialDetails");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



            //call the function when we will init the page
            function initPage() {
                if(generalInsurenceMotorService.getMotorQuoteFourthPageDetail().nomineeRequired){
                    motorInsurerVehicleInfoVm.totalLength = true;
                }else{
                    motorInsurerVehicleInfoVm.totalLength = false;
                }
             savedApplication = generalInsurenceMotorService.getSavedData();
             var  productType = generalInsurenceHomeService.getProductDetail().uin;

                 if (productType == '31') {
                motorInsurerVehicleInfoVm.title = $translate.instant('motorprivatecar');
            } else if (productType == '32') {
                motorInsurerVehicleInfoVm.title = $translate.instant('motortwowheeler');
            }


                motorInsurerVehicleInfoVm.accDetails = [{ 'account': 'STATE BANK OF INDIA A/C', 'accountNo': 1234567890 },
                    { 'account': 'STATE BANK OF INDIA A/C', 'accountNo': 5678904325 }
                ];



                
                //onkeyup validate fields if required
                motorInsurerVehicleInfoVm.validateService = validateService;
                generalInsurenceMotorService.getMIcommonMaster()

                  motorInsurerVehicleInfoVm.driverdetails = generalInsurenceMotorService.getMIcommonMaster().driverExperience;
                  var vehiclePurchasedNA = [{
                    "key" : "NA",
                    "value" : "NA"
                  }];
                 

                 if(productType == '31'){
                     motorInsurerVehicleInfoVm.VehicleType = generalInsurenceMotorService.getMIcommonMaster().vehiclePurchashedForFour;
                 }else{
                     motorInsurerVehicleInfoVm.VehicleType = generalInsurenceMotorService.getMIcommonMaster().vehiclePurchashedForTwo;
                 }
                  var vehicleType = generalInsurenceMotorService.getMotorTypeDetail();

            
                 

                // generalInsurenceMotorService.getVehicleType(function(responce) {
                //     motorInsurerVehicleInfoVm.VehicleEngine.VehicleType = responce.data.VehicleType;
                //     generalInsurenceMotorService.getDriverDetail(function(responce) {
                //         motorInsurerVehicleInfoVm.driverdetails = responce.data.DriverDetail;

                            if(generalInsurenceMotorService.getMotorPersonalThirdPageDetail()){
                                 motorInsurerVehicleInfoVm.VehicleEngine  = generalInsurenceMotorService.getMotorPersonalThirdPageDetail();
                            }else{
                                motorInsurerVehicleInfoVm.VehicleEngine  = {};
                                motorInsurerVehicleInfoVm.VehicleEngine.financeType = "self";
                            }

                if(vehicleType == "old"){
                    motorInsurerVehicleInfoVm.VehicleType = vehiclePurchasedNA; 
                    motorInsurerVehicleInfoVm.VehicleEngine.vehiclePurchaseAs =  motorInsurerVehicleInfoVm.VehicleType[0];      
                }
            
                        
                //     })

                // })
            }


            //call the function when we click the validate form
            function validateForm() {
                motorInsurerVehicleInfoVm.insuredVehicleDetail = {};
                if (motorInsurerVehicleInfoVm.validateService.isValidVehiclePurchasedAS(motorInsurerVehicleInfoVm.VehicleEngine.vehiclePurchaseAs)) {
                    motorInsurerVehicleInfoVm.insuredVehicleDetail.vehiclePurchaseAs = motorInsurerVehicleInfoVm.validateService.isValidVehiclePurchasedAS(motorInsurerVehicleInfoVm.VehicleEngine.vehiclePurchaseAs);
                }
                if (motorInsurerVehicleInfoVm.validateService.isValidRegistraionNumber(motorInsurerVehicleInfoVm.VehicleEngine.registrationNumber)) {
                    motorInsurerVehicleInfoVm.insuredVehicleDetail.registrationNumber = motorInsurerVehicleInfoVm.validateService.isValidRegistraionNumber(motorInsurerVehicleInfoVm.VehicleEngine.registrationNumber);
                }
                if (motorInsurerVehicleInfoVm.validateService.isValidEngineNumber(motorInsurerVehicleInfoVm.VehicleEngine.engineNumber)) {
                    motorInsurerVehicleInfoVm.insuredVehicleDetail.engineNumber = motorInsurerVehicleInfoVm.validateService.isValidEngineNumber(motorInsurerVehicleInfoVm.VehicleEngine.engineNumber);
                }
                if (motorInsurerVehicleInfoVm.validateService.isValidChassisNumber(motorInsurerVehicleInfoVm.VehicleEngine.chassisNumber)) {
                    motorInsurerVehicleInfoVm.insuredVehicleDetail.chassisNumber = motorInsurerVehicleInfoVm.validateService.isValidChassisNumber(motorInsurerVehicleInfoVm.VehicleEngine.chassisNumber);
                }
                if (motorInsurerVehicleInfoVm.validateService.isValidDriverExperience(motorInsurerVehicleInfoVm.VehicleEngine.DriverExperience)) {
                    motorInsurerVehicleInfoVm.insuredVehicleDetail.DriverExperience = motorInsurerVehicleInfoVm.validateService.isValidDriverExperience(motorInsurerVehicleInfoVm.VehicleEngine.DriverExperience);
                }



                return (angular.equals({}, motorInsurerVehicleInfoVm.insuredVehicleDetail)) ? true : false;
            }



            //call the function when we click on previous button
            motorInsurerVehicleInfoVm.goToPreviousPage = function() {
                $state.go("menu.motorInsurerAddressDetails");
            }

            //call the function when we click on next button
            motorInsurerVehicleInfoVm.goToNextPage = function() {
                if (validateForm()) {
                    if(motorInsurerVehicleInfoVm.VehicleEngine.financeType == "self"){
                        motorInsurerVehicleInfoVm.VehicleEngine.isSelfOwned = true;
                    }else{
                        motorInsurerVehicleInfoVm.VehicleEngine.isSelfOwned = false;
                    }
                    clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                    if(motorInsurerVehicleInfoVm.VehicleEngine.financeType == "self" && (generalInsurenceMotorService.getSavedFinance() != undefined  || generalInsurenceMotorService.getSavedFinance() != null)  ) {         
                        var listId = generalInsurenceMotorService.getSavedFinance();
                        if(listId){
                          listId = listId.split("#")[1];
                        }
                        var financedetails = {
                          "deleteFinanceLTH": {
                            "quoteNo": generalInsurenceMotorService.getQuoteDetail().quoteNumber + "#" + listId
                          }
                        }
                          generalInsurenceMotorService.deleteFinance(financedetails).then(function(data) {
                    
                        generalInsurenceMotorService.setSavedFinance(undefined);
                  
                          }, function(error) {
                               utilityService.showErrorMessage(error.responseMessage);
                          });
                    }
                    generalInsurenceMotorService.setMotorPersonalThirdPageDetail(motorInsurerVehicleInfoVm.VehicleEngine);
                   SetSaveApplicationForMotor();
                }
            }

            //one time initialization to be done when the controller is loaded
            $scope.$on('$ionicView.loaded', function() {});

            //actions to done everytime the view is shown
            $scope.$on('$ionicView.beforeEnter', function() {
                initPage();

            });

        }
    ]);

// })();
