angularApp.controller('motorNewCarGetCarInfoController', [
    "$state",
    "$scope",
    "$translate", "validateService", "generalInsurenceMotorService", "generalInsurenceHomeService","utilityService","GIconstant","clickStreamService",


    function(
        $state,
        $scope,
        $translate, validateService, generalInsurenceMotorService, generalInsurenceHomeService,utilityService,GIconstant,clickStreamService) {


        var motorNewCarGetCarInfoVm = this;
        motorNewCarGetCarInfoVm.newVheicalDetail = {};
        motorNewCarGetCarInfoVm.newVhiecle = {};
        motorNewCarGetCarInfoVm.showNext = true;
        motorNewCarGetCarInfoVm.showBack = true;
        motorNewCarGetCarInfoVm.validateService = validateService;
        var productType,vheicleMake,vheicleModel,vheicleVarient,vheicleTypeDetail;
         var secondPageDetail,savedApplication;



         function SetSaveApplicationForMotor() {
            var SavePageDetail = GIconstant.saveForMotor.motorVheicleDetail;
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                 if (savedApplication) {
                if (savedApplication.quoteData) {
                    if (savedApplication.quoteData.motorDetails) {} else {
                        savedApplication.quoteData = {};
                    }
                }
             } else {
                savedApplication = {};
                savedApplication.quoteData = {};
 
             }


                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, motorNewCarGetCarInfoVm.newVhiecle, modelname, SavePageDetail[count].type);
            }
            var JsonStingedData = angular.copy(savedApplication);
            generalInsurenceMotorService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.uin = generalInsurenceHomeService.getProductDetail().uin;
            JsonStingedData.productCode = generalInsurenceHomeService.getGIProductsID();
            JsonStingedData.planName = generalInsurenceHomeService.getProductDetail().policyName;
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
             JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
            generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Motor.MI_VEHICLE_DETAILS_1).then(function(data) {
            $state.go("menu.motorNewCarGetMoreCarInfo");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        //call the page when user clicks the init page 
        function initPage() {
            savedApplication = generalInsurenceMotorService.getSavedData();
            motorNewCarGetCarInfoVm.vheicleType = generalInsurenceMotorService.getMotorTypeDetail();
            if(motorNewCarGetCarInfoVm.vheicleType=="new"){
                motorNewCarGetCarInfoVm.tootalProgresslength = 3;
                motorNewCarGetCarInfoVm.activelength = 1;
            }else{
                motorNewCarGetCarInfoVm.tootalProgresslength = 4;
                motorNewCarGetCarInfoVm.activelength = 2;
            }
            productType = generalInsurenceHomeService.getProductDetail().uin;
            var uin = {
                 "uin": productType,
            }
            if (productType == '31') {
                motorNewCarGetCarInfoVm.disableFuel = false;
                motorNewCarGetCarInfoVm.title = $translate.instant('motorprivatecar');
            } else if (productType == '32') {
                motorNewCarGetCarInfoVm.disableFuel = true; 
                motorNewCarGetCarInfoVm.title = $translate.instant('motortwowheeler');
            }
            /* get Vehicle make based on vehicle type   */
            if(productType == '31'){
                vheicleTypeDetail = "2";
               vheicleMake =  {
                  "vehicleType": "2"
                }
            }else{
                vheicleTypeDetail = "1";
                vheicleMake =  {
                  "vehicleType": "1"
                }
            }

            generalInsurenceMotorService.postVehicleType(vheicleMake).then(function(response) {
                motorNewCarGetCarInfoVm.vehicleMakes = response.vehicleMake;
                  // getFuelType();
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

            secondPageDetail = generalInsurenceMotorService.getMotorQuoteSecondPageDetail();
                if (secondPageDetail) {
                    if(secondPageDetail.productType == productType){
                       motorNewCarGetCarInfoVm.newVhiecle = secondPageDetail;
                        motorNewCarGetCarInfoVm.getMotorModel();
                    }else{
                        motorNewCarGetCarInfoVm.newVhiecle = {};
                    }
                    
                   
                }else{
                    motorNewCarGetCarInfoVm.newVhiecle = {};
                }


        }

         motorNewCarGetCarInfoVm.getFueltype = function(data){
            if (data) {
            motorNewCarGetCarInfoVm.vehicleFuelTypes = generalInsurenceMotorService.getMIcommonMaster().fuelType;
            for (var count = 0; count < motorNewCarGetCarInfoVm.vehicleFuelTypes.length; count++) {
             if(data.fuelType && data.fuelType != "null"){
                            if(data.fuelType == motorNewCarGetCarInfoVm.vehicleFuelTypes[count].key.toString()){
                                     motorNewCarGetCarInfoVm.newVhiecle.fuelType = motorNewCarGetCarInfoVm.vehicleFuelTypes[count];
                                     motorNewCarGetCarInfoVm.disableClass = 'fss-disable';
                                     break;
                            }
                        }else{
                            motorNewCarGetCarInfoVm.newVhiecle.fuelType = "";
                            motorNewCarGetCarInfoVm.disableClass = 'fss-enable';
                    }
                        }
                }
            }


          /* get Vehicle Variant based on vehicle Make and Vehicle Modol   */       
          motorNewCarGetCarInfoVm.getVehicleVariant = function() {
          if(motorNewCarGetCarInfoVm.newVhiecle && motorNewCarGetCarInfoVm.newVhiecle.vehicleModel && motorNewCarGetCarInfoVm.newVhiecle.vehicleModel.modId){
                 var postDetail = {
                         "vehicleType": vheicleTypeDetail,
                        "modelId": motorNewCarGetCarInfoVm.newVhiecle.vehicleModel.modId
                }
            generalInsurenceMotorService.getMIVehicleVariant(postDetail).then(function(response) {
                motorNewCarGetCarInfoVm.vehicleVarients = response.vehicleVariant;
                motorNewCarGetCarInfoVm.newVhiecle.fuelType = "";
                 if (secondPageDetail) {
                    if(motorNewCarGetCarInfoVm.newVhiecle.vehicleVariant){
                      motorNewCarGetCarInfoVm.getFueltype(motorNewCarGetCarInfoVm.newVhiecle.vehicleVariant);
                    }
                  }

            }, function(error) {
                 utilityService.showErrorMessage(error.responseMessage);
            });
          }
              

          }





             /* get Vehicle Model based on vehicle Make   */
          motorNewCarGetCarInfoVm.getMotorModel = function() {
            var vheicalMakeDetail = {
                "makeId": motorNewCarGetCarInfoVm.newVhiecle.vehicleMake.key,
                "vehicleType": vheicleTypeDetail,
            }
            generalInsurenceMotorService.getVehicleModel(vheicalMakeDetail).then(function(response) {
                motorNewCarGetCarInfoVm.vehicleModels = response.vehicleModel;
                 if (secondPageDetail) {
                      motorNewCarGetCarInfoVm.getVehicleVariant();
                  }
            }, function(error) {
                 utilityService.showErrorMessage(error.responseMessage);
            });

          }

          

         



        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //called when user clicks the back button
        motorNewCarGetCarInfoVm.goBacktoPrevious = function() {

                if(motorNewCarGetCarInfoVm.vheicleType=="new"){
                     $state.go("menu.motorGetQuote");
                }else{
                   $state.go("menu.motorCarInsuredWithOtherCompany");
                }

        }




        //added for field levelo validation
        function validateForm() {
            motorNewCarGetCarInfoVm.newVheicalDetail = {};
            if (motorNewCarGetCarInfoVm.validateService.isValidVhicleMake(motorNewCarGetCarInfoVm.newVhiecle.vehicleMake)) {
                motorNewCarGetCarInfoVm.newVheicalDetail.vehicleMake = motorNewCarGetCarInfoVm.validateService.isValidVhicleMake(motorNewCarGetCarInfoVm.newVhiecle.vehicleMake);
            }
            if (motorNewCarGetCarInfoVm.validateService.isValidVhicleModel(motorNewCarGetCarInfoVm.newVhiecle.vehicleModel)) {
                motorNewCarGetCarInfoVm.newVheicalDetail.vehicleModel = motorNewCarGetCarInfoVm.validateService.isValidVhicleModel(motorNewCarGetCarInfoVm.newVhiecle.vehicleModel);
            }
            if (motorNewCarGetCarInfoVm.validateService.isValidVhicleVarient(motorNewCarGetCarInfoVm.newVhiecle.vehicleVariant)) {
                motorNewCarGetCarInfoVm.newVheicalDetail.vehicleVariant = motorNewCarGetCarInfoVm.validateService.isValidVhicleVarient(motorNewCarGetCarInfoVm.newVhiecle.vehicleVariant);
            }
            if (motorNewCarGetCarInfoVm.validateService.isValidVhicleFuelType(motorNewCarGetCarInfoVm.newVhiecle.fuelType)) {
                motorNewCarGetCarInfoVm.newVheicalDetail.fuelType = motorNewCarGetCarInfoVm.validateService.isValidVhicleFuelType(motorNewCarGetCarInfoVm.newVhiecle.fuelType);
            }


            return (angular.equals({}, motorNewCarGetCarInfoVm.newVheicalDetail)) ? true : false;
        }


        //calls when user clicks the next button
        motorNewCarGetCarInfoVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                motorNewCarGetCarInfoVm.newVhiecle.productType = productType;
                generalInsurenceMotorService.setMotorQuoteSecondPageDetail(motorNewCarGetCarInfoVm.newVhiecle);
                if(motorNewCarGetCarInfoVm.vheicleType=="new"){
                    motorNewCarGetCarInfoVm.newVhiecle.insuredFor = "1";
                }else{
                    motorNewCarGetCarInfoVm.newVhiecle.insuredFor = "2";
                }
               SetSaveApplicationForMotor();
            }

        }

        //calls when user clicks the decremennt button
        motorNewCarGetCarInfoVm.decrement = function() {
            motorNewCarGetCarInfoVm.number--;
        }

        //calls when user clicks the increment button
        motorNewCarGetCarInfoVm.increment = function() {
            motorNewCarGetCarInfoVm.number++;
        }

        //calls when user clicks the back button
        motorNewCarGetCarInfoVm.showBack = function() {
            menu.motorGetQuote
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();

        });


    }
]);


// })();
