angularApp.controller('motorPremiumCalculationController', [
        "$state",
        "$scope","generalInsurenceMotorService","generalInsurenceHomeService","clickStreamService",


        function(
            $state,
            $scope,generalInsurenceMotorService,generalInsurenceHomeService,clickStreamService) {

            var motorPremiumCalculationVm = this;


            //call the function when user clicks the button
            function initPage() {
                motorPremiumCalculationVm.Application_Title = 'Application';
                motorPremiumCalculationVm.HealthInfo = 'Health information';
                motorPremiumCalculationVm.number = 0;
                motorPremiumCalculationVm.showNext = true;
                motorPremiumCalculationVm.showBack = true;
                motorPremiumCalculationVm.quoteDetail = {};
                motorPremiumCalculationVm.quoteDetail = generalInsurenceMotorService.getQuoteDetail();
                motorPremiumCalculationVm.quoteDetail.quoteNumber;
                motorPremiumCalculationVm.quoteDetail.premiumAmount;
                motorPremiumCalculationVm.VehicalIDV = generalInsurenceMotorService.getMotorQuoteFourthPageDetail().suggestedIDV;

                generalInsurenceHomeService.setpolicySumInsured(motorPremiumCalculationVm.VehicalIDV);
            }



            //one time initialization to be done when the controller is loaded
            $scope.$on('$ionicView.loaded', function() {
                initPage();
            });

            //this will CALL  before enter the page
            $scope.$on('$ionicView.beforeEnter', function() {
                initPage();
            });


            //call the function when user clicks the previous page
            motorPremiumCalculationVm.goBacktoPrevious = function() {
                $state.go("menu.motorNewCarGetIDVDetails");
            }

            //call the function when user clicks the nextpage
            motorPremiumCalculationVm.goToNextPage = function() {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                 $state.go("menu.paymentAccountDetailsMotor");
            }

            //call the function when user clicks the decerement
            motorPremiumCalculationVm.decrement = function() {
                motorPremiumCalculationVm.number--;
            }

            //call the function when user clicks the increment
            motorPremiumCalculationVm.increment = function() {
                motorPremiumCalculationVm.number++;
            }
        }
    ]);


// })();
