angularApp.controller('accidentApplicationInsurerInfoController', [ "$filter", "$state", "$scope", "$translate", "validateService", "generalInsurenceAccidentService", "generalInsurenceHomeService", "utilityService", "GIconstant","clickStreamService",
    function($filter, $state, $scope, $translate, validateService, generalInsurenceAccidentService, generalInsurenceHomeService, utilityService, GIconstant,clickStreamService) {

        var accidentAppvm = this;
        var savedApplication;
        accidentAppvm.detail = {};
        function SetSaveApplicationForPAI() {
            var SavePageDetail = GIconstant.saveForPAI.personalDetail;
            savedApplication.applicationData = {};
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, accidentAppvm.detail, modelname, SavePageDetail[count].type);
            }
            if(savedApplication.applicationData.createquoterequest.personalDetails.gender=='Male'){
                savedApplication.applicationData.createquoterequest.personalDetails.gender = 'M';
            }else{
                savedApplication.applicationData.createquoterequest.personalDetails.gender = 'F';
            }
            savedApplication.applicationData.createquoterequest.personalDetails.locationSource =  generalInsurenceHomeService.getLocationDetail();
            var JsonStingedData = angular.copy(savedApplication);
            generalInsurenceAccidentService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();;
            JsonStingedData.mobileNumber = "";
            JsonStingedData.uin = generalInsurenceHomeService.getProductDetail().uin;
            JsonStingedData.productCode = generalInsurenceHomeService.getGIProductsID();
            JsonStingedData.planName = generalInsurenceHomeService.getProductDetail().policyName;
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
             JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
            generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.PAI.PAI_POLICY).then(function(data) {
                $state.go('menu.travelNomineeDetails');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
 

        accidentAppvm.titles = generalInsurenceAccidentService.getMasterData().salutation;
        function getlocationDetail(pincode) {
            if(pincode.length == 6){
                var pinCodeNumber = {
                "pinCode": pincode
            }
            generalInsurenceHomeService.getLocation(pinCodeNumber).then(function(data) {
                if (data) {
                    generalInsurenceHomeService.setLocationDetail(data);
                    accidentAppvm.detail.city = data.city.cityName;
                    accidentAppvm.locations = data.location;

                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            }            
        }


        function initPage() {
            savedApplication = generalInsurenceAccidentService.getSavedData();
            accidentAppvm.showBack = true;
            accidentAppvm.showNext = true;
            accidentAppvm.readonly = true;
            function prefillData(accountNumber) {
                if(generalInsurenceHomeService.getProductDetail().uin=='44'){
                    var account = {
                        "bankAccountNo": ''
                    }
                }else {
                    var account = {
                        "bankAccountNo": accountNumber[0].benAccntNo
                    }
                }
                    generalInsurenceHomeService.getSBIBankAccoutDetails(account).then(function(data) {
                        if (data) {
                            accidentAppvm.detail.firstName = data.cbsData.firstName;
                            accidentAppvm.detail.lastName = data.cbsData.lastName;
                            accidentAppvm.detail.dob = $filter('formatCbsDate')(data.cbsData.dateOfBirth);
                            accidentAppvm.detail.emailId = data.cbsData.email1;
                            accidentAppvm.detail.mobileNumber = data.cbsData.mobileNumber;
                            accidentAppvm.detail.pincode = data.cbsData.pinCode;
                            accidentAppvm.detail.plotNo = data.cbsData.addressLine1;
                            accidentAppvm.detail.plotNo = accidentAppvm.detail.plotNo ? accidentAppvm.detail.plotNo.replace(/[^A-Za-z0-9./,-\s]/g, '') : '';
                            accidentAppvm.detail.buildingName = data.cbsData.addressLine2;
                            accidentAppvm.detail.streetName = data.cbsData.addressLine3;
                            if (data.cbsData.genderCode == "F") {
                                accidentAppvm.detail.gender = "Female";
                            } else {
                                accidentAppvm.detail.gender = "Male";
                            }
                            getlocationDetail(data.cbsData.pinCode);
                            var pageDetail = generalInsurenceAccidentService.getInsuredDetails();
                            if (pageDetail) {
                                accidentAppvm.detail = pageDetail;
                            }
                        }
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                //}
            }
            accidentAppvm.validateService = validateService;
            var account = {};
            generalInsurenceHomeService.getSBIBankAccounts(account).then(function(data) {
                accidentAppvm.accDetails = data.beneficiaryList.ownAccounts;
                prefillData(accidentAppvm.accDetails)
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

            /* get all fields detail on click back button */
            // if (generalInsurenceAccidentService.getInsuredDetails()) {
            //     accidentAppvm.name = generalInsurenceAccidentService.getInsuredDetails().name;
            //     accidentAppvm.birthdate = generalInsurenceAccidentService.getInsuredDetails().birthDate;
            //     accidentAppvm.gender = generalInsurenceAccidentService.getInsuredDetails().gender;
            //     accidentAppvm.emailID = generalInsurenceAccidentService.getInsuredDetails().email;
            //     accidentAppvm.mobileNumber = generalInsurenceAccidentService.getInsuredDetails().mobileNumber;
            //     accidentAppvm.address = generalInsurenceAccidentService.getInsuredDetails().address;
            //     accidentAppvm.city = generalInsurenceAccidentService.getInsuredDetails().city;
            //     accidentAppvm.pin = generalInsurenceAccidentService.getInsuredDetails().pincode;
            // }
            accidentAppvm.sumInsured = $filter('rupeeSymbol')(generalInsurenceAccidentService.getsumInsuredDetail().SumInsuredValue);
        }


        /* Birthdate should be lesser than current date */
        accidentAppvm.minBirthdate = generalInsurenceHomeService.getCurrentDate();
        /* get sumInsured Value */
        accidentAppvm.insuredPersonDetail = generalInsurenceAccidentService.getsumInsuredDetail();
        //private methods section end
        accidentAppvm.getLocationDetail = function() {
            if (accidentAppvm.detail.pincode.length == '6') {
                getlocationDetail(accidentAppvm.detail.pincode);
            }
        }
        accidentAppvm.goBacktoPrevious = function() {
            $state.go('menu.accidentQuoteMemberInfo');
        }
        /*  if validation valid go to next page */
        accidentAppvm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                    generalInsurenceAccidentService.setInsuredDetails(accidentAppvm.detail);
                    SetSaveApplicationForPAI();
            }
        }

        /*  check for validation  */
        function validateForm() {
            accidentAppvm.genralAccidentForm = {};
            if (validateService.isValidTitle(accidentAppvm.detail.abbrName)) {
                accidentAppvm.genralAccidentForm.abbrName = validateService.isValidTitle(accidentAppvm.detail.abbrName);
            }
            if (validateService.isValidFirstName(accidentAppvm.detail.firstName)) {
                accidentAppvm.genralAccidentForm.firstName = validateService.isValidFirstName(accidentAppvm.detail.firstName);
            }
            if (validateService.isValidLastNameGI(accidentAppvm.detail.lastName,true)) {
                accidentAppvm.genralAccidentForm.lastName = validateService.isValidLastNameGI(accidentAppvm.detail.lastName,true);
            }
            if (validateService.isValidbirthDate(accidentAppvm.detail.dob)) {
                accidentAppvm.genralAccidentForm.dob = validateService.isValidbirthDate(accidentAppvm.detail.dob);
            }
            if (validateService.isValidGender(accidentAppvm.detail.gender)) {
                accidentAppvm.genralAccidentForm.gender = validateService.isValidGender(accidentAppvm.detail.gender);
            }
            if (validateService.isValidEmail((accidentAppvm.detail.emailId).trim())) {
                accidentAppvm.genralAccidentForm.emailId = validateService.isValidEmail((accidentAppvm.detail.emailId).trim());
            }
            if (validateService.isValidPhoneNo(accidentAppvm.detail.mobileNumber)) {
                accidentAppvm.genralAccidentForm.mobileNumber = validateService.isValidPhoneNo(accidentAppvm.detail.mobileNumber);
            }
            if (validateService.isValidplotNO(accidentAppvm.detail.plotNo)) {
                accidentAppvm.genralAccidentForm.plotNo = validateService.isValidplotNO(accidentAppvm.detail.plotNo);
            }
            if (validateService.isValidBuildingName(accidentAppvm.detail.buildingName)) {
                accidentAppvm.genralAccidentForm.buildingName = validateService.isValidBuildingName(accidentAppvm.detail.buildingName);
            }
            if (validateService.isValidStreetName(accidentAppvm.detail.streetName)) {
                accidentAppvm.genralAccidentForm.streetName = validateService.isValidStreetName(accidentAppvm.detail.streetName);
            }
            if (validateService.isValidlocality(accidentAppvm.detail.location)) {
                accidentAppvm.genralAccidentForm.location = validateService.isValidlocality(accidentAppvm.detail.location);
            }
            if (validateService.isValidPincode(accidentAppvm.detail.pincode)) {
                accidentAppvm.genralAccidentForm.pincode = validateService.isValidPincode(accidentAppvm.detail.pincode);
            }
            if (validateService.isValidSumInsured(accidentAppvm.sumInsured)) {
                accidentAppvm.genralAccidentForm.sumInsured = validateService.isValidName(accidentAppvm.sumInsured);
            }
            return (angular.equals({}, accidentAppvm.genralAccidentForm)) ? true : false;
        }

        accidentAppvm.setGender = function(_data) {
            if(_data){
                console.log("chk gender" + _data);
                if(_data.value == 'Mr'){
                     accidentAppvm.detail.gender = "Male";
                }else if(_data.value == 'Mrs'){
                     accidentAppvm.detail.gender = "Female";
                }else if(_data.value == 'Miss'){
                     accidentAppvm.detail.gender = "Female";
                }

            }
            
        }



        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });
        return this;
    }
]);
// })();
