/*
    Module Name    : Genral Insurance,
    Authers Name   : Kiran,
    Description    :Presonal Accident Insurance Policy start Date and End Date
*/


// (function() {
//     'use strict';
    angularApp.controller('accidentApplicationPolicyInfoController', ["$timeout", "$state", "$scope", "$translate", "validateService", "$filter", "generalInsurenceHomeService", "generalInsurenceAccidentService",
        function($timeout, $state, $scope, $translate, validateService, $filter, generalInsurenceHomeService, generalInsurenceAccidentService) {

            //functions, variables that can be accessed from the HTML come here
            var accidentApplicationPolicyInfoVm = this;
            //private methods section start
            function initPage() {
                accidentApplicationPolicyInfoVm.showBack = true;
                accidentApplicationPolicyInfoVm.showNext = true;

                /* get current date */
                var startDate = generalInsurenceHomeService.getCurrentDate();

                /* Calcutale policy start and end date*/
                accidentApplicationPolicyInfoVm.endDate = $filter('chosenDate')(startDate.setFullYear(startDate.getFullYear() + 1));
                accidentApplicationPolicyInfoVm.startDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());
            }


            //validation function starts
            accidentApplicationPolicyInfoVm.policyDateDetail = {};
            //onkeyup validate fields if required
            accidentApplicationPolicyInfoVm.validateService = validateService;

            /* check for field validation  */
            function validateForm() {
                accidentApplicationPolicyInfoVm.policyDateDetail = {};

                if (accidentApplicationPolicyInfoVm.validateService.isValidPolicyStartDate(accidentApplicationPolicyInfoVm.startDate)) {
                    accidentApplicationPolicyInfoVm.policyDateDetail.startDate = accidentApplicationPolicyInfoVm.validateService.isValidPolicyStartDate(accidentApplicationPolicyInfoVm.startDate);
                }
                if (accidentApplicationPolicyInfoVm.validateService.isValidPolicyEndDate(accidentApplicationPolicyInfoVm.endDate)) {
                    accidentApplicationPolicyInfoVm.policyDateDetail.endDate = accidentApplicationPolicyInfoVm.validateService.isValidPolicyStartDate(accidentApplicationPolicyInfoVm.endDate);
                }
                return (angular.equals({}, accidentApplicationPolicyInfoVm.policyDateDetail)) ? true : false;
            }

            //private methods section end  

            accidentApplicationPolicyInfoVm.goBacktoPrevious = function() {
                $state.go('menu.paymentAccountDetailsAccident');
            }

            accidentApplicationPolicyInfoVm.goToNextPage = function() {
                    if (validateForm()) {
                        var PolicyDateInformation = {
                            policyStartDate: accidentApplicationPolicyInfoVm.startDate,
                            policyEndDate: accidentApplicationPolicyInfoVm.endDate,
                        }
                        generalInsurenceAccidentService.setPolicyDateInfo(PolicyDateInformation);
                        $state.go('menu.accidentApplicationInsurerInfo');
                    }

                }
                //one time initialization to be done when the controller is loaded
            $scope.$on('$ionicView.loaded', function() {
                initPage();
            });

            //actions to done everytime the view is shown
            $scope.$on('$ionicView.beforeEnter', function() {
                //To Do
            });

            //actions to done everytime the view is hidden
            $scope.$on('$ionicView.afterLeave', function() {

                //any cleanup needs to be done here: executes everytime when page is left
            });
            return this;
        }
    ]);
// })();
