angularApp.controller('paiEndorseDetailsController', [
    "$state", 
    "$scope",
    "$filter",
    "$translate",
    "utilityService",
    "$ionicPopup",
    "getAccountDetailsService",
    "homeScreenService",
    "pailinkingRenwalService",
    "generalInsurenceHomeService",
    "arogyaSanjeevaniService",
    "customerInfoService",
    "generalInsurenceAccidentService",
    "validateService",
    "$ionicScrollDelegate",
    function($state, 
        $scope,
        $filter,
        $translate,
        utilityService,
        $ionicPopup,
        getAccountDetailsService,
        homeScreenService,
        pailinkingRenwalService,
        generalInsurenceHomeService,
        arogyaSanjeevaniService,
        customerInfoService,
        generalInsurenceAccidentService,
        validateService,
        $ionicScrollDelegate) {

        var paiEndorseDetailsVm = this;
        var rupeeSymbol = String.fromCharCode(8377);
        paiEndorseDetailsVm.validateService = validateService;
        paiEndorseDetailsVm.initPage = function () {
            paiEndorseDetailsVm.cutomerDetails = getAccountDetailsService.accountOverviewData.customerInformation ? getAccountDetailsService.accountOverviewData.customerInformation : "";
            
            paiEndorseDetailsVm.toggleCard = "0";
            paiEndorseDetailsVm.showInsPersonDetails = false;
            paiEndorseDetailsVm.showNomineeDetails = false;
            paiEndorseDetailsVm.showInsuranceDetails = false;
            paiEndorseDetailsVm.isEditInsuredPerson = true;
            paiEndorseDetailsVm.isEditNomineeDetail = true;
            paiEndorseDetailsVm.isEditInsuranceDetail = true;
            paiEndorseDetailsVm.isSaveInsuredPerson = false;
            paiEndorseDetailsVm.isSaveNomineeDetail = false;
            paiEndorseDetailsVm.isSaveInsuranceDetail = false;
            paiEndorseDetailsVm.showEditInsuredDetails = false;
            paiEndorseDetailsVm.showEditNomineeDetails = false;
            paiEndorseDetailsVm.showEditInsurancePolicyDetails = false;
            paiEndorseDetailsVm.pcePolicyDetails = pailinkingRenwalService.paiCanEndPolicyData ? pailinkingRenwalService.paiCanEndPolicyData : "";
            paiEndorseDetailsVm.pceOldPolicyDetails = angular.copy(paiEndorseDetailsVm.pcePolicyDetails);
			paiEndorseDetailsVm.pceOldPolicyDetailsCopy = angular.copy(paiEndorseDetailsVm.pcePolicyDetails);
            paiEndorseDetailsVm.isBankAddress = false;
            paiEndorseDetailsVm.isCurrentAddress = true;
            paiEndorseDetailsVm.detailsPage = {};
            paiEndorseDetailsVm.pceUpdatedInsured = [];
            paiEndorseDetailsVm.pceUpdateNominee = [];
            paiEndorseDetailsVm.pceUpdatedPolicyAmt = [];
            paiEndorseDetailsVm.pceUpdateAutoRenewFlag = [];
            paiEndorseDetailsVm.index = 0;
            paiEndorseDetailsVm.mobileSelected = false;
            paiEndorseDetailsVm.category = "";
            paiEndorseDetailsVm.isCbsLoc = false;

            paiEndorseDetailsVm.insuranceAmount = {
                    value: paiEndorseDetailsVm.pcePolicyDetails.txnAmount ? paiEndorseDetailsVm.pcePolicyDetails.txnAmount : 100,
                    options: {
                        disabled : false,
                        showTicksValues: true,
                        stepsArray: [
                            { value: rupeeSymbol+'100' },
                            { value: rupeeSymbol+'200' },
                            { value: rupeeSymbol+'500' },
                            { value: rupeeSymbol+'1000'}
                        ],
                        hideLimitLabels: true,
                        showSelectionBar: true,
                        onChange: function() {
                            var findSteps;
                            for (findSteps = 0; findSteps <= paiEndorseDetailsVm.insuranceAmount.options.stepsArray.length; findSteps++) {
                                if (paiEndorseDetailsVm.insuranceAmount.value == paiEndorseDetailsVm.insuranceAmount.options.stepsArray[findSteps].value) {
                                    if(paiEndorseDetailsVm.insuranceAmount.value == rupeeSymbol+'100'){
                                        paiEndorseDetailsVm.pcePolicyDetails.sumInsured = "200000";
                                    } else if(paiEndorseDetailsVm.insuranceAmount.value == rupeeSymbol+'200'){
                                        paiEndorseDetailsVm.pcePolicyDetails.sumInsured = "400000";
                                    } else  if(paiEndorseDetailsVm.insuranceAmount.value == rupeeSymbol+'500'){
                                        paiEndorseDetailsVm.pcePolicyDetails.sumInsured = "1000000";

                                    } else  if(paiEndorseDetailsVm.insuranceAmount.value == rupeeSymbol+'1000'){
                                        paiEndorseDetailsVm.pcePolicyDetails.sumInsured = "2000000";

                                    } else{
                                        paiEndorseDetailsVm.pcePolicyDetails.sumInsured = "2000000";
                                    }
                                
                                    break;
                                }
                            }
                            paiEndorseDetailsVm.onSaveClick("3");
                        }
                    }
                };
            if(!angular.equals({}, paiEndorseDetailsVm.cutomerDetails) && paiEndorseDetailsVm.pcePolicyDetails) {
                if(paiEndorseDetailsVm.pcePolicyDetails.txnAmount == "100") {
                    paiEndorseDetailsVm.insuranceAmount.value = rupeeSymbol+'100';
                    paiEndorseDetailsVm.pcePolicyDetails.sumInsured = "200000";
                }else if(paiEndorseDetailsVm.pcePolicyDetails.txnAmount == "200") {
                    paiEndorseDetailsVm.insuranceAmount.value = rupeeSymbol+'200';
                    paiEndorseDetailsVm.pcePolicyDetails.sumInsured = "400000";
                }else if(paiEndorseDetailsVm.pcePolicyDetails.txnAmount == "500") {
                    paiEndorseDetailsVm.insuranceAmount.value = rupeeSymbol+'500';
                    paiEndorseDetailsVm.pcePolicyDetails.sumInsured = "1000000";
                }else if(paiEndorseDetailsVm.pcePolicyDetails.txnAmount == "1000") {
                    paiEndorseDetailsVm.insuranceAmount.value = rupeeSymbol+'1000';
                    paiEndorseDetailsVm.pcePolicyDetails.sumInsured = "2000000";
                }
                if(paiEndorseDetailsVm.pcePolicyDetails.autoRenewalReqd.toUpperCase() == "N") {
                    paiEndorseDetailsVm.isAutoRenewdChecked = false;
                } else {
                    paiEndorseDetailsVm.isAutoRenewdChecked = true;
                }
                if(paiEndorseDetailsVm.pcePolicyDetails.gender == "F") {
                    paiEndorseDetailsVm.pcePolicyDetails.gender = "Female";
                } else if(paiEndorseDetailsVm.pcePolicyDetails.gender == "M") {
                    paiEndorseDetailsVm.pcePolicyDetails.gender = "Male";
                } else {
                    paiEndorseDetailsVm.pcePolicyDetails.gender = "Other";
                }

                var renewStartDate = paiEndorseDetailsVm.pcePolicyDetails.startDate;
                var resStartDate = renewStartDate.split(" ")[0];
                var dayStart = resStartDate.substring(0,2);
                var monStart = resStartDate.substring(2,4);
                var yearStart = resStartDate.substring(4);
                var startDate = yearStart+','+monStart+','+dayStart;
				if (utilityService.isIOSPlatform()) {
					startDate = monStart+'/'+dayStart+'/'+yearStart;
					paiEndorseDetailsVm.policyStartDate = new Date(startDate);
					
				}else{
					paiEndorseDetailsVm.policyStartDate = new Date(startDate);
				}
				
                var date = paiEndorseDetailsVm.pcePolicyDetails.endDate;
                var res = date.split(" ")[0];
                var day = res.substring(0,2);
                var mon = res.substring(2,4);
                var year = res.substring(4);
                var endDate = year+','+mon+','+day;
				
				if (utilityService.isIOSPlatform()) {
					endDate = mon+'/'+day+'/'+year;
				}

                var policyEndDate = new Date(endDate);
                paiEndorseDetailsVm.policyEndDate = policyEndDate;

                var renewalDate = new Date(endDate);
                var updatedEndDate = renewalDate.setDate(policyEndDate.getDate() + 1);
                paiEndorseDetailsVm.nenewalDueDate = updatedEndDate;

                paiEndorseDetailsVm.customerInfo = paiEndorseDetailsVm.cutomerDetails;
                callCBSLocDetails(paiEndorseDetailsVm.customerInfo.pinCode);
                paiEndorseDetailsVm.showMobNumbers = [];
                if(paiEndorseDetailsVm.customerInfo.mobile == paiEndorseDetailsVm.pcePolicyDetails.mobileNumber) {
                    paiEndorseDetailsVm.isMobileNoSame = true;
                    paiEndorseDetailsVm.mobileSelected = false;
                } else {
                    paiEndorseDetailsVm.isMobileNoSame = false;
                    paiEndorseDetailsVm.mobileSelected = true;
                    paiEndorseDetailsVm.showMobNumbers.push({
                            "key" : 1,
                            "value": paiEndorseDetailsVm.pcePolicyDetails.mobileNumber,
                        },
                        {
                            "key" : 2,
                            "value": paiEndorseDetailsVm.customerInfo.mobile,
                        }); 
                }
                callmasterForPAI();
                paiEndorseDetailsVm.onAutoRenewSelect();
                paiEndorseDetailsVm.pcePolicyDetails.maskMobileNumber = $filter('cardmask')(paiEndorseDetailsVm.pcePolicyDetails.mobileNumber, 'X', 4);
                paiEndorseDetailsVm.pcePolicyDetails.maskEmailAddress = paiEndorseDetailsVm.emailMaskCheck(paiEndorseDetailsVm.pcePolicyDetails.emailAddress);
                paiEndorseDetailsVm.selectedAddress = "CA";
                paiEndorseDetailsVm.scrollToTop();
            } else {
                pailinkingRenwalService.showError($translate.instant('PCE_TECHICAL_ERROR'),'menu.accountOverviewMyBalance','', function () { 
                    $state.go('menu.myPolicies');
                });
            }
        }

        function callmasterForPAI(){
            generalInsurenceAccidentService.getPersonalAccidentMasters().then(function(response) {
               generalInsurenceAccidentService.setMasterData(response);
               paiEndorseDetailsVm.nomineeRelationsWithInsured = response.nomineeRelation;
               paiEndorseDetailsVm.genderList = response.gender;
            }, function(error) {
                 utilityService.showErrorMessage(error.responseMessage);
            });
        }
        //Funtion to get location using pincode
        function callCBSLocDetails(cbsPinCode) {
            var pinCodeNumber = {
                "pinCode": cbsPinCode
            }
            generalInsurenceHomeService.getLocation(pinCodeNumber).then(function (data) {
                if (data) {
                    paiEndorseDetailsVm.cbsDistrict = data.district.districtName;
                    paiEndorseDetailsVm.cbsState = data.state.value;
                    paiEndorseDetailsVm.isCbsLoc = true;
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        paiEndorseDetailsVm.checkSpecialChar = function(address) {
            var modifiedAdd;
            if (address) {
                var regexToReplace = /[^\dA-Za-z .,/-]/g;
                modifiedAdd = address.replace(regexToReplace, " ").trim();
            } else {
                modifiedAdd = "";
            }

            return modifiedAdd;
        }

        paiEndorseDetailsVm.onAutoRenewSelect = function() {
            if(paiEndorseDetailsVm.isAutoRenewdChecked) {
                paiEndorseDetailsVm.pcePolicyDetails.autoRenewalReqd = "Y";
                paiEndorseDetailsVm.insuranceAmount.options.disabled = false;
            } else {
                paiEndorseDetailsVm.insuranceAmount.options.disabled = true;
                paiEndorseDetailsVm.pcePolicyDetails.autoRenewalReqd = "N";
            }
        }
        
        paiEndorseDetailsVm.viewDetails = function() {
            homeScreenService.isInsuranceFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 4;         
            $state.go('menu.accountOverviewMyBalance');
        }
        
        paiEndorseDetailsVm.toggleContent = function(item) {
            if(paiEndorseDetailsVm.toggleCard == item) {
                paiEndorseDetailsVm.toggleCard = "0";
            } else {    
                paiEndorseDetailsVm.toggleCard = item;
            }
            if(item == '1') {
                paiEndorseDetailsVm.showInsPersonDetails = true;
                paiEndorseDetailsVm.showNomineeDetails = false;
                paiEndorseDetailsVm.showInsuranceDetails = false;
            } else if(item == '2') {
                paiEndorseDetailsVm.showInsPersonDetails = false;
                paiEndorseDetailsVm.showNomineeDetails = true;
                paiEndorseDetailsVm.showInsuranceDetails = false;
            } else {
                paiEndorseDetailsVm.showInsPersonDetails = false;
                paiEndorseDetailsVm.showNomineeDetails = false;
                paiEndorseDetailsVm.showInsuranceDetails = true;
            }
        }

        paiEndorseDetailsVm.onEditClick = function(item) {
            paiEndorseDetailsVm.close(0);
            if(item == "1") {    
                paiEndorseDetailsVm.isEditInsuredPerson = !paiEndorseDetailsVm.isEditInsuredPerson;
                paiEndorseDetailsVm.isSaveInsuredPerson = true;
                paiEndorseDetailsVm.showEditInsuredDetails = true;
                paiEndorseDetailsVm.showEditNomineeDetails = false;
                paiEndorseDetailsVm.showEditInsurancePolicyDetails = false;   
            } else if(item == "2") {
                paiEndorseDetailsVm.isEditNomineeDetail = !paiEndorseDetailsVm.isEditNomineeDetail;
                paiEndorseDetailsVm.isSaveNomineeDetail = true;
                paiEndorseDetailsVm.showEditInsuredDetails = false;
                paiEndorseDetailsVm.showEditNomineeDetails = true;
                paiEndorseDetailsVm.showEditInsurancePolicyDetails = false;
            } else {
                paiEndorseDetailsVm.isEditInsuranceDetail = !paiEndorseDetailsVm.isEditInsuranceDetail;
                paiEndorseDetailsVm.isSaveInsuranceDetail = false;
                paiEndorseDetailsVm.showEditInsuredDetails = false;
                paiEndorseDetailsVm.showEditNomineeDetails = true;
                paiEndorseDetailsVm.showEditInsurancePolicyDetails = true;
            }
        }

        paiEndorseDetailsVm.showPop = function(inputData, category){
            var loadTemplate;
            paiEndorseDetailsVm.category = category;
            if(paiEndorseDetailsVm.category == 'M') {
               loadTemplate = pailinkingRenwalService.formPopUpTemplate("paiEndorseDetailsVm.showMobNumbers","paiEndorseDetailsVm");
            } else if(paiEndorseDetailsVm.category == 'G') {
                loadTemplate = pailinkingRenwalService.formPopUpTemplate("paiEndorseDetailsVm.genderList","paiEndorseDetailsVm");
            } else if(paiEndorseDetailsVm.category == 'R'){
                loadTemplate = pailinkingRenwalService.formPopUpTemplate("paiEndorseDetailsVm.nomineeRelationsWithInsured","paiEndorseDetailsVm");
            }
            if(inputData && inputData.length > 0){
                paiEndorseDetailsVm.popUpTemplate = loadTemplate;
                paiEndorseDetailsVm.popUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                    template: paiEndorseDetailsVm.popUpTemplate,
                    scope: $scope
                });
            }
        }

        paiEndorseDetailsVm.close = function(index){
            if(paiEndorseDetailsVm.popUp){
                paiEndorseDetailsVm.popUp.close();
            } 
            if(paiEndorseDetailsVm.category == 'M') {
                paiEndorseDetailsVm.pcePolicyDetails.mobileNumber = paiEndorseDetailsVm.showMobNumbers[index].value; 
            } else if(paiEndorseDetailsVm.category == 'G') {
                paiEndorseDetailsVm.pcePolicyDetails.gender = paiEndorseDetailsVm.genderList[index].value;
            } else if(paiEndorseDetailsVm.category == 'R') {
                paiEndorseDetailsVm.pcePolicyDetails.relationship = paiEndorseDetailsVm.nomineeRelationsWithInsured[index].value;
            }   
        }

        paiEndorseDetailsVm.onSaveClick = function(selectedItem) {
            if(selectedItem == "1") { 
                if(paiEndorseDetailsVm.validateInsuredPerson()){
                    paiEndorseDetailsVm.isEditInsuredPerson = true;
                    paiEndorseDetailsVm.isSaveInsuredPerson = false;
                    paiEndorseDetailsVm.showEditInsuredDetails = false;
                    paiEndorseDetailsVm.pcePolicyDetails.maskEmailAddress = paiEndorseDetailsVm.emailMaskCheck(paiEndorseDetailsVm.pcePolicyDetails.emailAddress);
                    if(paiEndorseDetailsVm.isMobileNoSame) {
                        paiEndorseDetailsVm.pcePolicyDetails.maskMobileNumber = $filter('cardmask')(paiEndorseDetailsVm.pceOldPolicyDetails.mobileNumber, 'X', 4);
                    } else {
                        paiEndorseDetailsVm.pcePolicyDetails.maskMobileNumber = $filter('cardmask')(paiEndorseDetailsVm.pcePolicyDetails.mobileNumber, 'X', 4);
                    }
                    var gender;
                    if(paiEndorseDetailsVm.pceOldPolicyDetails.gender == "F") {
                        gender = "Female";
                    } else if(paiEndorseDetailsVm.pceOldPolicyDetails.gender == "M") {
                        gender = "Male";
                    } else {
                        gender = "Other";
                    }
                    if(paiEndorseDetailsVm.pceOldPolicyDetails.emailAddress != paiEndorseDetailsVm.pcePolicyDetails.emailAddress) {
                       paiEndorseDetailsVm.index =  paiEndorseDetailsVm.getIndex(paiEndorseDetailsVm.pceUpdatedInsured,paiEndorseDetailsVm.pcePolicyDetails.emailAddress);
                       if(paiEndorseDetailsVm.index == -1) {
                            paiEndorseDetailsVm.pceUpdatedInsured.push({"subType": "ST10", "datums":[{"key": "emailId", "value" : paiEndorseDetailsVm.pcePolicyDetails.emailAddress}]});
                       }
                    }
                    if(paiEndorseDetailsVm.pceOldPolicyDetails.mobileNumber!= paiEndorseDetailsVm.pcePolicyDetails.mobileNumber) {
                        paiEndorseDetailsVm.index =  paiEndorseDetailsVm.getIndex(paiEndorseDetailsVm.pceUpdatedInsured,paiEndorseDetailsVm.pcePolicyDetails.mobileNumber);
                        if(paiEndorseDetailsVm.index == -1) { 
                            paiEndorseDetailsVm.pceUpdatedInsured.push({"subType": "ST03", "datums":[{"key": "mobileNumber", "value" : paiEndorseDetailsVm.pcePolicyDetails.mobileNumber}]});
                        }
                    }
                    if(gender!= paiEndorseDetailsVm.pcePolicyDetails.gender) {
                        paiEndorseDetailsVm.index =  paiEndorseDetailsVm.getIndex(paiEndorseDetailsVm.pceUpdatedInsured,paiEndorseDetailsVm.pcePolicyDetails.gender);
                        if(paiEndorseDetailsVm.index == -1) {
                            paiEndorseDetailsVm.pceUpdatedInsured.push({"subType": "ST12", "datums":[{"key": "gender", "value" : paiEndorseDetailsVm.pcePolicyDetails.gender}]});
                        }
                    }
                    if(paiEndorseDetailsVm.selectedAddress != "CA") {
                        paiEndorseDetailsVm.index =  paiEndorseDetailsVm.getIndex(paiEndorseDetailsVm.pceUpdatedInsured,paiEndorseDetailsVm.customerInfo.address);
                        if(paiEndorseDetailsVm.index == -1){
                                paiEndorseDetailsVm.pceUpdatedInsured.push({"subType": "ST02", "datums":[{"key": "blockNumber", "value" : paiEndorseDetailsVm.checkSpecialChar(paiEndorseDetailsVm.customerInfo.address)},
                                {"key": "building", "value" : paiEndorseDetailsVm.checkSpecialChar(paiEndorseDetailsVm.customerInfo.addressLine1)},
                                {"key": "streetAndLocality", "value" : paiEndorseDetailsVm.checkSpecialChar(paiEndorseDetailsVm.customerInfo.addressLine2)},
                                {"key": "pinCode", "value" : paiEndorseDetailsVm.customerInfo.pinCode}]})
                        } 
                    }
                    paiEndorseDetailsVm.scrollToTop();
                } 
            } else if(selectedItem == "2") {
                if(paiEndorseDetailsVm.validateNomineeDetails()) { 
                    paiEndorseDetailsVm.isEditNomineeDetail = true;
                    paiEndorseDetailsVm.isSaveNomineeDetail = false;
                    paiEndorseDetailsVm.showEditNomineeDetails = false;
                    if(paiEndorseDetailsVm.pceOldPolicyDetailsCopy.nomineeName != paiEndorseDetailsVm.pcePolicyDetails.nomineeName) {
						paiEndorseDetailsVm.pceOldPolicyDetailsCopy.nomineeName = paiEndorseDetailsVm.pcePolicyDetails.nomineeName;
						paiEndorseDetailsVm.pceOldPolicyDetails.nomineeName = paiEndorseDetailsVm.pcePolicyDetails.nomineeName;
                        paiEndorseDetailsVm.index =  paiEndorseDetailsVm.getIndex(paiEndorseDetailsVm.pceUpdateNominee,paiEndorseDetailsVm.pcePolicyDetails.nomineeName);
                        if(paiEndorseDetailsVm.index == -1){
                            paiEndorseDetailsVm.pceUpdateNominee.push({"subType": "ST06", "datums":[{"key": "nomineeName", "value" : paiEndorseDetailsVm.pcePolicyDetails.nomineeName}]}) 
                        }
                    }
                    if(paiEndorseDetailsVm.pceOldPolicyDetailsCopy.relationship != paiEndorseDetailsVm.pcePolicyDetails.relationship) {
						paiEndorseDetailsVm.pceOldPolicyDetailsCopy.relationship = paiEndorseDetailsVm.pcePolicyDetails.relationship;
						paiEndorseDetailsVm.pceOldPolicyDetails.relationship = paiEndorseDetailsVm.pcePolicyDetails.relationship;
                        paiEndorseDetailsVm.index =  paiEndorseDetailsVm.getIndex(paiEndorseDetailsVm.pceUpdateNominee,paiEndorseDetailsVm.pcePolicyDetails.relationship);
                        if(paiEndorseDetailsVm.index == -1){
                            paiEndorseDetailsVm.pceUpdateNominee.push({"subType": "ST32", "datums":[{"key": "relation", "value" : paiEndorseDetailsVm.pcePolicyDetails.relationship}]})
                        }
                    }
                }
            } else {
                if(paiEndorseDetailsVm.isAutoRenewdChecked) {
                    paiEndorseDetailsVm.isEditInsuranceDetail = true;
                    paiEndorseDetailsVm.isSaveInsuranceDetail = false;
                    paiEndorseDetailsVm.showEditInsurancePolicyDetails = false;
                    var changedPremAmt = paiEndorseDetailsVm.insuranceAmount.value.slice(1);
                    if(paiEndorseDetailsVm.pcePolicyDetails.txnAmount != changedPremAmt) {
                        paiEndorseDetailsVm.index =  paiEndorseDetailsVm.getIndex(paiEndorseDetailsVm.pceUpdatedPolicyAmt,changedPremAmt);
                        paiEndorseDetailsVm.pceUpdatedPolicyAmt = [];
                        if(paiEndorseDetailsVm.index == -1){
                            paiEndorseDetailsVm.pceUpdatedPolicyAmt.push({"subType": "ST64", "datums":[{"key": "newPremium", "value" : changedPremAmt},{"key" : "newSumInsured", "value" : paiEndorseDetailsVm.pcePolicyDetails.sumInsured}]})
                        }
                    }
                }
            }
        }

        paiEndorseDetailsVm.cancelEdit = function(selected) {
            paiEndorseDetailsVm.scrollToTop();
            paiEndorseDetailsVm.pcePolicyDetails = [];
            paiEndorseDetailsVm.pcePolicyDetails = paiEndorseDetailsVm.pceOldPolicyDetails;
            if(selected == "1") { 
                paiEndorseDetailsVm.isEditInsuredPerson = true;
                paiEndorseDetailsVm.isSaveInsuredPerson = false;
                paiEndorseDetailsVm.showEditInsuredDetails = false;
                if(paiEndorseDetailsVm.pcePolicyDetails.gender == "F") {
                    paiEndorseDetailsVm.pcePolicyDetails.gender = "Female";
                } else if(paiEndorseDetailsVm.pcePolicyDetails.gender == "M") {
                    paiEndorseDetailsVm.pcePolicyDetails.gender = "Male";
                } else {
                    paiEndorseDetailsVm.pcePolicyDetails.gender = "Other";
                }
                paiEndorseDetailsVm.selectedAddress = 'CA';
                paiEndorseDetailsVm.pcePolicyDetails.maskEmailAddress = paiEndorseDetailsVm.emailMaskCheck(paiEndorseDetailsVm.pcePolicyDetails.emailAddress);
                if(paiEndorseDetailsVm.isMobileNoSame) {
                    paiEndorseDetailsVm.pcePolicyDetails.maskMobileNumber = $filter('cardmask')(paiEndorseDetailsVm.pceOldPolicyDetails.mobileNumber, 'X', 4);
                } else {
                    paiEndorseDetailsVm.pcePolicyDetails.maskMobileNumber = $filter('cardmask')(paiEndorseDetailsVm.pcePolicyDetails.mobileNumber, 'X', 4);
                }
            } else if(selected == "2") {
                paiEndorseDetailsVm.isEditNomineeDetail = true;
                paiEndorseDetailsVm.isSaveNomineeDetail = false;
                paiEndorseDetailsVm.showEditNomineeDetails = false;
				paiEndorseDetailsVm.pcePolicyDetails.relationship = paiEndorseDetailsVm.pceOldPolicyDetailsCopy.relationship;
				paiEndorseDetailsVm.pcePolicyDetails.nomineeName = paiEndorseDetailsVm.pceOldPolicyDetailsCopy.nomineeName;
            } else {
                paiEndorseDetailsVm.isEditInsuranceDetail = true;
                paiEndorseDetailsVm.isSaveInsuranceDetail = false;
                paiEndorseDetailsVm.showEditInsurancePolicyDetails = false;
            }
        }

        paiEndorseDetailsVm.getIndex = function(arrayToMap, searchValue) {
           return arrayToMap.map(function(param) { return param.datums[0].value; }).indexOf(searchValue);
        }

        paiEndorseDetailsVm.scrollToTop = function() {
            $ionicScrollDelegate.$getByHandle('paiEndScrollContent').scrollTop();
        };

        paiEndorseDetailsVm.validateInsuredPerson = function() {
            paiEndorseDetailsVm.detailsPage = {};
            if(paiEndorseDetailsVm.pcePolicyDetails.emailAddress && paiEndorseDetailsVm.validateService.isValidEmail(paiEndorseDetailsVm.pcePolicyDetails.emailAddress)) {
                paiEndorseDetailsVm.detailsPage.email = paiEndorseDetailsVm.validateService.isValidEmail(paiEndorseDetailsVm.pcePolicyDetails.emailAddress);
            }
            if(paiEndorseDetailsVm.pcePolicyDetails.gender && paiEndorseDetailsVm.validateService.isValidGender(paiEndorseDetailsVm.pcePolicyDetails.gender)) {
                    paiEndorseDetailsVm.detailsPage.gender = paiEndorseDetailsVm.validateService.isValidGender(paiEndorseDetailsVm.pcePolicyDetails.gender);
                }
            if(!paiEndorseDetailsVm.isMobileNoSame) {     
                if(paiEndorseDetailsVm.pcePolicyDetails.mobileNumber && paiEndorseDetailsVm.validateService.isValidPhoneNo(paiEndorseDetailsVm.pcePolicyDetails.mobileNumber)) {
                    paiEndorseDetailsVm.detailsPage.mobile = paiEndorseDetailsVm.validateService.isValidPhoneNo(paiEndorseDetailsVm.pcePolicyDetails.mobileNumber);
                }
            }
            return (angular.equals({}, paiEndorseDetailsVm.detailsPage)) ? true : false;
        }

        paiEndorseDetailsVm.validateNomineeDetails = function() {
            paiEndorseDetailsVm.detailsPage = {};
            if (paiEndorseDetailsVm.pcePolicyDetails.nomineeName && paiEndorseDetailsVm.validateService.isValidFirstName(paiEndorseDetailsVm.pcePolicyDetails.nomineeName)) {
                paiEndorseDetailsVm.detailsPage.nomineeName = paiEndorseDetailsVm.validateService.isValidFirstName(paiEndorseDetailsVm.pcePolicyDetails.nomineeName);
            }
            if (paiEndorseDetailsVm.pcePolicyDetails.relationship && paiEndorseDetailsVm.validateService.isValidNomineeRelationWithInsured(paiEndorseDetailsVm.pcePolicyDetails.relationship)) {
                paiEndorseDetailsVm.detailsPage.nomineeRelationWithInsured = paiEndorseDetailsVm.validateService.isValidNomineeRelationWithInsured(paiEndorseDetailsVm.pcePolicyDetails.relationship);
            }
            return (angular.equals({}, paiEndorseDetailsVm.detailsPage)) ? true : false;
        }

        paiEndorseDetailsVm.onAdrressSelect = function(item) {
            if(item == '1') {
                paiEndorseDetailsVm.isCurrentAddress = !paiEndorseDetailsVm.isCurrentAddress;
                paiEndorseDetailsVm.isBankAddress = false;
            } else {
                if (paiEndorseDetailsVm.isCbsLoc) {
                    paiEndorseDetailsVm.isBankAddress = !paiEndorseDetailsVm.isBankAddress;
                    paiEndorseDetailsVm.isCurrentAddress = false;
                } else {
                    utilityService.showErrorMessage($translate.instant('CBS_DISTRICT_STATE_ERR'));
                }
            }
        }

        paiEndorseDetailsVm.emailMaskCheck = function(email){
            if(!utilityService.isUndefined(email)) {
                var arr = email.split("@");
                var firstDotIndex = arr[1].indexOf('.');
                var emailFirstPart = arr[1].substring(0, firstDotIndex);
                var emailSecondPart = arr[1].substring(firstDotIndex + 1);
                return paiEndorseDetailsVm.maskEmail2(arr[0]) + "@" + emailFirstPart+"."+emailSecondPart;
            }
		}

        paiEndorseDetailsVm.maskEmail2 = function (str) {
            return str[0] + "x".repeat(str.length - 2) + str[str.length - 1] ;  
		}

        paiEndorseDetailsVm.updateChanges = function() {
            paiEndorseDetailsVm.pceUpdateAutoRenewFlag = [];
            if(!paiEndorseDetailsVm.isAutoRenewdChecked) {
                paiEndorseDetailsVm.pceUpdatedPolicyAmt = [];
            }
            if(paiEndorseDetailsVm.pceOldPolicyDetails.autoRenewalReqd == paiEndorseDetailsVm.pcePolicyDetails.autoRenewalReqd) {
                paiEndorseDetailsVm.pceUpdateAutoRenewFlag = [];
            } else {
                if(paiEndorseDetailsVm.pceOldPolicyDetails.autoRenewalReqd == 'N' && paiEndorseDetailsVm.pcePolicyDetails.autoRenewalReqd == 'Y') {
                    paiEndorseDetailsVm.pceUpdateAutoRenewFlag.push({"subType": "ST27", "datums":[]});
                } else if(paiEndorseDetailsVm.pceOldPolicyDetails.autoRenewalReqd == 'Y' && paiEndorseDetailsVm.pcePolicyDetails.autoRenewalReqd == 'N') {
                    paiEndorseDetailsVm.pceUpdateAutoRenewFlag.push({"subType": "ST28", "datums":[]});
                } 
            }
            var finalUpdatedArray = [].concat(paiEndorseDetailsVm.pceUpdatedInsured,paiEndorseDetailsVm.pceUpdateNominee,paiEndorseDetailsVm.pceUpdatedPolicyAmt,paiEndorseDetailsVm.pceUpdateAutoRenewFlag);
            if (paiEndorseDetailsVm.isCbsLoc) {
            if(finalUpdatedArray.length != 0) {
                pailinkingRenwalService.getOtp().then(function (res) {
                    pailinkingRenwalService.isFromCancellation = false;
                    pailinkingRenwalService.setPaiUpdatePolicyDeatils(finalUpdatedArray);
                    $state.go('menu.consentPage');
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                pailinkingRenwalService.showErrorCaution("img/yc_Group.svg",$translate.instant('PCE_NO_CHANGES_MADE'));
            }
            } else {
                utilityService.showErrorMessage($translate.instant('CBS_DISTRICT_STATE_ERR'));
            }
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            paiEndorseDetailsVm.initPage();
        });

    }
]);
