angularApp.controller('paiLinkingFAQController', [
    "$state", 
    "$scope", 
    "validateService", 
    "utilityService",
    "$translate",
    "$ionicPopup",
    "$ionicHistory",
    "pailinkingRenwalService",
    function($state, 
        $scope, 
        validateService, 
        utilityService,
        $translate,
        $ionicPopup,
        $ionicHistory,
        pailinkingRenwalService) {

        var paiLinkingFAQVm = this;

        //private methods section start
        paiLinkingFAQVm.initPage = function () {
           paiLinkingFAQVm.showContent = false;
           paiLinkingFAQVm.faqContent = pailinkingRenwalService.faqQuestions.map(function(result,index) {
                var modifiedFaqObj = Object.assign({}, result);
                modifiedFaqObj.key = index; 
                modifiedFaqObj.isExpand = false;  
                modifiedFaqObj.questionContent = result.queryQuestion; 
                modifiedFaqObj.answerContent = result.queryAnswer;   
                modifiedFaqObj.moreContent = false;
                modifiedFaqObj.btnTxt = 'More'
                return  modifiedFaqObj;                   
            });
           paiLinkingFAQVm.faqContent[0].isExpand = true;
           paiLinkingFAQVm.faqContent[0].btnTxt = 'Less';
        }

        paiLinkingFAQVm.goBack = function() {
            $ionicHistory.goBack();
        }

        paiLinkingFAQVm.onToggleContent = function(selectedItem) {
            var tempArray = paiLinkingFAQVm.faqContent;
            paiLinkingFAQVm.faqContent = [];
            for(var i=0 ; i < tempArray.length; i++) {
                if(selectedItem==tempArray[i].key) {
                    if(tempArray[i].isExpand) {
                        tempArray[i].isExpand = false;
                        tempArray[i].btnTxt = 'More';
                    } else { 
                        tempArray[i].isExpand = true; 
                        tempArray[i].btnTxt = 'Less';
                    }
                } else {
                    tempArray[i].isExpand = false;
                    tempArray[i].btnTxt = 'More';
                }
            }
            paiLinkingFAQVm.faqContent = tempArray;
        }

        paiLinkingFAQVm.showMore = function(item) {
            var modifyArray = paiLinkingFAQVm.faqContent;
            paiLinkingFAQVm.faqContent = [];
            for(var i=0 ; i < modifyArray.length; i++) {
                if(item==modifyArray[i].key) {
                    if(modifyArray[i].btnTxt == 'More') {
                        modifyArray[i].moreContent = false;
                        modifyArray[i].btnTxt = 'Less';
                    } else { 
                        modifyArray[i].moreContent = true;
                        modifyArray[i].btnTxt = 'More';
                    }
                } else {
                    modifyArray[i].moreContent = false;
                    modifyArray[i].btnTxt = 'Less';
                }
            }
            paiLinkingFAQVm.faqContent = modifyArray;
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            paiLinkingFAQVm.initPage();
        });

    }
]);
