angularApp.controller('paiLinkingSuccessController', [
    "$state", 
    "$scope",
    "getAccountDetailsService",
    "homeScreenService",
    "$translate",
    "pailinkingRenwalService",
    function($state, 
        $scope,
        getAccountDetailsService,
        homeScreenService,
        $translate,
        pailinkingRenwalService) {

        var paiLinkingSuccessVm = this;

        //private methods section start
        paiLinkingSuccessVm.initPage = function () {
            paiLinkingSuccessVm.imageSrc = 'img/YCGroup5.svg';
            paiLinkingSuccessVm.description = $translate.instant('GI_LINK_SUCCESS_LBL');
            paiLinkingSuccessVm.height = '190px';
            paiLinkingSuccessVm.helpLine = pailinkingRenwalService.helpLine ? pailinkingRenwalService.helpLine : "";
        }

        /* Navigate to Account Overview Page*/
        paiLinkingSuccessVm.goToAccountOverview = function() {
            homeScreenService.isInsuranceFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 4;         
            $state.go('menu.accountOverviewMyBalance');
        }

        /* Navigate to Renew Page List*/
        paiLinkingSuccessVm.goToRenewPolicy = function() {
            homeScreenService.isInsuranceFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 4;         
            $state.go('menu.accountOverviewMyBalance');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            paiLinkingSuccessVm.initPage();
        });

    }
]);
