angularApp.controller('paymentAccountDetailsController', [
    "$state",
    "$scope",
    "generalInsurenceHomeService","GIconstant","utilityService","clickStreamService","generalInsurenceMotorService",
    function(
        $state,
        $scope,
        generalInsurenceHomeService,GIconstant,utilityService,clickStreamService,generalInsurenceMotorService
    ) {

        //functions, variables that can be accessed from the HTML come here
        var paymentAccountDetailsVm = this;
        paymentAccountDetailsVm.constant = GIconstant;
        paymentAccountDetailsVm.productType = {};
        paymentAccountDetailsVm.showSkipThis = false;
        
        //private methods section start
        function initPage() {


             var breakpoint = "HDC_ACCOUNT_SELECT";
                var applicationNumber = generalInsurenceHomeService.getapplicationNumber();
               generalInsurenceHomeService.saveListforOmni(breakpoint,applicationNumber).then(function(data) {
                
                }, function(error) {
                   
                });

               

            var account = {};
            generalInsurenceHomeService.getSBIBankAccounts(account).then(function(data) {
                paymentAccountDetailsVm.accDetails = data.beneficiaryList.ownAccounts;
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
             paymentAccountDetailsVm.productType = generalInsurenceHomeService.getProductDetail().uin;

           switch (paymentAccountDetailsVm.productType) {
                case '13':
                    paymentAccountDetailsVm.productName = paymentAccountDetailsVm.constant.common.hospitaldailycash;
                    break;
                case '11':
                   paymentAccountDetailsVm.productName = paymentAccountDetailsVm.constant.common.arogysPremier;
                    break;
                case '12':
                    paymentAccountDetailsVm.productName = paymentAccountDetailsVm.constant.common.criticalIllness;
                    break;
                case '31':
                    paymentAccountDetailsVm.productName = paymentAccountDetailsVm.constant.common.motorFour;
                    break;
                case '32':
                    paymentAccountDetailsVm.productName = paymentAccountDetailsVm.constant.common.motorTwo;
                    break;
                case '55':
                    paymentAccountDetailsVm.productName = paymentAccountDetailsVm.constant.common.TravelInsurance;
                    break;
                case '22':
                    paymentAccountDetailsVm.productName = paymentAccountDetailsVm.constant.common.longTermHome;
                    break;
                case '44':
                     paymentAccountDetailsVm.productName = paymentAccountDetailsVm.constant.common.PAI;
                    break;
                case '14':
                    paymentAccountDetailsVm.productName = paymentAccountDetailsVm.constant.common.simpleHealth;
                    break;
            }
        }




        //private methods section end

        function skipThis() {
            generalInsurenceHomeService.setaccountDetail(paymentAccountDetailsVm.accountDetail);
            switch (paymentAccountDetailsVm.productType) {
                // case '11':
                //     paymentAccountDetailsVm.showSkipThis = true;
                    // break;
                case '31':
                    paymentAccountDetailsVm.showSkipThis = true;
                    break;
                case '32':
                    paymentAccountDetailsVm.showSkipThis = true;
                    break;
                default:
                    paymentAccountDetailsVm.showSkipThis = false;
            }
        }

        paymentAccountDetailsVm.goToApplication = function(agree) {
            clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
            generalInsurenceHomeService.setaccountDetail(paymentAccountDetailsVm.accountDetail);
            switch (paymentAccountDetailsVm.productType) {
                case '13':
                    $state.go("menu.healthApplicationPersonalDetails", { agree: agree });
                    break;
                case '11':
                    $state.go("menu.healthApplicationPersonalDetails", { agree: agree });
                    break;
                case '12':
                    $state.go("menu.healthApplicationPersonalDetails", { agree: agree });
                    break;
                case '31':
                    $state.go("menu.motorInsurerPersonalDetails", { agree: agree });
                    generalInsurenceMotorService.UserSelectionLastName = agree.toString();
                    break;
                case '32':
                    $state.go("menu.motorInsurerPersonalDetails", { agree: agree });
                    generalInsurenceMotorService.UserSelectionLastName = agree.toString();
                    break;
                case '55':
                    $state.go("menu.travelProposerPersonalInfo", { agree: agree });
                    break;
                case '22':
                    $state.go("menu.homeApplicationOwnerDetails", { agree: agree });
                    break;
                case '44':
                    $state.go("menu.accidentApplicationInsurerInfo", { agree: agree });
                    break;
                case '14':
                    $state.go("menu.simpleHealthadditnolDetail", { agree: agree });
                    break;
            }

        }
        /* go back */
        paymentAccountDetailsVm.goBack = function() {
            switch (paymentAccountDetailsVm.productType) {
                case '13':
                   $state.go("menu.quotesList");
                    break;
                case '11':
                    $state.go("menu.quotesList");
                    break;
                case '12':
                     $state.go("menu.quotesList");
                    break;
                case '31':
                    $state.go("menu.motorPremiumCalculation");
                    break;
                case '32':
                     $state.go("menu.motorPremiumCalculation");
                    break;
                case '55':
                    $state.go("menu.travelPremiumSummary");
                    break;
                case '22':
                    $state.go("menu.homeQuoteSummary");
                    break;
                case '44':
                    $state.go("menu.accidentApplicationInsurerInfo");
                    break;
                case '14':
                    $state.go("menu.simpleHealthadditnolDetail");
                    break;
            }

        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {

            
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
             initPage();
            skipThis();

        });

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {

            //any cleanup needs to be done here: executes everytime when page is left
        });
        return this;
    }
]);
// })();
