angularApp.controller('quoteCalculationController', [
        "$state",
        "$scope","validateService","generalInsurenceHomeService",

        function(
            $state,
            $scope, validateService,generalInsurenceHomeService) {

            //functions, variables that can be accessed from the HTML come here
            var quoteCalcVm = this;
            //private methods section start
            function initPage() {
                quoteCalcVm.showBack = false;
                quoteCalcVm.showNext = true;
                quoteCalcVm.familySize = 2;
                quoteCalcVm.sumInsured = "₹ 50000";
                quoteCalcVm.birthdate = "15 OCT 1984";
                quoteCalcVm.productType = [{
                    "productType": "Individual",
                    "key": "0",
                }, {
                    "productType": "Family Floater",
                    "key": "1",
                }, {
                    "productType": "Family Individual",
                    "key": "2",
                }, ];
                quoteCalcVm.status = [{ "status": "Self" },
                    { "status": "Individual" },
                ];


                quoteCalcVm.sumInsuredList = [
                {
                    "key":'0',
                    "value":"1000000"
                },
                {
                    "key":'2',
                    "value":"1500000"
                },
                {
                    "key":'3',
                    "value":"2000000"
                },
                {
                    "key":'4',
                    "value":"2500000"
                },
                {
                    "key":'5',
                    "value":"3000000"
                }
                ]
                quoteCalcVm.showNext = true;
                quoteCalcVm.healthQuoteCalculation = {};
                quoteCalcVm.product = {};
                quoteCalcVm.validateService = validateService;
                quoteCalcVm.product.productTypes = quoteCalcVm.productType[0];
                quoteCalcVm.product.familySize = 1;


                // var todaysDate = generalInsurenceHomeService.getCurrentDate();
                // quoteCalcVm.product.defaultvalue = generalInsurenceHomeService.getFutureYear(todaysDate, -18);
                  /* birthdate svalidation for traveller */
            var currentDate = generalInsurenceHomeService.getCurrentDate();
            quoteCalcVm.product.maxDateLimit = generalInsurenceHomeService.getFutureYear(currentDate, -70);
            quoteCalcVm.product.minDateLimit= generalInsurenceHomeService.getFutureDate(currentDate, -15);
            quoteCalcVm.product.defaultvalue = generalInsurenceHomeService.getFutureDate(currentDate, -15);
            }






            //private methods section end


            function validateForm() {
                quoteCalcVm.healthQuoteCalculation = {};
                if (quoteCalcVm.validateService.isValidProductType(quoteCalcVm.product.productTypes)) {


                    quoteCalcVm.healthQuoteCalculation.productType = quoteCalcVm.validateService.isValidProductType(quoteCalcVm.product.productTypes);
                }

                if (quoteCalcVm.validateService.isValidbirthDate(quoteCalcVm.product.birthDate)) {
                    quoteCalcVm.healthQuoteCalculation.birthDate = quoteCalcVm.validateService.isValidbirthDate(quoteCalcVm.product.birthDate);
                }

                if (quoteCalcVm.validateService.isValidSumInsured(quoteCalcVm.product.sumInsured)) {
                    quoteCalcVm.healthQuoteCalculation.sumInsured = quoteCalcVm.validateService.isValidSumInsured(quoteCalcVm.product.sumInsured);
                }

                if (quoteCalcVm.validateService.isValidRelationship(quoteCalcVm.product.relationship)) {
                    quoteCalcVm.healthQuoteCalculation.relationship = quoteCalcVm.validateService.isValidRelationship(quoteCalcVm.product.relationship);
                }

                return (angular.equals({}, quoteCalcVm.healthQuoteCalculation)) ? true : false;
            }


            quoteCalcVm.validateproductType = function(type) {
                if (type.key == 0) {
                    quoteCalcVm.product.familySize = 1;
                } else {
                    quoteCalcVm.product.familySize = 2;
                }
            }





            quoteCalcVm.decrementInsurers = function() {
                if (quoteCalcVm.product.productTypes.key != 0) {
                    if (quoteCalcVm.product.familySize > 2) {
                        quoteCalcVm.product.familySize--;
                    } else {
                        return;
                    }
                }

            }
            quoteCalcVm.incrementInsurers = function() {
                if (quoteCalcVm.product.productTypes.key != 0) {
                    if (quoteCalcVm.product.productTypes.key == 2) {
                        if (quoteCalcVm.product.familySize < 6) {
                            quoteCalcVm.product.familySize++;
                        }
                    } else {
                        if (quoteCalcVm.product.familySize < 4) {
                            quoteCalcVm.product.familySize++;
                        }
                    }

                }
            }


            $scope.showQuote = function() {

                    var pages = "health";
                    if (validateForm()) {
                        $state.go("menu.quotesList", { pages: pages });


                    }
                }
                //one time initialization to be done when the controller is loaded
            $scope.$on('$ionicView.loaded', function() {
                initPage();
            });

            //actions to done everytime the view is shown
            $scope.$on('$ionicView.beforeEnter', function() {
                initPage();

            });

            //actions to done everytime the view is hidden
            $scope.$on('$ionicView.afterLeave', function() {
                //any cleanup needs to be done here: executes everytime when page is left
            });

        }
    ]);
// })();

