angularApp.controller('travelNomineeDetailsController', ["$timeout",
    "$state",
    "$scope", "generalInsurenceTravelService", "validateService", "$filter", "generalInsurenceMotorService", "generalInsurenceHomeService", "generalInsurenceHealthService", "generalInsurenceAccidentService", "utilityService", "GIconstant", "$ionicScrollDelegate","clickStreamService",

    function($timeout,
        $state,
        $scope, generalInsurenceTravelService, validateService, $filter, generalInsurenceMotorService, generalInsurenceHomeService, generalInsurenceHealthService, generalInsurenceAccidentService, utilityService, GIconstant, $ionicScrollDelegate,clickStreamService) {

        //functions, variables that can be accessed from the HTML come here
        var travelNomineeDetailsVm = this;
        var productType;
        var travelNomineeDetails;
        //private methods section start
        function initPage() {
            travelNomineeDetailsVm.terms = false;
            travelNomineeDetailsVm.showBack = true;
            travelNomineeDetailsVm.showNext = true;
            travelNomineeDetailsVm.nomineeReadonly = false;
            travelNomineeDetailsVm.apointeeReadonly = false;


            /* Check for Product type is accident or travel    */
            productType = generalInsurenceHomeService.getProductDetail().uin;

            travelNomineeDetailsVm.productType = productType;
            travelNomineeDetailsVm.travelNomineeDetailsInfoForm = {};
            //onkeyup validate fields if required
            var curentDate = generalInsurenceHomeService.getCurrentDate();
            travelNomineeDetailsVm.validateService = validateService;
            travelNomineeDetailsVm.minDOB = generalInsurenceHomeService.getFutureYear(curentDate, -110);
            travelNomineeDetailsVm.maxDOB = generalInsurenceHomeService.getFutureYear(curentDate, -18);
            travelNomineeDetailsVm.maxDOB = generalInsurenceHomeService.getFutureDate(travelNomineeDetailsVm.maxDOB, 1);
            // /*  get sum Relationship list from master  */
            if (productType == "11") {
                travelNomineeDetailsVm.titles = generalInsurenceHealthService.getArogyaMasterList().title;
                travelNomineeDetailsVm.nomineeRelationsWithInsured = generalInsurenceHealthService.getArogyaMasterList().nomineeRealtion;
                travelNomineeDetailsVm.relationsWithNominee = generalInsurenceHealthService.getArogyaMasterList().appointeeRelation;
                var relationShipDetail = generalInsurenceHealthService.getHealthInsureDetails();
                travelNomineeDetailsVm.RemoveSelf = false;
                for (var count = 0; count < relationShipDetail.Relationship.length; count++) {
                    if (relationShipDetail.Relationship[count].key == '1' || relationShipDetail.Relationship[count].value == "Self") {
                        travelNomineeDetailsVm.RemoveSelf = true;
                    }
                }
            } else if (productType == "13") {
                travelNomineeDetailsVm.titles = generalInsurenceHealthService.getHDCMasterList().nomineeTitle;
                travelNomineeDetailsVm.nomineeRelationsWithInsured = generalInsurenceHealthService.getHDCMasterList().nomineeRelation;
                travelNomineeDetailsVm.relationsWithNominee = generalInsurenceHealthService.getHDCMasterList().appointeeRelation;
                var relationShipDetail = generalInsurenceHealthService.getHealthAdditionalDetails();
                travelNomineeDetailsVm.RemoveSelf = false;
                for (var count = 0; count < relationShipDetail.relationship.length; count++) {
                    if (relationShipDetail.relationship[count].key == '1' || relationShipDetail.relationship[count].value == "Self") {
                        travelNomineeDetailsVm.RemoveSelf = true;
                    }
                }
            } else if (productType == "14") {
                travelNomineeDetailsVm.titles = generalInsurenceHealthService.getSimpleMasterList().salutation;
                travelNomineeDetailsVm.nomineeRelationsWithInsured = generalInsurenceHealthService.getSimpleMasterList().nomineeRelation;
                travelNomineeDetailsVm.relationsWithNominee = generalInsurenceHealthService.getSimpleMasterList().appointeeRelation;
                travelNomineeDetailsVm.RemoveSelf = true;
            } else if (productType == "12") {
                travelNomineeDetailsVm.titles = generalInsurenceHealthService.getCriticalMasterList().nomineeTitle;
                travelNomineeDetailsVm.nomineeRelationsWithInsured = generalInsurenceHealthService.getCriticalMasterList().nomineeRelation;
                travelNomineeDetailsVm.relationsWithNominee = generalInsurenceHealthService.getCriticalMasterList().appointeeRelation;

                var relationShipDetail = generalInsurenceHealthService.getHealthAdditionalDetails().relationship;
                travelNomineeDetailsVm.RemoveSelf = false;
                for (var count = 0; count < relationShipDetail.length; count++) {
                    if (relationShipDetail[count].key == '1' || relationShipDetail[count].value == "Self") {
                        travelNomineeDetailsVm.RemoveSelf = true;
                    }
                }
            } else if (productType == "31") {
                travelNomineeDetailsVm.titles = generalInsurenceMotorService.getMIcommonMaster().salutation;
                travelNomineeDetailsVm.nomineeRelationsWithInsured = generalInsurenceMotorService.getMIcommonMaster().motor4WAppointeeNomineeRelation;
                travelNomineeDetailsVm.relationsWithNominee = generalInsurenceMotorService.getMIcommonMaster().motor4WAppointeeNomineeRelation;
                travelNomineeDetailsVm.RemoveSelf = true;
            } else if (productType == "32") {
                travelNomineeDetailsVm.titles = generalInsurenceMotorService.getMIcommonMaster().salutation;
                travelNomineeDetailsVm.nomineeRelationsWithInsured = generalInsurenceMotorService.getMIcommonMaster().motor2WNomineeRelation;
                travelNomineeDetailsVm.relationsWithNominee = generalInsurenceMotorService.getMIcommonMaster().motor2WAppointeeRelation;
                travelNomineeDetailsVm.RemoveSelf = true;

            } else if (productType == "44") {
                travelNomineeDetailsVm.titles = generalInsurenceAccidentService.getMasterData().salutation;
                travelNomineeDetailsVm.nomineeRelationsWithInsured = generalInsurenceAccidentService.getMasterData().nomineeRelation;
                travelNomineeDetailsVm.relationsWithNominee = generalInsurenceAccidentService.getMasterData().appointeeRelation;
                travelNomineeDetailsVm.RemoveSelf = false;

            } else if (productType == "55") {
                travelNomineeDetailsVm.titles = generalInsurenceTravelService.getTravelMasterDetail().salutation;
                travelNomineeDetailsVm.nomineeRelationsWithInsured = generalInsurenceTravelService.getTravelMasterDetail().nomineeRelation;
                travelNomineeDetailsVm.relationsWithNominee = generalInsurenceTravelService.getTravelMasterDetail().appointeeRelation;
            } else {
                travelNomineeDetailsVm.titles = [{
                    "key": "0",
                    "value": "Mr"
                }, {
                    "key": "1",
                    "value": "Mrs"
                }, {
                    "key": "2",
                    "value": "Master"
                }, {
                    "key": "3",
                    "value": "Miss"
                }, ]
            }

            /* birthdate svalidation for traveller */
            var currentDate = generalInsurenceHomeService.getCurrentDate();
            travelNomineeDetailsVm.birthdateStartLimit = currentDate;


            /*  handle back button function */
            $timeout(function() {
                if (generalInsurenceTravelService.getTravelNomineeDetail()) {
                    if (generalInsurenceTravelService.getTravelNomineeDetail().uin == productType) {
                        travelNomineeDetailsVm.nomineeTitle = generalInsurenceTravelService.getTravelNomineeDetail().nomineeTitle;
                        travelNomineeDetailsVm.nomineeName = generalInsurenceTravelService.getTravelNomineeDetail().name1;
                        travelNomineeDetailsVm.nomineeLastName = generalInsurenceTravelService.getTravelNomineeDetail().nomineeLastName;
                        travelNomineeDetailsVm.nomineeRelationWithInsured = generalInsurenceTravelService.getTravelNomineeDetail().relationship;
                        travelNomineeDetailsVm.birthdate = generalInsurenceTravelService.getTravelNomineeDetail().birthDate;
                        travelNomineeDetailsVm.minorNominee = generalInsurenceTravelService.getTravelNomineeDetail().nomineeMinor;
                        travelNomineeDetailsVm.appointeeTitle = generalInsurenceTravelService.getTravelNomineeDetail().appointeeTitle;
                        travelNomineeDetailsVm.AppointeeName = generalInsurenceTravelService.getTravelNomineeDetail().name;
                        travelNomineeDetailsVm.appointeeLastName = generalInsurenceTravelService.getTravelNomineeDetail().appointeeLastName;
                        travelNomineeDetailsVm.relationWithNominee = generalInsurenceTravelService.getTravelNomineeDetail().relationshipWithNominee;
                        travelNomineeDetailsVm.proposerBirthday = generalInsurenceTravelService.getTravelNomineeDetail().proposerBirthday;
                        travelNomineeDetailsVm.renewal = generalInsurenceTravelService.getTravelNomineeDetail().renewal;
                        $scope.$apply();
                    } else {
                        travelNomineeDetailsVm.nomineeTitle = "";
                        travelNomineeDetailsVm.nomineeName = "";
                        travelNomineeDetailsVm.nomineeLastName = "";
                        travelNomineeDetailsVm.nomineeRelationWithInsured = "";
                        travelNomineeDetailsVm.birthdate = "";
                        travelNomineeDetailsVm.minorNominee = "";
                        travelNomineeDetailsVm.appointeeTitle = "";
                        travelNomineeDetailsVm.AppointeeName = "";
                        travelNomineeDetailsVm.appointeeLastName = "";
                        travelNomineeDetailsVm.relationWithNominee = "";
                        travelNomineeDetailsVm.renewal = "";
                    }
                }
            }, 10);



        }

        function getHeightInCM(height) {
            return height;
        }


        travelNomineeDetailsVm.isMinor = function() {
            if (travelNomineeDetailsVm.birthdate) {
                var isMinorbirthdate = travelNomineeDetailsVm.birthdate;
                var currentDate = generalInsurenceHomeService.getCurrentDate();
                var minorlimit = generalInsurenceHomeService.getFutureYear(currentDate, -18);
                minorlimit = generalInsurenceHomeService.getFutureDate(minorlimit, 2);
                var diffVal = $filter('dateDifferenceInDays')(minorlimit, isMinorbirthdate);
                if (diffVal > 0) {
                    travelNomineeDetailsVm.checkForMinor = true;
                    travelNomineeDetailsVm.minorNominee = true;
                } else {
                    travelNomineeDetailsVm.checkForMinor = false;
                    travelNomineeDetailsVm.minorNominee = false;
                }
            }

            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        }

        // form validation 
        function validateForm() {
            travelNomineeDetailsVm.travelNomineeDetailsInfoForm = {};
            if (travelNomineeDetailsVm.validateService.isValidFirstName(travelNomineeDetailsVm.nomineeName)) {
                travelNomineeDetailsVm.travelNomineeDetailsInfoForm.nomineeName = travelNomineeDetailsVm.validateService.isValidFirstName(travelNomineeDetailsVm.nomineeName);
            }
            if (travelNomineeDetailsVm.validateService.isValidTitle(travelNomineeDetailsVm.nomineeTitle)) {
                travelNomineeDetailsVm.travelNomineeDetailsInfoForm.nomineeTitle = travelNomineeDetailsVm.validateService.isValidTitle(travelNomineeDetailsVm.nomineeTitle);
            }
            if (travelNomineeDetailsVm.validateService.isValidLastName(travelNomineeDetailsVm.nomineeLastName)) {
                travelNomineeDetailsVm.travelNomineeDetailsInfoForm.nomineeLastName = travelNomineeDetailsVm.validateService.isValidLastName(travelNomineeDetailsVm.nomineeLastName);
            }
            if (travelNomineeDetailsVm.validateService.isValidNomineeRelationWithInsured(travelNomineeDetailsVm.nomineeRelationWithInsured)) {
                travelNomineeDetailsVm.travelNomineeDetailsInfoForm.nomineeRelationWithInsured = travelNomineeDetailsVm.validateService.isValidNomineeRelationWithInsured(travelNomineeDetailsVm.nomineeRelationWithInsured);
            }
            if (travelNomineeDetailsVm.validateService.isValidbirthDate(travelNomineeDetailsVm.birthdate)) {
                travelNomineeDetailsVm.travelNomineeDetailsInfoForm.birthdate = travelNomineeDetailsVm.validateService.isValidbirthDate(travelNomineeDetailsVm.birthdate);
            }

            if (travelNomineeDetailsVm.validateService.isValidDateGI(travelNomineeDetailsVm.birthdate, '01 Jan 1900', travelNomineeDetailsVm.birthdateStartLimit)) {
                travelNomineeDetailsVm.travelNomineeDetailsInfoForm.birthdate = travelNomineeDetailsVm.validateService.isValidDateGI(travelNomineeDetailsVm.birthdate, '01 Jan 1900', travelNomineeDetailsVm.birthdateStartLimit);
            }

            if (travelNomineeDetailsVm.minorNominee) {
                if (travelNomineeDetailsVm.validateService.isValidTitle(travelNomineeDetailsVm.appointeeTitle)) {
                    travelNomineeDetailsVm.travelNomineeDetailsInfoForm.appointeeTitle = travelNomineeDetailsVm.validateService.isValidTitle(travelNomineeDetailsVm.appointeeTitle);
                }
                if (travelNomineeDetailsVm.validateService.isValidLastName(travelNomineeDetailsVm.appointeeLastName)) {
                    travelNomineeDetailsVm.travelNomineeDetailsInfoForm.appointeeLastName = travelNomineeDetailsVm.validateService.isValidLastName(travelNomineeDetailsVm.appointeeLastName);
                }
                if (travelNomineeDetailsVm.validateService.isValidAppointeeRelationshipwithNominee(travelNomineeDetailsVm.relationWithNominee)) {
                    travelNomineeDetailsVm.travelNomineeDetailsInfoForm.relationWithNominee = travelNomineeDetailsVm.validateService.isValidAppointeeRelationshipwithNominee(travelNomineeDetailsVm.relationWithNominee);
                }
                if (travelNomineeDetailsVm.validateService.isValidName(travelNomineeDetailsVm.AppointeeName)) {
                    travelNomineeDetailsVm.travelNomineeDetailsInfoForm.AppointeeName = travelNomineeDetailsVm.validateService.isValidName(travelNomineeDetailsVm.AppointeeName);
                }
                if (travelNomineeDetailsVm.validateService.isValidbirthDate(travelNomineeDetailsVm.proposerBirthday)) {
                    travelNomineeDetailsVm.travelNomineeDetailsInfoForm.proposerBirthday = travelNomineeDetailsVm.validateService.isValidbirthDate(travelNomineeDetailsVm.proposerBirthday);
                }
                if (travelNomineeDetailsVm.validateService.isValidDateGI(travelNomineeDetailsVm.proposerBirthday, travelNomineeDetailsVm.minDOB, travelNomineeDetailsVm.maxDOB)) {
                    travelNomineeDetailsVm.travelNomineeDetailsInfoForm.proposerBirthday = travelNomineeDetailsVm.validateService.isValidDateGI(travelNomineeDetailsVm.proposerBirthday, travelNomineeDetailsVm.minDOB, travelNomineeDetailsVm.maxDOB);
                }
            }
            return (angular.equals({}, travelNomineeDetailsVm.travelNomineeDetailsInfoForm)) ? true : false;
        }


        function SetSaveApplicationForPAI() {
            var savedApplication = generalInsurenceAccidentService.getSavedData();

            savedApplication.applicationData.createquoterequest.nomineeDetails = {}
            savedApplication.applicationData.createquoterequest.appointeeDetails = {};
            savedApplication.applicationData.createquoterequest.nomineeDetails.name = {};
            savedApplication.applicationData.createquoterequest.nomineeDetails.name.firstName = travelNomineeDetailsVm.nomineeName;
            savedApplication.applicationData.createquoterequest.nomineeDetails.name.lastName = travelNomineeDetailsVm.nomineeLastName;
            savedApplication.applicationData.createquoterequest.nomineeDetails.name.salutation = travelNomineeDetailsVm.nomineeTitle;
            savedApplication.applicationData.createquoterequest.nomineeDetails.dob = new Date(travelNomineeDetailsVm.birthdate);
            savedApplication.applicationData.createquoterequest.nomineeDetails.relationship = travelNomineeDetailsVm.nomineeRelationWithInsured.key;
            savedApplication.applicationData.createquoterequest.appointeeDetails.name = travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName : "";
            savedApplication.applicationData.createquoterequest.appointeeDetails.appointeeTitle = travelNomineeDetailsVm.appointeeTitle ? travelNomineeDetailsVm.appointeeTitle : "";
            savedApplication.applicationData.createquoterequest.appointeeDetails.lastName = travelNomineeDetailsVm.appointeeLastName ? travelNomineeDetailsVm.appointeeLastName : "";
            savedApplication.applicationData.createquoterequest.appointeeDetails.appointeeRelationship = travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : "";
            savedApplication.applicationData.createquoterequest.appointeeDetails.dob = travelNomineeDetailsVm.proposerBirthday ? new Date(travelNomineeDetailsVm.proposerBirthday) : "";

            var JsonStingedData = angular.copy(savedApplication);

            if (generalInsurenceHomeService.isJson(savedApplication.quoteData)) {
                savedApplication.quoteData = JSON.parse(savedApplication.quoteData);
            }
            if (generalInsurenceHomeService.isJson(savedApplication.applicationData)) {
                savedApplication.applicationData = JSON.parse(savedApplication.applicationData);
            }

            generalInsurenceAccidentService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.uin = generalInsurenceHomeService.getProductDetail().uin;
            JsonStingedData.productCode = generalInsurenceHomeService.getGIProductsID();
            JsonStingedData.planName = generalInsurenceHomeService.getProductDetail().policyName;
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
            JsonStingedData.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            JsonStingedData.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";

            generalInsurenceHomeService.saveApplication(JsonStingedData, GIconstant.OmniChannel.PAI.PAI_NOMINEE).then(function(data) {
                var policyNumber = generalInsurenceAccidentService.getPolicyNumber();
                var dates = generalInsurenceAccidentService.getsumInsuredDetail();
                var insureDetail = generalInsurenceAccidentService.getInsuredDetails();
                var data = {
                    "quoteCreation": {
                        "quoteNumber": "",
                        "sumInsured": dates.SumInsuredValue,
                        "actualPremiumPayable": dates.finalPremiumAmount,
                        "policyTerms": {
                            "quotedate": dates.startDate,
                            "policyID": "",
                            "insuredId": "",
                            "effectDate": dates.startDate,
                            "expiryDate": dates.endDate,
                            "policyCtId": "",
                            "policyClauseId": "",
                            "feeType": "",
                            "customerCode": "",
                            "ppId": ""
                        }
                    }
                }
                generalInsurenceHealthService.setQuotecalculation(data);
                $state.go('menu.accidentPurchaseSummary');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        /* save application for simple health  */
        function saveApplicationSH() {
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationHealthStructure();
            var structure = stringifyStructure1;
            if (typeof(structure.quoteData) == 'string') {
                structure.quoteData = JSON.parse(structure.quoteData);
            }
            if (typeof(structure.applicationData) == 'string') {
                structure.applicationData = JSON.parse(structure.applicationData);
            }


            var partyCreateResponse = generalInsurenceHealthService.getCreatePartyNominee();


            var healthNominee = generalInsurenceHealthService.getSaveApplicationRequestForSimpleHealth();
            healthNominee.applicationData.createquoterequest.nomineeDetails = {};
            healthNominee.applicationData.createquoterequest.nomineeDetails.partyDetail = {};
            healthNominee.applicationData.createquoterequest.appointeeDetails = {};
            healthNominee.applicationData.createquoterequest.nomineeDetails.name = {};
            healthNominee.applicationData.createquoterequest.nomineeDetails.name.firstName = travelNomineeDetailsVm.nomineeName;
            healthNominee.applicationData.createquoterequest.nomineeDetails.name.lastName = travelNomineeDetailsVm.nomineeLastName;
            healthNominee.applicationData.createquoterequest.nomineeDetails.name.salutation = travelNomineeDetailsVm.nomineeTitle;
            healthNominee.applicationData.createquoterequest.nomineeDetails.relationship = travelNomineeDetailsVm.nomineeRelationWithInsured.key;
            healthNominee.applicationData.createquoterequest.nomineeDetails.dob = new Date(travelNomineeDetailsVm.birthdate);
            healthNominee.applicationData.createquoterequest.nomineeDetails.partyDetail = partyCreateResponse.partyCreate;
            healthNominee.applicationData.createquoterequest.appointeeDetails.name = travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName : "";
            healthNominee.applicationData.createquoterequest.appointeeDetails.appointeeTitle = travelNomineeDetailsVm.appointeeTitle ? travelNomineeDetailsVm.appointeeTitle : "";
            healthNominee.applicationData.createquoterequest.appointeeDetails.lastName = travelNomineeDetailsVm.appointeeLastName ? travelNomineeDetailsVm.appointeeLastName : "";
            healthNominee.applicationData.createquoterequest.appointeeDetails.appointeeRelationship = travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : "";




            structure.applicationData.createquoterequest.nomineeDetails = {};
            structure.applicationData.createquoterequest.appointeeDetails = {};
            structure.applicationData.createquoterequest.nomineeDetails = healthNominee.applicationData.createquoterequest.nomineeDetails;
            structure.applicationData.createquoterequest.appointeeDetails = healthNominee.applicationData.createquoterequest.appointeeDetails;
            structure.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            structure.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";

            var stringified = structure;



            if (typeof(stringified.quoteData) == 'object') {
                stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            if (typeof(stringified.applicationData) == 'object') {
                stringified.applicationData = JSON.stringify(stringified.applicationData);
            }

            generalInsurenceHomeService.setSaveApplicationHealthStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified, GIconstant.OmniChannel.SimpleHealth.SH_NOMINEE_DETAILS).then(function(data) {
                $state.go('menu.healthPurchaseSummary');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);

            });
        }


        /* save application for Arogyah  */
        function saveApplicationArogya() {
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationArogyaStructure();
            var structure = stringifyStructure1;
            if (typeof(structure.quoteData) == 'string') {
                structure.quoteData = JSON.parse(structure.quoteData);
            }
            if (typeof(structure.applicationData) == 'string') {
                structure.applicationData = JSON.parse(structure.applicationData);
            }
            var partyCreateResponse = generalInsurenceHealthService.getCreatePartyNominee();


            var healthNominee = generalInsurenceHealthService.getSaveApplicationRequestForArogya();
            healthNominee.applicationData.createquoterequest.nomineeDetails = {};
            healthNominee.applicationData.createquoterequest.appointeeDetails = {};
            healthNominee.applicationData.createquoterequest.nomineeDetails.partyDetail = {};
            healthNominee.applicationData.createquoterequest.nomineeDetails.name = {};
            healthNominee.applicationData.createquoterequest.nomineeDetails.name.firstName = travelNomineeDetailsVm.nomineeName;
            healthNominee.applicationData.createquoterequest.nomineeDetails.name.lastName = travelNomineeDetailsVm.nomineeLastName;
            healthNominee.applicationData.createquoterequest.nomineeDetails.name.salutation = travelNomineeDetailsVm.nomineeTitle;
            healthNominee.applicationData.createquoterequest.nomineeDetails.relationship = travelNomineeDetailsVm.nomineeRelationWithInsured.key;
            healthNominee.applicationData.createquoterequest.nomineeDetails.dob = new Date(travelNomineeDetailsVm.birthdate);
            healthNominee.applicationData.createquoterequest.nomineeDetails.partyDetail = partyCreateResponse.partyCreate;
            healthNominee.applicationData.createquoterequest.appointeeDetails.name = travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName : "";
            healthNominee.applicationData.createquoterequest.appointeeDetails.appointeeTitle = travelNomineeDetailsVm.appointeeTitle ? travelNomineeDetailsVm.appointeeTitle : "";
            healthNominee.applicationData.createquoterequest.appointeeDetails.lastName = travelNomineeDetailsVm.appointeeLastName ? travelNomineeDetailsVm.appointeeLastName : "";
            healthNominee.applicationData.createquoterequest.appointeeDetails.appointeeRelationship = travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : "";

            structure.applicationData.createquoterequest.nomineeDetails = {};
            structure.applicationData.createquoterequest.appointeeDetails = {};
            structure.applicationData.createquoterequest.nomineeDetails = healthNominee.applicationData.createquoterequest.nomineeDetails;
            structure.applicationData.createquoterequest.appointeeDetails = healthNominee.applicationData.createquoterequest.appointeeDetails;
            structure.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            structure.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";

            var stringified = structure;


            if (typeof(stringified.quoteData) == 'object') {
                stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            if (typeof(stringified.applicationData) == 'object') {
                stringified.applicationData = JSON.stringify(stringified.applicationData);
            }

            generalInsurenceHomeService.setSaveApplicationArogyaStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified, GIconstant.OmniChannel.Arogya.AP_NOMINEE_DETAILS).then(function(data) {
                $state.go('menu.healthPurchaseSummary');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);

            });
        }



        /* save application for Critical  */
        function saveApplicationCritical() {
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationCriticalStructure();
            var structure = stringifyStructure1;
            if (typeof(structure.quoteData) == 'string') {
                structure.quoteData = JSON.parse(structure.quoteData);
            }
            if (typeof(structure.applicationData) == 'string') {
                structure.applicationData = JSON.parse(structure.applicationData);
            }


            var healthNominee = generalInsurenceHealthService.getSaveApplicationRequestForCritical();
            var partyCreateResponse = generalInsurenceHealthService.getCreatePartyNominee();
            healthNominee.applicationData.createquoterequest.nomineeDetails = {};
            healthNominee.applicationData.createquoterequest.nomineeDetails.partyDetail = {};
            healthNominee.applicationData.createquoterequest.appointeeDetails = {};
            healthNominee.applicationData.createquoterequest.nomineeDetails.name = {};
            healthNominee.applicationData.createquoterequest.nomineeDetails.name.firstName = travelNomineeDetailsVm.nomineeName;
            healthNominee.applicationData.createquoterequest.nomineeDetails.name.lastName = travelNomineeDetailsVm.nomineeLastName;
            healthNominee.applicationData.createquoterequest.nomineeDetails.name.salutation = travelNomineeDetailsVm.nomineeTitle;
            healthNominee.applicationData.createquoterequest.nomineeDetails.relationship = travelNomineeDetailsVm.nomineeRelationWithInsured.key;
            healthNominee.applicationData.createquoterequest.nomineeDetails.dob = new Date(travelNomineeDetailsVm.birthdate);
            healthNominee.applicationData.createquoterequest.nomineeDetails.partyDetail = partyCreateResponse.partyCreate;
            healthNominee.applicationData.createquoterequest.appointeeDetails.name = travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName : "";
            healthNominee.applicationData.createquoterequest.appointeeDetails.appointeeTitle = travelNomineeDetailsVm.appointeeTitle ? travelNomineeDetailsVm.appointeeTitle : "";
            healthNominee.applicationData.createquoterequest.appointeeDetails.lastName = travelNomineeDetailsVm.appointeeLastName ? travelNomineeDetailsVm.appointeeLastName : "";
            healthNominee.applicationData.createquoterequest.appointeeDetails.appointeeRelationship = travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : "";

            structure.applicationData.createquoterequest.nomineeDetails = {};
            structure.applicationData.createquoterequest.appointeeDetails = {};
            structure.applicationData.createquoterequest.nomineeDetails = healthNominee.applicationData.createquoterequest.nomineeDetails;
            structure.applicationData.createquoterequest.appointeeDetails = healthNominee.applicationData.createquoterequest.appointeeDetails;
            structure.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            structure.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";

            var stringified = structure;

            if (typeof(stringified.quoteData) == 'object') {
                stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            if (typeof(stringified.applicationData) == 'object') {
                stringified.applicationData = JSON.stringify(stringified.applicationData);
            }


            generalInsurenceHomeService.setSaveApplicationCriticalStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified, GIconstant.OmniChannel.Critical.CI_NOMINEE_DETAILS).then(function(data) {
                $state.go('menu.healthPurchaseSummary');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);

            });
        }


        /* save application for HDC  */
        function saveApplicationHDC() {
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationHDCStructure();
            var structure = stringifyStructure1;

            if (typeof(structure.quoteData) == 'string') {
                structure.quoteData = JSON.parse(structure.quoteData);
            }
            if (typeof(structure.applicationData) == 'string') {
                structure.applicationData = JSON.parse(structure.applicationData);
            }

            var healthNominee = generalInsurenceHealthService.getSaveApplicationRequestForHDC();
            var partyCreateResponse = generalInsurenceHealthService.getCreatePartyNominee();
            healthNominee.applicationData.createquoterequest.nomineeDetails = {};
            healthNominee.applicationData.createquoterequest.nomineeDetails.partyDetail = {};
            healthNominee.applicationData.createquoterequest.appointeeDetails = {};
            healthNominee.applicationData.createquoterequest.nomineeDetails.name = {};
            healthNominee.applicationData.createquoterequest.nomineeDetails.name.firstName = travelNomineeDetailsVm.nomineeName;
            healthNominee.applicationData.createquoterequest.nomineeDetails.name.lastName = travelNomineeDetailsVm.nomineeLastName;
            healthNominee.applicationData.createquoterequest.nomineeDetails.name.salutation = travelNomineeDetailsVm.nomineeTitle;
            healthNominee.applicationData.createquoterequest.nomineeDetails.relationship = travelNomineeDetailsVm.nomineeRelationWithInsured.key;
            healthNominee.applicationData.createquoterequest.nomineeDetails.dob = new Date(travelNomineeDetailsVm.birthdate);
            healthNominee.applicationData.createquoterequest.nomineeDetails.partyDetail = partyCreateResponse.partyCreate;
            healthNominee.applicationData.createquoterequest.appointeeDetails.name = travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName : "";
            healthNominee.applicationData.createquoterequest.appointeeDetails.appointeeTitle = travelNomineeDetailsVm.appointeeTitle ? travelNomineeDetailsVm.appointeeTitle : "";
            healthNominee.applicationData.createquoterequest.appointeeDetails.lastName = travelNomineeDetailsVm.appointeeLastName ? travelNomineeDetailsVm.appointeeLastName : "";
            healthNominee.applicationData.createquoterequest.appointeeDetails.appointeeRelationship = travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : "";

            structure.applicationData.createquoterequest.nomineeDetails = {};
            structure.applicationData.createquoterequest.appointeeDetails = {};
            structure.applicationData.createquoterequest.nomineeDetails = healthNominee.applicationData.createquoterequest.nomineeDetails;
            structure.applicationData.createquoterequest.appointeeDetails = healthNominee.applicationData.createquoterequest.appointeeDetails;
            structure.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            structure.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";

            var stringified = structure;
            if (typeof(stringified.quoteData) == 'object') {
                stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            if (typeof(stringified.applicationData) == 'object') {
                stringified.applicationData = JSON.stringify(stringified.applicationData);
            }

            generalInsurenceHomeService.setSaveApplicationHDCStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified, GIconstant.OmniChannel.HDC.HDC_NOMINEE_DETAILS).then(function(data) {
                $state.go('menu.healthPurchaseSummary');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);

            });
        }


        /* save application for HDC  */
        function saveApplicationMotor() {
            var savedApplication = generalInsurenceMotorService.getSavedData();

            savedApplication.applicationData.createquoterequest.nomineeDetails = {}
            savedApplication.applicationData.createquoterequest.appointeeDetails = {};
			savedApplication.applicationData.createquoterequest.nomineeDetails.name = {};
            savedApplication.applicationData.createquoterequest.nomineeDetails.name.firstName = travelNomineeDetailsVm.nomineeName;
            savedApplication.applicationData.createquoterequest.nomineeDetails.name.lastName = travelNomineeDetailsVm.nomineeLastName;
            savedApplication.applicationData.createquoterequest.nomineeDetails.name.salutation = travelNomineeDetailsVm.nomineeTitle;
            savedApplication.applicationData.createquoterequest.nomineeDetails.dob = new Date(travelNomineeDetailsVm.birthdate);
            savedApplication.applicationData.createquoterequest.nomineeDetails.relationship = travelNomineeDetailsVm.nomineeRelationWithInsured.key;
            savedApplication.applicationData.createquoterequest.appointeeDetails.name = travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName : "";
            savedApplication.applicationData.createquoterequest.appointeeDetails.appointeeTitle = travelNomineeDetailsVm.appointeeTitle ? travelNomineeDetailsVm.appointeeTitle : "";
            savedApplication.applicationData.createquoterequest.appointeeDetails.lastName = travelNomineeDetailsVm.appointeeLastName ? travelNomineeDetailsVm.appointeeLastName : "";
            savedApplication.applicationData.createquoterequest.appointeeDetails.appointeeRelationship = travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : "";
            savedApplication.applicationData.createquoterequest.appointeeDetails.dob = travelNomineeDetailsVm.proposerBirthday ? new Date(travelNomineeDetailsVm.proposerBirthday) : "";

            var JsonStingedData = angular.copy(savedApplication);

            if (generalInsurenceHomeService.isJson(savedApplication.quoteData)) {
                savedApplication.quoteData = JSON.parse(savedApplication.quoteData);
            }
            if (generalInsurenceHomeService.isJson(savedApplication.applicationData)) {
                savedApplication.applicationData = JSON.parse(savedApplication.applicationData);
            }

            generalInsurenceMotorService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.uin = generalInsurenceHomeService.getProductDetail().uin;
            JsonStingedData.productCode = generalInsurenceHomeService.getGIProductsID();
            JsonStingedData.planName = generalInsurenceHomeService.getProductDetail().policyName;
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
            JsonStingedData.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            JsonStingedData.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";


            generalInsurenceHomeService.saveApplication(JsonStingedData, "MI_INSURED_DETAILS_2").then(function(data) {
                craeteJSONforMotor();
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);

            });
        }



        /* save application for HDC  */
        function saveApplicationTravel() {
            var savedApplication = generalInsurenceTravelService.getSavedData();

            savedApplication.applicationData.nomineeDetails = {}
            savedApplication.applicationData.appointeeDetails = {};
            savedApplication.applicationData.nomineeDetails.firstName = travelNomineeDetailsVm.nomineeName;
            savedApplication.applicationData.nomineeDetails.lastName = travelNomineeDetailsVm.nomineeLastName;
            savedApplication.applicationData.nomineeDetails.salutation = travelNomineeDetailsVm.nomineeTitle;
            savedApplication.applicationData.nomineeDetails.dob = new Date(travelNomineeDetailsVm.birthdate);
            savedApplication.applicationData.nomineeDetails.relationship = travelNomineeDetailsVm.nomineeRelationWithInsured.key;
            savedApplication.applicationData.appointeeDetails.name = travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName : "";
            savedApplication.applicationData.appointeeDetails.appointeeTitle = travelNomineeDetailsVm.appointeeTitle ? travelNomineeDetailsVm.appointeeTitle : "";
            savedApplication.applicationData.appointeeDetails.lastName = travelNomineeDetailsVm.appointeeLastName ? travelNomineeDetailsVm.appointeeLastName : "";
            savedApplication.applicationData.appointeeDetails.appointeeRelationship = travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : "";
            savedApplication.applicationData.appointeeDetails.dob = travelNomineeDetailsVm.proposerBirthday ? new Date(travelNomineeDetailsVm.proposerBirthday) : "";

            var JsonStingedData = angular.copy(savedApplication);

            if (generalInsurenceHomeService.isJson(savedApplication.quoteData)) {
                savedApplication.quoteData = JSON.parse(savedApplication.quoteData);
            }
            if (generalInsurenceHomeService.isJson(savedApplication.applicationData)) {
                savedApplication.applicationData = JSON.parse(savedApplication.applicationData);
            }

            generalInsurenceTravelService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.uin = generalInsurenceHomeService.getProductDetail().uin;
            JsonStingedData.productCode = generalInsurenceHomeService.getGIProductsID();
            JsonStingedData.planName = generalInsurenceHomeService.getProductDetail().policyName;
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
            JsonStingedData.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            JsonStingedData.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";


            generalInsurenceHomeService.saveApplication(JsonStingedData, "TI_NOMINEE_DETAILS").then(function(data) {
                $state.go('menu.travelPurchaseSummary');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);

            });
        }



        travelNomineeDetailsVm.goBacktoPrevious = function() {
                //To do
                /* switch (productType) {
                     case '13':
                         $state.go('menu.healthApplicationHealthInformation');
                         break;
                 }*/
            }
            /* go to previous page */
        travelNomineeDetailsVm.goBacktoPhysicalPrevious = function() {
            switch (productType) {
                case '13':
                    $state.go('menu.healthApplicationHealthInformation');
                    break;
                case '11':
                    $state.go('menu.healthApplicationHealthInformation');
                    break;
                case '12':
                    $state.go('menu.healthApplicationHealthInformation');
                    break;
                case '14':
                    var getQuote = {
                        "personalDetail": generalInsurenceHealthService.getHealthApplicationPersonalDetails(),
                        "additinoalDetail": generalInsurenceHealthService.getHealthAdditionalDetails()
                    }
                    generalInsurenceHealthService.getPremiumforsimpleHealth(getQuote);
                    $state.go('menu.simpleHealthPreExistingDesease');
                    break;
                case '55':
                    $state.go('menu.travelProposerphysiocalInfo');
                    break;
                case '44':
                    $state.go('menu.accidentApplicationInsurerInfo');
                    break;
                case '31':
                    $state.go('menu.motorInsurerFinancialDetails');
                    break;
                case '32':
                    $state.go('menu.motorInsurerFinancialDetails');
                    break;

            }
        }



        function getJsonforTravel() {

            var TravelInsureDetail = generalInsurenceTravelService.getTravellerPolicyDetails();
            var premiumDetail = generalInsurenceTravelService.getTravellerPremiumResponse();
            var physianDetail = generalInsurenceTravelService.getPhysicianDetails();
            var nomineeDetail = generalInsurenceTravelService.getTravelNomineeDetail();
            var proposerDetail = generalInsurenceTravelService.getProposerContactDetail();
            var partyDetail = generalInsurenceTravelService.getTravelCreateParty();
            var allTravellerDetail = generalInsurenceTravelService.getTravellerDetail();
            var allTravellerPersonalDetailDetail = generalInsurenceTravelService.getTravellerApplicationDetails();
            var partyDetails = generalInsurenceTravelService.getTravelInsuredCreateParty();
            var travellerList = [];
            for (var count = 0; count < allTravellerDetail.length; count++) {
                travellerList[count] = {};

                travellerList[count].diseases = [];
                for (var key in allTravellerPersonalDetailDetail.diseaseList[count]) {
                    if (!allTravellerPersonalDetailDetail.diseaseList[count].hasOwnProperty(key)) {
                        continue;
                    }
                    travellerList[count].diseases.push(allTravellerPersonalDetailDetail.diseaseList[count][key]);
                }


                travellerList[count].policyCtDetails = [];

                for (var i = 0; i < premiumDetail.premiumCalculation.insuredDetails[count].policyCtDetails.length; i++) {
                    travellerList[count].policyCtDetails[i] = {};
                    travellerList[count].policyCtDetails[i].coverTypeName = premiumDetail.premiumCalculation.insuredDetails[count].policyCtDetails[i].coverTypeName;
                    travellerList[count].policyCtDetails[i].policyCtId = premiumDetail.premiumCalculation.insuredDetails[count].policyCtDetails[i].policyCtId;
                }
                var travellerDOB;
                if ((validateService.calcAge(allTravellerDetail[count].Birthdate)) == 0) {
                    travellerDOB = "1";
                } else {
                    travellerDOB = validateService.calcAge(allTravellerDetail[count].Birthdate).toString();


                }

                travellerList[count].age = travellerDOB;
                travellerList[count].insuredId = premiumDetail.premiumCalculation.insuredDetails[count].insuredId;
                travellerList[count].firstName = allTravellerPersonalDetailDetail.firstName[count];
                travellerList[count].lastName = allTravellerPersonalDetailDetail.lastName[count];
                travellerList[count].dob = new Date(allTravellerDetail[count].Birthdate);
                travellerList[count].relationship = allTravellerDetail[count].Relationship.key;

                if (count == 0 || TravelInsureDetail.policyType.key != "3") {
                    travellerList[count].sumInsured = allTravellerDetail[count].SumInsured.value.toString();
                    travellerList[count].sumInsuredId = allTravellerDetail[count].SumInsured.key.toString();
                } else {
                    travellerList[count].sumInsured = "";
                }

                // travellerList[count].sumInsured = allTravellerDetail[count].SumInsured.value.toString();
                travellerList[count].gender = allTravellerPersonalDetailDetail.gender ? allTravellerPersonalDetailDetail.gender[count].ikey : "M";
                //allTravellerPersonalDetailDetail.gender[count].key;
                travellerList[count].passportNumber = allTravellerPersonalDetailDetail.passportNumber[count];
                travellerList[count].mobileNumber = allTravellerPersonalDetailDetail.mobileNumber[count];
                travellerList[count].isSufferingDisease = travellerList[count].diseases.length ? "true" : "false";
                travellerList[count].partyId = partyDetails ? partyDetails.partyCreate[count].partyID : "";
            }
            var planDetails = generalInsurenceTravelService.getTravelMasterDetail().planDetails;
            var planDetailsList;
            if (TravelInsureDetail.policyType.key == "1") {
                planDetailsList = planDetails.plan1;
            } else {
                planDetailsList = planDetails.plan2;
            }




            var travelDetail = {

                "quoteDetails": {
                    "countryOfMaxStay": TravelInsureDetail.Countrystay.locId,
                    "endDate": $filter('endDateWithTimezone')(TravelInsureDetail.endDate),
                    "noOfDays": TravelInsureDetail.diffVal.toString(),
                    "policyOption": TravelInsureDetail.policyOption.key,
                    "ppId": premiumDetail.premiumCalculation.policyTerms.ppId,
                    "productType": TravelInsureDetail.policyType.key,
                    "purposeOfTravel": TravelInsureDetail.travelPurpose.key,
                    "quoteNumber": premiumDetail.premiumCalculation.quoteNumber,
                    "startDate": $filter('startDateWithTimezone')(TravelInsureDetail.startDate),
                    "sumInsured": premiumDetail.premiumCalculation.sumInsured,
                    "travelToUSCanada": TravelInsureDetail.travellingToUSCanada.toString(),
                    "policyId": premiumDetail.premiumCalculation.policyTerms.policyID,
                    "planDetails": planDetailsList
                },
                "travellerDetails": travellerList,
                "phisicianDetails": {
                    "name": physianDetail.name,
                    "mobileNumber": physianDetail.mobileNumber
                },
                "proposerDetails": {
                    "buildingName": proposerDetail.buildingName,
                    "city": proposerDetail.city,
                    "dob": new Date(proposerDetail.birthdate),
                    "emailId": proposerDetail.email,
                    "firstName": proposerDetail.firstName,
                    "gender": proposerDetail.gender ? proposerDetail.gender.ikey : "",
                    "lastName": proposerDetail.lastName,
                    "location": proposerDetail.locality.loc,
                    "mobileNumber": proposerDetail.mobileNo,
                    "partyID": partyDetail.partyCreate.partyID,
                    "plotNo": proposerDetail.plotNO,
                    "streetName": proposerDetail.streetName,
                    "pincode": proposerDetail.pincode,
                    "title": proposerDetail.title.value
                },
                "nomineeDetails": {
                    "firstName": nomineeDetail.name1,
                    "lastName": nomineeDetail.nomineeLastName,
                    "relationship": nomineeDetail.relationship.key,
                    "dob": new Date(nomineeDetail.birthDate),
                    "isMinor": nomineeDetail.nomineeMinor.toString(),
                    "title": nomineeDetail.nomineeTitle.value
                },
                "appointeeDetails": {
                    "name": nomineeDetail.name ? nomineeDetail.name + " " + nomineeDetail.appointeeLastName : "",
                    "dob": travelNomineeDetailsVm.proposerBirthday ? travelNomineeDetailsVm.proposerBirthday : "",
                    "relationInsured": nomineeDetail.relationshipWithNominee ? nomineeDetail.relationship.value : "",
                    "relationNominee": nomineeDetail.relationshipWithNominee ? nomineeDetail.relationshipWithNominee.value : ""
                }
            }
            generalInsurenceTravelService.applyTIProduct(travelDetail).then(function(data) {
                generalInsurenceHealthService.setQuotecalculation(data);
                saveApplicationTravel();
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
                //alert(error.responseMessage);
            });
            //return  PAIPersonalDetail;
        }


        /*  party create for nominee  */
        function createPartyIdJson() {
            var locationDetail = generalInsurenceHomeService.getLocationDetails();
            var personalDetail = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
            // "dob": healthApplicationPersonalDetailsVm.data.birthdate,
            var nomineePartyCreate = {
                "partyCreate": {
                    "salutation": travelNomineeDetailsVm.nomineeTitle.pkey,
                    "firstName": travelNomineeDetailsVm.nomineeName,
                    "middleName": "",
                    "lastName": travelNomineeDetailsVm.nomineeLastName,
                    "dob": $filter('dateFormat')(travelNomineeDetailsVm.birthdate),
                    "gender": personalDetail.gender,
                    "emailID": personalDetail.email,
                    "mobile": personalDetail.mobile,
                    "plotNo": personalDetail.plotNo,
                    "buildingName": personalDetail.address,
                    "streetName": personalDetail.streetName,
                    "cityName": locationDetail.city.cityCode,
                    "stateName": locationDetail.state.key,
                    "pinCode": personalDetail.location.pinId,
                    "districtName": locationDetail.district.districtCode,
                    "locality": personalDetail.location.loc,
                    "addressType": "CurrentAddress",
                    "partyRole": "Nominee",
                    "maritalStatus":"",
                    "occupation":""
                }
            }
            var test = JSON.stringify(nomineePartyCreate);
            generalInsurenceHomeService.getPartyCreation(nomineePartyCreate).then(function(data) {
                generalInsurenceHealthService.setCreatePartyNominee(data);
                if (productType == "11") {
                    getJsonforArogya();
                } else if (productType == "12") {
                    getJsonforCI();
                } else if (productType == "14") {
                    getJsonforSimpleHealth();
                } else if (productType == "13") {
                    getJsonforHDC();
                }



            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        function createPartyIdForMotor() {
            /*var quotefirstPage = generalInsurenceMotorService.getMotorQuoteSecondPageDetail();
            var  quoteSecondPage =  generalInsurenceMotorService.getMotorQuoteThirdPageDetail();
            var quoteDetail = generalInsurenceMotorService.getQuoteDetail();*/
            var firstPage = generalInsurenceMotorService.getMotorPersonalFirstPageDetail();
            var secondPage = generalInsurenceMotorService.getMotorPersonalSecondPageDetail();
            /* var thirdPage  = generalInsurenceMotorService.getMotorPersonalThirdPageDetail();
             var fourthPage  = generalInsurenceMotorService.getMotorPersonalFourthPageDetail();*/
            var locationDetail = generalInsurenceHomeService.getLocatiopnBasedPincode();

            var nomineePartyCreate = {
                "partyCreate": {
                    "salutation": travelNomineeDetailsVm.nomineeTitle.pkey,
                    "firstName": travelNomineeDetailsVm.nomineeName,
                    "middleName": "",
                    "lastName": travelNomineeDetailsVm.nomineeLastName,
                    "dob": $filter('dateFormat')(travelNomineeDetailsVm.birthdate),
                    "gender": firstPage.gender.key,
                    "emailID": firstPage.mobileNumber,
                    "mobile": firstPage.mobileNumber,
                    "plotNo": secondPage.plotNO,
                    "buildingName": secondPage.BuildingName,
                    "streetName": secondPage.StreetName,
                    "cityName": locationDetail.city.cityCode,
                    "stateName": locationDetail.state.key,
                    "pinCode": secondPage.locality.pinId,
                    "districtName": locationDetail.district.districtCode,
                    "locality": secondPage.locality.loc,
                    "addressType": "CurrentAddress",
                    "partyRole": "Nominee",
                    "maritalStatus":"",
                    "occupation":""
                }
            }
            var test = JSON.stringify(nomineePartyCreate);
            generalInsurenceHomeService.getPartyCreation(nomineePartyCreate).then(function(data) {
                generalInsurenceHealthService.setCreatePartyNominee(data);
                if (productType == '31' || productType == '32') {
                    saveApplicationMotor();

                }



            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        function getJsonforCI() {
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationCriticalStructure();

            if (typeof(stringifyStructure1.quoteData) == 'string') {
                stringifyStructure1.quoteData = JSON.parse(stringifyStructure1.quoteData);
            }


            var personalDetail = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
            var aditionalDetails = generalInsurenceHealthService.getHealthAdditionalDetails();
            var healthDetails = generalInsurenceHealthService.getHealthInformationDetails();
            var createParty = generalInsurenceHealthService.getCreatePartyCI();
            var quoteCreation = generalInsurenceHealthService.getPremiumcalculationForCriticalIllness();
            var quoteList = generalInsurenceHomeService.getQuoteListDetails();
            quoteList.policyTerms = quoteList.policyTerms ? quoteList.policyTerms : stringifyStructure1.quoteData.premiumCalculation.request.planDuration.toString();
            generalInsurenceHomeService.setQuoteListDetails(quoteList);
            var proposerPartyCreate = generalInsurenceHealthService.getCreatePartyCI();
            var partyDetails = generalInsurenceHealthService.getCreatePartyInsured(); 
            var partyCreate = generalInsurenceHealthService.getCreatePartyNominee();
            var insureedDetails = [];
            var healthInformation = [];
            var concurrentInformation = [];
            for (var count = 0; count < aditionalDetails.birthDay.length; count++) {
                insureedDetails[count] = {}
                var calcage = validateService.calcAge(aditionalDetails.birthDay[count]);
                var age = calcage.toString();

                var grossIncome;
                if (aditionalDetails.monthlyIncome[count]) {
                    grossIncome = $filter('formatAmount')(aditionalDetails.monthlyIncome[count]);
                } else {
                    grossIncome = "0";
                }
                var heightInCm = Math.floor(getHeightInCM(aditionalDetails.height[count]));
                insureedDetails[count].name = aditionalDetails.name[count] + " " + aditionalDetails.lastName[count],
                    insureedDetails[count].dob = $filter('dateFormat')(aditionalDetails.birthDay[count]),
                    insureedDetails[count].gender = aditionalDetails.Gender[count].ikey,
                    insureedDetails[count].age = age,
                    // insureedDetails[count].height = aditionalDetails.height[count],
                    insureedDetails[count].height = heightInCm.toString(),
                    insureedDetails[count].weight = aditionalDetails.weight[count],
                    insureedDetails[count].occupation = aditionalDetails.occupation[count].key,
                    insureedDetails[count].realtionshipWithProposer = aditionalDetails.relationship[count].key,
                    insureedDetails[count].employmentDetails = aditionalDetails.employment[count].key,
                    insureedDetails[count].grossMonthlyIncome = grossIncome;
                    insureedDetails[count].partyId = partyDetails ? partyDetails.partyCreate[count].partyID : "";
            }

            for (var i = 0; i < healthDetails.length; i++) {
                healthInformation[i] = {}
                concurrentInformation[i] = {}
                if (i == 0) {

                    healthInformation[i].insuredPerson = healthDetails[i].insuredName ? healthDetails[i].insuredName : "";
                    healthInformation[i].doYouConsumeTobacco = healthDetails[i].consumeTobacoo ? "Yes" : "No";
                    healthInformation[i].doYouSmoke = healthDetails[i].smoke ? healthDetails[i].smoke.value : "";
                    healthInformation[i].alcoholStatus = healthDetails[i].alcohol ? "Yes" : "No";
                    healthInformation[i].diabetes = healthDetails[i].diabetes ? "Yes" : "No";
                    healthInformation[i].hyperTension = healthDetails[i].hypertension ? "Yes" : "No";
                    healthInformation[i].asthama = healthDetails[i].asthama ? "Yes" : "No";
                    healthInformation[i].impairments = healthDetails[i].otherHabits ? "Yes" : "No";
                    healthInformation[i].otherHabits = healthDetails[i].reason ? healthDetails[i].reason : "";

                }
                var filterSumInsured;
                if (healthDetails[i].sumInsured) {
                    filterSumInsured = $filter('formatAmount')(healthDetails[i].sumInsured);
                } else {
                    filterSumInsured = "";
                }

                concurrentInformation[i].concurrentType = healthDetails[i].policyType ? healthDetails[i].policyType.value : "";
                concurrentInformation[i].insuredPerson = healthDetails[i].name ? healthDetails[i].name : "";
                concurrentInformation[i].insuredComapny = healthDetails[i].companyName ? healthDetails[i].companyName.value : "";
                concurrentInformation[i].policyNo = healthDetails[i].policy ? healthDetails[i].policy : "";
                concurrentInformation[i].productOfInsurancefrom = healthDetails[i].insureFrom ? $filter('dateFormat')(healthDetails[i].insureFrom) : "";
                concurrentInformation[i].productOfInsuranceTo = healthDetails[i].insureTo ? $filter('dateFormat')(healthDetails[i].insureTo) : "";
                concurrentInformation[i].insuredSince = healthDetails[i].insureSince ? healthDetails[i].insureSince : "";
                concurrentInformation[i].sumInsured = filterSumInsured;

                concurrentInformation[i].specialCondition = healthDetails[i].specialCondition ? healthDetails[i].specialCondition : "";
                concurrentInformation[i].specialConditionDetails = healthDetails[i].conditiondetail ? healthDetails[i].conditiondetail : "";
                concurrentInformation[i].claimIfAny = healthDetails[i].claimPolicy ? healthDetails[i].claimPolicy : "";
                concurrentInformation[i].descriptionOfClaim = healthDetails[i].claimdetails ? healthDetails[i].claimdetails : "";
                concurrentInformation[i].claimAmount = healthDetails[i].claimamount ? $filter('formatAmount')(healthDetails[i].claimamount) : "";
            }
            var calcNomineeAge = validateService.calcAge(travelNomineeDetailsVm.birthdate);
            var Nomineeage = calcNomineeAge.toString();


            var createquoterequest = {
                "createquoterequest": {
                    "quoteDetails": {
                        "quoteNo": quoteCreation.premiumCalculation.quoteNumber,
                        "policyID": quoteCreation.premiumCalculation.policyTerms.policyID,
                        "effectiveDate": quoteCreation.premiumCalculation.policyTerms.effectDate,
                        "expiryDate": quoteCreation.premiumCalculation.policyTerms.expiryDate,
                        "planDuration": quoteList.policyTerms.toString(),
                        "insuredId": quoteCreation.premiumCalculation.policyTerms.insuredId,
                        "suminsured": stringifyStructure1.sumInsured.toString(),
                        "policyCtId": quoteCreation.premiumCalculation.policyTerms.policyCtId,
                        "ppId": quoteCreation.premiumCalculation.policyTerms.ppId,
                        "partyId": proposerPartyCreate.partyCreate.partyID,
                    },

                    "personalDetails": {
                        "abbrName": personalDetail.title.qkey,
                        "name": personalDetail.firstName + " " + personalDetail.LastName,
                        "dob": $filter('dateFormat')(personalDetail.birthdate),
                        "plotNo": personalDetail.plotNo,
                        "buildingName": personalDetail.address,
                        "streetName": personalDetail.streetName,
                        "city": personalDetail.city,
                        "pincode": personalDetail.pincode,
                        "address": personalDetail.address,
                        "gender": personalDetail.gender,
                        "emailId": personalDetail.email,
                        "mobileNumber": personalDetail.mobile
                    },
                    "insuredDetails": insureedDetails,
                    "healthInformation": healthDetails[0].tobacco ? "Yes" : "No",
                    "healthInformationDetails": healthInformation,
                    "everDeniedPolicy": healthDetails[0].denied ? "Yes" : "No",
                    "denialDetails": healthDetails[0].denialdetails ? "Yes" : "No",
                    "concurrentInsurance": healthDetails[0].insurance ? "Yes" : "No",
                    "concurrentInsuranceDetails": concurrentInformation,
                    "nomineeDetails": {
                        "name": travelNomineeDetailsVm.nomineeName + " " + travelNomineeDetailsVm.nomineeLastName,
                        "relationship": travelNomineeDetailsVm.nomineeRelationWithInsured.key,
                        "dob": $filter('dateFormat')(travelNomineeDetailsVm.birthdate),
                        "isMinor": travelNomineeDetailsVm.minorNominee ? "Yes" : "No",
                        "age": Nomineeage,
                        "partyID": partyCreate.partyID,
                    },
                    "appointeeDetails": {
                        "name": travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName + " " + travelNomineeDetailsVm.appointeeLastName : "",
                        "appointeeRelationship": travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : ""
                    }
                }
            }


            var test = JSON.stringify(createquoterequest);

            generalInsurenceTravelService.applyHICriticalIllnessProduct(createquoterequest).then(function(data) {
                //  generalInsurenceTravelService.setPolicyforPAI(data);
                generalInsurenceHealthService.setQuotecalculation(data);
                saveApplicationCritical();

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            //return  PAIPersonalDetail;
        }


        function getJsonforSimpleHealth() {
            var personalDetail = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
            var aditionalDetails = generalInsurenceHealthService.getHealthAdditionalDetails();
            var basicDetails = generalInsurenceHealthService.getbasicHealthDetail();
            var healthDetails = generalInsurenceHealthService.getHealthInformationDetails();
            var quoteCreation = generalInsurenceHealthService.getPremiumcalculationForSimpleHealth();
            var shQuestionary = generalInsurenceHealthService.getHealthQuestionaire();
            var preExistingDesease = generalInsurenceHealthService.getpreExistingDesease();
            var proposerPartyCreate = generalInsurenceHealthService.getCreatePartyCI();
            var partyCreate = generalInsurenceHealthService.getCreatePartyNominee();
            var insuredDetails = generalInsurenceHealthService.getHealthInsureDetails();
            var partyDetails = generalInsurenceHealthService.getCreatePartyInsured();
            var insureedDetails = [];
            var healthInformation = [];
            var individualHealthQtn = [];
            var individualDeseaseList = [];
            var concurrentInformation = [];
            for (var count = 0; count < aditionalDetails.birthDay.length; count++) {
                insureedDetails[count] = {}
                var calcage = validateService.calcAge(aditionalDetails.birthDay[count]);
                var age = calcage.toString();
                insureedDetails[count].name = aditionalDetails.name[count] + " " + aditionalDetails.lastName[count];
                insureedDetails[count].dob = $filter('dateFormat')(aditionalDetails.birthDay[count]);
                insureedDetails[count].gender = aditionalDetails.Gender[count].ikey;
                insureedDetails[count].age = age;
                insureedDetails[count].relationship = aditionalDetails.relationship[count].key;
                insureedDetails[count].partyId = partyDetails ? partyDetails.partyCreate[count].partyID : "";
                insureedDetails[count].sumInsured = $filter('formatAmount')(aditionalDetails.sumInsured[count]);
                insureedDetails[count].insuredId = quoteCreation.premiumCalculation.insuredDetails[count].insuredId;
                // insureedDetails[count].insuredId = "0";
                insureedDetails[count].coverTypeName = quoteCreation.premiumCalculation.insuredDetails[count].coverTypeName;
                insureedDetails[count].policyCtId = quoteCreation.premiumCalculation.insuredDetails[count].policyCtId;
            }

            if (preExistingDesease.data[0].preexistingdesease) {
                for (var i = 0; i < preExistingDesease.data.length; i++) {
                    healthInformation[i] = {}

                    // if (i == 0) {

                    healthInformation[i].insuredPerson = preExistingDesease.data[i].insuredName ? preExistingDesease.data[i].insuredName : "";
                    healthInformation[i].diseaseName = preExistingDesease.data[i].deseaseName ? preExistingDesease.data[i].deseaseName : "";
                    healthInformation[i].treatmentDetails = preExistingDesease.data[i].treatmentDetail ? preExistingDesease.data[i].treatmentDetail : "";
                    healthInformation[i].dateFirstTreated = preExistingDesease.data[i].startDate ? $filter('startDateWithTimezone')(preExistingDesease.data[i].startDate) : "";
                    healthInformation[i].currentStatus = preExistingDesease.data[i].currentStatus ? preExistingDesease.data[i].currentStatus : "";
                    // }
                }
            }

            for (var i = 0; i < preExistingDesease.insuranceList.length; i++) {
                if (preExistingDesease.insuranceList[0].otherHealthCover) {
                    concurrentInformation[i] = {}
                    var filterSumInsured;
                    if (preExistingDesease.insuranceList[i].sumInsured) {
                        filterSumInsured = $filter('formatAmount')(preExistingDesease.insuranceList[i].sumInsured);
                    } else {
                        filterSumInsured = "";
                    }



                    concurrentInformation[i].previous = preExistingDesease && preExistingDesease.insuranceList[i].policyType ? preExistingDesease.insuranceList[i].policyType.value : "";
                    concurrentInformation[i].insuredPerson = preExistingDesease && preExistingDesease.insuranceList[i].name ? preExistingDesease.insuranceList[i].name : "";
                    concurrentInformation[i].insuredComapny = preExistingDesease && preExistingDesease.insuranceList[i].companyName ? preExistingDesease.insuranceList[i].companyName.value : "";
                    concurrentInformation[i].policy = preExistingDesease && preExistingDesease.insuranceList[i] ? preExistingDesease.insuranceList[i].policy : "";
                    concurrentInformation[i].policyStratDate = preExistingDesease && preExistingDesease.insuranceList[i].insureFrom ? $filter('dateFormat')(preExistingDesease.insuranceList[i].insureFrom) : "";
                    concurrentInformation[i].policyEndDate = preExistingDesease && preExistingDesease.insuranceList[i].insureTo ? $filter('dateFormat')(preExistingDesease.insuranceList[i].insureTo) : "";
                    concurrentInformation[i].insuredSince = preExistingDesease && preExistingDesease.insuranceList[i].insureSince ? preExistingDesease.insuranceList[i].insureSince : "";
                    concurrentInformation[i].sumInsured = filterSumInsured;

                    concurrentInformation[i].specialCondition = preExistingDesease && preExistingDesease.insuranceList[i].specialCondition ? preExistingDesease.insuranceList[i].specialCondition : "";
                    concurrentInformation[i].specialConditionDetails = preExistingDesease && preExistingDesease.insuranceList[i].conditiondetail ? preExistingDesease.insuranceList[i].conditiondetail : "";
                    concurrentInformation[i].claimIfAny = preExistingDesease && preExistingDesease.insuranceList[i].claimPolicy ? preExistingDesease.insuranceList[i].claimPolicy : "";

                }
            }


            for (var i = 0; i < shQuestionary.length; i++) {
                // if (preExistingDesease.concurrentInsurance[0].preexistingdesease) {
                individualHealthQtn[i] = {}
                individualDeseaseList[i] = {}
                    // if (i == 0) {

                individualHealthQtn[i].name = shQuestionary[i].insuredName ? shQuestionary[i].insuredName : "";
                individualHealthQtn[i].doYouConsumeTobacco = shQuestionary[i].tobacco ? "Yes" : "No";
                individualHealthQtn[i].doYouSmoke = shQuestionary[i].smokestatus ? "Yes" : "No";
                individualHealthQtn[i].alcoholStatus = shQuestionary[i].alcoholstatus ? "Yes" : "No";
                // }

                individualDeseaseList[i].name = shQuestionary[i].insuredNameList ? shQuestionary[i].insuredNameList : "";
                individualDeseaseList[i].hypertension = shQuestionary[i].isHypertension ? "Yes" : "No";
                individualDeseaseList[i].diabetes = shQuestionary[i].isDiabetes ? "Yes" : "";
                individualDeseaseList[i].asthma = shQuestionary[i].isAsthma ? "Yes" : "No";
                individualDeseaseList[i].stroke = shQuestionary[i].isStroke ? "Yes" : "";
                individualDeseaseList[i].aids = shQuestionary[i].isAIDS ? "Yes" : "No";
                individualDeseaseList[i].cancer = shQuestionary[i].isCancer ? "Yes" : "No";
                individualDeseaseList[i].hepatits = shQuestionary[i].isHepatits ? "Yes" : "No";

                // }
            }

            var calcNomineeAge = validateService.calcAge(travelNomineeDetailsVm.birthdate);
            var Nomineeage = calcNomineeAge.toString();

            var createquoterequest = {
                "createquoterequest": {
                    "quoteDetails": {
                        "quoteNo": quoteCreation.premiumCalculation.quoteNumber,
                        "policyID": quoteCreation.premiumCalculation.policyTerms.policyID,
                        "productType": basicDetails.productTypes.key,
                        "familysize": basicDetails.familySize.toString(),
                        "effectiveDate": quoteCreation.premiumCalculation.policyTerms.effectDate,
                        "expiryDate": quoteCreation.premiumCalculation.policyTerms.expiryDate,
                        "partyId": proposerPartyCreate.partyCreate.partyID,
                        "planDuration": '1',
                        "sumInsured": quoteCreation.premiumCalculation.sumInsured,
                        "ppId": quoteCreation.premiumCalculation.policyTerms.ppId,
                        "adultCount": insuredDetails.noOfAdults,
                        "childCount": insuredDetails.noOfChilds
                    },

                    "personalDetails": {
                        "abbrName": personalDetail.title.value,
                        "name": personalDetail.firstName + " " + personalDetail.LastName,
                        "dob": $filter('dateFormat')(personalDetail.birthdate),
                        "plotNo": personalDetail.plotNo,
                        "buildingName": personalDetail.address,
                        "streetName": personalDetail.streetName,
                        "city": personalDetail.city,
                        "pincode": personalDetail.pincode,
                        "address": personalDetail.address,
                        "gender": personalDetail.gender,
                        "emailId": personalDetail.email,
                        "mobileNumber": personalDetail.mobile
                    },
                    "insuredDetails": insureedDetails,


                    "otherTreatment": shQuestionary[0].accident ? "Yes" : "No",
                    "healthInformation": shQuestionary[0].smoke ? "Yes" : "No",
                    "healthInformationDetails": individualHealthQtn,
                    "sufferedFromDiseases": shQuestionary[0].individualDeseaseList ? "Yes" : "No",
                    "insuredPersonDiseasesDetails": individualDeseaseList,
                    "preExistingDisease": preExistingDesease.data[0].preexistingdesease ? "Yes" : "No",
                    "preexistingDiseaseDetails": healthInformation,
                    "concurrentInsurance": preExistingDesease.insuranceList[0].otherHealthCover ? "Yes" : "No",
                    "concurrentInsuranceDetails": concurrentInformation,
                    "nomineeDetails": {
                        "name": travelNomineeDetailsVm.nomineeName + " " + travelNomineeDetailsVm.nomineeLastName,
                        "relationship": travelNomineeDetailsVm.nomineeRelationWithInsured.key,
                        "dob": $filter('dateFormat')(travelNomineeDetailsVm.birthdate),
                        "age": Nomineeage,
                        "partyID": partyCreate.partyCreate.partyID,
                        "isMinor": travelNomineeDetailsVm.minorNominee ? "Yes" : "No",
                    },
                    "appointeeDetails": {
                        "name": travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName + " " + travelNomineeDetailsVm.appointeeLastName : "",
                        "appointeeRelationship": travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : ""
                    }
                }
            }
            var test = JSON.stringify(createquoterequest);
            generalInsurenceHomeService.applySimpleHealthQuote(createquoterequest).then(function(data) {
                //  generalInsurenceTravelService.setPolicyforPAI(data);
                generalInsurenceHealthService.setQuotecalculation(data);

                saveApplicationSH();
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });


        }


        function craeteJSONforMotor() {
            var quotefirstPage = generalInsurenceMotorService.getMotorQuoteSecondPageDetail();
            var quoteSecondPage = generalInsurenceMotorService.getMotorQuoteThirdPageDetail();
            var quoteDetail = generalInsurenceMotorService.getQuoteDetail();
            var firstPage = generalInsurenceMotorService.getMotorPersonalFirstPageDetail();
            var secondPage = generalInsurenceMotorService.getMotorPersonalSecondPageDetail();
            var thirdPage = generalInsurenceMotorService.getMotorPersonalThirdPageDetail();
            var fourthPage = generalInsurenceMotorService.getMotorQuoteFourthPageDetail();
            var financePageDetail = generalInsurenceMotorService.getMotorPersonalFourthPageDetail();
            var locationDetail = generalInsurenceHomeService.getLocatiopnBasedPincode();
            var partyDetail = generalInsurenceHealthService.getCreatePartyNominee();//for Nominee
             var partyDetailInsured = generalInsurenceHomeService.getCreatePartyCI();//for Insured
            var savedApplication = generalInsurenceMotorService.getSavedData();
            var policyCTDetails = [];
            var policyClauseSOABOList = [];

            for (var count = 0; count < quoteDetail.insuredDetails.length; count++) {
                policyClauseSOABOList = quoteDetail.policyClauseSOABOList;
                for (var i = 0; i < quoteDetail.insuredDetails[count].policyCtDetails.length; i++) {
                    policyCTDetails[policyCTDetails.length] = quoteDetail.insuredDetails[count].policyCtDetails[i];

                }

            }
            var calcNomineeAge = validateService.calcAge(travelNomineeDetailsVm.birthdate);
            var Nomineeage = calcNomineeAge.toString();
            var motorDetail = {};
           // var age = $filter('calculateMonth')(quoteSecondPage.dateOfRegistration, validateService.getCurrentDate());
            var age;
            var policyMotorStartDate = generalInsurenceHomeService.getpolicyStartdate();
            if(generalInsurenceMotorService.getMotorTypeDetail() == "new"){
                age = "0.000";
            }else{
                policyMotorStartDate = validateService.getFutureDate(policyMotorStartDate,1);
                age = validateService.calculateAgeOfVehicle(policyMotorStartDate,quoteSecondPage.dateOfRegistration);
            }
            var previousVheicleDetail = {};
            if(savedApplication.quoteData.motorDetails.previousPolicyDetails){
                previousVheicleDetail =  {
                                "policyType": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.policyType : "",
                                "companyName": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.companyName : "",
                                "companyAddress": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.companyAddress : "",
                                "policyNumber": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.policyNumber : "",
                                "isClaimed": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.isClaimed : false,
                                "policyStartDate": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.policyStartDate : "",
                                "policyEndDate": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.policyEndDate : "",
                                "ncb": (savedApplication.quoteData.motorDetails.previousPolicyDetails && savedApplication.quoteData.motorDetails.previousPolicyDetails.ncb) ? savedApplication.quoteData.motorDetails.previousPolicyDetails.ncb : "",
                                "proofOfNcb": (savedApplication.quoteData.motorDetails.previousPolicyDetails && savedApplication.quoteData.motorDetails.previousPolicyDetails.proofOfNcb.key) ? savedApplication.quoteData.motorDetails.previousPolicyDetails.proofOfNcb.key : "",
                                "natureOfLoss": (savedApplication.quoteData.motorDetails.previousPolicyDetails && savedApplication.quoteData.motorDetails.previousPolicyDetails.natureOfLoss) ? savedApplication.quoteData.motorDetails.previousPolicyDetails.natureOfLoss.key : "",
                            }
            }else{
                previousVheicleDetail = {};
            }

            if (productType == '32') {



                motorDetail = {
                    "createquoterequest": {
                        "quoteDetails": {
                            "quoteNumber": quoteDetail.quoteNumber,
                            "policyID": quoteDetail.policyID,
                            "ppId": quoteDetail.ppId,
                            "policyctID": quoteDetail.policyCtId,
                            "insuredId": quoteDetail.insuredId,
                            "policyStartDate": quoteDetail.effectDate,
                            "policyEndDate": quoteDetail.expiryDate,
                            "previousPolicyDetails": previousVheicleDetail
                        },

                        "insuredDetails": {
                            "partyId": partyDetailInsured.partyCreate.partyID,
                            "title": "Miss",
                            "firstName": firstPage.firstName,
                            "lastName": firstPage.LastName,
                            "dob": $filter('dateFormat')(firstPage.birthday),
                            "ageOfDriver": thirdPage.DriverExperience.key.toString(),
                            "gender": firstPage.gender.key,
                            "emailId": firstPage.emailID,
                            "mobileNumber": firstPage.mobileNumber,
                            "plotNo": secondPage.plotNO,
                            "buildingNo": secondPage.BuildingName,
                            "streetName": secondPage.StreetName,
                            "location": secondPage.locality.loc,
                            "city": secondPage.cityCode,
                            "district": locationDetail.district.districtName,
                            "state": locationDetail.state.value,
                            "pincode1": secondPage.pin
                        },
                        "vehicleDetails": {
                            "make": quotefirstPage.vehicleMake.key.toString(),
                            "model": quotefirstPage.vehicleModel.modId,
                            "varient": quotefirstPage.vehicleVariant.vaId,
                            "cubicCapacity": quotefirstPage.vehicleVariant.cc,
                            "fuelType": quotefirstPage.vehicleVariant.fuelType,
                            "yearOfManufacture": quoteSecondPage.yearOfManufacture.toString(),
                            "ageOfVehicle": age + "",
                            "rtoCity": quoteSecondPage.selectedRTO.rtoDisCode,
                            "rtoState": quoteSecondPage.selectedRTO.stateId,
                            "rtoLocation": quoteSecondPage.selectedRTO.locationId,
                            "purchaseType": thirdPage.vehiclePurchaseAs.key == "NA" ? "3" : thirdPage.vehiclePurchaseAs.key,
                            "regnNumber": thirdPage.registrationNumber,
                            "regnDate": new Date(quoteSecondPage.dateOfRegistration),
                            "engineNumber": thirdPage.engineNumber,
                            "chassisNumber": thirdPage.chassisNumber,
                            "isSelfOwned": false,
                            "idv": fourthPage.suggestedIDV,
                            "drivingExperience": thirdPage.DriverExperience.key.toString(),
                            "exshowroomPrice": quoteSecondPage.selectedRTO.desc1,
                            "chassisNo": thirdPage.chassisNumber,
                            "nightParkingPincode": fourthPage.nightParkingPincode,
                            "pincode2": fourthPage.nightParkingPincode,
                            "licensedSeatingCapacity": quotefirstPage.vehicleVariant.seating,
                            "numberOfWheels": quotefirstPage.vehicleVariant.wheels,
                            "licensedCarryingCapacity": quotefirstPage.vehicleVariant.carrying
                        },
                        "nomineeDetails": {
                            "name": travelNomineeDetailsVm.nomineeName + " " + travelNomineeDetailsVm.nomineeLastName,
                            "relationship": travelNomineeDetailsVm.nomineeRelationWithInsured.key,
                            "dob": $filter('dateFormat')(travelNomineeDetailsVm.birthdate),
                            "age": Nomineeage,
                            "partyId": partyDetail.partyCreate.partyID,
                            "isMinor": travelNomineeDetailsVm.minorNominee ? "Yes" : "No"
                        },
                        "appointeeDetails": {
                            "name": travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName + " " + travelNomineeDetailsVm.appointeeLastName : "",
                            "appointeeRelationship": travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : ""
                        },

                        "financeDetails": {
                            "companyName": financePageDetail.financeCompanyName ? financePageDetail.financeCompanyName : "",
                            "companyCity": financePageDetail.companyCity ? financePageDetail.financeCompanyName : ""
                        },
                        "policyClauseSOABOList": policyClauseSOABOList,
                        "policyCtDetails": policyCTDetails,
                        "isAdditionalCoverage": savedApplication.quoteData.additonalCoverage ? (savedApplication.quoteData.additonalCoverage.length > 0) ? "Yes" : "No" : "No",
                        "additonalCoverage": savedApplication.quoteData.additonalCoverage ? savedApplication.quoteData.additonalCoverage : "",
                        "voluntaryDeductibles": savedApplication.quoteData.motorDetails.vehicleDetails.voluntaryDeductibles ? savedApplication.quoteData.motorDetails.vehicleDetails.voluntaryDeductibles.key : ""
                    }
                }


            } else {



                motorDetail = {
                    "createquoterequest": {
                        "quoteDetails": {
                            "quoteNo": quoteDetail.quoteNumber,
                            "policyID": quoteDetail.policyID,
                            "ppID": quoteDetail.ppId,
                            "policyctID": quoteDetail.policyCtId,
                            "insuredID": quoteDetail.insuredId,
                            "policyStartDate": quoteDetail.effectDate,
                            "policyEndDate": quoteDetail.expiryDate,
                            "previousPolicyDetails": previousVheicleDetail
                        },

                        "insuredDetails": {
                            "partyId": partyDetailInsured.partyCreate.partyID,
                            "title": "Miss",
                            "firstName": firstPage.firstName,
                            "lastName": firstPage.LastName,
                            "dob": $filter('dateFormat')(firstPage.birthday),
                            "ageOfDriver": thirdPage.DriverExperience.key.toString(),
                            "gender": firstPage.gender.key,
                            "emailId": firstPage.emailID,
                            "mobileNumber": firstPage.mobileNumber,
                            "plotNo": secondPage.plotNO,
                            "buildingNo": secondPage.BuildingName,
                            "streetName": secondPage.StreetName,
                            "location": secondPage.locality.loc,
                            "city": secondPage.cityCode,
                            "district": locationDetail.district.districtName,
                            "state": locationDetail.state.value,
                            "pincode1": secondPage.pincode1
                        },
                        "vehicleDetails": {
                            "make": quotefirstPage.vehicleMake.key.toString(),
                            "model": quotefirstPage.vehicleModel.modId,
                            "varient": quotefirstPage.vehicleVariant.vaId,
                            "cubicCapacity": quotefirstPage.vehicleVariant.cc,
                            "fuelType": quotefirstPage.vehicleVariant.fuelType,
                            "yearOfManufacture": quoteSecondPage.yearOfManufacture.toString(),
                            "ageOfVehicle": age + "",
                            "rtoCity": quoteSecondPage.selectedRTO.rtoDisCode,
                            "rtoState": quoteSecondPage.selectedRTO.stateId,
                            "rtoLocation": quoteSecondPage.selectedRTO.locationId,
                            "purchaseType": thirdPage.vehiclePurchaseAs.key == "NA" ? "3" : thirdPage.vehiclePurchaseAs.key,
                            "regnNumber": thirdPage.registrationNumber,
                            "regnDate": new Date(quoteSecondPage.dateOfRegistration),
                            "engineNumber": thirdPage.engineNumber,
                            "chassisNumber": thirdPage.chassisNumber,
                            "isSelfOwned": false,
                            "idv": fourthPage.suggestedIDV,
                            "bodyStyleDescription": quotefirstPage.vehicleVariant.bodyStyle,
                            "exshowroomPrice": quoteSecondPage.selectedRTO.desc1,
                            "licensedSeatingCapacity": quotefirstPage.vehicleVariant.seating,
                            "licensedCarryingCapacity": quotefirstPage.vehicleVariant.carrying,
                            "numberOfWheels": quotefirstPage.vehicleVariant.wheels,
                            "drivingAge": savedApplication.applicationData.createquoterequest.vehicleDetails ? savedApplication.applicationData.createquoterequest.vehicleDetails.drivingExperience.toString() : "",
                            "nightParkingPincode": savedApplication.quoteData.motorDetails.vehicleDetails ? savedApplication.quoteData.motorDetails.vehicleDetails.nightParkingPincode : "",
                            "noofPaidDrivers": (savedApplication.quoteData.motorDetails.vehicleDetails && savedApplication.quoteData.motorDetails.vehicleDetails.noofPaidDrivers) ? savedApplication.quoteData.motorDetails.vehicleDetails.noofPaidDrivers : ""
                        },
                        "nomineeDetails": {
                            "name": travelNomineeDetailsVm.nomineeName + " " + travelNomineeDetailsVm.nomineeLastName,
                            "relationship": travelNomineeDetailsVm.nomineeRelationWithInsured.key,
                            "dob": $filter('dateFormat')(travelNomineeDetailsVm.birthdate),
                            "age": Nomineeage,
                            "partyId": partyDetail.partyCreate.partyID,
                            "isMinor": travelNomineeDetailsVm.minorNominee ? "Yes" : "No"
                        },
                        "appointeeDetails": {
                            "name": travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName + " " + travelNomineeDetailsVm.appointeeLastName : "",
                            "appointeeRelationship": travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : ""
                        },
                        "financeDetails": {
                            "companyName": financePageDetail.financeCompanyName ? financePageDetail.financeCompanyName : "",
                            "companyCity": financePageDetail.companyCity ? financePageDetail.financeCompanyName : ""
                        },
                        "policyClauseSOABOList": policyClauseSOABOList,
                        "policyCtDetails": policyCTDetails,
                        "isAdditionalCoverage": savedApplication.quoteData.additonalCoverage ? (savedApplication.quoteData.additonalCoverage.length > 0) ? "Yes" : "No" : "No",
                        "additonalCoverage": savedApplication.quoteData.additonalCoverage ? savedApplication.quoteData.additonalCoverage : "",
                        "voluntaryDeductibles": savedApplication.quoteData.motorDetails.vehicleDetails.voluntaryDeductibles ? savedApplication.quoteData.motorDetails.vehicleDetails.voluntaryDeductibles.key : ""
                    }
                }

            }

            if(savedApplication.quoteData.motorDetails.previousPolicyDetails){
                    motorDetail.createquoterequest.quoteDetails.previousPolicyDetails = previousVheicleDetail;
            }
            
            generalInsurenceMotorService.applyMIProduct(motorDetail, productType).then(function(data) {
                generalInsurenceHealthService.setQuotecalculation(data);
                $state.go("menu.motorPurchaseSummary");

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });


        }

        function getJsonforArogya() {

            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationArogyaStructure();
            if (typeof(stringifyStructure1.quoteData) == 'string') {
                stringifyStructure1.quoteData = JSON.parse(stringifyStructure1.quoteData);
            }
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationArogyaStructure();
            var personalDetail = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
            var aditionalDetails = generalInsurenceHealthService.getHealthAdditionalDetails();
            var basicDetails = generalInsurenceHealthService.getbasicHealthDetail();
            var healthDetails = generalInsurenceHealthService.getHealthInformationDetails();
            var createParty = generalInsurenceHealthService.getCreatePartyCI();
            var quoteCreation = generalInsurenceHealthService.getPremiumcalculationForArogyaPremium();
            var quoteList = generalInsurenceHomeService.getQuoteListDetails();
            var partyDetails = generalInsurenceHealthService.getCreatePartyInsured();
            quoteList.policyTerms = quoteList.policyTerms ? quoteList.policyTerms : stringifyStructure1.quoteData.premiumCalculation.request.quoteDetails.planDuration.toString();
            generalInsurenceHomeService.setQuoteListDetails(quoteList);
            var partyCreate = generalInsurenceHealthService.getCreatePartyNominee();
            var proposerPartyCreate = generalInsurenceHealthService.getCreatePartyCI();
            var insureedDetails = [];
            var healthInformation = [];
            var concurrentInformation = [];

            for (var count = 0; count < aditionalDetails.birthDay.length; count++) {
                insureedDetails[count] = {}
                var calcage = validateService.calcAge(aditionalDetails.birthDay[count]);
                var age = calcage.toString();
                insureedDetails[count].name = aditionalDetails.name[count] + " " + aditionalDetails.lastName[count];
                insureedDetails[count].dob = $filter('dateFormat')(aditionalDetails.birthDay[count]);
                insureedDetails[count].gender = aditionalDetails.Gender[count].ikey;
                insureedDetails[count].age = age;
                insureedDetails[count].realtionship = aditionalDetails.relationship[count].key;
                insureedDetails[count].maritalStatus = aditionalDetails.maritalStatus[count].key;
                insureedDetails[count].insuredId = quoteCreation.premiumCalculation.insuredDetails[count].insuredId;
                insureedDetails[count].sumInsured = $filter('formatAmount')(aditionalDetails.sumInsured[count]);
                // insureedDetails[count].insuredId = "0";
                insureedDetails[count].coverTypeName = quoteCreation.premiumCalculation.insuredDetails[count].coverTypeName;
                insureedDetails[count].policyCtId = quoteCreation.premiumCalculation.insuredDetails[count].policyCtId;
                insureedDetails[count].partyId = partyDetails ? partyDetails.partyCreate[count].partyID : "";
            }

            for (var i = 0; i < healthDetails.length; i++) {


                // if (i == 0) {
                if (healthDetails[0].tobacco) {
                    healthInformation[i] = {}
                    healthInformation[i].insuredPerson = healthDetails[i].insuredName ? healthDetails[i].insuredName : "";
                    healthInformation[i].doYouConsumeTobacco = healthDetails[i].consumeTobacoo ? "Yes" : "No";
                    healthInformation[i].doYouSmoke = healthDetails[i].smoke ? "Yes" : "No";
                    healthInformation[i].alcoholStatus = healthDetails[i].alcohol ? "Yes" : "No";
                }

                // }
                var filterSumInsured;
                if (healthDetails[i].sumInsured) {
                    filterSumInsured = $filter('formatAmount')(healthDetails[i].sumInsured);
                } else {
                    filterSumInsured = "";
                }
                if (healthDetails[0].insurance) {
                    concurrentInformation[i] = {}
                    concurrentInformation[i].insuredPerson = healthDetails[i].name ? healthDetails[i].name : "";
                    concurrentInformation[i].insuredComapny = healthDetails[i].companyName ? healthDetails[i].companyName.value : "";
                    concurrentInformation[i].sumInsured = filterSumInsured;
                }

            }

            var calcNomineeAge = validateService.calcAge(travelNomineeDetailsVm.birthdate);
            var Nomineeage = calcNomineeAge.toString();


            var createquoterequest = {
                "createquoterequest": {

                    "quoteDetails": {
                        "quoteNo": quoteCreation.premiumCalculation.quoteNumber,
                        "policyID": quoteCreation.premiumCalculation.policyTerms.policyID,
                        "productType": basicDetails.productTypes.key,
                        "familysize": basicDetails.familySize.toString(),
                        "effectiveDate": quoteCreation.premiumCalculation.policyTerms.effectDate,
                        "expiryDate": quoteCreation.premiumCalculation.policyTerms.expiryDate,
                        "partyId": proposerPartyCreate.partyCreate.partyID,
                        "planDuration": quoteList.policyTerms.toString(),
                        "insuredId": quoteCreation.premiumCalculation.policyTerms.insuredId,
                        "suminsured": stringifyStructure1.sumInsured.toString(),
                        "suminsuredId": "",
                        "policyCtId": quoteCreation.premiumCalculation.policyTerms.policyCtId,
                        "ppId": quoteCreation.premiumCalculation.policyTerms.ppId
                    },

                    "personalDetails": {
                        "abbrName": personalDetail.title.qkey,
                        "name": personalDetail.firstName + " " + personalDetail.LastName,
                        "dob": $filter('dateFormat')(personalDetail.birthdate),
                        "plotNo": personalDetail.plotNo,
                        "buildingName": personalDetail.address,
                        "streetName": personalDetail.streetName,
                        "city": personalDetail.city,
                        "pincode": personalDetail.pincode,
                        "address": personalDetail.address,
                        "gender": personalDetail.gender,
                        "emailId": personalDetail.email,
                        "mobileNumber": personalDetail.mobile
                    },


                    "insuredDetails": insureedDetails,
                    "healthInformation": healthDetails[0].tobacco ? "Yes" : "No",
                    "healthInformationDetails": healthInformation,
                    "phsicalMentalDiseases": healthDetails[0].mentaldesease ? "Yes" : "No",
                    "insuranceByOtherComapany": healthDetails[0].denied ? "Yes" : "No",
                    "concurrentInsurance": healthDetails[0].insurance ? "Yes" : "No",
                    "concurrentInsuranceDetails": concurrentInformation,
                    "nomineeDetails": {
                        "name": travelNomineeDetailsVm.nomineeName + " " + travelNomineeDetailsVm.nomineeLastName,
                        "relationship": travelNomineeDetailsVm.nomineeRelationWithInsured.key,
                        "dob": $filter('dateFormat')(travelNomineeDetailsVm.birthdate),
                        "age": Nomineeage,
                        "partyID": partyCreate.partyCreate.partyID,
                        "isMinor": travelNomineeDetailsVm.minorNominee ? "Yes" : "No",
                    },
                    "appointeeDetails": {
                        "name": travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName + " " + travelNomineeDetailsVm.appointeeLastName : "",
                        "appointeeRelationship": travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : ""
                    }
                }
            }
            var test = JSON.stringify(createquoterequest);

            generalInsurenceHomeService.applyHIArogyaPremium(createquoterequest).then(function(data) {
                //  generalInsurenceTravelService.setPolicyforPAI(data);
                generalInsurenceHealthService.setQuotecalculation(data);
                saveApplicationArogya();

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        function getJsonforHDC() {

            var partyDetails = generalInsurenceHealthService.getCreatePartyInsured();
            var personalDetail = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
            var aditionalDetails = generalInsurenceHealthService.getHealthAdditionalDetails();
            var basicDetails = generalInsurenceHealthService.getHospitalDailyCashDetails();
            var healthDetails = generalInsurenceHealthService.getHealthInformationDetails();
            var createParty = generalInsurenceHealthService.getCreatePartyCI();
            var quoteCreation = generalInsurenceHealthService.getPremiumDetailsForHDC();
            var quoteList = generalInsurenceHomeService.getQuoteListDetails();
            var partyCreate = generalInsurenceHealthService.getCreatePartyNominee();
            var insureedDetails = [];
            var healthInformation = [];
            var concurrentInformation = [];

            var proposerPartyCreate = generalInsurenceHealthService.getCreatePartyCI();
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationHDCStructure();
            if (typeof(stringifyStructure1.quoteData) == 'string') {
                stringifyStructure1.quoteData = JSON.parse(stringifyStructure1.quoteData);
            }
            var quoteList = generalInsurenceHomeService.getQuoteListDetails();
            quoteList.policyTerms = quoteList.policyTerms ? quoteList.policyTerms : stringifyStructure1.quoteData.premiumCalculation.request.quoteDetails.planDuration.toString();
            generalInsurenceHomeService.setQuoteListDetails(quoteList);


            for (var count = 0; count < aditionalDetails.birthDay.length; count++) {
                insureedDetails[count] = {}
                var calcage = validateService.calcAge(aditionalDetails.birthDay[count]);
                var age = calcage.toString();
                var heightInCm = Math.floor(getHeightInCM(aditionalDetails.height[count]));
                insureedDetails[count].name = aditionalDetails.name[count] + " " + aditionalDetails.lastName[count];
                insureedDetails[count].dob = $filter('dateFormat')(aditionalDetails.birthDay[count]);
                insureedDetails[count].gender = aditionalDetails.Gender[count].ikey;
                insureedDetails[count].height = heightInCm.toString(),
                insureedDetails[count].weight = aditionalDetails.weight[count],
                insureedDetails[count].occupation = aditionalDetails.occupation[count].key,
                insureedDetails[count].age = age;
                insureedDetails[count].relationship = aditionalDetails.relationship[count].key;
                insureedDetails[count].hospitalcashlimit = aditionalDetails.cashLimit[count].value;
                insureedDetails[count].everHadOtherHosCash = "";
                insureedDetails[count].income = "";
                insureedDetails[count].suminsured = generalInsurenceHealthService.getHDCSumInsured();
                insureedDetails[count].insuredId = quoteCreation.premiumCalculation.insuredDetails[count].insuredId;
                insureedDetails[count].policyCtId = quoteCreation.premiumCalculation.insuredDetails[count].policyCtId;
                insureedDetails[count].partyId = partyDetails ? partyDetails.partyCreate[count].partyID : "";
            }

            for (var i = 0; i < healthDetails.length; i++) {
                healthInformation[i] = {}

                if (healthDetails[0].tobacco && healthDetails[i].insuredName) {

                    healthInformation[i].name = healthDetails[i].insuredName ? healthDetails[i].insuredName : "";
                    healthInformation[i].doYouConsumeTobacco = healthDetails[i].consumeTobacoo ? "true" : "false";
                    healthInformation[i].doYouSmoke = healthDetails[i].smoke ? healthDetails[i].smoke.key : "";
                    healthInformation[i].alcoholStatus = healthDetails[i].alcohol ? "true" : "false";
                    healthInformation[i].Otherailment = healthDetails[i].otherailment ? "true" : "false";
                    healthInformation[i].ailmentDetails = healthDetails[i].ailmentDetails ? healthDetails[i].ailmentDetails : "";
                    healthInformation[i].asthma = "";

                }

                if (healthDetails[0].insurance && healthDetails[i].name) {
                    if (healthDetails[0].insurance) {
                        concurrentInformation[i] = {}
                        var filterSumInsured;
                        if (healthDetails[i].sumInsured) {
                            filterSumInsured = $filter('formatAmount')(healthDetails[i].sumInsured);
                        } else {
                            filterSumInsured = "";
                        }
                        concurrentInformation[i].previous = healthDetails[i].policyType ? healthDetails[i].policyType.value : "";
                        concurrentInformation[i].insuredPerson = healthDetails[i].name ? healthDetails[i].name : "";
                        concurrentInformation[i].insuredCompany = healthDetails[i].companyName ? healthDetails[i].companyName.value : "";
                        concurrentInformation[i].policy = healthDetails[i].policy ? healthDetails[i].policy : "";
                        concurrentInformation[i].policyStartDate = healthDetails[i].insureFrom ? $filter('dateFormat')(healthDetails[i].insureFrom) : "";
                        concurrentInformation[i].policyEndDate = healthDetails[i].insureTo ? $filter('dateFormat')(healthDetails[i].insureTo) : "";
                        concurrentInformation[i].insuredSince = healthDetails[i].insureSince ? healthDetails[i].insureSince : "";
                        concurrentInformation[i].sumInsured = filterSumInsured;
                        concurrentInformation[i].claimIfAny = healthDetails[i].claimPolicy ? healthDetails[i].claimPolicy : "";
                    }

                }


            }

            var calcNomineeAge = validateService.calcAge(travelNomineeDetailsVm.birthdate);
            var Nomineeage = calcNomineeAge.toString();

            var createquoterequest = {
                "createquoterequest": {
                    "quoteNo": quoteCreation.premiumCalculation.quoteNumber,
                    "policyID": quoteCreation.premiumCalculation.policyTerms.policyID,
                    "ppId": quoteCreation.premiumCalculation.policyTerms.ppId,
                    "policyStartDate": quoteCreation.premiumCalculation.policyTerms.effectDate,
                    "policyEndDate": quoteCreation.premiumCalculation.policyTerms.expiryDate ? quoteCreation.premiumCalculation.policyTerms.expiryDate : $filter('endDateWithTimezone')(basicDetails.endDate),
                    "planType": quoteList.policyTerms.toString(),
                    "personalDetails": {
                        "name": personalDetail.firstName + " " + personalDetail.LastName,
                        "dob": $filter('dateFormat')(personalDetail.birthdate),
                        "plotNo": personalDetail.plotNo,
                        "buildingName": personalDetail.address,
                        "streetName": personalDetail.streetName,
                        "city": personalDetail.city,
                        "gender": personalDetail.gender,
                        "pincode": personalDetail.pincode,
                        "emailId": personalDetail.email,
                        "mobileNumber": personalDetail.mobile,
                        "partyId": createParty.partyCreate.partyID,
                        "customerCode": ""
                    },

                    "insuredDetails": insureedDetails,
                    "healthInformation": healthDetails[0].tobacco ? "true" : "false",
                    "healthInformationDetails": healthInformation,
                    "deniedByOtherCompany": healthDetails[0].denied ? "true" : "false",
                    "deniedDetails": healthDetails[0].denialdetails  ?  [{
                        "name": healthDetails[0].username,
                        "detailsonDenial": healthDetails[0].denialdetails
                    }] : [],
                    "concurrentInsurance": healthDetails[0].insurance ? "true" : "false",
                    "concurrentInsuranceDetails": concurrentInformation,
                    "nomineeDetails": {
                        "name": travelNomineeDetailsVm.nomineeName + " " + travelNomineeDetailsVm.nomineeLastName,
                        "relationship": travelNomineeDetailsVm.nomineeRelationWithInsured.key,
                        "dob": $filter('dateFormat')(travelNomineeDetailsVm.birthdate),
                        "age": Nomineeage,
                        "isMinor": travelNomineeDetailsVm.minorNominee ? "true" : "false",
                        "partyId": partyCreate.partyCreate.partyID,
                    },
                    "appointeeDetails": {
                        "name": travelNomineeDetailsVm.AppointeeName ? travelNomineeDetailsVm.AppointeeName + " " + travelNomineeDetailsVm.appointeeLastName : "",
                        "appointeeRelationship": travelNomineeDetailsVm.relationWithNominee ? travelNomineeDetailsVm.relationWithNominee.key : ""
                    }
                }
            }


            generalInsurenceHomeService.applyHDCQuote(createquoterequest).then(function(data) {
                //  generalInsurenceTravelService.setPolicyforPAI(data);
                generalInsurenceHealthService.setQuotecalculation(data);
                saveApplicationHDC();

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        /* if valid go to next page */
        travelNomineeDetailsVm.goToSubmit = function() {
            // to do
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                travelNomineeDetails = {
                    uin: travelNomineeDetailsVm.productType,
                    nomineeTitle: travelNomineeDetailsVm.nomineeTitle,
                    name1: travelNomineeDetailsVm.nomineeName,
                    nomineeLastName: travelNomineeDetailsVm.nomineeLastName,
                    relationship: travelNomineeDetailsVm.nomineeRelationWithInsured,
                    birthDate: travelNomineeDetailsVm.birthdate,
                    nomineeMinor: travelNomineeDetailsVm.minorNominee,
                    appointeeTitle: travelNomineeDetailsVm.appointeeTitle,
                    name: travelNomineeDetailsVm.AppointeeName,
                    appointeeLastName: travelNomineeDetailsVm.appointeeLastName,
                    relationshipWithNominee: travelNomineeDetailsVm.relationWithNominee,
                    renewal: travelNomineeDetailsVm.renewal,
                    proposerBirthday: travelNomineeDetailsVm.proposerBirthday
                }
                generalInsurenceTravelService.setTravelNomineeDetail(travelNomineeDetails);
                if (productType == '44') {
                    SetSaveApplicationForPAI();
                    //getJsonforPAI();
                } else if (productType == '55') {
                    getJsonforTravel();
                } else if (productType == '14') {
                    createPartyIdJson();


                } else if (productType == '13') {
                    createPartyIdJson();

                    // $state.go('menu.healthPurchaseSummary');
                } else if (productType == '11') {
                    createPartyIdJson();

                } else if (productType == '12') {
                    createPartyIdJson();

                } else if (productType == '31' || productType == '32') {
                    createPartyIdForMotor();
                    // craeteJSONforMotor();
                }
            }
        }

        travelNomineeDetailsVm.prefillProposerDetail = function(data) {
            var personalDetail = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
            if (data == 'nominee') {
                if (travelNomineeDetailsVm.nomineeRelationWithInsured.key == '1' || travelNomineeDetailsVm.nomineeRelationWithInsured.value == 'self') {
                    travelNomineeDetailsVm.nomineeName = personalDetail.firstName;
                    travelNomineeDetailsVm.nomineeLastName = personalDetail.LastName;
                    travelNomineeDetailsVm.birthdate = personalDetail.birthdate;
                    travelNomineeDetailsVm.nomineeTitle = personalDetail.title;
                    travelNomineeDetailsVm.nomineeReadonly = true;
                } else {
                    travelNomineeDetailsVm.nomineeReadonly = false;
                }
            } else {
                if (travelNomineeDetailsVm.relationWithNominee.key == '1' || travelNomineeDetailsVm.relationWithNominee.value == 'self') {
                    travelNomineeDetailsVm.nomineeName = personalDetail.firstName;
                    travelNomineeDetailsVm.nomineeLastName = personalDetail.LastName;
                    travelNomineeDetailsVm.birthdate = personalDetail.birthdate;
                    travelNomineeDetailsVm.nomineeTitle = personalDetail.title;
                    travelNomineeDetailsVm.apointeeReadonly = true;
                } else {
                    travelNomineeDetailsVm.apointeeReadonly = false;
                }
            }
        }

        travelNomineeDetailsVm.clickTerm = function() {
                generalInsurenceHomeService.getTermsAndCondtion();
                // .then(function(data) {}, function(error) {
                //     utilityService.showErrorMessage(error.responseMessage);
                // });
            }
            //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {


        });

        travelNomineeDetailsVm.clickDeclaration = function() {
            generalInsurenceHomeService.getDiclaration().then(function(data) {

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {

            //any cleanup needs to be done here: executes everytime when page is left
        });
        return this;
    }
]);
// })();
