angularApp.controller('travelPremiumSummaryController', ["$timeout",
        "$state",
        "$scope", "generalInsurenceTravelService","generalInsurenceHomeService","clickStreamService",

        function($timeout,
            $state,
            $scope, generalInsurenceTravelService,generalInsurenceHomeService,clickStreamService) {
            //functions, variables that can be accessed from the HTML come here
            var travelPremiumSummaryVm = this;
            //private methods section start
            function initPage() {
               travelPremiumSummaryVm.showBack = true;
                travelPremiumSummaryVm.showNext = true;
                travelPremiumSummaryVm.sumInsured = 0;
              var travelDetail =   generalInsurenceTravelService.getTravellerPremiumResponse();
             var travellerDetail = generalInsurenceTravelService.getTravellerDetail();
             

              if(generalInsurenceTravelService.getTravellerPolicyDetails()){
               if(generalInsurenceTravelService.getTravellerPolicyDetails().policyType.key == '2'){
                for(var count =0; count < travellerDetail.length; count++){
                   travelPremiumSummaryVm.sumInsured =  travelPremiumSummaryVm.sumInsured +travellerDetail[count].SumInsured.value;
                }
               }else{
                 travelPremiumSummaryVm.sumInsured  =  travellerDetail[0].SumInsured.value;
               }
                generalInsurenceHomeService.setpolicySumInsured(travelPremiumSummaryVm.sumInsured);
              }

                if(travelDetail){
                      // travelPremiumSummaryVm.sumInsured   =  travelDetail.premiumCalculation.sumInsured;
                      travelPremiumSummaryVm.quoteNumber   = travelDetail.premiumCalculation.quoteNumber;
                      travelPremiumSummaryVm.totalPremium    = travelDetail.premiumCalculation.actualPremiumPayable;
                }

            }


            travelPremiumSummaryVm.goBacktoPrevious = function() {
  
                $state.go("menu.travelQuoteTravellerInfo");
            }

               travelPremiumSummaryVm.goToNextPage = function() {
                    clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                    $state.go("menu.paymentAccountDetailsTravel");
                }
           

            //actions to done everytime the view is shown
            $scope.$on('$ionicView.beforeEnter', function() {
                initPage();
            });

           
            return this;
        }
    ]);
