angularApp.controller('travelProposerContactInfoController', [
    "$state",
    "$scope", "validateService", "generalInsurenceTravelService","GIconstant","generalInsurenceHomeService","clickStreamService",

    function($state,
        $scope,validateService, generalInsurenceTravelService,GIconstant,generalInsurenceHomeService,clickStreamService) {

        //functions, variables that can be accessed from the HTML come here
        var travelProposerContactInfoVm = this;
        var savedApplication;




          function SetSaveApplicationForTravel() {
             

            
            var SavePageDetail = GIconstant.saveForTravel.TravelPhysianDetail;
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, travelProposerContactInfoVm, modelname, SavePageDetail[count].type);
            }

             var JsonStingedData = angular.copy(savedApplication);
             generalInsurenceTravelService.setSavedData(savedApplication);
             JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
             JsonStingedData.cif = "";
             JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
             JsonStingedData.mobileNumber = "";
             JsonStingedData.uin = generalInsurenceHomeService.getProductDetail().uin;
             JsonStingedData.productCode = generalInsurenceHomeService.getGIProductsID();
             JsonStingedData.planName = generalInsurenceHomeService.getProductDetail().policyName;
             JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
             JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
             generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Travel.TI_HEALTH_QA).then(function(data) {
                  $state.go("menu.travelNomineeDetails");
             }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
             });
        }


        //private methods section start
        function initPage() {
            savedApplication = generalInsurenceTravelService.getSavedData();
            travelProposerContactInfoVm.showBack = true;
            travelProposerContactInfoVm.showNext = true;


            /*  validation for Travel Physical Info page */
            travelProposerContactInfoVm.travelPhysicalInfo = {};
            //onkeyup validate fields if required
            travelProposerContactInfoVm.validateService = validateService;

            /*  handle back button function */
         
                if (generalInsurenceTravelService.getPhysicianDetails()) {
                    travelProposerContactInfoVm.name = generalInsurenceTravelService.getPhysicianDetails().name;
                    travelProposerContactInfoVm.mobile = generalInsurenceTravelService.getPhysicianDetails().mobileNumber;
                   
                }
         

        }
        //private methods section end

        //added for field levelo validation
        function validateForm() {
            travelProposerContactInfoVm.travelPhysicalInfo = {};
            if (travelProposerContactInfoVm.validateService.isValidName(travelProposerContactInfoVm.name)) {
                travelProposerContactInfoVm.travelPhysicalInfo.name = travelProposerContactInfoVm.validateService.isValidName(travelProposerContactInfoVm.name);
            }
            if (travelProposerContactInfoVm.validateService.isValidPhoneNo(travelProposerContactInfoVm.mobile)) {
                travelProposerContactInfoVm.travelPhysicalInfo.mobile = travelProposerContactInfoVm.validateService.isValidPhoneNo(travelProposerContactInfoVm.mobile);
            }
            return (angular.equals({}, travelProposerContactInfoVm.travelPhysicalInfo)) ? true : false;
        }


        /* go to previous pagew  */
        travelProposerContactInfoVm.goBacktoPrevious = function() {
            //To do 
            $state.go("menu.travelProposerphysiocalInfo");
        }

        /* if valid to to next page*/
        travelProposerContactInfoVm.goToPhysicalNextPage = function() {

            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                var physicianDetail = {
                    name: travelProposerContactInfoVm.name,
                    mobileNumber: travelProposerContactInfoVm.mobile,
                }
                generalInsurenceTravelService.setPhysicianDetails(physicianDetail);
                SetSaveApplicationForTravel();
               
            }
        }

        /* go to previous pagew  */
        travelProposerContactInfoVm.goBacktoPhysicalPrevious = function() {
            $state.go("menu.travelApplicationTravellerInfo");
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

      
        return this;
    }
]);
// })();
