angularApp.controller('travelQuoteTravellerInfoController', ["$timeout",
    "$state",
    "$scope",
    "$translate", "generalInsurenceTravelService", "validateService", "$filter", "$ionicPopup", "generalInsurenceHomeService", "GIconstant","utilityService","clickStreamService",

    function($timeout,
        $state,
        $scope,
        $translate, generalInsurenceTravelService, validateService, $filter, $ionicPopup, generalInsurenceHomeService, GIconstant,utilityService,clickStreamService) {

        //functions, variables that can be accessed from the HTML come here
        var travelQuoteTravellerInfoVm = this;
        travelQuoteTravellerInfoVm.travelerMemberInfo = [1];
        var Policytype,savedApplication;







         function SetSaveApplicationForTravel(details) {
            if(details == "quote"){
               var travelQuoteDetail = generalInsurenceTravelService.getTravellerPremiumResponse();
               savedApplication.quoteData.premiumCalculation = {};
               savedApplication.quoteData.premiumCalculation.response  = travelQuoteDetail.premiumCalculation
            }else{
                var travellerList = [];
            for(var count = 0; count < travelQuoteTravellerInfoVm.data.length;count ++ ){
                travellerList[count] = {};
                travellerList[count].dob =  new Date(travelQuoteTravellerInfoVm.data[count].Birthdate);
                travellerList[count].sumInsured =    travelQuoteTravellerInfoVm.data[count].SumInsured ? travelQuoteTravellerInfoVm.data[count].SumInsured : "";
                travellerList[count].proposerRelation =  travelQuoteTravellerInfoVm.data[count].Relationship;
            }
             savedApplication.quoteData.travellerDetails = travellerList;
             savedApplication.quoteData.familySize = travelQuoteTravellerInfoVm.data.length;  
            }
             var JsonStingedData = angular.copy(savedApplication);
             generalInsurenceTravelService.setSavedData(savedApplication);
             JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
             JsonStingedData.cif = "";
             JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
             JsonStingedData.mobileNumber = "";
             JsonStingedData.uin = generalInsurenceHomeService.getProductDetail().uin;
             JsonStingedData.productCode = generalInsurenceHomeService.getGIProductsID();
             JsonStingedData.planName = generalInsurenceHomeService.getProductDetail().policyName;
             JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
            JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";

             generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Travel.TI_PREMIUM_2).then(function(data) {
                if(details == "quote" ){
                    $state.go("menu.travelPremiumSummary");
                 }else{
                     getJSONforTravel();
                 }
             }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
             });
        }


        //private methods section start
        function initPage() {
           
             savedApplication = generalInsurenceTravelService.getSavedData();
            var masterdata = generalInsurenceTravelService.getTravelMasterDetail();
            travelQuoteTravellerInfoVm.AllSumInsured = masterdata.sumInsured;
            travelQuoteTravellerInfoVm.AllRelationship = masterdata.travellerRelation;


            travelQuoteTravellerInfoVm.data = [];
            travelQuoteTravellerInfoVm.data[0] = {};
            travelQuoteTravellerInfoVm.Birthdate = {};
            travelQuoteTravellerInfoVm.travelTravellerInfo = {};
            travelQuoteTravellerInfoVm.Relationship = {};
            travelQuoteTravellerInfoVm.showBack = true;
            travelQuoteTravellerInfoVm.showNext = true;
            travelQuoteTravellerInfoVm.showAddTraveller = true;
            travelQuoteTravellerInfoVm.showFamilySumInsured = false;

            /* birthdate svalidation for traveller */
            var currentDate = generalInsurenceHomeService.getCurrentDate();
            travelQuoteTravellerInfoVm.birthdateEndLimit = generalInsurenceHomeService.getFutureYear(currentDate, -70);
            travelQuoteTravellerInfoVm.birthdateStartLimit = generalInsurenceHomeService.getFutureMonth(currentDate, -6);
            travelQuoteTravellerInfoVm.defaultdate = generalInsurenceHomeService.getFutureMonth(currentDate, -6);

            //validation function starts

            //onkeyup validate fields if required
            travelQuoteTravellerInfoVm.validateService = validateService;


            Policytype = generalInsurenceTravelService.getTravellerPolicyDetails().policyType.value;

            if (Policytype == "Family Floater") {
                travelQuoteTravellerInfoVm.ShowsumInsured = true;
                travelQuoteTravellerInfoVm.showFamilySumInsured = true;
                travelQuoteTravellerInfoVm.birthdateEndLimit = generalInsurenceHomeService.getFutureYear(currentDate, -60);
            }

           



            /*  handle back button function */
            $timeout(function() {
                  if (generalInsurenceTravelService.getTravellerDetail()) {
                     travelQuoteTravellerInfoVm.data =  generalInsurenceTravelService.getTravellerDetail();
                 }else{
                    travelQuoteTravellerInfoVm.data = [];
                    travelQuoteTravellerInfoVm.data[0] = {};
                 }

                  if (Policytype == "Individual") {
                travelQuoteTravellerInfoVm.showAddTraveller = false;
                for(var count = 0 ; count < travelQuoteTravellerInfoVm.data.length; count ++){
                    if(count !=0){
                       travelQuoteTravellerInfoVm.data.splice(count, 1);
                    }
                }
              }
            }, 10);
        }

        

        /* field validation  */
        function validateForm() {
            travelQuoteTravellerInfoVm.travelTravellerInfo = {};
            travelQuoteTravellerInfoVm.travelTravellerInfo.Birthdate = {};
            travelQuoteTravellerInfoVm.travelTravellerInfo.Relationship = {};
            travelQuoteTravellerInfoVm.travelTravellerInfo.SumInsured = {};
            var i;
            for (i = 0; i < travelQuoteTravellerInfoVm.data.length; i++) {
                travelQuoteTravellerInfoVm.travelTravellerInfo[i] = {};

                if (travelQuoteTravellerInfoVm.validateService.isValidPolicyStartDate(travelQuoteTravellerInfoVm.data[i].Birthdate)) {
                    travelQuoteTravellerInfoVm.travelTravellerInfo[i].Birthdate = travelQuoteTravellerInfoVm.validateService.isValidPolicyStartDate(travelQuoteTravellerInfoVm.data[i].Birthdate);
                }
                if (travelQuoteTravellerInfoVm.validateService.isvalidDateForRelationship(travelQuoteTravellerInfoVm.data[i].Relationship,travelQuoteTravellerInfoVm.data[i].Birthdate)) {
                    travelQuoteTravellerInfoVm.travelTravellerInfo[i].Birthdate = travelQuoteTravellerInfoVm.validateService.isvalidDateForRelationship(travelQuoteTravellerInfoVm.data[i].Relationship,travelQuoteTravellerInfoVm.data[i].Birthdate);
                }
                if (travelQuoteTravellerInfoVm.validateService.isValidDateGI(travelQuoteTravellerInfoVm.data[i].Birthdate,travelQuoteTravellerInfoVm.birthdateEndLimit,travelQuoteTravellerInfoVm.birthdateStartLimit)) {
                    travelQuoteTravellerInfoVm.travelTravellerInfo[i].Birthdate = travelQuoteTravellerInfoVm.validateService.isValidDateGI(travelQuoteTravellerInfoVm.data[i].Birthdate,travelQuoteTravellerInfoVm.birthdateEndLimit,travelQuoteTravellerInfoVm.birthdateStartLimit);
                }
                
                
                if (travelQuoteTravellerInfoVm.validateService.isValidRelationship(travelQuoteTravellerInfoVm.data[i].Relationship)) {
                    travelQuoteTravellerInfoVm.travelTravellerInfo[i].Relationship = travelQuoteTravellerInfoVm.validateService.isValidRelationship(travelQuoteTravellerInfoVm.data[i].Relationship);
                }
                if (travelQuoteTravellerInfoVm.validateService.isValidSumInsured(travelQuoteTravellerInfoVm.data[i].SumInsured)) {
                    if (travelQuoteTravellerInfoVm.ShowsumInsured) {
                        if (i == 0) {
                            travelQuoteTravellerInfoVm.travelTravellerInfo[i].SumInsured = travelQuoteTravellerInfoVm.validateService.isValidSumInsured(travelQuoteTravellerInfoVm.data[i].SumInsured);
                        }
                    } else {
                        travelQuoteTravellerInfoVm.travelTravellerInfo[i].SumInsured = travelQuoteTravellerInfoVm.validateService.isValidSumInsured(travelQuoteTravellerInfoVm.data[i].SumInsured);
                    }
                }
            }

            for (var count = 0; count < travelQuoteTravellerInfoVm.data.length; count++) {
                if ((angular.equals({}, travelQuoteTravellerInfoVm.travelTravellerInfo[count])) ? true : false) {} else {
                    return false;
                }
            }
            return true;




        }

        //private methods section end

        travelQuoteTravellerInfoVm.goBacktoPrevious = function() {
            //To do
            $state.go("menu.travelQuotePolicyInfo");
        }

        travelQuoteTravellerInfoVm.buyAnotherPolicy = function() {
            // To Do
        }

        travelQuoteTravellerInfoVm.checkforage = function() {
                if (Policytype == "Family Floater") {
                    var currentDate = generalInsurenceHomeService.getCurrentDate();
                    var maxage = generalInsurenceHomeService.getFutureYear(currentDate, -60);
                    for (var i = 0; i <= travelQuoteTravellerInfoVm.travelerMemberInfo.length - 1; i++) {
                        selectedDate = travelQuoteTravellerInfoVm.Birthdate[i];
                        dateDiff = $filter('dateDifferenceInDays')(maxage, selectedDate);
                        if (dateDiff < 0) {
                            var alertPopup = $ionicPopup.alert({
                                title: '',
                                templateUrl: 'pages/generalInsurance/travel/travelpurposePopup.html'
                            });
                            travelQuoteTravellerInfoVm.Birthdate[i] = "";
                        }
                    }
                }

            }
            /* add Max 4 members details  */
        travelQuoteTravellerInfoVm.addMembersInfo = function() {
            var Policytype = generalInsurenceTravelService.getTravellerPolicyDetails().policyType.value;
            if (Policytype != "Individual" && travelQuoteTravellerInfoVm.data.length < 4) {
                travelQuoteTravellerInfoVm.data.push(Math.max.apply(null, travelQuoteTravellerInfoVm.data) + 1);
                //travelQuoteTravellerInfoVm.data[]
            }
        }

        /* add Max 4 members details  */
        travelQuoteTravellerInfoVm.deleteMembersInfo = function(index) {
            var Policytype = generalInsurenceTravelService.getTravellerPolicyDetails().policyType.value;
            if (Policytype != "Individual" && travelQuoteTravellerInfoVm.data.length > 1) {
                travelQuoteTravellerInfoVm.data.splice(index, 1);
                //travelQuoteTravellerInfoVm.travelerMemberInfo.pop(travelQuoteTravellerInfoVm.travelerMemberInfo.index);
            }
        }


        /* show Terms and condition Popus */
        function getJSONforTravel() {
            var getTravellerPolicyDetails = generalInsurenceTravelService.getTravellerPolicyDetails();


            var travellerDetail = [];
            for (var count = 0; count < travelQuoteTravellerInfoVm.data.length; count++) {
                var ageDetail = validateService.calcAge(travelQuoteTravellerInfoVm.data[count].Birthdate);
                if (ageDetail == 0) {
                    ageDetail = "1";
                } else {
                    ageDetail = validateService.calcAge(travelQuoteTravellerInfoVm.data[count].Birthdate).toString();
                }

                travellerDetail[count] = {};
                travellerDetail[count].dob = $filter('startDateWithTimezone')(travelQuoteTravellerInfoVm.data[count].Birthdate);
                travellerDetail[count].age = ageDetail;
               // travellerDetail[count].sumInsured =  travelQuoteTravellerInfoVm.data[count].SumInsured.value.toString();
                if (count == 0 || getTravellerPolicyDetails.policyType.key != "3") {
                    travellerDetail[count].sumInsured = travelQuoteTravellerInfoVm.data[count].SumInsured.value.toString();
                    travellerDetail[count].sumInsuredId = travelQuoteTravellerInfoVm.data[count].SumInsured.key.toString();
                } else {
                    travellerDetail[count].sumInsured = travelQuoteTravellerInfoVm.data[0].SumInsured.value.toString();
                    travellerDetail[count].sumInsuredId = travelQuoteTravellerInfoVm.data[0].SumInsured.key.toString();
                }
                travellerDetail[count].proposerRelation = travelQuoteTravellerInfoVm.data[count].Relationship.key;
                travellerDetail[count].insuredId = "";
                travellerDetail[count].policyCtDetails = [];
                for (var i = 0; i < GIconstant.Travel.PremiumJsonCreateCount; i++) {
                    travellerDetail[count].policyCtDetails[i] = {};
                    travellerDetail[count].policyCtDetails[i].coverTypeName = "";
                    travellerDetail[count].policyCtDetails[i].policyCtId = "";
                }
            }




            var requestForJson = {
                "productDetails": {
                    "productType": getTravellerPolicyDetails.policyType.key,
                    "policyOption": getTravellerPolicyDetails.policyOption.key,
                    "travelToUSCanada": getTravellerPolicyDetails.travellingToUSCanada ? "true" : "false",
                    "countryOfMaxStay": getTravellerPolicyDetails.Countrystay.locId.toString(),
                    "noOfDays": getTravellerPolicyDetails.diffVal.toString(),
                    "travelStartDate": $filter('startDateWithTimezone')(getTravellerPolicyDetails.startDate),
                    "travelEndDate":  $filter('endDateWithTimezone')(getTravellerPolicyDetails.endDate),
                    "purposeOfTravel": getTravellerPolicyDetails.travelPurpose.key
                },
                "travellerDetails": travellerDetail,    
                "quoteDetails": {
                    "quoteNo": "",
                    "policyId": "",
                    "ppId": ""
                }
            }


                 var test = JSON.stringify(requestForJson);

            generalInsurenceTravelService.postTravelPremium(requestForJson).then(function(data) {
                generalInsurenceTravelService.setTravellerPremiumResponse(data);
                 SetSaveApplicationForTravel("quote"); 
               
            }, function(error) {
                 utilityService.showErrorMessage(error.responseMessage);
            });

        }



        /*if valid go to next page */
        travelQuoteTravellerInfoVm.goToNextPage = function() {
            // to do 
            var i;
            var noOfTraveller = travelQuoteTravellerInfoVm.travelerMemberInfo.length;
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                var ProductKey = generalInsurenceTravelService.getTravellerPolicyDetails().policyType.key;
                if (ProductKey != "1") {
                    if (travelQuoteTravellerInfoVm.data.length == 1) {
                        utilityService.showErrorMessage("Please select atleast two member");
                    } else {
                        travelQuoteTravellerInfoVm.data[0].Policytype = Policytype;
                        generalInsurenceTravelService.setTravellerDetail(travelQuoteTravellerInfoVm.data);
                        SetSaveApplicationForTravel(); 
                    }
                } else {
                    travelQuoteTravellerInfoVm.data[0].Policytype = Policytype;
                    generalInsurenceTravelService.setTravellerDetail(travelQuoteTravellerInfoVm.data);
                    SetSaveApplicationForTravel();
                }
            }
        }


        travelQuoteTravellerInfoVm.changeRelationship = function(data,index){
            if(index==0){
                if(data){
                    if(data.key == GIconstant.Travel.selfKeyinTravelRelationShip) {
                        if(travelQuoteTravellerInfoVm.data[0].Birthdate){
                            var age  =  validateService.calcAge(travelQuoteTravellerInfoVm.data[0].Birthdate);
                            if(age<18){
                                travelQuoteTravellerInfoVm.data[0].Birthdate = "";
                                travelQuoteTravellerInfoVm.travelTravellerInfo[0] = {};
                                travelQuoteTravellerInfoVm.travelTravellerInfo[0].Birthdate =  $translate.instant('isValidBDaySNMIN'); 
                            }
                        }
                    }
                }
            }
            if(index == 0 && (data.key == GIconstant.Travel.sonKeyinTravelRelationShip || data.key == GIconstant.Travel.daughterKeyinTravelRelationShip) && Policytype == "Individual"){
                if(data){
                    if(travelQuoteTravellerInfoVm.data[0].Birthdate){
                        var age  =  validateService.calcAge(travelQuoteTravellerInfoVm.data[0].Birthdate);
                        if(age<18){
                            travelQuoteTravellerInfoVm.data[0].Birthdate = "";
                            travelQuoteTravellerInfoVm.travelTravellerInfo[0] = {};
                            travelQuoteTravellerInfoVm.birthdateStartLimit = generalInsurenceHomeService.getFutureYear(generalInsurenceHomeService.getCurrentDate(), -18);
                            travelQuoteTravellerInfoVm.defaultdate = travelQuoteTravellerInfoVm.birthdateStartLimit;
                            travelQuoteTravellerInfoVm.travelTravellerInfo[0].Birthdate =  $translate.instant('isValidBDaySNMIN'); 
                        }
                    }
                }
            }
        }

      

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

       
        return this;
    }
]);
// })();
