'use strict';
angularApp.controller('governmentSchemeDetailsController', [
	"$state",
	"$scope",
	"ompMerchantsService","$ionicPopup","$stateParams","governmentSchemeService","mPinLoginService",
	function ($state, $scope,ompMerchantsService,$ionicPopup,$stateParams,governmentSchemeService,mPinLoginService) {

		var governmentSchemeDetailsVm = this;
	
	
    governmentSchemeDetailsVm.goToBack = function(){
			$state.go('menu.governmentSchemesLanding');
		};

    governmentSchemeDetailsVm.collapseIt = function (id) {
      governmentSchemeDetailsVm.collapseId = (governmentSchemeDetailsVm.collapseId == id) ? -1 : id;
    };


		governmentSchemeDetailsVm.applyNow = function(){
			if(angular.equals(governmentSchemeDetailsVm.schemeList.schemeName,governmentSchemeService.SsyScheme)){
			
			governmentSchemeDetailsVm.myPopup = $ionicPopup.show({
				template: '<div class="button_fund font-size-14 roboto-medium color-darkgrey" >'+governmentSchemeDetailsVm.schemeList.applyNow.dialogContent+'</div>',
				title: '',
				cssClass: 'new-purp-popup my-custom-popup',
				scope: '',
				buttons: [{
					text: 'OK',
					type: 'button-newpurple-OK',				
					onTap: function (e) {
						governmentSchemeDetailsVm.myPopup.then(function (res) {
							if (!res) {
								governmentSchemeDetailsVm.myPopup.close();
								$state.go('menu.governmentSchemeDetails');
							} 
						});
					}
				}]
			  });			 
			}
			else{
			governmentSchemeDetailsVm.myPopup = $ionicPopup.show({
					title: '',
					cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
					template: '<div class="disclaimerMainDiv"><div class="popupWhite ompSubheadrePopup disclaimerPopup " style="height:75% !important;"><div class="textAlignCenter ftMarginBottom16 disclaimerNew">' + governmentSchemeDetailsVm.schemeList.applyNow.dialogHeading +'</div>'
										+'<div class="textAlignjustified disclaimerTextPopup" id="bullet"><span>'+ governmentSchemeDetailsVm.schemeList.applyNow.dialogContent +'</span></br/>'
										+'</div></div><div class="agreeCancelDiv ompSubheadrePopup">'
										+'<button class="button-block popupButton purpleClassButtonCancel disclaimerPopupButton" ng-click="governmentSchemeDetailsVm.cancel()" translate="FTCANCEL" id="CANCL_POP_ANC"></button>'
										+'<button class="button-block popupButton purpleClassButtonAgree disclaimerPopupButton" style="margin-left: 3px;" ng-click="governmentSchemeDetailsVm.agreeApplyNow()" translate="I_AGREE" id="AGRE_BTN"></button>'
										+'</div></div>',
					scope: $scope
			});
		}
		};


		governmentSchemeDetailsVm.agreeApplyNow = function () {
			var request = {               
					
					"journeyName":"Government Schemes (URL redirection)",
					"schemeName":governmentSchemeDetailsVm.schemeList.schemeName,
					"schemeUrl":governmentSchemeDetailsVm.schemeList.applyNow.url,				
				   	"timeStamp":(new Date()).toString(),
					"isLoggedIn": mPinLoginService.isLoggedIn
				}			
				
             
		 governmentSchemeService.saveDisclaimer(request).then(function (response) {
              
				governmentSchemeDetailsVm.myPopup.close();
                if (angular.equals(response.responseCode,"0000")) {
			
					ompMerchantsService.inChromeBrowser(governmentSchemeDetailsVm.schemeList.applyNow.url);
					
                }
            }, function (error) {
                governmentSchemeDetailsVm.loadPopup.close();
                utilityService.showErrorMessage(error.responseMessage);
            });  
		};



		governmentSchemeDetailsVm.knowMore = function(){
			governmentSchemeDetailsVm.myPopup = $ionicPopup.show({
					title: '',
					cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',					
					template: '<div class="disclaimerMainDiv"><div class="popupWhite ompSubheadrePopup disclaimerPopup " style="height:75% !important;"><div class="textAlignCenter ftMarginBottom16 disclaimerNew">' + governmentSchemeDetailsVm.schemeList.knowMore.dialogHeading +'</div>'
										+'<div class="textAlignjustified disclaimerTextPopup" id="bullet"><span>'+ governmentSchemeDetailsVm.schemeList.knowMore.dialogContent +'</span></br/>'
										+'</div></div><div class="agreeCancelDiv ompSubheadrePopup">'
										+'<button class="button-block popupButton purpleClassButtonCancel disclaimerPopupButton" ng-click="governmentSchemeDetailsVm.cancel()" translate="FTCANCEL" id="CANCL_POP_ANC"></button>'
										+'<button class="button-block popupButton purpleClassButtonAgree disclaimerPopupButton" style="margin-left: 3px;" ng-click="governmentSchemeDetailsVm.agree()" translate="I_AGREE" id="AGRE_BTN"></button>'
										+'</div></div>',
					scope: $scope
			});
		};

		governmentSchemeDetailsVm.cancel = function () {
		  	governmentSchemeDetailsVm.myPopup.close();
		};
		governmentSchemeDetailsVm.agree = function () {
			
				var request = {				
					"journeyName":"Government Schemes (URL redirection)",
					"schemeName":governmentSchemeDetailsVm.schemeList.schemeName,
					"schemeUrl":governmentSchemeDetailsVm.schemeList.knowMore.url,				
					"timeStamp":(new Date()).toString(),
					"isLoggedIn": mPinLoginService.isLoggedIn
					   
				
				
				}
			
				governmentSchemeService.saveDisclaimer(request).then(function (response) {
					
					governmentSchemeDetailsVm.myPopup.close();
					if (angular.equals(response.responseCode,"0000")) {
					
						ompMerchantsService.inChromeBrowser(governmentSchemeDetailsVm.schemeList.knowMore.url);
						
					}
				}, function (error) {
					governmentSchemeDetailsVm.loadPopup.close();
					utilityService.showErrorMessage(error.responseMessage);
				});  
			
		};
		function initPage(){
			governmentSchemeDetailsVm.schemeList=$stateParams.schemeDetails;
		
		}
		$scope.$on('$ionicView.beforeEnter', function () {
			initPage();

		}); 
	
		

		return this;
		}]);
