'use strict';

angularApp.service('instaAadhaarValService',
    function($q, AdapterUtils, constantConfig) {
        var instaAadhaarValService = this;
        instaAadhaarValService.generateAadharOtp = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.generateAadharOtp, requestData, true).then(
                
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instaAadhaarValService.getEKycOTPSecure = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.getEKycOTPSecure, requestData, true).then(
                
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        }; 

        instaAadhaarValService.uploadPhoto = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.uploadPhoto, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };  
		instaAadhaarValService.aadhrOTPattempt = 0;
          
        return instaAadhaarValService;
    });
