'use strict';

angularApp.service('instaaccountOpeningLooksGreatService',
    function($q, AdapterUtils, constantConfig) {
        var instaaccountOpeningLooksGreatService = this;
        
        instaaccountOpeningLooksGreatService.uploadPhoto = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.uploadPhoto, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instaaccountOpeningLooksGreatService.retrievePhoto = function(requestData) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.retrieveDocument + requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return instaaccountOpeningLooksGreatService;
    });
