'use strict';

angularApp.controller('instaaDOccupationController', ["$state",
    "$scope",
    "instaService",
    "$translate",
    "instaadDetailsCommonService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "constantConfig",
    "$ionicScrollDelegate",
    "$window",
    "$location",
    "$rootScope",
    "$anchorScroll",


    function($state,
        $scope,
        instaService,
        $translate,
        instaadDetailsCommonService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        constantConfig,homeScreenService,$ionicScrollDelegate,$window,$location,$rootScope,$anchorScroll) {

        var instaaDOccupationVm = this;

        function initPage() {
            instaaDOccupationVm.showBack = true;
            instaaDOccupationVm.showNext = false;
            instaaDOccupationVm.aofooter = true;
            instaaDOccupationVm.loadOccupation();
           
            instaaDOccupationVm.showNotCatField = false;
            if(instaService.isResumeJourney == true){
                 instaaDOccupationVm.populateResumeData();
            }

            if(instaaDOccupationVm.annualIncomeValue && instaService.activeAdditionalDetails && instaService.activeAdditionalDetails.subOccupation){
                if((instaService.activeAdditionalDetails.suboccupation !="0700" && instaService.activeAdditionalDetails.suboccupation !="0600" && instaService.activeAdditionalDetails.suboccupation != "0500" && instaService.activeAdditionalDetails.suboccupation != "0493") && (instaaDOccupationVm.annualIncomeValue == "0" || instaaDOccupationVm.annualIncomeValue == 0)){
                    instaaDOccupationVm.annualIncomeError  = true;
                }else{
                    instaaDOccupationVm.annualIncomeError = false;
                }
            }

            if(instaService.activeAdditionalDetails.occupation == "0999" && instaService.customerAdditionalDetails.subOccupation){
                instaaDOccupationVm.searchLabelTemp =  instaService.customerAdditionalDetails.subOccupation;
                  instaaDOccupationVm.showNotCatField = true;
            }
           //console.log("$state.current.templateUrl" +$state.current.templateUrl);
        }

        instaaDOccupationVm.populateResumeData = function(){
            
                instaaDOccupationVm.activeStatus = instaService.getIdByValue(instaaDOccupationVm.occupationList, instaService.customerAdditionalDetails.occupation);
            
        }

      
        instaaDOccupationVm.loadOccupation = function(){
			instaaDOccupationVm.isErorr = false;
			utilityService.showSpinner();
            var requestParam = "OccupationLotusLevel1";
            instaadDetailsCommonService.getOccupation(requestParam).then(function(data) {                
                instaaDOccupationVm.isErorr = false;
				utilityService.hideSpinner();
				instaaDOccupationVm.occupationList = data;
            }, function(error) {
				utilityService.hideSpinner();
				instaaDOccupationVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instaaDOccupationVm.selectedObj = function(selectedItem){
            instaaDOccupationVm.searchLabel = selectedItem.description;
            instaaDOccupationVm.searchLabelTemp = selectedItem.description;
            instaService.customerAdditionalDetails.subOccupation  = selectedItem.description;
            instaService.activeAdditionalDetails.suboccupation = selectedItem.value;
            instaaDOccupationVm.isSearched = false;
            // if(document.getElementById('angucomplete-dropdown').scrollIntoView()!=undefined){
            //     document.getElementById('angucomplete-dropdown').scrollIntoView();
            // }
			cordova.plugins.Keyboard.close();
		}

        instaaDOccupationVm.getReligion = function() {
            $state.go("menu.instaKit_aDReligion");
        }

        instaaDOccupationVm.getOService = function() {
            $state.go("menu.instaKit_aDOccupationService");
        }

        instaaDOccupationVm.numerFormat = function() {
            //instaService.customerAdditionalDetails.annualIncomeValue = instaaDOccupationVm.annualIncomeValue;
        if(instaaDOccupationVm.annualIncomeValue){
            instaaDOccupationVm.annualIncomeValue = utilityService.amountFormat(instaaDOccupationVm.annualIncomeValue);
            if((instaService.activeAdditionalDetails.suboccupation !="0700" && instaService.activeAdditionalDetails.suboccupation !="0600" && instaService.activeAdditionalDetails.suboccupation != "0500" && instaService.activeAdditionalDetails.suboccupation != "0493") && (instaaDOccupationVm.annualIncomeValue == "0" || instaaDOccupationVm.annualIncomeValue == 0)){
                instaaDOccupationVm.annualIncomeError  = true;
            }else{
                instaaDOccupationVm.annualIncomeError = false;
            }
         }
        }

        instaaDOccupationVm.goBacktoPrevious = function() {
            // if(instaaDOccupationVm.journeyType != instaaDOccupationVm.constantJourneyTypeVKYC){
            //     $state.go("menu.instaKit_aDAnnualIncome");
            // }else{
                $state.go("menu.instaKit_aDFamilyDetails");
            // } 
            
        }

        instaaDOccupationVm.nonCatValueExist = function(username) {
            return instaaDOccupationVm.searchedList.some(function(el) {
              return el.description === username;
            }); 
        }

        instaaDOccupationVm.goToNextPage = function() {
 
            if(instaaDOccupationVm.searchLabel){
                if((instaaDOccupationVm.nonCatValueExist(instaaDOccupationVm.searchLabel) == true) && (instaaDOccupationVm.nonCatValueExist(instaaDOccupationVm.searchLabelTemp) == true)){
                    instaService.customerAdditionalDetails.showNext = true;
                    $state.go("menu.instakit_annualIncomeNew");
                }else{
                    //alert('Please enter the correct value of category.');
                }
             }   
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        /* Based on main occupation, redirect to respective sub occupation pages */
        instaaDOccupationVm.showHideSubOcc = function(param) {
            instaService.activeAdditionalDetails.occupation = param.value;
            instaService.customerAdditionalDetails.service = instaaDOccupationVm.selectedOccupation;
            instaService.customerAdditionalDetails.occupation = param.description; 
            instaaDOccupationVm.activeStatus = param.value;
            instaService.customerAdditionalDetails.annualIncomeValue = utilityService.resetAmountFormat(instaaDOccupationVm.annualIncomeValue);
            if (param.value === "0001") {
                instaaDOccupationVm.showNotCatField = false;
                $state.go("menu.instaKit_aDSubOccupationService");
            } 
            else if (param.value === "0002") {
                instaaDOccupationVm.showNotCatField = false;
                $state.go("menu.instaKit_aDSubOccupationOthers");
            }
            else if (param.value === "0303") {
                instaaDOccupationVm.showNotCatField = false;
                $state.go("menu.instaKit_aDSubOccupationBusiness");
            }
            else{
                instaaDOccupationVm.showNotCatField = true;
                //$state.go("menu.instaKit_annualIncomeNew");
            } 
           
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instaaDOccupationVm.journeyType = instaService.journeyType;
            instaaDOccupationVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instaaDOccupationVm.annualIncomeValue = instaService.customerAdditionalDetails.annualIncomeValue;
            instaaDOccupationVm.activeStatus = instaService.activeAdditionalDetails.occupation;
            if(instaaDOccupationVm.annualIncomeValue){
                instaaDOccupationVm.annualIncomeValue = utilityService.amountFormat(instaaDOccupationVm.annualIncomeValue);
            }
            if(instaService.activeAdditionalDetails.occupation == "0999" && instaService.customerAdditionalDetails.subOccupation){
                instaaDOccupationVm.searchLabelTemp =  instaService.customerAdditionalDetails.subOccupation;
                instaaDOccupationVm.searchLabel =  instaService.customerAdditionalDetails.subOccupation;
                  instaaDOccupationVm.showNotCatField = true;
            }
            if((instaService.activeAdditionalDetails.suboccupation !="0700" && instaService.activeAdditionalDetails.suboccupation !="0600" && instaService.activeAdditionalDetails.suboccupation != "0500" && instaService.activeAdditionalDetails.suboccupation != "0493") && (instaaDOccupationVm.annualIncomeValue == "0" || instaaDOccupationVm.annualIncomeValue == 0)){
                instaaDOccupationVm.annualIncomeError  = true;
            }else{
                instaaDOccupationVm.annualIncomeError = false;
            }
            instaaDOccupationVm.showNext =  instaService.customerAdditionalDetails.showNext;
            instaaDOccupationVm.getSearchJSONData();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        instaaDOccupationVm.goToReligionPage = function(){
            instaService.customerAdditionalDetails.annualIncomeValue = utilityService.resetAmountFormat(instaaDOccupationVm.annualIncomeValue);
            $state.go("menu.instaKit_aDReligion");
        }
        

        instaaDOccupationVm.goBacktoPreviousSalary = function(){
            instaService.customerAdditionalDetails.showNext = false;
            if (instaService.activeAdditionalDetails.occupation === "0001") {
                $state.go("menu.instaKit_aDSubOccupationService");
            } 
            else if (instaService.activeAdditionalDetails.occupation === "0002") {
                $state.go("menu.instaKit_aDSubOccupationOthers");
            }
            else if (instaService.activeAdditionalDetails.occupation === "0303") {
                $state.go("menu.instaKit_aDSubOccupationBusiness");
            }
            else{
                $state.go("menu.instaKit_aDOccupation");
            } 
        }

        instaaDOccupationVm.getSearchJSONData = function(){
			utilityService.showSpinner();
                var requestParam = "OccupationLotusNonCat";
                instaadDetailsCommonService.getOccupation(requestParam).then(function(data) { 
                    instaaDOccupationVm.isErorr = false;
                    utilityService.hideSpinner();		
                    instaaDOccupationVm.searchedList = data;
                }, function(error) {
                    instaaDOccupationVm.isErorr = true;
                    utilityService.hideSpinner();	
                    utilityService.showErrorMessage(error.responseMessage);
                });
		};

     

        instaaDOccupationVm.yonoSearch = function(inputItem){
			var arrForinputItem = [];
			var regExpInput = "";
			var str = '';
			instaaDOccupationVm.filteredList = [];
			instaaDOccupationVm.isSearched = false;
			var arr = [];
			if(inputItem && inputItem.length >= 2){
             
                // if(inputItem.length == 3){
                //     cordova.plugins.Keyboard.close();
                // }
				arrForinputItem = (inputItem.toLowerCase()).split(/[,\s]+/g);
				for(var i=0;i<arrForinputItem.length;i++){
					str += "(?=.*"+arrForinputItem[i]+")";
				}
				regExpInput = new RegExp("^"+str+".*$");
				angular.forEach(instaaDOccupationVm.searchedList,function(v1,k1){
					if(instaaDOccupationVm.searchedList[k1]["description"].toString().toLowerCase().match(regExpInput)){
						arr.push(v1);
						instaaDOccupationVm.filteredList = removedDuplicateObjects(arr);
						instaaDOccupationVm.isSearched = true;
                      
						//$ionicScrollDelegate.$getByHandle('search-functionality-handle').scrollTop();
					}
				});
			}
			else{
				instaaDOccupationVm.isSearched = false;
				instaaDOccupationVm.filteredList = [];
			}
			//instaaDOccupationVm.dashboardContainerBlur(arrForinputItem);
			// var reportStr = instaaDOccupationVm.searchLabel;
			// instaaDOccupationVm.reportId = reportStr.replace(/\s+/g,",").substring(0,reportStr.length)+"?";
			// if(!instaaDOccupationVm.isSearched && instaaDOccupationVm.filteredList.length === 0 && instaaDOccupationVm.searchLabel.length > 3)
			// 	clickStreamService.clickStreamData = "CNTNT_SRCH?"+instaaDOccupationVm.reportId;
			// return instaaDOccupationVm.filteredList;
		}

		// instaaDOccupationVm.dashboardContainerBlur = function(arrForinputItem){
		// 	var container = document.getElementById("homeScreenDashboardConatiner");
		// 	if(instaaDOccupationVm.searchLabel && instaaDOccupationVm.searchLabel.length >= 2){
		// 		container.className = "blur-dashboard-container";
		// 	}
		// 	else{
		// 		container.removeAttribute("class");
		// 	}
		// }

		var removedDuplicateObjects = function (arr) {
			return arr.filter(function(item, index){
				return arr.indexOf(item) >= index;
			});
		};
        return this;
    }
]);
