'use strict';

angularApp.controller('instaaDCityCountryController', ["$state",
    "$scope",
    "$translate",
    "instaService",
    "utilityService",
    "instaaDCityCountryService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$ionicPopover",

    function($state,
        $scope,
        $translate,
        instaService,
        utilityService,
        instaaDCityCountryService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $ionicPopover) {

        var instaaDCityCountryVm = this;

        function initPage() {
            instaaDCityCountryVm.showBack = true;
            instaaDCityCountryVm.showNext = true;
            instaaDCityCountryVm.disableNext = true;
            instaaDCityCountryVm.country = "";
			instaaDCityCountryVm.getInfoMsg = "";
            instaaDCityCountryVm.selectCountries = [];
            instaaDCityCountryVm.selectCitizen = [];
            instaaDCityCountryVm.selectNationality = [];
            instaaDCityCountryVm.aofooter = true;

            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instaaDCityCountryVm.okBtntext = translatedvalue;
            });
            // instaaDCityCountryVm.getCountriesList();
            // instaaDCityCountryVm.getNationalityList();
            // instaaDCityCountryVm.getCitizenshipList();
        }

        // instaaDCityCountryVm.getCountriesList = function() {
        //     instaaDCityCountryService.getCountries().then(function(body) {
        //         if(!utilityService.isUndefined(body)){
        //             for (var i = 0; i < body.length; i++) {
        //                 instaaDCityCountryVm.selectCountries.push(body[i].name);
        //                 instaaDCityCountryVm.selectCountries.sort();
        //             }
        //         }                
        //     }, function(error) {
        //         utilityService.showErrorMessage(error.responseMessage);
        //     });
        // }


        // instaaDCityCountryVm.getNationalityList = function() {
        //     instaaDCityCountryService.getNationality().then(function(body) {
        //         if(!utilityService.isUndefined(body)){
        //             instaaDCityCountryVm.selectNationality = body;
        //         }                
        //     }, function(error) {
        //         utilityService.showErrorMessage(error.responseMessage);
        //     });
        // }

        // instaaDCityCountryVm.getCitizenshipList = function() {
        //     instaaDCityCountryService.getCitizenship().then(function(body) {
        //         if(!utilityService.isUndefined(body)){
        //             for (var i = 0; i < body.length; i++) {
        //                 instaaDCityCountryVm.selectCitizen = body;
        //             }
        //         }                
        //     }, function(error) {
        //         utilityService.showErrorMessage(error.responseMessage);
        //     });
        // }

        instaaDCityCountryVm.showHideFilterDropDown = function(isValid) {
            if (!utilityService.isUndefined(instaaDCityCountryVm.country)) {
                instaaDCityCountryVm.hideOptions = true;
                //instaaDCityCountryVm.disableNext = false;
            } 
           else {
                instaaDCityCountryVm.hideOptions = false;
                instaaDCityCountryVm.disableNext = true;
            }
        }

        instaaDCityCountryVm.showHideCitizen = function(isValid) {
            if (!utilityService.isUndefined(instaaDCityCountryVm.citizen)) {
                instaaDCityCountryVm.citizenList = true;
                //instaaDCityCountryVm.disableNext = false;
            } 
           else {
                instaaDCityCountryVm.citizenList = false;
                instaaDCityCountryVm.disableNext = true;
            }
        }

        instaaDCityCountryVm.showHideNationality = function(isValid) {
            if (!utilityService.isUndefined(instaaDCityCountryVm.nationality)) {
                instaaDCityCountryVm.nationList = true;
                //instaaDCityCountryVm.disableNext = false;
            } 
           else {
                instaaDCityCountryVm.nationList = false;
                instaaDCityCountryVm.disableNext = true;
            }
        }

        instaaDCityCountryVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_pdetailsAN");
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaaDCityCountryVm.goToNextPage = function() {
            // if (!utilityService.isUndefined(instaaDCityCountryVm.city) && !utilityService.isUndefined(instaaDCityCountryVm.country) && instaaDCityCountryVm.country.toLowerCase() == constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(instaaDCityCountryVm.nationality) && !utilityService.isUndefined(instaaDCityCountryVm.citizen) && instaaDCityCountryVm.citizen.toLowerCase() == constantConfig.acOp.india.toLowerCase() && instaaDCityCountryVm.nationality.toLowerCase() == constantConfig.acOp.india.toLowerCase()) {
                instaService.customerAdditionalDetails.cityOfBirth = instaaDCityCountryVm.city;
                instaService.customerAdditionalDetails.citizenshipDeclarationFlag = instaaDCityCountryVm.citizenshipConsent;
                // instaService.customerAdditionalDetails.countryOfBirth = instaaDCityCountryVm.country;
                // instaService.customerAdditionalDetails.nationality = instaaDCityCountryVm.nationality;
                // instaService.customerAdditionalDetails.citizenship = instaaDCityCountryVm.citizen;
                $state.go('menu.instaKit_pdetailsAddress');
            // }
            // else{
            //     var title = '';
            //     var template = '{{"CITYCOUNTRY_NOTINDIA_INSTA" | translate}}';
            //     var onTap = 'menu.instaKit_aDCityCountry';
            //     var buttontext = '<b>' + instaaDCityCountryVm.okBtntext + '</b>';
            //     utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            // }
        }

        // instaaDCityCountryVm.validateForm = function(isValid) {
        //     if (isValid === true && !utilityService.isUndefined(instaaDCityCountryVm.country) && !utilityService.isUndefined(instaaDCityCountryVm.citizen) && !utilityService.isUndefined(instaaDCityCountryVm.nationality)) {
        //         instaaDCityCountryVm.disableNext = false;
        //         instaaDCityCountryVm.cityValidate = true;
        //     } else {
        //         instaaDCityCountryVm.disableNext = true;
        //         instaaDCityCountryVm.cityValidate = false;
        //     }
        // }

        instaaDCityCountryVm.validateForm = function(isValid) {
            if (isValid === true && instaaDCityCountryVm.citizenshipConsent) {
                instaaDCityCountryVm.disableNext = false;
            } else {
                instaaDCityCountryVm.disableNext = true;
            }
        }

        instaaDCityCountryVm.abortProcess = function(selectValue) {
            instaaDCityCountryVm.country = selectValue;
            instaaDCityCountryVm.hideOptions = false;
            if (utilityService.isUndefined(instaaDCityCountryVm.country)) {
                instaaDCityCountryVm.disableNext = true;
            } else if (selectValue.toLowerCase() !== constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(instaaDCityCountryVm.country)) {
                var title = '';
                var template = '{{"CITYCOUNTRY_NOTINDIA_INSTA" | translate}}';
                var onTap = 'menu.instaKit_aDCityCountry';
                var buttontext = '<b>' + instaaDCityCountryVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

                instaaDCityCountryVm.disableNext = true;

            } else {
                instaaDCityCountryVm.disableNext = utilityService.isUndefined(instaaDCityCountryVm.city);
            }
        }

        instaaDCityCountryVm.abortNationality = function(param) {
            instaaDCityCountryVm.nationality = param.name;
            instaService.customerAdditionalDetails.nationalityID = param.code;
            instaaDCityCountryVm.nationList = false;
            if (utilityService.isUndefined(instaaDCityCountryVm.nationality)) {
                instaaDCityCountryVm.disableNext = true;
            } else if (param.name.toLowerCase() !== constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(instaaDCityCountryVm.nationality)) {
                var title = '';
                var template = '{{"CITYCOUNTRY_NATIONALITY_NOTINDIA_INSTA" | translate}}';
                var onTap = 'menu.instaKit_aDCityCountry';
                var buttontext = '<b>' + instaaDCityCountryVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

                instaaDCityCountryVm.disableNext = true;

            }
        }

        instaaDCityCountryVm.abortCitizenship = function(value) {
            instaaDCityCountryVm.citizen = value.name;
            instaService.customerAdditionalDetails.citizenshipID = value.code;
            instaaDCityCountryVm.citizenList = false;
            if (utilityService.isUndefined(instaaDCityCountryVm.citizen)) {
                instaaDCityCountryVm.disableNext = true;
            } else if (value.name.toLowerCase() !== constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(instaaDCityCountryVm.citizen)) {
                var title = '';
                var template = '{{"CITYCOUNTRY_CITIZENSHIP_NOTINDIA_INSTA" | translate}}';
                var onTap = 'menu.instaKit_aDCityCountry';
                var buttontext = '<b>' + instaaDCityCountryVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);

                instaaDCityCountryVm.disableNext = true;

            } 
        }

        /* Info Popup */
        var template = '<ion-popover-view class="tooltiptext ao-popupInfo roboto-regular ao-aadhaarInfoHt">' + '<ion-content>' +
                        '<div class="" ng-bind="instaaDCityCountryVm.getInfoMsg"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        instaaDCityCountryVm.infoPopup = function($event,clickId) {
			instaaDCityCountryService.getInfoList().then(function(body) {
                if(clickId == "citizen"){
				 	instaaDCityCountryVm.getInfoMsg = body.infoList.citizenshipContent;
				}else if(clickId == "nationality"){
				 	instaaDCityCountryVm.getInfoMsg = body.infoList.nationalityContent;
				}  
				$scope.popover.show($event); 				
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        instaaDCityCountryVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */

        instaaDCityCountryVm.populateResumeData = function() {
            /*if (instaService.isResumeJourney == true) {*/
                instaaDCityCountryVm.city = instaService.customerAdditionalDetails.cityOfBirth;
                instaaDCityCountryVm.citizenshipConsent = instaService.customerAdditionalDetails.citizenshipDeclarationFlag;
                instaaDCityCountryVm.country = instaService.customerAdditionalDetails.countryOfBirth;
                instaaDCityCountryVm.nationality = instaService.customerAdditionalDetails.nationality;
                instaaDCityCountryVm.citizen = instaService.customerAdditionalDetails.citizenship;
                if(!utilityService.isUndefined(instaaDCityCountryVm.city) && !utilityService.isUndefined(instaaDCityCountryVm.country) && instaaDCityCountryVm.country.toLowerCase() == constantConfig.acOp.india.toLowerCase() && !utilityService.isUndefined(instaaDCityCountryVm.nationality) && !utilityService.isUndefined(instaaDCityCountryVm.citizen) && instaaDCityCountryVm.citizen.toLowerCase() == constantConfig.acOp.india.toLowerCase() && instaaDCityCountryVm.nationality.toLowerCase() == constantConfig.acOp.india.toLowerCase()){
                    instaaDCityCountryVm.disableNext = false;
                    instaaDCityCountryVm.hideOptions = false;
                    instaaDCityCountryVm.nationList = false;
                    instaaDCityCountryVm.citizenList = false;
                }               
            /*}*/
        }

        /* Clear the Search field */
        $scope.clearSearch = function() {
            instaaDCityCountryVm.country = "";
        };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instaaDCityCountryVm.populateResumeData();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
