'use strict';

angularApp.service('instaaDCityCountryService',
    function($q, AdapterUtils, constantConfig) {
        var instaaDCityCountryService = this;
        instaaDCityCountryService.getCountries = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getCountries, true).then(

                function(response) {
                    q.resolve(response.body);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
        instaaDCityCountryService.getCitizenship = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getCountries, true).then(

                function(response) {
                    q.resolve(response.body);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
        instaaDCityCountryService.getNationality = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getCountries, true).then(

                function(response) {
                    q.resolve(response.body);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
		instaaDCityCountryService.getInfoList = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getInfoList, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
        
        return instaaDCityCountryService;
    });
