'use strict';

angularApp.controller('companyDetailsController', ["$state",
    "$scope",
    "instaService",
    "utilityService",
    "instapersonalDetailsService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "instanomineeDetailsRelatedService",
    "companyDetailsService",
    function ($state,
        $scope,
        instaService,
        utilityService,
        instapersonalDetailsService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        instanomineeDetailsRelatedService,companyDetailsService) {

        var companyDetailsVm = this;
      
        function initPage() {
          companyDetailsVm.showNext = true;
          companyDetailsVm.showBack = true;
         if(instaService.salaryDetails && instaService.salaryDetails.length){
            companyDetailsVm.employerName =  instaService.salaryDetails.employerName;
            companyDetailsVm.designationName  = instaService.salaryDetails.designationName;
            companyDetailsVm.salary = instaService.salaryDetails.salary;
            companyDetailsVm.serviceNumber = instaService.salaryDetails.serviceNumber;
            companyDetailsVm.joineType = instaService.salaryDetails.joineType;
         }
        }

        companyDetailsVm.goBacktoPrevious = function () {
            // $state.go('menu.instaKit_aDCityCountry');
            $state.go("menu.instaKit_aDReligion");
        }

        companyDetailsVm.goToNextPage = function () {

            if(companyDetailsVm.companyForm.$valid){
                instaService.salaryDetails.employerName = companyDetailsVm.employerName;
                instaService.salaryDetails.designationName = companyDetailsVm.designationName;
                instaService.salaryDetails.salary = companyDetailsVm.salary;
                instaService.salaryDetails.serviceNumber = companyDetailsVm.serviceNumber;
                instaService.salaryDetails.joineType = companyDetailsVm.joineType;
                // $state.go('menu.salaryUploadDoc');
                $state.go('menu.instaKit_nominationRelated');
            }else{
                companyDetailsVm.companyForm.$invalid = true;
            }

            // var requestParams = {
            //     "lotusId" : instaService.customer.lotusId,
            //     "tempUsername": instanetBankingRegisterVm.tempUsername,
            //     "internetBankingUsername": instanetBankingRegisterVm.ibUsername,
            //     "password": instanetBankingRegisterVm.password
            // }
            // companyDetailsService.sendCompanyDetails(requestParams).then(function(response) {
            //    $state.go('menu.instaKit_aoMpin');
            // }, function(error) {
            //   utilityService.showErrorMessage(error.responseMessage);
            // });
        }

       


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            companyDetailsVm.journeyType = instaService.journeyType;
            companyDetailsVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
