'use strict';

angularApp.service('instadetailsExistService',
    function($q, AdapterUtils, constantConfig) {
        var instadetailsExistService = this;
        instadetailsExistService.getDetailsExistContent = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.detailsExist, true).then(

                function(response) {
                    q.resolve(response.data.details);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return instadetailsExistService;
    });
