'use strict';

angularApp.service('instaenterOTPReferenceCodeService',
    function($q, AdapterUtils, constantConfig) {
        var instaenterOTPReferenceCodeService = this;
        var nightMode = false;
        instaenterOTPReferenceCodeService.getRefContent = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.justStepMore, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        instaenterOTPReferenceCodeService.getAccountOpenCont = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getAccOpenContent, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instaenterOTPReferenceCodeService.openInstaPlusAccount = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(constantConfig.InstaAcOpeningAdapterUrl.openInstaPlusAccount, requestParams, true, 120000).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        instaenterOTPReferenceCodeService.saveVkycConsent = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(constantConfig.InstaAcOpeningAdapterUrl.saveVkycConsent, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };
        
         instaenterOTPReferenceCodeService.getNightmodeFlag = function() {
          return nightMode;   
         };
        
         instaenterOTPReferenceCodeService.setNightmodeFlag = function(flag) {
            nightMode = flag;
        };
        return instaenterOTPReferenceCodeService;
    });
