'use strict';

angularApp.service('instaforeignService',
    function($q, AdapterUtils, constantConfig) {
        var instaforeignService = this;

        instaforeignService.getFatcaInfoDetails = function(){
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getFatcaInfoDetails, true).then(

                function(response) {
                    q.resolve(response.data.fatcaDetails);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        }

        return instaforeignService;
    });
