'use strict';

angularApp.service('instaService', ['$state', "utilityService", "loggedInUserService",
    function($state, utilityService, loggedInUserService) {
        var Instaservice = this;
        var policyWording = "";
        var journeyType = "";
        var tokenNumber = "";
        Instaservice.literateFlag = false;
        Instaservice.employerNotListed = false;
        Instaservice.salaryDetails = [];
		Instaservice.getFeature = function(){
			return policyWording;
		}
		
		Instaservice.setFeature = function(feature){
			policyWording = feature;
		}
		
        Instaservice.customer = {
            aadharNumber: '',
            title: '',
            name: '',
            gender: '',
            dateOfYear: '',
            address: '',
            pincode: '',
            city: '',
            state: '',
            emailId: '',
            mobileNo: '',
            panNumber: '',
            lotusId: '1234',
            image: 'abc',
            deviceUid: '',
            deviceOS: '',
            referenceCode: '',
            photo: '',
            guardian: '',
            latitude: '',
            longitude: '',
            encodephoto: ''
        }

        Instaservice.customerAdditionalDetails = {
            "maidenName": "",
            "fatherName": "",
            "fatherFirstName": "",
            "fatherMiddleName": "",
            "fatherLastName": "",
            "spouseName": "",
            "motherMaidenName": "",
            "maritalStatus": "",
            "annualIncome": "",
            "occupation": "",
            "subOccupation": "",
            "religion": "",
            "education": "",
            "cityOfBirth": "",
            "countryOfBirth": "",
            "nationality":"",
            "nationalityID":"",
            "citizenship":"",
            "citizenshipID":"",
            "motherFirstname":"",
            "motherMiddlename":"",
            "motherLastname":"",
            "motherTitle":"",
            "motherTitleCode":"",
            "fatherTitle":"",
            "fatherTitleCode":"",
            "category":""
        }

        Instaservice.onScanAadhaar = {
            uid: ""
        }

        Instaservice.panDetails = {
            firstName: "",
            lastName:""
        }

        Instaservice.mapCoords = {
            latitude:'',
            longitude:''
        }

        Instaservice.mapGPS = [];

        Instaservice.debitCardDetails = {
            "firstName": '',
            "lastName": ''
        }

        Instaservice.selectByGPS = [];
        Instaservice.locateByGPS = [];

        Instaservice.customerCorrespondenceAddress = {
            address1: "",
            address2: "",
            state: "",
            stateCode: "",
            city: "",
            cityCode: "",
            pincode: "",
            isAadharScanned: false,
            locality: "",
            district:"",
            distCode:"",
            subdistrict:"",
            subdistCode:"",
            village:"",
            validity:'',
            villageCode:""
        }

        Instaservice.customerManualEntryDetails = {
            aadharNumber: "",
            firstName: "",
            lastName: "",
            middleName: "",
            fullName: "",
            gender: "",
            genderCode:"",
            title: "",
            titleCode:"",
            dob: "",
            address1: "",
            address2: "",
            city: "",
            cityCode: "",
            state: "",
            stateCode: "",
            pincode: "",
            isAadharScanned: false,
            locality: "",
            addressLine1: "",
            addressLine2: ""

        }

        Instaservice.customerAadhaarCardDetails = {
            uid: "",
            name: "",
            firstName: "",
            middleName: "",
            lastName: "",
            gender: "",
            genderCode:"",
            title: "",
            titleCode:"",
            yob: "",
            co: "",
            house: "",
            street: "",
            lm: "",
            loc: "",
            vtc: "",
            po: "",
            dist: "",
            district:"",
            distCode:"",
            cityCode:"",
            subdist: "",
            subdistCode:"",
            village:"",
            villageCode:"",
            state: "",
            stateCode:"",
            pc: "",
            dob: "",
            isAadharScanned: false,
            locality: "",
            addressLine1: "",
            addressLine2: "",
            aadharNewEntry:false
        }

        Instaservice.nomineeAadhaarCardDetails = {
            uid: "",
            name: "",
            gender: "",
            yob: "",
            co: "",
            house: "",
            street: "",
            lm: "",
            loc: "",
            vtc: "",
            po: "",
            dist: "",
            distCode:"",
            subdist: "",
            state: "",
            stateCode: "",
            pc: "",
            dob: "",
            relationship: "",
            guardianName: "",
            guardianAge:"",
            age: "",
            address1: "",
            address2: ""
        }

        Instaservice.activeAdditionalDetails = {

        }

        Instaservice.optionalAdditionalDetails = {
            category : "",
            categoryCode : "",
            numberOfDependents : "",
            netWorth : "",
            organisationName : "",
            designation : "",
            natureOfBuisness : "",
            personalDisability : "",
            perosonalDisabiltyCode: "",
            alternateMobileNo : "",
            residentialTelePhone : "",
            officeTelePhone : ""
          }

        Instaservice.selectedBranch = {
            branchname: "",
            branchaddress: ""
        }

        Instaservice.nominee = {
            uid: '',
            name: '',
            firstName: '',
            middleName: '',
            lastName: '',
            relationship: '',
            guardianName: '',
            guardianAge:'',
            age: '',
            address1: '',
            address2: '',
            pincode: '',
            dob: '',
            city: '',
            cityCode: '',
            state: '',
            stateCode: '',
            guardianAddressFlag: ''
        }

        Instaservice.branches = [];

        Instaservice.nomineeGuardianDetails = {
            address1: '',
            address2: '',
            pincode: '',
            city: '',
            cityCode: '',
            state: '',
            stateCode: '',
            locality: '',
            guardianConsent:'',
            guardianNewAddressEntry:false
        }

        Instaservice.direction = {
            latitude: '',
            longitude: '',
            branchname: '',
            address: '',
            state: ''
        }

        Instaservice.aadhaarManualPermanentAddress = {
            address1: "",
            address2: "",
            state: "",
            stateCode: "",
            city: "",
            cityCode:"",
            pincode: "",
            isAadharScanned: false,
            locality: ""
        }

        Instaservice.aadhaarManualCorrespondenceAddress = {
            address1: "",
            address2: "",
            state: "",
            stateCode: "",
            city: "",
            cityCode: "",
            pincode: "",
            isAadharScanned: false,
            locality: ""
        }

        Instaservice.localityNav = "";
        Instaservice.isNomineeAddress1Changed = false;
        Instaservice.isNomineeAddress2Changed = false;
        Instaservice.nomineeNav = "";
        Instaservice.isNomineeScanned = false;
        Instaservice.localityNextDisable = "";
        Instaservice.isResumeJourney = false;
        Instaservice.isAadharManualEntry = false;
        Instaservice.aadharAuthorizeFlag = false;
        Instaservice.cardReadyForCollection = "";
        Instaservice.isCustManualCorresChkBox = false;
        Instaservice.fatcaFlag = false;
        Instaservice.vkycProcessConsent= false;
        Instaservice.panCharMismatchDeclaration = false;
        Instaservice.termsAndConditionsFlag = false;
        Instaservice.employerNotListed = false;
        Instaservice.literateFlag = false;
        Instaservice.productOfferingFlag = true;
        Instaservice.homeBranchLocalityCity = "";
        Instaservice.homeBranchLocalityId = "";
        Instaservice.homeBranchGpsId = "";
        Instaservice.picId = '';
        Instaservice.salaryDocId = '';
        Instaservice.appPassword = '';
        Instaservice.cifNumber = '';
        Instaservice.acNumber = '';
        Instaservice.debitNumber = '';
        Instaservice.tncOtpValue = '';


        Instaservice.maritalStatusList = [];

        Instaservice.getIdByValue = function(obj, selectedValue) {
            var selectedId;
            for (var i = 0; i < obj.length; i++) {
                if (obj[i].description == selectedValue) {
                    selectedId = obj[i].value;
                }
            }
            return selectedId;
        }

        Instaservice.getValueById = function(obj, selectedId) {
            var selectedValue;
            for (var i = 0; i < obj.length; i++) {
                if (obj[i].value == selectedId) {
                    selectedValue = obj[i].description;
                }
            }
            return selectedValue;
        }

        //Method to check null / undefined values and append commas
        Instaservice.nullCheck = function(value) {
            var checkedVal = "";
            if (value != undefined && value != "") {
                checkedVal = value + ', ';
            }
            return checkedVal;
        }

        //Method to check for html tags
        Instaservice.checkHtmlTags = function(data) {
            var validData;
            if ((/<(.|\n)*?>/g).test(data) == false) {
                validData = data;
            } else {
                validData = '';
            }
            return validData;
        }

        //Method to pass regular expression and values for secured data
        Instaservice.checkSecuredData = function(regex, value) {
            var validValue;
            if (!utilityService.isUndefined(value)) {
                if (regex.test(value) == true) {
                    validValue = value;
                }
            } else {
                validValue = '';
            }
            return validValue;
        }

        /* ----------Click on cross icon - reset all data and redirect to homepage-------------*/
        Instaservice.homeNav = function() {
            Instaservice.customerManualEntryDetails = {
                aadharNumber: "",
                firstName: "",
                lastName: "",
                middleName: "",
                fullName: "",
                gender: "",
                genderCode:"",
                title: "",
                titleCode:"",
                dob: "",
                address1: "",
                address2: "",
                city: "",
                cityCode: "",
                state: "",
                stateCode: "",
                pincode: "",
                isAadharScanned: false,
                locality: "",
                addressLine1: "",
                addressLine2: ""

            }
            Instaservice.tncOtpValue = '';
            Instaservice.branches = [];
            Instaservice.customer.photo = "";
            Instaservice.picId = '';

            Instaservice.nomineeGuardianDetails = {
                address1: '',
                address2: '',
                pincode: '',
                city: '',
                cityCode: '',
                state: '',
                stateCode: '',
                locality: '',
                guardianNewAddressEntry:false
            }

            Instaservice.direction = {
                latitude: '',
                longitude: '',
                branchname: '',
                address: '',
                state: ''
            }

            Instaservice.nominee = {
                uid: '',
                name: '',
                firstName: '',
                middleName: '',
                lastName: '',
                relationship: '',
                guardianName: '',
                guardianAge:'',
                age: '',
                address1: '',
                address2: '',
                pincode: '',
                dob: '',
                city: '',
                cityCode: '',
                state: '',
                stateCode: '',
                guardianAddressFlag: ''
            }

            Instaservice.customer = {
                aadharNumber: '',
                title: '',
                name: '',
                gender: '',
                dateOfYear: '',
                address: '',
                pincode: '',
                city: '',
                state: '',
                emailId: '',
                mobileNo: '',
                panNumber: '',
                lotusId: '1234',
                image: 'abc',
                deviceUid: '',
                deviceOS: '',
                referenceCode: '',
                photo: '',
                guardian: '',
                latitude: '',
                longitude: '',
                encodephoto: ''
            }

            Instaservice.customerAdditionalDetails = {
                "maidenName": "",
                "fatherName": "",
                "fatherFirstName": "",
                "fatherMiddleName": "",
                "fatherLastName": "",
                "spouseName": "",
                "motherMaidenName": "",
                "maritalStatus": "",
                "annualIncome": "",
                "annualIncomeValue": "",
                "occupation": "",
                "subOccupation": "",
                "religion": "",
                "education": "",
                "cityOfBirth": "",
                "countryOfBirth": "",
                "nationality":"",
                "nationalityID":"",
                "citizenship":"",
                "citizenshipID":"",
                "motherFirstname":"",
                "motherMiddlename":"",
                "motherLastname":"",
                "motherTitle":"",
                "motherTitleCode":"",
                "fatherTitle":"",
                "fatherTitleCode":""
            }

            Instaservice.customerCorrespondenceAddress = {
                address1: "",
                address2: "",
                state: "",
                stateCode: "",
                city: "",
                cityCode: "",
                pincode: "",
                isAadhaarScanned: false,
                locality: "",
                district:"",
                distCode:"",
                subdistCode:"",
                subdistrict:"",
                validity:"",
                village:"",
                villageCode:""
            }

            Instaservice.onScanAadhaar = {
                uid: ""
            }

            Instaservice.panDetails = {
                firstName: "",
                lastName:""
            }

            Instaservice.customerAadhaarCardDetails = {
                uid: "",
                name: "",
                firstName: "",
                middleName: "",
                lastName: "",
                gender: "",
                genderCode:"",
                title: "",
                titleCode:"",
                yob: "",
                co: "",
                house: "",
                street: "",
                lm: "",
                loc: "",
                vtc: "",
                po: "",
                dist: "",
                distCode:"",
                cityCode:"",
                subdist: "",
                subdistCode:"",
                village:"",
                villageCode:"",
                state: "",
                stateCode:"",
                pc: "",
                dob: "",
                isAadharScanned: false,
                locality: "",
                addressLine1: "",
                addressLine2: "",
                photo:"",
                aadharNewEntry:false
            }

            Instaservice.nomineeAadhaarCardDetails = {
                uid: "",
                name: "",
                gender: "",
                yob: "",
                co: "",
                house: "",
                street: "",
                lm: "",
                loc: "",
                vtc: "",
                po: "",
                dist: "",
                subdist: "",
                state: "",
                pc: "",
                dob: "",
                relationship: "",
                guardianName: "",
                guardianAge:'',
                age: "",
                address1: "",
                address2: ""
            }

            Instaservice.activeAdditionalDetails = {

            }

            Instaservice.selectedBranch = {
                branchname: "",
                branchaddress: ""
            }
            Instaservice.aadhaarManualPermanentAddress = {
                address1: "",
                address2: "",
                state: "",
                stateCode: "",
                city: "",
                cityCode: "",
                pincode: "",
                isAadharScanned: false,
                locality: ""
            }

            Instaservice.aadhaarManualCorrespondenceAddress = {
                address1: "",
                address2: "",
                state: "",
                stateCode: "",
                city: "",
                cityCode:"",
                pincode: "",
                isAadharScanned: false,
                locality: ""
            }

            Instaservice.debitCardDetails = {
                firstName: "",
                lastName: ""
            }

            Instaservice.localityNav = "";
            Instaservice.isNomineeAddress1Changed = false;
            Instaservice.isNomineeAddress2Changed = false;
            Instaservice.nomineeNav = "";
            Instaservice.isNomineeScanned = false;
            Instaservice.localityNextDisable = "";
            Instaservice.isResumeJourney = false;
            Instaservice.isAadharManualEntry = false;
            Instaservice.aadharAuthorizeFlag = false;
            Instaservice.cardReadyForCollection = "";
            Instaservice.isCustManualCorresChkBox = false;
            Instaservice.fatcaFlag = false;
            Instaservice.vkycProcessConsent = false;
            Instaservice.panCharMismatchDeclaration = false;
            Instaservice.termsAndConditionsFlag = false;
            Instaservice.employerNotListed = false;
            Instaservice.literateFlag = false;
            Instaservice.productOfferingFlag = true;
            Instaservice.homeBranchLocalityCity = "";
            Instaservice.homeBranchLocalityId = "";
            Instaservice.homeBranchGpsId = "";
            Instaservice.appPassword = "";
            Instaservice.cifNumber = "";
            Instaservice.acNumber = '';
            Instaservice.debitNumber = '';
            $state.go('menu.selectSim');
            loggedInUserService.logoutAOUser();
            //$state.go('menu.homePage');
        }


        //Common method for resuming the data in resume/omnichannel/dedupe journey
        Instaservice.getResumeDocument = function(customerDetails) {
            var addressCount = 0;
            Instaservice.customer.panNumber = utilityService.getValue(customerDetails.personalDetails.pan);
            Instaservice.cifNumber = utilityService.getValue(customerDetails.personalDetails.cifStatus);
            Instaservice.fatcaFlag = customerDetails.fatcaFlag;
			Instaservice.fatcaResumeStatus = customerDetails.fatcaResumeStatus ? customerDetails.fatcaResumeStatus : "";
            Instaservice.aadharAuthorizeFlag = customerDetails.aadharAuthorizeFlag;
            Instaservice.vkycProcessConsent = customerDetails.vkycProcessConsent;
            Instaservice.panCharMismatchDeclaration = customerDetails.panCharMismatchDeclaration;
            Instaservice.customer.mobileNo = utilityService.getValue(customerDetails.personalDetails.mobileNumber);
            //Instaservice.appPassword = utilityService.getValue(customerDetails.auth.password);
            Instaservice.customer.emailId = utilityService.getValue(customerDetails.personalDetails.emailId);
            Instaservice.employerNotListed = customerDetails.employerNotListed;
            Instaservice.literateFlag = customerDetails.literateFlag;
            Instaservice.vkycStatus = utilityService.getValue(customerDetails.status);
            Instaservice.cifNumber = utilityService.getValue(customerDetails.cifNumber);
            Instaservice.acctNo = utilityService.getValue(customerDetails.acctNo);
            Instaservice.tokenNumber = utilityService.getValue(customerDetails.refNo);
            Instaservice.journeyType = utilityService.getValue(customerDetails.journeyType);

            if (!utilityService.isUndefined(customerDetails.vkyc)) {
                Instaservice.optionalAdditionalDetails.categoryText = utilityService.getValue(customerDetails.vkyc.category);
                Instaservice.optionalAdditionalDetails.categoryCode = utilityService.getValue(customerDetails.vkyc.categoryCode);
                Instaservice.optionalAdditionalDetails.numberOfDependents = utilityService.getValue(customerDetails.vkyc.numberOfDependents);
                Instaservice.optionalAdditionalDetails.netWorth = utilityService.getValue(customerDetails.vkyc.netWorth);
                Instaservice.optionalAdditionalDetails.organisationName = utilityService.getValue(customerDetails.vkyc.organisationName);
                Instaservice.optionalAdditionalDetails.designation = utilityService.getValue(customerDetails.vkyc.designation);
                Instaservice.optionalAdditionalDetails.natureOfBuisness = utilityService.getValue(customerDetails.vkyc.natureOfBuisness);
                Instaservice.optionalAdditionalDetails.personalDisability = utilityService.getValue(customerDetails.vkyc.personalDisability);
                Instaservice.optionalAdditionalDetails.perosonalDisabiltyCode = utilityService.getValue(customerDetails.vkyc.perosonalDisabiltyCode);
                Instaservice.optionalAdditionalDetails.alternateMobileNo = utilityService.getValue(customerDetails.vkyc.alternateMobileNo);
                Instaservice.optionalAdditionalDetails.residentialTelePhone = utilityService.getValue(customerDetails.vkyc.residentialTelePhone);
                Instaservice.optionalAdditionalDetails.officeTelePhone = utilityService.getValue(customerDetails.vkyc.officeTelePhone);

               
                Instaservice.correspondenceCheckStatus = customerDetails.isCurrentAddressDifferent;
                Instaservice.correspondenceFlag = customerDetails.correspondenceFlag;
                Instaservice.undertakingFlag = customerDetails.undertakingFlag;
                Instaservice.consentFlag = customerDetails.consentFlag;

                Instaservice.vkycBranchCode = customerDetails.vkyc.vkycBranchCode;

                Instaservice.customerAdditionalDetails.citizenshipDeclarationFlag = customerDetails.vkyc.citizenshipDeclarationFlag;

            }

            if (!utilityService.isUndefined(customerDetails.additionalDetails)) {
                
                Instaservice.customerAdditionalDetails.annualIncome = utilityService.getValue(customerDetails.additionalDetails.annualIncome);
                Instaservice.activeAdditionalDetails.income = utilityService.getValue(customerDetails.additionalDetails.annualIncomeCode);
                Instaservice.customerAdditionalDetails.education = utilityService.getValue(customerDetails.additionalDetails.education);
                Instaservice.activeAdditionalDetails.education = utilityService.getValue(customerDetails.additionalDetails.educationCode);
                Instaservice.customerAdditionalDetails.maritalStatus = utilityService.getValue(customerDetails.additionalDetails.maritalStatus);
                Instaservice.activeAdditionalDetails.marital = utilityService.getValue(customerDetails.additionalDetails.maritalStatusCode);
                Instaservice.customerAdditionalDetails.annualIncomeValue = utilityService.getValue(customerDetails.additionalDetails.annualIncomeValue);
                Instaservice.customerAdditionalDetails.occupation = utilityService.getValue(customerDetails.additionalDetails.occupation);
                Instaservice.activeAdditionalDetails.occupation = utilityService.getValue(customerDetails.additionalDetails.occupationCode);
                Instaservice.customerAdditionalDetails.religion = utilityService.getValue(customerDetails.additionalDetails.religion);
                Instaservice.activeAdditionalDetails.religion = utilityService.getValue(customerDetails.additionalDetails.religionCode);
                Instaservice.customerAdditionalDetails.category = utilityService.getValue(customerDetails.additionalDetails.category);
                Instaservice.activeAdditionalDetails.category = utilityService.getValue(customerDetails.additionalDetails.categoryCode);
                Instaservice.customerAdditionalDetails.subOccupation = utilityService.getValue(customerDetails.additionalDetails.subOccupation);
                Instaservice.activeAdditionalDetails.suboccupation = utilityService.getValue(customerDetails.additionalDetails.subOccupationCode);
                
                Instaservice.customerAdditionalDetails.fatherFirstName = utilityService.getValue(customerDetails.additionalDetails.fatherFirstName);
                Instaservice.customerAdditionalDetails.fatherMiddleName = utilityService.getValue(customerDetails.additionalDetails.fatherMiddleName);
                Instaservice.customerAdditionalDetails.fatherLastName = utilityService.getValue(customerDetails.additionalDetails.fatherLastName);
                Instaservice.customerAdditionalDetails.spouseName = utilityService.getValue(customerDetails.additionalDetails.spouseName);
                Instaservice.customerAdditionalDetails.motherMaidenName = utilityService.getValue(customerDetails.additionalDetails.motherMaidenName);
                Instaservice.customerAdditionalDetails.maidenName = utilityService.getValue(customerDetails.additionalDetails.maidenName);
                Instaservice.customerAdditionalDetails.motherFirstname = utilityService.getValue(customerDetails.additionalDetails.motherFirstName);
                Instaservice.customerAdditionalDetails.motherMiddlename = utilityService.getValue(customerDetails.additionalDetails.motherMiddleName);
                Instaservice.customerAdditionalDetails.motherLastname = utilityService.getValue(customerDetails.additionalDetails.motherLastName);
                Instaservice.customerAdditionalDetails.motherTitle = utilityService.getValue(customerDetails.additionalDetails.motherTitle);
                Instaservice.customerAdditionalDetails.motherTitleCode = utilityService.getValue(customerDetails.additionalDetails.motherTitleCode);
                Instaservice.customerAdditionalDetails.fatherTitle = utilityService.getValue(customerDetails.additionalDetails.fatherTitle);
                Instaservice.customerAdditionalDetails.fatherTitleCode = utilityService.getValue(customerDetails.additionalDetails.fatherTitleCode);
            }

            if(customerDetails.personalDetails.isAadhaarScanned == true){
                Instaservice.customerAadhaarCardDetails.title = utilityService.getValue(customerDetails.personalDetails.title);
                Instaservice.customerAadhaarCardDetails.titleCode = utilityService.getValue(customerDetails.personalDetails.titleCode);
                Instaservice.customerAadhaarCardDetails.name = utilityService.getValue(customerDetails.personalDetails.name);
                Instaservice.customerAadhaarCardDetails.firstName = utilityService.getValue(customerDetails.personalDetails.firstName);
                Instaservice.customerAadhaarCardDetails.middleName = utilityService.getValue(customerDetails.personalDetails.middleName);
                Instaservice.customerAadhaarCardDetails.lastName = utilityService.getValue(customerDetails.personalDetails.lastName);
                Instaservice.customerAadhaarCardDetails.gender = utilityService.getValue(customerDetails.personalDetails.gender);
                Instaservice.customerAadhaarCardDetails.genderCode = utilityService.getValue(customerDetails.personalDetails.genderCode);
                Instaservice.customerAadhaarCardDetails.uid = utilityService.getValue(customerDetails.personalDetails.uid);
                Instaservice.customerAadhaarCardDetails.dob = utilityService.getValue(customerDetails.personalDetails.dob);
                Instaservice.customerAdditionalDetails.cityOfBirth = utilityService.getValue(customerDetails.additionalDetails.cityOfBirth);
                Instaservice.customerAdditionalDetails.countryOfBirth = utilityService.getValue(customerDetails.additionalDetails.countryOfBirth);
                Instaservice.customerAdditionalDetails.nationality = utilityService.getValue(customerDetails.personalDetails.nationality);
                Instaservice.customerAdditionalDetails.nationalityID = utilityService.getValue(customerDetails.personalDetails.nationalityCode);
                Instaservice.customerAdditionalDetails.citizenship = utilityService.getValue(customerDetails.personalDetails.citizenship);
                Instaservice.customerAdditionalDetails.citizenshipID = utilityService.getValue(customerDetails.personalDetails.citizenshipCode);
		Instaservice.customerAadhaarCardDetails.vid = utilityService.getValue(customerDetails.personalDetails.vid);
            }


            

            if (!utilityService.isUndefined(customerDetails.personalDetails.address) && customerDetails.personalDetails.address.length > 0) {
                for (var i = 0; i < customerDetails.personalDetails.address.length; i++) {
                   // if (customerDetails.personalDetails.isAadhaarScanned == true) {
                        Instaservice.correspondenceCheckStatus = customerDetails.personalDetails.scannedCorrespondenceAddFlag;
                        if (customerDetails.personalDetails.address[i].type == "CORRESPONDENCE") {
                            Instaservice.customerCorrespondenceAddress.address1 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine1);
                            Instaservice.customerCorrespondenceAddress.address2 = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine2);
                            Instaservice.customerCorrespondenceAddress.pincode = utilityService.getValue(customerDetails.personalDetails.address[i].pincode);
                            Instaservice.customerCorrespondenceAddress.city = utilityService.getValue(customerDetails.personalDetails.address[i].city);
                            Instaservice.customerCorrespondenceAddress.state = utilityService.getValue(customerDetails.personalDetails.address[i].state);
                            Instaservice.customerCorrespondenceAddress.cityCode = utilityService.getValue(customerDetails.personalDetails.address[i].cityCode);
                            Instaservice.customerCorrespondenceAddress.stateCode = utilityService.getValue(customerDetails.personalDetails.address[i].stateCode);
                            Instaservice.customerCorrespondenceAddress.locality = utilityService.getValue(customerDetails.personalDetails.address[i].locality);
                             Instaservice.customerCorrespondenceAddress.district = utilityService.getValue(customerDetails.personalDetails.address[i].district);
                            Instaservice.customerCorrespondenceAddress.distCode = utilityService.getValue(customerDetails.personalDetails.address[i].districtCode);
                             Instaservice.customerCorrespondenceAddress.subdistrict = utilityService.getValue(customerDetails.personalDetails.address[i].subDist);
                              Instaservice.customerCorrespondenceAddress.validity = utilityService.getValue(customerDetails.personalDetails.address[i].validity);
                            Instaservice.customerCorrespondenceAddress.subdistCode = utilityService.getValue(customerDetails.personalDetails.address[i].subDistrictCode);
                             Instaservice.customerCorrespondenceAddress.village = utilityService.getValue(customerDetails.personalDetails.address[i].village);
                            Instaservice.customerCorrespondenceAddress.villageCode = utilityService.getValue(customerDetails.personalDetails.address[i].villageCode);
                            addressCount++;
                        } else if (customerDetails.personalDetails.address[i].type == "PERMANENT") {
                            Instaservice.customerAadhaarCardDetails.house = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine1);
                            Instaservice.customerAadhaarCardDetails.street = utilityService.getValue(customerDetails.personalDetails.address[i].addressLine2);
                            Instaservice.customerAadhaarCardDetails.dist = utilityService.getValue(customerDetails.personalDetails.address[i].city);
                            Instaservice.customerAadhaarCardDetails.state = utilityService.getValue(customerDetails.personalDetails.address[i].state);
                            Instaservice.customerAadhaarCardDetails.distCode = utilityService.getValue(customerDetails.personalDetails.address[i].cityCode);
                            Instaservice.customerAadhaarCardDetails.stateCode = utilityService.getValue(customerDetails.personalDetails.address[i].stateCode);
                            Instaservice.customerAadhaarCardDetails.pc = utilityService.getValue(customerDetails.personalDetails.address[i].pincode);
                            Instaservice.customerAadhaarCardDetails.loc = utilityService.getValue(customerDetails.personalDetails.address[i].locality);
                            Instaservice.customerAadhaarCardDetails.district = utilityService.getValue(customerDetails.personalDetails.address[i].district);
                            Instaservice.customerAadhaarCardDetails.subdist = utilityService.getValue(customerDetails.personalDetails.address[i].subDist);
                            Instaservice.customerAadhaarCardDetails.village = utilityService.getValue(customerDetails.personalDetails.address[i].village);
                            Instaservice.customerAadhaarCardDetails.distCode = utilityService.getValue(customerDetails.personalDetails.address[i].districtCode);
                            Instaservice.customerAadhaarCardDetails.subdistCode = utilityService.getValue(customerDetails.personalDetails.address[i].subDistrictCode);
                            Instaservice.customerAadhaarCardDetails.villageCode = utilityService.getValue(customerDetails.personalDetails.address[i].villageCode);
                        }
                        Instaservice.isAadharManualEntry = false;
                        Instaservice.customerCorrespondenceAddress.isAadhaarScanned = true;
                     

                   
                }
            }
             

            if (!utilityService.isUndefined(customerDetails.doc) && customerDetails.doc.length > 0) {
                for (var i = 0; i < customerDetails.doc.length; i++) {
                    if (customerDetails.doc[i].docType.toLowerCase() == "photograph") {
                        Instaservice.picId = customerDetails.doc[i].docRef;
                    }
                    if (customerDetails.doc[i].docType.toLowerCase() == "employment proof") {
                        Instaservice.salaryDocId = customerDetails.doc[i].docRef;
                    }
                }
            }

            if (!utilityService.isUndefined(customerDetails.nominees) && customerDetails.nominees.length > 0) {
                Instaservice.isNomineeScanned = customerDetails.nominees[0].isNomineeAadhaarScanned;

                if (Instaservice.isNomineeScanned === true) {
                    Instaservice.nomineeAadhaarCardDetails.uid = utilityService.getValue(customerDetails.nominees[0].uid);
                    Instaservice.nomineeAadhaarCardDetails.name = utilityService.getValue(customerDetails.nominees[0].name);
                    Instaservice.nomineeAadhaarCardDetails.relationship = utilityService.getValue(customerDetails.nominees[0].relationship);
                    Instaservice.nomineeAadhaarCardDetails.age = utilityService.getValue(customerDetails.nominees[0].age);
                    Instaservice.nomineeAadhaarCardDetails.dob = utilityService.getValue(customerDetails.nominees[0].dob);
                    //Instaservice.nomineeAadhaarCardDetails.guardianName = utilityService.getValue(customerDetails.nominees[0].guardianName);
                    Instaservice.nomineeAadhaarCardDetails.sameAsApplicantAddress = customerDetails.nominees[0].sameAsApplicantAddress;
                    if (!utilityService.isUndefined(customerDetails.nominees[0].address)) {
                        Instaservice.nomineeAadhaarCardDetails.address1 = utilityService.getValue(customerDetails.nominees[0].address.addressLine1);
                        Instaservice.nomineeAadhaarCardDetails.address2 = utilityService.getValue(customerDetails.nominees[0].address.addressLine2);
                        Instaservice.nomineeAadhaarCardDetails.pc = utilityService.getValue(customerDetails.nominees[0].address.pincode);
                        Instaservice.nomineeAadhaarCardDetails.dist = utilityService.getValue(customerDetails.nominees[0].address.city);
                        Instaservice.nomineeAadhaarCardDetails.state = utilityService.getValue(customerDetails.nominees[0].address.state);
                        Instaservice.nomineeAadhaarCardDetails.distCode = utilityService.getValue(customerDetails.nominees[0].address.cityCode);
                        Instaservice.nomineeAadhaarCardDetails.stateCode = utilityService.getValue(customerDetails.nominees[0].address.stateCode);
                    }
                    if (!utilityService.isUndefined(customerDetails.nominees[0].guardian)){
                        Instaservice.nomineeAadhaarCardDetails.guardianAge = utilityService.getValue(customerDetails.nominees[0].guardian.guardianAge);
                        Instaservice.nomineeAadhaarCardDetails.guardianName = utilityService.getValue(customerDetails.nominees[0].guardian.name);
                    }

                } else if (Instaservice.isNomineeScanned === false) {
                    Instaservice.nominee.name = utilityService.getValue(customerDetails.nominees[0].name);
                    Instaservice.nominee.relationship = utilityService.getValue(customerDetails.nominees[0].relationship);
                    Instaservice.nominee.age = utilityService.getValue(customerDetails.nominees[0].age);
                    Instaservice.nominee.sameAsApplicantAddress = customerDetails.nominees[0].sameAsApplicantAddress;
                    //Instaservice.nominee.guardianName = utilityService.getValue(customerDetails.nominees[0].guardianName);
                    if (!utilityService.isUndefined(customerDetails.nominees[0].address)) {
                        Instaservice.nominee.address1 = utilityService.getValue(customerDetails.nominees[0].address.addressLine1);
                        Instaservice.nominee.address2 = utilityService.getValue(customerDetails.nominees[0].address.addressLine2);
                        Instaservice.nominee.pincode = utilityService.getValue(customerDetails.nominees[0].address.pincode);
                        Instaservice.nominee.city = utilityService.getValue(customerDetails.nominees[0].address.city);
                        Instaservice.nominee.state = utilityService.getValue(customerDetails.nominees[0].address.state);
                        Instaservice.nominee.cityCode = utilityService.getValue(customerDetails.nominees[0].address.cityCode);
                        Instaservice.nominee.stateCode = utilityService.getValue(customerDetails.nominees[0].address.stateCode);
                    }

                    Instaservice.nominee.dob = utilityService.getValue(customerDetails.nominees[0].dob);
                    if (!utilityService.isUndefined(customerDetails.nominees[0].guardian)){
                        Instaservice.nominee.guardianAge = utilityService.getValue(customerDetails.nominees[0].guardian.guardianAge);
                        Instaservice.nominee.guardianName = utilityService.getValue(customerDetails.nominees[0].guardian.name);
                    }
                }

                if (!utilityService.isUndefined(customerDetails.nominees[0].guardian)) {
                    Instaservice.nominee.guardianAddressFlag = utilityService.getValue(customerDetails.nominees[0].guardian.guardianAddressFlag);
                    if (!utilityService.isUndefined(Instaservice.nominee.guardianAddressFlag)) {
                        Instaservice.nomineeGuardianDetails.address1 = utilityService.getValue(customerDetails.nominees[0].guardian.address.addressLine1);
                        Instaservice.nomineeGuardianDetails.address2 = utilityService.getValue(customerDetails.nominees[0].guardian.address.addressLine2);
                        Instaservice.nomineeGuardianDetails.locality = utilityService.getValue(customerDetails.nominees[0].guardian.address.locality);
                        Instaservice.nomineeGuardianDetails.city = utilityService.getValue(customerDetails.nominees[0].guardian.address.city);
                        Instaservice.nomineeGuardianDetails.state = utilityService.getValue(customerDetails.nominees[0].guardian.address.state);
                        Instaservice.nomineeGuardianDetails.cityCode = utilityService.getValue(customerDetails.nominees[0].guardian.address.cityCode);
                        Instaservice.nomineeGuardianDetails.stateCode = utilityService.getValue(customerDetails.nominees[0].guardian.address.stateCode);
                        Instaservice.nomineeGuardianDetails.pincode = utilityService.getValue(customerDetails.nominees[0].guardian.address.pincode);
                        Instaservice.nomineeGuardianDetails.guardianConsent = customerDetails.nominees[0].guardian.guardianConsent;
                       
                    }
                }
            }
            if (!utilityService.isUndefined(customerDetails.homeBranch)) {
                Instaservice.homeBranchLocalityCity = utilityService.getValue(customerDetails.homeBranch.city);
                Instaservice.homeBranchLocalityId = utilityService.getValue(customerDetails.homeBranch.branchId);
            }

            if (!utilityService.isUndefined(Instaservice.homeBranchLocalityCity)) {
                Instaservice.isGpsClicked = false;
            } else if (utilityService.isUndefined(Instaservice.homeBranchLocalityCity)) {
                Instaservice.isGpsClicked = true;
            }

            Instaservice.cardReadyForCollection = utilityService.getValue(customerDetails.cardReadyForCollection);
            Instaservice.debitCardDetails.firstName = utilityService.getValue(customerDetails.debitCardFirstName);
            Instaservice.debitCardDetails.lastName = utilityService.getValue(customerDetails.debitCardLastName);
            Instaservice.customer.referenceCode = utilityService.getValue(customerDetails.refNo);
            Instaservice.termsAndConditionsFlag = customerDetails.termsAndConditionsFlag;
            //Instaservice.productOfferingFlag = customerDetails.productOfferingFlag;
        }

        Instaservice.getCommonId = function(commonId, flag){
            if(commonId == "OIOO" || commonId == "DebitCard" || commonId == "tncOtp"){
                Instaservice.productOfferingFlag = flag;
            }
        }
		
		 Instaservice.setDateFormatDDMMYYY = function(data) {
            if(data){
            	data = data.replace(/-/g, '/');
            	data =data.replace(/\:/g, '/');
            	data =data.replace(/\./g, '/');
            	
            	data =data.replace(/ /g, '');
            	data =data.replace(/Jan/g, '01');
            	data =data.replace(/Feb/g, '02');
            	data =data.replace(/Mar/g, '03');
            	data =data.replace(/Apr/g, '04');
            	data =data.replace(/May/g, '05');
            	data =data.replace(/Jun/g, '06');
            	data =data.replace(/Jul/g, '07');
            	data =data.replace(/Aug/g, '08');
            	data =data.replace(/Sep/g, '09');
            	data =data.replace(/Oct/g, '10');
            	data =data.replace(/Nov/g, '11');
            	data =data.replace(/Dec/g, '12');
            }
            return data;
        }
      
	Instaservice.setSecurityQuestion = [];
	Instaservice.isVID = false;
        return Instaservice;

    }
]);
