'use strict';

angularApp.service('instalocateBranchService',
    function($q, AdapterUtils, constantConfig) {
        var instalocateBranchService = this;
        instalocateBranchService.getLocateBranchContent = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.locateBranch, true).then(

                function(response) {
                    q.resolve(response.data.locateBranch);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return instalocateBranchService;
    });
