'use strict';

angularApp.service('instamapService',
    function($q, AdapterUtils, constantConfig) {

        var instamapService = this;

        instamapService.getBranchesForGeo = function(params) {

            var q = $q.defer(); 
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getBranchesForGeo + params.longitude + "&latitude=" + params.latitude, true).then(

                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return instamapService;
    });
