'use strict';

angularApp.service('instapanAuthoriseService',
    function($q, AdapterUtils, constantConfig) {
        var instapanAuthoriseService = this;
        instapanAuthoriseService.getAuthorizationDetails = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getPersonalDetailsConcent, true).then(

                function(response) {
                    q.resolve(response.data.personalDetails);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instapanAuthoriseService.setPanAuthorizeFlag = function(requestParams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.setPanAuthorizeFlag, requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return instapanAuthoriseService;
    });
