'use strict';

angularApp.controller('instakindlyNoteController', ["$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "instapanDetailsService",
    "instaService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "newToSbiService",
    "$ionicPopup",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        utilityService,
        instapanDetailsService,
        instaService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        newToSbiService,$ionicPopup) {

        var instakindNoteVm = this;

        function initPage() {
            instakindNoteVm.showBack = true;
            instakindNoteVm.showNext = true;
            instakindNoteVm.aofooter = true;
            instakindNoteVm.disableNext = true;
            instakindNoteVm.isChecked = false;
            instakindNoteVm.enable = true;
            instakindNoteVm.isChecked = instaService.panCharMismatchDeclaration;
            //instakindNoteVm.enable = instaService.enableBtnKin;
            

            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instakindNoteVm.okBtntext = translatedvalue;
            });
        }

        instakindNoteVm.authoriseUser = function () {
				
			if(instakindNoteVm.isChecked){
				instakindNoteVm.isChecked = true;
                instakindNoteVm.enable = false;
            }else{
				instakindNoteVm.isChecked = false;
                instakindNoteVm.enable = true;
			}
        }

        instakindNoteVm.goBacktoPrevious = function() {
           $state.go("menu.instaKit_panDetails");
        }


        instakindNoteVm.updateCifStatus = function() {
            instaService.panCharMismatchDeclaration = instakindNoteVm.isChecked;
            instakindNoteVm.panName =  instaService.panName;
            var params = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "personalDetails": {
                        "pan": instaService.customer.panNumber.toLowerCase(),
                        "panName": instakindNoteVm.panName,
                        "cifStatus": instaService.cifNumber
                    },
                        "commonId":$state.$current.data.commonId,
                        "panCharMismatchDeclaration": instaService.panCharMismatchDeclaration
                    }
                }
           
            
            instapanDetailsService.updateCif(params).then(function(response) {
               $state.go('menu.instaKit_aOLooksGreat');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        instakindNoteVm.goToNextPage = function(isValid) {
            //instaService.kindlyNoteCheck = instakindNoteVm.misMactchChecked; 
            //instaService.enableBtnKin = instakindNoteVm.enable;
            instakindNoteVm.updateCifStatus();
        } 


        instakindNoteVm.populateResumeData = function(){
		   if (instaService.isResumeJourney == true){
                instakindNoteVm.isChecked = instaService.panCharMismatchDeclaration;
                instakindNoteVm.authoriseUser();
                // if(instakindNoteVm.isChecked == true){
                //     instakindNoteVm.enable = false;
                // }else{
                //     instakindNoteVm.enable = true;
                // }
            }else{
                instaService.panCharMismatchDeclaration = instakindNoteVm.isChecked;
                if(instakindNoteVm.isChecked){
                    instakindNoteVm.enable = false;
                }
            }
		}
       

        $scope.goToHome = function() {
            instaService.homeNav();
        }

       

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
           instakindNoteVm.populateResumeData();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instakindNoteVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);
        });

        return this;
    }
]);
