'use strict';

angularApp.controller('instapersonalDetailsCAddressController', ["$state",
    "$scope",
    "$ionicHistory",
    "instaService",
    "instapdetailsCAddressService",
    "utilityService",
    "$translate",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "ionicDatePicker",
    "instapersonalDataService",

    function($state,
        $scope,
        $ionicHistory,
        instaService,
        instapdetailsCAddressService,
        utilityService,
        $translate,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        ionicDatePicker,
        instapersonalDataService) {

        var instapdetailsCAddressVm = this;
        instapdetailsCAddressService.saveForFuturCont = "Dear Customer, Kindly note that this address will be used for all future correspondences. For any update in address kindly visit your nearest branch."

        function initPage() {
            instapdetailsCAddressVm.showBack = true;
            instapdetailsCAddressVm.showNext = true;
            instapdetailsCAddressVm.disableNext = true;
            instapdetailsCAddressVm.aofooter = true;
            instapdetailsCAddressVm.disableCity = true;
            instapdetailsCAddressVm.disableState = true;
            instapdetailsCAddressVm.disableVillage = true;
            instapdetailsCAddressVm.disableDist = true;
            instapdetailsCAddressVm.disablesubDist = true;
            instapdetailsCAddressVm.showField = true;
           
           
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instapdetailsCAddressVm.okBtntext = translatedvalue;
            });
			
			$translate(['AO_OK_LABEL' , 'SUBDISTRICT_CONST' , 'VILLEGETOWN_CONST' ,'SELECT_DISTSUBDIST_AO','SELECTSTATE']).then(function(translatedValue) {
                    instapdetailsCAddressVm.okBtntext = translatedValue['AO_OK_LABEL'];
                    instapdetailsCAddressVm.distConstant = translatedValue['SUBDISTRICT_CONST'];
                    instapdetailsCAddressVm.villConstant = translatedValue['VILLEGETOWN_CONST'];
                    instapdetailsCAddressVm.distSelect = translatedValue['SELECT_DISTSUBDIST_AO'];
                    instapdetailsCAddressVm.stateConstant = translatedValue['SELECTSTATE'];
                });

                 
        }


        //date picker functions

         instapdetailsCAddressVm.disableEnavleNextButton = function () {
            instapdetailsCAddressVm.disableNext = false;
         }

          instapdetailsCAddressVm.openDatePickerValid = function () {
            if (!instapdetailsCAddressVm.addValidUpFlag) {
                ionicDatePicker.openDatePicker(instapdetailsCAddressVm.dateObjValid);
            }
        };

        
        instapdetailsCAddressVm.validDateFormat = function (isValid, monthOrDay) {
            var fullDate = instapdetailsCAddressVm.validMonth + '/' + instapdetailsCAddressVm.addValidUp + '/' + instapdetailsCAddressVm.validYear;
            var dobMonth = instapdetailsCAddressVm.validMonth;
            var dobDay = instapdetailsCAddressVm.addValidUp;
            var dobYr = instapdetailsCAddressVm.validYear;
            var fullDateInMilliSeconds = Date.parse(fullDate);
            var formattedDate = new Date();
            
            //var currDate = new Date();
            
            var curDateInMilliSeconds = new Date().getTime();
            formattedDate.setFullYear(dobYr, dobMonth - 1, dobDay);
            var months30 = ['04', '06', '09', '11', "4", "6", "9"];
            var monthIndex = months30.indexOf(dobMonth);

            // If entered date is greater than the current date
            if (fullDateInMilliSeconds < curDateInMilliSeconds) {
                instapdetailsCAddressVm.disableNext = true;
                instapdetailsCAddressVm.invalid = true;
                instapdetailsCAddressVm.properDate = false;
            }
            // Leap year validation
            else if (dobYr % 4 == 0 && (dobYr % 100 != 0 || dobYr % 400 == 0)) {
                if ((dobMonth == 2 && dobDay > 29) || (monthIndex != -1 && dobDay == 31)) {
                    instapdetailsCAddressVm.disableNext = true;
                    instapdetailsCAddressVm.invalid = true;
                    instapdetailsCAddressVm.properDate = false;
                } else {
                    instapdetailsCAddressVm.disableNext = !isValid;
                    instapdetailsCAddressVm.invalid = false;
                    instapdetailsCAddressVm.properDate = true;
                }
            } 
            
            if (instapdetailsCAddressVm.addValidUp < 10 && instapdetailsCAddressVm.addValidUp.length == 1) {
                instapdetailsCAddressVm.disableNext = true;
                instapdetailsCAddressVm.invalid = true;
                instapdetailsCAddressVm.properDate = false;
            }
            if (instapdetailsCAddressVm.validMonth < 10 && instapdetailsCAddressVm.validMonth.length == 1) {
                instapdetailsCAddressVm.disableNext = true;
                instapdetailsCAddressVm.invalid = true;
                instapdetailsCAddressVm.properDate = false;
            }
            return instapdetailsCAddressVm.properDate;
        }

        instapdetailsCAddressVm.goBacktoPrevious = function() {
            if (instaService.correspondenceCheckStatus == true) {
                $state.go("menu.instaKit_pdetailsAddress");
            }
        }

        $scope.$watch("instapdetailsCAddressVm.pdetailsCForm.$valid", function(value) {
            if (value === true) {
                instapdetailsCAddressVm.disableNext = false;
            } else {
                instapdetailsCAddressVm.disableNext = true;
            }
        });

        


        instapdetailsCAddressVm.goToNextPage = function() {
        	
                instaService.customerCorrespondenceAddress.address1 = instapdetailsCAddressVm.addressAboveData;
                instaService.customerCorrespondenceAddress.address2 = instapdetailsCAddressVm.addressBelowData;
                instaService.customerCorrespondenceAddress.pincode = instapdetailsCAddressVm.pincodeData;
                
                instaService.customerCorrespondenceAddress.district = instapdetailsCAddressVm.districtLabelData;
                instaService.customerCorrespondenceAddress.stateCode = instapdetailsCAddressVm.stateitemData;
                if(!utilityService.isUndefined(instapdetailsCAddressVm.stateList)){
                    for (var i = 0; i < instapdetailsCAddressVm.stateList.length; i++) {
                        if(instapdetailsCAddressVm.stateList[i].value == instaService.customerCorrespondenceAddress.stateCode){
                            instaService.customerCorrespondenceAddress.state = instapdetailsCAddressVm.stateList[i].description;
                        }                       
                    }
                }
               
                instaService.customerCorrespondenceAddress.validity = moment(instapdetailsCAddressVm.addValidUp).format("DD-MM-YYYY");
                instaService.correspondenceFlag = instapdetailsCAddressVm.correspondenceFlag;
                instaService.undertakingFlag = instapdetailsCAddressVm.undertakingFlag;
                instaService.consentFlag = instapdetailsCAddressVm.consentFlag;       
                
              
                instapdetailsCAddressVm.ifAadharScanAddressUpdate();
            
        }

        instapdetailsCAddressVm.ifAadharScanAddressUpdate = function() {
            var addressLineOne = instaService.customerCorrespondenceAddress.address1.length;
            var addressLineSecond = instaService.customerCorrespondenceAddress.address2.length;
             if (addressLineOne > 40 || addressLineSecond > 40) {
                var title = '';
                var template = '{{"MAX_CHAR_AADHAAR" | translate}}';
                var onTap = '';
                var buttontext = '<b>' + instapdetailsCAddressVm.okBtntext + '</b>';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
            } 
            else {
            var requestParams1 = {
                "id": instaService.customer.mobileNo,
                "data": {
                    "isCurrentAddressDifferent": instaService.correspondenceCheckStatus,
                    "correspondenceFlag": instaService.correspondenceFlag ? instaService.correspondenceFlag : false,
                    "undertakingFlag": instaService.undertakingFlag ? instaService.undertakingFlag : false,
                    "consentFlag": instaService.consentFlag ? instaService.consentFlag : false,
                    "personalDetails": {
                        "isAadhaarScanned": true,
                        "address": [{
                            "type": "CORRESPONDENCE", 
                            "addressLine1": instaService.customerCorrespondenceAddress.address1,
                            "addressLine2": instaService.customerCorrespondenceAddress.address2,
                            "pincode": instaService.customerCorrespondenceAddress.pincode,
                            
                            "state": instaService.customerCorrespondenceAddress.state,
                            "stateCode": instaService.customerCorrespondenceAddress.stateCode,
                           
                            "district":instaService.customerCorrespondenceAddress.district,
                           
                            "validity":instaService.customerCorrespondenceAddress.validity
                        }]
                    },
                    "commonId": $state.$current.data.commonId
                    }
                }

                instapdetailsCAddressService.updateCorrespondenceAddress(requestParams1).then(function(response) {
                    if (response.responseCode === constantConfig.successCode) {

                        instapersonalDataService.showAlertPopup("alert", instapdetailsCAddressService.saveForFuturCont, instapdetailsCAddressService.saveForFuturCont,
                        "menu.instaKit_panDetails", "OK", "", "", "");
                        
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        

        instapdetailsCAddressVm.populateResumeData = function() {
          if(instaService.correspondenceCheckStatus){
            instapdetailsCAddressVm.addressAboveData = instaService.customerCorrespondenceAddress.address1;
                instapdetailsCAddressVm.addressBelowData = instaService.customerCorrespondenceAddress.address2;
                instapdetailsCAddressVm.pincodeData = instaService.customerCorrespondenceAddress.pincode;
               
                instapdetailsCAddressVm.stateitemData = instaService.customerCorrespondenceAddress.stateCode;
                instapdetailsCAddressVm.addValidUp = instaService.customerCorrespondenceAddress.validity ? moment(instaService.customerCorrespondenceAddress.validity,'DD-MM-YYYY' ).format("DD MMM YYYY"):"";
                instapdetailsCAddressVm.districtLabelData = instaService.customerCorrespondenceAddress.district;
               
                instapdetailsCAddressVm.correspondenceFlag = instaService.correspondenceFlag;
                instapdetailsCAddressVm.undertakingFlag = instaService.undertakingFlag;
                instapdetailsCAddressVm.consentFlag = instaService.consentFlag;    
          }
                
            
        }
        
   

    instapdetailsCAddressVm.loadstate = function(stateData) {
			
            if(!instapdetailsCAddressVm.selectStateList){
                instapdetailsCAddressService.getStateMaster().then(function(data) {
                    instapdetailsCAddressVm.selectStateList = data;
                    instapdetailsCAddressVm.stateList = data;
                    console.log("statelist", JSON.stringify(instapdetailsCAddressVm.stateList));
                       
   			 
                     }, function(error) {
                });
            }
		};

		
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            
            var tomorrow  = moment().add(1, 'days');
			tomorrow = tomorrow._d;
            instapdetailsCAddressVm.dateObjValid = {
                callback: function (val) {
                    instapdetailsCAddressVm.addValidUp = new Date(val);
                    
                },
                inputDate: tomorrow,
                from: tomorrow, // from:(new Date().setYear(new Date().getFullYear() - 120)) --for help
                to: (new Date().setYear(new Date().getFullYear() + 120)),
                mondayFirst: true,
                closeOnSelect: false,
                templateType: 'popup',
                dateFormat: 'dd-MMM-yyyy'
            };

           


            instapdetailsCAddressVm.populateResumeData();
            if(instaService.isResumeJourney){
                if(instaService.correspondenceCheckStatus){
                    instapdetailsCAddressVm.addressAboveData = instaService.customerCorrespondenceAddress.address1;
                instapdetailsCAddressVm.addressBelowData = instaService.customerCorrespondenceAddress.address2;
                instapdetailsCAddressVm.pincodeData = instaService.customerCorrespondenceAddress.pincode;
                instapdetailsCAddressVm.stateitemData = instaService.customerCorrespondenceAddress.stateCode;
                 instapdetailsCAddressVm.districtLabelData = instaService.customerCorrespondenceAddress.district;
                 instapdetailsCAddressVm.addValidUp = instaService.customerCorrespondenceAddress.validity ? moment(instaService.customerCorrespondenceAddress.validity,'DD-MM-YYYY' ).format("DD MMM YYYY"):"";  
                 instapdetailsCAddressVm.correspondenceFlag = instaService.correspondenceFlag;
                instapdetailsCAddressVm.undertakingFlag = instaService.undertakingFlag;
                instapdetailsCAddressVm.consentFlag = instaService.consentFlag; 
                }
                            
            }
                
               
			
          
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instapdetailsCAddressVm.loadstate();

           
            instapdetailsCAddressService.saveForFuture();
           

             
        });

        return this;
    }
]);
