'use strict';

angularApp.service('instapdetailsCAddressService',
    function($q, AdapterUtils, constantConfig) {
        var instapdetailsCAddressService = this;
        instapdetailsCAddressService.updateCorrespondenceAddress = function(requestData) {
            var q = $q.defer();
             AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.updateCorrespondenceAddress,requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instapdetailsCAddressService.updateAadhaarDetails = function(requestData) {
            var q = $q.defer();
             AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.adharcard, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instapdetailsCAddressService.getAreaDetailForPincode = function(inputparams) {
            
            var q = $q.defer();
           
           AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.getAreaDetailForPincode , inputparams, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        instapdetailsCAddressService.fetchDistrict = function(requestData) {
            var q = $q.defer();
             AdapterUtils.postDataWithTimeOut(constantConfig.InstaAcOpeningAdapterUrl.fetchDistrict, requestData, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instapdetailsCAddressService.fetchSubDistrict = function(requestData) {
            var q = $q.defer();
             AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.fetchSubDistrict, requestData, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instapdetailsCAddressService.fetchVillage = function(requestData) {
            var q = $q.defer();
             AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.fetchVillage, requestData, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

         instapdetailsCAddressService.getStateMaster = function() {
            var q = $q.defer();
             AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.getStateMaster, {}, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        return instapdetailsCAddressService;
    });
