'use strict';

angularApp.service('instaproductOfferingService',
    function($q, AdapterUtils, constantConfig) {
        var instaproductOfferingService = this;
        instaproductOfferingService.getOtherProductOfferings = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getInfoOtherProduct, true).then(

                function(response) {
                    q.resolve(response.data.informationOtherProduct);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instaproductOfferingService.postProdOffers = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.postProductOfferingDetails, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return instaproductOfferingService;
    });
