'use strict';

angularApp.service('instareceiveDebitCardService',
    function($q, AdapterUtils, constantConfig) {
        var instareceiveDebitCardService = this;

        instareceiveDebitCardService.receiveDebitCard = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.receiveDebitCard, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        instareceiveDebitCardService.getReferenceNo = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getReferenceNo, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return instareceiveDebitCardService;
    });
