
'use strict';

angularApp.service('instaresumeJourneyService',
    function($q, AdapterUtils, constantConfig) {
        var instaresumeJourneyService = this;

        instaresumeJourneyService.getPageDetails = function(requestData) {
            var q = $q.defer();
             AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.pageDetails + requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instaresumeJourneyService.getCustomerDetails = function(requestData) {
            
            var q = $q.defer();
           
           AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.customerDocumentDetails, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return instaresumeJourneyService;
    });
