'use strict';

angularApp.controller('instasbiInTouchRegisterOptionsController', ["$state",
    "$scope",
    "$ionicPopover",
    "instaService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $ionicPopover,
        instaService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instasbiInTouchRegisterOptionsVm = this;

        function initPage() {
            instasbiInTouchRegisterOptionsVm.showBack = true;
            instasbiInTouchRegisterOptionsVm.showNext = false;
        }

        /* Info Popup */
        var template = '<ion-popover-view class="ao-tooltip ao-popupInfo roboto-regular ao-twoLinesHt">' + '<ion-content>' +
                        '<div class="" translate="TEMP_USER_ID_INFO_ICON"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        instasbiInTouchRegisterOptionsVm.infoPopup = function($event) {
            $scope.popover.show($event);
        };

        instasbiInTouchRegisterOptionsVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */

        instasbiInTouchRegisterOptionsVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_homePage");
        }

        instasbiInTouchRegisterOptionsVm.goToNextPage = function() {
            $state.go("menu.instaKit_tempLogin");
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
