'use strict';

angularApp.controller('instaGetReadyKnowMoreController', ["$state",
    "$scope",
    "instaService",
    "instaenterOTPReferenceCodeService",
    "$timeout",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "constantConfig",
    "newToSbiService",
    "instaStartVKYCService",
    "$ionicPopup",
    function($state,
        $scope,
        instaService,
        instaenterOTPReferenceCodeService,
        $timeout,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        constantConfig,
        newToSbiService,
        instaStartVKYCService,
        $ionicPopup) {

        var instaGedReadyKnowMoreVm = this;
        instaGedReadyKnowMoreVm.showNext = false;

        function initPage() {
            instaGedReadyKnowMoreVm.showBack = true;
            
            instaGedReadyKnowMoreVm.aofooter = true;
            instaGedReadyKnowMoreVm.showOtpView = true;
            instaGedReadyKnowMoreVm.otpFooterView = true;
            instaGedReadyKnowMoreVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);
        }

        instaGedReadyKnowMoreVm.goBacktoPrevious = function(){
            $state.go("menu.instaKit_getReady");
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
           initPage();  
           $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);  
        });

        return this;
    }
]);
