'use strict';

angularApp.controller('instaStartVkycController', ["$state",
    "$scope",
    "instaService",
    "instaenterOTPReferenceCodeService",
    "$timeout",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "constantConfig",
    "newToSbiService",
    "instaStartVKYCService",
    "$ionicPopup",
    function($state,
        $scope,
        instaService,
        instaenterOTPReferenceCodeService,
        $timeout,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        constantConfig,
        newToSbiService,
        instaStartVKYCService,
        $ionicPopup) {

        var instaStartVkycVm = this;

        function initPage() {
            instaStartVkycVm.showBack = true;
            instaStartVkycVm.showNext = true;
            instaStartVkycVm.aofooter = true;
            instaStartVkycVm.showOtpView = true;
            instaStartVkycVm.otpFooterView = true;

          

            instaStartVkycVm.journeyType = instaService.journeyType;
            instaStartVkycVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instaStartVkycVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);
            
           
        }

        instaStartVkycVm.goBacktoPrevious = function(){
            $state.go("menu.instaKit_enterOTPReferenceCode");
        }

        instaStartVkycVm.goToNextPage = function() {
            instaStartVkycVm.showOtpView = false;
            instaStartVkycVm.otpFooterView = false;
            $state.go("menu.instaKit_getReady");
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }
        





        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
           initPage();  
           $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);  
        });

        return this;
    }
]);
