'use strict';

angularApp.service('instataxService',
    function($q, AdapterUtils, constantConfig) {
        var instataxService = this;

        instataxService.setFactaFlag = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.setFactaFlag, requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        instataxService.getFatcaDeclaration = function(){
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getFatcaDeclaration, true).then(

                function(response) {
                    q.resolve(response.data.fatcaDeclaration);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return instataxService;
    });
