'use strict';

angularApp.controller('instatempLoginController', ["$state",
    "$scope",
    "instaService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instatempLoginVm = this;

        function initPage() {
            instatempLoginVm.showBack = false;
            instatempLoginVm.showNext = true;
            instatempLoginVm.loginBtn = true;
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instatempLoginVm.login = function() {
            $state.go('menu.instaKit_accountOpeningDetails');
        }

        instatempLoginVm.validateForm = function(isValid) {
            instatempLoginVm.loginBtn = !isValid;
            return instatempLoginVm.loginBtn;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
