'use strict';
angularApp.controller('authenticateUserController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
        "irctcService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,irctcService) {
			var authenticateUserVm = this;
			


      authenticateUserVm.forgotIRCTCUser = function(){
      	cordova.ThemeableBrowser.open(irctcService.createIRCTCURL, '_system');
      };

      authenticateUserVm.goBack = function(){
      	$ionicHistory.goBack(-1);
      }

      authenticateUserVm.proceed = function(){
      	var uName = authenticateUserVm.userName;
      	irctcService.authenticateUser(uName).then(function (data) {
                irctcService.userLinkedStatus = true;
                irctcService.username = uName;
                $state.go('menu.travellerMyList');
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                   // $state.go('menu.travellerList');
             });
      };

      authenticateUserVm.createIRCTCAccount = function(){
      		cordova.ThemeableBrowser.open(irctcService.createIRCTCURL, '_system');
      };

		$scope.$on('$ionicView.beforeLeave', function(){

		});

		$scope.$on('$ionicView.afterEnter', function() {

		});
      
		$scope.$on('$ionicView.beforeEnter', function() {
			

		});

		return this;
	}
]);
