'use strict';
angularApp.controller('bookingCancelReviewController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
        "irctcService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,irctcService) {
			var bookingCancelReviewVm = this;
			
			bookingCancelReviewVm.goBack = function(){
				$ionicHistory.goBack(-1);
			}

			bookingCancelReviewVm.toggleMenu = function(){
		      bookingCancelReviewVm.menu = !bookingCancelReviewVm.menu;
		    }
			
			$scope.$on('$ionicView.beforeLeave', function(){

			});

			$scope.$on('$ionicView.afterEnter', function() {

			});
	      
			$scope.$on('$ionicView.beforeEnter', function() {
				if(irctcService.username){
			        irctcService.userLinkedStatus = true;
			        bookingCancelReviewVm.username = irctcService.username;
			    }else{
			        bookingCancelReviewVm.username = "Menu";
			        bookingCancelReviewVm.userLinkedStatus = false;
			    }
			    bookingCancelReviewVm.showManageInfo = irctcService.userLinkedStatus;
			});

		return this;
	}
]);
