'use strict';
angularApp.controller('bookingCancelStatusController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
        "irctcService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,irctcService) {
			var bookingCancelStatusVm = this;
			
			bookingCancelStatusVm.bookAnotherTicket = function(){
				$state.go('menu.irctcBookTicketSearch');
			}

			bookingCancelStatusVm.toggleMenu = function(){
		      bookingCancelStatusVm.menu = !bookingCancelStatusVm.menu;
		    }				

			$scope.$on('$ionicView.beforeLeave', function(){

			});

			$scope.$on('$ionicView.afterEnter', function() {

			});
	      
			$scope.$on('$ionicView.beforeEnter', function() {
				bookingCancelStatusVm.historyDetails = irctcService.bookHistoryDetail;
				bookingCancelStatusVm.ticketCancelledResp = irctcService.cancelTicket;
				 var rupeeSymbol = String.fromCharCode(8377);
                bookingCancelStatusVm.refundAmt = "An amount of "+ rupeeSymbol +" "+  bookingCancelStatusVm.ticketCancelledResp.refundAmount +" will be refunded within 5-7 business days after successful cancellation";

				if(irctcService.username){
			        irctcService.userLinkedStatus = true;
			        bookingCancelStatusVm.username = irctcService.username;
			    }else{
			        bookingCancelStatusVm.username = "Menu";
			        bookingCancelStatusVm.userLinkedStatus = false;
			    }
			    bookingCancelStatusVm.showManageInfo = irctcService.userLinkedStatus;
				bookingCancelStatusVm.fromSTN = irctcService.bookHistoryDetail.fromStn;
				bookingCancelStatusVm.toSTN = irctcService.bookHistoryDetail.toStn;
                bookingCancelStatusVm.duration = irctcService.bookHistoryDetail.duration;			
			});

		return this;
	}
]);
