'use strict';
angularApp.controller('irctcPayNowController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
    "irctcService","fTSetOTPService","constantConfig","cryptoService","customerInfoService","getAccountDetailsService","rdService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,irctcService,fTSetOTPService,constantConfig,cryptoService,customerInfoService,getAccountDetailsService,rdService) {
			var irctcPayNowVm = this;
      irctcPayNowVm.startorStopTimer = true;
      irctcPayNowVm.timerTimer = 10;
      irctcPayNowVm.listPage = false;
      irctcPayNowVm.dynamicVar = 'payNow';
      var refInAppBrowser;
      irctcPayNowVm.monthArray = ["01","02","03","04","05","06","07","08","09","10","11","12"];
		
     irctcPayNowVm.goBack = function(){
         $ionicHistory.goBack(-1);
     };

    irctcPayNowVm.rePlan = function(){
          irctcService.searchTrainObj="";
          irctcService.myList="";
          irctcService.selectedTrainData="";
          irctcService.myListFullData="";
          $state.go('menu.irctcBookTicketSearch');
     };

      irctcPayNowVm.payNow = function(){
      if(irctcPayNowVm.accTab == 2){
          //Load PG
          irctcService.loadPGDetails().then(function (data) {
            irctcPayNowVm.formData = data.htmlForm;
            irctcPayNowVm.formURL = data.url;
            irctcPayNowVm.loadExtURL(irctcPayNowVm.formData);
          },function(error){
            utilityService.showErrorMessage(error.responseMessage);
          });
      }
      else{
        irctcService.accountNumber = irctcPayNowVm.accList[irctcPayNowVm.account].accountNumber;
        var reqData = {};
        reqData.otpCode = constantConfig.keysForOTP.IRCTCOTP;
          reqData.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.IRCTCOTP).toString();
          fTSetOTPService.generateOTP(reqData).then(function(response){
          $state.go('menu.irctcOTP');
        }, function(error) {
          utilityService.showErrorMessage(error.responseMessage);
        });
      }  
 };

      irctcPayNowVm.toggleMenu = function(){
        irctcPayNowVm.menu = !irctcPayNowVm.menu;
      };

      irctcPayNowVm.loadExtURL = function (pageURL) {
        // body...
        var pageContentUrl = 'data:text/html;base64,' + btoa(pageURL);
        refInAppBrowser = cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
                    statusbar: {
                      color: '#ffffffff'
                    },
                    toolbar: {
                      height: 37,
                      color: '#ffffffff',
                      image: 'share'
                    },
                    closeButton: {
                      image: 'back',
                      height: 37,
                      width: 32,
                      align: 'left',
                      event: 'closePressed'
                    },
                    backButtonCanClose: true
                  });
            refInAppBrowser.addEventListener('loadstop',irctcPayNowVm.loadStartCallBack);
      };

      irctcPayNowVm.loadExtURL2 = function (pageURL) {
        // body...
        var pageContentUrl = 'data:text/html;base64,' + btoa(pageURL);
        var refInAppBrowser2 = cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
                    statusbar: {
                      color: '#ffffffff'
                    },
                    toolbar: {
                      height: 37,
                      color: '#ffffffff',
                      image: 'share'
                    },
                    closeButton: {
                      image: 'back',
                      height: 37,
                      width: 32,
                      align: 'left',
                      event: 'closePressed'
                    },
                    backButtonCanClose: true
                  });
            refInAppBrowser2.addEventListener('loadstart', function(event){
                if(event.url.indexOf(irctcPayNowVm.formURL) > -1){
                  refInAppBrowser2.close();

                  irctcService.getBookingStatus().then(function (data) {
                    irctcService.bookingStatus = data;
                        if(data.status){
                          irctcService.bookingCompleted=true;
                        }
                        else{
                           irctcService.bookingCompleted=false;
                        }
                    $state.go('menu.ticketConfirmation');
                  },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                  });
                }
            });  
      };

      irctcPayNowVm.loadStartCallBack = function(event) {
        // body...
          if(event.url.indexOf(irctcPayNowVm.formURL) == 0){
            refInAppBrowser.close();
            irctcService.confirmPGDetails().then(function (data) {
                    var formData = data.htmlForm;                    
                    var showPopup = $ionicPopup.show({
                        template: '<div class="popupBodyPadding font-dark-grey"><div align="center"><img class="fss-popup-activated-img" src="img/FSS/Approved.svg"></div><div class="fss-cards-payment-success roboto-light font-content font-dark-grey "><p class="text-align-center font-content roboto-regular"  translate="IRCTC_REDIRECT_SUCCESSFUL_MSG" ></p><br><p class="text-align-center font-content roboto-regular"  translate="IRCTC_REDIRECT_SUCCESSFUL_MSG2" ></p></div></div>',
                        cssClass: 'dialog',
                        buttons: [{
                          text: 'Ok',
                          type: 'button-positive',
                          onTap: function(e) {
                            showPopup.close();  
                            irctcPayNowVm.loadExtURL2(formData);
                          }
                        }]
                      });
                    
                  },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                  });
          }
      };


      irctcPayNowVm.selectAccNumber = function(){
         irctcPayNowVm.accountBalance = irctcPayNowVm.accList[irctcPayNowVm.account].accountBalance;
         if(parseInt(irctcPayNowVm.totalCollectableAmount) > parseInt(irctcPayNowVm.accountBalance)){
            irctcPayNowVm.lowBalance = true;
         }else{
            irctcPayNowVm.lowBalance = false;
         }
         irctcPayNowVm.validateMODAccessRights(irctcPayNowVm.accList[irctcPayNowVm.account].accountNumber);
      };
        
      irctcPayNowVm.selTab = function(tabIndex){
         irctcPayNowVm.accTab = tabIndex;
      };
	      
		irctcPayNowVm.setPrimaryAccount = function(tabIndex) {
			if (irctcPayNowVm.accList) {
				var selItem = getAccountDetailsService.displayPrimaryAccountAsDefaultRD(irctcPayNowVm.accList, getAccountDetailsService.accountOverviewData.customerInformation.accountNumber)
				irctcPayNowVm.account = selItem.selIndex.toString();
				irctcPayNowVm.selectAccNumber();
				irctcPayNowVm.validateMODAccessRights(irctcPayNowVm.accList[irctcPayNowVm.account].accountNumber);
			}
		};
			irctcPayNowVm.fetchMODAccessRights = function(accNo) {
				if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
					utilityService.showSpinner();
					if (irctcPayNowVm.isServiceCalling) {
						return true;
					}
					irctcPayNowVm.isServiceCalling = true; 
					getAccountDetailsService.getAccountsAccessRights('').then(function(data) {
						utilityService.hideSpinner();
						irctcPayNowVm.isServiceCalling = false;
						if (data) {
							irctcPayNowVm.tryAgain = false;
							getAccountDetailsService.accessRightsData = data;
							accNo = accNo.substr(accNo.length - 4, accNo.length);
							irctcPayNowVm.haveRights = rdService.checkMODAccessRights(accNo, getAccountDetailsService.accessRightsData);
						}
					}, function(error) {
						utilityService.hideSpinner();
						irctcPayNowVm.isServiceCalling = false;
						irctcPayNowVm.tryAgain = true;
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
			};
			irctcPayNowVm.validateMODAccessRights = function(accNo, data) {
				try {
					if (data) {
						accNo = data.split(",")[0];
					}
					if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
						accNo = accNo.substr(accNo.length - 4, accNo.length);
						irctcPayNowVm.fetchMODAccessRights(accNo);
					} else {
						accNo = accNo.substr(accNo.length - 4, accNo.length);
						irctcPayNowVm.haveRights = rdService.checkMODAccessRights(accNo, getAccountDetailsService.accessRightsData);
					}
				} catch(err) {
			}
		};
      
		$scope.$on('$ionicView.beforeEnter', function() {
         irctcPayNowVm.accList = irctcService.accList;
         irctcPayNowVm.totalPassengers = irctcService.totalTravellers;
         irctcPayNowVm.trainData = irctcService.selectedTrainData;
         irctcPayNowVm.sourceTime = irctcPayNowVm.trainData.departureTime;
         irctcPayNowVm.destTime = irctcPayNowVm.trainData.arrivalTime;
         irctcPayNowVm.trainDuration = irctcPayNowVm.trainData.duration;
         irctcPayNowVm.trainNumber = irctcPayNowVm.trainData.trainNumber;
         irctcPayNowVm.trainName = irctcPayNowVm.trainData.trainName;
         irctcPayNowVm.stationTo = irctcService.getStationNameCode(irctcPayNowVm.trainData.toStnCode,irctcService.stationCodeArray,irctcService.stationNameArray);
         irctcPayNowVm.stationFrom = irctcService.getStationNameCode(irctcPayNowVm.trainData.fromStnCode,irctcService.stationCodeArray,irctcService.stationNameArray);
         irctcPayNowVm.trainDate = irctcService.searchDate;
         irctcPayNowVm.totalCollectableAmount = irctcService.totalCollectableAmount;
         irctcPayNowVm.totalTravellers = irctcPayNowVm.totalPassengers+' Traveller(s) ';
         irctcPayNowVm.classQuota = irctcPayNowVm.trainData.avlFareEnq.enqClass + ', '+ irctcService.searchQuotaVal;
         irctcPayNowVm.availabilityStatus=irctcService.availabilityStatus;
  			 irctcPayNowVm.customerName = customerInfoService.customer.name;
  			 irctcPayNowVm.userMobile = irctcService.selectedTrainData.mobileNo;
			   irctcPayNowVm.isMealAail = false;
			   irctcPayNowVm.cost = 700;
         irctcPayNowVm.account = '0';
         if(irctcPayNowVm.accList.length > 0){
            irctcPayNowVm.accountBalance = irctcPayNowVm.accList[irctcPayNowVm.account].accountBalance;
            irctcPayNowVm.accTab = 1;
         }else{
            irctcPayNowVm.accTab = 2;
         }
         if(parseInt(irctcPayNowVm.totalCollectableAmount) > parseInt(irctcPayNowVm.accountBalance)){
            irctcPayNowVm.lowBalance = true;
         }else{
            irctcPayNowVm.lowBalance = false;
         }
         irctcPayNowVm.debitCardNo = "D";
         irctcPayNowVm.yearArray =[];
         var cardYear = new Date().getFullYear();
         for (var i = cardYear; i <= cardYear+15; i++) {
            irctcPayNowVm.yearArray.push(i);
         }
         irctcPayNowVm.cardExpiryMonth = "01";
         irctcPayNowVm.cardExpiryYear = irctcPayNowVm.yearArray[0].toString();
         if(irctcService.username){
          irctcService.userLinkedStatus = true;
          irctcPayNowVm.username = irctcService.username;
        }else{
          irctcPayNowVm.username = "Menu";
          irctcService.userLinkedStatus = false;
        }
        irctcPayNowVm.showManageInfo = irctcService.userLinkedStatus;
		    irctcPayNowVm.setPrimaryAccount();
		if(irctcPayNowVm.accList){
			irctcPayNowVm.validateMODAccessRights(irctcPayNowVm.accList[irctcPayNowVm.account].accountNumber);	
		}else{
			irctcPayNowVm.validateMODAccessRights("");
		}	
		});

		return this;
	}
]);
