'use strict';
angularApp.controller('irctcFAQController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"$timeout",
		"$ionicSideMenuDelegate",
        "$window","irctcService","cardsService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, $timeout,$ionicSideMenuDelegate,$window,irctcService,cardsService) {
			var irctcFAQVm = this;
			               
			irctcFAQVm.toggleMenu = function(){
				
				irctcFAQVm.menu = !irctcFAQVm.menu;
			}

			irctcFAQVm.GoBack = function() {
				$ionicHistory.goBack(-1);
			};

			irctcFAQVm.hideAnswer = function(index){
              irctcFAQVm.faqList[index].isExpand=!irctcFAQVm.faqList[index].isExpand;
			};

			$scope.$on('$ionicView.beforeLeave', function(){

			});

			$scope.$on('$ionicView.afterEnter', function() {

		       
			});
			
			$scope.$on('$ionicView.beforeEnter', function() {
                	
            	if(irctcService.username){
                	irctcService.userLinkedStatus = true;
                	irctcFAQVm.username = irctcService.username;
                }else{
                	irctcFAQVm.username = "Menu";
                	irctcService.userLinkedStatus = false;
                }
                var obj = {};

                //load all FAQs
                irctcService.getFAQ(obj).then(function (data) {
                  	irctcFAQVm.faqList =data.getFAQLists;
                  	for(var i=0;i<irctcFAQVm.faqList.length;i++)
                  	{
                  		if(i==0)
                  		{
                  		irctcFAQVm.faqList[i].isExpand=true;
                  	    }

                  	}
                                    
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                 });


			});

			return this;
		}
]);
