'use strict';
angularApp.controller('ticketReviewController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
    "$ionicScrollDelegate",
        "irctcService",
    "$rootScope",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,$ionicScrollDelegate,irctcService,$rootScope) {
			var ticketReviewVm 	= this;
          ticketReviewVm.startorStopTimer = true;
          ticketReviewVm.timerTimer = 10;
          ticketReviewVm.listPage = true;
          ticketReviewVm.dynamicVar = 'listing';
      ticketReviewVm.goBack = function(){
        irctcService.settimerData('');
         $ionicHistory.goBack(-1);
      };

       ticketReviewVm.toggleMenu = function(){
        ticketReviewVm.menu = !ticketReviewVm.menu;
      };

      ticketReviewVm.cancel=function(){
         ticketReviewVm.popUP.close();
      };

      ticketReviewVm.toggleFareBreakup = function(){
        ticketReviewVm.isFareBreakUp = !ticketReviewVm.isFareBreakUp;
        $ionicScrollDelegate.resize();
      };

      ticketReviewVm.continue=function(){
        ticketReviewVm.popUP.close();
        $state.go('menu.irctcPayNow');
        return;
      };

      ticketReviewVm.goToMakePayment = function(){
        ticketReviewVm.popUP = $ionicPopup.show({
            title: '',
            cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter ftpopup-body',
            templateUrl: 'pages/irctc/ticketReview/ticketReviewPopUp.html',
            scope: $scope
          });
      };
      $scope.$on('$ionicView.afterEnter', function() {
        $rootScope.$broadcast('runTimer');
      });
      
		$scope.$on('$ionicView.beforeEnter', function() {
        if(irctcService.username){
          irctcService.userLinkedStatus = true;
          ticketReviewVm.username = irctcService.username;
        }else{
          ticketReviewVm.username = "Menu";
          irctcService.userLinkedStatus = false;
        }
      ticketReviewVm.showManageInfo = irctcService.userLinkedStatus;
			ticketReviewVm.userMobile = "+91-"+irctcService.selectedTrainData.mobileNo;
			ticketReviewVm.passengerListInfant = [];
      ticketReviewVm.passengerList=[];
      var totalList = irctcService.myList;
        for(var i =0;i<totalList.length;i++){
          var checkInfant = totalList[i].isInfant;
          if(checkInfant){
            ticketReviewVm.passengerListInfant.push(totalList[i]);
          }else{
            ticketReviewVm.passengerList.push(totalList[i]);
          }
        }
         irctcService.passToBeDisplayed=ticketReviewVm.passengerList;
         ticketReviewVm.totalPassengers = irctcService.totalTravellers;
         ticketReviewVm.trainData = irctcService.selectedTrainData;
         ticketReviewVm.availabilityStatus =irctcService.availabilityStatus;
         ticketReviewVm.sourceTime = ticketReviewVm.trainData.departureTime;
         ticketReviewVm.destTime = ticketReviewVm.trainData.arrivalTime;
         ticketReviewVm.trainDuration = ticketReviewVm.trainData.duration;
         ticketReviewVm.trainNumber = ticketReviewVm.trainData.trainNumber;
         ticketReviewVm.trainName = ticketReviewVm.trainData.trainName;
         ticketReviewVm.stationTo = irctcService.getStationNameCode(ticketReviewVm.trainData.toStnCode,irctcService.stationCodeArray,irctcService.stationNameArray);
         ticketReviewVm.stationFrom = irctcService.getStationNameCode(ticketReviewVm.trainData.fromStnCode,irctcService.stationCodeArray,irctcService.stationNameArray);
			   ticketReviewVm.totalTravellers = ticketReviewVm.totalPassengers+' Traveller(s) ';
         ticketReviewVm.classQuota = ticketReviewVm.trainData.avlFareEnq.enqClass + ', '+ irctcService.searchQuotaVal;
         ticketReviewVm.trainDate = irctcService.searchDate;
         var tomorrow = new Date(irctcService.searchDate);
         tomorrow.setDate(tomorrow.getDate() + 1);
         var dateString = new Date(tomorrow).toISOString().slice(0,10);
         ticketReviewVm.jDate = dateString.replace(/-/g , "");
  			 ticketReviewVm.cost = irctcService.selectedTrainData.avlFareEnq.totalFare;
         ticketReviewVm.boardingStation = irctcService.selectedTrainData.boardingPoint;
         ticketReviewVm.reviewData = irctcService.reviewDetails;
         ticketReviewVm.cost = ticketReviewVm.reviewData.totalCollectibleAmount;
         irctcService.totalCollectableAmount = ticketReviewVm.cost;
         ticketReviewVm.destinationAddress = irctcService.destinationAddress;
		});

		return this;
	}
]);
