'use strict';
angularApp.controller('travellerListController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
        "irctcService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,irctcService) {
			var travellerListVm = this;
			

		travellerListVm.goBack = function(){
			$ionicHistory.goBack(-2);
		}

	  travellerListVm.toggleMenu = function(){
      
        travellerListVm.menu = !travellerListVm.menu;
      }


		travellerListVm.addPassenger = function(category){
			if (travellerListVm.totalPassengers <= 5) {
				if(category == 1){
					travellerListVm.noOfAdult++;
				}else if(category == 2){
					travellerListVm.noOfChildren++;
				}
				travellerListVm.totalPassengers = parseInt(travellerListVm.noOfAdult + travellerListVm.noOfChildren);
				console.log('after : '+travellerListVm.totalPassengers);
			}
			if(category == 3){
				if(travellerListVm.noOfInfant < 2){
					travellerListVm.noOfInfant++;
				}
			}
		}

		travellerListVm.removePassenger = function(category){
			if ( travellerListVm.totalPassengers > 0 ) {
				if(category == 1){
					if(travellerListVm.noOfAdult > 0){
						travellerListVm.noOfAdult--;
					}
				}else if(category == 2){
					if(travellerListVm.noOfChildren > 0){
						travellerListVm.noOfChildren--;
					}
					
				}
				travellerListVm.totalPassengers = parseInt(travellerListVm.noOfAdult + travellerListVm.noOfChildren);
				console.log('after :'+travellerListVm.totalPassengers);
			}
			if(category == 3){
					if(travellerListVm.noOfInfant > 0){
						travellerListVm.noOfInfant--;
					}
					
				}
		}

		travellerListVm.goToNextPage = function(){
			irctcService.totalTravellers = travellerListVm.totalPassengers;
			$state.go('menu.travellerMyList');

		}


      	$scope.$on('$ionicView.beforeLeave', function(){

		});

		$scope.$on('$ionicView.afterEnter', function() {

		});
      
		$scope.$on('$ionicView.beforeEnter', function() {


			    if(irctcService.username){
                    	irctcService.userLinkedStatus = true;
                    	travellerListVm.username = irctcService.username;
                    }else{
                    	travellerListVm.username = "Menu";
                    	irctcService.userLinkedStatus = false;
                    }
            travellerListVm.showManageInfo = irctcService.userLinkedStatus;
			travellerListVm.trainDate = irctcService.searchDate;

			travellerListVm.disablenext = false;
			travellerListVm.disableback = false;
			travellerListVm.showBack = true;
			travellerListVm.showNext = true;

			travellerListVm.noOfAdult = 1;
			travellerListVm.noOfChildren = 0;
			travellerListVm.noOfInfant = 0;

			travellerListVm.totalPassengers = 1;

			travellerListVm.trainData = irctcService.selectedTrainData;
         	console.log('selected train obj : '+JSON.stringify(travellerListVm.trainData));
			travellerListVm.sourceTime = travellerListVm.trainData.departureTime;
			travellerListVm.destTime = travellerListVm.trainData.arrivalTime;
			travellerListVm.trainDuration = travellerListVm.trainData.duration;
         	travellerListVm.trainNumber = travellerListVm.trainData.trainNumber;
         	travellerListVm.trainName = travellerListVm.trainData.trainName;
         	travellerListVm.stationTo = travellerListVm.trainData.toStnCode;
         	travellerListVm.stationFrom = travellerListVm.trainData.fromStnCode;

		});

		return this;
	}
]);
