'use strict';
angularApp.controller('irctcMyListController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "irctcService",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, irctcService) {
        var irctcMyListVm = this;

        irctcMyListVm.goBack = function() {
            $ionicHistory.goBack(-1);
        }
        irctcMyListVm.goToNextPage = function() {

        }


        irctcMyListVm.toggleMenu = function() {

            irctcMyListVm.menu = !irctcMyListVm.menu;
        }

        irctcMyListVm.Edit = function()

        {
            var noOfChecked = 0;
            var index = 0;
            for (var i = 0; i < irctcMyListVm.myList.length; i++) {
                if (irctcMyListVm.myList[i].checked) {
                    noOfChecked++;
                    index = i;
                    // irctcMyListVm.myList[i].berthPref = irctcService.getArrayElement(irctcMyListVm.myList[i].berthPref,irctcService.masterData.berthTypes,'');     

                }

            }
            if (noOfChecked == 1) {
                irctcService.from = "Edit";
                irctcMyListVm.myList[index].berthPref = irctcService.getArrayElement(irctcMyListVm.myList[index].berthPref, irctcService.masterData.berthTypes, '');
                irctcService.fromData = irctcMyListVm.myList[index];

                $state.go("menu.myListEdit");
            }


        }

        irctcMyListVm.delete = function()

        {
            var noOfChecked = 0;
            var sequenceNumberArray = [];

            for (var i = 0; i < irctcMyListVm.myList.length; i++) {
                if (irctcMyListVm.myList[i].checked) {
                    noOfChecked++;
                    sequenceNumberArray.push(irctcMyListVm.myList[i].sequenceNo)

                }

            }
            if (noOfChecked > 0) {





                  var myPopup = $ionicPopup.show({
                        templateUrl: 'pages/irctc/travellerMyList/deleteconfirmPass.html',
                        cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter ftpopup-body',
                        title: '',

                        buttons: [{
                                text: 'Cancel',
                                type: 'button-assertive',
                                onTap: function(e) {
                                    return;
                                }
                            },
                            {
                                text: 'YES',
                                type: 'button-energized',
                                onTap: function(e) {
                                   
                            var reqParams = {};
                            reqParams.seqNo = sequenceNumberArray
                            irctcService.deleteMyList(reqParams).then(function(data) {

                                irctcService.fetchMyList().then(function(data) {

                                    irctcService.myListFullData = data;
                                    irctcMyListVm.myList = data;
                                    irctcMyListVm.noOfChecked=0;


                                }, function(error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                                });



                            }, function(error) {
                                utilityService.showErrorMessage(error.responseMessage);
                            });

                                }
                            }
                        ]
                    });

            }


        }

        irctcMyListVm.toggleEditandDelete = function(index) {
            if (irctcMyListVm.myList[index].checked) {
                irctcMyListVm.noOfChecked++;
              
            } else {
                irctcMyListVm.noOfChecked--;
               

            }


        }


        irctcMyListVm.addTraveller = function() {
            irctcService.from = "Add";
            $state.go("menu.myListEdit");
        }


        $scope.$on('$ionicView.beforeLeave', function() {

        });

        $scope.$on('$ionicView.afterEnter', function() {

        });

        $scope.$on('$ionicView.beforeEnter', function() {
         irctcMyListVm.noOfChecked=0;

            if (irctcService.username) {
                irctcService.userLinkedStatus = true;
                irctcMyListVm.username = irctcService.username;
            } else {
                irctcMyListVm.username = "Menu";
                irctcMyListVm.userLinkedStatus = false;
            }
            irctcMyListVm.showManageInfo = irctcService.userLinkedStatus;


            irctcService.fetchMyList().then(function(data) {

                if (data) {

                    for (var i = 0; i < data.length; i++) {
                        data[i].checked = false;
                        data[i].berthPref = irctcService.getArrayElement(data[i].berthPref, irctcService.masterData.berthTypes, 'myValue');
                    }
                    irctcMyListVm.myList = data;
                }

                irctcMyListVm.disabled = false;


            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        });

        return this;

    }
]);
