'use strict';
angularApp.controller('optVikalpTrainListController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"$timeout",
		"$ionicSideMenuDelegate",
        "$window","irctcService","cardsService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, $timeout,$ionicSideMenuDelegate,$window,irctcService,cardsService) {
			var optVikalpTrainListVm = this;
			                
            optVikalpTrainListVm.GoBack=function()
            {
            	$ionicHistory.goBack(-1);
            }
            
            optVikalpTrainListVm.toggleMenu = function(){
      
		        optVikalpTrainListVm.menu = !optVikalpTrainListVm.menu;
		      }


		      	optVikalpTrainListVm.toggleEditandDelete=function(index)
				{
                      
               
                 
                 	 if(optVikalpTrainListVm.vikalpTrainList.trainBtwnStnsList[index].isChecked)
                 	 {
                          optVikalpTrainListVm.noOfchecked++;
                 	 }
                 	 else
                 	 {
                 	 	  optVikalpTrainListVm.noOfchecked--;
                 	 }
                 	
                 

				}
   

			optVikalpTrainListVm.submitVikalp = function(){
				optVikalpTrainListVm.token = [];
				optVikalpTrainListVm.tokenString = '';
				var vikalOptList = optVikalpTrainListVm.vikalpTrainList.trainBtwnStnsList;
				for (var i = 0; i < vikalOptList.length; i++) {
					if(vikalOptList[i].isChecked){
						optVikalpTrainListVm.token.push(vikalOptList[i].sNo);
					}
					
				}



				if (optVikalpTrainListVm.token.length <= 0) {
					utilityService.showErrorMessage("Please select train");
				}else if(optVikalpTrainListVm.token.length > 7){
					utilityService.showErrorMessage("You can select maximum 7 trains only");
				}else{
					optVikalpTrainListVm.tokenString = optVikalpTrainListVm.token.join();
					

			             var myPopup = $ionicPopup.show({
                        template: ' <div class="popupBodyPadding font-dark-grey"><div class="row fontSize-subHeading"><span >Would you like to proceed with VIKALP?</span></div></div>',

                        cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter ftpopup-body',
                        title: '',

                        buttons: [{
                                text: 'Cancel',
                                type: 'button-assertive',
                                onTap: function(e) {
                                    return;
                                }
                            },
                            {
                                text: 'Confirm',
                                type: 'button-energized',
                                onTap: function(e) {
                                   
                         
                                   var optVikalpObj = {
			                        	"resvId":irctcService.bookHistoryDetail.transID,
			                        	"trainLists":optVikalpTrainListVm.token,
			                        	"specialTrainFlag":false

			                        };


                                   irctcService.optVikalp(optVikalpObj).then(function (data) {
                                   	optVikalpTrainListVm.message=data.status;
                                   	   var showPopup = $ionicPopup.show({
										templateUrl: 'pages/irctc/vikalp/vikalpConfirm.html',
										scope: $scope,
										cssClass: 'dialog',
										buttons: [{
											text: 'Ok',
											type: 'button-positive',
											onTap: function(e) {
												showPopup.close();  
												$state.go('menu.irctcBookTicketSearch');
												
													
											}
										}]
									});
                   
                    
                                          },function(error){
                               utilityService.showErrorMessage(error.responseMessage);
                                }); 

                               

                                }
                            }
                        ]
                    });
				}

				

			}                           
			$scope.$on('$ionicView.beforeLeave', function(){

			});

			$scope.$on('$ionicView.afterEnter', function() {

		        
		       
			});
			
			$scope.$on('$ionicView.beforeEnter', function() {
               optVikalpTrainListVm.vikalpTrainList  = irctcService.vikalpTrainList;

               optVikalpTrainListVm.disableNext=false;
               for(var i=0;i< optVikalpTrainListVm.vikalpTrainList;i++)
               {
               	   optVikalpTrainListVm.vikalOptList[i].fromStnCode
               }

				optVikalpTrainListVm.historyDetails = irctcService.bookHistoryDetail;

				optVikalpTrainListVm.trainName = optVikalpTrainListVm.historyDetails.bookingResponseList.trainName;
				optVikalpTrainListVm.trainNumber = optVikalpTrainListVm.historyDetails.bookingResponseList.trainNumber;
				optVikalpTrainListVm.trainDate = optVikalpTrainListVm.historyDetails.bookingResponseList.journeyDate;
				optVikalpTrainListVm.stationFrom = optVikalpTrainListVm.historyDetails.bookingResponseList.fromStn;
				optVikalpTrainListVm.stationTo = optVikalpTrainListVm.historyDetails.bookingResponseList.destStn;
				optVikalpTrainListVm.departureTime = optVikalpTrainListVm.historyDetails.bookingResponseList.boardingDate;
				optVikalpTrainListVm.duration = optVikalpTrainListVm.historyDetails.bookingResponseList.trainDuration;
				optVikalpTrainListVm.arrivalTime = optVikalpTrainListVm.historyDetails.bookingResponseList.destArrvDate;
				optVikalpTrainListVm.showManageInfo = irctcService.userLinkedStatus;
				optVikalpTrainListVm.trainBtwnStnsList = irctcService.trainListData;
				optVikalpTrainListVm.sourceStation = irctcService.sourceStation;
				optVikalpTrainListVm.destnStation = irctcService.destStation;

				optVikalpTrainListVm.fromSTN = irctcService.bookHistoryDetail.fromStn;
				optVikalpTrainListVm.toSTN = irctcService.bookHistoryDetail.toStn;
				optVikalpTrainListVm.duration= irctcService.bookHistoryDetail.duration

				optVikalpTrainListVm.noOfchecked=0;
				optVikalpTrainListVm.vikalOptList = optVikalpTrainListVm.vikalpTrainList.trainBtwnStnsList;

				for(var i = 0 ; i< optVikalpTrainListVm.vikalOptList.length ; i++){
					var dateFormat=new Date(optVikalpTrainListVm.vikalOptList[i].departureDate) ;
					optVikalpTrainListVm.vikalOptList[i].departureDate=dateFormat;
					optVikalpTrainListVm.vikalOptList[i].isChecked = false;

				}
				   if(irctcService.username){
                      irctcService.userLinkedStatus = true;
                      optVikalpTrainListVm.username = irctcService.username;
                    }else{
                      optVikalpTrainListVm.username = "Menu";
                      optVikalpTrainListVm.userLinkedStatus = false;
                    }

               
			});

			return this;
		}
]);
