'use strict';

angularApp.controller('vurnableAppController',
	["$state",
		"$scope",
		"utilityService",
		"loggedInUserService",
		"$ionicModal",
		function ($state,
			$scope,
			utilityService,
			loggedInUserService,
			$ionicModal
		) {

			var vAppVM = this;

			vAppVM.proceed = function () {
				$state.go('menu.landingWithOptions');
			}
			$scope.$on('$ionicView.beforeEnter', function () {
				vAppVM.vuranbleAppList = loggedInUserService.rogueAppsDetectedList;
			});

			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {
				navigator.splashscreen.hide();
			});

			vAppVM.exitClick = function () {
				if (utilityService.isAndroidPlatform()) {
					ionic.Platform.exitApp();
					navigator.app.exitApp();
				} else {

					$scope.modal2 = $ionicModal.fromTemplate('<div class="modal vAppModal"><div><img src="img/vurnableApp/close_btn.png" alt="close" class="vApp_close_img"  ng-click="modal2.hide()" /><div class="clear"></div><div translate="LBL_VAPP_IOS_CLOSE_INFO" class="vApp_close_info pad-bot-54"></div></div></div>', {
						scope: $scope,
					});
					$scope.modal2.show();
				}
			}

			return this;
		}
	]);
