angularApp.controller('liForm_AppointeeInfoAadhaarScanController', [
    "$state",
    "$scope", 
    "commonAPIService",
    "lifeInsuranceBasicApplicationService",
    "suggestedPlansDetailsService",

    function(
        $state,
        $scope, 
        commonAPIService,
        lifeInsuranceBasicApplicationService,
        suggestedPlansDetailsService) {


        var liForm_AppointeeInfoAadhaarScanVm = this;
    
        function initPage() {
            liForm_AppointeeInfoAadhaarScanVm.showBack = true;
            liForm_AppointeeInfoAadhaarScanVm.showNext = true;
            liForm_AppointeeInfoAadhaarScanVm.commonAPIService = commonAPIService;
            liForm_AppointeeInfoAadhaarScanVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
        }

        liForm_AppointeeInfoAadhaarScanVm.goBacktoPrevious = function() {
            lifeInsuranceBasicApplicationService.setIsAadharScanned(false);
            $state.go('menu.liForm_MailingInfoEnterDetails');
        }

        liForm_AppointeeInfoAadhaarScanVm.goToNextPage = function() {
            lifeInsuranceBasicApplicationService.setBasicApplicationInformation6(liForm_AppointeeInfoAadhaarScanVm);
            lifeInsuranceBasicApplicationService.setIsAadharScanned(false);
            $state.go('menu.liForm_appointeeInformation');
        }

        liForm_AppointeeInfoAadhaarScanVm.scanAdhar = function() {
            liForm_AppointeeInfoAadhaarScanVm.commonAPIService.QRcodescanner(function(data) {
                lifeInsuranceBasicApplicationService.setAppointeeAadhar(data);
                lifeInsuranceBasicApplicationService.setIsAadharScanned(true);
                $state.go("menu.liForm_appointeeInformation");
            });
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);
