/*Module Name  : Life Insurance,
Authors Name    : Parshuram Pawar,
Description  : LI "Buy Policy - Medical History" page*/


angularApp.controller('liForm_MedicalHistoryController', ["$timeout",
    "$state",
    "$scope",
    "$translate",


    function($timeout,
        $state,
        $scope,
        $translate) {

        var liForm_MedicalHistoryVm = this;

        function initPage() {


            liForm_MedicalHistoryVm.showBack = true;
            liForm_MedicalHistoryVm.showNext = true;
            liForm_MedicalHistoryVm.disableBack = false;
            liForm_MedicalHistoryVm.disableNext = false;
        }



        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function() {

            initPage();
        });


        // On click of Back button
        liForm_MedicalHistoryVm.goBacktoPrevious = function() {

            $state.go("menu.liForm_ProposersFATCA_CRS");
        }

        // On click of Next button
        liForm_MedicalHistoryVm.goToNextPage = function() {
            $state.go("menu.liForm_DiseaseDetails");

        }
    }
]);
