angularApp.controller('liForm_PreviewController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$timeout",
    "lifeInsuranceBasicApplicationService",
    "premiumCalculationService",
    "lifeInsuranceApplicationService",
    "suggestedPlansDetailsService",
    "validateService",
    "$ionicScrollDelegate",
    "lifeInsuranceCommonService",
    "LiConstant","clickStreamService",

    function(
        $state,
        $scope,
        $ionicPopup,
        $timeout,
        lifeInsuranceBasicApplicationService,
        premiumCalculationService,
        lifeInsuranceApplicationService,
        suggestedPlansDetailsService,
        validateService,
        $ionicScrollDelegate,
        lifeInsuranceCommonService,
        LiConstant,clickStreamService) {

        var liForm_PreviewVm = this;
        var product;
        var uin;
        var premiumData;
        var mobileNo;
        var emailID;

        function initPage() {
            liForm_PreviewVm.showBack = true;
            liForm_PreviewVm.showNext = true;
            liForm_PreviewVm.disableBack = false;
            liForm_PreviewVm.disableNext = false;
            liForm_PreviewVm.canShowPersonalDetails = true;
            liForm_PreviewVm.canShowMedicalDetails = true;
            liForm_PreviewVm.familyHistory = [];
            liForm_PreviewVm.editDet = false;
            liForm_PreviewVm.agree = false;
            liForm_PreviewVm.validateService = validateService;
            liForm_PreviewVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct();
            getPremiumDetails();
            previewApplication();
            getDeclarationContent();
            getMedicalHistory();
        }

        function getPremiumDetails() {
            var personalDat = lifeInsuranceApplicationService.getPersonalDetails();
            liForm_PreviewVm.Birthdate = personalDat.dob;
            liForm_PreviewVm.Gender = personalDat.gender;

            if (personalDat.name.middle && personalDat.name.last) {
                liForm_PreviewVm.Name = personalDat.name.first + " " + personalDat.name.middle + " " + personalDat.name.last;
            }

            if (personalDat.name.middle && !personalDat.name.last) {
                liForm_PreviewVm.Name = personalDat.name.first + " " + personalDat.name.middle;
            }

            if (!personalDat.name.middle && personalDat.name.last) {
                liForm_PreviewVm.Name = personalDat.name.first + " " + personalDat.name.last;
            }

            if (!personalDat.name.middle && !personalDat.name.last) {
                liForm_PreviewVm.Name = personalDat.name.first;
            }


            // liForm_PreviewVm.Name = personalDat.name;
            product = suggestedPlansDetailsService.getCurrentSugestedProduct().productCode;
            uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;

            if (product == LiConstant.productCode.SMART_WEALTH_BUILDER && uin == LiConstant.productUIN.SMART_WEALTH_BUILDER) {
                premiumData = premiumCalculationService.getPremiumCalculationSW();
                liForm_PreviewVm.EmailId = premiumData.email;
                liForm_PreviewVm.MobileNum = premiumData.mobileNumber;
                mobileNo = premiumData.mobileNumber;
                emailID = premiumData.email;
                liForm_PreviewVm.SumAssured = premiumData.sumAssured;
                liForm_PreviewVm.AreYouResidentOfJnK = 'NA';
                liForm_PreviewVm.PolicyTerm = premiumData.policyTerm;
                liForm_PreviewVm.premium = premiumData.premiumAmount;
                liForm_PreviewVm.premiumPayingTerm = premiumData.payingTerm;
                liForm_PreviewVm.newEmail = liForm_PreviewVm.EmailId;
                liForm_PreviewVm.newMobileNo = liForm_PreviewVm.MobileNum;
            }
            //"SBI Life - Smart Money Back Gold"
            if (product == LiConstant.productCode.SMART_MONEY_BACK_GOLD && uin == LiConstant.productUIN.SMART_MONEY_BACK_GOLD) {

                premiumData = premiumCalculationService.getPremiumCalculationFData();
                liForm_PreviewVm.EmailId = premiumData.email;
                liForm_PreviewVm.MobileNum = premiumData.mobileNumber;
                liForm_PreviewVm.SumAssured = premiumData.sumAssured;
                liForm_PreviewVm.PolicyTerm = premiumData.policyTerm;
                liForm_PreviewVm.AreYouResidentOfJnK = premiumData.isJkResident;
                liForm_PreviewVm.premium = premiumData.premium;
                mobileNo = premiumData.mobileNumber;
                emailID = premiumData.email;
                liForm_PreviewVm.newEmail = liForm_PreviewVm.EmailId;
                liForm_PreviewVm.newMobileNo = liForm_PreviewVm.MobileNum;

            }
            //Smart Champ Insurance
            if (product == LiConstant.productCode.SMART_CHAMP_INSURANCE && uin == LiConstant.productUIN.SMART_CHAMP_INSURANCE) {

                premiumData = premiumCalculationService.getPremiumCalculationSC();
                liForm_PreviewVm.EmailId = premiumData.email;
                liForm_PreviewVm.MobileNum = premiumData.mobileNumber;
                liForm_PreviewVm.SumAssured = premiumData.sumAssured;
                liForm_PreviewVm.PolicyTerm = premiumData.policyTerm;
                liForm_PreviewVm.AreYouResidentOfJnK = premiumData.isJkResident;
                liForm_PreviewVm.PolicyTerm = premiumData.policyTerm;
                liForm_PreviewVm.premium = premiumData.premium;
                liForm_PreviewVm.premiumPayingTerm = premiumData.payingTerm;
                mobileNo = premiumData.mobileNumber;
                emailID = premiumData.email;
                liForm_PreviewVm.newEmail = liForm_PreviewVm.EmailId;
                liForm_PreviewVm.newMobileNo = liForm_PreviewVm.MobileNum;

            }
            //"SBI Life - Shub Nivesh"
            if (product == LiConstant.productCode.SHUBH_NIVESH && uin == LiConstant.productUIN.SHUBH_NIVESH) {

                premiumData = premiumCalculationService.getPremiumCalculationSN();
                liForm_PreviewVm.EmailId = premiumData.email;
                liForm_PreviewVm.MobileNum = premiumData.mobileNumber;
                liForm_PreviewVm.SumAssured = premiumData.sumAssured;
                liForm_PreviewVm.PolicyTerm = premiumData.policyTerm;
                liForm_PreviewVm.AreYouResidentOfJnK = 'NA';
                liForm_PreviewVm.premium = premiumData.premium;
                mobileNo = premiumData.mobileNumber;
                emailID = premiumData.email;
                liForm_PreviewVm.newEmail = liForm_PreviewVm.EmailId;
                liForm_PreviewVm.newMobileNo = liForm_PreviewVm.MobileNum;

            }

            //"SBI Life - Retire Smart"
            if (product == LiConstant.productCode.RETIRE_SMART && uin == LiConstant.productUIN.RETIRE_SMART) {
                premiumData = premiumCalculationService.getPremiumCalculationRS();

                liForm_PreviewVm.EmailId = premiumData.email;
                liForm_PreviewVm.MobileNum = premiumData.mobileNumber;
                liForm_PreviewVm.SumAssured = premiumData.sumAssured;
                liForm_PreviewVm.AreYouResidentOfJnK = 'NA';
                liForm_PreviewVm.PolicyTerm = premiumData.policyTerm;
                liForm_PreviewVm.premium = premiumData.premiumAmount;
                liForm_PreviewVm.premiumPayingTerm = premiumData.payingTerm;
                mobileNo = premiumData.mobileNumber;
                emailID = premiumData.email;
                liForm_PreviewVm.newEmail = liForm_PreviewVm.EmailId;
                liForm_PreviewVm.newMobileNo = liForm_PreviewVm.MobileNum;

            }

            //"SBI Life - Saral Swadhan"
            if (product == LiConstant.productCode.SARAL_SWADHAN_PLUS && uin == LiConstant.productUIN.SARAL_SWADHAN_PLUS) {

                premiumData = premiumCalculationService.getPremiumCalculationSS();

                liForm_PreviewVm.EmailId = premiumData.email;
                liForm_PreviewVm.MobileNum = premiumData.mobileNumber;
                liForm_PreviewVm.SumAssured = premiumData.sumAssured;
                liForm_PreviewVm.PolicyTerm = premiumData.policyTerm;
                liForm_PreviewVm.AreYouResidentOfJnK = 'NA';
                liForm_PreviewVm.premium = premiumData.premiumAmount;
                mobileNo = premiumData.mobileNumber;
                emailID = premiumData.email;
                liForm_PreviewVm.newEmail = liForm_PreviewVm.EmailId;
                liForm_PreviewVm.newMobileNo = liForm_PreviewVm.MobileNum;
            }
        }


        liForm_PreviewVm.update = function() {

            if (liForm_PreviewVm.editDet) {
                liForm_PreviewVm.EmailId = liForm_PreviewVm.newEmail;
                liForm_PreviewVm.MobileNum = liForm_PreviewVm.newMobileNo;
                liForm_PreviewVm.editDet = false;
                if (validateForm()) {
                    premiumCalculationService.setMobileEmail(liForm_PreviewVm.MobileNum, liForm_PreviewVm.EmailId);
                }

            } else {
                liForm_PreviewVm.editDet = true;
            }
        }

        liForm_PreviewVm.editData = function(screenName) {
            switch (screenName) {
                case 'yourNeedsPersonalDetails':
                    $state.go("menu.lifeInsuranceApplicationInfoPD"); //your needs
                    break;
                case 'existingLifeInsurance':
                    $state.go("menu.lifeInsuranceExistingPolicy");
                    break;
                case 'personalDetailsInfo':
                    $state.go("menu.lifeInsuranceBasicInformation4"); //personal details
                    break;
                case 'mailingInfo':
                    $state.go("menu.liForm_MailingInfo"); //mailing info
                    break;
                case 'nomineeInfo':
                    $state.go("menu.liForm_MailingInfoEnterDetails"); //nominee
                    break;
                case 'fatcaInfo':
                    $state.go("menu.liForm_ProposersFATCA_CRS"); //fatca
                    break;
                case 'medicalHistoryInfo':
                    $state.go("menu.retireSmartMedicalHistory", { start: 0 }); //medical
                    break;
                case 'einsuranceInfo':
                    $state.go("menu.liForm_eInsurance"); //einsurance   
                    break;
                default : break;
            }

        }



        liForm_PreviewVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };




        function getDeclarationContent() {
            lifeInsuranceBasicApplicationService.getDeclarationContent().then(function(response) {
                liForm_PreviewVm.declarationOfProposer = response.message;
            }, function(error) {});
        }

        function previewApplication() {
            liForm_PreviewVm.basicApplicationData = lifeInsuranceBasicApplicationService.getBasicApplicationData();
            var familyHis = lifeInsuranceBasicApplicationService.getFamilyHistory();
            var fatherDet = familyHis.father;
            var motherDet = familyHis.mother;
            if (lifeInsuranceBasicApplicationService.getFamilyHistory().spouse.age) {
                var spouseDet = familyHis.spouse;
                liForm_PreviewVm.basicApplicationPair = [fatherDet, motherDet, spouseDet];
            } else {
                liForm_PreviewVm.basicApplicationPair = [fatherDet, motherDet];
            }
            liForm_PreviewVm.basicApplicationDataChild = familyHis.familyMembers;
            
        }

        function getMedicalHistory() {
            liForm_PreviewVm.medicalAnswers = lifeInsuranceBasicApplicationService.getMedicalHistoryPreview();
            var questions = lifeInsuranceBasicApplicationService.getMedicalQuestions();
            var start = 0;
            for (var index = 0; index < questions.commonQues.length; index++) {
                liForm_PreviewVm.medicalAnswers[start].question = questions.commonQues[index].question;
                liForm_PreviewVm.medicalAnswers[start].quesType = questions.commonQues[index].quesType;

                for (var subIndex = 0; subIndex < liForm_PreviewVm.medicalAnswers[index].subAns.length; subIndex++) {
                    liForm_PreviewVm.medicalAnswers[start].subAns[subIndex].question = questions.commonQues[index].subQues[subIndex].question;
                    liForm_PreviewVm.medicalAnswers[start].subAns[subIndex].quesType = questions.commonQues[index].subQues[subIndex].quesType;
                }
                start++;
            }

            if (liForm_PreviewVm.Gender.key == 'F') {
                for (var index = 0; index < questions.femaleAdditionalQues.length; index++) {
                    liForm_PreviewVm.medicalAnswers[start].question = questions.femaleAdditionalQues[index].question;
                    liForm_PreviewVm.medicalAnswers[start].quesType = questions.femaleAdditionalQues[index].quesType;

                    for (var subIndex = 0; subIndex < liForm_PreviewVm.medicalAnswers[start].subAns.length; subIndex++) {
                        liForm_PreviewVm.medicalAnswers[start].subAns[subIndex].question = questions.femaleAdditionalQues[index].subQues[subIndex].question;
                        liForm_PreviewVm.medicalAnswers[start].subAns[subIndex].quesType = questions.femaleAdditionalQues[index].subQues[subIndex].quesType;
                    }
                    start++;
                }
            }


            for (var index = 0; index < questions.additionalQues.length; index++) {
                liForm_PreviewVm.medicalAnswers[start].question = questions.additionalQues[index].question;
                liForm_PreviewVm.medicalAnswers[start].quesType = questions.additionalQues[index].quesType;

                for (var subIndex = 0; subIndex < liForm_PreviewVm.medicalAnswers[start].subAns.length; subIndex++) {
                    liForm_PreviewVm.medicalAnswers[start].subAns[subIndex].question = questions.additionalQues[index].subQues[subIndex].question;
                    liForm_PreviewVm.medicalAnswers[start].subAns[subIndex].quesType = questions.additionalQues[index].subQues[subIndex].quesType;
                }
                start++;
            }

            liForm_PreviewVm.basicApplicationDataDisease = lifeInsuranceBasicApplicationService.getDiseaseDetailsPreview();
        }


        liForm_PreviewVm.togglePersonalDetails = function() {
            if (liForm_PreviewVm.canShowPersonalDetails) {

                liForm_PreviewVm.canShowPersonalDetails = false;

            } else {

                liForm_PreviewVm.canShowPersonalDetails = true;
            }
        }

        liForm_PreviewVm.toggleMedicalDetails = function() {
            if (liForm_PreviewVm.canShowMedicalDetails) {
                liForm_PreviewVm.canShowMedicalDetails = false;
            } else {
                liForm_PreviewVm.canShowMedicalDetails = true;
            }
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicScrollDelegate.scrollTop();
            initPage();
        });


        // On click of Back button
        liForm_PreviewVm.goBacktoPrevious = function() {
            $state.go("menu.liForm_eInsurance");
        }

        function validateForm() {

            liForm_PreviewVm.form = {};

            if (liForm_PreviewVm.validateService.isValidEmail(liForm_PreviewVm.EmailId)) {
                liForm_PreviewVm.form.email = liForm_PreviewVm.validateService.isValidEmail(liForm_PreviewVm.EmailId);
            }


            if (liForm_PreviewVm.validateService.isValidPhoneNo(liForm_PreviewVm.MobileNum)) {
                liForm_PreviewVm.form.phoneNo = liForm_PreviewVm.validateService.isValidPhoneNo(liForm_PreviewVm.MobileNum);
            }
            return (angular.equals({}, liForm_PreviewVm.form)) ? true : false;
        }

        function submitApplication1() {
            lifeInsuranceBasicApplicationService.submitApplication(LiConstant.journeyCommonId.APP_SUBMIT).then(function(data) {
                lifeInsuranceBasicApplicationService.getAadharTextFromCloud().then(function(data) {
                    lifeInsuranceBasicApplicationService.setAadharText(data.message);
                    $state.go("menu.lifeInsuranceUploadDocuments");
                });
            });
        }

        // On click of Next button
        liForm_PreviewVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = liForm_PreviewVm.selectedProduct.planName;
                if (!liForm_PreviewVm.insuranceActContent) {
                    lifeInsuranceBasicApplicationService.getInsuranceActContent().then(function(data) {
                        liForm_PreviewVm.insuranceActContent = data.message;
                        showInsuranceActPopup();
                    }, function(error) {});
                } else {
                    showInsuranceActPopup();
                }
            }
        };

        liForm_PreviewVm.prepareTemplate = function(){
            $timeout(function(){
                var pptText;
                if (product == LiConstant.productCode.SMART_WEALTH_BUILDER || product == LiConstant.productCode.RETIRE_SMART){
                    pptText = liForm_PreviewVm.premiumPayingTerm; 
                }else{
                    pptText = liForm_PreviewVm.PolicyTerm;
                }
                document.getElementById('productname').innerHTML = liForm_PreviewVm.selectedProduct.planName;
                document.getElementById('ppt').innerHTML = pptText;
            });
        }

        function showInsuranceActPopup() {
            var alertPopup = $ionicPopup.alert({
                title: 'Terms and Condition',
                templateUrl: 'pages/lifeInsurance/buyPolicy/payment/liForm_PreviewInsuranceActPopup.html',
                scope: $scope,
                cssClass: 'bi-table',
                buttons: [{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function(e) {
                        return false;
                    }
                }, {
                    text: 'Agree',
                    type: 'button-positive',
                    onTap: function(e) {
                        return true;
                    }
                }]
            });
            alertPopup.then(function(res) {
                if (res) {
                    submitApplication1();
                }
            });
        };
    }
]);
