angularApp.controller('enterOTPCallController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$stateParams",
    "lifeInsuranceBasicApplicationService",

    function(
        $state,
        $scope,
        $ionicPopup,
        $stateParams,
        lifeInsuranceBasicApplicationService) {

        var enterOTPCallVm = this;
        enterOTPCallVm.callCenterNumber;
     

        function initPage() {
            enterOTPCallVm.showBack = true;
            enterOTPCallVm.showNext = true;
            enterOTPCallVm.disableBack = false;
            enterOTPCallVm.disableNext = false;

            lifeInsuranceBasicApplicationService.getIRDAIText().then(function(data) {
                enterOTPCallVm.irdaiText = data.message;
                getCallCenterNumber();
            }, function(error) {
            });
        };
        
        function getCallCenterNumber() {
            lifeInsuranceBasicApplicationService.getCallCenterNumber().then(function(data) {
               enterOTPCallVm.callCenterNumber = "tel:" + data.callCenterNumber;
            }, function(error) {});
        };

        enterOTPCallVm.goBacktoPrevious = function() {
            $state.go('menu.declarationOfLI');
        };


        enterOTPCallVm.goToNextPage = function() {
            var alertPopup = $ionicPopup.alert({
                title: '',
                templateUrl: 'pages/lifeInsurance/buyPolicy/premiumCalculation/otpVerifiedPopup.html'
            });

            alertPopup.then(function(res) {
                $state.go('menu.lifeInsuranceBasicInformation');

            });
        };


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);
