angularApp.controller('newRenewalHomeController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceBasicApplicationService",
    "lifeInsuranceCommonService",
    "$ionicPopup", "utilityService",
    "liPolicyPaymentService", "getAccountDetailsService", "requestYCService", "linkingLIPolicyService",
    "pailinkingRenwalService", "homeScreenService", "arogyaSanjeevaniService", "$translate",


    function (
        $state,
        $scope,
        validateService,
        lifeInsuranceBasicApplicationService,
        lifeInsuranceCommonService,
        $ionicPopup, utilityService,
        liPolicyPaymentService, getAccountDetailsService, requestYCService, linkingLIPolicyService,
        pailinkingRenwalService, homeScreenService, arogyaSanjeevaniService, $translate
    ) {

        var newRenewalHomeVm = this;
        newRenewalHomeVm.validateService = validateService;

        function initPage() {
            newRenewalHomeVm.accDetails = [];
            newRenewalHomeVm.showBack = false;
            newRenewalHomeVm.showNext = true;
            newRenewalHomeVm.isChecked = true;
            newRenewalHomeVm.isPaiChecked = true;
            newRenewalHomeVm.showPaiSelect = true;
            newRenewalHomeVm.showLiSelect = true
            newRenewalHomeVm.showNewAmt = false;
            newRenewalHomeVm.isCollapsed = true;
            newRenewalHomeVm.isPaiCollapsed = true;
            newRenewalHomeVm.paiPolicyList = pailinkingRenwalService.paiPolicyData ? pailinkingRenwalService.paiPolicyData : [];
            if(newRenewalHomeVm.paiPolicyList.length!=0 && newRenewalHomeVm.paiPolicyList[0].noOfDaysRemaining < 0){
                newRenewalHomeVm.paiPolicyList[0].noOfDaysToExpire = 30 - Math.abs(newRenewalHomeVm.paiPolicyList[0].noOfDaysRemaining);
            }
            if (homeScreenService.offersData) {
                for (var i = 0; i < homeScreenService.offersData.length; i++) {
                    if (homeScreenService.offersData[i].category == 'LI-RENEWAL') {
                        newRenewalHomeVm.getPolicyList();
                        newRenewalHomeVm.getLIAccounts();
                    } else {
                        if(newRenewalHomeVm.paiPolicyList.length !=0) {
                            newRenewalHomeVm.showCollapseEnlarged();
                        }
                    }
                }
            } else {
                if(newRenewalHomeVm.paiPolicyList.length !=0) {
                    newRenewalHomeVm.showCollapseEnlarged();
                }
            }
            newRenewalHomeVm.paiAccList = [];
            if (newRenewalHomeVm.paiPolicyList.length !=0) {
                if(newRenewalHomeVm.paiPolicyList[0].newSumInsured && newRenewalHomeVm.paiPolicyList[0].newPremiumPaid) {
                    newRenewalHomeVm.showNewAmt = true;
                } else {
                    newRenewalHomeVm.showNewAmt = false;
                }
                newRenewalHomeVm.getPaiEligibleAcntList();
            }
            
        }

        newRenewalHomeVm.getPolicyList = function () {
            newRenewalHomeVm.lapseDate = [];
            newRenewalHomeVm.policyLists = [];
            var o = null;
            utilityService.showSpinner();
            lifeInsuranceBasicApplicationService.getSbiLifeSmbPolicyRenewalDetails().then(function (data) {
                newRenewalHomeVm.policyList = data.record;
                utilityService.hideSpinner();
                NumToWord(newRenewalHomeVm.policyList.length);
                angular.forEach(newRenewalHomeVm.policyList, function (value, key) {
                    pailinkingRenwalService.paiLiPolicyList.push(value);
                    if (value.dueDate) {
                        var currentDate = new Date();
                        var myDate = new Date(value.dueDate);
                        myDate.setDate(myDate.getDate() + 1 + 29);

                        var d = new Date(value.dueDate);
                        d.setDate(d.getDate() + 1);

                        var Difference_In_Time = myDate.getTime() - currentDate.getTime();
                        var Difference_In_Days = Difference_In_Time / (1000 * 3600 * 24);
                        if (parseInt(Difference_In_Days) <= 29) {
                            var result = newRenewalHomeVm.policyList.map(function (el) {
                                var modifiedPolicyObj = Object.assign({}, el);
                                if (value.policyNumber == el.policyNumber) {
                                    modifiedPolicyObj.isActive = 1;
                                    modifiedPolicyObj.noOfDays = parseInt(Difference_In_Days);
                                    newRenewalHomeVm.policyLists.push(modifiedPolicyObj);
                                }
                                return modifiedPolicyObj;
                            })
                        } else {
                            var result = newRenewalHomeVm.policyList.map(function (el) {
                                var modifiedPolicyObj = Object.assign({}, el);
                                if (value.policyNumber == el.policyNumber) {
                                    modifiedPolicyObj.isActive = 0;
                                    modifiedPolicyObj.noOfDays = '';
                                    newRenewalHomeVm.policyLists.push(modifiedPolicyObj);
                                }
                                return modifiedPolicyObj;
                            })
                               
                        }
                        // if(newRenewalHomeVm.policyLists.length > 0  && newRenewalHomeVm.paiPolicyList.length > 0) {
                        //     newRenewalHomeVm.isCollapsed = true;
                        //     newRenewalHomeVm.isPaiCollapsed = true;
                        // } else if(newRenewalHomeVm.policyLists.length > 0 && newRenewalHomeVm.policyLists.length == 1 && newRenewalHomeVm.paiPolicyList.length == 0) {
                        //     newRenewalHomeVm.isCollapsed = false;
                        //     newRenewalHomeVm.isPaiCollapsed = false;
                        // }else if(newRenewalHomeVm.policyLists.length > 1 && newRenewalHomeVm.paiPolicyList.length == 0){
                        //     newRenewalHomeVm.isCollapsed = true;
                        //     newRenewalHomeVm.isPaiCollapsed = true;
                        // } else if(newRenewalHomeVm.policyLists.length == 0 && newRenewalHomeVm.paiPolicyList.length == 1) {
                        //     newRenewalHomeVm.isCollapsed = false;
                        //     newRenewalHomeVm.isPaiCollapsed = false;
                        // } else if(newRenewalHomeVm.policyLists.length == 0 && newRenewalHomeVm.paiPolicyList.length > 1){
                        //     newRenewalHomeVm.isCollapsed = true;
                        //     newRenewalHomeVm.isPaiCollapsed = true;
                        // }
                        if((newRenewalHomeVm.policyLists.length > 0  && newRenewalHomeVm.paiPolicyList.length > 0) || 
                            (newRenewalHomeVm.policyLists.length > 1 && newRenewalHomeVm.paiPolicyList.length == 0) ||
                            (newRenewalHomeVm.policyLists.length == 0 && newRenewalHomeVm.paiPolicyList.length > 1)){
                            newRenewalHomeVm.isCollapsed = true;
                            newRenewalHomeVm.isPaiCollapsed = true;
                        } else if((newRenewalHomeVm.policyLists.length > 0 && newRenewalHomeVm.policyLists.length == 1 && newRenewalHomeVm.paiPolicyList.length == 0) ||
                            (newRenewalHomeVm.policyLists.length == 0 && newRenewalHomeVm.paiPolicyList.length == 1)) {
                            newRenewalHomeVm.isCollapsed = false;
                            newRenewalHomeVm.isPaiCollapsed = false;
                        }
                    }
                })
            }, function (error) {
                utilityService.hideSpinner();
            });
        }

        newRenewalHomeVm.showCollapseEnlarged = function() {
            if(newRenewalHomeVm.paiPolicyList.length > 1) {
                newRenewalHomeVm.isPaiCollapsed = true;
            } else {
                newRenewalHomeVm.isPaiCollapsed = false;
            }
        }

        newRenewalHomeVm.toggleGroup = function (group, length) {
            newRenewalHomeVm.isPaiCollapsed = true;
            if (newRenewalHomeVm.isGroupShown(group)) {
                newRenewalHomeVm.shownGroup = null;
                newRenewalHomeVm.isGroupShown(group);
            } else {
                newRenewalHomeVm.shownGroup = group;
                newRenewalHomeVm.isGroupShown(group);
            }
        };
        newRenewalHomeVm.isGroupShown = function (group) {
            return newRenewalHomeVm.shownGroup === group;
        };

        //pai 
        newRenewalHomeVm.togglePaiGroup = function (group, length) {
            newRenewalHomeVm.isCollapsed = true;
            if (newRenewalHomeVm.isPaiGroupShown(group)) {
                newRenewalHomeVm.shownPaiGroup = null;
                newRenewalHomeVm.isPaiGroupShown(group);
            } else {
                newRenewalHomeVm.shownPaiGroup = group;
                newRenewalHomeVm.isPaiGroupShown(group);
            }
        };

        //pai
        newRenewalHomeVm.isPaiGroupShown = function (group) {
            return newRenewalHomeVm.shownPaiGroup === group;
        };


        newRenewalHomeVm.showPop = function () {
            newRenewalHomeVm.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                templateUrl: 'pages/lifeInsurance/newRenewal/accountModelPopup.html',
                scope: $scope
            });
        }
        newRenewalHomeVm.getLIAccounts = function () {
            utilityService.showSpinner();
            var account = {};
            lifeInsuranceBasicApplicationService.getSBIBankAccounts(account).then(function (data) {
                utilityService.hideSpinner();
                for (var i = 0; i < data.beneficiaryList.ownAccounts.length; i++) {
                    if (data.beneficiaryList.ownAccounts[i].benAccntType == 'Savings' || data.beneficiaryList.ownAccounts[i].benAccntType == 'Current') {
                        newRenewalHomeVm.accDetails.push(data.beneficiaryList.ownAccounts[i]);
                    }
                }
                if (newRenewalHomeVm.accDetails.length > 0) {
                    newRenewalHomeVm.showLiSelect = false;
                    var primaryAccount = getAccountDetailsService.accountOverviewData.customerInformation.accountNumber;
                    var objPriAcc = getAccountDetailsService.displayPrimaryAccountAsDefault(newRenewalHomeVm.accDetails, primaryAccount);
                    newRenewalHomeVm.accountDetail = objPriAcc;
                    newRenewalHomeVm.close(newRenewalHomeVm.accountDetail.index);
                }
                else if (newRenewalHomeVm.accDetails.length == 0) {
                    requestYCService.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                        //$state.go('menu.homeScreen');
                    });
                }

            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        newRenewalHomeVm.close = function (index) {
            if (newRenewalHomeVm.popUp) {
                newRenewalHomeVm.popUp.close();
            }

            newRenewalHomeVm.balance = newRenewalHomeVm.accDetails[index].balance;
            newRenewalHomeVm.accType = newRenewalHomeVm.accDetails[index].benAccntType;
            newRenewalHomeVm.accountNumber = newRenewalHomeVm.accDetails[index].benAccntNo;
            requestYCService.selectedDetails.selIndex = newRenewalHomeVm.accDetails[index].index;
            requestYCService.selectedDetails.accountNumber = newRenewalHomeVm.accDetails[index].benAccntNo;
            requestYCService.selectedDetails.accountBalance = newRenewalHomeVm.accDetails[index].balance;
            newRenewalHomeVm.showLiSelect = false;
        }

        newRenewalHomeVm.payNow = function (policyDetails) {
            if (newRenewalHomeVm.validateAmount(policyDetails)) {
                if (validateForm(policyDetails)) {
                    var requestSecKey;
                    var requestDate = new Date();
                    var premiumAmount = parseFloat(policyDetails.premiumAmount);
                    requestDate = requestDate.getTime();
                    requestSecKey = Math.floor((Math.random()) + requestDate);
                    requestSecKey = (requestSecKey * 10 + 1);
                    var requestObj = {};
                    requestObj.proposalNumber = newRenewalHomeVm.proposalNumber;
                    requestObj.policyNumber = policyDetails.policyNumber;
                    requestObj.premiumAmount = premiumAmount.toString();
                    requestObj.accountHolderName = getAccountDetailsService.accountOverviewData.customerInformation.customerName;
                    requestObj.accountNumber = newRenewalHomeVm.accountNumber;
                    requestObj.ifscCode = '';
                    requestObj.isAutoPay = newRenewalHomeVm.isChecked ? newRenewalHomeVm.isChecked.toString() : 'false';
                    requestObj.panNumber = "";
                    requestObj.branchCode = "";
                    requestObj.productName = policyDetails.productName;
                    requestObj.secKey = requestSecKey;
                    requestObj.referralCode = "";
                    lifeInsuranceCommonService.renewalDataAdd(requestObj);
                    utilityService.showSpinner();
                    liPolicyPaymentService.payRenewSbiLifeSmbPolicy(requestObj).then(function (data) {
                        utilityService.hideSpinner();
                        if (data.isOTPRequired == "true") {
                            pailinkingRenwalService.policyNo = policyDetails.policyNumber;
                            $state.go("menu.newRenewalOTP");
                        }
                    }, function (error) {
                        utilityService.hideSpinner();
                    });
                }
            }
        }

        newRenewalHomeVm.lifeInsurancePolicyDetails = function (policyDetails) {
            utilityService.showSpinner();
            linkingLIPolicyService.getPolicyDetails(policyDetails.policyNumber).then(function (data) {
                newRenewalHomeVm.proposalNumber = data.proposalNumber;
                newRenewalHomeVm.payNow(policyDetails);
                utilityService.hideSpinner();
            }, function (error) {
                utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });
        };
        newRenewalHomeVm.validateAmount = function (policyDetails) {
            if (policyDetails.premiumAmount) {
                newRenewalHomeVm.premiumError = false;
                if (parseFloat(newRenewalHomeVm.balance) < parseFloat(policyDetails.premiumAmount)) {
                    newRenewalHomeVm.premiumError = true;
                    return false;
                } else {
                    newRenewalHomeVm.premiumError = false;
                    return true;
                }

            } else {
                newRenewalHomeVm.premiumError = true;
                return false;
            }
        }

        // validation function
        function validateForm(policy) {
            newRenewalHomeVm.newRenewalHomeForm = {};

            if (newRenewalHomeVm.validateService.renewalIsPolicyValid(policy.policyNumber)) {
                newRenewalHomeVm.newRenewalHomeForm.policyNo = newRenewalHomeVm.validateService.renewalIsPolicyValid(policy.policyNumber);
            }
            if (newRenewalHomeVm.validateService.renewalIsSumAssuredValid(policy.premiumAmount)) {
                newRenewalHomeVm.newRenewalHomeForm.amount = newRenewalHomeVm.validateService.renewalIsSumAssuredValid(policy.premiumAmount);
            }
            if (newRenewalHomeVm.validateService.renewalIsPremiumDueValid(policy.premiumAmount)) {
                newRenewalHomeVm.newRenewalHomeForm.premiumAmount = newRenewalHomeVm.validateService.renewalIsSumAssuredValid(policy.premiumAmount);
            }

            return (angular.equals({}, newRenewalHomeVm.newRenewalHomeForm)) ? true : false;
        }

        // pai validation function
        function validatePaiPolicyForm(policy) {
            newRenewalHomeVm.paiRenewalHomeForm = {};
            if (newRenewalHomeVm.validateService.renewalIsSumAssuredValid(policy.txnAmount)) {
                newRenewalHomeVm.paiRenewalHomeForm.amount = newRenewalHomeVm.validateService.renewalIsSumAssuredValid(policy.txnAmount);
            }
            if (newRenewalHomeVm.validateService.renewalIsPremiumDueValid(policy.txnAmount)) {
                newRenewalHomeVm.paiRenewalHomeForm.premiumAmount = newRenewalHomeVm.validateService.renewalIsSumAssuredValid(policy.txnAmount);
            }
            return (angular.equals({}, newRenewalHomeVm.paiRenewalHomeForm)) ? true : false;
        }

        //Pai Amount Validate
        newRenewalHomeVm.validatePaiAmount = function (policyDetails) {
            if (policyDetails.txnAmount) {
                newRenewalHomeVm.premiumError = false;
                if (parseFloat(newRenewalHomeVm.balance) < parseFloat(policyDetails.txnAmount)) {
                    newRenewalHomeVm.premiumError = true;
                    return false;
                } else {
                    newRenewalHomeVm.premiumError = false;
                    return true;
                }
            } else {
                newRenewalHomeVm.premiumError = true;
                return false;
            }
        }

        //convert number to Word
        function NumToWord(inputNumber) {
            var str = new String(inputNumber)
            var splt = str.split("");
            var rev = splt.reverse();
            var once = ['Zero', ' One', ' Two', ' Three', ' Four', ' Five', ' Six', ' Seven', ' Eight', ' Nine'];
            var twos = ['Ten', ' Eleven', ' Twelve', ' Thirteen', ' Fourteen', ' Fifteen', ' Sixteen', ' Seventeen', ' Eighteen', ' Nineteen'];
            var tens = ['', 'Ten', ' Twenty', ' Thirty', ' Forty', ' Fifty', ' Sixty', ' Seventy', ' Eighty', ' Ninety'];
            var numLength = null;
            numLength = rev.length;
            var word = new Array();
            var j = 0;

            for (var i = 0; i < numLength; i++) {
                switch (i) {

                    case 0:
                        if ((rev[i] == 0) || (rev[i + 1] == 1)) {
                            word[j] = '';
                        }
                        else {
                            word[j] = '' + once[rev[i]];
                        }
                        word[j] = word[j];
                        break;

                    case 1:
                        aboveTens();
                        break;

                    case 2:
                        if (rev[i] == 0) {
                            word[j] = '';
                        }
                        else if ((rev[i - 1] == 0) || (rev[i - 2] == 0)) {
                            word[j] = once[rev[i]] + " Hundred ";
                        }
                        else {
                            word[j] = once[rev[i]] + " Hundred and";
                        }
                        break;

                    case 3:
                        if (rev[i] == 0 || rev[i + 1] == 1) {
                            word[j] = '';
                        }
                        else {
                            word[j] = once[rev[i]];
                        }
                        if ((rev[i + 1] != 0) || (rev[i] > 0)) {
                            word[j] = word[j] + " Thousand";
                        }
                        break;

                        
                    case 4:
                        aboveTens();
                        break;

                    case 5:
                        if ((rev[i] == 0) || (rev[i + 1] == 1)) {
                            word[j] = '';
                        }
                        else {
                            word[j] = once[rev[i]];
                        }
                        if (rev[i + 1] !== '0' || rev[i] > '0') {
                            word[j] = word[j] + " Lakh";
                        }
                         
                        break;

                    case 6:
                        aboveTens();
                        break;

                    case 7:
                        if ((rev[i] == 0) || (rev[i + 1] == 1)) {
                            word[j] = '';
                        }
                        else {
                            word[j] = once[rev[i]];
                        }
                        if (rev[i + 1] !== '0' || rev[i] > '0') {
                            word[j] = word[j] + " Crore";
                        }
                        break;

                    case 8:
                        aboveTens();
                        break;

                    

                    default: break;
                }
                j++;
            }

            function aboveTens() {
                if (rev[i] == 0) { word[j] = ''; }
                else if (rev[i] == 1) { word[j] = twos[rev[i - 1]]; }
                else { word[j] = tens[rev[i]]; }
            }

            word.reverse();
            var finalOutput = '';
            for (i = 0; i < numLength; i++) {
                finalOutput = finalOutput + word[i];
            }
            newRenewalHomeVm.numbers = finalOutput.toLowerCase().trim();
            return newRenewalHomeVm.numbers;
        }

        /* Function to get Eligible Account List for PAI Renewal*/
        newRenewalHomeVm.getPaiEligibleAcntList = function () {
            //if(!newRenewalHomeVm.paiAccList) {
            pailinkingRenwalService.getPaiAccountInfo().then(function (data) {
                newRenewalHomeVm.paiAccList = data.customerAccounts ? data.customerAccounts : [];
                if (newRenewalHomeVm.paiAccList && newRenewalHomeVm.paiAccList.length > 0) {
                    newRenewalHomeVm.balance = newRenewalHomeVm.paiAccList[0].accountBalance;
                    newRenewalHomeVm.benAccntType = newRenewalHomeVm.paiAccList[0].accountType;
                    newRenewalHomeVm.benAccntNo = newRenewalHomeVm.paiAccList[0].accountNumber;
                    newRenewalHomeVm.selectedAccount = newRenewalHomeVm.paiAccList[0];
                    newRenewalHomeVm.showPaiSelect = false;
                } else {
                    utilityService.showErrorMessage($translate.instant('PAI_NO_ACCOUNT_ERROR'));
                }
            }, function (error) {
                utilityService.showErrorMessage($translate.instant('PAI_ACC_ERROR'));
            });
        }

        //On Click of Pay of Pai Policy
        newRenewalHomeVm.payPaiPolicy = function (policyDetails) {
            var statusCode = policyDetails.message.toUpperCase();
            if (statusCode == "E001" || statusCode == "E005" || statusCode == "E006") {
                if (newRenewalHomeVm.validatePaiAmount(policyDetails)) {
                    if (validatePaiPolicyForm(policyDetails)) {
                        var request = {};
                        request.accNo = newRenewalHomeVm.benAccntNo ? newRenewalHomeVm.benAccntNo : "";
                        /**KYC check */
                        arogyaSanjeevaniService.checkKyc(request).then(function (data) {
                            if (data && parseInt(data.kycPoints) >= 110) {
                                    var renewalSMSObj = {};
                                    renewalSMSObj["selectedAccountNumber"] = request.accNo;
                                    pailinkingRenwalService.getPaiRenewalSMS(renewalSMSObj).then(function (res) {
                                        //Navigate to OTP Page
                                        if(res.responseMessage.toLowerCase() == 'success') {
                                            var insertObject = {
                                                "autoRenewFlag": newRenewalHomeVm.isPaiChecked ? "true" : "false",
                                                "selectedAccnt": newRenewalHomeVm.benAccntNo ? newRenewalHomeVm.benAccntNo : ""
                                            }
                                            pailinkingRenwalService.setPaiInsertObject(insertObject);
                                            pailinkingRenwalService.isPaiRenewClicked = true;
                                            //set policy details Object
                                            pailinkingRenwalService.setPaiRenewPolicyDetails(policyDetails);
                                            pailinkingRenwalService.policyNo = policyDetails.journalNo;
                                            $state.go("menu.newRenewalOTP");
                                        }
                                    }, function (error) {
                                        utilityService.showErrorMessage(error.responseMessage);
                                    });
                            } else {
                                arogyaSanjeevaniService.showError($translate.instant('GI_KYC_ERROR_MSSG'));
                            }
                        }, function (error) {
                            arogyaSanjeevaniService.showError(error.responseMessage);
                        });
                    }
                }
            } else {
                var errorMssg;
                switch (statusCode) {
                    case "E002":
                        errorMssg = $translate.instant('GI_ERROR_RENEW_MSG_E002');
                        break;
                    case "E003":
                        errorMssg = $translate.instant('GI_ERROR_RENEW_MSG_E003');
                        break;
                    case "E004":
                        errorMssg = $translate.instant('GI_ERROR_RENEW_MSG_E004');
                        break;
                    case "E007":
                        errorMssg = $translate.instant('GI_ERROR_RENEW_MSG_E007');
                        break;
                }
                arogyaSanjeevaniService.showError(errorMssg);
            }
        }

        //Show Pai account List Popup
        newRenewalHomeVm.showpaiAccntPopup = function () {
            if (newRenewalHomeVm.paiAccList && newRenewalHomeVm.paiAccList.length > 0) {
                newRenewalHomeVm.popUpTemplate = pailinkingRenwalService.accountListPopUp("newRenewalHomeVm.paiAccList", "newRenewalHomeVm");
                newRenewalHomeVm.popUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                    template: newRenewalHomeVm.popUpTemplate,
                    scope: $scope
                });
            } else {
                utilityService.showErrorMessage($translate.instant('PAI_NO_ACCOUNT_ERROR'));
            }
        }

        /* Function to close PopUp of Account List*/
        newRenewalHomeVm.closeAccntPopUp = function (index) {
            if (newRenewalHomeVm.popUp) { newRenewalHomeVm.popUp.close() }
            newRenewalHomeVm.accountError = "";
            newRenewalHomeVm.balance = newRenewalHomeVm.paiAccList[index].accountBalance;
            newRenewalHomeVm.benAccntType = newRenewalHomeVm.paiAccList[index].accountType;
            newRenewalHomeVm.benAccntNo = newRenewalHomeVm.paiAccList[index].accountNumber;
            newRenewalHomeVm.selectedAccount = newRenewalHomeVm.paiAccList[index];
            newRenewalHomeVm.showPaiSelect = false;
        }

        newRenewalHomeVm.goBack = function () {
            $state.go('menu.accountOverviewMyBalance');
            homeScreenService.isInsuranceFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 4;
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            initPage();
        });

    }
]);
