angularApp.controller('ssPaymentSuccessController', [
    "$state", 
    "$scope", 
    "validateService",
    "utilityService","$filter","customerInfoService","sampoornSurakshaService","irctcService","$ionicPopup","openUrlInAppbroswerService","getAccountDetailsService","clickStreamService",
    function($state, 
        $scope, 
        validateService,
        utilityService,$filter,customerInfoService,sampoornSurakshaService,irctcService,$ionicPopup,openUrlInAppbroswerService,getAccountDetailsService,clickStreamService) {


        var ssPaymentSuccessVm = this;

        function initPage() {
           ssPaymentSuccessVm.emailId = sampoornSurakshaService.getFinalResponse().emailId;
           ssPaymentSuccessVm.formNumber = sampoornSurakshaService.getFinalResponse().coiNumber;
		   clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("LI_LYFINSPYMTSUC" + "_" + "LI_END_NXT_BTN"));
        }

        ssPaymentSuccessVm.redirect = function(){
        	getAccountDetailsService.tabIndex.tabIndex = 4;
			 $state.go('menu.accountOverviewMyBalance');
        }

        ssPaymentSuccessVm.downloadLetter = function(isEmail){
            var request = {
                "isEmail": isEmail,
				"coiNumber" : ssPaymentSuccessVm.formNumber,
                "type": "sampoornSuraksha1"
            }

            sampoornSurakshaService.getDocument(request).then(function(data) {
                    if(!isEmail){
			            var d = new Date();
						var currentDate = d.getDate()+""+(d.getMonth()+1)+""+d.getFullYear()+""+d.getHours()+""+d.getMinutes();
			            var filename =  data.fileName+currentDate+'.pdf';
			            var content =  data.pdf;
						var contentType = "application/pdf";
						if(utilityService.isAndroidPlatform()){
							ssPaymentSuccessVm.android = true;
							ssPaymentSuccessVm.folderpath = cordova.file.externalRootDirectory;
						}
						if(utilityService.isIOSPlatform()){
							ssPaymentSuccessVm.folderpath = cordova.file.applicationDirectory;
						}
						irctcService.savebase64AsPDFNew(ssPaymentSuccessVm.folderpath,filename,content,contentType);
						if(utilityService.isIOSPlatform()){
						var finalObject = {"folderpath":ssPaymentSuccessVm.folderpath,"filename":filename};
						openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
						}
						if(ssPaymentSuccessVm.android) {
							var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:ssPaymentSuccessVm.folderpath}"></div>';
				    			ssPaymentSuccessVm.downloadPopup = $ionicPopup.show({
				    				title: '',
				    				template: template,
				    				scope: $scope,
				    				cssClass: 'my-custom-popup',
				    				buttons: [{
				    					text:'OK',
				    					type: 'button-assertive',
				    					onTap: function() { 
				    						ssPaymentSuccessVm.downloadPopup.close();

				    					}
				    				}],
				    			});
						
						}
						ssPaymentSuccessVm.successPopup.close();
					}else{
						var alertPopup = $ionicPopup.alert({
							template: "<p class='fontWeight600 fss-col-verify font-size-16'>Email has been sent successfully</p>"
						});
                    }
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                }); 
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
