'use strict';
angularApp.controller('paclReqDetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"$ionicScrollDelegate","$filter","paclService","goldLoanRLMSService","homeScreenService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,
			$ionicScrollDelegate,$filter,paclService,goldLoanRLMSService,homeScreenService) {
			
			var paclReqDetailsVm = this;
			paclReqDetailsVm.detail = {};
			
			function initPage() {
				if(paclService.getPACLData()) {
					paclReqDetailsVm.detail = paclService.getPACLData();
					paclReqDetailsVm.detail.emi = parseInt(paclReqDetailsVm.detail.emi);
				}

				paclService.getLoanDetail().then(function(data) {
					paclReqDetailsVm.loanDetail = data;					
				},function(error){
                	utilityService.showErrorMessage(error.responseMessage);
            	});
			}

			paclReqDetailsVm.intrested = function() {
				var appRequest = {
  						"confirm": true
					};
				paclService.submitApplication(appRequest).then(function(data) {
					homeScreenService.isNotificationDataAvail = false;
					if(data.availedflg == "N"){
						paclService.setSuccessPACLData(data);
						// if (homeScreenService.offersData) {
                        //     for(var i = 0;i<homeScreenService.offersData.length; i++){ 
                        //         if (homeScreenService.offersData[i].category == "PACL") {
                        //             homeScreenService.offersData.splice(i, 1); 
                        //         }
                        //     }
                        // }						
                		$state.go('menu.paclCongratulations');                		
					}else{
						goldLoanRLMSService.showAlertPopup("alert","Dear Customer, it seems you have already availed this offer through other SBI channel. Kindly visit the branch",
                		"","menu.homeScreen","OK","","","");						
					}					
            	},function(error){
                	utilityService.showErrorMessage(error.responseMessage);
            	});
			}

			paclReqDetailsVm.notNow = function() {
				$state.go('menu.homeScreen');
			}

			paclReqDetailsVm.goBack = function() {			
				$state.go('menu.homeScreen');	
			}

		$scope.$on('$ionicView.beforeEnter', function () {
			initPage();
		});

		return this;
	}
		
]);


