angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
            .state('menu.patwlLandingPage', {
                url: '/patwlLanding',
                data: {
                    pageId: 'PATWL_LANDING'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/PATWL/patwlLandingPage.html',
                        controller: 'patwlLandingPageController',
                        controllerAs: 'patwlLandingPageVm'
                    }
                }
            })

                .state('menu.patwlReqDetails', {
                    url: '/patwlReqDetails',
                    data: {
                        pageId: 'PATWL_REQ_DETAILS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/PATWL/patwlReqDetails.html',
                            controller: 'patwlReqDetailsController',
                            controllerAs: 'patwlReqDetailsVm'
                        }
                    }
                })

                .state('menu.patwlApplicantDetails', {
                    url: '/patwlApplicantDetails',
                    data: {
                        pageId: 'PATWL_APPLICANT_DETAILS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/PATWL/patwlApplicantDetails.html',
                            controller: 'patwlApplicantDetailsController',
                            controllerAs: 'patwlApplicantDetailsVm'
                        }
                    }
                })

                .state('menu.patwlLoanDetails', {
                    url: '/patwlLoanDetails',
                    data: {
                        pageId: 'PATWL_LOAN_DETAILS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/PATWL/patwlLoanDetails.html',
                            controller: 'patwlLoanDetailsController',
                            controllerAs: 'patwlLoanDetailsVm'
                        }
                    }
                }) 

                .state('menu.patwlUploadPhotograph', {
                    url: '/patwlUploadPhotograph',
                    data: {
                        pageId: 'PATWL_UPLOAD_PHOTO'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/PATWL/patwlUploadPhotograph.html',
                            controller: 'patwlUploadPhotographController',
                            controllerAs: 'patwlUploadPhotographVm'
                        }
                    }
                })

                .state('menu.patwlOtp', {
                    url: '/patwlOtp',
                    data: {
                        pageId: 'PATWL_OTP'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/PATWL/patwlOtp.html',
                            controller: 'patwlOtpController',
                            controllerAs: 'patwlOtpVm'
                        }
                    }
                })

                 .state('menu.patwlReview', {
                    url: '/patwlReview',
                    data: {
                        pageId: 'PATWL_REVIEW'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/PATWL/patwlReview.html',
                            controller: 'patwlReviewController',
                            controllerAs: 'patwlReviewVm'
                        }
                    }
                }) 

                .state('menu.patwlCongratulations', {
                    url: '/patwlCongratulations',
                    data: {
                        pageId: 'PATWL_CONGRAT'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/PATWL/patwlCongratulations.html',
                            controller: 'patwlCongratulationsController',
                            controllerAs: 'patwlCongratulationsVm'
                        }
                    }
                }) 
        }
    ]);