'use strict';

angularApp.controller('patwlCongratulationsController', [
    "$state",
    "$scope",
    "$translate",  
    "$ionicSideMenuDelegate",
    "$filter", "paclService", "$ionicPopover", "utilityService", "openUrlInAppbroswerService",
    "irctcService", "$ionicPopup", "patwlService", "$ionicScrollDelegate","constantConfig",

    function($state,
        $scope,
        $translate,        
        $ionicSideMenuDelegate,
        $filter, paclService, $ionicPopover, utilityService, openUrlInAppbroswerService, 
        irctcService, $ionicPopup, patwlService, $ionicScrollDelegate,constantConfig) {

        var patwlCongratulationsVm = this; 
           patwlCongratulationsVm.isNightMode = false ;
          

        function initPage() {
            patwlCongratulationsVm.docList = [];

            if (patwlService.getCloudAppData()) {
                patwlCongratulationsVm.appStatusData = patwlService.getCloudAppData();
                patwlCongratulationsVm.refNo = patwlCongratulationsVm.appStatusData.yonoRef;
                patwlCongratulationsVm.loanAccountNo = patwlCongratulationsVm.appStatusData.loanAccountNo;
                patwlCongratulationsVm.loanAmount = patwlCongratulationsVm.appStatusData.loanAmount;
                patwlCongratulationsVm.docList = patwlCongratulationsVm.appStatusData.docList;   
                patwlCongratulationsVm.dealerName = patwlCongratulationsVm.appStatusData.dealerName;   
            }

            if (patwlService.getStatusEnquiryData()) {
                patwlCongratulationsVm.statusEnquiryData = patwlService.getStatusEnquiryData();
                patwlCongratulationsVm.refNo = patwlCongratulationsVm.statusEnquiryData.yonoRef;
                patwlCongratulationsVm.loanAccountNo = patwlCongratulationsVm.statusEnquiryData.loanAccountNo;
                patwlCongratulationsVm.loanAmount = patwlCongratulationsVm.statusEnquiryData.loanAmount;
                patwlCongratulationsVm.docList = patwlCongratulationsVm.statusEnquiryData.docList;  
                patwlCongratulationsVm.dealerName = patwlCongratulationsVm.statusEnquiryData.dealerName ; 
            }

            if(patwlService.getNightModeData()){
                patwlCongratulationsVm.nightModeData = patwlService.getNightModeData();
                patwlCongratulationsVm.refNo = patwlCongratulationsVm.nightModeData.yonoRef;
                patwlCongratulationsVm.loanAccountNo = patwlCongratulationsVm.nightModeData.customerAccountNo;
                patwlCongratulationsVm.isNightMode = true ;
            }
        }
       
        patwlCongratulationsVm.goToAccOverview = function() {
            $state.go('menu.accountOverviewMyBalance');
        }
      
        patwlCongratulationsVm.openPasswordInfo = function ($event) {
            patwlCongratulationsVm.leftStyle = "left : " + ($event.clientX - 10) + "px";           
            patwlCongratulationsVm.template = '<ion-popover-view class="loginnewarrow hmbr-info pswd-info-popnew passwordInfoPopup" id="runtimeHeight">'+ 
                '<div class="goldloan-arrow-upnew" style="{{patwlCongratulationsVm.leftStyle}}"></div>'+'<div class="padBottom3"><span class="inb-lock-roboto-bold font-size-14">Password eg. - 05Mar!8899</span></div>'+
                '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="patwlCongratulationsVm.closePopover()"><img src="img/Close.png" alt="" class="glPwdClose"></a>'+
                '<div class="popupDivider"></div>'+'<ion-content class="nfs-popover" has-bouncing="false">'+'<div class="row roboto-light font-size-12 padTop15">'+
                '<div class="col col-40"><div class="row"><div><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">05Mar</span><span>ch</span></div><span class="padLeft50">+</span></div><div class="row fss-text-center">Birth date and first 3 letters of birth month with first letter capital</div></div>'+
                '<div class="col col-20"><div class="row"><span class="inb-lock-roboto-bold font-size-12 text-underline-gl padLeft25">!</span><span class="padLeft50">+</span></div><div class="row fss-text-center">Mandatory "!" sign</div></div>'+
                '<div class="col col-40"><div class="row"><span class="padLeft50">9XXXXX</span><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">8899</span></div><div class="row fss-text-center padLeft25">Last 4 digits of the registered mobile number</div></div></div></ion-content></ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(patwlCongratulationsVm.template, {
                scope: $scope
            });
            $scope.popover.show($event);  
        }

        patwlCongratulationsVm.closePopover = function(){
            $scope.popover.hide();
            $ionicScrollDelegate.resize();
        }

        function savebase64AsPDF(filename, content, contentType) {
            patwlCongratulationsVm.popupFolderpath = "";
            var DataBlob = b64toBlob(content, contentType);
            if (utilityService.isAndroidPlatform()) {
                if(device.version==10){
                    const folderpath = cordova.file.externalDataDirectory;
                    patwlCongratulationsVm.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory,"") + filename;
                    window.resolveLocalFileSystemURL(folderpath, function(dir) {
                        dir.getFile(filename, { create: true }, function(file) {
                            file.createWriter(function(fileWriter) {
                                fileWriter.write(DataBlob);
                                //Show popup 
                                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PATWL_DOWNLOAD_RECEIPT" translate-values="{filePath:patwlCongratulationsVm.popupFolderpath}"></div>';
                                patwlCongratulationsVm.downloadPopup = $ionicPopup.show({
                                    title: '',
                                    template: template,
                                    scope: $scope,
                                    cssClass: 'my-custom-popup',
                                    buttons: [{
                                        text:'OK',
                                        type: 'button-assertive',
                                        onTap: function() {
                                            patwlCongratulationsVm.downloadPopup.close();
                                        }
                                    }],
                                });
                            }, function() {});
                        });
                    });
                }else{
                    //for Android below 10 and Android 11 not for 10
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
                        fileSystem.root.getDirectory("Download", {create: true, exclusive: false},function(dir) {
                            patwlCongratulationsVm.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true }, function(file) {
                                file.createWriter(function(fileWriter) {
                                    fileWriter.write(DataBlob);
                                    //Show popup 
                                    var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PATWL_DOWNLOAD_RECEIPT" translate-values="{filePath:patwlCongratulationsVm.popupFolderpath}"></div>';
                                    patwlCongratulationsVm.downloadPopup = $ionicPopup.show({
                                        title: '',
                                        template: template,
                                        scope: $scope,
                                        cssClass: 'my-custom-popup',
                                        buttons: [{
                                            text:'OK',
                                            type: 'button-assertive',
                                            onTap: function() {
                                                patwlCongratulationsVm.downloadPopup.close();
                                            }
                                        }],
                                    });
                                }, function() {});
                            });
                        });
                    });
                }                
			}
            if (utilityService.isIOSPlatform()) {
                const folderpath = cordova.file.documentsDirectory;
                const finalPath = folderpath + filename;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                        }, function () { });
                    });
                });
                cordova.plugins.fileOpener2.open(
                    finalPath,
                    'application/pdf', {
                        error: function (e) {
                            console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                        },
                        success: function () {
                            console.log('file opened successfully');
                        }
                    }
                );
            }
        }

        function b64toBlob(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        }

        patwlCongratulationsVm.downloadAndEmailDocument = function(doc,isEmail) {
            var payload = {};
                payload = {
                  "document": {
                    "docName": doc ? doc.docName : "",
                    "docID": doc ? doc.docID : ""
                  },
                  "isEmail": isEmail
                }         

            patwlService.downloadAndEmailDocument(payload).then(function(data) {
                if (isEmail == "Y") {
                    $ionicPopup.alert({
                        template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Email has been sent successfully</p>"
                    });
                }else{
                    var content = data.docList.base64;
                    var filename = doc.docName;
                    var contentType = "application/pdf";                   
                    savebase64AsPDF(filename,content,contentType);
                }
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });        

        return this;
    }
]);