'use strict';
angularApp.controller('carPersonalDetailsController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "$ionicScrollDelegate",
    "loanConfig",
    "homeLoanService", "validateService", "carLoanService","$filter",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, $ionicScrollDelegate, loanConfig, homeLoanService, validateService, carLoanService,$filter) {

        var carPersonalDetailsVm = this;
        carPersonalDetailsVm.detail = {};

        function initPage() {

            carPersonalDetailsVm.detail.currentAddressCheck = true;

            if (carLoanService.personalData) {

                carPersonalDetailsVm.detail = carLoanService.personalData;

                if (carLoanService.resumeData) {
                    carPersonalDetailsVm.masterData = carLoanService.resumeData.applicants[0];
                    carPersonalDetailsVm.masterData = carLoanService.resumeData.applicants[0];
                    carPersonalDetailsVm.genderMaster = carLoanService.resumeData.master.genders;
                    carPersonalDetailsVm.addressMaster = carLoanService.resumeData.master.residenceTypes;
                    carPersonalDetailsVm.martialStatus = carLoanService.resumeData.master.maritalStatuses;
                    carPersonalDetailsVm.states = carLoanService.resumeData.master.stateLists;
                } else {
                    carPersonalDetailsVm.masterData = carLoanService.userMaster;
                    carPersonalDetailsVm.genderMaster = carPersonalDetailsVm.masterData.master.genders;
                    carPersonalDetailsVm.addressMaster = carPersonalDetailsVm.masterData.master.residenceTypes;
                    carPersonalDetailsVm.martialStatus = carPersonalDetailsVm.masterData.master.maritalStatuses;
                    carPersonalDetailsVm.states = carPersonalDetailsVm.masterData.master.stateLists;
                }
                carPersonalDetailsVm.cities=[];
                carPersonalDetailsVm.cities.push(carPersonalDetailsVm.detail.city);
               // carPersonalDetailsVm.detail.city = cityObj;

                //var districtObj=JSON.parse(carPersonalDetailsVm.detail.district);
                carPersonalDetailsVm.districts=[];
                carPersonalDetailsVm.districts.push(carPersonalDetailsVm.detail.district);

                if(carPersonalDetailsVm.detail.currentCity){
                    carPersonalDetailsVm.currentCities = [];
                    carPersonalDetailsVm.currentCities.push(carPersonalDetailsVm.detail.currentCity);
                }

                if(carPersonalDetailsVm.detail.currentDistrict){
                    carPersonalDetailsVm.currentDistricts = [];
                    carPersonalDetailsVm.currentDistricts.push(carPersonalDetailsVm.detail.currentDistrict);
                }

                carPersonalDetailsVm.isFirstInit = false;

            } else if (carLoanService.resumeData) {
                carPersonalDetailsVm.isFirstInit = true;
                carPersonalDetailsVm.masterData = carLoanService.resumeData.applicants[0];
                carPersonalDetailsVm.genderMaster = carLoanService.resumeData.master.genders;
                carPersonalDetailsVm.addressMaster = carLoanService.resumeData.master.residenceTypes;
                carPersonalDetailsVm.martialStatus = carLoanService.resumeData.master.maritalStatuses;
                carPersonalDetailsVm.states = carLoanService.resumeData.master.stateLists;
                carLoanService.userMaster = carLoanService.resumeData;

                carPersonalDetailsVm.detail.maritalStatus = carPersonalDetailsVm.masterData.maritalStatus
                carPersonalDetailsVm.detail.residenceType = carPersonalDetailsVm.masterData.residenceType;
                carPersonalDetailsVm.detail.residenceMonth = carPersonalDetailsVm.masterData.monthsInCurrResidence;

                for (var i = 0; i < carPersonalDetailsVm.masterData.address.length; i++) {
                    if (carPersonalDetailsVm.masterData.address[i].addressType == 'P') {
                        if(carPersonalDetailsVm.masterData.address[i].addressLine2 == null){
                            carPersonalDetailsVm.masterData.address[i].addressLine2 = '';
                        }
                        if(carPersonalDetailsVm.masterData.address[i].addressLine3 == null){
                            carPersonalDetailsVm.masterData.address[i].addressLine3 = '';
                        }
                        carPersonalDetailsVm.detail.address = carPersonalDetailsVm.masterData.address[i].addressLine1 + ' ' + carPersonalDetailsVm.masterData.address[i].addressLine2 + ' ' + carPersonalDetailsVm.masterData.address[i].addressLine3;
                        carPersonalDetailsVm.masterData.permanentAddress = {};
                        carPersonalDetailsVm.masterData.permanentAddress.addressLine1 = carPersonalDetailsVm.masterData.address[i].addressLine1;
                        carPersonalDetailsVm.masterData.permanentAddress.addressLine2 = carPersonalDetailsVm.masterData.address[i].addressLine2;
                        carPersonalDetailsVm.masterData.permanentAddress.addressLine3 = carPersonalDetailsVm.masterData.address[i].addressLine3;
                        carPersonalDetailsVm.masterData.permanentAddress.pincode = carPersonalDetailsVm.masterData.address[i].pincode;

                        if(carPersonalDetailsVm.masterData.address[i].pincode)
                        {
                           carPersonalDetailsVm.detail.address=carPersonalDetailsVm.detail.address + ','+carPersonalDetailsVm.masterData.address[i].pincode;
                        }

                        var cityObj=JSON.parse(carPersonalDetailsVm.masterData.address[i].cityText);
                        carPersonalDetailsVm.cities=[];
                        carPersonalDetailsVm.cities.push(cityObj);
                        carPersonalDetailsVm.detail.city = cityObj;

                        var districtObj=JSON.parse(carPersonalDetailsVm.masterData.address[i].districtText);
                        carPersonalDetailsVm.districts=[];
                        carPersonalDetailsVm.districts.push(districtObj);
                        carPersonalDetailsVm.detail.district = districtObj;

                        carPersonalDetailsVm.detail.state = JSON.parse(carPersonalDetailsVm.masterData.address[i].stateText);

                        //carPersonalDetailsVm.detail.city = JSON.parse(carPersonalDetailsVm.masterData.address[i].cityText);// carPersonalDetailsVm.detail)

                    } else if (carPersonalDetailsVm.masterData.address[i].addressType == 'C') {

                        carPersonalDetailsVm.detail.addressLine1 = carPersonalDetailsVm.masterData.address[i].addressLine1;
                        carPersonalDetailsVm.detail.addressLine2 = carPersonalDetailsVm.masterData.address[i].addressLine2;
                        carPersonalDetailsVm.detail.addressLine3 = carPersonalDetailsVm.masterData.address[i].addressLine3;
                        carPersonalDetailsVm.detail.currentPincode = carPersonalDetailsVm.masterData.address[i].pincode;

                        var cityObj=JSON.parse(carPersonalDetailsVm.masterData.address[i].cityText);
                        carPersonalDetailsVm.currentCities=[];
                        carPersonalDetailsVm.currentCities.push(cityObj);
                        carPersonalDetailsVm.detail.currentCity = cityObj;

                        var districtObj=JSON.parse(carPersonalDetailsVm.masterData.address[i].districtText);
                        carPersonalDetailsVm.currentDistricts=[];
                        carPersonalDetailsVm.currentDistricts.push(districtObj);
                        carPersonalDetailsVm.detail.currentDistrict = districtObj;

                        carPersonalDetailsVm.detail.currentState = JSON.parse(carPersonalDetailsVm.masterData.address[i].stateText);

                        // carPersonalDetailsVm.detail.currentCity = carPersonalDetailsVm.masterData.address[i].districtText;
                        // carPersonalDetailsVm.detail.currentState = carPersonalDetailsVm.masterData.address[i].stateText;
                        carPersonalDetailsVm.detail.currentAddressCheck = false;
                    }

                    //carPersonalDetailsVm.detail.address = carPersonalDetailsVm.masterData.address.addressLine1 + ' ' + carPersonalDetailsVm.masterData.address.addressLine2 + ' ' + carPersonalDetailsVm.masterData.address.addressLine3;
                }
            } else {
                carPersonalDetailsVm.isFirstInit = true;
                carPersonalDetailsVm.masterData = carLoanService.userMaster;
                carPersonalDetailsVm.genderMaster = carPersonalDetailsVm.masterData.master.genders;
                carPersonalDetailsVm.addressMaster = carPersonalDetailsVm.masterData.master.residenceTypes;
                carPersonalDetailsVm.martialStatus = carPersonalDetailsVm.masterData.master.maritalStatuses;
                carPersonalDetailsVm.states = carPersonalDetailsVm.masterData.master.stateLists;
                carPersonalDetailsVm.detail.address = carPersonalDetailsVm.masterData.permanentAddress.addressLine1 + ' ' + carPersonalDetailsVm.masterData.permanentAddress.addressLine2 + ' ' + carPersonalDetailsVm.masterData.permanentAddress.addressLine3;
                if(carPersonalDetailsVm.masterData.permanentAddress.pincode)
                 {
                    carPersonalDetailsVm.detail.address=carPersonalDetailsVm.detail.address + ','+carPersonalDetailsVm.masterData.permanentAddress.pincode;
                 }

            }
            carPersonalDetailsVm.isMaskPan = true;
            carPersonalDetailsVm.isMaskAd = true;
            carPersonalDetailsVm.isMaskEmail = true;
            carPersonalDetailsVm.isMaskMobile = true;
            carPersonalDetailsVm.isMaskDob = true;





            //carPersonalDetailsVm.detail.residenceType = carPersonalDetailsVm.masterData.master.addressTypes[0].key;
            carPersonalDetailsVm.detail.title = homeLoanService.findObject(carPersonalDetailsVm.masterData.title, carLoanService.userMaster.master.titles);



            carPersonalDetailsVm.detail.custName = carPersonalDetailsVm.detail.title.value + ' ' + carPersonalDetailsVm.masterData.firstName + ' ' + carPersonalDetailsVm.masterData.lastName;
            carPersonalDetailsVm.detail.custNameFull = carPersonalDetailsVm.masterData.firstName + ' ' + carPersonalDetailsVm.masterData.lastName;
            carPersonalDetailsVm.detail.firstName = carPersonalDetailsVm.masterData.firstName;
            carPersonalDetailsVm.detail.lastName = carPersonalDetailsVm.masterData.lastName;

            carPersonalDetailsVm.detail.dob = $filter('homeDateFormat')(carPersonalDetailsVm.masterData.dob);
            var str = carPersonalDetailsVm.detail.dob.split(' ');
            var year = str[2];
            var Mask = year.replace(year,'XXXX');
            carPersonalDetailsVm.detail.dobMask = str[0]+' '+str[1]+' '+Mask;

            carPersonalDetailsVm.detail.pan = carPersonalDetailsVm.masterData.pan;

            carPersonalDetailsVm.detail.aadhaar = carPersonalDetailsVm.masterData.aadhaar;

            carPersonalDetailsVm.detail.mobile = carPersonalDetailsVm.masterData.mobile;
            if (!carLoanService.personalData) {
                carPersonalDetailsVm.detail.email = carPersonalDetailsVm.masterData.email;
            }
            if (carPersonalDetailsVm.masterData.email) {
                carPersonalDetailsVm.showMaskedEmail = true;
            } else {
                carPersonalDetailsVm.showMaskedEmail = false;
            }

            carPersonalDetailsVm.detail.permanentAddressLine1 = carPersonalDetailsVm.masterData.permanentAddress.addressLine1;
            carPersonalDetailsVm.detail.permanentAddressLine2 = carPersonalDetailsVm.masterData.permanentAddress.addressLine2;
            carPersonalDetailsVm.detail.permanentAddressLine3 = carPersonalDetailsVm.masterData.permanentAddress.addressLine3;
            carPersonalDetailsVm.detail.mobile = carPersonalDetailsVm.masterData.mobile ? carPersonalDetailsVm.masterData.mobile : "";
            if(carPersonalDetailsVm.isFirstInit){
                if (carPersonalDetailsVm.masterData.permanentAddress.pincode) {
                    carPersonalDetailsVm.detail.pincode = carPersonalDetailsVm.masterData.permanentAddress.pincode;
                   // carPersonalDetailsVm.getCityState(carPersonalDetailsVm.masterData.permanentAddress.pincode, "P");

                }
            }
            

            carPersonalDetailsVm.hideAllFields();
            carLoanService.dob = carPersonalDetailsVm.masterData.dob;




        };

        carPersonalDetailsVm.unmaskDob = function(){
            carPersonalDetailsVm.isMaskDob = !carPersonalDetailsVm.isMaskDob;
        }

        carPersonalDetailsVm.loadDistrict = function(type){
            var masterKey = "";
            if(type == 'district'){
                carPersonalDetailsVm.detail.district = "";
                carPersonalDetailsVm.detail.city="";
                masterKey = carPersonalDetailsVm.detail.state.key;
            }else if(type == 'subdistrict'){
                carPersonalDetailsVm.detail.city="";
                masterKey = carPersonalDetailsVm.detail.district.key;
            }

            var request = {
              "key": masterKey,
              "action": type
            };

            carLoanService.getDistrictCity(request).then(function(data) {
                if(type == 'district'){
                    carPersonalDetailsVm.districts = data.info;
                }else if(type == 'subdistrict'){
                    carPersonalDetailsVm.cities = data.info;
                }
                
                
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        carPersonalDetailsVm.loadDistrictCurrent = function(type){
                var masterKey = "";
                if(type == 'district'){
                    carPersonalDetailsVm.detail.currentDistrict = "";
                    carPersonalDetailsVm.detail.currentCity="";
                    masterKey = carPersonalDetailsVm.detail.currentState.key;
                }else if(type == 'subdistrict'){
                    carPersonalDetailsVm.detail.currentCity="";
                    masterKey = carPersonalDetailsVm.detail.currentDistrict.key;
                }

                var request = {
                  "key": masterKey,
                  "action": type
                };

                carLoanService.getDistrictCity(request).then(function(data) {
                    if(type == 'district'){
                        carPersonalDetailsVm.currentDistricts = data.info;
                    }else if(type == 'subdistrict'){
                        carPersonalDetailsVm.currentCities = data.info;
                    }
                    
                    
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }


        carPersonalDetailsVm.loadCityState = function() {
            if (carPersonalDetailsVm.detail.currentPincode.length == 6) {
                carPersonalDetailsVm.getCityState(carPersonalDetailsVm.detail.currentPincode, "C");
            }
        }

        carPersonalDetailsVm.showCurrentAddress = function() {
            $ionicScrollDelegate.resize();
            carPersonalDetailsVm.detail.addressLine1 = "";
            carPersonalDetailsVm.detail.addressLine2 = "";
            carPersonalDetailsVm.detail.addressLine3 = "";
            carPersonalDetailsVm.detail.currentPincode = "";
            carPersonalDetailsVm.detail.currentCity = "";
            carPersonalDetailsVm.detail.currentState="";
            carPersonalDetailsVm.detail.residenceType="";
            carPersonalDetailsVm.detail.residenceMonth="";
        }


        carPersonalDetailsVm.getCityState = function(pinCode, addType) {
            var obj = {
                "pinCode": pinCode
            };
            homeLoanService.getPincodeData(obj).then(function(data) {
                //carLoanService.stateCitydata=data;
                if (addType == "P") {

                    carPersonalDetailsVm.detail.address = carPersonalDetailsVm.detail.address + ' ' + data.districtName + ' ' + data.stateName;
                    carPersonalDetailsVm.detail.district = data.cityName;
                    carPersonalDetailsVm.detail.districtCode = data.cityCode;
                    carPersonalDetailsVm.detail.state = data.stateName;
                    carPersonalDetailsVm.detail.stateCode = data.stateCode;
                } else if (addType == "C") {
                    carPersonalDetailsVm.detail.currentCity = data.districtName;

                    carPersonalDetailsVm.detail.currentCityCode = data.cityCode;

                    carPersonalDetailsVm.detail.currentState = data.stateName;
                    carPersonalDetailsVm.detail.currentStateCode = data.stateCode;
                    carPersonalDetailsVm.detail.currentPincode = pinCode;
                }
            }, function(error) {

                carPersonalDetailsVm.detail.currentCity = "";
                carPersonalDetailsVm.detail.currentState = "";
                carPersonalDetailsVm.detail.currentStateCode = "";
                carPersonalDetailsVm.detail.currentCityCode = "";
            });
        }


        carPersonalDetailsVm.unmaskData = function(idType) {
            var request = {
                "type": idType,
                "loanType": "car"
            }
            if (idType == 'pan' || idType == 'aadhaar' || idType == 'mobile' || idType == 'email' || idType == 'dob') {
                homeLoanService.getUnmaskData(request).then(function(data) {
                    if (idType == 'pan') {
                        carPersonalDetailsVm.isMaskPan = false;
                        carPersonalDetailsVm.detail.pan = data;
                    } else if (idType == 'aadhaar') {
                        carPersonalDetailsVm.isMaskAd = false;
                        carPersonalDetailsVm.detail.aadhaar = data;
                    } else if (idType == 'mobile') {
                        carPersonalDetailsVm.isMaskMobile = false;
                        carPersonalDetailsVm.detail.mobile = data;
                    } else if (idType == 'email') {
                        carPersonalDetailsVm.isMaskEmail = false;
                        carPersonalDetailsVm.detail.email = data;
                    } else if (idType == 'dob'){
                        carPersonalDetailsVm.isMaskDob = false;
                        carPersonalDetailsVm.detail.dob = data;
                    }

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                if (idType == 'npan') {
                    carPersonalDetailsVm.isMaskPan = true;
                    carPersonalDetailsVm.detail.pan = carPersonalDetailsVm.masterData.pan;
                } else if (idType == 'naadhaar') {
                    carPersonalDetailsVm.isMaskAd = true;
                    carPersonalDetailsVm.detail.aadhaar = carPersonalDetailsVm.masterData.aadhaar;
                } else if (idType == 'nmobile') {
                    carPersonalDetailsVm.isMaskMobile = true;
                    carPersonalDetailsVm.detail.mobile = carPersonalDetailsVm.masterData.mobile;
                } else if (idType == 'nemail') {
                    carPersonalDetailsVm.isMaskEmail = true;
                    carPersonalDetailsVm.detail.email = carPersonalDetailsVm.masterData.email;
                } else if(idType == 'ndob'){
                    carPersonalDetailsVm.isMaskDob = true;
                    carPersonalDetailsVm.detail.dob = carPersonalDetailsVm.masterData.dob;
                    
                }

            }

        }

        carPersonalDetailsVm.applyknowmore = function(group) {

        }

        carPersonalDetailsVm.applyloan = function(group) {

        }

        carPersonalDetailsVm.hideAllFields = function() {
            carPersonalDetailsVm.isNetMonthlyIncome = false;
            //carPersonalDetailsVm.isNetAnnualIncome = false;
            carPersonalDetailsVm.isIncomeFromHouseProp = false;
            carPersonalDetailsVm.isEmployerType = false;
            carPersonalDetailsVm.isRetirementAge = false;
            carPersonalDetailsVm.isProfessionType = false;
            carPersonalDetailsVm.isProfession = false;
            carPersonalDetailsVm.isWorkExp = false;
            carPersonalDetailsVm.isMonthsInCurrJob = false;
            carPersonalDetailsVm.isMonthsInCurrJobProfession = false;
        }

        carPersonalDetailsVm.goToAO = function() {
            $state.go('menu.accountOverviewMyBalance');
        }

        $scope.$on('$ionicView.loaded', function() {

        });

        $scope.$on('$ionicView.beforeEnter', function() {
         if (utilityService.isIOSPlatform())
          {
           carPersonalDetailsVm.scroll=false;
          }

          else
          {
           carPersonalDetailsVm.scroll=true;
          }
            initPage();
        });

        carPersonalDetailsVm.validateForm = function() {
            carPersonalDetailsVm.errObj = {};

            if (carPersonalDetailsVm.detail.currentAddressCheck)
            {
                if (validateService.isValidMonthsInResidence(carPersonalDetailsVm.detail.residenceMonth)) {
                    carPersonalDetailsVm.errObj.residenceMonth = validateService.isValidMonthsInResidence(carPersonalDetailsVm.detail.residenceMonth);
                }
                 if (validateService.isValidResidanceType(carPersonalDetailsVm.detail.residenceType)) {
                    carPersonalDetailsVm.errObj.residenceType = validateService.isValidResidanceType(carPersonalDetailsVm.detail.residenceType);
                }
            }


            if (validateService.isValidEmailHL(carPersonalDetailsVm.detail.email)) {
                carPersonalDetailsVm.errObj.email = validateService.isValidEmailHL(carPersonalDetailsVm.detail.email);
            }           

            if (validateService.isMarritialStatus(carPersonalDetailsVm.detail.maritalStatus)) {
                carPersonalDetailsVm.errObj.maritalStatus = validateService.isMarritialStatus(carPersonalDetailsVm.detail.maritalStatus);
            }

            if(validateService.hlValidState(carPersonalDetailsVm.detail.state)){
                carPersonalDetailsVm.errObj.state = validateService.hlValidState(carPersonalDetailsVm.detail.state);
            }
            if(validateService.hlValidDistrict(carPersonalDetailsVm.detail.district)){
                carPersonalDetailsVm.errObj.district = validateService.hlValidDistrict(carPersonalDetailsVm.detail.district);
            }
            if(validateService.hlValidCity(carPersonalDetailsVm.detail.city)){
                carPersonalDetailsVm.errObj.city = validateService.hlValidCity(carPersonalDetailsVm.detail.city);
            }

            if (!carPersonalDetailsVm.detail.currentAddressCheck) {
                if (validateService.isValidPincode(carPersonalDetailsVm.detail.currentPincode)) {
                    carPersonalDetailsVm.errObj.currentPincode = validateService.isValidPincode(carPersonalDetailsVm.detail.currentPincode);
                }
                if (validateService.isValidAdress(carPersonalDetailsVm.detail.addressLine1)) {
                    carPersonalDetailsVm.errObj.addressLine1 = validateService.isValidAdress(carPersonalDetailsVm.detail.addressLine1);
                }

                if (validateService.isValidResidanceType(carPersonalDetailsVm.detail.residenceType)) {
                    carPersonalDetailsVm.errObj.residenceTypeCurrent = validateService.isValidResidanceType(carPersonalDetailsVm.detail.residenceType);
                }

                if (validateService.isValidMonthsInResidence(carPersonalDetailsVm.detail.residenceMonth)) {
                    carPersonalDetailsVm.errObj.residenceMonthCurrent = validateService.isValidMonthsInResidence(carPersonalDetailsVm.detail.residenceMonth);
                }

                if(validateService.hlValidState(carPersonalDetailsVm.detail.currentState)){
                    carPersonalDetailsVm.errObj.currentState = validateService.hlValidState(carPersonalDetailsVm.detail.currentState);
                }
                if(validateService.hlValidDistrict(carPersonalDetailsVm.detail.currentDistrict)){
                    carPersonalDetailsVm.errObj.currentDistrict = validateService.hlValidDistrict(carPersonalDetailsVm.detail.currentDistrict);
                }
                if(validateService.hlValidCity(carPersonalDetailsVm.detail.currentCity)){
                    carPersonalDetailsVm.errObj.currentCity = validateService.hlValidCity(carPersonalDetailsVm.detail.currentCity);
                }

                // if (!carPersonalDetailsVm.detail.currentState) {
                //     carPersonalDetailsVm.errObj.currentState = "Please enter Valid State";
                // }
                // if (!carPersonalDetailsVm.detail.currentCity) {
                //     carPersonalDetailsVm.errObj.currentCity = "Please enter Valid City";
                // }
            }

            return (angular.equals({}, carPersonalDetailsVm.errObj)) ? true : false;
        }

        function saveApplication() {
            var addressType = "";
            var addressArray = [];




            var addObjP = {
                "addressType": 'P',
                "addressLine1": carPersonalDetailsVm.masterData.permanentAddress.addressLine1,
                "addressLine2": carPersonalDetailsVm.masterData.permanentAddress.addressLine2,
                "addressLine3": carPersonalDetailsVm.masterData.permanentAddress.addressLine3,
                //"districtCode": carPersonalDetailsVm.detail.districtCode,
                "districtCode": carPersonalDetailsVm.detail.district.key,
                //  "cityCode": carPersonalDetailsVm.detail.districtCode,
                "cityCode": carPersonalDetailsVm.detail.city.key,
                //   "stateCode": carPersonalDetailsVm.detail.stateCode,
                "stateCode": carPersonalDetailsVm.detail.state.key,
                "districtText": JSON.stringify(carPersonalDetailsVm.detail.district),
                "cityText": JSON.stringify(carPersonalDetailsVm.detail.city) ,
                "stateText": JSON.stringify(carPersonalDetailsVm.detail.state),
                "pincode": carPersonalDetailsVm.masterData.permanentAddress.pincode

            }
            addressArray.push(addObjP);
            if (!carPersonalDetailsVm.detail.currentAddressCheck) {


                var addObj = {
                    "addressType": 'C',
                    "addressLine1": carPersonalDetailsVm.detail.addressLine1,
                    "addressLine2": carPersonalDetailsVm.detail.addressLine2,
                    "addressLine3": carPersonalDetailsVm.detail.addressLine3,
                    // "districtCode": carPersonalDetailsVm.detail.currentCityCode,
                    "districtCode": carPersonalDetailsVm.detail.currentDistrict.key,
                    // "cityCode": carPersonalDetailsVm.detail.currentCityCode,
                    "cityCode": carPersonalDetailsVm.detail.currentCity.key,
                    // "stateCode": carPersonalDetailsVm.detail.currentStateCode,
                    "stateCode": carPersonalDetailsVm.detail.currentState.key,
                    "districtText": JSON.stringify(carPersonalDetailsVm.detail.currentDistrict),
                    "cityText": JSON.stringify(carPersonalDetailsVm.detail.currentCity),
                    "stateText": JSON.stringify(carPersonalDetailsVm.detail.currentState),
                    "pincode": carPersonalDetailsVm.detail.currentPincode
                }

                addressArray.push(addObj);


            }
            carLoanService.personalDetailsArray = addressArray;

            var request = {
                "loanType": "car",
                "custFlag": "",
                "page": "personalDetails",

                "yonoRef": "",
                "losRef": "",
                "loanStatus": "",
                "loanStage": "",
                "loanAmount": "",
                "loanTenure": "",
                "applicantType": "",
                "applicantState": "",
                "applicantStatus": "",
                "firstName": carPersonalDetailsVm.masterData.firstName,
                "middleName": "",
                "stateOfPurchase": "",
                "stateOfPurchaseValue": "",
                "cityOfPurchase": "",
                "cityOfPurchaseValue": "",
                "lastName": carPersonalDetailsVm.masterData.lastName,
                "dob": "",
                "pan": "",
                "aadhaar": "",
                "residenceType": carPersonalDetailsVm.detail.residenceType,
                "maritalStatus": carPersonalDetailsVm.detail.maritalStatus,
                "gender": "",
                "employmentType": "",
                "netMonthlyIncome": "",
                "emis": [{
                    "type": "",
                    "typeValue": "",
                    "amount": ""
                }],
                "totalExistingEMI": "",
                "retirementAge": "",
                "workExp": "",
                "monthsInCurrJob": "",
                "make": "",
                "makeValue": "",
                "model": "",
                "modelValue": "",
                "variant": "",
                "variantValue": "",
                "exshowRoomPrice": "",
                "proforma": "",
                "warantty": "",
                "rto": "",
                "insurance": "",
                "accessories": "",
                "others": "",
                "dealerName": "",
                "onRoadPrice": "",
                "minVehiclecost": "",
                "maxVehiclecost": "",
                "minIncomeCost": "",
                "maxIncomeCost": "",
                "minloanAmt": "",
                "maxloanAmt": "",
                "minTenure": "",
                "maxTenure": "",
                "roi": "string",
                "applicants": [{
                    "loanType": "",
                    "custFlag": "",
                    "cifNo": "",
                    "yonoRef": "",
                    "loanAmount": "",
                    "loanTenure": "",
                    "applicantType": "",
                    "firstName": carPersonalDetailsVm.masterData.firstName,
                    "middleName": "",
                    "lastName": carPersonalDetailsVm.masterData.lastName,
                    "dob": "",
                    "pan": "",
                    "aadhaar": "",
                    "residenceType": carPersonalDetailsVm.detail.residenceType,
                    "residenceTypeValue": "",
                    "maritalStatus": carPersonalDetailsVm.detail.maritalStatus,

                    "workExpinyears": "",
                    "currJobinyears": "",
                    "workExpinmoths": "",
                    "currJobinmonths": "",
                    "maritalStatusValue": "",
                    "gender": "",
                    "genderValue": "",
                    "employmentType": "",
                    "employmentTypeValue": "",
                    "address": addressArray,
                    "netMonthlyIncome": "",
                    "emi": [{
                        "type": "",
                        "typeValue": "",
                        "amount": ""
                    }],
                    "totalExistingEMI": "",
                    "retirementAge": "",
                    "workExp": "",
                    "monthsInCurrJob": "",
                    "incomeHouseProperty": "",
                    "monthsInCurrResidence": carPersonalDetailsVm.detail.residenceMonth,
                    "primaryApplicantRef": "",
                    "applicantState": "",
                    "loanApprovalStatus": "",
                    "title": carPersonalDetailsVm.masterData.title,
                    "titleValue": carPersonalDetailsVm.detail.title.value,
                    "email": carPersonalDetailsVm.detail.email,
                    "age": "",
                    "mobile": "",
                    "accountNo": "",
                    "motherMaidenName": "",
                    "tan": "",
                    "qualification": "",
                    "category": "",
                    "categoryValue": "",
                    "employerType": "",
                    "employerTypeValue": "",
                    "professionTypeValue": "",
                    "professionType": "",
                    "officeName": "",
                    "officalEmail": ""
                }],
                "channel": {
                    "mobile": {
                        "pageNos": [
                            ""
                        ]
                    },
                    "portal": {
                        "pageNos": [
                            ""
                        ]
                    }
                }
            }


            carLoanService.saveData(request).then(function(data) {
                carLoanService.saveObj = request;

                carLoanService.personalData = carPersonalDetailsVm.detail;

                $state.go('menu.carLoanWorkDetails');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        carPersonalDetailsVm.goToNextPage = function() {
            if (carPersonalDetailsVm.validateForm()) {
                saveApplication();

            }
        }
        carPersonalDetailsVm.goBack = function() {
            $state.go('menu.loans');

        }



        return this;
    }


]);