'use strict';
angularApp.controller('eduCheckStatusController', [
		"$state",
		"$scope",		
		"utilityService",
		"$filter","educationLoanService",
		function($state, $scope,utilityService,$filter,educationLoanService) {
			
			var eduCheckStatusVm = this;

			function initPage(){
				eduCheckStatusVm.loanAmount = educationLoanService.getKnowMore().accountSummary.accountNumber;
				eduCheckStatusVm.amountRequested = educationLoanService.getKnowMore().accountSummary.lastAmountRequested;
				eduCheckStatusVm.requestDate = educationLoanService.getKnowMore().accountSummary.lastRequestDate;
				if(educationLoanService.getKnowMore().accountSummary.stage == "2"){
					eduCheckStatusVm.isInitiated = true;
					eduCheckStatusVm.isDisbursed = true;
				}else if(educationLoanService.getKnowMore().accountSummary.stage == "3"){
					eduCheckStatusVm.isInitiated = false;
					eduCheckStatusVm.isDisbursed = true;
				}else if(educationLoanService.getKnowMore().accountSummary.stage == "4"){
					eduCheckStatusVm.isInitiated = false;
					eduCheckStatusVm.isDisbursed = false;
				}
			}

			eduCheckStatusVm.goToPreviousPage = function(){
				$state.go('menu.eduSummary');
			}

			eduCheckStatusVm.goBack = function(){
				$state.go('menu.homeScreen');
			}

			eduCheckStatusVm.requestDisburse = function(){
				$state.go('menu.eduRequestDisburse');
			}

			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
			});

			return this;
		}

		
]);


