'use strict';

angularApp.controller('glCongratulationsRLMSController', [
    "$state",
    "$scope",
    "$translate",
    "$filter", "goldLoanRLMSService", "$ionicPopover", "utilityService",
    "openUrlInAppbroswerService", "$ionicPopup", "$ionicScrollDelegate", "constantConfig","homeScreenService","getAccountDetailsService",

    function($state,
        $scope,
        $translate,
        $filter, goldLoanRLMSService, $ionicPopover, utilityService,
        openUrlInAppbroswerService, $ionicPopup, $ionicScrollDelegate, constantConfig,homeScreenService,getAccountDetailsService) {

        var glCongratulationsVm = this;       

        function initPage() {
            if(goldLoanRLMSService.resumeData) {
                glCongratulationsVm.refNo = goldLoanRLMSService.resumeData.yonoRef;                
            } else {
                glCongratulationsVm.refNo = goldLoanRLMSService.userMaster.yonoRef;
            }
            glCongratulationsVm.branchVisited = goldLoanRLMSService.getLoanSummaryData().selectedBranch.branchName + ' ' + "("+ goldLoanRLMSService.getLoanSummaryData().selectedBranch.brCode +")";
        };

        glCongratulationsVm.openProofInfo = function ($event) {
            glCongratulationsVm.leftStyle = "left : " + ($event.clientX - 25) + "px";           
            glCongratulationsVm.template = '<ion-popover-view class="loginnewarrow hmbr-info hmbr-info-popnew popOverIDProofGL" id="runtimeHeight" >' + '<div class="edu-arrow-downnew" style="{{glCongratulationsVm.leftStyle}}"></div>' + 
            '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="glCongratulationsVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90 nfs-popover" has-bouncing="false">' +
            '<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12">'+
            '<div>Passport, Proof of possession of Aadhaar Number, Voter’s ID Card and Driving License are valid proof of Identity, Job card issue by NREGA, Letter issued by the National Population Register.</div>' + 
            '</div>' + '</ion-content>' + '</ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(glCongratulationsVm.template, {
                scope: $scope
            });
            $scope.popover.show($event);
               
        }

        glCongratulationsVm.openPasswordInfo = function ($event) {
            glCongratulationsVm.leftStyle = "left : " + ($event.clientX - 10) + "px";           
            glCongratulationsVm.template = '<ion-popover-view class="loginnewarrow hmbr-info pswd-info-popnew-rlms passwordInfoPopup-rlms" id="runtimeHeight">'+ 
                '<div class="goldloan-arrow-upnew-rlms" style="{{glCongratulationsVm.leftStyle}}"></div>'+'<div class="padBottom3"><span class="inb-lock-roboto-bold font-size-14">Password eg. - 05Mar!8899</span></div>'+
                '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="glCongratulationsVm.closePopover()"><img src="img/Close.png" class="glPwdClose"></a>'+
                '<div class="popupDivider"></div>'+'<ion-content class="nfs-popover" has-bouncing="false">'+'<div class="row roboto-light font-size-12 padTop15">'+
                '<div class="col col-40"><div class="row"><div><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">05Mar</span><span>&nbsp;ch</span></div><span class="padLeft50">+</span></div><div class="row fss-text-center">Birth date and first 3 letters of birth month with first letter capital</div></div>'+
                '<div class="col col-20"><div class="row"><span class="inb-lock-roboto-bold font-size-12 text-underline-gl padLeft25">!</span><span class="padLeft50">+</span></div><div class="row fss-text-center">Mandatory "!" sign</div></div>'+
                '<div class="col col-40"><div class="row"><span class="padLeft30">9XXXXX</span><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">&nbsp;8899</span></div><div class="row fss-text-center padLeft25">Last 4 digits of the registered mobile number</div></div></div></ion-content></ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(glCongratulationsVm.template, {
                scope: $scope
            });
            $scope.popover.show($event);               
        }     

         function savebase64AsPDF(filename, content, contentType) {
            glCongratulationsVm.popupFolderpath = "";
            var DataBlob = b64toBlob(content, contentType);
            if (utilityService.isAndroidPlatform()) {
                if(device.version==10) {
                    const folderpath = cordova.file.externalDataDirectory;
                    glCongratulationsVm.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory,"") + filename;
                    window.resolveLocalFileSystemURL(folderpath, function(dir) {
                        dir.getFile(filename, { create: true }, function(file) {
                            file.createWriter(function(fileWriter) {
                                fileWriter.write(DataBlob);
                                 //Show popup 
                                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="GL_DOWNLOAD_RECEIPT" translate-values="{filePath:glCongratulationsVm.popupFolderpath}"></div>';
                                glCongratulationsVm.downloadPopup = $ionicPopup.show({
                                    title: '',
                                    template: template,
                                    scope: $scope,
                                    cssClass: 'my-custom-popup',
                                    buttons: [{
                                        text:'OK',
                                        type: 'button-assertive',
                                        onTap: function() { 
                                            glCongratulationsVm.downloadPopup.close();
                                        }
                                    }],
                                });
                            }, function() {});
                        });
                    });
                } else {
                    //for Android below 10 and Android 11 not for 10
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
                        fileSystem.root.getDirectory("Download", {create: true, exclusive: false},function(dir) {
                            glCongratulationsVm.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true }, function(file) {
                                file.createWriter(function(fileWriter) {
                                    fileWriter.write(DataBlob);
                                     //Show popup 
                                    var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="GL_DOWNLOAD_RECEIPT" translate-values="{filePath:glCongratulationsVm.popupFolderpath}"></div>';
                                    glCongratulationsVm.downloadPopup = $ionicPopup.show({
                                        title: '',
                                        template: template,
                                        scope: $scope,
                                        cssClass: 'my-custom-popup',
                                        buttons: [{
                                            text:'OK',
                                            type: 'button-assertive',
                                            onTap: function() { 
                                                glCongratulationsVm.downloadPopup.close();
                                            }
                                        }],
                                    });
                                }, function() {});
                            });
                        });
                    });
                }               
            }
            if (utilityService.isIOSPlatform()){
                const folderpath = cordova.file.documentsDirectory;
                const finalPath = folderpath + filename;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function (fileWriter) {
                            fileWriter.write(DataBlob);
                        }, function () { });
                    });
                });
                cordova.plugins.fileOpener2.open(
                    finalPath,
                    'application/pdf', {
                        error: function (e) {
                            console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                        },
                        success: function () {
                            console.log('file opened successfully');
                        }
                    });
                }          
        }

        function b64toBlob(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];
            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        }


        glCongratulationsVm.downloadLetter = function(isEmail){
                var payload = {};
                if(!isEmail){
                    payload = {
                      "isEmail": false,
                      "type": "inprinciple"
                    };
                }else{
                    payload = {
                      "isEmail": true,
                      "type": "inprinciple"
                    };
                }

                goldLoanRLMSService.getDocument(payload).then(function(data) {
                    if(!isEmail) {
                        var content = data.pdf;
                        var filename = data.fileName;
                        var contentType = "application/pdf";
                        savebase64AsPDF(filename + ".pdf", content, contentType);                     
                    }else{
                        var alertPopup = $ionicPopup.alert({
                        template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Email has been sent successfully</p>"
                        });
                    }
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        
        glCongratulationsVm.closePopover = function(){
            $scope.popover.hide();
            $ionicScrollDelegate.resize();
        }

        glCongratulationsVm.goToAccOverview = function() {
            homeScreenService.ishamburgerMenuRO=false;
            homeScreenService.isLoansFlag = true;
            getAccountDetailsService.tabIndex.tabIndex=2;
            $state.go('menu.accountOverviewMyBalance');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);