angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.hlNTBApplicationStatus', {
                    url: '/hlNTBApplicationStatus',
                    data: {
                        pageId: 'HL_NTB_APP_STATUS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/HL_NTB_Calculator/hlNTBApplicationStatus.html',
                            controller: 'hlNTBApplicationStatusController',
                            controllerAs: 'hlNTBApplicationStatusVm'
                        }
                    }
                })
                .state('menu.hlNTBEligibileAmountDetails', {
                    url: '/hlNTBEligibileAmountDetails',
                    data: {
                        pageId: 'HL_NTB_AMOUNT'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/HL_NTB_Calculator/hlNTBEligibileAmountDetails.html',
                            controller: 'hlNTBEligibileAmountDetailsController',
                            controllerAs: 'hlNTBEligibileAmountDetailsVm'
                        }
                    }
                })
                .state('menu.hlNTBEligibilityCheckDetails', {
                    url: '/hlNTBEligibilityCheckDetails',
                    data: {
                        pageId: 'HL_NTB_CHECKS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/HL_NTB_Calculator/hlNTBEligibilityCheckDetails.html',
                            controller: 'hlNTBEligibilityCheckDetailsController',
                            controllerAs: 'hlNTBEligibilityCheckDetailsVm'
                        }
                    }
                })
                .state('menu.hlNTBExploreHomeLoan', {
                    url: '/hlNTBExploreHomeLoan',
                    data: {
                        pageId: 'HL_NTB_EXPLORE'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/HL_NTB_Calculator/hlNTBExploreHomeLoan.html',
                            controller: 'hlNTBExploreHomeLoanController',
                            controllerAs: 'hlNTBExploreHomeLoanVm'
                        }
                    }
                })
                .state('menu.hlNTBOTPVerification', {
                    url: '/hlNTBOTPVerification',
                    data: {
                        pageId: 'HL_NTB_OTP'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/HL_NTB_Calculator/hlNTBOTPVerification.html',
                            controller: 'hlNTBOTPVerificationController',
                            controllerAs: 'hlNTBOTPVerificationVm'
                        }
                    }
                })
                .state('menu.hlNTBReferenceDetails', {
                    url: '/hlNTBReferenceDetails',
                    data: {
                        pageId: 'HL_NTB_REFERENCE'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/HL_NTB_Calculator/hlNTBReferenceDetails.html',
                            controller: 'hlNTBReferenceDetailsController',
                            controllerAs: 'hlNTBReferenceDetailsVm'
                        }
                    }
                })
                .state('menu.hlNTBRequestCallBack', {
                    url: '/hlNTBRequestCallBack',
                    data: {
                        pageId: 'HL_NTB_CALLBACK'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/HL_NTB_Calculator/hlNTBRequestCallBack.html',
                            controller: 'hlNTBRequestCallBackController',
                            controllerAs: 'hlNTBRequestCallBackVm'
                        }
                    }
                })
                .state('menu.hlNTBSubmitDetails', {
                    url: '/hlNTBSubmitDetails',
                    data: {
                        pageId: 'HL_NTB_CSUBMIT'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/home/HL_NTB_Calculator/hlNTBSubmitDetails.html',
                            controller: 'hlNTBSubmitDetailsController',
                            controllerAs: 'hlNTBSubmitDetailsVm'
                        }
                    }
                })

            }
        ]);