'use strict';

angularApp.controller('hlNTBEligibileAmountDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "$filter",
    "hlNTBCalculatorService",
    "homeLoanService",
    "$morphCarousel",

    function ($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        hlNTBCalculatorService,
        homeLoanService,
        $morphCarousel) {

        var hlNTBEligibileAmountDetailsVm = this;
        $scope.masterData = {};
        $scope.isNonEdited = true ;

        hlNTBEligibileAmountDetailsVm.initPage = function () {
            var tenures = [];
            hlNTBEligibileAmountDetailsVm.EligibilityData = hlNTBCalculatorService.getCheckEligiblityResponse();
            $scope.masterData = hlNTBCalculatorService.getMasterDataService();
            hlNTBEligibileAmountDetailsVm.eligibilityRequestData = hlNTBCalculatorService.getCheckEligiblityRequest();
            hlNTBEligibileAmountDetailsVm.hlNTeligibilityEditScreen2Hide = false;
            hlNTBEligibileAmountDetailsVm.userGender = hlNTBCalculatorService.getApplicantGender();
            hlNTBEligibileAmountDetailsVm.occupationCode = hlNTBCalculatorService.getApplicantOccupation();
            if (hlNTBCalculatorService.isAmountBack) {
                var hlbackLoanDetail = hlNTBCalculatorService.getEligibalAmountDetail()
                hlNTBEligibileAmountDetailsVm.loanMaxAmount = hlbackLoanDetail.eligibleLoanAmount; // hlNTBEligibileAmountDetailsVm.EligibilityData.loanAmount; 
                hlNTBEligibileAmountDetailsVm.loanAmount = hlbackLoanDetail.eligibleLoanAmount;
                hlNTBEligibileAmountDetailsVm.selectedTenure = hlbackLoanDetail.loanTenure;
                hlNTBEligibileAmountDetailsVm.interestRate = hlbackLoanDetail.interestRate;
                hlNTBEligibileAmountDetailsVm.emiAmount  = hlbackLoanDetail.monthlyEMI ;
            } else {
                hlNTBEligibileAmountDetailsVm.loanMaxAmount = hlNTBEligibileAmountDetailsVm.EligibilityData.loanAmount;
                hlNTBEligibileAmountDetailsVm.loanAmount = hlNTBEligibileAmountDetailsVm.loanMaxAmount;
                hlNTBEligibileAmountDetailsVm.interestRate = hlNTBEligibileAmountDetailsVm.EligibilityData.rateOfInterest;                
                hlNTBEligibileAmountDetailsVm.emiAmount = hlNTBEligibileAmountDetailsVm.EligibilityData.monthlyEMI ;
            }
            var maxTenure = hlNTBEligibileAmountDetailsVm.EligibilityData.loanTunure;
            for (var i = 1; i <= maxTenure; i++) {
                tenures.push(i);
            }

            hlNTBEligibileAmountDetailsVm.tenures = tenures;
            hlNTBEligibileAmountDetailsVm.tenure = maxTenure;
            if (!hlNTBCalculatorService.isAmountBack) {
                hlNTBEligibileAmountDetailsVm.selectedTenure = maxTenure;
            }
            hlNTBEligibileAmountDetailsVm.loanMinAmount = 200000; // hard coded
            $morphCarousel.update('modal-carousel');

            hlNTBEligibileAmountDetailsVm.loanAmount = hlNTBEligibileAmountDetailsVm.loanMaxAmount;
            hlNTBEligibileAmountDetailsVm.disableMBtn = false;
            hlNTBEligibileAmountDetailsVm.disablePBtn = false;
            if (hlNTBEligibileAmountDetailsVm.loanAmount <= hlNTBEligibileAmountDetailsVm.loanMinAmount) {
                hlNTBEligibileAmountDetailsVm.disableMBtn = true;
            }
            if (hlNTBEligibileAmountDetailsVm.loanAmount >= hlNTBEligibileAmountDetailsVm.loanMaxAmount) {
                hlNTBEligibileAmountDetailsVm.disablePBtn = true;
            }
           
          
        }

        hlNTBEligibileAmountDetailsVm.hlNTEditButton = function () {
            $scope.isNonEdited = false ;
            hlNTBEligibileAmountDetailsVm.hlNTeligibilityEditScreen2Hide = true;
            if(hlNTBCalculatorService.isAmountBack){
                hlNTBEligibileAmountDetailsVm.loanMaxAmount = hlNTBEligibileAmountDetailsVm.EligibilityData.loanAmount; 
            }
            hlNTBEligibileAmountDetailsVm.updatedigest();
        }

        hlNTBEligibileAmountDetailsVm.goBack = function () {
            hlNTBCalculatorService.isCheckEligibilityBack = true;
            $state.go('menu.hlNTBEligibilityCheckDetails');
        }

        hlNTBEligibileAmountDetailsVm.requestCallBack = function () {
            hlNTBCalculatorService.setIsCallBackRequset('true')
            hlNTBCalculatorService.isSubmitDetailsBack = false ;
            $state.go('menu.hlNTBSubmitDetails');
        }

        hlNTBEligibileAmountDetailsVm.updatedigest = function () {
            if (!$scope.$$phase)
                $scope.$apply();
            return;
        }

        $scope.$watch(function () {
            return (hlNTBEligibileAmountDetailsVm.selectedTenure);
        },
            function (tenureValue) {
                if (tenureValue !== undefined) {
                    hlNTBEligibileAmountDetailsVm.selectedTenure = tenureValue;
                    if (hlNTBEligibileAmountDetailsVm.selectedTenure) {
                        hlNTBEligibileAmountDetailsVm.tenure = hlNTBEligibileAmountDetailsVm.selectedTenure;
                        hlNTBEligibileAmountDetailsVm.emiCalculation();
                    }
                }
            });


        //loan amount check
        hlNTBEligibileAmountDetailsVm.loanAmountCheck = function (loanValue) {
            var loanAmt = parseInt(loanValue);
            if ((loanAmt % 1000) > 0) {
                hlNTBEligibileAmountDetailsVm.loanAmount -= (loanAmt % 1000);
            } else {
                hlNTBEligibileAmountDetailsVm.loanAmount = loanAmt;
            }
            if (hlNTBEligibileAmountDetailsVm.loanAmount <= hlNTBEligibileAmountDetailsVm.loanMinAmount) {
                hlNTBEligibileAmountDetailsVm.loanAmount = parseInt(hlNTBEligibileAmountDetailsVm.loanMinAmount);
                hlNTBEligibileAmountDetailsVm.disableMBtn = true;
            } else {
                hlNTBEligibileAmountDetailsVm.disableMBtn = false;
            }
            if (hlNTBEligibileAmountDetailsVm.loanAmount >= hlNTBEligibileAmountDetailsVm.loanMaxAmount) {
                hlNTBEligibileAmountDetailsVm.loanAmount = parseInt(hlNTBEligibileAmountDetailsVm.loanMaxAmount)
                hlNTBEligibileAmountDetailsVm.disablePBtn = true;
            } else {
                hlNTBEligibileAmountDetailsVm.disablePBtn = false;
            }
            if (loanAmt < 200000 || isNaN(loanAmt)) {
                hlNTBEligibileAmountDetailsVm.loanAmount = 200000;
                return
            }
            hlNTBEligibileAmountDetailsVm.interestRate = hlNTBEligibileAmountDetailsVm.getInterestRate(hlNTBEligibileAmountDetailsVm.loanAmount, $scope.masterData.rateOfInterestMasterDataList);
            hlNTBEligibileAmountDetailsVm.emiCalculation();
        }

        // EMI calculation
        hlNTBEligibileAmountDetailsVm.emiCalculation = function () {
            if($scope.isNonEdited){
                return ;
            }else{
                hlNTBEligibileAmountDetailsVm.emiAmount = hlNTBCalculatorService.emiCalculation(hlNTBEligibileAmountDetailsVm.loanAmount, hlNTBEligibileAmountDetailsVm.interestRate, hlNTBEligibileAmountDetailsVm.tenure);
            }
        }

        //increase decrease amount for loan amount //
        hlNTBEligibileAmountDetailsVm.decreaseAmount = function (loanValue) {
            var loanAmount = parseInt(loanValue);
            if (loanAmount) {
                hlNTBEligibileAmountDetailsVm.disablePBtn = false;
                if (loanAmount <= hlNTBEligibileAmountDetailsVm.loanMinAmount) {
                    hlNTBEligibileAmountDetailsVm.disableMBtn = true;
                } else {
                    hlNTBEligibileAmountDetailsVm.loanAmount = loanAmount - 1000;
                    if (hlNTBEligibileAmountDetailsVm.loanAmount <= hlNTBEligibileAmountDetailsVm.loanMinAmount) {
                        hlNTBEligibileAmountDetailsVm.disableMBtn = true;
                    }
                }
                hlNTBEligibileAmountDetailsVm.loanAmountCheck(hlNTBEligibileAmountDetailsVm.loanAmount);
            }
        }

        hlNTBEligibileAmountDetailsVm.increaseAmount = function (loanValue) {
            var loanAmount = parseInt(loanValue);
            if (loanAmount) {
                hlNTBEligibileAmountDetailsVm.disableMBtn = false;
                if (loanAmount >= hlNTBEligibileAmountDetailsVm.loanMaxAmount) {
                    hlNTBEligibileAmountDetailsVm.disablePBtn = true;
                } else {
                    hlNTBEligibileAmountDetailsVm.loanAmount = loanAmount + 1000;
                    if (hlNTBEligibileAmountDetailsVm.loanAmount >= hlNTBEligibileAmountDetailsVm.loanMaxAmount) {
                        hlNTBEligibileAmountDetailsVm.disablePBtn = true;
                    }
                }
                hlNTBEligibileAmountDetailsVm.loanAmountCheck(hlNTBEligibileAmountDetailsVm.loanAmount);
            }
        }

        hlNTBEligibileAmountDetailsVm.interested = function () {

            if (hlNTBEligibileAmountDetailsVm.emiAmount > hlNTBEligibileAmountDetailsVm.EligibilityData.monthlyEMI) {
                utilityService.showErrorMessage("The proportion of EMIs in net monthly income (NMI) is higher than eligible limit, please verify EMI and/or NMI details and revise");
                return
            } else {
                var request = {
                    "loanamount": hlNTBEligibileAmountDetailsVm.loanMaxAmount ? hlNTBEligibileAmountDetailsVm.loanMaxAmount : '',
                    "eligibleLoanAmount": hlNTBEligibileAmountDetailsVm.loanAmount ? hlNTBEligibileAmountDetailsVm.loanAmount : '',
                    "monthlyEMI": hlNTBEligibileAmountDetailsVm.emiAmount ? hlNTBEligibileAmountDetailsVm.emiAmount : '',
                    "interestRate": hlNTBEligibileAmountDetailsVm.interestRate ? hlNTBEligibileAmountDetailsVm.interestRate : '',
                    "loanTenure": hlNTBEligibileAmountDetailsVm.selectedTenure ? hlNTBEligibileAmountDetailsVm.selectedTenure : '',
                    "propertyValue": hlNTBEligibileAmountDetailsVm.propertyValue ? hlNTBEligibileAmountDetailsVm.propertyValue : '',
                    "downPayment": hlNTBEligibileAmountDetailsVm.downPayment ? hlNTBEligibileAmountDetailsVm.downPayment : ''
                };

                hlNTBCalculatorService.setEligibalAmountDetail(request);
                hlNTBCalculatorService.setIsCallBackRequset('false');
                $state.go('menu.hlNTBSubmitDetails');
            }
        }

        hlNTBEligibileAmountDetailsVm.getInterestRate = function (loanAmt, arr) {
            loanAmt = parseInt(loanAmt);
            var isInterestRateSet = false ;
            var intRate = 0;
            for (var i = 0; i < arr.length; i++) {
                if (loanAmt >= arr[i].minLoanAmt && loanAmt <= arr[i].maxLoanAmt) {
                    intRate = arr[i].intRate;
                    isInterestRateSet = true ;
                    break;
                }
            }
           
            if(isInterestRateSet){
                return intRate;
            }else{
                for (var j = 0; j < arr.length; j++) {
                    if (intRate < arr[j].intRate) {
                        intRate = arr[j].intRate;
                    }
                }
               return intRate;
            }
           
        }
        $scope.$on('$ionicView.beforeEnter', function () {
            hlNTBEligibileAmountDetailsVm.initPage();
        });
        return this;
    }
]);