'use strict';
angularApp.controller('takeoverLoanBenifitController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,homeLoanService) {
			
			var takeoverLoanBenifitVm = this;
			
			function initPage() {

				if(!homeLoanService.getTopupData().topupLoanEMI){
					takeoverLoanBenifitVm.isTopup = false;
				}else{
					takeoverLoanBenifitVm.isTopup = true;
				}			
				
				takeoverLoanBenifitVm.graphDetails = homeLoanService.getGraphEMI();
				takeoverLoanBenifitVm.sbiEMIVal = takeoverLoanBenifitVm.graphDetails.sbiEMI;
				takeoverLoanBenifitVm.otherEMIVal = takeoverLoanBenifitVm.graphDetails.userEMI;
				takeoverLoanBenifitVm.otherEMI = "100";
				takeoverLoanBenifitVm.sbiEMI = parseInt((100 * takeoverLoanBenifitVm.graphDetails.sbiEMI)/ takeoverLoanBenifitVm.graphDetails.userEMI);
				takeoverLoanBenifitVm.loanBenifit = takeoverLoanBenifitVm.otherEMIVal - takeoverLoanBenifitVm.sbiEMIVal;

				takeoverLoanBenifitVm.sbiTenureVal = takeoverLoanBenifitVm.graphDetails.sbiTenure;
				takeoverLoanBenifitVm.otherTenureVal = takeoverLoanBenifitVm.graphDetails.userTenure;
				takeoverLoanBenifitVm.userTenure = "100";
				takeoverLoanBenifitVm.sbiTenure = parseInt((100 * takeoverLoanBenifitVm.graphDetails.sbiTenure)/ takeoverLoanBenifitVm.graphDetails.userTenure);
				takeoverLoanBenifitVm.tenureBenifit = takeoverLoanBenifitVm.otherTenureVal - takeoverLoanBenifitVm.sbiTenureVal;

				
				takeoverLoanBenifitVm.sbiTopUpEMIVal = takeoverLoanBenifitVm.graphDetails.sbiTopUpEMI;
				takeoverLoanBenifitVm.otherTopUpEMIVal = takeoverLoanBenifitVm.graphDetails.userTopUpEMI;
				if(takeoverLoanBenifitVm.otherTopUpEMIVal > takeoverLoanBenifitVm.sbiTopUpEMIVal){
					takeoverLoanBenifitVm.otherTopUpEMI = "100";
					takeoverLoanBenifitVm.sbiTopUpEMI = parseInt((100 * takeoverLoanBenifitVm.graphDetails.sbiTopUpEMI)/ takeoverLoanBenifitVm.graphDetails.userTopUpEMI);
					takeoverLoanBenifitVm.topUpBenifit = takeoverLoanBenifitVm.otherTopUpEMIVal - takeoverLoanBenifitVm.sbiTopUpEMIVal;
					takeoverLoanBenifitVm.isTopupLoanBenifit = true;
				}else{
					takeoverLoanBenifitVm.sbiTopUpEMI  = "100";
					takeoverLoanBenifitVm.otherTopUpEMI = parseInt((100 * takeoverLoanBenifitVm.graphDetails.userTopUpEMI)/ takeoverLoanBenifitVm.graphDetails.sbiTopUpEMI);
					takeoverLoanBenifitVm.topUpBenifit = takeoverLoanBenifitVm.sbiTopUpEMIVal - takeoverLoanBenifitVm.otherTopUpEMIVal;
					takeoverLoanBenifitVm.isTopupLoanBenifit = false;
				}
				

				takeoverLoanBenifitVm.sbiTopUpTenureVal = takeoverLoanBenifitVm.graphDetails.sbiTopUpTenure;
				takeoverLoanBenifitVm.otherTopUpTenureVal = takeoverLoanBenifitVm.graphDetails.userTopUpTenure;
				if(takeoverLoanBenifitVm.otherTopUpTenureVal > takeoverLoanBenifitVm.sbiTopUpTenureVal){
					takeoverLoanBenifitVm.userTopUpTenure = "100";
					takeoverLoanBenifitVm.sbiTopUpTenure = parseInt((100 * takeoverLoanBenifitVm.graphDetails.sbiTopUpTenure)/ takeoverLoanBenifitVm.graphDetails.userTopUpTenure);
					takeoverLoanBenifitVm.tenureTopUpBenifit = takeoverLoanBenifitVm.otherTopUpTenureVal - takeoverLoanBenifitVm.sbiTopUpTenureVal;
					takeoverLoanBenifitVm.isTopupTenureBenifit = true;
				}else{
					takeoverLoanBenifitVm.sbiTopUpTenure = "100";
					takeoverLoanBenifitVm.userTopUpTenure = parseInt((100 * takeoverLoanBenifitVm.graphDetails.userTopUpTenure)/ takeoverLoanBenifitVm.graphDetails.sbiTopUpTenure);
					takeoverLoanBenifitVm.tenureTopUpBenifit = takeoverLoanBenifitVm.sbiTopUpTenureVal - takeoverLoanBenifitVm.otherTopUpTenureVal ;
					takeoverLoanBenifitVm.isTopupTenureBenifit = false;
				}
				



				//sbiTenure
				//userTenure
			}

			takeoverLoanBenifitVm.goToNextPage = function(){
				$state.go('menu.homeLoanPersonalDetails');
			}

			takeoverLoanBenifitVm.goToPreviousPage = function(){
				$state.go('menu.hlTakeoverLoanDetails');
			}
			
			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


