'use strict';
angularApp.controller('takeoverPropertyTypeController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,homeLoanService) {
			
			var takeoverPropertyTypeVm = this;
			
			function initPage() {
				takeoverPropertyTypeVm.masterProperty = homeLoanService.userMaster.master.takeoverPropertyTypes;//takeoverPropertyTypes;.master.genders
				if(homeLoanService.selectedPropertyTakeover){
					takeoverPropertyTypeVm.selectedProperty = homeLoanService.selectedPropertyTakeover;
				}else{
					takeoverPropertyTypeVm.selectedProperty = "C";
				}
				
			}

			takeoverPropertyTypeVm.goToNextPage = function(){
				homeLoanService.selectedPropertyTakeover = takeoverPropertyTypeVm.selectedProperty;
				var obj = {};
				homeLoanService.setTakeoverData(null);
				homeLoanService.setTopupData(null);
				$state.go('menu.hlTakeoverLoanDetails');
			}

			
			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


