'use strict';
angularApp.controller('coApplicantWorkDetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"$ionicScrollDelegate",
		"customerInfoService",
		"validateService",
		"$filter",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,$ionicScrollDelegate,customerInfoService,validateService,$filter,homeLoanService) {
			
			var coApplicantWorkDetailsVm = this;
			coApplicantWorkDetailsVm.isMasked = true;
			coApplicantWorkDetailsVm.inputImg = "img/Visibility_off.svg";
			coApplicantWorkDetailsVm.emailInputType = "password";
			coApplicantWorkDetailsVm.emailInputImg = "img/Visibility_off.svg";
			coApplicantWorkDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
			coApplicantWorkDetailsVm.officePincodeText = "PINCODE";
			coApplicantWorkDetailsVm.officeStateText = "State";
			coApplicantWorkDetailsVm.officeDistrictText = "District";
			coApplicantWorkDetailsVm.officeSubDistrictText = "Sub-District";
			coApplicantWorkDetailsVm.officeVillageTownText = "Village/Town";
			coApplicantWorkDetailsVm.officeCityText = "City";
			coApplicantWorkDetailsVm.officeEmailText = "OFFICE_EMAIL";
			
			function initPage() {
				coApplicantWorkDetailsVm.groups = [{
					id : "office",
					name : "Office Details"
				}];

				coApplicantWorkDetailsVm.detail = {};
				coApplicantWorkDetailsVm.errObj = {};
				coApplicantWorkDetailsVm.sbiLoanEMI = 0;
				coApplicantWorkDetailsVm.masterData = homeLoanService.userMaster;
				coApplicantWorkDetailsVm.states = coApplicantWorkDetailsVm.masterData.master.states;
				coApplicantWorkDetailsVm.employmentType = coApplicantWorkDetailsVm.masterData.master.employmentTypes;
				coApplicantWorkDetailsVm.employerType = coApplicantWorkDetailsVm.masterData.master.employerTypes;
				coApplicantWorkDetailsVm.emiTypes = coApplicantWorkDetailsVm.masterData.master.emiTypes;
				coApplicantWorkDetailsVm.professionTypeList = coApplicantWorkDetailsVm.masterData.master.professionTypes;
				coApplicantWorkDetailsVm.emiType = [];
				coApplicantWorkDetailsVm.officeDistricts = [];
				coApplicantWorkDetailsVm.officeSubDistricts = [];
				coApplicantWorkDetailsVm.officeVillageTown = [];
				coApplicantWorkDetailsVm.officeCities = [];

				if(homeLoanService.getFetchDetails()){
					coApplicantWorkDetailsVm.sbiLoanEMI = parseFloat(homeLoanService.getFetchDetails().totalSbiEmi);
				}
				

				// var wkDet = {"mobile":"9803919728","accountNumber":"30002829895","dob":"23/05/2000","email":"mxxxxxxv@ixxxxm.com","relationshipList":[{"key":"FTH","value":"FATHER","$$hashKey":"object:636"},{"key":"GD","value":"GUARANTOR","$$hashKey":"object:637"},{"key":"GDD","value":"GRAND DAUGHTER","$$hashKey":"object:638"},{"key":"GDS","value":"GRAND SON","$$hashKey":"object:639"},{"key":"MIL","value":"MOTHER IN LAW","$$hashKey":"object:640"},{"key":"MTH","value":"MOTHER","$$hashKey":"object:641"},{"key":"NBR","value":"NEIGHBOUR","$$hashKey":"object:642"},{"key":"NEP","value":"NEPHEW","$$hashKey":"object:643"},{"key":"NIC","value":"NIECE","$$hashKey":"object:644"},{"key":"NOT","value":"NOT AVAILABLE","$$hashKey":"object:645"},{"key":"OTH","value":"OTHERS","$$hashKey":"object:646"},{"key":"SIS","value":"SISTER","$$hashKey":"object:647"},{"key":"SON","value":"SON","$$hashKey":"object:648"},{"key":"SPS","value":"SPOUSE","$$hashKey":"object:649"},{"key":"UNC","value":"UNCLE","$$hashKey":"object:650"},{"key":"DIL","value":"DAUGHTER IN LAW","$$hashKey":"object:651"},{"key":"ANT","value":"AUNT","$$hashKey":"object:652"},{"key":"BIL","value":"BROTHER IN LAW","$$hashKey":"object:653"},{"key":"CAP","value":"COAPPLICANT","$$hashKey":"object:654"},{"key":"CHD","value":"CHILDREN","$$hashKey":"object:655"},{"key":"COL","value":"COLLEAGUE","$$hashKey":"object:656"},{"key":"DAU","value":"DAUGHTER","$$hashKey":"object:657"},{"key":"FIL","value":"FATHER IN LAW","$$hashKey":"object:658"},{"key":"FRD","value":"FRIEND","$$hashKey":"object:659"}],"title":{"key":"01","value":"Mr."},"name":"Mr. hghish  la","gender":{"key":"M","value":"MALE"},"residenceList":[{"key":"C","value":"Company Lease","$$hashKey":"object:391"},{"key":"O","value":"Owned","$$hashKey":"object:392"},{"key":"R","value":"Rented","$$hashKey":"object:393"}],"currentAddress":"D","relationship":{"key":"MTH","value":"MOTHER","$$hashKey":"object:641"},"currentPincode":"400089","currentCity":"Mumbai Suburban","currentState":"Maharashtra","residenceTypeCurrent":{"key":"R","value":"Rented","$$hashKey":"object:393"},"residenceMonthCurrent":"56","addressLine1":"Avvavsvsgsv"};
				// homeLoanService.setCoApplicantWorkDetails(wkDet);
				// var test = {"eligible":"TRUE","coapplicantCIF":"","yonoRef":"HLY100718584417","title":"01","firstName":"hghish","middleName":"","lastName":"la","gender":"M","dob":"23/05/2000","pan":"","aadhar":"","email":"mxxxxxxv@ixxxxm.com","mobile":"9803919728","permanentAddress":{"addressLine1":"101","addressLine2":"","addressLine3":"mkmklmk","district":"27519:Mumbai","city":null,"state":null,"pincode":"400614","addressType":null},"status":"0000","count":0,"master":null,"reasons":null,"losRef":null};
				// homeLoanService.setCoApplicantDetails(test);
				// var masters = {"eligible":"true","coapplicantCIF":null,"yonoRef":"HLY100718165228","title":"01","firstName":"ashish","middleName":"","lastName":"la","gender":"M","dob":"23/05/1983","pan":"XXXXXX575M","aadhar":"XXXXXXXX9995","email":"twisha.dhimar@sbi.co.in","mobile":null,"permanentAddress":{"addressLine1":"101","addressLine2":"","addressLine3":"mkmklmk","district":"27519:Mumbai","city":null,"state":null,"pincode":"400614","addressType":null},"status":"0000","count":0,"master":{"employmentTypes":[{"key":"Businessman","value":"Self-Employed Non-Professional(Businessman)"},{"key":"Others","value":"Others (Pensioner, Housewife etc.)"},{"key":"Salaried","value":"Salaried"},{"key":"Self-Employed","value":"Self-Employed Professional"}],"employerTypes":[{"key":"LIST","value":"LISTED PVT."},{"key":"MNC","value":"MNC"},{"key":"N","value":"NON WORKING"},{"key":"PEN","value":"PENSIONER"},{"key":"PSU","value":"Central/ State Govts /PSU"},{"key":"ULST","value":"UNLISTED PVT."}],"professionTypes":[{"key":"0700","value":"Retired"},{"key":"0999","value":"Others"},{"key":"0100","value":"State Govt Services"},{"key":"0101","value":"Central Govt Services"},{"key":"0110","value":"Services In Public Sector Undertaking"},{"key":"0160","value":"Services In Defence Establishment"},{"key":"0170","value":"Services In Private Establishment"},{"key":"0201","value":"Medical Profession"},{"key":"0202","value":"Legal Profession"},{"key":"0203","value":"CA/ICWA/Taxation/Finance"},{"key":"0204","value":"Engineering/Architect/Technical/Consultant"},{"key":"0205","value":"Artist/Writer Etc"},{"key":"0207","value":"Artisan/Craftsman"},{"key":"0208","value":"Journalists"},{"key":"0209","value":"Share and Stock Broker"},{"key":"0210","value":"Capital Market Maker"},{"key":"0299","value":"Other Professionals"},{"key":"0301","value":"Industrialist"},{"key":"0302","value":"Business In Trade sector"},{"key":"0303","value":"Business In Service sector"},{"key":"0500","value":"Housewives"},{"key":"0600","value":"Students"},{"key":"0200","value":"Other Pensionable Service"},{"key":"0304","value":"Migrant Laborers"}],"emiTypes":[{"key":"08","value":"WORKING CAPITAL OVERDRAFT"},{"key":"09","value":"WORKING CAPITAL TERM LOAN"},{"key":"02","value":"CREDIT CARD"},{"key":"03","value":"PERSONAL LOAN"},{"key":"05","value":"WORKING CAPITAL DEMAND LOAN"},{"key":"21","value":"AUTO LOAN"},{"key":"22","value":"EDUCATION LOAN"},{"key":"23","value":"TERM LOAN"},{"key":"24","value":"MUTUAL FUND"},{"key":"25","value":"HOME LOAN"}],"relWithPriApplicants":[{"key":"FTH","value":"FATHER"},{"key":"GD","value":"GUARANTOR"},{"key":"GDD","value":"GRAND DAUGHTER"},{"key":"GDS","value":"GRAND SON"},{"key":"MIL","value":"MOTHER IN LAW"},{"key":"MTH","value":"MOTHER"},{"key":"NBR","value":"NEIGHBOUR"},{"key":"NEP","value":"NEPHEW"},{"key":"NIC","value":"NIECE"},{"key":"NOT","value":"NOT AVAILABLE"},{"key":"OTH","value":"OTHERS"},{"key":"SIS","value":"SISTER"},{"key":"SON","value":"SON"},{"key":"SPS","value":"SPOUSE"},{"key":"UNC","value":"UNCLE"},{"key":"DIL","value":"DAUGHTER IN LAW"},{"key":"ANT","value":"AUNT"},{"key":"BIL","value":"BROTHER IN LAW"},{"key":"CAP","value":"COAPPLICANT"},{"key":"CHD","value":"CHILDREN"},{"key":"COL","value":"COLLEAGUE"},{"key":"DAU","value":"DAUGHTER"},{"key":"FIL","value":"FATHER IN LAW"},{"key":"FRD","value":"FRIEND"}],"titles":[{"key":"Admiral","value":"Admiral"},{"key":"Admiral of the Fleet","value":"Admiral of the Fleet"},{"key":"Air Chief Marshal","value":"Air Chief Marshal"},{"key":"Air Commodore","value":"Air Commodore"},{"key":"Air Marshal","value":"Air Marshal"},{"key":"Air Vice Marshal","value":"Air Vice Marshal"},{"key":"Bharatratna","value":"Bharatratna"},{"key":"Brigadier","value":"Brigadier"},{"key":"Captain","value":"Captain"},{"key":"Colonel","value":"Colonel"},{"key":"Commander","value":"Commander"},{"key":"Dr.","value":"Dr."},{"key":"Dr.(Mrs.)","value":"Dr.(Mrs.)"},{"key":"Flt.Lieutenant","value":"Flt.Lieutenant"},{"key":"Flying Officer","value":"Flying Officer"},{"key":"General","value":"General"},{"key":"Group Captain","value":"Group Captain"},{"key":"Lieutenant","value":"Lieutenant"},{"key":"Lieutenant Colone","value":"Lieutenant Colone"},{"key":"Lieutenant Commander","value":"Lieutenant Commander"},{"key":"Lt.General","value":"Lt.General"},{"key":"M/s.","value":"M/s."},{"key":"Major","value":"Major"},{"key":"Major General","value":"Major General"},{"key":"Master","value":"Master"},{"key":"Miss.","value":"Miss."},{"key":"01","value":"Mr."},{"key":"02","value":"Mrs."},{"key":"03","value":"Ms."},{"key":"Padmabhushan","value":"Padmabhushan"},{"key":"Padmashri","value":"Padmashri"},{"key":"Padmavibhushan","value":"Padmavibhushan"},{"key":"Pilot","value":"Pilot"},{"key":"Pilot Officer","value":"Pilot Officer"},{"key":"Rear Admiral","value":"Rear Admiral"},{"key":"Shri","value":"Shri"},{"key":"Squadron Leader","value":"Squadron Leader"},{"key":"Sub Lieutenant","value":"Sub Lieutenant"},{"key":"Wing Commander","value":"Wing Commander"}],"genders":[{"key":"F","value":"FEMALE"},{"key":"M","value":"MALE"},{"key":"T","value":"THIRD GENDER"}],"addressTypes":[{"key":"C","value":"Company Lease"},{"key":"O","value":"Owned"},{"key":"R","value":"Rented"}],"loanPurposes":[{"key":"1","value":"Others"},{"key":"2","value":"Under Construction - No Builder Tie-up"},{"key":"3","value":"Under Construction - Builder Tie-up"},{"key":"4","value":"New / Resale - Ready possession"},{"key":"5","value":"Land / Plot"}],"rePaymentTypes":[{"key":"PDC","value":"Post Dated Cheques"},{"key":"ECSO","value":"ECS/STANDING INSTRUCTION linked to other accounts"},{"key":"C","value":"Check Off"},{"key":"ECSC","value":"ECS/STANDING INSTRUCTION linked to salary account"}],"maritalStatuses":[{"key":"M","value":"MARRIED"},{"key":"S","value":"SINGLE"}]},"reasons":null,"losRef":null};
				// homeLoanService.userMaster = masters;
				if(homeLoanService.getCoApplicantWorkApplication()){
					coApplicantWorkDetailsVm.detail = homeLoanService.getCoApplicantWorkApplication();
					for(var i=0 ; i< coApplicantWorkDetailsVm.detail.emi.length ; i++){
						if(coApplicantWorkDetailsVm.detail.emi[i].type == "28"){
							coApplicantWorkDetailsVm.sbiLoanEMI = 0;
						}
					}
					//coApplicantWorkDetailsVm.dob = coApplicantWorkDetailsVm.detail.dob;
					coApplicantWorkDetailsVm.showFieldsResume();
					coApplicantWorkDetailsVm.totalEMIs = [];
					coApplicantWorkDetailsVm.totalEMIs = homeLoanService.getCoApplicantWorkApplication().emi ? homeLoanService.getCoApplicantWorkApplication().emi : [];
					for(var i=0 ; i<coApplicantWorkDetailsVm.totalEMIs.length ; i++){						
						coApplicantWorkDetailsVm.totalEMIs[i].type = JSON.parse(coApplicantWorkDetailsVm.totalEMIs[i].typeValue);
						coApplicantWorkDetailsVm.totalEMIs[i].amount = parseFloat(coApplicantWorkDetailsVm.totalEMIs[i].amount);
					}
					coApplicantWorkDetailsVm.calculateEMIs();
					coApplicantWorkDetailsVm.showProfession();
					coApplicantWorkDetailsVm.tnc = true;

					
					if(coApplicantWorkDetailsVm.detail.officeDistrict){
						coApplicantWorkDetailsVm.officeDistricts.push(coApplicantWorkDetailsVm.detail.officeDistrict);
					}
					if(coApplicantWorkDetailsVm.detail.officeSubDistrict){
						coApplicantWorkDetailsVm.officeSubDistricts.push(coApplicantWorkDetailsVm.detail.officeSubDistrict);
					}
					if(coApplicantWorkDetailsVm.detail.officeVillageTown){
						coApplicantWorkDetailsVm.officeVillageTown.push(coApplicantWorkDetailsVm.detail.officeVillageTown);
					}
					if(coApplicantWorkDetailsVm.detail.officeCity){
						coApplicantWorkDetailsVm.officeCities.push(coApplicantWorkDetailsVm.detail.officeCity);
					}
					
				}else{
					coApplicantWorkDetailsVm.hideAllFields();
					coApplicantWorkDetailsVm.totalEMIs=[];
					coApplicantWorkDetailsVm.tnc = false;
					coApplicantWorkDetailsVm.detail.dob = homeLoanService.getFetchDetails().dob;					
					coApplicantWorkDetailsVm.detail.custName = coApplicantWorkDetailsVm.masterData.firstName + ' ' + coApplicantWorkDetailsVm.masterData.lastName;
					coApplicantWorkDetailsVm.calculateEMIs();
				}
			};



			coApplicantWorkDetailsVm.maskUnmask = function () {
				coApplicantWorkDetailsVm.isMasked == true ? (coApplicantWorkDetailsVm.isMasked = false , coApplicantWorkDetailsVm.inputImg = "img/Visibility_on.svg") : (coApplicantWorkDetailsVm.isMasked = true , coApplicantWorkDetailsVm.inputImg = "img/Visibility_off.svg");
			};

			coApplicantWorkDetailsVm.emailMaskUnmask = function (param) {
				coApplicantWorkDetailsVm.emailInputType == "password" ? (coApplicantWorkDetailsVm.emailInputType = "text" , coApplicantWorkDetailsVm.emailInputImg = "img/Visibility_on.svg") : (coApplicantWorkDetailsVm.emailInputType = "password" , coApplicantWorkDetailsVm.emailInputImg = "img/Visibility_off.svg");
			};

// ------------------------------------Office dtails--------------------------------------

			coApplicantWorkDetailsVm.toggleGroup = function(group) {
				coApplicantWorkDetailsVm.officeDetailErrorFlag = false;
				if (group.id == "office") {
					if (coApplicantWorkDetailsVm.isGroupShown(group)) {
						coApplicantWorkDetailsVm.shownGroup = null;
					} else {
							coApplicantWorkDetailsVm.shownGroup = group;
					}
				}
	
	
			};



			coApplicantWorkDetailsVm.isGroupShown = function(group) {
				if(coApplicantWorkDetailsVm.officeDetailErrorFlag){
					return true;
				}else{
				return coApplicantWorkDetailsVm.shownGroup === group;
				}
			};




			// ------------------------------------Office dtails END--------------------------------------


			coApplicantWorkDetailsVm.loadDistrictCurrent = function(type){
				var masterKey = "";
				if(type == 'district'){
					coApplicantWorkDetailsVm.detail.officeDistrict = "";
					coApplicantWorkDetailsVm.detail.officeSubDistrict = "";
					coApplicantWorkDetailsVm.detail.officeVillageTown = "";
					coApplicantWorkDetailsVm.detail.officeCity = "";
					masterKey = coApplicantWorkDetailsVm.detail.officeState.key;
				}else if(type == 'subdistrict'){
					coApplicantWorkDetailsVm.detail.officeSubDistrict = "";
					coApplicantWorkDetailsVm.detail.officeVillageTown = "";
					coApplicantWorkDetailsVm.detail.officeCity = "";
					masterKey = coApplicantWorkDetailsVm.detail.officeDistrict.key;
				}else if(type == 'village'){
					coApplicantWorkDetailsVm.detail.officeVillageTown = "";
					coApplicantWorkDetailsVm.detail.officeCity = "";
					masterKey = coApplicantWorkDetailsVm.detail.officeSubDistrict.key;
				}else if(type == 'city'){
					coApplicantWorkDetailsVm.detail.officeCity = "";
					masterKey = coApplicantWorkDetailsVm.detail.officeState.key;
				}

				var request = {
				  "key": masterKey,
				  "action": type
				};

				homeLoanService.getDistrictCity(request).then(function(data) {
					if(type == 'district'){
						coApplicantWorkDetailsVm.officeDistricts = data.info;
					}else if(type == 'subdistrict'){
						coApplicantWorkDetailsVm.officeSubDistricts = data.info;
					}else if(type == 'village'){
						coApplicantWorkDetailsVm.officeVillageTown = data.info;
					}else if(type == 'city'){
						coApplicantWorkDetailsVm.officeCities = data.info;
					}
					
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}


			coApplicantWorkDetailsVm.validateForm = function(){
				coApplicantWorkDetailsVm.errObj = {};

				if(validateService.isValidEmploymentType(coApplicantWorkDetailsVm.detail.employmentType)){
					coApplicantWorkDetailsVm.errObj.employmentType = validateService.isValidEmploymentType(coApplicantWorkDetailsVm.detail.employmentType);
				}


				if(coApplicantWorkDetailsVm.isEmployerType){
					if(validateService.isValidEmployerType(coApplicantWorkDetailsVm.detail.employerType)){
						coApplicantWorkDetailsVm.errObj.employerType = validateService.isValidEmployerType(coApplicantWorkDetailsVm.detail.employerType);
					}
				}

				if(coApplicantWorkDetailsVm.isNetMonthlyIncome){
					if(validateService.isValidMonthlyIncome(coApplicantWorkDetailsVm.detail.netMonthlyIncome)){
						coApplicantWorkDetailsVm.errObj.netMonthlyIncome = validateService.isValidMonthlyIncome(coApplicantWorkDetailsVm.detail.netMonthlyIncome);
					}
				}

				if(coApplicantWorkDetailsVm.isNetAnnualIncome){
					if(validateService.isValidAnnualIncomeHL(coApplicantWorkDetailsVm.detail.netAnnualIncome)){
						coApplicantWorkDetailsVm.errObj.netAnnualIncome = validateService.isValidAnnualIncomeHL(coApplicantWorkDetailsVm.detail.netAnnualIncome);
					}
				}



				if(coApplicantWorkDetailsVm.isOfficeDetails){
					if(validateService.isValidOfficeName(coApplicantWorkDetailsVm.detail.officeName)){
						coApplicantWorkDetailsVm.errObj.officeName = validateService.isValidOfficeName(coApplicantWorkDetailsVm.detail.officeName);

						coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
					}

					if(coApplicantWorkDetailsVm.detail.employmentType.key == "PensionerR"){

						if (validateService.isValidAdressNonMandatory(coApplicantWorkDetailsVm.detail.addressLine1)) {
							coApplicantWorkDetailsVm.errObj.addressLine1 = validateService.isValidAdressNonMandatory(coApplicantWorkDetailsVm.detail.addressLine1);
							coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
						}

					}else{

						if (validateService.isValidAdress(coApplicantWorkDetailsVm.detail.addressLine1)) {
							coApplicantWorkDetailsVm.errObj.addressLine1 = validateService.isValidAdress(coApplicantWorkDetailsVm.detail.addressLine1);
							coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
						}
					}


					if(coApplicantWorkDetailsVm.detail.employmentType.key == "PensionerR"){

						// if (validateService.isValidPincodeNonMandatory(coApplicantWorkDetailsVm.detail.officePincode)) {
						// 	coApplicantWorkDetailsVm.errObj.officePincode = validateService.isValidPincodeNonMandatory(coApplicantWorkDetailsVm.detail.officePincode);
						// }
						if(coApplicantWorkDetailsVm.detail.officePincode){
						coApplicantWorkDetailsVm.detail.officePincode = coApplicantWorkDetailsVm.detail.officePincode.replace(/ /g,'');
							if(parseInt(coApplicantWorkDetailsVm.detail.officePincode) < 1 || coApplicantWorkDetailsVm.detail.officePincode.length != 6){
								coApplicantWorkDetailsVm.errObj.officePincode = $translate.instant('HL_ERR_VALIDPINCODE');
								coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
							}
						}

					}else{

						// if (validateService.isValidPincode(coApplicantWorkDetailsVm.detail.officePincode)) {
						// 	coApplicantWorkDetailsVm.errObj.officePincode = validateService.isValidPincode(coApplicantWorkDetailsVm.detail.officePincode);
						// }

						if(!coApplicantWorkDetailsVm.detail.officePincode){
							coApplicantWorkDetailsVm.errObj.officePincode = $translate.instant('HL_ERR_PINCODE');
							coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
						}else{
							coApplicantWorkDetailsVm.detail.officePincode = coApplicantWorkDetailsVm.detail.officePincode.replace(/ /g,'');
							if(parseInt(coApplicantWorkDetailsVm.detail.officePincode) < 1 || coApplicantWorkDetailsVm.detail.officePincode.length != 6){
								coApplicantWorkDetailsVm.errObj.officePincode = $translate.instant('HL_ERR_VALIDPINCODE');
								coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
							}
						}

					}



					if(coApplicantWorkDetailsVm.detail.employmentType.key != "PensionerR"){

						if (validateService.isValidState(coApplicantWorkDetailsVm.detail.officeState)) {
							coApplicantWorkDetailsVm.errObj.officeState = validateService.isValidState(coApplicantWorkDetailsVm.detail.officeState);
							coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
						}
					}

					if(coApplicantWorkDetailsVm.detail.employmentType.key != "PensionerR"){

						if (validateService.hlValidDistrict(coApplicantWorkDetailsVm.detail.officeDistrict)) {
							coApplicantWorkDetailsVm.errObj.officeDistrict = validateService.hlValidDistrict(coApplicantWorkDetailsVm.detail.officeDistrict);
							coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
						}
					}

					if(coApplicantWorkDetailsVm.detail.employmentType.key != "PensionerR"){

						if (validateService.hlValidSubDistrict(coApplicantWorkDetailsVm.detail.officeSubDistrict)) {
							coApplicantWorkDetailsVm.errObj.officeSubDistrict = validateService.hlValidSubDistrict(coApplicantWorkDetailsVm.detail.officeSubDistrict);
							coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
						}
					}

					if(coApplicantWorkDetailsVm.detail.employmentType.key != "PensionerR"){

						if (validateService.hlValidVillage(coApplicantWorkDetailsVm.detail.officeVillageTown)) {
							coApplicantWorkDetailsVm.errObj.officeVillageTown = validateService.hlValidVillage(coApplicantWorkDetailsVm.detail.officeVillageTown);
							coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
						}
					}

					if(coApplicantWorkDetailsVm.detail.employmentType.key != "PensionerR"){

						if (validateService.hlValidCity(coApplicantWorkDetailsVm.detail.officeCity)) {
							coApplicantWorkDetailsVm.errObj.officeCity = validateService.hlValidCity(coApplicantWorkDetailsVm.detail.officeCity);
							coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
						}
					}

					// if(coApplicantWorkDetailsVm.detail.employmentType.key != "PensionerR"){

					// 	if (validateService.isValidPhoneMandatory(coApplicantWorkDetailsVm.detail.officePhone)) {
					// 		coApplicantWorkDetailsVm.errObj.officePhone = validateService.isValidPhoneMandatory(coApplicantWorkDetailsVm.detail.officePhone);
					// 	}
					// }



					if(coApplicantWorkDetailsVm.detail.employmentType.key == "PensionerR"){

						if(validateService.isValidEmailHLNonMandatory(coApplicantWorkDetailsVm.detail.officalEmail)){
							coApplicantWorkDetailsVm.errObj.officalEmail = validateService.isValidEmailHLNonMandatory(coApplicantWorkDetailsVm.detail.officalEmail);
							coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
						}

					}else{

						if(validateService.isValidEmailHL(coApplicantWorkDetailsVm.detail.officalEmail)){
							coApplicantWorkDetailsVm.errObj.officalEmail = validateService.isValidEmailHL(coApplicantWorkDetailsVm.detail.officalEmail);
							coApplicantWorkDetailsVm.officeDetailErrorFlag =true;
						}
					}

					

					
				}
				
				// if(coApplicantWorkDetailsVm.isIncomeFromHouseProp){
				// 	if(validateService.isValidIncome(coApplicantWorkDetailsVm.detail.incomeHouseProperty)){
				// 		coApplicantWorkDetailsVm.errObj.incomeFromHouseProp = validateService.isValidIncome(coApplicantWorkDetailsVm.detail.incomeHouseProperty);
				// 	}
				// }

				if(coApplicantWorkDetailsVm.isProfession){
					if(validateService.isValidProfession(coApplicantWorkDetailsVm.detail.profession)){
						coApplicantWorkDetailsVm.errObj.profession = validateService.isValidProfession(coApplicantWorkDetailsVm.detail.profession);
					}
				}
				
				if(coApplicantWorkDetailsVm.isWorkExp){
					if(validateService.isValidMonthsInWork(coApplicantWorkDetailsVm.detail.workExp)){
						coApplicantWorkDetailsVm.errObj.workExp = validateService.isValidMonthsInWork(coApplicantWorkDetailsVm.detail.workExp);
					}
				}

				if(coApplicantWorkDetailsVm.isMonthsInCurrJob){
					if(validateService.isValidMonthsInJob(coApplicantWorkDetailsVm.detail.monthsInCurrJob)){
						coApplicantWorkDetailsVm.errObj.monthsInCurrJob = validateService.isValidMonthsInJob(coApplicantWorkDetailsVm.detail.monthsInCurrJob);
					}
				}

				if(coApplicantWorkDetailsVm.isMonthsInCurrJobProfession){
					if(validateService.isValidMonthsInJobProfession(coApplicantWorkDetailsVm.detail.monthsInCurrJob)){
						coApplicantWorkDetailsVm.errObj.monthsInCurrJob = validateService.isValidMonthsInJobProfession(coApplicantWorkDetailsVm.detail.monthsInCurrJob);
					}
				}

				if(coApplicantWorkDetailsVm.isRetirementAge){
					if(validateService.isValidRetire(coApplicantWorkDetailsVm.detail.retirementAge,coApplicantWorkDetailsVm.detail.employerType.key)){
						coApplicantWorkDetailsVm.errObj.retirementAge = validateService.isValidRetire(coApplicantWorkDetailsVm.detail.retirementAge,coApplicantWorkDetailsVm.detail.employerType.key);
					}
				}


				return (angular.equals({}, coApplicantWorkDetailsVm.errObj)) ? true : false;
			}

			coApplicantWorkDetailsVm.saveApplication = function(){
				var workDetails = homeLoanService.getCoApplicantDetails();
				var coApplicantDetails = homeLoanService.getCoApplicantDetails();
				var primaryDetails = homeLoanService.getPersonalPrimaryDetails();

				var addArray = [];
				if(workDetails.currentAddress != "P"){
					var addObj2 = {
						"addressLine1": workDetails.addressLine1,
						"addressLine2": workDetails.addressLine2,
						"addressLine3": workDetails.addressLine3,
						"districtText": JSON.stringify(workDetails.currentDistrict),
						"subDistrict": workDetails.currentSubDistrict.key,
						"subDistrictText": JSON.stringify(workDetails.currentSubDistrict),
						"villageTown": workDetails.currentVillageTown.key,
						"villageTownText": JSON.stringify(workDetails.currentVillageTown),
						"cityText": JSON.stringify(workDetails.currentCity),
						"stateText": JSON.stringify(workDetails.currentState),
						"pincode": workDetails.currentPincode,
						"addressType": "C",
						"districtCode": workDetails.currentDistrict.key,
						"cityCode": workDetails.currentCity.key,
						"stateCode": workDetails.currentState.key
					};
					addArray.push(addObj2);
				}

				if(coApplicantWorkDetailsVm.isOfficeDetails){
					var addObj3 = {
						"addressLine1": coApplicantWorkDetailsVm.detail.addressLine1,
						"addressLine2": coApplicantWorkDetailsVm.detail.addressLine2,
						// "addressLine3": coApplicantWorkDetailsVm.addressLine3,
						"districtText": JSON.stringify(coApplicantWorkDetailsVm.detail.officeDistrict),
						"subDistrictText": JSON.stringify(coApplicantWorkDetailsVm.detail.officeSubDistrict),
						"villageTownText": JSON.stringify(coApplicantWorkDetailsVm.detail.officeVillageTown),
						"cityText": JSON.stringify(coApplicantWorkDetailsVm.detail.officeCity),
						"stateText": JSON.stringify(coApplicantWorkDetailsVm.detail.officeState),
						"pincode": coApplicantWorkDetailsVm.detail.officePincode,
						"addressType": "O",
						"districtCode": coApplicantWorkDetailsVm.detail.officeDistrict ? coApplicantWorkDetailsVm.detail.officeDistrict.key : "",
						"subDistrict": coApplicantWorkDetailsVm.detail.officeSubDistrict ? coApplicantWorkDetailsVm.detail.officeSubDistrict.key : "",
						"villageTown": coApplicantWorkDetailsVm.detail.officeVillageTown ? coApplicantWorkDetailsVm.detail.officeVillageTown.key : "",
						"cityCode": coApplicantWorkDetailsVm.detail.officeCity ? coApplicantWorkDetailsVm.detail.officeCity.key : "",
						"stateCode": coApplicantWorkDetailsVm.detail.officeState ? coApplicantWorkDetailsVm.detail.officeState.key : ""
					};
					addArray.push(addObj3);
				}
				var saveAppRequest = 
					{
						"loanType": homeLoanService.getGroupId(),
						"tnc": "",
						"applicants": [
							{
							"title": workDetails.title.key ? workDetails.title.key : "",
							"titleValue": workDetails.title.value ? JSON.stringify(workDetails.title) : "",
							"applicantType": "",
							"firstName": coApplicantDetails.firstName,
							"middleName": coApplicantDetails.middleName ? coApplicantDetails.middleName : "",
							"lastName": coApplicantDetails.lastName,
							"fatherName": coApplicantDetails.fatherName,
							"motherMaidenName": coApplicantDetails.motherMaidenName,
							// "eduQualification": coApplicantDetails.eduQualification.value,
							// "qualificationCode": coApplicantDetails.eduQualification.key,
							"eduQualificationValue": coApplicantDetails.eduQualification ? JSON.stringify(coApplicantDetails.eduQualification) : "",
							"eduQualification": coApplicantDetails.eduQualification.key,
							"gender": workDetails.gender.key ? workDetails.gender.key : "",
							"genderValue": workDetails.gender.value ? JSON.stringify(workDetails.gender) : "",
							"maritalStatus": "",
							"maritalStatusValue": "",
							"dob": coApplicantDetails.dob,
							"email": coApplicantDetails.email,
							"mobile": coApplicantDetails.mobile,
							"alternateContact": coApplicantDetails.alternateContact,
							"pan": coApplicantDetails.pan,
							"aadhaar":  coApplicantDetails.aadhar,
							"declaration": "",
							"address":addArray,
							"residenceType": workDetails.residenceTypeCurrent ? workDetails.residenceTypeCurrent.key : "",
							"residenceTypeValue": workDetails.residenceTypeCurrent ? JSON.stringify(workDetails.residenceTypeCurrent) : "",
							"monthsInCurrResidence": workDetails.residenceMonthCurrent ? workDetails.residenceMonthCurrent : "",
							"employmentType": coApplicantWorkDetailsVm.detail.employmentType ? coApplicantWorkDetailsVm.detail.employmentType.key : "",
							"employmentTypeValue": coApplicantWorkDetailsVm.detail.employmentType ? JSON.stringify(coApplicantWorkDetailsVm.detail.employmentType) : "",
							"employerType": coApplicantWorkDetailsVm.detail.employerType ? coApplicantWorkDetailsVm.detail.employerType.key : "",
							"employerTypeValue": coApplicantWorkDetailsVm.detail.employerType ? JSON.stringify(coApplicantWorkDetailsVm.detail.employerType) : "",
							"professionType": coApplicantWorkDetailsVm.detail.professionType ? coApplicantWorkDetailsVm.detail.professionType.key : "",
							"professionTypeValue": coApplicantWorkDetailsVm.detail.professionType ? JSON.stringify(coApplicantWorkDetailsVm.detail.employerType) : "",
							"otherProfessionType": coApplicantWorkDetailsVm.isProfession ? coApplicantWorkDetailsVm.detail.profession : "",
							"retirementAge": coApplicantWorkDetailsVm.detail.retirementAge ? coApplicantWorkDetailsVm.detail.retirementAge : "",
							"workExp": coApplicantWorkDetailsVm.detail.workExp ? coApplicantWorkDetailsVm.detail.workExp : "",
							"monthsInCurrJob": coApplicantWorkDetailsVm.detail.monthsInCurrJob ? coApplicantWorkDetailsVm.detail.monthsInCurrJob :"",
							"officeName": coApplicantWorkDetailsVm.detail.officeName,
							"officalEmail": coApplicantWorkDetailsVm.detail.officalEmail,
							"officePhone": coApplicantWorkDetailsVm.detail.officePhone,
							"maritalStatus": workDetails.maritalStatus ? workDetails.maritalStatus.key : "",
      						"maritalStatusValue": workDetails.maritalStatus ? JSON.stringify(workDetails.maritalStatus) : "",
							"netMonthlyIncome": coApplicantWorkDetailsVm.detail.netMonthlyIncome ? coApplicantWorkDetailsVm.detail.netMonthlyIncome : "",
							"netAnnualIncome": coApplicantWorkDetailsVm.detail.netAnnualIncome ? coApplicantWorkDetailsVm.detail.netAnnualIncome : "",
							"incomeHouseProperty": coApplicantWorkDetailsVm.detail.incomeHouseProperty ? coApplicantWorkDetailsVm.detail.incomeHouseProperty : "",
							"emi": coApplicantWorkDetailsVm.emiExisting ? coApplicantWorkDetailsVm.emiExisting : [],
							"totalExistingEMI": "",
							"propertyCost": "",
							"accountNo": workDetails.accountNumber ? workDetails.accountNumber : "",
							"relationWithPrimApplicant": workDetails.relationship ? workDetails.relationship.key : "",
							"relationWithPrimApplicantValue": workDetails.relationship ? JSON.stringify(workDetails.relationship) : "",
							"numberOfHouses": coApplicantDetails.numberOfHousesSliderValue,
							}
						],
						"applicantType": "",
						"applicantState": "",
						"approvalStatus": ""
					};
				
				
				homeLoanService.saveCoApplicant(saveAppRequest).then(function(data) {
					homeLoanService.setEmiResponse(data);
					homeLoanService.setCoApplicantWorkApplication(coApplicantWorkDetailsVm.detail);
					if(homeLoanService.getGroupId() == "TAKEOVER"){
						homeLoanService.propIdentified = 'Y';
						var obj ={};
						homeLoanService.setPropertiesData(obj);
						$state.go('menu.propDetailsHL');
					}else{
						coApplicantWorkDetailsVm.isPropertyIdentified();
					}
					
					//$state.go('menu.calculateEmi');
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});	
			
			}

			coApplicantWorkDetailsVm.isPropertyIdentified = function(){
				var templateSpan = '<div class="text-center roboto-regular font-size-14 color-darkgrey"><span translate="HL_PROP_IDENTIFIED" class=""></span></div>';
				var backPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: templateSpan,
					buttons: [{
						text: 'No',
						type: 'button-assertive',
						onTap: function () {
							backPopup.close();
							homeLoanService.propIdentified = 'N';
							$state.go('menu.calculateEmi');
						}
					},
					{
						text: 'Yes',
						type: 'button-assertive',
						onTap: function () {
							backPopup.close();
							homeLoanService.propIdentified = 'Y';
							var obj ={};
							homeLoanService.setPropertiesData(obj);
							$state.go('menu.propDetailsHL');
							
						}
					}],
				});
			}
			
			coApplicantWorkDetailsVm.goToNextPage = function(){
				if(coApplicantWorkDetailsVm.validateForm()){

					if(coApplicantWorkDetailsVm.detail.employmentType.key == "Salaried" || coApplicantWorkDetailsVm.detail.employmentType.key == "Self-Employed" || coApplicantWorkDetailsVm.detail.employmentType.key == "Businessman"){
						if(parseInt(coApplicantWorkDetailsVm.detail.workExp) < parseInt(coApplicantWorkDetailsVm.detail.monthsInCurrJob)){
							if(coApplicantWorkDetailsVm.isMonthsInCurrJobProfession){
								utilityService.showErrorMessage("Months in current Profession cannot be greater than work experience");
							}else{
								utilityService.showErrorMessage("Months in current Job cannot be greater than work experience");
							}
							return;
						}

						var myDOB = coApplicantWorkDetailsVm.detail.dob;
						var today = new Date();

						var dob = new Date(myDOB);

						var year1=myDOB.split('/')[2];// dob.getFullYear();
						var year2=today.getFullYear();

						var totalYears = year2 - parseInt(year1) - 14;
						var month1=myDOB.split('/')[1];
						var month2=today.getMonth();

						var totalMonths = (totalYears * 12) + month2 - parseInt(month1);

						if(totalMonths < parseInt(coApplicantWorkDetailsVm.detail.workExp)){
							utilityService.showErrorMessage("Maximum experience should be less than your age minus 14 years");
							return;
						} 
					}

					coApplicantWorkDetailsVm.detail.emi = [];
					coApplicantWorkDetailsVm.emiExisting = [];
					if(coApplicantWorkDetailsVm.totalEMIs.length > 0){
						for(var i = 0; i< coApplicantWorkDetailsVm.totalEMIs.length;i++){
							var obj = {};
							obj.type = coApplicantWorkDetailsVm.totalEMIs[i].type.key;
							obj.typeValue = JSON.stringify(coApplicantWorkDetailsVm.totalEMIs[i].type);
							obj.amount = coApplicantWorkDetailsVm.totalEMIs[i].amount ? coApplicantWorkDetailsVm.totalEMIs[i].amount : 0;

							var index = i+1;
							if(coApplicantWorkDetailsVm.sbiLoanEMI > 0){
								if(!obj.type){
									utilityService.showErrorMessage("Please select Loan type of "+ (index + 1) + " in Existing EMI");
									return;
								}else if(parseInt(obj.amount) < 1){
									utilityService.showErrorMessage("Please enter EMI of "+ (index + 1) + " in Existing EMI");
									return;
								}
							}else{
								if(!obj.type){
									utilityService.showErrorMessage("Please select Loan type of "+ index + " in Existing EMI");
									return;
								}else if(parseInt(obj.amount) < 1){
									utilityService.showErrorMessage("Please enter EMI of "+ index + " in Existing EMI");
									return;
								}
							}
							
							coApplicantWorkDetailsVm.detail.emi.push(obj);

							if(coApplicantWorkDetailsVm.totalEMIs[i].type.key != '28'){		//SBI Loans
								var objFilter = {};
								objFilter.type = coApplicantWorkDetailsVm.totalEMIs[i].type.key;
								objFilter.typeValue = JSON.stringify(coApplicantWorkDetailsVm.totalEMIs[i].type);
								objFilter.amount = coApplicantWorkDetailsVm.totalEMIs[i].amount ? coApplicantWorkDetailsVm.totalEMIs[i].amount : 0;
								var index = i+1;								
								coApplicantWorkDetailsVm.emiExisting.push(objFilter);
							}
						}
					}
					coApplicantWorkDetailsVm.saveApplication();
				}
			}

			coApplicantWorkDetailsVm.goBack = function() {
	            $state.go('menu.confirmApplicant');
	        }

			coApplicantWorkDetailsVm.addEMI = function(){
				coApplicantWorkDetailsVm.emi = {
	                "type": "",
					"typeValue" : "",
	                "amount": ""
	            };
	            // if(coApplicantWorkDetailsVm.totalEMIs.length < 6){
	            	coApplicantWorkDetailsVm.totalEMIs.push(coApplicantWorkDetailsVm.emi);
	            // }	           
			}

			coApplicantWorkDetailsVm.calculateEMIs = function(){				
				coApplicantWorkDetailsVm.totalEMICost = 0;
				if(coApplicantWorkDetailsVm.sbiLoanEMI){
					for(var i = 0; i< coApplicantWorkDetailsVm.totalEMIs.length;i++){
						coApplicantWorkDetailsVm.totalEMICost = coApplicantWorkDetailsVm.totalEMICost + (parseFloat(coApplicantWorkDetailsVm.totalEMIs[i].amount) ? parseFloat(coApplicantWorkDetailsVm.totalEMIs[i].amount) : 0); 
					}
					coApplicantWorkDetailsVm.totalEMICost = parseFloat(coApplicantWorkDetailsVm.sbiLoanEMI) + coApplicantWorkDetailsVm.totalEMICost;
				}else{
					for(var i = 0; i< coApplicantWorkDetailsVm.totalEMIs.length;i++){
						coApplicantWorkDetailsVm.totalEMICost = coApplicantWorkDetailsVm.totalEMICost + (parseFloat(coApplicantWorkDetailsVm.totalEMIs[i].amount) ? parseFloat(coApplicantWorkDetailsVm.totalEMIs[i].amount) : 0);						
					}
				}
			}

			coApplicantWorkDetailsVm.deleteEMI = function(emiIndex){			
	            coApplicantWorkDetailsVm.totalEMIs.splice(emiIndex,1);
	            coApplicantWorkDetailsVm.calculateEMIs();
			}

			coApplicantWorkDetailsVm.homeLoanTNC = function(){
				var request = {
					"type": "homeLoanTnc"
				};

				homeLoanService.getTermsAndCondition(request).then(function(data) {
						var title = "Declaration";
						var buttontext = "OK";
						var blankdata = null;
						var detail = $filter('ngBindHtmlFilter')(data);
						utilityService.showAlertModal(title, detail, blankdata, blankdata, $state, buttontext);
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
			}

			coApplicantWorkDetailsVm.hideAllFields = function(){
				coApplicantWorkDetailsVm.isNetMonthlyIncome = false;
				coApplicantWorkDetailsVm.isNetAnnualIncome = false;
				coApplicantWorkDetailsVm.isIncomeFromHouseProp = false;
				coApplicantWorkDetailsVm.isEmployerType = false;
				coApplicantWorkDetailsVm.isRetirementAge = false;
				coApplicantWorkDetailsVm.isProfessionType = false;
				coApplicantWorkDetailsVm.isProfession = false;
				coApplicantWorkDetailsVm.isWorkExp = false;
				coApplicantWorkDetailsVm.isMonthsInCurrJob = false;
				coApplicantWorkDetailsVm.isMonthsInCurrJobProfession = false;
				coApplicantWorkDetailsVm.isOfficeDetails = false;
			}

			coApplicantWorkDetailsVm.clearAllFields = function(){
				coApplicantWorkDetailsVm.detail.retirementAge = "";
				coApplicantWorkDetailsVm.detail.netAnnualIncome = "";
				coApplicantWorkDetailsVm.detail.netMonthlyIncome = "";
				coApplicantWorkDetailsVm.detail.incomeHouseProperty = "";
				coApplicantWorkDetailsVm.detail.professionType="";
				coApplicantWorkDetailsVm.detail.employerType = "";
				coApplicantWorkDetailsVm.detail.profession = "";
				coApplicantWorkDetailsVm.detail.workExp = "";
				coApplicantWorkDetailsVm.detail.monthsInCurrJob = "";
				
			}

			coApplicantWorkDetailsVm.validateAge = function(){
				if(coApplicantWorkDetailsVm.detail.employerType.key == 'PEN'){
					coApplicantWorkDetailsVm.isRetirementAge = false;
					coApplicantWorkDetailsVm.detail.retirementAge = "";
				}else{
					coApplicantWorkDetailsVm.isRetirementAge = true;
				}
			}

			coApplicantWorkDetailsVm.showProfession = function(){
				coApplicantWorkDetailsVm.isProfession = false;
				if((coApplicantWorkDetailsVm.detail.professionType && coApplicantWorkDetailsVm.detail.professionType.key == "0299") || (coApplicantWorkDetailsVm.detail.employmentType && coApplicantWorkDetailsVm.detail.employmentType.key == "Businessman")){
					coApplicantWorkDetailsVm.isProfession = true;
				}	
			}
			coApplicantWorkDetailsVm.showFields = function(){
				$ionicScrollDelegate.resize();
				coApplicantWorkDetailsVm.errObj = {};
				coApplicantWorkDetailsVm.errObj.employmentType = validateService.isValidEmploymentType(coApplicantWorkDetailsVm.detail.employmentType);
				coApplicantWorkDetailsVm.hideAllFields();
				coApplicantWorkDetailsVm.clearAllFields();
				if(coApplicantWorkDetailsVm.detail.employmentType){
					if(coApplicantWorkDetailsVm.detail.employmentType.key == "A"){

					}else if(coApplicantWorkDetailsVm.detail.employmentType.key == "Businessman"){
						coApplicantWorkDetailsVm.isIncomeFromHouseProp = true;
						coApplicantWorkDetailsVm.isNetAnnualIncome = true;
						coApplicantWorkDetailsVm.isWorkExp = true;
						coApplicantWorkDetailsVm.isMonthsInCurrJobProfession = true;
						coApplicantWorkDetailsVm.isProfession = true;
						coApplicantWorkDetailsVm.detail.professionType = "";
						coApplicantWorkDetailsVm.isOfficeDetails = true;
						coApplicantWorkDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
						coApplicantWorkDetailsVm.officePincodeText = "PINCODE";
						coApplicantWorkDetailsVm.officeStateText = "State";
						coApplicantWorkDetailsVm.officeDistrictText = "District";
						coApplicantWorkDetailsVm.officeSubDistrictText = "Sub-District";
						coApplicantWorkDetailsVm.officeVillageTownText = "Village/Town";
						coApplicantWorkDetailsVm.officeCityText = "City";
						coApplicantWorkDetailsVm.officeEmailText = "OFFICE_EMAIL";

					}else if(coApplicantWorkDetailsVm.detail.employmentType.key == "Homemaker" || coApplicantWorkDetailsVm.detail.employmentType.key == "Pensioner"){
						//coApplicantWorkDetailsVm.isNetMonthlyIncome = true;
						coApplicantWorkDetailsVm.isIncomeFromHouseProp = true;
						//coApplicantWorkDetailsVm.isEmployerType = true;
						//coApplicantWorkDetailsVm.isWorkExp = true;
					}else if(coApplicantWorkDetailsVm.detail.employmentType.key == "PensionerR"){
						coApplicantWorkDetailsVm.isNetMonthlyIncome = true;
						coApplicantWorkDetailsVm.isIncomeFromHouseProp = true;
						coApplicantWorkDetailsVm.isEmployerType = true;
						coApplicantWorkDetailsVm.isWorkExp = true;
						coApplicantWorkDetailsVm.isOfficeDetails = true;
						coApplicantWorkDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1_OPT";
						coApplicantWorkDetailsVm.officePincodeText = "PINCODE_OPT";
						coApplicantWorkDetailsVm.officeStateText = "State (Optional)";
						coApplicantWorkDetailsVm.officeDistrictText = "District (Optional)";
						coApplicantWorkDetailsVm.officeSubDistrictText = "Sub-District (Optional)";
						coApplicantWorkDetailsVm.officeVillageTownText = "Village/Town (Optional)";
						coApplicantWorkDetailsVm.officeCityText = "City (Optional)";
						coApplicantWorkDetailsVm.officeEmailText = "OFFICE_EMAIL_OPT";

					}else if(coApplicantWorkDetailsVm.detail.employmentType.key == "Salaried"){
						coApplicantWorkDetailsVm.isIncomeFromHouseProp = true;
						coApplicantWorkDetailsVm.isNetMonthlyIncome = true;
						coApplicantWorkDetailsVm.isRetirementAge = true;
						coApplicantWorkDetailsVm.isWorkExp = true;
						coApplicantWorkDetailsVm.isMonthsInCurrJob = true;
						coApplicantWorkDetailsVm.isEmployerType = true;
						coApplicantWorkDetailsVm.isOfficeDetails = true;
						coApplicantWorkDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
						coApplicantWorkDetailsVm.officePincodeText = "PINCODE";
						coApplicantWorkDetailsVm.officeStateText = "State";
						coApplicantWorkDetailsVm.officeDistrictText = "District";
						coApplicantWorkDetailsVm.officeSubDistrictText = "Sub-District";
						coApplicantWorkDetailsVm.officeVillageTownText = "Village/Town";
						coApplicantWorkDetailsVm.officeCityText = "City";
						coApplicantWorkDetailsVm.officeEmailText = "OFFICE_EMAIL";
					}else if(coApplicantWorkDetailsVm.detail.employmentType.key == "Self-Employed"){
						coApplicantWorkDetailsVm.isIncomeFromHouseProp = true;
					//	coApplicantWorkDetailsVm.isNetMonthlyIncome = true;
						coApplicantWorkDetailsVm.isNetAnnualIncome = true;
						coApplicantWorkDetailsVm.isWorkExp = true;
						coApplicantWorkDetailsVm.isMonthsInCurrJobProfession = true;
						coApplicantWorkDetailsVm.isOfficeDetails = true;
						coApplicantWorkDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
						coApplicantWorkDetailsVm.officePincodeText = "PINCODE";
						coApplicantWorkDetailsVm.officeStateText = "State";
						coApplicantWorkDetailsVm.officeDistrictText = "District";
						coApplicantWorkDetailsVm.officeSubDistrictText = "Sub-District";
						coApplicantWorkDetailsVm.officeVillageTownText = "Village/Town";
						coApplicantWorkDetailsVm.officeCityText = "City";
						coApplicantWorkDetailsVm.officeEmailText = "OFFICE_EMAIL";
					}else{
						coApplicantWorkDetailsVm.hideAllFields();
					}
				}else{
					coApplicantWorkDetailsVm.hideAllFields();
				}

			}

			coApplicantWorkDetailsVm.showFieldsResume = function(){

				if(coApplicantWorkDetailsVm.detail.employmentType){
					if(coApplicantWorkDetailsVm.detail.employmentType.key == "A"){

					}else if(coApplicantWorkDetailsVm.detail.employmentType.key == "Businessman"){
						coApplicantWorkDetailsVm.isIncomeFromHouseProp = true;
						coApplicantWorkDetailsVm.isNetAnnualIncome = true;
						coApplicantWorkDetailsVm.isWorkExp = true;
						coApplicantWorkDetailsVm.isMonthsInCurrJobProfession = true;
						coApplicantWorkDetailsVm.isProfession = true;
						coApplicantWorkDetailsVm.isOfficeDetails = true;
						//coApplicantWorkDetailsVm.detail.professionType = "";
						coApplicantWorkDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
						coApplicantWorkDetailsVm.officePincodeText = "PINCODE";
						coApplicantWorkDetailsVm.officeStateText = "State";
						coApplicantWorkDetailsVm.officeDistrictText = "District";
						coApplicantWorkDetailsVm.officeSubDistrictText = "Sub-District";
						coApplicantWorkDetailsVm.officeVillageTownText = "Village/Town";
						coApplicantWorkDetailsVm.officeCityText = "City";
						coApplicantWorkDetailsVm.officeEmailText = "OFFICE_EMAIL";

					}else if(coApplicantWorkDetailsVm.detail.employmentType.key == "Homemaker" || coApplicantWorkDetailsVm.detail.employmentType.key == "Pensioner"){
						//coApplicantWorkDetailsVm.isNetMonthlyIncome = true;
						coApplicantWorkDetailsVm.isIncomeFromHouseProp = true;
						//coApplicantWorkDetailsVm.isEmployerType = true;
						//coApplicantWorkDetailsVm.isWorkExp = true;
					}else if(coApplicantWorkDetailsVm.detail.employmentType.key == "PensionerR"){
						coApplicantWorkDetailsVm.isNetMonthlyIncome = true;
						coApplicantWorkDetailsVm.isIncomeFromHouseProp = true;
						coApplicantWorkDetailsVm.isEmployerType = true;
						coApplicantWorkDetailsVm.isWorkExp = true;
						coApplicantWorkDetailsVm.isOfficeDetails = true;
						coApplicantWorkDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1_OPT";
						coApplicantWorkDetailsVm.officePincodeText = "PINCODE_OPT";
						coApplicantWorkDetailsVm.officeStateText = "State (Optional)";
						coApplicantWorkDetailsVm.officeDistrictText = "District (Optional)";
						coApplicantWorkDetailsVm.officeSubDistrictText = "Sub-District (Optional)";
						coApplicantWorkDetailsVm.officeVillageTownText = "Village/Town (Optional)";
						coApplicantWorkDetailsVm.officeCityText = "City (Optional)";
						coApplicantWorkDetailsVm.officeEmailText = "OFFICE_EMAIL_OPT";

					}else if(coApplicantWorkDetailsVm.detail.employmentType.key == "Salaried"){
						coApplicantWorkDetailsVm.isIncomeFromHouseProp = true;
						coApplicantWorkDetailsVm.isNetMonthlyIncome = true;
						coApplicantWorkDetailsVm.isRetirementAge = true;
						coApplicantWorkDetailsVm.isWorkExp = true;
						coApplicantWorkDetailsVm.isMonthsInCurrJob = true;
						coApplicantWorkDetailsVm.isEmployerType = true;
						coApplicantWorkDetailsVm.isOfficeDetails = true;
						coApplicantWorkDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
						coApplicantWorkDetailsVm.officePincodeText = "PINCODE";
						coApplicantWorkDetailsVm.officeStateText = "State";
						coApplicantWorkDetailsVm.officeDistrictText = "District";
						coApplicantWorkDetailsVm.officeSubDistrictText = "Sub-District";
						coApplicantWorkDetailsVm.officeVillageTownText = "Village/Town";
						coApplicantWorkDetailsVm.officeCityText = "City";
						coApplicantWorkDetailsVm.officeEmailText = "OFFICE_EMAIL";
					}else if(coApplicantWorkDetailsVm.detail.employmentType.key == "Self-Employed"){
						coApplicantWorkDetailsVm.isIncomeFromHouseProp = true;
					//	coApplicantWorkDetailsVm.isNetMonthlyIncome = true;
						coApplicantWorkDetailsVm.isNetAnnualIncome = true;
						coApplicantWorkDetailsVm.isWorkExp = true;
						coApplicantWorkDetailsVm.isMonthsInCurrJobProfession = true;
						coApplicantWorkDetailsVm.isOfficeDetails = true;
						coApplicantWorkDetailsVm.officeAddressLine1Text = "ADDRESS_LINE_1";
						coApplicantWorkDetailsVm.officePincodeText = "PINCODE";
						coApplicantWorkDetailsVm.officeStateText = "State";
						coApplicantWorkDetailsVm.officeDistrictText = "District";
						coApplicantWorkDetailsVm.officeSubDistrictText = "Sub-District";
						coApplicantWorkDetailsVm.officeVillageTownText = "Village/Town";
						coApplicantWorkDetailsVm.officeCityText = "City";
						coApplicantWorkDetailsVm.officeEmailText = "OFFICE_EMAIL";
					}else{
						coApplicantWorkDetailsVm.hideAllFields();
					}
				}else{
					coApplicantWorkDetailsVm.hideAllFields();
				}
			}

			coApplicantWorkDetailsVm.showMInfoPopup = function(type){
				var templateInfo = "";
				if(type == 'netMonthlyIncome'){
					templateInfo = '<p translate="MONTHLY_INCOME_TOOL_TIP"></p>';
				}else if(type == 'netAnnualIncome'){
					templateInfo = '<p translate="ANNUAL_INCOME_TOOL_TIP"></p>';
				}else if(type == 'houseProp'){
					templateInfo = '<p translate="INCOME_HOUSE_TOOL_TIP"></p>';
				}else if(type == 'propertyCost'){
					templateInfo = '<p translate="PROP_COST_TOOL_TIP"></p>';
				}

				var hlInfoIcon = $ionicPopup.show({
					template: templateInfo,
					title: '',
					cssClass: 'dialog',
					scope: $scope,
					buttons: [{
						text: 'OK',
						type: 'button-positive'
					}]
				});

			}
			
			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
				$ionicScrollDelegate.resize();
			});

			return this;
		}

		
]);


