'use strict';
angularApp.controller('hlConfirmScheduleController', [
		"$state",
		"$scope",
		"$filter",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"customerInfoService",
		"homeLoanService",
		"openUrlInAppbroswerService",
		"irctcService",
		function($state, $scope,$filter, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,customerInfoService,homeLoanService,openUrlInAppbroswerService,irctcService) {
			
			var hlConfirmScheduleVm = this;
			
			function initPage() {
				hlConfirmScheduleVm.appointmentDetails = homeLoanService.appointmentDetails;
				hlConfirmScheduleVm.selDoc = hlConfirmScheduleVm.appointmentDetails.selDoc;
				hlConfirmScheduleVm.appdate = hlConfirmScheduleVm.appointmentDetails.appDate;
				if(hlConfirmScheduleVm.appointmentDetails.docPickTime){
					hlConfirmScheduleVm.appdatetime = hlConfirmScheduleVm.appointmentDetails.docPickTime.value;
				}
				
				hlConfirmScheduleVm.docSubmitBranch = homeLoanService.docSubmitBranch;
				hlConfirmScheduleVm.pickUpContactDetails = homeLoanService.pickUpContactDetails;
				hlConfirmScheduleVm.listOfDocuments = ["Agreement for Sale","Index 2","Allotment Letter","NOC for Builder (SBI format)","NOC for Project Finance","Aadhaar Copy"];
			}

			
			hlConfirmScheduleVm.goToAccOverview = function(){
				$state.go('menu.accountOverviewMyBalance');
			}

			hlConfirmScheduleVm.gotoInsurance = function(type){
				if(type == 'li'){
					$state.go('menu.generalInsurance');
				}else if(type == 'gi'){
					$state.go('menu.generalInsurance');
				}
			}
			
			hlConfirmScheduleVm.goToHome = function(){
				$state.go('menu.homeScreen')
			}

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


