'use strict';
angularApp.controller('hlRetrieveAppController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"homeLoanService",
		"irctcService",
		"openUrlInAppbroswerService",
		"$ionicScrollDelegate",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,homeLoanService,
			irctcService,openUrlInAppbroswerService,$ionicScrollDelegate) {
			
			var hlRetrieveAppVm = this;
			
			function initPage() {
				hlRetrieveAppVm.listOfDocuments = ["Agreement for Sale","Index 2","Allotment Letter","NOC for Builder (SBI format)","NOC for Project Finance","Aadhaar Copy"];
				hlRetrieveAppVm.salesPersonName = "Mr. ABC";
				hlRetrieveAppVm.salesPersonMobile = "+91 9876615556";
				if(homeLoanService.isMultipleLOS){
					hlRetrieveAppVm.isMultipleLOS = true;
					hlRetrieveAppVm.multipleAppStatus = homeLoanService.multipleAppErrors;
									
					hlRetrieveAppVm.applicationRef = hlRetrieveAppVm.multipleAppStatus.yonoRef;

				}else{
					hlRetrieveAppVm.applicationRef = homeLoanService.getYonoDedupeData() ? homeLoanService.getYonoDedupeData().yonoRef : "";
					hlRetrieveAppVm.appStartDate = homeLoanService.getYonoDedupeData() ? homeLoanService.getYonoDedupeData().startDate : "";
					hlRetrieveAppVm.losRetrieveStatus = homeLoanService.getLosDedupeData();
					// hlRetrieveAppVm.losRetrieveStatus = {
					//     "losDedupResult": "Y",
					//     "currApplicationStatus": [
					//       "Verification Completed"
					//     ],
					//     "losRef": [
					//       "124525","1245267"
					//     ],
					//     "statusCode": "3"
					//   };

					  hlRetrieveAppVm.yonoDedupe = homeLoanService.getYonoDedupeData();
					  if(hlRetrieveAppVm.losRetrieveStatus.propertyIdentify == 'Y'){
					  	hlRetrieveAppVm.isDocUpload = true;
					  }else{
					  	hlRetrieveAppVm.isDocUpload = false;
					  }

					  hlRetrieveAppVm.crmAssignedName = hlRetrieveAppVm.losRetrieveStatus.crmAssignedName;
					  hlRetrieveAppVm.crmAssignedNumber = hlRetrieveAppVm.losRetrieveStatus.crmAssignedNumber;
					  hlRetrieveAppVm.docStage = hlRetrieveAppVm.losRetrieveStatus.docStage;
					// hlRetrieveAppVm.yonoDedupe = {
					//     "loanExist": "FALSE",
					//     "loanStage": "string",
					//     "yonoRef": "string",
					//     "losRef": "string",
					//     "status": "string",
					//     "startDate": "string",
					//     "pdfName": "string",
					//     "consentsExist": "string",
					//     "consents": [
					//       {
					//         "appOrTransNo": "HL-1",
					//         "approverCifNo": "string",
					//         "consentType": "string",
					//         "consentStatus": "string",
					//         "requesterCifNo": "string",
					//         "approverMobileNo": "string",
					//         "requesterMobileNo": "string",
					//         "approverEmailId": "string",
					//         "requesterEmailId": "string",
					//         "applicationStartDate": "string",
					//         "requesterName": "string",
					//         "approverName": "string",
					//         "consentStartDate": "string"
					//       }//,
					//       // {
					//       //   "appOrTransNo": "HL-2",
					//       //   "approverCifNo": "string",
					//       //   "consentType": "string",
					//       //   "consentStatus": "string",
					//       //   "requesterCifNo": "string",
					//       //   "approverMobileNo": "string",
					//       //   "requesterMobileNo": "string",
					//       //   "approverEmailId": "string",
					//       //   "requesterEmailId": "string",
					//       //   "applicationStartDate": "string",
					//       //   "requesterName": "string",
					//       //   "approverName": "string",
					//       //   "consentStartDate": "string"
					//       // }
					//     ]
					//   };

					if(hlRetrieveAppVm.losRetrieveStatus.currApplicationStatus){
						hlRetrieveAppVm.isResumeApp = false;
						hlRetrieveAppVm.isRetrieveApp = true;
					}else{
						hlRetrieveAppVm.isResumeApp = true;
					}

					if(hlRetrieveAppVm.yonoDedupe.yonoRef){
						hlRetrieveAppVm.isLoanExistsOnYONO = true;
					}else{
						hlRetrieveAppVm.isLoanExistsOnYONO = false;
					}


					//Code commented as condition added for Takeover
					// if(hlRetrieveAppVm.yonoDedupe.loanExist == "FALSE"){
					// 	hlRetrieveAppVm.isLoanExistsOnYONO = false;
					// }else if(hlRetrieveAppVm.yonoDedupe.loanExist == "TRUE" ){
					// 	hlRetrieveAppVm.isLoanExistsOnYONO = true;
					// }
					//hlRetrieveAppVm.isResumeApp = true;
				}

				hlRetrieveAppVm.consentStateYono = hlRetrieveAppVm.yonoDedupe;
					hlRetrieveAppVm.consentState = hlRetrieveAppVm.consentStateYono.consents;			
				};

				hlRetrieveAppVm.expandConsent = function(index){
					if(hlRetrieveAppVm.consentState[index].isExpand)
	                {
	                    hlRetrieveAppVm.consentState[index].isExpand=false;
	                }
	                else
	                {
	                    hlRetrieveAppVm.consentState[index].isExpand=true;
	                }
	                $ionicScrollDelegate.resize();
				}

				hlRetrieveAppVm.goBack = function(){
					$ionicHistory.goBack(-1);
				}

				// hlRetrieveAppVm.uploadDoc = function(){
				// 	homeLoanService.docSubmitType = 0;
				// 	homeLoanService.selectedPrefBranch = 1;
				// }

			

			hlRetrieveAppVm.downloadLetter = function(isEmail){
				var payload = {};
				if(!isEmail){
					payload = {
					  "isEmail": false,
					  "type": "inprinciple"
					};
				}else{
					payload = {
					  "isEmail": true,
					  "type": "inprinciple"
					};
				}
				 
				homeLoanService.getDocument(payload).then(function(data) {

					if(!isEmail)
	                  {
			            var filename =  data.fileName+'.pdf';
			            var content =  data.pdf;
						var contentType = "application/pdf";
						if(utilityService.isAndroidPlatform()){
							hlRetrieveAppVm.android = true;

							hlRetrieveAppVm.folderpath = cordova.file.externalRootDirectory;
						}
						if(utilityService.isIOSPlatform()){
							hlRetrieveAppVm.folderpath = cordova.file.applicationDirectory;
						}
						 irctcService.savebase64AsPDF(hlRetrieveAppVm.folderpath,filename,content,contentType);
						if(utilityService.isIOSPlatform()){
						var finalObject = {"folderpath":hlRetrieveAppVm.folderpath,"filename":filename};
						openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
						}
						if(hlRetrieveAppVm.android) {
							var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:hlRetrieveAppVm.folderpath}"></div>';
				    			hlRetrieveAppVm.downloadPopup = $ionicPopup.show({
				    				title: '',
				    				template: template,
				    				scope: $scope,
				    				cssClass: 'my-custom-popup',
				    				buttons: [{
				    					text:'OK',
				    					type: 'button-assertive',
				    					onTap: function() { 
				    						hlRetrieveAppVm.downloadPopup.close();

				    					}
				    				}],
				    			});
						
						}
						hlRetrieveAppVm.successPopup.close();
					}
					else
                        {
                        	var alertPopup = $ionicPopup.alert({
								template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Email has been sent successfully</p>"
							});
                        }
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});

			}

			hlRetrieveAppVm.reviewConsent = function(consentObj){
				homeLoanService.appOrTransNo = consentObj.appOrTransNo;
				var request = {
				  "yonoRef": consentObj.appOrTransNo
				};
				homeLoanService.reviewConsent(request).then(function(data) {
					homeLoanService.setConsentData(data);
					$state.go('menu.homeLoanConsentPrimary');
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			hlRetrieveAppVm.rejectConsent = function(consentObj){
				homeLoanService.appOrTransNo = consentObj.appOrTransNo;
				var backPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div class="button_fund font-size-14 roboto-medium color-darkgrey" translate="HL_REJECT_APP"></div>',
					buttons: [{
						text: 'No',
						type: 'button-assertive',
						onTap: function () {
							backPopup.close();
						}
					},
					{
						text: 'Yes',
						type: 'button-assertive',
						onTap: function () {
							//service call for reject
							var request = {
							  "loanType": homeLoanService.getGroupId(),
							  "action": "REJECT",
							  "yonoRef": consentObj.appOrTransNo
							};
							homeLoanService.updateConsent(request).then(function(data) {
								$state.go('menu.loans');
							},function(error){
								utilityService.showErrorMessage(error.responseMessage);
							});
							backPopup.close();
						}
					}],
				});

				
			}			

			hlRetrieveAppVm.applyNew = function(){

				var backPopup = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div class="button_fund font-size-14 roboto-medium color-darkgrey" translate="HL_DELETE_APP"></div>',
					buttons: [{
						text: 'No',
						type: 'button-assertive',
						onTap: function () {
							backPopup.close();
						}
					},
					{
						text: 'Yes',
						type: 'button-assertive',
						onTap: function () {
							//service call for reject
							var request = {
								"loanType" : homeLoanService.getGroupId()
							};
							homeLoanService.removeApplication(request).then(function(data) {
								homeLoanService.clearAll();
								homeLoanService.isResume = false;
								$state.go('menu.loans');
								var alertPopup = $ionicPopup.alert({
									template: "<p style='text-align:center;font-weight:bold;font-size:16px'>All your pending applications have been deleted.</p>"
								});								
							},function(error){
								utilityService.showErrorMessage(error.responseMessage);
							});
							backPopup.close();
						}
					}],
				});

			}

			hlRetrieveAppVm.resumeApp = function(){
				homeLoanService.disableBackButton = false;
				homeLoanService.getApplication().then(function(data) {
					homeLoanService.setGroupId(data.loanType);
					var consentStatus = {};
					var primaryApplicant = [];
					var coApplicant = [];
					homeLoanService.isPropertyIdentified = data.propertyIdentify;
					if(data.crmLeadId){
						var obj = {
							"crmLeadId": data.crmLeadId,
    						"crmAssignedName": data.crmAssignedName,
    						"crmAssignedNumber": data.crmAssignedNumber
						};
						homeLoanService.setCRMData(obj);
					}

					if(data.propertyIdentify == "Y"){
						var obj = {
				  			"propertyIdentify": "Y",
				  			"loanPurpose": data.loanPurpose,
				  			"propertyType": data.propertyType,
				  			"propertyValue": data.propertyValue,
				  			"numberOfFloors": data.numberOfFloors,
				  			"moratoriumPeriod": data.moratoriumPeriod,
				  			"carpetArea": data.carpetArea
						};
						homeLoanService.setPropertiesData(obj);
					}
					
					if(data.propertyDetails){
						homeLoanService.reraPropertyDetails = data.propertyDetails;
					}
					

					if(data.takeOverDetails){
						homeLoanService.populateTakeoverData(data.takeOverDetails);
					}

					if(data.topupDetails){
						homeLoanService.setTopupData(data.topupDetails);
					}

					for(var i=0; i < data.applicants.length; i++){
						if(data.applicants[i].applicantType == "P"){
							primaryApplicant.push(data.applicants[i]);
						}else{
							homeLoanService.setIsCoApplicant(true);
							coApplicant.push(data.applicants[i]);
						}
					}
					homeLoanService.userMaster = {};
					homeLoanService.userMaster.master = data.master;
					if(data.applicants.length > 0){
						homeLoanService.homeBranch = data.applicants[0].homeBranch;
					}
					
					if(data.channel.mobile.pageNo.indexOf("1") >= 0){
						homeLoanService.setYonoRef(data.yonoRef);
						homeLoanService.populatePersonalPrimaryApplicant(primaryApplicant[0]);
						homeLoanService.populateWorkPrimaryApplicant(data,primaryApplicant[0]);
						if(data.channel.mobile.pageNo.indexOf("2") >= 0){
							homeLoanService.isResume = true;
							consentStatus.customerName = coApplicant[0].firstName + " " + coApplicant[0].lastName;
							homeLoanService.setFetchCoApplicant(coApplicant[0]);
							homeLoanService.populatePersonalCoApplicant(coApplicant[0]);
							homeLoanService.populateWorkCoApplicant(coApplicant[0]);
							if(data.channel.mobile.pageNo.indexOf("3") >= 0 || data.channel.mobile.pageNo.indexOf("4") >= 0){	
								homeLoanService.populateEmiPage(data);
								//$state.go('menu.calculateEmi');
							}// else{
							// 	$state.go('menu.coApplicantWorkDetails');
							// }
						}else{
							if(data.channel.mobile.pageNo.indexOf("3") >= 0){	
								homeLoanService.populateEmiPage(data);
								//$state.go('menu.calculateEmi');
							}// else{
							// 	$state.go('menu.addCoApplicant');
							// }
						}
					}

					if((data.consentData && data.consentData.length > 0) && !(data.channel.mobile.pageNo.indexOf("5") >= 0)){
						
						consentStatus.consentStatus = data.consentData[0].consentStatus.toLowerCase();
						homeLoanService.disableBackButton = true;
						homeLoanService.setConsentStatus(consentStatus);
						$state.go('menu.consentStatusHL');
					}else{
						if(data.channel.mobile.pageNo.indexOf("1") >= 0){
							if(data.channel.mobile.pageNo.indexOf("2") >= 0 || data.channel.mobile.pageNo.indexOf("4") >= 0){
								if(data.channel.mobile.pageNo.indexOf("5") >= 0){
									var request = {
										"loanType": homeLoanService.getGroupId()
									};
									homeLoanService.getRecommendedProduct(request).then(function(data) {
										if(data.cirResult == "Y"){
											homeLoanService.setRecommendedResponse(data);
											//Disable back button
											homeLoanService.disableBackButton = true;
											$state.go('menu.recommendProduct');
										}else if(data.cirResult == "E"){
											//Disable back button
											homeLoanService.disableBackButton = true;
											if(homeLoanService.getGroupId() == "TAKEOVER"){
												$state.go('menu.calculateEmiTakeover');
											}else{
												$state.go('menu.calculateEmi');
											}
											
										}else if(data.cirResult == "P"){
											utilityService.showErrorMessage("Credit Bureau enquiry not completed.");
										}else if(data.cirResult == "N"){
											utilityService.showErrorMessage($translate.instant("BUREAU_CHECK_FAILED"));
										}
									},function(error){
										utilityService.showErrorMessage(error.responseMessage);
									});
								}else{
									if(data.channel.mobile.pageNo.indexOf("2") >= 0) {
										$state.go('menu.coApplicantWorkDetails');
									}else{
										$state.go('menu.addCoApplicant');
									}									
								}
							}else{
								$state.go('menu.addCoApplicant');
							}
						}
					}			
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});

				
			}

			hlRetrieveAppVm.uploadDoc = function(){
				homeLoanService.getApplication().then(function(data) {
					if(data.crmLeadId){
						var obj = {
							"crmLeadId": data.crmLeadId,
    						"crmAssignedName": data.crmAssignedName,
    						"crmAssignedNumber": data.crmAssignedNumber
						};
						homeLoanService.setCRMData(obj);
					}
					homeLoanService.setApplicationDetails(data);
					homeLoanService.appointmentDetails = {};
					var obj = {
						"propLocation":data.propertyDetails.city,
						"addLocation":JSON.parse(data.applicants[0].address[0].cityText).value,
					};
					homeLoanService.docLandingLocation = obj;
					homeLoanService.userMaster = {};
					homeLoanService.userMaster.master = data.master;
					$state.go('menu.hlDocLanding');
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
				
			}
		

			hlRetrieveAppVm.goToHome = function(){
				$state.go('menu.homeScreen')
			}

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			return this;
		}

		
]);


