'use strict';
angularApp.controller('propByReraHLController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"$ionicScrollDelegate",
		"customerInfoService",
		"validateService",
		"$filter",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,$ionicScrollDelegate,customerInfoService,validateService,$filter,homeLoanService) {
			
			var propByReraHLVm = this;

			function initPage() {
				propByReraHLVm.detail = angular.copy(homeLoanService.reraPropertyDetails);
				propByReraHLVm.propertySearchType = homeLoanService.propertySearchType;	
				propByReraHLVm.errObj = {};	
				searchPropHLVm.detail = homeLoanService.searchPageDetails;		
			}

			propByReraHLVm.validateForm = function(){
				propByReraHLVm.errObj = {};
				if(!propByReraHLVm.detail.propertyAddressline1){
					propByReraHLVm.errObj.propertyAddressline1 = $translate.instant('HL_ERR_ADDLINE1');
				}

				return (angular.equals({}, propByReraHLVm.errObj)) ? true : false;
			}	

			propByReraHLVm.goToNextPage = function(){
				if(propByReraHLVm.validateForm()){
					//show popup and navigate HL_APPROVED_PROJ propertyIdentify
					var templateSpan = '<div class="text-center roboto-regular font-size-16 color-darkgrey"><span translate="HL_APPROVED_PROJ" class=""></span></div>';
					var backPopup = $ionicPopup.show({
						title: null,
						cssClass: 'my-custom-popup',
						template: templateSpan,
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								backPopup.close();
								if(homeLoanService.getGroupId() == "TAKEOVER"){
									$state.go('menu.calculateEmiTakeover');
								}else{
									$state.go('menu.pmay');
								}								
							}
						}],
					});
				}			

			}

			propByReraHLVm.goBack = function() {
				//$state.go('menu.homeLoanPersonalDetails');
				$ionicHistory.goBack(-1);
	        }

			
			
			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});
			
		

			return this;
		}

		
]);


