'use strict';
angularApp.controller('searchPropHLController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"$ionicScrollDelegate",
		"customerInfoService",
		"validateService",
		"$filter",
		"homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,$ionicScrollDelegate,customerInfoService,validateService,$filter,homeLoanService) {
			
			var searchPropDetailsHLVm = this;

			function initPage() {
				
				
			}

			searchPropDetailsHLVm.validateForm = function(){
				searchPropDetailsHLVm.errObj = {};

				if(!searchPropDetailsHLVm.detail.addressLine1){
					searchPropDetailsHLVm.errObj.addressLine1 = $translate.instant('HL_ERR_ADDLINE1');
				}
				if(!searchPropDetailsHLVm.detail.addressLine2){
					searchPropDetailsHLVm.errObj.addressLine2 = $translate.instant('HL_ERR_ADDLINE2');
				}



				return (angular.equals({}, searchPropDetailsHLVm.errObj)) ? true : false;
			}

			

			searchPropDetailsHLVm.goToNextPage = function(){
				if(searchPropDetailsHLVm.validateForm()){
					 
					//searchPropDetailsHLVm.saveApplication();
				}
			}

			searchPropDetailsHLVm.goBack = function() {
				//$state.go('menu.homeLoanPersonalDetails');
	        }

			searchPropDetailsHLVm.loadDistrict = function(type){
				var masterKey = "";
				if(type == 'district'){
					searchPropDetailsHLVm.detail.district = "";
					searchPropDetailsHLVm.detail.city="";
					masterKey = searchPropDetailsHLVm.detail.state.key;
				}else if(type == 'subdistrict'){
					searchPropDetailsHLVm.detail.city="";
					masterKey = searchPropDetailsHLVm.detail.district.key;
				}

				var request = {
				  "key": masterKey,
				  "action": type
				};

				homeLoanService.getDistrictCity(request).then(function(data) {
					if(type == 'district'){
						searchPropDetailsHLVm.districts = data.info;
					}else if(type == 'subdistrict'){
						searchPropDetailsHLVm.cities = data.info;
					}
					
					
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			
			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});
			
		

			return this;
		}

		
]);


