'use strict';
angularApp.controller('loansLandingController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"loanConfig",
		"lifeInsuranceBasicApplicationService","ompMerchantsService", "mPinLoginService","homeLoanService","loggedInUserService","hlNTBCalculatorService","clNTBCalculatorService","clickStreamService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate,loanConfig,
			lifeInsuranceBasicApplicationService,ompMerchantsService,mPinLoginService,homeLoanService,loggedInUserService,hlNTBCalculatorService,clNTBCalculatorService,clickStreamService) {
			
		var loansLandingVm = this;
		$scope.isLoggedin = mPinLoginService.isLoggedIn;
		loansLandingVm.isLoggedin = $scope.isLoggedin;
		loansLandingVm.goBack = function () {
			if (!loansLandingVm.isLoggedin) {
				$state.go('menu.userLogin');
			} else {
				$ionicHistory.clearCache().then(function () {
					$ionicHistory.goBack(-1);
				})
			}
		};

		function initPage() {				
			lifeInsuranceBasicApplicationService.getLoanLanding().then(function(data){
				loansLandingVm.groups = data.getLoans;
				//lifeInsuranceBasicApplicationService.setlandingPageDetails(data.getLoans);
			},function(error){
				utilityService.showErrorMessage(error.responseMessage);
			});				
		};

		loansLandingVm.redirect=function(id) {
			 lifeInsuranceBasicApplicationService.getHomeLoanRedirection1(id).then(function(response) {
				if(id == "education"){
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "EDU_LOAN_MOB"));
					if(utilityService.isAndroidPlatform()){
					 ompMerchantsService.inChromeBrowser(response.url); 
				  }
				  else{
					  ompMerchantsService.inAppBrowser(response.url);
				  }		
				  	
				} else if(id == "xpress") {
				//ompMerchantsService.inAppBrowser(response.url);
				homeLoanService.preLoginSelectedLoanType = id;
				loggedInUserService.productClicked = 'menu.loans';
				$state.go('menu.userLogin');
				}else if(id == "home"){
					homeLoanService.preLoginSelectedLoanType = id;
					loggedInUserService.productClicked = 'menu.loans';
					hlNTBCalculatorService.isFromHamburger = true;
					hlNTBCalculatorService.isFromNTB = false;
					$state.go('menu.hlNTBExploreHomeLoan');
				}else if (id == "car") {
					homeLoanService.preLoginSelectedLoanType = id;
					clNTBCalculatorService.isFromHamburger = true;
					clNTBCalculatorService.isFromNTB = false;
					loggedInUserService.productClicked = 'menu.loans';
					$state.go('menu.clNTBExploreCarLoan');
				}
			}, function(error) {
				utilityService.showErrorMessage(error.responseMessage);
			});		
		 }

		loansLandingVm.goToFProducts=function() {
			$state.go("menu.financialProducts");
		}

		$scope.$on('$ionicView.loaded', function () {			
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			initPage();
		});
		return this;
		}		
]);


