'use strict';

angularApp.controller('rxtcCongratulationsController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService", 
    "$filter",
    "rxtcService",
    "homeLoanService",
    "$ionicPopover","$ionicScrollDelegate","$timeout","constantConfig",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        $filter,
        rxtcService,
        homeLoanService,
        $ionicPopover,
        $ionicScrollDelegate,
        $timeout,
        constantConfig) {

        var rxtcCongratulationsVm = this;

        rxtcCongratulationsVm.initPage = function() {            
            rxtcCongratulationsVm.dde = rxtcService.isFromNesl;
            // rxtcCongratulationsVm.loanAmount = 1800000;
            rxtcCongratulationsVm.refNo = rxtcService.yonoRef;
            if (rxtcService.validityDate) {
                rxtcCongratulationsVm.validityDate = rxtcService.validityDate;
            }            
            // rxtcCongratulationsVm.branch = {"branchName":"State Bank Of India SBI000007","address":"PB NO 11 BELAPUR BHAVAN,SECTOR 11 OFFICE NO 3,CBD BELAPUR, NAVIMUMBAI 400614","pincode":"400614","phoneNumber":"27574506","city":"MUMBAI","state":"MAHARASHTRA","id":"40524","latitude":"19.0197419","longitude":"73.0420058","goldPoint":"Y"}
            rxtcCongratulationsVm.branchNo = rxtcService.selectedBranchCode;            
            
            if(rxtcService.isFromNesl){
                $timeout(function(){
                    var request = {
                        "appStatus" : "SUBMITTED"
                    }
                    rxtcService.saveUpdateAppStatus(request).then(function(data) {
                    },function(error){
                    });
                },1000);
            }else{
                rxtcCongratulationsVm.branch = rxtcService.getSelectedBranchData();
            }
        }

        rxtcCongratulationsVm.openPasswordInfo = function ($event) {
            rxtcCongratulationsVm.leftStyle = "left : " + ($event.clientX - 10) + "px";           
            rxtcCongratulationsVm.template = '<ion-popover-view class="loginnewarrow hmbr-info pswd-info-popnew passwordInfoPopup" id="runtimeHeight">'+ 
                '<div class="goldloan-arrow-upnew" style="{{rxtcCongratulationsVm.leftStyle}}"></div>'+'<div class="padBottom3"><span class="inb-lock-roboto-bold font-size-14">Password eg. - 05Mar!8899</span></div>'+
                '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="rxtcCongratulationsVm.closePopover()"><img src="img/Close.png" alt="" class="glPwdClose"></a>'+
                '<div class="popupDivider"></div>'+'<ion-content class="nfs-popover" has-bouncing="false">'+'<div class="row roboto-light font-size-12 padTop15">'+
                '<div class="col col-40"><div class="row"><div><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">05Mar</span><span>ch</span></div><span class="padLeft50">+</span></div><div class="row fss-text-center">Birth date and first 3 letters of birth month with first letter capital</div></div>'+
                '<div class="col col-20"><div class="row"><span class="inb-lock-roboto-bold font-size-12 text-underline-gl padLeft25">!</span><span class="padLeft50">+</span></div><div class="row fss-text-center">Mandatory "!" sign</div></div>'+
                '<div class="col col-40"><div class="row"><span class="padLeft50">9XXXXX</span><span class="inb-lock-roboto-bold font-size-12 text-underline-gl">8899</span></div><div class="row fss-text-center padLeft25">Last 4 digits of the registered mobile number</div></div></div></ion-content></ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(rxtcCongratulationsVm.template, {
                scope: $scope
            });
            $scope.popover.show($event);               
        }

        rxtcCongratulationsVm.closePopover = function(){
            $scope.popover.hide();
            $ionicScrollDelegate.resize();
        }

        rxtcCongratulationsVm.openMaps = function(loc){
             var geocoords = loc.latitude + "," + loc.longitude;
             if (utilityService.isIOSPlatform()) {
                cordova.ThemeableBrowser.open('https://www.google.com/maps/search/?api=1&query=' + geocoords, '_blank',
                {
                    statusbar: {
                        color:'#ffffffff'
                    },
                    toolbar: {
                        height: 37,
                        color: '#ffffffff',
                        image: 'share'
                    },

                    closeButton: {
                        image:'back',
                        height: 37,
                        width: 32,
                        align: 'left',
                        event: 'closePressed'
                    },

                    backButtonCanClose: true
                });
            }else {
                var label = encodeURI('Your Destination'); // encode the label!
                window.open('geo:0,0?q=' + geocoords + '(' + label + ')', '_system');
            }
        } 

        function savebase64AsPDF(filename, content, contentType) {
            rxtcCongratulationsVm.popupFolderpath = "";
            var DataBlob = b64toBlob(content, contentType);
            if (utilityService.isAndroidPlatform()) {
                if(device.version==10){
                    const folderpath = cordova.file.externalDataDirectory;
                    rxtcCongratulationsVm.popupFolderpath = folderpath.replace(cordova.file.externalRootDirectory,"") + filename;
                    window.resolveLocalFileSystemURL(folderpath, function(dir) {
                        dir.getFile(filename, { create: true }, function(file) {
                            file.createWriter(function(fileWriter) {
                                fileWriter.write(DataBlob);
                                 //Show popup 
                                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="RTXC_DOWNLOAD_RECEIPT" translate-values="{filePath:rxtcCongratulationsVm.popupFolderpath}"></div>';
                                rxtcCongratulationsVm.downloadPopup = $ionicPopup.show({
                                    title: '',
                                    template: template,
                                    scope: $scope,
                                    cssClass: 'my-custom-popup',
                                    buttons: [{
                                        text:'OK',
                                        type: 'button-assertive',
                                        onTap: function() {
                                            rxtcCongratulationsVm.downloadPopup.close();
                                        }
                                    }],
                                });
                            }, function() {});
                        });
                    });
                }
                else{
                    //for Android below 10 and Android 11 not for 10
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
                        fileSystem.root.getDirectory("Download", {create: true, exclusive: false},function(dir) {
                            rxtcCongratulationsVm.popupFolderpath = dir.fullPath + filename;
                            dir.getFile(filename, { create: true }, function(file) {
                                file.createWriter(function(fileWriter) {
                                    fileWriter.write(DataBlob);
                                     //Show popup 
                                    var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="RTXC_DOWNLOAD_RECEIPT" translate-values="{filePath:rxtcCongratulationsVm.popupFolderpath}"></div>';
                                    rxtcCongratulationsVm.downloadPopup = $ionicPopup.show({
                                        title: '',
                                        template: template,
                                        scope: $scope,
                                        cssClass: 'my-custom-popup',
                                        buttons: [{
                                            text:'OK',
                                            type: 'button-assertive',
                                            onTap: function() {
                                                rxtcCongratulationsVm.downloadPopup.close();
                                            }
                                        }],
                                    });
                                }, function() {});
                            });
                        });
                    });
                }               
            }
            if (utilityService.isIOSPlatform()){
                const folderpath = cordova.file.documentsDirectory;
                const finalPath = folderpath + filename;
                window.resolveLocalFileSystemURL(folderpath, function (dir) {
                    dir.getFile(filename, { create: true }, function (file) {
                        file.createWriter(function(fileWriter) {
                            fileWriter.write(DataBlob);
                        }, function() {});
                    });
                });
                cordova.plugins.fileOpener2.open(
                    finalPath,
                    'application/pdf', {
                        error: function (e) {
                            console.log('Error status: ' + e.status + ' - Error message: ' + e.message);
                        },
                        success: function () {
                            console.log('file opened successfully');
                        }
                    }
                );
            }          
        }

        function b64toBlob(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;
            var byteCharacters = atob(b64Data);
            var byteArrays = [];

            //Check PDF SIZE
            if (byteCharacters.length >= constantConfig.accOverview.pdfSize) {                           
                utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                return;
            }

            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);
                var byteNumbers = [];
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }
                var byteArray = new Uint8Array(byteNumbers);
                byteArrays.push(byteArray);
            }
            var blob = new Blob(byteArrays, { type: contentType });
            return blob;
        }


        rxtcCongratulationsVm.downloadLetter = function(){

            if(rxtcService.dxcFlag){
                rxtcCongratulationsVm.letterType = "";
            }else{
                rxtcCongratulationsVm.letterType = "SanctionLetter";
            }

            var payload = {};               
            payload = {
              "type": rxtcCongratulationsVm.letterType ? rxtcCongratulationsVm.letterType : ""
            };
        

           rxtcService.getPDFContent(payload).then(function(data) {

                var content = data.pdf;
                var filename = data.fileName;
                var contentType = "application/pdf";
                savebase64AsPDF(filename + ".pdf",content,contentType);            
                
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });

            }

        rxtcCongratulationsVm.goback = function() {
            $ionicHistory.goBack(-1);
        };

        rxtcCongratulationsVm.goToAccOverview = function(){
            $state.go('menu.accountOverviewMyBalance');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            rxtcCongratulationsVm.initPage();
        });

        return this;
    }
]);