'use strict';

angularApp.service('rxtcService',
    function($q, AdapterUtils, utilityService, constantConfig, $ionicPopup, $state, $ionicScrollDelegate,$cordovaCamera) {

        var rxtcService = this;

        var loanDetails,dedupData,buttonText,groupId,photoData,retrieveData,pushData,branchData,locData,codeLocData,finalEligibilityData,
        selectedBranchData;

        this.geocoords = "";
        this.locateByGPS = [];
        this.locateBranches = [];
        this.selectedBranch = "";
        this.selectedMethod = "";
        this.gpsState = "";
        this.locCodeList = "";
        this.rtxcPush = false;
        this.dxcFlag = false;
        this.isFromNesl = false;
        this.yonoRef = "";
        this.isLoanAppSanction = false;
        this.ddeEligible = false;
        this.validityDate = false;
        this.salaryAccountSpecial = false;
        this.neslFailedBack = false;
        this.dataChangeforTNC = false;
        this.letterDownloadedCounter = 0;
        this.reportInitiated = false;

        retrieveData = {
            "cifNo": "",
            "yonoRef": "",
            "rlmsRefNo": "",
            "pan": "",
            "salaryAccountBranchCode": "",
            "salaryAccountNumber": "",
            "salaryAccountType": "",
            "authorizeFlag": "",
            "userFilledLoanAmount": "",
            "userFilledEMI": "",
            "exemptedCategory": "",
            "pageId": "",
            "stageId": "",
            "mclrRate": "",
            "perfiosId": "",
            "perfiosFileId": "",
            "nmiRTXC": "",
            "nmiDXC": "",
            "perfiosEMI": "",
            "finalResultOfRTXCDXC": "",
            "repaymentDay": "",
            "stampDutyFee": "",
            "ddeFee": "",
            "appStatus": "",
            "photographDocId": "",
            "mimeType": "",
            "branchCode": "",
            "homeBranchCode": "",
            "salaryAccountBalance": "",
            "retirementDate": "",
            "tncFlag": "",
            "authorizeFlagForUI": false,
            "tncFlagForUI": false,
            "crmLeadId": "",
            "ddeEligible": "",
            "ddeInitiated": "",
            "ddeOpted": "",
            "perfiosIdTimeStamp": "",
            "selectedProductDetail": {
                "emi": "",
                "facilityType": "",
                "interestRate": "",
                "loanproductName": "",
                "loanproductVariant": "",
                "maxLoanAmount": "",
                "maxTenure": "",
                "minLoanAmount": "",
                "minTenure": "",
                "processingFee": "",
                "requestedAmount": "",
                "tenure": ""
            },
            "employerDetails": {
                "employerCode": "",
                "employerName": "",
                "employmentNatureCode": "",
                "employmentNature": "",
                "employmentNatureForUI": {
                    "key": "",
                    "value": ""
                },
                "organisationTypeCode": "",
                "organisationType": "",
                "organisationTypeForUI": {
                    "key": "",
                    "value": ""
                },
                "totalExp": "",
                "jobStrDate": ""
            },
            "workDetails": {
                "addressLine1": "",
                "addressLine2": "",
                "pincode": "",
                "cityCode": "",
                "cityText": "",
                "districtCode": "",
                "districtText": "",
                "stateCode": "",
                "stateText": "",
                "officeContactNo": ""
            },
            "loanQuoteList": [
              {
                "emi": "",
                "facilityType": "",
                "interestRate": "",
                "loanproductName": "",
                "loanproductVariant": "",
                "maxLoanAmount": "",
                "maxTenure": "",
                "minLoanAmount": "",
                "minTenure": "",
                "processingFee": "",
                "requestedAmount": "",
                "tenure": ""
              }
            ],
            "dob": ""             
        };

        rxtcService.clearAllFields = function() {
            loanDetails = null;buttonText = null;groupId = null;
        }

        rxtcService.clearAll = function() {
            photoData= null;pushData= null;branchData= null;locData= null;codeLocData= null;finalEligibilityData= null; selectedBranchData = null;
            retrieveData = {
                "cifNo": "",
                "yonoRef": "",
                "rlmsRefNo": "",
                "pan": "",
                "salaryAccountBranchCode": "",
                "salaryAccountNumber": "",
                "salaryAccountType": "",
                "authorizeFlag": "",
                "userFilledLoanAmount": "",
                "userFilledEMI": "",
                "exemptedCategory": "",
                "pageId": "",
                "stageId": "",
                "mclrRate": "",
                "perfiosId": "",
                "perfiosFileId": "",
                "nmiRTXC": "",
                "nmiDXC": "",
                "perfiosEMI": "",
                "finalResultOfRTXCDXC": "",
                "repaymentDay": "",
                "stampDutyFee": "",
                "ddeFee": "",
                "appStatus": "",
                "photographDocId": "",
                "mimeType": "",
                "branchCode": "",
                "homeBranchCode": "",
                "salaryAccountBalance": "",
                "retirementDate": "",
                "tncFlag": "",
                "authorizeFlagForUI": false,
                "tncFlagForUI": false,
                "crmLeadId": "",
                "ddeEligible": "",
                "ddeInitiated": "",
                "ddeOpted": "",
                "perfiosIdTimeStamp": "",
                "selectedProductDetail": {
                    "emi": "",
                    "facilityType": "",
                    "interestRate": "",
                    "loanproductName": "",
                    "loanproductVariant": "",
                    "maxLoanAmount": "",
                    "maxTenure": "",
                    "minLoanAmount": "",
                    "minTenure": "",
                    "processingFee": "",
                    "requestedAmount": "",
                    "tenure": ""
                },
                "employerDetails": {
                    "employerCode": "",
                    "employerName": "",
                    "employmentNatureCode": "",
                    "employmentNature": "",
                    "employmentNatureForUI": {
                        "key": "",
                        "value": ""
                    },
                    "organisationTypeCode": "",
                    "organisationType": "",
                    "organisationTypeForUI": {
                        "key": "",
                        "value": ""
                    },
                    "totalExp": "",
                    "jobStrDate": ""
                },
                "workDetails": {
                    "addressLine1": "",
                    "addressLine2": "",
                    "pincode": "",
                    "cityCode": "",
                    "cityText": "",
                    "districtCode": "",
                    "districtText": "",
                    "stateCode": "",
                    "stateText": "",
                    "officeContactNo": ""
                },
                "loanQuoteList": [
                    {
                        "emi": "",
                        "facilityType": "",
                        "interestRate": "",
                        "loanproductName": "",
                        "loanproductVariant": "",
                        "maxLoanAmount": "",
                        "maxTenure": "",
                        "minLoanAmount": "",
                        "minTenure": "",
                        "processingFee": "",
                        "requestedAmount": "",
                        "tenure": ""
                    }
                ],
                "dob": ""           
            };
        }

        rxtcService.savePageDetails = function(data) {
            var getData = rxtcService.getRetrieveData();
            Object.keys(data).forEach(function(key,index) {
                getData[key] = data[key]
            });
            rxtcService.setRetrieveData(getData);
        }
		
		rxtcService.getImageFromGallery=function(){
        	 var options = {
                quality: 50,
                destinationType: Camera.DestinationType.DATA_URL,
                sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
                allowEdit: true,
                popoverOptions: CameraPopoverOptions,
                correctOrientation:true
            }; 
            if (utilityService.isAndroidPlatform()) {
                if(device.version >= 11){
                    options.allowEdit = false ;
                }
            }
            var q =  $q.defer();
                $cordovaCamera.getPicture(options).then(function(imageData) {
                    q.resolve( "data:image/jpeg;base64," + imageData)
                }, function(err) {
                    q.reject("error");
                });
            return q.promise;
        }
		
		rxtcService.getnewImage = function(){
            var options = {
                quality: 50,
                destinationType: Camera.DestinationType.DATA_URL,
                sourceType: Camera.PictureSourceType.CAMERA,
                allowEdit: true,
                encodingType: Camera.EncodingType.JPEG,
                popoverOptions: CameraPopoverOptions,
                saveToPhotoAlbum: false,
                correctOrientation:true
            }; 
            if (utilityService.isAndroidPlatform()) {
                if(device.version >= 11){
                    options.allowEdit = false ;
                }
            }
            var q =  $q.defer();
            $cordovaCamera.getPicture(options).then(function(imageData) {
                q.resolve( "data:image/jpeg;base64," + imageData)
            }, function(err) {
                q.reject("error");
            });
            return q.promise;
        }
		

        // Setter/Getter

        rxtcService.setKnowMoreDetailsData = function(data) {
            loanDetails = data;
        };

        rxtcService.getKnowMoreDetailsData = function() {
            return loanDetails;
        };

        rxtcService.setYonoDedupeData = function(data) {
            dedupData = data;
        };

        rxtcService.getYonoDedupeData = function() {
            return dedupData;
        };

        rxtcService.setButtonText = function(text) {
            buttonText = text;
        };

        rxtcService.getButtonText = function() {
            return buttonText;
        };

        rxtcService.setGroupId = function(id) {
            groupId = id;
        }

        rxtcService.getGroupId = function() {
            return groupId;
        }

        rxtcService.setPhotographData = function(data) {
            photoData = data;
            retrieveData.photographDocId = data.photographDocId;
        }

        rxtcService.getPhotographData = function() {
            return photoData;
        }

        rxtcService.setRetrieveData = function(data) {
            retrieveData = data;
        }

        rxtcService.getRetrieveData = function() {
            return retrieveData;
        }

        rxtcService.setPushData = function(data) {
            pushData = data;
        }

        rxtcService.getPushData = function() {
            return pushData;
        }

        rxtcService.setBranchStateData = function(data) {
            branchData = data;
        }

        rxtcService.getBranchStateData = function() {
            return branchData;
        }

        rxtcService.setBranchByLocationData = function(data) {
            locData = data;
        }

        rxtcService.getBranchByLocationData = function() {
            return locData;
        }

        rxtcService.setBranchByCodeData = function(data) {
            codeLocData = data;
        }

        rxtcService.getBranchByCodeData = function() {
            return codeLocData;
        }

        rxtcService.setFinalEligibilityData = function(data) {
            finalEligibilityData = data;
        }

        rxtcService.getFinalEligibilityData = function() {
            return finalEligibilityData;
        }     

        rxtcService.setSelectedBranchData = function(data) {
            selectedBranchData = data;
        }

        rxtcService.getSelectedBranchData = function() {
            return selectedBranchData;
        }
        
        // Validations

        rxtcService.isValidField = function(obj,field) {
            if (!obj) {
                return 'Please provide ' +field;
            }
            return false;
        }; 

        rxtcService.emiCalculation = function(p,i,t){
            p = parseInt(p);
            i = parseFloat(i)/1200;
            t = parseInt(t);
            var numerator = p * i * Math.pow((1+i),t);
            var denominator = Math.pow((1+i),t) - 1;
            var emiAmount = Math.ceil((numerator/denominator));
            return emiAmount;
        }      

        // API call

        rxtcService.getTnC = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/getRTXCTnC", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.getKnowMoreDetails = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/getKnowMoreDetails", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.getYonoDedupe = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/getYonoDedup", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.getEligiblityCheck = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/checkInitialEligibility", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.enquireEligibilityStage = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/enquireStageDetails", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.getRlmsDedup = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/getRlmsDedup", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.retrieveApplication = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/retrieveApplication", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.deleteApplication = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/deleteApplication", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.validateUserPAN = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/validateUserPAN", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.initiateReport = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/initiateReport", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.uploadPhotograph = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/uploadPhotograph", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.retrievePhotograph = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/retrievePhotograph", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };  

        rxtcService.recalculateLoanDetails = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/recalculateLoanDetails", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.getBranchListByGeo = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/getBranchListByGeo", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.getBranchState = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/getBranchState", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.getBranchCity = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/psg/getBranchCity", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.getBranchByLocation = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/getBranchByLocation", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.getBranchByCode = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/getBranchByCode", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.checkFinalEligibility = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/checkFinalEligibility", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        // Generate OTP
        rxtcService.generateOTP = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", requestData, true).then(function (response) {
                q.resolve(response.data);
            },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };

        //Validate OTP
        rxtcService.validateOTP = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", requestData, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };

        rxtcService.submitApplication = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/submitApplication", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.getDocument = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/getDocument", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.getNESLFormData = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/getNESLFormData", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.searchEmployerByName = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/searchEmployerByName", payLoad, false).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.getPDFContent = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/getPDFContent", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.saveUpdateAppStatus = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/saveUpdateAppStatus", payLoad, false).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.keepSessionActive = function() {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/rtxcdxc/ddeDummyCall", {}, false).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        rxtcService.showAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if(buttontext1 != "" && buttontext2 != ""){
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {

                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {                            
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }                                              
                        }
                    }
                ];
            }
            else{
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            if(imageType && imageType.toLowerCase() == 'error'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if(imageType && imageType.toLowerCase() == 'success'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            }else if(imageType && imageType.toLowerCase() == 'alert'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            }else{
                imageType = "";
            }
            var bhimErrorPopup = $ionicPopup.alert({
                template: '<div class="font-dark-grey">'+imageType+'<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
                + message1 + '</span><div ng-if="message2" class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">'+message2+'</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {
            });
        };


        rxtcService.showAlertPopupWithCallback = function (imageType, message1, message2, message3, buttontext1, buttontext2, $scope, button1,button2) {
            if(imageType && imageType.toLowerCase() == 'error'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if(imageType && imageType.toLowerCase() == 'success'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            }else if(imageType && imageType.toLowerCase() == 'alert'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            }else{
                imageType = "";
            }
            var rtxcPopUp = $ionicPopup.alert({
                template: '<div class="font-dark-grey">'+imageType+'<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
                + message1 + '</span><div  class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">'+message2+'</div><div  class="textAlignCenter roboto-bold font-size-14 color-darkgrey padTop10">'+message3+'</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {
                            button1()
                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            button2()
                        }
                    }
                ]
            });
            rtxcPopUp.then(function (res) {
            });
        };


        rxtcService.showTncAlertPopup = function (content) {
            var test = '<div>'
                        +content+        
                '<div class="rtxcTnC"> <button class="rxtcTnC_button" ng-click = "closePopup()" >OK</button></div></div>';
            var bhimErrorPopup = $ionicPopup.show({
                template: test,
                title: 'Terms & Conditions',
                cssClass: 'bhim-alert-popup hlTermnCondition',
            });
            bhimErrorPopup.then(function (res) {
               //bhimErrorPopup.close();
            });            
        };
        
     return rxtcService;

    });