'use strict';

angularApp.controller('blockUnblockOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"openAccountService",
	"$rootScope",
	"customerInfoService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"blockUnblockService",
	"cardsService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		openAccountService,
		$rootScope,
		customerInfoService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		blockUnblockService,
		cardsService) {

		//functions, variables that can be accessed from the HTML come here
		var blockUnblockOtpVm = this;
		blockUnblockOtpVm.otp = "";

		blockUnblockOtpVm.mobileNumber = $rootScope.mobileNo;
		var count = 0;
		blockUnblockOtpVm.disableCount = function () {
			count += 1;
			if (count >= 3) {
				blockUnblockOtpVm.isNextEnabled = true;
				blockUnblockOtpVm.isDisabledOTP = true;
			}

		}



		blockUnblockOtpVm.goToNext = function () {

			//blockUnblockOtpVm.showNameError1 = blockUnblockOtpVm.otp.length;

			if (blockUnblockOtpVm.otp.length < 6) {
				blockUnblockOtpVm.nextEnable();
			} else {

				var requestParams = {
					otp: blockUnblockOtpVm.otp,
					mobile: customerInfoService.customer.mobile
				}

				personalLoanService.requestOtp(requestParams).then(function (data) {

					if (data.status == "Success") {






						if (blockUnblockService.blockUnblockTab == "block" && blockUnblockService.blockAllCards) {
							//all permanent block cards data
							var reqData = {}

							blockUnblockService.permanentBlockRequest(reqData).then(function (data) {

								blockUnblockOtpVm.successData = data;
								blockUnblockOtpVm.permanentblockcard = 0;
								blockUnblockOtpVm.unblockcard = 0;
								if (data.blockedCards != null) {
									blockUnblockOtpVm.permanentblockcard = data.blockedCards.length;
								}

								// if (blockUnblockOtpVm.unblockcard != null) {
									if (data.unblockedCards != null){
										// data.unblockedCards = 0;
										blockUnblockOtpVm.unblockcard = data.unblockedCards.length;
									}
									// else {
									// 	blockUnblockOtpVm.unblockcard = data.unblockedCards.length;

									// }
									// blockUnblockOtpVm.unblockcard = data.unblockedCards.length;
								// }

								blockUnblockOtpVm.showUnblockcard = data.unblockedCards;
								blockUnblockOtpVm.totalCards = blockUnblockOtpVm.unblockcard + blockUnblockOtpVm.permanentblockcard;



								blockUnblockOtpVm.myPopup = $ionicPopup.show({
									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									templateUrl: 'pages/nfs/blockUnblock/blockAll.html',
									scope: $scope
								});
								blockUnblockService.clearAllData();
							}, function (error) {
								// blockUnblockOtpVm.sendTxnIdData(reqData.txnId);
								utilityService.showErrorMessage(error.responseMessage);

							});


						} else if (blockUnblockService.blockUnblockTab == "block" && !blockUnblockService.blockAllCards) {
							//only selected  block cards data
							//blockUnblockOtpVm.selectedCardType = blockUnblockService.selectedCardType;
							if (blockUnblockService.selectedCardType == "Permanent") {
								blockUnblockOtpVm.selectedCardType = "permanently";
							} else {

								blockUnblockOtpVm.selectedCardType = "temporarily";

							}

							var reqData = {
								cardNumber: blockUnblockService.selectedCardValue.cardNo,
								typeOfBlock: blockUnblockService.selectedCardType
							}

							blockUnblockService.blockRequest(reqData).then(function (data) {

								blockUnblockOtpVm.successData = data;
								blockUnblockOtpVm.myPopup = $ionicPopup.show({
									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									templateUrl: 'pages/nfs/blockUnblock/blockPopup.html',
									scope: $scope
								});
								blockUnblockService.clearAllData();
							}, function (error) {
								// blockUnblockOtpVm.sendTxnIdData(reqData.txnId);
								utilityService.showErrorMessage(error.responseMessage);
								//$state.go('menu.serviceRequest');

							});
						} else {

							//only selected  block cards data

							var reqData = {
								cardNumber: blockUnblockService.selectedCardValue.cardNo
							}

							blockUnblockService.unblockDebitCard(reqData).then(function (data) {

								blockUnblockOtpVm.successData = data;
								blockUnblockOtpVm.myPopup = $ionicPopup.show({
									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									templateUrl: 'pages/nfs/blockUnblock/UnblockPopup.html',
									scope: $scope
								});
								blockUnblockService.clearAllData();
							}, function (error) {
								// blockUnblockOtpVm.sendTxnIdData(reqData.txnId);
								utilityService.showErrorMessage(error.responseMessage);

								//$state.go('menu.serviceRequest');

							});
						}


					}
					else {
						blockUnblockOtpVm.disableCount();
						utilityService.showErrorMessage(data.status);
					}

				}, function (error) {

					// otp faliure
					blockUnblockOtpVm.disableCount();
					utilityService.showErrorMessage(error.responseMessage);
					//$state.go('menu.serviceRequest');

				});

			}



		};

		blockUnblockOtpVm.nextEnable = function () {
			blockUnblockOtpVm.showNameError = blockUnblockOtpVm.otp.length;
			if (blockUnblockOtpVm.otp === blockUnblockOtpVm.otpValue)
				blockUnblockOtpVm.disableNext = false;
			else
				blockUnblockOtpVm.disableNext = true;
		}


		blockUnblockOtpVm.resendOTP = function () {
			if (blockUnblockOtpVm.isDisabledOTP) { return true }
			//    $scope.resendLable = true;
			//    $scope.sendLable = false;
			blockUnblockOtpVm.otp = "";
			var reqData = {
				"id": customerInfoService.customer.mobile,
				"emailId": customerInfoService.customer.emailID
			}
			personalLoanService.otpLoan(reqData).then(function (data) {

			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

			blockUnblockOtpVm.isDisabledOTP = true;
		}





		blockUnblockOtpVm.goToBack = function () {
			$state.go('menu.blockUnblockReview');
		}
		blockUnblockOtpVm.goToHome = function () {
			blockUnblockService.clearAllData();
			$state.go('menu.homeScreen');

		}

		

		/* 	blockUnblockOtpVm.goToNext = function () {
				blockUnblockOtpVm.myPopup = $ionicPopup.show({
						title:'',
						cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
						templateUrl : 'pages/nfs/blockUnblock/Congratulations.html',
						scope:$scope
					});
				
			} */

		blockUnblockOtpVm.tryAgain = function () {
			blockUnblockOtpVm.myPopup.close();
			//blockUnblockVm.otp = "";
			$state.go('menu.blockUnblock');
		};

		blockUnblockOtpVm.ok = function () {
			blockUnblockOtpVm.myPopup.close();
			//blockUnblockVm.otp = "";
			$state.go('menu.innerPage');
		};

		$scope.$on('$ionicView.beforeEnter', function () {

			blockUnblockOtpVm.isDisabledOTP = false;

		});




		return this;
	}
]);
