'use strict';

angularApp.controller('changeAccTypeOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"changeAccountTypeService",
	"$rootScope",
	"customerInfoService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"cryptoService",
	"loggedInUserService",
	"cardsService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		changeAccountTypeService,
		$rootScope,
		customerInfoService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		cryptoService,
		loggedInUserService,
		cardsService) {

		//functions, variables that can be accessed from the HTML come here
		var changeAccTypeOtpVm = this;
		changeAccTypeOtpVm.mobileNumber = $rootScope.mobileNo;
		
		changeAccTypeOtpVm.otp = "";

		var count = 0;
		changeAccTypeOtpVm.disableCount = function () {
			count += 1;
			if (count >= 3) {
				changeAccTypeOtpVm.isNextEnabled = true;
				changeAccTypeOtpVm.isDisabledOTP = true;
			}

		}

		
		changeAccTypeOtpVm.later = function () {

			changeAccountTypeService.clearAll();
			changeAccTypeOtpVm.myPopup.close();
			//utilityService.setCsatJournies('changeProductType');
			$state.go('menu.homeScreen');

		}

		changeAccTypeOtpVm.yes = function () {
			changeAccountTypeService.clearAll();
			changeAccTypeOtpVm.myPopup.close();
			utilityService.setCsatJournies('changeProductType');
			//utilityService.setCsatJournies('smsAlerts');
			$state.go('menu.requestChequeBook');
		}

		changeAccTypeOtpVm.goToNext = function () {

			if (changeAccTypeOtpVm.otp.length < 6) {
				changeAccTypeOtpVm.nextEnable();

			} else {

				var requestParams = {
					otp: changeAccTypeOtpVm.otp,
					mobile: customerInfoService.customer.mobile
				}

				personalLoanService.requestOtp(requestParams).then(function (data) {

					if (data.status == "Success") {

						var hashReqData = loggedInUserService.tokenLotus + changeAccountTypeService.selectedAccount.accountNumber + changeAccountTypeService.selectedAccount.productCode;  
						var ReqDatasha512 = cryptoService.getSHA512EncryptedData(hashReqData).toString();

						var reqData = {
							"accountNumber": changeAccountTypeService.selectedAccount.accountNumber,
							"productType": changeAccountTypeService.selectedAccount.productCode,
							"hash": ReqDatasha512
						}


						changeAccountTypeService.changeProductCode(reqData).then(function (data) {
						changeAccTypeOtpVm.accountMask = "XXXXXXXXXXXX"+ changeAccountTypeService.selectedAccount.accountNumber.substring(changeAccountTypeService.selectedAccount.accountNumber.length - 4);

							changeAccTypeOtpVm.myPopup = $ionicPopup.show({
								title: '',
								cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
								templateUrl: 'pages/nfs/changeAccountType/changeAccTypeSuccessPopUp.html',
								scope: $scope
							})

						}, function (error) {
							changeAccountTypeService.clearAll();
								utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");


						});

					}
					else {
						changeAccTypeOtpVm.disableCount();
						utilityService.showErrorMessage(data.status);
					}

				}, function (error) {
					changeAccTypeOtpVm.disableCount();
					//changeAccountTypeService.clearAll();
						utilityService.showErrorMessage(error.responseMessage);

					//$state.go('menu.serviceRequest');

				});

			}

		};

		changeAccTypeOtpVm.ok = function () {
			changeAccTypeOtpVm.myPopup.close();
			changeAccTypeOtpVm.otp = "";
			$state.go('menu.innerPage');
		};

		changeAccTypeOtpVm.nextEnable = function () {
			changeAccTypeOtpVm.showNameError = changeAccTypeOtpVm.otp.length;
			if (changeAccTypeOtpVm.otp === changeAccTypeOtpVm.otpValue)
				changeAccTypeOtpVm.disableNext = false;
			else
				changeAccTypeOtpVm.disableNext = true;
		}
		changeAccTypeOtpVm.goToHome = function () {
			changeAccountTypeService.clearAll();
			$state.go('menu.homeScreen');
		}


		changeAccTypeOtpVm.resendOTP = function () {
			if (changeAccTypeOtpVm.isDisabledOTP) { return true }
			//    $scope.resendLable = true;
			//    $scope.sendLable = false;
			changeAccTypeOtpVm.otp = "";
			var reqData = {
				"id": customerInfoService.customer.mobile,
				"emailId": customerInfoService.customer.emailID
			}
			personalLoanService.otpLoan(reqData).then(function (data) {

			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

			changeAccTypeOtpVm.isDisabledOTP = true;
		}







		changeAccTypeOtpVm.goToBack = function () {
			$state.go('menu.atmCardActivation');
		}







		return this;
	}
]);
