'use strict';

angularApp.service('changeAccountTypeService',
	function ($q, AdapterUtils) {

		var changeAccountTypeService = this;
		
		changeAccountTypeService.accList = [];
		changeAccountTypeService.selectedAccount = null;

		changeAccountTypeService.clearAll  = function () {

			changeAccountTypeService.accList = [];
			changeAccountTypeService.selectedAccount = null;

		}
		
		
		
		changeAccountTypeService.getAccountsForProductTypeChange = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getAccountsForProductTypeChange", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		
		
		
		changeAccountTypeService.changeProductCode = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/changeProductCode", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		

	

		return changeAccountTypeService;
	});
