'use strict';

angularApp.controller('cdReviewController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup","chequeDepositsService","AdapterUtils","$q","$ionicPopover","$filter","$ionicHistory","getAccountDetailsService",

    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,
        chequeDepositsService,AdapterUtils,$q,$ionicPopover,$filter,$ionicHistory,getAccountDetailsService) {

        var cdReviewVm = this;

        cdReviewVm.totalCheques = [];

        cdReviewVm.init=function (){
          cdReviewVm.isAddEnable = true;  
          cdReviewVm.isNextEnabled = true;
          cdReviewVm.isNextEnabled = false;
          cdReviewVm.totalCheques = chequeDepositsService.ttlCheque
          console.log("Cheq Data " + JSON.stringify(cdReviewVm.cheqData));
          
      }


      cdReviewVm.deleteCheque = function(chequeIndex){
        //   
        cdReviewVm.totalCheques.splice(chequeIndex,1);

        }



        cdReviewVm.goToHome=function (){

            $state.go('menu.homeScreen');
        }

        cdReviewVm.goToBack = function(){
            chequeDepositsService.clearAll();
            $state.go('menu.chequeDeposits');

        }

        cdReviewVm.goToNext = function(){

            //cdReviewVm.totalCheques
            var obj={
               "chequeDetails": cdReviewVm.totalCheques,
            }

            chequeDepositsService.insertCDKCheque(obj).then(function (data) {
                if (data.referenceNumber) {
                    chequeDepositsService.referenceNumber = data.referenceNumber;
                    chequeDepositsService.selDet = {
                        accountNumber: '',
                        selIndex:''
                    }
                    chequeDepositsService.ttlCheque =[];
                    $state.go('menu.thankYouCDK')
                }

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
                //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
            });

            // $state.go('menu.thankYouCDK');
        }

        cdReviewVm.goToPrevious = function(){
          $ionicHistory.goBack(-1);
        }

        
        


     

       

         $scope.$on('$ionicView.beforeEnter', function () {        
           
          
            cdReviewVm.init();


        });

    return this;
  }
]);
