'use strict';

angularApp.controller('chequeDepositsController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup","chequeDepositsService","AdapterUtils","$q","$ionicPopover","$filter","$ionicHistory","getAccountDetailsService","currentLocationService","ionicDatePicker","homeScreenService",

    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,
        chequeDepositsService,AdapterUtils,$q,$ionicPopover,$filter,$ionicHistory,getAccountDetailsService,currentLocationService,ionicDatePicker,homeScreenService) {

        var chequeDepositsVm = this;

        

        chequeDepositsVm.totalCheques = chequeDepositsService.ttlCheque ? chequeDepositsService.ttlCheque : [];

        chequeDepositsVm.init=function (){
          chequeDepositsVm.isAddEnable = true;  
          chequeDepositsVm.isNextEnabled = true;

          if(chequeDepositsVm.totalCheques){
            if(chequeDepositsVm.totalCheques.length > 0){
              chequeDepositsVm.isNextEnabled = false;
            }
          }
          
        //  chequeDepositsVm.payingFrom = getAccountDetailsService.accountOverviewData.accounts;
        //    chequeDepositsVm.accList = [];
        //    chequeDepositsVm.accList = chequeDepositsVm.payingFrom;
            chequeDepositsService.referenceNumber = null;
            chequeDepositsVm.fromeDate = new Date().toISOString().slice(0,10);
				    chequeDepositsVm.toDate = new Date().toISOString().slice(0,10);
            chequeDepositsVm.showDetailPage = false;

            chequeDepositsVm.selectedAccount = chequeDepositsService.selectedAccValue == null ? "" : JSON.stringify(chequeDepositsService.selectedAccValue);
            //chequeDepositsVm.selectedAccFun1();
            chequeDepositsVm.showSelect = true;
            // if(chequeDepositsService.selDet){
            //   if(chequeDepositsService.selDet.selIndex > 0){
            //     chequeDepositsVm.close(chequeDepositsService.selDet.selIndex);
            //   }else{
            //     chequeDepositsVm.close(0);
            //   }
              
            // }
            
      }

      chequeDepositsVm.getAccountList = function () {
        
				if (!chequeDepositsService.accList.length) {

          
          if (!getAccountDetailsService.accountOverviewData) {
            utilityService.showSpinner();
             homeScreenService.getCustomerInfo().then(function (data) {
               utilityService.hideSpinner();
                    getAccountDetailsService.accountOverviewData = data;
                    chequeDepositsService.accList = getAccountDetailsService.accountOverviewData.accounts
                      chequeDepositsVm.accList = chequeDepositsService.accList;                       
                        if(chequeDepositsVm.accList.length == 0){
                      chequeDepositsService.displayPopUp("","padBtm25 top-padding26","No Accounts available","OK",function(){
                        $state.go('menu.homeScreen');
                      });
                    }
                     chequeDepositsVm.close(0);

                    }, function (error) {
                      utilityService.hideSpinner();
            });
          }else{

            chequeDepositsService.accList = getAccountDetailsService.accountOverviewData.accounts
            chequeDepositsVm.accList = chequeDepositsService.accList;             
              if(chequeDepositsVm.accList.length == 0){
						chequeDepositsService.displayPopUp("","padBtm25 top-padding26","No Accounts available","OK",function(){
							$state.go('menu.homeScreen');
						});
					 }
            chequeDepositsVm.close(0);

          }



         





					//chequeDepositsService.getAccountDetails().then(function (data) {
        //     chequeDepositsService.chequeAccountFilterRequest().then(function (data) {            
				// 			chequeDepositsService.accList = data.accList;	
        //       console.log("CDK Acc list " + JSON.stringify(data.accList));
				// 			chequeDepositsVm.accList = chequeDepositsService.accList;
        //       chequeDepositsVm.close(0);
        //       if(chequeDepositsVm.accList.length == 0){
				// 		chequeDepositsService.displayPopUp("","padBtm25 top-padding26","No Accounts available","OK",function(){
				// 			$state.go('menu.homeScreen');
				// 		});
				// 	 }
				// }, function (error) {
        //   if(error.responseCode == "0003"){
        //     chequeDepositsService.displayPopUp("","padBtm25 top-padding26",error.responseMessage,"OK",function(){
				// 		$state.go('menu.homeScreen');
				// 	});
        //   }else{
        //     chequeDepositsService.displayPopUp("","padBtm25 top-padding26",error.responseMessage,"OK",function(){
				// 	//	$state.go('menu.homeScreen');
				// 	});
        //   }
				// 	//utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
          
				// });

				}else{
					chequeDepositsVm.accList = chequeDepositsService.accList;
					//chequeDepositsVm.selectedAccount = chequeDepositsService.chequeDepositsVm.selectedAccount == null ? "" : JSON.stringify(chequeDepositsService.selectedAccValue);
          chequeDepositsVm.showSelect = false;
          if(chequeDepositsService.selDet.selIndex == ""){
            chequeDepositsVm.close(0);
          }else{
            chequeDepositsVm.close(chequeDepositsService.selDet.selIndex);
          }
         
				}
				//chequeDepositsVm.nextEnable();

		}

    // chequeDepositsVm.selectedAccFun1 = function () {
		// 	chequeDepositsService.selectedAccValue = chequeDepositsVm.selectedAccount == "" ? null : JSON.parse(chequeDepositsVm.selectedAccount);	
    //   if (chequeDepositsVm.selectedAccount == "" || chequeDepositsVm.selectedAccount == undefined || chequeDepositsVm.selectedAccount == null) {
				
		// 		chequeDepositsVm.selectedAccount = "";
		// 	}
		// }

    chequeDepositsVm.showPop = function(){
				chequeDepositsVm.popUp = $ionicPopup.show({
					title: '',
					cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
					templateUrl: 'pages/nfs/chequeDeposits/dropdownModal.html',
					scope: $scope
				});
			}

      chequeDepositsVm.close = function(index){
        if(chequeDepositsVm.popUp){
          chequeDepositsVm.popUp.close();
        }
				
				chequeDepositsVm.balance = chequeDepositsVm.accList[index].accountBalance;
				chequeDepositsVm.accType = chequeDepositsVm.accList[index].accountType;
				chequeDepositsVm.accountNumber = chequeDepositsVm.accList[index].accountNumber;
        chequeDepositsService.selDet.selIndex = index ;
        chequeDepositsService.selDet.accountNumber = chequeDepositsVm.accList[index].accountNumber;
				chequeDepositsVm.showSelect = false;
			}



        chequeDepositsVm.goToHome=function (){
            $state.go('menu.homeScreen');
        }

        chequeDepositsVm.closeView = function(){
          $state.go('menu.homeScreen'); 
        }

        chequeDepositsVm.goToBack = function(){
        chequeDepositsService.clearAll();
        $state.go('menu.innerPage');

        }

        chequeDepositsVm.goToNext = function(){
            chequeDepositsService.ttlCheque = chequeDepositsVm.totalCheques;
            console.log("chequeDepositsService.selectedAccValue " + JSON.stringify(chequeDepositsService.selectedAccValue));
             $state.go('menu.reviewCDK');
        }

        chequeDepositsVm.goToPrevious = function(){
          $ionicHistory.goBack(-1);
        }

        chequeDepositsVm.goPrevious = function(){
          chequeDepositsVm.showDetailPage = false;
           //$ionicHistory.goBack(-1);
        }

        
        //Locate CDK
        chequeDepositsVm.locateCDK = function() {
            utilityService.showSpinner();
            $timeout(function () {
                currentLocationService.getCurrentPosition().then(
                    function (position) {
                        var latitude = position.coords.latitude;
                        var longitude = position.coords.longitude;
                        chequeDepositsService.locateByGPS.length = 0;
                        var params = {
                            "latitude": latitude,
                            "longitude": longitude
                        }
                        // var params = {
                        //     "latitude": 18.529435,
                        //     "longitude": 73.85747
                        // }
                        if (utilityService.isUndefined(chequeDepositsService.locateByGPS) ||
                        chequeDepositsService.locateByGPS.length === 0) {
                            chequeDepositsService.getCDKLoc(params).then(function (data) {
                                utilityService.hideSpinner();
                                if (!utilityService.isUndefined(data)) {
                                    for (var i = 0; i < data.length; i++) {
                                        chequeDepositsService.locateByGPS.push(data[i]);
                                    }
                                    if (chequeDepositsService.locateByGPS.length == 0) {
                                        chequeDepositsVm.confirmPopup = $ionicPopup.confirm({
                                          cssClass: 'dialog',
                                          title: '',
                                          template:"Couldn't locate CDK near you. Do you still wish to continue ?",
                                          scope: $scope,
                                          buttons: [
                                              {     text: 'No', 
                                                    onTap: function (e) { 
                                                    $state.go('menu.homeScreen');
                                                  } 
                                              }, 
                                              {
                                                  text: 'Yes',
                                                  onTap: function (e) {}
                                              }
                                          ],
                                      });
                                    } else {
                                        $state.go('menu.locateCDK');
                                    }
                                }
                            }, function (error) {
                                utilityService.hideSpinner();
                                chequeDepositsVm.confirmPopup = $ionicPopup.alert({
                                template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                                      + error.responseMessage + '</div></div></div></div></div></div>',
                                  cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                                  buttons: [
                                      {
                                          text: 'OK',
                                          type: 'button-positive',
                                          onTap: function (e) {
                                              chequeDepositsVm.confirmPopup.close();
                                          }
                                      }
                                  ]
                                });
                            });
                        } else {
                            utilityService.hideSpinner();
                        }
                    },
                    function (err) {
                        utilityService.hideSpinner();
                        var title = '';
                        var template = '{{"ON_GPS" | translate}}';
                        var onTap = '';
                        var buttontext = '<b>OK</b>';
                        utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                    });
            }, 2000);
        };


        // var chqtemplate = '<ion-popover-view class="loginnewarrow passpropopover" id="runtimeHeight" style="top: 30% !important;">' + '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="chequeDepositsVm.goToPenslip()">' + '<i class="ico-close-pension ver-align-middle"></i>' + '</a>' + '<ion-content class="col-97">' +
        // '<img src="img/AnyBankCheque.png" style="width: 90%;">'+'<div>'+'</ion-content>' + '</ion-popover-view>';
        var chqtemplate = '<ion-popover-view class="loginnewarrow passpropopover" id="runtimeHeight" style="top: 30% !important;">' + '<ion-content class="col-97">' +
        '<img src="img/AnyBankChequeNew.png" style="width: 90%;">'+'<div>'+'</ion-content>' + '</ion-popover-view>';


        $scope.popover = $ionicPopover.fromTemplate(chqtemplate, {
            scope: $scope
        });
       
        chequeDepositsVm.infoDetails = function($event) {   
          console.log("hit");
      //     var havingMPINPrblmPopUp = $ionicPopup.show({
			// 	template: "<img src='img/AnyBankCheque.png' style='width: 90%;height: 50%;'>",
			// 	title: '',
			// 	cssClass: 'dialog',
			// 	scope: $scope,
			// 	buttons: [{
			// 		text: 'OK',
			// 		type: 'button-positive'
			// 	}]
			// });     
                    $scope.popover.show($event);
        }
        
        chequeDepositsVm.goToPenslip = function(){        
             $scope.popover.hide();        
        }


      /*  chequeDepositsVm.getAccountList = function () {
          if (!chequeDepositsService.accList.length) {

            var reqData = {
              "journey": "STOP",
            }
            chequeDepositsService.chequeAccountFilterRequest(reqData).then(function (data) {
              chequeDepositsService.accList = data.accList;
              chequeDepositsVm.accList = chequeDepositsService.accList;


              console.log(JSON.stringify(data));
              //alert(JSON.stringify(data));
            }, function (error) {
              utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
            });

          } else {
            chequeDepositsVm.accList = chequeDepositsService.accList;
            chequeDepositsVm.selectedAccount = chequeDepositsService.selectedAccValue == null ? "" : JSON.stringify(chequeDepositsService.selectedAccValue);
          }
          chequeDepositsVm.nextEnable();

        }*/
        chequeDepositsVm.selectedAccountFun = function () {

          
          chequeDepositsService.selectedAccValue = chequeDepositsVm.selectedAccount == "" ? null : JSON.parse(chequeDepositsVm.selectedAccount);
          
        }

          chequeDepositsVm.selectedFromAccount = function () {
            chequeDepositsService.selectedAccValue = chequeDepositsService.selctValue == "" ? null : JSON.parse(chequeDepositsService.selctValue);          
        }

        
     /*  chequeDepositsVm.nextEnable = function () {
          if(!chequeDepositsVm.cheque.chequeNumber){
            chequeDepositsVm.cheque.chequeNumber = "";
          }
          if(!chequeDepositsVm.cheque.chequeAmount){
            chequeDepositsVm.cheque.chequeAmount = "";
          }
          
          if (chequeDepositsVm.totalCheques.length > 0 || chequeDepositsVm.cheque.chequeNumber === "" || chequeDepositsVm.cheque.chequeAmount === "") {
            chequeDepositsVm.isNextEnabled = false;
          } else {
            chequeDepositsVm.isNextEnabled = true;
          }

        
          if (chequeDepositsVm.selectedAccount != undefined && chequeDepositsVm.selectedAccount != null && chequeDepositsVm.selectedAccount != "" ) {
  					chequeDepositsVm.isNextEnabled = false;
  				} else {
  					chequeDepositsVm.isNextEnabled = true;
  				}
        }  
*/

            chequeDepositsVm.selType = function(bookingCategory){

            chequeDepositsVm.selTab =bookingCategory;
            if(bookingCategory == 'D'){
                chequeDepositsVm.classForMpinLoginOpt = 'tab-items tabs-style div-bottom bor-bot-active';
                chequeDepositsVm.classForUserLoginOpt = 'tab-items tabs-style div-bottom';
            }
            if(bookingCategory == 'V'){
                chequeDepositsVm.showDetailPage = false;
                //chequeDepositsVm.cdkRevList
                chequeDepositsVm.classForMpinLoginOpt = 'tab-items tabs-style div-bottom';
                chequeDepositsVm.classForUserLoginOpt = 'tab-items tabs-style div-bottom bor-bot-active';
            }

        }



        chequeDepositsVm.openDatePickerFrom = function() {
                var date = new Date()
                //var getDay = new Date().getDay();
                //var setDay = date.setFullYear((getDay-180))
                var currentMonth = date.getMonth();
                var currentDate = date.getDate();
                var currentYear = date.getFullYear();
                var setDay= new Date(currentYear, currentMonth-6, currentDate)
				chequeDepositsVm.dateObj = {
					callback: function (val) {
	                    // chequeDepositsVm.scheduleDate = val;
	                    var tomorrow = new Date(val);
		                  tomorrow.setDate(tomorrow.getDate() + 1);
	                    chequeDepositsVm.fromeDate = new Date(tomorrow).toISOString().slice(0,10);
                      //"2019-03-04"
	                    

						// chequeDepositsVm.scheduleDate = val;
						// rdService.createRdData.siDate = chequeDepositsVm.scheduleDate;
						// console.log(rdService.createRdData.siDate)
					},
					inputDate: new Date(),
					from: setDay,
					to: new Date(),
					mondayFirst: true,
					closeOnSelect: false,
					templateType: 'popup',
					dateFormat: 'dd MMM yyyy'

				};

				ionicDatePicker.openDatePicker(chequeDepositsVm.dateObj);
			};

      chequeDepositsVm.openDatePickerTo = function() {
                var date = new Date()
			          var currentMonth = date.getMonth();
                var currentDate = date.getDate();
                var currentYear = date.getFullYear();
                 var setDay= new Date(currentYear, currentMonth-6, currentDate)
				chequeDepositsVm.dateObj = {
					callback: function (val) {
	                    // chequeDepositsVm.scheduleDate = val;
	                    var tomorrow = new Date(val);
		                tomorrow.setDate(tomorrow.getDate() + 1);
	                    chequeDepositsVm.toDate = new Date(tomorrow).toISOString().slice(0,10);
	                    
						// chequeDepositsVm.scheduleDate = val;
						// rdService.createRdData.siDate = chequeDepositsVm.scheduleDate;
						// console.log(rdService.createRdData.siDate)
						// if (chequeDepositsVm.fromeDate && chequeDepositsVm.toDate) {
						// 	var fromDate = chequeDepositsVm.fromeDate;
						// 	var fromDateFormat = fromDate.toString().split('-');
						// 	var fromDateFinal = fromDateFormat[2] + fromDateFormat[1] + fromDateFormat[0];
							
						// 	var toDate = chequeDepositsVm.toDate;
						// 	var toDateFormat = toDate.toString().split('-');
						// 	var toDateFinal = toDateFormat[2] + toDateFormat[1] + toDateFormat[0]
						// 	var obj = {
						// 		"fromDate" : fromDateFinal,
						// 		"toDate" : toDateFinal
						// 	}
						// 	console.log(obj)
						// 	chequeDepositsVm.transactionDetails(obj);
						// }
					},
					inputDate: new Date(),
					from: setDay,
					to: new Date(),
					mondayFirst: true,
					closeOnSelect: false,
					templateType: 'popup',
					dateFormat: 'dd MMM yyyy'

				};

				ionicDatePicker.openDatePicker(chequeDepositsVm.dateObj);
			};


      chequeDepositsVm.viewList  = function () {
        if (chequeDepositsVm.fromeDate && chequeDepositsVm.toDate) {


            var obj={
               "submissionStartDate": chequeDepositsVm.fromeDate,
               "submissionEndDate" : chequeDepositsVm.toDate
            }

            chequeDepositsService.retriveDetails(obj).then(function (data) {
                if (data) {
                  if(data.refAccDetails.length >= 1)
                  {
                    chequeDepositsVm.cdkRevList1 = data.refAccDetails;

                    angular.forEach(chequeDepositsVm.cdkRevList1, function (value, key) {
                        if (value.refNoSubmitDate) {
                          var str1 = value.refNoSubmitDate.split(' ');
                          var str2 = str1[0].split('-');
                          var str3 = str2[2]+"-"+str2[1]+"-"+str2[0];
                          value.refNoSubmitDate =new Date(str3); //new Date(value.refNoSubmitDate)
                        }
                    });
                    chequeDepositsVm.cdkRevList = chequeDepositsVm.cdkRevList1;
                    console.log("data is " + JSON.stringify(data));
                  }else{
                      var listCDKPopUp = $ionicPopup.show({
                    	template: "<p>No records to display</p>",
                    	title: '',
                    	cssClass: 'dialog',
                    	scope: $scope,
                    	buttons: [{
                    		text: 'OK',
                    		type: 'button-positive'
                    	}]
                    });  
                  }
                    
                   
                }

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
                //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
            });
        }

      }

      chequeDepositsVm.gotoDetailList  = function (param) {
       
        chequeDepositsVm.showDetailLbl = param.presentmentStatus == 'P' ? 'Deposited ' : 'Not Deposited';
        chequeDepositsVm.showDetailDate = param.refNoSubmitDate;
        chequeDepositsVm.showDetailRefNo = param.referenceNumber;

        chequeDepositsService.retriveDetailsByRefNo(chequeDepositsVm.showDetailRefNo).then(function (data) {
               
                  if(data)
                  {                                       
                    console.log("data detao=il is " + JSON.stringify(data));
                    chequeDepositsVm.cdkRevDetailList = data.chequeDetails;
                    chequeDepositsVm.showDetailPage = true; 
                  }else{
                      var listCDKPopUp = $ionicPopup.show({
                    	template: "<p>No records to display</p>",
                    	title: '',
                    	cssClass: 'dialog',
                    	scope: $scope,
                    	buttons: [{
                    		text: 'OK',
                    		type: 'button-positive'
                    	}]
                    });  
                  }
                    
                   
                

            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
                //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
            });



      }





        chequeDepositsVm.ChequeFun = function () {

          chequeDepositsVm.enableAddNew();
      /*    var regexp = new RegExp("^[0]*[1-9][0-9]*$");
          if(chequeDepositsVm.cheque.chequeAmount === "")
          {
               chequeDepositsVm.isAddEnable = false;
          }
          if (chequeDepositsVm.cheque.chequeNumber.length < 6 || (!regexp.test(chequeDepositsVm.cheque.chequeNumber))) {
            chequeDepositsVm.isValidChequeError = true;

          } else {
            chequeDepositsVm.isValidChequeError = false;

            //chequeDepositsService.chequeNumber = chequeDepositsVm.cheque.chequeNumber;
          }*/

        }
        chequeDepositsVm.ChequeAmount = function(){
        var chqamtElement = document.getElementById('chqamtTxt');
			
				chqamtElement.focus();
               

          if(chequeDepositsVm.cheque.chequeAmount.length == 14){
            chequeDepositsVm.validationminlength = 21;
          }


          chequeDepositsVm.enableAddNew();
         /* if(chequeDepositsVm.cheque.chequeNumber === "")
          {
               chequeDepositsVm.isAddEnable = false;
          }
           chequeDepositsVm.isValidAmountError = false;*/

     /*     var regexp = new RegExp("^[0]*[1-9][0-9]*$");
          if (chequeDepositsVm.cheque.chequeAmount.length < 17 ) {
            chequeDepositsVm.isValidAmountError = true;

          } else {
            chequeDepositsVm.isValidAmountError = false;

            //chequeDepositsService.chequeNumber = chequeDepositsVm.cheque.chequeNumber;
          }*/
        }

        chequeDepositsVm.deleteCheque = function(chequeIndex){
         
        chequeDepositsVm.totalCheques.splice(chequeIndex,1);
         if(chequeDepositsVm.totalCheques.length < 1){
            chequeDepositsVm.isNextEnabled = true;
          }

        }

       chequeDepositsVm.chqFocus = function () {
        window.scrollTo(0, 0);
        document.body.scrollTop = 0;
        }

        chequeDepositsVm.enableAddNew = function(){
          chequeDepositsVm.isNextEnabled = true;
          var regexp = new RegExp("^[0]*[1-9][0-9]*$");
          var amountregexp = new RegExp("^[1-9,]+(\.[0-9][0-9]?)?");
          if(!chequeDepositsVm.cheque.chequeNumber){
            chequeDepositsVm.cheque.chequeNumber = "";
          }
          if(!chequeDepositsVm.cheque.chequeAmount){
            chequeDepositsVm.cheque.chequeAmount = "";
          }
          
          if(chequeDepositsVm.totalCheques.length > 9){
            chequeDepositsVm.isAddEnable = true;
            chequeDepositsVm.isNextEnabled = false;
          }
          else if(chequeDepositsVm.cheque.chequeNumber === "" || chequeDepositsVm.cheque.chequeAmount === "")
          {
                chequeDepositsVm.isAddEnable = true;
                if(chequeDepositsVm.totalCheques.length > 0 && !chequeDepositsVm.cheque.chequeAmount && !chequeDepositsVm.cheque.chequeNumber){
                  chequeDepositsVm.isNextEnabled = false;
                }
          }
          else if(chequeDepositsVm.cheque.chequeNumber.length < 6 || (!regexp.test(chequeDepositsVm.cheque.chequeNumber))) {
                    
              chequeDepositsVm.isValidChequeError = true;
              chequeDepositsVm.isAddEnable = true;

          }
          else if(!amountregexp.test(chequeDepositsVm.cheque.chequeAmount)) {

               chequeDepositsVm.isValidAmountError = true;
              chequeDepositsVm.isAddEnable = true;
          }
          else{
              chequeDepositsVm.isAddEnable = false;
              chequeDepositsVm.isValidChequeError = false;
             
          }

        
        }
        chequeDepositsVm.addNew = function(){

                if(chequeDepositsVm.totalCheques.length < 11){
                  if ($filter('filter')(chequeDepositsVm.totalCheques,{chequeNumber:chequeDepositsVm.cheque.chequeNumber},true)[0])
                  {
                    var errorText = "Duplicate Cheque Number(s) found.";
                    utilityService.showNfsAlertModal("", errorText, "menu.chequeDeposits", $scope, $state, "OK");
                    return;
                  }
                  if(chequeDepositsVm.cheque.chequeAmount.length == 15 && chequeDepositsVm.cheque.chequeAmount.substr(-1) == '.'){
                      chequeDepositsVm.cheque.chequeAmount = chequeDepositsVm.cheque.chequeAmount.slice(0, -1);
                  }
                  
                    if(chequeDepositsVm.cheque.chequeAmount.toString().split(".")[1]){
                      if(chequeDepositsVm.cheque.chequeAmount.toString().split(".")[1].length == 1){
                        chequeDepositsVm.cheque.chequeAmount = chequeDepositsVm.cheque.chequeAmount + '0'
                      }                      
                    }
                  

                  
                  chequeDepositsVm.totalCheques.push(chequeDepositsVm.cheque);
                  // chequeDepositsVm.cheque.chequeAmount = '';
                  // chequeDepositsVm.cheque.chequeNumber = '';
                }
                chequeDepositsVm.cheque = {};
                 chequeDepositsVm.isAddEnable = true;
                 chequeDepositsVm.isNextEnabled = false;
        }

         $scope.$on('$ionicView.beforeEnter', function () {
           chequeDepositsVm.platform = device.platform.toLowerCase();

             //pensionSlipVm.getPensionAccountDetails();
           chequeDepositsVm.classForMpinLoginOpt = 'tab-items tabs-style div-bottom bor-bot-active';
            chequeDepositsVm.classForUserLoginOpt = 'tab-items tabs-style div-bottom';
            chequeDepositsVm.selType('D');
            chequeDepositsVm.init();


        });
        $scope.$on('$ionicView.loaded', function () {
          chequeDepositsVm.getAccountList();



        });


    return this;
  }
]);
