angularApp.service('chequeDepositsService',
	function ($q, utilityService, AdapterUtils,constantConfig,$ionicPopup) {


		var chequeDepositsService = this;
		chequeDepositsService.accList = [];
		chequeDepositsService.locateByGPS = [];
		chequeDepositsService.ttlCheque =[];
		chequeDepositsService.selectedAccValue = null;
		chequeDepositsService.referenceNumber = null;

		chequeDepositsService.selDet = {
			accountNumber: '',
			selIndex:''
		}

		chequeDepositsService.selectedDetails = {
			accountType: '',
			accountNumber: '',
			accountBalance: '',
			intCategory: '',
			accountTypeCode: '',
			amount: '',
		};
		chequeDepositsService.customer = {
			selectedItem: '',
			indexId: 0
		}


		chequeDepositsService.clearAll  = function () {
			chequeDepositsService.accList = [];
			chequeDepositsService.selectedAccValue = null;
		}
		// chequeDepositsService.chequeAccountFilterRequest = function (obj) {
		// 	var q = $q.defer();
		// 	AdapterUtils.postData("adapters/ServiceRequestAdapter/getAccountDetails", obj, true).then(
		// 		function (response) {
		// 			q.resolve(response.data);
		// 		},
		// 		function (error) {
		// 			q.reject(error);
		// 		}
		// 	);
		// 	return q.promise;
		// };

		chequeDepositsService.chequeAccountFilterRequest = function() {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/getCDKAcctDetails", {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

		   chequeDepositsService.getCDKLoc = function(params) {
            var q = $q.defer(); 
			var obj = {
				"latitude": params.latitude,
				"longitude": params.longitude
			};
           // AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getCDKAtmForGeo + params.longitude + "&latitude=" + params.latitude, false).then(
			   AdapterUtils.postData("adapters/ServiceRequestAdapter/retriveCDKdetails", obj, true).then(
                function(response){ 
					console.log ("SDK succ " + JSON.stringify(response));
                    q.resolve(response.data);
                },
                function(error){    
					console.log ("SDK err " + JSON.stringify(error));
                    q.reject(error);
                }
            );
            return q.promise;
        };


		chequeDepositsService.insertCDKCheque = function(params) {
            var q = $q.defer(); 
			var obj = {
				"chequeDetails": params.chequeDetails,
				"cif": "",
				"accountNumber":chequeDepositsService.selDet.accountNumber,
				"cusType":""
			};
			   AdapterUtils.postData("adapters/ServiceRequestAdapter/insertCheque", obj, true).then(
                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };

		chequeDepositsService.retriveDetails = function(params) {
            var q = $q.defer(); 
			var obj = {
				"submissionStartDate": params.submissionStartDate,				
				"submissionEndDate": params.submissionEndDate,
				"cif": ""
			};
			   AdapterUtils.postData("adapters/ServiceRequestAdapter/retriveDetails", obj, true).then(
                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };

		chequeDepositsService.retriveDetailsByRefNo = function(params) {
            var q = $q.defer(); 
			var obj = {
				"referenceNumber": params
			};
			   AdapterUtils.postData("adapters/ServiceRequestAdapter/retriveDetailsByRefNo", obj, true).then(
                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };

		chequeDepositsService.displayPopUp = function (heading, css, message, buttonText, callBack) {
			var alertPopup = $ionicPopup.alert({
				title: heading,
				template: '<div class="popupTextBottomPadding  ss-popup-list fontSize-subHeading roboto-medium text-center ' + css + '">'
				+ message + '</div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
				buttons: [
					{
						text: buttonText,
						onTap: function (e) {
							callBack();
						}
					}
				],
			});
		};

		chequeDepositsService.getAccountDetails = function() {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/getAccountDetails", {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

	chequeDepositsService.isUserWhiteListed = function() {
			var q = $q.defer();	
				 var obj = {				  
			 };
			 AdapterUtils.postData("adapters/ServiceRequestAdapter/isUserWhiteListed", obj, true).then(
				 function(response){
					 q.resolve(response);
				 },
				 function(error){
					 q.reject(error);
				 }
				 ); 
			 return q.promise;
		 };

		



	return chequeDepositsService;

	});
