'use strict';

angularApp.controller('chequeEnquiryResultController', ["$state",
	"$ionicPopup",
	"$scope",
	"utilityService",
	"chequeEnquiryService",
	function ($state,
		$ionicPopup,
		$scope,
		utilityService,
		chequeEnquiryService) {

		var chequeEnquiryResultVm = this;
		chequeEnquiryResultVm.isNextEnabled = true;
		chequeEnquiryResultVm.fromCheque = chequeEnquiryService.fromCheque;
		chequeEnquiryResultVm.typesOfCheque = chequeEnquiryService.typesOfCheque;
		chequeEnquiryResultVm.toCheque = chequeEnquiryService.toCheque;
		chequeEnquiryResultVm.EnterCheque = chequeEnquiryService.EnterCheque;
		chequeEnquiryResultVm.accountNumber = chequeEnquiryService.selectedAccValue.accountNumber;
		chequeEnquiryResultVm.accountType = chequeEnquiryService.selectedAccValue.accountType;
		chequeEnquiryResultVm.branchName = chequeEnquiryService.selectedAccValue.branchName;
		chequeEnquiryResultVm.chequeDetails = chequeEnquiryService.chequeDetails;

		if (chequeEnquiryService.typesOfCheque == "single") {
			chequeEnquiryResultVm.singleChequeData = true;
		} else {
			chequeEnquiryResultVm.multipleChequeData = true;
		}

		chequeEnquiryResultVm.goToback = function () {
			$state.go('menu.chequeEnquiry');
		}

		chequeEnquiryResultVm.goToHome = function () {
			chequeEnquiryService.clearAll();
			$state.go('menu.homeScreen');
			
		}

	
	

	

	



		$scope.$on('$ionicView.loaded', function () {

		



	});



return this;
	}
]);
