'use strict';

angularApp.controller('DSBSLandingController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter","DSBSService",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter,DSBSService){


            var DSBSLandingVm = this;



            $scope.$on('$ionicView.beforeEnter', function() {
                DSBSLandingVm.isEnqiryMade = false;
                DSBSLandingVm.selectAccOpen = false;
                DSBSLandingVm.accList = [];
                DSBSLandingVm.disableNext = false;

                DSBSLandingVm.NewRequestFlag = true;
                DSBSLandingVm.ViewStatusFlag = false;             
                DSBSLandingVm.classForMpinLoginOpt = 'tab-item tabs-styleOne div-bottom bor-bot-active tab-item-line';
                DSBSLandingVm.classForUserLoginOpt = 'tab-item tabs-styleTwo div-bottom';


                DSBSLandingVm.landingAcc = DSBSService.landingAcc;
                DSBSLandingVm.ReqAcc = DSBSService.landingAcc;
                var request = {};
                DSBSService.getAccountList(request).then(function (data) {
        
                    DSBSService.accList = data.accountList;
                    DSBSLandingVm.accList = DSBSService.accList;
                    DSBSLandingVm.showPop = function(){
                        if(DSBSLandingVm.accList && DSBSLandingVm.accList.length > 0){
                            DSBSLandingVm.popUp = $ionicPopup.show({
                                title: '',
                                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                                templateUrl: 'pages/nfs/doorstepBanking/dropdownmodelregister.html',
                                scope: $scope
                            });
                        }
                    }
                    
                    }, function (err) {
                        
        
                       if(err.data === "" || err.data === null){
        
        
                         $ionicPopup.alert({
                                title: "",
                                template:  '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                                + err.responseMessage + '</span></div></div></div>',
                                scope: $scope,
                                cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                                buttons: [
                                    {
                                        text: "OK",
                                        type: 'button-positive',
                                        onTap: function () {
                                         
                                                $state.go('menu.homeScreen');
                                           
                                        }
                                    }
                                ],
                            });
                      
                            
                        }
                               
                    });         
              
         
			
            
            });
  

    DSBSLandingVm.goToUserLanding = function () {
        $state.go('menu.serviceRequest');
    }
                             
            



     DSBSLandingVm.toggleRequestMenu = function(requestCheck){
        if (requestCheck === 'NewRequest') {
            DSBSLandingVm.NewRequestFlag = true;
            DSBSLandingVm.ViewStatusFlag = false;
            DSBSLandingVm.classForMpinLoginOpt = 'tab-item tabs-styleOne div-bottom bor-bot-active tab-item-line';
            DSBSLandingVm.classForUserLoginOpt = 'tab-item tabs-styleTwo div-bottom';
        
        }
        if (requestCheck === 'ViewStatus') {
            DSBSLandingVm.NewRequestFlag = false;
            DSBSLandingVm.ViewStatusFlag = true;
            DSBSLandingVm.classForMpinLoginOpt = 'tab-item tabs-styleTwo div-bottom';
            DSBSLandingVm.classForUserLoginOpt = 'tab-item tabs-styleOne div-bottom bor-bot-active tab-item-line';
            // DSBSLandingVm.myPopup = $ionicPopup.show({
            //     title: '',
            //     cssClass: 'new-purp-popup my-custom-popup',
            //     templateUrl: 'pages/nfs/doorstepBanking/viewStatusErrorPopUp.html',
            //     scope: $scope
            // })

            var alertPopup = $ionicPopup.alert({
                title: '',
                template: '<img src="img/errorSymbol.svg" alt="Success Screen" class="img-pop-center" style="width: 45px;height: 45px;margin-top:10px;margin-bottom:5px;"/><div class="col center" style="text-align: center;">View status services will be\navailable Soon</div><div class="padBottom8"></div>',
                scope: $scope,
                cssClass: 'new-purp-popup my-custom-popup',
                buttons: [
                   
                    {
                        text: 'OK', 
                        type: 'button-newpurple-OK',
                        onTap: function (e) {
                            $state.go('menu.serviceRequest')
                        }
                    }
                    
                    ]
            });

        }
      
    }



            DSBSLandingVm.OK = function() {
            DSBSLandingVm.myPopup.close();
        }


      DSBSLandingVm.close = function(index){
        DSBSLandingVm.marginError = "";
        DSBSLandingVm.popUp.close();
        DSBSLandingVm.selectAccOpen = true;
       DSBSLandingVm.availableBalance = DSBSLandingVm.accList[index].availableBalance;
        DSBSLandingVm.accountType = DSBSLandingVm.accList[index].accountType;
        DSBSLandingVm.accountNumber = DSBSLandingVm.accList[index].accountNumber;
        DSBSLandingVm.selectedAccount = DSBSLandingVm.accList[index];
        if(DSBSLandingVm.accountNumber){
            DSBSLandingVm.disableNext = false;
            DSBSService.accountType = DSBSLandingVm.accountType;
            DSBSService.accountNumber = DSBSLandingVm.accountNumber;
            DSBSService.availableBalance = DSBSLandingVm.availableBalance;
            DSBSService.selectedAccount = DSBSLandingVm.selectedAccount;
            var request = {};
        request.accountNumber =  DSBSLandingVm.accountNumber;
        DSBSLandingVm.accountNumber = DSBSService.accountNumber;
     
        DSBSService.doDSBEnqiry(request).then(function(data) {
            
            DSBSLandingVm.doorStepFlag = data.doorStepFlag;
            DSBSLandingVm.accountNumberData = data.accountNumber;

            var accNo = Number(DSBSLandingVm.accountNumberData);
            var accNoOR = Number(DSBSLandingVm.accountNumber);
         if(accNo == accNoOR ){
          if(DSBSLandingVm.doorStepFlag === '1')
          {
            DSBSLandingVm.isEnqiryMade = true;
            DSBSLandingVm.isRegistration = true;
              DSBSLandingVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'new-purp-popup my-custom-popup',
                templateUrl: 'pages/nfs/doorstepBanking/DSBAlreadyRegisteredPopUp.html',
                scope: $scope
            })


          }
          if(DSBSLandingVm.doorStepFlag === '0' || DSBSLandingVm.doorStepFlag === ""){
            DSBSLandingVm.isEnqiryMade = true;
            DSBSLandingVm.isRegistration = false;
          }
         }

         }, function(error) {

             utilityService.showErrorMessage(error.responseMessage);

        });
    
      
    }

};
    
    DSBSLandingVm.goToRegister = function(){
        
        var request = {};
        
        DSBSService.getTNCContent(request).then(function(resdata) {

          
            DSBSService.disclamerText = resdata.title;
            DSBSService.disclamerContent = resdata.data;
            DSBSService.agreeText = resdata.iAgree;
            $state.go('menu.DSBRTNCContent');
           
        }, function(error) {

            utilityService.showErrorMessage(error.responseMessage);

        });

    };

   
    }
]);    
    