'use strict';

angularApp.service('emaillDetailsService',
	function ($q, AdapterUtils) {

		var emaillDetailsService = this;
		emaillDetailsService.dataList = {};
		emaillDetailsService.emailId = "";
		emaillDetailsService.emailupdate = false;
		emaillDetailsService.panUpdate = false;
		emaillDetailsService.CorrAdd = false;
		emaillDetailsService.iDelcare = false;
		emaillDetailsService.add1 = "";
		emaillDetailsService.add2 = "";
		emaillDetailsService.add3 = "";
		emaillDetailsService.city = "";
		emaillDetailsService.pinCode = "";
		emaillDetailsService.pan = "";
		emaillDetailsService.showNameError = 0;

		emaillDetailsService.clearAllData = function () {
			
		emaillDetailsService.dataList = {};
		emaillDetailsService.emailId = "";
		emaillDetailsService.emailupdate = false;
		emaillDetailsService.panUpdate = false;
		emaillDetailsService.CorrAdd = false;
		emaillDetailsService.iDelcare = false;
		emaillDetailsService.add1 = "";
		emaillDetailsService.add2 = "";
		emaillDetailsService.add3 = "";
		emaillDetailsService.city = "";
		emaillDetailsService.pinCode = "";
		emaillDetailsService.pan = "";
		emaillDetailsService.showNameError = 0;

		}
	

		emaillDetailsService.fetchDetails = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/fetchDetails", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		emaillDetailsService.update = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/update", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

			emaillDetailsService.updateCorrespondenceAddress = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/updateCorrespondenceAddress", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};


		emaillDetailsService.updatePAN = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/updatePAN", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		return emaillDetailsService;
	});
