'use strict';

angularApp.controller('emailUpdateController', ["$state",
	"$ionicPopup",
	"$scope",
	"emaillDetailsService",
	"personalLoanService",
	"customerInfoService",
	"utilityService",
	function ($state,
		$ionicPopup,
		$scope,
		emaillDetailsService,
		personalLoanService,
		customerInfoService,
		utilityService) {


		

		var emailUpdateVm = this;
		 emailUpdateVm.errorEmail = false;
		 emailUpdateVm.errorMatchEmail = false;
		 emailUpdateVm.isNextEnabled = true;
		 emailUpdateVm.alreadyRegisted = false;

		emailUpdateVm.enterEmailFun = function () {
		emaillDetailsService.emailId = emailUpdateVm.enterEmail;
		 //var emailValidExpr = /^([0-9a-zA-Z]([-_\\.]*[0-9a-zA-Z]+)*)@([0-9a-zA-Z]([-_\\.]*[0-9a-zA-Z]+)*)[\\.]([a-zA-Z]{2,9})$/;
		var emailValidExpr = /^(([^<>()[\]\\.,;:*{}/!?\s@\']+(\.[^<>()[\]\\.,;:*{}/!?\s@\']+)*)|(\'.+\'))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

		if (!emailValidExpr.test(emailUpdateVm.enterEmail)) {
            emailUpdateVm.errorEmail = true;
        }else{
			emailUpdateVm.errorEmail = false;
			if(emaillDetailsService.dataList.emailId == emailUpdateVm.enterEmail){
					emailUpdateVm.alreadyRegisted = true;
					emailUpdateVm.errorMatchEmail = false;
					 emailUpdateVm.isNextEnabled = true;

			}
			else if(emailUpdateVm.enterEmail == emailUpdateVm.reEnterEmail){
				emailUpdateVm.errorMatchEmail = false;
				emailUpdateVm.isNextEnabled = false;
				emailUpdateVm.alreadyRegisted = false;
				
			}else{
				emailUpdateVm.alreadyRegisted = false;
				emailUpdateVm.errorMatchEmail = true;
				emailUpdateVm.isNextEnabled = true;
			}
		}


		}
		emailUpdateVm.init = function () {
			emailUpdateVm.ShowDataEmailUpdate = emaillDetailsService.emailupdate;
			emailUpdateVm.ShowDataCorrAdd = emaillDetailsService.CorrAdd;
			emailUpdateVm.ShowDataPan = emaillDetailsService.panUpdate;
		}

		emailUpdateVm.panDetails = function () {
			emaillDetailsService.pan = emailUpdateVm.pan;
			var validateExp = /^[A-Za-z]{5}[0-9]{4}[A-Za-z]{1}$/;
			if (emailUpdateVm.pan=='' || emailUpdateVm.pan==null || emailUpdateVm.pan==undefined) {
				emailUpdateVm.panError = false;
				emailUpdateVm.alreadyRegisted = false;
				emailUpdateVm.isNextEnabled = true;
			} else if (!validateExp.test(emailUpdateVm.pan)) {
				emailUpdateVm.panError = true;
				emailUpdateVm.alreadyRegisted = false;
				emailUpdateVm.isNextEnabled = true;
			} else {
				    emailUpdateVm.panError = false;
				    if (emaillDetailsService.dataList.panNumber == emailUpdateVm.pan.toUpperCase()) {
				    emailUpdateVm.alreadyRegisted = true;
				    //emailUpdateVm.errorMatchEmail = false;
				    emailUpdateVm.isNextEnabled = true;
                    }
                    else{
				    emailUpdateVm.alreadyRegisted = false;
				    emailUpdateVm.isNextEnabled = false;
                    }
			}
		}

	emailUpdateVm.goToNext = function () {

			if(emaillDetailsService.emailupdate){
				$state.go('menu.emailUpdateOtpNew');
				
			}
			else if (emaillDetailsService.panUpdate){
                $state.go('menu.profilePwd');
			}			
			else {

				//manageAtmVm.validateUsageAndLimitInquiry();
			var reqData = {
				"id": customerInfoService.customer.mobile,
				"emailId": customerInfoService.customer.emailID
			}
			personalLoanService.otpLoan(reqData).then(function (data) {
				//personalLoanService.otp=data.otp;
				
				$state.go('menu.emailUpdateOtp');

			}, function (error) {
				utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
			});


			}

			
		}
	
	
	

		emailUpdateVm.goToHome = function () {
			emaillDetailsService.clearAllData();
			$state.go('menu.homeScreen');

		}

		emailUpdateVm.add1Fun = function () {
			emaillDetailsService.add1 = emailUpdateVm.add1;
			emailUpdateVm.nextEnable();

		}

		emailUpdateVm.add2Fun = function () {
			emaillDetailsService.add2 = emailUpdateVm.add2;


		}

		emailUpdateVm.add3Fun = function () {
			emaillDetailsService.add3 = emailUpdateVm.add3;


		}
		emailUpdateVm.cityFun = function () {
			emaillDetailsService.city = emailUpdateVm.city;
		}

		emailUpdateVm.iDelcareFun = function () {
			emaillDetailsService.iDelcare = emailUpdateVm.iDelcare;
			emailUpdateVm.nextEnable();
		}


		emailUpdateVm.pinCodeFun = function () {
			emailUpdateVm.errorPinCode = true;
			emaillDetailsService.pinCode = emailUpdateVm.pinCode;
			emailUpdateVm.showNameError = emailUpdateVm.pinCode.length;
			emaillDetailsService.showNameError = emailUpdateVm.showNameError;
			emailUpdateVm.nextEnable();

		}

		emailUpdateVm.nextEnable = function () {
			if (emaillDetailsService.CorrAdd) {
				if (emailUpdateVm.add1 && emailUpdateVm.showNameError === 6 && emaillDetailsService.iDelcare){

					emailUpdateVm.isNextEnabled = false;

				} else {
					emailUpdateVm.isNextEnabled = true;
				}
			}
		}

		$scope.$on('$ionicView.beforeEnter', function () {

			emailUpdateVm.init();

		});

		emailUpdateVm.goToback = function () {
			emaillDetailsService.clearAllData();
			$state.go('menu.emailDetails');

		}

		return this;
	}
]);
