'use strict';

angularApp.controller('forgotProfilePwdController', ["$state",
	"$ionicPopup",
	"$scope",
	"$filter",
	"loggedInUserService",
	"fgtProfilePwdService",
	"cryptoService",
	"appPasswordService",
	"utilityService","accountDetailsService","inbForgotPwdService",




	function ($state,
		$ionicPopup,
		$scope,
		$filter,
		loggedInUserService,
		fgtProfilePwdService,
		cryptoService,
		appPasswordService,
		utilityService,accountDetailsService,inbForgotPwdService) {

		var forgotProfilePwdVm = this;
		forgotProfilePwdVm.securityFlag = false;
		forgotProfilePwdVm.atmNumerFlag = true;
		forgotProfilePwdVm.isNextEnabled = true;
		forgotProfilePwdVm.atmPinFlag = true;


		forgotProfilePwdVm.init = function () {

		}
		

		forgotProfilePwdVm.disableSecurityFun = function () {
			forgotProfilePwdVm.securityFlag = true;
			forgotProfilePwdVm.atmNumerFlag = false;
			forgotProfilePwdVm.answer = "";
			forgotProfilePwdVm.selectedAccount = "";
			forgotProfilePwdVm.nextEnable();

		}


		forgotProfilePwdVm.disableAtmNumberFun = function () {
			forgotProfilePwdVm.securityFlag = false;
			forgotProfilePwdVm.atmNumerFlag = true;
			forgotProfilePwdVm.atmCardNumber = "";
			forgotProfilePwdVm.atmPin = "";
			forgotProfilePwdVm.nextEnable();

		}
		forgotProfilePwdVm.selectedAccFun = function () {
			forgotProfilePwdVm = this;

		}
		forgotProfilePwdVm.answerFun = function () {
			forgotProfilePwdVm = this;
		}

		forgotProfilePwdVm.atmCardNumberFun = function () {
			if(!forgotProfilePwdVm.atmCardNumber)
				forgotProfilePwdVm.atmPin = '';
		}

		forgotProfilePwdVm.goToHome = function () {
			 $state.go('menu.homeScreen');
		}
		forgotProfilePwdVm.atmPinFun = function () {
		}
		forgotProfilePwdVm.nextEnable = function () {
		}
		forgotProfilePwdVm.goToNext = function () {

			if(forgotProfilePwdVm.selectedAccount)
			{
			var reqData = {
				"hintSecurityQuestion": forgotProfilePwdVm.selectedAccount,
				"hintSecurityAnswer": forgotProfilePwdVm.answer
			}
			fgtProfilePwdService.validateSecQuestion(reqData).then(function (data) {
				inbForgotPwdService.profile = "SECURITY";
                $state.go('menu.resetProfilePwd');
			}, function (error) {
                

				
                
				utilityService.showErrorMessage(error.responseMessage);
			});
			}

			else
			{
				var finalThreeDES = "";
				var strPIN = "0";
				var PIN = forgotProfilePwdVm.atmPin;
				var pinLength = PIN.toString().length;
				var strHLen = pinLength.toString();
				strPIN = strPIN + strHLen;
				strPIN = strPIN + PIN;
				var yourNumber4 = strPIN.length;
				var lastValue = []
				for (yourNumber4; yourNumber4 < 16; yourNumber4++) {
					lastValue.push('F');
				}
				strPIN = strPIN + (lastValue.toString()).replace(/[^a-zA-Z ]/g, "");
				var strPAN = "0000";
				var pandigit = forgotProfilePwdVm.atmCardNumber;
				var resource = pandigit.slice(-13);
				var resource1 = resource.slice(0, 12);
				strPAN = strPAN + resource1;
				var s = strPAN.toString();
				var hexToBinary = function(s) {
					var i, k, part, ret = '';
					var lookupTable = {
						'0': '0000', '1': '0001', '2': '0010', '3': '0011', '4': '0100',
						'5': '0101', '6': '0110', '7': '0111', '8': '1000', '9': '1001',
						'a': '1010', 'b': '1011', 'c': '1100', 'd': '1101',
						'e': '1110', 'f': '1111',
						'A': '1010', 'B': '1011', 'C': '1100', 'D': '1101',
						'E': '1110', 'F': '1111'
					};
					for (i = 0; i < s.length; i += 1) {
						if (lookupTable.hasOwnProperty(s[i])) {
							ret += lookupTable[s[i]];
						} else {
							return { valid: false };
						}
					}
					return { valid: true, result: ret };
				}

				var output1 = hexToBinary(strPIN);
				var strBPIN = output1.result;
				var output2 = hexToBinary(strPAN);
				var strBPAN = output2.result;
				var result = "0100" ^ "0101";
				var FinalOutput = strBPIN;
				var FinalOutput2 = strBPAN;
				var Slice1 = FinalOutput;
				var SlicePan = FinalOutput2;
				var FinalSlice1 = "";
				var FinalSlice2 = "";
				var strXOR = "";
				var finalXor = [];
				var blockLen = strBPIN / 4;
				var xorStr = "";
				for (var i = 0; i <= 15; i++) {
					FinalSlice1 = strBPIN.slice(i * 4, i * 4 + 4);
					FinalSlice2 = strBPAN.slice(i * 4, i * 4 + 4);
					var xorBahubali = FinalSlice1 ^ FinalSlice2;
					for (var j = 0; j < 4; j++) {
						var pinBit = FinalSlice1.slice(j, j + 1)
						var panBit = FinalSlice2.slice(j, j + 1)
						xorStr = xorStr + (pinBit ^ panBit).toString();
					}
				}

				var s = xorStr;

				var binaryToHex = function(s) {
					var i, k, part, accum, ret = '';
					for (i = s.length - 1; i >= 3; i -= 4) {
						part = s.substr(i + 1 - 4, 4);
						accum = 0;
						for (k = 0; k < 4; k += 1) {
							if (part[k] !== '0' && part[k] !== '1') {
								return { valid: false };
							}
							accum = accum * 2 + parseInt(part[k], 10);
						}
						if (accum >= 10) {
							ret = String.fromCharCode(accum - 10 + 'A'.charCodeAt(0)) + ret;
						} else {
							ret = String(accum) + ret;
						}
					}
					if (i >= 0) {
						accum = 0;
						for (k = 0; k <= i; k += 1) {
							if (s[k] !== '0' && s[k] !== '1') {
								return { valid: false };
							}
							accum = accum * 2 + parseInt(s[k], 10);
						}
						ret = String(accum) + ret;
					}
					return { valid: true, result: ret };
				}

				var pinPanBlockValue = binaryToHex(s).result;
				var currDate = new Date();
				var txtDate = $filter('date')(currDate, 'MMddHHmmss');

				var pinPanBlockEncrypt = pinPanBlockValue.toString();
				var atmNumberEncrypt = forgotProfilePwdVm.atmCardNumber.toString();
				var reqParams = {};
				reqParams["pinPanBlock"] = pinPanBlockEncrypt;
				reqParams["atmNumber"] = atmNumberEncrypt;
				reqParams["txnDate"] = txtDate;
				reqParams["type"] = "PROFILE";


				fgtProfilePwdService.validateUserThruATMCardAndPinSecure(reqParams).then(function (response) {
					console.log(JSON.stringify(response));
                    inbForgotPwdService.profile = "ATM";
					 $state.go('menu.resetProfilePwd');

				}, function (error) {
					
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			
			
		}



		$scope.$on('$ionicView.loaded', function () {
		});

		$scope.$on('$ionicView.beforeEnter', function () {
		
			fgtProfilePwdService.getSecurityQuestions().then(function (data) {
				forgotProfilePwdVm.securityQuestions = data.masterDetails;
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

			forgotProfilePwdVm.init();

		});

			forgotProfilePwdVm.sessionLogout = function () {
			AdapterUtils.sessionLogout().then(
				function (response) {
				console.log("Logout success !!");
				loggedInUserService.logoutUser();
				},
				function (error) {
				console.log("Logout failure !!!");
				loggedInUserService.logoutUser();
				}
			);
		}

		return this;
	}

]);
