'use strict';

angularApp.controller('formSubmisDetailScreenTwoController', ["$state",
	"$ionicPopup",
	"$scope",
	"requestChequeBookService",
	"serviceRequestService",
	"utilityService",
	"form15SubmissionService",

	function ($state,
		$ionicPopup,
		$scope,
		requestChequeBookService,
		serviceRequestService,
		utilityService,
		form15SubmissionService) {

		var formSubmisDetailScreenTwoControllerVm = this;
		formSubmisDetailScreenTwoControllerVm.isTelephoneTextMasked = true;
		formSubmisDetailScreenTwoControllerVm.isTelephoneTextUnMasked = false;
		formSubmisDetailScreenTwoControllerVm.isMobileTextMasked = true;
		formSubmisDetailScreenTwoControllerVm.isMobileTextUnMasked = false;
		
		formSubmisDetailScreenTwoControllerVm.goToNext = function () {
			$state.go('menu.formSubmisDetailScreenThree');
		}

		formSubmisDetailScreenTwoControllerVm.goBack = function () {
			$state.go('menu.formSubmisDetailScreenOne');
		}

		formSubmisDetailScreenTwoControllerVm.maskedTelephoneText = function () {
			formSubmisDetailScreenTwoControllerVm.isTelephoneTextMasked = false;
			formSubmisDetailScreenTwoControllerVm.isTelephoneTextUnMasked = true;
		};

		formSubmisDetailScreenTwoControllerVm.unMaskedTelephoneText = function () {
			formSubmisDetailScreenTwoControllerVm.isTelephoneTextUnMasked = false;
			formSubmisDetailScreenTwoControllerVm.isTelephoneTextMasked = true;
		};

		formSubmisDetailScreenTwoControllerVm.maskedMobileText = function () {
			formSubmisDetailScreenTwoControllerVm.isMobileTextMasked = false;
			formSubmisDetailScreenTwoControllerVm.isMobileTextUnMasked = true;
		};

		formSubmisDetailScreenTwoControllerVm.unMaskedMobileText = function () {
			formSubmisDetailScreenTwoControllerVm.isMobileTextUnMasked = false;
			formSubmisDetailScreenTwoControllerVm.isMobileTextMasked = true;
		};

		formSubmisDetailScreenTwoControllerVm.maskedEmailText = function () {
			formSubmisDetailScreenTwoControllerVm.isEmailTextMasked = false;
			formSubmisDetailScreenTwoControllerVm.isEmailTextUnMasked = true;
		};

		formSubmisDetailScreenTwoControllerVm.unmaskedEmailText = function () {
			formSubmisDetailScreenTwoControllerVm.isEmailTextUnMasked = false;
			formSubmisDetailScreenTwoControllerVm.isEmailTextMasked = true;
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			formSubmisDetailScreenTwoControllerVm.unmaskedEmailText();
			formSubmisDetailScreenTwoControllerVm.unMaskedTelephoneText();
			formSubmisDetailScreenTwoControllerVm.secondPageDetails = form15SubmissionService.formDetails;
			formSubmisDetailScreenTwoControllerVm.typeG = form15SubmissionService.fromTypeG;
			formSubmisDetailScreenTwoControllerVm.typeH = form15SubmissionService.fromTypeH;
			if(formSubmisDetailScreenTwoControllerVm.typeG){
				formSubmisDetailScreenTwoControllerVm.count = 6;
			}
			if(formSubmisDetailScreenTwoControllerVm.typeH){
				formSubmisDetailScreenTwoControllerVm.count = 5;
			}
			formSubmisDetailScreenTwoControllerVm.flatDoor = formSubmisDetailScreenTwoControllerVm.secondPageDetails.addressLine1;
			formSubmisDetailScreenTwoControllerVm.nameOfPremises = formSubmisDetailScreenTwoControllerVm.secondPageDetails.addressLine2;
			formSubmisDetailScreenTwoControllerVm.roadStreet = formSubmisDetailScreenTwoControllerVm.secondPageDetails.addressLine3;
			formSubmisDetailScreenTwoControllerVm.pin = formSubmisDetailScreenTwoControllerVm.secondPageDetails.pinCode;
			formSubmisDetailScreenTwoControllerVm.telephoneNumber = formSubmisDetailScreenTwoControllerVm.secondPageDetails.telephoneNumber;
			formSubmisDetailScreenTwoControllerVm.stateName = formSubmisDetailScreenTwoControllerVm.secondPageDetails.stateName;
			formSubmisDetailScreenTwoControllerVm.distric = formSubmisDetailScreenTwoControllerVm.secondPageDetails.districtName;
			formSubmisDetailScreenTwoControllerVm.mobileNumber = formSubmisDetailScreenTwoControllerVm.secondPageDetails.mobileNumber;
			formSubmisDetailScreenTwoControllerVm.email = formSubmisDetailScreenTwoControllerVm.secondPageDetails.emailId;
			formSubmisDetailScreenTwoControllerVm.areaLocality = formSubmisDetailScreenTwoControllerVm.secondPageDetails.cityName;
		});

		return this;
	}
]);
