'use strict';

angularApp.service('formEnquiryService',
    function ($q, AdapterUtils, accountDetailsService, utilityService, $state, $filter, $ionicPopup) {

        var formEnquiryService = this;
        formEnquiryService.cifNum = "";
        formEnquiryService.pyDetailsList = [];
        formEnquiryService.selectedYear = "";

           formEnquiryService.getPYDetailsEnquiry = function (reqParams) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getPYDetailsEnquiry", reqParams, true).then(
                function (response) {
                    q.resolve(response);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

            formEnquiryService.getForm15GHPdf = function (reqParams) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getForm15GHPdf", reqParams, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

            formEnquiryService.getCifDetails = function () {

            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getCifDetails", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;

        }

             formEnquiryService.displayPopUp = function(heading,message,buttonText,callBack){
            var alertPopup = $ionicPopup.alert({
            title: heading,
            template: '<div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list inb-txt-center inb-lock-error-msg">'
            + message + '</div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
            buttons: [
                {
                    text: buttonText,
                    onTap: function(e) {
                        callBack();
                    }
                }
            ],
        });
    };

       
        return formEnquiryService;
    });
