'use strict';

angularApp.controller('reviewHMBRTController', ["$state",
	"$ionicPopup",
	"$scope",
	"$ionicHistory",
	"hmbrtService",
	"utilityService",
	function ($state,
		$ionicPopup,
		$scope,
		$ionicHistory,
		hmbrtService,
		utilityService) {

		var reviewHmbrtVm = this;

		reviewHmbrtVm.goToNext = function () {
			hmbrtService.getOtp().then(function(data) {
				$state.go('menu.otpHmbrt');
			},function(error){
				utilityService.showErrorMessage(error.responseMessage);
			});

		}

		reviewHmbrtVm.goToback = function () {
			$state.go('menu.hbBranchLocation');
		}

		reviewHmbrtVm.init = function () {
			reviewHmbrtVm.selectAcc = hmbrtService.selectedAcc;
			reviewHmbrtVm.selecltedGps = hmbrtService.selectedBranch;
			reviewHmbrtVm.cif = hmbrtService.userCif;
			reviewHmbrtVm.showOnlyAcc = hmbrtService.transferType == "acc" ? false : true;
		}
			
		$scope.$on('$ionicView.loaded', function () {
			reviewHmbrtVm.init();
		});

		return this;
	}
]);
