'use strict';

angularApp.controller('manageAtmController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"openAccountService",
	"$rootScope",
	"customerInfoService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"manageAtmService",
	"cardsService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		openAccountService,
		$rootScope,
		customerInfoService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		manageAtmService,
		cardsService) {

		//functions, variables that can be accessed from the HTML come here
		var manageAtmVm = this;
		manageAtmVm.oldUsageLimit = {};
		manageAtmVm.validErrorMessage = "Please Enter value in mulitiple of 5000";
		manageAtmVm.validErrorMessage1 = "Limit should not be greater than ATM max limit";
		manageAtmVm.validErrorMessage2 = "Limit should not be greater than POS max limit";
		manageAtmVm.isNextEnabled = true;
		manageAtmVm.validatePANErrorMessage = "";

		manageAtmVm.sendBoolean = function (value) {
			console.log(value);
			if (value == "Y") {
				return true;
			}
			return false;
		}


		manageAtmVm.selectedCardFun = function () {
			
		
			//manageAtmService.usageLimit = {};
			manageAtmService.manageCardNumber = manageAtmVm.ViewCardNumer;

			var reqData = {
				cardNumber: manageAtmService.manageCardNumber
			}
			manageAtmService.usageAndLimitInquiry(reqData).then(function (data) {

				console.log(JSON.stringify(data));
				//alert("usageAndLimitInquiry"+JSON.stringify(data));
				manageAtmVm.oldUsageLimit = angular.copy(data);
				manageAtmService.usageLimit = data;
				manageAtmVm.usageLimit = manageAtmService.usageLimit;
				manageAtmVm.cardTransection = manageAtmVm.sendBoolean(manageAtmService.usageLimit.atmFlag);
				manageAtmVm.posTrasection = manageAtmVm.sendBoolean(manageAtmService.usageLimit.posFlag);
				manageAtmVm.eCommerce = manageAtmVm.sendBoolean(manageAtmService.usageLimit.ecomFlag);
				manageAtmVm.domestic = manageAtmVm.sendBoolean(manageAtmService.usageLimit.domesticFlag);
				manageAtmVm.international = manageAtmVm.sendBoolean(manageAtmService.usageLimit.internationalFlag);
				manageAtmVm.ncmc = manageAtmVm.sendBoolean(manageAtmService.usageLimit.ncmcFlag);
				manageAtmVm.ncmcDisplay = manageAtmService.usageLimit.ncmcFlag;
				manageAtmVm.posLimit = manageAtmService.usageLimit.posLimit;
				manageAtmVm.posMaxLimit = manageAtmService.usageLimit.posMaxLimit;
				manageAtmVm.atmLimit = manageAtmService.usageLimit.atmLimit;
				manageAtmVm.atmMaxLimit = manageAtmService.usageLimit.atmMaxLimit;
				
				

			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
				manageAtmVm.ViewCardNumer = "";
				manageAtmVm.setDefalut();
				manageAtmVm.isNextEnabled = true;
			});
			manageAtmVm.enableNext();

		}

			manageAtmVm.validateUsageAndLimitInquiry = function () { 

			

				 if(manageAtmVm.oldUsageLimit.atmFlag == manageAtmService.usageLimit.atmFlag && manageAtmVm.oldUsageLimit.posFlag == manageAtmService.usageLimit.posFlag && manageAtmVm.oldUsageLimit.ecomFlag == manageAtmService.usageLimit.ecomFlag && manageAtmVm.oldUsageLimit.domesticFlag == manageAtmService.usageLimit.domesticFlag && manageAtmVm.oldUsageLimit.internationalFlag == manageAtmService.usageLimit.internationalFlag && manageAtmVm.oldUsageLimit.ncmcFlag == manageAtmService.usageLimit.ncmcFlag && manageAtmService.amtAtmData == "" && manageAtmService.amtPosData == "" ){


					manageAtmVm.myPopup = $ionicPopup.show({
								title: '',
								cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
								templateUrl: 'pages/nfs/manageAtm/validate.html',
								scope: $scope
							});


				}


			}	

			manageAtmVm.validate = function () {
					manageAtmVm.myPopup.close();
					$state.go('menu.serviceRequest');

			}
			
			manageAtmVm.ok  = function () {
				manageAtmVm.myPopup.close();
			}

			manageAtmVm.setDefalut = function () { 
				manageAtmVm.cardTransection = "N";
				manageAtmVm.posTrasection = "N";
				manageAtmVm.eCommerce = "N";
				manageAtmVm.domestic = "N";
				manageAtmVm.international = "N";
				manageAtmVm.ncmc = "N";
				manageAtmVm.posLimit = "";
				manageAtmVm.posMaxLimit = "";
				manageAtmVm.atmLimit = "";
				manageAtmVm.atmMaxLimit = "";
				manageAtmVm.ViewCardNumer = "";
				manageAtmVm.isNextEnabled = true;


			}

		manageAtmVm.cardTransectionFun = function () {
			console.log(manageAtmVm.cardTransection);
			if (manageAtmVm.cardTransection) {
				manageAtmService.usageLimit.atmFlag = "Y";
			} else {
				manageAtmService.usageLimit.atmFlag = "N";
			}

		}

		manageAtmVm.posTrasectionFun = function () {

			if (manageAtmVm.posTrasection) {
				manageAtmService.usageLimit.posFlag = "Y";
			} else {
				manageAtmService.usageLimit.posFlag = "N";
			}

		}

		manageAtmVm.eCommerceFun = function () {

			if (manageAtmVm.eCommerce) {
				manageAtmService.usageLimit.ecomFlag = "Y";
			} else {
				manageAtmService.usageLimit.ecomFlag = "N";
			}

		}

		manageAtmVm.domesticFun = function () {

			if (manageAtmVm.domestic) {
				manageAtmService.usageLimit.domesticFlag = "Y";
			} else {
				manageAtmService.usageLimit.domesticFlag = "N";
			}

		}

		manageAtmVm.internationalFun = function () {
			if (manageAtmVm.international && manageAtmVm.validatePANErrorMessage.length === 0) {
				manageAtmService.checkInternationalUsageEligibility().then(function(response){
					manageAtmService.usageLimit.internationalFlag = "Y";
					manageAtmVm.validatePANErrorMessage = "";
				},function error(e){
					manageAtmVm.international = false;
					manageAtmService.usageLimit.internationalFlag = "N";
					manageAtmVm.validatePANErrorMessage = e.responseMessage;
				});
			} else {
				manageAtmVm.international = false;
				manageAtmService.usageLimit.internationalFlag = "N";
			}

		}
		manageAtmVm.ncmcFun = function () {
			if (manageAtmVm.ncmc) {
				manageAtmService.usageLimit.ncmcFlag = "Y";
			} else {
				manageAtmService.usageLimit.ncmcFlag = "N";
			}

		}

		manageAtmVm.atmMatLimitFun = function () {
			manageAtmVm.amountData = manageAtmVm.amountData.replace(/^0+/, '');

			if(manageAtmVm.amountData == "" || manageAtmVm.amountData == undefined || manageAtmVm.amountData == null ){
					manageAtmService.amtAtmData = manageAtmVm.amountData;
					manageAtmVm.isValidError = false;
					manageAtmVm.isNextEnabled = false;
					manageAtmVm.isValidError1 = false;
					return;
			}
			

if (manageAtmVm.atmMaxLimit != undefined && (parseInt(manageAtmVm.amountData) <= parseInt(manageAtmVm.atmMaxLimit))){

				manageAtmService.amtAtmData = manageAtmVm.amountData;
				manageAtmVm.isValidError1 = false;
				manageAtmVm.isNextEnabled = false;
				
				if(parseInt(manageAtmVm.amountData)%5000 == 0 && manageAtmVm.amountData > 0 ){
				manageAtmService.amtAtmData = manageAtmVm.amountData;
				manageAtmVm.isValidError = false;
				manageAtmVm.isValidError1 = false;
				manageAtmVm.isNextEnabled = false;
				
				
		}
		else {
					manageAtmVm.isValidError = true;
					manageAtmVm.isNextEnabled = true;
					manageAtmVm.isValidError1 = false;
					
			}
				

			}else{
					manageAtmVm.isValidError1 = true;
					manageAtmVm.isNextEnabled = true;
			}
			
		
			}


		manageAtmVm.posMatLimitFun = function () {

			manageAtmVm.amountData1 = manageAtmVm.amountData1.replace(/^0+/, '');

			if(manageAtmVm.amountData1 == "" || manageAtmVm.amountData1 == undefined || manageAtmVm.amountData1 == null ){
					manageAtmService.amtPosData = manageAtmVm.amountData1;
					manageAtmVm.isValidPOSError = false;
					manageAtmVm.isNextEnabled = false;
					manageAtmVm.isValidError2 = false;
					return;
			}

			
if (manageAtmVm.posMaxLimit != undefined && parseInt(manageAtmVm.amountData1) <= parseInt(manageAtmVm.posMaxLimit)){

				manageAtmService.amtPosData = manageAtmVm.amountData1;
				manageAtmVm.isValidError2 = false;
				manageAtmVm.isNextEnabled = false;
				
			if(parseInt(manageAtmVm.amountData1)%5000 == 0 && manageAtmVm.amountData1 > 0){
				manageAtmService.amtPosData = manageAtmVm.amountData1;
				manageAtmVm.isValidPOSError = false;
				manageAtmVm.isValidError2 = false;
				manageAtmVm.isNextEnabled = false;
				
				
		}
		else {
					manageAtmVm.isValidPOSError = true;
					manageAtmVm.isNextEnabled = true;
					manageAtmVm.isValidError2 = false;
					
			}	

			}else{
					manageAtmVm.isValidError2 = true;
					manageAtmVm.isNextEnabled = true;
			}	
			
			



			
		}


		manageAtmVm.selectedAccFun = function () {
				manageAtmVm.setDefalut();
				manageAtmVm.cardList = [];
			//manageAtmService.usageLimit = {};
			//manageAtmService.selectedAccValue = JSON.parse(manageAtmVm.selctValue);
			manageAtmService.selectedAccValue = manageAtmVm.selctValue == "" ? null : JSON.parse(manageAtmVm.selctValue);

			manageAtmVm.enableNext();
			
			//manageAtmService.selectedAccValue.accountNumber = manageAtmVm.selctValue.accountNumber;

			var reqData = {
				"accountNumber": manageAtmService.selectedAccValue.accountNumber

			}

			manageAtmService.manageCardList(reqData).then(function (data) {
				manageAtmVm.cardList = data.cardList;

				console.log(JSON.stringify(data));
				//alert("manageCardList"+JSON.stringify(data));


			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

			

		}

		
			manageAtmVm.enableNext = function() {
			
			if(manageAtmService.selectedAccValue != "" && manageAtmService.selectedAccValue != null  && manageAtmVm.ViewCardNumer != undefined && manageAtmVm.ViewCardNumer != "" ){
				manageAtmVm.isNextEnabled = false;
			}else{
								manageAtmVm.isNextEnabled = true;

			}

		}

		manageAtmVm.requestOTPFun = function () {
			var reqData = {
				"id": customerInfoService.customer.mobile,
				"emailId": customerInfoService.customer.emailID
			}
			personalLoanService.otpLoan(reqData).then(function (data) {
				//personalLoanService.otp=data.otp;
				$state.go('menu.manageAtmOtp');

			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}


		manageAtmVm.goToback = function () {
			$state.go('menu.innerPage');
		}
		manageAtmVm.goToHome = function () {
			$state.go('menu.homeScreen');
		}

		manageAtmVm.goToNext = function () {
			manageAtmVm.reqData = {};
			manageAtmService.reqData = {};
			if(manageAtmVm.oldUsageLimit.atmFlag == manageAtmService.usageLimit.atmFlag && manageAtmVm.oldUsageLimit.posFlag == manageAtmService.usageLimit.posFlag && manageAtmVm.oldUsageLimit.ecomFlag == manageAtmService.usageLimit.ecomFlag && manageAtmVm.oldUsageLimit.domesticFlag == manageAtmService.usageLimit.domesticFlag && manageAtmVm.oldUsageLimit.internationalFlag == manageAtmService.usageLimit.internationalFlag && manageAtmVm.oldUsageLimit.ncmcFlag == manageAtmService.usageLimit.ncmcFlag && manageAtmService.amtAtmData == "" && manageAtmService.amtPosData == "" ){


					manageAtmVm.myPopup = $ionicPopup.show({
								title: '',
								cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
								templateUrl: 'pages/nfs/manageAtm/validate.html',
								scope: $scope
							});


				}

			else {

				if(manageAtmVm.oldUsageLimit.atmFlag != manageAtmService.usageLimit.atmFlag)
				{
					manageAtmVm.reqData.atmFlag = manageAtmService.usageLimit.atmFlag;
					manageAtmVm.reqData.posFlag = manageAtmService.usageLimit.posFlag;
					manageAtmVm.reqData.ecomFlag = manageAtmService.usageLimit.ecomFlag;
				}
				if(manageAtmVm.oldUsageLimit.posFlag != manageAtmService.usageLimit.posFlag)
				{
					manageAtmVm.reqData.atmFlag = manageAtmService.usageLimit.atmFlag;
					manageAtmVm.reqData.posFlag = manageAtmService.usageLimit.posFlag;
					manageAtmVm.reqData.ecomFlag = manageAtmService.usageLimit.ecomFlag;
				}
				if(manageAtmVm.oldUsageLimit.ecomFlag != manageAtmService.usageLimit.ecomFlag)
				{
					manageAtmVm.reqData.atmFlag = manageAtmService.usageLimit.atmFlag;
					manageAtmVm.reqData.posFlag = manageAtmService.usageLimit.posFlag;
					manageAtmVm.reqData.ecomFlag = manageAtmService.usageLimit.ecomFlag;
				}
				if(manageAtmVm.oldUsageLimit.domesticFlag != manageAtmService.usageLimit.domesticFlag)
				{
					manageAtmVm.reqData.domesticFlag = manageAtmService.usageLimit.domesticFlag;
					manageAtmVm.reqData.internationalFlag = manageAtmService.usageLimit.internationalFlag;
				}
				if(manageAtmVm.oldUsageLimit.internationalFlag != manageAtmService.usageLimit.internationalFlag)
				{
					manageAtmVm.reqData.domesticFlag = manageAtmService.usageLimit.domesticFlag;
					manageAtmVm.reqData.internationalFlag = manageAtmService.usageLimit.internationalFlag;
				}
				if((manageAtmVm.oldUsageLimit.ncmcFlag != manageAtmService.usageLimit.ncmcFlag) && (manageAtmService.usageLimit.ncmcFlag == 'Y' || manageAtmService.usageLimit.ncmcFlag == 'N'))
				{
					manageAtmVm.reqData.ncmcFlag = manageAtmService.usageLimit.ncmcFlag;
				}
				if((manageAtmVm.oldUsageLimit.posLimit != manageAtmService.amtPosData) && manageAtmService.amtPosData != "")
				{
					manageAtmVm.reqData.posLimit = manageAtmService.amtPosData;
					if((manageAtmVm.oldUsageLimit.atmLimit != manageAtmService.amtAtmData) && manageAtmService.amtAtmData != "")
					{
						manageAtmVm.reqData.atmLimit = manageAtmService.amtAtmData;
					}
					else{
						manageAtmVm.reqData.atmLimit = manageAtmVm.oldUsageLimit.atmLimit;
					}
				}
				if((manageAtmVm.oldUsageLimit.atmLimit != manageAtmService.amtAtmData) && manageAtmService.amtAtmData != "")
				{
					manageAtmVm.reqData.atmLimit = manageAtmService.amtAtmData;
					if((manageAtmVm.oldUsageLimit.posLimit != manageAtmService.amtPosData) && manageAtmService.amtPosData != "")
					{
						manageAtmVm.reqData.posLimit = manageAtmService.amtPosData;
					}
					else{
						manageAtmVm.reqData.posLimit = manageAtmVm.oldUsageLimit.posLimit;
					}
				}
				console.log(manageAtmVm.reqData);
				manageAtmService.reqData = manageAtmVm.reqData;
				manageAtmVm.requestOTPFun();
				
			}
			

		}

		$scope.$on('$ionicView.beforeEnter', function () {

			//load menu options
			manageAtmService.accountFilterRequest().then(function (data) {
				manageAtmVm.accList = data.accList;
				manageAtmService.accList = manageAtmVm.accList;
				manageAtmVm.showSelect = true;

				console.log(JSON.stringify(data));
				//alert(JSON.stringify(data));
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

			manageAtmVm.enableNext();
		});

		 manageAtmVm.showPop = function () {
            manageAtmVm.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                templateUrl: 'pages/nfs/manageAtm/accountListModal.html',
                scope: $scope
            });
        }

		manageAtmVm.close = function (index) {
            var title = '';
            var onTap = '';
            if (manageAtmVm.popUp) {
                manageAtmVm.popUp.close();
            }
			manageAtmVm.showSelect = false;

            manageAtmVm.accountNumber = manageAtmVm.accList[index].accountNumber;
            manageAtmVm.accountType = manageAtmVm.accList[index].accountType;
            manageAtmVm.accountBalance = manageAtmVm.accList[index].accountBalance;
			manageAtmVm.branchCode = manageAtmVm.accList[index].branchCode;
            manageAtmVm.branchName = manageAtmVm.accList[index].branchName;
            manageAtmVm.productCode = manageAtmVm.accList[index].productCode;

            manageAtmService.selectedAccValue.selIndex = index;
            manageAtmService.selectedAccValue.accountNumber = manageAtmVm.accList[index].accountNumber;
            manageAtmService.selectedAccValue.accountBalance = manageAtmVm.accList[index].accountBalance;


			manageAtmVm.setDefalut();
			manageAtmVm.cardList = [];
			//manageAtmService.usageLimit = {};
			//manageAtmService.selectedAccValue = JSON.parse(manageAtmVm.selctValue);
			//manageAtmService.selectedAccValue = manageAtmVm.selctValue == "" ? null : JSON.parse(manageAtmVm.selctValue);

			manageAtmVm.enableNext();
			
			var reqData = {
				"accountNumber": manageAtmService.selectedAccValue.accountNumber
			}

			manageAtmService.manageCardList(reqData).then(function (data) {
				manageAtmVm.cardList = data.cardList;
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

        }




		return this;
	}
]);
