'use strict';

angularApp.controller('editManageRightsController', ["$state",
	"$ionicPopup",
	"$scope",
	"serviceRequestService",
	"utilityService",
	"manageTransactionRightsService","constantConfig","ionicToast",

	function ($state,
		$ionicPopup,
		$scope,
		serviceRequestService,
		utilityService,
		manageTransactionRightsService,constantConfig,ionicToast) {
         var selectedTxnType;
		var editManageRightsVm = this;
        var currentTxnType;


        editManageRightsVm.init = function () {
            editManageRightsVm.fullTxn = false;
            editManageRightsVm.limited = false;
            editManageRightsVm.view = false;
            editManageRightsVm.disablesubmit = true;
            editManageRightsVm.MobileOpenEye = false;
            editManageRightsVm.MobileCloseEye = true;

            if(manageTransactionRightsService.selectedAccValue.accountType == 'Savings')
            {
                editManageRightsVm.accountType = 'Savings A/c';
            }
            else if(manageTransactionRightsService.selectedAccValue.accountType == 'Current')
            {
                editManageRightsVm.accountType = 'Current A/c';
            }
            else{
                editManageRightsVm.accountType = 'Overdraft A/c';
            }

            editManageRightsVm.accountNumber = utilityService.maskData(manageTransactionRightsService.selectedAccValue.accountNumber, "front", 4);
            var obj = manageTransactionRightsService.getList();
            currentTxnType = obj.txnRight;
            selectedTxnType = currentTxnType;
            if(currentTxnType == 'O'){
                 $scope.txnRight = {
                        name: 'fullTxn'
                      };
            }
             else if(currentTxnType == 'L'){
                 $scope.txnRight = {
                        name: 'limited'
                      };
            }
             else if(currentTxnType == 'V'){
                 $scope.txnRight = {
                        name: 'view'
                      };
            }
        }

        editManageRightsVm.selectedTxnTypeFun = function(type){
            if(type == 'O'){
                editManageRightsVm.fullTxn = true;
                editManageRightsVm.limited = false;
                editManageRightsVm.view = false;
                selectedTxnType = 'O';

                if(currentTxnType === type)
                {
                    if(editManageRightsVm.isChecked)
                     {
                        editManageRightsVm.disablesubmit = true;
                     }
                     else
                     {
                        editManageRightsVm.disablesubmit = true;
                     }
                }
                else{
                     if(editManageRightsVm.isChecked)
                     {
                        editManageRightsVm.disablesubmit = false;
                     }
                     else{
                        editManageRightsVm.disablesubmit = true;
                     }
                }

            }
            else if(type == 'L'){
                 editManageRightsVm.fullTxn = false;
                 editManageRightsVm.limited = true;
                 editManageRightsVm.view = false;
                 selectedTxnType = 'L';

                    if(currentTxnType === type)
                    {
                        if(editManageRightsVm.isChecked)
                         {
                            editManageRightsVm.disablesubmit = true;
                         }
                         else
                         {
                            editManageRightsVm.disablesubmit = true;
                         }
                    }
                    else{
                         if(editManageRightsVm.isChecked)
                         {
                            editManageRightsVm.disablesubmit = false;
                         }
                         else{
                            editManageRightsVm.disablesubmit = true;
                         }
                    }

             }
             else if(type == 'V'){
                editManageRightsVm.fullTxn = false;
                editManageRightsVm.limited = false;
                editManageRightsVm.view = true;
                selectedTxnType = 'V';

                if(currentTxnType === type)
                {
                    if(editManageRightsVm.isChecked)
                     {
                        editManageRightsVm.disablesubmit = true;
                     }
                     else
                     {
                        editManageRightsVm.disablesubmit = true;
                     }

                }
                else{
                     if(editManageRightsVm.isChecked)
                     {
                        editManageRightsVm.disablesubmit = false;
                     }
                     else{
                        editManageRightsVm.disablesubmit = true;
                     }
                }

        }
        }
        editManageRightsVm.eyesOffFun = function () {
            editManageRightsVm.MobileOpenEye = false;
            editManageRightsVm.MobileCloseEye = true;
            editManageRightsVm.accountNumber = utilityService.maskData(manageTransactionRightsService.selectedAccValue.accountNumber, "front", 4);
        }

        editManageRightsVm.eyesOnFun = function () {
                editManageRightsVm.MobileOpenEye = true;
                editManageRightsVm.MobileCloseEye = false;
                editManageRightsVm.accountNumber = manageTransactionRightsService.selectedAccValue.accountNumber;
        }

	    editManageRightsVm.backFunc = function () {
        		$state.go('menu.manageRights');
        }

        editManageRightsVm.confirmFun = function () {
            if(editManageRightsVm.fullTxn)
            {
                selectedTxnType = 'O';
            }
            else if(editManageRightsVm.limited){
                selectedTxnType = 'L';
            }
            else if(editManageRightsVm.view){
                selectedTxnType = 'V';
            }

             var data = manageTransactionRightsService.getList();
                 if(data.txnRight == selectedTxnType){
                    var dateRangeInfoPopUp = $ionicPopup.show({
                            template: '<p>Already existing right, Please select different right to update.</p>',
                            title: '',
                            cssClass: 'dialog',
                            scope: $scope,
                            buttons: [{
                                text: 'OK',
                                type: 'button-positive'
                            }]
                        });
                 }
                 else{
                      var requestObj = {
                         "accountNumber": manageTransactionRightsService.selectedAccValue.accountNumber,
                          "accessAllowed": selectedTxnType
                     };

                      manageTransactionRightsService.updateTxnRights(requestObj).then(function (data) {
                         editManageRightsVm.successPopUpForManageTxnRights();
                         utilityService.setCsatJournies('updateTxnRights');
                     }, function (err) {
                         utilityService.showErrorMessage(err.responseMessage);
                     });
                 }
        }

        editManageRightsVm.getCBValue = function (isChecked) {
            if (isChecked === true) {
                 if(currentTxnType == selectedTxnType){
                            editManageRightsVm.disablesubmit = true;
                   }
                   else{
                        editManageRightsVm.disablesubmit = false;
                   }
            } else {
                editManageRightsVm.disablesubmit = true;
            }
        }

        //TnC Popup
        editManageRightsVm.tncForManageTxnRights = function () {
                //Call for TnC
            var requestData = {
                "type": "getTnC"
            };

            manageTransactionRightsService.getTnC(requestData).then(function (data) {
                editManageRightsVm.tncData = data;
                    var alertPopup = $ionicPopup.alert({
                    title: 'Terms and Conditions',
                    templateUrl: 'pages/nfs/manageTransactionRights/manageTxnRights_tncPopup.html',
                    scope: $scope,
                    cssClass: 'bi-table',
                    buttons: [
                        {
                            text: 'OK',
                            type: 'button-positive',
                            onTap: function (e) {
                                return true;
                            }
                        }]
                });
            }, function (err) {
                utilityService.showErrorMessage(err.responseMessage);
                editManageRightsVm.nextButtonState = true;
            });
        };

        //Success Popup
        editManageRightsVm.successPopUpForManageTxnRights = function () {
                    var alertPopup = $ionicPopup.show({
                    title: '',
                    templateUrl: 'pages/nfs/manageTransactionRights/manageTxnRights_SuccessPopUp.html',
                    scope: $scope,
                    cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
                    buttons: [
                        {
                            text: 'OK',
                            type: 'button-assertive',
                            onTap: function (e) {
                                $state.go('menu.homeScreen');
                            }
                        }]
                });
        };


       editManageRightsVm.goToHome = function(){
            $state.go('menu.homeScreen');
        }

        $scope.$on('$ionicView.beforeEnter', function () {
        	editManageRightsVm.init();

        });

		return this;
	}
]);
