'use strict';

angularApp.service('manageTransactionRightsService',
	function ($q, AdapterUtils) {
        var accountListObj='';
		var manageTransactionRightsService = this;
		manageTransactionRightsService.selectedAccValue = null;

        //get CASA And OD Accounts
	    manageTransactionRightsService.getAccounts = function(){
            var q = $q.defer();

            AdapterUtils.postData("adapters/SettingsAdapter/getAccountList", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
         };

	    //update txn rights service
        manageTransactionRightsService.updateTxnRights = function(requestObj){
            var q = $q.defer();
            requestObj.accountNumber = accountListObj.accountNumber;
            requestObj.accountType = accountListObj.accountType;
            AdapterUtils.postData("adapters/SettingsAdapter/updateTxnRights", requestObj, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
         };

         //Terms And Conditions
         manageTransactionRightsService.getTnC = function (obj) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getTnC", obj, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;
         };

        manageTransactionRightsService.addList = function(data) {
            accountListObj=data;
        };

        manageTransactionRightsService.getList = function() {
            return accountListObj;
        };

		return manageTransactionRightsService;
	});
