'use strict';

angularApp.controller('validateProfilePwdController', [/*"$state",
	"$ionicPopup",
	"$scope",
	"emaillDetailsService",
	"serviceRequestService",
	"utilityService",
	"loggedInUserService",
	"fTReviewService",
	"inbResetPwdService",*/


	"$state",
    	"$scope",
    	"emaillDetailsService",
    	"serviceRequestService",
    	"fgtProfilePwdService",
    	"inbForgotPwdService",
    	"inbResetPwdService",
    	"cameraService",
    	"fTBeneficiaryService",
    	"utilityService",
    	"constantConfig",
    	"validationService",
    	"$ionicPopup",
    	"fTSetOTPService",
    	"loggedInUserService",
    	"$rootScope",

    	"fTReviewService",
    	"cryptoService",
        "manageTransactionRightsService",
	function (/*$state,
		$ionicPopup,
		$scope,
		emaillDetailsService,
		serviceRequestService,
		utilityService,
		loggedInUserService,
		fTReviewService,
		inbResetPwdService,*/

		$state,
        		$scope,
        		emaillDetailsService,
        		serviceRequestService,
        		fgtProfilePwdService,
        		inbForgotPwdService,
        		inbResetPwdService,
        		cameraService,
        		fTBeneficiaryService,
        		utilityService,
        		constantConfig,
        		validationService,
        		$ionicPopup, fTSetOTPService, loggedInUserService, $rootScope, fTReviewService, cryptoService,
		manageTransactionRightsService) {

		var validateProfilePwdVm = this;
        validateProfilePwdVm.isTextReadable = false;
        validateProfilePwdVm.isTextReadablereEnter = false;

        function initPage() {
            validateProfilePwdVm.disablesubmit = true;
        }

	    validateProfilePwdVm.next = function () {
           
             validateProfilePwdVm.validateProfilePwd();
        }


        validateProfilePwdVm.forgotPass = function () {
            $state.go('menu.forgotProfilePwd');
        };

        
        validateProfilePwdVm.Confirm = function () {
            instaHomeService.customer.otpClick == "instaclosure";
            var obj = {
                 "id": customerInfoService.customer.mobile,
                 "emailId": customerInfoService.customer.emailID
            }
            instaHomeService.requestOtp(obj).then(function (data) {
                $state.go('menu.instaOtp');
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        validateProfilePwdVm.getCBValue = function (isChecked) {
            if (isChecked === true) {
                validateProfilePwdVm.disablesubmit = false;
            } else {
                validateProfilePwdVm.disablesubmit = true;
            }
        }
		


        validateProfilePwdVm.showForgotProfPwdPopup = function () {
            var dateRangeInfoPopUp = $ionicPopup.show({
                template: '<p>Please visit onlinesbi.com or contact your nearest branch or call us at 1800 11 2211</p>',
                title: '',
                cssClass: 'dialog',
                scope: $scope,
                buttons: [{
                    text: 'OK',
                    type: 'button-positive'
                }]
            });
        }

        validateProfilePwdVm.forgotPass = function () {
        	$state.go('menu.forgotProfilePwd');
        };

        validateProfilePwdVm.validateProfilePwd = function () {
            var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
            if (validateProfilePwdVm.newProfilePassword) {
                fTReviewService.getProfilePassAndSerKey().then(function (response) {
                    var options = {
                        inbUserName:loggedInUserDetails.inbUsername,
                        strPass:validateProfilePwdVm.newProfilePassword,
                        keyId:response.keyId,
                        serviceId:response.serviceId,
                        osName:device.platform,
                        type:fgtProfilePwdService.type
                    };
                    var reqParams = utilityService.commonRequestForValidateProfilePass(options);

                        fTReviewService.getProfilePassAuth(reqParams).then(function (data) {
                            //goto next page
                            console.log("inside success response of profile password");
                            $state.go('menu.editManageRights');

                        }, function (error) {
                        console.log("inside failure response of profile password");
                           
                            	if (error.responseCode == "INB.AUTH.016") {
								validateProfilePwdVm.myPopup = $ionicPopup.show({
									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									templateUrl: 'pages/nfs/manageTransactionRights/managePasswordUnblock.html',
									scope: $scope
								})
							} else {
								utilityService.showErrorMessage(error.responseMessage);
							}
                        });

                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                utilityService.showErrorMessage('Please enter your Internet Banking Profile Password.')
            }
        };

        validateProfilePwdVm.goToHome = function(){
            $state.go('menu.homeScreen');
        }

        $scope.$on('$ionicView.loaded', function () {
        				initPage();
        			});

        $scope.$on('$ionicView.beforeEnter', function () {
        });
          validateProfilePwdVm.cancel = function (){
            validateProfilePwdVm.myPopup.close();
			$state.go('menu.homeScreen');
        }
        validateProfilePwdVm.unblockProfilePass = function (){
            validateProfilePwdVm.myPopup.close();
            $state.go('menu.forgotProfilePwd');
        }


   	validateProfilePwdVm.toggleSecretAns = function () {
			validateProfilePwdVm.isTextReadable == true ? validateProfilePwdVm.isTextReadable = false : validateProfilePwdVm.isTextReadable = true;
		};
		validateProfilePwdVm.toggleReEnter = function () {
			validateProfilePwdVm.isTextReadablereEnter == true ? validateProfilePwdVm.isTextReadablereEnter = false : validateProfilePwdVm.isTextReadablereEnter = true;
		};
		return this;
	}
]);
