angularApp.value('nfsConfig');


angularApp.config([
        '$stateProvider',
        function ($stateProvider) {
            $stateProvider

                .state('menu.updateLanding', {
                    url: '/updateLanding',
                    data: {
                        pageId: 'UPD_LAND'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/updateMobileNumber/updateLanding.html',
                            controller: 'updateLandingController',
                            controllerAs: 'updateLandingVm'
                        }
                    }
                })

                .state('menu.updateOTP', {
                    url: '/updateOTP',
                    data: {
                        pageId: 'UPD_OTP'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/updateMobileNumber/updateOTP.html',
                            controller: 'updateOTPController',
                            controllerAs: 'updateOTPVm'
                        }
                    }
                })

                .state('menu.updateCardDetails', {
                    url: '/updateCardDetails',
                    data: {
                        pageId: 'UPD_CARD'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/updateMobileNumber/updateCardDetails.html',
                            controller: 'updateCardDetailsController',
                            controllerAs: 'updateCardDetailsVm'
                        }
                    }
                })

                .state('menu.updateProfile', {
                    url: '/updateProfile',
                    data: {
                        pageId: 'UPD_PRO'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/updateMobileNumber/updateProfile.html',
                            controller: 'updateProfileController',
                            controllerAs: 'updateProfileVm'
                        }
                    }
                })

                .state('menu.updateSuccess', {
                    url: '/updateSuccess',
                    data: {
                        pageId: 'UPD_PRO'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/updateMobileNumber/updateSuccess.html',
                            controller: 'updateSuccessController',
                            controllerAs: 'updateSuccessVm'
                        }
                    }
                })
                .state('menu.hbAccSelect', {
                    url: '/hbAccSelect',
                    data: {
                        pageId: 'HOME_BR_ACC'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/homeBranchTransfer/accSelectHMBRT.html',
                            controller: 'accSelectHMBRTController',
                            controllerAs: 'accSelectHmbrtVm'
                        }
                    }
                })
                .state('menu.hbReview', {
                    url: '/hbReview',
                    data: {
                        pageId: 'HOME_BR_REV'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/homeBranchTransfer/reviewHMBRT.html',
                            controller: 'reviewHMBRTController',
                            controllerAs: 'reviewHmbrtVm'
                        }
                    }
                })
                .state('menu.hbSuccess', {
                    url: '/hbSuccess',
                    data: {
                        pageId: 'HOME_BR_SUC'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/homeBranchTransfer/hmbrTransferSuccess.html',
                            controller: 'hmbrTransferSuccessController',
                            controllerAs: 'hmbrTransferSuccessVm'
                        }
                    }
                })
                .state('menu.hbSearch', {
                    url: '/hbSearch',
                    data: {
                        pageId: 'HOME_BR_SRC'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/homeBranchTransfer/transferHMBRT.html',
                            controller: 'transferHMBRTController',
                            controllerAs: 'transferHmbrtVm'
                        }
                    }
                })

                .state('menu.hbBranchLocation', {
                    url: '/hbBranchLocation',
                    data: {
                        pageId: 'HOME_BR_LOC'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/homeBranchTransfer/locationHMBRT.html',
                            controller: 'locationHMBRTController',
                            controllerAs: 'locationHmbrtVm'
                        }
                    }
                })

                .state('menu.hbBrancResult', {
                    url: '/hbBrancResult',
                    data: {
                        pageId: 'HOME_BR_RES'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/homeBranchTransfer/resultLocationHMBRT.html',
                            controller: 'resultLocationHMBRTController',
                            controllerAs: 'resultLocationHmbrtVm'
                        }
                    }
                })

                .state('menu.otpHmbrt', {
                    url: '/otpHmbrt',
                    data: {
                        pageId: 'HOME_BR_OTP'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/homeBranchTransfer/otpHMBRT.html',
                            controller: 'hbOtpController',
                            controllerAs: 'hbOtpTVm'
                        }
                    }
                })
                .state('menu.hbBranchCode', {
                    url: '/hbBranchCode',
                    data: {
                        pageId: 'HOME_BR_COD'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/homeBranchTransfer/resultLocationHMBRT.html',
                            controller: 'resultLocationHMBRTController',
                            controllerAs: 'resultLocationHMBRTVm'
                        }
                    }
                })
                /*Doorstep Banking starts */
                .state('menu.DSBSLanding', {
                    url: '/DSBSLanding',
                    data: {
                        pageId: 'DSBS_LANDING'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/doorstepBanking/DSBSLanding.html',
                            controller: 'DSBSLandingController',
                            controllerAs: 'DSBSLandingVm'
                        }
                    }
                })
                .state('menu.DSBRegistrationSuccess', {
                    url: '/DSBRegistrationSuccess',
                    data: {
                        pageId: 'DSBS_REG_SUCCESS'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/doorstepBanking/DSBRegistrationSuccess.html',
                            controller: 'DSBRegistrationSuccessController',
                            controllerAs: 'DSBRegistrationSuccessVm'
                        }
                    }
                })
                .state('menu.DSBRTNCContent', {
                    url: '/DSBRTNCContent',
                    data: {
                        pageId: 'DSBS_REVIEW'
                    },
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/nfs/doorstepBanking/TNCContent.html',
                            controller: 'TNCContentController',
                            controllerAs: 'TNCContentVm'
                        }
                    }
                })
                /*Doorstep Banking ends*/
                
                
        }
    ]);
