'use strict';

angularApp.service('nomineeManagementService',
    function ($q, AdapterUtils) {

        var nomineeManagementService = this;

        nomineeManagementService.hitRequest = function (url,data) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/"+url, data, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return nomineeManagementService;
    });
