/* PensionForm16B Service created at  GOC,Hyderabad */
angularApp.service('pensionForm16BService',
	function ($q, utilityService, AdapterUtils) {
		var pensionForm16BService = this;
		pensionForm16BService.selectedAccValue = null;
		pensionForm16BService.getpensionForm16BDetails = function (request) {
			var q = $q.defer();
			//console.log("getpensionForm16BDetails service method called");
			//console.log("Request Object going to adapter is..."+request.accountNumber+"---"+request.financialYear+"---"+request.ppoUniqueID+"---"+request.isEmail);

			AdapterUtils.postData("adapters/ServiceRequestAdapter/pensionForm16BEmailOrDownload", request, true).then(
					function (response) {
							q.resolve(response.data);
					},
					function (error) {
							q.reject(error);
					}
			);

			/* Stub data starts here*/
			/*
			//var error={"responseCode":"002","responseMessage":"Error message here"};
			//q.reject(error);
			var response={"data":{"responseCode":"0000","responseMessage":"Success message here"}};
			q.resolve(response.data);
			*/
			/* Stub data ends here*/
			return q.promise;
		};
		pensionForm16BService.getForm16IncomeCerFlag = function (request) {
				var q = $q.defer();
				//console.log("getForm16IncomeCerFlag service method called");
				//console.log("Request Object going to adapter is..."+request.accountNumber+"---"+request.financialYear+"---"+request.ppoUniqueID);
				AdapterUtils.postData("adapters/ServiceRequestAdapter/getPensionForm16BIdentifier", request, true).then(
						function (response) {
								q.resolve(response.data);
						},
						function (error) {
								q.reject(error);
						}
				);
				return q.promise;
		};

		pensionForm16BService.getPensionAccountDetails = function () {
				//console.log("inside service ");
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getPensionAccountDetails", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		pensionForm16BService.getFinYears = function () {
		  //console.log("Service: pensionForm16BVM.getFinYear");
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getPensionForm16BFinancialYears", {}, true).then(
					function (response) {
							q.resolve(response.data);
					},
					function (error) {
							q.reject(error);
					}
			);
			return q.promise;
		};
});
