'use strict';

angularApp.controller('positivePaymentController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup",
    "chequeDepositsService",
    "AdapterUtils",
    "$q",
    "$ionicPopover",
    "$filter",
    "$ionicHistory",
    "getAccountDetailsService",
    "currentLocationService",
    "ionicDatePicker",
    "homeScreenService",
    "$ionicViewSwitcher",
    "ppsServices",
    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,
        chequeDepositsService,
        AdapterUtils,
        $q,
        $ionicPopover,
        $filter,
        $ionicHistory,
        getAccountDetailsService,
        currentLocationService,
        ionicDatePicker,
        homeScreenService,
        $ionicViewSwitcher,
        ppsServices) {

        var positivePaymentControllerVm = this;
        ppsServices.selectedType = "";
        ppsServices.ppsDetails = {};
        var resiStatus = customerInfoService.customerInfo ? customerInfoService.customerInfo.residentialStatus : "";
        var message = "<div class='pps_lbl_dereg_info2' translate='PPS_RI_NRI_CHECK'></div>";

        positivePaymentControllerVm.viewRequests = function () {
            if(resiStatus === "1" || resiStatus === "2"){ 
                $state.go('menu.ppsFetchRequestDetails');
            }else{
                utilityService.showBhimUpiAlert("error", message, "", "OK", $scope);
            }
        }

        positivePaymentControllerVm.chequeDetails = function () {
            if(resiStatus === "1" || resiStatus === "2"){ 
                $state.go('menu.ppsChequeDetails');
            }else{
                utilityService.showBhimUpiAlert("error", message, "", "OK", $scope);
            }
        }

        positivePaymentControllerVm.goToPrevious = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.innerPage');
        }

        positivePaymentControllerVm.commonFnClick = function(type){
            if(resiStatus === "1" || resiStatus === "2"){ 
                ppsServices.selectedType = type;
                $state.go('menu.ppsCommonView');
            }else{
                utilityService.showBhimUpiAlert("error", message, "", "OK", $scope);
            }
        }

        return this;
    }
]);
