'use strict';

angularApp.controller('ppsCommonReviewController', ["$timeout",
     "$state",
     "$location",
     "$scope",
     "$rootScope",
     "customerInfoService",
     "utilityService",
     "$ionicPopup",
     "chequeDepositsService",
     "AdapterUtils",
     "$q",
     "$ionicPopover",
     "$filter",
     "$ionicHistory",
     "getAccountDetailsService",
     "ionicDatePicker",
     "homeScreenService",
     "ppsServices",
     "$ionicViewSwitcher",
     function ($timeout,
          $state,
          $location,
          $scope,
          $rootScope,
          customerInfoService,
          utilityService,
          $ionicPopup,
          chequeDepositsService,
          AdapterUtils,
          $q,
          $ionicPopover,
          $filter,
          $ionicHistory,
          getAccountDetailsService,
          ionicDatePicker,
          homeScreenService,
          ppsServices,
          $ionicViewSwitcher) {

          var ppsCmmReviewVm = this;
          ppsCmmReviewVm.selectedType = ppsServices.selectedType;
          ppsCmmReviewVm.isAccountMasked = false;

          $scope.$on('$ionicView.beforeEnter', function () {
               ppsCmmReviewVm.selectedPPSDetails = ppsServices.ppsDetails;
               ppsCmmReviewVm.eyesOffFun(ppsServices.ppsDetails.selectedAccNo);
          });

          ppsCmmReviewVm.eyesOnFun = function (accNo) {
                ppsCmmReviewVm.isAccountMasked = false;
                ppsCmmReviewVm.accNumber = ppsCmmReviewVm.oldValue;
            }

            ppsCmmReviewVm.eyesOffFun = function (accNo) {
                ppsCmmReviewVm.isAccountMasked = true;
                ppsCmmReviewVm.oldValue = accNo;
                ppsCmmReviewVm.accNumber = utilityService.maskData(accNo, "front", 4);
            }

          ppsCmmReviewVm.goToNext = function(){
               $state.go("menu.ppsCommonOTPView");
          }

          ppsCmmReviewVm.goToPrevious = function(){
               $ionicViewSwitcher.nextDirection('back');
               $state.go('menu.ppsCommonView');
          }

          return this;
     }
]);
