'use strict';

angularApp.controller('ppfEReceiptController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",    
    "$ionicPopup", "ppfEReceiptService","AdapterUtils","$q","ionicDatePicker",

    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,ppfEReceiptService,AdapterUtils,$q,ionicDatePicker) {

        var ppfEReceiptVm = this;                
        //functions, variables that can be accessed from the HTML template

        ppfEReceiptVm.goToback = function(){
            $state.go('menu.innerPage');
        }

        		ppfEReceiptVm.showDateRangeInfoPopup = function () {
        			var dateRangeInfoPopUp = $ionicPopup.show({
        				template: '<p>Date range allowed is one year i.e. 365 days inclusive of dates chosen. Last three years data only will be available from the current date</p>',
        				title: '',
        				cssClass: 'dialog',
        				scope: $scope,
        				buttons: [{
        					text: 'OK',
        					type: 'button-positive'
        				}]
        			});
        		};

	/***Function to openDatePicker***/
	ppfEReceiptVm.startDatePicker = function(){
						ppfEReceiptVm.ppf_end_date="";
                	    var newDate = new Date();
        				newDate.setDate(newDate.getDate() -1094);
	                    ppfEReceiptVm.dateObj = {
            					callback: function (val) {

            		                    var tomorrow = new Date(val);
            		                    tomorrow.setDate(tomorrow.getDate() + 1);
            		                    ppfEReceiptVm.ppf_start_date = new Date(tomorrow).toISOString().slice(0,10);
            						},
            						inputDate: new Date(),
            						from: newDate,
            						to: new Date(),
            						mondayFirst: true,
            						closeOnSelect: false,
            						templateType: 'popup',
            						dateFormat: 'dd MMM yyyy'
            				};
            				ionicDatePicker.openDatePicker(ppfEReceiptVm.dateObj);
	}


	ppfEReceiptVm.endDatePicker = function(){
	    var newDate = new Date();
	    var startDate = new Date(ppfEReceiptVm.ppf_start_date);
	    var endDate = new Date(ppfEReceiptVm.ppf_start_date);
      endDate.setDate(startDate.getDate() +364);

	    if(endDate.getTime() > new Date().getTime()){
            endDate = new Date();
	    }



	    ppfEReceiptVm.dateObj = {
            					callback: function (val) {
            		                    var tomorrow = new Date(val);
            		                    tomorrow.setDate(tomorrow.getDate() + 1);
            		                    ppfEReceiptVm.ppf_end_date = new Date(tomorrow).toISOString().slice(0,10);
            						},

            						inputDate: endDate,
            						from: startDate,
            						to: endDate,
            						mondayFirst: true,
            						closeOnSelect: false,
            						templateType: 'popup',
            						dateFormat: 'dd MMM yyyy'
            				};
            				ionicDatePicker.openDatePicker(ppfEReceiptVm.dateObj);
	}


           ppfEReceiptVm.submitPPFDetails = function (selectedValue){
               var q = $q.defer();
                var startDate = new Date(ppfEReceiptVm.ppf_start_date);
                var month = startDate.getMonth()+1;
                var requestStartDate = startDate.getDate()+"/"+month+"/"+startDate.getFullYear();
                var endDate = new Date(ppfEReceiptVm.ppf_end_date);
                var month2 = endDate.getMonth()+1;
                var requestEndDate = endDate.getDate()+"/"+month2+"/"+endDate.getFullYear();


               var request = { "accountNumber":selectedValue,"fromDate":requestStartDate,"toDate":requestEndDate}

                       ppfEReceiptService.getPPFAccStmt(request).then(function(data){
                       ppfEReceiptService.addppfstmtList(data);
                       $state.go('menu.ppfViewDetails');
                   },function (error) {
                   utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
               });
           }

            ppfEReceiptVm.goToHome=function (){
                $state.go('menu.homeScreen');
            }

            $scope.$on('$ionicView.beforeEnter', function() {
                console.log(ppfEReceiptVm.listOfResponse)
                ppfEReceiptVm.listOfResponse=ppfEReceiptService.getppfList();
                    if(ppfEReceiptVm.listOfResponse.length==1)
                    {
                        ppfEReceiptVm.selectedValue = ppfEReceiptVm.listOfResponse[0].maskedAccountNumber;
                    }
            });
        return this;
    }

]);