'use strict';

angularApp.controller('requestAddressChequeBookController', ["$state",
	"$ionicPopup",
	"$scope",
	"requestChequeBookService",
	"utilityService",

	function ($state,
		$ionicPopup,
		$scope,
		requestChequeBookService,
		utilityService) {

		var requestAddressChequeBookVm = this;
		requestAddressChequeBookVm.errorPinCode = false;

		requestAddressChequeBookVm.init = function () {

			requestAddressChequeBookVm.selectAdd = requestChequeBookService.selectAdd;

			if (requestChequeBookService.selectAdd == 1 || requestChequeBookService.selectAdd == 2) {
				requestAddressChequeBookVm.registedData = true;
				requestAddressChequeBookVm.newAdd = false;
				requestAddressChequeBookVm.add1 = requestChequeBookService.add1;
				requestAddressChequeBookVm.add2 = requestChequeBookService.add2;
				requestAddressChequeBookVm.add3 = requestChequeBookService.add3;
				requestAddressChequeBookVm.add4 = requestChequeBookService.add4;
				requestAddressChequeBookVm.pinCode = requestChequeBookService.pinCode;
				requestAddressChequeBookVm.city = requestChequeBookService.city;
				requestAddressChequeBookVm.state = requestChequeBookService.state;
				requestAddressChequeBookVm.iDelcare = requestChequeBookService.iDelcare;
				requestAddressChequeBookVm.showNameError = requestChequeBookService.showNameError;
			} else {
				if (requestChequeBookService.selectAdd == 3) {
					requestAddressChequeBookVm.newAdd = true;
					requestAddressChequeBookVm.registedData = false;
					requestAddressChequeBookVm.add1 = "";
					requestAddressChequeBookVm.add2 = "";
					requestAddressChequeBookVm.add3 = "";
					requestAddressChequeBookVm.add4 = "";
					requestAddressChequeBookVm.pinCode = "";
					requestAddressChequeBookVm.city = "";
					requestAddressChequeBookVm.state = "";
					requestAddressChequeBookVm.iDelcare = requestChequeBookService.iDelcare;
					requestAddressChequeBookVm.showNameError = requestChequeBookService.showNameError;
				}


			}


			//requestAddressChequeBookVm.selectedchqPages();

			requestAddressChequeBookVm.nextEnable();
		}

		requestAddressChequeBookVm.goToNext = function () {
			$state.go('menu.requestReviewChequeBook');
		}

		requestAddressChequeBookVm.goToHome = function () {
			requestChequeBookService.clearAll();
			$state.go('menu.homeScreen');
		}

		requestAddressChequeBookVm.goToback = function () {
			$state.go('menu.requestChequeBook');
		}

		requestAddressChequeBookVm.add1Fun = function () {
			requestChequeBookService.add1 = requestAddressChequeBookVm.add1;
			requestAddressChequeBookVm.nextEnable();

		}
		requestAddressChequeBookVm.add2Fun = function () {
			requestChequeBookService.add2 = requestAddressChequeBookVm.add2;
			requestAddressChequeBookVm.nextEnable();

		}
		requestAddressChequeBookVm.add3Fun = function () {
			requestChequeBookService.add3 = requestAddressChequeBookVm.add3;
			requestAddressChequeBookVm.nextEnable();

		}
		requestAddressChequeBookVm.add4Fun = function () {
			requestChequeBookService.add4 = requestAddressChequeBookVm.add4;
			requestAddressChequeBookVm.nextEnable();

		}
		requestAddressChequeBookVm.pinCodeFun = function () {
			requestAddressChequeBookVm.errorPinCode = true;
			requestChequeBookService.pinCode = requestAddressChequeBookVm.pinCode;
			requestAddressChequeBookVm.showNameError = requestAddressChequeBookVm.pinCode.length;
			requestChequeBookService.showNameError = requestAddressChequeBookVm.showNameError;

			if (requestAddressChequeBookVm.showNameError === 6) {
				// pin code service call
				var reqData = {
					"pinCode": requestAddressChequeBookVm.pinCode
				}

				requestChequeBookService.requestPincode(reqData).then(function (data) {

					requestAddressChequeBookVm.city = data[0].districtName;
					requestChequeBookService.city = requestAddressChequeBookVm.city;
					requestAddressChequeBookVm.state = data[0].stateName;
					requestChequeBookService.state = requestAddressChequeBookVm.state;
					requestAddressChequeBookVm.nextEnable();

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
					requestAddressChequeBookVm.isNextEnabled = true;
				});

			}

			requestAddressChequeBookVm.nextEnable();

		}

		requestAddressChequeBookVm.cityFun = function () {
			requestChequeBookService.city = requestAddressChequeBookVm.city;
			requestAddressChequeBookVm.nextEnable();

		}

		requestAddressChequeBookVm.stateFun = function () {
			requestChequeBookService.state = requestAddressChequeBookVm.state;
			requestAddressChequeBookVm.nextEnable();

		}

		requestAddressChequeBookVm.iDelcareFun = function () {
			requestChequeBookService.iDelcare = requestAddressChequeBookVm.iDelcare;
			requestAddressChequeBookVm.nextEnable();
		}
		requestAddressChequeBookVm.customerProfileFun = function () {
			requestChequeBookService.city = "";
			requestChequeBookService.state = "";
			requestAddressChequeBookVm.iDelcare = false;
			var requestData = {
				"branchCode": requestChequeBookService.selectedAccValue.branchCode,
				"accountNumber": requestChequeBookService.selectedAccValue.accountNumber,
				"addressType": requestChequeBookService.selectAdd
			}



			requestChequeBookService.customerProfile(requestData).then(function (data) {

				
				requestChequeBookService.add1 = data.addressLine1;
				requestChequeBookService.add2 = data.addressLine2;
				requestChequeBookService.add3 = data.addressLine3;
				requestChequeBookService.add4 = data.addressLine4;
				requestChequeBookService.pinCode = data.pinCode;
				requestChequeBookService.city = data.city;
				requestChequeBookService.state = data.state;

				// for show purpose

				requestAddressChequeBookVm.add1 = requestChequeBookService.add1;
				requestAddressChequeBookVm.add2 = requestChequeBookService.add2;
				requestAddressChequeBookVm.add3 = requestChequeBookService.add3;
				requestAddressChequeBookVm.add4 = requestChequeBookService.add4;
				requestAddressChequeBookVm.pinCode = requestChequeBookService.pinCode;
				requestAddressChequeBookVm.city = requestChequeBookService.city;
				requestAddressChequeBookVm.state = requestChequeBookService.state;
				requestAddressChequeBookVm.showNameError = requestChequeBookService.showNameError;


			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
				requestAddressChequeBookVm.isNextEnabled = true;
			});


		}


		requestAddressChequeBookVm.selectedchqPages = function () {
			requestAddressChequeBookVm.add1 = "";
			requestAddressChequeBookVm.add2 = "";
			requestAddressChequeBookVm.add3 = "";
			requestAddressChequeBookVm.add4 = "";
			requestAddressChequeBookVm.pinCode = "";
			requestAddressChequeBookVm.city = "";
			requestAddressChequeBookVm.state = "";
			requestAddressChequeBookVm.registedData = false;
			requestChequeBookService.selectAdd = requestAddressChequeBookVm.selectAdd;

			if (requestAddressChequeBookVm.selectAdd == 1) {

				requestAddressChequeBookVm.customerProfileFun();

				requestAddressChequeBookVm.registedData = true;
				requestAddressChequeBookVm.newAdd = false;

			} else if (requestAddressChequeBookVm.selectAdd == 2) {

				requestAddressChequeBookVm.customerProfileFun();

				requestAddressChequeBookVm.registedData = true;
				requestAddressChequeBookVm.newAdd = false;

			} else if (requestAddressChequeBookVm.selectAdd == 3) {

				requestAddressChequeBookVm.newAdd = true;
				requestAddressChequeBookVm.registedData = false;
				if (!requestAddressChequeBookVm.iDelcare) {
					requestAddressChequeBookVm.add1 = "";
					requestAddressChequeBookVm.add2 = "";
					requestAddressChequeBookVm.add3 = "";
					requestAddressChequeBookVm.add4 = "";
					requestAddressChequeBookVm.pinCode = "";
					requestAddressChequeBookVm.city = "";
					requestAddressChequeBookVm.state = "";
					requestAddressChequeBookVm.iDelcare = false;
					requestAddressChequeBookVm.showNameError = requestChequeBookService.showNameError;
				}
			} else {

				requestAddressChequeBookVm.registedData = false;
				requestAddressChequeBookVm.newAdd = false;
			}


			requestAddressChequeBookVm.nextEnable();

		}

		requestAddressChequeBookVm.nextEnable = function () {
			if (requestAddressChequeBookVm.selectAdd != "" && requestAddressChequeBookVm.selectAdd != undefined && requestAddressChequeBookVm.selectAdd != null) {


				if (requestAddressChequeBookVm.selectAdd == 3) {

					if (requestAddressChequeBookVm.add1 != "" && requestAddressChequeBookVm.add1 != null && requestAddressChequeBookVm.add1 != undefined && requestAddressChequeBookVm.add2 != "" && requestAddressChequeBookVm.add2 != undefined && requestAddressChequeBookVm.add2 != null && requestAddressChequeBookVm.add3 != "" && requestAddressChequeBookVm.add3 != undefined && requestAddressChequeBookVm.add3 != null && requestAddressChequeBookVm.pinCode != "" && requestAddressChequeBookVm.pinCode != undefined && requestAddressChequeBookVm.pinCode != null && requestAddressChequeBookVm.showNameError === 6 && requestAddressChequeBookVm.city != "" && requestAddressChequeBookVm.city != undefined && requestAddressChequeBookVm.city != null && requestAddressChequeBookVm.state != "" && requestAddressChequeBookVm.state != null && requestAddressChequeBookVm.state != undefined && requestAddressChequeBookVm.iDelcare != "" && requestAddressChequeBookVm.iDelcare != null && requestAddressChequeBookVm.iDelcare != undefined && requestAddressChequeBookVm.iDelcare != false) {
						requestAddressChequeBookVm.isNextEnabled = false;
					}
					else {
						requestAddressChequeBookVm.isNextEnabled = true;
					}

				} else {
					requestAddressChequeBookVm.isNextEnabled = false;

				}





			} else {
				requestAddressChequeBookVm.isNextEnabled = true;
			}
		}

		$scope.$on('$ionicView.beforeEnter', function () {

			requestAddressChequeBookVm.init();

		});


		return this;
	}



]);
