'use strict';

angularApp.service('requestChequeBookService',
	function ($q, AdapterUtils) {

		var requestChequeBookService = this;
		requestChequeBookService.tncCheck = false;
		requestChequeBookService.conDetails = false;
		requestChequeBookService.tncStateCheck = false;
		requestChequeBookService.chqPages = "";
		requestChequeBookService.iDelcare = false;
		requestChequeBookService.selectAdd = "";
		requestChequeBookService.add1 = "";
		requestChequeBookService.add2 = "";
		requestChequeBookService.add3 = "";
		requestChequeBookService.add4 = "";
		requestChequeBookService.pinCode = "";
		requestChequeBookService.city = "";
		requestChequeBookService.state = "";
		requestChequeBookService.showNameError = "";
		requestChequeBookService.accList = [];
		requestChequeBookService.cardList = [];
		requestChequeBookService.selectedAccValue = null;
		requestChequeBookService.selectedCardValue = null;
		requestChequeBookService.selectedCardType = "";
		requestChequeBookService.selectedCardType = "";

		requestChequeBookService.clearAll = function () {

			requestChequeBookService.tncCheck = false;
			requestChequeBookService.conDetails = false;
			requestChequeBookService.tncStateCheck = false;
			requestChequeBookService.chqPages = "";
			requestChequeBookService.iDelcare = false;
			requestChequeBookService.selectAdd = "";
			requestChequeBookService.add1 = "";
			requestChequeBookService.add2 = "";
			requestChequeBookService.add3 = "";
			requestChequeBookService.add4 = "";
			requestChequeBookService.pinCode = "";
			requestChequeBookService.city = "";
			requestChequeBookService.state = "";
			requestChequeBookService.showNameError = "";
			requestChequeBookService.accList = [];
			requestChequeBookService.cardList = [];
			requestChequeBookService.selectedAccValue = null;
			requestChequeBookService.selectedCardValue = null;
			requestChequeBookService.selectedCardType = "";
			requestChequeBookService.selectedCardType = "";

		}

		requestChequeBookService.accountFilterRequest = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/accountFilterRequest", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		requestChequeBookService.getTnC = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getTnC", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		requestChequeBookService.customerProfile = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/customerProfile", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		requestChequeBookService.getRequest = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getRequest", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		// requestChequeBookService.requestPincode = function (obj) {
		// 	var q = $q.defer();
		// 	AdapterUtils.postData("adapters/AccountOpeningAdapter/getAreaDetailForPinCodeData/"+ obj.pinCode, obj, true).then(
		// 		function (response) {
		// 			q.resolve(response.data);
		// 		},
		// 		function (error) {
		// 			q.reject(error);
		// 		}
		// 	);
		// 	return q.promise;
		// };

		requestChequeBookService.requestPincode = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/fetchByPincode", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		
		

		



		return requestChequeBookService;
	});
