'use strict';

angularApp.controller('requestReviewChequeBookController', ["$state",
	"$ionicPopup",
	"$scope",
	"requestChequeBookService",
	"utilityService",

	function ($state,
		$ionicPopup,
		$scope,
		requestChequeBookService,
		utilityService) {

		var requestReviewChequeBookVm = this;
		requestReviewChequeBookVm.selectAdd = requestChequeBookService.selectAdd;
		requestReviewChequeBookVm.accountNumber = requestChequeBookService.selectedAccValue.accountNumber;
		requestReviewChequeBookVm.accountType = requestChequeBookService.selectedAccValue.accountType;
		requestReviewChequeBookVm.branchName = requestChequeBookService.selectedAccValue.branchName;
		requestReviewChequeBookVm.chqPages = requestChequeBookService.chqPages;
		requestReviewChequeBookVm.branchName = requestChequeBookService.selectedAccValue.branchName;
		requestReviewChequeBookVm.add1 = requestChequeBookService.add1;
		requestReviewChequeBookVm.add2 = requestChequeBookService.add2;
		requestReviewChequeBookVm.add3 = requestChequeBookService.add3;
		requestReviewChequeBookVm.add4 = requestChequeBookService.add4;
		requestReviewChequeBookVm.pinCode = requestChequeBookService.pinCode;
		requestReviewChequeBookVm.city = requestChequeBookService.city;
		requestReviewChequeBookVm.state = requestChequeBookService.state;

		requestReviewChequeBookVm.goToNext = function () {
			if (requestReviewChequeBookVm.selectAdd == 1 || requestReviewChequeBookVm.selectAdd == 2) {

				var requestData = {

					"branchCode": requestChequeBookService.selectedAccValue.branchCode,
					"accountNumber": requestChequeBookService.selectedAccValue.accountNumber,
					"addressType": requestChequeBookService.selectAdd,
					"addressLine1": requestChequeBookService.add1,
					"addressLine2": requestChequeBookService.add2,
					"addressLine3": requestChequeBookService.add3,
					"addressLine4": requestChequeBookService.add4,
					"pinCode": requestChequeBookService.pinCode,
					"city": requestChequeBookService.city,
					"state": requestChequeBookService.state,
					"accountType": requestChequeBookService.selectedAccValue.accountType,
					"numberOfLeaves": requestChequeBookService.chqPages,
					"termsNcondition": true

				}

			}else{

				var requestData = {

					"branchCode": requestChequeBookService.selectedAccValue.branchCode,
					"accountNumber": requestChequeBookService.selectedAccValue.accountNumber,
					"addressType": requestChequeBookService.selectAdd,
					"addressLine1": requestChequeBookService.add1,
					"addressLine2": requestChequeBookService.add2,
					"addressLine3": requestChequeBookService.add3,
					"pinCode": requestChequeBookService.pinCode,
					"city": requestChequeBookService.city,
					"state": requestChequeBookService.state,
					"accountType": requestChequeBookService.selectedAccValue.accountType,
					"numberOfLeaves": requestChequeBookService.chqPages,
					"termsNcondition": true

				}

			}


			requestChequeBookService.getRequest(requestData).then(function (data) {

				
				requestReviewChequeBookVm.referenceNumber = data.referenceNumber;
				requestReviewChequeBookVm.myPopup = $ionicPopup.show({
					title: '',
					cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
					templateUrl: 'pages/nfs/requestChequeBook/requestChequeBook_PopUp.html',
					scope: $scope
				});

			}, function (error) {
				requestChequeBookService.clearAll();
				 utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
			});



		}

		requestReviewChequeBookVm.goToHome = function () {
			requestChequeBookService.clearAll();
			$state.go('menu.homeScreen');
		}

		requestReviewChequeBookVm.goToback = function () {
			$state.go('menu.requestAddressChequeBook');
		}




		requestReviewChequeBookVm.ok = function () {
			requestChequeBookService.clearAll();
			requestReviewChequeBookVm.myPopup.close();
			utilityService.setCsatJournies('newCheque');

			$state.go('menu.homeScreen');
		};



		return this;
	}
]);
