angularApp.service('siNfsService',
	function($q,AdapterUtils,utilityService,constantConfig,$ionicPopup){
    
    var siNfsService = this;

    var fromAccountDetails,toAccountDetails;

    siNfsService.setFromAccountDetails = function(ref) {
        fromAccountDetails = ref;
    };

    siNfsService.getFromAccountDetails = function() {
        return fromAccountDetails;
    };

    siNfsService.setToAccountDetails = function(ref) {
        toAccountDetails = ref;
    };

    siNfsService.getToAccountDetails = function() {
        return toAccountDetails;
    };

    siNfsService.setNew = {};
    
	siNfsService.getSIAccounts = function() {
		var q = $q.defer();
		AdapterUtils.postData("adapters/ServiceRequestAdapter/getSIfromAccount",{},true).then(
			function(response){	
				q.resolve(response.data);
			},
			function(error){	
				q.reject(error);
			}); 


		return q.promise;
	};

    siNfsService.getSItoAccounts = function(obj) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/getSItoAccount",obj,true).then(
            function(response){ 
                q.resolve(response.data);
            },
            function(error){    
                q.reject(error);
            }); 

        
        return q.promise;
    };

    siNfsService.createSIRequest = function(obj) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/createSIRequest",obj,true).then(
            function(response){ 
                q.resolve(response.data);
            },
            function(error){    
                q.reject(error);
            }); 

        
        return q.promise;
    };

    siNfsService.getSIEnquiry = function(obj) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/getSIEnquiry",obj,true).then(
            function(response){ 
                q.resolve(response.data);
            },
            function(error){    
                q.reject(error);
            }); 

        
        return q.promise;
    };

    siNfsService.deleteSI = function(obj) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/deleteSIRequest",obj,true).then(
            function(response){ 
                q.resolve(response.data);
            },
            function(error){    
                q.reject(error);
            }); 

        
        return q.promise;
    };

    siNfsService.viewSISchedule = function(obj) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/getSIViewSchedule",obj,true).then(
            function(response){ 
                q.resolve(response.data);
            },
            function(error){    
                q.reject(error);
            }); 

        
        return q.promise;
    };

    siNfsService.siErrorPopUp = function(heading,message,buttonText,$state,menuState){
        var alertPopup = $ionicPopup.alert({
            title: heading,
            template: '<div class="nfsSIpopupBodyPadding font-dark-grey textAlignCenter"><div><img class="nfsSIapprovedIconPosition" src="img/errorImage.png"></div></div><div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list font-size-14 roboto-regular ss-text-color textAlignCenter">'
            + message + '</div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
            buttons: [
                {
                    text: buttonText,
                    onTap: function(e) {
                        //callBack();
                        if (menuState !== '' && menuState !== null) {
                            $state.go(menuState);
                        } 
                    }
                }
            ],
        });
    };
	
	return siNfsService;

});
