'use strict';

angularApp.service('smsAlertActivationService',
	function ($q, AdapterUtils) {

		var smsAlertActivationService = this;

		
		smsAlertActivationService.accList = [];
		smsAlertActivationService.cardList = [];
		smsAlertActivationService.selectedAccount = null;
		smsAlertActivationService.selectedCardValue = null;
		smsAlertActivationService.enquiryData = {};
		smsAlertActivationService.oldenquiryData = null;
		smsAlertActivationService.debitCardusageAlert = "";
		smsAlertActivationService.disableAllSms = "";
	

		smsAlertActivationService.clearAll  = function () {

		smsAlertActivationService.accList = [];
		smsAlertActivationService.cardList = [];
		smsAlertActivationService.selectedAccount = null;
		smsAlertActivationService.selectedCardValue = null;
		smsAlertActivationService.enquiryData = {};
		smsAlertActivationService.debitCardusageAlert = "";
		smsAlertActivationService.disableAllSms = "";
		smsAlertActivationService.oldenquiryData = null;

		}
		
		
		smsAlertActivationService.getAccountsForSMSAlerts = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getAccountsForSMSAlerts", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		
		smsAlertActivationService.getSMSEnquiry = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getSMSEnquiry", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		
		smsAlertActivationService.updateSMSAlerts = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/updateSMSAlerts", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		
		smsAlertActivationService.getChargesPopup = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/smsAlertChargesDetails", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
	

		return smsAlertActivationService;
	});
