'use strict';

angularApp.service('stopChequeService',
	function ($q, AdapterUtils) {

		var stopChequeService = this;

		stopChequeService.typesOfCheque = "single";
		stopChequeService.fromCheque = "";
		stopChequeService.toCheque = "";
		stopChequeService.EnterCheque = "";
		stopChequeService.accList = [];
		stopChequeService.cardList = [];
		stopChequeService.selectedAccValue = null;
		stopChequeService.selectedCardValue = null;
		
		stopChequeService.blockAllCards = false;
		stopChequeService.selectedCardType = "";
		stopChequeService.stopReason = "";
		stopChequeService.multiSelectedCardType = "";

		
		stopChequeService.clearAll  = function () {

		stopChequeService.typesOfCheque = "single";
		stopChequeService.fromCheque = "";
		stopChequeService.toCheque = "";
		stopChequeService.EnterCheque = "";
		stopChequeService.accList = [];
		stopChequeService.cardList = [];
		stopChequeService.selectedAccValue = null;
		stopChequeService.selectedCardValue = null;
		stopChequeService.blockAllCards = false;
		stopChequeService.selectedCardType = "";
		stopChequeService.stopReason = "";
		stopChequeService.multiSelectedCardType = "";

		}
		stopChequeService.chequeAccountFilterRequest = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/chequeAccountFilterRequest", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		stopChequeService.getTnC = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getTnC", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		stopChequeService.stopChequeRequest = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/stopChequeRequest", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		

		return stopChequeService;
	});
