'use strict';

angularApp.controller('trpnSuccessNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices) {

        var trpnSuccessNPSControllerVM = this;
        $scope.currentPage = "2";
        $scope.lastPage = "16";

        trpnSuccessNPSControllerVM.close = function(){
           $ionicViewSwitcher.nextDirection('back');
           $state.go('menu.homeScreen');
        }

        trpnSuccessNPSControllerVM.goBack = function(){
            $state.go('menu.accountDetailsNPSView');
        }

        trpnSuccessNPSControllerVM.goNext = function(){

            if (!npsServices.applicantData.panNumber) {
                npsServices.getCIFDetails().then(function (data) {
                    npsServices.applicantData = data;
                    $state.go('menu.npsPersonalDetails');

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                $state.go('menu.npsPersonalDetails');
            }

            
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            trpnSuccessNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            trpnSuccessNPSControllerVM.npsAccountType = npsServices.npsAccountDetails.npsAccountType;
            trpnSuccessNPSControllerVM.npsTprnSuccessData = angular.copy(npsServices.npsTprnSuccessData);
        });

        
        return this;
    }
]);
