angularApp.service('pendingRequestService',
	function ($q, utilityService, AdapterUtils) {

		var PRService = this;

		PRService.getRequestDetailData = {}

		PRService.getServiceRequest = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/instaGetAccountDetails", {}, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		PRService.instaFetchSecondaryDetails = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/instaFetchSecondaryDetails",obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		PRService.instaUpdateConsent = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/instaUpdateConsent",{}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		PRService.getRequestDetail = function (module, storeRefNumber) {
			var q = $q.defer();

			var req = { "storeRefNumber": storeRefNumber };

			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getRequestDetail", req, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		return PRService;
	});
