 'use strict';

angularApp.controller('currentLoanController',[
                        "$state",
                        "$scope",
                        "personalLoanService",

function ($state,
         $scope,
         personalLoanService) {


    var currentLoanVm = this;

    currentLoanVm.goToBack = function(){
        $state.go('menu.accountOverviewMyBalance');
    }

    $scope.goToHome = function(){
            $state.go('menu.homeScreen');
    }

    $scope.$on('$ionicView.beforeEnter', function() {
        currentLoanVm.loanAmount = personalLoanService.loanAmount;
        currentLoanVm.duration = personalLoanService.duration;
        currentLoanVm.intRate = parseFloat(personalLoanService.personalLoanData.interestRate);
        currentLoanVm.emiAmount = personalLoanService.emiAmount;
    });

    return this;
}]);
 