
angularApp.service('accountDetailsService',
	function($q,AdapterUtils){
		var accountDetailsService =this;
		var accountList="";	
		
		//Validate user through ATM details
		accountDetailsService.validateUserThroughATMDetails = function(requestData) {
			var q = $q.defer();	
			//AdapterUtils.postData("adapters/PreHomeLoginAdapter/validateUserThruATMCardAndPin",requestData,true).then(function(response){
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/validateUserThruATMCardAndPinNewRegistration",requestData,true).then(function(response){
				q.resolve(response);
			},
			function(error){
				q.reject(error);
			}); 
			return q.promise;
		};
		//Validate user through ATM details
		accountDetailsService.validateUserThroughATMPreLogin = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/ServiceRequestAdapter/validateUserThruATMCardAndPin",requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};
		
		//Set temporary user name and password and send to registered mobile number
		accountDetailsService.createLotusINBUser = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/lotusINBUserCreationService",requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};
		
		//Validate user
		accountDetailsService.validateUser = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/validateUser",requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};
		
		//Set new INB username and password
		accountDetailsService.setUserNameAndPassword = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/setUserNameAndPassword",requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};
		
		//Set new INB username and password
		accountDetailsService.accountAndBankDetails = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/getATMDetails",requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};
		
		//Generate OTP
		accountDetailsService.generateOTP = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/OTPAdapter/getOTPToken",requestData,false).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};
		
		//Validate OTP
		accountDetailsService.validateOTP = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPToken",requestData,true).then(
			function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};
		
			/****** Add Account List *****/
		accountDetailsService.addAccoutDetails = function(newObj) {
			accountList = newObj;
			
		};
		  /****** Get Account List *****/
		accountDetailsService.getDetails = function(){
		return accountList;
		};
		
		
		return accountDetailsService;
	});  
