'use strict';

angularApp.controller('atmCardPinController',
	["$ionicPopup", "$state", "$scope","$filter","accountDetailsService","utilityService","regProcessWithAccNoService","encryptionService",
	function ($ionicPopup, $state, $scope,$filter, accountDetailsService,utilityService, regProcessWithAccNoService,encryptionService) {

	var atmCardPinVm = this;
	atmCardPinVm.cardPin1 = '';
	atmCardPinVm.cardPin2 = '';
	atmCardPinVm.cardPin3 = '';
	atmCardPinVm.cardPin4 = '';
	atmCardPinVm.cardPinRequired = false;
	
	atmCardPinVm.goToAccAndBankDetails = function(atmNumber, atmPin) {
		var strPIN = "0";
		var PIN = atmPin;
		var pinLength = PIN.toString().length;
		var strHLen = pinLength.toString();
		strPIN = strPIN+strHLen;
		strPIN = strPIN+PIN;
		var yourNumber4 = strPIN.length;
		var lastValue=[]
		for (yourNumber4 ; yourNumber4 < 19; yourNumber4++) { 
			lastValue.push('F');
		}
		strPIN= strPIN+(lastValue.toString()).replace(/[^a-zA-Z ]/g, "");
		atmCardPinVm.currentDate=new Date();
		var txtDate=$filter('date')(atmCardPinVm.currentDate,'MMddHHmmss');
		
		// var pinPanBlockEncrypt = pinPanBlockValue.toString();
		var atmNumberEncrypt = atmNumber.replace(/\s/g, "").toString();
		
		var reqParams = {};
		reqParams["pinPanBlock"] = encryptionService.getAES256EncryptedData(strPIN);
		reqParams["atmNumber"] = atmNumberEncrypt.substring(atmNumberEncrypt.length-6);
		reqParams["txnDate"] = txtDate;
		reqParams["cifNumber"] = regProcessWithAccNoService.customerDetails.cifNumber;
		accountDetailsService.validateUserThroughATMDetails(reqParams).then(function(data){
			$state.go("menu.setInternetBankingDetails");
		}, function(error){
			utilityService.showBhimUpiAlert("error", error.responseMessage, "menu.selectSim", "OK", $scope);
		});
	}

	atmCardPinVm.submit = function(){
		atmCardPinVm.cardPin = '' + atmCardPinVm.cardPin1 + atmCardPinVm.cardPin2 + atmCardPinVm.cardPin3 + atmCardPinVm.cardPin4;
		if(atmCardPinVm.cardPin.length === 4) {
			atmCardPinVm.goToAccAndBankDetails(regProcessWithAccNoService.atmCardNumber, atmCardPinVm.cardPin);
			//$state.go("menu.setInternetBankingDetails");
		}
		else{
			atmCardPinVm.cardPinRequired = true;
		}
	}
	atmCardPinVm.close = function(){
		$state.go("menu.selectSim");
	}
}]);
