'use strict';

angularApp.controller('setProfilePasswordController', 
						["$timeout", "$state", "$scope", "$translate", "internetBankingService","utilityService","cryptoService","loggedInUserService", "$rootScope","encryptionService","$ionicPopup","getAccountDetailsService",
						function ($timeout, $state, $scope, $translate, internetBankingService, utilityService, cryptoService, loggedInUserService, $rootScope, encryptionService, $ionicPopup,getAccountDetailsService) {
							
	var setProfilePasswordVm = this;
	setProfilePasswordVm.passwordMatchFlag = true;
	
	//Set profile password and Goto Security questions page
	setProfilePasswordVm.goToSecurityQuestions = function(newPassword, reEnteredPassword){
		if(setProfilePasswordVm.checkPasswordMatches(newPassword, reEnteredPassword)){
			var aesEncryptedPassword = newPassword.toString();
			$state.go('menu.securityQuestions',{profileDetails : aesEncryptedPassword});
		}
	};
	
	//Check wheather new password and confirm password are matching or not
	setProfilePasswordVm.checkPasswordMatches = function(newPassword, reEnteredPassword){
		if(newPassword !== reEnteredPassword){
			setProfilePasswordVm.passwordMatchFlag = false;
			return false;
		}
		setProfilePasswordVm.passwordMatchFlag = true;
		return true;
	};

	//Profile Password info popup
	setProfilePasswordVm.passwordInfoPopup = function() {
		var userInfoPopUp = $ionicPopup.show({
			template: '<p>Text content goes here</p>',
			title: '',
			cssClass: 'dialog',
			scope: $scope,
			buttons: [{
				text: 'OK',
				type: 'button-positive'
			}]
		});
	}
	
	setProfilePasswordVm.goToBack = function(){
		$state.go('menu.inbLogin',{previousPage : "openNewDigitalAccountPage"});
	};
	
	setProfilePasswordVm.closeView = function(){
		//if(getAccountDetailsService.accountOverviewData.profilePasswordFlag){
			$state.go(utilityService.prevPage);
		// }else{
		// 	$state.go('menu.openNewDigitalAccount');	
		// }
	};
	
}]);