'use strict';
angularApp.controller('userLoginController', ["$timeout", "$state", "$scope", "$translate", "$ionicPopup", "$ionicPopover", "utilityService",
	"internetBankingService", "cryptoService", "loggedInUserService", "$rootScope", "ConnectivityMonitorUtils", "$ionicSideMenuDelegate", "encryptionService", "mPinLoginService", "myProfileService", "keyGuardService", "feedebackService", "ionicToast", "AdapterUtils", "currentLocationService", "locateNearestBranchService", "aoService", "$ionicScrollDelegate", "constantConfig", "ompMerchantsService", "clickStreamService",
	"cardCompareService", "bhimUpiService", "bQRService", "$cordovaBarcodeScanner", "customerInfoService", "$q", "$filter", "sampoornSurakshaService", "inbLockUnlockService", "homeScreenService", "ompOffersService","agriMandiService","registerWithSimService","quickPayService",
	"getAccountDetailsService","newCardService","fTBeneficiaryService","linkCardService","myBalanceService","mutualFundsService","leadGenerationService","openAccountService",
	"myDreamsService","cardsService","applyNowService",
	function ($timeout, $state, $scope, $translate, $ionicPopup, $ionicPopover, utilityService, internetBankingService, cryptoService, loggedInUserService, $rootScope, ConnectivityMonitorUtils, $ionicSideMenuDelegate, encryptionService, mPinLoginService, myProfileService, keyGuardService, feedebackService, ionicToast, AdapterUtils, currentLocationService, locateNearestBranchService, aoService, $ionicScrollDelegate, constantConfig, ompMerchantsService, clickStreamService,
		cardCompareService, bhimUpiService, bQRService, $cordovaBarcodeScanner, customerInfoService, $q, $filter, sampoornSurakshaService, inbLockUnlockService, homeScreenService, ompOffersService, agriMandiService, registerWithSimService,quickPayService,getAccountDetailsService,newCardService,fTBeneficiaryService,linkCardService,myBalanceService,mutualFundsService,leadGenerationService,openAccountService,myDreamsService,cardsService,applyNowService) {

		var userLoginVm = this;
		// userLoginVm.setpassword = "";
		userLoginVm.userName = "";
		userLoginVm.password = "";
		userLoginVm.isChallenged = false;
		userLoginVm.mpinErrorMsg = "";
		userLoginVm.mpinErrorMsgFlag = false;
		userLoginVm.userLoginErrorMsg = "";
		userLoginVm.userLoginErrorFlag = false;
		userLoginVm.securityCheckName = "AuthenticateMPinSecurityCheck";
		userLoginVm.mPinAuthChallengeHandler = WL.Client.createSecurityCheckChallengeHandler(userLoginVm.securityCheckName);
		userLoginVm.mPinAuthChallengeHandler.securityCheckName = userLoginVm.securityCheckName;
		userLoginVm.isLoginBtnClicked = false;
		userLoginVm.toggle = false;
		userLoginVm.fastTagflag=loggedInUserService.fastTagFlag;
		userLoginVm.customerName = localStorage.getItem("customername");
		$scope.banners = {};
		if (!localStorage.getItem('ignoredVersion'))
			localStorage.setItem('ignoredVersion', "0.0.0");
		userLoginVm.keystoreValue = loggedInUserService.keystoreValue;
		$scope.err = '';
		if (device.platform.toLowerCase() == 'android' || device.platform.toLowerCase() == 'windows') {
			userLoginVm.isAndroidDevice = true;
		} else {
			userLoginVm.isAndroidDevice = false;
		}

		userLoginVm.isUnameAndPwdInvalid = false;

		//if (!utilityService.isAndroidPlatform()) {
		userLoginVm.mpinConsent = loggedInUserService.mpinConsent;
		//}
		// else {
		// 	if (localStorage.getItem('mpinConsent') == 'true') {
		// 		userLoginVm.mpinConsent = true;
		// 	} else {
		// 		userLoginVm.mpinConsent = false;
		// 	}
		// }

		//Login with Username and Password

	//Function used for Cards journey apply part
	function allowApplications(card) { 
         if(newCardService.getParams().applyCardName == ''){
            applyNowService.resetApplyForm();
                newCardService.setParams({ "applyCardType": card.cardType });
                newCardService.setParams({ "applyCardName": card.cardName });
                newCardService.setParams({ "applyPictureURL": card.pictureURL });
                newCardService.setParams({ "applyCardCategory": card.categoryName });

                applyNowService.getCities().then(function(response) {
                    cardsService.errorLogger(response);
                    cardsService.setParams({ "city": response.data.cities });
                    cardsService.setParams({ 'pendingApplication': false });
                    $state.go('menu.cardPersonalDetails1');
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                }); 
         }else{
             applyNowService.getCities().then(function(response) {
                cardsService.errorLogger(response);
                cardsService.setParams({ "city": response.data.cities });
                cardsService.setParams({ 'pendingApplication': false });
                $state.go('menu.cardPersonalDetails1');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });            
         }
        
    }
		    //This method is called from redirectToFSSJourney function 
    userLoginVm.getServerUrl = function () {
        var q = $q.defer();
        mutualFundsService.getServerUrl().then(function (data) {
            q.resolve(data);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    }

	//Function call for Outbound Analytics and centralized consent FSS journey redirection to various FSS Screens
	userLoginVm.redirectToFSSJourney = function (){
		var preLoginSelectedMenu = newCardService.getPreLoginSelectedMenu();
		var postLoginSelectedMenu = newCardService.getPostLoginSelectedMenu();
		//Adding below lines for Zero is Hero banner redirection in prelogin invest option
		customerInfoService.customer = customerInfoService.customerInfo;
		customerInfoService.customer.isPanAvailable = customerInfoService.customerInfo.panNumber;
		customerInfoService.customer.DOB = customerInfoService.customerInfo.dob;
		var termsAndConditionsOutboundAnalyticsData = newCardService.getTermsAndConditionsOutboundAnalyticsData;
		//Adding below code for centralised consent sprint 2 journey
            leadGenerationService.checkConsent().then(function(response){
            	if(response.customerRecordExists == "false"){
            		var redirecturl = loggedInUserService.productClicked;
					loggedInUserService.productClicked = "";
					$state.go(redirecturl, { data: termsAndConditionsOutboundAnalyticsData });
            	}else{
            		if(preLoginSelectedMenu == 'cards'){
        				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "CC_START_NXT_BTN"));
        				var card = termsAndConditionsOutboundAnalyticsData;
        				utilityService.showSpinner();
        				if(linkCardService.getAllowAppStatus() == ""){
        				    linkCardService.getPendingApplicationStatus({})
        				    .then(function(response) {
        				            cardsService.errorLogger(response);
        				            if (response.data) {
        				                if (response.data.allow == "false"){
        				                    linkCardService.setAllowAppStatus(response.data);
        				                    utilityService.hideSpinner();
        				                    utilityService.enableShowErrorMessage(); 
        				                    utilityService.showErrorMessage(response.data.allowMessage);   
        				                    return false;       
        				                }
        				                else{
        				                    linkCardService.setAllowAppStatus(response.data);
        				                        allowApplications(card);
        				                }
        				            }
        				        },
        				        function(error) {
        				            utilityService.hideSpinner();
        				             allowApplications(card);
        				        });
        				}
        				else{
        				    if(linkCardService.getAllowAppStatus().allow == "false"){
        				        utilityService.hideSpinner();
        				        utilityService.enableShowErrorMessage(); 
        				        utilityService.showErrorMessage(linkCardService.getAllowAppStatus().allowMessage);   
        				        return false;       
        				    }
        				    else{
        				        utilityService.hideSpinner();
        				        allowApplications(card);
        				    }
        				}
        			}else if(preLoginSelectedMenu == 'invest'){
						loggedInUserService.productClicked = "";
            			clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "MF_START_NXT_BTN"));
            			newCardService.checkInvestNowClicked = 'True';
            			$state.go('menu.fundDetails');
        			}else if(preLoginSelectedMenu == 'myInvestment'){
        				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "MF_START_NXT_BTN"));   
        				myDreamsService.dreamId = "";   
        				homeScreenService.ishamburgerMenuRO=false;
        				homeScreenService.isInvestmentFlag = true;
        				getAccountDetailsService.tabIndex.tabIndex=3;
        				$state.go('menu.accountOverviewMyBalance');
        			}else if(preLoginSelectedMenu == 'myInvestmentAllProducts'){
        			    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "MF_START_NXT_BTN"));
        			    $state.go('menu.Investments');
        			}else if(preLoginSelectedMenu == 'know'){
        				$state.go('menu.startInvesting');
        			}else if(preLoginSelectedMenu == 'open'){
        			    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "DM_START_NXT_BTN"));
        			    openAccountService.setStatusOfOpenAccount(0);
        			    $state.go('menu.dematAndTradingAccount');
        			}else if(preLoginSelectedMenu == 'linkDematAccount'){
        			   clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "DM_START_NXT_BTN"));
        			   $state.go('menu.linkAccount');
        			}else if(preLoginSelectedMenu == 'folio'){
        				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "MF_START_NXT_BTN"));
        				userLoginVm.getServerUrl().then(function (_data) {
        				    userLoginVm.URL = _data;
        				    userLoginVm.panCard = userLoginVm.URL.kycNo;
        				    if (userLoginVm.panCard == '' || userLoginVm.panCard == null || userLoginVm.panCard == undefined) {
        				        $rootScope.isCreateFolio = 1;
        				        $rootScope.checkStatusPage = 1;
        				        $rootScope.kycCompliant = 0;
        				        $rootScope.kycNonCompliant = 0;
        				        $state.go('menu.KYC');
        				    } else {
        				        userLoginVm.checkKycStatus();
        				    }
        				}, function (error) {
        				    utilityService.showErrorMessage(error.responseMessage);
        				});
        			}else if(preLoginSelectedMenu == 'linkOrOpenNewAcc'){
        			    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "DM_START_NXT_BTN"));          
        			    myDreamsService.dreamId = "";
        			    homeScreenService.ishamburgerMenuRO=false;
        			    homeScreenService.isInvestmentFlag = true;
        			    getAccountDetailsService.tabIndex.tabIndex=3;
        			    $state.go('menu.accountOverviewMyBalance');
        			}else if(postLoginSelectedMenu == 'goRinnRaksha'){
          			  clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "LI_START_NXT_BTN"));
          			  $state.go('menu.rinnRaksha');
          			}else if(postLoginSelectedMenu == 'goRinnRakshaGLI'){
          			  clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "LI_START_NXT_BTN"));  
          			  $state.go('menu.rinnRaksha', {lifeGeneInsure : true});
          			}else if(preLoginSelectedMenu == 'allMFSchemes'){
              			$state.go('menu.mutualFundsList');
         			}			
    			}
            },function(error) {
                var redirecturl = loggedInUserService.productClicked;
				loggedInUserService.productClicked = "";
				$state.go(redirecturl, { data: termsAndConditionsOutboundAnalyticsData });
            });
	};
		userLoginVm.loginWithUserName = function () {
			if(utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (userLoginVm.isSimChanged || userLoginVm.simList == undefined || userLoginVm.simList.length == 0)){
				if(userLoginVm.isSimChanged)
				{
					userLoginVm.reloadApp(registerWithSimService.changedSimMsg, true);
				}
					//utilityService.showBhimUpiAlert("alert", registerWithSimService.changedSimMsg);
				else if(userLoginVm.simList == undefined || userLoginVm.simList.length == 0)
					utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
				return;
			}
			userLoginVm.userLoginErrorFlag = false;
			userLoginVm.isLoginBtnClicked = true;
			if (userLoginVm.userName && userLoginVm.password) {
				userLoginVm.isLoginBtnClicked = false;
				utilityService.showSpinner();
				internetBankingService.getServiceIdAndKey().then(function (data) {
					loggedInUserService.keyIdINB = data.keyId;
					loggedInUserService.serviceIdINB = data.serviceId;
					loggedInUserService.finalSHA512Val = loggedInUserService.generateINBSHA512Val(userLoginVm.userName, userLoginVm.password);
					userLoginVm.userloginStart();
				}, function (error) {
					userLoginVm.userName = '';
					userLoginVm.password = '';
					utilityService.hideSpinner();
					if (error.responseMessage) {
						utilityService.showErrorMessage(error.responseMessage);
					} else {
						utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
					}
				});
			}
		};

		userLoginVm.userloginStart = function () {
			userLoginVm.mPinAuthChallengeHandler.handleChallenge = function (challenge) {
				userLoginVm.isChallenged = true;
				userLoginVm.userName = '';
				userLoginVm.password = '';
				utilityService.accessRestricted = "";
				utilityService.hideSpinner();
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "USRLGN_BTN_MOB"));
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE_MOB"));
				if (challenge.errorMsg !== null) {
					if (challenge.errorCode == "AC001") {
							loggedInUserService.fileForStorageData('{"isDeviceRegistered":false,"mpinConsent":false}').then(function (res) {
								localStorage.setItem('isDeviceRegistered', false);
								localStorage.setItem('mpinConsent', false);
								userLoginVm.reloadApp(challenge.errorMsg);
							}, function (err) {
								localStorage.setItem('isDeviceRegistered', false);
								localStorage.setItem('mpinConsent', false);
								userLoginVm.reloadApp(challenge.errorMsg);
							});
						}
					else if (challenge.errorMsg.indexOf("2003:") !== -1) {
						challenge.errorMsg = challenge.errorMsg.replace("2003:", "");

						//if (!utilityService.isAndroidPlatform()) {
							loggedInUserService.fileForStorageData('{"isDeviceRegistered":false,"mpinConsent":false, "simSubscriptionId":""}').then(function(res){
								localStorage.setItem('isDeviceRegistered', false);
								localStorage.setItem('mpinConsent', false);
								userLoginVm.reloadApp(challenge.errorMsg);
							},function(err){
								localStorage.setItem('isDeviceRegistered', false);
								localStorage.setItem('mpinConsent', false);
								userLoginVm.reloadApp(challenge.errorMsg);
							});
						//}
					} else if (challenge.errorMsg.indexOf("2005:") !== -1) {
						challenge.errorMsg = challenge.errorMsg.replace("2005:", "");
						userLoginVm.reloadApp(challenge.errorMsg);
					} else if (challenge.errorCode == "M003" || challenge.errorCode == "LOCK.001") {
						if (challenge.errorCode == "LOCK.001") {
							inbLockUnlockService.challengeErrorCode = "LOCK.001";
						}
						inbLockUnlockService.displayErrorPopUp('<img class="inb-error-icon" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12">Your access has been locked.</p>',
							challenge.errorMsg, ["Cancel", "Unlock"], function () {

							}, function () {
								clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
								var reqParams = {
									"deviceId": device.uuid
								}
								internetBankingService.fetchDetailsByDeviceID(reqParams).then(function (data) {
									loggedInUserService.setInbUserId(data);
									$state.go('menu.inbUnlockAccessDetails');
								}, function (error) {
									utilityService.showErrorMessage(error.responseMessage);
								});
							});
						return
					}
					else if(challenge.errorCode == "FP01"){
						utilityService.showForcePasswordPopup(challenge.errorMsg,"menu.userLogin");
					}
					else if(challenge.errorCode === "SB001"){
						userLoginVm.reloadApp(challenge.errorMsg, true);
					}
					else if(challenge.errorCode === "F001"){
						registerWithSimService.reloadAppSimBinding(challenge.errorMsg);
					}

					else{
						userLoginVm.userLoginErrorMsg = challenge.errorMsg;
						userLoginVm.userLoginErrorFlag = true;
					}
				} else {
					utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
				}
			};

			userLoginVm.mPinAuthChallengeHandler.handleSuccess = function (data) {
				userLoginVm.isChallenged = false;
				if (data.user) {
					loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
					loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
					var userDetails = AdapterUtils.secretData == "" ? data.user.attributes.userDetails : encryptionService.getAES256DecryptedData(data.user.attributes.userDetails);
					if (data.user.attributes.sessionId && data.user.attributes.lotusId) {
						clickStreamService.sessionId = AdapterUtils.secretData == "" ? data.user.attributes.sessionId : encryptionService.getAES256DecryptedData(data.user.attributes.sessionId);
						clickStreamService.lotusId = AdapterUtils.secretData == "" ? data.user.attributes.lotusId : encryptionService.getAES256DecryptedData(data.user.attributes.lotusId);
					}
					loggedInUserService.setUserProfileDetails(JSON.parse(userDetails));
				}
			};

			userLoginVm.mPinAuthChallengeHandler.handleFailure = function (error) {
				userLoginVm.mPinAuthChallengeHandler.cancel();
				userLoginVm.isChallenged = false;
				userLoginVm.userName = '';
				userLoginVm.password = '';
				utilityService.accessRestricted = "";
				utilityService.hideSpinner();
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "USRLGN_BTN_MOB"));
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE_MOB"));
				if (error.errorCode == "INVALID_REQUEST" || error.errorCode == "invalid_client") {
					loggedInUserService.setMFPUrl(false);
					return;
				}
				if (error.failure) {
					utilityService.showErrorMessage(error.failure);
				} else {
					utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
				}
			}

			var payload = {};
			var hasedSimInfo = "";
				if(utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin){
					hasedSimInfo = userLoginVm.hasedSimInfo;
				}
			var requestParams = {
				"userName": userLoginVm.userName,
				"sha512Password": loggedInUserService.finalSHA512Val,
				"bankCode": "0",
				"osName": device.platform,
				"channel": "lotus",
				"serviceId": loggedInUserService.serviceIdINB,
				"referralMobNo": "",
				"mfDeviceId": loggedInUserService.deviceIdForMpin,
				"id": loggedInUserService.deviceInfo,
				"isRegister": "false",
				"simId": hasedSimInfo.toString()
			};

			var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
			payload = {
				"data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
				"src": src
			}

			payload = AdapterUtils.secretData == "" ? requestParams : payload;
			if (userLoginVm.isChallenged) {
				userLoginVm.mPinAuthChallengeHandler.submitChallengeAnswer(payload);
			} else {
				WLAuthorizationManager.login(userLoginVm.mPinAuthChallengeHandler.securityCheckName, payload).then(
					function (data) {
						utilityService.accessRestricted = utilityService.mPinAuthRequire;
						//mPinLoginService.isLoggedIn = true;
						utilityService.csatJournies = [];
						homeScreenService.isCustCalled = true;
						quickPayService.getCustomerInfo().then(function (data1) {
							mPinLoginService.isLoggedIn = true;
							getAccountDetailsService.accountOverviewData = data1;
							homeScreenService.isCustCalled = false;
							customerInfoService.customerInfo = data1.customerInformation;
							quickPayService.customerInfo = getAccountDetailsService.accountOverviewData;
							if (loggedInUserService.productClicked) {
								var redirecturl;
								if (loggedInUserService.productClicked == "menu.cardIntroduction") {
									cardCompareService.getShikharEligibilityCheck().then(function (response) {
										cardCompareService.shikharFlag = response.data.shikharFlag;
										if (cardCompareService.shikharFlag == true || cardCompareService.shikharFlag == "true") {
											redirecturl = 'menu.shikharCards';
											loggedInUserService.productClicked = "";
											$state.go(redirecturl);
										} else {
											redirecturl = loggedInUserService.productClicked;
											loggedInUserService.productClicked = "";
											$state.go(redirecturl);
										}
									}, function (error) {
										redirecturl = loggedInUserService.productClicked;
										loggedInUserService.productClicked = "";
										$state.go(redirecturl);
									})
								} 
								else if(loggedInUserService.productClicked == "menu.termsAndConditionsOutboundAnalytics"){

									userLoginVm.redirectToFSSJourney();
									
								}else if(loggedInUserService.productClicked == "menu.goToMyInsurance"){									
									redirecturl = 'menu.accountOverviewMyBalance';
									homeScreenService.isInsuranceFlag = true;
									getAccountDetailsService.tabIndex.tabIndex = 4;        
									loggedInUserService.productClicked = "";
									$state.go(redirecturl);
								}else if(loggedInUserService.productClicked == "linkCard"){
								//added below code for centralised journey
									linkCardService.getLinkedCards({}).then(function (response) {
										userLoginVm.cardList = response.data.cards;
										if(userLoginVm.cardList.length>0){
											homeScreenService.ishamburgerMenuRO = false;
                							fTBeneficiaryService.isCreditCardFlag = true;
                							getAccountDetailsService.setRewTab = true;
                							getAccountDetailsService.tabIndex.tabIndex = 5;
                							$state.go('menu.accountOverviewMyBalance');
										}else{
											myBalanceService.LinkCreditCards();
										}
									},function (error) {
                    					utilityService.showErrorMessage(error.responseMessage);
                					});
							} else {
									redirecturl = loggedInUserService.productClicked;
									loggedInUserService.productClicked = "";
									$state.go(redirecturl);
								}

						} else {
							internetBankingService.checkSession().then(function (data) {
								utilityService.hideSpinner();
									//notification changes starts
									if (ompOffersService.fromOfferPage) {
										ompOffersService.fromOfferPage=false;
										var redirectPath = ompOffersService.redirectURL;
										$state.go(redirectPath);
									}
									else {
									userLoginVm.setRedirection();
									}
									//notification changes ends
								//userLoginVm.setDataLogin(); /*commented for Home Screen API Optimization */
								clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "USRLGN_BTN_MOB"));
								clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_SUCCESS_MOB"));
							}, function (error) {
								utilityService.hideSpinner();
									//notification changes starts
									if (ompOffersService.fromOfferPage) {
										ompOffersService.fromOfferPage=false;
										var redirectPath = ompOffersService.redirectURL;
										$state.go(redirectPath);
									}
									else {
									userLoginVm.setRedirection();
									}
									//notification changes ends
								//userLoginVm.setDataLogin(); /*commented for Home Screen API Optimization */
								clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "USRLGN_BTN_MOB"));
								clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_SUCCESS_MOB"));
							});
						}
						}, function (error) {
							homeScreenService.isCustCalled = false;
							//homeScreenVM.welcomeTitleSpinner = false;
							$rootScope.profileImageUrl = 'img/profile_placeholder.svg';
							userLoginVm.userName = '';
							userLoginVm.password = '';
							if (error.responseCode === "SB001") {
								userLoginVm.reloadApp(error.responseMessage, true);
							}
							else if(error.errorCode === "F001"){
								registerWithSimService.reloadAppSimBinding(error.responseMessage);
							}
							else {
								utilityService.showErrorMessage(error.responseMessage);

							}
						});
						
					},
					function (error) {
						userLoginVm.userName = '';
						userLoginVm.password = '';
						utilityService.accessRestricted = "";
						utilityService.hideSpinner();
						if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
							return;
						}
						if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
							userLoginVm.mPinAuthChallengeHandler.cancel();
						}
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "USRLGN_BTN_MOB"));
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE_MOB"));
						if (error.errorCode == "INVALID_REQUEST" || error.errorCode == "invalid_client") {
							loggedInUserService.setMFPUrl(false);
							return;
						}
						utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
					});
			}
		}

		/*commented for Home Screen API Optimization: UX2.0 */
		// userLoginVm.setDataLogin = function () {
		// 	feedebackService.setDataLogin().then(function (data) {
		// 	}, function (error) {
		// 	});
		// }
		/*End of Home Screen API Optimization */

		userLoginVm.resetTimeStamp = function () {
			userLoginVm.userLoginErrorFlag = false;
			// userLoginVm.userLoginErrorFlag = false;
			if (!utilityService.lastTimeStamp) {
				utilityService.lastTimeStamp = new Date();
			} else {
				var diff = Math.ceil(((new Date()) - utilityService.lastTimeStamp) / 60000);
				if (diff > constantConfig.SBITIMEOUT) {
					userLoginVm.reloadApp(constantConfig.adapter.SESSION_INACTIVITY);
					return true;
				}
			}
		}
		//Login with MPIN
		userLoginVm.loginWithMpin = function () {
			if(utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (userLoginVm.isSimChanged || userLoginVm.simList == undefined || userLoginVm.simList.length == 0)){
				if(userLoginVm.isSimChanged)
				{
					userLoginVm.reloadApp(registerWithSimService.changedSimMsg, true);
				}
					//utilityService.showBhimUpiAlert("alert", registerWithSimService.changedSimMsg);
				else if(userLoginVm.simList == undefined || userLoginVm.simList.length == 0)
					utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
				userLoginVm.first = '';
				userLoginVm.second = '';
				userLoginVm.third = '';
				userLoginVm.fourth = '';
				userLoginVm.fifth = '';
				userLoginVm.sixth = '';
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				userLoginVm.enabledThisInput(1);
				return;
			}
			var newMpin = userLoginVm.first.trim() +
				userLoginVm.second.trim() +
				userLoginVm.third.trim() +
				userLoginVm.fourth.trim() +
				userLoginVm.fifth.trim() +
				userLoginVm.sixth.trim();
			//var newMpin = userLoginVm.setpassword;
			if (newMpin.length == 6) {
				if (ConnectivityMonitorUtils.isOffline()) {
					userLoginVm.first = '';
					userLoginVm.second = '';
					userLoginVm.third = '';
					userLoginVm.fourth = '';
					userLoginVm.fifth = '';
					userLoginVm.sixth = '';
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					//userLoginVm.enabledThisInput(1);
					/*login flow improvement*/
					var inputElement = document.getElementById('InputTxt1');
					inputElement.disabled = false;
					utilityService.offlineAlert();
					return;
				}
				utilityService.showSpinner();
				loggedInUserService.finalSHA512Val = registerWithSimService.isSimLogin ?
					loggedInUserService.generateMPINSHA512ValWithSim(newMpin, userLoginVm.simSubscriptionId) :
					loggedInUserService.generateMPINSHA512Val(newMpin) ;
				userLoginVm.mPinAuthChallengeHandler.handleChallenge = function (challenge) {
					userLoginVm.isChallenged = true;
					//userLoginVm.setpassword = "";
					userLoginVm.first = '';
					userLoginVm.second = '';
					userLoginVm.third = '';
					userLoginVm.fourth = '';
					userLoginVm.fifth = '';
					userLoginVm.sixth = '';
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					userLoginVm.enabledThisInput(1);
					utilityService.accessRestricted = "";
					utilityService.hideSpinner();
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN_MOB"));
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE_MOB"));
					if (challenge.errorMsg !== null) {
						if (challenge.errorCode == "AC001") {
							loggedInUserService.fileForStorageData('{"isDeviceRegistered":false,"mpinConsent":false}').then(function (res) {
								localStorage.setItem('isDeviceRegistered', false);
								localStorage.setItem('mpinConsent', false);
								userLoginVm.reloadApp(challenge.errorMsg);
							}, function (err) {
								localStorage.setItem('isDeviceRegistered', false);
								localStorage.setItem('mpinConsent', false);
								userLoginVm.reloadApp(challenge.errorMsg);
							});
						}
						else if (challenge.errorMsg.indexOf("2003:") !== -1) {
							challenge.errorMsg = challenge.errorMsg.replace("2003:", "");
							userLoginVm.reloadApp(registerWithSimService.changedSimMsg, true);
						} else if (challenge.errorMsg.indexOf("2005:") !== -1) {
							challenge.errorMsg = challenge.errorMsg.replace("2005:", "");
							userLoginVm.reloadApp(challenge.errorMsg);
						} else if (challenge.errorCode == "M003" || challenge.errorCode == "LOCK.001") {
							if (challenge.errorCode == "LOCK.001") {
								inbLockUnlockService.challengeErrorCode = "LOCK.001";
							}
							inbLockUnlockService.displayErrorPopUp('<img class="inb-error-icon" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12">Your access has been locked.</p>',
								challenge.errorMsg, ["Cancel", "Unlock"], function () {
								}, function () {
									clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
									var reqParams = {
										"deviceId": device.uuid,
										"journeyName": "N25"
									}
									internetBankingService.fetchDetailsByDeviceID(reqParams).then(function (data) {
										loggedInUserService.setInbUserId(data);
										$state.go('menu.inbUnlockAccessDetails');
									}, function (error) {
										if (error.responseCode == "cs002") {
											utilityService.comingSoon(error.responseMessage);
										} else {
											utilityService.showErrorMessage(error.responseMessage);
										}
									});
								});
							return

						}
						else if(challenge.errorCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
							utilityService.showForcePasswordPopup(challenge.errorMsg,"");
						}
						else if(challenge.errorCode === "SB001" || challenge.errorCode === "F001"){
							userLoginVm.reloadApp(challenge.errorMsg, true);
						}
						else {
							userLoginVm.mpinErrorMsg = challenge.errorMsg;
							userLoginVm.mpinErrorMsgFlag = true;
						}
					} else {
						utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
					}
				};

				userLoginVm.mPinAuthChallengeHandler.handleSuccess = function (data) {
					userLoginVm.isChallenged = false;
					if (data.user) {
						loggedInUserService.keyId = AdapterUtils.secretData == "" ? data.user.attributes.keyId : encryptionService.getAES256DecryptedData(data.user.attributes.keyId);
						loggedInUserService.tokenLotus = AdapterUtils.secretData == "" ? data.user.attributes.lotusToken : encryptionService.getAES256DecryptedData(data.user.attributes.lotusToken);
						var userDetails = AdapterUtils.secretData == "" ? data.user.attributes.userDetails : encryptionService.getAES256DecryptedData(data.user.attributes.userDetails);
						if (data.user.attributes.sessionId && data.user.attributes.lotusId) {
							clickStreamService.sessionId = AdapterUtils.secretData == "" ? data.user.attributes.sessionId : encryptionService.getAES256DecryptedData(data.user.attributes.sessionId);
							clickStreamService.lotusId = AdapterUtils.secretData == "" ? data.user.attributes.lotusId : encryptionService.getAES256DecryptedData(data.user.attributes.lotusId);
						}
						loggedInUserService.setUserProfileDetails(JSON.parse(userDetails));
					}
				};

				userLoginVm.mPinAuthChallengeHandler.handleFailure = function (error) {
					userLoginVm.mPinAuthChallengeHandler.cancel();
					userLoginVm.isChallenged = false;
					//userLoginVm.setpassword = "";
					userLoginVm.first = '';
					userLoginVm.second = '';
					userLoginVm.third = '';
					userLoginVm.fourth = '';
					userLoginVm.fifth = '';
					userLoginVm.sixth = '';
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					$scope.doErase();
					userLoginVm.enabledThisInput(1);
					utilityService.accessRestricted = "";
					utilityService.hideSpinner();
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN_MOB"));
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE_MOB"));
					if (error.errorCode == "INVALID_REQUEST" || error.errorCode == "invalid_client") {
							loggedInUserService.setMFPUrl(false);
							return;
					}
					if (error.failure) {
						utilityService.showErrorMessage(error.failure);
					} else {
						utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
					}
				}

				var payload = {};
				var hasedSimInfo = "";
				if(utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin){
					hasedSimInfo = userLoginVm.hasedSimInfo;
				}
				var requestParams = {
					"mPinNumber": loggedInUserService.finalSHA512Val,
					"mfDeviceId": loggedInUserService.deviceIdForMpin,
					"id": loggedInUserService.deviceInfo,
					"osName": device.platform,
					"keyId": loggedInUserService.keyId,
					"simId": hasedSimInfo.toString(),
				};

				var src = cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey);
				payload = {
					"data": AdapterUtils.secretData + encryptionService.getAES256EncryptedData(JSON.stringify(requestParams)),
					"src": src
				}

				payload = AdapterUtils.secretData == "" ? requestParams : payload;
				if (userLoginVm.isChallenged) {
					userLoginVm.mPinAuthChallengeHandler.submitChallengeAnswer(payload);
				} else {
					WLAuthorizationManager.login(userLoginVm.mPinAuthChallengeHandler.securityCheckName, payload).then(
						function (data) {
							utilityService.accessRestricted = utilityService.mPinAuthRequire;
							//mPinLoginService.isLoggedIn = true;
							utilityService.csatJournies = [];
							homeScreenService.isCustCalled = true;
							quickPayService.getCustomerInfo().then(function (data1) {
								mPinLoginService.isLoggedIn = true;
								getAccountDetailsService.accountOverviewData = data1;
								homeScreenService.isCustCalled = false;
								customerInfoService.customerInfo = data1.customerInformation;
								quickPayService.customerInfo = getAccountDetailsService.accountOverviewData;
								if (loggedInUserService.productClicked != "") {
								var redirecturl;
								if (loggedInUserService.productClicked == "menu.cardIntroduction") {
									cardCompareService.getShikharEligibilityCheck().then(function (response) {
										cardCompareService.shikharFlag = response.data.shikharFlag;
										if (cardCompareService.shikharFlag == true || cardCompareService.shikharFlag == "true") {
											redirecturl = 'menu.shikharCards';
											loggedInUserService.productClicked = "";
											$state.go(redirecturl);
										} else {
											redirecturl = loggedInUserService.productClicked;
											loggedInUserService.productClicked = "";
											$state.go(redirecturl);
										}
									}, function (error) {
										redirecturl = loggedInUserService.productClicked;
										loggedInUserService.productClicked = "";
										$state.go(redirecturl);
									})
								}else if(loggedInUserService.productClicked == "menu.termsAndConditionsOutboundAnalytics"){
										userLoginVm.redirectToFSSJourney();
								}else if(loggedInUserService.productClicked == "menu.goToMyInsurance"){									
									redirecturl = 'menu.accountOverviewMyBalance';
									homeScreenService.isInsuranceFlag = true;
									getAccountDetailsService.tabIndex.tabIndex = 4;        
									loggedInUserService.productClicked = "";
									$state.go(redirecturl);
								}else {
								redirecturl = loggedInUserService.productClicked;
								loggedInUserService.productClicked = "";
								$state.go(redirecturl);
								}
							} else {
								internetBankingService.checkSession().then(function (data) {
									console.log("success");
									utilityService.hideSpinner();
								//notification changes starts
								if (ompOffersService.fromOfferPage) {
									ompOffersService.fromOfferPage=false;
									var redirectPath = ompOffersService.redirectURL;
									$state.go(redirectPath);
								}
								else {
										userLoginVm.setRedirection();
									}
								//notification changes ends
									//userLoginVm.setDataLogin(); /*commented for: Home Screen API Optimization */
								}, function (error) {
									console.log("failure");
									utilityService.hideSpinner();
									//notification changes starts
									if (ompOffersService.fromOfferPage) {
										ompOffersService.fromOfferPage=false;
										var redirectPath = ompOffersService.redirectURL;
										$state.go(redirectPath);
									}
									else {
										userLoginVm.setRedirection();
									}
									//notification changes ends
									//userLoginVm.setDataLogin(); /*commented for: Home Screen API Optimization */
								});
							}
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN_MOB"));
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_SUCCESS_MOB"));
							}, function (error) {
								homeScreenService.isCustCalled = false;
								//homeScreenVM.welcomeTitleSpinner = false;
								$rootScope.profileImageUrl = 'img/profile_placeholder.svg';
								userLoginVm.first = '';
								userLoginVm.second = '';
								userLoginVm.third = '';
								userLoginVm.fourth = '';
								userLoginVm.fifth = '';
								userLoginVm.sixth = '';
								$scope.doErase();
								$scope.doErase();
								$scope.doErase();
								$scope.doErase();
								$scope.doErase();
								$scope.doErase();
								userLoginVm.enabledThisInput(1);
								if (error.responseCode == "SB001") {
									userLoginVm.reloadApp(error.responseMessage, true);
								}
								else {
									utilityService.showErrorMessage(error.responseMessage);

								}
							});
						},
						function (error) {
							//userLoginVm.setpassword = "";
							userLoginVm.first = '';
							userLoginVm.second = '';
							userLoginVm.third = '';
							userLoginVm.fourth = '';
							userLoginVm.fifth = '';
							userLoginVm.sixth = '';
							$scope.doErase();
							$scope.doErase();
							$scope.doErase();
							$scope.doErase();
							$scope.doErase();
							$scope.doErase();
							userLoginVm.enabledThisInput(1);
							utilityService.accessRestricted = "";
							utilityService.hideSpinner();
							if (error.errorCode == 'CHALLENGE_HANDLING_CANCELED' || error.errorCode == 'APPLICATION_DISABLED') {
								return;
							}
							if (error.errorCode == "LOGIN_ALREADY_IN_PROCESS") {
								userLoginVm.mPinAuthChallengeHandler.cancel();
							}
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "MPINLGN_BTN_MOB"));
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "LOGIN_FAILURE_MOB"));
							if (error.errorCode == "INVALID_REQUEST" || error.errorCode == "invalid_client") {
							loggedInUserService.setMFPUrl(false);
							return;
							}
							utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
						});
				}
			} else {
				//userLoginVm.setpassword = "";
				userLoginVm.first = '';
				userLoginVm.second = '';
				userLoginVm.third = '';
				userLoginVm.fourth = '';
				userLoginVm.fifth = '';
				userLoginVm.sixth = '';
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				userLoginVm.enabledThisInput(1);
				utilityService.showErrorMessage('Please Enter 6 digit valid MPIN');
			}
		};
		userLoginVm.setRedirection = function () {
			if(!homeScreenService.setBannerRedirection){
				$state.go('menu.homeScreen');
			}else{
				if($scope.banners.isLanguageRequired == 'Y'){
					if(localStorage.getItem('customerlanguage')){
						agriMandiService.selectLanguage = localStorage.getItem('customerlanguage').toLowerCase();
						$state.go($scope.banners.redirectionURL);
					}
					else{
						$state.go('menu.selectLanguage');
					}
				}
				else {
					$state.go($scope.banners.redirectionURL);
				}
			}
          
		}
		userLoginVm.redirectToBharatQR = function () {
			utilityService.showSpinner();
			if (!localStorage.getItem("appGenId")) {
				bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
					if (device.platform.toLowerCase() == 'android') {
						bhimUpiService.appGenId = data.appGenId;
					} else {
						bhimUpiService.appGenId = data;
					}
					userLoginVm.redirectToBharatQrFlow();
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			} else {
				bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId")).then(function (data) {
					userLoginVm.redirectToBharatQrFlow();
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			}
			// } else {
			// 	var comingsoonPopup = $ionicPopup.alert({
			// 		template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
			// 		+ 'Coming Soon</div></div></div></div></div></div>',
			// 		cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
			// 		buttons: [
			// 			{
			// 				text: 'OK',
			// 				type: 'button-positive',
			// 				onTap: function (e) {
			// 					comingsoonPopup.close();
			// 				}
			// 			}
			// 		]
			// 	});
			// }
		}

		userLoginVm.redirectToBharatQrFlow = function () {
			if (device.platform.toLowerCase() == 'android') {
				utilityService.showSpinner();
				var json = JSON.stringify({});
				getNativeData(constantConfig.upiConstant.getpermission, function (data) {
					if (data.permission === 'Allowed') {
						userLoginVm.redirectToBharatQRJourney();
					} else {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("error", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
					}
				}, function (msg) {
					utilityService.hideSpinner();
					userLoginVm.showVpaErrorMessage(msg);
				}, json);
			} else if (device.platform.toLowerCase() == 'windows') {
				ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
			} else {
				utilityService.showSpinner();
				var json = JSON.stringify({
					"pspId": constantConfig.upiConstant.pspId,
					"encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
				});
				bhimUpiService.getNativeData("initializeIOSsdk", json).then(function (data) {
					if (data !== "S") {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("error", data);
						return false;
					}
					utilityService.showSpinner();
					json = JSON.stringify({
						"addInfo": {
							"addInfo10": constantConfig.upiConstant.addInfo10,
							"addInfo9": constantConfig.upiConstant.addInfo9
						},
						"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
						"requestInfo": {
							"pspId": constantConfig.upiConstant.pspId,
							"pspRefNo": generateRandomString(27)
						},
						"updateFlag": constantConfig.upiConstant.updateFlag,
						"smsSent": "false"
					});
					bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (nData) {
						$rootScope.checkDeviceInfo = JSON.parse(nData);
						utilityService.hideSpinner();
						if ($rootScope.checkDeviceInfo.status == 'S') {
							if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
								$state.go('menu.scanQRCode');
							} else {
								utilityService.showBhimUpiAlert("alert", "Looks like you do not have a UPI profile to make payments. Please register UPI for making further transactions");
							}
						} else {
							utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
						}
					}, function (msg) {
						utilityService.hideSpinner();
						userLoginVm.showVpaErrorMessage(msg);
					});
				}, function (msg) {
					utilityService.hideSpinner();
					userLoginVm.showVpaErrorMessage(msg);
				});
			}
		}

		userLoginVm.redirectToBharatQRJourney = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag,
				"smsSent": false
			});
			getNativeData(constantConfig.upiConstant.checkDevice, function (data) {
				$rootScope.checkDeviceInfo = JSON.parse(data);
				utilityService.hideSpinner();
				if ($rootScope.checkDeviceInfo.status == 'S') {
					if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
						$state.go('menu.scanQRCode');
					} else {
						utilityService.showBhimUpiAlert("error", "Looks like you do not have a UPI profile to make payments. Please register UPI for making further transactions");
					}
				} else {
					utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				userLoginVm.showVpaErrorMessage(msg);
			}, json);
		}

		userLoginVm.changeInput = function ($event, index) {

			cordova.plugins.Keyboard.close();
			/*login flow improvements*/
			if (loggedInUserService.isServerConnected) {
				userLoginVm.loginWithMpin();
			} else {
				connectServer();
			}


		}

		userLoginVm.enabledThisInput = function (index) {
			try {
				userLoginVm.mpinErrorMsgFlag = false;
				for (var i = 1; i <= 6; i++) {
					var inputElement = document.getElementById('InputTxt' + i);
					if (index == i) {
						inputElement.disabled = false;
						inputElement.style = "border-bottom:1px solid #0095da !important;"
					} else {
						inputElement.disabled = true;
						inputElement.style = "border-bottom:1px solid #bcbebf !important;"
					}
				}
			} catch (err) { }
		}



		userLoginVm.cross =function () {
           userLoginVm.myDonationPop.close();
        };

		userLoginVm.lockUnlockPassword = function ($event) {
			userLoginVm.toggle = !userLoginVm.toggle;
			if (userLoginVm.toggle) {
				$event.srcElement.className = "eyeiconsize ion-eye";
				$event.srcElement.id = "UNLOCKED_IMG";
				for (var i = 1; i <= 6; i++) {
					var inputElement = document.getElementById('InputTxt' + i);
					inputElement.className = "show-text";
					inputElement.value = "";
				}
			} else {
				$event.srcElement.className = "eyeiconsize ion-eye-disabled";
				$event.srcElement.id = "LOCKED_IMG";
				for (var i = 1; i <= 6; i++) {
					var inputElement = document.getElementById('InputTxt' + i);
					inputElement.className = "show-dot";
					inputElement.value = "";
				}
			}
			setTimeout(function () {
				userLoginVm.enabledThisInput(1);
			}, 100);
		}

		//Show popup for having problem link on mpin login screen when consent is NOT GIVEN
		userLoginVm.showWithoutMpinHavingProblemPopup = function () {
			var havingMPINPrblmPopUp = $ionicPopup.show({
				template: '<p>MPIN is your 6 digit password to access your app. Click on "SET MPIN" to set a new MPIN based login.</p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive'
				}]
			});
		};

		//Reload App
		userLoginVm.reloadApp = function (message, sbFlag) {
			userLoginVm.mPinAuthChallengeHandler.cancel();
			userLoginVm.isChallenged = false;
			if(sbFlag){
				registerWithSimService.reloadAppSimOk(message);
			}
			else {
				if (utilityService.isAndroidPlatform()) {
					var reloadPopup = $ionicPopup.show({
						title: null,
						cssClass: 'my-custom-popup',
						template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">' + message + '</div>',
						scope: '',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								reloadPopup.close();
								loggedInUserService.logoutUser();
							}
						}, {
							text: 'Exit',
							type: 'button-assertive',
							onTap: function () {
								reloadPopup.close();
								loggedInUserService.logoutUser('exitApplication');
							}
						}],
					});
				} else {
					var reloadPopup = $ionicPopup.show({
						title: null,
						cssClass: 'my-custom-popup',
						template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey">' + message + '</div>',
						scope: '',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								reloadPopup.close();
								loggedInUserService.logoutUser();
							}
						}],
					});
				}
			}
			
		}

		//Show popup for having problem link on mpin login screen when consent is given
		userLoginVm.showMpinHavingProblemPopup = function () {
			var havingMPINPrblmPopUp = $ionicPopup.show({
				template: '<p>(1) If you have forgotton your MPIN you may reset your MPIN by logging in using your INB credentials. Then go to settings, select "Remove MPIN".In your next login, you may go to the tab "Login using MPIN" and choose "Set MPIN"<br>(2) For changing MPIN, after logging in from the menu, go to Settings and select "Change MPIN".</p>',
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive'
				}]
			});
		};

		userLoginVm.forgotpassPopup = function () {
			var havingMPINPrblmPopUp = $ionicPopup.show({
				template: "<p> If you have forgotton your profile password, you can reset the same yourself. You need to  authenticate yourself either with the hint question and answer that you had set for the Profile password or ATM Card details & PIN. You can approach branch in case you don't remember Hint Question/answer or ATM card details & PIN </p>",
				title: '',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'OK',
					type: 'button-positive'
				}]
			});
		};


		//Show popup for having problem link on uname/password login screen
		userLoginVm.showHavingProblemPopup = function () {
			// var reqParams = {
			// 	"deviceId": device.uuid
			// }
			// internetBankingService.fetchDetailsByDeviceID(reqParams).then(function (data) {
			// 	console.log(JSON.stringify(data));
			// 	loggedInUserService.setInbUserId(data);
			// 	$state.go('menu.inbForgotPassword');
			// }, function (error) {
			// 	utilityService.showErrorMessage(error.responseMessage);
			// });
			$state.go('menu.inbForgotPassword');
		};

		//cant login functionality: switch on mpin and userlogin screen
		userLoginVm.cantLogin = function () {
			if (userLoginVm.MPINLoginFlag) {
				userLoginVm.showMpinHavingProblemPopup();
			} else if (userLoginVm.UserIdLoginFlag) {
				userLoginVm.showHavingProblemPopup();
			} else {
				//Do Nothing
			}
		}

		//Toggle Login menus
		userLoginVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom bor-bot-active';
		userLoginVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom';
		userLoginVm.MPINLoginFlag = true;
		userLoginVm.UserIdLoginFlag = false;
		userLoginVm.toggleLoginMenu = function (loginOption) {
			if (loginOption === 'MPINLogin') {
				//userLoginVm.setpassword = "";
				userLoginVm.first = '';
				userLoginVm.second = '';
				userLoginVm.third = '';
				userLoginVm.fourth = '';
				userLoginVm.fifth = '';
				userLoginVm.sixth = '';
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				userLoginVm.MPINLoginFlag = true;
				userLoginVm.UserIdLoginFlag = false;
				userLoginVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom bor-bot-active';
				userLoginVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom';
				userLoginVm.toggle = false;
				userLoginVm.mpinErrorMsgFlag = false;
				//$ionicScrollDelegate.scrollTop();
			}
			if (loginOption === 'UserIdLogin') {
				userLoginVm.isLoginBtnClicked = false;
				userLoginVm.userName = '';
				userLoginVm.password = '';
				userLoginVm.MPINLoginFlag = false;
				userLoginVm.UserIdLoginFlag = true;
				userLoginVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom';
				userLoginVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom bor-bot-active';
				userLoginVm.userLoginErrorFlag = false;
			}
		};

		userLoginVm.goToRegistration = function () {
			mPinLoginService.isSetMPIN = true;
			$state.go('menu.inbLogin', { previousPage: "UserLoginPage" });
		};

		// userLoginVm.goToProductPage = function () {
		// 	$state.go('menu.financialProducts');
		// };

		// //Redirect to shop page
		// userLoginVm.goToShopPage = function () {
		// 	ionicToast.show("Please login to access this page", 'bottom', false, 3000);
		// };

		//Function for close login view
		userLoginVm.closeView = function () {
			userLoginVm.confirmPopup = $ionicPopup.confirm({
				cssClass: 'dialog',
				template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="EXIT_APP"></div>',
				buttons: [{
					text: '<span class="txt-blue">YES</span>',
					onTap: function (e) {
						$timeout(function () {
							//close the popup after 3 mili seconds
							userLoginVm.confirmPopup.close();
						}, 300);
						e.preventDefault();
						navigator.app.exitApp();
					}
				}, {
					text: 'NO',
					type: 'button-positive',
					onTap: function (e) {
						userLoginVm.confirmPopup.close();
					}
				}],
			});
		};

		userLoginVm.locateNearestBranch = function () {
			utilityService.showSpinner();
			$timeout(function () {
				currentLocationService.getCurrentPosition().then(
					function (position) {
						var latitude = position.coords.latitude;
						var longitude = position.coords.longitude;
						aoService.locateByGPS.length = 0;
						var params = {
							"latitude": latitude,
							"longitude": longitude,
							"branchLocator": "true"
						}
						if (utilityService.isUndefined(aoService.locateByGPS) ||
							aoService.locateByGPS.length === 0) {
							locateNearestBranchService.getBranchesForGeo(params).then(function (data) {
								utilityService.hideSpinner();
								if (!utilityService.isUndefined(data)) {
									for (var i = 0; i < data.branches.length; i++) {
										aoService.locateByGPS.push(data.branches[i]);
									}
									if (aoService.locateByGPS.length == 0) {
										var title = '';
										var template = 'No Branch is available within 5 km from your location';
										var onTap = '';
										var buttontext = 'OK';
										utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
									} else {
										$state.go('menu.locateNearestBranchByGPS');
									}
								}
							}, function (error) {
								utilityService.hideSpinner();
								utilityService.showErrorMessage(error.responseMessage);
							});
						} else {
							utilityService.hideSpinner();
						}
					},
					function (err) {
						utilityService.hideSpinner();
						var title = '';
						var template = '{{"ON_GPS" | translate}}';
						var onTap = '';
						var buttontext = '<b>OK</b>';
						utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
					});
			}, 2000);
		};
		/* Info Popup */
		var template = '<ion-popover-view class="fraudemergencypopover" id="runtimeHeight" >' + '<div class="arrowDownLogin"></div>' + '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="userLoginVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="one col-90 widthC90">' +
			'<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12" translate="EMERGENCYFRAUDMESSAGE"></div>' + '</ion-content>' + '</ion-popover-view>';

		$scope.popover = $ionicPopover.fromTemplate(template, {
			scope: $scope
		});

		userLoginVm.infoPopup = function ($event) {

			$scope.popover.show($event);
			/*var heightRender = document.getElementById("renderHeight").clientHeight;
			var heightRender = document.getElementById("renderHeight").clientHeight;
			document.getElementById("runtimeHeight").style.height = heightRender+40+"px";
				 if(heightRender => 59){
					document.getElementById("runtimeHeight").style.height = "100px";

			}else{
					document.getElementById("runtimeHeight").style.height = "70px";
			} */
		};

		userLoginVm.closePopover = function () {
			$scope.popover.hide();
		};
		/* Login flow imrpovements */
		userLoginVm.serverConnectErrorPopup = function () {
			if (userLoginVm.MPINLoginFlag) {
				userLoginVm.first = '';
				userLoginVm.second = '';
				userLoginVm.third = '';
				userLoginVm.fourth = '';
				userLoginVm.fifth = '';
				userLoginVm.sixth = '';
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				var inputElement = document.getElementById('InputTxt1');
				inputElement.disabled = false;
			} else {
				userLoginVm.userName = "";
				userLoginVm.password = "";
			}
			utilityService.hideSpinner();
			utilityService.showErrorMessage($scope.err);
		};

		userLoginVm.showUpgradeMsg = function (errormessage) {
			if (userLoginVm.MPINLoginFlag) {
				userLoginVm.first = '';
				userLoginVm.second = '';
				userLoginVm.third = '';
				userLoginVm.fourth = '';
				userLoginVm.fifth = '';
				userLoginVm.sixth = '';
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				$scope.doErase();
				var inputElement = document.getElementById('InputTxt1');
				inputElement.disabled = false;
			} else {
				userLoginVm.userName = "";
				userLoginVm.password = "";
			}
			utilityService.hideSpinner();
			utilityService.showUpgradeMessage(errormessage);
		}

		function connectServer() {
			try {
				var payload = {
					"data": cryptoService.encryptRSAWithPublicKey(encryptionService.iv + "^" + encryptionService.passphrase + "^" + encryptionService.salt, cryptoService.rsaPublicKey),
					"src": userLoginVm.keystoreValue != "" ? cryptoService.encryptRSAWithPublicKey(userLoginVm.keystoreValue, cryptoService.rsaPublicKey) : "",
				};
				utilityService.showSpinner();
				var resourceRequest = new WLResourceRequest("adapters/CustomSessionAdapter/saveCustomInformation", WLResourceRequest.POST, { timeout: 15000 });
				resourceRequest.send(payload).then(function (response) {
					utilityService.lastTimeStamp = new Date();
					response.responseText = utilityService.isJSON(response.responseText) ? JSON.parse(response.responseText) : JSON.parse(encryptionService.getAES256DecryptedData(response.responseText));
					if (response.responseText.responseCode == '0000') {
						//landingVM.isServerconnected = true;
						AdapterUtils.secretData = response.responseText.data.key;
						loggedInUserService.keyId = response.responseText.data.keyId;
						loggedInUserService.deviceIdForMpin = response.responseText.data.deviceId;
						loggedInUserService.upiPermissionKey = response.responseText.data.upiPermissionVal;
						loggedInUserService.billDeskUrl = response.responseText.data.billDeskUrl;
						loggedInUserService.sbiCollectUrl = response.responseText.data.sbiCollectUrl;
						utilityService.getUPIPermissions(loggedInUserService.upiPermissionKey);
						loggedInUserService.isServerConnected = true;
						utilityService.hideSpinner();
						if (userLoginVm.MPINLoginFlag) {
							userLoginVm.loginWithMpin();
						} else if (userLoginVm.UserIdLoginFlag) {
							userLoginVm.loginWithUserName();
						}
					} else if (response.responseText.responseCode == '0001') {
						$scope.err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
						loggedInUserService.isServerConnected = false;
						userLoginVm.serverConnectErrorPopup();
						return;
					} else if (response.responseText.responseCode == '0002') {
						$scope.err = response.responseText.responseCode + " : " + constantConfig.adapter.CANNOT_PROCESS_NOW;
						loggedInUserService.isServerConnected = false;
						userLoginVm.serverConnectErrorPopup();
						return;
					} else if (response.responseText.responseCode == '0003' || response.responseText.responseCode == '0004') {
						$scope.err = response.responseText.responseCode + " : " + response.responseText.responseMessage;
						loggedInUserService.isServerConnected = false;
						userLoginVm.serverConnectErrorPopup();
						return;
					}
				}, function (error) {
					if (error.errorCode == 'APPLICATION_DOES_NOT_EXIST') {
						$scope.err = error;
						userLoginVm.showUpgradeMsg($scope.err);
					} else {
						$scope.err = utilityService.getServerExceptionMessage(error);
						userLoginVm.serverConnectErrorPopup();
					}
					loggedInUserService.isServerConnected = false;
				});
			} catch (err) {
				$scope.err = constantConfig.adapter.SOMETHING_WENT_WRONG;
				loggedInUserService.isServerConnected = false;
				userLoginVm.serverConnectErrorPopup();
			}
		}

		userLoginVm.loginWithUserNameCheck = function () {
			if (loggedInUserService.isServerConnected) {
				userLoginVm.loginWithUserName();
			} else {
				connectServer();
			}
		}
		/* End of Login flow imrpovements */

		/* Info Popup */

		// userLoginVm.goToPaymentsPage = function () {
		// 	$state.go('menu.payments');
		// };

		//Register For Push
		// userLoginVm.registerForPushAndroid = function () {
		// 	WLAuthorizationManager.obtainAccessToken("push.mobileclient").then(
		// 		MFPPush.registerDevice(
		// 			null,
		// 			function (successResponse) {
		// 			},
		// 			function (failureResponse) {
		// 			}
		// 		)
		// 	);
		// }

		userLoginVm.goToSupportPage = function () {
			$state.go('menu.support');
		};

		userLoginVm.goToTermsConditions = function () {
			$state.go('menu.termsandconditions');
		};

		userLoginVm.goToPrivacyPolicy = function () {
			$state.go('menu.privacypolicy');
		};
		userLoginVm.inbLockApp = function () {



			inbLockUnlockService.displayErrorPopUp('<img class="inb-error-icon" src="img/FT/BhimUpi/alertSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p>',
				"Any Scheduled fund transfer, Night mode request & Running SIPs in Mutual Fund will be cancelled.Do you want to continue?", ["Cancel", "OK"], function () {

				}, function () {
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
					var reqParams = {
						"deviceId": device.uuid,
						"journeyName": "N25"
					}
					internetBankingService.fetchDetailsByDeviceID(reqParams).then(function (data) {
						loggedInUserService.setInbUserId(data);
						$state.go('menu.inbLockAccessDeatils');
						// inbLockUnlockService.checkPreLoginWhiteListUser().then(function (data) {
						// 	$state.go('menu.inbLockAccessDeatils');
						// }, function (error) {
						// 	// utilityService.showErrorMessage(error.responseMessage);
						// 	if (error.responseCode == "cs002") {
						// 		utilityService.comingSoon(error.responseMessage);
						// 	} else {
						// 		utilityService.showErrorMessage(error.responseMessage);
						// 	}
						// });
					}, function (error) {
						// utilityService.showErrorMessage(error.responseMessage);
						if (error.responseCode == "cs002") {
							utilityService.comingSoon(error.responseMessage);
						} else {
							utilityService.showErrorMessage(error.responseMessage);
						}
					});

				});

		};

		//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function () {
			$ionicSideMenuDelegate.canDragContent(false);
			$rootScope.isInUserLogin = true;
			navigator.splashscreen.hide();
		});

		userLoginVm.openLinkAccount = function () {
			ompMerchantsService.inAppBrowser('https://retail.onlinesbi.com/retops/aadhaarlinkinginitial.htm');
		}


		userLoginVm.redirectToBhimUpi = function () {
			utilityService.showSpinner();
			if (!localStorage.getItem("appGenId")) {
				bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
					if (device.platform.toLowerCase() == 'android') {
						bhimUpiService.appGenId = data.appGenId;
					} else {
						bhimUpiService.appGenId = data;
					}
					userLoginVm.redirectToBhimUpiFlow();
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			} else {
				bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId")).then(function (data) {
					userLoginVm.redirectToBhimUpiFlow();
				}, function (msg) {
					utilityService.hideSpinner();
					utilityService.showBhimUpiAlert("error", msg);
				});
			}
			// } else {
			// 	var comingsoonPopup = $ionicPopup.alert({
			// 		template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
			// 		+ 'Coming Soon</div></div></div></div></div></div>',
			// 		cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
			// 		buttons: [
			// 			{
			// 				text: 'OK',
			// 				type: 'button-positive',
			// 				onTap: function (e) {
			// 					comingsoonPopup.close();
			// 				}
			// 			}
			// 		]
			// 	});
			// }
		}

		userLoginVm.redirectToBhimUpiFlow = function () {
			if (device.platform.toLowerCase() == 'android') {
				utilityService.showSpinner();
				var json = JSON.stringify({});
				getNativeData(constantConfig.upiConstant.getpermission, function (data) {
					if (data.permission === 'Allowed') {
						userLoginVm.redirectToBhimUpiJourney();
					} else {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("error", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
					}
				}, function (msg) {
					utilityService.hideSpinner();
					userLoginVm.showVpaErrorMessage(msg);
				}, json);
			} else if (device.platform.toLowerCase() == 'windows') {
				ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
			} else {
				utilityService.showSpinner();
				var json = JSON.stringify({
					"pspId": constantConfig.upiConstant.pspId,
					"encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
				});
				bhimUpiService.getNativeData("initializeIOSsdk", json).then(function (data) {
					if (data !== "S") {
						utilityService.hideSpinner();
						utilityService.showBhimUpiAlert("error", data);
						return false;
					}
					utilityService.showSpinner();
					json = JSON.stringify({
						"addInfo": {
							"addInfo10": constantConfig.upiConstant.addInfo10,
							"addInfo9": constantConfig.upiConstant.addInfo9
						},
						"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
						"requestInfo": {
							"pspId": constantConfig.upiConstant.pspId,
							"pspRefNo": generateRandomString(27)
						},
						"updateFlag": constantConfig.upiConstant.updateFlag,
						"smsSent": "false"
					});
					bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (nData) {
						$rootScope.checkDeviceInfo = JSON.parse(nData);
						utilityService.hideSpinner();
						if ($rootScope.checkDeviceInfo.status == 'S') {
							if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
								$state.go('menu.bhimUpiPayments');
							} else {
								utilityService.showBhimUpiAlert("alert", "Looks like you do not have a UPI profile to make payments. Please register UPI for making further transactions");
							}
						} else {
							utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
						}
					}, function (msg) {
						utilityService.hideSpinner();
						userLoginVm.showVpaErrorMessage(msg);
					});
				}, function (msg) {
					utilityService.hideSpinner();
					userLoginVm.showVpaErrorMessage(msg);
				});
			}
		}

		userLoginVm.redirectToBhimUpiJourney = function () {
			utilityService.showSpinner();
			var json = JSON.stringify({
				"addInfo": {
					"addInfo10": constantConfig.upiConstant.addInfo10,
					"addInfo9": constantConfig.upiConstant.addInfo9
				},
				"recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
				"requestInfo": {
					"pspId": constantConfig.upiConstant.pspId,
					"pspRefNo": generateRandomString(27)
				},
				"updateFlag": constantConfig.upiConstant.updateFlag,
				"smsSent": false
			});
			getNativeData(constantConfig.upiConstant.checkDevice, function (data) {
				$rootScope.checkDeviceInfo = JSON.parse(data);
				utilityService.hideSpinner();
				if ($rootScope.checkDeviceInfo.status == 'S') {
					if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
						$state.go('menu.bhimUpiPayments');
					} else {
						utilityService.showBhimUpiAlert("error", "Looks like you do not have a UPI profile to make payments. Please register UPI for making further transactions");
					}
				} else {
					utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
				}
			}, function (msg) {
				utilityService.hideSpinner();
				userLoginVm.showVpaErrorMessage(msg);
			}, json);
		}

		//actions to done everytime the view is shown
		userLoginVm.loginBannerClick = function(){
			if($scope.banners.type == "popup"){
				var template = homeScreenService.formPopUp("userLoginVm");
				userLoginVm.loginBannerPopup = $ionicPopup.show({
					title: '',
					cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
					template: template,
					scope: $scope
				});
			}
			else if ($scope.banners.type == "redirect"){
				userLoginVm.disclaimerPopup = $ionicPopup.show({
					template: '<p><center>' + $scope.banners.content + '</center></p>',
					title: '',
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: $scope.banners.btnName,
						type: 'button-assertive',
						onTap: function () {
								cordova.ThemeableBrowser.open($scope.banners.redirectionURL, '_system', {
							});
						}
					}],
				});
			}
		};
		userLoginVm.closeLoginBannerPopup = function (setBannerRedirection){
			userLoginVm.loginBannerPopup.close();
			homeScreenService.setBannerRedirection = setBannerRedirection;
		}
		$scope.$on('$ionicView.beforeEnter', function () {
			userLoginVm.simSubscriptionId = "";
			userLoginVm.hasedSimInfo = "";
			userLoginVm.simList = [];
			userLoginVm.isSimChanged = false;
			loggedInUserService.shopNOrderPre=''; //Reset OMP value after login  
			loggedInUserService.shopNOrderPreHash="";
			userLoginVm.showFooter = true;
			$ionicSideMenuDelegate.canDragContent(false);
			mPinLoginService.userLoginStatus.isRegistered = true;
			mPinLoginService.isLoggedIn = false;
			//Check device is locked or not, depend on that go to User ID tab as default
			userLoginVm.keyguardValue = internetBankingService.checkKeyguardValue;
			if(userLoginVm.keyguardValue !== "true"){userLoginVm.toggleLoginMenu('UserIdLogin');}
			// Code added by GOC,Hyderabad for UserId Passwd and Mpin Hint
			if (utilityService.isIOSPlatform()) {
				userLoginVm.topStyle = "margin-top : -32px !important;";
			}
			else {
				userLoginVm.topStyle = "margin-top : 13px !important;";
			}
			//End of Code added by GOC,Hyderabad for UserId Passwd and Mpin Hint
			

			if (internetBankingService.banners.login.length === 0) {
				$scope.banners = {
					imageURL: "../www/img/login/banner_yc.jpg",
					redirectionURL: "",
					type: "simple"
				}
			}
			else {
				$scope.banners = internetBankingService.banners.login[0];
			}
			if (utilityService.isAndroidPlatform()) {
                            utilityService.showSpinner();
                            readSimcardInfo();
                        }
		});
		function readSimcardInfo() {
                /*Sim card Info fetching - Start*/
                function simInfosuccessCallback(result) {
                    utilityService.hideSpinner();
					var str = "";
					userLoginVm.isSimChanged = false;
					if(result.cards && result.cards.length > 0)
                    {
                        userLoginVm.simList = result.cards;
						var isAccountExists = -1;
						userLoginVm.simList.some(function (obj, i) {
							return obj.subscriptionId == registerWithSimService.simSubscriptionId ? isAccountExists = i : false;
						});
						if (isAccountExists !== -1) {
							str = device.uuid + registerWithSimService.simSubscriptionId;
							userLoginVm.simSubscriptionId = registerWithSimService.simSubscriptionId;
							userLoginVm.hasedSimInfo = cryptoService.getSHA512EncryptedData(str);
						}
						else{
							//either sim card is removed or slot changed or subscription id changed due to sim changes
							userLoginVm.isSimChanged = true;
							userLoginVm.simSubscriptionId = "";
						}
                    }
					if (userLoginVm.simList == undefined || userLoginVm.simList.length == 0) {
						utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
                    }
                    
                    $scope.$apply();
                }

                function HasPerminionSuccessCallback(result) {
                    if (result) {
                        window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
                    } else {
                        requestReadPermission();
                    }
                }

                function errorCallback(error) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("Permission denied.");
                }

                function requestSuccessCallback(result) {
                    if (result) {
                        hasReadPermission();
                    }
                }
                // Android only: check permission
                function hasReadPermission() {
                    window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
                }
                // Android only: request permission
                function requestReadPermission() {
                    window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
                }
                hasReadPermission();
                /*Sim card Info fetching - End*/
            }
		userLoginVm.showVpaErrorMessage = function (errorCode) {
			switch (errorCode) {
				case -1: utilityService.showErrorMessage(constantConfig.upiConstant.minusOne);
					break;

				case -2: utilityService.showErrorMessage(constantConfig.upiConstant.minusTwo);
					break;

				case -3: utilityService.showErrorMessage(constantConfig.upiConstant.minusThree);
					break;

				case -4: utilityService.showErrorMessage(constantConfig.upiConstant.minusFour);
					break;

				case -5: utilityService.showErrorMessage(constantConfig.upiConstant.minusFive);
					break;

				case -6: utilityService.showErrorMessage(constantConfig.upiConstant.minusSix);
					break;

				case -7: utilityService.showErrorMessage(constantConfig.upiConstant.minusSeven);
					break;

				default: utilityService.showErrorMessage(constantConfig.upiConstant.someWentWrong);
			}
		};
		userLoginVm.redirectToBillPay = function() {
			var url = loggedInUserService.billDeskUrl;
			cordova.ThemeableBrowser.open(url, '_system', {
				statusbar: {
					color: '#ffffffff'
				},
				toolbar: {
					height: 44,
					color: '#ffffffff',
					image: 'share'
				},
				closeButton: {
					wwwImage: 'img/inappback.png',
					align: 'left',
					event: 'closePressed'
				},
				backButtonCanClose: true
			});
		}
		userLoginVm.redirectToSBIFastag = function (errorCode) {			
			$state.go('menu.fasTagLanding');		
		};
		userLoginVm.goToUserLanding = function(){
			$state.go('menu.userLanding');
		}
		$scope.$on('$ionicView.enter', function () {
			//$ionicSideMenuDelegate.canDragContent(true);
			userLoginVm.enabledThisInput(1);
			homeScreenService.setBannerRedirection = false;
		});

		//any cleanup needs to be done here: executes everytime when page is left
		$scope.$on('$ionicView.afterLeave', function () {
			$ionicSideMenuDelegate.canDragContent(false);
			$rootScope.isInUserLogin = false;
		});

		$scope.$on('$ionicView.afterEnter', function () {

			$translate(['VERSION_NO']).then(function (translations) {
				clickStreamService.appVersion = translations['VERSION_NO'];
				if (loggedInUserService.latestAndroidAppVersion && loggedInUserService.latestIOSAppVersion) {

					var latestAndroidAppVersion_components = loggedInUserService.latestAndroidAppVersion.split(".");
					var latestIOSAppVersion_components = loggedInUserService.latestIOSAppVersion.split(".");
					var appVersion_components = clickStreamService.appVersion.split(".");
					userLoginVm.ignoredVersion = localStorage.getItem('ignoredVersion');
					var ignoredVersion_components = userLoginVm.ignoredVersion.split(".");
					var lenAndroid = Math.min(latestAndroidAppVersion_components.length, appVersion_components.length);
					var lenIOS = Math.min(latestIOSAppVersion_components.length, appVersion_components.length);
					var latestAndroidSum = 0;
					if (ionic.Platform.isAndroid()) {

						for (var i = 0; i < lenAndroid; i++) {
							if (parseInt(latestAndroidAppVersion_components[i]) > parseInt(ignoredVersion_components[i]) && parseInt(latestAndroidAppVersion_components[i]) > parseInt(appVersion_components[i])) {

								userLoginVm.appUpdatePopup = $ionicPopup.show({
									template: '<p><center>Yono has been updated with new features and security. Current version is ' + loggedInUserService.latestAndroidAppVersion + '. Older version may not work properly. Please update. Ignore if it is already done.</p>',
									title: '',
									scope: $scope,
									cssClass: 'my-custom-popup',
									buttons: [{
										text: 'Update',
										type: 'button-assertive',
										onTap: function () {

											cordova.plugins.market.open('com.sbi.lotusintouch');
										}
									},

									{
										text: 'Later',
										type: 'button-assertive',
										onTap: function () {

											localStorage.setItem('ignoredVersion', loggedInUserService.latestAndroidAppVersion);
											$state.go('menu.userLogin');
										}
									}],

								});

								break;
							}


						}

					}
					if (ionic.Platform.isIOS()) {

						for (var i = 0; i < lenIOS; i++) {

							if (parseInt(latestIOSAppVersion_components[i]) > parseInt(ignoredVersion_components[i]) && parseInt(latestIOSAppVersion_components[i]) > parseInt(appVersion_components[i])) {
								userLoginVm.appUpdatePopup = $ionicPopup.show({
									template: '<p><center>Yono has been updated with new features and security. Current version is ' + loggedInUserService.latestIOSAppVersion + '. Older version may not work properly. Please update. Ignore if it is already done.</p>',
									title: '',
									scope: $scope,
									cssClass: 'my-custom-popup',
									buttons: [{
										text: 'Update',
										type: 'button-assertive',
										onTap: function () {

											cordova.plugins.market.open('id1231393474');
										}
									},

									{
										text: 'Later',
										type: 'button-assertive',
										onTap: function () {

											localStorage.setItem('ignoredVersion', loggedInUserService.latestIOSAppVersion);
											$state.go('menu.userLogin');
										}
									}],

								});
								break;
							}


						}

					}

				}

			});

		});

		$scope.$on('$ionicView.beforeLeave', function () {

		});

		/*Custom Keypad for MPIN*/

		$scope.password = '';
		$scope.canErase = false;
		$scope.pinDotVisible = {};
		$scope.success = null;
		$scope.keyboardVisible = false;
		$scope.pinArray = [];

		$scope.keyboardSettings = {
			// settings here
			action: function (number) {
				if ($scope.password.length < 6) {
					$scope.password += number;
					$scope.pinArray.push(number);
					$scope.pinDotVisible[$scope.password.length] = true;
					$scope.canErase = true;
					$scope.success = null;
					var pass = $scope.password;
					pass = pass.split("");
					try {
						userLoginVm.first = pass[0];
						userLoginVm.second = pass[1];
						userLoginVm.third = pass[2];
						userLoginVm.fourth = pass[3];
						userLoginVm.fifth = pass[4];
						userLoginVm.sixth = pass[5];
					} catch (err) { }

				}
				if ($scope.password && $scope.password.length === 6) {
					var e = {};
					$scope.newMpin = $scope.password;
					var pass = $scope.password;
					pass = pass.split("");
					try {
						userLoginVm.first = pass[0];
						userLoginVm.second = pass[1];
						userLoginVm.third = pass[2];
						userLoginVm.fourth = pass[3];
						userLoginVm.fifth = pass[4];
						userLoginVm.sixth = pass[5];
					} catch (err) { }
					var e = {};
					e.srcElement = {};
					e.srcElement.value = 2;
					userLoginVm.changeInput(e, 6);
				}
			},

			// Clear
			leftButton: {
				html: '<i class="icon ion-backspace"></i>',
				action: function () {
					$scope.doErase();
				},
				style: {
					bgColor: '#fff',
					activeBgColor: '#dfdfdf',
					borderColor: '#dfdfdf',
					fontSize: '20px'
				}
			},

			// Submit login
			rightButton: {
				html: '<i class="icon ion-eye"></i>	<i class="icon ion-eye-disabled login-eye-btn" ></i>',
				//html: '<i id="eyeElement" class="icon ion-eye"></i>',
				action: function () {
					//$scope.hideKeyboard();
					if ($scope.isPassVisible) {
						var elementHide = document.getElementsByClassName("ion-eye-disabled")[0];
						elementHide.classList.add("login-eye-btn");
						var elementShow = document.getElementsByClassName("ion-eye")[0];
						elementShow.classList.remove("login-eye-btn");

						$scope.isPassVisible = false;
					} else {
						$scope.isPassVisible = true;
						var elementHide = document.getElementsByClassName("ion-eye")[0];
						elementHide.classList.add("login-eye-btn");
						var elementShow = document.getElementsByClassName("ion-eye-disabled")[0];
						elementShow.classList.remove("login-eye-btn");
					}
				},
				style: {
					bgColor: '#fff',
					activeBgColor: '#dfdfdf',
					borderColor: '#dfdfdf',
					fontSize: '30px'
				}
			}
		}

		$scope.doErase = function () {
			$scope.pinDotVisible[$scope.password.length] = false;
			$scope.password = $scope.password.slice(0, -1);
			if ($scope.password.length == 0) $scope.canErase = false;
			try {
				var pass = $scope.password;
				pass = pass.split("");
				userLoginVm.first = pass[0] ? pass[0] : "";
				userLoginVm.second = pass[1] ? pass[1] : "";
				userLoginVm.third = pass[2] ? pass[2] : "";
				userLoginVm.fourth = pass[3] ? pass[3] : "";
				userLoginVm.fifth = pass[4] ? pass[4] : "";
				userLoginVm.sixth = pass[5] ? pass[5] : "";
			} catch (err) { }
		}



		$scope.unmask = function () {

		}

		$scope.rightAction = function () {
			pinDotVisible[0] = false;
			pinDotVisible[1] = false;
			pinDotVisible[2] = false;
			pinDotVisible[3] = false;
			pinDotVisible[4] = false;
			pinDotVisible[5] = false;
		}

		$scope.showKeyboard = function () {
			$scope.keyboardVisible = true;
		}

		$rootScope.hidekeypad = function ($event) {
			switch ($event.target.className) {
				case "mpin1 activated":
				// code block

				case "mpin1":
				// code block

				case "digit-keyboard-key":
				// code block

				case "digit-keyboard-key-action ng-binding":
				// code block

				case "icon ion-record":
				// code block

				case "digit-keyboard-key activated":
				// code block

				case "icon ion-backspace":
				// code block

				case "mpin1 ng-pristine ng-untouched ng-valid ng-empty activated":
				// code block

				case "mpin1 ng-binding":
				// code block

				case "icon ion-eye-disabled login-eye-btn":
				// code block

				case "icon ion-eye login-eye-btn":
				// code block

				case "digit-keyboard-key-number":
					// code block
					if (!$scope.keyboardVisible) {
						$scope.showKeyboard();
					}
					break;
				default:
					// code block
					if ($scope.keyboardVisible) {
						$scope.hideKeyboard();
					}
					break;
			}
		}

		$scope.hideKeyboard = function () {
			$scope.keyboardVisible = false;
		}


		userLoginVm.cybercrimeHelpline = function(){
			userLoginVm.helpPopUp = $ionicPopup.show({
				templateUrl: 'pages/preHomeLogin/InternetBanking/cybercrimeHelplinePopUp.html',				
				title: '',
				cssClass: 'dialog-prelogin',
				scope: $scope,
			});
		}

		userLoginVm.cybercrimeHelplineOK = function(){
			userLoginVm.helpPopUp.close();
			$state.go('menu.userLogin');
		}
		/*End of Custom Keypad for MPIN*/
		
				
var template_MPIN_HINT = '<ion-popover-view class="quickpay loginnewarrow hmbr-info username-hint-popover-mpin" id="runtimeHeight" style="{{userLoginVm.topStyle}}">' + '<div class="username-hint-arrow-upnew"></div>' +
															'<ion-content class="nfs-popover" style="margin: 0px !important;">' +
															'<div id="renderHeight" class="padding-right-10 font-size-12" style="padding-left: 14px !important;">' +
															'<div class="roboto-regular font-sixe-12 color3f3f3f" translate="MPIN_HINT" style="text-align:justify !important;"></div>' +
															'</div>' + '</ion-content>' + '</ion-popover-view>';
var template_Username_HINT = '<ion-popover-view class="quickpay loginnewarrow hmbr-info username-hint-popover-user-pass " id="runtimeHeight" style="{{userLoginVm.topStyle}}">' + '<div class="username-hint-arrow-upnew" style="right :3%;"></div>' +
															'<ion-content class="nfs-popover" style="margin: 0px !important;">' +
															'<div id="renderHeight" class="padding-right-10 font-size-12" style="padding-left: 14px !important;">' +
															'<div class="roboto-regular font-sixe-12 color3f3f3f" translate="USERNAME_HINT" style="text-align:justify !important;" ></div>' +
															'</div>' + '</ion-content>' + '</ion-popover-view>';
var template_Pass_HINT =     '<ion-popover-view class="quickpay loginnewarrow hmbr-info username-hint-popover-user-pass" id="runtimeHeight" style="{{userLoginVm.topStyle}}">' + '<div class="username-hint-arrow-upnew" style="right :3%;"></div>' +
															'<ion-content class="nfs-popover" style="margin: 0px !important;">' +
															'<div id="renderHeight" class="padding-right-10 font-size-12" style="padding-left: 14px !important;">' +
															'<div class="roboto-regular font-sixe-12 color3f3f3f" translate="PASS_HINT" style="text-align:justify !important;"></div>' +
															'</div>' + '</ion-content>' + '</ion-popover-view>';


userLoginVm.mpinHint = function($event) {
		$scope.popover_hint = $ionicPopover.fromTemplate(template_MPIN_HINT, {
			scope : $scope
		});
		$scope.popover_hint.show($event);
}
userLoginVm.usernameHint = function($event) {
	$scope.popover_hint = $ionicPopover.fromTemplate(template_Username_HINT, {
		scope : $scope
	});
	$scope.popover_hint.show($event);
}
userLoginVm.passHint = function($event) {
	$scope.popover_hint = $ionicPopover.fromTemplate(template_Pass_HINT, {
		scope : $scope
	});
	$scope.popover_hint.show($event);
}


	}]);
