'use strict';

angularApp.controller('loginTnCController', ["$timeout", "$state", "$scope", "$translate", "$ionicPopup", 
					  "loggedInUserService", "internetBankingService", "utilityService", "$stateParams","$ionicSideMenuDelegate","mPinLoginService", "fTBeneficiaryService",
					function ($timeout, $state, $scope, $translate, $ionicPopup, loggedInUserService, internetBankingService, utilityService, $stateParams, $ionicSideMenuDelegate , mPinLoginService, fTBeneficiaryService) {
							
	var loginTnCVm = this;
	
	loginTnCVm.termsConditions = $stateParams.obj;
	
	loginTnCVm.closeView = function(){
		$state.go('menu.openNewDigitalAccount');
	};
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false);
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
}]);