'use strict';

angularApp.controller('needHelpController', ["$state",
    "$scope",
    "instaService",
    "$ionicScrollDelegate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "utilityService",
	"needHelpService",
    function($state,
        $scope,
        instaService,
        $ionicScrollDelegate,
        $ionicSideMenuDelegate,
        mPinLoginService,
        utilityService,
        needHelpService) { 

        var needHelpVm = this;

        function initPage() {
           
        }      

        $scope.goToHome = function() {
        	if(needHelpService.isInternetBankLoaded){
        		$state.go("menu.openNewDigitalAccount");
        		needHelpService.isInternetBankLoaded = false;
        	}else{
        		instaService.homeNav();
        	}
            
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            needHelpVm.knowMoreContent = needHelpService.knowMoreContent;
        });

        return this;
    }
]);
