'use strict';

angularApp.controller('paymentsController', 
	["$timeout",
	"$state",
	"$scope",
	"$translate",
	"$ionicPopup",
	"loggedInUserService",

	function ($timeout,
		$state,
		$scope,
		$translate,
		$ionicPopup,
		loggedInUserService) {

	//functions, variables that can be accessed from the HTML come here
	var paymentsVm = this;
	//private methods section start

	//public functions end
	paymentsVm.closeView = function(){
		$state.go('menu.userLogin');
	}
	paymentsVm.goBack = function(){
		$state.go('menu.userLogin');
	}

	paymentsVm.sbiCollect = function(){
		var url = loggedInUserService.sbiCollectUrl;
		var refInAppBrowser = cordova.ThemeableBrowser.open(url, '_system', {
			statusbar: {
				color: '#ffffffff'
			},
			toolbar: {
				height: 37,
				color: '#ffffffff',
				image: 'share'
			},

			closeButton: {
				image: 'back',
				height: 37,
				width: 32,
				align: 'left',
				event: 'closePressed'
			},


			backButtonCanClose: true
		});

	}

	paymentsVm.billPayment = function(){
		var url = loggedInUserService.billDeskUrl;
		var refInAppBrowser = cordova.ThemeableBrowser.open(url, '_system', {
			statusbar: {
				color: '#ffffffff'
			},
			toolbar: {
				height: 37,
				color: '#ffffffff',
				image: 'share'
			},

			closeButton: {
				image: 'back',
				height: 37,
				width: 32,
				align: 'left',
				event: 'closePressed'
			},


			backButtonCanClose: true
		});
	}

	return this;
}]);