 
angularApp.service('regProcessWithAccNoService',
	function($q, $http, AdapterUtils, utilityService){
		var regProcessWithAccNoService =this;	
		regProcessWithAccNoService.isRequestNumberCreated = false;
		regProcessWithAccNoService.selectedBranchDetails = '';
		regProcessWithAccNoService.customerDetails = {};
		regProcessWithAccNoService.customerDetailsForATM = {};
		regProcessWithAccNoService.transactionDetails = {};
		regProcessWithAccNoService.requestNumber = '';
		regProcessWithAccNoService.isActivationCodeBtnClicked = false;
		regProcessWithAccNoService.userNameStep3 = '';
		regProcessWithAccNoService.isStepDisplay = true;
		regProcessWithAccNoService.custDetails = {};
		regProcessWithAccNoService.cifn = '';
		regProcessWithAccNoService.registerWithATM = '';
		regProcessWithAccNoService.atmCardNumber = '';
		regProcessWithAccNoService.regReferralCode = '';

		regProcessWithAccNoService.checkCifNoAvailability = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/checkCifNoAvailability", requestData, true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					utilityService.hideSpinner();
					q.reject(error);
				}); 
			return q.promise;
		};

		regProcessWithAccNoService.getCustomerDetails = function(requestData) {
			var q = $q.defer();
			var url = "adapters/PreHomeLoginAdapter/getCustomerDetails";
			if(regProcessWithAccNoService.registerWithATM === 'Y')
				url = "adapters/PreHomeLoginAdapter/getCustomerDetailsForNewATM";
			AdapterUtils.postData(url, requestData, true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					utilityService.hideSpinner();
					q.reject(error);
				}); 
			return q.promise;
		};
		
		regProcessWithAccNoService.getBranchMasterData = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/getBranchesForLocalityRegistration", requestData, true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					utilityService.hideSpinner();
					q.reject(error);
				}); 
			return q.promise;
		};

		regProcessWithAccNoService.setInternetBankingDetails = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/blockUserAvailability", requestData, true).then(function(response){
					q.resolve(response);
				},
				function(error){
					utilityService.hideSpinner();
					q.reject(error);
				}); 
			return q.promise;
		};

		regProcessWithAccNoService.validateOTP = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenOVD", requestData, true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					utilityService.hideSpinner();
					q.reject(error);
				}); 
			return q.promise;
		};
		
		regProcessWithAccNoService.validateActivationCode = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/validateActivationCode", requestData, true).then(function(response){
					q.resolve(response);
				},
				function(error){
					utilityService.hideSpinner();
					q.reject(error);
				}); 
			return q.promise;
		};

		regProcessWithAccNoService.activateNewuserAccount = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/activateNewuserAccount", requestData, true).then(function(response){
					q.resolve(response);
				},
				function(error){
					utilityService.hideSpinner();
					q.reject(error);
				}); 
			return q.promise;
		};

		regProcessWithAccNoService.generateOTP = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/otpgeneration", requestData, true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					utilityService.hideSpinner();
					q.reject(error);
				}); 
			return q.promise;
		};

		regProcessWithAccNoService.authenticateLogin = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/authenticateLogin", requestData, true).then(function(response){
					q.resolve(response);
				},
				function(error){
					utilityService.hideSpinner();
					q.reject(error);
				}); 
			return q.promise;
		};

		regProcessWithAccNoService.getBranchDetails = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/getBranchDetails", requestData, true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					utilityService.hideSpinner();
					q.reject(error);
				}); 
			return q.promise;
		};

		regProcessWithAccNoService.sendOTP = function(requestData) {
			var q = $q.defer();	
			var req = regProcessWithAccNoService.registerWithATM !== 'Y' ? requestData : {};
			var url = regProcessWithAccNoService.registerWithATM !== 'Y' ? "adapters/PreHomeLoginAdapter/sendOTP" : "adapters/PreHomeLoginAdapter/generateOTPForNewATM";
			AdapterUtils.postData(url, req, true).then(function(response){
					q.resolve(response);
				},
				function(error){
					utilityService.hideSpinner();
					q.reject(error);
				}); 
			return q.promise;
		};

		//Hot fix for ATM Journey
		regProcessWithAccNoService.getCustomerDetailsForATM = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/getCustomerDetailsForATM", requestData, true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					utilityService.hideSpinner();
					q.reject(error);
				}); 
			return q.promise;
		};
		//Hot fix for ATM Journey

		regProcessWithAccNoService.getACardDetails = function(requestData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/PreHomeLoginAdapter/getValueForATM",requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}); 
			return q.promise;
		};
		return regProcessWithAccNoService;
	});   
