'use strict';
angularApp.controller('userLandingController', [
  "$state",
  "$scope",
  "$ionicPopup",
  "$translate",
  "$ionicHistory",
  "utilityService",
  "loggedInUserService",
  "quickPayService",
  "internetBankingService",
  "ompMerchantsService",
  "$ionicPopover",
  "$rootScope",
  "$ionicSlideBoxDelegate",
  "bhimUpiService",
  "customerInfoService",
  "constantConfig",
  "cryptoService",
  "encryptionService",
  "AdapterUtils",
  "ConnectivityMonitorUtils",
  "mpassbookdetailsService",
  "$stateParams",
  "clickStreamService",
  "$filter","openUrlInAppbroswerService","homeScreenService","getAccountDetailsService","myBalanceService",
  "$sce",
  "registerWithSimService","ompOffersService",
	function ($state,
    $scope,
    $ionicPopup,
    $translate,
    $ionicHistory,
    utilityService,
    loggedInUserService,
    quickPayService,
    internetBankingService,
    ompMerchantsService,
    $ionicPopover,
    $rootScope,
    $ionicSlideBoxDelegate,
    bhimUpiService,
    customerInfoService,
    constantConfig,
    cryptoService,
    encryptionService,
    AdapterUtils,
    ConnectivityMonitorUtils,
	  mpassbookdetailsService,
    $stateParams,
    clickStreamService,
    $filter,openUrlInAppbroswerService,homeScreenService,getAccountDetailsService,myBalanceService,
    $sce,
    registerWithSimService, ompOffersService) {
			
			var userLandingVm = this;
			userLandingVm.keystoreValue = loggedInUserService.keystoreValue;
      userLandingVm.authFlag = "";
      userLandingVm.mpinErrorMsg = "";
      userLandingVm.mpinErrorMsgFlag = false;
      userLandingVm.isLoginBtnClicked = false;

      //1-Mpin 2-username 3-biometric
			function initPage() {
      
      $translate(['YQP_USERNAME', 'YQP_PASSWORD','OMP_OFFER_PDF']).then(function (translations) {
        userLandingVm.usernameTxt = translations['YQP_USERNAME'];
        userLandingVm.passwordTxt = translations['YQP_PASSWORD'];
        userLandingVm.pdfUrl = translations['OMP_OFFER_PDF'];
      });
      userLandingVm.isImageAvl = false;
      userLandingVm.isBiometricSet = localStorage.getItem("isBiometricSet");
      if(userLandingVm.isBiometricSet == undefined || userLandingVm.isBiometricSet == "false"){
        userLandingVm.isBiometricSet = false;
      }
      else{
        userLandingVm.isBiometricSet = true;
      }
      userLandingVm.toggle.checked = false;
      userLandingVm.isFingerprintAvl = quickPayService.isFingerprintAviFlag;
      userLandingVm.isMpinSet = loggedInUserService.mpinConsent;
      $scope.passLenLimitReached = false;
      if(!userLandingVm.isMpinSet){
        userLandingVm.toggle.checked = true;
      }
      var imageId = localStorage.getItem("customerImageId");
      if (quickPayService.customerInfo != '')
        userLandingVm.accountList = quickPayService.customerInfo.accounts;
      quickPayService.isFingerprintAvailable().then(function (response) {
        userLandingVm.isFingerprintAvl = response.responseMessage;
      }, function (error) {
        //utilityService.showErrorMessage(error.responseMessage);
      });

      userLandingVm.bio_text = "";
                  if(quickPayService.isBiometricType == 'face')
                                          userLandingVm.bio_text = "Face ID";
                                          else
                                          userLandingVm.bio_text = "Touch ID";

                  $translate(['ENABLE_FACEID','ENABLE_FACEID_DESC','YQP_AUTH_MSG'],{FIELD_1 : userLandingVm.bio_text}).then(function (translations) {
                                          userLandingVm.ENABLE_FACEID = translations['ENABLE_FACEID'];
                                          userLandingVm.ENABLE_FACEID_DESC = translations['ENABLE_FACEID_DESC'];
                                          userLandingVm.YQP_AUTH_MSG = translations['YQP_AUTH_MSG'];
                                    });

      if (imageId && imageId != "") {
        var obj = {
          "id": imageId

        };
        //call service
        quickPayService.getImageById(obj).then(function (response) {
          userLandingVm.profileImageUrl = "data:image/jpeg;base64," + response.documentData;
          userLandingVm.isImageAvl = true;
        }, function (error) {
          //utilityService.showErrorMessage(error.responseMessage);
        });
      }
      if (!userLandingVm.isImageAvl) {
        var full_name = localStorage.getItem("customername");
        if (full_name != "" && full_name !== null) {
          var name_array = full_name.split(" ");
          var first_initial = name_array[0].charAt(0);
          var last_initial = name_array[name_array.length - 1].charAt(0);
          userLandingVm.customerNameInitials = first_initial + last_initial;
          userLandingVm.customerFirstName = full_name;
        }
        else {
          userLandingVm.customerNameInitials = "";
          userLandingVm.customerFirstName = "";
        }
      }   
    };


        userLandingVm.goToUserLogin = function () {
            loggedInUserService.shopNOrderPre=''; //Reset OMP value after login
            loggedInUserService.shopNOrderPreHash="";     
            internetBankingService.preHomeBanners().then(function(data){
				if(!utilityService.isUndefined(data)){	
                    userLandingVm.fastTagFlag=data.data.fastagFlag;
                    userLandingVm.HCheck = data.data.fastagFlagTempCode;
					if (userLandingVm.HCheck == cryptoService.getSHA512EncryptedData(userLandingVm.fastTagFlag).toString()) {
                        loggedInUserService.fastTagFlag=userLandingVm.fastTagFlag;
                    }
                    
                }
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
    
                });
            $state.go('menu.userLogin');
         }
         userLandingVm.userAuthPopoverTemplate = quickPayService.userAuthPopoverTemplate("","userLandingVm");
         $scope.popover = $ionicPopover.fromTemplate(userLandingVm.userAuthPopoverTemplate,{
          scope:$scope
         });
         
         
         $scope.openPopover = function($event){
           userLandingVm.authFailure = false;
          $scope.popover.show($event);

          userLandingVm.isFingerprintAvl = false;
                  userLandingVm.isFingerprintAvlDevice = false;

            quickPayService.isFingerprintAvailable().then(function (response) {
                        userLandingVm.isFingerprintAvlDevice = true;

                        var fingerprintToken = "";
                        cordova.plugins.SecureKeyStore.get(function (res) {
                              fingerprintToken = res;
                              if (fingerprintToken == null || fingerprintToken == "null" || fingerprintToken == undefined || fingerprintToken == "undefined" || fingerprintToken == "") {
                                    userLandingVm.isFingerprintAvl = false;
                              }
                              else {
                                    userLandingVm.isFingerprintAvl = true;
                                    //to auto populate fingerprint option
                                    userLandingVm.checkBiometric();
                              }
                        }, function (error) {
    
                        }, loggedInUserService.deviceInfo);
                  }, function (error) {
                  });
         };
    $scope.closePopover = function ($event) {
      $scope.popover.hide();
    };

    $scope.slideHasChanged = function (index) {
      $scope.currentSlide = index;
	//mpassbook related functionality added by GOC, Hyderabad
	    mpassbookdetailsService.selectedACNo = userLandingVm.accountList[index].accountNumber;
      mpassbookdetailsService.branchCode = userLandingVm.accountList[index].branchCode;
      //mpassbookdetailsService.goBackToState = "menu.userLanding";
      
	  // end of mpassbook functionality
    }
	//mpassbook related functionality added by GOC, Hyderabad
	userLandingVm.goMpassbook = function (index) {
	  mpassbookdetailsService.goBackToState = "menu.userLanding";
      $state.go('menu.mpassbookdetails');
    }
	// end of mpassbook functionality 

    $scope.pagerClick = function (index) {
      $ionicSlideBoxDelegate.slide(index);
      $scope.$apply();
    }

    $scope.goNext = function (index) {
      $ionicSlideBoxDelegate.next();
    }

    $scope.goPrev = function (index) {
      $ionicSlideBoxDelegate.previous();
    }

    $scope.$on('$destroy', function () {
      $scope.popover.remove();
    });

        
        userLandingVm.goToViewBalance = function($event){
      loggedInUserService.shopNOrderPre=''; //Reset OMP value after login  
      loggedInUserService.shopNOrderPreHash="";
      localStorage.setItem('isRedirectedTowdsLoan', "");
			localStorage.setItem('redirectOnlyFlow', "");
          userLandingVm.clickOn = 'view_balance';
          //if already authenticated then no need to show auth popup
            //alert('Coming Soon');return;
      if (!userLandingVm.viewbalAvl) {
            //userLandingVm.toggle.checked = false;
            userLandingVm.first = '';
        userLandingVm.second = '';
        userLandingVm.third = '';
        userLandingVm.fourth = '';
        userLandingVm.fifth = '';
        userLandingVm.sixth = '';
        $scope.clearMpin();
        userLandingVm.enabledThisInput(1);
        $scope.openPopover($event);
          }

          //dynamically adding background colour
          userLandingVm.popoverBbackdrop();
          
          
        }
        $scope.clearMpin = function () {
            $scope.doErase();
            $scope.doErase();
            $scope.doErase();
            $scope.doErase();
            $scope.doErase();
            $scope.doErase();
        }

      userLandingVm.popoverBbackdrop = function(){
        var backDrop = document.getElementsByClassName("popover-backdrop");
        if(backDrop && backDrop[0]){
          backDrop[0].setAttribute("style","background-color: rgba(0, 0, 0, 0.7) !important;");
        }
      }
        
    $scope.$on('popover.hidden', function () {
      //execute action
    });


    $scope.$on('popover.removed', function () {
      //execute action
    });

    userLandingVm.toggle = function () {
      $scope.hideKeyboard();
      if (userLandingVm.toggle.checked) {
          var userAuthModalICId = document.getElementById("userAuthModalICId");
        if (userAuthModalICId) {
            userAuthModalICId.setAttribute("style","bottom:0px !important;");
          }
      }
      else {

      }
    }
    

    userLandingVm.goToQuickPay = function ($event) {
      loggedInUserService.shopNOrderPre=''; //Reset OMP value after login 
      loggedInUserService.shopNOrderPreHash=""; 
      localStorage.setItem('isRedirectedTowdsLoan', "");
			localStorage.setItem('redirectOnlyFlow', "");
      userLandingVm.clickOn = 'quick_pay';
      afterUserAuthSuccess(false,$event);
    
    }

    userLandingVm.viewBalClose = function ($event) {

      userLandingVm.viewbalAvl = false;
      //to stop click event of outer div
      $event.stopPropagation();
    };
    

    userLandingVm.checkBiometric = function () {
      if (quickPayService.isFingerprintAviFlag && !userLandingVm.authfailure) {
        var encryptConfig = {
          clientId: "SBI YONO", //Android: Used for encryption. iOS: used for dialogue if no `localizedReason` is given.
          clientSecret: loggedInUserService.deviceInfo, //Necessary for Android encrpytion of keys. Use random secret key.
          disableBackup: true,

        };
        Fingerprint.show(encryptConfig, successCallback, errorCallback);
      }
    }

    function successCallback() {
      authByBiometric();
      /*if (result.withFingerprint) {
        //call service to Auth
        authByBiometric();
      } else if (result.withBackup) {
        //call service to retrieve token at adapter

      }
      else if (result == 'Success') {
        //call service to Auth
        authByBiometric();
      }*/
    }

    function authByBiometric() {
      if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (userLandingVm.isSimChanged || userLandingVm.simList == undefined || userLandingVm.simList.length == 0)) {
        if (userLandingVm.isSimChanged) {
          registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
        }
        //utilityService.showBhimUpiAlert("alert", registerWithSimService.changedSimMsg);
        else if (userLandingVm.simList == undefined || userLandingVm.simList.length == 0)
          utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
        return;
      }
      var hasedSimInfo = "";
				if(utilityService.isAndroidPlatform()){
					hasedSimInfo = userLandingVm.hasedSimInfo;
				}
      var params = { 'type': 'biometric', "simId": hasedSimInfo.toString()};
      //call service to retrieve token at adapter
      quickPayService.userAuthentication(params).then(function (data) {
        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYBIOSUCCESS"));
        if(userLandingVm.clickOn == 'quick_pay'){
            userLandingVm.isUserAuthQuickPay = true;
          }
        afterUserAuthSuccess(data);
      }, function (error) {
        userLandingVm.authFailure = true;
        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYBIOFAIL"));
        if (error.responseCode == "SB001" || error.responseCode == "F001") {
          registerWithSimService.reloadAppSimOk(error.responseMessage);
        }else if(error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
            userLandingVm.authFailure = false;
            utilityService.showForcePasswordPopup(error.responseMessage,"");
        }
        else {
          quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { userLandingVm.authFailure = false; });
        }


      });
    }
    function errorCallback(error) {
      
    }

    //one time initialization to be done when the controller is loaded
    $scope.$on('$ionicView.loaded', function () {
      initPage();
      navigator.splashscreen.hide();
    });


    $scope.$on('$ionicView.beforeEnter', function () {
        userLandingVm.simSubscriptionId = "";
      userLandingVm.hasedSimInfo = "";
      userLandingVm.simList = [];
      userLandingVm.isSimChanged = false;
      homeScreenService.preLoginYonoCash=false;
      loggedInUserService.shopNOrderPre=''; //Reset OMP value after login  
      loggedInUserService.shopNOrderPreHash="";
      $scope.slideUpTrue=false; //YONO_SPLASH
      $scope.slideDownTrue=true; //YONO_SPLASH
      userLandingVm.authFailure = false;
      //userLandingVm.viewbalAvl = quickPayService.viewbalAvl;
      userLandingVm.isUserAuthQuickPay = false;
      //Check device is locked or not, depend on that go to User ID tab as default
			userLandingVm.keyguardValue = internetBankingService.checkKeyguardValue;
      userLandingVm.showViewBalance = $stateParams.showViewBalance ? true : false;
      userLandingVm.viewbalAvl = userLandingVm.showViewBalance && quickPayService.viewbalAvl;

     if (utilityService.isAndroidPlatform()) {
                            utilityService.showSpinner();
                            readSimcardInfo();
                        }      userLandingVm.bgimg = "";
      if (internetBankingService.banners.landing.length > 0) {
        userLandingVm.bgimg = internetBankingService.banners.landing[0].imageURL;
        userLandingVm.findOutMoreUrl = internetBankingService.findOutMoreUrl;

      } else {
        internetBankingService.preHomeBanners().then(function (response) {

          internetBankingService.banners = response.data.banners;
          internetBankingService.findOutMoreUrl = response.data.findOutMoreUrl;
          userLandingVm.bgimg = internetBankingService.banners.landing[0].imageURL;
          userLandingVm.findOutMoreUrl = internetBankingService.findOutMoreUrl;

        }, function (error) {
          userLandingVm.bgimg = "../www/img/login/banner_yc.jpg";
          internetBankingService.findOutMoreUrl = "";
          userLandingVm.findOutMoreUrl = "";
        });
      }
    });
    function readSimcardInfo() {
                /*Sim card Info fetching - Start*/
                function simInfosuccessCallback(result) {
                    utilityService.hideSpinner();
                    console.log(result);
					var str = "";
          userLandingVm.isSimChanged = false;
					if(result.cards && result.cards.length > 0)
                    {
                        userLandingVm.simList = result.cards;
						var isAccountExists = -1;
						userLandingVm.simList.some(function (obj, i) {
							return obj.subscriptionId == registerWithSimService.simSubscriptionId ? isAccountExists = i : false;
						});
						if (isAccountExists !== -1) {
							str = device.uuid + registerWithSimService.simSubscriptionId;
							userLandingVm.simSubscriptionId = registerWithSimService.simSubscriptionId;
							userLandingVm.hasedSimInfo = cryptoService.getSHA512EncryptedData(str);
						}
						else{
							//either sim card is removed or slot changed or subscription id changed due to sim changes
              userLandingVm.isSimChanged = true;
							userLandingVm.simSubscriptionId = "";
						}
                    }
					if (userLandingVm.simList == undefined || userLandingVm.simList.length == 0) {
                      utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
                    }
              ompOffersService.isSimChangedForOmpPreLogin = userLandingVm.isSimChanged;
              ompOffersService.hasedSimInfoForOmpPreLogin = userLandingVm.hasedSimInfo;
              ompOffersService.simSubscriptionIdForOmpPreLogin = userLandingVm.simSubscriptionId;
              ompOffersService.simListForOmpPreLogin = userLandingVm.simList;
                    $scope.$apply();
                }

                function HasPerminionSuccessCallback(result) {
                    if (result) {
                        window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallbackSim);
                    } else {
                        requestReadPermission();
                    }
                }

                function errorCallbackSim(error) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("Permission denied.");
                }

                function requestSuccessCallback(result) {
                    if (result) {
                        hasReadPermission();
                    }
                }
                // Android only: check permission
                function hasReadPermission() {
                    window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallbackSim);
                }
                // Android only: request permission
                function requestReadPermission() {
                    window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallbackSim);
                }
                hasReadPermission();
                /*Sim card Info fetching - End*/
            }
    userLandingVm.updateToStore = function () {
      utilityService.upgradeApp()
    }

    userLandingVm.exitForUpdateApp = function () {
      ionic.Platform.exitApp();
      navigator.app.exitApp();
    }

    $scope.$on('$ionicView.afterEnter', function () {
      if (loggedInUserService.appOutdateFlag) {
        var message = $filter('limitTo')(loggedInUserService.appOutdateMessage, 180);
        var exitAppButton = utilityService.isAndroidPlatform() ? '<button class="btn exitBtn" ng-click="userLandingVm.exitForUpdateApp()">Exit</button>' : '';
        userLandingVm.appUpdatePopup = $ionicPopup.show({
          template: '<div class="popup-body"><div class="appUpdateContainer"><img class="appUpdateLogo" src="img/OMP/appUpdate.svg" alt="App update Logo"/></div><div class="appUpdateHeading">App Update Available</div><div class="appUpdateInfo">' + message + '</div><button class="btn updateAppBtn marginBottom4" ng-click="userLandingVm.updateToStore()">Update</button>'+ exitAppButton + '</div></p>',
          title: '',
          scope: $scope,
          cssClass: 'app-update-popup'
        });
        var elem = angular.element(document.querySelector(".backdrop"));
        if (elem) {
          elem.addClass('app-update-backdrop');
        }
      }
    });


    userLandingVm.loginWithMpin = function () {
      if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (userLandingVm.isSimChanged || userLandingVm.simList == undefined || userLandingVm.simList.length == 0)) {
        if (userLandingVm.isSimChanged) {
          registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
        }
        //utilityService.showBhimUpiAlert("alert", registerWithSimService.changedSimMsg);
        else if (userLandingVm.simList == undefined || userLandingVm.simList.length == 0)
          utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
        return;
      }
      var newMpin = userLandingVm.first.trim() +
        userLandingVm.second.trim() +
        userLandingVm.third.trim() +
        userLandingVm.fourth.trim() +
        userLandingVm.fifth.trim() +
        userLandingVm.sixth.trim();
      //var newMpin = userLandingVm.setpassword;;
      if (newMpin.length == 6) {
        if (ConnectivityMonitorUtils.isOffline()) {
          userLandingVm.first = '';
          userLandingVm.second = '';
          userLandingVm.third = '';
          userLandingVm.fourth = '';
          userLandingVm.fifth = '';
          userLandingVm.sixth = '';
          $scope.clearMpin();
          //userLandingVm.enabledThisInput(1);
          /*login flow improvement*/
          var inputElement = document.getElementById('InputTxt1');
          inputElement.disabled = false;
          utilityService.offlineAlert();
          return;
        }
        var hasedSimInfo = "";
				if(utilityService.isAndroidPlatform()){
					hasedSimInfo = userLandingVm.hasedSimInfo;
				}
        var requestParams = {
          "mPinNumber": newMpin,
          "type" : "mpin",
          "simId": hasedSimInfo.toString(),
          "simSubId" : userLandingVm.simSubscriptionId
        };

        
        quickPayService.userAuthentication(requestParams).then(function (data) {
          clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYMPINSUCCESS"));
          $scope.hideKeyboard();
          
          if(userLandingVm.clickOn == 'quick_pay'){
            userLandingVm.isUserAuthQuickPay = true;
          }
          afterUserAuthSuccess(data);
          userLandingVm.first = '';
        userLandingVm.second = '';
        userLandingVm.third = '';
        userLandingVm.fourth = '';
        userLandingVm.fifth = '';
        userLandingVm.sixth = '';
          $scope.passLenLimitReached = false;
        $scope.clearMpin();
        }, function (error) {
          $scope.passLenLimitReached = false;
          userLandingVm.first = '';
          userLandingVm.second = '';
          userLandingVm.third = '';
          userLandingVm.fourth = '';
          userLandingVm.fifth = '';
          userLandingVm.sixth = '';
          $scope.clearMpin();
          userLandingVm.enabledThisInput(1);
          userLandingVm.authFailure = true;
          clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYMPINFAIL"));
          if (error.responseCode == "SB001" || error.responseCode == "F001") {
            registerWithSimService.reloadAppSimOk(error.responseMessage);
          }else if(error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
              userLandingVm.authFailure = false;
              utilityService.showForcePasswordPopup(error.responseMessage,"");
          }
          else {
            quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { userLandingVm.authFailure = false; });
          }
                
        });
        
      } else {
        userLandingVm.first = '';
        userLandingVm.second = '';
        userLandingVm.third = '';
        userLandingVm.fourth = '';
        userLandingVm.fifth = '';
        userLandingVm.sixth = '';
        $scope.clearMpin();
        userLandingVm.enabledThisInput(1);
        userLandingVm.authFailure = true;
        //utilityService.showErrorMessage('Please Enter 6 digit valid MPIN');
        quickPayService.showAuthFailurePopup('error', 'Please Enter 6 digit valid MPIN','','','OK','',$scope,true, function () { userLandingVm.authFailure = false; });
      }
    };

    userLandingVm.changeInput = function ($event, index) {

      cordova.plugins.Keyboard.close();
      /*login flow improvements*/
      if (loggedInUserService.isServerConnected) {
        userLandingVm.loginWithMpin();
      } else {
        //connectServer();
      }
 
    }

    userLandingVm.enabledThisInput = function (index) {
      try {
        userLandingVm.mpinErrorMsgFlag = false;
        for (var i = 1; i <= 6; i++) {
          var inputElement = document.getElementById('InputTxt' + i);
          if (index == i) {
            inputElement.disabled = false;
            inputElement.style = "border-bottom:1px solid #0095da !important;"
          } else {
            inputElement.disabled = true;
            inputElement.style = "border-bottom:1px solid #bcbebf !important;"
          }
        }
      } catch (err) { }
    }


    userLandingVm.authenticate = function () {
      if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (userLandingVm.isSimChanged || userLandingVm.simList == undefined || userLandingVm.simList.length == 0)) {
        if (userLandingVm.isSimChanged) {
          registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
        }
        //utilityService.showBhimUpiAlert("alert", registerWithSimService.changedSimMsg);
        else if (userLandingVm.simList == undefined || userLandingVm.simList.length == 0)
          utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
        return;
      }
      userLandingVm.userLoginErrorFlag = false;
      userLandingVm.isLoginBtnClicked = true;
      if (userLandingVm.userName && userLandingVm.password) {
        userLandingVm.isLoginBtnClicked = false;
        utilityService.showSpinner();
        internetBankingService.getServiceIdAndKey().then(function (data) {
          loggedInUserService.keyIdINB = data.keyId;
          loggedInUserService.serviceIdINB = data.serviceId;
          loggedInUserService.finalSHA512Val = loggedInUserService.generateINBSHA512Val(userLandingVm.userName, userLandingVm.password);
          utilityService.hideSpinner();
          userLandingVm.userloginStart();
        }, function (error) {
          userLandingVm.userName = '';
          userLandingVm.password = '';
          utilityService.hideSpinner();
          userLandingVm.authFailure = true;
          if (error.responseMessage) {
            //utilityService.showErrorMessage(error.responseMessage);
            quickPayService.showAuthFailurePopup('error', error.responseMessage,'','','OK','',$scope,true, function () { userLandingVm.authFailure = false; });
          } else {
            //utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
            quickPayService.showAuthFailurePopup('error', constantConfig.adapter.CANNOT_PROCESS_NOW,'','','OK','',$scope,true, function () { userLandingVm.authFailure = false; });
          }
        });
      }
    }

    userLandingVm.userloginStart = function(){
      var hasedSimInfo = "";
				if(utilityService.isAndroidPlatform()){
					hasedSimInfo = userLandingVm.hasedSimInfo;
				}
      var requestParams = {
        "userName": userLandingVm.userName,
        "sha512Password": loggedInUserService.finalSHA512Val,
        "type" : "username",
        "simId": hasedSimInfo.toString()
      };
      quickPayService.userAuthentication(requestParams).then(function (data) {
        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYUSERNAMESUCCESS"));
          $scope.hideKeyboard();
          userLandingVm.userName = "";
          userLandingVm.password = "";
          
          if(userLandingVm.clickOn == 'quick_pay'){
            userLandingVm.isUserAuthQuickPay = true;
          }
          afterUserAuthSuccess(data);
      }, function (error) {
        userLandingVm.authFailure = true;
        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYUSERNAMEFAIL"));
        if (error.responseCode == "SB001" || error.responseCode == "F001") {
          registerWithSimService.reloadAppSimOk(error.responseMessage);
        }
        else if(error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
            userLandingVm.authFailure = false;
            utilityService.showForcePasswordPopup(error.responseMessage,"");
        }
        else {
          quickPayService.showAuthFailurePopup('error', error.responseMessage, '', '', 'OK', '', $scope, true, function () { userLandingVm.authFailure = false; });
        }


      });
    }

    function afterUserAuthSuccess(data,$event){
      if(data){
      quickPayService.customerInfo = data;
      quickPayService.yqpBiometricLimit = quickPayService.customerInfo.yqpBiometricLimit;
      quickPayService.yqpVpaLimit = quickPayService.customerInfo.yqpVpaLimit;
      quickPayService.yqpBeneficiaryLimit = quickPayService.customerInfo.yqpBeneficiaryLimit;
      quickPayService.yqpRaiseRequestLimit = quickPayService.customerInfo.yqpRaiseRequestLimit;
      localStorage.setItem('customerImageId', quickPayService.customerInfo.customerInformation.imageUrl);
      }
        var isBiometricSet = localStorage.getItem("isBiometricSet");
        if(isBiometricSet == undefined || isBiometricSet == "false"){
        isBiometricSet = false;
      }
      else{
        isBiometricSet = true;
      }

        var isMpinSet = loggedInUserService.mpinConsent;
        var customerInfo = quickPayService.customerInfo;
        
        userLandingVm.viewbalAvl = false;
        quickPayService.viewbalAvl = false;
        if (userLandingVm.clickOn == 'view_balance') {

          userLandingVm.accountList = customerInfo.accounts;
		//mpassbook related functionality added by GOC, Hyderabad
        mpassbookdetailsService.selectedACNo ="";
        mpassbookdetailsService.branchCode ="";
        mpassbookdetailsService.goBackToState ="";
		    mpassbookdetailsService.selectedACNo = userLandingVm.accountList[0].accountNumber;
        mpassbookdetailsService.branchCode = userLandingVm.accountList[0].branchCode;
        //mpassbookdetailsService.goBackToState = "menu.userLanding";

		//end of mpassbook functionality

          var viewBalSkipCount = localStorage.getItem("viewBalSkipCount");
          //viewBalSkipCount = 0;
          if (!viewBalSkipCount) {
            viewBalSkipCount = 0;
          }


          var isPrimarySet = false;
          if (viewBalSkipCount < 2) {
            $state.go('menu.viewBalanceSetUp');
              userLandingVm.viewbalAvl = true;
              quickPayService.viewbalAvl = true;
              $scope.popover.hide();
          }
          else {
            userLandingVm.viewbalAvl = true;
            quickPayService.viewbalAvl = true;
            $scope.popover.hide();
          }
        }
        else {
          //clear service variables here
          quickPayService.clearVariables();

          var isPrimarySet = false;
          if(data){
          if (customerInfo.customerInformation.accountNumber && customerInfo.customerInformation.accountNumber != '') {
            isPrimarySet = true;
          }
          else {
            isPrimarySet = false;
          }
          }
          if(isBiometricSet){

                  quickPayService.isFingerprintAvailable().then(function (response) {
                       isBiometricSet = true;
                       quickPayRedirection(isBiometricSet,isMpinSet,isPrimarySet,data,$event);
                  }, function (error) {
                    isBiometricSet = false;
                    quickPayRedirection(isBiometricSet,isMpinSet,isPrimarySet,data,$event);
                        //utilityService.showErrorMessage(error.responseMessage);
                  });
          }
          else{
            quickPayRedirection(isBiometricSet,isMpinSet,isPrimarySet,data,$event);
          }

        }

    }
    function quickPayRedirection(isBiometricSet, isMpinSet, isPrimarySet, data, $event) {
      if (isMpinSet) {
        $state.go('menu.quickPayPreAuth');
      }
      else {
        //open popover for authentication
        if (userLandingVm.isUserAuthQuickPay) {
          $scope.popover.hide();
          $state.go('menu.quickPaySetUp');
        }
        else {
          $scope.openPopover($event);
        }
      }
    }
    userLandingVm.openVideo = function(){
      if(userLandingVm.findOutMoreUrl != '' && userLandingVm.findOutMoreUrl != undefined)
      {
        $scope.videoUrl=userLandingVm.findOutMoreUrl;
					 $scope.trustSrcVideo = function(videoUrl){
						 return  $sce.trustAsResourceUrl(videoUrl)
				}
				var videopopup=$ionicPopup.alert({
			 title: '',
			 templateUrl: 'pages/quickPay/howDoIVideoPopup.html',
			 scope: $scope,
			 cssClass: 'dialog',
			 buttons: [
				 {
				   text: 'Close',
					  onTap: function(e) {
							videopopup.close();
						//$state.go('menu.howDoIVideoPopup');
					  }
				}
			 ]
		   });
        //  cordova.ThemeableBrowser.open(userLandingVm.findOutMoreUrl, '_blank',
				//   {
				// 	  statusbar: {
				// 		  color:'#ffffffff'
				// 	  },
				// 	  toolbar: {
				// 		  height: 37,
				// 		  color: '#ffffffff',
				// 		  image: 'share'
				// 	  },

				// 	  closeButton: {
				// 		  image:'back',
				// 		  height: 37,
				// 		  width: 32,
				// 		  align: 'left',
				// 		  event: 'closePressed'
				// 	  },

				// 	  backButtonCanClose: true
				//   });
          //ompMerchantsService.inChromeBrowser(userLandingVm.findOutMoreUrl);
      }
      
    }
    
      /*Custom Keypad for MPIN*/
    


    $scope.password = '';
    $scope.canErase = false;
    $scope.pinDotVisible = {};
    $scope.success = null;
    $scope.keyboardVisible = false;
    $scope.pinArray = [];

    $scope.keyboardSettings = {
      // settings here
      action: function (number) {
        if ($scope.password.length < 6) {
          $scope.password += number;
          $scope.pinArray.push(number);
          $scope.pinDotVisible[$scope.password.length] = true;
          $scope.canErase = true;
          $scope.success = null;
          var pass = $scope.password;
          pass = pass.split("");
          try {
            userLandingVm.first = pass[0];
            userLandingVm.second = pass[1];
            userLandingVm.third = pass[2];
            userLandingVm.fourth = pass[3];
            userLandingVm.fifth = pass[4];
            userLandingVm.sixth = pass[5];
          } catch (err) { }

        }
        if ($scope.password && $scope.password.length === 6 && $scope.passLenLimitReached == false) {
          $scope.passLenLimitReached = true;
          var e = {};
          $scope.newMpin = $scope.password;
          var pass = $scope.password;
          pass = pass.split("");
          try {
            userLandingVm.first = pass[0];
            userLandingVm.second = pass[1];
            userLandingVm.third = pass[2];
            userLandingVm.fourth = pass[3];
            userLandingVm.fifth = pass[4];
            userLandingVm.sixth = pass[5];
            var e = {};
            e.srcElement = {};
            e.srcElement.value = 2;
            userLandingVm.changeInput(e, 6);
          } catch (err) { }
        }
      },

      // Clear
      leftButton: {
        html: '<i class="icon ion-backspace"></i>',
        action: function () {
          $scope.doErase();
        },
        style: {
          bgColor: '#fff',
          activeBgColor: '#dfdfdf',
          borderColor: '#dfdfdf',
          fontSize: '20px'
        }
      },

      // Submit login
      rightButton: {
        html: '<i class="icon ion-eye"></i> <i class="icon ion-eye-disabled login-eye-btn" ></i>',
        //html: '<i id="eyeElement" class="icon ion-eye"></i>',
        action: function () {
          //$scope.hideKeyboard();
          if ($scope.isPassVisible) {
            var elementHide = document.getElementsByClassName("ion-eye-disabled")[0];
            elementHide.classList.add("login-eye-btn");
            var elementShow = document.getElementsByClassName("ion-eye")[0];
            elementShow.classList.remove("login-eye-btn");

            $scope.isPassVisible = false;
          } else {
            $scope.isPassVisible = true;
            var elementHide = document.getElementsByClassName("ion-eye")[0];
            elementHide.classList.add("login-eye-btn");
            var elementShow = document.getElementsByClassName("ion-eye-disabled")[0];
            elementShow.classList.remove("login-eye-btn");
          }
        },
        style: {
          bgColor: '#fff',
          activeBgColor: '#dfdfdf',
          borderColor: '#dfdfdf',
          fontSize: '30px'
        }
      }
    }

    $scope.doErase = function () {
      $scope.pinDotVisible[$scope.password.length] = false;
      $scope.password = $scope.password.slice(0, -1);
      if ($scope.password.length == 0) $scope.canErase = false;
      try {
        var pass = $scope.password;
        pass = pass.split("");
        userLandingVm.first = pass[0] ? pass[0] : "";
        userLandingVm.second = pass[1] ? pass[1] : "";
        userLandingVm.third = pass[2] ? pass[2] : "";
        userLandingVm.fourth = pass[3] ? pass[3] : "";
        userLandingVm.fifth = pass[4] ? pass[4] : "";
        userLandingVm.sixth = pass[5] ? pass[5] : "";
      } catch (err) { }
    }



    $scope.unmask = function () {

    }

    $scope.rightAction = function () {
      pinDotVisible[0] = false;
      pinDotVisible[1] = false;
      pinDotVisible[2] = false;
      pinDotVisible[3] = false;
      pinDotVisible[4] = false;
      pinDotVisible[5] = false;
    }

    $scope.showKeyboard = function () {
      $scope.keyboardVisible = true;
    }

    $rootScope.hidekeypad = function ($event) {
      switch ($event.target.className) {
        case "mpin1 activated":
        // code block

        case "digit-keyboard-key":
        // code block

        case "digit-keyboard-key-action ng-binding":
        // code block

        case "icon ion-record":
        // code block

        case "digit-keyboard-key activated":
        // code block

        case "icon ion-backspace":
        // code block

        case "mpin1 ng-pristine ng-untouched ng-valid ng-empty activated":
        // code block

        case "mpin1 ng-binding":
        // code block

        case "icon ion-eye-disabled login-eye-btn":
        // code block

        case "icon ion-eye login-eye-btn":
        // code block

        case "digit-keyboard-key-number":
          // code block
          if (!$scope.keyboardVisible) {
            $scope.showKeyboard();
          }
          break;
        default:
          // code block
          if ($scope.keyboardVisible) {
            $scope.hideKeyboard();
          }
          break;
      }
    }

    $scope.hideKeyboard = function () {
      $scope.keyboardVisible = false;
    }

    /*End of Custom Keypad for MPIN*/
    
  /** YONO Splash starts here */
$scope.showHideDrawer=function(slideFlow){
  if(slideFlow){
    $scope.slideDownTrue=false;
    $scope.slideUpTrue=true;
  }else{
    $scope.slideUpTrue=false;
    $scope.slideDownTrue=true;
  }
 
}
$scope.showDrawer=function(){
    $scope.slideDownTrue=false;
    $scope.slideUpTrue=true;
}
$scope.hideDrawer=function(){
  $scope.slideUpTrue=false;
  $scope.slideDownTrue=true;
}
$scope.downloadOfferPage =function(){
    localStorage.setItem('isRedirectedTowdsLoan', "");
	localStorage.setItem('redirectOnlyFlow', "");
    ompMerchantsService.inChromeBrowser(userLandingVm.pdfUrl); 
}
$scope.goToInvestment=function(){
      localStorage.setItem('isRedirectedTowdsLoan', "");
			localStorage.setItem('redirectOnlyFlow', "");
            loggedInUserService.productClicked='menu.leadGenerationInvestment';
      loggedInUserService.isFirstLogin=true;
 
            $state.go('menu.leadGenerationInvestment');
}
$scope.gotToYonoCash=function(){
  localStorage.setItem('isRedirectedTowdsLoan', "");
	localStorage.setItem('redirectOnlyFlow', "");
  homeScreenService.isBackCheck = true;
  homeScreenService.preLoginYonoCash = true;
  loggedInUserService.isFirstLogin=true;
  loggedInUserService.productClicked = 'menu.homeScreen'; // 'menu.yonoCash';
  $state.go('menu.userLogin');
}
$scope.gotToShopNOrder=function(){
  localStorage.setItem('isRedirectedTowdsLoan', "");
	localStorage.setItem('redirectOnlyFlow', "");
  homeScreenService.preLoginYonoCash = false;
  homeScreenService.irctcCallAfterSuccLogin = false;
  homeScreenService.automallCallAfterSuccLogin = false;
  homeScreenService.automobileCallAfterSuccLogin = false;
  loggedInUserService.isFirstLogin=true;
  loggedInUserService.shopNOrderPre="1";
  $state.go('menu.ompMerchants');
}
$scope.gotToBestOffers=function(){
  localStorage.setItem('isRedirectedTowdsLoan', "");
	localStorage.setItem('redirectOnlyFlow', "");
  loggedInUserService.shopNOrderPre="1";
  homeScreenService.categoryCode='OMPBO60';
  homeScreenService.storeSelected='Best Offer';
  clickStreamService.clickStreamData = "websiteId," +  homeScreenService.categoryCode;
  homeScreenService.preLoginYonoCash = false;
  homeScreenService.irctcCallAfterSuccLogin = false;
  homeScreenService.automallCallAfterSuccLogin = false;
  homeScreenService.automobileCallAfterSuccLogin = false;
  loggedInUserService.isFirstLogin=true;
  $state.go('menu.merchantList');
}

        $scope.insurancePage=function(){
      localStorage.setItem('isRedirectedTowdsLoan', "");
			localStorage.setItem('redirectOnlyFlow', "");
      loggedInUserService.productClicked='menu.leadGenerationInsurance';
      loggedInUserService.isFirstLogin=true;
      $state.go('menu.leadGenerationInsurance');
 
      }

  /** YONO Splash ends here */
    return this;
  }

]);


