'use strict';
angularApp.controller('createRdController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"customerInfoService",
		"rdService",
		"blockUnblockService",
		"getAccountDetailsService",
	"homeScreenService",
	function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, customerInfoService, rdService, blockUnblockService, getAccountDetailsService, homeScreenService) {
			
			var createRdVm = this;

			createRdVm.indexId = 0;
			
			function initPage() {
			createRdVm.isBackCheck = homeScreenService.isBackCheck;
			homeScreenService.isBackCheck = false;
				// createRdVm.showBack = false;
				// createRdVm.showNext = true;
				createRdVm.showBack = false;
				createRdVm.showNext = true;
				createRdVm.disablenext = true;
				createRdVm.disableconfirm = true;
				createRdVm.isValidError = false;
				createRdVm.validErrorMessage = "";
				createRdVm.isValidAccount = false;
				createRdVm.validAccountMessage = "";
				createRdVm.selectedDataLimit =false;
				createRdVm.multiple_ten_flag = false;
				createRdVm.selectYearValueValid = false;

				$translate(['SAVING_INFO', 'AMOUNT', 'DEPOSIT_FROM', 'TAX_SAVER', 'FIXED_DEPOSIT', 'AMOUNT_COMPARE', 'SENIOR_CITIZEN', 'SELECT_ACCOUNT', 'FDINFOMSG', 'FDINFOMSG_NEXT', 'FDINFOMSG_DOWN', 'AMOUNT_LIMIT', 'SENIOR_AMOUNT_LIMIT', 'TAX_AMOUNT', 'SENIOR_TAX_AMOUNT', 'INACTIVE_ACCOUNT', 'NO_TRANS_RIGHTS','ACC_TRANS_RIGHTS','FETCH_TRANS_RGTS']).then(function (translations) {
					createRdVm.fixedDeposit = translations['SAVING_INFO'];
					createRdVm.amount = translations['AMOUNT'];
					createRdVm.depositFrom = translations['DEPOSIT_FROM'];
					createRdVm.taxSaver = translations['TAX_SAVER'];
					createRdVm.fdTitle = translations['FIXED_DEPOSIT'];
					createRdVm.amtCmperror = translations['AMOUNT_COMPARE'];
					createRdVm.seniorCitizen = translations['SENIOR_CITIZEN'];
					createRdVm.selectedAccount = translations['SELECT_ACCOUNT'];
					createRdVm.amountinfofd = translations['FDINFOMSG'];
					createRdVm.amountinfotsfd = translations['FDINFOMSG_NEXT'];
					createRdVm.taxsaverinfo = translations['FDINFOMSG_DOWN'];
					createRdVm.normalAmountLimit = translations['AMOUNT_LIMIT'];
					createRdVm.senioramountLimit = translations['SENIOR_AMOUNT_LIMIT'];
					createRdVm.taxAmounLimit = translations['TAX_AMOUNT'];
					createRdVm.seniorTaxAmounLimit = translations['SENIOR_TAX_AMOUNT'];
					createRdVm.activeAccount = translations['INACTIVE_ACCOUNT'];
					createRdVm.transactionRights = translations['NO_TRANS_RIGHTS'];
					createRdVm.accTransRights = translations['ACC_TRANS_RIGHTS'];
					createRdVm.fetchTransRights = translations['FETCH_TRANS_RGTS'];
				});
			};

			


			createRdVm.getInfomessage = function (createRdVm) {
				fixedDepositService.fetchInfoMessage(createRdVm).then(function (data) {
					if (data.message) {
						createRdVm.amountInfoMeesage = data.message;
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			createRdVm.infoPopup = function ($event) {
				$ionicPopover.fromTemplateUrl('pages/recurringDeposite/createRd/popover.html', {
					scope: $scope
				}).then(function (popover) {
					if (createRdVm.isTaxable) {
						createRdVm.action = "amountToSaveFd";
					} else {
						createRdVm.action = "amountToSaveTsfd"
					}
					createRdVm.getInfomessage(createRdVm);
					$scope.popover = popover;
					$scope.popover.show($event);
				});
			};

			createRdVm.closePopover = function () {
				$scope.popover.hide();
			};

			createRdVm.getInfomessageTax = function (createRdVm) {
				fixedDepositService.fetchInfoMessage(createRdVm).then(function (data) {
					if (data.message) {
						createRdVm.taxInfoMeesage = data.message;
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			createRdVm.infoPopupFD = function ($event) {
				$ionicPopover.fromTemplateUrl('pages/recurringDeposite/createRd/popoverFD.html', {
					scope: $scope
				}).then(function (popover) {
					createRdVm.action = "FDToBeAtaxSaverFd";
					createRdVm.getInfomessageTax(createRdVm);
					$scope.popover = popover;
					$scope.popover.show($event);
				});
			};

			createRdVm.infoPopupFDSC = function ($event) {
				$ionicPopover.fromTemplateUrl('pages/recurringDeposite/createRd/popoverFDSC.html', {
					scope: $scope
				}).then(function (popover) {
					$scope.popover = popover;
					$scope.popover.show($event);
				});
			};

		createRdVm.selectedAccountFunRdSave = function (e) {
			if (createRdVm.selectedValueYear == 10) {
				createRdVm.selectedValueMonth = "0";
				createRdVm.selectYearValueValid = true;
			} else {
				createRdVm.selectYearValueValid = false
			}
			if(createRdVm.selectedValueYear && e === 'year' && !createRdVm.selectedValueMonth){
				createRdVm.selectedValueMonth = "0";
			}

				if (createRdVm.selectedValueYear != "" && createRdVm.selectedValueYear != undefined && createRdVm.selectedValueMonth != "" && createRdVm.selectedValueMonth && createRdVm.scheduleDate != "") {
					createRdVm.disableconfirm = false;

					var endDate = new Date();
					var getyear = createRdVm.selectedValueYear;
					var getMonth = createRdVm.selectedValueMonth;
					// var months = endDate.getMonth() + parseInt(getMonth);
					var months = parseInt(getMonth);
					var years = (endDate.getFullYear() + parseInt(getyear)) - endDate.getFullYear();
					var finalMonth = endDate.setMonth(endDate.getMonth() + parseInt(getMonth));
					var finalYear = endDate.setFullYear(endDate.getFullYear() + parseInt(getyear));
					var finalDate = endDate.toISOString().slice(0,10);

					rdService.createRdData.years = years;
					rdService.createRdData.months = months;
					rdService.createRdData.siDate = createRdVm.scheduleDate;
					rdService.createRdData.iRate = createRdVm.iRateRdSave;
					rdService.createRdData.tensure = ((parseInt(years)*12) + parseInt(months));
					// console.log(getAccountDetailsService.accountOverviewData)
					var obj = {
						// "dob": customerInfoService.customer.DOB,
						"dob": "",
						"endDate": finalDate,
						"tenure": rdService.createRdData.tensure,
						"installmentAmount": rdService.createRdData.monthControAmount,
						"amount": rdService.selectedDetails.accountBalance,
						"siDate": createRdVm.scheduleDate,
						"accountNumber": rdService.selectedDetails.accountNumber,
						"pfNumber": getAccountDetailsService.accountOverviewData.customerInformation.pfNumber,
						"customerType": getAccountDetailsService.accountOverviewData.customerInformation.customerType,
						"panNumber": "",
						"accountTypeCode": "",
						"intCategory": "",
						"startDate": "",
						"isSenior": rdService.customer.isSenior,
					}
					console.log(obj)
					rdService.checkPreEvaluation(obj).then(function(data) {
						createRdVm.mDateRdSave = data.maturityDate;
						createRdVm.iRateRdSave = data.interestRate;
						rdService.createRdData.maturityDate = data.maturityDate;
						rdService.createRdData.maturityAmount = data.maturityAmount;
						rdService.createRdData.iRate = data.interestRate;
						rdService.createRdData.nightModeFlag = data.nightMode;
						createRdVm.showMaturityAndIRate = true;
					},function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					createRdVm.disableconfirm = true;
					createRdVm.showMaturityAndIRate = false;
				}

			};

			createRdVm.selectedAccountFun = function () {
				if (createRdVm.selectedValue) {
					var data = createRdVm.selectedValue.split(",");
					var e = [];
					e.accountNumber = data[0];
					e.accountBalance = data[1];
					e.accountType = data[2];
					e.indexId = data[3];
					e.nreFlag = data[4];
					createRdVm.indexId = e.indexId;
					rdService.customer.indexId = createRdVm.indexId;
					createRdVm.selectedAccountType = e.accountType;
					createRdVm.selectedAccountNumber = e.accountNumber;
					createRdVm.selectedAccountAmount = e.accountBalance;
					rdService.customer.selectedItem = e.accountNumber;
					rdService.selectedDetails.accountBalance = e.accountBalance;
					rdService.selectedDetails.productCodeNRI = e.nreFlag;
					rdService.customer.nominee = "";

					var account_number = e.accountNumber;
					rdService.createRdData.accountNumberCreate = e.accountNumber;
					rdService.selectedDetails.accountNumber = e.accountNumber;

					if (rdService.selectedDetails.productCodeNRI == "TRUE") {
						createRdVm.isSenior = false;
						createRdVm.seniorWithNRI = true;
						rdService.customer.isSenior = false;
					}
				}
				createRdVm.changeAmount();
			};

			/* validation for amount field */
			createRdVm.getCBValue = function (isChecked) {
				if (isChecked === true) {
					createRdVm.isTaxable = true;
					if (fixedDepositService.customer.isPanAvailable === "" || fixedDepositService.customer.isPanAvailable === undefined || fixedDepositService.customer.isPanAvailable === null) {
						var title = '';
						var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PAN4" "></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="PAN1"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PAN2"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PAN3"></div>';
						var onTap = 'menu.fixedDeposit';
						rdService.showAlertModal(title, template, onTap, $scope, $state);
						createRdVm.isTaxable = false;
					}
				} else {
					createRdVm.isTaxable = false;
				}
				rdService.customer.isTaxable = createRdVm.isTaxable;
				createRdVm.changeAmount();
			};

			/* change event for senior citizen check box */
			createRdVm.getSCValue = function (isChecked) {
				if (isChecked === true) {
					createRdVm.isSenior = true;
				} else {
					createRdVm.isSenior = false;
				}
				rdService.customer.isSenior = createRdVm.isSenior;
				var isSenior = createRdVm.isSenior;
				createRdVm.changeAmount();
			};

			/*event for changing the amount field */
			createRdVm.changeAmount = function () {
				createRdVm.checkdisable = false;
				// console.log(createRdVm.selectedValue)
				if (createRdVm.amountData != "" && createRdVm.amountData != undefined && createRdVm.selectedValue) {
					// console.log("ofofofoffo")
					var amountCheck = createRdVm.selectedValue.split(',');
					var multipleCheck = createRdVm.amountData.split('').pop();
					if (multipleCheck != 0 || createRdVm.amountData < 100 || multipleCheck != 0) {
						createRdVm.multiple_ten_flag = true;
					} else {
						createRdVm.multiple_ten_flag = false;
						rdService.customer.amountData = createRdVm.amountData;
					}

					if (createRdVm.amountData < 100 || multipleCheck != 0 || (createRdVm.selectedValue && parseInt(amountCheck[1]) < parseInt(createRdVm.amountData))) {
						createRdVm.disablenext = true;
					} else {
						createRdVm.disablenext = false;
					}

					if (createRdVm.selectedValue && parseInt(amountCheck[1]) < parseInt(createRdVm.amountData)) {
						createRdVm.selectedDataLimit = true;
					} else {
						createRdVm.selectedDataLimit = false;
					}

				} else {
					createRdVm.disablenext = true;
				}
			};

			createRdVm.goToAO = function () {
				rdService.initialValueStage();
			if (homeScreenService.ishamMenu === true) {
				$ionicHistory.goBack();
				//$state.go("menu.homeScreen");
				homeScreenService.ishamMenu = false;
			}
			else {
				$state.go("menu.accountOverviewMyBalance");
			}
		}

			createRdVm.goCreate = function () {
				$state.go("menu.createRd");
			}

			createRdVm.createRdSaveGo = function () {
				var selectedData = createRdVm.selectedValue.split(',');
            	rdService.customer.amount = createRdVm.amount;
            	rdService.selectedDetails.accountNumber = selectedData[0];
            	rdService.selectedDetails.accountBalance = selectedData[1];
            	rdService.selectedDetails.accountType = selectedData[2];
            	rdService.selectedDetails.productCodeNRI = selectedData[4];
				rdService.createRdData.monthControAmount = createRdVm.amountData;
				rdService.createRdData.accountTypeCode = rdService.selectedDetails.accountType;

				if (createRdVm.isSenior == true) {
					var nri_msg = 'NRE and NRO deposits of Staff and Senior Citizens will not be eligible for any additional interest rate as applicable for Domestic Retail Deposits'
					var cust_dob = customerInfoService.customer.DOB.toUpperCase();
					var title = '';
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DATE_OF_BIRTH"></div><div class="text-center">'+cust_dob+'</div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="DOB_WORNG"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey">'+nri_msg+'</div>';
					$ionicPopup.show({
						title: '',
						template: template,
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								$state.go("menu.createRdSave");
							}
						}],
					});
				} else {
					$state.go("menu.createRdSave");
				}
			}

			createRdVm.goReview = function () {
				$state.go("menu.reviewRd");
			}

			createRdVm.goInterestRates = function () {
				$state.go("menu.interestRates");
			}

			$scope.getSelectedDate = function (date) {
				createRdVm.scheduleDate = date;
				$scope.selectedDate = date;
			}

			createRdVm.openDatePopup = function () {
				var confirmPopup = $ionicPopup.confirm({
					title: '',
					templateUrl: 'pages/recurringDeposite/createRd/datePickerPopup.html',
					scope: $scope,
					buttons: [
						{
							text: 'Cancel',
							onTap: function (e) {
								confirmPopup.close();
								createRdVm.scheduleDate = $scope.selectedDate;
							}
						},
						{
							text: 'Ok',
							onTap: function (e) {
								confirmPopup.close();
								createRdVm.scheduleDate = $scope.selectedDate;
								var suffixSet = createRdVm.scheduleDate;
			                    console.log("suffixSet",suffixSet)
			                	if (suffixSet <= 3 || suffixSet == 21 || suffixSet == 22 || suffixSet == 23) {
			                		if (suffixSet == 1 || suffixSet == 21) {
			                			createRdVm.suffixValue = "st";
			                		} else if (suffixSet == 2 || suffixSet == 22) {
			                			createRdVm.suffixValue = "nd";
			                		} else if (suffixSet == 3 || suffixSet == 23) {
			                			createRdVm.suffixValue = "rd";
			                		}
			                	} else {
			                		createRdVm.suffixValue = "th";
			                	}
								// createRdVm.scheduleDate = val;
								rdService.createRdData.siDate = createRdVm.scheduleDate;
								$scope.selectedDate = rdService.createRdData.siDate;
								// console.log(rdService.createRdData.siDate)
								createRdVm.selectedAccountFunRdSave();
							}
						}
					]
				});

			}

			createRdVm.seniorCitizenPopup = function () {
				var content = 'e-Recurring Deposit with additional rate of interest for senior citizens will be issued if option for "Senior Citizen" is selected by the customer and age of customer is 60 years or above, on the date of creating the recurring deposit, as per date of birth recorded with the bank. The minimum days and minimum amount appicable for additional rate of interest for senoir citizen will be as per Bank`s policy.</br></br>If you choose the Senior Citizen option, you must ensure that your age as on the date of making the deposit is 60 years or more. If at any time the Bank discovers that you did not qualify for the Senior Citizen benefit, the Bank reserves the right to recover from you any additional amount of interest that the Bank might have paid to you and take any other action as permitted by law.</br></br>NRE and NRO deposits of Staff and Senior Citizens will not be eligible for any additional interest rate as applicable for Domestic Retail Deposits'
				var template = '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">'+content+'</div></div></div>';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.createRd');
						}
					}],
				});
			}


			createRdVm.loadCheckAccess = function() {
				if (!rdService.accountDetails.length) {
					rdService.getcheckAccessRights().then(function(data) {
						console.log(data)
						createRdVm.accountDetails = data.accList;
                    	rdService.accountDetails = createRdVm.accountDetails;  

                    	createRdVm.validateDropdown(rdService.accountDetails);
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					createRdVm.accountDetails = rdService.accountDetails;
                    rdService.accountDetails = createRdVm.accountDetails;
                    createRdVm.validateDropdown(rdService.accountDetails);
				}
            }

            createRdVm.validateDropdown = function(accountDetailsData) {
	            createRdVm.accDetailsNew = [];
				createRdVm.accDetailsNew = accountDetailsData;
				for (var i in createRdVm.accDetailsNew) {
					if (createRdVm.accDetailsNew[i].accountType === "Savings") {
						createRdVm.accDetailsNew[i].accountType = "Savings A/c";
					} else if (createRdVm.accDetailsNew[i].accountType === "Current") {
						createRdVm.accDetailsNew[i].accountType = "Current A/c";
					} else if (createRdVm.accDetailsNew[i].accountType === "Overdraft") {
						createRdVm.accDetailsNew[i].accountType = "Overdraft A/c";
					}
					createRdVm.accDetailsNew[i].accountBalance = parseInt(createRdVm.accDetailsNew[i].accountBalance);
				}
				createRdVm.accountDetails = createRdVm.accDetailsNew;

				if (rdService.selectedDetails.accountType === '') {
					if (createRdVm.accountDetails[0] != undefined) {
						createRdVm.selectedValue = createRdVm.accountDetails[0].accountNumber + "," + createRdVm.accountDetails[0].accountBalance + "," + createRdVm.accountDetails[0].accountType + ",0," + createRdVm.accountDetails[0].nreFlag;
						createRdVm.disablenext = true;
						createRdVm.indexId = 0;
						rdService.selectedDetails.accountNumber = createRdVm.accountDetails[0].accountNumber;
						rdService.createRdData.accountNumberCreate = createRdVm.accountDetails[0].accountNumber;

						rdService.selectedDetails.accountBalance = createRdVm.accountDetails[0].accountBalance;
						rdService.selectedDetails.productCodeNRI = createRdVm.accountDetails[0].nreFlag;
						// rdService.createRdData.accountNumberCreate = createRdVm.accountDetails[0].accountNumber;

						rdService.selectedDetails.accountType = createRdVm.accountDetails[0].accountNumber;
						rdService.createRdData.accountType = createRdVm.accountDetails[0].accountType;

						if (rdService.selectedDetails.productCodeNRI == "TRUE") {
							createRdVm.isSenior = false;
							createRdVm.seniorWithNRI = true;
							rdService.customer.isSenior = false;
						}
					}
				} else {
					createRdVm.indexId = rdService.customer.indexId;

					rdService.selectedDetails.accountNumber = createRdVm.accountDetails[createRdVm.indexId].accountNumber;
					rdService.createRdData.accountNumberCreate = createRdVm.accountDetails[createRdVm.indexId].accountNumber;

					rdService.selectedDetails.accountBalance = createRdVm.accountDetails[createRdVm.indexId].accountBalance;
					rdService.selectedDetails.productCodeNRI = createRdVm.accountDetails[createRdVm.indexId].nreFlag;


					rdService.selectedDetails.accountType = createRdVm.accountDetails[createRdVm.indexId].accountNumber;
					rdService.createRdData.accountType = createRdVm.accountDetails[createRdVm.indexId].accountType;
					createRdVm.selectedValue = createRdVm.accountDetails[createRdVm.indexId].accountNumber + "," + createRdVm.accountDetails[createRdVm.indexId].accountBalance + "," + createRdVm.accountDetails[createRdVm.indexId].accountType + "," + createRdVm.indexId + "," + createRdVm.accountDetails[createRdVm.indexId].nreFlag;
					
					if (rdService.selectedDetails.productCodeNRI == "TRUE") {
						createRdVm.isSenior = false;
						createRdVm.seniorWithNRI = true;
						rdService.customer.isSenior = false;
					}
				}
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				createRdVm.loadCheckAccess();
				// console.log("creatrddata--------------",rdService.createRdData)
				var date = new Date();
				var getDate = date.getDate();

			if (getDate > 28) {
				createRdVm.scheduleDate = 28;
				$scope.selectedDate = 28;
			} else {
				createRdVm.scheduleDate = new Date().getDate().toString();
				$scope.selectedDate = createRdVm.scheduleDate;
				$scope.currentDateForRd = new Date().getDate().toString();
				
			}

            	var suffixSet = createRdVm.scheduleDate;
            	if (suffixSet <= 3 || suffixSet == 21 || suffixSet == 22 || suffixSet == 23) {
            		if (suffixSet == 1 || suffixSet == 21) {
            			createRdVm.suffixValue = "st";
            		} else if (suffixSet == 2 || suffixSet == 22) {
            			createRdVm.suffixValue = "nd";
            		} else if (suffixSet == 3 || suffixSet == 23) {
            			createRdVm.suffixValue = "rd";
            		}
            	} else {
            		createRdVm.suffixValue = "th";
            	}
            	
				// console.log("senior citizen",customerInfoService.customer.DOB)
				if (customerInfoService.customer.DOB !== "" && customerInfoService.customer.DOB !== undefined && customerInfoService.customer.DOB !== null) {
					createRdVm.custDate = customerInfoService.customer.DOB;
					rdService.customer.custDOB = customerInfoService.customer.DOB;
					var todayDate = new Date();
					var customerDOB = new Date(customerInfoService.customer.DOB);
					var age = todayDate.getFullYear() - customerDOB.getFullYear();
					createRdVm.custAge = age;
					createRdVm.custAge = parseInt(createRdVm.custAge);
					if (createRdVm.custAge === 60 || createRdVm.custAge > 60) {
						createRdVm.inSeniorCitizen = true;
					} else {
						createRdVm.inSeniorCitizen = false;
					}
				} else {
					createRdVm.inSeniorCitizen = false;
				}
				// console.log("senir citizen flag",rdService.customer.isSenior)
				
				if (createRdVm.inSeniorCitizen == false) {
					createRdVm.isSenior = false;
					rdService.customer.isSenior = false;
				} else {
					createRdVm.isSenior = rdService.customer.isSenior;
				}

				if (rdService.selectedDetails.productCodeNRI == "TRUE") {
					createRdVm.isSenior = false;
					createRdVm.seniorWithNRI = true;
					rdService.customer.isSenior = false;
				}

				createRdVm.amountData = rdService.customer.amountData;

				createRdVm.selectedValueMonth = String(rdService.createRdData.months);
				
				if (rdService.createRdData.interestSelectYear && rdService.createRdData.interestSelectYear != "" && rdService.createRdData.interestSelectYear != undefined) {
					createRdVm.selectedValueYear = String(parseInt(parseInt(rdService.createRdData.interestSelectYear) / 12));
					if (createRdVm.selectedValueMonth == "") {
						createRdVm.selectedValueMonth = "0"
					}
					createRdVm.checkPreEvaluationCallOnPageLoad();
				} else {
					if (rdService.createRdData.years != "") {
						createRdVm.selectedValueYear = String(rdService.createRdData.years);
						createRdVm.selectedValueMonth = String(rdService.createRdData.months);
						createRdVm.checkPreEvaluationCallOnPageLoad();
					}

				}

				if (rdService.createRdData.siDate) {
					createRdVm.scheduleDate = rdService.createRdData.siDate;
					$scope.selectedDate = rdService.createRdData.siDate;
					var suffixSet = createRdVm.scheduleDate;
                	if (suffixSet <= 3 || suffixSet == 21 || suffixSet == 22 || suffixSet == 23) {
                		if (suffixSet == 1 || suffixSet == 21) {
                			createRdVm.suffixValue = "st";
                		} else if (suffixSet == 2 || suffixSet == 22) {
                			createRdVm.suffixValue = "nd";
                		} else if (suffixSet == 3 || suffixSet == 23) {
                			createRdVm.suffixValue = "rd";
                		}
                	} else {
                		createRdVm.suffixValue = "th";
                	}
				}

				if (createRdVm.selectedValueYear != "" && createRdVm.selectedValueYear != undefined && createRdVm.selectedValueMonth != "" && createRdVm.selectedValueMonth && createRdVm.scheduleDate != "") {
					createRdVm.disableconfirm = false;
					createRdVm.showMaturityAndIRate = true;
					createRdVm.mDateRdSave = rdService.createRdData.maturityDate;
					createRdVm.iRateRdSave = rdService.createRdData.iRate;
				} else {
					createRdVm.disableconfirm = true;
					createRdVm.showMaturityAndIRate = false;
					createRdVm.mDateRdSave = "";
					createRdVm.iRateRdSave = "";
				}
				
				createRdVm.changeAmount();
			});

			createRdVm.checkPreEvaluationCallOnPageLoad= function () {
			if (createRdVm.selectedValueYear != "" && createRdVm.selectedValueYear != undefined && createRdVm.selectedValueMonth != "" && createRdVm.selectedValueMonth && createRdVm.scheduleDate != "") {
					createRdVm.disableconfirm = false;
					var endDate = new Date();
					var getyear = createRdVm.selectedValueYear;
					var getMonth = createRdVm.selectedValueMonth;
					var months = parseInt(getMonth);
					var years = (endDate.getFullYear() + parseInt(getyear)) - endDate.getFullYear();
					var finalMonth = endDate.setMonth(endDate.getMonth() + parseInt(getMonth));
					var finalYear = endDate.setFullYear(endDate.getFullYear() + parseInt(getyear));
					var finalDate = endDate.toISOString().slice(0, 10);

					rdService.createRdData.years = years;
					rdService.createRdData.months = months;
					rdService.createRdData.siDate = createRdVm.scheduleDate;
					rdService.createRdData.iRate = createRdVm.iRateRdSave;
					rdService.createRdData.tensure = ((parseInt(years) * 12) + parseInt(months));
					var obj = {
						"dob": "",
						"endDate": finalDate,
						"tenure": rdService.createRdData.tensure,
						"installmentAmount": rdService.createRdData.monthControAmount,
						"amount": rdService.selectedDetails.accountBalance,
						"siDate": createRdVm.scheduleDate,
						"accountNumber": rdService.selectedDetails.accountNumber,
						"pfNumber": getAccountDetailsService.accountOverviewData.customerInformation.pfNumber,
						"customerType": getAccountDetailsService.accountOverviewData.customerInformation.customerType,
						"panNumber": "",
						"accountTypeCode": "",
						"intCategory": "",
						"startDate": "",
						"isSenior": rdService.customer.isSenior,
					}
				
					rdService.checkPreEvaluation(obj).then(function (data) {
						createRdVm.mDateRdSave = data.maturityDate;
						createRdVm.iRateRdSave = data.interestRate;
						rdService.createRdData.maturityDate = data.maturityDate;
						rdService.createRdData.maturityAmount = data.maturityAmount;
						rdService.createRdData.iRate = data.interestRate;
						rdService.createRdData.nightModeFlag = data.nightMode;
						createRdVm.showMaturityAndIRate = true;
						rdService.createRdData.interestSelectYear = "";
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {

					rdService.createRdData.interestSelectYear = "";
					createRdVm.disableconfirm = true;
					createRdVm.showMaturityAndIRate = false;
				}
		}


			$scope.$on('$ionicView.afterLeave', function () {
				//any cleanup needs to be done here: executes everytime when page is left
			});

			return this;
		}
]);


