'use strict';

angularApp.controller('nomineeRdController', ["$timeout",
	"$state",
	"$scope",
	"$translate",
	"fixedDepositService",
	"nomineeRdService",
	"closePopupService",
	"$ionicPopup",
	"ionicDatePicker",
	"validationService",
	"utilityService",
	"rdClosureService",
	"rdService",
	function ($timeout,
		$state,
		$scope,
		$translate,
		fixedDepositService,
		nomineeRdService,
		closePopupService,
		$ionicPopup,
		ionicDatePicker,
		validationService,
		utilityService,
		rdClosureService,
		rdService) {

		var nomineeRdVm = this;
		function initPage() {
			nomineeRdVm.showBack = true;
			nomineeRdVm.showNext = true;
			nomineeRdVm.showNameError = false;
			nomineeRdVm.showGNameError = false;
			nomineeRdVm.showAgeError = false;
			nomineeRdVm.showAddressError = false;
			nomineeRdVm.showAddress2Error = false;
			nomineeRdVm.showSubmitButton = false;
			nomineeRdVm.Relations = [];
			$translate(['NOMINEE_INFO', 'NOMINEE_NAME', 'NOMINEE_AGE', 'SELECT_RELATION', 'RELATION_TITLE', 'NOMINEE_FADDRESS', 'NOMINEE_SADDRESS', 'NOMINEE_GUARD', 'FIXED_DEPOSIT', 'NOMINEE_HIDE_RD', 'DATE_OF_BIRTH', 'EDITT']).then(function (translations) {
				nomineeRdVm.nominee = translations['NOMINEE_INFO'];
				nomineeRdVm.nomineeName = translations['NOMINEE_NAME'];
				nomineeRdVm.nomineeAge = translations['NOMINEE_AGE'];
				nomineeRdVm.relationSelect = translations['SELECT_RELATION'];
				nomineeRdVm.relationTitle = translations['RELATION_TITLE'];
				nomineeRdVm.nomineefAddress = translations['NOMINEE_FADDRESS'];
				nomineeRdVm.nomineesAddress = translations['NOMINEE_SADDRESS'];
				nomineeRdVm.nomineeGuard = translations['NOMINEE_GUARD'];
				nomineeRdVm.fdTitle = translations['FIXED_DEPOSIT'];
				nomineeRdVm.nomineeHide = translations['NOMINEE_HIDE_RD'];
				nomineeRdVm.dateofbirth = translations['DATE_OF_BIRTH'];
				nomineeRdVm.edit = translations['EDITT']
			});
		}
		nomineeRdVm.ipObj1 = {
			callback: function (val) {
				var date = new Date(val);
				var formatedDate = new Date(date.setDate(date.getDate()))
				nomineeRdVm.DOBCust = formatedDate;
				// d.setDate(15); 
				// nomineeRdVm.DOBCust = new Date(val);
				console.log("nominee date borth",nomineeRdVm.DOBCust)
				// var date = new Date();
				// var dateRange2 = new Date();
				// dateRange2.setFullyear(date.getFullYear());
				if (parseInt(getCalculatedAge(nomineeRdVm.DOBCust)) < 18) {
					nomineeRdVm.minorFlag = true;
					rdService.createRdData.minor = true;
					rdService.customer.minorFlag = true;
					nomineeRdVm.guardNData = true;
					nomineeRdVm.guardiaAge = true;
					if (nomineeRdVm.age === undefined || nomineeRdVm.age === "" || nomineeRdVm.age === null || nomineeRdVm.age < 18 || nomineeRdVm.age > 99) {
						nomineeRdVm.showAgeError = true;
					} else {
						nomineeRdVm.showAgeError = false;
					}
					if (nomineeRdVm.guardianName === undefined || nomineeRdVm.guardianName === "" || nomineeRdVm.guardianName === null) {
						nomineeRdVm.showGNameError = true;
					} else {
						nomineeRdVm.showGNameError = false;
					}
				} else {
					nomineeRdVm.minorFlag = false;
					rdService.createRdData.minor = false;
					rdService.customer.minorFlag = false;
					nomineeRdVm.guardNData = false;
					nomineeRdVm.guardiaAge = false;
					nomineeRdVm.showGNameError = false;
					nomineeRdVm.showAgeError = false;
					nomineeRdVm.age = "";
					nomineeRdVm.guardianName = "";
				}
				nomineeRdVm.setSubmitButton();
			},
			inputDate: new Date(),
			to: new Date(),
			mondayFirst: true,
			closeOnSelect: false,
			templateType: 'popup',
		};

		nomineeRdVm.goToAO = function () {
			if (rdService.customer.nomineeClick === 'closeRd') {
				$state.go('menu.rdDetailsClosure');
			}
			if (rdService.customer.nomineeClick === 'reviewRd') {
				$state.go('menu.reviewRd');
			}
		}

		nomineeRdVm.goBacktoPrevious = function() {
			nomineeRdVm.showSubmitButton = false;
			// console.log(rdService.customer)
			// if (rdService.customer.nomineeClick === 'detailsfd') {
			// 	$state.go('menu.fixedDepositDetails');
			// }
			if (rdService.customer.nomineeClick === 'closeRd') {
				$state.go('menu.rdDetailsClosure');
			}
			if (rdService.customer.nomineeClick === 'reviewRd') {
				$state.go('menu.reviewRd');
			}
			// $state.go('menu.accountOverviewMyBalance')
		}

		function getCalculatedAge(born) {
			var now = new Date();
			var birthday = new Date(now.getFullYear(), born.getMonth(), born.getDate());
			if(now >= birthday)
				return now.getFullYear() - born.getFullYear();
			else
				return (now.getFullYear() - born.getFullYear()) - 1;
		}

		nomineeRdVm.openDatePicker = function () {
			ionicDatePicker.openDatePicker(nomineeRdVm.ipObj1);
		};

		nomineeRdVm.selectedAccountFun = function () {
			var data = nomineeRdVm.selectedValue.split(",");
			var e = [];
			e.relationname = data[0];
			e.indexId = data[1];
			nomineeRdVm.indexId = e.indexId;
			rdService.customer.nomIndexid = nomineeRdVm.indexId;
			nomineeRdVm.relationType = e.relationname;
			rdService.customer.relation = nomineeRdVm.relationType;
			nomineeRdVm.setSubmitButton();
		}

		nomineeRdVm.getNomineeValue = function (isChecked) {
			if (isChecked === true) {
				nomineeRdVm.nameToBePrintedFlag = "N";
				nomineeRdVm.showNominee = true;
			} else {
				nomineeRdVm.nameToBePrintedFlag = "Y";
				nomineeRdVm.showNominee = false;
			}
			nomineeRdVm.customer.showNominee = nomineeRdVm.showNominee;
			nomineeRdVm.customer.nameToBePrintedFlag = nomineeRdVm.nameToBePrintedFlag;
		}

		nomineeRdVm.getNomineeName = function () {
			var regexp = new RegExp("^([a-zA-Z ]{0,30})$");
			if (regexp.test(nomineeRdVm.nameData)) {
				nomineeRdVm.nameDataValid = true;
			} else {
				nomineeRdVm.nameDataValid = false;
			}

			if (nomineeRdVm.nameData === "" || nomineeRdVm.nameData === undefined || nomineeRdVm.nameData === null || nomineeRdVm.nameDataValid === false) {
				nomineeRdVm.showNameError = true;
			} else {
				nomineeRdVm.showNameError = false;
				nomineeRdVm.customer.nominee = nomineeRdVm.nameData;
			}
			nomineeRdVm.setSubmitButton();
		}

		nomineeRdVm.getNomineeAge = function () {
			if (nomineeRdVm.age !== undefined && nomineeRdVm.age !== "" && nomineeRdVm.age !== null) {
				nomineeRdVm.age = parseInt(nomineeRdVm.age);
			} else {
				nomineeRdVm.age = "";
			}

			if (nomineeRdVm.age >= 18 && nomineeRdVm.age <= 99) {
				nomineeRdVm.customer.age = nomineeRdVm.age;
				nomineeRdVm.showAgeError = false;
			} else {
				nomineeRdVm.showAgeError = true;
			}
			nomineeRdVm.setSubmitButton();
		}

		nomineeRdVm.getNomineeGuardian = function () {
			var regexp = new RegExp("^([a-zA-Z ]{0,30})$");
			if (regexp.test(nomineeRdVm.guardianName)) {
				nomineeRdVm.guardianNameValid = true;
			} else {
				nomineeRdVm.guardianNameValid = false;
			}

			if (nomineeRdVm.guardianName === "" || nomineeRdVm.guardianName === undefined || nomineeRdVm.guardianName === null || nomineeRdVm.guardianNameValid === false) {
				nomineeRdVm.showGNameError = true;
			} else {
				nomineeRdVm.showGNameError = false;
				nomineeRdVm.customer.guardian = nomineeRdVm.guardianName;
			}
			nomineeRdVm.setSubmitButton();
		}

		nomineeRdVm.getNomineeAddress1 = function () {
			var regexp = new RegExp("^.{1,30}$");
			if (regexp.test(nomineeRdVm.address1)) {
				nomineeRdVm.address1Valid = true;
			} else {
				nomineeRdVm.address1Valid = false;
			}

			if (nomineeRdVm.address1 === "" || nomineeRdVm.address1 === undefined || nomineeRdVm.address1 === null || nomineeRdVm.address1Valid === false) {
				nomineeRdVm.showAddressError = true;
			} else {
				nomineeRdVm.showAddressError = false;
				nomineeRdVm.customer.address1 = nomineeRdVm.address1;
			}
			nomineeRdVm.setSubmitButton();
		}

		nomineeRdVm.getNomineeAddress2 = function () {
			var regexp = new RegExp("^.{1,30}$");
			if (regexp.test(nomineeRdVm.address2)) {
				nomineeRdVm.address2Valid = true;
			} else {
				nomineeRdVm.address2Valid = false;
			}

			if (nomineeRdVm.address2 === "" || nomineeRdVm.address2 === undefined || nomineeRdVm.address2 === null || nomineeRdVm.address2Valid === false) {
				nomineeRdVm.showAddress2Error = true;
			} else {
				nomineeRdVm.showAddress2Error = false;
				nomineeRdVm.customer.address2 = nomineeRdVm.address2;
			}
			nomineeRdVm.setSubmitButton();
		}

		nomineeRdVm.setSubmitButton = function () {
			if(!nomineeRdVm.showNameError &&
				(nomineeRdVm.relationType != "" && nomineeRdVm.indexId > 0) &&
				nomineeRdVm.DOBCust != "Date of Birth" && 
				nomineeRdVm.address1 != "" && !nomineeRdVm.showAddressError && 
				nomineeRdVm.address2 != "" && !nomineeRdVm.showAddress2Error) {
					if(nomineeRdVm.guardNData && nomineeRdVm.guardiaAge) {
						if(nomineeRdVm.guardianName != "" && !nomineeRdVm.showGNameError && nomineeRdVm.age != "" && !nomineeRdVm.showAgeError) {
							nomineeRdVm.disablesubmit = false;
						} else {
							nomineeRdVm.disablesubmit = true;
						}
					} else {
						nomineeRdVm.disablesubmit = false;
					}
				} else {
					nomineeRdVm.disablesubmit = true;
				}
		}

		nomineeRdVm.editnominee = function () {
			nomineeRdVm.showaddress2 = true;
			nomineeRdVm.guardiaAge = false;
			nomineeRdVm.guardNData = false;
			nomineeRdVm.disablesubmit = true;
			nomineeRdVm.hideDOB = true;
			nomineeRdVm.disNomName = false;
			nomineeRdVm.disNomSelect = false;
			nomineeRdVm.disNomDOB = false;
			nomineeRdVm.disNomGuardName = false;
			nomineeRdVm.disNomAddress1 = false;
			nomineeRdVm.disNomcheckbox = false;
			nomineeRdVm.showNameError = false;
			nomineeRdVm.showGNameError = false;
			nomineeRdVm.showAgeError = false;
			nomineeRdVm.showAddressError = false;
			nomineeRdVm.showAddress2Error = false;
			nomineeRdVm.customer = [];
			nomineeRdVm.guardianName = "";
			nomineeRdVm.address1 = "";
			nomineeRdVm.address2 = "";
			nomineeRdVm.nameData = "";
			nomineeRdVm.DOBCust = "Date of Birth";
			nomineeRdVm.showSubmitButton = true;
			nomineeRdVm.selectedValue = nomineeRdVm.Relations[0].relationname + ",0";
			nomineeRdVm.indexId = 0;
			nomineeRdVm.showNominee = false;
			nomineeRdVm.age = "";

			rdService.customer.age = "";
			rdService.customer.dob = "";
			rdService.customer.relation = "";
			rdService.customer.nomIndexid = 0;
			rdService.customer.guardian = "";
			rdService.customer.address1 = "";
			rdService.customer.address2 = "" ;
			rdService.customer.nominee = "";
			rdService.customer.showNominee  = "";
			rdService.customer.minorFlag = "";
			// console.log("nomineeRdVm.showSubmitButton",nomineeRdVm.showSubmitButton)
		}

		// nomineeRdVm.goToAO = function () {
		// 	if (fixedDepositService.customer.nomineeClick === 'detailsfd') {
		// 		$state.go('menu.rdDetails');
		// 	}
		// 	if (fixedDepositService.customer.nomineeClick === 'closefd') {
		// 		$state.go('menu.rdDetailsClosure');
		// 	}
		// 	if (fixedDepositService.customer.nomineeClick === 'reviewfd') {
		// 		$state.go('menu.reviewFD');
		// 	}
		// }

		// nomineeRdVm.goBacktoPrevious = function () {
		// 	if (fixedDepositService.customer.nomineeClick === 'detailsfd') {
		// 		$state.go('menu.rdDetails');
		// 	}
		// 	if (fixedDepositService.customer.nomineeClick === 'closefd') {
		// 		$state.go('menu.rdDetailsClosure');
		// 	}
		// 	if (fixedDepositService.customer.nomineeClick === 'reviewfd') {
		// 		$state.go('menu.reviewRd');
		// 	}
		// }

		function doubleDigitFormat(number) {
		     return (number < 10 ? '0' : '') + number
		}

		nomineeRdVm.goToNextPage = function () {
			rdService.customer.age = nomineeRdVm.age;
			rdService.customer.dob = nomineeRdVm.DOBCust;
			rdService.customer.relation = nomineeRdVm.relationType;
			rdService.customer.guardian = nomineeRdVm.guardianName;
			rdService.customer.tempAddr1 = nomineeRdVm.address1;
			rdService.customer.address1 = nomineeRdVm.address1 + " " + nomineeRdVm.address2;
			rdService.customer.address2 = nomineeRdVm.address2;
			rdService.customer.nominee = nomineeRdVm.nameData;
			rdService.customer.showNominee = nomineeRdVm.showNominee;
			rdService.customer.minorFlag = nomineeRdVm.minorFlag;
			rdService.customer.nameToBePrintedFlag = nomineeRdVm.nameToBePrintedFlag;

			if (nomineeRdVm.DOBCust != "") {
				var dobdate = doubleDigitFormat(new Date(nomineeRdVm.DOBCust).getDate());
				var dob = new Date(nomineeRdVm.DOBCust).toISOString();
				var dobFormat = dob.toString().split('-');
				var dobFinal = dobdate + dobFormat[1] + dobFormat[0]
			} else {
				var dobFinal = ""
			}

			if (nomineeRdVm.minorFlag == true) {
				var minorData = "Y";
				var guardianAddr1 = nomineeRdVm.address1;
				var guardianAddr2 = nomineeRdVm.address2;
			} else if (nomineeRdVm.minorFlag == false) {
				var minorData = "N";
				var guardianAddr1 = "";
				var guardianAddr2 = "";
			} else {
				var minorData = "";
				var guardianAddr1 = nomineeRdVm.address1;
				var guardianAddr2 = nomineeRdVm.address2;
			}

			var obj = {
				"accountNumber": "",
				"nomineeName": nomineeRdVm.nameData,
				"minorFlag": minorData,
				"nomineeAddress": nomineeRdVm.address1 + " " + nomineeRdVm.address2,
				"relationship": nomineeRdVm.relationType,
				"dateOfBirth": dobFinal,
				"guardianName": nomineeRdVm.guardianName,
				"guardianAddress1": guardianAddr1,
				"guardianAddress2": guardianAddr2,
				"guardianAge": nomineeRdVm.age
			}
			console.log(obj,rdService.customer.nomineeClick)
			if (rdService.customer.nomineeClick !== 'reviewRd') {
				nomineeRdService.updateNominee(obj).then(function (data) {
					nomineeRdVm.showSubmitButton = false;
					// var template = data.status;
					var template = 'Your nominee details have been updated successfully for RD ' + rdService.viewRdData.accountNumber;
					$ionicPopup.show({
						title: '',
						template: '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey">'+template+'</div>',
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								if (rdService.customer.nomineeClick === 'closeRd') {
									$state.go('menu.rdDetailsClosure');
								}
								if (rdService.customer.nomineeClick === 'reviewRd') {
									$state.go('menu.reviewRd');
								}
							}
						}],
					});
				}, function (error) {
					nomineeRdVm.showSubmitButton = true;
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				nomineeRdVm.showSubmitButton = false;
				if (rdService.customer.nomineeClick === 'closeRd') {
					$state.go('menu.rdDetailsClosure');
				}
				if (rdService.customer.nomineeClick === 'reviewRd') {
					$state.go('menu.reviewRd');
				}
			}
		}

		nomineeRdVm.setRelationship = function () {
			// console.log("set relation",rdService.customer)
			if (rdService.createRdData.relationship === "" || rdService.createRdData.relationship === null || rdService.createRdData.relationship === undefined) {
				nomineeRdVm.indexId = 0;
				nomineeRdVm.selectedValue = nomineeRdVm.Relations[0].relationname + ",0";
			}
			else {
				for (var i = 0; i < nomineeRdVm.Relations.length; i++) {
					if (nomineeRdVm.Relations[i].relationname === rdService.createRdData.relationship) {
						nomineeRdVm.indexId = nomineeRdVm.Relations[i].id;
					}
				}
				nomineeRdVm.selectedValue = rdService.createRdData.relationship + "," + nomineeRdVm.indexId;
			}
		}

		$scope.$on('$ionicView.loaded', function () {
			initPage();
			if(!rdService.Relations.length){
				rdClosureService.getRelationship().then(function(data) {
					console.log(data)
					if(!utilityService.isUndefined(data)) {
						rdService.Relations = data.relations;
						nomineeRdVm.Relations = rdService.Relations;
					}
					nomineeRdVm.setRelationship();
				}, function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				nomineeRdVm.Relations = rdService.Relations;
				nomineeRdVm.setRelationship();
			}
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			// console.log(rdService.createRdData,"nomineepageeeeeeeeeeeeeee")
			nomineeRdVm.disablesubmit = true;
			nomineeRdVm.showNameError = false;
			nomineeRdVm.showGNameError = false;
			nomineeRdVm.showAgeError = false;
			nomineeRdVm.showAddressError = false;
			nomineeRdVm.showAddress2Error = false;
			nomineeRdVm.showaddress2 = false;
			nomineeRdVm.guardiaAge = false;
			nomineeRdVm.disNomName = true;
			nomineeRdVm.disNomSelect = true;
			nomineeRdVm.disNomDOB = true;
			nomineeRdVm.disNomGuardName = true;
			nomineeRdVm.disNomAddress1 = true;
			nomineeRdVm.disNomcheckbox = true;
			console.log(rdService.createRdData.guardianName,rdService.customer.guardian)
			
			if (rdService.createRdData.minor == "Y" || rdService.customer.minorFlag == "Y" || rdService.customer.minorFlag == true || rdService.createRdData.minor == true) {
				nomineeRdVm.guardNData = true;
				nomineeRdVm.minorFlag = true;
				rdService.customer.minorFlag = true;
				rdService.createRdData.minor = true;
			} else {
				nomineeRdVm.guardNData = false;
				nomineeRdVm.minorFlag = false;
				rdService.customer.minorFlag = false;
				rdService.createRdData.minor = false;
				rdService.createRdData.guardianName = "";
				rdService.customer.guardian = "";
			}

			if (rdService.customer.dob == "") {
				nomineeRdVm.hideDOB = false;
			} else {
				nomineeRdVm.hideDOB = true;
				if (rdService.customer.dob != "") {
					nomineeRdVm.DOBCust = rdService.customer.dob;
				} else {
					nomineeRdVm.DOBCust = rdService.createRdData.dob;
				}
			}


			// if (nomineeRdVm.DOBCust !== "" && nomineeRdVm.DOBCust !== undefined && nomineeRdVm.DOBCust !== null) {
			// 	var todayDate = new Date();
			// 	var customerDOB = new Date(nomineeRdVm.DOBCust);
			// 	console.log("nomineeRdVm.DOBCust",nomineeRdVm.DOBCust,customerDOB,customerDOB.getFullYear())
			// 	var age = todayDate.getFullYear() - customerDOB.getFullYear();
			// 	console.log("DOBCust",todayDate.getFullYear(),customerDOB.getFullYear())
			// 	if (age < 18) {
			// 		nomineeRdVm.minorFlag = true;
			// 		rdService.customer.minorFlag = true;
			// 		rdService.createRdData.minor = true;
			// 	} else {
			// 		nomineeRdVm.minorFlag = false;
			// 		rdService.customer.minorFlag = false;
			// 		rdService.createRdData.minor = false;
			// 	}
			// } else {
			// 	nomineeRdVm.minorFlag = false;
			// 	rdService.customer.minorFlag = false;
			// 	rdService.createRdData.minor = false;
			// }

			String.prototype.toProperCase = function () {
			    return this.replace(/\w\S*/g, function(txt){return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();});
			};

			if (rdService.customer.nominee != "") {
				// console.log("rdService.customer.nominee")
				if (rdService.customer.relation == "") {
					rdService.customer.nomIndexid = 0
				} else if (rdService.customer.relation == "Father") {
					rdService.customer.nomIndexid = 1
				} else if (rdService.customer.relation == "Mother") {
					rdService.customer.nomIndexid = 2
				} else if (rdService.customer.relation == "Wife") {
					rdService.customer.nomIndexid = 3
				} else if (rdService.customer.relation == "Husband") {
					rdService.customer.nomIndexid = 4
				} else if (rdService.customer.relation == "Daughter") {
					rdService.customer.nomIndexid = 5
				} else if (rdService.customer.relation == "Son") {
					rdService.customer.nomIndexid = 6
				}
			} else {
				// console.log("rdService.customer.nominee elslelllsllell")
				if (rdService.createRdData.relationship == "") {
					rdService.createRdData.nomIndexid = 0
				} else if (rdService.createRdData.relationship == "Father") {
					rdService.createRdData.nomIndexid = 1
				} else if (rdService.createRdData.relationship == "Mother") {
					rdService.createRdData.nomIndexid = 2
				} else if (rdService.createRdData.relationship == "Wife") {
					rdService.createRdData.nomIndexid = 3
				} else if (rdService.createRdData.relationship == "Husband") {
					rdService.createRdData.nomIndexid = 4
				} else if (rdService.createRdData.relationship == "Daughter") {
					rdService.createRdData.nomIndexid = 5
				} else if (rdService.createRdData.relationship == "Son") {
					rdService.createRdData.nomIndexid = 6
				}
			}

			if (rdService.customer.nominee != "") {
				nomineeRdVm.age = rdService.customer.age
				nomineeRdVm.DOBCust = rdService.customer.dob
				nomineeRdVm.selectedValue = rdService.customer.relation + "," + rdService.customer.nomIndexid;
				// nomineeRdVm.relationType = rdService.customer.relation
				nomineeRdVm.guardianName = rdService.customer.guardian
				nomineeRdVm.address1 = rdService.customer.address1
				nomineeRdVm.address2 = rdService.customer.address2 
				nomineeRdVm.nameData = rdService.customer.nominee
				nomineeRdVm.showNominee = rdService.customer.showNominee 
				nomineeRdVm.minorFlag = rdService.customer.minorFlag
				nomineeRdVm.nameToBePrintedFlag = rdService.customer.nameToBePrintedFlag 
			} else {
				nomineeRdVm.age = rdService.createRdData.age;
				nomineeRdVm.DOBCust = rdService.createRdData.dob;
				nomineeRdVm.nameData = rdService.createRdData.name;
				nomineeRdVm.selectedValue = rdService.createRdData.relationship + "," + rdService.createRdData.nomIndexid;
				nomineeRdVm.guardianName = rdService.createRdData.guardianName;
				nomineeRdVm.address1 = rdService.createRdData.address;
				nomineeRdVm.showNominee = rdService.createRdData.showNominee;
				nomineeRdVm.fdAccountNumber = rdService.createRdData.fdnumber;
				nomineeRdVm.minorFlag = rdService.createRdData.minor
				nomineeRdVm.nameToBePrintedFlag = "N";
				nomineeRdVm.branchCode = rdService.createRdData.branchCode;
			}
		});

		$scope.$on('$ionicView.afterLeave', function () {
			//any cleanup needs to be done here: executes everytime when page is left
		});
		return this;
	}]);