angularApp.service('nomineeRdService',
	function ($q, AdapterUtils) {
		var RDservice = this;
		RDservice.updateNominee = function (obj) {
			var q = $q.defer();

			AdapterUtils.postData("adapters/RecurringDepositAdapter/updateNominee", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		RDservice.getRelationship = function () {
			var q = $q.defer();
			var obj = {
				"id": "MasterDataTry1",
				"fields": ["Relationship"]
			};
			AdapterUtils.postData("adapters/RecurringDepositAdapter/getRelationship", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		return RDservice;
	});  