'use strict';
angularApp.controller('rdDetailsController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"rdClosureService",
		"rdService",
		"getAccountDetailsService",
		"openUrlInAppbroswerService",
		"constantConfig",
		"$rootScope",
		"pwdProtectedPdfDownloadService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,rdClosureService,rdService, getAccountDetailsService, openUrlInAppbroswerService, constantConfig, $rootScope, pwdProtectedPdfDownloadService) {
			
			var rdDetailsVm = this;
			rdDetailsVm.isAccountMasked = false;
			
			function initPage() {
				// rdDetailsVm.showBack = false;
				// rdDetailsVm.showNext = true;
				// createRdVm.disablenext = true;
				// createRdVm.isValidError = false;
				// createRdVm.validErrorMessage = "";
				// createRdVm.isValidAccount = false;
				// createRdVm.validAccountMessage = "";
				rdDetailsVm.rdModeOperationButton = false;
				rdDetailsVm.availod = true;
				rdDetailsVm.closeDetails = [];
				rdDetailsVm.nightMode = false;
				rdDetailsVm.showDateDiv = true;
				rdDetailsVm.indexId = 0;
				rdDetailsVm.disableConfirmClosure = false;

				$translate(['FDN','NAME','PRINCIPAL_AMT','TENURE','DEPOST_DATE','MATURITY_DATE','MATURITY_AMT','RATE_OF_INT',
					'EFFCTIVE_IE','AMNT_CREDITED','INTRST_PAYOUT', 'MATURITY_INST','CREDIT_AC','NOMINEE','START_DATE','CLOSEFD','REGISTERED','NOMINEELINK','SELECT_ACCOUNT','LIEN_AMOUNT','NOT_AVAILABLE','NO_NOMINEE']).then(function (translations) {
						// rdDetailsVm.fdNumber=translations['FDN'];
						// rdDetailsVm.name=translations['NAME'];
						// rdDetailsVm.principalAmount=translations['PRINCIPAL_AMT'];
						rdDetailsVm.tenure=translations['TENURE'];
						rdDetailsVm.depositDate=translations['DEPOST_DATE'];
						rdDetailsVm.maturityDate=translations['MATURITY_DATE'];
						rdDetailsVm.maturityAmount=translations['MATURITY_AMT'];
						rdDetailsVm.rateOfInterest=translations['RATE_OF_INT'];
						rdDetailsVm.effectiveIE=translations['EFFCTIVE_IE'];
						rdDetailsVm.amountCredited=translations['AMNT_CREDITED'];
						rdDetailsVm.interestPayout=translations['INTRST_PAYOUT'];
						rdDetailsVm.maturityInst=translations['MATURITY_INST'];
						rdDetailsVm.creditAc=translations['CREDIT_AC'];
						rdDetailsVm.nominee=translations['NOMINEE'];
						rdDetailsVm.startDate=translations['START_DATE'];
						rdDetailsVm.closefd=translations['CLOSEFD'];
						rdDetailsVm.register = translations['REGISTERED'];
						rdDetailsVm.nomineeLink = translations['NOMINEELINK'];
						rdDetailsVm.selectedAccount = translations['SELECT_ACCOUNT'];
						rdDetailsVm.lienAmount = translations['LIEN_AMOUNT'];
						rdDetailsVm.notAvailable = translations['NOT_AVAILABLE'];
						rdDetailsVm.nonominee = translations['NO_NOMINEE'];
				}); 
			};

			rdDetailsVm.eyesOnFun = function(accNo){
				rdDetailsVm.isAccountMasked = false;
				rdDetailsVm.rdAccNumber = rdDetailsVm.oldValue;
			}

			rdDetailsVm.eyesOffFun = function(accNo){
				rdDetailsVm.isAccountMasked = true;
				rdDetailsVm.oldValue = accNo;
				rdDetailsVm.rdAccNumber = utilityService.maskData(accNo, "front", 4);
			}

			rdDetailsVm.openDatePickerFrom = function() {
                var date = new Date()
                var getCurrentYear = new Date().getFullYear();
                var setYear = date.setFullYear((getCurrentYear-3))
				rdDetailsVm.dateObj = {
					callback: function (val) {
	                    // rdDetailsVm.scheduleDate = val;
	                    var tomorrow = new Date(val);
		                tomorrow.setDate(tomorrow.getDate() + 1);
	                    rdDetailsVm.fromeDate = new Date(tomorrow).toISOString().slice(0,10);
	                    

						// rdDetailsVm.scheduleDate = val;
						// rdService.createRdData.siDate = rdDetailsVm.scheduleDate;
					},
					inputDate: new Date(),
					from: setYear,
					to: new Date(),
					mondayFirst: true,
					closeOnSelect: false,
					templateType: 'popup',
					dateFormat: 'dd MMM yyyy'

				};

				ionicDatePicker.openDatePicker(rdDetailsVm.dateObj);
			};

			rdDetailsVm.nightModePopup = function() {
				var content = 'View Nominee detail service is currently unavailable. You can view nominee detail during the next business hour.';
				var template = '<div class="popupTextBottomPadding fontSize-subHeading"><div class="text-justify">'+content+'</div></div></div>';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.rdDetailsClosure');
						}
					}],
				});
			}

			rdDetailsVm.openDatePickerTo = function() {
				var dateRange2 = new Date();
				dateRange2.setFullYear(dateRange2.getFullYear() + 3)
				rdDetailsVm.dateObj = {
					callback: function (val) {
	                    // rdDetailsVm.scheduleDate = val;
	                    var tomorrow = new Date(val);
		                tomorrow.setDate(tomorrow.getDate() + 1);
	                    rdDetailsVm.toDate = new Date(tomorrow).toISOString().slice(0,10);
	                    
						// rdDetailsVm.scheduleDate = val;
						// rdService.createRdData.siDate = rdDetailsVm.scheduleDate;
						if (rdDetailsVm.fromeDate && rdDetailsVm.toDate) {
							var fromDate = rdDetailsVm.fromeDate;
							var fromDateFormat = fromDate.toString().split('-');
							var fromDateFinal = fromDateFormat[2] + fromDateFormat[1] + fromDateFormat[0];
							
							var toDate = rdDetailsVm.toDate;
							var toDateFormat = toDate.toString().split('-');
							var toDateFinal = toDateFormat[2] + toDateFormat[1] + toDateFormat[0]
							var obj = {
								"fromDate" : fromDateFinal,
								"toDate" : toDateFinal
							}
							rdDetailsVm.transactionDetails(obj);
						}
					},
					inputDate: new Date(),
					from: new Date(),
					to: dateRange2,
					mondayFirst: true,
					closeOnSelect: false,
					templateType: 'popup',
					dateFormat: 'dd MMM yyyy'

				};

				ionicDatePicker.openDatePicker(rdDetailsVm.dateObj);
			};

			rdDetailsVm.effectiveRatePopup = function () {
				var content = 'Interest paid on premature withdrawal of term deposits could be less than the contracted rate, as per the appicable rule on the date of premature payment. Premature- closure for e-RD (Recurring Deposit) would be as per applicable rules for the term Deposits. For current rules, please visit <a target="_blank" href="https://sbi.co.in">https://sbi.co.in</a>. Presently, the penalty on premature withdrawals of Domestic Retail Term Deposits (effective from 01 April 2017) is as under:</br></br>1. Retail Term Deposits up to Rs.5.00 lacs : 0.50% (Penalty for All Tenures).</br></br>2. Retail Term Deposits above Rs.5.00 lacs but below Rs.1 Crore : 1% (Penalty for All Tenures).</br></br>3. The interest shall be 0.50% or 1% below the rate appicable at the applicable at the times of Deposits for the period Deposit has remained with the bank or 0.50% or 1% below the contracted rate, whichever is lower.</br></br>4. No interest will be paid on Deposits which remain for a period of less than 7 days.';
				var template = '<div class="popupTextBottomPadding fontSize-subHeading"><div class="text-justify">'+content+'</div></div></div>';
				$ionicPopup.show({
					title: 'Effective Interest Rate',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.rdDetailsClosureConfirm');
						}
					}],
				});
			}

			rdDetailsVm.nomineeInfo = function () {
				var title = '';
				var onTap = 'menu.reviewFD';
				var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey">{{rdDetailsVm.nonominee}}</div>';
				fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
			}

			String.prototype.toProperCase = function () {
			    return this.replace(/\w\S*/g, function(txt){return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();});
			};

			rdDetailsVm.editnominee = function () {
				rdService.customer.nomineeClick = "closeRd"
				// var account_number = "";
				if (rdService.viewRdData.nightModeFlag == "N") {
					rdService.fetchNomineeDetails().then(function(data) {
						if (data != null) {
							rdService.createRdData.name = data.name;
							rdService.customer.nominee = data.name;

							rdService.createRdData.minor = data.minor;
							rdService.customer.minorFlag = data.minor;

							rdService.createRdData.guardianName = data.guardianName;
							rdService.customer.guardian = data.guardianName;

							rdService.createRdData.dob = data.dob.trim();
							rdService.customer.dob = data.dob.trim();

							rdService.createRdData.address = data.address;
							rdService.customer.address1 = data.address;
							
							rdService.createRdData.relationship = data.relationship.toProperCase();
							rdService.customer.relation = data.relationship.toProperCase();
							$state.go('menu.nomineeRd');
						} else {
							if (rdService.customer.nominee == "") {
								var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>No nominee found!!</span></div></div></div>';
								$ionicPopup.show({
									title: '',
									template: template,
									scope: $scope,
									cssClass: 'my-custom-popup',
									buttons: [{
										text: 'OK',
										type: 'button-assertive',
										onTap: function () {
											$state.go('menu.nomineeRd');
										}
									}],
								});
							} else {
								$state.go('menu.nomineeRd');
							}
						}
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					var template = 'View Nominee detail service is currently unavailable. You can view nominee detail during the next business hour.';
					$ionicPopup.show({
						title: '',
						template: '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey">'+template+'</div>',
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								if (rdService.customer.nomineeClick === 'closeRd') {
									$state.go('menu.rdDetailsClosure');
								}
								if (rdService.customer.nomineeClick === 'reviewRd') {
									$state.go('menu.reviewRd');
								}
							}
						}],
					});
				}
			}

			rdDetailsVm.termconditionPopUp = function (TnCDetails) {
				var title = 'Terms & Conditions';
				var templateUrl;
				var cssClass = "ODtncPopup";
				var onTap = '';
				templateUrl = '<div class="fontSize-subHeading font-content roboto-light" ng-click="rdDetailsVm.closePopup()">' + TnCDetails + '</div>';
				rdDetailsVm.closeTnC = rdService.showTnCAlertModal(title, templateUrl, onTap, cssClass, $scope, $state);
			}

			//public functions end
			rdDetailsVm.termcondition = function () {
				if(rdService.normalFDTnC == "") {
					rdService.fetchRtermcondition().then(function(data) {
						if (!utilityService.isUndefined(data)) {
							rdService.normalFDTnC = data;
							rdDetailsVm.termconditionPopUp(rdService.normalFDTnC);
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					rdDetailsVm.termconditionPopUp(rdService.normalFDTnC);
				}
			}

			rdDetailsVm.transactionDetails = function(obj) {	
				rdClosureService.transactionDetails(obj).then(function(data) {
					rdDetailsVm.transDetails = data;
				},function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			rdDetailsVm.selectedAccountFun = function () {
				if (rdDetailsVm.creditToAccount) {
					var data = rdDetailsVm.creditToAccount.split(",");
					var e = [];
					e.accountNumber = data[0];
					e.accountType = data[1];
					e.indexId = data[2];
					rdDetailsVm.indexId = e.indexId;

					rdDetailsVm.selectedAccountType = e.accountType;

					rdDetailsVm.selectedAccountNumber = e.accountNumber;

					rdDetailsVm.selectedAccountAmount = e.accountBalance;
					rdService.customer.selectedItem = e.accountNumber;
					rdService.customer.nominee = "";
				}
			};

			rdDetailsVm.accountDetails = function() {
				if (!rdService.accountDetailsCloser.length) {
					getAccountDetailsService.getAccountDetails().then(function(data) {
	                    rdService.accountDetailsCloser = data.accounts;  
	                    rdDetailsVm.accountDetails = rdService.accountDetailsCloser;  
	                    rdDetailsVm.indexId = 0;
	                    rdDetailsVm.creditToAccount = rdDetailsVm.accountDetails[0].accountNumber + "," + rdDetailsVm.accountDetails[0].accountType + ",0";
						if (rdDetailsVm.creditToAccount) {
							var data = rdDetailsVm.creditToAccount.split(",");
							var e = [];
							e.accountNumber = data[0];
							e.accountType = data[1];
							e.indexId = data[2];
							rdDetailsVm.indexId = e.indexId;
							// rdService.customer.indexId = rdDetailsVm.indexId;

							rdDetailsVm.selectedAccountType = e.accountType;

							rdDetailsVm.selectedAccountNumber = e.accountNumber;

							rdDetailsVm.selectedAccountAmount = e.accountBalance;
							rdService.customer.selectedItem = e.accountNumber;
						}
					},function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
	                rdDetailsVm.accountDetails = rdService.accountDetailsCloser;  
					rdDetailsVm.indexId = 0;
	                rdDetailsVm.creditToAccount = rdDetailsVm.accountDetails[0].accountNumber + "," + rdDetailsVm.accountDetails[0].accountType + ",0";
					if (rdDetailsVm.creditToAccount) {
						var data = rdDetailsVm.creditToAccount.split(",");
						var e = [];
						e.accountNumber = data[0];
						e.accountType = data[1];
						e.indexId = data[2];
						rdDetailsVm.indexId = e.indexId;
						// rdService.customer.indexId = rdDetailsVm.indexId;

						rdDetailsVm.selectedAccountType = e.accountType;

						rdDetailsVm.selectedAccountNumber = e.accountNumber;

						rdDetailsVm.selectedAccountAmount = e.accountBalance;
						rdService.customer.selectedItem = e.accountNumber;
					}
				}
			}

			rdDetailsVm.confirmClosureRD = function() {	
			//Errors added as per the new BRS - DM2021129686
				if(!rdDetailsVm.disableConfirmClosure){
				
					if(rdDetailsVm.rdModeOperationButton == true || rdDetailsVm.showLA == true){
						rdDetailsVm.RDErrorCSS = 'app-footer app-footer-loginbanner bar bar-footer border-radius-top-left-right heightCountOne';
						rdDetailsVm.closeRDNotAllowedPopUp = true;
						$scope.showDrawer();
					}
					else if(rdDetailsVm.showLA == true && rdDetailsVm.rdModeOperationButton == true){
						rdDetailsVm.RDErrorCSS = 'app-footer app-footer-loginbanner bar bar-footer border-radius-top-left-right heightCountTwo';
						rdDetailsVm.closeRDNotAllowedPopUp = true;
						$scope.showDrawer();
						

					}

					else{
			
						var rdNumber = rdDetailsVm.rdAccNumber;
						rdClosureService.rdClosureCheckBranch(rdNumber).then(function (data) {
							rdDetailsVm.rdClosure();
						},
						function(error){
							utilityService.showErrorMessage(error.responseMessage);
						});
					}
				}
			}


			$scope.showDrawer=function(){
				$scope.slideDownTrue=false;
				$scope.slideUpTrue=true;
			}


			rdDetailsVm.OKCloseClosureMsgPopUp = function(){

				if(rdDetailsVm.closeRDNotAllowedPopUp){
					rdDetailsVm.closeRDNotAllowedPopUp = false;
				}
				$scope.hideDrawer();
			}


			$scope.hideDrawer=function(){
			  $scope.slideUpTrue=false;
			  $scope.slideDownTrue=true;
			}

			//Errors added as per the new BRS - DM2021129686
			rdDetailsVm.rdClosure = function(){
				var maskedNum = utilityService.maskData(rdService.viewRdData.accountNumber, "front", 4);
				var template = 'Are you sure you want to close your recurring deposit ' + maskedNum + '?';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'Cancel',
						type: 'button-assertive',
						onTap: function () {
							// if (onTapgo !== '' && onTapgo !== null) {
								$state.go('menu.rdDetailsClosure');
							// }
						}
					},{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							var account_number = rdService.viewRdData.accountNumber
							rdClosureService.RDprematureClosure(account_number).then(function(data) {
								rdService.viewRdData.amountCredit = data.netAmountCredited;
								rdService.viewRdData.principalAmount = data.penalty;
								$state.go('menu.rdDetailsClosureConfirm');
							},function(error) {
								utilityService.showErrorMessage(error.responseMessage);
							});
						}
					}],
				});
			}

			rdDetailsVm.confirmClosureRDConfirm = function() {
				var obj = {
					"fromAccount": "",
					"toAccount": rdDetailsVm.selectedAccountNumber,
					"payableAmount": rdService.viewRdData.amountCredit,
				};
				var maskedRDAcc = utilityService.maskData(rdService.viewRdData.accountNumber, "front", 4);
				$state.go('menu.closeDepositOTP',{depositObject: {depositType: 'rdClosure',rdDetailsVm: rdDetailsVm,rdParams:obj}});
			}

			rdDetailsVm.getCBValue = function (isChecked) {
				if (isChecked === true) {
					rdDetailsVm.disablesubmit = false;
					rdDetailsVm.checkTnC = true;
				}
				else {
					rdDetailsVm.disablesubmit = true;
					rdDetailsVm.checkTnC = false;
				}
			}

			rdDetailsVm.selectePeriodTrans = function () {
				var today = new Date();
				var today2 = new Date();
				// console.log(today)
				var fromDateFormat = "";
				var fromDateFinal = "";
				var toDateFormat = "";
				var toDateFinal = "";
				// console.log(rdDetailsVm.selectPeriod)
				if (rdDetailsVm.selectPeriod != "") {
					if (rdDetailsVm.selectPeriod && rdDetailsVm.selectPeriod == "by_date") {
						rdDetailsVm.showDateDiv = false;
					} else {
						rdDetailsVm.showDateDiv = true;
					}
					// SonarQube issue fix added - Need to reviewed by Architect
					if (rdDetailsVm.selectPeriod == 1 || rdDetailsVm.selectPeriod == 3 || rdDetailsVm.selectPeriod == 6 || rdDetailsVm.selectPeriod == 10) {
						
							var date = today.setMonth(today.getMonth() - parseInt(rdDetailsVm.selectPeriod));
							var fromDate = new Date(date).toISOString().slice(0,10);
							fromDateFormat = fromDate.toString().split('-');
							fromDateFinal = fromDateFormat[2] + fromDateFormat[1] + fromDateFormat[0]

							var toDate = new Date(today2).toISOString().slice(0,10);
							toDateFormat = toDate.toString().split('-');
							toDateFinal = toDateFormat[2] + toDateFormat[1] + toDateFormat[0]
						

						var obj = {
							"fromDate" : fromDateFinal,
							"toDate" : toDateFinal
						}
						rdDetailsVm.transactionDetails(obj);
					}
				} else {
	                rdDetailsVm.transDetails = rdService.viewRdData.transactionDetails
				}
			}

			rdDetailsVm.receiptEmail = function () {
				utilityService.showSpinner();
				rdService.rdEmailReceipt().then(function (data) {
					utilityService.hideSpinner();
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="">Mail has been sent to your registered email id.</div>';
					$ionicPopup.show({
						title: '',
						template: template,
						cssClass: 'my-custom-popup',
						buttons: [{
							text:'OK',
							type: 'button-assertive',
							onTap: function() { 
							}
						}],
					});
				}, function (error) {
					utilityService.hideSpinner();
					var msg = '<div class="font-size-16 roboto-medium">'+error.responseMessage+'</div>'
					utilityService.showBhimUpiAlert("info", msg, "", "OK", $scope);
				});
			}

			rdDetailsVm.download = function () {
				utilityService.showSpinner();
				rdService.rdDownloadReceipt().then(function (data) {
					utilityService.hideSpinner();
					var content = data.pdf;
					var fileName = data.fileName + '.pdf';
					pwdProtectedPdfDownloadService.savePDF(fileName, content, "").then(function(response){
						pwdProtectedPdfDownloadService.pwdCommonTemplate();	
					},function error(e){
						utilityService.hideSpinner();
						utilityService.showErrorMessage(e);
					});
				}, function (error) {
					utilityService.hideSpinner();
					var msg = '<div class="font-size-16 roboto-medium">'+error.responseMessage+'</div>'
					utilityService.showBhimUpiAlert("info", msg, "", "OK", $scope);
				});
			}

			rdDetailsVm.closeBetweenDate = function () {
				rdDetailsVm.showDateDiv = true;
				rdDetailsVm.selectPeriod = "";
			}

			rdDetailsVm.goBacktoPrevious = function(){
				$state.go('menu.rdDetailsClosure')
			}

			rdDetailsVm.goToAO = function () {
				$state.go("menu.accountOverviewMyBalance");
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
				// if(getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
				// 	getAccountDetailsService.getAccountsAccessRights('').then( function(data) {
                //     getAccountDetailsService.accessRightsData = data;
				// 	}, function(error) {
				// 		// Failure block
				// 	});
				// }
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				rdDetailsVm.disablesubmit = true;

				rdDetailsVm.fromeDate = new Date().toISOString().slice(0,10);
				rdDetailsVm.toDate = new Date().toISOString().slice(0,10);

				rdDetailsVm.fdNumber = rdService.viewRdData.productDescription
				rdDetailsVm.rdAccName = rdService.viewRdData.accountName
				rdDetailsVm.rdAccNumber = rdService.viewRdData.accountNumber
				rdDetailsVm.balAmount = rdService.viewRdData.currentBalance
				rdDetailsVm.rdIRate = rdService.viewRdData.iRate
				rdDetailsVm.rdMDate = rdService.viewRdData.maturityDate 
				rdDetailsVm.rdOpenDate = rdService.viewRdData.accountOpeningDate
				rdDetailsVm.eyesOffFun(rdDetailsVm.rdAccNumber);
				
				if (rdService.viewRdData.nightModeFlag == "Y") {
					rdDetailsVm.nightMode = true;
				} else {
					rdDetailsVm.nightMode = false;
				}


				// rdDetailsVm.rdTensure = rdService.viewRdData.years + " Years " + rdService.viewRdData.months + " Months"
				if (rdService.viewRdData.years == 0 || rdService.viewRdData.years == 1 && rdService.viewRdData.months > 1) {
					rdDetailsVm.rdTensure = rdService.viewRdData.years + " Year " + rdService.viewRdData.months + " Months";
				} else if (rdService.viewRdData.months == 0 || rdService.viewRdData.months == 1 && rdService.viewRdData.years > 1) {
					rdDetailsVm.rdTensure = rdService.viewRdData.years + " Year " + rdService.viewRdData.months + " Month";
				} else if (rdService.viewRdData.months > 1 && rdService.viewRdData.years > 1) {
					rdDetailsVm.rdTensure = rdService.viewRdData.years + " Years " + rdService.viewRdData.months + " Months";
				} else {
					rdDetailsVm.rdTensure = rdService.viewRdData.years + " Year " + rdService.viewRdData.months + " Month";
				}
				rdDetailsVm.rdModeOperation = rdService.viewRdData.mop
				rdDetailsVm.rdMIntruction = rdService.viewRdData.mIntruction
				rdDetailsVm.rdAccInterest = rdService.viewRdData.accumulatedInterest
				rdDetailsVm.rdOutAmount = rdService.viewRdData.termValue
				rdDetailsVm.rdLienAmount = rdService.viewRdData.holdValue
				rdDetailsVm.maturityAmountValue = rdService.viewRdData.maturityAmount

				rdDetailsVm.account = rdService.viewRdData.accountNumber
				rdDetailsVm.name = rdService.viewRdData.accountName
				rdDetailsVm.principalAmount = rdService.viewRdData.principalAmount
                rdDetailsVm.iRate = rdService.viewRdData.iRate
                rdDetailsVm.amountCredit = rdService.viewRdData.amountCredit
                if (!rdDetailsVm.selectPeriod || rdDetailsVm.selectPeriod == "" || rdDetailsVm.selectPeriod == undefined) {
                	rdDetailsVm.transDetails = rdService.viewRdData.transactionDetails
                }

                if (rdService.viewRdData.mop  !== undefined && rdService.viewRdData.mop   !== "" && rdService.viewRdData.mop  !== null) {
				

				
					if (rdService.viewRdData.mop != "SINGLE") {
						rdDetailsVm.rdModeOperationButton = true;
					} else {
						rdDetailsVm.rdModeOperationButton = false;
					}
				}
				else{
					rdDetailsVm.disableConfirmClosure = true;
				}

				if (rdDetailsVm.rdLienAmount  !== undefined && rdDetailsVm.rdLienAmount  !== "" && rdDetailsVm.rdLienAmount !== null) {
					rdDetailsVm.rdLienAmountINT = parseInt(rdDetailsVm.rdLienAmount);
					if (rdDetailsVm.rdLienAmountINT  > 0) {
						rdDetailsVm.showLA = true;
					} else {
						rdDetailsVm.showLA = false;
					}
				} else{
					rdDetailsVm.disableConfirmClosure = true;
				}
				rdDetailsVm.currency = getAccountDetailsService.currency ;
				
				// rdDetailsVm.transactionDetails();
				rdDetailsVm.accountDetails();
			});

			return this;
		}
]);


