angularApp.service('rdService',
	function ($q, utilityService, AdapterUtils, customerInfoService, fixedDepositService, $ionicPopup, secKeyValidationServices,constantConfig) {
		var RDservice = this;

		RDservice.accountDetails = [];
		RDservice.accountDetailsCloser = [];
		RDservice.interestRateDetails = [];
		RDservice.normalFDTnC = "";

		RDservice.selectedDetails = {
			accountType: '',
			accountNumber: '',
			accountBalance: '',
			isActive: '',
			isTransactional: '',
			branchCode: '',
			branchName: '',
			intCategory: '',
			accountTypeCode: '',
			productCodeNRI: ''
		};

		RDservice.createRdData = {
			enddate: '',
			tensure: '',
			siDate: '',
			monthControAmount: '',
			monthControDate: '',
			maturityDate: '',
			maturityAmount: '',
			iRate: '',
			accountNumberCreate: '',
			accountTypeCode: '',
			accountType: '',
			name: '',
			minor: '',
			guardianName: '',
			dob: '',
			address: '',
			nomIndexid: '',
			relationship: '',
			nightModeFlag: 'N',
			modeOfOperation: '',
			amount: '',
			days: '',
			years: '',
			interestSelectYear: '',
			months: ''
		};


		RDservice.viewRdData = {
			enddate: '',
			tensure: '',
			siDate: '',
			monthControAmount: '',
			monthControDate: '',
			accumulatedInterest: '',
			nightModeFlag: "N",
			mop: '',
			currentBalance: '',
			accountName: '',
			holdValue: '',
			accountOpeningDate: '',
			productDescription: '',
			accountNumber: '',
			termValue: '',
			amountCredit: '',
			principalAmount: '',
			maturityDate: '',
			maturityAmount: '',
			rdOutAmount: '',
			iRate: '',
			accountNumberCreate: '',
			accountTypeCode: '',
			name: '',
			minor: '',
			guardianName: '',
			dob: '',
			address: '',
			relationship: '',
			amount: '',
			days: '',
			years: '',
			months: '',
			transactionDetails: []
		};

		RDservice.Relations = [];
		RDservice.customer = {
			amountData: '',
			years: '',
			months: '',
			days: '',
			maturityDate: '',
			interestRate: '',
			maturityAmount: '',
			interestPayout: '',
			maturityInstruction: '',
			diffDays: '',
			maturityDateFull: '',
			isvalidDays: '',
			isTaxable: false,
			accountNo: '',
			fdAccountNumber: '',
			loanEligibility: '',
			receiptLink: '',
			nomineeClick: '',
			selectedItem: '',
			ODLimit: '',
			ODIntRate: '',
			ODExyDate: '',
			isSenior: true,
			custName: '',
			custDOB: '',
			nominee: '',
			age: '',
			relation: '',
			guardian: '',
			address1: '',
			address2: '',
			dob: '',
			showNominee: false,
			viewInterest: false,
			isPanAvailable: '',
			fdnumber: '',
			AODclick: '',
			intpayoutMD: '',
			intpayoutAMT: '',
			maturitydateRequest: '',
			nameToBePrintedFlag: '',
			minorFlag: '',
			custype: '',
			intpayoutservice: '',
			matInstService: '',
			indexId: 0,
			amountCredited: '',
			effectiveInterestRates: '',
			clickback: '',
			intpaycheck: '',
			nomIndexid: '',
			checkPAL: '',
			preApprovedLoanAmount: '',
			product: '',
			principalAmount: '',
			checkPage: false,
			maturitydateFD: '',
			maturitydateFDRequest: '',
			branchCode: '',
			branchName: '',
			intpayamount: '',
			intpaystring: '',
			checkNominee: false,
			fdCloseClick: '',
			intpayoutACCT: '',
			intCategory: '',
			accountTypeCode: '',
			nightMode: '',
			modeOfOperation: '',
			scheme:''
		};

		// getting data of full rd
		RDservice.initialValueStage = function() {
			RDservice.createRdData = {
				enddate: '',
				tensure: '',
				siDate: '',
				monthControAmount: '',
				monthControDate: '',
				maturityDate: '',
				maturityAmount: '',
				iRate: '',
				accountNumberCreate: '',
				accountTypeCode: '',
				accountType: '',
				name: '',
				minor: '',
				guardianName: '',
				dob: '',
				address: '',
				nomIndexid: '',
				relationship: '',
				nightModeFlag: 'N',
				modeOfOperation: '',
				amount: '',
				days: '',
				years: '',
				months: ''
			};
			RDservice.customer = {
				amountData: '',
				years: '',
				months: '',
				days: '',
				maturityDate: '',
				interestRate: '',
				maturityAmount: '',
				interestPayout: '',
				maturityInstruction: '',
				diffDays: '',
				maturityDateFull: '',
				isvalidDays: '',
				isTaxable: false,
				accountNo: '',
				fdAccountNumber: '',
				loanEligibility: '',
				receiptLink: '',
				nomineeClick: '',
				selectedItem: '',
				ODLimit: '',
				ODIntRate: '',
				ODExyDate: '',
				isSenior: true,
				custName: '',
				custDOB: '',
				nominee: '',
				age: '',
				relation: '',
				guardian: '',
				address1: '',
				address2: '',
				dob: '',
				showNominee: false,
				viewInterest: false,
				isPanAvailable: '',
				fdnumber: '',
				AODclick: '',
				intpayoutMD: '',
				intpayoutAMT: '',
				maturitydateRequest: '',
				nameToBePrintedFlag: '',
				minorFlag: '',
				custype: '',
				intpayoutservice: '',
				matInstService: '',
				indexId: 0,
				amountCredited: '',
				effectiveInterestRates: '',
				clickback: '',
				intpaycheck: '',
				nomIndexid: '',
				checkPAL: '',
				preApprovedLoanAmount: '',
				product: '',
				principalAmount: '',
				checkPage: false,
				maturitydateFD: '',
				maturitydateFDRequest: '',
				branchCode: '',
				branchName: '',
				intpayamount: '',
				intpaystring: '',
				checkNominee: false,
				fdCloseClick: '',
				intpayoutACCT: '',
				intCategory: '',
				accountTypeCode: '',
				nightMode: '',
				modeOfOperation: '',
				scheme:''
			};
			RDservice.selectedDetails = {
				accountType: '',
				accountNumber: '',
				accountBalance: '',
				isActive: '',
				isTransactional: '',
				branchCode: '',
				branchName: '',
				intCategory: '',
				accountTypeCode: ''
			};
			// RDservice.accountDetails = []
		}

		// getting data of full rd
		RDservice.initialCloseValueStage = function() {
			RDservice.viewRdData = {
				enddate: '',
				tensure: '',
				siDate: '',
				monthControAmount: '',
				monthControDate: '',
				accumulatedInterest: '',
				mop: '',
				currentBalance: '',
				accountName: '',
				holdValue: '',
				accountOpeningDate: '',
				productDescription: '',
				accountNumber: '',
				termValue: '',
				amountCredit: '',
				principalAmount: '',
				maturityDate: '',
				maturityAmount: '',
				rdOutAmount: '',
				iRate: '',
				accountNumberCreate: '',
				accountTypeCode: '',
				name: '',
				minor: '',
				guardianName: '',
				dob: '',
				address: '',
				relationship: '',
				amount: '',
				days: '',
				years: '',
				months: ''
			};
			RDservice.customer = {
				amountData: '',
				years: '',
				months: '',
				days: '',
				maturityDate: '',
				interestRate: '',
				maturityAmount: '',
				interestPayout: '',
				maturityInstruction: '',
				diffDays: '',
				maturityDateFull: '',
				isvalidDays: '',
				isTaxable: false,
				accountNo: '',
				fdAccountNumber: '',
				loanEligibility: '',
				receiptLink: '',
				nomineeClick: '',
				selectedItem: '',
				ODLimit: '',
				ODIntRate: '',
				ODExyDate: '',
				isSenior: false,
				custName: '',
				custDOB: '',
				nominee: '',
				age: '',
				relation: '',
				guardian: '',
				address1: '',
				address2: '',
				dob: '',
				showNominee: false,
				viewInterest: false,
				isPanAvailable: '',
				fdnumber: '',
				AODclick: '',
				intpayoutMD: '',
				intpayoutAMT: '',
				maturitydateRequest: '',
				nameToBePrintedFlag: '',
				minorFlag: '',
				custype: '',
				intpayoutservice: '',
				matInstService: '',
				indexId: 0,
				amountCredited: '',
				effectiveInterestRates: '',
				clickback: '',
				intpaycheck: '',
				nomIndexid: '',
				checkPAL: '',
				preApprovedLoanAmount: '',
				product: '',
				principalAmount: '',
				checkPage: false,
				maturitydateFD: '',
				maturitydateFDRequest: '',
				branchCode: '',
				branchName: '',
				intpayamount: '',
				intpaystring: '',
				checkNominee: false,
				fdCloseClick: '',
				intpayoutACCT: '',
				intCategory: '',
				accountTypeCode: '',
				nightMode: '',
				modeOfOperation: '',
				scheme:''
			};
			RDservice.createRdData = {
				enddate: '',
				tensure: '',
				siDate: '',
				monthControAmount: '',
				monthControDate: '',
				maturityDate: '',
				maturityAmount: '',
				iRate: '',
				accountNumberCreate: '',
				accountTypeCode: '',
				accountType: '',
				name: '',
				minor: '',
				guardianName: '',
				dob: '',
				address: '',
				nomIndexid: '',
				relationship: '',
				nightModeFlag: 'N',
				modeOfOperation: '',
				amount: '',
				days: '',
				years: '',
				months: ''
			};
		}

		RDservice.viewRdFullRd = function(acc_number) {
			console.log("inside Rd service");
			var q = $q.defer();
			var obj = {
				"accountNumber": acc_number
			};
			console.log(obj)
			AdapterUtils.postData("adapters/RecurringDepositAdapter/viewRDDetails",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		// getting data for first screen createrd
		RDservice.getcheckAccessRights = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/RecurringDepositAdapter/accountFilterRequest",{},true).then(
			// AdapterUtils.postData("adapters/ServiceRequestAdapter/accountFilterRequest",{},true).then(
				function(response){	

					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		RDservice.fetchNomineeDetails = function () {
			var q = $q.defer();
			// var obj = {
			// 	"accountNumber": acc_number
			// };
			AdapterUtils.postData("adapters/RecurringDepositAdapter/fetchNomineeDetails", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		// create rd screen 1 on change dropdown 
		RDservice.checkModeOfOperation = function (acc_number) {
			var q = $q.defer();
			var obj = {
				"accountNumber": acc_number
			};
			AdapterUtils.postData("adapters/RecurringDepositAdapter/checkModeOfOperation", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		// create rd screen 1 on change dropdown 
		RDservice.checkPreEvaluation = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/RecurringDepositAdapter/checkPreEvaluation", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		// confirm creating rd
		RDservice.createFixedDeposit = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/RecurringDepositAdapter/createRecurringDeposit", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		RDservice.fetchRtermcondition = function () {
			var q = $q.defer();
			var obj = {
				"type" : "rdTnC"
			}
			// AdapterUtils.getData("adapters/FixedDepositAdapter/fetchTermsandConditions", true).then(
			AdapterUtils.postData("adapters/RecurringDepositAdapter/getTnC", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		RDservice.rdDownloadReceipt = function () {
			var q = $q.defer();
			var requestSecKey = secKeyValidationServices.generatesRandomNums();
			// AdapterUtils.getData("adapters/FixedDepositAdapter/fetchTermsandConditions", true).then(
			var requestParams = {
				"secKey":requestSecKey,
				"isNewBuild":"true"
			}
			AdapterUtils.postData("adapters/RecurringDepositAdapter/rdDownloadReceipt",requestParams, true).then(
				function (response) {
					var finalcalculatedKey = secKeyValidationServices.verifySecKey(parseInt(response.secKey));
					if(requestSecKey === finalcalculatedKey){
						q.resolve(response.data);
					}else{
						q.reject({responseMessage:constantConfig.secKeyErrors.technicalError});
					}
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		RDservice.rdEmailReceipt = function () {
			var q = $q.defer();
			var requestSecKey = secKeyValidationServices.generatesRandomNums();
			var requestParams = {
				"secKey":requestSecKey
			}
			// AdapterUtils.getData("adapters/FixedDepositAdapter/fetchTermsandConditions", true).then(
			AdapterUtils.postData("adapters/RecurringDepositAdapter/rdEmailReceipt",requestParams, true).then(
				function (response) {
					var finalcalculatedKey = secKeyValidationServices.verifySecKey(parseInt(response.secKey));
					if(requestSecKey === finalcalculatedKey){
						q.resolve(response.data);
					}else{
						q.reject({responseMessage:constantConfig.secKeyErrors.technicalError});
					}
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
			  		
		RDservice.showAlertModal = function (title, template, onTapgo, $scope, $state) {
			var alertPopup = $ionicPopup.show({
				title: title,
				template: template,
				scope: $scope,
				cssClass: 'my-custom-popup',
				buttons: [{
					text: 'OK',
					type: 'button-assertive',
					onTap: function () {
						if (onTapgo !== '' && onTapgo !== null) {
							$state.go(onTapgo);
						}
					}
				}],
			});
		}
		RDservice.showTnCAlertModal = function (title, template, onTapgo, cssClasstnc, $scope, $state) {
			var alertPopup = $ionicPopup.show({
				title: title,
				template: template,
				scope: $scope,
				cssClass: cssClasstnc,
				buttons: [{
					text: 'OK',
					type: 'button-assertive',
					onTap: function () {
						if (onTapgo !== '' && onTapgo !== null) {
							$state.go(onTapgo);
						}
					}
				}],
			});
			return alertPopup;
		}


		return RDservice;
	});  
