'use strict';
angularApp.controller('reviewRdController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"rdService",
		"customerInfoService",
		"getAccountDetailsService",
		"openUrlInAppbroswerService",
		"constantConfig",
		"myDreamsService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,rdService, customerInfoService, getAccountDetailsService, openUrlInAppbroswerService, constantConfig, myDreamsService) {
			
			var reviewRdVm = this;
			reviewRdVm.nightMode = false;
			function initPage() {
				// reviewRdVm.showBack = false;
				// reviewRdVm.showNext = true;
				// createRdVm.disablenext = true;
				// createRdVm.isValidError = false;
				// createRdVm.validErrorMessage = "";
				// createRdVm.isValidAccount = false;
				// createRdVm.validAccountMessage = "";

				reviewRdVm.availod = true;
				reviewRdVm.closeDetails = [];
				reviewRdVm.nightMode = false;
				$translate(['NAME', 'MONTHLY_CONTRO', 'MONTHLY_CONTRO_DATE', 'TENSURE', 'MATURITY_AMOUNT', 'PAMOUNT', 'ACCOUNT', 'MDATE', 'MAMOUNT', 'RATE_OF_INT', 'IPAYOUT', 'MINSTRUCTION', 'NOMINEE', 'READTERMS', 'CONGRATS', 'FIXED_DEPOSIT', 'REGISTERED', 'NOMINEELINK', 'NO_NOMINEE']).then(function (translations) {
					reviewRdVm.name = translations['NAME'];
					reviewRdVm.monthlyContro = translations['MONTHLY_CONTRO'];
					reviewRdVm.monthlyControDate = translations['MONTHLY_CONTRO_DATE'];
					reviewRdVm.tensure = translations['TENSURE'];
					reviewRdVm.mAmount = translations['MATURITY_AMOUNT'];
					reviewRdVm.pAmount = translations['PAMOUNT'];
					reviewRdVm.account = translations['ACCOUNT'];
					reviewRdVm.mDate = translations['MDATE'];
					reviewRdVm.mAmount = translations['MAMOUNT'];
					reviewRdVm.iRate = translations['RATE_OF_INT'];
					reviewRdVm.iPayout = translations['IPAYOUT'];
					reviewRdVm.mInstruction = translations['MINSTRUCTION'];
					reviewRdVm.Nominee = translations['NOMINEE'];
					reviewRdVm.termscondition = translations['READTERMS'];
					reviewRdVm.congrats = translations['CONGRATS'];
					reviewRdVm.fdTitle = translations['FIXED_DEPOSIT'];
					reviewRdVm.register = translations['REGISTERED'];
					reviewRdVm.nomineeLink = translations['NOMINEELINK'];
					reviewRdVm.nonominee = translations['NO_NOMINEE'];
				});
			};

			reviewRdVm.termconditionPopUp = function (TnCDetails) {
				var title = 'Terms & Conditions';
				var templateUrl;
				var cssClass = "ODtncPopup";
				var onTap = '';
				templateUrl = '<div class="fontSize-subHeading font-content roboto-light" ng-click="reviewRdVm.closePopup()">' + TnCDetails + '</div>';
				reviewRdVm.closeTnC = rdService.showTnCAlertModal(title, templateUrl, onTap, cssClass, $scope, $state);
			}

			//public functions end
			reviewRdVm.termcondition = function () {
				if(rdService.normalFDTnC == "") {
					rdService.fetchRtermcondition().then(function (data) {
						if (!utilityService.isUndefined(data)) {
							rdService.normalFDTnC = data;
							reviewRdVm.termconditionPopUp(rdService.normalFDTnC);
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					reviewRdVm.termconditionPopUp(rdService.normalFDTnC);
				}
			}
			
			reviewRdVm.closePopup = function () {
				reviewRdVm.closeTnC.close();
				utilityService.hideSpinner();
			}

			reviewRdVm.nomineeInfo = function () {
				var title = '';
				var onTap = 'menu.reviewFD';
				var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey">{{reviewRdVm.nonominee}}</div>';
				fixedDepositService.showAlertModal(title, template, onTap, $scope, $state);
			}
			reviewRdVm.getCBValue = function (isChecked) {
				if (isChecked === true) {
					reviewRdVm.disableconfirm = false;
					reviewRdVm.checkTnC = true;
				}
				else {
					reviewRdVm.disableconfirm = true;
					reviewRdVm.checkTnC = false;
				}
			}

			String.prototype.toProperCase = function () {
			    return this.replace(/\w\S*/g, function(txt){return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();});
			};

			reviewRdVm.editnominee = function () {
				rdService.customer.nomineeClick = "reviewRd"
				// console.log(rdService.customer.nomineeClick)
				if (rdService.createRdData.nightModeFlag == "N") {
					if (rdService.createRdData.name == "") {
						rdService.fetchNomineeDetails().then(function(data) {
							// console.log("fetch nomineeeeee",data)
								if (data != null) {
									rdService.createRdData.name = data.name;
									rdService.createRdData.minor = data.minor;
									rdService.createRdData.guardianName = data.guardianName;

									rdService.createRdData.dob = data.dob.trim();
									// rdService.customer.dob = data.dob.trim();
									
									rdService.createRdData.address = data.address;
									rdService.createRdData.relationship = data.relationship.toProperCase();
									$state.go('menu.nomineeRd');
								} else {
									if (rdService.customer.nominee == "") {
										var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>No nominee found!!</span></div></div></div>';
										$ionicPopup.show({
											title: '',
											template: template,
											scope: $scope,
											cssClass: 'my-custom-popup',
											buttons: [{
												text: 'OK',
												type: 'button-assertive',
												onTap: function () {
													$state.go('menu.nomineeRd');
												}
											}],
										});
									} else {
										$state.go('menu.nomineeRd');
									}
								}
						},function(error){
							// console.log("fetch nomineeeeee error",error)
							utilityService.showErrorMessage(error.responseMessage);
						});
					} else {
						$state.go('menu.nomineeRd');
					}
				} else {
					var template = 'View Nominee detail service is currently unavailable. You can view nominee detail during the next business hour.';
					$ionicPopup.show({
						title: '',
						template: '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey">'+template+'</div>',
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								if (rdService.customer.nomineeClick === 'closeRd') {
									$state.go('menu.rdDetailsClosure');
								}
								if (rdService.customer.nomineeClick === 'reviewRd') {
									$state.go('menu.reviewRd');
								}
							}
						}],
					});
				}
			}

			function doubleDigitFormat(number) {
			    return (number < 10 ? '0' : '') + number
			}

			reviewRdVm.goToAO = function () {
				rdService.initialValueStage();
				$state.go("menu.accountOverviewMyBalance");
			}

			reviewRdVm.goToCancel = function () {
				$state.go("menu.createRdSave");
			}

			reviewRdVm.goToConfirm = function () {
				// console.log(rdService.createRdData)
				
				var amountCalc = (parseInt(rdService.createRdData.tensure) * parseInt(reviewRdVm.monthlyControAmount))
				var minorData = "";
				if (reviewRdVm.mDateVal) {
					var enddd = doubleDigitFormat(new Date(reviewRdVm.mDateVal).getDate());
					var endDate = new Date(reviewRdVm.mDateVal).toISOString().slice(0,10)
					var endDateFormat = endDate.toString().split('-');
					var endDateFinal = enddd + endDateFormat[1] + endDateFormat[0]
				} else {
					var endDateFinal = ""
				}
				
				if (rdService.customer.dob != "") {
					var dobdate = doubleDigitFormat(new Date(rdService.customer.dob).getDate());
					var dob = new Date(rdService.customer.dob).toISOString().slice(0,10);
					var dobFormat = dob.toString().split('-');
					var dobFinal = dobdate + dobFormat[1] + dobFormat[0]
				} else {
					var dobFinal = ""
				}

				if (reviewRdVm.monthlyControDateVal) {
					// var siDate = new Date(reviewRdVm.monthlyControDateVal).toISOString().slice(0,10)
					// var siDateFormat = siDate.toString().split('-');
					var siDateFinal = reviewRdVm.monthlyControDateVal
				} else {
					var siDateFinal = ""
				}

				var add1 = rdService.customer.address1;
				var tempaddr1 = rdService.customer.tempAddr1;
				var add2 = rdService.customer.address2;
				console.log("rdService.customer.minorFlag",rdService.customer.minorFlag)
				if (rdService.customer.minorFlag == true || rdService.createRdData.minor == true) {
					minorData = "Y"
				} else if (rdService.customer.minorFlag == false || rdService.createRdData.minor == false) {
					minorData = "N"
					add1 = "";
					tempaddr1 = "";
					add2 = "";
				} else {
					minorData = ""
				}

				if (rdService.customer.dob == "") {
					minorData = "";
				}

				console.log("minorData",minorData)
				var obj = {
					"dob": "",
					"endDate": endDateFinal,
					"tenure": rdService.createRdData.tensure,
					"installmentAmount": reviewRdVm.monthlyControAmount,
					"amount": amountCalc,
					"siDate": siDateFinal,
					"customerName": reviewRdVm.custName,
					"address1": "",
					"address2": "",
					"debitAccountNumber": reviewRdVm.accNumber,
					"nomineeName": rdService.customer.nominee,
					"minorFlag": minorData,
					"nomineeAddress": rdService.customer.address1,
					"relationship": rdService.customer.relation,
					"dateOfBirth": dobFinal,
					"guardianName": rdService.customer.guardian,
					"guardianAddress1": tempaddr1,
					"guardianAddress2": add2,
					"guardianAge": rdService.customer.age,
					"isSrCitizen": rdService.customer.isSenior,
					"pfNumber": getAccountDetailsService.accountOverviewData.customerInformation.pfNumber,
					"customerType": getAccountDetailsService.accountOverviewData.customerInformation.customerType
				};
				console.log(obj)

				if(myDreamsService.selectedDreamDetails && myDreamsService.selectedDreamDetails.dreamId){
					obj["dreamID"] = myDreamsService.selectedDreamDetails.dreamId;
				}
				reviewRdVm.shortDisableNext = 'Y';
				rdService.createFixedDeposit(obj).then(function (response) {
					if(response.responseCode == "0008"){
						var template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey">'+ response.responseMessage+'</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"></div>';
						reviewRdVm.successPopup = $ionicPopup.show({
						title: '',
						template: template,
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								rdService.initialValueStage();
								reviewRdVm.successPopup.close();
								getAccountDetailsService.accountOverviewData = "";
								utilityService.setCsatJournies('rdCreate');
								$state.go('menu.accountOverviewMyBalance');
							}
						}],
					});
					return "";
					}
					// response = response.data;
					reviewRdVm.shortDisableNext = '';
					reviewRdVm.newRdAccountNumber = response.accountNumber;
					reviewRdVm.maskedAccNumber = reviewRdVm.newRdAccountNumber ? utilityService.maskData(reviewRdVm.newRdAccountNumber, "front", 4) : "";
					reviewRdVm.referenceNo = response.storeRefNumber;
					var template = '';
					if (response.nightMode) {
						if (response.nightMode == "Y") {
							template = '<div class ="congratsOD"><img src="img/check.png" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey">Your request number '+reviewRdVm.referenceNo+' for Recurring Deposit has been received.</div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey">You will be notified once the request is processed.</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">You can check the status of the request from the menu under service request.</div>';
						} else {

							if(response.linkStatus && response.linkStatus.toLowerCase() == "success"){
								rdService.initialValueStage();
								getAccountDetailsService.accountOverviewData = "";
								utilityService.setCsatJournies('rdCreate');
								// utilityService.showBhimUpiAlert("success", "Your RD is created and linked successfully", "menu.accountOverviewMyBalance");
								template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="RD_CREATE" translate-values="{RDnumber:reviewRdVm.maskedAccNumber}"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">Your advice has been sent to your registered email id</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">Kindly visit the RD details page to check/update the nominee details.</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="font-link-blue" href="javascript:void(0)" translate="DOWNLOAD" ng-click="reviewRdVm.download()"></div>';
								// return true;
							}
							if(response.linkStatus && response.linkStatus.toLowerCase() !== "success"){
								rdService.initialValueStage();
								getAccountDetailsService.accountOverviewData = "";
								utilityService.setCsatJournies('rdCreate');
								utilityService.showBhimUpiAlert("alert", "We are unable to link the RD to the Dream " + myDreamsService.selectedDreamDetails.dreamName + " due to some technical reasons. Please link to your investment through linking process.", "menu.accountOverviewMyBalance");
								return true;
							}


							template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="RD_CREATE" translate-values="{RDnumber:reviewRdVm.maskedAccNumber}"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">Your advice has been sent to your registered email id</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">Kindly visit the RD details page to check/update the nominee details.</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="font-link-blue" href="javascript:void(0)" translate="DOWNLOAD" ng-click="reviewRdVm.download()"></div>';
						}
					} else {

						if(response.linkStatus && response.linkStatus.toLowerCase() == "success"){
							rdService.initialValueStage();
							getAccountDetailsService.accountOverviewData = "";
							utilityService.setCsatJournies('rdCreate');
							// utilityService.showBhimUpiAlert("success", "Your RD is created and linked successfully", "menu.accountOverviewMyBalance");
							template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="RD_CREATE" translate-values="{RDnumber:reviewRdVm.maskedAccNumber}"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">Your advice has been sent to your registered email id</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">Kindly visit the RD details page to check/update the nominee details.</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="font-link-blue" href="javascript:void(0)" translate="DOWNLOAD" ng-click="reviewRdVm.download()"></div>';
							// return true;
						}
						if(response.linkStatus && response.linkStatus.toLowerCase() !== "success"){
							rdService.initialValueStage();
							getAccountDetailsService.accountOverviewData = "";
							utilityService.setCsatJournies('rdCreate');
							utilityService.showBhimUpiAlert("alert", "We are unable to link the RD to the Dream " + myDreamsService.selectedDreamDetails.dreamName + " due to some technical reasons. Please link to your investment through linking process", "menu.accountOverviewMyBalance");
							return true;
						}


						template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="RD_CREATE" translate-values="{RDnumber:reviewRdVm.newRdAccountNumber}"></div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey">Your advice has been sent to your registered email id</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"><a class="font-link-blue" href="javascript:void(0)" translate="DOWNLOAD" ng-click="reviewRdVm.download()"></div>';

					}
					reviewRdVm.successPopup = $ionicPopup.show({
						title: '',
						template: template,
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								rdService.initialValueStage();
								reviewRdVm.successPopup.close();
								getAccountDetailsService.accountOverviewData = "";
								utilityService.setCsatJournies('rdCreate');
								$state.go('menu.accountOverviewMyBalance');
							}
						}],
					});
				}, function (error) {
					reviewRdVm.shortDisableNext = '';
					reviewRdVm.isChecked = false;
					reviewRdVm.disableconfirm = true;
					var response = error;
					if(response.responseCode == "0008"){
						var template = '<div class ="congratsOD"><img src="img/happyface.svg" height="45" width="45" class="happyFaceOD"></div><div class="button_fund_closure RFDpopup fontSize-heading roboto-regular font-dark-grey" translate="CONGRATSNEW"></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey">'+ response.responseMessage+'</div><div class="FDpopup-styling fontSize-subHeading roboto-light font-dark-grey"></div>';
						reviewRdVm.successPopup = $ionicPopup.show({
						title: '',
						template: template,
						scope: $scope,
						cssClass: 'my-custom-popup',
						buttons: [{
							text: 'OK',
							type: 'button-assertive',
							onTap: function () {
								rdService.initialValueStage();
								reviewRdVm.successPopup.close();
								getAccountDetailsService.accountOverviewData = "";
								utilityService.setCsatJournies('rdCreate');
								$state.go('menu.accountOverviewMyBalance');
							}
						}],
					});
					return "";
					}
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			function b64toBlob(b64Data, contentType, sliceSize) {
				contentType = contentType || '';
				sliceSize = sliceSize || 512;

				var byteCharacters = atob(b64Data);
				var byteArrays = [];

				for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
					var slice = byteCharacters.slice(offset, offset + sliceSize);

					var byteNumbers = [];
					for (var i = 0; i < slice.length; i++) {
						byteNumbers[i] = slice.charCodeAt(i);
					}

					var byteArray = new Uint8Array(byteNumbers);

					byteArrays.push(byteArray);
				}

				var blob = new Blob(byteArrays, { type: contentType });
				return blob;
			}

			function savebase64AsPDF(folderpath, filename, content, contentType) {
				// Convert the base64 string in a Blob
				var DataBlob = b64toBlob(content, contentType);
				filename = filename + ".pdf";
				window.resolveLocalFileSystemURL(folderpath, function (dir) {
					dir.getFile(filename, { create: true }, function (file) {
						file.createWriter(function (fileWriter) {
							fileWriter.write(DataBlob);

						}, function (error) {

						});
					});
				});
			}

			reviewRdVm.download = function () {
				rdService.rdDownloadReceipt().then(function (data) {
					// console.log("download reciept",data)
					var content = data.pdf;
					var filename = data.fileName;

					var contentStr = atob(content);
					var contentLen = contentStr.length;

					if(contentLen >= constantConfig.accOverview.pdfSize) {   
						utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
						return;
					}

					var contentType = "application/pdf";
					if (utilityService.isAndroidPlatform()) {
						reviewRdVm.folderpath = cordova.file.externalRootDirectory;
					}
					if (utilityService.isIOSPlatform()) {
						reviewRdVm.folderpath = cordova.file.documentsDirectory;
					}
					savebase64AsPDF(reviewRdVm.folderpath, filename, content, contentType);
					if (utilityService.isIOSPlatform()) {
						filename = filename + ".pdf";
						var finalObject = { "folderpath": reviewRdVm.folderpath, "filename": filename };
						openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "","");
						rdService.initialValueStage();
						reviewRdVm.successPopup.close();
						getAccountDetailsService.accountOverviewData = "";
						$state.go('menu.accountOverviewMyBalance');
					}
					/* to show information popup for downlaod receipt, which will tell user format of passowrd for android and ios */
					if (utilityService.isAndroidPlatform()) {
						var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:reviewRdVm.folderpath}"></div>';
						reviewRdVm.downloadPopup = $ionicPopup.show({
							title: '',
							template: template,
							scope: $scope,
							cssClass: 'my-custom-popup',
							buttons: [{
								text: 'OK',
								type: 'button-assertive',
								onTap: function () {
									rdService.initialValueStage();
									reviewRdVm.successPopup.close();
									getAccountDetailsService.accountOverviewData = "";
									$state.go('menu.accountOverviewMyBalance');
								}
							}],
						});
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			$scope.$on('$ionicView.beforeEnter', function () {
				// console.log(rdService.createRdData)
				// console.log(customerInfoService.customer)
				reviewRdVm.disableconfirm = true;
				reviewRdVm.custName = customerInfoService.customer.name;
				reviewRdVm.monthlyControAmount = rdService.createRdData.monthControAmount;
				reviewRdVm.monthlyControDateVal = rdService.createRdData.siDate;
				reviewRdVm.accNumber = rdService.createRdData.accountNumberCreate;

				if (reviewRdVm.monthlyControDateVal) {
					var suffixSet = reviewRdVm.monthlyControDateVal;
	            	if (suffixSet <= 3 || suffixSet == 21 || suffixSet == 22 || suffixSet == 23) {
	            		if (suffixSet == 1 || suffixSet == 21) {
	            			reviewRdVm.suffixValue = "st";
	            		} else if (suffixSet == 2 || suffixSet == 22) {
	            			reviewRdVm.suffixValue = "nd";
	            		} else if (suffixSet == 3 || suffixSet == 23) {
	            			reviewRdVm.suffixValue = "rd";
	            		}
	            	} else {
	            		reviewRdVm.suffixValue = "th";
	            	}
	            }

				if (rdService.createRdData.years == 0 || rdService.createRdData.years == 1 && rdService.createRdData.months > 1) {
					reviewRdVm.tensureVal = rdService.createRdData.years + " Year " + rdService.createRdData.months + " Months";
				} else if (rdService.createRdData.months == 0 || rdService.createRdData.months == 1 && rdService.createRdData.years > 1) {
					reviewRdVm.tensureVal = rdService.createRdData.years + " Year " + rdService.createRdData.months + " Month";
				} else if (rdService.createRdData.months > 1 && rdService.createRdData.years > 1) {
					reviewRdVm.tensureVal = rdService.createRdData.years + " Years " + rdService.createRdData.months + " Months";
				} else {
					reviewRdVm.tensureVal = rdService.createRdData.years + " Year " + rdService.createRdData.months + " Month";
				}

				reviewRdVm.mDateVal = rdService.createRdData.maturityDate;
				reviewRdVm.maturityAmountVal = rdService.createRdData.maturityAmount;
				reviewRdVm.interestRateVal = rdService.createRdData.iRate;
				reviewRdVm.accountTypeSaving = rdService.createRdData.accountType;
			});

			$scope.$on('$ionicView.loaded', function () {
				initPage();
				// if(getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
				// 	getAccountDetailsService.getAccountsAccessRights('').then( function(data) {
                //     getAccountDetailsService.accessRightsData = data;
				// 	}, function(error) {
				// 		// Failure block
				// 	});
				// }
			});

			return this;
		}
]);


