'use strict';
        angularApp.controller('redirectionToRbiGiltController', ["$state",
        "$scope",
        "$ionicScrollDelegate",
        "utilityService",
        "$timeout",
        "$translate",
        "clickStreamService",
        "openUrlInAppbroswerService",
        "redirectToRbiGiltService",
    
        function($state,
            $scope,
            $ionicScrollDelegate,
            utilityService,
            $timeout,
            $translate,
            clickStreamService,
            openUrlInAppbroswerService,
            redirectToRbiGiltService) 
    {


        var redirectionToRbiGiltVm = this;
        redirectionToRbiGiltVm.errMsg = $translate.instant('RBI_ERROR_MSG');
        $scope.$on('$ionicView.beforeEnter', function() {          
            redirectionToRbiGiltVm.disableCheckbox = true;         
            redirectionToRbiGiltVm.disableNext = true;
            redirectionToRbiGiltVm.checkTermsandCondition = ""; 
            redirectToRbiGiltService.RBIDirectContent().then(function(data) {
                if(!utilityService.isUndefined(data)){
                    if(data.disclaimer != undefined && data.disclaimer !=null && data.disclaimer != ''){
                        redirectionToRbiGiltVm.banners = data.disclaimer;
                    $timeout(function() {
                        redirectionToRbiGiltVm.checkScrollOnLoad()
                    });
                }else{
                    utilityService.showBhimUpiAlert("error",redirectionToRbiGiltVm.errMsg,"menu.landingPage","","");
                }            
                }else{
                    utilityService.showBhimUpiAlert("error",redirectionToRbiGiltVm.errMsg,"menu.landingPage","","");
                }
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            
        
        });
 
        redirectionToRbiGiltVm.goToNextPage = function(){
            if(redirectionToRbiGiltVm.isChecked){
                redirectionToRbiGiltVm.checkTermsandCondition = "";
                var payLoad ={
                    "responseMessage": "success",
                    "responseCode": "0000"
                }
                redirectToRbiGiltService.RBIDirectConfirm(payLoad).then(function(data) {
                    if(!utilityService.isUndefined(data)){
                        if(data.url!= undefined && data.url!=null && data.url!=''){
                            redirectionToRbiGiltVm.url = data.url;    
                            clickStreamService.clickStreamData = "RbiGiltURL: " +  redirectionToRbiGiltVm.url + "Disclaimer: " +  redirectionToRbiGiltVm.banners ;       
                            openUrlInAppbroswerService.openUrl ( redirectionToRbiGiltVm.url, "");    
                        }else{
                            utilityService.showBhimUpiAlert("error",redirectionToRbiGiltVm.errMsg,"menu.landingPage","","");
                        }
                                 
                    }else{
                        utilityService.showBhimUpiAlert("error",redirectionToRbiGiltVm.errMsg,"menu.landingPage","","");
                    }
                    
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else{             
                    redirectionToRbiGiltVm.checkTermsandCondition =  $translate.instant('RBI_TERMS_LABEL');;            
            }

        }

        redirectionToRbiGiltVm.goback = function(){
            $state.go('menu.landingPage');
        }
   

        redirectionToRbiGiltVm.checkScroll = function(event) {
           var currentTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollPosition().top;
           var maxTop = $ionicScrollDelegate.$getByHandle('scroller').getScrollView().__maxScrollTop;
            if(maxTop!==0){ 
                if (currentTop >= maxTop) {
                    redirectionToRbiGiltVm.disableCheckbox = false;
                    document.getElementById('TERMCOND_CHK').removeAttribute("disabled");
                  }
               }                
        }
        redirectionToRbiGiltVm.checkScrollOnLoad = function(){
            var tc = document.getElementById("tcId").offsetHeight;
            var tcContent = document.getElementById("tcContent").offsetHeight;
            if(tcContent <= tc){
                redirectionToRbiGiltVm.disableCheckbox = false; 
            }
        }

       

        redirectionToRbiGiltVm.agreeChkBox = function () {
            if (redirectionToRbiGiltVm.isChecked) {
                redirectionToRbiGiltVm.disableNext = false;
                redirectionToRbiGiltVm.checkTermsandCondition = "";
               
            } else {
                redirectionToRbiGiltVm.disableNext = true;
               
            }
        }
        return this;
    }    
]);