'use strict';

angularApp.controller('rrpaymentDetailsController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "getAccountDetailsService",
    "utilityService",
    "homeScreenService",
    "$ionicPopup",
    "$rootScope",
    "$filter","rrService","$ionicPopover",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        getAccountDetailsService,
        utilityService,
        homeScreenService,
        $ionicPopup,
        $rootScope,
        $filter,rrService,$ionicPopover
    ) {

        var rrpaymentDetailsVm = this;
        rrpaymentDetailsVm.isChallenged = false;
        rrpaymentDetailsVm.isValidAccount = false;
        rrpaymentDetailsVm.validAccountMessage = "";
        rrpaymentDetailsVm.disablenext = false;
        $scope.isINR = false;
        rrpaymentDetailsVm.isChecked =false;
        rrpaymentDetailsVm.isCheckedAuth = false;


        function initPage() {

            rrpaymentDetailsVm.getLIAccounts();
            rrpaymentDetailsVm.singlePriumAmt=rrService.premiumDetails.totPremAmt;
            rrpaymentDetailsVm.ycchannel=requestYCService.ycchannel
            rrpaymentDetailsVm.showBack = true;
            rrpaymentDetailsVm.showNext = false;
            rrpaymentDetailsVm.showPay = true
            rrpaymentDetailsVm.payingFrom = getAccountDetailsService.accountOverviewData.accounts;
            rrpaymentDetailsVm.accDetails = [];
            rrpaymentDetailsVm.accDetails = rrpaymentDetailsVm.payingFrom;
            rrpaymentDetailsVm.selectedAccount = requestYCService.selectedAccValue == null ? "" : JSON.stringify(requestYCService.selectedAccValue);
            rrpaymentDetailsVm.showSelect = true;
            rrpaymentDetailsVm.gonextPg = false;
            angular.forEach(rrpaymentDetailsVm.accDetails, function (value, key) {
                if (value.accountType) {
                    value.accountType =value.accountType.substr(0, value.accountType.length-1) + "C";
                }
            });
            //rrpaymentDetailsVm.showTnC();
            rrpaymentDetailsVm.invalidReferralCode = false;
            rrpaymentDetailsVm.multipleOf100 = false;
            rrpaymentDetailsVm.multipleOf500 = false;
            rrpaymentDetailsVm.amountBound = false;
            rrpaymentDetailsVm.lessBal = false;

            rrpaymentDetailsVm.amountBoundAll = false;
            rrpaymentDetailsVm.amountBoundFiv = false;
            rrpaymentDetailsVm.amountBoundPOS = false;
        

            
            

        }
        


        rrpaymentDetailsVm.getLIAccounts = function(){
             utilityService.showSpinner();
            var account = {};
            rrService.getSBIBankAccounts(account).then(function(data) {
                utilityService.hideSpinner();
                rrpaymentDetailsVm.accDetails = data.beneficiaryList.ownAccounts;
                if (rrpaymentDetailsVm.accDetails.length > 0) {
                    var primaryAccount = getAccountDetailsService.accountOverviewData.customerInformation.accountNumber;
                    var objPriAcc = getAccountDetailsService.displayPrimaryAccountAsDefault(rrpaymentDetailsVm.accDetails,primaryAccount);
                    rrpaymentDetailsVm.accountDetail=objPriAcc;
                    rrpaymentDetailsVm.close(rrpaymentDetailsVm.accountDetail.index);    
                }
                else if(rrpaymentDetailsVm.accDetails.length == 0){
                    requestYCService.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                            $state.go('menu.homeScreen');
                        });
                } 
                
            }, function (error) {
               utilityService.hideSpinner();
               utilityService.showErrorMessage(error.responseMessage);
            });
        }

        // rrpaymentDetailsVm.getAccountList = function () {           


        //         if (!getAccountDetailsService.accountOverviewData) {
        //             utilityService.showSpinner();
        //             homeScreenService.getCustomerInfo().then(function (data) {
        //                 utilityService.hideSpinner();
        //                 getAccountDetailsService.accountOverviewData = data;
        //                 rrpaymentDetailsVm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
        //                 if (rrpaymentDetailsVm.accDetails.length == 0) {
        //                     requestYCService.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
        //                         $state.go('menu.homeScreen');
        //                     });
        //                 }
        //                 rrpaymentDetailsVm.setPrimaryAccount();
        //                 //rrpaymentDetailsVm.close(0);

        //             }, function (error) {
        //                 utilityService.hideSpinner();
        //             });
        //         } else {

        //             //requestYCService.accDetails = getAccountDetailsService.accountOverviewData.accounts
        //             rrpaymentDetailsVm.accDetails = getAccountDetailsService.accountOverviewData.accounts;
        //             if (rrpaymentDetailsVm.accDetails.length == 0) {
        //                 requestYCService.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
        //                     $state.go('menu.homeScreen');
        //                 });
        //             }                    
        //             rrpaymentDetailsVm.showSelect = false;
        //             if (requestYCService.selectedDetails.selIndex == "") {
        //                 rrpaymentDetailsVm.setPrimaryAccount();
        //             } else {
        //                 //rrpaymentDetailsVm.setPrimaryAccount();
        //                 rrpaymentDetailsVm.close(requestYCService.selectedDetails.selIndex);
        //                //rrpaymentDetailsVm.close(0);
        //             }

        //         }
              

           

        // }

        rrpaymentDetailsVm.setPrimaryAccount = function () {
        
            // if(getAccountDetailsService.accountOverviewData.customerInformation.accountNumber){
            //      var arr = rrpaymentDetailsVm.accDetails;
                 
			// 	for (var i = 0, j = arr.length; i < j; i++) {
			// 		if (arr[i].accountNumber == getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
            //            var topElement = rrpaymentDetailsVm.accDetails[i];
            //             rrpaymentDetailsVm.close(i);
            //             if (rrpaymentDetailsVm.accDetails.indexOf(topElement) > 0) {
            //                 rrpaymentDetailsVm.accDetails.splice(rrpaymentDetailsVm.accDetails.indexOf(topElement), 1);
            //                 rrpaymentDetailsVm.accDetails.unshift(topElement);
            //             }
			// 		}
			// 	}; 
            // }else{
            //     rrpaymentDetailsVm.close(0); 
            // }
            

            // rrpaymentDetailsVm.balance = rrpaymentDetailsVm.accDetails[index].balance;
            // rrpaymentDetailsVm.accType = rrpaymentDetailsVm.accDetails[index].benAccntType;
            // rrpaymentDetailsVm.accountNumber = rrpaymentDetailsVm.accDetails[index].benAccntNo;
            // requestYCService.selectedDetails.selIndex = rrpaymentDetailsVm.accDetails[index].index ;
            // requestYCService.selectedDetails.accountNumber = rrpaymentDetailsVm.accDetails[index].benAccntNo;
            // requestYCService.selectedDetails.accountBalance = rrpaymentDetailsVm.accDetails[index].balance;

				
			
		};
        
        rrpaymentDetailsVm.showTnC = function (tncData,title) {
            $ionicPopup.alert({
                title: title,
                template: tncData,
                cssClass: 'removePopup-head popupWidth90 rrpopupMargin popupBackgroundWhite ss-popup ODtncPopup rr-TNC',
                buttons: [
                    {
                        text: "OK",
                        onTap: function (e) { }
                    }
                ],
            });
        }
        rrpaymentDetailsVm.showDeclaration = function (tncData,title) {
            $ionicPopup.alert({
                title: title,
                template: tncData,
                cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup ODtncPopup rr-main rr-DEC',
                buttons: [
                    {
                        text: "OK",
                        onTap: function (e) { }
                    }
                ],
            });
        }
        rrpaymentDetailsVm.getdeclContent = function () {
             var title="";  
          if(!rrpaymentDetailsVm.declContent){   
                    utilityService.showSpinner();
                    rrService.getdeclContent().then(function (data) {
                        rrpaymentDetailsVm.declContent =data.content;
                        title= $translate.instant("RR_DECLRATION");                       
                        rrpaymentDetailsVm.showDeclaration(rrpaymentDetailsVm.declContent,title);                                     
                        utilityService.hideSpinner();          
                    }, function (error) {
                        utilityService.hideSpinner();   
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }else{
                     title= $translate.instant("RR_DECLRATION");
                     rrpaymentDetailsVm.showDeclaration(rrpaymentDetailsVm.declContent,title); 
                      utilityService.hideSpinner(); 
                }
        }
        rrpaymentDetailsVm.termcondition = function () { 
                var title="";          
                if(!rrpaymentDetailsVm.response){                   
                        utilityService.showSpinner();                                         
                        rrService.getTncContent().then(function (data) {
                        rrpaymentDetailsVm.response =data.content;
                        title= $translate.instant("RR_TNC");                       
                        rrpaymentDetailsVm.showTnC(rrpaymentDetailsVm.response,title);                                     
                        utilityService.hideSpinner();          
                    }, function (error) {
                        utilityService.hideSpinner();   
                        utilityService.showErrorMessage(error.responseMessage);
                    });             
            }else{               
                 title= $translate.instant("RR_TNC");
                 rrpaymentDetailsVm.showTnC(rrpaymentDetailsVm.response,title);                    
                 utilityService.hideSpinner(); 
            }
            
        }

        

        rrpaymentDetailsVm.showPop = function(){
            rrpaymentDetailsVm.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                templateUrl: 'pages/rinnraksha/paymentDetails/dropdownModal.html',
                scope: $scope
            });
        }

        rrpaymentDetailsVm.close = function(index){
                
                // if(rrpaymentDetailsVm.popUp){
                // rrpaymentDetailsVm.popUp.close();
                // }
                        
                // rrpaymentDetailsVm.balance = rrpaymentDetailsVm.accDetails[index].accountBalance;
                // rrpaymentDetailsVm.accType = rrpaymentDetailsVm.accDetails[index].accountType;
                // rrpaymentDetailsVm.accountNumber = rrpaymentDetailsVm.accDetails[index].accountNumber;
                // rrpaymentDetailsVm.isActive = rrpaymentDetailsVm.accDetails[index].isActive;
                // rrpaymentDetailsVm.isTransactional = rrpaymentDetailsVm.accDetails[index].isTransactional;
                // requestYCService.selectedDetails.selIndex = index ;
                // requestYCService.selectedDetails.accountNumber = rrpaymentDetailsVm.accDetails[index].accountNumber;
                // requestYCService.selectedDetails.accountBalance = rrpaymentDetailsVm.accDetails[index].accountBalance;
                // rrpaymentDetailsVm.showSelect = false;

                // if (rrpaymentDetailsVm.isActive === "false" || rrpaymentDetailsVm.isActive === false) {
                // rrpaymentDetailsVm.disablenext = true;
                // var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SELECT_ACTIVE_ACC_DREAM"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="ACTIVE_OR"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="CONTACT_NEAREST"></div>';
                // requestYCService.showAlertModal(title, template, onTap, $scope, $state);
                // }
                // if (rrpaymentDetailsVm.isTransactional === "false" || rrpaymentDetailsVm.isTransactional === false) {
                //     rrpaymentDetailsVm.disablenext = true;
                //     var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="USE_TRANS_RIGHTS"></div>';
                //     requestYCService.showAlertModal(title, template, onTap, $scope, $state);
                // }
                // rrpaymentDetailsVm.changeAmount();
                if(rrpaymentDetailsVm.popUp){
                rrpaymentDetailsVm.popUp.close();
                }
                        
                rrpaymentDetailsVm.balance = rrpaymentDetailsVm.accDetails[index].balance;
                rrpaymentDetailsVm.accType = rrpaymentDetailsVm.accDetails[index].benAccntType;
                rrpaymentDetailsVm.accountNumber = rrpaymentDetailsVm.accDetails[index].benAccntNo;
                requestYCService.selectedDetails.selIndex = rrpaymentDetailsVm.accDetails[index].index ;
                requestYCService.selectedDetails.accountNumber = rrpaymentDetailsVm.accDetails[index].benAccntNo;
                requestYCService.selectedDetails.accountBalance = rrpaymentDetailsVm.accDetails[index].balance;
                rrpaymentDetailsVm.showSelect = false;
                
            }

        // rrpaymentDetailsVm.changeAmount = function () {
                        
            
        //     if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
        //                         rrpaymentDetailsVm.disablenext = true;
        //                         rrpaymentDetailsVm.isValidAccount = true;
        //                         rrpaymentDetailsVm.validAccountMessage = rrpaymentDetailsVm.fetchTransRights;
        //                     } else {
        //                         var isAccountTransactional = false;
        //                         for (var i in getAccountDetailsService.accessRightsData.accounts) {
        //                             if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === requestYCService.selectedDetails.accountNumber && parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) != 0) {
        //                                 isAccountTransactional = true;
        //                             }
        //                         }
        //                         if (isAccountTransactional) {
        //                             rrpaymentDetailsVm.isAmtMoreThanBal = false;
        //                             rrpaymentDetailsVm.isValidAccount = false;
        //                             if (getAccountDetailsService.accessRightsData.accounts) {
        //                                 for (var i in getAccountDetailsService.accessRightsData.accounts) {
        //                                     if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === requestYCService.selectedDetails.accountNumber && getAccountDetailsService.accessRightsData.accounts[i].modBalance) {
        //                                         rrpaymentDetailsVm.sumModAccountAmount = parseFloat(requestYCService.selectedDetails.accountBalance) + parseFloat(getAccountDetailsService.accessRightsData.accounts[i].modBalance);
        //                                         break;
        //                                     }
        //                                 }
        //                             } else {
        //                                 rrpaymentDetailsVm.sumModAccountAmount = parseFloat(requestYCService.selectedDetails.amount);
        //                             }

        //                             if(rrpaymentDetailsVm.amountData){
        //                                  if (rrpaymentDetailsVm.sumModAccountAmount >= parseFloat(rrpaymentDetailsVm.amountData.replace(",", ""))) {
        //                                 //success                                                  
        //                                 rrpaymentDetailsVm.disablenext = false ;
        //                                 rrpaymentDetailsVm.gonextPg = true;  
        //                                 } else {                                            
        //                                 rrpaymentDetailsVm.isAmtMoreThanBal = true
        //                                 rrpaymentDetailsVm.disablenext = true;
        //                                 }
        //                             }                               

        //                         } else {
                                    
        //                             rrpaymentDetailsVm.disablenext = true;
        //                             rrpaymentDetailsVm.isValidAccount = true;
        //                             rrpaymentDetailsVm.validAccountMessage = rrpaymentDetailsVm.accTransRights;
        //                         }
        //                     }
        // }



         rrpaymentDetailsVm.showReferalPopup = function($event,id){
           
            rrpaymentDetailsVm.template = '<ion-popover-view class="loginnewarrow rr-las-popover-referralCode" id="runtimeHeight" >' + '<div class="rr-las-popover-tip-eligibleLoan"></div>' +
            '<div id="renderHeight" class="text-left font-size-12" translate="RR_REFERRAL_INFO_POPUP"></div>' + '</ion-popover-view>';
            $scope.popover = $ionicPopover.fromTemplate(rrpaymentDetailsVm.template, {
                scope: $scope
            });
            
            $scope.popover.show($event);
            // var showReferalPopup = $ionicPopup.show({
			// 	template: '<p translate="RR_REFERRAL_INFO_POPUP"></p>',
			// 	title: '',
			// 	cssClass: 'dialog',
			// 	scope: $scope,
			// 	buttons: [{
			// 		text: 'OK',
			// 		type: 'button-positive'
			// 	}]
			// });
        }

        rrpaymentDetailsVm.closePopover = function () {
            $scope.popover.hide();
        };



        //Function for close view
        rrpaymentDetailsVm.closeView = function () {
          homeScreenService.ishamburgerMenuRO=false;
          homeScreenService.isInsuranceFlag = true;
          getAccountDetailsService.tabIndex.tabIndex=4;          
          $state.go('menu.accountOverviewMyBalance');
        }

        rrpaymentDetailsVm.onKeyUp = function(){
            $scope.isINR = true;
        }

        //onclick of Back button
        rrpaymentDetailsVm.goBacktoPrevious = function () {
            $state.go('menu.rrReviewDetails');
        };

        rrpaymentDetailsVm.validateAmount= function(){   
            if(rrpaymentDetailsVm.singlePriumAmt){
                rrpaymentDetailsVm.premiumError = false;
                if(parseInt(rrpaymentDetailsVm.balance)<parseInt(rrpaymentDetailsVm.singlePriumAmt)){
                rrpaymentDetailsVm.error = false;
                return false;
                }
                rrpaymentDetailsVm.error = true;
                return true;
            }else{
                rrpaymentDetailsVm.premiumError = true;
                return false;                
            }

           
           
        }

        rrpaymentDetailsVm.vaildateReferral = function () {
            if(rrpaymentDetailsVm.referral && (rrpaymentDetailsVm.referral.length < 10 && rrpaymentDetailsVm.referral.length > 0)){
                rrpaymentDetailsVm.invalidReferralCode = true;
            }
            else{
                rrpaymentDetailsVm.invalidReferralCode = false;
            }
        }
        



        //onclick of next button
        rrpaymentDetailsVm.goToNextPage = function () {
            var requestSecKey='';
            var reqParams = {};
            
            var requestDate = new Date();
            requestDate = requestDate.getTime();
            requestSecKey=Math.floor((Math.random()) + requestDate);
            requestSecKey = (requestSecKey * 10 + 1);

            reqParams["appNo"]=rrService.saveData.application.app.appNo;
            reqParams["accountNo"]=rrpaymentDetailsVm.accountNumber;
            reqParams["referral"]=rrpaymentDetailsVm.referral;
            reqParams["secKey"]=requestSecKey;
            if(rrpaymentDetailsVm.validateAmount()){
                rrService.payForNew(reqParams).then(function(data){
                    $state.go('menu.rrOTP');
                },function(error){
                     utilityService.hideSpinner();
                     utilityService.showErrorMessage(error.responseMessage);
                })
             }
            
           
            
        }

      

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            //rrpaymentDetailsVm.getAccountList();            
            // if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
            //     getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
            //         getAccountDetailsService.accessRightsData = data;
            //     }, function (error) {
            //         // Failure block
            //     });
            // }
        });


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            initPage();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            if(requestYCService.selectedDetails.amount && requestYCService.selectedDetails.amount !=""){
               rrpaymentDetailsVm.amountData = $filter('INR')(requestYCService.selectedDetails.amount);
               //rrpaymentDetailsVm.amountData = requestYCService.selectedDetails.amount;
                rrpaymentDetailsVm.changeAmount();
            }
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);