'use strict';

angularApp.controller('rrOTPController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "getAccountDetailsService",
    "utilityService",
    "homeScreenService",
    "$ionicPopup",
    "$rootScope",
    "$filter","rrService","customerInfoService",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        getAccountDetailsService,
        utilityService,
        homeScreenService,
        $ionicPopup,
        $rootScope,
        $filter,rrService,customerInfoService
    ) {

        var rrOTPVm = this;
        rrOTPVm.isChallenged = false;
        rrOTPVm.isValidAccount = false;
        rrOTPVm.validAccountMessage = "";
        rrOTPVm.disablenext = false;
        $scope.isINR = false;
        rrOTPVm.showSubmit =true;
        rrOTPVm.showBack = true;
         var count = 0;


        function initPage() {
            rrOTPVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);          
                   

        }


        //Function for close view
        rrOTPVm.closeView = function () {
          homeScreenService.ishamburgerMenuRO=false;
          homeScreenService.isInsuranceFlag = true;
          getAccountDetailsService.tabIndex.tabIndex=4;          
          $state.go('menu.accountOverviewMyBalance');
        }

        rrOTPVm.onKeyUp = function(){
            $scope.isINR = true;
        }

        //onclick of Back button
        rrOTPVm.goBacktoPrevious = function () {
            $state.go('menu.rrPaymantDetails');
        };

        

        rrOTPVm.resendOtp = function(){  
            count += 1;
				if (count >= 3) {
                    rrOTPVm.isDisabledOTP = true;
                }else{
                    rrOTPVm.otp ='';          
                    rrService.resendOTP().then(function(data){     
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                    })
                }
        }
         rrOTPVm.validateOTPForPayNew = function(){
            var reqParams = {};
            var requestSecKey = '';
            var requestDate = new Date();
            requestDate = requestDate.getTime();
            requestSecKey=Math.floor((Math.random()) + requestDate);
            requestSecKey = (requestSecKey * 10 + 1);
            reqParams["otp"] = rrOTPVm.otp;
            reqParams["secKey"] = requestSecKey;
            rrService.validateOTPForPayNew(reqParams).then(function(data){
                rrOTPVm.response = data;
                //rrService.mfNumber=data;
                rrService.loanTypeInfo = '';
                rrService.addMFNumber(rrOTPVm.response);
                $state.go('menu.rrSuccess');
            },function(error){
                rrOTPVm.otp ='';
                if(error.responseCode=="0003"){
                    utilityService.showErrorMessage(error.responseMessage);
                }else{
                    utilityService.showErrorMessage(error.responseMessage);
                    $state.go('menu.rrPaymantDetails');
                }  
                
            })
        }
       
       

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {           
            // if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
            //     getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
            //         getAccountDetailsService.accessRightsData = data;
            //     }, function (error) {
            //         // Failure block
            //     });
            // }
        });


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            initPage();           
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);