'use strict';

angularApp.controller('rrSuccessController', ["$state",
    "$scope",    
    "$ionicSideMenuDelegate",    
    "$translate",   
    "utilityService",
    "$timeout",    
    "rrService","homeScreenService","getAccountDetailsService","mPinLoginService","clickStreamService",

    function ($state,
        $scope,        
        $ionicSideMenuDelegate,       
        $translate,        
        utilityService,
        $timeout,           
        rrService,homeScreenService,getAccountDetailsService,mPinLoginService,clickStreamService
    ) {

        var rrSuccessVm = this;
        rrSuccessVm.isChallenged = false;
        rrSuccessVm.showBack = true;
        rrSuccessVm.showNext = true;

        function initPage() {           
            rrSuccessVm.getMFNumber = rrService.getMFNumber().mFormNo;
            //rrSuccessVm.getMFNumber=rrService.mfNumber.mfno;
             clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("LI_LYFINSPYMTSUC" + "_" + "LI_END_NXT_BTN"));
                       
        }



        //Function for close view
        rrSuccessVm.closeView = function () {
          homeScreenService.ishamburgerMenuRO=false;
          homeScreenService.isInsuranceFlag = true;
          getAccountDetailsService.tabIndex.tabIndex=4;          
          $state.go('menu.accountOverviewMyBalance');
        }
        

        //onclick of home button
        rrSuccessVm.goToHome = function () {
          homeScreenService.ishamburgerMenuRO=false;
          homeScreenService.isInsuranceFlag = true;
          getAccountDetailsService.tabIndex.tabIndex=4;          
          $state.go('menu.accountOverviewMyBalance');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
