'use strict';

angularApp.controller('rrReviewDetailsController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "getAccountDetailsService",
    "utilityService",
    "homeScreenService",
    "$ionicPopup",
    "$rootScope",
    "$filter",
    "ionicDatePicker","rrService",
    "rrService",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        getAccountDetailsService,
        utilityService,
        homeScreenService,
        $ionicPopup,
        $rootScope,
        $filter,
        ionicDatePicker,
        rrService
    ) {

        var rrReviewDetailsVm = this;
        rrReviewDetailsVm.isChallenged = false;
        rrReviewDetailsVm.isValidAccount = false;
        rrReviewDetailsVm.validAccountMessage = "";
        rrReviewDetailsVm.disablenext = false;
        $scope.isINR = false;


        function initPage() {
            rrReviewDetailsVm.ycchannel=requestYCService.ycchannel
            rrReviewDetailsVm.showBack = true;
            rrReviewDetailsVm.showNext = true;
            rrReviewDetailsVm.payingFrom = getAccountDetailsService.accountOverviewData.accounts;
            rrReviewDetailsVm.customerInformation=getAccountDetailsService.accountOverviewData.customerInformation; 
            rrReviewDetailsVm.accDetails = [];
            rrReviewDetailsVm.accDetails = rrReviewDetailsVm.payingFrom;
            rrReviewDetailsVm.selectedAccount = requestYCService.selectedAccValue == null ? "" : JSON.stringify(requestYCService.selectedAccValue);
            rrReviewDetailsVm.showSelect = true;
            rrReviewDetailsVm.gonextPg = false;
            rrReviewDetailsVm.isMaskedDOB = true;
            rrReviewDetailsVm.isMaskedPAN = true;
            rrReviewDetailsVm.isMaskedMOB = true;
            rrReviewDetailsVm.isMaskedEmail = true;
            rrReviewDetailsVm.inputImgEmail = "img/Visibility_off.svg";
            
            rrReviewDetailsVm.inputImgMOB = "img/Visibility_off.svg";
            rrReviewDetailsVm.inputImgPAN = "img/Visibility_off.svg";
            rrReviewDetailsVm.inputImgDOB = "img/Visibility_off.svg";
            angular.forEach(rrReviewDetailsVm.accDetails, function (value, key) {
                if (value.accountType) {
                    value.accountType =value.accountType.substr(0, value.accountType.length-1) + "C";
                }
            });
            rrReviewDetailsVm.getApplicationsData();
            rrReviewDetailsVm.bindMedDetails = [];
            
           
            rrReviewDetailsVm.multipleOf100 = false;
            rrReviewDetailsVm.multipleOf500 = false;
            rrReviewDetailsVm.amountBound = false;
            rrReviewDetailsVm.lessBal = false;

            rrReviewDetailsVm.amountBoundAll = false;
            rrReviewDetailsVm.amountBoundFiv = false;
            rrReviewDetailsVm.amountBoundPOS = false;
        

            

            rrReviewDetailsVm.group = {description: "", id: "home", message: "Coming soon", name: "Home Loan", ntb: false}


            // var upgradeInstaVm = $ionicPopup.confirm({
			// 	template: '<p><div class=""><img class="ycpopupStyleM5" src="img/yc_Group.svg"</div> <div class ="ycwidth90" translate="RR_POP_MSG_VALID" ></div>   </p>',
			// 	cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogYC',
			// 	scope: $scope,
			// 	buttons: [{
			// 		text: 'No',
			// 		type: 'button-negative',
			// 		onTap: function (e) {
			// 			upgradeInstaVm.close();
			// 			e.preventDefault();
			// 		}
			// 	},
			// 	{
			// 		text: 'Yes',
			// 		type: 'button-positive',
			// 		onTap: function (e) {
			// 			upgradeInstaVm.close();
			// 			e.preventDefault();   
			// 		}
			// 	}]
			// });
            

        }


        rrReviewDetailsVm.getMedicalQuestions = function(){
         rrService.getMedicalQuestions().then(function(data){
                    rrReviewDetailsVm.QuestionsdataList=JSON.parse(data.content).content.healthQues;    

                    var bindMedDetails = rrReviewDetailsVm.saveData.application.app.medical.questions;
                    //for (var i in rrReviewDetailsVm.saveData.application.app.medical.questions.id) {
                        for (var i in bindMedDetails) {
                        if(bindMedDetails[i].id == 'HD_ADVICE_HOSPITAL_FUTURE'){     
                                rrReviewDetailsVm.HD_ADVICE_HOSPITAL_FUTURE_ID  = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ADVICE_HOSPITAL_FUTURE_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ADVICE_HOSPITAL_FUTURE_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_ADVICE_HOSPITAL_FUTURE_ANS = bindMedDetails[i].ans;
                                }       
                            }
                            if(bindMedDetails[i].id == 'HD_IS_ILLNESS_SURGICAL_OP'){    
                                rrReviewDetailsVm.HD_IS_ILLNESS_SURGICAL_OP_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_IS_ILLNESS_SURGICAL_OP_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_IS_ILLNESS_SURGICAL_OP_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_IS_ILLNESS_SURGICAL_OP_ANS = bindMedDetails[i].ans;
                                }                              
                                
                            }
                            if(bindMedDetails[i].id == 'HD_DIABETES_BP'){    
                                rrReviewDetailsVm.HD_DIABETES_BP_ID = bindMedDetails[i].id; 
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_DIABETES_BP_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_DIABETES_BP_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_DIABETES_BP_ANS = bindMedDetails[i].ans;
                                }                              
                                
                            }
                            if(bindMedDetails[i].id == 'HD_CHESTPAIN_HEART_ATTACK'){         
                                rrReviewDetailsVm.HD_CHESTPAIN_HEART_ATTACK_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_CHESTPAIN_HEART_ATTACK_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_CHESTPAIN_HEART_ATTACK_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_CHESTPAIN_HEART_ATTACK_ANS = bindMedDetails[i].ans;
                                }                        
                                
                            }
                            if(bindMedDetails[i].id == 'HD_STROKE_PARALYSIS'){  
                                rrReviewDetailsVm.HD_STROKE_PARALYSIS_ID = bindMedDetails[i].id; 
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_STROKE_PARALYSIS_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_STROKE_PARALYSIS_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_STROKE_PARALYSIS_ANS = bindMedDetails[i].ans;
                                }                              
                                
                            }

                            if(bindMedDetails[i].id == 'HD_HIV_INFECTION'){     
                                rrReviewDetailsVm.HD_HIV_INFECTION_ID = bindMedDetails[i].id; 
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_HIV_INFECTION_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_HIV_INFECTION_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_HIV_INFECTION_ANS = bindMedDetails[i].ans;
                                }                            
                                
                            }
                            if(bindMedDetails[i].id == 'HD_CANCER_TUMOR'){                
                                rrReviewDetailsVm.HD_CANCER_TUMOR_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_CANCER_TUMOR_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_CANCER_TUMOR_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_CANCER_TUMOR_ANS = bindMedDetails[i].ans;
                                }               
                                
                            }
                            if(bindMedDetails[i].id == 'HD_KIDNEY_DISORDER'){     
                                rrReviewDetailsVm.HD_KIDNEY_DISORDER_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_KIDNEY_DISORDER_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_KIDNEY_DISORDER_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_KIDNEY_DISORDER_ANS = bindMedDetails[i].ans;
                                }                           
                                
                            }
                            if(bindMedDetails[i].id == 'HD_DIGESTIVE_DISORDER'){ 
                                 rrReviewDetailsVm.HD_DIGESTIVE_DISORDER_ID = bindMedDetails[i].id; 
                                  if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_DIGESTIVE_DISORDER_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_DIGESTIVE_DISORDER_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_DIGESTIVE_DISORDER_ANS = bindMedDetails[i].ans;
                                }                              
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ASTHMA'){                 
                                rrReviewDetailsVm.HD_ASTHMA_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ASTHMA_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ASTHMA_ANS = 'No'
                                }else{
                                   rrReviewDetailsVm.HD_ASTHMA_ANS = bindMedDetails[i].ans;
                                }                
                                
                            }
                            if(bindMedDetails[i].id == 'HD_MENTAL_PSYCHIATRIC'){          
                                rrReviewDetailsVm.HD_MENTAL_PSYCHIATRIC_ID = bindMedDetails[i].id;   
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_MENTAL_PSYCHIATRIC_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_MENTAL_PSYCHIATRIC_ANS = 'No'
                                }else{
                                   rrReviewDetailsVm.HD_MENTAL_PSYCHIATRIC_ANS = bindMedDetails[i].ans;
                                }                      
                                
                            }

                            if(bindMedDetails[i].id == 'HD_OTHER_DISEASE'){               
                                rrReviewDetailsVm.HD_OTHER_DISEASE_ID = bindMedDetails[i].id;  
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_OTHER_DISEASE_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_OTHER_DISEASE_ANS = 'No'
                                }else{
                                  rrReviewDetailsVm.HD_OTHER_DISEASE_ANS = bindMedDetails[i].ans;
                                }              
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ANY_MEDICATION'){
                                rrReviewDetailsVm.HD_ANY_MEDICATION_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ANY_MEDICATION_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ANY_MEDICATION_ANS = 'No'
                                }else{
                                  rrReviewDetailsVm.HD_ANY_MEDICATION_ANS = bindMedDetails[i].ans;
                                }
                                
                            }
                            if(bindMedDetails[i].id == 'HD_PRAPOSAL_DECLI_POSTPOND'){                 
                                rrReviewDetailsVm.HD_PRAPOSAL_DECLI_POSTPOND_ID = bindMedDetails[i].id;  
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_PRAPOSAL_DECLI_POSTPOND_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_PRAPOSAL_DECLI_POSTPOND_ANS = 'No'
                                }else{
                                  rrReviewDetailsVm.HD_PRAPOSAL_DECLI_POSTPOND_ANS = bindMedDetails[i].ans;
                                }             
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ADVISED_FOR_INVESTIGATION'){                  
                                rrReviewDetailsVm.HD_ADVISED_FOR_INVESTIGATION_ID = bindMedDetails[i].id;  
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ADVISED_FOR_INVESTIGATION_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ADVISED_FOR_INVESTIGATION_ANS = 'No'
                                }else{
                                 rrReviewDetailsVm.HD_ADVISED_FOR_INVESTIGATION_ANS = bindMedDetails[i].ans;
                                }            
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ULTRA_SONO'){                    
                                 rrReviewDetailsVm.HD_ULTRA_SONO_ID = bindMedDetails[i].id; 
                                  if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ULTRA_SONO_ANS = 'Ultra Sonography'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ULTRA_SONO_ANS = 'No'
                                }else{
                                  rrReviewDetailsVm.HD_ULTRA_SONO_ANS = bindMedDetails[i].ans;
                                }          
                               
                            }
                            if(bindMedDetails[i].id == 'HD_CT_SCANMRI'){             
                                rrReviewDetailsVm.HD_CT_SCANMRI_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_CT_SCANMRI_ANS = 'CT Scan/ MRI'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_CT_SCANMRI_ANS = 'No'
                                }else{
                                  rrReviewDetailsVm.HD_CT_SCANMRI_ANS = bindMedDetails[i].ans;
                                }                      
                                
                            }
                            if(bindMedDetails[i].id == 'HD_BIOPSY'){
                                rrReviewDetailsVm.HD_BIOPSY_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_BIOPSY_ANS = 'Biopsy'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_BIOPSY_ANS = 'No'
                                }else{
                                   rrReviewDetailsVm.HD_BIOPSY_ANS = bindMedDetails[i].ans;
                                }   
                               
                            }
                            if(bindMedDetails[i].id == 'HD_ANGIOGRAPHY'){
                                rrReviewDetailsVm.HD_ANGIOGRAPHY_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ANGIOGRAPHY_ANS = 'Coronary Angiography'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ANGIOGRAPHY_ANS = 'No'
                                }else{
                                   rrReviewDetailsVm.HD_ANGIOGRAPHY_ANS = bindMedDetails[i].ans;
                                }
                               
                            }
                            if(bindMedDetails[i].id == 'HD_CONSUME_CIGARETTES'){
                                rrReviewDetailsVm.HD_CONSUME_CIGARETTES_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_CONSUME_CIGARETTES_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_CONSUME_CIGARETTES_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_CONSUME_CIGARETTES_ANS = bindMedDetails[i].ans;
                                }
                               
                            }
                            if(bindMedDetails[i].id == 'HD_CONSUME_ALCOLOL'){
                                rrReviewDetailsVm.HD_CONSUME_ALCOLOL_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_CONSUME_ALCOLOL_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_CONSUME_ALCOLOL_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_CONSUME_ALCOLOL_ANS = bindMedDetails[i].ans;
                                }
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ALCOHOL_TYPE'){
                                rrReviewDetailsVm.HD_ALCOHOL_TYPE_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ALCOHOL_TYPE_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ALCOHOL_TYPE_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_ALCOHOL_TYPE_ANS = bindMedDetails[i].ans;
                                }
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ALCOHOL_QUANTITY'){
                                rrReviewDetailsVm.HD_ALCOHOL_QUANTITY_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ALCOHOL_QUANTITY_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ALCOHOL_QUANTITY_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_ALCOHOL_QUANTITY_ANS = bindMedDetails[i].ans;
                                }
                                
                            }
                            if(bindMedDetails[i].id == 'HD_NARCOTICS_GRUGS'){
                                rrReviewDetailsVm.HD_NARCOTICS_GRUGS_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_NARCOTICS_GRUGS_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_NARCOTICS_GRUGS_ANS = 'No'
                                }else{
                                     rrReviewDetailsVm.HD_NARCOTICS_GRUGS_ANS = bindMedDetails[i].ans;
                                }
                               
                            }
                            if(bindMedDetails[i].id == 'HD_IS_PREGNANT'){
                                rrReviewDetailsVm.HD_IS_PREGNANT_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_IS_PREGNANT_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_IS_PREGNANT_ANS = 'No'
                                }else{
                                     rrReviewDetailsVm.HD_IS_PREGNANT_ANS = bindMedDetails[i].ans;
                                }
                                
                            }
                            if(bindMedDetails[i].id == 'PREGNANT_MONTHS'){
                                rrReviewDetailsVm.PREGNANT_MONTHS_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.PREGNANT_MONTHS_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.PREGNANT_MONTHS_ANS = 'No'
                                }else{
                                     rrReviewDetailsVm.PREGNANT_MONTHS_ANS = bindMedDetails[i].ans;
                                }
                                
                            }

                            if(bindMedDetails[i].id == 'HD_GYNAECOLOGICAL_PROBLEM'){
                                rrReviewDetailsVm.HD_GYNAECOLOGICAL_PROBLEM_ID= bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_GYNAECOLOGICAL_PROBLEM_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_GYNAECOLOGICAL_PROBLEM_ANS = 'No'
                                }else{
                                      rrReviewDetailsVm.HD_GYNAECOLOGICAL_PROBLEM_ANS = bindMedDetails[i].ans;
                                }
                               
                            }

                    }
                   
                   
                                     
                 },function(error){
                     rrReviewDetailsVm.dataList=error.tabs;
                     rrReviewDetailsVm.QuestionsdataList=error.tabs;

                    var bindMedDetails = rrReviewDetailsVm.saveData.application.app.medical.questions;
                    //for (var i in rrReviewDetailsVm.saveData.application.app.medical.questions.id) {
                        for (var i in bindMedDetails) {
                        if(bindMedDetails[i].id == 'HD_ADVICE_HOSPITAL_FUTURE'){     
                                rrReviewDetailsVm.HD_ADVICE_HOSPITAL_FUTURE_ID  = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ADVICE_HOSPITAL_FUTURE_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ADVICE_HOSPITAL_FUTURE_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_ADVICE_HOSPITAL_FUTURE_ANS = bindMedDetails[i].ans;
                                }       
                            }
                            if(bindMedDetails[i].id == 'HD_IS_ILLNESS_SURGICAL_OP'){    
                                rrReviewDetailsVm.HD_IS_ILLNESS_SURGICAL_OP_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_IS_ILLNESS_SURGICAL_OP_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_IS_ILLNESS_SURGICAL_OP_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_IS_ILLNESS_SURGICAL_OP_ANS = bindMedDetails[i].ans;
                                }                              
                                
                            }
                            if(bindMedDetails[i].id == 'HD_DIABETES_BP'){    
                                rrReviewDetailsVm.HD_DIABETES_BP_ID = bindMedDetails[i].id; 
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_DIABETES_BP_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_DIABETES_BP_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_DIABETES_BP_ANS = bindMedDetails[i].ans;
                                }                              
                                
                            }
                            if(bindMedDetails[i].id == 'HD_CHESTPAIN_HEART_ATTACK'){         
                                rrReviewDetailsVm.HD_CHESTPAIN_HEART_ATTACK_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_CHESTPAIN_HEART_ATTACK_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_CHESTPAIN_HEART_ATTACK_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_CHESTPAIN_HEART_ATTACK_ANS = bindMedDetails[i].ans;
                                }                        
                                
                            }
                            if(bindMedDetails[i].id == 'HD_STROKE_PARALYSIS'){  
                                rrReviewDetailsVm.HD_STROKE_PARALYSIS_ID = bindMedDetails[i].id; 
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_STROKE_PARALYSIS_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_STROKE_PARALYSIS_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_STROKE_PARALYSIS_ANS = bindMedDetails[i].ans;
                                }                              
                                
                            }

                            if(bindMedDetails[i].id == 'HD_HIV_INFECTION'){     
                                rrReviewDetailsVm.HD_HIV_INFECTION_ID = bindMedDetails[i].id; 
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_HIV_INFECTION_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_HIV_INFECTION_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_HIV_INFECTION_ANS = bindMedDetails[i].ans;
                                }                            
                                
                            }
                            if(bindMedDetails[i].id == 'HD_CANCER_TUMOR'){                
                                rrReviewDetailsVm.HD_CANCER_TUMOR_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_CANCER_TUMOR_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_CANCER_TUMOR_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_CANCER_TUMOR_ANS = bindMedDetails[i].ans;
                                }               
                                
                            }
                            if(bindMedDetails[i].id == 'HD_KIDNEY_DISORDER'){     
                                rrReviewDetailsVm.HD_KIDNEY_DISORDER_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_KIDNEY_DISORDER_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_KIDNEY_DISORDER_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_KIDNEY_DISORDER_ANS = bindMedDetails[i].ans;
                                }                           
                                
                            }
                            if(bindMedDetails[i].id == 'HD_DIGESTIVE_DISORDER'){ 
                                 rrReviewDetailsVm.HD_DIGESTIVE_DISORDER_ID = bindMedDetails[i].id; 
                                  if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_DIGESTIVE_DISORDER_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_DIGESTIVE_DISORDER_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_DIGESTIVE_DISORDER_ANS = bindMedDetails[i].ans;
                                }                              
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ASTHMA'){                 
                                rrReviewDetailsVm.HD_ASTHMA_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ASTHMA_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ASTHMA_ANS = 'No'
                                }else{
                                   rrReviewDetailsVm.HD_ASTHMA_ANS = bindMedDetails[i].ans;
                                }                
                                
                            }
                            if(bindMedDetails[i].id == 'HD_MENTAL_PSYCHIATRIC'){          
                                rrReviewDetailsVm.HD_MENTAL_PSYCHIATRIC_ID = bindMedDetails[i].id;   
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_MENTAL_PSYCHIATRIC_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_MENTAL_PSYCHIATRIC_ANS = 'No'
                                }else{
                                   rrReviewDetailsVm.HD_MENTAL_PSYCHIATRIC_ANS = bindMedDetails[i].ans;
                                }                      
                                
                            }

                            if(bindMedDetails[i].id == 'HD_OTHER_DISEASE'){               
                                rrReviewDetailsVm.HD_OTHER_DISEASE_ID = bindMedDetails[i].id;  
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_OTHER_DISEASE_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_OTHER_DISEASE_ANS = 'No'
                                }else{
                                  rrReviewDetailsVm.HD_OTHER_DISEASE_ANS = bindMedDetails[i].ans;
                                }              
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ANY_MEDICATION'){
                                rrReviewDetailsVm.HD_ANY_MEDICATION_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ANY_MEDICATION_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ANY_MEDICATION_ANS = 'No'
                                }else{
                                  rrReviewDetailsVm.HD_ANY_MEDICATION_ANS = bindMedDetails[i].ans;
                                }
                                
                            }
                            if(bindMedDetails[i].id == 'HD_PRAPOSAL_DECLI_POSTPOND'){                 
                                rrReviewDetailsVm.HD_PRAPOSAL_DECLI_POSTPOND_ID = bindMedDetails[i].id;  
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_PRAPOSAL_DECLI_POSTPOND_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_PRAPOSAL_DECLI_POSTPOND_ANS = 'No'
                                }else{
                                  rrReviewDetailsVm.HD_PRAPOSAL_DECLI_POSTPOND_ANS = bindMedDetails[i].ans;
                                }             
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ADVISED_FOR_INVESTIGATION'){                  
                                rrReviewDetailsVm.HD_ADVISED_FOR_INVESTIGATION_ID = bindMedDetails[i].id;  
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ADVISED_FOR_INVESTIGATION_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ADVISED_FOR_INVESTIGATION_ANS = 'No'
                                }else{
                                 rrReviewDetailsVm.HD_ADVISED_FOR_INVESTIGATION_ANS = bindMedDetails[i].ans;
                                }            
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ULTRA_SONO'){                    
                                 rrReviewDetailsVm.HD_ULTRA_SONO_ID = bindMedDetails[i].id; 
                                  if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ULTRA_SONO_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ULTRA_SONO_ANS = 'No'
                                }else{
                                  rrReviewDetailsVm.HD_ULTRA_SONO_ANS = bindMedDetails[i].ans;
                                }          
                               
                            }
                            if(bindMedDetails[i].id == 'HD_CT_SCANMRI'){             
                                rrReviewDetailsVm.HD_CT_SCANMRI_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_CT_SCANMRI_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_CT_SCANMRI_ANS = 'No'
                                }else{
                                  rrReviewDetailsVm.HD_CT_SCANMRI_ANS = bindMedDetails[i].ans;
                                }                      
                                
                            }
                            if(bindMedDetails[i].id == 'HD_BIOPSY'){
                                rrReviewDetailsVm.HD_BIOPSY_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_BIOPSY_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_BIOPSY_ANS = 'No'
                                }else{
                                   rrReviewDetailsVm.HD_BIOPSY_ANS = bindMedDetails[i].ans;
                                }   
                               
                            }
                            if(bindMedDetails[i].id == 'HD_ANGIOGRAPHY'){
                                rrReviewDetailsVm.HD_ANGIOGRAPHY_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ANGIOGRAPHY_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ANGIOGRAPHY_ANS = 'No'
                                }else{
                                   rrReviewDetailsVm.HD_ANGIOGRAPHY_ANS = bindMedDetails[i].ans;
                                }
                               
                            }
                            if(bindMedDetails[i].id == 'HD_CONSUME_CIGARETTES'){
                                rrReviewDetailsVm.HD_CONSUME_CIGARETTES_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_CONSUME_CIGARETTES_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_CONSUME_CIGARETTES_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_CONSUME_CIGARETTES_ANS = bindMedDetails[i].ans;
                                }
                               
                            }
                            if(bindMedDetails[i].id == 'HD_CONSUME_ALCOLOL'){
                                rrReviewDetailsVm.HD_CONSUME_ALCOLOL_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_CONSUME_ALCOLOL_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_CONSUME_ALCOLOL_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_CONSUME_ALCOLOL_ANS = bindMedDetails[i].ans;
                                }
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ALCOHOL_TYPE'){
                                rrReviewDetailsVm.HD_ALCOHOL_TYPE_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ALCOHOL_TYPE_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ALCOHOL_TYPE_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_ALCOHOL_TYPE_ANS = bindMedDetails[i].ans;
                                }
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ALCOHOL_QUANTITY'){
                                rrReviewDetailsVm.HD_ALCOHOL_QUANTITY_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_ALCOHOL_QUANTITY_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_ALCOHOL_QUANTITY_ANS = 'No'
                                }else{
                                    rrReviewDetailsVm.HD_ALCOHOL_QUANTITY_ANS = bindMedDetails[i].ans;
                                }
                                
                            }
                            if(bindMedDetails[i].id == 'HD_NARCOTICS_GRUGS'){
                                rrReviewDetailsVm.HD_NARCOTICS_GRUGS_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_NARCOTICS_GRUGS_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_NARCOTICS_GRUGS_ANS = 'No'
                                }else{
                                     rrReviewDetailsVm.HD_NARCOTICS_GRUGS_ANS = bindMedDetails[i].ans;
                                }
                               
                            }
                            if(bindMedDetails[i].id == 'HD_IS_PREGNANT'){
                                rrReviewDetailsVm.HD_IS_PREGNANT_ID = bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_IS_PREGNANT_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_IS_PREGNANT_ANS = 'No'
                                }else{
                                     rrReviewDetailsVm.HD_IS_PREGNANT_ANS = bindMedDetails[i].ans;
                                }
                                
                            }
                            if(bindMedDetails[i].id == 'PREGNANT_MONTHS'){
                                rrReviewDetailsVm.PREGNANT_MONTHS_ID = bindMedDetails[i].id;
                                 if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.PREGNANT_MONTHS_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.PREGNANT_MONTHS_ANS = 'No'
                                }else{
                                     rrReviewDetailsVm.PREGNANT_MONTHS_ANS = bindMedDetails[i].ans;
                                }
                                
                            }

                            if(bindMedDetails[i].id == 'HD_GYNAECOLOGICAL_PROBLEM'){
                                rrReviewDetailsVm.HD_GYNAECOLOGICAL_PROBLEM_ID= bindMedDetails[i].id;
                                if(bindMedDetails[i].ans == 'true'){
                                    rrReviewDetailsVm.HD_GYNAECOLOGICAL_PROBLEM_ANS = 'Yes'
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rrReviewDetailsVm.HD_GYNAECOLOGICAL_PROBLEM_ANS = 'No'
                                }else{
                                      rrReviewDetailsVm.HD_GYNAECOLOGICAL_PROBLEM_ANS = bindMedDetails[i].ans;
                                }
                               
                            }

                    }
                 })
         }
     


  

        

        

        rrReviewDetailsVm.showPop = function(){
            rrReviewDetailsVm.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                templateUrl: 'pages/yonoCash/landing/dropdownModal.html',
                scope: $scope
            });
        }

        rrReviewDetailsVm.close = function(index){
            var title = '';
			var onTap = '';
            if(rrReviewDetailsVm.popUp){
              rrReviewDetailsVm.popUp.close();
            }
                    
                    rrReviewDetailsVm.balance = rrReviewDetailsVm.accDetails[index].accountBalance;
                    rrReviewDetailsVm.accType = rrReviewDetailsVm.accDetails[index].accountType;
                    rrReviewDetailsVm.accountNumber = rrReviewDetailsVm.accDetails[index].accountNumber;
                    rrReviewDetailsVm.isActive = rrReviewDetailsVm.accDetails[index].isActive;
                    rrReviewDetailsVm.isTransactional = rrReviewDetailsVm.accDetails[index].isTransactional;
                    requestYCService.selectedDetails.selIndex = index ;
                    requestYCService.selectedDetails.accountNumber = rrReviewDetailsVm.accDetails[index].accountNumber;
                    requestYCService.selectedDetails.accountBalance = rrReviewDetailsVm.accDetails[index].accountBalance;
                    rrReviewDetailsVm.showSelect = false;

                if (rrReviewDetailsVm.isActive === "false" || rrReviewDetailsVm.isActive === false) {
                rrReviewDetailsVm.disablenext = true;
                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SELECT_ACTIVE_ACC_DREAM"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="ACTIVE_OR"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="CONTACT_NEAREST"></div>';
                requestYCService.showAlertModal(title, template, onTap, $scope, $state);
                }

                if (rrReviewDetailsVm.isTransactional === "false" || rrReviewDetailsVm.isTransactional === false) {
                    rrReviewDetailsVm.disablenext = true;
                    var template1 = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="USE_TRANS_RIGHTS"></div>';
                    requestYCService.showAlertModal(title, template1, onTap, $scope, $state);
                }
                    rrReviewDetailsVm.changeAmount();
                }


               
                

        rrReviewDetailsVm.toggleGroup = function (group) {
            if (rrReviewDetailsVm.isGroupShown(group)) {
                rrReviewDetailsVm.shownGroup = null;
                rrReviewDetailsVm.isGroupShown(group)
            } else {
                rrReviewDetailsVm.shownGroup = group;
                rrReviewDetailsVm.isGroupShown(group)
            }
        };


        
         rrReviewDetailsVm.isGroupShown = function (group) {
            return rrReviewDetailsVm.shownGroup === group;
        };


        rrReviewDetailsVm.maskUnmaskdob = function () {
                                
              if(rrReviewDetailsVm.isMaskedDOB == true){
                rrReviewDetailsVm.isMaskedDOB = false ;
                rrReviewDetailsVm.inputImgDOB = "img/Visibility_on.svg";
                }else{
                rrReviewDetailsVm.isMaskedDOB = true ;
                rrReviewDetailsVm.inputImgDOB = "img/Visibility_off.svg" ;   
                }     
    
             };

        rrReviewDetailsVm.maskUnmaskPAN = function () {
                                
                if(rrReviewDetailsVm.isMaskedPAN == true){
                    rrReviewDetailsVm.isMaskedPAN = false ;
                    rrReviewDetailsVm.inputImgPAN = "img/Visibility_on.svg";
                }else{
                    rrReviewDetailsVm.isMaskedPAN = true ;
                    rrReviewDetailsVm.inputImgPAN = "img/Visibility_off.svg";
                }

            };


        rrReviewDetailsVm.maskUnmaskMOB = function () {
                                
                if(rrReviewDetailsVm.isMaskedMOB == true){
                    rrReviewDetailsVm.isMaskedMOB = false ;
                    rrReviewDetailsVm.inputImgMOB = "img/Visibility_on.svg";
                }else{
                    rrReviewDetailsVm.isMaskedMOB = true ;
                    rrReviewDetailsVm.inputImgMOB = "img/Visibility_off.svg";
                }

            };
            

        rrReviewDetailsVm.maskUnmaskEmail = function () {
            
            if(rrReviewDetailsVm.isMaskedEmail == true){
                rrReviewDetailsVm.isMaskedEmail = false ;
                rrReviewDetailsVm.inputImgEmail = "img/Visibility_on.svg";                
            }else{
                rrReviewDetailsVm.isMaskedEmail = true ;
                rrReviewDetailsVm.inputImgEmail = "img/Visibility_off.svg";
            }
        };

        rrReviewDetailsVm.emailMaskCheck = function(email){
            if(email){
                var arr = email.split("@");
                var firstDotIndex = arr[1].indexOf('.');
                var emailFirstPart = arr[1].substring(0, firstDotIndex);
                var emailSecondPart = arr[1].substring(firstDotIndex + 1);
                rrReviewDetailsVm.custemail=rrReviewDetailsVm.maskEmail2(arr[0]) + "@" + rrReviewDetailsVm.maskEmail(emailFirstPart)+"."+emailSecondPart;
            }			
		}
        rrReviewDetailsVm.maskEmail = function (str) {
		 return str[0] + "x".repeat(str.length - 2) + str.slice(-1);
		}
		rrReviewDetailsVm.maskEmail2 = function (str) {
	 	return str[0] + "x".repeat(str.length - 2) + str[str.length - 1] ;        
		}



        //Function for close view
        rrReviewDetailsVm.closeView = function () {
          homeScreenService.ishamburgerMenuRO=false;
          homeScreenService.isInsuranceFlag = true;
          getAccountDetailsService.tabIndex.tabIndex=4;
          $state.go('menu.accountOverviewMyBalance');
            //$state.go('menu.homeScreen');
        }

        rrReviewDetailsVm.onKeyUp = function(){
            $scope.isINR = true;
        }

        //onclick of Back button
        rrReviewDetailsVm.goBacktoPrevious = function () {
             $state.go('menu.rinQuestionsAns',{ termsObj: 'review_back' });
        };

        //onclick of next button
        rrReviewDetailsVm.goToNextPage = function () {
            rrService.saveData.application.app.pageNo = 5;
             rrService.saveApplication().then(function (data) {
                        utilityService.hideSpinner();                         
                        $state.go('menu.rrPaymantDetails');
                    }, function (error) {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);       
                    });                  
        }

        rrReviewDetailsVm.editPersonalDetails = function(value){
            $state.go('menu.rrPersonalDetails', { termsObj: value });
        }

        rrReviewDetailsVm.changeAddressDetails = function(value){
            $state.go('menu.rrEditAddress', { termsObj: value });
        }

        rrReviewDetailsVm.editNomineeDetails = function(value){
            $state.go('menu.rrNomioneeDetails', { termsObj: value });
        }

        rrReviewDetailsVm.editMedicalQuestions = function(value){
            $state.go('menu.rinQuestionsAns', { termsObj: value });
        }
        rrReviewDetailsVm.editTestingQuestions = function(value){
            $state.go('menu.rinQuestionsAns', { termsObj: value });
        }
        rrReviewDetailsVm.changeApplicationDetails = function(){
            $state.go('menu.rrPersonalDetails', { termsObj: "edit"});
        }

         rrReviewDetailsVm.getMaster = function () {
            rrService.getMedicalQuestions().then(function(data){                        
                        rrReviewDetailsVm.masterDataList=JSON.parse(data.content).content.appMaster;     
                    },function(error){
                        rrReviewDetailsVm.masterDataList=error.tabs;
                        
                    })
         } 
      
        rrReviewDetailsVm.getApplicationsData = function(){

            var reqParams = {
                "appNo": rrService.saveData.application.app.appNo
            }                
            
             rrService.getApplicationsData(reqParams).then(function (data) {
                        utilityService.hideSpinner();       
                        rrReviewDetailsVm.saveData= data;
                        rrService.saveData = data;
                        rrReviewDetailsVm.toShowCoverAmount = rrReviewDetailsVm.saveData.application.app.coverAmt
                        rrReviewDetailsVm.showCoverAmount = parseInt(rrReviewDetailsVm.toShowCoverAmount);
                        rrService.premiumDetails.totPremAmt = rrService.saveData.application.app.totPremAmt;
                        rrService.premiumDetails.basePremAmt = rrService.saveData.application.app.basePremAmt;
                        rrService.premiumDetails.quoteNo = rrService.saveData.application.app.quoteNo;
                        rrService.premiumDetails.taxAmt = rrService.saveData.application.app.taxAmt;
                        rrReviewDetailsVm.tenureYears = rrReviewDetailsVm.yearcalc(rrReviewDetailsVm.saveData.application.app.coverTerm);
                        rrService.loanTypeInfo = data.application.app.loanAcType;

                        rrReviewDetailsVm.maskedPersonalDOB = rrReviewDetailsVm.saveData.application.app.personal.dob.substring(0, rrReviewDetailsVm.saveData.application.app.personal.dob.length - 4)  + 'XXXX';

                        if(rrReviewDetailsVm.saveData.application.app.personal.title){
                        angular.forEach(rrReviewDetailsVm.masterDataList.salutations, function (value, key) {
							if (value.key.toString() == rrReviewDetailsVm.saveData.application.app.personal.title) {
								rrReviewDetailsVm.saveData.application.app.personal.title = value.value;
							}
						});
                        }
                        if(rrReviewDetailsVm.saveData.application.app.nominee.title){
                        angular.forEach(rrReviewDetailsVm.masterDataList.salutations, function (value, key) {
							if (value.key.toString() == rrReviewDetailsVm.saveData.application.app.nominee.title) {
								rrReviewDetailsVm.saveData.application.app.nominee.title = value.value;
							}
						});
                        }
                        if(rrReviewDetailsVm.saveData.application.app.appointee.title){
                        angular.forEach(rrReviewDetailsVm.masterDataList.salutations, function (value, key) {
							if (value.key.toString() == rrReviewDetailsVm.saveData.application.app.appointee.title) {
								rrReviewDetailsVm.saveData.application.app.appointee.title = value.value;
							}
						});
                        }
                        if(rrReviewDetailsVm.saveData.application.app.personal.address.pincode){
                            rrReviewDetailsVm.getPinData(rrReviewDetailsVm.saveData.application.app.personal.address.pincode);
                        }
                        if(rrReviewDetailsVm.saveData.application.app.nominee.address.pincode){
                            rrReviewDetailsVm.getPinDataNom(rrReviewDetailsVm.saveData.application.app.nominee.address.pincode);
                        }
                        rrReviewDetailsVm.emailMaskCheck(rrReviewDetailsVm.saveData.application.app.personal.email)
                        rrReviewDetailsVm.getMedicalQuestions();        
                        //$state.go('menu.rrNomioneeDetails');
                    }, function (error) {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                        //$state.go('menu.rrPersonalDetails');
                    });
        }

        rrReviewDetailsVm.yearcalc = function (monthCount){
            
                function getPlural(number, word) {
                    return number === 1 && word.one || word.other;
                }
            
                var months = { one: 'Month', other: 'Months' },
                    years = { one: 'Year', other: 'Years' },
                    m = monthCount % 12,
                    y = Math.floor(monthCount / 12),
                    result = [];
            
                y && result.push(y + ' ' + getPlural(y, years));
                m && result.push(m + ' ' + getPlural(m, months));
                return result.join('  ');
                    
            
        }


        rrReviewDetailsVm.getPinData = function (pinCode) {
				
                if(pinCode.length == 6){
                    var inputparams = {
				    "pinCode" : pinCode
                    }                    
                    rrService.getPostalDetailByPincode(inputparams).then(function(data) {                        
                            rrReviewDetailsVm.areaDetailsList = data[0];
                            rrReviewDetailsVm.saveData.application.app.personal.address.city =  rrReviewDetailsVm.areaDetailsList.cityCode;
                            rrReviewDetailsVm.saveData.application.app.personal.address.state =  rrReviewDetailsVm.areaDetailsList.stateCode;

                        
                    }, function(error) {
                        if(error.responseCode == '2001'){
                        utilityService.showErrorMessage("Invalid Pincode");    
                        }else{
                        utilityService.showErrorMessage(error.responseMessage);    
                        }
                    });
                    
                }


			}
        rrReviewDetailsVm.getPinDataNom = function (pinCode) {
            
            if(pinCode.length == 6){
                var inputparams = {
                "pinCode" : pinCode
                }                    
                rrService.getPostalDetailByPincode(inputparams).then(function(data) {                        
                        rrReviewDetailsVm.areaDetailsList1 = data[0];
                        rrReviewDetailsVm.saveData.application.app.nominee.address.city =  rrReviewDetailsVm.areaDetailsList1.cityCode;
                        rrReviewDetailsVm.saveData.application.app.nominee.address.state =  rrReviewDetailsVm.areaDetailsList1.stateCode;

                    
                }, function(error) {
                    if(error.responseCode == '2001'){
                        utilityService.showErrorMessage("Invalid Pincode");    
                        }else{
                        utilityService.showErrorMessage(error.responseMessage);    
                        }
                });
                
            }


        }
     


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
           
        });


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            rrReviewDetailsVm.getMaster();
            //rrReviewDetailsVm.groups = [{name:'Anupam',description:'test'}];
            initPage();      
            rrReviewDetailsVm.shownGroup = null;      
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);