'use strict';

angularApp.controller('premiumCalculatorController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "getAccountDetailsService",
    "utilityService",
    "homeScreenService",
    "$ionicPopup",
    "$rootScope",
    "$filter","rrService","$ionicScrollDelegate","$ionicHistory","$timeout","$stateParams",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        getAccountDetailsService,
        utilityService,
        homeScreenService,
        $ionicPopup,
        $rootScope,
        $filter,rrService,$ionicScrollDelegate,$ionicHistory,$timeout,$stateParams
    ) {

        var premiumCalculatorVm = this;
        premiumCalculatorVm.lifeGeneInsure = $stateParams.lifeGeneInsure;
        premiumCalculatorVm.isChallenged = false;
        premiumCalculatorVm.isValidAccount = false;
        premiumCalculatorVm.validAccountMessage = "";
        premiumCalculatorVm.disablenext = false;
        $scope.isINR = false;


        function initPage() {
            premiumCalculatorVm.disableBtn = true;
            premiumCalculatorVm.readOnlyCheck = true;
            premiumCalculatorVm.CoverTermErr = false;
            premiumCalculatorVm.showBack = true;
            premiumCalculatorVm.showNext = true;
            premiumCalculatorVm.amountSlider={};
            premiumCalculatorVm.monthsSlider={};
            premiumCalculatorVm.refreshSlider();
            premiumCalculatorVm.payingFrom = getAccountDetailsService.accountOverviewData.accounts;
            premiumCalculatorVm.accDetails = [];
            premiumCalculatorVm.accDetails = premiumCalculatorVm.payingFrom;
            premiumCalculatorVm.showSelect = true;
            premiumCalculatorVm.gonextPg = false;   
            premiumCalculatorVm.isRetrive=rrService.getRetrive();
            if(!premiumCalculatorVm.isRetrive){
                rrService.saveData ={
					 "application": {
					  "tncConsent": "",
					  "claimConsent": "",
					  "app": {    
					   "appNo": "",
					   "pageNo": "",
					   "riConsent": "",
					   "personal": {
					    "title": "",
					    "spouse": "",
					    "address": {
					     "building": "",
					     "locality": "",
					     "landMark": "",
					     "pincode": "",
					     "city": "",
					     "state": "",
					     "country": "",
						 "minCoverAmt":"",
						 "maxCoverAmt":"",
						 "minCoverTerm":"",
						 "maxCoverTerm":"",
						 "outStandTerm":"",
						 "outStndAmt":"",
						 "coverAmtStep":"",
						 "coverTerm":"",
						 "coverAmt":""
					    }
					   },

					   "professional": {
					    "occupation": "",
					    "company": "",
					    "desig": "",
					    "companyNature": "",
						"otherOccupation":""
					   },

					   "nominee": {
					    "title": "",
					    "firstName": "",
					    "middleName": "",
					    "lastName": "",
					    "relation": "",
					    "gender": "",
					    "dob": "",
					    "sameApplAddress": "",
					    "address": {
					     "building": "",
					     "locality": "",
					     "landMark": "",
					     "pincode": "",
					     "city": "",
					     "state": ""
					    },
					    "isMinor": ""
					   },

					   "appointee": {
					    "title": "",
					    "firstName": "",
					    "lastName": "",
					    "dob": "",
					    "relation": ""
					   },

					   "medical": {
					    "heightFeet": "",
					    "heightInches": "",
					    "weight": "",
					    
					    "diseases": [{
					      "nature": "",
					      "diagDate": "",
					      "recovered": "",
					      "treatDetail": ""
					     }
					    ],
					    "questions": [{
					     
					      "id": "",
					      "ans": ""
					     }
					    ],
					   
					    "tests": [{
					      "id": "",
					      "reason": ""

					     }
					    ]
					   }
					  }
					 }
					};
            }     
             
            premiumCalculatorVm.isMaskedTotal = true;         
            //premiumCalculatorVm.getApplications();

            if(rrService.saveData){
            premiumCalculatorVm.loanNumber = rrService.saveData.application.app.loanAc ? rrService.saveData.application.app.loanAc : ''
            premiumCalculatorVm.ttlpremium = rrService.saveData.application.app.emiAmt ? rrService.saveData.application.app.emiAmt : ''
            premiumCalculatorVm.tenureMonths = rrService.saveData.application.app.coverTerm ? rrService.saveData.application.app.coverTerm : ''

            if(rrService.saveData.application.app.appNo){
                premiumCalculatorVm.ttlpremium = rrService.premiumDetails.totPremAmt;
                premiumCalculatorVm.basePremAmt = rrService.premiumDetails.basePremAmt;
                premiumCalculatorVm.quoteNo = rrService.premiumDetails.quoteNo;
                premiumCalculatorVm.taxAmt = rrService.premiumDetails.taxAmt;
                premiumCalculatorVm.msgQuote = rrService.premiumDetails.message;
            }else{
                rrService.premiumDetails = {
                    basePremAmt: "",
                    quoteNo: "",
                    taxAmt: "",
                    totPremAmt: ""
                };
                rrService.eligibleResponse = {
                    coverAmtStep: "",
                    coverTermStep: "",
                    loanAc: "",
                    maxCoverAmt: "",
                    maxCoverTerm: "",
                    minCoverAmt: "",
                    minCoverTerm: "",
                    outStantTerm: "",
                    outStndAmt: ""
                };
            }

            

            if(rrService.saveData.application.app.loanAc){      
                        for(var i =0; i<= premiumCalculatorVm.loanAccount.length; i++){
                            if(premiumCalculatorVm.loanAccount[i].loanNumber == rrService.saveData.application.app.loanAc){
                                premiumCalculatorVm.setValue(i);
                            }
                        }
                    }
            }
            
            
            
          
           
           
            premiumCalculatorVm.lessBal = false;       

           
            

        }

        premiumCalculatorVm.hideshowTotal = function () {

            if(premiumCalculatorVm.isMaskedTotal == true){
                premiumCalculatorVm.isMaskedTotal = false
                premiumCalculatorVm.footheight = '235px';
            }else{
                premiumCalculatorVm.isMaskedTotal = true
                premiumCalculatorVm.footheight = '105px';
            }
        };

        premiumCalculatorVm.getAccount =function(){
                if (!getAccountDetailsService.accountOverviewData) {
                    utilityService.showSpinner();
                    homeScreenService.getCustomerInfo().then(function (data) {
                        utilityService.hideSpinner();
                        getAccountDetailsService.accountOverviewData = data;
                        premiumCalculatorVm.customerInformation=getAccountDetailsService.accountOverviewData.customerInformation;                 
                        //premiumCalculatorVm.loanAccount=getAccountDetailsService.accountOverviewData.loanDetails;
                         // if(premiumCalculatorVm.loanAccount.length == 0){
                         //        rrService.displayPopUp("","padBtm25 top-padding26","No Accounts available","OK",function(){
                         //                $state.go('menu.homeScreen');
                         //            });
                         //    }
                            // else if(premiumCalculatorVm.customerInformation.residentialStatus != '1'){
                            //     premiumCalculatorVm.showNRIPopup();
                            // }
                            if(premiumCalculatorVm.customerInformation.isStaffFlag){
                                if(premiumCalculatorVm.customerInformation.isStaffFlag.toLowerCase() != "n"){
                                    rrService.displayPopUp("", "padBtm25 top-padding26", "Staff users are not allowed to apply for Rinn Raksha policy.", "OK", function () {
                                        homeScreenService.isInsuranceFlag = true;
                                        getAccountDetailsService.tabIndex.tabIndex=4; 
                                        $state.go('menu.accountOverviewMyBalance');
                                    });
                                }
                            }else if(!premiumCalculatorVm.customerInformation.firstName && !premiumCalculatorVm.customerInformation.lastName){
                                premiumCalculatorVm.emptyField = "First name and Last name "
                                premiumCalculatorVm.showFieldPopup();
                            }else if(!premiumCalculatorVm.customerInformation.firstName){
                                premiumCalculatorVm.emptyField = "First name "
                                premiumCalculatorVm.showFieldPopup();
                            }else if(!premiumCalculatorVm.customerInformation.lastName){
                                premiumCalculatorVm.emptyField = "Last name "
                                premiumCalculatorVm.showFieldPopup();
                            }else if(!premiumCalculatorVm.customerInformation.dob){
                                premiumCalculatorVm.emptyField = "date of birth "
                                premiumCalculatorVm.showFieldPopup();
                            }else if(!premiumCalculatorVm.customerInformation.gender){
                                premiumCalculatorVm.emptyField = "Gender "
                                premiumCalculatorVm.showFieldPopup();
                            }else if(!premiumCalculatorVm.customerInformation.panNumber){
                                premiumCalculatorVm.emptyField = "Pan No "
                                premiumCalculatorVm.showFieldPopup();
                            }else if(premiumCalculatorVm.customerInformation.gender.toLowerCase() != 'male' &&  premiumCalculatorVm.customerInformation.gender.toLowerCase() != 'female'){
                                rrService.displayPopUp("", "padBtm25 top-padding26", "Gender status has not been updated in your account, kindly contact your Home Branch.", "OK", function () {
                                    homeScreenService.isInsuranceFlag = true;
                                    getAccountDetailsService.tabIndex.tabIndex=4; 
                                    $state.go('menu.accountOverviewMyBalance');
                                });
                            }
                    }, function (error) {
                        //utilityService.hideSpinner();
                        //utilityService.showErrorMessage(error.responseMessage);
                        //$state.go('menu.homeScreen');
                         rrService.displayPopUp("","padBtm25 top-padding26",error.responseMessage,"OK",function(){
                                $state.go('menu.homeScreen');
                            });
                        utilityService.hideSpinner();    
                    });
                } else {
                    premiumCalculatorVm.customerInformation=getAccountDetailsService.accountOverviewData.customerInformation;                 
                    //premiumCalculatorVm.loanAccount=getAccountDetailsService.accountOverviewData.loanDetails;
                    // if(premiumCalculatorVm.loanAccount.length == 0){
                    //             rrService.displayPopUp("","padBtm25 top-padding26","No Accounts available","OK",function(){
                    //                     $state.go('menu.homeScreen');
                    //                 });
                    // }
                    // else if(premiumCalculatorVm.customerInformation.residentialStatus != '1'){
                    //     premiumCalculatorVm.showNRIPopup();
                    // }
                     if(premiumCalculatorVm.customerInformation.isStaffFlag){
                        if(premiumCalculatorVm.customerInformation.isStaffFlag.toLowerCase() != "n"){
                            rrService.displayPopUp("", "padBtm25 top-padding26", "Staff users are not allowed to apply for Rinn Raksha policy.", "OK", function () {
                                homeScreenService.isInsuranceFlag = true;
                                getAccountDetailsService.tabIndex.tabIndex=4; 
                                $state.go('menu.accountOverviewMyBalance');
                            });
                        }
                     }else if(!premiumCalculatorVm.customerInformation.firstName && !premiumCalculatorVm.customerInformation.lastName){
                        premiumCalculatorVm.emptyField = "First name and Last name "
                        premiumCalculatorVm.showFieldPopup();
                    }else if(!premiumCalculatorVm.customerInformation.firstName){
                        premiumCalculatorVm.emptyField = "First name "
                        premiumCalculatorVm.showFieldPopup();
                    }else if(!premiumCalculatorVm.customerInformation.lastName){
                        premiumCalculatorVm.emptyField = "Last name "
                        premiumCalculatorVm.showFieldPopup();
                    }else if(!premiumCalculatorVm.customerInformation.dob){
                        premiumCalculatorVm.emptyField = "date of birth "
                        premiumCalculatorVm.showFieldPopup();
                    }else if(!premiumCalculatorVm.customerInformation.gender){
                        premiumCalculatorVm.emptyField = "Gender "
                        premiumCalculatorVm.showFieldPopup();
                    }else if(!premiumCalculatorVm.customerInformation.panNumber){
                        premiumCalculatorVm.emptyField = "Pan No "
                        premiumCalculatorVm.showFieldPopup();
                    }else if(premiumCalculatorVm.customerInformation.gender.toLowerCase() != 'male' &&  premiumCalculatorVm.customerInformation.gender.toLowerCase() != 'female') {
                        rrService.displayPopUp("", "padBtm25 top-padding26", "Gender status has not been updated in your account, kindly contact your Home Branch.", "OK", function () {
                            homeScreenService.isInsuranceFlag = true;
                            getAccountDetailsService.tabIndex.tabIndex=4; 
                            $state.go('menu.accountOverviewMyBalance');
                        });
                    }
                }
                 if (!rrService.loanAccountData || rrService.loanAccountData.length == 0) {
                    rrService.getRRLoanAcList().then(function (data) {
                        premiumCalculatorVm.loanAccount=data.loanAcList;
                        rrService.loanAccountData=data.loanAcList;
                         if(premiumCalculatorVm.loanAccount.length == 0){
                                rrService.displayPopUp("","padBtm25 top-padding26","No Accounts available","OK",function(){
                                        $state.go('menu.homeScreen');
                                    });
                            }
                    },function (error) {
                        //utilityService.hideSpinner();
                        //utilityService.showErrorMessage(error.responseMessage);
                        //$state.go('menu.homeScreen');
                         rrService.displayPopUp("","padBtm25 top-padding26",error.responseMessage,"OK",function(){
                                $state.go('menu.homeScreen');
                            });
                        utilityService.hideSpinner();    
                    });
                 }else{
                    premiumCalculatorVm.loanAccount=rrService.loanAccountData;
                 }
                
                
            }

            premiumCalculatorVm.showNRIPopup = function(){
                var showNRIPopup = $ionicPopup.confirm({
                    template: '<p><div class=""><img class="rrpopupStyleM5" src="img/yc_Group.svg"</div> <div class ="rrwidth90" translate="RR_POP_MSG_NRI" ></div>   </p>',
                    cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogRR',
                    scope: $scope,
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (e) {
                            showNRIPopup.close();
                            // homeScreenService.isInsuranceFlag = true;
                            // getAccountDetailsService.tabIndex.tabIndex=4;
                            //$state.go('menu.accountOverviewMyBalance');
                            e.preventDefault();
                        }
                    },
                    {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (e) {
                            showNRIPopup.close();
                           homeScreenService.isInsuranceFlag = true;
                           getAccountDetailsService.tabIndex.tabIndex=4; 
                           $state.go('menu.accountOverviewMyBalance');
                            e.preventDefault();   
                        }
                    }]
                });
            }

            premiumCalculatorVm.showFieldPopup = function(){
                var showFieldPopup = $ionicPopup.confirm({
                    template: '<p><img class="rrpopupStyleM5" src="img/yc_Group.svg"><div class="rrwidth90"><span translate="RR_POP_MSG_FIELD" ></span><span>'+premiumCalculatorVm.emptyField+'</span></div>   </p>',
                    cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogRRFld',
                    scope: $scope,
                    buttons: [
                    {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (e) {
                            showFieldPopup.close();
                            $state.go('menu.homeScreen');
                            e.preventDefault();   
                        }
                    }]
                });
            }
            
        // premiumCalculatorVm.getApplications = function(){
        //     rrService.getApplications().then(function(res){
        //         angular.forEach(res, function (value, key) {
        //                     for (var i in value) {
        //                         if (value.status == 'Pending') {
        //                             premiumCalculatorVm.getApplicationsData(value);                          
                                      
        //                         }
        //                     }
        //                 });
        //     })
        //     }

        // premiumCalculatorVm.getApplicationsData = function(value){            
        //     var reqParams = {
        //         "appNo": value.appNo
        //     }            
        //      rrService.getApplicationsData(reqParams).then(function (data) {
        //                 utilityService.hideSpinner();       
        //                 rrReviewDetailsVm.saveData= data;
        //                 rrReviewDetailsVm.tenureYears = rrReviewDetailsVm.yearcalc(rrReviewDetailsVm.saveData.application.app.loanTerm);
        //                 console.log('Save Data RR ' + JSON.stringify(data)); 
        //                 rrReviewDetailsVm.getMedicalQuestions();
        //                 //$state.go('menu.rrNomioneeDetails');
        //             }, function (error) {
        //                 utilityService.hideSpinner();
        //                 utilityService.showErrorMessage(error.responseMessage);
        //                 //$state.go('menu.rrPersonalDetails');
        //             });
        // }
        premiumCalculatorVm.showPop = function(){
            premiumCalculatorVm.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                templateUrl: 'pages/rinnraksha/premiumCalculator/accountModelPopup.html',
                scope: $scope
            });
        }
        premiumCalculatorVm.setValue = function(index){
            premiumCalculatorVm.refreshSlider();
            premiumCalculatorVm.fromEdit=true;            
            rrService.saveData.application.app.coverTerm = parseInt(rrService.saveData.application.app.coverTerm);  
            rrService.saveData.application.app.coverAmt = parseInt(rrService.saveData.application.app.coverAmt);  

            premiumCalculatorVm.loanLabel = premiumCalculatorVm.loanAccount[index].loanLabel;
            premiumCalculatorVm.loanNumber = premiumCalculatorVm.loanAccount[index].loanNumber;
            premiumCalculatorVm.loanInterest = premiumCalculatorVm.loanAccount[index].interest;

            
            
            rrService.eligibleResponse.coverAmtStep = rrService.saveData.application.app.coverAmtStep;  
            rrService.eligibleResponse.coverTermStep = rrService.saveData.application.app.coverTermStep;
            rrService.eligibleResponse.loanAc = premiumCalculatorVm.loanNumber;  
            rrService.eligibleResponse.maxCoverAmt = rrService.saveData.application.app.maxCoverAmt;
            rrService.eligibleResponse.minCoverAmt = rrService.saveData.application.app.minCoverAmt;  
            rrService.eligibleResponse.maxCoverTerm = rrService.saveData.application.app.maxCoverTerm;   
            rrService.eligibleResponse.minCoverTerm = rrService.saveData.application.app.minCoverTerm;

            
            rrService.eligibleResponse.outStndTerm =  parseInt(rrService.saveData.application.app.coverTerm);  
            rrService.eligibleResponse.outStndAmt = parseInt(rrService.saveData.application.app.coverAmt);  

            premiumCalculatorVm.amountSlider.value = rrService.saveData.application.app.coverAmt;
            premiumCalculatorVm.monthsSlider.value = rrService.saveData.application.app.coverTerm;
            premiumCalculatorVm.loanAmount = rrService.saveData.application.app.coverAmt;
            premiumCalculatorVm.tenureMonths = rrService.saveData.application.app.coverTerm;

            if(rrService.saveData.application.app.riConsent){
                premiumCalculatorVm.isChecked = true;
            }
                        

            premiumCalculatorVm.tenureYears = premiumCalculatorVm.yearcalc(premiumCalculatorVm.tenureMonths);
             if(rrService.eligibleResponse.outStndTerm < 180){
                    premiumCalculatorVm.showMonthSlider = false;
                    premiumCalculatorVm.readOnlyCheck = true;
                }else{
                    premiumCalculatorVm.showMonthSlider = true;
                    premiumCalculatorVm.readOnlyCheck = false;
                }


            



            premiumCalculatorVm.amountSlider = {
                value: Number(rrService.eligibleResponse.outStndAmt),
                options: {
                    showSelectionBar: true,
                    floor:Number(rrService.eligibleResponse.minCoverAmt),//min amt
                    ceil:  Number(rrService.eligibleResponse.maxCoverAmt),//max amt
                    step: Number(rrService.eligibleResponse.coverAmtStep),
                    onChange: function (id, model) {
                        premiumCalculatorVm.loanAmount = premiumCalculatorVm.amountSlider.value;
                        premiumCalculatorVm.checkFlag = premiumCalculatorVm.checkFlag + 1
                        premiumCalculatorVm.disableBuy = true;
                        premiumCalculatorVm.disableBtn = true;
                        premiumCalculatorVm.footheight = '60px';
                    },
                    translate: function (value, id, label) {
                        return '₹ '+ $filter('INRFLOAT')(value);
                        
                    }
                }
            };
            premiumCalculatorVm.monthsSlider = {
                value: Number(rrService.eligibleResponse.outStndTerm),
                options: {
                    showSelectionBar: true,
                    floor: Number(rrService.eligibleResponse.minCoverTerm),//min month
                    ceil: Number(rrService.eligibleResponse.maxCoverTerm),//max year
                    step: Number(rrService.eligibleResponse.coverTermStep),
                    onChange: function (id, model) {
                        premiumCalculatorVm.tenureMonths = premiumCalculatorVm.monthsSlider.value;
                        //  if(premiumCalculatorVm.tenureMonths > 180 ){
                        //             premiumCalculatorVm.readOnlyCheck = false;
                        //         }
                        premiumCalculatorVm.tenureYears = premiumCalculatorVm.yearcalc(premiumCalculatorVm.tenureMonths);                        
                        premiumCalculatorVm.checkFlag = premiumCalculatorVm.checkFlag + 1
                        premiumCalculatorVm.disableBuy = true;
                        premiumCalculatorVm.disableBtn = true;
                        premiumCalculatorVm.CoverTermErr = false;
                        premiumCalculatorVm.footheight = '60px';
                    },
                    translate: function (value, id, label) {
                        return value + " Months";
                    }
                }
            };
            
            
            
            premiumCalculatorVm.disableBuy = false;  
            premiumCalculatorVm.disableBtn = false; 
            premiumCalculatorVm.custEligibility = true;          
            

           
        }


        premiumCalculatorVm.close = function(index){
            
            premiumCalculatorVm.custEligibility = false;
            if(premiumCalculatorVm.popUp){
              premiumCalculatorVm.popUp.close();
            }    
                            
                    //premiumCalculatorVm.balance = premiumCalculatorVm.accDetails[index].accountBalance;
                    premiumCalculatorVm.loanLabel = premiumCalculatorVm.loanAccount[index].loanLabel;
                    premiumCalculatorVm.loanNumber = premiumCalculatorVm.loanAccount[index].loanNumber;
                    premiumCalculatorVm.loanInterest = premiumCalculatorVm.loanAccount[index].interest;

                    premiumCalculatorVm.reqParams = {};
                    premiumCalculatorVm.reqParams['loanAc'] = premiumCalculatorVm.loanNumber;
                    //premiumCalculatorVm.reqParams['loanType'] = premiumCalculatorVm.loanLabel;
                    //premiumCalculatorVm.reqParams['dob'] = premiumCalculatorVm.customerInformation.dob;
                    // premiumCalculatorVm.reqParams['dob'] = '05 Jan 1987';
                    //  rrService.eligibleResponse = {
                    //     coverAmtStep: "1000",
                    //     coverTermStep: "20",
                    //     loanAc: "30002843015",
                    //     maxCoverAmt: "500000",
                    //     maxCoverTerm: "400",
                    //     minCoverAmt: "100000",
                    //     minCoverTerm: "40",
                    //     outStndTerm: "200",
                    //     outStndAmt: "300000"
                    // }

                 rrService.getRREligibility(premiumCalculatorVm.reqParams).then(function(data){
                    premiumCalculatorVm.checkFlag = 1;
                    premiumCalculatorVm.custEligibility = true;     
                    rrService.eligibleResponse = data.rrDetails;
                    angular.forEach(premiumCalculatorVm.loanAccount, function (value, key) {
                        if(value.loanNumber==premiumCalculatorVm.loanNumber){
                            premiumCalculatorVm.productCode=value.accountTypeCode + "" + value.intCategory;
                        }
                        
                    })
                    

                    rrService.eligibleResponse.outStndTerm = parseInt(rrService.eligibleResponse.outStndTerm);
                    rrService.eligibleResponse.outStndAmt = parseInt(rrService.eligibleResponse.outStndAmt);
                   


                    //show message 
                    premiumCalculatorVm.showMessage = data.message;

                        
                   
                     premiumCalculatorVm.amountSlider = {
                        value: Number(rrService.eligibleResponse.outStndAmt),
                        options: {
                            showSelectionBar: true,
                            floor:Number(rrService.eligibleResponse.minCoverAmt),//min amt
                            ceil:  Number(rrService.eligibleResponse.maxCoverAmt),//max amt
                            step: Number(rrService.eligibleResponse.coverAmtStep),
                            onChange: function (id, model) {
                                premiumCalculatorVm.loanAmount = premiumCalculatorVm.amountSlider.value;
                                premiumCalculatorVm.checkFlag = premiumCalculatorVm.checkFlag + 1
                                premiumCalculatorVm.disableBuy = true;
                                premiumCalculatorVm.disableBtn = true;
                                premiumCalculatorVm.footheight = '60px';
                            },
                            translate: function (value, id, label) {
                                return '₹ '+ $filter('INRFLOAT')(value);
                                
                            }
                        }
                    };
                    premiumCalculatorVm.monthsSlider = {
                        value: Number(rrService.eligibleResponse.outStndTerm),
                        options: {
                            showSelectionBar: true,
                            floor: Number(rrService.eligibleResponse.minCoverTerm),//min month
                            ceil: Number(rrService.eligibleResponse.maxCoverTerm),//max year
                            step: Number(rrService.eligibleResponse.coverTermStep),
                            onChange: function (id, model) {
                                premiumCalculatorVm.tenureMonths = premiumCalculatorVm.monthsSlider.value;
                                // if(premiumCalculatorVm.tenureMonths > 180 ){
                                //     premiumCalculatorVm.readOnlyCheck = false;
                                // }
                                premiumCalculatorVm.tenureYears = premiumCalculatorVm.yearcalc(premiumCalculatorVm.tenureMonths);
                                premiumCalculatorVm.checkFlag = premiumCalculatorVm.checkFlag + 1
                                premiumCalculatorVm.disableBuy = true;
                                premiumCalculatorVm.disableBtn = true;
                                premiumCalculatorVm.CoverTermErr = false;
                                premiumCalculatorVm.footheight = '60px';
                            },
                            translate: function (value, id, label) {
                                return value + " Months";
                            }
                        }
                    };

                    if(rrService.eligibleResponse.outStndTerm < 180){
                        premiumCalculatorVm.showMonthSlider = false;
                        premiumCalculatorVm.readOnlyCheck = true;
                    }else{
                        premiumCalculatorVm.showMonthSlider = true;
                        premiumCalculatorVm.readOnlyCheck = false;
                    }

                    if(rrService.saveData.application.app.loanAc){
                    premiumCalculatorVm.amountSlider.value = rrService.saveData.application.app.coverAmt;
                    premiumCalculatorVm.monthsSlider.value = rrService.saveData.application.app.coverTerm;
                    premiumCalculatorVm.loanAmount = rrService.saveData.application.app.coverAmt;
                    premiumCalculatorVm.tenureMonths = rrService.saveData.application.app.coverTerm;
                    premiumCalculatorVm.tenureYears = premiumCalculatorVm.yearcalc(premiumCalculatorVm.tenureMonths);
                    premiumCalculatorVm.calculatePremiumData();
                    
                    }else{
                    premiumCalculatorVm.amountSlider.value = rrService.eligibleResponse.outStndAmt
                    premiumCalculatorVm.monthsSlider.value = rrService.eligibleResponse.outStndTerm
                    premiumCalculatorVm.loanAmount = rrService.eligibleResponse.outStndAmt;
                    premiumCalculatorVm.tenureMonths = rrService.eligibleResponse.outStndTerm;
                    premiumCalculatorVm.tenureYears = premiumCalculatorVm.yearcalc(premiumCalculatorVm.tenureMonths);
                    premiumCalculatorVm.calculatePremiumData();    
                    }
                 },function (error) {                        
                        premiumCalculatorVm.custEligibility = false;
                        premiumCalculatorVm.disableBtn = true;
                        utilityService.showErrorMessage(error.responseMessage);
                    });

                
                  

                   

                   
                

             }

             premiumCalculatorVm.checkMinMax= function () {
                 if(parseInt(premiumCalculatorVm.tenureMonths) < parseInt(rrService.eligibleResponse.maxCoverTerm) && parseInt(premiumCalculatorVm.tenureMonths) > (rrService.eligibleResponse.minCoverTerm)){
                     premiumCalculatorVm.CoverTermErr = false;  
                     premiumCalculatorVm.checkFlag = 2;                  
                     premiumCalculatorVm.tenureYears = premiumCalculatorVm.yearcalc(premiumCalculatorVm.tenureMonths);
                     premiumCalculatorVm.monthsSlider = {
                        value: Number(premiumCalculatorVm.tenureMonths),
                        options: {
                            showSelectionBar: true,
                            floor: Number(rrService.eligibleResponse.minCoverTerm),//min month
                            ceil: Number(rrService.eligibleResponse.maxCoverTerm),//max year
                            step: Number(rrService.eligibleResponse.coverTermStep),
                            onChange: function (id, model) {
                                premiumCalculatorVm.tenureMonths = premiumCalculatorVm.monthsSlider.value;                                
                                premiumCalculatorVm.tenureYears = premiumCalculatorVm.yearcalc(premiumCalculatorVm.tenureMonths);
                                premiumCalculatorVm.checkFlag = premiumCalculatorVm.checkFlag + 1
                                premiumCalculatorVm.disableBuy = true;
                                premiumCalculatorVm.disableBtn = true;
                                premiumCalculatorVm.CoverTermErr = false;
                                premiumCalculatorVm.footheight = '60px';
                            },
                            translate: function (value, id, label) {
                                return value + " Months";
                            }
                        }
                    };
                 }else{
                    if(parseInt(premiumCalculatorVm.tenureMonths) > parseInt(rrService.eligibleResponse.maxCoverTerm)){
                     premiumCalculatorVm.CoverTermErr = true;
                     premiumCalculatorVm.CoverTermMessage = "Maximum cover term should be less than "+parseInt(rrService.eligibleResponse.maxCoverTerm);
                    }else if(parseInt(premiumCalculatorVm.tenureMonths) < parseInt(rrService.eligibleResponse.minCoverTerm)){
                     premiumCalculatorVm.CoverTermErr = true;
                     premiumCalculatorVm.CoverTermMessage = "Minimum cover term should be greater than "+parseInt(rrService.eligibleResponse.minCoverTerm);   
                    }    
                 }
                 
            
            }

            premiumCalculatorVm.checkMinMaxAmt= function () {
                 if(parseInt(premiumCalculatorVm.loanAmount) <= parseInt(rrService.eligibleResponse.maxCoverAmt) && parseInt(premiumCalculatorVm.loanAmount) >= (rrService.eligibleResponse.minCoverAmt)){
                     premiumCalculatorVm.CoverAmtErr = false;  
                     premiumCalculatorVm.checkFlag = 2;                  
                     
                     premiumCalculatorVm.amountSlider = {
                        value: Number(premiumCalculatorVm.loanAmount),
                        options: {
                            showSelectionBar: true,
                            floor:Number(rrService.eligibleResponse.minCoverAmt),//min amt
                            ceil:  Number(rrService.eligibleResponse.maxCoverAmt),//max amt
                            step: Number(rrService.eligibleResponse.coverAmtStep),
                            onChange: function (id, model) {
                                premiumCalculatorVm.loanAmount = premiumCalculatorVm.amountSlider.value;
                                premiumCalculatorVm.checkFlag = premiumCalculatorVm.checkFlag + 1
                                premiumCalculatorVm.CoverAmtErr = false;  
                                premiumCalculatorVm.disableBuy = true;
                                premiumCalculatorVm.disableBtn = true;
                                premiumCalculatorVm.footheight = '60px';
                            },
                            translate: function (value, id, label) {
                                return '₹ '+ $filter('INRFLOAT')(value);
                                
                            }
                        }
                    };
                    premiumCalculatorVm.refreshSlider();
                 }else{
                    if(parseInt(premiumCalculatorVm.loanAmount) > parseInt(rrService.eligibleResponse.maxCoverAmt)){
                     premiumCalculatorVm.CoverAmtErr = true;
                     premiumCalculatorVm.CoverAmtMessage = "Maximum Loan amount should be less than or equal to "+parseInt(rrService.eligibleResponse.maxCoverAmt);
                    }else if(parseInt(premiumCalculatorVm.loanAmount) < parseInt(rrService.eligibleResponse.minCoverAmt)){
                     premiumCalculatorVm.CoverAmtErr = true;
                     premiumCalculatorVm.CoverAmtMessage = "Minimum Loan amount should be greater than or equal to "+parseInt(rrService.eligibleResponse.minCoverAmt);   
                    }    
                 }
                 
            
            }


        premiumCalculatorVm.changeAmount = function () {
            
        }
       premiumCalculatorVm.calculatePremiumData = function () {

           if(!premiumCalculatorVm.CoverTermErr){
            premiumCalculatorVm.calReqParams = {};
                    premiumCalculatorVm.calReqParams['coverAmt'] = premiumCalculatorVm.loanAmount ? parseInt(premiumCalculatorVm.loanAmount).toFixed(2).toString() : "";
                    premiumCalculatorVm.calReqParams['coverTerm'] = premiumCalculatorVm.tenureMonths.toString();
                    premiumCalculatorVm.calReqParams['productCode']=premiumCalculatorVm.productCode;
                    rrService.calculatePremium(premiumCalculatorVm.calReqParams).then(function (data) {
                        utilityService.hideSpinner();                        
                        //rrService.premiumDetails = data; 
                        premiumCalculatorVm.ttlpremium = data.totPremAmt;
                        premiumCalculatorVm.basePremAmt = data.basePremAmt;                       
                        premiumCalculatorVm.taxAmt = data.taxAmt;
                        premiumCalculatorVm.msgQuote = data.mdclRqrmnt;
                        premiumCalculatorVm.quoteNo = data.quoteNo;
                        rrService.premiumDetails.totPremAmt = data.totPremAmt;
                        rrService.premiumDetails.basePremAmt = data.basePremAmt;                        
                        rrService.premiumDetails.taxAmt = data.taxAmt;
                        rrService.premiumDetails.msgQuote = data.mdclRqrmnt;
                        rrService.premiumDetails.quoteNo = data.quoteNo;
                        // if(rrService.saveData.application.app.quoteNo){
                        //  premiumCalculatorVm.quoteNo = data.quoteNo;
                        //  rrService.premiumDetails.quoteNo = data.quoteNo;
                        // }
                         
                        

                        $ionicScrollDelegate.$getByHandle('calculatePremiumData').scrollBottom();
                        premiumCalculatorVm.checkFlag = 1;
                        premiumCalculatorVm.disableBuy = false;   
                        premiumCalculatorVm.disableBtn = false;  
                        premiumCalculatorVm.isMaskedTotal = true; 
                        premiumCalculatorVm.footheight = '105px';                  
                        console.log('Calculate Premium ' + data); 
                    }, function (error) {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                        premiumCalculatorVm.disableBtn = true;

                    });    
           }                

        }


     

      

        //Function for close view
        premiumCalculatorVm.closeView = function () {
            if(premiumCalculatorVm.fromEdit){
                homeScreenService.ishamburgerMenuRO=false;
                homeScreenService.isInsuranceFlag = true;
                getAccountDetailsService.tabIndex.tabIndex=4;
                $state.go('menu.accountOverviewMyBalance');
            }
            else if(premiumCalculatorVm.lifeGeneInsure){
                $state.go('menu.generalInsurance', {backInsurance : true});
            }else{
                $ionicHistory.goBack(-1);
            }

            

           
        }

        

       

        //onclick of next button
        premiumCalculatorVm.goToNextPage = function () {
           
            
        }

             

        premiumCalculatorVm.yearcalc = function (monthCount){
            
                function getPlural(number, word) {
                    return number === 1 && word.one || word.other;
                }
            
                var months = { one: 'Month', other: 'Months' },
                    years = { one: 'Year', other: 'Years' },
                    m = monthCount % 12,
                    y = Math.floor(monthCount / 12),
                    result = [];
            
                y && result.push(y + ' ' + getPlural(y, years));
                m && result.push(m + ' ' + getPlural(m, months));
                return result.join('  ');
                    
            
        }





        premiumCalculatorVm.gotoKnowMore = function(){
            $state.go('menu.rrKnowMore');  
        }

        premiumCalculatorVm.buyNow = function(){
            if(!premiumCalculatorVm.isChecked || premiumCalculatorVm.isChecked == false){               
                premiumCalculatorVm.showNRIPopup();               
                //show popup
            }else{
                if(premiumCalculatorVm.msgQuote != 'Medical'){
                    premiumCalculatorVm.showMsg = 'This Quote is valid for period of 30 days and if there are any changes in premium,  Cover Term SBI LIFE INSURANCE will intimate you accordingly'
                 }else{
                    premiumCalculatorVm.showMsg = 'This Quote is valid for period of 30 days and if there are any changes in premium,  Cover Term SBI LIFE INSURANCE will intimate you accordingly.<br>You may need to undergo medical checkup.</br>'
                }

                var rrQuotepopup = $ionicPopup.confirm({
                    template: '<p><div class=""><img class="rrpopupStyleM5" src="img/yc_Group.svg"</div> <div class ="rrwidth90" >' + premiumCalculatorVm.showMsg +'</div></p>',
                    cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogRR',
                    scope: $scope,
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (e) {
                            rrQuotepopup.close();
                            e.preventDefault();
                        }
                    },
                    {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (e) {
                            rrService.saveData.application.app.loanAc = premiumCalculatorVm.loanNumber ? premiumCalculatorVm.loanNumber:"";
                            rrService.saveData.application.app.emiAmt = premiumCalculatorVm.ttlpremium ? premiumCalculatorVm.ttlpremium : "";
                            //rrService.saveData.application.app.loanTerm = premiumCalculatorVm.tenureMonths ? premiumCalculatorVm.tenureMonths : "";
                            rrService.saveData.application.app.coverAmt = premiumCalculatorVm.loanAmount ? premiumCalculatorVm.loanAmount :"";
                            rrService.saveData.application.app.coverTerm = premiumCalculatorVm.tenureMonths ? premiumCalculatorVm.tenureMonths :"";

                            rrService.saveData.application.app.minCoverAmt = rrService.eligibleResponse.minCoverAmt ? rrService.eligibleResponse.minCoverAmt :"";
                            rrService.saveData.application.app.maxCoverAmt = rrService.eligibleResponse.maxCoverAmt ? rrService.eligibleResponse.maxCoverAmt :"";
                            rrService.saveData.application.app.minCoverTerm = rrService.eligibleResponse.minCoverTerm ? rrService.eligibleResponse.minCoverTerm :"";                           
                            rrService.saveData.application.app.maxCoverTerm = rrService.eligibleResponse.maxCoverTerm ? rrService.eligibleResponse.maxCoverTerm :"";
                            rrService.saveData.application.app.outStandTerm = rrService.eligibleResponse.outStndTerm ? rrService.eligibleResponse.outStndTerm :"";
                            rrService.saveData.application.app.outStndAmt = rrService.eligibleResponse.outStndAmt ? rrService.eligibleResponse.outStndAmt :"";
                            rrService.saveData.application.app.coverAmtStep = rrService.eligibleResponse.coverAmtStep ? rrService.eligibleResponse.coverAmtStep :"";
                            rrService.saveData.application.app.coverTermStep = rrService.eligibleResponse.coverTermStep ? rrService.eligibleResponse.coverTermStep :"";

                            rrService.saveData.application.app.riConsent = premiumCalculatorVm.isChecked;
                            
                           

                            





                            rrService.saveData.application.app.ttlpremium = rrService.premiumDetails.totPremAmt ? rrService.premiumDetails.totPremAmt : "";
                            rrService.saveData.application.app.basePremAmt = rrService.premiumDetails.basePremAmt ? rrService.premiumDetails.basePremAmt : "";
                            rrService.saveData.application.app.quoteNo = rrService.premiumDetails.quoteNo ? rrService.premiumDetails.quoteNo : "";
                            rrService.saveData.application.app.taxAmt = rrService.premiumDetails.taxAmt ? rrService.premiumDetails.taxAmt : "";
                            rrService.loanTypeInfo = premiumCalculatorVm.loanLabel ? premiumCalculatorVm.loanLabel :"";
                            

                            rrService.saveData.application.app.pageNo = 1;            
                            rrService.saveApplication().then(function (data) {
                                        utilityService.hideSpinner();    
                                        rrService.addRetrive(true); 
                                        if(!rrService.saveData.application.app.appNo){
                                        rrService.saveData.application.app.appNo = data.data.appNo;
                                        }                                        
                                        console.log('Save Data RR ' + JSON.stringify(data)); 
                                        $state.go('menu.rrPersonalDetails');
                                    }, function (error) {
                                        utilityService.hideSpinner();
                                        utilityService.showErrorMessage(error.responseMessage);
                                        $state.go('menu.rrPersonalDetails');
                                    });     
                //$state.go('menu.rrPersonalDetails');
                            $state.go('menu.rrPersonalDetails');
                            rrQuotepopup.close();
                            e.preventDefault();   
                        }
                    }]
                });
                //show popup




                
            }
           
        }

        premiumCalculatorVm.refreshSlider = function(){
            console.log("refresh hit");
            $timeout(function(){
                $scope.$broadcast('rzSliderForceRender');
            });
    
        };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {         
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            //$state.go('menu.rrReviewDetails');
            premiumCalculatorVm.isChecked = false;
            premiumCalculatorVm.getAccount();
            initPage();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);

//Save Data RR {"data":{"appNo":"4I4UAuVZVn"},"responseCode":"0000","responseMessage":"success"}