'use strict';

angularApp.controller('rrKnowMoreController', ["$state",
    "$scope", 
    "validateService",
    "utilityService",
    "sampoornSurakshaService",  
    "rrService","openUrlInAppbroswerService","irctcService",
    function($state, 
        $scope, 
        validateService,
        utilityService,
        sampoornSurakshaService,
        rrService,openUrlInAppbroswerService,irctcService) {


        var rrKnowMoreVm = this;

        function initPage() {

           
            rrService.getproductContent().then(function (data) {
                    rrKnowMoreVm.classForProductOpt = 'tab-items  div-bottom bor-bot-active';
                    rrKnowMoreVm.classForFeatureOpt = 'tab-items  div-bottom';
                    rrKnowMoreVm.classForTncOpt = 'tab-items  div-bottom';
                    rrKnowMoreVm.selType('P');
                    //rrKnowMoreVm.policyFeatures = JSON.parse(data.content);
                     rrKnowMoreVm.policyFeatures = data.content;
                     rrKnowMoreVm.policyFeatures = JSON.parse(rrKnowMoreVm.policyFeatures);
                     rrKnowMoreVm.loanTypeSection = rrKnowMoreVm.policyFeatures.data.tabs[0].elgTable[0];

                    //  rrKnowMoreVm.policyFeatures.data.tabs.tnc.content = "<ol> <li>All the product features under this plan shall be chosen by the Master policy holder in his capacity as the group administrator. Only features chosen by the Master policy holder shall be made available to the group members, based on eligibility. A group member can choose from the options/ features made available to him/ her by the Master policy holder.</li> <li>Termination of insurance cover: The insurance cover will automatically cease on the happenings of the earliest of the following dates:<ol class='tncInnerList'><li>The date of termination of the cover on the behest of the member.</li><li>The end of the policy term.</li><li>On death of the insured member.</li><li>The date on which the member reaches the maximum cover ceasing age.</li><li>The date on which surrender value is paid, if payable.</li><li>The date of payment on free-look cancellation.</li></ol> </li> <li>Surrender benefit:  You may request for surrender of the insurance cover in writing at any point of time after first policy year, provided at least first policy year’s premiums are paid. The Surrender Value (SV) available under this plan is : <br> SV = (50% x Premium(s) paid) x (Unexpired term / Total term)</li> <li>Free look cancellation: The member has the option to cancel the policy within 15 days of receipt of the certificate of insurance after reviewing the terms and conditions. Premium paid would be returned after deducting proportionate risk premium, taxes, expense incurred towards medical examination carried out and expense towards stamp duty.</li> <li>Suicide Clause: In case of death due to suicide in the first year of the insurance cover, the Sum Assured is not payable. In such a scenario, the 80% of the premiums (net of taxes and cess) paid in respect of the member will be refunded.</li> <li>For more details on risk factors, terms and conditions please read the common product sales brochure before concluding a sale.</li> </ol>"

                    //  rrKnowMoreVm.policyFeatures.data.desc = "<p>SBI Life – RiNn Raksha, a group credit life insurance plan, you can rest assured that your family will always enjoy the assets, which you so lovingly acquired, without worrying about any liabilities.</p> <p> In other words, live life 'Debt- Free'</p>"
                    //  rrKnowMoreVm.policyFeatures.data.footer = '<b>BEWARE OF SPURIOUS CALLS AND FICTITIOUS/FRAUDULENT OFFERS.</b><br /><p>IRDAI is not involved in activities like selling insurance policies, announcing bonus or investment of premiums. Public receiving such phone calls are requested to lodge a police compliant.</p><br /> <p>State Bank of India is a Corporate Agent (CoR No. CA0003) of  SBI Life Insurance Company Limited. Insurance is  underwritten by SBI Life Insurance Company Limited. The  purchase by a bank’s customer of any insurance products is  purely voluntary and is not linked to availment of any other  facility from the bank. Trade logo displayed above belongs to  State Bank of India and is used by SBI Life under license. SBI  Life Insurance Company Limited. Registered & Corporate  Office: Natraj, M.V. Road & Western Express Highway Junction,  Andheri (East), Mumbai - 400 069. IRDAI Registration No. 111 •  CIN: L99999MH2000PLC129113 • Website: www.sbilife.co.in  E-mail: info@sbilife.co.in • Toll Free: 1800 267 9090 (Between  9:00 am to 9:00 pm) • SMS ‘CELEBRATE’ to 56161.</p>'
                    //  rrKnowMoreVm.policyFeatures.data.tabs[1].condition = "*Tax benefits, are as per the Income Tax laws & is subject to change from time to time. Please consult your tax advisor for details."        
                    //  rrKnowMoreVm.policyFeatures.data.tabs[1].content = "<ul> <li>A <span>comprehensive benefit package</span> that can be customized to cover your debts in case of death or disability.</li> <li><span>Wide variety of loans covered</span> -  Housing Loans, Vehicle Loans, Educational Loans and Personal loans.</li> <li>Option to surrender/continue with life cover even after pre closure of loan.</li> <li><span>Tax benefits*</span> as per prevailing tax laws.</li> </ul>"
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    }); 
        }

        // function b64toBlob(b64Data, contentType, sliceSize) {
		// 	contentType = contentType || '';
		// 	sliceSize = sliceSize || 512;

		// 	var byteCharacters = atob(b64Data);
		// 	var byteArrays = [];

		// 	for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
		// 		var slice = byteCharacters.slice(offset, offset + sliceSize);

		// 		var byteNumbers = [];
		// 		for (var i = 0; i < slice.length; i++) {
		// 			byteNumbers[i] = slice.charCodeAt(i);
		// 		}

		// 		var byteArray = new Uint8Array(byteNumbers);

		// 		byteArrays.push(byteArray);
		// 	}

		// 	var blob = new Blob(byteArrays, { type: contentType });
		// 	return blob;
		// }
        

        rrKnowMoreVm.downloadPDF = function(){
                    var content = rrKnowMoreVm.policyFeatures.data.brochureUrl;
					var filename = "rinn_raksha_brochure.pdf";

					// var contentStr = atob(content);
					// var contentLen = contentStr.length;

					// if(contentLen >= constantConfig.accOverview.pdfSize) {   
					// 	utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
					// 	return;
					// }

					var contentType = "application/pdf";
					// if (utilityService.isAndroidPlatform()) {
					// 	rrKnowMoreVm.folderpath = cordova.file.externalRootDirectory;
					// }
					// if (utilityService.isIOSPlatform()) {
					// 	rrKnowMoreVm.folderpath = cordova.file.documentsDirectory;
					// }
					// savebase64AsPDF(rrKnowMoreVm.folderpath, filename, content, contentType);
					// if (utilityService.isIOSPlatform()) {
					// 	filename = filename + ".pdf";
					// 	var finalObject = { "folderpath": rrKnowMoreVm.folderpath, "filename": filename };
					// 	rrService.openUrl("data:application/pdf;base64," + content + "","");
						
					// }
                    if(utilityService.isAndroidPlatform()){
							rrKnowMoreVm.folderpath = cordova.file.externalRootDirectory;
						}
						if(utilityService.isIOSPlatform()){
							rrKnowMoreVm.folderpath = cordova.file.applicationDirectory;
						}
						irctcService.savebase64AsPDF(rrKnowMoreVm.folderpath,filename,content,contentType);
						if(utilityService.isIOSPlatform()){
						//var finalObject = {"folderpath":rrKnowMoreVm.folderpath,"filename":filename};
						openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
						}
					/* to show information popup for downlaod receipt, which will tell user format of passowrd for android and ios */
					if (utilityService.isAndroidPlatform()) {
						var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:rrKnowMoreVm.folderpath}"></div>';
						rrKnowMoreVm.downloadPopup = $ionicPopup.show({
							title: '',
							template: template,
							scope: $scope,
							cssClass: 'my-custom-popup',
							buttons: [{
								text: 'OK',
								type: 'button-assertive',
								onTap: function () {
									rrKnowMoreVm.downloadPopup.close();
								}
							}],
						});
					}
        }

        

         rrKnowMoreVm.nFormatter = function(num){
                if (num >= 10000000) {
                    return (num / 10000000).toFixed(1).replace(/\.0$/, '') + 'Cr';
                }
                if (num >= 100000) {
                    return (num / 100000).toFixed(1).replace(/\.0$/, '') + 'L';
                }
                if (num >= 1000) {
                    return (num / 1000).toFixed(1).replace(/\.0$/, '') + 'K';
                }
                return num;
         }


         rrKnowMoreVm.downloadBrochure = function(){
            var rrdownloadLink = document.getElementById("rrdownloadLink");
                rrdownloadLink.href = rrKnowMoreVm.policyFeatures.data.brochureUrl.replace("<baseurl>", "");
                rrdownloadLink.download = "Product Brochure - RiNn Raksha.pdf";
                rrdownloadLink.click();
        }

        rrKnowMoreVm.goToPremiumPage = function(){
            sampoornSurakshaService.getPremiumAndNomineeInfo().then(function(data) {
                sampoornSurakshaService.clearAll();
                sampoornSurakshaService.setPremiumDetails(data);
                $state.go('menu.rinnRaksha');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        rrKnowMoreVm.goBack = function(){
            if(rrKnowMoreVm.showBuyNow){
                $state.go('menu.homeScreen');
            }else{
                $state.go('menu.rinnRaksha');
            }
        }

        rrKnowMoreVm.buyClick = function(){
                rrService.addRetrive(false);
                $state.go('menu.rinnRaksha');
        }


        rrKnowMoreVm.toggleGroup = function (group) {
            if (rrKnowMoreVm.isGroupShown(group)) {
                rrKnowMoreVm.shownGroup = null;
                rrKnowMoreVm.isGroupShown(group)
            } else {
                rrKnowMoreVm.shownGroup = group;
                rrKnowMoreVm.isGroupShown(group)
            }
        };


        
         rrKnowMoreVm.isGroupShown = function (group) {
            return rrKnowMoreVm.shownGroup === group;
        };


        

        rrKnowMoreVm.selType = function(bookingCategory){

            rrKnowMoreVm.selTab =bookingCategory;
            if(bookingCategory == 'P'){
                rrKnowMoreVm.classForProductOpt = 'tab-items  div-bottom bor-bot-active';
                rrKnowMoreVm.classForFeatureOpt = 'tab-items  div-bottom';
                rrKnowMoreVm.classForTncOpt = 'tab-items  div-bottom';
            }
            if(bookingCategory == 'F'){
                rrKnowMoreVm.classForProductOpt = 'tab-items  div-bottom';
                rrKnowMoreVm.classForFeatureOpt = 'tab-items  div-bottom bor-bot-active';
                rrKnowMoreVm.classForTncOpt = 'tab-items  div-bottom';
            }
            if(bookingCategory == 'T'){
                rrKnowMoreVm.classForProductOpt = 'tab-items  div-bottom';
                rrKnowMoreVm.classForFeatureOpt = 'tab-items  div-bottom';
                rrKnowMoreVm.classForTncOpt = 'tab-items  div-bottom  bor-bot-active';
            }

        }

        $scope.$on('$ionicView.beforeEnter', function() {
             rrKnowMoreVm.shownGroup = null;
             rrKnowMoreVm.platform = device.platform.toLowerCase();
             initPage();
        });

    }
]);