angularApp.controller('rrPolicySummaryController', [
    "$state", 
    "$scope", 
    "validateService",
    "utilityService","$filter","rrService","irctcService","$ionicPopup","openUrlInAppbroswerService","$ionicHistory","getAccountDetailsService",
    function($state, 
        $scope, 
        validateService,
        utilityService,$filter,rrService,irctcService,$ionicPopup,openUrlInAppbroswerService,$ionicHistory,getAccountDetailsService) {


        var rrPolicySummaryVm = this;

        function initPage() { 
          rrPolicySummaryVm.customerInformation=getAccountDetailsService.accountOverviewData.customerInformation;        
          rrPolicySummaryVm.name = rrService.getRRPolicyDetails() ? rrService.getRRPolicyDetails().customerName : "";
          rrPolicySummaryVm.coverStartDate1 = rrService.getRRPolicyDetails() ? rrService.getRRPolicyDetails().coverStartDate : "";
          rrPolicySummaryVm.coverStartDate = rrPolicySummaryVm.coverStartDate1 ? rrPolicySummaryVm.getFormattedDate(rrPolicySummaryVm.coverStartDate1) : '';
          rrPolicySummaryVm.coverEndDate1 = rrService.getRRPolicyDetails() ? rrService.getRRPolicyDetails().coverEndDate : "";
          rrPolicySummaryVm.coverEndDate = rrPolicySummaryVm.coverEndDate1 ? rrPolicySummaryVm.getFormattedDate(rrPolicySummaryVm.coverEndDate1) : '';
          rrPolicySummaryVm.memberNo = rrService.getRRPolicyDetails() ? rrService.getRRPolicyDetails().formNo : "";
          rrPolicySummaryVm.sumAssured = rrService.getRRPolicyDetails() ? rrService.getRRPolicyDetails().sumAssured : "";
          rrPolicySummaryVm.premium = rrService.getRRPolicyDetails() ? rrService.getRRPolicyDetails().premium : "";
          rrPolicySummaryVm.status = rrService.getRRPolicyDetails() ? rrService.getRRPolicyDetails().status : "";
          rrPolicySummaryVm.loanType = rrService.getRRPolicyDetails() ? rrService.getRRPolicyDetails().loanType : "";
          rrPolicySummaryVm.loanSubCat = rrService.getRRPolicyDetails() ? rrService.getRRPolicyDetails().loanSubCat : "";
          
        }

        rrPolicySummaryVm.getFormattedDate = function (input) {
               var months=["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"];
               var day = input.split('-')[0];
               var month = input.split('-')[1];
               var year = input.split('-')[2]; 
               if(month < 10){
                month = month.substring(1);
                }
               return (day +"-"+ months[month-1] +"-"+ year);
               
          }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        rrPolicySummaryVm.goBack = function(){
            $ionicHistory.goBack(-1);
        }


    }
]);
