angularApp.service('rrService',
	function ($q, AdapterUtils, $translate, getAccountDetailsService,$ionicPopup,cardConfig,lifeInsuranceConfig) {
		var rrService = this;		
		 var params = {};	
		 var MFNumber='';
		 var isRetrive='';	
		 var rrPolicyDetails; 
		rrService.eligibleResponse = {
			coverAmtStep: "",
			coverTermStep: "",
			loanAc: "",
			maxCoverAmt: "",
			maxCoverTerm: "",
			minCoverAmt: "",
			minCoverTerm: "",
			outStantTerm: "",
			outStndAmt: ""
		};
		rrService.premiumDetails = {
			basePremAmt: "",
			quoteNo: "",
			taxAmt: "",
			totPremAmt: ""
		};
		rrService.loanAccountData = '';
		rrService.loanTypeInfo = '';
		rrService.termsObj={};

		// rrService.mfNumber = {
		// 	secKey:"",
		// 	mfno:"",
		// 	remark:""
		// }
		
		rrService.addMFNumber = function (mFnumber) {
			MFNumber = mFnumber;
		};
		rrService.getMFNumber = function () {
			return MFNumber;
		};
		rrService.addRetrive = function (retrive) {
			isRetrive = retrive;
		};
		rrService.getRetrive = function () {
			return isRetrive;
		};

		rrService.setRRPolicyDetails = function(details) {
	    rrPolicyDetails = details;
		};

		rrService.getRRPolicyDetails = function() {
			return rrPolicyDetails;
		};

		rrService.masterDropDownData = {
										"responseCode": "0000",
										"responseMessage": "success",
										"data": {
											"content": {
											"healthQues": [
												{
												"title": "Medical",
												"ques": [
													{
													"id": "Hd_ADVICE_HOSPITAL_FUTURE",
													"qstn": "Have you consulted any doctor for surgical operations or have been hospitalised for any disorder other than minor cough,cold or flu during the last 5 years?",
													"type": "1"
													},
													{
													"id": "Hd_is_illness_surgical_op",
													"qstn": "Have you ever had any  critical illness/injury, major surgical operation or received any treatment for any medical condition for a continuous period of more than 14 days (Except for minor cough, cold, flu, appendicitis & typhoid)?",
													"type": "1",
													"subQ": [
														{
														"type": "4"
														}
													]
													}
												]
												},
												{
												"title": "Treatement",
												"ques": [
													{
													"id": "Hd_diabetes_bp",
													"qstn": "Diabetes, raised blood sugar or high blood pressure",
													"type": "1"
													},
													{
													"id": "Hd_chestpain_heart_attack",
													"qstn": "Chest pain, heart attack, heart disease or any other disorder of the circulatory system",
													"type": "1"
													},
													{
													"id": "Hd_stroke_paralysis",
													"qstn": "Stroke, paralysis, disorder of the brain/nervous system",
													"type": "1"
													},
													{
													"id": "Hd_hiv_infection",
													"qstn": "HIV infection, AIDS",
													"type": "1"
													},
													{
													"id": "Hd_cancer_tumor",
													"qstn": "Cancer, tumor, growth or cyst of any kind",
													"type": "1"
													},
													{
													"id": "Hd_kidney_disorder",
													"qstn": "Any genitourinary or kidney disorder, Hepatitis B/C or any other liver disease",
													"type": "1"
													},
													{
													"id": "Hd_digestive_disorder",
													"qstn": "Any digestive disorder (ulcer, colitis etc), any disease of the gall bladder, spleen, any blood disorder, disorder of any other gland (e.g. Thyroid etc) or any musculoskeletal disorder",
													"type": "1"
													},
													{
													"id": "Hd_asthma",
													"qstn": "Asthma, Tuberculosis, Pneumonia, or any other disease of the lung.",
													"type": "1"
													},
													{
													"id": "Hd_mental_psychiatric",
													"qstn": "Mental, psychiatric or nervous disorder",
													"type": "1"
													},
													{
													"id": "Hd_other_disease",
													"qstn": "Have you suffered from any other disease not mentioned above?",
													"type": "1"
													}
												]
												},
												{
												"title": "Medication",
												"ques": [
													{
													"id": "Hd_any_medication",
													"qstn": "Are you at present taking any medication, or on any special diet or on any treatment ?",
													"type": "1"
													},
													{
													"id": "HD_PRAPOSAL_DECLI_POSTPOND",
													"qstn": "Has a proposal for Life Insurance, ever been declined, postponed, withdrawn or accepted at extra premium ?",
													"type": "1"
													}
												]
												},
												{
												"title": "Testing",
												"ques": [
													{
													"id": "Hd_advised_for_investigation",
													"qstn": "Have you had or have been advised to undergo any of the following tests or investigations ?",
													"type": "1",
													"subQ": [
														{
														"id": "HD_ULTRA_SONO",
														"qstn": "Ultra Sonography",
														"type": "2"
														},
														{
														"id": "HD_CT_SCANMRI",
														"qstn": "CT Scan / MRI",
														"type": "2"
														},
														{
														"id": "HD_BIOPSY",
														"qstn": "Biopsy",
														"type": "2"
														},
														{
														"id": "HD_ANGIOGRAPHY",
														"qstn": "Coronary Angiography",
														"type": "2"
														}
													]
													}
												]
												},
												{
												"title": "Habits",
												"ques": [
													{
													"id": "Hd_consume_cigarettes",
													"qstn": "Do you consume more than 10 cigarettes / bidis per day or chew more than 5 pouches of tobacco per day ?",
													"type": "1"
													},
													{
													"id": "Hd_consume_alcolol",
													"qstn": "Do you consume more than 2 pegs of alcohol per day in any form ?",
													"type": "1",
													"subQstn": "If \"Yes\" Please provide the type of alcohol and daily quantity consumed.",
													"subQ": [
														{
														"id": "Hd_alcohol_type",
														"qstn": "Type",
														"type": "3"
														},
														{
														"id": "Hd_alcohol_quantity",
														"qstn": "Quantity per day",
														"type": "3"
														}
													]
													},
													{
													"id": "Hd_narcotics_grugs",
													"qstn": "Do you use or have you used any narcotics / any other prohibited drugs ?",
													"type": "1"
													}
												]
												},
												{
												"title": "Female",
												"ques": [
													{
													"id": "Hd_is_pregnant",
													"qstn": "Are you pregnant ?",
													"type": "1",
													"subQ": [
														{
														"id": "PREGNANT_MONTHS",
														"qstn": "How many months pregnant Months",
														"type": "3"
														}
													]
													},
													{
													"id": "Hd_gynaecological_problem",
													"qstn": "Have you suffered from any gynaecological problems or illness related to breasts, uterus or ovary ?",
													"type": "1"
													}
												]
												}
											],
											"appMaster": {
												"designation": [
												{
													"value": "Doctor",
													"key": "Doctor"
												},
												{
													"value": "Aviation",
													"key": "Aviation"
												},
												{
													"value": "Engineer",
													"key": "Engineer"
												}
												],
												"relationships": [
												{
													"value": "Brother",
													"key": "Brother"
												},
												{
													"value": "Son",
													"key": "Son"
												},
												{
													"value": "Daughter",
													"key": "Daughter"
												},
												{
													"value": "Father",
													"key": "Father"
												},
												{
													"value": "Grand Father",
													"key": "Grand Father"
												},
												{
													"value": "Grand Mother",
													"key": "Grand Mother"
												},
												{
													"value": "Husband",
													"key": "Husband"
												},
												{
													"value": "Mother",
													"key": "Mother"
												},
												{
													"value": "Sister",
													"key": "Sister"
												},
												{
													"value": "Wife",
													"key": "Wife"
												},
												{
													"value": "Others",
													"key": "Others"
												},
												{
													"value": "Aunt",
													"key": "Aunt"
												},
												{
													"value": "Brother in law",
													"key": "Brother in law"
												},
												{
													"value": "Cousin",
													"key": "Cousin"
												},
												{
													"value": "Daughter in law",
													"key": "Daughter in law"
												},
												{
													"value": "Father in law",
													"key": "Father in law"
												},
												{
													"value": "Grand Daughter",
													"key": "Grand Daughter"
												},
												{
													"value": "Grand Son",
													"key": "Grand Son"
												},
												{
													"value": "Legal Guardian",
													"key": "Legal Guardian"
												},
												{
													"value": "Mother in law",
													"key": "Mother in law"
												},
												{
													"value": "Nephew",
													"key": "Nephew"
												},
												{
													"value": "Niece",
													"key": "Niece"
												},
												{
													"value": "Sister in law",
													"key": "Sister in law"
												},
												{
													"value": "Son in law",
													"key": "Son in law"
												},
												{
													"value": "Spouse",
													"key": "Spouse"
												},
												{
													"value": "Uncle",
													"key": "Uncle"
												},
												{
													"value": "Trustee",
													"key": "Trustee"
												},
												{
													"value": "Adopted heirs",
													"key": "Adopted heirs"
												},
												{
													"value": "Friend",
													"key": "Friend"
												},
												{
													"value": "Unrelated",
													"key": "Unrelated"
												}
												],
												"natureOfOrg": [
												{
													"value": "Private",
													"key": "Private"
												},
												{
													"value": "Government",
													"key": "Government"
												}
												],
												"occupations": [
												{
													"value": "Service",
													"key": "Service",
													"isDefencePersonnel": "false"
												},
												{
													"value": "Professional",
													"key": "Professional",
													"isDefencePersonnel": "false"
												},
												{
													"value": "Business",
													"key": "Business",
													"isDefencePersonnel": "false"
												},
												{
													"value": "Self employed",
													"key": "Self Employed",
													"isDefencePersonnel": "false"
												},
												{
													"value": "Agriculturist",
													"key": "Agriculturist",
													"isDefencePersonnel": "false"
												},
												{
													"value": "Housewife",
													"key": "Housewife",
													"isDefencePersonnel": "false"
												},
												{
													"value": "Retired",
													"key": "Retired",
													"isDefencePersonnel": "false"
												},
												{
													"value": "Student",
													"key": "Student",
													"isDefencePersonnel": "false"
												},
												{
													"value": "Army",
													"key": "Army",
													"isDefencePersonnel": "true"
												},
												{
													"value": "Navy",
													"key": "Navy",
													"isDefencePersonnel": "true"
												},
												{
													"value": "Air Force",
													"key": "Air Force",
													"isDefencePersonnel": "true"
												},
												{
													"value": "Indian Coast guard",
													"key": "Indian Coast guard",
													"isDefencePersonnel": "true"
												},
												{
													"value": "Rashtriya Rifles",
													"key": "Rashtriya Rifles",
													"isDefencePersonnel": "true"
												},
												{
													"value": "Border Roads/GREF",
													"key": "Border Roads/GREF",
													"isDefencePersonnel": "true"
												},
												{
													"value": "Assam Rifles",
													"key": "Assam Rifles",
													"isDefencePersonnel": "true"
												},
												{
													"value": "BSF",
													"key": "BSF",
													"isDefencePersonnel": "true"
												},
												{
													"value": "CISF",
													"key": "CISF",
													"isDefencePersonnel": "true"
												},
												{
													"value": "CRPF",
													"key": "CRPF",
													"isDefencePersonnel": "true"
												},
												{
													"value": "ITBP",
													"key": "ITBP",
													"isDefencePersonnel": "true"
												},
												{
													"value": "NSG",
													"key": "NSG",
													"isDefencePersonnel": "true"
												},
												{
													"value": "SSB",
													"key": "SSB",
													"isDefencePersonnel": "true"
												},
												{
													"value": "Other Arm Forces except police",
													"key": "Other Arm Forces except police",
													"isDefencePersonnel": "true"
												}
												]
											}
											}
										}
									}
									

		
		
		rrService.saveData = {
					 "application": {
					  "tncConsent": "",
					  "claimConsent": "",
					  "app": {
					   "appNo": "",
					   "pageNo": "",
					   "riConsent": "",
					   "personal": {
					    "title": "",
					    "spouse": "",
					    "address": {
					     "building": "",
					     "locality": "",
					     "landMark": "",
					     "pincode": "",
					     "city": "",
					     "state": "",
					     "country": "",
						 "minCoverAmt":"",
						 "maxCoverAmt":"",
						 "minCoverTerm":"",
						 "maxCoverTerm":"",
						 "outStandTerm":"",
						 "outStndAmt":"",
						 "coverAmtStep":"",
						 "coverTerm":"",
						 "coverAmt":""
					    }
					   },

					   "professional": {
					    "occupation":"",
					    "company": "",
					    "desig": "",
					    "companyNature": "",
						"otherOccupation":""
					   },

					   "nominee": {
					    "title": "",
					    "firstName": "",
					    "middleName": "",
					    "lastName": "",
					    "relation": "",
					    "gender": "",
					    "dob": "",
					    "sameApplAddress": "",
					    "address": {
					     "building": "",
					     "locality": "",
					     "landMark": "",
					     "pincode": "",
					     "city": "",
					     "state": ""
					    },
					    "isMinor": ""
					   },

					   "appointee": {
					    "title": "",
					    "firstName": "",
					    "lastName": "",
					    "dob": "",
					    "relation": ""
					   },

					   "medical": {
					    "heightFeet": "",
					    "heightInches": "",
					    "weight": "",
					    
					    "diseases": [{
					      "nature": "",
					      "diagDate": "",
					      "recovered": "",
					      "treatDetail": ""
					     }
					    ],
					    "questions": [{
					     
					      "id": "",
					      "ans": ""
					     }
					    ],
					   
					    "tests": [{
					      "id": "",
					      "reason": ""

					     }
					    ]
					   }
					  }
					 }
					}
					
		rrService.editData = {
					 "application": {
					  "tncConsent": "",
					  "claimConsent": "",
					  "app": {
					   "appNo": "",
					   "pageNo": "",
					   "riConsent": "",
					   "personal": {
					    "title": "",
					    "spouse": "",
					    "address": {
					     "building": "",
					     "locality": "",
					     "landMark": "",
					     "pincode": "",
					     "city": "",
					     "state": "",
					     "country": "",
						 "minCoverAmt":"",
						 "maxCoverAmt":"",
						 "minCoverTerm":"",
						 "maxCoverTerm":"",
						 "outStandTerm":"",
						 "outStndAmt":"",
						 "coverAmtStep":"",
						 "coverTerm":"",
						 "coverAmt":""
					    }
					   },

					   "professional": {
					    "occupation": "",
					    "company": "",
					    "desig": "",
					    "companyNature": "",
						"otherOccupation":""
					   },

					   "nominee": {
					    "title": "",
					    "firstName": "",
					    "middleName": "",
					    "lastName": "",
					    "relation": "",
					    "gender": "",
					    "dob": "",
					    "sameApplAddress": "",
					    "address": {
					     "building": "",
					     "locality": "",
					     "landMark": "",
					     "pincode": "",
					     "city": "",
					     "state": ""
					    },
					    "isMinor": ""
					   },

					   "appointee": {
					    "title": "",
					    "firstName": "",
					    "lastName": "",
					    "dob": "",
					    "relation": ""
					   },

					   "medical": {
					    "heightFeet": "",
					    "heightInches": "",
					    "weight": "",
					    
					    "diseases": [{
					      "nature": "",
					      "diagDate": "",
					      "recovered": "",
					      "treatDetail": ""
					     }
					    ],
					    "questions": [{
					     
					      "id": "",
					      "ans": ""
					     }
					    ],
					   
					    "tests": [{
					      "id": "",
					      "reason": ""

					     }
					    ]
					   }
					  }
					 }
					}			
		
		rrService.getRREligibility = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/LifeInsuranceAdapterv2/rr/v1/getRREligibility", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		rrService.getRRLoanAcList = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/LifeInsuranceAdapterv2/rr/v1/getLoanAcList", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		rrService.getMedicalQuestions = function () {
			var q = $q.defer();
			AdapterUtils.getData("adapters/LifeInsuranceAdapterv2/rr/v1/appMaster",  true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		rrService.calculatePremium = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/LifeInsuranceAdapterv2/rr/v1/calculatePremium", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		rrService.getApplicationsData = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/LifeInsuranceAdapterv2/rr/v1/getApplicationData", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		//to get the purchase  list
		rrService.getApplications = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/LifeInsuranceAdapterv2/rr/v1/getApplications",  true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		rrService.displayPopUp = function (heading, css, message, buttonText, callBack) {
			 $ionicPopup.alert({
				title: heading,
				template: '<div class="popupTextBottomPadding  ss-popup-list fontSize-subHeading roboto-medium text-center ' + css + '">'
				+ message + '</div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
				buttons: [
					{
						text: buttonText,
						onTap: function (e) {
							callBack();
						}
					}
				],
			});
		};

		rrService.getCompany = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/CardsAdapterv2/getCompanies", payload, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };

		rrService.getDesignation = function(payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/CardsAdapterv2/getDesignation", payload, true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };

		// rrService.setParams = function(obj) {
        //     setParams = angular.extend(params, obj);
        // }

        /*
            Function Name: getParams,
            Input: none,
            Output: none,
            Description: Get state params
        */
        rrService.getParams = function() {
                return params;
            }
            /*
                Function Name: resetParams,
                Input: none,
                Output: none,
                Description: reset state params
            */
        rrService.resetParams = function() {
            params = {};
        }
		 

		rrService.errorLogger = function(response, callback) {
            if (response.responseCode != cardConfig.responseCode.success) {
                var popupObject = {
                    cssClass: 'sbi-alert-popup',
                    buttons: [{
                        text: cardConfig.buttons.OK_LABEL,
                        type: 'button-positive',

                    }]
                };
                popupObject.template = '<div class="text-align-center font-content sbi-sub-label roboto-regular">' + response.responseMessage + '</div>';
                alertModal(popupObject, callback);
            }

        }

		rrService.saveApplication = function() {        
            if(rrService.saveData.xLotusToken){
            	delete rrService.saveData.xLotusToken;
            }
            var payload = rrService.saveData;
            var q = $q.defer();           

            AdapterUtils.postData('adapters/LifeInsuranceAdapterv2/rr/v1/saveApplication', payload, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        rrService.payForNew = function(reqParams) {         
            var q = $q.defer();
			AdapterUtils.postData("adapters/LifeInsuranceAdapterv2/rr/v1/payForNew", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
        };
        rrService.resendOTP = function(reqParams) {         
            var q = $q.defer();
			AdapterUtils.postData("adapters/LifeInsuranceAdapterv2/rr/v1/resendOTPForPayNew", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
        };
        rrService.validateOTPForPayNew = function(reqParams) {         
            var q = $q.defer();
			AdapterUtils.postData("adapters/LifeInsuranceAdapterv2/rr/v1/validateOTPForPayNew", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
        };
        //Delete application
        rrService.deleteRinApplication = function(reqParams) {         
            var q = $q.defer();
			AdapterUtils.postData("adapters/LifeInsuranceAdapterv2/rr/v1/deleteApplication", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
        };

		rrService.getStateList = function() {
            var q = $q.defer();
            AdapterUtils.getData(lifeInsuranceConfig.adapterURL.getStateList[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }

            );
            return q.promise;
        };

        rrService.getCityList = function(state) {
            var q = $q.defer();
            AdapterUtils.postData(lifeInsuranceConfig.adapterURL.getCityList[0], state, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };


		rrService.getTncContent = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/LifeInsuranceAdapterv2/rr/v1/tncContent",true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		rrService.getdeclContent  = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/LifeInsuranceAdapterv2/rr/v1/declContent ",true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		

		rrService.getproductContent = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/LifeInsuranceAdapterv2/rr/v1/productContent",true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		rrService.getPostalDetailByPincode = function(reqParams) {
            var q = $q.defer();
			
            AdapterUtils.postData("adapters/CommonAdapter/getPostalDetailByPincode", reqParams, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }

            );
            return q.promise;
        };

		rrService.getSBIBankAccounts = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FSSCommonAdapter/getOwnAccounts", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
	
		rrService.openUrl=function(url,reqParams){
				if(reqParams!=''){
						url=url+"?"+reqParams;
				}
				cordova.ThemeableBrowser.open(url, '_blank', {

				statusbar:{
						color: '#ffffffff'
				},
				toolbar: {
					height: 44,
					color: '#ffffffff',
					image: 'share'
				},
				
				closeButton: {
					 wwwImage: 'img/inappback.png',
					align: 'left',
					event: 'closePressed'
				},
				backButtonCanClose: true
				}).addEventListener('backPressed', function(e) {
				
				}).addEventListener('helloPressed', function(e) {
				
				}).addEventListener('sharePressed', function(e) {
					
				}).addEventListener(cordova.ThemeableBrowser.EVT_ERR, function(e) {
					
				}).addEventListener(cordova.ThemeableBrowser.EVT_WRN, function(e) {
					
				});
			
			};

		

		rrService.fetchNomineeDetails = function(payLoad) {
			var q = $q.defer();
			AdapterUtils.postData('adapters/LifeInsuranceAdapterv2/rr/v1/getNomineeIfno', payLoad, true).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		rrService.getRrPolicyDetails = function(payLoad) {
			console.log("Hit");
			var q = $q.defer();
			AdapterUtils.postData('adapters/LifeInsuranceAdapterv2/rr/v1/getProposalDetail', payLoad, false).then(
				function(response) {
					q.resolve(response.data);
				},
				function(error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		return rrService;
	});  
