angularApp.service('mySecurityProfileService',
  	function($q,AdapterUtils){
		var mySecurityProfileService=this;
		var accountList = [];
		var dpIdVal='';
		
		//getSecuity Profile Details  service
		mySecurityProfileService.getSecuityProfileDetails = function() {
			var q = $q.defer();	
			var reqParams={};
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/linkPortfolioDetails", reqParams, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		//Track application service
		mySecurityProfileService.trackApplication = function(requestData) {
            var q = $q.defer();
           	
		
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/trackApplication", requestData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
           
        };
		
		//assetsDetails
		mySecurityProfileService.assetsDetails = function(requestData) {
            var q = $q.defer();
           	
		
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/getAssetDetails", requestData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
           
        };
		
		//Get Trade URl 
		mySecurityProfileService.tradeNowUrl = function() {
            var q = $q.defer();
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/tradeNowUrl",{}, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
           
        };
		
		//Get get Securities OverView
		mySecurityProfileService.getSecProfile = function() {
            var q = $q.defer();
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/getSecuritiesOverView",{}, false).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
           
        };
		// Add Details
		mySecurityProfileService.addDetails = function(newObj) {
			accountList = [];
			accountList.push(newObj);
		};
		// Get Details
		mySecurityProfileService.getDetails = function(){
			return accountList;
		};
		
		// Add  DP  Details
		mySecurityProfileService.addDPId= function(dpId) {
			dpIdVal=dpId;
		};
		
		// get  DP  Details
		mySecurityProfileService.getDPId = function(){
			return dpIdVal;
		};
		
        return mySecurityProfileService;
        

    });
