'use strict';

angularApp.controller('manageEstmtController', ["$state",
    "$ionicPopup",
    "$scope",
    "utilityService",
    "manageEstatementService",
    "$ionicHistory",
    "ionicDatePicker",
    "customerInfoService",
    "$ionicPopover",
    "getAccountDetailsService",
    function($state,
        $ionicPopup,
        $scope,
        utilityService,
        manageEstatementService,
        $ionicHistory,
        ionicDatePicker,
        customerInfoService,
        $ionicPopover,
        getAccountDetailsService) {

        var manageEstmtVm = this;

        function initPage(){

                      

        }
        var template = '<ion-popover-view class="loginnewarrow edu-fraudemergencypopovernew" id="runtimeHeight" style="max-height:160px">' 
        + '<div class="estmt-arrow-upnew"></div>' + '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="manageEstmtVm.closePopover()">' 
        + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col">' +
      '<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12"><ol style="padding:5px;list-style-type: decimal;"><li>Statement would only be sent to the registered e-mail Id of the user.</li>' + 
      '<li>Inoperative/Dormant accounts would not be eligible for registration of e-Statement request.</li>' + 
      '<li>A User can  select the frequency, cycle and day indicator of the Statement.</li>' + 
      '<li>Cycle will the month from which e-Statement would be sent.</li>' + 
      '<li>Day Indicator is the day of the month on which statement will be sent. For example, if the user have selected frequency Q: Quarterly with cycle and Day indicator selected as 6 and 10, the first e-statement will be sent of 10 th  day of June. The next statement will be sent on 10th of September and likewise.</li>' + 
      '<li>Statement will not be generated if there is no transaction performed during the selected cycle.</li>' + 
      '<ol></div>' 
      + '</ion-content>' + '</ion-popover-view>';

      $scope.popover = $ionicPopover.fromTemplate(template, {
        scope: $scope
      });

      manageEstmtVm.infoDetails = function($event){
        $scope.popover.show($event);
      }

      manageEstmtVm.closePopover = function(){
        $scope.popover.hide();
      }
        manageEstmtVm.goToHome = function() {
            $ionicHistory.goBack(-1);
        }


        manageEstmtVm.goToReviewRegistration = function(){
          if(manageEstmtVm.selTab == 'Y'){
            if(!manageEstmtVm.accountNumber || manageEstmtVm.accountNumber == '')
            {
              manageEstmtVm.regAccountListError = "Please select an account."
              
            }
            else if(!manageEstmtVm.userSelectedFreq || manageEstmtVm.userSelectedFreq == ""){
              manageEstmtVm.freqError = "Please select receive statement.";
            }
            else if((manageEstmtVm.userSelectedFreq == 'Q' || manageEstmtVm.userSelectedFreq == 'Y' || manageEstmtVm.userSelectedFreq == 'H') && (!manageEstmtVm.userSelectedMonth || manageEstmtVm.userSelectedMonth == "")){
              manageEstmtVm.monthError = "Please select month.";
            }
            else if((manageEstmtVm.userSelectedFreq == 'W' || manageEstmtVm.userSelectedFreq == 'F' || manageEstmtVm.userSelectedFreq == 'M' || manageEstmtVm.userSelectedFreq == 'Q' || manageEstmtVm.userSelectedFreq == 'Y' || manageEstmtVm.userSelectedFreq == 'H') && (!manageEstmtVm.userSelectedDay || manageEstmtVm.userSelectedDay == "")){
              manageEstmtVm.dayError = "Please select day.";
            }
            else if(manageEstmtVm.regAccountListError != ""){

            } 
            else{
              
              manageEstatementService.registerData.accountNumber = manageEstmtVm.accountNumber;
              manageEstatementService.registerData.frequency = manageEstmtVm.userSelectedFreq;
              manageEstatementService.registerData.month = manageEstmtVm.userSelectedMonth;
              manageEstatementService.registerData.day = manageEstmtVm.userSelectedDay;
              $state.go('menu.reviewDetails');
            }
          }
          else{
            //call for otp
            if(manageEstmtVm.deregAccountListError == '' && (manageEstmtVm.deregAccountNumber && manageEstmtVm.deregAccountNumber != ''))
            {
              manageEstatementService.DeRegisterData.accountNumber = manageEstmtVm.deregAccountNumber;
              
            manageEstatementService.getOtp().then(function (data) {
                manageEstatementService.checkRegOrDereg = 'deregister';
                    $state.go('menu.manageEstmtOTP');
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            else{
                manageEstmtVm.deregAccountListError = "Please select an account."
            }
            
          }
          
        }


        /* Double Tab */
          manageEstmtVm.selType = function(bookingCategory){
    			manageEstatementService.myTab = bookingCategory;
    			manageEstmtVm.selTab = manageEstatementService.myTab;
    			if(bookingCategory == 'Y'){
    				manageEstmtVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom e-stmt-bor-bot-active roboto-medium';
    				manageEstmtVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom';
    			}else{
    				manageEstmtVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom';
    				manageEstmtVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom e-stmt-bor-bot-active roboto-medium';
    			}

    		}
        /* End of Double Tab */


        

    manageEstmtVm.showPop = function(type){
      if(type=='reg'){
        if(manageEstmtVm.accListReg.length > 0)
        {
          manageEstmtVm.popUpTemplate = manageEstatementService.accountListPopupTemplate("manageEstmtVm.accListReg","manageEstmtVm");
                manageEstmtVm.popUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                    template: manageEstmtVm.popUpTemplate,
                    scope: $scope
                });
          
        }
      }
       else{
        if(manageEstmtVm.accListDereg.length > 0)
        {
          manageEstmtVm.popUpTemplate = manageEstatementService.accountListPopupTemplate("manageEstmtVm.accListDereg","manageEstmtVm");
                manageEstmtVm.popUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                    template: manageEstmtVm.popUpTemplate,
                    scope: $scope
                });
          
        }
       } 
    }


    manageEstmtVm.close = function(index,type){
      if(type=='Y')
      {
        manageEstmtVm.regAccountListError = "";
        manageEstmtVm.popUp.close();
        manageEstmtVm.branchName = manageEstmtVm.accListReg[index].branchName;
        manageEstmtVm.branchCode = manageEstmtVm.accListReg[index].branchCode;
        manageEstmtVm.accountType = manageEstmtVm.accListReg[index].accountType;
        manageEstmtVm.accountNumber = manageEstmtVm.accListReg[index].accountNumber;
        manageEstmtVm.selectedAccount = manageEstmtVm.accListReg[index];
        manageEstmtVm.showSelect = false;
        //call account to cif to check primary or secondary
         manageEstmtVm.getAccountToCif();
      }
      else{
        manageEstmtVm.deregAccountListError = "";
        manageEstmtVm.popUp.close();
        manageEstmtVm.deregBranchName = manageEstmtVm.accListDereg[index].branchName;
        manageEstmtVm.deregBranchCode = manageEstmtVm.accListDereg[index].branchCode;
        manageEstmtVm.deregAccountType = manageEstmtVm.accListDereg[index].accountType;
        manageEstmtVm.deregAccountNumber = manageEstmtVm.accListDereg[index].accountNumber;
        manageEstmtVm.deregSelectedAccount = manageEstmtVm.accListDereg[index];
        manageEstmtVm.deregShowSelect = false;
        manageEstatementService.DeRegisterData.accountNumber = angular.copy(manageEstmtVm.deregAccountNumber);
        manageEstmtVm.deregAccountNumberMasked = manageEstatementService.DeRegisterData.accountNumber;
        //call get details service for deregistered
        manageEstmtVm.getRegistrationDetails();
        manageEstmtVm.getAccountToCifDeReg();
      }
        
      }


      manageEstmtVm.selectDefaultAccount = function(index,type){
      if(type=='Y')
      {
        manageEstmtVm.regAccountListError = "";
        
        manageEstmtVm.branchName = manageEstmtVm.accListReg[index].branchName;
        manageEstmtVm.branchCode = manageEstmtVm.accListReg[index].branchCode;
        manageEstmtVm.accountType = manageEstmtVm.accListReg[index].accountType;
        manageEstmtVm.accountNumber = manageEstmtVm.accListReg[index].accountNumber;
        manageEstmtVm.selectedAccount = manageEstmtVm.accListReg[index];
        manageEstmtVm.showSelect = false;
        //call account to cif to check primary or secondary
         manageEstmtVm.getAccountToCif();
      }
      else{
        manageEstmtVm.deregAccountListError = "";
        
        manageEstmtVm.deregBranchName = manageEstmtVm.accListDereg[index].branchName;
        manageEstmtVm.deregBranchCode = manageEstmtVm.accListDereg[index].branchCode;
        manageEstmtVm.deregAccountType = manageEstmtVm.accListDereg[index].accountType;
        manageEstmtVm.deregAccountNumber = manageEstmtVm.accListDereg[index].accountNumber;
        manageEstmtVm.deregSelectedAccount = manageEstmtVm.accListDereg[index];
        manageEstmtVm.deregShowSelect = false;
        manageEstatementService.DeRegisterData.accountNumber = angular.copy(manageEstmtVm.deregAccountNumber);
        manageEstmtVm.deregAccountNumberMasked = manageEstatementService.DeRegisterData.accountNumber;
        //call get details service for deregistered
        manageEstmtVm.getRegistrationDetails();
        manageEstmtVm.getAccountToCifDeReg();
      }
        
      }
      manageEstmtVm.getAccountToCif = function(){
        var obj = {
                    "accountNumber": manageEstmtVm.accountNumber,
                    
                  }
        manageEstatementService.getAccountToCif(obj).then(function(data) {
            
              console.log('account to cif', data);
              if(data.primaryFlag != 'Y')
              {
                manageEstmtVm.regAccountListError = "You are not eligible for e-statement facility";
              }
              
            
            
            },function(error){
              utilityService.showErrorMessage(error.responseMessage);
            });
      }
      manageEstmtVm.getAccountToCifDeReg = function(){
        var obj = {
                    "accountNumber": manageEstmtVm.deregAccountNumber,
                    
                  }
        manageEstatementService.getAccountToCif(obj).then(function(data) {
            
              console.log('account to cif', data);
              if(data.primaryFlag != 'Y')
              {
                manageEstmtVm.deregAccountListError = "You are not eligible for e-statement facility";
              }
              
            
            
            },function(error){
              utilityService.showErrorMessage(error.responseMessage);
            });
      }

      //get review details
      manageEstmtVm.getRegistrationDetails = function(){
        var isAccountExists = -1;
        manageEstmtVm.frequencyTextDereg = '';    
              manageEstmtVm.accListDereg.some(function(obj, i) {
                  return obj.accountNumber == manageEstmtVm.deregAccountNumber ? isAccountExists = i : false;
              });
              if(isAccountExists !== -1){
                var freq = manageEstmtVm.accListDereg[isAccountExists].frequency;
                if(freq == 'D')
                 {
                    manageEstmtVm.frequencyTextDereg = 'Daily';
                 }
                 else if(freq == 'W')
                 {
                    manageEstmtVm.frequencyTextDereg = 'Weekly';
                 }
                 else if(freq == 'F')
                 {
                    manageEstmtVm.frequencyTextDereg = 'Fortnightly';
                 }
                 else if(freq == 'M')
                 {
                    manageEstmtVm.frequencyTextDereg = 'Monthly';
                 }
                 else if(freq == 'Q')
                 {
                    manageEstmtVm.frequencyTextDereg = 'Quarterly';
                 }
                 else if(freq == 'Y')
                 {
                    manageEstmtVm.frequencyTextDereg = 'Yearly';
                 }
                 else if(freq == 'H')
                 {
                    manageEstmtVm.frequencyTextDereg = 'Half Yearly';
                 }
                 else{
                    manageEstmtVm.frequencyTextDereg = freq;
                 }
              }
            
       
      }

      manageEstmtVm.setDefaultValues = function(){
        manageEstmtVm.setDropdownValues();
        manageEstmtVm.userSelectedMonth = "";
        manageEstmtVm.userSelectedDay = "";
        manageEstmtVm.freqError = "";
        manageEstmtVm.monthError = "";
        manageEstmtVm.dayError = "";
        if(manageEstmtVm.userSelectedFreq == 'D'){
          manageEstmtVm.selectMonth = [{"key":"00","value":"00"}];
          manageEstmtVm.selectDay = [{"key":"00","value":"00"}];
          manageEstmtVm.userSelectedMonth = "00";
          manageEstmtVm.userSelectedDay = "00";
        }
        else if(manageEstmtVm.userSelectedFreq == 'W' || manageEstmtVm.userSelectedFreq == 'F'){
          manageEstmtVm.selectMonth = [{"key":"00","value":"00"}];
          manageEstmtVm.selectDay = [{"key":"1","value":"01"},{"key":"2","value":"02"},{"key":"3","value":"03"},{"key":"4","value":"04"},
                                   {"key":"5","value":"05"},{"key":"6","value":"06"},{"key":"7","value":"07"}];
          manageEstmtVm.userSelectedMonth = "00";
          //manageEstmtVm.userSelectedDay = "01";
        }
        else if(manageEstmtVm.userSelectedFreq == 'M'){
          manageEstmtVm.selectMonth = [{"key":"00","value":"00"}];
          manageEstmtVm.selectDay = [{"key":"1","value":"01"},{"key":"2","value":"02"},{"key":"3","value":"03"},{"key":"4","value":"04"},
                                   {"key":"5","value":"05"},{"key":"6","value":"06"},{"key":"7","value":"07"},{"key":"8","value":"08"},
                                   {"key":"9","value":"09"},{"key":"10","value":"10"},{"key":"11","value":"11"},{"key":"12","value":"12"},
                                   {"key":"13","value":"13"},{"key":"14","value":"14"},{"key":"15","value":"15"},{"key":"16","value":"16"},
                                   {"key":"17","value":"17"},{"key":"18","value":"18"},{"key":"19","value":"19"},{"key":"20","value":"20"},
                                   {"key":"21","value":"21"},{"key":"22","value":"22"},{"key":"23","value":"23"},{"key":"24","value":"24"},
                                   {"key":"25","value":"25"},{"key":"26","value":"26"},{"key":"27","value":"27"},{"key":"28","value":"28"}];
          manageEstmtVm.userSelectedMonth = "00";
          //manageEstmtVm.userSelectedDay = "01";
        }
        else{
          //manageEstmtVm.userSelectedMonth = "01";
          //manageEstmtVm.userSelectedDay = "01";
        }
      }

      manageEstmtVm.setDropdownValues = function(){
        
        manageEstmtVm.selectFreq = [{"key":"D","value":"Daily"},{"key":"W","value":"Weekly"},
                      {"key":"F","value":"Fortnightly"},{"key":"M","value":"Monthly"},
                      {"key":"Q","value":"Quarterly"},{"key":"Y","value":"Yearly"},
                      {"key":"H","value":"Half Yearly"}];

        

       manageEstmtVm.selectMonth = [{"key":"1","value":"01"},{"key":"2","value":"02"},{"key":"3","value":"03"},{"key":"4","value":"04"},
                                    {"key":"5","value":"05"},{"key":"6","value":"06"},{"key":"7","value":"07"},{"key":"8","value":"08"},
                                    {"key":"9","value":"09"},{"key":"10","value":"10"},{"key":"11","value":"11"},{"key":"12","value":"12"}];

      
        manageEstmtVm.selectDay = [{"key":"1","value":"01"},{"key":"2","value":"02"},{"key":"3","value":"03"},{"key":"4","value":"04"},
                                   {"key":"5","value":"05"},{"key":"6","value":"06"},{"key":"7","value":"07"},{"key":"8","value":"08"},
                                   {"key":"9","value":"09"},{"key":"10","value":"10"},{"key":"11","value":"11"},{"key":"12","value":"12"},
                                   {"key":"13","value":"13"},{"key":"14","value":"14"},{"key":"15","value":"15"},{"key":"16","value":"16"},
                                   {"key":"17","value":"17"},{"key":"18","value":"18"},{"key":"19","value":"19"},{"key":"20","value":"20"},
                                   {"key":"21","value":"21"},{"key":"22","value":"22"},{"key":"23","value":"23"},{"key":"24","value":"24"},
                                   {"key":"25","value":"25"},{"key":"26","value":"26"},{"key":"27","value":"27"},{"key":"28","value":"28"}];
      }

      manageEstmtVm.eyesOffFun = function (mask){
        if(mask =="account"){
                    manageEstmtVm.deregAccountNumberMasked = manageEstatementService.DeRegisterData.accountNumber;
                    manageEstmtVm.AccountCloseEye = true;
                    manageEstmtVm.AccountOpenEye = false;
            }else if(mask =="email"){
                        manageEstmtVm.email = manageEstatementService.custEmail;
                        manageEstmtVm.emailCloseEye = true;
                        manageEstmtVm.emailOpenEye = false;
            }
            
      }

        manageEstmtVm.eyesOnFun = function (mask){
               if(mask =="account"){
                var obj = {
                              "keyType": "eStmtKeyTypeAccount",
                              "debitAccount": manageEstmtVm.deregAccountNumber,
                            }
                    manageEstatementService.getUnmaskData(obj).then(function (data) {
                        console.log('email unmask data', data);
                        manageEstmtVm.deregAccountNumberMasked = data;
                        manageEstmtVm.AccountCloseEye = false;
                        manageEstmtVm.AccountOpenEye = true;
                            
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                    });
                    
            }else if(mask =="email"){
                        var obj = {
                              "keyType": "eStmtKeyTypeEmail",
                              "emailId": manageEstmtVm.email
                            }
                    manageEstatementService.getUnmaskData(obj).then(function (data) {
                        console.log('email unmask data', data);
                        manageEstmtVm.email = data;
                        manageEstmtVm.emailCloseEye = false;
                        manageEstmtVm.emailOpenEye = true;
                            
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                    });
            } 
                            
               
        }

      $scope.$on('$ionicView.beforeEnter', function () {
        
        manageEstmtVm.showSelect = true;
        manageEstmtVm.deregShowSelect = true;
        manageEstmtVm.regAccountListError = "";
        manageEstmtVm.deregAccountListError = "";
        manageEstmtVm.emailCloseEye = true;
        manageEstmtVm.AccountCloseEye = true;
        manageEstmtVm.freqError = "";
        manageEstmtVm.monthError = "";
        manageEstmtVm.dayError = "";
        manageEstmtVm.name  = customerInfoService.customer.name;
  			manageEstmtVm.classForMpinLoginOpt = 'tab-item tabs-style div-bottom bor-bot-active';
  			manageEstmtVm.classForUserLoginOpt = 'tab-item tabs-style div-bottom';
  			
  			manageEstmtVm.selType(manageEstatementService.myTab);

        manageEstmtVm.selectFreq = [{"key":"D","value":"Daily"},{"key":"W","value":"Weekly"},
                      {"key":"F","value":"Fortnightly"},{"key":"M","value":"Monthly"},
                      {"key":"Q","value":"Quarterly"},{"key":"Y","value":"Yearly"},
                      {"key":"H","value":"Half Yearly"}];
        manageEstmtVm.selectMonth = [{"key":"00","value":"00"}];
          manageEstmtVm.selectDay = [{"key":"00","value":"00"}];
        //manageEstmtVm.userSelectedFreq = "D";
        //manageEstmtVm.userSelectedMonth = "00";
        //manageEstmtVm.userSelectedDay = "00";

     manageEstmtVm.accListReg = [];
     manageEstmtVm.accListDereg = [];
     manageEstmtVm.isAccountLoaded = false;
     manageEstatementService.getRegAccountList().then(function(data) {

          manageEstatementService.custEmail = data.custEmailId; 
          manageEstmtVm.email = manageEstatementService.custEmail;
            if(data.accountDetails.length < 1)
            {
              manageEstmtVm.regAccountListError = "No account available.";
              manageEstmtVm.deregAccountListError = "No account available.";
            }
            for(var i=0; i<data.accountDetails.length; i++){
              if(data.accountDetails[i].flag == 'false'){
                manageEstmtVm.accListReg.push(data.accountDetails[i]);
              }
              else{
                manageEstmtVm.accListDereg.push(data.accountDetails[i]);
              }
            }
            
            if(manageEstmtVm.accListDereg.length < 1){
              manageEstmtVm.deregAccountListError = "No account available."
            }
            if(manageEstmtVm.accListReg.length < 1){
              manageEstmtVm.regAccountListError = "No account available.";
            }
            if(manageEstmtVm.accListDereg.length == 1){
              manageEstmtVm.selectDefaultAccount(0,'C');
            }
            if(manageEstmtVm.accListReg.length == 1){
              manageEstmtVm.selectDefaultAccount(0,'Y');
            }
            manageEstmtVm.isAccountLoaded = true;

            },function(error){
              manageEstmtVm.isAccountLoaded = true;
              manageEstmtVm.regAccountListError = "No account available.";
              manageEstmtVm.deregAccountListError = "No account available."
              utilityService.showErrorMessage(error.responseMessage);
            });
        });
      return this;
    }
]);
