angularApp.service('serviceRequestService',
	function ($q, utilityService, AdapterUtils) {

		var getRequestDetailData = "";
		var storeRefNumber = "";
		var module_LBL = "";
		var storeRefNumber_LBL = "";
		var name_LBL = "";
		var amount_LBL = "";
		var amount_Value = "";
		var roi_LBL = "";
		var roi_Value = "";
		var innerURL = "";
		var serviceNameInnerURL = "";
		var kycValidationFlag = "";
		var isNightMode = "";
		var innerpageHeader = "";
		var innerLinks = "";
		var backFlag="";

		var getMenuOptions = function () {

			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getMenuOptions", {}, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

 			};

		var getNewMenuOptions = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getNewMenuOptions", {}, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;
		};


		var getMenuOptionTypes = function (innerURL) {

			var q = $q.defer();
			var request = { "optionURL": innerURL }
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getMenuOptionTypes", request, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		};

		

		var kycValidation = function () {

			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/kycValidation", {}, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		};

		var kycAndNightModeValidation = function () {

			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/kycAndNightModeValidation", {}, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		};

		var getServiceRequest = function () {

			var q = $q.defer();
			AdapterUtils.postData("adapters/CommonAdapter/getServiceRequest", {}, false).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		};

		var getRequestDetail = function (storeRefNumber) {

			var q = $q.defer();
			var req = { "storeRefNumber": storeRefNumber };
			AdapterUtils.postData("adapters/CommonAdapter/getRequestDetail", req, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		};

		var checkWhiteListUser = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/checkWhiteListUser", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

		var getFinYears = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getFinYears", {}, true).then(
                function (response) {
                    q.resolve(response.data);                    
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        var getTDSDetails = function (request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getTDSDetails", request, true).then(
                function (response) {
                    q.resolve(response.data);                    
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
				var getDebitCardOptions = function () {
					var level2=

					  	[{
															 "serviceName":"Block Card",
															 "serviceIcon":"img/serviceRequest/ATM_Debit_card/Block_Card.svg",
															 "module":"menu.blockUnblock"
							},{
															 "serviceName":"Manage Card",
															 "serviceIcon":"img/serviceRequest/ATM_Debit_card/Manage_card.svg",
															 "module":"menu.manageAtm"
							},{
															 "serviceName":"Request New / Replacement",
															 "serviceIcon":"img/serviceRequest/ATM_Debit_card/Req_Replacement.svg",
															 "module":"menu.newDebitCard"
							},{
															 "serviceName":"Activate Card",
															 "serviceIcon":"img/serviceRequest/ATM_Debit_card/Activate_card.svg",
															 "module":"menu.atmCardActivation"
							}];
						return level2;
				};
				var getTaxInvOptions = function () {
					var level2=

						   	[{
																	"serviceName":"PPF Loan & Withdrawal Eligibility",
																	"serviceIcon":"img/serviceRequest/Tax_Investments/PPF_Loan.svg",
																	"module":"menu.ppfEligibility"
								 },{
																	"serviceName":"Print PPF e\u2011receipt",
																	"serviceIcon":"img/serviceRequest/Tax_Investments/Print_PPF.svg",
																	"module":"menu.ppfEReceipt"
								 },
								/* {
																	"serviceName":"Reprint Challan Tax",
																	"serviceIcon":"img/serviceRequest/Tax_Investments/reprint_challan.svg",
																	"module":"menu.reprintChallan"
								 },*/
								 {
																	"serviceName":"TDS Enquiry",
																	"serviceIcon":"img/serviceRequest/Tax_Investments/TSD_Certification.svg",
																	"module":"menu.tdsEnquiry"
								 },{
																	"serviceName":"Form 15 G/H Enquiry",
																	"serviceIcon":"img/serviceRequest/Tax_Investments/Form15G.svg",
																	"module":"menu.formEnquiryLanding"
								 }
								 ,{
																	"serviceName":"Form 15 G/H Submission",
																	"serviceIcon":"img/serviceRequest/Tax_Investments/Form15G.svg",
																	"module":"menu.form15SubmissionLanding"
								 },{
								 }];
						return level2;
				};

				var getPensionOptions = function (){
					var level2=
								[{
										"serviceName":"Pension Slip",
										"serviceIcon":"img/serviceRequest/Pension/Pension_Slip.svg",
										"module":"menu.pensionSlip"



								},{		"serviceName":"Payment Information",
										"serviceIcon":"img/serviceRequest/Pension/Payment_Information.svg",
										"module":"menu.paymentInformation"
								},{									
										"serviceName":"Form 16 \n(PartB)",
										"serviceIcon":"img/serviceRequest/Pension/Form16B.svg",
										"module":"menu.pensionForm16B"
								}];


				return level2;
				};
				var getChequeOptions = function () {
				var level2=
								[{
												 "serviceName":"Request Cheque Book",
												 "serviceIcon":"img/serviceRequest/Cheques/Request_Cheque_Book.svg",
												 "module":"menu.requestChequeBook"

								},{
												 "serviceName":"Enquiry",
												 "serviceIcon":"img/serviceRequest/Cheques/Cheque_Status.svg",
												 "module":"menu.chequeEnquiry"
								},{
												 "serviceName":"Stop Cheque",
												 "serviceIcon":"img/serviceRequest/Cheques/Stop_Cheque.svg",
												 "module":"menu.stopCheque"
								},{
												 "serviceName":"Revoke Stop",
												 "serviceIcon":"img/serviceRequest/Cheques/RevokeChequeStop.svg",
												 "module":"menu.revokeCheque"
								},{
												 "serviceName":"Cheque Deposits",
												 "serviceIcon":"img/serviceRequest/Cheques/Cheque_Deposits_white.svg",
												 "module":"menu.chequeDeposits"
								},{
												 "serviceName": "Positive Pay System",
												 "serviceIcon": "img/serviceRequest/Cheques/PPS_Icon.svg",
												 "module": "menu.positivePayment"
								}];

return level2;
};

var getAccountOptions = function () {
var level2 =
						 	[{
														"serviceName":"Activate SMS Alerts",
														"serviceIcon":"img/serviceRequest/Account/Activate_SMS_Alerts.svg",
														"module":"menu.smsAlertActivation"
							},{
														"serviceName":"Change Account Type",
														"serviceIcon":"img/serviceRequest/Account/Change_Account.svg",
														"module":"menu.selAccToEnableChangeAcc"
							},{
														"serviceName":"Scheduled Request",
														"serviceIcon":"img/serviceRequest/Account/Scheduled_request.svg",
														"module":"menu.scheduledRequests"
							},{
														"serviceName":"Manage Nominee",
														"serviceIcon":"img/serviceRequest/Account/Manage_Nominee.svg",
														"module":"menu.ppfAccSelType"
							},
{
														"serviceName":"Manage e-Statements",
														"serviceIcon":"img/serviceRequest/Account/manage_e-stat.svg",
														"module":"menu.manageEstmt"
							},
							{
														"serviceName":"Change Home Branch",
														"serviceIcon":"img/serviceRequest/Account/home_branch.svg",
														"module":"menu.ppfAccSelType"
							},
							{
														"serviceName": "Disable / Enable Account (UPI)",
														"serviceIcon": "img/FT/BhimUpi/enable_disable.svg",
														"module": "menu.enableDisableUpi"
							}];
return level2;
};



		return {
			getMenuOptions: getMenuOptions,
			getNewMenuOptions: getNewMenuOptions,
			getMenuOptionTypes: getMenuOptionTypes,
			getServiceRequest: getServiceRequest,
			getRequestDetail: getRequestDetail,
			checkWhiteListUser : checkWhiteListUser,
			getRequestDetailData: getRequestDetailData,
			storeRefNumber: storeRefNumber,
			kycValidation: kycValidation,
			innerpageHeader:innerpageHeader,
			kycAndNightModeValidation:kycAndNightModeValidation,
			kycValidationFlag:kycValidationFlag,
			isNightMode:isNightMode,
			module_LBL: module_LBL,
			serviceNameInnerURL: serviceNameInnerURL,
			storeRefNumber_LBL: storeRefNumber_LBL,
			name_LBL: name_LBL,
			amount_LBL: amount_LBL,
			amount_Value: amount_Value,
			roi_LBL: roi_LBL,
			roi_Value: roi_Value,
			innerURL: innerURL,
			getFinYears: getFinYears,
			getTDSDetails: getTDSDetails,
			innerLinks: innerLinks,
			backFlag: backFlag,
			getAccountOptions: getAccountOptions,
			getChequeOptions: getChequeOptions,
			getTaxInvOptions: getTaxInvOptions,
			getDebitCardOptions: getDebitCardOptions,
			getPensionOptions:getPensionOptions

		}
	});
