angularApp.service('manageQrCodeService',
	function($q,AdapterUtils){
		var MQRservice =this;
		
		//getVPA function is define to get VPA details for respective account number
		MQRservice.getVPA = function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/SettingsAdapter/getVPA", reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
		//getQRCodeForVPA function is define to get QR code for respective VPA
		MQRservice.getQRCodeForVPA = function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/SettingsAdapter/getQRCodeForVPA", reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
		//createQRCode function is define to create QR code for respective VPA
		MQRservice.createQRCode = function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/SettingsAdapter/createQRCode", reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
				
		return MQRservice;
	});  