'use strict';

angularApp.controller('FAQDetailsController', 
						["$timeout",
						 "$state",
						 "$ionicHistory",
						 "$location",
						 "$scope","$stateParams","$ionicSideMenuDelegate","supportServices","$rootScope","utilityService",
				         
function ($timeout,
		 $state,
		 $ionicHistory,
		 $location,
		 $scope,$stateParams,$ionicSideMenuDelegate,supportServices,$rootScope,utilityService) {
	
	//functions, variables that can be accessed from the HTML come here
	var FAQDetailsVm = this;
	//FAQDetailsVm.FAQType=$stateParams.obj + " " + "Faq's";
    FAQDetailsVm.FAQType=$stateParams.obj.sbiFAQCategoryName + " " + "Faq's";	
	FAQDetailsVm.FAQUrl=$stateParams.obj.sbiFAQServiceURL; 
	supportServices.nfsFAQObj=$stateParams.obj;
	
	
	//private methods section start
	function initPage(){
		FAQDetailsVm.showBack = false;
		FAQDetailsVm.showNext = true;
		FAQDetailsVm.reqParams={};
		FAQDetailsVm.reqParams['category']=FAQDetailsVm.FAQType;
		FAQDetailsVm.reqParams['sbiFAQServiceURL']=FAQDetailsVm.FAQUrl;
		
	 /*************************Fetch all faq list start************************************/	
		supportServices.getFAQList(FAQDetailsVm.reqParams).then(function(data){
			FAQDetailsVm.faqQues = data.getFAQLists; 
		},function(error){
			utilityService.showErrorMessage(error.responseMessage);
		}); 
		/*************************Fetch all faq list end************************************/
		
	}
	//Go to faq list details page
	FAQDetailsVm.FAQDetailsList = function(FAQObj,FAQType){ 
		$state.go('menu.FAQListDetails',{obj:FAQObj,obj1:FAQType});
	}
	
	//back to prev page
	
	FAQDetailsVm.gotToPreviousPage = function(){
		if(supportServices.fromNFS)
		{

			$state.go('menu.nfsFaq',{obj:supportServices.faqData});
			
		}

		else{
			$state.go('menu.FAQ',{obj:supportServices.faqData});
			
		}
	
		
	}
	
	FAQDetailsVm.gotToHomePage = function(){
		$state.go('menu.support');
	}
	
	//go to next page
	FAQDetailsVm.goToNextPage = function(){
		$state.go('menu.accountOverviewPopup');
	}
	
	
	//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false)

		initPage();
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(true)

	});
	return this;
}]);
