'use strict';

angularApp.controller('FAQListDetailsController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope","$stateParams",
						 "supportServices","$ionicSideMenuDelegate","$ionicPopup","$window","utilityService","$ionicHistory",
				         
function ($timeout,
		 $state,
		 $location,
		 $scope,$stateParams,supportServices,$ionicSideMenuDelegate,$ionicPopup,$window,utilityService,$ionicHistory) {
	
	//functions, variables that can be accessed from the HTML come here
	var FAQListDetailsVm = this;
	
	//FAQListDetailsVm.FAQType=$stateParams.obj.sbiFAQCategoryName;
	//FAQListDetailsVm.FAQType=$stateParams.obj1;
	
	//private methods section start

	
	function initPage(){
		FAQListDetailsVm.showBack = false;
		FAQListDetailsVm.showNext = false;
		
		 /*************************Fetch question , answer and category name ************************************/	
		    FAQListDetailsVm.FAQQuestions = $stateParams.obj.queryQuestion; 
			FAQListDetailsVm.FAQAnswer = $stateParams.obj.queryAnswer;
			FAQListDetailsVm.FAQCategory=$stateParams.obj.categoryName;
			FAQListDetailsVm.FAQType = $stateParams.obj1;
	    /*************************Fetch question , answer and category name ************************************/	
	}
	
	
	 /*************************submit faq question feedback start************************************/	
	FAQListDetailsVm.FAQFeedbackSubmit=function(questionId,faqType,feedback){
		var reqParams={};
		reqParams['questionId'] = questionId;
		reqParams['feedback'] = feedback;
	    reqParams['faqType'] = faqType;
		
		supportServices.submitFaq(reqParams).then(
		function(data) {
			//var resData = data;		
					
			  var alertPopup = $ionicPopup.alert({
				   template: '<img src="img/congratulations-smile.svg" alt="Success Screen"/><span class="col center">'+ data.feedback.message +'<span>' ,
				  inputType: 'Ok', 
				   cssClass: 'dialog',
			  });
				  alertPopup.then(function(res) {
					  
				  $ionicHistory.goBack();
			  });      
		},
		function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		}
	);
	}
	 /*************************submit faq question feedback end************************************/	
	//back to prev page
	FAQListDetailsVm.goToHome = function(){
		$state.go('menu.support');
	}
	
	FAQListDetailsVm.gotToPreviousPage  = function(){
		//history.back();
		
		//$ionicHistory.goBack();
	//$state.go('menu.FAQDetails',{obj:'fromNFS'});
	//$state.go('menu.FAQListDetails',{obj:FAQObj,obj1:FAQType});
          var stateObj= supportServices.nfsFAQObj;
	
	$state.go('menu.FAQDetails',{obj:stateObj,obj1:FAQListDetailsVm.FAQType});
		/* $state.go('menu.FAQDetailsBack'); */
		/* $state.go('menu.FAQ');  */
		//$state.go('menu.support');
	}
	
	//go to next page
	FAQListDetailsVm.goToNextPage = function(){
		$state.go('menu.accountOverviewPopup');
	}
	
	
	//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false)

		initPage();
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(true)

	});
	return this;
}]);
