angularApp.service('transactionDetailsService',
	function ($q, utilityService, AdapterUtils) {
		var TDService = function (requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HelpAdapter/getRecentTransactions", requestData, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		return {
			TDService: TDService
		}

	});