'use strict';

angularApp.controller('nfsFaqController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope","$stateParams","$ionicSideMenuDelegate","supportServices","$rootScope","utilityService",
				         
function ($timeout,
		 $state,
		 $location,
		 $scope,$stateParams,$ionicSideMenuDelegate,supportServices,$rootScope,utilityService) {
	
	//functions, variables that can be accessed from the HTML come here
	var nfsFaqVm = this;
	nfsFaqVm.FAQType=$stateParams.obj;
    nfsFaqVm.FAQType=$stateParams.obj.sbiFAQCategoryName;	
	nfsFaqVm.FAQUrl=$stateParams.obj.sbiFAQServiceURL; 
	
	
	//private methods section start
	function initPage(){
		nfsFaqVm.showBack = false;
		nfsFaqVm.showNext = true;
		nfsFaqVm.reqParams={};
		nfsFaqVm.reqParams['category']=nfsFaqVm.FAQType;
		nfsFaqVm.reqParams['sbiFAQServiceURL']=nfsFaqVm.FAQUrl;
		
	 /*************************Fetch all faq list start************************************/	
				var reqData = {
			"url": nfsFaqVm.FAQUrl
			}
	supportServices.getFAQCategories(reqData).then(function(data){	 	
			var resData = data;			
				nfsFaqVm.faqCategoryLists = resData.getFAQCategoriesLists;
				
			},function(error){
					  utilityService.showErrorMessage(error.responseMessage);
 			});
	
		/*************************Fetch all faq list end************************************/
		
	}
	//Go to faq list details page
	nfsFaqVm.FAQDetailsList = function(FAQObj,FAQType){
		$state.go('menu.FAQListDetails',{obj:FAQObj,obj1:FAQType});
	}
	
	nfsFaqVm.transQuery = function(FAQObj,FAQType){
		$state.go('menu.FAQDetails',{obj:FAQObj,obj1:FAQType});
	}
	
	//back to prev page
	
	nfsFaqVm.gotToPreviousPage = function(){
		$state.go('menu.FAQ');
		
	}
	
	nfsFaqVm.gotToHomePage = function(){
		$state.go('menu.support');
	}
	
	//go to next page
	nfsFaqVm.goToNextPage = function(){
		$state.go('menu.accountOverviewPopup');
	}
	
	
	//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false)

		initPage();
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(true)

	});
	return this;
}]);
