
	
	angularApp.service('supportServices',
	function($q,AdapterUtils,loggedInUserService){
		var supportServices =this;	
			this.nfsFAQObj="";
			this.faqData="";
			this.fromNFS=false;
	 /**************GetTransactions Service - start*************/		
		supportServices.getRecentTransactions =function(reqParams) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/AccountOverViewAdapter/getTransactions",reqParams, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				 }
				); 
				
			return q.promise;
		};    
    /**************GetTransactions Service - end*************/		
	
	 /**************GetAccountDetails Service - start*************/	
		supportServices.getAccountDetails =function() {
			var q = $q.defer();	
			//AdapterUtils.postData("adapters/AccountOverViewAdapter/getAccountDetails", true).then(
			AdapterUtils.postData("adapters/HomeAdapter/customerAndAccountInfo", true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				 }
				); 
			return q.promise;
		};
    /**************GetAccountDetails Service - end*************/	
 
   /**************GetAccountDetails Service - start*************/	
		supportServices.submitQuery = function(reqParams) {
			var q = $q.defer();		
			AdapterUtils.postData("adapters/HelpAdapter/submitQuery",reqParams,true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
	/**************GetAccountDetails Service - end*************/	
	
	/**************GetQueryList Service - start*************/	
		
		supportServices.getQueryList = function() {
			var q = $q.defer();	
		AdapterUtils.getData("adapters/HelpAdapter/getQueryList",true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
	/**************GetQueryList Service - end*************/
		
		
	/**************ChatQuery Service - start*************/
		supportServices.submitChat = function(reqParams) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/HelpAdapter/chatQuery",reqParams,true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject("error");
				}
				); 
			return q.promise;
		};
	/**************ChatQuery Service - end*************/
		
		
	/**************GetFAQCategory Service - start*************/
		supportServices.getFAQCategories = function(requestData) {
			if(loggedInUserService.isLoggedInDetails.isLoggedIn){
				var q = $q.defer();	
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getFAQCategory", requestData, true).then(
		
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				);
			return q.promise;

			}else{
				var q = $q.defer();	
			AdapterUtils.postData("adapters/ServiceRequestAdapter/oa/v1/getFAQCategory", requestData, true).then(
		
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				);
			return q.promise;
			}
			
		};
	/**************GetFAQCategory Service - end*************/
	
	
	/**************GetFAQList Service - start*************/
		supportServices.getFAQList = function(reqParams) {
			if(loggedInUserService.isLoggedInDetails.isLoggedIn){
				var q = $q.defer();	
				AdapterUtils.postData("adapters/ServiceRequestAdapter/getFAQList",  reqParams, true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
					);
				return q.promise;
		}else{
				var q = $q.defer();	
				AdapterUtils.postData("adapters/ServiceRequestAdapter/oa/v1/getFAQList",  reqParams, true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
					);
				return q.promise;

			}
			
		};
	/**************GetFAQList Service - end*************/
			
			
		/**************SubmitFAQFeedback Service - start*************/
		supportServices.submitFaq = function(reqParams) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/HelpAdapter/submitFAQFeedback", reqParams, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
	  /**************SubmitFAQFeedback Service - end*************/	
	  
	    /**************GetSBIHelpline Service - start*************/	
		supportServices.getSBIHelpline = function() {
			var q = $q.defer();	
			AdapterUtils.getData("adapters/ContactUsAdapter/getSBIHelpline",true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
	    };
	/**************GetSBIHelpline Service - end*************/	
	
	/**************GetFeatureVideos Service - start*************/	
		
		supportServices.getFeatureVideos = function() {
		var q = $q.defer();	
		AdapterUtils.getData("adapters/HelpAdapter/getFeatureVideos",true).then(
			function(response){
				q.resolve(response.data);
			},
			function(error){
				q.reject(error);
			}
			); 
		return q.promise;
		};
	/**************GetFeatureVideos Service - end*************/	
	 /**************GetAccountDetails Service - start*************/	
		supportServices.getCMSRedirectUrl =function(reqParams) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/HelpAdapter/getCMSRedirectUrl",reqParams, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				 }
				); 
			return q.promise;
		};
    /**************GetAccountDetails Service - end*************/	
		
		return supportServices;
	});  
