
'use strict';

angularApp.controller('trackQueryDetailsController', function($scope, $state,$stateParams,$filter,supportServices,$ionicScrollDelegate,$rootScope, $ionicSideMenuDelegate) {
	
	var trackQueryDetailsVm = this;
	
	function initPage(){
		trackQueryDetailsVm.sender=[];
		trackQueryDetailsVm.queryMessage="";
		trackQueryDetailsVm.queryDetailsObj=$stateParams.queryObj;
		$ionicScrollDelegate.scrollBottom(true);
		 
		
	}
	 /*************************Send Query to SBI Executive start************************************/	
	trackQueryDetailsVm.sendMessage=function(queryReferenceNumber,message){
		if(trackQueryDetailsVm.queryMessage!=""){
			 trackQueryDetailsVm.customerName = $rootScope.customerName;
			trackQueryDetailsVm.queryMessage = "";
			var reqParams = {};
			reqParams['queryReferenceNumber']=queryReferenceNumber;
			reqParams['message'] = message;
			reqParams['name'] =  trackQueryDetailsVm.customerName; /* name come from session from account overview section*/
			
			supportServices.submitChat(reqParams).then(
				function(data) {
						trackQueryDetailsVm.sender.push({'message':message,'dateTime':$filter('date')(new Date(), "dd/MM/yyyy hh:mm a"),'senderName':'User'});
						$ionicScrollDelegate.scrollBottom(true);
					
				},
				function(errResponse) {
					 utilityService.showErrorMessage(error.responseMessage);
				}
			);
		}
	}
	
	 /*************************Send Query to SBI Executive end************************************/	
	 
	 
    //Go to back page
	trackQueryDetailsVm.goToPreviousPage=function(){
		
		$state.go("menu.trackQuery");
	}
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false)

		initPage();
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(true)

	});
});
