/**
 *   @ngdoc config
 *   @name angularApp.config : cardConfig
 *   @description
 *  configuration file for cards module
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.verifyDetails', {
                    url: '/verifyDetails',
                    data: {
                        pageId: 'VERIFYDETAILS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/wealthmgmt/verifyDetails/verifydetails.html',
                            controller: 'verifyDetailsController',
                            controllerAs: 'verifyDetailsVm'
                        }
                    }
                })
        }
    ]);
