var slidingTabsDirective = angular.module("ionic").directive('ionXcSlideTabs', ['$timeout', '$compile', '$interval', '$ionicSlideBoxDelegate', '$ionicScrollDelegate', '$ionicGesture', "xpressCreditService", "utilityService",
    function($timeout, $compile, $interval, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicGesture, xpressCreditService, utilityService) {
        return {
            require: "^ionSlideBox",
            restrict: 'A',
            link: function(scope, element, attrs, parent) {

                var ionicSlideBoxDelegate;
                var ionicScrollDelegate;
                var ionicScrollDelegateID;
                var randNum;

                var slideTabs;
                var indicator;

                var slider;
                var tabsBar;

                var options = {
                    "slideTabsScrollable": true,
                    "isXpress": true
                }


                var init = function() {



                    if (angular.isDefined(attrs.isXpress) && attrs.isXpress === "false") {
                        options.slideTabsScrollable = false;
                    }

                    if (angular.isDefined(attrs.isXpress) && attrs.isXpress === "false") {
                        options.isXpress = false;
                    }
                    /*
                                       var tabItems = '<li ng-repeat="x in tabs" ng-click="onTabTabbed($event, {{$index}})" ng-if="$index===0" id="AOV_MYBAL_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">{{x.label}}</div><div> &#8377; {{x.accountBalance | INR}}</div></li>'
                                                    +'<li ng-repeat="x in tabs" ng-click="onTabTabbed($event, {{$index}})" ng-if="$index===1" id="AOV_MYDEPO_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">{{x.label}}</div><div> &#8377; {{x.accountBalance | INR}}</div></li>'
                                                    +'<li ng-repeat="x in tabs" ng-click="onTabTabbed($event, {{$index}})" ng-if="$index===2" id="AOV_MYBORRO_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">{{x.label}}</div><div> &#8377; {{x.accountBalance | INR}}</div></li>'
                                                    +'<li ng-repeat="x in tabs" ng-click="onTabTabbed($event, {{$index}})" ng-if="$index===3" id="AOV_MYINVEST_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">{{x.label}}</div><div> &#8377; {{x.accountBalance | INRFLOAT : 2}}</div></li>'
                                                    +'<li ng-repeat="x in tabs" ng-click="onTabTabbed($event, {{$index}});Vm.loadGI()" ng-if="$index===4" id="AOV_MYINSU_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">{{x.label}}</div></li>'
                                                    +'<li ng-repeat="x in tabs" ng-click="onTabTabbed($event, {{$index}});Vm.cardsApiCall();" ng-if="$index===5" id="AOV_MYCRDS_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">{{x.label}}</div></li>'
                                                    +'<li  ng-click="onTabTabbed($event, 6)" id="AOV_MYRWRDS_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">My Rewards</div><div> {{Vm.myLoyalityRewards}} </div></li>';
                        */
                    var tabItems = "";

                    if (options.isXpress) {

                        tabItems = '<li  ng-click="onTabTabbed($event, 0);"  id="MYELIG_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">Eligibility</div><div ng-if="Vm.MyBalanceAmount===0 &&Vm.displaySpinner===true"><ion-spinner icon="dots" class="spinner-dark"></ion-spinner></div><div ng-if="Vm.MyBalanceAmount>0"> &#8377; {{Vm.MyBalanceAmount | INR}}</div></li>' +
                            '<li  ng-click="onTabTabbed($event, 1);"  id="MYFET_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">Features</div><div ng-if="Vm.MyDepositsAmount===0 &&Vm.displaySpinner===true"><ion-spinner icon="dots" class="spinner-dark"></ion-spinner></div><div ng-if="Vm.MyDepositsAmount>0"> &#8377; {{Vm.MyDepositsAmount | INR}}</div></li>' +
                            '<li ng-click="onTabTabbed($event, 2)"  id="MYDOC_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">Documentation</div><div ng-if="Vm.MyBorrowingsAmount===0 &&Vm.displaySpinner===true"><ion-spinner icon="dots" class="spinner-dark"></ion-spinner></div><div ng-if="Vm.MyBorrowingsAmount>0"> &#8377; {{Vm.MyBorrowingsAmount | INR}}</div></li>' +
                            '<li  ng-click="onTabTabbed($event, 3);"  id="MYINT_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">Interest Rates</div><div ng-if="Vm.MyInvestmentsAmount===0 &&Vm.displaySpinner===true"><ion-spinner icon="dots" class="spinner-dark"></ion-spinner></div><div ng-if="Vm.MyInvestmentsAmount>0"> &#8377; {{Vm.MyInvestmentsAmount | INRFLOAT : 2}}</div></li>' +
                            '<li  ng-click="onTabTabbed($event, 4);" id="MYEMICAL_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">EMI Calculator</div></li>';
                    } else {
                        tabItems = '<li  ng-click="onTabTabbed($event, 0);"  id="MYELIG_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">EMI Calculator</div><div ng-if="Vm.MyBalanceAmount===0 &&Vm.displaySpinner===true"><ion-spinner icon="dots" class="spinner-dark"></ion-spinner></div><div ng-if="Vm.MyBalanceAmount>0"> &#8377; {{Vm.MyBalanceAmount | INR}}</div></li>' +
                            '<li  ng-click="onTabTabbed($event, 1);"  id="MYFET_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">Features</div><div ng-if="Vm.MyDepositsAmount===0 &&Vm.displaySpinner===true"><ion-spinner icon="dots" class="spinner-dark"></ion-spinner></div><div ng-if="Vm.MyDepositsAmount>0"> &#8377; {{Vm.MyDepositsAmount | INR}}</div></li>' +
                            '<li ng-click="onTabTabbed($event, 2)"  id="MYDOC_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">Documentation</div><div ng-if="Vm.MyBorrowingsAmount===0 &&Vm.displaySpinner===true"><ion-spinner icon="dots" class="spinner-dark"></ion-spinner></div><div ng-if="Vm.MyBorrowingsAmount>0"> &#8377; {{Vm.MyBorrowingsAmount | INR}}</div></li>' +
                            '<li  ng-click="onTabTabbed($event, 3);"  id="MYINT_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">Interest Rates</div><div ng-if="Vm.MyInvestmentsAmount===0 &&Vm.displaySpinner===true"><ion-spinner icon="dots" class="spinner-dark"></ion-spinner></div><div ng-if="Vm.MyInvestmentsAmount>0"> &#8377; {{Vm.MyInvestmentsAmount | INRFLOAT : 2}}</div></li>' +
                            '<li  ng-click="onTabTabbed($event, 4);" id="MYEMICAL_HEDR_TAB" click-stream="click" class="slider-slide-tab font-dark-grey font-content" ><div class="selectedTab">Eligibility</div></li>';
                    }

                    if (options.slideTabsScrollable) {
                        randNum = Math.random();
                        ionicScrollDelegateID = "ion-slide-tabs-handle-" + Math.floor((randNum * 10000) + 1);
                        //alert(ionicScrollDelegateID);
                        tabsBar = angular.element('<ion-scroll has-bouncing ="false" overflow-scroll="false" delegate-handle="' + ionicScrollDelegateID + '" class="slidingTabs" direction="x" ><ul>' + tabItems + '</ul> <div class="tab-indicator-wrapper"><div class="tab-indicator"></div></div> </ion-scroll>');
                    } else {

                        tabsBar = angular.element('<div class="slidingTabs"><ul>' + tabItems + '</ul> <div class="tab-indicator-wrapper"><div class="tab-indicator"></div></div> </div>');

                    }


                    slider = angular.element(element);

                    var compiled = $compile(tabsBar);
                    slider.parent().prepend(tabsBar);
                    compiled(scope);

                    //get Tabs DOM Elements
                    indicator = angular.element(tabsBar[0].querySelector(".tab-indicator"));

                    //get the slideBoxHandle
                    var slideHandle = slider.attr('delegate-handle');
                    var scrollHandle = tabsBar.attr('delegate-handle');

                    ionicSlideBoxDelegate = $ionicSlideBoxDelegate;
                    if (slideHandle) {
                        ionicSlideBoxDelegate = ionicSlideBoxDelegate.$getByHandle(slideHandle);
                    }


                    if (options.slideTabsScrollable) {

                        ionicScrollDelegate = $ionicScrollDelegate;
                        if (scrollHandle) {
                            ionicScrollDelegate = ionicScrollDelegate.$getByHandle(scrollHandle);
                        }

                    }


                    addEvents();
                    setTabBarWidth();
                    slideToCurrentPosition();
                    // scope.onTabTabbed(event,xpressCreditService.tabIndex.tabIndex);
                };

                var addEvents = function() {

                    ionic.onGesture("dragleft", scope.onSlideMove, slider[0]);
                    ionic.onGesture("dragright", scope.onSlideMove, slider[0]);
                    ionic.onGesture("release", scope.onSlideChange, slider[0]);

                }

                var setTabBarWidth = function() {

                    if (!angular.isDefined(slideTabs) || slideTabs.length == 0) {
                        return false;
                    }

                    var tabsList = tabsBar.find("ul");
                    var tabsWidth = 0;

                    angular.forEach(slideTabs, function(currentElement, index) {

                        var currentLi = angular.element(currentElement);
                        tabsWidth += currentLi[0].offsetWidth + 2;
                    });

                    if (options.slideTabsScrollable) {

                        angular.element(tabsBar[0].querySelector(".scroll")).css("width", tabsWidth + 1 + "px");

                    } else {

                        slideTabs.css("width", tabsList[0].offsetWidth / slideTabs.length + "px");
                    }

                    slideToCurrentPosition();

                };

                var addTabTouchAnimation = function(event, currentElement) {

                    //var ink = angular.element(currentElement[0].querySelector(".ink"));
                    var ink = angular.element(null);

                    if (!angular.isDefined(ink) || ink.length == 0) {
                        ink = angular.element("<span class='ink'></span>");
                        currentElement.prepend(ink);
                    }


                    ink.removeClass("animate");

                    if (!ink.offsetHeight && !ink.offsetWidth) {

                        var d = Math.max(currentElement[0].offsetWidth, currentElement[0].offsetHeight);
                        ink.css("height", d + "px");
                        ink.css("width", d + "px");
                    }

                    var x = event.offsetX - ink[0].offsetWidth / 2;
                    var y = event.offsetY - ink[0].offsetHeight / 2;


                    ink.css("top", y + 'px');
                    ink.css("left", x + 'px');
                    ink.addClass("animate");
                }

                var slideToCurrentPosition = function() {

                    if (!angular.isDefined(slideTabs) || slideTabs.length == 0) {
                        return false;
                    }

                    var targetSlideIndex = ionicSlideBoxDelegate.currentIndex();

                    var targetTab = angular.element(slideTabs[targetSlideIndex]);
                    var targetLeftOffset = targetTab.prop("offsetLeft");
                    var targetWidth = targetTab[0].offsetWidth;



                    indicator.css({
                        "-webkit-transition-duration": "3ms",
                        "-webkit-transform": "translateZ(0)",
                        "width": targetWidth + "px"
                    });
                    indicator.css({
                        "-webkit-transform": "translate(" + targetLeftOffset + "px,0px)"
                    });

                    if (options.slideTabsScrollable && ionicScrollDelegate) {
                        var scrollOffset = 80;
                        ionicScrollDelegate.scrollTo(targetLeftOffset - scrollOffset, 0, true);
                    }

                    slideTabs.removeClass("tab-active");
                    targetTab.addClass("tab-active");

                }


                var setIndicatorPosition = function(currentSlideIndex, targetSlideIndex, position, slideDirection) {

                    var targetTab = angular.element(slideTabs[targetSlideIndex]);

                    var currentTab = angular.element(slideTabs[currentSlideIndex]);
                    var targetLeftOffset = targetTab.prop("offsetLeft");

                    var currentLeftOffset = currentTab.prop("offsetLeft");
                    var offsetLeftDiff = Math.abs(targetLeftOffset - currentLeftOffset);


                    if (currentSlideIndex == 0 && targetSlideIndex == ionicSlideBoxDelegate.slidesCount() - 1 && slideDirection == "right" ||
                        targetSlideIndex == 0 && currentSlideIndex == ionicSlideBoxDelegate.slidesCount() - 1 && slideDirection == "left") {
                        return;
                    }

                    var targetWidth = targetTab[0].offsetWidth;
                    var currentWidth = currentTab[0].offsetWidth;
                    var widthDiff = targetWidth - currentWidth;

                    var indicatorPos = 0;
                    var indicatorWidth = 0;

                    if (currentSlideIndex > targetSlideIndex) {

                        indicatorPos = targetLeftOffset - (offsetLeftDiff * (position - 1));
                        indicatorWidth = targetWidth - ((widthDiff * (1 - position)));

                    } else if (targetSlideIndex > currentSlideIndex) {

                        indicatorPos = targetLeftOffset + (offsetLeftDiff * (position - 1));
                        indicatorWidth = targetWidth + ((widthDiff * (position - 1)));

                    }



                    indicator.css({
                        "-webkit-transition-duration": "300ms",
                        "-webkit-transform": "translate(" + indicatorPos + "px,0px)",
                        "width": indicatorWidth + "px"
                    });


                    if (options.slideTabsScrollable && ionicScrollDelegate) {
                        var scrollOffset = 80;
                        ionicScrollDelegate.scrollTo(indicatorPos - scrollOffset, 0, false);
                    }

                }

                scope.onTabTabbed = function(event, index) {
                    // xpressCreditService.tabIndex.tabIndex=index;
                    addTabTouchAnimation(event, angular.element(event.currentTarget));
                    ionicSlideBoxDelegate.slide(index);
                    slideToCurrentPosition();

                }


                scope.tabs = [];

                scope.addTabContent = function($content) {
                    scope.tabs.push($content);
                    //scope.$apply();
                    setTimeout(function() {
                        scope.$apply();
                        slideTabs = angular.element(tabsBar[0].querySelector("ul").querySelectorAll(".slider-slide-tab"));
                        slideToCurrentPosition();
                        setTabBarWidth()
                    }, 100);
                }

                scope.onSlideChange = function(slideIndex) {
                    slideToCurrentPosition();
                };

                scope.onSlideMove = function() {
                    var scrollDiv = slider[0].getElementsByClassName("slider-slide");

                    var currentSlideIndex = ionicSlideBoxDelegate.currentIndex();
                    var currentSlide = angular.element(scrollDiv[currentSlideIndex]);
                    var currentSlideLeftOffset = currentSlide.css('-webkit-transform').replace(/[^0-9\-.,]/g, '').split(',')[0];

                    var targetSlideIndex = (currentSlideIndex + 1) % scrollDiv.length;
                    if (currentSlideLeftOffset > slider.prop("offsetLeft")) {
                        targetSlideIndex = currentSlideIndex - 1;
                        if (targetSlideIndex < 0) {
                            targetSlideIndex = scrollDiv.length - 1;
                        }
                    }
                    var targetSlide = angular.element(scrollDiv[targetSlideIndex]);

                    var position = currentSlideLeftOffset / slider[0].offsetWidth;
                    var slideDirection = position > 0 ? "right" : "left";
                    position = Math.abs(position);

                    setIndicatorPosition(currentSlideIndex, targetSlideIndex, position, slideDirection);
                };

                init();
            },
            controller: ['$scope', function($scope) {
                this.addTab = function($content) {
                    $timeout(function() {
                        if ($scope.addTabContent) {
                            $scope.addTabContent($content);
                        }
                    });
                }
            }]
        };
    }
]);

slidingTabsDirective.directive('ionXcSlideTabLabel', [function() {
    return {
        require: "^ionXcSlideTabs",
        scope: { data: '=ionXcSlideTabLabel' },
        link: function($scope, $element, $attrs, $parent) {
            $parent.addTab($scope.data);
        }
    }
}]);