'use strict';
angularApp.controller('xcLiableController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService) {
			
			var xcLiableVm = this;
			
			function initPage() {
				xcLiableVm.disabledNext = true;
				xcLiableVm.isExpand = false;
				// xcLiableVm.loansother = 0;
				// xcLiableVm.mortgaged = 0;
				// xcLiableVm.employer = 0;
				// xcLiableVm.frndrelative = 0;
				// xcLiableVm.others = 0;


				xcLiableVm.enabledRelation = true;
			};

			xcLiableVm.goToAO = function () {
				xpressCreditService.initialValueStage();
				$state.go('menu.loans');
			}

			xcLiableVm.hideShow = function() {
		      	if(xcLiableVm.isExpand == false) {
		      		xcLiableVm.isExpand = true;
		      	} else {
		      		xcLiableVm.isExpand = false;
		      	}

		    }

		    xcLiableVm.validationAll = function () {
				// if (xcLiableVm.employer > 0) {
					// if (xcLiableVm.employer > 0 && xcLiableVm.others > 0) {
				if (xcLiableVm.others > 0) {
					xcLiableVm.enabledRelation = false;
					if (xcLiableVm.Sperelation) {
						xcLiableVm.disabledNext = false;
					} else {
						xcLiableVm.disabledNext = true;
					}
				} else {
					xcLiableVm.enabledRelation = true;
					xcLiableVm.disabledNext = false;
					xcLiableVm.Sperelation = "";
				}
				// } else {
				// 	xcLiableVm.disabledNext = true;
				// }
			}

			xcLiableVm.changeAmount = function() {
				// if (xcLiableVm.employer) {
					var a = Number(xcLiableVm.loansother || 0);
					var b = Number(xcLiableVm.mortgaged || 0);
					var c = Number(xcLiableVm.employer || 0);
					var d = Number(xcLiableVm.frndrelative || 0);
					var e = Number(xcLiableVm.others || 0);
				
					xcLiableVm.totalAmountValue = a + b + c + d + e;
				// }
				
				xcLiableVm.validationAll();
				
			}

			xcLiableVm.goToCancel = function () {
				$state.go('menu.xcAssets');
			}

			xcLiableVm.goToConfirm = function () {
				xpressCreditService.createXcData.liable.employer = xcLiableVm.employer;
				xpressCreditService.createXcData.liable.mortgaged = xcLiableVm.mortgaged;
				xpressCreditService.createXcData.liable.loansother = xcLiableVm.loansother;
				xpressCreditService.createXcData.liable.frndrelative = xcLiableVm.frndrelative;
				xpressCreditService.createXcData.liable.others = xcLiableVm.others;
				xpressCreditService.createXcData.liable.Sperelation = xcLiableVm.Sperelation;
				xpressCreditService.createXcData.liable.totalAmountValue = xcLiableVm.totalAmountValue;


    			var obj = {
					"pageName": "declarationOnLiabilities",
					"progress": "60%",
					"yonoRefNo": "",
					"liabilityDetails" : [{
						"liabilityCategory": "LS",
  						"liabilityType": "OL",
						"empBorrowingAmount": xcLiableVm.employer,
					  	"mortgagedAmount": xcLiableVm.mortgaged,
					  	"otherLoansAmount": xcLiableVm.loansother,
					  	"friOrRealAmount": xcLiableVm.frndrelative,
					  	"othersRelations": xcLiableVm.others,
					  	"relationship": xcLiableVm.Sperelation,
					}],
					"totalAmount": xcLiableVm.totalAmountValue
				}

				xpressCreditService.getEMICalcValues(obj).then(function(data) {
                    console.log("OmniCallResponse",obj,data)
                    xpressCreditService.createXcData.productDetails = data.productDetails;   
			        xpressCreditService.createXcData.loanOfferSelected = "";
			        $state.go('menu.xcLoanoffer');
                },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });		
				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				if (xpressCreditService.createXcData.liable.employer) {
					xcLiableVm.employer = xpressCreditService.createXcData.liable.employer;
				}

				if (xpressCreditService.createXcData.liable.mortgaged) {
					xcLiableVm.mortgaged = xpressCreditService.createXcData.liable.mortgaged;
				}

				if (xpressCreditService.createXcData.liable.loansother) {
					xcLiableVm.loansother = xpressCreditService.createXcData.liable.loansother;
				}

				if (xpressCreditService.createXcData.liable.frndrelative) {
					xcLiableVm.frndrelative = xpressCreditService.createXcData.liable.frndrelative;
				}

				if (xpressCreditService.createXcData.liable.others) {
					xcLiableVm.others = xpressCreditService.createXcData.liable.others;
				}

				if (xpressCreditService.createXcData.liable.Sperelation) {
					xcLiableVm.Sperelation = xpressCreditService.createXcData.liable.Sperelation;
				}

				if (xpressCreditService.createXcData.liable.totalAmountValue) {
					xcLiableVm.totalAmountValue = xpressCreditService.createXcData.liable.totalAmountValue;
				}

				xcLiableVm.validationAll();
			});

			return this;
		}
]);


