'use strict';
angularApp.controller('xcLoanofferController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService) {
			
			var xcLoanofferVm = this;
			
			function initPage() {
				// xcLoanofferVm.loanofferChecked = "overdraft";
				xcLoanofferVm.disabledNext = true;
			};

			xcLoanofferVm.goToAO = function () {
				xpressCreditService.initialValueStage();
				$state.go('menu.loans');
			}
			
			xcLoanofferVm.onChnageGet = function (value) {
				if (value) {
					if (xpressCreditService.createXcData.productDetails.length == 1) {
						xpressCreditService.createXcData.gstPercentage = xpressCreditService.createXcData.productDetails[0].gstPercentage;
			  			xpressCreditService.createXcData.processingfeesPercentage = xpressCreditService.createXcData.productDetails[0].processingfeesPercentage;
				        xpressCreditService.createXcData.minimumLoanTenure = xpressCreditService.createXcData.productDetails[0].minimumTenure;
				        xpressCreditService.createXcData.maximumLoanTenure = xpressCreditService.createXcData.productDetails[0].maximumTenure;
				        xpressCreditService.createXcData.minimumLoanAmount = xpressCreditService.createXcData.productDetails[0].minimumLoanAmount;
				        xpressCreditService.createXcData.maximumLoanAmount = xpressCreditService.createXcData.productDetails[0].maximumLoanAmount;
				        xpressCreditService.createXcData.maximumLoanAmount = xpressCreditService.createXcData.productDetails[0].maximumLoanAmount;
				        xpressCreditService.createXcData.ProcessingFees = xpressCreditService.createXcData.productDetails[0].processFeeCalc;
				        xpressCreditService.createXcData.rateCalculator = xpressCreditService.createXcData.productDetails[0].rate;
				        xpressCreditService.createXcData.emiCalculator = xpressCreditService.createXcData.productDetails[0].emi;

				        xpressCreditService.createXcData.selectedLoanAmout = xpressCreditService.createXcData.productDetails[0].maximumLoanAmount;
				        xpressCreditService.createXcData.selectedTenure = xpressCreditService.createXcData.productDetails[0].maximumTenure;
					} else {
						if (value == "overdraft") {
							xpressCreditService.createXcData.gstPercentage = xpressCreditService.createXcData.productDetails[0].gstPercentage;
							xpressCreditService.createXcData.processingfeesPercentage = xpressCreditService.createXcData.productDetails[0].processingfeesPercentage;
					        xpressCreditService.createXcData.minimumLoanTenure = xpressCreditService.createXcData.productDetails[0].minimumTenure;
					        xpressCreditService.createXcData.maximumLoanTenure = xpressCreditService.createXcData.productDetails[0].maximumTenure;
					        xpressCreditService.createXcData.minimumLoanAmount = xpressCreditService.createXcData.productDetails[0].minimumLoanAmount;
					        xpressCreditService.createXcData.maximumLoanAmount = xpressCreditService.createXcData.productDetails[0].maximumLoanAmount;
					        xpressCreditService.createXcData.maximumLoanAmount = xpressCreditService.createXcData.productDetails[0].maximumLoanAmount;
					        xpressCreditService.createXcData.ProcessingFees = xpressCreditService.createXcData.productDetails[0].processFeeCalc;
					        xpressCreditService.createXcData.rateCalculator = xpressCreditService.createXcData.productDetails[0].rate;
					        xpressCreditService.createXcData.emiCalculator = xpressCreditService.createXcData.productDetails[0].emi;

					        xpressCreditService.createXcData.selectedLoanAmout = xpressCreditService.createXcData.productDetails[0].maximumLoanAmount;
					        xpressCreditService.createXcData.selectedTenure = xpressCreditService.createXcData.productDetails[0].maximumTenure;
				  		} else {
				  			xpressCreditService.createXcData.gstPercentage = xpressCreditService.createXcData.productDetails[1].gstPercentage;
				  			xpressCreditService.createXcData.processingfeesPercentage = xpressCreditService.createXcData.productDetails[1].processingfeesPercentage;
					        xpressCreditService.createXcData.minimumLoanTenure = xpressCreditService.createXcData.productDetails[1].minimumTenure;
					        xpressCreditService.createXcData.maximumLoanTenure = xpressCreditService.createXcData.productDetails[1].maximumTenure;
					        xpressCreditService.createXcData.minimumLoanAmount = xpressCreditService.createXcData.productDetails[1].minimumLoanAmount;
					        xpressCreditService.createXcData.maximumLoanAmount = xpressCreditService.createXcData.productDetails[1].maximumLoanAmount;
					        xpressCreditService.createXcData.maximumLoanAmount = xpressCreditService.createXcData.productDetails[1].maximumLoanAmount;
					        xpressCreditService.createXcData.ProcessingFees = xpressCreditService.createXcData.productDetails[1].processFeeCalc;
					        xpressCreditService.createXcData.rateCalculator = xpressCreditService.createXcData.productDetails[1].rate;
					        xpressCreditService.createXcData.emiCalculator = xpressCreditService.createXcData.productDetails[1].emi;

					        xpressCreditService.createXcData.selectedLoanAmout = xpressCreditService.createXcData.productDetails[1].maximumLoanAmount;
					        xpressCreditService.createXcData.selectedTenure = xpressCreditService.createXcData.productDetails[1].maximumTenure;
				  		}
					}
					xcLoanofferVm.disabledNext = false;
				}
			}

			xcLoanofferVm.goToCancel = function () {
				$state.go('menu.xcLiable');
			}

			xcLoanofferVm.goToConfirm = function () {
				xpressCreditService.createXcData.loanOfferSelected = xcLoanofferVm.loanofferChecked;

				
				// 	if (xpressCreditService.createXcData.productDetails.length == 1) {
				// 		xpressCreditService.createXcData.gstPercentage = xpressCreditService.createXcData.productDetails[0].gstPercentage;
			 //  			xpressCreditService.createXcData.processingfeesPercentage = xpressCreditService.createXcData.productDetails[0].processingfeesPercentage;
				//         xpressCreditService.createXcData.minimumLoanTenure = xpressCreditService.createXcData.productDetails[0].minimumTenure;
				//         xpressCreditService.createXcData.maximumLoanTenure = xpressCreditService.createXcData.productDetails[0].maximumTenure;
				//         xpressCreditService.createXcData.minimumLoanAmount = xpressCreditService.createXcData.productDetails[0].minimumLoanAmount;
				//         xpressCreditService.createXcData.maximumLoanAmount = xpressCreditService.createXcData.productDetails[0].maximumLoanAmount;
				//         xpressCreditService.createXcData.maximumLoanAmount = xpressCreditService.createXcData.productDetails[0].maximumLoanAmount;
				//         xpressCreditService.createXcData.ProcessingFees = xpressCreditService.createXcData.productDetails[0].processFeeCalc;
				//         xpressCreditService.createXcData.rateCalculator = xpressCreditService.createXcData.productDetails[0].rate;
				//         xpressCreditService.createXcData.emiCalculator = xpressCreditService.createXcData.productDetails[0].emi;

				//         xpressCreditService.createXcData.selectedLoanAmout = xpressCreditService.createXcData.productDetails[0].maximumLoanAmount;
				//         xpressCreditService.createXcData.selectedTenure = xpressCreditService.createXcData.productDetails[0].maximumTenure;
				// 	} else {
				// 		if (xcLoanofferVm.loanofferChecked == "overdraft") {
				// 			xpressCreditService.createXcData.gstPercentage = xpressCreditService.createXcData.productDetails[0].gstPercentage;
				// 			xpressCreditService.createXcData.processingfeesPercentage = xpressCreditService.createXcData.productDetails[0].processingfeesPercentage;
				// 	        xpressCreditService.createXcData.minimumLoanTenure = xpressCreditService.createXcData.productDetails[0].minimumTenure;
				// 	        xpressCreditService.createXcData.maximumLoanTenure = xpressCreditService.createXcData.productDetails[0].maximumTenure;
				// 	        xpressCreditService.createXcData.minimumLoanAmount = xpressCreditService.createXcData.productDetails[0].minimumLoanAmount;
				// 	        xpressCreditService.createXcData.maximumLoanAmount = xpressCreditService.createXcData.productDetails[0].maximumLoanAmount;
				// 	        xpressCreditService.createXcData.maximumLoanAmount = xpressCreditService.createXcData.productDetails[0].maximumLoanAmount;
				// 	        xpressCreditService.createXcData.ProcessingFees = xpressCreditService.createXcData.productDetails[0].processFeeCalc;
				// 	        xpressCreditService.createXcData.rateCalculator = xpressCreditService.createXcData.productDetails[0].rate;
				// 	        xpressCreditService.createXcData.emiCalculator = xpressCreditService.createXcData.productDetails[0].emi;

				// 	        xpressCreditService.createXcData.selectedLoanAmout = xpressCreditService.createXcData.productDetails[0].maximumLoanAmount;
				// 	        xpressCreditService.createXcData.selectedTenure = xpressCreditService.createXcData.productDetails[0].maximumTenure;
				//   		} else {
				//   			xpressCreditService.createXcData.gstPercentage = xpressCreditService.createXcData.productDetails[1].gstPercentage;
				//   			xpressCreditService.createXcData.processingfeesPercentage = xpressCreditService.createXcData.productDetails[1].processingfeesPercentage;
				// 	        xpressCreditService.createXcData.minimumLoanTenure = xpressCreditService.createXcData.productDetails[1].minimumTenure;
				// 	        xpressCreditService.createXcData.maximumLoanTenure = xpressCreditService.createXcData.productDetails[1].maximumTenure;
				// 	        xpressCreditService.createXcData.minimumLoanAmount = xpressCreditService.createXcData.productDetails[1].minimumLoanAmount;
				// 	        xpressCreditService.createXcData.maximumLoanAmount = xpressCreditService.createXcData.productDetails[1].maximumLoanAmount;
				// 	        xpressCreditService.createXcData.maximumLoanAmount = xpressCreditService.createXcData.productDetails[1].maximumLoanAmount;
				// 	        xpressCreditService.createXcData.ProcessingFees = xpressCreditService.createXcData.productDetails[1].processFeeCalc;
				// 	        xpressCreditService.createXcData.rateCalculator = xpressCreditService.createXcData.productDetails[1].rate;
				// 	        xpressCreditService.createXcData.emiCalculator = xpressCreditService.createXcData.productDetails[1].emi;

				// 	        xpressCreditService.createXcData.selectedLoanAmout = xpressCreditService.createXcData.productDetails[1].maximumLoanAmount;
				// 	        xpressCreditService.createXcData.selectedTenure = xpressCreditService.createXcData.productDetails[1].maximumTenure;
				//   		}
				// 	}

				var obj = {
					"pageName": "loanOffer",
					"progress": "70%",
					"yonoRefNo": "",
					// "productDetails": xpressCreditService.createXcData.productDetails,
					"loanOffer": xcLoanofferVm.loanofferChecked
				}

				xpressCreditService.OmniCallResponse(obj).then(function(data) {
                    console.log("OmniCallResponse",obj,data)			
			        $state.go('menu.xcLoancalculator');
                },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });			
				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				if (xpressCreditService.createXcData.loanOfferSelected) {
					xcLoanofferVm.loanofferChecked = xpressCreditService.createXcData.loanOfferSelected;
					xcLoanofferVm.disabledNext = false;
				} else {
					xcLoanofferVm.disabledNext = true;
				}

				// if (xpressCreditService.createXcData.loanTypes.length <= 0) {
					xcLoanofferVm.loanDetails = xpressCreditService.createXcData.productDetails;
				// }
			});

			return this;
		}
]);


