'use strict';
angularApp.controller('xcSanctionappController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService) {
			
			var xcSanctionappVm = this;
			
			function initPage() {
				if (xpressCreditService.checkStatusData.conditionalDisplay == "pending") {
					xcSanctionappVm.sanctionedApplication = false; 
				} else {
					xcSanctionappVm.sanctionedApplication = true; 
				}

				if (xpressCreditService.checkStatusData.loanAmount) {
					xcSanctionappVm.amountValue = xpressCreditService.checkStatusData.loanAmount;
				} else {
					xcSanctionappVm.amountValue = 0;
				}
				
                xcSanctionappVm.referenceNumberValue = xpressCreditService.checkStatusData.referenceNumber;
                xcSanctionappVm.statusValue = xpressCreditService.checkStatusData.status;
                xcSanctionappVm.dateValue = xpressCreditService.checkStatusData.date;

                if (xcSanctionappVm.sanctionedApplication == true) {
	                var obj = {
						"type" : "GetXpressCreditTrackApp"
					}

					xpressCreditService.xpressWcmContent(obj).then(function(data) {
						xcSanctionappVm.wcmContent = data;
						if (xpressCreditService.checkStatusData.branchCode != "") {
							var params = {
				                "locality": xpressCreditService.checkStatusData.branchCode
				            }
							xpressCreditService.getBranchesForLocality(params).then(function(data) {
				                console.log("getBranchesForLocality",data)
				                xcSanctionappVm.addressDetails = data.branches[0].address;
				                xcSanctionappVm.city = data.branches[0].city;
				                xcSanctionappVm.pincode = data.branches[0].pincode;
				                xcSanctionappVm.state = data.branches[0].state;
				                xcSanctionappVm.phoneNumberDetails = data.branches[0].phoneNumber;
				            }, function(error) {
				                utilityService.showErrorMessage(error.responseMessage);
				            });
						}
	                },function(error) {
	                    if (xpressCreditService.checkStatusData.branchCode != "") {
							var params = {
				                "locality": xpressCreditService.checkStatusData.branchCode
				            }
							xpressCreditService.getBranchesForLocality(params).then(function(data) {
				                console.log("getBranchesForLocality",data)
				                xcSanctionappVm.addressDetails = data.branches[0].address;
				                xcSanctionappVm.phoneNumberDetails = data.branches[0].phoneNumber;
				            }, function(error) {
				                utilityService.showErrorMessage(error.responseMessage);
				            });
						}
	                });
					xcSanctionappVm.applicationStatus = "Sanctioned Application";
	                utilityService.setCsatJournies('xpressCredit');	
				} else {
					xcSanctionappVm.applicationStatus = "Pending Application";
				}
			};

			xcSanctionappVm.goToAO = function () {
				$state.go('menu.loans');
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
			});

			return this;
		}
]);


