'use strict';
angularApp.controller('xcUpdateaccountController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"xpressCreditService",
		"$cordovaBarcodeScanner",
		"customerInfoService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, xpressCreditService, $cordovaBarcodeScanner, customerInfoService) {
			
			var xcUpdateaccountVm = this;
			
			function initPage() {
				xcUpdateaccountVm.disabledNext = true;

				xcUpdateaccountVm.aadhar = true;
				xcUpdateaccountVm.validdoc = false;
			};

			xcUpdateaccountVm.goToAO = function () {
				xpressCreditService.initialValueStage();
				$state.go('menu.loans');
			}

			xcUpdateaccountVm.redirectToAadharDetails = function () {
				xpressCreditService.createXcData.isManuallyFillDetails = true;
				xpressCreditService.createXcData.aadharScanDetails.aadharnumber = "";
				xpressCreditService.createXcData.aadharScanDetails.title = "";
				xpressCreditService.createXcData.aadharScanDetails.firstname = "";
				xpressCreditService.createXcData.aadharScanDetails.middlename = "";
				xpressCreditService.createXcData.aadharScanDetails.lastname = "";
				xpressCreditService.createXcData.aadharScanDetails.gender = "";
				xpressCreditService.createXcData.aadharScanDetails.dob = "";
				xpressCreditService.createXcData.aadharScanDetails.yob = "";
				$state.go('menu.xcAadhardetails');
			}

			xcUpdateaccountVm.setSelected = function (value) {
				console.log(value)
				xcUpdateaccountVm.docType = value;
				xpressCreditService.createXcData.updateAccDocType = xcUpdateaccountVm.docType;

				xcUpdateaccountVm.disabledNext = false;
			}

			xcUpdateaccountVm.updateAccount = function (clickvalue) {
				if (clickvalue == "aadhar") {
					xcUpdateaccountVm.aadhar = true;
					xcUpdateaccountVm.validdoc = false;
				} else {
					xcUpdateaccountVm.validdoc = true;
					xcUpdateaccountVm.aadhar = false;
				}
			}

			xcUpdateaccountVm.getParameterByName = function(name, url) {
				if (!url) url = window.location.href;
				name = name.replace(/[\[\]]/g, "\\$&");
				var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
					results = regex.exec(url);
				if (!results) return null;
				if (!results[2]) return '';
				return decodeURIComponent(results[2].replace(/\+/g, " "));
			}

			xcUpdateaccountVm.goToQRCodeDetails = function () {
				$cordovaBarcodeScanner.scan().then(function (barcodeData) {
					console.log("barcodeData",barcodeData.text)
					// try{
					// 	if(!utilityService.isUndefined(barcodeData.text)){
							var xmlText = barcodeData.text;
			                var formattedXml = xmlText.replace("/?xml","?xml");
			                formattedXml = formattedXml.replace("xml?","?xml");
			                var x2js = new X2JS();
			                var jsonObj = x2js.xml_str2json(formattedXml);
			                if (utilityService.isUndefined(jsonObj)) {
			                    var title = '';
			                    var template = "{{'AADHAAR_POPUP'| translate}}";
			                    var onTap = '';
			                    var buttontext = "<b>OK</b>";
			                    utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext); 
			                } else {                    
			                	var jsonStr = JSON.stringify(jsonObj);
			                	console.log("jsonStrjsonStr",jsonStr);
			                	var nameFull = jsonObj.PrintLetterBarcodeData._name;
			                	// var splitName = nameFull.split(' ');
			                	var fName = "";
			                	var mName = "";
			                	var lName = "";

			                	var splittedName = nameFull.split(" ");
					            var splitLen = nameFull.split(" ").length;
					            var i;
					            var middleName = [];
					            if (splitLen === 1) {
					                fName = splittedName[0];
					            } else if (splitLen === 2) {
					                fName = splittedName[0];
					                lName = splittedName[1];
					            } else {
					                fName = splittedName[0];
					                for (i = 1; i < splitLen - 1; i++) {
					                    middleName[i] = splittedName[i];
					                }
					                mName = middleName.join(' ');
					                lName = splittedName[splitLen - 1];
					            }

			                	xpressCreditService.createXcData.aadharScanDetails.aadharnumber = jsonObj.PrintLetterBarcodeData._uid;
								xpressCreditService.createXcData.aadharScanDetails.title = "";
								xpressCreditService.createXcData.aadharScanDetails.firstname = fName;
								xpressCreditService.createXcData.aadharScanDetails.middlename = mName;
								xpressCreditService.createXcData.aadharScanDetails.lastname = lName;
								xpressCreditService.createXcData.aadharScanDetails.gender = jsonObj.PrintLetterBarcodeData._gender;
								xpressCreditService.createXcData.aadharScanDetails.dob = jsonObj.PrintLetterBarcodeData._dob;
								xpressCreditService.createXcData.aadharScanDetails.yob = jsonObj.PrintLetterBarcodeData._yob;
								$state.go('menu.xcAadhardetails');
			                }
			                xpressCreditService.createXcData.isManuallyFillDetails = false;
							// fTBeneficiaryService.customer.vpa = xcUpdateaccountVm.getParameterByName('pa', barcodeData.text);
							// var customerName = xcUpdateaccountVm.getParameterByName('pn', barcodeData.text);
							// fTBeneficiaryService.customer.nameData = customerName ? customerName : "";
							xcUpdateaccountVm.scannedImage = "img/xpresscredit/QR_Scan.svg"; //Add here scanned image.
							// xcUpdateaccountVm.goToNext();
					// 	}else{
					// 		xcUpdateaccountVm.scannedImage = "img/xpresscredit/QR_Scan.svg";
					// 	}
					// }catch(e){}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			};

			xcUpdateaccountVm.goToCancel = function () {
				if (customerInfoService.customer.isPanAvailable == "" || customerInfoService.customer.isPanAvailable == null) {
					$state.go('menu.xcPanupdate');
				} else {
					//$state.go('menu.xcPanupdate');
					if(xpressCreditService.createXcData.isKycUser == "N"){
							$state.go('menu.xcPanupdate');
						}
						else{
							$state.go('menu.xcCheckoff');
						}
					//$state.go('menu.xcCheckoff');
				}
			}

			xcUpdateaccountVm.goToConfirm = function () {
				xpressCreditService.createXcData.updateAccDocType = xcUpdateaccountVm.docType;
				xpressCreditService.createXcData.redirectFromKyc = true;
				if(xcUpdateaccountVm.validdoc == true){
					xpressCreditService.createXcData.kycDocType = "OVD";
				}
				else{
					xpressCreditService.createXcData.kycDocType = "AADHAR";
				}
				var isDocChanged = false;
				if(xpressCreditService.createXcData.updateAccDocType != xpressCreditService.retrieveData.updateAccDocType){
					isDocChanged = true;
				}
				var obj = {
					// "conditionBasedOmniCall" : {
						"pageName": "updateAccount",
						"progress": "10%",
						"yonoRefNo": "",
						"officeValidDoc": xcUpdateaccountVm.docType,
						"kycDocType": xpressCreditService.createXcData.kycDocType,
						"isDocChanged": isDocChanged
					// }
				}

				xpressCreditService.OmniCallResponse(obj).then(function(data) {
                    console.log("OmniCallResponse",obj,data)
					$state.go('menu.xcAddressDetails');
					if(xpressCreditService.createXcData.updateAccDocType != xpressCreditService.retrieveData.updateAccDocType){
						xpressCreditService.isDocument1Changed = true;
						xpressCreditService.isDocument2Changed = true;
					}
                },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });		
				
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				if (xpressCreditService.createXcData.updateAccDocType) {
					xcUpdateaccountVm.docType = xpressCreditService.createXcData.updateAccDocType;
					xcUpdateaccountVm.disabledNext = false;
					if(xpressCreditService.createXcData.updateAccDocType == "aadhar")
					{
						xcUpdateaccountVm.aadhar = true;
						xcUpdateaccountVm.validdoc = false;
					}
					else{
						xcUpdateaccountVm.aadhar = false;
						xcUpdateaccountVm.validdoc = true;
					}
				}
			});

			return this;
		}
]);


