angularApp.service('xpressCreditService',
	function ($q, utilityService, AdapterUtils, customerInfoService, fixedDepositService, $ionicPopup, $cordovaCamera, $state) {
		var XCservice = this;

		// XCservice.selectedYearsDetails = {
		// 	range: '',
		// 	indexYearId: ''
		// };
		XCservice.wcmContent = "";
		XCservice.interestCheckOffContent = "";

		XCservice.organizationTypeArray = [];
		XCservice.timeInOrganizationArray = [];
		XCservice.govermentTypeArray = [];
		XCservice.defenceTypeArray = [];
		XCservice.companyArray = [];
		XCservice.instituteArray = [];
		XCservice.psuTypeArray = [];
		XCservice.titleArray = [];
		XCservice.psuNameWithOwnershipCentralsArray = [];
		XCservice.psuNameWithOwnershipStatesArray = [];
		
		XCservice.eduQualiArray = [];
		XCservice.houseOwnerArray = [];
		XCservice.religionArray = [];
		XCservice.categoryArray = [];
		XCservice.physicalDisableArray = [];

		XCservice.emiTypeArray = [];

		XCservice.stateArray = [];
		XCservice.districtArray = [];
		XCservice.cityArray = [];

		XCservice.stateWorkArray = [];
		XCservice.districtWorkArray = [];
		XCservice.cityWorkArray = [];

		XCservice.districtpermanentArray = [];
		XCservice.citypermanentArray = [];

		XCservice.subDistArray = [];
		XCservice.villageArray = [];

		XCservice.subDistWorkArray = [];
		XCservice.villageWorkArray = [];

		XCservice.branchGpsArray = [];
		XCservice.branchHomeArray = [];
		XCservice.branchAreaArray = [];

		XCservice.isDocument1Changed = false;
		XCservice.isDocument2Changed = false;
		XCservice.statusXc = "";

		XCservice.knowMoreData = { 
			eligibilty : "",
			features : "",
			documentation : "",
			interest : "",
			loanDetails : [],
			selectedLoanAmout : ""
		}

		XCservice.checkStatusData = { 
			loanAmount : "",
			referenceNumber : "",
			status : "",
			date : "",
			branchCode : "",
			conditionalDisplay : ""
		}

		XCservice.createXcData = { 
			applicationId : "",
			finaltenure : "",
			finalAmount : "",
			isCheckOff : "",
			isKycUser : true,
			isPANAvail : "Y",
			netMonthlyIncome : "",
			isManuallyFillDetails : false,
			selectedYearsType : "",
			selectedMonthsType : "",
			organizationType : "",
			empTypeRadio : "",
			govOrgType : "",
			publicStateType : "",
			publicStatePSU : "",
			defenceType : "",
			forceNumber : "",
			regimentNumber : "",
			instituteName : "",
			instituteId : "",
			psuStateName : "",
			psuStateId : "",
			companyName : "",
			companyId : "",
			isCurrentDiffAddr : true,
			isCibil : false,
			totalOfAllAssets : "",
			loanType : "",
			gpsSelectOption : "",
			branchName : "",
			branchAddress : "",
			branchCode : "",
			panNumber : "",
			redirectFromKyc : false,
			redirectFromPAN : false,
			emi : [],
			emiTotalCost : "",
			permanentAddress : "",
			uploadDoc : [],
			residentAddress : {
				addressLine1 : "",
				addressLine2 : "",
				addressLine3 : "",
				pincode : "",
				cityText : "",
				cityCode : "",
				stateText : "",
				stateCode : "",
				districtText : "",
				districtCode : "",
				subDistrictText : "",
				villageTownText : ""
			},
			residentPermanentAddress : {
				addressLine1 : "",
				addressLine2 : "",
				addressLine3 : "",
				pincode : "",
				cityText : "",
				cityCode : "",
				stateText : "",
				stateCode : "",
				districtText : "",
				districtCode : "",
				subDistrictText : "",
				villageTownText : ""
			},
			additionalAddress : {
				motherMaidenName : "",
				eduQualification : "",
				houseOwner : "",
				grossIncome : "",
				religion : "",
				category : "",
				physicalDisability : ""
			},
			workAddress : {
				addressLine1 : "",
				addressLine2 : "",
				pincode : "",
				cityText : "",
				cityCode : "",
				stateText : "",
				stateCode : "",
				districtText : "",
				districtCode : "",
				subDistrictText : "",
				villageTownText : "",
				officeContactNo : "",
				remainingService : "",
				addressOfDdo : "",
				designationOfDdo : "",
				organisationWork : ""
			},
			eligibilityEmiFlag : "",
			assests : [
				{
					"assetCategory": "IA",
					"assetType": "HOUSE",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "IA",
					"assetType": "FLAT",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "IA",
					"assetType": "SHOP",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "IA",
					"assetType": "PLOT",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "IA",
					"assetType": "OTHERS",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "MA",
					"assetType": "FOURWL",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "MA",
					"assetType": "TWOWL",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "LA",
					"assetType": "BD",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "LA",
					"assetType": "INV",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "LA",
					"assetType": "OTHERS",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				}
			],
			aadharScanDetails : {
				aadharnumber : "",
				title : "",
				firstname : "",
				middlename : "",
				lastname : "",
				gender : "",
				dob : "",
				yob : ""
			},
			liable : {
				employer : "",
				mortgaged : "",
				loansother : "",
				frndrelative : "",
				others : "",
				Sperelation : "",
				totalAmountValue : ""
			},
			updateAccDocType : "",
			loanOfferSelected : "",
			productDetails : [],
			minimumLoanAmount : "",
			maximumLoanAmount : "",
			minimumLoanTenure : "",
			maximumLoanTenure : "",
			gstPercentage : "",
			processingfeesPercentage : "",
			ProcessingFees : "",
			rateCalculator : "",
			emiCalculator : "",
			selectedLoanAmout : "",
			selectedTenure : "",
			kycDocType : "",
			isPanReq : "Y"
		};
		XCservice.retrieveData = { 
			applicationId : "",
			finaltenure : "",
			finalAmount : "",
			isCheckOff : "",
			isKycUser : true,
			isPANAvail : "Y",
			netMonthlyIncome : "",
			isManuallyFillDetails : false,
			selectedYearsType : "",
			selectedMonthsType : "",
			organizationType : "",
			empTypeRadio : "",
			govOrgType : "",
			publicStateType : "",
			publicStatePSU : "",
			defenceType : "",
			forceNumber : "",
			regimentNumber : "",
			instituteName : "",
			instituteId : "",
			psuStateName : "",
			psuStateId : "",
			companyName : "",
			companyId : "",
			isCurrentDiffAddr : true,
			isCibil : false,
			totalOfAllAssets : "",
			loanType : "",
			gpsSelectOption : "",
			branchName : "",
			branchAddress : "",
			branchCode : "",
			panNumber : "",
			redirectFromKyc : false,
			redirectFromPAN : false,
			emi : [],
			emiTotalCost : "",
			permanentAddress : "",
			uploadDoc : [],
			residentAddress : {
				addressLine1 : "",
				addressLine2 : "",
				addressLine3 : "",
				pincode : "",
				cityText : "",
				cityCode : "",
				stateText : "",
				stateCode : "",
				districtText : "",
				districtCode : "",
				subDistrictText : "",
				villageTownText : ""
			},
			residentPermanentAddress : {
				addressLine1 : "",
				addressLine2 : "",
				addressLine3 : "",
				pincode : "",
				cityText : "",
				cityCode : "",
				stateText : "",
				stateCode : "",
				districtText : "",
				districtCode : "",
				subDistrictText : "",
				villageTownText : ""
			},
			additionalAddress : {
				motherMaidenName : "",
				eduQualification : "",
				houseOwner : "",
				grossIncome : "",
				religion : "",
				category : "",
				physicalDisability : ""
			},
			workAddress : {
				addressLine1 : "",
				addressLine2 : "",
				pincode : "",
				cityText : "",
				cityCode : "",
				stateText : "",
				stateCode : "",
				districtText : "",
				districtCode : "",
				subDistrictText : "",
				villageTownText : "",
				officeContactNo : "",
				remainingService : "",
				addressOfDdo : "",
				designationOfDdo : "",
				organisationWork : ""
			},
			eligibilityEmiFlag : "",
			assests : [
				{
					"assetCategory": "IA",
					"assetType": "HOUSE",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "IA",
					"assetType": "FLAT",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "IA",
					"assetType": "SHOP",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "IA",
					"assetType": "PLOT",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "IA",
					"assetType": "OTHERS",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "MA",
					"assetType": "FOURWL",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "MA",
					"assetType": "TWOWL",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "LA",
					"assetType": "BD",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "LA",
					"assetType": "INV",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				},{
					"assetCategory": "LA",
					"assetType": "OTHERS",
					"hypothicatedFlag": false,
					"estimatedMarketValue": "",
					"registrationNo": "",
					"mortgagedFlag": false,
					"presentMarketValue": "",
					"addressLine1": "",
					"addressLine2": "",
					"pincode": "",
					"bankDeposit": "",
					"investments": "",
					"others": ""
				}
			],
			aadharScanDetails : {
				aadharnumber : "",
				title : "",
				firstname : "",
				middlename : "",
				lastname : "",
				gender : "",
				dob : "",
				yob : ""
			},
			liable : {
				employer : "",
				mortgaged : "",
				loansother : "",
				frndrelative : "",
				others : "",
				Sperelation : "",
				totalAmountValue : ""
			},
			updateAccDocType : "",
			loanOfferSelected : "",
			productDetails : [],
			minimumLoanAmount : "",
			maximumLoanAmount : "",
			minimumLoanTenure : "",
			maximumLoanTenure : "",
			gstPercentage : "",
			processingfeesPercentage : "",
			ProcessingFees : "",
			rateCalculator : "",
			emiCalculator : "",
			selectedLoanAmout : "",
			selectedTenure : "",
			kycDocType : ""
		};
		XCservice.initialValueStage = function() {
			XCservice.createXcData = { 
				applicationId : "",
				finaltenure : "",
				finalAmount : "",
				isCheckOff : "",
				isKycUser : true,
				isPANAvail : "Y",
				netMonthlyIncome : "",
				isManuallyFillDetails : false,
				selectedYearsType : "",
				selectedMonthsType : "",
				organizationType : "",
				empTypeRadio : "",
				govOrgType : "",
				publicStateType : "",
				publicStatePSU : "",
				defenceType : "",
				forceNumber : "",
				regimentNumber : "",
				instituteName : "",
				instituteId : "",
				psuStateName : "",
				psuStateId : "",
				companyName : "",
				companyId : "",
				isCurrentDiffAddr : true,
				isCibil : false,
				totalOfAllAssets : "",
				loanType : "",
				gpsSelectOption : "",
				branchName : "",
				branchAddress : "",
				branchCode : "",
				panNumber : "",
				redirectFromKyc : false,
				redirectFromPAN : false,
				emi : [],
				emiTotalCost : "",
				permanentAddress : "",
				uploadDoc : [],
				residentAddress : {
					addressLine1 : "",
					addressLine2 : "",
					addressLine3 : "",
					pincode : "",
					cityText : "",
					cityCode : "",
					stateText : "",
					stateCode : "",
					districtText : "",
					districtCode : "",
					subDistrictText : "",
					villageTownText : ""
				},
				residentPermanentAddress : {
					addressLine1 : "",
					addressLine2 : "",
					addressLine3 : "",
					pincode : "",
					cityText : "",
					cityCode : "",
					stateText : "",
					stateCode : "",
					districtText : "",
					districtCode : "",
					subDistrictText : "",
					villageTownText : ""
				},
				additionalAddress : {
					motherMaidenName : "",
					eduQualification : "",
					houseOwner : "",
					grossIncome : "",
					religion : "",
					category : "",
					physicalDisability : ""
				},
				workAddress : {
					addressLine1 : "",
					addressLine2 : "",
					pincode : "",
					cityText : "",
					cityCode : "",
					stateText : "",
					stateCode : "",
					districtText : "",
					districtCode : "",
					subDistrictText : "",
					villageTownText : "",
					officeContactNo : "",
					remainingService : "",
					addressOfDdo : "",
					designationOfDdo : "",
					organisationWork : ""
				},
				eligibilityEmiFlag : "",
				assests : [
					{
						"assetCategory": "IA",
						"assetType": "HOUSE",
						"hypothicatedFlag": false,
						"estimatedMarketValue": "",
						"registrationNo": "",
						"mortgagedFlag": false,
						"presentMarketValue": "",
						"addressLine1": "",
						"addressLine2": "",
						"pincode": "",
						"bankDeposit": "",
						"investments": "",
						"others": ""
					},{
						"assetCategory": "IA",
						"assetType": "FLAT",
						"hypothicatedFlag": false,
						"estimatedMarketValue": "",
						"registrationNo": "",
						"mortgagedFlag": false,
						"presentMarketValue": "",
						"addressLine1": "",
						"addressLine2": "",
						"pincode": "",
						"bankDeposit": "",
						"investments": "",
						"others": ""
					},{
						"assetCategory": "IA",
						"assetType": "SHOP",
						"hypothicatedFlag": false,
						"estimatedMarketValue": "",
						"registrationNo": "",
						"mortgagedFlag": false,
						"presentMarketValue": "",
						"addressLine1": "",
						"addressLine2": "",
						"pincode": "",
						"bankDeposit": "",
						"investments": "",
						"others": ""
					},{
						"assetCategory": "IA",
						"assetType": "PLOT",
						"hypothicatedFlag": false,
						"estimatedMarketValue": "",
						"registrationNo": "",
						"mortgagedFlag": false,
						"presentMarketValue": "",
						"addressLine1": "",
						"addressLine2": "",
						"pincode": "",
						"bankDeposit": "",
						"investments": "",
						"others": ""
					},{
						"assetCategory": "IA",
						"assetType": "OTHERS",
						"hypothicatedFlag": false,
						"estimatedMarketValue": "",
						"registrationNo": "",
						"mortgagedFlag": false,
						"presentMarketValue": "",
						"addressLine1": "",
						"addressLine2": "",
						"pincode": "",
						"bankDeposit": "",
						"investments": "",
						"others": ""
					},{
						"assetCategory": "MA",
						"assetType": "FOURWL",
						"hypothicatedFlag": false,
						"estimatedMarketValue": "",
						"registrationNo": "",
						"mortgagedFlag": false,
						"presentMarketValue": "",
						"addressLine1": "",
						"addressLine2": "",
						"pincode": "",
						"bankDeposit": "",
						"investments": "",
						"others": ""
					},{
						"assetCategory": "MA",
						"assetType": "TWOWL",
						"hypothicatedFlag": false,
						"estimatedMarketValue": "",
						"registrationNo": "",
						"mortgagedFlag": false,
						"presentMarketValue": "",
						"addressLine1": "",
						"addressLine2": "",
						"pincode": "",
						"bankDeposit": "",
						"investments": "",
						"others": ""
					},{
						"assetCategory": "LA",
						"assetType": "BD",
						"hypothicatedFlag": false,
						"estimatedMarketValue": "",
						"registrationNo": "",
						"mortgagedFlag": false,
						"presentMarketValue": "",
						"addressLine1": "",
						"addressLine2": "",
						"pincode": "",
						"bankDeposit": "",
						"investments": "",
						"others": ""
					},{
						"assetCategory": "LA",
						"assetType": "INV",
						"hypothicatedFlag": false,
						"estimatedMarketValue": "",
						"registrationNo": "",
						"mortgagedFlag": false,
						"presentMarketValue": "",
						"addressLine1": "",
						"addressLine2": "",
						"pincode": "",
						"bankDeposit": "",
						"investments": "",
						"others": ""
					},{
						"assetCategory": "LA",
						"assetType": "OTHERS",
						"hypothicatedFlag": false,
						"estimatedMarketValue": "",
						"registrationNo": "",
						"mortgagedFlag": false,
						"presentMarketValue": "",
						"addressLine1": "",
						"addressLine2": "",
						"pincode": "",
						"bankDeposit": "",
						"investments": "",
						"others": ""
					}
				],
				aadharScanDetails : {
					aadharnumber : "",
					title : "",
					firstname : "",
					middlename : "",
					lastname : "",
					gender : "",
					dob : "",
					yob : ""
				},
				liable : {
					employer : "",
					mortgaged : "",
					loansother : "",
					frndrelative : "",
					others : "",
					Sperelation : "",
					totalAmountValue : ""
				},
				updateAccDocType : "",
				loanOfferSelected : "",
				productDetails : [],
				minimumLoanAmount : "",
				maximumLoanAmount : "",
				minimumLoanTenure : "",
				maximumLoanTenure : "",
				gstPercentage : "",
				processingfeesPercentage : "",
				ProcessingFees : "",
				rateCalculator : "",
				emiCalculator : "",
				selectedLoanAmout : "",
				selectedTenure : "",
				kycDocType : "",
				isPanReq : "Y"
			};
		}

		XCservice.getnewImage = function() {
			var options = {
				quality: 50,
				destinationType: Camera.DestinationType.DATA_URL,
				sourceType: Camera.PictureSourceType.CAMERA,
				allowEdit: true,
				encodingType: Camera.EncodingType.JPEG,
				popoverOptions: CameraPopoverOptions,
				saveToPhotoAlbum: false,
				correctOrientation:true
			}; 

           	var q =  $q.defer();
            $cordovaCamera.getPicture(options).then(function(imageData) {
            	q.resolve( "data:image/jpeg;base64," + imageData)
            }, function(err) {
            	q.reject("error");
            });
            return q.promise;
		}

		XCservice.getImageFromGallery = function() {
			var options = {
				quality: 50,
				destinationType: Camera.DestinationType.DATA_URL,
				sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
				mediaType: Camera.MediaType.ALLMEDIA,
				allowEdit: true,
				popoverOptions: CameraPopoverOptions,
				correctOrientation:true
			}; 

           	var q =  $q.defer();
            $cordovaCamera.getPicture(options).then(function(imageData) {

            	// var path = "file://" + imageData;
            	
				// getFileContentAsBase64(path, function(base64Image) {
				// 	if(utilityService.isIOSPlatform()){
				// 		q.resolve( "data:image/jpeg;base64," + base64Image);
				// 	}else{
				// 		q.resolve(base64Image);
				// 	}
				// });
				if (utilityService.isIOSPlatform()) {
					q.resolve( "data:image/jpeg;base64," + imageData);
				} else {
					var path = "file://" + imageData;
					getFileContentAsBase64(path,function(base64Image){
						q.resolve(base64Image)
					});
				}
				
				
            }, function(err) {
            	q.reject("error");
            });
            return q.promise;
		}

		function getFileContentAsBase64(path,callback) {

			window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
			    window.resolveLocalFileSystemURL(path, gotFile, fail);
			});

		    function fail(e) {
		        // alert('Cannot found requested file');
		    }

		    function gotFile(fileEntry) {
	           	fileEntry.file(function(file) {

	              	var reader = new FileReader();

	              	reader.onloadend = function(e) {
	                  	var content = this.result;
	                  	callback(content);
	              	};

	              	reader.readAsDataURL(file);
	           	});
		    }
		}

		XCservice.inChromeBrowser = function (url) {
			cordova.ThemeableBrowser.open(url, '_system', {
			});
		};

		XCservice.loanDataFetch = function(data, statusCheck) {

			if (statusCheck == 2) {
				var dataMaster = data.conditionBasedMasterCall;
			} else {
				var dataMaster = data;
			}

			XCservice.organizationTypeArray = dataMaster.master.organisationTpyes;
            XCservice.timeInOrganizationArray = dataMaster.master.tenures;
            XCservice.govermentTypeArray = dataMaster.master.govOrgTypes;
            XCservice.defenceTypeArray = dataMaster.master.defenseEstTypes;
            XCservice.psuTypeArray = dataMaster.master.psuTypes;
            XCservice.titleArray = dataMaster.master.titles;

            XCservice.stateArray = dataMaster.master.states;
            XCservice.stateWorkArray = dataMaster.master.states;
            
            XCservice.eduQualiArray = dataMaster.master.qualifications;
            XCservice.houseOwnerArray = dataMaster.master.houseOwnerships;
            XCservice.religionArray = dataMaster.master.religions;
            XCservice.categoryArray = dataMaster.master.categories;
            XCservice.companyArray = dataMaster.master.companies;
            XCservice.instituteArray = dataMaster.master.institutions;
            XCservice.physicalDisableArray = dataMaster.master.physicalDisabilities;

            XCservice.psuNameWithOwnershipCentralsArray = dataMaster.master.psuNameWithOwnershipCentrals;
            XCservice.psuNameWithOwnershipStatesArray = dataMaster.master.psuNameWithOwnershipStates;

            XCservice.emiTypeArray = dataMaster.master.emiTypes;

            if (statusCheck == 2) {
            	XCservice.createXcData.netMonthlyIncome = data.netMonthlyIncome;
            	// XCservice.createXcData.selectedYearsType = data.timeInCurrentOrg;
            	XCservice.createXcData.selectedYearsType = data.timeInOrgYears;
            	XCservice.createXcData.selectedMonthsType = data.timeInOrgMonths;
            	XCservice.createXcData.empTypeRadio = data.employmentType;
            	XCservice.createXcData.organizationType = data.orgTypeText;
            	XCservice.createXcData.govOrgType = data.typeOfOrgText;
            	XCservice.createXcData.defenceType = data.typeOfDefenceText;
            	XCservice.createXcData.publicStateType = data.typeOfPsuText;

            	XCservice.createXcData.publicStatePSU = data.psuName;
            	XCservice.createXcData.psuStateName = data.psuNameText;
            	XCservice.createXcData.psuStateId = data.psuNameId;
            	XCservice.createXcData.instituteName = data.institutionText;
            	XCservice.createXcData.instituteId = data.institutionId;
            	XCservice.createXcData.companyName = data.companyText;
            	XCservice.createXcData.companyId = data.companyId;
            	XCservice.createXcData.forceNumber = data.forceNo;
            	XCservice.createXcData.regimentNumber = data.regimentNo;
            	
            	if (data.emi) {
            		XCservice.createXcData.emi = data.emi;
            	}
            	
            	XCservice.createXcData.emiTotalCost = data.totalExistingEMI;

            	XCservice.createXcData.isCheckOff = String(data.checkOff);
            	
            	XCservice.createXcData.isCurrentDiffAddr = data.currentAddres;
            	XCservice.createXcData.isCibil = Boolean(data.cibil);
            	
            	if (data.address) {
            		for (var i=0; i < data.address.length; i++) {
            			if (data.address[i].addressType == "CURRES") {
            				XCservice.createXcData.residentAddress = data.address[i];
            			} 

            			if (data.address[i].addressType == "OFFICE") {
            				XCservice.createXcData.workAddress = data.address[i];
            			}

            			if (data.address[i].addressType == "PERMNENT") {
            				XCservice.createXcData.residentPermanentAddress = data.address[i];
            			}
            		}
            	}

            	XCservice.createXcData.isKycUser = data.kycUser;
				XCservice.createXcData.isPANAvail = data.kycUser;

            	XCservice.createXcData.additionalAddress.motherMaidenName = data.maidenName;
            	XCservice.createXcData.additionalAddress.eduQualification = data.qualificationText;
            	XCservice.createXcData.additionalAddress.houseOwner = data.ownerShipText;
            	XCservice.createXcData.additionalAddress.grossIncome = data.grossMonthlyIncome;
            	XCservice.createXcData.additionalAddress.religion = data.religionText;
            	XCservice.createXcData.additionalAddress.category = data.categoryText;
            	XCservice.createXcData.additionalAddress.physicalDisability = data.phyDisabilityText;

            	if (data.assetDeclarations.length) {
            		XCservice.createXcData.assests = data.assetDeclarations;
            	}

            	XCservice.createXcData.totalOfAllAssets = data.assetDecTotalAmount;

            	if (data.liabilityDetails) {
	            	XCservice.createXcData.liable.employer = data.liabilityDetails[0].empBorrowingAmount;
	            	XCservice.createXcData.liable.mortgaged = data.liabilityDetails[0].mortgagedAmount;
	            	XCservice.createXcData.liable.loansother = data.liabilityDetails[0].otherLoansAmount;
	            	XCservice.createXcData.liable.frndrelative = data.liabilityDetails[0].friOrRealAmount;
	            	XCservice.createXcData.liable.others = data.liabilityDetails[0].othersRelations;
	            	XCservice.createXcData.liable.Sperelation = data.liabilityDetails[0].relationship;
	            }

            	XCservice.createXcData.liable.totalAmountValue = data.totalAmount;

				XCservice.createXcData.minimumLoanAmount = data.loanCalMinAmount;
				XCservice.createXcData.maximumLoanAmount = data.loanCalMaxAmount;
				XCservice.createXcData.minimumLoanTenure = data.loanCalMinTenure;
				XCservice.createXcData.maximumLoanTenure = data.loanCalMaxTenure;
				XCservice.createXcData.selectedLoanAmout = data.loanCalAmount;
				XCservice.createXcData.selectedTenure = data.loanCalDuration;
				XCservice.createXcData.processingfees = data.loanCalProcessingFee;
				XCservice.createXcData.rateCalculator = data.loanCalInterest;
				XCservice.createXcData.emiCalculator = data.loanCalEmiAmount;
				
				XCservice.createXcData.processingfeesPercentage = data.processingFeesPercentage;
				XCservice.createXcData.gstPercentage = data.gstPercentage;

				if (data.productDetails) {
					XCservice.createXcData.productDetails = data.productDetails;
				}

				XCservice.createXcData.aadharScanDetails.aadharnumber = data.aadhaarValtNo;
				XCservice.createXcData.aadharScanDetails.title = data.title;
				XCservice.createXcData.aadharScanDetails.firstname = data.firstName;
				XCservice.createXcData.aadharScanDetails.middlename = data.middleName;
				XCservice.createXcData.aadharScanDetails.lastname = data.lastName;
				XCservice.createXcData.aadharScanDetails.gender = data.gender;
				XCservice.createXcData.aadharScanDetails.dob = data.dob;

				XCservice.createXcData.loanOfferSelected = data.loanOffer;

				XCservice.createXcData.gpsSelectOption = data.branchSelecter;
				XCservice.createXcData.branchName = data.branchName;
				XCservice.createXcData.branchAddress = data.branchAddress;
				XCservice.createXcData.branchCode = data.branchCode;
				XCservice.createXcData.panNumber = data.panNo;

				XCservice.createXcData.updateAccDocType = data.officeValidDoc;
				XCservice.createXcData.isPanReq = data.isPanReq;
				XCservice.createXcData.uploadDoc = data.uploadDoc;
				XCservice.retrieveData = angular.copy(XCservice.createXcData);
            	if (data.pageName) {
	            	if (data.pageName == "incomeAndEmploymentDetails") {
	            		$state.go('menu.xcCreate');
	            	} else if (data.pageName == "checkOff") {
	            		$state.go('menu.xcCheckoff');
	            	} else if (data.pageName == "residentialDetails") {
	            		$state.go('menu.xcAddressDetails');
	            	} else if (data.pageName == "additionalDetails") {
	            		$state.go('menu.xcAdditionalDetails');
	            	} else if (data.pageName == "workDetails") {
	            		$state.go('menu.xcWorkDetails');
	            	} else if (data.pageName == "declarationOnAssets") {
	            		$state.go('menu.xcAssets');
	            	} else if (data.pageName == "declarationOnLiabilities") {
	            		$state.go('menu.xcLiable');
	            	} else if (data.pageName == "loanOffer") {
	            		$state.go('menu.xcLoanoffer');
	            	} else if (data.pageName == "loanCalculator") {
	            		$state.go('menu.xcLoancalculator');
	            	} else if (data.pageName == "branchSelect") {
	            		$state.go('menu.xcBranchselect');
	            	} else if (data.pageName == "uploadDocument") {
	            		$state.go('menu.xcDocupload');
	            	} else if (data.pageName == "panDetails") {
	            		$state.go('menu.xcPanupdate');
	            	} else if (data.pageName == "updateAccount") {
	            		$state.go('menu.xcUpdateaccount');
	            	} else if (data.pageName == "aadharDetails") {
	            		$state.go('menu.xcAadhardetails');
	            	} 
            	} else {
            		$state.go('menu.xcCreate');
            	}
            }

		};

		XCservice.setButtonText = function(text) {
		    buttonText = text;
		};

		XCservice.getXpressMaster = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getXpressMaster",{},true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.xpressCreditKycCompliance = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/xpressCreditKycCompliance",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.xpressCreditKycCompliance = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/xpressCreditKycCompliance",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.getBeauroScoreValidation = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getBeauroScoreValidation",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.afterBeauroScoreValidation = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/afterBeauroScoreValidation",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.getBranchesForLocality = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ExistingCustomerAccountOpeningAdapter/getBranchesForLocality", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		XCservice.createXpressCredit = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/createXpressCredit",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.getEMICalcValues = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getEmiCalcValues",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.fetchLocationByPinCode = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ExistingCustomerAccountOpeningAdapter/fetchLocationByPinCode",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};


		XCservice.fetchLocationByPinCodeInsta = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/InstaAccountOpeningAdapter/fetchLocationByPinCode",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.fetchSubDistrictMasterByDistCode = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/fetchSubDistrictMasterByDistCode",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.getDistrictSubDistrict = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getDistrictSubDistrict",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.fetchVillageMasterByStateDistSubDist = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/fetchVillageMasterByStateDistSubDist",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.customerDemographicDetails = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/customerDemographicDetails",{},true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.checkApplicationAlreadyApplied = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/checkApplicationAlreadyApplied",{},true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.OmniCallResponse = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/omniCallResponse",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.initialEligibilityService = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/initialEligibilityService",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.retrieveApplication = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/retrieveApplication",{},true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		XCservice.xpressWcmContent = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getTnC",obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		XCservice.uploadDocService = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/uploadDocService",obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		XCservice.getXpressCreditDetails = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getXpressCreditDetails", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		XCservice.getXpressCreditKnowMoreDetails = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getXpressCreditKnowMoreDetails", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		XCservice.xpressDownloadDocument = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/xpressDownloadCheckOff",{}, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		XCservice.xpressEmailReceipt = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/xpressEmailCheckOff",{}, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		XCservice.deleteDocument = function(docType) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/deleteUploadDocCloudant",docType,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		return XCservice;
	});  
