'use strict';

angularApp.service('landingYCService',
    function($q, AdapterUtils, constantConfig) {
        var landingYCService = this;

        landingYCService.locateByGPS = [];

        landingYCService.getProductFeatures = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getProductFeatures, true).then(

                function(response) {
                    q.resolve(response.data.productFeatures);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        landingYCService.getLoggedUserDetails = function() {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getCustomerInfo, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return landingYCService;
    });
