'use strict';

angularApp.controller('trnDetailYCController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "utilityService",
    "$ionicPopup",
    "$filter",
    "$stateParams",
    "$ionicHistory",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        utilityService,
        $ionicPopup,
        $filter,
        $stateParams, 
        $ionicHistory

    ) {

        var trnDetailYCVm = this;
        trnDetailYCVm.isChallenged = false;
        trnDetailYCVm.showBack = true;
        trnDetailYCVm.showNext = true;
        trnDetailYCVm.allData = {};

        function initPage() {
            
            trnDetailYCVm.termsObj = $stateParams.termsObj;
        
        }

        //function to del transactions

        

        trnDetailYCVm.deletTransaction = function (_data) {
            if(_data.docType == "Merchant POS-Cash"){               
                var upgradeInstaVm = $ionicPopup.confirm({
				template: '<p><div class=""><img class="ycpopupStyleM5" src="img/yc_Group.svg"</div> <div class ="ycwidth90" translate="YC_POPUP" ></div>   </p>',
				cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogYC',
				scope: $scope,
				buttons: [{
					text: 'No',
					type: 'button-negative',
					onTap: function (e) {
						upgradeInstaVm.close();
						e.preventDefault();
					}
				},
				{
					text: 'Yes',
					type: 'button-positive',
					onTap: function (e) {
						upgradeInstaVm.close();
						e.preventDefault();
                        utilityService.showSpinner();
                        //_data.docType = "YONO_CASH_POS";
                        requestYCService.cancleTransaction(_data).then(function (data) {
                            if (data) {
                                utilityService.hideSpinner();
                                $state.go('menu.yonoCash');
                            }

                        }, function (error) {
                            utilityService.hideSpinner();
                            utilityService.showErrorMessage(error.responseMessage);
                            //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                        });
						
					}
				}]
			});




            }else if(_data.docType == "CSP"){
               
                var upgradeInstaVm = $ionicPopup.confirm({
				template: '<p><div class=""><img class="ycpopupStyleM5" src="img/yc_Group.svg"</div> <div class ="ycwidth90" translate="YC_POPUP" ></div>   </p>',
				cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogYC',
				scope: $scope,
				buttons: [{
					text: 'No',
					type: 'button-negative',
					onTap: function (e) {
						upgradeInstaVm.close();
						e.preventDefault();
					}
				},
				{
					text: 'Yes',
					type: 'button-positive',
					onTap: function (e) {
						upgradeInstaVm.close();
						e.preventDefault();
                        utilityService.showSpinner();
                        //_data.docType = "YONO_CASH_CSP";
                        requestYCService.cancleTransaction(_data).then(function (data) {
                            if (data) {
                                utilityService.hideSpinner();
                                $state.go('menu.yonoCash');
                            }

                        }, function (error) {
                            utilityService.hideSpinner();
                            utilityService.showErrorMessage(error.responseMessage);
                            //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                        });
						
					}
				}]
			});


            }else if(_data.docType == "ATM"){
               
                var upgradeInstaVm = $ionicPopup.confirm({
				template: '<p><div class=""><img class="ycpopupStyleM5" src="img/yc_Group.svg"</div> <div class ="ycwidth90" translate="YC_POPUP" ></div>   </p>',
				cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogYC',
				scope: $scope,
				buttons: [{
					text: 'No',
					type: 'button-negative',
					onTap: function (e) {
						upgradeInstaVm.close();
						e.preventDefault();
					}
				},
				{
					text: 'Yes',
					type: 'button-positive',
					onTap: function (e) {
						upgradeInstaVm.close();
						e.preventDefault();
                        utilityService.showSpinner();
                        //_data.docType = "YONO_CASH_TRAN";
                        requestYCService.cancleTransaction(_data).then(function (data) {
                            if (data) {
                                utilityService.hideSpinner();
                                $state.go('menu.yonoCash');
                            }

                        }, function (error) {
                            utilityService.hideSpinner();
                            utilityService.showErrorMessage(error.responseMessage);
                            //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                        });
						
					}
				}]
			});

            }else if(_data.docType == "Merchant POS-Shopping"){
               
                var upgradeInstaVm = $ionicPopup.confirm({
				template: '<p><div class=""><img class="ycpopupStyleM5" src="img/yc_Group.svg"</div> <div class ="ycwidth90" translate="YC_POPUP_SH" ></div>   </p>',
				cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogYC',
				scope: $scope,
				buttons: [{
					text: 'No',
					type: 'button-negative',
					onTap: function (e) {
						upgradeInstaVm.close();
						e.preventDefault();
					}
				},
				{
					text: 'Yes',
					type: 'button-positive',
					onTap: function (e) {
						upgradeInstaVm.close();
						e.preventDefault();
                        utilityService.showSpinner();
                        //_data.docType = "YONO_SHOPPING";
                        requestYCService.cancleTransaction(_data).then(function (data) {
                            if (data) {
                                utilityService.hideSpinner();
                                $state.go('menu.yonoCash');
                            }

                        }, function (error) {
                            utilityService.hideSpinner();
                            utilityService.showErrorMessage(error.responseMessage);
                            //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                        });
						
					}
				}]
			});
            }

            

        }

        trnDetailYCVm.goBack = function () {
            requestYCService.fromDetail = 'yes';
            $ionicHistory.goBack(-1);
        }


     
        //Function for close view
        trnDetailYCVm.closeView = function () {
            $state.go('menu.homeScreen');
        }


        //onclick of home button
        trnDetailYCVm.homeClick = function () {
            $state.go('menu.homeScreen')
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
