/* Allow Only Alpha character with this special character "_,@.&-|\s"  */
angularApp.directive('allowAlphanumericSpChar', function () {
    return {
        require: 'ngModel',
        link: function (scope, element, attr, ngModelCtrl) {
            function fromUser(text) {
                
            	   if (text) {
                        var reg = /^[a-zA-Z0-9@]*$/;
                        if (!text.match(reg)) {
                            var transformedInput = text.substring(0, text.length-1);
                            ngModelCtrl.$setViewValue(transformedInput);
                            ngModelCtrl.$render();
                            return transformedInput;
                        }                
                   }  
                return text;
            }   
           ngModelCtrl.$parsers.push(fromUser);
        }
    };
});
