angularApp.filter('convertAmount', function () {
    return function (amt) {
        var ext = '';
        var ind = 0;
        var result = '';
        var decIndex = 0;
        var addDec = false;

        if (amt > 9999999) {
            ext = 'C';
            addDec = ((amt / 10000000).toString().indexOf('.') != -1)
            amt = amt.toString();
            amt.split('');
            ind = amt.length - 7;
        } else if (amt > 99999) {
            ext = 'L';
            addDec = ((amt / 100000).toString().indexOf('.') != -1)
            amt = amt.toString();
            amt.split('');
            ind = amt.length - 5;
        } else if (amt > 999) {
            ext = 'T';
            addDec = ((amt / 1000).toString().indexOf('.') != -1)
            amt = amt.toString();
            amt.split('');
            ind = amt.length - 3;
        } else {
            return '';
        }

        for (var index = 0; index < ind; index++) {
            result += amt[index];
            decIndex = index;
        }
        if (addDec) {
            result += '.';
            for (var index1 = decIndex + 1; index1 <= decIndex + 2; index1++) {
                result += amt[index1];
            }
        }
        result += ext;
        return result;
    }
});

angularApp.filter('convertAmountFull', function () {
    return function (amt) {
        var ext = '';
        var ind = 0;
        var result = '';
        var decIndex = 0;
        var addDec = false;

        if (amt > 9999999) {
            ext = ' Crore';
            addDec = ((amt / 10000000).toString().indexOf('.') != -1)
            amt = amt.toString();
            amt.split('');
            ind = amt.length - 7;
        } else if (amt > 99999) {
            ext = ' Lakh';
            addDec = ((amt / 100000).toString().indexOf('.') != -1)
            amt = amt.toString();
            amt.split('');
            ind = amt.length - 5;
        } else if (amt > 999) {
            ext = ' Thousand';
            addDec = ((amt / 1000).toString().indexOf('.') != -1)
            amt = amt.toString();
            amt.split('');
            ind = amt.length - 3;
        } else {
            return '';
        }

        for (var index = 0; index < ind; index++) {
            result += amt[index];
            decIndex = index;
        }
        if (addDec) {
            result += '.';
            for (var index1 = decIndex + 1; index1 <= decIndex + 2; index1++) {
                result += amt[index1];
            }
        }
        result += ext;
        return result;
    }
});

angularApp.filter('convertAmountFullAlternate', function () {
    return function (amt) {
        var ext = '';
        var ind = 0;
        var result = '';
        var decIndex = 0;
        var addDec = false;

        if (amt > 9999999) {
            ext = ' Crore';
            addDec = ((amt / 10000000).toString().indexOf('.') != -1)
            amt = amt.toString();
            amt.split('');
            ind = amt.length - 7;
        } else if (amt > 99999) {
            ext = ' Lacs';
            addDec = ((amt / 100000).toString().indexOf('.') != -1)
            amt = amt.toString();
            amt.split('');
            ind = amt.length - 5;
        } else if (amt > 999) {
            ext = ' Thousand';
            addDec = ((amt / 1000).toString().indexOf('.') != -1)
            amt = amt.toString();
            amt.split('');
            ind = amt.length - 3;
        } else {
            return '';
        }

        for (var index = 0; index < ind; index++) {
            result += amt[index];
            decIndex = index;
        }
        if (addDec) {
            result += '.';
            for (var index1 = decIndex + 1; index1 <= decIndex + 2; index1++) {
                result += amt[index1];
            }
        }
        result += ext;
        return result;
    }
});

angularApp.filter('highlight', function ($sce) {
    return function (text, phrase) {
        if (phrase && text.indexOf('<span class="highlighted">') == -1) text = text.replace(new RegExp('(' + phrase + ')', 'gi'),
            '<span class="highlighted">$1</span>')
        phrase.split(' ').forEach(function (element) {
            if (element && text.indexOf('<span class="highlighted">') == -1) text = text.replace(new RegExp('(' + element + ')', 'gi'),
                '<span class="highlighted">$1</span>')
        }, this);

        return $sce.trustAsHtml(text)
    }
});
