angularApp.directive('appFooterTmpl', function(constantConfig) {
    'use strict';
    return {
        restrict: 'E',
        scope: {
            goback: "&",
            gonext: "&",
            showback: '=',
            shownext: '=',
            disableback: "=",
            disablenext: "=",
            aofooter: "=",


        },
        require: '?ngModel',
        transclude: false,
        replace: false,
        templateUrl: constantConfig.templateUrl.footerTmpl,
        link: function(scope, element, attrs, ngModel) {

            scope.nextText = (attrs.nexttext) ? attrs.nexttext : 'NEXT';
            scope.backText = (attrs.backtext) ? attrs.backtext : 'BACK';
            scope.goBack = function() {
                scope.goback();
            }
            scope.goNext = function() {
                scope.gonext();
            }
        },
    };
});

