angularApp.directive('menuTmpl', function(constantConfig,$state,irctcService,ompMerchantsService) {
    'use strict';
    return {
        restrict: 'E',
        scope: {
           
           
             showInfo: '='

        },
        require: '?ngModel',
        transclude: false,
        replace: false,
        templateUrl: constantConfig.templateUrl.menuTmpl,
        link: function(scope, element, attrs, ngModel) {
            scope.showCollapse = false;
            scope.goMyList = function() {
                 irctcService.selTab="Y";
                $state.go("menu.myList");
            }
            scope.linkDelinkUser = function() {
                 irctcService.selTab="Y";
                $state.go("menu.linkDelinkUser");
            }
            scope.gotoFAQ = function() {
                 irctcService.selTab="Y";
                $state.go("menu.irctcFAQ");
            }
            scope.gotoSupport = function() {
                 irctcService.selTab="Y";
                 $state.go("menu.irctcFeedback");
            }
            scope.gotoTnC = function() {
              //  $state.go('menu.irctcBookingPolicy');
              ompMerchantsService.inAppBrowser("http://contents.irctc.co.in/en/term.html#Q3");
            }
            scope.forgotID = function() {
                
            }
            scope.forgotPassword = function() {
                cordova.ThemeableBrowser.open(irctcService.forgotPasswordURL, '_system');               
            }
            
            scope.goBookingHistory=function()
            {
                 irctcService.selTab="Y";
                $state.go("menu.bookingHistory");
            }
            
            scope.toggleCollapse = function(){
               scope.showCollapse = !scope.showCollapse;
            }

            scope.taxInvoice = function() {
                $state.go("menu.taxInvoiceList");
            }
            
            scope.goToBookTicket = function(){
                irctcService.searchTrainObj="";
                irctcService.myList="";
                irctcService.masterData="";
                irctcService.selectedTrainData="";
                irctcService.myListFullData="";
                $state.go('menu.irctcBookTicketSearch');
                irctcService.selTab="Y";
                
            }
            
        },
    };
});