angularApp.directive('rinRakshaFooter', function(constantConfig) {
    'use strict';
    return {
        restrict: 'E',
        scope: {
            goback: "&",
            gonext: "&",
            goconfirm: "&",
            gosave: "&",
            gosubmit: "&",
            gocancel: "&",
            gopay: "&",
            showback: '=',
            shownext: '=',
            showsave: '=',
            showsubmit: '=',
            showconfirm: '=',
            showcancel: '=',
            showpay: '=',
            disableback: "=",
            disablenext: "=",
            disablesave: "=",
            disablesubmit: "=",
            disableconfirm: "=",
            disablecancel: "=",
            disablepay: "=",
            aofooter: "=",
            backenabled: "="


        },
        require: '?ngModel',
        transclude: false,
        replace: false,
        templateUrl: constantConfig.templateUrl.rinRakshaFooter,
        link: function(scope, element, attrs, ngModel) {
            scope.nextText = (attrs.nexttext) ? attrs.nexttext : 'NEXT';
			scope.backText = (attrs.backtext) ? attrs.backtext : 'BACK';
            scope.goBack = function() {
                scope.goback();
            }
            scope.goNext = function() {
                scope.gonext();
            }
            scope.goConfirm = function() {
                scope.goconfirm();
            }
            scope.goSave = function() {
                scope.gosave();
            }
            scope.goSubmit = function() {
                scope.gosubmit();
            }
            scope.goCancel = function() {
                scope.gocancel();
            }
            scope.goPay = function() {
                scope.gopay();
            }
        },
    };
});