angularApp.directive('validPasswordC', function() {
    'use strict';
    return {
        restrict: 'A',
        scope: {
            reference: "=validPasswordC"

        },
        require: 'ngModel',
        transclude: false,
        replace: false,
        link: function(scope, elm, attrs, ctrl) {
        var limit = parseInt(attrs.limitTo);
    
            ctrl.$parsers.unshift(function(viewValue, $scope) {
				if(viewValue.length > limit){
				viewValue = viewValue.substr(0,limit);
				ctrl.$setViewValue(viewValue);
				ctrl.$render();
				}
                var noMatch = viewValue != scope.reference
                ctrl.$setValidity('noMatch', !noMatch);
                return (noMatch) ? noMatch : !noMatch;
            });
            scope.$watch("reference", function(value) {;
                ctrl.$setValidity('noMatch', value === ctrl.$viewValue);
            });
        }
    };
});