angularApp.filter('filterCountry', function () {
  return function (items, modelValue) {
    var filtered = [];
    if(modelValue != undefined){
    for (var i = 0; i < items.length; i++) {
      var item = items[i];
      if (item.toString().substr(0,modelValue.length).toLowerCase() == modelValue.toLowerCase()) {
        filtered.push(item);
      }
    } 
  }
  if(filtered.length === 0){
    angular.element(document.querySelector('.list')).addClass('lastListItem');
  }
  else{
    angular.element(document.querySelector('.list')).removeClass('lastListItem');
  }
  return filtered;

  };
});

angularApp.filter('stringToInteger', function() {
        return function(input) {
        angular.forEach(input, function(value) {
            value.gd =  parseInt(value.gd);
        })
    return input;
  };
});


angularApp.filter('customSelectFilter', function () {
  return function (items, modelValue) {
    var filtered = [];
    if(modelValue != undefined){
    for (var i = 0; i < items.length; i++) {
      if (items[i].name.toString().substr(0,modelValue.length).toLowerCase() == modelValue.toLowerCase()) {
        filtered.push(items[i]);
      }
    } 
  }
  if(filtered.length === 0){
    angular.element(document.querySelector('.list')).addClass('lastListItem');
  }
  else{
    angular.element(document.querySelector('.list')).removeClass('lastListItem');
  }
  return filtered;

  };
});


angularApp.filter('customFilterEmp', function () {
  return function (items, modelValue) {
   
      var filtered = [];
    if(modelValue != undefined){
    for (var i = 0; i < items.length; i++) {
      if (items[i].description.toString().substr(0,modelValue.length).toLowerCase() == modelValue.toLowerCase()) {
        filtered.push(items[i]);
      }
    } 
  }
    
    
  if(filtered.length === 0){
    angular.element(document.querySelector('.list')).addClass('lastListItem');
  }
  else{
    angular.element(document.querySelector('.list')).removeClass('lastListItem');
  }
  return filtered;

  };
});
