//mask character filter start
angularApp.filter('mask', function(utilityService) {
    try {
        return function(value, symbol, count) {
            if (!utilityService.isUndefined(value)) {
                !isNaN(value) ? value = value.toString() : value;
                if (value.length > 0) {
                    var count = count || value.length;
                    var symbol = symbol || "*";
                    var symbols = [];
                    var temp = "";
                    for (var i = 0; i < value.length - count; i++) {
                        symbols.push(symbol);
                    }
                    symbol = symbols.join("");
                    value = symbol + value.substring(value.length - count);
                    return value;
                }
            }
        }
    } catch (e) {  }
});
//mask character filter end
//OnlineDemat DOB Mask Starts
angularApp.filter('maskDOB', function(utilityService) {
    try {
        return function(value, symbol, count) {
            if (!utilityService.isUndefined(value)) {
                var removeSpace = value.replace(/ /g,'');
                var maskedDate = removeSpace[0].replace(removeSpace[0],"x")+removeSpace[1].replace(removeSpace[1],"x");
                var maskedMonth = removeSpace[2].replace(removeSpace[2],"x")+removeSpace[2].replace(removeSpace[2],"x");
                var finalMaskedDOB = maskedDate+' '+maskedMonth+' '+removeSpace.slice(5);
                return finalMaskedDOB;
            }
        }
    } catch (e) {  }
});
//OnlineDemat DOB Mask Starts