'use strict';
angularApp.service('clearServiceDataService',
	function ($q, utilityService, AdapterUtils, myBalanceService, myDreamsServices,
		accountOverviewService, getAccountDetailsService, feedebackService,
		fixedDepositService, fTNewBeneficiaryService, fTNewBeneficiary_MobileService,
		fTBeneficiaryService, fTReviewService, homeScreenService, mPinLoginService,
		comparisonChartService, filterService, ompMerchantsService, ompShopService,
		productDescriptionServices, searchListServices, wishListService,
		personalLoanService, accountDetailsService, reportService, introSecurityService,
		openAccountService, mySecurityProfileService, aoService, constantConfig) {

		var clearServiceDataService = this;
		var clearServiceData = function () {

			/*Account Overview*/
			myBalanceService.err = {};
			myDreamsServices.accDetails = [];
			myDreamsServices.selectedDetails = {
				accountType: '',
				accountNumber: '',
				accountBalance: '',
				intCategory: '',
				accountTypeCode: ''
			};
			myDreamsServices.customer = {
				selectedItem: '',
				indexId: 0
			}
			myDreamsServices.myDreamsList = {};
			myDreamsServices.accountList = [];
			accountOverviewService.customer = {
				ODaccount: '',
				FDaccount: '',
				startDate: '',
				operational: '',
				lienAmount: '',
				accountCategory: ''
			};
			getAccountDetailsService.accountOverviewData = "";
			getAccountDetailsService.accType = { accno: '', typeId: '', indexId: '', type: '', amount: '', transactionFlag: '', branchName: '' };
			getAccountDetailsService.tabIndex = { tabIndex: 0 };
			getAccountDetailsService.autoLoanAccNo = '';
			getAccountDetailsService.transactionTag = '';
			getAccountDetailsService.dataDisplay = { savingDisplay: false, currentDisplay: false, overdraftDisplay: false, graphDisplay: false };

			feedebackService.setUserFeedback = [];

			/*Fixed Deposit*/

			fixedDepositService.accDetails = [];

			fixedDepositService.selectedDetails = {
				accountType: '',
				accountNumber: '',
				accountBalance: '',
				isActive: '',
				isTransactional: '',
				branchCode: '',
				branchName: '',
				intCategory: '',
				accountTypeCode: ''
			};

			fixedDepositService.Relations = [];
			fixedDepositService.customer = {
				amountData: '',
				years: '',
				months: '',
				days: '',
				maturityDate: '',
				interestRate: '',
				maturityAmount: '',
				interestPayout: '',
				maturityInstruction: '',
				diffDays: '',
				maturityDateFull: '',
				isvalidDays: '',
				isTaxable: false,
				accountNo: '',
				fdAccountNumber: '',
				loanEligibility: '',
				receiptLink: '',
				nomineeClick: '',
				selectedItem: '',
				ODLimit: '',
				ODIntRate: '',
				ODExyDate: '',
				isSenior: false,
				custName: '',
				custDOB: '',
				nominee: '',
				age: '',
				relation: '',
				guardian: '',
				address1: '',
				address2: '',
				dob: '',
				showNominee: false,
				viewInterest: false,
				isPanAvailable: '',
				fdnumber: '',
				AODclick: '',
				intpayoutMD: '',
				intpayoutAMT: '',
				maturitydateRequest: '',
				nameToBePrintedFlag: '',
				minorFlag: '',
				custype: '',
				intpayoutservice: '',
				matInstService: '',
				indexId: 0,
				amountCredited: '',
				effectiveInterestRates: '',
				clickback: '',
				intpaycheck: '',
				nomIndexid: '',
				checkPAL: '',
				preApprovedLoanAmount: '',
				product: '',
				principalAmount: '',
				checkPage: '',
				maturitydateFD: '',
				maturitydateFDRequest: '',
				branchCode: '',
				branchName: '',
				intpayamount: '',
				intpaystring: '',
				checkNominee: false,
				fdCloseClick: '',
				intpayoutACCT: '',
				intCategory: '',
				accountTypeCode: '',
				nightMode: ''
			};

			/*Funds Transfer*/
			fTNewBeneficiaryService.selectedDiv = "";
			fTNewBeneficiary_MobileService.selectedDiv = "";

			fTBeneficiaryService.savedImg = "";
			fTBeneficiaryService.beneficiaryData = {
				freqTransItems: [],
				schedTransItems: [],
				otherAccItems: [],
				ownAccItems: []
			};

			fTBeneficiaryService.customer = {
				picDocId: '',
				imgData: constantConfig.ft.defaultEditBenImg,
				conImg: constantConfig.ft.defaultBenImg,
				sbiLogo: constantConfig.SBILogo,
				nameData: '',
				nickName: '',
				mobileNo: '',
				bankData: '',
				ifsc: '',
				accountNoData: '',
				accountTypeData: '',
				mmid: '',
				remMMID: '',
				vpa: '',
				sBalance: '',
				transAmount: '',
				remarks: '',
				transFee: '',
				transactionId: '',
				fromAccNumber: '',
				fromAccType: '',
				fromAccBalance: '',
				maxLimit: '',
				benType: '',
				intraBankFlag: '',
				isOwnAccntFlag: '',
				ownAccount: false,
				siId: '',
				scheduleDate: '',
				sAccountType: '',
				sAccountNo: '',
				scheduledTransferAmount: '',
				siFrequency: '',
				siCount: '',
				selectedItem: '',
				selectedItemImg: '',
				indexId: 0,
				ownAccItems: []
			};

			fTBeneficiaryService.beneficiaryItem = {
				"beneficiaryName": "",
				"nickName": "",
				"bankName": "",
				"pictureUrl": "",
				"type": "",
				"accountNumber": "",
				"mmid": "",
				"vpa": ""
			};

			fTBeneficiaryService.payingFrom = '';

			fTBeneficiaryService.accDetails = [];

			fTBeneficiaryService.selectedDetails = {
				accountType: '',
				accountNo: '',
				balance: '',
				img: ''
			};

			fTBeneficiaryService.payingFromVPA = [
				{
					img: "img/FT/SBI-logo.svg",
					accountID: 1,
					accountType: "VPA",
					accountNo: "",
					balance: ""
				}, {
					img: "img/FT/SBI-logo.svg",
					accountID: 2,
					accountType: "VPA",
					accountNo: "",
					balance: ""
				}
			];
			fTBeneficiaryService.cif = "";
			fTBeneficiaryService.minAmount = "";
			fTBeneficiaryService.qrflag = false;
			fTBeneficiaryService.maxAmountTansfer = 100000;
			fTBeneficiaryService.checkBox = "N";
			fTReviewService.transactionFee = "";

			/*mPinLogin*/
			mPinLoginService.userLoginStatus = {
				isLoggedIn: false,
				isRegistered: false
			};

			/*OMP Start*/
			comparisonChartService.compareData = [];
			filterService.from = ''
			filterService.selectedLevelOneData = "";
			filterService.selectedLevelTwoData = "";
			filterService.selectedLevelThreeData = "";
			filterService.selectedCategoryId = "";
			filterService.filterOldData = '';
			filterService.isFilterApplied = '';
			filterService.addedFilterFullData = [];
			filterService.addedFilterNewFullData = [];
			filterService.addedFilterData = [];
			filterService.selectedColour = [];
			filterService.addedFilterDataWOA = [];
			filterService.addedFilterFullDataWOA = [];
			filterService.beforeAppliedFilter = [];
			filterService.filterCategory = {
				selectedLevelOneData: "",
				selectedLevelTwoData: "",
				selectedLevelThreeData: "",
				selectedCategoryId: ''
			};
			filterService.filterNewData = {
				categoryList: [],
				subCategoryList: [],
				colorList: [],
				priceList: [],
				callFunctionsList: []
			};
			ompMerchantsService.listName = "";
			ompMerchantsService.merchantWishlistCount = "";
			ompMerchantsService.isLoggedIn = "";
			ompMerchantsService.firstTimeLoaded = "";
			ompMerchantsService.merchantsListData = '';
			ompMerchantsService.isMerchantsWishListAvl = '';
			ompShopService.category = "";
			ompShopService.merWebId = "";
			ompShopService.selectedFeature = "";
			ompShopService.categoryList = [];
			ompShopService.featuredCategoriesList = '';
			ompShopService.subCategory = [];
			productDescriptionServices.productData = "";
			productDescriptionServices.categoryFiltersData =
				searchListServices.searchFor = "";
			searchListServices.allProductsList = "";
			searchListServices.products = [];
			searchListServices.isCompareAvailable = '';
			searchListServices.serviceFromObj = '';
			searchListServices.serviceFrom = '';
			searchListServices.sortObjectData = {};
			searchListServices.isSortApplied = '';
			searchListServices.selectedSortOption = '';
			searchListServices.filterData = {
				categoryList: [],
				subCategoryList: [],
				colorList: [],
				priceList: [],
				callFunctionsList: []
			};
			searchListServices.categoryFilters = [];
			searchListServices.maxValue = -1;
			searchListServices.minValue = -1;
			wishListService.wishCount = "";

			/*Personal Loan Start*/

			personalLoanService.accountNumber = "";
			personalLoanService.loanAmount = "";
			personalLoanService.duration = "";
			personalLoanService.emiDate = "";
			personalLoanService.emiAmount = "";
			personalLoanService.loanAccountNumber = "";
			personalLoanService.accNo = "";
			personalLoanService.amount = "";
			personalLoanService.personalLoanData = {};
			personalLoanService.otp = "";
			personalLoanService.checkBox = 'N';
			personalLoanService.minDuration = "";
			personalLoanService.maxDuration = "";
			personalLoanService.minBestOffer = "";
			personalLoanService.interestRate = "";
			personalLoanService.activityCode = "";
			personalLoanService.schemeCode = "";
			personalLoanService.interest = "";
			personalLoanService.product = "";

			/*Pre home login*/

			accountDetailsService.accountList = "";

			/*Report*/

			reportService.bugDetails = {
				journey: "",
				title: "",
				name: "",
				bugDesc: "",
				expectedBeh: "",
				bugSeverity: "",
				vesionNo: "",
				mobileNo: ""
			};

			/*Securities*/

			introSecurityService.answer = "";
			introSecurityService.question = "";

			openAccountService.statusOfOpenAccount = '';

			mySecurityProfileService.accountList = [];
			mySecurityProfileService.dpIdVal = '';

			/*Account Opening*/

			aoService.customer = {
				aadharNumber: '',
				title: '',
				name: '',
				gender: '',
				dateOfYear: '',
				address: '',
				pincode: '',
				city: '',
				state: '',
				emailId: '',
				mobileNo: '',
				panNumber: '',
				lotusId: '',
				image: '',
				deviceUid: '',
				deviceOS: '',
				referenceCode: '',
				photo: '',
				guardian: '',
				latitude: '',
				longitude: '',
				encodephoto: ''
			}

			aoService.customerAdditionalDetails = {
				"maidenName": "",
				"fatherName": "",
				"fatherFirstName": "",
				"fatherMiddleName": "",
				"fatherLastName": "",
				"spouseName": "",
				"motherMaidenName": "",
				"maritalStatus": "",
				"annualIncome": "",
				"occupation": "",
				"subOccupation": "",
				"religion": "",
				"education": "",
				"cityOfBirth": "",
				"countryOfBirth": ""
			}

			aoService.mapCoords = {
				latitude: '',
				longitude: ''
			}

			aoService.mapGPS = [];

			aoService.debitCardDetails = {
				"firstName": '',
				"lastName": ''
			}

			aoService.selectByGPS = [];

			aoService.customerCorrespondenceAddress = {
				address1: "",
				address2: "",
				state: "",
				stateCode: "",
				city: "",
				cityCode: "",
				pincode: "",
				isAadharScanned: false,
				locality: ""
			}

			aoService.customerManualEntryDetails = {
				aadharNumber: "",
				firstName: "",
				lastName: "",
				middleName: "",
				fullName: "",
				gender: "",
				genderCode: "",
				title: "",
				titleCode: "",
				dob: "",
				address1: "",
				address2: "",
				city: "",
				cityCode: "",
				state: "",
				stateCode: "",
				pincode: "",
				isAadharScanned: false,
				locality: "",
				addressLine1: "",
				addressLine2: ""

			}

			aoService.customerAadhaarCardDetails = {
				uid: "",
				name: "",
				firstName: "",
				middleName: "",
				lastName: "",
				gender: "",
				genderCode: "",
				title: "",
				titleCode: "",
				yob: "",
				co: "",
				house: "",
				street: "",
				lm: "",
				loc: "",
				vtc: "",
				po: "",
				dist: "",
				distCode: "",
				subdist: "",
				state: "",
				stateCode: "",
				pc: "",
				dob: "",
				isAadharScanned: false,
				locality: "",
				addressLine1: "",
				addressLine2: ""
			}

			aoService.nomineeAadhaarCardDetails = {
				uid: "",
				name: "",
				gender: "",
				yob: "",
				co: "",
				house: "",
				street: "",
				lm: "",
				loc: "",
				vtc: "",
				po: "",
				dist: "",
				distCode: "",
				subdist: "",
				state: "",
				stateCode: "",
				pc: "",
				dob: "",
				relationship: "",
				guardianName: "",
				guardianAge: "",
				age: "",
				address1: "",
				address2: ""
			}

			aoService.activeAdditionalDetails = {

			}

			aoService.selectedBranch = {
				branchname: "",
				branchaddress: ""
			}

			aoService.nominee = {
				uid: '',
				name: '',
				firstName: '',
				middleName: '',
				lastName: '',
				relationship: '',
				guardianName: '',
				guardianAge: '',
				age: '',
				address1: '',
				address2: '',
				pincode: '',
				dob: '',
				city: '',
				cityCode: '',
				state: '',
				stateCode: '',
				guardianAddressFlag: ''
			}

			aoService.branches = [];

			aoService.nomineeGuardianDetails = {
				address1: '',
				address2: '',
				pincode: '',
				city: '',
				cityCode: '',
				state: '',
				stateCode: '',
				locality: '',
				guardianConsent: ''
			}

			aoService.direction = {
				latitude: '',
				longitude: '',
				branchname: '',
				address: '',
				state: ''
			}

			aoService.aadhaarManualPermanentAddress = {
				address1: "",
				address2: "",
				state: "",
				stateCode: "",
				city: "",
				cityCode: "",
				pincode: "",
				isAadharScanned: false,
				locality: ""
			}

			aoService.aadhaarManualCorrespondenceAddress = {
				address1: "",
				address2: "",
				state: "",
				stateCode: "",
				city: "",
				cityCode: "",
				pincode: "",
				isAadharScanned: false,
				locality: ""
			}

			aoService.localityNav = "";
			aoService.isNomineeAddress1Changed = false;
			aoService.isNomineeAddress2Changed = false;
			aoService.nomineeNav = "";
			aoService.isNomineeScanned = false;
			aoService.localityNextDisable = "";
			aoService.isResumeJourney = false;
			aoService.isAadharManualEntry = false;
			aoService.panAuthorizeFlag = false;
			aoService.cardReadyForCollection = "";
			aoService.isCustManualCorresChkBox = false;
			aoService.fatcaFlag;
			aoService.termsAndConditionsFlag = false;
			aoService.productOfferingFlag = true;
			aoService.homeBranchLocalityCity = "";
			aoService.homeBranchLocalityId = "";
			aoService.homeBranchGpsId = "";
			aoService.picId = '';
			aoService.appPassword = '';
			aoService.cifNumber = '';
			aoService.acNumber = '';
			aoService.debitNumber = '';
			aoService.tncOtpValue = '';
			aoService.maritalStatusList = [];
		};

		return { clearServiceData: clearServiceData }

	});