
angularApp.service('leadGenerationService',['$q','AdapterUtils',
	function($q,AdapterUtils){

        var leadGeneration = this;
        leadGeneration.checkConsent = function() {
            var q = $q.defer();
            AdapterUtils.postData('adapters/FSSCommonAdapter/oa/v1/checkConsent', true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        leadGeneration.updateConsent = function() {
            var q = $q.defer();
            AdapterUtils.postData('adapters/FSSCommonAdapter/oa/v1/updateConsent', true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        leadGeneration.insertConsent = function() {
            var q = $q.defer();
            AdapterUtils.postData('adapters/FSSCommonAdapter/oa/v1/insertConsent', true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
}]);