'use strict';

angularApp.service('accountOpeningLooksGreatService',
    function($q, AdapterUtils, constantConfig) {
        var accountOpeningLooksGreatService = this;
        
        accountOpeningLooksGreatService.uploadPhoto = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.uploadPhoto, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        accountOpeningLooksGreatService.retrievePhoto = function(requestData) {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.retrieveDocument + requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return accountOpeningLooksGreatService;
    });
