'use strict';

angularApp.service('knowMoreService',
    function($q, AdapterUtils, constantConfig) {
        var knowMoreService = this;
        knowMoreService.productKnowMore = function() {
            var q = $q.defer();

            //Get product features additional information
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.productFeatureKnowMore, true).then(

                function(response) {
                    q.resolve(response.data.productFeaturesKnowMore);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return knowMoreService;
    });