'use strict';

angularApp.controller('addFundsOptionsController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",


    function($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var addFundsOptionsVm = this;

        function initPage() {
            addFundsOptionsVm.showBack = true;
            addFundsOptionsVm.aofooter = true;
        }

        addFundsOptionsVm.goBacktoPrevious = function() {
            $state.go('menu.aoMpin');
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        addFundsOptionsVm.fundFromOtherBank = function() {
            $state.go('menu.addFundsToYourAccount');
        }

        addFundsOptionsVm.locateDepositMachine = function(){
            $state.go('menu.locateNearestBranch');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
