'use strict';

angularApp.service('aDCityCountryService',
    function($q, AdapterUtils, constantConfig) {
        var aDCityCountryService = this;
        aDCityCountryService.getCountries = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getCountries, true).then(

                function(response) {
                    q.resolve(response.body);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        aDCityCountryService.getCitizenship = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getCountries, true).then(

                function(response) {
                    q.resolve(response.body);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
        aDCityCountryService.getNationality = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getCountries, true).then(

                function(response) {
                    q.resolve(response.body);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
		
		aDCityCountryService.getInfoList = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getInfoList, true).then(
				
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
        
        return aDCityCountryService;
    });
