'use strict';

angularApp.service('branchDetailsService',
    function($q, AdapterUtils, constantConfig) {
        var branchDetailsService = this;

        branchDetailsService.loadBranchDetails = function(params) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getInTouchBranchesByCity, params, true).then(

                 function(response){ 
                    q.resolve(response);
                },
                function(error){    
                    q.reject(error);
                }
            );

            return q.promise;
        };

        branchDetailsService.getCities = function() {
           
             var q = $q.defer(); 
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getCities, true).then(
                function(response){ 
                    q.resolve(response.body);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;

        };
        return branchDetailsService;
    });
