'use strict';

angularApp.service('debitCardDetailsService',
    function($q, AdapterUtils, constantConfig) {
        var debitCardDetailsService = this;
        debitCardDetailsService.setDebitCardDetails = function(requestParams) {
            var q = $q.defer(); 

            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.setDebitCardNameDetails,requestParams, true).then(
                function(response){ 
                    q.resolve(response);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };

        debitCardDetailsService.receiveDebitCard = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.receiveDebitCard, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                    
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        debitCardDetailsService.getReferenceNo = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getReferenceNo, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                    
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        debitCardDetailsService.sendRefEmailAndSms = function(requestParams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getReferenceDetails, requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return debitCardDetailsService;
}); 