'use strict';

angularApp.service('foreignService',
    function($q, AdapterUtils, constantConfig) {
        var foreignService = this;

        foreignService.getFatcaInfoDetails = function(){
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getFatcaInfoDetails, true).then(

                function(response) {
                    q.resolve(response.data.fatcaDetails);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        }

        return foreignService;
    });
