'use strict';

angularApp.controller('fundController', ["$state",
    "$scope",
    "aoService",

    function($state,
        $scope,
        aoService) {

        var fundVm = this;

        function initPage() {
            fundVm.showBack = true;
            fundVm.aofooter = true;

            fundVm.banksJson = [{ bank: "Axis Bank" },
                { bank: "ICICI Bank" },
                { bank: "HDFC Bank" },
                { bank: "HSBC Bank" },
                { bank: "DENA Bank" },
                { bank: "Syndicate Bank" },
                { bank: "IDBI Bank" },
                { bank: "Canara Bank" },
                { bank: "Kotak Mahindra Bank" },
                { bank: "KVB" },
                { bank: "LVB" }
            ];
        }

        fundVm.goBacktoPrevious = function() {
            $state.go('menu.addFundsOptions');
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });
        
        return this;
    }
]);
