'use strict';

angularApp.service('locateBranchService',
    function($q, AdapterUtils, constantConfig) {
        var locateBranchService = this;
        locateBranchService.getLocateBranchContent = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.locateBranch, true).then(

                function(response) {
                    q.resolve(response.data.locateBranch);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return locateBranchService;
    });
