'use strict';

angularApp.controller('multipleCustomerController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var multipleCustomerVm = this;

        function initPage() {
            multipleCustomerVm.showBack = true;
            multipleCustomerVm.showNext = false;
        }

        multipleCustomerVm.goBacktoPrevious = function() {
            $state.go('menu.panDetails');
        }

        multipleCustomerVm.goToNextPage = function() {
            //$state.go('menu.aadhaarManualEntry');
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        multipleCustomerVm.displaymap = function() {
            $state.go('menu.locateNearestBranch');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);   
        });
        
        return this;
    }
]);
