'use strict';

angularApp.service('panAuthoriseService',
    function($q, AdapterUtils, constantConfig) {
        var panAuthoriseService = this;
		panAuthoriseService.isComingfromPanAuthPage = false;
        panAuthoriseService.getAuthorizationDetails = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getPersonalDetails, true).then(

                function(response) {
                    q.resolve(response.data.personalDetails);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        panAuthoriseService.setPanAuthorizeFlag = function(requestParams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.setPanAuthorizeFlag, requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return panAuthoriseService;
    });
