'use strict';

angularApp.service('panDetailsService',
    function($q, AdapterUtils, constantConfig) {
        var panDetailsService = this;

        panDetailsService.updatePanNumber = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.updatePANNumber, data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
                );
            return q.promise;

        };

        panDetailsService.updateCif = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.updateCif, data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
                );
            return q.promise;

        };

        panDetailsService.validatePanNumber = function(data) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(constantConfig.acOpeningAdapterUrl.validatePanNumber, data, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
                );
            return q.promise;

        };
        
        panDetailsService.getDetailsforJTSix = function(data) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(constantConfig.JTSix.getCustomerInfromation, data, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
                );
            return q.promise;

        };
        return panDetailsService;

    });




