'use strict';

angularApp.service('productOfferingService',
    function($q, AdapterUtils, constantConfig) {
        var productOfferingService = this;
        productOfferingService.getOtherProductOfferings = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getOtherProductInfo, true).then(

                function(response) {
                    q.resolve(response.data.otherProductInfo);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        productOfferingService.postProdOffers = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.postProductOfferingDetails, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return productOfferingService;
    });
