'use strict';

angularApp.service('receiveDebitCardService',
    function($q, AdapterUtils, constantConfig) {
        var receiveDebitCardService = this;

        receiveDebitCardService.receiveDebitCard = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.receiveDebitCard, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        receiveDebitCardService.getReferenceNo = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getReferenceNo, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return receiveDebitCardService;
    });
