'use strict';

angularApp.controller('sbiInTouchRegisterOptionsController', ["$state",
    "$scope",
    "$ionicPopover",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $ionicPopover,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var sbiInTouchRegisterOptionsVm = this;

        function initPage() {
            sbiInTouchRegisterOptionsVm.showBack = true;
            sbiInTouchRegisterOptionsVm.showNext = false;
        }

        /* Info Popup */
        var template = '<ion-popover-view class="ao-tooltip ao-popupInfo roboto-regular ao-twoLinesHt">' + '<ion-content>' +
                        '<div class="" translate="TEMP_USER_ID_INFO_ICON"></div>' + '</ion-content>' + '</ion-popover-view>';

        $scope.popover = $ionicPopover.fromTemplate(template, {
            scope: $scope
        });

        sbiInTouchRegisterOptionsVm.infoPopup = function($event) {
            $scope.popover.show($event);
        };

        sbiInTouchRegisterOptionsVm.closePopover = function() {
            $scope.popover.hide();
        };
       /* Info Popup */

        sbiInTouchRegisterOptionsVm.goBacktoPrevious = function() {
            $state.go("menu.homePage");
        }

        sbiInTouchRegisterOptionsVm.goToNextPage = function() {
            $state.go("menu.tempLogin");
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
