'use strict';

angularApp.controller('tempLoginController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var tempLoginVm = this;

        function initPage() {
            tempLoginVm.showBack = false;
            tempLoginVm.showNext = true;
            tempLoginVm.loginBtn = true;
        }

        $scope.goToHome = function() {
            aoService.homeNav();
        }

        tempLoginVm.login = function() {
            $state.go('menu.accountOpeningDetails');
        }

        tempLoginVm.validateForm = function(isValid) {
            tempLoginVm.loginBtn = !isValid;
            return tempLoginVm.loginBtn;
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

         //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn); 
        });

        return this;
    }
]);
