'use strict';

angularApp.service('termsAndConditionsService',
    function($q, AdapterUtils, constantConfig) {
        var termsAndConditionsService = this;
        termsAndConditionsService.getTermsAndConditions = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getTermsAndConditions, true).then(

                function(response) {
                    q.resolve(response.data.termsAndConditions);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        termsAndConditionsService.postTAndC = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.postTAndCDetails, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return termsAndConditionsService;
    });
