'use strict';
angularApp.controller('aglResumeController', [
    "$state",
    "$ionicPopup",
    "$scope",
    "ionicToast",
    "customerInfoService",
    "utilityService",
    "constantConfig",
    "loggedInUserService",
    "validationService", "$translate", "agriMandiService",

    function($state, $ionicPopup, $scope, ionicToast, customerInfoService, utilityService, constantConfig, loggedInUserService, validationService, $translate, agriMandiService) {

        var aglResumeVm = this;


        aglResumeVm.goBack = function() {
             $state.go('menu.aglKnowMore');
        }


        $scope.$on('$ionicView.beforeEnter', function() {
          aglResumeVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
          aglResumeVm.date = agriMandiService.WCMData.startDate;
            

        });

        

        aglResumeVm.goToResume=function()
        {
            agriMandiService.resumeApplication().then(function(data) {

               agriMandiService.resumeData =data;
                $state.go('menu.aglPersonalDetails');
                

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }










        return this;
    }
]);