'use strict';

angularApp.controller('kccLandholdingController', [
    "$state",
    "$scope",
    "$filter", "$ionicPopup", "utilityService", "kccService", "agriMandiService","AdapterUtils","$ionicViewSwitcher",

    function ($state,
        $scope,
        $filter, $ionicPopup, utilityService, kccService, agriMandiService,AdapterUtils, $ionicViewSwitcher) {
        var kccLandholdingVm = this;
        kccLandholdingVm.goBack = function () {
            $state.go("menu.kccPersonalDetails");
        };
        kccLandholdingVm.closeView = function () {
            $state.go('menu.kccKhataLanding');
        }
        kccLandholdingVm.goToNextPage = function () {
            $state.go("menu.kccCroppingPattern");
        };
        kccLandholdingVm.goToPopUp = function () {
            kccLandholdingVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'new-purp-popup yono-kcc-popup',
                templateUrl: 'pages/Agl/kccLandholdingPopup.html',
                scope: $scope
            })
        }
        kccLandholdingVm.OK = function () {
            kccLandholdingVm.myPopup.close();
            $ionicViewSwitcher.nextDirection('back');
            $state.go("menu.agriLanding");
        }
        kccLandholdingVm.Cancel = function () {
            kccLandholdingVm.myPopup.close();
        }
        $scope.$on('$ionicView.beforeEnter', function () {
            if (utilityService.isIOSPlatform()) {
                kccLandholdingVm.scroll = false;
            } else {
                kccLandholdingVm.scroll = true;
            }
            kccLandholdingVm.detail = {};
            kccLandholdingVm.showDescription = false;
            kccLandholdingVm.customStyle = agriMandiService.getCustomStyle(agriMandiService.selectLanguage);
            kccLandholdingVm.detail.totlLandArea = kccService.dataForKCC.totalLandArea;
            if (!kccLandholdingVm.detail.totlLandArea) {
                kccLandholdingVm.isLandAreaAvail = false;
            } else {
                kccLandholdingVm.isLandAreaAvail = true;
            }
        });
        return this;
    }
]);