'use strict';

angularApp.controller('safalAdditionalDetailsController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter","safalService",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter,safalService) {

        var safalAdditionalDetailsVm = this;
        safalAdditionalDetailsVm.removeFooter=false;
        safalAdditionalDetailsVm.totalAreaInAcres = 0;
        safalAdditionalDetailsVm.cropList = [];
        $scope.$on('$ionicView.beforeEnter', function() {
            safalAdditionalDetailsVm.isCrop = safalService.isCropProduction;
            safalAdditionalDetailsVm.masterdata = angular.copy(safalService.masterdata);
        
            safalAdditionalDetailsVm.detail = angular.copy(safalAdditionalDetailsVm.masterdata);
            safalAdditionalDetailsVm.masterCloudData = angular.copy(safalService.masterCloudData);
        if(safalAdditionalDetailsVm.isCrop){           
            safalAdditionalDetailsVm.totalAreaInAcres = Number( safalAdditionalDetailsVm.detail.areaOwned) + Number( safalAdditionalDetailsVm.detail.areaLeased);
        }
        safalAdditionalDetailsVm.cropList = safalAdditionalDetailsVm.detail.cropDetails;
        if(!safalAdditionalDetailsVm.isCrop){           
            safalAdditionalDetailsVm.detail.milkProduction = Math.floor(safalAdditionalDetailsVm.detail.milkProduction/parseInt(safalAdditionalDetailsVm.masterCloudData.dairyLoanTenure))

        }
        if(safalAdditionalDetailsVm.isCrop){   
            safalAdditionalDetailsVm.detail.activityUndertaken = "Crop";
        }
        else{
            safalAdditionalDetailsVm.detail.activityUndertaken = "Dairy";

        }


        });
        

        safalAdditionalDetailsVm.goBack = function() {
            $ionicHistory.goBack(-1);;
        }

        safalAdditionalDetailsVm.goToLoanDetails = function() {
             $state.go('menu.safalLoanDetails')
            
        }


        safalAdditionalDetailsVm.goToPopUp = function() {

            safalAdditionalDetailsVm.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'new-purp-popup my-custom-popup',
                templateUrl: 'pages/Agl/safal/safalAdditionalDetailsPopUp.html',
                scope: $scope
            })
        }

       safalAdditionalDetailsVm.OK = function() {
        safalAdditionalDetailsVm.myPopup.close();
        $state.go('menu.homeScreen');
    }

    safalAdditionalDetailsVm.Cancel = function(){

        safalAdditionalDetailsVm.myPopup.close();

    }
       
  
      
    }
]);