angularApp.service('safalService',
    function($q, AdapterUtils, utilityService, constantConfig) {

        var safalService = this;
        var safalDetails;
        safalService.setSAFALData = function(data) {
            safalDetails = data;
            safalService.loanType = safalDetails.category;

            if(safalDetails.category=="SAFAL-CROP"){
            safalService.isCropProduction = true;
            }
            else if(safalDetails.category=="SAFAL-DAIRY"){
                safalService.isCropProduction = false;
            }
        };

       
        safalService.getProductDetails = function (reqData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriSafal/getSafalProductDetails", reqData, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;
         };
        
         safalService.safalPersonalAndCorporateDetails = function (reqData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriSafal/getPersonalAndCorporateDetails", reqData, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;
         };
         safalService.safalTermsAndConditions = function (reqData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriSafal/getTermsAndConditions", reqData, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;
         };
        
         safalService.submitSafalApplication = function (reqData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/AgriSafal/submitSafalApplication", reqData, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;
         };
       

        return safalService;

    });