'use strict';

angularApp.controller('safalSuccessController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter",
    "safalService", 
    "agriMandiService",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter,
        safalService,
        agriMandiService) {

        var safalSuccessVm = this;
        
        safalSuccessVm.SMSAlert = true;
        $scope.$on('$ionicView.beforeEnter', function() {

            
            safalSuccessVm.successDedupDetails = angular.copy(safalService.successDetails);
            safalSuccessVm.successSubmitDetails = angular.copy(safalService.successData);
            if(safalSuccessVm.successDedupDetails){
                safalSuccessVm.SMSAlert = false;
                safalSuccessVm.successDetails = angular.copy(safalSuccessVm.successDedupDetails);
            }
            else{
                safalSuccessVm.successDetails = angular.copy(safalSuccessVm.successSubmitDetails);
            }

        });

        safalSuccessVm.goToAgri=function(){
              
            if (getAccountDetailsService.accountOverviewData) {
                
                if (getAccountDetailsService.accountOverviewData.customerInformation.language) {
                    agriMandiService.selectLanguage = getAccountDetailsService.accountOverviewData.customerInformation.language.toLowerCase();
                    $state.go('menu.agriLanding');

                } else {
                    $state.go('menu.selectLanguage');
                }

            } else {
                agriMandiService.langError =true;
                $state.go('menu.selectLanguage');

            }
            
        }


        safalSuccessVm.goBack = function() {
            $ionicHistory.goBack(-1);;
        }

    
    }
]);