'use strict';
angularApp.service('automallService', function ($q, utilityService, AdapterUtils, $rootScope, paclService, $morphCarousel) {
    var selectedProduct = [];
    var oemList = [];
    var offerList = [];
    var oemOfferList = [];
    var oemSelected = false;
    var selectedOem = [];
    var selectedOemName = [];
    var offerDetails = [];
    var selectedOffer = '';
    var productDetails = {};
    var landingBanners = [];
    var masterEmiData = [];
    var productList = [];
    var showSearchFilters = false;
    var comparisonData = [];
    var availableFilters = [];
    var filtersApplied = [];
    var selectedVariant = [];
    var productDetailSelected = false;
    var pageId = '';
    var searchTerm = '';

    var getSearchTerm = function () {
        return searchTerm;
    };

    var setSearchTerm = function (value) {
        searchTerm = value;
    };

    var getPageId = function () {
        return pageId;
    };

    var setPageId = function (value) {
        pageId = value;
    };

    var getProductDetailSelected = function () {
        return productDetailSelected;
    };

    var setProductDetailSelected = function (value) {
        productDetailSelected = value;
    };

    var getSelectedVariant = function () {
        return selectedVariant
    };

    var setSelectedVariant = function (value) {
        selectedVariant = value;
    };

    var getFiltersApplied = function () {
        return filtersApplied;
    };

    var setFiltersApplied = function (value) {
        filtersApplied = value;
    };

    var getAvailableFilters = function () {
        return availableFilters;
    };

    var setAvailableFilters = function (value) {
        availableFilters = value;
    };

    var getComparisonData = function () {
        return comparisonData;
    };

    var setComparisonData = function (value) {
        comparisonData = value;
    };


    var getShowSearchFilters = function () {
        return showSearchFilters;
    };

    var setShowSearchFilters = function (value) {
        showSearchFilters = value;
    };

    var getProductList = function () {
        return productList;
    };

    var setProductList = function (value) {
        productList = value;
    };

    var getMasterEmiData = function () {
        return masterEmiData;
    };

    var setMasterEmiData = function (value) {
        masterEmiData = value;
    };

    var getLandingBanners = function () {
        return landingBanners;
    };

    var setLandingBanners = function (value) {
        landingBanners = value;
    };

    var getProductDetails = function () {
        return productDetails;
    };

    var setProductDetails = function (value) {
        productDetails = value;
    };

    var getSelectedOffer = function () {
        return selectedOffer;
    };

    var setSelectedOffer = function (value) {
        selectedOffer = value;
    };

    var getOfferDetails = function () {
        return offerDetails;
    };

    var setOfferDetails = function (value) {
        offerDetails = value;
    };

    var getSelectedOem = function () {
        return selectedOem;
    };

    var getSelectedOemName = function () {
        return selectedOemName;
    };

    var setSelectedOem = function (value) {
        selectedOem = value;
    };

    var setSelectedOemName = function (value) {
        selectedOemName = value;
    };

    var getOfferList = function () {
        return offerList;
    };

    var setOfferList = function (value) {
        offerList = value;
    };

    var getOemOfferList = function () {
        return oemOfferList;
    };

    var setOemOfferList = function (value) {
        oemOfferList = value;
    };

    var getOemList = function () {
        return oemList
    };

    var setOemList = function (value) {
        oemList = value;
    };


    var getOEMListService = function () {
        var q = $q.defer();
        var obj = {};
        AdapterUtils.postData("adapters/OMPAdapter/automallOemCarList/", obj, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var getAutomallBanners = function () {
        var q = $q.defer();
        var obj = {};
        AdapterUtils.postData("adapters/OMPAdapter/automallBanners/", obj, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var getOfferListService = function () {
        var q = $q.defer();
        AdapterUtils.postData("adapters/OMPAdapter/automallOfferList/", {}, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var getOfferOnBrandList = function () {
        var q = $q.defer();
        var obj = {};
        AdapterUtils.postData("adapters/OMPAdapter/automallBrandOffer/", obj, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var getOfferDetailsService = function (obj) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/OMPAdapter/automallOfferDetails", { 'offerCode': obj }, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var getProductDetailsService = function (obj) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/OMPAdapter/automallProductDetails", { 'modelCode': obj.modelCode }, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var getEmiMasterService = function () {
        var q = $q.defer();
        AdapterUtils.postData('adapters/OMPAdapter/automallCalculatorDetails/', {}, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });

        return q.promise;
    };

    var getAvailableCarListService = function (obj) {
        var q = $q.defer();
        AdapterUtils.postData('adapters/OMPAdapter/automallAvailableCars/', obj, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });

        return q.promise;
    };

    var getStateCityDealerList = function (obj) {
        var q = $q.defer();
        AdapterUtils.postData('adapters/OMPAdapter/automallStateCityDealers?=', { 'oemCode': obj }, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var leadCaptureService = function (obj) {
        var q = $q.defer();
        AdapterUtils.postData('adapters/OMPAdapter/automallLead/', obj, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var getOemModelsService = function (obj) {
        var q = $q.defer();
        AdapterUtils.postData('adapters/OMPAdapter/automallOemModels', { 'oemCode': obj.oemCode }, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var getLoanSteps = function () {
        var q = $q.defer();
        AdapterUtils.postData('adapters/OMPAdapter/automallLoanSteps/', {}, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var getPaclBanners = function () {
        var q = $q.defer();
        AdapterUtils.postData('adapters/OMPAdapter/automallCarloanBanner/', {}, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var carSearchService = function (obj) {
        var q = $q.defer();
        AdapterUtils.postData('adapters/OMPAdapter/automallCarSearch', obj, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var getSearchList = function () {
        var q = $q.defer();
        AdapterUtils.postData('adapters/OMPAdapter/automallAutosuggestKeywords/', {}, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var compareCarService = function (obj) {
        var q = $q.defer();
        var qp = {};
        qp.primaryVariantCode = obj.variantcode1; qp.secondaryVariantCode = obj.variantcode2; qp.city = obj.city;
        AdapterUtils.postData('adapters/OMPAdapter/automallCompareCars', qp, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    var getSbiOffers = function () {
        var q = $q.defer();
        AdapterUtils.postData('adapters/OMPAdapter/automallSbiOffers/', {}, true).then(function (response) {
            q.resolve(response);
        }, function (error) {
            q.reject(error);
        });
        return q.promise;
    };

    /**
     * All the functionality related to EMI Calculator
     */
    var emiCalc = {
        selectedTenure: '',
        tenures: [],
        loanAmount: 0,
        btnDescDisabled: false,
        btnInscDisabled: false,
        emi: 0,
        interest: 0,
        isPaclCustomer: false,
        maxLoanConfig: 9999999999,
        maxLoanAmount: 0,
        minLoanAmount: 0,
        minTenure: 12,
        maxTenure: 84,
        termsAndConditions: [],
        paclData: [],
        disableAuto: false,


        clear: function () {
            // reset the models
            emiCalc.selectedTenure = '';
            emiCalc.tenures = [];
            emiCalc.loanAmount = 0;
            emiCalc.btnDescDisabled = false;
            emiCalc.btnInscDisabled = false;
            emiCalc.emi = 0;
            emiCalc.interest = 0;
            emiCalc.maxLoanConfig = 9999999999;
            emiCalc.maxLoanAmount = emiCalc.maxLoanConfig;
            emiCalc.minLoanAmount = 0;
            emiCalc.minTenure = 12;
            emiCalc.maxTenure = 84;
            emiCalc.termsAndConditions = [];
            emiCalc.isPaclCustomer = false;
            emiCalc.disableAuto = false;

        },

        init: function () {
            var landingBannerData = getLandingBanners().data[0];
            emiCalc.defaultLoanAmount = parseFloat(landingBannerData.nonPaclLoanAmount);
            // load the EMI calculation details
            var temp = getMasterEmiData().data;
            for (var index = 0; index < temp.length; index++) {
                if (temp[index].type == 'vehicle') {
                    temp = temp[index];
                }
            }

            emiCalc.clear();
            emiCalc.minTenure = temp.minTenure;
            emiCalc.maxTenure = temp.maxTenure;
            emiCalc.minLoanAmount = parseFloat(temp.minLoanAmount);
            emiCalc.interest = parseFloat(temp.intRate);
            //emiCalc.loanAmount = emiCalc.minLoanAmount;

            for (var ten = emiCalc.minTenure; ten <= emiCalc.maxTenure; ten++) {
                emiCalc.tenures.push(ten);
            }
            emiCalc.selectedTenure = emiCalc.maxTenure;


            emiCalc.calculateEmi();

            emiCalc.paclData = paclService.getPACLData();

            // conditions for display amount based on variant price if coming from variant selection.
            if (getSelectedVariant() != undefined) {
                if (emiCalc.maxLoanAmount > getSelectedVariant().price && getSelectedVariant().price != undefined && getSelectedVariant().price > emiCalc.minLoanAmount) {
                    emiCalc.maxLoanAmount = getSelectedVariant().price;
                    if (emiCalc.paclData && emiCalc.paclData.bannerFlag == "True") {
                        // conditions for pacl customer
                        if (getSelectedVariant().price < emiCalc.paclData.amount) {
                            emiCalc.loanAmount = emiCalc.maxLoanAmount;
                            emiCalc.isPaclCustomer = true;
                        } else {
                            emiCalc.loanAmount = emiCalc.paclData.amount;
                            emiCalc.isPaclCustomer = true;
                        }
                    } else {
                        // conditions based on non pacl customer
                        emiCalc.loanAmount = emiCalc.defaultLoanAmount;
                    }
                }
            } else {
                // not coming from product details page
                // check if user is PACL
                if (emiCalc.paclData != undefined) {
                    if (emiCalc.paclData.bannerFlag == "True") {
                        emiCalc.isPaclCustomer = true;
                        emiCalc.paclData.amount = parseFloat(emiCalc.paclData.amount);
                        emiCalc.loanAmount = emiCalc.paclData.amount;
                    }
                    else {
                        emiCalc.isPaclCustomer = false;
                        emiCalc.loanAmount = emiCalc.defaultLoanAmount;
                    }
                }
                else {
                    emiCalc.isPaclCustomer = false;
                    emiCalc.loanAmount = emiCalc.defaultLoanAmount;
                }
            }


            emiCalc.amountChanaged();

        },

        /**
         * Refresh the carousel and add style is not already added
         */
        updateCarousel: function () {
            setTimeout(function () {
                var id = "automallEmiTenuresmyslide" + emiCalc.tenures.indexOf(emiCalc.selectedTenure);
                if (!document.getElementById(id).classList.contains('morph-carousel_main')) {
                    document.getElementById(id).classList.add("morph-carousel_main")
                }
                document.getElementById("automallEmiTenureslabel" + emiCalc.tenures.indexOf(emiCalc.selectedTenure)).innerHTML = 'Months';
                $morphCarousel.update('automallEmiTenures');
            }, 100);
        },

        /**
         * - button is clicked
         */
        descreaseLAmt: function () {
            emiCalc.btnDescDisabled = false;
            emiCalc.btnInscDisabled = false;
            if (typeof (emiCalc.loanAmount) != "number") {
                emiCalc.loanAmount = parseInt(emiCalc.loanAmount);
            }
            if (emiCalc.loanAmount - 15000 <= emiCalc.minLoanAmount) {
                emiCalc.loanAmount = emiCalc.minLoanAmount;
                emiCalc.btnDescDisabled = true;
            } else {
                emiCalc.loanAmount = emiCalc.loanAmount - 15000;
            }
            if (!emiCalc.disableAuto && emiCalc.paclData && emiCalc.paclData.bannerFlag && emiCalc.loanAmount <= emiCalc.paclData.amount) {
                emiCalc.isPaclCustomer = true
            }

            emiCalc.calculateEmi();
        },

        /**
         * = button is clicked
         */
        increaseLAmt: function () {
            emiCalc.btnDescDisabled = false;
            emiCalc.btnInscDisabled = false;
            if (typeof (emiCalc.loanAmount) != "number") {
                emiCalc.loanAmount = parseInt(emiCalc.loanAmount);
            }
            if (emiCalc.loanAmount + 15000 >= emiCalc.maxLoanAmount) {
                emiCalc.loanAmount = emiCalc.maxLoanAmount;
                emiCalc.btnInscDisabled = true;

            } else {
                emiCalc.loanAmount = emiCalc.loanAmount + 15000;
            }

            if (!emiCalc.disableAuto && emiCalc.paclData && emiCalc.paclData.bannerFlag && emiCalc.loanAmount > emiCalc.paclData.amount) {
                emiCalc.isPaclCustomer = false;
            }

            emiCalc.calculateEmi();
        },

        /**
         * Calculate the EMI amount
         */
        calculateEmi: function () {
            var p = parseFloat(emiCalc.loanAmount);
            var i = (emiCalc.interest / 1200);
            if (emiCalc.isPaclCustomer) {
                try {
                    i = parseFloat(emiCalc.paclData.interest) / 1200;
                } catch(err) {
                    console.log(err);
                }
            }
            var t = emiCalc.selectedTenure;
            var numerator = p * i * Math.pow((1 + i), t);
            var denominator = Math.pow((1 + i), t) - 1;
            emiCalc.emi = Math.round((numerator / denominator));
            //for 2 digit decimal 
            //emiCalc.emi = Math.round(((numerator / denominator) + Number.EPSILON) * 100) / 100;
        },

        /**
         * Checks the amount validation and enabled / disables the buttons
         */
        amountChanaged: function () {
            emiCalc.btnInscDisabled = false;
            emiCalc.btnDescDisabled = false;
            if (emiCalc.loanAmount >= emiCalc.maxLoanAmount) {
                // if loan amount is more than max amount set it to max amount and disable the + button
                emiCalc.loanAmount = emiCalc.maxLoanAmount;
                emiCalc.btnInscDisabled = true;
            } else if (emiCalc.loanAmount <= emiCalc.minLoanAmount) {
                // if loan amount is less than min amount set it to min amount and disable the - button
                emiCalc.loanAmount = emiCalc.minLoanAmount;
                emiCalc.btnDescDisabled = true;
            }

            if (!emiCalc.disableAuto && emiCalc.paclData && emiCalc.paclData.bannerFlag && emiCalc.loanAmount > emiCalc.paclData.amount) {
                emiCalc.isPaclCustomer = false;
            } else if (!emiCalc.disableAuto && emiCalc.paclData && emiCalc.paclData.bannerFlag && emiCalc.loanAmount < emiCalc.paclData.amount && emiCalc.paclData < emiCalc.maxLoanAmount) {
                emiCalc.isPaclCustomer = true
            }

            emiCalc.calculateEmi();

            setTimeout(function () {
                // to refresh the view
                $rootScope.$apply(function () { });
            }, 500);
        },

        userClicked: function () {
            if (!emiCalc.isPaclCustomer) {
                emiCalc.disableAuto = true;
            } else {
                emiCalc.disableAuto = false;
            }

        },

        /**
         * Pre approved loan control is toggled
         */
        paclToggle: function () {
            // check if the user is PACL customer and set max amount and loan amount accordingly
            if (!emiCalc.isPaclCustomer) {
                emiCalc.loanAmount = emiCalc.defaultLoanAmount;
                emiCalc.maxLoanAmount = emiCalc.maxLoanConfig;
            } else {
                // emiCalc.maxLoanAmount = emiCalc.paclData.amount;
                emiCalc.loanAmount = emiCalc.paclData.amount;
            }

            // check if the user is coming from product details and set max amount accordingly
            if (undefined != getSelectedVariant() && emiCalc.maxLoanAmount > getSelectedVariant().price) {
                emiCalc.maxLoanAmount = getSelectedVariant().price;
                emiCalc.loanAmount = emiCalc.maxLoanAmount;
            }

            emiCalc.amountChanaged();
        }
    };

    /**
     * Clear all the stored data from factory.
     */
    var clear = function () {
        selectedProduct = [];
        oemList = [];
        offerList = [];
        oemOfferList = [];
        oemSelected = false;
        selectedOem = [];
        selectedOemName = [];
        offerDetails = [];
        selectedOffer = '';
        productDetails = {};
        landingBanners = [];
        masterEmiData = [];
        productList = [];
        showSearchFilters = false;
        comparisonData = [];
        availableFilters = [];
        filtersApplied = [];
        selectedVariant = [];
    };

    return {
        clear: clear,
        selectedProduct: selectedProduct,
        setOemList: setOemList,
        getOemList: getOemList,
        getOEMListService: getOEMListService,
        getAutomallBanners: getAutomallBanners,
        getOfferListService: getOfferListService,
        getOfferOnBrandList: getOfferOnBrandList,
        getOfferList: getOfferList,
        setOfferList: setOfferList,
        getOemOfferList: getOemOfferList,
        setOemOfferList: setOemOfferList,
        oemSelected: oemSelected,
        getSelectedOem: getSelectedOem,
        setSelectedOem: setSelectedOem,
        getSelectedOemName: getSelectedOemName,
        setSelectedOemName: setSelectedOemName,
        getOfferDetails: getOfferDetails,
        setOfferDetails: setOfferDetails,
        getOfferDetailsService: getOfferDetailsService,
        getSelectedOffer: getSelectedOffer,
        setSelectedOffer: setSelectedOffer,
        getProductDetails: getProductDetails,
        setProductDetails: setProductDetails,
        getProductDetailsService: getProductDetailsService,
        getLandingBanners: getLandingBanners,
        setLandingBanners: setLandingBanners,
        getMasterEmiData: getMasterEmiData,
        setMasterEmiData: setMasterEmiData,
        getEmiMasterService: getEmiMasterService,
        getAvailableCarListService: getAvailableCarListService,
        getProductList: getProductList,
        setProductList: setProductList,
        getStateCityDealerList: getStateCityDealerList,
        leadCaptureService: leadCaptureService,
        getOemModelsService: getOemModelsService,
        getLoanSteps: getLoanSteps,
        getPaclBanners: getPaclBanners,
        carSearchService: carSearchService,
        getSearchList: getSearchList,
        compareCarService: compareCarService,
        getSbiOffers: getSbiOffers,
        emiCalc: emiCalc,
        setShowSearchFilters: setShowSearchFilters,
        getShowSearchFilters: getShowSearchFilters,
        setComparisonData: setComparisonData,
        getComparisonData: getComparisonData,
        getAvailableFilters: getAvailableFilters,
        setAvailableFilters: setAvailableFilters,
        getFiltersApplied: getFiltersApplied,
        setFiltersApplied: setFiltersApplied,
        getSelectedVariant: getSelectedVariant,
        setSelectedVariant: setSelectedVariant,
        getProductDetailSelected: getProductDetailSelected,
        setProductDetailSelected: setProductDetailSelected,
        getPageId: getPageId,
        setPageId: setPageId,
        getSearchTerm: getSearchTerm,
        setSearchTerm: setSearchTerm
    };
});
