'use strict';
angularApp.controller('filterCategoryController', [
		"$state", 
		"$scope", 
		"$ionicPopup", 
		"utilityService", 
		"filterService", 
		"searchListServices",
		"ompMerchantsService",
		"mPinLoginService",
		"clickStreamService",
		"$ionicSideMenuDelegate",
		function($state, 
				$scope, 
				$ionicPopup, 
				utilityService, 
				filterService, 
				searchListServices,
				ompMerchantsService,
				mPinLoginService,
				clickStreamService,
				$ionicSideMenuDelegate) {
			var filterCategoryControllerVm = this;
			$scope.data = {
				cf : ''
			};
			$scope.toggleGroupLevelTwo = function(groupSub, arr,isHide) {

				if(!$scope.hideThree){
					groupSub.show = false
				}
				$scope.hideThree = isHide;
				$scope.isDisabledButton = false;

				$scope.selectedCategoryId = groupSub.id;
				if (groupSub.childrenData.length > 0) {
					if ($scope.isGroupShownLevelTwo(groupSub.name)) {
						$scope.shownGroupSub2 = null;
					} else {
						$scope.shownGroupSub2 = groupSub.name;
					}
					if (groupSub.show == false || groupSub.show == undefined) {
						if (arr && ((groupSub.show == undefined) || (groupSub.show == false))) {
							angular.forEach(arr, function(value, key) {
								value.show = false;
							});
						}
						groupSub.show = true;
					} else {
						groupSub.show = false
					}
				}else{
					$scope.setThreeData = "";
				}
			
			};
			$scope.isGroupShownLevelTwo = function(groupSub) {
				return groupSub.show;
			};
			$scope.toggleGroupSubOne = function(groupSub, arr,isHide) {
				if(!$scope.hideSecond){
					groupSub.show = false
				}
				$scope.hideSecond = isHide;
				$scope.isDisabledButton = false;
				if ($scope.isGroupShownSub(groupSub.name)) {
					$scope.shownGroupSub = null;
				} else {
					$scope.shownGroupSub = groupSub.name;
				}
				if (groupSub.show == false || groupSub.show == undefined) {
					if (arr && ((groupSub.show == undefined) || (groupSub.show == false))) {
						angular.forEach(arr, function(value, key) {
							value.show = false;
						});
					}
					groupSub.show = true;
				} else {
					groupSub.show = false
				}
			};
			$scope.isGroupShownSub = function(groupSub) {
			   return groupSub.show;
			};
			$scope.selectedCategorieLevelOne = function(levelOne) {
				$scope.setOneData = levelOne.name;
			}
			$scope.selectedCategorieLevelTwo = function(levelTwo) {
				
				if($scope.setTwoData == levelTwo.name){
					$scope.setTwoData = levelTwo.name;
				}else{
					$scope.setTwoData = levelTwo.name;
					$scope.setThreeData = "";
				}
				}
			$scope.selectedCategorieLevelThree = function(levelThree) {
				$scope.setThreeData = levelThree.name;
				$scope.selectedCategoryId = levelThree.id;
				
			}
			filterCategoryControllerVm.goBack = function() {
				$state.go('menu.filter');
			};
			this.clear = function() {
				$scope.isDisabledButton = true;
				$scope.filterOption = "clear";
				filterService.selectedCategoryId = '';
				$scope.selectedLevelOneData = filterService.selectedLevelOneData;
				$scope.selectedLevelTwoData = filterService.selectedLevelTwoData;
				$scope.selectedLevelThreeData = filterService.selectedLevelThreeData;
				$scope.setThreeData = filterService.selectedLevelThreeData;
				$scope.setTwoData = filterService.selectedLevelTwoData;
				$scope.setOneData = filterService.selectedLevelOneData;;
				$scope.shownGroupSub = '';
				$scope.shownGroupSub2 = '';

				$scope.hideFirst = false;
				$scope.hideSecond = false;
				$scope.hideThree = false;
			};
			this.apply = function() {
				$scope.filterOption = "apply";
				filterService.selectedLevelOneData = $scope.setOneData;
				filterService.selectedLevelTwoData = $scope.setTwoData;
				filterService.selectedLevelThreeData = $scope.setThreeData;
				filterService.selectedCategoryId = $scope.selectedCategoryId;
				$scope.hideFirst = false;
				$scope.hideSecond = false;
				$scope.hideThree = false;
				if(utilityService.isUndefined($scope.setThreeData)){
					if(utilityService.isUndefined($scope.setTwoData)){
						searchListServices.searchFor =  searchListServices.searchFor;
					}else{
						searchListServices.searchFor =  $scope.setTwoData;
					}
				}else{
					searchListServices.searchFor =  $scope.setThreeData;
				}

					var obj = {
						"category" : filterService.selectedCategoryId,
						"websiteId" : ompMerchantsService.listName.websiteId,
						"filters" : [],
						"sort" : {},
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getSelectedCategoryProduct(obj).then(function(data) {
						filterService.filterOldData = searchListServices.filterData;
						searchListServices.allProductsList = data;
						searchListServices.isCompareAvailable = true;
						searchListServices.serviceFrom = 'getSelectedCategoryProduct';
						searchListServices.serviceFromObj = obj;
						searchListServices.products.length = 0
						filterService.addedFilterFullData.length = 0
						filterService.addedFilterData.length = 0
						filterService.selectedColour.length = 0
						searchListServices.filterNewData = {
						                	          		categoryList : [],
						                	          		subCategoryList : [],
						                	          		colorList : [],
						                	          		priceList : [],
						                	          		callFunctionsList : []
						                	          	};
						filterService.isFilterApplied = false;
						searchListServices.isSortApplied = false;
						if(filterService.filterNewData.priceList[0]){
						filterService.filterNewData.priceList[0].min = searchListServices.filterData.priceList[0].min;
						filterService.filterNewData.priceList[0].max = searchListServices.filterData.priceList[0].max; 
						}
						$state.go('menu.filter');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				
				
			};
			$scope.$on('$ionicView.beforeLeave', function(){
				   ompMerchantsService.endTimer();
				});
			$scope.$on('$ionicView.afterEnter', function() {
				ompMerchantsService.startTimer();
			});	
			$scope.$on('$ionicView.beforeEnter', function() {
				$scope.data.categories = "";
				$scope.filterItems = searchListServices.filterData.categoryList[0];
				var subList=searchListServices.filterData.subCategoryList;
				var filteredSubCat=[];
				var subListLen = subList.length; 
				for(var i=0;i<subListLen;i++)
					{
					if(subList[i].name==filterService.selectedLevelOneData)
						{
						
						filteredSubCat.push(subList[i]);
						
						}
					}
				$scope.categoriesItems = filteredSubCat;
				$scope.categoriesSubListItems = $scope.categoriesItems[0].childrenData;
				$scope.setThreeData = filterService.selectedLevelThreeData;
				$scope.setTwoData = filterService.selectedLevelTwoData;
				$scope.setOneData = filterService.selectedLevelOneData;
				$scope.selectedCategoriesName = "";
				$scope.selectedSubCategoriesName = "";
				$scope.selectedCategoryId = "";
				$scope.shownGroupSub = '';
				$scope.shownGroupSub2 = '';
				$scope.filterOption = "clear";
				$scope.isDisabledButton = true;
				$scope.hideFirst = false;
				$scope.hideSecond = false;
				$scope.hideThree = false;
				$scope.dataFirst = filterService.selectedLevelOneData;
				$scope.dataSecond = filterService.selectedLevelTwoData;
				$scope.dataThree = filterService.selectedLevelThreeData;

				$scope.isSetThreeData = true
				$scope.isSetTwoData = true;
				$scope.issetOneData = true;
				
				var arr = $scope.categoriesItems;
				var keyVal = 0;
				angular.forEach(arr, function(value, key) {
							if(arr[key].name == filterService.selectedLevelOneData){
								$scope.toggleGroupSubOne( arr[key] , arr,false);
								key = keyVal;
							}
						});
						
				var arr = arr[keyVal].childrenData;		
				angular.forEach(arr, function(value, key) {
							if(arr[key].name == filterService.selectedLevelTwoData){
								$scope.toggleGroupLevelTwo( arr[key] , arr,false);
							}
						});		
				$scope.addDataToClickStream();
				$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			});
			$scope.addDataToClickStream = function() {
									if(ompMerchantsService){
										if(ompMerchantsService.listName){
											clickStreamService.clickStreamData = "websiteId,"+ompMerchantsService.listName.affiliateId;
									 }	
									};	
							};
			return this;
		}
]);
