'use strict';
angularApp.controller('filterCategoryListController', [
		"$state", 
		"$scope", 
		"$ionicPopup", 
		"utilityService", 
		"filterService", 
		"searchListServices",
		"ompMerchantsService",
		"productDescriptionServices",
		"mPinLoginService",
		"clickStreamService",
		"$ionicSideMenuDelegate",
		function($state, 
				$scope, 
				$ionicPopup, 
				utilityService, 
				filterService, 
				searchListServices,
				ompMerchantsService,
				productDescriptionServices,
				mPinLoginService,
				clickStreamService,
				$ionicSideMenuDelegate) {
			var filterCategoryControllerVm = this;
			$scope.data = {
				cf : ''
			};
			$scope.toggleGroupLevelTwo = function(groupSub, arr,isHide) {

				$scope.isDisabledButton = false;
				$scope.selectedCategoryId = groupSub.value;
				if (groupSub.childrenData.length > 0) {
					if ($scope.isGroupShownLevelTwo(groupSub.label)) {
						$scope.shownGroupSub2 = null;
					} else {
						$scope.shownGroupSub2 = groupSub.label;
					}
					if (groupSub.show == false || groupSub.show == undefined) {
						if (arr && ((groupSub.show == undefined) || (groupSub.show == false))) {
							angular.forEach(arr, function(value, key) {
								value.show = false;
							});
						}
						groupSub.show = true;
					} else {
						groupSub.show = false
					}
				}else{
					$scope.setThreeData = "";
					
				}
			
			};
			$scope.isGroupShownLevelTwo = function(groupSub) {
				return groupSub.show;
			};
			$scope.toggleGroupSubOne = function(groupSub, arr,isHide) {
				$scope.isDisabledButton = false;
				if ($scope.isGroupShownSub(groupSub.label)) {
					$scope.shownGroupSub = null;
				} else {
					$scope.shownGroupSub = groupSub.label;
				}
				if (groupSub.show == false || groupSub.show == undefined) {
					if (arr && ((groupSub.show == undefined) || (groupSub.show == false))) {
						angular.forEach(arr, function(value, key) {
							value.show = false;
						});
					}
					groupSub.show = true;
				} else {
					groupSub.show = false
				}
			};
			$scope.isGroupShownSub = function(groupSub) {
				return groupSub.show;
			};
			$scope.selectedCategorieLevelOne = function(levelOne) {
				$scope.setOneData = levelOne.label;
				}
			$scope.selectedCategorieLevelTwo = function(levelTwo) {
				
				if($scope.setTwoData == levelTwo.label){
					$scope.setTwoData = levelTwo.label;
				}else{
					$scope.setTwoData = levelTwo.label;
					$scope.setThreeData = "";
				}
			}
			$scope.selectedCategorieLevelThree = function(levelThree) {
				$scope.setThreeData = levelThree.label;
				$scope.selectedCategoryId = levelThree.value;
				$scope.isDisabledButton = false;
			}
			filterCategoryControllerVm.goBack = function() {
				$state.go('menu.filter');
			};
			this.clear = function() {
				$scope.isDisabledButton = true;
				$scope.filterOption = "clear";
				filterService.selectedCategoryId = '';
				$scope.selectedLevelOneData = filterService.selectedLevelOneData;
				$scope.selectedLevelTwoData = filterService.selectedLevelTwoData;
				$scope.selectedLevelThreeData = filterService.selectedLevelThreeData;
				$scope.setThreeData = filterService.selectedLevelThreeData;
				$scope.setTwoData = filterService.selectedLevelTwoData;
				$scope.setOneData = filterService.selectedLevelOneData;;
				$scope.shownGroupSub = '';
				$scope.shownGroupSub2 = '';

				$scope.hideFirst = false;
				$scope.hideSecond = false;
				$scope.hideThree = false;
			};
			this.apply = function() {
				$scope.filterOption = "apply";
				filterService.selectedLevelOneData = $scope.setOneData;
				filterService.selectedLevelTwoData = $scope.setTwoData;
				filterService.selectedLevelThreeData = $scope.setThreeData;
				filterService.selectedCategoryId = $scope.selectedCategoryId;
				if(utilityService.isUndefined($scope.setThreeData)){
					if(utilityService.isUndefined($scope.setTwoData)){
						searchListServices.searchFor =  searchListServices.searchFor;
					}else{
						searchListServices.searchFor =  $scope.setTwoData;
					}
				}else{
					searchListServices.searchFor =  $scope.setThreeData;
				}
				$scope.catObj=[{
					"value" : "category",
					"data" : [filterService.selectedCategoryId]
				}]
				if (searchListServices.serviceFrom === 'getSearchProductsList') {
					var obj = {
						"websiteId" : ompMerchantsService.listName.websiteId,
						"keyword" : searchListServices.serviceFromObj.keyword,
						"filters" : $scope.catObj,
						"sort" : {},
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getSearchProductsList(obj).then(function(data) {
						filterService.filterOldData = searchListServices.filterData;
						searchListServices.allProductsList = data;
						searchListServices.products.length = 0
						filterService.addedFilterFullData.length = 0
						filterService.addedFilterData.length = 0
						filterService.selectedColour.length = 0
						searchListServices.isCompareAvailable = true;
						searchListServices.serviceFrom = 'getSearchProductsList';
						searchListServices.serviceFromObj = obj;
						filterService.addedFilterData = $scope.catObj;
						filterService.isFilterApplied = true;
						searchListServices.isSortApplied = false;
						searchListServices.filterNewData = {
						                	          		categoryList : [],
						                	          		subCategoryList : [],
						                	          		colorList : [],
						                	          		priceList : [],
						                	          		callFunctionsList : []
						                	          	};
						$state.go('menu.filter');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else if (searchListServices.serviceFrom === 'getRecentlyViewedListing') {
					var recentProductsList = {
						"websiteId" : ompMerchantsService.listName.websiteId,
						"filters" : $scope.catObj,
						"sort" : {},
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getRecentlyViewedCategoryListing(recentProductsList).then(function(data) {
						filterService.filterOldData = searchListServices.filterData;
						searchListServices.allProductsList = data;
						searchListServices.products.length = 0
						filterService.addedFilterFullData.length = 0
						filterService.addedFilterData.length = 0
						filterService.selectedColour.length = 0
						searchListServices.isCompareAvailable = false;
						searchListServices.serviceFrom = 'getRecentlyViewedListing';
						searchListServices.serviceFromObj = recentProductsList;
						filterService.addedFilterData = $scope.catObj;
						filterService.isFilterApplied = true;
						searchListServices.isSortApplied = false;
						searchListServices.filterNewData = {
						                	          		categoryList : [],
						                	          		subCategoryList : [],
						                	          		colorList : [],
						                	          		priceList : [],
						                	          		callFunctionsList : []
						                	          	};
						$state.go('menu.filter');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else if (searchListServices.serviceFrom === 'getSimilarProductList') {
					var similarProductsList = {
						"websiteId" : ompMerchantsService.listName.websiteId,
						"productId" : searchListServices.serviceFromObj.productId,
						"price" : searchListServices.serviceFromObj.price,
						"filters" : $scope.catObj,
						"sort" : {},
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					};
					productDescriptionServices.getSimilarProductCategoryList(similarProductsList).then(function(data) {
						filterService.filterOldData = searchListServices.filterData;
						searchListServices.allProductsList = data;
						searchListServices.products.length = 0
						filterService.addedFilterFullData.length = 0
						filterService.addedFilterData.length = 0
						filterService.selectedColour.length = 0
						searchListServices.isCompareAvailable = false;
						searchListServices.serviceFrom = 'getSimilarProductList';
						searchListServices.serviceFromObj = similarProductsList;
						filterService.addedFilterData = $scope.catObj;
						filterService.isFilterApplied = true;
						searchListServices.isSortApplied = false;
						searchListServices.filterNewData = {
						                	          		categoryList : [],
						                	          		subCategoryList : [],
						                	          		colorList : [],
						                	          		priceList : [],
						                	          		callFunctionsList : []
						                	          	};
						$state.go('menu.filter');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					var dealList = {
						"type" : searchListServices.serviceFromObj.type,
						"websiteId" : ompMerchantsService.listName.websiteId,
						"filters" : $scope.catObj,
						"sort" : {},
						"page" : '1',
						"isLoggedIn":mPinLoginService.isLoggedIn
					}
					searchListServices.getDealCategoryList(dealList).then(function(data) {
						filterService.filterOldData = searchListServices.filterData;
						searchListServices.allProductsList = data;
						searchListServices.products.length = 0
						filterService.addedFilterFullData.length = 0
						filterService.addedFilterData.length = 0
						filterService.selectedColour.length = 0
						searchListServices.isCompareAvailable = false;
						searchListServices.serviceFrom = searchListServices.serviceFrom;
						searchListServices.serviceFromObj = dealList;
						filterService.addedFilterData = $scope.catObj;
						filterService.isFilterApplied = true;
						searchListServices.isSortApplied = false;
						searchListServices.filterNewData = {
						                	          		categoryList : [],
						                	          		subCategoryList : [],
						                	          		colorList : [],
						                	          		priceList : [],
						                	          		callFunctionsList : []
						                	          	};
						$state.go('menu.filter');
					}, function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}
				
			};
			$scope.$on('$ionicView.beforeLeave', function(){
				   ompMerchantsService.endTimer();
			});
			$scope.$on('$ionicView.afterEnter', function() {
				ompMerchantsService.startTimer();
			});
			$scope.$on('$ionicView.beforeEnter', function() {
				$scope.data.categories = "";
				$scope.filterItems = searchListServices.filterData.categoryList;
				$scope.categoriesItems = searchListServices.filterData.subCategoryList;
				$scope.setThreeData = filterService.selectedLevelThreeData;
				$scope.setTwoData = filterService.selectedLevelTwoData;
				$scope.setOneData = filterService.selectedLevelOneData;
				$scope.selectedCategoriesName = "";
				$scope.selectedSubCategoriesName = "";
				$scope.selectedCategoryId = "";
				$scope.shownGroupSub = '';
				$scope.shownGroupSub2 = '';
				$scope.filterOption = "clear";
				$scope.isDisabledButton = true;
				$scope.addDataToClickStream();
				$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			});
			$scope.addDataToClickStream = function() {
									if(ompMerchantsService){
										if(ompMerchantsService.listName){
											clickStreamService.clickStreamData = "websiteId,"+ompMerchantsService.listName.affiliateId;
									 }	
									};	
							};
			return this;
		}
]);
