'use strict';
angularApp.service('localWishlistService', function($q, utilityService, AdapterUtils) {
	var getMerchantWishList = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getMerchantWishList", obj, true).then(function(response) {
			q.resolve(response.data);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	return {
		getMerchantWishList : getMerchantWishList
	};
});
