'use strict';
angularApp.service('ompMerchantsService', function ($q, utilityService, AdapterUtils, wishListService, $rootScope, cryptoService, encryptionService, $state, constantConfig,clickStreamService,loggedInUserService, mPinLoginService) {
	var listName = "";
	var merchantWishlistCount = "";
	var isLoggedIn = "";
	var firstTimeLoaded = "";
	var merchantsListData = '';
	var isMerchantsWishListAvl = '';
	var spendTime = '';
	var startTime = '';
	var endTime = '';
	var getStores = function (obj,hideLoader) {
		var q = $q.defer();
		/*Condition added for: Home Screen API Optimization: UX2.0*/
		if(hideLoader){
		AdapterUtils.postData("adapters/OMPAdapter/getMerchant", obj, false).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});	
		} else {
		AdapterUtils.postData("adapters/OMPAdapter/getMerchant", obj, true).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});
		}
		return q.promise;
	};
	var getAllCategory = function (obj,hideLoader) {
		var q = $q.defer();
		var adapterURL= loggedInUserService.shopNOrderPre ? constantConfig.omp.getAllCategoryPre : constantConfig.omp.getAllCategory; 
		if(hideLoader){
		AdapterUtils.postData(adapterURL, obj, false).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});	
		} else {
		AdapterUtils.postData(adapterURL, obj, true).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});
		}
		return q.promise;
	};
	var getTopCategory = function (obj,hideLoader) {
		var q = $q.defer();
		var adapterURL= loggedInUserService.shopNOrderPre ? constantConfig.omp.getTopCategoryPre : constantConfig.omp.getTopCategory; 
		if(hideLoader){
		AdapterUtils.postData(adapterURL, obj, false).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});	
		} else {
		AdapterUtils.postData(adapterURL, obj, true).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});
		}
		return q.promise;
	};
	var getWhatNewMerchants = function (obj,hideLoader) {
		var q = $q.defer();
		var adapterURL= loggedInUserService.shopNOrderPre ? constantConfig.omp.newOnYONOPre : constantConfig.omp.newOnYONO; 
		if(hideLoader){
		AdapterUtils.postData(adapterURL, obj, false).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});	
		} else {
		AdapterUtils.postData(adapterURL, obj, true).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});
		}
		return q.promise;
	};
	var getFreqViewMerchants = function (obj,hideLoader) {
		var q = $q.defer();
		if(hideLoader){
		AdapterUtils.postData("adapters/OMPAdapter/getFreqViewMerchants", obj, false).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});	
		} else {
		AdapterUtils.postData("adapters/OMPAdapter/getFreqViewMerchants", obj, true).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});
		}
		return q.promise;
	};
	var getMerchantsByCategory = function (obj,hideLoader) {
		var q = $q.defer();
		var adapterURL= loggedInUserService.shopNOrderPre ? constantConfig.omp.getMerchantsByCategoryPre : constantConfig.omp.getMerchantsByCategory; 
		if(hideLoader){
		AdapterUtils.postData(adapterURL, obj, false).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});	
		} else {
		AdapterUtils.postData(adapterURL, obj, true).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});
		}
		return q.promise;
	};
	var getBestOfYono = function (obj,hideLoader) {
		var q = $q.defer();
		var adapterURL= loggedInUserService.shopNOrderPre ? constantConfig.omp.getPopularOfferPre : constantConfig.omp.getPopularOffer; 
		if(hideLoader){
		AdapterUtils.postData(adapterURL, obj, false).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});	
		} else {
		AdapterUtils.postData(adapterURL, obj, true).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});
		}
		return q.promise;
	};
	var getTopBrands = function (obj,hideLoader) {
		var q = $q.defer();
		if(hideLoader){
		AdapterUtils.postData("adapters/OMPAdapter/getTopBrands", obj, false).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});	
		} else {
		AdapterUtils.postData("adapters/OMPAdapter/getTopBrands", obj, true).then(function (response) {
			q.resolve(response.data);
		}, function (error) {
			q.reject(error);
		});
		}
		return q.promise;
	};
	var showHeader = function showHeader() {
		var header = document.getElementById("nav1");
		var header1 = document.getElementById("nav2");
		var header2 = document.getElementById("nav3");
		if (header.classList) {
			if (header.classList.contains('hide')) {
				header.classList.remove('hide');
			}
		}
		if (header1.classList) {
			if (header1.classList.contains('hide')) {
				header1.classList.remove('hide');
			}
		}
		if (header2.classList) {
			if (header2.classList.contains('hide')) {
				header2.classList.remove('hide');
			}
		}
	}
	var inAppBrowser = function (url,merchantDetails) {
		var ompPageId ='';
		var affiliateId ='';
		var exitPopupContent ='';
		var showPOPUPFlag=true;
		if(merchantDetails){
			ompPageId = merchantDetails.pageId ? merchantDetails.pageId : '';
			affiliateId= merchantDetails.affiliateId ? merchantDetails.affiliateId : '' ; 
			exitPopupContent= merchantDetails.exitPopupContent ? merchantDetails.exitPopupContent : '' ; 
		}
		var ref;

		if(merchantDetails == undefined || (merchantDetails && merchantDetails.offerHeaderCount == "0")){
			ref = cordova.ThemeableBrowser.open(url, '_blank', {
				statusbar: {
					color: '#ffffffff'
				},
				toolbar: {
					height: 44,
					color: '#ffffffff',
					image: 'share'
				},

				closeButton: {
					wwwImage: 'img/OMP/inAppBack.png',
					align: 'left',
					event: 'closePressed'
				},
				backButtonCanClose: true,
				showPOPUP: true
			});
		}else {
			ref = cordova.ThemeableBrowser.open(url, '_blank', {
				statusbar: {
					color: '#ffffffff'
				},
				toolbar: {
					height: 44,
					color: '#ffffffff',
					image: 'share'
				},

			closeButton: {
				wwwImage: 'img/OMP/inAppBack.png',
				align: 'left',
				event: 'closePressed'
			},

				customButtons: [{
					
					wwwImage: 'img/OMP/offerBtn.png', 
					align: 'right',
					event: 'sharePressed'
				}],
				backButtonCanClose: true,
				showPOPUP: true
			});

		}
		
		ref.addEventListener('closePressed', function (e) {
            var headerElem = document.querySelector('body');
			if (!showPOPUPFlag) {
				return false;
			}
			else if(exitPopupContent){
				navigator.notification.confirm(exitPopupContent, function onConfirm(button) {
					if(button==1){
						showPOPUPFlag=false;
						clickStreamService.clickStreamData =affiliateId;
						if(!mPinLoginService.isLoggedIn){
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("PRE_LOGIN_"+ompPageId + "_" + "OMP_INAPPBROWSER_POPUP_OK"));
						}else{
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData(ompPageId + "_" + "OMP_INAPPBROWSER_POPUP_OK"));
						}
                        
						ref.close();
						
					}else{
						clickStreamService.clickStreamData =affiliateId;
						if(!mPinLoginService.isLoggedIn){
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("PRE_LOGIN_"+ompPageId + "_" + "OMP_INAPPBROWSER_POPUP_CANCEL"));
						}else{
							clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData(ompPageId + "_" + "OMP_INAPPBROWSER_POPUP_CANCEL"));
						}
                        
						return false;
					}
					if (headerElem) {
						headerElem.classList.remove('popover-open');
					}
				}, "Confirmation", "OK,CANCEL");
				
			}else{
				if(affiliateId){
					clickStreamService.clickStreamData =affiliateId;
					if(!mPinLoginService.isLoggedIn){
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("PRE_LOGIN_"+ompPageId + "_" + "OMP_INAPPBROWSER_BACK"));
					}else{
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData(ompPageId + "_" + "OMP_INAPPBROWSER_BACK"));
					}
					if (headerElem) {
						headerElem.classList.remove('popover-open');
					}
				}
				showPOPUPFlag=false;
				ref.close();
			}
		});
		ref.addEventListener('helloPressed', function (e) {

		});
		ref.addEventListener('sharePressed', function (e) {
			clickStreamService.clickStreamData = affiliateId;
		
			if(!mPinLoginService.isLoggedIn){
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("PRE_LOGIN_"+ompPageId + "_" + "OMP_INAPPBROWSER_VIEW_OFFERS"));
			}else{
				clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData(ompPageId + "_" + "OMP_INAPPBROWSER_VIEW_OFFERS"));
			}
			
		
			var codes = '';
			var couponIndex = 0;
			codes += "\n";
			for (var index = 0; index < merchantDetails.coupons.length; index++) {

				if (merchantDetails.coupons[index].couponCode) {
					couponIndex = (couponIndex + 1);
					codes += couponIndex + '. ';
					codes += merchantDetails.coupons[index].couponCode + '\n';
				}
				if (merchantDetails.coupons[index].headerLines && merchantDetails.coupons[index].headerLines.length > 0) {
					for (var lineIndex = 0; lineIndex < merchantDetails.coupons[index].headerLines.length; lineIndex++) {
						if (!merchantDetails.coupons[index].couponCode) {
							couponIndex = couponIndex + 1;
							codes += couponIndex + '. ';
						}

						codes += merchantDetails.coupons[index].headerLines[lineIndex] + '\n';

						if (lineIndex === merchantDetails.coupons[index].headerLines.length - 1 || !merchantDetails.coupons[index].couponCode) {
							codes += "\n";
						}

					}
				} else {
					codes += "\n";
				}

			}
			navigator.notification.alert(codes, function onConfirm(button) {
				return false;
			}, "Offers", "OK");

		});
		ref.addEventListener('loadstop', function (e) {
			
		});
		ref.addEventListener('loadstart', function (e) {
			
		});
		ref.addEventListener(cordova.ThemeableBrowser.EVT_ERR, function (e) {

		});
		ref.addEventListener(cordova.ThemeableBrowser.EVT_WRN, function (e) {

		});
	}

	var inChromeBrowser = function (url) {
		cordova.ThemeableBrowser.open(url, '_system', {
		});
	};

	var inChromeTabBrowser = function(url) {
		SafariViewController.isAvailable(function (available) {
			if (available) {
				SafariViewController.show({
					url: url,
					hidden: false, // default false. You can use this to load cookies etc in the background (see issue #1 for details).
					animated: false, // default true, note that 'hide' will reuse this preference (the 'Done' button will always animate though)
					transition: 'curl', // (this only works in iOS 9.1/9.2 and lower) unless animated is false you can choose from: curl, flip, fade, slide (default)
					enterReaderModeIfAvailable: false, // default false
					tintColor: "#ffffff", // default is ios blue
					toolbarColor: "#673391", // change color of address bar in android
					barColor: "#673391", // on iOS 10+ you can change the background color as well
					controlTintColor: "#ffffff" // on iOS 10+ you can override the default tintColor
				},
					// this success handler will be invoked for the lifecycle events 'opened', 'loaded' and 'closed'
					function (result) {
						if (result.event === 'opened') {
							console.log('opened');
						} else if (result.event === 'loaded') {
							console.log('loaded');
						} else if (result.event === 'closed') {
							console.log('closed');
						}
					},
					function (msg) {
						console.log("Error: " + msg);
					})
			} else {
				window.open(url, '_blank', 'location=yes');
			}
		});
	};
	var saveLead = function (obj) {
		var q = $q.defer();
		var adapterURL= loggedInUserService.shopNOrderPre ? constantConfig.omp.saveLeadPre : constantConfig.omp.saveLead; 
		AdapterUtils.postData(adapterURL, obj, false).then(function (response) {
			q.resolve(response);
		}, function (error) {
			q.reject(error);
		});
		return q.promise;
	};

	var saveCrmLead = function (obj) {
		var q = $q.defer();
		var adapterURL= loggedInUserService.shopNOrderPre ? constantConfig.omp.saveLeadPre : constantConfig.omp.saveCrmLead; 
		AdapterUtils.postData(adapterURL, obj, false).then(function (response) {
			q.resolve(response);
		}, function (error) {
			q.reject(error);
		});
		return q.promise;
	};

	var getBannerInformation = function (obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getBannerInformation", obj, false).then(function (response) {
			q.resolve(response);
		}, function (error) {
			q.reject(error);
		});
		return q.promise;
	};

	var submitBannerAction = function (obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/submitBannerAction", obj, false).then(function (response) {
			q.resolve(response);
		}, function (error) {
			q.reject(error);
		});
		return q.promise;
	};

	var startTimer = function (obj) {
		startTime = new Date();
	};

	var endTimer = function (obj) {
		endTime = new Date();
		if (!spendTime) {
			spendTime = endTime - startTime;
		} else {
			spendTime = spendTime + (endTime - startTime);
		}
		utilityService.timeSpent = getSpendTime();
	};

	var getSpendTime = function (obj) {
		if (!spendTime) {
			return 0;
		} else {
			var time = Math.ceil((spendTime / 1000));
			return time;
		}
	};

	var resetOMPCSAT = function (obj) {
		spendTime = '';
		startTime = '';
		endTime = '';
	};
    
    /**Searched services starts here **/
    
    /**Function to get list of merchant/category and product for autocomplete event***/
    
    var getAllMerchantKeywordList = function(obj) {
        var q = $q.defer();
		var adapterURL= loggedInUserService.shopNOrderPre ? constantConfig.omp.searchKeywordsPre : constantConfig.omp.searchKeywords; 
        AdapterUtils.postData(adapterURL, obj, false).then(function(response) {
            q.resolve(response);
        }, function(error) {
            q.reject(error);
        });
        return q.promise;
    };
    
    /**Function to get recent searched history***/
    var getRecentSearches = function(obj) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/OMPAdapter/get-recent-keywords", obj, false).then(function(response) {
            q.resolve(response);
        }, function(error) {
            q.reject(error);
        });
        return q.promise;
    };
    
    /**Function to get filtered list of particular product/merchant/category***/
    var getCateMerProdFliteredList = function(obj) {
        var q = $q.defer();
		var adapterURL= loggedInUserService.shopNOrderPre ? constantConfig.omp.merchantByKeywordsPre : constantConfig.omp.merchantByKeywords; 
        AdapterUtils.postData(adapterURL, obj, false).then(function(response) {
            q.resolve(response.data);
        }, function(error) {
            q.reject(error);
        });
        return q.promise;
    };
    
    /**Function to save recent searched history***/
    var saveRecentSearchHistory = function(obj) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/OMPAdapter/post-recent-keywords", obj, true).then(function(response) {
            q.resolve(response.data);
        }, function(error) {
            q.reject(error);
        });
        return q.promise;
    };
    /**Searched services ends here **/
    return {
        listName: listName,
        getStores: getStores,
        getAllCategory:getAllCategory,
        getTopCategory:getTopCategory,
        getWhatNewMerchants:getWhatNewMerchants,
        getFreqViewMerchants:getFreqViewMerchants,
        getMerchantsByCategory:getMerchantsByCategory,
        getBestOfYono:getBestOfYono,
        getTopBrands:getTopBrands,
        merchantsListData: merchantsListData,
        isMerchantsWishListAvl: isMerchantsWishListAvl,
        merchantWishlistCount: merchantWishlistCount,
        saveLead: saveLead,
	    saveCrmLead: saveCrmLead,
        getBannerInformation: getBannerInformation,
        inAppBrowser: inAppBrowser,
        showHeader: showHeader,
        submitBannerAction: submitBannerAction,
        isLoggedIn: isLoggedIn,
        firstTimeLoaded: firstTimeLoaded,
        startTimer: startTimer,
        endTimer: endTimer,
        getSpendTime: getSpendTime,
        resetOMPCSAT: resetOMPCSAT,
        inChromeBrowser: inChromeBrowser,
        getAllMerchantKeywordList: getAllMerchantKeywordList,
        getRecentSearches :getRecentSearches,
        getCateMerProdFliteredList: getCateMerProdFliteredList,
        saveRecentSearchHistory : saveRecentSearchHistory,
		    inChromeTabBrowser: inChromeTabBrowser
    };
});
