'use strict';
angularApp
		.controller(
				'ompShopController',
				[
						"$timeout",
						"$state",
						"$scope",
						"ompShopService",
						"$translate",
						"searchListServices",
						"$ionicScrollDelegate",
						"$ionicSlideBoxDelegate",
						"$interval",
						"utilityService",
						"ompMerchantsService",
						"$ionicHistory",
						"constantConfig",
						"productDescriptionServices",
						"filterService",
						"mPinLoginService",
						"$ionicPopup",
						"personalLoanService",
						"$rootScope",
						"$ionicModal",
						"clickStreamService",
						"$ionicSideMenuDelegate",
						function($timeout, $state, $scope, ompShopService, $translate, searchListServices, $ionicScrollDelegate, $ionicSlideBoxDelegate, $interval, utilityService, ompMerchantsService, $ionicHistory, constantConfig, productDescriptionServices, filterService,mPinLoginService , $ionicPopup, personalLoanService,$rootScope ,$ionicModal ,clickStreamService,$ionicSideMenuDelegate) {
							var ompShopVm = this;
							var isWebviewLoadingCanceled = false;
							ompShopVm.goBack = function() {
								$ionicHistory.goBack(-1);
							};
							
							ompShopVm.gotoSelBannerPre = function (img) {
										if (img.redirectionType == "External") {
											ompShopVm.disclaimer(img);
										}else{
											ompShopVm.gotoSelBanner(img);
										}
									}
							ompShopVm.gotoSelBanner = function(img) {
								if(ompMerchantsService){ 
									if(img.affiliateId){
										clickStreamService.clickStreamData = "websiteId,"+img.affiliateId;
								    }else{
								    	clickStreamService.clickStreamData = "websiteId,"+ "";
								    }	
								};
								var redirectUrl=img.redirectUrl;
								isWebviewLoadingCanceled = false;
								if(img.redirectionType=="External")
								{
										ompShopVm.loadPopup = $ionicPopup.show({
													title : '',
													cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
													templateUrl : "pages/OMP/ompShop/loading.html",
													scope : $scope
												});
									if(!img.affiliateId){
										img.affiliateId = "";
									}	
									var obj ={
										"sessionId":img.sessionId,
										"merchantName" : img.merchantName,
										"type" : "accept",
										"treatmentCode" : img.treatmentCode,
										"isLoggedIn":mPinLoginService.isLoggedIn,
										"affiliateId" : img.affiliateId,
										"websiteId" : ""
									};
									ompMerchantsService.submitBannerAction(obj).then(function(data) {
										ompShopVm.loadPopup.close();
										if(isWebviewLoadingCanceled == true){ return "";}
										isWebviewLoadingCanceled = true;
										if(img.redirectUrl.indexOf('?') != -1){
											if(mPinLoginService.isLoggedIn){	
											ompMerchantsService.inAppBrowser(img.redirectUrl+"&"+data.data.parameter);
											//logoutChallangeHandler();
											}
										}else{
											if(mPinLoginService.isLoggedIn){	
											ompMerchantsService.inAppBrowser(img.redirectUrl+"?"+data.data.parameter);
											//logoutChallangeHandler();
											}
										}
										
									}, function(error) {
										ompShopVm.loadPopup.close();
										utilityService.showErrorMessage(error.responseMessage);
									});
								}else{
									var bannerinfoobj=JSON.parse(redirectUrl)
					                ompMerchantsService.listName.websiteId=bannerinfoobj.WebsiteId;
					             ;
									if(bannerinfoobj.pageId.toLowerCase()=="shop")	{
										
									
											 }
											 
											 else	if(bannerinfoobj.pageId.toLowerCase()=="productdescription")	{
											
											var product = {
														"websiteId" : bannerinfoobj.WebsiteId,
														"productId" : bannerinfoobj.productId,
														"isLoggedIn":mPinLoginService.isLoggedIn
													};
													productDescriptionServices.getProductDetails(product).then(function(data) {
														productDescriptionServices.productData = data;
														$state.go('menu.productDescription');
													}, function(error) {
														utilityService.showErrorMessage(error.responseMessage);
													});	
							          			 
											 }		
									
											 else if(bannerinfoobj.pageId.toLowerCase()=="list")
											 {
											 
											 if(bannerinfoobj.listType.toLowerCase()=="deal")
												 {
												 
													
														var dealList = {
															"type" : "deal",
															"websiteId" : bannerinfoobj.WebsiteId,
															"filters" : [],
															"sort" : {},
															"isLoggedIn":mPinLoginService.isLoggedIn
														}
														searchListServices.getDealList(dealList).then(function(data) {
															filterService.filterOldData = searchListServices.filterData;
															searchListServices.allProductsList = data;
															filterService.selectedLevelOneData = '';
															filterService.selectedLevelTwoData = "";
															filterService.selectedLevelThreeData = "";
															searchListServices.products.length = 0
															filterService.addedFilterFullData.length = 0
															filterService.addedFilterData.length = 0
															filterService.selectedColour.length = 0
															searchListServices.isCompareAvailable = false;
															searchListServices.serviceFrom = 'deal';
															searchListServices.serviceFromObj = dealList;
															filterService.isFilterApplied = false;
															searchListServices.isSortApplied = false;

															searchListServices.searchFor="Deals for you";
															searchListServices.filterNewData = {
															                	          		categoryList : [],
															                	          		subCategoryList : [],
															                	          		colorList : [],
															                	          		priceList : [],
															                	          		callFunctionsList : []
															                	          	};
															$state.go('menu.searchList');
														}, function(error) {
															utilityService.showErrorMessage(error.responseMessage);
														});
													
													
												 
												 
												 
												 
												 }
											 
											 else if (bannerinfoobj.listType.toLowerCase()=="category")
												 {
												 var obj = {
															"category" : bannerinfoobj.categoryId,
															"websiteId" : bannerinfoobj.WebsiteId,
															"filters" : [],
															"sort" : {},
															"isLoggedIn":mPinLoginService.isLoggedIn
														}
												 searchListServices.getSelectedCategoryProduct(obj).then(function(data) {
														filterService.filterOldData = searchListServices.filterData;
														searchListServices.allProductsList = data;
														filterService.selectedLevelOneData = '';
														filterService.selectedLevelTwoData = "";
														filterService.selectedLevelThreeData = "";
														searchListServices.products.length = 0
														filterService.addedFilterFullData.length = 0
														filterService.addedFilterData.length = 0
														filterService.selectedColour.length = 0
														searchListServices.isCompareAvailable = true;
														searchListServices.serviceFrom = 'getSelectedCategoryProduct';
														searchListServices.serviceFromObj = obj;
														filterService.isFilterApplied = false;
														searchListServices.isSortApplied = false;
														searchListServices.filterNewData = {
														                	          		categoryList : [],
														                	          		subCategoryList : [],
														                	          		colorList : [],
														                	          		priceList : [],
														                	          		callFunctionsList : []
														                	          	};
														$state.go('menu.searchList');
													}, function(error) {
														utilityService.showErrorMessage(error.responseMessage);
													});
												 
												 
												 }
											 
											 else if (bannerinfoobj.listType.toLowerCase()=="whatsnew")
											 {
											 
												 var newList = {
															"type" : "whatsnew",
															"websiteId" : bannerinfoobj.WebsiteId,
															"filters" : [],
															"sort" : {},
															"isLoggedIn":mPinLoginService.isLoggedIn
														}
														searchListServices.getDealList(newList).then(function(data) {
															filterService.filterOldData = searchListServices.filterData;
															searchListServices.allProductsList = data;
															filterService.selectedLevelOneData = '';
															filterService.selectedLevelTwoData = "";
															filterService.selectedLevelThreeData = "";
															searchListServices.products.length = 0
															filterService.addedFilterFullData.length = 0
															filterService.addedFilterData.length = 0
															filterService.selectedColour.length = 0
															searchListServices.isCompareAvailable = false;
															searchListServices.serviceFrom = 'whatsnew';
															searchListServices.serviceFromObj = newList;
															searchListServices.searchFor="Whats New";
															filterService.isFilterApplied = false;
															searchListServices.isSortApplied = false;
															searchListServices.filterNewData = {
															                	          		categoryList : [],
															                	          		subCategoryList : [],
															                	          		colorList : [],
															                	          		priceList : [],
															                	          		callFunctionsList : []
															                	          	};
															$state.go('menu.searchList');
														}, function(error) {
															utilityService.showErrorMessage(error.responseMessage);
														});
											 
											 
											 }
											 
											 else if (bannerinfoobj.listType.toLowerCase()=="trending")
												 {
												 var trendList = {
															"type" : "trending",
															"websiteId" : bannerinfoobj.WebsiteId,
															"filters" : [],
															"sort" : {},
															"isLoggedIn":mPinLoginService.isLoggedIn
														}
														searchListServices.getDealList(trendList).then(function(data) {
															filterService.filterOldData = searchListServices.filterData;
															searchListServices.allProductsList = data;
															filterService.selectedLevelOneData = '';
															filterService.selectedLevelTwoData = "";
															filterService.selectedLevelThreeData = "";
															searchListServices.products.length = 0
															filterService.addedFilterFullData.length = 0
															filterService.addedFilterData.length = 0
															filterService.selectedColour.length = 0
															searchListServices.isCompareAvailable = false;
															searchListServices.serviceFrom = 'trending';
															searchListServices.searchFor="Trending";
															searchListServices.serviceFromObj = trendList;
															filterService.isFilterApplied = false;
															searchListServices.isSortApplied = false;
															searchListServices.filterNewData = {
															                	          		categoryList : [],
															                	          		subCategoryList : [],
															                	          		colorList : [],
															                	          		priceList : [],
															                	          		callFunctionsList : []
															                	          	};
															$state.go('menu.searchList');
														}, function(error) {
															utilityService.showErrorMessage(error.responseMessage);
														});
												 
												 
												 
												 }
								





					}
					else if (bannerinfoobj.pageId.toLowerCase() == "menu.personalloan") {
						personalLoanService.clearAll();
						personalLoanService.getLoanDetails().then(function (data) {

							personalLoanService.personalLoanData = data;
							personalLoanService.minDuration = data.minTenure;
							personalLoanService.maxDuration = data.maxTenure;
							personalLoanService.interestRate = data.interestRate;
							personalLoanService.product = data.productCode;
							personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
							personalLoanService.processingFee = data.processingFee;
							personalLoanService.minBestOffer = data.minPalAmount;
							personalLoanService.activityCode = data.activityCode;
							personalLoanService.schemeCode = data.schemeCode;


							$state.go('menu.personalLoan');

						}, function (error) {
							utilityService.showErrorMessage(error);
						});

					}

					else {

						$state.go(bannerinfoobj.pageId);
					}


				}
			}

			ompShopVm.tapCancel = function () {
				isWebviewLoadingCanceled = true;
				ompShopVm.loadPopup.close();
			};

			ompShopVm.productDescription = function (data) {
				var product = {
					"websiteId": ompMerchantsService.listName.websiteId,
					"productId": data.id,
					"isLoggedIn": mPinLoginService.isLoggedIn
				};
				productDescriptionServices.getProductDetails(product).then(function (data) {
					productDescriptionServices.productData = data;
					$state.go('menu.productDescription');
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			};
			ompShopVm.gotoSearch = function () {
				$state.go('menu.ompSearch');
			};
			ompShopVm.wishList = function () {
				if ((!mPinLoginService.userLoginStatus.isRegistered)) {
					ompShopVm.loginPop = $ionicPopup.show({
						cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head popupBackgroundDark',
						templateUrl: 'pages/OMP/productDescription/registerPopup.html',
						scope: $scope
					});

				}
				else if ((!mPinLoginService.isLoggedIn)) {
					ompShopVm.loginPop = $ionicPopup.show({
						title: '',
						cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head popupBackgroundDark',
						templateUrl: 'pages/OMP/ompShop/loginPop.html',
						scope: $scope
					});
				} else {
					$state.go('menu.localWishlist');
				}

							};
							
							 $scope.resumeSession=function(mpin){
							 	var myState = $state;
							 	var myScope =  $scope; 
							    mPinLoginService;
							 	ompMerchantsService.loginAuthChallengeHandler(mpin, myState  , mPinLoginService , myScope);
					       },
							$scope.registerSkip = function() {
								ompShopVm.loginPop.close();
							};
							$scope.regPopup = function() {
								ompShopVm.loginPop.close();
								$state.go('menu.openNewDigitalAccount');
							};	
							ompShopVm.loginSkip = function() {
								ompShopVm.loginPop.close();
							};
							ompShopVm.loginPopup = function() {
								ompShopVm.loginPop.close();
								 $ionicModal.fromTemplateUrl( 'pages/mPinLogin/mpinLoginModel.html',{
							            scope: $scope,
							            animation: 'slide-in-up',
							            focusFirstInput: true
							        }).then(function(modal) {
							            $scope.modal = modal;
							            $scope.modal.show();
							        }); 
							};
							ompShopVm.gotoMore = function() {
								$state.go('menu.categoryList');
							};
							ompShopVm.gotoFeatureMore = function() {
								$state.go('menu.shopCategories');
							};
							ompShopVm.gotoCategory = function(category) {
								if (category.childrenData.length > 0 ){
									ompShopService.subCategory = category.childrenData;
									ompShopService.category = category.name;
									$state.go('menu.electronics');
								}
								else {

									filterService.selectedLevelThreeData = category.name;
									searchListServices.searchFor = category.name;
									filterService.selectedCategoryId = category.id;
									var obj = {
										"category" : category.id,
										"websiteId" : ompMerchantsService.listName.websiteId,
										"filters" : [],
										"sort" : {},
										"isLoggedIn":mPinLoginService.isLoggedIn
									}
									searchListServices.getSelectedCategoryProduct(obj).then(function(data) {
										filterService.filterOldData = searchListServices.filterData;
										searchListServices.allProductsList = data;
										searchListServices.isCompareAvailable = true;
										searchListServices.serviceFrom = 'getSelectedCategoryProduct';
										searchListServices.serviceFromObj = obj;
										searchListServices.products.length = 0
										filterService.addedFilterFullData.length = 0
										filterService.addedFilterData.length = 0
										filterService.selectedColour.length = 0
										searchListServices.filterNewData = {
										                	          		categoryList : [],
										                	          		subCategoryList : [],
										                	          		colorList : [],
										                	          		priceList : [],
										                	          		callFunctionsList : []
										                	          	};
										filterService.isFilterApplied = false;
										searchListServices.isSortApplied = false;
										$state.go('menu.searchList');
									}, function(error) {
										utilityService.showErrorMessage(error.responseMessage);
									});
								
								
									
								}
							};
							ompShopVm.gotoFeatureCategory = function(data) {
								
								
								var listofdata=ompShopService.categoryList;
								var listofdataLenght = listofdata.length;
								for(var i=0;i<listofdataLenght;i++)
									{
									if(data.id==listofdata[i].id)
										{
										break;
										}
									
									var firstLevelData=listofdata[i].childrenData;
									var firstLevelDataLen = firstLevelData.length;
									for(var j=0;j<firstLevelDataLen;j++)
										{
										
										if(data.id==firstLevelData[j].id)
										{
											filterService.selectedLevelThreeData="";
											filterService.selectedLevelTwoData=firstLevelData[j].name;
											filterService.selectedLevelOneData=listofdata[i].name;
											
										break;
										}
										var secondLevelData=firstLevelData[j].childrenData;
										var secondLevelDataLen = secondLevelData.length;
										for(var k=0;k<secondLevelDataLen;k++)
										{
										
											if(data.id==secondLevelData[k].id)
											{
										
											filterService.selectedLevelThreeData=secondLevelData[k].name;
											filterService.selectedLevelTwoData=firstLevelData[j].name;
											filterService.selectedLevelOneData=listofdata[i].name;
											break;
											}
										
										}
										
										
										
										}
									
									}
								searchListServices.searchFor = data.name;
								filterService.selectedCategoryId = data.id;
								var obj = {
									"category" : data.id,
									"websiteId" : ompMerchantsService.listName.websiteId,
									"filters" : [],
									"sort" : {},
									"isLoggedIn":mPinLoginService.isLoggedIn
								}
								searchListServices.getSelectedCategoryProduct(obj).then(function(data) {
									filterService.filterOldData = searchListServices.filterData;
									searchListServices.allProductsList = data;
									searchListServices.products.length = 0
									filterService.addedFilterFullData.length = 0
									filterService.addedFilterData.length = 0
									filterService.selectedColour.length = 0
									searchListServices.isCompareAvailable = true;
									searchListServices.serviceFrom = 'getSelectedCategoryProduct';
									searchListServices.serviceFromObj = obj;
									filterService.isFilterApplied = false;
									searchListServices.isSortApplied = false;
									searchListServices.filterNewData = {
									                	          		categoryList : [],
									                	          		subCategoryList : [],
									                	          		colorList : [],
									                	          		priceList : [],
									                	          		callFunctionsList : []
									                	          	};
									$state.go('menu.searchList');
								}, function(error) {
									utilityService.showErrorMessage(error.responseMessage);
								});
							};
							ompShopVm.gotoSelectedFeature = function(feature) {
								searchListServices.searchFor = feature;
								if (feature === ompShopVm.deal_lbl) {
									var dealList = {
										"type" : "deal",
										"websiteId" : ompShopVm.merchant.websiteId,
										"filters" : [],
										"sort" : {},
										"isLoggedIn":mPinLoginService.isLoggedIn
									}
									searchListServices.getDealList(dealList).then(function(data) {
										filterService.filterOldData = searchListServices.filterData;
										searchListServices.allProductsList = data;
										filterService.selectedLevelOneData = '';
										filterService.selectedLevelTwoData = "";
										filterService.selectedLevelThreeData = "";
										searchListServices.products.length = 0
										filterService.addedFilterFullData.length = 0
										filterService.addedFilterData.length = 0
										filterService.selectedColour.length = 0
										searchListServices.isCompareAvailable = false;
										searchListServices.serviceFrom = 'deal';
										searchListServices.serviceFromObj = dealList;
										filterService.isFilterApplied = false;
										searchListServices.isSortApplied = false;
										searchListServices.filterNewData = {
										                	          		categoryList : [],
										                	          		subCategoryList : [],
										                	          		colorList : [],
										                	          		priceList : [],
										                	          		callFunctionsList : []
										                	          	};
										$state.go('menu.searchList');
									}, function(error) {
										utilityService.showErrorMessage(error.responseMessage);
									});
								} else if (feature === ompShopVm.new_lbl) {
									var newList = {
										"type" : "whatsnew",
										"websiteId" : ompShopVm.merchant.websiteId,
										"filters" : [],
										"sort" : {},
										"isLoggedIn":mPinLoginService.isLoggedIn
									}
									searchListServices.getDealList(newList).then(function(data) {
										filterService.filterOldData = searchListServices.filterData;
										searchListServices.allProductsList = data;
										filterService.selectedLevelOneData = '';
										filterService.selectedLevelTwoData = "";
										filterService.selectedLevelThreeData = "";
										searchListServices.products.length = 0
										filterService.addedFilterFullData.length = 0
										filterService.addedFilterData.length = 0
										filterService.selectedColour.length = 0
										searchListServices.isCompareAvailable = false;
										searchListServices.serviceFrom = 'whatsnew';
										searchListServices.serviceFromObj = newList;
										filterService.isFilterApplied = false;
										searchListServices.isSortApplied = false;
										searchListServices.filterNewData = {
										                	          		categoryList : [],
										                	          		subCategoryList : [],
										                	          		colorList : [],
										                	          		priceList : [],
										                	          		callFunctionsList : []
										                	          	};
										$state.go('menu.searchList');
									}, function(error) {
										utilityService.showErrorMessage(error.responseMessage);
									});
								} else if (feature === ompShopVm.trend_lbl) {
									var trendList = {
										"type" : "trending",
										"websiteId" : ompShopVm.merchant.websiteId,
										"filters" : [],
										"sort" : {},
										"isLoggedIn":mPinLoginService.isLoggedIn
									}
									searchListServices.getDealList(trendList).then(function(data) {
										filterService.filterOldData = searchListServices.filterData;
										searchListServices.allProductsList = data;
										filterService.selectedLevelOneData = '';
										filterService.selectedLevelTwoData = "";
										filterService.selectedLevelThreeData = "";
										searchListServices.products.length = 0
										filterService.addedFilterFullData.length = 0
										filterService.addedFilterData.length = 0
										filterService.selectedColour.length = 0
										searchListServices.isCompareAvailable = false;
										searchListServices.serviceFrom = 'trending';
										searchListServices.serviceFromObj = trendList;
										filterService.isFilterApplied = false;
										searchListServices.isSortApplied = false;
										searchListServices.filterNewData = {
										                	          		categoryList : [],
										                	          		subCategoryList : [],
										                	          		colorList : [],
										                	          		priceList : [],
										                	          		callFunctionsList : []
										                	          	};
										$state.go('menu.searchList');
									}, function(error) {
										utilityService.showErrorMessage(error.responseMessage);
									});
								} else {
									var recentProductsList = {
										"websiteId" : ompMerchantsService.listName.websiteId,
										"filters" : [],
										"sort" : {},
										"isLoggedIn":mPinLoginService.isLoggedIn
									}
									searchListServices.getRecentlyViewedListing(recentProductsList).then(function(data) {
										filterService.filterOldData = searchListServices.filterData;
										searchListServices.allProductsList = data;
										filterService.selectedLevelOneData = '';
										filterService.selectedLevelTwoData = "";
										filterService.selectedLevelThreeData = "";
										searchListServices.products.length = 0
										filterService.addedFilterFullData.length = 0
										filterService.addedFilterData.length = 0
										filterService.selectedColour.length = 0
										searchListServices.isCompareAvailable = false;
										searchListServices.serviceFrom = 'getRecentlyViewedListing';
										searchListServices.serviceFromObj = recentProductsList;
										filterService.isFilterApplied = false;
										searchListServices.isSortApplied = false;
										searchListServices.filterNewData = {
										                	          		categoryList : [],
										                	          		subCategoryList : [],
										                	          		colorList : [],
										                	          		priceList : [],
										                	          		callFunctionsList : []
										                	          	};
										$state.go('menu.searchList');
									}, function(error) {
										utilityService.showErrorMessage(error.responseMessage);
									});
								}
							};
							ompShopVm.next = function() {
								$ionicSlideBoxDelegate.next();
							};
							ompShopVm.previous = function() {
								$ionicSlideBoxDelegate.previous();
							};
							$scope.slideChanged = function(index) {
								$scope.slideIndex = index;
							};
							$scope.$on('$ionicView.beforeEnter', function() {
								initPage();
								ompShopVm.isMerchantsWishListAvl = ompMerchantsService.isMerchantsWishListAvl;
								ompShopVm.dealImg = constantConfig.omp.dealImg;
								ompShopVm.disc = constantConfig.omp.discount;
								ompShopVm.merchant = ompMerchantsService.listName;
								ompShopService.merWebId = ompShopVm.merchant.websiteId;
								ompShopService.merAffiliateiId=ompShopVm.merchant.affiliateId;
								
								filterService.selectedLevelOneData="";
								filterService.selectedLevelTwoData="";
								filterService.selectedLevelThreeData="";
								filterService.selectedColour = [];
								filterService.addedFilterData = [];
								filterService.addedFilterFullData = [];
								
								
								filterService.addedFilterFullData.length = 0;
								filterService.addedFilterData.length = 0;
								filterService.selectedColour.length = 0;
								searchListServices.isCompareAvailable = true;
								filterService.isFilterApplied = false;
								searchListServices.isSortApplied = false;
								filterService.filterNewData = {
																categoryList : [],
																subCategoryList : [],
																colorList : [],
																priceList : [],
																callFunctionsList : []
															};	
								
								
								
								ompShopVm.images=[];
								
							   var affiliateId = "";
							   if(ompShopVm.merchant.affiliateId){
							   	  affiliateId  = ompShopVm.merchant.affiliateId
							   }
								var bannerobj = {
										"type" : "merchant",
										"websiteId":ompShopVm.merchant.websiteId,
										"sessionId":"",
										"isLoggedIn":mPinLoginService.isLoggedIn,
										"affiliateId" : affiliateId
									};	
									ompMerchantsService.getBannerInformation(bannerobj).then(function(data) {
										
										   var bannerInformationsLen = data.data.bannerInformations.length;
										    
										    ompShopVm.images=data.data.bannerInformations;
											
											$ionicSlideBoxDelegate.update();
											$ionicSlideBoxDelegate.loop(true);
									}, function(error) {
										utilityService.showErrorMessage(error.responseMessage);
									});
								ompShopVm.isDealsAvailable = false;
								ompShopVm.isWhatsNewAvailable = false;
								ompShopVm.isTrendingAvailable = false;
								ompShopVm.isFeatCatAvailable = false;
								ompShopVm.isRecentAvailable = false;

								ompShopVm.showDeals = false;
								ompShopVm.showWhatsNew = false;
								ompShopVm.showTrending = false;
								ompShopVm.showFeatCat = false;
								ompShopVm.showRecent = false;
								
								ompShopVm.recentIds = ompShopService.recentIds;
								$interval(function() {
									if ($ionicSlideBoxDelegate.currentIndex() == ompShopVm.images.length - 1)
										$ionicSlideBoxDelegate.$getByHandle('landingPageSlide').slide(0);
									else
										$ionicSlideBoxDelegate.$getByHandle('landingPageSlide').start();
								}, 8000);
								var objNavigationCategoryList = {
									"websiteId" : ompShopVm.merchant.websiteId,
									"depth" : '4',
									"isLoggedIn":mPinLoginService.isLoggedIn
								};
								ompShopService.getNavigationCategoryList(objNavigationCategoryList).then(function(data) {
									ompShopVm.catList = data[0].childrenData;
									ompShopService.categoryList = data[0].childrenData;
									
								}, function(error) {
									utilityService.showErrorMessage(error.responseMessage);
								});
								var objGetFeaturedCategories = {
									"websiteId" : ompShopVm.merchant.websiteId,
									"isLoggedIn":mPinLoginService.isLoggedIn
								};
								ompShopService.getFeaturedCategories(objGetFeaturedCategories).then(function(data) {
									ompShopVm.isFeatCatAvailable = true;
									ompShopVm.featuredCategories = data;
									ompShopService.featuredCategoriesList = data;
									if(data.length > 0){
										ompShopVm.showFeatCat = true;
									}else{
										ompShopVm.showFeatCat = false;
									}
									$timeout(function() {
									var fc = $ionicScrollDelegate.$getByHandle('horizontalFeaturedCategories').getScrollView();
									var container = fc.__container;
									var originaltouchStart = fc.touchStart;
									var originaltouchMove = fc.touchMove;
									container.removeEventListener('touchstart', fc.touchStart);
									document.removeEventListener('touchmove', fc.touchMove);
									fc.touchStart = function(e) {
										e.preventDefault = function() {
										};
										originaltouchStart.apply(fc, [
											e
										]);
									}
									fc.touchMove = function(e) {
										e.preventDefault = function() {
										};
										originaltouchMove.apply(fc, [
											e
										]);
									}
									container.addEventListener("touchstart", fc.touchStart, false);
									document.addEventListener("touchmove", fc.touchMove, false);
								},700);
								}, function(error) {
									ompShopVm.isFeatCatAvailable = false;	
									ompShopVm.showFeatCat = false;
									utilityService.showErrorMessage(error.responseMessage);
								});
								
								if(mPinLoginService.isLoggedIn){
									var dealsRespone = {
									"type" : "deal",
									"websiteId" : ompShopVm.merchant.websiteId,
									"isLoggedIn":mPinLoginService.isLoggedIn
								};
									ompShopService.getDeals(dealsRespone).then(function(data) {
									ompShopVm.isDealsAvailable = true;
									ompShopVm.deals = data;
									if(data.count > 0){
										ompShopVm.showDeals = true;
									}else{
										ompShopVm.showDeals = false;
									}
										
										$timeout(function() {
									var sv = $ionicScrollDelegate.$getByHandle('horizontalDeals').getScrollView();
									var container = sv.__container;
									var originaltouchStart = sv.touchStart;
									var originaltouchMove = sv.touchMove;
									container.removeEventListener('touchstart', sv.touchStart);
									document.removeEventListener('touchmove', sv.touchMove);
									sv.touchStart = function(e) {
										e.preventDefault = function() {
										};
										originaltouchStart.apply(sv, [
											e
										]);
									}
									sv.touchMove = function(e) {
										e.preventDefault = function() {
										};
										originaltouchMove.apply(sv, [
											e
										]);
									}
									container.addEventListener("touchstart", sv.touchStart, false);
									document.addEventListener("touchmove", sv.touchMove, false);
								},700);
								}, function(error) {
									ompShopVm.isDealsAvailable = false;	
									ompShopVm.showDeals = false;
									utilityService.showErrorMessage(error.responseMessage);
								});
								
								var recentProduct = {
									"websiteId" : ompShopVm.merchant.websiteId,
									"isLoggedIn":mPinLoginService.isLoggedIn
								};
								ompShopService.getRecentlyViewed(recentProduct).then(function(data) {
									ompShopVm.isRecentAvailable = true;
									if(data.count > 0)
										ompShopVm.showRecent = true;
									else
										ompShopVm.showRecent = false;
									ompShopVm.recent = data;
									
									if(data.isWishlist){
											ompMerchantsService.isMerchantsWishListAvl = "S";
											ompShopVm.isMerchantsWishListAvl= "S";
									}
									$timeout(function() {
									var rec = $ionicScrollDelegate.$getByHandle('pageScroll').getScrollView();
									var container = rec.__container;
									var originaltouchStart = rec.touchStart;
									var originaltouchMove = rec.touchMove;
									container.removeEventListener('touchstart', rec.touchStart);
									document.removeEventListener('touchmove', rec.touchMove);
									rec.touchStart = function(e) {
										e.preventDefault = function() {
										};
										originaltouchStart.apply(rec, [
											e
										]);
									}
									rec.touchMove = function(e) {
										e.preventDefault = function() {
										};
										originaltouchMove.apply(rec, [
											e
										]);
									}
									container.addEventListener("touchstart", rec.touchStart, false);
									document.addEventListener("touchmove", rec.touchMove, false);
								},700);
								}, function(error) {
									ompShopVm.isRecentAvailable = false;
									ompShopVm.showRecent = false;
									utilityService.showErrorMessage(error.responseMessage);
								});
								}else{
									ompShopVm.showRecent = false;
									ompShopVm.showDeals = false;
								}
								
								
								
								var whatsNewRespone = {
									"type" : "whatsnew",
									"websiteId" : ompShopVm.merchant.websiteId,
									"isLoggedIn":mPinLoginService.isLoggedIn
								};
								ompShopService.getDeals(whatsNewRespone).then(function(data) {
									ompShopVm.isWhatsNewAvailable = true;
									ompShopVm.whatsNew = data;
									if(data.count > 0){
										ompShopVm.showWhatsNew = true;
									}else{
										ompShopVm.showWhatsNew = false;
									}
									$timeout(function() {
									var wtNew = $ionicScrollDelegate.$getByHandle('horizontalNew').getScrollView();
									var container = wtNew.__container;
									var originaltouchStart = wtNew.touchStart;
									var originaltouchMove = wtNew.touchMove;
									container.removeEventListener('touchstart', wtNew.touchStart);
									document.removeEventListener('touchmove', wtNew.touchMove);
									wtNew.touchStart = function(e) {
										e.preventDefault = function() {
										};
										originaltouchStart.apply(wtNew, [
											e
										]);
									}
									wtNew.touchMove = function(e) {
										e.preventDefault = function() {
										};
										originaltouchMove.apply(wtNew, [
											e
										]);
									}
									container.addEventListener("touchstart", wtNew.touchStart, false);
									document.addEventListener("touchmove", wtNew.touchMove, false);
								},700);
								}, function(error) {
									ompShopVm.isWhatsNewAvailable = false;
									ompShopVm.showWhatsNew = false;
									utilityService.showErrorMessage(error.responseMessage);
								});
								var trendingRespone = {
									"type" : "trending",
									"websiteId" : ompShopVm.merchant.websiteId,
									"isLoggedIn":mPinLoginService.isLoggedIn
								};
								ompShopService.getDeals(trendingRespone).then(function(data) {
									ompShopVm.isTrendingAvailable = true;
									ompShopVm.trending = data;
									if(data.count > 0){
										ompShopVm.showTrending = true;
									}
									else{
										ompShopVm.showTrending = false;
									}
									$timeout(function() {
									var trend = $ionicScrollDelegate.$getByHandle('horizontalTrending').getScrollView();
									var container = trend.__container;
									var originaltouchStart = trend.touchStart;
									var originaltouchMove = trend.touchMove;
									container.removeEventListener('touchstart', trend.touchStart);
									document.removeEventListener('touchmove', trend.touchMove);
									trend.touchStart = function(e) {
										e.preventDefault = function() {
										};
										originaltouchStart.apply(trend, [
											e
										]);
									}
									trend.touchMove = function(e) {
										e.preventDefault = function() {
										};
										originaltouchMove.apply(trend, [
											e
										]);
									}
									container.addEventListener("touchstart", trend.touchStart, false);
									document.addEventListener("touchmove", trend.touchMove, false);
								},700);
								}, function(error) {
									ompShopVm.isTrendingAvailable = false;
									ompShopVm.showTrending = false;
									utilityService.showErrorMessage(error.responseMessage);
								});
								$scope.addDataToClickStream();
								$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
							});
							$scope.addDataToClickStream = function() {
									if(ompMerchantsService){
										if(ompShopVm.merchant){
											clickStreamService.clickStreamData = "websiteId,"+ompShopVm.merchant.affiliateId;
									 }	
									};	
							};
							function initPage() {
								$translate([
										'DEALS', 'FEATURED_CATEGORIES', 'TRENDING', 'WHATS_NEW', 'RECENTLY', 'SHOP' , 'SBI_PROD' , 'TRANSC_QUICKLY' , 'XCLUSIVE_OFFERS'
								]).then(function(translations) {
									ompShopVm.deal_lbl = translations['DEALS'];
									ompShopVm.fc_lbl = translations['FEATURED_CATEGORIES'];
									ompShopVm.trend_lbl = translations['TRENDING'];
									ompShopVm.new_lbl = translations['WHATS_NEW'];
									ompShopVm.rec_lbl = translations['RECENTLY'];
									ompShopVm.shop = translations['SHOP'];
									
									ompShopVm.l_one = translations['SBI_PROD'];
									ompShopVm.l_two = translations['TRANSC_QUICKLY'];
									ompShopVm.l_three = translations['XCLUSIVE_OFFERS'];
									$scope.records = [
											        ompShopVm.l_one,
											        ompShopVm.l_two,
									                ompShopVm.l_three 
											    ];
								});
								
								
								
								
								
							};
								
							 ompShopVm.disclaimer = function (data) {
						            ompShopVm.merchantsList = data;
						            ompShopVm.myPopup = $ionicPopup.show({
						                title: '',
						                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
						                templateUrl: "pages/OMP/ompShop/disclaimerPopup.html",
						                scope: $scope
						            });
						        };
		        
						         ompShopVm.cancel = function () {
						            ompShopVm.myPopup.close();
						        };
		
						        ompShopVm.agree = function () {
						            ompShopVm.myPopup.close();
						        	ompShopVm.gotoSelBanner(ompShopVm.merchantsList);
							   }
							$scope.$on('$ionicView.beforeLeave', function(){
							   ompMerchantsService.endTimer();
							});
							$scope.$on('$ionicView.afterEnter', function() {
								ompMerchantsService.startTimer();
							});
							$scope.$on('$ionicView.enter', function(e) {
							    $timeout(function() {
									  ompMerchantsService.showHeader();
									 
									var rec = $ionicScrollDelegate.$getByHandle('pageScroll').getScrollView();
									var container = rec.__container;
									var originaltouchStart = rec.touchStart;
									var originaltouchMove = rec.touchMove;
									container.removeEventListener('touchstart', rec.touchStart);
									document.removeEventListener('touchmove', rec.touchMove);
									rec.touchStart = function(e) {
										e.preventDefault = function() {
										};
										originaltouchStart.apply(rec, [
											e
										]);
									}
									rec.touchMove = function(e) {
										e.preventDefault = function() {
										};
										originaltouchMove.apply(rec, [
											e
										]);
									}
									container.addEventListener("touchstart", rec.touchStart, false);
									document.addEventListener("touchmove", rec.touchMove, false);
								
								  }, 1000);

					
								});
							return this;
						}
				]);
