'use strict';
angularApp
		.controller(
				'searchListController',
				[
						"$state",
						"$scope",
						"$ionicPopup",
						"searchListServices",
						"comparisonChartService",
						"filterService",
						"ompMerchantsService",
						"$translate",
						"$ionicHistory",
						"productDescriptionServices",
						"constantConfig",
						"utilityService",
						"ompShopService",
						"$location",
						"$ionicScrollDelegate",
						"closePopupService",
						"mPinLoginService",
						"$rootScope",
						"$ionicModal",
						"$timeout",
						"clickStreamService",
						"$ionicSideMenuDelegate",
						function($state, $scope, $ionicPopup, searchListServices, comparisonChartService, filterService, ompMerchantsService, $translate, $ionicHistory, productDescriptionServices, constantConfig, utilityService, ompShopService, $location, $ionicScrollDelegate, closePopupService,mPinLoginService , $rootScope ,$ionicModal,$timeout,clickStreamService,$ionicSideMenuDelegate) {
							var searchListVm = this;
							$scope.resultCont = '';
							searchListVm.productsList = '';
							function initPage() {
								searchListVm.images = [];
								$scope.currentPage = 1;
							};
							searchListVm.goBack = function() {
								$ionicHistory.goBack(-1);
							}
							searchListVm.gotoSearch = function() {
								$state.go('menu.ompSearch');
							}
							searchListVm.displaySort = function() {
								searchListVm.sortPopup = $ionicPopup.show({
									templateUrl : 'pages/OMP/searchList/sortPopup.html',
									scope : $scope,
									cssClass : 'my-sort-popup'
								});
								closePopupService.register(searchListVm.sortPopup);
							}
							searchListVm.getSort = function(sorting, pagination) {
								searchListVm.sortOP = '';
								if (pagination) {
									var sortObj = searchListVm.sortObject;
									var isLoad =true;
									searchListVm.sortOP = searchListServices.selectedSortOption;
									$scope.currentPage = $scope.currentPage + 1;
								} else {
									$scope.currentPage = 1;
									$scope.noMoreItemsAvailable = false;
									var isLoad =false;
									var sortObj = {
										"key" : sorting.key,
										"direction" : sorting.dir
									}
									searchListServices.sortObjectData = sortObj;			
									searchListServices.isSortApplied = true;
									searchListVm.sortOP = sorting.dir;
									searchListServices.selectedSortOption = sorting.dir;
									searchListVm.sortPopup.close();
								}
								if(!filterService.isFilterApplied){
									if (searchListServices.serviceFrom === 'getSelectedCategoryProduct') {
										var obj = {
											"category" : searchListServices.serviceFromObj.category,
											"websiteId" : searchListServices.serviceFromObj.websiteId,
											"filters" : [],
											"sort" : searchListServices.sortObjectData,
											"page" : $scope.currentPage.toString(),
											"isLoggedIn":mPinLoginService.isLoggedIn
										}
										searchListServices.getSelectedCategoryProduct(obj,isLoad).then(function(data) {
											searchListServices.allProductsList = data;
											searchListServices.isCompareAvailable = true;
											if (pagination) {
												searchListVm.searchResult.products = searchListVm.searchResult.products.concat(searchListServices.allProductsList.products);
											} else {
												searchListVm.searchResult = searchListServices.allProductsList;
												
											}
											loadData(searchListVm.sortOP);
											if (pagination) {
												$scope.$broadcast('scroll.infiniteScrollComplete');
											}
										}, function(error) {
											utilityService.showErrorMessage(error.responseMessage);
										});
									} else if (searchListServices.serviceFrom === 'getSearchProductsList') {
										var obj = {
											"websiteId" : searchListServices.serviceFromObj.websiteId,
											"keyword" : searchListServices.serviceFromObj.keyword,
											"filters" : [],
											"sort" : searchListServices.sortObjectData,
											"page" : $scope.currentPage.toString(),
											"isLoggedIn":mPinLoginService.isLoggedIn
										}
										searchListServices.getSearchProductsList(obj,isLoad).then(function(data) {
											searchListServices.allProductsList = data;
											filterService.selectedLevelOneData = '';
											filterService.selectedLevelTwoData = "";
											filterService.selectedLevelThreeData = "";
											searchListServices.isCompareAvailable = true;
											if (pagination) {
												searchListVm.searchResult.products = searchListVm.searchResult.products.concat(searchListServices.allProductsList.products);
											} else {
												searchListVm.searchResult = searchListServices.allProductsList;
											}
											loadData(searchListVm.sortOP);
										}, function(error) {
											utilityService.showErrorMessage(error.responseMessage);
										});
									} else if (searchListServices.serviceFrom === 'getRecentlyViewedListing') {
										var recentProductsList = {
											"websiteId" : searchListServices.serviceFromObj.websiteId,
											"filters" : [],
											"sort" : searchListServices.sortObjectData,
											"page" : $scope.currentPage.toString(),
											"isLoggedIn":mPinLoginService.isLoggedIn
										}
										searchListServices.getRecentlyViewedListing(recentProductsList,isLoad).then(function(data) {
											searchListServices.allProductsList = data;
											filterService.selectedLevelOneData = '';
											filterService.selectedLevelTwoData = "";
											filterService.selectedLevelThreeData = "";
											searchListServices.isCompareAvailable = false;
											if (pagination) {
												searchListVm.searchResult.products = searchListVm.searchResult.products.concat(searchListServices.allProductsList.products);
											} else {
												searchListVm.searchResult = searchListServices.allProductsList;
											}
											loadData(searchListVm.sortOP);
										}, function(error) {
											utilityService.showErrorMessage(error.responseMessage);
										});
									} else if (searchListServices.serviceFrom === 'getSimilarProductList') {
										var similarProductsList = {
											"websiteId" : searchListServices.serviceFromObj.websiteId,
											"productId" : searchListServices.serviceFromObj.productId,
											"price" : searchListServices.serviceFromObj.price,
											"filters" :[],
											"sort" : searchListServices.sortObjectData,
											"page" : $scope.currentPage.toString(),
											"isLoggedIn":mPinLoginService.isLoggedIn
										};
										productDescriptionServices.getSimilarProductList(similarProductsList,isLoad).then(function(data) {
											searchListServices.allProductsList = data;
											filterService.selectedLevelOneData = '';
											filterService.selectedLevelTwoData = "";
											filterService.selectedLevelThreeData = "";
											searchListServices.isCompareAvailable = true;
											if (pagination) {
												searchListVm.searchResult.products = searchListVm.searchResult.products.concat(searchListServices.allProductsList.products);
											} else {
												searchListVm.searchResult = searchListServices.allProductsList;
											}
											loadData(searchListVm.sortOP);
										}, function(error) {
											utilityService.showErrorMessage(error.responseMessage);
										});
									} else {
										var dealList = {
											"type" : searchListServices.serviceFromObj.type,
											"websiteId" : searchListServices.serviceFromObj.websiteId,
											"filters" : [],
											"sort" : searchListServices.sortObjectData,
											"page" : $scope.currentPage.toString(),
											"isLoggedIn":mPinLoginService.isLoggedIn
										}
										searchListServices.getDealList(dealList,isLoad).then(function(data) {
											searchListServices.allProductsList = data;
											filterService.selectedLevelOneData = '';
											filterService.selectedLevelTwoData = "";
											filterService.selectedLevelThreeData = "";
											searchListServices.isCompareAvailable = false;
											if (pagination) {
												searchListVm.searchResult.products = searchListVm.searchResult.products.concat(searchListServices.allProductsList.products);
											} else {
												searchListVm.searchResult = searchListServices.allProductsList;
											}
											loadData(searchListVm.sortOP);
										}, function(error) {
											utilityService.showErrorMessage(error.responseMessage);
										});
									}
									
									
								}else{
									
									if (searchListServices.serviceFrom === 'getSelectedCategoryProduct') {
										var obj = {
											"category" : searchListServices.serviceFromObj.category,
											"websiteId" : searchListServices.serviceFromObj.websiteId,
											"filters" : filterService.addedFilterData,
											"sort" : searchListServices.sortObjectData,
											"page" : $scope.currentPage.toString(),
											"isLoggedIn":mPinLoginService.isLoggedIn
										}
										searchListServices.getSelectedCategoryNewProduct(obj,isLoad).then(function(data) {
											searchListServices.allProductsList = data;
											searchListServices.isCompareAvailable = true;
											if (pagination) {
												searchListVm.searchResult.products = searchListVm.searchResult.products.concat(searchListServices.allProductsList.products);
											} else {
												searchListVm.searchResult = searchListServices.allProductsList;
												
											}
											loadData(searchListVm.sortOP);
											if (pagination) {
												$scope.$broadcast('scroll.infiniteScrollComplete');
											}
										}, function(error) {
											utilityService.showErrorMessage(error.responseMessage);
										});
									} else if (searchListServices.serviceFrom === 'getSearchProductsList') {
										var obj = {
											"websiteId" : searchListServices.serviceFromObj.websiteId,
											"keyword" : searchListServices.serviceFromObj.keyword,
											"filters" : filterService.addedFilterData,
											"sort" : searchListServices.sortObjectData,
											"page" : $scope.currentPage.toString(),
											"isLoggedIn":mPinLoginService.isLoggedIn
										}
										searchListServices.getSearchNewProductsList(obj,isLoad).then(function(data) {
											searchListServices.allProductsList = data;
											filterService.selectedLevelOneData = '';
											filterService.selectedLevelTwoData = "";
											filterService.selectedLevelThreeData = "";
											searchListServices.isCompareAvailable = true;
											if (pagination) {
												searchListVm.searchResult.products = searchListVm.searchResult.products.concat(searchListServices.allProductsList.products);
											} else {
												searchListVm.searchResult = searchListServices.allProductsList;
											}
											loadData(searchListVm.sortOP);
										}, function(error) {
											utilityService.showErrorMessage(error.responseMessage);
										});
									} else if (searchListServices.serviceFrom === 'getRecentlyViewedListing') {
										var recentProductsList = {
											"websiteId" : searchListServices.serviceFromObj.websiteId,
											"filters" : filterService.addedFilterData,
											"sort" : searchListServices.sortObjectData,
											"page" : $scope.currentPage.toString(),
											"isLoggedIn":mPinLoginService.isLoggedIn
										}
										searchListServices.getRecentlyViewedNewListing(recentProductsList,isLoad).then(function(data) {
											searchListServices.allProductsList = data;
											filterService.selectedLevelOneData = '';
											filterService.selectedLevelTwoData = "";
											filterService.selectedLevelThreeData = "";
											searchListServices.isCompareAvailable = false;
											if (pagination) {
												searchListVm.searchResult.products = searchListVm.searchResult.products.concat(searchListServices.allProductsList.products);
											} else {
												searchListVm.searchResult = searchListServices.allProductsList;
											}
											loadData(searchListVm.sortOP);
										}, function(error) {
											utilityService.showErrorMessage(error.responseMessage);
										});
									} else if (searchListServices.serviceFrom === 'getSimilarProductList') {
										var similarProductsList = {
											"websiteId" : searchListServices.serviceFromObj.websiteId,
											"productId" : searchListServices.serviceFromObj.productId,
											"price" : searchListServices.serviceFromObj.price,
											"filters" :filterService.addedFilterData,
											"sort" : searchListServices.sortObjectData,
											"page" : $scope.currentPage.toString(),
											"isLoggedIn":mPinLoginService.isLoggedIn
										};
										productDescriptionServices.getSimilarProductNewList(similarProductsList,isLoad).then(function(data) {
											searchListServices.allProductsList = data;
											filterService.selectedLevelOneData = '';
											filterService.selectedLevelTwoData = "";
											filterService.selectedLevelThreeData = "";
											searchListServices.isCompareAvailable = true;
											if (pagination) {
												searchListVm.searchResult.products = searchListVm.searchResult.products.concat(searchListServices.allProductsList.products);
											} else {
												searchListVm.searchResult = searchListServices.allProductsList;
											}
											loadData(searchListVm.sortOP);
										}, function(error) {
											utilityService.showErrorMessage(error.responseMessage);
										});
									} else {
										var dealList = {
											"type" : searchListServices.serviceFromObj.type,
											"websiteId" : searchListServices.serviceFromObj.websiteId,
											"filters" : filterService.addedFilterData,
											"sort" : searchListServices.sortObjectData,
											"page" : $scope.currentPage.toString(),
											"isLoggedIn":mPinLoginService.isLoggedIn
										}
										searchListServices.getDealNewList(dealList,isLoad).then(function(data) {
											searchListServices.allProductsList = data;
											filterService.selectedLevelOneData = '';
											filterService.selectedLevelTwoData = "";
											filterService.selectedLevelThreeData = "";
											searchListServices.isCompareAvailable = false;
											if (pagination) {
												searchListVm.searchResult.products = searchListVm.searchResult.products.concat(searchListServices.allProductsList.products);
											} else {
												searchListVm.searchResult = searchListServices.allProductsList;
											}
											loadData(searchListVm.sortOP);
										}, function(error) {
											utilityService.showErrorMessage(error.responseMessage);
										});
									}
								}
							}
							searchListVm.getCompare = function(isChecked, product) {
								searchListVm.compare = true;
								if (isChecked === true) {
									if (searchListVm.images.length < 2) {
										if (searchListVm.images.length > 0) {
											if (searchListVm.images[0].setId === product.setId) {
												searchListVm.images.push(product);
												searchListServices.products = searchListVm.images;
											} else {
												angular.forEach(searchListVm.searchResult.products, function(item) {
													if (item.id === product.id)
														item.selected = false;
												});
												var a = searchListVm.searchResult.products;
												var alertPop = $ionicPopup.alert({
													template : '<div class="cmpPopup" translate="COMPARESIMILAR"></div>',
													scope : $scope,
													cssClass : 'my-omp-popup',
													buttons : [
														{
															text : 'OK',
															type : 'button-assertive',
															onTap : function() {
																alertPop.close();
															}
														}
													],
												});
											}
										} else {
											searchListVm.images.push(product);
											searchListServices.products = searchListVm.images;
										}
										if (searchListVm.images.length === 2) {
											searchListVm.disbledcompare = false;
										}
									} else {
										angular.forEach(searchListVm.searchResult.products, function(item) {
											if (item.id === product.id)
												item.selected = false;
										});
										var a = searchListVm.searchResult.products;
										var alertPopup = $ionicPopup.alert({
											template : '<div class="cmpPopup" translate="OMPCOMPARE"></div>',
											scope : $scope,
											cssClass : 'my-omp-popup',
											buttons : [
												{
													text : 'OK',
													type : 'button-assertive',
													onTap : function() {
														alertPopup.close();
													}
												}
											],
										});
									}
								} else {
									var searchListVmLen = searchListVm.images.length;
									for (var i = 0; i < searchListVmLen; i++) {
										if (product.id === searchListVm.images[i].id) {
											searchListVm.images.splice(i, 1);
											searchListServices.products = searchListVm.images;
										}
										if (searchListVm.images.length < 2) {
											searchListVm.disbledcompare = true;
										}
									}
									if (searchListVm.images.length === undefined || searchListVm.images.length === null || searchListVm.images.length < 1) {
										searchListVm.compare = false;
									}
								}
							}
							searchListVm.closeComapre = function() {
								searchListVm.compare = false;
								searchListVm.images = [];
								searchListServices.products = searchListVm.images;
								angular.forEach(searchListVm.searchResult.products, function(item) {
									item.selected = false;
								});
							}
							searchListVm.getCompareItem = function() {
								searchListVm.imagesCompare = searchListVm.images;
								var compareResponse = {
									"websiteId" : ompShopService.merWebId,
									"productId1" : searchListVm.images[0].id,
									"productId2" : searchListVm.images[1].id,
									"isLoggedIn":mPinLoginService.isLoggedIn
								};
								comparisonChartService.getProductCompare(compareResponse).then(function(data) {
									comparisonChartService.compareData = data;
									searchListVm.compare = false;
									$state.go('menu.comparisonChart');
								}, function(error) {
									utilityService.showErrorMessage(error.responseMessage);
								});
							}
							searchListVm.productDescription = function(data) {
								searchListServices.selectedProduct = data;
								var product = {
									"websiteId" : ompShopService.merWebId,
									"productId" : data.id,
									"isLoggedIn":mPinLoginService.isLoggedIn
								};
								productDescriptionServices.getProductDetails(product).then(function(data) {
									productDescriptionServices.productData = data;
									$state.go('menu.productDescription');
								}, function(error) {
									utilityService.showErrorMessage(error.responseMessage);
								});
							}
							searchListVm.removeItem = function(id) {
								var searchListVmLen = searchListVm.images.length;
								for (var i = 0; i < searchListVmLen; i++) {
									if (id === searchListVm.images[i].id) {
										searchListVm.images.splice(i, 1);
										searchListServices.products = searchListVm.images;
										angular.forEach(searchListVm.searchResult.products, function(item) {
											if (item.id === id)
												item.selected = false;
										});
									}
									if (searchListVm.images.length < 2) {
										searchListVm.disbledcompare = true;
									}
								}
								if (searchListVm.images.length === undefined || searchListVm.images.length === null || searchListVm.images.length < 1) {
									searchListVm.compare = false;
								}
							}
							this.filter = function() {

								filterService.addedFilterDataWOA = filterService.addedFilterData;
								filterService.addedFilterFullDataWOA = filterService.addedFilterFullData;
								$state.go('menu.filter');
							};
							
							$scope.registerSkip = function() {
								searchListVm.loginPop.close();
							};
							$scope.regPopup = function() {
								searchListVm.loginPop.close();
								$state.go('menu.openNewDigitalAccount');
							};	
							
							this.gotoWishlist = function() { 
								if((!mPinLoginService.userLoginStatus.isRegistered)){
									searchListVm.loginPop = $ionicPopup.show({
										title: '',
										cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head popupBackgroundDark',
										templateUrl: 'pages/OMP/productDescription/registerPopup.html',
										scope: $scope
									});
								}			
								else if((!mPinLoginService.isLoggedIn)){
									searchListVm.loginPop = $ionicPopup.show({
										title: '',
										cssClass : 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head popupBackgroundDark',
										templateUrl: 'pages/OMP/searchList/loginPop.html',
										scope: $scope
									});
								}	else{
									searchListServices.localWish = true;
									$state.go('menu.localWishlist');
								}	   
							
							};
							
							searchListVm.loginSkip = function() {
								searchListVm.loginPop.close();
							};
							searchListVm.logPopup = function() {
								searchListVm.loginPop.close();
								 $ionicModal.fromTemplateUrl( 'pages/mPinLogin/mpinLoginModel.html',{
							            scope: $scope,
							            animation: 'slide-in-up',
							            focusFirstInput: true
							        }).then(function(modal) {
							            $scope.modal = modal;
							            $scope.modal.show();
							        }); 
								
							};
							
							 $scope.resumeSession=function(mpin){
							 	var myState = $state;
							 	var myScope =  $scope; 
							    mPinLoginService;
							 	ompMerchantsService.loginAuthChallengeHandler(mpin, myState  , mPinLoginService , myScope);
					       },
							$scope.$on('$ionicView.beforeEnter', function() {
								initPage();
								$translate(['RESULTS' , 'SBI_PROD' , 'TRANSC_QUICKLY' , 'XCLUSIVE_OFFERS']).then(function(translatedValue) {
									searchListVm.showing = translatedValue['RESULTS'];
									searchListVm.l_one = translatedValue['SBI_PROD'];
									searchListVm.l_two = translatedValue['TRANSC_QUICKLY'];
									searchListVm.l_three = translatedValue['XCLUSIVE_OFFERS'];
									$scope.records = [
											        searchListVm.l_one,
											        searchListVm.l_two,
									                searchListVm.l_three 
											    ];
								});
								searchListVm.isMerchantsWishListAvl = ompMerchantsService.isMerchantsWishListAvl;
								searchListVm.merchant = ompMerchantsService.listName;
								$scope.selectedSubCat = searchListServices.searchFor;
								searchListVm.dealImg = constantConfig.omp.dealImg;
								searchListVm.disc = constantConfig.omp.discount;
								searchListVm.isCompareAvailable = searchListServices.isCompareAvailable;
								searchListVm.searchResult = searchListServices.allProductsList;
								var sortDir = '';
								angular.forEach(searchListVm.searchResult.sort, function(item) {
									if (item.key === 'relevancy') {
										sortDir = item.dir;
										searchListServices.selectedSortOption = sortDir;
									}
								});
								if(filterService.isFilterApplied){
									if($scope.resultCont == "0"){
									$scope.isComingFromFilterPageNonZeorResult = true;
									$scope.diplayNonZeroSearchMessage  = false;
								    $scope.diplayNonZeroFilterMessage = true; 
									}else{
									$scope.isComingFromFilterPageNonZeorResult = true;	
									}
								}else{
									if($scope.resultCont == "0"){
									$scope.showFilterHolder = false;
									$scope.diplayNonZeroSearchMessage  = true;
								    $scope.diplayNonZeroFilterMessage = false; 
									}
								}
								loadData(sortDir);
								$scope.items = [];
								$scope.noMoreItemsAvailable = false;
								$scope.items = [
									0
								]
								$scope.isComingFromFilterPageNonZeorResult = true;
								$scope.showFilterHolder = true;
								$scope.diplayNonZeroSearchMessage  = false;
								$scope.diplayNonZeroFilterMessage = false; 
								if(filterService.isFilterApplied){
									$scope.showFilterHolder = true;
									if($scope.resultCont == "0"){
									$scope.isComingFromFilterPageNonZeorResult = true;
									$scope.diplayNonZeroSearchMessage  = false;
								    $scope.diplayNonZeroFilterMessage = true; 
									}else{
									$scope.isComingFromFilterPageNonZeorResult = true;	
									}
								}else{
									if($scope.resultCont == "0"){
									$scope.showFilterHolder = false;
									$scope.diplayNonZeroSearchMessage  = true;
								    $scope.diplayNonZeroFilterMessage = false; 
									}
								}
								$scope.scrollMainToTop();
								$scope.addDataToClickStream();
								$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
							});
					       $scope.addDataToClickStream = function() {
									if(ompMerchantsService){
										if(ompMerchantsService.listName){
											clickStreamService.clickStreamData = "websiteId,"+ompMerchantsService.listName.affiliateId;
									 }	
									};	
							};
							$scope.$on('$ionicView.beforeLeave', function(){
							   ompMerchantsService.endTimer();
							});
							$scope.$on('$ionicView.afterEnter', function() {
								ompMerchantsService.startTimer();
							});
					       $scope.$on('$ionicView.enter', function(e) {
					       		  $timeout(function() {
									  ompMerchantsService.showHeader();
								  }, 1000);

					
								});
							$scope.loadMore = function() {
								var obj = {};
								if ($scope.resultCont > 15) {
									$scope.paginationApplyed = true;
									searchListVm.getSort(obj, true);
								}else{
									$scope.noMoreItemsAvailable = true;
								}
							};
							
							  $scope.scrollMainToTop = function() {
							  	var element=angular.element(document.querySelector('.has-subheader > .scroll'));
								element = element[0];
								element.style.webkitTransform = "";
								element.style.MozTransform = "";
								element.style.msTransform = "";
								element.style.OTransform = "";
								element.style.transform = "";
							   
							var test=   angular.element(document.querySelector('.scroll'));
							test.css("transform", "1");
							  };

							$scope.loadMoreAfter = function(data) {
								var elements = document.getElementsByClassName("productRowHeight");
								while (elements.length > 0) {
									elements[0].parentNode.removeChild(elements[0]);
								}
								$scope.items = [
									0
								];
								if ($scope.currentPage >= (Math.ceil(parseInt($scope.resultCont) / 15))) {
									$scope.noMoreItemsAvailable = true;
								}
								$scope.$broadcast('scroll.infiniteScrollComplete');
							}
							function loadData(sortDir) {
								searchListVm.sortData = sortDir;
								searchListVm.sortOptions = searchListServices.allProductsList.sort;
								$scope.resultCont = utilityService.getValue(searchListServices.allProductsList.count);
								angular.forEach(searchListVm.searchResult.products, function(item) {
									item.selected = false;
								});
								if (utilityService.isUndefined(searchListServices.products) || searchListServices.products.length === 0) {
									searchListVm.compare = false;
									searchListVm.disbledcompare = true;
								} else {
									if (searchListServices.products === 2) {
										searchListVm.disbledcompare = false;
									}
								}
								searchListVm.images = searchListServices.products;
								var productsLen = searchListVm.searchResult.products.length;
								for (var i = 0; i < productsLen; i++) {
									var productsLength = searchListServices.products.length;
									for (var j = 0; j < productsLength; j++) {
										if (searchListVm.searchResult.products[i].id === searchListServices.products[j].id) {
											searchListVm.searchResult.products[i].selected = true;
											searchListVm.compare = true;
											break;
										} else {
											searchListVm.searchResult.products[i].selected = false;
										}
									}
								}
								if ($scope.paginationApplyed) {
									$scope.loadMoreAfter(searchListVm.searchResult.products);
									$scope.paginationApplyed = false;
								}
								
								
								

								if (filterService.isFilterApplied) {
									var oldFilterLen = filterService.filterOldData.categoryList.filters.length;
									var newFilterLen = filterService.filterNewData.categoryList.filters.length;
									var oldColorFilterDataLen = filterService.filterOldData.colorList.length;
									var newColorFilterDataLen = filterService.filterNewData.colorList.length;
									for (var i = 0; i < oldFilterLen; i++) {
										var isoldFilterAvl = false;
										if (filterService.filterOldData.categoryList.filters[i].code === "price" || filterService.filterOldData.categoryList.filters[i].code === "category"
												|| filterService.filterOldData.categoryList.filters[i].code === "color" || containsData(filterService.addedFilterNewFullData, filterService.filterOldData.categoryList.filters[i].code)) {
											continue;
										}
										for (var j = 0; j < newFilterLen; j++) {
											if (filterService.filterOldData.categoryList.filters[i].code === filterService.filterNewData.categoryList.filters[j].code) {
												var isoldFilterAvl = true;
												var oldFilterDataLen = filterService.filterOldData.categoryList.filters[i].data.length;
												var newFilterDataLen = filterService.filterNewData.categoryList.filters[j].data.length;
												for (var k = 0; k < oldFilterDataLen; k++) {
													var isoldFilterDataAvl = false;
													for (var l = 0; l < newFilterDataLen; l++) {
														if (filterService.filterOldData.categoryList.filters[i].data[k].value === filterService.filterNewData.categoryList.filters[j].data[l].value) {
															isoldFilterDataAvl = true;
															break;
														}
													}
													if (!isoldFilterDataAvl) {
														var addFltDataLen = filterService.addedFilterData.length;
														var isoldSubFilterDataAvl = false;
														
														for (var m = 0; m < addFltDataLen; m++) {
															if (filterService.addedFilterData[m].value === filterService.filterOldData.categoryList.filters[i].code) {
																var addedFilterDataArrLen = filterService.addedFilterData[m].data.length;
																for (var n = 0; n < addedFilterDataArrLen; n++) {
																	if (filterService.addedFilterData[m].data[n] === filterService.filterOldData.categoryList.filters[i].data[m]) {
																		isoldSubFilterDataAvl = true;
																		break;
																	}
																}
															}
														}
														var isSelected = (filterService.filterOldData.categoryList.filters[i].data[k].isSelected === true);
														if (!isoldSubFilterDataAvl && (!isSelected)) {
															filterService.filterOldData.categoryList.filters[i].data[k].disable = true;
																													
														}
														
													}else{
														filterService.filterOldData.categoryList.filters[i].data[k].disable = false;
													}
												}
											}
										}
										
										if (!isoldFilterAvl) {
																						var oldFilterDataLen = filterService.filterOldData.categoryList.filters[i].data.length;
																							for (var k = 0; k < oldFilterDataLen; k++) {
																								var isSelected = (filterService.filterOldData.categoryList.filters[i].data[k].isSelected === true);
																								if(!isSelected)	{
																									filterService.filterOldData.categoryList.filters[i].data[k].disable = true;
																								}		
																								
																							}
																																								}
										
									}
									
									if (!containsData(filterService.addedFilterNewFullData, 'color')) {
																			for (var i = 0; i < oldColorFilterDataLen; i++) {
																				var isoldColorFilterAvl = false;
																				for (var j = 0; j < newColorFilterDataLen; j++) {
																					if (filterService.filterOldData.colorList[i].value === filterService.filterNewData.colorList[j].value) {
																						isoldColorFilterAvl = true;
																						break;
																					}
																				}
																				if (!isoldColorFilterAvl) {
																					var isSelected = (filterService.filterOldData.colorList[i].isSelected === true);
																					if(!isSelected)	{
																					filterService.filterOldData.colorList[i].disable = true;
																					}
																				} else {
																					filterService.filterOldData.colorList[i].disable = false;
																				}
																			}
																		}
									
									
									
								}
								
								function containsData(filterArray, code) {
									var filterArrayLen = filterArray.length ;
									for (var i = 0; i < filterArrayLen; i++) {
										if (filterArray[i] === code) {
											return true;
										}
									}
									return false;
								};
								
								
							}
							return this;
						}
				]);
