'use strict';

angularApp.controller('shopCategoriesController', [
	"$state",
	"$scope",
	"$translate",
	"ompShopService",
	"ompMerchantsService",
	"$ionicHistory",
	"utilityService",
	"constantConfig",
	"filterService",
	"searchListServices",
	"mPinLoginService",
	"clickStreamService",
	"$ionicSideMenuDelegate",
	function ($state,
		$scope,
		$translate,
		ompShopService,
		ompMerchantsService,
		$ionicHistory,
		utilityService,
		constantConfig,
		filterService,
		searchListServices,
		mPinLoginService,
		clickStreamService,
		$ionicSideMenuDelegate) {
			var shopCategoriesVm = this;
			shopCategoriesVm.goBack = function() {
				$ionicHistory.goBack(-1);
			};
			shopCategoriesVm.goNext = function(data) {
				
				var listofdata=ompShopService.categoryList;
				var listofdataLen =  listofdata.length;
				for(var i=0;i<listofdataLen;i++)
					{
					if(data.id==listofdata[i].id)
						{
						break;
						}
					
					var firstLevelData=listofdata[i].childrenData;
					var firstLevelDataLen = firstLevelData.length;
					for(var j=0;j<firstLevelDataLen;j++)
						{
						
						if(data.id==firstLevelData[j].id)
						{
							filterService.selectedLevelThreeData="";
							filterService.selectedLevelTwoData=firstLevelData[j].name;
							filterService.selectedLevelOneData=listofdata[i].name;
							
						break;
						}
						var secondLevelData=firstLevelData[j].childrenData;
						var secondLevelDataLen = secondLevelData.length;
						for(var k=0;k<secondLevelDataLen;k++)
						{
						
							if(data.id==secondLevelData[k].id)
							{
						
							filterService.selectedLevelThreeData=secondLevelData[k].name;
							filterService.selectedLevelTwoData=firstLevelData[j].name;
							filterService.selectedLevelOneData=listofdata[i].name;
							break;
							}
						
						}
						
						
						
						}
					
					}
				searchListServices.searchFor = data.name;
				var obj = {
					"category" : data.id,
					"websiteId" : ompMerchantsService.listName.websiteId,
					"filters" : [],
					"sort" : {},
					"isLoggedIn":mPinLoginService.isLoggedIn
				}
				searchListServices.getSelectedCategoryProduct(obj).then(function(data) {

					filterService.filterOldData = searchListServices.filterData;
					searchListServices.allProductsList = data;
					searchListServices.products.length = 0
					filterService.addedFilterFullData.length = 0
					filterService.addedFilterData.length = 0
					filterService.selectedColour.length = 0
					searchListServices.isCompareAvailable = true;
					searchListServices.serviceFrom = 'getSelectedCategoryProduct';
					searchListServices.serviceFromObj = obj;
					filterService.isFilterApplied = false;
					searchListServices.isSortApplied = false;
					searchListServices.filterNewData = {
					                	          		categoryList : [],
					                	          		subCategoryList : [],
					                	          		colorList : [],
					                	          		priceList : [],
					                	          		callFunctionsList : []
					                	          	};
					$state.go('menu.searchList');
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			};
			$scope.$on('$ionicView.beforeLeave', function(){
				   ompMerchantsService.endTimer();
				});
				$scope.$on('$ionicView.afterEnter', function() {
					ompMerchantsService.startTimer();
				});
			$scope.$on('$ionicView.beforeEnter', function() {
				shopCategoriesVm.disc = constantConfig.omp.discount;
				shopCategoriesVm.merchant = ompMerchantsService.listName;
				shopCategoriesVm.catgList = ompShopService.featuredCategoriesList;
				$scope.addDataToClickStream();
				$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			});
			$scope.addDataToClickStream = function() {
									if(ompMerchantsService){
										if(ompMerchantsService.listName){
											clickStreamService.clickStreamData = "websiteId,"+ompMerchantsService.listName.affiliateId;
									 }	
									};	
							};
			return this;
		}
]);
