'use strict';
angularApp.service('wishListService', function($q, utilityService, AdapterUtils) {
	var wishCount = "";
	var getGlobalWishList = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getGlobalWishList", obj, true).then(function(response) {
			q.resolve(response.data[0]);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	var getGlobalWishlistCount = function(obj) {
		var q = $q.defer();
		AdapterUtils.postData("adapters/OMPAdapter/getGlobalWishlistCount", obj, false).then(function(response) {
			q.resolve(response.data);
		}, function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	return {
		wishCount : wishCount,
		getGlobalWishList : getGlobalWishList,
		getGlobalWishlistCount : getGlobalWishlistCount
	};
});
