'use strict';

angularApp.service('VIDDataServiceAO',
    function($q, AdapterUtils, constantConfig) {
        var VIDDataServiceAO = this;
        VIDDataServiceAO.generateAadharOtp = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.generateAadharOtpOVD, requestData, true).then(
                
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        VIDDataServiceAO.getEKycOTPSecure = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.getEKycOTPSecureOVD, requestData, true).then(
                
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        }; 
		VIDDataServiceAO.aadhrOTPattempt = 0;
          
        return VIDDataServiceAO;
    });
