'use strict';

angularApp.controller('religionDetailsAOController', ["$state",
    "$scope",
    "additionalDetailsAOService",
    "utilityService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "accountOpeningHomeService",//
	"enterOTPAOService",
    function($state,
        $scope,
        additionalDetailsAOService,
        utilityService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        accountOpeningHomeService,
        enterOTPAOService) {//

        var religionDetailsVm = this;

        function initPage() {
            religionDetailsVm.showBack = true;
            religionDetailsVm.showNext = false;
            religionDetailsVm.aofooter = true;
              // religionDetailsVm.religionList = [{ "value": "AO_RELHINDU_BTN", "description": "Hindu" },
                // { "value": "AO_RELCHRIST_BTN", "description": "Christian" },
                // { "value": "AO_RELMUSLIM_BTN", "description": "Muslim" },
                // { "value": "AO_RELSIKH_BTN", "description": "Sikh" },
                // { "value": "AO_RELOTHER_BTN", "description": "Others" }
            // ];
            // alert('TO BE REMOVED');
        }

        religionDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.eduQualificationListDetailsAO");
        }

        //If Religion is not selected and clicked on "Next" navigate to the next page
        religionDetailsVm.goToNextPage = function() {
            religionDetailsVm.updateAdditionalDetailsCall();
        }

        //If Religion is selected, get religion data and navigate
        religionDetailsVm.goToNextPageReligion = function(param) {
            additionalDetailsAOService.activeAdditionalDetails.religion = param.value;
            additionalDetailsAOService.customerAdditionalDetails.religion = param.description;
             $state.go("menu.category");
        }

        religionDetailsVm.populateResumeData = function(){
            if(enterOTPAOService.isResumeJourney){
                religionDetailsVm.activeStatus = additionalDetailsAOService.getIdByValue(religionDetailsVm.religionList, additionalDetailsAOService.customerAdditionalDetails.religion);
            }
        }

		religionDetailsVm.loadReligionList = function(){
            var requestParam = "MaritalLotus";
            religionDetailsVm.isErorr = false;
            utilityService.showSpinner();
                
            additionalDetailsAOService.getReligionStatus(requestParam).then(function(data) {
                religionDetailsVm.isErorr = false;
                utilityService.hideSpinner();
                religionDetailsVm.religionList = data.data.masterDetails;
                additionalDetailsAOService.religionList = data.data.masterDetails;
               religionDetailsVm.populateResumeData();
               // religionDetailsVm.maritalStatusList = additionalDetailsAOService.maritalStatusList;
            }, function(error) {
            	utilityService.hideSpinner();
            	religionDetailsVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            additionalDetailsAOService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            religionDetailsVm.activeStatus = additionalDetailsAOService.activeAdditionalDetails.religion;
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            if(!religionDetailsVm.religionList){
            	if(additionalDetailsAOService.religionList){
            		religionDetailsVm.religionList = additionalDetailsAOService.religionList;
            	}else{
            		religionDetailsVm.loadReligionList();	
            	}
            	
            }
            religionDetailsVm.populateResumeData();
            
        });

        return this;
    }
]);
