'use strict';

angularApp.controller('applicationExistsAOController', ["$state",
    "$scope",
    "$translate",
    "utilityService",
    "$ionicSideMenuDelegate",
    "accountOpeningHomeService",
    "enterOTPAOService",
    "chequeBookServiceDetailsService",
    "userLoginDetailsService",
	"applicationExistsAOService",
	"currentAddressPDCService",
	"additionalDetailsAOService",
	"nomineeDetailsAOService",
	"constantConfig",
       function($state,
        $scope,
        $translate,
        utilityService,
        $ionicSideMenuDelegate,
        accountOpeningHomeService,
        enterOTPAOService,
        chequeBookServiceDetailsService,
        userLoginDetailsService,
		applicationExistsAOService,
		currentAddressPDCService,
		additionalDetailsAOService,
		nomineeDetailsAOService,
		constantConfig) {

        var applicationExistsAOVm = this;

        applicationExistsAOVm.showBack = true;
        applicationExistsAOVm.showNext = false;
        applicationExistsAOVm.aofooter = true;

        function initPage() {
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                applicationExistsAOVm.okBtntext = translatedvalue;  
            });
        }

        applicationExistsAOVm.goBacktoPrevious = function() {
            $state.go('menu.resumeAccountPageAO');
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        // applicationExistsAOVm.goToNextPage = function() {

        // }

        applicationExistsAOVm.freshApp = function(){
            var requestParams = {
                "id" : userLoginDetailsService.mobile
            }

            applicationExistsAOService.removeCustomerDocument(requestParams).then(function(response) {
                if(enterOTPAOService.taxPage.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
					enterOTPAOService.clearResumeData();
                    applicationExistsAOService.journeyRedirectOption = constantConfig.acOpeningAdapterOVDConstant.digitalOVD;
                }else{
					enterOTPAOService.clearResumeData();
                    applicationExistsAOService.journeyRedirectOption = constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar;
				}
				
                $state.go('menu.ovdAadhaarSplitAO');
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        applicationExistsAOVm.resumeApp = function(){
			//applicationExistsAOVm.navigateToPage(enterOTPAOService.resumeDocumentData);
			enterOTPAOService.navigateToPage(enterOTPAOService.resumeDocumentData);
        }


        // applicationExistsAOVm.navigateToPage = function(response) {
		// 	switch(response.payLoad.commonId) {
		// 		case "FatcaDetails":
		// 			if(enterOTPAOService.taxPage.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
		// 				$state.go('menu.aadhaarOption');
		// 			}else{
		// 				$state.go(response.payLoad.mobileURL);
		// 			}
		// 			break;
		// 		case "proofOfAddress":
		// 			$state.go(response.payLoad.mobileURL);
		// 			break;
		// 		case "personalDetails":
		// 			if(enterOTPAOService.taxPage.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
		// 				if("menu.currentAddressPDAO" == response.payLoad.mobileURL &&
		// 				chequeBookServiceDetailsService.isPasswordSet !== true && !currentAddressPDCService.isCustomerCorrespondenceAddressSet){
		// 				 $state.go("menu.aadhaarOption");
		// 				 }else if("menu.currentAddressPDAO" == response.payLoad.mobileURL &&
		// 		       chequeBookServiceDetailsService.isPasswordSet !== true){
		// 		    	$state.go("menu.tempLoginAO");
		// 		    	}else{
		// 					$state.go('menu.getPictureAO'); 
		// 				}
		// 			}else{
		// 				if("menu.currentAddressPDAO" == response.payLoad.mobileURL &&
		// 		       chequeBookServiceDetailsService.isPasswordSet !== true){
		// 		    	$state.go("menu.tempLoginAO");
		// 		    }else{
		// 		    	$state.go(response.payLoad.mobileURL);	
		// 		    }
		// 			}
					
		// 			//$state.go("menu.citizenshipDetailsAO");
		// 			break;
		// 		case "currentAddress":
		// 		if(enterOTPAOService.taxPage.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
		// 			if("menu.getPictureAO" == response.payLoad.mobileURL &&
		// 			chequeBookServiceDetailsService.isPasswordSet !== true){
		// 			$state.go("menu.tempLoginAO");
		// 			}else{
		// 				$state.go(response.payLoad.mobileURL);
		// 			}
		// 		}else{
		// 			$state.go(response.payLoad.mobileURL);
		// 		}				
		// 			break;
		// 		case "customerPhoto":
		// 			$state.go(response.payLoad.mobileURL);
		// 			break;
		// 		case "additionalDetails":
		// 			if (additionalDetailsAOService.activeAdditionalDetails.subOccupation) {
		// 				$state.go(response.payLoad.mobileURL);
		// 			} else {
		// 				$state.go(response.payLoad.mobileURL);
		// 			}
		// 			break;
		// 		case "nomineeDetails":
		// 		if(nomineeDetailsAOService.nominee){
		// 			if(parseInt(nomineeDetailsAOService.nominee.age) > 18){
		// 				$state.go(response.payLoad.mobileURL);
		// 			}
		// 			else{
		// 				if(!nomineeDetailsAOService.nominee.guardianName && !nomineeDetailsAOService.nominee.guardianAge){
		// 					$state.go("menu.nomineeDetailsAO");
		// 				}
		// 				else{
		// 					$state.go("menu.nomineeDetailsAddressOptionAO");
		// 				}
		// 			}
		// 		}
				
		// 			break;
	
		// 		case "GuardianDetails":
		// 			if (nomineeDetailsAOService.nominee.guardianAddressFlag == "nomineeAddress") {
		// 				$state.go(response.payLoad.mobileURL);
		// 			} else if (nomineeDetailsAOService.nominee.guardianAddressFlag == "applicantAddress") {
		// 				$state.go(response.payLoad.mobileURL);
		// 			} else if (nomineeDetailsAOService.nominee.guardianAddressFlag == "newAddress") {
		// 				$state.go(response.payLoad.mobileURL);
		// 			}
		// 			break;
		// 		case "guardianDetails":
		// 			if (nomineeDetailsAOService.guardian.guardianAddressFlag == "nomineeAddress") {
		// 				$state.go(response.payLoad.mobileURL);
		// 			} else if (nomineeDetailsAOService.guardian.guardianAddressFlag == "applicantAddress") {
		// 				$state.go(response.payLoad.mobileURL);
		// 			} else if (nomineeDetailsAOService.guardian.guardianAddressFlag == "newAddress") {
		// 				$state.go(response.payLoad.mobileURL);
		// 			}
		// 			break;
		// 		case "servicesRequired":
		// 			$state.go(response.payLoad.mobileURL);
		// 			break;
		// 		case "personalisedKit":
		// 			$state.go(response.payLoad.mobileURL);
		// 			break;
		// 		case "customerTnC":
		// 			$state.go(response.payLoad.mobileURL);
		// 			break;
		// 		case "productOffer":
		// 			$state.go(response.payLoad.mobileURL);
		// 			break;
		// 		case "RefNumber":
		// 			$state.go(response.payLoad.mobileURL);
		// 			break;
		// 		default:
		// 			$state.go(response.payLoad.mobileURL);
		// 	}
	
		// };

        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
       //     $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
       if(enterOTPAOService.taxPage.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
        applicationExistsAOVm.appExistsUsingAadhaar = true;
        applicationExistsAOVm.appExistsUsingOvd = false;
       }else{
        applicationExistsAOVm.appExistsUsingOvd = true;
        applicationExistsAOVm.appExistsUsingAadhaar = false;
       }


        });
        
        return this;
    }
]);
