'use strict';

angularApp.service('chequeBookServiceDetailsService',
    function($q, AdapterUtils, constantConfig) {
        var chequeBookServiceDetailsService = this;
        chequeBookServiceDetailsService.setDebitCardDetails = function(requestParams) {
            var q = $q.defer(); 

            AdapterUtils.postData("",requestParams, true).then(
                function(response){ 
                    q.resolve(response);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };

        chequeBookServiceDetailsService.receiveDebitCard = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.setDebitCardKitDetailsOVD, requestParams, true).then(
                function(response) {
                    q.resolve(response);
                    
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        chequeBookServiceDetailsService.getReferenceNo = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData("", requestParams, true).then(
                function(response) {
                    q.resolve(response);
                    
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        chequeBookServiceDetailsService.sendRefEmailAndSms = function(requestParams) {
            var q = $q.defer();
            AdapterUtils.postData("", requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        
        
        chequeBookServiceDetailsService.getbankingRights = function(requestParams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.fetchDropDownListOVD+ requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        
        chequeBookServiceDetailsService.saveBankingRights = function(requestParams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.setServicesDetailsOVD, requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        
        
        chequeBookServiceDetailsService.getCardtype = function(requestParams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.fetchDropDownListOVD+ requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        
        
        chequeBookServiceDetailsService.getCardVariantOVD = function(requestParams) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.getCardVariantOVD,requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        
        
        return chequeBookServiceDetailsService;
}); 