'use strict';

angularApp.controller('aoHomePageController', [
    "$state",
    "$scope",
    "$ionicSideMenuDelegate",
    "utilityService",
	"$translate",
	"accountOpeningHomeService",
	"enterOTPAOService",
    function($state,
        $scope,
        $ionicSideMenuDelegate,
        utilityService,
		$translate,
		accountOpeningHomeService,
		enterOTPAOService) { 

        var homePageAccountOpeningVm = this;
	
		function initPage() {
			homePageAccountOpeningVm.showBack = false;
			homePageAccountOpeningVm.showNext = true;
			homePageAccountOpeningVm.disableNext = true;
			homePageAccountOpeningVm.aofooter = true;
	
		}

		$scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }
	
	
		homePageAccountOpeningVm.checkResume = function() {
			homePageAccountOpeningVm.disableNext = false;
			homePageAccountOpeningVm.applySelected = "AOactive";
			homePageAccountOpeningVm.resumeSelected = "";
			homePageAccountOpeningVm.NextActionResumePage = true;
		}
	
		homePageAccountOpeningVm.checkApplyNew = function() {
			homePageAccountOpeningVm.disableNext = false;
			homePageAccountOpeningVm.applySelected = "";
			homePageAccountOpeningVm.resumeSelected = "AOactive";
			homePageAccountOpeningVm.NextActionResumePage = false;
		}
	
		homePageAccountOpeningVm.goToNextPage = function() {
			if (homePageAccountOpeningVm.NextActionResumePage) {
				//$state.go('menu.productInformationPageAO');
				$state.go("menu.ovdAadhaarSplitAO");
			} else {
				$state.go('menu.resumeAccountPageAO');
			}
		}

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
        	homePageAccountOpeningVm.newBtnClass = "";
        	homePageAccountOpeningVm.resumeBtnClass = "";
        	enterOTPAOService.isResumeJourney = false;
	    });

        return this;
    }
]);
