'use strict';

angularApp.controller('ovdAadhaarSplitAOController', ["$state",
    "$scope",
    "utilityService",
    "$ionicSideMenuDelegate",
    "$translate",
    "knowMoreAOService",
    "productInformationService",
    "accountOpeningHomeService",
    "applicationExistsAOService",
    function ($state,
        $scope,
        utilityService,
        $ionicSideMenuDelegate,
        $translate,
        knowMoreAOService,
        productInformationService,
        accountOpeningHomeService,
        applicationExistsAOService) {

        var ovdAadhaarSplitAOVm = this;

        ovdAadhaarSplitAOVm.showBack = false;
        ovdAadhaarSplitAOVm.showNext = true;

        function initPage() {
            ovdAadhaarSplitAOVm.aofooter = true;
            
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                ovdAadhaarSplitAOVm.okBtntext = translatedvalue;
            });
        }

        
        // ovdAadhaarSplitAOVm.loadProductFeatures = function () {
        //     if(!ovdAadhaarSplitAOVm.featuresJson ){
        //     utilityService.showSpinner();	
        //     productInformationService.getProductFeatures().then(function (data) {
        //         utilityService.hideSpinner();
        //         ovdAadhaarSplitAOVm.featuresJson = data.productFeatures;
        //     }, function (error) {
        //     	utilityService.hideSpinner();
        //         utilityService.showErrorMessage(error.responseMessage);
        //     });
        //     }else{
        //     	// //ovdAadhaarSplitAOVm.featuresJson = ovdAadhaarSplitAOVm.featuresJson;
        //     }
        // }


   
       ovdAadhaarSplitAOVm.goToNextPage = function () {
        console.log("Journey starts with : " + ovdAadhaarSplitAOVm.journeyStartOption);
        accountOpeningHomeService.journeyType = ovdAadhaarSplitAOVm.journeyStartOption;
        $state.go('menu.productInformationPageAO');
        }
        
        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
           //ovdAadhaarSplitAOVm.loadProductFeatures();
           if(applicationExistsAOService.journeyRedirectOption){
            ovdAadhaarSplitAOVm.journeyStartOption = applicationExistsAOService.journeyRedirectOption;
           }
        });

        $scope.$on('$ionicView.beforeLeave', function () {
            
        });

        return this;
    }
]);