'use strict';

angularApp.controller('aadhaarAddressAOController', ["$state",
    "$scope",
    "accountOpeningHomeService",
    "utilityService",
    "aadhaarAddressService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "userLoginDetailsService",
    "currentAddressPDCService",
    "enterOTPAOService",
    "chequeBookServiceDetailsService",
    "citizenshipDetailsAOService",

    function($state,
        $scope,
        accountOpeningHomeService,
        utilityService,
        aadhaarAddressService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        userLoginDetailsService,
        currentAddressPDCService,
        enterOTPAOService,
        chequeBookServiceDetailsService,
        citizenshipDetailsAOService) {

        var aadhaarAddressAOVm = this;
        var isAddressEmpty = false;
        var leftoverAddressLine1 = "";

        function initPage() {
            aadhaarAddressAOVm.showBack = true;
            aadhaarAddressAOVm.showNext = true;
            if(enterOTPAOService.isResumeJourney == false)
            aadhaarAddressAOVm.isChecked = false;
            aadhaarAddressAOVm.aofooter = true;
        }

        aadhaarAddressAOVm.goBacktoPrevious = function() {
            citizenshipDetailsAOService.previousState = "AADHAARADDRESS";
            $state.go('menu.citizenshipDetailsAO');	
        }

        aadhaarAddressAOVm.goToNextPage = function() {
            // if (aadhaarAddressAOVm.isChecked) {
            //     accountOpeningHomeService.correspondenceCheckStatus = true;

            if(!currentAddressPDCService.customerCorrespondenceAddress){
                currentAddressPDCService.customerCorrespondenceAddress = {}
            }
                currentAddressPDCService.customerCorrespondenceAddress.address1 = aadhaarAddressAOVm.isAadhaarScanEntry ? aadhaarAddressAOVm.concatAddressLine1() : aadhaarAddressAOVm.addressAboveData;
                currentAddressPDCService.customerCorrespondenceAddress.address2 = aadhaarAddressAOVm.isAadhaarScanEntry ? aadhaarAddressAOVm.concatAddressLine2() : aadhaarAddressAOVm.addressBelowData;
                currentAddressPDCService.customerCorrespondenceAddress.pincode = aadhaarAddressAOVm.personalDetails.pincode;
                currentAddressPDCService.customerCorrespondenceAddress.city = aadhaarAddressAOVm.personalDetails.city;
                currentAddressPDCService.customerCorrespondenceAddress.district = aadhaarAddressAOVm.personalDetails.district;
                currentAddressPDCService.customerCorrespondenceAddress.state = aadhaarAddressAOVm.personalDetails.state;
                currentAddressPDCService.customerCorrespondenceAddress.locality = aadhaarAddressAOVm.personalDetails.locality;
                currentAddressPDCService.customerCorrespondenceAddress.stateCode = "";

            if (chequeBookServiceDetailsService.isPasswordSet) {
                aadhaarAddressAOVm.updateAadharDetailsCall('menu.getPictureAO');
            }else{
                aadhaarAddressAOVm.updateAadharDetailsCall('menu.tempLoginAO');
            }
                
            // } else {
            //     accountOpeningHomeService.correspondenceCheckStatus = false;
            //     accountOpeningHomeService.customerCorrespondenceAddress.address1 = "";
            //     accountOpeningHomeService.customerCorrespondenceAddress.address2 = "";
            //     accountOpeningHomeService.customerCorrespondenceAddress.pincode = "";
            //     accountOpeningHomeService.customerCorrespondenceAddress.city = "";
            //     accountOpeningHomeService.customerCorrespondenceAddress.state = "";
            //     accountOpeningHomeService.customerCorrespondenceAddress.locality = "";
            //     if(accountOpeningHomeService.isCustManualCorresChkBox){
 		    //                    aadhaarAddressAOVm.updateAadharDetailsCall('menu.personalDetailsKYCDetails');
            //                   }else{
            //                  		aadhaarAddressAOVm.updateAadharDetailsCall('menu.panDetails'); 	
            //                   } 
            // }
        }

        aadhaarAddressAOVm.differentAddressFromAadhaar = function(){
            $state.go('menu.addressNotSameAsAadhaarAO');
        }

        aadhaarAddressAOVm.setGender = function(){
            var genderDetails = {};
            if(accountOpeningHomeService.customerAadhaarCardDetails.gender.toLowerCase() == "m" || accountOpeningHomeService.customerAadhaarCardDetails.gender.toLowerCase() == constantConfig.acOp.maleGender){
                genderDetails.genderValue = "Male";
                genderDetails.genderCode = "M";
            }
            else if(accountOpeningHomeService.customerAadhaarCardDetails.gender.toLowerCase() == "f" || accountOpeningHomeService.customerAadhaarCardDetails.gender.toLowerCase() == constantConfig.acOp.femaleGender){
                genderDetails.genderValue = "Female";
                genderDetails.genderCode = "F";
            }
            else if(accountOpeningHomeService.customerAadhaarCardDetails.gender.toLowerCase() == constantConfig.acOp.transGender){
                genderDetails.genderValue = "Transgender";
                genderDetails.genderCode = "T";
            }
            return genderDetails;
        }

        // aadhaarAddressAOVm.updateAadharDetailsCall = function(navigationPage) {
        //     var genderDetails = aadhaarAddressAOVm.setGender();

        //     var requestParams = {
        //         "id": accountOpeningHomeService.customer.mobileNo,
        //         "data": {
        //             "personalDetails": {
        //                 "uid": accountOpeningHomeService.customerAadhaarCardDetails.uid,
        //                 "name": accountOpeningHomeService.customerAadhaarCardDetails.name,
        //                 "firstName": accountOpeningHomeService.customerAadhaarCardDetails.firstName,
        //                 "middleName": accountOpeningHomeService.customerAadhaarCardDetails.middleName,
        //                 "lastName": accountOpeningHomeService.customerAadhaarCardDetails.lastName,
        //                 "title": accountOpeningHomeService.customerAadhaarCardDetails.title,
        //                 "titleCode":accountOpeningHomeService.customerAadhaarCardDetails.titleCode,
        //                 "gender": genderDetails.genderValue,
        //                 "genderCode":genderDetails.genderCode,
        //                 "dob": accountOpeningHomeService.customerAadhaarCardDetails.dob,
        //                 "scannedCorrespondenceAddFlag":accountOpeningHomeService.correspondenceCheckStatus,
        //                 "isAadhaarScanned": true,
        //                 "emailId" : accountOpeningHomeService.customer.emailId,
        //                 "mobileNumber" : accountOpeningHomeService.customer.mobileNo,
        //                 "nationality":accountOpeningHomeService.customerAdditionalDetails.nationality,
        //                 "nationalityCode":accountOpeningHomeService.customerAdditionalDetails.nationalityID,
        //                 "citizenship": accountOpeningHomeService.customerAdditionalDetails.citizenship,
        //                 "citizenshipCode": accountOpeningHomeService.customerAdditionalDetails.citizenshipID,
        //                 "cityOfBirth": accountOpeningHomeService.customerAdditionalDetails.cityOfBirth,
        //                 "placeOfBirth": accountOpeningHomeService.customerAdditionalDetails.cityOfBirth,
        //                 "countryOfBirth": accountOpeningHomeService.customerAdditionalDetails.countryOfBirth,
        //                 "address": [{
        //                     "type": "aadhaar",
        //                     "addressLine1": aadhaarAddressAOVm.concatAddressLine1(),
        //                     "addressLine2": aadhaarAddressAOVm.concatAddressLine2(),
        //                     "pincode": accountOpeningHomeService.customerAadhaarCardDetails.pc,
        //                     "city": accountOpeningHomeService.customerAadhaarCardDetails.dist,
        //                     "cityCode":"",
        //                     "state": accountOpeningHomeService.customerAadhaarCardDetails.state,
        //                     "stateCode":"",
        //                     "locality": ""
        //                 }]
        //             },
        //             "additionalDetails":{
        //                 "cityOfBirth": accountOpeningHomeService.customerAdditionalDetails.cityOfBirth,
        //                 "placeOfBirth": accountOpeningHomeService.customerAdditionalDetails.cityOfBirth,
        //                 "countryOfBirth": accountOpeningHomeService.customerAdditionalDetails.countryOfBirth
        //             },
        //             "commonId": $state.$current.data.commonId
        //         }
        //     }
        //     aadhaarAddressService.updateAadhaarDetails(requestParams).then(function(response) {
        //         $state.go(navigationPage);
        //     }, function(error) {
        //         utilityService.showErrorMessage(error.responseMessage);
        //     });
        // }


        aadhaarAddressAOVm.updateAadharDetailsCall = function(navigationPage) {
            var genderDetails = aadhaarAddressAOVm.setGender();

            var requestParams = {
                "id": userLoginDetailsService.mobile,
                "type":"AO",
                "data": {
                    "personalDetails": {
                        "scannedCorrespondenceAddFlag": aadhaarAddressAOVm.isChecked,
                        "address": [{
                            "type": "PERMANENT",
                            "isAadhaarScanned": aadhaarAddressAOVm.isAadhaarScanEntry ? aadhaarAddressAOVm.isAadhaarScanEntry : false,
                            "addressLine1": aadhaarAddressAOVm.isAadhaarScanEntry ? aadhaarAddressAOVm.concatAddressLine1() : aadhaarAddressAOVm.addressAboveData,
                            "addressLine2": aadhaarAddressAOVm.isAadhaarScanEntry ? aadhaarAddressAOVm.concatAddressLine2() : aadhaarAddressAOVm.addressBelowData,
                            "pincode": aadhaarAddressAOVm.personalDetails.pincode,
                            "city": aadhaarAddressAOVm.personalDetails.city,
                            "cityCode": "",
                            "state": aadhaarAddressAOVm.personalDetails.state,
                            "stateCode": "",
                            "locality": aadhaarAddressAOVm.personalDetails.locality,
                            "district": aadhaarAddressAOVm.personalDetails.district,
                            "districtCode": "",
                            "village": "",
          					"villageCode": ""
                        }]
                    },
                    "commonId": $state.$current.data.commonId
                }                
            }

            currentAddressPDCService.savePersonalDetailsOVD(requestParams).then(function(response) {
                $state.go(navigationPage);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        // aadhaarAddressAOVm.updateAadhaarLink = function() {
        //     $state.go('menu.updateAadhaar');
        // }

        aadhaarAddressAOVm.concatAadharAddress = function() {
            var fullAddr = "";
            if (!aadhaarAddressAOVm.isVID) {
                // fullAddr = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.house) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.street) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.lm) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.loc) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.vtc) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.po) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.dist) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.state);
                fullAddr = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.house) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.street) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.lm) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.loc) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.vtc) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.po) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.dist);
            }else if(aadhaarAddressAOVm.isVID){
                fullAddr = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.addressLine1) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.addressLine2);
               
            } else {
                fullAddr = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.addressLine1) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.addressLine2);

            }
            var index = fullAddr.lastIndexOf(",");
            fullAddr = fullAddr.substring(0, index) + fullAddr.substring(index + 1);
            return fullAddr;
        }

        aadhaarAddressAOVm.concatAddressLine1 = function() {
            var addressLine1 = "";
            // addressLine1 = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.house) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.street) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.loc);
            addressLine1 = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.house) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.street);
            var index = addressLine1.lastIndexOf(",");
            addressLine1 = addressLine1.substring(0, index) + addressLine1.substring(index + 1);
            var addressLine1Length = addressLine1.length;
            if(addressLine1Length > 40){
                var index = addressLine1.lastIndexOf(",");
                leftoverAddressLine1 = addressLine1.substring(index + 1).trim();
                addressLine1 = addressLine1.substring(0, index);
            }
            return addressLine1;
        }

        aadhaarAddressAOVm.concatAddressLine2 = function() {
            var addressLine2 = "";
            //addressLine2 = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.lm) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.loc) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.vtc) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.po) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.dist) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.state);
            // addressLine2 = accountOpeningHomeService.nullCheck(leftoverAddressLine1) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.lm) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.vtc) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.po) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.dist);
            addressLine2 = accountOpeningHomeService.nullCheck(leftoverAddressLine1) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.lm) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.vtc) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.po);
            var index = addressLine2.lastIndexOf(",");
            addressLine2 = addressLine2.substring(0, index) + addressLine2.substring(index + 1);
            return addressLine2;
        }

        aadhaarAddressAOVm.checkForAddressLine1 = function() {
            var customerAddressLine1 = "";
            if (utilityService.isUndefined(accountOpeningHomeService.customerAadhaarCardDetails.house) && utilityService.isUndefined(accountOpeningHomeService.customerAadhaarCardDetails.street)) {
                customerAddressLine1 = "";
            } else {
                customerAddressLine1 = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.house) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.street);
            }
            return customerAddressLine1;
        }

        aadhaarAddressAOVm.checkForAddressLine2 = function() {
            var customerAddressLine2 = "";
            if (utilityService.isUndefined(accountOpeningHomeService.customerAadhaarCardDetails.lm) && utilityService.isUndefined(accountOpeningHomeService.customerAadhaarCardDetails.vtc) && utilityService.isUndefined(accountOpeningHomeService.customerAadhaarCardDetails.loc)) {
                customerAddressLine2 = "";
            } else {
                customerAddressLine2 = accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.lm) + accountOpeningHomeService.nullCheck(accountOpeningHomeService.customerAadhaarCardDetails.loc) + utilityService.isUndefined(accountOpeningHomeService.customerAadhaarCardDetails.vtc);
            }
            return customerAddressLine2;
        }

        //Abort the process if the address is empty and navigate to map page
        aadhaarAddressAOVm.abortIfAddressEmpty = function() {
            if (utilityService.isUndefined(aadhaarAddressAOVm.concatAadharAddress()) || utilityService.isUndefined(aadhaarAddressAOVm.checkForAddressLine1()) || utilityService.isUndefined(aadhaarAddressAOVm.checkForAddressLine2())) {
                var title = '';
                var template = '{{"AADHAAR_ADDRESS_IF_EMPTY" | translate}}';
                var onTap = 'menu.locateNearestBranch';
                var buttontext = 'Locate Nearest Branch';
                utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                aadhaarAddressAOVm.showNext = false;
                isAddressEmpty = true;
            }
            else{
                aadhaarAddressAOVm.showNext = true;
            }
            return isAddressEmpty;
        }

        aadhaarAddressAOVm.populateResumeData = function() {
            //  if (currentAddressPDCService.customerCorrespondenceAddress.isAadhaarScanned == true) {
                  aadhaarAddressAOVm.addressAboveData = currentAddressPDCService.customerCorrespondenceAddress.address1;
                  aadhaarAddressAOVm.addressBelowData = currentAddressPDCService.customerCorrespondenceAddress.address2;
                  

                    aadhaarAddressAOVm.personalDetails.pincode= currentAddressPDCService.customerCorrespondenceAddress.pincode;
                    aadhaarAddressAOVm.personalDetails.city= currentAddressPDCService.customerCorrespondenceAddress.city;
                    aadhaarAddressAOVm.personalDetails.state= currentAddressPDCService.customerCorrespondenceAddress.state;
                    aadhaarAddressAOVm.personalDetails.locality= currentAddressPDCService.customerCorrespondenceAddress.locality;
                    aadhaarAddressAOVm.personalDetails.district= currentAddressPDCService.customerCorrespondenceAddress.district;
                    aadhaarAddressAOVm.isChecked= citizenshipDetailsAOService.customerManualEntryDetails.isCustManualCorresChkBox;

                    if(aadhaarAddressAOVm.isAadhaarScanEntry || aadhaarAddressAOVm.isVID){
                        aadhaarAddressAOVm.address = aadhaarAddressAOVm.addressAboveData +" "+ aadhaarAddressAOVm.personalDetails.locality +" "+ aadhaarAddressAOVm.addressBelowData +" "+ aadhaarAddressAOVm.personalDetails.district;
                    }else{
                        aadhaarAddressAOVm.address = aadhaarAddressAOVm.addressAboveData + aadhaarAddressAOVm.addressBelowData;
                    }

                    aadhaarAddressAOVm.personalDetails.address= aadhaarAddressAOVm.address;
                
                 
             // }
          };

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            aadhaarAddressAOVm.personalDetails = {};
            aadhaarAddressAOVm.isAadhaarScanEntry = enterOTPAOService.isAadhaarScanEntry;
            aadhaarAddressAOVm.isVID = enterOTPAOService.isVID;
            if (enterOTPAOService.isResumeJourney == true && currentAddressPDCService.isCustomerCorrespondenceAddressSet){
                aadhaarAddressAOVm.populateResumeData();
            }//else{
                
                if(accountOpeningHomeService.customerAadhaarCardDetails.addressLine1 || accountOpeningHomeService.customerAadhaarCardDetails.addressLine2 || accountOpeningHomeService.customerAadhaarCardDetails.house || accountOpeningHomeService.customerAadhaarCardDetails.street || accountOpeningHomeService.customerAadhaarCardDetails.lm || accountOpeningHomeService.customerAadhaarCardDetails.loc || accountOpeningHomeService.customerAadhaarCardDetails.vtc || accountOpeningHomeService.customerAadhaarCardDetails.po || accountOpeningHomeService.customerAadhaarCardDetails.dist){
                aadhaarAddressAOVm.addressAboveData = accountOpeningHomeService.customerAadhaarCardDetails.addressLine1;
                aadhaarAddressAOVm.addressBelowData = accountOpeningHomeService.customerAadhaarCardDetails.addressLine2;

                aadhaarAddressAOVm.personalDetails.address= aadhaarAddressAOVm.concatAadharAddress();
                }
                if (accountOpeningHomeService.customerAadhaarCardDetails.pc){
                    aadhaarAddressAOVm.personalDetails.pincode= accountOpeningHomeService.customerAadhaarCardDetails.pc
                }
                if (accountOpeningHomeService.customerAadhaarCardDetails.dist){
                    aadhaarAddressAOVm.personalDetails.city= accountOpeningHomeService.customerAadhaarCardDetails.city;
                }
                if (accountOpeningHomeService.customerAadhaarCardDetails.state){
                    aadhaarAddressAOVm.personalDetails.state= accountOpeningHomeService.customerAadhaarCardDetails.state;
                }
                if (accountOpeningHomeService.customerAadhaarCardDetails.loc){
                    aadhaarAddressAOVm.personalDetails.locality= accountOpeningHomeService.customerAadhaarCardDetails.loc;
                }
                if (accountOpeningHomeService.customerAadhaarCardDetails.dist){
                    aadhaarAddressAOVm.personalDetails.district= accountOpeningHomeService.customerAadhaarCardDetails.dist;
                }
                
                
                
                
                //};
            //}
            
            // aadhaarAddressAOVm.isChecked = accountOpeningHomeService.correspondenceCheckStatus;
            /*if (enterOTPAOService.isResumeJourney == false) {
                aadhaarAddressAOVm.abortIfAddressEmpty();
            }*/

            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);

        });

        return this;
    }
]);
