'use strict';

angularApp.controller('addressNotSameAsAadhaarAOController', ["$state",
    "$scope",
    "$translate",
    "utilityService",
    "$ionicSideMenuDelegate",
    "accountOpeningHomeService",
    "$ionicHistory",
    "userLoginDetailsService",
    "applicationExistsAOService",
    "enterOTPAOService",
    "constantConfig",
       function($state,
        $scope,
        $translate,
        utilityService,
        $ionicSideMenuDelegate,
        accountOpeningHomeService,
        $ionicHistory,
        userLoginDetailsService,
        applicationExistsAOService,
        enterOTPAOService,
        constantConfig) {

        var addressNotSameAsAadhaarAOVm = this;

        addressNotSameAsAadhaarAOVm.showBack = true;
        addressNotSameAsAadhaarAOVm.showNext = false;
        addressNotSameAsAadhaarAOVm.aofooter = true;

        function initPage() {
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                addressNotSameAsAadhaarAOVm.okBtntext = translatedvalue;  
            });
        }

        addressNotSameAsAadhaarAOVm.goBacktoPrevious = function() {
            //$state.go('menu.aadharScanAddress');
            $ionicHistory.goBack();
        }

        $scope.goToHome = function() {
            accountOpeningHomeService.homeNav();
        }

        addressNotSameAsAadhaarAOVm.goToNextPage = function() {
            //$state.go('menu.takeSelfieAO');
        }

        addressNotSameAsAadhaarAOVm.openWithOvd = function(){
            var requestParams = {
                "id" : userLoginDetailsService.mobile
            }

            applicationExistsAOService.removeCustomerDocument(requestParams).then(function(response) {
                enterOTPAOService.clearResumeData();
                applicationExistsAOService.journeyRedirectOption = constantConfig.acOpeningAdapterOVDConstant.digitalOVD;
				
                $state.go('menu.ovdAadhaarSplitAO');
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
       //     $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        
        return this;
    }
]);
