'use strict';

angularApp.service('citizenshipDetailsAOService',
    function($q, AdapterUtils, constantConfig) {
        var citizenshipDetailsAOService = this;
        citizenshipDetailsAOService.getCountries = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.getCountries, true).then(

                function(response) {
                    q.resolve(response.body);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        citizenshipDetailsAOService.getCitizenship = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.getCountries, true).then(

                function(response) {
                    q.resolve(response.body);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
        citizenshipDetailsAOService.getNationality = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.getCountries, true).then(

                function(response) {
                    q.resolve(response.body);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
		
		citizenshipDetailsAOService.getInfoList = function() {
            var q = $q.defer();
            
            AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.getInfoList, true).then(
				
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
        
        citizenshipDetailsAOService.savePersonaldetailsOVD = function(request) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.savePersonalDetailsOVD, request,true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        
        return citizenshipDetailsAOService;
    });
