'use strict';

angularApp.controller('knowMorePageAOController', ["$state",
    "$scope",
    "knowMoreAOService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        knowMoreAOService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var knowMoreAOVm = this;

        knowMoreAOVm.showBack = true;
        knowMoreAOVm.showNext = false;

        function initPage() {
            knowMoreAOVm.aofooter = true;
            knowMoreAOVm.featuresJson = knowMoreAOService.featuresJson;
        }

       
        knowMoreAOVm.goBacktoPrevious = function() {
            //$state.go('');
        }

        $scope.goToHome = function(){
            $state.go('menu.productInformationPageAO');
        }
        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        
        return this;
    }
]);
