'use strict';

angularApp.service('productOfferingAOService',
    function($q, AdapterUtils, constantConfig) {
        var productOfferingAOService = this;
        productOfferingAOService.getOtherProductOfferings = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterUrl.getOtherProductInfo, true).then(

                function(response) {
                    q.resolve(response.data.otherProductInfo);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        productOfferingAOService.postProdOffers = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.productOfferFlagOVD, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return productOfferingAOService;
    });
