'use strict';

angularApp.service('taxServiceAO',
    function($q, AdapterUtils, constantConfig) {
        var taxServiceAO = this;

        taxServiceAO.setFactaFlag = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.setFactaFlagWithPanOVD, requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        taxServiceAO.getFatcaDeclaration = function(){
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.fatcaDeclarationOVD, true).then(

                function(response) {
                    q.resolve(response.data.fatcaDeclaration);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        taxServiceAO.getFatcaDetails = function(){
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.fatcaDetailsOVD, true).then(

                function(response) {
                    q.resolve(response.data.fatcaDetails);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return taxServiceAO;
    });
