'use strict';
angularApp.controller('tempLoginAOController', ["$timeout", "$state", "$scope", "$translate", "tempLoginServiceAO", "userLoginDetailsService", "utilityService", "chequeBookServiceDetailsService", "constantConfig","accountOpeningHomeService","$ionicPopup","enterOTPAOService","citizenshipDetailsAOService",
	function ($timeout, $state, $scope, $translate, tempLoginServiceAO, userLoginDetailsService, utilityService, chequeBookServiceDetailsService, constantConfig,accountOpeningHomeService,$ionicPopup,enterOTPAOService,citizenshipDetailsAOService) {

		var tempLoginAOVm = this;
		
		 function initPage() {
            tempLoginAOVm.showBack = true;
            tempLoginAOVm.showNext = true;
            tempLoginAOVm.disableNext = false;
			tempLoginAOVm.aofooter = true;
			tempLoginAOVm.inputType = "password";
			tempLoginAOVm.reInputType = "password";
			tempLoginAOVm.inputImg = "img/Visibility_OffPurple.svg";
			tempLoginAOVm.reInputImg = "img/Visibility_OffPurple.svg";
			tempLoginAOVm.userNameAvailibility = "notChecked";
        }
		
		//Login with Username and Password
		tempLoginAOVm.loginWithUserName = function () {
			
		};

		$scope.goToHome = function() {
			accountOpeningHomeService.homeNav();
		}
		
		tempLoginAOVm.showInbUserCreateSuccess=function(){
			var infoPopup = $ionicPopup.show({
				template: '<p translate="INB_USER_CREATE_MSG" ></p>',
				title:'Alert',
				cssClass: 'dialog activated-blue',		
				scope: $scope,
				buttons: [ {
					text: 'Ok',
					onTap: function(e) {
						if(tempLoginAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar){
							$state.go('menu.getPictureAO');
						}else{
							$state.go('menu.currentAddressPDAO');
						}
					}
				}]
			});
		}


		tempLoginAOVm.agreeToAuthorize = function() {
            if (tempLoginAOVm.isChecked) {
                tempLoginAOVm.disableNext = true;
            } else {
                tempLoginAOVm.disableNext = false;
            }
        }

		tempLoginAOVm.goToNextPage = function () {

			tempLoginServiceAO.inbUserConsent = tempLoginAOVm.isChecked;
			var requestParams = {
				"id": userLoginDetailsService.mobile,
				"commonId":$state.$current.data.commonId,
				"data": {
						"auth" : {
							"userName": tempLoginAOVm.userName,
							"password" :tempLoginAOVm.inbPass
						},
						"personalDetails": {
								"emailId" : userLoginDetailsService.emailId,
								"mobileNumber" : userLoginDetailsService.mobile,
								"custMobNo" : userLoginDetailsService.mobile
						},
						"inbUserConsent":tempLoginServiceAO.inbUserConsent
				}
		}

		tempLoginServiceAO.saveInbUser(requestParams).then(function(response) {
			var responseCode = response.responseCode;
			if (responseCode === constantConfig.successCode) {
				chequeBookServiceDetailsService.isPasswordSet = true;
				// $state.go('menu.currentAddressPDAO');	
				tempLoginAOVm.showInbUserCreateSuccess();
			}

	}, function(error) {
		 utilityService.showErrorMessage(error.responseMessage);
	});


			
		};
		
		tempLoginAOVm.goBacktoPrevious = function () {
			if((tempLoginAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && enterOTPAOService.isAadhaarScanEntry) || (tempLoginAOVm.journeyType == constantConfig.acOpeningAdapterOVDConstant.digitalAadhaar && enterOTPAOService.isVID)){
				$state.go('menu.aadharScanAddress');
			}else{
				citizenshipDetailsAOService.previousState = "TEMPUSER";
				$state.go('menu.citizenshipDetailsAO');	
			}
		};

		tempLoginAOVm.resetUserfield = function(){
			tempLoginAOVm.userNameAvailibility = "notChecked";
		}

		tempLoginAOVm.hideShowPassword = function (param) {
			if(param == "enterPassword"){
			tempLoginAOVm.inputType == "password" ? (tempLoginAOVm.inputType = "text" , tempLoginAOVm.inputImg = "img/Visibility_OnPurple.svg") : (tempLoginAOVm.inputType = "password" , tempLoginAOVm.inputImg = "img/Visibility_OffPurple.svg");
			}
			else{
			tempLoginAOVm.reInputType == "password" ? (tempLoginAOVm.reInputType = "text" , tempLoginAOVm.reInputImg = "img/Visibility_OnPurple.svg") : (tempLoginAOVm.reInputType = "password" , tempLoginAOVm.reInputImg = "img/Visibility_OffPurple.svg");
			}
		};

		// tempLoginAOVm.validateForm = function(isValid) {
		// 	isValid ? tempLoginAOVm.disableNext = false : tempLoginAOVm.disableNext = true;
		// 	 return tempLoginAOVm.disableNext;
		//  }

		tempLoginAOVm.checkAvailability = function(){
			var requestParams = {
				"id":userLoginDetailsService.mobile,
				"userName": tempLoginAOVm.userName,
				"channel": "lotus",
				"cifNo": ""
			  }
			  tempLoginServiceAO.checkInbUser(requestParams).then(function(data) {
				  if(data.data.isUserAvaliable == true){
					tempLoginAOVm.userNameAvailibility = "available";
				  }
				  else{
					tempLoginAOVm.userNameAvailibility = "notAvailable";
				  }
			}, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
			
		}

		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function () {
			initPage();

			var requestParams = {}
			if(!tempLoginServiceAO.usernamePasswordFormat){
			tempLoginServiceAO.getUsernamePasswordFormat(requestParams).then(function(data) {
				tempLoginServiceAO.usernamePasswordFormat = data.data.getUsernamePasswordFormat
				tempLoginAOVm.usernamePasswordFormat = data.data.getUsernamePasswordFormat;

		}, function(error) {
							utilityService.showErrorMessage(error.responseMessage);
					});
				}else{
					tempLoginAOVm.usernamePasswordFormat = tempLoginServiceAO.usernamePasswordFormat;
				}


				if (enterOTPAOService.isResumeJourney) {
					tempLoginAOVm.journeyType = enterOTPAOService.taxPage.journeyType;
					if(tempLoginServiceAO.inbUserConsent){
						tempLoginAOVm.isChecked = tempLoginServiceAO.inbUserConsent;
					}
				}else{
					tempLoginAOVm.journeyType = accountOpeningHomeService.journeyType;
					tempLoginAOVm.isChecked = false;
				}
				

		});

		//one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {

        });
	}]);