'use strict';

angularApp.service('termsAndConditionsAOService',
    function($q, AdapterUtils, constantConfig) {
        var termsAndConditionsAOService = this;
        termsAndConditionsAOService.getTermsAndConditions = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.acOpeningAdapterOVDUrl.getTermsAndConditionsOVD, true).then(

                function(response) {
                    q.resolve(response.data.termsAndConditions);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        termsAndConditionsAOService.postTAndC = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.acOpeningAdapterOVDUrl.termsAndConditionsFlagOVD, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return termsAndConditionsAOService;
    });
