 
angularApp.service('closeDepositOTPService',
	function($q, AdapterUtils){
		
		var closeDepositOTPService =this;
		
		//Generate OTP
		closeDepositOTPService.generateClosureOTP = function(requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure",requestData,false).then(function(response){
					q.resolve(response);
				},
				function(error){
					q.reject(error);
				});
			return q.promise;
		};

		//Validate OTP
		closeDepositOTPService.validateClosureOTP = function(requestData) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure",requestData,true).then(function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				});
			return q.promise;
		};
		return closeDepositOTPService;
	});   