/*
*Open investment account Controller
* Delevoper name:Shipra Shrivastav
*/	

'use strict';

angularApp.controller('createInvestmentAccountController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$translate",
						 "$location",
						 "$ionicScrollDelegate","mySecurityProfileService","mutualFundsService","utilityService","constantConfig","getAccountDetailsService","myDreamsServices","fixedDepositService","$rootScope","$ionicPopup",
				 
function ($timeout,
		 $state,
		 $scope,
		 $translate,
		 $location,
		 $ionicScrollDelegate,mySecurityProfileService,mutualFundsService,utilityService,constantConfig,getAccountDetailsService,myDreamsServices,fixedDepositService,$rootScope,$ionicPopup) {
	
	var createInvestAccVm = this;
	
	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		createInvestAccVm.createAccountInformation=0;
		createInvestAccVm.openAccount=1;		
		//createInvestAccVm.getIntroduction();
		createInvestAccVm.getSBIAccounts();
		createInvestAccVm.getPanCard(); 
	}
	
	/**
	*Function to go to Mutual Funds List Page 
	**/
	createInvestAccVm.goToHome=function(){
		$state.go('menu.mutualFunds');
	}
	 
	 createInvestAccVm.Urls=function(){
		mutualFundsService.getServerUrl().then(function(data){
			createInvestAccVm.panCard=data.kycNo;
		})		
		
	}

	 createInvestAccVm.getPanCard=function(){
        var reqParams={};
        reqParams['id']='';
        mutualFundsService.getPanCardNumber(reqParams).then(function(data){            
            createInvestAccVm.aofStatus=data.mfKyc.aofStatus;
			createInvestAccVm.ekycStatus=data.mfKyc.ekycStatus;            
        });
        }  

	 /**
	* Fetch getPanCard From server
	* @param {id}
	* type
	**/
	createInvestAccVm.panCard=mutualFundsService.getUserPanDetails().panNumber;
	if(createInvestAccVm.panCard=='' || createInvestAccVm.panCard ==null || createInvestAccVm.panCard==undefined){
		createInvestAccVm.panCard=mutualFundsService.geteKycPanDetails();
		if(createInvestAccVm.panCard=='' || createInvestAccVm.panCard ==null){
			createInvestAccVm.Urls();
		}
	}
	 
	
	
	/*** Function to show open account  ***/

	createInvestAccVm.showOpenAccount=function(){
		//createInvestAccVm.showLinkAccountSelection();
		createInvestAccVm.getSBIAccounts();
		if(!createInvestAccVm.openAccountSavingList){
	    	utilityService.showSpinner();
	    	createInvestAccVm.getAccountData();
		}else{
		    createInvestAccVm.createAccountInformation=0;	
		    createInvestAccVm.openAccount=1; 
		}
	}
	
	
	
	
	createInvestAccVm.getAccountData=function(){
		createInvestAccVm.MyBalanceAmount=0;
		createInvestAccVm.MyDepositsAmount=0;
		createInvestAccVm.MyBorrowingsAmount=0;
		createInvestAccVm.MyInvestmentsAmount=0;
				createInvestAccVm.displaySpinner=true;
				getAccountDetailsService.getAccountDetails().then(function(data) {
					utilityService.hideSpinner();
                getAccountDetailsService.accountOverviewData = data;
				if (!utilityService.isUndefined(getAccountDetailsService.accountOverviewData.accounts)) {
                createInvestAccVm.accounts = getAccountDetailsService.accountOverviewData.accounts;
				var accLength=createInvestAccVm.accounts.length;
                for (var i = 0; i < accLength; i++) {
                    if (createInvestAccVm.accounts[i].accountType === "Savings A/c") {

                        createInvestAccVm.savingDisplay = true;
                        getAccountDetailsService.dataDisplay.savingDisplay = createInvestAccVm.savingDisplay;

                    } else if (createInvestAccVm.accounts[i].accountType === "Current A/c") {

                        createInvestAccVm.currentDisplay = true;
                        getAccountDetailsService.dataDisplay.currentDisplay = createInvestAccVm.currentDisplay;

                    } else if (createInvestAccVm.accounts[i].accountType === "Overdraft A/c") {

                        createInvestAccVm.overdraftDisplay = true;
                        getAccountDetailsService.dataDisplay.overdraftDisplay = createInvestAccVm.overdraftDisplay;
                    }
                }
                fixedDepositService.accDetails = getAccountDetailsService.accountOverviewData.accounts;
				//Account list for securities Need to check accountList
				mySecurityProfileService.addDetails(createInvestAccVm.accounts);
				//Account list for dreams
				myDreamsServices.addAccountDetails(createInvestAccVm.accounts);
				//Account list for MF
				mutualFundsService.addAccoutDetails(createInvestAccVm.accounts);
            }	
			//createInvestAccVm.showLinkAccountSelection();
			createInvestAccVm.getSBIAccounts();
		    createInvestAccVm.createAccountInformation=0;
		    createInvestAccVm.openAccount=1; 
			} ,function(error) {
				utilityService.hideSpinner();
                                utilityService.showErrorMessage(error.responseMessage);
                            });
	}
	/***Show Saving account selection  page***/
	
	createInvestAccVm.showLinkAccountSelection = function() {
		
		createInvestAccVm.accounts=mutualFundsService.getDetails();
		$scope.accounts=[];
		if(createInvestAccVm.accounts){
			$scope.accountListTemp=createInvestAccVm.accounts;
			var accountListTempLength  = $scope.accountListTemp.length ;
			for(createInvestAccVm.list=0;createInvestAccVm.list < accountListTempLength; createInvestAccVm.list++){
				if($scope.accountListTemp[createInvestAccVm.list].accountType==constantConfig.mfAndsecConst.savingAccountInOpenAccount || $scope.accountListTemp[createInvestAccVm.list].accountType==constantConfig.mfAndsecConst.currentAccountInOpenAccount || $scope.accountListTemp[createInvestAccVm.list].accountType==constantConfig.mfAndsecConst.odAccountInOpenAccount){
					$scope.accounts.push($scope.accountListTemp[createInvestAccVm.list]);
				}
			}
			$timeout(function() {
				createInvestAccVm.accountFirstNo = $scope.accounts[0].accountNumber;
				createInvestAccVm.openAccountSavingList =$scope.accounts[0].accountNumber ;
			}, 400);
			createInvestAccVm.openAccountSavingList =$scope.accounts[0].accountNumber ;
		}else{
			createInvestAccVm.openAccountSavingList='';
		}
		
		}

		createInvestAccVm.getSBIAccounts=function(){
				mutualFundsService.getSBIBankAccounts().then(function(data){
					$scope.accounts=data.beneficiaryList.ownAccounts;
					if($scope.accounts.length > 0){						
						createInvestAccVm.accountFirstNo = $scope.accounts[0].benAccntNo;
						createInvestAccVm.openAccountSavingList=$scope.accounts[0].benAccntNo;
					}
				})
			}	
		
	/*** Function to fetch customer details to pre populate  ***/
	createInvestAccVm.agreeToFetchAccountDetails=function(){
		createInvestAccVm.fetchUserDetails();
		
		
	} 
	/*
	* Fetch user Details
	* @param {object}
	* bankAccountNumber
	* Pancard,
	*/		

	createInvestAccVm.fetchUserDetails=function(){
		var reqParams={};
		reqParams['id']=createInvestAccVm.panCard; 
		mutualFundsService.addSelectedAccount(createInvestAccVm.openAccountSavingList);  //Add account number to open account form
		
		/**call Service to fetch all user details**/
		mutualFundsService.fetchUserDetailsFromCloudant(reqParams).then(function(data){  // call to cloudant
			if(data != null && data!='' ){ 				
				mutualFundsService.addUserDetails(data,true);
				$timeout(function(){
					$state.go('menu.investmentAccountForm');
				},800);
			}else{   
				$rootScope.isBankDetail=true;
				$rootScope.fetchUserDetails=true;				
				var reqParams={};
				reqParams['bankAccountNumber']=  createInvestAccVm.openAccountSavingList; 
				mutualFundsService.fetchUserDetails(reqParams).then(function(data){
					
					mutualFundsService.addUserDetails(data,true);
					$timeout(function(){
						$state.go('menu.investmentAccountForm');
					},800);
				}, function(error){
				utilityService.showErrorMessage(error.responseMessage);

				});
			}
		}, function(error){
			createInvestAccVm.showErrorInformationPopup(error.responseMessage);
		});
		
	}
	
	/**
	* Fetch KYC COMPLIANT TEXT
	* @param {object}
	* action
	**/	
	createInvestAccVm.getIntroduction=function(){
		createInvestAccVm.reqParams={};
		createInvestAccVm.reqParams['action']=constantConfig.mfAndsecConst.kycCompliantText;
		mutualFundsService.getTermsAndConditions(createInvestAccVm.reqParams).then(function(data) {
			createInvestAccVm.investmentFormIntro=data.message;
			
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	

	/*** Function to Skip customer details to pre populate  ***/
	createInvestAccVm.skipAccountDetails=function(){
		var reqParams={};
		reqParams['id']=createInvestAccVm.panCard; 
		mutualFundsService.addSelectedAccount(createInvestAccVm.openAccountSavingList); 
		
		/**call Service to fetch all user details***/
		mutualFundsService.fetchUserDetailsFromCloudant(reqParams).then(function(data){  // call to cloudant
			  //Call to CBS
			  $rootScope.isBankDetail=true;	
			   $rootScope.skipAccountDetails=true;
				var reqParams={};
				reqParams['bankAccountNumber']=  createInvestAccVm.openAccountSavingList; 
				mutualFundsService.fetchUserDetails(reqParams).then(function(data){
				
					mutualFundsService.addUserDetails(data,true);
					$timeout(function(){
						$state.go('menu.investmentAccountForm');
					},800);
				}, function(error){
				utilityService.showErrorMessage(error.responseMessage);

				});
			
		}, function(error){
			createInvestAccVm.showErrorInformationPopup(error.responseMessage);
		});
		
	}		
	
	
	
	/*** actions to done everytime the view is shown***/	
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
		
	});

	createInvestAccVm.showErrorInformationPopup=function(message){
		$ionicPopup.show({
			template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
				+ message + '</span></div></div></div>',
			title:'',
			cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',		
			scope: $scope,
			buttons: [ {
				text: 'Ok',
				onTap: function(e) {
				$state.go('menu.accountOverviewMyBalance');				
			}
			}]
		});
	}	
	
	
	return this;
}]);

