
/*******SIP Success Controller ******/

'use strict';

angularApp.controller('createSIPSuccessController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$translate",
						 "$location","$ionicPopup",
						 "$ionicScrollDelegate","$stateParams",
				 
function ($timeout,
		 $state,
		 $scope,
		 $translate,
		 $location,$ionicPopup,
		 $ionicScrollDelegate,$stateParams) {
			 
	/*** Initialize the variables that has to show in  the HTML come here ***/
	var createSIPSuccessVm = this;
	function initPage(){
		createSIPSuccessVm.isTermsAndConditionChecked=0;
		createSIPSuccessVm.createSIPSuccess=1;
		createSIPSuccessVm.successPage=0;
	}
	/***Function to show information POP UP***/
	createSIPSuccessVm.showPopup=function(){
		
		var myPopup = $ionicPopup.show({
			template: '<ul class="bullet-list"><li>Transactions made past 2:45 p.m. will be executed the next day.</li><li>Disclaimer: MF investment are to Market Risks.Please read all scheme related documents carefully.</li></ul>',
			scope: $scope,
			cssClass: 'dialog',
			buttons: [
            {
               text: 'Ok',
               type: 'button-positive',
                  onTap: function(e) {
						 $timeout(function() {
						   myPopup.close(); //close the popup after 3 seconds for some reason
						 }, 300);
						$state.go("menu.");
                     if (!$scope.data.model) {
						  //don't allow the user to close unless he enters model...
                           e.preventDefault();
                     } else {
                        return $scope.data.model;
                     }
                  }
            }
			]
		});

		myPopup.then(function(res) {
        
      });    
	}
	
	/***Function to go to Link account***/
	createSIPSuccessVm.proceedToLinkAccount=function(){
		createSIPSuccessVm.createSIPSuccess=0;
		createSIPSuccessVm.successPage=1;
	}
	
	/***Function to go to Portfolio ***/
	createSIPSuccessVm.portfolio=function(){
		$state.go("menu.portfolio");
		createSIPSuccessVm.createSIPSuccess=1;
		createSIPSuccessVm.successPage=0;
	}
	
	/*** one time initialization to be done when the controller is loaded***/
	$scope.$on('$ionicView.loaded', function() {
		
		
	});
	
	/*** actions to done everytime the view is shown***/	
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
	
	});
	
	/***any cleanup needs to be done here: executes everytime when page is left***/
	$scope.$on('$ionicView.afterLeave', function() {
	
	});
	return this;
}]);

