
/******* Fund account Controller ******/

'use strict';

angularApp.controller('fundDetailsController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$ionicPopup",
						 "$translate",
						 "$location",
						 "$ionicScrollDelegate","mutualFundsService","utilityService","$sce","$filter","constantConfig","getAccountDetailsService","$ionicLoading","$rootScope","clickStreamService","$ionicHistory","loggedInUserService","newCardService","leadGenerationService",
				 
function ($timeout,
		 $state,
		 $scope,
		 $ionicPopup,
		 $translate,
		 $location,
		 $ionicScrollDelegate,mutualFundsService,utilityService,$sce,$filter,constantConfig,getAccountDetailsService,$ionicLoading,$rootScope,clickStreamService,$ionicHistory,loggedInUserService,newCardService,leadGenerationService) {
	
	
	/*** Initialize the variables that has to show in  the HTML come here ***/

	var fundDetailsVm = this;
	
	function initPage(){

		if(!loggedInUserService.isLoggedInDetails.isLoggedIn){
               $scope.currentDate = new Date();	
				fundDetailsVm.moreDetails=0;
				$scope.currentIndex=0;
				fundDetailsVm.fundObj=mutualFundsService.getFundId();
				fundDetailsVm.fundId=fundDetailsVm.fundObj[0].amfiCode;
				fundDetailsVm.riskParameter=fundDetailsVm.fundObj[0].riskParameter;
				fundDetailsVm.riskParameterGraphImage=fundDetailsVm.fundObj[0].riskParameterGraphImage;
				fundDetailsVm.selectedFndOption = "";
				fundDetailsVm.selectedoptnnavDate = '';
				fundDetailsVm.selectedoptnFaceVal = '';
				fundDetailsVm.selectedoptnnav = '';
				fundDetailsVm.selectOption = "0";
				
				if(fundDetailsVm.fundObj[0].isNfo=='Y'){
					fundDetailsVm.NFO=1;
				}else{
					fundDetailsVm.NFO=0;
					fundDetailsVm.performanceDuration12Month = fundDetailsVm.fundObj[0].performanceDuration12Month;
					fundDetailsVm.performanceDuration36Month = fundDetailsVm.fundObj[0].performanceDuration36Month;
					fundDetailsVm.performanceDuration60Month = fundDetailsVm.fundObj[0].performanceDuration60Month;
					fundDetailsVm.performanceDurationSinceIncep = fundDetailsVm.fundObj[0].performanceDurationSinceIncep;
				}
				fundDetailsVm.getFundDetails("prelogin");
				fundDetailsVm.infoMessage=mutualFundsService.getInfoList();
				if(fundDetailsVm.infoMessage.nav){
					fundDetailsVm.infoMessage=fundDetailsVm.infoMessage.nav;
				}else{
					fundDetailsVm.infoMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;
				}
            }else{
				
				fundDetailsVm.preLoginSelectedMenu = newCardService.getPreLoginSelectedMenu();
				$scope.currentDate = new Date();
				fundDetailsVm.getServerUrl();
				utilityService.showSpinner();
				fundDetailsVm.getAccountData();
				fundDetailsVm.moreDetails=0;
				$scope.currentIndex=0;
				fundDetailsVm.fundObj=mutualFundsService.getFundId();
				fundDetailsVm.fundId=fundDetailsVm.fundObj[0].amfiCode;
				fundDetailsVm.riskParameter=fundDetailsVm.fundObj[0].riskParameter;
				fundDetailsVm.riskParameterGraphImage=fundDetailsVm.fundObj[0].riskParameterGraphImage;
				fundDetailsVm.selectedFndOption = "";
				fundDetailsVm.selectedoptnnavDate = '';
				fundDetailsVm.selectedoptnFaceVal = '';
				fundDetailsVm.selectedoptnnav = '';
				fundDetailsVm.selectOption = "0";
				// if (ionic.Platform.isIOS()) {
				// 	fundDetailsVm.selectOption = 0;
				// }
				if(fundDetailsVm.fundObj[0].isNfo=='Y'){
					fundDetailsVm.NFO=1;
				}else{
					fundDetailsVm.NFO=0;
					fundDetailsVm.performanceDuration12Month = fundDetailsVm.fundObj[0].performanceDuration12Month;
					fundDetailsVm.performanceDuration36Month = fundDetailsVm.fundObj[0].performanceDuration36Month;
					fundDetailsVm.performanceDuration60Month = fundDetailsVm.fundObj[0].performanceDuration60Month;
					fundDetailsVm.performanceDurationSinceIncep = fundDetailsVm.fundObj[0].performanceDurationSinceIncep;
				}
				fundDetailsVm.getFundDetails("postlogin");
				fundDetailsVm.infoMessage=mutualFundsService.getInfoList();
				if(fundDetailsVm.infoMessage.nav){
					fundDetailsVm.infoMessage=fundDetailsVm.infoMessage.nav;
				}else{
					fundDetailsVm.infoMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;
				}
				
			}


		
		
		
	}
	
	/** Get accountList **/
	fundDetailsVm.getAccountData=function(){
		$ionicLoading.show({
           template: '<ion-spinner icon="android"></ion-spinner>'
         });
		mutualFundsService.fetchAccountList().then(function() {
			$ionicLoading.hide();
		} ,function(error) {
			$ionicLoading.hide();
            utilityService.showErrorMessage(error.responseMessage);
   		});
	}


	/**
	* Function to go to get fund Deatils
    @Params:{fundId:''}
	***/
	fundDetailsVm.getFundDetails=function(_data){
		
		utilityService.hideSpinner();
		fundDetailsVm.reqParams={};
		fundDetailsVm.reqParams['amfiCode']=fundDetailsVm.fundId;
		if(fundDetailsVm.fundObj[0].isNfo=='Y'){
			fundDetailsVm.reqParams['isNfo']=fundDetailsVm.fundObj[0].isNfo;
		}
		if(_data == "postlogin"){
			mutualFundsService.getFundDetailsNfo(fundDetailsVm.reqParams).then(function(data) {
			fundDetailsVm.fundDetailList=data;
			fundDetailsVm.fundNmShow = fundDetailsVm.fundDetailList.schemeName.split('-')[0]+" - Regular Plan";
			fundDetailsVm.fundDetailList.planList = [];
			for(var p=0; p<fundDetailsVm.fundObj.length; p++){
					fundDetailsVm.fundDetailList.planList.push(fundDetailsVm.fundObj[p].planList[0]);
			}
			var i;
			for(i=0; i<fundDetailsVm.fundDetailList.planList.length; i++){
					if(fundDetailsVm.fundDetailList.planList[i].option=='D'){
						fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend";
					}
					if(fundDetailsVm.fundDetailList.planList[i].option=='G'){
						fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Growth";
					}
					if(fundDetailsVm.fundDetailList.planList[i].option=='DM'){
						fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Monthly";
					}
					if(fundDetailsVm.fundDetailList.planList[i].option=='DY'){
						fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Yearly";
					}
					if(fundDetailsVm.fundDetailList.planList[i].option=='DQ'){
						fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Quarterly";
					}
					if(fundDetailsVm.fundDetailList.planList[i].option=='DW'){
						fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Weekly";
					}
					if(fundDetailsVm.fundDetailList.planList[i].option=='DF'){
						fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Fortnightly";
					}
					if(fundDetailsVm.fundDetailList.planList[i].option=='DD'){
						fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Daily";
					}
					if(fundDetailsVm.fundDetailList.planList[i].option=='DA'){
						fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Annually";
					}
					
					if(i==0){
						if(fundDetailsVm.fundDetailList.planList[i].option=='D'){fundDetailsVm.selectedFndOption = "Dividend";}
						if(fundDetailsVm.fundDetailList.planList[i].option=='G'){fundDetailsVm.selectedFndOption = "Growth";}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DM'){fundDetailsVm.selectedFndOption = "Dividend Monthly";}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DY'){fundDetailsVm.selectedFndOption = "Dividend Yearly";}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DQ'){fundDetailsVm.selectedFndOption = "Dividend Quarterly";}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DW'){fundDetailsVm.selectedFndOption = "Dividend Weekly";}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DD'){fundDetailsVm.selectedFndOption = "Dividend Daily";}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DF'){fundDetailsVm.selectedFndOption = "Dividend Fortnightly";}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DA'){fundDetailsVm.selectedFndOption = "Dividend Annually";}				
					}
					fundDetailsVm.selectedoptnnavDate = fundDetailsVm.fundDetailList.planList[0].navDate;
					fundDetailsVm.selectedoptnnav = fundDetailsVm.fundDetailList.planList[0].nav;
					if(fundDetailsVm.fundObj[0].isNfo=='Y'){
						fundDetailsVm.selectedoptnFaceVal = fundDetailsVm.fundDetailList.planList[0].nfoFaceValue;
					}
			}
			fundDetailsVm.aumDate=$filter('date')(new Date(fundDetailsVm.fundDetailList.aumEffectiveDate), 'dd MMM yyyy');
			fundDetailsVm.getRiskImg();
			if(newCardService.checkInvestNowClicked=='True'){
				newCardService.checkInvestNowClicked='';
				fundDetailsVm.applyNowAfterTnc();
			}
			}, function(error) {
				utilityService.hideSpinner();
				utilityService.showErrorMessage(error.responseMessage);
			});
		}else{
				fundDetailsVm.reqParamsNfo={};
				fundDetailsVm.reqParamsNfo['amfiCode']=fundDetailsVm.fundId;				
				fundDetailsVm.reqParamsNfo['isNfo']='Y';
				
				mutualFundsService.getFundDetailsNfoPreLogin(fundDetailsVm.reqParamsNfo).then(function(data) {
				fundDetailsVm.fundDetailList=data;
				fundDetailsVm.fundNmShow = fundDetailsVm.fundDetailList.schemeName.split('-')[0]+" - Regular Plan";
				fundDetailsVm.fundDetailList.planList = [];
				for(var p=0; p<fundDetailsVm.fundObj.length; p++){
						fundDetailsVm.fundDetailList.planList.push(fundDetailsVm.fundObj[p].planList[0]);
				}
				var i;
				for(i=0; i<fundDetailsVm.fundDetailList.planList.length; i++){
						if(fundDetailsVm.fundDetailList.planList[i].option=='D'){
							fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend";
						}
						if(fundDetailsVm.fundDetailList.planList[i].option=='G'){
							fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Growth";
						}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DM'){
							fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Monthly";
						}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DY'){
							fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Yearly";
						}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DQ'){
							fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Quarterly";
						}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DW'){
							fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Weekly";
						}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DF'){
							fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Fortnightly";
						}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DD'){
							fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Daily";
						}
						if(fundDetailsVm.fundDetailList.planList[i].option=='DA'){
							fundDetailsVm.fundDetailList.planList[i].Optionlbl = fundDetailsVm.fundDetailList.planList[i].plan +" - Dividend Annually";
						}
						
						if(i==0){
							if(fundDetailsVm.fundDetailList.planList[i].option=='D'){fundDetailsVm.selectedFndOption = "Dividend";}
							if(fundDetailsVm.fundDetailList.planList[i].option=='G'){fundDetailsVm.selectedFndOption = "Growth";}
							if(fundDetailsVm.fundDetailList.planList[i].option=='DM'){fundDetailsVm.selectedFndOption = "Dividend Monthly";}
							if(fundDetailsVm.fundDetailList.planList[i].option=='DY'){fundDetailsVm.selectedFndOption = "Dividend Yearly";}
							if(fundDetailsVm.fundDetailList.planList[i].option=='DQ'){fundDetailsVm.selectedFndOption = "Dividend Quarterly";}
							if(fundDetailsVm.fundDetailList.planList[i].option=='DW'){fundDetailsVm.selectedFndOption = "Dividend Weekly";}
							if(fundDetailsVm.fundDetailList.planList[i].option=='DD'){fundDetailsVm.selectedFndOption = "Dividend Daily";}
							if(fundDetailsVm.fundDetailList.planList[i].option=='DF'){fundDetailsVm.selectedFndOption = "Dividend Fortnightly";}
							if(fundDetailsVm.fundDetailList.planList[i].option=='DA'){fundDetailsVm.selectedFndOption = "Dividend Annually";}				
						}
						fundDetailsVm.selectedoptnnavDate = fundDetailsVm.fundDetailList.planList[0].navDate;
						fundDetailsVm.selectedoptnnav = fundDetailsVm.fundDetailList.planList[0].nav;
						if(fundDetailsVm.fundObj[0].isNfo=='Y'){
							fundDetailsVm.selectedoptnFaceVal = fundDetailsVm.fundDetailList.planList[0].nfoFaceValue;
						}
				}
				fundDetailsVm.aumDate=$filter('date')(new Date(fundDetailsVm.fundDetailList.aumEffectiveDate), 'dd MMM yyyy');
				fundDetailsVm.getRiskImg();
				}, function(error) {
					utilityService.hideSpinner();
					utilityService.showErrorMessage(error.responseMessage);
				});
		}
		
	}

	fundDetailsVm.changeOption = function(selectedindex){
		//var selectedindex = selectFndOptionBox.selectedIndex-1;
		$scope.currentIndex = selectedindex;
		fundDetailsVm.fundId=fundDetailsVm.fundObj[selectedindex].amfiCode;
		//fundDetailsVm.fundDetailList.planList[selectedindex]
		fundDetailsVm.selectedoptnnavDate =  fundDetailsVm.fundDetailList.planList[selectedindex].navDate;
		fundDetailsVm.selectedoptnnav =  fundDetailsVm.fundDetailList.planList[selectedindex].nav;
		if(fundDetailsVm.fundDetailList.planList[selectedindex].option=='D'){fundDetailsVm.selectedFndOption = "Dividend";}
		if(fundDetailsVm.fundDetailList.planList[selectedindex].option=='G'){fundDetailsVm.selectedFndOption = "Growth";}
		if(fundDetailsVm.fundDetailList.planList[selectedindex].option=='DM'){fundDetailsVm.selectedFndOption = "Dividend Monthly";}
		if(fundDetailsVm.fundDetailList.planList[selectedindex].option=='DY'){fundDetailsVm.selectedFndOption = "Dividend Yearly";}
		if(fundDetailsVm.fundDetailList.planList[selectedindex].option=='DQ'){fundDetailsVm.selectedFndOption = "Dividend Quarterly";}
		if(fundDetailsVm.fundDetailList.planList[selectedindex].option=='DW'){fundDetailsVm.selectedFndOption = "Dividend Weekly";}
		if(fundDetailsVm.fundDetailList.planList[selectedindex].option=='DD'){fundDetailsVm.selectedFndOption = "Dividend Daily";}
		if(fundDetailsVm.fundDetailList.planList[selectedindex].option=='DF'){fundDetailsVm.selectedFndOption = "Dividend Fortnightly";}
		if(fundDetailsVm.fundDetailList.planList[selectedindex].option=='DA'){fundDetailsVm.selectedFndOption = "Dividend Annually";}				

		if(fundDetailsVm.fundObj[selectedindex].isNfo=='Y'){
			fundDetailsVm.selectedoptnFaceVal = fundDetailsVm.fundDetailList.planList[selectedindex].nfoFaceValue;		
		}
		else{
			fundDetailsVm.NFO=0;
			fundDetailsVm.performanceDuration12Month = fundDetailsVm.fundObj[selectedindex].performanceDuration12Month;
			fundDetailsVm.performanceDuration36Month = fundDetailsVm.fundObj[selectedindex].performanceDuration36Month;
			fundDetailsVm.performanceDuration60Month = fundDetailsVm.fundObj[selectedindex].performanceDuration60Month;
			fundDetailsVm.performanceDurationSinceIncep = fundDetailsVm.fundObj[selectedindex].performanceDurationSinceIncep;
		}		 
	}

	fundDetailsVm.Urls=function(){
		mutualFundsService.getServerUrl().then(function(data){
			fundDetailsVm.panNumber=data.kycNo;
		})
	}
		/**
	* Function to go to get RiskImage
    @Params:{}
	***/
	fundDetailsVm.getRiskImg=function(){
		if(!loggedInUserService.isLoggedInDetails.isLoggedIn){
			fundDetailsVm.reqParams={};
		mutualFundsService.getRiskImgListPrelogin(fundDetailsVm.reqParams).then(function(data) {
		   fundDetailsVm.riskImgArray=data.riskometer;
		   angular.forEach(fundDetailsVm.riskImgArray,function(value,key){
				if(value.riskType.toUpperCase()==fundDetailsVm.riskParameter.toUpperCase()){
				   fundDetailsVm.riskParameterGraphImage=$sce.trustAsResourceUrl(value.riskImgUrl);
				}
		   });
		   
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
		}else{
			fundDetailsVm.reqParams={};
		mutualFundsService.getRiskImgList(fundDetailsVm.reqParams).then(function(data) {
		   fundDetailsVm.riskImgArray=data.riskometer;
		   angular.forEach(fundDetailsVm.riskImgArray,function(value,key){
				if(value.riskType.toUpperCase()==fundDetailsVm.riskParameter.toUpperCase()){
				   fundDetailsVm.riskParameterGraphImage=$sce.trustAsResourceUrl(value.riskImgUrl);
				}
		   });
		   
		}, function(error) {
			utilityService.showErrorMessage(error.responseMessage);
		});
		}
	}

	    fundDetailsVm.panNumber=mutualFundsService.getUserDetails().panNumber;
    	if(fundDetailsVm.panNumber=='' || fundDetailsVm.panNumber ==null || fundDetailsVm.panNumber==undefined){
    		fundDetailsVm.panNumber=mutualFundsService.geteKycPanDetails();
    		if(fundDetailsVm.panNumber=='' || fundDetailsVm.panNumber ==null){
    			fundDetailsVm.Urls();
    		}
    	}
	/*** Function to go to apply Now for KYC Page  ***/
	fundDetailsVm.applyNow=function(){
		utilityService.showSpinner();
		if(!loggedInUserService.isLoggedInDetails.isLoggedIn){
				utilityService.hideSpinner();
				newCardService.setPreLoginSelectedMenu('invest');
				loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
				$state.go('menu.userLogin');
		}else{
			// code added for centralized consent Check
			leadGenerationService.checkConsent().then(function(data){
				utilityService.hideSpinner();
				console.log(data);
				if(data.customerRecordExists == "false"){
					newCardService.checkInvestNowClicked = 'True';
					newCardService.setPostLoginSelectedMenu('invest');
					loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
					$state.go('menu.termsAndConditionsOutboundAnalytics');
				}else{
					clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("OA_TNC_CONSENT" + "_" + "MF_START_NXT_BTN"));
					fundDetailsVm.applyNowAfterTnc();
				}
			},function(error){
					utilityService.hideSpinner();	
					utilityService.showErrorMessage(error.responseMessage);
				});	
			}	
	}

	fundDetailsVm.applyNowAfterTnc = function () {
		utilityService.showSpinner();
		if(!fundDetailsVm.fundDetailList.minInvestment){
			utilityService.hideSpinner();
			return false;
			}
			if(fundDetailsVm.fundDetailList.scmPurAvailable == 'NO' && fundDetailsVm.fundDetailList.scmsipAvailable == 'NO' && fundDetailsVm.fundDetailList.isNfo !='Y'){
				fundDetailsVm.showPurchaseNtAllowPopup("Lumpsum and SIP purchases is not available for this Scheme");
				utilityService.hideSpinner();
				return false;
			}
			$rootScope.isLotusCreate=0;
			var fundToApply={};
			fundToApply['plan']=fundDetailsVm.fundDetailList.planList[$scope.currentIndex].plan;
			fundToApply['option']=fundDetailsVm.fundDetailList.planList[$scope.currentIndex].option;
			fundToApply['nav']=fundDetailsVm.fundDetailList.planList[$scope.currentIndex].nav;
			fundToApply['navDate']=fundDetailsVm.fundDetailList.planList[$scope.currentIndex].navDate;
			if(fundDetailsVm.fundDetailList.isNfo=='Y'){
				fundToApply['nfoFaceValue']=fundDetailsVm.fundDetailList.planList[$scope.currentIndex].nfoFaceValue;
				fundToApply['isNfo']=fundDetailsVm.fundDetailList.isNfo;
				fundToApply['nfoStartDate']=fundDetailsVm.fundDetailList.nfoStartDate;
				fundToApply['nfoEndDate']=fundDetailsVm.fundDetailList.nfoEndDate;
				fundToApply['nfoAllotmentDate']=fundDetailsVm.fundDetailList.nfoAllotmentDate;
			}
			fundToApply['fundId']=fundDetailsVm.fundId;  //amfiCode
			fundToApply['amfiCode']=fundDetailsVm.fundId;  //amfiCode
			fundToApply['fundName']=fundDetailsVm.fundDetailList.fundName;
			fundToApply['amcCode']=fundDetailsVm.fundDetailList.scmAmcCd;
			mutualFundsService.addFundToInvest(fundToApply);
			
			fundDetailsVm.reqParams={};
			fundDetailsVm.reqParams['id']="";		
			mutualFundsService.getPanCardNumber(fundDetailsVm.reqParams).then(function(data) {
			utilityService.hideSpinner();				
			mutualFundsService.addFolioToInvest(data);		
				if(data.mfKyc.ekycStatus == null || data == '' ){
					$rootScope.ekycPan=fundDetailsVm.panNumber.toUpperCase();
					if(fundDetailsVm.panNumber=='' || fundDetailsVm.panNumber==null || fundDetailsVm.panNumber==undefined){
						$rootScope.checkStatusPage=1;
						$rootScope.kycCompliant=0;
						$rootScope.kycNonCompliant=0;
						$state.go('menu.KYC');						
					}else{
						fundDetailsVm.checkStatus();
					}
					
				}else{
					fundDetailsVm.panCard=data.mfKyc.panNo;
					fundDetailsVm.divPayOutMechanism=data.mfKyc.divPayOutMechanism;
					fundDetailsVm.redPayOutMechanism=data.mfKyc.redPayOutMechanism;
					fundDetailsVm.folioNo=data.mfKyc.folioNo;
					fundDetailsVm.applicationStatus=data.mfKyc.aofStatus;
					fundDetailsVm.ekycStatus=data.mfKyc.ekycStatus;
					
					if(fundDetailsVm.applicationStatus=='Submitted' && fundDetailsVm.ekycStatus=="Submitted"){	
						// if(fundDetailsVm.fundDetailList.isNfo=='Y'){
						// 	$state.go("menu.lumpsum");
						// }else{	
							//$state.go('menu.typeOfInvestment');
							$state.go("menu.lumpsum");
						//}	
					}else if(fundDetailsVm.applicationStatus=='Pending' && fundDetailsVm.ekycStatus=="Submitted"){
						$state.go('menu.createInvestmentAccount'); 
					}else if(fundDetailsVm.ekycStatus=="Submitted"){
						$state.go('menu.createInvestmentAccount'); 
					}else{					
						if(fundDetailsVm.panNumber=='' || fundDetailsVm.panNumber==null || fundDetailsVm.panNumber==undefined){
							$rootScope.checkStatusPage=1;
							$rootScope.kycCompliant=0;
							$rootScope.kycNonCompliant=0;
						}else{
							if(data.mfKyc.ekycType=='Y'){
								$rootScope.kycCompliant=1;
								$rootScope.checkStatusPage=0;
								$rootScope.kycNonCompliant=0;
							}else{
								$rootScope.kycCompliant=0;
								$rootScope.checkStatusPage=1;
								$rootScope.kycNonCompliant=0;
							}
						}
						$state.go('menu.KYC');
						//$rootScope.kycCompliant=0;
						//$state.go('menu.createInvestmentAccount'); 
					}
				}
				
			}, function(error) {
				utilityService.hideSpinner();			
				if(error.responseCode=="2001"){  
					if(fundDetailsVm.panNumber=='' || fundDetailsVm.panNumber==null || fundDetailsVm.panNumber==undefined){
						$rootScope.checkStatusPage=1;
						$rootScope.kycCompliant=0;
						$rootScope.kycNonCompliant=0;
						$state.go('menu.KYC');
					}else{
						fundDetailsVm.checkStatus();
					}
					
				}else{
					utilityService.showErrorMessage(error.responseMessage);
				}
			});
	}

	fundDetailsVm.showPurchaseNtAllowPopup = function (message) {
		$ionicPopup.show({
			template: '<p>' + message + '</p>',
			title: 'Alert',
			cssClass: 'dialog',
			scope: $scope,
			buttons: [{
						text: 'Ok',
						onTap: function (e) {
							 $ionicHistory.goBack(-1);    
						}
					}]
		});
	}

	fundDetailsVm.backHandling = function(){
		mutualFundsService.addNewFundDetails("false");
		$ionicHistory.goBack(-1);
	}
	
	/*** Function to show hidden fields  ***/
	fundDetailsVm.showMore=function(){
		
		if(fundDetailsVm.moreDetails==0){
			fundDetailsVm.moreDetails=1;
		}else if(fundDetailsVm.moreDetails==1){
			fundDetailsVm.moreDetails=0;
		}
	}
	
	/*** Function to change seleted plan option  ***/
	fundDetailsVm.changeDivident=function(){
		fundDetailsVm.divident=1
		fundDetailsVm.growth=0;
	}
	
	/*** Function to change seleted plan option  ***/
	
	fundDetailsVm.setActiveList=function(index){
		$scope.currentIndex=index;
		fundDetailsVm.growth=1;
	}
	
	/***Function to show information POP UP***/
	
	fundDetailsVm.showPopup=function(){
		var infoPop = $ionicPopup.show({
			template: '<p>'+fundDetailsVm.infoMessage+'</p>',
			cssClass: 'dialog',		
			scope: $scope,
			
			buttons: [
			{ text: 'Ok' }
			]
		});
		infoPop.then(function(res) {
        
		});    
   
	
	}
	/*** one time initialization to be done when the controller is loaded***/
	$scope.$on('$ionicView.loaded', function() {
		
	});
	
	/*** actions to done everytime the view is shown***/	
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
		
		
	});
	
	 /***any cleanup needs to be done here: executes everytime when page is left***/
	$scope.$on('$ionicView.afterLeave', function() {
	
	});
	fundDetailsVm.getServerUrl=function(){
		mutualFundsService.getServerUrl().then(function(data){
			fundDetailsVm.URL=data;
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
	}
	
	/***Function to check KYC Status***/
	fundDetailsVm.checkStatus=function(formData){
		var pageContent="";
		var pageContentUrl="";
		$rootScope.ekycPan=fundDetailsVm.panNumber.toUpperCase();
		fundDetailsVm.sessionId = utilityService.getRandomNumber();
		clickStreamService.clickStreamData=fundDetailsVm.sessionId;		
	
		//fundDetailsVm.kycData =  fundDetailsVm.panNumber.toUpperCase()+'|'+fundDetailsVm.emailId+'|'+fundDetailsVm.mobile+'|sbiApp|'+fundDetailsVm.URL.camsUserId+'|'+fundDetailsVm.URL.camsPwd+'|L||sess_id';	

			 var reqPara={};
            reqPara['panId']=fundDetailsVm.panNumber.toUpperCase();
            mutualFundsService.getEncryptString(reqPara).then(function (data) {
			fundDetailsVm.encKycData=JSON.parse(data.encryptedString).data.responseString;
		
			 pageContent = '<html><head></head><body><form id="form_Id" enctype="application/x-www-form-urlencoded" name="cbsulogin" action="'+fundDetailsVm.URL.camsUrl+'" method="POST">' +
			'<input type="hidden" name="url" value="'+fundDetailsVm.URL.mobileUrl+'">' +
			'<input type="hidden" name="sess_id" value="abcd1234">' +
			'<input type="hidden" name="ekyctype" value="E">' +		
			'<input type="hidden" name="kyc_data" value="'+fundDetailsVm.encKycData+'">'+
			'</form> <script type="text/javascript">document.getElementById("form_Id").submit();</script></body></html>';	

			pageContentUrl = 'data:text/html;base64,' + btoa(pageContent);
			var ref= cordova.ThemeableBrowser.open(pageContentUrl, '_blank', {
				statusbar:{color: '#ffffffff'},
				toolbar: {
					height: 37,
					color: '#ffffffff',
					image: 'share'
				},closeButton: {
					image: 'back',
					height: 37,
					width: 32,
					align: 'left',
					event: 'closePressed'
				},backButtonCanClose: true
			});
		
			ref.addEventListener('loadstart', function(event) {	
				
				var URL=event.url;
				var n = URL.indexOf("result");
				if(n==-1){
					return;
				}
				if (n) {
					var sessId = '';
					var result=URL.split('?')[1];
					result=result.split("=")[1];
					result=decodeURIComponent(result).toString();
				}
				mutualFundsService.getDecryptString(result).then(function(resdata){
					try{
					var resultData=JSON.parse(resdata.plainString);
					resultData=resultData.data.responseString.split("|")[2];
					resultData=resultData.replace('&sess_id','');
					fundDetailsVm.todayDate=$scope.currentDate.setDate($scope.currentDate.getDate());
					fundDetailsVm.ekycType=JSON.parse(resdata.plainString).data.responseString.split("|")[0];
				 }catch(e){
				 	ref.close();
				 }			
					if(n!=-1){						
						if(fundDetailsVm.ekycType=='Y' || resultData=='KS100'){
							fundDetailsVm.reqParams={
                                "mfKyc": {
                                    "panNo": $rootScope.ekycPan,
                                    "aadharNo": fundDetailsVm.aadhaarCard,
                                    "gender": fundDetailsVm.gender,
                                    "dob": fundDetailsVm.dob,
                                    "ekycStatus":"Submitted",
                                    "aofStatus":"",
                                    "ekycType":fundDetailsVm.ekycType,
                                    "ekycTimeStamp":fundDetailsVm.todayDate,
                                    "ekycMaxInvestmentLimit":""
                                }
                            };   
								utilityService.showSpinner();
							 mutualFundsService.checkKYCStatus(fundDetailsVm.reqParams).then(function (dataKYC) {
                                    if (dataKYC.id) {
                                        var reqParams = {};
                                        reqParams['id'] = '';
									 mutualFundsService.getPanCardNumber(reqParams).then(function(dataPAN){
                                        fundDetailsVm.getServerUrl();
                                        fundDetailsVm.divPayOutMechanism=dataPAN.mfKyc.divPayOutMechanism;
                                        fundDetailsVm.redPayOutMechanism=dataPAN.mfKyc.redPayOutMechanism;
                                        fundDetailsVm.applicationStatus=dataPAN.mfKyc.aofStatus;
                                        mutualFundsService.addeKycPanDetails(fundDetailsVm.URL.kycNo);
											$rootScope.kycCompliant=1;
						            	  	$rootScope.checkStatusPage=0;
						            	  	$rootScope.kycNonCompliant=0;
											utilityService.hideSpinner();
											//$state.go('menu.createInvestmentAccount'); 
											$state.go('menu.KYC');                            
                                        
                                    }, function(error){
										utilityService.hideSpinner();
                                        utilityService.showErrorMessage(error.responseMessage);

                                    }); 	
																
								}	
							 }, function(error) {
								   utilityService.hideSpinner();
								utilityService.showErrorMessage(error.responseMessage);
							});	
						
					}else if(fundDetailsVm.ekycType=='N' || resultData=='KS101'){
	            			$rootScope.kycCompliant=0;
		            		$rootScope.checkStatusPage=0;
		            		$rootScope.kycNonCompliant=1;    								
    						$state.go('menu.KYC');			
					}						
						ref.close();
					}
				},function(error){
			    	 ref.close();		      	 
			         utilityService.showErrorMessage(error.responseMessage);
		       })
			});
			ref.addEventListener('loadstop', function(event) {
				//navigator.notification.activityStop();
			});
		},function(error){
			 ref.close();
			utilityService.showErrorMessage(error.responseMessage);
		})
			
	} 
	return this;
}]);

