/******* Introduction Mutual funds Controller ******/
'use strict';

angularApp.controller('introMutualFundsController', 
						["$timeout",
						 "$state",
						 "$scope","mutualFundsService","utilityService","$sce","homeScreenService",
				 
function ($timeout,
		 $state,
		 $scope,mutualFundsService,utilityService,$sce,homeScreenService) {
	
	
	var introMutualFundsVm = this;
	
	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		$scope.currentIndex=0;
		introMutualFundsVm.videoListFunc();
		introMutualFundsVm.isBackCheck=homeScreenService.isBackCheck;
		homeScreenService.isBackCheck	=false;
		//introMutualFundsVm.videoList=mutualFundsService.getVideoListFromService();
		//if(!introMutualFundsVm.videoList){	
		//}else{
			//introMutualFundsVm.openVideo($scope.currentIndex);
		//}
	}
	
	/** function to call video service **/
	introMutualFundsVm.videoListFunc=function(){
		/***call Service to fetch all video list ***/
		mutualFundsService.getVideoList().then(function(data){
			introMutualFundsVm.videoList=data.videoList;
			mutualFundsService.addVideo(introMutualFundsVm.videoList);
			introMutualFundsVm.openVideo($scope.currentIndex);
			
		}, function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});
		
		
	}
	/*** Function to go to Start investing page  ***/
	introMutualFundsVm.startInvesting=function (){
		introMutualFundsVm.stopVideo();
		$state.go('menu.startInvesting');
		
	}
	
	/*** Function to play video page  ***/
	introMutualFundsVm.openVideo=function (index){
	//	introMutualFundsVm.spinner=true;
		introMutualFundsVm.stopVideo();
		$scope.currentIndex=index;
		$scope.url=$scope.trustSrc(introMutualFundsVm.videoList[$scope.currentIndex].videoUrl);
		/** Auto play video**/
		introMutualFundsVm.videoPlay = document.getElementById("mfVideo"); 
		introMutualFundsVm.videoPlay.src=$scope.url;
		introMutualFundsVm.videoPlay.load();
		
		
		
		introMutualFundsVm.videoPlay.onloadedmetadata=function(){
			//	introMutualFundsVm.spinner=false;
			introMutualFundsVm.videoPlay.currentTime = 0;
			introMutualFundsVm.videoPlay.play();
			introMutualFundsVm.videoPlay.controls=true;
		}
			
		
	}
	
	$scope.trustSrc = function(videoUrl){
		return  $sce.trustAsResourceUrl(videoUrl)
	}

	/**stopVideo from playing**/
	introMutualFundsVm.stopVideo=function (){
		introMutualFundsVm.videoPlay = document.getElementById("mfVideo"); 
		introMutualFundsVm.videoPlay.pause(); 
		introMutualFundsVm.videoPlay.currentTime = 0;
		introMutualFundsVm.spinner=0;
		
	}
	/**show Controls**/
	$scope.showControls=function (){
		introMutualFundsVm.VDcontrols = document.getElementById("mfVideo"); 
		introMutualFundsVm.VDcontrols.load();
		introMutualFundsVm.VDcontrols.controls=true;
		
		
	}
	
	/*** actions to done everytime the view is shown***/	
	$scope.$on('$ionicView.beforeEnter', function() {
		initPage();
		
	});
	
	
	return this;
}]);

