/*******Investment accountForm Controller ******/

'use strict';

angularApp.controller('investmentAccountFormController',
	["$timeout",
		"$filter",
		"$state",
		"$scope",
		"$rootScope",
		"$ionicPopup",
		"$translate",
		"utilityService",
		"$ionicScrollDelegate",
		"ionicDatePicker",
		"mutualFundsService",
		"cameraService",
		"constantConfig",
		"getAccountDetailsService",
		"customerInfoService",
		function ($timeout,
			$filter,
			$state,
			$scope,
			$rootScope,
			$ionicPopup,
			$translate,
			utilityService,
			$ionicScrollDelegate,
			ionicDatePicker,
			mutualFundsService,
			cameraService,
			constantConfig,
			getAccountDetailsService,
			customerInfoService) {
			var investAccountVm = this;
			/*** Initialize the variables that has to show in  the HTML come here ***/
			function initPage() {
				$scope.minorFlag1 = 0;
				$scope.minorFlag2 = 0;
				$scope.minorFlag3 = 0;

				investAccountVm.imageSizeError = true;
				$scope.profileImageUrl = 'img/profile_placeholder.svg';
				investAccountVm.getTitle(); 				// get Title list
				investAccountVm.getOccupation(); 			// get Occupation list
				investAccountVm.getCityList(); 				// get City List
				investAccountVm.getStateList(); 			//get State List
				investAccountVm.getCountryList(); 			// get City List
				investAccountVm.getPepList(); 				// get Pep List
				investAccountVm.getTaxStatusList(); 		//get TaxStatus List
				investAccountVm.getGrossIncome(); 		//get Gross Of Wealth List
				investAccountVm.getDistributorCode();
				investAccountVm.getRelMaster();

				investAccountVm.userDetails = mutualFundsService.getUserDetails();
				investAccountVm.accountFetchFlag = mutualFundsService.accountFetch();
				investAccountVm.getSelectedAccount = mutualFundsService.getSelectedAccount();
				investAccountVm.investmentAccountForm1 = $rootScope.form6Flag || $rootScope.form7Flag ? 0: 1;  
				investAccountVm.pageVal = $rootScope.pageVal ? $rootScope.pageVal : 1;
				investAccountVm.investmentAccountForm2 = 0;
				investAccountVm.investmentAccountForm3 = 0;
				investAccountVm.investmentAccountForm4 = 0;
				investAccountVm.investmentAccountForm5 = 0;
				investAccountVm.investmentAccountForm6 = $rootScope.form6Flag ? $rootScope.form6Flag : 0;  
				investAccountVm.investmentAccountForm7 = $rootScope.form7Flag ? $rootScope.form7Flag : 0;
				investAccountVm.isTermsAndConditionChecked = 0;
				investAccountVm.noOfNominee = "1";
				investAccountVm.secondCountryDetails = 0;
				investAccountVm.thirdCountryDetails = 0;
				investAccountVm.arnNo = '';
				investAccountVm.nomineeShare = '';
				investAccountVm.nomineeShare2 = '';
				investAccountVm.nomineeShare3 = '';
				investAccountVm.shareErrorFlag = 0;
				investAccountVm.shareErrorMessage = '';
				investAccountVm.actualSharePercent = 100;
				investAccountVm.sameAddressFlag1Checked = false;
				investAccountVm.sameAddressFlag2Checked = false;
				investAccountVm.sameAddressFlag3Checked = false;
				investAccountVm.investAcntFormTermsAndConditionsFlag = 0;
				$rootScope.clickCount = 0;
				$rootScope.invalidOtpCount = 0;
				investAccountVm.FATCAFlag = "2";
				$scope.uploadPanFlag = 0;
				investAccountVm.dob = '';
				investAccountVm.asOnDate = '';
				investAccountVm.nomineeDob = '';
				investAccountVm.nomineeDob2 = '';
				investAccountVm.nomineeDob3 = '';
				investAccountVm.applicantName = '';
				investAccountVm.fatherName = '';
				investAccountVm.email = '';
				investAccountVm.mobileNumber = '';
				investAccountVm.residentialNumber = '';
				investAccountVm.diasbleShareInput1 = true
				investAccountVm.diasbleShareInput2 = true
				investAccountVm.diasbleShareInput3 = true
				investAccountVm.nomineeNameValid = false;
				investAccountVm.nomineeNameValid2 = false;
				investAccountVm.nomineeNameValid3 = false;
				investAccountVm.nomineeShareValid = false
				investAccountVm.nomineeShareValid2 = false
				investAccountVm.nomineeShareValid3 = false
				investAccountVm.nomineeShareValidOnAddress = false
				investAccountVm.nomineeShareValidOnAddress2 = false
				investAccountVm.nomineeRelValid = false;
				investAccountVm.nomineeDobValid = false;
				investAccountVm.nomineeRelValid2 = false;
				investAccountVm.nomineeDobValid2 = false;
				investAccountVm.nomineeRelValid3 = false;
				investAccountVm.nomineeDobValid3 = false;

				investAccountVm.guarNameValid1 = false;
				investAccountVm.guarNameValid2 = false;
				investAccountVm.guarNameValid3 = false;
				investAccountVm.guarRelValid1 = false;
				investAccountVm.guarRelValid2 = false;
				investAccountVm.guarRelValid3 = false;	
				investAccountVm.guarDobValid1 = false;
				investAccountVm.guarDobValid2 = false;
				investAccountVm.guarDobValid3 = false;										
				investAccountVm.nomineeRel1 = '';
				investAccountVm.noOfNomineeChangeEvt();
				investAccountVm.maskString(customerInfoService.customer.mobile);
				investAccountVm.hideSubhearder = $rootScope.hideSubhearder ? $rootScope.hideSubhearder : 0; 
				investAccountVm.folioNumber = $rootScope.folioNumber ? $rootScope.folioNumber : '';
				investAccountVm.fundName = $rootScope.fundName ? $rootScope.fundName : '';
				investAccountVm.plan = $rootScope.plan ? $rootScope.plan : '';
				investAccountVm.option = $rootScope.option ? $rootScope.option : '';
				
				$timeout(function () {
					/** Check data is coming from Cloudant **/
					if (investAccountVm.userDetails.body != null && investAccountVm.userDetails.body != '') {
						if (investAccountVm.accountFetchFlag) {
							investAccountVm.applicantName = investAccountVm.userDetails.body.customerProfile.ckyc.firstName;
							investAccountVm.gender = investAccountVm.userDetails.body.customerProfile.ckyc.gender;
							investAccountVm.dob = investAccountVm.userDetails.body.customerProfile.ckyc.dob;
							if (investAccountVm.dob != null && investAccountVm.dob != '') {
								investAccountVm.dob = $filter('date')(new Date(investAccountVm.dob), 'MM/dd/yyyy');
							} else {
								investAccountVm.dob = '';
							}
							investAccountVm.title = investAccountVm.userDetails.body.customerProfile.ckyc.title;
							investAccountVm.fatherName = investAccountVm.userDetails.body.customerProfile.profile.fatherName;
							investAccountVm.email = investAccountVm.userDetails.body.customerProfile.ckyc.emailId;
							investAccountVm.mobileNumber = investAccountVm.userDetails.body.customerProfile.ckyc.mobilephoneNo;
							investAccountVm.address1 = investAccountVm.userDetails.body.customerProfile.ckyc.address[0].line1;
							investAccountVm.address2 = investAccountVm.userDetails.body.customerProfile.ckyc.address[0].line2;
							investAccountVm.locality = investAccountVm.userDetails.body.customerProfile.ckyc.address[0].locality;
							investAccountVm.city = investAccountVm.userDetails.body.customerProfile.ckyc.address[0].city;
							investAccountVm.state = investAccountVm.userDetails.body.customerProfile.ckyc.address[0].state;
							investAccountVm.pinCode = investAccountVm.userDetails.body.customerProfile.ckyc.address[0].pincode;
							investAccountVm.residentialNumber = investAccountVm.userDetails.body.customerProfile.ckyc.landLineNumber;
							investAccountVm.occupation = investAccountVm.userDetails.body.customerProfile.profile.occupation;
							$scope.occupation = investAccountVm.occupation;
							investAccountVm.branchCode = investAccountVm.userDetails.body.branchCode;
							investAccountVm.country = investAccountVm.userDetails.body.customerProfile.ckyc.address[0].country;
							investAccountVm.netWorth = investAccountVm.userDetails.body.fatchDeclaration.netWorth;
							investAccountVm.asOnDate = investAccountVm.userDetails.body.fatchDeclaration.nwDate;
							investAccountVm.annualIncome = investAccountVm.userDetails.body.fatchDeclaration.incSlab;
							$timeout(function () {
								investAccountVm.nationality = investAccountVm.userDetails.body.customerProfile.ckyc.nationality;
								investAccountVm.PEP = investAccountVm.userDetails.body.fatchDeclaration.pepFlag;
							}, 500);
							$scope.annualIncomeCode = investAccountVm.annualIncome;
							investAccountVm.birthPlace = investAccountVm.userDetails.body.fatchDeclaration.poBirInc;
							if (investAccountVm.asOnDate != null && investAccountVm.asOnDate != '') {
								investAccountVm.grossOrNet = "2";
								investAccountVm.annualIncome = '';
								investAccountVm.asOnDate = $filter('date')(new Date(investAccountVm.asOnDate), 'MM/dd/yyyy');
							} else {
								investAccountVm.grossOrNet = "1";
								investAccountVm.netWorth = '';
								investAccountVm.asOnDate = '';
							}
							//Country details
							investAccountVm.taxId1 = investAccountVm.userDetails.body.fatchDeclaration.tpin1;
							investAccountVm.taxCountry1 = investAccountVm.userDetails.body.fatchDeclaration.taxRes1;
							investAccountVm.identificationType1 = investAccountVm.userDetails.body.fatchDeclaration.id1Type;
							if (investAccountVm.userDetails.body.fatchDeclaration.tpin2) {
								investAccountVm.taxId2 = investAccountVm.userDetails.body.fatchDeclaration.tpin2;
								investAccountVm.taxCountry2 = investAccountVm.userDetails.body.fatchDeclaration.taxRes2;
								investAccountVm.identificationType2 = investAccountVm.userDetails.body.fatchDeclaration.id2Type;
								investAccountVm.secondCountryDetails = 1;
							} else {
								investAccountVm.secondCountryDetails = 0;
							}
							if (investAccountVm.userDetails.body.fatchDeclaration.tpin3) {
								investAccountVm.taxId3 = investAccountVm.userDetails.body.fatchDeclaration.tpin3;
								investAccountVm.taxCountry3 = investAccountVm.userDetails.body.fatchDeclaration.taxRes3;
								investAccountVm.identificationType3 = investAccountVm.userDetails.body.fatchDeclaration.id3Type;
								investAccountVm.thirdCountryDetails = 1;
							} else {
								investAccountVm.thirdCountryDetails = 0;
							}
							//Add Nominee details
							investAccountVm.nominee1 = investAccountVm.userDetails.body.nomieeData.nomieeDetail[0];
							investAccountVm.nominee2 = investAccountVm.userDetails.body.nomieeData.nomieeDetail[1];
							investAccountVm.nominee3 = investAccountVm.userDetails.body.nomieeData.nomieeDetail[2];
							if (investAccountVm.nominee1) {
								investAccountVm.shareErrorFlag = 0;
								investAccountVm.appointee3 = investAccountVm.nominee1.appointeeName;
								investAccountVm.appointeeDob3 = investAccountVm.nominee1.appointeeDob;
								investAccountVm.appointeeRel3 = investAccountVm.nominee1.appointeeRelWithNominee;
								investAccountVm.nomineeRelSav1 = investAccountVm.nominee1.relwithNomiee;
								if(investAccountVm.nomineeRelSav1){
									investAccountVm.nomineeRel1={key:"", value:""};
									angular.forEach(investAccountVm.relationshipsNomineeMaster , function (value, key) { 
										if (value.value == investAccountVm.nomineeRelSav1) {               
											investAccountVm.nomineeRel1.key = value.key
											investAccountVm.nomineeRel1.value = value.value

										}  
                           			});
								}
								investAccountVm.nomineeName = investAccountVm.nominee1.nomieeName;
								investAccountVm.nomineeDob = investAccountVm.nominee1.nomieeDob;
								if (investAccountVm.nomineeDob != null && investAccountVm.nomineeDob != '') {
									investAccountVm.nomineeDob = $filter('date')(new Date(investAccountVm.nomineeDob), 'MM/dd/yyyy');
								} else {
									investAccountVm.nomineeDob = '';
								}
								investAccountVm.checkMinor();
								investAccountVm.firstNomineeAddress1 = investAccountVm.nominee1.addressOne;
								investAccountVm.firstNomineeAddress2 = investAccountVm.nominee1.addressTwo;
								investAccountVm.firstNamineeLocality = investAccountVm.nominee1.locality;
								investAccountVm.firstNomineePinCode = investAccountVm.nominee1.pinCode;
								investAccountVm.firstNomineeCity = investAccountVm.nominee1.city;
								investAccountVm.firstNomineeState = investAccountVm.nominee1.state;
								investAccountVm.appointee1 = investAccountVm.nominee1.appointeeName;
								investAccountVm.appointeeDob1 = investAccountVm.nominee1.appointeeDob;
								investAccountVm.appointeeRel1 = investAccountVm.nominee1.appointeeRelWithNominee;
								if (investAccountVm.nominee1.sharePerct) {
									investAccountVm.nomineeShare = investAccountVm.nominee1.sharePerct;
								}
							}
							if (investAccountVm.nominee2) {
								investAccountVm.shareErrorFlag = 0;
								investAccountVm.nomineeName2 = investAccountVm.nominee2.nomieeName;
								investAccountVm.nomineeDob2 = investAccountVm.nominee2.nomieeDob;
								if (investAccountVm.nomineeDob2 != null && investAccountVm.nomineeDob2 != '') {
									investAccountVm.nomineeDob2 = $filter('date')(new Date(investAccountVm.nomineeDob2), 'MM/dd/yyyy');
								} else {
									investAccountVm.nomineeDob2 = '';
								}
								
								investAccountVm.nomineeRelSav2 = investAccountVm.nominee2.relwithNomiee;
								if(investAccountVm.nomineeRelSav2){
									investAccountVm.nomineeRel2={key:"", value:""};
									angular.forEach(investAccountVm.relationshipsNomineeMaster , function (value, key) {   
										if (value.value == investAccountVm.nomineeRelSav2) {               
											investAccountVm.nomineeRel2.key = value.key
											investAccountVm.nomineeRel2.value = value.value
										}  
                           			});
								}
								investAccountVm.secondNomineeAddress1 = investAccountVm.nominee2.addressOne;
								investAccountVm.secondNomineeAddress2 = investAccountVm.nominee2.addressTwo;
								investAccountVm.secondNamineeLocality = investAccountVm.nominee2.locality;
								investAccountVm.secondNomineePinCode = investAccountVm.nominee2.pinCode;
								investAccountVm.secondNomineeCity = investAccountVm.nominee2.city;
								investAccountVm.secondNomineeState = investAccountVm.nominee2.state;
								investAccountVm.nomineeShare2 = investAccountVm.nominee2.sharePerct;
								investAccountVm.appointee2 = investAccountVm.nominee2.appointeeName;
								investAccountVm.appointeeDob2 = investAccountVm.nominee2.appointeeDob;
								investAccountVm.appointeeRel2 = investAccountVm.nominee2.appointeeRelWithNominee;
							}
							if (investAccountVm.nominee3) {
								investAccountVm.shareErrorFlag = 0;
								investAccountVm.nomineeName3 = investAccountVm.nominee3.nomieeName;
								investAccountVm.nomineeDob3 = investAccountVm.nominee3.nomieeDob;
								if (investAccountVm.nomineeDob3 != null && investAccountVm.nomineeDob3 != '') {
									investAccountVm.nomineeDob3 = $filter('date')(new Date(investAccountVm.nomineeDob3), 'MM/dd/yyyy');
								} else {
									investAccountVm.nomineeDob3 = '';
								}
								
								investAccountVm.nomineeRelSav3 = investAccountVm.nominee3.relwithNomiee;
								if(investAccountVm.nomineeRelSav3){
									investAccountVm.nomineeRel3={key:"", value:""};
									angular.forEach(investAccountVm.relationshipsNomineeMaster , function (value, key) { 
										if (value.value == investAccountVm.nomineeRelSav3) {               
											investAccountVm.nomineeRel3.key = value.key
											investAccountVm.nomineeRel3.value = value.value
										}  
                           			});
								}
								investAccountVm.thirdNomineeAddress1 = investAccountVm.nominee3.addressOne;
								investAccountVm.thirdNomineeAddress2 = investAccountVm.nominee3.addressTwo;
								investAccountVm.thirdNamineeLocality = investAccountVm.nominee3.locality;
								investAccountVm.thirdNomineePinCode = investAccountVm.nominee3.pinCode;
								investAccountVm.thirdNomineeCity = investAccountVm.nominee3.city;
								investAccountVm.thirdNomineeState = investAccountVm.nominee3.state;
								investAccountVm.nomineeShare3 = investAccountVm.nominee3.sharePerct;
								investAccountVm.appointee3 = investAccountVm.nominee3.appointeeName;
								investAccountVm.appointeeDob3 = investAccountVm.nominee3.appointeeDob;

								investAccountVm.appointeeRelSav3 = investAccountVm.nominee3.appointeeRelWithNominee;
								if(investAccountVm.appointeeRelSav3){
									investAccountVm.appointeeRel3={key:"", value:""};
									angular.forEach(investAccountVm.relationshipsGuardian , function (value, key) { 
										if (value.value == investAccountVm.appointeeRelSav3) {               
											investAccountVm.appointeeRel3.key = value.key
											investAccountVm.appointeeRel3.value = value.value

										}  
                           			});
								}								
							}
							investAccountVm.checkMinor();
							if (investAccountVm.userDetails.body.nomieeData.isNomiee) {
								investAccountVm.nomineeFlag = true;
								investAccountVm.noOfNominee = investAccountVm.userDetails.body.nomieeData.noOfNomiee;
								if(investAccountVm.noOfNominee){
									if (investAccountVm.noOfNominee == 2) {
									investAccountVm.countOfNominee2 = 1;
									}
									if (investAccountVm.noOfNominee == 3) {
										investAccountVm.countOfNominee2 = 1;
										investAccountVm.countOfNominee3 = 1;
									}
									if (investAccountVm.noOfNominee == "0") {
										investAccountVm.noOfNominee ='1';										
									}
									investAccountVm.noOfNomineeChangeEvt();
								}
								
							}else{
								investAccountVm.noOfNominee ='1';
								investAccountVm.noOfNomineeChangeEvt();
							}
							if (investAccountVm.userDetails.body.fatchDeclaration.id1Type) {
								investAccountVm.FATCAFlag = "2";
							}
						} else {
							investAccountVm.applicantName = investAccountVm.userDetails.body.customerProfile.ckyc.firstName;
							investAccountVm.gender = investAccountVm.userDetails.body.customerProfile.ckyc.gender;
							investAccountVm.dob = investAccountVm.userDetails.body.customerProfile.ckyc.dob;
							investAccountVm.branchCode = investAccountVm.userDetails.body.branchCode;
							investAccountVm.occupation = investAccountVm.userDetails.body.customerProfile.profile.occupation;
							$scope.occupation = investAccountVm.occupation;
							$scope.occupation = investAccountVm.occupation;
							if (investAccountVm.dob != null && investAccountVm.dob != '') {
								investAccountVm.dob = $filter('date')(new Date(investAccountVm.dob), 'MM/dd/yyyy');
							} else {
								investAccountVm.dob = '';
							}
							investAccountVm.title = investAccountVm.userDetails.body.customerProfile.ckyc.title;
						}
					} else {
						/** Check data is coming from CBS **/
						if (investAccountVm.accountFetchFlag) {
							investAccountVm.applicantName = investAccountVm.userDetails.name;
							investAccountVm.gender = investAccountVm.userDetails.gender;
							investAccountVm.dob = investAccountVm.userDetails.dob;
							if (investAccountVm.dob != null && investAccountVm.dob != '') {
								investAccountVm.dob = $filter('date')(new Date(investAccountVm.dob), 'MM/dd/yyyy');
							} else {
								investAccountVm.dob = '';
							}
							investAccountVm.title = "Mr."; // investAccountVm.userDetails.title; To do-- no title is coming from backend
							investAccountVm.fatherName = investAccountVm.userDetails.fatherName;
							investAccountVm.email = investAccountVm.userDetails.emailId;
							investAccountVm.mobileNumber = investAccountVm.userDetails.phoneNumber;
							if ($rootScope.fetchUserDetails == true) {
								$rootScope.fetchUserDetails = false;
								investAccountVm.address1 = investAccountVm.userDetails.addressLine1;
								investAccountVm.address2 = investAccountVm.userDetails.addressLine2;
								investAccountVm.locality = investAccountVm.userDetails.locality;
								investAccountVm.branchCode = investAccountVm.userDetails.branchcode;
								investAccountVm.city = investAccountVm.userDetails.city;
								investAccountVm.state = investAccountVm.userDetails.state; 					//Need to uncomment when city code will come correct
								investAccountVm.pinCode = investAccountVm.userDetails.pinCode;
								investAccountVm.residentialNumber = investAccountVm.userDetails.residentialNumber;
								if ($rootScope.isBankDetail == true) {
									investAccountVm.city = '';
									investAccountVm.state = '';
								}
							} else {
								$rootScope.skipAccountDetails = false;
								investAccountVm.address1 = "";
								investAccountVm.address2 = "";
								investAccountVm.locality = "";
								investAccountVm.branchCode = investAccountVm.userDetails.branchcode;
								if ($rootScope.isBankDetail == true) {
									investAccountVm.city = '';
									investAccountVm.state = '';
								}
								investAccountVm.pinCode = "";
								investAccountVm.residentialNumber = "";
							}
							investAccountVm.occupation = investAccountVm.userDetails.occupationName;
							$scope.occupation = investAccountVm.occupation;
							investAccountVm.annualIncome = investAccountVm.userDetails.grossAnnualIncome;
							$scope.annualIncomeCode = investAccountVm.annualIncome;
							investAccountVm.birthPlace = "";
							investAccountVm.country = constantConfig.mfAndsecConst.country;  // Need to uncomment when country code will come correct
							investAccountVm.nationality = investAccountVm.userDetails.nationality;
							investAccountVm.netWorth = investAccountVm.userDetails.netWorthAmount;
							investAccountVm.asOnDate = investAccountVm.userDetails.netWorthAmountAsOn;
							if (investAccountVm.asOnDate != null && investAccountVm.asOnDate != '') {
								investAccountVm.grossOrNet = "2";
								investAccountVm.annualIncome = '';
								investAccountVm.asOnDate = $filter('date')(new Date(investAccountVm.asOnDate), 'MM/dd/yyyy');
							} else {
								investAccountVm.grossOrNet = "1";
								investAccountVm.netWorth = '';
								investAccountVm.asOnDate = '';
							}
							investAccountVm.otherTaxCountryDetails = investAccountVm.userDetails.otherTaxCountryDetails;
							//Add country Details 
							var otherTaxCountryDetailsLength = investAccountVm.otherTaxCountryDetails.length;
							for (var list = 0; list < otherTaxCountryDetailsLength; list++) {
								if (investAccountVm.otherTaxCountryDetails[list].taxCountryNumber != "") {
									investAccountVm.taxId[list] = investAccountVm.otherTaxCountryDetails[list].taxId;
									investAccountVm.taxCountry[list] = investAccountVm.otherTaxCountryDetails[list].taxCountryNumber;
									investAccountVm.identificationType[list] = investAccountVm.otherTaxCountryDetails[list].taxIdType;
								}
							}
							//Add Nominee details
							if (investAccountVm.userDetails.nomineeDetails[0]) {
								investAccountVm.shareErrorFlag = 0;
								investAccountVm.nomineeName = investAccountVm.userDetails.nomineeDetails[0].nomineeName;
								investAccountVm.nomineeDob = investAccountVm.userDetails.nomineeDetails[0].nomineeDob;
								investAccountVm.noOfNominee = investAccountVm.userDetails.nomineeDetails[0].noOfNomiee;
								if (investAccountVm.nomineeDob != null && investAccountVm.nomineeDob != '') {
									investAccountVm.nomineeDob = $filter('date')(new Date(investAccountVm.nomineeDob), 'MM/dd/yyyy');
								} else {
									investAccountVm.nomineeDob = '';
								}
								investAccountVm.checkMinor();
								investAccountVm.firstNomineeAddress1 = investAccountVm.userDetails.nomineeDetails[0].addressLine1;
								investAccountVm.firstNomineeAddress2 = investAccountVm.userDetails.nomineeDetails[0].addressLine2;
								investAccountVm.firstNamineeLocality = investAccountVm.userDetails.nomineeDetails[0].locality;
								investAccountVm.firstNomineePinCode = investAccountVm.userDetails.nomineeDetails[0].pinCode;
								investAccountVm.firstNomineeCity = investAccountVm.userDetails.nomineeDetails[0].city;
								investAccountVm.firstNomineeState = investAccountVm.userDetails.nomineeDetails[0].state;
								investAccountVm.nomineeShare = investAccountVm.userDetails.nomineeDetails[0].sharePercentage;
							}
							if (investAccountVm.userDetails.nomineeDetails[1]) {
								investAccountVm.shareErrorFlag = 0;
								investAccountVm.nomineeName2 = investAccountVm.userDetails.nomineeDetails[1].nomineeName;
								investAccountVm.nomineeDob2 = investAccountVm.userDetails.nomineeDetails[1].nomineeDob;
								if (investAccountVm.nomineeDob2 != null && investAccountVm.nomineeDob2 != '') {
									investAccountVm.nomineeDob2 = $filter('date')(new Date(investAccountVm.nomineeDob2), 'MM/dd/yyyy');
								} else {
									investAccountVm.nomineeDob2 = '';
								}
								investAccountVm.secondNomineeAddress1 = investAccountVm.userDetails.nomineeDetails[1].addressLine1;
								investAccountVm.secondNomineeAddress2 = investAccountVm.userDetails.nomineeDetails[1].addressLine2;
								investAccountVm.secondNamineeLocality = investAccountVm.userDetails.nomineeDetails[1].locality;
								investAccountVm.secondNomineePinCode = investAccountVm.userDetails.nomineeDetails[1].pinCode;
								investAccountVm.secondNomineeCity = investAccountVm.userDetails.nomineeDetails[1].city;
								investAccountVm.secondNomineeState = investAccountVm.userDetails.nomineeDetails[1].state;
								investAccountVm.nomineeShare2 = investAccountVm.userDetails.nomineeDetails[1].sharePercentage;
							}
							if (investAccountVm.userDetails.nomineeDetails[2]) {
								investAccountVm.shareErrorFlag = 0;
								investAccountVm.nomineeName3 = investAccountVm.userDetails.nomineeDetails[2].nomineeName;
								investAccountVm.nomineeDob3 = investAccountVm.userDetails.nomineeDetails[2].nomineeDob;
								if (investAccountVm.nomineeDob3 != null && investAccountVm.nomineeDob3 != '') {
									investAccountVm.nomineeDob3 = $filter('date')(new Date(investAccountVm.nomineeDob3), 'MM/dd/yyyy');
								} else {
									investAccountVm.nomineeDob3 = '';
								}
								investAccountVm.thirdNomineeAddress1 = investAccountVm.userDetails.nomineeDetails[21].addressLine1;
								investAccountVm.thirdNomineeAddress2 = investAccountVm.userDetails.nomineeDetails[2].addressLine2;
								investAccountVm.thirdNamineeLocality = investAccountVm.userDetails.nomineeDetails[2].locality;
								investAccountVm.thirdNomineePinCode = investAccountVm.userDetails.nomineeDetails[2].pinCode;
								investAccountVm.thirdNomineeCity = investAccountVm.userDetails.nomineeDetails[2].city;
								investAccountVm.thirdNomineeState = investAccountVm.userDetails.nomineeDetails[2].state;
								investAccountVm.nomineeShare3 = investAccountVm.userDetails.nomineeDetails[2].sharePercentage;
							}
							if (investAccountVm.userDetails.isNominee) {
								investAccountVm.noOfNominee = investAccountVm.userDetails.numberofNominees;
								if (investAccountVm.noOfNominee == 2) {
									investAccountVm.countOfNominee2 = 1;
								}
								if (investAccountVm.noOfNominee == 3) {
									investAccountVm.countOfNominee2 = 1;
									investAccountVm.countOfNominee3 = 1;
								}
								investAccountVm.checkMinor();
							}
							if (investAccountVm.otherTaxCountryDetails.length) {
								investAccountVm.FATCAFlag = "2";
							}
						} else {
							investAccountVm.occupation = investAccountVm.userDetails.occupationName;
							investAccountVm.applicantName = investAccountVm.userDetails.name;
							investAccountVm.gender = investAccountVm.userDetails.gender;
							investAccountVm.branchCode = investAccountVm.userDetails.branchcode;
							investAccountVm.dob = investAccountVm.userDetails.dob;
							if (investAccountVm.dob != null && investAccountVm.dob != '') {
								investAccountVm.dob = $filter('date')(new Date(investAccountVm.dob), 'MM/dd/yyyy');
							} else {
								investAccountVm.dob = '';
							}
							investAccountVm.title = "Mr.";
						}
					}
					$timeout(function () {
						if (investAccountVm.occupation) {
							investAccountVm.getOccupationType(investAccountVm.occupation);
						}
						if (investAccountVm.city) {
							investAccountVm.getLocationType(investAccountVm.city);
						}
						if (investAccountVm.state) {
							investAccountVm.getStateType(investAccountVm.state);
						}
					}, 2000);

				}, 1500);
				WL.Device.getNetworkInfo(function (networkInfo) {
					investAccountVm.ipAddress = networkInfo.ipAddress;
				});
			}

			/**
			*Function to Show Saving account selection  page
			**/
			investAccountVm.showLinkAccountSelection = function () {
				investAccountVm.accounts = mutualFundsService.getDetails();
				$scope.accounts = [];
				$scope.accountListTemp = investAccountVm.accounts;
				var accountListTempLength = $scope.accountListTemp.length;
				for (investAccountVm.list = 0; investAccountVm.list < accountListTempLength; investAccountVm.list++) {
					if ($scope.accountListTemp[investAccountVm.list].accountType == constantConfig.mfAndsecConst.savingAccountInOpenAccount) {
						$scope.accounts.push($scope.accountListTemp[investAccountVm.list]);
					}
				}
				$timeout(function () {
					//Default display primary account
						var primaryAccount = getAccountDetailsService.accountOverviewData.customerInformation.accountNumber;
						var objPriAcc = getAccountDetailsService.displayPrimaryAccountAsDefault($scope.accounts,primaryAccount);
						$scope.accountFirstNo = objPriAcc.benAccntNo;
						

					investAccountVm.savingAccountList = $scope.accounts[objPriAcc.index].accountNumber;
					
					
				}, 500);
			}

			/**
			*Function to Open selection popup for image
			params:{}
			
			**/
			investAccountVm.choosePancardImage = function () {
				$scope.uploadPanFlag = 0;
				investAccountVm.selectPopup = $ionicPopup.show({
					templateUrl: 'pages/accountOverview/mutualFunds/investmentAccountForm/uploadPancardPopup.html',
					title: 'Select Photo',
					cssClass: 'dialog acc',
					scope: $scope

				});

			}
			/**
			*Function to close upload Image popup 
			**/
			investAccountVm.closePopup = function () {
				investAccountVm.selectPopup.close();
			}

			/**
			*function to take a photo from camera service
			**/

			investAccountVm.takePhoto = function () {
				utilityService.showSpinner();
				$scope.profileImageUrl = '';
				try {
					cameraService.getnewImageMF().then(function (data) {						
						var blob = new Blob([data], { type: 'image/jpeg' });
						if (blob.size < 600 * 1024) {
							investAccountVm.imageSizeError = true;
							$scope.profileImageUrl = data;
							$scope.uploadPanFlag = 1;
						} else {
							$scope.uploadPanFlag = 0;
							investAccountVm.imageSizeError = false;
							$scope.profileImageUrl = '';
						}
						utilityService.hideSpinner();
						investAccountVm.closePopup();
					}, function (error) {
						utilityService.hideSpinner();
					});
				} catch (error) {
					utilityService.showErrorMessage("Please upload less than 1 MB size of pan image");
				}
			}
			/**
			*function to select image from gallery service
			**/
			investAccountVm.selectImagefromGallery = function () {
				$scope.profileImageUrl = '';
				utilityService.showSpinner();
				cameraService.getImageFromGalleryMF().then(function (data) {
					var blob = new Blob([data], { type: 'image/jpeg' });
					if (blob.size < 600 * 1024) {
						investAccountVm.imageSizeError = true;
						$scope.profileImageUrl = data;
						$scope.uploadPanFlag = 1;
					} else {
						$scope.uploadPanFlag = 0;
						investAccountVm.imageSizeError = false;
						$scope.profileImageUrl = '';
					}
					utilityService.hideSpinner();
					investAccountVm.closePopup();
				}, function (error) {
					utilityService.hideSpinner();
				});
			}


			/**
			* Function to Upload PanCard Image
			@Params:{}
			*/

			investAccountVm.maskString = function(data){
				var mobNo = data;
                
                var startAt = 1;
                var endAt = mobNo.length-4;
                var trimStr = mobNo.substring(startAt, endAt);
                var maskedChar = "";
                for (var count = 0; count < trimStr.length; count++) {
                    maskedChar = maskedChar + "x";
                }
                 $rootScope.mobileNumber =  mobNo.replace(trimStr, maskedChar);
			}

			$scope.goToOtp = function(){
				$rootScope.lumsumotpPage = 0;
				$rootScope.stpotpPage=0;
			    $rootScope.redeemotpPage=0;
				$rootScope.cancelotpPage=0;       	
			    $rootScope.sipotpPage=0;				
				$rootScope.swpotpPage=0;									
				$rootScope.switchotpPage=0;
				$rootScope.lumsumNfOotpPage=0;
				$rootScope.folioOtpPage = 1;
				$rootScope.pageVal = investAccountVm.pageVal;	
				mutualFundsService.generateOTP().then(function(data) {
					$state.go('menu.createFolioOTP');
				},function(error){
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			$scope.validateOTPNext=function(){

				$scope.enterOTP = document.getElementById('txt_otp1').value+document.getElementById('txt_otp2').value+document.getElementById('txt_otp3').value+document.getElementById('txt_otp4').value+document.getElementById('txt_otp5').value+document.getElementById('txt_otp6').value;
				if(validateForm()){
					$scope.folioValidateOTP();
				}           
			}     

			function validateForm(){
				$scope.mutualFundEnterOTPForm={};          
				$scope.enterOTP = document.getElementById('txt_otp1').value+document.getElementById('txt_otp2').value+document.getElementById('txt_otp3').value+document.getElementById('txt_otp4').value+document.getElementById('txt_otp5').value+document.getElementById('txt_otp6').value;  
					if (!$scope.enterOTP) {
						$scope.errorMessage = 'Please Enter OTP Number';
						return false;
					}
					if ($scope.enterOTP.length < 6) {
						$scope.errorMessage = 'Please Enter Valid OTP Number';
						return false;
					}
					else{
						return true;
					}
			}

			$scope.folioValidateOTP=function(){
				var reqParams={};
				reqParams.otp= $scope.enterOTP;
				mutualFundsService.validateOTP(reqParams).then(function(data){
					$rootScope.lumsumSuccessPage=0;                  
					$rootScope.lumsumNfOotpPage=0;					 
					$rootScope.cancelSuccessPage=0;
					$rootScope.commonErrorPage=0; 
					$rootScope.cancelbtnHide=0; 
					$rootScope.redeemSuccessPage=0;
					$rootScope.swpSuccessPage=0;
					$rootScope.switchSuccessPage=0;
					$rootScope.stpSuccessPage=0;                 	
					$rootScope.sipSuccessPage=0;
					$rootScope.folioOtpPage = 0;    								
					investAccountVm.uploadPanCard(); 
				},function(error){
					$rootScope.invalidOtpCount++;
					$scope.errorMessage = 'Please Enter Valid OTP Number';
					if($rootScope.invalidOtpCount>2){
						investAccountVm.showErrorInformationPopup(error.responseMessage);
					}else{
						utilityService.showErrorMessage(error.responseMessage);
					}
				});
					
			}	

			$scope.resendOTP=function(){
				$scope.enterOTP = "";
				$scope.enterOTP1 = ""; 
				$scope.enterOTP2 = "";
				$scope.enterOTP3 = "";
				$scope.enterOTP4 = "";
				$scope.enterOTP5 = "";
				$scope.enterOTP6 = "";
				var reqParams ={};
				reqParams.id ="";
				reqParams.emailId ="";
					mutualFundsService.generateOTP(reqParams).then(function(data){
					$rootScope.clickCount++;
					$scope.mutualFundEnterOTPForm={};
					if($rootScope.clickCount>2){
						$scope.disableLink=true;
						utilityService.showErrorMessage($translate.instant('MAX_OTP_GENERATION'));
					}
				})          
			}

			investAccountVm.nextFocus = function(div){
				if(div == 'mpin1'){document.getElementsByClassName('mpin2')[0].focus();}
				if(div == 'mpin2'){document.getElementsByClassName('mpin3')[0].focus();}
				if(div == 'mpin3'){document.getElementsByClassName('mpin4')[0].focus();}
				if(div == 'mpin4'){document.getElementsByClassName('mpin5')[0].focus();}
				if(div == 'mpin5'){document.getElementsByClassName('mpin6')[0].focus();}
			}


			investAccountVm.uploadPanCard = function () {
				investAccountVm.reqParams = {};
				investAccountVm.reqParams = mutualFundsService.finalReqObj;
					investAccountVm.reqParams.body["channel"] = { 										
						"mobile": {
								"pageNo": [investAccountVm.pageVal]
						}
					}
					investAccountVm.curDateFormat = $filter('date')(new Date(), 'MM/dd/yyyy HH:mm:ss');
					investAccountVm.curDate = investAccountVm.curDateFormat.split(' ')[0];
					investAccountVm.curTime = investAccountVm.curDateFormat.split(' ')[1];
					investAccountVm.reqParams["applicationStatus"] = "Submitted";
					investAccountVm.reqParams["isZeroFolioUser"] = "true";
					investAccountVm.reqParams.body["aofBody"] = [
						{
							"arnCode": investAccountVm.arnCode,
							"pan": investAccountVm.panCard.toUpperCase(),
							"name": investAccountVm.applicantName,
							"docType": "AOF",
							"docRefNo": investAccountVm.arnCode + "_" + investAccountVm.panCard.toUpperCase() + "_AOF"
						}
					];
					investAccountVm.reqParams.body["electronicLog"] = {
						"arnCode": investAccountVm.arnCode,
						"pan": investAccountVm.panCard.toUpperCase(),
						"name": investAccountVm.applicantName,
						"docType": "ALL",
						"docRefNo": investAccountVm.arnCode + "_" + investAccountVm.panCard.toUpperCase() + "_PAN",
						"electronic": investAccountVm.ipAddress + "$INTOUCH$" + investAccountVm.curDate
					};
					investAccountVm.getFundAum = mutualFundsService.getFundId();
					investAccountVm.aum = investAccountVm.getFundAum.aum;
					investAccountVm.currentDate = $filter('date')(new Date(), 'MM/dd/yyyy');
					utilityService.showSpinner();
					mutualFundsService.AOFAllData=investAccountVm.reqParams;
					investAccountVm.reqCreateUpdate={
                                "mfKyc": {
                                    "panNo": $rootScope.panCard,                                                                
                                    "aofStatus":"Pending"                                   
                                }
                            }; 

					mutualFundsService.finalSubmitAOForm(investAccountVm.reqParams).then(function (res) {
						var reqParams = {};
						reqParams['panNo'] = $rootScope.panCard;
						mutualFundsService.getZeroFolio(reqParams).then(function (data) {
							investAccountVm.folioNumber = data.folioNumber;
							var reqParams = {};
							reqParams['id'] = '';
							mutualFundsService.getPanCardNumber(reqParams).then(function (data) {
								mutualFundsService.addFolioToInvest(data);
								investAccountVm.setAccountFormDetail();
								//investAccountVm.getPortfolio();
								mutualFundsService.getPortfolio().then(function (res) {
									mutualFundsService.multiFolio = res.multiFolio;
								})
							}, function (error) {
								investAccountVm.setAccountFormDetail();
								//investAccountVm.getPortfolio();
								mutualFundsService.getPortfolio().then(function (res) {
									mutualFundsService.multiFolio = res.multiFolio;
								});
							});
						}, function (error) {					
							mutualFundsService.AOFAllData.applicationStatus='Pending';
							mutualFundsService.finalSubmitAOForm(mutualFundsService.AOFAllData).then(function (res) {
							 mutualFundsService.checkKYCStatus(investAccountVm.reqCreateUpdate).then(function (data) {
								utilityService.hideSpinner();
								investAccountVm.zeroFolioshowInformationPopup('Your request for opening of a new account/folio can not be processed successfully.Please contact us at feedback.yono@sbi.co.in');
							},function(error){
								utilityService.hideSpinner();
								investAccountVm.zeroFolioshowInformationPopup('Your request for opening of a new account/folio can not be processed successfully.Please contact us at feedback.yono@sbi.co.in');
							});
							},function(error){
								utilityService.hideSpinner();
								investAccountVm.zeroFolioshowInformationPopup('Your request for opening of a new account/folio can not be processed successfully.Please contact us at feedback.yono@sbi.co.in');
							});
						});
					}, function (error) {						
						mutualFundsService.AOFAllData.applicationStatus='Pending';
						mutualFundsService.finalSubmitAOForm(mutualFundsService.AOFAllData).then(function (res) {
							 mutualFundsService.checkKYCStatus(investAccountVm.reqCreateUpdate).then(function (data) {
							 	utilityService.hideSpinner();
								investAccountVm.zeroFolioshowInformationPopup('Your request for opening of a new account/folio can not be processed successfully.Please contact us at feedback.yono@sbi.co.in');
							},function(error){
								utilityService.hideSpinner();
								investAccountVm.zeroFolioshowInformationPopup('Your request for opening of a new account/folio can not be processed successfully.Please contact us at feedback.yono@sbi.co.in');
							});
						},function(error){
							utilityService.hideSpinner();
							utilityService.showErrorMessage(error.responseMessage);
						});
					});
			}

		/***Function to show alert POP UP***/
			investAccountVm.showErrorInformationPopup=function(message){
				$ionicPopup.show({
					template: '<p>'+message+'</p>',
					title:'Alert',
					cssClass: 'dialog',		
					scope: $scope,
					buttons: [ {
						text: 'Ok',
						onTap: function(e) {
							$state.go('menu.accountOverviewMyBalance');				
						}
					}]
				});
			}
			investAccountVm.getPortfolio = function () {
				var reqParams = {};
				reqParams['panNo'] = $rootScope.panCard;
				mutualFundsService.getPortfolio(reqParams).then(function (res) {
					mutualFundsService.multiFolio = res.multiFolio;
				})
			}
			investAccountVm.setAccountFormDetail = function (data) {
				investAccountVm.fundObj = mutualFundsService.getFundToInvest();
				investAccountVm.fundName = investAccountVm.fundObj.fundName;
				investAccountVm.plan = investAccountVm.fundObj.plan;
				investAccountVm.option = investAccountVm.fundObj.option;
				mutualFundsService.addFundToInvest(investAccountVm.fundObj);
				$rootScope.isLotusCreate = 1;
				investAccountVm.hideSubhearder = 1;
				investAccountVm.investmentAccountForm5 = 0;
				utilityService.hideSpinner();
				if ($rootScope.isCreateFolio == 1) {
					investAccountVm.investmentAccountForm6 = 1;
					investAccountVm.investmentAccountForm7 = 0;
					$rootScope.form6Flag = investAccountVm.investmentAccountForm6;
					$rootScope.form7Flag = investAccountVm.investmentAccountForm7;
					$rootScope.hideSubhearder = investAccountVm.hideSubhearder;	
					$rootScope.folioNumber = investAccountVm.folioNumber;	
					$state.go('menu.investmentAccountForm');					
				} else {
					investAccountVm.investmentAccountForm7 = 1;
					investAccountVm.investmentAccountForm6 = 0;
					$rootScope.form6Flag = investAccountVm.investmentAccountForm6;
					$rootScope.form7Flag = investAccountVm.investmentAccountForm7;
					$rootScope.hideSubhearder = investAccountVm.hideSubhearder;	
					$rootScope.folioNumber = investAccountVm.folioNumber;	
					$rootScope.fundName = investAccountVm.fundName;
					$rootScope.plan = investAccountVm.plan;
					$rootScope.option = investAccountVm.option;
					$state.go('menu.investmentAccountForm');
				}
			}

			/***Function to go to Mutual fund home page***/
			investAccountVm.goToHome = function () {
				$state.go('menu.mutualFunds');
			}
			/***Function to go  Back Formwise***/
			investAccountVm.goBack = function (currentPageNo) {
				if (currentPageNo == 1) {
					$state.go('menu.createInvestmentAccount');
				}
				if (currentPageNo == 2) {
					investAccountVm.investmentAccountForm1 = 1;
					investAccountVm.investmentAccountForm2 = 0;
					investAccountVm.pageVal = 1;
				}
				if (currentPageNo == 3) {
					investAccountVm.investmentAccountForm2 = 1;
					investAccountVm.investmentAccountForm3 = 0;
					investAccountVm.pageVal = 2;
				}
				if (currentPageNo == 4) {
				if(investAccountVm.nomineeRel1){
						angular.forEach(investAccountVm.relationshipsNomineeMaster , function (value, key) {  
							if (value.name == investAccountVm.nomineeRel1) {   
								investAccountVm.nomineeRel1={code:"", name:""};            
								investAccountVm.nomineeRel1.code = value.code
								investAccountVm.nomineeRel1.name = value.name
							}  
						});
					}
					
					if(investAccountVm.nomineeRel2){
						angular.forEach(investAccountVm.relationshipsNomineeMaster , function (value, key) { 
							if (value.name == investAccountVm.nomineeRel2) {
								investAccountVm.nomineeRel2={code:"", name:""};                
								investAccountVm.nomineeRel2.code = value.code
								investAccountVm.nomineeRel2.name = value.name
							}  
						});
					}
					
					if(investAccountVm.nomineeRel3){
						angular.forEach(investAccountVm.relationshipsNomineeMaster , function (value, key) {  
							if (value.name == investAccountVm.nomineeRel3) {   
								investAccountVm.nomineeRel3={code:"", name:""};             
								investAccountVm.nomineeRel3.code = value.code
								investAccountVm.nomineeRel3.name = value.name
							}  
						});
					}
					if(investAccountVm.appointeeRel1){
						angular.forEach(investAccountVm.relationshipsGuardian , function (value, key) {  
							if (value.name == investAccountVm.appointeeRel1) {   
								investAccountVm.appointeeRel1={code:"", name:""};            
								investAccountVm.appointeeRel1.code = value.code
								investAccountVm.appointeeRel1.name = value.name
							}  
						});
					}
					if(investAccountVm.appointeeRel2){
						angular.forEach(investAccountVm.relationshipsGuardian , function (value, key) {  
							if (value.name == investAccountVm.appointeeRel2) {   
								investAccountVm.appointeeRel2={code:"", name:""};            
								investAccountVm.appointeeRel2.code = value.code
								investAccountVm.appointeeRel2.name = value.name
							}  
						});
					}
					if(investAccountVm.appointeeRel3){
						angular.forEach(investAccountVm.relationshipsGuardian , function (value, key) {  
							if (value.name == investAccountVm.appointeeRel3) {   
								investAccountVm.appointeeRel3={code:"", name:""};            
								investAccountVm.appointeeRel3.code = value.code
								investAccountVm.appointeeRel3.name = value.name
							}  
						});
					}
					investAccountVm.investmentAccountForm3 = 1;
					investAccountVm.investmentAccountForm4 = 0;
					investAccountVm.pageVal = 3;
					$scope.annualIncomeCode = investAccountVm.annualIncome;
				}
				if (currentPageNo == 5) {
				if(investAccountVm.nomineeRel1){
						angular.forEach(investAccountVm.relationshipsNomineeMaster , function (value, key) {  
							if (value.name == investAccountVm.nomineeRel1) {   
								investAccountVm.nomineeRel1={code:"", name:""};            
								investAccountVm.nomineeRel1.code = value.code
								investAccountVm.nomineeRel1.name = value.name
							}  
						});
					}
					
					if(investAccountVm.nomineeRel2){
						angular.forEach(investAccountVm.relationshipsNomineeMaster , function (value, key) { 
							if (value.name == investAccountVm.nomineeRel2) {
								investAccountVm.nomineeRel2={code:"", name:""};                
								investAccountVm.nomineeRel2.code = value.code
								investAccountVm.nomineeRel2.name = value.name
							}  
						});
					}
					
					if(investAccountVm.nomineeRel3){
						angular.forEach(investAccountVm.relationshipsNomineeMaster , function (value, key) {  
							if (value.name == investAccountVm.nomineeRel3) {   
								investAccountVm.nomineeRel3={code:"", name:""};             
								investAccountVm.nomineeRel3.code = value.code
								investAccountVm.nomineeRel3.name = value.name
							}  
						});
					}
					if(investAccountVm.appointeeRel1){
						angular.forEach(investAccountVm.relationshipsGuardian , function (value, key) {  
							if (value.name == investAccountVm.appointeeRel1) {   
								investAccountVm.appointeeRel1={code:"", name:""};            
								investAccountVm.appointeeRel1.code = value.code
								investAccountVm.appointeeRel1.name = value.name
							}  
						});
					}
					if(investAccountVm.appointeeRel2){
						angular.forEach(investAccountVm.relationshipsGuardian , function (value, key) {  
							if (value.name == investAccountVm.appointeeRel2) {   
								investAccountVm.appointeeRel2={code:"", name:""};            
								investAccountVm.appointeeRel2.code = value.code
								investAccountVm.appointeeRel2.name = value.name
							}  
						});
					}
					if(investAccountVm.appointeeRel3){
						angular.forEach(investAccountVm.relationshipsGuardian , function (value, key) {  
							if (value.name == investAccountVm.appointeeRel3) {   
								investAccountVm.appointeeRel3={code:"", name:""};            
								investAccountVm.appointeeRel3.code = value.code
								investAccountVm.appointeeRel3.name = value.name
							}  
						});
					}

					investAccountVm.investmentAccountForm5 = 0;
					investAccountVm.investmentAccountForm4 = 1;
					investAccountVm.pageVal = 4;
				}
			}
			/**
			* Change event of gross Income
			**/
			investAccountVm.changeGrossAndNet = function () {
				if (investAccountVm.grossOrNet == "1") {
					investAccountVm.netWorth = '';
					investAccountVm.asOnDate = '';
				} else {
					investAccountVm.annualIncome = '';
				}
			}
			/**
			* Submit openAcocuntForm details  to cloudant on every next click 
			* @param {Object}
			*
			**/

			investAccountVm.submitFormToCloudant = function () {
				var reqParams = {};
				if (investAccountVm.grossOrNet == "1") {
					investAccountVm.netWorth = '';
					investAccountVm.asOnDate = '';
				} else {
					investAccountVm.annualIncome = '';
				}
				if (investAccountVm.asOnDate) {
					investAccountVm.asOnDate = $filter('date')(new Date(investAccountVm.asOnDate), 'MM/dd/yyyy');
				} else {
					investAccountVm.asOnDate = null;
				}
				//Nominee details
				investAccountVm.nomineeArray = [];
					if(investAccountVm.nomineeRel1){
						if( typeof investAccountVm.nomineeRel1 == 'object'){
							investAccountVm.nomineeRel1 = investAccountVm.nomineeRel1 ? investAccountVm.nomineeRel1.name : '';
						}
					}		
					if( typeof investAccountVm.appointeeRel1 == 'object'){
							investAccountVm.appointeeRel1 = investAccountVm.appointeeRel1 ? investAccountVm.appointeeRel1.name : '';
					}			
					investAccountVm.nomineeObj1 = {
						"nomieeName": investAccountVm.nomineeName,
						"nomieeDob": $filter('date')(new Date(investAccountVm.nomineeDob), 'MM/dd/yyyy'),
						"nomieeOccupation": '',
						"sharePerct": investAccountVm.nomineeShare,
						"relwithNomiee": investAccountVm.nomineeRel1,
						"addressOne": investAccountVm.firstNomineeAddress1,
						"addressTwo": investAccountVm.firstNomineeAddress2,
						"locality": investAccountVm.firstNamineeLocality,
						"pinCode": investAccountVm.firstNomineePinCode,
						"city": investAccountVm.firstNomineeCity,
						"state": investAccountVm.firstNomineeState,
						"appointeeName": investAccountVm.appointee1,
						"appointeeDob": investAccountVm.appointeeDob1,
						"appointeeRelWithNominee": investAccountVm.appointeeRel1
					};
					investAccountVm.nomineeArray.push(investAccountVm.nomineeObj1);
					if (investAccountVm.noOfNominee == 2 || investAccountVm.noOfNominee == 3) {
						if(investAccountVm.nomineeRel2){
							if( typeof investAccountVm.nomineeRel2 == 'object'){
								investAccountVm.nomineeRel2 = investAccountVm.nomineeRel2 ? investAccountVm.nomineeRel2.name : '';
							}
						}
						if( typeof investAccountVm.appointeeRel2 == 'object'){
							investAccountVm.appointeeRel2 = investAccountVm.appointeeRel2 ? investAccountVm.appointeeRel2.name : '';
						}						
						investAccountVm.nomineeObj2 = {
							"nomieeName": investAccountVm.nomineeName2,
							"nomieeDob": $filter('date')(new Date(investAccountVm.nomineeDob2), 'MM/dd/yyyy'),
							"nomieeOccupation": '',
							"sharePerct": investAccountVm.nomineeShare2,
							"relwithNomiee": investAccountVm.nomineeRel2,
							"addressOne": investAccountVm.firstNomineeAddress1,
							"addressTwo": investAccountVm.firstNomineeAddress2,
							"locality": investAccountVm.secondNamineeLocality,
							"pinCode": investAccountVm.secondNomineePinCode,
							"city": investAccountVm.secondNomineeCity,
							"state": investAccountVm.secondNomineeState,
							"appointeeName": investAccountVm.appointee2,
							"appointeeDob": investAccountVm.appointeeDob2,
							"appointeeRelWithNominee": investAccountVm.appointeeRel2
						};
						investAccountVm.nomineeArray.push(investAccountVm.nomineeObj2);
					}
					if (investAccountVm.noOfNominee == 3) {
						if(investAccountVm.nomineeRel3){
							if( typeof investAccountVm.nomineeRel3 == 'object'){
								investAccountVm.nomineeRel3 = investAccountVm.nomineeRel3 ? investAccountVm.nomineeRel3.name : '';
							}
						}
						if( typeof investAccountVm.appointeeRel3 == 'object'){
							investAccountVm.appointeeRel3 = investAccountVm.appointeeRel3 ? investAccountVm.appointeeRel3.name : '';
						}
						investAccountVm.nomineeObj3 = {
							"nomieeName": investAccountVm.nomineeName3,
							"nomieeDob": $filter('date')(new Date(investAccountVm.nomineeDob3), 'MM/dd/yyyy'),
							"nomieeOccupation": '',
							"sharePerct": investAccountVm.nomineeShare3,
							"relwithNomiee": investAccountVm.nomineeRel3,
							"addressOne": investAccountVm.thirdNomineePinCode,
							"addressTwo": investAccountVm.thirdNomineeAddress2,
							"locality": investAccountVm.thirdNamineeLocality,
							"pinCode": investAccountVm.firstNomineePinCode,
							"city": investAccountVm.thirdNomineeCity,
							"state": investAccountVm.thirdNomineeState,
							"appointeeName": investAccountVm.appointee3,
							"appointeeDob": investAccountVm.appointeeDob3,
							"appointeeRelWithNominee": investAccountVm.appointeeRel3
						};
						investAccountVm.nomineeArray.push(investAccountVm.nomineeObj3);
					}
				
					investAccountVm.noOfNomineeData = investAccountVm.noOfNominee;
				if (investAccountVm.FATCAFlag == "2") {
					investAccountVm.identificationType1 = 'C';
					investAccountVm.taxCountry1 = constantConfig.mfAndsecConst.country;
					investAccountVm.taxId1 = investAccountVm.panCard.toUpperCase();
				}
				investAccountVm.curDateFormat = $filter('date')(new Date(), 'MM/dd/yyyy HH:mm:ss');
				investAccountVm.curDate = investAccountVm.curDateFormat.split(' ')[0];
				investAccountVm.curTime = investAccountVm.curDateFormat.split(' ')[1];
				reqParams = {
					"applicationStatus": "Pending",
					"panNo": investAccountVm.panCard.toUpperCase(),
					"body": {
						"accountName": "SBI",
						"accountType": "Saving",
						"accountNo": investAccountVm.getSelectedAccount,
						"taxStatusCode": investAccountVm.taxStatus,
						"locationCode": investAccountVm.city,
						"lcFix":'y',
						"branchCode": investAccountVm.branchCode,
						"customerProfile": {
							"ckyc": {
								"firstName": investAccountVm.applicantName,
								"gender": investAccountVm.gender,
								"dob": $filter('date')(new Date(investAccountVm.dob), 'MM/dd/yyyy'),
								"nationality": investAccountVm.nationality,
								"address": [
									{
										"line1": investAccountVm.address1,
										"line2": investAccountVm.address2,
										"state": investAccountVm.state,
										"city": investAccountVm.city,
										"locality": investAccountVm.locality,
										"pincode": investAccountVm.pinCode,
										"country": investAccountVm.country,
										"type": "permanent"
									}
								],
								"mobile": [
									{
										"number": investAccountVm.mobileNumber,
										"type": "primary"
									}
								],
								"landLineNumber": investAccountVm.residentialNumber,
								"aadherId": "",
								"panId": investAccountVm.panCard.toUpperCase(),
								"mobilephoneNo": investAccountVm.mobileNumber,
								"title": investAccountVm.title,
								"middleName": "",
								"emailId": investAccountVm.email
							},
							"profile": {
								"occupation": investAccountVm.occupation,
								"annualIncome": investAccountVm.annualIncome,
								"occupationCategory": investAccountVm.occupationType,
								"netWorth": investAccountVm.netWorth,
								"fatherName": investAccountVm.fatherName
							}
						},
						"fatchDeclaration": {
							"bankName": "",
							"branchName": "",
							"bankCity": "",
							"panRp": investAccountVm.panCard.toUpperCase(),
							"invNHame": investAccountVm.applicantName,
							"dob": $filter('date')(new Date(investAccountVm.dob), 'MM/dd/yyyy'),
							"frName": investAccountVm.fatherName,
							"spName": "",
							"taxStatus": investAccountVm.taxStatus,
							"poBirInc": investAccountVm.birthPlace,
							"coBirInc": investAccountVm.country,
							"taxRes1": investAccountVm.taxCountry1,
							"tpin1": investAccountVm.taxId1,
							"id1Type": investAccountVm.identificationType1,
							"taxRes2": investAccountVm.taxCountry2,
							"tpin2": investAccountVm.taxId2,
							"id2Type": investAccountVm.identificationType2,
							"taxRes3": investAccountVm.taxCountry3,
							"tpin3": investAccountVm.taxId3,
							"id3Type": investAccountVm.identificationType3,
							"taxRes4": "",
							"tpin4": "",
							"id4Type": "",
							"incSlab": investAccountVm.annualIncome,
							"netWorth": investAccountVm.netWorth,
							"nwDate": investAccountVm.asOnDate,
							"pepFlag": investAccountVm.PEP,
							"occCode": investAccountVm.occupation,
							"occType": investAccountVm.occupationType,
							"logName": investAccountVm.panCard.toUpperCase() + "_" + investAccountVm.curDate + "_" + investAccountVm.curTime
						},
						"aofBody": [

							{
								"arnCode": investAccountVm.arnCode,
								"pan": investAccountVm.panCard.toUpperCase(),
								"name": investAccountVm.applicantName,
								"docType": "AOF",
								"docRefNo": investAccountVm.arnCode + "_" + investAccountVm.panCard.toUpperCase() + "_AOF"


							}
						],
						"electronicLog": {
							"arnCode": investAccountVm.arnCode,
							"pan": investAccountVm.panCard.toUpperCase(),
							"name": investAccountVm.applicantName,
							"docType": "PAN",
							"docRefNo": investAccountVm.arnCode + "_" + investAccountVm.panCard.toUpperCase() + "_PAN",
							"electronic": investAccountVm.ipAddress + "$INTOUCH$" + investAccountVm.curDate

						},
						"nomieeData": {
							"noOfNomiee": investAccountVm.noOfNomineeData,
							"nomieeDetail": investAccountVm.nomineeArray
						},
						"channel": {
							"mobile": {
								"pageNo": [investAccountVm.pageVal]
							}
						}
					}
				};
				return reqParams;
			}

			/***Function to go to investmentForm2 page***/
			investAccountVm.investmentForm2 = function (formData) {
				var reqParams = investAccountVm.submitFormToCloudant();
				$timeout(function () {
					mutualFundsService.submitAOFormToCloudant(reqParams).then(function (data) {
						investAccountVm.investmentAccountForm1 = 0;
						investAccountVm.investmentAccountForm2 = 1;
						investAccountVm.done1 = 1;
						investAccountVm.pageVal = 2;
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);

					});
				}, 1000);
			}

			/***Function to go to investmentForm3 page***/
			investAccountVm.investmentForm3 = function () {
				var reqParams = investAccountVm.submitFormToCloudant();
				$timeout(function () {
					mutualFundsService.submitAOFormToCloudant(reqParams).then(function (data) {
						investAccountVm.investmentAccountForm2 = 0;
						investAccountVm.investmentAccountForm3 = 1;
						investAccountVm.done1 = 1;
						investAccountVm.done2 = 1;
						investAccountVm.pageVal = 3;
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}, 1000);
			}

			/***Function to go to investmentForm4 page***/
			investAccountVm.investmentForm4 = function () {
				var reqParams = investAccountVm.submitFormToCloudant();
				$timeout(function () {
					mutualFundsService.submitAOFormToCloudant(reqParams).then(function (data) {
						investAccountVm.done1 = 1;
						investAccountVm.done2 = 1;
						investAccountVm.done3 = 1;
						investAccountVm.pageVal = 4;
						investAccountVm.investmentAccountForm3 = 0;
						investAccountVm.investmentAccountForm4 = 1;
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				}, 1000);
					if(investAccountVm.appointeeRel1){
						angular.forEach(investAccountVm.relationshipsGuardian , function (value, key) {  
							if (value.name == investAccountVm.appointeeRel1) {   
								investAccountVm.appointeeRel1={code:"", name:""};            
								investAccountVm.appointeeRel1.code = value.code
								investAccountVm.appointeeRel1.name = value.name
							}  
						});
					}
					if(investAccountVm.appointeeRel2){
						angular.forEach(investAccountVm.relationshipsGuardian , function (value, key) {  
							if (value.name == investAccountVm.appointeeRel2) {   
								investAccountVm.appointeeRel2={code:"", name:""};            
								investAccountVm.appointeeRel2.code = value.code
								investAccountVm.appointeeRel2.name = value.name
							}  
						});
					}			
					if(investAccountVm.appointeeRel3){
						angular.forEach(investAccountVm.relationshipsGuardian , function (value, key) {  
							if (value.name == investAccountVm.appointeeRel3) {   
								investAccountVm.appointeeRel3={code:"", name:""};            
								investAccountVm.appointeeRel3.code = value.code
								investAccountVm.appointeeRel3.name = value.name
							}  
						});
					}

			}

			/**
			* Submit openAcocuntForm details 
			* @param {Object}
			*
			**/
			investAccountVm.investmentForm5 = function () {
				var reqParams = investAccountVm.submitFormToCloudant();
				$timeout(function () {
					mutualFundsService.submitAOFormToCloudant(reqParams).then(function (data) {
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);

					});
				}, 1200);
				investAccountVm.investmentAccountForm3 = 0;
				investAccountVm.investmentAccountForm4 = 0;
				investAccountVm.investmentAccountForm5 = 1;
				investAccountVm.done1 = 1;
				investAccountVm.done2 = 1;
				investAccountVm.done3 = 1;
				investAccountVm.done4 = 1;
				investAccountVm.pageVal = 5;
				mutualFundsService.finalReqObj = reqParams;	
				investAccountVm.showLinkAccountSelection();
			}

			/**
			*Function to Continue investing
			***/

			investAccountVm.continueInvesting = function () {
				$rootScope.fundName = '';
				$rootScope.plan = '';
				$rootScope.option = '';
				$rootScope.form6Flag = '';
				$rootScope.form7Flag = '';
				$rootScope.hideSubhearder = '';
				$rootScope.folioNumber = '';
				$state.go('menu.typeOfInvestment');
			}

			/***Function to viewAllFunds Page***/
			investAccountVm.viewAllFunds = function () {
				//Call service to fetch funds list
				$rootScope.hideSubhearder = '';
				$rootScope.folioNumber = '';
				$rootScope.form6Flag = '';
				$rootScope.form7Flag = '';
				mutualFundsService.getAllMutualFunds().then(function (data) {
					mutualFundsService.addFundList(data.fundList);
					$state.go('menu.mutualFundsList');
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			/***Function to show TypeOf investmentPage Page***/
			investAccountVm.typeOfInvestment = function () {
				$state.go('menu.typeOfInvestment');
			}


			/***Function to increment Number of nominee***/
			investAccountVm.noOfNomineeChangeEvt = function () {
					investAccountVm.nomineeShare="";
					investAccountVm.nomineeShare2="";
					investAccountVm.nomineeShare3="";
				if (investAccountVm.noOfNominee == "2") {
					investAccountVm.diasbleShareInput1 = false
					investAccountVm.diasbleShareInput2 = true
					investAccountVm.diasbleShareInput3 = true
					investAccountVm.countOfNominee2 = 1;
					investAccountVm.countOfNominee3 = 0;
					$scope.minorFlag3 = 0;
					if (investAccountVm.nomineeShare == '100') {
						investAccountVm.shareErrorFlag = 0;
					} else {
						if (parseInt(investAccountVm.nomineeShare) + parseInt(investAccountVm.nomineeShare2) == 100) {
							investAccountVm.shareErrorFlag = 0;
						}
					}
				} else {

					investAccountVm.countOfNominee2 = 0;
				}
				if (investAccountVm.noOfNominee == "3") {
					investAccountVm.diasbleShareInput1 = false
					investAccountVm.diasbleShareInput2 = false
					investAccountVm.diasbleShareInput3 = true
					investAccountVm.countOfNominee3 = 1;
					investAccountVm.countOfNominee2 = 1;
					if (investAccountVm.nomineeShare == '100') {
						investAccountVm.shareErrorFlag = 0;
					}else{
						if (parseInt(investAccountVm.nomineeShare) + parseInt(investAccountVm.nomineeShare2) + parseInt(investAccountVm.nomineeShare3) == 100) {
							investAccountVm.shareErrorFlag = 0;
						}
					}
				} else {
					investAccountVm.countOfNominee3 = 0;
				}
				if (investAccountVm.noOfNominee == "1") {
					investAccountVm.diasbleShareInput1 = true
					investAccountVm.diasbleShareInput2 = true
					investAccountVm.diasbleShareInput3 = true
					if (investAccountVm.nomineeShare == '100') {
						investAccountVm.shareErrorFlag = 0;
					}else{
						if (parseInt(investAccountVm.nomineeShare) == 100) {
							investAccountVm.shareErrorFlag = 0;
						}
					}
					investAccountVm.nomineeShare = 100;
					investAccountVm.nomineeShareValid = false
					investAccountVm.nomineeShareValid2 = false
					investAccountVm.nomineeShareValid3 = false
					investAccountVm.shareReqErrorFlag = 0
					investAccountVm.shareErrorFlag= 0
					$scope.minorFlag3 = 0;
					investAccountVm.countOfNominee3 = 0;

				}
			}

			/***Function to increment Number of nominee***/
			investAccountVm.setNumberOfNominee = function () {
				investAccountVm.noOfNominee = "1";
				investAccountVm.noOfNomineeChangeEvt();
			}

			/**
			*Function to check minor 
			***/
			investAccountVm.checkMinor = function () {
				if (investAccountVm.nomineeDob) {
					let birthdate = new Date(investAccountVm.nomineeDob);
					let timeDiff = Math.abs(Date.now() - birthdate.getTime());
					let age = Math.floor((timeDiff / (1000 * 3600 * 24))/365.25);
					if(age < 18) {
						$scope.minorFlag1 = 1;
					} else {
						$scope.minorFlag1 = 0;
					}
				}
				if (investAccountVm.nomineeDob2) {
					let birthdate = new Date(investAccountVm.nomineeDob2);
					let timeDiff = Math.abs(Date.now() - birthdate.getTime());
					let age = Math.floor((timeDiff / (1000 * 3600 * 24))/365.25);
					if(age < 18) {
						$scope.minorFlag2 = 1;
					} else {
						$scope.minorFlag2 = 0;
					}
				}
				if (investAccountVm.nomineeDob3) {
					let birthdate = new Date(investAccountVm.nomineeDob3);
					let timeDiff = Math.abs(Date.now() - birthdate.getTime());
					let age = Math.floor((timeDiff / (1000 * 3600 * 24))/365.25);
					if(age < 18) {
						$scope.minorFlag3 = 1;
					} else {
						$scope.minorFlag3 = 0;
					}
				}
			}

			/***Function to openDatePickerDiv***/
			investAccountVm.openDatePickerDiv = {
				callback: function (val) {
					var date = $filter('date')(new Date(val), 'MM/dd/yyyy');
					investAccountVm.dob = date;
				},
				dateFormat: 'MM/dd/yyyy',
				closeOnSelect: false,
				templateType: 'popup',
				to: (new Date().setYear(new Date().getFullYear() - 18)),
				from: (new Date().setYear(new Date().getFullYear() - 120))
			};
			/***Function to openDatePicker***/
			investAccountVm.openDatePicker = function () {
				if (investAccountVm.dob) {
					investAccountVm.openDatePickerDiv.inputDate = new Date(investAccountVm.dob);
				} else {
					var date = new Date().setYear(new Date().getFullYear() - 18);
					investAccountVm.openDatePickerDiv.inputDate = new Date(date);
				}
				ionicDatePicker.openDatePicker(investAccountVm.openDatePickerDiv);
			};

			/***Function to openDatePicker NetWorth***/
			investAccountVm.openDatePickerForPep = function () {
				ionicDatePicker.openDatePicker(investAccountVm.asOnDatePicker);
			};


			investAccountVm.asOnDatePicker = {
				callback: function (val) {
					var date = $filter('date')(new Date(val), 'MM/dd/yyyy');
					investAccountVm.asOnDate = date;
				},
				inputDate: new Date(),
				to: new Date(),
				from: (new Date().setYear(new Date().getFullYear() - 120)),
				mondayFirst: true,
				closeOnSelect: false,
				templateType: 'popup',
				dateFormat: 'MM/dd/yyyy'

			};
			/***Function to openDatePicker NetWorth Ends ***/

			/***Function to openDatePickerDiv for nominee1***/
			investAccountVm.openDatePickerForNominee = function () {
				if(!investAccountVm.nomineeName){
					investAccountVm.nomineeNameValid =true
				}
				
					var date = new Date();
					date.setDate(toDate.getDate() - 1);
					investAccountVm.openDatePickerDivForNominee.inputDate = date;
				

				ionicDatePicker.openDatePicker(investAccountVm.openDatePickerDivForNominee);
			};
			var toDate = new Date();
                toDate.setDate(toDate.getDate() - 1);
			investAccountVm.openDatePickerDivForNominee = {
				callback: function (val) {
					var date = $filter('date')(new Date(val), 'MM/dd/yyyy');
					investAccountVm.nomineeDob = date;
					investAccountVm.nomineeDobValid = false;
					investAccountVm.checkMinor();
				},
				dateFormat: 'MM/dd/yyyy',
				closeOnSelect: false,
				templateType: 'popup',
				to: toDate,
				from: (new Date().setYear(new Date().getFullYear() - 100))
			};
			/***Function to openDatePicker for nominee1 ends ***/


			/***Function to openDatePicker2 for nominee2***/
			investAccountVm.openDatePickerForNominee2 = function () {
					if(!investAccountVm.nomineeName2){
					investAccountVm.nomineeNameValid2 =true
					}
					var date = new Date();
					date.setDate(toDate1.getDate() - 1);
					investAccountVm.openDatePickerDivForNominee2.inputDate = date;
				
				ionicDatePicker.openDatePicker(investAccountVm.openDatePickerDivForNominee2);
			};
			var toDate1 = new Date();
                toDate1.setDate(toDate1.getDate() - 1);
			investAccountVm.openDatePickerDivForNominee2 = {
				callback: function (val) {
					var date = $filter('date')(new Date(val), 'MM/dd/yyyy');
					investAccountVm.nomineeDob2 = date;
					investAccountVm.nomineeDobValid2 = false;
					investAccountVm.checkMinor();
				},
				dateFormat: 'MM/dd/yyyy',
				closeOnSelect: false,
				templateType: 'popup',
				to: toDate1,
				from: (new Date().setYear(new Date().getFullYear() - 100))
			};
			/***Function to openDatePicker2 for nominee2 ends ***/

			/***Function to openDatePicker3 for nominee 3 starts***/
			investAccountVm.openDatePickerForNominee3 = function () {
					if(!investAccountVm.nomineeName3){
					investAccountVm.nomineeNameValid3 =true
					}
					var date = new Date();
					date.setDate(toDate2.getDate() - 1);
					investAccountVm.openDatePickerDivForNominee3.inputDate = date;
				
				ionicDatePicker.openDatePicker(investAccountVm.openDatePickerDivForNominee3);
			};
			var toDate2 = new Date();
                toDate2.setDate(toDate2.getDate() - 1);
			investAccountVm.openDatePickerDivForNominee3 = {
				callback: function (val) {
					var date = $filter('date')(new Date(val), 'MM/dd/yyyy');
					investAccountVm.nomineeDob3 = date;
					investAccountVm.nomineeDobValid3 = false;
					investAccountVm.checkMinor();
				},

				dateFormat: 'MM/dd/yyyy',
				closeOnSelect: false,
				templateType: 'popup',
				to: toDate2,
				from: (new Date().setYear(new Date().getFullYear() - 100))
			};
			/***Function to openDatePicker3 for nominee 3 ends***/

			/***Function to openDatePicker For Appointee Dob1 starts***/
			investAccountVm.openDatePickerForAppointeeDob1 = function () {
				if (investAccountVm.appointeeDob1) {
					investAccountVm.openDatePcDivAppointeeDob1.inputDate = new Date(investAccountVm.appointeeDob1);
				} else {
					investAccountVm.openDatePcDivAppointeeDob1.inputDate = new Date(new Date().setYear(new Date().getFullYear() - 18));
				}
				ionicDatePicker.openDatePicker(investAccountVm.openDatePcDivAppointeeDob1);
			};

			investAccountVm.openDatePcDivAppointeeDob1 = {
				callback: function (val) {
					var date = $filter('date')(new Date(val), 'MM/dd/yyyy');
					investAccountVm.appointeeDob1 = date;
				},

				dateFormat: 'MM/dd/yyyy',
				closeOnSelect: false,
				templateType: 'popup',
				to: (new Date().setYear(new Date().getFullYear() - 18)),
				from: (new Date().setYear(new Date().getFullYear() - 100))
			};
			/***Function to openDatePicker For Appointee Dob1 Ends***/

			/***Function to openDatePicker For Appointee Dob2 starts***/
			investAccountVm.openDatePickerForAppointeeDob2 = function () {
				if (investAccountVm.appointeeDob2) {
					investAccountVm.openDatePcDivAppointeeDob2.inputDate = new Date(investAccountVm.appointeeDob2);
				} else {
					investAccountVm.openDatePcDivAppointeeDob2.inputDate = new Date(new Date().setYear(new Date().getFullYear() - 18));
				}
				ionicDatePicker.openDatePicker(investAccountVm.openDatePcDivAppointeeDob2);
			};
			investAccountVm.openDatePcDivAppointeeDob2 = {
				callback: function (val) {
					var date = $filter('date')(new Date(val), 'MM/dd/yyyy');
					investAccountVm.appointeeDob2 = date;
				},
				dateFormat: 'MM/dd/yyyy',
				closeOnSelect: false,
				templateType: 'popup',
				to: (new Date().setYear(new Date().getFullYear() - 18)),
				from: (new Date().setYear(new Date().getFullYear() - 100))
			};

			/***Function to openDatePicker For Appointee Dob2 ends***/

			/***Function to openDatePicker For Appointee Dob3 starts***/
			investAccountVm.openDatePickerForAppointeeDob3 = function () {
				if (investAccountVm.appointeeDob3) {
					investAccountVm.openDatePcDivAppointeeDob3.inputDate = new Date(investAccountVm.appointeeDob3);
				} else {
					investAccountVm.openDatePcDivAppointeeDob3.inputDate = new Date(new Date().setYear(new Date().getFullYear() - 18));
				}
				ionicDatePicker.openDatePicker(investAccountVm.openDatePcDivAppointeeDob3);
			};

			investAccountVm.openDatePcDivAppointeeDob3 = {
				callback: function (val) {
					var date = $filter('date')(new Date(val), 'MM/dd/yyyy');
					investAccountVm.appointeeDob3 = date;
				},
				dateFormat: 'MM/dd/yyyy',
				closeOnSelect: false,
				templateType: 'popup',
				to: (new Date().setYear(new Date().getFullYear() - 18)),
				from: (new Date().setYear(new Date().getFullYear() - 100))
			};

			/***Function to openDatePicker For Appointee Dob3 ends***/
			/**
			* Fetch getTitle From master
			* @param {Object}
			* type
			**/
			investAccountVm.getTitle = function () {
				var reqParams = {};
				reqParams['type'] = constantConfig.mfAndsecConst.titleInMF;
				mutualFundsService.getMasterCommon(reqParams).then(function (data) {
					investAccountVm.titleObj = data;
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			/**
			* Fetch gender From master
			*@param {Object}
			* type
			**/
			investAccountVm.getGenderList = function () {
				var reqParams = {};
				reqParams['type'] = constantConfig.mfAndsecConst.genderInMF;
				mutualFundsService.getMasterCommon(reqParams).then(function (data) {
					investAccountVm.genderObj = data;
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			/**
			* Fetch Occupation From master
			* @param {Object}
			* type
			**/
			investAccountVm.getOccupation = function () {
				mutualFundsService.getOccupation().then(function (data) {
					investAccountVm.occupationObj = data;
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			/**
			* Fetch City From master
			* @param {Object}
			* type
			**/
			investAccountVm.getCityList = function () {
				mutualFundsService.getCity().then(function (data) {
					investAccountVm.cityObj = data;
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			/**
			* Fetch State  List From master
			* @param {Object}
			* type
			**/
			investAccountVm.getStateList = function () {
				mutualFundsService.getState().then(function (data) {
					investAccountVm.stateObj = data;
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			/**
			* Fetch Country  List From master
			* @param {Object}
			* type
			**/
			investAccountVm.getCountryList = function () {
				mutualFundsService.getCountry().then(function (data) {
					investAccountVm.nationalityObj = data;
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			/**
			* Fetch PEP  List From master
			* @param {Object}
			* type
			**/
			investAccountVm.getPepList = function () {
				var reqParams = {};
				reqParams['type'] = constantConfig.mfAndsecConst.pepInMF;
				mutualFundsService.getMasterCommon(reqParams).then(function (data) {
					investAccountVm.pepObj = data;
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			/**
			* Fetch  TaxStatus List From master
			* @param {Object}
			* type
			*/
			investAccountVm.getTaxStatusList = function () {
				mutualFundsService.getTaxStatus().then(function (data) {
					investAccountVm.taxStatusObj = data;
					$timeout(function () {
						investAccountVm.taxStatus = constantConfig.mfAndsecConst.taxStatus;
					}, 300);
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			/**
			* Fetch  Identification List From master
			* @param {Object}
			* type
			*/

			investAccountVm.getDistributorCode = function () {
				var reqParams = {};
				reqParams['type'] = constantConfig.mfAndsecConst.distributor;
				mutualFundsService.getDistributor(reqParams).then(function (data) {
					investAccountVm.arnCode = data.distributorCode;
				}, function (error) {
					//utilityService.showErrorMessage(error.responseMessage);
				});
			}

			/**
			* Fetch  Distributor List From master
			* @param {Object}
			* type
			*/

			investAccountVm.getIdentificationList = function () {
				var reqParams = {};
				reqParams['type'] = constantConfig.mfAndsecConst.identificationTypeInMF;
				mutualFundsService.getMasters(reqParams).then(function (data) {
					investAccountVm.identificationTypeObj = data.masterDetails;
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}


			/**
			* Fetch  Gross Income List From master
			* @param {Object}
			* type
			*/
			investAccountVm.getGrossIncome = function () {
				mutualFundsService.getGrossIncomeList().then(function (data) {
					investAccountVm.annualIncomeObj = data;
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			/**
				
			* Fetch getPanCard From server
			* @param {id}
			* type
			*/
			investAccountVm.Urls = function () {
				mutualFundsService.getServerUrl().then(function (data) {
					investAccountVm.panCard = data.kycNo;
					$rootScope.panCard = data.kycNo;
				})
			}


			investAccountVm.panCard = mutualFundsService.getUserPanDetails().panNumber;
			if (investAccountVm.panCard == '' || investAccountVm.panCard == null || investAccountVm.panCard == undefined) {
				investAccountVm.Urls();
			} else {
				$rootScope.panCard = investAccountVm.panCard;
			}

			investAccountVm.setNomName = function () {
				if(investAccountVm.nomineeName == '' || investAccountVm.nomineeName == null || investAccountVm.nomineeName == undefined){
					investAccountVm.nomineeNameValid = true
				}else{
					investAccountVm.nomineeNameValid = false
				}
			}
			investAccountVm.setNomName2 = function () {
				if(investAccountVm.nomineeName2 == '' || investAccountVm.nomineeName2 == null || investAccountVm.nomineeName2 == undefined){
					investAccountVm.nomineeNameValid2 = true
				}else{
					investAccountVm.nomineeNameValid2 = false
				}
			}
			investAccountVm.setNomName3 = function () {
				if(investAccountVm.nomineeName3 == '' || investAccountVm.nomineeName3 == null || investAccountVm.nomineeName3 == undefined){
					investAccountVm.nomineeNameValid3 = true
				}else{
					investAccountVm.nomineeNameValid3 = false
				}
			}
			investAccountVm.setGuarName1 = function () {
				if(investAccountVm.appointee1 == '' || investAccountVm.appointee1 == null || investAccountVm.appointee1 == undefined){
					investAccountVm.guarNameValid1 = true
				}else{
					investAccountVm.guarNameValid1 = false
				}
			}
			investAccountVm.setGuarName2 = function () {
				if(investAccountVm.appointee2 == '' || investAccountVm.appointee2 == null || investAccountVm.appointee2 == undefined){
					investAccountVm.guarNameValid2 = true
				}else{
					investAccountVm.guarNameValid2 = false
				}
			}
			investAccountVm.setGuarName3 = function () {
				if(investAccountVm.appointee3 == '' || investAccountVm.appointee3 == null || investAccountVm.appointee3 == undefined){
					investAccountVm.guarNameValid3 = true
				}else{
					investAccountVm.guarNameValid3 = false
				}
			}
			investAccountVm.guarRelChk1 = function () {
				if(!investAccountVm.appointee1){
					investAccountVm.guarNameValid1 =true;
				}else{
					investAccountVm.guarNameValid1 =false;
				}
				if(!investAccountVm.appointeeDob1){
					investAccountVm.guarDobValid1 = true;
				}else{
					investAccountVm.guarDobValid1 = false;
				}
				if(!investAccountVm.appointeeRel1){
					investAccountVm.guarRelValid1 = true
				}else{					
					investAccountVm.guarRelValid1 = false
				}
			}
			investAccountVm.guarRelChk2 = function () {
				if(!investAccountVm.appointee2){
					investAccountVm.guarNameValid2 =true;
				}else{
					investAccountVm.guarNameValid2 =false;
				}
				if(!investAccountVm.appointeeDob2){
					investAccountVm.guarDobValid2 = true;
				}else{
					investAccountVm.guarDobValid2 = false;
				}
				if(!investAccountVm.appointeeRel2){
					investAccountVm.guarRelValid2 = true
				}else{					
					investAccountVm.guarRelValid2 = false
				}
			}
			investAccountVm.guarRelChk3 = function () {
				if(!investAccountVm.appointee3){
					investAccountVm.guarNameValid3 =true;
				}else{
					investAccountVm.guarNameValid3 =false;
				}
				if(!investAccountVm.appointeeDob3){
					investAccountVm.guarDobValid3 = true;
				}else{
					investAccountVm.guarDobValid3 = false;
				}
				if(!investAccountVm.appointeeRel3){
					investAccountVm.guarRelValid3 = true
				}else{					
					investAccountVm.guarRelValid3 = false
				}
			}
			investAccountVm.validRelChk = function () {
				if(!investAccountVm.nomineeName){
					investAccountVm.nomineeNameValid =true
				}
				if(!investAccountVm.nomineeDob){
					investAccountVm.nomineeDobValid = true;
				}else{
					investAccountVm.nomineeDobValid = false;
				}

				if(!investAccountVm.nomineeRel1){
					investAccountVm.nomineeRelValid = true
				}else{					
					investAccountVm.nomineeRelValid = false
				}
			}	
			investAccountVm.validRelChk2 = function () {
				if(!investAccountVm.nomineeName2){
					investAccountVm.nomineeNameValid2 =true
				}
				if(!investAccountVm.nomineeDob2){
					investAccountVm.nomineeDobValid2 = true;
				}else{
					investAccountVm.nomineeDobValid2 = false;
				}
				if(!investAccountVm.nomineeRel2){
					investAccountVm.nomineeRelValid2 = true
				}else{					
					investAccountVm.nomineeRelValid2 = false
				}
			}
			investAccountVm.validRelChk3 = function () {
				if(!investAccountVm.nomineeName3){
					investAccountVm.nomineeNameValid3 =true
				}
				if(!investAccountVm.nomineeDob3){
					investAccountVm.nomineeDobValid3 = true;
				}else{
					investAccountVm.nomineeDobValid3 = false;
				}
				if(!investAccountVm.nomineeRel3){
					investAccountVm.nomineeRelValid3 = true
				}else{					
					investAccountVm.nomineeRelValid3 = false
				}
			}
			investAccountVm.checkValidDobRel1 = function () {
				if(!investAccountVm.nomineeName){
					investAccountVm.nomineeNameValid =true
				}
				if(!investAccountVm.nomineeRel1){
					investAccountVm.nomineeRelValid = true
				}else{
					investAccountVm.nomineeRelValid = false
				}
				if(!investAccountVm.nomineeDob){
					investAccountVm.nomineeDobValid = true;
				}else{
					investAccountVm.nomineeDobValid = false;
				}
			}
			investAccountVm.checkValidDobRel2 = function () {
				if(!investAccountVm.nomineeName2){
					investAccountVm.nomineeNameValid2 =true
				}
				if(!investAccountVm.nomineeRel2){
					investAccountVm.nomineeRelValid2 = true
				}else{
					investAccountVm.nomineeRelValid2 = false
				}
				if(!investAccountVm.nomineeDob2){
					investAccountVm.nomineeDobValid2 = true;
				}else{
					investAccountVm.nomineeDobValid2 = false;
				}
			}
			investAccountVm.checkValidDobRel3 = function () {
				if(!investAccountVm.nomineeName3){
					investAccountVm.nomineeNameValid3 =true
				}
				if(!investAccountVm.nomineeRel3){
					investAccountVm.nomineeRelValid3 = true
				}else{
					investAccountVm.nomineeRelValid3 = false
				}
				if(!investAccountVm.nomineeDob3){
					investAccountVm.nomineeDobValid3 = true;
				}else{
					investAccountVm.nomineeDobValid3 = false;
				}
			}
			/**
			*	Add Same address as Investor for nominee1
			*/
			investAccountVm.setAddressAsInvestor1 = function () {
				if(!investAccountVm.nomineeName){
					investAccountVm.nomineeNameValid =true
				}
				if(!investAccountVm.nomineeRel1){
					investAccountVm.nomineeRelValid = true
				}else{
					investAccountVm.nomineeRelValid = false
				}
				if(!investAccountVm.nomineeDob){
					investAccountVm.nomineeDobValid = true;
				}else{
					investAccountVm.nomineeDobValid = false;
				}
				if(!investAccountVm.nomineeShare){
					investAccountVm.nomineeShareValidOnAddress = true
				}
				if (investAccountVm.sameAddressFlag1Checked == false) {
					investAccountVm.sameAddressFlag1Checked = true;
					investAccountVm.firstNomineeAddress1 = investAccountVm.address1;
					investAccountVm.firstNomineeAddress2 = investAccountVm.address2;
					investAccountVm.firstNamineeLocality = investAccountVm.locality;
					investAccountVm.firstNomineeState = investAccountVm.state;
					investAccountVm.firstNomineeCity = investAccountVm.city;
					investAccountVm.firstNomineePinCode = investAccountVm.pinCode;
				}
				else if (investAccountVm.sameAddressFlag1Checked == true) {
					investAccountVm.sameAddressFlag1Checked = false;
					investAccountVm.firstNomineeAddress1 = '';
					investAccountVm.firstNomineeAddress2 = '';
					investAccountVm.firstNamineeLocality = '';
					investAccountVm.firstNomineeState = '';
					investAccountVm.firstNomineeCity = '';
					investAccountVm.firstNomineePinCode = '';
				}
			}
			/**
			*	Add Same address as Investor for nominee1
			*/
			investAccountVm.setAddressAsInvestor2 = function () {
				if(!investAccountVm.nomineeName2){
					investAccountVm.nomineeNameValid2 =true
				}
				if(!investAccountVm.nomineeRel2){
					investAccountVm.nomineeRelValid2 = true
				}else{
					investAccountVm.nomineeRelValid2 = false
				}
				if(!investAccountVm.nomineeDob2){
					investAccountVm.nomineeDobValid2 = true;
				}else{
					investAccountVm.nomineeDobValid2 = false;
				}
				if(!investAccountVm.nomineeShare2){
					investAccountVm.nomineeShareValidOnAddress2 = true
				}
				if (investAccountVm.sameAddressFlag2Checked == false) {
					investAccountVm.sameAddressFlag2Checked = true;
					investAccountVm.secondNomineeAddress1 = investAccountVm.address1;
					investAccountVm.secondNomineeAddress2 = investAccountVm.address2;
					investAccountVm.secondNamineeLocality = investAccountVm.locality;
					investAccountVm.secondNomineeState = investAccountVm.state;
					investAccountVm.secondNomineeCity = investAccountVm.city;
					investAccountVm.secondNomineePinCode = investAccountVm.pinCode;
				} else if (investAccountVm.sameAddressFlag2Checked == true) {
					investAccountVm.sameAddressFlag2Checked = false;
					investAccountVm.secondNomineeAddress1 = '';
					investAccountVm.secondNomineeAddress2 = '';
					investAccountVm.secondNamineeLocality = '';
					investAccountVm.secondNomineeState = '';
					investAccountVm.secondNomineeCity = '';
					investAccountVm.secondNomineePinCode = '';
				}
			}
			/**
			*	Add Same address as Investor for nominee1
			*/
			investAccountVm.setAddressAsInvestor3 = function () {
				if(!investAccountVm.nomineeName3){
					investAccountVm.nomineeNameValid3 =true
				}
				if(!investAccountVm.nomineeRel3){
					investAccountVm.nomineeRelValid3 = true
				}else{
					investAccountVm.nomineeRelValid3 = false
				}
				if(!investAccountVm.nomineeDob3){
					investAccountVm.nomineeDobValid3 = true;
				}else{
					investAccountVm.nomineeDobValid3 = false;
				}
				if(!investAccountVm.nomineeShare3){
					investAccountVm.nomineeShareValid3 = true
				}
				if (investAccountVm.sameAddressFlag3Checked == false) {
					investAccountVm.sameAddressFlag3Checked = true;
					investAccountVm.thirdNomineeAddress1 = investAccountVm.address1;
					investAccountVm.thirdNomineeAddress2 = investAccountVm.address2;
					investAccountVm.thirdNamineeLocality = investAccountVm.locality;
					investAccountVm.thirdNomineeState = investAccountVm.state;
					investAccountVm.thirdNomineeCity = investAccountVm.city;
					investAccountVm.thirdNomineePinCode = investAccountVm.pinCode;
				} else if (investAccountVm.sameAddressFlag3Checked == true) {
					investAccountVm.sameAddressFlag3Checked = false;
					investAccountVm.thirdNomineeAddress1 = '';
					investAccountVm.secondNomineeAddress2 = '';
					investAccountVm.thirdNamineeLocality = '';
					investAccountVm.thirdNomineeState = '';
					investAccountVm.thirdNomineeCity = '';
					investAccountVm.thirdNomineePinCode = '';
				}
			}
			/*
			*	Add Country Function
			*/
			investAccountVm.addCounty = function () {
				if (investAccountVm.secondCountryDetails == 1) {
					investAccountVm.thirdCountryDetails = 1;
				}
				if (investAccountVm.secondCountryDetails == 0) {
					investAccountVm.secondCountryDetails = 1;
				}
			}
			/*
			*	getOccupationCode
			*/
			investAccountVm.getOccupationType = function (occCode) {
				for (var i = 0; i < investAccountVm.occupationObj.length; i++) {
					if (investAccountVm.occupationObj[i].occupationCode == occCode) {
						investAccountVm.occupationType = investAccountVm.occupationObj[i].occupationTypeCode;
					}
				}
			}
			investAccountVm.getLocationType = function (locationCode) {
				for (var i = 0; i < investAccountVm.cityObj.length; i++) {
					if (investAccountVm.cityObj[i].locationCode == locationCode) {
						investAccountVm.city = investAccountVm.cityObj[i].locationCode;

					}
				}
			}
			investAccountVm.getStateType = function (stateCode) {
				for (var i = 0; i < investAccountVm.stateObj.length; i++) {
					if (investAccountVm.stateObj[i].stateCode == stateCode) {
						investAccountVm.state = investAccountVm.stateObj[i].stateCode;
					}
				}
			}

			/***Function to update Share Percent***/
			investAccountVm.updateSharePercent = function (shareAmount, shareOf) {
				investAccountVm.nomineeShareValidOnAddress = false
				investAccountVm.nomineeShareValidOnAddress2 = false
				if(investAccountVm.nomineeShare == '' || investAccountVm.nomineeShare == null || investAccountVm.nomineeShare == undefined || investAccountVm.nomineeShare <= 0){
					investAccountVm.nomineeShareValid = true
					investAccountVm.shareReqErrorFlag = 0;
				}else{
					investAccountVm.nomineeShareValid = false
				}				
				if(investAccountVm.nomineeShare >= 100){
					investAccountVm.nomineeShareValid = true
					investAccountVm.shareReqErrorFlag = 0;
				}
				
				if(investAccountVm.nomineeShare == 0){
					investAccountVm.nomineeShare ='';
				}
				if(investAccountVm.nomineeShare2 == 0){
					investAccountVm.nomineeShare2 ='';
				}
				if (investAccountVm.noOfNominee == "1") {
				investAccountVm.nomineeShare = 100;
				}
				if (investAccountVm.actualSharePercent >= shareAmount) {
					if (investAccountVm.noOfNominee == "1") {
						if (investAccountVm.actualSharePercent == shareAmount) {
							investAccountVm.shareErrorFlag = 0;
						} else {
							investAccountVm.shareErrorFlag = 1;
						}
					} else {
						if (investAccountVm.countOfNominee2 == 1) {
							if(investAccountVm.nomineeShare2 == '' || investAccountVm.nomineeShare2 == null || investAccountVm.nomineeShare2 == undefined || investAccountVm.nomineeShare2 <= 0){
								investAccountVm.nomineeShareValid2 = true
								investAccountVm.shareReqErrorFlag = 0;
							}else{
								investAccountVm.nomineeShareValid2 = false
							}
							if(investAccountVm.nomineeShare2 >= 100){
								investAccountVm.nomineeShareValid = true
								investAccountVm.shareReqErrorFlag = 0;
							}
							investAccountVm.sumOfTwo = parseInt(investAccountVm.nomineeShare) + parseInt(investAccountVm.nomineeShare2);
							if (investAccountVm.countOfNominee3 == 1) {
								if(investAccountVm.nomineeShare3 == '' || investAccountVm.nomineeShare3 == null || investAccountVm.nomineeShare3 == undefined){
									investAccountVm.nomineeShareValid3 = true
									investAccountVm.shareReqErrorFlag = 0;
								}else{
									investAccountVm.nomineeShareValid3 = false
								}
								if(investAccountVm.sumOfTwo < 100){
									investAccountVm.nomineeShare3 = investAccountVm.actualSharePercent -  parseInt(investAccountVm.nomineeShare) - parseInt(investAccountVm.nomineeShare2);
									investAccountVm.sumOfThree = parseInt(investAccountVm.nomineeShare) + parseInt(investAccountVm.nomineeShare2) + parseInt(investAccountVm.nomineeShare3);
										if (investAccountVm.sumOfThree != parseInt(investAccountVm.actualSharePercent)) {
											investAccountVm.shareErrorFlag = 1;
											investAccountVm.shareReqErrorFlag = 0;
										}else if(investAccountVm.nomineeShare3 < 1){
											investAccountVm.shareReqErrorFlag = 1;
											investAccountVm.shareErrorFlag = 0;
										}else
										{
											investAccountVm.shareErrorFlag = 0;
											investAccountVm.shareReqErrorFlag = 0;
											
										}

								}else{
									if(investAccountVm.nomineeShare !='' && investAccountVm.nomineeShare2 !=''){
										investAccountVm.shareReqErrorFlag = 1;
										investAccountVm.shareErrorFlag = 0;
										investAccountVm.nomineeShare3 = '';
									}
									
								}	

							} else {
								investAccountVm.nomineeShare2 = investAccountVm.actualSharePercent -  parseInt(investAccountVm.nomineeShare);
								investAccountVm.shareErrorFlag = 0;
								investAccountVm.sumOfTwo = parseInt(investAccountVm.nomineeShare) + parseInt(investAccountVm.nomineeShare2);
								if (investAccountVm.sumOfTwo != investAccountVm.actualSharePercent) {
									investAccountVm.shareErrorFlag = 1;
								} else {
									investAccountVm.shareErrorFlag = 0;
									
									}
							}
						} else {
							investAccountVm.sumOfTwo = parseInt(investAccountVm.nomineeShare) + parseInt(investAccountVm.nomineeShare2);
							if (investAccountVm.sumOfTwo != investAccountVm.actualSharePercent) {
								investAccountVm.shareErrorFlag = 1;
							} else investAccountVm.shareErrorFlag = 0;
						}
					}

				} else {
					if(investAccountVm.nomineeShare > 100 || investAccountVm.nomineeShare2 > 100){
						investAccountVm.shareReqErrorFlag = 1;
						investAccountVm.shareErrorFlag = 0;
						investAccountVm.nomineeShareValid2 = false
						investAccountVm.nomineeShareValid = false
					}else{
						investAccountVm.shareErrorFlag = 1;
					}
				}

			}
			/***Function to caLL Trem and condition SERVICE***/
			investAccountVm.showInvestAcntTermsAndCondition = function () {
				if (investAccountVm.investAcntFormTermsAndConditionsFlag == 1) {
					investAccountVm.investAcntFormTermsAndConditionsFlag = 0;
				} else {
					//Call service to fetch Disclaimer
					investAccountVm.reqParams = {};
					investAccountVm.reqParams['action'] = constantConfig.mfAndsecConst.AOTermsAndConditions;
					mutualFundsService.getTermsAndConditions(investAccountVm.reqParams).then(function (data) {
						investAccountVm.investAcntFormTermsAndConditionsMessage = data.message;
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
					investAccountVm.investAcntFormTermsAndConditionsFlag = 1;
				}
			}

			/**
			*Function to go to get fund Deatils
			@params:{fundId:''}
			
			**/
			investAccountVm.getFundDetails = function () {
				investAccountVm.fundObj = mutualFundsService.getFundToInvest();
				investAccountVm.fundId = investAccountVm.fundObj.fundId;
				investAccountVm.reqParams = {};
				investAccountVm.reqParams['amfiCode'] = investAccountVm.fundId;
				mutualFundsService.getFundDetails(investAccountVm.reqParams).then(function (data) {
					investAccountVm.fundDetailList = data;
					if (investAccountVm.fundDetailList.planList[0]) {
						investAccountVm.plan = investAccountVm.fundDetailList.planList[0].plan;
						investAccountVm.option = investAccountVm.fundDetailList.planList[0].option;
						investAccountVm.nav = investAccountVm.fundDetailList.planList[0].nav;
						investAccountVm.navDate = investAccountVm.fundDetailList.planList[0].navDate;
						investAccountVm.amcCode = investAccountVm.fundDetailList.planList[0].scmAmcCd;
					} else {
						investAccountVm.plan = '';
						investAccountVm.option = '';
						investAccountVm.nav = '';
						investAccountVm.navDate = '';
						investAccountVm.amcCode = '';
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			/***Function to show alert POP UP***/
			investAccountVm.zeroFolioshowInformationPopup = function (message) {
				var infoPopup = $ionicPopup.show({
					template: '<p>' + message + '</p>',
					title: 'Alert',
					cssClass: 'dialog',
					scope: $scope,
					buttons: [{
						text: 'Ok',
						onTap: function (e) {
							$state.go('menu.accountOverviewMyBalance');
						}
					}]
				});
			}

			/**
			@Function to check user's tax status
			* PanCard:{object}
			***/
			investAccountVm.taxStatusChangeEvt = function () {
				if (investAccountVm.taxStatus != constantConfig.mfAndsecConst.taxStatus) {
					var infoPopup = $ionicPopup.show({
						template: '<p translate="TAX_STATUS_ERROR"></p>',
						cssClass: 'dialog',
						scope: $scope,
						buttons: [{
							text: 'Ok'
						}]
					});
					investAccountVm.taxStatus = constantConfig.mfAndsecConst.taxStatus;
				}
			}

			/**
			@Function to check COUNTRY
			* PanCard:{object}
			***/
			investAccountVm.countryChangeEvt = function () {
				if (investAccountVm.country != constantConfig.mfAndsecConst.country || investAccountVm.nationality != constantConfig.mfAndsecConst.country) {
					var infoPopup = $ionicPopup.show({
						template: '<p translate="COUNTRY_ERROR_AOF"></p>',
						cssClass: 'dialog',
						scope: $scope,
						buttons: [{
							text: 'Ok'
						}]
					});
					investAccountVm.country = constantConfig.mfAndsecConst.country;
					investAccountVm.nationality = constantConfig.mfAndsecConst.country;
				}
			}

			/**
			@Function to check fatca 
			* PanCard:{object}
			***/
			investAccountVm.factaChangeEvt = function () {
				if (investAccountVm.FATCAFlag != "2") {
					var infoPopup = $ionicPopup.show({
						template: '<p translate="TAX_STATUS_ERROR"></p>',
						cssClass: 'dialog',
						scope: $scope,
						buttons: [{
							text: 'Ok'
						}]
					});
					investAccountVm.FATCAFlag = '2';
				}
			}

		investAccountVm.getRelMaster=function(){
            		mutualFundsService.getRelMaster().then(function(data){
	    			investAccountVm.relationshipsNomineeMaster = data.relationshipNameAndCode;
				investAccountVm.relationshipsGuardian = data.guardianRelationship;                 
                }, function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }            

			/*** one time initialization to be done when the controller is loaded***/
			$scope.$on('$ionicView.loaded', function () {

			});

			/*** actions to done everytime the view is shown***/
			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();

			});

			/***any cleanup needs to be done here: executes everytime when page is left***/
			$scope.$on('$ionicView.afterLeave', function () {
				investAcntForm.reset();

			});
			return this;
		}]);

