/******* Mutual Funds List Controller ******/

'use strict';
angularApp.controller('mutualFundsListController',
						["$timeout",
						 "$state",
						 "$scope",
						 "$translate","$ionicScrollDelegate","mutualFundsService","$ionicPopup","constantConfig","$filter","$rootScope","utilityService","homeScreenService","$ionicHistory","getAccountDetailsService","newCardService","loggedInUserService","clickStreamService",

function ($timeout,
		 $state,
		 $scope,
		 $translate,$ionicScrollDelegate,mutualFundsService,$ionicPopup,constantConfig,$filter,$rootScope,utilityService,homeScreenService,$ionicHistory,getAccountDetailsService,newCardService,loggedInUserService,clickStreamService) {

	var mutualFundslistVm= this;

	/*** Initialize the variables that has to show in  the HTML come here ***/
	function initPage(){
		mutualFundslistVm.cbsPan=mutualFundsService.getUserDetails().panNumber;

		mutualFundslistVm.pageVal=1; //Pagination
		mutualFundslistVm.isSort=0;   //For sorting
		mutualFundslistVm.NFONotFound=0;
		$scope.pageId=mutualFundsService.getPageId();  //Usig for back button
		mutualFundslistVm.fundList=mutualFundsService.getFundList(); //Get all fundList from service
		if(mutualFundslistVm.fundList.length > 0 && mutualFundslistVm.fundList[0].fundSchemeName != "All funds"){
			var temparay=[]; 
			for (var i = 0; i <mutualFundslistVm.fundList.length; i++) {
				if(mutualFundslistVm.fundList[i].fundSchemeName == "Popular Funds"){
					mutualFundslistVm.fundList[i].fundSchemeName = "Popular";
				}
				if(mutualFundslistVm.fundList[i].fundSchemeName == "Solution Orient"){
					mutualFundslistVm.fundList[i].fundSchemeName = "Solution Oriented";
				}
				for (var j = 0; j <mutualFundslistVm.fundList[i].fundSchemeList.length; j++){
					if(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration1Month){mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration1Month = parseFloat(parseFloat(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration1Month).toFixed(2));}
					else{mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration1Month = 'NA'}
					
					if(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration3Month){mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration3Month = parseFloat(parseFloat(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration3Month).toFixed(2));}
					else{mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration3Month = 'NA'}
					
					if(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration6Month){mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration6Month = parseFloat(parseFloat(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration6Month).toFixed(2));}
					else{mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration6Month = 'NA'}
					
					if(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration12Month){mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration12Month = parseFloat(parseFloat(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration12Month).toFixed(2));}
					else{mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration12Month = 'NA'}
					
					if(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration36Month){mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration36Month = parseFloat(parseFloat(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration36Month).toFixed(2));}
					else{mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration36Month = 'NA'}
					
					if(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration60Month){mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration60Month = parseFloat(parseFloat(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration60Month).toFixed(2));}
					else{mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDuration60Month = 'NA'}
					
					if(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDurationSinceIncep){mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDurationSinceIncep = parseFloat(parseFloat(mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDurationSinceIncep).toFixed(2));}
					else{mutualFundslistVm.fundList[i].fundSchemeList[j].performanceDurationSinceIncep = 'NA'}

					if(mutualFundslistVm.fundList[i].fundSchemeName != "NFO" && mutualFundslistVm.fundList[i].fundSchemeName != "Popular"){	
						temparay.push(mutualFundslistVm.fundList[i].fundSchemeList[j]); 
					}
					if(mutualFundslistVm.fundList[i].fundSchemeName == "NFO"){
						mutualFundslistVm.fundList[i].fundSchemeList[j].fundOption = mutualFundslistVm.fundList[i].fundSchemeList[j].planList[0].option;
					}	  
				}		
			}
			//var unique = (arr, props = []) => [...new Map(arr.map(entry => [props.map(k => entry[k]).join('|'), entry])).values()]; 
			//temparay = unique(temparay, ['fundId']);
			temparay = $filter('uniqueArr')(temparay, 'fundId');
			var allfndsObj = {'fundSchemeList':temparay,'fundSchemeName':"All funds"};
			mutualFundslistVm.fundList.splice(0, 0, allfndsObj);
		}
		if(mutualFundsService.getNewFundDetails()=="true"){
			mutualFundslistVm.fundDetailsList=mutualFundslistVm.fundList[2].fundSchemeList;
			mutualFundslistVm.showFundListDetails(mutualFundslistVm.fundDetailsList,2);
		}else{
			mutualFundslistVm.fundDetailsList=mutualFundslistVm.fundList[0].fundSchemeList;
			mutualFundslistVm.showFundListDetails(mutualFundslistVm.fundDetailsList,0);
		}

		
		mutualFundslistVm.infoMessage=mutualFundsService.getInfoList();

		if(mutualFundslistVm.infoMessage.aum){
			mutualFundslistVm.infoMessage=mutualFundslistVm.infoMessage.aum;
		}else{
			mutualFundslistVm.infoMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;
		}
		mutualFundslistVm.aumEffectiveDate=$filter('date')(new Date(mutualFundslistVm.fundDetailsList[0].aumEffectiveDate), 'dd MMM yyyy');
		// GET THE RISK PROFILE SUGGESTED DATA- IF AN USER HAS

		mutualFundslistVm.riskProfileSuggestions= mutualFundsService.getRiskProfile();
		$scope.performanceDuration1Month = false;
		$scope.performanceDuration3Month = false;
		$scope.performanceDuration6Month = false;
		$scope.performanceDuration12Month = false;
		$scope.performanceDuration36Month = false;
		$scope.performanceDuration60Month = false;
		$scope.performanceDurationSinceIncep = true;
		$scope.selectedReturnVal = 'MAX';
		$scope.dynamicOrder = 'fundName';
		$scope.order = {
			field: 'performanceDurationSinceIncep',
			reverse: false
		};
	}
	/**
	* Show information Popup
	@params:{}
	**/
	mutualFundslistVm.showPopup=function(){
		var infoPopup = $ionicPopup.show({
			template: '<p>'+mutualFundslistVm.infoMessage+'</p>',
			cssClass: 'dialog',
			scope: $scope,
			buttons: [{
				text: 'Ok'
			}]
		});

		infoPopup.then(function(res) {

		});

	}
	/*** Function to go to Show fund Details Page  .All fund details will come in single function  when data will come from backend***/
	mutualFundslistVm.showFundDetails=function(fundObj){
		var fundoptnArr = [];
		 if(fundObj.isNfo == "Y"){
			var id = fundObj.fundName;
			fundoptnArr.push(fundObj);
			//mutualFundslistVm.fundList[0].fundSchemeList
			for (var i = 0; i <mutualFundslistVm.fundList.length; i++) {
				for (var j = 0; j <mutualFundslistVm.fundList[i].fundSchemeList.length; j++){ 
					if(mutualFundslistVm.fundList[i].fundSchemeName == "NFO"){
						if(mutualFundslistVm.fundList[i].fundSchemeList[j].fundName == id && mutualFundslistVm.fundList[i].fundSchemeList[j].fundOption !='G'){
							fundoptnArr.push(mutualFundslistVm.fundList[i].fundSchemeList[j]);
						}
					}
				}	
			}
		 }
		 else{
			var schFndid = fundObj.schemeFundId;
			//var fundoptnArr = [];
			fundoptnArr.push(fundObj);
			//mutualFundslistVm.fundList[0].fundSchemeList
			for (var k = 0; k <mutualFundslistVm.fundList[0].fundSchemeList.length; k++) {
				//fundObj.fundId
				if(mutualFundslistVm.fundList[0].fundSchemeList[k].schemeFundId == schFndid && mutualFundslistVm.fundList[0].fundSchemeList[k].fundOption !='G'){
					fundoptnArr.push(mutualFundslistVm.fundList[0].fundSchemeList[k]);
				}
			}
		 }
		//var unique = (arr, props = []) => [...new Map(arr.map(entry => [props.map(k => entry[k]).join('|'), entry])).values()]; 
		fundoptnArr = $filter('uniqueArr')(fundoptnArr, 'fundId');
		if(fundoptnArr[0].fundOption != "G"){
			var indexOfG = $filter('findIndexByKeyValue')(fundoptnArr,'fundOption', 'G');
			if(indexOfG != -1){ fundoptnArr.unshift(fundoptnArr.splice(indexOfG, 1)[0]);}
		}
		mutualFundsService.addFundId(fundoptnArr);
		$state.go('menu.fundDetails');
	}

	/*** Function to Show  Details Page  ***/
	mutualFundslistVm.showFundListDetails=function(fundSchemeList,index){
		var fundTypeName = "";
		if(mutualFundslistVm.fundList && mutualFundslistVm.fundList.length > 0)
		{
           fundTypeName = mutualFundslistVm.fundList[index].fundSchemeName;
		}
		
		clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + fundTypeName+"_MOB").toUpperCase());
		//if isnfo true then go to NFO tab page
		if(fundSchemeList.length==0){
			mutualFundslistVm.NFONotFound=1;  
			mutualFundslistVm.isNFO=0;
            //return true;
		}else{
		if(fundSchemeList[0].isNfo!='Y'){
			mutualFundslistVm.isNFO=2;

		}else{
			mutualFundslistVm.isNFO=1;
		}
	}
	

		$scope.currentIndex=index;
		mutualFundslistVm.fundDetailsList='';
		mutualFundslistVm.fundDetailsList=fundSchemeList;

	}

	/*** Function to change Performance ***/
	mutualFundslistVm.performChange=function(){
		
	}
	/*** Sorting function  ***/
	mutualFundslistVm.sorting=function(isSort){
		if(isSort != "close"){
			$scope.dynamicOrder = 'performanceDurationSinceIncep';
			$scope.order = {
				field: 'performanceDurationSinceIncep',
				reverse: false
			};
		}
		
		var element = document.getElementsByClassName("slidertest")[0];
        element.classList.toggle("closetest");
		if(document.getElementById("mfoverlay").style.display == "none"){
			document.getElementById("mfoverlay").style.display = "";
		}
		else{
			document.getElementById("mfoverlay").style.display = "none";
		}		
	}

	$scope.mfclickRadio = function(key){
		var objkey = "";
		if($scope.selectedReturnVal == '1M'){objkey = 'performanceDuration1Month';}
		if($scope.selectedReturnVal == '3M'){objkey = 'performanceDuration3Month';}
		if($scope.selectedReturnVal == '6M'){objkey = 'performanceDuration6Month';}
		if($scope.selectedReturnVal == '1Y'){objkey = 'performanceDuration12Month';}
		if($scope.selectedReturnVal == '3Y'){objkey = 'performanceDuration36Month';}
		if($scope.selectedReturnVal == '5Y'){objkey = 'performanceDuration60Month';}
		if($scope.selectedReturnVal == 'MAX'){objkey = 'performanceDurationSinceIncep';}
		console.log(mutualFundslistVm.fundDetailsList);	
		$scope.dynamicOrder = objkey;
		if(key == 'high'){
			$scope.order = {
				field: objkey,
				reverse: true
			};
		}
		else{
			$scope.order = {
				field: objkey,
				reverse: false
			};
		}
	}

	$scope.sortByKey = function(array, key) {
		return array.sort(function(a, b) {
			var x = a[key]; var y = b[key];
			return ((x < y) ? -1 : ((x > y) ? 1 : 0));
		});
	};

	mutualFundslistVm.clearreturn = function(){
		$scope.performanceDuration1Month = false;
		$scope.performanceDuration3Month = false;
		$scope.performanceDuration6Month = false;
		$scope.performanceDuration12Month = false;
		$scope.performanceDuration36Month = false;
		$scope.performanceDuration60Month = false;
		$scope.performanceDurationSinceIncep = false;
	}

	$scope.mfselectReturns = function (pDiv){
		$scope.selectedReturnVal = pDiv;
		document.getElementsByClassName('mfReturnsDetfocus')[0].classList.remove('mfReturnsDetfocus')
		document.getElementById('div' + pDiv).classList.add("mfReturnsDetfocus");
		mutualFundslistVm.clearreturn();
		if(pDiv == '1M'){$scope.performanceDuration1Month = true;}
		if(pDiv == '3M'){$scope.performanceDuration3Month = true;}
		if(pDiv == '6M'){$scope.performanceDuration6Month = true;}
		if(pDiv == '1Y'){$scope.performanceDuration12Month = true;}
		if(pDiv == '3Y'){$scope.performanceDuration36Month = true;}
		if(pDiv == '5Y'){$scope.performanceDuration60Month = true;}
		if(pDiv == 'MAX'){$scope.performanceDurationSinceIncep = true;}	
		
	}
/**
	@Function to get Folio
	* PanCard:{object}
	***/
	mutualFundslistVm.getFolio=function(){
		var reqParams={};
		reqParams['panNo']=mutualFundslistVm.panCard;
		mutualFundsService.getPortfolio(reqParams).then(function(data) {

		});
	}

	 mutualFundslistVm.getServerUrl=function(){
            mutualFundsService.getServerUrl().then(function(data){
                mutualFundslistVm.URL=data;
               if(mutualFundslistVm.cbsPan=='' || mutualFundslistVm.cbsPan ==null || mutualFundslistVm.cbsPan==undefined){
                 mutualFundslistVm.panCard=mutualFundslistVm.URL.kycNo;
               }
               mutualFundslistVm.getFolio();
            });
        }

	 if(mutualFundslistVm.cbsPan=='' || mutualFundslistVm.cbsPan==null || mutualFundslistVm.cbsPan==undefined){
	 	if($rootScope.panCard=='' || $rootScope.panCard ==null || $rootScope.panCard==undefined){
			 if(loggedInUserService.isLoggedInDetails.isLoggedIn){
				mutualFundslistVm.getServerUrl();
			 }
	 		 
	 	}else{
	 		mutualFundslistVm.panCard=$rootScope.panCard;
	 		mutualFundslistVm.getFolio();
	 	}
	 }else{
	 	mutualFundslistVm.panCard=mutualFundslistVm.cbsPan;
	 	mutualFundslistVm.getFolio();
	 }

	
	
	/*** Go to home function  ***/
	mutualFundslistVm.goToHome=function(){
		 if(!loggedInUserService.isLoggedInDetails.isLoggedIn){
			$state.go('menu.leadGenerationInvestment');
		 }else{
			if($scope.pageId=='portfolio'){
			$state.go("menu.portfolio");
			mutualFundsService.setPageId('');
			}else if($scope.pageId=='quickBuy'){
				$state.go('menu.accountOverviewMyBalance');
				mutualFundsService.setPageId('');
			}else if(homeScreenService.ishamMenu===true){
				//$state.go("menu.homeScreen");
				$ionicHistory.goBack();
				homeScreenService.ishamMenu=false;
			}else{
				$state.go("menu.mutualFunds");
			}
		 }
		
	}

	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		// mutualFundslistVm.isBackCheck=homeScreenService.isBackCheck;
		// homeScreenService.isBackCheck	=false;
		if(homeScreenService.ishamburgerMenuViewMF){
			mutualFundslistVm.isHamCheck = true;
			mutualFundslistVm.isBackCheck = true;
		}else {
			mutualFundslistVm.isBackCheck = false;
			mutualFundslistVm.isHamCheck = false;
		}
		initPage();
	});


   $scope.toggleGroup = function(group) {
    if ($scope.isGroupShown(group)) {
      $scope.shownGroup = null;
    } else {
      $scope.shownGroup = group;
    }
    // $ionicScrollDelegate.resize();
  }
  $scope.isGroupShown = function(group) {
    return $scope.shownGroup === group;
  }

  $scope.isSubGroupShown = function(item) {
    return $scope.shownChild === item;
  }

	return this;
}]);
