'use strict';
angularApp.service('myBalanceService', function($q, utilityService, AdapterUtils, cardCompareService, linkCardService, cardsService, floatingMenuService, $state) {
var dummymenuCheck=true;
	var err = {};
	var setErrorObj = function(errObj) {
		err = errObj;
	};
	var getErrorObj = function() {
		return err;
	};
var LinkCreditCards = function () {
linkCardService.LinkCreditCards({}).then(
		function (response) {
				cardsService.errorLogger(response);
				floatingMenuService.getRedirectionMessage().then(function (response) {
						cardsService.errorLogger(response);
						if (response.data && response.data.message) {
								cardsService.setParams({
										"rewardsAgreeContent": response.data.message
								});
								$state.go("menu.rewardsAgree");
						}
				}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
				});
				floatingMenuService.setParams({
						"sourceRedirect": "linkCard"
				});
		},
		function (error) {
				utilityService.showErrorMessage(error.responseMessage);
		});
	};
	return {
		setErrorObj : setErrorObj,
		getErrorObj : getErrorObj,
		LinkCreditCards : LinkCreditCards
	};
});
