'use strict';

angularApp.controller('myInsuranceController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$translate",
						 "$location",
						 "$ionicScrollDelegate",
						 "getAccountDetailsService",
				 
function ($timeout,
		 $state,
		 $scope,
		 $translate,
		 $location,
		 $ionicScrollDelegate,
		 getAccountDetailsService) {
	
	//functions, variables that can be accessed from the HTML come here

	var myInsuranceVm = this;
	
	//private methods section start
	function initPage(){
		

$location.hash('myInsuranceView');

     // call $ionicScrollDelegate()
     $ionicScrollDelegate.anchorScroll();
		myInsuranceVm.test='test from insurence';

	
		 myInsuranceVm.lifeinsurance = "Life Insurance";
		
		myInsuranceVm.preDue = "Premium Due";
		
		myInsuranceVm.RenewalDate = "Renewal Date";
		
		myInsuranceVm.sumassured = "Sum Assured";
		
		myInsuranceVm.homins = "Home Insurance";

		myInsuranceVm.enddate = "End Date";

		myInsuranceVm.savingsacc = "Savings Account";
		myInsuranceVm.currentacc = "Current Account";
		myInsuranceVm.avgmonthly = "Average Monthly Balance";

		getAccountDetailsService.getAccountDetails().then(function(data){
			myInsuranceVm.headerList=data.headerList;
			//Success - Data
		
		myInsuranceVm.lifeInsurance=data.lifeInsurance;
		myInsuranceVm.homeInsurance=data.homeInsurance;
		

		}, function(error){

		});



	}
	//private methods section end



	myInsuranceVm.gotohomeInsurance = function(){
		$state.go('menu.myPolicies');
	}
	
	myInsuranceVm.myInsurance=function (){
		$state.go('menu.transaction');
	}
	
	myInsuranceVm.goToNextPage=function (){
		$state.go('menu.generalInsurance');

	}
	
	myInsuranceVm.goToPolicyPage=function (){
		$state.go('menu.linkingLIPolicy');
	}

	
	
	
	myInsuranceVm.transaction= function(){
	$state.go('menu.transaction');	
	}
	


	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		
		
		initPage();
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
	
		
	});
	
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		
		//any cleanup needs to be done here: executes everytime when page is left
		
	});
	return this;
}]);

