'use strict';

angularApp.controller('myInvestmentsController', 
						["$timeout",
						 "$state",
						 "$scope",
						 "$location",
						 "$ionicScrollDelegate",
						 "getAccountDetailsService",

function ($timeout,
		 $state,
		 $scope,
		 $location,
		 $ionicScrollDelegate,
		 getAccountDetailsService) {

	//functions, variables that can be accessed from the HTML come here
	var myInvestmentsvm = this;
	//private methods section start
	function initPage(){
		

		$location.hash('myInvestmentsView');

     // call $ionicScrollDelegate()
     $ionicScrollDelegate.anchorScroll();
     myInvestmentsvm.showBack = false;
     myInvestmentsvm.showNext = false;
     myInvestmentsvm.mf = 'Mutual Funds';
     myInvestmentsvm.secure = 'Securities';
     myInvestmentsvm.currValue = 'Current Value';
     myInvestmentsvm.currInvest ='Invested Value';
     myInvestmentsvm.mutalfundReturn ='Returns';
     myInvestmentsvm.securecurrValue = 'Current Value';
     myInvestmentsvm.securecurrInvest = 'Invested Value';
     myInvestmentsvm.secureReturn = 'Returns';

     getAccountDetailsService.getAccountDetails().then(function(data){
     	myInvestmentsvm.headerList=data.headerList;
			//Success - Data
		
		myInvestmentsvm.mutualFunds=data.mutualFunds;
		myInvestmentsvm.securities=data.securities;
		

		}, function(error){

		});


	}
	myInvestmentsvm.mutualFundsFun = function(){
		//To do
		$state.go('menu.mutualFunds');
	}
	myInvestmentsvm.goBacktoPrevious = function(){
		//To do
	}

	myInvestmentsvm.goToNextPage = function(){
		$state.go('menu.myInsurance');
	}

	myInvestmentsvm.transaction= function(){
	$state.go('menu.transaction');	
	}
	
	myInvestmentsvm.linkAccount = function(){
		$state.go('menu.linkAccount');
	}
	myInvestmentsvm.sbiCAPSecurities=function(){
		$state.go("menu.securitiesPortfolio");
	}
	myInvestmentsvm.dematAccountHome=function(){
		
		$state.go("menu.dematAccountHome");
	}
	
	myInvestmentsvm.openAccountAgree = function()
	{
		$state.go('menu.openAccountAgree');
		
	}
	

	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {

		
		initPage();
	});

	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {

		
	});

	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {

		//any cleanup needs to be done here: executes everytime when page is left
		
	});
	return this;
}]); 