
'use strict';

/*State defination with respective names, urls, controllers and templates */
angularApp.config(['$stateProvider',
	function ($stateProvider) {
		$stateProvider
          .state('menu.ppfExtReview', {
               url: '/ppfExtReview',
               cache: false,
               data: {
                    pageId: 'PPF_EXT_REVIEW'
               },
               views: {
                    'menuContent': {
                         templateUrl: 'pages/accountOverview/otherDeposits/ppfExtension/ppfExtReview.html',
                         controller: 'ppfExtReviewController',
                         controllerAs: 'ppfExtReviewVM',
                    }
               }
          })
          .state('menu.ppfExtOTP', {
               url: '/ppfExtOTP',
               cache: false,
               data: {
                    pageId: 'PPF_EXT_OTP'
               },
               views: {
                    'menuContent': {
                         templateUrl: 'pages/accountOverview/otherDeposits/ppfExtension/ppfExtOTP.html',
                         controller: 'ppfExtOTPController',
                         controllerAs: 'ppfExtOTPVM',
                    }
               }
          })
          .state('menu.ppfExtSuccess', {
               url: '/ppfExtSuccess',
               cache: false,
               data: {
                    pageId: 'PPF_EXT_SUCCESS'
               },
               views: {
                    'menuContent': {
                         templateUrl: 'pages/accountOverview/otherDeposits/ppfExtension/ppfExtSuccess.html',
                         controller: 'ppfExtSuccessController',
                         controllerAs: 'ppfExtSuccessVM',
                    }
               }
          })
    }
]);