angularApp.service('ppfExtService', function ($q, utilityService, AdapterUtils, $state, getAccountDetailsService) {
     var ppfExtService = this;
     ppfExtService.ppfAccDetails = {};

     ppfExtService.getNomineeDetails = function (data) {
          var q = $q.defer();
          var obj = {
               "fdAccountNumber": data.otherAccountNumber,
               "branchCode": data.branchCode
          };
          AdapterUtils.postData("adapters/AccountOverViewAdapter/viewPPFNomineeDetails", obj, true).then(
               function (response) {
                    q.resolve(response.data);
               },
               function (error) {
                    q.reject(error);
               }
          );
          return q.promise;
     };

     ppfExtService.getPDFDetails = function (data) {
          var q = $q.defer();
          AdapterUtils.postData("adapters/AccountOverViewAdapter/getPPFExtensionPDFForm", {}, true).then(
               function (response) {
                    q.resolve(response.data);
               },
               function (error) {
                    q.reject(error);
               }
          );
          return q.promise;
     };

     ppfExtService.success = function (data) {
          var q = $q.defer();
          AdapterUtils.postData("adapters/AccountOverViewAdapter/submitPPFExtension", {}, true).then(
               function (response) {
                    q.resolve(response);
               },
               function (error) {
                    q.reject(error);
               }
          );
          return q.promise;
     };

     ppfExtService.getTnCDetails = function (data) {
          var q = $q.defer();
          AdapterUtils.postData("adapters/AccountOverViewAdapter/getPPFTermsandCondition", {}, false).then(
               function (response) {
                    q.resolve(response.data);
               },
               function (error) {
                    q.reject(error);
               }
          );
          return q.promise;
     };

     ppfExtService.checkKYC = function () {
          var q = $q.defer();
          AdapterUtils.postData("adapters/FundsTransferAdapter/checkKYC", {}, true).then(function (response) {
               q.resolve(response.data);
          },
               function (error) {
                    q.reject(error);
               });
          return q.promise;
     };

     return ppfExtService;
});