angularApp.controller('consentRevocationController', ["$state", "$scope","leadGenerationService","$ionicPopup","utilityService",
 function($state, $scope,leadGenerationService,$ionicPopup,utilityService) {

     var consentRevocationControllerVm = this;
     consentRevocationControllerVm.disableSubmit = true;

      function initPage() {
          
        leadGenerationService.checkConsent().then(function(response){
           consentRevocationControllerVm.customerRecordExists = response.customerRecordExists;
           consentRevocationControllerVm.isConsentOrRevoke = response.isConsentOrRevoke;

        }, function(error) {
            utilityService.showErrorMessage(error.responseMessage);
        });
      }

      consentRevocationControllerVm.goNext = function(){
          $ionicPopup.alert({
                template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color"><span class="oa_highlight_txt">' + 'Request for Cancellation of Authorization to ' +
                'Call for Product Offer is accepted </span>' + '<br><br>' + 'You will no longer be contacted for the ' +
                'Product offers.' + '</span></div></div></div>',
                scope: $scope,
                cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                buttons: [
                    {
                        text: "Ok",
                        type: 'button-positive',
                        onTap: function () {
                          utilityService.showSpinner();
                            leadGenerationService.updateConsent().then(function(response){
                              utilityService.hideSpinner();
                                $state.go('menu.homeScreen'); 
                            },function(error) {
								utilityService.hideSpinner();
                                utilityService.showErrorMessage(error.responseMessage);
                            });
                            
                            
                        }
                    }
                ],
            });
          
      }

      consentRevocationControllerVm.agreeChkBox = function() {
        if (consentRevocationControllerVm.isChecked) {
            consentRevocationControllerVm.disableSubmit = false;
        } else {
            consentRevocationControllerVm.disableSubmit = true;
        }
    }

       //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

 }]);