angularApp.controller('leadGenerationCreditCardController', ["$state", "$scope", "newCardService","loggedInUserService","utilityService","$timeout","cardConfig","$ionicSlideBoxDelegate",
 function($state, $scope, newCardService, loggedInUserService,utilityService,$timeout,cardConfig,$ionicSlideBoxDelegate) {

     var leadGenerationCreditCardVm = this;
     $scope.slideIndex = 0;
     $scope.myActiveSlide = 0;

     function initPage() {
           leadGenerationCreditCardVm.getRecommendedCards();
        }
     
     leadGenerationCreditCardVm.browseAllCards = function(tabname){
         newCardService.browseCardsTabsPreLogin(tabname);
    }

    leadGenerationCreditCardVm.goBack = function() {
		 $state.go('menu.userLanding');
    }
    leadGenerationCreditCardVm.LinkCreditCards = function () {
      newCardService.setPreLoginSelectedMenu('link');
      loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
      $state.go('menu.userLogin');
    }

    leadGenerationCreditCardVm.getRecommendedCardsBanner = function() {
          leadGenerationCreditCardVm.getRecommendedCardList = [];
            angular.forEach(leadGenerationCreditCardVm.getAllCardList, function(value, key) {
              leadGenerationCreditCardVm.getRecommendedCardList[key]=value;
          }); 
    }

      leadGenerationCreditCardVm.getRecommendedCards = function() {
        $ionicSlideBoxDelegate.$getByHandle('creditCardOutbound').update();
            var data = {};
            newCardService.getRecommendedCardsPreLogin(data).then(function(response) {   
            leadGenerationCreditCardVm.getAllCardList = response.data[0].banners || [];
            leadGenerationCreditCardVm.getRecommendedCardsBanner()
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        leadGenerationCreditCardVm.goToCard = function(page){
        newCardService.browseCardsTabsPreLogin('All');
        }  
      

      leadGenerationCreditCardVm.applyNow = function(card){
        newCardService.setPreLoginSelectedMenu('cards');
        newCardService.setTermsAndConditionsOutboundAnalyticsData(card);
        loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
        $state.go('menu.userLogin');
      }

      $scope.$on('$ionicView.beforeEnter', function(event, data) {
            initPage();
        });


 }]);