


'use strict';


angularApp.controller('cardProfessionalDetails4Controller', ["$state", "$scope", "$translate", "validateService", "applyNowService", "cardsService", "cardConfig", "$timeout", "utilityService", "floatingMenuService","clickStreamService","$ionicPopup","constantConfig",
    function($state, $scope, $translate, validateService, applyNowService, cardsService, cardConfig, $timeout, utilityService, floatingMenuService,clickStreamService,$ionicPopup,constantConfig) {

      
        var step4Vm = this;
        var pendingApplication;
     
        function initPage() {



            step4Vm.step4Form = {};
            step4Vm.professionalDetails = {};
            step4Vm.personalDetails = {};
            step4Vm.professionalDetails.address = {};
            step4Vm.validateService = validateService;

            step4Vm.cities = cardsService.getParams().city;


            step4Vm.terms = false;
            step4Vm.professionalDetails.officePhoneNumber = {};
            step4Vm.professionalDetails.officePhoneNumber.countryCode = cardConfig.initPage.Phone_code;
            step4Vm.professionalDetails.accountHolderDetails = {};
            step4Vm.professionalDetails.accountHolderDetails.mailingAddress = "residential";
            step4Vm.professionalDetails.accountHolderDetails.StatementPreference = "E";
             step4Vm.getTooltipContent();
            getDisclaimer17();

            getRedirectionMessage();
            getBankingDetailWCM();

            pendingApplication = cardsService.getParams().pendingApplication;
            if (pendingApplication) {

                var trackPersonalDetails = cardsService.getApplicationDetail();
                if (trackPersonalDetails) {
                    step4Vm.professionalDetails.accountHolderDetails = {};

                    if (trackPersonalDetails.applicantDetails.professionalDetails.address.city && trackPersonalDetails.applicantDetails.professionalDetails.address.city.length >= 3) {
                        step4Vm.getStatePIN(trackPersonalDetails.applicantDetails.professionalDetails.address.city);
                    }
                    step4Vm.professionalDetails.address.address = trackPersonalDetails.applicantDetails.professionalDetails.address.address;
                    step4Vm.professionalDetails.address.street = trackPersonalDetails.applicantDetails.professionalDetails.address.street;
                    step4Vm.professionalDetails.address.locality = trackPersonalDetails.applicantDetails.professionalDetails.address.locality;

                    cardsService.setParams({ "citySelected": trackPersonalDetails.applicantDetails.professionalDetails.address.city });
                    var citieListProff = {
                        "key": trackPersonalDetails.applicantDetails.professionalDetails.address.city,
                        "value": trackPersonalDetails.applicantDetails.professionalDetails.address.city
                    }
                    if (trackPersonalDetails.applicantDetails.professionalDetails.address.city != "") {


                        step4Vm.cities = [citieListProff, ]
                        step4Vm.professionalDetails.address.city = trackPersonalDetails.applicantDetails.professionalDetails.address.city;
                        step4Vm.professionalDetails.address.pinCode = trackPersonalDetails.applicantDetails.professionalDetails.address.pinCode;
                        step4Vm.professionalDetails.officePhoneNumber.areaCode = trackPersonalDetails.applicantDetails.professionalDetails.officePhoneNumber.areaCode;
                        step4Vm.professionalDetails.officePhoneNumber.number = trackPersonalDetails.applicantDetails.professionalDetails.officePhoneNumber.number;
                    } else { step4Vm.cities = cardsService.getParams().city; }

                    if (step4Vm.professionalDetails.accountHolderDetails.mailingAddress == "" || step4Vm.professionalDetails.accountHolderDetails.mailingAddress == undefined) {

                        step4Vm.professionalDetails.accountHolderDetails = {};
                        step4Vm.professionalDetails.accountHolderDetails.mailingAddress = "residential";



                    } else {
                        step4Vm.professionalDetails.accountHolderDetails.mailingAddress = trackPersonalDetails.applicantDetails.mailingOption;

                    }
                    step4Vm.professionalDetails.alternativeCreditCard = trackPersonalDetails.applicantDetails.alternativeCreditCard;
                    step4Vm.professionalDetails.referralCode = step4Vm.professionalDetails.referralCode;
                    step4Vm.professionalDetails.accountHolderDetails.StatementPreference = "E";
                }

            }

            var professionalDetails = applyNowService.getParams().professionalDetails2;
            if (professionalDetails) {
               if(professionalDetails.address.city)
                {
                step4Vm.getStatePIN(professionalDetails.address.city);
                }
               
                step4Vm.professionalDetails = professionalDetails;

            }


        }


step4Vm.changePinandArea=function(state)
{
    step4Vm.professionalDetails.address.state = state;

    for(var i=0;i<step4Vm.state.length;i++)
    {

        if(step4Vm.state[i].stateKey==state)
        {

    step4Vm.pin =step4Vm.state[i].pinCodes
    step4Vm.areaCode=step4Vm.state[i].stdCodes;
    if(step4Vm.areaCode.length==1)
    {
      step4Vm.professionalDetails.officePhoneNumber.areaCode = step4Vm.areaCode[0];
                    
    }

     if(step4Vm.pin.length==1)
                    {
                            step4Vm.professionalDetails.address.pinCode=step4Vm.pin[0];
                      }

               break;       

        }
    }
  step4Vm.step4Form.state="";
  step4Vm.step4Form.pinCode="";
  step4Vm.step4Form.areaCode="";
}

        step4Vm.getStatePIN = function(city) {
                applyNowService.getStatePIN({ city: city }).then(function(response) {
                    cardsService.errorLogger(response);



                    step4Vm.state=response.data.states;


                  if(response.data.states.length==1)
                  {

                    step4Vm.areaCode = response.data.states[0].stdCodes;
                    step4Vm.pin = response.data.states[0].pinCodes;

                     if(step4Vm.areaCode.length==1)
    {
      step4Vm.professionalDetails.officePhoneNumber.areaCode = step4Vm.areaCode[0];
                    
    }

         if(step4Vm.pin.length==1)
                    {
                            step4Vm.professionalDetails.address.pinCode=step4Vm.pin[0];
                      }
                     step4Vm.professionalDetails.address.state = response.data.states[0].stateKey;

                  }

                  else
                  {

                     step4Vm.changePinandArea(step4Vm.professionalDetails.address.state);

                  }

                  

                    var getLandlineProffesional = step4Vm.areaCode;
                    var length = getLandlineProffesional.toString().length;


                    if (length == "4") {
                        step4Vm.landlinenumber = "7";

                    } else if (length == "3") {
                        step4Vm.landlinenumber = "8";
                    } else {
                        step4Vm.landlinenumber = "6";
                    }


               

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
          
            step4Vm.getTooltipContent=function(){
                 applyNowService.getToolTipContent().then(function(response) {                       
                    if(response.data.toolTips[0].key=='170bab13-0a24-4d39-8e99-a4a6a826befb'){
                        step4Vm.professionalDetails.refCodeContentMessage=response.data.toolTips[0].value;
                    }else{
                        step4Vm.professionalDetails.refCodeContentMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;
                    }                       
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);

                    });
            }


        step4Vm.gotoBack = function() {
                applyNowService.setParams({ professionalDetails2: step4Vm.professionalDetails });
                $state.go('menu.cardProfessional1');
            }
          
             /***Function to show information POP UP***/
	        step4Vm.showInformationPopupRefCode= function() {
	        	var infoPopup = $ionicPopup.show({
					template: '<p>'+ step4Vm.professionalDetails.refCodeContentMessage+'</p>',
					title:'Information',
					scope: $scope,
					cssClass: 'dialog',		
					buttons: [
		            {
		               text: 'Ok'
		            }
					]
				});

	            
	        }


        step4Vm.gotoSubmit = function() {
                if (validateForm()) {
                     utilityService.showSpinner();
                       clickStreamService.clickStreamData = cardsService.getParams().cardName;
                   applyNowService.setParams({ tnc: true });
                    applyNowService.setParams({ pageNo: "2" });
                     applyNowService.setParams({ referralCode: step4Vm.professionalDetails.referralCode });
                    applyNowService.setProfessionalData2(step4Vm.professionalDetails);
                    applyNowService.setParams({ professionalDetails2: step4Vm.professionalDetails });
                    applyNowService.saveApplication(false).then(function(response) {
                        cardsService.errorLogger(response);


                    }, function(error) {
                         utilityService.hideSpinner();

                        utilityService.showErrorMessage(error.responseMessage);
                    });
                    applyNowService.applyCard().then(function(response) {
                            cardsService.errorLogger(response);
                            switch (response.responseCode) {
                                case cardConfig.responseCode.success:
                                  utilityService.hideSpinner();
                                  clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("CRDS_CRDRQSTAPRV_CC_END_NXT_BTN"));
                                    $state.go('menu.cardRequestApprove');

                                    break;
                                case cardConfig.responseCode.failed:
                                 utilityService.hideSpinner();
                                    break;
                                default:
                                 utilityService.hideSpinner();
                                    break;
                            }

                        },
                        function(error) {
                             utilityService.hideSpinner();
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                }


            }
           
        step4Vm.closeJourney = function() {
            applyNowService.setParams({ pageNo: "2" });
            applyNowService.setProfessionalData2(step4Vm.professionalDetails);
            applyNowService.setParams({ professionalDetails2: step4Vm.professionalDetails });

            var journeyConfirmation = {
                cssClass: 'sbi-alert-popup',
                buttons: [{
                    text: cardConfig.buttons.OK_LABEL,
                    type: 'button-positive',
                    onTap: function(e) {
                        cardsService.setParams({ 'pendingApplication': false });
                        $state.go('menu.accountOverviewMyBalance');
                    }
                }]
            };
            var alertObj = {
                template: '<div class="text-align-center font-content roboto-regular" translate="JOURNEY_CLOSE"></div>',
                cssClass: 'sbi-alert-popup',
                buttons: [{
                    text: cardConfig.buttons.CANCEL_LABEL,
                    type: 'button-positive'
                }, {
                    text: cardConfig.buttons.YES_LABEL,
                    type: 'button-positive',
                    onTap: function(e) {
                        journeyConfirmation.template = '<img class="fss-popup-activated-img" src="img/FSS/Approved.svg"><div class="text-align-center font-content sbi-sub-label roboto-regular" translate="JOURNEY_CLOSE_CONFIRM"></div>';
                        applyNowService.saveApplication().then(function(response) {
                            cardsService.errorLogger(response);

                            cardsService.alertModal(journeyConfirmation, null);
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                }]
            };
            cardsService.alertModal(alertObj, function(res) {

            });
        };

        function getDisclaimer17() {

            step4Vm.parseContent = cardsService.getParams().getDisclaimer17;


            $timeout(function() {
                document.getElementById("9d26261e-c612-4d31-8169-e0c8f21842e4").addEventListener("click", function() {

                    var declarationObj = {
                        cssClass: 'sbi-alert-popup',
                        buttons: [{
                            text: cardConfig.buttons.OK_LABEL,
                            type: 'button-positive'
                        }]
                    };

                    applyNowService.getDeclaration().then(function(response) {
                        cardsService.errorLogger(response);
                        declarationObj.template = '<ion-scroll direction="y" class="fss-list-bullet card-scroll-context"><div class="fontSize-subHeading roboto-light  font-dark-grey fss-p-10 ">' + response.data.message + '</div></ion-scroll>';

                        cardsService.alertModal(declarationObj, null);
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);

                    });

                });
            }, 50);


        }
        function getBankingDetailWCM() {           


            $timeout(function() {
                var getElemn = document.getElementById("cards-terms-br-details");
                if (getElemn) {
                getElemn.addEventListener("click", function() {

                    var declarationObj = {
                        cssClass: 'sbi-alert-popup',
                        buttons: [{
                            text: cardConfig.buttons.OK_LABEL,
                            type: 'button-positive'
                        }]
                    };

                    applyNowService.getBankingRelationDeclaration().then(function(response) {
                        cardsService.errorLogger(response);
                        declarationObj.template = '<ion-scroll direction="y" class="fss-list-bullet card-scroll-context"><div class="fontSize-subHeading roboto-light  font-dark-grey fss-p-10 ">' + response.data.message + '</div></ion-scroll>';

                        cardsService.alertModal(declarationObj, null);
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);

                    });

                });
              }
            }, 50);


        }

    

        function getRedirectionMessage() {

            $timeout(function() {

                var getElem = document.getElementById("f0b86a1d-59b9-4463-8a40-bf620d529dfd");
                if (getElem) {

                    getElem.addEventListener("click", function() {

                        var declarationObj = {
                            cssClass: 'sbi-alert-popup',
                            buttons: [{
                                text: cardConfig.buttons.OK_LABEL,
                                type: 'button-positive'
                            }]
                        };

                        floatingMenuService.getTermsAndCondition()
                            .then(function(response) {
                                cardsService.errorLogger(response);
                                declarationObj.template = '<ion-scroll direction="y" class="fss-list-bullet card-scroll-context"><div class="fontSize-subHeading roboto-light  font-dark-grey fss-p-10 ">' + response.data.message + '</div></ion-scroll>';

                                cardsService.alertModal(declarationObj, null);
                            }, function(error) {
                                utilityService.showErrorMessage(error.responseMessage);

                            });

                    });
                }
            }, 50);

            step4Vm.parseContentDisc = cardsService.getParams().getRedirectionMessage;
        }



        //common validation function
        function validateForm() {
            step4Vm.step4Form = {};
            step4Vm.professionalDetails.officePhoneNumber = {};

            if (!step4Vm.professionalDetails.hasOwnProperty('address')) {
                step4Vm.professionalDetails.address = {};
            }
            if (!step4Vm.professionalDetails.hasOwnProperty('officePhoneNumber')) {
                step4Vm.professionalDetails.officePhoneNumber = {};
            }
            if (step4Vm.personalDetails.occupation != 'P') {
                if (step4Vm.validateService.isValidCity(step4Vm.professionalDetails.address.city)) {
                    step4Vm.step4Form.city = step4Vm.validateService.isValidCity(step4Vm.professionalDetails.address.city);
                }
            }
            if (step4Vm.personalDetails.occupation != 'P') {
                if (step4Vm.validateService.isValidState(step4Vm.professionalDetails.address.state)) {
                    step4Vm.step4Form.state = step4Vm.validateService.isValidState(step4Vm.professionalDetails.address.state);
                }
            }

            if (step4Vm.personalDetails.occupation != 'P') {
                if (step4Vm.validateService.isValidPincode(step4Vm.professionalDetails.address.pinCode)) {
                    step4Vm.step4Form.pinCode = step4Vm.validateService.isValidPincode(step4Vm.professionalDetails.address.pinCode);
                }
            }

            if (step4Vm.validateService.isValidBuilding(step4Vm.professionalDetails.address.address)) {
                step4Vm.step4Form.houseAddress = step4Vm.validateService.isValidBuilding(step4Vm.professionalDetails.address.address);
            }

          

            if (step4Vm.personalDetails.occupation != 'P' && !step4Vm.professionalDetails.officePhoneNumber.number) {
				if(step4Vm.professionalDetails.officePhoneNumber.number)
				{
                if (step4Vm.validateService.isValidOfficeNo(step4Vm.professionalDetails.officePhoneNumber.number)) {
                    step4Vm.step4Form.officeNo = step4Vm.validateService.isValidOfficeNo(step4Vm.professionalDetails.officePhoneNumber.number);
                }
				}
            }
           
            if (step4Vm.validateService.isValidProffStreet(step4Vm.professionalDetails.address.street)) {
                step4Vm.step4Form.street = step4Vm.validateService.isValidProffStreet(step4Vm.professionalDetails.address.street);
            }

            if (step4Vm.validateService.isValidLocalityProff(step4Vm.professionalDetails.address.locality)) {
                step4Vm.step4Form.locality = step4Vm.validateService.isValidLocalityProff(step4Vm.professionalDetails.address.locality);
            }

            if (!step4Vm.professionalDetails.accountHolderDetails.StatementPreference) {
                step4Vm.professionalDetails.accountHolderDetails.StatementPreference = "P";
            }

            return (angular.equals({}, step4Vm.step4Form)) ? true : false;
        }

   
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });


    }
]);
