

'use strict';

angularApp.controller('cardRequestApproveController', ["$timeout", "$state", "$scope", "$translate", "applyNowService", "cardConfig", "cardsService", "utilityService","homeScreenService","fTBeneficiaryService","getAccountDetailsService","clickStreamService",
    function($timeout, $state, $scope, $translate, applyNowService, cardConfig, cardsService, utilityService,homeScreenService,fTBeneficiaryService,getAccountDetailsService,clickStreamService) {

      
        var cardApproveVm = this;
      
        function initPage() {

            //Add click stream anupam
            clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("CRDS_CRDRQSTAPRV" + "_" + "CC_END_NXT_BTN"));
            cardApproveVm.showleadReferNo = false;
            cardApproveVm.refered = false;
            getDisclaimerInfo();
            retriewStatusInfo();
            clearApplicationData();
        }

      
        cardApproveVm.checkStatus = function() {
            $state.go('menu.accountOverviewMyBalance');
        }

        function getDisclaimerInfo() {
           
            applyNowService.getDisclaimerInfo().then(function(response) {
                cardsService.errorLogger(response);
                cardApproveVm.parseContent = response.data.message;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        // function retriewStatusInfo() {
        //     applyNowService.applyCardResponse(function(response) {
        //         cardsService.errorLogger(response);
        //         var data = response.data;
        //         cardApproveVm.appNo = data.applicationNumber;
             
        //         cardApproveVm.creditLimit = data.creditLimit;
        //           cardApproveVm.requestReceivedMsg = data.status;
        //         cardApproveVm.requestReceived = data.action;
        //         if (data.action == "Referred" || data.action == "referred") {
        //             cardApproveVm.favIcon = "img/FSS/Referral_2.svg";
        //             cardApproveVm.documentHandoverFlag = true;
        //              utilityService.setCsatJournies('cards');
        //         } else if (data.action == "Soft Approve" || data.action == "soft approve") {
        //             cardApproveVm.favIcon = "img/FSS/Approved.svg";
        //             cardApproveVm.documentHandoverFlag = true;
        //              utilityService.setCsatJournies('cards');
                    
        //         } else if (data.action == "Decline" || data.action == "decline") {
        //             cardApproveVm.favIcon = "img/FSS/sadface.svg";
        //             cardApproveVm.documentHandoverFlag = false;
        //              utilityService.setCsatJournies('cards');
        //         } else {
        //             cardApproveVm.favIcon = "img/FSS/sadface.svg";
        //             cardApproveVm.documentHandoverFlag = false;
        //              utilityService.setCsatJournies('cards');
        //         }

              
        //     });


        // }

        function retriewStatusInfo() {
            applyNowService.applyCardResponse(function (response) {
            cardsService.errorLogger(response);
            var cardname = response.cardname;
            var data = response.data.applicationResponse;
                // var data = {
                //     "applicationNumber": "34897324987",
                //     "status": "Your Application for SBI Elite Advantage Credit Card has been approved in principle.",
                //     "creditLimit": "50000",
                //     "leadReferNo": "654616541646",
                //     "action": "Soft Approve"
                // }
                cardApproveVm.appNo = data.applicationNumber;

                if (!cardApproveVm.appNo || cardApproveVm.appNo == "" || cardApproveVm.appNo == null) {
                    // cardApproveVm.appNo show lead
                    cardApproveVm.showleadReferNo = true;
                    cardApproveVm.leadReferNo = data.leadRefNumber;
                }


                cardApproveVm.creditLimit = data.creditLimit;
                cardApproveVm.requestReceivedMsg = data.applicationStatus;
                cardApproveVm.requestReceived = data.applicationStatusDesc;
                if (data.applicationStatusDesc == "Curing Required " || data.applicationStatusDesc == "Soft Decision - Referred" || data.applicationStatusDesc == "Referred" || data.applicationStatusDesc == "referred" ||  data.applicationStatusDesc.includes("Curing")) {
                    cardApproveVm.favIcon = "img/mf/cap_Approved.svg";
                    cardApproveVm.documentHandoverFlag = false;
                    cardApproveVm.requestReceived = "Approval Pending";
                    cardApproveVm.requestReceivedMsg = "Thanks for your Application for "+ cardname +" Credit Card ";
                    cardApproveVm.refered = true;
                    //utilityService.setCsatJournies('cards');
                } else if (data.applicationStatusDesc == "Soft Decision - Approved" || data.applicationStatusDesc == "Soft Approve" || data.applicationStatusDesc == "soft approve" || data.applicationStatusDesc == "Approved" || data.applicationStatusDesc == "approved" || data.applicationStatusDesc.includes("Approve")) {
                    cardApproveVm.favIcon = "img/mf/cap_Approved.svg";
                    cardApproveVm.documentHandoverFlag = true;
                    cardApproveVm.requestReceived = "Approved";
                    cardApproveVm.requestReceivedMsg = "Your Application for "+ cardname +" Credit Card has been approved in principle."

                } else if (data.applicationStatusDesc == "Decline" || data.applicationStatusDesc == "decline" || data.applicationStatusDesc == "Final Decline" || data.applicationStatusDesc.includes("Decline")) {
                    cardApproveVm.favIcon = "img/FT/BhimUpi/errorSymbol.svg";
                    cardApproveVm.documentHandoverFlag = false;
                    cardApproveVm.requestReceived = "Decline";
                   // cardApproveVm.requestReceivedMsg = "Your Application for "+ cardname +" Credit Card has been approved in principle."
                    cardApproveVm.requestReceivedMsg = "Your application has been declined, please contact SBI Cards team.";
                    //cardApproveVm.refered = true;
                } else {
                    cardApproveVm.favIcon = "img/FT/BhimUpi/errorSymbol.svg";
                    cardApproveVm.documentHandoverFlag = false;
                    cardApproveVm.requestReceivedMsg = "";
                    //utilityService.setCsatJournies('cards');
                }

            });
            // applyNowService.applyCardResponse(function(response) {
            //     cardsService.errorLogger(response);
            //     var data = response.data;
            //     cardApproveVm.appNo = data.applicationNumber;
             
            //     cardApproveVm.creditLimit = data.creditLimit;
            //       cardApproveVm.requestReceivedMsg = data.status;
            //     cardApproveVm.requestReceived = data.action;
            //     if (data.action == "Referred" || data.action == "referred") {
            //         cardApproveVm.favIcon = "img/FSS/Referral_2.svg";
            //         cardApproveVm.documentHandoverFlag = true;
            //          utilityService.setCsatJournies('cards');
            //     } else if (data.action == "Soft Approve" || data.action == "soft approve") {
            //         cardApproveVm.favIcon = "img/FSS/Approved.svg";
            //         cardApproveVm.documentHandoverFlag = true;
            //          utilityService.setCsatJournies('cards');
                    
            //     } else if (data.action == "Decline" || data.action == "decline") {
            //         cardApproveVm.favIcon = "img/FSS/sadface.svg";
            //         cardApproveVm.documentHandoverFlag = false;
            //          utilityService.setCsatJournies('cards');
            //     } else {
            //         cardApproveVm.favIcon = "img/FSS/sadface.svg";
            //         cardApproveVm.documentHandoverFlag = false;
            //          utilityService.setCsatJournies('cards');
            //     }
            // });


        }

        
        cardApproveVm.goBack = function() {
            homeScreenService.ishamburgerMenuRO=false;
            fTBeneficiaryService.isCreditCardFlag=true;
            getAccountDetailsService.setRewTab = true;
            getAccountDetailsService.tabIndex.tabIndex=5;
            $state.go('menu.accountOverviewMyBalance');
        }

        cardApproveVm.getDocuments = function() {
            $state.go('menu.ccdocumentCollection');
        }
        

        function clearApplicationData() {
            applyNowService.resetParams();
            cardsService.setParams({ 'pendingApplication': false });
        }

        
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

    }
]);
