
'use strict';

angularApp.service('cardCompareService', ['cardConfig', '$q', 'AdapterUtils','loggedInUserService',
    function(cardConfig, $q, AdapterUtils,loggedInUserService) {

        var cardCompareService = this;
        var params = {};
        cardCompareService.accoutId = '';
        cardCompareService.disableBlock = '';
        cardCompareService.policyWrapper = [];
        cardCompareService.shikharFlag = '';
        cardCompareService.getCardComparison = function(requestParams, callback) {
        if(loggedInUserService.isLoggedInDetails.isLoggedIn){
            
                var q = $q.defer();
                AdapterUtils.postData(cardConfig.adapterURL.getCardComparison[0], requestParams, true).then(
                    function(response) {

                        q.resolve(response);
                    },
                    function(error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            
        }else{
                var q = $q.defer();
                AdapterUtils.postData(cardConfig.adapterURL.getCardComparisonPreLogin[0], requestParams, true).then(
                    function(response) {

                        q.resolve(response);
                    },
                    function(error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            }
        };
        

        // service to get shikhar card eligibility
        cardCompareService.getShikharEligibilityCheck = function(){
          var q = $q.defer();
            AdapterUtils.getData("adapters/CardsAdapterv2/getShikharEligibilityCheck", null, false).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        }

        cardCompareService.setParams = function(obj) {
            var setParams = angular.extend(params, obj);
        }

        cardCompareService.getParams = function() {
            return params;
        }

        cardCompareService.resetParams = function() {
            params = {};
        }

        return cardCompareService;
    }
]);
