angularApp.directive('fssFooterTmpl', function() {
    'use strict';
    return {
        restrict: 'E',
        scope: {
            goback: "&",
            gonext: "&",
            showback: '=',
            shownext: '=',
            disableback: "=",
            disablenext: "=",
            aofooter: "=",
			backenabled: "="
        },
        require: '?ngModel',
        transclude: false,
        replace: false,
        templateUrl: 'pages/cards/common/directives/templates/fssFooterTmpl.html',
        link: function(scope, element, attrs, ngModel) {
			scope.nextText = (attrs.nexttext) ? attrs.nexttext : 'NEXT';
			scope.backText = (attrs.backtext) ? attrs.backtext : 'BACK';
            scope.goBack = function() {
                scope.goback();
            }
            scope.goNext = function() {
                scope.gonext();
            }
        },
    };
});