angularApp.directive('searchableDropDown', function() {
    'use strict';
    return {
        restrict: 'EAC',
        scope: {
            label: '@',
            labelField: '@',
            provider: '=',
            ngModel: '=?',
            ngValue: '=?',

        },
        require: '?ngModel',
        transclude: false,
        replace: false,
         templateUrl: 'pages/cards/common/directives/templates/searchableDropDown.html',
        link: function(scope, element, attrs, ngModel) {
            scope.ngValue = attrs.ngValue||'company name';

            scope.selecionar = function(item) {
                ngModel.$setViewValue(item);
                scope.showHide = false;
            };

            element.bind('click', function() {
                // element.find('input').focus();
            });

            scope.open = function() {

                scope.ngModel = "";
                return scope.showHide = !scope.showHide;
            };

            scope.onKeyDown = function() {
                scope.showHide = true;
                if (!scope.ngModel) {
                    scope.showHide = false;
                }
            }

            scope.$watch('ngModel', function(newValue) {
                if (newValue)
                    element.find('input').val(newValue[scope.labelField]);

            });
        },
    };
});
