
    'use strict';

    angularApp.controller('cardServicesController', ["$timeout",
        "$state",
        "$scope",
        "$stateParams",
        "payNowServices",
        "cardsService",
        "$ionicBackdrop",
        "$ionicPopover",
        "$ionicScrollDelegate",
        "cardConfig",
        "floatingMenuService", "utilityService",
        "cardCompareService","linkCardService","$ionicPopup",
		"homeScreenService","fTBeneficiaryService","getAccountDetailsService",

        function($timeout,
            $state,
            $scope,
            $stateParams,
            payNowServices,
            cardsService,
            $ionicBackdrop,
            $ionicPopover,
            $ionicScrollDelegate,
            cardConfig,
            floatingMenuService, utilityService,
            cardCompareService,linkCardService,$ionicPopup,homeScreenService,fTBeneficiaryService,getAccountDetailsService) {

        //functions, variables that can be accessed from the HTML come here
        var cardServicesVm = this;
        var toggleAddon = false;
        //Entry point   
        function initPage(stateParams) {
            utilityService.showSpinner();
            payNowServices.getRedirectUrls().then(function(response) {
                              
                    payNowServices.links=JSON.parse(response.data.urls);
                     utilityService.hideSpinner();


                }, function(error) {
                    utilityService.hideSpinner();
                });
            cardServicesVm.cardDetails = {};
            cardServicesVm.hasAddonCards = false;
            cardServicesVm.getLinkedCards = cardsService.getCardList();
			cardServicesVm.showDelinkCards = true;

            cardsService.setCardList(cardServicesVm.getLinkedCards);
            cardServicesVm.getLinkedCards = cardsService.getCardList();


            if (cardsService.getParams().hasOwnProperty('primaryCardSelected')) {
                cardServicesVm.selectedIndex = cardServicesVm.id = cardsService.getParams().primaryCardSelected || 0;
            } else {
                cardServicesVm.selectedIndex = cardServicesVm.id = cardsService.getSelectedCard() || 0;
            }

            cardServicesVm.updateCardDetail(cardServicesVm.id);

            cardServicesVm.selectedCardNo = cardServicesVm.getLinkedCards[cardServicesVm.selectedIndex]['cardNumber'];
            cardServicesVm.accountId = cardServicesVm.getLinkedCards[cardServicesVm.selectedIndex]['accountId'];
            cardCompareService.accountId = cardServicesVm.accountId;
            cardServicesVm.cardDetails = {};
            cardServicesVm.cardDetails = cardServicesVm.getLinkedCards[cardServicesVm.selectedIndex];
            cardCompareService.policyWrapper = cardServicesVm.cardDetails.policyWrapper;
            cardServicesVm.policyWrapper = [];
            cardServicesVm.policyWrapper = cardCompareService.policyWrapper;
            if (cardServicesVm.policyWrapper.atmPinReplacement === "Approved") {
                cardServicesVm.showManagePIN = true;
            } else {
                cardServicesVm.showManagePIN = false;
            }

              if (cardServicesVm.policyWrapper.cardHotlist === "Approved") {
                cardServicesVm.showBlockCard = true;
            } else {
                cardServicesVm.showBlockCard = false;
            }
            if (cardServicesVm.policyWrapper.rewardCatalogue === "Approved" && cardServicesVm.policyWrapper.rewardsRedemption === "Approved") {
                cardServicesVm.showRewards = true;
            } else {
                cardServicesVm.showRewards = false;
            }
            // if (cardServicesVm.policyWrapper.activateInternationalUsage === "Approved") {
            //     cardServicesVm.showInternationalusage = true;
            // } else {
            //     cardServicesVm.showInternationalusage = false;
            // }
            if (cardServicesVm.policyWrapper.reissueReplacementCheck === "Approved") {
                cardCompareService.disableBlock = false;
            } else {
                cardCompareService.disableBlock = true;
            }
            cardsService.setSelectedCard(cardServicesVm.cardDetails.id);
            var creditUtilized = (parseInt(cardServicesVm.cardDetails.credit.available, 10) / parseInt(cardServicesVm.cardDetails.credit.limit, 10)) * 100;
            cardServicesVm.creditUtilized = 100 - (creditUtilized || 0);
           //yono it - 1520
            if(cardServicesVm.creditUtilized < 0)
            {
                 cardServicesVm.creditUtilized = 0;
            }
            var cashUtilized = (parseInt(cardServicesVm.cardDetails.cash.available, 10) / parseInt(cardServicesVm.cardDetails.cash.limit, 10)) * 100;
            cardServicesVm.cashUtilized = 100 - (cashUtilized || 0);
            if(cardServicesVm.cashUtilized < 0)
            {
                 cardServicesVm.cashUtilized = 0;
            }
            //end yono it - 1520

        }

        // update card details for selected card
        cardServicesVm.updateCardDetail = function(cardNum, fromDropDown) {
            if (fromDropDown) {
                cardServicesVm.selectedIndex = cardServicesVm.id;
                cardNum = cardServicesVm.getLinkedCards[cardServicesVm.selectedIndex]['cardNumber'];
                cardServicesVm.accountId = cardServicesVm.getLinkedCards[cardServicesVm.selectedIndex]['accountId'];
                cardCompareService.accountId = cardServicesVm.accountId;
                cardServicesVm.cardDetails = cardServicesVm.getLinkedCards[cardServicesVm.selectedIndex];
                cardCompareService.policyWrapper = cardServicesVm.cardDetails.policyWrapper;
                cardServicesVm.policyWrapper = [];
                cardServicesVm.policyWrapper = cardCompareService.policyWrapper;
                if (cardServicesVm.policyWrapper.atmPinReplacement === "Approved") {
                    cardServicesVm.showManagePIN = true;
                } else {
                    cardServicesVm.showManagePIN = false;
                }
                if (cardServicesVm.policyWrapper.rewardCatalogue === "Approved" && cardServicesVm.policyWrapper.rewardsRedemption === "Approved") {
                    cardServicesVm.showRewards = true;
                } else {
                    cardServicesVm.showRewards = false;
                }
                // if (cardServicesVm.policyWrapper.activateInternationalUsage === "Approved") {
                //     cardServicesVm.showInternationalusage = true;
                // } else {
                //     cardServicesVm.showInternationalusage = false;
                // }
                if (cardServicesVm.policyWrapper.reissueReplacementCheck === "Approved") {
                    cardCompareService.disableBlock = false;
                } else {
                    cardCompareService.disableBlock = true;
                }
                var creditUtilized = (parseInt(cardServicesVm.cardDetails.credit.available, 10) / parseInt(cardServicesVm.cardDetails.credit.limit, 10)) * 100;
                cardServicesVm.creditUtilized = 100 - creditUtilized;
                var cashUtilized = (parseInt(cardServicesVm.cardDetails.cash.available, 10) / parseInt(cardServicesVm.cardDetails.cash.limit, 10)) * 100;
                cardServicesVm.cashUtilized = 100 - cashUtilized;
                cardsService.setSelectedCard(cardServicesVm.cardDetails.id);
                var responseData = {
                    primaryCardSelected: cardServicesVm.selectedIndex
                }

                cardsService.setParams(responseData);
                var addOnCardPayload = {
                    "cardNumber": cardNum
                    //"accountId": cardCompareService.accountId
                };

                payNowServices.getAddOnCards(addOnCardPayload).then(function(response) {
                    cardsService.errorLogger(response);
                    // cardServicesVm.cardDetails.addonCards = response.data.cards;

                    if (response.data && response.data.cards) {
                        cardsService.setParams({ "addOnCards": response.data.cards || [] });

                          cardServicesVm.cardDetails.addonCards = cardsService.getParams().addOnCards;
                          payNowServices.setaddonCards(cardServicesVm.cardDetails.addonCards);
                          cardServicesVm.addonCards = cardServicesVm.cardDetails.addonCards;

                          cardServicesVm.counter =0 ;
                          for(var s=0; s< cardServicesVm.addonCards.length;s++){
                            if(cardServicesVm.addonCards[s].isAddOnCardDetailEnabled === true){
                            cardServicesVm.counter = cardServicesVm.counter + 1;
                          }
							}
                         cardsService.getSetCardDetail(cardServicesVm.cardDetails, cardServicesVm.selectedIndex);
                    }

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

            else
            {
                       cardServicesVm.cardDetails.addonCards = cardsService.getParams().addOnCards;
                        payNowServices.setaddonCards(cardServicesVm.cardDetails.addonCards);
                        cardServicesVm.addonCards = cardServicesVm.cardDetails.addonCards;

                        cardServicesVm.counter =0 ;
                        for(var m=0; m< cardServicesVm.addonCards.length;m++){
                            if(cardServicesVm.addonCards[m].isAddOnCardDetailEnabled === true){
                                cardServicesVm.counter = cardServicesVm.counter + 1;
                             }
                         }
                              cardsService.getSetCardDetail(cardServicesVm.cardDetails, cardServicesVm.selectedIndex);
            }

        }

        // go to home
        cardServicesVm.goBackHome = function() {
            $state.go('menu.accountOverviewMyBalance');
        };

        // go to card payment page
        cardServicesVm.goToCardPayment = function(index) {
             utilityService.showSpinner();
            payNowServices.getUserAccounts({}).then(function(response) {

                cardsService.errorLogger(response);
                if (response.data && response.data.beneficiaryList && response.data.beneficiaryList.ownAccounts) {
                    cardsService.setParams({ "paymentAccounts": response.data.beneficiaryList.ownAccounts });
                    utilityService.hideSpinner();
					cardsService.getSetCardDetail(cardServicesVm.cardDetails, index);
                    $state.go('menu.cardPayment');
                }
            }, function(error) {
                  utilityService.hideSpinner();
                utilityService.showErrorMessage(error.responseMessage);
            });

        };

        // group visibility toggle function
        cardServicesVm.isGroupShown = function() {

            return toggleAddon;
        };

        // group toggle function
        cardServicesVm.toggleGroup = function() {
            if (toggleAddon) {
                toggleAddon = false;
                $timeout(function() {
                    $ionicScrollDelegate.$getByHandle('mainScroll').scrollTop(true);
                }, 100)
            } else {
                toggleAddon = true;
                $timeout(function() {
                    $ionicScrollDelegate.$getByHandle('mainScroll').scrollBottom(true);
                }, 100)

            }
        };

        // floating menu open event handler
        $scope.$on('floating-menu:open', function(event) {
            var elem = document.querySelectorAll('#floating-backdrop');
            for (var j = 0; j < elem.length; j++) {
                elem[j].className = '';
                elem[j].className = 'backdrop visible active';
            }

        });

        // floating menu close event handler
        $scope.$on('floating-menu:close', function(event) {
            var elem = document.querySelectorAll('#floating-backdrop');
            for (var j = 0; j < elem.length; j++) {
                elem[j].className = '';
                elem[j].className = 'backdrop';
            }
        });

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.enter', function() {
            initPage();
        });
		
		cardServicesVm.toRewards = function() {
			$state.go("menu.rewards");
		};
		
		cardServicesVm.toBlockResetCard= function() {
			$state.go("menu.selectCardBlockHotlist");
		};
		
		cardServicesVm.gotransactions = function(index){
           $state.go('menu.cardTransactions');  
        };
		
		cardServicesVm.toInternationalUse = function(index){
           $state.go('menu.internationalUsageActivate');  
        };

        cardServicesVm.KnowMoreClick = function(){
            var comingsoonPopup = $ionicPopup.alert({
                template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                    + "Coming Soon" + '</div></div></div></div></div></div>',
                cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                buttons: [
                    {
                        text: 'OK',
                        type: 'button-positive',
                        onTap: function (e) {
                            comingsoonPopup.close();
                        }
                    }
                ]
            });
        };
		
		cardServicesVm.deLinkCards = function () {
				var popuptxt = '<p><div class=""><img class="cardpopupStyleM5" src="img/yc_Group.svg"</div>';
				var popuptxt1 = '<div class="sbi-sub-label delinkPopup" translate="DELINK_MSG_1"></div>';
				var popuptxt2 = '\n\</br><div class="sbi-sub-label delinkPopup" translate="DELINK_MSG_2"></div></p>';
				var delinkpopup = $ionicPopup.confirm({
                    template: popuptxt+''+popuptxt1+''+popuptxt2,
                    cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogDelink',
                    scope: $scope,
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function (e) {
                            delinkpopup.close();
                            e.preventDefault();
                        }
                    },
                    {
                        text: 'Delink',
                        type: 'button-positive',
                        onTap: function (e) {
                            
                            linkCardService.deLink({}).then(function (response) {
								cardsService.errorLogger(response);
								switch (response.responseCode) {
									case cardConfig.responseCode["success"]:
										if (response.responseMessage) {
											cardServicesVm.showDelinkCards = false;
											var delinkSuccpopup = $ionicPopup.confirm({
												template: '<p><div class=""><img class="cardpopupStyleM5" src="img/YCGroup5.svg"</div><div class="sbi-sub-label delinkPopup">' + response.data.responseMessage + '</div> \n\</p>',
												cssClass: 'removePopup-head popupWidth90 padding4 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter dialogDelink',
												scope: $scope,
												buttons: [{
													text: 'Ok',
													type: 'button-positive',
													onTap: function (c) {														
														delinkSuccpopup.close();         
                                                        homeScreenService.ishamburgerMenuRO=false;
                                                        fTBeneficiaryService.isCreditCardFlag=true;
                                                        getAccountDetailsService.setRewTab = true;
                                                        getAccountDetailsService.tabIndex.tabIndex=5;
                                                        $state.go('menu.accountOverviewMyBalance');  
														c.preventDefault();   
													}
												}]
											});
										}
									break;
									case cardConfig.responseCode.failed:
									 utilityService.hideSpinner();
									break;
									default:
									 utilityService.hideSpinner();
									break;
								}
							}, function (error) {
								utilityService.showErrorMessage(error.responseMessage);
							});
							
                            delinkpopup.close();
                            e.preventDefault();   
                        }
                    }]
				});
			
			
			
            
        };
		
        cardServicesVm.toResetPin = function() {
           floatingMenuService.isResendExhaust = false;
            floatingMenuService.isTextExhaust = false;
            floatingMenuService.setIsResend(true);
            if (cardServicesVm.addonCards && cardServicesVm.addonCards.length >= 1) {
                $state.go("menu.resetPin");
            } else {
              if(cardServicesVm.cardDetails.isManagePinEnabled){
                  //send otp for reset pin
                  var sendOTPPayload = {
                    "cardNumber": cardServicesVm.cardDetails['cardNumber'],
                    // "mobileNumber": cardServicesVm.cardDetails['regMobileNumber'],
                    // "email": cardServicesVm.cardDetails['regEmail'],
                    "accountId" :cardServicesVm.cardDetails['accountId'],
                    "isResend" : "false"
                };

                floatingMenuService.setParams(sendOTPPayload);

                floatingMenuService.sendOTP(sendOTPPayload)
                .then(function(response) {
                    cardsService.errorLogger(response);
                    switch (response.data.responseCode) {
                        case cardConfig.responseCode.dataSuccess:
                        floatingMenuService.setParams({ cardNumber: sendOTPPayload.cardNumber });
                        $state.go("menu.resendOTPPin");
                        break;
						case cardConfig.responseCode.failed:
						 utilityService.hideSpinner();
						break;
						default:
						 utilityService.hideSpinner();
						break;
                    }
                },
                function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            else {
                $state.go("menu.resetPin");
            }


        }
    };

}
]);
