(function() {
    'use strict';

    angularApp.controller('selectInternationalUsageController', ["$state",
        "$scope",
        "$stateParams",
        "cardsService",
        function($state,
            $scope,
            $stateParams,
            cardsService) {

            //functions, variables that can be accessed from the HTML come here
            var selectInternationalUsageVm = this;
            //private methods section start
            function initPage(stateParams) {
                selectInternationalUsageVm.cardList = [];
                selectInternationalUsageVm.card = cardsService.getSetCardDetail();
                selectInternationalUsageVm.cardList.push(cardsService.getSetCardDetail());
                if (cardsService.getSetCardDetail().hasOwnProperty('cardDetails')) {
                    selectInternationalUsageVm.cardList.concat(cardsService.getSetCardDetail().cardDetails.addonCards);
                }
            }
            //redirect to activate page
            selectInternationalUsageVm.goToActivate = function() {
                    $state.go('menu.internationalUsageActivate', {
                        cardNumber: selectInternationalUsageVm.card.cardNumber
                    });
                }
                //actions to done everytime the view is shown

            $scope.$on('$ionicView.beforeEnter', function(event, data) {
                initPage(data.stateParams);
            });

        }
    ]);
})();
