/*
	Module Name  : Cards,
	File Name    : paymentSuccess.js,
	Description	 : controller function for payment success Controller function
*/

'use strict';

angularApp.controller('paymentSuccessfulController', ["$state",
    "$scope",
    "$translate",
    "payNowServices",
    "cardConfig",
    "cardsService",
    "getAccountDetailsService",
    "$filter",

    function($state,
        $scope,
        $translate,
        payNowServices,
        cardConfig,
        cardsService,getAccountDetailsService,$filter) {

        //functions, variables that can be accessed from the HTML come here
        var paymentSuccessfulVm = this;
        //Entry point
        function initPage() {
            var params = payNowServices.getParams();
            params['cardType'] = cardsService.getSetCardDetail().cardType;
            params.cardNumber=$filter('cardmask')(params.cardNumber, 'X', 4);
            // resendOTPPinVm.mobileNumber = $filter('cardmask')(applyNowService.getParams().eapplyMobileNumber, 'X', 4);
            paymentSuccessfulVm.translationData = params;

            if (params.success) {
                paymentSuccessfulVm.successful = true;
            } else {
                paymentSuccessfulVm.successful = false;
            }
        }
        // go to card account overview page

        paymentSuccessfulVm.goSuccessMsg = function() {
                 getAccountDetailsService.tabIndex.tabIndex=5;
                         $state.go('menu.accountOverviewMyBalance');

                     }
        //actions to done everytime the view is shown
        
        $scope.$on('$ionicView.enter', function(event, data) {
            initPage();            
        });
    }
]);
