'use strict';

angularApp.controller('chatBotController', 
					["$timeout",
					 "$state",
					 "$location",
					 "$scope",
					 "$rootScope",
					 "utilityService",
					 "$ionicPopup",
					 "$ionicSideMenuDelegate",
					 "$sce",
					 "$compile",
					 "chatBotService",
					 "$ionicScrollDelegate",
					 "$window",
					 "homeScreenService",
					 function ($timeout,
					 $state,
					 $location,
					 $scope,
					 $rootScope,
					 utilityService,
					 $ionicPopup,
					 $ionicSideMenuDelegate,
					 $sce,
					 $compile,
					 chatBotService,
					 $ionicScrollDelegate,
					 $window,
					 homeScreenService
					) {
	
	//functions, variables that can be accessed from the HTML come here
	var chatBotVm = this;	
	//private methods section start
						
	function initPage(){
						
		chatBotVm.showBack = false;
		chatBotVm.showNext = true;
		chatBotVm.displaySpinner=true;
		chatBotVm.topButton=true;
		chatBotVm.chatResponse="";
		chatBotVm.textDisabled=true;
		chatBotVm.botResponseSpinner=false;
		chatBotVm.chatSend("!@#HI!@#");
		chatBotVm.heightValue=0;
		chatBotVm.id="";
		chatBotVm.minHeight=30;
		chatBotVm.maxHeight=80;
		chatBotVm.bottom=-8;
		
		
		if(device.platform.toLowerCase()==="ios"){
			if(screen.height===568){
			chatBotVm.id="cbID52";	
			}else{
				chatBotVm.id="cbID45";	
			}
			
		}
		
	}
	chatBotVm.reSize=function(){
		var lines = chatBotVm.chatMsg.split("\n");
		var msg=chatBotVm.chatMsg;
		chatBotVm.chatMsg=msg.replace("^",'').replace("[",'').replace("&",'').replace("]",'').replace("/",'').replace("\\",'');
		
		if(lines.length===2){
		chatBotVm.minHeight=30;	
			angular.element(document.getElementsByClassName('bar-footer')).css("height", 50 + "px");
		}else if(lines.length===3){
		chatBotVm.minHeight=50;	
			angular.element(document.getElementsByClassName('bar-footer')).css("height", 55 + "px");
		}else if(lines.length>=4){
			angular.element(document.getElementsByClassName('bar-footer')).css("height", 75 + "px");
		chatBotVm.minHeight=70;	
		}else{
		chatBotVm.minHeight=chatBotVm.minHeight;	
		}
	
	}
	
	chatBotVm.chatSend=function(msg){
		chatBotVm.topButton=true;
		
		chatBotVm.botResponseSpinner=true;
		var d=new Date();
		chatBotVm.time=d.toLocaleString([],{hour:'2-digit',minute:'2-digit'});
		
		chatBotVm.reciever='<div class="receiver"><div class="row "><div class="col col-80 bg-color-white border-radius5">'+msg+'</div>'
	+'<div class="col col-20"><div><img class="img_size" src="'+$rootScope.profileImageUrl+'"></div></div></div>'
	+'<div class="row"><div class="col col-100"><span class="roboto-regular">'+chatBotVm.time+'</span></div></div></div>';
	
	
	chatBotVm.chatMsg='';
		
		if(msg!="" && msg!="!@#HI!@#" && msg!=undefined){
		chatBotVm.chatResponse=$sce.trustAsHtml(chatBotVm.chatResponse+chatBotVm.reciever);
		$timeout(function() {
                $ionicScrollDelegate.$getByHandle('homeScroll').scrollBottom(true);
				
            }, 0);
		}
		if(msg==="!@#HI!@#"){chatBotVm.chatResponse="";}
		chatBotVm.resp='';
		chatBotVm.btnsResp='';
		chatBotVm.buttons='';
		chatBotVm.hrefs='';
		
		if(msg!="" && msg!=undefined){
			chatBotVm.textDisabled=true;
		chatBotService.chatBotQuery(msg).then(
			function(data) {
				//alert(JSON.stringify(data));
				chatBotVm.displaySpinner=false;
				chatBotVm.textDisabled=false;
				chatBotVm.botResponseSpinner=false;
				
			chatBotVm.resp=data.output.text[0];	
			chatBotVm.btnsResp=data.output.text[1];	
			
			
		chatBotVm.sndr='<div class="sender"><div class="row "><div class="col col-20"><div>'
	+'<img src="img/ChatBot_Icon.svg" style="width:50px;"></div></div><div class="col col-80 bg-color-white border-radius5">'
	+chatBotVm.resp+'</div></div>'
	+'<div class="row"><div class="col col-100"><span class="roboto-regular float_right">'+chatBotVm.time+'</span></div></div></div>';
	 
	if(chatBotVm.btnsResp!="" && chatBotVm.btnsResp!=undefined){
	
	chatBotVm.buttons=chatBotVm.btnsResp
	+'<div class="row"><div class="col col-100"><span class="roboto-regular float_right">'+chatBotVm.time+'</span></div></div>';
	}		
			
	chatBotVm.chatResponse=$sce.trustAsHtml(chatBotVm.chatResponse+chatBotVm.sndr+chatBotVm.buttons);
	  $timeout(function() {
                $ionicScrollDelegate.$getByHandle('homeScroll').scrollBottom();
				
            }, 0);
	
				
			},
			function(error) {
				chatBotVm.displaySpinner=false;
				chatBotVm.textDisabled=false;
				chatBotVm.botResponseSpinner=false;
				utilityService.showErrorMessage(error.responseMessage);
			}
			
	
		);
	}
		
	
		
	}
	
	chatBotVm.chatScrollTop= function(){
		//	alert('top');
			//alert("HH::"+$(window).height());
			//alert("h::"+$window.innerHeight);
			
			/*angular.element($window).bind('resize',function(){$scope.$apply(function(){
				alert("resize::"+$window.innerHeight);
				if($window.innerHeight>=659){chatBotVm.topButton=true;}else{chatBotVm.topButton=false;}
				
			})});
			*/
			
			//var uuu="Top:"+$ionicScrollDelegate.getScrollPosition().top;
			//alert("top::"+$ionicScrollDelegate.getScrollPosition().top)
			
			//alert($ionicScrollDelegate.$getByHandle('homeScroll').getScrollPosition().top);
			$ionicScrollDelegate.$getByHandle('homeScroll').scrollTop();
			chatBotVm.topButton=false;
		}
		/*
		chatBotVm.getPosition=function(){
			chatBotVm.heightValue=($ionicScrollDelegate.$getByHandle('homeScroll').getScrollPosition().top);
		alert("scroll fun"+$ionicScrollDelegate.$getByHandle('homeScroll').getScrollPosition().top);	
		}*/
	/*
	angular.element($window).bind('resize',function(){$scope.$apply(function(){
					chatBotVm.heightValue=($ionicScrollDelegate.$getByHandle('homeScroll').getScrollPosition().top);
		alert("scroll fun resize"+$ionicScrollDelegate.$getByHandle('homeScroll').getScrollPosition().top);	
				
			})});*/
	
	
	chatBotVm.openNewURL=function(url){		
	  window.open(url ,"_system");			
	}

	
	//this function os define to close current view
	chatBotVm.closeView = function(){
		//alert('Coming soon...!');
		if(homeScreenService.isRedirectionFromHomeScreen){
				homeScreenService.isRedirectionFromHomeScreen = false;
				$state.go('menu.homeScreen');
		}
		else{
				$state.go('menu.chatbotfeedback');
		}
	}
	//back to prev page
	chatBotVm.goBacktoPrevious = function(){		
		//$state.go('menu.settings');
	}	
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		//$ionicSideMenuDelegate.canDragContent(false);		
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		chatBotVm.isBackCheck = homeScreenService.isBackCheck;
		homeScreenService.isBackCheck = false;
		//$ionicSideMenuDelegate.canDragContent(false);		
		initPage();
	});
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		//$ionicSideMenuDelegate.canDragContent(true);
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);