'use strict';

angularApp.controller('chatBotSecurityTipController', ["$state",
    "$scope",
    "$timeout",
    "$ionicHistory",
    "$sce",
    "$ionicScrollDelegate",
    "chatBotService",
    "utilityService",

    function ($state,
        $scope,
        $timeout,
        $ionicHistory,
        $sce,
        $ionicScrollDelegate,
        chatBotService,
        utilityService
       ) {
         var chatBotSecurityTipVm = this;

         chatBotSecurityTipVm.goBack =function(){
            $state.go('menu.chatbotlanding');
         }
         chatBotSecurityTipVm.loadSecurityTips = function() {
          chatBotService.getChatbotSecurityTips().then(function(data) {
              chatBotSecurityTipVm.response = data;
              chatBotSecurityTipVm.displaySecurityResponse(chatBotSecurityTipVm.response);
          }, function(error) {
              utilityService.showErrorMessage(error.responseMessage);
          });
        };
        chatBotSecurityTipVm.displaySecurityResponse = function(resp) {
          var response=resp;
          var outputResponse ='<div class="receiver"><div class="row "><div class="col col-100 bg-color-white border-radius5">' + response;
          chatBotSecurityTipVm.chatResponse=$sce.trustAsHtml( outputResponse );
        }
        chatBotSecurityTipVm.scrollToTop = function() {
          $ionicScrollDelegate.$getByHandle('homeScroll').scrollTop();
        };


         chatBotSecurityTipVm.scrollToTop = function() {
           $ionicScrollDelegate.$getByHandle('homeScroll').scrollTop();
         };
         //actions to done everytime the view is shown
         $scope.$on('$ionicView.beforeEnter', function () {
           chatBotSecurityTipVm.loadSecurityTips();

         });

         $scope.$on('$ionicView.beforeLeave', function () {

         });

         return this;
     }
 ]);
