angularApp.service('chatBotService',
	function($q,utilityService,AdapterUtils){
	
	
		var chatBotQuery = function(txt) {	

/* if(txt==='!@#HI!@#'){
	txt="Hi";
}else{txt=txt;}	 */	
			var payLoad={"input": {"text": txt}};
			//alert(JSON.stringify(payLoad));
			var q = $q.defer();
			AdapterUtils.postData("adapters/HelpAdapter/submitChatBotQuery",payLoad,false).then(
				function(response){	
   
					q.resolve(response);
				},
				function(error){
			
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		var submitChatBotFeedback = function(thumbRating,starRating) {
			
			var payLoad={"thumbRating":thumbRating,"starRating":starRating };
			//alert(JSON.stringify(payLoad));
			var q = $q.defer();
			AdapterUtils.postData("adapters/HelpAdapter/submitChatBotFeedback",payLoad,false).then(
				function(response){	
   
					q.resolve(response);
				},
				function(error){
			
					q.reject(error);
				}
				); 
			return q.promise;
			
		};
		
		
		var getCustomerAccountInfo = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/customerAndAccountInfo", {}, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		var getChatbotWhatsNew = function () {
	 	var q = $q.defer();
	 	AdapterUtils.postData("adapters/HelpAdapter/chatbotContent",{},true).then(
			function(response){
			 q.resolve(response.data);
		 },
		 function(error){
			 q.reject(error);
		 });
	 	return q.promise;
 		};

		var getChatbotSecurityTips = function () {
		var q = $q.defer();
		AdapterUtils.postData("adapters/HelpAdapter/chatbotSecurityContent",{},true).then(
			function(response){
			 q.resolve(response.data);
		 },
		 function(error){
			 q.reject(error);
		 });
		return q.promise;
		};
		var getChatResponse = function () {
			var chatResponseOptions ={
								"version" : "1.0.0",
								"id" : "First",
								"title" : "what can I do",
								"request" : "",
								"response" : "For me to help you, please select from below category <br/>",
								"btnResponse":'<input type="button" class="watcanido-btn"  ng-click="chatBotWhatCanIDoVm.gotoLevel2(\'YONO Pay\')"  value="YONO Pay" />'
								+'<input type="button" class="watcanido-btn"  ng-click="chatBotWhatCanIDoVm.gotoLevel2(\'Open Account\')"  value="Open Account"/>'
								+'<input type="button" class="watcanido-btn"  ng-click="chatBotWhatCanIDoVm.gotoLevel2(\'PAPL\')"  value="PAPL"/>'
								+'<input type="button" class="watcanido-btn"  ng-click="chatBotWhatCanIDoVm.gotoLevel2(\'Insurance\')"  value="Insurance"/>'
								+'<input type="button" class="watcanido-btn"  ng-click="chatBotWhatCanIDoVm.gotoLevel2(\'Investments\')"  value="Investments"/>'
								+'<input type="button" class="watcanido-btn"  ng-click="chatBotWhatCanIDoVm.gotoLevel2(\'Credit Card\')"  value="Credit Card"/>'
								+'<input type="button" class="watcanido-btn"  ng-click="chatBotWhatCanIDoVm.gotoLevel2(\'Shop\')"  value="Shop"/>'
								+'<input type="button" class="watcanido-btn"  ng-click="chatBotWhatCanIDoVm.gotoLevel2(\'Book & Order\')"  value="Book & Order"/>',
								"children" : [{

												"id" : "YONO Pay",
												"request" : "I want to use YONO Pay<br/>",
												"response" : "YONO Pay provides many convenient ways to transfer your funds. <br/	><br/>Please select from below category<br/>",
												"btnResponse" : '<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Quick Transfer via Account Number\')"' +' value="Quick Transfer via Account Number" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Quick Transfer via Mobile No & MMID\')"' +' value="Quick Transfer via Mobile No & MMID" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Transfer to Own Account\')"' +' value="Transfer to Own Account" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Transfer to SBI Account of Others\')"' +' value="Transfer to SBI Account of Others" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Transfer to Other Banks Account\')"' +' value="Transfer to Other Banks Account" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Pay Utility Bill\')"' +' value="Pay Utility Bill" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Send/Receive using UPI/VPA/Contacts\')"' +' value="Send/Receive using UPI/VPA/Contacts" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Scan QR and Make Payment\')"' +' value="Scan QR and Make Payment" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Payment to Phonebook Contacts\')"' +' value="Payment to Phonebook Contacts" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Contribute to Existing NPS Account\')"' +' value="Contribute to Existing NPS Account" />',
												"children" : [
																{
																	"id" : "Quick Transfer via Account Number",
																	"request" : "I want to transfer funds using Quick Transfer via Account Number<br/>",
																	"response" : "You can transfer fund quickly ( without adding beneficiary).<br><br> To use this service please follow the steps- <br><br><b>Login in App >> Click on \"YONO Pay\" Tab >> Click on \"Quick Transfer\" >> Put your Profile password >> Select via Account >> Select other bank Account/SBI Account</b><br/>"
																},
																{
																	"id" : "Quick Transfer via Mobile No & MMID",
																	"request" : "I want to transfer funds using Quick Transfer via Mobile No & MMID<br/>",
																	"response" : "You can transfer fund quickly via Mobile number & MMID ( without adding beneficiary).<br><br>To use this service please follow the steps- <b><br><br>Login in App >> Click on \"YONO Pay\" Tab >> Click on \"Quick Transfer\" >> Put your Profile password >> Select via Mobile >> Select other bank Account/SBI Account.</b><br>"
																},
																{
																	"id" : "Transfer to Own Account",
																	"request" : "I want to transfer fund to my own account<br/>",
																	"response" : "You can transfer fund to your own account <br><br>To use this service please follow the steps-<br><br><b>Login in App >> Click on \"YONO Pay\" Tab >> Click on \"Bank Account Tab\" >> Click Own SBI Account</b>"
																},
																{
																	"id" : "Transfer to SBI Account of Others",
																	"request" : "I want to transfer fund to SBI account of other people<br/>",
																	"response" : "You can transfer fund to SBI account of other people <br><br>To use this service please follow the steps-<br><br><b>Login in App >> Click on \"YONO Pay\" Tab >> Click on \"Bank Account Tab\" >> Click on \"Other Account\</b>"
																},
																{
																	"id" : "Transfer to Other Banks Account",
																	"request" : "I want to transfer fund to other Banks account <br/>",
																	"response" : "You can transfer fund to other Banks account<br><br>To use this service please follow the steps-<br><br>Login in App >>"
																	+"<b> Click on \"YONO Pay\" Tab >>Click on \"Bank Account Tab\" >> Click on \"Pay a new Beneficiary\" >> Put your Profile Password >> Select via Account >> Select other bank Account/SBI Account</b>"
																},
																{
																	"id" : "Pay Utility Bill",
																	"request" : "I want to pay my utility bills<br/>",
																	"response" : "You can pay utility bill (Mobile Postpaid, broadband, landline, electricity, gas, water etc.) <br><br>"
																								+"To use this service please follow the steps-<br><br>"
																								+"<b>Login in App >> Hamburger Menu >> YONO Pay >> Bill Payment >> Pay & Register </b><br><br>"
																								+"Or <br><br>"
																								+"<b>Login in App >> Click on \"YONO Pay\" Tab >> Quick Payments >> Select Prepaid mobile/SBI credit Card/ DTH recharge /Bill Pay >> Pay & Register</b>"
																},
																{
																	"id" : "Send/Receive using UPI/VPA/Contacts",
																	"request" : "I want to pay/receive money using UPI/VPA/from your contacts<br/>",
																	"response" : "Coming Soon"
																},
																{
																	"id" : "Scan QR and Make Payment",
																	"request" : "I want to Scan the QR and make payment<br/>",
																	"response" : "Coming Soon"
																},
																{
																	"id" : "Payment to Phonebook Contacts",
																	"request" : "I want to make payments to my contacts from phone book<br/>",
																	"response" : "Coming Soon"
																},
																{
																	"id" : "Contribute to Existing NPS Account",
																	"request" : "I want to contribute to an existing National Pension Scheme (NPS )<br/>",
																	"response" : "Coming soon"
																}
															]
											},
											{
												"id" : "Open Account",
												"request" : "I want to open an account",
												"response" : "For me to help you, please select from below category <br/>",
												"btnResponse" : '<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Fixed Deposit\')"' +' value="Fixed Deposit" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Recurring Deposit\')"' +' value="Recurring Deposit" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Create Dream\')"' +' value="Create Dream" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Tax Saver Fixed Deposit\')"' +' value="Tax Saver Fixed Deposit" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'OD against FD\')"' +' value="OD against FD" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'OD against RD\')"' +' value="OD against RD" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'NPS account against RD\')"' +' value="NPS account against RD" />',
												"children" : [
												{
													"id" : "Fixed Deposit",
													"request" : "I want to open a Fixed Deposit account<br/>",
													"response" : "You can open a Fixed Deposit account. <br><br>"
																				+"To use this service please follow the steps-<br><br>"
																				+"<b>Login in App >> Click on Tab \"Deposits\" >> Under \"My Deposits\" >> Click on create a new deposit</b><br><br>"
												},
												{
													"id" : "Recurring Deposit",
													"request" : "I want to open a Reccuring Deposit account<br/>",
													"response" : "You can open a Recurring Deposit account. <br><br>"
																				+"To use this service please follow the steps-<br><br>"
																				+"<b>Login in App >> Click on Tab \"Deposits\" >> Under \"My Deposits\" >> Click on create a create a recurring deposit</b><br><br>"
												},
												{
													"id" : "Create Dream",
													"request" : "I want to start investing in my dreams<br/>",
													"response" : "You can start investing in your dreams<br><br>"
																				+"To use this service please follow the steps-<br><br>"
																				+"<b>Login in App >> Click on Tab \"Deposits\" >> Under \"My Deposits\" >> Click on create a New Dream</b><br><br>"
												},
												{
													"id" : "Tax Saver Fixed Deposit",
													"request" : "I want to open a tax saver Fixed deposit account<br/>",
													"response" : "You can open a tax saver Fixed deposit account<br><br>"
																				+"To use this service please follow the steps-<br><br>"
																				+"<b>Login in App >> Click on Tab \"Deposits\" >> Under \"My Deposits\" >> Click on create a new deposit >> Select the check box  of tax saver FD</b><br><br>"
												},
												{
													"id" : "OD against FD",
													"request" : "I want to open an overdraft account against a fixed account<br/>",
													"response" : "You can open an overdraft account against a fixed account<br><br>"
																				+"To use this service please follow the steps-<br><br>"
																				+"<b>Login in App >> Click on Tab \"Deposits\" >> Under \"My Deposits\" >> Fixed Deposit >> Select one FD >> Avail OD</b><br><br>"
												},
												{
													"id" : "OD against RD",
													"request" : "I want to open an overdraft account against recurring account<br/>",
													"response" : "Coming Soon<br><br>"
												},
												{
													"id" : "NPS account against RD",
													"request" : "I want to open a National Pension Scheme(NPS) account against recurring account<br/>",
													"response" : "Coming Soon<br><br>"
												}
												]
											},
											{
												"id" : "PAPL",
												"request" : "I want to avail Pre approved personal loan(PAPL) facility.",
												"response" : "You can avail Pre approved personal loans(PAPL) in just four clicks <br/><br/>"
																			+"Login in App >> Check if you are having PAPL offer banner on the landing page>> Click on PAPL banner >> A screen will open which will display the maximum loan amount and loan term offered to the you >> This is an editable field where you can change the loan amount and loan term (within the maximum offered loan amount and loan term) according to your requirement.<br/><br/>"
																			+"The EMI amount will be shown as per the amount of loan availed and Rate of Interest applicable for the loan offered will also be displayed in the same screen.<br/><br/>"
																			+"On clicking “next” , you will get a new screen where you have to select your EMI/SI date>> On selecting the EMI/SI date, you will be prompted to move to next screen wherein the detailed terms and conditions of the loan will be displayed>>you have to read the terms and conditions by scrolling the screen to the bottom>> at the lower part of the screen, you will be prompted to accept the terms and conditions by clicking the check box and confirm >> On confirmation, you will receive an OTP on your mobile registered with the Bank and after entering that OTP and clicking next button, you will get a congratulation message that your loan account has been successfully created and that the proceeds have been credited to savings account.<br/><br/>"
																			+"You can check your new PAPL account opened through this path: hamburger menu >> Relationships >> Loans",
												"btnResponse" :"",
												"children" :[]
											},
											{
												"id" : "Insurance",
												"request" : "I want to avail Insurance facility.",
												"response" : "For all your Insurance needs, say Hello to YONO!  You can avail Insurance plans for life cover, health, motor, travel, home and personal accident cover. You can also link your existing SBI Life policy and manage it on the go! <br/><br/>"
																			+"<b>Login >> Go to Insurance >> Buy a Policy</b><br/><br/>"
																			+"<b>Login >> Go to Hamburger Menu >> Insure</b><br/><br/>",
												"btnResponse" :"",
												"children" :[]
											},
											{
												"id" : "Investments",
												"request" : "I want to start Investing.",
												"response" : "Experience the ease of investments on YONO. You can invest in Mutual Funds and manage your demat & trading a/c. Beginners can also learn about investing.<br/><br/>"
																			+"<b>Login >> Go to Investments</b><br/><br/>"
																			+"<b>Login >> Go to Hamburger Menu >> Invest</b><br/><br/>",
												"btnResponse" :"",
												"children" :[]
											},
											{
												"id" : "Credit Card",
												"request" : "I want to avail Credit Card facility.",
												"response" : "Pick the best suited Credit Card from an array of 18 variants available on YONO and go for hassle-free digital experience. You can also link your existing SBI Credit Card and enjoy our seamless services like bill payment, manage PIN or Rewards, International usage & more.<br/><br/>"
																			+"<b>Login >> Go to Cards </b><br/><br/>"
																			+"<b>Login >> Go to Hamburger Menu >> Cards</b><br/><br/>",
												"btnResponse" :"",
												"children" :[]
											},
											{
												"id" : "Shop",
												"request" : "I want to explore Shop.",
												"response" : "For me to help you, please select from below category <br/>",
												"btnResponse" : '<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Shop\')"' +' value="Shop" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Book an automobile\')"' +' value="Book an automobile" />',

												"children" :[
													{
														"id" : "Shop",
														"request" : "I want to explore shop<br/>",
														"response" : "You can Shop for categories like Fashion, Lifestyle, Jewellery, Health, Fitness , Gifting, Gift Cards,  Home Furnishing, Grocery, General Merchandise, Learning, Online Magazines, Baby Care, pharmacy or Agricultural products, Apparels, footwear etc.<br><br>"
																					+"To use this service please follow the steps-<br><br>"
																					+"<b>Login in App >> Click on Shop tab</b>"


													},
													{
														"id" : "Book an automobile",
														"request" : "I want to Book an automobile<br/>",
														"response" : "You can Book an automobile from merchants like Tata, Mahindra, Hyundai and Ford.<br><br>"
																					+"To use this service please follow the steps-<br><br>"
																					+"<b>Login in App >> Click on Shop Tab >> Goto Automobile Category</b><br/>"+"OR<br/>"
																					+"<b>Login in App >> Click on Hamburger Menu >> Goto Automobile Category</b>"

													},
												]
											},
											{
												"id" : "Book & Order",
												"request" : "I want to explore Book & Order category.",
												"response" : "For me to help you, please select from below category <br/>",
												"btnResponse" : '<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Flights & Buses\')"' +' value="Flights & Buses" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Food\')"' +' value="Food" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Holidays\')"' +' value="Holidays" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Best Offers\')"' +' value="Best Offers" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Entertainment\')"' +' value="Entertainment" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Book Deals\')"' +' value="Book Deals" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Cabs & Car Rentals\')"' +' value="Cabs & Car Rentals" />'

												+'<input type="button" class="watcanido-btn1"'
												+'ng-click="chatBotWhatCanIDoDetailVm.gotoLevel3(\'Hospitality & Hotels\')"' +' value="Hospitality & Hotels" />',

												"children" :[
													{
														"id" : "Flights & Buses",
														"request" : "I want to book a Flight/Bus ticket<br/>",
														"response" : "You can book flights or buses.<br><br>"
																					+"To use this service please follow the steps-<br><br>"
																					+"<b>Login in App >> Click on Book & Order Tab >> Goto Flights & Bus category</b><br/>"+"OR<br/>"
																					+"<b>Login in App >> Click on Hamburger Menu >> Goto Flights & Bus category</b>"

													},
													{
														"id" : "Food",
														"request" : "I want to order Food<br/>",
														"response" : "You can order Food online or book a table with easydiner<br><br>"
																					+"To use this service please follow the steps-<br><br>"
																					+"<b>Login in App >> Click on Book & Order Tab >> Goto Food category<br/></b>"+"OR<br/>"
																					+"<b>Login in App >> Click on Hamburger Menu >> Goto Food category</b>"

													},
													{
														"id" : "Holidays",
														"request" : "I want to book holiday packages<br/>",
														"response" : "You can book holiday packages<br><br>"
																					+"To use this service please follow the steps-<br><br>"
																					+"<b>Login in App >> Click on Book & Order Tab >> Goto Holidays<br/></b>"+"OR<br/>"
																					+"<b>Login in App >> Click on Hamburger Menu >> Goto Holidays</b>"

													},
													{
														"id" : "Best Offers",
														"request" : "I want to explore Best Offers<br/>",
														"response" : "You can explore best offers on YONO <br><br>"
																					+"To use this service please follow the steps-<br><br>"
																					+"<b>Login in App >> Click on Book & Order Tab >> Goto Best Offers<br/></b>"+"OR<br/>"
																					+"<b>Login in App >> Click on Hamburger Menu >> Goto Best Offers</b>"

													},
													{
														"id" : "Entertainment",
														"request" : "I want to explore Entertainment category<br/>",
														"response" : "You can book movie tickets on yono through Book my Show<br><br>"
																					+"To use this service please follow the steps-<br><br>"
																					+"<b>Login in App >> Click on Book & Order Tab >> Goto Entertainment<br/></b>"+"OR<br/>"
																					+"<b>Login in App >> Click on Hamburger Menu >> Goto Entertainment</b>"

													},
													{
														"id" : "Book Deals",
														"request" : "I want to find good deals<br/>",
														"response" : "You can find good deals for your outings<br><br>"
																					+"To use this service please follow the steps-<br><br>"
																					+"<b>Login in App >> Click on Book & Order Tab >> Goto Book Deals <br/></b>"+"OR<br/>"
																					+"<b>Login in App >> Click on Hamburger Menu >> Goto Book Deals</b>"

													},
													{
														"id" : "Cabs & Car Rentals",
														"request" : "I want to book/rent a cab<br/>",
														"response" : "You can book cab or take car rental<br><br>"
																					+"To use this service please follow the steps-<br><br>"
																					+"<b>Login in App >> Click on Book & Order Tab >> Goto Cabs & Car Rentals<br/></b>"+"OR<br/>"
																					+"<b>Login in App >> Click on Hamburger Menu >> Goto Cabs & Car Rentals</b>"

													},
													{
														"id" : "Hospitality & Hotels",
														"request" : "I want to book a hotel<br/>",
														"response" : "You can book hotels online <br><br>"
																					+"To use this service please follow the steps-<br><br>"
																					+"<b>Login in App >> Click on Book & Order Tab >> Goto Hospitality & Hotels<br/></b>"+"OR<br/>"
																					+"<b>Login in App >> Click on Hamburger Menu >> Goto Hospitality & Hotels</b>"

													},
												]
											}
											]
											};
											return chatResponseOptions;

									};
		return {
			chatBotQuery:chatBotQuery,
			submitChatBotFeedback:submitChatBotFeedback,

			getChatbotWhatsNew:getChatbotWhatsNew,
			getChatbotSecurityTips:getChatbotSecurityTips,
			getChatResponse:getChatResponse
		}
	});  

