'use strict';

angularApp.controller('chatBotWhatCanIDoDetailController', ["$timeout",
     "$state",
     "$location",
     "$scope",
     "$rootScope",
     "utilityService",
     "$ionicPopup",
     "$ionicSideMenuDelegate",
     "$sce",
     "$compile",
     "chatBotService",
     "$ionicScrollDelegate",

     function ($timeout,
     $state,
     $location,
     $scope,
     $rootScope,
     utilityService,
     $ionicPopup,
     $ionicSideMenuDelegate,
     $sce,
     $compile,
     chatBotService,
     $ionicScrollDelegate
       ) {
         var chatBotWhatCanIDoDetailVm = this;
         function initPage(){
           chatBotWhatCanIDoDetailVm.sttButton=false;
           chatBotWhatCanIDoDetailVm.chatResponse="";
           chatBotWhatCanIDoDetailVm.chatMsg = "";
           chatBotWhatCanIDoDetailVm.chatServiceList = chatBotService.getChatResponse();
           chatBotWhatCanIDoDetailVm.msg=chatBotService.msg;
           chatBotWhatCanIDoDetailVm.resp=chatBotService.resp;
           chatBotWhatCanIDoDetailVm.btnResp=chatBotService.btnResp;
           chatBotWhatCanIDoDetailVm.chatSend();
           chatBotWhatCanIDoDetailVm.scrollToTop();

         };
         chatBotWhatCanIDoDetailVm.gotoLevel3=function(id)
         {
           chatBotWhatCanIDoDetailVm.id=id;
           for(var i=0;i<chatBotWhatCanIDoDetailVm.chatServiceList.children.length;i++){
            for(var j=0;j<chatBotWhatCanIDoDetailVm.chatServiceList.children[i].children.length;j++){
            if(chatBotWhatCanIDoDetailVm.id==chatBotWhatCanIDoDetailVm.chatServiceList.children[i].children[j].id){
              chatBotWhatCanIDoDetailVm.msg=chatBotWhatCanIDoDetailVm.chatServiceList.children[i].children[j].request;
              chatBotWhatCanIDoDetailVm.resp=chatBotWhatCanIDoDetailVm.chatServiceList.children[i].children[j].response;
              chatBotWhatCanIDoDetailVm.btnResp="";
            }
          }
          }
          chatBotWhatCanIDoDetailVm.chatSend();
        };
         chatBotWhatCanIDoDetailVm.chatSend = function(){
         var d = new Date();
         var time = d.toLocaleString([],{hour:'2-digit',minute:'2-digit'});

         var reciever='<div class="sender"><div class="row ">'
                   +'<div class="col col-20"><div><img class="img_size" fallback-src="img/profile_placeholder.svg" src="'+$rootScope.profileImageUrl+'"></div></div><div class="col col-80 bg-color-white border-radius5 roboto-regular">'
                   + chatBotWhatCanIDoDetailVm.msg +'</div></div>'
                   +'<div class="row"><div class="col col-100"><span class="roboto-regular float_right lowerCase">'+ time +'</span></div></div></div>';



         chatBotWhatCanIDoDetailVm.chatMsg='';
         if (chatBotWhatCanIDoDetailVm.msg != "" && chatBotWhatCanIDoDetailVm.msg != "First" && chatBotWhatCanIDoDetailVm.msg != undefined) {
           chatBotWhatCanIDoDetailVm.chatResponse=$sce.trustAsHtml(chatBotWhatCanIDoDetailVm.chatResponse + reciever);
           $timeout(function() {
                      $ionicScrollDelegate.$getByHandle('homeScroll').scrollBottom(true);
                  }, 0);
         }

         chatBotWhatCanIDoDetailVm.displayFAQResponse(chatBotWhatCanIDoDetailVm.resp,chatBotWhatCanIDoDetailVm.btnResp);
         };
         /**
         * Display FAQ responses
         */
         chatBotWhatCanIDoDetailVm.displayFAQResponse = function(response, btnsResp) {

           chatBotWhatCanIDoDetailVm.isWaitingForResponse = false;
           var d = new Date();
           var time = d.toLocaleString([],{hour:'2-digit',minute:'2-digit'});

           chatBotWhatCanIDoDetailVm.inTransaction = false;

           var outputResponse ='<div class="receiver"><div class="row "><div class="col col-80 bg-color-white border-radius5 roboto-regular">' + response + btnsResp+ '</div>'
           +'<div class="col col-20 chatbot_txtRight"><div><img src="img/ChatBot_Icon.svg" style="width:50px;"></div></div></div>'
           +'<div class="row"><div class="col col-100"><span class="roboto-regular lowerCase">' + time + '</span></div></div>';

           chatBotWhatCanIDoDetailVm.chatResponse=$sce.trustAsHtml(chatBotWhatCanIDoDetailVm.chatResponse + outputResponse );

           $timeout(function() {
             $ionicScrollDelegate.$getByHandle('homeScroll').scrollBottom();
           }, 0);

         };

         chatBotWhatCanIDoDetailVm.goBack =function(){
            $state.go('menu.chatbotwhatcanido');
         };
         chatBotWhatCanIDoDetailVm.goHome =function(){
            $state.go('menu.chatbotlanding');
         };
         chatBotWhatCanIDoDetailVm.getScrollPosition = function() {
           //monitor the scroll
           var moveData = $ionicScrollDelegate.$getByHandle('homeScroll').getScrollPosition().top;
           // console.log(moveData);
           if(moveData>150){
               $scope.$apply(function(){
               chatBotWhatCanIDoDetailVm.sttButton=true;
            });//apply
           }else{
             $scope.$apply(function(){
             chatBotWhatCanIDoDetailVm.sttButton=false;
           });//apply
         }
         };
   chatBotWhatCanIDoDetailVm.scrollToTop = function() {
     $ionicScrollDelegate.$getByHandle('homeScroll').scrollTop();
     chatBotWhatCanIDoDetailVm.sttButton=false;
   };

        $scope.$on('$ionicView.beforeEnter', function () {
           initPage();
        });
        $scope.$on('$ionicView.afterEnter', function () {
           chatBotWhatCanIDoDetailVm.scrollToTop();
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;


        }
]);
