angularApp.service('csatService',
	function ($q, utilityService,AdapterUtils) {
		var csatService = this;
		csatService.showCsatScreen = false;
		csatService.csatScreenType = 'CSR';
		csatService.getGoldenJourneyStatus = function (payLoad) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/CSATFeedbackAdapter/getGoldenJourneyStatus", payLoad, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		csatService.saveGoldenJourneyStatus = function (payLoad) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/CSATFeedbackAdapter/saveGoldenJourneyStatus", payLoad, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		return csatService;
	});  
