angularApp.service('changeMaturityService',
	function ($q, utilityService, AdapterUtils, $state,$ionicPopup) {
		var changeMaturityService = this;
		changeMaturityService.normalFDTnC = "";
        changeMaturityService.accList = [];
        changeMaturityService.maturityDate = "";
        changeMaturityService.transferAccountNumber = "";
		changeMaturityService.fetchRtermcondition = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getTnC", obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
        changeMaturityService.getMaturityInstDetail = function (obj) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/FixedDepositAdapter/CMI/getChangeMaturityInstDetails", obj, true).then(
                function (response) {

                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
		changeMaturityService.showTnCAlertModal = function (heading,message,buttonText,callBack) {
			var alertPopup = $ionicPopup.alert({
            title: heading,
            template: '<div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list font-size-12 font-light ss-text-color">'
            + message + '</div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
            buttons: [
					{
						text: buttonText,
						onTap: function(e) {
							callBack();
						}
					}
				],
        	});
		}

		changeMaturityService.updateChangeMaturity = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/FixedDepositAdapter/CMI/updateMaturityInst", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    changeMaturityService.getUnmaskData = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/FixedDepositAdapter/CMI/getUnmaskData", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    changeMaturityService.getAccountList = function() {
        var q = $q.defer();
        AdapterUtils.postData("adapters/FixedDepositAdapter/CMI/getAccountList", {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

		return changeMaturityService;
	});  
