'use strict';

angularApp.service('fixedDepositService',
	function ($ionicPopup, $q, AdapterUtils) {

		var FDservice = this;

		FDservice.accDetails = [];
		FDservice.isChangeMaturity = false;
		FDservice.selectedDetails = {
			accountType: '',
			accountNumber: '',
			accountBalance: '',
			isActive: '',
			isTransactional: '',
			branchCode: '',
			branchName: '',
			intCategory: '',
			accountTypeCode: '',
			linkAccountType: ''
		};

		FDservice.Relations = [];
		FDservice.customer = {
			creditAc:'',
			debitAccountNumber:'',
			debitAccountType:'',
			debitAccountBalance:'',
			effectiveIE:'',
			isAvailOD:false,
			isCloseFD:false,
			isModPmryEligible:'false',
			maskedFdNumber:'',
			amountData: '',
			years: '',
			months: '',
			days: '',
			maturityDate: '',
			interestRate: '',
			maturityAmount: '',
			interestPayout: '',
			maturityInstruction: '',
			diffDays: '',
			maturityDateFull: '',
			isvalidDays: '',
			isTaxable: false,
			accountNo: '',
			fdAccountNumber: '',
			loanEligibility: '',
			receiptLink: '',
			nomineeClick: '',
			selectedItem: '',
			ODLimit: '',
			ODIntRate: '',
			ODExyDate: '',
			isSenior: false,
			custName: '',
			custDOB: '',
			nominee: '',
			age: '',
			relation: '',
			guardian: '',
			address1: '',
			address2: '',
			dob: '',
			showNominee: false,
			viewInterest: false,
			isPanAvailable: '',
			fdnumber: '',
			AODclick: '',
			intpayoutMD: '',
			intpayoutAMT: '',
			maturitydateRequest: '',
			nameToBePrintedFlag: '',
			minorFlag: '',
			custype: '',
			intpayoutservice: '',
			matInstService: '',
			indexId: 0,
			amountCredited: '',
			effectiveInterestRates: '',
			clickback: '',
			intpaycheck: '',
			nomIndexid: '',
			checkPAL: '',
			preApprovedLoanAmount: '',
			product: '',
			principalAmount: '',
			checkPage: false,
			maturitydateFD: '',
			maturitydateFDRequest: '',
			branchCode: '',
			branchName: '',
			intpayamount: '',
			intpaystring: '',
			checkNominee: false,
			fdCloseClick: '',
			intpayoutACCT: '',
			intCategory: '',
			accountTypeCode: '',
			nightMode: '',
			modeOfOperation: '',
			scheme:''
		};
		/**
		 * Common pop up message
		 * @param {string} title 
		 * @param {tempalte html as string} template
		 * @param {string} onTapgo
		 * @param {obejct} $scope
		 * @param {object} $state
		 */

		 //Hambergur changes Starts
		 	FDservice.initializeFDvariables = function(){
		 		FDservice.customer = {
		 				creditAc:'',
						debitAccountNumber:'',
						debitAccountType:'',
						debitAccountBalance:'',
						effectiveIE:'',
						isAvailOD:false,
						isCloseFD:false,
						isModPmryEligible:'false',
						maskedFdNumber:'',
						amountData: '',
						years: '',
						months: '',
						days: '',
						maturityDate: '',
						interestRate: '',
						maturityAmount: '',
						interestPayout: '',
						maturityInstruction: '',
						diffDays: '',
						maturityDateFull: '',
						isvalidDays: '',
						isTaxable: false,
						accountNo: '',
						fdAccountNumber: '',
						loanEligibility: '',
						receiptLink: '',
						nomineeClick: '',
						selectedItem: '',
						ODLimit: '',
						ODIntRate: '',
						ODExyDate: '',
						isSenior: false,
						custName: '',
						custDOB: '',
						nominee: '',
						age: '',
						relation: '',
						guardian: '',
						address1: '',
						address2: '',
						dob: '',
						showNominee: false,
						viewInterest: false,
						isPanAvailable: '',
						fdnumber: '',
						AODclick: '',
						intpayoutMD: '',
						intpayoutAMT: '',
						maturitydateRequest: '',
						nameToBePrintedFlag: '',
						minorFlag: '',
						custype: '',
						intpayoutservice: '',
						matInstService: '',
						indexId: 0,
						amountCredited: '',
						effectiveInterestRates: '',
						clickback: '',
						intpaycheck: '',
						nomIndexid: '',
						checkPAL: '',
						preApprovedLoanAmount: '',
						product: '',
						principalAmount: '',
						checkPage: '',
						maturitydateFD: '',
						maturitydateFDRequest: '',
						branchCode: '',
						branchName: '',
						intpayamount: '',
						intpaystring: '',
						checkNominee: false,
						fdCloseClick: '',
						intpayoutACCT: '',
						intCategory: '',
						accountTypeCode: '',
						nightMode: ''
				};

				FDservice.selectedDetails = {
						accountType: '',
						accountNumber: '',
						accountBalance: '',
						isActive: '',
						isTransactional: '',
						branchCode: '',
						branchName: '',
						intCategory: '',
						accountTypeCode: '',
						linkAccountType: ''
				};
			}
		 //Hambergur changes ends

		FDservice.showAlertModal = function (title, template, onTapgo, $scope, $state) {
			var alertPopup = $ionicPopup.show({
				title: title,
				template: template,
				scope: $scope,
				cssClass: 'my-custom-popup',
				buttons: [{
					text: 'OK',
					type: 'button-assertive',
					onTap: function () {
						if (onTapgo !== '' && onTapgo !== null) {
							$state.go(onTapgo);
						}
					}
				}],
			});
		}
		FDservice.showTnCAlertModal = function (title, template, onTapgo, cssClasstnc, $scope, $state) {
			var alertPopup = $ionicPopup.show({
				title: title,
				template: template,
				scope: $scope,
				cssClass: cssClasstnc,
				buttons: [{
					text: 'OK',
					type: 'button-assertive',
					onTap: function () {
						if (onTapgo !== '' && onTapgo !== null) {
							$state.go(onTapgo);
						}
					}
				}],
			});
			return alertPopup;
		}

		FDservice.fetchInfoMessage = function (data) {
			var q = $q.defer();
			var obj = {
				"action": data.action
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/fetchInfoMessage", obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.fetchNightModeStatus = function (data, isLoader) {
			var q = $q.defer();
			var obj = {
				"module": data.moduleName,
				"action": data.actionName,
				"date": ""
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/fetchNightModeStatus", obj, isLoader).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		FDservice.fetchTSFDMessage = function (data) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HelpAdapter/TSFDcontent", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		return FDservice;
	});
