angularApp.service('interestPayoutService',
	function ($q, utilityService, AdapterUtils) {
		var FDservice = this;
		FDservice.getMaturityDetails = function (data) {
			var q = $q.defer();
			var obj = {
				"days": data.days,
				"interestPayout": data.intpayoutservice,
				"maturityInstruction": data.maturityInstruction,
				"months": data.months,
				"amount": data.amount,
				"startDate": data.startDate,
				"maturityDate": data.maturitydateRequest,
				"taxSaver": data.isTaxable,
				"isSeniorCitizen": data.isSenior,
				"years": data.years,
				"isStaffFlag": data.isStaffFlag,
				"intCategory": data.intCategory,
				"accountTypeCode": data.accountTypeCode,
				"branchCode": data.branchCode
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/getMaturityDetails", obj, true).then(
				function (response) {

					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		return FDservice;
	});  