angularApp.service('interestrateService',
	function ($q, utilityService, AdapterUtils, customerInfoService, fixedDepositService) {
		var FDservice = this;
		FDservice.fetchInterestRate = function (data) {
			var q = $q.defer();
			var obj = {
				"isTaxSaverFD": data.isTaxable,
				"custype": data.custype,
				"customerType": customerInfoService.customer.type,
				"intCategory": fixedDepositService.customer.intCategory,
				"accountTypeCode": fixedDepositService.customer.accountTypeCode,
				"isSeniorCitizen": fixedDepositService.customer.isSenior
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/fetchInterestRate", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		return FDservice;
	});  