angularApp.service('nomineeService',
	function ($q, AdapterUtils) {
		var FDservice = this;
		FDservice.updateNominee = function (data) {
			var q = $q.defer();
			var nominee = {
				"fdAccountNumber": data.fdAccountNumber,
				"nominee": {
					"name": data.nameData,
					"relation": data.relationType,
					"ageofGuardian": data.age,
					"nomineeGuardian": data.guardian,
					"address1": data.address1,
					"address2": data.address2,
					"dob": data.nomineeDOB,
					"hideNominee": data.showNominee
				},
				"nameToBePrintedFlag": data.nameToBePrintedFlag,
				"minorFlag": data.minorFlag,
				"branchCode": data.branchCode
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/updateNominee", nominee, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		FDservice.getRelationship = function () {
			var q = $q.defer();
			var obj = {
				"id": "MasterDataTry1",
				"fields": ["Relationship"]
			};
			AdapterUtils.postData("adapters/FixedDepositAdapter/getRelationship", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		return FDservice;
	});  