'use strict';

angularApp.controller('bharatQrSuccessController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"bQRService",
	"ionicToast",
	"bhimUpiService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		bQRService,
		ionicToast,
		bhimUpiService) {

		var bharatQrSuccessVm = this;

		bharatQrSuccessVm.goToBack = function () {
			if (customerInfoService.scanQrEntrypoint && customerInfoService.scanQrEntrypoint !== 'FTLANDING') {
				$state.go('menu.fundtrans');
			} else {
				$state.go('menu.fundsTransferLanding');
			}
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			bharatQrSuccessVm.merchantName = bQRService.merchantDetails.merchantName;
			bharatQrSuccessVm.transactionAmt = Number.parseFloat(bQRService.transactionAmount) + Number.parseFloat(bQRService.convenienceFee);
		});

		bharatQrSuccessVm.gotoRelationshipOverview = function () {
			$state.go('menu.accountOverviewMyBalance');
		}

		return this;
	}
]);
