'use strict';

angularApp.controller('collectRequestSuccessController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"ionicToast",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		ionicToast) {

		var collectRequestSuccessVm = this;

		collectRequestSuccessVm.backToBhimUpi = function(){
			$state.go('menu.fundtrans');
		}

		collectRequestSuccessVm.goToRelationshipOverview = function(){
			$state.go('menu.accountOverviewMyBalance');
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			collectRequestSuccessVm.collectRequest = {
				collectType: customerInfoService.collectRequest.collectType || "VA",
				payerVpa: customerInfoService.collectRequest.payerVpa || "",
				payerName: customerInfoService.collectRequest.payerName || "",
				amount: customerInfoService.collectRequest.amount || "",
				remark: customerInfoService.collectRequest.remark || "NA",
				payeeVpa: customerInfoService.collectRequest.payeeVpa ? customerInfoService.collectRequest.payeeVpa.trim() : "",
				payeeAccount: customerInfoService.collectRequest.payeeAccount || "",
				expiry : customerInfoService.collectRequest.expiry || ""
			}
		});

		return this;
	}
]);
