'use strict';

angularApp.controller('raiseDisputeSuccessController', ["$state",
	"$ionicPopup",
	"$scope",
	"customerInfoService",
	"utilityService",
	"constantConfig",
	"$rootScope",
	"ionicToast",
	"bhimUpiService",

	function ($state,
		$ionicPopup,
		$scope,
		customerInfoService,
		utilityService,
		constantConfig,
		$rootScope,
		ionicToast,
		bhimUpiService) {

		var raiseDisputeSuccessVm = this;

		raiseDisputeSuccessVm.goToBack = function(){
			$state.go('menu.transactionHistory');
		}

		raiseDisputeSuccessVm.goToFundTransfer = function(){
			$state.go('menu.fundtrans');
		}

		raiseDisputeSuccessVm.goToRelationshipOverview = function(){
			$state.go('menu.accountOverviewMyBalance');
		}

		$scope.$on('$ionicView.beforeEnter', function () {
             raiseDisputeSuccessVm.dispute = customerInfoService.disputeDetails
        });

		return this;
	}
]);
