angularApp.service('ftIFSCSearchService', function($q,AdapterUtils,constantConfig) {
	var searchIFSCCodes = function(searchStr) {
		var q = $q.defer();
		
		var payload = {
			"keys" : [searchStr],
			"limit" : "20"
		};
		
		AdapterUtils.postData(constantConfig.ftAdapterUrl.getIFSCCode,payload,false).then(
			function(response){
				q.resolve(response.data);
			},
			function(error) {
			q.reject(error);
		});
		return q.promise;
	};
	
	var searchIFSCCodesbyBank = function (bankSearchString, branchSearchString) {		
		var q = $q.defer();
		var payload = {
			"bankSearchString": bankSearchString,
			"branchSearchString": branchSearchString,
			"limit": "20"
		};

		AdapterUtils.postData('adapters/FundsTransferAdapter/getBankBranchList', payload, false).then(
			function (response) {
				q.resolve(response.data);
			},
			function (error) {
				q.reject(error);
			});
		return q.promise;
	};
	return {
		searchIFSCCodes : searchIFSCCodes,
		searchIFSCCodesbyBank: searchIFSCCodesbyBank
	};
});
