angularApp.service('fTNewBeneficiary_VPAService', function($q, utilityService, constantConfig, AdapterUtils) {
	var addBeneficiary = function(beneficiary,remAccntNo,benName,amount,charges,remarks,timeStamp) {
		var q = $q.defer();
		
		var payload = {
			"inbUserID":"",
			"benName": beneficiary.nameData,
			"benNickName": beneficiary.nickName,
			"benBankName": beneficiary.bankData,
			"benType": "mobile",
			"transferLimit": beneficiary.maxLimit,
			"benAccntNo": beneficiary.accountNoData,
			"benIfscCode": "",
			"intraBankFlag": beneficiary.intraBankFlag,
			"benMMID": beneficiary.mmid,
			"remMMID": "",
			"benMobileNo": beneficiary.mobileNo,
			"remAccntNo": remAccntNo,
			"amount": amount,
			"transactionFee": charges,
			"remarks": remarks,
			"txnType":"",
			"otpTimeStamp": timeStamp,
			"benPicDocId": ""
		};
		
		AdapterUtils.postData(constantConfig.ftAdapterUrl.addBeneficiary, payload, true).then(
			function(response){	
				q.resolve(response);
			},
			function(error){	
				q.reject(error);
			}
			); 
		return q.promise;
	};
	return {
		addBeneficiary : addBeneficiary
	};
});
