angularApp.service('fTScheduleReviewService', 
		function($q, AdapterUtils, constantConfig) {
			var UpdateService = this;
			
			UpdateService.updateSchedulePayment = function(beneficiary) {
				var q = $q.defer();	
				var schedule={
					"remAccntNo": beneficiary.fromAccNumber,
					  "amount": beneficiary.scheduledTransferAmount,
					  "transactionFee": beneficiary.transFee,
					  "remMMID": "",
					  "remarks": beneficiary.remarks,
					  "siDate": beneficiary.scheduleDate,
					  "siFrequency": beneficiary.siFrequency,
					  "siCount": beneficiary.siCount,
					  "siId": beneficiary.siId
				};
			
				AdapterUtils.postData(constantConfig.ftAdapterUrl.updateScheduledPayment,schedule,true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error) {
					q.reject(error);
				});
				return q.promise;
			};
			
			return UpdateService;
});
