angularApp.service('fTBeneficiaryService', function($q, AdapterUtils, utilityService, constantConfig, homeScreenService, $ionicPopup) {
    var FTservice = this;
    var isCreditCardFlag=false;
    var savedImg = "";
    var beneficiaryData = {
        freqTransItems: [],
        schedTransItems: [],
        otherAccItems: [],
        ownAccItems: []
    };
    FTservice.config = {
        quickTransferLimit: ''
    }
    FTservice.customer = {
        accountType: '',
        frequentAmount: '',
        picDocId: '',
        imgData: constantConfig.ft.defaultEditBenImg,
        conImg: constantConfig.ft.defaultBenImg,
        sbiLogo: constantConfig.SBILogo,
        nameData: '',
        nickName: '',
        mobileNo: '',
        bankData: '',
        ifsc: '',
        accountNoData: '',
        accountTypeData: '',
        mmid: '',
        remMMID: '',
        vpa: '',
        sBalance: '',
        transAmount: '',
        remarks: '',
        transFee: '',
        transactionId: '',
        fromAccNumber: '',
        fromAccType: '',
        fromAccBalance: '',
        maxLimit: '',
        benType: '',
        intraBankFlag: '',
        isOwnAccntFlag: '',
        ownAccount: false,
        siId: '',
        scheduleDate: '',
        sAccountType: '',
        sAccountNo: '',
        scheduledTransferAmount: '',
        siFrequency: '',
        siCount: '',
        selectedItem: '',
        selectedItemImg: '',
        indexId: 0,
        ownAccItems: [],
        benStatus: '',
        credAcType:''
	
	};
    FTservice.beneficiaryItem = {
        "beneficiaryName": "",
        "nickName": "",
        "bankName": "",
        "pictureUrl": "",
        "type": "",
        "accountNumber": "",
        "mmid": "",
        "vpa": ""
    };

    FTservice.payingFrom = '';
    FTservice.accDetails = [];
    FTservice.selectedDetails = {
        accountType: '',
        accountNo: '',
        balance: '',
        img: ''
    };

    FTservice.cif = "";
    FTservice.minAmount = "";
    FTservice.qrflag = false;
    FTservice.checkBox = "N";
    FTservice.imagesLoaded = false;
    /* GOC Hyderabad CR Changes Start */
    FTservice.stateIFSC = "";
    FTservice.unmaskedOBAccNo="";
    FTservice.newMaxLimit="";
    /* GOC Hyderabad CR Changes End */
    FTservice.remarkPurpose="";
    FTservice.remarkOther="";
    FTservice.getFTPurposes = function () {
        console.log("Service: getRemarkPurposes");        
          var q = $q.defer();
          AdapterUtils.postData("adapters/FundsTransferAdapter/getRemarkPurposes", {}, true).then(
                  function (response) {
                          q.resolve(response.data);
                  },
                  function (error) {
                          q.reject(error);
                  }
          );
          return q.promise;
      };
    /* Adapter call to get Beneficiary List */
    FTservice.getBeneficiaryList = function(isLoading) {

        var q = $q.defer();
        AdapterUtils.postData(constantConfig.ftAdapterUrl.beneficiaries, {}, isLoading).then(
            function(response) {
                beneficiaryData.freqTransItems.length = 0;
                beneficiaryData.otherAccItems.length = 0;
                beneficiaryData.ownAccItems.length = 0;
                if (!utilityService.isUndefined(response.data.beneficiaryList.frequentAccounts))
                    for (var i = 0; i < response.data.beneficiaryList.frequentAccounts.length; i++) {
                        var tempObj = {
                            img: response.data.beneficiaryList.frequentAccounts[i].picDocId,
                            picDocId: response.data.beneficiaryList.frequentAccounts[i].picDocId,
                            name: response.data.beneficiaryList.frequentAccounts[i].benName,
                            bank: response.data.beneficiaryList.frequentAccounts[i].bankName,
                            nickName: response.data.beneficiaryList.frequentAccounts[i].benNickName,
                            mobileNumber: response.data.beneficiaryList.frequentAccounts[i].mobileNo,
                            benType: response.data.beneficiaryList.frequentAccounts[i].benType.toLowerCase(),
                            accountNo: response.data.beneficiaryList.frequentAccounts[i].benAccntNo,
                            mmid: response.data.beneficiaryList.frequentAccounts[i].benMMID,
                            vpa: response.data.beneficiaryList.frequentAccounts[i].vpa,
                            remarks: response.data.beneficiaryList.frequentAccounts[i].remarks,
                            ifscCode: response.data.beneficiaryList.frequentAccounts[i].benIFSCCode,
                            frequentAmount: response.data.beneficiaryList.frequentAccounts[i].amount,
                            type: response.data.beneficiaryList.frequentAccounts[i].type,
                            maxLimit: response.data.beneficiaryList.frequentAccounts[i].maxLimit,
                            intraBankFlag: response.data.beneficiaryList.frequentAccounts[i].intraBankFlag,
                            isActive: 'Y'
                        };
                        tempObj.img = utilityService.isUndefined(response.data.beneficiaryList.frequentAccounts[i].picDocId) ? constantConfig.ft.defaultBenImg : response.data.beneficiaryList.frequentAccounts[i].picDocId;
                        beneficiaryData.freqTransItems.push(tempObj);
                    };

                if (!utilityService.isUndefined(response.data.beneficiaryList.otherAccounts))
                    for (var i = 0; i < response.data.beneficiaryList.otherAccounts.length; i++) {
                        var temObj = {
                            img: response.data.beneficiaryList.otherAccounts[i].picDocId,
                            picDocId: response.data.beneficiaryList.otherAccounts[i].picDocId,
                            name: response.data.beneficiaryList.otherAccounts[i].benName,
                            bank: response.data.beneficiaryList.otherAccounts[i].bankName,
                            nickName: response.data.beneficiaryList.otherAccounts[i].benNickName,
                            mobileNumber: response.data.beneficiaryList.otherAccounts[i].mobileNo,
                            benType: response.data.beneficiaryList.otherAccounts[i].benType.toLowerCase(),
                            accountNo: response.data.beneficiaryList.otherAccounts[i].benAccntNo,
                            mmid: response.data.beneficiaryList.otherAccounts[i].benMMID,
                            vpa: response.data.beneficiaryList.otherAccounts[i].vpa,
                            ifscCode: response.data.beneficiaryList.otherAccounts[i].benIFSCCode,

                            type: response.data.beneficiaryList.otherAccounts[i].type,
                            maxLimit: response.data.beneficiaryList.otherAccounts[i].maxLimit,
                            intraBankFlag: response.data.beneficiaryList.otherAccounts[i].intraBankFlag,
                            isActive: response.data.beneficiaryList.otherAccounts[i].isActive
                        };
                        temObj.img = utilityService.isUndefined(response.data.beneficiaryList.otherAccounts[i].picDocId) ? constantConfig.ft.defaultBenImg : response.data.beneficiaryList.otherAccounts[i].picDocId;
                        beneficiaryData.otherAccItems.push(temObj);
                    };

                if (!utilityService.isUndefined(response.data.beneficiaryList.ownAccounts))
                    for (var i = 0; i < response.data.beneficiaryList.ownAccounts.length; i++) {
                        var tObj = {
                            nickName: response.data.beneficiaryList.ownAccounts[i].benName,
                            benType: response.data.beneficiaryList.ownAccounts[i].benAccntType.toLowerCase(),
                            accountNo: response.data.beneficiaryList.ownAccounts[i].benAccntNo,
                            balance: response.data.beneficiaryList.ownAccounts[i].balance,
                            img: response.data.beneficiaryList.ownAccounts[i].picDocId || 'img/SBI.png',
                            picDocId: response.data.beneficiaryList.ownAccounts[i].picDocId,
                            bank: 'SBI',
                            intraBankFlag: "Y",
                            ownAccount: true
                        };
                        beneficiaryData.ownAccItems.push(tObj);
                    };
                q.resolve(beneficiaryData);
            },
            function(error) {
                q.reject(error);
            });
        return q.promise;
    };
    /* Adapter call to Delete Beneficiary */
    FTservice.deleteBeneficiary = function(account) {
        var q = $q.defer();
        var obj = {
            "benName": account.name,
            "benNickName": account.nickName,
            "benType": account.benType,
            "benMMID": "",
            "inbUserID": "",
            "intraBankFlag": account.intraBankFlag,
            "benIFSCCode": account.ifscCode ? account.ifscCode : "",
            "benAccntNo": account.accountNo ? account.accountNo : "",
            "benMMID": account.mmid ? account.mmid : "",
            "benMobileNo": account.mobileNumber ? account.mobileNumber : "",
            "benStatus": account.benStatus ? account.benStatus : ""
        };

        AdapterUtils.postData(constantConfig.ftAdapterUrl.deleteBeneficiary, obj, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            });
        return q.promise;
    };

    /* Adapter call to get Scheduled Payment */
    FTservice.getScheduledPayment = function(isLoader) {
        var q = $q.defer();
        var reqParams = {
            "siId": "string"
        }
        AdapterUtils.postData(constantConfig.ftAdapterUrl.scheduledPayments, reqParams, isLoader).then(
            function(response) {
                beneficiaryData.schedTransItems.length = 0;
                if (!utilityService.isUndefined(response.data.scheduledTransfers))
                    for (var i = 0; i < response.data.scheduledTransfers.length; i++) {
                        var tempObj = {
                            siId: response.data.scheduledTransfers[i].siId,
                            name: response.data.scheduledTransfers[i].benName,
                            nickName: response.data.scheduledTransfers[i].benNickName,
                            type: response.data.scheduledTransfers[i].benType,
                            accountNo: response.data.scheduledTransfers[i].benAccntNor,
                            fromAccNumber: response.data.scheduledTransfers[i].remAccntNo,
                            mmid: response.data.scheduledTransfers[i].benMMID,
                            remMMID: response.data.scheduledTransfers[i].remMMID,
                            intraBankFlag: response.data.scheduledTransfers[i].intraBankFlag,
                            remarks: response.data.scheduledTransfers[i].remarks,
                            scheduledDate: response.data.scheduledTransfers[i].siDate,
                            scheduledTransferAmount: response.data.scheduledTransfers[i].siAmount,
                            siFrequency: response.data.scheduledTransfers[i].siFrequency,
                            siCount: response.data.scheduledTransfers[i].siCount,
                            charges: response.data.scheduledTransfers[i].transactionFee,
                            isOwnAccntFlag: response.data.scheduledTransfers[i].isOwnAccntFlag,
                            isScheduleFlag: true,
                            isActive: 'Y'
                        };
                        beneficiaryData.schedTransItems.push(tempObj);
                    };
                q.resolve(beneficiaryData.schedTransItems);
            },
            function(error) {
                q.reject(error);
            });
        return q.promise;
    };

    /* Adapter call to update Beneficiary */
    FTservice.updateBeneficiary = function(params) {
        var q = $q.defer();
        AdapterUtils.postData(constantConfig.ftAdapterUrl.updateBeneficiary, params, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            });
        return q.promise;
    };

    /* Adapter call to upload BeneficiaryPicture */
    FTservice.uploadBeneficiaryPicture = function(params) {
        var q = $q.defer();
        AdapterUtils.postData(constantConfig.ftAdapterUrl.uploadBeneficiaryPicture, params, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            });
        return q.promise;
    };

    /* Adapter call to update BeneficiaryPicture */
    FTservice.updateBeneficiaryPicture = function(params) {
        var q = $q.defer();
        AdapterUtils.postData(constantConfig.ftAdapterUrl.updateBeneficiaryPicture, params, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            });
        return q.promise;
    };

    /* Adapter call to retrive BeneficiaryPicture */
    FTservice.retriveBeneficiaryPicture = function(params) {
        var q = $q.defer();
        AdapterUtils.postData(constantConfig.ftAdapterUrl.retriveBeneficiaryPicture, params, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            });
        return q.promise;
    };

    /* Adapter call to retrive BeneficiaryPicture */
    FTservice.deleteBeneficiaryPicture = function(params) {
        var q = $q.defer();
        AdapterUtils.postData(constantConfig.ftAdapterUrl.deleteBeneficiaryPicture, params, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            });
        return q.promise;
    };

    /* Adapter call to retrive BeneficiaryPicture */
    FTservice.searchBeneficiaryPicture = function(params) {
        var q = $q.defer();
        AdapterUtils.postData(constantConfig.ftAdapterUrl.searchBeneficiaryPicture, params, false).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            });
        return q.promise;
    };

    /* Adapter call to retrive terms and conditions */
    FTservice.getTermsCondition = function(params) {
        var q = $q.defer();
        AdapterUtils.postData(constantConfig.ftAdapterUrl.getTermsCondition, params, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            });
        return q.promise;
    };

    //show alert modal
    FTservice.showAlertModal = function(title, template, onTapgo, $scope, $state) {
        var alertPopup = $ionicPopup.show({
            title: title,
            template: template,
            scope: $scope,
            cssClass: 'my-custom-popup',
            buttons: [{
                text: 'OK',
                type: 'button-assertive',
                onTap: function() {
                    if (onTapgo !== '' && onTapgo !== null) {
                        $state.go(onTapgo);
                    }
                }
            }],
        });
    }


    //show error modal
    FTservice.showErrorModal = function(title, template, onTapgo, $scope, $state, message) {
        var alertPopup = $ionicPopup.show({
            title: title,
            template: template || '<div class="popupBodyPadding font-dark-grey"><div><img class="approvedIconPosition" src="img/errorImage.png"></div><div translate="ERROR_TITLE" class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>' +
                message + '</span></div></div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter',
            scope: $scope,
            buttons: [{
                text: 'OK',
                type: 'button-assertive',
                onTap: function() {
                    if (onTapgo !== '' && onTapgo !== null) {
                        $state.go(onTapgo);
                    }
                }
            }],
        });
    }

    return FTservice;
});
