'use strict';
angularApp.controller('quickTransferReviewBeneController', [
		"$state",
		"$scope",		
		"utilityService",
		"quickTransferService",
		"$translate",
		"getAccountDetailsService",
		"$ionicPopup",
		"validationService",
		"ftIFSCSearchService",
		"cameraService",
		"$ionicHistory",
		"$ionicViewSwitcher",
		function($state, 
		$scope,
		utilityService,
		quickTransferService,
		$translate,
		getAccountDetailsService,
		$ionicPopup,
		validationService,
		ftIFSCSearchService,
		cameraService,
		$ionicHistory,
		$ionicViewSwitcher) {
			
			var quickTransferReviewBeneVm = this;
			quickTransferReviewBeneVm.defaultImage = quickTransferService.paymentData["defaultImage"];
			var plusImg = "img/quickpay/add.svg";
			var minusImg = "img/quickpay/Del.svg"
			quickTransferReviewBeneVm.defaultPlusImage = plusImg;
			var accOverviewData = getAccountDetailsService.accountOverviewData;
			var profPassObj = {};
			
			var isDefaultPic = true;

			function initPage(){
				var pay_type = "";
				quickTransferReviewBeneVm.pay_type = quickTransferService.paymentType ? quickTransferService.paymentType : "sbi";

				if(quickTransferService.paymentType == 'sbi'){
					pay_type = 'SBI A/C';
				}
				else if(quickTransferService.paymentType == 'other'){
					pay_type = 'OTHER BANK A/C';
				}
				else if(quickTransferService.paymentType == 'mobile'){
					pay_type = 'MOBILE NUMBER';
				}
				$translate(['QT_HEADER'], {type: pay_type }).then(function (translations) {
                    quickTransferReviewBeneVm.header_txt = translations['QT_HEADER'];
                });

				quickTransferReviewBeneVm.name = quickTransferService.paymentData["beneName"];
				quickTransferReviewBeneVm.accountNumber = quickTransferService.paymentData["beneAccNo"];
				quickTransferReviewBeneVm.ifsc = quickTransferService.paymentData["ifsc"];
				quickTransferReviewBeneVm.beneMMID = quickTransferService.paymentData["mmid"];
				quickTransferReviewBeneVm.beneMobileNo = quickTransferService.paymentData["beneMobileNo"];
				quickTransferReviewBeneVm.beneNickName = quickTransferService.paymentData["beneNickName"];
				quickTransferReviewBeneVm.maxLimit = quickTransferService.paymentData["maxLimit"];
                
			}
   
			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
			});
			$scope.$on('$ionicView.loaded', function () {
			
			});

			quickTransferReviewBeneVm.goBack = function(){
				$ionicHistory.goBack();
			}

			quickTransferReviewBeneVm.goNext = function(){
				 profPassObj = {
					prevPage:"menu.quickTransferAddBeneView",
					nextPage:"menu.quickTransferProfilePasswordView",
					goto:"menu.setProfilePassword",
					ionicPopup:$ionicPopup,
					accOverviewData:accOverviewData
				};
				getAccountDetailsService.commonfunForProfilePassCheck(profPassObj);
			}

			quickTransferReviewBeneVm.gotoHome = function(){
				$ionicViewSwitcher.nextDirection('back');
            	$state.go("menu.quickTransferLanding");
			}

			return this;
		}

		
]);


