angularApp.service('fTReviewService', function($ionicPopup, $q, AdapterUtils, constantConfig) {
	var Reviewservice = this;
	Reviewservice.transactionFee = "";
	Reviewservice.getTransactionFee = function(reqParams) {
		var isSuccess = true;
		var q = $q.defer();
		AdapterUtils.postData(constantConfig.ftAdapterUrl.getTransactionFee,reqParams,true).then(
			function(response){	
				q.resolve(response.data);
			},
			function(error){	
				q.reject(error);
			}); 
		return q.promise;
	};
	
	Reviewservice.getProfilePassAndSerKey = function() {
		var isSuccess = true;
		var q = $q.defer();
		var payload = {};
		AdapterUtils.postData("adapters/PreHomeLoginAdapter/getProfileSecretKey", payload,true).then(
			function(response){	
				q.resolve(response.data);
			},
			function(error){	
				q.reject(error);
			}); 
		return q.promise;
	};
	
	Reviewservice.getProfilePassAuth = function(payload) {
		var isSuccess = true;
		var q = $q.defer();
		AdapterUtils.postData("adapters/PreHomeLoginAdapter/profilePasswordAuthenticateService", payload,true).then(
			function(response){	
				q.resolve(response.data);
			},
			function(error){	
				q.reject(error);
			}); 
		return q.promise;
	};
	Reviewservice.validateProfilePasswordSecure = function(payload) {
		var isSuccess = true;
		var q = $q.defer();
		AdapterUtils.postData("adapters/ServiceRequestAdapter/validateProfilePasswordSecure", payload,true).then(
			function(response){	
				q.resolve(response.data);
			},
			function(error){	
				q.reject(error);
			}); 
		return q.promise;
	};
	
	return Reviewservice;
});
