angularApp.service('generalInsurenceHomeService', ["$filter", "$state", "genralInsurenceConfig",  "$q", "AdapterUtils", "utilityService", 
    function($filter, $state, genralInsurenceConfig, $q, AdapterUtils, utilityService) {

        var generalInsurenceHome = this;
		var renewClickedFlag = false;
        var productDetail, healthProduct, accountDetail, planDetail, IIBaccountDetail, policyCreate, didYouKnowDetail, policyTerm, quoteListDetail, CreatePartyCI, onlinePolicy, agentRecipt, policyDetail, locationDetail, locationDetails, giProducts, productID,productList, newpolicyDetail, selectedProduct, saveApplicationHealth, saveApplicationArogya, saveApplicationCriticalIllness, saveApplicationHDC, refData, backNavigationState, landingPage;
        var LocatiopnBasedPincode,applicationNum,allJournyList;
        var sumInsured,policystartDate,renewDetail,allProductListAPI,allProductListDetailsAPI,desclamierAPI,quoteNumber,policyCreatedDate,calculatedKey;

        var autoRenewal=false;
		
        generalInsurenceHome.clearAll = function(){
             productDetail= null; healthProduct= null; accountDetail= null; planDetail= null; IIBaccountDetail= null; policyCreate= null; didYouKnowDetail= null; policyTerm= null; quoteListDetail= null; CreatePartyCI= null; onlinePolicy= null; 
             agentRecipt = null; policyDetail= null; locationDetail= null; locationDetails= null; productID= null;productList=null; newpolicyDetail= null; selectedProduct= null; saveApplicationHealth= null; saveApplicationArogya= null; 
             saveApplicationCriticalIllness= null; saveApplicationHDC = null;LocatiopnBasedPincode= null;applicationNum= null;allJournyList = null;sumInsured= null;policystartDate= null;renewDetail =  null,quoteNumber = null,policyCreatedDate = null;calculatedKey = null;
        }


         generalInsurenceHome.getRecommend = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getRecommend[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


         generalInsurenceHome.getAllPlans = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getAllPlans[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

         generalInsurenceHome.getDidYouKnowList = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.didYouKnowList[0],data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

         generalInsurenceHome.getRecomendedDetail = function(data) {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.recomendedDetail[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getPlan = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getPlan[0],data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

         generalInsurenceHome.getClaimIntimation = function(data) {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getClaimIntimation[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        

         generalInsurenceHome.eInsuranceAccount = function(data) {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.eInsuranceAccount[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.requestSubmitMotor = function(data) {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.requestSubmitMotor[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

         generalInsurenceHome.requestSubmitNonMotor = function(data) {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.requestSubmitNonMotor[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

           // get banner data
        generalInsurenceHome.getInsuranceBannerPage = function() {
        
            var q = $q.defer();
            AdapterUtils.postData("adapters/GeneralInsuranceAdapter/getInsuranceBannerPage", {}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

      // get allPlans
        generalInsurenceHome.getAllRedesignPlans = function() {
        
            var q = $q.defer();
            AdapterUtils.postData("adapters/GeneralInsuranceAdapter/getAllRedesignPlans", {}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.setBackNavigationState = function(state) {
            backNavigationState = state;
        }

        generalInsurenceHome.getBackNavigationState = function() {
            return backNavigationState;
        }

        generalInsurenceHome.setLandingPage = function(page) {
            landingPage = page;
        }

        generalInsurenceHome.getLandingPage = function() {
            return landingPage;
        }

        generalInsurenceHome.setaccountDetail = function(account) {
            accountDetail = account;
        };

        generalInsurenceHome.getaccountDetail = function(data) {
            return accountDetail;
        };


        generalInsurenceHome.setIIBaccountDetail = function(account) {
            IIBaccountDetail = account;

        };

        generalInsurenceHome.getIIBaccountDetail = function() {
            return IIBaccountDetail;
        };


        generalInsurenceHome.setDidYouKnowDetail = function(didYouKnow) {
            didYouKnowDetail = didYouKnow;

        };

        generalInsurenceHome.getDidYouKnowDetail = function() {
            return didYouKnowDetail;
        };

        generalInsurenceHome.setPlanDetail = function(data) {
            planDetail = data;

        };

        generalInsurenceHome.getPlanDetail = function() {
            return planDetail;
        };

        generalInsurenceHome.setProductID = function(data) {
            productID = data;

        };
        generalInsurenceHome.getGIProductList = function() {
            return productList;
        };

        generalInsurenceHome.setGIProductList = function(data) {
            productList = data;

        };

        generalInsurenceHome.getProductID = function() {
            return productID;
        };

        generalInsurenceHome.setQuoteListDetails = function(quoteList) {
            quoteListDetail = quoteList;
        }
        generalInsurenceHome.getQuoteListDetails = function() {
            return quoteListDetail;
        }


        generalInsurenceHome.setLinkedpolicyDetailDetails = function(data) {
            policyDetail = data;
        }
        generalInsurenceHome.getLinkedpolicyDetailDetails = function() {
            return policyDetail;
        }

        generalInsurenceHome.setLinkedpolicyDetailDetailsNew = function(data) {
            newpolicyDetail = data;
        }
        generalInsurenceHome.getLinkedpolicyDetailDetailsNew = function() {
            return newpolicyDetail;
        }


        generalInsurenceHome.setpolicyStartdate = function(data) {
            policystartDate = data;
        }
        generalInsurenceHome.getpolicyStartdate = function() {
            return policystartDate;
        }
        
        generalInsurenceHome.setpolicySumInsured = function(data) {
            sumInsured = data;
        }
        generalInsurenceHome.getpolicySumInsured = function() {
            return sumInsured;
        }

        generalInsurenceHome.setRenewDetail = function(data) {
            renewDetail = data;
        }

        generalInsurenceHome.getRenewDetail = function() {
            return renewDetail;
        }

        generalInsurenceHome.setQuoteNumber = function(quote){
                quoteNumber = quote;
        }
        generalInsurenceHome.getQuoteNumber = function(){
                return  quoteNumber;
        }

        //for topnbottom banner for prelogin Insurance 
        generalInsurenceHome.getInsurePreBanners = function (payload) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FSSCommonAdapter/oa/v1/getInsurancePreLoginBanners", payload, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
        /* for more products */
        generalInsurenceHome.browseMoreProducts = function (payload) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FSSCommonAdapter/oa/v1/getRecommendedProductsAndContent", payload, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
        //for lead generation
         generalInsurenceHome.insurLeadGenerate = function (payload) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FSSCommonAdapter/oa/v1/createCrmLead", payload, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
        //for insure products list
         generalInsurenceHome.insurLeadProducts = function (payload) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FSSCommonAdapter/oa/v1/getInsurancePreLoginProductList", payload, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

        generalInsurenceHome.loadPersonalAccidentBannerInfo = function() {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getBannerInfo[0], {}, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
// Method to get cards papl banner from wcm
        generalInsurenceHome.getCardswithPapl = function(){
            var q = $q.defer();
            AdapterUtils.postData("adapters/CardsAdapterv2/getCardWithPaplWcm", {}, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }

        generalInsurenceHome.getEInsuranceData = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getEInsuranceData[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getProductFeatures = function(product) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getPlanDetails[0], product, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getDisclaimer = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getDisclaimer[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getAllGIProducts = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getAllGIProducts[0], false).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getSBIBankAccounts = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getSBIBankAccounts[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        generalInsurenceHome.getPartyCreation = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.createParty[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getPartyCreationInsured = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.createPartyInsured[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        generalInsurenceHome.getSBIBankAccoutDetails = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getSBIBankAccountDetails[0], data, true).then(
                function(response) {
                    if(response.data && response.data.cbsData && response.data.cbsData.middleName){
                        response.data.cbsData.firstName = response.data.cbsData.firstName + " " +response.data.cbsData.middleName;
                        response.data.cbsData.middleName = "";
                    }
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.applyHDCPremium = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getHDCPremiumCalculation[0], data, true).then(
                function(response) {
                    if(response.data){
                        quoteNumber = response.data.premiumCalculation.quoteNumber;
                    } 
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.applyHIArogyaPremium = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.applyHIArogyaProduct[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.applySimpleHealthQuote = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.applySimpleHealthQuote[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.applyHDCQuote = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.applyHDCQuote[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        generalInsurenceHome.getLocation = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getLocation[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };




        generalInsurenceHome.getLinkedpolicies = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getGILinkedPolicies[0], data, false).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        generalInsurenceHome.getDocSearch = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getDocSearch[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.payForSHPurchase = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.payForSHPurchase[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

       //function for validating otp for Simple Health        
        generalInsurenceHome.validateOTPForSHPayment = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.validateOTPForSHPayment[0], data, true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

       //function for Resend otp for Simple Health        
        generalInsurenceHome.resendOTPForSHPayment = function() {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.resendOTPForSH[0], true).then(
                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        function showAlertModal(title, template, onTapgo, $scope, $state, buttontext) { 
                var alertPopup = $ionicPopup.alert({
                    title : title,
                    template : template,
                    scope : $scope,
                    cssClass : 'sbi-alert-popup',
                    buttons : [
                        {
                            text : buttontext,
                            type : 'button-positive',
                            onTap : function() {
                                if (onTapgo !== '' && onTapgo !== null) {
                                    $state.go(onTapgo);
                                } else {
                                }
                            }
                        }
                    ],
                });
                alertPopup.then(function(res) {
                });
            };


        generalInsurenceHome.getTermsAndCondtion = function(url) {
            cordova.ThemeableBrowser.open(url, '_system');
        };



         generalInsurenceHome.getDiclaration = function() {
             var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getDiclaration[0], true).then(
                function(response) {
                    var title = "Declaration";
                    var buttontext = "OK";
                    var blankdata = null;
                    var detail = $filter('ngBindHtmlFilter')(response.data.msg);
                    utilityService.showAlertModal(title, detail, blankdata, blankdata, $state, buttontext)

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };



       





        generalInsurenceHome.saveApplication = function(data,omniChannel) {
            var q = $q.defer();
            data.quoteNumber = quoteNumber ? quoteNumber : "";
            data.policyStartDate = data.policyStartDate && data.policyStartDate!="" ?  $filter('startDateWithTimezone')(data.policyStartDate) : "";
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.saveApplication[0], data, true).then(
                function(response) {

                    generalInsurenceHome.saveListforOmni(omniChannel,response.data.applicationNumber);
                    applicationNum = response.data.applicationNumber;
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };





        generalInsurenceHome.getSavedApplicationForAPI = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getSavedApplication[0], data, true).then(
                function(response) {
                    
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        generalInsurenceHome.getSavedApplications = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getSavedApplications[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        generalInsurenceHome.getQuoteDetail = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getQuoteDetails[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.getRenewalPolicy = function(data) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(genralInsurenceConfig.adapterURL.getRenewalPolicy[0], data, true,240000).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
		
		generalInsurenceHome.getPAIRenewalDetails = function(data) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getPAIRenewalDetails[0], data, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        generalInsurenceHome.getJourneyMaster = function() {
            var q = $q.defer();
            var request = {
                "journeyType" : "GI"
            }
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getJourneyMaster[0], request, true).then(
                function(response) {
                    allJournyList =  response.data;
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHome.saveListforOmni = function(breakpoints,applicationNumber){
                    var breakPointDetail;
             breakPointDetail =  $filter('selectBoxFilter')(allJournyList,breakpoints,"commonId");   
             if(!breakPointDetail){
                breakPointDetail = {};
             }   
                     var currentTime = generalInsurenceHome.getCurrentDate().getTime();
                    var payload  = {
                          "id": applicationNumber,
                          "journey": [
                            {
                              "journeyType": "GI",
                              "commonId": breakpoints,
                              "lastModifiedTime": currentTime+"",
                              "lastModifiedBy": "Mobile",
                              "portalURL": breakPointDetail.portalURL,
                              "mobileURL": breakPointDetail.mobileURL
                            }
                          ]
                    }
             var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.saveJourney[0], payload, false).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        }


          generalInsurenceHome.redirectForOmni = function(payload){
              var q = $q.defer();
              AdapterUtils.postData(genralInsurenceConfig.adapterURL.getSavedJourney[0], payload, true).then(
                function(response) {
                    if(response.data.mobileURL){
                     $state.go(response.data.mobileURL);
                    }else{
                       var  breakPointDetail =  $filter('selectBoxFilter')(allJournyList,response.data.commonId,"commonId");
                        $state.go(breakPointDetail.mobileURL);
                    }
                    q.resolve(response.data);

                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
          }


          generalInsurenceHome.getDocumentList = function(){
              var q = $q.defer();
              AdapterUtils.postData(genralInsurenceConfig.adapterURL.getDocumentList[0], true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
          }








        generalInsurenceHome.setProductDetail = function(data) {
            productDetail = data;
        }


        generalInsurenceHome.getProductDetail = function() {
            return productDetail
        }



        generalInsurenceHome.setReferralCode = function(data) {
            refData = data;
        }


        generalInsurenceHome.getReferralCode = function() {
            return refData
        }


        generalInsurenceHome.getCurrentDate = function() {
            return new Date();
        }


        generalInsurenceHome.getPreviousYears = function(noOfYears) {
            var date = new Date();
            var years = [];
            for(var i = 0; i < noOfYears ; i++){
                years[i] = date.getFullYear() - i;
            }
            return years;
        }

        generalInsurenceHome.getFutureDate = function(date, future) {
            date = new Date(date);
            date.setDate(date.getDate() + future);
            return $filter('chosenDate')(date);
        }

        generalInsurenceHome.getFutureMonth = function(date, future) {
            date = new Date(date);
            date.setMonth(date.getMonth() + future);
            return $filter('chosenDate')(date);
        }


        generalInsurenceHome.getFutureYear = function(date, year) {
            var years = Number(year);
            date = new Date(date);
            var futureYear = date.setFullYear(date.getFullYear() + years);
            var days = new Date(date);
            days.setDate(days.getDate() + -1);
            return $filter('chosenDate')(days);
        }

        generalInsurenceHome.setHealthProduct = function(data) {
            healthProduct = angular.copy(data);
        }

        generalInsurenceHome.getHealthProduct = function() {
            return angular.copy(healthProduct);
        }
        generalInsurenceHome.setPolicyTerm = function(data) {
            policyTerm = data;
        }

        generalInsurenceHome.getPolicyTerm = function() {
            return policyTerm;
        }


        generalInsurenceHome.setCreatePartyCI = function(data) {
            CreatePartyCI = data;
        }

        generalInsurenceHome.getCreatePartyCI = function() {
            return CreatePartyCI;
        }

        generalInsurenceHome.setOnlinePolicy = function(data) {
            onlinePolicy = data;
        }

        generalInsurenceHome.getOnlinePolicy = function() {
            return onlinePolicy;
        }

        generalInsurenceHome.setPolicyCreateDetail = function(data) {
            policyCreate = data;
        }

        generalInsurenceHome.getPolicyCreateDetail = function() {
            return policyCreate;
        }
        generalInsurenceHome.setAgentRecipt = function(data) {
            agentRecipt = data;
        }

        generalInsurenceHome.getAgentRecipt = function() {
            return agentRecipt;
        }
        generalInsurenceHome.setLocationDetail = function(location) {
            locationDetail = location;
        }

        generalInsurenceHome.getLocationDetail = function() {
            return locationDetail;
        }
        generalInsurenceHome.setLocationDetails = function(locationDetail) {
            locationDetails = locationDetail;
        }

        generalInsurenceHome.getLocationDetails = function() {
            return locationDetails;
        }

        generalInsurenceHome.setGIProducts = function(giProducts1) {
            giProducts = angular.copy(giProducts1);
        }

        generalInsurenceHome.getGIProducts = function() {
            return angular.copy(giProducts);
        }

        generalInsurenceHome.setGIProductsID = function(selectedProductID) {
            selectedProduct = angular.copy(selectedProductID);
        }

        generalInsurenceHome.getGIProductsID = function() {
            return angular.copy(selectedProduct);
        }

        generalInsurenceHome.setLocatiopnBasedPincode = function(Location) {
            LocatiopnBasedPincode = Location;
        }


        generalInsurenceHome.getLocatiopnBasedPincode = function() {
            return LocatiopnBasedPincode;
        }


        generalInsurenceHome.setapplicationNumber = function(applionNum) {
            applicationNum = applionNum;
        }


        generalInsurenceHome.getapplicationNumber = function() {
            return applicationNum;
        }

         generalInsurenceHome.setJourneyMasterList = function(journyList) {
            allJournyList = journyList;
        }


        generalInsurenceHome.getJourneyMasterList = function() {
            return allJournyList;
        }


         generalInsurenceHome.setAllProductListAPI = function(allProdLstAPI) {
            allProductListAPI =  allProdLstAPI;
        }

         generalInsurenceHome.getAllProductListAPI = function() {
            return allProductListAPI;
        }

        generalInsurenceHome.setAllProductListDetailsAPI = function(allProdLstAPI) {
            allProductListDetailsAPI =  allProdLstAPI;
        }

         generalInsurenceHome.getAllProductListDetailsAPI = function() {
            return allProductListDetailsAPI;
        }

        generalInsurenceHome.setDesclamaierAPI = function(desclamier) {
           desclamierAPI =  desclamier;
        }

         generalInsurenceHome.getDesclamaierAPI = function() {
            return desclamierAPI;
        }


        generalInsurenceHome.setpolicyCreatedDate = function(cDate) {
           policyCreatedDate =  cDate;
        }

         generalInsurenceHome.getpolicyCreatedDate = function() {
            return policyCreatedDate;
        }

        generalInsurenceHome.verifySecKey = function(secKey) {
            return calculatedKey=((secKey/2)-1)/99;
        }

        generalInsurenceHome.generateSecKey = function() {
            var requestDate = new Date();
	    requestDate = requestDate.getTime()
	    var randomNumber=Math.floor((Math.random()) + requestDate);
	    randomNumber = (randomNumber * 10 + 1);
	    return randomNumber;
        }

        generalInsurenceHome.calculateAge = function(startdate,endData) {
            var today = new Date(startdate);
            var birthDate = new Date(endData);
            var age = Number(today.getFullYear() - birthDate.getFullYear());
            var m = today.getMonth() - birthDate.getMonth();
            if (m < 0 || (m === 0 && today.getDate() < birthDate.getDate())) {
                age--;
            }
            return age;
        }

        generalInsurenceHome.isJson = function(str) {
            try {
                JSON.parse(str);
            } catch (e) {
                return false;
            }
            return true;
        }

        generalInsurenceHome.getvalueforSelectBox = function(list, value, keys) {
            for (var count = 0; count < list.length; count++) {
                if (keys) {
                    if (list[count][keys] == value) {
                        return list[count];
                    }
                } else {
                    if (list[count].key == value) {
                        return list[count];
                    }
                }
            }
        }


        generalInsurenceHome.setObjectForSave = function(savedData, cloudName, pageDetail, modelname, type) {
            var s = modelname;
            var t = cloudName;
            var sourcecount = s.split(".");
            var destCount = t.split(".");
            var sourcelen = 0;
            var destlen = 0;
            var value = s.split('.').reduce(function(a, b) {
                if(a){
                     return a[b];
                }
            }, pageDetail);
            var assignedValue = t.split('.').reduce(function(c, d) {
                destlen++
                if (destlen == destCount.length) {

                    switch (type) {
                        case 'date':
                            c[d] = new Date(value);
                            break;
                        case 'selectKey':
                        if(value){
                            c[d] = value.key;
                        }else{
                            c[d] = "";
                        }
                            
                            break;
                        case 'amount':
                            c[d] = $filter('formatAmount')(value);
                            break;
                        case 'array':
                            c[d] = $filter('formatAmount')(value);
                            break;
                         case 'boolean':
                                var checkempty  = (angular.equals({}, value)) ? false : true;
                                c[d] = (!value || !checkempty) ? false : true;
                            break;
                        default:
                            c[d] = value;
                    }
                }
                if (destlen != destCount.length) {
                    if (!c[d]) {
                        c[d] = {};
                    }
                }
                return c[d];
            }, savedData);
            return savedData;
        }



        generalInsurenceHome.setObjectForService = function(savedData, cloudName, pageDetail, modelname, type) {
            var s = cloudName;
            var t = modelname;
            var sourcecount = s.split(".");
            var destCount = t.split(".");
            var sourcelen = 0;
            var destlen = 0;

            var value = s.split('.').reduce(function(a, b) {
                 if(a){
                return a[b];
             }
            }, savedData);

            var assignedValue = t.split('.').reduce(function(c, d) {
                destlen++
                if (destlen == destCount.length) {

                    switch (type) {
                        case 'date':
                            c[d] = $filter('chosenDate')(value);
                            break;
                        case 'selectKey':
                            c[d] = value;
                            break;
                        case 'amount':
                            c[d] = $filter('formatAmount')(value);
                            break;
                         case 'boolean':

                                var checkempty  = (angular.equals({}, value)) ? false : true;
                                c[d] = (!value || !checkempty) ? false : true;
                                if(value == ""){
                                  c[d] =  false;  
                                }else if(value == true){
                                    c[d] =  true; 
                                }
                            break;
                        case 'array':
                            c[d] = $filter('formatAmount')(value);
                            break;
                        default:
                            c[d] = value;
                    }
                }

                if (!c[d]) {
                    c[d] = "";
                }else if((angular.equals({}, c[d])) ? true : false) {
                     c[d] = "";
                }

                return c[d];
            }, pageDetail);
            return pageDetail;
        }

        generalInsurenceHome.getPageRoute = function(pagename) {
            var currentDevice = pagename.split('_');
            var pageRoute = currentDevice[1];
            var pageDetail = {
                "cardPersonalDetails1": "personal.Details",
                "cardPersonalDetails2": "cardProfessional.Details",
                "cardProfessional1": "cardProfessional.Details",
                "cardProfessional2": "cardProfessional.Details"
            }
            if (currentDevice[0] == 'mobile') {
                return pageRoute;
            } else {
                for (var key in pageDetail) {
                    if (pageDetail.hasOwnProperty(key)) {
                        if (pageDetail[key] == pagename) {
                            return key;
                        }
                    }
                }
            }
        }

        generalInsurenceHome.getSaveApplicationSimpleHealth = function() {
            var saveApplication = {
                "cif": "",
                "applicationNumber": "",
                "productCode": "string",
                "uin": "string",
                "planName": "string",
                "mobileNumber": "string",
                "quoteData": {},
                "applicationData": {}
            }
            return saveApplication;
        }

        generalInsurenceHome.setSaveApplicationHealthStructure = function(saveApplication) {
            saveApplicationHealth = saveApplication;
        }
        generalInsurenceHome.getSaveApplicationHealthStructure = function() {
            return saveApplicationHealth;
        }

        generalInsurenceHome.setSaveApplicationArogyaStructure = function(saveApplication) {
            saveApplicationArogya = saveApplication;
        }
        generalInsurenceHome.getSaveApplicationArogyaStructure = function() {
            return saveApplicationArogya;
        }

        generalInsurenceHome.setSaveApplicationCriticalStructure = function(saveApplication) {
            saveApplicationCriticalIllness = saveApplication;
        }
        generalInsurenceHome.getSaveApplicationCriticalStructure = function() {
            return saveApplicationCriticalIllness;
        }

        generalInsurenceHome.setSaveApplicationHDCStructure = function(saveApplication) {
            saveApplicationHDC = saveApplication;
        }
        generalInsurenceHome.getSaveApplicationHDCStructure = function() {
            return saveApplicationHDC;
        }

        return generalInsurenceHome;
		
		return {
			renewClickedFlag: renewClickedFlag
		}
		

    }
]);
