angularApp.controller('paymentOtpController', [
    "$state",
    "$scope",
    "$translate", "$ionicPopup", "$filter",  "utilityService",  "validateService", "generalInsurenceHomeService", "generalInsurenceHealthService",
    "generalInsurenceAccidentService", "customerInfoService","$stateParams","generalInsurenceTravelService","generalInsurenceHomeDetailService","generalInsurenceMotorService","lifeInsuranceCommonService","GIconstant",
    function(
        $state,
        $scope,
        $translate, $ionicPopup, $filter,  utilityService,  validateService, generalInsurenceHomeService, generalInsurenceHealthService, 
        generalInsurenceAccidentService,customerInfoService,$stateParams,generalInsurenceTravelService,generalInsurenceHomeDetailService,generalInsurenceMotorService,lifeInsuranceCommonService,GIconstant) {

        var paymentOtpVm = this;
        var paiPaymentDetail;
        var paymentDetailAfterPayment;
        var productUid;
        var quoteCalculationDetail;
         var personalDetail;
        var savedApplication;
        var productSiCodeDetail;
                                               
                                               
   
        function initPage() {
            var rupeeSymbol = String.fromCharCode(8377);
            paymentOtpVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
            paymentOtpVm.clickCount = 0;
            paymentOtpVm.isResendOTP = false;
            paymentOtpVm.isResendDisabled=false;
                                               
        paymentOtpVm.renewal =  generalInsurenceHomeService.autoRenew;
           // paymentOtpVm.mobileNumber = $filter('cardmask')("1234567890", 'X', 4);
                                               
                                               paymentOtpVm.accountList = "";
                                               paymentOtpVm.balance = "";
                                               paymentOtpVm.paymentForm = {};
                                               savedApplication = generalInsurenceHomeDetailService.getSavedData();
                                               productUid = generalInsurenceHomeService.getProductDetail().uin;
                                               productSiCodeDetail = generalInsurenceHomeService.getPlanDetail();
                                               var uin = {
                                               'uin': productUid
                                               }
                                               
            productUid = generalInsurenceHomeService.getProductDetail().uin;
            quoteCalculationDetail = generalInsurenceHealthService.getQuotecalculation();
                                               paymentOtpVm.quoteNUmber = generalInsurenceHomeService.getQuoteNumber();
                                               paymentOtpVm.premiumAmount = quoteCalculationDetail.quoteCreation.actualPremiumPayable;
                                               paymentOtpVm.sumAssured  =   generalInsurenceHomeService.getpolicySumInsured();
                                  
                                               
                                               
            paymentOtpVm.premiumAmount = generalInsurenceHealthService.getQuotecalculation().quoteCreation.actualPremiumPayable;
            paymentOtpVm.enterOTP='Please enter OTP to make Payment of ' +  rupeeSymbol + paymentOtpVm.premiumAmount + '.';
                                               
                                               switch($stateParams.page){
                                               case  'travel' :
                                               personalDetail = {};
                                               generalInsurenceTravelService.getProposerContactDetail();
                                               personalDetail.firstName = generalInsurenceTravelService.getProposerContactDetail().firstName;
                                               personalDetail.LastName = generalInsurenceTravelService.getProposerContactDetail().lastName;
                                               personalDetail.birthdate = generalInsurenceTravelService.getProposerContactDetail().birthdate;
                                               personalDetail.email = generalInsurenceTravelService.getProposerContactDetail().emailID;
                                               personalDetail.address1 = generalInsurenceTravelService.getProposerContactDetail().plotNO;
                                               personalDetail.address2 = generalInsurenceTravelService.getProposerContactDetail().buildingName;
                                               personalDetail.address3 = generalInsurenceTravelService.getProposerContactDetail().streetName;
                                               break;
                                               case  'home' :
                                               personalDetail = {};
                                               personalDetail.firstName = generalInsurenceHomeDetailService.getPersonalFifthpageDetail().firstName;
                                               personalDetail.LastName = generalInsurenceHomeDetailService.getPersonalFifthpageDetail().LastName;
                                               personalDetail.birthdate = generalInsurenceHomeDetailService.getPersonalFifthpageDetail().birthDate;
                                               personalDetail.email = generalInsurenceHomeDetailService.getPersonalFifthpageDetail().emailID;
                                               personalDetail.address1 = generalInsurenceHomeDetailService.getPersonalForthpageDetail().ploatNo;
                                               personalDetail.address2 = generalInsurenceHomeDetailService.getPersonalForthpageDetail().buildingName;
                                               personalDetail.address3 = generalInsurenceHomeDetailService.getPersonalForthpageDetail().streetName;
                                               break;
                                               case  'motor':
                                               personalDetail = {};
                                               personalDetail.firstName = generalInsurenceMotorService.getMotorPersonalFirstPageDetail().firstName;
                                               personalDetail.LastName = generalInsurenceMotorService.getMotorPersonalFirstPageDetail().LastName;
                                               personalDetail.email = generalInsurenceMotorService.getMotorPersonalFirstPageDetail().emailID;
                                               personalDetail.birthdate = generalInsurenceMotorService.getMotorPersonalFirstPageDetail().birthday;
                                               personalDetail.address1 = generalInsurenceMotorService.getMotorPersonalSecondPageDetail().plotNO;
                                               personalDetail.address2 = generalInsurenceMotorService.getMotorPersonalSecondPageDetail().BuildingName;
                                               personalDetail.address3 = generalInsurenceMotorService.getMotorPersonalSecondPageDetail().StreetName;
                                               break;
                                               case  'accident' :
                                               personalDetail = {};
                                               var PAIpersonalInfo = generalInsurenceAccidentService.getInsuredDetails()
                                               personalDetail.birthdate = PAIpersonalInfo.dob;
                                               personalDetail.firstName = PAIpersonalInfo.firstName;
                                               personalDetail.LastName = PAIpersonalInfo.lastName;
                                               personalDetail.email = PAIpersonalInfo.emailId;
                                               personalDetail.address1 = PAIpersonalInfo.plotNo;
                                               personalDetail.address2 = PAIpersonalInfo.buildingName;
                                               personalDetail.address3 = PAIpersonalInfo.streetName;
                                               break;
                                               case 'health' :
                                               personalDetail = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
                                               break;
                                               default : 
                                               personalDetail = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
                                               break;
                                               
                                               }
        }

       // Function to call validateOTP API from adapter for all 3 payments..
        paymentOtpVm.validateOTP = function(){
            var reqParams = {};
            var requestSecKey=generalInsurenceHomeService.generateSecKey();
            reqParams.otp = paymentOtpVm.getOTPNumber;
            reqParams.secKey = requestSecKey;

            if(productUid == "14" && !generalInsurenceHomeService.renewClickedFlag){
				
                generalInsurenceHomeService.validateOTPForSHPayment(reqParams).then(function(response){                                                                    
                  var newNumber=parseInt(response.data.secKey) ;
                  var generatedNumber = generalInsurenceHomeService.verifySecKey(newNumber);
                  if(reqParams.secKey!=generatedNumber){
                      utilityService.hideSpinner();
                      utilityService.showErrorMessage(response.responseMessage)
                  }else if(response.data.otpStatus == "0000"){
					  
                      paymentDetailAfterPayment = response.data;
                      getAgentRecipt(response.data);
                      utilityService.setCsatJournies('generalInsurance'); 
                  }else if(data.otpStatus != "0000"){
                        paymentOtpVm.resetPinOTP.getOTPNumber = response.responseMessage;
                  }
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                })
                
            }else if(productUid == "44"){
				var renewalDetail = generalInsurenceHomeService.getRenewDetail();
				if(renewalDetail && renewalDetail.isRenewal){
					generalInsurenceHealthService.validateOTPForPAIRenewal(reqParams).then(function(data) {
						var newNumber=parseInt(data.secKey) ;
					    var generatedNumber = generalInsurenceHomeService.verifySecKey(newNumber);
					    if(reqParams.secKey!=generatedNumber){
							utilityService.hideSpinner();
							utilityService.showErrorMessage(GIconstant.errorMessage);
						}else if(data.otpStatus == "0000"){
							generalInsurenceHomeService.setLinkedpolicyDetailDetails(data.policy);
							data.policy.onlinePolicy = {};
							data.policy.onlinePolicy.policyNumber = data.policy.policyNo;
							generalInsurenceHomeService.setOnlinePolicy(data.payment);
							$state.go('menu.healthPaymentSuccess');
							utilityService.setCsatJournies('generalInsurance');
						}else if(response.data.otpStatus != "0000"){
							paymentOtpVm.resetPinOTP.getOTPNumber = response.responseMessage;
						}
					}, function(error) {
						//renewalDetail.isRenewal = false;
						generalInsurenceHomeService.setRenewDetail(renewalDetail);
						//utilityService.showAlertModal("", $translate.instant("PAYMENT_FAILURE_MSG"), "menu.generalInsurance", $scope, $state, "OK");
						utilityService.showErrorMessage(error.responseMessage);
					});
				}else{
					generalInsurenceAccidentService.validateOTPForPAIPayment(reqParams).then(function(response){                                                                         
					    var newNumber=parseInt(response.data.secKey) ;
					    var generatedNumber = generalInsurenceHomeService.verifySecKey(newNumber);
					    if(reqParams.secKey!=generatedNumber){
							utilityService.hideSpinner();
							utilityService.showErrorMessage(response.responseMessage);
						}else if(response.data.otpStatus == "0000"){
							utilityService.setCsatJournies('generalInsurance');
							paiPaymentDetail =  response.data;
							generalInsurenceHomeService.setOnlinePolicy(response.data.payment);
							policyCreate();
						}else if(response.data.otpStatus != "0000"){
							paymentOtpVm.resetPinOTP.getOTPNumber = response.responseMessage;
						}
					},function(error) {
						utilityService.showErrorMessage(error.responseMessage);
					})
				}	
            }else{
				
               generalInsurenceHealthService.validateOTPForOtherPayment(reqParams).then(function(response){                                                                             
                var newNumber=parseInt(response.data.secKey) ;
                var generatedNumber = generalInsurenceHomeService.verifySecKey(newNumber);
                if(reqParams.secKey!=generatedNumber){
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(response.responseMessage);
                }else if(response.data.otpStatus == "0000"){
					if(generalInsurenceHomeService.getRenewDetail() && generalInsurenceHomeService.getRenewDetail().isRenewal){
						generalInsurenceHomeService.setLinkedpolicyDetailDetails(response.data.policy);
						response.data.policy.onlinePolicy = {};
						response.data.policy.onlinePolicy.policyNumber = response.data.policy.policyNo;
						generalInsurenceHomeService.setOnlinePolicy(response.data.policy);
						$state.go('menu.healthPaymentSuccess');
						utilityService.setCsatJournies('generalInsurance');
					}else{
						paymentDetailAfterPayment = response.data;
						getAgentRecipt(response.data);
						utilityService.setCsatJournies('generalInsurance');
					}
                }else if(response.data.otpStatus != "0000"){
                    paymentOtpVm.resetPinOTP.getOTPNumber = response.responseMessage;
                }
               },function(error) {
				    if(error.responseCode == "GIPPT01"){
						utilityService.showAlertModal("Payment Received", $translate.instant("POLICY_ISSUE_FAILURE"), "menu.generalInsurance", $scope, $state, "OK");
				    }else{
						utilityService.showAlertModal("", $translate.instant("PAYMENT_FAILURE_MSG"), "menu.generalInsurance", $scope, $state, "OK");  
				    }
            })
            }
        }

        function getAgentRecipt(paymentDetail) {
            var planDetail = generalInsurenceHomeService.getPlanDetail();
            var currentDate = generalInsurenceHomeService.getCurrentDate();			
			var getAgentReceipt = {
			"agentReceiptDetailsRequest": {
				"instumentTotal": quoteCalculationDetail.quoteCreation.actualPremiumPayable,
				"payor": quoteCalculationDetail.quoteCreation.policyTerms.customerCode,
				"payorCustCodeArr": quoteCalculationDetail.quoteCreation.policyTerms.customerCode,
				"payorType": "individual",
				"quoteNo": quoteCalculationDetail.quoteCreation.quoteNumber,
				"receiveAmountArr": quoteCalculationDetail.quoteCreation.actualPremiumPayable,
				"totalPremium": quoteCalculationDetail.quoteCreation.actualPremiumPayable,
				"transationID": paymentDetail.payment.paymentRefNumber,
				"receiptDate": $filter('newdateFormat')(currentDate),
				"con": paymentDetail.payment.lotusRefNumber,
				"productCode": planDetail.productCode,
				"productSubCode": planDetail.productSubCode
				}
			}
			
            
            generalInsurenceHealthService.getAgentReceipt(getAgentReceipt).then(function(data) {
                getOnlinepolicy();
                generalInsurenceHomeService.setAgentRecipt(data);
            }, function(error) {
                showRetry("Payment Received", $translate.instant("POLICY_ISSUE_FAILURE"), "agent");
            });
        }
                                               
                                               
                                               function showRetry(title, template, funName) {
                                               var alertPopup = $ionicPopup.alert({
                                                                                  title: title,
                                                                                  template: template,
                                                                                  scope: $scope,
                                                                                  cssClass: 'sbi-alert-popup',
                                                                                  buttons: [{
                                                                                            text: 'OK',
                                                                                            type: 'button-positive',
                                                                                            onTap: function(e) {
                                                                                            return true;
                                                                                            }
                                                                                            }]
                                                                                  
                                                                                  });
                                               alertPopup.then(function(res) {
                                                               $state.go('menu.generalInsurance');
                                                               });
                                               
                                               }
                                     

        function getOnlinepolicy() {
            var planDetail = generalInsurenceHomeService.getPlanDetail();
			var getOnlinePolicy = {
				"onlinePolicy": {
					"transactionType": "1",
					"quoteNumber": quoteCalculationDetail.quoteCreation.quoteNumber,
					"productCode": planDetail.productCode,
					"productSubCode": planDetail.productSubCode,
					"lotusRefNumber" : paymentDetailAfterPayment.payment.lotusRefNumber
				}
			}
            generalInsurenceHealthService.getOnlinePolicy(getOnlinePolicy).then(function(data) {
                generalInsurenceHomeService.setOnlinePolicy(data);
                policyCreate();
            }, function(error) {
                showRetry("Payment Received", $translate.instant("POLICY_ISSUE_FAILURE"), "online");
            });
        }

        function policyCreate() {		
			var productDetail = generalInsurenceHomeService.getProductDetail();
			var productID = generalInsurenceHomeService.getProductID();
			if ($stateParams.page == "motor") {
				productDetail.vehicleIdv = generalInsurenceMotorService.getMotorQuoteFourthPageDetail().suggestedIDV;
				productDetail.vehicleMake = generalInsurenceMotorService.getMotorQuoteSecondPageDetail().vehicleMake.value;
				productDetail.vehicleModel = generalInsurenceMotorService.getMotorQuoteSecondPageDetail().vehicleModel.modelDesc;
				productDetail.registrationNo = generalInsurenceMotorService.getMotorPersonalThirdPageDetail().registrationNumber;
			} else {
				productDetail.vehicleIdv = "";
				productDetail.vehicleMake = "";
				productDetail.vehicleModel = "";
				productDetail.registrationNo = "";
			}

			if ($stateParams.page == "accident") {
				var  premiumDetailForPai = generalInsurenceAccidentService.getsumInsuredDetail()
				planDetail = generalInsurenceHomeService.getPlanDetail();
				var PAIpersonalInfo = generalInsurenceAccidentService.getInsuredDetails()
				quoteCalculationDetail = {};
				quoteCalculationDetail.quoteCreation = {};
				quoteCalculationDetail.quoteCreation.actualPremiumPayable =  premiumDetailForPai.finalPremiumAmount;
				quoteCalculationDetail.quoteCreation.policyTerms = {};
				quoteCalculationDetail.quoteCreation.policyTerms.actualPremiumPayable = premiumDetailForPai.finalPremiumAmount;
				quoteCalculationDetail.quoteCreation.policyTerms.expiryDate =   $filter('endDateWithTimezone')(premiumDetailForPai.endDate);
				quoteCalculationDetail.quoteCreation.policyTerms.effectDate =  $filter('startDateWithTimezone')(premiumDetailForPai.startDate);
			   
			}

			var planDetail = generalInsurenceHomeService.getPlanDetail();
			var policyNo = generalInsurenceHomeService.getOnlinePolicy();
			
			if($stateParams.page == "accident"){
					policyNo = {};
					policyNo.onlinePolicy = {};
					policyNo.onlinePolicy.policyNumber = paiPaymentDetail.payment.journalNo;

			}
			var quoteList;
			if (productUid == "22") {
				 quoteList = savedApplication.quoteData.premiumCalculation.policydetails.tenure;
			} else if (productUid == "11" || productUid == "12") {
				 quoteList = generalInsurenceHomeService.getQuoteListDetails().policyTerms;
			} else if(productUid == '55'){
				quoteList =  generalInsurenceTravelService.getTravellerPolicyDetails().diffVal;
			}else {
				 quoteList = 1;
			}

			var createPolicy = {
				"portfolio": {
					"generalInsurance": {
						"products": [{
								"productId": productID,
								"policies": [{
										"policyName": planDetail.planName,
										"uin": planDetail.uin,
										"productCode": planDetail.productCode,
										"productSubCode": planDetail.productSubCode,
										"dob": $filter('startDateWithTimezone')(personalDetail.birthdate),
										"planName": planDetail.planName,
										"imageUrl": planDetail.imageUrlMobile,
										"customerName": personalDetail.firstName + " " + personalDetail.LastName,
										"policyNo": policyNo.onlinePolicy.policyNumber,
										"annualPremium": quoteCalculationDetail.quoteCreation.actualPremiumPayable,
										"sumInsured": paymentOtpVm.sumAssured.toString(),
										"renewalDate": quoteCalculationDetail.quoteCreation.policyTerms.expiryDate,
										"policyTerm": quoteList.toString(),
										"premiumPaid": quoteCalculationDetail.quoteCreation.actualPremiumPayable,
										"status": "Active",
                    "realTimeStatus": "Active",
										"policyValidUntil": quoteCalculationDetail.quoteCreation.policyTerms.expiryDate,
										"vehicleIdv": productDetail.vehicleIdv,
										"vehicleMake": productDetail.vehicleMake,
										"vehicleModel": productDetail.vehicleModel,
										"registrationNo": productDetail.registrationNo,
										"ownerAccountNumber": paymentOtpVm.accountList.benAccntNo,
										"emailId": PAIpersonalInfo ? PAIpersonalInfo.emailId : "",
										"mobileNo": PAIpersonalInfo ? PAIpersonalInfo.mobileNumber : "",
										"nomineeName": generalInsurenceTravelService.getTravelNomineeDetail() ? generalInsurenceTravelService.getTravelNomineeDetail().name1  : "" ,
										"nomineeRelationship": generalInsurenceTravelService.getTravelNomineeDetail() ? generalInsurenceTravelService.getTravelNomineeDetail().relationship.value : "",
										"address1": personalDetail.address1,
										"address2": personalDetail.address2,
										"address3": personalDetail.address3,
										"address4": "",
										"autoRenew": paymentOtpVm.renewal ? true : false,
										"policyStartDate":quoteCalculationDetail.quoteCreation.policyTerms.effectDate

										
									},

								]
							},

						]
					}
				}
			}
			generalInsurenceHomeService.setLinkedpolicyDetailDetails(createPolicy.portfolio.generalInsurance.products[0].policies[0]);
			generalInsurenceHomeService.setLinkedpolicyDetailDetailsNew(createPolicy.portfolio.generalInsurance.products[0]);
			var test = JSON.stringify(createPolicy);

			generalInsurenceHealthService.getPolicyCreate(createPolicy).then(function(data) {
				//generalInsurenceHomeService.setPolicyCreateDetail(data);
				$state.go('menu.healthPaymentSuccess');
			}, function(error) {
				showRetry("Payment Received", $translate.instant("POLICY_ISSUE_FAILURE"), "online");
			});
				
			
            
        }

        paymentOtpVm.resendOTP = function() {
          var renewalDetail = generalInsurenceHomeService.getRenewDetail();
            paymentOtpVm.getOTPNumber = "";
            if(productUid == "14"){
                generalInsurenceHomeService.resendOTPForSHPayment().then(function(response){
                        handleResend();
                        if(response.data.otpStatus!="0000")
                        {
                             utilityService.showErrorMessage(response.responseMessage);
                        }
                },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
               })
            }else if(productUid == "44"){
              generalInsurenceAccidentService.resendOTPForPAIPayment().then(function(response){
                 handleResend();
                        if(response.data.otpStatus!="0000")
                        {
                             utilityService.showErrorMessage(response.responseMessage);
                        }
              },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
               })
            }else if(productUid == "44" && renewalDetail.isRenewal==true){
              generalInsurenceAccidentService.resendOTPForPAIRenewalPayment().then(function(response){
                 handleResend();
                        if(response.data.otpStatus!="0000")
                        {
                             utilityService.showErrorMessage(response.responseMessage);
                        }
              },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
               })
            }
            else {
                generalInsurenceHealthService.resendOTPForOtherPayment().then(function(response){
                 handleResend();
                        if(response.data.otpStatus!="0000")
                        {
                             utilityService.showErrorMessage(response.responseMessage);
                        }
              },function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
               })
            }
        }

        function handleResend(){
            paymentOtpVm.clickCount++;
            paymentOtpVm.isResendOTP = true;
                if(paymentOtpVm.clickCount==2)
                {
                    paymentOtpVm.isResendDisabled=true;
                }
        };

        function validateForm() {
            resendOTPPinVm.resetPinOTP = {};
            if (resendOTPPinVm.validateService.isValidOTPNumCards(resendOTPPinVm.getOTPNumber)) {
                resendOTPPinVm.resetPinOTP.getOTPNumber = resendOTPPinVm.validateService.isValidOTPNumCards(resendOTPPinVm.getOTPNumber);
            }
            return (angular.equals({}, resendOTPPinVm.resetPinOTP)) ? true : false;
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
