angularApp.controller('productDetailsController', [
    "$state",
    "$scope",
    "$stateParams",

    function(
        $state,
        $scope,
        $stateParams) {

        var productDetailsVm = this;

        function initPage() {
            productDetailsVm.showBack = false;
            productDetailsVm.showNext = true;


        }


        productDetailsVm.goToNextPage = function() {
            if ($stateParams.page == "health") {
                $state.go('menu.healthInsurance');
            } else if ($stateParams.page == "accident") {
                $state.go('menu.accidentInsurance');
            } else if ($stateParams.page == "home") {
                $state.go('menu.homeInsurance');
            } else if ($stateParams.page == "travel") {
                $state.go('menu.travelInsurance');
            } else if ($stateParams.page == "motor") {
                $state.go('menu.motorInsurance');
            }

        }
        productDetailsVm.goToProductFeatures = function() {
                if ($stateParams.page == "health") {
                    $state.go('menu.recommendedPolicyDetails');
                } else if ($stateParams.page == "accident") {
                    $state.go("menu.accidentRecommendedPolicyFeatures");
                } else if ($stateParams.page == "home") {
                    $state.go("menu.homeRecommendedPolicyFeatures");
                } else if ($stateParams.page == "travel") {
                    $state.go("menu.travelRecommendedPolicyFeatures");
                } else if ($stateParams.page == "motor") {
                    $state.go("menu.motorRecommendedPolicyFeatures");
                }
            }

        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        $scope.$on('$ionicView.beforeEnter', function() {

        });

        $scope.$on('$ionicView.afterLeave', function() {

        });
        return this;
    }
]);
