angularApp.controller('purchaseSummaryController', [
    "$state",
    "$scope",
    "$translate",
    "$stateParams", "$filter", "validateService", "generalInsurenceTravelService", "generalInsurenceHealthService", "generalInsurenceAccidentService", "generalInsurenceHomeService", "generalInsurenceHomeDetailService", "generalInsurenceMotorService", "utilityService", "$ionicPopup","lifeInsuranceCommonService","GIconstant","constantConfig",


    function(
        $state,
        $scope,
        $translate,
        $stateParams, $filter, validateService, generalInsurenceTravelService, generalInsurenceHealthService, generalInsurenceAccidentService, generalInsurenceHomeService, generalInsurenceHomeDetailService, generalInsurenceMotorService, utilityService, $ionicPopup,lifeInsuranceCommonService,GIconstant,constantConfig) {

        var purchaseSummaryVm = this;
        var productUid, quoteCalculationDetail, productSiCodeDetail;
        var paymentDetailAfterPayment;
        var paiPaymentDetail;
        var savedApplication;
        var personalDetail
        var applicationNumber;

        function initPage() {
            purchaseSummaryVm.accountList = "";
            purchaseSummaryVm.balance = "";
            purchaseSummaryVm.paymentForm = {};
            purchaseSummaryVm.renewal = false;
            savedApplication = generalInsurenceHomeDetailService.getSavedData();
            productUid = generalInsurenceHomeService.getProductDetail().uin;
            productSiCodeDetail = generalInsurenceHomeService.getPlanDetail();
            var IsRenewal = generalInsurenceHomeService.getRenewDetail();
            if(IsRenewal!=null || IsRenewal!=undefined){
                purchaseSummaryVm.IsRenewal=IsRenewal.isRenewal;
            }else{
                purchaseSummaryVm.IsRenewal="";
            }
            purchaseSummaryVm.getTooltipContent();
            var uin = {
                'uin': productUid
            }
            generalInsurenceHomeService.getProductFeatures(uin).then(function(data) {
                generalInsurenceHomeService.setPlanDetail(data);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            quoteCalculationDetail = generalInsurenceHealthService.getQuotecalculation();
            purchaseSummaryVm.quoteNUmber = generalInsurenceHomeService.getQuoteNumber();
            purchaseSummaryVm.premiumAmount = quoteCalculationDetail.quoteCreation.actualPremiumPayable;
            purchaseSummaryVm.sumAssured  =   generalInsurenceHomeService.getpolicySumInsured();

            if(productUid == '44' || productUid == '14'){
                 purchaseSummaryVm.showQuote = true;
            }else{
                 purchaseSummaryVm.showQuote = false;
            }
            if ($stateParams.page == "accident") {
                purchaseSummaryVm.premiumAmount = generalInsurenceAccidentService.getsumInsuredDetail().finalPremiumAmount;
            } 


            purchaseSummaryVm.ProductIds = productUid;

            switch (productUid) {
                case '12':
                    purchaseSummaryVm.policyTitle = $translate.instant("CI_PURCHASE_SUIMMARY"); 
                    break;
                case '11':
                    purchaseSummaryVm.policyTitle = $translate.instant("AP_PURCHASE_SUIMMARY"); 
                    break;
                case '14':
                    purchaseSummaryVm.policyTitle = $translate.instant("SH_PURCHASE_SUIMMARY"); 
                    break;
                case '13':
                    purchaseSummaryVm.policyTitle = $translate.instant("HDC_PURCHASE_SUIMMARY"); 
                    break;
                 case '22':
                    purchaseSummaryVm.policyTitle = $translate.instant("LTH_PURCHASE_SUIMMARY"); 
                    break;
                case '31':
                    purchaseSummaryVm.policyTitle = $translate.instant("M4W_PURCHASE_SUIMMARY"); 
                    break;
                case '32':
                    purchaseSummaryVm.policyTitle = $translate.instant("M2W_PURCHASE_SUIMMARY"); 
                    break;
                case '44':
                    purchaseSummaryVm.policyTitle = $translate.instant("PAI_PURCHASE_SUIMMARY"); 
                    break;
                case '55':
                    purchaseSummaryVm.policyTitle = $translate.instant("TI_PURCHASE_SUIMMARY"); 
                    break;

            }



            if(productUid =='22' || productUid =='31' || productUid =='32' || productUid =='44' || productUid =='55'){
                     applicationNumber = generalInsurenceHomeService.getapplicationNumber(); 
           }else if(productUid =='11'){
                     applicationNumber =    generalInsurenceHomeService.getSaveApplicationArogyaStructure() ? generalInsurenceHomeService.getSaveApplicationArogyaStructure().applicationNumber : "";
           }else if(productUid =='12'){
                     applicationNumber =     generalInsurenceHomeService.getSaveApplicationCriticalStructure() ? generalInsurenceHomeService.getSaveApplicationCriticalStructure().applicationNumber : "";
           }else if(productUid =='13'){
                     applicationNumber =    generalInsurenceHomeService.getSaveApplicationHDCStructure() ? generalInsurenceHomeService.getSaveApplicationHDCStructure().applicationNumber : "";
           }else if(productUid =='14'){
                 applicationNumber =    generalInsurenceHomeService.getSaveApplicationHealthStructure() ? generalInsurenceHomeService.getSaveApplicationHealthStructure().applicationNumber : "";
           }



            purchaseSummaryVm.showBack = true;
            purchaseSummaryVm.showNext = true;
            purchaseSummaryVm.disableBack = false;
            purchaseSummaryVm.disableNext = false;
            var account = {};
            generalInsurenceHomeService.getSBIBankAccounts(account).then(function(data) {
                purchaseSummaryVm.accDetails = data.beneficiaryList.ownAccounts;
                purchaseSummaryVm.changeAccount(objPriAcc);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            switch($stateParams.page){
                case  'travel' :
                        personalDetail = {};
                        generalInsurenceTravelService.getProposerContactDetail();
                        personalDetail.firstName = generalInsurenceTravelService.getProposerContactDetail().firstName;
                        personalDetail.LastName = generalInsurenceTravelService.getProposerContactDetail().lastName;
                        personalDetail.birthdate = generalInsurenceTravelService.getProposerContactDetail().birthdate;
                        personalDetail.email = generalInsurenceTravelService.getProposerContactDetail().emailID;
                        personalDetail.address1 = generalInsurenceTravelService.getProposerContactDetail().plotNO;
                        personalDetail.address2 = generalInsurenceTravelService.getProposerContactDetail().buildingName;
                        personalDetail.address3 = generalInsurenceTravelService.getProposerContactDetail().streetName;
                        break;
                case  'home' :
                        personalDetail = {};
                        personalDetail.firstName = generalInsurenceHomeDetailService.getPersonalFifthpageDetail().firstName;
                        personalDetail.LastName = generalInsurenceHomeDetailService.getPersonalFifthpageDetail().LastName;
                        personalDetail.birthdate = generalInsurenceHomeDetailService.getPersonalFifthpageDetail().birthDate;
                        personalDetail.email = generalInsurenceHomeDetailService.getPersonalFifthpageDetail().emailID;
                        personalDetail.address1 = generalInsurenceHomeDetailService.getPersonalForthpageDetail().ploatNo;
                        personalDetail.address2 = generalInsurenceHomeDetailService.getPersonalForthpageDetail().buildingName;
                        personalDetail.address3 = generalInsurenceHomeDetailService.getPersonalForthpageDetail().streetName;
                        break;
                case  'motor':
                        personalDetail = {};
                        personalDetail.firstName = generalInsurenceMotorService.getMotorPersonalFirstPageDetail().firstName;
                        personalDetail.LastName = generalInsurenceMotorService.getMotorPersonalFirstPageDetail().LastName;
                        personalDetail.email = generalInsurenceMotorService.getMotorPersonalFirstPageDetail().emailID;
                        personalDetail.birthdate = generalInsurenceMotorService.getMotorPersonalFirstPageDetail().birthday;
                        personalDetail.address1 = generalInsurenceMotorService.getMotorPersonalSecondPageDetail().plotNO;
                        personalDetail.address2 = generalInsurenceMotorService.getMotorPersonalSecondPageDetail().BuildingName;
                        personalDetail.address3 = generalInsurenceMotorService.getMotorPersonalSecondPageDetail().StreetName;
                        break;
                case  'accident' :
                        personalDetail = {};
                        var PAIpersonalInfo = generalInsurenceAccidentService.getInsuredDetails()
                        personalDetail.birthdate = PAIpersonalInfo.dob;
                        personalDetail.firstName = PAIpersonalInfo.firstName;
                        personalDetail.LastName = PAIpersonalInfo.lastName;
                        personalDetail.email = PAIpersonalInfo.emailId;
                        personalDetail.address1 = PAIpersonalInfo.plotNo;
                        personalDetail.address2 = PAIpersonalInfo.buildingName;
                        personalDetail.address3 = PAIpersonalInfo.streetName;
                        break;
                case 'health' :
                           personalDetail = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
                            break;
                default : 
                           personalDetail = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
                            break;

            }
            
        }

        function getPAIPayment() {
            var planDetail = generalInsurenceHomeService.getPlanDetail();
            var personalDetails = generalInsurenceAccidentService.getInsuredDetails();
            var secKey = generalInsurenceHomeService.generateSecKey();            
            var paiPayment = {
                "secKey" : secKey,
                "personalAccidentInsPayment": {
                    "applicationNumber" : applicationNumber,
                    "premiumAmount": Number(purchaseSummaryVm.premiumAmount),
                    "nomineeFirstName": generalInsurenceTravelService.getTravelNomineeDetail().name1 ? generalInsurenceTravelService.getTravelNomineeDetail().name1  : "" ,
                    "nomineeMiddleName": "",
                    "nomineeLastName": generalInsurenceTravelService.getTravelNomineeDetail().nomineeLastName ? generalInsurenceTravelService.getTravelNomineeDetail().nomineeLastName : "",
                    "nomineeRelationshipCode": generalInsurenceTravelService.getTravelNomineeDetail().relationship.key,
                    "nomineeDateOfBirth": new Date (generalInsurenceTravelService.getTravelNomineeDetail().birthDate),
                    "guardianFirstName": generalInsurenceTravelService.getTravelNomineeDetail().name,
                    "guardianMiddleName": "",
                    "guardianLastName": generalInsurenceTravelService.getTravelNomineeDetail().appointeeLastName,
                    "autoRenew": purchaseSummaryVm.renewal ? true : false,
                    "debitAccount": purchaseSummaryVm.accountList.benAccntNo,
                    "termsAndConditionsAcceptance": true,
                    "transactionBranchCode": purchaseSummaryVm.accountList.branchCode,
                    "effectiveDate":  $filter('startDateWithTimezone')(generalInsurenceAccidentService.getsumInsuredDetail().startDate),
                    "flag": "new",
                    "customerName" : personalDetail ? personalDetail.firstName + " " + personalDetail.LastName : "",
                    "insuredName" : personalDetails.firstName,
                    "emailId" : personalDetails.emailId,
                    "mobileNumber" : personalDetails.mobileNumber,
                    "proposerDob" : personalDetails.dob,
                    "address1": personalDetails.plotNo,
                    "address2": personalDetails.buildingName,
                    "address3": personalDetails.streetName,
                    "address4": "",
                    "sumInsured": purchaseSummaryVm.sumAssured,
                     "referralCode":purchaseSummaryVm.refCode
                    
                }
            }


            generalInsurenceAccidentService.payForPAIPurchase(paiPayment).then(function(data) {
				if(data.isOTPRequired == "true"){
					switch ($stateParams.page) {
					    case "motor":
							$state.go("menu.paymentOtp", { page: $stateParams.page });
							break;
					    case "travel":
							$state.go("menu.paymentOtp", { page: $stateParams.page });
							break;
					    case "health":
							$state.go("menu.paymentOtp", { page: $stateParams.page });
							break;
					    case "accident":
							$state.go("menu.paymentOtp", { page: $stateParams.page });
							break;
					    case "home":
							$state.go("menu.paymentOtp", { page: $stateParams.page });
							break;
					}
                                                                               
                }else if(data.isOTPRequired == "false"){
					if(!isValidSecKey(data.secKey,secKey)){
						utilityService.showErrorMessage(GIconstant.errorMessage)
					}else{
						utilityService.setCsatJournies('generalInsurance');
						paiPaymentDetail =  data;
						generalInsurenceHomeService.setOnlinePolicy(data.payment);
						policyCreate();
					} 
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }
         purchaseSummaryVm.getTooltipContent=function(){
                 generalInsurenceAccidentService.getInfoContentForGI().then(function(response) {  
                if(response.infoList[0].key=='cbb2d20c-6a94-47df-9a7e-7a197e0dc21f'){
                    purchaseSummaryVm.refCodeContentMessage=response.infoList[0].value;
                }else{
                    purchaseSummaryVm.refCodeContentMessage=constantConfig.mfAndsecConst.riskInfoEmptyText;
                }                       
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);

                });
            }

        function getSimpleHealthPayment() {
            var memeberList = generalInsurenceHealthService.getHealthAdditionalDetails();
            var personalDetails = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
            var childList = [];
            var elderList = [];
            var childCount = 0;
            var elderCount = 0;


            for (var count = 0; count < memeberList.birthDay.length; count++) {
                if (validateService.calcAge(memeberList.birthDay[count]) < 18) {
                    childList.push(count);
                    childCount++;
                } else {
                    elderList.push(count);
                    elderCount++;
                }
            }

            var productType = generalInsurenceHealthService.getbasicHealthDetail().productTypes.value;
            var nomineeDetail = generalInsurenceTravelService.getTravelNomineeDetail();
            var planDetail = generalInsurenceHomeService.getPlanDetail();
            var travellerDetail = productType +" "+"-" +" " + (elderCount ? elderCount+ "A" : "")  + (childCount ? "+"+childCount+"C" + "" : "") ;
            var secKey = generalInsurenceHomeService.generateSecKey();

			var productDetails = {
				"secKey" : secKey,
                    "generalHealthInsInsPayment": {
                    "applicationNumber" : applicationNumber,
                    "sumInsured":  purchaseSummaryVm.sumAssured,
                    "contactMode": 0,
                    "selfMemberID": "",
                    "plan": travellerDetail,
                    "spouseName": elderList[1] ? memeberList.name[elderList[1]] : '',
                    "spouseMemberID": "",
                    "spouseGender": elderList[1] ? memeberList.Gender[elderList[1]].key : '',
                    "spouseDateofBirth": elderList[1] ? new Date(memeberList.birthDay[elderList[1]]) : '',
                    "firstChildName": childList[0] ? memeberList.name[childList[0]] : '',
                    "firstChildMemberID": "",
                    "firstChildGender": childList[0] ? memeberList.Gender[childList[0]].key : '',
                    "firstChildDateofBirth": childList[0] ? new Date(memeberList.birthDay[childList[0]]) : '',
                    "secondChildName": childList[1] ? memeberList.name[childList[1]] : '',
                    "secondChildMemberID": '',
                    "secondChildGender": childList[1] ? memeberList.Gender[childList[1]].key : '',
                    "secondChildDateofBirth": childList[1] ? new Date(memeberList.birthDay[childList[1]]) : '',
                    "branchManagerPFId": "",
                    "nomineeFirstName": nomineeDetail.name1,
                    "nomineeMiddleName": "",
                    "nomineeLastName": nomineeDetail.nomineeLastName,
                    "nomineeRelationshipCode": nomineeDetail.relationship.key,
                    "nomineeDateOfBirth": new Date(nomineeDetail.birthDate),
                    "guardianFirstName": nomineeDetail.name ? nomineeDetail.name : "",
                    "guardianMiddleName": "",
                    "guardianLastName": nomineeDetail.appointeeLastName ? nomineeDetail.appointeeLastName : "",
                    "autoRenew": purchaseSummaryVm.renewal ? true : false,
                    "debitAccount": purchaseSummaryVm.accountList.benAccntNo,
                    "termsAndConditionsAcceptance": true,
                    "tellerId": "4362330",
                    "transactionBranchCode": purchaseSummaryVm.accountList.branchCode,
                    "effectiveDate": quoteCalculationDetail.quoteCreation.policyTerms.effectDate,
                    "expiryDate": quoteCalculationDetail.quoteCreation.policyTerms.expiryDate,
                    "productCode": planDetail.productCode,
                    "productSubCode": planDetail.productSubCode,
                    "siCategory": planDetail.siCategory,
                    "siProductId": planDetail.siProductId,
                    "quoteNo": quoteCalculationDetail.quoteCreation.quoteNumber,
                    "flag": "New",
                    "customerName" : personalDetail ? personalDetail.firstName + " " + personalDetail.LastName : "",
                    "creationDate" : generalInsurenceHomeService.getpolicyCreatedDate() ?generalInsurenceHomeService.getpolicyCreatedDate() :  $filter('startDateWithTimezone')(generalInsurenceHomeService.getCurrentDate()),
                    "premium": quoteCalculationDetail.quoteCreation.actualPremiumPayable,
                    "insuredName" : personalDetails.firstName,
                    "emailId" : personalDetails.email,
                    "mobileNumber" : personalDetails.mobile,
                    "proposerDob" : personalDetails.birthdate,
                    "address1": personalDetails.plotNo,
                    "address2": personalDetails.address,
                    "address3": personalDetails.streetName,
                    "address4": "",
                    "uin" : planDetail.uin,
                     "referralCode":purchaseSummaryVm.refCode                     
                    
                }
            }
          
            generalInsurenceHomeService.payForSHPurchase(productDetails).then(function(data) {
                if(data.isOTPRequired == "true"){
				    switch ($stateParams.page) {
						case "motor":
							$state.go("menu.paymentOtp", { page: $stateParams.page });
							break;
						case "travel":
							$state.go("menu.paymentOtp", { page: $stateParams.page });
							break;
						case "health":
							$state.go("menu.paymentOtp", { page: $stateParams.page });
							break;
						case "accident":
							$state.go("menu.paymentOtp", { page: $stateParams.page });
							break;
						case "home":
							$state.go("menu.paymentOtp", { page: $stateParams.page });
							break;
				    }
                                                                              
                }else if(data.isOTPRequired == "false"){
					if(!isValidSecKey(data.secKey,secKey)){
						utilityService.showErrorMessage(GIconstant.errorMessage)
					}else{
						paymentDetailAfterPayment = data.data;
						getAgentRecipt(data.data);
						utilityService.setCsatJournies('generalInsurance'); 
					}
                    
                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
		
		function isValidSecKey(secKey,requestKey) {
			var calculatedKey = lifeInsuranceCommonService.verifySeckey(parseInt(secKey));
				if(requestKey == calculatedKey){
					return true;
				}							
			return false;			
		}


        purchaseSummaryVm.paymentForm = {};
        purchaseSummaryVm.validateService = validateService;

        function validateForm() {
            purchaseSummaryVm.paymentForm = {};
            if (purchaseSummaryVm.validateService.isValidAccountNum(purchaseSummaryVm.accountList)) {
                purchaseSummaryVm.paymentForm.accountList = purchaseSummaryVm.validateService
                    .isValidAccountNum(purchaseSummaryVm.accountList);
            }

            return (angular.equals({}, purchaseSummaryVm.paymentForm)) ? true : false;
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        /***Function to show information POP UP***/
	        purchaseSummaryVm.showInformationPopupRef= function() {
	        	var infoPopup = $ionicPopup.show({
					template: '<p>'+purchaseSummaryVm.refCodeContentMessage+'</p>',
					title:'Information',
					scope: $scope,
					cssClass: 'dialog',		
					buttons: [
		            {
		               text: 'Ok'
		            }
					]
				});

	            
	        }


        purchaseSummaryVm.changeAccount = function(account) {
            purchaseSummaryVm.balance = account.balance;
            if (purchaseSummaryVm.balance < purchaseSummaryVm.premiumAmount) {
                purchaseSummaryVm.paymentForm.accountList = "your balance is too low";
            }


        }

        purchaseSummaryVm.displayBalance = function(balance) {
            if (balance) {
                return $filter('rupeeSymbol')(balance);
            }

        }

        purchaseSummaryVm.goBacktoPrevious = function() {
            if ($stateParams.page == "health") {
                $state.go("menu.travelNomineeDetails");
            } else if ($stateParams.page == "motor") {
                if(generalInsurenceMotorService.getMotorQuoteFourthPageDetail().nomineeRequired){
                        $state.go("menu.travelNomineeDetails");
                }else{
                     $state.go("menu.motorInsurerFinancialDetails");
                }
               
            } else if ($stateParams.page == "travel") {
                $state.go("menu.travelNomineeDetails");
            } else if ($stateParams.page == "accident") {
                $state.go("menu.travelNomineeDetails");
            } else if ($stateParams.page == "home") {
                $state.go("menu.homeInsuredLocationDetails");
            }
        }



        function showRetry(title, template, funName) {
            var alertPopup = $ionicPopup.alert({
                title: title,
                template: template,
                scope: $scope,
                cssClass: 'sbi-alert-popup',
                buttons: [{
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function(e) {
                        return true;
                    }
                }]
               
            });
            alertPopup.then(function(res) {
                $state.go('menu.generalInsurance');
            });

        }



        function getPayment() {
            var planDetail = generalInsurenceHomeService.getPlanDetail();
            var secKey = generalInsurenceHomeService.generateSecKey();            
            if ($stateParams.page == "health") {
                var nomineeDetail = generalInsurenceTravelService.getTravelNomineeDetail();
                var proposerDetails = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
                var paymentDetail = {
                    "secKey" : secKey,
                    "generalOtherPoliciesInsPayment": {
                        "applicationNumber" : applicationNumber,
                        "quoteNo": quoteCalculationDetail.quoteCreation.quoteNumber,
                        "productName": planDetail.productCode,
                        "debitAccount": purchaseSummaryVm.accountList.benAccntNo,
                        "transactionBranchCode": purchaseSummaryVm.accountList.branchCode,
                        "flag": "New",
                        "productCode": planDetail.productCode,
                        "customerName" : personalDetail ? personalDetail.firstName + " " + personalDetail.LastName : "",
                        "insuredName": proposerDetails ? proposerDetails.firstName : "", 
                        "emailId": proposerDetails ? proposerDetails.email : "", 
                        "mobileNumber": proposerDetails ? proposerDetails.mobile : "",
                        "proposerDob": proposerDetails ? proposerDetails.birthdate : "",  
                        "nomineeName": nomineeDetail ? nomineeDetail.name1 : "",
                        "nomineeRelationship": nomineeDetail ? nomineeDetail.relationship.key : "",
                        "address1": proposerDetails ? proposerDetails.plotNo : "",
                        "address2": proposerDetails ? proposerDetails.address : "",
                        "address3": proposerDetails ? proposerDetails.streetName : "",
                        "address4":"",
                        "vehicleMake": "",
                        "vehicleModel": "",
                        "registrationNumber": "",
                        "uin" : planDetail.uin,
                        "referralCode":purchaseSummaryVm.refCode
                        
                    }
                }
            } else if ($stateParams.page == "motor") {
                var vehicleDetails = generalInsurenceMotorService.getMotorQuoteSecondPageDetail();
                var proposerDetails = generalInsurenceMotorService.getMotorPersonalFirstPageDetail();
                var addressDetails = generalInsurenceMotorService.getMotorPersonalSecondPageDetail();
                var regNumber = generalInsurenceMotorService.getMotorPersonalThirdPageDetail();
                var nomineeDetail = generalInsurenceTravelService.getTravelNomineeDetail();
                var vehicleIdv = generalInsurenceMotorService.getMotorQuoteFourthPageDetail().suggestedIDV;
                var paymentDetail = {
                    "secKey" : secKey,
                    "generalOtherPoliciesInsPayment": {
                        "applicationNumber" : applicationNumber,
                        "quoteNo": quoteCalculationDetail.quoteCreation.quoteNumber,
                        "productName": planDetail.productCode,
                        "debitAccount": purchaseSummaryVm.accountList.benAccntNo,
                        "transactionBranchCode": purchaseSummaryVm.accountList.branchCode,
                        "flag": "New",
                        "productCode": planDetail.productCode,
                        "customerName" : personalDetail ? personalDetail.firstName + " " + personalDetail.LastName : "",
                        "insuredName": proposerDetails ? proposerDetails.firstName : "", 
                        "emailId": proposerDetails ? proposerDetails.emailID : "", 
                        "mobileNumber": proposerDetails ? proposerDetails.mobileNumber : "",
                        "proposerDob": proposerDetails ? proposerDetails.birthday : "",  
                        "nomineeName": nomineeDetail ? nomineeDetail.name1 : "",
                        "nomineeRelationship": nomineeDetail ? nomineeDetail.relationship.key : "",
                        "address1": addressDetails ? addressDetails.plotNO : "",
                        "address2": addressDetails ? addressDetails.BuildingName : "",
                        "address3": addressDetails ? addressDetails.StreetName : "",
                        "address4":"",
                        "vehicleMake": vehicleDetails ? vehicleDetails.vehicleMake.value : "",
                        "vehicleModel": vehicleDetails ? vehicleDetails.vehicleModel.modelDesc : "",
                        "registrationNumber": regNumber ? regNumber.registrationNumber : "",
                        "uin" : planDetail.uin,
                        "idv" : vehicleIdv ? vehicleIdv : "",
                         "referralCode":purchaseSummaryVm.refCode
                         
                    }
                }
            } else if ($stateParams.page == "travel") {
                var nomineeDetail = generalInsurenceTravelService.getTravelNomineeDetail();
                var proposerDetails = generalInsurenceTravelService.getProposerContactDetail();
                var paymentDetail = {
                    "secKey" : secKey,
                    "generalOtherPoliciesInsPayment": {
                        "applicationNumber" : applicationNumber,
                        "quoteNo": quoteCalculationDetail.quoteCreation.quoteNumber,
                        "productName": planDetail.productCode,
                        "debitAccount": purchaseSummaryVm.accountList.benAccntNo,
                        "transactionBranchCode": purchaseSummaryVm.accountList.branchCode,
                        "flag": "New",
                        "productCode": planDetail.productCode,
                        "customerName" : personalDetail ? personalDetail.firstName + " " + personalDetail.LastName : "",
                        "insuredName": proposerDetails ? proposerDetails.firstName : "", 
                        "emailId": proposerDetails ? proposerDetails.email : "", 
                        "mobileNumber": proposerDetails ? proposerDetails.mobileNo : "",
                        "proposerDob": proposerDetails ? proposerDetails.birthdate : "",  
                        "nomineeName": nomineeDetail ? nomineeDetail.name1 : "",
                        "nomineeRelationship": nomineeDetail ? nomineeDetail.relationship.key : "",
                        "address1": proposerDetails ? proposerDetails.plotNO : "",
                        "address2": proposerDetails ? proposerDetails.buildingName : "",
                        "address3": proposerDetails ? proposerDetails.streetName : "",
                        "address4":"",
                        "vehicleMake": "",
                        "vehicleModel": "",
                        "registrationNumber": "",
                        "uin" : planDetail.uin,
                         "referralCode":purchaseSummaryVm.refCode
                         
                    }
                }
            }else if ($stateParams.page == "home") {
                var addressDetails = generalInsurenceHomeDetailService.getPersonalSecondpageDetail();
                var proposerDetails = generalInsurenceHomeDetailService.getPersonalFirstpageDetail();
                var paymentDetail = {
                    "secKey" : secKey,
                    "generalOtherPoliciesInsPayment": {
                        "applicationNumber" : applicationNumber,
                        "quoteNo": quoteCalculationDetail.quoteCreation.quoteNumber,
                        "productName": planDetail.productCode,
                        "debitAccount": purchaseSummaryVm.accountList.benAccntNo,
                        "transactionBranchCode": purchaseSummaryVm.accountList.branchCode,
                        "flag": "New",
                        "productCode": planDetail.productCode,
                        "customerName" : personalDetail ? personalDetail.firstName + " " + personalDetail.LastName : "",
                        "insuredName": proposerDetails ? proposerDetails[0].firstName : "", 
                        "emailId": proposerDetails ? proposerDetails.email : "", 
                        "mobileNumber": proposerDetails ? proposerDetails.mobileNo : "",
                        "proposerDob": proposerDetails ? proposerDetails[0].dob : "",  
                        "nomineeName": "",
                        "nomineeRelationship": "",
                        "address1": addressDetails ? addressDetails.ploatNo : "",
                        "address2": addressDetails ? addressDetails.buildingName : "",
                        "address3": addressDetails ? addressDetails.streetName : "",
                        "address4":"",
                        "vehicleMake": "",
                        "vehicleModel": "",
                        "registrationNumber": "",
                        "uin" : planDetail.uin,
                         "referralCode":purchaseSummaryVm.refCode

                         
                    }
                }
            }    



            generalInsurenceHealthService.payForOtherPurchase(paymentDetail).then(function(data) {
				if(data.isOTPRequired == "true"){
                                                                                  
                  switch ($stateParams.page) {
                  case "motor":
                  $state.go("menu.paymentOtp", { page: $stateParams.page });
                  break;
                  case "travel":
                  $state.go("menu.paymentOtp", { page: $stateParams.page });
                  break;
                  case "health":
                  $state.go("menu.paymentOtp", { page: $stateParams.page });
                  break;
                  case "accident":
                  $state.go("menu.paymentOtp", { page: $stateParams.page });
                  break;
                  case "home":
                  $state.go("menu.paymentOtp", { page: $stateParams.page });
                  break;
                  }
                                                                                  
                                                                                  
                }else if(data.isOTPRequired == "false"){
					if(!isValidSecKey(data.secKey,secKey)){
						utilityService.showErrorMessage(GIconstant.errorMessage)
					}else{
						var renewalDetail = generalInsurenceHomeService.getRenewDetail();
						if(renewalDetail){
							renewalDetail.isRenewal = false;
							generalInsurenceHomeService.setRenewDetail(renewalDetail);
						}
						paymentDetailAfterPayment = data;
						getAgentRecipt(data);
						utilityService.setCsatJournies('generalInsurance');
					} 
                }
            }, function(error) {
                utilityService.showAlertModal("", $translate.instant("PAYMENT_FAILURE_MSG"), "menu.generalInsurance", $scope, $state, "OK");
            });



        }


        function getAgentRecipt(paymentDetail) {
            var planDetail = generalInsurenceHomeService.getPlanDetail();
            var currentDate = generalInsurenceHomeService.getCurrentDate();
            var getAgentReceipt = {
                "agentReceiptDetailsRequest": {
                    "instumentTotal": quoteCalculationDetail.quoteCreation.actualPremiumPayable,
                    "payor": quoteCalculationDetail.quoteCreation.policyTerms.customerCode,
                    "payorCustCodeArr": quoteCalculationDetail.quoteCreation.policyTerms.customerCode,
                    "payorType": "individual",
                    "quoteNo": quoteCalculationDetail.quoteCreation.quoteNumber,
                    "receiveAmountArr": quoteCalculationDetail.quoteCreation.actualPremiumPayable,
                    "totalPremium": quoteCalculationDetail.quoteCreation.actualPremiumPayable,
                    "transationID": paymentDetail.payment.paymentRefNumber,
                    "receiptDate": $filter('newdateFormat')(currentDate),
                    "con": paymentDetail.payment.lotusRefNumber,
                    "productCode": planDetail.productCode,
                    "productSubCode": planDetail.productSubCode
                }
            }
            generalInsurenceHealthService.getAgentReceipt(getAgentReceipt).then(function(data) {
                getOnlinepolicy();
                generalInsurenceHomeService.setAgentRecipt(data);
            }, function(error) {
                showRetry("Payment Received", $translate.instant("POLICY_ISSUE_FAILURE"), "agent");
            });
        }

        function getOnlinepolicy() {
            var planDetail = generalInsurenceHomeService.getPlanDetail();
            var getOnlinePolicy = {
                "onlinePolicy": {
                    "transactionType": "1",
                    "quoteNumber": quoteCalculationDetail.quoteCreation.quoteNumber,
                    "productCode": planDetail.productCode,
                    "productSubCode": planDetail.productSubCode,
                    "lotusRefNumber" : paymentDetailAfterPayment.payment.lotusRefNumber
                }
            }

            generalInsurenceHealthService.getOnlinePolicy(getOnlinePolicy).then(function(data) {
                generalInsurenceHomeService.setOnlinePolicy(data);
                policyCreate();
            }, function(error) {
                showRetry("Payment Received", $translate.instant("POLICY_ISSUE_FAILURE"), "online");
            });
        }

        function policyCreate() {
            var productDetail = generalInsurenceHomeService.getProductDetail();
            var productID = generalInsurenceHomeService.getProductID();
            if ($stateParams.page == "motor") {
                productDetail.vehicleIdv = generalInsurenceMotorService.getMotorQuoteFourthPageDetail().suggestedIDV;
                productDetail.vehicleMake = generalInsurenceMotorService.getMotorQuoteSecondPageDetail().vehicleMake.value;
                productDetail.vehicleModel = generalInsurenceMotorService.getMotorQuoteSecondPageDetail().vehicleModel.modelDesc;
                productDetail.registrationNo = generalInsurenceMotorService.getMotorPersonalThirdPageDetail().registrationNumber;
            } else {
                productDetail.vehicleIdv = "";
                productDetail.vehicleMake = "";
                productDetail.vehicleModel = "";
                productDetail.registrationNo = "";
            }

            if ($stateParams.page == "accident") {
                var  premiumDetailForPai = generalInsurenceAccidentService.getsumInsuredDetail()
                planDetail = generalInsurenceHomeService.getPlanDetail();
                var PAIpersonalInfo = generalInsurenceAccidentService.getInsuredDetails()
                quoteCalculationDetail = {};
                quoteCalculationDetail.quoteCreation = {};
                quoteCalculationDetail.quoteCreation.actualPremiumPayable =  premiumDetailForPai.finalPremiumAmount;
                quoteCalculationDetail.quoteCreation.policyTerms = {};
                quoteCalculationDetail.quoteCreation.policyTerms.actualPremiumPayable = premiumDetailForPai.finalPremiumAmount;
                quoteCalculationDetail.quoteCreation.policyTerms.expiryDate =   $filter('endDateWithTimezone')(premiumDetailForPai.endDate);
                quoteCalculationDetail.quoteCreation.policyTerms.effectDate =  $filter('startDateWithTimezone')(premiumDetailForPai.startDate);
               
            }

            var planDetail = generalInsurenceHomeService.getPlanDetail();
            var policyNo = generalInsurenceHomeService.getOnlinePolicy();
            
            if($stateParams.page == "accident"){
                    policyNo = {};
                    policyNo.onlinePolicy = {};
                    policyNo.onlinePolicy.policyNumber = paiPaymentDetail.payment.journalNo;

            }
            var quoteList;
            if (productUid == "22") {
                 quoteList = savedApplication.quoteData.premiumCalculation.policydetails.tenure;
            } else if (productUid == "11" || productUid == "12") {
                 quoteList = generalInsurenceHomeService.getQuoteListDetails().policyTerms;
            } else if(productUid == '55'){
                quoteList =  generalInsurenceTravelService.getTravellerPolicyDetails().diffVal;
            }else {
                 quoteList = 1;
            }

            var createPolicy = {
                "portfolio": {
                    "generalInsurance": {
                        "products": [{
                                "productId": productID,
                                "policies": [{
                                        "policyName": planDetail.planName,
                                        "uin": planDetail.uin,
                                        "productCode": planDetail.productCode,
                                        "productSubCode": planDetail.productSubCode,
                                        "dob": $filter('startDateWithTimezone')(personalDetail.birthdate),
                                        "planName": planDetail.planName,
                                        "imageUrl": planDetail.imageUrlMobile,
                                        "customerName": personalDetail.firstName + " " + personalDetail.LastName,
                                        "policyNo": policyNo.onlinePolicy.policyNumber,
                                        "annualPremium": quoteCalculationDetail.quoteCreation.actualPremiumPayable,
                                        "sumInsured": purchaseSummaryVm.sumAssured.toString(),
                                        "renewalDate": quoteCalculationDetail.quoteCreation.policyTerms.expiryDate,
                                        "policyTerm": quoteList.toString(),
                                        "premiumPaid": quoteCalculationDetail.quoteCreation.actualPremiumPayable,
                                        "status": "Active",
                                        "realTimeStatus": "Active",
                                        "policyValidUntil": quoteCalculationDetail.quoteCreation.policyTerms.expiryDate,
                                        "vehicleIdv": productDetail.vehicleIdv,
                                        "vehicleMake": productDetail.vehicleMake,
                                        "vehicleModel": productDetail.vehicleModel,
                                        "registrationNo": productDetail.registrationNo,
                                        "ownerAccountNumber": purchaseSummaryVm.accountList.benAccntNo,
                                        "emailId": PAIpersonalInfo ? PAIpersonalInfo.emailId : "",
                                        "mobileNo": PAIpersonalInfo ? PAIpersonalInfo.mobileNumber : "",
                                        "nomineeName": generalInsurenceTravelService.getTravelNomineeDetail() ? generalInsurenceTravelService.getTravelNomineeDetail().name1  : "" ,
                                        "nomineeRelationship": generalInsurenceTravelService.getTravelNomineeDetail() ? generalInsurenceTravelService.getTravelNomineeDetail().relationship.value : "",
                                        "address1": personalDetail.address1,
                                        "address2": personalDetail.address2,
                                        "address3": personalDetail.address3,
                                        "address4": "",
                                        "autoRenew": purchaseSummaryVm.renewal ? true : false,
                                        "policyStartDate":quoteCalculationDetail.quoteCreation.policyTerms.effectDate
                                        
                                        
                                    },

                                ]
                            },

                        ]
                    }
                }
            }
            generalInsurenceHomeService.setLinkedpolicyDetailDetails(createPolicy.portfolio.generalInsurance.products[0].policies[0]);
            generalInsurenceHomeService.setLinkedpolicyDetailDetailsNew(createPolicy.portfolio.generalInsurance.products[0]);
            var test = JSON.stringify(createPolicy);

            generalInsurenceHealthService.getPolicyCreate(createPolicy).then(function(data) {
                generalInsurenceHomeService.setPolicyCreateDetail(data);
                $state.go('menu.healthPaymentSuccess');
            }, function(error) {
                showRetry("Payment Received", $translate.instant("POLICY_ISSUE_FAILURE"), "online");
            });
        }

        
        purchaseSummaryVm.checkRenewal = function(){
            purchaseSummaryVm.renewal = !purchaseSummaryVm.renewal;
        }

        purchaseSummaryVm.goToNextPage = function() {

            if (validateForm()) {

                var alertPopup = $ionicPopup.alert({
                    title: "Confirm",
                    template: "Are you sure you want to proceed with a payment of " + $filter('rupeeSymbol')(purchaseSummaryVm.premiumAmount) + "?",
                    scope: $scope,
                    cssClass: 'sbi-alert-popup',
                    buttons: [{
                        text: 'Cancel',
                        type: 'button-negative',
                        onTap: function(e) {
                            return false;
                        }
                    },{
                        text: 'Proceed',
                        type: 'button-positive',
                        onTap: function(e) {
                            return true;
                        }
                    }]
               
                });

                  alertPopup.then(function(res) {
                generalInsurenceMotorService.UserSelectionLastName='false';      
                generalInsurenceHomeService.autoRenew = purchaseSummaryVm.renewal;
                                  
                    if (res) {
                        if ($stateParams.page == "health") {
                            if (purchaseSummaryVm.ProductIds == '14') {
                                getSimpleHealthPayment();
                            } else {
                                getPayment();
                            }
                        } else if ($stateParams.page == "motor") {
                            getPayment();
                        } else if ($stateParams.page == "travel") {
                            getPayment();
                        } else if ($stateParams.page == "accident") {
                            getPAIPayment();
                        } else if ($stateParams.page == "home") {
                            getPayment();
                        }          
                    }
                });     
            }
        }
    }
]);
