angularApp.controller('recommendedPoliciesController', [
    "$state",
    "$scope",

    function(
        $state,
        $scope) {

        var recommendedPoliciesVm = this;
        function initPage() {
           
            recommendedPoliciesVm.showBack = false;
            recommendedPoliciesVm.showNext = true;

            recommendedPoliciesVm.policiesList = [{
                title: "Critical Illness",
                imagePath: "img/generalInsurance/generalInsurance.png",
                htmlContent: "<p>Multiple coverage options - Individual & Family Floater options.</p>" +
                    " <p>OPD expenses as specified in the policy schedule.Sum Insured :  &#8377; 5,00,000</p>",
            }, {
                title: "Arogya Premier",
                imagePath: "img/generalInsurance/generalInsurance.png",
                htmlContent: "<p>No pre-policy medical test up to the age of 55 years for people with no medical history.</p>" +
                    " <p>142 Day Care expenses coveredSum Insured :  &#8377; 10,00,000</p>",
            }];
        }


        recommendedPoliciesVm.goToArogyaPremier = function() {
           
        }

        recommendedPoliciesVm.goBacktoPrevious = function() {

        }

        $scope.goToNextPage = function() {        
            $state.go('menu.recommendedPolicyDetails');
        }


        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        $scope.$on('$ionicView.beforeEnter', function() {
        });


        $scope.$on('$ionicView.afterLeave', function() {
        });
        return this;
    }
]);

