//'use strict';

angularApp.controller('recommendedPolicyDetailsController', [
    "$state",
    "$scope",
    "$stateParams", "generalInsurenceHomeService", "generalInsurenceMotorService", "GIconstant", "utilityService","$compile","arogyaSanjeevaniService",
    "$translate","$ionicPopup","generalInsurenceAccidentService",

    function(
        $state,
        $scope,
        $stateParams, generalInsurenceHomeService, generalInsurenceMotorService, GIconstant, utilityService,$compile,arogyaSanjeevaniService,
        $translate, $ionicPopup, generalInsurenceAccidentService) {


        var recommendedPolicyDetailsVm = this;
        var productDetail;
         $scope.paiErrorTitle = '';
        $scope.paiErrorDescription = '';
        $scope.paiErrorFooter = '';
        $scope.paiDisplayHelpContactMessage = '';
        recommendedPolicyDetailsVm.emptyObject = "&lt;p&gt; &lt;br /&gt; &lt;/p&gt;";
        recommendedPolicyDetailsVm.openUrl = function(url){
            if(url == "1"){
                generalInsurenceHomeService.getTermsAndCondtion(recommendedPolicyDetailsVm.padeDescription.policyBrochure);
            }else{
                 generalInsurenceHomeService.getTermsAndCondtion(recommendedPolicyDetailsVm.padeDescription.policyWording);

            }
        }

        function initPage() {

            recommendedPolicyDetailsVm.copyRight = generalInsurenceHomeService.getGIProducts() ? generalInsurenceHomeService.getGIProducts().productFooter : "";
            productDetail = generalInsurenceHomeService.getProductDetail();
            recommendedPolicyDetailsVm.policyLogo = productDetail.logoImgUrlMobile;
            recommendedPolicyDetailsVm.policyTitle = productDetail.policyName;
            recommendedPolicyDetailsVm.showContect = 0;
            
            if (productDetail) {
                var uin = {
                    'uin': productDetail.uin
                }
                generalInsurenceHomeService.getProductFeatures(uin).then(function(data) {
                    generalInsurenceHomeService.setPlanDetail(data);
                    recommendedPolicyDetailsVm.policyDiscription = data.planDesc;
                    recommendedPolicyDetailsVm.padeDescription = data;
                    recommendedPolicyDetailsVm.policyTitle = data.planName; 

                    var brocherUrl = recommendedPolicyDetailsVm.padeDescription.policyBrochure; 
                    var policyWordingUrl = recommendedPolicyDetailsVm.padeDescription.policyWording;   
                    var downloadArray = {};

                    if(productDetail.uin == GIconstant.common.arogyaSanjeevani){
                        downloadArray = {
                            "name" : "Downloads",
                            "featureItems" : [
                                "&lt;ul&gt; &lt;li  &gt;&lt;a onclick='angular.element(this).scope().recommendedPolicyDetailsVm.openUrl(1)' rel='noopener' target='_systen' &gt; Product Brochure &lt;/a&gt;&lt;/li&gt; &lt;/ul&gt;"
                            ]
                        } 
                    }else if(productDetail.uin != GIconstant.common.simpleHealth){
                        downloadArray = {
                            "name" : "Downloads",
                            "featureItems" : [
                                "&lt;ul&gt; &lt;li  &gt;&lt;a onclick='angular.element(this).scope().recommendedPolicyDetailsVm.openUrl(1)' rel='noopener' target='_systen'  &gt;Product Brochure&lt;/a&gt; &lt;/li&gt; &lt;li&gt;&lt;a onclick='angular.element(this).scope().recommendedPolicyDetailsVm.openUrl(2)' rel='noopener' target='_systen' &gt; Policy Wording &lt;/a&gt;&lt;/li&gt; &lt;/ul&gt;"
                            ]
                        }
                    }else{
                        downloadArray = {
                            "name" : "Downloads",
                            "featureItems" : [
                                "&lt;ul&gt; &lt;li  &gt;&lt;a onclick='angular.element(this).scope().recommendedPolicyDetailsVm.openUrl(2)' rel='noopener' target='_systen' &gt; Policy Wording &lt;/a&gt;&lt;/li&gt; &lt;/ul&gt;"
                            ]
                        } 
                    }
                            
                    recommendedPolicyDetailsVm.padeDescription.planFeatures.push(downloadArray);
                    recommendedPolicyDetailsVm.DetailsFAQ = recommendedPolicyDetailsVm.padeDescription.planFeatures[0].featureItems;
                    recommendedPolicyDetailsVm.coverages = data.coverage;
                    recommendedPolicyDetailsVm.keyFeatures = data.keyFeature;
                    recommendedPolicyDetailsVm.faqs = data.faq;
                    recommendedPolicyDetailsVm.exclusions = data.exclusions;                
                }, function(error) {
                    if(error.responseCode == '0003'){
                        $ionicPopup.alert({
                            template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">' + error.responseMessage + '</span></div></div></div>',
                            scope: $scope,
                            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                            buttons: [
                                {
                                    text: "OK",
                                    type: 'button-positive',
                                    onTap: function () {
                                        
                                        $state.go("menu.personalaccidentdetail"); 
                                        
                                    }
                                }
                            ],
                        });
                    }
                    else{
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                });

            }
            recommendedPolicyDetailsVm.showBack = false;
            recommendedPolicyDetailsVm.showNext = true;
            if ($stateParams.page) {
                generalInsurenceMotorService.setMotorType($stateParams.type);
            }
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        recommendedPolicyDetailsVm.showFAQS = function(data) {
            recommendedPolicyDetailsVm.DetailsFAQ = data.featureItems;
        }

        recommendedPolicyDetailsVm.goBack = function() {

            switch ($stateParams.page) {
                case 'health':
                    $state.go('menu.healthInsurance');
                    break;
                case 'motor':
                    $state.go('menu.motorInsuranceDetail');
                    break;
                case 'travel':
                    $state.go('menu.travelInsuranceDetail');
                    break;
                case 'accident':
                    $state.go('menu.personalaccidentdetail');
                    break;
                default:
                    $state.go('menu.homeInsuranceDetail');
            }
        }

        recommendedPolicyDetailsVm.onClickBuy = function() {
            switch (productDetail.uin) {
                case GIconstant.common.TravelInsurance:
                    $state.go('menu.travelQuotePolicyInfo');
                    break;
                case GIconstant.common.motorTwo:
                    $state.go('menu.motorGetQuote');
                    break;
                case GIconstant.common.motorFour:
                    $state.go('menu.motorGetQuote');
                    break;
                case GIconstant.common.arogysPremier:
                    $state.go('menu.simpleHealthPremiumCalulation');
                    break;
                case GIconstant.common.criticalIllness:
                    $state.go('menu.criticalIlnessPremiumCalulation');
                    break;
                case GIconstant.common.hospitaldailycash:
                    $state.go('menu.hospitalDailyCashPremiumCalculation');
                    break;
                case GIconstant.common.simpleHealth:
                    $state.go('menu.simpleHealthPremiumCalulation');
                    break;
                case GIconstant.common.PAI:
                    // Validate policy purchase API
                    utilityService.showSpinner();
                    generalInsurenceAccidentService.paiValidatePolicyPurchase().then(function(response) {
                        utilityService.hideSpinner();
                        if(response.data.isAllowed == "true"){
                            $state.go('menu.accidentQuoteMemberInfo');
                        }
                        else{
                            $scope.paiErrorTitle = response.data.errorTitle;
                            $scope.paiErrorFooter = response.data.errorFooter;
                            $scope.paiErrorDescription = response.data.errorDescription;
                            recommendedPolicyDetailsVm.popUp = $ionicPopup.show({
                                title: '',
                                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                                templateUrl: 'pages/generalInsurance/common/paiErrorMessagePopup.html',
                                scope: $scope
                            });
                        }
                    },function(error) {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                    break;
                case GIconstant.common.arogyaSanjeevani:
                     arogyaSanjeevaniService.clearAll();
                     $state.go('menu.arsaQuoteCalculation');
                    break;
                default:
                    $state.go('menu.homeQuotePolicyInfo');
                    break;
            }
        }
        recommendedPolicyDetailsVm.close = function(){
            recommendedPolicyDetailsVm.popUp.close();
        }
        return this;
    }
]);
