angularApp.service('generalInsurenceHealthService', ["$filter", "$state",  "genralInsurenceConfig", "$q", "AdapterUtils", "generalInsurenceHomeService", "generalInsurenceTravelService","utilityService","validateService",
    function($filter, $state,  genralInsurenceConfig, $q, AdapterUtils, generalInsurenceHomeService, generalInsurenceTravelService,utilityService,validateService) {



        var generalInsurenceHealth = this;
        var productDetail, healthProduct,insuredParty;
        var basicDetail, healthType, healthAdditionalDetails, insureDetail, preExistingDesease, createPartyNominee;
        var healthApplicationPersonalDetails, hospitalInsuredDetail, criticalIllnessDetails, hdcMasters, arogyaMasters, criticalMasters, simpleMasters, criticalIllnessOffer, arogyaOffer, hdcOffer, saveApplicationArogyaResponse, saveApplicationCriticalResponse, saveApplicationHDCResponse;
        var CriticalillnessFirstPageDetail, healthAdditionalDetails123, healthInformation, criticalIllnessQuoteNumberDetail, arogymPremiumCalc, criticalMaster;
        var PremiumcalculationForCriticalIllness, createParty, Quotecalculation, healthQuestionaire, HDCpremiumDetails, PremiumcalculationForArogya, simpleHealthCalc, HDCSumInsured;

        generalInsurenceHealth.getHDCMaster = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getHDCMaster[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHealth.getArogyaMaster = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getArogyaMaster[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHealth.getSimpleMaster = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getSimpleMaster[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /*  get Critical Illness  Masters list */
        generalInsurenceHealth.getCriticalMaster = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getCriticalMaster[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* Quote for critical illness*/
        generalInsurenceHealth.getHICriticalIllnessQuote = function(criticalillnessDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getHICriticalIllnessQuote[0], criticalillnessDetail, true).then(
                function(response) {
                    if(response.data){
                        generalInsurenceHomeService.setQuoteNumber(response.data.premiumCalculation.quoteNumber);
                    }
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        /* Quote for Simple Health*/
        generalInsurenceHealth.getSimpleHealthPremium = function(simpleHealthDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getSimpleHealthPremium[0], simpleHealthDetail, true).then(
                function(response) {
                    if(response.data){
                        generalInsurenceHomeService.setQuoteNumber(response.data.premiumCalculation.quoteNumber);
                    }
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* getAgentReceipt  */
        generalInsurenceHealth.getAgentReceipt = function(agentData) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(genralInsurenceConfig.adapterURL.getAgentReceipt[0], agentData, true,genralInsurenceConfig.adapterURL.getAgentReceipt[1]).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* Arogym Premium Calculation  */
        generalInsurenceHealth.getHIArogyaQuote = function(arogyaPremium) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getHIArogyaQuote[0], arogyaPremium, true).then(
                function(response) {
                     if(response.data){
                        generalInsurenceHomeService.setQuoteNumber(response.data.premiumCalculation.quoteNumber);
                    }   
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

         /* Arogym Premium Calculation  */
        generalInsurenceHealth.getHIArogyaQuoteWithoutOverlay = function(arogyaPremium) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getHIArogyaQuote[0], arogyaPremium, false).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        /* get Online Policy  */
        generalInsurenceHealth.getOnlinePolicy = function(onlinePolicy) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(genralInsurenceConfig.adapterURL.getOnlinePolicy[0], onlinePolicy, true , genralInsurenceConfig.adapterURL.getOnlinePolicy[1]).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* get Policy Create  */
        generalInsurenceHealth.getPolicyCreate = function(policyCreate) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(genralInsurenceConfig.adapterURL.getPolicyCreate[0], policyCreate, true,genralInsurenceConfig.adapterURL.getPolicyCreate[1]).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        /* get Delink  */
        generalInsurenceHealth.getDelink = function(delink) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getDelink[0], delink, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* get claim Status  */
        generalInsurenceHealth.getClaimStatus = function(claimStatus) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.getClaimStatus[0], claimStatus, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceHealth.payForOtherPurchase = function(paymentData) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.payForOtherPurchase[0], paymentData, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
		
		generalInsurenceHealth.payForPAIRenew = function(paymentData) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.payForPAIRenew[0], paymentData, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
		
		generalInsurenceHealth.validateOTPForPAIRenewal = function(paymentData) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.validateOTPForPAIRenewal[0], paymentData, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

       // function to validate OTP for Other products
        generalInsurenceHealth.validateOTPForOtherPayment = function(otpRequest) {
            var q = $q.defer();
            AdapterUtils.postDataWithTimeOut(genralInsurenceConfig.adapterURL.validateOTPForOtherPayment[0], otpRequest, true,300000).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        // function to resend OTP for Other products
        generalInsurenceHealth.resendOTPForOtherPayment = function() {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.resendOTPForOthers[0], true).then(
                function(response) {

                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };



        generalInsurenceHealth.setHICriticalIllnessQuoteDetail = function(data) {
            criticalIllnessQuoteNumberDetail = data;
        }

        generalInsurenceHealth.getHICriticalIllnessQuoteDetail = function() {
            return criticalIllnessQuoteNumberDetail;
        }

        generalInsurenceHealth.setCriticalPrimiumForOffer = function(data) {
            criticalIllnessOffer = data;
        }

        generalInsurenceHealth.getCriticalPrimiumForOffer = function() {
            return criticalIllnessOffer;
        }

        generalInsurenceHealth.setArogyaPrimiumForOffer = function(data) {
            arogyaOffer = data;
        }

        generalInsurenceHealth.getArogyaPrimiumForOffer = function() {
            return arogyaOffer;
        }

        generalInsurenceHealth.setHDCPrimiumForOffer = function(data) {
            hdcOffer = data;
        }

        generalInsurenceHealth.getHDCPrimiumForOffer = function() {
            return hdcOffer;
        }

        generalInsurenceHealth.setPremiumcalculationForArogyaPremium = function(data) {
            arogymPremiumCalc = data;
        }

        generalInsurenceHealth.getPremiumcalculationForArogyaPremium = function() {
            return arogymPremiumCalc;
        }

        generalInsurenceHealth.setCriticalIllnessMaster = function(data) {
            criticalMaster = data;
        }

        generalInsurenceHealth.getCriticalIllnessMaster = function() {
            return criticalMaster;
        }

        generalInsurenceHealth.setPremiumcalculationForSimpleHealth = function(data) {
            simpleHealthCalc = data;
        }

        generalInsurenceHealth.getPremiumcalculationForSimpleHealth = function() {
            return simpleHealthCalc;
        }

        generalInsurenceHealth.getQuoutforsimpleHealth = function(callback) {}


        generalInsurenceHealth.getPremiumforsimpleHealth = function(callback) {}

        generalInsurenceHealth.setCriticalIllnessDetails = function(data) {
            criticalIllnessDetails = data;
        }

        generalInsurenceHealth.getQuoutforArogyaPremium = function(callback) {}

        generalInsurenceHealth.getCriticalIllnessDetails = function() {
            return criticalIllnessDetails;
        }


        generalInsurenceHealth.getPremiumforsArogyaPremium = function(callback) {}



        generalInsurenceHealth.getQuoutforHospitalDailycash = function(callback) {}

        generalInsurenceHealth.getPremiumforHospitalDailycash = function(callback) {}


        generalInsurenceHealth.getQuoutforcriticalIllness = function(callback) {}

        generalInsurenceHealth.getPremiumforcriticalIllness = function(callback) {}

        generalInsurenceHealth.setPremiumDetailsForHDC = function(data) {
            HDCpremiumDetails = data;
        }

        generalInsurenceHealth.getPremiumDetailsForHDC = function() {
            return HDCpremiumDetails;
        }

        generalInsurenceHealth.setHDCSumInsured = function(data) {
            HDCSumInsured = data;
        }

        generalInsurenceHealth.getHDCSumInsured = function() {
            return HDCSumInsured;
        }



        generalInsurenceHealth.setbasicHealthDetail = function(data) {
            basicDetail = angular.copy(data);
        }

        generalInsurenceHealth.getbasicHealthDetail = function() {
            return angular.copy(basicDetail);
        }

        generalInsurenceHealth.setHealthInsureDetails = function(data) {
            insureDetail = angular.copy(data);
        }

        generalInsurenceHealth.getHealthInsureDetails = function() {

            return angular.copy(insureDetail);
        }

        generalInsurenceHealth.setHealthInformationDetails = function(detail) {
            healthInformation = angular.copy(detail);
        }

        generalInsurenceHealth.getHealthInformationDetails = function() {
            return angular.copy(healthInformation);
        }

        generalInsurenceHealth.sethealthType = function(data) {
            healthType = data;
        }

        generalInsurenceHealth.gethealthType = function() {
            return healthType;
        }


        generalInsurenceHealth.setHospitalDailyCashDetails = function(data) {
            hospitalInsuredDetail = data;
        }
        generalInsurenceHealth.getHospitalDailyCashDetails = function(data) {
            return hospitalInsuredDetail;
        }

        /* set Additional Health Information of users  */
        generalInsurenceHealth.setHealthAdditionalDetails = function(data) {
                healthAdditionalDetails = angular.copy(data);
            }
            /* return Additional Health Information of users  */
        generalInsurenceHealth.getHealthAdditionalDetails = function() {
            return angular.copy(healthAdditionalDetails);
        }

        generalInsurenceHealth.setHealthApplicationPersonalDetails = function(data) {
            healthApplicationPersonalDetails = data;
        }

        generalInsurenceHealth.getHealthApplicationPersonalDetails = function() {
            return healthApplicationPersonalDetails;
        }


        generalInsurenceHealth.setCriticalillnessFirstPageDetail = function(data) {
            CriticalillnessFirstPageDetail = data;
        }

        generalInsurenceHealth.getCriticalillnessFirstPageDetail = function() {
            return CriticalillnessFirstPageDetail;
        }

        generalInsurenceHealth.setPremiumcalculationForCriticalIllness = function(data) {
            PremiumcalculationForCriticalIllness = data;
        }

        generalInsurenceHealth.getPremiumcalculationForCriticalIllness = function() {
            return PremiumcalculationForCriticalIllness;
        }

        /* set HDC Masters  */
        generalInsurenceHealth.setHDCMasterList = function(data) {
                hdcMasters = data;
            }
            /* get HDC Masters  */
        generalInsurenceHealth.getHDCMasterList = function() {
            return hdcMasters;
        }

        /* set Arogya Masters  */
        generalInsurenceHealth.setArogyaMasterList = function(data) {
                arogyaMasters = data;
            }
            /* get Arogya Masters  */
        generalInsurenceHealth.getArogyaMasterList = function() {
            return arogyaMasters;
        }

        /* set Arogya Masters  */
        generalInsurenceHealth.setSimpleMasterList = function(data) {
                simpleMasters = data;
            }
            /* get Arogya Masters  */
        generalInsurenceHealth.getSimpleMasterList = function() {
            return simpleMasters;
        }

        /* set Arogya Masters  */
        generalInsurenceHealth.setCriticalMasterList = function(data) {
                criticalMasters = data;
            }
            /* get Arogya Masters  */
        generalInsurenceHealth.getCriticalMasterList = function() {
            return criticalMasters;
        }

        //   generalInsurenceHealth.setQuotecalculation = function(data) {
        //     PremiumcalculationForArogya = data;
        // }

        // generalInsurenceHealth.getQuotecalculation = function() {
        //     return PremiumcalculationForArogya;
        // }

        generalInsurenceHealth.setQuotecalculation = function(data) {
            Quotecalculation = data;
        }

        generalInsurenceHealth.getQuotecalculation = function() {
            return Quotecalculation;
        }

        generalInsurenceHealth.setHealthQuestionaire = function(data) {
            healthQuestionaire = data;
        }

        generalInsurenceHealth.getHealthQuestionaire = function() {
            return healthQuestionaire;
        }

        generalInsurenceHealth.setCreatePartyCI = function(data) {
            createParty = data;
        }

        generalInsurenceHealth.getCreatePartyCI = function() {
            return createParty;
        }

        generalInsurenceHealth.setCreatePartyInsured = function(data) {
            insuredParty = data;
        }

        generalInsurenceHealth.getCreatePartyInsured = function() {
            return insuredParty;
        }

        generalInsurenceHealth.setCreatePartyNominee = function(data) {
            createPartyNominee = data;
        }

        generalInsurenceHealth.getCreatePartyNominee = function() {
            return createPartyNominee;
        }

        generalInsurenceHealth.setpreExistingDesease = function(data) {
            preExistingDesease = angular.copy(data);
        }

        generalInsurenceHealth.getpreExistingDesease = function() {
            return angular.copy(preExistingDesease);
        }

        generalInsurenceHealth.setSaveApplicationArogyaResponse = function(data) {
            saveApplicationArogyaResponse = data;
        }

        generalInsurenceHealth.getSaveApplicationArogyaResponse = function() {
            return saveApplicationArogyaResponse;
        }

        generalInsurenceHealth.setSaveApplicationCriticalResponse = function(data) {
            saveApplicationCriticalResponse = data;
        }

        generalInsurenceHealth.getSaveApplicationCriticalResponse = function() {
            return saveApplicationCriticalResponse;
        }
        generalInsurenceHealth.setSaveApplicationHDCResponse = function(data) {
            saveApplicationHDCResponse = data;
        }

        generalInsurenceHealth.getSaveApplicationHDCResponse = function() {
            return saveApplicationHDCResponse;
        }


        generalInsurenceHealth.clearAllData = function() {
            productDetail = null;healthProduct = null;basicDetail =  null;healthType =  null;healthAdditionalDetails =  null;insureDetail =  null;
            preExistingDesease =  null;createPartyNominee = null;healthApplicationPersonalDetails = null;hospitalInsuredDetail = null; criticalIllnessDetails = null;hdcMasters = null;arogyaMasters = null;
            criticalMasters= null;simpleMasters= null; criticalIllnessOffer= null; arogyaOffer= null; hdcOffer= null; saveApplicationArogyaResponse= null; saveApplicationCriticalResponse= null; saveApplicationHDCResponse;
            CriticalillnessFirstPageDetail= null; healthAdditionalDetails123= null; healthInformation= null; criticalIllnessQuoteNumberDetail= null; arogymPremiumCalc= null; criticalMaster;
            PremiumcalculationForCriticalIllness= null; createParty= null; Quotecalculation= null; healthQuestionaire= null; HDCpremiumDetails= null; PremiumcalculationForArogya= null; simpleHealthCalc= null; HDCSumInsured= null;
        }



        generalInsurenceHealth.getSaveQuoteRequestForSimpleHealth = function() {

            var structure = {
                "quoteData": {
                    "premiumCalculation": {
                        "request": {
                            "quoteDetails": {},
                            "insuredDetails": []
                        },
                        "response": {}
                    }
                }
            }
            return structure;
        }

        generalInsurenceHealth.getSaveQuoteRequestForArogya = function() {

            var structure = {
                "quoteData": {
                    "premiumCalculation": {
                        "response": {},
                        "request": {
                            "insuredDetails": [],
                            "quoteDetails": {}
                        }
                    }
                }
            }

            return structure;
        }

        generalInsurenceHealth.getSaveApplicationRequestForSimpleHealth = function() {

            var structure = {
                "applicationData": {
                    "createquoterequest": {
                        "personalDetails": {},
                        "insuredDetails": [],
                        "healthInformationDetails": [],
                        "insuredPersonDiseasesDetails": [],
                        "preexistingDiseaseDetails": [],
                        "concurrentInsuranceDetails": [],
                        "nomineeDetails": {}
                    },
                    "partyDetail": {},
                    "response": {}
                }
            }
            return structure;
        }

        generalInsurenceHealth.getSaveApplicationRequestForArogya = function() {

            var structure = {
                "applicationData": {
                    "createquoterequest": {
                        "personalDetails": {},
                        "insuredDetails": [],
                        "healthInformationDetails": [],
                        "concurrentInsuranceDetails": [],
                        "nomineeDetails": {}
                    },
                    "partyDetail": {},
                    "response": {}
                }
            }
            return structure;
        }

        generalInsurenceHealth.getSaveApplicationRequestForCritical = function() {

            var structure = {
                "applicationData": {
                    "createquoterequest": {
                        "personalDetails": {},
                        "healthInformationDetails": [],
                        "concurrentInsuranceDetails": [],
                        "insuredDetails": [],
                        "nomineeDetails": {}
                    },
                    "partyDetail": {},
                    "response": {}
                }
            }
            return structure;
        }

        generalInsurenceHealth.getSaveApplicationRequestForHDC = function() {

            var structure = {
                "applicationData": {
                    "createquoterequest": {
                        "personalDetails": {},
                        "insuredDetails": [],
                        "healthInformationDetails": [],
                        "deniedDetails": [],
                        "concurrentInsuranceDetails": [],
                        "nomineeDetails": {}
                    },
                    "partyDetail": {},
                    "response": {}
                }
            }
            return structure;
        }


        generalInsurenceHealth.getSaveQuoteRequestForCriticalIllness = function() {

            var structure = {
                "quoteData": {
                    "premiumCalculation": {
                        "request": {},
                        "response": {}
                    }
                }
            }
            return structure;
        }

        generalInsurenceHealth.getSaveQuoteRequestForHDC = function() {

            var structure = {
                "quoteData": {
                    "premiumCalculation": {
                        "response": {},
                        "quotes": [],
                        "request": {
                            "insuredDetails": [],
                            "quoteDetails": {}
                        }
                    }
                }
            }
            return structure;
        }


        function saveObjectforArogyaFirstPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request && savedData.quoteData.premiumCalculation.request.quoteDetails) {
                var savedDetail = {}
                savedDetail.familySize = savedData.quoteData.premiumCalculation.request.quoteDetails.familysize;
                savedDetail.productTypes = savedData.quoteData.premiumCalculation.request.quoteDetails.productType;
                savedDetail.startDate = $filter('chosenDate')(savedData.quoteData.premiumCalculation.request.quoteDetails.effectiveDate);
                savedDetail.uin = savedData.uin;
                basicDetail = savedDetail;
            }
        }

        function saveObjectforArogyaThirdPage(savedData) {

            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.response && savedData.quoteData.premiumCalculation.response.premiumCalculation) {
                var savedDetail = {}
                savedDetail.data = [];
                savedDetail.productUin = savedData.uin;
                savedDetail.quoteNumber = savedData.quoteData.premiumCalculation.response.premiumCalculation.quoteNumber;
                savedDetail.sumInsured = savedData.sumInsured;
                savedDetail.data[0] = savedData.quoteData.premiumCalculation.response.premiumCalculation.actualPremiumPayable;
                generalInsurenceHomeService.setQuoteListDetails(savedDetail);
                arogymPremiumCalc = savedData.quoteData.premiumCalculation.response;
            }

        }

        function saveObjectforArogyaSecondPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request && savedData.quoteData.premiumCalculation.request.quoteDetails) {
                var savedDetail = {}
                savedDetail.Birthdate = [];
                savedDetail.Relationship = [];
                savedDetail.SumInsured = [];
                for (var count = 0; count < savedData.quoteData.premiumCalculation.request.quoteDetails.familysize; count++) {
                    if (savedData.quoteData.premiumCalculation.request.insuredDetails.length > 0) {
                        savedDetail.Birthdate[count] = {};
                        savedDetail.Relationship[count] = {};
                        savedDetail.SumInsured[count] = {};
                        savedDetail.Birthdate[count] = $filter('chosenDate')(savedData.quoteData.premiumCalculation.request.insuredDetails[count].dob);
                        savedDetail.Relationship[count] = savedData.quoteData.premiumCalculation.request.insuredDetails[count].relationship;
                        savedDetail.SumInsured[count] = savedData.quoteData.premiumCalculation.request.insuredDetails[count].sumInsured ? $filter('selectBoxFilter')(arogyaMasters.variantSumInsured, savedData.quoteData.premiumCalculation.request.insuredDetails[count].sumInsured,"value") : "";
                    }
                }

                savedDetail.uin = savedData.uin;
                insureDetail = savedDetail;
                arogymPremiumCalc = savedData.quoteData.premiumCalculation.response;
            }

        }

        function saveObjectforArogyaSixthPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest) {
              var   savedDetail = [];
                savedDetail[0] = {};
                savedDetail[0].tobacco = savedData.applicationData.createquoterequest.healthInformation;
                for (var count = 0; count < savedData.quoteData.premiumCalculation.request.quoteDetails.familysize; count++) {
                    if (count != 0) {
                        savedDetail[count] = {};
                    }
                    if (savedData.applicationData.createquoterequest.healthInformationDetails.length > 0) {
                        savedDetail[count].insuredName = savedData.applicationData.createquoterequest.healthInformationDetails[count].name;
                        savedDetail[count].consumeTobacoo = savedData.applicationData.createquoterequest.healthInformationDetails[count].doYouConsumeTobacco;
                        savedDetail[count].smoke = savedData.applicationData.createquoterequest.healthInformationDetails[count].doYouSmoke;
                    }

                }
                savedDetail[0].mentaldesease = savedData.applicationData.createquoterequest.phsicalMentalDiseases;
                savedDetail[0].denied = savedData.applicationData.createquoterequest.insuranceByOtherComapany;
                savedDetail[0].insurance = savedData.applicationData.createquoterequest.concurrentInsurance;
                generalInsurenceHealth.getArogyaMaster().then(function(response) {
                    generalInsurenceHealth.setArogyaMasterList(response);
                    for (var count = 0; count < savedData.applicationData.createquoterequest.concurrentInsuranceDetails.length; count++) {
                        if (savedData.applicationData.createquoterequest.concurrentInsuranceDetails.length > 0) {
                            savedDetail[count].companyName = generalInsurenceHealth.assignKeyValueForArogya(arogyaMasters.insuranceComapnyName, savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredComapny);
                            savedDetail[count].name = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredPerson;
                            savedDetail[count].sumInsured = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].sumInsured;
                        }

                    }

                    healthInformation = savedDetail;
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    //alert(error.responseMessage);
                });
            }
        }

        function saveObjectforArogyaFourthPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.personalDetails) {
                var savedDetail = {}
                savedDetail.LastName = savedData.applicationData.createquoterequest.personalDetails.lastName;
                savedDetail.address = savedData.applicationData.createquoterequest.personalDetails.buildingName;
                savedDetail.birthdate = $filter('chosenDate')(savedData.applicationData.createquoterequest.personalDetails.dob);
                savedDetail.city = savedData.applicationData.createquoterequest.personalDetails.city;
                savedDetail.email = savedData.applicationData.createquoterequest.personalDetails.emailId;
                savedDetail.firstName = savedData.applicationData.createquoterequest.personalDetails.firstName;
                savedDetail.location = savedData.applicationData.createquoterequest.personalDetails.location;
                savedDetail.locations = savedData.applicationData.createquoterequest.personalDetails.locationSource.location;
                savedDetail.mobile = savedData.applicationData.createquoterequest.personalDetails.mobileNumber;
                savedDetail.pincode = savedData.applicationData.createquoterequest.personalDetails.pincode;
                savedDetail.plotNo = savedData.applicationData.createquoterequest.personalDetails.plotNo;
                savedDetail.streetName = savedData.applicationData.createquoterequest.personalDetails.streetName;
                savedDetail.title = savedData.applicationData.createquoterequest.personalDetails.abbrName;
                savedDetail.gender = savedData.applicationData.createquoterequest.personalDetails.gender;
               if(savedData.applicationData.partyDetail){
                        createParty = {};
                        createParty.partyCreate = savedData.applicationData.partyDetail;
               }
                
                

                generalInsurenceHomeService.setLocationDetails(savedData.applicationData.createquoterequest.personalDetails.locationSource);
                healthApplicationPersonalDetails = savedDetail;
            }
        }

        function saveObjectforArogyaFifthPage(savedData) {

            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.insuredDetails) {
                var savedDetail = {};
                savedDetail.Gender = [];
                savedDetail.birthDay = []
                savedDetail.lastName = [];
                savedDetail.name = [];
                savedDetail.relationship = []
                savedDetail.sumInsured = [];
                savedDetail.title = [];
                savedDetail.maritalStatus = [];
                insuredParty = {};
                insuredParty.partyCreate = [];
                for (var count = 0; count < savedData.quoteData.premiumCalculation.request.quoteDetails.familysize; count++) {
                    if (savedData.applicationData.createquoterequest.insuredDetails.length > 0) {
                        savedDetail.Gender[count] = {};
                        savedDetail.birthDay[count] = {};
                        savedDetail.lastName[count] = {};
                        savedDetail.name[count] = {};
                        savedDetail.maritalStatus[count] = {};
                        savedDetail.relationship[count] = {};
                        savedDetail.sumInsured[count] = {};
                        savedDetail.title[count] = {};
                        savedDetail.Gender[count] = savedData.applicationData.createquoterequest.insuredDetails[count].gender ? $filter('selectBoxFilter')(arogyaMasters.gender, savedData.applicationData.createquoterequest.insuredDetails[count].gender,"ikey") : "";
                        //savedDetail.Gender[count] = generalInsurenceHealth.assignKeyValueForArogya(arogyaMasters.gender, savedData.applicationData.createquoterequest.insuredDetails[count].gender);
                        savedDetail.birthDay[count] = $filter('chosenDate')(savedData.applicationData.createquoterequest.insuredDetails[count].insureDob);
                        savedDetail.lastName[count] = savedData.applicationData.createquoterequest.insuredDetails[count].lastName;
                        savedDetail.name[count] = savedData.applicationData.createquoterequest.insuredDetails[count].firstName;
                        savedDetail.relationship[count] = savedData.applicationData.createquoterequest.insuredDetails[count].relationship;
                        savedDetail.sumInsured[count] = savedData.applicationData.createquoterequest.insuredDetails[count].sumInsured;
                        savedDetail.title[count] = savedData.applicationData.createquoterequest.insuredDetails[count].salutation;
                        savedDetail.maritalStatus[count] = generalInsurenceHealth.assignKeyValueForArogya(arogyaMasters.martialStatus, savedData.applicationData.createquoterequest.insuredDetails[count].maritalStatus);
                        insuredParty.partyCreate.push(savedData.applicationData.createquoterequest.insuredDetails[count].partyDetails);
                        savedDetail.uin = savedData.uin;

                    }

                }
                healthAdditionalDetails = savedDetail;
            }



            // var savedDetail = []

            // for (var count = 0; count < savedData.quoteData.premiumCalculation.request.quoteDetails.familysize; count++) {
            //     savedDetail[count] = {};
            //     savedDetail[count].Gender = generalInsurenceHealth.assignKeyValueForArogya(arogyaMasters.gender, savedData.applicationData.createquoterequest.insuredDetails[count].gender);
            //     savedDetail[count].birthDay = $filter('chosenDate')(savedData.applicationData.createquoterequest.insuredDetails[count].insureDob);
            //     savedDetail[count].lastName = savedData.applicationData.createquoterequest.insuredDetails[count].lastName;
            //     savedDetail[count].maritalStatus = generalInsurenceHealth.assignKeyValueForArogya(arogyaMasters.martialStatus, savedData.applicationData.createquoterequest.insuredDetails[count].maritalStatus);
            //     savedDetail[count].name = savedData.applicationData.createquoterequest.insuredDetails[count].firstName;
            //     savedDetail[count].relationship = generalInsurenceHealth.assignKeyValueForArogya(arogyaMasters.realtionWithproposer, savedData.applicationData.createquoterequest.insuredDetails[count].relationship);
            //     savedDetail[count].sumInsured = savedData.applicationData.createquoterequest.insuredDetails[count].sumInsured;
            //     savedDetail[count].title = savedData.applicationData.createquoterequest.insuredDetails[count].salutation;
            //     savedDetail.uin = savedData.uin;
            // }
            // healthAdditionalDetails = savedDetail;
        }

        function saveObjectforArogyaSeventhPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.nomineeDetails) {
                var savedDetail = {}
                    // savedDetail.nomineeTitle = savedData.applicationData.createquoterequest.nomineeDetails.lastName;
                savedDetail.name1 = savedData.applicationData.createquoterequest.nomineeDetails.name.firstName;
                savedDetail.nomineeTitle = savedData.applicationData.createquoterequest.nomineeDetails.name.salutation;
                savedDetail.nomineeLastName = savedData.applicationData.createquoterequest.nomineeDetails.name.lastName;
                savedDetail.relationship = generalInsurenceHealth.assignKeyValueForArogya(arogyaMasters.nomineeRealtion, savedData.applicationData.createquoterequest.nomineeDetails.relationship);
                savedDetail.birthDate = $filter('chosenDate')(savedData.applicationData.createquoterequest.nomineeDetails.dob);
                // savedDetail.nomineeMinor = savedData.applicationData.createquoterequest.personalDetails.firstName;
                if(savedData.applicationData.createquoterequest.appointeeDetails){
                    savedDetail.appointeeTitle = savedData.applicationData.createquoterequest.appointeeDetails.appointeeTitle;
                    savedDetail.name = savedData.applicationData.createquoterequest.appointeeDetails.name;
                    savedDetail.appointeeLastName = savedData.applicationData.createquoterequest.appointeeDetails.lastName;
                    savedDetail.relationshipWithNominee = generalInsurenceHealth.assignKeyValueForArogya(arogyaMasters.appointeeRelation, savedData.applicationData.createquoterequest.appointeeDetails.appointeeRelationship);
                }               
                savedDetail.uin = savedData.uin;
                generalInsurenceTravelService.setTravelNomineeDetail(savedDetail);
                createPartyNominee = {};
                createPartyNominee.partyCreate = savedData.applicationData.createquoterequest.nomineeDetails.partyDetail;
            }

        }

        /* Assign value for Arogya Premium  */
        generalInsurenceHealth.assignvalueForArogya = function() {
            var pagelength = 7;
            var savedData = generalInsurenceHomeService.getSaveApplicationArogyaStructure();
            generalInsurenceHealth.getArogyaMaster().then(function(response) {
                arogyaMasters = response;
                saveObjectforArogyaFirstPage(savedData);
                saveObjectforArogyaSecondPage(savedData);
                saveObjectforArogyaThirdPage(savedData);
                saveObjectforArogyaFourthPage(savedData);
                saveObjectforArogyaFifthPage(savedData);
                saveObjectforArogyaSixthPage(savedData);
                saveObjectforArogyaSeventhPage(savedData);
                //$state.go('menu.simpleHealthPremiumCalulation');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
                //alert(error.responseMessage);
            });
        }

        /* Assign value for Critical Illness  */
        generalInsurenceHealth.assignvalueForCritical = function() {
            var pagelength = 7;
            var savedData = generalInsurenceHomeService.getSaveApplicationCriticalStructure();
            generalInsurenceHealth.getCriticalMaster().then(function(response) {
                criticalMasters = response;
                saveObjectforCriticalFirstPage(savedData);
                saveObjectforCriticalSecondPage(savedData);
                saveObjectforCriticalThirdPage(savedData);
                saveObjectforCriticalFourthPage(savedData);
                saveObjectforCriticalFifthPage(savedData);
                saveObjectforCriticalSixthPage(savedData);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
                //alert(error.responseMessage);
            });


        }

        function saveObjectforCriticalFirstPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request) {
                var savedDetail = {}
                savedDetail.sumInsured = generalInsurenceHealth.assignKeyValueForArogya(criticalMasters.sumInsured, savedData.quoteData.premiumCalculation.request.suminsured);
                savedDetail.Birthday = $filter('chosenDate')(savedData.quoteData.premiumCalculation.request.dob);
                savedDetail.policyStartDate = $filter('chosenDate')(savedData.quoteData.premiumCalculation.request.effectiveDate);
                savedDetail.Gender = savedData.quoteData.premiumCalculation.request.gender;
                criticalIllnessDetails = savedDetail;
                PremiumcalculationForCriticalIllness = savedData.quoteData.premiumCalculation.response;
            }

        }

        function saveObjectforCriticalSecondPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.response && savedData.quoteData.premiumCalculation.response.premiumCalculation) {
                var savedDetail = {}
                savedDetail.data = [];
                savedDetail.productUin = savedData.uin;
                savedDetail.quoteNumber = savedData.quoteData.premiumCalculation.response.premiumCalculation.quoteNumber;
                savedDetail.sumInsured = savedData.sumInsured;
                savedDetail.data[0] = savedData.quoteData.premiumCalculation.response.premiumCalculation.actualPremiumPayable;
                generalInsurenceHomeService.setQuoteListDetails(savedDetail);
                PremiumcalculationForCriticalIllness = savedData.quoteData.premiumCalculation.response;
            }

        }

        function saveObjectforCriticalThirdPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.personalDetails) {
                var savedDetail = {}
                savedDetail.LastName = savedData.applicationData.createquoterequest.personalDetails.lastName;
                savedDetail.address = savedData.applicationData.createquoterequest.personalDetails.buildingName;
                savedDetail.birthdate = $filter('chosenDate')(savedData.applicationData.createquoterequest.personalDetails.dob);
                savedDetail.city = savedData.applicationData.createquoterequest.personalDetails.city;
                savedDetail.email = savedData.applicationData.createquoterequest.personalDetails.emailId;
                savedDetail.firstName = savedData.applicationData.createquoterequest.personalDetails.firstName;
                savedDetail.location = savedData.applicationData.createquoterequest.personalDetails.location;
                savedDetail.locations = savedData.applicationData.createquoterequest.personalDetails.locationSource.location;
                savedDetail.mobile = savedData.applicationData.createquoterequest.personalDetails.mobileNumber;
                savedDetail.pincode = savedData.applicationData.createquoterequest.personalDetails.pincode;
                savedDetail.plotNo = savedData.applicationData.createquoterequest.personalDetails.plotNo;
                savedDetail.streetName = savedData.applicationData.createquoterequest.personalDetails.streetName;
                savedDetail.title = savedData.applicationData.createquoterequest.personalDetails.abbrName;
                savedDetail.gender = savedData.applicationData.createquoterequest.personalDetails.gender;
                generalInsurenceHomeService.setLocationDetails(savedData.applicationData.createquoterequest.personalDetails.locationSource);
                healthApplicationPersonalDetails = savedDetail;


                if(savedData.applicationData.partyDetail){
                        createParty = {};
                        createParty.partyCreate = savedData.applicationData.partyDetail;
               }

            }

        }

        function saveObjectforCriticalFourthPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.insuredDetails) {
                insuredParty = {};
                insuredParty.partyCreate = [];
                var savedDetail = {}
                for (var count = 0; count < 1; count++) {
                    if (savedData.applicationData.createquoterequest.insuredDetails.length > 0) {
                        savedDetail.Gender = [];
                        savedDetail.birthDay = [];
                        savedDetail.employment = [];
                        savedDetail.height = [];
                        savedDetail.lastName = [];
                        savedDetail.monthlyIncome = [];
                        savedDetail.monthlyIncome = [];
                        savedDetail.name = [];
                        savedDetail.occupation = [];
                        savedDetail.relationship = [];
                        savedDetail.title = [];
                        savedDetail.weight = [];
                        savedDetail.Gender[count] = savedData.applicationData.createquoterequest.insuredDetails[count].gender ? $filter('selectBoxFilter')(criticalMasters.gender, savedData.applicationData.createquoterequest.insuredDetails[count].gender,"ikey") : "";
                        savedDetail.birthDay[count] = $filter('chosenDate')(savedData.applicationData.createquoterequest.insuredDetails[count].insureDob);
                        savedDetail.employment[count] = generalInsurenceHealth.assignKeyValueForArogya(criticalMasters.employmentDetails, savedData.applicationData.createquoterequest.insuredDetails[count].employementDetail);
                        savedDetail.height[count] = savedData.applicationData.createquoterequest.insuredDetails[count].height;
                        savedDetail.lastName[count] = savedData.applicationData.createquoterequest.insuredDetails[count].lastName;
                        savedDetail.monthlyIncome[count] = savedData.applicationData.createquoterequest.insuredDetails[count].monthlyIncome;
                        savedDetail.name[count] = savedData.applicationData.createquoterequest.insuredDetails[count].firstName;
                        savedDetail.occupation[count] = generalInsurenceHealth.assignKeyValueForArogya(criticalMasters.occupation, savedData.applicationData.createquoterequest.insuredDetails[count].occupation);
                        savedDetail.relationship[count] = savedData.applicationData.createquoterequest.insuredDetails[count].relationship;
                        savedDetail.title[count] = savedData.applicationData.createquoterequest.insuredDetails[count].salutation;
                        savedDetail.weight[count] = savedData.applicationData.createquoterequest.insuredDetails[count].weight;
                        insuredParty.partyCreate.push(savedData.applicationData.createquoterequest.insuredDetails[count].partyDetails);
                    }
                }
                savedDetail.uin = savedData.uin;

                healthAdditionalDetails = savedDetail;
            }
        }


        function saveObjectforCriticalFifthPage(savedData) {

            if (savedData.applicationData && savedData.applicationData.createquoterequest) {


                var savedDetail = [];
                savedDetail[0] = {};
                savedDetail[0].tobacco = savedData.applicationData.createquoterequest.healthInformation;
                if(savedData.applicationData.createquoterequest.healthInformation){
                    if(!savedData.applicationData.createquoterequest.healthInformation){
                        savedDetail[0].tobacco  = false;
                    }
                }
                
                for (var count = 0; count < savedData.applicationData.createquoterequest.healthInformationDetails.length; count++) {
                    if (count != 0) {
                        savedDetail[count] = {};
                    }

                    if (savedData.applicationData.createquoterequest.healthInformationDetails.count > 0) {
                        savedDetail[count].insuredName = savedData.applicationData.createquoterequest.healthInformationDetails[count].name;
                        savedDetail[count].consumeTobacoo = savedData.applicationData.createquoterequest.healthInformationDetails[count].doYouConsumeTobacco;
                        savedDetail[count].smoke = generalInsurenceHealth.assignKeyValueForArogya(criticalMasters.smokerStatus, savedData.applicationData.createquoterequest.healthInformationDetails[count].doYouSmoke);
                        savedDetail[count].alcohol = savedData.applicationData.createquoterequest.healthInformationDetails[count].alcoholStatus;
                        savedDetail[count].diabetes = savedData.applicationData.createquoterequest.healthInformationDetails[count].diabetes;
                        savedDetail[count].hypertension = savedData.applicationData.createquoterequest.healthInformationDetails[count].hyperTension;
                        savedDetail[count].asthama = savedData.applicationData.createquoterequest.healthInformationDetails[count].asthama;
                        savedDetail[count].consumeTobacoo = savedData.applicationData.createquoterequest.healthInformationDetails[count].doYouConsumeTobacco;
                        savedDetail[count].consumeTobacoo = savedData.applicationData.createquoterequest.healthInformationDetails[count].doYouConsumeTobacco;
                        savedDetail[count].otherhabits = savedData.applicationData.createquoterequest.healthInformationDetails[count].impairments;
                        savedDetail[count].reason = savedData.applicationData.createquoterequest.healthInformationDetails[count].otherHabits;
                    }
                }
                if(savedData.applicationData.createquoterequest.everDeniedPolicy){
                     savedDetail[0].denied = true; 
                }else{
                    savedDetail[0].denied = false; 
                }
                if(savedData.applicationData.createquoterequest.concurrentInsurance){
                     savedDetail[0].insurance = true; 
                }else{
                    savedDetail[0].insurance = false; 
                }

                

               
                savedDetail[0].username = savedData.applicationData.createquoterequest.userName;
                savedDetail[0].denialdetails = savedData.applicationData.createquoterequest.deniedDetails;

                for (var count = 0; count < savedData.applicationData.createquoterequest.concurrentInsuranceDetails.length; count++) {
                    if (count != 0) {
                        savedDetail[count] = {};
                    }
                    if (savedData.applicationData.createquoterequest.concurrentInsuranceDetails.length > 0) {
                        savedDetail[count].companyName = generalInsurenceHealth.assignKeyValueForArogya(criticalMasters.insuranceCompanyNames, savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].company);
                        savedDetail[count].policyType = generalInsurenceHealth.assignKeyValueForArogya(criticalMasters.concurrentHealthPolicies, savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].previousOrCon);
                        savedDetail[count].policy = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].policyNo;
                        savedDetail[count].sumInsured = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].sumInsured;
                        savedDetail[count].insureSince = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].since;
                        savedDetail[count].insureFrom = $filter('chosenDate')(savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insFrom);
                        savedDetail[count].insureTo = $filter('chosenDate')(savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insPeriodTo);
                        if(savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].splCondition && savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].splCondition !="false"){
                            savedDetail[count].specialCondition = true;
                        }else{
                            savedDetail[count].specialCondition = false;
                        }
                        
                        savedDetail[count].conditiondetail = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].splConditionDetail;
                        if(savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].claim && savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].claim !='false'){
                             savedDetail[count].claimPolicy =  true;
                        }else{
                             savedDetail[count].claimPolicy =  false;
                        }
                        //savedDetail[count].claimPolicy = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].claim;
                        savedDetail[count].claimamount = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].claimReceived;
                        savedDetail[count].claimdetails = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].claimDesc;
                        savedDetail[count].name = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredPerson;
                    }


                }
                healthInformation = angular.copy(savedDetail);
            }
        }

        function saveObjectforCriticalSixthPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.nomineeDetails) {
                var savedDetail = {}
                    // savedDetail.nomineeTitle = savedData.applicationData.createquoterequest.nomineeDetails.lastName;
                savedDetail.name1 = savedData.applicationData.createquoterequest.nomineeDetails.name.firstName;
                savedDetail.nomineeTitle = savedData.applicationData.createquoterequest.nomineeDetails.name.salutation;
                savedDetail.nomineeLastName = savedData.applicationData.createquoterequest.nomineeDetails.name.lastName;
                savedDetail.relationship = generalInsurenceHealth.assignKeyValueForArogya(criticalMasters.nomineeRelation, savedData.applicationData.createquoterequest.nomineeDetails.relationship);
                savedDetail.birthDate = $filter('chosenDate')(savedData.applicationData.createquoterequest.nomineeDetails.dob);
                // savedDetail.nomineeMinor = savedData.applicationData.createquoterequest.personalDetails.firstName;
                if(savedData.applicationData.createquoterequest.appointeeDetails){
                    savedDetail.appointeeTitle = savedData.applicationData.createquoterequest.appointeeDetails.appointeeTitle;
                    savedDetail.name = savedData.applicationData.createquoterequest.appointeeDetails.name;
                    savedDetail.appointeeLastName = savedData.applicationData.createquoterequest.appointeeDetails.lastName;
                    savedDetail.relationshipWithNominee = generalInsurenceHealth.assignKeyValueForArogya(criticalMasters.appointeeRelation, savedData.applicationData.createquoterequest.appointeeDetails.appointeeRelationship);
                }   
                savedDetail.uin = savedData.uin;
                generalInsurenceTravelService.setTravelNomineeDetail(savedDetail);
                createPartyNominee = {};
                createPartyNominee.partyCreate = savedData.applicationData.createquoterequest.nomineeDetails.partyDetail;
            }
        }


        /* Assign value for HDC  */
        generalInsurenceHealth.assignvalueForHDC = function() {
            var pagelength = 7;
            var savedData = generalInsurenceHomeService.getSaveApplicationHDCStructure();
            generalInsurenceHealth.getHDCMaster().then(function(response) {
                hdcMasters = response;
                saveObjectforHDCFirstPage(savedData);
                saveObjectforHDCSecondPage(savedData);
                saveObjectforHDCThirdPage(savedData);
                saveObjectforHDCFourthPage(savedData);
                saveObjectforHDCFifthPage(savedData);
                saveObjectforHDCSixthPage(savedData);
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
                //alert(error.responseMessage);
            });
        }

        function saveObjectforHDCFirstPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request) {
                var savedDetail = {}
                savedDetail.membersList = [];
                savedDetail.startDate = $filter('chosenDate')(savedData.quoteData.premiumCalculation.request.policyStartDate);
                savedDetail.endDate = $filter('chosenDate')(savedData.quoteData.premiumCalculation.request.policyEndDate);
                savedDetail.memberCount = savedData.quoteData.premiumCalculation.request.familysize;
                for (var count = 0; count < savedData.quoteData.premiumCalculation.request.familysize; count++) {
                    if (savedData.quoteData.premiumCalculation.request.insuredDetails.length > 0) {
                        savedDetail.membersList[count] = {};
                        savedDetail.membersList[count].ageGroup = savedData.quoteData.premiumCalculation.request.insuredDetails[count].age;
                        savedDetail.membersList[count].cashLimit = {};
                        savedDetail.membersList[count].cashLimit.value = savedData.quoteData.premiumCalculation.request.insuredDetails[count].hospitalizationCashLimit;

                    }

                }
                HDCpremiumDetails = savedData.quoteData.premiumCalculation.response;
                hospitalInsuredDetail = savedDetail;
            }

        }

        function saveObjectforHDCSecondPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.response && savedData.quoteData.premiumCalculation.response.premiumCalculation) {
                var savedDetail = {}
                savedDetail.data = [];
                savedDetail.productUin = savedData.uin;
                savedDetail.quoteNumber = savedData.quoteData.premiumCalculation.response.premiumCalculation.quoteNumber;
                savedDetail.sumInsured = savedData.sumInsured;
                savedDetail.data[0] = savedData.quoteData.premiumCalculation.response.premiumCalculation.actualPremiumPayable;
                generalInsurenceHomeService.setQuoteListDetails(savedDetail);
                HDCpremiumDetails = savedData.quoteData.premiumCalculation.response;
            }

            if(savedData && savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request && savedData.quoteData.premiumCalculation.request.insuredDetails && savedData.quoteData.premiumCalculation.request.insuredDetails[0]){
                var amount = Number(savedData.quoteData.premiumCalculation.request.insuredDetails[0].hospitalizationCashLimit.value);
                var  term = Number(savedData.quoteData.premiumCalculation.request.quoteDetails.planDuration);
                HDCSumInsured = term * amount;
                HDCSumInsured =  HDCSumInsured.toString();
            }

        }

        function saveObjectforHDCThirdPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.personalDetails) {
                var savedDetail = {}
                savedDetail.LastName = savedData.applicationData.createquoterequest.personalDetails.lastName;
                savedDetail.address = savedData.applicationData.createquoterequest.personalDetails.buildingName;
                savedDetail.birthdate = $filter('chosenDate')(savedData.applicationData.createquoterequest.personalDetails.dob);
                savedDetail.city = savedData.applicationData.createquoterequest.personalDetails.city;
                savedDetail.email = savedData.applicationData.createquoterequest.personalDetails.emailId;
                savedDetail.firstName = savedData.applicationData.createquoterequest.personalDetails.firstName;
                savedDetail.location = savedData.applicationData.createquoterequest.personalDetails.location;
                savedDetail.locations = savedData.applicationData.createquoterequest.personalDetails.locationSource.location;
                savedDetail.mobile = savedData.applicationData.createquoterequest.personalDetails.mobileNumber;
                savedDetail.pincode = savedData.applicationData.createquoterequest.personalDetails.pincode;
                savedDetail.plotNo = savedData.applicationData.createquoterequest.personalDetails.plotNo;
                savedDetail.streetName = savedData.applicationData.createquoterequest.personalDetails.streetName;
                savedDetail.title = savedData.applicationData.createquoterequest.personalDetails.abbrName;
                savedDetail.gender = savedData.applicationData.createquoterequest.personalDetails.gender;

                generalInsurenceHomeService.setLocationDetails(savedData.applicationData.createquoterequest.personalDetails.locationSource);
                healthApplicationPersonalDetails = savedDetail;

                if(savedData.applicationData.partyDetail){
                        createParty = {};
                        createParty.partyCreate = savedData.applicationData.partyDetail;
               }
               
            }
        }



        function saveObjectforHDCFourthPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.insuredDetails) {
                var savedDetail = {}
                savedDetail.Gender = [];
                savedDetail.birthDay = [];
                savedDetail.employment = [];
                savedDetail.height = [];
                savedDetail.lastName = [];
                savedDetail.name = [];
                savedDetail.occupation = [];
                savedDetail.relationship = [];
                savedDetail.cashLimit = []
                savedDetail.title = [];
                savedDetail.weight = [];
                insuredParty = {};
                insuredParty.partyCreate = [];
                for (var count = 0; count < savedData.applicationData.createquoterequest.insuredDetails.length; count++) {
                    if (savedData.applicationData.createquoterequest.insuredDetails.length > 0) {
                        savedDetail.Gender[count] = savedData.applicationData.createquoterequest.insuredDetails[count].gender ? $filter('selectBoxFilter')(hdcMasters.gender, savedData.applicationData.createquoterequest.insuredDetails[count].gender,"ikey") : "";
                        //savedDetail.Gender[count] = generalInsurenceHealth.assignKeyValueForArogya(hdcMasters.gender, savedData.applicationData.createquoterequest.insuredDetails[count].gender);
                        savedDetail.birthDay[count] = $filter('chosenDate')(savedData.applicationData.createquoterequest.insuredDetails[count].insureDob);
                        savedDetail.cashLimit[count] = generalInsurenceHealth.assignKeyValueForArogya(hdcMasters.hospitalCashLimit, savedData.applicationData.createquoterequest.insuredDetails[count].hospitalcashlimit);
                        savedDetail.height[count] = savedData.applicationData.createquoterequest.insuredDetails[count].height;
                        savedDetail.lastName[count] = savedData.applicationData.createquoterequest.insuredDetails[count].lastName;
                        savedDetail.name[count] = savedData.applicationData.createquoterequest.insuredDetails[count].firstName;
                        savedDetail.occupation[count] = generalInsurenceHealth.assignKeyValueForArogya(hdcMasters.occupation, savedData.applicationData.createquoterequest.insuredDetails[count].occupation);
                        savedDetail.relationship[count] = savedData.applicationData.createquoterequest.insuredDetails[count].relationship;
                        savedDetail.title[count] = savedData.applicationData.createquoterequest.insuredDetails[count].salutation;
                        savedDetail.weight[count] = savedData.applicationData.createquoterequest.insuredDetails[count].weight;
                        insuredParty.partyCreate.push(savedData.applicationData.createquoterequest.insuredDetails[count].partyDetails);
                    }

                }
                savedDetail.uin = savedData.uin;
                healthAdditionalDetails = savedDetail;
            }
        }

        function saveObjectforHDCFifthPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest) {
               var  savedDetail = [];
                     savedDetail[0] = {};
                if(savedData.applicationData.createquoterequest.healthInformation){
                     savedDetail[0].tobacco = savedData.applicationData.createquoterequest.healthInformation;
                }else{
                    savedDetail[0].tobacco =false;
                }
               
                for (var count = 0; count < savedData.applicationData.createquoterequest.healthInformationDetails.length; count++) {
                    if (savedData.applicationData.createquoterequest.healthInformationDetails.length > 0) {
                        if(!savedDetail[count]){
                            savedDetail[count] = {};
                        }
                        savedDetail[count].insuredName = savedData.applicationData.createquoterequest.healthInformationDetails[count].name;
                        savedDetail[count].consumeTobacoo = savedData.applicationData.createquoterequest.healthInformationDetails[count].doYouConsumeTobacco;
                        savedDetail[count].smoke = generalInsurenceHealth.assignKeyValueForArogya(hdcMasters.smokerStatus, savedData.applicationData.createquoterequest.healthInformationDetails[count].doYouSmoke);
                        savedDetail[count].alcohol = savedData.applicationData.createquoterequest.healthInformationDetails[count].alcoholStatus;
                        savedDetail[count].OtherAilment = false ;
                        savedDetail[count].AilmentDetails = savedData.applicationData.createquoterequest.healthInformationDetails[count].ailmentDetails;
                    }
                }
                if(savedData.applicationData.createquoterequest.everDeniedPolicy){
                    savedDetail[0].denied = savedData.applicationData.createquoterequest.everDeniedPolicy;
                }else{
                    savedDetail[0].denied =false;
                }
                if(savedData.applicationData.createquoterequest.deniedDetails && savedData.applicationData.createquoterequest.deniedDetails[0]){
                    savedDetail[0].username = savedData.applicationData.createquoterequest.deniedDetails[0].name 
                    savedDetail[0].denialdetails = savedData.applicationData.createquoterequest.deniedDetails[0].detailsonDenial

                }
    
                savedDetail[0].insurance = savedData.applicationData.createquoterequest.concurrentInsurance;
                for (var count = 0; count < savedData.applicationData.createquoterequest.concurrentInsuranceDetails.length; count++) {
                    if (savedData.applicationData.createquoterequest.concurrentInsuranceDetails.length > 0) {
                            if(!savedDetail[count]){
                                     savedDetail[count] = {};
                            }
                       
                         //savedDetail[count].insuredName = "TT";
                        savedDetail[count].companyName = generalInsurenceHealth.assignKeyValueForArogya(hdcMasters.insuranceComapny, savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredComapny);
                        savedDetail[count].policyType = generalInsurenceHealth.assignKeyValueForArogya(hdcMasters.previousOrConcurrent, savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].previous);
                        savedDetail[count].policy = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].policy;
                        savedDetail[count].sumInsured = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].sumInsured;
                        savedDetail[count].insureSince = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredSince;
                        savedDetail[count].insureFrom = $filter('chosenDate')(savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].policyStratDate);
                        savedDetail[count].insureTo = $filter('chosenDate')(savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].policyEndDate);
                        savedDetail[count].claim = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].claim;
                        savedDetail[count].name = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredPerson;
                        savedDetail[count].claimPolicy = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].claimIfAny;
                    }

                }
                healthInformation = savedDetail;
            }
        }


        function saveObjectforHDCSixthPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.nomineeDetails) {
                var savedDetail = {}
                    // savedDetail.nomineeTitle = savedData.applicationData.createquoterequest.nomineeDetails.lastName;
                savedDetail.name1 = savedData.applicationData.createquoterequest.nomineeDetails.name.firstName;
                savedDetail.nomineeTitle = savedData.applicationData.createquoterequest.nomineeDetails.name.salutation;
                savedDetail.nomineeLastName = savedData.applicationData.createquoterequest.nomineeDetails.name.lastName;
                savedDetail.relationship = generalInsurenceHealth.assignKeyValueForArogya(hdcMasters.nomineeRelation, savedData.applicationData.createquoterequest.nomineeDetails.relationship);
                savedDetail.birthDate = $filter('chosenDate')(savedData.applicationData.createquoterequest.nomineeDetails.dob);
                // savedDetail.nomineeMinor = savedData.applicationData.createquoterequest.personalDetails.firstName;
                if(savedData.applicationData.createquoterequest.appointeeDetails){
                    savedDetail.appointeeTitle = savedData.applicationData.createquoterequest.appointeeDetails.appointeeTitle;
                    savedDetail.name = savedData.applicationData.createquoterequest.appointeeDetails.name;
                    savedDetail.appointeeLastName = savedData.applicationData.createquoterequest.appointeeDetails.lastName;
                    savedDetail.relationshipWithNominee = generalInsurenceHealth.assignKeyValueForArogya(hdcMasters.appointeeRelation, savedData.applicationData.createquoterequest.appointeeDetails.appointeeRelationship);
                }
                savedDetail.uin = savedData.uin;
                generalInsurenceTravelService.setTravelNomineeDetail(savedDetail);
                createPartyNominee = {};
                createPartyNominee.partyCreate = savedData.applicationData.createquoterequest.nomineeDetails.partyDetail;
            }
        }


        /* Assign value for Simple Health  */
        generalInsurenceHealth.assignvalueForSimple = function() {
            var pagelength = 7;
            var savedData = generalInsurenceHomeService.getSaveApplicationHealthStructure();
            generalInsurenceHealth.getSimpleMaster().then(function(response) {
                simpleMasters = response;
                saveObjectforSimpleFirstPage(savedData);
                saveObjectforSimpleSecondPage(savedData);
                saveObjectforSimpleThirdPage(savedData);
                saveObjectforSimpleFourthPage(savedData);
                saveObjectforSimpleFifthPage(savedData);
                saveObjectforSimpleSixthPage(savedData);
                saveObjectforSimpleSeventhPage(savedData);

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
                //alert(error.responseMessage);
            });
        }

        function saveObjectforSimpleFirstPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request && savedData.quoteData.premiumCalculation.request.quoteDetails) {
                var savedDetail = {}
                savedDetail.familySize = savedData.quoteData.premiumCalculation.request.quoteDetails.familysize;
                savedDetail.productTypes = savedData.quoteData.premiumCalculation.request.quoteDetails.productType;
                savedDetail.startDate = $filter('chosenDate')(savedData.quoteData.premiumCalculation.request.quoteDetails.effectiveDate);
                savedDetail.policyEndDate = $filter('chosenDate')(savedData.quoteData.premiumCalculation.request.quoteDetails.expiryDate);
                savedDetail.uin = savedData.uin;
                basicDetail = savedDetail;

            }

        }

        function saveObjectforSimpleSecondPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request && savedData.quoteData.premiumCalculation.request.quoteDetails.familysize) {
                var savedDetail = {}

                savedDetail.Birthdate = [];
                savedDetail.Relationship = [];
                savedDetail.SumInsured = [];
                for (var count = 0; count < savedData.quoteData.premiumCalculation.request.quoteDetails.familysize; count++) {
                    if (savedData.quoteData.premiumCalculation.request.insuredDetails.length > 0) {
                        savedDetail.Birthdate[count] = {};
                        savedDetail.Relationship[count] = {};
                        savedDetail.SumInsured[count] = {};
                        savedDetail.Birthdate[count] = $filter('chosenDate')(savedData.quoteData.premiumCalculation.request.insuredDetails[count].dob);
                        savedDetail.Relationship[count] = savedData.quoteData.premiumCalculation.request.insuredDetails[count].relationship;
                        savedDetail.SumInsured[count] = {};
                        savedDetail.SumInsured[count].key = savedData.quoteData.premiumCalculation.request.insuredDetails[count].sumInsured;
                        savedDetail.SumInsured[count].value = savedData.quoteData.premiumCalculation.request.insuredDetails[count].sumInsured;
                    }

                }
                savedDetail.totalSumInsured = savedData.quoteData.premiumCalculation.request.insuredDetails[0].sumInsured;
                simpleHealthCalc = savedData.quoteData.premiumCalculation.response;

                savedDetail.uin = savedData.uin;
                insureDetail = savedDetail;
                 insureDetail.noOfAdults = 0;
                 insureDetail.noOfChilds = 0;
                 for (var count = 0; count < insureDetail.Birthdate.length; count++) {
                
                    if(validateService.calcAge(insureDetail.Birthdate[count]) >= 18){
                        insureDetail.noOfAdults++;
                    }else{
                        insureDetail.noOfChilds++;
                    }
               
                }

            }
        }

        function saveObjectforSimpleThirdPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.personalDetails) {
                var savedDetail = {}
                savedDetail.LastName = savedData.applicationData.createquoterequest.personalDetails.lastName;
                savedDetail.address = savedData.applicationData.createquoterequest.personalDetails.buildingName;
                savedDetail.birthdate = $filter('chosenDate')(savedData.applicationData.createquoterequest.personalDetails.dob);
                savedDetail.city = savedData.applicationData.createquoterequest.personalDetails.city;
                savedDetail.email = savedData.applicationData.createquoterequest.personalDetails.emailId;
                savedDetail.firstName = savedData.applicationData.createquoterequest.personalDetails.firstName;
                savedDetail.location = savedData.applicationData.createquoterequest.personalDetails.location;
                savedDetail.locations = savedData.applicationData.createquoterequest.personalDetails.locationSource.location;
                savedDetail.mobile = savedData.applicationData.createquoterequest.personalDetails.mobileNumber;
                savedDetail.pincode = savedData.applicationData.createquoterequest.personalDetails.pincode;
                savedDetail.plotNo = savedData.applicationData.createquoterequest.personalDetails.plotNo;
                savedDetail.streetName = savedData.applicationData.createquoterequest.personalDetails.streetName;
                savedDetail.title = savedData.applicationData.createquoterequest.personalDetails.abbrName;
                savedDetail.gender = savedData.applicationData.createquoterequest.personalDetails.gender;
                generalInsurenceHomeService.setLocationDetails(savedData.applicationData.createquoterequest.personalDetails.locationSource);
                healthApplicationPersonalDetails = savedDetail;

                if(savedData.applicationData.partyDetail){
                        createParty = {};
                        createParty.partyCreate = savedData.applicationData.partyDetail;
               }
               
            }
        }

        function saveObjectforSimpleFourthPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.insuredDetails.length) {
                var savedDetail = {};
                savedDetail.Gender = [];
                savedDetail.birthDay = []
                savedDetail.lastName = [];
                savedDetail.name = [];
                savedDetail.relationship = []
                savedDetail.sumInsured = [];
                savedDetail.title = [];
                insuredParty = {};
                insuredParty.partyCreate = [];
                for (var count = 0; count < savedData.quoteData.premiumCalculation.request.quoteDetails.familysize; count++) {
                    if (savedData.applicationData.createquoterequest.insuredDetails.length > 0) {
                        savedDetail.Gender[count] = {};
                        savedDetail.birthDay[count] = {};
                        savedDetail.lastName[count] = {};
                        savedDetail.name[count] = {};
                        savedDetail.relationship[count] = {};
                        savedDetail.sumInsured[count] = {};
                        savedDetail.title[count] = {};
                        savedDetail.Gender[count] = savedData.applicationData.createquoterequest.insuredDetails[count].gender ? $filter('selectBoxFilter')(simpleMasters.gender, savedData.applicationData.createquoterequest.insuredDetails[count].gender,"ikey") : "";
                        //savedDetail.Gender[count] = generalInsurenceHealth.assignKeyValueForArogya(simpleMasters.gender, savedData.applicationData.createquoterequest.insuredDetails[count].gender);
                        savedDetail.birthDay[count] = $filter('chosenDate')(savedData.applicationData.createquoterequest.insuredDetails[count].insureDob);
                        savedDetail.lastName[count] = savedData.applicationData.createquoterequest.insuredDetails[count].lastName;
                        savedDetail.name[count] = savedData.applicationData.createquoterequest.insuredDetails[count].firstName;
                        savedDetail.relationship[count] = savedData.applicationData.createquoterequest.insuredDetails[count].relationship;
                        savedDetail.sumInsured[count] = savedData.applicationData.createquoterequest.insuredDetails[count].sumInsured;
                        savedDetail.title[count] = savedData.applicationData.createquoterequest.insuredDetails[count].salutation;
                        savedDetail.uin = savedData.uin;
                        insuredParty.partyCreate.push(savedData.applicationData.createquoterequest.insuredDetails[count].partyDetails);
                    }
                }
                healthAdditionalDetails = savedDetail;
            }
        }

        function saveObjectforSimpleSeventhPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest.nomineeDetails) {


                var savedDetail = {}

                savedDetail.name1 = savedData.applicationData.createquoterequest.nomineeDetails.name.firstName;
                savedDetail.nomineeTitle = savedData.applicationData.createquoterequest.nomineeDetails.name.salutation;
                savedDetail.nomineeLastName = savedData.applicationData.createquoterequest.nomineeDetails.name.lastName;
                savedDetail.relationship = generalInsurenceHealth.assignKeyValueForArogya(simpleMasters.nomineeRelation, savedData.applicationData.createquoterequest.nomineeDetails.relationship);
                savedDetail.birthDate = $filter('chosenDate')(savedData.applicationData.createquoterequest.nomineeDetails.dob);
                if(savedData.applicationData.createquoterequest.appointeeDetails){
                    savedDetail.appointeeTitle = savedData.applicationData.createquoterequest.appointeeDetails.salutation;
                    savedDetail.name = savedData.applicationData.createquoterequest.personalDetails.locationSource.lastName;
                    savedDetail.appointeeLastName = savedData.applicationData.createquoterequest.appointeeDetails.lastName;
                    savedDetail.relationshipWithNominee = generalInsurenceHealth.assignKeyValueForArogya(simpleMasters.appointeeRelation, savedData.applicationData.createquoterequest.appointeeDetails.appointeeRelationship);
                } 
                savedDetail.uin = savedData.uin;
                generalInsurenceTravelService.setTravelNomineeDetail(savedDetail);
                createPartyNominee = {};
                createPartyNominee.partyCreate = savedData.applicationData.createquoterequest.nomineeDetails.partyDetail;

            }
        }

        function saveObjectforSimpleFifthPage(savedData) {
            if (savedData.applicationData && savedData.applicationData.createquoterequest) {

               var  savedDetail = [];
                savedDetail[0] = {};
                if(savedData.applicationData.createquoterequest.otherTreatment && savedData.applicationData.createquoterequest.otherTreatment !="false"){
                    savedDetail[0].accident = savedData.applicationData.createquoterequest.otherTreatment;
                }else{
                    savedDetail[0].accident = false;
                }

                if(savedData.applicationData.createquoterequest.healthInformation && savedData.applicationData.createquoterequest.healthInformation !="false"){
                    savedDetail[0].smoke = savedData.applicationData.createquoterequest.healthInformation;
                }else{
                     savedDetail[0].smoke =  false;
                }
                
                
                for (var count = 0; count < savedData.quoteData.premiumCalculation.request.quoteDetails.familysize; count++) {
                    if (!savedDetail[count]) {
                        savedDetail[count] = {};
                    }
                    if (savedData.applicationData.createquoterequest.healthInformationDetails.length > 0) {
                        savedDetail[count].insuredName = savedData.applicationData.createquoterequest.healthInformationDetails[count].name;
                        savedDetail[count].tobacco = savedData.applicationData.createquoterequest.healthInformationDetails[count].doYouConsumeTobacco;
                        savedDetail[count].alcoholstatus = savedData.applicationData.createquoterequest.healthInformationDetails[count].alcoholStatus;
                        savedDetail[count].smokestatus = savedData.applicationData.createquoterequest.healthInformationDetails[count].doYouSmoke;
                    }

                }
                 if(savedData.applicationData.createquoterequest.sufferedFromDiseases && savedData.applicationData.createquoterequest.sufferedFromDiseases !="false"){
                    savedDetail[0].individualDeseaseList = savedData.applicationData.createquoterequest.sufferedFromDiseases;
                }else{
                     savedDetail[0].individualDeseaseList =  false;
                }

                
                for (var count = 0; count < savedData.applicationData.createquoterequest.insuredPersonDiseasesDetails.length; count++) {
                    if (!savedDetail[count]) {
                        savedDetail[count] = {};
                    }
                    if (savedData.applicationData.createquoterequest.insuredPersonDiseasesDetails.length > 0) {
                        savedDetail[count].insuredNameList = savedData.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].name;
                        savedDetail[count].isHypertension = savedData.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].hypertension;
                        savedDetail[count].isDiabetes = savedData.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].diabetes;
                        savedDetail[count].isAsthma = savedData.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].asthma;
                        savedDetail[count].isStroke = savedData.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].stroke;
                        savedDetail[count].isHepatits = savedData.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].hepatits;
                        savedDetail[count].isAIDS = savedData.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].aids;
                        savedDetail[count].isCancer = savedData.applicationData.createquoterequest.insuredPersonDiseasesDetails[count].cancer;
                    }

                }
                healthQuestionaire = savedDetail;
            }
        }

        function saveObjectforSimpleSixthPage(savedData) {

            if (savedData.applicationData && savedData.applicationData.createquoterequest && savedData.applicationData.createquoterequest) {
                var savedDetail = {};
                savedDetail.data = [];
                savedDetail.insuranceList = [];
                savedDetail.data[0] = {};
                if(savedData.applicationData.createquoterequest.preExistingDisease) {
                    savedDetail.data[0].preexistingdesease = savedData.applicationData.createquoterequest.preExistingDisease;
                }else{
                    savedDetail.data[0].preexistingdesease = false;
                }
                
                savedDetail.insuranceList[0] = {};
                if(savedData.applicationData.createquoterequest.concurrentInsurance){
                    savedDetail.insuranceList[0].otherHealthCover = savedData.applicationData.createquoterequest.concurrentInsurance;
                }else{
                    savedDetail.insuranceList[0].otherHealthCover =  false;
                }
                

                for (var count = 0; count < savedData.applicationData.createquoterequest.preexistingDiseaseDetails.length; count++) {
                    if (count != 0) {
                        savedDetail.data[count] = {};
                    }
                    if (savedData.applicationData.createquoterequest.preexistingDiseaseDetails.length > 0) {
                        savedDetail.data[count].insuredName = savedData.applicationData.createquoterequest.preexistingDiseaseDetails[count].insuredPerson;
                        savedDetail.data[count].deseaseName = savedData.applicationData.createquoterequest.preexistingDiseaseDetails[count].DiseaseName;
                        savedDetail.data[count].treatmentDetail = savedData.applicationData.createquoterequest.preexistingDiseaseDetails[count].treatmentDetails;
                        savedDetail.data[count].startDate = $filter('chosenDate')(savedData.applicationData.createquoterequest.preexistingDiseaseDetails[count].dateFirstTreated);
                        savedDetail.data[count].currentStatus = savedData.applicationData.createquoterequest.preexistingDiseaseDetails[count].currentStatus;

                    }


                }

                for (var count = 0; count < savedData.applicationData.createquoterequest.concurrentInsuranceDetails.length; count++) {
                    if (count != 0) {
                        savedDetail.insuranceList[count] = {};
                    }
                    if (savedData.applicationData.createquoterequest.concurrentInsuranceDetails.length > 0) {
                        savedDetail.insuranceList[count].name = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredPerson;
                        savedDetail.insuranceList[count].policyType = generalInsurenceHealth.assignKeyValueForArogya(simpleMasters.concurrentHealthPolicies, savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].previous);
                        savedDetail.insuranceList[count].companyName = generalInsurenceHealth.assignKeyValueForArogya(simpleMasters.insuranceComapnyName, savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredComapny);
                        savedDetail.insuranceList[count].policy = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].policy;
                        savedDetail.insuranceList[count].insureFrom = $filter('chosenDate')(savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].policyStratDate);
                        savedDetail.insuranceList[count].insureTo = $filter('chosenDate')(savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].policyEndDate);
                        savedDetail.insuranceList[count].insureSince = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredSince;
                        savedDetail.insuranceList[count].sumInsured = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].sumInsured;
                        savedDetail.insuranceList[count].specialCondition = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].specialCondition;
                        savedDetail.insuranceList[count].conditiondetail = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].specialConditionDetails;
                        savedDetail.insuranceList[count].claimPolicy = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].claimIfAny;

                    }

                }

                preExistingDesease = savedDetail;
            }


            // savedDetail = {};
            // savedDetail.preExistingDesease = [];
            // savedDetail.preExistingDesease[0] = {};

            // savedDetail.preExistingDesease[0].preexistingdesease = savedData.applicationData.createquoterequest.preExistingDisease;
            // for (var count = 0; count < savedData.quoteData.premiumCalculation.request.quoteDetails.familysize; count++) {
            //     savedDetail.preExistingDesease[count] = {};
            //     savedDetail.preExistingDesease[count].insuredName = savedData.applicationData.createquoterequest.preexistingDiseaseDetails[count].insuredPerson;
            //     savedDetail.preExistingDesease[count].deseaseName = savedData.applicationData.createquoterequest.preexistingDiseaseDetails[count].DiseaseName;
            //     savedDetail.preExistingDesease[count].treatmentDetail = savedData.applicationData.createquoterequest.preexistingDiseaseDetails[count].treatmentDetails;
            //     savedDetail.preExistingDesease[count].startDate = $filter('chosenDate')(savedData.applicationData.createquoterequest.preexistingDiseaseDetails[count].dateFirstTreated);
            //     savedDetail.preExistingDesease[count].currentStatus = savedData.applicationData.createquoterequest.preexistingDiseaseDetails[count].currentStatus;
            // }
            // savedDetail[0].individualDeseaseList = savedData.applicationData.createquoterequest.sufferedFromDiseases;
            // savedDetail[0].concurrentInsuranceLength = savedData.applicationData.createquoterequest.concurrentInsuranceDetails.length;
            // for (var count = 0; count < savedData.applicationData.createquoterequest.concurrentInsuranceDetails.length; count++) {
            //     savedDetail.concurrentInsurance[count] = {};
            //     savedDetail.concurrentInsurance[count].name = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredPerson;
            //     savedDetail.concurrentInsurance[count].policyType = generalInsurenceHealth.assignKeyValueForArogya(simpleMasters.concurrentHealthPolicies, savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].previous);
            //     savedDetail.concurrentInsurance[count].companyName = generalInsurenceHealth.assignKeyValueForArogya(simpleMasters.insuranceComapnyName, savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredComapny);
            //     savedDetail.concurrentInsurance[count].policy = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].policy;
            //     savedDetail.concurrentInsurance[count].insureFrom = $filter('chosenDate')(savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].policyStratDate);
            //     savedDetail.concurrentInsurance[count].insureTo = $filter('chosenDate')(savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].policyEndDate);
            //     savedDetail.concurrentInsurance[count].insureSince = $filter('chosenDate')(savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredSince);
            //     savedDetail.concurrentInsurance[count].sumInsured = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].sumInsured;
            //     savedDetail.concurrentInsurance[count].specialCondition = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].specialCondition;
            //     savedDetail.concurrentInsurance[count].conditiondetail = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].specialConditionDetails;
            //     savedDetail.concurrentInsurance[count].claimPolicy = savedData.applicationData.createquoterequest.concurrentInsuranceDetails[count].claimIfAny;
            // }
            // healthQuestionaire = savedDetail;
        }

        generalInsurenceHealth.assignKeyValueForArogya = function(alldata, value, specifiedKey) {
            for (var count = 0; count < alldata.length; count++) {
                if (specifiedKey) {
                    if (alldata[count][specifiedKey] == value) {
                        return alldata[count];
                    }
                } else {
                    if (alldata[count].key == value) {
                        return alldata[count];
                    }
                }
            }
        }




        return generalInsurenceHealth;


    }
]);
