angularApp.service('arogyaSanjeevaniService', ["$filter", "$state",  "genralInsurenceConfig", "$q", "AdapterUtils", "generalInsurenceHomeService", "generalInsurenceTravelService","utilityService","validateService","$ionicPopup",
    function($filter, $state,  genralInsurenceConfig, $q, AdapterUtils, generalInsurenceHomeService, generalInsurenceTravelService,utilityService,validateService, $ionicPopup) {



        var arogyaSanjeevaniService = this;
        var premiumData,panNumber,eInsurance,quoteNumber,policyDetails,nomineeDetail,insuredDetails,
        basicHealthDetail,arogyaQuestion,applicationNumber,saveApplicationArsa,sumInsured,policyStartDate,personalDetails,
         healthDetails, arsaGenderArray,arogymPremiumCalc,productCode,policyNumber;

        arogyaSanjeevaniService.clearAll = function(){
            premiumData = null;panNumber = null; eInsurance = null;quoteNumber = null;insuredDetails = null;
            policyDetails = null;nomineeDetail= null;basicHealthDetail = null;arogyaQuestion=null;healthDetails=null;
            applicationNumber = null;saveApplicationArsa = null;sumInsured = null;policyStartDate=null;personalDetails= null; arsaGenderArray=null;
            arogymPremiumCalc=null;productCode=null;policyNumber=null;
        }

        arogyaSanjeevaniService.getValue = function (inputValue) {
			return (inputValue && inputValue != null  && inputValue != undefined) ? inputValue.toString() : '';
		};

        arogyaSanjeevaniService.setpolicyNumber = function(data){
            policyNumber = data;
        }

        arogyaSanjeevaniService.getpolicyNumber = function(){
            return policyNumber;
        }

        arogyaSanjeevaniService.setpolicySumInsured = function(data){
            sumInsured = data;
        }

        arogyaSanjeevaniService.getpolicySumInsured = function(){
            return sumInsured;
        }

        arogyaSanjeevaniService.setpolicyStartdate = function(data){
            policyStartDate = data;
        }

        arogyaSanjeevaniService.getpolicyStartdate = function(){
            return policyStartDate;
        }

        arogyaSanjeevaniService.setPan = function(data){
            panNumber = data;
        }

        arogyaSanjeevaniService.getPan = function(){
            return panNumber;
        }

        arogyaSanjeevaniService.setSaveApplicationArogyaStructure = function(saveApplication) {
            saveApplicationArsa = saveApplication;
        }
        arogyaSanjeevaniService.getSaveApplicationArogyaStructure = function() {
            return saveApplicationArsa;
        }

        arogyaSanjeevaniService.getSaveApplicationSimpleHealth = function() {
            var saveApplication = {
                "cif": "",
                "applicationNumber": "",
                "productCode": "string",
                "uin": "string",
                "planName": "string",
                "mobileNumber": "string",
                "quoteData": {},
                "applicationData": {}
            }
            return saveApplication;
        }

        arogyaSanjeevaniService.setHealthInsureDetails = function(data){
            insuredDetails = data;
        }

        arogyaSanjeevaniService.getHealthInsureDetails = function(){
            return insuredDetails;
        }

        arogyaSanjeevaniService.setProductCode = function(data){
            productCode = data;
        }

        arogyaSanjeevaniService.getProductCode = function(){
            return productCode;
        }

        arogyaSanjeevaniService.setSaveApplicationArogyaResponse = function(data) {
            applicationNumber = data;
        }

        arogyaSanjeevaniService.getSaveApplicationArogyaResponse = function() {
            return applicationNumber;
        }

        /* Assign value for Arogya Premium  */
        arogyaSanjeevaniService.assignvalueForArogyaSanjeevani = function() {
            var savedData = arogyaSanjeevaniService.getSaveApplicationArogyaStructure();
            saveObjectforArogyaFirstPage(savedData);
            saveObjectforArogyaSecondPage(savedData);
            saveObjectforArogyaThirdPage(savedData);
            saveObjectforArogyaFourthPage(savedData);
            saveObjectforArogyaFifthPage(savedData);
            saveObjectforArogyaSixPage(savedData);
            saveObjectforArogyaSeventhPage(savedData);
            saveObjectforArogyaEigthPage(savedData);
        }

        function saveObjectforArogyaFirstPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request && savedData.quoteData.premiumCalculation.request.quoteDetails) {
                var savedDetail = {}
                savedDetail.familySize = savedData.quoteData.premiumCalculation.request.quoteDetails.familysize;
                savedDetail.productTypes = savedData.quoteData.premiumCalculation.request.quoteDetails.productType;
                savedDetail.startDate = $filter('chosenDate')(savedData.quoteData.premiumCalculation.request.quoteDetails.effectiveDate);
                savedDetail.uin = savedData.uin;
                savedDetail.sumInsured = savedData.quoteData.premiumCalculation.request.quoteDetails.sumInsured;
                sumInsured = savedDetail.sumInsured.value;
                basicHealthDetail = savedDetail;
                productCode = savedData.productCode;
            }
        }

        function saveObjectforArogyaSecondPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request && savedData.quoteData.premiumCalculation.request.insuredDetails.length > 0) {
                var savedDetail = {}
                savedDetail.Birthdate = [];
                savedDetail.Relationship = [];
                for (var count = 0; count < savedData.quoteData.premiumCalculation.request.quoteDetails.familysize; count++) {
                    if (savedData.quoteData.premiumCalculation.request.insuredDetails.length > 0) {
                        savedDetail.Birthdate[count] = {};
                        savedDetail.Relationship[count] = {};
                        savedDetail.Birthdate[count] = $filter('chosenDate')(savedData.quoteData.premiumCalculation.request.insuredDetails[count].dob);
                        savedDetail.Relationship[count] = savedData.quoteData.premiumCalculation.request.insuredDetails[count].relationship;
                    }
                }
                
                arsaGenderArray = savedData.quoteData.premiumCalculation.request.quoteDetails.genderArray ? savedData.quoteData.premiumCalculation.request.quoteDetails.genderArray : [];
                savedDetail.uin = savedData.uin;
                insuredDetails = savedDetail;
                arogymPremiumCalc = savedData.quoteData.premiumCalculation.response;
            }
        }

        function saveObjectforArogyaThirdPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request.premiumCalc) { // && savedData.quoteData.premiumCalculation.response.premiumCalculation
                premiumData = savedData.quoteData.premiumCalculation.request.premiumCalc;
            }
        }

        function saveObjectforArogyaFourthPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request && savedData.quoteData.premiumCalculation.request.personalDetails) {
                personalDetails = savedData.quoteData.premiumCalculation.request.personalDetails;
                panNumber = savedData.quoteData.premiumCalculation.request.personalDetails.pan;
           }
        }

        function saveObjectforArogyaSixPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request && savedData.quoteData.premiumCalculation.request.medicalQuestions) {
                arogyaQuestion = savedData.quoteData.premiumCalculation.request.medicalQuestions;
            }
        } 

        function saveObjectforArogyaFifthPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request && savedData.quoteData.premiumCalculation.request.holderDetails) {
                healthDetails = savedData.quoteData.premiumCalculation.request.holderDetails;
            }
        }  

        function saveObjectforArogyaSeventhPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request && savedData.quoteData.premiumCalculation.request.nomineeDetails) {
                nomineeDetail = savedData.quoteData.premiumCalculation.request.nomineeDetails;
            }
        }  

        function saveObjectforArogyaEigthPage(savedData) {
            if (savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.request && savedData.quoteData.premiumCalculation.request.einsurance) {
                eInsurance = savedData.quoteData.premiumCalculation.request.einsurance;
            }
        }

        arogyaSanjeevaniService.setPremiumcalculationForArogyaPremium = function(data) {
            arogymPremiumCalc = data;
        }

        arogyaSanjeevaniService.getPremiumcalculationForArogyaPremium = function() {
            return arogymPremiumCalc;
        }

        arogyaSanjeevaniService.getSaveQuoteRequestForArogya = function() {
            var structure = {
                "quoteData": {
                    "premiumCalculation": {
                        "response": {},
                        "request": {
                            "insuredDetails": [],
                            "quoteDetails": {}
                        }
                    }
                }
            }
            return structure;
        }
       
        arogyaSanjeevaniService.showError = function(message,url,buttonText,callback){
            var confirmPopupIonic = $ionicPopup.alert({
				title: "",
				template: '<div class="popup-padding font-dark-grey"><div><center><img alt="" class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="arsa-pop-msg-color">'
				+ message + '</span></div></div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                buttons: [{
                    text: buttonText ? buttonText : 'OK',
                    type: 'button-positive',
                    onTap: function () {
                        url ? callback() : confirmPopupIonic.close();
                    }
                }]
			})

        }

        arogyaSanjeevaniService.showErrorCaution = function(message,url,buttonText,callback){
            var confirmPopupIonic = $ionicPopup.alert({
				title: "",
				template: '<div class="popup-padding font-dark-grey"><div><center><img alt="" class="approvedIconPosition" src="img/yc_Group.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="arsa-pop-msg-color">'
				+ message + '</span></div></div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                buttons: [{
                    text: buttonText ? buttonText : 'OK',
                    type: 'button-positive',
                    onTap: function () {
                        url ? callback() : confirmPopupIonic.close();
                    }
                }]
			})

        }

        arogyaSanjeevaniService.formPopUpTemplate = function(array,controllerName){
            var template = '<div class="font-dark-grey irctc">'+
            '<div ng-repeat="acc in '+ array + ' track by $index">'+
            '<div class="row  borderbtm" ng-click="'+controllerName + '.close($index)">'+
            '<div class="col las-p-t-2pt2per font-size-20 roboto-regular color545454">₹ {{acc.balance |INR}}</div>'+
            '<div class="col padTopBTM30 font-size-12 roboto-medium color545454">{{acc.benAccntType}} <br><span class="font-size-14 roboto-medium color545454">{{acc.benAccntNo  | cardmask:"X":4}}</span></div>'+
            '</div></div></div>';
            return template;
        }

        arogyaSanjeevaniService.displayPopUp = function (heading, css, message, buttonText, callBack) {
			$ionicPopup.alert({
				title: heading,
				template: '<div class="popupTextBottomPadding  ss-popup-list fontSize-subHeading roboto-medium text-center ' + css + '">'
				+ message + '</div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
				buttons: [
					{
						text: buttonText,
						onTap: function (e) {
							callBack();
						}
					}
				],
			});
		};

        arogyaSanjeevaniService.showAlertModal = function (title, template, onTapgo, $scope, state, buttontext,minorForAO,accountOpeningHomeService) {
			var alertPopup = $ionicPopup.alert({
				title: title,
				template: template,
				scope: $scope,
				cssClass: 'arsa-alert-popup',
				buttons: [
					{
						text: buttontext,
						type: 'button-positive',
						onTap: function () {
							alertPopup.close();
						}
					}
				],
			});
			alertPopup.then(function (res) {
			});
		};


        arogyaSanjeevaniService.setArogyaQuestion = function(data) {
            arogyaQuestion = data;
        }

        arogyaSanjeevaniService.getArogyaQuestion = function() {
            return arogyaQuestion;
        }

        arogyaSanjeevaniService.setbasicHealthDetail = function(data){
            basicHealthDetail = data
        }

        arogyaSanjeevaniService.getbasicHealthDetail = function(){
            return basicHealthDetail;
        }

        arogyaSanjeevaniService.getNomineeDetail = function(){
            return nomineeDetail;
        }

        arogyaSanjeevaniService.setNomineeDetail = function(data){
            nomineeDetail = data;
        }

        arogyaSanjeevaniService.setPremiumData  = function(data){
            premiumData = data;
        }

        arogyaSanjeevaniService.getPremiumData  = function(data){
            return premiumData;
        }

        arogyaSanjeevaniService.setEinsurance  = function(data){
            eInsurance = data;
        }

        arogyaSanjeevaniService.getEinsurance  = function(data){
            return eInsurance;
        }

        arogyaSanjeevaniService.getQuote  = function(data){
            return quoteNumber;
        }

        arogyaSanjeevaniService.setQuote  = function(data){
            quoteNumber = data;
        }

       arogyaSanjeevaniService.setLinkedpolicyDetails  = function(data){
            policyDetails = data;
        }

        arogyaSanjeevaniService.getLinkedpolicyDetails  = function(data){
            return policyDetails;
        }

        arogyaSanjeevaniService.setHealthApplicationPersonalDetails = function(data){
            personalDetails = data;
        }

        arogyaSanjeevaniService.getHealthApplicationPersonalDetails = function(){
            return personalDetails;
        }

        arogyaSanjeevaniService.setHealthAdditionalDetails = function(data){
            healthDetails = data;
        }

        arogyaSanjeevaniService.getHealthAdditionalDetails = function(){
            return healthDetails;
        }

        arogyaSanjeevaniService.setArsaGenderArray = function(data) {
            arsaGenderArray = data;
        }

        arogyaSanjeevaniService.getArsaGenderArray = function(data) {
            return arsaGenderArray;
        }

         /* get Estimated Premmium */
        arogyaSanjeevaniService.quickQuote = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/GeneralInsuranceAdapter/as/v1/getHIArogyaSanjeevaniQuote", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

          /* get Full Premmium And Quote Number*/
        arogyaSanjeevaniService.fullQuote = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/GeneralInsuranceAdapter/as/v1/applyHIArogyaSanjeevaniProduct", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* Policy Purchase Of Arogya Sanjeevani */
        arogyaSanjeevaniService.payARSAPolicy = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/GeneralInsuranceAdapter/as/v1/payForASPolicyPurchase", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* Resend OTP for Arogya Sanjeevani Payment */
        arogyaSanjeevaniService.resendOTPArsaPayment = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/GeneralInsuranceAdapter/as/v1/resendOTPForASPayment", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* Validate OTP for Arogya Sanjeevani Payment */
        arogyaSanjeevaniService.valiateOTPArsaPayment = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/GeneralInsuranceAdapter/as/v1/validateOTPForASPayment", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* Get Paymemt Acknowledgement Document*/
        arogyaSanjeevaniService.getPaymentAcknowledgeSlip = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/GeneralInsuranceAdapter/as/v1/getASPolicyPDF", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* Check KYC score*/
        arogyaSanjeevaniService.checkKyc = function(payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/GeneralInsuranceAdapter/as/v1/getKYCScore", payLoad, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        arogyaSanjeevaniService.getSBIBankAccounts = function(data) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/GeneralInsuranceAdapter/as/v1/getArogyaOwnAccounts", data, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return arogyaSanjeevaniService;


    }
]);
