angularApp.controller('arsaPolicyHolderController', 
    ["$state", "$scope", "$filter",
    "validateService", "generalInsurenceHealthService",
    "generalInsurenceHomeService", "GIconstant", "utilityService",
    "$translate", "arogyaSanjeevaniService",


    function ($state, $scope, $filter, validateService,
        generalInsurenceHealthService, generalInsurenceHomeService,
        GIconstant, utilityService, $translate, arogyaSanjeevaniService) {

        var arsaPolicyHolderVm = this;

        /* Function to display the necessary information
         & put validation on Page load*/
        arsaPolicyHolderVm.initPage = function () {
            var productType;
            arsaPolicyHolderVm.validateService = validateService;
            arsaPolicyHolderVm.constant = GIconstant;
            arsaPolicyHolderVm.premium = arogyaSanjeevaniService.getPremiumData() ? arogyaSanjeevaniService.getPremiumData().estPremium : "";
            productType = generalInsurenceHomeService.getProductDetail() ? generalInsurenceHomeService.getProductDetail().uin : "15";
            arsaPolicyHolderVm.showBack = true;
            arsaPolicyHolderVm.showNext = true;
            arsaPolicyHolderVm.maritalStatusList = generalInsurenceHealthService.getArogyaMasterList().martialStatus;
            arsaPolicyHolderVm.occupationList = generalInsurenceHealthService.getArogyaMasterList().arogyaSanjeevaniOccupation;
            arsaPolicyHolderVm.proposerDetails = arogyaSanjeevaniService.getHealthApplicationPersonalDetails();
            arsaPolicyHolderVm.membersDetails = arogyaSanjeevaniService.getHealthInsureDetails();
            arsaPolicyHolderVm.quoteDeatils = arogyaSanjeevaniService.getbasicHealthDetail();
            arsaPolicyHolderVm.member = [];
            arsaPolicyHolderVm.member = arogyaSanjeevaniService.getbasicHealthDetail().familySize;
            arsaPolicyHolderVm.detailsPage = [];
            if (arogyaSanjeevaniService.getHealthAdditionalDetails()) {
                arsaPolicyHolderVm.memeberList = [];
                for (var count = 0; count < arsaPolicyHolderVm.member; count++) {
                    arsaPolicyHolderVm.memeberList.push(count);
                }
                arsaPolicyHolderVm.data = arogyaSanjeevaniService.getHealthAdditionalDetails();
            } else {
                arsaPolicyHolderVm.data = {};
                arsaPolicyHolderVm.data.isOccupation = [];
                arsaPolicyHolderVm.data.name = [];
                arsaPolicyHolderVm.data.lastName = [];
                arsaPolicyHolderVm.data.birthDay = [];
                arsaPolicyHolderVm.data.Gender = [];
                arsaPolicyHolderVm.data.uin = [];
                arsaPolicyHolderVm.data.maritalStatus = [];
                arsaPolicyHolderVm.data.sumInsured = [];
                arsaPolicyHolderVm.data.occupation = [];
                arsaPolicyHolderVm.data.uin = productType;
                arsaPolicyHolderVm.productType = productType;
                arsaPolicyHolderVm.data.title = [];
                arsaPolicyHolderVm.data.relationship = [];
                arsaPolicyHolderVm.data.titles = [];
                arsaPolicyHolderVm.data.relationship = arsaPolicyHolderVm.membersDetails.Relationship;
                arsaPolicyHolderVm.memeberList = [];
                arsaPolicyHolderVm.data.isTitleDisabled = [];
                for (count = 0; count < arsaPolicyHolderVm.member; count++) {
                    arsaPolicyHolderVm.memeberList.push(count);
                    arsaPolicyHolderVm.data.birthDay[count] =  arsaPolicyHolderVm.membersDetails.Birthdate[count]
                    arsaPolicyHolderVm.data.sumInsured[count] = arsaPolicyHolderVm.quoteDeatils.sumInsured.value;
                    arsaPolicyHolderVm.data.titles[count] = generalInsurenceHealthService.getArogyaMasterList().title;
                    if (arsaPolicyHolderVm.data.relationship[count].key == '1') {
                        arsaPolicyHolderVm.data.title[count] = arsaPolicyHolderVm.proposerDetails.title;
                        arsaPolicyHolderVm.data.name[count] = arsaPolicyHolderVm.proposerDetails.firstName;
                        arsaPolicyHolderVm.data.lastName[count] = arsaPolicyHolderVm.proposerDetails.LastName;
                        arsaPolicyHolderVm.data.Gender[count] = (arsaPolicyHolderVm.proposerDetails.gender == 'F') ? "Female" : "Male";
                        arsaPolicyHolderVm.data.occupation[count] = arsaPolicyHolderVm.proposerDetails.occupation;
                        arsaPolicyHolderVm.data.isTitleDisabled[count] = true;
                    } else {
                        
                        if (arsaPolicyHolderVm.data.relationship[count].key == '2') {
                            arsaPolicyHolderVm.data.maritalStatus[count] = arsaPolicyHolderVm.maritalStatusList.find(function (status) {
                                return status.key == '1'
                            })
                            arsaPolicyHolderVm.populate(arogyaSanjeevaniService.getArsaGenderArray()[0].ikey,count);
                        } else {
                            var age = arsaPolicyHolderVm.validateService.calcAge(arsaPolicyHolderVm.membersDetails.Birthdate[count]);
                            if (age < 18) {
                                arsaPolicyHolderVm.data.maritalStatus[count] = arsaPolicyHolderVm.maritalStatusList.find(function (status) {
                                    return status.key == '2'
                                })
                            }
                            if(arsaPolicyHolderVm.data.relationship[count].key == '3' || arsaPolicyHolderVm.data.relationship[count].key == '5' || arsaPolicyHolderVm.data.relationship[count].key == '7') {
                                arsaPolicyHolderVm.populate("M",count);
                            }else{
                                arsaPolicyHolderVm.populate("F",count);
                            }
                        }
                    }
                    if (arsaPolicyHolderVm.data.relationship[count].ikey == "C") {
                        arsaPolicyHolderVm.data.isOccupation[count] = false;
                    } else {
                        arsaPolicyHolderVm.data.isOccupation[count] = true;
                    }
                }
            }
        }
    
        /* Function to get Title Array in the Select Option */
       arsaPolicyHolderVm.populate = function (code,index) {
           arsaPolicyHolderVm.data.isTitleDisabled[index] = false;
            if (code == "F") {
                arsaPolicyHolderVm.data.Gender[index] = "Female";
                arsaPolicyHolderVm.data.titles[index] = arsaPolicyHolderVm.data.titles[index].filter(function (title) {
                    return title.key != "9000000001";
                })
            } else {
                arsaPolicyHolderVm.data.Gender[index] = "Male";
                var maleTitle = arsaPolicyHolderVm.data.titles[index].filter(function (title) {
                    return title.key == "9000000001";
                })
                arsaPolicyHolderVm.data.title[index] = maleTitle[0];
                arsaPolicyHolderVm.data.isTitleDisabled[index] = true;
            }
        }

        /* Function to Auto Populate Gender */
        arsaPolicyHolderVm.autoPopulateGender = function (index) {
            arsaPolicyHolderVm.data.title[index].key != '9000000001' ? arsaPolicyHolderVm.data.Gender[index] = "Female" : arsaPolicyHolderVm.data.Gender[index] = "Male";
        }

        /* go to previous page */
        arsaPolicyHolderVm.goBacktoPrevious = function () {
            $state.go("menu.arsaProposerDetails");
        }

        /* save application for Arogya Sanjeevani  */
        arsaPolicyHolderVm.saveApplicationArogya = function() {
            var stringifyStructure1 = arogyaSanjeevaniService.getSaveApplicationArogyaStructure();
            var structure = stringifyStructure1;
            if(typeof(structure.quoteData)=='string'){
                structure.quoteData = JSON.parse(structure.quoteData);
            }
            var firstPageDetail = arogyaSanjeevaniService.getSaveQuoteRequestForArogya();
            var applicationNo = arogyaSanjeevaniService.getSaveApplicationArogyaResponse();
            firstPageDetail.quoteData = structure.quoteData;
            firstPageDetail.quoteData.premiumCalculation.request.holderDetails = {};
            firstPageDetail.quoteData.premiumCalculation.request.holderDetails = arsaPolicyHolderVm.data;          
            structure.applicationNumber = applicationNo.applicationNumber;
            structure.sumInsured =  arogyaSanjeevaniService.getpolicySumInsured() ?  arogyaSanjeevaniService.getpolicySumInsured() : "";   
            structure.policyStartDate =   arogyaSanjeevaniService.getpolicyStartdate() ?   arogyaSanjeevaniService.getpolicyStartdate() : "";
            structure.quoteData = firstPageDetail.quoteData;
            structure.applicationData = GIconstant.OmniChannel.ArogyaSanjeevani.AP_INSURER_DETAILS;
            var stringified = structure;
            if(typeof(stringified.quoteData)=='object'){
                stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            arogyaSanjeevaniService.setSaveApplicationArogyaStructure(structure);
            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.Arogya.AP_INSURER_DETAILS).then(function(data) {
                arogyaSanjeevaniService.setHealthAdditionalDetails(arsaPolicyHolderVm.data);
                $state.go("menu.arsaMedicalQuestion");
            }, function(error) {
                arogyaSanjeevaniService.showError(error.responseMessage);
            });
        }

        /* go to Next Page */
        arsaPolicyHolderVm.goToNextPage = function () {
            if(arsaPolicyHolderVm.validateForm()){
                arsaPolicyHolderVm.saveApplicationArogya();
            }
        }

        /* Function to validate the fields */
        arsaPolicyHolderVm.validateForm = function () {
            arsaPolicyHolderVm.detailsPage.title = [];
            arsaPolicyHolderVm.detailsPage.name = [];
            arsaPolicyHolderVm.detailsPage.lastName = [];
            arsaPolicyHolderVm.detailsPage.occupation = [];
            arsaPolicyHolderVm.detailsPage.maritalStatus = [];
            var isValid = true;
            for (var count = 0; count < Number(arsaPolicyHolderVm.member); count++) {
                if (arsaPolicyHolderVm.validateService.isValidTitle(arsaPolicyHolderVm.data.title[count])) {
                    arsaPolicyHolderVm.detailsPage.title[count] =
                        arsaPolicyHolderVm.validateService.isValidTitle(arsaPolicyHolderVm.data.title[count]);
                    isValid = false;
                }
                if (arsaPolicyHolderVm.validateService.isValidFirstName(arsaPolicyHolderVm.data.name[count])) {
                    arsaPolicyHolderVm.detailsPage.name[count] =
                        arsaPolicyHolderVm.validateService.isValidFirstName(arsaPolicyHolderVm.data.name[count]);
                    isValid = false;
                }
                if (count > 0) {
                    if (arsaPolicyHolderVm.validateService.isValidLastNameGI(arsaPolicyHolderVm.data.lastName[count], false)) {
                        arsaPolicyHolderVm.detailsPage.lastName[count] =
                            arsaPolicyHolderVm.validateService.isValidLastNameGI(arsaPolicyHolderVm.data.lastName[count], false);
                        isValid = false;
                    }
                } else {
                    if (arsaPolicyHolderVm.validateService.isValidLastNameGI(arsaPolicyHolderVm.data.lastName[0], true)) {
                        arsaPolicyHolderVm.detailsPage.lastName[0] =
                            arsaPolicyHolderVm.validateService.isValidLastNameGI(arsaPolicyHolderVm.data.lastName[0], true);
                        isValid = false;
                    }
                }
                if (arsaPolicyHolderVm.data.isOccupation[count] && arsaPolicyHolderVm.validateService.isValidOccupationArsa(arsaPolicyHolderVm.data.occupation[count])) {
                    arsaPolicyHolderVm.detailsPage.occupation[count] =
                        arsaPolicyHolderVm.validateService.isValidOccupationArsa(arsaPolicyHolderVm.data.occupation[count]);
                    isValid = false;
                }
                if (arsaPolicyHolderVm.validateService.isValidMaritalStatus(arsaPolicyHolderVm.data.maritalStatus[count])) {
                    arsaPolicyHolderVm.detailsPage.maritalStatus[count] =
                        arsaPolicyHolderVm.validateService.isValidMaritalStatus(arsaPolicyHolderVm.data.maritalStatus[count]);
                    isValid = false;
                }
            }
            return (isValid);
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            arsaPolicyHolderVm.initPage();
        });
    }
]);
