angularApp.controller('arsaMemberDetailsController', 
    ["$state","$scope","$filter", 
    "validateService", "generalInsurenceHealthService", 
    "generalInsurenceHomeService", "GIconstant", "utilityService", 
    "$translate","customerInfoService","arogyaSanjeevaniService", "getAccountDetailsService",


    function($state, $scope,  $filter, validateService, 
        generalInsurenceHealthService, generalInsurenceHomeService, 
        GIconstant, utilityService, $translate, customerInfoService,arogyaSanjeevaniService, getAccountDetailsService) {

        var memberDetailsControllerVm = this;
        memberDetailsControllerVm.constant = GIconstant;
        memberDetailsControllerVm.showBack = true;
        memberDetailsControllerVm.showNext = true;
        memberDetailsControllerVm.product = {};
        memberDetailsControllerVm.validateService = validateService;
        memberDetailsControllerVm.childCount = false;
  
        var productType, policyStartDate,originalRelationValue,errorMssgDOB, ageErrorMssg,previouspageData,
        arsaMasterData,currentPageData;

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            memberDetailsControllerVm.initPage();
        });

        /* Function to display the necessary information
         & put validation on Page load*/
        memberDetailsControllerVm.initPage = function() {
            memberDetailsControllerVm.product = {};
            memberDetailsControllerVm.product.Relationship = [];
            memberDetailsControllerVm.member = {};
            memberDetailsControllerVm.product.Birthdate = [];
            memberDetailsControllerVm.product.SumInsured = [];

            memberDetailsControllerVm.product.Gender = [];
            memberDetailsControllerVm.birthdateEndLimit = [];
            memberDetailsControllerVm.birthdateStartLimit = [];
            memberDetailsControllerVm.childCount = false;
            memberDetailsControllerVm.notChildRelationship = [];
            memberDetailsControllerVm.healthQuoteCalculation = {};
            originalRelationValue = [];
            errorMssgDOB = $translate.instant('DOB_ALERT');
            ageErrorMssg = $translate.instant('AGE_ALERT_GREATER_THAN_LIMIT');

            previouspageData = arogyaSanjeevaniService.getbasicHealthDetail();
            arsaMasterData = generalInsurenceHealthService.getArogyaMasterList();
            currentPageData = arogyaSanjeevaniService.getHealthInsureDetails();
            policyStartDate = previouspageData.startDate;
            memberDetailsControllerVm.relationship = arsaMasterData.arogyaSanjeevaniRelationShip ? arsaMasterData.arogyaSanjeevaniRelationShip : arsaMasterData.nomineeRealtion; 
            originalRelationValue = memberDetailsControllerVm.relationship;  
            memberDetailsControllerVm.genderList = arsaMasterData.gender;
            productType = generalInsurenceHomeService.getProductDetail() ? generalInsurenceHomeService.getProductDetail().uin : '15';
                    
                if (previouspageData) {
                    memberDetailsControllerVm.member = previouspageData.familySize;
                        if (currentPageData) {
                            memberDetailsControllerVm.product = currentPageData;
                            memberDetailsControllerVm.product.Gender = [];
                            var index = memberDetailsControllerVm.product.Relationship.findIndex(function (obj) {
                                return obj.key == '2'
                            });
                            if (index > -1) {
                                for (var i = 0; i < memberDetailsControllerVm.member; i++) {
                                    if (i == index) {
                                        memberDetailsControllerVm.product.Gender[i] = arogyaSanjeevaniService.getArsaGenderArray()[0];
                                    } else {
                                        memberDetailsControllerVm.product.Gender[i] = null;
                                    }
                                }
                            } 
                            if(previouspageData.familySize > 1) { 
                                memberDetailsControllerVm.product.Relationship[0] = memberDetailsControllerVm.relationship[0];
                                memberDetailsControllerVm.product.Birthdate[0] = customerInfoService.customer.DOB ? customerInfoService.customer.DOB : '';
                                memberDetailsControllerVm.product.Gender[0] = memberDetailsControllerVm.product.Gender[0] ? memberDetailsControllerVm.product.Gender[0] : null;
                                var ageOfSelf = validateService.calcAge(memberDetailsControllerVm.product.Birthdate[0]);
                                if (memberDetailsControllerVm.product.Birthdate[0] != '') {
                                    if (ageOfSelf >= 55) {
                                        arogyaSanjeevaniService.showErrorCaution(ageErrorMssg);
                                    }
                                } else {
                                    arogyaSanjeevaniService.showError(errorMssgDOB);
                                }
                            } 
                        } else {
                            if (arsaMasterData) {
                                originalRelationValue = memberDetailsControllerVm.relationship;
                                memberDetailsControllerVm.product.Relationship[0] = memberDetailsControllerVm.relationship[0];
                                memberDetailsControllerVm.product.Birthdate[0] = customerInfoService.customer.DOB ? customerInfoService.customer.DOB : '';
                                if(previouspageData.familySize > 1) { 
                                    var ageOf_Self = validateService.calcAge(memberDetailsControllerVm.product.Birthdate[0]);
                                    if (memberDetailsControllerVm.product.Birthdate[0] != '') {
                                        if (ageOf_Self >= 55) {
                                            arogyaSanjeevaniService.showErrorCaution(ageErrorMssg);
                                        }
                                    } else {
                                        arogyaSanjeevaniService.showError(errorMssgDOB);
                                    }
                                }
                            }
                        }
                }

            if(memberDetailsControllerVm.product.Relationship[0].key.toString() == '1'){
                    memberDetailsControllerVm.checkForAge(memberDetailsControllerVm.product.Relationship[0],0);
                    memberDetailsControllerVm.birthdateEndLimit[0] = generalInsurenceHomeService.getFutureYear(validateService.getCurrentDate(), memberDetailsControllerVm.constant.Health.birthdateEndLimit);
            }
            memberDetailsControllerVm.memeberList = [];
                for (var count = 0; count < memberDetailsControllerVm.member; count++) {
                memberDetailsControllerVm.memeberList.push(count);
                if (productType == memberDetailsControllerVm.constant.Health.arogyaSanjeevani) {
                    memberDetailsControllerVm.birthdateStartLimit[count] = generalInsurenceHomeService.getFutureYear(policyStartDate, -55);
                    memberDetailsControllerVm.birthdateStartLimit[count] = generalInsurenceHomeService.getFutureDate(memberDetailsControllerVm.birthdateStartLimit[count], 2);
                    memberDetailsControllerVm.birthdateEndLimit[count] = generalInsurenceHomeService.getFutureMonth(policyStartDate, memberDetailsControllerVm.constant.Arogya.birthdateEndLimitMonth);
                } else {
                    if (count == 0) {
                        memberDetailsControllerVm.birthdateStartLimit[count] = generalInsurenceHomeService.getFutureYear(policyStartDate, memberDetailsControllerVm.constant.Health.birthdateStartLimit);
                        memberDetailsControllerVm.birthdateEndLimit[count] = generalInsurenceHomeService.getFutureYear(policyStartDate, memberDetailsControllerVm.constant.Health.birthdateEndLimit);

                    } else {
                        memberDetailsControllerVm.birthdateStartLimit[count] = generalInsurenceHomeService.getFutureYear(policyStartDate, memberDetailsControllerVm.constant.Health.birthdateStartLimit);
                        memberDetailsControllerVm.birthdateEndLimit[count] = generalInsurenceHomeService.getFutureMonth(policyStartDate, memberDetailsControllerVm.constant.Health.birthdateEndLimitMonth);
                    }
                }
            }

            if(memberDetailsControllerVm.member == 1){
                memberDetailsControllerVm.relationship = originalRelationValue.filter(function (relation) {
                   return relation.ikey != 'C';
                });
            }

        }

        /* Function to Calculate the Child & Adult count
        & display the alert message accordingly*/
        memberDetailsControllerVm.onRelationSelect = function(key,index) {
            memberDetailsControllerVm.product.Birthdate[index] = '';
            if(key == '1') {
                memberDetailsControllerVm.product.Birthdate[index] = customerInfoService.customer.DOB ? customerInfoService.customer.DOB : '';
            }
            var childCount = 0;
            var parentsAlert = false;
            var parentInLawAlert = false;
            var adultCount = 0;
            for(var i=0; i < memberDetailsControllerVm.memeberList.length; i++) {
                if(i < memberDetailsControllerVm.product.Relationship.length) {
                    if(memberDetailsControllerVm.product.Relationship[i]!=undefined || memberDetailsControllerVm.product.Relationship[i]!=null) {
                        
                        if (memberDetailsControllerVm.product.Relationship[i].ikey == 'C') {
                            childCount++;
                        } else {
                            adultCount++;
                        }

                        if (key == '5' || key == '6') {
                            if (memberDetailsControllerVm.product.Relationship[i].key == '7' || memberDetailsControllerVm.product.Relationship[i].key == '8') {
                                parentInLawAlert = true;
                            }
                        } else if (key == '7' || key == '8') {
                            if (memberDetailsControllerVm.product.Relationship[i].key == '5' || memberDetailsControllerVm.product.Relationship[i].key == '6') {
                                parentsAlert = true;
                            }
                        }
                    }
                }               
            }
            var maxChildLimitMssg = $translate.instant('CHILD_SELECT_LIMIT');
            var maxAdultLimitMssg = $translate.instant('MAXIMUM_ADULT_LIMIT');
            var parentsSelectionMssg = $translate.instant('PARENTS_SELECTION');
            var parentsInLawSelectionMssg = $translate.instant('PARENTS_INLAW_SELECTION');
            if(childCount > 3) {
                memberDetailsControllerVm.product.Relationship[index] = '';
                arogyaSanjeevaniService.showError(maxChildLimitMssg);
            } 
            if(adultCount > 4) {
                memberDetailsControllerVm.product.Relationship[index] = '';
                arogyaSanjeevaniService.showError(maxAdultLimitMssg);
            }
            if(parentsAlert) {
                memberDetailsControllerVm.product.Relationship[index] = '';
                arogyaSanjeevaniService.showError(parentsSelectionMssg);
            } else if(parentInLawAlert) {
                memberDetailsControllerVm.product.Relationship[index] = '';
                arogyaSanjeevaniService.showError(parentsInLawSelectionMssg);
            }
        }

        /* Function to calculate the age of the selected person */
        memberDetailsControllerVm.checkForAge = function(data, index) {
            memberDetailsControllerVm.healthQuoteCalculation = {};
            memberDetailsControllerVm.healthQuoteCalculation.Birthdate = {};
            if (data.key == memberDetailsControllerVm.constant.Health.ageRelationshipSon || data.key == memberDetailsControllerVm.constant.Health.ageRelationshipDaughter) {
                memberDetailsControllerVm.birthdateStartLimit[index] = generalInsurenceHomeService.getFutureYear(generalInsurenceHomeService.getCurrentDate(), -25); //-18
                memberDetailsControllerVm.birthdateStartLimit[index] = generalInsurenceHomeService.getFutureDate(memberDetailsControllerVm.birthdateStartLimit[index], 2);
                memberDetailsControllerVm.birthdateEndLimit[index] = generalInsurenceHomeService.getFutureMonth(generalInsurenceHomeService.getCurrentDate(), memberDetailsControllerVm.constant.Health.birthdateEndLimitMonth);
                
            } else {
                    memberDetailsControllerVm.birthdateStartLimit[index] = generalInsurenceHomeService.getFutureYear(generalInsurenceHomeService.getCurrentDate(), -55);
                    memberDetailsControllerVm.birthdateStartLimit[index] = generalInsurenceHomeService.getFutureDate(memberDetailsControllerVm.birthdateStartLimit[index], 2);
                    memberDetailsControllerVm.birthdateEndLimit[index] = generalInsurenceHomeService.getFutureYear(generalInsurenceHomeService.getCurrentDate(), -18);
                    if (new Date(memberDetailsControllerVm.product.Birthdate[index]) > new Date(memberDetailsControllerVm.birthdateEndLimit[index])) {
                       memberDetailsControllerVm.healthQuoteCalculation.Birthdate[index] = 'Minimum age limit is 18 years';
                    }
                }
        }

        /* Function to calculate the age difference between 
        proposal & its Relation */
        memberDetailsControllerVm.calculateAge = function(age, key, index) {
            if(key == '3' || key == '4' ) { 
                var childAge = validateService.calcAge(age);
                if(childAge > 18) {
                    var mssg = $translate.instant('AGE_CHILD_GREATER_EIGHTEEN');
                    var title = '';
                    var onTap = '';
                    var buttontext = 'OK';
                    arogyaSanjeevaniService.showAlertModal(title, mssg, onTap, $scope, $state, buttontext);
                }
            } else if(key == '5' || key == '6' || key == '7' || key == '8') {
                if(customerInfoService.customer.DOB != undefined || customerInfoService.customer.DOB != null) {
                    var proposalAge = validateService.calcAge(customerInfoService.customer.DOB);
                    var memberAge = validateService.calcAge(age);
                    var diffInAge = memberAge - proposalAge;
                    
                    var relation;
                    switch (key) {
                        case '5':
                            relation = 'Father';
                            break;
                        case '6':
                            relation = 'Mother';
                            break;
                        case '7':
                            relation = 'Father In Law';
                            break;
                        case '8':
                            relation = 'Mother In Law';
                            break;
                        default:
                    }

                    var errorMssg = 'Age gap between ' + relation + ' and Proposer is less than 18yrs. Please select a valid relationship.'
                    if (diffInAge < 18) {
                        memberDetailsControllerVm.product.Birthdate[index] = '';
                        arogyaSanjeevaniService.showError(errorMssg);
                    }
                } else {
                    arogyaSanjeevaniService.showError(errorMssgDOB);
                }

            }
        }

        /*  go to previous page */
        memberDetailsControllerVm.goBacktoPrevious = function() {
            $state.go('menu.arsaQuoteCalculation');
        }

        /*  go to next page */
        memberDetailsControllerVm.goToNextPage = function() {
            if(customerInfoService.customer && customerInfoService.customer.DOB) {
                if (validateForm()) {
                    if(customerInfoService.customer.residentialStatus && customerInfoService.customer.residentialStatus != '1'){
                        arogyaSanjeevaniService.showError($translate.instant('ARSA_NRI_ERROR'));
                        return;
                    }
                    if(getAccountDetailsService.accountOverviewData && getAccountDetailsService.accountOverviewData.customerInformation){
                        var gender = getAccountDetailsService.accountOverviewData.customerInformation.gender.toLowerCase();
                        if(arogyaSanjeevaniService.getValue(getAccountDetailsService.accountOverviewData.customerInformation.firstName) == '') {
                            arogyaSanjeevaniService.showError($translate.instant('ARSA_PROPOSER_FIRSTNAME_MISSING'));
                            return;
                        }
                        if(arogyaSanjeevaniService.getValue(getAccountDetailsService.accountOverviewData.customerInformation.lastName) == '') {
                            arogyaSanjeevaniService.showError($translate.instant('ARSA_PROPOSER_LASTNAME_MISSING'));
                            return;
                        }
                        if(arogyaSanjeevaniService.getValue(gender) == '') {
                            arogyaSanjeevaniService.showError($translate.instant('ARSA_PROPOSER_GENDER_MISSING'));
                            return;
                        }
                        if(gender != "male" && gender != "female"){
                            arogyaSanjeevaniService.showError($translate.instant('ARSA_PREM_AMT_GREATER_ONE_LAKH'));
                            return;
                        }
                    }
                    var insureDetArrary = [];
                    var adult = 0;
                    var child = 0;
                    var ffCat = '';
                    var proposalAge = validateService.calcAge(customerInfoService.customer.DOB);
                    if(proposalAge < 18){
                        arogyaSanjeevaniService.showError($translate.instant('ARSA_MINOR_ERROR'));
                        return;
                    }
                    if(previouspageData.familySize == 1) {
                        if(memberDetailsControllerVm.product.Relationship[0].key == '1') {
                            if(proposalAge >= 55) {
                                return arogyaSanjeevaniService.showErrorCaution(ageErrorMssg);
                            }   
                        }
                    }
                    for (var i = 0; i < memberDetailsControllerVm.memeberList.length; i++) {
                        insureDetArrary[i] = {};
                        insureDetArrary[i].dob = $filter('dateFormat')(memberDetailsControllerVm.product.Birthdate[i]);
                        insureDetArrary[i].argInsuredRelToProposer = memberDetailsControllerVm.product.Relationship[i].key;
                        var ageOfNominee = validateService.calcAge(memberDetailsControllerVm.product.Birthdate[i]);
                        if(ageOfNominee >= 55) {
                           return arogyaSanjeevaniService.showErrorCaution(ageErrorMssg);
                        }
                         if(memberDetailsControllerVm.product.Relationship[i].ikey == 'C') {
                            child++;
                         }  else{
                             adult++;
                         }
                    }
                    child == 0 ? ffCat = adult + 'A' : ffCat = adult + 'A+' + child + 'C';
                    var sanjeevaniFFCategory = generalInsurenceHealthService.getArogyaMasterList().arogyaSanjeevaniFamilyFloaterRelation.find(function (ff) {
                        return ff.ikey == ffCat;
                    })
                    var request = {
                        "createQuoteRequest": {
                            "quoteDetails": {
                                "arogyaPolicyType": arogyaSanjeevaniService.getbasicHealthDetail().productTypes.key,
                                "policyStartDate": $filter('dateFormat')(arogyaSanjeevaniService.getbasicHealthDetail().startDate),
                                "sumInsured": arogyaSanjeevaniService.getbasicHealthDetail().sumInsured.key,
                                "sanjeevaniFFCategory": sanjeevaniFFCategory ? sanjeevaniFFCategory.key : '',
                                "productCode" : arogyaSanjeevaniService.getProductCode() ? arogyaSanjeevaniService.getProductCode() : ''
                            },
                            "insuredDetails": insureDetArrary
                        }
                    }
                    arogyaSanjeevaniService.quickQuote(request).then(function (data) {
                        var premiumData = {};
                        premiumData.estPremium = data.arogyaSanjeevani.grossPremium;
                        arogyaSanjeevaniService.setPremiumData(premiumData);
                        memberDetailsControllerVm.saveApplication();     
                    }, function (error) {
                        arogyaSanjeevaniService.showError(error.responseMessage);
                    }); 
                }
            } else {
                arogyaSanjeevaniService.showError(errorMssgDOB);
            }
        }

          memberDetailsControllerVm.saveApplication = function() {
               var genderArray = [];
               genderArray = memberDetailsControllerVm.product.Gender.filter(function (gender) {
                   if(gender && gender.value){
                     return gender.value == 'Male' || gender.value == 'Female';
                   }
                });
                var stringifyStructure1 = arogyaSanjeevaniService.getSaveApplicationArogyaStructure();
                var structure = stringifyStructure1;
                 if(typeof(structure.quoteData)=='string'){
                     structure.quoteData = JSON.parse(structure.quoteData);
                 }
                var firstPageDetail = arogyaSanjeevaniService.getSaveQuoteRequestForArogya();
                var premiumDetail = arogyaSanjeevaniService.getPremiumcalculationForArogyaPremium();
                var applicationNo = arogyaSanjeevaniService.getSaveApplicationArogyaResponse();
                firstPageDetail.quoteData = structure.quoteData;
                firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.planDuration = '1';
                firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.genderArray = genderArray;
                for (var count = 0; count < memberDetailsControllerVm.memeberList.length; count++) {
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count] = {};
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count].dob = new Date(memberDetailsControllerVm.product.Birthdate[count]);
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count].relationship = memberDetailsControllerVm.product.Relationship[count];
                }
                firstPageDetail.quoteData.premiumCalculation.response = premiumDetail;
                structure.applicationNumber = applicationNo.applicationNumber;
                structure.sumInsured =  arogyaSanjeevaniService.getpolicySumInsured() ?  arogyaSanjeevaniService.getpolicySumInsured() : '';   
                structure.policyStartDate =   arogyaSanjeevaniService.getpolicyStartdate() ?   arogyaSanjeevaniService.getpolicyStartdate() : '';
                structure.applicationData = GIconstant.OmniChannel.ArogyaSanjeevani.AP_PREMIUM_2;
                structure.quoteData = firstPageDetail.quoteData;
                var stringified = structure;
                if(typeof(stringified.quoteData)=='object'){
                   stringified.quoteData = JSON.stringify(stringified.quoteData);
               }
                arogyaSanjeevaniService.setSaveApplicationArogyaStructure(structure);
                arogyaSanjeevaniService.setArsaGenderArray(genderArray);
                generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.Arogya.AP_PREMIUM_2).then(function(data) {
                   arogyaSanjeevaniService.setHealthInsureDetails(memberDetailsControllerVm.product);
                   $state.go('menu.arsaQuoteSummary'); 
                }, function(error) {
                    arogyaSanjeevaniService.showError(error.responseMessage);
                });
            }

         /* Form Validation   */
        function validateForm() {
            memberDetailsControllerVm.healthQuoteCalculation = {};
            memberDetailsControllerVm.healthQuoteCalculation.Birthdate = {};
            memberDetailsControllerVm.healthQuoteCalculation.Relationship = {};
            memberDetailsControllerVm.healthQuoteCalculation.Gender = {};
            var firstMemberAge = validateService.calcAge(memberDetailsControllerVm.product.Birthdate[0]);

             for (var count = 0; count < memberDetailsControllerVm.member; count++) {
                    if (memberDetailsControllerVm.validateService.isValidbirthDate(memberDetailsControllerVm.product.Birthdate[count])) {
                        if(firstMemberAge < 18) {
                            memberDetailsControllerVm.healthQuoteCalculation.Birthdate[count] = 'Minimum age limit is 18 years';
                        } else {
                            memberDetailsControllerVm.healthQuoteCalculation.Birthdate[count] = memberDetailsControllerVm.validateService.isValidbirthDate(memberDetailsControllerVm.product.Birthdate[count]);     
                        }
                    }  
                    if (memberDetailsControllerVm.validateService.isValidRelationship(memberDetailsControllerVm.product.Relationship[count])) {
                        memberDetailsControllerVm.healthQuoteCalculation.Relationship[count] = memberDetailsControllerVm.validateService.isValidRelationship(memberDetailsControllerVm.product.Relationship[count]);
                    }
                    if(memberDetailsControllerVm.product.Relationship[count].key == '2') {
                        if (memberDetailsControllerVm.validateService.isValidGender(memberDetailsControllerVm.product.Gender[count])) {
                            memberDetailsControllerVm.healthQuoteCalculation.Gender[count] = memberDetailsControllerVm.validateService
                                .isValidGender(memberDetailsControllerVm.product.Gender[count]);
                        }
                    }
                }

             return (((angular.equals({}, memberDetailsControllerVm.healthQuoteCalculation.Birthdate)) ? true : false) && ((angular.equals({}, memberDetailsControllerVm.healthQuoteCalculation.Relationship)) ? true : false) &&
              ((angular.equals({}, memberDetailsControllerVm.healthQuoteCalculation.Gender)) ? true : false));
        }

    }
]);
