angularApp.controller('claimIntimationController', [
    "$scope",
    "$ionicPopup","generalInsurenceHomeService","$state",
    function(
        $scope,
        $ionicPopup,generalInsurenceHomeService,$state) {

        var claimIntimationVm = this;
        var productUid;

        function initPage() {
            claimIntimationVm.productId =  generalInsurenceHomeService.getLinkedpolicyDetailDetailsNew().productId;
            generalInsurenceHomeService.getClaimIntimation().then(function(detail) {
                claimIntimationVm.claimTerms = detail.guidelines;
                claimIntimationVm.nontravelleerDetail = detail.contactDetails[0];
                claimIntimationVm.travellerDetail = detail.contactDetails[1];
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
  


        }

        claimIntimationVm.goBack  = function (){
            $state.go("menu.myPolicies");
        }

        claimIntimationVm.showTravelClaimContacts = function() {
            var travelContactsPopup = $ionicPopup.alert({
                title: '',
                cssClass : 'fss-claim-popup',
                templateUrl: 'pages/generalInsurance/common/travelIntimationContactsPopup.html',
                okText: "Close",
                scope: $scope
            });

            travelContactsPopup.then(function(res) {
              
            });
        }

        claimIntimationVm.showNonTravelClaimContacts = function() {
                var travelContactsPopup = $ionicPopup.alert({
                    title: '',
                    cssClass : 'fss-claim-popup',
                    templateUrl: 'pages/generalInsurance/common/nonTravelIntimateContactsPopup.html',
                    okText: "Close",
                    scope: $scope
                });

                travelContactsPopup.then(function(res) {
                  
                });
            }

          $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
