angularApp.controller('criticalIlnessPremiumCalulationController', ["$state", "$scope", "$filter", "validateService", "generalInsurenceHomeService", "generalInsurenceHealthService", "utilityService","GIconstant","clickStreamService",
    function($state, $scope, $filter, validateService, generalInsurenceHomeService, generalInsurenceHealthService, utilityService,GIconstant,clickStreamService) {

        var criticalIlnessPremiumCalulationVm = this;
        criticalIlnessPremiumCalulationVm.validateService = validateService;
        criticalIlnessPremiumCalulationVm.showNext = "true";
        criticalIlnessPremiumCalulationVm.showBack = "true";
        var curentDate = generalInsurenceHomeService.getCurrentDate();
        criticalIlnessPremiumCalulationVm.minDOB = generalInsurenceHomeService.getFutureYear(curentDate, -65);
        criticalIlnessPremiumCalulationVm.minDOB = generalInsurenceHomeService.getFutureDate(criticalIlnessPremiumCalulationVm.minDOB, 1);
        criticalIlnessPremiumCalulationVm.maxDOB = generalInsurenceHomeService.getFutureYear(curentDate, -18);
        criticalIlnessPremiumCalulationVm.maxDOB = generalInsurenceHomeService.getFutureDate(criticalIlnessPremiumCalulationVm.maxDOB, 1);
        criticalIlnessPremiumCalulationVm.policyMinStartDate = $filter('chosenDate')(curentDate);
        criticalIlnessPremiumCalulationVm.policyMaxStartDate = generalInsurenceHomeService.getFutureDate(curentDate, 7);
        criticalIlnessPremiumCalulationVm.data = {};

        criticalIlnessPremiumCalulationVm.calculatePolicyEndDate = calculatePolicyEndDate;
        criticalIlnessPremiumCalulationVm.goBacktoPrevious = goBacktoPrevious;
        criticalIlnessPremiumCalulationVm.goToNextPage = goToNextPage;
        var productType;

        function initPage() {
            var previouspageData = generalInsurenceHealthService.getCriticalIllnessDetails();
            if (previouspageData) {
                criticalIlnessPremiumCalulationVm.data = previouspageData;
            }else{
                criticalIlnessPremiumCalulationVm.data.policyStartDate =  $filter('chosenDate')(curentDate);
            }
            productType = generalInsurenceHomeService.getProductDetail().uin;
            generalInsurenceHealthService.getCriticalMaster().then(function(response) {
                generalInsurenceHealthService.setCriticalMasterList(response);
                criticalIlnessPremiumCalulationVm.listSumInsured = response.sumInsured;
                criticalIlnessPremiumCalulationVm.genderList = response.gender;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

        }

        function calculatePolicyEndDate() {
            criticalIlnessPremiumCalulationVm.data.policyEndDate = generalInsurenceHomeService.getFutureYear(criticalIlnessPremiumCalulationVm.data.policyStartDate, 1);
        }

        function calcExpDate(startYear, totalYear) {
            var year = parseInt(totalYear);
            var endYear = generalInsurenceHomeService.getFutureYear(startYear, year);
            return endYear;
        }

        function saveApplicationCriticalIllness() {
            generalInsurenceHomeService.setpolicyStartdate(criticalIlnessPremiumCalulationVm.data.policyStartDate);
            var structure = generalInsurenceHomeService.getSaveApplicationSimpleHealth();
            var firstPageDetail = generalInsurenceHealthService.getSaveQuoteRequestForCriticalIllness();
            var criticalIllness = generalInsurenceHealthService.getPremiumcalculationForCriticalIllness();
            var year = generalInsurenceHealthService.getCriticalMasterList().policyTenure[0];
            var age = validateService.calcAge(criticalIlnessPremiumCalulationVm.data.Birthday);
            var age1 = age.toString();
            var expiryDate = calcExpDate(criticalIlnessPremiumCalulationVm.data.policyStartDate, year.ikey);
            firstPageDetail.quoteData.premiumCalculation.request.quoteNo = criticalIllness ? criticalIllness.premiumCalculation.quoteNumber : "";
            firstPageDetail.quoteData.premiumCalculation.request.policyID = criticalIllness ? criticalIllness.premiumCalculation.policyTerms.policyID : "";
            firstPageDetail.quoteData.premiumCalculation.request.effectiveDate = new Date(criticalIlnessPremiumCalulationVm.data.policyStartDate);
            firstPageDetail.quoteData.premiumCalculation.request.expiryDate = new Date(expiryDate);
            firstPageDetail.quoteData.premiumCalculation.request.planDuration = year.ikey;
            firstPageDetail.quoteData.premiumCalculation.request.suminsured = criticalIlnessPremiumCalulationVm.data.sumInsured;
            firstPageDetail.quoteData.premiumCalculation.request.age = age1;
            firstPageDetail.quoteData.premiumCalculation.request.insuredId = criticalIllness ? criticalIllness.premiumCalculation.policyTerms.insuredId : "";
            firstPageDetail.quoteData.premiumCalculation.request.dob = $filter('dateFormat')(criticalIlnessPremiumCalulationVm.data.Birthday);
            firstPageDetail.quoteData.premiumCalculation.request.gender = criticalIlnessPremiumCalulationVm.data.Gender;
            firstPageDetail.quoteData.premiumCalculation.request.policyCtId = criticalIllness ? criticalIllness.premiumCalculation.policyTerms.policyCtId : "";
            firstPageDetail.quoteData.premiumCalculation.request.ppId = criticalIllness ? criticalIllness.premiumCalculation.policyTerms.ppId : "";
            firstPageDetail.quoteData.premiumCalculation.response = criticalIllness;
            var planDetail = generalInsurenceHomeService.getPlanDetail();
            structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            structure.applicationNumber = generalInsurenceHealthService.getSaveApplicationCriticalResponse() ?  generalInsurenceHealthService.getSaveApplicationCriticalResponse().applicationNumber : "";
            structure.productCode = planDetail.productCode;
            structure.uin = productType;
            structure.planName = planDetail.planName;
            structure.mobileNumber = "";
            structure.quoteData = firstPageDetail.quoteData;

            if(structure.applicationData){
                if(typeof(structure.applicationData)=='object'){
                   structure.applicationData = JSON.stringify(structure.applicationData);
                }
            }
            
            structure.applicationData = structure.applicationData ? structure.applicationData : "";
            var stringified = structure;
            if(typeof(stringified.quoteData)=='object'){
               stringified.quoteData = JSON.stringify(stringified.quoteData);
            }

            generalInsurenceHomeService.setSaveApplicationCriticalStructure(structure);
            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.Critical.CI_PREMIUM_1).then(function(data) {
                generalInsurenceHealthService.setSaveApplicationCriticalResponse(data);
                $state.go("menu.quotesList");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        function getJsonForCI() {
            var criticalIllness = generalInsurenceHealthService.getPremiumcalculationForCriticalIllness();
            var year = generalInsurenceHealthService.getCriticalMasterList().policyTenure[0];
            var age = validateService.calcAge(criticalIlnessPremiumCalulationVm.data.Birthday);
            var age1 = age.toString();
            var expiryDate = calcExpDate(criticalIlnessPremiumCalulationVm.data.policyStartDate, year.ikey);
            var policydetails = {
                "premiumCalculation": {
                    "request": {
                        "quoteNo": criticalIllness ? criticalIllness.premiumCalculation.quoteNumber : "",
                        "policyID": criticalIllness ? criticalIllness.premiumCalculation.policyTerms.policyID : "",
                        "effectiveDate": $filter('startDateWithTimezone')(criticalIlnessPremiumCalulationVm.data.policyStartDate),
                        "expiryDate": $filter('endDateWithTimezone')(expiryDate),
                        "planDuration": year.ikey,
                        "suminsured": $filter('formatAmount')(criticalIlnessPremiumCalulationVm.data.sumInsured.value),
                        "age": age1,
                        "insuredId": criticalIllness ? criticalIllness.premiumCalculation.policyTerms.insuredId : "",
                        "dob": $filter('dateFormat')(criticalIlnessPremiumCalulationVm.data.Birthday),
                        "policyCtId": criticalIllness ? criticalIllness.premiumCalculation.policyTerms.policyCtId : "",
                        "ppId": criticalIllness ? criticalIllness.premiumCalculation.policyTerms.ppId : "",

                    }
                }
            }
             
            generalInsurenceHealthService.getHICriticalIllnessQuote(policydetails).then(function(data) {
                generalInsurenceHealthService.setPremiumcalculationForCriticalIllness(data);
                generalInsurenceHealthService.setHICriticalIllnessQuoteDetail(data);
                generalInsurenceHealthService.setCriticalPrimiumForOffer(data);
                generalInsurenceHomeService.setQuoteListDetails(null);
                saveApplicationCriticalIllness();
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        function goBacktoPrevious() {
            $state.go('menu.recommendedPolicyDetails');
        }


        function goToNextPage() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                var InsureDetail = {
                    "sumInsured": criticalIlnessPremiumCalulationVm.sumInsured,
                    "birthday": criticalIlnessPremiumCalulationVm.Birthday,
                    "startDate": criticalIlnessPremiumCalulationVm.policyMinStartDate,
                    "endDate": criticalIlnessPremiumCalulationVm.policyEndDate,
                    "Gender": criticalIlnessPremiumCalulationVm.Gender
                }
                generalInsurenceHealthService.setCriticalIllnessDetails(criticalIlnessPremiumCalulationVm.data);
                if (productType == '12') {
                    generalInsurenceHealthService.setCriticalillnessFirstPageDetail(InsureDetail);
                    getJsonForCI();
                }

            }
        }

        criticalIlnessPremiumCalulationVm.criticalIllnessForm = {};
        criticalIlnessPremiumCalulationVm.validateService = validateService;
        function validateForm() {
            criticalIlnessPremiumCalulationVm.criticalIllnessForm = {};
            if (criticalIlnessPremiumCalulationVm.validateService.isValidSumInsured(criticalIlnessPremiumCalulationVm.data.sumInsured)) {
                criticalIlnessPremiumCalulationVm.criticalIllnessForm.sumInsured = criticalIlnessPremiumCalulationVm.validateService
                    .isValidSumInsured(criticalIlnessPremiumCalulationVm.data.sumInsured);
            }
            if (criticalIlnessPremiumCalulationVm.validateService.isValidDateGI(criticalIlnessPremiumCalulationVm.data.Birthday,criticalIlnessPremiumCalulationVm.minDOB,criticalIlnessPremiumCalulationVm.maxDOB)) {
                criticalIlnessPremiumCalulationVm.criticalIllnessForm.Birthday = criticalIlnessPremiumCalulationVm.validateService
                    .isValidDateGI(criticalIlnessPremiumCalulationVm.data.Birthday,criticalIlnessPremiumCalulationVm.minDOB,criticalIlnessPremiumCalulationVm.maxDOB);
            }
            if (criticalIlnessPremiumCalulationVm.validateService.isValidDOB(criticalIlnessPremiumCalulationVm.data.Birthday)) {
                criticalIlnessPremiumCalulationVm.criticalIllnessForm.Birthday = criticalIlnessPremiumCalulationVm.validateService
                    .isValidDOB(criticalIlnessPremiumCalulationVm.data.Birthday);
            }
            if (criticalIlnessPremiumCalulationVm.validateService.isValidPolicyStartDate(criticalIlnessPremiumCalulationVm.data.policyStartDate)) {
                criticalIlnessPremiumCalulationVm.criticalIllnessForm.policyStartDate = criticalIlnessPremiumCalulationVm.validateService
                    .isValidPolicyStartDate(criticalIlnessPremiumCalulationVm.data.policyStartDate);
            }
            if (criticalIlnessPremiumCalulationVm.validateService.isValidDateGI(criticalIlnessPremiumCalulationVm.data.policyStartDate,criticalIlnessPremiumCalulationVm.policyMinStartDate,criticalIlnessPremiumCalulationVm.policyMaxStartDate)) {
                criticalIlnessPremiumCalulationVm.criticalIllnessForm.policyStartDate = criticalIlnessPremiumCalulationVm.validateService
                    .isValidDateGI(criticalIlnessPremiumCalulationVm.data.policyStartDate,criticalIlnessPremiumCalulationVm.policyMinStartDate,criticalIlnessPremiumCalulationVm.policyMaxStartDate);
            }
            if (criticalIlnessPremiumCalulationVm.validateService.isValidGender(criticalIlnessPremiumCalulationVm.data.Gender)) {
                criticalIlnessPremiumCalulationVm.criticalIllnessForm.Gender = criticalIlnessPremiumCalulationVm.validateService
                    .isValidGender(criticalIlnessPremiumCalulationVm.data.Gender);
            }
            return (angular.equals({}, criticalIlnessPremiumCalulationVm.criticalIllnessForm)) ? true : false;
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
// })();
