angularApp.controller('healthApplicationHealthInformationController', ["$timeout",
    "$state",
    "$scope", "$ionicPopup", "$filter", "validateService", "generalInsurenceHealthService", "generalInsurenceHomeService", "GIconstant", "utilityService", "$translate","clickStreamService",


    function($timeout,
        $state,
        $scope, $ionicPopup, $filter, validateService, generalInsurenceHealthService, generalInsurenceHomeService, GIconstant, utilityService, $translate,clickStreamService) {

        var healthApplicationHealthInformationVm = this;
        healthApplicationHealthInformationVm.constant = GIconstant;
        healthApplicationHealthInformationVm.healthInformation = {};
        healthApplicationHealthInformationVm.insuranceList = [];
        // healthApplicationHealthInformationVm.healthHabits = {};
        healthApplicationHealthInformationVm.concurrenceInsurance = [0];
        var member, productType;

        function initPage() {
            healthApplicationHealthInformationVm.blockingQuestion = [];
            var yearDiff = validateService.getCurrentDate().getFullYear() - 1999;
            healthApplicationHealthInformationVm.insuredSince = generalInsurenceHomeService.getPreviousYears(yearDiff);

            healthApplicationHealthInformationVm.constant = GIconstant;
            var healthType = generalInsurenceHomeService.getProductDetail().uin;
            if (healthType == healthApplicationHealthInformationVm.constant.Health.arogya) {
                healthApplicationHealthInformationVm.healthtype = $translate.instant('AROGYAPREMIER');
            } else if (healthType == healthApplicationHealthInformationVm.constant.Health.hdc) {
                healthApplicationHealthInformationVm.healthtype = $translate.instant('HOSPITAL_DAILY_CASH');
            } else if (healthType == healthApplicationHealthInformationVm.constant.Health.simple) {
                healthApplicationHealthInformationVm.healthtype = $translate.instant('simpleHealth');
            } else if (healthType == healthApplicationHealthInformationVm.constant.Health.critical) {
                healthApplicationHealthInformationVm.healthtype = $translate.instant('CRITICAL_ILLNESS');
            }

            healthApplicationHealthInformationVm.healthProductName = healthType;



            healthApplicationHealthInformationVm.insuranceList[0] = {};
            healthApplicationHealthInformationVm.showBack = true;
            healthApplicationHealthInformationVm.showNext = true;
            healthApplicationHealthInformationVm.disableBack = false;
            healthApplicationHealthInformationVm.disableNext = false;
            healthApplicationHealthInformationVm.test = true;
            healthApplicationHealthInformationVm.insuranceList.insuredName = {};
            productType = generalInsurenceHomeService.getProductDetail().uin;
            healthApplicationHealthInformationVm.productType = productType;
            healthApplicationHealthInformationVm.memberList = [0];
            if (productType == healthApplicationHealthInformationVm.constant.Health.arogya) {
                healthApplicationHealthInformationVm.productName = healthApplicationHealthInformationVm.constant.Health.arogyaPremium;
            } else if (productType == healthApplicationHealthInformationVm.constant.Health.hdc) {
                healthApplicationHealthInformationVm.productName = healthApplicationHealthInformationVm.constant.Health.hospitaldailycash;
            } else if (productType == healthApplicationHealthInformationVm.constant.Health.simple) {
                healthApplicationHealthInformationVm.productName = healthApplicationHealthInformationVm.constant.Health.simpleHealth;

            }


            if (productType == healthApplicationHealthInformationVm.constant.Health.arogya) {
                healthApplicationHealthInformationVm.companyList = generalInsurenceHealthService.getArogyaMasterList().insuranceComapnyName;
            }

            if (productType == healthApplicationHealthInformationVm.constant.Health.hdc) {
                healthApplicationHealthInformationVm.smokeStatus = generalInsurenceHealthService.getHDCMasterList().smokerStatus;
                healthApplicationHealthInformationVm.policyTypeList = generalInsurenceHealthService.getHDCMasterList().previousOrConcurrent;
                healthApplicationHealthInformationVm.companyList = generalInsurenceHealthService.getHDCMasterList().insuranceComapny;
            } else if (productType == healthApplicationHealthInformationVm.constant.Health.critical) {
                healthApplicationHealthInformationVm.smokeStatus = generalInsurenceHealthService.getCriticalMasterList().smokerStatus;
                healthApplicationHealthInformationVm.policyTypeList = generalInsurenceHealthService.getCriticalMasterList().concurrentHealthPolicies;
                healthApplicationHealthInformationVm.companyList = generalInsurenceHealthService.getCriticalMasterList().insuranceCompanyNames;
            }
            /* Fetch family size from first page  */
            if (productType == healthApplicationHealthInformationVm.constant.Health.critical) {
                member = 1;
            } else if (productType == healthApplicationHealthInformationVm.constant.Health.hdc) {
                member = generalInsurenceHealthService.getHospitalDailyCashDetails().memberCount;
            } else {
                var familySizeList = generalInsurenceHealthService.getbasicHealthDetail();
                member = familySizeList.familySize;
            }

            var insuredDetails = generalInsurenceHealthService.getHealthAdditionalDetails().name;
            var insuredAllDetails = generalInsurenceHealthService.getHealthAdditionalDetails();
            healthApplicationHealthInformationVm.aaa = insuredDetails;

            healthApplicationHealthInformationVm.memeberList = [];
            for (var count = 0; count < member; count++) {
                healthApplicationHealthInformationVm.memeberList.push(count);
                insuredAllDetails[i] = insuredDetails[i] + " " + insuredAllDetails.lastName[i];
            }

            /* set name of insured person  */
            healthApplicationHealthInformationVm.nameList = [];
            for (var i = 0; i < member; i++) {
                healthApplicationHealthInformationVm.insuranceList[i] = {};
                healthApplicationHealthInformationVm.insuranceList[i].insuredName = insuredDetails[i] + " " + insuredAllDetails.lastName[i];
                healthApplicationHealthInformationVm.nameList.push(healthApplicationHealthInformationVm.insuranceList[i].insuredName);
            }
            $timeout(function() {
                var previouspageData = generalInsurenceHealthService.getHealthInformationDetails();
                if (previouspageData) {
                    if(previouspageData && previouspageData[0]){
                        if((healthType == healthApplicationHealthInformationVm.constant.Health.critical || healthType == healthApplicationHealthInformationVm.constant.Health.hdc || healthType == healthApplicationHealthInformationVm.constant.Health.arogya) && previouspageData[0].name){
                            healthApplicationHealthInformationVm.insuranceList = angular.copy(previouspageData);
                        }else if((healthType != healthApplicationHealthInformationVm.constant.Health.critical && healthType != healthApplicationHealthInformationVm.constant.Health.hdc && healthType != healthApplicationHealthInformationVm.constant.Health.arogya) && previouspageData[0].insuredName){
                            healthApplicationHealthInformationVm.insuranceList = angular.copy(previouspageData);
                        }
                    }
                    
                    if(healthApplicationHealthInformationVm.insuranceList){
                        for(var count = 0; count < healthApplicationHealthInformationVm.insuranceList.length; count++){
                                if(healthApplicationHealthInformationVm.insuranceList[count].insureFrom){
                                        healthApplicationHealthInformationVm.checkForPolicyEndDate();
                                         healthApplicationHealthInformationVm.insuranceList = previouspageData;
                                }
                        }

                    }
                    healthApplicationHealthInformationVm.nameList = [];
                    for (var i = 0; i < member; i++) {
                        healthApplicationHealthInformationVm.insuranceList[i].insuredName = insuredDetails[i] + " " + insuredAllDetails.lastName[i];
                        healthApplicationHealthInformationVm.insuranceList[i].name = insuredDetails[i] + " " + insuredAllDetails.lastName[i];
                        healthApplicationHealthInformationVm.nameList.push(healthApplicationHealthInformationVm.insuranceList[i].insuredName);
                    }
                }     
            }, 10);
        }


        healthApplicationHealthInformationVm.deniedbymainQuestion = function() {
            if ((productType == healthApplicationHealthInformationVm.constant.common.criticalIllness && healthApplicationHealthInformationVm.insuranceList[0].tobacco)) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    templateUrl: 'pages/generalInsurance/health/simpleHealthAccidentPopup.html'
                });
                healthApplicationHealthInformationVm.insuranceList[0].tobacco = false;
            }
        }


        healthApplicationHealthInformationVm.deniedbyothercompanyForAlchohal = function(index) {
            if (productType == healthApplicationHealthInformationVm.constant.common.arogysPremier  || productType == healthApplicationHealthInformationVm.constant.common.criticalIllness) {
                if (healthApplicationHealthInformationVm.insuranceList[index].alcohol) {
                    var alertPopup = $ionicPopup.alert({
                        title: '',
                        templateUrl: 'pages/generalInsurance/health/simpleHealthAccidentPopup.html'
                    });
                    healthApplicationHealthInformationVm.insuranceList[index].alcohol = "";
                }
            }
        }

        healthApplicationHealthInformationVm.deniedbyConcurrentInsurance = function(index) {
            if (productType == healthApplicationHealthInformationVm.constant.common.criticalIllness) {
                if (healthApplicationHealthInformationVm.insuranceList[index].insurance) {
                    var alertPopup = $ionicPopup.alert({
                        title: '',
                        templateUrl: 'pages/generalInsurance/health/simpleHealthAccidentPopup.html'
                    });
                    healthApplicationHealthInformationVm.insuranceList[index].claimPolicy = "";
                }
            }
        }

        healthApplicationHealthInformationVm.deniedbyothercompanyForTobacoo = function(index) {
            if (productType == healthApplicationHealthInformationVm.constant.common.criticalIllness) {
                if (healthApplicationHealthInformationVm.insuranceList[index].consumeTobacoo) {
                    var alertPopup = $ionicPopup.alert({
                        title: '',
                        templateUrl: 'pages/generalInsurance/health/simpleHealthAccidentPopup.html'
                    });
                    healthApplicationHealthInformationVm.insuranceList[index].consumeTobacoo = "";
                }

            }
        }

        /* denied by other company   */
        healthApplicationHealthInformationVm.deniedbyothercompany = function() {
            if (productType != healthApplicationHealthInformationVm.constant.Health.hdc) {
                if (healthApplicationHealthInformationVm.insuranceList[0].denied) {
                    var alertPopup = $ionicPopup.alert({
                        title: '',
                        templateUrl: 'pages/generalInsurance/health/simpleHealthAccidentPopup.html'
                    });
                    healthApplicationHealthInformationVm.insuranceList[0].denied = "";
                }
            }
        }

        /* denied for mental desease   */
        healthApplicationHealthInformationVm.deniedMendalDesease = function() {
            if (healthApplicationHealthInformationVm.insuranceList[0].mentaldesease) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    templateUrl: 'pages/generalInsurance/health/simpleHealthAccidentPopup.html'
                });
                healthApplicationHealthInformationVm.insuranceList[0].mentaldesease = "";
            }
        }

        healthApplicationHealthInformationVm.checkSmokeStatus = function(index) {


            if (healthApplicationHealthInformationVm.insuranceList[index].smoke.key == 3) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    templateUrl: 'pages/generalInsurance/health/smokepopup.html'
                });
                healthApplicationHealthInformationVm.insuranceList[index].smoke = "";
                // }
            }

        }

         healthApplicationHealthInformationVm.showPopup = function(value) {
            if(value){
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    templateUrl: 'pages/generalInsurance/health/simpleHealthAccidentPopup.html'
                });
            }
        }


        /* save application for Arogya Premium  */
        function saveApplicationArogya() {
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationArogyaStructure();
            var structure = stringifyStructure1;

            if(typeof(structure.applicationData)=='string'){
                structure.applicationData = JSON.parse(structure.applicationData);
            }
            


            var healthInformation = generalInsurenceHealthService.getSaveApplicationRequestForArogya();
            healthInformation.applicationData.createquoterequest.healthInformation = healthApplicationHealthInformationVm.insuranceList[0].tobacco ? healthApplicationHealthInformationVm.insuranceList[0].tobacco : "false";
            if (healthInformation.applicationData.createquoterequest.healthInformation != "false") {
                for (var count = 0; count < member; count++) {
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count] = {};
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].name = count+""; //healthApplicationHealthInformationVm.insuranceList[count].insuredName;
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].doYouSmoke = healthApplicationHealthInformationVm.insuranceList[count].smoke;
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].doYouConsumeTobacco = healthApplicationHealthInformationVm.insuranceList[count].consumeTobacoo;
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].alcoholStatus = healthApplicationHealthInformationVm.insuranceList[count].alcohol;
                }
            }
            healthInformation.applicationData.createquoterequest.phsicalMentalDiseases = healthApplicationHealthInformationVm.insuranceList[0].mentaldesease ? healthApplicationHealthInformationVm.insuranceList[0].mentaldesease : "false";
            healthInformation.applicationData.createquoterequest.insuranceByOtherComapany = healthApplicationHealthInformationVm.insuranceList[0].denied ? healthApplicationHealthInformationVm.insuranceList[0].denied : "false";
            healthInformation.applicationData.createquoterequest.concurrentInsurance = healthApplicationHealthInformationVm.insuranceList[0].insurance ? healthApplicationHealthInformationVm.insuranceList[0].insurance : "false";

            if (healthInformation.applicationData.createquoterequest.concurrentInsurance != "false") {
                for (var count = 0; count < healthApplicationHealthInformationVm.concurrenceInsurance.length; count++) {
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count] = {};
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredPerson = count+""; //healthApplicationHealthInformationVm.insuranceList[count].name;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredComapny = healthApplicationHealthInformationVm.insuranceList[count].companyName.key;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].sumInsured = $filter('formatAmount')(healthApplicationHealthInformationVm.insuranceList[count].sumInsured);
                }
            }
            structure.applicationData.createquoterequest.healthInformationDetails = [];
            structure.applicationData.createquoterequest.concurrentInsuranceDetails = [];
            structure.applicationData.createquoterequest.healthInformationDetails = healthInformation.applicationData.createquoterequest.healthInformationDetails;
            structure.applicationData.createquoterequest.concurrentInsuranceDetails = healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails;
            structure.applicationData.createquoterequest.healthInformation = JSON.parse(healthInformation.applicationData.createquoterequest.healthInformation);
            structure.applicationData.createquoterequest.phsicalMentalDiseases = JSON.parse(healthInformation.applicationData.createquoterequest.phsicalMentalDiseases);
            structure.applicationData.createquoterequest.insuranceByOtherComapany = JSON.parse(healthInformation.applicationData.createquoterequest.insuranceByOtherComapany);
            structure.applicationData.createquoterequest.concurrentInsurance = JSON.parse(healthInformation.applicationData.createquoterequest.concurrentInsurance);
            structure.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            structure.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";

            var stringified = structure;

             if(typeof(stringified.applicationData)=='object'){
                  stringified.applicationData = JSON.stringify(stringified.applicationData);
             }

             if(typeof(stringified.quoteData)=='object'){
                  stringified.quoteData = JSON.stringify(stringified.quoteData);
             }
            generalInsurenceHomeService.setSaveApplicationArogyaStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified, GIconstant.OmniChannel.Arogya.AP_HEALTH_QA).then(function(data) {
                $state.go("menu.travelNomineeDetails");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);

            });
        }


        /* save application for Critical Illness  */
        function saveApplicationCritical() {
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationCriticalStructure();
            var structure = stringifyStructure1;
            if(typeof(structure.applicationData)=='string'){
                   structure.applicationData = JSON.parse(structure.applicationData);
               }
           


            var healthInformation = generalInsurenceHealthService.getSaveApplicationRequestForCritical();
            healthInformation.applicationData.createquoterequest.healthInformation = healthApplicationHealthInformationVm.insuranceList[0].tobacco ? healthApplicationHealthInformationVm.insuranceList[0].tobacco : "false";
            if (healthInformation.applicationData.createquoterequest.healthInformation != "false") {
                for (var count = 0; count < member; count++) {
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count] = {};
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].name = healthApplicationHealthInformationVm.insuranceList[count].insuredName;
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].doYouSmoke = healthApplicationHealthInformationVm.insuranceList[count].smoke.key;
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].doYouConsumeTobacco = healthApplicationHealthInformationVm.insuranceList[count].consumeTobacoo ? healthApplicationHealthInformationVm.insuranceList[count].consumeTobacoo : "false";
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].alcoholStatus = healthApplicationHealthInformationVm.insuranceList[count].alcohol ? healthApplicationHealthInformationVm.insuranceList[count].alcohol : "false";
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].diabetes = healthApplicationHealthInformationVm.insuranceList[count].diabetes ? healthApplicationHealthInformationVm.insuranceList[count].diabetes : "false";
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].hyperTension = healthApplicationHealthInformationVm.insuranceList[count].hypertension ? healthApplicationHealthInformationVm.insuranceList[count].hypertension : "false";
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].asthama = healthApplicationHealthInformationVm.insuranceList[count].asthama ? healthApplicationHealthInformationVm.insuranceList[count].asthama : "false";
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].impairments = healthApplicationHealthInformationVm.insuranceList[count].otherhabits ? healthApplicationHealthInformationVm.insuranceList[count].otherhabits : "false";
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].otherHabits = healthApplicationHealthInformationVm.insuranceList[count].reason ? healthApplicationHealthInformationVm.insuranceList[count].reason : "false";

                }
            }
            healthInformation.applicationData.createquoterequest.everDeniedPolicy = healthApplicationHealthInformationVm.insuranceList[0].denied ? healthApplicationHealthInformationVm.insuranceList[0].denied : false;
            if (healthInformation.applicationData.createquoterequest.everDeniedPolicy) {
                healthInformation.applicationData.createquoterequest.userName = healthApplicationHealthInformationVm.insuranceList[0].username;
                healthInformation.applicationData.createquoterequest.deniedDetails = healthApplicationHealthInformationVm.insuranceList[0].denialdetails;
            }
            healthInformation.applicationData.createquoterequest.concurrentInsurance = healthApplicationHealthInformationVm.insuranceList[0].insurance ? healthApplicationHealthInformationVm.insuranceList[0].insurance : false;

            if (healthInformation.applicationData.createquoterequest.concurrentInsurance) {
                for (var count = 0; count < healthApplicationHealthInformationVm.concurrenceInsurance.length; count++) {
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count] = {};
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].previousOrCon = healthApplicationHealthInformationVm.insuranceList[count].policyType.key;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredPerson = healthApplicationHealthInformationVm.insuranceList[count].name;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].company = healthApplicationHealthInformationVm.insuranceList[count].companyName.key;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].policyNo = healthApplicationHealthInformationVm.insuranceList[count].policy;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].since = healthApplicationHealthInformationVm.insuranceList[count].insureSince;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].insFrom = new Date(healthApplicationHealthInformationVm.insuranceList[count].insureFrom);
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].insPeriodTo = new Date(healthApplicationHealthInformationVm.insuranceList[count].insureTo);
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].splCondition = healthApplicationHealthInformationVm.insuranceList[count].specialCondition ? healthApplicationHealthInformationVm.insuranceList[count].specialCondition : "false";
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].splConditionDetail = healthApplicationHealthInformationVm.insuranceList[count].conditiondetail;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].claim = healthApplicationHealthInformationVm.insuranceList[count].claimPolicy ? healthApplicationHealthInformationVm.insuranceList[count].claimPolicy : "false";
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].claimReceived = $filter('formatAmount')(healthApplicationHealthInformationVm.insuranceList[count].claimamount);
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].claimDesc = healthApplicationHealthInformationVm.insuranceList[count].claimdetails;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].sumInsured = $filter('formatAmount')(healthApplicationHealthInformationVm.insuranceList[count].sumInsured);

                }
            }
            structure.applicationData.createquoterequest.healthInformationDetails = [];
            structure.applicationData.createquoterequest.concurrentInsuranceDetails = [];
            structure.applicationData.createquoterequest.healthInformationDetails = healthInformation.applicationData.createquoterequest.healthInformationDetails;
            structure.applicationData.createquoterequest.concurrentInsuranceDetails = healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails;
            structure.applicationData.createquoterequest.healthInformation = JSON.parse(healthInformation.applicationData.createquoterequest.healthInformation);
            structure.applicationData.createquoterequest.everDeniedPolicy = JSON.parse(healthInformation.applicationData.createquoterequest.everDeniedPolicy);
            structure.applicationData.createquoterequest.userName = healthInformation.applicationData.createquoterequest.userName;
            structure.applicationData.createquoterequest.deniedDetails = healthInformation.applicationData.createquoterequest.deniedDetails;
            structure.applicationData.createquoterequest.concurrentInsurance = JSON.parse(healthInformation.applicationData.createquoterequest.concurrentInsurance);


            structure.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            structure.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";

            var stringified = structure;
            if(typeof(stringified.applicationData)=='object'){
                  stringified.applicationData = JSON.stringify(stringified.applicationData);
             }
             if(typeof(stringified.quoteData)=='object'){
                  stringified.quoteData = JSON.stringify(stringified.quoteData);
             }

            generalInsurenceHomeService.setSaveApplicationCriticalStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified, GIconstant.OmniChannel.Critical.CI_HEALTH_QA).then(function(data) {
                $state.go("menu.travelNomineeDetails");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);

            });
        }


        /* save application for HDC  */
        function saveApplicationHDC() {
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationHDCStructure();
            var structure = stringifyStructure1;
           if(typeof(structure.applicationData)=='string'){
                   structure.applicationData = JSON.parse(structure.applicationData);
               }


            var healthInformation = generalInsurenceHealthService.getSaveApplicationRequestForHDC();
            healthInformation.applicationData.createquoterequest.healthInformation = healthApplicationHealthInformationVm.insuranceList[0].tobacco ? healthApplicationHealthInformationVm.insuranceList[0].tobacco : "false";
            if (healthInformation.applicationData.createquoterequest.healthInformation != "false") {
                for (var count = 0; count < member; count++) {
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count] = {};
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].name = count+""; //healthApplicationHealthInformationVm.insuranceList[count].insuredName;
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].doYouSmoke = healthApplicationHealthInformationVm.insuranceList[count].smoke.key;
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].doYouConsumeTobacco = healthApplicationHealthInformationVm.insuranceList[count].consumeTobacoo ? healthApplicationHealthInformationVm.insuranceList[count].consumeTobacoo : "false";
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].alcoholStatus = healthApplicationHealthInformationVm.insuranceList[count].alcohol ? healthApplicationHealthInformationVm.insuranceList[count].alcohol : "false";
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].Otherailment = false;
                    healthInformation.applicationData.createquoterequest.healthInformationDetails[count].ailmentDetails = healthApplicationHealthInformationVm.insuranceList[count].AilmentDetails ? healthApplicationHealthInformationVm.insuranceList[count].AilmentDetails : "";

                }
            }
            healthInformation.applicationData.createquoterequest.everDeniedPolicy = healthApplicationHealthInformationVm.insuranceList[0].denied ? healthApplicationHealthInformationVm.insuranceList[0].denied : "false";
            if (healthInformation.applicationData.createquoterequest.everDeniedPolicy != "false") {
                healthInformation.applicationData.createquoterequest.name = healthApplicationHealthInformationVm.insuranceList[0].username;
                healthInformation.applicationData.createquoterequest.deniedDetails = [];
                 healthInformation.applicationData.createquoterequest.deniedDetails[0] = {};
                healthInformation.applicationData.createquoterequest.deniedDetails[0].name = healthApplicationHealthInformationVm.insuranceList[0].username;
                healthInformation.applicationData.createquoterequest.deniedDetails[0].detailsonDenial = healthApplicationHealthInformationVm.insuranceList[0].denialdetails;
            }
            healthInformation.applicationData.createquoterequest.concurrentInsurance = healthApplicationHealthInformationVm.insuranceList[0].insurance ? healthApplicationHealthInformationVm.insuranceList[0].insurance : "false";

            if (healthInformation.applicationData.createquoterequest.concurrentInsurance != "false") {
                for (var count = 0; count < healthApplicationHealthInformationVm.concurrenceInsurance.length; count++) {
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count] = {};
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].previous = healthApplicationHealthInformationVm.insuranceList[count].policyType.key;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredPerson = count+""; //healthApplicationHealthInformationVm.insuranceList[count].name;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredComapny = healthApplicationHealthInformationVm.insuranceList[count].companyName.key;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].policy = healthApplicationHealthInformationVm.insuranceList[count].policy;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredSince = healthApplicationHealthInformationVm.insuranceList[count].insureSince;
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].policyStratDate = new Date(healthApplicationHealthInformationVm.insuranceList[count].insureFrom);
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].policyEndDate = new Date(healthApplicationHealthInformationVm.insuranceList[count].insureTo);
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].claimIfAny = healthApplicationHealthInformationVm.insuranceList[count].claimPolicy ? healthApplicationHealthInformationVm.insuranceList[count].claimPolicy : "false";
                    healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails[count].sumInsured = $filter('formatAmount')(healthApplicationHealthInformationVm.insuranceList[count].sumInsured);

                }
            }
            structure.applicationData.createquoterequest.healthInformationDetails = [];
            structure.applicationData.createquoterequest.concurrentInsuranceDetails = [];
            structure.applicationData.createquoterequest.deniedDetails = [];
            structure.applicationData.createquoterequest.deniedDetails = healthInformation.applicationData.createquoterequest.deniedDetails;
            structure.applicationData.createquoterequest.healthInformationDetails = healthInformation.applicationData.createquoterequest.healthInformationDetails;
            structure.applicationData.createquoterequest.concurrentInsuranceDetails = healthInformation.applicationData.createquoterequest.concurrentInsuranceDetails;
            structure.applicationData.createquoterequest.healthInformation = JSON.parse(healthInformation.applicationData.createquoterequest.healthInformation);
            structure.applicationData.createquoterequest.everDeniedPolicy = JSON.parse(healthInformation.applicationData.createquoterequest.everDeniedPolicy);
            structure.applicationData.createquoterequest.detailsonDenial = healthInformation.applicationData.createquoterequest.detailsonDenial;
            healthInformation.applicationData.createquoterequest.name = healthInformation.applicationData.createquoterequest.name;
            structure.applicationData.createquoterequest.concurrentInsurance = JSON.parse(healthInformation.applicationData.createquoterequest.concurrentInsurance);


            structure.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            structure.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";

            var stringified = structure;
            if(typeof(stringified.applicationData)=='object'){
                  stringified.applicationData = JSON.stringify(stringified.applicationData);
             }
             if(typeof(stringified.quoteData)=='object'){
                  stringified.quoteData = JSON.stringify(stringified.quoteData);
             }
            generalInsurenceHomeService.setSaveApplicationHDCStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.HDC.HDC_HEALTH_QA).then(function(data) {
                $state.go("menu.travelNomineeDetails");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);

            });
        }

        /* Add more concurrent insurance */

        healthApplicationHealthInformationVm.addMembersInfo = function() {
            if (healthApplicationHealthInformationVm.concurrenceInsurance.length < 3) {
                healthApplicationHealthInformationVm.concurrenceInsurance.push(Math.max.apply(null, healthApplicationHealthInformationVm.concurrenceInsurance) + 1);
                healthApplicationHealthInformationVm.concurrenceInsurance[Math.max.apply(null, healthApplicationHealthInformationVm.concurrenceInsurance)] = {};

            }
        }

        healthApplicationHealthInformationVm.deleteMembersInfo = function(index) {
            healthApplicationHealthInformationVm.concurrenceInsurance.splice(index, 1);
        }

        healthApplicationHealthInformationVm.policystart = function() {
            if (healthApplicationHealthInformationVm.insuranceList[0].insurance) {
                var curentDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());
                healthApplicationHealthInformationVm.policyMaxEndDate = generalInsurenceHomeService.getFutureDate(curentDate, -1);
                healthApplicationHealthInformationVm.insuredSinceMaxEndDate = curentDate;
                healthApplicationHealthInformationVm.policyMinstartDate = generalInsurenceHomeService.getFutureYear(curentDate, -3);

            }
        }

        /* calculate policy End Date Limit Based on policy type   */
        healthApplicationHealthInformationVm.checkForPolicyEndDate = function() {
            healthApplicationHealthInformationVm.policyEndMaxEndDate = [];
            healthApplicationHealthInformationVm.policyEndMinStartDate = [];
            healthApplicationHealthInformationVm.defaultPolicyEndDate = [];
            healthApplicationHealthInformationVm.insuredListTo = [];
            var curentDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());
            var healthType = generalInsurenceHomeService.getProductDetail().uin;

            for (var i = 0; i < healthApplicationHealthInformationVm.concurrenceInsurance.length; i++) {
                if (healthApplicationHealthInformationVm.insuranceList[i].policyType.key == 'Previous') {
                    healthApplicationHealthInformationVm.insuranceList[i].insureTo = "";
                    healthApplicationHealthInformationVm.policyEndMaxEndDate[i] = generalInsurenceHomeService.getFutureDate(curentDate, -1);
                    healthApplicationHealthInformationVm.defaultPolicyEndDate[i] = generalInsurenceHomeService.getFutureDate(curentDate, -1);

                } else {
                    healthApplicationHealthInformationVm.insuranceList[i].insureTo = "";
                    healthApplicationHealthInformationVm.policyEndMinStartDate[i] = generalInsurenceHomeService.getFutureDate(curentDate, 1);
                    healthApplicationHealthInformationVm.defaultPolicyEndDate[i] = generalInsurenceHomeService.getFutureDate(curentDate, 1);
                    healthApplicationHealthInformationVm.policyEndMaxEndDate[i] = generalInsurenceHomeService.getFutureDate(curentDate, 46);

                }

                if (healthType == healthApplicationHealthInformationVm.constant.Health.critical || healthType == healthApplicationHealthInformationVm.constant.Health.hdc) {
                    var diff = validateService.calcAge("01 JAN 2000");
                    if (healthApplicationHealthInformationVm.insuranceList[i].policyType.key == 'Previous') {
                        healthApplicationHealthInformationVm.policyMaxEndDate = generalInsurenceHomeService.getFutureDate(curentDate, -1);
                        healthApplicationHealthInformationVm.policyMinstartDate = generalInsurenceHomeService.getFutureYear(curentDate, -diff);
                        healthApplicationHealthInformationVm.policyEndMinStartDate[i] = healthApplicationHealthInformationVm.policyMinstartDate;
                        healthApplicationHealthInformationVm.policyEndMaxEndDate[i] = generalInsurenceHomeService.getFutureDate(curentDate, -1);
                        healthApplicationHealthInformationVm.defaultPolicyEndDate[i] = healthApplicationHealthInformationVm.policyEndMaxEndDate[i];
                    } else {
                        healthApplicationHealthInformationVm.policyMaxEndDate = generalInsurenceHomeService.getFutureDate(curentDate, -1);
                        healthApplicationHealthInformationVm.policyMinstartDate = generalInsurenceHomeService.getFutureYear(curentDate, -diff);
                        healthApplicationHealthInformationVm.policyEndMinStartDate[i] = generalInsurenceHomeService.getFutureDate(curentDate, 1);
                        healthApplicationHealthInformationVm.policyEndMaxEndDate[i] = generalInsurenceHomeService.getFutureYear(curentDate, 4);
                        healthApplicationHealthInformationVm.defaultPolicyEndDate[i] = healthApplicationHealthInformationVm.policyEndMinStartDate[i];
                    }

                }

                if (healthType == healthApplicationHealthInformationVm.constant.Health.hdc) {
                    healthApplicationHealthInformationVm.policyEndMaxEndDate[i] = generalInsurenceHomeService.getFutureYear(healthApplicationHealthInformationVm.insuranceList[i].insureFrom, 1);
                }

                if (healthApplicationHealthInformationVm.insuranceList[i].insureFrom) {
                    for (var count = 1; count <= 3; count++) {
                        var list = generalInsurenceHomeService.getFutureYear(healthApplicationHealthInformationVm.insuranceList[i].insureFrom, count);
                        healthApplicationHealthInformationVm.insuredListTo.push(list);
                    }
                }
            }
        }

        //validation function starts
        healthApplicationHealthInformationVm.healthInformation = {};
        //onkeyup validate fields if required
        healthApplicationHealthInformationVm.validateService = validateService;


        /*  check all field validation  */
        function validateForm() {
            if (productType != healthApplicationHealthInformationVm.constant.Health.arogya) {
                healthApplicationHealthInformationVm.healthApplicationHealthInformationVm = {};

                if (healthApplicationHealthInformationVm.insuranceList[0].tobacco) {
                    for (var i = 0; i < member; i++) {
                        healthApplicationHealthInformationVm.healthInformation[i] = {};
                        if (productType == healthApplicationHealthInformationVm.constant.Health.critical && healthApplicationHealthInformationVm.insuranceList[i].otherhabits) {
                            if (healthApplicationHealthInformationVm.validateService.isValidAilmentDetails(healthApplicationHealthInformationVm.insuranceList[i].reason)) {
                                healthApplicationHealthInformationVm.healthInformation[i].reason = healthApplicationHealthInformationVm.validateService.isValidAilmentDetails(healthApplicationHealthInformationVm.insuranceList[i].reason);
                            }
                        }

                        if (productType == healthApplicationHealthInformationVm.constant.Health.hdc && healthApplicationHealthInformationVm.insuranceList[i].OtherAilment) {


                            if(!healthApplicationHealthInformationVm.blockingQuestion[i]){
                                if (healthApplicationHealthInformationVm.validateService.isValidAilmentDetails(healthApplicationHealthInformationVm.blockingQuestion[i])) {
                                healthApplicationHealthInformationVm.healthInformation[i].AilmentDetails = healthApplicationHealthInformationVm.validateService.isValidAilmentDetails(healthApplicationHealthInformationVm.blockingQuestion[i]);
                               }
                            }else{
                                var QuestionSelected = false;
                                for (var key in healthApplicationHealthInformationVm.blockingQuestion[i]) {
                                    if(healthApplicationHealthInformationVm.blockingQuestion[i][key]){
                                        QuestionSelected = true;
                                        healthApplicationHealthInformationVm.healthInformation[i].AilmentDetails = $translate.instant('ACCIDENTERRORMESSAGE');
                                        break;
                                    }
                                    
                                }
                                if(!QuestionSelected){
                                     healthApplicationHealthInformationVm.healthInformation[i].AilmentDetails = healthApplicationHealthInformationVm.validateService.isValidAilmentDetails(QuestionSelected);
                                }
                            }

                
                            // if (healthApplicationHealthInformationVm.validateService.isValidAilmentDetails(healthApplicationHealthInformationVm.insuranceList[i].AilmentDetails)) {
                            //     healthApplicationHealthInformationVm.healthInformation[i].AilmentDetails = healthApplicationHealthInformationVm.validateService.isValidAilmentDetails(healthApplicationHealthInformationVm.insuranceList[i].AilmentDetails);
                            // }
                        }

                        if (productType == healthApplicationHealthInformationVm.constant.Health.hdc || productType == healthApplicationHealthInformationVm.constant.Health.critical) {
                            if (healthApplicationHealthInformationVm.validateService.isValidSmokeStatus(healthApplicationHealthInformationVm.insuranceList[i].smoke)) {
                                healthApplicationHealthInformationVm.healthInformation[i].smoke = healthApplicationHealthInformationVm.validateService.isValidSmokeStatus(healthApplicationHealthInformationVm.insuranceList[i].smoke);
                            }
                        }
                    }
                    for (var i = 0; i < member; i++) {
                        if (angular.equals({}, healthApplicationHealthInformationVm.healthInformation[i])) {} else {
                            return false;
                        }
                    }
                }

                if (healthApplicationHealthInformationVm.insuranceList[0].denied) {
                    healthApplicationHealthInformationVm.healthInformation = {};
                    if (productType == healthApplicationHealthInformationVm.constant.Health.hdc || productType == healthApplicationHealthInformationVm.constant.Health.critical) {
                        if (healthApplicationHealthInformationVm.validateService.isValidInsuredPerson(healthApplicationHealthInformationVm.insuranceList[0].username)) {
                            healthApplicationHealthInformationVm.healthInformation.username = healthApplicationHealthInformationVm.validateService.isValidInsuredPerson(healthApplicationHealthInformationVm.insuranceList[0].username);

                        }
                        if (healthApplicationHealthInformationVm.validateService.isValidDenialDetail(healthApplicationHealthInformationVm.insuranceList[0].denialdetails)) {
                            healthApplicationHealthInformationVm.healthInformation.denialdetails = healthApplicationHealthInformationVm.validateService.isValidDenialDetail(healthApplicationHealthInformationVm.insuranceList[0].denialdetails);

                        }
                    }
                    if (angular.equals({}, healthApplicationHealthInformationVm.healthInformation)) {} else {
                        return false;
                    }
                }


                if (healthApplicationHealthInformationVm.insuranceList[0].insurance) {
                    for (var i = 0; i < healthApplicationHealthInformationVm.concurrenceInsurance.length; i++) {
                        healthApplicationHealthInformationVm.healthInformation[i] = {};
                        if (healthApplicationHealthInformationVm.validateService.isValidName(healthApplicationHealthInformationVm.insuranceList[i].name)) {
                            healthApplicationHealthInformationVm.healthInformation[i].name = healthApplicationHealthInformationVm.validateService.isValidCompanyName(healthApplicationHealthInformationVm.insuranceList[i].name);
                        }
                        if (healthApplicationHealthInformationVm.validateService.isValidPreviousCurrent(healthApplicationHealthInformationVm.insuranceList[i].policyType)) {
                            healthApplicationHealthInformationVm.healthInformation[i].policyType = healthApplicationHealthInformationVm.validateService.isValidPreviousCurrent(healthApplicationHealthInformationVm.insuranceList[i].policyType);
                        }
                        if (healthApplicationHealthInformationVm.validateService.isValidCompanyName(healthApplicationHealthInformationVm.insuranceList[i].companyName)) {
                            healthApplicationHealthInformationVm.healthInformation[i].companyName = healthApplicationHealthInformationVm.validateService.isValidCompanyName(healthApplicationHealthInformationVm.insuranceList[i].companyName);
                        }
                        if (healthApplicationHealthInformationVm.healthProductName == '12') {
                            if (healthApplicationHealthInformationVm.validateService.isValidPolicyNumber(healthApplicationHealthInformationVm.insuranceList[i].policy)) {
                                healthApplicationHealthInformationVm.healthInformation[i].policy = healthApplicationHealthInformationVm.validateService.isValidPolicyNumber(healthApplicationHealthInformationVm.insuranceList[i].policy);
                            }
                        } else {
                            if (healthApplicationHealthInformationVm.validateService.isValidPolicyType(healthApplicationHealthInformationVm.insuranceList[i].policy)) {
                                healthApplicationHealthInformationVm.healthInformation[i].policy = healthApplicationHealthInformationVm.validateService.isValidPolicyType(healthApplicationHealthInformationVm.insuranceList[i].policy);
                            }
                        }




                        if (healthApplicationHealthInformationVm.validateService.isValidInsuranceInsuredSince(healthApplicationHealthInformationVm.insuranceList[i].insureSince)) {
                            healthApplicationHealthInformationVm.healthInformation[i].insureSince = healthApplicationHealthInformationVm.validateService.isValidInsuranceInsuredSince(healthApplicationHealthInformationVm.insuranceList[i].insureSince);
                        }
                        if (healthApplicationHealthInformationVm.validateService.isValidInsuranceInsuredFrom(healthApplicationHealthInformationVm.insuranceList[i].insureFrom)) {
                            healthApplicationHealthInformationVm.healthInformation[i].insureFrom = healthApplicationHealthInformationVm.validateService.isValidInsuranceInsuredFrom(healthApplicationHealthInformationVm.insuranceList[i].insureFrom);
                        }

                        if (healthApplicationHealthInformationVm.insuranceList[i].policyType) {
                            if (healthApplicationHealthInformationVm.validateService.isValidInsuranceInsuredTo(healthApplicationHealthInformationVm.insuranceList[i].insureTo, healthApplicationHealthInformationVm.insuranceList[i].policyType.key)) {
                                healthApplicationHealthInformationVm.healthInformation[i].insureTo = healthApplicationHealthInformationVm.validateService.isValidInsuranceInsuredTo(healthApplicationHealthInformationVm.insuranceList[i].insureTo, healthApplicationHealthInformationVm.insuranceList[i].policyType.key);
                            }
                        } else {
                            if (healthApplicationHealthInformationVm.validateService.isValidInsuranceInsuredTo(healthApplicationHealthInformationVm.insuranceList[i].insureTo, "")) {
                                healthApplicationHealthInformationVm.healthInformation[i].insureTo = healthApplicationHealthInformationVm.validateService.isValidInsuranceInsuredTo(healthApplicationHealthInformationVm.insuranceList[i].insureTo, "");
                            }
                        }


                        if (healthApplicationHealthInformationVm.validateService.isValidSumInsuredHDC(healthApplicationHealthInformationVm.insuranceList[i].sumInsured)) {
                            healthApplicationHealthInformationVm.healthInformation[i].sumInsured = healthApplicationHealthInformationVm.validateService.isValidSumInsuredHDC(healthApplicationHealthInformationVm.insuranceList[i].sumInsured);
                        }

                    }
                    for (var i = 0; i < healthApplicationHealthInformationVm.concurrenceInsurance.length; i++) {
                        if (angular.equals({}, healthApplicationHealthInformationVm.healthInformation[i])) {} else {
                            return false;
                        }
                    }
                }

                return true;
            } else {
                healthApplicationHealthInformationVm.healthApplicationHealthInformationVm = {};

                if (healthApplicationHealthInformationVm.insuranceList[0].insurance) {
                    for (var i = 0; i < healthApplicationHealthInformationVm.concurrenceInsurance.length; i++) {
                        healthApplicationHealthInformationVm.healthInformation[i] = {};

                        if (healthApplicationHealthInformationVm.validateService.isValidName(healthApplicationHealthInformationVm.insuranceList[i].name)) {
                            healthApplicationHealthInformationVm.healthInformation[i].name = healthApplicationHealthInformationVm.validateService.isValidCompanyName(healthApplicationHealthInformationVm.insuranceList[i].name);
                        }
                        if (healthApplicationHealthInformationVm.validateService.isValidCompanyName(healthApplicationHealthInformationVm.insuranceList[i].companyName)) {
                            healthApplicationHealthInformationVm.healthInformation[i].companyName = healthApplicationHealthInformationVm.validateService.isValidCompanyName(healthApplicationHealthInformationVm.insuranceList[i].companyName);
                        }


                        if (healthApplicationHealthInformationVm.validateService.isValidSumInsured(healthApplicationHealthInformationVm.insuranceList[i].sumInsured)) {
                            healthApplicationHealthInformationVm.healthInformation[i].sumInsured = healthApplicationHealthInformationVm.validateService.isValidSumInsured(healthApplicationHealthInformationVm.insuranceList[i].sumInsured);
                        }
                    }
                    for (var i = 0; i < healthApplicationHealthInformationVm.concurrenceInsurance.length; i++) {
                        if (angular.equals({}, healthApplicationHealthInformationVm.healthInformation[i])) {} else {
                            return false;
                        }
                    }
                }



                healthApplicationHealthInformationVm.selectQuestion = false;


                if (productType == healthApplicationHealthInformationVm.constant.Health.arogya) {
                    if (healthApplicationHealthInformationVm.insuranceList[0].tobacco) {
                        healthApplicationHealthInformationVm.selectQuestion = true;
                        for (var count = 0; count < healthApplicationHealthInformationVm.insuranceList.length; count++) {
                            if (healthApplicationHealthInformationVm.insuranceList[count].consumeTobacoo || healthApplicationHealthInformationVm.insuranceList[count].smoke || healthApplicationHealthInformationVm.insuranceList[count].alcohol) {
                                healthApplicationHealthInformationVm.selectQuestion = false;
                            }
                        }
                    }
                    if (healthApplicationHealthInformationVm.selectQuestion) {
                        return false;
                    }
                }




                return true;

            }
        }


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });
        healthApplicationHealthInformationVm.goBacktoPrevious = function() {
            //To do
            switch (productType) {
                case healthApplicationHealthInformationVm.constant.Health.hdc:
                    $state.go("menu.simpleHealthadditnolDetail");
                    break;
                case healthApplicationHealthInformationVm.constant.Health.arogya:
                    $state.go("menu.simpleHealthadditnolDetail");
                    break;
                case healthApplicationHealthInformationVm.constant.Health.critical:
                    $state.go("menu.simpleHealthadditnolDetail");
                    break;
            }
            // $state.go("menu.healthApplicationNomineeDetails");
        }

        healthApplicationHealthInformationVm.goToNextPage = function() {
            generalInsurenceHealthService.setHealthInformationDetails(healthApplicationHealthInformationVm.insuranceList);
            clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
            if (validateForm()) {
                if (productType == healthApplicationHealthInformationVm.constant.Health.hdc) {
                  
                     saveApplicationHDC();
                } else if (productType == healthApplicationHealthInformationVm.constant.Health.critical) {
                    saveApplicationCritical();
                } else if (productType == healthApplicationHealthInformationVm.constant.Health.arogya) {
                    saveApplicationArogya();

                } else {
                    $state.go("menu.healthPremiumSummary");
                }
            }
        }
    }
]);
