angularApp.controller('healthApplicationPersonalDetailsController', [
    "$state",
    "$scope",
    "$stateParams", "$filter", "validateService", "generalInsurenceHealthService", "generalInsurenceHomeService", "GIconstant", "utilityService","$translate","clickStreamService",

    function(
        $state,
        $scope,
        $stateParams, $filter, validateService, generalInsurenceHealthService, generalInsurenceHomeService, GIconstant, utilityService,$translate,clickStreamService) {

        //variables that can be accessed from the HTML come here
        var healthApplicationPersonalDetailsVm = this;
        healthApplicationPersonalDetailsVm.constant = GIconstant;
        healthApplicationPersonalDetailsVm.showBack = true;
        healthApplicationPersonalDetailsVm.showNext = true;
        healthApplicationPersonalDetailsVm.disableNext = false;
        healthApplicationPersonalDetailsVm.disableback = false;
        healthApplicationPersonalDetailsVm.data = {};
        healthApplicationPersonalDetailsVm.detailsPage = {};

        //functions  that can be accessed from the HTML come here
        healthApplicationPersonalDetailsVm.validateService = validateService;
        healthApplicationPersonalDetailsVm.goBacktoPrevious = goBacktoPrevious;
        healthApplicationPersonalDetailsVm.goToNextPage = goToNextPage;

        var healthType;
        var cbsDataDetail;




        function prefilCBSData(account) {
            if(healthType=='14'){
                account.bankAccountNo='';                
             }
            generalInsurenceHomeService.getSBIBankAccoutDetails(account).then(function(data) {

                if (data) {
                     if(data.cbsData.pinCode.length==6){
                        var detail = {
                        "pinCode": data.cbsData.pinCode
                        }
                         locationDetail(detail);
                     }                  


                    healthApplicationPersonalDetailsVm.data.gender =  data.cbsData.genderCode;

                    


                    // }
                    cbsDataDetail = data.cbsData.genderCode;
                    if( data.cbsData.genderCode=='F'){
                        for(var count =0; count < healthApplicationPersonalDetailsVm.titles.length;count++){
                            if("02" == healthApplicationPersonalDetailsVm.titles[count].cbsKey){
                              healthApplicationPersonalDetailsVm.data.title =   healthApplicationPersonalDetailsVm.titles[count];
                            }
                            
                        }
                        }else{
                            for(var count =0; count < healthApplicationPersonalDetailsVm.titles.length;count++){
                            if("01" == healthApplicationPersonalDetailsVm.titles[count].cbsKey){
                              healthApplicationPersonalDetailsVm.data.title =   healthApplicationPersonalDetailsVm.titles[count];
                            }
                            
                        }

                    }

                     if(!healthApplicationPersonalDetailsVm.data.title){
                                    if( data.cbsData.genderCode=='F'){
                                    for(var count =0; count < healthApplicationPersonalDetailsVm.titles.length;count++){
                                        if("9000000004" == healthApplicationPersonalDetailsVm.titles[count].key){
                                          healthApplicationPersonalDetailsVm.data.title =   healthApplicationPersonalDetailsVm.titles[count];
                                        }
                                        
                                    }
                                    }else{
                                        for(var count =0; count < healthApplicationPersonalDetailsVm.titles.length;count++){
                                        if("9000000001" == healthApplicationPersonalDetailsVm.titles[count].key){
                                          healthApplicationPersonalDetailsVm.data.title =   healthApplicationPersonalDetailsVm.titles[count];
                                        }
                                        
                                    }

                                }


                                }

                   
                    healthApplicationPersonalDetailsVm.data.firstName = data.cbsData.firstName;
                    healthApplicationPersonalDetailsVm.data.gender = data.cbsData.genderCode;
                    healthApplicationPersonalDetailsVm.data.LastName = data.cbsData.lastName;
                    healthApplicationPersonalDetailsVm.data.birthdate = $filter('formatCbsDate')(data.cbsData.dateOfBirth);
                    healthApplicationPersonalDetailsVm.data.plotNo = data.cbsData.addressLine1;
                    healthApplicationPersonalDetailsVm.data.plotNo = healthApplicationPersonalDetailsVm.data.plotNo ? healthApplicationPersonalDetailsVm.data.plotNo.replace(/[^A-Za-z0-9./,-\s]/g, '') : '';
                    healthApplicationPersonalDetailsVm.data.address = data.cbsData.addressLine2;
                    healthApplicationPersonalDetailsVm.data.streetName = data.cbsData.addressLine3;
                    // healthApplicationPersonalDetailsVm.data.city = data.cbsData.city;
                    healthApplicationPersonalDetailsVm.data.pincode = data.cbsData.pinCode;
                    //healthApplicationPersonalDetailsVm.data.location = data.cbsData.firstName;
                    healthApplicationPersonalDetailsVm.data.email = data.cbsData.email1;
                    healthApplicationPersonalDetailsVm.data.mobile = data.cbsData.mobileNumber;



                    generalInsurenceHomeService.setIIBaccountDetail(data);
                    healthApplicationPersonalDetailsVm.detail = data.cbsData;

                }
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //private methods section start
        function initPage() {
            healthApplicationPersonalDetailsVm.readonly = true;
            healthType = generalInsurenceHomeService.getProductDetail().uin;
            if (healthType == healthApplicationPersonalDetailsVm.constant.Health.hdc) {
                healthApplicationPersonalDetailsVm.titles = generalInsurenceHealthService.getHDCMasterList().salutation;
            } else if (healthType == healthApplicationPersonalDetailsVm.constant.Health.arogya) {
                healthApplicationPersonalDetailsVm.titles = generalInsurenceHealthService.getArogyaMasterList().title;
            } else if (healthType == healthApplicationPersonalDetailsVm.constant.Health.critical) {
                healthApplicationPersonalDetailsVm.titles = generalInsurenceHealthService.getCriticalMasterList().proposerTitle;
            } else {
                healthApplicationPersonalDetailsVm.titles = generalInsurenceHealthService.getSimpleMasterList().salutation;
            }

            if (healthType == healthApplicationPersonalDetailsVm.constant.Health.arogya) {
                healthApplicationPersonalDetailsVm.productName = $translate.instant('AROGYAPREMIER');
            } else if (healthType == healthApplicationPersonalDetailsVm.constant.Health.hdc) {
                healthApplicationPersonalDetailsVm.productName = $translate.instant('HOSPITAL_DAILY_CASH');
            } else if (healthType == healthApplicationPersonalDetailsVm.constant.Health.simple) {
                healthApplicationPersonalDetailsVm.productName = $translate.instant('simpleHealth');
            } else if (healthType == healthApplicationPersonalDetailsVm.constant.Health.critical) {
                healthApplicationPersonalDetailsVm.productName =$translate.instant('CRITICAL_ILLNESS');
            }

            healthApplicationPersonalDetailsVm.healthtype = healthType;
            //healthApplicationPersonalDetailsVm.productName = generalInsurenceHomeService.getProductDetail().planName;


            if (!$stateParams.agree) {
                healthApplicationPersonalDetailsVm.data = {};
                healthApplicationPersonalDetailsVm.detailsPage = {};
                //healthApplicationPersonalDetailsVm.readonly = false;
            }

            if (generalInsurenceHealthService.getHealthApplicationPersonalDetails()) {
                healthApplicationPersonalDetailsVm.data = generalInsurenceHealthService.getHealthApplicationPersonalDetails();
                cbsDataDetail = generalInsurenceHealthService.getHealthApplicationPersonalDetails().gender;
                healthApplicationPersonalDetailsVm.detailsPage = {};
            } else {
                if ($stateParams.agree || (healthType == healthApplicationPersonalDetailsVm.constant.Health.simple)) {

                    healthApplicationPersonalDetailsVm.readonly = true;

                    var accountNumber = generalInsurenceHomeService.getaccountDetail();
                    if (accountNumber) {
                        var account = {
                            "bankAccountNo": accountNumber.benAccntNo
                        }
                        prefilCBSData(account)
                    } else {
                        var account = {};
                        generalInsurenceHomeService.getSBIBankAccounts(account).then(function(data) {

                            var account = {
                                "bankAccountNo": data.beneficiaryList.ownAccounts[0].benAccntNo
                            }

                            prefilCBSData(account);

                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });


                    }

                }

            }
            /*else if (!$stateParams.agree) {
                healthApplicationPersonalDetailsVm.data = {};
                healthApplicationPersonalDetailsVm.detailsPage = {};
            }
*/

            if (healthType == healthApplicationPersonalDetailsVm.constant.Health.simple) {
                healthApplicationPersonalDetailsVm.canShowTerms = true;
            }






            

        }

        function locationDetail(detail) {

            generalInsurenceHomeService.getLocation(detail).then(function(dataDetail) {
                generalInsurenceHomeService.setLocationDetails(dataDetail);
                if (dataDetail) {
                    // homeInsuredLocationDetailsVm.detail.state = data.state.value;
                    healthApplicationPersonalDetailsVm.data.city = dataDetail.city.cityName;
                    healthApplicationPersonalDetailsVm.data.locations = dataDetail.location;


                }

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        healthApplicationPersonalDetailsVm.chkforpincode = function() {
            if (healthApplicationPersonalDetailsVm.data.pincode && healthApplicationPersonalDetailsVm.data.pincode.length == 6) {
                var detail = {
                    "pinCode": healthApplicationPersonalDetailsVm.data.pincode
                }
                locationDetail(detail);
            }
        }



        /* save application for simple health  */
        function saveApplicationSH() {
            var structure = generalInsurenceHomeService.getSaveApplicationHealthStructure();
            var personalDetail = generalInsurenceHealthService.getSaveApplicationRequestForSimpleHealth();
            var locationSource = generalInsurenceHomeService.getLocationDetails();
            var createParty = generalInsurenceHealthService.getCreatePartyCI();
            personalDetail.applicationData.createquoterequest.personalDetails = {};
            personalDetail.applicationData.createquoterequest.personalDetails.abbrName = healthApplicationPersonalDetailsVm.data.title;
            personalDetail.applicationData.createquoterequest.personalDetails.firstName = healthApplicationPersonalDetailsVm.data.firstName;
            personalDetail.applicationData.createquoterequest.personalDetails.lastName = healthApplicationPersonalDetailsVm.data.LastName;
            personalDetail.applicationData.createquoterequest.personalDetails.dob = healthApplicationPersonalDetailsVm.data.birthdate;
            personalDetail.applicationData.createquoterequest.personalDetails.emailId = healthApplicationPersonalDetailsVm.data.email;
            personalDetail.applicationData.createquoterequest.personalDetails.mobileNumber = healthApplicationPersonalDetailsVm.data.mobile;
            personalDetail.applicationData.createquoterequest.personalDetails.gender = healthApplicationPersonalDetailsVm.data.gender;
            personalDetail.applicationData.createquoterequest.personalDetails.pincode = healthApplicationPersonalDetailsVm.data.pincode;
            personalDetail.applicationData.createquoterequest.personalDetails.plotNo = healthApplicationPersonalDetailsVm.data.plotNo;
            personalDetail.applicationData.createquoterequest.personalDetails.buildingName = healthApplicationPersonalDetailsVm.data.address;
            personalDetail.applicationData.createquoterequest.personalDetails.streetName = healthApplicationPersonalDetailsVm.data.streetName;
            personalDetail.applicationData.createquoterequest.personalDetails.city = healthApplicationPersonalDetailsVm.data.city;
            personalDetail.applicationData.createquoterequest.personalDetails.locationSource = locationSource;
            personalDetail.applicationData.createquoterequest.personalDetails.location = healthApplicationPersonalDetailsVm.data.location;
            personalDetail.applicationData.partyDetail = createParty.partyCreate;




            structure.applicationData = personalDetail.applicationData;
            structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            var stringified = structure;
             if(typeof(stringified.applicationData)=='object'){
                    stringified.applicationData = JSON.stringify(stringified.applicationData);
            }
           if(typeof(stringified.quoteData)=='object'){
                 stringified.quoteData = JSON.stringify(stringified.quoteData);
           }
                        
            generalInsurenceHomeService.setSaveApplicationHealthStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.SimpleHealth.SH_PROPOSER_DETAILS).then(function(data) {
                $state.go('menu.simpleHealthadditnolDetail');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        /* save application for Arogya Premium  */
        function saveApplicationArogya() {
            var structure = generalInsurenceHomeService.getSaveApplicationArogyaStructure();
            var personalDetail = generalInsurenceHealthService.getSaveApplicationRequestForArogya();
            var locationSource = generalInsurenceHomeService.getLocationDetails();
            var createParty = generalInsurenceHealthService.getCreatePartyCI();
            personalDetail.applicationData.createquoterequest.personalDetails = {};
            personalDetail.applicationData.createquoterequest.personalDetails.abbrName = healthApplicationPersonalDetailsVm.data.title;
            personalDetail.applicationData.createquoterequest.personalDetails.firstName = healthApplicationPersonalDetailsVm.data.firstName;
            personalDetail.applicationData.createquoterequest.personalDetails.lastName = healthApplicationPersonalDetailsVm.data.LastName;
            personalDetail.applicationData.createquoterequest.personalDetails.dob = new Date(healthApplicationPersonalDetailsVm.data.birthdate);
            personalDetail.applicationData.createquoterequest.personalDetails.emailId = healthApplicationPersonalDetailsVm.data.email;
            personalDetail.applicationData.createquoterequest.personalDetails.mobileNumber = healthApplicationPersonalDetailsVm.data.mobile;
            personalDetail.applicationData.createquoterequest.personalDetails.gender = healthApplicationPersonalDetailsVm.data.gender;
            personalDetail.applicationData.createquoterequest.personalDetails.pincode = healthApplicationPersonalDetailsVm.data.pincode;
            personalDetail.applicationData.createquoterequest.personalDetails.plotNo = healthApplicationPersonalDetailsVm.data.plotNo;
            personalDetail.applicationData.createquoterequest.personalDetails.buildingName = healthApplicationPersonalDetailsVm.data.address;
            personalDetail.applicationData.createquoterequest.personalDetails.streetName = healthApplicationPersonalDetailsVm.data.streetName;
            personalDetail.applicationData.createquoterequest.personalDetails.city = healthApplicationPersonalDetailsVm.data.city;
            personalDetail.applicationData.createquoterequest.personalDetails.locationSource = locationSource;
            personalDetail.applicationData.createquoterequest.personalDetails.location = healthApplicationPersonalDetailsVm.data.location;
            personalDetail.applicationData.partyDetail = createParty.partyCreate;




            structure.applicationData = personalDetail.applicationData;
            structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";

            var stringified = structure;
            if(typeof(stringified.applicationData)=='object'){
              stringified.applicationData = JSON.stringify(stringified.applicationData);
           }
           if(typeof(stringified.quoteData)=='object'){
                 stringified.quoteData = JSON.stringify(stringified.quoteData);
           }
           
            generalInsurenceHomeService.setSaveApplicationArogyaStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.Arogya.AP_PROPOSER_DETAILS).then(function(data) {
                $state.go('menu.simpleHealthadditnolDetail');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        /* save application for simple health  */
        function saveApplicationCritical() {
            var structure = generalInsurenceHomeService.getSaveApplicationCriticalStructure();
            var personalDetail = generalInsurenceHealthService.getSaveApplicationRequestForCritical();
            var locationSource = generalInsurenceHomeService.getLocationDetails();
            var createParty = generalInsurenceHealthService.getCreatePartyCI();
            personalDetail.applicationData.createquoterequest.personalDetails = {};
            personalDetail.applicationData.createquoterequest.personalDetails.abbrName = healthApplicationPersonalDetailsVm.data.title;
            personalDetail.applicationData.createquoterequest.personalDetails.firstName = healthApplicationPersonalDetailsVm.data.firstName;
            personalDetail.applicationData.createquoterequest.personalDetails.lastName = healthApplicationPersonalDetailsVm.data.LastName;
            personalDetail.applicationData.createquoterequest.personalDetails.dob = healthApplicationPersonalDetailsVm.data.birthdate;
            personalDetail.applicationData.createquoterequest.personalDetails.emailId = healthApplicationPersonalDetailsVm.data.email;
            personalDetail.applicationData.createquoterequest.personalDetails.mobileNumber = healthApplicationPersonalDetailsVm.data.mobile;
            personalDetail.applicationData.createquoterequest.personalDetails.gender = healthApplicationPersonalDetailsVm.data.gender;
            personalDetail.applicationData.createquoterequest.personalDetails.pincode = healthApplicationPersonalDetailsVm.data.pincode;
            personalDetail.applicationData.createquoterequest.personalDetails.plotNo = healthApplicationPersonalDetailsVm.data.plotNo;
            personalDetail.applicationData.createquoterequest.personalDetails.buildingName = healthApplicationPersonalDetailsVm.data.address;
            personalDetail.applicationData.createquoterequest.personalDetails.streetName = healthApplicationPersonalDetailsVm.data.streetName;
            personalDetail.applicationData.createquoterequest.personalDetails.city = healthApplicationPersonalDetailsVm.data.city;
            personalDetail.applicationData.createquoterequest.personalDetails.locationSource = locationSource;
            personalDetail.applicationData.createquoterequest.personalDetails.location = healthApplicationPersonalDetailsVm.data.location;
            personalDetail.applicationData.partyDetail = createParty.partyCreate;




            structure.applicationData = personalDetail.applicationData;
            var stringified = structure;
            if(typeof(stringified.applicationData)=='object'){
              stringified.applicationData = JSON.stringify(stringified.applicationData);
           }
            if(typeof(stringified.quoteData)=='object'){
                 stringified.quoteData = JSON.stringify(stringified.quoteData);
           }
           
            generalInsurenceHomeService.setSaveApplicationCriticalStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.Critical.CI_PROPOSER_DETAILS).then(function(data) {
                $state.go('menu.simpleHealthadditnolDetail');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        /* save application for simple health  */
        function saveApplicationHDC() {
            var structure = generalInsurenceHomeService.getSaveApplicationHDCStructure();
            var personalDetail = generalInsurenceHealthService.getSaveApplicationRequestForHDC();
            var locationSource = generalInsurenceHomeService.getLocationDetails();
            var createParty = generalInsurenceHealthService.getCreatePartyCI();
            personalDetail.applicationData.createquoterequest.personalDetails = {};
            personalDetail.applicationData.createquoterequest.personalDetails.abbrName = healthApplicationPersonalDetailsVm.data.title;
            personalDetail.applicationData.createquoterequest.personalDetails.firstName = healthApplicationPersonalDetailsVm.data.firstName;
            personalDetail.applicationData.createquoterequest.personalDetails.lastName = healthApplicationPersonalDetailsVm.data.LastName;
            personalDetail.applicationData.createquoterequest.personalDetails.dob = healthApplicationPersonalDetailsVm.data.birthdate;
            personalDetail.applicationData.createquoterequest.personalDetails.emailId = healthApplicationPersonalDetailsVm.data.email;
            personalDetail.applicationData.createquoterequest.personalDetails.mobileNumber = healthApplicationPersonalDetailsVm.data.mobile;
            personalDetail.applicationData.createquoterequest.personalDetails.gender = healthApplicationPersonalDetailsVm.data.gender;
            personalDetail.applicationData.createquoterequest.personalDetails.pincode = healthApplicationPersonalDetailsVm.data.pincode;
            personalDetail.applicationData.createquoterequest.personalDetails.plotNo = healthApplicationPersonalDetailsVm.data.plotNo;
            personalDetail.applicationData.createquoterequest.personalDetails.buildingName = healthApplicationPersonalDetailsVm.data.address;
            personalDetail.applicationData.createquoterequest.personalDetails.streetName = healthApplicationPersonalDetailsVm.data.streetName;
            personalDetail.applicationData.createquoterequest.personalDetails.city = healthApplicationPersonalDetailsVm.data.city;
            personalDetail.applicationData.createquoterequest.personalDetails.locationSource = locationSource;
            personalDetail.applicationData.createquoterequest.personalDetails.location = healthApplicationPersonalDetailsVm.data.location;
            personalDetail.applicationData.partyDetail = createParty.partyCreate;




            structure.applicationData = personalDetail.applicationData;
            structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
            var stringified = structure;
            if(typeof(stringified.applicationData)=='object'){
             stringified.applicationData = JSON.stringify(stringified.applicationData);
           }
           if(typeof(stringified.quoteData)=='object'){
                 stringified.quoteData = JSON.stringify(stringified.quoteData);
           }
            generalInsurenceHomeService.setSaveApplicationHDCStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.HDC.HDC_PROPOSER_DETAILS).then(function(data) {
                $state.go('menu.simpleHealthadditnolDetail');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }





        //validation for for,

        function validateForm() {
            healthApplicationPersonalDetailsVm.detailsPage = {};
            if (healthApplicationPersonalDetailsVm.validateService.isValidTitle(healthApplicationPersonalDetailsVm.data.title)) {
                healthApplicationPersonalDetailsVm.detailsPage.title = healthApplicationPersonalDetailsVm.validateService.isValidTitle(healthApplicationPersonalDetailsVm.data.title);
            }
            if (healthApplicationPersonalDetailsVm.validateService.isValidFirstName(healthApplicationPersonalDetailsVm.data.firstName)) {
                healthApplicationPersonalDetailsVm.detailsPage.firstName = healthApplicationPersonalDetailsVm.validateService.isValidFirstName(healthApplicationPersonalDetailsVm.data.firstName);
            }
            if (healthApplicationPersonalDetailsVm.validateService.isValidLastNameGI(healthApplicationPersonalDetailsVm.data.LastName,true)) {
                healthApplicationPersonalDetailsVm.detailsPage.LastName = healthApplicationPersonalDetailsVm.validateService.isValidLastNameGI(healthApplicationPersonalDetailsVm.data.LastName,true);
            }


            if (healthApplicationPersonalDetailsVm.validateService.isValidbirthDate(healthApplicationPersonalDetailsVm.data.birthdate)) {
                healthApplicationPersonalDetailsVm.detailsPage.birthdate = healthApplicationPersonalDetailsVm.validateService.isValidbirthDate(healthApplicationPersonalDetailsVm.data.birthdate);
            }

            if (healthApplicationPersonalDetailsVm.validateService.isValidPlotNo(healthApplicationPersonalDetailsVm.data.plotNo)) {
                healthApplicationPersonalDetailsVm.detailsPage.plotNo = healthApplicationPersonalDetailsVm.validateService.isValidPlotNo(healthApplicationPersonalDetailsVm.data.plotNo);
            }

            if (healthApplicationPersonalDetailsVm.validateService.isValidAdress(healthApplicationPersonalDetailsVm.data.address)) {
                healthApplicationPersonalDetailsVm.detailsPage.address = healthApplicationPersonalDetailsVm.validateService.isValidAdress(healthApplicationPersonalDetailsVm.data.address);
            }

            if (healthApplicationPersonalDetailsVm.validateService.isValidStreet(healthApplicationPersonalDetailsVm.data.streetName)) {
                healthApplicationPersonalDetailsVm.detailsPage.streetName = healthApplicationPersonalDetailsVm.validateService.isValidStreet(healthApplicationPersonalDetailsVm.data.streetName);
            }

            if (healthApplicationPersonalDetailsVm.validateService.isValidCity(healthApplicationPersonalDetailsVm.data.city)) {
                healthApplicationPersonalDetailsVm.detailsPage.city = healthApplicationPersonalDetailsVm.validateService.isValidCity(healthApplicationPersonalDetailsVm.data.city);
            }

            if (healthApplicationPersonalDetailsVm.validateService.isValidPincode(healthApplicationPersonalDetailsVm.data.pincode)) {
                healthApplicationPersonalDetailsVm.detailsPage.pincode = healthApplicationPersonalDetailsVm.validateService.isValidPincode(healthApplicationPersonalDetailsVm.data.pincode);
            }
            if (healthApplicationPersonalDetailsVm.validateService.isValidLocatiom(healthApplicationPersonalDetailsVm.data.location)) {
                healthApplicationPersonalDetailsVm.detailsPage.location = healthApplicationPersonalDetailsVm.validateService.isValidLocatiom(healthApplicationPersonalDetailsVm.data.location);
            }


            if (healthApplicationPersonalDetailsVm.validateService.isValidPhoneNo(healthApplicationPersonalDetailsVm.data.mobile)) {
                healthApplicationPersonalDetailsVm.detailsPage.mobile = healthApplicationPersonalDetailsVm.validateService.isValidPhoneNo(healthApplicationPersonalDetailsVm.data.mobile);
            }

            if (healthApplicationPersonalDetailsVm.validateService.isValidEmail((healthApplicationPersonalDetailsVm.data.email).trim())) {
                healthApplicationPersonalDetailsVm.detailsPage.email = healthApplicationPersonalDetailsVm.validateService.isValidEmail((healthApplicationPersonalDetailsVm.data.email).trim());
            }

            return (angular.equals({}, healthApplicationPersonalDetailsVm.detailsPage)) ? true : false;
        }


        function createPartyIdJson() {
            var locationDetail = generalInsurenceHomeService.getLocationDetails();
            // "dob": healthApplicationPersonalDetailsVm.data.birthdate,
            var personalDetail = {
                "partyCreate": {
                    "salutation": healthApplicationPersonalDetailsVm.data.title.pkey,
                    "firstName": healthApplicationPersonalDetailsVm.data.firstName,
                    "middleName": "",
                    "lastName": healthApplicationPersonalDetailsVm.data.LastName,
                    "dob": $filter('dateFormat')(healthApplicationPersonalDetailsVm.data.birthdate),
                    "gender": healthApplicationPersonalDetailsVm.data.gender,
                    "emailID": healthApplicationPersonalDetailsVm.data.email,
                    "mobile": healthApplicationPersonalDetailsVm.data.mobile,
                    "plotNo": healthApplicationPersonalDetailsVm.data.plotNo,
                    "buildingName": healthApplicationPersonalDetailsVm.data.address,
                    "streetName": healthApplicationPersonalDetailsVm.data.streetName,
                    "cityName": locationDetail.city.cityCode,
                    "stateName": locationDetail.state.key,
                    "pinCode": healthApplicationPersonalDetailsVm.data.location.pinId,
                    //"pinCode": "576106",
                    "districtName": locationDetail.district.districtCode,
                    "locality": healthApplicationPersonalDetailsVm.data.location.loc,
                    "addressType": "CurrentAddress",
                    "partyRole": "Policy Holder",
                    "maritalStatus":"",
                    "occupation":""
                }
            }
            generalInsurenceHomeService.getPartyCreation(personalDetail).then(function(data) {
                generalInsurenceHealthService.setCreatePartyCI(data);

                switch (healthType) {
                    case healthApplicationPersonalDetailsVm.constant.Health.arogya:
                        saveApplicationArogya();
                        break;
                    case healthApplicationPersonalDetailsVm.constant.Health.simple:
                        saveApplicationSH();
                        break;
                    case healthApplicationPersonalDetailsVm.constant.Health.critical:
                        saveApplicationCritical();
                        break;
                    case healthApplicationPersonalDetailsVm.constant.Health.hdc:
                        saveApplicationHDC();
                        break;
                }


            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


      

        //private methods section end simpleHealthadditnolDetail
        function goBacktoPrevious() {

            switch (healthType) {
                case healthApplicationPersonalDetailsVm.constant.Health.hdc:
                    $state.go("menu.paymentAccountDetails");
                    break;
                case healthApplicationPersonalDetailsVm.constant.Health.arogya:
                    generalInsurenceHealthService.setHealthApplicationPersonalDetails(null);
                    $state.go("menu.paymentAccountDetails");
                    break;
                case healthApplicationPersonalDetailsVm.constant.Health.critical:
                    $state.go("menu.paymentAccountDetails");
                    break;
                case healthApplicationPersonalDetailsVm.constant.Health.simple:
                    $state.go("menu.healthPremiumSummary");
                    break;
            }
        }


        function goToNextPage() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                healthApplicationPersonalDetailsVm.data.gender = cbsDataDetail;
                generalInsurenceHealthService.setHealthApplicationPersonalDetails(healthApplicationPersonalDetailsVm.data);
                switch (healthType) {
                    case healthApplicationPersonalDetailsVm.constant.Health.arogya:
                        createPartyIdJson();

                        break;
                    case healthApplicationPersonalDetailsVm.constant.Health.simple:
                        createPartyIdJson();
                        break;
                    case healthApplicationPersonalDetailsVm.constant.Health.critical:
                        createPartyIdJson();
                        break;
                    case healthApplicationPersonalDetailsVm.constant.Health.hdc:
                        createPartyIdJson();
                        break;
                }
            }
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {

        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {

            //any cleanup needs to be done here: executes everytime when page is left
        });
    }
]);
