angularApp.controller('healthInsureDetailController', ["$timeout","$state", "$scope", "$translate", "validateService", "$filter", "generalInsurenceHealthService", "generalInsurenceHomeService", "GIconstant", "utilityService","clickStreamService",
        function($timeout,$state, $scope, $translate, validateService, $filter, generalInsurenceHealthService, generalInsurenceHomeService, GIconstant, utilityService,clickStreamService) {

            //functions, variables that can be accessed from the HTML come here
            var healthInsureDetailVm = this;
            healthInsureDetailVm.constant = GIconstant;
            //healthInsureDetailVm.productType = healthInsureDetailVm.constant.Health.productTypeFamilyFloater;
            healthInsureDetailVm.healthInfo = {};
            healthInsureDetailVm.validateService = validateService;
            healthInsureDetailVm.showBack = true;
            healthInsureDetailVm.showNext = true;
            healthInsureDetailVm.data = {};
            healthInsureDetailVm.data.Birthdate = [];
            healthInsureDetailVm.data.SumInsured = [];
            healthInsureDetailVm.data.Relationship = [];
            healthInsureDetailVm.birthdateEndLimit = [];
            healthInsureDetailVm.birthdateStartLimit = [];
            healthInsureDetailVm.member = {};
            var healthType, healthquotePageDetail;
            var healthInformation = [];
            healthInsureDetailVm.data.totalSumInsured = {};

            function initPage() {
                healthType = generalInsurenceHomeService.getProductDetail().uin;
                healthInsureDetailVm.healthType = healthType;
                healthInsureDetailVm.data.uin = healthType;
                healthquotePageDetail = generalInsurenceHealthService.getbasicHealthDetail();
                healthInsureDetailVm.productType = healthquotePageDetail.productTypes;
                healthInsureDetailVm.member = healthquotePageDetail.familySize;
                var policyStartDate = healthquotePageDetail.startDate;

                if (healthType == healthInsureDetailVm.constant.Health.arogya) {
                    healthInsureDetailVm.productName = healthInsureDetailVm.constant.Health.arogyaPremium;
                } else if (healthType == healthInsureDetailVm.constant.Health.hdc) {
                    healthInsureDetailVm.productName = healthInsureDetailVm.constant.Health.hospitaldailycash;
                } else if (healthType == healthInsureDetailVm.constant.Health.simple) {
                    healthInsureDetailVm.productName = healthInsureDetailVm.constant.Health.simpleHealth;

                }

                /* back button handle */
                setTimeout(function() {
                    var previouspageData = generalInsurenceHealthService.getHealthInsureDetails();
                    if (previouspageData) {
                        var totalFamilySize = generalInsurenceHealthService.getbasicHealthDetail().familySize;
                        if (previouspageData.uin == healthType && totalFamilySize == previouspageData.Birthdate.length) {
                            healthInsureDetailVm.data = previouspageData;
                        } else {
                            healthInsureDetailVm.data.Birthdate = [];
                            healthInsureDetailVm.data.SumInsured = [];
                            healthInsureDetailVm.data.Relationship = [];
                        }
                    }else{
                         healthInsureDetailVm.data.Birthdate = [];
                         healthInsureDetailVm.data.SumInsured = [];
                         healthInsureDetailVm.data.Relationship = [];
                    }

                    /*  get relationship from master */
                    if (healthType == healthInsureDetailVm.constant.Health.arogya) {
                        if (healthquotePageDetail.productTypes.key == "1") {
                            healthInsureDetailVm.AllRelationship = generalInsurenceHealthService.getArogyaMasterList().realtionWithproposer;
                        } else if (healthquotePageDetail.productTypes.key == "2") {
                            healthInsureDetailVm.AllRelationship = generalInsurenceHealthService.getArogyaMasterList().individualFamilyRelation;
                        } else if (healthquotePageDetail.productTypes.key == "3") {
                            healthInsureDetailVm.AllRelationship = generalInsurenceHealthService.getArogyaMasterList().familyFloaterRelation;
                        }

                        healthInsureDetailVm.sumInsuredList = generalInsurenceHealthService.getArogyaMasterList().variantSumInsured;
                    } else {
                        healthInsureDetailVm.AllRelationship = generalInsurenceHealthService.getSimpleMasterList().relation;
                        healthInsureDetailVm.sumInsuredList = generalInsurenceHealthService.getSimpleMasterList().sumInsured;

                        
                    }
                    healthInsureDetailVm.data.Relationship[0] = healthInsureDetailVm.AllRelationship[0];
                    if(healthInsureDetailVm.data.Relationship[0].key.toString() == "1"){
                        healthInsureDetailVm.checkForAge(healthInsureDetailVm.data.Relationship[0],0);
                        healthInsureDetailVm.birthdateEndLimit[0] = generalInsurenceHomeService.getFutureYear(validateService.getCurrentDate(), healthInsureDetailVm.constant.Health.birthdateEndLimit);
                    }
                }, 10);

                var basicDetail = generalInsurenceHealthService.getbasicHealthDetail();
                healthInsureDetailVm.memeberList = [];
                for (var count = 0; count < healthInsureDetailVm.member; count++) {
                    healthInsureDetailVm.memeberList.push(count);
                    if (healthType == healthInsureDetailVm.constant.Health.arogya) {
                        healthInsureDetailVm.birthdateStartLimit[count] = generalInsurenceHomeService.getFutureYear(policyStartDate, -56);
                        healthInsureDetailVm.birthdateStartLimit[count] = generalInsurenceHomeService.getFutureDate(healthInsureDetailVm.birthdateStartLimit[count], 2);
                        healthInsureDetailVm.birthdateEndLimit[count] = generalInsurenceHomeService.getFutureMonth(policyStartDate, healthInsureDetailVm.constant.Arogya.birthdateEndLimitMonth);
                    } else {
                        if (count == 0) {
                            healthInsureDetailVm.birthdateStartLimit[count] = generalInsurenceHomeService.getFutureYear(policyStartDate, healthInsureDetailVm.constant.Health.birthdateStartLimit);
                            healthInsureDetailVm.birthdateEndLimit[count] = generalInsurenceHomeService.getFutureYear(policyStartDate, healthInsureDetailVm.constant.Health.birthdateEndLimit);

                        } else {
                            healthInsureDetailVm.birthdateStartLimit[count] = generalInsurenceHomeService.getFutureYear(policyStartDate, healthInsureDetailVm.constant.Health.birthdateStartLimit);
                            healthInsureDetailVm.birthdateEndLimit[count] = generalInsurenceHomeService.getFutureMonth(policyStartDate, healthInsureDetailVm.constant.Health.birthdateEndLimitMonth);
                        }
                    }
                }
            }

            healthInsureDetailVm.checkForCashLimit = function(data, index) {
                $timeout(function() {
                    if (healthType == healthInsureDetailVm.constant.Health.simple) {
                        healthInsureDetailVm.healthInfo.SumInsured = {};
                        if (healthInsureDetailVm.data.SumInsured[index].key > healthInsureDetailVm.data.SumInsured[0].key) {
                            healthInsureDetailVm.data.SumInsured[index] = {};
                            healthInsureDetailVm.healthInfo.SumInsured[index] = 'Sum insured cannot be more than primary insured cash limit';
                            healthInsureDetailVm.data.SumInsured[index].value = "";
                        }
                    }else if(healthType == healthInsureDetailVm.constant.Health.arogya){
                        if(healthInsureDetailVm.data.Relationship[0].key.toString() == "1"){
                            healthInsureDetailVm.healthInfo.SumInsured = {};
                            if (healthInsureDetailVm.data.SumInsured[index].key > healthInsureDetailVm.data.SumInsured[0].key) {
                                healthInsureDetailVm.data.SumInsured[index] = {};
                                healthInsureDetailVm.healthInfo.SumInsured[index] = $translate.instant('Arogya_Dependent_SI');
                                //healthInsureDetailVm.data.SumInsured[index].value = "";
                            } 
                        }
                    }
                }, 100);
                
            }

            healthInsureDetailVm.checkForAge = function(data, index) {
                healthInsureDetailVm.healthInfo = {};
                healthInsureDetailVm.healthInfo.Birthdate = {};
                if (healthType == healthInsureDetailVm.constant.Health.simple || healthType == healthInsureDetailVm.constant.Health.arogya) {
                    if (data.key == healthInsureDetailVm.constant.Health.ageRelationshipSon || data.key == healthInsureDetailVm.constant.Health.ageRelationshipDaughter) {
						if(healthType == healthInsureDetailVm.constant.Health.arogya){
                            healthInsureDetailVm.birthdateStartLimit[index] = generalInsurenceHomeService.getFutureYear(generalInsurenceHomeService.getCurrentDate(), -18);
							healthInsureDetailVm.birthdateStartLimit[index] = generalInsurenceHomeService.getFutureDate(healthInsureDetailVm.birthdateStartLimit[index], 2);
                        }else{
							   healthInsureDetailVm.birthdateStartLimit[index] = generalInsurenceHomeService.getFutureYear(generalInsurenceHomeService.getCurrentDate(), healthInsureDetailVm.constant.Health.minorBirthdateStartLimit);
						}

                        healthInsureDetailVm.birthdateEndLimit[index] = generalInsurenceHomeService.getFutureMonth(generalInsurenceHomeService.getCurrentDate(), healthInsureDetailVm.constant.Health.birthdateEndLimitMonth);
                        //healthInsureDetailVm.data.Birthdate[index] = "";
                    } else {
                        if(healthType == healthInsureDetailVm.constant.Health.arogya){
                            healthInsureDetailVm.birthdateStartLimit[index] = generalInsurenceHomeService.getFutureYear(generalInsurenceHomeService.getCurrentDate(), -56);
                            healthInsureDetailVm.birthdateStartLimit[index] = generalInsurenceHomeService.getFutureDate(healthInsureDetailVm.birthdateStartLimit[index], 2);
                        }else{
                            healthInsureDetailVm.birthdateStartLimit[index] = generalInsurenceHomeService.getFutureYear(generalInsurenceHomeService.getCurrentDate(), -65);
                        }
                        healthInsureDetailVm.birthdateEndLimit[index] = generalInsurenceHomeService.getFutureYear(generalInsurenceHomeService.getCurrentDate(), -18);
                        if (new Date(healthInsureDetailVm.data.Birthdate[index]) > new Date(healthInsureDetailVm.birthdateEndLimit[index])) {
                            healthInsureDetailVm.data.Birthdate[index] = "";
                            healthInsureDetailVm.healthInfo.Birthdate[index] = "Minimum age limit is 18 years";
                        }
                    }
                }
            }

            function calcExpDate(startYear, totalYear) {
                var year = parseInt(totalYear);
                var endYear = generalInsurenceHomeService.getFutureYear(startYear, year);
                return endYear;
            }

            function validateForm() {

                healthInsureDetailVm.healthInfo = {};
                healthInsureDetailVm.healthInfo.Birthdate = {};
                healthInsureDetailVm.healthInfo.SumInsured = {};
                healthInsureDetailVm.healthInfo.Relationship = {};

                for (var count = 0; count < healthInsureDetailVm.member; count++) {
                    if (healthInsureDetailVm.validateService.isValidbirthDate(healthInsureDetailVm.data.Birthdate[count])) {
                        healthInsureDetailVm.healthInfo.Birthdate[count] = healthInsureDetailVm.validateService.isValidbirthDate(healthInsureDetailVm.data.Birthdate[count]);
                    }
                     if (healthInsureDetailVm.validateService.isValidDateGI(healthInsureDetailVm.data.Birthdate[count],healthInsureDetailVm.birthdateStartLimit[count],healthInsureDetailVm.birthdateEndLimit[count])) {
                        healthInsureDetailVm.healthInfo.Birthdate[count] = healthInsureDetailVm.validateService.isValidDateGI(healthInsureDetailVm.data.Birthdate[count],healthInsureDetailVm.birthdateStartLimit[count],healthInsureDetailVm.birthdateEndLimit[count]);
                    }

                    if (healthInsureDetailVm.productType.key != healthInsureDetailVm.constant.Health.productTypeFamilyFloater || count == 0) {
                        if (healthInsureDetailVm.validateService.isValidSumInsured(healthInsureDetailVm.data.SumInsured[count])) {
                            healthInsureDetailVm.healthInfo.SumInsured[count] = healthInsureDetailVm.validateService.isValidSumInsured(healthInsureDetailVm.data.SumInsured[count]);
                        }

                        

                    }
                    if (healthInsureDetailVm.validateService.isValidRelationship(healthInsureDetailVm.data.Relationship[count])) {
                        healthInsureDetailVm.healthInfo.Relationship[count] = healthInsureDetailVm.validateService.isValidRelationship(healthInsureDetailVm.data.Relationship[count]);
                    }
                }
                if (healthType == healthInsureDetailVm.constant.Health.simple){
                         healthInsureDetailVm.data.noOfAdults = 0;
                         healthInsureDetailVm.data.noOfChilds = 0;
                         for (var count = 0; count < healthInsureDetailVm.member; count++) {
                        
                            if(validateService.calcAge(healthInsureDetailVm.data.Birthdate[count]) >= 18){
                                healthInsureDetailVm.data.noOfAdults++;
                            }else{
                                healthInsureDetailVm.data.noOfChilds++;
                            }
                       
                        }
                    if((healthInsureDetailVm.data.noOfAdults >2)  || (healthInsureDetailVm.data.noOfChilds >2)){
                        for (var count = 0; count < healthInsureDetailVm.member; count++) {
                            healthInsureDetailVm.healthInfo.Birthdate[count] = $translate.instant('MaxAdults');
                            if(count > 0){
                                healthInsureDetailVm.data.Birthdate[count] = "";
                            }
                        }
                    }
                }
                return (((angular.equals({}, healthInsureDetailVm.healthInfo.Birthdate)) ? true : false) && ((angular.equals({}, healthInsureDetailVm.healthInfo.SumInsured)) ? true : false) && ((angular.equals({}, healthInsureDetailVm.healthInfo.Relationship)) ? true : false));
            }


            /* save application for simple health  */
            function saveApplicationSH() {
                var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationHealthStructure();
                var structure = stringifyStructure1;
                var firstPageDetail = {};
                if(typeof(structure.quoteData)=='string'){
                        structure.quoteData = JSON.parse(structure.quoteData);
                   }
               
                firstPageDetail.quoteData = structure.quoteData;
               
                var premiumDetail = generalInsurenceHealthService.getPremiumcalculationForSimpleHealth();
                firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.planDuration = "1";
                firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.quoteNo = premiumDetail.premiumCalculation.quoteNumber;
                firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.policyID = premiumDetail.premiumCalculation.policyTerms.policyID;
                firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.ppId = premiumDetail.premiumCalculation.policyTerms.ppId;
                for (var count = 0; count < healthInsureDetailVm.member; count++) {
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count] = {};
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count].dob = new Date(healthInsureDetailVm.data.Birthdate[count]);
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count].age = healthInformation[count].age;
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count].relationship = healthInsureDetailVm.data.Relationship[count];
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count].insuredId = healthInformation[count].insuredId;
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count].coverTypeName = healthInformation[count].coverTypeName;
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count].policyCtId = healthInformation[count].policyCtId;
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count].sumInsured =  healthInsureDetailVm.data.SumInsured[count] ? healthInsureDetailVm.data.SumInsured[count].key : "";
                }
                firstPageDetail.quoteData.premiumCalculation.response = premiumDetail;

                
                structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
               structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";

                structure.quoteData = firstPageDetail.quoteData;
                structure.applicationData = "";
                var stringified = structure;
                if(typeof(stringified.quoteData)=='object'){
                   stringified.quoteData = JSON.stringify(stringified.quoteData);
                }
                generalInsurenceHomeService.setSaveApplicationHealthStructure(structure);

                generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.SimpleHealth.SH_PREMIUM_2).then(function(data) {
                    $state.go("menu.healthPremiumSummary");
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }



            /* save application for Arogya Premium  */
            function saveApplicationArogya() {
                var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationArogyaStructure();
                var structure = stringifyStructure1;
                 if(typeof(structure.quoteData)=='string'){
                     structure.quoteData = JSON.parse(structure.quoteData);
                 }
                
               

                var firstPageDetail = generalInsurenceHealthService.getSaveQuoteRequestForArogya();
                var premiumDetail = generalInsurenceHealthService.getPremiumcalculationForArogyaPremium();
                var applicationNo = generalInsurenceHealthService.getSaveApplicationArogyaResponse();
                var pagedetail = "Arogya Premier";
                firstPageDetail.quoteData = structure.quoteData;
                firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.planDuration = "1";
                firstPageDetail.quoteData.premiumCalculation.request.primarySumInsured = $filter('formatAmount')(healthInsureDetailVm.data.SumInsured[0]);
                for (var count = 0; count < healthInsureDetailVm.member; count++) {
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count] = {};
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count].dob = new Date(healthInsureDetailVm.data.Birthdate[count]);
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count].relationship = healthInsureDetailVm.data.Relationship[count];
                    firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[count].sumInsured = healthInsureDetailVm.data.SumInsured[count] ? healthInsureDetailVm.data.SumInsured[count].value : "";
                }
                firstPageDetail.quoteData.premiumCalculation.response = premiumDetail;
                // structure.quoteData.premiumCalculation.request.insuredDetails = [];
                structure.applicationNumber = applicationNo.applicationNumber;
                // structure.quoteData.premiumCalculation.request.quoteDetails.planDuration = firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.planDuration;
                // structure.quoteData.premiumCalculation.request.insuredDetails = firstPageDetail.quoteData.premiumCalculation.request.insuredDetails;
                structure.applicationData = "";
                structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
                structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";

                structure.quoteData = firstPageDetail.quoteData;
                var stringified = structure;
                if(typeof(stringified.quoteData)=='object'){
                   stringified.quoteData = JSON.stringify(stringified.quoteData);
               }
                generalInsurenceHomeService.setSaveApplicationArogyaStructure(structure);

                generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.Arogya.AP_PREMIUM_2).then(function(data) {
                    $state.go("menu.quotesList", { pages: pagedetail });
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }




                /* Premium Calculation for Simple Health  */
            function getJsonforSH() {
                var simpleHealthPremium = generalInsurenceHealthService.getPremiumcalculationForSimpleHealth();
                healthInformation = [];
                for (var i = 0; i < healthquotePageDetail.familySize; i++) {
                    healthInformation[i] = {}
                    var age = validateService.calcAge(healthInsureDetailVm.data.Birthdate[i]);
                    healthInformation[i].dob = $filter('dateFormat')(healthInsureDetailVm.data.Birthdate[i]);
                    healthInformation[i].age = age.toString();
                    healthInformation[i].realtionship = healthInsureDetailVm.data.Relationship[i].key;
                    if(simpleHealthPremium && healthquotePageDetail.familySize == simpleHealthPremium.premiumCalculation.insuredDetails.length){
                        healthInformation[i].insuredId = simpleHealthPremium ? simpleHealthPremium.premiumCalculation.insuredDetails[i].insuredId : "";
                        healthInformation[i].coverTypeName = simpleHealthPremium ? simpleHealthPremium.premiumCalculation.insuredDetails[i].coverTypeName : "";
                        healthInformation[i].policyCtId = simpleHealthPremium ? simpleHealthPremium.premiumCalculation.insuredDetails[i].policyCtId : "";
                    }else{
                        healthInformation[i].insuredId =  "";
                        healthInformation[i].coverTypeName = "";
                        healthInformation[i].policyCtId =  "";
                        simpleHealthPremium = null;
                    }
                    
                    if (i == 0 || healthquotePageDetail.productTypes.key != "3") {
                        healthInformation[i].sumInsured = $filter('formatAmount')(healthInsureDetailVm.data.SumInsured[i].value);
                    } else {
                        healthInformation[i].sumInsured = "";
                    }
                }
                var policydetails = {
                    "premiumCalculation": {
                        "quoteDetails": {
                            "quoteNo": simpleHealthPremium ? simpleHealthPremium.premiumCalculation.quoteNumber : "",
                            "policyID": simpleHealthPremium ? simpleHealthPremium.premiumCalculation.policyTerms.policyID : "",
                            "productType": healthquotePageDetail.productTypes.key,
                            "familysize": healthquotePageDetail.familySize.toString(),
                            "effectiveDate": $filter('startDateWithTimezone')(healthquotePageDetail.startDate),
                            "expiryDate": $filter('endDateWithTimezone')(healthquotePageDetail.policyEndDate),
                            "planDuration": "1",
                            // "insuredId": simpleHealthPremium ? simpleHealthPremium.premiumCalculation.policyTerms.insuredId : "",
                            // "name": "kiran",
                            // "policyCtId": simpleHealthPremium ? simpleHealthPremium.premiumCalculation.policyTerms.policyCtId : "",
                            "ppId": simpleHealthPremium ? simpleHealthPremium.premiumCalculation.policyTerms.ppId : "",
                            "adultCount" : healthInsureDetailVm.data.noOfAdults,
                            "childCount" : healthInsureDetailVm.data.noOfChilds
                        },
                        "insuredDetails": healthInformation
                    }
                }

                
                generalInsurenceHealthService.getSimpleHealthPremium(policydetails).then(function(data) {
                    generalInsurenceHealthService.setPremiumcalculationForSimpleHealth(data);
                    saveApplicationSH();
                    // $state.go("menu.healthPremiumSummary");

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }


             /* Premium Calculation for Arogya Premium  */
            function getJsonForArogya() {
                var pagedetail = "Arogya Premier";
                var year = generalInsurenceHealthService.getArogyaMasterList().policyTenure[0];
                var arogyaPremium = generalInsurenceHealthService.getPremiumcalculationForArogyaPremium();
                healthInformation = [];
                for (var i = 0; i < healthquotePageDetail.familySize; i++) {
                    healthInformation[i] = {}
                    var age = validateService.calcAge(healthInsureDetailVm.data.Birthdate[i]);
                    healthInformation[i].dob = $filter('dateFormat')(healthInsureDetailVm.data.Birthdate[i]);
                    healthInformation[i].age = age.toString();
                    healthInformation[i].realtionship = healthInsureDetailVm.data.Relationship[i].key.toString();
                    if(arogyaPremium && arogyaPremium.premiumCalculation && healthquotePageDetail.familySize == arogyaPremium.premiumCalculation.insuredDetails.length){
                         healthInformation[i].insuredId = arogyaPremium ? arogyaPremium.premiumCalculation.insuredDetails[i].insuredId : "";
                         healthInformation[i].coverTypeName = arogyaPremium ? arogyaPremium.premiumCalculation.insuredDetails[i].insuredName : "";
                         healthInformation[i].policyCtId = arogyaPremium ? arogyaPremium.premiumCalculation.insuredDetails[i].policyCtId : "";
                    }else{
                        arogyaPremium = null;
                         healthInformation[i].insuredId = "";
                       healthInformation[i].coverTypeName = "";
                       healthInformation[i].policyCtId = "";
                    }
                   
                    if (i == 0 || healthquotePageDetail.productTypes.key != "3") {
                        healthInformation[i].sumInsured = healthInsureDetailVm.data.SumInsured[i].value.toString();
                    } else {
                        healthInformation[i].sumInsured = healthInsureDetailVm.data.SumInsured[0].value.toString();
                    }
                }
                var expiryDate = calcExpDate(healthquotePageDetail.startDate, year.key);
                var policydetails = {
                    "premiumCalculation": {
                        "quoteDetails": {
                            "quoteNo": arogyaPremium ? arogyaPremium.premiumCalculation.quoteNumber : "",
                            "policyID": arogyaPremium ? arogyaPremium.premiumCalculation.policyTerms.policyID : "",
                            "productType": healthquotePageDetail.productTypes.key,
                            "familysize": healthquotePageDetail.familySize.toString(),
                            "effectiveDate": $filter('startDateWithTimezone')(healthquotePageDetail.startDate),
                            "expiryDate": $filter('endDateWithTimezone')(expiryDate),
                            "planDuration": year.key,
                            // "insuredId": arogyaPremium ? arogyaPremium.premiumCalculation.policyTerms.insuredId : "",
                            "name": "",
                            // "policyCtId": arogyaPremium ? arogyaPremium.premiumCalculation.policyTerms.policyCtId : "",
                            "ppId": arogyaPremium ? arogyaPremium.premiumCalculation.policyTerms.ppId : ""
                        },
                        "insuredDetails": healthInformation
                    }
                }

                generalInsurenceHealthService.getHIArogyaQuote(policydetails).then(function(data) {
                    generalInsurenceHealthService.setPremiumcalculationForArogyaPremium(data);
                    generalInsurenceHealthService.setArogyaPrimiumForOffer(data);
                    generalInsurenceHomeService.setQuoteListDetails(null);
                    saveApplicationArogya();

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

            healthInsureDetailVm.goToNextPage = function() {
                var pagedetail = "Arogya Premier";
               
                

                if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                healthInsureDetailVm.data.totalSumInsured = angular.copy(healthInsureDetailVm.data.SumInsured[0]);
                if(healthquotePageDetail.productTypes.key == "2"){
                    for (var count = 1; count < healthInsureDetailVm.member; count++) {
                        healthInsureDetailVm.data.totalSumInsured.value += healthInsureDetailVm.data.SumInsured[count].value;
                    }
                }
                
                    generalInsurenceHealthService.setHealthInsureDetails(healthInsureDetailVm.data);
                    switch (healthType) {
                        case healthInsureDetailVm.constant.Health.simple:
                            var detailData = {
                                "nameList": generalInsurenceHealthService.getbasicHealthDetail(),
                                "MemberDetail": healthInsureDetailVm.data
                            }
                            generalInsurenceHealthService.getQuoutforsimpleHealth(detailData);
                            getJsonforSH();

                            break;
                        case healthInsureDetailVm.constant.Health.arogya:
                            getJsonForArogya();

                            break;
                        case healthInsureDetailVm.constant.Health.critical:
                            $state.go("menu.quotesList", { pages: pagedetail });
                            break;
                    }
                }
            }

            healthInsureDetailVm.goBacktoPrevious = function() {
                    $state.go("menu.simpleHealthPremiumCalulation");
                }
                //actions to done everytime the view is shown
            $scope.$on('$ionicView.beforeEnter', function() {
                initPage();
            });
        }
    ]);
// })();
