angularApp.controller('simplePreExistingDeseaseController', [
    "$state",
    "$scope",
    "$translate", "generalInsurenceHealthService", "$filter", "validateService", "generalInsurenceHomeService", "utilityService","GIconstant","clickStreamService",

    function(
        $state,
        $scope,
        $translate, generalInsurenceHealthService, $filter, validateService, generalInsurenceHomeService, utilityService,GIconstant,clickStreamService) {

        var simplePreExistingDeseaseVm = this;


        var productType, member;
        simplePreExistingDeseaseVm.data = [];
        simplePreExistingDeseaseVm.insuranceList = [];
        simplePreExistingDeseaseVm.concurrenceInsurance = [];
        simplePreExistingDeseaseVm.memeberList = [];

        function initPage() {

            simplePreExistingDeseaseVm.healthtype = generalInsurenceHomeService.getProductDetail().planName;

              simplePreExistingDeseaseVm.constant = GIconstant;
              var  healthType = generalInsurenceHomeService.getProductDetail().uin;
             if (healthType == simplePreExistingDeseaseVm.constant.Health.arogya) {
                simplePreExistingDeseaseVm.healthtype = $translate.instant('AROGYAPREMIER');
            } else if (healthType == simplePreExistingDeseaseVm.constant.Health.hdc) {
                simplePreExistingDeseaseVm.healthtype = $translate.instant('HOSPITAL_DAILY_CASH');
            } else if (healthType == simplePreExistingDeseaseVm.constant.Health.simple) {
                simplePreExistingDeseaseVm.healthtype = $translate.instant('simpleHealth');
            } else if (healthType == simplePreExistingDeseaseVm.constant.Health.critical) {
                simplePreExistingDeseaseVm.healthtype =$translate.instant('CRITICAL_ILLNESS');
            }



            simplePreExistingDeseaseVm.showBack = true;
            simplePreExistingDeseaseVm.showNext = true;
            simplePreExistingDeseaseVm.disableBack = false;
            simplePreExistingDeseaseVm.disableNext = false;
            simplePreExistingDeseaseVm.preexistingdesease = false;
            simplePreExistingDeseaseVm.otherHealthCover = false;
            productType = generalInsurenceHomeService.getProductDetail().uin;
            simplePreExistingDeseaseVm.productType = productType;
            member = generalInsurenceHealthService.getbasicHealthDetail().familySize;
            simplePreExistingDeseaseVm.member = member;
            var insuredDetails = [];
            insuredDetails = generalInsurenceHealthService.getHealthAdditionalDetails();

            simplePreExistingDeseaseVm.companyList = generalInsurenceHealthService.getSimpleMasterList().insuranceComapnyName;
            simplePreExistingDeseaseVm.policyTypeList = generalInsurenceHealthService.getSimpleMasterList().concurrentHealthPolicies;
            // generalInsurenceHealthService.getPolicyStatus(function(response) {
            //     simplePreExistingDeseaseVm.policyTypeList = response.data.policyTypeList;
            // });

            /* set name of insured person  */
            simplePreExistingDeseaseVm.nameList = [];
            for (var i = 0; i < member; i++) {
                simplePreExistingDeseaseVm.insuranceList[i] = {};
                simplePreExistingDeseaseVm.insuranceList[i].name = insuredDetails[i];
                simplePreExistingDeseaseVm.nameList.push(simplePreExistingDeseaseVm.insuranceList[i].name +" "+simplePreExistingDeseaseVm.insuranceList[i].lastName);
            }



            var currentDate = generalInsurenceHomeService.getCurrentDate();
            simplePreExistingDeseaseVm.minstartDate = generalInsurenceHomeService.getFutureDate(currentDate, -1);
            simplePreExistingDeseaseVm.DefaultDate  = generalInsurenceHomeService.getFutureDate(currentDate, -1); 


            /* set name of insured person  */
            simplePreExistingDeseaseVm.nameList = [];   
            for (var i = 0; i < member; i++) {
                simplePreExistingDeseaseVm.data[i] = {};
                simplePreExistingDeseaseVm.data[i].insuredName = insuredDetails.name[i] +" " + insuredDetails.lastName[i];
                simplePreExistingDeseaseVm.nameList.push(simplePreExistingDeseaseVm.data[i].insuredName);
            }

            simplePreExistingDeseaseVm.insuranceList[0] = {};

            var preexistingDesis =  generalInsurenceHealthService.getpreExistingDesease();
            if(preexistingDesis){
                simplePreExistingDeseaseVm.data = preexistingDesis.data;
                simplePreExistingDeseaseVm.insuranceList = preexistingDesis.insuranceList;
                simplePreExistingDeseaseVm.chkForExistingDesease();
                simplePreExistingDeseaseVm.chkForConcurrentInsurance();
                for (var count =0; count < simplePreExistingDeseaseVm.insuranceList.length; count++){
                    if(simplePreExistingDeseaseVm.insuranceList[count].policyType && simplePreExistingDeseaseVm.insuranceList[count].insureFrom){
                        simplePreExistingDeseaseVm.checkForPolicyEndDate();
                    }
                }
                simplePreExistingDeseaseVm.insuranceList = preexistingDesis.insuranceList;
                
            }

            var yearDiff = validateService.getCurrentDate().getFullYear() - 1999;     
            simplePreExistingDeseaseVm.insuredListSince = generalInsurenceHomeService.getPreviousYears(yearDiff);

        }

        simplePreExistingDeseaseVm.chkForExistingDesease = function() {
            if (simplePreExistingDeseaseVm.data[0].preexistingdesease) {
                simplePreExistingDeseaseVm.memeberList = [0];
            } else {
                simplePreExistingDeseaseVm.memeberList = []
            }
        }
        simplePreExistingDeseaseVm.chkForConcurrentInsurance = function() {
            if (simplePreExistingDeseaseVm.insuranceList[0].otherHealthCover) {
                simplePreExistingDeseaseVm.concurrenceInsurance = [0];
                var curentDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());
                simplePreExistingDeseaseVm.policyMaxEndDate = curentDate;
                simplePreExistingDeseaseVm.insuredSinceMaxEndDate = curentDate;
                simplePreExistingDeseaseVm.policyMinstartDate = generalInsurenceHomeService.getFutureYear(curentDate, -3);
            } else {
                simplePreExistingDeseaseVm.concurrenceInsurance = []
            }
        }


        /* calculate policy End Date Limit Based on policy type   */
        simplePreExistingDeseaseVm.checkForPolicyEndDate = function() {
            simplePreExistingDeseaseVm.policyEndMaxEndDate = [];
            simplePreExistingDeseaseVm.policyEndMinStartDate = [];
            simplePreExistingDeseaseVm.defaultPolicyEndDate = [];
            simplePreExistingDeseaseVm.insuredListTo = [];
            var curentDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());

            for (var i = 0; i < simplePreExistingDeseaseVm.concurrenceInsurance.length; i++) {
                /*if (simplePreExistingDeseaseVm.insuranceList[i].policyType.key == 'Previous') {
                    simplePreExistingDeseaseVm.insuranceList[i].insureTo = "";
                    simplePreExistingDeseaseVm.policyEndMaxEndDate[i] = generalInsurenceHomeService.getFutureDate(curentDate, -1);
                    simplePreExistingDeseaseVm.defaultPolicyEndDate[i] = generalInsurenceHomeService.getFutureDate(curentDate, -1);
                    simplePreExistingDeseaseVm.policyMaxEndDate = generalInsurenceHomeService.getFutureDate(curentDate, -1);
                    simplePreExistingDeseaseVm.insureFrom = generalInsurenceHomeService.getFutureDate(curentDate, -1);

                } else {
                    simplePreExistingDeseaseVm.insuranceList[i].insureTo = "";
                    simplePreExistingDeseaseVm.policyEndMinStartDate[i] = generalInsurenceHomeService.getFutureDate(curentDate, 1);
                    simplePreExistingDeseaseVm.defaultPolicyEndDate[i] = generalInsurenceHomeService.getFutureDate(curentDate, 1);

                }*/

                if(simplePreExistingDeseaseVm.insuranceList[i].insureFrom){
                    for(var count = 1; count <= 3;count++){
                        var list  = generalInsurenceHomeService.getFutureYear(simplePreExistingDeseaseVm.insuranceList[i].insureFrom, count);
                        simplePreExistingDeseaseVm.insuredListTo.push(list);
                    }               
                }
            }
        }


        /* Add more concurrent insurance */

        simplePreExistingDeseaseVm.addMembersInfo = function() {
            if (simplePreExistingDeseaseVm.concurrenceInsurance.length < 3) {
                simplePreExistingDeseaseVm.concurrenceInsurance.push(Math.max.apply(null, simplePreExistingDeseaseVm.concurrenceInsurance) + 1);
                simplePreExistingDeseaseVm.insuranceList[Math.max.apply(null, simplePreExistingDeseaseVm.concurrenceInsurance)] = {};
            }
        }

        simplePreExistingDeseaseVm.deleteMembersInfo = function(index) {
            simplePreExistingDeseaseVm.concurrenceInsurance.splice(index, 1);
        }

        /* Add more concurrent insurance */

        simplePreExistingDeseaseVm.addMemberDeseaseInfo = function() {
            if (simplePreExistingDeseaseVm.memeberList.length < member) {
                simplePreExistingDeseaseVm.memeberList.push(Math.max.apply(null, simplePreExistingDeseaseVm.memeberList) + 1);
                simplePreExistingDeseaseVm.insuranceList[Math.max.apply(null, simplePreExistingDeseaseVm.memeberList)] = {};
            }
        }

        simplePreExistingDeseaseVm.deleteMemberDeseaseInfo = function(index) {
            simplePreExistingDeseaseVm.memeberList.splice(index, 1);
        }

        /* save application for simple health  */
        function saveApplicationSH() {
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationHealthStructure();
            var structure = stringifyStructure1;

            if(typeof(structure.applicationData)=='string'){
               structure.applicationData = JSON.parse(structure.applicationData);
            }


            var preExistingDesease = generalInsurenceHealthService.getSaveApplicationRequestForSimpleHealth();
            preExistingDesease.applicationData.createquoterequest.preExistingDisease = simplePreExistingDeseaseVm.data[0].preexistingdesease ? simplePreExistingDeseaseVm.data[0].preexistingdesease : "false";
            if (preExistingDesease.applicationData.createquoterequest.preExistingDisease) {
                for (var count = 0; count < simplePreExistingDeseaseVm.memeberList.length; count++) {
                    preExistingDesease.applicationData.createquoterequest.preexistingDiseaseDetails[count] = {};
                    preExistingDesease.applicationData.createquoterequest.preexistingDiseaseDetails[count].insuredPerson = simplePreExistingDeseaseVm.data[count].insuredName;
                    preExistingDesease.applicationData.createquoterequest.preexistingDiseaseDetails[count].DiseaseName = simplePreExistingDeseaseVm.data[count].deseaseName;
                    preExistingDesease.applicationData.createquoterequest.preexistingDiseaseDetails[count].treatmentDetails = simplePreExistingDeseaseVm.data[count].treatmentDetail;
                    preExistingDesease.applicationData.createquoterequest.preexistingDiseaseDetails[count].dateFirstTreated = new Date(simplePreExistingDeseaseVm.data[count].startDate);
                    preExistingDesease.applicationData.createquoterequest.preexistingDiseaseDetails[count].currentStatus = simplePreExistingDeseaseVm.data[count].currentStatus;

                }
            }

            preExistingDesease.applicationData.createquoterequest.concurrentInsurance = simplePreExistingDeseaseVm.insuranceList[0].otherHealthCover ? simplePreExistingDeseaseVm.insuranceList[0].otherHealthCover : "false";
            if (preExistingDesease.applicationData.createquoterequest.concurrentInsurance) {
                for (var count = 0; count < simplePreExistingDeseaseVm.concurrenceInsurance.length; count++) {
                    preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails[count] = {};
                    preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredPerson = simplePreExistingDeseaseVm.insuranceList[count].name;
                    preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails[count].previous = simplePreExistingDeseaseVm.insuranceList[count].policyType.key;
                    preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredComapny = simplePreExistingDeseaseVm.insuranceList[count].companyName.key;
                    preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails[count].policy = simplePreExistingDeseaseVm.insuranceList[count].policy;
                    preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails[count].policyStratDate = new Date(simplePreExistingDeseaseVm.insuranceList[count].insureFrom);
                    preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails[count].policyEndDate = new Date(simplePreExistingDeseaseVm.insuranceList[count].insureTo);
                    preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails[count].insuredSince = simplePreExistingDeseaseVm.insuranceList[count].insureSince;
                    preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails[count].sumInsured = $filter('formatAmount')(simplePreExistingDeseaseVm.insuranceList[count].sumInsured);
                    preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails[count].specialCondition = simplePreExistingDeseaseVm.insuranceList[count].specialCondition ? simplePreExistingDeseaseVm.insuranceList[count].specialCondition : "false";
                    preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails[count].specialConditionDetails = simplePreExistingDeseaseVm.insuranceList[count].conditiondetail ? simplePreExistingDeseaseVm.insuranceList[count].conditiondetail : "";
                    preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails[count].claimIfAny = simplePreExistingDeseaseVm.insuranceList[count].claimPolicy ? simplePreExistingDeseaseVm.insuranceList[count].claimPolicy : "";
                }
            }

            structure.applicationData.createquoterequest.preexistingDiseaseDetails = [];
            structure.applicationData.createquoterequest.concurrentInsuranceDetails = [];
            structure.applicationData.createquoterequest.preExistingDisease = JSON.parse(preExistingDesease.applicationData.createquoterequest.preExistingDisease);
            structure.applicationData.createquoterequest.concurrentInsurance = JSON.parse(preExistingDesease.applicationData.createquoterequest.concurrentInsurance);
            structure.applicationData.createquoterequest.preexistingDiseaseDetails = preExistingDesease.applicationData.createquoterequest.preexistingDiseaseDetails;
            structure.applicationData.createquoterequest.concurrentInsuranceDetails = preExistingDesease.applicationData.createquoterequest.concurrentInsuranceDetails;
            structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";


            var stringified = structure;
            if(typeof(stringified.applicationData)=='object'){
               stringified.applicationData = JSON.stringify(stringified.applicationData);
            }
            if(typeof(stringified.quoteData)=='object'){
               stringified.quoteData = JSON.stringify(stringified.quoteData);
            }
            generalInsurenceHomeService.setSaveApplicationHealthStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.SimpleHealth.SH_HEALTH_QA).then(function(data) {
                $state.go("menu.travelNomineeDetails");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);

            });
        }


        //validation function starts
        simplePreExistingDeseaseVm.preExistingDesease = {};
        //onkeyup validate fields if required
        simplePreExistingDeseaseVm.validateService = validateService;


        /*  check all field validation  */
        function validateForm() {
            simplePreExistingDeseaseVm.preExistingDesease = {};
            if (simplePreExistingDeseaseVm.data[0].preexistingdesease) {
                for (var i = 0; i < simplePreExistingDeseaseVm.memeberList.length; i++) {
                    simplePreExistingDeseaseVm.preExistingDesease[i] = {};
                    if (simplePreExistingDeseaseVm.validateService.isValidDesease(simplePreExistingDeseaseVm.data[i].deseaseName)) {
                        simplePreExistingDeseaseVm.preExistingDesease[i].deseaseName = simplePreExistingDeseaseVm.validateService.isValidDesease(simplePreExistingDeseaseVm.data[i].deseaseName);
                    }
                    if (simplePreExistingDeseaseVm.validateService.isValidTreatmentDetail(simplePreExistingDeseaseVm.data[i].treatmentDetail)) {
                        simplePreExistingDeseaseVm.preExistingDesease[i].treatmentDetail = simplePreExistingDeseaseVm.validateService.isValidTreatmentDetail(simplePreExistingDeseaseVm.data[i].treatmentDetail);
                    }
                    if (simplePreExistingDeseaseVm.validateService.isValidTreatmentStartDate(simplePreExistingDeseaseVm.data[i].startDate)) {
                        simplePreExistingDeseaseVm.preExistingDesease[i].startDate = simplePreExistingDeseaseVm.validateService.isValidTreatmentStartDate(simplePreExistingDeseaseVm.data[i].startDate);
                    }
                    if (simplePreExistingDeseaseVm.validateService.isValidCurrentStatus(simplePreExistingDeseaseVm.data[i].currentStatus)) {
                        simplePreExistingDeseaseVm.preExistingDesease[i].currentStatus = simplePreExistingDeseaseVm.validateService.isValidCurrentStatus(simplePreExistingDeseaseVm.data[i].currentStatus);
                    }
                }
            }
            if (simplePreExistingDeseaseVm.insuranceList[0].otherHealthCover) {
                for (var i = 0; i < simplePreExistingDeseaseVm.concurrenceInsurance.length; i++) {
                    simplePreExistingDeseaseVm.preExistingDesease[i] = {};

                    if (simplePreExistingDeseaseVm.validateService.isValidName(simplePreExistingDeseaseVm.insuranceList[i].name)) {
                        simplePreExistingDeseaseVm.preExistingDesease[i].name = simplePreExistingDeseaseVm.validateService.isValidCompanyName(simplePreExistingDeseaseVm.insuranceList[i].name);
                    }
                    if (simplePreExistingDeseaseVm.validateService.isValidPreviousCurrent(simplePreExistingDeseaseVm.insuranceList[i].policyType)) {
                        simplePreExistingDeseaseVm.preExistingDesease[i].policyType = simplePreExistingDeseaseVm.validateService.isValidPreviousCurrent(simplePreExistingDeseaseVm.insuranceList[i].policyType);
                    }
                    if (simplePreExistingDeseaseVm.validateService.isValidCompanyName(simplePreExistingDeseaseVm.insuranceList[i].companyName)) {
                        simplePreExistingDeseaseVm.preExistingDesease[i].companyName = simplePreExistingDeseaseVm.validateService.isValidCompanyName(simplePreExistingDeseaseVm.insuranceList[i].companyName);
                    }
                    if (simplePreExistingDeseaseVm.validateService.isValidPolicyNumber(simplePreExistingDeseaseVm.insuranceList[i].policy)) {
                        simplePreExistingDeseaseVm.preExistingDesease[i].policy = simplePreExistingDeseaseVm.validateService.isValidPolicyNumber(simplePreExistingDeseaseVm.insuranceList[i].policy);
                    }
                    if (simplePreExistingDeseaseVm.validateService.isValidInsuranceInsuredSince(simplePreExistingDeseaseVm.insuranceList[i].insureSince)) {
                        simplePreExistingDeseaseVm.preExistingDesease[i].insureSince = simplePreExistingDeseaseVm.validateService.isValidInsuranceInsuredSince(simplePreExistingDeseaseVm.insuranceList[i].insureSince);
                    }
                    if (simplePreExistingDeseaseVm.validateService.isValidInsuranceInsuredFrom(simplePreExistingDeseaseVm.insuranceList[i].insureFrom)) {
                        simplePreExistingDeseaseVm.preExistingDesease[i].insureFrom = simplePreExistingDeseaseVm.validateService.isValidInsuranceInsuredFrom(simplePreExistingDeseaseVm.insuranceList[i].insureFrom);
                    }
                    if(simplePreExistingDeseaseVm.insuranceList[i].policyType){
                        if (simplePreExistingDeseaseVm.validateService.isValidInsuranceInsuredTo(simplePreExistingDeseaseVm.insuranceList[i].insureTo,simplePreExistingDeseaseVm.insuranceList[i].policyType.key)) {
                            simplePreExistingDeseaseVm.preExistingDesease[i].insureTo = simplePreExistingDeseaseVm.validateService.isValidInsuranceInsuredTo(simplePreExistingDeseaseVm.insuranceList[i].insureTo,simplePreExistingDeseaseVm.insuranceList[i].policyType.key);
                        }
                    }else{
                        if (simplePreExistingDeseaseVm.validateService.isValidInsuranceInsuredTo(simplePreExistingDeseaseVm.insuranceList[i].insureTo,"")) {
                            simplePreExistingDeseaseVm.preExistingDesease[i].insureTo = simplePreExistingDeseaseVm.validateService.isValidInsuranceInsuredTo(simplePreExistingDeseaseVm.insuranceList[i].insureTo,"");
                        }
                    }
                    
                    if (simplePreExistingDeseaseVm.validateService.isValidSumInsured(simplePreExistingDeseaseVm.insuranceList[i].sumInsured)) {
                        simplePreExistingDeseaseVm.preExistingDesease[i].sumInsured = simplePreExistingDeseaseVm.validateService.isValidSumInsured(simplePreExistingDeseaseVm.insuranceList[i].sumInsured);
                    }
                }
            }

            for (var i = 0; i < simplePreExistingDeseaseVm.memeberList.length; i++) {
                if (angular.equals({}, simplePreExistingDeseaseVm.preExistingDesease[i])) {} else {
                    return false;
                }
            }
            for (var i = 0; i < simplePreExistingDeseaseVm.concurrenceInsurance.length; i++) {
                if (angular.equals({}, simplePreExistingDeseaseVm.preExistingDesease[i])) {} else {
                    return false;
                }
            }
            return true;
            // return (angular.equals({}, simplePreExistingDeseaseVm.preExistingDesease)) ? true : false;
        }


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        simplePreExistingDeseaseVm.goBacktoPrevious = function() {
            //To do
            $state.go("menu.simpleHealthQuestionarie");
        }

        simplePreExistingDeseaseVm.goToNextPage = function() {
            //$state.go("menu.healthPurchaseSummary");
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                var preExistingDesease = {
                    preExistingDesease: simplePreExistingDeseaseVm.data,
                    concurrentInsurance: simplePreExistingDeseaseVm.insuranceList,
                    concurrentInsuranceLength: simplePreExistingDeseaseVm.concurrenceInsurance.length,
                }
                generalInsurenceHealthService.setpreExistingDesease(simplePreExistingDeseaseVm);
                saveApplicationSH();

            }
        }
    }
]);
