// 'use strict';

angularApp.controller('homeBestQuotesController', ["$timeout",
    "$state",
    "$scope",
    "$translate",

    function($timeout,
        $state,
        $scope,
        $translate
    ) {

        //functions, variables that can be accessed from the HTML come here
        var homeBestQuotesVm = this;
        //private methods section start

        homeBestQuotesVm.bestQuotesData = {
            heading: "Best Quotes for you",
            sumAssured: "1,00,000",
            quoteNumber: "0000011420139",
            policyTerm: [{
                duration: "5 years",
                amount: "40365"
            }, {
                duration: "10 years",
                amount: "78400",
                title: "(Get 10% off on purchasing a policy for 10 years)"

            }, {
                duration: "15 years",
                amount: "110000",
                title: "(Get 15% off on purchasing a policy for 15 years)"
            }]
        };

        homeBestQuotesVm.goToNextPage = function() {

            $state.go('menu.homeQuoteSummary');
        }
        return this;
    }
]);
