angularApp.controller('homeInsuredBuildingDetailsController', [
    "$scope",
    "$state",
    "$ionicPopup", "$translate", "validateService", "generalInsurenceHomeDetailService", "generalInsurenceHomeService", "GIconstant","utilityService","generalInsurenceMotorService","clickStreamService",

    function(
         $scope,
        $state,
        $ionicPopup, $translate, validateService, generalInsurenceHomeDetailService, generalInsurenceHomeService, GIconstant , utilityService,generalInsurenceMotorService,clickStreamService
    ) {

        var homeInsuredBuildingDetailsVm = this;
        var savedApplication;
        homeInsuredBuildingDetailsVm.showBack = true;
        homeInsuredBuildingDetailsVm.showNext = true;
        homeInsuredBuildingDetailsVm.checkedTrue = true;
        homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm = {};
        homeInsuredBuildingDetailsVm.typeofbuildings = generalInsurenceHomeDetailService.getMasterDetail().typeOfbuilding;


        homeInsuredBuildingDetailsVm.data = {
            togleData: $translate.instant('goodStateTorepair'),
            checkBoxData: $translate.instant('residencyOnly'),
            propertyData: $translate.instant('Hypothates')
        }

        var currentYear;

        function SetSaveApplicationForHome() {
            var SavePageDetail = GIconstant.saveForHome.buildingDetail;
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, homeInsuredBuildingDetailsVm.product, modelname, SavePageDetail[count].type);
            }
			var saveListId = generalInsurenceHomeDetailService.getFinance();
			if(saveListId){
			  saveListId = saveListId.split("#")[1];
			}
			savedApplication.applicationData.createQuoteRequest.listId = saveListId;
            var JsonStingedData = angular.copy(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
             JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
            generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Home.LTH_LOCATION_DETAILS_1).then(function(data) {
                $state.go('menu.homeInsuredLocationDetails');

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        function initPage() {
            savedApplication = generalInsurenceHomeDetailService.getSavedData();
            homeInsuredBuildingDetailsVm.product = {};
            var pagedetail = generalInsurenceHomeDetailService.getPersonalThirdpageDetail();
            if (pagedetail) {
                homeInsuredBuildingDetailsVm.product = pagedetail;
                homeInsuredBuildingDetailsVm.product.isInGoodCondition =  true;
            }else{
                 homeInsuredBuildingDetailsVm.product.isInGoodCondition =  true;
            }
            currentYear = generalInsurenceHomeService.getCurrentDate().getFullYear();
        }
        homeInsuredBuildingDetailsVm.insuredLocation = {};
        homeInsuredBuildingDetailsVm.validateService = validateService;

        function validateForm() {
            homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm = {};
            if (homeInsuredBuildingDetailsVm.validateService.isValidNumberofFloor(homeInsuredBuildingDetailsVm.product.numberOfFloors)) {
                homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm.numberOfFloors = homeInsuredBuildingDetailsVm.validateService.isValidNumberofFloor(homeInsuredBuildingDetailsVm.product.numberOfFloors);
            }
            if (homeInsuredBuildingDetailsVm.validateService.isValidYourFloor(homeInsuredBuildingDetailsVm.product.floorNumber)) {
                homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm.floorNumber = homeInsuredBuildingDetailsVm.validateService.isValidYourFloor(homeInsuredBuildingDetailsVm.product.floorNumber);
            }
            if (homeInsuredBuildingDetailsVm.validateService.isValidTypeOfBuilding(homeInsuredBuildingDetailsVm.product.buildingType)) {
                homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm.buildingType = homeInsuredBuildingDetailsVm.validateService.isValidTypeOfBuilding(homeInsuredBuildingDetailsVm.product.buildingType);
            }
            if (homeInsuredBuildingDetailsVm.validateService.isValidYearOfConstruction(homeInsuredBuildingDetailsVm.product.yearOfConstruction)) {
                homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm.yearOfConstruction = homeInsuredBuildingDetailsVm.validateService.isValidYearOfConstruction(homeInsuredBuildingDetailsVm.product.yearOfConstruction);
            }
            if (homeInsuredBuildingDetailsVm.validateService.isValidAreadofProperty(homeInsuredBuildingDetailsVm.product.areaOfProperty)) {
                homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm.areaOfProperty = homeInsuredBuildingDetailsVm.validateService.isValidAreadofProperty(homeInsuredBuildingDetailsVm.product.areaOfProperty);
            }
            if (Number(homeInsuredBuildingDetailsVm.product.floorNumber) > Number(homeInsuredBuildingDetailsVm.product.numberOfFloors)) {
                homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm.floorNumber = $translate.instant('FLOOR_ERROR_MESSAGE');
            }
            if (homeInsuredBuildingDetailsVm.product.isHypothecated) {
                if (homeInsuredBuildingDetailsVm.validateService.isValidFinanceInstruct(homeInsuredBuildingDetailsVm.product.nameFinancialInstitution)) {
                    homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm.nameFinancialInstitution = homeInsuredBuildingDetailsVm.validateService.isValidFinanceInstruct(homeInsuredBuildingDetailsVm.product.nameFinancialInstitution);
                }
                if (homeInsuredBuildingDetailsVm.validateService.isValidFinancebranch(homeInsuredBuildingDetailsVm.product.branchFinancialInstitution)) {
                    homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm.branchFinancialInstitution = homeInsuredBuildingDetailsVm.validateService.isValidFinancebranch(homeInsuredBuildingDetailsVm.product.branchFinancialInstitution);
                }

                if (homeInsuredBuildingDetailsVm.validateService.isValidloanaccount(homeInsuredBuildingDetailsVm.product.loanAccountNo)) {
                    homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm.loanAccountNo = homeInsuredBuildingDetailsVm.validateService.isValidloanaccount(homeInsuredBuildingDetailsVm.product.loanAccountNo);
                }
                if (homeInsuredBuildingDetailsVm.validateService.isValidAdress(homeInsuredBuildingDetailsVm.product.addressoFinancialInstitution)) {
                    homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm.addressoFinancialInstitution = homeInsuredBuildingDetailsVm.validateService.isValidAdress(homeInsuredBuildingDetailsVm.product.addressoFinancialInstitution);
                }
            }
            if (currentYear - Number(homeInsuredBuildingDetailsVm.product.yearOfConstruction) > 30) {
                homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm.yearOfConstruction = $translate.instant('construction30');
            } else if (currentYear - Number(homeInsuredBuildingDetailsVm.product.yearOfConstruction) < 0) {
                homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm.yearOfConstruction = $translate.instant('constructionnegative');
            }
            return (angular.equals({}, homeInsuredBuildingDetailsVm.homeQuoteOwnerInfoForm)) ? true : false;
        }

        homeInsuredBuildingDetailsVm.changeGoodCondition = function() {
            if (!homeInsuredBuildingDetailsVm.product.isInGoodCondition) {
                utilityService.showAlertModal($translate.instant('HomeInsurance'),$translate.instant('oldhome'),"",$scope,$state,"OK");
            }
        }

        homeInsuredBuildingDetailsVm.goToNextPage = function() {
            if (validateForm() && homeInsuredBuildingDetailsVm.product.isInGoodCondition) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                if (!homeInsuredBuildingDetailsVm.product.isInGoodCondition || homeInsuredBuildingDetailsVm.product.isInGoodCondition ==  true) {
                    var listId = savedApplication.applicationData.createQuoteRequest.listId;
                    if(homeInsuredBuildingDetailsVm.product.isHypothecated){
                                
                                var financeDetails = {
                                  "saveFinanceRequest": {
                                    "accNumber": homeInsuredBuildingDetailsVm.product.loanAccountNo,
                                    "address": homeInsuredBuildingDetailsVm.product.addressoFinancialInstitution,
                                    "agreementType": "1",
                                    "branchName": homeInsuredBuildingDetailsVm.product.branchFinancialInstitution,
                                    "branchAddress": "",
                                    "companyName": homeInsuredBuildingDetailsVm.product.nameFinancialInstitution,
                                    "listId": listId ? listId : "",
                                    "quoteNumber": generalInsurenceHomeDetailService.getQuoteNumberDetail().premiumCalculation.quoteNumber,
                                    "remarks": "",
                                    "typeLoan": ""
                                  }
                                }
                            generalInsurenceHomeDetailService.saveFinance(financeDetails).then(function(data) {
                                    generalInsurenceHomeDetailService.setFinance(data.status);
                                     generalInsurenceHomeDetailService.setPersonalThirdpageDetail(homeInsuredBuildingDetailsVm.product);
                                    SetSaveApplicationForHome();
                            }, function(error) {
                                 utilityService.showErrorMessage(error.responseMessage);
                            });
                    }else{
                            if(generalInsurenceHomeDetailService.getFinance() != undefined  || generalInsurenceHomeDetailService.getFinance() != null)
                            {
                                            var financedetails = {
                          "deleteFinanceLTH": {
                            "quoteNo": generalInsurenceHomeDetailService.getQuoteNumberDetail().premiumCalculation.quoteNumber + "#" + listId
                          }
                        }
                          generalInsurenceHomeDetailService.deleteFinance(financedetails).then(function(data) {
                            generalInsurenceHomeDetailService.setPersonalThirdpageDetail(homeInsuredBuildingDetailsVm.product);
                        SetSaveApplicationForHome();
                        generalInsurenceMotorService.setFinance(undefined);
                  
                          }, function(error) {
                               utilityService.showErrorMessage(error.responseMessage);
                          });
                            }else{
                                        generalInsurenceHomeDetailService.setPersonalThirdpageDetail(homeInsuredBuildingDetailsVm.product);
                        SetSaveApplicationForHome();
                            }
                        
                        
                    }
                    
                }
            }else if(!homeInsuredBuildingDetailsVm.product.isInGoodCondition){
                utilityService.showAlertModal($translate.instant('HomeInsurance'),$translate.instant('oldhome'),"",$scope,$state,"OK");
            }
        }
        homeInsuredBuildingDetailsVm.goBacktoPrevious = function() {
            $state.go('menu.homeOwnerContactDetails');
        }
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);
