angularApp.controller('homeInsuredLocationDetailsController', [
    "$scope","$state", "validateService", "generalInsurenceHomeDetailService", "generalInsurenceHomeService", "utilityService", "GIconstant","clickStreamService","$filter","generalInsurenceHealthService",

    function(
        $scope,$state, validateService, generalInsurenceHomeDetailService, generalInsurenceHomeService, utilityService, GIconstant,clickStreamService,$filter,generalInsurenceHealthService
    ) {

        var homeInsuredLocationDetailsVm = this;
        var savedApplication;
        homeInsuredLocationDetailsVm.showNext = true;
        homeInsuredLocationDetailsVm.showBack = true;
        homeInsuredLocationDetailsVm.detail = {};
        homeInsuredLocationDetailsVm.locationDetail = {};
        homeInsuredLocationDetailsVm.validateService = validateService;
        var firstPageFetail,secondPageDetail,thirdPageDetail,forthPageDetail,fifthPageDetail,GenderValue;

        function SetSaveApplicationForHome() {
            var SavePageDetail = GIconstant.saveForHome.locationDetail;
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, homeInsuredLocationDetailsVm.detail, modelname, SavePageDetail[count].type);
            }
            //savedApplication.applicationData.createQuoteRequest.locationDetails.locationSource =  generalInsurenceHomeService.getLocatiopnBasedPincode();
           // savedApplication.applicationData.createQuoteRequest.locationDetails.city = savedApplication.applicationData.createQuoteRequest.locationDetails.locationSource.city;
            //savedApplication.applicationData.createQuoteRequest.locationDetails.state = savedApplication.applicationData.createQuoteRequest.locationDetails.locationSource.state;

            var JsonStingedData = angular.copy(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
             JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            generalInsurenceHomeService.saveApplication(JsonStingedData,JsonStingedData,GIconstant.OmniChannel.Home.LTH_OWNER_DETAILS_2).then(function(data) {
                //createPartyIdJson();
				applyhomeproduct();
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

         function createPartyIdJson(){

            if(fifthPageDetail.title.pkey == '9000000001'){
                GenderValue = 'M'
              }else{
                GenderValue = 'F'
              }

           var locationDetail =  generalInsurenceHomeService.getLocatiopnBasedPincode();
            var personalDetail =   {
                  "partyCreate": {
                  "salutation": fifthPageDetail.title.pkey,
                  "firstName":fifthPageDetail.firstName,
                  "middleName":"",
                  "lastName": fifthPageDetail.LastName,
                  "dob":  $filter('dateFormat')(fifthPageDetail.birthDate),
                  "gender":  GenderValue ? GenderValue : 'M',
                  "emailID": fifthPageDetail.emailID,
                  "mobile": fifthPageDetail.mobileNo,
                  "plotNo":secondPageDetail.ploatNo,
                  "buildingName":secondPageDetail.buildingName, 
                  "streetName":secondPageDetail.streetName,
                  "cityName": locationDetail.city.cityCode,
                  "stateName": locationDetail.state.key,
                  "pinCode": secondPageDetail.locality.pinId,
                  "districtName": locationDetail.district.districtCode,
                  "locality": forthPageDetail.locality.loc,
                  "addressType":"CurrentAddress"
                }
              }
              generalInsurenceHomeService.getPartyCreation(personalDetail).then(function(data) {
                generalInsurenceHomeDetailService.setPartyDetails(personalDetail);
                generalInsurenceHomeDetailService.setPartyResponse(data);
                 applyhomeproduct(data);
                }, function(error) {
                   utilityService.showErrorMessage(error.responseMessage);
            });
         }

         function  applyhomeproduct(){
			 var partyDetails = generalInsurenceHomeDetailService.getPartyResponse();
                  var ownerDetails = [];
                 for (var count = 0; count < firstPageFetail.length; count++) {
                    ownerDetails[count] = {};
                   ownerDetails[count] = {
                        "title": firstPageFetail[count].title.value,
                        "firstName": firstPageFetail[count].firstName,
                        "lastName": firstPageFetail[count].lastName,
                        "dob": $filter('dateFormat')(firstPageFetail[count].dob),
                        "name" : firstPageFetail[count].firstName + " " + firstPageFetail[count].lastName
                    };
                }

                var quoteDetail =  generalInsurenceHomeDetailService.getQuoteNumberDetail();
               
                 var homeDetail =  {
                  "createQuoteRequest": {
                    "quoteNo": quoteDetail.premiumCalculation.quoteNumber,
                    "sumInsured": quoteDetail.premiumCalculation.sumInsured,
                    "policyID": quoteDetail.premiumCalculation.policyTerms.policyID,
                    "startDate": quoteDetail.premiumCalculation.policyTerms.effectDate,
                    "endDate": quoteDetail.premiumCalculation.policyTerms.expiryDate,
                    "quotedate": quoteDetail.premiumCalculation.policyTerms.quotedate,
                    "tenure": 1 + generalInsurenceHomeService.calculateAge(quoteDetail.premiumCalculation.policyTerms.expiryDate,quoteDetail.premiumCalculation.policyTerms.effectDate),
                    "ppId": quoteDetail.premiumCalculation.policyTerms.ppId,
                    "partyId": partyDetails.partyCreate.partyID,
                     "insuredDetails": quoteDetail.premiumCalculation.insuredDetails,
                    // "insuredId": quoteDetail.premiumCalculation.policyTerms.insuredId,
                    // "policyCtId": quoteDetail.premiumCalculation.policyTerms.policyCtId,
                    "ownerDetails": ownerDetails,
                    "locationDetails": [
                      {
                        "plotNo": secondPageDetail.ploatNo,
                        "buildingNumber": secondPageDetail.buildingName,
                        "streetName": secondPageDetail.streetName,
                        "locality": secondPageDetail.locality.loc,
                        "state": secondPageDetail.stateObject ? secondPageDetail.stateObject.key  : "",
                        "city": secondPageDetail.cityObject ? secondPageDetail.cityObject.cityCode : "",
                        "pincode": secondPageDetail.pinCode,
                      }
                    ],

                    "buildingDetails" : {
                    "noofFloors": thirdPageDetail.numberOfFloors,
                    "yourFloor": thirdPageDetail.floorNumber,
                    "buildingtype": thirdPageDetail.buildingType.key.toString(),
                    "contructionType": thirdPageDetail.numberOfFloors,
                    "underConstruction": "",
                    "yearOfConstruction": thirdPageDetail.yearOfConstruction,
                    "area": thirdPageDetail.areaOfProperty,
                    "isGoodCondition": thirdPageDetail.isInGoodCondition ? "yes" : "no",
                    "isHypothecated": thirdPageDetail.isHypothecated ? true : false,
                    "financialInstitutionalDetails": {
                        "loanAmmount": "",
                        "name": thirdPageDetail.nameFinancialInstitution ? thirdPageDetail.nameFinancialInstitution : "" ,
                        "branch":  thirdPageDetail.branchFinancialInstitution ? thirdPageDetail.branchFinancialInstitution : "" ,
                        "loanAccountNumber":  thirdPageDetail.loanAccountNo ? thirdPageDetail.loanAccountNo : "" ,
                        "address": thirdPageDetail.addressoFinancialInstitution ? thirdPageDetail.addressoFinancialInstitution : "" 
                    }
                },
                   "ownerContactDetails": {
                      "isSameAddress": forthPageDetail.previousDetail ? "yes" : "no",
                      "title": fifthPageDetail.title.cbsKey,
                      "firstName": fifthPageDetail.firstName,
                      "lastName": fifthPageDetail.LastName,
                      "address": forthPageDetail.locality.loc+","+forthPageDetail.ploatNo + ","+forthPageDetail.buildingName+","+forthPageDetail.streetName + "," + secondPageDetail.stateObject.key + "," + secondPageDetail.cityObject.cityCode + "," + secondPageDetail.pinCode,
                      "gender": GenderValue ? GenderValue : "M",
                      "dob": $filter('dateFormat')(fifthPageDetail.birthDate),
                      "emailId": fifthPageDetail.emailID,
                      "mobileNumber": fifthPageDetail.mobileNo
                    }
                  }
                }
               
                generalInsurenceHomeDetailService.sendProductDetailQuote(homeDetail).then(function(data) {
                        generalInsurenceHealthService.setQuotecalculation(data);
                        generalInsurenceHomeDetailService.setpremiumAmountDetail(data);
                        $state.go("menu.homePurchaseSummary");


                }, function(error) {
                   utilityService.showErrorMessage(error.responseMessage);
                });
        }

        homeInsuredLocationDetailsVm.getLocation = function() {
            if (homeInsuredLocationDetailsVm.detail.pinCode.length == 6) {
                var detail = {
                    "pinCode": homeInsuredLocationDetailsVm.detail.pinCode
                }
                generalInsurenceHomeService.getLocation(detail).then(function(data) {
                    generalInsurenceHomeService.setLocatiopnBasedPincode(data);
                    if (data) {
                        homeInsuredLocationDetailsVm.detail.stateObject = data.state;
                        homeInsuredLocationDetailsVm.detail.state = data.state.value;
                        homeInsuredLocationDetailsVm.detail.cityObject = data.city;
                        homeInsuredLocationDetailsVm.detail.city = data.city.cityName;
                        homeInsuredLocationDetailsVm.localitions = data.location;
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }


        function initPage() {
            homeInsuredLocationDetailsVm.detail.previousDetail = true;
            homeInsuredLocationDetailsVm.setprevioudData();
            savedApplication = generalInsurenceHomeDetailService.getSavedData();
            var pageDetail = generalInsurenceHomeDetailService.getPersonalSecondpageDetail();
            if (!angular.equals(pageDetail,{}) && pageDetail) {
                homeInsuredLocationDetailsVm.detail = pageDetail;
                homeInsuredLocationDetailsVm.getLocation();
            } else {
                var accountNumber = generalInsurenceHomeService.getaccountDetail();
                var accountDetail =  generalInsurenceHomeService.getIIBaccountDetail();
                homeInsuredLocationDetailsVm.detail.pinCode = accountDetail.cbsData.pinCode;
                homeInsuredLocationDetailsVm.detail.ploatNo = accountDetail.cbsData.addressLine1;
                homeInsuredLocationDetailsVm.detail.buildingName = accountDetail.cbsData.addressLine2;
                homeInsuredLocationDetailsVm.detail.streetName = accountDetail.cbsData.addressLine3;
                homeInsuredLocationDetailsVm.getLocation(accountDetail.cbsData.pinCode);
            }
        }

        function validateForm() {
            homeInsuredLocationDetailsVm.locationDetail = {};
            if (homeInsuredLocationDetailsVm.validateService.isValidCity(homeInsuredLocationDetailsVm.detail.city)) {
                homeInsuredLocationDetailsVm.locationDetail.city = homeInsuredLocationDetailsVm.validateService.isValidCity(homeInsuredLocationDetailsVm.detail.city);
            }
            if (homeInsuredLocationDetailsVm.validateService.isValidPincode(homeInsuredLocationDetailsVm.detail.pinCode)) {
                homeInsuredLocationDetailsVm.locationDetail.pinCode = homeInsuredLocationDetailsVm.validateService.isValidPincode(homeInsuredLocationDetailsVm.detail.pinCode);
            }
            if (homeInsuredLocationDetailsVm.validateService.isValidState(homeInsuredLocationDetailsVm.detail.state)) {
                homeInsuredLocationDetailsVm.locationDetail.state = homeInsuredLocationDetailsVm.validateService.isValidState(homeInsuredLocationDetailsVm.detail.state);
            }
            if (homeInsuredLocationDetailsVm.validateService.isValidStreetName(homeInsuredLocationDetailsVm.detail.streetName)) {
                homeInsuredLocationDetailsVm.locationDetail.streetName = homeInsuredLocationDetailsVm.validateService.isValidStreetName(homeInsuredLocationDetailsVm.detail.streetName);
            }
            if (homeInsuredLocationDetailsVm.validateService.isValidBuildingName(homeInsuredLocationDetailsVm.detail.buildingName)) {
                homeInsuredLocationDetailsVm.locationDetail.buildingName = homeInsuredLocationDetailsVm.validateService.isValidBuildingName(homeInsuredLocationDetailsVm.detail.buildingName);
            }
            if (homeInsuredLocationDetailsVm.validateService.isValidplotNO(homeInsuredLocationDetailsVm.detail.ploatNo)) {
                homeInsuredLocationDetailsVm.locationDetail.ploatNo = homeInsuredLocationDetailsVm.validateService.isValidplotNO(homeInsuredLocationDetailsVm.detail.ploatNo);
            }
            if (homeInsuredLocationDetailsVm.validateService.isValidlocality(homeInsuredLocationDetailsVm.detail.locality)) {
                homeInsuredLocationDetailsVm.locationDetail.locality = homeInsuredLocationDetailsVm.validateService.isValidlocality(homeInsuredLocationDetailsVm.detail.locality);
            }
            return (angular.equals({}, homeInsuredLocationDetailsVm.locationDetail)) ? true : false;
        }
        homeInsuredLocationDetailsVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                generalInsurenceHomeDetailService.setPersonalSecondpageDetail(homeInsuredLocationDetailsVm.detail);
                var applyHomeProduct = {
                    "quoteNumber": "string",
                }

                applyHomeProduct.ownerDetails = [];
                 firstPageFetail = generalInsurenceHomeDetailService.getPersonalFirstpageDetail();
                 secondPageDetail = generalInsurenceHomeDetailService.getPersonalSecondpageDetail();
                 thirdPageDetail = generalInsurenceHomeDetailService.getPersonalThirdpageDetail();
                 forthPageDetail = generalInsurenceHomeDetailService.getPersonalForthpageDetail();
                 fifthPageDetail = generalInsurenceHomeDetailService.getPersonalFifthpageDetail();
                SetSaveApplicationForHome();
            }
        }

        homeInsuredLocationDetailsVm.setprevioudData = function() {
            if (homeInsuredLocationDetailsVm.detail.previousDetail) {
                var pageDetail = generalInsurenceHomeDetailService.getPersonalForthpageDetail();
                if (pageDetail) {
                    homeInsuredLocationDetailsVm.detail = pageDetail;
                    homeInsuredLocationDetailsVm.detail.locality = pageDetail.locality;
                    homeInsuredLocationDetailsVm.getlocationBasedpincode(homeInsuredLocationDetailsVm.detail.pinCode);
                }
                homeInsuredLocationDetailsVm.detail.previousDetail = true;
            } else {
                homeInsuredLocationDetailsVm.detail = {};
                homeInsuredLocationDetailsVm.detail.previousDetail = false;
            }
        }

        homeInsuredLocationDetailsVm.getlocationBasedpincode = function(){
            if(homeInsuredLocationDetailsVm.detail.pinCode && homeInsuredLocationDetailsVm.detail.pinCode.length == 6){

                var detail = {
                    "pinCode": homeInsuredLocationDetailsVm.detail.pinCode
                }
                generalInsurenceHomeService.getLocation(detail).then(function(data) {
                    generalInsurenceHomeService.setLocatiopnBasedPincode(data);
                    if (data) {
                        homeInsuredLocationDetailsVm.detail.stateObject = data.state;
                        homeInsuredLocationDetailsVm.detail.state = data.state.value;
                        homeInsuredLocationDetailsVm.detail.cityObject = data.city;
                        homeInsuredLocationDetailsVm.detail.city = data.city.cityName;
                        homeInsuredLocationDetailsVm.localitions = data.location;
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
           
            }
        }

        homeInsuredLocationDetailsVm.clickDeclaration = function(){
            generalInsurenceHomeService.getDiclaration().then(function(data) {
               
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        homeInsuredLocationDetailsVm.goBacktoPrevious = function() {
            $state.go('menu.homeInsuredBuildingDetails');
        }
        
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


    }
]);
