
angularApp.controller('homeOwnerContactDetailsController', [
    "$state",
    "$scope", "validateService", "generalInsurenceHomeDetailService", "GIconstant", "generalInsurenceHomeService","clickStreamService","$filter","utilityService",

    function(
        $state,
        $scope, validateService, generalInsurenceHomeDetailService, GIconstant, generalInsurenceHomeService,clickStreamService,$filter,utilityService
    ) {


        var homeOwnerContactDetailsVm = this;
        var savedApplication,fifthPageDetail;
        homeOwnerContactDetailsVm.showNext = true;
        homeOwnerContactDetailsVm.showBack = true;
        homeOwnerContactDetailsVm.detail = {};
        homeOwnerContactDetailsVm.validateService = validateService;

        function SetSaveApplicationForHome() {
            var SavePageDetail = GIconstant.saveForHome.personalOwnerDetail;
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, homeOwnerContactDetailsVm.detail, modelname, SavePageDetail[count].type);
            }
			savedApplication.applicationData.partyDetails = generalInsurenceHomeDetailService.getPartyResponse() ? generalInsurenceHomeDetailService.getPartyResponse().partyCreate : "";
            var JsonStingedData = angular.copy(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
            JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
            generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Home.LTH_LOCATION_DETAILS_2).then(function(data) {
                //$state.go('menu.homeApplicationContactDetails');
                $state.go('menu.homeInsuredBuildingDetails');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
		
		function createPartyIdJson(){
			var firstPageFetail = generalInsurenceHomeDetailService.getPersonalFirstpageDetail();
			var thirdPageDetail = generalInsurenceHomeDetailService.getPersonalThirdpageDetail();
			var forthPageDetail = generalInsurenceHomeDetailService.getPersonalForthpageDetail();
			var fifthPageDetail = generalInsurenceHomeDetailService.getPersonalFifthpageDetail();
			var GenderValue = "";
            if(fifthPageDetail.title.pkey == '9000000001'){
                GenderValue = 'M'
              }else{
                GenderValue = 'F'
              }

           var locationDetail =  generalInsurenceHomeService.getLocatiopnBasedPincode();
            var personalDetail =   {
                  "partyCreate": {
                  "salutation": fifthPageDetail.title.pkey,
                  "firstName":fifthPageDetail.firstName,
                  "middleName":"",
                  "lastName": fifthPageDetail.LastName,
                  "dob":  $filter('dateFormat')(fifthPageDetail.birthDate),
                  "gender":  GenderValue ? GenderValue : 'M',
                  "emailID": fifthPageDetail.emailID,
                  "mobile": fifthPageDetail.mobileNo,
                  "plotNo":homeOwnerContactDetailsVm.detail.ploatNo,
                  "buildingName":homeOwnerContactDetailsVm.detail.buildingName, 
                  "streetName":homeOwnerContactDetailsVm.detail.streetName,
                  "cityName": locationDetail.city.cityCode,
                  "stateName": locationDetail.state.key,
                  "pinCode": homeOwnerContactDetailsVm.detail.locality.pinId,
                  "districtName": locationDetail.district.districtCode,
                  "locality": forthPageDetail.locality.loc,
                  "addressType":"CurrentAddress",
                  "partyRole": "Policy Holder",
                }
              }
              generalInsurenceHomeService.getPartyCreation(personalDetail).then(function(data) {
                generalInsurenceHomeDetailService.setPartyDetails(personalDetail);
                generalInsurenceHomeDetailService.setPartyResponse(data);
                SetSaveApplicationForHome();
                }, function(error) {
                   utilityService.showErrorMessage(error.responseMessage);
            });
        }

        homeOwnerContactDetailsVm.getLocation = function() {
            if (homeOwnerContactDetailsVm.detail.pinCode.length == 6) {
                var detail = {
                    "pinCode": homeOwnerContactDetailsVm.detail.pinCode
                }
                generalInsurenceHomeService.getLocation(detail).then(function(data) {
                    generalInsurenceHomeService.setLocatiopnBasedPincode(data);
                    if (data) {
                        homeOwnerContactDetailsVm.detail.stateObject = data.state;
                        homeOwnerContactDetailsVm.detail.state = homeOwnerContactDetailsVm.detail.stateObject.value;
                        homeOwnerContactDetailsVm.detail.cityObject = data.city;
                        homeOwnerContactDetailsVm.detail.city = homeOwnerContactDetailsVm.detail.cityObject.cityName;
						homeOwnerContactDetailsVm.detail.cityKey = data.city.cityCode;
                        homeOwnerContactDetailsVm.localitions = data.location;
						homeOwnerContactDetailsVm.detail.localitionSource = data;
                    }
                }, function(error) {
					homeOwnerContactDetailsVm.detail.locality = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        function initpage() {
            savedApplication = generalInsurenceHomeDetailService.getSavedData();
            /*var pageDetail = generalInsurenceHomeDetailService.getPersonalForthpageDetail();
            if (pageDetail) {
                homeOwnerContactDetailsVm.detail = pageDetail;

                if(homeOwnerContactDetailsVm.detail){
                    homeOwnerContactDetailsVm.getlocationBasedpincode( homeOwnerContactDetailsVm.detail.pinCode);
                }
            }*/
			fifthPageDetail = generalInsurenceHomeDetailService.getPersonalFifthpageDetail();
			if(fifthPageDetail.title.pkey == '9000000001'){
                homeOwnerContactDetailsVm.gender  = 'M';
              }else{
                homeOwnerContactDetailsVm.gender  = 'F';
              }
			
            var pageDetail = generalInsurenceHomeDetailService.getPersonalForthpageDetail();
            if (!angular.equals(pageDetail,{}) && pageDetail) {
                homeOwnerContactDetailsVm.detail = pageDetail;
                homeOwnerContactDetailsVm.getLocation();
            } else {
                var accountNumber = generalInsurenceHomeService.getaccountDetail();
                var accountDetail =  generalInsurenceHomeService.getIIBaccountDetail();
                homeOwnerContactDetailsVm.detail.pinCode = accountDetail.cbsData.pinCode;
                homeOwnerContactDetailsVm.detail.ploatNo = accountDetail.cbsData.addressLine1;
                homeOwnerContactDetailsVm.detail.ploatNo = homeOwnerContactDetailsVm.detail.ploatNo ? homeOwnerContactDetailsVm.detail.ploatNo.replace(/[^A-Za-z0-9./,-\s]/g, '') : '';
                homeOwnerContactDetailsVm.detail.buildingName = accountDetail.cbsData.addressLine2;
                homeOwnerContactDetailsVm.detail.streetName = accountDetail.cbsData.addressLine3;
                homeOwnerContactDetailsVm.getLocation(accountDetail.cbsData.pinCode);
            }
        }

       /* homeOwnerContactDetailsVm.setprevioudData = function() {
            if (homeOwnerContactDetailsVm.detail.previousDetail) {
                var pageDetail = generalInsurenceHomeDetailService.getPersonalSecondpageDetail();
                if (pageDetail) {
                    homeOwnerContactDetailsVm.detail = pageDetail;
                    homeOwnerContactDetailsVm.detail.locality = pageDetail.locality;
                    homeOwnerContactDetailsVm.getlocationBasedpincode(homeOwnerContactDetailsVm.detail.pinCode);
                }
                homeOwnerContactDetailsVm.detail.previousDetail = true;
            } else {
                homeOwnerContactDetailsVm.detail = {};
                homeOwnerContactDetailsVm.detail.previousDetail = false;
            }
        }*/

        function validateForm() {
            homeOwnerContactDetailsVm.locationDetail = {};
            if (homeOwnerContactDetailsVm.validateService.isValidCity(homeOwnerContactDetailsVm.detail.city)) {
                homeOwnerContactDetailsVm.locationDetail.city = homeOwnerContactDetailsVm.validateService.isValidCity(homeOwnerContactDetailsVm.detail.city);
            }
            if (homeOwnerContactDetailsVm.validateService.isValidPincode(homeOwnerContactDetailsVm.detail.pinCode)) {
                homeOwnerContactDetailsVm.locationDetail.pinCode = homeOwnerContactDetailsVm.validateService.isValidPincode(homeOwnerContactDetailsVm.detail.pinCode);
            }

            if (homeOwnerContactDetailsVm.validateService.isValidState(homeOwnerContactDetailsVm.detail.state)) {
                homeOwnerContactDetailsVm.locationDetail.state = homeOwnerContactDetailsVm.validateService.isValidState(homeOwnerContactDetailsVm.detail.state);
            }

            if (homeOwnerContactDetailsVm.validateService.isValidStreetName(homeOwnerContactDetailsVm.detail.streetName)) {
                homeOwnerContactDetailsVm.locationDetail.streetName = homeOwnerContactDetailsVm.validateService.isValidStreetName(homeOwnerContactDetailsVm.detail.streetName);
            }

            if (homeOwnerContactDetailsVm.validateService.isValidBuildingName(homeOwnerContactDetailsVm.detail.buildingName)) {
                homeOwnerContactDetailsVm.locationDetail.buildingName = homeOwnerContactDetailsVm.validateService.isValidBuildingName(homeOwnerContactDetailsVm.detail.buildingName);
            }
            if (homeOwnerContactDetailsVm.validateService.isValidplotNO(homeOwnerContactDetailsVm.detail.ploatNo)) {
                homeOwnerContactDetailsVm.locationDetail.ploatNo = homeOwnerContactDetailsVm.validateService.isValidplotNO(homeOwnerContactDetailsVm.detail.ploatNo);
            }
            if (homeOwnerContactDetailsVm.validateService.isValidlocality(homeOwnerContactDetailsVm.detail.locality)) {
                homeOwnerContactDetailsVm.locationDetail.locality = homeOwnerContactDetailsVm.validateService.isValidlocality(homeOwnerContactDetailsVm.detail.locality);
            }
            return (angular.equals({}, homeOwnerContactDetailsVm.locationDetail)) ? true : false;
        }

        homeOwnerContactDetailsVm.getlocationBasedpincode = function(){
            if(homeOwnerContactDetailsVm.detail.pinCode && homeOwnerContactDetailsVm.detail.pinCode.length == 6){

                var detail = {
                    "pinCode": homeOwnerContactDetailsVm.detail.pinCode
                }
                generalInsurenceHomeService.getLocation(detail).then(function(data) {
                    generalInsurenceHomeService.setLocatiopnBasedPincode(data);
                    if (data) {
                        homeOwnerContactDetailsVm.detail.cityObject = data.city;
                        homeOwnerContactDetailsVm.detail.city = homeOwnerContactDetailsVm.detail.cityObject.cityName;
						homeOwnerContactDetailsVm.detail.cityKey = data.city.cityCode;
                        homeOwnerContactDetailsVm.localitions = data.location;
                        homeOwnerContactDetailsVm.detail.stateObject = data.state;
                        homeOwnerContactDetailsVm.detail.state = homeOwnerContactDetailsVm.detail.stateObject.value;
						homeOwnerContactDetailsVm.detail.localitionSource = data;
                    }
                }, function(error) {
					homeOwnerContactDetailsVm.detail.locality = ""
                    utilityService.showErrorMessage(error.responseMessage);
                });
           
            }
        }

        homeOwnerContactDetailsVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                generalInsurenceHomeDetailService.setPersonalForthpageDetail(homeOwnerContactDetailsVm.detail);
                //SetSaveApplicationForHome();
				createPartyIdJson();
            }
        }



        homeOwnerContactDetailsVm.goBacktoPrevious = function() {
            $state.go('menu.homeApplicationContactDetails');
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initpage();
        });

        return this;
    }
]);
