angularApp.controller('leadGenerationInsuranceController', [ "$state", "$scope","generalInsurenceHomeService","$ionicSlideBoxDelegate","utilityService","$ionicPopup","loggedInUserService","sampoornSurakshaService","newCardService","$window",
function( $state, $scope, generalInsurenceHomeService,$ionicSlideBoxDelegate,utilityService, $ionicPopup, loggedInUserService, sampoornSurakshaService,newCardService,$window) {
    var leadGenerationInsuranceVm = this;
    $scope.bannerData = "";

function initPage() {

   

    //for top n bottom banner
    generalInsurenceHomeService.getInsurePreBanners().then(function(data){
        $scope.allBanners = data;
         $scope.bannersD = [];
            angular.forEach($scope.allBanners, function(value, key) {
                $scope.bannersD[key] = value;
                console.log("bannersD",JSON.stringify($scope.bannersD));
                for (var i = 0; i < $scope.bannersD.length; i++) {
                    $scope.productId = $scope.bannersD[i].productId;
                }
                $ionicSlideBoxDelegate.update();
                $ionicSlideBoxDelegate.loop(true);
            });
    }, function(error) {
        $scope.allBanners = '';
        utilityService.showErrorMessage(error.responseMessage);
    });

    

    leadGenerationInsuranceVm.navInsurance = "life";
    leadGenerationInsuranceVm.navSubCategory = "all";
    leadGenerationInsuranceVm.activeAllSubCategory = true;
    leadGenerationInsuranceVm.activeWelSubCategory = false;
    leadGenerationInsuranceVm.activePureSubCategory = false;
    leadGenerationInsuranceVm.activeSavSubCategory = false;
    leadGenerationInsuranceVm.activeRetSubCategory = false;
    
    //for product list 
    generalInsurenceHomeService.insurLeadProducts().then(function(data){
            $scope.allPlans = data;
            for (var i = 0; i < $scope.allPlans.length; i++) {
               $scope.policies = $scope.allPlans[i].policies;
             }
        }, function(error) {
            $scope.allPlans = '';
            utilityService.showErrorMessage(error.responseMessage);
        });

   
    // for subcategory pls check first working or not
    if(sampoornSurakshaService.getActiveCategory()){

        leadGenerationInsuranceVm.navInsurance = sampoornSurakshaService.getActiveCategory();
    }else{
        leadGenerationInsuranceVm.navInsurance = "life";
        if(leadGenerationInsuranceVm.navInsurance == 'life' ){
            leadGenerationInsuranceVm.navSubCategory = "all";
             
        }
    }
        //for category
       if(leadGenerationInsuranceVm.navInsurance == "health"){
            leadGenerationInsuranceVm.tab = 2;
        }else if(leadGenerationInsuranceVm.navInsurance == "personal-accident"){
            leadGenerationInsuranceVm.tab = 3;
        }else if(leadGenerationInsuranceVm.navInsurance == "home"){
            leadGenerationInsuranceVm.tab = 4;
        }else if(leadGenerationInsuranceVm.navInsurance == "travel"){
            leadGenerationInsuranceVm.tab = 5;
        }else if(leadGenerationInsuranceVm.navInsurance == "motor"){
            leadGenerationInsuranceVm.tab = 6;
        }else if(leadGenerationInsuranceVm.navInsurance == "life"){
            leadGenerationInsuranceVm.tab = 1;   
        }

        

    }

//actions to done everytime the view is shown
$scope.$on('$ionicView.beforeEnter', function() {
    initPage();
});


// Set active tab after navigating from one tab to another
    leadGenerationInsuranceVm.insuranceTab = function (index, category) {
    leadGenerationInsuranceVm.tab = index;
    leadGenerationInsuranceVm.navInsurance = category;
    
   
    //tab section
    if(leadGenerationInsuranceVm.navSubCategory !== 'all' || leadGenerationInsuranceVm.navInsurance !== 'life'){
        leadGenerationInsuranceVm.navSubCategory = 'all';
        leadGenerationInsuranceVm.activeAllSubCategory = true;
        leadGenerationInsuranceVm.navSubCategoryWealth = "";
        leadGenerationInsuranceVm.activeWelSubCategory = false;
        leadGenerationInsuranceVm.navSubCategoryPure = "";
        leadGenerationInsuranceVm.activePureSubCategory = false;
        leadGenerationInsuranceVm.navSubCategorySav = "";
        leadGenerationInsuranceVm.activeSavSubCategory = false;
        leadGenerationInsuranceVm.navSubCategoryRet = "";
        leadGenerationInsuranceVm.activeRetSubCategory = false;
        $scope.withoutLife = 'divTopInsure';
        const element = document.getElementById("insurProductsId");
        element.getElementsByClassName("scroll")[0].style.transform = 'translate3d(0px, 0px, 0px) scale(1)';
       
    }else{
        $scope.withoutLife = '';
    }
}

leadGenerationInsuranceVm.inSubCategories = function (index, subCategory, activeSubCat,click) {
    leadGenerationInsuranceVm.navCategory = index;
    const insDiv = document.getElementById("insurProductsId");
    insDiv.getElementsByClassName("scroll")[0].style.transform = 'translate3d(0px, 0px, 0px) scale(1)';
    if((activeSubCat == 'activeAll')){
        
          leadGenerationInsuranceVm.activeAllSubCategory = true;
        if(leadGenerationInsuranceVm.activeAllSubCategory){
            
            leadGenerationInsuranceVm.navSubCategory = "all";
            leadGenerationInsuranceVm.navSubCategoryWealth = "";
            leadGenerationInsuranceVm.activeWelSubCategory = false;
            leadGenerationInsuranceVm.navSubCategoryPure = "";
            leadGenerationInsuranceVm.activePureSubCategory = false;
            leadGenerationInsuranceVm.navSubCategorySav = "";
            leadGenerationInsuranceVm.activeSavSubCategory = false;
            leadGenerationInsuranceVm.navSubCategoryRet = "";
            leadGenerationInsuranceVm.activeRetSubCategory = false;

        }
        
    }

    if(activeSubCat == 'activeWealth'){
        leadGenerationInsuranceVm.activeWelSubCategory = !leadGenerationInsuranceVm.activeWelSubCategory;
        
        if(leadGenerationInsuranceVm.activeWelSubCategory){
             leadGenerationInsuranceVm.activeAllSubCategory = false;
             leadGenerationInsuranceVm.navSubCategory = "";
            leadGenerationInsuranceVm.navSubCategoryWealth = "wealth-creation";
            
        }else{
            leadGenerationInsuranceVm.navSubCategoryWealth = "";
            leadGenerationInsuranceVm.activeWelSubCategory = false;
        }
    }

    if(activeSubCat == 'activePure'){
        leadGenerationInsuranceVm.activePureSubCategory = !leadGenerationInsuranceVm.activePureSubCategory;
        
        if(leadGenerationInsuranceVm.activePureSubCategory){
            leadGenerationInsuranceVm.activeAllSubCategory = false;
            leadGenerationInsuranceVm.navSubCategory = "";
            leadGenerationInsuranceVm.navSubCategoryPure = "pure-protection";
            
        }else{
            leadGenerationInsuranceVm.navSubCategoryPure = "";
            leadGenerationInsuranceVm.activePureSubCategory = false;
            
        }
    }

    if(activeSubCat == 'activeSavings'){
         leadGenerationInsuranceVm.activeSavSubCategory = !leadGenerationInsuranceVm.activeSavSubCategory;
        
        if(leadGenerationInsuranceVm.activeSavSubCategory){
             leadGenerationInsuranceVm.activeAllSubCategory = false;
             leadGenerationInsuranceVm.navSubCategory = "";
            leadGenerationInsuranceVm.navSubCategorySav = "savings";
            
        }else{
            leadGenerationInsuranceVm.navSubCategorySav = "";
            leadGenerationInsuranceVm.activeSavSubCategory = false;
           
        }
        
    }

    if(activeSubCat == 'activeRetire'){
        leadGenerationInsuranceVm.activeRetSubCategory = !leadGenerationInsuranceVm.activeRetSubCategory;
        
        if(leadGenerationInsuranceVm.activeRetSubCategory){
             leadGenerationInsuranceVm.activeAllSubCategory = false;
             leadGenerationInsuranceVm.navSubCategory = "";
            leadGenerationInsuranceVm.navSubCategoryRet = "retirement";
            
        }else{
            leadGenerationInsuranceVm.navSubCategoryRet = "";
            leadGenerationInsuranceVm.activeRetSubCategory = false;
        }
    }

//for default all selection 
    if((activeSubCat == 'activeWealth') || (activeSubCat == 'activeRetire') || (activeSubCat == 'activePure') || (activeSubCat == 'activeSavings')){
        if((!leadGenerationInsuranceVm.activeWelSubCategory) && (!leadGenerationInsuranceVm.activePureSubCategory) && (!leadGenerationInsuranceVm.activeSavSubCategory) && (!leadGenerationInsuranceVm.activeRetSubCategory)){
            leadGenerationInsuranceVm.navSubCategory = "all";
            leadGenerationInsuranceVm.activeAllSubCategory = true;
        }
     }
  }

    leadGenerationInsuranceVm.goBackToPreviousPage = function(){
        $state.go('menu.userLanding');
    }

    $scope.RedirectToOcas = function() {
            
            var landingUrl = "http://onlineapply.sbi.co.in/personal-banking/cve?utm=YonoPreLogin";
           
            $window.location.href = landingUrl;
    };

    leadGenerationInsuranceVm.redirect = function(type, id){
        $scope.productId = id;

        if($scope.productId == 'health'){
            leadGenerationInsuranceVm.tab = 2;
        } 
        if($scope.productId == 'personal-accident'){
            leadGenerationInsuranceVm.tab = 3;
        } 
        if($scope.productId == 'home'){
            leadGenerationInsuranceVm.tab = 4;
        }
        if($scope.productId == 'travel'){
            leadGenerationInsuranceVm.tab = 5;
        }
        if($scope.productId == 'motor'){
            leadGenerationInsuranceVm.tab = 6;
        }

       // For non-yono product
        if(type == 'non-yono'){
                var alertPopup = $ionicPopup.alert({
                template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/generalInsurance/Redirection-icon.png"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><p class="titleNonY">' + 'Re-Direction' + '</div><span class="popUp-msg-color">' + 'You will be redirected to customer consent capture and product requirement screen since the product chosen by you is not available in YONO at this point for digital fulfilment.' + '</span></div></div></div>',
                scope: $scope,
                cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup insurButton',
                buttons: [
                    {
                        text: "Cancel",
                        type: 'button-negative',
                        onTap: function () {
                            alertPopup.close();
                        }
                    },
                    {
                        text: "OK",
                        type: 'button-positive',
                        onTap: function () {
                           $scope.RedirectToOcas();
                            
                        }
                    }
                ],
            });
        }else{
             var alertPopup1 = $ionicPopup.alert({
                template: '<div class="popup-padding font-dark-grey"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">' + 'Please login to know more and <p>buy the product !</p>' + '</span></div></div></div>',
                scope: $scope,
                cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup insurButton preLogin',
                buttons: [
                    {
                        text: "Back",
                        type: 'button-negative',
                        onTap: function () {
                            alertPopup1.close();
                        }
                    },
                    {
                        text: "Go to Login",
                        type: 'button-positive',
                        onTap: function () {

                        if($scope.productId == 'life' && type == 'yono' || $scope.productId == 'SBI Life - RiNn Raksha' && type == 'yono' || $scope.productId == 'SBI Life - Sampoorn Suraksha' && type == 'yono'){
                            loggedInUserService.productClicked = 'menu.goToMyInsurance';
                            $state.go('menu.userLogin');
                        }else{

                            
                        sampoornSurakshaService.setActiveCategory(leadGenerationInsuranceVm.navInsurance);
                       
                        switch(leadGenerationInsuranceVm.tab){
                                case 2:
                                    generalInsurenceHomeService.setGIProductsID('health-insurance');
                                    break;
                                case 3:
                                    generalInsurenceHomeService.setGIProductsID('personal-accident-insurance');
                                    break;
                                case 4:
                                    generalInsurenceHomeService.setGIProductsID('home-insurance');
                                    break;
                                case 5:
                                    generalInsurenceHomeService.setGIProductsID('travel-insurance');
                                    break;
                                case 6:
                                    generalInsurenceHomeService.setGIProductsID('motor-insurance');
                                    break;
                                default:
                                    break;
                            }
                            newCardService.setPreLoginSelectedMenu('insure');
                            loggedInUserService.productClicked = 'menu.declaimer';
                            $state.go('menu.userLogin');
                         }   
                        }
                    }
                ],
            });
        }
    }

    

}]);