angularApp.controller('motorCarInsuredWithOtherCompanyController', [
    "$state",
    "$scope",
    "$translate", "generalInsurenceMotorService", "validateService", "$filter", "$ionicPopup", "generalInsurenceHomeService", "GIconstant",


    function(
        $state,
        $scope,
        $translate, generalInsurenceMotorService, validateService, $filter, $ionicPopup, generalInsurenceHomeService, GIconstant) {

        //variable initialization
        var motorCarInsuredWithOtherCompanyVm = this;
        var uin, savedApplication;



        function SetSaveApplicationForHome() {
            var claimStatus = angular.equals({}, motorCarInsuredWithOtherCompanyVm.previousVheical.claimsInPreviousPolicy) ? true : false;
            if (claimStatus) {
                motorCarInsuredWithOtherCompanyVm.previousVheical.claimsInPreviousPolicy = false;
            }
            var SavePageDetail = GIconstant.saveForMotor.motorInsuredWithOtherCompany;
            if (savedApplication) {
                if (savedApplication.quoteData) {
                    if (savedApplication.quoteData.motorDetails) {} else {
                        savedApplication.quoteData = {};
                    }
                }
            } else {
                savedApplication = {};
                savedApplication.quoteData = {};

            }
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, motorCarInsuredWithOtherCompanyVm.previousVheical, modelname, SavePageDetail[count].type);
            }
            var JsonStingedData = angular.copy(savedApplication);
            generalInsurenceMotorService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.uin = generalInsurenceHomeService.getProductDetail().uin;
            JsonStingedData.productCode = generalInsurenceHomeService.getGIProductsID();
            JsonStingedData.planName = generalInsurenceHomeService.getProductDetail().policyName;
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
             JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
            generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Motor.MI_PREVIOUS_POLICY).then(function(data) {
                $state.go('menu.motorOldCarGetCarInfo');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        function retriewSaveData() {
            // var detail = {
            //     "applicationNumber": "11222"
            // }
            // generalInsurenceHomeService.getSavedApplicationForAPI(detail).then(function(data) {
            //     if (data) {

            //         if (generalInsurenceHomeService.isJson(data.quoteData)) {
            //             data.quoteData = JSON.parse(data.quoteData);
            //         }
            //         if (generalInsurenceHomeService.isJson(data.applicationData)) {
            //             data.applicationData = JSON.parse(data.applicationData);
            //         }
            //         savedApplication = data;
            //         generalInsurenceMotorService.setSavedData(savedApplication);
            //         generalInsurenceMotorService.assignvalueForMotor();



                    var previouspageData = generalInsurenceMotorService.getMotorQuoteFirstPageDetail();
                    if (previouspageData) {
                        motorCarInsuredWithOtherCompanyVm.previousVheical = previouspageData;
                    } 
                    //else {}
               // }
            // }, function(error) {
            //     utilityService.showErrorMessage(error.responseMessage);
            // });
        }









        //we will call this function every time 
        function pageLoad() {

           
            uin = generalInsurenceHomeService.getProductDetail();
            motorCarInsuredWithOtherCompanyVm.previousVheicalDetail = {};
            motorCarInsuredWithOtherCompanyVm.previousVheical = {};
            motorCarInsuredWithOtherCompanyVm.previousVheical.claimsInPreviousPolicy = false;
            motorCarInsuredWithOtherCompanyVm.validateService = validateService;
            motorCarInsuredWithOtherCompanyVm.showNext = true;
            motorCarInsuredWithOtherCompanyVm.showBack = true;
            var Motormasters = generalInsurenceMotorService.getMIcommonMaster();
            motorCarInsuredWithOtherCompanyVm.productTypes = Motormasters.policyType;
            motorCarInsuredWithOtherCompanyVm.companyName = Motormasters.insuranceCompany;
            motorCarInsuredWithOtherCompanyVm.proofOfNcbs = Motormasters.proofOFNcb;
            motorCarInsuredWithOtherCompanyVm.NCBPreviousPolicys = Motormasters.ncbOnPrevious;
            motorCarInsuredWithOtherCompanyVm.natureOfLosses = Motormasters.natureOfLoss;
            if (generalInsurenceMotorService.getMotorQuoteFirstPageDetail()) {
                if (motorCarInsuredWithOtherCompanyVm.previousVheical.productType == uin.uin) {
                    motorCarInsuredWithOtherCompanyVm.previousVheical = generalInsurenceMotorService.getMotorQuoteFirstPageDetail();
                }
            }
           


            var motorTypes = generalInsurenceMotorService.getMotorType();
            if (uin.uin != '32') {
                motorCarInsuredWithOtherCompanyVm.title = $translate.instant('motorprivatecar');
            } else {
                motorCarInsuredWithOtherCompanyVm.title = $translate.instant('motortwowheeler');
            }
            
            var oneyearBack = validateService.getFutureYear(generalInsurenceHomeService.getCurrentDate() , -1);
            motorCarInsuredWithOtherCompanyVm.policyMinDate = generalInsurenceHomeService.getFutureDate(new Date(oneyearBack), 2);
            motorCarInsuredWithOtherCompanyVm.toDaysDate = generalInsurenceHomeService.getFutureDate(new Date(motorCarInsuredWithOtherCompanyVm.policyMinDate), 44);
           

            // motorCarInsuredWithOtherCompanyVm.toDaysDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());
            // motorCarInsuredWithOtherCompanyVm.toDaysDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());

             retriewSaveData();
        }


        //added for field levelo validation
        function validateForm() {
            motorCarInsuredWithOtherCompanyVm.previousVheicalDetail = {};
            if (motorCarInsuredWithOtherCompanyVm.validateService.isValidPolicyType(motorCarInsuredWithOtherCompanyVm.previousVheical.policyType)) {
                motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.policyType = motorCarInsuredWithOtherCompanyVm.validateService.isValidPolicyType(motorCarInsuredWithOtherCompanyVm.previousVheical.policyType);
            }

            if (motorCarInsuredWithOtherCompanyVm.validateService.isValidPreviousCompanyName(motorCarInsuredWithOtherCompanyVm.previousVheical.companyName)) {
                motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.companyName = motorCarInsuredWithOtherCompanyVm.validateService.isValidPreviousCompanyName(motorCarInsuredWithOtherCompanyVm.previousVheical.companyName);
            }
            if (motorCarInsuredWithOtherCompanyVm.validateService.isValidPreviousCompanyAdress(motorCarInsuredWithOtherCompanyVm.previousVheical.companyAddress)) {
                motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.companyAddress = motorCarInsuredWithOtherCompanyVm.validateService.isValidPreviousCompanyAdress(motorCarInsuredWithOtherCompanyVm.previousVheical.companyAddress);
            }
            if (motorCarInsuredWithOtherCompanyVm.validateService.isValidPreviousPolicyNumber(motorCarInsuredWithOtherCompanyVm.previousVheical.policyNumber)) {
                motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.policyNumber = motorCarInsuredWithOtherCompanyVm.validateService.isValidPreviousPolicyNumber(motorCarInsuredWithOtherCompanyVm.previousVheical.policyNumber);
            }

            
            if (motorCarInsuredWithOtherCompanyVm.validateService.isValidPolicyStartDate(motorCarInsuredWithOtherCompanyVm.previousVheical.policyStartDate)) {
                motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.policyStartDate = motorCarInsuredWithOtherCompanyVm.validateService.isValidPolicyStartDate(motorCarInsuredWithOtherCompanyVm.previousVheical.policyStartDate);
            }
            if (motorCarInsuredWithOtherCompanyVm.validateService.isValidDateGI(motorCarInsuredWithOtherCompanyVm.previousVheical.policyStartDate,motorCarInsuredWithOtherCompanyVm.policyMinDate,motorCarInsuredWithOtherCompanyVm.toDaysDate)) {
                motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.policyStartDate = motorCarInsuredWithOtherCompanyVm.validateService.isValidDateGI(motorCarInsuredWithOtherCompanyVm.previousVheical.policyStartDate,motorCarInsuredWithOtherCompanyVm.policyMinDate,motorCarInsuredWithOtherCompanyVm.toDaysDate);
            }

            if (motorCarInsuredWithOtherCompanyVm.validateService.isValidPolicyEndDate(motorCarInsuredWithOtherCompanyVm.previousVheical.policyEndDate)) {
                motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.policyEndDate = motorCarInsuredWithOtherCompanyVm.validateService.isValidPolicyEndDate(motorCarInsuredWithOtherCompanyVm.previousVheical.policyEndDate);
            }
           

            if (motorCarInsuredWithOtherCompanyVm.previousVheical.claimsInPreviousPolicy) {
                if (motorCarInsuredWithOtherCompanyVm.validateService.isValidNatureOfLoss(motorCarInsuredWithOtherCompanyVm.previousVheical.natureOfLoss)) {
                    motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.natureOfLoss = motorCarInsuredWithOtherCompanyVm.validateService.isValidNatureOfLoss(motorCarInsuredWithOtherCompanyVm.previousVheical.natureOfLoss);
                }
                if(motorCarInsuredWithOtherCompanyVm.previousVheical.natureOfLoss.key != 'Own Damage'){
                    if (motorCarInsuredWithOtherCompanyVm.validateService.isValidNCBOnPreviousPolicy(motorCarInsuredWithOtherCompanyVm.previousVheical.NCBOnPreviousPolicy)) {
                        motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.NCBOnPreviousPolicy = motorCarInsuredWithOtherCompanyVm.validateService.isValidNCBOnPreviousPolicy(motorCarInsuredWithOtherCompanyVm.previousVheical.NCBOnPreviousPolicy);
                    }
                    if(motorCarInsuredWithOtherCompanyVm.previousVheical.NCBOnPreviousPolicy.key != '1'){
                        if (motorCarInsuredWithOtherCompanyVm.validateService.isValidPreviousProofOfNCB(motorCarInsuredWithOtherCompanyVm.previousVheical.proofOfNCB)) {
                            motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.proofOfNCB = motorCarInsuredWithOtherCompanyVm.validateService.isValidPreviousProofOfNCB(motorCarInsuredWithOtherCompanyVm.previousVheical.proofOfNCB);
                        }
                    }
                }
            } else {
                if (motorCarInsuredWithOtherCompanyVm.validateService.isValidNCBOnPreviousPolicy(motorCarInsuredWithOtherCompanyVm.previousVheical.NCBOnPreviousPolicy)) {
                    motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.NCBOnPreviousPolicy = motorCarInsuredWithOtherCompanyVm.validateService.isValidNCBOnPreviousPolicy(motorCarInsuredWithOtherCompanyVm.previousVheical.NCBOnPreviousPolicy);
                }
                if (motorCarInsuredWithOtherCompanyVm.validateService.isValidPreviousProofOfNCB(motorCarInsuredWithOtherCompanyVm.previousVheical.proofOfNCB)) {
                    motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.proofOfNCB = motorCarInsuredWithOtherCompanyVm.validateService.isValidPreviousProofOfNCB(motorCarInsuredWithOtherCompanyVm.previousVheical.proofOfNCB);
                }

            }

            return (angular.equals({}, motorCarInsuredWithOtherCompanyVm.previousVheicalDetail)) ? true : false;
        }


        //Show popup When user select Liablity in selectBox
        motorCarInsuredWithOtherCompanyVm.showInformationPopup = function() {
            var myPopup = $ionicPopup.show({
                template: '<p>29th Jun 2015: SBIG Renewals is in contention and this will not be considered conversion until confirmation from HCL senior management</p>',
                title: 'Information',
                scope: $scope,
                buttons: [{
                    text: '<b>OK</b>'
                }]
            });

            myPopup.then(function(res) {
                motorCarInsuredWithOtherCompanyVm.previousVheical.policyType = motorCarInsuredWithOtherCompanyVm.productTypes[1];
            });
        }

        //function to clean NCB if nature of loss is Own Damage
        motorCarInsuredWithOtherCompanyVm.clearNCB = function(){
            if(motorCarInsuredWithOtherCompanyVm.previousVheical.natureOfLoss && motorCarInsuredWithOtherCompanyVm.previousVheical.natureOfLoss.key == 'Own Damage' && motorCarInsuredWithOtherCompanyVm.previousVheical.claimsInPreviousPolicy){
                motorCarInsuredWithOtherCompanyVm.previousVheical.NCBOnPreviousPolicy = "";
            }
        }

        motorCarInsuredWithOtherCompanyVm.clearProofOfNcb = function(){
             if (motorCarInsuredWithOtherCompanyVm.previousVheical.claimsInPreviousPolicy) {
                    if(motorCarInsuredWithOtherCompanyVm.previousVheical.natureOfLoss.key != 'Own Damage'){
                        if(motorCarInsuredWithOtherCompanyVm.previousVheical.NCBOnPreviousPolicy.key == '1'){
                            motorCarInsuredWithOtherCompanyVm.previousVheical.proofOfNCB = "";
                        }
                    }
                }
         }
        //function will call when user changes policy type
        motorCarInsuredWithOtherCompanyVm.customerTypeChange = function() {
            if (motorCarInsuredWithOtherCompanyVm.previousVheical.policyType.key == 'Liability') {
                motorCarInsuredWithOtherCompanyVm.showInformationPopup();
            }
        }

        //function will call when user select the start date  
        motorCarInsuredWithOtherCompanyVm.startDateChange = function() {
            if (motorCarInsuredWithOtherCompanyVm.previousVheical) {
                if (motorCarInsuredWithOtherCompanyVm.previousVheical.policyStartDate) {
                    motorCarInsuredWithOtherCompanyVm.previousVheical.policyEndDate = generalInsurenceHomeService.getFutureYear(motorCarInsuredWithOtherCompanyVm.previousVheical.policyStartDate, 1);
                }
            }
            return motorCarInsuredWithOtherCompanyVm.previousVheicalDetail.policyStartDate;
        }

        //function will call when click next page
        motorCarInsuredWithOtherCompanyVm.goToNextPage = function() {
            if (validateForm()) {
                generalInsurenceHomeService.setpolicyStartdate(motorCarInsuredWithOtherCompanyVm.previousVheical.policyEndDate);
                motorCarInsuredWithOtherCompanyVm.previousVheical.productType = uin.uin;
                motorCarInsuredWithOtherCompanyVm.clearProofOfNcb();
                generalInsurenceMotorService.setMotorQuoteFirstPageDetail(motorCarInsuredWithOtherCompanyVm.previousVheical);
              SetSaveApplicationForHome();
            
            }
        }



        //function will call when click previous Page 
        motorCarInsuredWithOtherCompanyVm.goBacktoPrevious = function() {
            $state.go('menu.motorGetQuote');
        }


        //function will call before page load
        $scope.$on('$ionicView.beforeEnter', function() {
            pageLoad();
        });



    }
]);


// })();
