angularApp.controller('motorInsurerAddressDetailsController', [
        "$state",
        "$scope",
        "$translate",
        "$stateParams",
        "$filter",
        "validateService", "generalInsurenceMotorService","generalInsurenceHomeService","utilityService","GIconstant","clickStreamService",


        function(
            $state,
            $scope,
            $translate,
            $stateParams,
            $filter,
            validateService, generalInsurenceMotorService,generalInsurenceHomeService,utilityService,GIconstant,clickStreamService
        ) {

            //functions, variables that can be accessed from the HTML come here
            var motorInsurerAddressDetailsVm = this;
            motorInsurerAddressDetailsVm.showBack = true;
            motorInsurerAddressDetailsVm.showNext = true;
            motorInsurerAddressDetailsVm.travelNomineeDetailsForm = {};
            motorInsurerAddressDetailsVm.locationDetail = {};
            motorInsurerAddressDetailsVm.validateService = validateService;
             var productType,savedApplication;



             function SetSaveApplicationForMotor(dataDetail) {
            

             var SavePageDetail = GIconstant.saveForMotor.PersonalAddressDetails;
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, motorInsurerAddressDetailsVm.locationDetail, modelname, SavePageDetail[count].type);
            }
            savedApplication.applicationData.partyDetails = generalInsurenceHomeService.getCreatePartyCI().partyCreate;
            savedApplication.applicationData.createquoterequest.insuredDetails.locationSource = generalInsurenceHomeService.getLocatiopnBasedPincode();       
        
            var JsonStingedData = angular.copy(savedApplication);
            generalInsurenceMotorService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
             JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
            generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Motor.MI_OWNER_DETAILS_2).then(function(data) {
             $state.go("menu.motorInsurerVehicleInfo");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
          




            //private methods section start
            function initPage() {
               if(generalInsurenceMotorService.getMotorQuoteFourthPageDetail().nomineeRequired){
                motorInsurerAddressDetailsVm.totalLength = true;
            }else{
                motorInsurerAddressDetailsVm.totalLength = false;
            }
              savedApplication = generalInsurenceMotorService.getSavedData();

               productType = generalInsurenceHomeService.getProductDetail().uin;

                 if (productType == '31') {
                motorInsurerAddressDetailsVm.title = $translate.instant('motorprivatecar');
            } else if (productType == '32') {
                motorInsurerAddressDetailsVm.title = $translate.instant('motortwowheeler');
            }

                if (generalInsurenceMotorService.getprepopulatePersonalDetail()) {

                    var PersonalDetails = generalInsurenceHomeService.getIIBaccountDetail();
                    if(PersonalDetails){
                        
                       
                        if(generalInsurenceMotorService.getMotorPersonalSecondPageDetail()){
                           motorInsurerAddressDetailsVm.locationDetail =  generalInsurenceMotorService.getMotorPersonalSecondPageDetail();
                        }else{
                          motorInsurerAddressDetailsVm.locationDetail = {};
                           motorInsurerAddressDetailsVm.locationDetail.city = PersonalDetails.cbsData.city;
                           motorInsurerAddressDetailsVm.locationDetail.pin = PersonalDetails.cbsData.pinCode;
                           motorInsurerAddressDetailsVm.locationDetail.plotNO = PersonalDetails.cbsData.addressLine1;
                           motorInsurerAddressDetailsVm.locationDetail.plotNO = motorInsurerAddressDetailsVm.locationDetail.plotNO ? motorInsurerAddressDetailsVm.locationDetail.plotNO.replace(/[^A-Za-z0-9./,-\s]/g, '') : '';
                           motorInsurerAddressDetailsVm.locationDetail.BuildingName = PersonalDetails.cbsData.addressLine2;
                            motorInsurerAddressDetailsVm.locationDetail.StreetName = PersonalDetails.cbsData.addressLine3;
                        }
                        
                        motorInsurerAddressDetailsVm.getLocation ();
                    }
                    };                  
                    
                }

         //   }


             motorInsurerAddressDetailsVm.getLocation = function() {
          
            if(motorInsurerAddressDetailsVm.locationDetail.pin && motorInsurerAddressDetailsVm.locationDetail.pin.length==6){
                var detail = {
                           "pinCode": motorInsurerAddressDetailsVm.locationDetail.pin
                         }

                    generalInsurenceHomeService.getLocation(detail).then(function(data) {
                      generalInsurenceHomeService.setLocatiopnBasedPincode(data);
                              if(data){
                                    motorInsurerAddressDetailsVm.locationDetail.State = data.state.value;
                                   motorInsurerAddressDetailsVm.locationDetail.city = data.city.cityName;
                                    motorInsurerAddressDetailsVm.localitions = data.location;
                                     motorInsurerAddressDetailsVm.locationDetail.stateKey = data.state.key;
                                   motorInsurerAddressDetailsVm.locationDetail.cityCode = data.city.cityCode;


                              }
                           
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                     });
            }
            
     }




            //actions to done when user clicks previous page
            motorInsurerAddressDetailsVm.goToPreviousPage = function() {
                $state.go("menu.motorInsurerPersonalDetails");

            }


          


            //actions to done everytime the view is shown
            $scope.$on('$ionicView.beforeEnter', function() {
                initPage();
            });

             function createPartyIdJson(){
            // "dob": healthApplicationPersonalDetailsVm.data.birthdate,
            var firstPageDetail =  generalInsurenceMotorService.getMotorPersonalFirstPageDetail();
            var secondpageDetail = motorInsurerAddressDetailsVm.locationDetail;
            var locationDetail =  generalInsurenceHomeService.getLocatiopnBasedPincode();
            var personalDetail =   {
                  "partyCreate": {
                  "salutation": "9000000001",
                  "firstName":firstPageDetail.firstName,
                  "middleName":"",
                  "lastName": firstPageDetail.LastName,
                  "dob":  $filter('dateFormat')(firstPageDetail.birthday),
                  "gender": "M",
                  "emailID": firstPageDetail.emailID,
                  "mobile": firstPageDetail.mobileNumber,

                  "plotNo": secondpageDetail.plotNO,
                  "buildingName":motorInsurerAddressDetailsVm.locationDetail.BuildingName, 
                  "streetName":motorInsurerAddressDetailsVm.locationDetail.StreetName,
                  "cityName":locationDetail.city.cityCode,
                  "stateName": locationDetail.city.stateCode,
                  "pinCode": secondpageDetail.locality.pinId,
                  "districtName": locationDetail.district.districtCode,
                  "locality": motorInsurerAddressDetailsVm.locationDetail.loc,
                  "addressType":"CurrentAddress",
                  "partyRole": "Policy Holder",
                  "maritalStatus":"",
                  "occupation":""
                }
              }
              generalInsurenceHomeService.getPartyCreation(personalDetail).then(function(data) {
                generalInsurenceMotorService.setPartyDetails(personalDetail);
                 generalInsurenceHomeService.setCreatePartyCI(data);
                 SetSaveApplicationForMotor();
                 
                }, function(error) {
                   utilityService.showErrorMessage(error.responseMessage);
            });
         }






            //conmmon validation function to go to next page
            motorInsurerAddressDetailsVm.goToNextPage = function() {
                if (validateForm()) {
                    clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                    generalInsurenceMotorService.setMotorPersonalSecondPageDetail(motorInsurerAddressDetailsVm.locationDetail);
                    createPartyIdJson();
                    
                }

            }

            //conmmon validation function to validatte fields
            function validateForm() {
                motorInsurerAddressDetailsVm.travelNomineeDetailsForm = {};

                 if (motorInsurerAddressDetailsVm.validateService.isValidlocality(motorInsurerAddressDetailsVm.locationDetail.locality)) {
                    motorInsurerAddressDetailsVm.travelNomineeDetailsForm.locality = motorInsurerAddressDetailsVm.validateService.isValidlocality(motorInsurerAddressDetailsVm.locationDetail.locality);
                }

                 if (motorInsurerAddressDetailsVm.validateService.isValidplotNO(motorInsurerAddressDetailsVm.locationDetail.plotNO)) {
                    motorInsurerAddressDetailsVm.travelNomineeDetailsForm.plotNO = motorInsurerAddressDetailsVm.validateService.isValidplotNO(motorInsurerAddressDetailsVm.locationDetail.plotNO);
                }


                if (motorInsurerAddressDetailsVm.validateService.isValidBuildingName(motorInsurerAddressDetailsVm.locationDetail.BuildingName)) {
                    motorInsurerAddressDetailsVm.travelNomineeDetailsForm.BuildingName = motorInsurerAddressDetailsVm.validateService.isValidBuildingName(motorInsurerAddressDetailsVm.locationDetail.BuildingName);
                }
                
                if (motorInsurerAddressDetailsVm.validateService.isValidStreetName(motorInsurerAddressDetailsVm.locationDetail.StreetName)) {
                    motorInsurerAddressDetailsVm.travelNomineeDetailsForm.StreetName = motorInsurerAddressDetailsVm.validateService.isValidStreetName(motorInsurerAddressDetailsVm.locationDetail.StreetName);
                }
                
                if (motorInsurerAddressDetailsVm.validateService.isValidCity(motorInsurerAddressDetailsVm.locationDetail.city)) {
                    motorInsurerAddressDetailsVm.travelNomineeDetailsForm.CITY = motorInsurerAddressDetailsVm.validateService.isValidCity(motorInsurerAddressDetailsVm.locationDetail.city);
                }

                if (motorInsurerAddressDetailsVm.validateService.isValidState(motorInsurerAddressDetailsVm.locationDetail.State)) {
                    motorInsurerAddressDetailsVm.travelNomineeDetailsForm.State = motorInsurerAddressDetailsVm.validateService.isValidState(motorInsurerAddressDetailsVm.locationDetail.State);
                }

                if (motorInsurerAddressDetailsVm.validateService.isValidPincode(motorInsurerAddressDetailsVm.locationDetail.pin)) {
                    motorInsurerAddressDetailsVm.travelNomineeDetailsForm.PINCODE = motorInsurerAddressDetailsVm.validateService.isValidPincode(motorInsurerAddressDetailsVm.locationDetail.pin);
                }
                return (angular.equals({}, motorInsurerAddressDetailsVm.travelNomineeDetailsForm)) ? true : false;
            }

        }
    ]);



// })();
