angularApp.controller('motorInsurerFinancialDetailsController', [
    "$scope",
    "$translate", "$filter", "validateService", "generalInsurenceMotorService", "generalInsurenceHomeService", "generalInsurenceHealthService", "utilityService", "GIconstant", "$state","clickStreamService",



    function(
        $scope,
        $translate, $filter, validateService, generalInsurenceMotorService, generalInsurenceHomeService, generalInsurenceHealthService, utilityService, GIconstant, $state,clickStreamService

    ) {

        //functions, variables that can be accessed from the HTML come here
        var motorInsurerFinancialDetailsVm = this;
        var savedApplication;
        motorInsurerFinancialDetailsVm.showBack = true;
        motorInsurerFinancialDetailsVm.showNext = true;
        motorInsurerFinancialDetailsVm.financeOptions = {};
        motorInsurerFinancialDetailsVm.FinanceDetails = {};
        motorInsurerFinancialDetailsVm.validateService = validateService;
        var productType;
        //private methods section start
        function initPage() {
            if (generalInsurenceMotorService.getMotorQuoteFourthPageDetail().nomineeRequired) {
                motorInsurerFinancialDetailsVm.totalLength = true;
            } else {
                motorInsurerFinancialDetailsVm.totalLength = false;
            }
            motorInsurerFinancialDetailsVm.termsConditionCheck = false;
            savedApplication = generalInsurenceMotorService.getSavedData();
            productType = generalInsurenceHomeService.getProductDetail().uin;

            if (productType == '31') {
                motorInsurerFinancialDetailsVm.title = $translate.instant('motorprivatecar');
            } else if (productType == '32') {
                motorInsurerFinancialDetailsVm.title = $translate.instant('motortwowheeler');
            }

            var dataOfPaeg = generalInsurenceMotorService.getMotorPersonalThirdPageDetail()
            if (dataOfPaeg.financeType == "financed") {
                motorInsurerFinancialDetailsVm.showFinance = true;
            } else {
                motorInsurerFinancialDetailsVm.showFinance = false;
            }
            var pageDetail = generalInsurenceMotorService.getMotorPersonalFourthPageDetail();
            if (pageDetail) {
                motorInsurerFinancialDetailsVm.FinanceDetails = generalInsurenceMotorService.getMotorPersonalFourthPageDetail();
            } else {
                motorInsurerFinancialDetailsVm.FinanceDetails = {};
            }
        }

        function setSaveApplicationForMotor() {
            var SavePageDetail = GIconstant.saveForMotor.motorVheicleFinanceDetail;
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, motorInsurerFinancialDetailsVm.FinanceDetails, modelname, SavePageDetail[count].type);
            }
            var JsonStingedData = angular.copy(savedApplication);
            generalInsurenceMotorService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
            JsonStingedData.listId = "";
            JsonStingedData.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            JsonStingedData.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";

            generalInsurenceHomeService.saveApplication(JsonStingedData, GIconstant.OmniChannel.Motor.MI_INSURED_DETAILS_2).then(function(data) {
                craeteJSONforMotor();
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }





        function craeteJSONforMotor() {
            var quotefirstPage = generalInsurenceMotorService.getMotorQuoteSecondPageDetail();
            var quoteSecondPage = generalInsurenceMotorService.getMotorQuoteThirdPageDetail();
            var quoteDetail = generalInsurenceMotorService.getQuoteDetail();
            var firstPage = generalInsurenceMotorService.getMotorPersonalFirstPageDetail();
            var secondPage = generalInsurenceMotorService.getMotorPersonalSecondPageDetail();
            var thirdPage = generalInsurenceMotorService.getMotorPersonalThirdPageDetail();
            var fourthPage = generalInsurenceMotorService.getMotorQuoteFourthPageDetail();
            var locationDetail = generalInsurenceHomeService.getLocatiopnBasedPincode();
            var partyDetail = generalInsurenceHomeService.getCreatePartyCI();
            var firstPageDetail = generalInsurenceMotorService.getMotorQuoteFirstPageDetail();
            var policyCTDetails = [];
            var policyClauseSOABOList = [];

            for (var count = 0; count < quoteDetail.insuredDetails.length; count++) {
                policyClauseSOABOList = quoteDetail.policyClauseSOABOList;
                for (var i = 0; i < quoteDetail.insuredDetails[count].policyCtDetails.length; i++) {
                    policyCTDetails[policyCTDetails.length] = quoteDetail.insuredDetails[count].policyCtDetails[i];
                }

            }
            var motorDetail = {};
            var vheicleType = generalInsurenceMotorService.getMotorTypeDetail();
            //var age = $filter('calculateMonth')(quoteSecondPage.dateOfRegistration, validateService.getCurrentDate());
            var age;
            var policyMotorStartDate = generalInsurenceHomeService.getpolicyStartdate();
            if(generalInsurenceMotorService.getMotorTypeDetail() == "new"){
                age = "0.000";
            }else{
                policyMotorStartDate = validateService.getFutureDate(policyMotorStartDate,1);
                age = validateService.calculateAgeOfVehicle(policyMotorStartDate,quoteSecondPage.dateOfRegistration);
            }
            var previousVheicleDetail = {};
            if(savedApplication.quoteData.motorDetails.previousPolicyDetails){
                previousVheicleDetail =  {
                                "policyType": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.policyType : "",
                                "companyName": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.companyName : "",
                                "companyAddress": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.companyAddress : "",
                                "policyNumber": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.policyNumber : "",
                                "isClaimed": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.isClaimed : false,
                                "policyStartDate": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.policyStartDate : "",
                                "policyEndDate": savedApplication.quoteData.motorDetails.previousPolicyDetails ? savedApplication.quoteData.motorDetails.previousPolicyDetails.policyEndDate : "",
                                "ncb": (savedApplication.quoteData.motorDetails.previousPolicyDetails && savedApplication.quoteData.motorDetails.previousPolicyDetails.ncb) ? savedApplication.quoteData.motorDetails.previousPolicyDetails.ncb : "",
                                "proofOfNcb": (savedApplication.quoteData.motorDetails.previousPolicyDetails && savedApplication.quoteData.motorDetails.previousPolicyDetails.proofOfNcb.key) ? savedApplication.quoteData.motorDetails.previousPolicyDetails.proofOfNcb.key : "",
                                "natureOfLoss": (savedApplication.quoteData.motorDetails.previousPolicyDetails && savedApplication.quoteData.motorDetails.previousPolicyDetails.natureOfLoss) ? savedApplication.quoteData.motorDetails.previousPolicyDetails.natureOfLoss : "",
                            }
            }else{
                previousVheicleDetail = {};
            }

            if (productType == '32') {



                motorDetail = {
                    "createquoterequest": {
                        "quoteDetails": {
                            "quoteNumber": quoteDetail.quoteNumber,
                            "policyID": quoteDetail.policyID,
                            "ppId": quoteDetail.ppId,
                            "policyctID": quoteDetail.policyCtId,
                            "insuredId": quoteDetail.insuredId,
                            "policyStartDate": quoteDetail.effectDate,
                            "policyEndDate": quoteDetail.expiryDate,
                           // "previousPolicyDetails": previousVheicleDetail

                        },

                        "insuredDetails": {
                            "partyId": partyDetail.partyCreate.partyID,
                            "title": firstPage.title.value,
                            "firstName": firstPage.firstName,
                            "lastName": firstPage.LastName,
                            "dob": $filter('dateFormat')(firstPage.birthday),
                            "ageOfDriver": thirdPage.DriverExperience.key.toString(),
                            "gender": firstPage.gender.key,
                            "emailId": firstPage.emailID,
                            "mobileNumber": firstPage.mobileNumber,
                            "plotNo": secondPage.plotNO,
                            "buildingNo": secondPage.BuildingName,
                            "streetName": secondPage.StreetName,
                            "location": secondPage.locality.loc,
                            "city": secondPage.cityCode,
                            "district": locationDetail.district.districtName,
                            "state": locationDetail.state.value,
                            "pincode1": secondPage.pin
                        },
                        "vehicleDetails": {
                            "make": quotefirstPage.vehicleMake.key.toString(),
                            "model": quotefirstPage.vehicleModel.modId,
                            "varient": quotefirstPage.vehicleVariant.vaId,
                            "cubicCapacity": quotefirstPage.vehicleVariant.cc,
                            "fuelType": quotefirstPage.vehicleVariant.fuelType,
                            "yearOfManufacture": quoteSecondPage.yearOfManufacture.toString(),
                            "ageOfVehicle": age + "",
                            "rtoCity": quoteSecondPage.selectedRTO.rtoDisCode,
                            "rtoState": quoteSecondPage.selectedRTO.stateId,
                            "rtoLocation": quoteSecondPage.selectedRTO.locationId,
                            "purchaseType": thirdPage.vehiclePurchaseAs && thirdPage.vehiclePurchaseAs.key == "NA" ? "3" : thirdPage.vehiclePurchaseAs.key,
                            "regnNumber": thirdPage.registrationNumber,
                            "regnDate": new Date(quoteSecondPage.dateOfRegistration),
                            "engineNumber": thirdPage.engineNumber,
                            "chassisNumber": thirdPage.chassisNumber,
                            "idv": fourthPage.suggestedIDV,
                            "isSelfOwned": thirdPage.financeType=="self" ? true : false,
                            "licensedSeatingCapacity": quotefirstPage.vehicleVariant.seating,
                            "numberOfWheels": quotefirstPage.vehicleVariant.wheels,
                            "licensedCarryingCapacity": quotefirstPage.vehicleVariant.carrying,
                            "exshowroomPrice": quoteSecondPage.selectedRTO.desc1,
                            "drivingExperience": thirdPage.DriverExperience.key.toString(),
                            "nightParkingPincode": fourthPage.nightParkingPincode,
                            "pincode2": fourthPage.nightParkingPincode
                        },
                        "financeDetails": {
                            "companyName": motorInsurerFinancialDetailsVm.FinanceDetails.financeCompanyName ? motorInsurerFinancialDetailsVm.FinanceDetails.financeCompanyName : "",
                            "companyCity": motorInsurerFinancialDetailsVm.FinanceDetails.companyCity ? motorInsurerFinancialDetailsVm.FinanceDetails.companyCity : "",
                            "fnanceType": motorInsurerFinancialDetailsVm.FinanceDetails.financeType ? motorInsurerFinancialDetailsVm.FinanceDetails.financeType.key : ""
                        },
                        "policyClauseSOABOList": policyClauseSOABOList,
                        "policyCtDetails": policyCTDetails,
                        "isAdditionalCoverage": savedApplication.quoteData.additonalCoverage ? (savedApplication.quoteData.additonalCoverage.length > 0) ? "Yes" : "No" : "No",
                        "additonalCoverage": savedApplication.quoteData.additonalCoverage ? savedApplication.quoteData.additonalCoverage : "",
                        "voluntaryDeductibles": savedApplication.quoteData.motorDetails.vehicleDetails.voluntaryDeductibles ? savedApplication.quoteData.motorDetails.vehicleDetails.voluntaryDeductibles.key : ""
                    }
                }



            } else {



                motorDetail = {
                    "createquoterequest": {
                        "quoteDetails": {
                            "quoteNo": quoteDetail.quoteNumber,
                            "policyID": quoteDetail.policyID,
                            "ppID": quoteDetail.ppId,
                            "policyctID": quoteDetail.policyCtId,
                            "insuredID": quoteDetail.insuredId,
                            "policyStartDate": quoteDetail.effectDate,
                            "policyEndDate": quoteDetail.expiryDate,
                           // "previousPolicyDetails": previousVheicleDetail
                        },
                        "insuredDetails": {
                            "partyId": partyDetail.partyCreate.partyID,
                            "title": firstPage.title.value,
                            "firstName": firstPage.firstName,
                            "lastName": firstPage.LastName,
                            "dob": $filter('dateFormat')(firstPage.birthday),
                            "ageOfDriver": thirdPage.DriverExperience.key.toString(),
                            "gender": firstPage.gender.key,
                            "emailId": firstPage.emailID,
                            "mobileNumber": firstPage.mobileNumber,
                            "plotNo": secondPage.plotNO,
                            "buildingNo": secondPage.BuildingName,
                            "streetName": secondPage.StreetName,
                            "location": secondPage.locality.loc,
                            "city": secondPage.cityCode,
                            "district": locationDetail.district.districtName,
                            "state": locationDetail.state.value,
                            "pincode1": secondPage.pin
                        },
                        "vehicleDetails": {
                            "idv": fourthPage.suggestedIDV,
                            "make": quotefirstPage.vehicleMake.key.toString(),
                            "model": quotefirstPage.vehicleModel.modId,
                            "varient": quotefirstPage.vehicleVariant.vaId,
                            "cubicCapacity": quotefirstPage.vehicleVariant.cc,
                            "fuelType": quotefirstPage.vehicleVariant.fuelType,
                            "yearOfManufacture": quoteSecondPage.yearOfManufacture.toString(),
                            "ageOfVehicle": age,
                            "rtoCity": quoteSecondPage.selectedRTO.rtoDisCode,
                            "rtoState": quoteSecondPage.selectedRTO.stateId,
                            "rtoLocation": quoteSecondPage.selectedRTO.locationId,
                            "purchaseType": thirdPage.vehiclePurchaseAs.key == "NA" ? "3" : thirdPage.vehiclePurchaseAs.key,
                            "regnNumber": thirdPage.registrationNumber,
                            "regnDate": new Date(quoteSecondPage.dateOfRegistration),
                            "engineNumber": thirdPage.engineNumber,
                            "chassisNumber": thirdPage.chassisNumber,
                            "isSelfOwned": thirdPage.financeType=="self" ? true : false,
                            "drivingExperience": savedApplication.applicationData.createquoterequest.vehicleDetails ? savedApplication.applicationData.createquoterequest.vehicleDetails.drivingExperience.toString() : "",
                            "pincode2": savedApplication.quoteData.motorDetails.vehicleDetails ? savedApplication.quoteData.motorDetails.vehicleDetails.nightParkingPincode : "",
                            "licensedSeatingCapacity": quotefirstPage.vehicleVariant.seating,
                            "usedVehicleOrNewVehicle": vheicleType,
                            "numberOfWheels": quotefirstPage.vehicleVariant.wheels,
                            "licensedCarryingCapacity": quotefirstPage.vehicleVariant.carrying,
                            "bodyStyleDescription": quotefirstPage.vehicleVariant.bodyStyle,
                            "exshowroomPrice": quoteSecondPage.selectedRTO.desc1,
                            "drivingAge": savedApplication.applicationData.createquoterequest.vehicleDetails ? savedApplication.applicationData.createquoterequest.vehicleDetails.drivingExperience.toString() : "",
                            "nightParkingPincode": savedApplication.quoteData.motorDetails.vehicleDetails ? savedApplication.quoteData.motorDetails.vehicleDetails.nightParkingPincode : "",
                            "noofPaidDrivers": (savedApplication.quoteData.motorDetails.vehicleDetails && savedApplication.quoteData.motorDetails.vehicleDetails.noofPaidDrivers) ? savedApplication.quoteData.motorDetails.vehicleDetails.noofPaidDrivers : ""
                        },
                        "financeDetails": {
                            "companyName": motorInsurerFinancialDetailsVm.FinanceDetails.financeCompanyName ? motorInsurerFinancialDetailsVm.FinanceDetails.financeCompanyName : "",
                            "companyCity": motorInsurerFinancialDetailsVm.FinanceDetails.companyCity ? motorInsurerFinancialDetailsVm.FinanceDetails.companyCity : "",
                            "financeType": motorInsurerFinancialDetailsVm.FinanceDetails.financeType ? motorInsurerFinancialDetailsVm.FinanceDetails.financeType.key : ""
                        },
                        "policyClauseSOABOList": policyClauseSOABOList,
                        "policyCtDetails": policyCTDetails,
                        "isAdditionalCoverage": savedApplication.quoteData.additonalCoverage ? (savedApplication.quoteData.additonalCoverage.length > 0) ? "Yes" : "No" : "No",
                        "additonalCoverage": savedApplication.quoteData.additonalCoverage ? savedApplication.quoteData.additonalCoverage : "",
                        "voluntaryDeductibles": savedApplication.quoteData.motorDetails.vehicleDetails.voluntaryDeductibles ? savedApplication.quoteData.motorDetails.vehicleDetails.voluntaryDeductibles.key : ""
                    }
                }


            }

            if(savedApplication.quoteData.motorDetails.previousPolicyDetails){
                    motorDetail.createquoterequest.quoteDetails.previousPolicyDetails = previousVheicleDetail;
            }
            if (generalInsurenceMotorService.getMotorQuoteFourthPageDetail().nomineeRequired) {
                generalInsurenceMotorService.setMotorPersonalFourthPageDetail(motorInsurerFinancialDetailsVm.FinanceDetails);
                $state.go("menu.travelNomineeDetails");
            } else {
                generalInsurenceMotorService.applyMIProduct(motorDetail, productType).then(function(data) {
                    generalInsurenceHealthService.setQuotecalculation(data);
                    $state.go("menu.motorPurchaseSummary");

                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }




        }

        motorInsurerFinancialDetailsVm.financeType = generalInsurenceMotorService.getMIcommonMaster().financeType;
        motorInsurerFinancialDetailsVm.termsCondition = "I have read and agreed to the Terms and Conditions";

        //added for field levelo validation
        function validateForm() {
            motorInsurerFinancialDetailsVm.financeOptions = {};
            if (motorInsurerFinancialDetailsVm.showFinance) {
                if (motorInsurerFinancialDetailsVm.validateService.isValidFinaceType(motorInsurerFinancialDetailsVm.FinanceDetails.financeType)) {
                    motorInsurerFinancialDetailsVm.financeOptions.financeType = motorInsurerFinancialDetailsVm.validateService.isValidFinaceType(motorInsurerFinancialDetailsVm.FinanceDetails.financeType);
                }
                if (motorInsurerFinancialDetailsVm.validateService.isValidFinaceCompanyName(motorInsurerFinancialDetailsVm.FinanceDetails.financeCompanyName)) {
                    motorInsurerFinancialDetailsVm.financeOptions.financeCompanyName = motorInsurerFinancialDetailsVm.validateService.isValidFinaceCompanyName(motorInsurerFinancialDetailsVm.FinanceDetails.financeCompanyName);
                }
                if (motorInsurerFinancialDetailsVm.validateService.isValidFinaceCompanyCity(motorInsurerFinancialDetailsVm.FinanceDetails.companyCity)) {
                    motorInsurerFinancialDetailsVm.financeOptions.companyCity = motorInsurerFinancialDetailsVm.validateService.isValidFinaceCompanyCity(motorInsurerFinancialDetailsVm.FinanceDetails.companyCity);
                }
            }



            return (angular.equals({}, motorInsurerFinancialDetailsVm.financeOptions)) ? true : false;
        }


        motorInsurerFinancialDetailsVm.clickTerm = function() {
            generalInsurenceHomeService.getTermsAndCondtion();

            // .then(function(data) {
            // }, function(error) {
            //    utilityService.showErrorMessage(error.responseMessage);
            // });
        }



        //actions to done when user clicks Next page
        motorInsurerFinancialDetailsVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;     
                if (motorInsurerFinancialDetailsVm.showFinance && (generalInsurenceMotorService.getSavedFinance() == null && generalInsurenceMotorService.getSavedFinance() == undefined)) {
                    var listId = generalInsurenceMotorService.getSavedFinance();
                    if (listId) {
                        listId = listId.split("#")[1];
                    }
                    var motorDetail = {
                        "saveFinanceRequest": {
                            "accNumber": "",
                            "address": motorInsurerFinancialDetailsVm.FinanceDetails.companyCity,
                            "agreementType": motorInsurerFinancialDetailsVm.FinanceDetails.financeType.key,
                            "branchName": "",
                            "branchAddress": "",
                            "companyName": motorInsurerFinancialDetailsVm.FinanceDetails.financeCompanyName,
                            "listId": listId ? listId : "",
                            "quoteNumber": generalInsurenceMotorService.getQuoteDetail().quoteNumber,
                            "remarks": "",
                            "typeLoan": ""
                        }

                    }

                    generalInsurenceMotorService.saveFinance(motorDetail).then(function(data) {
                        motorInsurerFinancialDetailsVm.FinanceDetails.listId = data.status.split("#")[1];
                        setSaveApplicationForMotor();
                        generalInsurenceMotorService.setSavedFinance(data.status);
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                } else {
                    craeteJSONforMotor();

                }


            }

        }


        motorInsurerFinancialDetailsVm.clickDeclaration = function() {
            generalInsurenceHomeService.getDiclaration().then(function(data) {

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };


        //actions to done when user clicks previous page
        motorInsurerFinancialDetailsVm.goToPreviousPage = function() {
            $state.go("menu.motorInsurerVehicleInfo");
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


    }
]);


// })();
