angularApp.controller('motorNewCarApplicationController', [
        "$state",
        "$scope",
        "$stateParams",


        function(
            $state,
            $scope,
            $stateParams) {

            var motorNewCarApplicationVm = this;
            //function will call when page load
            function initPage() {
                motorNewCarApplicationVm.Application_Title = 'Application';
                motorNewCarApplicationVm.HealthInfo = 'Health information';
                motorNewCarApplicationVm.number = 0;
            }

            //one time initialization to be done when the controller is loaded
            $scope.$on('$ionicView.loaded', function() {
                initPage();
            });


            //actions will call when user will clicks the previous button
            motorNewCarApplicationVm.goBacktoPrevious = function() {
                //To do
                if ($stateParams.page == "newcar") {
                    $state.go("menu.motorGetQuote");
                } else if ($stateParams.page == "rollover") {
                    $state.go("menu.motorCarInsuredWithOtherCompany");
                }
            }

            //actions will call when user clicks the next button
            motorNewCarApplicationVm.goToNextPage = function() {
                $state.go("menu.motorNewCarGetCarInfo");
                //To do
            }

            //actions will call when user clicks the decrement button
            motorNewCarApplicationVm.decrement = function() {
                motorNewCarApplicationVm.number--;
            }

            //actions will call when user clicks the plus button
            motorNewCarApplicationVm.increment = function() {
                motorNewCarApplicationVm.number++;
            }

            //actions to done everytime the view is shown
            $scope.$on('$ionicView.beforeEnter', function() {
                initPage();
            });

        }
    ]);


// })();
