angularApp.controller('accidentQuoteMemberInfoController', [ "$state", "$scope", "validateService", "$filter", "generalInsurenceAccidentService", "generalInsurenceHomeService","utilityService","$timeout","GIconstant","clickStreamService",
        function( $state, $scope,  validateService, $filter, generalInsurenceAccidentService, generalInsurenceHomeService,utilityService,$timeout,GIconstant,clickStreamService) {


        //functions, variables that can be accessed from the HTML come here
        var accidentQuoteMemberInfoVm = this;
        var savedApplication;
        var rupeeSymbol = String.fromCharCode(8377);
        //private methods section start

        function callmasterForPAI(){
              generalInsurenceAccidentService.getPersonalAccidentMasters().then(function(data) {
               generalInsurenceAccidentService.setMasterData(data);
            }, function(error) {
                 utilityService.showErrorMessage(error.responseMessage);
            });
        }
            function SetSaveApplicationForTravel() {
         //   var SavePageDetail = GIconstant.saveForMotor.TravelPolicyDetail;
         if(savedApplication){
            if(savedApplication.quoteData){
                if(savedApplication.quoteData.productDetails){
                }else{
                     savedApplication.quoteData = {};
                }
            }
        }else {
            savedApplication = {};
            savedApplication.quoteData = {};
        }

        savedApplication.quoteData =  {
          "policyStartDate": new Date(accidentQuoteMemberInfoVm.startDate),
          "policyEndDate":   new Date(accidentQuoteMemberInfoVm.endDate),
          "premiumAmount": accidentQuoteMemberInfoVm.premiumAmount.value.replace(String.fromCharCode(8377),""),
          "sumInsured": $filter('formatAmount')(accidentQuoteMemberInfoVm.FinalSumInsured),
        }
   
             var JsonStingedData = angular.copy(savedApplication);

              if(generalInsurenceHomeService.isJson(savedApplication.quoteData)){
                        savedApplication.quoteData = JSON.parse(savedApplication.quoteData);
                    }
                    if(generalInsurenceHomeService.isJson(savedApplication.applicationData)){
                        savedApplication.applicationData = JSON.parse(savedApplication.applicationData);
                    }
                    
             generalInsurenceAccidentService.setSavedData(savedApplication);
             JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
             JsonStingedData.cif = "";
             JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
             JsonStingedData.mobileNumber = "";
             JsonStingedData.uin = generalInsurenceHomeService.getProductDetail().uin;
             JsonStingedData.productCode = generalInsurenceHomeService.getGIProductsID();
             JsonStingedData.planName = generalInsurenceHomeService.getProductDetail().policyName;
             JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
              JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
            generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.PAI.PAI_PREMIUM).then(function(data) {
               $state.go('menu.accidentApplicationInsurerInfo');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        function initPage() {


                accidentQuoteMemberInfoVm.premiumAmount = {
                    value: 100,
                    options: {
                        showTicksValues: true,
                        stepsArray: [
    
                            { value:  rupeeSymbol+'100', legend: rupeeSymbol+'2L' },
                            { value: rupeeSymbol+'200', legend:  rupeeSymbol+'4L' },
                            { value: rupeeSymbol+'500', legend:  rupeeSymbol+'10L' },
                            { value: rupeeSymbol+'1000', legend: rupeeSymbol+'20L' }
                        ],
                        hideLimitLabels: true,
                        showSelectionBar: true,
                        onChange: function() {
                            var findSteps;
                            var SumInsuredValue;
                            for (findSteps = 0; findSteps <= accidentQuoteMemberInfoVm.premiumAmount.options.stepsArray.length; findSteps++) {
                                if (accidentQuoteMemberInfoVm.premiumAmount.value == accidentQuoteMemberInfoVm.premiumAmount.options.stepsArray[findSteps].value) {
                                    if(accidentQuoteMemberInfoVm.premiumAmount.value == rupeeSymbol+'100'){
                                        accidentQuoteMemberInfoVm.FinalSumInsured = "2,00,000"
                                    } else if(accidentQuoteMemberInfoVm.premiumAmount.value == rupeeSymbol+'200'){
                                        accidentQuoteMemberInfoVm.FinalSumInsured = "4,00,000"
                                    }
                                    else  if(accidentQuoteMemberInfoVm.premiumAmount.value == rupeeSymbol+'500'){
                                        accidentQuoteMemberInfoVm.FinalSumInsured = "10,00,000"

                                    } else{
                                         accidentQuoteMemberInfoVm.FinalSumInsured = "20,00,000"
                                    }
                                   
                                   // accidentQuoteMemberInfoVm.FinalSumInsured = accidentQuoteMemberInfoVm.premiumAmount.options.stepsArray[findSteps].legend;
                                    break;
                                }
                            }


                        }
                    }
                };
                
                callmasterForPAI();
               // retriewSaveData();
                accidentQuoteMemberInfoVm.showBack = true;
                accidentQuoteMemberInfoVm.showNext = true;
                accidentQuoteMemberInfoVm.FinalSumInsured = "2L";
                accidentQuoteMemberInfoVm.FinalSumInsured = "2,00,000";

                /* get Sum Insured And Premium Amount from user click*/
               
                /* set policy start and end date  */
                var startDate = generalInsurenceHomeService.getCurrentDate();
               
                accidentQuoteMemberInfoVm.endDate =  generalInsurenceHomeService.getFutureYear(startDate,1) ;
                 // $filter('chosenDate')(startDate.setFullYear(startDate.getFullYear() + 1));
                accidentQuoteMemberInfoVm.startDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());

                /*  get all fields details on click back button  */
                $timeout(function() {
                    if (generalInsurenceAccidentService.getsumInsuredDetail()) {
                        accidentQuoteMemberInfoVm.FinalSumInsured = generalInsurenceAccidentService.getsumInsuredDetail().SumInsuredValue;
                        accidentQuoteMemberInfoVm.premiumAmount.value = rupeeSymbol + generalInsurenceAccidentService.getsumInsuredDetail().finalPremiumAmount;
                        accidentQuoteMemberInfoVm.startDate = generalInsurenceAccidentService.getPolicyDateInfo().policyStartDate;
                        accidentQuoteMemberInfoVm.endDate = generalInsurenceAccidentService.getPolicyDateInfo().policyEndDate;
                        $scope.$apply();
                         $scope.$broadcast('rzSliderForceRender');
                    }
                }, 10);
            }


            //validation function starts
            accidentQuoteMemberInfoVm.accidentpersonalDetail = {};

            //onkeyup validate fields if required
            accidentQuoteMemberInfoVm.validateService = validateService;

            //private methods section end
            /*  GO Back to Previous Page */
            accidentQuoteMemberInfoVm.goBacktoPrevious = function() {
                var backNavigationState = generalInsurenceHomeService.getBackNavigationState();
                var landingPage = generalInsurenceHomeService.getLandingPage();
                if(backNavigationState && landingPage == "buy") {
                    generalInsurenceHomeService.setBackNavigationState("");
                    $state.go(backNavigationState);
                } else {
                    $state.go('menu.accidentRecommendedPolicyFeatures');
                }
            }

            /*  GO Back to Next Page */
            accidentQuoteMemberInfoVm.goToNextPage = function() {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                generalInsurenceHomeService.setpolicyStartdate(accidentQuoteMemberInfoVm.startDate);
                var accidentPremiumDetails = {
                    SumInsuredValue: $filter('formatAmount')(accidentQuoteMemberInfoVm.FinalSumInsured),
                    finalPremiumAmount: accidentQuoteMemberInfoVm.premiumAmount.value.replace(String.fromCharCode(8377),""),
                    startDate : accidentQuoteMemberInfoVm.startDate,
                    endDate : accidentQuoteMemberInfoVm.endDate
                }
                generalInsurenceHomeService.setpolicySumInsured($filter('formatAmount')(accidentQuoteMemberInfoVm.FinalSumInsured) );
                generalInsurenceAccidentService.setsumInsuredDetail(accidentPremiumDetails);
                var PolicyDateInformation = {
                    policyStartDate: accidentQuoteMemberInfoVm.startDate,
                    policyEndDate: accidentQuoteMemberInfoVm.endDate,
                }
                generalInsurenceAccidentService.setPolicyDateInfo(PolicyDateInformation);
                SetSaveApplicationForTravel();
            }


            //one time initialization to be done when the controller is loaded
            $scope.$on('$ionicView.loaded', function() {

            });

            //actions to done everytime the view is shown
            $scope.$on('$ionicView.beforeEnter', function() {
                initPage();
                //To Do
            });

            //actions to done everytime the view is hidden
            $scope.$on('$ionicView.afterLeave', function() {
                
                //any cleanup needs to be done here: executes everytime when page is left
            });
            return this;
        }
    ]);
// })();
