angularApp.controller('quotesListController', [
    "$state",
    "$scope",
    "$translate", "$ionicPopup", "$stateParams", "$filter", "validateService", "generalInsurenceHomeDetailService", "generalInsurenceHomeService", "generalInsurenceHealthService", "GIconstant", "utilityService","clickStreamService",

    function(
        $state,
        $scope,
        $translate, $ionicPopup, $stateParams, $filter, validateService, generalInsurenceHomeDetailService, generalInsurenceHomeService, generalInsurenceHealthService, GIconstant, utilityService,clickStreamService) {

        //functions, variables that can be accessed from the HTML come here
        var quotesListVm = this;
        quotesListVm.constant = GIconstant;
        var showHomeDetail, productType;
        var firstPageDetail;
        var criticalillnessdetail, arogyaPremiumDetail, arogyaInsureDetails;
        var selectedIndex, selectedyears, homeSumInsured;
        var productType, pagedetail, selectedYearKey;
        quotesListVm.checkAPIResponce = false;
        quotesListVm.data = [];
        var healthInformation = [];
        quotesListVm.popUpDetail = {};
          var quoteslist = [],homeSelectedYear;
          var arogyaOffer;
		  var responseDetails = [];

        function showHomeYearList() {
            firstPageDetail = generalInsurenceHomeDetailService.getQuoteFirstpageDetail();
            //quotesListVm.sumInsured = firstPageDetail.buildingSumInsured;

            var test = [{
                "key": firstPageDetail.tenure,
                "value": firstPageDetail.tenure,
            }];

            for (var count = 0; count < quotesListVm.quotedetail.length; count++) {
                if (Number(firstPageDetail.tenure) < Number(quotesListVm.quotedetail[count].value)) {
                    quotesListVm.quotedetail.splice(count, 0, test[0]);
                    quotesListVm.filterIndex = count;
                    break;
                }
            }
            if(quotesListVm.filterIndex != 0 ){
            if(!quotesListVm.filterIndex){
                quotesListVm.quotedetail = [];
                quotesListVm.quotedetail = test;
                 quotesListVm.filterIndex = null;
            }
        }
            selectedyears = $filter('arrayFilterBasedIndex')(quotesListVm.quotedetail,quotesListVm.filterIndex);
            selectedyears = selectedyears[0];  



            if (productType == quotesListVm.constant.common.longTermHome) {

                 if (!pagedetail) {
                        //generalInsurenceHomeDetailService.setTenure(selectedyears);
                  } //selectedyears = selectedyears

            }


            
        }


        function SetSaveApplicationForHomeQuote() {
            var detail = generalInsurenceHomeDetailService.getQuoteNumberDetail();
            var savedApplication = generalInsurenceHomeDetailService.getSavedData();
            savedApplication.quoteData.premiumCalculation.response = detail.premiumCalculation;
            savedApplication.quoteData.premiumCalculation.policydetails.tenure = generalInsurenceHomeDetailService.getTenure().value;
            savedApplication.quoteData.premiumCalculation.quotes = quoteslist;
            var JsonStingedData = angular.copy(savedApplication);

            generalInsurenceHomeDetailService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
             JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";

            generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Home.LTH_PREMIUM_TERM).then(function(data) {
                $state.go("menu.homeQuoteSummary");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        //private methods section start
        function initPage() {
            quotesListVm.filterIndex  = null;
            quoteslist = [];
			responseDetails = [];
            productType = generalInsurenceHomeService.getProductDetail().uin;

            if(productType == quotesListVm.constant.Health.hdc){
                quotesListVm.showterm = true;
            }else{
                 quotesListVm.showterm = false;
            }

            
            quotesListVm.productName = productType;
            pagedetail = generalInsurenceHomeService.getQuoteListDetails();
            if (pagedetail) {
                if (pagedetail.productUin == productType) {
                    quotesListVm.showterms = true;
                    quotesListVm.terms = pagedetail.termsCondition;
                    quotesListVm.policyTerms = pagedetail.policyTerms - 1;
                    if(quotesListVm.policyTerms > 2){
                        quotesListVm.policyTerms = 0;
                    }
                    quotesListVm.sumInsured = pagedetail.sumInsured;
                    quotesListVm.totalSumInsured = pagedetail.sumInsured;
                    quotesListVm.QuoteNumber = pagedetail.quoteNumber;
                    quotesListVm.data = pagedetail.data;
                    quotesListVm.checkAPIResponce = true;
                    selectedyears = pagedetail.policyTerms;
                } else {
                    quotesListVm.showterms = false;
                    quotesListVm.terms = "";
                    quotesListVm.policyTerms = "";
                    quotesListVm.sumInsured = "";
                    quotesListVm.QuoteNumber = "";
                    quotesListVm.data = [];
                }
            } else {
                quotesListVm.showterms = true;
                quotesListVm.terms = "";
                quotesListVm.policyTerms = "";
                quotesListVm.sumInsured = "";
                quotesListVm.QuoteNumber = "";
                quotesListVm.data = [];
                quotesListVm.policyTerms = 0;
            }



            if (productType == quotesListVm.constant.Health.arogya) {

                var arogyaPremiumResult = generalInsurenceHealthService.getPremiumcalculationForArogyaPremium();
                arogyaPremiumDetail = generalInsurenceHealthService.getbasicHealthDetail();
                arogyaInsureDetails = generalInsurenceHealthService.getHealthInsureDetails();
                // quotesListVm.policyTerms = arogyaPremium.policyTerms;
                if (!pagedetail) {
                    quotesListVm.data[0] = {};
                    quotesListVm.sumInsured = arogyaInsureDetails.SumInsured[0].value;
                    quotesListVm.QuoteNumber = arogyaPremiumResult.premiumCalculation.quoteNumber;
                    quotesListVm.data[0].amount = arogyaPremiumResult.premiumCalculation.actualPremiumPayable;
                    quotesListVm.checkAPIResponce = true;
                    quotesListVm.totalSumInsured = arogyaInsureDetails.totalSumInsured.value;
                    generalInsurenceHomeService.setpolicySumInsured(arogyaInsureDetails.totalSumInsured.value)
                    selectedyears = generalInsurenceHealthService.getArogyaMasterList().policyTenure[0];
                }

               var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationArogyaStructure();
               var structure = stringifyStructure1;

                if(typeof(structure.quoteData)=='string'){
                     structure.quoteData = JSON.parse(structure.quoteData);
                }

               if(structure.quoteData && structure.quoteData.premiumCalculation && structure.quoteData.premiumCalculation.request && structure.quoteData.premiumCalculation.request.quoteDetails && structure.quoteData.premiumCalculation.request.quoteDetails.planDuration){
                    var planDuration =  structure.quoteData.premiumCalculation.request.quoteDetails.planDuration;
                    planDuration = Number(planDuration) - 1;
                    quotesListVm.policyTerms = planDuration;
                    if(structure.quoteData.premiumCalculation.response && structure.quoteData.premiumCalculation.response.premiumCalculation && structure.quoteData.premiumCalculation.response.premiumCalculation.actualPremiumPayable){
                        quotesListVm.data[planDuration] = {};
                       quotesListVm.data[planDuration].amount = structure.quoteData.premiumCalculation.response.premiumCalculation.actualPremiumPayable;
                       selectedyears = generalInsurenceHealthService.getArogyaMasterList().policyTenure[planDuration];
                       selectedYearKey = selectedyears.key;
                    }
                     

               }

                
            }
            if (productType == quotesListVm.constant.common.longTermHome) {
                var homePremium = generalInsurenceHomeDetailService.getQuoteNumberDetail();
                homeSumInsured = generalInsurenceHomeDetailService.getQuoteFirstpageDetail();

                var savedApplication = generalInsurenceHomeDetailService.getSavedData();
                if(savedApplication && savedApplication.quoteData && savedApplication.quoteData.premiumCalculation  && savedApplication.quoteData.premiumCalculation && savedApplication.quoteData.premiumCalculation.policydetails && savedApplication.quoteData.premiumCalculation.policydetails.tenure){
                        var selected = {
                            "key" : savedApplication.quoteData.premiumCalculation.policydetails.tenure,
                            "value" : savedApplication.quoteData.premiumCalculation.policydetails.tenure
                        }
                        homeSelectedYear = selected;
                        generalInsurenceHomeDetailService.setTenure(selected);
                }

                if (!pagedetail) {
                    quotesListVm.data[0] = {};
                    quotesListVm.sumInsured = $filter('formatAmount')(homeSumInsured.buildingSumInsured);
                    quotesListVm.QuoteNumber = homePremium.premiumCalculation.quoteNumber;
                    quotesListVm.data[0].amount = homePremium.premiumCalculation.actualPremiumPayable;
                    quotesListVm.checkAPIResponce = true;
                    quotesListVm.totalSumInsured =  $filter('formatAmount')(homeSumInsured.buildingSumInsured);
                    selectedyears = generalInsurenceHomeDetailService.getMasterDetail().policyTenure[0];
                }
            }

            if (productType == quotesListVm.constant.Health.critical) {

                criticalillnessdetail = generalInsurenceHealthService.getCriticalIllnessDetails();
                var criticalIllness = generalInsurenceHealthService.getPremiumcalculationForCriticalIllness();
                if (!pagedetail) {
                    quotesListVm.data[0] = {};
                    quotesListVm.sumInsured = criticalillnessdetail.sumInsured.value;
                    quotesListVm.QuoteNumber = criticalIllness.premiumCalculation.quoteNumber;
                    quotesListVm.data[0].amount = criticalIllness.premiumCalculation.actualPremiumPayable;
                    quotesListVm.checkAPIResponce = true;
                      generalInsurenceHomeService.setpolicySumInsured(criticalillnessdetail.sumInsured.value)
                    quotesListVm.totalSumInsured = criticalillnessdetail.sumInsured.value;
                    selectedyears = generalInsurenceHealthService.getCriticalMasterList().policyTenure[0];
                }

                var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationCriticalStructure();
               var structure = stringifyStructure1;

                if(typeof(structure.quoteData)=='string'){
                     structure.quoteData = JSON.parse(structure.quoteData);
                }


                if(structure.quoteData && structure.quoteData.premiumCalculation && structure.quoteData.premiumCalculation.request && structure.quoteData.premiumCalculation.request && structure.quoteData.premiumCalculation.request.planDuration){
                    var planDuration =  structure.quoteData.premiumCalculation.request.planDuration;
                     var selctYear = $filter('selectBoxFilter')(generalInsurenceHealthService.getCriticalMasterList().policyTenure,planDuration,"ikey"); 
                      var index = generalInsurenceHealthService.getCriticalMasterList().policyTenure.indexOf(selctYear);
                    // planDuration = Number(planDuration) - 1;
                     quotesListVm.policyTerms = index;
                    if(structure.quoteData.premiumCalculation.response && structure.quoteData.premiumCalculation.response.premiumCalculation && structure.quoteData.premiumCalculation.response.premiumCalculation.actualPremiumPayable){
                        quotesListVm.data[index] = {};
                       quotesListVm.data[index].amount = structure.quoteData.premiumCalculation.response.premiumCalculation.actualPremiumPayable;
                       selectedyears = selctYear;
                       selectedYearKey = selectedyears.key;
                    }
                     

               }

            }

            if (productType == quotesListVm.constant.Health.hdc) {

                var hdcDetails = generalInsurenceHealthService.getHospitalDailyCashDetails();
                var hdcPremiumResult = generalInsurenceHealthService.getPremiumDetailsForHDC();
                if (!pagedetail) {
                    quotesListVm.data[0] = {};
                    selectedyears = generalInsurenceHealthService.getHDCMasterList().policyTenure[0];
                    quotesListVm.sumInsured = hdcDetails.membersList[0].cashLimit.value * selectedyears.value;
                    quotesListVm.QuoteNumber = hdcPremiumResult.premiumCalculation.quoteNumber;
                    quotesListVm.data[0].amount = hdcPremiumResult.premiumCalculation.actualPremiumPayable;
                    quotesListVm.checkAPIResponce = true;
                    generalInsurenceHomeService.setpolicySumInsured(hdcDetails.membersList[0].cashLimit.value * selectedyears.value)
                    quotesListVm.totalSumInsured = hdcDetails.membersList[0].cashLimit.value * selectedyears.value;
                }


               var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationHDCStructure();
               var structure = stringifyStructure1;

                if(typeof(structure.quoteData)=='string'){
                     structure.quoteData = JSON.parse(structure.quoteData);
                }

                if(structure.quoteData && structure.quoteData.premiumCalculation && structure.quoteData.premiumCalculation.request && structure.quoteData.premiumCalculation.request && structure.quoteData.premiumCalculation.request.quoteDetails && structure.quoteData.premiumCalculation.request.quoteDetails.planDuration){
                    var planDuration =  structure.quoteData.premiumCalculation.request.quoteDetails.planDuration;
                    var selctYear = $filter('selectBoxFilter')(generalInsurenceHealthService.getHDCMasterList().policyTenure,planDuration); 
                    var index = generalInsurenceHealthService.getHDCMasterList().policyTenure.indexOf(selctYear);
                    // planDuration = Number(planDuration) - 1;
                     quotesListVm.policyTerms = index;
                    if(structure.quoteData.premiumCalculation.response && structure.quoteData.premiumCalculation.response.premiumCalculation && structure.quoteData.premiumCalculation.response.premiumCalculation.actualPremiumPayable){
                        quotesListVm.data[index] = {};
                       quotesListVm.data[index].amount = structure.quoteData.premiumCalculation.response.premiumCalculation.actualPremiumPayable;
                       selectedyears = selctYear;
                       selectedYearKey = selectedyears.key;
                    }
                     

               }

            }

            var previouspageData = generalInsurenceHomeService.getPolicyTerm();

            quotesListVm.showBack = true;
            quotesListVm.showNext = true;
            // quotesListVm.sumInsured = '₹ 1,50,000';
            quotesListVm.quoteNumber = '00165457';
            quotesListVm.oneYear = '₹ 8400';
            quotesListVm.twoYears = '₹ 16,600';
            quotesListVm.threeYears = '₹ 24,400';

            quotesListVm.showNext = true;
            quotesListVm.backcolor = 0;
            quotesListVm.data0 = true;

            quotesListVm.pageDetail = $stateParams.pages;
            productType = generalInsurenceHomeService.getProductDetail().uin;

            var uin = {
                    "uin": productType
                }

            if (productType == quotesListVm.constant.common.longTermHome) {
                var details = generalInsurenceHomeDetailService.getMasterDetail();
                firstPageDetail = generalInsurenceHomeDetailService.getQuoteFirstpageDetail();

                quotesListVm.quotedetail = details.policyTenure;
                showHomeYearList();
                if(homeSelectedYear  && homeSelectedYear.key){
                    

                   var yearList =  $filter('arrayFilterBasedIndex')(quotesListVm.quotedetail,quotesListVm.filterIndex);
                   var selectedYr = $filter('selectBoxFilter')(yearList,homeSelectedYear.value,"value"); 
                   quotesListVm.policyTerms = yearList.indexOf(selectedYr);
                    //quotesListVm.policyTerms  = yearList.indexOf(homeSelectedYear);
                }


            
                var index = 1;
                for(var count = quotesListVm.filterIndex+1 ; count < quotesListVm.filterIndex+3 ; count++){
                    if(quotesListVm.quotedetail[count]){
                         quotesListVm.callLTHPremium(quotesListVm.quotedetail[count] , index , false,count);
                    }
                   
                    index++;
                }
            } else if (productType == quotesListVm.constant.Health.arogya) {
                quotesListVm.quotedetail = generalInsurenceHealthService.getArogyaMasterList().policyTenure;
                var indexDetail
                if(quotesListVm.data && quotesListVm.data[0] && quotesListVm.data[0].amount){
                    indexDetail = 0;
                }else{
                     indexDetail = 0;
                }
                for(var count = indexDetail ; count < quotesListVm.quotedetail.length ; count++){
                    quotesListVm.callArogyaPremium(quotesListVm.quotedetail[count] , count , false,count);
                }
            } else if (productType == quotesListVm.constant.Health.critical) {
                quotesListVm.quotedetail = generalInsurenceHealthService.getCriticalMasterList().policyTenure;
                /*for(var count = 1 ; count < quotesListVm.quotedetail.length ; count++){
                    quotesListVm.callCriticalPremium(quotesListVm.quotedetail[count] , count , false);
                }*/
            } else if (productType == quotesListVm.constant.Health.hdc) {
                quotesListVm.quotedetail = generalInsurenceHealthService.getHDCMasterList().policyTenure;
                /*for(var count = 1 ; count < quotesListVm.quotedetail.length ; count++){
                    quotesListVm.callHDCPremium(quotesListVm.quotedetail[count] , count , false);
                }*/
            }

            // }, function(error) {});

            quotesListVm.showHome = true;
        }


        function showPopUp() {
            var alertPopup = $ionicPopup.alert({
                title: '',
                templateUrl: 'pages/generalInsurance/quotes/quotelistPopup.html',
                scope: $scope
            });
            alertPopup.then(function(res) {});
        }



        function calcExpDate(startYear, totalYear) {
            var year = parseInt(totalYear);
            var endYear = generalInsurenceHomeService.getFutureYear(startYear, year);
            return endYear;
        }

        function getDobFromAgeGroup(ageGruop) {
            var CurrentDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());
            var apprxDob = generalInsurenceHomeService.getFutureYear(CurrentDate, -ageGruop);
            return apprxDob;
        }


        quotesListVm.formatAmount = function(amount, displayText) {

         var yearlist = $filter('arrayFilterBasedIndex')(quotesListVm.quotedetail,quotesListVm.filterIndex);
           for(var count = 0; count < yearlist.length; count++){
                 quoteslist[count] =  {}
                 quoteslist[count].term =  yearlist[count].value;
           }

             for(var key in quotesListVm.data){
                 if (quotesListVm.data.hasOwnProperty(key)){
                    if(quoteslist[Number(key)]) {
                     quoteslist[Number(key)].amount =  quotesListVm.data[key].amount;
                    }
                 }else{
                     quoteslist[countforSubFunction].amount = "";
                 }
             }
            if (amount) {
                if (displayText) {
                    return ($translate.instant(displayText) + " : " + ($filter('rupeeSymbol')(amount)));
                } else {
                    return $filter('rupeeSymbol')(amount);
                }
            }
        }




        /* save application for Arogya Premium  */
        function saveApplicationArogya() {
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationArogyaStructure();
            var structure = stringifyStructure1;
              if(typeof(structure.quoteData)=='string'){
                     structure.quoteData = JSON.parse(structure.quoteData);
                }

            var firstPageDetail = generalInsurenceHealthService.getSaveQuoteRequestForArogya();
            var premiumDetail = generalInsurenceHealthService.getPremiumcalculationForArogyaPremium();

            firstPageDetail.quoteData = structure.quoteData;
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.planDuration = selectedYearKey ? selectedYearKey : "1";
            firstPageDetail.quoteData.premiumCalculation.response = premiumDetail;
            structure.applicationData = "";
            structure.quoteData = firstPageDetail.quoteData;
            structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";

            var quoteDetailObject = [];
            for(var i=0;i<generalInsurenceHealthService.getArogyaMasterList().policyTenure.length ; i++){
                var quotes = {}
                quotes.term = generalInsurenceHealthService.getArogyaMasterList().policyTenure[i].key;
                quotes.amount = generalInsurenceHomeService.getQuoteListDetails().data[i] ? generalInsurenceHomeService.getQuoteListDetails().data[i].amount : "";
                quoteDetailObject.push(quotes);
            }
            firstPageDetail.quoteData.premiumCalculation.quotes = quoteDetailObject;

            
            var stringified = structure;
            if(typeof(stringified.quoteData)=='object'){
              stringified.quoteData = JSON.stringify(stringified.quoteData);
            }

            generalInsurenceHomeService.setSaveApplicationArogyaStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.Arogya.AP_PREMIUM_RESULT).then(function(data) {
                
                 $state.go("menu.paymentAccountDetails", { page: "Health" });
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        /* save application for Critical Illness  */
        function saveApplicationCriticalIllness() {
            // var structure = generalInsurenceHomeService.getSaveApplicationSimpleHealth();
            var stringifyStructure1 = generalInsurenceHomeService.getSaveApplicationCriticalStructure();
            var structure = stringifyStructure1;
             if(typeof(structure.quoteData)=='string'){
                     structure.quoteData = JSON.parse(structure.quoteData);
                }
            var firstPageDetail = generalInsurenceHealthService.getSaveQuoteRequestForCriticalIllness();
            var criticalIllness = generalInsurenceHealthService.getPremiumcalculationForCriticalIllness();
             var applicationNo = generalInsurenceHealthService.getSaveApplicationCriticalResponse();
            var age = validateService.calcAge(criticalillnessdetail.Birthday);
            var age1 = age.toString();

            var expiryDate = calcExpDate(criticalillnessdetail.policyStartDate, selectedyears.ikey);
            firstPageDetail.quoteData.premiumCalculation.request.quoteNo = criticalIllness ? criticalIllness.premiumCalculation.quoteNumber : "";
            firstPageDetail.quoteData.premiumCalculation.request.policyID = criticalIllness ? criticalIllness.premiumCalculation.policyTerms.policyID : "";
            firstPageDetail.quoteData.premiumCalculation.request.effectiveDate = new Date(criticalillnessdetail.policyStartDate);
            firstPageDetail.quoteData.premiumCalculation.request.expiryDate = new Date(expiryDate);
            firstPageDetail.quoteData.premiumCalculation.request.planDuration = selectedyears.ikey;
            firstPageDetail.quoteData.premiumCalculation.request.suminsured = $filter('formatAmount')(criticalillnessdetail.sumInsured.value),
            firstPageDetail.quoteData.premiumCalculation.request.age = age1;
            firstPageDetail.quoteData.premiumCalculation.request.gender = criticalillnessdetail.Gender;
            firstPageDetail.quoteData.premiumCalculation.request.insuredId = criticalIllness ? criticalIllness.premiumCalculation.policyTerms.insuredId : "";
            firstPageDetail.quoteData.premiumCalculation.request.dob = $filter('dateFormat')(criticalillnessdetail.Birthday);
            firstPageDetail.quoteData.premiumCalculation.request.policyCtId = criticalIllness ? criticalIllness.premiumCalculation.policyTerms.policyCtId : "";
            firstPageDetail.quoteData.premiumCalculation.request.ppId = criticalIllness ? criticalIllness.premiumCalculation.policyTerms.ppId : "";
            firstPageDetail.quoteData.premiumCalculation.response = criticalIllness;
            var quoteDetailObject = [];
            for(var i=0;i<generalInsurenceHealthService.getCriticalMasterList().policyTenure.length ; i++){
                var quotes = {}
                quotes.term = generalInsurenceHealthService.getCriticalMasterList().policyTenure[i].ikey;
                quotes.amount = generalInsurenceHomeService.getQuoteListDetails().data[i] ? generalInsurenceHomeService.getQuoteListDetails().data[i].amount : "";
                quoteDetailObject.push(quotes);
            }
            firstPageDetail.quoteData.premiumCalculation.quotes = quoteDetailObject;
            var planDetail = generalInsurenceHomeService.getPlanDetail();
            // var stringifyDetail = JSON.stringify(firstPageDetail);
            structure.applicationNumber = applicationNo.applicationNumber;
            structure.productCode = planDetail.productCode;
            structure.uin = productType;
            structure.planName = planDetail.planName;
            structure.mobileNumber = "";
            structure.quoteData = firstPageDetail.quoteData;
            structure.applicationData = "";
            structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";

            var stringified = structure;
            if(typeof(stringified.quoteData)=='object'){
               stringified.quoteData = JSON.stringify(stringified.quoteData);
            }

            generalInsurenceHomeService.setSaveApplicationCriticalStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.Critical.CI_PREMIUM_RESULT).then(function(data) {
                 $state.go("menu.paymentAccountDetails", { page: "Health" });
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        /* save application for HDC Premium  */
        function saveApplicationHDC() {
            var structure = generalInsurenceHomeService.getSaveApplicationSimpleHealth();
            var firstPageDetail = generalInsurenceHealthService.getSaveQuoteRequestForHDC();
            var hdcPremium = generalInsurenceHealthService.getPremiumDetailsForHDC();
            var hdcDetails = generalInsurenceHealthService.getHospitalDailyCashDetails();
              var applicationNo = generalInsurenceHealthService.getSaveApplicationHDCResponse();
        


            for (var i = 0; i < hdcDetails.memberCount; i++) {
                firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[i] = {};
                firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[i].hospitalizationCashLimit = hdcDetails.membersList[i].cashLimit;
                firstPageDetail.quoteData.premiumCalculation.request.insuredDetails[i].age = hdcDetails.membersList[i].ageGroup;
            }
            firstPageDetail.quoteData.premiumCalculation.request.policyStartDate = new Date(hdcDetails.startDate);
            firstPageDetail.quoteData.premiumCalculation.request.policyEndDate = new Date(hdcDetails.endDate);
            firstPageDetail.quoteData.premiumCalculation.request.familysize = hdcDetails.memberCount.toString();
            firstPageDetail.quoteData.premiumCalculation.request.primarySumInsured = hdcDetails.membersList[0].cashLimit.value * selectedyears.value;
            firstPageDetail.quoteData.premiumCalculation.request.quoteDetails.planDuration = selectedyears.value;
            firstPageDetail.quoteData.premiumCalculation.response = hdcPremium;


            var quoteDetailObject = [];
            for(var i=0;i<generalInsurenceHealthService.getHDCMasterList().policyTenure.length ; i++){
                var quotes = {}
                quotes.term = generalInsurenceHealthService.getHDCMasterList().policyTenure[i].key;
                quotes.amount = generalInsurenceHomeService.getQuoteListDetails().data[i] ? generalInsurenceHomeService.getQuoteListDetails().data[i].amount : "";
                quoteDetailObject.push(quotes);
            }
            firstPageDetail.quoteData.premiumCalculation.quotes = quoteDetailObject;

            var planDetail = generalInsurenceHomeService.getPlanDetail();
            // var stringifyDetail = JSON.stringify(firstPageDetail);
            structure.applicationNumber = applicationNo.applicationNumber;
            structure.productCode = planDetail.productCode;
            structure.uin = productType;
            structure.planName = planDetail.planName;
            structure.mobileNumber = "";
            structure.quoteData = firstPageDetail.quoteData;
            structure.applicationData = "";
            structure.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            structure.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
            var stringified = structure;
            if(typeof(stringified.quoteData)=='object'){
              stringified.quoteData = JSON.stringify(stringified.quoteData);
            }

            generalInsurenceHomeService.setSaveApplicationHDCStructure(structure);

            generalInsurenceHomeService.saveApplication(stringified,GIconstant.OmniChannel.HDC.HDC_PREMIUM_RESULT).then(function(data) {
               $state.go("menu.paymentAccountDetails", { page: "Health" });
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }






        quotesListVm.showDetail = function(year, index) {
                selectedyears = year;
                selectedIndex = index;
                selectedYearKey = year.key;
                var years;
                quotesListVm.showterms = true;
                if (productType == quotesListVm.constant.common.longTermHome) {
                    quotesListVm.callLTHPremium(year, index,true,quotesListVm.filterIndex+2);
                } else if (productType == quotesListVm.constant.Health.hdc) {
                    var details = generalInsurenceHealthService.getHospitalDailyCashDetails();
                    var isVaild = true;
                    for(var i=0; i <details.membersList.length ; i++){
                        if(details.membersList[i].ageGroup.key >= 65){
                            isVaild = false;
                        }
                    }
                    if(!isVaild && year.value.toString() == "60"){
                        quotesListVm.policyTerms = 0;
                        selectedyears = quotesListVm.quotedetail[0];
                        document.getElementById("0").checked = true;
                        document.getElementById("0").className += "ng-valid-parse";
                        utilityService.showErrorMessage($translate.instant('HDC_AGE_GROUP_VALIDATION'));
                    }else{
                        quotesListVm.callHDCPremium(year, index,true);
                    }
                    
                } else if (productType == quotesListVm.constant.Health.simple) {
                    quotesListVm.popUpDetail.heading = "Group Health Insurance - SBI ";
                } else if (productType == quotesListVm.constant.Health.critical) {                       
                    var age = validateService.calcAge(criticalillnessdetail.Birthday);
                    if(age > 57 && year.ikey == 3){
                        quotesListVm.policyTerms = 0;
                        selectedyears = quotesListVm.quotedetail[0];
                        document.getElementById("0").checked = true;
                        document.getElementById("0").className += "ng-valid-parse";
                        utilityService.showErrorMessage($translate.instant('CI_AGE_GROUP_VALIDATION'));
                    }else{
                        quotesListVm.callCriticalPremium(year, index,true);
                    }
                } else if (productType == quotesListVm.constant.Health.arogya) {
                   quotesListVm.callArogyaPremium(year, index,true,quotesListVm.quotedetail.length-1);
                }


            }
            //private methods section end
        quotesListVm.buyAnotherPolicy = function() {
            // To Do
        }

        quotesListVm.goToNextPage = function() {
            // to do
        }
        quotesListVm.selectedPolicy = function() {
            var quoteListDetailsDetails = {
                Policyterm: quotesListVm.policyTerms,
                termsCondition: quotesListVm.terms,
                policyTerms: productType == quotesListVm.constant.Health.critical ? selectedyears.ikey : selectedyears.key,
                policyTermsValue: selectedyears.value,
                productUin: productType,
                sumInsured: quotesListVm.sumInsured,
                quoteNumber: quotesListVm.QuoteNumber,
                selectedIndex: selectedIndex,
                data: quotesListVm.data
            }
            generalInsurenceHomeService.setQuoteListDetails(quoteListDetailsDetails);
            clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
            if (productType == quotesListVm.constant.common.longTermHome) {
                SetSaveApplicationForHomeQuote()
            } else {
                if (productType == quotesListVm.constant.Health.arogya) {
                    saveApplicationArogya();
                } else if (productType == quotesListVm.constant.Health.critical) {
                    saveApplicationCriticalIllness();
                } else if (productType == quotesListVm.constant.Health.hdc) {
                    saveApplicationHDC();
                } else {
                    $state.go("menu.quoteIRDAIOtp", { page: $stateParams.pages });
                }

            }
        }

        quotesListVm.getyear = function(data) {
            if ($stateParams.pages == 'home' || productType == "22") {
                return data.value + " " + $translate.instant('YEARS');
            }else if(productType == quotesListVm.constant.Health.hdc) {
                return data.value + " days";
            } else {
                return data.value;
            }

        }

        quotesListVm.clickTerm = function() {
                generalInsurenceHomeService.getTermsAndCondtion()
                // .then(function(data) {}, function(error) {
                //     utilityService.showErrorMessage(error.responseMessage);
                // });
            }


            quotesListVm.clickDeclaration =  function(){
                  generalInsurenceHomeService.getDiclaration().then(function(data) {
               
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
            }



            quotesListVm.callLTHPremium = function(year, index, showPop,count){
                var quoteDetails = generalInsurenceHomeDetailService.getQuoteNumberDetail();
                var homeOfferAmount = generalInsurenceHomeDetailService.getHomePrimiumForOffer();
				if(index == 0){
					quoteLTH(homeOfferAmount);
				}else if(responseDetails[year.value]){
					quoteLTH(responseDetails[year.value]);				
				}else{
					var policydetails = {
                        "premiumCalculation": {

                            "quoteDetails": {
                                "quoteNo": quoteDetails ? quoteDetails.premiumCalculation.quoteNumber : null,
                                "policyID": quoteDetails ? quoteDetails.premiumCalculation.policyTerms.policyID : null,
                                "ppId": quoteDetails ? quoteDetails.premiumCalculation.policyTerms.ppId : null,
                                "insuredDetails": quoteDetails ? quoteDetails.premiumCalculation.insuredDetails : [],
                            },
                            "policydetails": {
                                "tenure": year.value.toString(),
                                "startDate": $filter('startDateWithTimezone')(firstPageDetail.startDate),
                                "endDate": $filter('endDateWithTimezone')(generalInsurenceHomeService.getFutureYear(firstPageDetail.startDate, year.value)),
                                "insuredPincode": firstPageDetail.pinCode,
                                "insuredBuildingSum": $filter('formatAmount')(firstPageDetail.buildingSumInsured)
                            }



                        }
                    }

                    if(count && count == quotesListVm.filterIndex+2){
                       generalInsurenceHomeDetailService.getHomeIQuote(policydetails).then(function(data) {
						    var yearDiff =  new Date(data.premiumCalculation.policyTerms.expiryDate).getFullYear()   - new Date(data.premiumCalculation.policyTerms.effectDate).getFullYear()
							responseDetails[yearDiff] = data;
                            quoteLTH(data);
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        }); 
                   }else{
                        generalInsurenceHomeDetailService.getHomeIQuoteWithoutOverlay(policydetails).then(function(data) {
							var yearDiff =  new Date(data.premiumCalculation.policyTerms.expiryDate).getFullYear()   - new Date(data.premiumCalculation.policyTerms.effectDate).getFullYear()
							responseDetails[yearDiff] = data;
							quoteLTH(data);
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                   }
				}

                    

                   function quoteLTH (data){
                        if (data) {
                            quotesListVm.checkAPIResponce = true;
                        }
                        
                        quotesListVm.QuoteNumber = data.premiumCalculation.quoteNumber;
                        quotesListVm.sumInsured = $filter('formatAmount')(homeSumInsured.buildingSumInsured);
                        quotesListVm.data[index] = {};
                        quotesListVm.data[index].amount = data.premiumCalculation.actualPremiumPayable;
                        quotesListVm.popUpDetail.heading = "Long Term Home Insurance";
                        quotesListVm.popUpDetail.QuoteNumber = data.premiumCalculation.quoteNumber;
                        quotesListVm.popUpDetail.years = year.value + " Years ";  
                        data.premiumCalculation.actualPremiumPayable;
                        quotesListVm.popUpDetail.amount = data.premiumCalculation.actualPremiumPayable;
                        if(showPop){
                            showPopUp();
                            generalInsurenceHomeDetailService.setTenure(year);
                            generalInsurenceHomeDetailService.setQuoteNumberDetail(data);
                        }
                   }

                    
            }


            quotesListVm.callHDCPremium = function(year, index, showPop){
                 var details = generalInsurenceHealthService.getHospitalDailyCashDetails();
                    var isVaild = true;
                    for(var i=0; i <details.membersList.length ; i++){
                        if(details.membersList[i].ageGroup.key >= 65){
                            isVaild = false;
                        }
                    }
                    if(!isVaild && year.value.toString() == "60"){
                        quotesListVm.policyTerms = 0;
                        selectedyears = quotesListVm.quotedetail[0];
                        document.getElementById("0").checked = true;
                        document.getElementById("0").className += "ng-valid-parse";
                        utilityService.showErrorMessage($translate.instant('HDC_AGE_GROUP_VALIDATION'));
                    }else{
						quotesListVm.popUpDetail.heading = "Hospital Daily Cash";
						var hdcPremiumResponse = generalInsurenceHealthService.getPremiumDetailsForHDC();
						var hdcDetails = generalInsurenceHealthService.getHospitalDailyCashDetails();
						var hdcOfferAmount = generalInsurenceHealthService.getHDCPrimiumForOffer();
						var productTypes;
						if (hdcDetails.memberCount == '1') {
							productTypes = 'Individual';
						} else {
							productTypes = 'Family Floater';
						}
						var insureedDetails = [];
						for (var i = 0; i < hdcDetails.memberCount; i++) {
							insureedDetails[i] = {}
							insureedDetails[i].age = hdcDetails.membersList[i].ageGroup.key;
							insureedDetails[i].dateOfBirth = $filter('dateFormat')(getDobFromAgeGroup(insureedDetails[i].age));
							insureedDetails[i].hospitalizationCashLimit = hdcDetails.membersList[i].cashLimit.value;
							insureedDetails[i].insuredId = hdcPremiumResponse ? hdcPremiumResponse.premiumCalculation.insuredDetails[i].insuredId : "";
							insureedDetails[i].insuredName = hdcPremiumResponse ? hdcPremiumResponse.premiumCalculation.insuredDetails[i].insuredName : "";
							insureedDetails[i].policyCtId = hdcPremiumResponse ? hdcPremiumResponse.premiumCalculation.insuredDetails[i].policyCtId : "";
						}
						if(index == 0){
							responseDetails[index] = generalInsurenceHealthService.getHDCPrimiumForOffer();
							quoteHDC(responseDetails[index]);
						}else if(responseDetails[index]){
							quoteHDC(responseDetails[index]);
						}else{
							var HDCPremium = {
								"premiumCalculation": {
									"productType": productTypes,
									"quoteNo": hdcPremiumResponse ? hdcPremiumResponse.premiumCalculation.quoteNumber : "",
									"policyID": hdcPremiumResponse ? hdcPremiumResponse.premiumCalculation.policyTerms.policyID : "",

									"familySize": hdcDetails.memberCount.toString(),
									"policyStartDate": $filter('startDateWithTimezone')(hdcDetails.startDate),
									"policyEndDate": $filter('endDateWithTimezone')(hdcDetails.endDate),
									"ppId": hdcPremiumResponse ? hdcPremiumResponse.premiumCalculation.policyTerms.ppId : "",
									"noOfDays": year.value.toString(),

									"insuredDetails": insureedDetails
								}
							}
							generalInsurenceHomeService.applyHDCPremium(HDCPremium).then(function(data) {
								responseDetails[index] = data;
								quoteHDC(data);
							}, function(error) {
								utilityService.showErrorMessage(error.responseMessage);
								//alert(error.responseMessage);
							});
							}
					}
                        
					
					function quoteHDC(data){
						if (data) {
                            quotesListVm.checkAPIResponce = true;
                        }
                        //  generalInsurenceTravelService.setPolicyforPAI(data);
                        
                        quotesListVm.QuoteNumber = data.premiumCalculation.quoteNumber;
                        quotesListVm.data[index] = {};
                        quotesListVm.data[index].amount = data.premiumCalculation.actualPremiumPayable;
                        quotesListVm.sumInsured = hdcDetails.membersList[0].cashLimit.value * year.value;

                        generalInsurenceHealthService.setHDCSumInsured(quotesListVm.sumInsured);

                        quotesListVm.popUpDetail.QuoteNumber = data.premiumCalculation.quoteNumber;
                        quotesListVm.popUpDetail.years = year.value + " Days ";
                        quotesListVm.popUpDetail.amount = data.premiumCalculation.actualPremiumPayable;
                        if(showPop){
                            showPopUp();
                            quotesListVm.totalSumInsured = hdcDetails.membersList[0].cashLimit.value * year.value;
                            generalInsurenceHealthService.setPremiumDetailsForHDC(data);
                        }
					}
            }

            quotesListVm.callCriticalPremium = function(year, index, showPop){
                var criticalIllness = generalInsurenceHealthService.getPremiumcalculationForCriticalIllness();
                    var criticalIllnessOffer = generalInsurenceHealthService.getCriticalPrimiumForOffer();
                    //var policyEndDate = generalInsurenceHomeService.getFutureYear(criticalillnessdetail.policyStartDate, quotesListVm.constant.Health.policyEndYear);
                    var age = validateService.calcAge(criticalillnessdetail.Birthday);
                    if(age > 57 && year.ikey == 3){
                        quotesListVm.policyTerms = 0;
                        selectedyears = quotesListVm.quotedetail[0];
                        document.getElementById("0").checked = true;
                        document.getElementById("0").className += "ng-valid-parse";
                        utilityService.showErrorMessage($translate.instant('CI_AGE_GROUP_VALIDATION'));
                    }else{
                        var age1 = age.toString();
                        var expiryDate = calcExpDate(criticalillnessdetail.policyStartDate, year.ikey);
                        quotesListVm.popUpDetail.heading = "Critical Illness";

                        var policydetails = {
                            "premiumCalculation": {
                                "request": {
                                    "quoteNo": criticalIllness ? criticalIllness.premiumCalculation.quoteNumber : "",
                                    "policyID": criticalIllness ? criticalIllness.premiumCalculation.policyTerms.policyID : "",
                                    "effectiveDate": $filter('startDateWithTimezone')(criticalillnessdetail.policyStartDate),
                                    "expiryDate": $filter('endDateWithTimezone')(expiryDate),
                                    "planDuration": year.ikey,
                                    "suminsured": $filter('formatAmount')(criticalillnessdetail.sumInsured.value),
                                    "age": age1,
                                    "insuredId": criticalIllness ? criticalIllness.premiumCalculation.policyTerms.insuredId : "",
                                    "dob": $filter('dateFormat')(criticalillnessdetail.Birthday),
                                    "policyCtId": criticalIllness ? criticalIllness.premiumCalculation.policyTerms.policyCtId : "",
                                    "ppId": criticalIllness ? criticalIllness.premiumCalculation.policyTerms.ppId : "",

                                }
                            }
                        }
                      
                        generalInsurenceHealthService.getHICriticalIllnessQuote(policydetails).then(function(data) {
                            if (data) {
                                quotesListVm.checkAPIResponce = true;
                            }
                            
                            generalInsurenceHealthService.setHICriticalIllnessQuoteDetail(data);
                            quotesListVm.QuoteNumber = data.premiumCalculation.quoteNumber;
                            quotesListVm.data[index] = {};
                            quotesListVm.data[index].amount = data.premiumCalculation.actualPremiumPayable;
                            quotesListVm.sumInsured = data.premiumCalculation.sumInsured;

                            quotesListVm.data[index].savedAmount = (criticalIllnessOffer.premiumCalculation.actualPremiumPayable * year.ikey) - data.premiumCalculation.actualPremiumPayable;
                            if (quotesListVm.data[index].savedAmount > 0) {
                                quotesListVm.data[index].offer = "( Saved " + quotesListVm.formatAmount(quotesListVm.data[index].savedAmount) + " )";
                                quotesListVm.data[index].withoutDiscount = criticalIllnessOffer.premiumCalculation.actualPremiumPayable * year.ikey;
                            }
                            quotesListVm.popUpDetail.QuoteNumber = data.premiumCalculation.quoteNumber;
                            quotesListVm.popUpDetail.years = year.value;
                            quotesListVm.popUpDetail.amount = data.premiumCalculation.actualPremiumPayable;
                            if(showPop){
                                showPopUp();
                                generalInsurenceHealthService.setPremiumcalculationForCriticalIllness(data);
                            }
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
             }


            quotesListVm.callArogyaPremium = function(year, index, showPop,count){
				var arogyaPremium = generalInsurenceHealthService.getPremiumcalculationForArogyaPremium();
				arogyaOffer = generalInsurenceHealthService.getArogyaPrimiumForOffer();
				healthInformation = [];
				for (var i = 0; i < arogyaPremiumDetail.familySize; i++) {
					healthInformation[i] = {}
					var age = validateService.calcAge(arogyaInsureDetails.Birthdate[i]);
					healthInformation[i].dob = $filter('dateFormat')(arogyaInsureDetails.Birthdate[i]);
					healthInformation[i].age = age.toString();
					healthInformation[i].insuredId = arogyaPremium ? arogyaPremium.premiumCalculation.insuredDetails[i].insuredId : "";
					healthInformation[i].coverTypeName = arogyaPremium ? arogyaPremium.premiumCalculation.insuredDetails[i].insuredName : "";
					healthInformation[i].policyCtId = arogyaPremium ? arogyaPremium.premiumCalculation.insuredDetails[i].policyCtId : "";

					healthInformation[i].realtionship = arogyaInsureDetails.Relationship[i].key.toString();
					if (i == 0 || arogyaPremiumDetail.productTypes.key != quotesListVm.constant.Health.productTypeFamilyFloater) {
						healthInformation[i].sumInsured = arogyaInsureDetails.SumInsured[i].value.toString();
					} else {
						healthInformation[i].sumInsured = arogyaInsureDetails.SumInsured[0].value.toString();
					} 
				}
				if(responseDetails[year.key]){
					var popUpDetails = {};
					if(index == 0){
						popUpDetails = generalInsurenceHealthService.getArogyaPrimiumForOffer();
						quoteArogya(popUpDetails);
					}else{
						quoteArogya(responseDetails[year.key]);
					}
					
				}else{
					
                    var expiryDate = calcExpDate(arogyaPremiumDetail.startDate, year.key);
                    quotesListVm.popUpDetail.heading = "Arogya Premium";
                    var policydetails = {
                        "premiumCalculation": {
                            "quoteDetails": {
                                "quoteNo": arogyaPremium ? arogyaPremium.premiumCalculation.quoteNumber : "",
                                "policyID": arogyaPremium ? arogyaPremium.premiumCalculation.policyTerms.policyID : "",
                                "productType": arogyaPremiumDetail.productTypes.key,
                                "familysize": arogyaPremiumDetail.familySize.toString(),
                                "effectiveDate": $filter('startDateWithTimezone')(arogyaPremiumDetail.startDate),
                                "expiryDate": $filter('endDateWithTimezone')(expiryDate),
                                "planDuration": year.key,
                                "name": "",
                                "ppId": arogyaPremium ? arogyaPremium.premiumCalculation.policyTerms.ppId : ""
                            },
                            "insuredDetails": healthInformation
                        }
                    }

                   


                    if(count && count == quotesListVm.quotedetail.length-1){
                       generalInsurenceHealthService.getHIArogyaQuote(policydetails).then(function(data) {
                        //generalInsurenceHealthService.setPremiumcalculationForArogyaPremium(data);
                        if(data && data.premiumCalculation && data.premiumCalculation.policyTerms && data.premiumCalculation.policyTerms.expiryDate){
                          var yearDiff =  new Date(data.premiumCalculation.policyTerms.expiryDate).getFullYear()   - new Date(data.premiumCalculation.policyTerms.effectDate).getFullYear()
						  responseDetails[yearDiff] = data;
                           if(yearDiff == 1){
                            arogyaOffer = data;
                             generalInsurenceHealthService.setArogyaPrimiumForOffer(data);
                           }
                        }
                             quoteArogya(data);
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        }); 
                   }else{
                        generalInsurenceHealthService.getHIArogyaQuoteWithoutOverlay(policydetails).then(function(data) {
                         // generalInsurenceHealthService.setPremiumcalculationForArogyaPremium(data);
                         if(data  && data.premiumCalculation && data.premiumCalculation.policyTerms && data.premiumCalculation.policyTerms.expiryDate){
                          var yearDiff =  new Date(data.premiumCalculation.policyTerms.expiryDate).getFullYear()   - new Date(data.premiumCalculation.policyTerms.effectDate).getFullYear()
						  responseDetails[yearDiff] = data;
                           if(yearDiff == 1){
                            arogyaOffer = data;
                                generalInsurenceHealthService.setArogyaPrimiumForOffer(data);
                           }
                        }

                           quoteArogya(data);
                        }, function(error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                   }
				}
                 



                    function quoteArogya(data){
                        if (data) {
                            quotesListVm.checkAPIResponce = true;
                        }
                        
                        quotesListVm.QuoteNumber = data.premiumCalculation.quoteNumber;
                        quotesListVm.data[index] = {};
                        quotesListVm.data[index].amount = data.premiumCalculation.actualPremiumPayable;
                        quotesListVm.sumInsured = arogyaInsureDetails.SumInsured[0].value;

                        quotesListVm.data[index].savedAmount = (arogyaOffer.premiumCalculation.actualPremiumPayable * year.key) - data.premiumCalculation.actualPremiumPayable;
                        if (quotesListVm.data[index].savedAmount > 0) {
                            quotesListVm.data[index].offer = "( Saved " + quotesListVm.formatAmount(quotesListVm.data[index].savedAmount) + " )";
                            quotesListVm.data[index].withoutDiscount = arogyaOffer.premiumCalculation.actualPremiumPayable * year.key;
                        }
                        quotesListVm.popUpDetail.QuoteNumber = data.premiumCalculation.quoteNumber;
                        quotesListVm.popUpDetail.years = year.value;
                        quotesListVm.popUpDetail.amount = data.premiumCalculation.actualPremiumPayable;
                        if(showPop){
                            showPopUp();
                            generalInsurenceHealthService.setPremiumcalculationForArogyaPremium(data);
                        }
                    }
             }

        quotesListVm.goBacktoPrevious = function() {
            switch (productType) {
                case quotesListVm.constant.Health.hdc:
                    $state.go("menu.hospitalDailyCashPremiumCalculation");
                    break;
                case quotesListVm.constant.Health.arogya:
                    generalInsurenceHomeService.setPolicyTerm(quotesListVm.policyTerms);
                    $state.go("menu.healthInsureDetail");
                    break;
                case quotesListVm.constant.Health.critical:
                    $state.go("menu.criticalIlnessPremiumCalulation");
                    break;
                case quotesListVm.constant.Health.simple:
                    $state.go("menu.healthInsureDetail");
                    break;
                case '22':
                    $state.go("menu.homeQuotePolicyInfo");
                    break;
                default:
                    $state.go("menu.quoteIRDAIOtp");
                    break;
            }
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {

            //any cleanup needs to be done here: executes everytime when page is left

        });
        return this;
    }
]);
// })();
