angularApp.service('generalInsurenceTravelService', ["$filter", "$q", "AdapterUtils", "genralInsurenceConfig", "commonAPIService", "generalInsurenceHomeService",
    function($filter, $q, AdapterUtils, genralInsurenceConfig, commonAPIService, generalInsurenceHomeService) {

        var generalInsurenceTravel = this;
        var travelPolicydetails, travellerDetails, travellerPersonalDetails,insuredPartyDetail;
        var TravellerApplicationDetails, physicianDetail, proposerLocationDetail, proposerContactDetail, travelNomineeDetail, paramStatus, premiumCalculation; /* application variable */
        var travelMaster, partyDetail, savedData;

        generalInsurenceTravel.clearAll = function(){
              travelPolicydetails = null; travellerDetails= null; travellerPersonalDetails = null;
              TravellerApplicationDetails= null; physicianDetail= null; proposerLocationDetail= null; proposerContactDetail= null; travelNomineeDetail= null; paramStatus= null; premiumCalculation =  null; /* application variable */
              travelMaster= null; partyDetail = null; savedData = null,insuredPartyDetail = null;
        }
        //to set Travel  Policy Details 
        generalInsurenceTravel.setTravellerPolicyDetails = function(data) {
            travelPolicydetails = data;
        }

        //to getTravel  Policy Details 
        generalInsurenceTravel.getTravellerPolicyDetails = function() {
            return travelPolicydetails
        }



        //to set Traveller Details from Users Info Fields 
        generalInsurenceTravel.setTravellerDetail = function(data) {
            travellerDetails = data;
        }

        //to get  Traveller Details from Users Info Fields 
        generalInsurenceTravel.getTravellerDetail = function() {
            return travellerDetails
        }

        //to set Traveller Personal Details from Users Info Fields 
        generalInsurenceTravel.setTravellerPersonalDetails = function(data) {
            travellerPersonalDetails = data;
        }

        //to get  Traveller Personal Details from Users Info Fields 
        generalInsurenceTravel.getTravellerPersonalDetails = function() {
            return travellerPersonalDetails
        }

        //to set Traveller Personal Details from Users Info Fields 
        generalInsurenceTravel.setTravellerApplicationDetails = function(data) {
            TravellerApplicationDetails = data;
        }

        //to get  Traveller Personal Details from Users Info Fields 
        generalInsurenceTravel.getTravellerApplicationDetails = function() {
            return TravellerApplicationDetails
        }

        //to set Traveller Personal Details from Users Info Fields 
        generalInsurenceTravel.setPhysicianDetails = function(data) {
            physicianDetail = data;
        }

        //to get  Traveller Personal Details from Users Info Fields 
        generalInsurenceTravel.getPhysicianDetails = function() {
            return physicianDetail
        }

        //to set Proposer Location  Details from Users Info Fields 
        generalInsurenceTravel.setProposerLocationDetail = function(data) {
            proposerLocationDetail = data;
        }

        //to get   Proposer Location  Details from Users Info Fields 
        generalInsurenceTravel.getProposerLocationDetail = function() {
            return proposerLocationDetail
        }

        //to set Proposer Contact  Details from Users Info Fields 
        generalInsurenceTravel.setProposerContactDetail = function(data) {
            proposerContactDetail = data;
        }

        //to get   Proposer Contact  Details from Users Info Fields 
        generalInsurenceTravel.getProposerContactDetail = function() {
            return proposerContactDetail
        }

        //to set Proposer Contact  Details from Users Info Fields 
        generalInsurenceTravel.setTravelNomineeDetail = function(data) {
            travelNomineeDetail = data;
        }
        generalInsurenceTravel.getTravelNomineeDetail = function(data) {
            return travelNomineeDetail
        }

        //to set param status for traveller  
        generalInsurenceTravel.setTravelStateParam = function(data) {
            paramStatus = data;
        }

        //to get param status of traveller  
        generalInsurenceTravel.getTravelStateParam = function() {
            return paramStatus
        }

        //to set Premium info response
        generalInsurenceTravel.setTravellerPremiumResponse = function(data) {
            premiumCalculation = data;
        }

        //to get  Premium info response in premium calculation page
        generalInsurenceTravel.getTravellerPremiumResponse = function() {
            return premiumCalculation
        }

        generalInsurenceTravel.getTravellerPremiumResponse = function() {
            return premiumCalculation
        }

        generalInsurenceTravel.setTravelMasterDetail = function(data) {
            travelMaster = data;
        }
        generalInsurenceTravel.getTravelMasterDetail = function() {
            // return premiumCalculation
            return travelMaster;
        }


        generalInsurenceTravel.setTravelCreateParty = function(data) {
            partyDetail = data;
        }
        generalInsurenceTravel.getTravelCreateParty = function() {
            // return premiumCalculation
            return partyDetail;
        }

         generalInsurenceTravel.setTravelInsuredCreateParty = function(data) {
            insuredPartyDetail = data;
        }
        generalInsurenceTravel.getTravelInsuredCreateParty = function() {
            return insuredPartyDetail;
        }

        generalInsurenceTravel.setSavedData = function(data) {
            // return premiumCalculation
            savedData = data;
        }


        generalInsurenceTravel.getSavedData = function() {
            // return premiumCalculation
            return savedData;
        }



        generalInsurenceTravel.postTravelPremium = function(travelPremium) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.postTravelPremium[0], travelPremium, true).then(
                function(response) {
                    if(response.data){
                        generalInsurenceHomeService.setQuoteNumber(response.data.premiumCalculation.quoteNumber);
                    } 
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceTravel.applyPAIProduct = function(PaiPremium) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.applyPAIProduct[0], PaiPremium, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceTravel.applyHICriticalIllnessProduct = function(CIPremium) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.applyHICriticalIllnessProduct[0], CIPremium, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        generalInsurenceTravel.getTravelMaster = function() {
            var q = $q.defer();
            AdapterUtils.getData(genralInsurenceConfig.adapterURL.getTravelMaster[0], true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        generalInsurenceTravel.applyTIProduct = function(travelDetail) {
            var q = $q.defer();
            AdapterUtils.postData(genralInsurenceConfig.adapterURL.applyTIProduct[0], travelDetail, true).then(
                function(response) {

                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        generalInsurenceTravel.assignvalueForTravel = function() {
            var pagelength = 7;
            var savedApplication = {}
            var services = ["TravelPolicyDetail", "travellerList", "quoteDetail", "travelPersonalDetail", "travellerListDetail", "physcianDetail","nomineeDetail"];
            for (var serCount = 0; serCount < pagelength; serCount++) {
                var SavePageDetail = services[serCount];
                if (SavePageDetail == "TravelPolicyDetail") {
                    if (savedData && savedData.quoteData &&  savedData.quoteData.productDetails) {
                        var details = savedData.quoteData.productDetails;
                        var selectedDetail = {
                            policyType: details.productType,
                            policyOption: details.policyOption,
                            travellingToUSCanada: details.travelToUSCanada,
                            Countrystay:  $filter('selectBoxFilter')(travelMaster.countryList, details.countryOfMaxStay, "locId") ,
                            travelPurpose: details.purposeOfTravel,
                            startDate: $filter('chosenDate')(details.travelStartDate),
                            endDate: $filter('chosenDate')(details.travelEndDate),
                            diffVal: details.noOfDays,
                        }
                        travelPolicydetails = selectedDetail;
                    }

                } else if (SavePageDetail == 'travellerList') {
                    if (savedData && savedData.quoteData && savedData.quoteData.travellerDetails && savedData.quoteData.travellerDetails.length) {
                        var travellerList = savedData.quoteData.travellerDetails;
                        var userList = [];
                        for (var count = 0; count < travellerList.length; count++) {
                            userList[count] = {};
                            userList[count].Birthdate = $filter('chosenDate')(travellerList[count].dob);
                            userList[count].SumInsured =   travellerList[count].sumInsured;
                            userList[count].Relationship = travellerList[count].proposerRelation;
                        }
                        travellerDetails = userList;
                    }

                } else if (SavePageDetail == 'quoteDetail') {
                    if (savedData && savedData.quoteData && savedData.quoteData.premiumCalculation && savedData.quoteData.premiumCalculation.response) {
                        var quoteDetail = savedData.quoteData.premiumCalculation.response;
                        premiumCalculation = {};
                        premiumCalculation.premiumCalculation = quoteDetail;
                    }

                } else if (SavePageDetail == "travelPersonalDetail") {
                    if (savedData && savedData.applicationData && savedData.applicationData.proposerDetails && savedData.applicationData.proposerDetails.locationSource) {
                        var detailsForPersonal = savedData.applicationData.proposerDetails;
                        var selectedDetailForPersonal = {
                            title: detailsForPersonal.abbrName,
                            firstName: detailsForPersonal.firstName,
                            lastName: detailsForPersonal.lastName,
                            address: detailsForPersonal.address,
                            city: detailsForPersonal.city,
                            pincode: detailsForPersonal.pincode,
                            birthdate: $filter('chosenDate')(detailsForPersonal.dob),
                            email: detailsForPersonal.emailId,
                            mobileNo: detailsForPersonal.mobileNumber,  
                            gender: $filter('selectBoxFilter')(travelMaster.gender, detailsForPersonal.gender, "ikey"),
                            plotNO: detailsForPersonal.plotNo,
                            buildingName: detailsForPersonal.buildingName,
                            streetName: detailsForPersonal.streetName,
                            locality: detailsForPersonal.location
                        }
                        generalInsurenceHomeService.setLocationDetail(savedData.applicationData.proposerDetails.locationSource);
                        var party = {
                            partyCreate: savedData.applicationData.partyDetails.response
                        };
                        partyDetail = party;
                        proposerContactDetail = selectedDetailForPersonal;
                    }
                } else if (SavePageDetail == 'travellerListDetail') {
                    if (savedData && savedData.applicationData && savedData.applicationData.travellerDetails && savedData.applicationData.travellerDetails.length && savedData.applicationData.travellerDetails) {
                        var travellerlist = savedData.applicationData.travellerDetails;
                        var title = [];
                        var firstName = [];
                        var lastName = [];
                        var gender = [];
                        var passportNo = [];
                        var mobileNo = [];
                        var RelationshipInfo = [];
                        var diseaseList = [];
                        var sufferingFromAnyDisease = [];
                        insuredPartyDetail = {};
                        insuredPartyDetail.partyCreate = [];
                        for (var count = 0; count < travellerlist.length; count++) {
                            title[count] = travellerlist[count].title;
                            firstName[count] = travellerlist[count].firstName;
                            lastName[count] = travellerlist[count].lastName;
                            gender[count] = $filter('selectBoxFilter')(travelMaster.gender, travellerlist[count].gender, "ikey");
                            passportNo[count] = travellerlist[count].passportNumber;
                            mobileNo[count] = travellerlist[count].mobileNumber;
                            diseaseList[count] = travellerlist[count].diseases;
                            insuredPartyDetail.partyCreate.push(travellerlist[count].partyDetails);
                            if(angular.equals({}, diseaseList[count])){
                                sufferingFromAnyDisease[count] = false;     
                            }else{
                                sufferingFromAnyDisease[count] = true;   
                            }

                            

                            
                            RelationshipInfo[count] = $filter('selectBoxFilter')(travelMaster.travellerRelation, travellerlist[count].relationship);
                        }
                       var travelllist = {
                            title: title,
                            firstName: firstName,
                            lastName: lastName,
                            gender: gender,
                            passportNumber: passportNo,
                            mobileNumber: mobileNo,
                            relationship: RelationshipInfo,
                            sufferingFromAnyDisease:sufferingFromAnyDisease,
                            diseaseList: diseaseList
                                // finalPremiumAmount: travelQuotePolicyInfoVm.premiumAmount.value,
                        }
                        TravellerApplicationDetails = travelllist;
                    }
                } else if (SavePageDetail == "physcianDetail") {
                    if (savedData && savedData.applicationData && savedData.applicationData.phisicianDetails) {
                        var physianDetail = savedData.applicationData.phisicianDetails;
                        var detail = {
                            name: physianDetail.name,
                            mobileNumber: physianDetail.mobileNumber,
                        }
                        physicianDetail = detail;
                    }
                }else if (SavePageDetail == "nomineeDetail") {
                   if (savedData && savedData.applicationData && savedData.applicationData && savedData.applicationData.nomineeDetails) {

                        var nomineeDetail = {};
                        nomineeDetail.uin  = savedData.uin;
                        nomineeDetail.nomineeTitle = savedData.applicationData.nomineeDetails.salutation;
                        nomineeDetail.name1 = savedData.applicationData.nomineeDetails.firstName;
                        nomineeDetail.nomineeLastName = savedData.applicationData.nomineeDetails.lastName;
                        nomineeDetail.relationship = $filter('selectBoxFilter')(travelMaster.nomineeRelation,savedData.applicationData.nomineeDetails.relationship); 
                        nomineeDetail.birthDate =  $filter('chosenDate')(savedData.applicationData.nomineeDetails.dob);
                       if(savedData.applicationData.appointeeDetails){
                        nomineeDetail.appointeeTitle =  savedData.applicationData.appointeeDetails.appointeeTitle;
                        nomineeDetail.name = savedData.applicationData.appointeeDetails.name;
                        nomineeDetail.appointeeLastName =  savedData.applicationData.appointeeDetails.lastName;
                        nomineeDetail.relationshipWithNominee = $filter('selectBoxFilter')(travelMaster.appointeeRelation,savedData.applicationData.appointeeDetails.appointeeRelationship);
                        nomineeDetail.proposerBirthday =  $filter('chosenDate')(savedData.applicationData.appointeeDetails.dob);
                       }
                    travelNomineeDetail = nomineeDetail;
                        

                     }
                } else {
                    for (var count = 0; count < SavePageDetail.length; count++) {
                        var cloudname = SavePageDetail[count].cloudName;
                        var modelname = SavePageDetail[count].modelName;
                        savedApplication = generalInsurenceHomeService.setObjectForService(savedData, cloudname, savedApplication, modelname, SavePageDetail[count].type);
                    }
                }
                
                savedApplication = {};
            }
        }




    }
]);



// })();
