angularApp.controller('travelApplicationTravellerInfoController', ["$state", "$scope", "$filter", "$translate", "$ionicPopup", "validateService", "generalInsurenceTravelService", "generalInsurenceHomeService", "utilityService", "GIconstant","generalInsurenceHealthService","clickStreamService",
    function($state, $scope, $filter, $translate, $ionicPopup, validateService, generalInsurenceTravelService, generalInsurenceHomeService, utilityService, GIconstant, generalInsurenceHealthService,clickStreamService) {

        //functions, variables that can be accessed from the HTML come here
        var travelApplicationTravellerInfoVm = this;
        travelApplicationTravellerInfoVm.travelerMemberDetails = [1];
        var noOftravellers, savedApplication;





        function SetSaveApplicationForTravel() {




            var travllerAppendedList = []
            var travellerlist = generalInsurenceTravelService.getTravellerDetail();
            var desisDetail = [];
            var partyDetails = generalInsurenceTravelService.getTravelInsuredCreateParty();

            travelApplicationTravellerInfoVm.isSufferingFromDisease = false;
            for (var count = 0; count < noOftravellers; count++) {
                desisDetail[count] = {}
                travllerAppendedList[count] = {};
                travllerAppendedList[count].title = travelApplicationTravellerInfoVm.title[count];
                travllerAppendedList[count].firstName = travelApplicationTravellerInfoVm.firstName[count];
                travllerAppendedList[count].lastName = travelApplicationTravellerInfoVm.LastName[count];
                travllerAppendedList[count].gender = travelApplicationTravellerInfoVm.gender[count].ikey;
                travllerAppendedList[count].passportNumber = travelApplicationTravellerInfoVm.passportNo[count];
                travllerAppendedList[count].mobileNumber = travelApplicationTravellerInfoVm.mobileNo[count];
                travllerAppendedList[count].dob = new Date(travellerlist[count].Birthdate);
                travllerAppendedList[count].relationship = travellerlist[count].Relationship.key;
                travllerAppendedList[count].sumInsured = travellerlist[count].SumInsured ? travellerlist[count].SumInsured : "";
                travllerAppendedList[count].partyDetails =  partyDetails.partyCreate[count];
                if (travelApplicationTravellerInfoVm.travelerDisease) {
                    if (travelApplicationTravellerInfoVm.travelerDisease[count]) {
                        travelApplicationTravellerInfoVm.isSufferingFromDisease = true;
                        for (var i = 0; i < travelApplicationTravellerInfoVm.desisList.length; i++) {
                            if (travelApplicationTravellerInfoVm.simpleHealthQuestionary.question[count]) {
                                if (travelApplicationTravellerInfoVm.simpleHealthQuestionary.question[count][i + 1]) {
                                    desisDetail[count][i] = travelApplicationTravellerInfoVm.desisList[i].value;
                                    if (travelApplicationTravellerInfoVm.simpleHealthQuestionary.quesAns && travelApplicationTravellerInfoVm.simpleHealthQuestionary.quesAns[count] && travelApplicationTravellerInfoVm.simpleHealthQuestionary.quesAns[count][i] && travelApplicationTravellerInfoVm.simpleHealthQuestionary.quesAns[count][i].desisValue) {
                                        desisDetail[count][i] = travelApplicationTravellerInfoVm.simpleHealthQuestionary.quesAns[count][i].desisValue;
                                    }
                                }
                            }
                        }
                    }
                }

                travllerAppendedList[count].diseases = desisDetail[count];

            }
            var Details = generalInsurenceTravelService.getTravellerApplicationDetails();
            Details.diseaseList = desisDetail;
            generalInsurenceTravelService.setTravellerApplicationDetails(Details);



            savedApplication.applicationData.travellerDetails = travllerAppendedList;
            savedApplication.applicationData.isSufferingDisease = travelApplicationTravellerInfoVm.isSufferingFromDisease;


            var JsonStingedData = angular.copy(savedApplication);
            generalInsurenceTravelService.setSavedData(savedApplication);
            JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
            JsonStingedData.cif = "";
            JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
            JsonStingedData.mobileNumber = "";
            JsonStingedData.uin = generalInsurenceHomeService.getProductDetail().uin;
            JsonStingedData.productCode = generalInsurenceHomeService.getGIProductsID();
            JsonStingedData.planName = generalInsurenceHomeService.getProductDetail().policyName;
            JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
            JsonStingedData.sumInsured = generalInsurenceHomeService.getpolicySumInsured() ? generalInsurenceHomeService.getpolicySumInsured() : "";
            JsonStingedData.policyStartDate = generalInsurenceHomeService.getpolicyStartdate() ? generalInsurenceHomeService.getpolicyStartdate() : "";

            generalInsurenceHomeService.saveApplication(JsonStingedData, GIconstant.OmniChannel.Travel.TI_TRAVELLER_DETAILS_1).then(function(data) {
                $state.go("menu.travelProposerphysiocalInfo");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        //private methods section start
        function initPage() {
            savedApplication = generalInsurenceTravelService.getSavedData();
            //travelApplicationTravellerInfoVm.name = [];
            travelApplicationTravellerInfoVm.title = [];
            travelApplicationTravellerInfoVm.firstName = [];
            travelApplicationTravellerInfoVm.LastName = [];
            travelApplicationTravellerInfoVm.sumInsured = [];
            travelApplicationTravellerInfoVm.passportNo = [];
            travelApplicationTravellerInfoVm.sumInsured = [];
            travelApplicationTravellerInfoVm.previousSumInsured = [];
            travelApplicationTravellerInfoVm.passportNo = [];
            travelApplicationTravellerInfoVm.mobileNo = [];
            travelApplicationTravellerInfoVm.gender = [];
            travelApplicationTravellerInfoVm.RelationshipInfo = [];
            travelApplicationTravellerInfoVm.travelerDisease = [];
            travelApplicationTravellerInfoVm.birthdate = [];
            travelApplicationTravellerInfoVm.showBack = true;
            travelApplicationTravellerInfoVm.showNext = true;
            travelApplicationTravellerInfoVm.simpleHealthQuestionary = {}
            travelApplicationTravellerInfoVm.simpleHealthQuestionary.question = [];
            travelApplicationTravellerInfoVm.simpleHealthQuestionary.quesAns = [];

            var pageDetailforPrevious = generalInsurenceTravelService.getTravellerDetail();
            noOftravellers = pageDetailforPrevious.length;



            travelApplicationTravellerInfoVm.genderList = generalInsurenceTravelService.getTravelMasterDetail().gender;
            travelApplicationTravellerInfoVm.titles = generalInsurenceTravelService.getTravelMasterDetail().salutation;
            travelApplicationTravellerInfoVm.desisList = generalInsurenceTravelService.getTravelMasterDetail().aliment;


            if (travelApplicationTravellerInfoVm.travelerMemberDetails.length == noOftravellers) {
                travelApplicationTravellerInfoVm.addTraveller = false;
            } else {
                travelApplicationTravellerInfoVm.addTraveller = true;
            }



            /*  handle back button function */
            if (generalInsurenceTravelService.getTravellerApplicationDetails()) {
                travelApplicationTravellerInfoVm.title = generalInsurenceTravelService.getTravellerApplicationDetails().title;
                travelApplicationTravellerInfoVm.firstName = generalInsurenceTravelService.getTravellerApplicationDetails().firstName;
                travelApplicationTravellerInfoVm.LastName = generalInsurenceTravelService.getTravellerApplicationDetails().lastName;
                travelApplicationTravellerInfoVm.RelationshipInfo = generalInsurenceTravelService.getTravellerApplicationDetails().relationship;
                travelApplicationTravellerInfoVm.gender = generalInsurenceTravelService.getTravellerApplicationDetails().gender;
                travelApplicationTravellerInfoVm.passportNo = generalInsurenceTravelService.getTravellerApplicationDetails().passportNumber;
                travelApplicationTravellerInfoVm.mobileNo = generalInsurenceTravelService.getTravellerApplicationDetails().mobileNumber;
                travelApplicationTravellerInfoVm.travelerDisease = generalInsurenceTravelService.getTravellerApplicationDetails().sufferingFromAnyDisease;
                var desisCount = generalInsurenceTravelService.getTravellerApplicationDetails().diseaseList;
                for (var count = 0; count < desisCount.length; count++) {
                    travelApplicationTravellerInfoVm.simpleHealthQuestionary.question[count] = {};
                    for (var key in desisCount[count]) {
                        if (desisCount[count].hasOwnProperty(key)) {
                            key = (Number(key) + 1) + "";

                            for (var i = 0; i < travelApplicationTravellerInfoVm.desisList.length; i++) {

                                if (key == travelApplicationTravellerInfoVm.desisList[i].key) {
                                    var selectedItem = travelApplicationTravellerInfoVm.desisList[i].key
                                    travelApplicationTravellerInfoVm.simpleHealthQuestionary.question[count][selectedItem] = true;
                                    if (travelApplicationTravellerInfoVm.desisList[i].field) {

                                        key = (Number(key) - 1) + "";
                                        travelApplicationTravellerInfoVm.simpleHealthQuestionary.quesAns[count] = {}
                                        travelApplicationTravellerInfoVm.simpleHealthQuestionary.quesAns[count][key] = {}
                                        travelApplicationTravellerInfoVm.simpleHealthQuestionary.quesAns[count][key].desisValue = desisCount[count][key];
                                    }
                                }


                            }


                        }
                    }

                }

            }


            /* set relationship of travellers  */
            var getrelationship = generalInsurenceTravelService.getTravellerDetail();
            for (var i = 0; i < getrelationship.length; i++) {
                travelApplicationTravellerInfoVm.RelationshipInfo[i] = getrelationship[i].Relationship.value;
                travelApplicationTravellerInfoVm.birthdate[i] = getrelationship[i].Birthdate;
                if (getrelationship.Policytype && getrelationship.Policytype == "Family Floater") {
                    travelApplicationTravellerInfoVm.previousSumInsured[i] = getrelationship[i].SumInsured.value;
                } else {
                    travelApplicationTravellerInfoVm.previousSumInsured[i] = "";
                }
                if (getrelationship[i].Relationship.key == "1") {
                    var personalDetail = generalInsurenceTravelService.getProposerContactDetail()
                    travelApplicationTravellerInfoVm.title[i] = personalDetail.title;
                    travelApplicationTravellerInfoVm.firstName[i] = personalDetail.firstName;
                    travelApplicationTravellerInfoVm.LastName[i] = personalDetail.lastName;
                    travelApplicationTravellerInfoVm.gender[i] = personalDetail.gender;
                    travelApplicationTravellerInfoVm.mobileNo[i] = personalDetail.mobileNo;

                }
            }



        }

        travelApplicationTravellerInfoVm.autoPopulateGender = function(index) {
            if (travelApplicationTravellerInfoVm.title[index].gender) {
                travelApplicationTravellerInfoVm.gender[index] = $filter('selectBoxFilter')(travelApplicationTravellerInfoVm.genderList, travelApplicationTravellerInfoVm.title[index].gender, "ikey");
            }
        }

        //private methods section end

        /* add Traveller details  */
        travelApplicationTravellerInfoVm.addMembersInfo = function() {
            if (travelApplicationTravellerInfoVm.travelerMemberDetails.length < noOftravellers) {
                travelApplicationTravellerInfoVm.travelerMemberDetails.push(travelApplicationTravellerInfoVm.travelerMemberDetails.length);
            }
            if (travelApplicationTravellerInfoVm.travelerMemberDetails.length == noOftravellers) {
                travelApplicationTravellerInfoVm.addTraveller = false;
            } else {
                travelApplicationTravellerInfoVm.addTraveller = true;
            }

        }

        //Validation
        travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm = {};
        travelApplicationTravellerInfoVm.validateService = validateService;

        function partyCreate(){
            var proposerDetails = generalInsurenceTravelService.getProposerContactDetail();
            var proposerPartyDetails = generalInsurenceTravelService.getTravelCreateParty();
            var partCreate = {};
            partCreate.partyCreate = [];

            for (var count = 0; count < noOftravellers; count++) {
                if(travelApplicationTravellerInfoVm.RelationshipInfo[count] != "Self"){
                    var personalDetail = {
                        "salutation": travelApplicationTravellerInfoVm.title[count].pkey,
                        "firstName": travelApplicationTravellerInfoVm.firstName[count],
                        "middleName": "",
                        "lastName": travelApplicationTravellerInfoVm.LastName[count],
                        "dob": $filter('dateFormat')(new Date(travelApplicationTravellerInfoVm.birthdate[count])),
                        "gender": travelApplicationTravellerInfoVm.gender[count].ikey,
                        "emailID": proposerDetails ? proposerDetails.email : "",
                        "mobile": proposerDetails ? proposerDetails.mobileNo : "",
                        "plotNo": proposerDetails ? proposerDetails.plotNO : "" ,
                        "buildingName": proposerDetails ? proposerDetails.address : "",
                        "streetName": proposerDetails ? proposerDetails.streetName : "",
                        "cityName" :  generalInsurenceHomeService.getLocationDetail().city.cityCode,
                        "stateName" : generalInsurenceHomeService.getLocationDetail().state.key,
                        "pinCode": proposerDetails ? proposerDetails.pincode : "",
                        "districtName" : generalInsurenceHomeService.getLocationDetail().district.districtCode,
                        "locality": proposerDetails ? proposerDetails.locality.loc : "",
                        "addressType": "CurrentAddress",
                        "partyRole": "Insured Member",
                        "maritalStatus":"",
                        "occupation":""
                    }
                    partCreate.partyCreate.push(personalDetail);
                }
            }

            //var locationDetail = generalInsurenceHomeService.getLocationDetails();
            // "dob": healthApplicationPersonalDetailsVm.data.birthdate,
            if(partCreate.partyCreate.length > 0){
                var partyDetails = {};
                partyDetails.partyCreate = [];
                generalInsurenceHomeService.getPartyCreationInsured(partCreate).then(function(data) {
                    var insuredParty = data;    
                    for (var count = 0; count < noOftravellers; count++) {
                        if(travelApplicationTravellerInfoVm.RelationshipInfo[count] == "Self"){
                            partyDetails.partyCreate.push(proposerPartyDetails.partyCreate);
                        }else{
                            partyDetails.partyCreate.push(insuredParty.partyCreate[0]);
                            insuredParty.partyCreate.splice(0,1);
                        }
                    }
                    //Save PartyDetails to cloudant
                    generalInsurenceTravelService.setTravelInsuredCreateParty(partyDetails);
                    var TravellerApplicationDetails = {
                        title: travelApplicationTravellerInfoVm.title,
                        firstName: travelApplicationTravellerInfoVm.firstName,
                        lastName: travelApplicationTravellerInfoVm.LastName,
                        gender: travelApplicationTravellerInfoVm.gender,
                        passportNumber: travelApplicationTravellerInfoVm.passportNo,
                        mobileNumber: travelApplicationTravellerInfoVm.mobileNo,
                        relationship: travelApplicationTravellerInfoVm.RelationshipInfo,
                        sufferingFromAnyDisease: travelApplicationTravellerInfoVm.travelerDisease,
                        diseaseList: travelApplicationTravellerInfoVm.diseases,
                        // finalPremiumAmount: travelQuotePolicyInfoVm.premiumAmount.value,
                    }

                    generalInsurenceTravelService.setTravellerApplicationDetails(TravellerApplicationDetails);
                    SetSaveApplicationForTravel();
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            
            }else{
                var partyDetails = {};
                partyDetails.partyCreate = [];
                partyDetails.partyCreate.push(proposerPartyDetails.partyCreate);
                generalInsurenceTravelService.setTravelInsuredCreateParty(partyDetails);
                var TravellerApplicationDetails = {
                    title: travelApplicationTravellerInfoVm.title,
                    firstName: travelApplicationTravellerInfoVm.firstName,
                    lastName: travelApplicationTravellerInfoVm.LastName,
                    gender: travelApplicationTravellerInfoVm.gender,
                    passportNumber: travelApplicationTravellerInfoVm.passportNo,
                    mobileNumber: travelApplicationTravellerInfoVm.mobileNo,
                    relationship: travelApplicationTravellerInfoVm.RelationshipInfo,
                    sufferingFromAnyDisease: travelApplicationTravellerInfoVm.travelerDisease,
                    diseaseList: travelApplicationTravellerInfoVm.diseases,
                    // finalPremiumAmount: travelQuotePolicyInfoVm.premiumAmount.value,
                }

                generalInsurenceTravelService.setTravellerApplicationDetails(TravellerApplicationDetails);
                SetSaveApplicationForTravel();
            }
            
        }

        //on click of next button
        travelApplicationTravellerInfoVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                if (travelApplicationTravellerInfoVm.travelerMemberDetails.length != noOftravellers) {
                    var travelContactsPopup = $ionicPopup.alert({
                        title: '',
                        templateUrl: 'pages/generalInsurance/travel/travelApplicationValidationPopup.html',
                        okText: "Close"
                    });

                    travelContactsPopup.then(function(res) {
                        //$state.go("menu.mySecurityProfiles");
                    });
                } else {
                    partyCreate();
                   
                }
            }
        }

        //common validation function
        function validateForm() {
            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm = {};
            //travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.name = {};
            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.title = [];
            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.firstName = [];
            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.LastName = [];
            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.passportNo = [];
            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.gender = [];
            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.birthdate = [];
            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.previousSumInsured = [];
            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.mobileNo = [];
            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.healthQuest = [];
            var i;
            var error = true;
            for (i = 0; i <= travelApplicationTravellerInfoVm.travelerMemberDetails.length - 1; i++) {
                if (travelApplicationTravellerInfoVm.validateService.isValidTitle(travelApplicationTravellerInfoVm.title[i])) {
                    travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.title[i] = travelApplicationTravellerInfoVm.validateService.isValidTitle(travelApplicationTravellerInfoVm.title[i]);
                    error = false;
                }
                if (travelApplicationTravellerInfoVm.validateService.isValidFirstName(travelApplicationTravellerInfoVm.firstName[i])) {
                    travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.firstName[i] = travelApplicationTravellerInfoVm.validateService.isValidFirstName(travelApplicationTravellerInfoVm.firstName[i]);
                    error = false;
                }

                if(travelApplicationTravellerInfoVm.RelationshipInfo[i] == "Self"){
                    if (travelApplicationTravellerInfoVm.validateService.isValidLastNameGI(travelApplicationTravellerInfoVm.LastName[i],true)) {
                        travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.LastName[i] = travelApplicationTravellerInfoVm.validateService.isValidLastNameGI(travelApplicationTravellerInfoVm.LastName[i],true);
                        error = false;
                    }
                }else{
                    if (travelApplicationTravellerInfoVm.validateService.isValidLastNameGI(travelApplicationTravellerInfoVm.LastName[i],false)) {
                        travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.LastName[i] = travelApplicationTravellerInfoVm.validateService.isValidLastNameGI(travelApplicationTravellerInfoVm.LastName[i],false);
                        error = false;
                    }
                }
                
                if (travelApplicationTravellerInfoVm.validateService.isValidPassportNo(travelApplicationTravellerInfoVm.passportNo[i])) {
                    travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.passportNo[i] = travelApplicationTravellerInfoVm.validateService.isValidPassportNo(travelApplicationTravellerInfoVm.passportNo[i]);
                    error = false;
                }
                if (travelApplicationTravellerInfoVm.validateService.isValidGender(travelApplicationTravellerInfoVm.gender[i])) {
                    travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.gender[i] = travelApplicationTravellerInfoVm.validateService.isValidGender(travelApplicationTravellerInfoVm.gender[i]);
                    error = false;
                }
                if (travelApplicationTravellerInfoVm.validateService.isValidPhoneNo(travelApplicationTravellerInfoVm.mobileNo[i])) {
                    travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.mobileNo[i] = travelApplicationTravellerInfoVm.validateService.isValidPhoneNo(travelApplicationTravellerInfoVm.mobileNo[i]);
                    error = false;
                }
                // if (travelApplicationTravellerInfoVm.validateService.isValidbirthDate(travelApplicationTravellerInfoVm.birthdate[i])) {
                //     travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.birthdate[i] = travelApplicationTravellerInfoVm.validateService.isValidbirthDate(travelApplicationTravellerInfoVm.birthdate[i]);
                // }

                // if (travelApplicationTravellerInfoVm.validateService.isValidSumInsured(travelApplicationTravellerInfoVm.previousSumInsured[i])) {
                //     travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.previousSumInsured[i] = travelApplicationTravellerInfoVm.validateService.isValidSumInsured(travelApplicationTravellerInfoVm.previousSumInsured[i]);
                // }

                if (travelApplicationTravellerInfoVm.travelerDisease[i]) {
                    
                    if ((angular.equals({}, travelApplicationTravellerInfoVm.simpleHealthQuestionary.question[i]) ? true : false) || !travelApplicationTravellerInfoVm.simpleHealthQuestionary.question[i]) {
                        travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.healthQuest[i] = $translate.instant('SELECT_HEALTH_QUESTION');
                        error = false;
                    }
                    var errorDetail = true;
                    if (travelApplicationTravellerInfoVm.simpleHealthQuestionary && travelApplicationTravellerInfoVm.simpleHealthQuestionary.question && travelApplicationTravellerInfoVm.simpleHealthQuestionary.question[i]) {
                        for (var key in travelApplicationTravellerInfoVm.simpleHealthQuestionary.question[i]) {
                            if (travelApplicationTravellerInfoVm.simpleHealthQuestionary.question[i].hasOwnProperty(key)) {
                                if (travelApplicationTravellerInfoVm.simpleHealthQuestionary.question[i][key] == true) {
                                   errorDetail =  false;
                                }
                            }
                        }
                    }
                    if(errorDetail == true){
                         error = false;
                          travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.healthQuest[i] = $translate.instant('SELECT_HEALTH_QUESTION');
                    }

                }
            }
            return error;
        }



            travelApplicationTravellerInfoVm.chkValidLastName = function() {
            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm = {};
            
            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.LastName = [];
            
            var error = true;
            
               
                for (var count = 0; count < noOftravellers; count++) {
                    if(travelApplicationTravellerInfoVm.RelationshipInfo[count] == "Self"){
                        if (travelApplicationTravellerInfoVm.validateService.isValidLastNameGI(travelApplicationTravellerInfoVm.LastName[count],true)) {
                            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.LastName[count] = travelApplicationTravellerInfoVm.validateService.isValidLastNameGI(travelApplicationTravellerInfoVm.LastName[count],true);
                            error = false;
                        }
                    }else{
                        if (travelApplicationTravellerInfoVm.validateService.isValidLastNameGI(travelApplicationTravellerInfoVm.LastName[count],false)) {
                            travelApplicationTravellerInfoVm.travelApplicationTravellerInfoForm.LastName[count] = travelApplicationTravellerInfoVm.validateService.isValidLastNameGI(travelApplicationTravellerInfoVm.LastName[count],false);
                            error = false;
                        }
                    }
                }
                
                
                
                
               
            
            return error;
        }

        

        /* go to previous page  */
        travelApplicationTravellerInfoVm.goBacktoPrevious = function() {
            $state.go("menu.travelProposerPersonalInfo");
        }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });



    }
]);




// }

// })();
