angularApp.controller('travelProposerPersonalInfoController', ["$timeout",
    "$state",
    "$scope", "$filter","validateService", "generalInsurenceTravelService", "generalInsurenceHomeService","utilityService","GIconstant","clickStreamService",

    function($timeout,
        $state,
        $scope,$filter,validateService, generalInsurenceTravelService, generalInsurenceHomeService,utilityService,GIconstant,clickStreamService) {

        //functions, variables that can be accessed from the HTML come here
        var travelProposerPersonalInfoVm = this;
        var savedApplication;
         var TravelMaster;
         travelProposerPersonalInfoVm.validateService = validateService;




         function SetSaveApplicationForTravel() {
             

             savedApplication.applicationData = {}; 
            var SavePageDetail = GIconstant.saveForTravel.TravelPersonalDetail;
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, travelProposerPersonalInfoVm, modelname, SavePageDetail[count].type);
            }
            savedApplication.applicationData.proposerDetails.gender =  travelProposerPersonalInfoVm.gender.ikey; 
            savedApplication.applicationData.proposerDetails.locationSource = generalInsurenceHomeService.getLocationDetail();
            savedApplication.applicationData.partyDetails =  {};
            savedApplication.applicationData.partyDetails.response =  generalInsurenceTravelService.getTravelCreateParty().partyCreate;


             var JsonStingedData = angular.copy(savedApplication);
             generalInsurenceTravelService.setSavedData(savedApplication);
             JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
             JsonStingedData.cif = "";
             JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
             JsonStingedData.mobileNumber = "";
             JsonStingedData.uin = generalInsurenceHomeService.getProductDetail().uin;
             JsonStingedData.productCode = generalInsurenceHomeService.getGIProductsID();
             JsonStingedData.planName = generalInsurenceHomeService.getProductDetail().policyName;
             JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
             JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
             JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";

             generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Travel.TI_PROPOSER_DETAILS).then(function(data) {
                 $state.go("menu.travelApplicationTravellerInfo");
             }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
             });
        }


        //private methods section start
        function initPage() {
           savedApplication = generalInsurenceTravelService.getSavedData();
           TravelMaster =  generalInsurenceTravelService.getTravelMasterDetail()

             travelProposerPersonalInfoVm.titles  = TravelMaster.proposerTitle;
             travelProposerPersonalInfoVm.genders =  TravelMaster.gender;

     

            var accountNumber = generalInsurenceHomeService.getaccountDetail();

            if(accountNumber){
                var account = {
                    "bankAccountNo" : accountNumber.benAccntNo
                }
                 generalInsurenceHomeService.getSBIBankAccoutDetails(account).then(function(data) {
                        if(data){
                         travelProposerPersonalInfoVm.firstName  =   data.cbsData.firstName;
                          travelProposerPersonalInfoVm.LastName  =   data.cbsData.lastName;
                          if(data.cbsData.genderCode=="F"){

                          }
                        travelProposerPersonalInfoVm.birthdate = $filter('formatCbsDate')(data.cbsData.dateOfBirth);
                        travelProposerPersonalInfoVm.pincode = data.cbsData.pinCode;
                            var pinCodeNumber;
                            if(travelProposerPersonalInfoVm.pincode.length == 6){
                                    pinCodeNumber =     {
                                          "pinCode": travelProposerPersonalInfoVm.pincode
                                      }
                                    generalInsurenceHomeService.getLocation(pinCodeNumber).then(function(data) {
                                        if(data){
                                        generalInsurenceHomeService.setLocationDetail(data);
                                            travelProposerPersonalInfoVm.city = data.city.cityName;
                                            travelProposerPersonalInfoVm.locations = data.location;
                                            
                                        }
                                    


                                        }, function(error) {
                                                utilityService.showErrorMessage(error.responseMessage);
                                    });
                            }
                              
                      
                         if(data.cbsData.email1){ 
                                travelProposerPersonalInfoVm.email = data.cbsData.email1;
                           }else{
                                 travelProposerPersonalInfoVm.email = data.cbsData.email1;
                          }  
                        travelProposerPersonalInfoVm.mobileNo = data.cbsData.mobileNumber;
                        travelProposerPersonalInfoVm.plotNO = data.cbsData.addressLine1;
                        travelProposerPersonalInfoVm.plotNO = travelProposerPersonalInfoVm.plotNO ? travelProposerPersonalInfoVm.plotNO.replace(/[^A-Za-z0-9./,-\s]/g, '') : '';
                        travelProposerPersonalInfoVm.BuildingName = data.cbsData.addressLine2;
                        travelProposerPersonalInfoVm.StreetName = data.cbsData.addressLine3;
                         
                    if(data.cbsData.genderCode=='F'){
                            travelProposerPersonalInfoVm.gender  = travelProposerPersonalInfoVm.genders[1]; 
                        for(var count =0; count < travelProposerPersonalInfoVm.titles.length;count++){
                            if("02" == travelProposerPersonalInfoVm.titles[count].cbsKey){
                              travelProposerPersonalInfoVm.title =   travelProposerPersonalInfoVm.titles[count];
                            }
                          }
                        }else{
                            travelProposerPersonalInfoVm.gender  = travelProposerPersonalInfoVm.genders[0]; 
                            for(var count =0; count < travelProposerPersonalInfoVm.titles.length;count++){
                            if("01" == travelProposerPersonalInfoVm.titles[count].cbsKey){
                              travelProposerPersonalInfoVm.title =   travelProposerPersonalInfoVm.titles[count];
                            }
                        }
                    }



                                      
                    }
                }, function(error) {
                   utilityService.showErrorMessage(error.responseMessage);
             });
            }

            travelProposerPersonalInfoVm.showBack = true;
            travelProposerPersonalInfoVm.showNext = true;

            /* birthdate svalidation for traveller */
            var currentDate = generalInsurenceHomeService.getCurrentDate();
            travelProposerPersonalInfoVm.birthdateEndLimit = generalInsurenceHomeService.getFutureYear(currentDate, -70);
            travelProposerPersonalInfoVm.birthdateStartLimit = generalInsurenceHomeService.getFutureDate(currentDate, -15);
            travelProposerPersonalInfoVm.defaultdate = generalInsurenceHomeService.getFutureDate(currentDate, -15);

            /*  handle back button function */
            $timeout(function() {
                if (generalInsurenceTravelService.getProposerContactDetail()) {
                    travelProposerPersonalInfoVm.firstName = generalInsurenceTravelService.getProposerContactDetail().firstName;
                    travelProposerPersonalInfoVm.LastName = generalInsurenceTravelService.getProposerContactDetail().lastName;
                    travelProposerPersonalInfoVm.name = generalInsurenceTravelService.getProposerContactDetail().name;
                    travelProposerPersonalInfoVm.address = generalInsurenceTravelService.getProposerContactDetail().address;
                    travelProposerPersonalInfoVm.city = generalInsurenceTravelService.getProposerContactDetail().city;
                    travelProposerPersonalInfoVm.pincode = generalInsurenceTravelService.getProposerContactDetail().pincode;
                     travelProposerPersonalInfoVm.checkpincodeDetail();
                    travelProposerPersonalInfoVm.birthdate = generalInsurenceTravelService.getProposerContactDetail().birthdate;
                    travelProposerPersonalInfoVm.email = generalInsurenceTravelService.getProposerContactDetail().email;
                    travelProposerPersonalInfoVm.mobileNo = generalInsurenceTravelService.getProposerContactDetail().mobileNo;

                    travelProposerPersonalInfoVm.title = generalInsurenceTravelService.getProposerContactDetail().title;
                    travelProposerPersonalInfoVm.gender = generalInsurenceTravelService.getProposerContactDetail().gender;
                    travelProposerPersonalInfoVm.plotNO = generalInsurenceTravelService.getProposerContactDetail().plotNO;
                    travelProposerPersonalInfoVm.plotNO = travelProposerPersonalInfoVm.plotNO ? travelProposerPersonalInfoVm.plotNO.replace(/[^A-Za-z0-9./,-\s]/g, '') : '';                    
                    travelProposerPersonalInfoVm.BuildingName = generalInsurenceTravelService.getProposerContactDetail().buildingName;
                    travelProposerPersonalInfoVm.StreetName = generalInsurenceTravelService.getProposerContactDetail().streetName;
                    travelProposerPersonalInfoVm.locality = generalInsurenceTravelService.getProposerContactDetail().locality;

                    $scope.$apply();
                }
            }, 10);


            travelProposerPersonalInfoVm.travelProposePersonalInfoForm = {};
            //onkeyup validate fields if required
           
        }
        //private methods section end

        //added for field levelo validation
        function validateForm() {
            travelProposerPersonalInfoVm.travelProposePersonalInfoForm = {};



            if (travelProposerPersonalInfoVm.validateService.isValidTitle(travelProposerPersonalInfoVm.title)) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.title = travelProposerPersonalInfoVm.validateService.isValidTitle(travelProposerPersonalInfoVm.title);
            }
            if (travelProposerPersonalInfoVm.validateService.isValidFirstName(travelProposerPersonalInfoVm.firstName)) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.firstName = travelProposerPersonalInfoVm.validateService.isValidFirstName(travelProposerPersonalInfoVm.firstName);
            }
            if (travelProposerPersonalInfoVm.validateService.isValidLastName(travelProposerPersonalInfoVm.LastName)) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.LastName = travelProposerPersonalInfoVm.validateService.isValidLastName(travelProposerPersonalInfoVm.LastName);
            }
             if (travelProposerPersonalInfoVm.validateService.isValidGender(travelProposerPersonalInfoVm.gender)) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.gender = travelProposerPersonalInfoVm.validateService.isValidGender(travelProposerPersonalInfoVm.gender);
            }
            if (travelProposerPersonalInfoVm.validateService.isValidplotNO(travelProposerPersonalInfoVm.plotNO)) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.plotNO = travelProposerPersonalInfoVm.validateService.isValidplotNO(travelProposerPersonalInfoVm.plotNO);
            }
            if (travelProposerPersonalInfoVm.validateService.isValidBuildingName(travelProposerPersonalInfoVm.BuildingName)) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.BuildingName = travelProposerPersonalInfoVm.validateService.isValidBuildingName(travelProposerPersonalInfoVm.BuildingName);
            }
            if (travelProposerPersonalInfoVm.validateService.isValidStreetName(travelProposerPersonalInfoVm.StreetName)) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.StreetName = travelProposerPersonalInfoVm.validateService.isValidStreetName(travelProposerPersonalInfoVm.StreetName);
            }
            if (travelProposerPersonalInfoVm.validateService.isValidlocality(travelProposerPersonalInfoVm.locality)) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.locality = travelProposerPersonalInfoVm.validateService.isValidlocality(travelProposerPersonalInfoVm.locality);
            }
            if (travelProposerPersonalInfoVm.validateService.isValidCity(travelProposerPersonalInfoVm.city)) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.city = travelProposerPersonalInfoVm.validateService.isValidCity(travelProposerPersonalInfoVm.city);
            }
            if (travelProposerPersonalInfoVm.validateService.isValidPincode(travelProposerPersonalInfoVm.pincode)) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.pincode = travelProposerPersonalInfoVm.validateService.isValidPincode(travelProposerPersonalInfoVm.pincode);
            }
            if (travelProposerPersonalInfoVm.validateService.isValidbirthDate(travelProposerPersonalInfoVm.birthdate)) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.birthdate = travelProposerPersonalInfoVm.validateService.isValidbirthDate(travelProposerPersonalInfoVm.birthdate);
            }
            if (travelProposerPersonalInfoVm.validateService.isValidEmail((travelProposerPersonalInfoVm.email).trim())) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.email = travelProposerPersonalInfoVm.validateService.isValidEmail((travelProposerPersonalInfoVm.email).trim());
            }
            if (travelProposerPersonalInfoVm.validateService.isValidPhoneNo(travelProposerPersonalInfoVm.mobileNo)) {
                travelProposerPersonalInfoVm.travelProposePersonalInfoForm.mobileNo = travelProposerPersonalInfoVm.validateService.isValidPhoneNo(travelProposerPersonalInfoVm.mobileNo);
            }
            return (angular.equals({}, travelProposerPersonalInfoVm.travelProposePersonalInfoForm)) ? true : false;
        }


        travelProposerPersonalInfoVm.goBacktoPrevious = function() {
            $state.go("menu.paymentAccountDetailsTravel");
            //To do
        }

        travelProposerPersonalInfoVm.checkpincodeDetail = function(){
            if(travelProposerPersonalInfoVm.pincode){
                if(travelProposerPersonalInfoVm.pincode.length==6){
                    var  pinCodeNumber =  {
                                          "pinCode": travelProposerPersonalInfoVm.pincode
                                      }

                    generalInsurenceHomeService.getLocation(pinCodeNumber).then(function(data) {
                                if(data){
                                 generalInsurenceHomeService.setLocationDetail(data);
                                       travelProposerPersonalInfoVm.city = data.city.cityName;
                                       travelProposerPersonalInfoVm.locations = data.location;


                                }
                               

                                }, function(error) {
                                    utilityService.showErrorMessage(error.responseMessage);
                              });

                }
            }
        }


        function createParty(){

          var PersonalDetail =   {
              "partyCreate" : {
                "salutation" : travelProposerPersonalInfoVm.title.pkey,
                "firstName" : travelProposerPersonalInfoVm.firstName,
                "middleName": "",
                "lastName": travelProposerPersonalInfoVm.LastName,
                "dob" : $filter('dateFormat')(travelProposerPersonalInfoVm.birthdate) ,
                "gender" : travelProposerPersonalInfoVm.gender.ikey,
                "emailID" : travelProposerPersonalInfoVm.email,
                "mobile" : travelProposerPersonalInfoVm.mobileNo,
                "plotNo" : travelProposerPersonalInfoVm.plotNO,
                "buildingName" : travelProposerPersonalInfoVm.BuildingName,
                "streetName" : travelProposerPersonalInfoVm.StreetName,
                "cityName" :  generalInsurenceHomeService.getLocationDetail().city.cityCode,
                "stateName" : generalInsurenceHomeService.getLocationDetail().state.key,
                "pinCode" : travelProposerPersonalInfoVm.locality.pinId,
                "districtName" : generalInsurenceHomeService.getLocationDetail().district.districtCode,
                "locality" : travelProposerPersonalInfoVm.locality.loc,
                "addressType": "CurrentAddress",
                "partyRole": "Policy Holder",
                "maritalStatus":"",
                "occupation":""
              }
            }


             generalInsurenceHomeService.getPartyCreation(PersonalDetail).then(function(data) {
                    if(data){
                        generalInsurenceTravelService.setTravelCreateParty(data);
                        SetSaveApplicationForTravel();
                        
                    }
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
            });


            


        }


        /*  if valid go to next page  */
        travelProposerPersonalInfoVm.goToNextPage = function() {
                // to do
                if (validateForm()) {
                   clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                    createParty();
                    var proposerContactDetail = {
                        title : travelProposerPersonalInfoVm.title,
                        firstName : travelProposerPersonalInfoVm.firstName,
                        lastName : travelProposerPersonalInfoVm.LastName,
                        address: travelProposerPersonalInfoVm.address,
                        city: travelProposerPersonalInfoVm.city,
                        pincode: travelProposerPersonalInfoVm.pincode,
                        birthdate: travelProposerPersonalInfoVm.birthdate,
                        email: travelProposerPersonalInfoVm.email,
                        mobileNo: travelProposerPersonalInfoVm.mobileNo,
                        gender :  travelProposerPersonalInfoVm.gender,
                        plotNO : travelProposerPersonalInfoVm.plotNO,
                        buildingName : travelProposerPersonalInfoVm.BuildingName,
                        streetName : travelProposerPersonalInfoVm.StreetName,
                        locality :  travelProposerPersonalInfoVm.locality



                    }
                    generalInsurenceTravelService.setProposerContactDetail(proposerContactDetail);
                   // $state.go("menu.travelApplicationTravellerInfo");
                }
            }
            //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {

        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {
            //any cleanup needs to be done here: executes everytime when page is left
        });
        return this;
    }
]);
// })();
