angularApp.controller('travelQuotePolicyInfoController', [
    "$state",
    "$scope", "generalInsurenceTravelService", "validateService", "$filter", "$ionicPopup", "generalInsurenceHomeService","GIconstant","utilityService","generalInsurenceHomeDetailService","clickStreamService",

    function(
        $state,
        $scope, generalInsurenceTravelService, validateService, $filter, $ionicPopup, generalInsurenceHomeService,GIconstant,utilityService,generalInsurenceHomeDetailService,clickStreamService) {

        //functions, variables that can be accessed from the HTML come here
        var travelQuotePolicyInfoVm = this;
        var countryList,Masters;
        travelQuotePolicyInfoVm.constant =   GIconstant;

        var savedApplication;

         function assignforTravel(){
        /* get all fields details on click back button  */
                if (generalInsurenceTravelService.getTravellerPolicyDetails()) {
                    travelQuotePolicyInfoVm.productType = generalInsurenceTravelService.getTravellerPolicyDetails().policyType;
                    travelQuotePolicyInfoVm.policyOption = generalInsurenceTravelService.getTravellerPolicyDetails().policyOption;
                    travelQuotePolicyInfoVm.additonal = generalInsurenceTravelService.getTravellerPolicyDetails().travellingToUSCanada;
                    travelQuotePolicyInfoVm.Countrystay = generalInsurenceTravelService.getTravellerPolicyDetails().Countrystay;
                    travelQuotePolicyInfoVm.travelPurpose = generalInsurenceTravelService.getTravellerPolicyDetails().travelPurpose;
                    travelQuotePolicyInfoVm.startDate = generalInsurenceTravelService.getTravellerPolicyDetails().startDate;
                    travelQuotePolicyInfoVm.endDate = generalInsurenceTravelService.getTravellerPolicyDetails().endDate;
                    travelQuotePolicyInfoVm.diffVal = generalInsurenceTravelService.getTravellerPolicyDetails().diffVal;
                }else{

                    travelQuotePolicyInfoVm.productType = "";
                    travelQuotePolicyInfoVm.policyOption = "";
                    travelQuotePolicyInfoVm.additonal = "";
                    travelQuotePolicyInfoVm.Countrystay = "";
                    travelQuotePolicyInfoVm.travelPurpose = "";
                    travelQuotePolicyInfoVm.startDate = "";
                    travelQuotePolicyInfoVm.endDate = "";
                    travelQuotePolicyInfoVm.diffVal = "";

                }
        }





        //  function retriewSaveData() {
        //     var detail = {
        //         "applicationNumber": generalInsurenceHomeService.getapplicationNumber()
        //     }
        //     generalInsurenceHomeService.getSavedApplicationForAPI(detail).then(function(data) {
        //         if (data) {
        //             if(generalInsurenceHomeService.isJson(data.quoteData)){
        //                 data.quoteData = JSON.parse(data.quoteData);
        //             }
        //             if(generalInsurenceHomeService.isJson(data.applicationData)){
        //                 data.applicationData = JSON.parse(data.applicationData);
        //             }
        //             savedApplication = data;
        //             generalInsurenceTravelService.setSavedData(savedApplication);
        //             generalInsurenceTravelService.assignvalueForTravel();
        //             assignforTravel();
        //         }
        //     }, function(error) {
        //         utilityService.showErrorMessage(error.responseMessage);
        //     });
        // }




        function SetSaveApplicationForTravel() {
            var SavePageDetail = GIconstant.saveForTravel.TravelPolicyDetail;
            if(savedApplication.quoteData){
                if(savedApplication.quoteData.productDetails){
                }else{
                     savedApplication.quoteData = {};
                }
            }
            for (var count = 0; count < SavePageDetail.length; count++) {
                var cloudname = SavePageDetail[count].cloudName;
                var modelname = SavePageDetail[count].modelName;
                savedApplication = generalInsurenceHomeService.setObjectForSave(savedApplication, cloudname, travelQuotePolicyInfoVm, modelname, SavePageDetail[count].type);
                savedApplication.quoteData.productDetails.countryOfMaxStay = travelQuotePolicyInfoVm.Countrystay.locId;
             }
             var JsonStingedData = angular.copy(savedApplication);
             generalInsurenceTravelService.setSavedData(savedApplication);
             JsonStingedData.quoteData = JSON.stringify(JsonStingedData.quoteData);
             JsonStingedData.cif = "";
             JsonStingedData.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
             JsonStingedData.mobileNumber = "";
             JsonStingedData.uin = generalInsurenceHomeService.getProductDetail().uin;
             JsonStingedData.productCode = generalInsurenceHomeService.getGIProductsID();
             JsonStingedData.planName = generalInsurenceHomeService.getProductDetail().policyName;
             JsonStingedData.applicationData = JSON.stringify(JsonStingedData.applicationData);
              JsonStingedData.sumInsured =  generalInsurenceHomeService.getpolicySumInsured() ?  generalInsurenceHomeService.getpolicySumInsured() : "";   
            JsonStingedData.policyStartDate =   generalInsurenceHomeService.getpolicyStartdate() ?   generalInsurenceHomeService.getpolicyStartdate() : "";
            
            generalInsurenceHomeService.saveApplication(JsonStingedData,GIconstant.OmniChannel.Travel.TI_PREMIUM_1).then(function(data) {


               $state.go("menu.travelQuoteTravellerInfo");
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }



        
        //private methods section start
        function initPage() {
            //retriewSaveData();
            travelQuotePolicyInfoVm.isChecked = false;
            travelQuotePolicyInfoVm.showBack = true;
            travelQuotePolicyInfoVm.showNext = true;
            travelQuotePolicyInfoVm.additonal = false;
            travelQuotePolicyInfoVm.airplaneMode = [{ "checked": true }];

            /* validate travel start date  */
            travelQuotePolicyInfoVm.minstartDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());
            travelQuotePolicyInfoVm.maxEndDate = generalInsurenceHomeService.getFutureDate(travelQuotePolicyInfoVm.minstartDate, GIconstant.Travel.TravelEnddateLimit);
           assignforTravel();

        }


         generalInsurenceTravelService.getTravelMaster().then(function(data) {
            if(data){
                generalInsurenceTravelService.setTravelMasterDetail(data);
                Masters = data;
                travelQuotePolicyInfoVm.productTypes = data.productTypes;
                travelQuotePolicyInfoVm.policyOptions = data.policyOptions; 
                travelQuotePolicyInfoVm.travelPurposes = data.purposeOfTravel;
                travelQuotePolicyInfoVm.Countrystays = data.countryList;
            }
              

            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });

           


        /*  List each dropdown list in perticular field */
        function travelResponse(response) {
            travelQuotePolicyInfoVm.productTypes = response.data.productTypes;
            travelQuotePolicyInfoVm.policyOptions = response.data.policyOptions;
            travelQuotePolicyInfoVm.policyOption = response.data.policyOptions[0];
            travelQuotePolicyInfoVm.Countrystays = response.data.countryList;
            travelQuotePolicyInfoVm.travelPurposes = response.data.travelPurpose;
        }

        // date difference function
        travelQuotePolicyInfoVm.showDateDiff = function() {
            travelQuotePolicyInfoVm.diffVal = $filter('dateDifferenceInDays')(travelQuotePolicyInfoVm.startDate, travelQuotePolicyInfoVm.endDate);
            return travelQuotePolicyInfoVm.diffVal;
        }


        //validation function starts
        travelQuotePolicyInfoVm.travelPolicyInfo = {};
        //onkeyup validate fields if required
        travelQuotePolicyInfoVm.validateService = validateService;


        /*  check all field validation  */
        function validateForm() {
            travelQuotePolicyInfoVm.travelPolicyInfo = {};

            if (travelQuotePolicyInfoVm.validateService.isValidProductType(travelQuotePolicyInfoVm.productType)) {
                travelQuotePolicyInfoVm.travelPolicyInfo.productType = travelQuotePolicyInfoVm.validateService.isValidProductType(travelQuotePolicyInfoVm.productType);
            }
            if (travelQuotePolicyInfoVm.validateService.isValidPolicyOption(travelQuotePolicyInfoVm.policyOption)) {
                travelQuotePolicyInfoVm.travelPolicyInfo.policyOption = travelQuotePolicyInfoVm.validateService.isValidPolicyOption(travelQuotePolicyInfoVm.policyOption);
            }
            if (travelQuotePolicyInfoVm.validateService.isValidPolicyStartDate(travelQuotePolicyInfoVm.startDate)) {
                travelQuotePolicyInfoVm.travelPolicyInfo.startDate = travelQuotePolicyInfoVm.validateService.isValidPolicyStartDate(travelQuotePolicyInfoVm.startDate);
            }
           
            if (travelQuotePolicyInfoVm.validateService.isValidDateGI(travelQuotePolicyInfoVm.startDate,travelQuotePolicyInfoVm.minstartDate,travelQuotePolicyInfoVm.maxEndDate)) {
                travelQuotePolicyInfoVm.travelPolicyInfo.startDate = travelQuotePolicyInfoVm.validateService.isValidDateGI(travelQuotePolicyInfoVm.startDate,travelQuotePolicyInfoVm.minstartDate,travelQuotePolicyInfoVm.maxEndDate);
            }
            if (travelQuotePolicyInfoVm.policyOption.value == 'Single trip') {
                if (travelQuotePolicyInfoVm.validateService.isValidCountryStay(travelQuotePolicyInfoVm.Countrystay)) {
                    travelQuotePolicyInfoVm.travelPolicyInfo.Countrystay = travelQuotePolicyInfoVm.validateService.isValidCountryStay(travelQuotePolicyInfoVm.Countrystay);
                }

            }

            if (travelQuotePolicyInfoVm.validateService.isValidPolicyEndDate(travelQuotePolicyInfoVm.endDate)) {
                travelQuotePolicyInfoVm.travelPolicyInfo.endDate = travelQuotePolicyInfoVm.validateService.isValidPolicyEndDate(travelQuotePolicyInfoVm.endDate);
            }
            
            if (travelQuotePolicyInfoVm.validateService.isValidDateGI(travelQuotePolicyInfoVm.endDate,travelQuotePolicyInfoVm.travelEndStartLimit,travelQuotePolicyInfoVm.travelEndLimit)) {
                travelQuotePolicyInfoVm.travelPolicyInfo.endDate = travelQuotePolicyInfoVm.validateService.isValidDateGI(travelQuotePolicyInfoVm.endDate,travelQuotePolicyInfoVm.travelEndStartLimit,travelQuotePolicyInfoVm.travelEndLimit);
            }

            if (travelQuotePolicyInfoVm.validateService.isValideTravelPurpose(travelQuotePolicyInfoVm.travelPurpose)) {
                travelQuotePolicyInfoVm.travelPolicyInfo.travelPurpose = travelQuotePolicyInfoVm.validateService.isValideTravelPurpose(travelQuotePolicyInfoVm.travelPurpose);
            }
            return (angular.equals({}, travelQuotePolicyInfoVm.travelPolicyInfo)) ? true : false;
        }


        /* calculate Travel End Date Limit Based on Travel start Date */
        travelQuotePolicyInfoVm.calculateEndDateLimit = function() {
            var startDate = travelQuotePolicyInfoVm.startDate;
            travelQuotePolicyInfoVm.travelEndLimit = generalInsurenceHomeService.getFutureDate(startDate, GIconstant.Travel.TraveldateLimit);
            travelQuotePolicyInfoVm.travelEndStartLimit = generalInsurenceHomeService.getFutureDate(startDate, 1);
            travelQuotePolicyInfoVm.defaultEndDate = generalInsurenceHomeService.getFutureDate(startDate, 1);
        }

        /* Calculate End Date based on Number of days  */
        travelQuotePolicyInfoVm.calculateStartEndDate = function() {
            var noOfDays = parseInt(travelQuotePolicyInfoVm.diffVal);
            noOfDays--;
            if(noOfDays > 0){
                 if (noOfDays <= GIconstant.Travel.TraveldateLimit || !noOfDays) {
                    travelQuotePolicyInfoVm.startDate = $filter('chosenDate')(generalInsurenceHomeService.getCurrentDate());
                    var travelEndDate = generalInsurenceHomeService.getFutureDate(travelQuotePolicyInfoVm.startDate, noOfDays);
                    travelQuotePolicyInfoVm.endDate = travelEndDate;
                 }
            }else{
                travelQuotePolicyInfoVm.endDate = "";
            }
        }

        //private methods section end

        /*  if valid go to next page  */
        travelQuotePolicyInfoVm.goToNextPage = function() {
            if (validateForm()) {
                clickStreamService.clickStreamData = generalInsurenceHomeService.getProductDetail().policyName;
                generalInsurenceHomeService.setpolicyStartdate(travelQuotePolicyInfoVm.startDate); 
                var TravellerPolicyDetails = {
                policyType: travelQuotePolicyInfoVm.productType,
                policyOption: travelQuotePolicyInfoVm.policyOption,
                travellingToUSCanada: travelQuotePolicyInfoVm.additonal,
                Countrystay: travelQuotePolicyInfoVm.Countrystay,
                travelPurpose: travelQuotePolicyInfoVm.travelPurpose,
                startDate: travelQuotePolicyInfoVm.startDate,
                endDate: travelQuotePolicyInfoVm.endDate,
                diffVal: travelQuotePolicyInfoVm.diffVal,
            }
            generalInsurenceTravelService.setTravellerPolicyDetails(TravellerPolicyDetails);

            if (savedApplication) {
                SetSaveApplicationForTravel();
            } else {
                var basicStructure = generalInsurenceHomeDetailService.getBasicStructureForHome();
                basicStructure.applicationNumber = generalInsurenceHomeService.getapplicationNumber();
                basicStructure.uin = generalInsurenceHomeService.getProductDetail().uin;
                basicStructure.productCode = generalInsurenceHomeService.getGIProductsID();
                basicStructure.planName = generalInsurenceHomeService.getProductDetail().policyName;
                savedApplication = basicStructure;
                SetSaveApplicationForTravel();
                
            }

                
                
            }
        }

        /*  go to back button */
        travelQuotePolicyInfoVm.goBacktoPrevious = function() {
            $state.go("menu.travelRecommendedPolicyFeatures");
        }

        /* single trip for family floater */
        travelQuotePolicyInfoVm.changePolicyOption = function() {
            if (travelQuotePolicyInfoVm.productType.value == 'Family Floater') {
                travelQuotePolicyInfoVm.policyOption = travelQuotePolicyInfoVm.policyOptions[0];
            }
        }

        /* Popup for Sports / Medical Travel   */
        travelQuotePolicyInfoVm.changeTravelPurposeOption = function() {
            if (travelQuotePolicyInfoVm.travelPurpose.key == GIconstant.Travel.purposeOfTravelForMedical || travelQuotePolicyInfoVm.travelPurpose.key == GIconstant.Travel.purposeOfTravelForAdventureSports) {
                var alertPopup = $ionicPopup.alert({
                    title: '',
                    templateUrl: 'pages/generalInsurance/travel/travelpurposePopup.html'
                });
                travelQuotePolicyInfoVm.travelPurpose = "";
            }
        }

        

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

       
    }
]);
// })();
