'use strict';
angularApp.controller('governmentSchemesLandingWCMController', [
	"$state", "governmentSchemeService", "$scope", "utilityService",
	function ($state, governmentSchemeService, $scope, utilityService) {

		var governmentSchemesLandingWCMVm = this;
	
		governmentSchemesLandingWCMVm.goToBack = function () {
			$state.go('menu.serviceRequest');
		};

		governmentSchemesLandingWCMVm.goToscheme = function (schemeDetailsWCMURL) {
			var requestData = { "schemeDetailsWCMURL": schemeDetailsWCMURL };
			
			governmentSchemeService.getGovernmentSchemeDetails(requestData).then(function (data) {
				
				$state.go('menu.governmentSchemeDetails', { schemeDetails: data });
			}, function (err) {
				utilityService.showNfsAlertModal("", err.responseMessage, "menu.serviceRequest", $scope, $state, "OK");
			});



		};
	
		function initPage() {
		
			var requestData = { "type": "getGovernmentSchemes" };
			governmentSchemeService.getGovernmentSchemesList(requestData).then(function (data) {
			
				governmentSchemesLandingWCMVm.getGovernmentSchemesList = data.getGovernmentSchemes;
			
			}, function (err) {
				utilityService.showNfsAlertModal("", err.responseMessage, "menu.serviceRequest", $scope, $state, "OK");
			});

		}

		$scope.$on('$ionicView.beforeEnter', function () {
			initPage();

		});
		return this;
	}

]);
