'use strict';

angularApp.controller('homeScreenController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"openAccountService",
	"$rootScope",
	"customerInfoService",
	"getAccountDetailsService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"generalInsurenceHomeService",
	"cardsService",
	"mutualFundsService",
	"aoService",
	"myProfileService",
	"lifeInsuranceBasicApplicationService",
	"$filter",
	"sampoornSurakshaService",
	"currentLocationService",
	"locateNearestBranchService",
	"fTBeneficiaryService",
	"ompMerchantsService",
	"bookingsService",
	"instaHomeService",
	"wealthService",
	"requestYCService",
	"irctcService",
	"agriMandiService",
	"$ionicSlideBoxDelegate",
	"ionicToast",
	"clickStreamService",
	"wearableServices",
	"paclService",
	"bhimUpiService",
	"loggedInUserService",
	"constantConfig",
	"ompOffersService",
	"safalService",
	"patwlService",
	"mySecurityProfileService",
	"$translate",
	"automallService",
	"cryptoService",
	"mobilityLandingService",
	"updateKYCService",	"pablService",
	function ($timeout,
		$state,
		$ionicPopup,
		$scope,
		homeScreenService,
		openAccountService,
		$rootScope,
		customerInfoService,
		getAccountDetailsService,
		utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		generalInsurenceHomeService,
		cardsService,
		mutualFundsService,
		aoService,
		myProfileService,
		lifeInsuranceBasicApplicationService,
		$filter,
		sampoornSurakshaService,
		currentLocationService,
		locateNearestBranchService,
		fTBeneficiaryService,
		ompMerchantsService,
		bookingsService,
		instaHomeService,
		wealthService,
		requestYCService,
		irctcService,
		agriMandiService,
		$ionicSlideBoxDelegate,
		ionicToast,
		clickStreamService,
		wearableServices,
		paclService,
		bhimUpiService,
		loggedInUserService,
		constantConfig,
		ompOffersService,
		safalService,
		patwlService,
		mySecurityProfileService,
		$translate,
		automallService,
		cryptoService,
		mobilityLandingService,
		updateKYCService, pablService) {

		var homeScreenVM = this;
		homeScreenVM.log_image = true;
		homeScreenVM.alertsData = [];
		homeScreenVM.offersData = [];
		//homeScreenVM.profileImg = "";
		homeScreenVM.dateForInsta = "";
		$rootScope.searchObj = {};
		homeScreenVM.isSearched = false;
		homeScreenVM.selectedMerchantAffiliateId = "";
		var isWebviewLoadingCanceled = false;

		function initPage() {
			$ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
			if (!$rootScope.bellNotificationCnt) {
				$rootScope.bellNotificationCnt = 0;
			}

			$ionicSlideBoxDelegate.update();
			$ionicSlideBoxDelegate.loop(true);
			redirectToIrctc();
		}
		
		/**
		 * START : SEARCH FUNCTIONALITY
		 */
		homeScreenVM.getSearchJSONData = function(){
			if(Object.keys(homeScreenService.searchedList).length === 0){
				homeScreenService.getSearchFunctionalityData().then(function(data) {
					homeScreenService.searchedList = data;
					homeScreenVM.searchedList = data;
				},function(error){});
			}
			else{
				homeScreenVM.searchedList = homeScreenService.searchedList;
			}
		};

		homeScreenVM.yonoSearch = function(inputItem){
			var arrForinputItem = [];
			var regExpInput = "";
			var str = '';
			homeScreenVM.filteredList = [];
			homeScreenVM.isSearched = false;
			var arr = [];
			if(inputItem && inputItem.length >= 2){
				arrForinputItem = (inputItem.toLowerCase()).split(/[,\s]+/g);
				for(var i=0;i<arrForinputItem.length;i++){
					str += "(?=.*"+arrForinputItem[i]+")";
				}
				regExpInput = new RegExp("^"+str+".*$"),"gm";
				angular.forEach(homeScreenVM.searchedList,function(v1,k1){
					if(homeScreenVM.searchedList[k1]["searchLabel"].toString().toLowerCase().match(regExpInput)){
						arr.push(v1);
						homeScreenVM.filteredList = removedDuplicateObjects(arr);
						homeScreenVM.isSearched = true;
						$ionicScrollDelegate.$getByHandle('search-functionality-handle').scrollTop();
					}
				});
			}
			else{
				homeScreenVM.isSearched = false;
				homeScreenVM.filteredList = [];
			}
			homeScreenVM.dashboardContainerBlur(arrForinputItem);
			var reportStr = homeScreenVM.searchLabel;
			homeScreenVM.reportId = reportStr.replace(/\s+/g,",").substring(0,reportStr.length);
			return homeScreenVM.filteredList;
		}

		homeScreenVM.dashboardContainerBlur = function(arrForinputItem){
			var container = document.getElementById("homeScreenDashboardConatiner");
			if(homeScreenVM.searchLabel && homeScreenVM.searchLabel.length >= 2){
				container.className = "blur-dashboard-container";
			}
			else{
				container.removeAttribute("class");
			}
		}

		homeScreenVM.highlightSearchedText = function(arrForinputItem){
			if(homeScreenVM.isSearched && homeScreenVM.filteredList.length > 0){
				setTimeout(function(){
					for(var j=0;j<arrForinputItem.length;j++){
						for(var i=0;i<homeScreenVM.filteredList.length;i++){
							var a = document.getElementsByClassName("phraseDropdownId") ? document.getElementsByClassName("phraseDropdownId")[i].innerText : "";
							a = a.toLowerCase().toString();
							if(homeScreenVM.filteredList[i]["phraseInDropdown"].toLowerCase().match(arrForinputItem[j])){
								var r = new RegExp("("+arrForinputItem[j]+")",'gi');
								var t = homeScreenVM.filteredList[i]["phraseInDropdown"].replace(r,"<span class='highlight'>$1</span>");
								if(a){
									document.getElementsByClassName("phraseDropdownId")[i].innerHTML = t;
								}
							}
						}
					}
				},1);
			}
		}

		var removedDuplicateObjects = function (arr) {
			return arr.filter(function(item, index){
				return arr.indexOf(item) >= index;
			});
		};

		homeScreenVM.selectedObj = function(selectedItem){
			var spinner = $ionicPopup.show({
				cssClass: 'removePopupHeader removePopupBodyPading spinnerPopup',
				templateUrl: 'common/directives/templates/spinner.html'
			});
			cordova.plugins.Keyboard.close();
			var view = selectedItem.view.indexOf("()");
			setTimeout(function(){spinner.close();},1000);
			
			if(selectedItem.isRoutingToVPAView && selectedItem.isRoutingToVPAView.toLowerCase() === "true"){
				//Code for UPI, Scan and Pay to contact
				homeScreenVM.redirectToBhimUpi(selectedItem);
			}
			else{
				if(view === -1){
					$state.go(selectedItem.view);
				}
				else{
					$scope.$eval(selectedItem.view);
				}
			}
		}

		homeScreenVM.redirectToBhimUpi = function(selectedItem){
			utilityService.showSpinner();
            if (!localStorage.getItem("appGenId")) {
                bhimUpiService.getNativeData("generateAppGenId", {}).then(function (data) {
                    if (device.platform.toLowerCase() == 'android') {
                        bhimUpiService.appGenId = data.appGenId;
                    } else {
                        bhimUpiService.appGenId = data;
                    }
                    homeScreenVM.redirectToBhimUpiFlow(selectedItem);
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            } else {
                bhimUpiService.getNativeData("setAppGenId", localStorage.getItem("appGenId")).then(function (data) {
                    homeScreenVM.redirectToBhimUpiFlow(selectedItem);
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            }
		}

		homeScreenVM.redirectToBhimUpiFlow = function(selectedItem){
			if (device.platform.toLowerCase() == 'android') {
                utilityService.showSpinner();
                var json = JSON.stringify({});
                bhimUpiService.getNativeData(constantConfig.upiConstant.getpermission, json).then(function (data) {
                    if (data.permission === 'Allowed') {
                        homeScreenVM.redirectToBhimUpiJourney(selectedItem);
                    } else {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("alert", "UPI registration requires permission to use camera, SMS and Phone calls. Please allow these permissions. If problem persists re-initiate UPI registration.");
                    }
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            } else if (device.platform.toLowerCase() == 'windows') {
                ionicToast.show("The functionality is not available in windows currently.", 'bottom', false, 3000);
            } else {
                utilityService.showSpinner();
                var json = JSON.stringify({
                    "pspId": constantConfig.upiConstant.pspId,
                    "encryptionKey": loggedInUserService.upiPermissionKey.split("^")[2]
                });
                bhimUpiService.getNativeData("initializeIOSsdk", json).then(function (data) {
                    if (data !== "S") {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("error", data);
                        return false;
                    }
                    utilityService.showSpinner();
                    var json = JSON.stringify({
                        "addInfo": {
                            "addInfo10": constantConfig.upiConstant.addInfo10,
                            "addInfo9": constantConfig.upiConstant.addInfo9
                        },
                        "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                        "requestInfo": {
                            "pspId": constantConfig.upiConstant.pspId,
                            "pspRefNo": generateRandomString(27)
                        },
                        "updateFlag": constantConfig.upiConstant.updateFlag,
                        "smsSent": "false"
                    });
                    bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
                        $rootScope.checkDeviceInfo = JSON.parse(data);
                        if ($rootScope.checkDeviceInfo.status == 'S') {
							utilityService.hideSpinner();
							if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
								if(selectedItem.category && selectedItem.category.toUpperCase() === "QR"){
									customerInfoService.scanQrEntrypoint = 'FTLANDING';
                                    customerInfoService.payerDetails = {};
                                    customerInfoService.payeeDetails = {};
									$state.go('menu.payToQR');
								}
                                else{
									$state.go('menu.fundtrans');
								}
                            }else{
								homeScreenVM.fundTransfer();
							}
                        } else {
                            utilityService.hideSpinner();
                            utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
                        }
                    }, function (msg) {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("error", msg);
                    });
                }, function (msg) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("error", msg);
                });
            }
		}

		homeScreenVM.redirectToBhimUpiJourney = function(selectedItem){
			/*Sim card Info fetching - Start*/
            function simInfosuccessCallback(result) {
                if (result !== undefined && result != null && result != '') {
                    if (result.cards && result.cards.length > 0) {
                        customerInfoService.simCardInfo = result;
                        utilityService.showSpinner();
                        var json = JSON.stringify({
                            "addInfo": {
                                "addInfo10": constantConfig.upiConstant.addInfo10,
                                "addInfo9": constantConfig.upiConstant.addInfo9
                            },
                            "recoveryOptionFlag": constantConfig.upiConstant.recoveryOptionFlag,
                            "requestInfo": {
                                "pspId": constantConfig.upiConstant.pspId,
                                "pspRefNo": generateRandomString(27)
                            },
                            "updateFlag": constantConfig.upiConstant.updateFlag,
                            "smsSent": false
                        });
                        bhimUpiService.getNativeData(constantConfig.upiConstant.checkDevice, json).then(function (data) {
                            $rootScope.checkDeviceInfo = JSON.parse(data);
                            if ($rootScope.checkDeviceInfo.status == 'S') {
								utilityService.hideSpinner();
                                if ($rootScope.checkDeviceInfo.deviceStatus == 'DR' && $rootScope.checkDeviceInfo.simStatus == 'SNM') {
                                	if(selectedItem.category && selectedItem.category.toUpperCase() === "QR"){
										customerInfoService.scanQrEntrypoint = 'FTLANDING';
										customerInfoService.payerDetails = {};
										customerInfoService.payeeDetails = {};
										$state.go('menu.payToQR');
									}
									else{
										$state.go('menu.fundtrans');
									}
                                }else{
									homeScreenVM.fundTransfer();
								}
                            } else {
                                utilityService.hideSpinner();
                                utilityService.showBhimUpiAlert("error", $rootScope.checkDeviceInfo.statusDesc);
                            }
                        }, function (msg) {
                            utilityService.hideSpinner();
                            utilityService.showBhimUpiAlert("error", msg);
                        });
                    } else {
                        utilityService.hideSpinner();
                        utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
                    }
                } else {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("alert", "Please insert simcard to proceed further");
                }
            }

            function HasPerminionSuccessCallback(result) {
                if (result) {
                    window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallback);
                } else {
                    requestReadPermission();
                }
            }

            function errorCallback(error) {
                var elementSimInfo = document.getElementById('ErrorInfo');
                elementSimInfo.innerHTML = error;
            }

            function requestSuccessCallback(result) {
                if (result) {
                    hasReadPermission();
                }
            }

            // Android only: check permission
            function hasReadPermission() {
                window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallback);
            }

            // Android only: request permission
            function requestReadPermission() {
                window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallback);
            }

            hasReadPermission();
            /*Sim card Info fetching - End*/
		}

		homeScreenVM.commonfunForProfilePassCheck = function(){
			var profPassObj = {
				prevPage: "menu.homeScreen",
				nextPage: "menu.ftProfilePassword",
				goto: "menu.setProfilePassword",
				ionicPopup: $ionicPopup,
				accOverviewData: getAccountDetailsService.accountOverviewData
			};
			getAccountDetailsService.commonfunForProfilePassCheck(profPassObj);
		}

		homeScreenVM.redirectToInsurance = function(productId){
			switch (productId) {
                case 'life-insurance':
                    $state.go('menu.sbiLifeIntro');
                    break;
                case 'personal-accident-insurance':
                    $state.go('menu.declaimer');
                    break;
                case 'health-insurance':
                    $state.go('menu.declaimer');
                    break;
                case 'motor-insurance':
                    $state.go('menu.declaimer');
                    break;
                case 'travel-insurance':
                    $state.go('menu.declaimer');
                    break;
                case 'home-insurance':
                    $state.go('menu.declaimer');
                    break;
                // case '111N078V03': 
                //      rrService.addRetrive(false);
                //      $state.go('menu.rinnRaksha');
                //      break;
                case '111N040V04':
                   sampoornSurakshaService.getPremiumAndNomineeInfo().then(function(data) {
                        sampoornSurakshaService.clearAll();
                        sampoornSurakshaService.setPremiumDetails(data);
                        $state.go('menu.ssPremiumCalculation');
                    }, function(error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                    break;
            }
            generalInsurenceHomeService.setGIProductsID(productId);
		}
		/**
		 * END : SEARCH FUNCTIONALITY
		 */


		$scope.draggedStyle = {
			bottom: '20px',
			right: '20px'
		};
		var onDraggableEvent = function (evt, data) {
			if (evt.name == 'draggable:start') {
				$scope.OffsetDifferenceTop = data.y - data.element[0].offsetTop;
				$scope.OffsetDifferenceLeft = data.x - data.element[0].offsetLeft;
				$scope.newTop = $scope.OffsetDifferenceTop;
				$scope.newLeft = $scope.OffsetDifferenceLeft;
			} else if (evt.name == 'draggable:end') {
				if (data.y - $scope.OffsetDifferenceTop < 20) {
					$scope.newTop = 40;
					data.y = 80;
				} else if (((data.y - $scope.OffsetDifferenceTop) + 20) > document.getElementsByClassName("homeScreenbg")[1].clientHeight) {
					$scope.newTop = 20;
					data.y = document.getElementsByClassName("homeScreenbg")[1].clientHeight;
				}
				if (data.x - $scope.OffsetDifferenceLeft < 0) {
					$scope.newLeft = 20;
					data.x = 20;
				} else if (((data.x - $scope.OffsetDifferenceLeft) + 75) > document.getElementsByClassName("homeScreenbg")[1].clientWidth) {
					$scope.newLeft = 75;
					data.x = document.getElementsByClassName("homeScreenbg")[1].clientWidth;
				}
				$scope.setPosition(data);
			} else if (evt.name == 'touch') {
			}
		}
		$scope.$on('draggable:start', onDraggableEvent);
		$scope.$on('draggable:end', onDraggableEvent);
		$scope.$on('touch', onDraggableEvent);
		$scope.setPosition = function (data) {
			$scope.draggedStyle = {
				top: (data.y - $scope.newTop) + 'px',
				left: (data.x - $scope.newLeft) + 'px'
			};
		}
		$timeout(function () {
			var home = $ionicScrollDelegate.$getByHandle('horizontalHome').getScrollView();
			if (!home) {
				return true;
			}
			var container = home.__container;
			var originaltouchStart = home.touchStart;
			var originaltouchMove = home.touchMove;
			container.removeEventListener('touchstart', home.touchStart);
			document.removeEventListener('touchmove', home.touchMove);
			home.touchStart = function (e) {
				e.preventDefault = function () { }
				originaltouchStart.apply(home, [e]);
			}
			home.touchMove = function (e) {
				e.preventDefault = function () { }
				originaltouchMove.apply(home, [e]);
			}
			container.addEventListener("touchstart", home.touchStart, false);
			document.addEventListener("touchmove", home.touchMove, false);
		});


		$timeout(function () {
			var homeshop = $ionicScrollDelegate.$getByHandle('horizontalHomeShop').getScrollView();
			if (!homeshop) {
				return true;
			}
			var container = homeshop.__container;
			var originaltouchStart = homeshop.touchStart;
			var originaltouchMove = homeshop.touchMove;
			container.removeEventListener('touchstart', homeshop.touchStart);
			document.removeEventListener('touchmove', homeshop.touchMove);
			homeshop.touchStart = function (e) {
				e.preventDefault = function () { }
				originaltouchStart.apply(homeshop, [e]);
			}
			homeshop.touchMove = function (e) {
				e.preventDefault = function () { }
				originaltouchMove.apply(homeshop, [e]);
			}
			container.addEventListener("touchstart", homeshop.touchStart, false);
			document.addEventListener("touchmove", homeshop.touchMove, false);
		});

		homeScreenVM.getProfilePercent = function () {
			if (!$rootScope.profileScore) {
				myProfileService.getProfilePercent().then(function (data) {
					$rootScope.profileScore = data.profilePercentage;
				}, function (error) {
					$rootScope.profileScore = "";
				});
			}
		}

		/**
		 * Register For Push
		 */
        homeScreenVM.registerForPush = function () {
            try {
                  WLAuthorizationManager.obtainAccessToken("push.mobileclient").then(
                    MFPPush.registerDevice(null,
                        function (successResponse) {
                            homeScreenService.isPushEnabled = true;
                        },function (failureResponse) { 
                        }
                    )
                );
            }
            catch(err) {
              console.log(err);
            }
            
        }

		/**
		 * it will calculate customer age
		 */
		homeScreenVM.calculateAge = function(dob){
			if(dob){
                var today = new Date();
                var tempDate = dob;
                tempDate = tempDate.split(' ');
                var monList = ["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"];
                for(var i=0 ; i<monList.length ; i++){
					if(tempDate[1].toUpperCase() == monList[i]){
						tempDate[1] = i+1;
                        break;
                	}
                }
				var newTmepDate = tempDate[2] + "/" + tempDate[1] + "/" + tempDate[0];
                var birthDate = new Date(newTmepDate);
                var age = today.getFullYear() - birthDate.getFullYear();
                var m = today.getMonth() - birthDate.getMonth();
                if (m < 0 || (m === 0 && today.getDate() < birthDate.getDate())) {
                    age--;
                }
                return age;
            }else{
                return 18;
            }
		}

		homeScreenVM.getCustomerInfo = function () {
			if (!getAccountDetailsService.accountOverviewData) {
				//homeScreenVM.welcomeTitleSpinner = true;
				homeScreenService.isCustCalled = true;
				homeScreenService.getCustomerInfo().then(function (data) {
					//To display message for NRI customers only [residentialStatus : 1 (India), 2(NRI)]
					if (data.customerInformation && (data.customerInformation.residentialStatus && data.customerInformation.residentialStatus === "2")) {
						var getNRICounterFromLocalStorage = sessionStorage.getItem('getNRICounterFromLocalStorage');
						if (!getNRICounterFromLocalStorage || getNRICounterFromLocalStorage === "0") {
							homeScreenVM.msgForNRICustomers();
						}
					}
					homeScreenService.isCustCalled = false;
					getAccountDetailsService.accountOverviewData = data;
					if (getAccountDetailsService.isProfilePwdSet && getAccountDetailsService.accountOverviewData.profilePasswordFlag) {
						getAccountDetailsService.accountOverviewData.profilePasswordFlag = true;
					}
					homeScreenVM.data = data.customerInformation;
					customerInfoService.customerInfo = data.customerInformation;
					//localStorage.setItem("customername", homeScreenVM.data.customerName);
					homeScreenVM.setCustomerInofAndAccountDetails();
					//homeScreenVM.welcomeTitleSpinner = false;

					// homeScreenService.isCustCalled = false;
					// getAccountDetailsService.accountOverviewData = data;
					// homeScreenVM.data = data.customerInformation;
					// localStorage.setItem("customername", homeScreenVM.data.customerName);
					// homeScreenVM.setCustomerInofAndAccountDetails();
					// homeScreenVM.welcomeTitleSpinner = false;
					homeScreenVM.customerAge = homeScreenVM.calculateAge(homeScreenVM.data.dob);
					if(homeScreenService.offersData && homeScreenVM.customerAge > 55){
						homeScreenVM.offers = [];
						homeScreenVM.offers = homeScreenService.offersData.filter(function(offer){
							return offer.category !== "SS";
						});
						homeScreenService.offersData = homeScreenVM.offers;
						homeScreenVM.offersData = homeScreenVM.offers;
					}
				}, function (error) {
					homeScreenService.isCustCalled = false;
					//homeScreenVM.welcomeTitleSpinner = false;
					$rootScope.profileImageUrl = 'img/profile_placeholder.svg';
				});
			} else {
				homeScreenVM.data = getAccountDetailsService.accountOverviewData.customerInformation;
				if(getAccountDetailsService.isProfilePwdSet && getAccountDetailsService.accountOverviewData.profilePasswordFlag){
					getAccountDetailsService.accountOverviewData.profilePasswordFlag = true;
				}
				homeScreenVM.setCustomerInofAndAccountDetails();
			}
		}

		homeScreenVM.msgForNRICustomers = function(){
			var msg = $filter('translate')('MESSAGE_FOR_NRI_CUSTOMERS');
			ionicToast.show(msg, "middle", false, 7000);
			var dynamicDiv = document.createElement("div");
			var imgDiv = document.createElement("img");
			imgDiv.setAttribute("src","img/Info_icon.svg");
			imgDiv.setAttribute("style","width:30px;text-align:center;");
			dynamicDiv.appendChild(imgDiv);
			if(document.getElementsByClassName('ionic_toast')){
				document.getElementsByClassName('ionic_toast')[0].setAttribute("style","background:rgba(255,255,255,1);margin:0 10px;padding-left: 5px;padding-right: 5px;font-size:14px;border-radius:5px;color:#3F3F3F;box-shadow: 0 0 20px #4c4c4c;");
				document.getElementsByClassName('ionic_toast')[0].insertBefore(dynamicDiv,document.getElementsByClassName('ionic_toast')[0].firstChild);
				var getNRICounterFromLocalStorage = parseInt(sessionStorage.getItem('getNRICounterFromLocalStorage') ? sessionStorage.getItem('getNRICounterFromLocalStorage') : 0);
				sessionStorage.setItem('getNRICounterFromLocalStorage',getNRICounterFromLocalStorage+1);
			}
		}

		/**
		 * it will return set customer info and account details
		 */
		homeScreenVM.setCustomerInofAndAccountDetails = function () {
			mutualFundsService.addUserDetails(homeScreenVM.data, true);
			mutualFundsService.addUserPanDetails(homeScreenVM.data);
			$rootScope.customerInfoForProfile = homeScreenVM.data;
			customerInfoService.customer.name = homeScreenVM.data.customerName;
			customerInfoService.customer.type = homeScreenVM.data.customerType;
			customerInfoService.customer.DOB = homeScreenVM.data.dob;
			customerInfoService.customer.isPanAvailable = homeScreenVM.data.panNumber;
			customerInfoService.customer.isStaffFlag = homeScreenVM.data.isStaffFlag;
			customerInfoService.customer.emailID = homeScreenVM.data.emailID;
			customerInfoService.customer.mobile = homeScreenVM.data.mobile;
			customerInfoService.customer.title = homeScreenVM.data.title;
			customerInfoService.customer.residentialStatus = homeScreenVM.data.residentialStatus;

			$rootScope.customerAccNo = homeScreenVM.data.accountNumber;
			$rootScope.mobileNo = homeScreenVM.data.mobile;
			localStorage.setItem("customername", homeScreenVM.data.customerName);
			localStorage.setItem("customerlanguage", homeScreenVM.data.language);			$rootScope.customerName = localStorage.getItem('customername');
			customerInfoService.customer.imageurl = homeScreenVM.data.imageUrl;
			var balData = homeScreenVM.data.balance;
			balData = balData.split("+");
			if (balData.length === 1) {
				homeScreenVM.symbol = "";
				homeScreenVM.balance = balData[0];
			} else if (balData.length > 1) {
				homeScreenVM.symbol = "";
				homeScreenVM.balance = balData[1];
			} else {
				balData = balData.split("-");
				if (balData.length === 1) {
					homeScreenVM.symbol = "";
					homeScreenVM.balance = balData[0];
				} else {
					homeScreenVM.symbol = "-";
					homeScreenVM.balance = balData[1];
				}
			}
		}

		homeScreenVM.eligibleWealth = function () {
			if (wealthService.wealthLinkToKnowMore != "") {
                homeScreenVM.createKnowMore(wealthService.wealthLinkToKnowMore);
            } else {
                var obj = {
                    "type": "wealthLinkToKnowMore"
                }
                wealthService.WealthLinkToSbiExclusif(obj).then(function (data) {
                    wealthService.wealthLinkToKnowMore = data;
                    homeScreenVM.createKnowMore(data);
                }, function (error) {
                    console.log("error", error)
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }

		}

        homeScreenVM.createKnowMore = function (contentWcm) {
            var template = '';
            template = '<div class ="exlusif_know_more">' + contentWcm + '</div>';
            $ionicPopup.show({
                title: '',
                template: template,
                scope: $scope,
                cssClass: 'my-custom-popup',
                buttons: [{
                    text: 'OK',
                    type: 'button-assertive',
                    onTap: function () {
                        $state.go('menu.verifyDetails');
                    }
                }],
            });
        }

		/**
		 * This function will open selected PAPL.
		 */
		homeScreenVM.openPal = function (categoryType) {
			personalLoanService.clearAll();
			personalLoanService.getLoanDetails({category:categoryType}).then(function (data) {
				personalLoanService.setPANDOBData();
				personalLoanService.personalLoanData = data;
				personalLoanService.minDuration = data.minTenure;
				personalLoanService.maxDuration = data.maxTenure;
				personalLoanService.interestRate = data.interestRate;
				personalLoanService.product = data.productCode;
				personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
				personalLoanService.processingFee = data.processingFee;
				personalLoanService.minBestOffer = data.minPalAmount;
				personalLoanService.activityCode = data.activityCode;
				personalLoanService.schemeCode = data.schemeCode;
				personalLoanService.categoryType = categoryType ;
				if(categoryType.toUpperCase() == 'PAPL'){
					$state.go('menu.plPanDob');
				}else{
					personalLoanService.getKavachDeclaration().then(function(data){
						personalLoanService.kavachDeclarationText = data ;
						$state.go('menu.paplKawachDeclaration');					
					},function(error){
						utilityService.showErrorMessage(error.responseMessage);
					})					
				}
			}, function (error) {
				homeScreenService.isNotificationDataAvail = false;
				homeScreenVM.getnotificationOffer();
				utilityService.showErrorMessage(error.responseMessage);
			});
		}

		homeScreenVM.bannerWidth = function () {
			if (homeScreenService.offersData && homeScreenService.offersData.length > 1) {
				homeScreenVM.homeWidth = window.innerWidth - (window.innerWidth * 0.15) + "px";
			} else {
				homeScreenVM.homeWidth = "100%";
			}
		}
			// code for YSF Starts
		homeScreenVM.disclaimer = function (offerData) {
          homeScreenVM.selectedOffer=offerData;
		 homeScreenVM.myPopup = $ionicPopup.show({
                title: '',
                cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
                templateUrl: "pages/homeScreen/disclaimerPopup.html",
                scope: $scope
            });
        };

        homeScreenVM.cancel = function () {
            homeScreenVM.myPopup.close();
        };

        homeScreenVM.agree = function () {
			clickStreamService.clickStreamData = "websiteId," + "";
            homeScreenVM.myPopup.close();
			$state.go('menu.ompMerchants');
        }

		//code for YSF Ends

		homeScreenVM.getnotificationOffer = function () {
			if (!homeScreenService.isNotificationDataAvail) {
				homeScreenVM.isPageCurrent=true;
				homeScreenService.getnotificationOffer().then(function (data) {
					homeScreenService.isNotificationDataAvail = true;
					if (data.suggestedData.offers && data.suggestedData.alerts) {
						homeScreenService.alertsData = data.suggestedData.alerts;
						if(homeScreenVM.customerAge && homeScreenVM.customerAge > 55){
							homeScreenService.offersData = data.suggestedData.offers.filter(function(offer){
								return offer.category !== "SS";
							});
						}else{
							homeScreenService.offersData = data.suggestedData.offers;
						}
						homeScreenVM.offersData = homeScreenService.offersData;
						homeScreenVM.alertsData = homeScreenService.alertsData;
						homeScreenVM.bannerWidth();
						$rootScope.bellNotificationCnt = homeScreenService.getBellNotificationCount();
						for(var i=0 ; i <data.suggestedData.offers.length ; i++){
							data.suggestedData.offers[i].category = data.suggestedData.offers[i].category.toUpperCase();
							if(data.suggestedData.offers[i].category == "SS"){
								/*ADDED FOR: Home Screen API Optimization: UX2.0*/
								var eligibleSumAssured = String.fromCharCode(8377) + $filter('INR')(parseInt(data.suggestedData.offers[i].amount));
								data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("FIELD_1}}",eligibleSumAssured).replace("Rs. ",String.fromCharCode(8377)) : eligibleSumAssured;


							}else if (data.suggestedData.offers[i].category == "IHL") {
								var eligibleSumAssured = $filter('INR')(parseInt(data.suggestedData.offers[i].amount));
								data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("FIELD_1}}", eligibleSumAssured).replace("FIELD_2}}", '<a href="javscript:;">here</a>') : eligibleSumAssured;
								instaHomeService.isInstaAvail = true;
							}
							if(data.suggestedData.offers[i].category == "PAPL"){
								var eligibleSumAssured = String.fromCharCode(8377) + $filter('INR')(parseInt(data.suggestedData.offers[i].palAmount));
								data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace(data.suggestedData.offers[i].palAmount,eligibleSumAssured).replace("Rs. ",String.fromCharCode(8377)) : eligibleSumAssured;
							}
if (data.suggestedData.offers[i].category == "WEALTH") {
								if(data.suggestedData.offers[i].bannerFlag == "True")
								{
									wealthService.bannerFlag = true;
									data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription : '';
								}
								else{
									data.suggestedData.offers.splice(i,1);
									wealthService.bannerFlag = false;
								}
							}
							
							if(data.suggestedData.offers[i].category == "PACL"){
								var eligibleSumAssured = $filter('INR')(parseInt(data.suggestedData.offers[i].amount));
								data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("FIELD_1}}",eligibleSumAssured).replace("Rs. ",String.fromCharCode(8377)) : eligibleSumAssured;
								paclService.setPACLData(data.suggestedData.offers[i]);
							}
							if (data.suggestedData.offers[i].category == "PA2WL") {
								var eligibleSumAssuredPATWL = $filter('INR')(parseInt(data.suggestedData.offers[i].maxLoanAmt));
								data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("FIELD_1}}", eligibleSumAssuredPATWL).replace("Rs. ", String.fromCharCode(8377)) : eligibleSumAssuredPATWL;
								//  patwlService.setOfferBannerData(data.suggestedData.offers[i]);
							}
							if(data.suggestedData.offers[i].category == "SAFAL-CROP"){
								var eligibleSumAssured = String.fromCharCode(8377) + $filter('INR')(parseInt(data.suggestedData.offers[i].amount));
								data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("SAFAL",'<b>SAFAL</b>').replace("Loan",'<b>Loan</b>').replace("FIELD_1}}",eligibleSumAssured) : eligibleSumAssured;
							}
							if(data.suggestedData.offers[i].category == "SAFAL-DAIRY"){
								var eligibleSumAssured = String.fromCharCode(8377) + $filter('INR')(parseInt(data.suggestedData.offers[i].amount));
								data.suggestedData.offers[i].messageDescription = data.suggestedData.offers[i].messageDescription ? data.suggestedData.offers[i].messageDescription.replace("SAFAL",'<b>SAFAL</b>').replace("Loan",'<b>Loan</b>').replace("FIELD_1}}",eligibleSumAssured) : eligibleSumAssured;
							}
						}
					}
					//code for ysf starts
					ompOffersService.ysfData=data;
						if(ompOffersService.ysfData.suggestedData.ysf == "TRUE"){
							if(ompOffersService.fromOfferPage){
							}
							else{
								if(homeScreenVM.isPageCurrent){
									homeScreenVM.disclaimer(ompOffersService.ysfData.suggestedData.ysfDetails);
								}
								else{

								}

							}
						}
					//code for ysf ends
				}, function (error) {
					homeScreenService.isNotificationDataAvail = false;
					ompOffersService.ysfData="";
				});
			} else {
				if (homeScreenService.offersData && homeScreenService.alertsData) {
					homeScreenVM.offersData = homeScreenService.offersData;
					homeScreenVM.alertsData = homeScreenService.alertsData;
					homeScreenVM.bannerWidth();
					$rootScope.bellNotificationCnt = homeScreenService.getBellNotificationCount();
				}

			}
		}

		homeScreenVM.buyoffer = function(offer){
			if(offer.category == "SS"){
				sampoornSurakshaService.getPremiumAndNomineeInfo().then(function(data) {
					sampoornSurakshaService.clearAll();
					sampoornSurakshaService.setPremiumDetails(data);
					$state.go('menu.ssPremiumCalculation');
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}else if (offer.category == "ODTA") {
				if (!mutualFundsService.totalSecurities) {
					mySecurityProfileService.getSecProfile().then(function (data) {
						mutualFundsService.totalSecurities = data.securities;
						homeScreenVM.checkDpList();
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					homeScreenVM.checkDpList();
				}

			} else if(offer.category == "LR"){
				homeScreenService.isInsuranceFlag = true;
				getAccountDetailsService.tabIndex.tabIndex = 4;
				$state.go('menu.accountOverviewMyBalance');
			} else if(offer.category == "YSS") {
				homeScreenService.onYSSBuyNow();
			}
		}

		homeScreenVM.goToYonoAgri = function () {
			agriMandiService.isUserFromSettings = false;
			if (getAccountDetailsService.accountOverviewData) {
				if (getAccountDetailsService.accountOverviewData.customerInformation.language) {
					agriMandiService.selectLanguage = getAccountDetailsService.accountOverviewData.customerInformation.language.toLowerCase();
					if(!agriMandiService.kucFlag){
                        agriMandiService.checkEligibilityKUC().then(function(data) {
                            agriMandiService.kucFlag = data.eligibilityStatus;
                            $state.go('menu.agriLanding');
                        }, function (error) {
                            $state.go('menu.agriLanding'); 
                        });
                    }else {
                         $state.go('menu.agriLanding'); 
                    }
				} else {
					$state.go('menu.selectLanguage');
				}
			} else {
				utilityService.showBhimUpiAlert("alert", "Customer details are being fetched. Please try again.");
			}
		}

		homeScreenVM.mitraMandiRedirection = function(URL){
			if (getAccountDetailsService.accountOverviewData) {
				if (getAccountDetailsService.accountOverviewData.customerInformation.language) {
                    agriMandiService.selectLanguage =  getAccountDetailsService.accountOverviewData.customerInformation.language.toLowerCase();
					$state.go(URL)
                } else {
					 agriMandiService.selectLanguage = 'en';
					 $state.go(URL)
				}
			} else {
				utilityService.showBhimUpiAlert("alert", "Customer details are being fetched. Please try again.");
			}
		}

		homeScreenVM.checkDpList = function () {
			if (mutualFundsService.totalSecurities.dpList != null && mutualFundsService.totalSecurities.dpList.length > 0) {
				homeScreenVM.showError($translate.instant('OPEN_DEMAT_ALREADY_HAVE_ACCOUNT_LBL'));
			} else {
				openAccountService.checkDematApplicationExists().then(function (data) {
					if (data.applicationStatus == null || data.applicationStatus.trim() == "" || data.applicationStatus.toLowerCase() == "initiated") {
						openAccountService.setStatusOfOpenAccount(0);
						clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "ONLINE_DEMAT_OPEN_NOW"));
						$state.go('menu.dematAndTradingAccount');
					} else {
						homeScreenService.isInvestmentFlag = true;
						getAccountDetailsService.tabIndex.tabIndex = 3;
						$state.go('menu.accountOverviewMyBalance');
						//homeScreenVM.showErrorCaution($translate.instant('OPEN_DEMAT_UNDER_PROCESS_LBL'));
					}

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				})

			}
		}

		homeScreenVM.showErrorCaution = function (mssg) {
			var showPopUp = $ionicPopup.alert({
				title: "",
				template: '<div class="popup-padding font-dark-grey"><div><center><img alt="" class="approvedIconPosition" src="img/yc_Group.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="arsa-pop-msg-color">'
				+ mssg + '</span></div></div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
				buttons: [{
					text: 'OK',
					type: 'button-positive',
					onTap: function () {
						showPopUp.close();
					}
				}]
			})
		}

		//Show popup of showError if user is already having Demat ID
		homeScreenVM.showError = function (message) {
			$ionicPopup.show({
				template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
				+ message + '</span></div></div></div>',
				title: 'Alert',
				cssClass: 'dialog',
				scope: $scope,
				buttons: [{
					text: 'Ok',
					onTap: function (e) {
						homeScreenService.isInvestmentFlag = true;
						getAccountDetailsService.tabIndex.tabIndex = 3;
						$state.go('menu.accountOverviewMyBalance');
					}
				}]
			});
		}

		homeScreenVM.knowMoreOffer = function(offer){
			if(offer.category == "SS"){
				sampoornSurakshaService.getPolicyFeatures().then(function(data) {
					sampoornSurakshaService.setPolicyDetails(data);
					sampoornSurakshaService.setBuyNow(true);
					$state.go('menu.ssPolicyFeatures');
				}, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
		}

		homeScreenVM.billPay = function () {
			billDeskService.billDeskToken();
		}
		homeScreenVM.yonoCash = function () {
			$state.go('menu.yonoCash');
			// requestYCService.isUserWhiteListed().then(function(response) {               
			//     if (response.isUserWhiteListed == true) {                    
			//        $state.go('menu.yonoCash');                    
			//     }else{
			// 		var comingsoonPopup = $ionicPopup.alert({
			//         template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
			//         + "Coming Soon" + '</div></div></div></div></div></div>',
			//         cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
			//         buttons: [
			//             {
			//                 text: 'OK',
			//                 type: 'button-positive',
			//                 onTap: function (e) {
			//                     comingsoonPopup.close();
			//                 }
			//             }
			//         ]
			//     });
			// 	}                
			// }, function(error) {
			// 	var comingsoonPopup = $ionicPopup.alert({
			//         template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
			//         + "Coming Soon" + '</div></div></div></div></div></div>',
			//         cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
			//         buttons: [
			//             {
			//                 text: 'OK',
			//                 type: 'button-positive',
			//                 onTap: function (e) {
			//                     comingsoonPopup.close();
			//                 }
			//             }
			//         ]
			//     });
			//      //utilityService.showErrorMessage(error.responseMessage);
			// });
		}

		homeScreenVM.showhide = function () {
			homeScreenVM.log_datainfo = true;
			homeScreenVM.log_image = false;
		}

		homeScreenVM.backToUser = function () {
			homeScreenVM.log_datainfo = false;
			homeScreenVM.log_image = true;
		}

		homeScreenVM.accountOverview = function () {
			$state.go('menu.accountOverviewMyBalance');
		}

		homeScreenVM.financialProducts = function () {
			$state.go('menu.financialProducts');
		}

		homeScreenVM.fundTransfer = function () {
			$state.go('menu.fundsTransferLanding');
		}

		homeScreenVM.chatBot = function () {
			homeScreenService.isRedirectionFromHomeScreen = true;
			//$state.go('menu.chatbot');
			$state.go('menu.chatbotlanding');
		}
		homeScreenVM.chatBotwhaticando = function () {
			homeScreenService.isRedirectionFromHomeScreen = true;
			//$state.go('menu.chatbot');
			$state.go('menu.chatbotwhatcanido');
		}

		homeScreenVM.book = function () {
			homeScreenService.ishamburgerMenuBookMain=false;
			$state.go('menu.bookings');
		}

		homeScreenVM.serviceRequest = function(){
				homeScreenService.isBackCheck = false;
				homeScreenService.ishamburgerMenuSR=false;
		    $state.go('menu.serviceRequest');
		}

      homeScreenVM.faq = function(){
		  	homeScreenService.isBackCheck = false;
					homeScreenService.isRedirectionFromHomeScreen = true;
          $state.go('menu.FAQ');
      }

		homeScreenVM.updateKYC = function () {
			updateKYCService.checkEligibilityKYC().then(function (data) {
				$state.go('menu.updateKYCProfilePassword');
			}, function (error) {
				if(error.responseMessage.indexOf('|') > -1){
					let errorMsg = error.responseMessage.split('|')
					if(errorMsg.length == 3){
						updateKYCService.showAlertPopup("alert", errorMsg[0], errorMsg[1],errorMsg[2], "", "OK", "", "", "");
					}else{
						updateKYCService.showAlertPopup("alert", errorMsg[0], errorMsg[1],"", "", "OK", "", "", "");
					}
				}else{
					updateKYCService.showAlertPopup("alert", error.responseMessage, "", "", "", "OK", "", "", "");
				}
			});
		}

      homeScreenVM.bookTrain = function(){
				irctcService.searchTrainObj = "";
				irctcService.myList = "";
				irctcService.masterData = "";
				irctcService.selectedTrainData = "";
				irctcService.myListFullData = "";

				homeScreenService.ishamburgerMenuIRCTC=false;
				$state.go('menu.irctcBookTicketSearch');
      }

      homeScreenVM.locateNearestBranch = function () {
		  homeScreenService.isBackCheck = false;
          utilityService.showSpinner();
          $timeout(function () {
              currentLocationService.getCurrentPosition().then(
                  function (position) {
                      var latitude = position.coords.latitude;
                      var longitude = position.coords.longitude;
                      aoService.locateByGPS.length = 0;
                      var params = {
                          "latitude": latitude,
                          "longitude": longitude,
                          "branchLocator": "true"
                      }
                      if (utilityService.isUndefined(aoService.locateByGPS) ||
                          aoService.locateByGPS.length === 0) {
                          locateNearestBranchService.getBranchesForGeo(params).then(function (data) {
                              utilityService.hideSpinner();
                              if (!utilityService.isUndefined(data)) {
                                  for (var i = 0; i < data.branches.length; i++) {
                                      aoService.locateByGPS.push(data.branches[i]);
                                  }
                                  if (aoService.locateByGPS.length == 0) {
                                      var title = '';
                                      var template = 'No Branch is available within 5 km from your location';
                                      var onTap = '';
                                      var buttontext = 'OK';
                                      utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                                  } else {
																			homeScreenService.isRedirectionFromHomeScreen = true;
                                      $state.go('menu.locateNearestBranchByGPS');
                                  }
                              }
                          }, function (error) {
                              utilityService.hideSpinner();
                              utilityService.showErrorMessage(error.responseMessage);
                          });
                      } else {
                          utilityService.hideSpinner();
                      }
                  },
                  function (err) {
                      utilityService.hideSpinner();
                      var title = '';
                      var template = '{{"ON_GPS" | translate}}';
                      var onTap = '';
                      var buttontext = '<b>OK</b>';
                      utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
                  });
          }, 2000);
      };

		homeScreenVM.showpopup = function () {
			this.option = "sup";
			var alertPopup = $ionicPopup.alert({
				template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Coming Soon</p>"
			});
		};

        //Accounts redirection
        homeScreenVM.goToAccounts = function() {
					homeScreenService.ishamburgerMenuRO=false;
          homeScreenService.isAccountsFlag=true;
          getAccountDetailsService.tabIndex.tabIndex=0;
          $state.go('menu.accountOverviewMyBalance');
        };
        //Card redirection
        homeScreenVM.goToCreditCardPay = function() {
					homeScreenService.ishamburgerMenuRO=false;
          fTBeneficiaryService.isCreditCardFlag=true;
		  getAccountDetailsService.setRewTab = true;
          getAccountDetailsService.tabIndex.tabIndex=5;
          $state.go('menu.accountOverviewMyBalance');
        };
        //Insurance redirection
        homeScreenVM.goToInsurance = function() {
					homeScreenService.ishamburgerMenuRO=false;
          homeScreenService.isInsuranceFlag = true;
          getAccountDetailsService.tabIndex.tabIndex=4;
          $state.go('menu.accountOverviewMyBalance');
        };
        //Investment redirection
        homeScreenVM.goToInvestments = function() {
					homeScreenService.ishamburgerMenuRO=false;
         homeScreenService.isInvestmentFlag = true;
            getAccountDetailsService.tabIndex.tabIndex=3;
            $state.go('menu.accountOverviewMyBalance');
        }
        //Deposits redirection
        homeScreenVM.goToDeposits = function(){
						homeScreenService.ishamburgerMenuRO=false;
            homeScreenService.isDepositsFlag = true;
             getAccountDetailsService.tabIndex.tabIndex=1;
             $state.go('menu.accountOverviewMyBalance');
        }
        //Loans Redirection
        homeScreenVM.goToLoans = function(){
						homeScreenService.ishamburgerMenuRO=false;
            homeScreenService.isLoansFlag = true;
            getAccountDetailsService.tabIndex.tabIndex=2;
            $state.go('menu.accountOverviewMyBalance');
        }

		//Banner Redirection FOROMP2.0
		homeScreenVM.goToBanner = function (store, BannerIndex) {
			// revised redirection rule logic
			BannerIndex = BannerIndex + 1;
		if (store.redirectionType == "MERCHANT") {
			clickStreamService.clickStreamData = "websiteId," + store.affiliateId +",index," + BannerIndex;
			homeScreenVM.selectedMerchantAffiliateId = store.affiliateId;
			homeScreenService.getMerchantDetailsByAffId({ "affiliateId": homeScreenVM.selectedMerchantAffiliateId, "merchantKey": cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + homeScreenVM.selectedMerchantAffiliateId).toString() }).then(function (data) {
				$scope.merchantDetails = data[0];
				ompMerchantsService.listName = data[0];
				ompMerchantsService.listName.pageId = $state.current.data.pageId;
				isWebviewLoadingCanceled = false;
                ompMerchantsService.psudoIdEnble = data[0].psudoIdEnble;
				if ((data[0].coupons || data[0].offerPoints) && (data[0].coupons.length > 0 || data[0].offerPoints.length > 0)) {
					$state.go('menu.redirectionDiscliamer');
				} else {
					homeScreenVM.dynamicDisclaimer = decodeURIComponent(data[0].disclaimerContent).replace(new RegExp("\\+", "g"), ' ');
					homeScreenVM.ompdisclaimer(data[0]);
				}
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		} else if (store.redirectionType == "CATEGORY") {
			// redirection based on categoryCode
			clickStreamService.clickStreamData = "websiteId," + store.categoryCode +",index," + BannerIndex;
			homeScreenService.storeSelected = store.title;
			homeScreenService.categoryCode = store.categoryCode;
			$state.go('menu.merchantList');
		} else {
			clickStreamService.clickStreamData = "websiteId," + store.categoryCode +",index," + BannerIndex;
			if (store.categoryCode == 'IRCTC') {
				irctcService.searchTrainObj = "";
				irctcService.myList = "";
				irctcService.masterData = "";
				irctcService.selectedTrainData = "";
				irctcService.myListFullData = "";
				irctcService.infantArray = [];
				irctcService.passArray = [];
				$state.go(store.redirectionURL);
			} else if (store.categoryCode.toLowerCase() == 'mandi') {
				agriMandiService.source = "mandi"
				homeScreenVM.mitraMandiRedirection(store.redirectionURL);
			} else if (store.categoryCode.toLowerCase() == 'mitra') {
				agriMandiService.source = "mitra"
				homeScreenVM.mitraMandiRedirection(store.redirectionURL);
			} else {
				$state.go(store.redirectionURL);
			}
		}
	}

	homeScreenVM.ompdisclaimer = function (data) {
		homeScreenVM.merchantsList = data
		homeScreenVM.bannerPopup = $ionicPopup.show({
			title: '',
			cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head  popupBackgroundDark',
			templateUrl: "pages/homeScreen/bannerDisclaimerPopup.html",
			scope: $scope
		});
	}

	homeScreenVM.bannerPopupCancel = function () {
		clickStreamService.clickStreamData = "websiteId," + homeScreenVM.merchantsList.affiliateId;
		homeScreenVM.bannerPopup.close();
	}

	homeScreenVM.bannerPopupAgree = function () {
		homeScreenVM.bannerPopup.close();
				 
		if (homeScreenVM.merchantsList.merchantType === 'Redirection') {
			clickStreamService.clickStreamData = "websiteId," + homeScreenVM.merchantsList.affiliateId;

			homeScreenVM.loadPopup = $ionicPopup.show({
				title: '',
				cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundTransparent removePopup-head textAlignCenter popupBackgroundDark',
				templateUrl: "pages/homeScreen/bannerLoadPopup.html",
				scope: $scope
			})

			var mobileRedirectKey='';
				mobileRedirectKey= cryptoService.getSHA512EncryptedData(loggedInUserService.tokenLotus + homeScreenVM.merchantsList.mobileRedirectUrl).toString();
			var saveLeadObj = {
				"leadId": "",
				"websiteId": homeScreenVM.merchantsList.websiteId,
				"affiliateId": homeScreenVM.merchantsList.affiliateId,
				"request": {
					"ompCcustToken": "",
					"loggedIn": "",
					"channel": "",
					"segId": "",
					"ompTokenId": "",
					"merchantSku": "",
					"prdPrice": "",
					"wishlistSkus": "",
					"ompDisValue": "",
					"ompDisPct": "",
					"ompDisType": "",
					"isLoggedIn": mPinLoginService.isLoggedIn
				},
				"leadParam": homeScreenVM.merchantsList.leadParam,
				"segmentParam": homeScreenVM.merchantsList.segmentParam,
				"affiliateIdParam": homeScreenVM.merchantsList.affiliateIdParam,
				"mobileRedirectUrl" : homeScreenVM.merchantsList.mobileRedirectUrl,
				"mobileRedirectKey" : mobileRedirectKey,
				"shopNOrder": "",
                "psudoIdEnble": ompMerchantsService.psudoIdEnble
			}

			ompMerchantsService.saveLead(saveLeadObj).then(function (response) {
				const hRespCheck = response.data.resourceParameter;
				if (hRespCheck == undefined || hRespCheck == null || hRespCheck == "" || hRespCheck == cryptoService.getSHA512EncryptedData(response.data.mobileUrl).toString()) {
				homeScreenVM.saveLeadData = response;
				homeScreenVM.loadPopup.close();
				if (isWebviewLoadingCanceled == true) {
					return "";
				}
				isWebviewLoadingCanceled = true;
					if (mPinLoginService.isLoggedIn) {
						if (homeScreenVM.merchantsList.merchantCode == "ubr") {
							if (utilityService.isAndroidPlatform()) {
								appAvailability.check('com.ubercab',
									function () {
										var url = response.data.mobileUrl;        
										ompMerchantsService.inChromeBrowser(url);
									},
									function () {
										var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
										ompMerchantsService.inChromeBrowser(url);
									});
							} else {
								appAvailability.check('uber://', function () {
									var url = response.data.mobileUrl;
									ompMerchantsService.inChromeBrowser(url);
								}, function () {
									var url = "https://m.uber.com/sign-up?client_id=<CLIENT_ID>";
									ompMerchantsService.inChromeBrowser(url);
								});
							}
							return true;
						}
					   else if (homeScreenVM.merchantsList.browserType === 'inApp') {
						ompMerchantsService.inAppBrowser(response.data.mobileUrl,$scope.merchantDetails);
						} else if (homeScreenVM.merchantsList.browserType === 'default') {
							ompMerchantsService.inChromeBrowser(response.data.mobileUrl);
						} else if (homeScreenVM.merchantsList.browserType === 'chrome_tab') {
							ompMerchantsService.inChromeTabBrowser(response.data.mobileUrl);
						}
					}
				    } else {
						homeScreenVM.loadPopup.close();
						utilityService.showErrorMessage("Invalid request");
					}
				   
			}, function (error) {
				homeScreenVM.loadPopup.close();
				utilityService.showErrorMessage(error.responseMessage);
			});
		} 
	}


	homeScreenVM.tapCancel = function () {
		homeScreenVM.loadPopup.close();
		isWebviewLoadingCanceled = true;
		$state.go('menu.homeScreen');
	}

			homeScreenVM.omp = function () {
				clickStreamService.clickStreamData = "websiteId,";
				homeScreenService.ishamburgerMenuomp=false;
			if ($rootScope.showInProgress) {
				homeScreenVM.showpopup();
			} else {
				$state.go('menu.ompMerchants');
			}
		}

		homeScreenVM.goToBestOffers= function (title,categoryCode) {
			homeScreenService.categoryCode=categoryCode;
			homeScreenService.storeSelected=title;
			clickStreamService.clickStreamData = "websiteId," + categoryCode;
			$state.go('menu.merchantList');
		}
			
		homeScreenVM.goToMobility = function(){
			mobilityLandingService.getMobilityData().then(function(data) {
				mobilityLandingService.setBannersData(data);
                $state.go('menu.mobilityLanding');
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
		}

		homeScreenVM.createInsta = function() {
            instaHomeService.getFetchData().then(function(data) {
                instaHomeService.initialValueInsta();
                if (data) {
					instaHomeService.customer.accountno = data.loanAccountNumber;
					instaHomeService.customer.bestofferamount = data.maxLoanAmount;
					instaHomeService.customer.selectedamount = data.maxLoanAmount;
					instaHomeService.customer.interestrate = data.interestRate;
					instaHomeService.customer.loanduration = data.duration;
					instaHomeService.customer.processingfees = data.processingFees;
					instaHomeService.customer.creditToAccount = data.disbursementAccountNumber;
					instaHomeService.customer.mclr = data.mclr;
					instaHomeService.customer.nightMode = data.nightMode;
					instaHomeService.customer.reviewProcessingFee = data.reviewProcessingFee;
					instaHomeService.customer.minLoanAmount = data.minLoanAmount;
                    instaHomeService.customer.steppingAmount = data.steppingAmount;
					instaHomeService.customer.customerName = data.customerName;
                }
                $state.go('menu.instaCreate');
            }, function (error) {
            	if(error.responseCode == '0002')
				{
					var instaAlreadyApplied = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div style="text-align:center"><img class="approvedIconPosition" src="img/errorImage.png"></div><div class="button_fund fontSize-subHeading roboto-light font-dark-grey">'+error.responseMessage+'</div>',
					buttons: [{
						text: 'OK',
						type: 'button-assertive'
					}]
				});
				}
				else{
					utilityService.showErrorMessage(error.responseMessage);
				}

            });

        };

		homeScreenVM.navigateEmiAlerts = function (offerData) {
			//Customer info service called
			if(!customerInfoService.customer.mobile) {
                    homeScreenService.getCustomerInfo().then(function (data) {
                        getAccountDetailsService.accountOverviewData = data;
                        customerInfoService.customer.name = data.customerInformation.customerName;
                        customerInfoService.customer.type = data.customerInformation.customerType;
                        customerInfoService.customer.DOB = data.customerInformation.dob;
                        customerInfoService.customer.isPanAvailable = data.customerInformation.panNumber;
                        customerInfoService.customer.isStaffFlag = data.customerInformation.isStaffFlag;
                        customerInfoService.customer.emailID = data.customerInformation.emailID;
                        customerInfoService.customer.mobile = data.customerInformation.mobile;
                        customerInfoService.customer.title = data.customerInformation.title;
                        customerInfoService.customer.residentialStatus = data.customerInformation.residentialStatus;
                    },
                    function (error) {

					});
                }
			offerData.category = offerData.category.toUpperCase();
			switch (offerData.category) {
				case 'LI':
					generalInsurenceHomeService.setGIProductsID(offerData.category);
					$state.go('menu.sbiLifeIntro');
					break;
				case 'DEMAT':
					openAccountService.setStatusOfOpenAccount(0);
					$state.go('menu.openSecurityAccount');
					break;
				case 'CC':
					cardsService.setParams({
						"cardName": offerData.name
					});
					$state.go('menu.cardIntroduction');
					break;
				case 'PAPL':
					homeScreenVM.openPal(offerData.category);
					break;
				case 'KAVACH':
					homeScreenVM.openPal(offerData.category);
					break;
				case 'OMP':
					$state.go(offerData.stateGo);
					break;
				case 'LI-RENEWAL':
					//generalInsurenceHomeService.setGIProductsID(offerData.category);
					$state.go('menu.newRenewalHome');
					break;
				case 'GI':
					generalInsurenceHomeService.setGIProductsID(offerData.category);
					$state.go('menu.declaimer');
					break;
				case 'SS':
					// sampoornSurakshaService.getPremiumAndNomineeInfo().then(function(data) {
					// 	sampoornSurakshaService.setPremiumDetails(data);
					// 	$state.go('menu.ssPremiumCalculation');
					// }, function(error) {
					// 	utilityService.showErrorMessage(error.responseMessage);
					// });
					break;
				case 'MF':
					$state.go('menu.mutualFunds');
					break;//Here MF developer need to confirm redirection
				case 'IHL':
					homeScreenVM.createInsta();
					break;//Here MF developer need to confirm redirection
				case 'WEALTH':
					homeScreenVM.eligibleWealth();
					break;//Here MF developer need to confirm redirection
				case 'SAFAL-CROP':
					safalService.setSAFALData(offerData);
					homeScreenVM.goToSAFAL();				
					break;
				case 'SAFAL-DAIRY':
					safalService.setSAFALData(offerData);
					homeScreenVM.goToSAFAL();				
					break;
				case 'PACL':
					paclService.setPACLData(offerData);
					$state.go('menu.paclReqDetails');
					break;
				case 'PA2WL':
					homeScreenVM.goToPATWL();
					patwlService.setOfferBannerData(offerData);
					break;
				case 'PABL':
					homeScreenVM.goToPABL();
					break;
				default:
			}
		}

		homeScreenVM.goToPABL = function() {
			pablService.getPABLBasicEligibility().then(function (response) {
				pablService.setEligibilityDetailsData(response);
				$state.go('menu.pablChoose');
			}, function (error) {
				if (error.errorType == "SO") {
					pablService.showAlertPopup("alert","Sorry!", error.responseMessage, "menu.homeScreen", "OK", "", "", "");
				}else if (error.errorType == "TA"){
					pablService.showAlertPopup("alert","Try Again!", error.responseMessage, "menu.homeScreen", "OK", "", "", "");
				}else if (error.errorType == "AA"){
					pablService.showAlertPopup("alert","Already Applied!", error.responseMessage, "menu.homeScreen", "OK", "", "", "");
				}else if (error.errorType == "TR"){
					pablService.showAlertPopup("alert","Transaction Rights", error.responseMessage, "menu.homeScreen", "OK", "", "", "");
				}else{
					pablService.showAlertPopup("error","", error.responseMessage, "menu.homeScreen", "OK", "", "", "");
				}				
			});
		}

		homeScreenVM.goToPATWL = function() {
			patwlService.getInitialEligibility().then(function (response) {
				if (response.eligibilityResult.toUpperCase() == 'Y') {					
					patwlService.setInitailEligibilityData(response);
					$state.go('menu.patwlLandingPage');
				}
			}, function (error) {
				if (error.responseCode == "IE01") {
					homeScreenService.isNotificationDataAvail = false;
					homeScreenVM.getnotificationOffer();
					patwlService.showAlertPopup("error", error.responseMessage, "", "menu.homeScreen", "OK", "", "", "");
				} else {
					utilityService.showErrorMessage(error.responseMessage);
				}
			});
		}

		homeScreenVM.goToSAFAL = function(offerData){
			safalService.setSAFALData(offerData);
			agriMandiService.isUserFromSettings = false;
             if (getAccountDetailsService.accountOverviewData) {
                 if (getAccountDetailsService.accountOverviewData.customerInformation.language) {
				     agriMandiService.selectLanguage = getAccountDetailsService.accountOverviewData.customerInformation.language.toLowerCase();			
			 		$state.go('menu.safalIntroduction');
                } else {
                    $state.go('menu.selectLanguage');
                }

            } else {
                agriMandiService.langError =true;
                $state.go('menu.selectLanguage');
            };
		}

      homeScreenVM.setAccountsAndHeaderLabel = function () {
          if(!homeScreenService.isCustCalled){
			homeScreenVM.MyBalanceText = true;
			homeScreenVM.MyBalanceAmount = 0;

          if(!getAccountDetailsService.accountOverviewData){
				homeScreenService.isCustCalled = true;
	          	getAccountDetailsService.getAccountDetails().then(function (data) {
	          	 homeScreenVM.displaySpinner = true;
	          	 homeScreenService.isCustCalled = false;
	              getAccountDetailsService.accountOverviewData = data;
	              homeScreenVM.displaySpinner = false;
	              homeScreenVM.headerList = getAccountDetailsService.accountOverviewData.headerList;
	              angular.forEach(homeScreenVM.headerList, function (value, key) {
	                  if (value.label == "My Balance") {
	                      homeScreenVM.MyBalanceAmount = value.accountBalance;
                homeScreenVM.MyBalanceAmountSplit =homeScreenVM.MyBalanceAmount.split('.');
	                  }
	              });
	           });
          }else{
          	homeScreenVM.headerList = getAccountDetailsService.accountOverviewData.headerList;
              angular.forEach(homeScreenVM.headerList, function (value, key) {
                  if (value.label == "My Balance") {
                      homeScreenVM.MyBalanceAmount = value.accountBalance;
              homeScreenVM.MyBalanceAmountSplit =homeScreenVM.MyBalanceAmount.split('.');
                  }
              });
          }
	  }
	  else {
		var balanceWaitPopUp = $ionicPopup.show({
			title: null,
			cssClass: 'my-custom-popup',
			template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="FETCH_BALANCE"></div>',
			buttons: [{
				text: 'OK',
				type: 'button-assertive'
			}]
		});
	  }
      }

			homeScreenVM.hide = function(){
			homeScreenVM.MyBalanceText = false;
		}


      homeScreenVM.newAccountPopUp = function(){
              var dateRangeInfoPopUp = $ionicPopup.show({
                  template: "<div class='ss-error-header font-reg'>Oops!</div>"+"</br><p>In view of recent Supreme Court judgement, this facility has been temporarily disabled. </br>Inconvenience is regretted. </br></br>Please visit a branch to open an account.</p>",
                  title: '',
                  cssClass: 'dialog custButtonPopup',
                  scope: $scope,
                  buttons: [{
                      text: 'OK',
                      type: 'button-positive'
                  }]
              });
      }

		homeScreenVM.goToMyRewards = function(){
				homeScreenService.ishamburgerMenuRO=false;
				homeScreenService.isMyRewardsFlag = true;
				getAccountDetailsService.setRewTab = true;
				getAccountDetailsService.tabIndex.tabIndex=7;
				$state.go('menu.accountOverviewMyBalance');
		}

		/*Home Screen API Optimization:UX2.0 */

		  $scope.slideChanged = function (index) {
			$scope.slideIndex = index;
		};
		homeScreenVM.next = function () {
            $ionicSlideBoxDelegate.next();
        };
        homeScreenVM.previous = function () {
            $ionicSlideBoxDelegate.previous();
        };

		$scope.$on('$ionicView.loaded', function () {
			homeScreenVM.getCustomerInfo();
			homeScreenVM.getnotificationOffer();
			// if (!homeScreenService.isPushEnabled) {
			// 	homeScreenVM.registerForPush();
			// }
			
		});

			$scope.$on('$ionicView.beforeEnter', function () {
			        if(loggedInUserService.isUserTour && !loggedInUserService.isFirstLogin)
				        $state.go("menu.userTour");
				homeScreenVM.getSearchJSONData();
				if(homeScreenService.grabOffers.length!=0) {
 					homeScreenVM.graboffers = homeScreenService.grabOffers;
				} else {
					homeScreenService.getRevisedOfferOptions().then(function (data) {
						homeScreenService.grabOffers = data;
						homeScreenVM.graboffers = homeScreenService.grabOffers;
						$ionicSlideBoxDelegate.update();
						$ionicSlideBoxDelegate.loop(true);
					}, function (err) {
						var offers = [{
							"bannerSubject": "Property",
							"categoryCode": "OMPBO90",
							"imageurl": "img/landingPage/Banner_1-100.jpg",
							"redirectionURL": "menu.ompMerchants"
						}, {
							"bannerSubject": "Fashion &amp; Lifestyle",
							"categoryCode": "OMPS20",
							"imageurl": "img/landingPage/Banner_2-100.jpg",
							"redirectionURL": "menu.ompMerchants"
						}, {
							"bannerSubject": "Automobiles",
							"categoryCode": "OMPS100",
							"imageurl": "img/landingPage/Banner_3-100.jpg",
							"redirectionURL": "menu.ompMerchants"
						}, {
							"bannerSubject": "Multi Category",
							"categoryCode": "OMPS10",
							"imageurl": "img/landingPage/Banner_4-100.jpg",
							"redirectionURL": "menu.ompMerchants"
						}, {
							"bannerSubject": "Flight &amp; Bus",
							"categoryCode": "OMPBO10",
							"imageurl": "img/landingPage/Banner_5-100.jpg",
							"redirectionURL": "menu.ompMerchants"
						},
						{
							"bannerSubject": "Hospitality &amp; Hotels",
							"categoryCode": "OMPBO20",
							"imageurl": "img/landingPage/Banner_6-100.jpg",
							"redirectionURL": "menu.ompMerchants"
						}];
						homeScreenVM.graboffers = offers;
						$ionicSlideBoxDelegate.update();
						$ionicSlideBoxDelegate.loop(true);
					});
				}
		setTimeout(function() {
				var data = localStorage.getItem('reraId');
				var pageRedirect = localStorage.getItem('isRedirectedTowdsLoan');
				if (data && pageRedirect === "false") {
					$state.go('menu.loans');
					localStorage.setItem('isRedirectedTowdsLoan', "");
				}
			}, 900);
		});


		function redirectToIrctc() {
			if (ompOffersService.irctcNotificationRecieved === true) {
				ompOffersService.irctcNotificationRecieved = false;
				if ("string" == typeof (irctcService.pushNotificationData)) {
					irctcService.pushNotificationData = JSON.parse(irctcService.pushNotificationData);
				}
				if (irctcService.pushNotificationData && irctcService.pushNotificationData.isTargeted) {
					irctcService.getStationMaster().then(function (data) {
							if (data.username) {
								irctcService.userLinkedStatus = true;
								irctcService.username = data.username;
							} else {
								irctcService.username = "Menu";
								irctcService.userLinkedStatus = false;
							}
					irctcService.selTab = "Y";
					$state.go('menu.bookingHistory');
						}, function (error) {
							utilityService.showErrorMessage(error.responseMessage);
					});
				} else {
					$state.go('menu.irctcBookTicketSearch');
				}
			}
		}

		$scope.$on('$ionicView.afterEnter', function () {
			homeScreenVM.MyBalanceText = false;
			initPage();
			setTimeout(function() {
				var data = localStorage.getItem('reraId');
				var pageRedirect = localStorage.getItem('isRedirectedTowdsLoan');
				var redirectOnly = localStorage.getItem('redirectOnlyFlow');
				if ((data && pageRedirect === "false") || redirectOnly === "true") {
					$state.go('menu.loans');
					localStorage.setItem('isRedirectedTowdsLoan', "");
					localStorage.setItem('redirectOnlyFlow', "");
				}
			}, 90);
			setTimeout(function() {  //Yono cash in case of prelogin
				if(homeScreenService.preLoginYonoCash){
					$state.go('menu.yonoCash');
					homeScreenService.preLoginYonoCash=false;
				}
			},700);
			
			setTimeout(function() {   //redirect to irctc after login
				if(homeScreenService.irctcCallAfterSuccLogin){
					homeScreenService.irctcCallAfterSuccLogin = false;
					irctcService.searchTrainObj = "";
					irctcService.myList = "";
					irctcService.masterData = "";
					irctcService.selectedTrainData = "";
					irctcService.myListFullData = "";
					irctcService.infantArray = [];
					irctcService.passArray = [];
					$state.go('menu.irctcBookTicketSearch');
				}
				if(homeScreenService.automobileCallAfterSuccLogin){
					homeScreenService.automobileCallAfterSuccLogin = false;
					$state.go('menu.automobileLanding');
				}
				if(homeScreenService.automallCallAfterSuccLogin){ //redirect to automall after login
					homeScreenService.automallCallAfterSuccLogin = false;
					automallService.getEmiMasterService().then(function (emiMaster) {
                        automallService.setMasterEmiData(emiMaster);
                        automallService.getAutomallBanners().then(function (banner) {
                            automallService.setLandingBanners(banner);
                            automallService.getOEMListService().then(function (oemList) {
                                automallService.setOemList(oemList);
                                $state.go('menu.automall');
                            }, function (error) {
                                utilityService.showErrorMessage(error.responseMessage);
                                })

                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }, function (error) {
                        utilityService.showErrorMessage(error.responseMessage);
                    });
				}
			},100);

		});

		$scope.$on('$ionicView.afterLeave', function () {
			if (!homeScreenService.isPushEnabled) {
				homeScreenVM.registerForPush();
			}
		});

		$scope.$on('$ionicView.beforeLeave', function () {
			homeScreenVM.isPageCurrent = false;
		});

		homeScreenVM.goToMyWearables = function () {
			homeScreenService.ishamburgerMenuRO = false;
			homeScreenService.isMyWearableFlag = true;
			getAccountDetailsService.setRewTab = true;
			getAccountDetailsService.tabIndex.tabIndex = 6;


			if (getAccountDetailsService.accountOverviewData.customerInformation && (getAccountDetailsService.accountOverviewData.customerInformation.residentialStatus && getAccountDetailsService.accountOverviewData.customerInformation.residentialStatus != "1")) {

				homeScreenVM.popUpNRI = $ionicPopup.show({
					title: '',
					cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
					templateUrl: 'pages/yonoWearable/landing/nriCheckPopup.html',
					scope: $scope
				});
			} else {
				homeScreenVM.checkWhiteListedUsers();

			}

		}

		homeScreenVM.checkWhiteListedUsers = function(){
			 wearableServices.isUserWhiteListed().then(function(response) {
					if (response.isUserWhiteListed == true) {
						$state.go('menu.accountOverviewMyBalance');
					}else{
			 		var comingsoonPopup = $ionicPopup.alert({
                     template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
                     + "Coming Soon" + '</div></div></div></div></div></div>',
                     cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
                     buttons: [
                         {
                             text: 'OK',
                             type: 'button-positive',
                             onTap: function (e) {
                                 comingsoonPopup.close();
                             }
                         }
                     ]
                 });
			 	}
                }, function(error) {

						utilityService.showErrorMessage(error.responseMessage);

                });

		}


		homeScreenVM.closeNRI = function () {
			homeScreenVM.popUpNRI.close();
		}




		return this;
	}
]);
