angularApp.service('homeScreenService',
	function ($q, AdapterUtils, mPinLoginService, ompMerchantsService,internetBankingService,utilityService) {
		var homeScreenService = this;
		var isCreditCardFlag=false;
		var isInsuranceFlag = false;
		var isInvestmentFlag = false;
		var isDepositsFlag = false;
		var isLoansFlag = false;
		var isAccountsFlag = false;
		var isMyRewardsFlag = false;
		homeScreenService.ishamMenu = false;
		homeScreenService.offersData = [];
		homeScreenService.alertsData = [];
		homeScreenService.isNotificationDataAvail = false;
		homeScreenService.isRedirectionFromHomeScreen = false;
		var storeflag=false;
		var bookflag=false;
	    var isCustCalled = false;
		homeScreenService.isProfilePicSet = false;
		homeScreenService.isCustomerInfoSaved = false;
		homeScreenService.grabOffers = [];
		homeScreenService.searchedList = [];
		homeScreenService.isAccessRightsAvail = false;
		homeScreenService.showDonationPopup = true;
		homeScreenService.showDonationPreLogin = false;
		homeScreenService.irctcCallAfterSuccLogin = false;
		homeScreenService.automallCallAfterSuccLogin = false;
		homeScreenService.automobileCallAfterSuccLogin = false;
	
		homeScreenService.getCustomerInfo = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/customerAndAccountInfo", {}, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		homeScreenService.getnotificationOffer = function () {			
            var payload = {
                "isPa2wlEligibleBuild": "Y"
            }
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/notificationOffer", payload, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		/** Function to fetch image from filenet**/
		homeScreenService.retrieveImage = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/MyDreamsAdapter/retrieveImage", reqParams, false).then(
				function (response) {
					q.resolve(response);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		homeScreenService.getBellNotificationCount = function () {
			return homeScreenService.offersData.length + homeScreenService.alertsData.length;
		}

				homeScreenService.getShop=function(){
					

				};
				homeScreenService.getBookAndOrder=function(){
					
				};

        //Revised redirection on homescreen Banner
		homeScreenService.getRevisedOfferOptions = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/getRevisedHomeBanner", {}, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		homeScreenService.getMerchantDetailsByAffId = function (param) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OMPAdapter/getMerchantByAffiliateId", param, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		//End - Revised redirection on homescreen Banner

		homeScreenService.getSearchFunctionalityData = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/getSearchJsonData", {}, false).then(
				function (response) {
					q.resolve(response.datas);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		homeScreenService.formPopUp = function(controllerName){
			var popUpContent = internetBankingService.banners.login[0];
			var template = '<div class="disclaimerMainDiv">' +
				'<div class="popupWhite notificationSubheadrePopupDisclaimer disclaimerPopupHome">' +
				'<div class="logoYSF">' +
				'<img ng-if="banners.imageBanner" src="'+popUpContent.imageBanner+'" alt="'+popUpContent.name+'" />' +
				'<img src="img/OMP/close.svg" class="banner-popup-close" click-stream="click" id="LOGIN_PAGE_BANNER_CLOSE" ng-click="'+controllerName+'.closeLoginBannerPopup(false)">'+
				popUpContent.content + '' +
				'</div>' +
				'<div class="exploreButton">' +
				'<button class="button-block popupButton disclaimerPopupButtonHomeScreen donation-bor-6" click-stream="click" id="LOGIN_PAGE_BANNER_CONTINUE" ng-click="'+controllerName+'.closeLoginBannerPopup(true)" >'+popUpContent.btnName+'</button>' +
				'</div></div></div>';
			return template;
		}

		return homeScreenService;
	});
