'use strict';
angularApp.controller('instaClosureController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"instaHomeService",
		"openUrlInAppbroswerService",
		"constantConfig",
		"getAccountDetailsService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, instaHomeService, openUrlInAppbroswerService,constantConfig,getAccountDetailsService) {
			
			var instaClosureVm = this;
			
			function initPage() {
				$scope.limit = 5;
				instaClosureVm.availod = true;
				instaClosureVm.closeDetails = [];
				instaHomeService.accountDetailsCloser = [];
				if(instaHomeService.viewInstaData.nightMode == "Y")
				{
					instaClosureVm.nightMode = true;
				}
				else{
					instaClosureVm.nightMode = false;
				}
				
				instaClosureVm.showDateDiv = true;
				instaClosureVm.indexId = 0;

				instaClosureVm.isMaskPan = true;

				var date = new Date();
				var years = [];
				years = instaHomeService.getLastFiveFinancialYear();
				instaClosureVm.yearDetails = years;

				instaClosureVm.fdNumber = instaHomeService.viewInstaData.productDescription;
				instaClosureVm.rdAccName = instaHomeService.viewInstaData.customerName;
				instaClosureVm.rdAccNumber = instaHomeService.viewInstaData.accountNumber;
				instaClosureVm.balAmount = parseInt(instaHomeService.viewInstaData.outstandingAmount) + "";
				instaClosureVm.remainingDurationVal = instaHomeService.viewInstaData.remainingDuration;
				instaClosureVm.interestRateVal = instaHomeService.viewInstaData.emiInterestrates;
				instaClosureVm.emiAmountVal = parseInt(instaHomeService.viewInstaData.emiAmount);
				instaClosureVm.limitVal = parseInt(instaHomeService.viewInstaData.limitAmount) + "";
				instaClosureVm.interestAppliedCurrentVal = parseInt(instaHomeService.viewInstaData.currentYearInterest);
				instaClosureVm.interestAppliedPreviousVal = instaHomeService.viewInstaData.previousYearInterest ?parseInt(instaHomeService.viewInstaData.previousYearInterest) : "0";
				instaClosureVm.currency = getAccountDetailsService.currency ;
			};

			instaClosureVm.goToAO = function () {
				$state.go('menu.accountOverviewMyBalance');
			}

			instaClosureVm.selectePeriodTrans = function () {
				var today = new Date();
				var today2 = new Date();
				
				var fromDateFormat = "";
				var fromDateFinal = "";
				var toDateFormat = "";
				var toDateFinal = "";
				
				if (instaClosureVm.selectPeriod != "") {
					if (instaClosureVm.selectPeriod && instaClosureVm.selectPeriod == "by_date") {
						instaClosureVm.showDateDiv = false;
					} else {
						instaClosureVm.showDateDiv = true;
					}

					if (instaClosureVm.selectPeriod == 1 || instaClosureVm.selectPeriod == 3 || instaClosureVm.selectPeriod == 6 || instaClosureVm.selectPeriod == 5) {
						if (instaClosureVm.selectPeriod == 1) {
							var date = today.setMonth(today.getMonth() - parseInt(instaClosureVm.selectPeriod));
							
							var fromDate = new Date(date).toISOString().slice(0,10);
							fromDateFormat = fromDate.toString().split('-');
							fromDateFinal = fromDateFormat[2] + fromDateFormat[1] + fromDateFormat[0]

							var toDate = new Date(today2).toISOString().slice(0,10);
							toDateFormat = toDate.toString().split('-');
							toDateFinal = toDateFormat[2] + toDateFormat[1] + toDateFormat[0]
						} else if (instaClosureVm.selectPeriod == 3) {
							var date = today.setMonth(today.getMonth() - parseInt(instaClosureVm.selectPeriod));
							var fromDate = new Date(date).toISOString().slice(0,10);
							fromDateFormat = fromDate.toString().split('-');
							fromDateFinal = fromDateFormat[2] + fromDateFormat[1] + fromDateFormat[0]

							var toDate = new Date(today2).toISOString().slice(0,10);
							toDateFormat = toDate.toString().split('-');
							toDateFinal = toDateFormat[2] + toDateFormat[1] + toDateFormat[0]
						} else if (instaClosureVm.selectPeriod == 6) {
							var date = today.setMonth(today.getMonth() - parseInt(instaClosureVm.selectPeriod));
							var fromDate = new Date(date).toISOString().slice(0,10);
							fromDateFormat = fromDate.toString().split('-');
							fromDateFinal = fromDateFormat[2] + fromDateFormat[1] + fromDateFormat[0]

							var toDate = new Date(today2).toISOString().slice(0,10);
							toDateFormat = toDate.toString().split('-');
							toDateFinal = toDateFormat[2] + toDateFormat[1] + toDateFormat[0]
						} else if (instaClosureVm.selectPeriod == 5) {
							var date = today.setMonth(today.getMonth() - parseInt(instaClosureVm.selectPeriod));
							var fromDate = new Date(date).toISOString().slice(0,10);
							fromDateFormat = fromDate.toString().split('-');
							//fromDateFinal = fromDateFormat[2] + fromDateFormat[1] + fromDateFormat[0]
							fromDateFinal = "";

							var toDate = new Date(today2).toISOString().slice(0,10);
							toDateFormat = toDate.toString().split('-');
							toDateFinal = toDateFormat[2] + toDateFormat[1] + toDateFormat[0]
						} 

						var obj = {
							"fromDate" : fromDateFinal,
							"toDate" : toDateFinal
						}
						instaClosureVm.transactionDetails(obj);
					}
				} else {
	                instaClosureVm.transDetails = instaHomeService.viewInstaData.transactionDetails
				}
				
			}

			instaClosureVm.openDatePickerFrom = function() {
                var date = new Date()
                var getCurrentYear = new Date().getFullYear();
                var setYear = date.setFullYear((getCurrentYear-3))
				instaClosureVm.dateObj = {
					callback: function (val) {
	                    // instaClosureVm.scheduleDate = val;
	                    var tomorrow = new Date(val);
		                tomorrow.setDate(tomorrow.getDate() + 1);
		                instaClosureVm.fromeDateVal = tomorrow;
	                    instaClosureVm.fromeDate = new Date(tomorrow).toISOString().slice(0,10);
					},
					inputDate: new Date(),
					from: setYear,
					to: new Date(),
					mondayFirst: true,
					closeOnSelect: false,
					templateType: 'popup',
					dateFormat: 'dd MMM yyyy'

				};

				ionicDatePicker.openDatePicker(instaClosureVm.dateObj);
			};
				function datediff(first, second) {
    // Take the difference between the dates and divide by milliseconds per day.
    // Round to nearest whole number to deal with DST.
    return Math.round((second-first)/(1000*60*60*24));
}
			instaClosureVm.openDatePickerTo = function() {
				var dateRange2 = new Date();
				dateRange2.setFullYear(dateRange2.getFullYear() - 3)
				instaClosureVm.dateObj = {
					callback: function (val) {
	                    // instaClosureVm.scheduleDate = val;
	                    var tomorrow = new Date(val);
		                tomorrow.setDate(tomorrow.getDate() + 1);
		                if(datediff(tomorrow - instaClosureVm.fromeDateVal) >= 365)
		                {
		                	utilityService.showErrorMessage('Please select date range between 1 year only.');
		                }
		                else{
		                	instaClosureVm.toDate = new Date(tomorrow).toISOString().slice(0,10);
	                    
						
							if (instaClosureVm.fromeDate && instaClosureVm.toDate) {
								var fromDate = instaClosureVm.fromeDate;
								var fromDateFormat = fromDate.toString().split('-');
								var fromDateFinal = fromDateFormat[2] + fromDateFormat[1] + fromDateFormat[0];
								
								var toDate = instaClosureVm.toDate;
								var toDateFormat = toDate.toString().split('-');
								var toDateFinal = toDateFormat[2] + toDateFormat[1] + toDateFormat[0]
								var obj = {
									"fromDate" : fromDateFinal,
									"toDate" : toDateFinal
								}
								
								instaClosureVm.transactionDetails(obj);
							}
		                }
	                    
					},
					inputDate: new Date(),
					to: new Date(),
					from: dateRange2,
					mondayFirst: true,
					closeOnSelect: false,
					templateType: 'popup',
					dateFormat: 'dd MMM yyyy'

				};

				ionicDatePicker.openDatePicker(instaClosureVm.dateObj);
			};

			instaClosureVm.closeBetweenDate = function () {
				instaClosureVm.showDateDiv = true;
				instaClosureVm.selectPeriod = "";
			}

			instaClosureVm.unmaskData = function(idType) {
	            var request = {
	                "type": idType,
	                "keyType": "instaViewAccountNumber",
	                "loanType": "IHL"
	            }
	            if (idType == 'accountno') {
	                instaHomeService.getUnmaskData(request).then(function(data) {
	                    if (idType == 'accountno') {
	                        instaClosureVm.isMaskPan = false;
	                        instaClosureVm.rdAccNumber = data;
	                    }
	                }, function(error) {
	                    utilityService.showErrorMessage(error.responseMessage);
	                });
	            } else {
	                if (idType == 'naccountno') {
	                    instaClosureVm.isMaskPan = true;
	                    instaClosureVm.rdAccNumber = instaHomeService.viewInstaData.accountNumber;
	                }
	            }
	        }

			instaClosureVm.interestAppliedPreviousFunc = function () {
				var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">The amount of Interest charged in the last financial year.</div></div>';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.instaClosure');
						}
					}],
				});
			}

			instaClosureVm.interestAppliedCurrentFunc = function () {
				var template =  '<div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter">Total Interest debited for the  "Tax year", to date.</div></div>';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.instaClosure');
						}
					}],
				});
			}

			instaClosureVm.Closure = function () {

				if(!instaClosureVm.nightMode)
				{

				var template = 'Are you sure you want to close your Insta Home Loan '+instaHomeService.viewInstaData.accountNumber+'?';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'Cancel',
						type: 'button-assertive',
						onTap: function () {
							$state.go('menu.instaClosure');
						}
					},{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							var account_number = instaHomeService.viewInstaData.accountNumber;
							
							instaHomeService.prematureClosureInsta(account_number).then(function(data) {
								
						 		instaHomeService.viewInstaData.totalClosureAmount = data.currentBalance;
						 		instaHomeService.viewInstaData.interestAccrued = data.intrestAccrued;
						 		instaHomeService.viewInstaData.totalOutstandingAmount = data.netClosureAmount;
						 		instaHomeService.viewInstaData.status = data.status;
								$state.go('menu.instaClosureEnquiry');
							},function(error) {
								utilityService.showErrorMessage(error.responseMessage);
							});
						}
					}],
				});
			}
			else{
				var template = '<div translate="NIGHTMODEMSG"></div>';
				$ionicPopup.show({
					title: '',
					template: template,
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							
						}
					}],
				});
			}
			}

			instaClosureVm.getDownloadYear = function (value) {
				
				instaClosureVm.yearRangeValue = value;
				instaClosureVm.selected = value;
			}

			function b64toBlob(b64Data, contentType, sliceSize) {
				contentType = contentType || '';
				sliceSize = sliceSize || 512;

				var byteCharacters = atob(b64Data);
				var byteArrays = [];

				for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
					var slice = byteCharacters.slice(offset, offset + sliceSize);

					var byteNumbers = [];
					for (var i = 0; i < slice.length; i++) {
						byteNumbers[i] = slice.charCodeAt(i);
					}

					var byteArray = new Uint8Array(byteNumbers);

					byteArrays.push(byteArray);
				}

				var blob = new Blob(byteArrays, { type: contentType });
				return blob;
			}

			function savebase64AsPDF(folderpath, filename, content, contentType) {
				var contentStr = atob(content);
                        var contentLen = contentStr.length;
                        if (contentLen >= constantConfig.accOverview.pdfSize) {
                           
                            utilityService.showErrorMessage(constantConfig.accOverview.sizeLimitMessage);
                            return;
                        }
				// Convert the base64 string in a Blob
				var DataBlob = b64toBlob(content, contentType);
				filename = filename + ".pdf";
				window.resolveLocalFileSystemURL(folderpath, function (dir) {
					dir.getFile(filename, { create: true }, function (file) {
						file.createWriter(function (fileWriter) {
							fileWriter.write(DataBlob);
						}, function (error) {

						});
					});
				});
			}

			instaClosureVm.downloadStatements = function () {
				$ionicPopup.show({
					title: '',
					templateUrl: 'pages/insta/instaClosure/instaDownloadYearPopup.html',
					scope: $scope,
					cssClass: 'my-custom-popup',
					buttons: [{
						text: 'OK',
						type: 'button-assertive',
						onTap: function () {
							
							var date_selected = instaClosureVm.yearRangeValue.split("-");
							var from_date_year = date_selected[0];
							var to_date_year = date_selected[1];
							var fromDateFinal = "01-04-" + from_date_year;
							var toDateFinal = "31-03-" + to_date_year;
							var obj = {
								"fromDate" : fromDateFinal,
								"toDate" : toDateFinal,
								"accountType" : instaHomeService.viewInstaData.accountType,
								"branchName" : instaHomeService.viewInstaData.branchName
							}
							instaHomeService.instaDownloadReceipt(obj).then(function (data) {
								if(data==null){
									utilityService.showErrorMessage('No data available in the selected period');
								}
								else{
									var content = data.pdf;
								var filename = data.fileName + '.pdf';
								var contentType = "application/pdf";
								if (utilityService.isAndroidPlatform()) {
									instaClosureVm.folderpath = cordova.file.externalRootDirectory;
								}
								if (utilityService.isIOSPlatform()) {
									instaClosureVm.folderpath = cordova.file.documentsDirectory;
								}
								savebase64AsPDF(instaClosureVm.folderpath, filename, content, contentType);
								if (utilityService.isIOSPlatform()) {
									filename = filename + ".pdf";
									var finalObject = { "folderpath": instaClosureVm.folderpath, "filename": filename };
									openUrlInAppbroswerService.openUrl("data:application/pdf;base64," + content + "","");
									//$state.go('menu.instaClosure');
								}
								if (utilityService.isAndroidPlatform()) {
									var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPTINSTA"></div>';
									instaClosureVm.downloadPopup = $ionicPopup.show({
										title: '',
										template: template,
										scope: $scope,
										cssClass: 'my-custom-popup',
										buttons: [{
											text: 'OK',
											type: 'button-assertive',
											onTap: function () {
												$state.go('menu.instaClosure');
											}
										}],
									});
								}
								}
								
								
							}, function (error) {
								utilityService.showErrorMessage(error.responseMessage);
							});
						}
					}],
				});
			}

			instaClosureVm.receiptEmail = function () {
				var obj = {
					"isEmail" : true
				}
				instaHomeService.instaDownloadReceipt().then(function (data) {
					var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="">Mail has been sent to your registered email id.</div>';
					$ionicPopup.show({
						title: '',
						template: template,
						cssClass: 'my-custom-popup',
						buttons: [{
							text:'OK',
							type: 'button-assertive',
							onTap: function() { 
							}
						}],
					});
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			instaClosureVm.transactionDetails = function(obj) {	
				
				// var account_number = '30002625938'
				instaHomeService.instaTransactionDetails(obj).then(function(data) {
					instaClosureVm.transDetails = data;
					instaHomeService.viewInstaData.transactionDetails = instaClosureVm.transDetails;
				},function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}

			instaClosureVm.viewMore = function(obj) {
			if(instaHomeService.viewInstaData.transactionDetails.length > 5)	
				$scope.limit = instaHomeService.viewInstaData.transactionDetails.length;
			}

			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				// instaClosureVm.transactionDetails();
			});

			return this;
		}
]);


