angularApp.service('instaHomeService',
	function ($q, utilityService, AdapterUtils, customerInfoService, fixedDepositService, $ionicPopup) {
		var InstaHomeService = this;

		InstaHomeService.accountDetails = [];
		InstaHomeService.accountDetailsCloser = [];
		InstaHomeService.normalFDTnC = "";
		InstaHomeService.normalClosureTnC = "";
		InstaHomeService.isInstaAvail = false;
		InstaHomeService.selectedDetails = {
			accountType: '',
			accountNumber: '',
			accountBalance: '',
			isActive: '',
			isTransactional: '',
			branchCode: '',
			branchName: '',
			intCategory: '',
			accountTypeCode: ''
		};

		InstaHomeService.viewInstaData = {
			productDescription: '',
			customerName: '',
			accountNumber: '',
			outstandingAmount: '',
			remainingDuration: '',
			emiAmount: '',
			emiInterestrates: '',
			limitAmount: '',
			currentYearInterest: '',
			previousYearInterest: '',
			currency: '',
			closureFlag: '',
			interestAccrued: '',
			totalClosureAmount: '',
			totalOutstandingAmount: '',
			payingFromAccount: '',
			accountOpeningDate: '',
			rateOfInterest: '',
			accountTypeCode: '',
			displayAccountFormat: '',
			transactionDetails: [],
			status: '',
			nightMode: '',
			branchName: '',
			accountType: ''
		};

		InstaHomeService.customer = {
			bestofferamount: '',
			selectedamount: '',
			loanduration: '',
			emiamount: '',
			interestrate: '',
			emipaymentday: '',
			fullemipaymentday: '',
			accountno: '',
			processingfees: '',
			reviewProcessingFee: '',
			otpClick: '',
			isSenior: false,
			isPanAvailable: '',
			indexId: 0,
			checkNominee: false,
			nightMode: '',
			creditToAccount : '',
			mclr: '',
			nightMode : ''
		};

		InstaHomeService.initialCloseValueStage = function() {
			InstaHomeService.viewInstaData = {
				productDescription: '',
				customerName: '',
				accountNumber: '',
				accountSelectedDetails: '',
				outstandingAmount: '',
				remainingDuration: '',
				emiAmount: '',
				emiInterestrates: '',
				limitAmount: '',
				currentYearInterest: '',
				previousYearInterest: '',
				currency: '',
				closureFlag: '',
				interestAccrued: '',
				totalClosureAmount: '',
				totalOutstandingAmount: '',
				payingFromAccount: '',
				accountOpeningDate: '',
				rateOfInterest: '',
				accountTypeCode: '',
				displayAccountFormat: '',
				displayAccountNumberFormat: '',
				accountBalance: '',
				transactionDetails: [],
				status: '',
				nightMode: '',
				branchName: '',
				accountType: ''
			};
			InstaHomeService.customer = {
				bestofferamount: '',
				selectedamount: '',
				loanduration: '',
				emiamount: '',
				interestrate: '',
				emipaymentday: '',
				fullemipaymentday: '',
				accountno: '',
				processingfees: '',
				reviewProcessingFee: '',
				otpClick: '',
				isSenior: false,
				isPanAvailable: '',
				indexId: 0,
				checkNominee: false,
				nightMode: '',
				creditToAccount : '',
				mclr: '',
				nightMode : ''
			};
		}

		// getting data of full rd
		InstaHomeService.initialValueInsta = function() {
			InstaHomeService.customer = {
				bestofferamount: '',
				selectedamount: '',
				loanduration: '',
				emiamount: '',
				interestrate: '',
				emipaymentday: '',
				fullemipaymentday: '',
				accountno: '',
				processingfees: '',
				reviewProcessingFee: '',
				otpClick: '',
				isSenior: false,
				isPanAvailable: '',
				indexId: 0,
				checkNominee: false,
				nightMode: '',
				creditToAccount : '',
				mclr: '',
				nightMode : ''
			};
			InstaHomeService.selectedDetails = {
				accountType: '',
				accountNumber: '',
				accountBalance: '',
				isActive: '',
				isTransactional: '',
				branchCode: '',
				branchName: '',
				intCategory: '',
				accountTypeCode: ''
			};
		}

		// getting data for first screen createrd
		InstaHomeService.getcheckAccessRights = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/RecurringDepositAdapter/accountFilterRequest",{},true).then(
			// AdapterUtils.postData("adapters/ServiceRequestAdapter/accountFilterRequest",{},true).then(
				function(response){	

					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		InstaHomeService.instaEmailReceipt = function () {
			var q = $q.defer();
			AdapterUtils.getData("adapters/PreApprovedLoanAdapter/instaEmailReceipt",{}, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		InstaHomeService.instaTransactionDetails = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/instaTransactionDetails",obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		InstaHomeService.getUnmaskData = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getInstaUnmaskData",obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		InstaHomeService.instaDownloadReceipt = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/instaDownloadReceipt",obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		
		InstaHomeService.fetchRtermcondition = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getTnC", obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		InstaHomeService.getFetchData = function() {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/fetchData",{},true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				});
			return q.promise;
		};

		InstaHomeService.viewInstaHomeLoan = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/viewInstaLoanAccount",obj,true).then(
				function(response){	
					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		InstaHomeService.prematureClosureInsta = function (acc_number) {
			var q = $q.defer();
			var obj = {
				"accountNumber": acc_number
			};
			
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/preClosureInstaLoanAccount", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		InstaHomeService.requestOtp = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure",obj, true).then(
				function(response){	

					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};


		InstaHomeService.validateOtp = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/validateOTPSecure",obj, true).then(
				function(response){	

					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		InstaHomeService.createInstaHomeLoan = function(obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/instaFinalConditionalCreate",obj,true).then(
				function(response){	

					q.resolve(response.data);
				},
				function(error){	
					q.reject(error);
				}
				); 
			return q.promise;
		};

		InstaHomeService.instaPrematureClosure = function (acc_number) {
			var q = $q.defer();
			var obj = {
				"accountNumber": acc_number
			};
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/preClosure", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		InstaHomeService.sendInstaClosure = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/closureInstaLoanAccount", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		InstaHomeService.getAccountList = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/instaClosureAccountFilter", obj, true).then(
				function (response) {
					q.resolve(response.data);
				}, function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		InstaHomeService.getAccountDetails =function() {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/HomeAdapter/customerAndAccountInfo", true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				 }
				); 
			return q.promise;
		};
		InstaHomeService.showAlertModal = function (title, template, onTapgo, $scope, $state) {
			var alertPopup = $ionicPopup.show({
				title: title,
				template: template,
				scope: $scope,
				cssClass: 'my-custom-popup',
				buttons: [{
					text: 'OK',
					type: 'button-assertive',
					onTap: function () {
						if (onTapgo !== '' && onTapgo !== null) {
							$state.go(onTapgo);
						}
					}
				}],
			});
		}

		InstaHomeService.showTnCAlertModal = function (heading,message,buttonText,callBack) {
			var alertPopup = $ionicPopup.alert({
            title: heading,
            template: '<div class="popupTextBottomPadding ss-p-r-f-8 ss-popup-list font-size-12 font-light ss-text-color">'
            + message + '</div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
            buttons: [
					{
						text: buttonText,
						onTap: function(e) {
							callBack();
						}
					}
				],
        	});
		}

		InstaHomeService.getLastFiveFinancialYear = function() {
			  var fiscalyear = [];
			  var today = new Date();
			  for (var i=0; i<5; i++) {
			  if ((today.getMonth() + 1) <= 3) {
			    fiscalyear[i] = (today.getFullYear() - i - 1) + "-" + (today.getFullYear() - i)
			  } else {
			    fiscalyear[i] = (today.getFullYear() - i) + "-" + (today.getFullYear() + 1 - i)
			  }
			}
			  return fiscalyear
		}

		return InstaHomeService;
	});  