'use strict';

angularApp.controller('instaAadhaarValidationController', ["$state",
    "$scope",
    "instaAadhaarValService",
    "instaService",
    "utilityService",
    "constantConfig",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    // "autoOtpReadService",
    function($state,
        $scope,
        instaAadhaarValService,
        instaService,
        utilityService,
        constantConfig,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate
        // autoOtpReadService
        ) {

        var instaaadhaarValidVm = this;

        function initPage() {
            instaaadhaarValidVm.showBack = true;
            instaaadhaarValidVm.showNext = false;
            instaaadhaarValidVm.disableNext = true;
            instaaadhaarValidVm.aofooter = true;
            instaaadhaarValidVm.otpNumberInput = true;
            $translate('AO_OK_LABEL').then(function(translatedvalue) {
                instaaadhaarValidVm.okBtntext = translatedvalue;
            });    
			instaaadhaarValidVm.isSubmitNotTapped = true;
        }

        instaaadhaarValidVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_personalDetails');            
        }

        instaaadhaarValidVm.goToNextPage = function() {
            instaService.customerAadhaarCardDetails.uid = instaaadhaarValidVm.aadhaarnumber;
            instaService.customerAadhaarCardDetails.vid = instaaadhaarValidVm.vidnumber;
            $state.go('menu.instaKit_aoAadhaarOtp');
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaaadhaarValidVm.updateAadhaarNumber = function(){
            if(instaService.isAadharManualEntry == false){
                instaaadhaarValidVm.aadhaarnumber = instaService.customerAadhaarCardDetails.uid;
                instaaadhaarValidVm.vidnumber = instaService.customerAadhaarCardDetails.vid;
            }
            else{
                instaaadhaarValidVm.aadhaarnumber = "";
                instaaadhaarValidVm.vidnumber = "";
            }
        };

        instaaadhaarValidVm.checkFormValid = function(isValid){
            if(isValid){
                instaaadhaarValidVm.disableNext = false;
            }
            else{
                instaaadhaarValidVm.disableNext = true;
            }
        };

           
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instaaadhaarValidVm.isAadharManualEntry = instaService.isAadharManualEntry;
            instaaadhaarValidVm.updateAadhaarNumber();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instaService.customerAadhaarCardDetails.aadharNewEntry = false;
            if(instaService.isVID){
            	instaaadhaarValidVm.isVID = instaService.isVID;	
            }else if(instaService.customerAadhaarCardDetails.vid){
            	instaService.isVID = true;
            	instaaadhaarValidVm.isVID = instaService.customerAadhaarCardDetails.vid;
            }
            
        });

        return this;
    }
]);
