'use strict';

angularApp.controller('instaaccountOpeningProcessGlanceController', ["$state",
    "$scope",
    "instaaccountOpeningService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "constantConfig",
    "newToSbiService",
    "preHomeLoginService",
    "$ionicPopup",
    "$sce",

    function($state,
        $scope,
        instaaccountOpeningService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        constantConfig,
        newToSbiService,
        preHomeLoginService,$ionicPopup,$sce) {

        var instaaccountOpeningProcessGlanceVm = this;
        instaaccountOpeningProcessGlanceVm.showNext = true;
        instaaccountOpeningProcessGlanceVm.showBack = false;
        
        function initPage() {
            //instaaccountOpeningVm.journeyType = instaService.journeyType;
           instaaccountOpeningProcessGlanceVm.getINSTAPlusDeatail = "";
           instaaccountOpeningProcessGlanceVm.featuresJson = "";
           instaaccountOpeningProcessGlanceVm.loadProcessGlance();
           instaaccountOpeningProcessGlanceVm.pVideoDemo();
        }

       
        instaaccountOpeningProcessGlanceVm.loadProcessGlance = function() {
            instaaccountOpeningService.getInstaPlusDetail().then(function(data) {
                console.log(instaaccountOpeningProcessGlanceVm.getInstaPlusDetail);
                instaaccountOpeningProcessGlanceVm.getINSTAPlusDeatail = data;
                console.log(instaaccountOpeningProcessGlanceVm.getINSTAPlusDeatail);
                instaaccountOpeningProcessGlanceVm.featuresJson = instaaccountOpeningProcessGlanceVm.getINSTAPlusDeatail.processAtGlance;
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        // instaaccountOpeningProcessGlanceVm.pVideoDemo = function() {
        //     alert("working");
        // }

        instaaccountOpeningProcessGlanceVm.pVideoDemo = function(videoId){

	        instaaccountOpeningService.getVideoDemo().then(function(response) {
		        angular.forEach(response.videoList, function (value, key) {

		 	        if (value.videoName == videoId) {
		 			    $scope.videoUrl=value.videoUrl;
					    $scope.trustSrcVideo = function(videoUrl){
						    return  $sce.trustAsResourceUrl(videoUrl)
				        }

				        $scope.videoTitle=value.videoTitle;

                        instaaccountOpeningService.videopopup=$ionicPopup.alert({
                            title: '',
                            templateUrl: 'pages/instaKit/accountOpening/instaKit_accountOpeningProcessAtglanceVideoPop.html',
                            scope: $scope,
                            cssClass: 'dialog pAOvideo',
                            buttons: [{
                                text: 'Close',
                                    onTap: function(e) {
                                        instaaccountOpeningService.videopopup.close();
                                    }
                                }]
                        });
		 	        }
		        })

			}, function(error) {
			    utilityService.showErrorMessage(error.responseMessage);
		    });
        }

        // instaaccountOpeningProcessGlanceVm.authoriseUser = function(){
        //     if(instaaccountOpeningProcessGlanceVm.isChecked){
        //         instaaccountOpeningProcessGlanceVm.disableNext = false;
        //     }
        //     else{
        //         instaaccountOpeningProcessGlanceVm.disableNext = true;
        //     }
        // }

        instaaccountOpeningProcessGlanceVm.goToNextPage = function() {
            $state.go('menu.instaKit_mobileEntryPage');
        }
	
        instaaccountOpeningProcessGlanceVm.pFaq = function(){
           $state.go('menu.accountOpeningProcessGlanceFAQ');
       }


        $scope.goToHome = function(){
            instaService.homeNav();
        }
        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instaaccountOpeningProcessGlanceVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);

        });
        
        return this;
    }
]);
