'use strict';

angularApp.controller('instaaccountOpeningProcessGlanceFAQController', ["$state",
    "$scope",
    "instaaccountOpeningService",
    "instaService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "constantConfig",
    "newToSbiService",


    function($state,
        $scope,
        instaaccountOpeningService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        constantConfig,
        newToSbiService) {

        var instaaccountOpeningProcessGlanceFAQVm = this;
        instaaccountOpeningProcessGlanceFAQVm.showNext = false;
        instaaccountOpeningProcessGlanceFAQVm.showBack = true;
        
        function initPage() {
            //instaaccountOpeningVm.journeyType = instaService.journeyType;
           //instaaccountOpeningProcessGlanceFAQVm.getINSTAPlusDeatail = "";
           instaaccountOpeningProcessGlanceFAQVm.loadProcessGlanceFAQ();
        }

       
        instaaccountOpeningProcessGlanceFAQVm.loadProcessGlanceFAQ = function() {
            instaaccountOpeningService.getFAQList().then(function(data) {
                
                instaaccountOpeningProcessGlanceFAQVm.getFAQList = data;
                instaaccountOpeningProcessGlanceFAQVm.featuresJson = instaaccountOpeningProcessGlanceFAQVm.getFAQList.getFAQLists;
                console.log(instaaccountOpeningProcessGlanceFAQVm.featuresJson);
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }


        instaaccountOpeningProcessGlanceFAQVm.goBacktoPrevious = function() {
            $state.go('menu.accountOpeningProcessAtglance');
        }

        $scope.goToHome = function(){
            instaService.homeNav();
        }
        
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            instaaccountOpeningProcessGlanceFAQVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);

        });
        
        return this;
    }
]);
