'use strict';

angularApp.service('instaknowMoreService',
    function($q, AdapterUtils, constantConfig) {
        var instaknowMoreService = this;
        instaknowMoreService.productKnowMore = function() {
            var q = $q.defer();

            //Get product features additional information
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.productFeatureKnowMore, true).then(

                function(response) {
                    q.resolve(response.data.productFeaturesKnowMore);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return instaknowMoreService;
    });