'use strict';

angularApp.controller('instaadditionalDetailsController', ["$state",
    "$scope",
    "instaService",
    "instaadDetailsCommonService",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaService,
        instaadDetailsCommonService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaadditionalDetailsVm = this;

        function initPage() {
            instaadditionalDetailsVm.showBack = true;
            instaadditionalDetailsVm.showNext = false;
            instaadditionalDetailsVm.aofooter= true;
            instaadditionalDetailsVm.loadQualification();
        }

        instaadditionalDetailsVm.getMariatlStatus = function() {
            $state.go("menu.instaKit_aDMaritalStatus")
        }

        instaadditionalDetailsVm.loadQualification = function(){
        	instaadditionalDetailsVm.isErorr = false;
            var requestParam = "EducationLotus";
            utilityService.showSpinner();
            instaadDetailsCommonService.getQualification(requestParam).then(function(data) {
                instaadditionalDetailsVm.isErorr = false;
                utilityService.hideSpinner();
                instaadditionalDetailsVm.eduQualificationList = data;
            }, function(error) {
            	utilityService.hideSpinner();
            	instaadditionalDetailsVm.isErorr = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        instaadditionalDetailsVm.populateResumeData = function(){
            if(instaService.isResumeJourney == true){
                instaadditionalDetailsVm.activeStatus = instaService.getIdByValue(instaadditionalDetailsVm.eduQualificationList, instaService.customerAdditionalDetails.education);
            }
        }

        instaadditionalDetailsVm.goBacktoPrevious = function() {            
            $state.go("menu.instaKit_aOLooksGreat");
        }


        instaadditionalDetailsVm.goToNextPage = function(param) {
            instaService.activeAdditionalDetails.education = param.value;
            instaService.customerAdditionalDetails.education = param.description;
            $state.go("menu.instaKit_aDMaritalStatus"); 
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            instaadditionalDetailsVm.activeStatus = instaService.activeAdditionalDetails.education;
            //instaadditionalDetailsVm.populateResumeData();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
