'use strict';

angularApp.service('instaappPasswordService',
    function($q, AdapterUtils, constantConfig) {
        var instaappPasswordService = this;
        
        instaappPasswordService.registerCustomer = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.registerCustomer, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };

        instaappPasswordService.loadSecurityQuestions = function() {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.getSecurityQuestions, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;

        };
        return instaappPasswordService;

    });
