'use strict';

angularApp.controller('instaapplyNewOrResumeController',
	["$timeout", "$state", "$scope", "$translate", "$ionicSideMenuDelegate", "ionicToast", "$ionicScrollDelegate", "needHelpService", "utilityService", "$ionicSlideBoxDelegate", "loggedInUserService", "constantConfig", "cryptoService", "encryptionService", "AdapterUtils", "regProcessWithAccNoService", "ompMerchantsService", "preHomeLoginService", "$ionicPopup", "$sce", "instaService","newToSbiService",
		function ($timeout, $state, $scope, $translate, $ionicSideMenuDelegate, ionicToast, $ionicScrollDelegate, needHelpService, utilityService, $ionicSlideBoxDelegate, loggedInUserService, constantConfig, cryptoService, encryptionService, AdapterUtils, regProcessWithAccNoService, ompMerchantsService, preHomeLoginService, $ionicPopup, $sce, instaService,newToSbiService) {

			var instaapplyNewOrResumeVm = this;
			
			instaapplyNewOrResumeVm.journeyType = instaService.journeyType;

			instaapplyNewOrResumeVm.goBack = function () {
				$state.go('menu.openDsaWithoutVisit');
			}

			instaapplyNewOrResumeVm.startNewApplication = function() {
				instaService.isResumeJourney = false;

				
				
				if(instaapplyNewOrResumeVm.journeyType == "VKYC-CSP"){
					$state.go("menu.employerDetails");
				}else{
					$state.go("menu.instaKit_accountOpening");
				}
			}
	
			instaapplyNewOrResumeVm.resumeApplication = function() {
				instaService.isResumeJourney = true;
				$state.go("menu.instaKit_resumeJourney");
			}

			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {
				$ionicSideMenuDelegate.canDragContent(false);
			});


			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {
				$ionicSideMenuDelegate.canDragContent(false);
				instaapplyNewOrResumeVm.journeyType = instaService.journeyType;
				if(instaService.journeyType == constantConfig.acOpeningAdapterOVDConstant.salaryAcc){
                    instaapplyNewOrResumeVm.showSalaryAccTitle = true;
				}else{
					instaapplyNewOrResumeVm.showSalaryAccTitle = false;
					instaapplyNewOrResumeVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
				}
            	
			});

			//any cleanup needs to be done here: executes everytime when page is left
			$scope.$on('$ionicView.afterLeave', function () {
				$ionicSideMenuDelegate.canDragContent(false);
			});
		
		}]);
