'use strict';

angularApp.service('instabranchDetailsService',
    function($q, AdapterUtils, constantConfig) {
        var instabranchDetailsService = this;

        instabranchDetailsService.loadBranchDetails = function(params) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.getInTouchBranchesByCity, params, true).then(

                 function(response){ 
                    q.resolve(response);
                },
                function(error){    
                    q.reject(error);
                }
            );

            return q.promise;
        };

        instabranchDetailsService.getCities = function() {
           
             var q = $q.defer(); 
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getCities, true).then(
                function(response){ 
                    q.resolve(response.body);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;

        };
        return instabranchDetailsService;
    });
