'use strict';

angularApp.service('companyDetailsService',
    function($q, AdapterUtils, constantConfig) {
        var companyDetailsService = this;

        companyDetailsService.sendCompanyDetails = function(requestParams) {

            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.companyDetails, requestParams, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );

            return q.promise;
        };

        return companyDetailsService;
    });
