'use strict';

angularApp.controller('instahomePageController', ["$state",
    "$scope","$ionicHistory","instaService","$timeout","$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        $ionicHistory,
        instaService,
        $timeout,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instahomePageVm = this;

        function initPage() {
            instahomePageVm.hideBtn = true;
           // window.addEventListener('native.showkeyboard', instahomePageVm.keyboardShowHandler);
           // window.addEventListener('native.hidekeyboard', instahomePageVm.keyboardHideHandler);
        }

        instahomePageVm.goToYourAccount = function() {
            $state.go('menu.instaKit_sbiInTouchRegisterOptions');
        }

        instahomePageVm.openDigitalAccount = function(){
            $state.go("menu.instaKit_applyNewOrResume");
        }

        instahomePageVm.goToShoppingPage = function(){
            $state.go("menu.ompMerchants");
        }

        //Show the footer when keypad is hidden
        // instahomePageVm.keyboardHideHandler = function(e) {
        //     var j;
        //     var footer = document.getElementsByClassName("app-footer");
        //     for (j = 0; j < footer.length; j++) {
        //         footer[j].style.display = 'block';
        //     }
        // }

        // //Hide the footer when keypad is shown
        // instahomePageVm.keyboardShowHandler = function(e) {
        //     var j;
        //     var footer = document.getElementsByClassName("app-footer");
        //     for (j = 0; j < footer.length; j++) {
        //         footer[j].style.display = 'none';
        //     }
        // }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

         //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $timeout(function () {
                $ionicHistory.clearCache();
                $ionicHistory.clearHistory();
            }, 1500)    
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);     
        });
        return this;
    }
]);
