'use strict';

angularApp.controller('instamultipleCustomerController', ["$state",
    "$scope",
    "instaService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",


    function($state,
        $scope,
        instaService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instamultipleCustomerVm = this;

        function initPage() {
            instamultipleCustomerVm.showBack = true;
            instamultipleCustomerVm.showNext = false;
        }

        instamultipleCustomerVm.goBacktoPrevious = function() {
            $state.go('menu.instaKit_panDetails');
        }

        instamultipleCustomerVm.goToNextPage = function() {
            //$state.go('menu.aadhaarManualEntry');
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instamultipleCustomerVm.displaymap = function() {
            $state.go('menu.instaKit_locateNearestBranch');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        
        return this;
    }
]);
