'use strict';

angularApp.service('instapasswordOTPService',
    function($q, AdapterUtils, constantConfig) {
        var instapasswordOTPService = this;
        
        /* Send the OTP and ID to complete the registration */
        instapasswordOTPService.OTPValidation = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.validateOTP, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        /* Request for OTP on page load to the registered mobile number */
        instapasswordOTPService.requestOtp = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.getOTP, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        /* Request for OTP on page load to the registered mobile number */
        instapasswordOTPService.sendCommonId = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.completeRegistration, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
        return instapasswordOTPService;
    });
