'use strict';

angularApp.service('instapersonalDetailsService',
    function($q, AdapterUtils, constantConfig) {
        var instapersonalDetailsService = this;
        instapersonalDetailsService.updateAadhaarDetails = function(requestParams) {
            var q = $q.defer(); 

            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.adharcard, requestParams, true).then(
                function(response){ 
                    q.resolve(response);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instapersonalDetailsService.fetchDistrict = function(requestData) {
            var q = $q.defer();
             AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.fetchDistrict, requestData, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instapersonalDetailsService.fetchSubDistrict = function(requestData) {
            var q = $q.defer();
             AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.fetchSubDistrict, requestData, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };

        instapersonalDetailsService.fetchVillage = function(requestData) {
            var q = $q.defer();
             AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.fetchVillage, requestData, true).then(

                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            
            return q.promise;
        };
        return instapersonalDetailsService;
}); 