'use strict';

angularApp.controller('instaSearchBranchByOptionController', ["$state",
    "$scope",
    "instaService",
    "$ionicHistory",
    "$translate",
    "currentLocationService",
    "utilityService",
    "instaselectBranchListService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",

    function($state,
        $scope,
        instaService,
        $ionicHistory,
        $translate,
        currentLocationService,
        utilityService,
        instaselectBranchListService,
        $ionicSideMenuDelegate,
        mPinLoginService) {

        var instaSearchBranchByOptionVm = this;

        function initPage() {
            instaSearchBranchByOptionVm.showBack = true;
            instaSearchBranchByOptionVm.showNext = false;
            instaSearchBranchByOptionVm.disableNext = true;
            instaSearchBranchByOptionVm.aofooter = true;
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instaSearchBranchByOptionVm.okBtntext = translatedvalue;  
            });
        }

        instaSearchBranchByOptionVm.goBacktoPrevious = function() {
            $state.go("menu.instaKit_selectBListLocalityByPincode");
        }

        instaSearchBranchByOptionVm.goToNextPage = function() {            
            $state.go('menu.instaKit_searchBranch');
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaSearchBranchByOptionVm.searchBy = function(searchType) {
            instaSearchBranchByOptionVm.searchBranchBy = searchType;
            instaService.searchBranchBy = searchType;
            instaService.clearSearchBrData = true
            $state.go('menu.instaKit_searchBranch');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            // instaService.localityNav = "selectBranch";
            // instaService.localityNextDisable="selectBranchList";
            if (!instaService.searchBranchBy){
                instaSearchBranchByOptionVm.searchBranchBy = "";
            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
