'use strict';

angularApp.controller('instaselectBranchListByPinController', ["$state",
    "$scope",
    "$ionicScrollDelegate",
    "instaselectBranchListService",
    "instaService",
    "utilityService",
    "$ionicHistory",
    "$translate",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "employerDetailsService",


    function ($state,
        $scope,
        $ionicScrollDelegate,
        instaselectBranchListService,
        instaService,
        utilityService,
        $ionicHistory,
        $translate,
        $ionicSideMenuDelegate,
        mPinLoginService,
        employerDetailsService) {

        var instaselectBranchListPinVm = this;

        function initPage() {
            instaselectBranchListPinVm.showBack = true;
            instaselectBranchListPinVm.showNext = true;
            instaselectBranchListPinVm.disableNext = true;
            instaselectBranchListPinVm.bankListLocality = [];
            instaselectBranchListPinVm.aofooter = true;
            instaselectBranchListPinVm.showRadioBtn = true;
            instaselectBranchListPinVm.showLink = false;
            instaselectBranchListPinVm.pincode = "";
            $translate('AO_OK_LABEL').then(function (translatedvalue) {
                instaselectBranchListPinVm.okBtntext = translatedvalue;
            });
        }

        instaselectBranchListPinVm.goBacktoPrevious = function () {
           
            if(parseInt(instaService.nomineeAadhaarCardDetails.age) < 18 || parseInt(instaService.nominee.age) < 18){
                if(instaService.nominee.guardianAddressFlag == "nomineeAddress"){
                    $state.go("menu.instaKit_nomineeEnteredAddress");
                }
                else if(instaService.nominee.guardianAddressFlag == "applicantAddress"){
                    $state.go("menu.instaKit_nomineeAddress");
                }
                else if(instaService.nominee.guardianAddressFlag == "newAddress"){
                    $state.go("menu.instaKit_nomineeCAddress");
                }
                else{
                    $state.go("menu.instaKit_nomineeDetailsAddressOption");
                }
            }
            else{
                $state.go("menu.instaKit_nomineeDetailsNext");
            }
        }

        instaselectBranchListPinVm.goToNextPage = function () {
            if(instaselectBranchListPinVm.branchList == "-1"){
                $state.go('menu.instaKit_searchBranchByOption');
            } else {
                instaService.homeBranchLocalityId = instaselectBranchListPinVm.homeBranchLocalityId;
                instaService.homeBranchLocalityBranchName = instaselectBranchListPinVm.homeBranchLocalityBranchName;
                instaService.homeBranchLocalityAddress = instaselectBranchListPinVm.homeBranchLocalityAddress;
                instaService.homeBranchLocalityCityName = instaselectBranchListPinVm.homeBranchLocalityCityName;
                instaService.homeBranchLocalityPincode = instaselectBranchListPinVm.homeBranchLocalityPincode;
                instaService.vkycBranchCode = instaselectBranchListPinVm.vkycBranchCode;
                $state.go('menu.instaKit_reviewSelectedBranch');
            }
        }

        $scope.goToHome = function () {
            instaService.homeNav();
        }

        // instaselectBranchListPinVm.notaFn = function () {
        //     var temp = {}
        //     temp.address = "None Of The Above";
        //     temp.branchName = "";
        //     temp.city = "";
        //     temp.id = "-1";
        //     temp.latitude = "";
        //     temp.longitude = "";
        //     temp.phoneNumber = "";
        //     temp.pincode = "";
        //     temp.state = "";
        //     temp.vkycBranchCode = "";
        //     instaselectBranchListPinVm.checkDiv(temp);
        //     instaselectBranchListPinVm.selectedBranch(temp);
        // }

        //Make the radio button checked if the respective div is clicked
        instaselectBranchListPinVm.checkDiv = function (param) {
            instaselectBranchListPinVm.branchList = param.id;
            instaselectBranchListPinVm.disableNext = false;
            // instaService.homeBranchLocalityId = param.id;
            // instaService.homeBranchLocalityBranchName = param.branchName;
            // instaService.homeBranchLocalityAddress = param.address;
            // instaService.homeBranchLocalityCityName = param.city;
            // instaService.homeBranchLocalityPincode = param.pincode;
            // instaService.vkycBranchCode = param.vkycBranchCode;
            instaselectBranchListPinVm.homeBranchLocalityId = param.id;
            instaselectBranchListPinVm.homeBranchLocalityBranchName = param.branchName;
            instaselectBranchListPinVm.homeBranchLocalityAddress = param.address;
            instaselectBranchListPinVm.homeBranchLocalityCityName = param.city;
            instaselectBranchListPinVm.homeBranchLocalityPincode = param.pincode;
            instaselectBranchListPinVm.vkycBranchCode = param.vkycBranchCode;
        }

        instaselectBranchListPinVm.validateForm = function (isValid) {
            if (isValid) {
                instaselectBranchListPinVm.disableNext = false;
            }
            else {
                instaselectBranchListPinVm.disableNext = true;
            }
        }

        instaselectBranchListPinVm.selectedBranch = function (param) {
            instaService.branchname = param.branchName;
            instaService.branchaddress = param.address;
            // instaService.homeBranchLocalityId = param.id;
            // instaService.homeBranchLocalityBranchName = param.branchName;
            // instaService.homeBranchLocalityAddress = param.address;
            // instaService.homeBranchLocalityCityName = param.city;
            // instaService.homeBranchLocalityPincode = param.pincode;
            // instaService.vkycBranchCode = param.vkycBranchCode;
            instaselectBranchListPinVm.homeBranchLocalityId = param.id;
            instaselectBranchListPinVm.homeBranchLocalityBranchName = param.branchName;
            instaselectBranchListPinVm.homeBranchLocalityAddress = param.address;
            instaselectBranchListPinVm.homeBranchLocalityCityName = param.city;
            instaselectBranchListPinVm.homeBranchLocalityPincode = param.pincode;
            instaselectBranchListPinVm.vkycBranchCode = param.vkycBranchCode;
        }

        //Service for displaying branch list for locality
        instaselectBranchListPinVm.loadBranchesLocality = function () {
            instaselectBranchListPinVm.hideOptions = false;
            instaselectBranchListPinVm.bankListLocality.length = 0;
            var params = {
                "locality": instaselectBranchListPinVm.pincode,
                "localityType": "PINCODE"
            }
            instaService.homeBranchLocalityCity = instaselectBranchListPinVm.pincode;
            instaselectBranchListService.getBranchesForLocality(params).then(function (data) {
                instaselectBranchListPinVm.noBranchMsg = "No branch available for your pincode as per Aadhaar. Kindly select 'None of the above' to search by branch code or branch name.";
                if (utilityService.isUndefined(data)) {
                     employerDetailsService.showAlertPopup("alert", instaselectBranchListPinVm.noBranchMsg,"","menu.instaKit_searchBranchByOption", "OK", "", "", "");
                } else {
                    if (data.branches.length == 0) {
                        
                        employerDetailsService.showAlertPopup("alert", instaselectBranchListPinVm.noBranchMsg,"","menu.instaKit_searchBranchByOption", "OK", "", "", "");
                    }
                    else {
                        for (var i = 0; i < data.branches.length; i++) {
                            instaselectBranchListPinVm.bankListLocality.push(data.branches[i]);
                            if (instaselectBranchListPinVm.bankListLocality[i].id == instaService.homeBranchLocalityId) {
                                instaselectBranchListPinVm.branchList = instaselectBranchListPinVm.bankListLocality[i].id;
                                // instaService.homeBranchLocalityBranchName = instaselectBranchListPinVm.bankListLocality[i].branchName;
                                // instaService.homeBranchLocalityAddress = instaselectBranchListPinVm.bankListLocality[i].address;
                                // instaService.homeBranchLocalityCityName = instaselectBranchListPinVm.bankListLocality[i].city;
                                // instaService.homeBranchLocalityPincode = instaselectBranchListPinVm.bankListLocality[i].pincode;
                                // instaService.vkycBranchCode = instaselectBranchListPinVm.bankListLocality[i].vkycBranchCode;
                                instaselectBranchListPinVm.homeBranchLocalityId = instaselectBranchListPinVm.bankListLocality[i].id;
                                instaselectBranchListPinVm.homeBranchLocalityBranchName = instaselectBranchListPinVm.bankListLocality[i].branchName;
                                instaselectBranchListPinVm.homeBranchLocalityAddress = instaselectBranchListPinVm.bankListLocality[i].address;
                                instaselectBranchListPinVm.homeBranchLocalityCityName = instaselectBranchListPinVm.bankListLocality[i].city;
                                instaselectBranchListPinVm.homeBranchLocalityPincode = instaselectBranchListPinVm.bankListLocality[i].pincode;
                                instaselectBranchListPinVm.vkycBranchCode = instaselectBranchListPinVm.bankListLocality[i].vkycBranchCode;
                                instaselectBranchListPinVm.disableNext = false;
                            }
                        }
                        var temp = {}
                        temp.address = "None Of The Above";
                        temp.branchName = " ";
                        temp.city = "";
                        temp.id = "-1";
                        temp.latitude = "";
                        temp.longitude = "";
                        temp.phoneNumber = "";
                        temp.pincode = "";
                        temp.state = "";
                        temp.vkycBranchCode = "";
                        instaselectBranchListPinVm.bankListLocality.push(temp);
                        
                    }
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            instaService.searchBranchBy = ""
            instaselectBranchListPinVm.pincode = instaService.customerAadhaarCardDetails.pc;
            if (!utilityService.isUndefined(instaselectBranchListPinVm.pincode)) {
                instaselectBranchListPinVm.loadBranchesLocality();
            }
            else if (utilityService.isUndefined(instaselectBranchListPinVm.pincode)) {
                instaselectBranchListPinVm.bankListLocality = [];
                instaselectBranchListPinVm.disableNext = true;
                instaService.homeBranchLocalityId = '';
                instaService.homeBranchLocalityCity = '';
                instaService.homeBranchLocalityBranchName = '';
                instaService.homeBranchLocalityAddress = '';
                instaService.homeBranchLocalityCityName = '';
                instaService.homeBranchLocalityPincode = '';
                instaService.vkycBranchCode = '';

            }
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });
        return this;
    }
]);
