'use strict';

angularApp.controller('instaGetReadyController', ["$state",
    "$scope",
    "instaService",
    "instaenterOTPReferenceCodeService",
    "$timeout",
    "utilityService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "constantConfig",
    "newToSbiService",
    "instaStartVKYCService",
    "$ionicPopup",
    "employerDetailsService",
    "rxtcService",
    function($state,
        $scope,
        instaService,
        instaenterOTPReferenceCodeService,
        $timeout,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        constantConfig,
        newToSbiService,
        instaStartVKYCService,
        $ionicPopup,
        employerDetailsService,
        rxtcService) {

        var instaGedReadyVm = this;

        function initPage() {
            instaGedReadyVm.showBack = true;
            instaGedReadyVm.showNext = true;
            instaGedReadyVm.aofooter = true;
            instaGedReadyVm.showOtpView = true;
            instaGedReadyVm.otpFooterView = true;
            // instaGedReadyVm.getContent();
            if (!instaStartVKYCService.isPushEnabled) {
				instaGedReadyVm.registerForPush();
            }

            instaGedReadyVm.journeyType = instaService.journeyType;
            instaGedReadyVm.constantJourneyTypeVKYC = constantConfig.acOpeningAdapterOVDConstant.vkycInsta;
            instaGedReadyVm.getInstaPlusDetail = angular.copy(newToSbiService.getInstaPlusDetail);
           
        }

    
     instaGedReadyVm.knowMoreCont = function(){
            $state.go("menu.instaKit_getReadyKnowMore");
        }

        instaGedReadyVm.goBacktoPrevious = function(){
            $state.go("menu.instaKit_enterOTPReferenceCode");
        }

        instaGedReadyVm.startVkycConfirmation = function (){

            //  var msg = "Document size should be less than 2 MB."
            //     $ionicPopup.show({
            //         title: '',
            //         template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
			// 		+ msg + '</span></div></div></div>',
            //         scope: $scope,
            //         cssClass: 'my-custom-popup bhim-alert-popup ao-popupMain',
            //         buttons: [{
            //             text: 'OK',
            //             type: 'button-assertive',
            //             onTap: function () {

            //             }
            //         }],
            //     });
            instaGedReadyVm.message = "You will be redirected to a third party website for completion of video KYC."
            // employerDetailsService.showAlertPopup("success", instaGedReadyVm.message,"",instaGedReadyVm.startVKYC(), "OK", "", "", "");

                //employerDetailsService.showAlertPopup("", "OTP resent Successfully", "", "", "OK", "", "", "");
            $ionicPopup.show({
                title: '',
                template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src="img/AO/successSymbol.svg" /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'+ instaGedReadyVm.message + '</span></div></div></div>',
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: [{
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function () {
                       instaGedReadyVm.startVKYC();
                    }
                }],
            });

            //   $ionicPopup.alert({
            //     title: "",
            //     template: '<div class="confirmPopupPadding font-dark-grey"><div><img class="confirmIcon-ao" src="img/AO/successSymbol.svg"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
            //     + instaGedReadyVm.message + '</span></div></div></div>',
            //     scope: $scope,
            //     cssClass: 'removePopup-head bhim-alert-popup ao-getReady popupWidth90 popupMargin ftpopup-body popupBackgroundWhite textAlignCenter inb-pop-btn ss-popup',
            //     buttons: [{
            //       text: 'Ok',
            //       type: 'button-positive',
            //       onTap: function () {
            //         instaGedReadyVm.startVKYC();
            //       }
            //     }]
        
            //   })

            
        }

        instaGedReadyVm.goToNextPage = function() {
            instaGedReadyVm.showOtpView = false;
            instaGedReadyVm.otpFooterView = false;
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaGedReadyVm.registerForPush = function () {
            try {
                  WLAuthorizationManager.obtainAccessToken("push.mobileclient").then(
                    MFPPush.registerDevice(null,
                        function (successResponse) {
                            instaStartVKYCService.isPushEnabled = true;
                        },function (failureResponse) { 
                        }
                    )
                );
            }
            catch(err) {
              console.log(err);
            }
            
        }
       

        


        instaGedReadyVm.startVKYC = function() {
            // alert("COMMING SOON")
            instaStartVKYCService.startVKYCUser().then(function(response) {
                instaGedReadyVm.redirectURL = response.data.url;  
                console.log(instaGedReadyVm.redirectURL);

                if(instaGedReadyVm.redirectURL){

                    SafariViewController.isAvailable(function (available) {
                        if (available) {
                          SafariViewController.show({
                                url: instaGedReadyVm.redirectURL,
                                hidden: false, // default false. You can use this to load cookies etc in the background (see issue #1 for details).
                                animated: false, // default true, note that 'hide' will reuse this preference (the 'Done' button will always animate though)
                                transition: 'curl', // (this only works in iOS 9.1/9.2 and lower) unless animated is false you can choose from: curl, flip, fade, slide (default)
                                enterReaderModeIfAvailable: false, // default false
                                tintColor: "#00ffff", // default is ios blue
                                toolbarColor: "#90305e", // change color of address bar in android
                                barColor: "#90305e", // on iOS 10+ you can change the background color as well
                                controlTintColor: "#ffffff" // on iOS 10+ you can override the default tintColor
                              },
                              // this success handler will be invoked for the lifecycle events 'opened', 'loaded' and 'closed'
                              function(result) {
                                if (result.event === 'opened') {
                                  console.log('opened');
                                } else if (result.event === 'loaded') {
                                  console.log('loaded');
                                } else if (result.event === 'closed') {
                                  console.log('closed');
                                  instaService.homeNav();
                                }
                              },
                              function(msg) {
                                console.log("Error: " + msg);
                              })
                        } else {
                          // potentially powered by InAppBrowser because that (currently) clobbers window.open
                          window.open(instaGedReadyVm.redirectURL, '_blank', 'location=yes');
                        }
                      })               

                }
                
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

       


        instaGedReadyVm.getAccContent = function(){ 
            instaenterOTPReferenceCodeService.getAccountOpenCont().then(function(response) {
                instaGedReadyVm.otpReferenceText = response.data.accOpenContent;         
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

       

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
           initPage();  
           $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn); 
           //instaGedReadyVm.knowMoreCont(); 
        });



        

        return this;
    }
]);
