'use strict';

angularApp.service('instatermsAndConditionsService',
    function($q, AdapterUtils, constantConfig) {
        var instatermsAndConditionsService = this;
        instatermsAndConditionsService.getTermsAndConditions = function() {
            var q = $q.defer();
            AdapterUtils.getData(constantConfig.InstaAcOpeningAdapterUrl.getTermsAndConditions, true).then(

                function(response) {
                    q.resolve(response.data.termsAndConditions);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        instatermsAndConditionsService.postTAndC = function(requestData) {
            var q = $q.defer();
            AdapterUtils.postData(constantConfig.InstaAcOpeningAdapterUrl.postTAndCDetails, requestData, true).then(

                function(response) {
                    q.resolve(response);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return instatermsAndConditionsService;
    });
