'use strict';

angularApp.controller('instaupdateAadhaarController', ["$state",
    "$scope","instaupdateAadhaarService","instaService", "utilityService","$ionicSideMenuDelegate",
    "mPinLoginService", "$ionicHistory",

    function($state,
        $scope,
        instaupdateAadhaarService,
        instaService,
        utilityService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $ionicHistory) {

        var instaupdateAadhaarVm = this;

        function initPage() {
            instaupdateAadhaarVm.showBack = true;
            instaupdateAadhaarVm.showNext = false;
            instaupdateAadhaarVm.loadUpdateAadharContent();
        }
        
        instaupdateAadhaarVm.goBacktoPrevious = function() {
            // $state.go('menu.instaKit_pdetailsAddress');
            $ionicHistory.goBack();
        }

        $scope.goToHome = function() {
            instaService.homeNav();
        }

        instaupdateAadhaarVm.displaymap = function() {
            $state.go('menu.instaKit_locateNearestBranch');
        }

        instaupdateAadhaarVm.loadUpdateAadharContent = function(){
            instaupdateAadhaarService.getLocateBranchAadharContent().then(function(data) {
                instaupdateAadhaarVm.locateBranchAadharDesc = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
        });

        return this;
    }
]);
