'use strict';
angularApp.controller('tdrPassListController', [
	"$state",
	"$scope",
	"$ionicPopup",
	"$translate",
	"$ionicHistory",
	"utilityService",
	"ionicDatePicker",
	"$ionicSideMenuDelegate",
	"irctcService",
	function ($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, irctcService) {
		var tdrPassListVm = this;


		tdrPassListVm.goBack = function () {
			$ionicHistory.goBack(-1);
		}

		tdrPassListVm.toggleMenu = function () {

			tdrPassListVm.menu = !tdrPassListVm.menu;
		}

		// tdrPassListVm.goToNextPage = function () {

		// 	tdrPassListVm.popUP = $ionicPopup.show({
		// 		title: '',
		// 		cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter ftpopup-body',
		// 		templateUrl: 'pages/irctc/bookingHistory/CancelConfirmPopup.html',
		// 		scope: $scope
		// 	});

		// }



		tdrPassListVm.goToNextPage = function () {
			tdrPassListVm.cancellationList = [];
			tdrPassListVm.historyDetails.bookingResponseList.cancelledPsgn = [];
			for (var i = 0; i < tdrPassListVm.passengerList.length; i++) {

				if (tdrPassListVm.passengerList[i].checked) {
					tdrPassListVm.cancellationList.push(tdrPassListVm.passengerList[i].passengerSerialNumber);
					tdrPassListVm.historyDetails.bookingResponseList.cancelledPsgn.push(tdrPassListVm.passengerList[i]);
				}

			}
			irctcService.bookHistoryDetail = tdrPassListVm.historyDetails;
			var psgnCancelArray = tdrPassListVm.cancellationList;
			var psgnTokenString = '';
			for (var i = 0; i < psgnCancelArray.length; i++) {
				psgnTokenString = psgnTokenString + psgnCancelArray[i];
			}

			irctcService.tdrFiledPsgn = tdrPassListVm.cancellationList;
			var cancelObj = {
				"transactionId": irctcService.bookHistoryDetail.transID,
				"psgnToken": psgnTokenString,
				"reservationId": irctcService.bookHistoryDetail.resvID
			}


			//call cancel service
			var obj = {};
			irctcService.getTDR(obj).then(function (data) {
				irctcService.fileTDR=data;
				$state.go("menu.irctcFileTDR");                        
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });

		}

		tdrPassListVm.cancel = function () {
			tdrPassListVm.popUP.close();

		}

		tdrPassListVm.checkCancelStatus = function (index) {
			for (var i = 0; i < tdrPassListVm.passengerList.length; i++) {
				if (tdrPassListVm.passengerList[i].checked) {
					
					if(index==i)
				{
					tdrPassListVm.noOfChecked++;
				}



				} else {
					
					
						if(index==i)
				{
					tdrPassListVm.noOfChecked--;
				}

				}
			}

			if(tdrPassListVm.noOfChecked==tdrPassListVm.passengerList.length)
			{
             tdrPassListVm.selectAllData=true;
			}

			else
			{
				tdrPassListVm.selectAllData=false;

			}
			if(tdrPassListVm.noOfChecked>0)
			{
				tdrPassListVm.isNextEnabled = false;
			}
			else
			{
				tdrPassListVm.isNextEnabled = true;
			}
		}


		$scope.$on('$ionicView.beforeLeave', function () {

		});

		$scope.$on('$ionicView.afterEnter', function () {

		});

		tdrPassListVm.selectAll = function () {
			if (tdrPassListVm.selectAllData) {
				for (var i = 0; i < tdrPassListVm.passengerList.length; i++) {
					tdrPassListVm.passengerList[i].checked = true;
                  
				}
				 tdrPassListVm.noOfChecked=tdrPassListVm.passengerList.length;
				tdrPassListVm.isNextEnabled = false;

			} else {
				for (var i = 0; i < tdrPassListVm.passengerList.length; i++) {
					tdrPassListVm.passengerList[i].checked = false;
				

				}
				tdrPassListVm.noOfChecked=0;
				tdrPassListVm.isNextEnabled = true;
			}

		}

		$scope.$on('$ionicView.beforeEnter', function () {
			tdrPassListVm.isNextEnabled = true;
			tdrPassListVm.historyDetails = irctcService.bookHistoryDetail;
			tdrPassListVm.noOfChecked=0;

			tdrPassListVm.fromSTN = irctcService.bookHistoryDetail.fromStn;
			tdrPassListVm.toSTN = irctcService.bookHistoryDetail.toStn;

			tdrPassListVm.duration = irctcService.bookHistoryDetail.duration

			tdrPassListVm.passengerList1 = tdrPassListVm.historyDetails.bookingResponseList.psgnDtlList;
			//tdrPassListVm.historyDetails.bookingResponseList.psgnDtlList[0].checked = false;
            tdrPassListVm.passengerList=[];

			//passenger.checked
			for (var i = 0; i < tdrPassListVm.passengerList1.length; i++) {
			  tdrPassListVm.passengerList1[i].checked = false;
               if(tdrPassListVm.passengerList1[i].currentStatus !='CAN')
               {
				 tdrPassListVm.passengerList.push( tdrPassListVm.passengerList1[i]);
               }
				
			}

			if (irctcService.username) {
				irctcService.userLinkedStatus = true;
				tdrPassListVm.username = irctcService.username;
			} else {
				tdrPassListVm.username = "Menu";
				tdrPassListVm.userLinkedStatus = false;
			}
			tdrPassListVm.showManageInfo = irctcService.userLinkedStatus;

		});

		return this;
	}
]);
