'use strict';
angularApp.controller('irctcBookingPolicyController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"$timeout",
		"$ionicSideMenuDelegate",
        "$window","irctcService","cardsService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, $timeout,$ionicSideMenuDelegate,$window,irctcService,cardsService) {
			var irctcBookingPolicyVm = this;
			               
			irctcBookingPolicyVm.toggleMenu = function(){
				
				irctcBookingPolicyVm.menu = !irctcBookingPolicyVm.menu;
			}



			

			irctcBookingPolicyVm.GoBack = function() {
				$ionicHistory.goBack(-1);
			};

			$scope.$on('$ionicView.beforeLeave', function(){

			});

			$scope.$on('$ionicView.afterEnter', function() {

		       
			});
			
			$scope.$on('$ionicView.beforeEnter', function() {
                	
            	if(irctcService.username){
                	irctcService.userLinkedStatus = true;
                	irctcBookingPolicyVm.username = irctcService.username;
                }else{
                	irctcBookingPolicyVm.username = "Menu";
                	irctcService.userLinkedStatus = false;
                }

                var reqParams={};
              	reqParams.type="eTicketPolicy";

                irctcService.getTnC(reqParams).then(function (data) {
              		irctcBookingPolicyVm.binding = data;          
                },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                });


			});

			return this;
		}
]);
