'use strict';
angularApp.controller('viewRouteController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
        "irctcService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker,$ionicSideMenuDelegate,irctcService) {
			var viewRouteVm = this;
         
		viewRouteVm.goBack = function() {
			$ionicHistory.goBack(-1);
		};

		viewRouteVm.toggleMenu = function(){
	      	viewRouteVm.menu = !viewRouteVm.menu;
	    }

       	$scope.$on('$ionicView.beforeLeave', function(){

		});

		$scope.$on('$ionicView.afterEnter', function() {

		});

		$scope.$on('$ionicView.beforeEnter', function() {
			viewRouteVm.trainRoute = irctcService.viewRouteData;
	        viewRouteVm.trainData = irctcService.selectedTrainData;
			viewRouteVm.sourceTime = viewRouteVm.trainData.departureTime;
			viewRouteVm.destTime = viewRouteVm.trainData.arrivalTime;
			viewRouteVm.trainDuration = viewRouteVm.trainData.duration;
	     	viewRouteVm.trainNumber = viewRouteVm.trainData.trainNumber;
	     	viewRouteVm.trainName = viewRouteVm.trainData.trainName;
	     	//viewRouteVm.stationTo = viewRouteVm.trainData.toStnCode;
	     	//viewRouteVm.stationFrom = viewRouteVm.trainData.fromStnCode;
	     	viewRouteVm.trainRoute.trainDate = irctcService.searchDate;

	     	var list = viewRouteVm.trainRoute.stationList;
            var stationCodeArray = [];
            var stationNameArray = [];
            for (var i = 0; i < list.length; i++) {

            	stationCodeArray.push(list[i].stationCode);
            	stationNameArray.push(list[i].stationName);
            }

	     	viewRouteVm.stationTo = irctcService.getStationNameCode(viewRouteVm.trainData.toStnCode,stationCodeArray,stationNameArray);
         	viewRouteVm.stationFrom = irctcService.getStationNameCode(viewRouteVm.trainData.fromStnCode,stationCodeArray,stationNameArray);

	     	//Load IRCTC Masters & Station List
	          if(irctcService.username){
		          irctcService.userLinkedStatus = true;
		          viewRouteVm.username = irctcService.username;
		        }else{
		          viewRouteVm.username = "Menu";
		          viewRouteVm.userLinkedStatus = false;
		        }
	            viewRouteVm.showManageInfo = irctcService.userLinkedStatus;
		});

		return this;
	}
]);
