angularApp.controller('lifeInsuranceApplicationInfoBuyHomeController', [
    "$state",
    "$scope",
    "validateService",
    "lifeInsuranceApplicationService",
    "lifeInsuranceCommonService",
    "LiConstant",
    "$ionicScrollDelegate",


    function(
        $state,
        $scope,
        validateService,
        lifeInsuranceApplicationService,
        lifeInsuranceCommonService,
        LiConstant,
        $ionicScrollDelegate) {

        var lifeInsuranceApplicationInfoBuyHomeVm = this;
        lifeInsuranceApplicationInfoBuyHomeVm.validateService = validateService;
        lifeInsuranceApplicationInfoBuyHomeVm.showBack = true;
        lifeInsuranceApplicationInfoBuyHomeVm.showNext = true;
        lifeInsuranceApplicationInfoBuyHomeVm.disableBack = false;
        lifeInsuranceApplicationInfoBuyHomeVm.disableNext = false;
        var date = validateService.getCurrentDate();
        var currentYear = parseInt(date.getFullYear());


        lifeInsuranceApplicationInfoBuyHomeVm.data = {};

        function initPage() {
            if (lifeInsuranceApplicationService.getHomeDetails()) {
                lifeInsuranceApplicationInfoBuyHomeVm.data = lifeInsuranceApplicationService.getHomeDetails();
            }

            var d = new Date();
            var currentYear = d.getFullYear();
            var buyHomeAtArray = [{"key":"0","value":"No Plans"}];
            var k= 1;
            for (var i=currentYear; i<= (currentYear+35); i++ ){
                var j = {"key":(k++).toString(),"value":i.toString()}
                buyHomeAtArray.push(j);
            }
            //console.log("buyHomeAtArray :" + buyHomeAtArray);

            lifeInsuranceApplicationInfoBuyHomeVm.buyHomeAt = buyHomeAtArray;

            //lifeInsuranceApplicationInfoBuyHomeVm.buyHomeAt = lifeInsuranceApplicationService.getNeedAnalysisMastersList().buyHomeAt;

            //console.log("lifeInsuranceApplicationInfoBuyHomeVm.buyHomeAt :" + JSON.stringify(lifeInsuranceApplicationInfoBuyHomeVm.buyHomeAt));
        }


        lifeInsuranceApplicationInfoBuyHomeVm.updateByHome = function() {
            if(JSON.stringify(lifeInsuranceApplicationInfoBuyHomeVm.data.buyHomeYear) === JSON.stringify(lifeInsuranceApplicationInfoBuyHomeVm.buyHomeAt[0])) {
                 lifeInsuranceApplicationInfoBuyHomeVm.data.savedAmount = '0';
                lifeInsuranceApplicationInfoBuyHomeVm.data.currentCost = '0';
           } else {
                lifeInsuranceApplicationInfoBuyHomeVm.data.savedAmount = '';
                lifeInsuranceApplicationInfoBuyHomeVm.data.currentCost = '';
            }
        }


        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        lifeInsuranceApplicationInfoBuyHomeVm.closeJourney = function() {
             lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                   $state.go("menu.generalInsurance"); 
                }
            });
        };

        lifeInsuranceApplicationInfoBuyHomeVm.resize = function() {
            $ionicScrollDelegate.$getByHandle('mainScroll').resize();
        };
        
        //onclick of back button
        lifeInsuranceApplicationInfoBuyHomeVm.goBacktoPrevious = function() {
            $state.go("menu.lifeInsuranceApplicationInfoRP");
        }


        //onclick of next button
        lifeInsuranceApplicationInfoBuyHomeVm.goToNextPage = function() {
            if (validateForm()) {
                if(lifeInsuranceApplicationInfoBuyHomeVm.data.buyHomeYear.key == 0) {
                    lifeInsuranceApplicationInfoBuyHomeVm.data.savedAmount = '0';
                    lifeInsuranceApplicationInfoBuyHomeVm.data.currentCost = '0';
                    lifeInsuranceApplicationService.setNoHomePlan(true);
                } else {
                    lifeInsuranceApplicationService.setNoHomePlan(false);
                }

                lifeInsuranceApplicationService.setNeedAnalysisHomeDetails(lifeInsuranceApplicationInfoBuyHomeVm.data);
                lifeInsuranceApplicationService.saveNA(LiConstant.journeyCommonId.NA_BUY_HOME).then(function() {
                    $state.go("menu.lifeInsuranceApplicationInfoOG");
                });
            }
        }


        function validateForm() {
            lifeInsuranceApplicationInfoBuyHomeVm.lifeInsuranceApplicationBuyHomeForm = {};

            if (lifeInsuranceApplicationInfoBuyHomeVm.validateService.isValidBuyHomeBy(lifeInsuranceApplicationInfoBuyHomeVm.data.buyHomeYear)) {
                lifeInsuranceApplicationInfoBuyHomeVm.lifeInsuranceApplicationBuyHomeForm.buyHomeYear = lifeInsuranceApplicationInfoBuyHomeVm.validateService.isValidBuyHomeBy(lifeInsuranceApplicationInfoBuyHomeVm.data.buyHomeYear);
            }

            if(lifeInsuranceApplicationInfoBuyHomeVm.data.buyHomeYear && (lifeInsuranceApplicationInfoBuyHomeVm.data.buyHomeYear.key != 0)) {
                if (lifeInsuranceApplicationInfoBuyHomeVm.validateService.isValidSavings(lifeInsuranceApplicationInfoBuyHomeVm.data.savedAmount)) {
                    lifeInsuranceApplicationInfoBuyHomeVm.lifeInsuranceApplicationBuyHomeForm.savedAmount = lifeInsuranceApplicationInfoBuyHomeVm.validateService.isValidSavings(lifeInsuranceApplicationInfoBuyHomeVm.data.savedAmount);
                }

                if (lifeInsuranceApplicationInfoBuyHomeVm.validateService.isValidCurrentCost(lifeInsuranceApplicationInfoBuyHomeVm.data.currentCost, lifeInsuranceApplicationInfoBuyHomeVm.data.savedAmount)) {
                    lifeInsuranceApplicationInfoBuyHomeVm.lifeInsuranceApplicationBuyHomeForm.currentCost = lifeInsuranceApplicationInfoBuyHomeVm.validateService.isValidCurrentCost(lifeInsuranceApplicationInfoBuyHomeVm.data.currentCost, lifeInsuranceApplicationInfoBuyHomeVm.data.savedAmount);
                }
            }
            return (angular.equals({}, lifeInsuranceApplicationInfoBuyHomeVm.lifeInsuranceApplicationBuyHomeForm)) ? true : false;
        }
    }
]);
