angularApp.controller('lifeInsuranceDidYouKnowController', [
    "$state",
    "$scope",
    "$ionicSlideBoxDelegate",
    "lifeInsuranceApplicationService",

    function(
        $state,
        $scope,
        $ionicSlideBoxDelegate,
        lifeInsuranceApplicationService
    ) {

        var lifeInsuranceDidYouKnowVm = this;

        function initPage() {
            lifeInsuranceDidYouKnowVm.showBack = false;
            lifeInsuranceDidYouKnowVm.showNext = true;
            lifeInsuranceDidYouKnowVm.didyouknowList = [];
            lifeInsuranceDidYouKnowVm.didyouknowListDisclaimer = "";
            didyouknowlist();
        };

       
        lifeInsuranceDidYouKnowVm.goBack = function() {
            $state.go('menu.sbiLifeIntro');
        };

        function didyouknowlist() {
            lifeInsuranceDidYouKnowVm.didyouknowList = lifeInsuranceApplicationService.getDidYouKnow().items;
            lifeInsuranceDidYouKnowVm.didyouknowListDisclaimer = lifeInsuranceApplicationService.getDidYouKnow().disclaimer;
            $ionicSlideBoxDelegate.update();
            $scope.slideIndex = 0;
            $ionicSlideBoxDelegate.start();
        };


        // On click of "Help me choose" button
        lifeInsuranceDidYouKnowVm.helpMeChoose = function() {
            if (!lifeInsuranceApplicationService.getHelpMeChoose()) {
                lifeInsuranceApplicationService.getWelcomeText().then(function(data) {
                    lifeInsuranceApplicationService.setHelpMeChoose(data.message);
                    $state.go('menu.helpMeChoosePolicy');
                });
            } else {
                $state.go('menu.helpMeChoosePolicy');
            }
        };


        lifeInsuranceDidYouKnowVm.previous = function() {
            $ionicSlideBoxDelegate.previous();
        };


        lifeInsuranceDidYouKnowVm.next = function() {
            $ionicSlideBoxDelegate.next();
        };


        lifeInsuranceDidYouKnowVm.slideChanged = function(index) {
    
        };


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


    }
]);
