angularApp.controller('lifeInsuranceIntroController', [
    "$scope",
    "$state",
    "lifeInsuranceApplicationService",
    "homeScreenService",
    "$ionicHistory","getAccountDetailsService",


    function($scope,
        $state,
        lifeInsuranceApplicationService,
        homeScreenService,
        $ionicHistory,getAccountDetailsService) {

        var lifeInsuranceIntroVm = this;


        function initPage() {
            if (!lifeInsuranceIntroVm.consentText) {
                lifeInsuranceApplicationService.getConsentText().then(function(data) {
                    lifeInsuranceIntroVm.consentText = data.message;
                    if (!lifeInsuranceIntroVm.getAddress) {
                        lifeInsuranceApplicationService.getConsentProceedAddressText().then(function(data) {
                            lifeInsuranceIntroVm.getAddress = data.message;
                        });
                    }
                });
            }
            lifeInsuranceIntroVm.isBackCheck=homeScreenService.isBackCheck;
            homeScreenService.isBackCheck	=false;
        };


        lifeInsuranceIntroVm.goBack = function() {
          if(homeScreenService.ishamMenu===true){
            //$state.go("menu.homeScreen");
            $ionicHistory.goBack();
            homeScreenService.ishamMenu=false;
          }
          else{
            $state.go('menu.generalInsurance', {backInsurance : true});
          }
        };

        // on click of "Did you know" button
        $scope.onClickLetsBegin = function() {
            getAccountDetailsService.accountOverviewData.isPolicyRenewal=false;
            lifeInsuranceApplicationService.getJourneyMasterFromCloud().then(function(data) {
                lifeInsuranceApplicationService.getDidYouKnowList().then(function(data) {
                    lifeInsuranceApplicationService.setDidYouKnow(data);
                    $state.go('menu.lifeInsuranceDidYouKnow');
                });
            });
        };

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
