angularApp.controller('liForm_AdditionalDetailsController', [
    "$state",
    "$scope",
    "lifeInsuranceBasicApplicationService",
    "validateService",
    "lifeInsuranceCommonService",
    "suggestedPlansDetailsService",
    "LiConstant",


    function(
        $state,
        $scope,
        lifeInsuranceBasicApplicationService,
        validateService,
        lifeInsuranceCommonService,
        suggestedPlansDetailsService,
        LiConstant) {

        var liForm_AdditionalDetailsVm = this;
        liForm_AdditionalDetailsVm.validateService = validateService;
        var addQuestions;

        function initPage() {

            liForm_AdditionalDetailsVm.showBack = true;
            liForm_AdditionalDetailsVm.showNext = true;
            liForm_AdditionalDetailsVm.disableBack = false;
            liForm_AdditionalDetailsVm.disableNext = false;
            liForm_AdditionalDetailsVm.addAnswer = [];
            liForm_AdditionalDetailsVm.sub = [];

            liForm_AdditionalDetailsVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;

            liForm_AdditionalDetailsVm.perDays = ['0', '10', '20', '30', '40', '50', '60', '70', '80', '90'];
            liForm_AdditionalDetailsVm.gender = lifeInsuranceBasicApplicationService.getPersonalDetails1().gender.key;
            liForm_AdditionalDetailsVm.maxSince = lifeInsuranceBasicApplicationService.getPersonalDetails1().age;

            getMasterDataAdd();

            if (lifeInsuranceCommonService.isFromRetrieveApplication()) {
                var commonQuestionLength = lifeInsuranceBasicApplicationService.getMedicalQuestions().commonQues.length;
                lifeInsuranceBasicApplicationService.setCommonQuestionLength(commonQuestionLength);
                liForm_AdditionalDetailsVm.proposerGender = lifeInsuranceBasicApplicationService.getPersonalDetails1().gender.key;
                var totalLength;
                if (liForm_AdditionalDetailsVm.proposerGender == 'F') {
                    var femaleQuestionLength = lifeInsuranceBasicApplicationService.getMedicalQuestions().femaleAdditionalQues.length;
                    lifeInsuranceBasicApplicationService.setFemaleQuestionLength(femaleQuestionLength);
                    totalLength = commonQuestionLength + femaleQuestionLength;
                } else {
                    totalLength = commonQuestionLength;
                };
                lifeInsuranceBasicApplicationService.setTotalLength(totalLength);
                prepopulate();
            } else if (lifeInsuranceBasicApplicationService.gettotalLength()) {
                prepopulate();
            } else {
                firstpopulate();
            }
        }


        liForm_AdditionalDetailsVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if (result) {
                    $state.go("menu.generalInsurance");
                }
            });
        };

        var firstpopulate = function() {
            var com = lifeInsuranceBasicApplicationService.getcommonQuestionLength();
            if (lifeInsuranceBasicApplicationService.getfemaleQuestionLength()) {
                var fem = lifeInsuranceBasicApplicationService.getfemaleQuestionLength();
                var start = parseInt(fem) + parseInt(com);

            } else {
                var start = parseInt(com);
            }
            addQuestions = lifeInsuranceBasicApplicationService.getMedicalQuestions().additionalQues;
            var total = parseInt(addQuestions.length) + start;
            var k = 0;
            var i;
            for (i = start; i < total; i++, k++) {
                if (addQuestions[k].quesType == '1') {
                    liForm_AdditionalDetailsVm.addAnswer[k] = '';
                } else {
                    liForm_AdditionalDetailsVm.addAnswer[k] = undefined;

                }
                liForm_AdditionalDetailsVm.sub[k] = {};
                liForm_AdditionalDetailsVm.sub[k].details = [];
                for (var l = 0; l < addQuestions[k].subQues.length; l++) {
                    if (addQuestions[k].subQues[l].quesType == '2') {
                        liForm_AdditionalDetailsVm.sub[k].details[l] = undefined;
                    } else if (addQuestions[k].subQues[l].quesType == '1') {
                        liForm_AdditionalDetailsVm.sub[k].details[l] = '';
                    } else if (addQuestions[k].subQues[l].quesType == '3') {
                        liForm_AdditionalDetailsVm.sub[k].details[l] = '';
                    }
                }
            }
        }

        function getMasterDataAdd() {

            var response = lifeInsuranceBasicApplicationService.getMedicalQuestions().additionalQues;
            liForm_AdditionalDetailsVm.addQuestion = response;
        };

        var prepopulate = function() {
            var preMedical = lifeInsuranceBasicApplicationService.getMedicalHistory().questions;
            var start = lifeInsuranceBasicApplicationService.gettotalLength();
            var total = lifeInsuranceBasicApplicationService.getMedicalQuestions().additionalQues.length + start;
            var k = 0;
            var i;
            for (i = start; i < total; i++, k++) {
                liForm_AdditionalDetailsVm.addAnswer[k] = preMedical[i].ans;
                liForm_AdditionalDetailsVm.sub[k] = {};
                liForm_AdditionalDetailsVm.sub[k].details = [];
                for (var l = 0; l < preMedical[i].subAns.length; l++) {

                    if (preMedical[i].subAns[l].ans) {

                        liForm_AdditionalDetailsVm.sub[k].details[l] = preMedical[i].subAns[l].ans;
                    }
                }
            }
            return liForm_AdditionalDetailsVm;
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });


        function validateForm() {

            liForm_AdditionalDetailsVm.liForm_AdditionalDetailsVmForm = {};
            liForm_AdditionalDetailsVm.liForm_AdditionalDetailsVmForm.test = [];
            liForm_AdditionalDetailsVm.liForm_AdditionalDetailsVmForm.sub = [];
            var isValid = true;

            for (var i = 0; i < liForm_AdditionalDetailsVm.addQuestion.length; i++) {
                liForm_AdditionalDetailsVm.liForm_AdditionalDetailsVmForm.sub[i] = {};
                liForm_AdditionalDetailsVm.liForm_AdditionalDetailsVmForm.sub[i].details = [];

                if (liForm_AdditionalDetailsVm.addQuestion[i].quesType == '1') {
                    if (liForm_AdditionalDetailsVm.validateService.isValiddetails(liForm_AdditionalDetailsVm.addAnswer[i])) {
                        liForm_AdditionalDetailsVm.liForm_AdditionalDetailsVmForm.test[i] = liForm_AdditionalDetailsVm.validateService.isValiddetails(liForm_AdditionalDetailsVm.addAnswer[i]);
                        isValid = false;
                    }
                }

                if (liForm_AdditionalDetailsVm.addAnswer[i] == undefined && liForm_AdditionalDetailsVm.addQuestion[i].quesType == '2') {
                    if (liForm_AdditionalDetailsVm.validateService.isValidYesNo(liForm_AdditionalDetailsVm.addAnswer[i])) {
                        liForm_AdditionalDetailsVm.liForm_AdditionalDetailsVmForm.test[i] = liForm_AdditionalDetailsVm.validateService.isValidYesNo(liForm_AdditionalDetailsVm.addAnswer[i]);
                        isValid = false;
                    }
                }

                for (var l = 0; l < liForm_AdditionalDetailsVm.addQuestion[i].subQues.length; l++) {
                    if ((liForm_AdditionalDetailsVm.addQuestion[i].subQues[l].quesType == '2') && (liForm_AdditionalDetailsVm.sub[i].details[l] == undefined) && (liForm_AdditionalDetailsVm.addAnswer[i])) {
                        if (liForm_AdditionalDetailsVm.validateService.isValidYesNo(liForm_AdditionalDetailsVm.sub[i].details[l])) {
                            liForm_AdditionalDetailsVm.liForm_AdditionalDetailsVmForm.sub[i].details[l] = liForm_AdditionalDetailsVm.validateService.isValidYesNo(liForm_AdditionalDetailsVm.sub[i].details[l]);
                            isValid = false;
                        }
                    }

                    if (liForm_AdditionalDetailsVm.addQuestion[i].subQues[l].quesType == '1' && (liForm_AdditionalDetailsVm.addAnswer[i])) {
                        if (liForm_AdditionalDetailsVm.validateService.isValiddetails(liForm_AdditionalDetailsVm.sub[i].details[l])) {
                            liForm_AdditionalDetailsVm.liForm_AdditionalDetailsVmForm.sub[i].details[l] = liForm_AdditionalDetailsVm.validateService.isValiddetails(liForm_AdditionalDetailsVm.sub[i].details[l]);
                            isValid = false;
                        }
                    }
                    if (liForm_AdditionalDetailsVm.addQuestion[i].subQues[l].quesType == '3' && (liForm_AdditionalDetailsVm.addAnswer[i])) {
                        if (liForm_AdditionalDetailsVm.validateService.isValiddetails(liForm_AdditionalDetailsVm.sub[i].details[l])) {
                            liForm_AdditionalDetailsVm.liForm_AdditionalDetailsVmForm.sub[i].details[l] = liForm_AdditionalDetailsVm.validateService.isValiddetails(liForm_AdditionalDetailsVm.sub[i].details[l]);
                            isValid = false;
                        }
                    }
                }
            }
            return isValid;
        }



        liForm_AdditionalDetailsVm.goBacktoPrevious = function() {
            $state.go("menu.liForm_DiseaseDetails");
        }

        liForm_AdditionalDetailsVm.goToNextPage = function() {
            if (validateForm()) {
                lifeInsuranceBasicApplicationService.setMedicalHistoryAdd(liForm_AdditionalDetailsVm);
                lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_ADDITIONAL).then(function() {
                    $state.go("menu.liForm_FamilyHistory");
                });
            }
        }
    }
]);
