angularApp.controller('liForm_MailingInfoAadhaarScanController', ["$state",
    "$scope", 
    "commonAPIService", 
    "lifeInsuranceBasicApplicationService",
    "suggestedPlansDetailsService",

    function(
        $state,
        $scope, 
        commonAPIService, 
        lifeInsuranceBasicApplicationService,
        suggestedPlansDetailsService) {

        var liForm_MailingInfoAadhaarScanVm = this;
        liForm_MailingInfoAadhaarScanVm.commonAPIService = commonAPIService;

        function initPage() {
            liForm_MailingInfoAadhaarScanVm.showBack = true;
            liForm_MailingInfoAadhaarScanVm.showNext = true;
            liForm_MailingInfoAadhaarScanVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;

        }


        liForm_MailingInfoAadhaarScanVm.scanAdhar = function() {
            liForm_MailingInfoAadhaarScanVm.commonAPIService.QRcodescanner(function(dataAdhar) {
                lifeInsuranceBasicApplicationService.setNomineeAadhar(dataAdhar);
                lifeInsuranceBasicApplicationService.setIsAadharScanned(true);
                $state.go("menu.liForm_MailingInfoEnterDetails");
            });
        }


        // On click of Back button
        liForm_MailingInfoAadhaarScanVm.goBacktoPrevious = function() {
            $state.go('menu.liForm_MailingInfo');
        }

        // On click of Next button
        liForm_MailingInfoAadhaarScanVm.goToNextPage = function() {
            lifeInsuranceBasicApplicationService.setBasicApplicationInformation5(liForm_MailingInfoAadhaarScanVm);
            lifeInsuranceBasicApplicationService.setIsAadharScanned(false);
            $state.go('menu.liForm_MailingInfoEnterDetails');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
