angularApp.controller('liForm_ProposersFATCA_CRSController', [
    "$state",
    "$scope",
    "lifeInsuranceBasicApplicationService",
    "validateService",
    "utilityService",
    "suggestedPlansDetailsService",
    "lifeInsuranceCommonService",
    "LiConstant","clickStreamService",

    function(
        $state,
        $scope,
        lifeInsuranceBasicApplicationService,
        validateService,
        utilityService,
        suggestedPlansDetailsService,
        lifeInsuranceCommonService,
        LiConstant,clickStreamService) {

        var liForm_ProposersFATCA_CRSVm = this;
        liForm_ProposersFATCA_CRSVm.validateService = validateService;


        liForm_ProposersFATCA_CRSVm.showBack = true;
        liForm_ProposersFATCA_CRSVm.showNext = true;
        liForm_ProposersFATCA_CRSVm.disableBack = false;
        liForm_ProposersFATCA_CRSVm.disableNext = false;
        liForm_ProposersFATCA_CRSVm.showNatureOfOrg = false;

        function initPage() {
            var personalDetails = lifeInsuranceBasicApplicationService.getPersonalDetails1();
            liForm_ProposersFATCA_CRSVm.data = {};
            liForm_ProposersFATCA_CRSVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
            liForm_ProposersFATCA_CRSVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
            liForm_ProposersFATCA_CRSVm.uinObj = { "uin": liForm_ProposersFATCA_CRSVm.uin };
            liForm_ProposersFATCA_CRSVm.data.proposersName = personalDetails.name.first;
            if (personalDetails.name.middle) {
                liForm_ProposersFATCA_CRSVm.data.proposersName = liForm_ProposersFATCA_CRSVm.data.proposersName + " " + personalDetails.name.middle;
            }
            if (personalDetails.name.last) {
                liForm_ProposersFATCA_CRSVm.data.proposersName = liForm_ProposersFATCA_CRSVm.data.proposersName + " " + personalDetails.name.last;
            }
            liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers = [];

            liForm_ProposersFATCA_CRSVm.data.idProofType = "Aadhaar Card";

            lifeInsuranceBasicApplicationService.getApplicationMasterList(function(response) {
                liForm_ProposersFATCA_CRSVm.CountryOfBirth = response.countryOfBirth;
                liForm_ProposersFATCA_CRSVm.ResidentialStatus = response.residentialStatus;
                liForm_ProposersFATCA_CRSVm.OrganizationNature = response.natureOfOrganisations;
                liForm_ProposersFATCA_CRSVm.Selection = response.curingDocuments;
            });
             liForm_ProposersFATCA_CRSVm.taxPayerLocalMaster = [
                      {
                        "value": "Yes",
                        "key": 'true'
                      },
                      {
                        "value": "No",
                        "key": 'false'
                      }
            ];

            lifeInsuranceBasicApplicationService.getFatcaCrsContent().then(function(response) {
                liForm_ProposersFATCA_CRSVm.crsContent = response.message;
            }, function(error) {});
            if (lifeInsuranceBasicApplicationService.getFatcaDetails()) {
                liForm_ProposersFATCA_CRSVm.data = lifeInsuranceBasicApplicationService.getFatcaDetails();
            }else{
                liForm_ProposersFATCA_CRSVm.data.countryOfbirth = liForm_ProposersFATCA_CRSVm.CountryOfBirth[121];
            }
            if(!liForm_ProposersFATCA_CRSVm.curingDocumentList) {
                lifeInsuranceBasicApplicationService.getCuringDocumentList().then(function(data) {
                    liForm_ProposersFATCA_CRSVm.curingDocumentList = data.message;
                });
            }

            liForm_ProposersFATCA_CRSVm.natureOfOrg = lifeInsuranceBasicApplicationService.getBasicApplicationInformation4();
            if(liForm_ProposersFATCA_CRSVm.natureOfOrg.occupation.key == 'Service'){
                liForm_ProposersFATCA_CRSVm.showNatureOfOrg = true;
            }
        }

        liForm_ProposersFATCA_CRSVm.deleteTaxPayer = function(index) {
            if (index == 1) {
                liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers.pop();
            } else {
                liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers = [];
            }
        };


        liForm_ProposersFATCA_CRSVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                    $state.go("menu.generalInsurance"); 
                }
            });
        };

        liForm_ProposersFATCA_CRSVm.addTaxPayer = function() {
            if (liForm_ProposersFATCA_CRSVm.data.isTaxPayerInOtherCountry == 'true') {
                var taxPayer = {};
                liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers.push(taxPayer);
            } else {
                liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers = [];
            }
        };


        liForm_ProposersFATCA_CRSVm.residentInfo = function() {
            var title = '';
            var template = "<p class='roboto-regular font-content'></p>";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        };

        liForm_ProposersFATCA_CRSVm.crsInfo = function() {
            var title = '';
            var template = "<p class='roboto-regular font-content'></p>";
            var onTap = '';
            var buttontext = "<b>OK</b>";
            utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
        };

        function validationForm() {
            liForm_ProposersFATCA_CRSVm.fatcaCrsDetail = {};
            var isValid = true;

            if (liForm_ProposersFATCA_CRSVm.validateService.isValidName(liForm_ProposersFATCA_CRSVm.data.proposersName)) {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.ProposersName = liForm_ProposersFATCA_CRSVm.validateService.isValidName(liForm_ProposersFATCA_CRSVm.data.proposersName);
                isValid = false;
            }

            if (liForm_ProposersFATCA_CRSVm.validateService.isValidMotherName(liForm_ProposersFATCA_CRSVm.data.motherName)) {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.MothersName = liForm_ProposersFATCA_CRSVm.validateService.isValidMotherName(liForm_ProposersFATCA_CRSVm.data.motherName);
                isValid = false;
            }

            if (liForm_ProposersFATCA_CRSVm.validateService.isValidCKYCNumber(liForm_ProposersFATCA_CRSVm.data.ckycNumber)) {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.ckycNumber = liForm_ProposersFATCA_CRSVm.validateService.isValidCKYCNumber(liForm_ProposersFATCA_CRSVm.data.ckycNumber);
                isValid = false;
            }

            if (liForm_ProposersFATCA_CRSVm.validateService.isValidIdenChoose(liForm_ProposersFATCA_CRSVm.data.idProofType)) {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.IdenChoose = liForm_ProposersFATCA_CRSVm.validateService.isValidIdenChoose(liForm_ProposersFATCA_CRSVm.data.idProofType);
                isValid = false;
            }
            
            if (liForm_ProposersFATCA_CRSVm.validateService.isValidAadharCardNum(liForm_ProposersFATCA_CRSVm.data.idProofNumber)) {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.IdenNum = liForm_ProposersFATCA_CRSVm.validateService.isValidAadharCardNum(liForm_ProposersFATCA_CRSVm.data.idProofNumber);
                isValid = false;
            }


            if (liForm_ProposersFATCA_CRSVm.validateService.isValidSpouseName(liForm_ProposersFATCA_CRSVm.data.spouseName)) {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.spouseName = liForm_ProposersFATCA_CRSVm.validateService.isValidSpouseName(liForm_ProposersFATCA_CRSVm.data.spouseName)
                isValid = false;
            }

            if (liForm_ProposersFATCA_CRSVm.validateService.isValidCountryOfBirth(liForm_ProposersFATCA_CRSVm.data.countryOfbirth)) {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.countryOfbirth = liForm_ProposersFATCA_CRSVm.validateService.isValidCountryOfBirth(liForm_ProposersFATCA_CRSVm.data.countryOfbirth);
                isValid = false;
            }

            if (liForm_ProposersFATCA_CRSVm.validateService.isValidPlaceOfBirth(liForm_ProposersFATCA_CRSVm.data.placeOfbirth)) {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.placeOfbirth = liForm_ProposersFATCA_CRSVm.validateService.isValidPlaceOfBirth(liForm_ProposersFATCA_CRSVm.data.placeOfbirth);
                isValid = false;
            }

            if (liForm_ProposersFATCA_CRSVm.validateService.isValidResedentialStatus(liForm_ProposersFATCA_CRSVm.data.residentialStatus)) {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.residentialStatus = liForm_ProposersFATCA_CRSVm.validateService.isValidResedentialStatus(liForm_ProposersFATCA_CRSVm.data.residentialStatus);
                isValid = false;
            }
            if(liForm_ProposersFATCA_CRSVm.showNatureOfOrg == true){
                if (liForm_ProposersFATCA_CRSVm.validateService.isValidNatureOfOrganization(liForm_ProposersFATCA_CRSVm.data.natureOfOrganization)) {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.natureOfOrganization = liForm_ProposersFATCA_CRSVm.validateService.isValidNatureOfOrganization(liForm_ProposersFATCA_CRSVm.data.natureOfOrganization);
                isValid = false;
                }
            }
            if (liForm_ProposersFATCA_CRSVm.validateService.isValidOtherCountryTaxPayer(liForm_ProposersFATCA_CRSVm.data.isTaxPayerInOtherCountry)) {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.taxPayerOthCountryValid = liForm_ProposersFATCA_CRSVm.validateService.isValidOtherCountryTaxPayer(liForm_ProposersFATCA_CRSVm.data.isTaxPayerInOtherCountry);
                isValid = false;
            }

            if (liForm_ProposersFATCA_CRSVm.data.isTaxPayerInOtherCountry == 'true') {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.CountryofTaxResidency = [];
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.TIN_num = [];
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.IdentificationType = [];
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.ResidenceAddress = [];
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.Business = [];

                for (var count = 0; count < liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers.length; count++) {
                    if (liForm_ProposersFATCA_CRSVm.validateService.isValidCountryOfTaxResident(liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers[count].country)) {
                        liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.CountryofTaxResidency[count] = liForm_ProposersFATCA_CRSVm.validateService.isValidCountryOfTaxResident(liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers[count].country);
                        isValid = false;
                    }

                    if (liForm_ProposersFATCA_CRSVm.validateService.isValidTINNumber(liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers[count].taxIdNumber)) {
                        liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.TIN_num[count] = liForm_ProposersFATCA_CRSVm.validateService.isValidTINNumber(liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers[count].taxIdNumber);
                        isValid = false;
                    }
                    if (liForm_ProposersFATCA_CRSVm.validateService.isValidIdentifyType(liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers[count].idProofType)) {
                        liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.IdentificationType[count] = liForm_ProposersFATCA_CRSVm.validateService.isValidIdentifyType(liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers[count].idProofType);
                        isValid = false;
                    }
                    if (liForm_ProposersFATCA_CRSVm.validateService.isValidResidentialadress(liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers[count].residentAddress)) {
                        liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.ResidenceAddress[count] = liForm_ProposersFATCA_CRSVm.validateService.isValidResidentialadress(liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers[count].residentAddress);
                        isValid = false;
                    }

                    if (liForm_ProposersFATCA_CRSVm.validateService.isValidIdBuisness(liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers[count].business)) {
                        liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.Business[count] = liForm_ProposersFATCA_CRSVm.validateService.isValidIdBuisness(liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers[count].business);
                        isValid = false;
                    }
                }
            }

            if (liForm_ProposersFATCA_CRSVm.validateService.isValidInstructions(liForm_ProposersFATCA_CRSVm.data.isCuringDocument)) {
                liForm_ProposersFATCA_CRSVm.fatcaCrsDetail.instructionsValid = liForm_ProposersFATCA_CRSVm.validateService.isValidInstructions(liForm_ProposersFATCA_CRSVm.data.isCuringDocument);
                isValid = false;
            }
            return isValid;
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        // On click of Back button  
        liForm_ProposersFATCA_CRSVm.goBacktoPrevious = function() {
            lifeInsuranceBasicApplicationService.setIsAadharScanned(false);
            if (lifeInsuranceBasicApplicationService.getNomineeInformation().isNomineeMinor == 'true') {
                $state.go("menu.liForm_appointeeInformation");
            } else { $state.go("menu.liForm_MailingInfoEnterDetails"); }
        }

        // On click of Next button
        liForm_ProposersFATCA_CRSVm.goToNextPage = function() {
            if (validationForm()) {
                clickStreamService.clickStreamData = liForm_ProposersFATCA_CRSVm.selectedProduct;
                var fatcacrs = {};
                fatcacrs.proposersName = liForm_ProposersFATCA_CRSVm.data.proposersName;
                fatcacrs.motherName = liForm_ProposersFATCA_CRSVm.data.motherName;
                fatcacrs.spouseName = liForm_ProposersFATCA_CRSVm.data.spouseName;
                fatcacrs.countryOfbirth = liForm_ProposersFATCA_CRSVm.data.countryOfbirth;
                fatcacrs.placeOfbirth = liForm_ProposersFATCA_CRSVm.data.placeOfbirth;
                fatcacrs.residentialStatus = liForm_ProposersFATCA_CRSVm.data.residentialStatus;
                fatcacrs.natureOfOrganization = liForm_ProposersFATCA_CRSVm.data.natureOfOrganization;
                fatcacrs.ckycNumber = liForm_ProposersFATCA_CRSVm.data.ckycNumber;
                fatcacrs.idProofType = liForm_ProposersFATCA_CRSVm.data.idProofType;
                fatcacrs.idProofNumber = liForm_ProposersFATCA_CRSVm.data.idProofNumber;

                if (liForm_ProposersFATCA_CRSVm.data.isTaxPayerInOtherCountry == 'true') {
                    fatcacrs.isTaxPayerInOtherCountry = "true";
                } else {
                    fatcacrs.isTaxPayerInOtherCountry = "false";
                }
                fatcacrs.otherCountryTaxPayers = liForm_ProposersFATCA_CRSVm.data.otherCountryTaxPayers;
                fatcacrs.isCuringDocument = liForm_ProposersFATCA_CRSVm.data.isCuringDocument;

                lifeInsuranceBasicApplicationService.setFATCACRSinfo(fatcacrs);

                lifeInsuranceBasicApplicationService.getMasterDataHealth(liForm_ProposersFATCA_CRSVm.uinObj).then(function(data) {
                    lifeInsuranceBasicApplicationService.setMedicalQuestions(data);
                    lifeInsuranceBasicApplicationService.saveApplication(LiConstant.journeyCommonId.APP_FATCA).then(function() {
                        $state.go('menu.retireSmartMedicalHistory', { start: 0 });
                    });
                });
            }
        }
    }
]);
