angularApp.controller('lifeInsuranceDocumentsReceivedController', ["$state",
    "$scope",
    "lifeInsuranceBasicApplicationService",
    "suggestedPlansDetailsService",


    function(
        $state,
        $scope,
        lifeInsuranceBasicApplicationService,
        suggestedPlansDetailsService
    ) {


        var lifeInsuranceDocumentsReceivedVm = this;

        function initPage() {

            lifeInsuranceDocumentsReceivedVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;

            lifeInsuranceDocumentsReceivedVm.showBack = false;
            lifeInsuranceDocumentsReceivedVm.showNext = true;

            var response = lifeInsuranceBasicApplicationService.getSubmitApplicationResponse();
            lifeInsuranceDocumentsReceivedVm.proposalNo = response.proposalNo;
        }


        // on click of next page
        lifeInsuranceDocumentsReceivedVm.goToNextPage = function() {
            $state.go('menu.accountOverviewMyBalance');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);


