angularApp.controller('lifeInsurancePaymentSuccessController', [
    "$state",
    "$scope",
    "lifeInsuranceBasicApplicationService",
    "lifeInsuranceApplicationService",
    "suggestedPlansDetailsService",
    "$filter","clickStreamService",


    function(
        $state,
        $scope,
        lifeInsuranceBasicApplicationService,
        lifeInsuranceApplicationService,
        suggestedPlansDetailsService,
        $filter,clickStreamService) {


        var lifeInsurancePaymentSuccessVm = this;

        function initPage() {
            lifeInsurancePaymentSuccessVm.msg2 = "Your transaction is successful.";

            lifeInsurancePaymentSuccessVm.uin = suggestedPlansDetailsService.getCurrentSugestedProduct().uin;
            lifeInsurancePaymentSuccessVm.selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct().planName;
            var details = lifeInsuranceApplicationService.getPersonalDetails();
            var name = details.name.first;

            if (details.name.middle) {
                name += ' ' + details.name.middle;
            }

            if (details.name.last) {
                name += ' ' + details.name.last;
            }


            lifeInsurancePaymentSuccessVm.msg1 = "Congrats " + name + "!";

            var selectedProduct = suggestedPlansDetailsService.getCurrentSugestedProduct();

            var paymentRequest = lifeInsuranceBasicApplicationService.getPayment();
            lifeInsurancePaymentSuccessVm.successMessage1 = {
                "proposalNo": paymentRequest.proposalNumber,
            };
        }

        lifeInsurancePaymentSuccessVm.gotoNextPage = function() {
            clickStreamService.clickStreamData = lifeInsurancePaymentSuccessVm.selectedProduct;
            $state.go('menu.accountOverviewMyBalance');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
