///'use strict';

angularApp.controller('planDetailsController1', ["$timeout", "$state", "$scope", "$translate",
    function($timeout, $state, $scope, $translate) {

        //functions, variables that can be accessed from the HTML come here
        var planDetailsVm = this;
        //private methods section start
        function initPage() {
            planDetailsVm.showBack = false;
            planDetailsVm.showNext = true;
            planDetailsVm.showContect = 0;

            planDetailsVm.welcomeGift = "E-Gift Voucher worth ₹ 3,000 from any of the following brands: Yatra, " +
                "Hush Puppies /Bata, Marks & Spencer, Westside, Shoppers Stop";

            planDetailsVm.Plan1 = {
                PlanType: "SBI Life- Smart Money Back Gold",
                planUINNumber: "111N096V001",
                planDesc: "A traditional life insurance, You are eligible for this card with Credit Limit of ₹ 1,00,000.",
                imgSrc: 'img/generalInsurance/generalInsurance.png'
            }
        }

        //private methods section end

        planDetailsVm.buyNow = function() {
            $state.go('menu.premiumCalculation');
        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            //To Do
        });

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {
            //any cleanup needs to be done here: executes everytime when page is left
        });
        return this;
    }
]);
