//'use strict';

angularApp.controller('premiumCalculationController', ["$timeout",
    "$state",
    "$scope",
    "$translate",
    "lifeInsuranceCommonService",


    function($timeout,
        $state,
        $scope,
        $translate,
        lifeInsuranceCommonService) {

        var premiumCalculationVm = this;

        function initPage() {
            premiumCalculationVm.Relationships = [
                { "relation": "Wife" },
                { "relation": "Son" },
                { "relation": "Daughter" }
            ];
            premiumCalculationVm.Gender = [
                { "gender": "Male" },
                { "gender": "Female" },
            ];

            premiumCalculationVm.PolicyTerm = [
                { "pTerm": "10 Years" },
                { "pTerm": "15 Years" },
            ];

            premiumCalculationVm.PlanOption = [
                { "pOption": "Regular Premimum" },
                { "pOption": "Test Premimum" },
            ];

            premiumCalculationVm.PremiumFrequency = [
                { "pFrequency": "Yearly" },
                { "pFrequency": "Quterly" },
            ];

            premiumCalculationVm.showBack = true;
            premiumCalculationVm.showNext = true;
            premiumCalculationVm.disableBack = false;
            premiumCalculationVm.disableNext = false;



            premiumCalculationVm.birthdate = "";
        }

        $scope.$on('$ionicView.loaded', function() {
            initPage();
        });

        premiumCalculationVm.closeJourney = function() {
            lifeInsuranceCommonService.closePopUp().then(function(result) {
                if(result) {
                   $state.go("menu.generalInsurance"); 
                }
            });
        };

        premiumCalculationVm.goBacktoPrevious = function() {
            //To do
            $state.go("menu.planDetails");
        }

        premiumCalculationVm.goToNextPage = function() {
            $state.go("menu.premiumCalculation2");
            //To do
        }
    }
]);
