angularApp.controller('productNotSaleOnAppController', [
    "$state",
    "$scope",
    "suggestedPlansDetailsService",

    function(
        $state,
        $scope,
        suggestedPlansDetailsService) {

        //functions, variables that can be accessed from the HTML come here
        var productNotSaleOnAppVm = this;

        //private methods section start
        function initPage() {
            if (!productNotSaleOnAppVm.content) {
                suggestedPlansDetailsService.getProductNotSold().then(function(data) {
                    productNotSaleOnAppVm.content = data.message;
                });
            }
        }

        //private methods section end
        //public functions start
        productNotSaleOnAppVm.onClickOk = function() {
            $state.go('menu.suggestedPlans');
        }


        productNotSaleOnAppVm.goBack = function() {
            $state.go('menu.suggestedPlans');
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
