//'use strict';

angularApp.service('aadharScanService',
    function ($q, utilityService) {

        //public functions start
        this.connectToServer = function () {

            WL.App.getServerUrl(function (url) {

            });

            var q = $q.defer();
            WLAuthorizationManager.obtainAccessToken()
                .then(
                function (accessToken) {
                    var resp = {};
                    resp.title = "Yay!";
                    resp.status = "Connected to MobileFirst Server";
                    resp.token = accessToken;
                    q.resolve(resp);
                },
                function (error) {
                    var resp = {};
                    resp.title = "Bummer...";
                    resp.status = "Failed to connect to MobileFirst Server";
                    resp.error = error;
                    q.reject(resp);
                }
                );
            return q.promise;
        };
        //public functions end

        //private functions start
        this.getAadhaarDetails = function (adharNo) {
            var q = $q.defer();
            AdapterUtils.getData("adapters/AccountOpeningAdapter/adharcard/" + adharNo, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //private functions end
        return this;
    });
