angularApp.controller('paymentCompleteController', [
    "$state",
    "$scope",
    "liPolicyPaymentService",
    "linkingLIPolicyService","getAccountDetailsService",

    function(
        $state,
        $scope,
        liPolicyPaymentService,
        linkingLIPolicyService,getAccountDetailsService) {


        var paymentCompleteVm = this;

        function initPage() {

            var policy = linkingLIPolicyService.getMyPolicyDetails();
            var renewalDetails = liPolicyPaymentService.getPolicyRenewalDetails();
            var paymentResponse = liPolicyPaymentService.getpayRenewalResponse();

            paymentCompleteVm.payNowComplitedRespoData = {
                transactionId: paymentResponse.siRefNumber,
                sumReceived: renewalDetails.grossAmount,
                policyNo: policy.policyDetails.policyNumber,
            };

            liPolicyPaymentService.getPayRenewalMessage().then(function(data) {
                paymentCompleteVm.note = data.message;
            });
        };

        //go next 
        paymentCompleteVm.goNext = function() {
            getAccountDetailsService.accountOverviewData="";
            $state.go("menu.accountOverviewMyBalance");
        };

        paymentCompleteVm.goBack = function() {
            $state.go("menu.paymentSummary");
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
