angularApp.controller('ssPolicyFeaturesController', [
    "$state", 
    "$scope", 
    "validateService",
    "utilityService",
    "sampoornSurakshaService","$ionicHistory",
    function($state, 
        $scope, 
        validateService,
        utilityService,
        sampoornSurakshaService,
        $ionicHistory) {


        var ssPolicyFeaturesVm = this;

        function initPage() {
            ssPolicyFeaturesVm.showBuyNow = sampoornSurakshaService.getBuyNow();
            ssPolicyFeaturesVm.policyFeatures = sampoornSurakshaService.getPolicyDetails();
            ssPolicyFeaturesVm.showCategory = ssPolicyFeaturesVm.policyFeatures.planFeatures[0];
        }

        ssPolicyFeaturesVm.goToPremiumPage = function(){
            sampoornSurakshaService.getPremiumAndNomineeInfo().then(function(data) {
                sampoornSurakshaService.clearAll();
                sampoornSurakshaService.setPremiumDetails(data);
                $state.go('menu.ssPremiumCalculation');
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        ssPolicyFeaturesVm.goBack = function(){
            if(sampoornSurakshaService.isFromPapl){
                sampoornSurakshaService.isFromPapl = false;
                $ionicHistory.goBack(-1);
            }else if(ssPolicyFeaturesVm.showBuyNow){
                $state.go('menu.homeScreen');
            }else{
                $state.go('menu.ssPremiumCalculation');
            }
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

    }
]);
