angularApp.controller('ssRenewalController', [
    "$state", 
    "$scope",
    "sampoornSurakshaService",
    "$ionicPopup",
    "$ionicPopover",
    "utilityService",
    "$filter",
    "customerInfoService",
    "getAccountDetailsService",
    "openUrlInAppbroswerService",
    "irctcService",
    "clickStreamService",
    function($state, 
        $scope,
        sampoornSurakshaService,
        $ionicPopup,
        $ionicPopover,
        utilityService,
        $filter,
        customerInfoService,
        getAccountDetailsService,
        openUrlInAppbroswerService,
        irctcService,
        clickStreamService) {

        var ssRenewalVm = this;

        ssRenewalVm.initPage = function(){
            ssRenewalVm.isScheduled = sampoornSurakshaService.getRenewalDetails().isScheduled;
            if(!ssRenewalVm.isScheduled){
                ssRenewalVm.footerText  = "Pay Now";
            }else{
                ssRenewalVm.footerText  = "Submit";
            }
            ssRenewalVm.showSelect = true;
            ssRenewalVm.lifeCover = sampoornSurakshaService.getRenewalDetails().policyDetails.sumAssured;
            ssRenewalVm.gst = sampoornSurakshaService.getRenewalDetails().accountDetails.gst;
            ssRenewalVm.totalpremium = sampoornSurakshaService.getRenewalDetails().accountDetails.grossPremium;
            ssRenewalVm.basicPremium = sampoornSurakshaService.getRenewalDetails().accountDetails.basePremium;
            ssRenewalVm.name = sampoornSurakshaService.getRenewalDetails().policyDetails.name;
            ssRenewalVm.startDate = sampoornSurakshaService.getRenewalDetails().policyDetails.renewalDate;
            ssRenewalVm.endDate = sampoornSurakshaService.getRenewalDetails().policyDetails.endDateRenewal;
            ssRenewalVm.status = sampoornSurakshaService.getRenewalDetails().policyDetails.status;
            ssRenewalVm.autoRenew = sampoornSurakshaService.getRenewalDetails().policyDetails.autoRenewal;
            ssRenewalVm.groups = [{
                "name" : "Policy Details"
            }];
            ssRenewalVm.accList = sampoornSurakshaService.getRenewalDetails().accountDetails.accList;
            ssRenewalVm.dueDate = sampoornSurakshaService.getRenewalDetails().policyDetails.renewalDate;
            sampoornSurakshaService.formPopUpTemplate();
            ssRenewalVm.amountDue = sampoornSurakshaService.getRenewalDetails().accountDetails.grossPremium;
        }

        ssRenewalVm.showPop = function(){
			if(ssRenewalVm.accList && ssRenewalVm.accList.length > 0){
                ssRenewalVm.popUpTemplate = sampoornSurakshaService.formPopUpTemplate("ssRenewalVm.accList","ssRenewalVm");
                ssRenewalVm.popUp = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                    template: ssRenewalVm.popUpTemplate,
                    scope: $scope
                });
            }
		}

        ssRenewalVm.goBack = function(){
            getAccountDetailsService.tabIndex.tabIndex = 4;
            $state.go('menu.accountOverviewMyBalance');
        }

        ssRenewalVm.openInfo = function($event){
            ssRenewalVm.leftStyle = "left : " + ($event.clientX - 30) + "px";
			ssRenewalVm.template = '<ion-popover-view class="loginnewarrow hmbr-info edu-fraudemergencypopovernew hmbr-cif-info nfs-popover-height" id="runtimeHeight" >' + '<div class="hmbr-arrow-upnew" style="{{ssRenewalVm.leftStyle}}"></div>' + '<a class="iconsubtext closeinfobutton float-right" id="CALL_ANC" click-stream="click" ng-click="ssRenewalVm.closePopover()">' + '<i class="ico-close ver-align-middle"></i>' + '</a>' + '<ion-content class="col-90 nfs-popover">' +
			'<div id="renderHeight" class="text-left padding-left-10 padding-right-10 font-size-12">'+
            '<div ng-class="tipClass"><div class="row font-size-12">'+
							    '<div class="col-md-8">'+
								  '<p class="test ss-m-b">PDF Password Hint Eg.</p>'+
								  '<p class="ss-m-b">Date of birth + !  +  Mobile number = Password</p><p>'+								  
								  '<span class="ss-dashed-border">30Mar</span>ch + '+
								  '<span class="ss-dashed-border ss-p-l-r-3">!</span>  +  '+
								  '880044 <span class="ss-dashed-border">6047</span> = '+
								  '<span class="ss-dashed-border">30Mar!6047</span></p></div></div><div class="tooltip-arrow"></div></div>'
            +'</div>' + '</ion-content>' + '</ion-popover-view>';
			$scope.popover = $ionicPopover.fromTemplate(ssRenewalVm.template, {
				scope: $scope
			});
			$scope.popover.show($event);
        }

        ssRenewalVm.closePopover = function(){
			$scope.popover.hide();
		}

        ssRenewalVm.getAutoRenewalTnC = function(){
            sampoornSurakshaService.getAutoRenewal().then(function(data) {
                var title = "Auto Renewal Declaration";
                var buttontext = "OK";
                var detail = data;
                sampoornSurakshaService.displayPopUp(title, detail, buttontext,function(){});
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        ssRenewalVm.getDeclaration = function(){
            sampoornSurakshaService.getCustomerDeclaration().then(function(data) {
                var title = "Customer Declaration";
                var buttontext = "OK";
                var htmlObject = document.createElement('div');
                htmlObject.innerHTML = data;
                var fragment = document.createDocumentFragment(); 
                fragment.appendChild(htmlObject);
                fragment.getElementById('cusname').innerText = customerInfoService.customer ? customerInfoService.customer.name : "";
                fragment.getElementById('cusmobilenumber').innerText = customerInfoService.customer ? $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4) : "";
                var detail = fragment.firstChild.innerHTML;
                sampoornSurakshaService.displayPopUp(title, detail, buttontext,function(){});
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });            
        }

        ssRenewalVm.getTNC = function(){
            sampoornSurakshaService.getTermsAndConditions().then(function(data) {
                var title = "Terms and Conditions";
                var buttontext = "OK";
                var detail = data;
                sampoornSurakshaService.displayPopUp(title, detail, buttontext,function(){});
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        ssRenewalVm.sendEmail = function(){
            var request = {
                "isEmail": true,
				"coiNumber" : sampoornSurakshaService.getRenewalDetails().policyDetails.coiNumber,
                "type": "sampoornSuraksha1"
            }
            sampoornSurakshaService.getDocument(request).then(function(data) {
                var alertPopup = $ionicPopup.alert({
                    template: "<p class='fontWeight600 fss-col-verify font-size-16'>Email has been sent successfully</p>"
                });
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        ssRenewalVm.goToNextPage = function(){
            if(!ssRenewalVm.isScheduled){
                if(parseFloat(ssRenewalVm.accountBalance) < parseFloat(ssRenewalVm.totalpremium)){ 
                    utilityService.showErrorMessage("Currently your account is having insufficient balance. Please keep sufficient balance to renew your policy.");
                }else{
                    var request = {
                        "createPolicyRequest": {                     
                            "referralCode": ssRenewalVm.referralCode,               
                            "autoRenewal": ssRenewalVm.autoRenewFlag ? "Y" : "N",        
                            "fromAccount": ssRenewalVm.accountNumber,
                            "oldCOI": sampoornSurakshaService.getRenewalDetails().policyDetails.coiNumber
                        }
                    }
                    sampoornSurakshaService.renewalRequest = request;
                    sampoornSurakshaService.generateSSRenewOTP(request).then(function(data) {
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "OTP_REQ"));
                        $state.go('menu.ssRenewalOtp');
                    },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                    }); 
                }                
            }else if(ssRenewalVm.isScheduled){
                var request = {
                    "coiNumber": sampoornSurakshaService.getRenewalDetails().policyDetails.coiNumber,
                    "autoRenewalFlag": ssRenewalVm.autoRenewFlag ? "Y" : "N",
                    "accountNumber": ssRenewalVm.accountNumber,
                    "referralCode": ssRenewalVm.referralCode 
                }
                sampoornSurakshaService.scheduleRenewalPayment(request).then(function(data) {
                    clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "SCH_REQ"));
                    sampoornSurakshaService.isRenewalSuccess = true;
                    $state.go('menu.ssRenewalRequest');
                },function(error){
                    sampoornSurakshaService.isRenewalSuccess = false;
                    $state.go('menu.ssRenewalRequest');
                }); 

            }
        }

        ssRenewalVm.close = function(index){
            ssRenewalVm.popUp.close();
            ssRenewalVm.accountBalance = ssRenewalVm.accList[index].accountBalance;
            ssRenewalVm.accType = ssRenewalVm.accList[index].accountType;
            ssRenewalVm.accountNumber = ssRenewalVm.accList[index].accountNumber;
            ssRenewalVm.selectedAccount = ssRenewalVm.accList[index];
			ssRenewalVm.showSelect = false;
        }

        ssRenewalVm.toggleGroup = function(group) {
            if (ssRenewalVm.isGroupShown(group)) {
                ssRenewalVm.shownGroup = null;
            }else{
                ssRenewalVm.shownGroup = group;
            }
        }

        ssRenewalVm.isGroupShown = function(group) {
            return ssRenewalVm.shownGroup === group;
        };

        ssRenewalVm.viewCOI = function(){
            var request = {
                "isEmail": false,
				"coiNumber" : sampoornSurakshaService.getRenewalDetails().policyDetails.coiNumber,
                "type": "sampoornSuraksha1"
            }

            sampoornSurakshaService.getDocument(request).then(function(data) {
                var filename =  data.fileName+'.pdf';
                var content =  data.pdf;
                var contentType = "application/pdf";
                if(utilityService.isAndroidPlatform()){
                    ssRenewalVm.android = true;
                    ssRenewalVm.folderpath = cordova.file.externalRootDirectory;
                }
                if(utilityService.isIOSPlatform()){
                    ssRenewalVm.folderpath = cordova.file.applicationDirectory;
                }
                irctcService.savebase64AsPDFNew(ssRenewalVm.folderpath,filename,content,contentType);
                if(utilityService.isIOSPlatform()){
                var finalObject = {"folderpath":ssRenewalVm.folderpath,"filename":filename};
                openUrlInAppbroswerService.openUrl("data:application/pdf;base64,"+content+"","");
                }
                if(ssRenewalVm.android) {
                    var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="DOWNLOADFDRECEIPT" translate-values="{folderpath:ssRenewalVm.folderpath}"></div>';
                        ssRenewalVm.downloadPopup = $ionicPopup.show({
                            title: '',
                            template: template,
                            scope: $scope,
                            cssClass: 'my-custom-popup',
                            buttons: [{
                                text:'OK',
                                type: 'button-assertive',
                                onTap: function() { 
                                    ssRenewalVm.downloadPopup.close();

                                }
                            }],
                        });
                
                }
                //ssRenewalVm.successPopup.close();
            },function(error){
                utilityService.showErrorMessage(error.responseMessage);
            }); 
        }
        
        $scope.$on('$ionicView.beforeEnter', function() {
            ssRenewalVm.initPage();
        });

    }
]);
