angularApp.controller('ssRenewalRequestController', [
    "$state", 
    "$scope",
    "sampoornSurakshaService",
    "getAccountDetailsService",
    function($state, 
        $scope,
        sampoornSurakshaService,
        getAccountDetailsService) {

        var ssRenewalRequestVm = this;

        ssRenewalRequestVm.initPage = function(){
           ssRenewalRequestVm.isSuccess = sampoornSurakshaService.isRenewalSuccess;
           if(ssRenewalRequestVm.isSuccess){
               ssRenewalRequestVm.dueDate = sampoornSurakshaService.getRenewalDetails().policyDetails.renewalDate;
               ssRenewalRequestVm.totalPremium = sampoornSurakshaService.getRenewalDetails().accountDetails.grossPremium;
               if(getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy){
			    for (var i=0; i < getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy.length; i++) {
					if (getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy[i].coiNumber === sampoornSurakshaService.getRenewalDetails().policyDetails.coiNumber) {
						getAccountDetailsService.accountOverviewData.sampoornaSurakshaPolicy[i].policyPaymentFlag = "";
					}
				}
		   }
           }
        }

        ssRenewalRequestVm.tryAgain = function(){
            getAccountDetailsService.tabIndex.tabIndex = 4;
            $state.go('menu.accountOverviewMyBalance');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            ssRenewalRequestVm.initPage();
        });

    }
]);
