angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            $stateProvider                              
                .state('menu.pablChoose', {
                    url: '/pablChoose',
                    data: {
                        pageId: 'PABL_CHOOSE'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/PABL/pablChoose.html',
                            controller: 'pablChooseController',
                            controllerAs: 'pablChooseVm'
                        }
                    }
                })

                .state('menu.pablNotInterested', {
                    url: '/pablNotInterested',
                    data: {
                        pageId: 'PABL_NOT_INTERESTED'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/PABL/pablNotInterested.html',
                            controller: 'pablNotInterestedController',
                            controllerAs: 'pablNotInterestedVm'
                        }
                    }
                })

                .state('menu.pablThankYou', {
                    url: '/pablThankYou',
                    data: {
                        pageId: 'PABL_THANK_YOU'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/PABL/pablThankYou.html',
                            controller: 'pablThankYouController',
                            controllerAs: 'pablThankYouVm'
                        }
                    }
                })
            }
        ]);