'use strict';

angularApp.controller('pablThankYouController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "pablService",

    function($state,
        $scope,
        $translate,
        $ionicHistory,        
        pablService) {

        var pablThankYouVm = this;
        pablThankYouVm.submittedData = {};

        pablThankYouVm.initPage = function() {
            pablThankYouVm.getPABLSubmittedData = pablService.getSubmittedData();
            pablThankYouVm.loanDetailsData = pablService.getEligibilityDetailsData();
            pablThankYouVm.crmLeadId = pablThankYouVm.getPABLSubmittedData.crmLeadId;
            pablThankYouVm.crmFlag = pablThankYouVm.getPABLSubmittedData.crmFlag;
            pablThankYouVm.branchName = pablThankYouVm.loanDetailsData.branchName;
            pablThankYouVm.branchCode = pablThankYouVm.loanDetailsData.branchCode;  
        }

        pablThankYouVm.goback = function() {
            $ionicHistory.goBack(-1);
        };

        pablThankYouVm.okClicked = function(){
            $state.go('menu.homeScreen');
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            pablThankYouVm.initPage();
        });

        return this;
    }
]);