angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            $stateProvider                
                .state('menu.clNTBEligibileAmountDetails', {
                    url: '/clNTBEligibileAmountDetails',
                    data: {
                        pageId: 'CL_NTB_AMOUNT'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/carLoan/CL_NTB/clNTBEligibileAmountDetails.html',
                            controller: 'clNTBEligibileAmountDetailsController',
                            controllerAs: 'clNTBEligibileAmountDetailsVm'
                        }
                    }
                })
                .state('menu.clNTBEligibilityCheckDetails', {
                    url: '/clNTBEligibilityCheckDetails',
                    data: {
                        pageId: 'CL_NTB_CHECKS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/carLoan/CL_NTB/clNTBEligibilityCheckDetails.html',
                            controller: 'clNTBEligibilityCheckDetailsController',
                            controllerAs: 'clNTBEligibilityCheckDetailsVm'
                        }
                    }
                })
                .state('menu.clNTBExploreCarLoan', {
                    url: '/clNTBExploreCarLoan',
                    data: {
                        pageId: 'CL_NTB_EXPLORE'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/carLoan/CL_NTB/clNTBExploreCarLoan.html',
                            controller: 'clNTBExploreCarLoanController',
                            controllerAs: 'clNTBExploreCarLoanVm'
                        }
                    }
                })
                .state('menu.clNTBOTPVerification', {
                    url: '/clNTBOTPVerification',
                    data: {
                        pageId: 'CL_NTB_OTP'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/carLoan/CL_NTB/clNTBOTPVerification.html',
                            controller: 'clNTBOTPVerificationController',
                            controllerAs: 'clNTBOTPVerificationVm'
                        }
                    }
                })
                .state('menu.clNTBReferenceDetails', {
                    url: '/clNTBReferenceDetails',
                    data: {
                        pageId: 'CL_NTB_REFERENCE'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/carLoan/CL_NTB/clNTBReferenceDetails.html',
                            controller: 'clNTBReferenceDetailsController',
                            controllerAs: 'clNTBReferenceDetailsVm'
                        }
                    }
                })
                // .state('menu.clNTBRequestCallBack', {
                //     url: '/clNTBRequestCallBack',
                //     data: {
                //         pageId: 'CL_NTB_CALLBACK'
                //     },
                //     cache : false,
                //     views: {
                //         'menuContent': {
                //             templateUrl: 'pages/loans/carLoan/CL_NTB/clNTBRequestCallBack.html',
                //             controller: 'clNTBRequestCallBackController',
                //             controllerAs: 'clNTBRequestCallBackVm'
                //         }
                //     }
                // })
                .state('menu.clNTBSubmitDetails', {
                    url: '/clNTBSubmitDetails',
                    data: {
                        pageId: 'CL_NTB_CSUBMIT'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/carLoan/CL_NTB/clNTBSubmitDetails.html',
                            controller: 'clNTBSubmitDetailsController',
                            controllerAs: 'clNTBSubmitDetailsVm'
                        }
                    }
                })

                .state('menu.clNTBIncomeStmt', {
                    url: '/clNTBIncomeStmt',
                    data: {
                        pageId: 'CL_NTB_INCOME_STMT'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/carLoan/CL_NTB/clNTBIncomeStmt.html',
                            controller: 'clNTBIncomeStmtController',
                            controllerAs: 'clNTBIncomeStmtVm'
                        }
                    }
                })

                 .state('menu.ntbAALandingPage', {
                    url: '/ntbAALandingPage',
                    data: {
                        pageId: 'NTB_AA_LANDING'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/AccountAggregator/ntbAALandingPage.html',
                            controller: 'ntbAALandingPageController',
                            controllerAs: 'ntbAALandingVm'
                        }
                    }
                 })

                  .state('menu.ntbAccountAggregatorList', {
                    url: '/ntbAccountAggregatorList',
                    data: {
                        pageId: 'NTB_AA_LIST'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/AccountAggregator/ntbAccountAggregatorList.html',
                            controller: 'ntbAccountAggregatorListController',
                            controllerAs: 'ntbAccountAggregatorListVm'
                        }
                    }
                 })

                  .state('menu.ntbEnterAccountAggregatorID', {
                    url: '/ntbEnterAccountAggregatorID',
                    data: {
                        pageId: 'NTB_AA_ID'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/AccountAggregator/ntbEnterAccountAggregatorID.html',
                            controller: 'ntbEnterAccountAggregatorIDController',
                            controllerAs: 'ntbEnterAccountAggregatorIDVm'
                        }
                    }
                 })

            }
        ]);