'use strict';

angularApp.service('clNTBCalculatorService',
    function ($q, AdapterUtils, utilityService, constantConfig, $ionicPopup, $state, $ionicScrollDelegate, cryptoService) {

        var clNTBCalculatorService = this;

        var disclaimerNTBAAPopup;
        var consentCounter = 0;

        var loanDetails, referenceStatusData;
        var applicantGender;
        var applicantOccupation;
        var applicantDOB;
        var applicantNMI;
        var applicantExistingEMI;
        var applicantIncomeSource;
        var checkEligiblityResponse = {};
        var checkEligibilityRequest = {};
        var eligibalAmountDetail = {};
        var generateLeadData = {};
        var isCallBackRequest = 'false';
        var contactNumber = '';
        this.trackReferenceData = false;
        this.leadID = '';
        this.leadMobile = '';
        this.isHomeScreenBack = false;
        this.isJourneyCompleted = false;
        this.submitLeadData = {};
        this.isCheckEligibilityBack = false;
        this.applicantData = {};
        this.isCalculatorBack = false;
        this.isSubmitDetailsBack = false;
        this.selectedCity = {};
        this.selectedloanPurpose = {};
        this.selectedBranch = '';
        this.isAmountBack = false;

        var rateOfInterestMasterDataLists = [];
        var emiNMIRatioMasterDataList = [];
        var staticMasterData = {};
        this.isFromHamburger = false;
        this.isFromNTB = false;
        this.isIdAvailiable = false;
        this.productIDNTBCL = "YONOCARLOAN";
        this.consentReceived = false;
        this.ntbAARespURL = "";
        this.ntbConsentCounter = 0;

        clNTBCalculatorService.clearAll = function () {
            loanDetails = null;
            referenceStatusData = null;
        }

        clNTBCalculatorService.getStaticMasterData = function () {
            return staticMasterData;
        }

        clNTBCalculatorService.setStaticMasterData = function (masterData) {
            staticMasterData = masterData;
        }

        clNTBCalculatorService.setRateOfInterestMasterDataLists = function (data) {
            rateOfInterestMasterDataLists = data;
        }

        clNTBCalculatorService.getRateOfInterestMasterDataLists = function () {
            return rateOfInterestMasterDataLists;
        }

        // eminmi ratio master data list
        clNTBCalculatorService.setEmiNMIRatioMasterDataList = function (emiNmi) {
            emiNMIRatioMasterDataList = emiNmi;
        }

        clNTBCalculatorService.getEmiNMIRatioMasterDataList = function () {
            return emiNMIRatioMasterDataList;
        }

        clNTBCalculatorService.clearAll = function () {
            loanDetails = null; referenceStatusData = null;
        }

        // Setter/Getter
        clNTBCalculatorService.getContactNumber = function () {
            return contactNumber;
        }
        clNTBCalculatorService.setContactNumber = function (val) {
            contactNumber = val;
        }
        clNTBCalculatorService.getIsCallBackRequset = function () {
            return isCallBackRequest;
        }
        clNTBCalculatorService.setIsCallBackRequset = function (val) {
            isCallBackRequest = val;
        }

        clNTBCalculatorService.setReferenceStatusData = function (data) {
            referenceStatusData = data;
        }

        clNTBCalculatorService.getReferenceStatusData = function () {
            return referenceStatusData;
        }

        clNTBCalculatorService.getGenerateLeadData = function () {
            return generateLeadData;
        }
        clNTBCalculatorService.setGenerateLeadData = function (obj) {
            generateLeadData = obj;
        }

        clNTBCalculatorService.getEligibalAmountDetail = function () {
            return eligibalAmountDetail;
        }
        clNTBCalculatorService.setEligibalAmountDetail = function (obj) {
            eligibalAmountDetail = obj;
        }

        clNTBCalculatorService.getCheckEligiblityRequest = function () {
            return checkEligibilityRequest;
        }

        clNTBCalculatorService.setCheckEligiblityRequest = function (data) {
            checkEligibilityRequest = data;
        }

        clNTBCalculatorService.getCheckEligiblityResponse = function () {
            return checkEligiblityResponse;
        }

        clNTBCalculatorService.setCheckEligiblityResponse = function (data) {
            checkEligiblityResponse = data;
        }

        clNTBCalculatorService.getApplicantIncomeSource = function () {
            return applicantIncomeSource;
        }

        clNTBCalculatorService.setApplicantIncomeSource = function (sourc) {
            if (sourc == 'SL') {
                applicantIncomeSource = Salaried;
            } else {
                applicantIncomeSource = Other;
            }
        }

        clNTBCalculatorService.getApplicantExistingEMI = function () {
            return applicantExistingEMI;
        }

        clNTBCalculatorService.setApplicantExistingEMI = function (emi) {
            applicantExistingEMI = emi;
        }

        clNTBCalculatorService.getApplicantDOB = function () {
            return applicantDOB;
        }

        clNTBCalculatorService.setApplicantDOB = function (dob) {
            applicantDOB = dob;
        }

        clNTBCalculatorService.getApplicantNMI = function () {
            return applicantNMI;
        }

        clNTBCalculatorService.setApplicantNMI = function (nmi) {
            applicantNMI = nmi;
        }

        clNTBCalculatorService.setGLLoanDetails = function (data) {
            loanDetails = data;
        };

        clNTBCalculatorService.getGLLoanDetails = function () {
            return loanDetails;
        };

        clNTBCalculatorService.getApplicantGender = function () {
            return applicantGender;
        }

        clNTBCalculatorService.setApplicantGender = function (gen) {
            if (gen == 'F') {
                applicantGender = gen;
            } else {
                applicantGender = 'M';
            }
        }

        clNTBCalculatorService.getApplicantOccupation = function () {
            return applicantOccupation;
        };

        clNTBCalculatorService.setApplicantOccupation = function (occ) {
            applicantOccupation = occ;
        };

        // Validations
        clNTBCalculatorService.updatedigest = function () {
            if (!$scope.$$phase)
                $scope.$apply();
            return;
        }

        clNTBCalculatorService.isValidField = function (obj, field) {
            if (!obj) {
                return 'Please provide ' + field;
            }
            return false;
        };

        clNTBCalculatorService.emiCalculation = function (p, i, t) {
            p = parseInt(p);
            i = parseFloat(i) / 1200;
            t = parseInt(t) * 12;
            var numerator = p * i * Math.pow((1 + i), t);
            var denominator = Math.pow((1 + i), t) - 1;
            var emiAmount = Math.ceil((numerator / denominator));
            return emiAmount;
        }

        clNTBCalculatorService.getPropValue = function (d, l) {
            d = parseInt(d);
            l = parseInt(l);
            var p = d + l;
            return p;
        }

        clNTBCalculatorService.loanAmtCalculation = function (i, t, e) {
            e = parseInt(e) //emi amount
            i = parseFloat(i) / 1200; // interest rate
            t = parseInt(t) * 12; // tenure
            var numerator = e * (Math.pow((1 + i), t) - 1);
            var denominator = i * Math.pow((1 + i), t);
            var loanAmount = Math.ceil(numerator / denominator);
            return loanAmount;
        }

        // API call

        clNTBCalculatorService.calculateAgeProvided = function (maxAge) {
            var year = new Date().getFullYear() - maxAge;
            var month = new Date().getMonth();
            var day = new Date().getDate();
            return new Date(year, month, day);
        }

        clNTBCalculatorService.calculateAge = function (birth) {
            var today = new Date();
            var nowyear = today.getFullYear();
            var nowmonth = today.getMonth();
            var nowday = today.getDate();

            var birthyear = birth.getFullYear();
            var birthmonth = birth.getMonth();
            var birthday = birth.getDate();

            var age = nowyear - birthyear;
            var age_month = nowmonth - birthmonth;
            var age_day = nowday - birthday;

            if (age_month < 0 || (age_month == 0 && age_day < 0)) {
                age = parseInt(age) - 1;
            }
            return age;
        }

        clNTBCalculatorService.calculateNMIToEMIRatio = function (nmi) {
            var annualInCome = 12 * nmi;
            var salaryType = "SL";
            var ratio;

            if (salaryType == "SL") {
                if (annualInCome > 0 || annualInCome <= 120000) {
                    ratio = 20;
                } else if (annualInCome > 120000 || annualInCome <= 300000) {
                    ratio = 30;
                } else if (annualInCome > 300000 || annualInCome <= 500000) {
                    ratio = 55;
                } else if (annualInCome > 500000 || annualInCome <= 800000) {
                    ratio = 60;
                } else if (annualInCome > 800000 || annualInCome <= 1000000) {
                    ratio = 65;
                } else if (annualInCome > 1000000) {
                    ratio = 70;
                }
            }
            return ratio;
        }

        clNTBCalculatorService.totalEligibalEMIAmoutBasedOnEMINMIRatio = function (appNMI, coAppNMI) {
            var totalOfNMI = appNMI + coAppNMI;
            var totalAnnualIncome = totalOfNMI * 12;
            var emiTonmiRatio = clNTBCalculatorService.calculateNMIToEMIRatio(totalAnnualIncome);
            return (totalAnnualIncome * emiTonmiRatio) / 100;
        }

        clNTBCalculatorService.checkWetherEligibalOrNot = function (existingemi, nmi) {
            var totalEMIPaying = existingemi;
            return (clNTBCalculatorService.totalEligibalEMIAmoutBasedOnEMINMIRatio(nmi) >= totalEMIPaying);
        }

        // service call
        clNTBCalculatorService.submitLeadDetails = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/car/submitCLLeadDetails", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        clNTBCalculatorService.getMasterData = function () {
            var q = $q.defer();
            var payload = {};
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/car/getMasterData", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        // get HomeContent
        clNTBCalculatorService.getHomeContent = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/car/fetchGetStartedPageContent", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


        // get lead generate banner
        clNTBCalculatorService.getLeadGenerationBanner = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/car/getCLLeadGenerationBanner", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //get branch list by city api
        clNTBCalculatorService.getBranchListByCity = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getBranchListByCity", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //get city pincode api
        clNTBCalculatorService.getCityByPinCode = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getCityByPinCode", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //get eligibility check 
        clNTBCalculatorService.getEligiblityCheck = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/car/performEligiblityCheck", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //get inner banner 
        clNTBCalculatorService.getBannerExplore = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/OMPAdapter/preLogin/getMerchantsByCategory", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //Generate OTP
        clNTBCalculatorService.generateOTP = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getOTPTokenForNTB", requestData, false).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };

        //Validate OTP
        clNTBCalculatorService.validateOTP = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/validateOTPTokenForNTB", requestData, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };

        clNTBCalculatorService.validateNMIEMI = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/Car/validateNMIEMI", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //submit reference number api
        clNTBCalculatorService.submitReferenceNumber = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/car/getCLLeadContactNumber", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //for reference number
        clNTBCalculatorService.getReferenceNumberStatus = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/car/getCLLeadStatus", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //popup section
        //show popup
        clNTBCalculatorService.showAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {
                            obj.addressChangeFlag = false;
                            obj.resiAddressFlag = "";
                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                        }
                    }
                ];
            }
            else {
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }
            if(imageType && imageType.toLowerCase() == 'error'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            } else if(imageType && imageType.toLowerCase() == 'success'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            }else if(imageType && imageType.toLowerCase() == 'alert'){
                imageType = '<div><img class="approvedIconPosition" alt="" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            }else{
                imageType = "";
            }
            var bhimErrorPopup = $ionicPopup.alert({
                template: '<div class="font-dark-grey">' + imageType + '<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'+ message1 + '</span><div class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">' + message2 + '</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {
            });
        };


        //banner explore popup
        clNTBCalculatorService.getBannerExploreDetails = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {
                            obj.addressChangeFlag = false;
                            obj.resiAddressFlag = "";
                        }
                    },{
                        text: buttontext1 || "",
                        type: 'button-positive',
                        onTap: function () {
                        }
                    }
                ];
            } else {
                btn_array = [
                    {
                        text: "",
                        type: 'button button-icon icon ion-close',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            var bhimErrorPopup = $ionicPopup.alert({
                buttons: btn_array,
                title: message1,
                template: '<div class="roboto-regular font-size-14 color-darkgrey">' +
                    '<div ng-repeat="merchant in merchantData" class="MRCHTLST_DIV" ng-show="!isTopBrands">' +
                    '<div class="mainDivCategories">' +
                    '<div class="bigbox cl_marchent_popup" ng-show="merchant.isShownInMobile" id="MERCHANT_IMG" style= "margin-right: 0px !important;margin-left: 5px !important;">' +
                    '<img class="imagesIndividualCategory textAlignCenter" ng-src="{{merchant.appLogo}}" alt="{{merchant.name}}">' +
                    '<div></div></div>' +
                    '</div>',               
                scope: $scope,
                cssClass: 'bhim-alert-popup hlTermnCondition clExplorePopup',

            });
            bhimErrorPopup.then(function (res) {
            });
        };

        clNTBCalculatorService.openDisclaimerPopup = function ($scope) {
            disclaimerNTBAAPopup = $ionicPopup.show({
                templateUrl: "pages/loans/AccountAggregator/ntbAARedirectionDisclaimerPopup.html",
                title: '<h3 class="popup-title translate="NTB_DISCLR_LBL"></h3><img src="img/OMP/close_btn.PNG" class="close_disclaimer_btn" alt="close_btn"/>',
                scope: $scope,
                cssClass: 'redirectionalDisclaimerPopup'
            });
        };

        clNTBCalculatorService.closeDisclaimerPopup = function ($scope) {
            disclaimerNTBAAPopup.close();
        }

        clNTBCalculatorService.getAAUrl = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/aggregator/getAAUrl", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        clNTBCalculatorService.getConsentStatus = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/aggregator/getConsentStatus", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        clNTBCalculatorService.getDisclaimerContent = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/aggregator/getDisclaimerContent", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        clNTBCalculatorService.extendSession = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/aggregator/dummyCall", {}, false).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        clNTBCalculatorService.finalConsentCheck = function(){
            var SHA512HashedVal = clNTBCalculatorService.productIDNTBCL + clNTBCalculatorService.getGenerateLeadData().mobile + clNTBCalculatorService.getReferenceStatusData().crmLeadID;
            var val = cryptoService.getSHA512EncryptedData(SHA512HashedVal).toString();

            var payload = {
                "productId": clNTBCalculatorService.productIDNTBCL,
                "mobileNumber": clNTBCalculatorService.getGenerateLeadData().mobile,
                "accountID":clNTBCalculatorService.getReferenceStatusData().crmLeadID,
                "val": val
            }
            clNTBCalculatorService.getConsentStatus(payload).then(function (response) {
                clNTBCalculatorService.ntbConsentCounter = consentCounter;
                if(response.consentStatus.toUpperCase() == "ACTIVE"){
                    consentCounter = 0;
                    clNTBCalculatorService.consentReceived = true;
                    clNTBCalculatorService.showAlertPopup("success","Successful!","Thank you for sharing the consent to fetch your bank account statement.","menu.clNTBReferenceDetails","OK","","","");
                }else if(response.consentStatus.toUpperCase() == "REJECTED"){
                    consentCounter = 0;
                    clNTBCalculatorService.consentReceived = false;
                    $state.go('menu.clNTBReferenceDetails');
                }else if(response.consentStatus.toUpperCase() == "PENDING"){
                    consentCounter++;
                    clNTBCalculatorService.ntbConsentCounter = consentCounter;
                    clNTBCalculatorService.consentReceived = false;
                    if(consentCounter === 1){
                        $state.go('menu.clNTBIncomeStmt');
                    }else if (consentCounter === 2){
                        $state.go('menu.ntbAALandingPage');
                    }else{
                        consentCounter = 0;
                        $state.go('menu.clNTBReferenceDetails');
                    }
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });            
        }
        
        clNTBCalculatorService.getNTBCarLoanTnC = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/car/getNtbCLTnC", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        return clNTBCalculatorService;
    });