angularApp.config([
    '$stateProvider',
    function($stateProvider) {
        //Cards start
        $stateProvider
            .state('menu.cardetails', {
                url: '/carDetails',
                data: {
                    pageId: 'CL_CD'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carDetails.html',
                        controller: 'carDetailsController',
                        controllerAs: 'carDetailsVm'
                    }
                }
            })


            .state('menu.carPersonaldetails', {
                url: '/carPersonaldetails',
                data: {
                    pageId: 'CL_CPD'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carPersonalDetails.html',
                        controller: 'carPersonalDetailsController',
                        controllerAs: 'carPersonalDetailsVm'
                    }
                }
            })

            .state('menu.carLoanSelectBranch', {
                url: '/carLoanSelectBranch',
                data: {
                    pageId: 'CL_SELBRNCH'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/clSelectBranch.html',
                        controller: 'clSelectBranchController',
                        controllerAs: 'clSelectBranchVm'
                    }
                }
            })

            .state('menu.carLoanAppStatus', {
                url: '/carLoanAppStatus',
                data: {
                    pageId: 'CL_SELBRNCH'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carAppStatus.html',
                        controller: 'carAppStatusController',
                        controllerAs: 'carAppStatusVm'
                    }
                }
            })

            


            .state('menu.carLoanWorkDetails', {
                url: '/carLoanWorkDetails.html',
                data: {
                    pageId: 'CL_CWD'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanWorkDetails.html',
                        controller: 'carLoanWorkDetailsController',
                        controllerAs: 'carLoanWorkDetailsVm'
                    }
                }
            })


            .state('menu.carLoanCalculator', {
                url: '/carLoanCalculator',
                data: {
                    pageId: 'CL_CL'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanCalculator.html',
                        controller: 'carLoanCalculatorController',
                        controllerAs: 'carLoanCalculatorVm'
                    }
                }
            })


            .state('menu.carLoancalculateEMI', {
                url: '/carLoancalculateEMI',
                data: {
                    pageId: 'CL_CEMI'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoancalculateEMI.html',
                        controller: 'carLoancalculateEMIController',
                        controllerAs: 'carLoancalculateEMIVm'
                    }
                }
            })


            .state('menu.clApplicationStatus', {
                url: '/clApplicationStatus',
                data: {
                    pageId: 'CL_APS'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/clApplicationStatus.html',
                        controller: 'clApplicationStatusController',
                        controllerAs: 'clApplicationStatusVm'
                    }
                }
            })

            .state('menu.carLoanKnowMore', {
                url: '/carLoanKnowMore',
                data: {
                    pageId: 'CL_APS'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/carLoanKnowMore.html',
                        controller: 'carLoanKnowMoreController',
                        controllerAs: 'carLoanKnowMoreVm'
                    }
                }
            })



            .state('menu.cLReferenceNumber', {
                url: '/cLReferenceNumber',
                data: {
                    pageId: 'CL_REF'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/cLReferenceNumber.html',
                        controller: 'cLReferenceNumberController',
                        controllerAs: 'cLReferenceNumberVm'
                    }
                }
            })

              .state('menu.cLExtinginLos', {
                url: '/cLExtinginLos',
                data: {
                    pageId: 'CL_REF'
                },
                cache : false,
                views: {
                    'menuContent': {
                        templateUrl: 'pages/loans/carLoan/cLExistinginLos.html',
                        controller: 'cLExistinginLosController',
                        controllerAs: 'cLExistinginLosVm'
                    }
                }
            })




    }
]);