angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.glPersonalDetailsRLMS', {
                    url: '/glPersonalDetailsRLMS',
                    data: {
                        pageId: 'GOLD_PERSONAL_DETAILS_RLMS'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/glPersonalDetailsRLMS.html',
                            controller: 'glPersonalDetailsRLMSController',
                            controllerAs: 'glPersonalDetailsVm'
                        }
                    }
                })

                .state('menu.goldKnowMoreRLMS', {
                    url: '/goldKnowMoreRLMS',
                    data: {
                        pageId: 'GOLD_KNOW_MORE_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/goldKnowMoreRLMS.html',
                            controller: 'goldKnowMoreRLMSController',
                            controllerAs: 'goldKnowMoreVm'
                        }
                    }
                })   

                .state('menu.goldOrnamentDetailsRLMS', {
                    url: '/goldOrnamentDetailsRLMS',
                    data: {
                        pageId: 'GOLD_ORNAMENTS_DETAILS_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/goldOrnamentDetailsRLMS.html',
                            controller: 'goldOrnamentDetailsRLMSController',
                            controllerAs: 'goldOrnamentDetailsVm'
                        }
                    }
                })

                 .state('menu.glLoanDetailsRLMS', {
                    url: '/glLoanDetailsRLMS',
                    data: {
                        pageId: 'GOLD_LOAN_DETAILS_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/glLoanDetailsRLMS.html',
                            controller: 'glLoanDetailsRLMSController',
                            controllerAs: 'glLoanDetailsVm'
                        }
                    }
                }) 

                .state('menu.glAdditionalDetailsRLMS', {
                    url: '/glAdditionalDetailsRLMS',
                    data: {
                        pageId: 'GOLD_LOAN_ADDITIONAL_DETAILS_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/glAdditionalDetailsRLMS.html',
                            controller: 'glAdditionalDetailsRLMSController',
                            controllerAs: 'glAdditionalDetailsVm'
                        }
                    }
                })

                .state('menu.glSelectBranchRLMS', {
                    url: '/glSelectBranchRLMS',
                    data: {
                        pageId: 'GOLD_LOAN_SELECT_BRANCH_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/glSelectBranchRLMS.html',
                            controller: 'glSelectBranchRLMSController',
                            controllerAs: 'glSelectBranchVm'
                        }
                    }
                }) 

                .state('menu.glBranchesNearRLMS', {
                    url: '/glBranchesNearRLMS',
                    data: {
                        pageId: 'GOLD_LOAN_BRANCHES_NEAR_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/glBranchesNearRLMS.html',
                            controller: 'glBranchesNearRLMSController',
                            controllerAs: 'glBranchesNearVm'
                        }
                    }
                })

                .state('menu.glGPSErrorRLMS', {
                    url: '/glGPSErrorRLMS',
                    data: {
                        pageId: 'GOLD_LOAN_GPS_ERROR_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/glGPSErrorRLMS.html',
                            controller: 'glGPSErrorRLMSController',
                            controllerAs: 'glGPSErrorVm'
                        }
                    }
                })

                .state('menu.glSelectBranchLocCodeRLMS', {
                    url: '/glSelectBranchLocCodeRLMS',
                    data: {
                        pageId: 'GOLD_LOAN_BRANCH_BY_LOCATION_CODE_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/glSelectBranchLocCodeRLMS.html',
                            controller: 'glSelectBranchLocCodeRLMSController',
                            controllerAs: 'glSelectBranchLocCodeVm'
                        }
                    }
                })

                .state('menu.glSelectBranchLocCodeListRLMS', {
                    url: '/glSelectBranchLocCodeListRLMS',
                    data: {
                        pageId: 'GOLD_LOAN_BRANCH_BY_LOCATION_CODE_LIST_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/glSelectBranchLocCodeListRLMS.html',
                            controller: 'glSelectBranchLocCodeListRLMSController',
                            controllerAs: 'glSelectBranchLocCodeListVm'
                        }
                    }
                }) 

                .state('menu.goldLoanErrorRLMS', {
                    url: '/goldLoanErrorRLMS',
                    data: {
                        pageId: 'GOLD_LOAN_ERROR_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/goldLoanErrorRLMS.html',
                            controller: 'goldLoanErrorRLMSController',
                            controllerAs: 'goldLoanErrorVm'
                        }
                    }
                }) 

                .state('menu.glLoanSummaryRLMS', {
                    url: '/glLoanSummaryRLMS',
                    data: {
                        pageId: 'GOLD_LOAN_SUMMARY_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/glLoanSummaryRLMS.html',
                            controller: 'glLoanSummaryRLMSController',
                            controllerAs: 'glLoanSummaryVm'
                        }
                    }
                })

                .state('menu.glCongratulationsRLMS', {
                    url: '/glCongratulationsRLMS',
                    data: {
                        pageId: 'GOLD_LOAN_CONGRAT_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/glCongratulationsRLMS.html',
                            controller: 'glCongratulationsRLMSController',
                            controllerAs: 'glCongratulationsVm'
                        }
                    }
                })

                .state('menu.glApplicationStatusRLMS', {
                    url: '/glApplicationStatusRLMS',
                    data: {
                        pageId: 'GOLD_LOAN_APP_STATUS_RLMS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/goldLoanRLMS/glApplicationStatusRLMS.html',
                            controller: 'glApplicationStatusRLMSController',
                            controllerAs: 'glApplicationStatusVm'
                        }
                    }
                })
        }
    ]);