'use strict';

angularApp.service('hlNTBCalculatorService',
    function ($q, AdapterUtils, utilityService, constantConfig, $ionicPopup, $state, $ionicScrollDelegate) {

        var hlNTBCalculatorService = this;

        var loanDetails, referenceStatusData, applicantGender, coAppicantGender, applicantOccupation, coApplicantOccupation, applicantDOB,
        coAppicantDOB, applicantNMI, coApplicantNMI, applicantExistingEMI, coApplicantExistingEMI, isCoApplicantAdded, applicantIncomeSource,
            coApplicantIncomeSource, applicantRetireAge, coApplicantRetireAge;
        var checkEligiblityResponse = {};
        var checkEligibilityRequest = {};
        var eligibalAmountDetail = {};
        var masterData = {};
        var generateLeadData = {};
        var isCallBackRequest = 'false';
        var contactNumber = '';
        this.trackReferenceData = false;
        this.leadID = '';
        this.leadMobile = '';
        this.isHomeScreenBack = false;
        this.submitLeadData = {};
        this.isCheckEligibilityBack = false;
        this.applicantData = {};
        this.coapplicantDate = {};
        this.isCalculatorBack = false;
        this.isSubmitDetailsBack = false;
        this.selectedCity = {};
        this.selectedloanPurpose = {};
        this.selectedBranch = '';
        this.isAmountBack = false;
        this.isFromRefer = false;
        this.isFromHamburger= false;
        this.isFromNTB = false;


        hlNTBCalculatorService.clearAll = function () {
            loanDetails = null; referenceStatusData = null;
        }

        // Setter/Getter
        hlNTBCalculatorService.getMasterDataService = function(){
            return masterData ;
        }
        hlNTBCalculatorService.setMasterDataService = function(obj){
             masterData = obj ;
        }

        hlNTBCalculatorService.getContactNumber = function () {
            return contactNumber;
        }
        hlNTBCalculatorService.setContactNumber = function (val) {
            contactNumber = val;
        }
        hlNTBCalculatorService.getIsCallBackRequset = function () {
            return isCallBackRequest;
        }
        hlNTBCalculatorService.setIsCallBackRequset = function (val) {
            isCallBackRequest = val;
        }

        hlNTBCalculatorService.setReferenceStatusData = function (data) {
            referenceStatusData = data;
        }

        hlNTBCalculatorService.getReferenceStatusData = function () {
            return referenceStatusData;
        }

        hlNTBCalculatorService.getGenerateLeadData = function () {
            return generateLeadData;
        }
        hlNTBCalculatorService.setGenerateLeadData = function (obj) {
            generateLeadData = obj;
        }

        hlNTBCalculatorService.getEligibalAmountDetail = function () {
            return eligibalAmountDetail;
        }
        hlNTBCalculatorService.setEligibalAmountDetail = function (obj) {
            eligibalAmountDetail = obj;
        }

        hlNTBCalculatorService.getCheckEligiblityRequest = function () {
            return checkEligibilityRequest;
        }

        hlNTBCalculatorService.setCheckEligiblityRequest = function (data) {
            checkEligibilityRequest = data;
        }

        hlNTBCalculatorService.getCheckEligiblityResponse = function () {
            return checkEligiblityResponse;
        }

        hlNTBCalculatorService.setCheckEligiblityResponse = function (data) {
            checkEligiblityResponse = data;
        }

        hlNTBCalculatorService.getApplicantRetireAge = function () {
            return applicantRetireAge;
        }
        hlNTBCalculatorService.setApplicantRetireAge = function (age) {
            applicantRetireAge = age;
        }

        hlNTBCalculatorService.getCoApplicantRetireAge = function () {
            return coApplicantRetireAge;
        }
        hlNTBCalculatorService.setCoApplicantRetireAge = function (age) {
            coApplicantRetireAge = age;
        }

        hlNTBCalculatorService.getCoApplicantIncomeSource = function () {
            return coApplicantIncomeSource;
        }
        hlNTBCalculatorService.setCoApplicantIncomeSource = function (sourc) {
            if (sourc == 'SL') {
                coApplicantIncomeSource = 'Salaried';
            } else {
                coApplicantIncomeSource = 'Other';
            }
        }

        hlNTBCalculatorService.getApplicantIncomeSource = function () {
            return applicantIncomeSource;
        }
        hlNTBCalculatorService.setApplicantIncomeSource = function (sourc) {
            if (sourc == 'SL') {
                applicantIncomeSource = 'Salaried';
            } else {
                applicantIncomeSource = 'Other';
            }
        }


        hlNTBCalculatorService.getCoApplicantAdded = function () {
            return isCoApplicantAdded;
        }
        hlNTBCalculatorService.setCoApplicantAdded = function (coApp) {
            if (coApp == 'Y') {
                isCoApplicantAdded = true;
            } else {
                isCoApplicantAdded = false;
            }
        }


        hlNTBCalculatorService.getApplicantExistingEMI = function () {
            return applicantExistingEMI;
        }

        hlNTBCalculatorService.setApplicantExistingEMI = function (emi) {
            applicantExistingEMI = emi;
        }
        hlNTBCalculatorService.getCoApplicantExistingEMI = function () {
            return coApplicantExistingEMI;
        }

        hlNTBCalculatorService.setCoApplicantExistingEMI = function (emi) {
            coApplicantExistingEMI = emi;
        }


        hlNTBCalculatorService.getApplicantDOB = function () {
            return applicantDOB;
        }

        hlNTBCalculatorService.setApplicantDOB = function (dob) {
            applicantDOB = dob;
        }


        hlNTBCalculatorService.getCoApplicantDOB = function () {
            return coAppicantDOB;
        }

        hlNTBCalculatorService.setCoApplicantDOB = function (dob) {
            coAppicantDOB = dob;
        }




        hlNTBCalculatorService.getApplicantNMI = function () {
            return applicantNMI;
        }


        hlNTBCalculatorService.setApplicantNMI = function (nmi) {
            applicantNMI = nmi;
        }

        hlNTBCalculatorService.getCoApplicantNMI = function () {
            return coApplicantNMI;
        }

        hlNTBCalculatorService.setCoApplicantNMI = function (nmi) {
            coApplicantNMI = nmi;
        }


        hlNTBCalculatorService.setGLLoanDetails = function (data) {
            loanDetails = data;
        };

        hlNTBCalculatorService.getGLLoanDetails = function () {
            return loanDetails;
        };
        hlNTBCalculatorService.getApplicantGender = function () {
            return applicantGender;
        }
        hlNTBCalculatorService.setApplicantGender = function (gen) {
            if (gen == 'F') {
                applicantGender = gen;
            } else {
                applicantGender = 'M';
            }

        }
        hlNTBCalculatorService.getCoApplicantGender = function () {
            return coAppicantGender;
        }
        hlNTBCalculatorService.setCoApplicantGender = function (gen) {
            if (gen == 'F') {
                coAppicantGender = gen;
            } else {
                coAppicantGender = 'M';
            }
        }
        hlNTBCalculatorService.getApplicantOccupation = function () {
            return applicantOccupation
        };
        hlNTBCalculatorService.getCoApplicantOccupation = function () {
            return coApplicantOccupation;
        }
        hlNTBCalculatorService.setApplicantOccupation = function (occ) {
            applicantOccupation = occ;
        };
        hlNTBCalculatorService.setCoApplicantOccupation = function (occ) {
            coApplicantOccupation = occ;
        }



        // Validations
        hlNTBCalculatorService.updatedigest = function () {
            // if (!$scope.$$phase)
            //     $scope.$apply();

            return;
        }

        hlNTBCalculatorService.isValidField = function (obj, field) {
            if (!obj) {
                return 'Please provide ' + field;
            }
            return false;
        };

        hlNTBCalculatorService.emiCalculation = function (p, i, t) {
            p = parseInt(p);
            i = parseFloat(i) / 1200;
            t = parseInt(t) * 12;
            var numerator = p * i * Math.pow((1 + i), t);
            var denominator = Math.pow((1 + i), t) - 1;
            var emiAmount = Math.ceil((numerator / denominator));
            return emiAmount;
        }

        hlNTBCalculatorService.minDownPay = function (p, l) {
            p = parseInt(p);
            l = parseInt(l);
            var downPayment = p - l;
            return downPayment;
        }

        hlNTBCalculatorService.getPropValue = function (d, l) {
            d = parseInt(d);
            l = parseInt(l);
            var p = d + l;
            return p;
        }

        hlNTBCalculatorService.minProperty = function (p, l) {
            p = parseInt(p);
            l = parseInt(l);
            var propertyValue = Math.ceil((p * 100) / l);
            return propertyValue;
        }

        hlNTBCalculatorService.loanAmtCalculation = function (i, t, e) {
            e = parseInt(e) //emi amount
            i = parseFloat(i) / 1200; // interest rate
            t = parseInt(t) * 12; // tenure
            var numerator = e * (Math.pow((1 + i), t) - 1);
            var denominator = i * Math.pow((1 + i), t);
            var loanAmount = Math.ceil(numerator / denominator);
            return loanAmount;
        }


        // API call

        hlNTBCalculatorService.calculateAge = function (birth) {

            var today = new Date();
            var nowyear = today.getFullYear();
            var nowmonth = today.getMonth();
            var nowday = today.getDate();

            var birthyear = birth.getFullYear();
            var birthmonth = birth.getMonth();
            var birthday = birth.getDate();

            var age = nowyear - birthyear;
            var age_month = nowmonth - birthmonth;
            var age_day = nowday - birthday;

            if (age_month < 0 || (age_month == 0 && age_day < 0)) {
                age = parseInt(age) - 1;
            }
            return age;
        }

        hlNTBCalculatorService.calculateNMIToEMIRatio = function (nmi) {
            var annualInCome = 12 * nmi;
            var ratio
            if (annualInCome > 0 || annualInCome <= 120000) {
                ratio = 20;
            } else if (annualInCome > 120000 || annualInCome <= 300000) {
                ratio = 30;
            } else if (annualInCome > 300000 || annualInCome <= 500000) {
                ratio = 55;
            } else if (annualInCome > 500000 || annualInCome <= 800000) {
                ratio = 60;
            } else if (annualInCome > 800000 || annualInCome <= 1000000) {
                ratio = 65;
            } else if (annualInCome > 1000000) {
                ratio = 70;
            }


            return ratio;
        }

        hlNTBCalculatorService.totalEligibalEMIAmoutBasedOnEMINMIRatio = function (appNMI, coAppNMI) {
            var totalOfNMI = appNMI + coAppNMI;
            var totalAnnualIncome = totalOfNMI * 12;
            var emiTonmiRatio = hlNTBCalculatorService.calculateNMIToEMIRatio(totalAnnualIncome);
            return (totalAnnualIncome * emiTonmiRatio) / 100;
        }


        hlNTBCalculatorService.submitLeadDetails = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/submitLeadDetails", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        hlNTBCalculatorService.getMasterData = function (payload) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getHlNtbMasterData", payload, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        hlNTBCalculatorService.getDisclaimerContent = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getDisclaimerContent", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        hlNTBCalculatorService.getOtherBanner = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getOtherBanner", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        hlNTBCalculatorService.getLeadGenerationBanner = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getLeadGenerationBanner", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        hlNTBCalculatorService.getBranchListByCity = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getBranchListByCity", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        hlNTBCalculatorService.getCityByPinCode = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getCityByPinCode", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        hlNTBCalculatorService.getEligiblityCheck = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/performEligiblityCheck", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        hlNTBCalculatorService.getTermsAndConditions = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getTermsAndConditions", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        //Generate OTP
        hlNTBCalculatorService.generateOTP = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getOTPTokenForNTB", requestData, false).then(function (response) {
                q.resolve(response.data);
            },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };

        //Validate OTP
        hlNTBCalculatorService.validateOTP = function (requestData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/validateOTPTokenForNTB", requestData, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                });
            return q.promise;
        };


        hlNTBCalculatorService.submitReferenceNumber = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getLeadContactNumber", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        hlNTBCalculatorService.getReferenceNumberStatus = function (payLoad) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/ntb/Home/getLeadStatus", payLoad, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

        hlNTBCalculatorService.showAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {
                            obj.addressChangeFlag = false;
                            obj.resiAddressFlag = "";
                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                        }
                    }
                ];
            }
            else {
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            // if (imageType && imageType.toLowerCase() == 'error') {
            //     imageType += '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            // } else if (imageType && imageType.toLowerCase() == 'success') {
            //     imageType += '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            // } else if (imageType && imageType.toLowerCase() == 'alert') {
            //     imageType += '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            // } else {
            //     imageType += "";
            // }
            var bhimErrorPopup = $ionicPopup.alert({
                template: '<div class="font-dark-grey">' + '<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span>'
                    + message1 + '</span><div ng-if="message2" class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">' + message2 + '</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {
            });
        };

        /**
         * 
         */
        hlNTBCalculatorService.showTncAlertPopup = function (imageType, message1, message2, onTapgo, buttontext1, buttontext2, $scope, obj) {
            var btn_array = [];
            if (buttontext1 != "" && buttontext2 != "") {
                btn_array = [
                    {
                        text: buttontext2 || "Cancel",
                        type: 'button-negative',
                        onTap: function () {
                            obj.addressChangeFlag = false;
                            obj.resiAddressFlag = "";
                        }
                    },
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                        }
                    }
                ];
            }
            else {
                btn_array = [
                    {
                        text: buttontext1 || "OK",
                        type: 'button-positive',
                        onTap: function () {
                            if (onTapgo) {
                                $state.go(onTapgo);
                            }
                        }
                    }
                ];
            }

            // if (imageType && imageType.toLowerCase() == 'error') {
            //     imageType = '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"/></div>';
            // } else if (imageType && imageType.toLowerCase() == 'success') {
            //     imageType = '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/successSymbol.svg"/></div>';
            // } else if (imageType && imageType.toLowerCase() == 'alert') {
            //     imageType = '<div><img class="approvedIconPosition" src="img/FT/BhimUpi/alertSymbol.svg"/></div>';
            // } else {
            //     imageType = "";
            // }
            var bhimErrorPopup = $ionicPopup.alert({
                title: message1,
                template: '<div class="roboto-regular font-size-14 color-darkgrey padTop10">' + message2 + '</div>',
                // '<div class="font-dark-grey">' + imageType + '<div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter roboto-medium font-size-16 color-darkgrey"><span></span><div ng-if="message2" class="textAlignCenter roboto-regular font-size-14 color-darkgrey padTop10">' + message2 + '</div></div></div></div>', //template,
                scope: $scope,
                cssClass: 'bhim-alert-popup hlTermnCondition',
                buttons: btn_array,
            });
            bhimErrorPopup.then(function (res) {
            });
        };


        return hlNTBCalculatorService;

    });