'use strict';
angularApp.controller('homeLoanErrorController', [
    "$state",
    "$scope",
    "$ionicPopup",
    "$translate",
    "$ionicHistory",
    "utilityService",
    "ionicDatePicker",
    "$ionicSideMenuDelegate",
    "homeLoanService",
    function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, homeLoanService) {

        var homeLoanErrorVm = this;

        function initPage() {
            homeLoanErrorVm.errorDetails = homeLoanService.dedupErrors;

            if (homeLoanService.source == "car") {
                homeLoanErrorVm.isCar = true;
            } else {
                homeLoanErrorVm.isCar = false;
            }
            // homeLoanErrorVm.errorDetails =  [
            //     {
            //       "errorTitle": "KYC Details",
            //       "errorDescription": "Your KYC details are not updated. Kindly visit the branch"
            //     },
            //     {
            //       "errorTitle": "Resident Indian",
            //       "errorDescription": "Presently, Home loans are only available only to Resident Indians through this channel."
            //     },
            //     {
            //       "errorTitle": "Account Status",
            //       "errorDescription": "Your KYC details are not updated. Kindly visit the branch"
            //     },
            //     {
            //       "errorTitle": "PAN",
            //       "errorDescription": "Your PAN is not updated in bank records."
            //     },
            //     {
            //       "errorTitle": "AADHAR",
            //       "errorDescription": "Your AADHAR is not updated in bank records."
            //     }

            //   ];
        }

        homeLoanErrorVm.goBack = function() {
            $ionicHistory.goBack(-1);
        }

        $scope.$on('$ionicView.loaded', function() {
            
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }


]);