'use strict';
angularApp.controller('recommendProductController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"validateService",
		"$filter","homeLoanService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, validateService, $filter,homeLoanService) {
			
			var recommendProductVm = this;

			recommendProductVm.detail = {};
			function validateForm() {
			
			}
			
			function initPage() {
				recommendProductVm.selectedIndex = 1000;
				var rupeeSymbol = String.fromCharCode(8377);
				recommendProductVm.loanAmount = 100000;
				recommendProductVm.showOtherProducts = false;
				recommendProductVm.disableBackButton = homeLoanService.disableBackButton;
				// recommendProductVm.productDetails =	{
				// 	"yonoRef": "HLY180618100001",
				// 	"loanType": "HOME",
				// 	"loanAmount": "8000000",
				// 	"tenure": "30",
				// 	"products": {"product":          [
				// 					{
				// 		"productcode": "HL_GREEN_4",
				// 		"productname": "SBI-MAX-GAIN",
				// 		"intrates": {
				// 			"intrate": [               {
				// 				"fromloanamount": "0",
				// 				"toloanamount": "8000000",
				// 				"rate": "9.0",
				// 				"interestType": "F"
				// 			}
				// 		]},
				// 		"emis": {"emi": [{"emi" : "297501",
				// 		"fromTenure" : "1",
				// 		"toTenure" : "300"
				// },{"emi" : "454",
				// 		"fromTenure" : "1",
				// 		"toTenure" : "45"
				// }]}
				// 		},
				// 		{
				// 		"productcode": "HL_GREEN_4",
				// 		"productname": "SBI-MIN-GAIN",
				// 		"intrates": {
				// 			"intrate": [               {
				// 				"fromloanamount": "0",
				// 				"toloanamount": "8000000",
				// 				"rate": "9.0",
				// 				"interestType": "F"
				// 			}
				// 		]},
				// 		"emis": {"emi": [{"emi" : "297501",
				// 		"fromTenure" : "",
				// 		"toTenure" : "300"
				// }]}
				// 		},{
				// 		"productcode": "HL_GREEN_4",
				// 		"productname": "SBI-HAHA-GAIN",
				// 		"intrates": {
				// 			"intrate": [               {
				// 				"fromloanamount": "0",
				// 				"toloanamount": "8000000",
				// 				"rate": "9.0",
				// 				"interestType": "F"
				// 			}
				// 		]},
				// 		"emis": {"emi": [{"emi" : "297501",
				// 		"fromTenure" : "",
				// 		"toTenure" : "300"
				// }]}
				// 		}

				// 	]}
				// };
				recommendProductVm.productDetails = homeLoanService.getRecommendedResponse();
				recommendProductVm.recommendedProduct = [];
				recommendProductVm.otherProduct = [];
				for(var i=0 ; i<recommendProductVm.productDetails.products.product.length;i++){
					if(i==0){
						recommendProductVm.recommendedProduct.push(recommendProductVm.productDetails.products.product[i]);
					}else{
						recommendProductVm.otherProduct.push(recommendProductVm.productDetails.products.product[i]);
					}
				}

				//to show/hide edit product button
				if(homeLoanService.getGroupId() == "TAKEOVER"){
					recommendProductVm.isEditButton = false;
				}else{
					recommendProductVm.isEditButton = true;
				}
			};

			$scope.$on('$ionicView.loaded', function () {
				
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initPage();
			});

			recommendProductVm.goBack = function(){
				if(homeLoanService.getGroupId() == "TAKEOVER"){
					$state.go('menu.calculateEmiTakeover');
				}else{
					$state.go('menu.calculateEmi');
				}
				
			}

			recommendProductVm.editProduct = function(selectProduct){
				homeLoanService.editProduct = selectProduct;
				$state.go('menu.hlEditProduct');
			}

			recommendProductVm.goToNextPage = function(){
				var selectedProduct = {
					"productCode" : "",
					"productName": ""
				}
				if(recommendProductVm.selectedIndex == 1000){
					selectedProduct.productCode = recommendProductVm.recommendedProduct[0].productcode;
					selectedProduct.productName = recommendProductVm.recommendedProduct[0].productname;
				}else{
					selectedProduct.productCode = recommendProductVm.otherProduct[recommendProductVm.selectedIndex].productcode;
					selectedProduct.productName = recommendProductVm.otherProduct[recommendProductVm.selectedIndex].productname;
				}

				homeLoanService.setSelectedProduct(selectedProduct);
				if(recommendProductVm.productDetails.topupProducts){
					$state.go('menu.recommendProductTopup')
				}else{
					$state.go('menu.homeLoanSelectBranch');
				}
				
			}

			recommendProductVm.show = function(){
				recommendProductVm.showOtherProducts = !recommendProductVm.showOtherProducts;
				if(!recommendProductVm.showOtherProducts){
					recommendProductVm.selectedIndex = 1000;
				}
			}

			recommendProductVm.selectProduct = function(index){
				recommendProductVm.selectedIndex = index;
			}

			recommendProductVm.displayEMI = function(emiList){
				
				var templateInfo = '<div class="row roboto-regular color-darkgrey padtop10"><div class="col hlAllBorder"><span>Duration</span><br>(months)</div><div class="col hlAllBorder">EMI</div></div>';

				for(var i =0;i<emiList.length;i++){
					templateInfo += '<div class="row roboto-light font-size-14 color-darkgrey"><div class="col hlAllBorder"> ' + emiList[i].fromTenure + ' - '+ emiList[i].toTenure +'</div><div class="col hlAllBorder">&#8377;&nbsp;'+ emiList[i].emi + '</div></div>'; 
				}
				var templateInfoParent = '<div class="roboto-medium font-size-16 color-darkgrey">Flexipay</div>';
				
				var hlInfoIcon = $ionicPopup.show({
					template: templateInfoParent + templateInfo,
					title: '',
					cssClass: 'dialog',
					scope: $scope,
					buttons: [{
						text: 'OK',
						type: 'button-positive'
					}]
				});
			}

			return this;
		}

		
]);


