'use strict';

angularApp.service('mobilityLandingService',
    function($q, AdapterUtils, utilityService, $state, $ionicScrollDelegate) {
    	var mobilityLandingService = this;

        var bannersData;

        mobilityLandingService.setBannersData = function(data) {
            bannersData = data;
        };

        mobilityLandingService.getBannersData = function() {
            return bannersData;
        };

		mobilityLandingService.getMobilityData = function() {
            var q = $q.defer();
            AdapterUtils.postData("adapters/PreApprovedLoanAdapter/loansMobility/fetchMobilityBanners", {}, true).then(
                function(response) {
                    q.resolve(response.data);
                },
                function(error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };
        return mobilityLandingService;
    });