angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            $stateProvider
                .state('menu.rxtcKnowMore', {
                    url: '/rxtcKnowMore',
                    data: {
                        pageId: 'RTXC_KNOW_MORE'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/rxtcKnowMore.html',
                            controller: 'rxtcKnowMoreController',
                            controllerAs: 'rxtcKnowMoreVm'
                        }
                    }
                })

                .state('menu.rtxcEligibilityChecks', {
                    url: '/rtxcEligibilityChecks',
                    data: {
                        pageId: 'RTXC_ELIGIBILITY_CHECK'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/rtxcEligibilityChecks.html',
                            controller: 'rtxcEligibilityChecksController',
                            controllerAs: 'rtxcEligibilityChecksVm'
                        }
                    }
                })
                
                .state('menu.rxtcDetails', {
                    url: '/rxtcDetails',
                    data: {
                        pageId: 'RTXC_DETAILS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/rxtcDetails.html',
                            controller: 'rxtcDetailsController',
                            controllerAs: 'rxtcDetailsVm'
                        }
                    }
                })

                .state('menu.rxtcUploadPhotograph', {
                    url: '/rxtcUploadPhotograph',
                    data: {
                        pageId: 'RTXC_UPLOAD_PHOTOGRAPH'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/rxtcUploadPhotograph.html',
                            controller: 'rxtcUploadPhotographController',
                            controllerAs: 'rxtcUploadPhotographVm'
                        }
                    }
                })
                
                .state('menu.rxtcXpressCredit', {
                    url: '/rxtcXpressCredit',
                    data: {
                        pageId: 'RTXC_XPRESS_CREDIT'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/rxtcXpressCredit.html',
                            controller: 'rxtcXpressCreditController',
                            controllerAs: 'rxtcXpressCreditVm'
                        }
                    }
                })

                .state('menu.branchSelection', {
                    url: '/branchSelection',
                    data: {
                        pageId: 'RTXC_XPRESS_BRNCH_SEL'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/branchSelection.html',
                            controller: 'branchSelectionController',
                            controllerAs: 'branchSelectionVm'
                        }
                    }
                })

                .state('menu.rtxcBranchesNear', {
                    url: '/rtxcBranchesNear',
                    data: {
                        pageId: 'RTXC_NEAR_BRANCHES'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/rtxcBranchesNear.html',
                            controller: 'rtxcBranchesNearController',
                            controllerAs: 'rtxcBranchesNearVm'
                        }
                    }
                })

                .state('menu.rtxcGPSError', {
                    url: '/rtxcGPSError',
                    data: {
                        pageId: 'RTXC_GPS_ERROR'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/rtxcGPSError.html',
                            controller: 'rtxcGPSErrorController',
                            controllerAs: 'rtxcGPSErrorVm'
                        }
                    }
                })

                .state('menu.rtxcSelectBranchLocCode', {
                    url: '/rtxcSelectBranchLocCode',
                    data: {
                        pageId: 'RTXC_SELECT_BRANCH_CODE'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/rtxcSelectBranchLocCode.html',
                            controller: 'rtxcSelectBranchLocCodeController',
                            controllerAs: 'rtxcSelectBranchLocCodeVm'
                        }
                    }
                })

                .state('menu.rtxcSelectBranchLocCodeList', {
                    url: '/rtxcSelectBranchLocCodeList',
                    data: {
                        pageId: 'RTXC_SELECT_BRANCH_CODE_LIST'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/rtxcSelectBranchLocCodeList.html',
                            controller: 'rtxcSelectBranchLocCodeListController',
                            controllerAs: 'rtxcSelectBranchLocCodeListVm'
                        }
                    }
                })

                .state('menu.rtxcLoanProduct', {
                    url: '/rtxcLoanProduct',
                    data: {
                        pageId: 'RTXC_SELECT_PRODUCT'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/rtxcLoanProduct.html',
                            controller: 'rtxcLoanProductController',
                            controllerAs: 'rtxcLoanProductVm'
                        }
                    }
                })

                .state('menu.reviewExpressCredit', {
                    url: '/reviewExpressCredit',
                    data: {
                        pageId: 'RTXC_XPRESS_REVIEW'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/reviewExpressCredit.html',
                            controller: 'reviewExpressCreditController',
                            controllerAs: 'reviewExpressCreditVm'
                        }
                    }
                })

                .state('menu.otpExpressCredit', {
                    url: '/otpExpressCredit',
                    data: {
                        pageId: 'RTXC_XPRESS_OTP'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/otpExpressCredit.html',
                            controller: 'otpExpressCreditController',
                            controllerAs: 'otpExpressCreditVm'
                        }
                    }
                })

                .state('menu.rtxcApplicationStatus', {
                    url: '/rtxcApplicationStatus',
                    data: {
                        pageId: 'RTXC_XPRESS_APPLICATION_STATUS'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/rtxcApplicationStatus.html',
                            controller: 'rtxcApplicationStatusController',
                            controllerAs: 'rtxcApplicationStatusVm'
                        }
                    }
                })

                .state('menu.rxtcCongratulations', {
                    url: '/rxtcCongratulations',
                    data: {
                        pageId: 'RTXC_XPRESS_SANCTIONED'
                    },
                    cache : false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/loans/rxtc/rxtcCongratulations.html',
                            controller: 'rxtcCongratulationsController',
                            controllerAs: 'rxtcCongratulationsVm'
                        }
                    }
                })

            }
        ]);