'use strict';

angularApp.controller('rxtcXpressCreditController', [
    "$state",
    "$scope",
    "$translate",
    "$ionicHistory",
    "utilityService", 
    "$filter",
    "rxtcService",
    "homeLoanService",
    "$morphCarousel",
    "$ionicScrollDelegate",

    function($state,
        $scope,
        $translate,
        $ionicHistory,
        utilityService,
        $filter,
        rxtcService,
        homeLoanService,
        $morphCarousel,
        $ionicScrollDelegate) {

        var rxtcXpressCreditVm = this;

        rxtcXpressCreditVm.initPage = function () {
            var tenures = [];
            rxtcXpressCreditVm.tenures = [];
            rxtcXpressCreditVm.disableMBtn = false;
            rxtcXpressCreditVm.disablePBtn = false;

            if (rxtcService.ddeEligible) {
                rxtcService.ddeEligible = false;
                rxtcService.showAlertPopupWithCallback("","To save your Branch visit, we are offering you Digital Document Execution (DDE) facility.",
                        "Note: You will be directed to a third party platform for completing DDE which will require Aadhar number. Please ensure to keep Aadhar number and mobile registered with Aadhar ready for completing this process. On successful completion of DDE process, your Loan account will be opened and proceeds will be credited to your salary account. In case, DDE is unsuccessful, please visit your Home Branch for documentatiion.",
                        "Are you interested?",
                    "Yes","No",$scope,function(){
                        rxtcService.isFromNesl = false;
                        $state.go('menu.branchSelection');
                    },function(){
                        rxtcService.isFromNesl = true;
                        $state.go('menu.reviewExpressCredit');
                });
            }

            if(rxtcService.getRetrieveData() && rxtcService.getRetrieveData().selectedProductDetail && rxtcService.getRetrieveData().selectedProductDetail.emi) {           
                rxtcXpressCreditVm.retrieveData = rxtcService.getRetrieveData();
                rxtcXpressCreditVm.loanMinAmount = rxtcXpressCreditVm.retrieveData.selectedProductDetail.minLoanAmount;
                rxtcXpressCreditVm.loanMaxAmount = rxtcXpressCreditVm.retrieveData.selectedProductDetail.maxLoanAmount;
                rxtcXpressCreditVm.loanproductName = rxtcXpressCreditVm.retrieveData.selectedProductDetail.loanproductName;
                rxtcXpressCreditVm.loanProductAmt = rxtcXpressCreditVm.retrieveData.selectedProductDetail.maxLoanAmount;
                rxtcXpressCreditVm.loanProductTenure = rxtcXpressCreditVm.retrieveData.selectedProductDetail.maxTenure;
                rxtcXpressCreditVm.loanAmount = parseInt(rxtcXpressCreditVm.retrieveData.selectedProductDetail.requestedAmount);
                rxtcXpressCreditVm.emiAmount = parseInt(rxtcXpressCreditVm.retrieveData.selectedProductDetail.emi);
                rxtcXpressCreditVm.maxEMIAmount = rxtcXpressCreditVm.emiAmount;
                rxtcXpressCreditVm.interestRate = parseFloat(rxtcXpressCreditVm.retrieveData.selectedProductDetail.interestRate);                
                rxtcXpressCreditVm.minTenure = parseInt(rxtcXpressCreditVm.retrieveData.selectedProductDetail.minTenure);
                rxtcXpressCreditVm.maxTenure = parseInt(rxtcXpressCreditVm.retrieveData.selectedProductDetail.maxTenure);
                rxtcXpressCreditVm.processingFee = rxtcXpressCreditVm.retrieveData.selectedProductDetail.processingFee;
                rxtcXpressCreditVm.facilityType = rxtcXpressCreditVm.retrieveData.selectedProductDetail.facilityType; 
                rxtcXpressCreditVm.loanproductVariant = rxtcXpressCreditVm.retrieveData.selectedProductDetail.loanproductVariant;                

                for (var i = rxtcXpressCreditVm.minTenure; i <= rxtcXpressCreditVm.maxTenure; i++) {
                    tenures.push(i);
                }
                rxtcXpressCreditVm.tenures = tenures;
                rxtcXpressCreditVm.selectedTenure = parseInt(rxtcXpressCreditVm.retrieveData.selectedProductDetail.tenure);
                rxtcXpressCreditVm.tenure = rxtcXpressCreditVm.selectedTenure;

                if (rxtcXpressCreditVm.retrieveData.repaymentDay) {
                    var repaymentDay = rxtcXpressCreditVm.retrieveData.repaymentDay;
                    rxtcXpressCreditVm.selectRepaymentDate(repaymentDay);
                }
            }else{
                rxtcXpressCreditVm.finalEligibilityData = rxtcService.getRetrieveData();
                if(!rxtcService.dxcFlag) {
                    rxtcXpressCreditVm.loanMinAmount = parseInt(rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].minLoanAmount);
                    rxtcXpressCreditVm.loanMaxAmount = parseInt(rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].maxLoanAmount);
                    rxtcXpressCreditVm.loanproductName = rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].loanproductName;
                    rxtcXpressCreditVm.loanProductAmt = rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].maxLoanAmount;
                    rxtcXpressCreditVm.loanProductTenure = rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].maxTenure; 
                    rxtcXpressCreditVm.loanAmount = parseInt(rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].maxLoanAmount);
                    rxtcXpressCreditVm.emiAmount = parseInt(rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].emi);
                    rxtcXpressCreditVm.maxEMIAmount = rxtcXpressCreditVm.emiAmount;                    
                    rxtcXpressCreditVm.interestRate = parseFloat(rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].interestRate);                    
                    rxtcXpressCreditVm.minTenure = parseInt(rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].minTenure);
                    rxtcXpressCreditVm.maxTenure = parseInt(rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].maxTenure);
                    rxtcXpressCreditVm.processingFee = rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].processingFee;
                    rxtcXpressCreditVm.facilityType = rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].facilityType; 
                    rxtcXpressCreditVm.loanproductVariant = rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].loanproductVariant;
                    for (var j = rxtcXpressCreditVm.minTenure; j <= rxtcXpressCreditVm.maxTenure; j++) {
                        tenures.push(j);
                    }
                    rxtcXpressCreditVm.tenures = tenures;
                    rxtcXpressCreditVm.selectedTenure = parseInt(rxtcXpressCreditVm.finalEligibilityData.loanQuoteList[0].maxTenure);
                    rxtcXpressCreditVm.tenure = rxtcXpressCreditVm.selectedTenure;
                }                
            }

            if(rxtcXpressCreditVm.loanAmount <= rxtcXpressCreditVm.loanMinAmount){
                rxtcXpressCreditVm.disableMBtn = true;
            }
            if(rxtcXpressCreditVm.loanAmount >= rxtcXpressCreditVm.loanMaxAmount){
                rxtcXpressCreditVm.disablePBtn = true;
            }

            rxtcXpressCreditVm.emiCalculation();  
        }

        var listener = $scope.$watch(function () {
            return (rxtcXpressCreditVm.selectedTenure);
        },
        function (tenureValue) {
            if (tenureValue !== undefined) {
                rxtcXpressCreditVm.selectedTenure = tenureValue;
                if (rxtcXpressCreditVm.selectedTenure) {
                    rxtcXpressCreditVm.tenure = rxtcXpressCreditVm.selectedTenure;
                    rxtcXpressCreditVm.emiCalculation();
                }
            }
        });


        rxtcXpressCreditVm.selectRepaymentDate = function(repayDay){
            var monthList = ["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"];
           
            var d = new Date();
            
            rxtcXpressCreditVm.day = d.getDate();
            rxtcXpressCreditVm.repaymentDay = repayDay;
            rxtcXpressCreditVm.repaymentyear = d.getFullYear();

            if(repayDay <= rxtcXpressCreditVm.day){
                if(monthList[d.getMonth()] == "DEC"){
                    rxtcXpressCreditVm.repaymentMonth = monthList[0];
                    rxtcXpressCreditVm.repaymentyear = d.getFullYear()+1;
                }else{
                   rxtcXpressCreditVm.repaymentMonth = monthList[(d.getMonth())+1];
                }
            }else{
                rxtcXpressCreditVm.repaymentMonth = monthList[d.getMonth()];
            }

            rxtcXpressCreditVm.repaymentDate = rxtcXpressCreditVm.repaymentDay + " " + rxtcXpressCreditVm.repaymentMonth + " " + rxtcXpressCreditVm.repaymentyear;
        }

        rxtcXpressCreditVm.loanAmountCheck = function(loanValue){
            var loanAmt = 0;
            if (!loanValue) {
                rxtcXpressCreditVm.loanAmount = rxtcXpressCreditVm.loanMinAmount;
                loanAmt = parseInt(rxtcXpressCreditVm.loanAmount);
            }else{
                loanAmt = parseInt(loanValue);
            }
            
            if((loanAmt % 1000) > 0){
                rxtcXpressCreditVm.loanAmount -= (loanAmt % 1000);
            }else{
                rxtcXpressCreditVm.loanAmount = loanAmt;
            }
            
            if(rxtcXpressCreditVm.loanAmount <= rxtcXpressCreditVm.loanMinAmount){
                rxtcXpressCreditVm.loanAmount = parseInt(rxtcXpressCreditVm.loanMinAmount);
                rxtcXpressCreditVm.disableMBtn = true;
            }else{
                rxtcXpressCreditVm.disableMBtn = false;
            }
            if(rxtcXpressCreditVm.loanAmount >= rxtcXpressCreditVm.loanMaxAmount){
                rxtcXpressCreditVm.loanAmount = parseInt(rxtcXpressCreditVm.loanMaxAmount)
                rxtcXpressCreditVm.disablePBtn = true;
            }else{
                rxtcXpressCreditVm.disablePBtn = false;
            }
            rxtcXpressCreditVm.emiCalculation();
        }

        rxtcXpressCreditVm.emiCalculation = function() {            
            rxtcXpressCreditVm.emiAmount = rxtcService.emiCalculation(rxtcXpressCreditVm.loanAmount,rxtcXpressCreditVm.interestRate,rxtcXpressCreditVm.tenure);
            if(rxtcXpressCreditVm.maxEMIAmount){
                rxtcXpressCreditVm.maxEMIAmount = rxtcService.emiCalculation(rxtcXpressCreditVm.loanMaxAmount,rxtcXpressCreditVm.interestRate,rxtcXpressCreditVm.maxTenure);
                if (rxtcXpressCreditVm.emiAmount > rxtcXpressCreditVm.maxEMIAmount) {
                    rxtcXpressCreditVm.maxEmiError = "EMI breaches the maximum permissible value";
                }else{
                    rxtcXpressCreditVm.maxEmiError = "";
                } 
            }            
        }

        rxtcXpressCreditVm.decreaseAmount = function (loanValue) {
            var loanAmount = parseInt(loanValue);
            if(loanAmount){
                rxtcXpressCreditVm.disablePBtn = false;
                if(loanAmount <= rxtcXpressCreditVm.loanMinAmount){
                    rxtcXpressCreditVm.disableMBtn = true;               
                }else{
                    rxtcXpressCreditVm.loanAmount = loanAmount - 1000;
                    if(rxtcXpressCreditVm.loanAmount <= rxtcXpressCreditVm.loanMinAmount){
                        rxtcXpressCreditVm.disableMBtn = true;               
                    }else{
                        rxtcXpressCreditVm.loanAmountCheck(rxtcXpressCreditVm.loanAmount);
                    }
                }                
            }  
        }

        rxtcXpressCreditVm.increaseAmount = function (loanValue) {
            var loanAmount = parseInt(loanValue);
            if(loanAmount){
                rxtcXpressCreditVm.disableMBtn = false;
                if(loanAmount >= rxtcXpressCreditVm.loanMaxAmount){
                    rxtcXpressCreditVm.disablePBtn = true;              
                }else{
                    rxtcXpressCreditVm.loanAmount = loanAmount + 1000;
                    if(rxtcXpressCreditVm.loanAmount >= rxtcXpressCreditVm.loanMaxAmount){
                        rxtcXpressCreditVm.disablePBtn = true;
                        rxtcXpressCreditVm.loanAmount = rxtcXpressCreditVm.loanMaxAmount;            
                    }else{
                        rxtcXpressCreditVm.loanAmountCheck(rxtcXpressCreditVm.loanAmount);
                    }
                }                
            }
        }


        rxtcXpressCreditVm.goback = function() {
            $state.go('menu.rxtcUploadPhotograph');
        };

        rxtcXpressCreditVm.goToNextPage = function() {
            rxtcService.dataChangeforTNC = false;       
            if(rxtcXpressCreditVm.repaymentDate && !rxtcXpressCreditVm.maxEmiError) {
                var saveRequest = {
                  "repaymentDay": rxtcXpressCreditVm.repaymentDay ? rxtcXpressCreditVm.repaymentDay : '',
                  "selectedProductDetail": {
                    "emi": rxtcXpressCreditVm.emiAmount ? rxtcXpressCreditVm.emiAmount : '',
                    "facilityType": rxtcXpressCreditVm.facilityType ? rxtcXpressCreditVm.facilityType : '',
                    "interestRate": rxtcXpressCreditVm.interestRate ? rxtcXpressCreditVm.interestRate : '',
                    "loanproductName": rxtcXpressCreditVm.loanproductName ? rxtcXpressCreditVm.loanproductName : '',
                    "loanproductVariant": rxtcXpressCreditVm.loanproductVariant ? rxtcXpressCreditVm.loanproductVariant : '',
                    "maxLoanAmount": rxtcXpressCreditVm.loanMaxAmount ? rxtcXpressCreditVm.loanMaxAmount : '',
                    "maxTenure": rxtcXpressCreditVm.maxTenure ? rxtcXpressCreditVm.maxTenure : '',
                    "minLoanAmount": rxtcXpressCreditVm.loanMinAmount ? rxtcXpressCreditVm.loanMinAmount : '',
                    "minTenure": rxtcXpressCreditVm.minTenure ? rxtcXpressCreditVm.minTenure : '',
                    "processingFee": rxtcXpressCreditVm.processingFee ? rxtcXpressCreditVm.processingFee : '',
                    "requestedAmount": rxtcXpressCreditVm.loanAmount ? rxtcXpressCreditVm.loanAmount : '',
                    "tenure": rxtcXpressCreditVm.tenure ? rxtcXpressCreditVm.tenure : ''
                  }
                }

                rxtcService.recalculateLoanDetails(saveRequest).then(function(data) {
                    listener();
                    if (rxtcService.getRetrieveData().selectedProductDetail) {
                        if (rxtcService.getRetrieveData().selectedProductDetail.emi) {
                            if (parseInt(rxtcService.getRetrieveData().selectedProductDetail.requestedAmount) == saveRequest.selectedProductDetail.requestedAmount) {
                                rxtcService.dataChangeforTNC = true;
                            }else{
                                rxtcService.dataChangeforTNC = false;
                            }
                            if (rxtcService.dataChangeforTNC && parseInt(rxtcService.getRetrieveData().selectedProductDetail.tenure) == saveRequest.selectedProductDetail.tenure) {
                                rxtcService.dataChangeforTNC = true;
                            }else{
                                rxtcService.dataChangeforTNC = false;
                            }
                            if (rxtcService.dataChangeforTNC && rxtcService.getRetrieveData().repaymentDay == saveRequest.repaymentDay) {
                                rxtcService.dataChangeforTNC = true;
                            }else{
                                rxtcService.dataChangeforTNC = false;
                            }
                        }
                    }

                    saveRequest.stampDutyFee = data.stampDutyFee;
                    saveRequest.selectedProductDetail = data.selectedProductDetail;
                    rxtcService.savePageDetails(saveRequest);
                    if (data.ddeEligible.toUpperCase() == "Y") {
                         rxtcService.showAlertPopupWithCallback("","To save your Branch visit, we are offering you Digital Document Execution (DDE) facility.",
                        "Note: You will be directed to a third party platform for completing DDE which will require Aadhar number. Please ensure to keep Aadhar number and mobile registered with Aadhar ready for completing this process. On successful completion of DDE process, your Loan account will be opened and proceeds will be credited to your salary account. In case, DDE is unsuccessful, please visit your Home Branch for documentatiion.",
                        "Are you interested?",
                        "Yes","No",$scope,function(){
                            rxtcService.isFromNesl = false;
                            $state.go('menu.branchSelection');
                        },function(){
                            rxtcService.isFromNesl = true;
                            $state.go('menu.reviewExpressCredit');
                        }); 
                    }else{
                        $state.go('menu.branchSelection');
                    }
                    
                },function(error){
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }else{
                rxtcXpressCreditVm.repaymentError = "Please select Loan Repayment Date";
                $ionicScrollDelegate.scrollBottom();
            }            
        }

        $scope.$on('$ionicView.beforeEnter', function() {
            rxtcXpressCreditVm.initPage();            
        });
       
        return this;
    }
]);