'use strict';

angularApp.controller('menuController',
	function ($scope,
		$rootScope,
		$state,
		$ionicPopup,
		wishListService,
		$ionicSideMenuDelegate,
		utilityService,
		$translate,
		getAccountDetailsService,
		$ionicModal,
		mPinLoginService,
		billDeskService,
		constantConfig,
		clearServiceDataService,
		feedebackService,
		homeScreenService,
		personalLoanService,
		generalInsurenceHomeService,
		openAccountService,
		cardsService,
		loggedInUserService,
		AdapterUtils,
		ionicToast,
		sampoornSurakshaService,
		requestYCService,
		fixedDepositService,
		newCardService,
		fTBeneficiaryService,
		rdService,
		lifeInsuranceBasicApplicationService,
		homeLoanService,
		ompMerchantsService,
		bookingsService,
		linkCardService,
		floatingMenuService,
		mutualFundsService,
		clickStreamService,
		mySecurityProfileService,
		cardConfig,
		$q,
		$ionicLoading,
		myBalanceService,
		cardCompareService,
		$ionicScrollDelegate,
		customerInfoService,
    instaHomeService,
		educationLoanService,
		appRateService,
		$timeout,
		rrService,
		csatService,
		menuService, 
		openUrlInAppbroswerService,
		internetBankingService,
		cryptoService
		) {


		var menuControllerVM = this;
		menuControllerVM.option = "";
		menuControllerVM.ompStart = 'f';
		$rootScope.profileScore = "";
		$rootScope.profileImageUrl = "";
		$rootScope.isInUserLogin = false;
		$scope.isiPhone = utilityService.isIOSPlatform();
		menuControllerVM.versionHide = constantConfig.version.versionHide;
		$rootScope.showInProgress = false;
		menuControllerVM.allNotificationsData = [];
		menuControllerVM.allAlertsData = [];
		menuControllerVM.allOffersData = [];
		menuControllerVM.showLoader = false;
		menuControllerVM.openSub = false;
		menuControllerVM.openPayments = true;
		menuControllerVM.openLogin = true;
		menuControllerVM.closePayments = false;
		menuControllerVM.openSBCollect = false;
		menuControllerVM.openBharatBill =false;
		menuControllerVM.ssproduct = {};
		menuControllerVM.securities=[];
		menuControllerVM.papl=false;
		menuControllerVM.noPAPL=true;
		menuControllerVM.openMsc = false;
		menuControllerVM.eMandate = false;
		menuControllerVM.openMscDesc = true;		
		$rootScope.customerName = localStorage.getItem('customername'); /*Home screen API Optimization: UX2.0 */
		menuControllerVM.imageUrl=""; /*Home screen API Optimization: UX2.0 */
		menuControllerVM.isProfilePicSet = false; /*Home screen API Optimization: UX2.0 */
		menuControllerVM.preShopAndOrderSubMenu=false;
		menuControllerVM.preBestOffersSubMenu=false;
		menuControllerVM.preShopAndOrderMenu=true;
		menuControllerVM.closeShop=false;

		$ionicModal.fromTemplateUrl('pages/mPinLogin/mpinLoginModel.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function (modal) {
			$rootScope.modal = modal
		});

		$ionicModal.fromTemplateUrl('pages/menu/overlay.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function (modal) {
			$scope.modal = modal;
		});

		menuControllerVM.showpopup = function () {
			menuControllerVM.option = "sup";
			var alertPopup = $ionicPopup.alert({
				template: "<p style='text-align:center;font-weight:bold;font-size:16px'>Coming Soon</p>"
			});
		};

		menuControllerVM.homeScreen = function () {
			menuControllerVM.option = "home";
			menuControllerVM.ompStart = 'f';
			$state.go('menu.homeScreen');
			$ionicSideMenuDelegate.toggleLeft();
		};

		menuControllerVM.subOpen = function () {
			menuControllerVM.option = "home";
			menuControllerVM.ompStart = 'f';
			menuControllerVM.openSub = true;
			menuControllerVM.openPayments = false;
			menuControllerVM.openLogin = false;
			menuControllerVM.closePayments = true;
			menuControllerVM.openSBCollect = true;
			menuControllerVM.openBharatBill =true;
			menuControllerVM.preShopAndOrderSubMenu=false;
			menuControllerVM.preBestOffersSubMenu=false;
			menuControllerVM.preShopAndOrderMenu=false;
			menuControllerVM.closeShop=false;
			menuControllerVM.openMsc = false;
			menuControllerVM.eMandate = false;
			menuControllerVM.openMscDesc = false;		
		};
		menuControllerVM.openMscMenu = function () {
			menuControllerVM.option = "home";
			menuControllerVM.ompStart = 'f';
			menuControllerVM.openSub = false;

			menuControllerVM.openLogin = false;
			menuControllerVM.closePayments = false;
			menuControllerVM.closeShop = false;			
			menuControllerVM.openMsc = true;			
			menuControllerVM.openMscDesc = false;

			menuControllerVM.eMandate = true;
			menuControllerVM.openPayments = false;			
			menuControllerVM.openSBCollect = false;			
			menuControllerVM.openBharatBill = false;
			menuControllerVM.preShopAndOrderSubMenu = false;
			menuControllerVM.preBestOffersSubMenu = false;
			menuControllerVM.preShopAndOrderMenu = false;			
		}
menuControllerVM.payments = function () {
	menuControllerVM.option = "home";
	menuControllerVM.ompStart = 'f';
	menuControllerVM.openSub = false;
	menuControllerVM.openPayments = true;
	menuControllerVM.openLogin = true;
	menuControllerVM.closePayments = false;
	menuControllerVM.openSBCollect = false;
	menuControllerVM.openBharatBill =false;
			menuControllerVM.preShopAndOrderSubMenu=false;
			menuControllerVM.preBestOffersSubMenu=false;
			menuControllerVM.preShopAndOrderMenu=true;
			menuControllerVM.closeShop=false;
			menuControllerVM.openMscDesc = true;			
		};

		menuControllerVM.subOpenPayment = function () {
			menuControllerVM.submenu=true;
			menuControllerVM.option = "home";
			menuControllerVM.ompStart = 'f';
			menuControllerVM.openSub = true;
			menuControllerVM.openPayments = false;
			menuControllerVM.openLogin=false;
			menuControllerVM.openLoginPayment = false;
			menuControllerVM.openLoginShop = true;
			menuControllerVM.openLoginCards = true;
			menuControllerVM.openLoginInsure = true;
			menuControllerVM.openLoginInvest = true;
			menuControllerVM.openLoginLoan = true;
			menuControllerVM.openLoginDeposit = true;
			menuControllerVM.closePayments = true;
			menuControllerVM.closeCards = false;
			menuControllerVM.closeShop = false;
			menuControllerVM.closeInsure = false;
			menuControllerVM.closeInvest = false;
			menuControllerVM.closeLoan = false;
			menuControllerVM.closeDeposit = false;
			menuControllerVM.openSBCollect = true;
			menuControllerVM.openBharatBill =true;
			 $ionicScrollDelegate.scrollTop();
		};

		menuControllerVM.paymentsLogin= function () {
			menuControllerVM.submenu=false;
			menuControllerVM.option = "home";
			menuControllerVM.ompStart = 'f';
			menuControllerVM.openSub = false;
			menuControllerVM.openPayments = true;
			menuControllerVM.openLogin=true;
			menuControllerVM.openLoginPayment = true;
			menuControllerVM.closePayments = false;
			menuControllerVM.openSBCollect = false;
			menuControllerVM.openBharatBill =false;

		};
		menuControllerVM.subOpenMenuCards = function () {
			menuControllerVM.submenu=true;
			menuControllerVM.option = "home";
			menuControllerVM.ompStart = 'f';
			menuControllerVM.openSub = true;
			//menuControllerVM.openCards = false;
			menuControllerVM.openLogin=false;
			menuControllerVM.openLoginCards = false;
			menuControllerVM.closeCards = true;
			menuControllerVM.closePayments = false;
			menuControllerVM.closeShop = false;
			menuControllerVM.closeInsure = false;
			menuControllerVM.closeInvest = false;
			menuControllerVM.closeLoan = false;
			menuControllerVM.closeDeposit = false;

			menuControllerVM.openLoginPayment = true;
			menuControllerVM.openLoginShop = true;
			menuControllerVM.openLoginInsure = true;
			menuControllerVM.openLoginInvest = true;
			menuControllerVM.openLoginLoan = true;
			menuControllerVM.openLoginDeposit = true;
			$ionicScrollDelegate.scrollTop();
		};
		menuControllerVM.menucards = function () {
			menuControllerVM.submenu=false;
			menuControllerVM.option = "home";
			menuControllerVM.ompStart = 'f';
			menuControllerVM.openSub = false;
			//menuControllerVM.openCards = true;
			menuControllerVM.openLogin=true;
			menuControllerVM.openLoginCards = true;
			menuControllerVM.closeCards = false;
		};

menuControllerVM.subOpenMenuShop = function () {
			menuControllerVM.submenu=true;
	menuControllerVM.option = "home";
	menuControllerVM.ompStart = 'f';
	menuControllerVM.openSub = true;
	//menuControllerVM.openShop = false;
	menuControllerVM.openLogin=false;
	menuControllerVM.openLoginShop = false;
	menuControllerVM.closeShop = true;

	menuControllerVM.closePayments = false;
	menuControllerVM.closeCards = false;
	menuControllerVM.closeInsure = false;
	menuControllerVM.closeInvest = false;
	menuControllerVM.closeLoan = false;
	menuControllerVM.closeDeposit = false;

	menuControllerVM.openLoginPayment = true;
	menuControllerVM.openLoginCards = true;
	menuControllerVM.openLoginInsure = true;
	menuControllerVM.openLoginInvest = true;
	menuControllerVM.openLoginLoan = true;
	menuControllerVM.openLoginDeposit = true;
	var hideLoader = true; /*Home Screen API Optimization: UX2.0*/
};
menuControllerVM.menuShop = function () {
			menuControllerVM.submenu=false;
	menuControllerVM.option = "home";
	menuControllerVM.ompStart = 'f';
	menuControllerVM.openSub = false;
			menuControllerVM.openPayments = true;
	menuControllerVM.openLogin=true;
	menuControllerVM.openLoginShop = true;
	menuControllerVM.closeShop = false;
			menuControllerVM.preShopAndOrderSubMenu=false;
			menuControllerVM.preBestOffersSubMenu=false;
			menuControllerVM.preShopAndOrderMenu=true;
			menuControllerVM.openMscDesc = true;			
	$ionicScrollDelegate.scrollTop();
};
menuControllerVM.subOpenMenuInsure = function () {
			menuControllerVM.submenu=true;
	menuControllerVM.option = "home";
	menuControllerVM.ompStart = 'f';
	menuControllerVM.openSub = true;
	//menuControllerVM.openShop = false;
	menuControllerVM.openLogin=false;
	menuControllerVM.openLoginInsure = false;
	menuControllerVM.closeInsure = true;

	menuControllerVM.closePayments = false;
	menuControllerVM.closeCards = false;
	menuControllerVM.closeShop = false;
	menuControllerVM.closeInvest = false;
	menuControllerVM.closeLoan = false;
	menuControllerVM.closeDeposit = false;

	menuControllerVM.openLoginPayment = true;
	menuControllerVM.openLoginShop = true;
	menuControllerVM.openLoginCards = true;
	menuControllerVM.openLoginInvest = true;
	menuControllerVM.openLoginLoan = true;
	menuControllerVM.openLoginDeposit = true;
	$ionicScrollDelegate.scrollTop();


};
menuControllerVM.menuInsure = function () {
			menuControllerVM.submenu=false;
	menuControllerVM.option = "home";
	menuControllerVM.ompStart = 'f';
	menuControllerVM.openSub = false;
//	menuControllerVM.openShop = true;
	menuControllerVM.openLogin=true;
	menuControllerVM.openLoginInsure = true;
	menuControllerVM.closeInsure = false;
};

menuControllerVM.subOpenMenuInvest = function () {
			menuControllerVM.submenu=true;
	menuControllerVM.option = "home";
	menuControllerVM.ompStart = 'f';
	menuControllerVM.openSub = true;
	//menuControllerVM.openShop = false;
	menuControllerVM.openLogin=false;
	menuControllerVM.openLoginInvest = false;
	menuControllerVM.closeInvest = true;

	menuControllerVM.closePayments = false;
	menuControllerVM.closeCards = false;
	menuControllerVM.closeShop = false;
	menuControllerVM.closeInsure = false;
	menuControllerVM.closeLoan = false;
	menuControllerVM.closeDeposit = false;

	menuControllerVM.openLoginPayment = true;
	menuControllerVM.openLoginShop = true;
	menuControllerVM.openLoginCards = true;
	menuControllerVM.openLoginInsure = true;
	menuControllerVM.openLoginLoan = true;
	menuControllerVM.openLoginDeposit = true;
$ionicScrollDelegate.scrollTop();
					//menuControllerVM.getAllMFPortfolioData();



};
menuControllerVM.menuInvest = function () {
			menuControllerVM.submenu=false;
	menuControllerVM.option = "home";
	menuControllerVM.ompStart = 'f';
	menuControllerVM.openSub = false;
//	menuControllerVM.openShop = true;
	menuControllerVM.openLogin=true;
	menuControllerVM.openLoginInvest = true;
	menuControllerVM.closeInvest = false;
};
menuControllerVM.subOpenMenuLoan = function () {
			menuControllerVM.submenu=true;
	menuControllerVM.option = "home";
	menuControllerVM.ompStart = 'f';
	menuControllerVM.openSub = true;
	//menuControllerVM.openShop = false;
	menuControllerVM.openLogin=false;
	menuControllerVM.openLoginLoan = false;
	menuControllerVM.openLoginPayment = true;
	menuControllerVM.openLoginShop = true;
	menuControllerVM.openLoginCards = true;
	menuControllerVM.openLoginInsure = true;
	menuControllerVM.openLoginInvest = true;

	menuControllerVM.openLoginDeposit = true;

	menuControllerVM.closeLoan = true;

	menuControllerVM.closePayments = false;
	menuControllerVM.closeCards = false;
	menuControllerVM.closeShop = false;
	menuControllerVM.closeInsure = false;
	menuControllerVM.closeInvest = false;
	menuControllerVM.closeDeposit = false;
	$ionicScrollDelegate.scrollTop();
};
menuControllerVM.menuLoan = function () {
			menuControllerVM.submenu=false;
	menuControllerVM.option = "home";
	menuControllerVM.ompStart = 'f';
	menuControllerVM.openSub = false;
//	menuControllerVM.openShop = true;
	menuControllerVM.openLogin=true;
	menuControllerVM.openLoginLoan = true;
	menuControllerVM.closeLoan = false;
};
menuControllerVM.subOpenMenuDeposit = function () {
			menuControllerVM.submenu=true;
	menuControllerVM.option = "home";
	menuControllerVM.ompStart = 'f';
	menuControllerVM.openSub = true;
	//menuControllerVM.openShop = false;
	menuControllerVM.openLogin=false;
	menuControllerVM.openLoginDeposit = false;
	menuControllerVM.closeDeposit = true;

	menuControllerVM.closePayments = false;
	menuControllerVM.closeCards = false;
	menuControllerVM.closeShop = false;
	menuControllerVM.closeInsure = false;
	menuControllerVM.closeInvest = false;
	menuControllerVM.closeLoan = false;

	menuControllerVM.closePayments = false;
	menuControllerVM.closeCards = false;
	menuControllerVM.closeShop = false;
	menuControllerVM.closeInsure = false;
	menuControllerVM.closeInvest = false;
	menuControllerVM.closeLoan = false;

	menuControllerVM.openLoginPayment = true;
	menuControllerVM.openLoginShop = true;
	menuControllerVM.openLoginCards = true;
	menuControllerVM.openLoginInsure = true;
	menuControllerVM.openLoginInvest = true;
	menuControllerVM.openLoginLoan = true;
 $ionicScrollDelegate.scrollTop();
};
menuControllerVM.menuDeposit = function () {
	menuControllerVM.option = "home";
	menuControllerVM.ompStart = 'f';
	menuControllerVM.openSub = false;
//	menuControllerVM.openShop = true;
	menuControllerVM.openLogin=true;
	menuControllerVM.openLoginDeposit = true;
	menuControllerVM.closeDeposit = false;
			menuControllerVM.submenu=false;
};



		menuControllerVM.accountOpening = function () {
			menuControllerVM.option = "acOp";
			menuControllerVM.ompStart = 'f';
			$state.go('menu.homePage');
		}

		menuControllerVM.accountOverviewMyBalance = function () {
			menuControllerVM.option = "aov";
			menuControllerVM.ompStart = 'f';
			$state.go('menu.accountOverviewMyBalance');
		};

		menuControllerVM.fundTransfer = function () {
			homeScreenService.isBackCheck = true;
			homeScreenService.ishamMenu = true;
			homeScreenService.ishamburgerMenuFT = true;
			menuControllerVM.option = "ft";
			menuControllerVM.ompStart = 'f';
			$ionicSideMenuDelegate.toggleLeft();
			$state.go('menu.fundsTransfer');
		};

		menuControllerVM.fundTransferLanding = function () {
			homeScreenService.isBackCheck = true;
			homeScreenService.ishamMenu = true;
			homeScreenService.ishamburgerMenuFTL = true;
			menuControllerVM.option = "ft";
			menuControllerVM.ompStart = 'f';
			$ionicSideMenuDelegate.toggleLeft();
			$state.go('menu.fundsTransferLanding');
		};

		menuControllerVM.loans = function () {
			menuControllerVM.option = "loans";
			$state.go('menu.loans');
		}

		menuControllerVM.serviceRequest = function () {
			homeScreenService.isBackCheck = true;
			menuControllerVM.option = "serReq";
			homeScreenService.ishamburgerMenuSR=true;
			$state.go('menu.serviceRequest');
			$ionicSideMenuDelegate.toggleLeft();
		};

		menuControllerVM.pendingRequest = function () {
			menuControllerVM.option = "pendingReq";
			$state.go('menu.pendingRequest');
		};

		menuControllerVM.pendingRequest = function () {
			menuControllerVM.option = "pendingReq";
			$state.go('menu.pendingRequest');
		};

		menuControllerVM.wishList = function () {
			menuControllerVM.option = "wish";
			menuControllerVM.ompStart = 't';
			$state.go('menu.wishList');
		};

		menuControllerVM.getwishListCount = function () {
			return wishListService.wishCount;
		};

		menuControllerVM.isLoggedIn = function () {
			return mPinLoginService.isLoggedIn;
		};

		menuControllerVM.omp = function () {
		homeScreenService.ishamburgerMenuomp=true;
			$ionicSideMenuDelegate.toggleLeft();
			homeScreenService.menuOption="omp";
			menuControllerVM.option = "omp";
			menuControllerVM.ompStart = 't';
			clickStreamService.clickStreamData = "websiteId," + "";
			if (homeScreenService.dummymenuCheck == true) {
				$state.go('menu.menudummy');
			}
			else {
				$state.go('menu.ompMerchants');
			}
		};

		menuControllerVM.book = function () {
			homeScreenService.ishamburgerMenuBookMain=true;
			$ionicSideMenuDelegate.toggleLeft();
			menuControllerVM.option = "book";
			menuControllerVM.ompStart = 't';
			$state.go('menu.bookings');
		};

		menuControllerVM.settings = function () {
			menuControllerVM.option = "set";
			menuControllerVM.ompStart = 'f';
			$state.go('menu.settings');
		};

		menuControllerVM.myProfile = function () {
			$state.go('menu.myProfile');
		}

		menuControllerVM.logout = function () {
			var logoutConfirmationPopup = $ionicPopup.show({
				title: null,
				cssClass: 'my-custom-popup',
				template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="LOGOUT_APP"></div>',
				buttons: [{
					text: 'YES',
					type: 'button-assertive',
					onTap: function () {
						logoutConfirmationPopup.close();
						//service to get if csat screen needs to be displayed or not
						csatService.getGoldenJourneyStatus().then(function (data) {
							if (data.csatFeedbackType == constantConfig.CSAT.CSAT_CSR || data.csatFeedbackType == constantConfig.CSAT.CSAT_NPR) {
								csatService.showCsatScreen = true;
								csatService.csatScreenType = data.csatFeedbackType;
								$state.go('menu.csatLanding');
							}
							else {
								csatService.showCsatScreen = false;
								utilityService.showSpinner();
								sessionStorage.setItem('getNRICounterFromLocalStorage', "0");
								clearServiceDataService.clearServiceData();
								menuControllerVM.getCSATDetails();
							}
						}, function (error) {
							//utilityService.showErrorMessage(error.responseMessage);
							utilityService.showSpinner();
							sessionStorage.setItem('getNRICounterFromLocalStorage', "0");
							clearServiceDataService.clearServiceData();
							menuControllerVM.getCSATDetails();
						});
					}
				},
				{
					text: 'NO',
					type: 'button-assertive',
					onTap: function () {
						logoutConfirmationPopup.close();
					}
				}],
			});
			// utilityService.showSpinner();
			// clearServiceDataService.clearServiceData();
			// menuControllerVM.getCSATDetails();
		};

		menuControllerVM.getCSATDetails = function () {
			utilityService.hideSpinner();
			menuControllerVM.sessionLogout();
			
			//CSAT Code is removed for improvement UX 2.0
			// if (menuControllerVM.isLoggedIn()) {
			// 	if (utilityService.timeSpent > 0) {
			// 		utilityService.setCsatJournies('ompShoppingDeals');
			// 	}
			// 	var allJournies = utilityService.getCsatJournies();
			// 	feedebackService.getFeedbackData(allJournies).then(function (data) {
			// 		utilityService.hideSpinner();
			// 		if (!data || data == null) {
			// 			mPinLoginService.isLoggedIn = false;
			// 			menuControllerVM.sessionLogout();
			// 		} else {
			// 			mPinLoginService.isLoggedIn = false;
			// 			feedebackService.data = data;
			// 			$state.go('menu.feedback');
			// 		}
			// 	}, function (error) {
			// 		utilityService.hideSpinner();
			// 		mPinLoginService.isLoggedIn = false;
			// 		menuControllerVM.sessionLogout();
			// 	});
			// } else {
			// 	var allJournies = utilityService.getCsatJournies();
			// 	feedebackService.getFeedbackDataPreLogin(allJournies).then(function (data) {
			// 		utilityService.hideSpinner();
			// 		if (!data || data == null) {
			// 			mPinLoginService.isLoggedIn = false;
			// 			menuControllerVM.sessionLogout();
			// 		} else {
			// 			mPinLoginService.isLoggedIn = false;
			// 			feedebackService.data = data;
			// 			$state.go('menu.feedback');
			// 		}
			// 	}, function (error) {
			// 		utilityService.hideSpinner();
			// 		mPinLoginService.isLoggedIn = false;
			// 		menuControllerVM.sessionLogout();
			// 	});
			// }
		}

		menuControllerVM.sessionLogout = function () {
			AdapterUtils.sessionLogout().then(
				function (response) {
					console.log("Logout success !!");
					loggedInUserService.logoutUser(true);
				},
				function (error) {
					console.log("Logout failure !!!");
					loggedInUserService.logoutUser(true);
				}
			);
		}

		/* general Insurance Kiran */
		menuControllerVM.generalInsurance = function (label) {
			menuControllerVM.option = "prod";
			$state.go('menu.financialProducts');
		};

		menuControllerVM.billPay = function () {
			billDeskService.billDeskToken();
		}

		menuControllerVM.lifeInsurance = function () {
			$state.go('menu.lifeInsurance');
		};

		menuControllerVM.cards = function () {
			$state.go('menu.temp');
		}

		// New Design Functions


		menuControllerVM.redirectToUrl = function (url) {
			menuControllerVM.clearPreLoginOMPService();
			if (url == 'homeLoan') {
				$state.go('menu.loansLanding');
			}else if (url == 'menu.redirectionToRbiGilt') {
				$state.go('menu.redirectionToRbiGilt');
			}
			else if(url == 'menu.leadGenerationCreditCard'){
				$state.go('menu.leadGenerationCreditCard');
			}
			else if(url == 'menu.leadGenerationInsurance'){
				$state.go('menu.leadGenerationInsurance');
			} 
			else if(url == 'menu.investment'){
				$state.go('menu.leadGenerationInvestment');
			} else {
				loggedInUserService.productClicked = url;
				if($state.current.data.pageId=="OMP_MRCHT"){
					menuControllerVM.goToQuickPayLanding();
				}
				//$state.go('menu.userLogin');
			}
		}
		menuControllerVM.sbiCollect = function () {
			menuControllerVM.clearPreLoginOMPService();
			var url = loggedInUserService.sbiCollectUrl;
			var refInAppBrowser = cordova.ThemeableBrowser.open(url, '_system', {
				statusbar: {
					color: '#ffffffff'
				},
				toolbar: {
					height: 44,
					color: '#ffffffff',
					image: 'share'
				},
				closeButton: {
					wwwImage: 'img/inappback.png',
					align: 'left',
					event: 'closePressed'
				},
				backButtonCanClose: true
			});

		}

		menuControllerVM.billPayment = function () {
		        menuControllerVM.clearPreLoginOMPService();
			var url = loggedInUserService.billDeskUrl;
			var refInAppBrowser = cordova.ThemeableBrowser.open(url, '_system', {
				statusbar: {
					color: '#ffffffff'
				},
				toolbar: {
					height: 44,
					color: '#ffffffff',
					image: 'share'
				},
				closeButton: {
					wwwImage: 'img/inappback.png',
					align: 'left',
					event: 'closePressed'
				},
				backButtonCanClose: true
			});
		}
		menuControllerVM.openEMandate = function () {
			menuControllerVM.clearPreLoginOMPService();	
			menuService.fetchEMandUrl().then(function(data){
				if(!utilityService.isUndefined(data)){	
					var url = data;
					openUrlInAppbroswerService.openUrl (url, "");
				}
			}, function (error){
				utilityService.showErrorMessage(error.responseMessage);

			});	
		}

		
        
		menuControllerVM.debitCardEMandate = function () {
			menuControllerVM.clearPreLoginOMPService();	
			internetBankingService.preHomeBanners().then(function(data){
				if(!utilityService.isUndefined(data)){	
					var url = data.data.debitCardEmandateUrl;
					menuControllerVM.HCheck = data.data.debitCardUrlTempCode;
					if (menuControllerVM.HCheck == cryptoService.getSHA512EncryptedData(url).toString()) {
					openUrlInAppbroswerService.openUrl (url, "");	
					
					}
					else{
						
						utilityService.showErrorMessage($translate.instant('DEBITCARD_EMAND_ERR'));
					}	
				}
				else{
                     utilityService.showBhimUpiAlert("error", $translate.instant('DEBITCARD_EMAND_ERR'),"menu.landingPage","","");
			    }
			}, function (error){
				utilityService.showErrorMessage($translate.instant('DEBITCARD_EMAND_ERR'));

			});	
		}
		menuControllerVM.preShopSubMenu = function () {
			menuControllerVM.submenu=true;
			menuControllerVM.option = "home";
			menuControllerVM.ompStart = 'f';
			menuControllerVM.openSub = false;
			menuControllerVM.openPayments = false;
			menuControllerVM.openLogin = false;
			menuControllerVM.openMsc = false;
			menuControllerVM.closePayments = false;
			menuControllerVM.openSBCollect = false;
			menuControllerVM.openBharatBill = false;
			menuControllerVM.preShopAndOrderSubMenu=true;
			menuControllerVM.preBestOffersSubMenu=true;
			menuControllerVM.preShopAndOrderMenu=false;
			menuControllerVM.closeShop=true;
			menuControllerVM.eMandate = false;
			menuControllerVM.openMscDesc = false;
		}

		menuControllerVM.goToShopPage = function () {
			loggedInUserService.shopNOrderPre="1";
			localStorage.setItem('isRedirectedTowdsLoan', "");
			localStorage.setItem('redirectOnlyFlow', "");
			$state.go('menu.ompMerchants');
			//ionicToast.show("Please login to access this page", 'bottom', false, 3000);
		};
		menuControllerVM.bestOffers=function(){
			localStorage.setItem('isRedirectedTowdsLoan', "");
			localStorage.setItem('redirectOnlyFlow', "");
  			loggedInUserService.shopNOrderPre="1";
  			homeScreenService.categoryCode='OMPBO60';
  			homeScreenService.storeSelected='Best Offer';
  			clickStreamService.clickStreamData = "websiteId," +  homeScreenService.categoryCode;
  			$state.go('menu.merchantList');
		}
		// End New Design Functions


		menuControllerVM.yonocash = function () {
			 homeScreenService.isBackCheck = true;
			$ionicSideMenuDelegate.toggleLeft();
            $state.go('menu.yonoCash');


			// requestYCService.isUserWhiteListed().then(function(response) {
            //     if (response.isUserWhiteListed == true) {
			// 	   			$ionicSideMenuDelegate.toggleLeft();
            //        $state.go('menu.yonoCash');
            //     }else{
			// 		$ionicSideMenuDelegate.toggleLeft();
			// 		var comingsoonPopup = $ionicPopup.alert({
            //         template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
            //         + "Coming Soon" + '</div></div></div></div></div></div>',
            //         cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
            //         buttons: [
            //             {
            //                 text: 'OK',
            //                 type: 'button-positive',
            //                 onTap: function (e) {
            //                     comingsoonPopup.close();
            //                 }
            //             }
            //         ]
            //     });
			// 	}
            // }, function(error) {
			// 	$ionicSideMenuDelegate.toggleLeft();
			// 	 var comingsoonPopup = $ionicPopup.alert({
            //         template: '<div class="CSPadding font-dark-grey "><div class="parentCS"><img class="imgwidthCS" src="img/Coming_Soon_Illustration.svg"><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><div class="childCS">'
            //         + "Coming Soon" + '</div></div></div></div></div></div>',
            //         cssClass: 'custOpacity removePopup-head widthCS popupMargin ftpopup-body textAlignCenter custButtonCS button0pd',
            //         buttons: [
            //             {
            //                 text: 'OK',
            //                 type: 'button-positive',
            //                 onTap: function (e) {
            //                     comingsoonPopup.close();
            //                 }
            //             }
            //         ]
            //     });
            // });

		};


		//Support
		menuControllerVM.support = function () {
			menuControllerVM.option = "sup";
			$state.go('menu.support');
			$ionicSideMenuDelegate.toggleLeft();

		}

		menuControllerVM.report = function () {
			$state.go('menu.report');
			$ionicSideMenuDelegate.toggleLeft();
		}

		//public methods end
		menuControllerVM.setSelectedTab = function (index) {
			$scope.selectedTabIndex = index;
		};

		menuControllerVM.showNotification = function ($event) {
			$scope.selectedTabIndex = 1;
			if (!homeScreenService.isNotificationDataAvail) {
				menuControllerVM.showLoader = true;
				homeScreenService.getnotificationOffer().then(function (data) {
					homeScreenService.isNotificationDataAvail = true;
					menuControllerVM.showLoader = false;
					if (data.suggestedData.offers && data.suggestedData.alerts) {
						homeScreenService.offersData = data.suggestedData.offers;
						homeScreenService.alertsData = data.suggestedData.alerts;
						menuControllerVM.allNotificationsData = homeScreenService.offersData.concat(homeScreenService.alertsData);
						menuControllerVM.allOffersData = homeScreenService.offersData;
						menuControllerVM.allAlertsData = homeScreenService.alertsData;
						$rootScope.bellNotificationCnt = homeScreenService.getBellNotificationCount();
						menuControllerVM.setTabCount();
					}
				}, function (error) {
					homeScreenService.isNotificationDataAvail = false;
					menuControllerVM.showLoader = false;
				});
			} else {
				if (homeScreenService.offersData && homeScreenService.alertsData) {
					menuControllerVM.allNotificationsData = homeScreenService.offersData.concat(homeScreenService.alertsData);
					menuControllerVM.allOffersData = homeScreenService.offersData;
					menuControllerVM.allAlertsData = homeScreenService.alertsData;
					$rootScope.bellNotificationCnt = homeScreenService.getBellNotificationCount();
					menuControllerVM.setTabCount();
				}
			}
			menuControllerVM.option = "bellVisible";
			$scope.bellVisible = true;
			var instance = $scope.modal;
			$scope.modal.show();
			instance.scope.$on('modal.hidden', function () {
				menuControllerVM.option = "";
				$scope.bellVisible = false;
			});
		};

		menuControllerVM.openOffer = function (offerData) {
			if (offerData.messageType && offerData.messageType.toLowerCase() == "alert") {
				return;
			}
			$scope.modal.hide();
			angular.element(document.body).removeClass('modal-open');
			switch (offerData.category) {
				case 'LI':
					generalInsurenceHomeService.setGIProductsID(offerData.category);
					$state.go('menu.sbiLifeIntro');
					break;
				case 'DEMAT':
					openAccountService.setStatusOfOpenAccount(0);
					$state.go('menu.openSecurityAccount');
					break;
				case 'CC':
					cardsService.setParams({
						"cardName": offerData.name
					});
					$state.go('menu.cardIntroduction');
					break;
				case 'PAPL':
					menuControllerVM.openPal();
					break;
				case 'OMP':
					$state.go(offerData.stateGo);
					break;
				case 'GI':
					generalInsurenceHomeService.setGIProductsID(offerData.category);
					newCardService.setPostLoginSelectedMenu('insure');
					$state.go('menu.declaimer');
					break;
				case 'SS':
					sampoornSurakshaService.getPremiumAndNomineeInfo().then(function (data) {
						sampoornSurakshaService.clearAll();
						sampoornSurakshaService.setPremiumDetails(data);
						$state.go('menu.ssPremiumCalculation');
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
					break;
				case 'MF':
					$state.go('menu.introMutualFunds');
					break;//Here MF developer need to confirm redirection
				case 'IHL':
					menuControllerVM.createInsta();
					break;//Here MF developer need to confirm redirection
				default:
					break;
			}
		}

		menuControllerVM.createInsta = function () {
			instaHomeService.getFetchData().then(function (data) {
				instaHomeService.initialValueInsta();
				if (data) {
					instaHomeService.customer.accountno = data.loanAccountNumber;
					instaHomeService.customer.bestofferamount = data.maxLoanAmount;
					instaHomeService.customer.selectedamount = data.maxLoanAmount;
					instaHomeService.customer.interestrate = data.interestRate;
					instaHomeService.customer.loanduration = data.duration;
					instaHomeService.customer.processingfees = data.processingFees;
					instaHomeService.customer.creditToAccount = data.disbursementAccountNumber;
					instaHomeService.customer.mclr = data.mclr;
					instaHomeService.customer.nightMode = data.nightMode;
					instaHomeService.customer.reviewProcessingFee = data.reviewProcessingFee;
					instaHomeService.customer.minLoanAmount = data.minLoanAmount;
                    instaHomeService.customer.steppingAmount = data.steppingAmount;
					instaHomeService.customer.customerName = data.customerName;
				}
				$state.go('menu.instaCreate');
			}, function (error) {
				if(error.responseCode == '0002')
				{
					var instaAlreadyApplied = $ionicPopup.show({
					title: null,
					cssClass: 'my-custom-popup',
					template: '<div style="text-align:center"><img class="approvedIconPosition" src="img/errorImage.png"></div><div class="button_fund fontSize-subHeading roboto-light font-dark-grey">'+error.responseMessage+'</div>',
					buttons: [{
						text: 'OK',
						type: 'button-assertive'
					}]
				});
				}
				else{
					utilityService.showErrorMessage(error.responseMessage);
				}
			});

        };

		menuControllerVM.openPal = function () {
			personalLoanService.clearAll();
			personalLoanService.getLoanDetails().then(function (data) {

				personalLoanService.personalLoanData = data;
				personalLoanService.minDuration = data.minTenure;
				personalLoanService.maxDuration = data.maxTenure;
				personalLoanService.interestRate = data.interestRate;
				personalLoanService.product = data.productCode;
				personalLoanService.maxEmiLimit = data.maxPermissibleEMI;
				personalLoanService.processingFee = data.processingFee;
				personalLoanService.minBestOffer = data.minPalAmount;
				personalLoanService.activityCode = data.activityCode;
				personalLoanService.schemeCode = data.schemeCode;


				$state.go('menu.personalLoan');

			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		}


		menuControllerVM.setTabCount = function () {
			$scope.allCount = 0;
			$scope.OfferCount = 0;
			$scope.alertCount = 0;
			for (var i = 0; i < menuControllerVM.allNotificationsData.length; i++) {
				if (menuControllerVM.allNotificationsData[i].messageDescription) {
					$scope.allCount = $scope.allCount + 1;
				}
			}
			for (var i = 0; i < menuControllerVM.allAlertsData.length; i++) {
				if (menuControllerVM.allAlertsData[i].messageDescription) {
					$scope.alertCount = $scope.alertCount + 1;
				}
			}
			for (var i = 0; i < menuControllerVM.allOffersData.length; i++) {
				if (menuControllerVM.allOffersData[i].messageDescription) {
					$scope.OfferCount = $scope.OfferCount + 1;
				}
			}
		}

/*Hambergur changes starts*/
        menuControllerVM.openNewDigitalSavingsAccnt = function(){
                var dateRangeInfoPopUp = $ionicPopup.show({
                    template: "<div class='ss-error-header font-reg'>Oops!</div>"+"</br><p>In view of recent Supreme Court judgement, this facility has been temporarily disabled. </br>Inconvenience is regretted. </br></br>Please visit a branch to open an account.</p>",
                    title: '',
                    cssClass: 'hampopup dialog ' ,
                    scope: $scope,
                    buttons: [{
                        text: 'OK',
                        type: 'button-positive'
                    }]
                });
								$ionicSideMenuDelegate.toggleLeft();
        }

         menuControllerVM.createFD = function (taxSaverFlag) {
	 				 homeScreenService.isBackCheck = true;
					 $ionicSideMenuDelegate.toggleLeft(); //taxSaverFlag is true in case when customer selects Tax Saver FD
					 homeScreenService.ishamMenu=true;
			homeScreenService.menuOption="fixedDeposit";
			homeScreenService.fromHamFD=true;
			homeScreenService.ishamburgerMenuFD=true;
					 if(taxSaverFlag){
							fixedDepositService.customer.isPanAvailable = customerInfoService.customer.isPanAvailable;
							 if (fixedDepositService.customer.isPanAvailable === "" || fixedDepositService.customer.isPanAvailable === undefined || fixedDepositService.customer.isPanAvailable === null) {
								var alertPopup = $ionicPopup.show({
									title: '',
									template: '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PAN4" "></div><div class="FDpopup-margin fontSize-subHeading roboto-light font-dark-grey" translate="PAN1"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PAN2"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="PAN3"></div>',
									scope: $scope,
									cssClass: 'my-custom-popup',
									buttons: [{
										text: 'OK',
										type: 'button-assertive',
										onTap: function () {

											alertPopup.close();
										}
									}],
								});
		 					}
							else{
								fixedDepositService.initializeFDvariables();
							 	fixedDepositService.customer.isTaxable = taxSaverFlag;
							 	getAccountDetailsService.tabIndex.tabIndex = 1;
						if (homeScreenService.dummymenuCheck == true) {
							$state.go('menu.menudummy');
						}
						else {
							 	$state.go('menu.fixedDeposit');
						}
							 	$ionicSideMenuDelegate.toggleLeft();
							}
					 }
					 else{
							 fixedDepositService.initializeFDvariables();
							 fixedDepositService.customer.isTaxable = taxSaverFlag;
							 getAccountDetailsService.tabIndex.tabIndex = 1;
					if (homeScreenService.dummymenuCheck == true) {
						$state.go('menu.menudummy');
					}
					else {
							 $state.go('menu.fixedDeposit');
					}
							 $ionicSideMenuDelegate.toggleLeft();
					 }

        }

        menuControllerVM.createRD = function () {
					homeScreenService.isBackCheck = true;
					homeScreenService.ishamMenu=true;
					$ionicSideMenuDelegate.toggleLeft();
          rdService.initialValueStage();
          $state.go('menu.createRd');
        };

        menuControllerVM.createMyDream = function () {
        	homeScreenService.isBackCheck = true;
			homeScreenService.ishamMenu=true;
			$ionicSideMenuDelegate.toggleLeft();
          	// $state.go('menu.createMyDream');
          	myDreamsService.getDefaultDreams().then(function (response) {
                myDreamsService.defaultDreamsData = response;
                $state.go('menu.createNewDream');
            }, function (error) {
                utilityService.showBhimUpiAlert("error", error.responseMessage);
            });

			// homeScreenService.isBackCheck = true;
			// homeScreenService.ishamMenu=true;
			// $ionicSideMenuDelegate.toggleLeft();
   			// $state.go('menu.createMyDream');
        }

        //OD against FD redirection
        menuControllerVM.goToDeposits = function(){
			homeScreenService.ishamburgerMenuRO=true;
					$ionicSideMenuDelegate.toggleLeft();
             homeScreenService.isDepositsFlag = true;
			homeScreenService.menuOption="relationshipOverview";
             getAccountDetailsService.tabIndex.tabIndex=1;
			//console.log("inside goToDeposits");
			if (myBalanceService.dummymenuCheck == true) {
				$state.go('menu.menudummy');
			}
			else {
             $state.go('menu.accountOverviewMyBalance');
			}
        }

        menuControllerVM.educationLoan=function(){
				$ionicSideMenuDelegate.toggleLeft();
			// var idnew = "education";

			// lifeInsuranceBasicApplicationService.getHomeLoanRedirection1(idnew).then(function (response) {
			// 	if (idnew == "education" && utilityService.isAndroidPlatform()) {
			// 		ompMerchantsService.inChromeBrowser(response.url);
			// 	}
			// 	else {
			// 		ompMerchantsService.inAppBrowser(response.url);
			// 	}
			// }, function (error) {
			// 	utilityService.showErrorMessage(error.responseMessage);
			// });
			if(educationLoanService.getKnowMore()){
				$state.go('menu.eduKnowMore');
			}else{
				educationLoanService.knowMore().then(function(data) {
					educationLoanService.setKnowMore(data);
					$state.go('menu.eduKnowMore');
				}, function(error) {
					//utilityService.showErrorMessage(error.responseMessage);
					var idnew = "education";
					lifeInsuranceBasicApplicationService.getHomeLoanRedirection1(idnew).then(function (response) {
						if (idnew == "education" && utilityService.isAndroidPlatform()) {
							ompMerchantsService.inChromeBrowser(response.url);
						}else {
							ompMerchantsService.inAppBrowser(response.url);
						}
					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});
				});
			}
        }

        menuControllerVM.loans = function(loanType){
					homeScreenService.ishamMenu=true;
			homeScreenService.menuOption="loans";
			homeScreenService.isBackCheck = true;
					$ionicSideMenuDelegate.toggleLeft();
             homeLoanService.hambergerSelectedLoanType = loanType;
             //if(loanType == "home"){
		if (homeScreenService.dummymenuCheck == true) {
			$state.go('menu.menudummy');
		}
		else {
                $state.go('menu.loans');
             //}
        }
		}
				menuControllerVM.goToInvestments = function (quick) {
			if(quick == 'quick'){
				$ionicSideMenuDelegate.toggleLeft();
				$state.go('menu.mutualFunds');
				return true;
			}
			homeScreenService.ishamburgerMenuRO=true;
					$ionicSideMenuDelegate.toggleLeft();
					homeScreenService.isInvestmentFlag = true;
			homeScreenService.menuOption="relationshipOverview";
					getAccountDetailsService.tabIndex.tabIndex=3;
					if(myBalanceService.dummymenuCheck==true){
						$state.go('menu.menudummy');
					}
					else{
						$state.go('menu.accountOverviewMyBalance');
					}
						//$ionicSlideBoxDelegate.slide(getAccountDetailsService.tabIndex.tabIndex);
				}

		menuControllerVM.goToInvestmentsPreHomeLogin = function () {
			$ionicSideMenuDelegate.toggleLeft();
			$state.go('menu.Investments');
		}
				menuControllerVM.goToStartInvest = function(){
			homeScreenService.isBackCheck = true;
					$ionicSideMenuDelegate.toggleLeft();
						$state.go('menu.startInvesting');
				}
				menuControllerVM.introMutualFunds=function (){
			homeScreenService.isBackCheck = true;
					$ionicSideMenuDelegate.toggleLeft();
					$state.go('menu.introMutualFunds');
				}
		menuControllerVM.knowledgeSeries = function () {
			homeScreenService.isBackCheck = true;
					$ionicSideMenuDelegate.toggleLeft();
					$state.go('menu.securityKnowledgeSeries');
				}
		menuControllerVM.introSecurities = function () {
			homeScreenService.isBackCheck = true;
					$ionicSideMenuDelegate.toggleLeft();
					$state.go('menu.introSecurities');
				}
				menuControllerVM.viewAvailableMF=function (){
			var nfoArray=[];
			$ionicSideMenuDelegate.toggleLeft();
			homeScreenService.ishamburgerMenuViewMF=true;
			mutualFundsService.getAllMutualFunds().then(function (data) {
											if(data.fundList.length > 5){
											angular.forEach(data, function (value, key) {
													for(var i in value){
														if (value[i].fundSchemeName == "NFO") {
														 nfoArray.push(data.fundList[i]);
														 data.fundList.splice(i,1);
														 data.fundList.splice(1,0,nfoArray[0]);
													}
											}
									});
									}

											//data.fundList.splice(1,0,data.fundList[4])
											menuControllerVM.popularFunds = data.fundList;
											mutualFundsService.addFundList(menuControllerVM.popularFunds);
											$ionicLoading.hide();
											mutualFundsService.setPageId('quickBuy');
											$state.go('menu.mutualFundsList');
									}, function (error) {
											$ionicLoading.hide();
											utilityService.showErrorMessage(error.responseMessage);
									});

				}
				// menuControllerVM.goToInvestments = function() {
				// 	$ionicSideMenuDelegate.toggleLeft();
				//   homeScreenService.isInvestmentFlag = true;
				// 	//getAccountDetailsService.tabIndex.tabIndex=3;
				// 	$state.go('menu.accountOverviewMyBalance');
				// }


/*Hambergur changes ends*/

		$scope.showMenuContentOverlay = false;
		$scope.$watch(function () {
			return $ionicSideMenuDelegate.isOpenLeft();
		}, function (isOpen) {
			var self = this;
			if (isOpen) {
				$scope.showMenuContentOverlay = true;
			} else {
				$scope.showMenuContentOverlay = false;
			}
		});

		//to set common popup title
		$translate(['POPUP_TITLE']).then(function (translations) {
			$rootScope.popupTitle = translations['POPUP_TITLE'];
		});


				//New hamburger Menu redirection
		//0-TradeNow   1-LinkDematAccnt
		menuControllerVM.getSecurityProfile = function (value) {
			homeScreenService.ishamMenu = true;
			homeScreenService.isBackCheck = true;
			$ionicSideMenuDelegate.toggleLeft();
			menuControllerVM.accounts = getAccountDetailsService.accountOverviewData.accounts;
			mySecurityProfileService.addDetails(menuControllerVM.accounts);
			if (menuControllerVM.securities.dpList === null || menuControllerVM.securities.dpList === '') {
					if(value==0){
						menuControllerVM.goToInvestments();
					}
					else{
						$state.go('menu.linkAccount');
					}
			}
			else {
					if(value==0){
						$state.go("menu.securitiesPortfolio");
					}else{
							menuControllerVM.goToInvestments();
					}
			}
				}
		menuControllerVM.gotoAllInsurance = function () {
		$state.go('menu.generalInsurance');
		$ionicSideMenuDelegate.toggleLeft();
		};

				menuControllerVM.browseCards = function() {
			homeScreenService.ishamburgerMenuBrowseCards = true;
					homeScreenService.isBackCheck = true;
					$ionicSideMenuDelegate.toggleLeft();
				utilityService.showSpinner();
					homeScreenService.ishamMenu=true;
						if(cardCompareService.shikharFlag == true || cardCompareService.shikharFlag == "true"){
				utilityService.hideSpinner();
							$state.go('menu.shikharCards');
						}else if(cardCompareService.shikharFlag == false || cardCompareService.shikharFlag == "false"){
				utilityService.hideSpinner();
							newCardService.browseCards();
						}else{
				utilityService.hideSpinner();
							 utilityService.showErrorMessage("Unable to connect. Please try after some time");
						}
					};

				menuControllerVM.needAnalysis = function() {
			homeScreenService.ishamburgerMenuApplyNewCard=true;
			homeScreenService.ishamburgerMenuNeedAnalysis=true;
					homeScreenService.isBackCheck = true;
					$ionicSideMenuDelegate.toggleLeft();
					homeScreenService.ishamMenu=true;
						if(cardCompareService.shikharFlag == true || cardCompareService.shikharFlag == "true"){

							$state.go('menu.shikharCards');
						}else if(cardCompareService.shikharFlag == false || cardCompareService.shikharFlag == "false"){
							newCardService.needAnalysis();
						}else{
							 utilityService.showErrorMessage("Unable to connect. Please try after some time");
						}
					};

				menuControllerVM.goToCreditCard = function() {
			homeScreenService.ishamburgerMenuRO=true;
					$ionicSideMenuDelegate.toggleLeft();
					fTBeneficiaryService.isCreditCardFlag=true;
			homeScreenService.menuOption="relationshipOverview";
					getAccountDetailsService.tabIndex.tabIndex=5;
					if(myBalanceService.dummymenuCheck==true){
						$state.go('menu.menudummy');
					}
					else{
						$state.go('menu.accountOverviewMyBalance');
					}
				};

				menuControllerVM.ApplyNewCreditCard = function () {
			homeScreenService.ishamburgerMenuApplyNewCard=true;
					homeScreenService.isBackCheck = true;	
					homeScreenService.ishamMenu=true;
					$ionicSideMenuDelegate.toggleLeft();
						if(cardCompareService.shikharFlag == true || cardCompareService.shikharFlag == "true"){

							$state.go('menu.shikharCards');
						}else if(cardCompareService.shikharFlag == false || cardCompareService.shikharFlag == "false"){
							homeScreenService.ishamMenu=true;
							$state.go('menu.cardIntroduction');
						}else{
							 utilityService.showErrorMessage("Unable to connect. Please try after some time");
					}
				 };
		//Function to goto Simply Earn card - commenting below code due till business confirmation
		// menuControllerVM.gotoSimplyEarn = function () {
		// 	$ionicSideMenuDelegate.toggleLeft();
		// 	homeScreenService.yccKnowMoreFlag = true;
		// 	cardsService.setParams({ "cardName": "YONO SimplyEARN SBI Card" });
  //           $state.go('menu.cardPlatinum');
		// }
		// Function for consent revocation
		menuControllerVM.JVConsentRevocation = function(){
			$ionicSideMenuDelegate.toggleLeft();
            $state.go('menu.consentRevocation');
		}

				menuControllerVM.LinkCreditCard = function () {
			homeScreenService.ishamburgerMenuRO=true;
					homeScreenService.isBackCheck = true;
					homeScreenService.ishamMenu=true;
					$ionicSideMenuDelegate.toggleLeft();
			utilityService.hideSpinner();
					utilityService.showSpinner();
					linkCardService.getLinkedCards({}).then(function (response) {
									cardsService.errorLogger(response);
									switch (response.responseCode) {
											case cardConfig.responseCode["success"]:
													if (response) {
															menuControllerVM.cardList = (response.data.cards) ? response.data.cards : [];
							getAccountDetailsService.accountOverviewData.cards = response.data;
															cardsService.setCardList(menuControllerVM.cardList);
															menuControllerVM.showLinkCards = (menuControllerVM.cardList.length) ? false : true;
															if(menuControllerVM.showLinkCards==true){
																utilityService.hideSpinner();
																myBalanceService .LinkCreditCards();
															}
															else{
																utilityService.hideSpinner();
																fTBeneficiaryService.isCreditCardFlag=true;
								homeScreenService.menuOption="relationshipOverview";
																getAccountDetailsService.tabIndex.tabIndex=5;
																//console.log("inside goToCredit");
																if(myBalanceService.dummymenuCheck==true){
																	$state.go('menu.menudummy');
																}
																else{
																	$state.go('menu.accountOverviewMyBalance');
																}

															}
															// Vm.showLinkedSection = (Vm.cardList.length) ? true : false;
															// Vm.showNoCardsMsg = (Vm.cardList.length) ? false : true;
															// Vm.showDelinkCards = (Vm.cardList.length) ? true : false;
															// Vm.cardsSpinner = false;
													}
													break;
									}
							}, function (error) {
									// Vm.cardsSpinner = false;
									// Vm.showLinkCards = false;

									// if (Vm.showLinkedSection == false) {
									// 		Vm.showDelinkCards = false;
									// }
							});
				};





				 menuControllerVM.goToQuickTransfer= function() {
					$ionicSideMenuDelegate.toggleLeft();
					if (getAccountDetailsService.accountOverviewData) {
						$state.go('menu.quickTransferLanding');
					}
					else {
						var errorData = "Something went wrong. Please try again after sometime.";
						utilityService.showNfsAlertModal("", errorData, "menu.homeScreen", $scope, $state, "OK");
					}
				 };
				 menuControllerVM.goToBillPay = function() {
					 $ionicSideMenuDelegate.toggleLeft();
						 billDeskService.billDeskToken();
				 };
				 menuControllerVM.goToLifeInsurance= function() {
			homeScreenService.isBackCheck = true;
					 homeScreenService.ishamMenu=true;
					 $ionicSideMenuDelegate.toggleLeft();
			 $state.go('menu.generalInsurance');
				 };
				 menuControllerVM.goToPersonalAccidentInsurance= function() {
					 homeScreenService.ishamMenu=true;
					 $ionicSideMenuDelegate.toggleLeft();
					 newCardService.setPostLoginSelectedMenu('insure');
						$state.go('menu.declaimer');
						generalInsurenceHomeService.setGIProductsID("personal-accident-insurance");
				};
				 menuControllerVM.goToHealthInsurance= function() {
					 homeScreenService.ishamMenu=true;
					 $ionicSideMenuDelegate.toggleLeft();
					 newCardService.setPostLoginSelectedMenu('insure');
						 $state.go('menu.declaimer');
						 generalInsurenceHomeService.setGIProductsID("health-insurance");
				};
				menuControllerVM.goToTravelInsurance= function() {
					homeScreenService.ishamMenu=true;
					$ionicSideMenuDelegate.toggleLeft();
					newCardService.setPostLoginSelectedMenu('insure');
						$state.go('menu.declaimer');
						generalInsurenceHomeService.setGIProductsID("travel-insurance");
				};
				menuControllerVM.goToMotorInsurance= function() {
					homeScreenService.ishamMenu=true;
					$ionicSideMenuDelegate.toggleLeft();
					newCardService.setPostLoginSelectedMenu('insure');
						$state.go('menu.declaimer');
						generalInsurenceHomeService.setGIProductsID("motor-insurance");
				};
				menuControllerVM.goToHomeInsurance= function() {
					homeScreenService.ishamMenu=true;
					$ionicSideMenuDelegate.toggleLeft();
					newCardService.setPostLoginSelectedMenu('insure');
						$state.go('menu.declaimer');
						generalInsurenceHomeService.setGIProductsID("home-insurance");
				};
				menuControllerVM.goToBankAccount = function() {
			homeScreenService.isBackCheck = true;
						homeScreenService.ishamMenu=true;
						$ionicSideMenuDelegate.toggleLeft();
            $state.go('menu.fundsTransfer');
        };
				menuControllerVM.gotoSampoorn= function() {

					if(menuControllerVM.ssproduct.customerFlag=='true'){
							sampoornSurakshaService.getPremiumAndNomineeInfo().then(function(data) {
							sampoornSurakshaService.clearAll();
							sampoornSurakshaService.setPremiumDetails(data);
							$ionicSideMenuDelegate.toggleLeft();
							$state.go('menu.ssPremiumCalculation');
						}, function(error) {
							utilityService.showErrorMessage(error.responseMessage);
						});
					}
					else{
						sampoornSurakshaService.displayErrorPopUp("",sampoornSurakshaService.genericError,["cancel","Ok"],function(){
						},function(){
								clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "PROCEED_BTN"));
								$ionicSideMenuDelegate.toggleLeft();
								$state.go('menu.generalInsurance');
						});
					}
				};
				menuControllerVM.goToAllCategories = function (store) {
		    homeScreenService.ishamburgerMenuShop = true;
			homeScreenService.ishamburgerShop = true;
			homeScreenService.isBackCheck = true;
			homeScreenService.menuOption="allCategories";
			clickStreamService.clickStreamData = "websiteId," + "";
			if (menuControllerVM.errorflagShop === true) {
				utilityService.showErrorMessage(menuControllerVM.errormsg);
			}
			else {
				$ionicSideMenuDelegate.toggleLeft();
				utilityService.clearHistoryExceptCurrentView();
				if (homeScreenService.dummymenuCheck == true) {
					$state.go('menu.menudummy');
				}
				else {
					$state.go('menu.viewAllCategories');
				}
				}
			};

			menuControllerVM.goToStores = function (title,categoryCode) {
			$ionicSideMenuDelegate.toggleLeft();
			homeScreenService.ishamburgerMenuShop = true;
			homeScreenService.ishamburgerShop = true;
			homeScreenService.isBackCheck = true;
			homeScreenService.menuOption="shop";
		    homeScreenService.categoryCode=categoryCode;
			homeScreenService.storeSelected=title;
			clickStreamService.clickStreamData = "websiteId," + categoryCode;
			utilityService.clearHistoryExceptCurrentView();
			
				if (homeScreenService.dummymenuCheck == true) {
					$state.go('menu.menudummy');
				}
				else {
					$state.go('menu.merchantList');
				}
			};

				menuControllerVM.goToBookNOrder= function(store){
			homeScreenService.ishamburgerMenuBook = true;
			homeScreenService.ishamburgerBook = true;
			homeScreenService.isBackCheck = true;
			homeScreenService.menuOption="book";
					 if(menuControllerVM.errorflagBook===true){

					 utilityService.showErrorMessage(menuControllerVM.errormsg);
					 }
					 else{
					 $ionicSideMenuDelegate.toggleLeft();
					 for(var i=0;i<menuControllerVM.bookNOrder.length;i++){
					 if(store===menuControllerVM.bookNOrder[i].label){
						 menuControllerVM.selectedStore=menuControllerVM.bookNOrder[i];
					 }
				 }
						utilityService.clearHistoryExceptCurrentView();
						bookingsService.moreScore = menuControllerVM.selectedStore;
						bookingsService.store =menuControllerVM.bookNOrder;
						utilityService.clearHistoryExceptCurrentView();
						// ompMerchantsService.hamMenu="true";
			//	$state.go('menu.bookingList');
			if (homeScreenService.dummymenuCheck == true) {
			$state.go('menu.menudummy');
			}
			else {
						$state.go('menu.bookingList');
					}
				}
			}
				menuControllerVM.goToPAPL= function(){
					homeScreenService.getnotificationOffer().then(function (data) {

						if (data.suggestedData.offers && data.suggestedData.alerts) {
							homeScreenService.offersData = data.suggestedData.offers;

					for(var i=0 ; i <data.suggestedData.offers.length ; i++){
						if(data.suggestedData.offers[i].category == "PAPL"){
							menuControllerVM.papl=true;
							$ionicSideMenuDelegate.toggleLeft();
							menuControllerVM.openPal();
						}
				else{
					menuControllerVM.noPAPL=true;
					}
				}
			if(menuControllerVM.noPAPL==true && menuControllerVM.papl==false){
				var dateRangeInfoPopUp = $ionicPopup.show({
						template: "<div class='ss-error-header font-reg'>Oops!</div>"+"</br><p>You are not eligible for Pre Approved personal loan. </p>",
						title: '',
						cssClass: 'hampopup dialog ' ,
						scope: $scope,
						buttons: [{
								text: 'OK',
								type: 'button-positive'
						}]
				});
					//utilityService.showErrorMessage("Sorry! you are not eligible for Pre Approved personal loan.");
			}
		}
}, function (error) {
	homeScreenService.isNotificationDataAvail = false;
	menuControllerVM.showLoader = false;
	utilityService.showErrorMessage(error);
});
}

menuControllerVM.goToETax = function () {
			$ionicSideMenuDelegate.toggleLeft();
			$state.go('menu.eTax');
		}
		menuControllerVM.goToNCMC = function () {
			if (!getAccountDetailsService.accountOverviewData) {
                
                getAccountDetailsService.getAccountDetails().then(function (data) {
                	$ionicSideMenuDelegate.toggleLeft();
					$state.go('menu.NCMCLanding');
                    getAccountDetailsService.accountOverviewData = data;
                    
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
			else
			{
				$ionicSideMenuDelegate.toggleLeft();
				$state.go('menu.NCMCLanding');
			}
		}
		/* start donation code remove from iOS */
		menuControllerVM.goToDonation = function () {
			$ionicSideMenuDelegate.toggleLeft();
			$state.go('menu.donation');
		}
		/* end donation code remove from iOS */
		menuControllerVM.chatBot = function () {
			$state.go('menu.chatbotlanding');
		}
		$scope.$watch(function() {
			return $ionicSideMenuDelegate.$getByHandle('postLogin').isOpen();
		}, function(isOpen) {
		    if (isOpen && mPinLoginService.isLoggedIn ) {
					//console.log($rootScope);
		        // Menu Opened
					$ionicScrollDelegate.scrollTop();
					sampoornSurakshaService.checkCustomerStatus().then(function(data) {
						menuControllerVM.ssproduct = data;
					}, function(error) {
						//utilityService.showErrorMessage(error.responseMessage);
					});
					mySecurityProfileService.getSecProfile().then(function (data) {
							menuControllerVM.securities = data.securities;
							mutualFundsService.totalSecurities = menuControllerVM.securities;
							if (!menuControllerVM.securities.currentValue) {
									menuControllerVM.securities.currentValue = data.securities.currentValue
							}
							mutualFundsService.addTotalSecurities(parseFloat(menuControllerVM.securities.currentValue));
						}, function (error) {
						//utilityService.showErrorMessage(error.responseMessage);

					});

					// if (mutualFundsService.totalSecurities) {
					// 		menuControllerVM.securities = mutualFundsService.totalSecurities;
					// }
					fixedDepositService.accDetails = getAccountDetailsService.accountOverviewData.accounts;

					if(!cardCompareService.shikharFlag){
						cardCompareService.getShikharEligibilityCheck().then(function(response){
						cardCompareService.shikharFlag = response.data.shikharFlag;
					},function(error){
						cardCompareService.shikharFlag = "";
					});
					 }
		    }
		    else {
		        // Menu Closed
						menuControllerVM.openLoginPayment = true;
						menuControllerVM.openLoginShop = true;
						menuControllerVM.openLoginCards = true;
						menuControllerVM.openLoginInsure = true;
						menuControllerVM.openLoginInvest = true;
						menuControllerVM.openLoginLoan = true;
						menuControllerVM.openLoginDeposit = true;
						menuControllerVM.closeCards = false;
						menuControllerVM.closeShop = false;
						menuControllerVM.closeInsure = false;
						menuControllerVM.closeInvest = false;
						menuControllerVM.closeLoan = false;
						menuControllerVM.closeDeposit = false;
				        menuControllerVM.eMandate = false;
						menuControllerVM.paymentsLogin();
						menuControllerVM.menucards();
						menuControllerVM.menuShop();
						menuControllerVM.menuInsure();
						menuControllerVM.menuInvest();
						menuControllerVM.menuLoan();
						menuControllerVM.menuDeposit();

		    }
		});

		/*Home Screen Api optimization: UX2.0*/
		// menuControllerVM.getProfileImage = function () {
		// menuControllerVM.profileImg = menuControllerVM.imageUrl ? menuControllerVM.imageUrl : "";
		// 		var reqParams = {
		// 			"id": menuControllerVM.profileImg,
		// 			"documentClass": "LT_ProfileImage"
		// 		}
		// 		homeScreenService.retrieveImage(reqParams).then(function (response) {
		// 			console.log("success retrieving image in menu controller");
		// 			$rootScope.profileImageUrl = "data:image/jpeg;base64," + response.data.documentData;
		// 		}, function (error) {
		// 			console.log("failure retrieving image in menu controller");
		// 			$rootScope.profileImageUrl = 'img/profile_placeholder.svg';
		// 		});
		// }

		/*Home Screen Api optimization: UX2.0 : Calling profile image on menu icon click*/
		menuControllerVM.getProfileImage = function () {
			menuControllerVM.imageUrl = customerInfoService.customer.imageurl;
			if (menuControllerVM.isLoggedIn()) { /* check if user is logged in or not */
				console.log("profileimgid " + menuControllerVM.imageUrl);
				if ($rootScope.profileImageUrl == "") { /* check if image is already set or not */
					console.log("profile image not set");
					if (!menuControllerVM.imageUrl) { /* check if image url is empty string or undefined */
						$rootScope.profileImageUrl = 'img/profile_placeholder.svg';
						return;
					} else {
						var reqParams = {
							"id": menuControllerVM.imageUrl,
							"documentClass": "LT_ProfileImage"
						}
						homeScreenService.retrieveImage(reqParams).then(function (response) {
							console.log("success retrieving image in menu controller");
							$rootScope.profileImageUrl = "data:image/jpeg;base64," + response.data.documentData;
						}, function (error) {
							console.log("failure retrieving image in menu controller");
							$rootScope.profileImageUrl = 'img/profile_placeholder.svg';
						});
					}
				} else {
					if ($rootScope.profileImageUrl == 'img/profile_placeholder.svg' && menuControllerVM.imageUrl) { /* profile image is placeholder but image url is now available::send request for image */
						var reqParams = {
							"id": menuControllerVM.imageUrl,
							"documentClass": "LT_ProfileImage"
						}
						homeScreenService.retrieveImage(reqParams).then(function (response) {
							console.log("success retrieving image in menu controller");
							$rootScope.profileImageUrl = "data:image/jpeg;base64," + response.data.documentData;
						}, function (error) {
							console.log("failure retrieving image in menu controller");
							$rootScope.profileImageUrl = 'img/profile_placeholder.svg';
						});
					} else {
						//do nothing
					}
					console.log("profile image already set");
					//do nothing
				}
			} else {
				//do nothing
			}
		}

		menuControllerVM.gotoRinRaksha = function () {
			homeScreenService.isBackCheck = true;
			rrService.addRetrive(false);
			$ionicSideMenuDelegate.toggleLeft();
			$state.go('menu.rinnRaksha');
		}

		menuControllerVM.goToQuickPayLanding = function(){
			loggedInUserService.shopNOrderPre=''; //Reset OMP value after login  
			loggedInUserService.shopNOrderPreHash="";
			$state.go('menu.userLanding');
		}
	$scope.$on('$ionicView.loaded', function () {
			console.log("menu controller view loaded called");
			// if(menuControllerVM.isLoggedIn() && homeScreenService.isProfilePicSet==false){
			// 	homeScreenService.isProfilePicSet=true;
			// 	homeScreenService.getCustomerInfo().then(function (data) {
			// 	menuControllerVM.imageUrl =  data.customerInformation.imageUrl;
			// 	customerInfoService.customer.name = data.customerInformation.customerName;
			// 	customerInfoService.customer.type = data.customerInformation.customerType;
			// 	customerInfoService.customer.DOB =data.customerInformation.dob;
			// 	customerInfoService.customer.isPanAvailable = data.customerInformation.panNumber;
			// 	customerInfoService.customer.isStaffFlag =data.customerInformation.isStaffFlag;
			// 	customerInfoService.customer.emailID = data.customerInformation.emailID;
			// 	customerInfoService.customer.mobile = data.customerInformation.mobile;
			// 	customerInfoService.customer.title = data.customerInformation.title;
			// 	customerInfoService.customer.residentialStatus = data.customerInformation.residentialStatus;
			// 	$rootScope.customerName = data.customerInformation.customerName;
			// 	$rootScope.customerAccNo = data.customerInformation.accountNumber;
			// 	$rootScope.mobileNo = data.customerInformation.mobile;
			// 	localStorage.setItem("customername",data.customerInformation.customerName);
			// 	$scope.customerFullname = localStorage.getItem('customername');
			// 	homeScreenService.isCustomerInfoSaved = true;
			// 	//menuControllerVM.getProfileImage(); /* Profile image call is shifted to on click of hamburger menu */
			// 	}, function (error) {
			// 	$rootScope.profileImageUrl = 'img/profile_placeholder.svg';
			// 	});
			// } else {
			// 	//do nothing
			// }
		});
	/*Home Screen Api optimization: UX2.0*/

		 /** YONO splash sbi reality redirection */

		document.addEventListener("resume", onResumePage, false);

		function onResumePage() {
			if (!utilityService.lastTimeStamp) {
				utilityService.lastTimeStamp = new Date();
			} else {
				var diff = Math.ceil(((new Date()) - utilityService.lastTimeStamp) / 60000);
				if (diff > constantConfig.SBITIMEOUT) {
					//if(!AdapterUtils.isAppTimedOut) {
					return;
					//}
				}
			}
			setTimeout(function() {
				var data = localStorage.getItem('reraId');
				var pageRedirect = localStorage.getItem('isRedirectedTowdsLoan');
				var redirectOnly = localStorage.getItem('redirectOnlyFlow');

				if ((data && pageRedirect === "false") || redirectOnly === "true") {
					ompMerchantsService.ompSearchHistory="";
					if(loggedInUserService.shopNOrderPre){ //loan redirection incase of sbi reality prelogin
						loggedInUserService.shopNOrderPre=''; //Reset OMP value after login  
						loggedInUserService.shopNOrderPreHash="";
                       	$state.go('menu.userLanding');
					}else{
						if(mPinLoginService.isLoggedIn){
						$state.go('menu.loans');
						localStorage.setItem('isRedirectedTowdsLoan', "");
						localStorage.setItem('redirectOnlyFlow', "");
						}else{
							$state.go('menu.userLanding');
						}
					}
					
				}
			}, 900);
		}
		menuControllerVM.clearPreLoginOMPService=function(){
			loggedInUserService.shopNOrderPre=''; //Reset OMP value after login  
			loggedInUserService.shopNOrderPreHash="";
			localStorage.setItem('isRedirectedTowdsLoan', "");
			localStorage.setItem('redirectOnlyFlow', "");
		}
		 /** YONO splash sbi reality redirection ends */ 
		menuControllerVM.login = function(){
			loggedInUserService.shopNOrderPre=''; //Reset OMP value after login 
			loggedInUserService.shopNOrderPreHash="";
            $state.go('menu.userLogin');
         }

		menuControllerVM.goToDepositCalc = function () {
			homeScreenService.ishamburgerMenuRO = true;
			$ionicSideMenuDelegate.toggleLeft();
			$state.go('menu.calculateFDRD');
		}
		return this;
	});
