'use strict';
angularApp.controller('NCMCLandingController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"NCMCService","getAccountDetailsService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, NCMCService,getAccountDetailsService) {
			
			var NCMCLandingVm = this;
			
			function initPage() {

				
			};

			function initializeValues(){
				NCMCService.clearNCMCData();
				if (!getAccountDetailsService.accountOverviewData) {
                
                getAccountDetailsService.getAccountDetails().then(function (data) {
                	
                    getAccountDetailsService.accountOverviewData = data;
                    
                    
                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
			};

			NCMCLandingVm.goToManageNFC = function(){
				$ionicHistory.clearCache().then(function(){ $state.go('menu.NCMCManageNFC'); })
				
			};
			
			NCMCLandingVm.goToOfflineStmt = function(){
				$ionicHistory.clearCache().then(function(){ $state.go('menu.offlineNCMCStatement'); })
				
			};

			NCMCLandingVm.goToLoadNCMC = function(){
				$ionicHistory.clearCache().then(function(){ $state.go('menu.NCMCLoadCard'); })
				
			};
			NCMCLandingVm.goBacktoPrevious = function(){
				 $state.go('menu.homeScreen');
			};
			
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
				initializeValues();
				
			});

			return this;
		}
]);


