'use strict';

angularApp.controller('atmCardActivationController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"openAccountService",
	"$rootScope",
	"customerInfoService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"atmCardActivationService",
	"cardsService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		openAccountService,
		$rootScope,
		customerInfoService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		atmCardActivationService,
		cardsService) {

		//functions, variables that can be accessed from the HTML come here
		var atmCardActivationVm = this;
		atmCardActivationVm.isNextEnabled = true;



		atmCardActivationVm.init = function () {
			atmCardActivationVm.enableNext();
			//atmCardActivationVm.EnterCardNumer = atmCardActivationService.activationCardNumber;
			//atmCardActivationVm.accList = atmCardActivationService.accList;
			//atmCardActivationVm.selctValue = atmCardActivationService.selectedAccValue;
		
		}


		atmCardActivationVm.goToback = function () {
		$state.go('menu.innerPage');
		}

		atmCardActivationVm.selectedAccFun = function () {
			//atmCardActivationService.selectedAccValue = JSON.parse(atmCardActivationVm.selctValue);
			atmCardActivationService.selectedAccValue = atmCardActivationVm.selctValue;
			atmCardActivationVm.enableNext();
		}

		atmCardActivationVm.cardNum = function () {
			atmCardActivationService.activationCardNumber = atmCardActivationVm.EnterCardNumer;
			atmCardActivationVm.showNameError = atmCardActivationVm.EnterCardNumer.length;
			
			
				
			atmCardActivationVm.enableNext();
				
			
		}

		
		

		atmCardActivationVm.goToNext  = function () {
				var selectedAccountNumber = JSON.parse(atmCardActivationService.selectedAccValue);
				var reqParams = {
					cardNumber: atmCardActivationService.activationCardNumber,
					accountNumber: selectedAccountNumber.accountNumber
				}
				
				atmCardActivationService.debitCardEnquiry(reqParams).then(function (data) {

						var reqData = {
				// "id": customerInfoService.customer.mobile,
				// "emailId": customerInfoService.customer.emailID
				 "id": customerInfoService.customer.mobile,
				 "emailId": customerInfoService.customer.emailID
			}

			personalLoanService.otpLoan(reqData).then(function (data) {
				//personalLoanService.otp=data.otp;
				$state.go('menu.atmCardActivationOtp');
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			
				
			});

				


					
				//alert(JSON.stringify(data));
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				
					
						
					
				});
			
			
				
		}

		atmCardActivationVm.enableNext = function() {
			
			if(atmCardActivationVm.selctValue != "" && atmCardActivationVm.selctValue != undefined && atmCardActivationVm.EnterCardNumer != undefined  && atmCardActivationService.activationCardNumber != "" && atmCardActivationVm.showNameError === 16 ){
				atmCardActivationVm.isNextEnabled = false;
			}else{
								atmCardActivationVm.isNextEnabled = true;

			}

		}

		atmCardActivationVm.goToHome = function () {

			$state.go('menu.homeScreen');
		}

		atmCardActivationVm.ok = function () {
				atmCardActivationVm.myPopup.close();
				$state.go('menu.atmCardActivationOtp');
			};

			

			$scope.$on('$ionicView.loaded', function () {

		
						atmCardActivationService.accountFilterRequest().then(function (data) {
							atmCardActivationService.accList = data.accList;	
							atmCardActivationVm.accList = atmCardActivationService.accList;
							

					console.log(JSON.stringify(data));
					//alert(JSON.stringify(data));
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
				
			
		
		});

				$scope.$on('$ionicView.beforeEnter', function () {

							

				atmCardActivationVm.init();
				



		});









		return this;
	}
]);
