'use strict';

angularApp.service('chequeEnquiryService',
	function ($q, AdapterUtils) {

		var chequeEnquiryService = this;

		chequeEnquiryService.typesOfCheque = "single";
		chequeEnquiryService.fromCheque = "";
		chequeEnquiryService.toCheque = "";
		chequeEnquiryService.EnterCheque = "";
		chequeEnquiryService.accList = [];
		chequeEnquiryService.cardList = [];
		chequeEnquiryService.chequeDetails = {};
		chequeEnquiryService.referenceNumber = "";
		chequeEnquiryService.selectedAccValue = null;
		chequeEnquiryService.selectedCardValue = null;
		chequeEnquiryService.blockAllCards = false;
		chequeEnquiryService.selectedCardType = "";
		chequeEnquiryService.multiSelectedCardType = "";

		
		chequeEnquiryService.clearAll  = function () {

		chequeEnquiryService.typesOfCheque = "single";
		chequeEnquiryService.fromCheque = "";
		chequeEnquiryService.toCheque = "";
		chequeEnquiryService.EnterCheque = "";
		chequeEnquiryService.accList = [];
		chequeEnquiryService.cardList = [];
		chequeEnquiryService.chequeDetails = {};
		chequeEnquiryService.referenceNumber = "";
		chequeEnquiryService.selectedAccValue = null;
		chequeEnquiryService.selectedCardValue = null;
		chequeEnquiryService.selectedCardType = "";
		chequeEnquiryService.blockAllCards = false;
		chequeEnquiryService.selectedCardType = "";
		chequeEnquiryService.multiSelectedCardType = "";

		}
		chequeEnquiryService.chequeAccountFilterRequest = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/chequeAccountFilterRequest", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		chequeEnquiryService.getTnC = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getTnC", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		chequeEnquiryService.chequeStatusEnquiry = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/chequeStatusEnquiry", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		

		return chequeEnquiryService;
	});
