angularApp.service('DSBSService',
    function($q, AdapterUtils, utilityService, constantConfig) {

        var DSBSService = this;
  
    DSBSService.getAccountList = function (reqData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/DoorStepServices/getAccountsForDoorStep", reqData, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;
         };
        
         DSBSService.doDSBEnqiry = function (reqData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/DoorStepServices/enquiryForDoorStepBankingRegistration", reqData, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;
         };


         DSBSService.getTNCContent = function (reqData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/DoorStepServices/dsbRegistrationTnC", reqData, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;
         };


         DSBSService.doDSBRegistration = function (reqData) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/DoorStepServices/submitForDoorStepBankingRegistration", reqData, true).then(
                
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;
         };
       

        return DSBSService;

    });