'use strict';

angularApp.controller('TNCContentController', [
    "$state",
    "$scope",
    "$translate",
    "fTBeneficiaryService",
    "cancelScheduledPaymentService",
    "$ionicHistory",
    "$ionicPopup",
    "utilityService",
    "constantConfig",
    "AdapterUtils",
    "$ionicScrollDelegate",
    "fTReviewService",
    "ionicToast",
    "loggedInUserService",
    "cryptoService",
    "getAccountDetailsService",
    "customerInfoService",
    "homeScreenService",
    "$rootScope",
    "billDeskService",
    "applyNowService",
    "personalLoanService",
    "sampoornSurakshaService",
    "cardsService",
    "lifeInsuranceBasicApplicationService",
    "requestYCService",
    "$ionicSideMenuDelegate",
    "$filter","DSBSService",

    function($state,
        $scope,
        $translate,
        fTBeneficiaryService,
        cancelScheduledPaymentService,
        $ionicHistory,
        $ionicPopup,
        utilityService,
        constantConfig,
        AdapterUtils,
        $ionicScrollDelegate,
        fTReviewService, ionicToast,
        loggedInUserService, cryptoService,
        getAccountDetailsService,
        customerInfoService,
        homeScreenService,
        $rootScope,
        billDeskService,
        applyNowService,
        personalLoanService,
        sampoornSurakshaService,
        cardsService,
        lifeInsuranceBasicApplicationService,
        requestYCService,
        $ionicSideMenuDelegate,
        $filter,DSBSService) {


            var TNCContentVm = this;

            TNCContentVm.isRegistration = DSBSService.isRegistration;
            TNCContentVm.disableNext = false;
            
            $scope.$on('$ionicView.beforeEnter', function() {
                TNCContentVm.disclamerText = DSBSService.disclamerText;
                TNCContentVm.disclamerContent = DSBSService.disclamerContent;
                TNCContentVm.agreeText = DSBSService.agreeText;
                

            
            });


            TNCContentVm.goToUserLanding = function () {
                $ionicHistory.goBack(-1);
            }
                  
            
    TNCContentVm.agree = function(){
        
        TNCContentVm.accountNumber = DSBSService.accountNumber;
        TNCContentVm.balance = DSBSService.balance;
        TNCContentVm.selectedAccount = DSBSService.selectedAccount;
        TNCContentVm.accType = DSBSService.accType;
        var request = {}
        request.doorStepFlag = "1";
        request.accountNumber = TNCContentVm.accountNumber;
        
        
        DSBSService.doDSBRegistration(request).then(function(data) {
            DSBSService.accountNumber = TNCContentVm.accountNumber;
            $state.go('menu.DSBRegistrationSuccess');
        }, function(error) {
            utilityService.showErrorMessage(error.responseMessage);
        });
    }
      }

]);    
    