'use strict';

angularApp.controller('emailDetailsController', ["$state",
	"$ionicPopup",
	"$scope",
	"emaillDetailsService",
	"serviceRequestService",
	"utilityService",

	function ($state,
		$ionicPopup,
		$scope,
		emaillDetailsService,
		serviceRequestService,
		utilityService) {

		var emailDetailsVm = this;

		emailDetailsVm.init = function () {
			
			emailDetailsVm.eyesOff = true;
			emailDetailsVm.eyesOn = false;

			emailDetailsVm.MobileOpenEye = false;
			emailDetailsVm.emailOpenEye = false;
			emailDetailsVm.panOpenEye = false;

			emailDetailsVm.MobileCloseEye = true;
			emailDetailsVm.emailCloseEye = true;
			emailDetailsVm.panCloseEye = true;
			emailDetailsVm.isN2WhiteListedUser = false;
			//emailDetailsVm.openEye = false;
			//emailDetailsVm.CloseEye = true;
			
			
	
			

		}

		emailDetailsVm.eyesOffFun = function (mask){
				emailDetailsVm.eyesOff = true;
				emailDetailsVm.eyesOn = false;
				//emailDetailsVm.openEye = false;
				//emailDetailsVm.CloseEye = true;
				if(mask =="mobile"){
					emailDetailsVm.mobileNumber = utilityService.maskData(emailDetailsVm.dataList.mobileNumber, "front", 2);
					emailDetailsVm.MobileCloseEye = true;
					emailDetailsVm.MobileOpenEye = false;
	
				}else if(mask =="email"){
					emailDetailsVm.maskemailID = utilityService.maskData(emailDetailsVm.dataList.emailId, "front", 0, "@");
					emailDetailsVm.emailCloseEye = true;
					emailDetailsVm.emailOpenEye = false;
	
				
				}else if(mask =="pan"){
					
					emailDetailsVm.maskPan = utilityService.maskData(emailDetailsVm.dataList.panNumber, "front", 4);
					emailDetailsVm.panCloseEye = true;
					emailDetailsVm.panOpenEye = false;
			
				}
				
					
					
		}

		emailDetailsVm.eyesOnFun = function (mask){
				emailDetailsVm.eyesOff = false;
				emailDetailsVm.eyesOn = true;
				emailDetailsVm.openEye = true;
				emailDetailsVm.CloseEye = false;

				if(mask =="mobile"){
					emailDetailsVm.mobileNumber = emaillDetailsService.dataList.mobileNumber;
					emailDetailsVm.MobileCloseEye = false;
					emailDetailsVm.MobileOpenEye = true;
				}else if(mask =="email"){
					emailDetailsVm.maskemailID = emaillDetailsService.dataList.emailId;
					emailDetailsVm.emailCloseEye = false;
					emailDetailsVm.emailOpenEye = true;
					
				}else if(mask =="pan"){
					emailDetailsVm.maskPan = emaillDetailsService.dataList.panNumber;
					emailDetailsVm.panCloseEye = false;
					emailDetailsVm.panOpenEye = true;
				}

				
				
			
		}

		// function maskData(str, sequence, digit, splitstring) {
		// 	var backCharacters = "";
		// 	var frontCharacters = "";
		// 	var combinedCharacters = "";

		// 	if (splitstring) {
		// 		var testarray = str.split(splitstring);
		// 		var backCharacters = "";
		// 		var frontCharacters = "";
		// 		// for(var i=0;i<testarray[1].length;i++)
		// 		// {
		// 		//  backCharacters=backCharacters+"x";
		// 		// }

		// 		for (var i = 0; i < testarray[0].length; i++) {
		// 			if (i != digit) {
		// 				frontCharacters = frontCharacters + "x";
		// 			}
		// 			else {
		// 				frontCharacters = testarray[0][i];
		// 			}
		// 		}

		// 		combinedCharacters = frontCharacters + splitstring + testarray[1];

		// 	}
		// 	else {
		// 		var backCharacters = str.substring(str.length - digit);



		// 		var data2 = str.substring(0, str.length - digit);


		// 		// var data3="";
		// 		// var data4="";

		// 		for (var i = 0; i < data2.length; i++) {
		// 			frontCharacters = frontCharacters + "X";
		// 		}



		// 		if (sequence == "front") {
		// 			combinedCharacters = frontCharacters + backCharacters
		// 		}
		// 		else {
		// 			combinedCharacters = data2 + frontCharacters;
		// 		}
		// 	}




		// 	return combinedCharacters;

		// }

		emailDetailsVm.emailFun = function () {

			emaillDetailsService.emailupdate = true;
			emaillDetailsService.CorrAdd = false;
			//$state.go('menu.emailUpdate');
			$state.go('menu.profilePwd');

		}

		emailDetailsVm.panFun = function () {
			emaillDetailsService.panUpdate = true;
			emaillDetailsService.emailupdate = false;
			emaillDetailsService.CorrAdd = false;
			$state.go('menu.emailUpdate');
		}

		emailDetailsVm.goToHome = function () {
			emaillDetailsService.clearAllData();
			$state.go('menu.homeScreen');

		}

		emailDetailsVm.goToback = function () {
			emaillDetailsService.clearAllData();
			$state.go('menu.serviceRequest');

		}

		emailDetailsVm.addressFun = function () {
			emaillDetailsService.emailupdate = false;
			emaillDetailsService.CorrAdd = true;
			serviceRequestService.kycAndNightModeValidation().then(function (data) {

				serviceRequestService.isNightMode = data.isNightMode;

				if (serviceRequestService.isNightMode) {

					var NightModetxt = "Request can not be processed now. Please try between 08:00 Hrs(IST) to 20.00 Hrs(IST).";
					utilityService.showNfsAlertModal("", NightModetxt, "menu.homeScreen", $scope, $state, "OK", "errorImgTitle");
				} else {
					$state.go('menu.emailUpdate')

				}

			}, function (error) {
				//utilityService.showErrorMessage(error.responseMessage);
				utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
			});


		}

		emailDetailsVm.updateMobile = function(){
			$state.go('menu.updateProfile');
		}

		emailDetailsVm.getdataList = function () {

			if (angular.equals({}, emaillDetailsService.dataList)) {

				emaillDetailsService.fetchDetails().then(function (data) {
					emaillDetailsService.dataList = data;
					emailDetailsVm.dataList = emaillDetailsService.dataList;
					emailDetailsVm.mobileNumber = utilityService.maskData(emailDetailsVm.dataList.mobileNumber, "front", 2);
					emailDetailsVm.maskemailID = utilityService.maskData(emailDetailsVm.dataList.emailId, "front", 0, "@");
					emailDetailsVm.maskPan = utilityService.maskData(emailDetailsVm.dataList.panNumber, "front", 4);
					if(emailDetailsVm.openEye){
						emailDetailsVm.eyesOnFun();
						
					}else{
						emailDetailsVm.eyesOffFun();
					}

					emailDetailsVm.isN2WhiteListedUser = emaillDetailsService.dataList.isN2WhiteListedUser ? emaillDetailsService.dataList.isN2WhiteListedUser : false;
					console.log(JSON.stringify(data));
					//alert(JSON.stringify(data));
				}, function (error) {

					utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
				});

			} else {
				emailDetailsVm.dataList = emaillDetailsService.dataList;

			}
			//emailDetailsVm.nextEnable();

		}

		$scope.$on('$ionicView.loaded', function () {


			emailDetailsVm.getdataList();

		});

		$scope.$on('$ionicView.beforeEnter', function () {

			emailDetailsVm.init();

		});



		return this;
	}
]);
