'use strict';

angularApp.controller('emailUpdateOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"openAccountService",
	"$rootScope",
	"customerInfoService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"emaillDetailsService",
	"loggedInUserService",
	"cryptoService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		openAccountService,
		$rootScope,
		customerInfoService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		emaillDetailsService,
		loggedInUserService,
		cryptoService) {

		//functions, variables that can be accessed from the HTML come here
		var emailUpdateOtpVm = this;
		emailUpdateOtpVm.otp = "";

		emailUpdateOtpVm.mobileNumber = $rootScope.mobileNo;
		var count = 0;
		emailUpdateOtpVm.disableCount = function () {
			count += 1;
			if (count >= 3) {
				emailUpdateOtpVm.isNextEnabled = true;
				emailUpdateOtpVm.isDisabledOTP = true;
			}

		}



		emailUpdateOtpVm.goToNext = function () {

			//emailUpdateOtpVm.showNameError1 = emailUpdateOtpVm.otp.length;

			if (emailUpdateOtpVm.otp.length < 6) {
				emailUpdateOtpVm.nextEnable();
			} else {

				var requestParams = {
					otp: emailUpdateOtpVm.otp,
					mobile: customerInfoService.customer.mobile
				}

				personalLoanService.requestOtp(requestParams).then(function (data) {

				emailUpdateOtpVm.emailupdate  = emaillDetailsService.emailupdate;
				emailUpdateOtpVm.CorrAdd  = emaillDetailsService.CorrAdd;

					if (data.status == "Success") {

						if (emaillDetailsService.emailupdate) {
							 $state.go('menu.profilePwd');
							// var hashEmail = loggedInUserService.tokenLotus + emaillDetailsService.emailId;
							// var emailSHA512 = cryptoService.getSHA512EncryptedData(hashEmail).toString();
							// console.log(emailSHA512);
							// var requestData = {
							// 	"emailId": emaillDetailsService.emailId,
							// 	"hash": emailSHA512
							// }
							// emaillDetailsService.update(requestData).then(function (data) {

							// 	console.log(JSON.stringify(data));
							// 	emailUpdateOtpVm.referenceNumber = data.referenceNumber;
							// 	emailUpdateOtpVm.myPopup = $ionicPopup.show({
							// 		title: '',
							// 		cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
							// 		templateUrl: 'pages/nfs/emailUpdate/Congratulations.html',
							// 		scope: $scope
							// 	});


							// }, function (error) {
							// 	utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
							// });

						} else {
							var addresshashEmail = loggedInUserService.tokenLotus + emaillDetailsService.add1 + emaillDetailsService.add2 + emaillDetailsService.add3 + emaillDetailsService.city +  emaillDetailsService.pinCode;
							var addressSHA512 = cryptoService.getSHA512EncryptedData(addresshashEmail).toString();
							console.log(addressSHA512);
							var requestData = {
								"addressLine1": emaillDetailsService.add1,
								"addressLine2": emaillDetailsService.add2,
								"addressLine3": emaillDetailsService.add3,
								"addressLine4": emaillDetailsService.city,
								"postalCode": emaillDetailsService.pinCode,
								"termsNcondition": true,
								"hash": addressSHA512
							}
							
							emaillDetailsService.updateCorrespondenceAddress(requestData).then(function (data) {

								console.log(JSON.stringify(data));
								emailUpdateOtpVm.referenceNumber = data.referenceNumber;
								emailUpdateOtpVm.myPopup = $ionicPopup.show({
									title: '',
									cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
									templateUrl: 'pages/nfs/emailUpdate/Congratulations.html',
									scope: $scope
								});


							}, function (error) {
								utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
							});

						}



					}
					else {

						emailUpdateOtpVm.disableCount();
						utilityService.showErrorMessage(data.status);
					}

				}, function (error) {

					// otp faliure
					emailUpdateOtpVm.disableCount();
					utilityService.showErrorMessage(error.responseMessage);
					emailUpdateOtpVm.otp = "";
					//$state.go('menu.serviceRequest');

				});

			}



		};

		emailUpdateOtpVm.nextEnable = function () {
			emailUpdateOtpVm.showNameError = emailUpdateOtpVm.otp.length;
			if (emailUpdateOtpVm.otp === emailUpdateOtpVm.otpValue)
				emailUpdateOtpVm.disableNext = false;
			else
				emailUpdateOtpVm.disableNext = true;
		}


		emailUpdateOtpVm.resendOTP = function () {
			if (emailUpdateOtpVm.isDisabledOTP) { return true }
			//    $scope.resendLable = true;
			//    $scope.sendLable = false;
			emailUpdateOtpVm.otp = "";
			var reqData = {
				"id": customerInfoService.customer.mobile,
				"emailId": customerInfoService.customer.emailID
			}
			personalLoanService.otpLoan(reqData).then(function (data) {

			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

			emailUpdateOtpVm.isDisabledOTP = true;
		}






		emailUpdateOtpVm.goToHome = function () {
			emaillDetailsService.clearAllData();
			$state.go('menu.homeScreen');

		}





		/* 	emailUpdateOtpVm.goToNext = function () {
				emailUpdateOtpVm.myPopup = $ionicPopup.show({
						title:'',
						cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
						templateUrl : 'pages/nfs/blockUnblock/Congratulations.html',
						scope:$scope
					});
				
			} */


		emailUpdateOtpVm.ok = function () {
			
			if(emaillDetailsService.emailupdate){
					utilityService.setCsatJournies('updateEmail');
			}else{
				utilityService.setCsatJournies('updateAddress');
			}
		
			emaillDetailsService.clearAllData();
			emailUpdateOtpVm.myPopup.close();
			//blockUnblockVm.otp = "";
			$state.go('menu.homeScreen');
		};

		$scope.$on('$ionicView.beforeEnter', function () {

			emailUpdateOtpVm.isDisabledOTP = false;

		});




		return this;
	}
]);
