'use strict';

angularApp.controller('forgotProfilePwdOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"openAccountService",
	"$rootScope",
	"customerInfoService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"fgtProfilePwdService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"loggedInUserService",
	"feedebackService",
	"cryptoService","inbForgotPwdService","clearServiceDataService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		openAccountService,
		$rootScope,
		customerInfoService,
		getAccountDetailsService,
		wishListService, 
		utilityService,
		fgtProfilePwdService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		loggedInUserService,
		feedebackService,
		cryptoService,inbForgotPwdService,clearServiceDataService) {
		var forgotProfilePwdOtpVm = this;

		var forgotProfilePwdOtpVm = this;
		forgotProfilePwdOtpVm.mobileNumber = $rootScope.mobileNo;
		forgotProfilePwdOtpVm.otp = "";
		var count = 0;
		forgotProfilePwdOtpVm.disableCount = function () {
			count += 1;
			if (count >= 3) {
				forgotProfilePwdOtpVm.isNextEnabled = true;
				forgotProfilePwdOtpVm.isDisabledOTP = true;
			}

		}

			
		forgotProfilePwdOtpVm.goToLogin = function () {
			
			forgotProfilePwdOtpVm.myPopup.close();
			utilityService.setCsatJournies('updateProfilePassword');
			utilityService.showSpinner();
			clearServiceDataService.clearServiceData();
			forgotProfilePwdOtpVm.getCSATDetails();

		};

		forgotProfilePwdOtpVm.getCSATDetails = function () {
			
	
			if (utilityService.timeSpent > 0) {
				utilityService.setCsatJournies('ompShoppingDeals');
			}
			var allJournies = utilityService.getCsatJournies();
				feedebackService.getFeedbackData(allJournies).then(function (data) {
				utilityService.hideSpinner();
				if (!data || data == null) {
					mPinLoginService.isLoggedIn = false;
			utilityService.hideSpinner();
			$state.go('menu.feedback');
				} else {
					
					feedebackService.data = data;
					utilityService.hideSpinner();
			$state.go('menu.feedback');
				}
			}, function (error) {
				utilityService.hideSpinner();
				
				loggedInUserService.logoutUser();
			});
		
		}

				forgotProfilePwdOtpVm.sessionLogout = function () {
			AdapterUtils.sessionLogout().then(
				function (response) {
				console.log("Logout success !!");
				loggedInUserService.logoutUser();
				},
				function (error) {
				console.log("Logout failure !!!");
				loggedInUserService.logoutUser();
				}
			);
		}

		forgotProfilePwdOtpVm.goToNext = function () {


			if (forgotProfilePwdOtpVm.otp.length < 6) {
				forgotProfilePwdOtpVm.nextEnable();

			} else {

				var requestParams = {
					otp: forgotProfilePwdOtpVm.otp
				}

				fgtProfilePwdService.validateOTPSecure(requestParams).then(function (data) {

					if (data.responseCode == "0000") {

						

						var loggedInUserDetails = loggedInUserService.getUserProfileDetails();
						var SaltValue = "|";
					var finalSHA512Val = cryptoService.encryptRSAWithPublicKey(fgtProfilePwdService.reEnterPassword, cryptoService.rsaPublicKey);

						var reqData = {
							"profilePassword": finalSHA512Val
						}
					

						fgtProfilePwdService.setProfilePassword(reqData).then(function (data) {
							forgotProfilePwdOtpVm.profilePassword=true;
							forgotProfilePwdOtpVm.myPopup = $ionicPopup.show({
							title: '',
							cssClass: 'ftpopup-body popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter',
							templateUrl: 'pages/nfs/forgotProfilePassword/ForgotProfileSuccessPopup.html',
							scope: $scope
						})
						}, function (error) {
							utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
						});



					}
					else {
						forgotProfilePwdOtpVm.disableCount();
						utilityService.showErrorMessage(data.status);
					}

				}, function (error) {
					forgotProfilePwdOtpVm.disableCount();
					utilityService.showErrorMessage(error.responseMessage);
				});



			}



		};

		forgotProfilePwdOtpVm.ok = function () {
			forgotProfilePwdOtpVm.myPopup.close();
			utilityService.setCsatJournies('updateProfilePassword');
			forgotProfilePwdOtpVm.otp = "";
			$state.go('menu.innerPage');
		};

		forgotProfilePwdOtpVm.goToHome = function () {

			$state.go('menu.homeScreen');
		}


		forgotProfilePwdOtpVm.nextEnable = function () {
			forgotProfilePwdOtpVm.showNameError = forgotProfilePwdOtpVm.otp.length;
			if (forgotProfilePwdOtpVm.otp === forgotProfilePwdOtpVm.otpValue)
				forgotProfilePwdOtpVm.disableNext = false;
			else
				forgotProfilePwdOtpVm.disableNext = true;
		}

		forgotProfilePwdOtpVm.resendOTP = function () {
			if (forgotProfilePwdOtpVm.isDisabledOTP) { return true }
			forgotProfilePwdOtpVm.otp = "";
			var finalSHA512Val = cryptoService.encryptRSAWithPublicKey(fgtProfilePwdService.reEnterPassword, cryptoService.rsaPublicKey);
			var reqData = {
				"toChange": finalSHA512Val,
				"mode":  inbForgotPwdService.profile,
				"journeyName":constantConfig.OTP_EMAIL_SMS_TEMPLATE.RESET_PROFILE_PASS
			}

			fgtProfilePwdService.getOTPSecure(reqData).then(function (data) {
			
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});

			forgotProfilePwdOtpVm.isDisabledOTP = true;
		}
		forgotProfilePwdOtpVm.goToBack = function () {

			$state.go('menu.newDebitCard');
		}
		return this;
	}
]);


