'use strict';

angularApp.controller('formSubDetailReviewController', ["$state",
	"$ionicPopup",
	"$scope",
	"requestChequeBookService",
	"serviceRequestService",
	"utilityService",
	"form15SubmissionService",
	"inbForgotPwdService",
	"inbLockUnlockService",
	"inbResetPwdService",
	"$ionicPopover",
	"NCMCService",

	function ($state,
		$ionicPopup,
		$scope,
		requestChequeBookService,
		serviceRequestService,
		utilityService,
		form15SubmissionService,
		inbForgotPwdService,
		inbLockUnlockService,
		inbResetPwdService,
		$ionicPopover,
		NCMCService) {

		var formSubDetailReviewControllerVm = this;
		// formSubDetailReviewControllerVm.isTelephoneTextMasked = true;
		// formSubDetailReviewControllerVm.isTelephoneTextUnMasked = false;
		// formSubDetailReviewControllerVm.isMobileTextMasked = true;
		// formSubDetailReviewControllerVm.isMobileTextUnMasked = false;
		// formSubDetailReviewControllerVm.isEmailTextMasked = true;
		// formSubDetailReviewControllerVm.isEmailTextUnMasked = false;

		formSubDetailReviewControllerVm.maskedTelephoneText = function () {
			formSubDetailReviewControllerVm.isTelephoneTextMasked = false;
			formSubDetailReviewControllerVm.isTelephoneTextUnMasked = true;
		};

		formSubDetailReviewControllerVm.unMaskedTelephoneText = function () {
			formSubDetailReviewControllerVm.isTelephoneTextUnMasked = false;
			formSubDetailReviewControllerVm.isTelephoneTextMasked = true;
		};

		formSubDetailReviewControllerVm.maskedMobileText = function () {
			formSubDetailReviewControllerVm.isMobileTextMasked = false;
			formSubDetailReviewControllerVm.isMobileTextUnMasked = true;
		};

		formSubDetailReviewControllerVm.unMaskedMobileText = function () {
			formSubDetailReviewControllerVm.isMobileTextUnMasked = false;
			formSubDetailReviewControllerVm.isMobileTextMasked = true;
		};

		formSubDetailReviewControllerVm.maskedEmailText = function () {
			formSubDetailReviewControllerVm.isEmailTextMasked = false;
			formSubDetailReviewControllerVm.isEmailTextUnMasked = true;
		};

		formSubDetailReviewControllerVm.unmaskedEmailText = function () {
			formSubDetailReviewControllerVm.isEmailTextUnMasked = false;
			formSubDetailReviewControllerVm.isEmailTextMasked = true;
		};

		formSubDetailReviewControllerVm.maskedPanText = function(){
			formSubDetailReviewControllerVm.isTextMasked = true;
			formSubDetailReviewControllerVm.isTextUnMasked = false;
		}

		formSubDetailReviewControllerVm.unMaskedPanText = function(){
			formSubDetailReviewControllerVm.isTextMasked = false;
			formSubDetailReviewControllerVm.isTextUnMasked = true;
		}

		formSubDetailReviewControllerVm.goToNext = function () {
			if (formSubDetailReviewControllerVm.validateForm()) {
				form15SubmissionService.getOTPTokenSecure().then(function (data) {
					$state.go('menu.formSubmisOtp');
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
		}

		formSubDetailReviewControllerVm.goBack = function () {
			$state.go('menu.formSubDetailScreenFour');
		}

		formSubDetailReviewControllerVm.infoDetails = function ($event) {
			if(utilityService.isIOSPlatform()){
              formSubDetailReviewControllerVm.topStyle = "margin-top : -5px; right:15px; width:90%; height:370px; left:unset !important;background: #d7d7d7 !important;";
            }
            else{
              formSubDetailReviewControllerVm.topStyle = "margin-top : 10px; right:15px; width:90%; height:370px; left:unset !important;background: #d7d7d7 !important;";
            }
			var template = '<ion-popover-view class=" loginnewarrow form15" style="{{formSubDetailReviewControllerVm.topStyle}}" id="nfsruntimeHeight" >' + '<div class="form-15-popover-arrow" style="right:11px !important;"></div>' + '<ion-content has-bouncing="false" class="pad-right-12">' +
				'<div id="renderHeight" class="text-left form15-pad-lft30 padding-right-10 font-size-12" translate=""><ul style="list-style-type:disc"><li class="margin-lft24" translate="NFS_SUB_REVIEW_ONE"></li><li class="margin-lft24" translate="NFS_SUB_REVIEW_TWO"></li></ul></div>' + '<div><p class="form15-tc-txt pad-left-6" translate="NFS_SUB_REVIEW_TWO_SUB_ONE"></p></div>' + '<div><p class="form15-tc-txt pad-left-6"  translate="NFS_SUB_REVIEW_TWO_SUB_TWO"></p></div>' + '</ion-content>' + '</ion-popover-view>';
			$scope.popover = $ionicPopover.fromTemplate(template, {
				scope: $scope
			});
			$scope.popover.show($event);
		}

		formSubDetailReviewControllerVm.closePopover = function () {
			$scope.popover.hide();
		}

		formSubDetailReviewControllerVm.termcondition = function () {
			if (form15SubmissionService.normalDec == "") {
				form15SubmissionService.getForm15GHSubmitDeclaration().then(function (data) {
					if (!utilityService.isUndefined(data)) {
						form15SubmissionService.normalDec = data;
						formSubDetailReviewControllerVm.termconditionPopUp(form15SubmissionService.normalDec);
					}
				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				formSubDetailReviewControllerVm.termconditionPopUp(form15SubmissionService.normalDec);
			}
		}

		formSubDetailReviewControllerVm.termconditionPopUp = function (TnCDetails) {
			var title = "";
			var buttontext = "OK";
			var detail = TnCDetails;
			NCMCService.showTnCAlertModal(title, detail, buttontext, function () { });
		}

		formSubDetailReviewControllerVm.validateForm = function () {
			formSubDetailReviewControllerVm.errObj = {};
			if (!formSubDetailReviewControllerVm.isChecked) {
				formSubDetailReviewControllerVm.errObj.isChecked = true;
			}
			return (angular.equals({}, formSubDetailReviewControllerVm.errObj)) ? true : false;
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			formSubDetailReviewControllerVm.maskedPanText();
			formSubDetailReviewControllerVm.unmaskedEmailText();
			formSubDetailReviewControllerVm.unMaskedTelephoneText();
			formSubDetailReviewControllerVm.unMaskedMobileText();
			formSubDetailReviewControllerVm.typeG = form15SubmissionService.fromTypeG;
			formSubDetailReviewControllerVm.typeH = form15SubmissionService.fromTypeH;
			formSubDetailReviewControllerVm.reviewPageDetails = form15SubmissionService.formDetails;
			formSubDetailReviewControllerVm.nameOfAssesse = form15SubmissionService.formDetails.customerName;
			formSubDetailReviewControllerVm.panNumber = form15SubmissionService.formDetails.panNumber;
			formSubDetailReviewControllerVm.dob = form15SubmissionService.formDetails.dob;
			formSubDetailReviewControllerVm.status = form15SubmissionService.formDetails.status;
			formSubDetailReviewControllerVm.previousYear = form15SubmissionService.formDetails.previousYear;
			formSubDetailReviewControllerVm.residentialStatus = form15SubmissionService.formDetails.residentialStatus;
			formSubDetailReviewControllerVm.completeAddress = form15SubmissionService.formDetails.completeAddress;
			formSubDetailReviewControllerVm.pinCode = form15SubmissionService.formDetails.pinCode;
			formSubDetailReviewControllerVm.emailId = form15SubmissionService.formDetails.emailId;
			formSubDetailReviewControllerVm.mobileNumber = form15SubmissionService.formDetails.mobileNumber;
			formSubDetailReviewControllerVm.telephoneNumber = form15SubmissionService.formDetails.telephoneNumber;
			formSubDetailReviewControllerVm.estimatedIncomeForDeclaration = form15SubmissionService.formDetails.estimatedIncomeForDeclaration;
			formSubDetailReviewControllerVm.valueChecked = form15SubmissionService.valueChecked;
			if(formSubDetailReviewControllerVm.valueChecked == 'Y'){
				formSubDetailReviewControllerVm.taxAct1961 = 'Yes';
				formSubDetailReviewControllerVm.taxAct1961Year = form15SubmissionService.selectedYear.value;
			}
			else{
				formSubDetailReviewControllerVm.taxAct1961 = 'No';
				formSubDetailReviewControllerVm.taxAct1961Year = '';
			}
			//formSubDetailReviewControllerVm.selectedYear = form15SubmissionService.selectedYear;
			//formSubDetailReviewControllerVm.taxAct1961 = form15SubmissionService.taxAct1961;
			//formSubDetailReviewControllerVm.taxAct1961Year = form15SubmissionService.assessedYear;
			formSubDetailReviewControllerVm.filedAggregateAmount = form15SubmissionService.filedAggregateAmount;
			formSubDetailReviewControllerVm.numOfFormFiled = form15SubmissionService.numOfFormFiled;
			formSubDetailReviewControllerVm.estimatedTotalPY = form15SubmissionService.estimTotalIncome;

			
				
		});

		return this;
	}
]);
