'use strict';

angularApp.controller('formSubmisDetailScreenOneController', ["$state",
	"$ionicPopup",
	"$scope",
	"requestChequeBookService",
	"serviceRequestService",
	"utilityService",
	"$ionicPopover",
	"form15SubmissionService",

	function ($state,
		$ionicPopup,
		$scope,
		requestChequeBookService,
		serviceRequestService,
		utilityService,
		$ionicPopover,
		form15SubmissionService) {

		var formSubmisDetailScreenOneControllerVm = this;
		formSubmisDetailScreenOneControllerVm.isTextMasked = true;
		formSubmisDetailScreenOneControllerVm.isTextUnMasked = false;

		formSubmisDetailScreenOneControllerVm.infoDetails = function ($event) {
			if(utilityService.isIOSPlatform()){
              formSubmisDetailScreenOneControllerVm.topStyle = "margin-top : -5px; right:15px; width:90%; height:300px; left:unset !important;background: #d7d7d7 !important;";
            }
            else{
              formSubmisDetailScreenOneControllerVm.topStyle = "margin-top : 10px; right:15px; width:90%; height:300px; left:unset !important;background: #d7d7d7 !important;";
            }   
			if(formSubmisDetailScreenOneControllerVm.typeG){
				var template = '<ion-popover-view class=" loginnewarrow form15"  id="nfsruntimeHeight" style="{{formSubmisDetailScreenOneControllerVm.topStyle}}">' + '<div class="form-15-popover-arrow" style="right:11px !important;" ></div>' + '<ion-content has-bouncing="false" class="col">' +
				'<div id="renderHeight" class="text-left form15-pad-lft30 padding-right-10 font-size-12" translate=""><ul style="list-style-type:disc"><li class="margin-lft24" translate="NFS_FORM_POPOVER_TEXT1"></li><li class="margin-lft24" translate="NFS_FORM_POPOVER_TEXT2"></li><li class="margin-lft24" translate="NFS_FORM_POPOVER_TEXT3"></li><li class="margin-lft24" translate="NFS_FORM_POPOVER_TEXT4"></li></ul></div>' + '</ion-content>' + '</ion-popover-view>';
			}
			else{
				var template = '<ion-popover-view class=" loginnewarrow"  id="nfsruntimeHeight" style="{{formSubmisDetailScreenOneControllerVm.topStyle}}">' + '<div class="form-15-popover-arrow" style="right:11px !important;" ></div>' + '<ion-content has-bouncing="false" class="col">' +
				'<div id="renderHeight" class="text-left form15-pad-lft30 padding-right-10 font-size-12" translate=""><ul style="list-style-type:disc"><li class="margin-lft24" translate="NFS_FORM_POPOVER_H_TEXT1"></li><li class="margin-lft24" translate="NFS_FORM_POPOVER_H_TEXT2"></li><li class="margin-lft24" translate="NFS_FORM_POPOVER_H_TEXT3"></li></ul></div>' + '</ion-content>' + '</ion-popover-view>';
			}
			
			$scope.popover = $ionicPopover.fromTemplate(template, {
				scope: $scope
			});
			$scope.popover.show($event);
		}
		formSubmisDetailScreenOneControllerVm.closePopover = function () {
			$scope.popover.hide();
		}

		formSubmisDetailScreenOneControllerVm.goToNext = function () {
			$state.go('menu.formSubmisDetailScreenTwo');
		}
		formSubmisDetailScreenOneControllerVm.goBack = function () {
			$state.go('menu.form15SubmissionLanding');
		}

		formSubmisDetailScreenOneControllerVm.maskedText = function () {
			formSubmisDetailScreenOneControllerVm.isTextMasked = false;
			formSubmisDetailScreenOneControllerVm.isTextUnMasked = true;

		};

		formSubmisDetailScreenOneControllerVm.unMaskedText = function () {
			formSubmisDetailScreenOneControllerVm.isTextUnMasked = false;
			formSubmisDetailScreenOneControllerVm.isTextMasked = true;
		};

		$scope.$on('$ionicView.beforeEnter', function () {
			formSubmisDetailScreenOneControllerVm.formOneDetails = form15SubmissionService.formDetails;
			formSubmisDetailScreenOneControllerVm.typeG = form15SubmissionService.fromTypeG;
			formSubmisDetailScreenOneControllerVm.typeH = form15SubmissionService.fromTypeH;
		});

		return this;
	}
]);
