'use strict';

angularApp.controller('formSubmisDetailScreenThreeController', ["$state",
	"$ionicPopup",
	"$scope",
	"requestChequeBookService",
	"serviceRequestService",
	"utilityService",
	"$ionicPopover",
	"form15SubmissionService",
	"$filter",
	function ($state,
		$ionicPopup,
		$scope,
		requestChequeBookService,
		serviceRequestService,
		utilityService,
		$ionicPopover,
		form15SubmissionService,
		$filter) {

		var formSubmisDetailScreenThreeControllerVm = this;
		
		formSubmisDetailScreenThreeControllerVm.validateAmount = function(){
			formSubmisDetailScreenThreeControllerVm.estimTotalIncomeError = false;
			if(formSubmisDetailScreenThreeControllerVm.estimTotalIncome && formSubmisDetailScreenThreeControllerVm.estimTotalIncome.split(".")[0].length > 6){
				formSubmisDetailScreenThreeControllerVm.estimTotalIncome = formSubmisDetailScreenThreeControllerVm.estimTotalIncome.slice(0, 6);
			}
		}	
		
		formSubmisDetailScreenThreeControllerVm.goToNext = function () {
			if(formSubmisDetailScreenThreeControllerVm.validateFormFields()){
				form15SubmissionService.valueChecked = formSubmisDetailScreenThreeControllerVm.valueChecked;
				form15SubmissionService.selectedYear = formSubmisDetailScreenThreeControllerVm.selectedYear;
				//form15SubmissionService.estimTotalIncome = Number(formSubmisDetailScreenThreeControllerVm.estimTotalIncome).toFixed(2);
				form15SubmissionService.estimTotalIncome = formSubmisDetailScreenThreeControllerVm.estimTotalIncome;
				$state.go('menu.formSubDetailScreenFour');
			}
		}

		formSubmisDetailScreenThreeControllerVm.validateFormFields = function(){
			formSubmisDetailScreenThreeControllerVm.valueCheckedError = false;
			formSubmisDetailScreenThreeControllerVm.selectedYearError = false;
			formSubmisDetailScreenThreeControllerVm.estimTotalIncomeError = false;
			if(!formSubmisDetailScreenThreeControllerVm.valueChecked){
				formSubmisDetailScreenThreeControllerVm.valueCheckedError = true;
				//return false
			}
			if(!formSubmisDetailScreenThreeControllerVm.selectedYear && !formSubmisDetailScreenThreeControllerVm.assessedYearFalg){
				formSubmisDetailScreenThreeControllerVm.selectedYearError = true;
				//return false
			}
			if(formSubmisDetailScreenThreeControllerVm.typeH && formSubmisDetailScreenThreeControllerVm.thirdPageDetails.isAgeGreaterThanEqualsEighty == "Y" && Number(formSubmisDetailScreenThreeControllerVm.estimTotalIncome) > 500000){
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeError = true;
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeErrorMsg = 'Maximum amount should not exceed Rs.5,00,000/-';
				//return false
			}
			if(formSubmisDetailScreenThreeControllerVm.typeH && formSubmisDetailScreenThreeControllerVm.thirdPageDetails.isAgeGreaterThanEqualsEighty == "N" && Number(formSubmisDetailScreenThreeControllerVm.estimTotalIncome) > 300000){
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeError = true;
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeErrorMsg = 'Maximum amount should not exceed Rs.3,00,000/-';
				//return false
			}
			if(formSubmisDetailScreenThreeControllerVm.thirdPageDetails.intProjectedAndPaidUnderCifAtBankLevel && 
			Number(formSubmisDetailScreenThreeControllerVm.thirdPageDetails.intProjectedAndPaidUnderCifAtBankLevel) > Number(formSubmisDetailScreenThreeControllerVm.estimTotalIncome)){
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeError = true;
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeErrorMsg = 'Please enter estimated total amount equals to or more than estimated income declared/projected TDS.';
				//return false
			}
			if(formSubmisDetailScreenThreeControllerVm.thirdPageDetails.estimatedIncomeForDeclaration && 
			Number(formSubmisDetailScreenThreeControllerVm.thirdPageDetails.estimatedIncomeForDeclaration) > Number(formSubmisDetailScreenThreeControllerVm.estimTotalIncome)){
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeError = true;
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeErrorMsg = 'Please enter estimated total amount equals to or more than estimated income declared/projected TDS.';
				//return false
			}
			if(formSubmisDetailScreenThreeControllerVm.typeG && formSubmisDetailScreenThreeControllerVm.estimTotalIncome && Number(formSubmisDetailScreenThreeControllerVm.estimTotalIncome) > 250000){
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeError = true;
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeErrorMsg = 'Maximum amount should not exceed Rs.2,50,000/-';
				//return false
			}
			if(formSubmisDetailScreenThreeControllerVm.estimTotalIncome && Number(formSubmisDetailScreenThreeControllerVm.estimTotalIncome) == 0){
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeError = true;
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeErrorMsg = 'Enter the valid amount';
				//return false
			}
			if(!formSubmisDetailScreenThreeControllerVm.estimTotalIncome){
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeError = true;
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeErrorMsg = 'Enter an amount';
				//return false
			}
			if(isNaN(formSubmisDetailScreenThreeControllerVm.estimTotalIncome)){
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeError = true;
				formSubmisDetailScreenThreeControllerVm.estimTotalIncomeErrorMsg = 'Enter the valid amount';
			}
			
			
			if(formSubmisDetailScreenThreeControllerVm.valueCheckedError || formSubmisDetailScreenThreeControllerVm.selectedYearError || formSubmisDetailScreenThreeControllerVm.estimTotalIncomeError){
				return false;
			}
			else{
				return true;
			}
			//return true;
		}

		formSubmisDetailScreenThreeControllerVm.changeVal = function (val) {
			if (val == "N") {
				formSubmisDetailScreenThreeControllerVm.assessedYearFalg = true;
				formSubmisDetailScreenThreeControllerVm.selectedYear = '';
			} else {
				formSubmisDetailScreenThreeControllerVm.assessedYearFalg = false;
			}
		}

		formSubmisDetailScreenThreeControllerVm.goBack = function () {
			$state.go('menu.formSubmisDetailScreenTwo');
		}

		formSubmisDetailScreenThreeControllerVm.radioYes = function () {
			form15SubmissionService.taxAct1961 = formSubmisDetailScreenThreeControllerVm.yes;
		}
		formSubmisDetailScreenThreeControllerVm.radioNo = function () {
			form15SubmissionService.taxAct1961 = formSubmisDetailScreenThreeControllerVm.no;
		}

		formSubmisDetailScreenThreeControllerVm.seletedYear = function () {
			form15SubmissionService.selectedYear = formSubmisDetailScreenThreeControllerVm.selectedYear;
		}

		formSubmisDetailScreenThreeControllerVm.infoDetails = function ($event) {
			if(utilityService.isIOSPlatform()){
              formSubmisDetailScreenThreeControllerVm.topStyle = "margin-top : -5px; right:15px; width:90%; height:250px; left:unset !important;background: #d7d7d7 !important;";
            }
            else{
              formSubmisDetailScreenThreeControllerVm.topStyle = "margin-top : 10px; right:15px; width:90%; height:250px; left:unset !important;background: #d7d7d7 !important;";
            }

			var template = '<ion-popover-view class=" loginnewarrow form15" style="{{formSubmisDetailScreenThreeControllerVm.topStyle}}" id="nfsruntimeHeight" >' + '<div class="form-15-popover-arrow" style="right:11px !important;"></div>' + '<ion-content has-bouncing="false" class="col">' +
				'<div id="renderHeight" class="text-left form15-pad-lft30 padding-right-10 font-size-12" translate=""><ul style="list-style-type:disc"><li class="margin-lft24" translate="NFS_SUB_THIRD_ONE"></li><li class="margin-lft24" translate="NFS_SUB_THIRD_TWO"></li></ul></div>' + '</ion-content>' + '</ion-popover-view>';

			$scope.popover = $ionicPopover.fromTemplate(template, {
				scope: $scope
			});
			$scope.popover.show($event);
		}
		formSubmisDetailScreenThreeControllerVm.closePopover = function () {
			$scope.popover.hide();
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			//form15SubmissionService.otherFormDetailsFlag = '';
			formSubmisDetailScreenThreeControllerVm.valueCheckedError = false;
			formSubmisDetailScreenThreeControllerVm.selectedYearError = false
			formSubmisDetailScreenThreeControllerVm.estimTotalIncomeError = false;

			formSubmisDetailScreenThreeControllerVm.typeG = form15SubmissionService.fromTypeG;
			formSubmisDetailScreenThreeControllerVm.typeH = form15SubmissionService.fromTypeH;
			if(utilityService.isIOSPlatform()){
				formSubmisDetailScreenThreeControllerVm.inputType = "text";
				//if(formSubmisDetailScreenThreeControllerVm.typeG){
					formSubmisDetailScreenThreeControllerVm.maxlength = "11";
				//}
				// else{
				// 	formSubmisDetailScreenThreeControllerVm.maxlength = "20";
				// }
			}
			else{
				formSubmisDetailScreenThreeControllerVm.inputType = "tel";
				//if(formSubmisDetailScreenThreeControllerVm.typeG){
					formSubmisDetailScreenThreeControllerVm.maxlength = "11";
				// }
				// else{
				// 	formSubmisDetailScreenThreeControllerVm.maxlength = "20";
				// }
			}
			
			if(formSubmisDetailScreenThreeControllerVm.typeG){
				formSubmisDetailScreenThreeControllerVm.count = 15;
			}
			if(formSubmisDetailScreenThreeControllerVm.typeH){
				formSubmisDetailScreenThreeControllerVm.count = 14;
			}
			formSubmisDetailScreenThreeControllerVm.thirdPageDetails = form15SubmissionService.formDetails;
			formSubmisDetailScreenThreeControllerVm.estimatedincome = form15SubmissionService.formDetails.estimatedIncomeForDeclaration;
			formSubmisDetailScreenThreeControllerVm.taxYears = formSubmisDetailScreenThreeControllerVm.thirdPageDetails.latestAssessmentYears;
			formSubmisDetailScreenThreeControllerVm.valueChecked = form15SubmissionService.valueChecked;
			if(form15SubmissionService.valueChecked == 'N'){
				formSubmisDetailScreenThreeControllerVm.assessedYearFalg = true;
			}
			formSubmisDetailScreenThreeControllerVm.selectedYear = form15SubmissionService.selectedYear;
			
			formSubmisDetailScreenThreeControllerVm.estimTotalIncome = form15SubmissionService.estimTotalIncome;
		});

		return this;
	}
]);
