'use strict';

angularApp.controller('formSubmisOtpController', [
		"$state",
		"$scope",		
		"utilityService",
		"customerInfoService","$filter","getAccountDetailsService","quickPayService","cryptoService","$stateParams","$ionicHistory",
		"loggedInUserService","form15SubmissionService",
		function($state, $scope,utilityService,customerInfoService,$filter,getAccountDetailsService,quickPayService,
			cryptoService,$stateParams,$ionicHistory,loggedInUserService,form15SubmissionService) {
			
			var formSubmisOtpControllerVm = this;

			function initPage(){
				formSubmisOtpControllerVm.otpCount = 0;
				formSubmisOtpControllerVm.clickCount = 0;
				formSubmisOtpControllerVm.isResendDisabled = false;
				formSubmisOtpControllerVm.mobileNumber = $filter('cardmask')(customerInfoService.customer.mobile, 'X', 4);
				
			}
			
			formSubmisOtpControllerVm.goNext = function(){
				formSubmisOtpControllerVm.resetPinOTP = "";
				if(!formSubmisOtpControllerVm.otpNumber){
					formSubmisOtpControllerVm.resetPinOTP = "Please Enter the OTP";
				}else if(formSubmisOtpControllerVm.otpNumber.length != 6){
					formSubmisOtpControllerVm.resetPinOTP = "Please enter 6 digits OTP";
				}else{
					var request = {
						"otp" : formSubmisOtpControllerVm.otpNumber
					}


         form15SubmissionService.validateOTP(request).then(function(data) {
						
			form15SubmissionService.confirmForm15GHSubmission().then(function (data) {
						$state.go('menu.formSubmissionSuccess');
				}, function (error) {
					formSubmisOtpControllerVm.otp = "";
					utilityService.showErrorMessage(error.responseMessage);
				});
						
						
						
					},function(error){
						formSubmisOtpControllerVm.otpNumber = "";
						formSubmisOtpControllerVm.otpCount++;
						if(formSubmisOtpControllerVm.otpCount >= 3){
							var title = '';
							var template = error.responseMessage;
							var onTap = '';
							var buttontext = "OK";
							//utilityService.showAlertModal(title, template, onTap, $scope, $state, buttontext);
							utilityService.showBhimUpiAlert('error', template, onTap, buttontext, $scope);
						}else{
							utilityService.showErrorMessage(error.responseMessage);
						}
					});
      
      





					
				}
			}

			formSubmisOtpControllerVm.resendOTP = function(){
				form15SubmissionService.getOTPTokenSecure().then(function(data) {
					formSubmisOtpControllerVm.otpNumber = "";
					formSubmisOtpControllerVm.resetPinOTP = "";
					formSubmisOtpControllerVm.clickCount++;
					if(formSubmisOtpControllerVm.clickCount >= 2){
						formSubmisOtpControllerVm.isResendDisabled = true;
					}
					var title = '';
					var template = "OTP has been sent to your registered mobile number.";
					var onTap = '';
					var buttontext = "OK";
					//utilityService.showAlertModal('', template, onTap, $scope, $state, buttontext);
					utilityService.showBhimUpiAlert('success', template, onTap, buttontext, $scope);
				},function(error){
					formSubmisOtpControllerVm.otpNumber = "";
					utilityService.showErrorMessage(error.responseMessage);
				});
			}





			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
				
			});
			
			return this;
		}

		
]);
