'use strict';

angularApp.service('form15SubmissionService',
    function ($q, AdapterUtils, accountDetailsService, utilityService, $state, $filter, $ionicPopup) {

        var form15SubmissionService = this;
        form15SubmissionService.cifNum = "";
        form15SubmissionService.custInfo = "";
        form15SubmissionService.formDetails = "";
        form15SubmissionService.fromTypeG = false;
        form15SubmissionService.fromTypeH = false;
        form15SubmissionService.latestAssessmentYears = "";
        form15SubmissionService.taxAct1961 = "";
        form15SubmissionService.assessedYear = "";
         form15SubmissionService.filedAggregateAmount = "";
         form15SubmissionService.numOfFormFiled = "";
         form15SubmissionService.valueChecked = "";
         form15SubmissionService.estimTotalIncome = "";
         form15SubmissionService.selectedYear = "";
         form15SubmissionService.normalDec ="";
         form15SubmissionService.branch ="";
        //  form15SubmissionService.estimTotalIncomeOfPY = "";
        //  form15SubmissionService.numOfFormFiled = "";
        //  form15SubmissionService.aggregateAmount ="";
         
        form15SubmissionService.clearServiceVars = function(){
            form15SubmissionService.cifNum = "";
        form15SubmissionService.custInfo = "";
        form15SubmissionService.formDetails = "";
        form15SubmissionService.fromTypeG = false;
        form15SubmissionService.fromTypeH = false;
        form15SubmissionService.latestAssessmentYears = "";
        form15SubmissionService.taxAct1961 = "";
        form15SubmissionService.assessedYear = "";
         form15SubmissionService.filedAggregateAmount = "";
         form15SubmissionService.numOfFormFiled = "";
         form15SubmissionService.valueChecked = "";
         form15SubmissionService.estimTotalIncome = "";
         form15SubmissionService.selectedYear = "";
         form15SubmissionService.normalDec ="";
         form15SubmissionService.branch ="";
        }
             form15SubmissionService.checkPreValidation  = function (reqParams) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/checkPreValidation", reqParams, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;

        }

        

        form15SubmissionService.getCifDetails = function (reqParams) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getCifDetails", reqParams, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;

        }

         form15SubmissionService.getMaskedCif = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getMaskedCif", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;

        }
             form15SubmissionService.getBranchList = function () {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getBranchList", {}, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;

        }

             form15SubmissionService.submitForm15GH = function (reqParams) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/submitForm15GH", reqParams, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {

                    q.reject(error);
                }
            );
            return q.promise;

        }

        form15SubmissionService.getForm15GHDetails = function (obj) {
			
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getForm15GHDetails",obj, true).then(
				function (response) {
					q.resolve(response);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		}

        
	form15SubmissionService.getOTPTokenSecure = function() {
	    var q = $q.defer();
	    AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", {}, true).then(
		    function(response) {
		        q.resolve(response.data);
		    },
		    function(error) {
		        q.reject(error);
		    }
	    );
        return q.promise;
    };

    form15SubmissionService.confirmForm15GHSubmission = function() {
	    var q = $q.defer();
	    AdapterUtils.postData("adapters/ServiceRequestAdapter/confirmForm15GHSubmission", {}, true).then(
		    function(response) {
		        q.resolve(response.data);
		    },
		    function(error) {
		        q.reject(error);
		    }
	    );
        return q.promise;
    };
       form15SubmissionService.getForm15GHSubmitDeclaration = function() {
	    var q = $q.defer();
	    AdapterUtils.postData("adapters/ServiceRequestAdapter/getForm15GHSubmitDeclaration", {}, true).then(
		    function(response) {
		        q.resolve(response.data);
		    },
		    function(error) {
		        q.reject(error);
		    }
	    );
        return q.promise;
    };


       form15SubmissionService.validateOTP = function(request) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", request, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };
    
        return form15SubmissionService;
    });
