'use strict';

angularApp.controller('hmbrTransferSuccessController', ["$state",
	"$ionicPopup",
	"$scope",
	"hmbrtService",
	"utilityService",
	"clickStreamService",
	function ($state,
		$ionicPopup,
		$scope,
		hmbrtService,
		utilityService,
		clickStreamService) {

		var hmbrTransferSuccessVm = this;

		hmbrTransferSuccessVm.init = function(){
			hmbrTransferSuccessVm.homeBranch = hmbrtService.selectedBranch.branchName;
			clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId));
		}

		hmbrTransferSuccessVm.relationships = function(){
			$state.go('menu.accountOverviewMyBalance');
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			hmbrTransferSuccessVm.init();
		});

		return this;
	}
]);
