'use strict';

angularApp.controller('inbForgotPasswordController', ["$state",
	"$ionicPopup",
	"$scope",
	"$filter",
	"loggedInUserService",
	"cryptoService",
	"utilityService",
	"fTReviewService",
	"accountDetailsService",
	"inbForgotPwdService",

	function ($state,
		$ionicPopup,
		$scope,
		$filter,
		loggedInUserService,
		cryptoService,
		utilityService,
		fTReviewService,
		accountDetailsService,
		inbForgotPwdService) {

		var inbForgotPasswordVm = this;
		// inbForgotPasswordVm.inbUser = loggedInUserService.getInbUserId().data.inbUserId;
		inbForgotPasswordVm.inbUser = "";
		inbForgotPasswordVm.newProfilePassword = inbForgotPasswordVm.profilePassword;
		inbForgotPasswordVm.goToHome = function () {
				$state.go('menu.userLogin');
		}

		inbForgotPasswordVm.init = function () {
			inbForgotPasswordVm.nextEnable();
			inbForgotPasswordVm.atmdtlsflag = true;
			inbForgotPasswordVm.atmpinFlags = true;
		}

$scope.$on('$ionicView.beforeEnter', function () {

			inbForgotPasswordVm.init();

		});

		inbForgotPasswordVm.enableInbPassword = function () {
			inbForgotPasswordVm.atmCardNumber = "";
			inbForgotPasswordVm.atmPin = "";
			inbForgotPasswordVm.atmdtlsflag = true;
			inbForgotPasswordVm.PFlag = false;
		}

		inbForgotPasswordVm.enabledAtmcardFun = function () {
			inbForgotPasswordVm.inbUser="";
			inbForgotPasswordVm.profilePassword = "";
			inbForgotPasswordVm.atmdtlsflag = false;
			inbForgotPasswordVm.nextEnable();
			inbForgotPasswordVm.PFlag = true;

		}

		inbForgotPasswordVm.atmCardNumberFun = function () {
			fgtProfilePwdService.atmCardNumber = inbForgotPasswordVm.atmCardNumber;
			inbForgotPasswordVm.showNameError = inbForgotPasswordVm.atmCardNumber.length;
			inbForgotPasswordVm.disableSecurityFun();

			if (inbForgotPasswordVm.atmCardNumber.length === 16||19) {
				inbForgotPasswordVm.atmPinFlag = false;
			} else {
				inbForgotPasswordVm.atmPinFlag = true;
				inbForgotPasswordVm.atmPin = "";
			}
			inbForgotPasswordVm.nextEnable();
		}

			
		inbForgotPasswordVm.nextEnable = function () {
			if(inbForgotPasswordVm.profilePassword){
				inbForgotPasswordVm.isNextEnabled = false;
				
			}else if(inbForgotPasswordVm.atmCardNumber && inbForgotPasswordVm.atmPin && inbForgotPasswordVm.atmCardLength === 16||19 && inbForgotPasswordVm.atmPin.length === 4){
				inbForgotPasswordVm.isNextEnabled = false;
			}else{
				inbForgotPasswordVm.isNextEnabled = true;
			}
		}


		inbForgotPasswordVm.setpassdetails = function (val) {
			if(!inbForgotPasswordVm.atmCardNumber)
				inbForgotPasswordVm.atmPin = '';
			if (val == 1) {
			inbForgotPasswordVm.enableInbPassword();
				if (inbForgotPasswordVm.profilePassword) {
					inbForgotPasswordVm.atmdtlsflag = true;
				}
				else {
					inbForgotPasswordVm.atmdtlsflag = false;
				}

			}

			else if (val == 2) {
				
				inbForgotPasswordVm.enabledAtmcardFun();
				 inbForgotPasswordVm.atmCardLength = inbForgotPasswordVm.atmCardNumber.length;
				 
				
				 if(inbForgotPasswordVm.atmCardLength === 16||19){
					inbForgotPasswordVm.atmpinFlags = false;
				}else{
					inbForgotPasswordVm.atmpinFlags = true;
				}

				if (inbForgotPasswordVm.atmCardNumber) {
					inbForgotPasswordVm.PFlag = true;
				}
				else {
					inbForgotPasswordVm.PFlag = false;
					
				}

			}
			inbForgotPasswordVm.nextEnable();
		}

		inbForgotPasswordVm.validateProfilePassword = function () {
			if (inbForgotPasswordVm.profilePassword) {
				fTReviewService.getProfilePassAndSerKey().then(function (response) {
					var options = {
						inbUserName:inbForgotPasswordVm.inbUser,
						strPass:inbForgotPasswordVm.profilePassword,
						keyId:response.keyId,
						serviceId:response.serviceId,
						osName:device.platform,
						deviceId:device.uuid
					};
					var reqParams = utilityService.commonRequestForValidateProfilePass(options);
					inbForgotPwdService.validateForgotProfile(reqParams).then(function (response) {
						console.log(JSON.stringify(response));
						loggedInUserService.setInbUserId(inbForgotPasswordVm.inbUser);
						$state.go('menu.setPassword');

					}, function (error) {
						utilityService.showErrorMessage(error.responseMessage);
					});

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			} else {
				var finalThreeDES = "";
				var strPIN = "0";
				var PIN = inbForgotPasswordVm.atmPin;
				var pinLength = PIN.toString().length;
				var strHLen = pinLength.toString();
				strPIN = strPIN + strHLen;
				strPIN = strPIN + PIN;
				var yourNumber4 = strPIN.length;
				var lastValue = []
				for (yourNumber4; yourNumber4 < 16; yourNumber4++) {
					lastValue.push('F');
				}
				strPIN = strPIN + (lastValue.toString()).replace(/[^a-zA-Z ]/g, "");
				var strPAN = "0000";
				var pandigit = inbForgotPasswordVm.atmCardNumber;
				var resource = pandigit.slice(-13);
				var resource1 = resource.slice(0, 12);
				strPAN = strPAN + resource1;
				var s = strPAN.toString();
				var hexToBinary = function(s) {
					var i, k, part, ret = '';
					var lookupTable = {
						'0': '0000', '1': '0001', '2': '0010', '3': '0011', '4': '0100',
						'5': '0101', '6': '0110', '7': '0111', '8': '1000', '9': '1001',
						'a': '1010', 'b': '1011', 'c': '1100', 'd': '1101',
						'e': '1110', 'f': '1111',
						'A': '1010', 'B': '1011', 'C': '1100', 'D': '1101',
						'E': '1110', 'F': '1111'
					};
					for (i = 0; i < s.length; i += 1) {
						if (lookupTable.hasOwnProperty(s[i])) {
							ret += lookupTable[s[i]];
						} else {
							return { valid: false };
						}
					}
					return { valid: true, result: ret };
				}

				var output1 = hexToBinary(strPIN);
				var strBPIN = output1.result;
				var output2 = hexToBinary(strPAN);
				var strBPAN = output2.result;
				var result = "0100" ^ "0101";
				var FinalOutput = strBPIN;
				var FinalOutput2 = strBPAN;
				var Slice1 = FinalOutput;
				var SlicePan = FinalOutput2;
				var FinalSlice1 = "";
				var FinalSlice2 = "";
				var strXOR = "";
				var finalXor = [];
				var blockLen = strBPIN / 4;
				var xorStr = "";
				for (var i = 0; i <= 15; i++) {
					FinalSlice1 = strBPIN.slice(i * 4, i * 4 + 4);
					FinalSlice2 = strBPAN.slice(i * 4, i * 4 + 4);
					var xorBahubali = FinalSlice1 ^ FinalSlice2;
					for (var j = 0; j < 4; j++) {
						var pinBit = FinalSlice1.slice(j, j + 1)
						var panBit = FinalSlice2.slice(j, j + 1)
						xorStr = xorStr + (pinBit ^ panBit).toString();
					}
				}

				var s = xorStr;

				var binaryToHex = function(s) {
					var i, k, part, accum, ret = '';
					for (i = s.length - 1; i >= 3; i -= 4) {
						part = s.substr(i + 1 - 4, 4);
						accum = 0;
						for (k = 0; k < 4; k += 1) {
							if (part[k] !== '0' && part[k] !== '1') {
								return { valid: false };
							}
							accum = accum * 2 + parseInt(part[k], 10);
						}
						if (accum >= 10) {
							ret = String.fromCharCode(accum - 10 + 'A'.charCodeAt(0)) + ret;
						} else {
							ret = String(accum) + ret;
						}
					}
					if (i >= 0) {
						accum = 0;
						for (k = 0; k <= i; k += 1) {
							if (s[k] !== '0' && s[k] !== '1') {
								return { valid: false };
							}
							accum = accum * 2 + parseInt(s[k], 10);
						}
						ret = String(accum) + ret;
					}
					return { valid: true, result: ret };
				}

				var pinPanBlockValue = binaryToHex(s).result;
				var currDate = new Date();
				var txtDate = $filter('date')(currDate, 'MMddHHmmss');

				var pinPanBlockEncrypt = pinPanBlockValue.toString();
				var atmNumberEncrypt = inbForgotPasswordVm.atmCardNumber.toString();
				var reqParams = {};
				reqParams["pinPanBlock"] = pinPanBlockEncrypt;
				reqParams["atmNumber"] = atmNumberEncrypt;
				reqParams["txnDate"] = txtDate;
				reqParams["type"] = "INB";


				inbForgotPwdService.validateUserThroughATMPreLogin(reqParams).then(function (response) {
					console.log(JSON.stringify(response));

					$state.go('menu.setPassword');

				}, function (error) {
					utilityService.showErrorMessage(error.responseMessage);
				});
			}
			if (inbForgotPasswordVm.profilePassword) {
				inbForgotPwdService.profile = "PROFILE";
			} else {
				inbForgotPwdService.profile = "ATM";
			}

		};

		return this;
	}

]);
