'use strict';

angularApp.controller('inbUnLockAccessOtpController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"$rootScope",
	"customerInfoService",
	"internetBankingService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"inbForgotPwdService",
	"cryptoService",
	"loggedInUserService",
	"cardsService", "clearServiceDataService", "feedebackService",
	"sampoornSurakshaService",
	"inbLockUnlockService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		$rootScope,
		customerInfoService,
		internetBankingService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		inbForgotPwdService,
		cryptoService,
		loggedInUserService,
		cardsService, clearServiceDataService, feedebackService,
		sampoornSurakshaService,
		inbLockUnlockService) {

		var inbUnLockAccessOtpVm = this;
		inbUnLockAccessOtpVm.isNextEnabled = false;
		inbUnLockAccessOtpVm.isDisabledOTP = false;
		inbUnLockAccessOtpVm.disableNext = false;

		inbUnLockAccessOtpVm.mobileNum = loggedInUserService.inbUserId.data.mobileNumber;

		inbUnLockAccessOtpVm.otp = "";
		var count = 0;
        var countInbOtpAttempt = 0;
		inbUnLockAccessOtpVm.disableCount = function () {
			count += 1;
			if (count >= 2) {
				inbUnLockAccessOtpVm.isDisabledOTP = true;
				inbUnLockAccessOtpVm.disableNext = true;
			} else {
				inbUnLockAccessOtpVm.isDisabledOTP = false;

			}

		}
		inbUnLockAccessOtpVm.nextEnable = function () {
			if (inbUnLockAccessOtpVm.otp.length == 6) {
				if(countInbOtpAttempt >= 3){
					inbUnLockAccessOtpVm.isNextEnabled = true;
				}else{
				inbUnLockAccessOtpVm.isNextEnabled = false;
				}
			} else {
				inbUnLockAccessOtpVm.isNextEnabled = true;
			}
		}

		inbUnLockAccessOtpVm.goToNext = function () {
			if (inbUnLockAccessOtpVm.otp.length < 6) {
			} else {
				countInbOtpAttempt += 1;
				var reqParams = {};
				reqParams.otp = inbUnLockAccessOtpVm.otp;
				inbLockUnlockService.validateOTP(reqParams).then(function (data) {
					var SaltValue = "#";
					var rsaValue = cryptoService.encryptRSAWithPublicKey(inbLockUnlockService.reEnterPassword, cryptoService.rsaPublicKey);
					var finalSHA512Val = rsaValue;
					var reqData = {
						"newPassword": finalSHA512Val
					};
					inbForgotPwdService.setLoginPassword(reqData).then(function (data) {
						inbUnLockAccessOtpVm.mobileNum = loggedInUserService.inbUserId.data.mobileNumber;
						inbUnLockAccessOtpVm.intBankUname = loggedInUserService.getInbUserId().data.inbUserId;
						inbLockUnlockService.challengeErrorCode === "LOCK.001";
						var reqParams = {	
							"permLock": (inbLockUnlockService.challengeErrorCode === "LOCK.001") ? "true" : "false"
						};
						inbLockUnlockService.unlockUser(reqParams).then(function (response) {
							inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/successSymbol.svg" /></center><br><center><p class="inb-alert-header inb-mart-6">Access UNLOCKED</p></center>', response.responseMessage, ["Login"], function () {
								if (inbLockUnlockService.challengeErrorCode === "LOCK.001") {
									loggedInUserService.fileForStorageData('{"isDeviceRegistered":true,"mpinConsent":false}');
									localStorage.setItem('mpinConsent', false);
									loggedInUserService.mpinConsent = false;
									inbLockUnlockService.NoMpinCreated = true;
									 $state.go('menu.userLogin');
								} else {
									 $state.go('menu.userLogin');
								}
							});

						}, function (error) {
							inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
								error.responseMessage, ["OK"], function () {
									$state.go('menu.inbUnLockAccessOtp');
								});
						});


					}, function (error) {
						inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
							error.responseMessage, ["OK"], function () {
								$state.go('menu.inbUnLockAccessOtp');
							});
					});

				}, function (error) {
					if(countInbOtpAttempt >= 3){
					inbUnLockAccessOtpVm.otp = "";
					inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
						error.responseMessage, ["OK"], function () {
							$state.go('menu.userLogin');
						});
						}else{
							inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
						error.responseMessage, ["OK"], function () {
							$state.go('menu.inbUnLockAccessOtp');
						});
						}
				});
			}
		};

		inbUnLockAccessOtpVm.resendOTP = function () {
			if (inbUnLockAccessOtpVm.isDisabledOTP) { return true }
			inbUnLockAccessOtpVm.otp = "";

			var rsaValue = cryptoService.encryptRSAWithPublicKey(inbLockUnlockService.reEnterPassword, cryptoService.rsaPublicKey);
			var finalSHA512Val = rsaValue;

			var reqData = {
				"toChange": finalSHA512Val,
				"mode": inbForgotPwdService.profile
			};
			inbForgotPwdService.getOTP(reqData).then(function (data) {
				inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/successSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
					"OTP has been sent to your registered mobile number.", ["OK"], function () {
						$state.go('menu.inbUnLockAccessOtp');
					});
				inbUnLockAccessOtpVm.disableCount();
			}, function (error) {
				inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
					error.responseMessage, ["OK"], function () {
						$state.go('menu.inbUnLockAccessOtp');
					});
			});
			inbUnLockAccessOtpVm.isDisabledOTP = true;
		}
		return this;
	}
]);
