'use strict';

angularApp.controller('inbUnlockAccessDetailsController', ["$state",
	"$ionicPopup",
	"$scope",
	"$filter",
	"loggedInUserService",
	"cryptoService",
	"utilityService",
	"fTReviewService",
	"accountDetailsService",
	"inbForgotPwdService",
	"inbLockUnlockService",

	function ($state,
		$ionicPopup,
		$scope,
		$filter,
		loggedInUserService,
		cryptoService,
		utilityService,
		fTReviewService,
		accountDetailsService,
		inbForgotPwdService,
		inbLockUnlockService) {

		var inbUnlockAccessDetailsVm = this;
		inbUnlockAccessDetailsVm.atmdtlsflag = false;
		inbUnlockAccessDetailsVm.atmpinFlags = false;
		inbUnlockAccessDetailsVm.inbUname = false;
		inbUnlockAccessDetailsVm.PFlag = false;
		inbUnlockAccessDetailsVm.profPass = false;

		inbUnlockAccessDetailsVm.setpassdetails = function (val) {
			if (!inbUnlockAccessDetailsVm.atmCardNumber)
				inbUnlockAccessDetailsVm.atmPin = '';
			if (val == 1) {
				if (inbUnlockAccessDetailsVm.profPwd.length < 8) {
					inbUnlockAccessDetailsVm.profPass = true;
				}else{
					inbUnlockAccessDetailsVm.profPass = false;
				}
				if (inbUnlockAccessDetailsVm.profPwd) {
					inbUnlockAccessDetailsVm.atmdtlsflag = true;
				}
				else {
					inbUnlockAccessDetailsVm.atmdtlsflag = false;
				}

			}

			else if (val == 2) {
				inbUnlockAccessDetailsVm.atmCardLength = inbUnlockAccessDetailsVm.atmCardNumber.length;
				if (inbUnlockAccessDetailsVm.atmCardLength === 16 || 19) {
					inbUnlockAccessDetailsVm.atmpinFlags = false;
				} else {
					inbUnlockAccessDetailsVm.atmpinFlags = true;
				}
				if (inbUnlockAccessDetailsVm.atmCardNumber) {
					inbUnlockAccessDetailsVm.PFlag = true;
				}
				else {
					inbUnlockAccessDetailsVm.PFlag = false;
				}
			}
		}

		inbUnlockAccessDetailsVm.init = function () {
			inbUnlockAccessDetailsVm.inbUname = false;
			inbUnlockAccessDetailsVm.atmdtlsflag = false;
		}
		inbUnlockAccessDetailsVm.enterInbUname = function () {
			inbUnlockAccessDetailsVm.inbUserName = loggedInUserService.getInbUserId().data.inbUserId;
			if (inbUnlockAccessDetailsVm.inbUserName !== inbUnlockAccessDetailsVm.intBankUname) {
				inbUnlockAccessDetailsVm.inbUname = true;
				inbUnlockAccessDetailsVm.PFlag = true;
				inbUnlockAccessDetailsVm.atmdtlsflag = true;

			} else {
				inbUnlockAccessDetailsVm.inbUname = false;
				inbUnlockAccessDetailsVm.PFlag = false;
				inbUnlockAccessDetailsVm.atmdtlsflag = false;
			}
		}

		inbUnlockAccessDetailsVm.validateProfilePassword = function () {
			if(inbUnlockAccessDetailsVm.validateForm()){

			var reqParams = {
				"userName": inbUnlockAccessDetailsVm.intBankUname
			};
			inbLockUnlockService.unlockUserDataValidation(reqParams).then(function (data) {

					if (inbUnlockAccessDetailsVm.profPwd) {

						inbForgotPwdService.profile = "PROFILE";
						fTReviewService.getProfilePassAndSerKey().then(function (response) {
							inbLockUnlockService.serviceId = response.serviceId;
							var options = {
								inbUserName:inbUnlockAccessDetailsVm.intBankUname,
								strPass:inbUnlockAccessDetailsVm.profPwd,
								keyId:response.keyId,
								serviceId:response.serviceId,
								osName:device.platform,
								journeyName:"N25"
							};
							var reqParams = utilityService.commonRequestForValidateProfilePass(options);
							inbForgotPwdService.validateProfilePassword(reqParams).then(function (response) {
								$state.go('menu.inbUnlockSetNewPassword');

						}, function (error) {
							inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
								error.responseMessage, ["OK"], function () {
									$state.go('menu.inbUnlockAccessDetails');
								});

						});

					}, function (error) {
						inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
							error.responseMessage, ["OK"], function () {
								$state.go('menu.inbUnlockAccessDetails');
							});

					});
				} 
				else {
					inbForgotPwdService.profile = "ATM";
					var finalThreeDES = "";
					var strPIN = "0";
					var PIN = inbUnlockAccessDetailsVm.atmPin;
					var pinLength = PIN.toString().length;
					var strHLen = pinLength.toString();
					strPIN = strPIN + strHLen;
					strPIN = strPIN + PIN;
					var yourNumber4 = strPIN.length;
					var lastValue = []
					for (yourNumber4; yourNumber4 < 16; yourNumber4++) {
						lastValue.push('F');
					}
					strPIN = strPIN + (lastValue.toString()).replace(/[^a-zA-Z ]/g, "");
					var strPAN = "0000";
					var pandigit = inbUnlockAccessDetailsVm.atmCardNumber;
					var resource = pandigit.slice(-13);
					var resource1 = resource.slice(0, 12);
					strPAN = strPAN + resource1;
					var s = strPAN.toString();
					var hexToBinary = function(s) {
						var i, k, part, ret = '';
						var lookupTable = {
							'0': '0000', '1': '0001', '2': '0010', '3': '0011', '4': '0100',
							'5': '0101', '6': '0110', '7': '0111', '8': '1000', '9': '1001',
							'a': '1010', 'b': '1011', 'c': '1100', 'd': '1101',
							'e': '1110', 'f': '1111',
							'A': '1010', 'B': '1011', 'C': '1100', 'D': '1101',
							'E': '1110', 'F': '1111'
						};
						for (i = 0; i < s.length; i += 1) {
							if (lookupTable.hasOwnProperty(s[i])) {
								ret += lookupTable[s[i]];
							} else {
								return { valid: false };
							}
						}
						return { valid: true, result: ret };
					}

					var output1 = hexToBinary(strPIN);
					var strBPIN = output1.result;
					var output2 = hexToBinary(strPAN);
					var strBPAN = output2.result;
					var result = "0100" ^ "0101";
					var FinalOutput = strBPIN;
					var FinalOutput2 = strBPAN;
					var Slice1 = FinalOutput;
					var SlicePan = FinalOutput2;
					var FinalSlice1 = "";
					var FinalSlice2 = "";
					var strXOR = "";
					var finalXor = [];
					var blockLen = strBPIN / 4;
					var xorStr = "";
					for (var i = 0; i <= 15; i++) {
						FinalSlice1 = strBPIN.slice(i * 4, i * 4 + 4);
						FinalSlice2 = strBPAN.slice(i * 4, i * 4 + 4);
						var xorBahubali = FinalSlice1 ^ FinalSlice2;
						for (var j = 0; j < 4; j++) {
							var pinBit = FinalSlice1.slice(j, j + 1)
							var panBit = FinalSlice2.slice(j, j + 1)
							xorStr = xorStr + (pinBit ^ panBit).toString();
						}
					}

					var s = xorStr;

					var binaryToHex = function(s) {
						var i, k, part, accum, ret = '';
						for (i = s.length - 1; i >= 3; i -= 4) {
							part = s.substr(i + 1 - 4, 4);
							accum = 0;
							for (k = 0; k < 4; k += 1) {
								if (part[k] !== '0' && part[k] !== '1') {
									return { valid: false };
								}
								accum = accum * 2 + parseInt(part[k], 10);
							}
							if (accum >= 10) {
								ret = String.fromCharCode(accum - 10 + 'A'.charCodeAt(0)) + ret;
							} else {
								ret = String(accum) + ret;
							}
						}
						if (i >= 0) {
							accum = 0;
							for (k = 0; k <= i; k += 1) {
								if (s[k] !== '0' && s[k] !== '1') {
									return { valid: false };
								}
								accum = accum * 2 + parseInt(s[k], 10);
							}
							ret = String(accum) + ret;
						}
						return { valid: true, result: ret };
					}

					var pinPanBlockValue = binaryToHex(s).result;
					var currDate = new Date();
					var txtDate = $filter('date')(currDate, 'MMddHHmmss');

					var pinPanBlockEncrypt = pinPanBlockValue.toString();
					var atmNumberEncrypt = inbUnlockAccessDetailsVm.atmCardNumber.toString();
					var reqParams = {};
					reqParams["pinPanBlock"] = pinPanBlockEncrypt;
					reqParams["atmNumber"] = atmNumberEncrypt;
					reqParams["txnDate"] = txtDate;
					reqParams["type"] = "INB";
						reqParams["journeyName"] = "N25";


					inbForgotPwdService.validateUserThroughATMPreLogin(reqParams).then(function (response) {
						$state.go('menu.inbUnlockSetNewPassword');

					}, function (error) {
						inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
							error.responseMessage, ["OK"], function () {
								$state.go('menu.inbUnlockAccessDetails');
							});

					});
				}

			}, function (error) {
				inbLockUnlockService.displayPopUp('<center><img class="inb-error-sym" src="img/FT/BhimUpi/errorSymbol.svg" /><br><p class="inb-alert-header inb-mart-12"></p><center/>',
					error.responseMessage, ["OK"], function () {
						$state.go('menu.inbUnlockAccessDetails');
					});
			});

			if (inbUnlockAccessDetailsVm.profPwd) {
				inbLockUnlockService.profile = "PROFILE";
			} else {
				inbLockUnlockService.profile = "ATM";
			}
              
		}
		};

		inbUnlockAccessDetailsVm.validateForm = function () {
			inbUnlockAccessDetailsVm.errObj = {};
			if (!inbUnlockAccessDetailsVm.intBankUname) {
				inbUnlockAccessDetailsVm.errObj.inbUname = true;
			}
			if (!inbUnlockAccessDetailsVm.profPwd) {
				if(((inbUnlockAccessDetailsVm.atmCardNumber.length == 16 || inbUnlockAccessDetailsVm.atmCardNumber.length == 19) && inbUnlockAccessDetailsVm.atmPin.length == 4)){
                         
				}
				else{
					inbUnlockAccessDetailsVm.errObj.profPass = true;
				}
				
			}
		 
			return (angular.equals({}, inbUnlockAccessDetailsVm.errObj)) ? true : false;

		}


		return this;
	}

]);
