angularApp.service('manageAtmService',
	function ($q, utilityService, AdapterUtils) {

		
		var newCardrequest = "";
		var newCardAccNumber = "";
		var newcardName = "";
		var selType = "";
		var accList = [];
		var selectedAccValue = {
			selIndex:"",
			accountNumber:"",
			accountBalance:""
		};
		var manageCardNumber = "";
		var oldUsageLimit = {};
		var usageLimit = {};
		var amtAtmData = "";
		var amtPosData = "";

		//manageAtmService.abc
		var accountFilterRequest = function () {

			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/accountFilterRequest", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		};


var usageAndLimitInquiry = function (obj) {

			var q = $q.defer();


			AdapterUtils.postData("adapters/ServiceRequestAdapter/usageAndLimitInquiry", obj, true).then(
				function (response) {

					q.resolve(response.data);

				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		};

var manageUpdation = function (obj) {

			var q = $q.defer();


			AdapterUtils.postData("adapters/ServiceRequestAdapter/manageUpdation", obj, true).then(
				function (response) {

					q.resolve(response.data);

				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		};

		var manageCardList = function (obj) {

			var q = $q.defer();


			AdapterUtils.postData("adapters/ServiceRequestAdapter/manageCardList", obj, true).then(
				function (response) {

					q.resolve(response.data);

				},
				function (error) {

					q.reject(error);
				}
			);
			return q.promise;

		};

		var verifySecKey = function (secKey) {
			return ((secKey / 2) - 1) / 99;
		}
		var checkInternationalUsageEligibility = function () {
			var q = $q.defer();
			var requestSecKey = '';
			var random_num = (window.crypto.getRandomValues(new Uint32Array(1))[0]);
			requestSecKey = (random_num * 10 + 1);
			var obj = {
				"secKey" : requestSecKey
			};
			AdapterUtils.postData("adapters/ServiceRequestAdapter/checkInternationalUsageEligibility", obj, true).then(
				function (response) {
					var finalcalculatedKey = verifySecKey(parseInt(response.secKey));
					if(requestSecKey === finalcalculatedKey)
						q.resolve(response);
					else{
						q.reject({responseMessage:"Technical error, please try later."});
					}
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};


		return {
			accountFilterRequest: accountFilterRequest,
			manageUpdation:manageUpdation,
			manageCardList: manageCardList,
			amtAtmData:amtAtmData,
			amtPosData:amtPosData,
			selectedAccValue:selectedAccValue,
			accList:accList,
			manageCardNumber:manageCardNumber,
			usageLimit:usageLimit,
			oldUsageLimit:oldUsageLimit,
			
			usageAndLimitInquiry:usageAndLimitInquiry,
			checkInternationalUsageEligibility:checkInternationalUsageEligibility

		}
	});

