'use strict';

angularApp.controller('manageRightsController', ["$state",
	"$ionicPopup",
	"$scope",
	"manageTransactionRightsService",
	"serviceRequestService",
	"utilityService",

	function ($state,
		$ionicPopup,
		$scope,
		manageTransactionRightsService,
		serviceRequestService,
		utilityService) {

		var manageRightsVm = this;
        

		manageRightsVm.init = function () {
			manageRightsVm.MobileOpenEye = false;
			manageRightsVm.MobileCloseEye = false;
			manageRightsVm.infoDiv = false;
	
	
			manageRightsVm.globalList = manageTransactionRightsService.txnData.globalList;
            manageRightsVm.accList = manageTransactionRightsService.txnData.accList;
            manageRightsVm.accListUnmask = manageTransactionRightsService.txnData.accListUnmask;
			 }

		manageRightsVm.selectedAccountFun = function () {
		    if(manageRightsVm.selectedAccount=="") {
    						manageRightsVm.MobileOpenEye = false;
                			manageRightsVm.MobileCloseEye = false;
                			manageRightsVm.infoDiv = false;
		    }
		    else{
		                    manageRightsVm.infoDiv = true;
		        			manageTransactionRightsService.selectedAccValue = manageRightsVm.selectedAccount == "" ? null : JSON.parse(manageRightsVm.selectedAccount);
                            var matchStr = manageTransactionRightsService.selectedAccValue.accountNumber.substring(manageTransactionRightsService.selectedAccValue.accountNumber.length - 4, manageTransactionRightsService.selectedAccValue.accountNumber.length + 1 );

                             angular.forEach(manageRightsVm.globalList, function (value, key) {
                                if(matchStr === value.accountNumber.substring(value.accountNumber.length - 4, value.accountNumber.length + 1 ))
                                {
                                    manageTransactionRightsService.selectedAccValue.accountNumber = value.accountNumber;
                                    manageTransactionRightsService.addList(value); //storing user selected account object in service file for future reference
                                }

                             });
                            manageRightsVm.accountNumber = utilityService.maskData(manageTransactionRightsService.selectedAccValue.accountNumber, "front", 4);
                            manageRightsVm.MobileOpenEye = false;
                            manageRightsVm.MobileCloseEye = true;

                            if(manageTransactionRightsService.selectedAccValue.txnRight == 'O')
                            {
                                     manageRightsVm.txnRight = 'Full Transaction Rights';
                            }
                            else if(manageTransactionRightsService.selectedAccValue.txnRight == 'L')
                            {
                                     manageRightsVm.txnRight = 'Limited Transaction rights';
                             }
                            else if(manageTransactionRightsService.selectedAccValue.txnRight == 'V')
                            {
                                     manageRightsVm.txnRight = 'View Only rights';
                            }
		    }
		}

		manageRightsVm.eyesOffFun = function () {
            manageRightsVm.MobileOpenEye = false;
            manageRightsVm.MobileCloseEye = true;
            manageRightsVm.accountNumber = utilityService.maskData(manageTransactionRightsService.selectedAccValue.accountNumber, "front", 4);
        }

        manageRightsVm.eyesOnFun = function () {
                manageRightsVm.MobileOpenEye = true;
                manageRightsVm.MobileCloseEye = false;
                manageRightsVm.accountNumber = manageTransactionRightsService.selectedAccValue.accountNumber;
        }


        manageRightsVm.goToValidatePassword = function(){
            $state.go('menu.validateProfilePwd');
        }

		$scope.$on('$ionicView.beforeEnter', function () {
			manageRightsVm.init();
		});

        manageRightsVm.goToHome = function(){
                    $state.go('menu.homeScreen');
        }

		return this;
	}
]);
