'use strict';

angularApp.controller('newDebitCardController', ["$timeout",
	"$state",
	"$ionicPopup",
	"$scope",
	"homeScreenService",
	"openAccountService",
	"$rootScope",
	"customerInfoService",
	"getAccountDetailsService",
	"wishListService",
	"utilityService",
	"mPinLoginService",
	"billDeskService",
	"personalLoanService", "myProfileService",
	"$ionicSideMenuDelegate",
	"$ionicScrollDelegate",
	"fTBeneficiaryService",
	"constantConfig",
	"newDebitCardService",
	"cardsService","fTSetOTPService","cryptoService",
	function ($timeout,
		$state, $ionicPopup,
		$scope,
		homeScreenService,
		openAccountService,
		$rootScope,
		customerInfoService,
		getAccountDetailsService,
		wishListService, utilityService,
		mPinLoginService,
		billDeskService,
		personalLoanService,
		myProfileService,
		$ionicSideMenuDelegate,
		$ionicScrollDelegate,
		fTBeneficiaryService,
		constantConfig,
		newDebitCardService,
		cardsService,fTSetOTPService,cryptoService) {

		//functions, variables that can be accessed from the HTML come here
		var newDebitCardVm = this;
		//newDebitCardVm.nextButtonState = true;
		newDebitCardVm.validErrorMessage = "Numbers, special characters and consequtive spaces are not allowed.";
		newDebitCardVm.tncCheck = false;
		newDebitCardVm.isValidError = false;
		var NamePattern = /\s\s/;
		var alphaNumric = /[^A-Za-z\s]/;

		newDebitCardVm.init = function () {
			newDebitCardVm.nextEnable();
		}

		

		newDebitCardVm.goToback = function () {
			$state.go('menu.innerPage');
		}

		// Function to check if TnC checkbox is checked or not
		newDebitCardVm.tncStateCheckFun = function () {
			if (newDebitCardVm.tncCheck != true) {
				newDebitCardVm.nextButtonState = true;

			} else {
				newDebitCardVm.nextButtonState = false;
				newDebitCardService.tncStateCheck = newDebitCardVm.tncCheck;
				newDebitCardVm.nextEnable();
			}
		};

		// Function to be called on Account selection drop down
		newDebitCardVm.selectedAccFun = function (index) {

			//newDebitCardService.selectedAccValue = JSON.parse(newDebitCardVm.selctValue);
			
			newDebitCardVm.showSelect = false;

			if(!newDebitCardVm.isOneAccount){
				newDebitCardVm.popUp.close();
			}
			
		
			newDebitCardVm.accountNumber = newDebitCardVm.accList[index].accountNumber;
			newDebitCardVm.accountBalance = newDebitCardVm.accList[index].accountBalance;
			newDebitCardVm.accountType = newDebitCardVm.accList[index].accountType;
			newDebitCardService.accountNumber = newDebitCardVm.accountNumber;
			newDebitCardService.accountBalance = newDebitCardVm.accountBalance;
			newDebitCardService.accountType = newDebitCardVm.accountType;
			
			//newDebitCardService.selectedAccValue = newDebitCardVm.accountNumber  == "" ? null : JSON.parse(newDebitCardVm.accountNumber);

			if (newDebitCardService.accountNumber != "" && newDebitCardService.accountNumber != null && newDebitCardService.accountNumber != undefined) {

				var reqData = {
					"accountNumber": newDebitCardService.accountNumber,
					"productCode": ""

				}
				
				newDebitCardVm.CardType = "";
				newDebitCardService.cardType(reqData).then(function (data) {
					newDebitCardVm.cardList = data.cardList;
					newDebitCardVm.statusCode = data.statusCode;
					newDebitCardVm.errorDesc = data.errorDesc;
					console.log(JSON.stringify(data));

					if(newDebitCardVm.statusCode == "01")
					{
						
					newDebitCardVm.myPopup = $ionicPopup.show({
						title: '',
						cssClass: 'new-purp-popup my-custom-popup',
						templateUrl: 'pages/nfs/newDebitCard/morethanTwoAccPopUp.html',
						scope: $scope
					})
		
					}



					//alert(JSON.stringify(data));
				}, function (err) {
					utilityService.showErrorMessage(err.responseMessage);
					newDebitCardVm.CardType = "";
					newDebitCardVm.nextButtonState = true;
				});

			 } 
			//else {
			// 	newDebitCardVm.nextEnable();
			// }

    

		}

		newDebitCardVm.closepopup = function(){
			
			
			newDebitCardVm.myPopup.close();
			
			if(newDebitCardVm.isOneAccount){

			$state.go('menu.innerPage');

			}
		}	


		// Function for card type selection drop down
		newDebitCardVm.selCardType = function () {
			newDebitCardService.selectedCardType = newDebitCardVm.CardType;


			newDebitCardService.customerAddress().then(function (data) {
				console.log(JSON.stringify(data));
				//alert(JSON.stringify(data));
				newDebitCardVm.permanentAddress = data.permanentAddress;
				newDebitCardVm.correspondenceAddress = data.correspondenceAddress;
				newDebitCardVm.permanentAddressFlag = data.permanentAddressFlag;
				newDebitCardVm.correspondenceAddressFlag = data.correspondenceAddressFlag;
				if (data.permanentAddressFlag == "false" && data.correspondenceAddressFlag == "false") {
					newDebitCardVm.nextButtonState = true;
					
				}


			}, function (err) {
				utilityService.showErrorMessage(err.responseMessage);
				newDebitCardVm.nextButtonState = true;
			});

			newDebitCardVm.nextEnable();

		};

		// Function to be called when clicked on Address Radio button
		newDebitCardVm.addressTypeFun = function () {

				newDebitCardService.addressType = newDebitCardVm.addressType;
			

		};

		//TnC Popup
		newDebitCardVm.tncForNewDebitCard = function () {

			//Call for TnC
		var requestData = {
			"type": "getNewDebitCardTnC"
		};
		newDebitCardService.getTnC(requestData).then(function (data) {
			newDebitCardVm.tncData = data;
				var alertPopup = $ionicPopup.alert({
				title: 'Terms and Conditions',
				templateUrl: 'pages/nfs/newDebitCard/newDebitCard_tncPopup.html',
				scope: $scope,
				cssClass: 'bi-table',
				buttons: [
					{
						text: 'OK',
						type: 'button-positive',
						onTap: function (e) {
							return true;
						}
					}]
			});
		}, function (err) {
			utilityService.showErrorMessage(err.responseMessage);
			newDebitCardVm.nextButtonState = true;
		});


		
		};

		//Function for Name check blank  
		newDebitCardVm.checkCardName = function () {
			
			if (!NamePattern.test(newDebitCardVm.cardName) && !alphaNumric.test(newDebitCardVm.cardName)){
				newDebitCardService.newcardName = newDebitCardVm.cardName;
				newDebitCardVm.isValidError = false;
			}else{
				newDebitCardVm.isValidError = true;
			}
			
			newDebitCardVm.nextEnable();
			//newDebitCardVm.isValidError = false;
		};

		newDebitCardVm.nextEnable = function () {

			if (newDebitCardVm.cardName != "" && newDebitCardVm.cardName != null && newDebitCardVm.cardName != undefined && newDebitCardVm.accountNumber != "" && newDebitCardVm.accountNumber != null && newDebitCardVm.accountNumber != undefined && newDebitCardVm.accountBalance != "" && newDebitCardVm.accountBalance != null && newDebitCardVm.accountBalance != undefined && newDebitCardVm.accountType != "" && newDebitCardVm.accountType != null && newDebitCardVm.accountType != undefined && newDebitCardVm.CardType != "" && newDebitCardVm.CardType != null && newDebitCardVm.CardType != undefined && newDebitCardVm.addressType != undefined && newDebitCardVm.addressType != null && newDebitCardVm.tncCheck == true && newDebitCardVm.tncCheck != null && newDebitCardVm.tncCheck != undefined && !NamePattern.test(newDebitCardVm.cardName) && !alphaNumric.test(newDebitCardVm.cardName)) {
				//newDebitCardVm.isValidError = true;
				newDebitCardVm.nextButtonState = false;

			} else {
				newDebitCardVm.nextButtonState = true;
			}

		}

		newDebitCardVm.goToHome = function () {

			$state.go('menu.homeScreen');
		}

		//Next button event
		newDebitCardVm.goToNext = function () {
			newDebitCardVm.nextEnable();

			var reqData = {};
			reqData["id"] = $rootScope.mobileNo;
			reqData.otpCode = constantConfig.keysForOTP.CARDOTP;
			reqData.ocHash = cryptoService.getSHA512EncryptedData(constantConfig.keysForOTP.CARDOTP).toString();
			fTSetOTPService.generateOTP(reqData).then(function (response) {
				$state.go('menu.newDebitCardOtp');
		   
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);


			});
		 	$state.go('menu.newDebitCardOtp');

		}


		$scope.$on('$ionicView.loaded', function () {
			
			newDebitCardVm.init();


		});

		$scope.$on('$ionicView.beforeEnter', function () {
			//load menu options
			newDebitCardVm.showSelect = true;
			 utilityService.showSpinner();
			newDebitCardService.accountFilterRequest().then(function (data) {
				 utilityService.hideSpinner();
				newDebitCardVm.accList = data.accList;
				
					if(newDebitCardVm.accList && newDebitCardVm.accList.length > 0){

						if(newDebitCardVm.accList.length === 1){
							newDebitCardVm.isOneAccount = true;
							newDebitCardVm.showSelect = false;
							newDebitCardVm.selectedAccFun(0);
							
						}
						else{
							newDebitCardVm.isOneAccount = false;
					newDebitCardVm.showPop = function(){
						newDebitCardVm.popUp = $ionicPopup.show({
							title: '',
							cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
							templateUrl: 'pages/nfs/newDebitCard/dropdownModal.html',
							scope: $scope
							});

						 }	
					
						}
				}
				//alert(JSON.stringify(data));
			}, function (err) {
					 utilityService.hideSpinner();
				utilityService.showErrorMessage(err.responseMessage);
				newDebitCardVm.nextButtonState = true;
			});
			


		});


		return this;
	}
]);
