angularApp.service('nfsService',["$q","AdapterUtils","$ionicPopup",
	function($q,AdapterUtils,$ionicPopup){
    
    var nfsService = this;

    var newNumber,updateMethod;

    nfsService.getOtp = function() {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/getOtpForOldMobile", {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    nfsService.getOtpNew = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/getOtpForNewMobile", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    nfsService.validateOtp = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/validateOtpForOldMobile", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    nfsService.validateOtpNew = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/validateOtpForNewMobile", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    nfsService.updateNumber = function() {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/addUpdateMobile", {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    nfsService.getAccountDetails = function() {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/getAccountDetails", {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    nfsService.getCardsList = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/viewDebitCardList", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    nfsService.validateDebitCardNumber = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/validateDebitCardNumber", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    nfsService.displayPopUp = function(heading,css,message,buttonText,callBack){
        var alertPopup = $ionicPopup.alert({
            title: heading,
            template: '<div class="popupTextBottomPadding  ss-popup-list fontSize-subHeading roboto-medium text-center '+ css +'">'
            + message + '</div></div>',
            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
            buttons: [
                {
                    text: buttonText,
                    onTap: function(e) {
                        callBack();
                    }
                }
            ],
        });
    };

    nfsService.getNewNumber = function() {
        return newNumber;
    };

    nfsService.setNewNumber = function(no) {
	    newNumber = no;
	};

    nfsService.getUpdateMethod = function() {
        return updateMethod;
    };

    nfsService.setUpdateMethod = function(method) {
	    updateMethod = method;
	};
       
	return nfsService;

}]);
