'use strict';

angularApp.controller('ppfAccSelTypeController', ["$state",
    "$ionicPopup",
    "$scope",
    "requestChequeBookService",
    "utilityService",
    "ionicDatePicker",
    "ppfEligibilityService",
    "nomineeManagementService",
    "customerInfoService","$ionicScrollDelegate",

    function($state,
        $ionicPopup,
        $scope,
        requestChequeBookService,
        utilityService,
        ionicDatePicker,
        ppfEligibilityService,
        nomineeManagementService,
        customerInfoService,$ionicScrollDelegate) {

        var ppfAccSelTypeVm = this;
        ppfAccSelTypeVm.editNomineeDetailsFlag = false;
        ppfAccSelTypeVm.gaurdianFlag = false;
        ppfAccSelTypeVm.multipleNomineeFlag = false;
        ppfAccSelTypeVm.dispNomineeDetails = false;
        ppfAccSelTypeVm.editNomineeDetailsFlag = false;
        ppfAccSelTypeVm.errorNomineeName = false;
        ppfAccSelTypeVm.errorRelationship = false;
        ppfAccSelTypeVm.errorNomineeAddress = false;
        ppfAccSelTypeVm.errorGaurdianName = false;
        ppfAccSelTypeVm.errorAge = false;
        ppfAccSelTypeVm.errorGuardianAddress = false;
        ppfAccSelTypeVm.errorDate = false;
        ppfAccSelTypeVm.submitDisableFlag = false;
        ppfAccSelTypeVm.submitDisableFlagBelowAge = true;
        ppfAccSelTypeVm.addNomineeInfoFlag = true;
        ppfAccSelTypeVm.SubmitDisableEnable = true;
        ppfAccSelTypeVm.url = "getNomineeCreation";

        ppfAccSelTypeVm.goToHome = function() {
            $state.go('menu.serviceRequest');
        }

        ppfAccSelTypeVm.cancelUpdate = function() {


            if (ppfAccSelTypeVm.url == "getNomineeCreation") {
                $state.go('menu.serviceRequest');
            } else {
                ppfAccSelTypeVm.url = "getNomineeCreation";
                ppfAccSelTypeVm.dispNomineeDetails = true;
                ppfAccSelTypeVm.editNomineeDetailsFlag = false;
            }
            // ppfAccSelTypeVm.dispNomineeDetails = true;
            // ppfAccSelTypeVm.editNomineeDetailsFlag = false;
            // $state.go('menu.ppfSelAcc');
        }
        ppfAccSelTypeVm.openDatePicker = function() {
            var monList = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
            var newDate = new Date();
            //newDate.setFullYear(newDate.getFullYear() - 100);
            var inpuDate = "";

            if (!ppfAccSelTypeVm.dob) {
                inpuDate = new Date()

            } else {
                inpuDate = new Date(ppfAccSelTypeVm.dob);

            }
            //var toDate = new Date();

            //toDate.setFullYear(toDate.getFullYear());
            inpuDate.setFullYear(inpuDate.getFullYear());
            ppfAccSelTypeVm.dateObj = {
                callback: function(val) {
                    var expiry = new Date(val);
                    ppfAccSelTypeVm.dob = expiry.getDate() + " " + monList[expiry.getMonth()] + " " + expiry.getFullYear();
                    var age = getAge(ppfAccSelTypeVm.dob);
                    if (age < 18) {
                        ppfAccSelTypeVm.gaurdianFlag = true;
                    } else {
                        ppfAccSelTypeVm.gaurdianFlag = false;
                    }
                    ppfAccSelTypeVm.checkValidation();
                },
                inputDate: inpuDate,
                monthsList: monList,

                to: newDate,
                mondayFirst: true,
                closeOnSelect: true,
                templateType: 'popup',
                dateFormat: 'dd MMM yyyy'
            };
            ionicDatePicker.openDatePicker(ppfAccSelTypeVm.dateObj);
        }

        ppfAccSelTypeVm.getNomineeDetails = function(optionIndex) {
            ppfAccSelTypeVm.nomineeDetails = {};

            if (optionIndex !== undefined && optionIndex !== "") {
                var accNum = ppfAccSelTypeVm.pppAccountsDetails[optionIndex].accountNumber;

                // if (accNum !== undefined && accNum !== "") {
                var accNumber = {
                    "accountNumber": accNum
                }
                nomineeManagementService.hitRequest("getNomineeInquiry", accNumber).then(function(data) {

                    ppfAccSelTypeVm.dispNomineeDetails = false;
                    ppfAccSelTypeVm.editNomineeDetailsFlag = true;
                    ppfAccSelTypeVm.multipleNomineeFlag = false;
                    ppfAccSelTypeVm.addNomineeInfoFlag = true;
                    ppfAccSelTypeVm.SubmitDisableEnable = true;
                    ppfAccSelTypeVm.nomineeNameOld = "";
                    ppfAccSelTypeVm.relationshipOld = "";
                    ppfAccSelTypeVm.dobOld = "";
                    ppfAccSelTypeVm.nomineeAddressOld = "";
                    ppfAccSelTypeVm.accNum = accNum;
                    if (data.nomineeList.length > 0) {
                        ppfAccSelTypeVm.addNomineeInfoFlag = false;
                        ppfAccSelTypeVm.nomineeDetails = data.nomineeList[0];

                        if (ppfAccSelTypeVm.nomineeDetails.minor == 'Y') {
                            ppfAccSelTypeVm.gaurdianFlag = true;
                        } else {
                            ppfAccSelTypeVm.gaurdianFlag = false;
                        }
                        if (ppfAccSelTypeVm.nomineeDetails.dob == undefined || ppfAccSelTypeVm.nomineeDetails.dob == "") {
                            ppfAccSelTypeVm.nomineeDetails.dob = "";
                        } else {
                            var tempDateForEdit = ppfAccSelTypeVm.nomineeDetails.dob;
                            tempDateForEdit = tempDateForEdit.split('/');
                            var newTmepDate = tempDateForEdit[2] + "-" + tempDateForEdit[1] + "-" + tempDateForEdit[0];
                            ppfAccSelTypeVm.nomineeDetails.dob = formatDateToDDMMMYYY(newTmepDate);
                        }
                        if (data.nomineeList.length == 1) {

                            ppfAccSelTypeVm.dispNomineeDetails = true;
                            ppfAccSelTypeVm.editNomineeDetailsFlag = false;
                        } else if (data.nomineeList.length > 1) {
                            ppfAccSelTypeVm.multipleNomineeFlag = true;
                            ppfAccSelTypeVm.dispNomineeDetails = false;
                            ppfAccSelTypeVm.editNomineeDetailsFlag = false;
                        }
                        ppfAccSelTypeVm.nomineeNameOld = ppfAccSelTypeVm.nomineeDetails.nomineeName;
                        ppfAccSelTypeVm.relationshipOld = ppfAccSelTypeVm.nomineeDetails.relationship;
                        ppfAccSelTypeVm.dobOld = ppfAccSelTypeVm.nomineeDetails.dob;
                        ppfAccSelTypeVm.nomineeAddressOld = ppfAccSelTypeVm.nomineeDetails.nomineeAddress;
                    }

                  
                    if (ppfAccSelTypeVm.gaurdianFlag) {
                        if (!ppfAccSelTypeVm.gaurdianName || !ppfAccSelTypeVm.age || !ppfAccSelTypeVm.guardianAddress1 || !ppfAccSelTypeVm.nomineeName || !ppfAccSelTypeVm.relationship || !ppfAccSelTypeVm.dob || !ppfAccSelTypeVm.nomineeAddress) {
                            ppfAccSelTypeVm.SubmitDisableEnable = true;
                        } else {
                            ppfAccSelTypeVm.SubmitDisableEnable = false;
                        }
                    }

                    else
                    {
                    if (!ppfAccSelTypeVm.nomineeName || !ppfAccSelTypeVm.relationship || !ppfAccSelTypeVm.dob || !ppfAccSelTypeVm.nomineeAddress) {
                        ppfAccSelTypeVm.SubmitDisableEnable = true;
                    } 

                    else {

                          ppfAccSelTypeVm.SubmitDisableEnable = false;
                     }

                    }




                }, function(error) {
                    ppfAccSelTypeVm.multipleNomineeFlag = false;
                    ppfAccSelTypeVm.dispNomineeDetails = false;
                    ppfAccSelTypeVm.editNomineeDetailsFlag = false;
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                ppfAccSelTypeVm.dispNomineeDetails = false;
                ppfAccSelTypeVm.editNomineeDetailsFlag = false;
                ppfAccSelTypeVm.gaurdianFlag = false;
            }
        }
        ppfAccSelTypeVm.checkValidation = function() {
            if (ppfAccSelTypeVm.nomineeName == undefined || ppfAccSelTypeVm.nomineeName == "") {
                ppfAccSelTypeVm.errorNomineeName = true;

            } else {
                ppfAccSelTypeVm.errorNomineeName = false;
            }

            if (ppfAccSelTypeVm.relationship == undefined || ppfAccSelTypeVm.relationship == "") {
                ppfAccSelTypeVm.errorRelationship = true;
            } else {
                ppfAccSelTypeVm.errorRelationship = false;
            }

            if (ppfAccSelTypeVm.nomineeAddress == undefined || ppfAccSelTypeVm.nomineeAddress == "") {
                ppfAccSelTypeVm.errorNomineeAddress = true;
            } else {
                ppfAccSelTypeVm.errorNomineeAddress = false;
            }

            if (ppfAccSelTypeVm.addNomineeInfoFlag) {
                if (ppfAccSelTypeVm.dob == undefined || ppfAccSelTypeVm.dob == "") {
                    ppfAccSelTypeVm.errorDate = true;
                } else {
                    ppfAccSelTypeVm.errorDate = false;
                }

            }

            if (!ppfAccSelTypeVm.addNomineeInfoFlag && ppfAccSelTypeVm.minorFlag == 'Y') {
                if (ppfAccSelTypeVm.dob == undefined || ppfAccSelTypeVm.dob == "") {
                    ppfAccSelTypeVm.errorDate = true;
                } else {
                    ppfAccSelTypeVm.errorDate = false;
                }
            }

            if (!ppfAccSelTypeVm.nomineeName || !ppfAccSelTypeVm.relationship || !ppfAccSelTypeVm.dob || !ppfAccSelTypeVm.nomineeAddress) {
                ppfAccSelTypeVm.SubmitDisableEnable = true;

            } else {
                ppfAccSelTypeVm.SubmitDisableEnable = false;
            }

            if (ppfAccSelTypeVm.gaurdianFlag) {
                if (ppfAccSelTypeVm.gaurdianName == undefined || ppfAccSelTypeVm.gaurdianName == "") {
                    ppfAccSelTypeVm.errorGaurdianName = true;
                } else {
                    ppfAccSelTypeVm.errorGaurdianName = false;
                }

                if (ppfAccSelTypeVm.age == undefined || ppfAccSelTypeVm.age == "") {
                    ppfAccSelTypeVm.errorAge = true;
                } else {
                    ppfAccSelTypeVm.errorAge = false;
                }
                if (ppfAccSelTypeVm.guardianAddress1 == undefined || ppfAccSelTypeVm.guardianAddress1 == "") {
                    ppfAccSelTypeVm.errorGuardianAddress = true;
                } else {
                    ppfAccSelTypeVm.errorGuardianAddress = false;
                }

                if (!ppfAccSelTypeVm.gaurdianName || !ppfAccSelTypeVm.age || !ppfAccSelTypeVm.guardianAddress1 || ppfAccSelTypeVm.age == "0" || ppfAccSelTypeVm.age == "00") {
                    ppfAccSelTypeVm.SubmitDisableEnable = true;
                } else {
                    ppfAccSelTypeVm.SubmitDisableEnable = false;
                }
            }
            
                if(!ppfAccSelTypeVm.nomineeName || !ppfAccSelTypeVm.relationship || !ppfAccSelTypeVm.dob || !ppfAccSelTypeVm.nomineeAddress)
                {
                     ppfAccSelTypeVm.SubmitDisableEnable = true;
                }
                else
                {
                    ppfAccSelTypeVm.SubmitDisableEnable = false;

                }
            
        }

        ppfAccSelTypeVm.submitDetails = function() {

            if ((ppfAccSelTypeVm.gaurdianFlag == false && ppfAccSelTypeVm.nomineeNameOld.trim() == ppfAccSelTypeVm.nomineeName.trim()) && (ppfAccSelTypeVm.relationshipOld.trim() == ppfAccSelTypeVm.relationship.trim() && ppfAccSelTypeVm.dobOld.trim() == ppfAccSelTypeVm.dob.trim()) && (ppfAccSelTypeVm.nomineeAddressOld.trim() == ppfAccSelTypeVm.nomineeAddress.trim())) {

                utilityService.showErrorMessage("You have not modified any details.Please change the details to proceed");

            } else {

                var createParam = {
                    "accountNumber": ppfAccSelTypeVm.accNum,
                    "nomineeName": ppfAccSelTypeVm.nomineeName,
                    "nomineeAddress": ppfAccSelTypeVm.nomineeAddress,
                    "relationship": ppfAccSelTypeVm.relationship,
                    "dobOfNominee": formateDate(ppfAccSelTypeVm.dob),
                    // "mobile": ppfAccSelTypeVm.mobile,
                    "nameFlag": "Y",
                    "minorFlag": ppfAccSelTypeVm.gaurdianFlag ? 'Y' : 'N',
                    "guardianName": ppfAccSelTypeVm.gaurdianName,
                    "guardianAddress1": ppfAccSelTypeVm.guardianAddress1,
                    "guardianAddress2": ppfAccSelTypeVm.guardianAddress2,
                    "guardianAge": ppfAccSelTypeVm.age
                }

                nomineeManagementService.hitRequest(ppfAccSelTypeVm.url, createParam).then(function(data) {

                    // ppfAccSelTypeVm.pppAccountsDetails = data.accList;
                    // ppfAccSelTypeVm.dispNomineeDetails = true;
                    // ppfAccSelTypeVm.editNomineeDetailsFlag = false;
                    // var alertPopup = $ionicPopup.alert({
                    //     template: "<div class='popupBodyPadding font-dark-grey'><div  align='center'> <img class='fss-popup-activated-img' src='img/FSS/Approved.svg'></div><p style='text-align:center;font-weight:bold;font-size:16px'>Your Nomination in PPF Account has been successfully updated.</p></div>",
                    //     buttons: [

                    //         {
                    //             text: '<b>Ok</b>',
                    //             type: 'button-positive',
                    //             onTap: function (e) {
                    //                 alertPopup.close();
                    //                 $state.go("menu.homeScreen");
                    //             }
                    //         }
                    //     ]
                    // });
                    $state.go("menu.maangeNomineeSuccess");
                }, function(error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        function formatDateToDDMMMYYY(dateParam) {
            var monList = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
            var tempDate = new Date(dateParam);

            return tempDate.getDate() + " " + monList[tempDate.getMonth()] + " " + tempDate.getFullYear();
        }

        function formateDate(dateParam) {
            var tempDate = new Date(dateParam);
            if (tempDate.getDate() < 10) {
                var dd = "0" + tempDate.getDate().toString();
            } else {
                var dd = tempDate.getDate();
            }
            if (tempDate.getMonth() + 1 < 10) {
                var mm = "0" + (tempDate.getMonth() + 1).toString();
            } else {
                var mm = tempDate.getMonth() + 1;
            }
            return dd + "/" + mm + "/" + tempDate.getFullYear();
        }

        function getAge(dateString) {
            var today = new Date();
            var tempDate = dateString;
            tempDate = tempDate.split('/');
            var newTmepDate = tempDate[2] + "-" + tempDate[1] + "-" + tempDate[0];
            var birthDate = new Date(newTmepDate);
            var age = today.getFullYear() - birthDate.getFullYear();
            var m = today.getMonth() - birthDate.getMonth();
            if (m < 0 || (m === 0 && today.getDate() < birthDate.getDate())) {
                age--;
            }
            return age;
        }
        $scope.$on('$ionicView.beforeEnter', function() {

            ppfAccSelTypeVm.showSelect=true;

            if (utilityService.isIOSPlatform()) {
                ppfAccSelTypeVm.scroll = false;
            } else {
                ppfAccSelTypeVm.scroll = true;
            }


             if (!customerInfoService.customer.residentialStatus)
             {
              var errorText = "Cannot Process now.Please try after some time";
                utilityService.showNfsAlertModal("", errorText, "menu.serviceRequest", $scope, $state, "OK");
             }

          else if (customerInfoService.customer.residentialStatus == "1") {
                nomineeManagementService.hitRequest("kycAndNightModeValidation", {}).then(function(data) {
                    ppfAccSelTypeVm.kycValidation = data.flag;
                    ppfAccSelTypeVm.isNightMode = data.isNightMode;
                    if (ppfAccSelTypeVm.kycValidation == "TRUE" && ppfAccSelTypeVm.isNightMode == false) {

                        nomineeManagementService.hitRequest("getPPFAccountFilter", {}).then(function(data) {
                            ppfAccSelTypeVm.pppAccountsDetails = data.accList;

                             if(data.accList.length==1)
                            {
                               ppfAccSelTypeVm.showSelect=false;
                                ppfAccSelTypeVm.balance = data.accList[0].availableBalance;
                                ppfAccSelTypeVm.typeacc = data.accList[0].accountType;
                                ppfAccSelTypeVm.accountNumber = data.accList[0].accountNumber;
                            }
                            if (ppfAccSelTypeVm.pppAccountsDetails.length !== undefined) {
                                ppfAccSelTypeVm.ppfAccount = '0';
                                ppfAccSelTypeVm.getNomineeDetails(0);
                            }

                        }, function(error) {
                           
                            utilityService.showNfsAlertModal("", error.responseMessage, "menu.serviceRequest", $scope, $state, "OK", "errorImgTitle");
                        });
                    } else if (ppfAccSelTypeVm.isNightMode) {

                        var NightModetxt = "Request can not be processed now. Please try between 08:00 Hrs(IST) to 20.00 Hrs(IST).";
                        utilityService.showNfsAlertModal("", NightModetxt, "menu.serviceRequest", $scope, $state, "OK", "errorImgTitle");
                    } else {
                        var errorText = "User is not KYC complaint,Can-not proceed.";
                        utilityService.showNfsAlertModal("", errorText, "menu.serviceRequest", $scope, $state, "OK");
                    }
                }, function(error) {
                    // utilityService.showErrorMessage(error.responseMessage);
                    utilityService.showNfsAlertModal("", error.responseMessage, "menu.serviceRequest", $scope, $state, "OK");
                });

            } else {
                var errorText = "Sorry, you cannot access Nominee Management Services Online.Please visit / contact your home branch.";
                utilityService.showNfsAlertModal("", errorText, "menu.serviceRequest", $scope, $state, "OK");
            }


        });

           ppfAccSelTypeVm.showPop = function()
        {
            ppfAccSelTypeVm.popUP = $ionicPopup.show({
                                    title: '',
                                    cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter ftpopup-body',
                                    templateUrl: 'pages/nfs/nomineeManagement/dropdownModal.html',
                                    scope: $scope
                                });

        }

        ppfAccSelTypeVm.close =function(index)
        {
            ppfAccSelTypeVm.popUP.close();
            ppfAccSelTypeVm.balance = ppfAccSelTypeVm.pppAccountsDetails[index].availableBalance;
            ppfAccSelTypeVm.typeacc = ppfAccSelTypeVm.pppAccountsDetails[index].accountType;
            ppfAccSelTypeVm.accountNumber = ppfAccSelTypeVm.pppAccountsDetails[index].accountNumber;
            ppfAccSelTypeVm.showSelect=false;
            if(ppfAccSelTypeVm.pppAccountsDetails.length>1)
            {
                ppfAccSelTypeVm.getNomineeDetails(index);
            }
            
            
        }
        ppfAccSelTypeVm.editNominee = function() {
             $ionicScrollDelegate.resize();
            if (ppfAccSelTypeVm.nomineeDetails.dob == undefined || ppfAccSelTypeVm.nomineeDetails.dob == "") {
                ppfAccSelTypeVm.dob = "";
            } else {
                // var tempDateForEdit = ppfAccSelTypeVm.nomineeDetails.dob;
                // tempDateForEdit = tempDateForEdit.split('/');
                // var newTmepDate = tempDateForEdit[2] + "-" + tempDateForEdit[1] + "-" + tempDateForEdit[0];
                // ppfAccSelTypeVm.dob = newTmepDate;
                ppfAccSelTypeVm.dob = ppfAccSelTypeVm.nomineeDetails.dob;
            }

            ppfAccSelTypeVm.url = "getNomineeUpdate";
            ppfAccSelTypeVm.nomineeName = ppfAccSelTypeVm.nomineeDetails.nomineeName.trim();
            ppfAccSelTypeVm.nomineeAddress = ppfAccSelTypeVm.nomineeDetails.nomineeAddress.trim();
            ppfAccSelTypeVm.relationship = ppfAccSelTypeVm.nomineeDetails.relationship.trim();
            ppfAccSelTypeVm.gaurdianName = ppfAccSelTypeVm.nomineeDetails.guardianName;
            ppfAccSelTypeVm.guardianAddress1 = ppfAccSelTypeVm.nomineeDetails.guardianAddress1;
            ppfAccSelTypeVm.guardianAddress2 = ppfAccSelTypeVm.nomineeDetails.guardianAddress2;
            ppfAccSelTypeVm.age = ppfAccSelTypeVm.nomineeDetails.guardianAge;

            ppfAccSelTypeVm.minorFlag = ppfAccSelTypeVm.nomineeDetails.minor;
            if (ppfAccSelTypeVm.minorFlag == 'Y') {
                ppfAccSelTypeVm.gaurdianFlag = true;
            } else {
                ppfAccSelTypeVm.gaurdianFlag = false;
            }
            if (!ppfAccSelTypeVm.nomineeName || !ppfAccSelTypeVm.relationship || !ppfAccSelTypeVm.dob || !ppfAccSelTypeVm.nomineeAddress) {
                ppfAccSelTypeVm.SubmitDisableEnable = true;
            } else {
                ppfAccSelTypeVm.SubmitDisableEnable = false;
            }
            if (ppfAccSelTypeVm.gaurdianFlag) {
                if (!ppfAccSelTypeVm.gaurdianName || !ppfAccSelTypeVm.age || !ppfAccSelTypeVm.guardianAddress1 || !ppfAccSelTypeVm.guardianAddress2) {
                    ppfAccSelTypeVm.SubmitDisableEnable = true;
                } else {
                    ppfAccSelTypeVm.SubmitDisableEnable = false;
                }
            }

            ppfAccSelTypeVm.dispNomineeDetails = false;
            ppfAccSelTypeVm.editNomineeDetailsFlag = true;
            $ionicScrollDelegate.resize();

        }

        return this;
    }
]);