'use strict';

angularApp.controller('ppsChequeListController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup", "chequeDepositsService", "AdapterUtils", "$q", "$ionicPopover", "$filter", "$ionicHistory", "getAccountDetailsService", "currentLocationService", "ionicDatePicker", "homeScreenService", "ppsServices",

    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,
        chequeDepositsService, AdapterUtils, $q, $ionicPopover, $filter, $ionicHistory, getAccountDetailsService, currentLocationService, ionicDatePicker, homeScreenService, ppsServices) {

        var ppsChequeListControllerVm = this;


        ppsChequeListControllerVm.getChequeList = function () {
            ppsChequeListControllerVm.getChequeData = ppsServices.viewChequeData;
            var chequeDate = ppsChequeListControllerVm.getChequeData.chequeDate;
            var date = chequeDate.substring(0,2);
            var month = chequeDate.substring(2,4);
            var year = chequeDate.substring(4,8);
            var tempDate = year + '-' + month + '-' + date;
            ppsChequeListControllerVm.getChequeData.chequeDate = new Date(tempDate);
        }
        ppsChequeListControllerVm.deleteRequest = function () {
            utilityService.comingSoon("Coming soon");
            /*ppsChequeListControllerVm.deleteChequeRequestPopup = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll yonoWeableBackdrop',
                templateUrl: 'pages/nfs/positivePaymentSystem/deleteChequeRequestPopup.html',
                scope: $scope
            });*/
        }
        ppsChequeListControllerVm.closeDeleteRequestPopup = function () {
            ppsChequeListControllerVm.deleteChequeRequestPopup.close();
        }
        ppsChequeListControllerVm.successDeleteRequest = function () {
            ppsChequeListControllerVm.deleteChequeRequestPopup.close();
            $state.go("menu.ppsOTPPage", {action : 'delete_request'});
        }

        ppsChequeListControllerVm.goToPrevious = function () {
			$ionicHistory.goBack();
	    }

        $scope.$on('$ionicView.beforeEnter', function () {
            ppsChequeListControllerVm.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            ppsChequeListControllerVm.getChequeList();

        });

        return this;
    }
]);
