'use strict';

angularApp.controller('ppsCommonSuccessController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup",
    "chequeDepositsService",
    "AdapterUtils",
    "$q",
    "$ionicPopover",
    "$filter",
    "$ionicHistory",
    "getAccountDetailsService",
    "currentLocationService",
    "ionicDatePicker",
    "homeScreenService",
    "$ionicViewSwitcher",
    "ppsServices",
    "cryptoService",
    "loggedInUserService",
    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,
        chequeDepositsService,
        AdapterUtils,
        $q,
        $ionicPopover,
        $filter,
        $ionicHistory,
        getAccountDetailsService,
        currentLocationService,
        ionicDatePicker,
        homeScreenService,
        $ionicViewSwitcher,
        ppsServices,
        cryptoService,
        loggedInUserService) {

        var ppsCmmSuccessVm = this;
        ppsCmmSuccessVm.selectedType = ppsServices.selectedType;
        
        $scope.$on('$ionicView.beforeEnter', function () {
            ppsCmmSuccessVm.selectedAccNo = ppsServices.ppsDetails.selectedAccNo;
            ppsCmmSuccessVm.refNumber = ppsServices.ppsDetails.refNumber;
            ppsCmmSuccessVm.limitAmount = ppsCmmSuccessVm.selectedType === 'changeAccLmt' ? ppsServices.ppsDetails.newAmtLmt : ppsServices.ppsDetails.limitAmount;
        });

        ppsCmmSuccessVm.goToRelationship = function(){
            $state.go('menu.accountOverviewMyBalance');
        }

        ppsCmmSuccessVm.goToPPSLanding = function(){
            $state.go('menu.positivePayment');
        }


        return this;
    }
]);
