angularApp.service('ppfEReceiptService',
	function ($q, utilityService, AdapterUtils) {

        var ppfList='';
        var ppfstmtList='';

        var getPPFAccounts = function () {
                var q = $q.defer();

                AdapterUtils.postData("adapters/ServiceRequestAdapter/getPPFAccounts", {}, true).then(
                    function (response) {
                        q.resolve(response.data);
                    },
                    function (error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            };

         var addppfList= function(List) {
            ppfList=List;
         };

        var addppfstmtList= function(List){
            ppfstmtList=List;
        };

        var getppfstmtList= function(){
            return ppfstmtList;
        };

      	var getppfList = function() {
      		return ppfList;
      	};

        var getPPFAccStmt = function (request) {
                var q = $q.defer();
                AdapterUtils.postData("adapters/ServiceRequestAdapter/getPPFAccountStatement", request, true).then(
                    function (response) {
                        q.resolve(response.data);
                    },
                    function (error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            };

        var getPPFTransactionReceipt = function (request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getPPFTransactionReceipt", request, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };


		return {
            getPPFAccounts: getPPFAccounts,
            addppfList: addppfList,
            getppfList: getppfList,
            getPPFAccStmt: getPPFAccStmt,
            addppfstmtList: addppfstmtList,
            getppfstmtList: getppfstmtList,
            getPPFTransactionReceipt: getPPFTransactionReceipt
		}
	});
