'use strict';

angularApp.controller('ppfEligibilityController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "utilityService",
    "$ionicPopup","ppfEligibilityService","AdapterUtils","$q",

    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        utilityService,
        $ionicPopup,
        ppfEligibilityService,AdapterUtils,$q) {

        var ppfEligibilityVm = this;     

        ppfEligibilityVm.goToHome=function (){
             utilityService.setCsatJournies('ppfEligibility');
            $state.go('menu.homeScreen');
        }
        ppfEligibilityVm.getPPFAccountDetails = function() {
        ppfEligibilityService.getPPFAccountDetails().then(function(data){
            ppfEligibilityVm.isAccountone=true;
            
        if(data.accList.length == 1)
        {
                    ppfEligibilityVm.isAccountone=false;
                    ppfEligibilityVm.selectedValue=data.accList[0].accountNumber;
                    ppfEligibilityVm.getPPFEligibility();
        }             
       ppfEligibilityVm.accList=data.accList;     
       ppfEligibilityVm.selectedValue=data.accList[0].accountNumber;
                     
            },function (error) {
                utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
            });
        }

        ppfEligibilityVm.getPPFEligibility = function() {
                 if(ppfEligibilityVm.selectedValue!="null" && ppfEligibilityVm.selectedValue!="undefined" && ppfEligibilityVm.selectedValue!="select") {


                var reqData = {
                   "accountNumber": ppfEligibilityVm.selectedValue
               }
             
                ppfEligibilityService.getPPFEligibility(reqData).then(function(data){
                ppfEligibilityVm.fetcheddetails=true;
                ppfEligibilityVm.ppfData=data;
                utilityService.setCsatJournies('ppfEligibility');
                },function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            ppfEligibilityVm.fetcheddetails=false;
            ppfEligibilityVm.getPPFAccountDetails();
            
        });
    
        

    return this;
  }
]);
