angularApp.service('reprintITChallanService',
	function ($q, utilityService, AdapterUtils) {

        var challanDtlList='';

        var setChallanDtlList = function(List){
            challanDtlList=List;
        }

        var getChallanDtlList = function(List){
            return challanDtlList;
        }

        var getChallanDtl = function (request) {
                var q = $q.defer();
                AdapterUtils.postData("adapters/ServiceRequestAdapter/getITStatement", request, true).then(
                    function (response) {
                        q.resolve(response.data);
                    },
                    function (error) {
                        q.reject(error);
                    }
                );
                return q.promise;
            };

        var getITChallanReceipt = function (request) {
            var q = $q.defer();
            AdapterUtils.postData("adapters/ServiceRequestAdapter/getITTaxChallan", request, true).then(
                function (response) {
                    q.resolve(response.data);
                },
                function (error) {
                    q.reject(error);
                }
            );
            return q.promise;
        };

		return {
            getChallanDtl: getChallanDtl,
            getChallanDtlList: getChallanDtlList,
            setChallanDtlList: setChallanDtlList,
            getITChallanReceipt: getITChallanReceipt
		}
	});
