'use strict';

angularApp.controller('requestChequeBookController', ["$state",
	"$ionicPopup",
	"$scope",
	"requestChequeBookService",
	"serviceRequestService",
	"utilityService",

	function ($state,
		$ionicPopup,
		$scope,
		requestChequeBookService,
		serviceRequestService,
		utilityService) {

		var requestChequeBookVm = this;
		requestChequeBookVm.chequeDisabled = true;

		requestChequeBookVm.init = function () {
			requestChequeBookVm.selctValue = requestChequeBookService.selectedAccValue == null ? "" : JSON.stringify(requestChequeBookService.selectedAccValue);
			//requestChequeBookVm.tncCheck = requestChequeBookService.tncCheck;
			
			requestChequeBookVm.chqPages = requestChequeBookService.chqPages;
			
					requestChequeBookVm.selectedAccFun1();
			
			if(requestChequeBookService.tncCheck && requestChequeBookService.conDetails){
				requestChequeBookVm.tncCheck = requestChequeBookService.tncCheck;
				requestChequeBookVm.conDetails = requestChequeBookService.conDetails;
			}
			requestChequeBookVm.nextEnable();
		}

		requestChequeBookVm.getAccountList = function () {
				if (!requestChequeBookService.accList.length) {

					requestChequeBookService.accountFilterRequest().then(function (data) {
							requestChequeBookService.accList = data.accList;	
							requestChequeBookVm.accList = requestChequeBookService.accList;
							

					
				}, function (error) {
					utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
				});

				}else{
					requestChequeBookVm.accList = requestChequeBookService.accList;
					requestChequeBookVm.selectedAccount = requestChequeBookService.requestChequeBookVm.selectedAccount == null ? "" : JSON.stringify(requestChequeBookService.selectedAccValue);
				}
				requestChequeBookVm.nextEnable();

		}

		requestChequeBookVm.selectedAccFun = function () {
			requestChequeBookVm.clearData();
			requestChequeBookVm.tncCheck = false;
			requestChequeBookVm.conDetails = false;
			requestChequeBookService.selectedAccValue = requestChequeBookVm.selctValue == "" ? null : JSON.parse(requestChequeBookVm.selctValue);

			requestChequeBookVm.chequeDisabled = false;
			if (requestChequeBookService.selectedAccValue && requestChequeBookService.selectedAccValue.accountType) {
				if (requestChequeBookService.selectedAccValue.accountType == "Savings") {
					requestChequeBookVm.innerPageResponse = {

						"getLinks": [
							{ "pages": "10" },
							{ "pages": "25" },
							{ "pages": "50" },
							{ "pages": "100" },
						]
					}

					requestChequeBookVm.chqPages = "";
				} else {

					requestChequeBookVm.innerPageResponse = {

						"getLinks": [
							{ "pages": "25" },
							{ "pages": "50" },
							{ "pages": "100" },
						]


					}

					requestChequeBookVm.chqPages = "";


				}
			}



			if (requestChequeBookVm.selctValue == "" || requestChequeBookVm.selctValue == undefined || requestChequeBookVm.selctValue == null) {
				//requestChequeBookService.clearAll();
				requestChequeBookVm.tncCheck = false;
				requestChequeBookVm.conDetails = false;
				requestChequeBookVm.selctValue = "";
				requestChequeBookVm.chqPages = "";
				requestChequeBookVm.chequeDisabled = true;
			} else {
				
			}

			requestChequeBookVm.nextEnable();

		}

		requestChequeBookVm.selectedAccFun1 = function () {
			//requestChequeBookVm.clearData();
			requestChequeBookVm.tncCheck = false;
			requestChequeBookVm.conDetails = false;
			requestChequeBookService.selectedAccValue = requestChequeBookVm.selctValue == "" ? null : JSON.parse(requestChequeBookVm.selctValue);

			requestChequeBookVm.chequeDisabled = false;
			if (requestChequeBookService.selectedAccValue && requestChequeBookService.selectedAccValue.accountType) {
				if (requestChequeBookService.selectedAccValue.accountType == "Savings") {
					requestChequeBookVm.innerPageResponse = {

						"getLinks": [
							{ "pages": "10" },
							{ "pages": "25" },
							{ "pages": "50" },
							{ "pages": "100" },
						]
					}

					//requestChequeBookVm.chqPages = "";
				} else {

					requestChequeBookVm.innerPageResponse = {

						"getLinks": [
							{ "pages": "25" },
							{ "pages": "50" },
							{ "pages": "100" },
						]


					}

					//requestChequeBookVm.chqPages = "";


				}
			}



			if (requestChequeBookVm.selctValue == "" || requestChequeBookVm.selctValue == undefined || requestChequeBookVm.selctValue == null) {
				//requestChequeBookService.clearAll();
				requestChequeBookVm.tncCheck = false;
				requestChequeBookVm.conDetails = false;
				requestChequeBookVm.selctValue = "";
				requestChequeBookVm.chqPages = "";
				requestChequeBookVm.chequeDisabled = true;
			} else {
				
			}

			requestChequeBookVm.nextEnable();

		}



		requestChequeBookVm.selectedchqPages = function () {

			requestChequeBookService.chqPages = requestChequeBookVm.chqPages;
			//requestChequeBookVm.chequeDisabled = false;
			requestChequeBookVm.nextEnable();
		}

		requestChequeBookVm.clearData = function () {
			requestChequeBookService.iDelcare = false;
			requestChequeBookService.selectAdd = "";
			requestChequeBookService.add1 = "";
			requestChequeBookService.add2 = "";
			requestChequeBookService.add3 = "";
			requestChequeBookService.add4 = "";
			requestChequeBookService.pinCode = "";
			requestChequeBookService.city = "";
			requestChequeBookService.state = "";
			requestChequeBookService.showNameError = "";
		}

		requestChequeBookVm.tncStateCheckFun = function () {
			if (requestChequeBookVm.tncCheck != true && requestChequeBookVm.conDetails != true ) {
				requestChequeBookVm.isNextEnabled = true;

			} else {
				requestChequeBookVm.nextButtonState = false;
				requestChequeBookService.tncCheck = requestChequeBookVm.tncCheck;
				requestChequeBookService.conDetails = requestChequeBookVm.conDetails;
				requestChequeBookVm.nextEnable();
			}
		};

		//TnC Popup
		requestChequeBookVm.getChequeReqTnCFun = function () {

			requestChequeBookService.tncCheck = requestChequeBookVm.tncCheck;
			requestChequeBookVm.nextEnable();

			var requestData = {
			"type": "getChequeReqTnC"
		};

		requestChequeBookService.getTnC(requestData).then(function (data) {
			requestChequeBookVm.tncData = data;
		

			var alertPopup = $ionicPopup.alert({
			title: 'Terms and Conditions',
			templateUrl: 'pages/nfs/requestChequeBook/requestChequeBook_tncPopup.html',
			scope: $scope,
			cssClass: 'bi-table',
			buttons: [
				{
					text: 'OK',
					type: 'button-positive',
					onTap: function (e) {
						return true;
					}
				}]
		});
		}, function (error) {
			utilityService.showErrorMessage(error.responseMessage);
			//requestChequeBookVm.isNextEnabled = true;
			
		});


		
		};


	

		requestChequeBookVm.goToNext = function () {
			$state.go('menu.requestAddressChequeBook');
		}

		requestChequeBookVm.goToHome = function () {
			requestChequeBookService.clearAll();
			$state.go('menu.homeScreen');
		}

		requestChequeBookVm.goToback = function () {
			requestChequeBookService.clearAll();
			$state.go('menu.innerPage');
		}

		requestChequeBookVm.nextEnable = function () {
			if (requestChequeBookVm.selctValue != "" && requestChequeBookVm.selctValue != undefined && requestChequeBookVm.selctValue != null && requestChequeBookVm.chqPages != "" && requestChequeBookVm.chqPages != undefined && requestChequeBookVm.chqPages != null && requestChequeBookVm.tncCheck != "" && requestChequeBookVm.tncCheck != undefined && requestChequeBookVm.tncCheck != null && requestChequeBookVm.tncCheck != false && requestChequeBookVm.conDetails != "" && requestChequeBookVm.conDetails != undefined && requestChequeBookVm.conDetails != null && requestChequeBookVm.conDetails != false) {
				requestChequeBookVm.isNextEnabled = false;
			} else {
				requestChequeBookVm.isNextEnabled = true;
			}
		}

		$scope.$on('$ionicView.loaded', function () {

				
				requestChequeBookVm.getAccountList();		
				
			
		
		});

		$scope.$on('$ionicView.beforeEnter', function () {
			// requestChequeBookVm.accData = {

				// "accList": [
					// { "accountNumber": "XXXXXXX2015", "accountType": "overdraft", "accountBalance": "17600.00", "branchCode": "00437", "branchName": "Nasik", "productCode": "50111101" },
					// { "accountNumber": "XXXXXXX2015", "accountType": "Current", "accountBalance": "7600.00", "branchCode": "00437", "branchName": "pune", "productCode": "50111101" },
					// { "accountNumber": "XXXXXXX7218", "accountType": "Savings", "accountBalance": "319851.00", "branchCode": "04791", "branchName": "mumbai", "productCode": "10111101" }
				// ]
			// }

			// requestChequeBookService.accountFilterRequest().then(function (data) {
			// 				requestChequeBookService.accList = data.accList;	
			// 				requestChequeBookVm.accList = requestChequeBookService.accList;
							

			
			// 	}, function (error) {
			// 		utilityService.showErrorMessage(error.responseMessage);
			// 	});

			

			requestChequeBookVm.init();

		});





		return this;
	}
]);
