'use strict';

angularApp.service('revokeChequeService',
	function ($q, AdapterUtils) {

		var revokeChequeService = this;

		revokeChequeService.typesOfCheque = "single";
		revokeChequeService.fromCheque = "";
		revokeChequeService.toCheque = "";
		revokeChequeService.EnterCheque = "";
		revokeChequeService.accList = [];
		revokeChequeService.cardList = [];
		revokeChequeService.selectedAccValue = null;
		revokeChequeService.selectedCardValue = null;
		revokeChequeService.blockAllCards = false;
		revokeChequeService.selectedCardType = "";
		revokeChequeService.multiSelectedCardType = "";

		
		revokeChequeService.clearAll  = function () {

		revokeChequeService.typesOfCheque = "single";
		revokeChequeService.fromCheque = "";
		revokeChequeService.toCheque = "";
		revokeChequeService.EnterCheque = "";
		revokeChequeService.accList = [];
		revokeChequeService.cardList = [];
		revokeChequeService.selectedAccValue = null;
		revokeChequeService.selectedCardValue = null;
		revokeChequeService.blockAllCards = false;
		revokeChequeService.selectedCardType = "";
		revokeChequeService.multiSelectedCardType = "";

		}
		revokeChequeService.chequeAccountFilterRequest = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/chequeAccountFilterRequest", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		revokeChequeService.getTnC = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/getTnC", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		revokeChequeService.revokeStopRequest = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/ServiceRequestAdapter/revokeStopRequest", obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		

		return revokeChequeService;
	});
