'use strict';

angularApp.controller('siLandingController', ["$state",
	"$ionicPopup",
	"$scope",
	"$filter",
	"loggedInUserService",
	"cryptoService",
	"utilityService",
	"siNfsService",
	function ($state,
		$ionicPopup,
		$scope,
		$filter,
		loggedInUserService,
		cryptoService,
		utilityService,
		siNfsService) {

		var siLandingVm = this;

		siLandingVm.goToback = function(){

		}

		siLandingVm.setNew = function(){

			siNfsService.getSIAccounts().then(function(data){
				if(data.accList.length > 0){            
		            siNfsService.setFromAccountDetails(data.accList);
		            $state.go('menu.siSelAccount');
		        }else{
		        	utilityService.showErrorMessage("No Accounts Available");
		        }
	        },function (error) {
	        	//$state.go('menu.siSelAccount');
	            utilityService.showErrorMessage(error.responseMessage);
            });
			
		}

		siLandingVm.viewSI = function(){
			siNfsService.getSIEnquiry().then(function(data){        
	            
	        },function (error) {
	            utilityService.showErrorMessage(error.responseMessage);
            });
		}

		$scope.$on('$ionicView.beforeEnter', function() {
			siNfsService.setNew.accDetails = {};
		});

		return this;
	}

]);
