'use strict';

angularApp.controller('addressDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter) {

        var addressDetailsNPSControllerVM = this;
        $scope.currentPage = "6";
        $scope.lastPage = "16";


        addressDetailsNPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        addressDetailsNPSControllerVM.goBack = function () {
            $state.go('menu.npsParentDetails');
        }

        addressDetailsNPSControllerVM.goNext = function () {
            npsServices.applicantData.stateCode = addressDetailsNPSControllerVM.applicantData.stateCode;
            npsServices.applicantData.state = addressDetailsNPSControllerVM.applicantData.state;

            $state.go("menu.npsContactDetails");
        }

        addressDetailsNPSControllerVM.selectedStateUnionTerritory = function (index) {
            addressDetailsNPSControllerVM.applicantData.state = utilityService.getTextFromDropdown("value", addressDetailsNPSControllerVM.applicantData.stateCode, addressDetailsNPSControllerVM.stateList, "description");
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            addressDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            addressDetailsNPSControllerVM.stateList = npsServices.npsDropdownData.stateMasters;
            addressDetailsNPSControllerVM.applicantData = angular.copy(npsServices.applicantData);

        });

        return this;
    }
]);
