'use strict';

angularApp.controller('contributionReviewNPSController', ["$timeout",
  "$ionicPopup",
  "$state",
  "$scope",
  "$rootScope",
  "$translate",
  "$location",
  "$ionicScrollDelegate",
  "getAccountDetailsService",
  "$ionicSlideBoxDelegate",
  "utilityService",
  "$ionicHistory",
  "homeScreenService",
  "$ionicViewSwitcher",
  "npsServices",
  "$filter",
  "ionicDatePicker",
  function ($timeout,
    $ionicPopup,
    $state,
    $scope,
    $rootScope,
    $translate,
    $location,
    $ionicScrollDelegate,
    getAccountDetailsService,
    $ionicSlideBoxDelegate,
    utilityService,
    $ionicHistory,
    homeScreenService,
    $ionicViewSwitcher,
    npsServices,
    $filter,
    ionicDatePicker) {

    var contributionReviewNPSControllerVM = this;
    $scope.currentPage = "15";
    $scope.lastPage = "16";

    contributionReviewNPSControllerVM.dob = $filter('date')(new Date(), "dd MMM yyyy");

    contributionReviewNPSControllerVM.close = function () {
      $ionicViewSwitcher.nextDirection('back');
      $state.go('menu.homeScreen');
    }

    contributionReviewNPSControllerVM.goBack = function () {
      $state.go("menu.contributionDetails");
    }

    contributionReviewNPSControllerVM.goNext = function () {

      $state.go("menu.reviewDetailsNps");

    }

    contributionReviewNPSControllerVM.calculateTotalCharges = function () {
      contributionReviewNPSControllerVM.charges = parseFloat(contributionReviewNPSControllerVM.npsContributionReviewDetails.charges ? contributionReviewNPSControllerVM.npsContributionReviewDetails.charges : 0) + parseFloat(contributionReviewNPSControllerVM.npsContributionReviewDetails.registrationCharges ? contributionReviewNPSControllerVM.npsContributionReviewDetails.registrationCharges : 0);
    }

    $scope.$on('$ionicView.beforeEnter', function () {
      contributionReviewNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
      homeScreenService.isBackCheck = false;
      contributionReviewNPSControllerVM.npsContributionReviewDetails = {};
      contributionReviewNPSControllerVM.npsContributionDetails = angular.copy(npsServices.npsContributionDetails);
      contributionReviewNPSControllerVM.npsContributionReviewDetails = angular.copy(npsServices.npsContributionReviewDetails);
      contributionReviewNPSControllerVM.npsAccountDetails = angular.copy(npsServices.npsAccountDetails);
      contributionReviewNPSControllerVM.npsFinalSuccessDetails = angular.copy(npsServices.npsFinalSuccessDetails);

      contributionReviewNPSControllerVM.calculateTotalCharges();

      contributionReviewNPSControllerVM.NPSDetails = npsServices.NPSDetails;
      contributionReviewNPSControllerVM.contriDisclaimer = contributionReviewNPSControllerVM.NPSDetails.npsContriDisclaimer;
    });



    return this;
  }
]);
