angularApp.service('npsServices', function ($ionicPopup,$q, $http, AdapterUtils, utilityService, $cordovaDevice, $state, $ionicPopover) {
    var npsServices = this;

    npsServices.resumeDataSet = false;

    npsServices.resumeRedirectData = {
        resumeid: "",
        resumeState: ""
    };

    npsServices.npsTermsAndCondition = {
        tncFlag: ""
    };

    npsServices.npsDropdownData = {};

    npsServices.npsAccountDetails = {
        accountSelectedIndex: "",
        npsAccountType: "",
        crAgency: "NSDL e-Governance Infrastructure Ltd.",
        ckycNumber: "",
        preExistingNpsAccount: "",
        bankAccountNumber: "",
        bankAccountType: ""
    };

    npsServices.npsTprnSuccessData = {
        tprn: "",
        createdDate: ""
    };

    npsServices.applicantData = {
        cif: "",
        salutation: "",
        salutationValue: "",
        fullName: "",
        maidenName: "",
        genderCode: "",
        gender: "",
        dateOfBirth: "",
        placeOfBirth: "",
        countryOfBirth: "",
        countryOfBirthValue: "",
        fatherFirstName: "",
        fatherMiddleName: "",
        fatherLastName: "",
        motherFirstName: "",
        motherMiddleName: "",
        motherLastName: "",
        residentialStatus: "",
        residentialValue: "",
        maritalStatus: "",
        maritalStatusValue: "",
        spouseFirstName: "",
        spouseMiddleName: "",
        spouseLastName: "",
        panNumber: "",
        aadhaarNumber: "",
        addressType: "",
        addressLine1: "",
        addressLine2: "",
        addressLine3: "",
        state: "",
        stateCode: "",
        district: "",
        subDistrict: "",
        city: "",
        villageCode: "",
        pinCode: "",
        email: "",
        telPhoneNumberResidential: "",
        telPhoneNumberOffice: "",
        isdCountryCode: "",
        mobileNumber: "",
        customerPhoto: "",
        custphotoid: "",
        customerSignature: "",
        custsignid: "",
        reviewconsent: ""
    };

    npsServices.npsParentsDetails = {
        motherNamePrintCheckbox: ""
    };

    npsServices.npsContactDetails = {
        displayOnlyEmail: ""       //doNot Clear this data
    };

    npsServices.npsOtherDetails = {
        occupation: "",
        occupationText: "",
        otherOccupationDetails: "",
        income: "",
        incomeText: "",
        education: "",
        educationText: "",
        politicalExposed: "00"
    };

    npsServices.npsBankDetails = {
        branchName: "",
        address: "",
        pincode: "",
        phoneNumber: "",
        district: "",
        state: "",
        stateCode: "",
        micrCode: "",
        ifscCode: "",
        bankName: "",
        country: ""
    };

    npsServices.npsNominationDetails = {

        numberOfNominee: "",
        nominees: [],
        sameNomineeForTierII: ""
    };

    npsServices.npsNomineeAddressDetails = {

        nomineesAddress: []
    };

    npsServices.npsNominationDetailsTierII = {

        numberOfNominee: "",
        nominees: []
    };

    npsServices.npsNomineeAddressDetailsTierII = {

        nomineesAddress: []
    };

    npsServices.npsPensionDetails = {

        pensionFundList: [],           //doNot Clear this data
        assetAllocationList: [],    //doNot Clear this data
        tierIdata: {
            pensionFund: "",
            pensionFundText: "",
            investmentOption: "",
            assetAllocation: "",
            assetAllocationText: "",
            equity: "",
            equityCode: "",
            corporateDebt: "",
            corporateDebtCode: "",
            governmentBond: "",
            governmentBondCode: "",
            alternativeFund: "",
            alternativeFundCode: ""
        },
        tierIIdata: {
            pensionFund: "",
            pensionFundText: "",
            investmentOption: "",
            assetAllocation: "",
            assetAllocationText: "",
            equity: "",
            equityCode: "",
            corporateDebt: "",
            corporateDebtCode: "",
            governmentBond: "",
            governmentBondCode: "",
            alternativeFund: "",
            alternativeFundCode: ""
        }

    };

    npsServices.npsFatcaDetails = {
        isUsCitizen: "",
        residentCountries: [],
        autoFetchConsent: "",
        tncFlag: ""
    };

    npsServices.npsMoneyLaunderingDetails = {
        moneyLaunderingFlag: ""
    };

    npsServices.npsContributionDetails = {
        contributionAmountTierI: "",
        contributionAmountTierII: ""
    };

    npsServices.npsContributionReviewDetails = {
        charges: "",
        registrationCharges: "",
        gst: "",
        totalAmtReceivable: "",
        totalInvestmentAmount: "",
        npsContriDisclaimer:''
    }

    npsServices.npsFinalSuccessDetails = {
        registrationReceiptNo: "",
        contributionReceiptNo: "",
        pran: "",
        pdfDocName: "",
        applicationSubmittedDate: "",
        leg: ""
    }

    npsServices.deviceInfo = {
        deviceIMEI: $cordovaDevice.getUUID(),
        deviceOS: $cordovaDevice.getPlatform()
    };

    //------------------------------------ Info Popup -----------------------------------------------------
    npsServices.sizeInfoPopover = function ($event, $scope) {

    var getInfoMsg = "Photo and signature should be in jpg format. Size should be between 4KB - 12 KB.";
    var template = '<ion-popover-view class="nps-tooltip-after tooltiptext nps-otherDetails-tooltip roboto-regular" style = "height: 85px;">' + '<ion-content>' +
     '<div class="text-left">' + getInfoMsg + '</div>' + '</ion-content>' + '</ion-popover-view>';

    var popover = $ionicPopover.fromTemplate(template, {
        scope: $scope
    });
        popover.show($event);
    }
     
     npsServices.showErrorMessage = function (message, openSetting) {
		
			var deferred = $q.defer();
			$ionicPopup.alert({
				title: "",
				template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" alt="Alert" src="img/FT/BhimUpi/alertSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
				+ message + '</span></div></div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',

			}).then(function (res) {
				deferred.resolve(res);
				if (res && openSetting) {
					if (typeof cordova.plugins.settings.openSetting != undefined) {
						cordova.plugins.settings.openSetting("settings", function () {

						},
							function () {

							});
					}
				}
			});
			return deferred.promise;
	   };

    //-----------------------------------Info Popup End -----------------------------------------------------


    // ------------------------ Set Resume Data ----------------------------

    npsServices.setResumeData = function (resumeData) {

        if (resumeData.data.tprn && !npsServices.resumeDataSet) {

            npsServices.npsTprnSuccessData.tprn = resumeData.data.tprn;
            npsServices.npsTprnSuccessData.createdDate = resumeData.npsData.customerDetails.applistartdate;

            npsServices.applicantData.cif = resumeData.npsData.customerDetails.cifnumber;
            npsServices.applicantData.salutation = resumeData.npsData.customerDetails.titlecode;
            npsServices.applicantData.salutationValue = resumeData.npsData.customerDetails.title;
            npsServices.applicantData.fullName = resumeData.npsData.customerDetails.name;
            npsServices.applicantData.maidenName = resumeData.npsData.customerDetails.maidenname;
            npsServices.applicantData.genderCode = resumeData.npsData.customerDetails.gendercode;
            npsServices.applicantData.gender = resumeData.npsData.customerDetails.gender;
            npsServices.applicantData.dateOfBirth = resumeData.npsData.customerDetails.dob;
            npsServices.applicantData.placeOfBirth = resumeData.npsData.customerDetails.cityofbirth;
            npsServices.applicantData.countryOfBirth = resumeData.npsData.customerDetails.countryofbirthcode;
            npsServices.applicantData.countryOfBirthValue = resumeData.npsData.customerDetails.countryofbirth;
            npsServices.applicantData.fatherFirstName = resumeData.npsData.customerDetails.fatherfirstname;
            npsServices.applicantData.fatherMiddleName = resumeData.npsData.customerDetails.fathermiddlename;
            npsServices.applicantData.fatherLastName = resumeData.npsData.customerDetails.fatherlastname;
            npsServices.applicantData.motherFirstName = resumeData.npsData.customerDetails.motherfirstname;
            npsServices.applicantData.motherMiddleName = resumeData.npsData.customerDetails.mothermiddlename;
            npsServices.applicantData.motherLastName = resumeData.npsData.customerDetails.motherlastname;
            npsServices.applicantData.residentialStatus = resumeData.npsData.customerDetails.residentialstatuscode;
            npsServices.applicantData.residentialValue = resumeData.npsData.customerDetails.residentialstatus;
            npsServices.applicantData.maritalStatus = resumeData.npsData.customerDetails.maritalstatuscode;
            npsServices.applicantData.maritalStatusValue = resumeData.npsData.customerDetails.maritalstatus;
            npsServices.applicantData.spouseFirstName = resumeData.npsData.customerDetails.spousefirstname;
            npsServices.applicantData.spouseMiddleName = resumeData.npsData.customerDetails.spousemiddlename;
            npsServices.applicantData.spouseLastName = resumeData.npsData.customerDetails.spouselastname;
            npsServices.applicantData.panNumber = resumeData.npsData.customerDetails.pan;
            npsServices.applicantData.email = resumeData.npsData.customerDetails.emailid;
            npsServices.applicantData.telPhoneNumberResidential = resumeData.npsData.customerDetails.personaltelephone;
            npsServices.applicantData.telPhoneNumberOffice = resumeData.npsData.customerDetails.officetelephone;
            npsServices.applicantData.mobileNumber = resumeData.npsData.customerDetails.mobilenumber;
            npsServices.applicantData.custphotoid = resumeData.npsData.customerDetails.custphotoid;
            npsServices.applicantData.custsignid = resumeData.npsData.customerDetails.custsignid;
            npsServices.applicantData.reviewconsent = resumeData.npsData.customerDetails.reviewconsent == "Y" ? true : false;
            npsServices.applicantData.otpflag = resumeData.npsData.customerDetails.otpflag == "Y" ? true : false;
            npsServices.applicantData.signConfirmFlag = resumeData.npsData.customerDetails.signConfirmFlag == "Y" ? true : false;
            npsServices.applicantData.photoConfirmFlag = resumeData.npsData.customerDetails.photoConfirmFlag == "Y" ? true : false;

            npsServices.npsParentsDetails.motherNamePrintCheckbox = resumeData.npsData.customerDetails.mothernameprintrequired == "Y" ? true : false;

            npsServices.npsTermsAndCondition.tncFlag = resumeData.npsData.customerDetails.termsandconditionsflag == "Y" ? true : false;
            npsServices.npsAccountDetails.bankAccountNumber = resumeData.npsData.customerDetails.accountno;
            npsServices.npsAccountDetails.ckycNumber = resumeData.npsData.customerDetails.ckycno;
            npsServices.npsAccountDetails.preExistingNpsAccount = resumeData.npsData.customerDetails.nonpsconsent == "Y" ? true : false;

            npsServices.npsOtherDetails.occupation = resumeData.npsData.customerDetails.occupationcode;
            npsServices.npsOtherDetails.occupationText = resumeData.npsData.customerDetails.occupation;
            npsServices.npsOtherDetails.otherOccupationDetails = resumeData.npsData.customerDetails.suboccupation;
            npsServices.npsOtherDetails.income = resumeData.npsData.customerDetails.annualincomecode;
            npsServices.npsOtherDetails.incomeText = resumeData.npsData.customerDetails.annualincome;
            npsServices.npsOtherDetails.education = resumeData.npsData.customerDetails.educationcode;
            npsServices.npsOtherDetails.educationText = resumeData.npsData.customerDetails.education;
            npsServices.npsOtherDetails.politicalExposed = resumeData.npsData.customerDetails.ispoliticallyexposed ? resumeData.npsData.customerDetails.ispoliticallyexposed : "00";

            if (resumeData.npsData.address[0]) {

                for (var i = 0; i < resumeData.npsData.address.length; i++) {

                    if (resumeData.npsData.address[i].addressType.toLowerCase() == "residential") {

                        npsServices.applicantData.addressType = resumeData.npsData.address[i].addressType;
                        npsServices.applicantData.addressLine1 = resumeData.npsData.address[i].addressline1;
                        npsServices.applicantData.addressLine2 = resumeData.npsData.address[i].addressline2;
                        npsServices.applicantData.addressLine3 = resumeData.npsData.address[i].addressline3;
                        npsServices.applicantData.state = resumeData.npsData.address[i].state;
                        npsServices.applicantData.stateCode = resumeData.npsData.address[i].statecode;
                        npsServices.applicantData.district = resumeData.npsData.address[i].district;
                        npsServices.applicantData.subDistrict = resumeData.npsData.address[i].subDist;
                        npsServices.applicantData.city = resumeData.npsData.address[i].city;
                        npsServices.applicantData.villageCode = resumeData.npsData.address[i].villagecode;
                        npsServices.applicantData.pinCode = resumeData.npsData.address[i].pincode;
                    }
                }

            }

            if (resumeData.npsData.bankDetails) {

                npsServices.npsAccountDetails.npsAccountType = resumeData.npsData.bankDetails.npsaccounttype;
                npsServices.npsAccountDetails.bankAccountType = resumeData.npsData.bankDetails.accounttype;
                npsServices.npsBankDetails.branchName = resumeData.npsData.bankDetails.branchname;
                npsServices.npsBankDetails.address = resumeData.npsData.bankDetails.branchaddress;
                npsServices.npsBankDetails.pincode = resumeData.npsData.bankDetails.pincode;
                npsServices.npsBankDetails.stateCode = resumeData.npsData.bankDetails.statecode;
                npsServices.npsBankDetails.state = resumeData.npsData.bankDetails.state;
                npsServices.npsBankDetails.micrCode = resumeData.npsData.bankDetails.micr;
                npsServices.npsBankDetails.ifscCode = resumeData.npsData.bankDetails.ifsc;
                npsServices.npsBankDetails.bankName = resumeData.npsData.bankDetails.bankname;
                npsServices.npsBankDetails.country = resumeData.npsData.bankDetails.country;
            }

            if (resumeData.npsData.nomineeDetails[0]) {

                var countTier1 = 0;
                var countTier2 = 0;

                npsServices.npsNominationDetails.sameNomineeForTierII = resumeData.npsData.customerDetails.isnomineesame == "Y" ? true : false;

                for (var j = 0; j < resumeData.npsData.nomineeDetails.length; j++) {

                    if (resumeData.npsData.nomineeDetails[j].npsaccounttype.toLowerCase() == "tier1") {

                        var insert = {
                            count: countTier1 + 1,
                            enableDelete: countTier1 == 0 ? false : true,
                            npsNomineeType: resumeData.npsData.nomineeDetails[j].ismajor,
                            nomineeFirstName: resumeData.npsData.nomineeDetails[j].firstname,
                            nomineeMiddleName: resumeData.npsData.nomineeDetails[j].middlename,
                            nomineeSurname: resumeData.npsData.nomineeDetails[j].lastname,
                            nomineeRelationship: resumeData.npsData.nomineeDetails[j].relationship,
                            nomineeDob: resumeData.npsData.nomineeDetails[j].dob,
                            percentageShare: resumeData.npsData.nomineeDetails[j].percentageshare,
                            guardianFirstName: resumeData.npsData.nomineeDetails[j].guardianfirstname,
                            guardianMiddleName: resumeData.npsData.nomineeDetails[j].guardianmiddlename,
                            guardianSurname: resumeData.npsData.nomineeDetails[j].guardianlastname
                        }

                        npsServices.npsNominationDetails.nominees.push(insert);
                        countTier1 = countTier1 + 1;

                    } else if (resumeData.npsData.nomineeDetails[j].npsaccounttype.toLowerCase() == "tier2") {

                        var insert = {
                            count: countTier2 + 1,
                            enableDelete: countTier2 == 0 ? false : true,
                            npsNomineeType: resumeData.npsData.nomineeDetails[j].ismajor,
                            nomineeFirstName: resumeData.npsData.nomineeDetails[j].firstname,
                            nomineeMiddleName: resumeData.npsData.nomineeDetails[j].middlename,
                            nomineeSurname: resumeData.npsData.nomineeDetails[j].lastname,
                            nomineeRelationship: resumeData.npsData.nomineeDetails[j].relationship,
                            nomineeDob: resumeData.npsData.nomineeDetails[j].dob,
                            percentageShare: resumeData.npsData.nomineeDetails[j].percentageshare,
                            guardianFirstName: resumeData.npsData.nomineeDetails[j].guardianfirstname,
                            guardianMiddleName: resumeData.npsData.nomineeDetails[j].guardianmiddlename,
                            guardianSurname: resumeData.npsData.nomineeDetails[j].guardianlastname
                        }

                        npsServices.npsNominationDetailsTierII.nominees.push(insert);
                        countTier2 = countTier2 + 1;
                    }
                }

                if (npsServices.npsNominationDetails.nominees[0]) {

                    npsServices.npsNominationDetails.numberOfNominee = npsServices.npsNominationDetails.nominees.length;

                }

                if (npsServices.npsNominationDetailsTierII.nominees[0]) {

                    npsServices.npsNominationDetailsTierII.numberOfNominee = npsServices.npsNominationDetailsTierII.nominees.length;

                }


            }

            if (resumeData.npsData.address[1]) {

                var countTier1 = 0;
                var countTier2 = 0;

                for (var k = 0; k < resumeData.npsData.address.length; k++) {

                    if (resumeData.npsData.address[k].addressType.toLowerCase().indexOf("tier1") != -1) {

                        var insert = {
                            count: countTier1 + 1,
                            addressLine1: resumeData.npsData.address[k].addressline1,
                            addressLine2: resumeData.npsData.address[k].addressline2,
                            districtTownCity: resumeData.npsData.address[k].district,
                            pinCode: resumeData.npsData.address[k].pincode,
                            stateUnionTerritory: resumeData.npsData.address[k].statecode,
                            stateUnionTerritoryText: resumeData.npsData.address[k].state,
                            country: resumeData.npsData.address[k].countrycode ? resumeData.npsData.address[k].countrycode : "IN",
                            countryText: resumeData.npsData.address[k].country ? resumeData.npsData.address[k].country : "India",
                        }

                        npsServices.npsNomineeAddressDetails.nomineesAddress.push(insert);
                        countTier1 = countTier1 + 1;

                    } else if (resumeData.npsData.address[k].addressType.toLowerCase().indexOf("tier2") != -1) {

                        var insert = {
                            count: countTier2 + 1,
                            addressLine1: resumeData.npsData.address[k].addressline1,
                            addressLine2: resumeData.npsData.address[k].addressline2,
                            districtTownCity: resumeData.npsData.address[k].district,
                            pinCode: resumeData.npsData.address[k].pincode,
                            stateUnionTerritory: resumeData.npsData.address[k].statecode,
                            stateUnionTerritoryText: resumeData.npsData.address[k].state,
                            country: resumeData.npsData.address[k].countrycode ? resumeData.npsData.address[k].countrycode : "IN",
                            countryText: resumeData.npsData.address[k].country ? resumeData.npsData.address[k].country : "India",
                        }

                        npsServices.npsNomineeAddressDetailsTierII.nomineesAddress.push(insert);
                        countTier2 = countTier2 + 1;
                    }

                }

            }

            if (resumeData.npsData.accountDetails[0]) {

                for (var l = 0; l < resumeData.npsData.accountDetails.length; l++) {

                    if (resumeData.npsData.accountDetails[l].npsaccounttype.toLowerCase() == "tier1") {

                        npsServices.npsPensionDetails.tierIdata.pensionFund = resumeData.npsData.accountDetails[l].fundcode;
                        npsServices.npsPensionDetails.tierIdata.pensionFundText = resumeData.npsData.accountDetails[l].nameoffund;
                        npsServices.npsPensionDetails.tierIdata.investmentOption = resumeData.npsData.accountDetails[l].investmenttype;
                        npsServices.npsPensionDetails.tierIdata.assetAllocation = resumeData.npsData.accountDetails[l].assetallocation; // assigning same value to code and text
                        npsServices.npsPensionDetails.tierIdata.assetAllocationText = resumeData.npsData.accountDetails[l].assetallocation;
                        npsServices.npsPensionDetails.tierIdata.equity = resumeData.npsData.accountDetails[l].eClassInvestment;
                        npsServices.npsPensionDetails.tierIdata.equityCode = resumeData.npsData.accountDetails[l].schemeClassE;
                        npsServices.npsPensionDetails.tierIdata.corporateDebt = resumeData.npsData.accountDetails[l].cClassInvestment;
                        npsServices.npsPensionDetails.tierIdata.corporateDebtCode = resumeData.npsData.accountDetails[l].schemeClassC;
                        npsServices.npsPensionDetails.tierIdata.governmentBond = resumeData.npsData.accountDetails[l].gClassInvestment;
                        npsServices.npsPensionDetails.tierIdata.governmentBondCode = resumeData.npsData.accountDetails[l].schemeClassG;
                        npsServices.npsPensionDetails.tierIdata.alternativeFund = resumeData.npsData.accountDetails[l].aClassInvestment;
                        npsServices.npsPensionDetails.tierIdata.alternativeFundCode = resumeData.npsData.accountDetails[l].schemeClassA;

                        npsServices.npsContributionDetails.contributionAmountTierI = resumeData.npsData.accountDetails[l].contributionamount;


                    } else if (resumeData.npsData.accountDetails[l].npsaccounttype.toLowerCase() == "tier2") {

                        npsServices.npsPensionDetails.tierIIdata.pensionFund = resumeData.npsData.accountDetails[l].fundcode;
                        npsServices.npsPensionDetails.tierIIdata.pensionFundText = resumeData.npsData.accountDetails[l].nameoffund;
                        npsServices.npsPensionDetails.tierIIdata.investmentOption = resumeData.npsData.accountDetails[l].investmenttype;
                        npsServices.npsPensionDetails.tierIIdata.assetAllocation = resumeData.npsData.accountDetails[l].assetallocation; // assigning same value to code and text
                        npsServices.npsPensionDetails.tierIIdata.assetAllocationText = resumeData.npsData.accountDetails[l].assetallocation;
                        npsServices.npsPensionDetails.tierIIdata.equity = resumeData.npsData.accountDetails[l].eClassInvestment;
                        npsServices.npsPensionDetails.tierIIdata.equityCode = resumeData.npsData.accountDetails[l].schemeClassE;
                        npsServices.npsPensionDetails.tierIIdata.corporateDebt = resumeData.npsData.accountDetails[l].cClassInvestment;
                        npsServices.npsPensionDetails.tierIIdata.corporateDebtCode = resumeData.npsData.accountDetails[l].schemeClassC;
                        npsServices.npsPensionDetails.tierIIdata.governmentBond = resumeData.npsData.accountDetails[l].gClassInvestment;
                        npsServices.npsPensionDetails.tierIIdata.governmentBondCode = resumeData.npsData.accountDetails[l].schemeClassG;
                        npsServices.npsPensionDetails.tierIIdata.alternativeFund = resumeData.npsData.accountDetails[l].aClassInvestment;
                        npsServices.npsPensionDetails.tierIIdata.alternativeFundCode = resumeData.npsData.accountDetails[l].schemeClassA;

                        npsServices.npsContributionDetails.contributionAmountTierII = resumeData.npsData.accountDetails[l].contributionamount;

                    }
                }

            }


            npsServices.npsMoneyLaunderingDetails.moneyLaunderingFlag = resumeData.npsData.customerDetails.launderingflag == "Y" ? true : false;
            npsServices.npsFatcaDetails.autoFetchConsent = resumeData.npsData.customerDetails.autofetchconsent == "Y" ? true : false;
            npsServices.npsFatcaDetails.isUsCitizen = resumeData.npsData.customerDetails.isuscitizen;
            npsServices.npsFatcaDetails.tncFlag = resumeData.npsData.customerDetails.tncflag == "Y" ? true : false;
            if (resumeData.npsData.fatcaDetails[0]) {

                var count = 0;

                for (var m = 0; m < resumeData.npsData.fatcaDetails.length; m++) {
                    var insert = {

                        count: count + 1,
                        enableDelete: count == 0 ? false : true,
                        displayOnlyField: count == 0 ? true : false,
                        residentCountry: resumeData.npsData.fatcaDetails[m].countrycode,
                        residentCountryText: resumeData.npsData.fatcaDetails[m].country,
                        residentCountryAddress: { addressLine1: resumeData.npsData.fatcaDetails[m].addressline1, cityTownVillage: resumeData.npsData.fatcaDetails[m].city, state: resumeData.npsData.fatcaDetails[m].state, stateCode: resumeData.npsData.fatcaDetails[m].statecode, pinCode: resumeData.npsData.fatcaDetails[m].pincode },
                        taxIdentificationNo: resumeData.npsData.fatcaDetails[m].tin,
                        tinIssuingCountry: resumeData.npsData.fatcaDetails[m].tinissuingcountrycode,
                        tinIssuingCountryText: resumeData.npsData.fatcaDetails[m].tinissuingcountry,
                        validTill: resumeData.npsData.fatcaDetails[m].validity
                    }

                    npsServices.npsFatcaDetails.residentCountries.push(insert);
                    count = count + 1;

                }

            }



            npsServices.npsContributionReviewDetails.totalAmtReceivable = resumeData.npsData.customerDetails.totaldebitedamount;
            npsServices.npsContributionReviewDetails.totalInvestmentAmount = resumeData.npsData.customerDetails.totalinvestedamount;
            npsServices.npsFinalSuccessDetails.pdfDocName = resumeData.npsData.customerDetails.pdfdocname;
            npsServices.npsFinalSuccessDetails.applicationSubmittedDate = resumeData.npsData.customerDetails.applisubmitdate;
            npsServices.npsContributionReviewDetails.npsContriDisclaimer = resumeData.npsData.customerDetails.npsContriDisclaimer;

            if (resumeData.npsData.reports) {

                npsServices.npsContributionReviewDetails.charges = resumeData.npsData.reports.totalBankCharges;
                npsServices.npsContributionReviewDetails.registrationCharges = resumeData.npsData.reports.registrationCharges;
                npsServices.npsContributionReviewDetails.gst = resumeData.npsData.reports.gst;
                npsServices.npsFinalSuccessDetails.registrationReceiptNo = resumeData.npsData.reports.registartionReceiptNumber;
                npsServices.npsFinalSuccessDetails.contributionReceiptNo = resumeData.npsData.reports.contributionReceiptNumber;
                npsServices.npsFinalSuccessDetails.pran = resumeData.npsData.reports.pran;
                npsServices.npsFinalSuccessDetails.leg = resumeData.npsData.reports.leg;
            }


            // after resume Data Set
            npsServices.resumeDataSet = true;

        }

        if (resumeData.data.tprn) {

            //set resume redirection data
            if (resumeData.npsData.customerDetails.resumeid && resumeData.npsData.customerDetails.resumeState) {

                npsServices.resumeRedirectData.resumeid = resumeData.npsData.customerDetails.resumeid;
                npsServices.resumeRedirectData.resumeState = resumeData.npsData.customerDetails.resumeState;

            }

        }

    }

    npsServices.resumeRedirect = function () {

        if (npsServices.resumeRedirectData.resumeid == "generateTPRN") {

            if (!npsServices.applicantData.panNumber) {
                npsServices.getCIFDetails().then(function (data) {
                    npsServices.applicantData = data;
                    $state.go(npsServices.resumeRedirectData.resumeState);

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });
            } else {
                $state.go(npsServices.resumeRedirectData.resumeState);
            }


        } else if (npsServices.resumeRedirectData.resumeid == "saveNomineeTier1") {

            if (npsServices.npsNominationDetails.sameNomineeForTierII || npsServices.npsAccountDetails.npsAccountType.toUpperCase() == "TIER1") {

                npsServices.fetchPensionFundList().then(function (response) {
                    npsServices.npsPensionDetails.pensionFundList = response.pensionFundList;
                    npsServices.npsPensionDetails.assetAllocationList = response.autoAssetAllocationList;
                    $state.go("menu.npsPensionFundDetails");

                }, function (error) {
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                });

            } else {
                $state.go(npsServices.resumeRedirectData.resumeState);
            }



        } else if (npsServices.resumeRedirectData.resumeid == "saveNomineeTier2" || npsServices.resumeRedirectData.resumeid == "savePensionFundListTier1") {

            npsServices.fetchPensionFundList().then(function (response) {
                npsServices.npsPensionDetails.pensionFundList = response.pensionFundList;
                npsServices.npsPensionDetails.assetAllocationList = response.autoAssetAllocationList;

                if (npsServices.resumeRedirectData.resumeid == "savePensionFundListTier1") {

                    if (npsServices.npsAccountDetails.npsAccountType.toUpperCase() == "TIER1") {
                        $state.go("menu.fatcaDetails");
                    } else {
                        $state.go(npsServices.resumeRedirectData.resumeState);
                    }

                } else {

                    $state.go(npsServices.resumeRedirectData.resumeState);

                }


            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });

        } else {

            $state.go(npsServices.resumeRedirectData.resumeState);

        }



    }



    // -----------------------------------------------------API CALL START----------------------------------------------


    // -----------------FETCH API START-----------------------

    npsServices.getAccountList = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/getAccountList", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.validateAccountNumber = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/validateAccountNumber", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.getNPSDetails = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/getNPSDetail", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.fetchNPSDropDown = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/fetchNPSDropDown", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.getCIFDetails = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/getCIFDetails", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.fetchBranchDetails = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/fetchBranchDetails", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.fetchPensionFundList = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/fetchPensionFundList", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.fetchAssetAllocation = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/fetchAssetAllocation", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.fetchConributionCharges = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/fetchConributionCharges", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.generatePRAN = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/generatePRAN", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.generateOTP = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/generateOTP", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.validateOTP = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/validateOTP", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.getDocument = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/getDocument", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.retrievePhoto = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/retrieveDocument/" + requestData, "", true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    // -----------------FETCH API END-----------------------

    // -----------------RESUME API START-----------------------

    npsServices.checkNPSApplication = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/checkNPSApplication", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };


    // -----------------RESUME API END-----------------------


    // -----------------SAVE API START-----------------------

    npsServices.registerCustomerForNPS = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/registerCustomerForNPS", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.savePersonalAndParentsDetails = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/savePersonalAndParentsDetails", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.saveAddressAndContactDetails = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/saveAddressAndContactDetails", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.saveOtherDetails = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/saveOtherDetails", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.saveNomineeDetails = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/updateNomineeDetails", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.saveFatcaDetails = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/saveFatcaDetails", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.savePensionFundDetails = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/savePensionFundDetails", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    npsServices.uploadDocument = function (requestData) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/AccountOpeningAdapter/NPS/uploadDocument", requestData, true).then(
            function (response) {
                q.resolve(response);
            },
            function (error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    // -----------------SAVE API END-----------------------

    return npsServices;
});