'use strict';

angularApp.controller('assetAllocationDetailsNPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter) {

        var assetAllocationDetailsNPSControllerVM = this;
        $scope.currentPage = "5";
        $scope.lastPage = "16";


        assetAllocationDetailsNPSControllerVM.close = function(){
           $ionicViewSwitcher.nextDirection('back');
           $state.go('menu.homeScreen');
        }

        assetAllocationDetailsNPSControllerVM.goBack = function(){
            $ionicHistory.goBack();
        }

        // assetAllocationDetailsNPSControllerVM.goNext = function(){
        //     $state.go("menu.npsContactDetails");
        // }

        $scope.$on('$ionicView.beforeEnter', function () {
            assetAllocationDetailsNPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            assetAllocationDetailsNPSControllerVM.applicantData = angular.copy(npsServices.applicantData);
            
        });

        return this;
    }
]);
