'use strict';

angularApp.controller('pensionFundDetailsTierIINPSController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "npsServices",
    "$filter",
    "constantConfig",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        npsServices,
        $filter,
        constantConfig) {

        var pensionFundDetailsTierIINPSControllerVM = this;
        $scope.currentPage = "12";
        $scope.lastPage = "16";
        pensionFundDetailsTierIINPSControllerVM.npsInvestmentOptionFlag = false;
        pensionFundDetailsTierIINPSControllerVM.showActive = true;

        pensionFundDetailsTierIINPSControllerVM.totalPensionPercentage = 0;

        pensionFundDetailsTierIINPSControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            $state.go('menu.homeScreen');
        }

        pensionFundDetailsTierIINPSControllerVM.goBack = function () {
            $state.go("menu.npsPensionFundDetails");
        }


        pensionFundDetailsTierIINPSControllerVM.goNext = function () {
            npsServices.npsPensionDetails.tierIIdata.pensionFund = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.pensionFund;
            npsServices.npsPensionDetails.tierIIdata.pensionFundText = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.pensionFundText;
            npsServices.npsPensionDetails.tierIIdata.investmentOption = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption;
            npsServices.npsPensionDetails.tierIIdata.assetAllocation = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.assetAllocation;
            npsServices.npsPensionDetails.tierIIdata.assetAllocationText = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.assetAllocationText;
            npsServices.npsPensionDetails.tierIIdata.equity = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.equity;
            npsServices.npsPensionDetails.tierIIdata.equityCode = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.equityCode;
            npsServices.npsPensionDetails.tierIIdata.corporateDebt = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt;
            npsServices.npsPensionDetails.tierIIdata.corporateDebtCode = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.corporateDebtCode;
            npsServices.npsPensionDetails.tierIIdata.governmentBond = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.governmentBond;
            npsServices.npsPensionDetails.tierIIdata.governmentBondCode = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.governmentBondCode;
            // npsServices.npsPensionDetails.tierIIdata.alternativeFund = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.alternativeFund;
            // npsServices.npsPensionDetails.tierIIdata.alternativeFundCode = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.alternativeFundCode;

            var requestParams = {
                "npsAccountType": "Tier2",
                "pensionFund": {
                    "nameOfFund": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.pensionFundText,
                    "fundCode": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.pensionFund,
                    "investmentType": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption,
                    "assetAllocation": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption.toLowerCase() == 'auto' ? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.assetAllocationText : '',
                    "assetAllocationCode": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption.toLowerCase() == 'auto' ? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.assetAllocation : '',
                    "equity": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.equity : '',
                    "equityCode": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.equityCode : '',
                    "corporateDebt": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt : '',
                    "corporateDebtCode": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.corporateDebtCode : '',
                    "governmentBond": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.governmentBond : '',
                    "governmentBondCode": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.governmentBondCode : '',
                    // "alternativeFund": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.alternativeFund : '',
                    // "alternativeFundCode": pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption.toLowerCase() == 'active' ? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.alternativeFundCode : ''
                    "alternativeFund":"",
                    "alternativeFundCode": ""
                }
            };

            npsServices.savePensionFundDetails(requestParams).then(function (response) {
                $state.go("menu.fatcaDetails");

            }, function (error) {
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });

        }
        pensionFundDetailsTierIINPSControllerVM.fetchActiveAssetAllocationData = function () {
            var requestParams = {
                pfmId: pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.pensionFund
            };

            npsServices.fetchAssetAllocation(requestParams).then(function (response) {

                pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.equityCode = response.assetClassETier2;
                pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.corporateDebtCode = response.assetClassCTier2;
                pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.governmentBondCode = response.assetClassGTier2;
                // pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.alternativeFundCode = response.assetClassATier2;
                pensionFundDetailsTierIINPSControllerVM.showActive = true;

            }, function (error) {
                pensionFundDetailsTierIINPSControllerVM.showActive = false;
                utilityService.enableShowErrorMessage();
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        pensionFundDetailsTierIINPSControllerVM.npsPFInvestmentOptionChange = function () {
            if (pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption.toLowerCase() == 'active') {
                pensionFundDetailsTierIINPSControllerVM.fetchActiveAssetAllocationData();
                pensionFundDetailsTierIINPSControllerVM.assetPercentageChange();
            } else {
                pensionFundDetailsTierIINPSControllerVM.disableNext = false;
            }
        }

        pensionFundDetailsTierIINPSControllerVM.moreDetails = function () {

            npsServices.npsPensionDetails.tierIIdata.pensionFund = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.pensionFund;
            npsServices.npsPensionDetails.tierIIdata.pensionFundText = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.pensionFundText;
            npsServices.npsPensionDetails.tierIIdata.investmentOption = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption;
            npsServices.npsPensionDetails.tierIIdata.assetAllocation = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.assetAllocation;
            npsServices.npsPensionDetails.tierIIdata.assetAllocationText = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.assetAllocationText;
            npsServices.npsPensionDetails.tierIIdata.equity = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.equity;
            npsServices.npsPensionDetails.tierIIdata.equityCode = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.equityCode;
            npsServices.npsPensionDetails.tierIIdata.corporateDebt = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt;
            npsServices.npsPensionDetails.tierIIdata.corporateDebtCode = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.corporateDebtCode;
            npsServices.npsPensionDetails.tierIIdata.governmentBond = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.governmentBond;
            npsServices.npsPensionDetails.tierIIdata.governmentBondCode = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.governmentBondCode;
            // npsServices.npsPensionDetails.tierIIdata.alternativeFund = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.alternativeFund;
            // npsServices.npsPensionDetails.tierIIdata.alternativeFundCode = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.alternativeFundCode;

            $state.go("menu.npsAssetAllocationDetails");
        }

        pensionFundDetailsTierIINPSControllerVM.assetPercentageChange = function () {
            pensionFundDetailsTierIINPSControllerVM.totalPensionPercentage = parseFloat(pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.equity && pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.equity != '.'? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.equity : "0") + parseFloat(pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt && pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt != '.' ? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt : "0") + parseFloat(pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.governmentBond && pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.governmentBond != '.' ? pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.governmentBond : "0");

            if (pensionFundDetailsTierIINPSControllerVM.totalPensionPercentage == 100 || pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.investmentOption.toLowerCase() != 'active') {
                pensionFundDetailsTierIINPSControllerVM.disableNext = false;
            } else {
                pensionFundDetailsTierIINPSControllerVM.disableNext = true;
            }
        }

        pensionFundDetailsTierIINPSControllerVM.selectedPensionFund = function () {

            pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.pensionFundText = utilityService.getTextFromDropdown("pfmId", pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.pensionFund, pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.pensionFundList, "pfmName");

        }

        pensionFundDetailsTierIINPSControllerVM.selectedAssetAllocation = function () {

            pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.assetAllocationText = utilityService.getTextFromDropdown("assetAllocationCode", pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.assetAllocation, pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.assetAllocationList, "assetAllocation");

        }

        pensionFundDetailsTierIINPSControllerVM.calculateEquityPercentage = function () {

            var age = utilityService.getAge(npsServices.applicantData.dateOfBirth);

            if (age <= 50) {
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentage = "75%";
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentageValue = "75.0";
            } else if (age == 51) {
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentage = "72.5%";
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentageValue = "72.5";
            } else if (age == 52) {
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentage = "70%";
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentageValue = "70.0";
            } else if (age == 53) {
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentage = "67.5%";
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentageValue = "67.5";
            } else if (age == 54) {
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentage = "65%";
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentageValue = "65.0";
            } else if (age == 55) {
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentage = "62.5%";
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentageValue = "62.5";
            } else if (age == 56) {
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentage = "60%";
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentageValue = "60.0";
            } else if (age == 57) {
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentage = "57.5%";
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentageValue = "57.5";
            } else if (age == 58) {
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentage = "55%";
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentageValue = "55.0";
            } else if (age == 59) {
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentage = "52.5%";
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentageValue = "52.5";
            } else if (age >= 60) {
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentage = "50%";
                pensionFundDetailsTierIINPSControllerVM.maxEquityPercentageValue = "50.0";
            }
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            pensionFundDetailsTierIINPSControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            pensionFundDetailsTierIINPSControllerVM.calculateEquityPercentage();
            pensionFundDetailsTierIINPSControllerVM.npsAccountType = npsServices.npsAccountDetails.npsAccountType;
            pensionFundDetailsTierIINPSControllerVM.npsPensionDetails = angular.copy(npsServices.npsPensionDetails);
            if (!pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.pensionFund) {
                pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.pensionFund = "PFM001";
            }
            if (!pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.assetAllocation) {
                pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.assetAllocation = pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.assetAllocationList[1].assetAllocationCode;
            }
            if (!pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.equity) {
                pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.equity = 0;
            }
            if (!pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt) {
                pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.corporateDebt = 0;
            }
            if (!pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.governmentBond) {
                pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.governmentBond = 0;
            }
            // if (!pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.alternativeFund) {
            //     pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.alternativeFund = 0;
            // }


            pensionFundDetailsTierIINPSControllerVM.selectedPensionFund();
            if(pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.assetAllocation && pensionFundDetailsTierIINPSControllerVM.npsPensionDetails.tierIIdata.assetAllocation != "0"){
                pensionFundDetailsTierIINPSControllerVM.selectedAssetAllocation();
            }
            pensionFundDetailsTierIINPSControllerVM.assetPercentageChange();

        });



        return this;
    }
]);
