/**
 *   @ngdoc config
 *   @name angularApp.config : cardConfig
 *   @description
 *  configuration file for cards module
 */

/*This function defines all the constants named  Adapters url for cards module*/
angularApp
    /*State defination with respective names, urls, controllers and templates */
    .config([
        '$stateProvider',
        function ($stateProvider) {
            //Cards start
            $stateProvider
                .state('menu.pendingRequest', {
                    url: '/pendingRequest',
                    data: {
                        pageId: 'PENDINGREQUEST'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/pendingRequest/pendingRequest.html',
                            controller: 'pendingRequestController',
                            controllerAs: 'pendingRequestVm'
                        }
                    }
                }) 

                .state('menu.pendingRequestInsta', {
                    url: '/pendingRequestInsta',
                    data: {
                        pageId: 'PENDINGREQUESTINSTA'
                    },
                    cache: false,
                    views: {
                        'menuContent': {
                            templateUrl: 'pages/pendingRequest/pendingRequestInsta.html',
                            controller: 'pendingRequestInstaController',
                            controllerAs: 'pendingRequestInstaVm'
                        }
                    }
                }) 
        }
    ]);
