'use strict';

angularApp.controller('pendingRequestController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "customerInfoService",
    "emaillDetailsService",
    "utilityService",
    "pendingRequestService",
    "$ionicPopup",
    function ($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        customerInfoService,
        emaillDetailsService,
        utilityService,
        pendingRequestService,
        $ionicPopup) {

        //functions, variables that can be accessed from the HTML template
        var pendingRequestVm = this;

        function initPage() {
            pendingRequestVm.getServiceRequest();
        };

        pendingRequestVm.getServiceRequest = function () {
            console.log("inininik")
            // pendingRequestVm.spinner = true;
            pendingRequestService.getServiceRequest().then(function (response) {
                console.log("inininikresponse",response.payLoad)
                pendingRequestVm.serviceDetailResponses = response.payLoad;
                // pendingRequestVm.spinner = false;
                // pendingRequestVm.serviceReqFail = false;
            }, function (error) {
                // pendingRequestVm.spinner = false;
                // pendingRequestVm.serviceReqFail = true;
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        pendingRequestVm.goToAO = function() {
        $state.go('menu.serviceRequest');
        }

        pendingRequestVm.getRequestDetail = function (module, storeRefNumber) {
            var obj = {
                "appOrTransNo" : storeRefNumber
            }
            pendingRequestService.instaFetchSecondaryDetails(obj).then(function (response) {
                pendingRequestService.getRequestDetailData = response;
                if (module === "instatopup") {
                    $state.go('menu.pendingRequestInsta');
                }
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        };

        pendingRequestVm.scheduledfdDetails = function (module, storeRefNumber) {
            pendingRequestVm.getRequestDetail(module, storeRefNumber);
        };

        $scope.$on('$ionicView.beforeEnter', function () {
            // pendingRequestVm.spinner = true;
            // pendingRequestVm.serviceReqFail = false;
            initPage();
        });

        return this;
    }
]);
