'use strict';

angularApp.controller('emiPayDateController', [
	"$state",
	"$scope",
	"$sce",
	"ionicDatePicker",
	"personalLoanService",
	"utilityService",
	"fixedDepositService",
	"$rootScope","$ionicPopup","$filter",

	function ($state,
		$scope,
		$sce,
		ionicDatePicker,
		personalLoanService,
		utilityService,
		fixedDepositService,
		$rootScope,$ionicPopup,$filter) {


		var emiPayDateVm = this;
		emiPayDateVm.nightMode = false;
		$rootScope.currentPage = 2;
		emiPayDateVm.isAccountMasked = false;
		emiPayDateVm.isAndroidDevice = true ;
		$scope.dateobj = {};
		
		var configMtnsNumForCovid
		if (personalLoanService.product && personalLoanService.product === "64514034") {
			configMtnsNumForCovid = personalLoanService.configDetails.monthPeriod;
		}
		if (personalLoanService.categoryType == 'KAVACH') {
			configMtnsNumForCovid = personalLoanService.configDetails.monthPeriod;
		}

		emiPayDateVm.goBacktoPrevious = function () {
			$state.go('menu.personalLoan');
		}

		emiPayDateVm.calculateDate = function () {
			var toCurDate = new Date();
			var fromCurDate = new Date();
			var d = toCurDate.getDate();
			var m = toCurDate.getMonth();
			if (personalLoanService.product && personalLoanService.product === "64514034") {
				d = new Date(toCurDate.getFullYear(), (toCurDate.getMonth() + 1) + configMtnsNumForCovid, toCurDate.getDate()).getDate();
				m = new Date(toCurDate.setMonth(toCurDate.getMonth() + configMtnsNumForCovid)).getMonth();
			}
			if (personalLoanService.categoryType == "KAVACH") {
				d = new Date(toCurDate.getFullYear(), (toCurDate.getMonth() + 1) + configMtnsNumForCovid, toCurDate.getDate()).getDate();
				m = new Date(toCurDate.setMonth(toCurDate.getMonth() + configMtnsNumForCovid)).getMonth();
			}
			if (m === 0) {
				var days = 31;
				var nmDays = 30;
			} else if (m === 1) {
				var days = 28;
				var nmDays = 31;
			} else if (m === 2 || m === 4 || m === 7 || m === 9) {
				var days = 31;
				var nmDays = 30;
			} else if (m === 3 || m === 5 || m === 8 || m === 10) {
				var days = 30;
				var nmDays = 31;
			} else {
				var days = 31;
				var nmDays = 31;
			}
			/*if (nmDays > days)
				var excess = nmDays - days; 
			else
				var excess = days - nmDays; 
			if (m === 1 && d == 28)
				var excess = 0;
			else if ((m === 3 || m === 5 || m === 8 || m === 10) && (d === 30))
				var excess = 0;
			else if (d === 31)
				var excess = 0;*/
			if (!emiPayDateVm.nightMode) {

				emiPayDateVm.fromDate = new Date(toCurDate.setDate(d + 1));
				if (personalLoanService.product && personalLoanService.product === "64514034") {
					emiPayDateVm.toDate = new Date(toCurDate.setDate(d + 29));
				}else  if (personalLoanService.categoryType == 'KAVACH') {
					emiPayDateVm.toDate = new Date(toCurDate.setDate(d + 29));
				}
				else {
					if (m === 1) {
						if (d == 28) {
							var tempDate = new Date(toCurDate.setMonth(toCurDate.getMonth() + 1));
							var tempEmiDate = new Date(tempDate.setDate(tempDate.getDate() + 3));
							emiPayDateVm.toDate = tempEmiDate;
						} else {
							var tempDate = new Date(toCurDate.setMonth(toCurDate.getMonth() + 1));
							var tempEmiDate = new Date(tempDate.setDate(tempDate.getDate() + 2));
							emiPayDateVm.toDate = tempEmiDate;
						}
					}
					else if ((m === 0 || m === 2 || m === 4 || m === 7 || m === 9) && (d === 31)) {
						var tempDate = new Date(toCurDate.setMonth(toCurDate.getMonth() + 1));
						var tempEmiDate = new Date(tempDate.setDate(tempDate.getDate() - 1));
						emiPayDateVm.toDate = tempEmiDate;
					} else if ((m === 6 || m === 11) && (d === 31)) {
						var tempDate = new Date(toCurDate.setMonth(toCurDate.getMonth() + 1));
						var tempEmiDate = new Date(tempDate.setDate(tempDate.getDate()));
						emiPayDateVm.toDate = tempEmiDate;
					} else if ((m === 3 || m === 5 || m === 8 || m === 10) && (d === 30)) {
						var tempDate = new Date(toCurDate.setMonth(toCurDate.getMonth() + 1));
						var tempEmiDate = new Date(tempDate.setDate(tempDate.getDate() + 1));
						emiPayDateVm.toDate = tempEmiDate;
					}
					else {
						emiPayDateVm.toDate = new Date(toCurDate.setDate(d + days));
					}
				}

			} else {

				emiPayDateVm.fromDate = new Date(toCurDate.setDate(d + 2));
				if (personalLoanService.product && personalLoanService.product === "64514034") {
					emiPayDateVm.toDate = new Date(toCurDate.setDate(d + 29));
				}else  if (personalLoanService.categoryType == 'KAVACH') {
					emiPayDateVm.toDate = new Date(toCurDate.setDate(d + 29));
				}
				else {
					if (m === 1) {
						if (d == 28) {
							var tempDate = new Date(toCurDate.setMonth(toCurDate.getMonth() + 1));
							var tempEmiDate = new Date(tempDate.setDate(tempDate.getDate() + 4));
							emiPayDateVm.toDate = tempEmiDate;
						} else {
							var tempDate = new Date(toCurDate.setMonth(toCurDate.getMonth() + 1));
							var tempEmiDate = new Date(tempDate.setDate(tempDate.getDate() + 3));
							emiPayDateVm.toDate = tempEmiDate;
						}
					}
					else if ((m === 0 || m === 2 || m === 4 || m === 7 || m === 9) && (d === 31)) {
						var tempDate = new Date(toCurDate.setMonth(toCurDate.getMonth() + 1));
						var tempEmiDate = new Date(tempDate.setDate(tempDate.getDate()));
						emiPayDateVm.toDate = tempEmiDate;
					} else if ((m === 6 || m === 11) && (d === 31)) {
						var tempDate = new Date(toCurDate.setMonth(toCurDate.getMonth() + 1));
						var tempEmiDate = new Date(tempDate.setDate(tempDate.getDate() + 1));
						emiPayDateVm.toDate = tempEmiDate;
					} else if ((m === 3 || m === 5 || m === 8 || m === 10) && (d === 30)) {
						var tempDate = new Date(toCurDate.setMonth(toCurDate.getMonth() + 1));
						var tempEmiDate = new Date(tempDate.setDate(tempDate.getDate() + 2));
						emiPayDateVm.toDate = tempEmiDate;
					}
					else {
						emiPayDateVm.toDate = new Date(toCurDate.setDate(d + days + 1));
					}
				}
			}
			/*emiPayDateVm.toDate = new Date(curDate.setDate(d + nmDays - excess));*/

		}

		emiPayDateVm.checkDate = function () {
			if (emiPayDateVm.scheduleDate !== "" && (emiPayDateVm.account !== null)) {
				emiPayDateVm.disableNext = false;
			} else {
				emiPayDateVm.disableNext = true;
			}
		}

		emiPayDateVm.openDatePickerForIOS = function () {
			var minDateInPicker = new Date(emiPayDateVm.fromDate.getFullYear(), emiPayDateVm.fromDate.getMonth(), emiPayDateVm.fromDate.getDate());
			var maxDateInPicker = new Date(emiPayDateVm.toDate.getFullYear(), emiPayDateVm.toDate.getMonth(), emiPayDateVm.toDate.getDate());
            $scope.dateOptions = {
                maxDate: maxDateInPicker,
                minDate: minDateInPicker,
                formatYear: 'yy',
                startingDay: 1
            }
			
            var datePickerPopup = $ionicPopup.alert({
                cssClass: 'rtxc-datepicker-popup',
                template: '<div class="datePickerBlock font-size-14">' +
                    '<input type="text" datepicker="dd MMM yyyy" ng-model="dateobj.dt" max-date="dateOptions.maxDate" min-date="dateOptions.minDate" format-day-title="dd MMM yyyy" is-open="true" show-weeks="false"/>' +
                    '</div>',
                scope: $scope,
                buttons: [ {
                    text: 'OK',
                    type: 'button-positive',
                    onTap: function (res) {
						console.log(res);
                        emiPayDateVm.repayDateError = '';
                        var repayStartDate = $filter('date')($scope.dateobj.dt, "dd MMM yyyy");
                        emiPayDateVm.scheduleDate = repayStartDate.toUpperCase();
                    }
                },{
                    text: 'Cancel',
                    type: 'button-negative',
                    onTap: function (res) {
                        datePickerPopup.close();
                    }
                }],
            });
        }




		emiPayDateVm.openDatePicker = function () {
			ionicDatePicker.openDatePicker(emiPayDateVm.dateObj);
		};

		emiPayDateVm.goToReview = function () {
			personalLoanService.emiDate = new Date(emiPayDateVm.scheduleDate);
			$state.go('menu.reviewLoan');
		};

		emiPayDateVm.goToNext = function () {
			utilityService.showSpinner();
			personalLoanService.emiDate = new Date(emiPayDateVm.scheduleDate);
			var newDate = personalLoanService.emiDate;
			var monthName = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
			personalLoanService.emiDate = "" + newDate.getDate() + " " + monthName[newDate.getMonth()] + " " + newDate.getFullYear();

			var reqData = {
				"productCode": personalLoanService.product,
				"rateofInterest": personalLoanService.interestRate,
				"emi": personalLoanService.emiAmount,
				"date": personalLoanService.emiDate,
				"repaymentPeriod": personalLoanService.duration,
				"commoncementDate": personalLoanService.emiDate,
				"loanAmount": personalLoanService.loanAmount
			}

			personalLoanService.requestPalTerm(reqData).then(function (data) {
				personalLoanService.ConditionsJson = $sce.trustAsHtml(data.data);
				personalLoanService.pdfContent = data.pdfContent;
				utilityService.hideSpinner();
				$state.go('menu.plTerms');
			}, function (error) {
				utilityService.hideSpinner();
				utilityService.showErrorMessage(error.responseMessage);
			});
		};

		$scope.goToHome = function () {
			$state.go('menu.homeScreen');
		}

		$scope.$on('$ionicView.beforeEnter', function () {
			emiPayDateVm.moduleName = "PreApprovedLoan";
			emiPayDateVm.actionName = "createLoanAdditionalProducts";
			fixedDepositService.fetchNightModeStatus(emiPayDateVm, true).then(function (data) {
				emiPayDateVm.nightMode = data.nightMode === "Y" ? true : false;
				emiPayDateVm.account = personalLoanService.accountNumber;
				emiPayDateVm.eyesOffFun(emiPayDateVm.account);
				emiPayDateVm.scheduleDate = "";
				emiPayDateVm.calculateDate();
				emiPayDateVm.dateObj = {
					callback: function (val) {
						emiPayDateVm.scheduleDate = new Date(val);
						emiPayDateVm.checkDate();
					},
					inputDate: new Date(emiPayDateVm.fromDate.getFullYear(), emiPayDateVm.fromDate.getMonth(), emiPayDateVm.fromDate.getDate()),
					from: new Date(emiPayDateVm.fromDate.getFullYear(), emiPayDateVm.fromDate.getMonth(), emiPayDateVm.fromDate.getDate()),
					to: new Date(emiPayDateVm.toDate.getFullYear(), emiPayDateVm.toDate.getMonth(), emiPayDateVm.toDate.getDate()),
					mondayFirst: true,
					closeOnSelect: false,
					templateType: 'popup',
					dateFormat: 'dd MMMM yyyy'
				};
				
				if(personalLoanService.categoryType == 'KAVACH'){
					emiPayDateVm.dateObj.monthsList = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];
				}
				if (!utilityService.isUndefined(personalLoanService.emiDate)){
					emiPayDateVm.scheduleDate = new Date(personalLoanService.emiDate);
				}else{
					emiPayDateVm.scheduleDate = new Date(emiPayDateVm.fromDate.getFullYear(), emiPayDateVm.fromDate.getMonth(), emiPayDateVm.fromDate.getDate()) ;
				}
				if(utilityService.isAndroidPlatform()){
					emiPayDateVm.isAndroidDevice = true ;
				}else{
					emiPayDateVm.isAndroidDevice = false ;
				}
					$scope.dateobj.dt = new Date(emiPayDateVm.fromDate.getFullYear(), emiPayDateVm.fromDate.getMonth(), emiPayDateVm.fromDate.getDate()) ;
					
				emiPayDateVm.checkDate();
			}, function (error) {
				utilityService.showErrorMessage(error.responseMessage);
			});
		});

		emiPayDateVm.eyesOnFun = function (accNo) {
			emiPayDateVm.isAccountMasked = false;
			emiPayDateVm.account = emiPayDateVm.oldValue;
		}

		emiPayDateVm.eyesOffFun = function (accNo) {
			emiPayDateVm.isAccountMasked = true;
			emiPayDateVm.oldValue = accNo;
			emiPayDateVm.account = utilityService.maskData(accNo, "front", 4);
		}

		return this;

	}]);

