'use strict';

angularApp.controller('kawachDeclarationController', [
    "$state",
    "$scope",
    "$rootScope",
    "utilityService",
    "$ionicPopup",
    "personalLoanService",
    "getAccountDetailsService",
    "$ionicHistory",
    "clickStreamService",
    "homeScreenService",
    function ($state,
        $scope,
        $rootScope,
        utilityService,
        $ionicPopup,
        personalLoanService,
        getAccountDetailsService,
        $ionicHistory,
        clickStreamService,
        homeScreenService) {

        var paplKawachDeclarationVm = this;

        paplKawachDeclarationVm.init = function () {
            paplKawachDeclarationVm.authorizeCheck = false ;
            paplKawachDeclarationVm.kavachDeclarationText= personalLoanService.kavachDeclarationText
        }
        paplKawachDeclarationVm.goToNext = function(){
            if(! paplKawachDeclarationVm.authorizeCheck){
                paplKawachDeclarationVm.errorCheck = true ;
            }else{
                paplKawachDeclarationVm.errorCheck = false ;
                $state.go('menu.personalLoan');
            }
        }
            
        // paplKawachDeclarationVm.goToBack = function () {
        //     $ionicHistory.goBack(-1);
        // };
        $scope.goToHome = function () {
            $state.go('menu.homeScreen');
        }
        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function () {
            paplKawachDeclarationVm.init()
        });

        $scope.$on('$ionicView.loaded', function () {
        });

        return this;
    }
]);
