 'use strict';

angularApp.controller('reviewLoanController', [
    "$state",
    "$scope",
    "personalLoanService",
    "getAccountDetailsService", "utilityService", "$sce", "$rootScope",

    function ($state,
        $scope,
        personalLoanService, getAccountDetailsService, utilityService, $sce, $rootScope) {

        var reviewLoanVm = this;
        reviewLoanVm.isCOVIDPAPL = false;
        $scope.isKavach = false ;

        $rootScope.currentPage = 4;
        reviewLoanVm.isAccountMasked = false;

        reviewLoanVm.goBack = function () {
            $state.go('menu.plTerms');
        };

        reviewLoanVm.goBackBo = function () {
            $ionicGoBack();
        };

        $scope.goToHome = function () {
            $state.go('menu.homeScreen');
        }

        reviewLoanVm.goToNext = function () {
            $state.go('menu.plOTP');
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            reviewLoanVm.loanAmount = personalLoanService.loanAmount;
            reviewLoanVm.duration = personalLoanService.duration;
            reviewLoanVm.emiDate = personalLoanService.emiDate;
            reviewLoanVm.emiAmount = personalLoanService.emiAmount;
            reviewLoanVm.accountNumber = personalLoanService.accountNumber;
            reviewLoanVm.eyesOffFun(reviewLoanVm.accountNumber);
            reviewLoanVm.interest = personalLoanService.interest;
            reviewLoanVm.currency = getAccountDetailsService.currency;
           
            if(personalLoanService.product && personalLoanService.product === "64514034"){
                reviewLoanVm.isCOVIDPAPL = true;
                reviewLoanVm.configValues = personalLoanService.setConfigValues(personalLoanService.configDetails,reviewLoanVm.loanAmount);
                reviewLoanVm.processFee = reviewLoanVm.configValues.processingFee;
            } else if (personalLoanService.categoryType == "KAVACH" ){
                $scope.isKavach = true;
                if(parseInt(personalLoanService.processingFee) <= 0){
                    reviewLoanVm.processFee = 'NIL';
                }else{
                    reviewLoanVm.processFee = personalLoanService.processingFee;
                }
        }
            else{
                reviewLoanVm.isCOVIDPAPL = false;
                reviewLoanVm.processFee = personalLoanService.processingFee ? personalLoanService.processingFee : "NIL";
            }
        });

        reviewLoanVm.eyesOnFun = function(accNo){
            reviewLoanVm.isAccountMasked = false;
            reviewLoanVm.accountNumber = reviewLoanVm.oldValue;
        }

        reviewLoanVm.eyesOffFun = function(accNo){
            reviewLoanVm.isAccountMasked = true;
            reviewLoanVm.oldValue = accNo;
            reviewLoanVm.accountNumber = utilityService.maskData(accNo, "front", 4);
        }

        return this;

    }]);
