angularApp.service('mPinLoginService',
	function ($q, utilityService, AdapterUtils, loggedInUserService) {
		var mPinLoginService = this;
		mPinLoginService.isLoggedIn = false;
		mPinLoginService.isSetMPIN = false;
		loggedInUserService.isLoggedInDetails = mPinLoginService;
		
		mPinLoginService.userLoginStatus = {
			isLoggedIn: false,
			isRegistered: false
		};

		mPinLoginService.create = function (mobileNuber, mPin) {
			var q = $q.defer();
			var payload = {};
			payload.mobileNumber = mobileNuber;
			payload.mPin = mPin;
			AdapterUtils.postData("adapters/MPinAdapter/mPin/create", payload, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		mPinLoginService.update = function (mobileNuber, mPin) {
			var q = $q.defer();
			var payload = {};
			AdapterUtils.postData("adapters/MPinAdapter/mPin/create", payload, false).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		return mPinLoginService;
	});