'use strict';

angularApp.controller('privacyPolicyController', ["$state",
    "$scope",
	"termsPolicyService",
  "utilityService",

    function($state,
        $scope,
		termsPolicyService,utilityService
        ) {

        var privacyPolicyVm = this;

        function initPage() {

            privacyPolicyVm.loadProductFeatures();
        }

        privacyPolicyVm.loadProductFeatures = function() {
			
            termsPolicyService.getTnCData('Privacy').then(function(data) {
                privacyPolicyVm.featuresJson = data;
            }, function(error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
	

        }

        privacyPolicyVm.goBacktoPrevious = function() {
			privacyPolicyVm.featuresJson="";
            $state.go('menu.userLogin');
        }



        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        return this;
    }
]);
