'use strict';

angularApp.controller('haveInternetBankingController',
	["$timeout", "$state", "$scope", "$translate", "$ionicSideMenuDelegate", "ionicToast", "$ionicPopup", "$ionicScrollDelegate","needHelpService","utilityService","loggedInUserService","regProcessWithAccNoService",
		function ($timeout, $state, $scope, $translate, $ionicSideMenuDelegate, ionicToast, $ionicPopup, $ionicScrollDelegate,needHelpService,utilityService,loggedInUserService,regProcessWithAccNoService) {

			var haveInternetBankingControllerVm = this;
			//show visit branch pop up
			haveInternetBankingControllerVm.goToLoginOption = function () {
				$translate('VISIT_BRANCH_REG_PAGE').then(function (translatedvalue) {
					var kycSuccessPop = $ionicPopup.show({
						template: '<p>' + translatedvalue + '</p>',
						title: '',
						cssClass: 'dialog',
						scope: $scope,
						buttons: [{
							text: 'OK',
							type: 'button-positive'
						}]
					});
				});
			}
			//go to gerister to YONO page
			haveInternetBankingControllerVm.registerWithYONO = function () {
				regProcessWithAccNoService.registerWithATM = 'Y';
				$state.go("menu.regAccountDetails");
				// var kycSuccessPop = $ionicPopup.show({
				// 	template: '<p>Keep your bank details, ATM card and registered mobile number with you !</p>',
				// 	title: '',
				// 	cssClass: 'dialog',
				// 	scope: $scope,
				// 	buttons: [{
				// 		text: 'OK',
				// 		type: 'button-positive',
				// 		onTap: function (e) {
				// 			$state.go('menu.cifDetails');
				// 			//$state.go('menu.accountDetailsPage');
				// 		}
				// 	}]
				// });
			};
			
			haveInternetBankingControllerVm.openNeedHelp = function(){
  
					if(!needHelpService.knowMoreContent){
					 utilityService.showSpinner();
					needHelpService.getknowMoreContent().then(function(data) {
					  utilityService.hideSpinner();
					  needHelpService.knowMoreContent = data.contentMessage;
					  $state.go('menu.needHelp');
					 }, function(error) {
					  utilityService.hideSpinner();
					  utilityService.showErrorMessage(error.responseMessage);
					 });
					}else{
					 $state.go('menu.needHelp');
					}
			}
			//one time initialization to be done when the controller is loaded
			$scope.$on('$ionicView.loaded', function () {
				$ionicSideMenuDelegate.canDragContent(false)
			});

			//actions to done everytime the view is shown
			$scope.$on('$ionicView.beforeEnter', function () {
				$ionicSideMenuDelegate.canDragContent(false);
				$ionicSideMenuDelegate.canDragContent(false);
				$ionicScrollDelegate.$getByHandle("formularContent").freezeAllScrolls(true);
				$ionicScrollDelegate.$getByHandle("formularContent").freezeScroll(true);
				$ionicScrollDelegate.freezeAllScrolls(true);
				$ionicScrollDelegate.$getByHandle("formularContent").getScrollView().options.scrollingY = false;
			});

			//any cleanup needs to be done here: executes everytime when page is left
			$scope.$on('$ionicView.afterLeave', function () {
				$ionicSideMenuDelegate.canDragContent(false);

			});

			//Go to Registration Account Number 
			haveInternetBankingControllerVm.gotoRegisterWithAccNo = function(){
				regProcessWithAccNoService.registerWithATM = '';
				regProcessWithAccNoService.isStepDisplay = true;
				regProcessWithAccNoService.isActivationCodeBtnClicked = false;
				$state.go("menu.regProcessMenu");
			}


		}]);
