'use strict';

angularApp.controller('openNewDigitalAccountController', ["$timeout", "$state", "$scope", "$translate", "$ionicPopup","$ionicSideMenuDelegate","$ionicScrollDelegate","needHelpService","utilityService",
						function ($timeout, $state, $scope, $translate, $ionicPopup, $ionicSideMenuDelegate,$ionicScrollDelegate,needHelpService,utilityService ) {
							
	var openNewDigitalAccountVm = this;
	//Go to internet banking page
	openNewDigitalAccountVm.openPopUp =function(){
		$state.go('menu.haveInternetBanking');
		// $translate('VISIT_BRANCH_REG_PAGE').then(function (translatedvalue) {
		// 			var kycSuccessPop = $ionicPopup.show({
		// 				template: '<p>' + translatedvalue + '</p>',
		// 				title: '',
		// 				cssClass: 'dialog',
		// 				scope: $scope,
		// 				buttons: [{
		// 					text: 'OK',
		// 					type: 'button-positive'
		// 				}]
		// 			});
		// 		});
	} 
	//Go to internet banking page
	openNewDigitalAccountVm.goToINBLogin = function() {
		$state.go('menu.inbLogin',{previousPage : "openNewDigitalAccountPage"});
	}
	//Go back to pre home Login page 
	openNewDigitalAccountVm.goToBack = function(){
		$state.go('menu.landingWithOptions');
	}
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	openNewDigitalAccountVm.needHelp= function(){
		if(!needHelpService.knowMoreContent){
			utilityService.showSpinner();
		needHelpService.getknowMoreContent().then(function(data) {
				utilityService.hideSpinner();
				needHelpService.knowMoreContent = data.contentMessage;
				needHelpService.isInternetBankLoaded = true;
				$state.go('menu.needHelp');
			}, function(error) {
				utilityService.hideSpinner();
				utilityService.showErrorMessage(error.responseMessage);
			});
		}else{
			needHelpService.isInternetBankLoaded = true;
			$state.go('menu.needHelp');
		}
	}
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false);
			$ionicScrollDelegate.$getByHandle("formularContent").freezeAllScrolls(true);
		$ionicScrollDelegate.$getByHandle("formularContent").freezeScroll(true);
		$ionicScrollDelegate.freezeAllScrolls(true);
		$ionicScrollDelegate.$getByHandle("formularContent").getScrollView().options.scrollingY = false;
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
}]);
