'use strict';

angularApp.controller('userEligibilityController',
    ["$state",
    "$scope",
    "$filter",
    "regProcessWithAccNoService",
    "registerWithSimService",
    function (
        $state, 
        $scope,
        $filter,
        regProcessWithAccNoService,
        registerWithSimService) {
        var userEligibilityVm = this;
        userEligibilityVm.regFlag = registerWithSimService.userRegFlag;
        userEligibilityVm.regOptionList = [
            {
                regFlag: 'AVAILCF',
                regImg: 'img/register/regWithSimA.svg',
                regTitle: $filter('translate')('UE_REG_OP_TITLE1'),
                regEnTitle: $filter('translate')('UE_REG_OP_ENTITLE1'),
                regDesc: $filter('translate')('UE_REG_OP_DESC1'),
            },
            {
                regFlag: 'ACTCODE',
                regImg: 'img/register/regWithSimB.svg',
                regTitle: $filter('translate')('UE_REG_OP_TITLE2'),
                regEnTitle: $filter('translate')('UE_REG_OP_ENTITLE2'),
                regDesc: $filter('translate')('UE_REG_OP_DESC2'),
            },
            {
                regFlag: 'EXTNOINB',
                regImg: 'img/register/regWithSimC.svg',
                regTitle: $filter('translate')('UE_REG_OP_TITLE3'),
                regEnTitle: $filter('translate')('UE_REG_OP_ENTITLE3'),
                regDesc: $filter('translate')('UE_REG_OP_DESC3'),
            }
        ];
        userEligibilityVm.proceedReg = function(type){
            registerWithSimService.MLTCFAcc = '';
            // Internet Banking
            if(type === 'AVAILCF'){
                $state.go('menu.inbLogin',{previousPage:""});
            }
            // Activation Code
            else if(type === 'ACTCODE'){
                regProcessWithAccNoService.isActivationCodeBtnClicked = true;
                $state.go("menu.regProcessMenu",{previousPage:""});
            }
            // Register with ATM or Account Details
            else if(type === 'EXTNOINB'){
                $state.go('menu.haveInternetBanking');
            }
        }
}]);
