'use strict';

angularApp.controller('regAccountDetailsController',
    ["$timeout", 
    "$state", 
    "$scope", 
    "$translate", 
    "$ionicSideMenuDelegate", 
    "ionicToast", 
    "$ionicPopup", 
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicHistory",
    "ionicDatePicker",
    "regProcessWithAccNoService",
    "$filter",
    "registerWithSimService",
    function (
        $timeout, 
        $state, 
        $scope, 
        $translate, 
        $ionicSideMenuDelegate, 
        ionicToast, 
        $ionicPopup, 
        $ionicScrollDelegate,
        utilityService,
        $ionicHistory,
        ionicDatePicker,
        regProcessWithAccNoService,
        $filter,
        registerWithSimService) {

        var regAccountDetailsControllerVm = this;

        regAccountDetailsControllerVm.hideCardInput = true;
        regAccountDetailsControllerVm.isInDisabled = false;
        regAccountDetailsControllerVm.accountNumber = "";
        regAccountDetailsControllerVm.prevAccountNumber = "";
        regAccountDetailsControllerVm.isBranchLocatorHide = true;
        regAccountDetailsControllerVm.isBranchDisabled = false;
        regAccountDetailsControllerVm.isEyeClose = true;
        regAccountDetailsControllerVm.minCharacters = false;
        regAccountDetailsControllerVm.branchNotFound = false;
        regAccountDetailsControllerVm.isNotValidAccNum = false;
        regAccountDetailsControllerVm.invalidReferralCode = false;
        var validRefCodePattern = /^[0][1-9]\d{9}$|^[1-9,6-9]\d{9}$/;
        regAccountDetailsControllerVm.isSubmitted = false;

        regAccountDetailsControllerVm.registerWithATM = regProcessWithAccNoService.registerWithATM;

        var d = new Date();
        regAccountDetailsControllerVm.fromDate = new Date(d.getFullYear() - 142,d.getMonth(),d.getDate());
        regAccountDetailsControllerVm.toDate = new Date(d.getFullYear() - 17,d.getMonth(),d.getDate());
        /*regAccountDetailsControllerVm.fromDate = new Date(d.getFullYear() - 125,d.getMonth(),d.getDate());
        regAccountDetailsControllerVm.toDate = new Date(d.getFullYear() - 18,d.getMonth(),d.getDate());*/


        regAccountDetailsControllerVm.close = function(){
            $state.go("menu.selectSim");
        }
        regAccountDetailsControllerVm.goBack = function(){
            $state.go("menu.selectSim");
        }

        // $scope.$watch('regAccountDetailsControllerVm.accountNumber',function(newValue,oldValue){
        //     regAccountDetailsControllerVm.prevAccountNumber = oldValue;
        // });

        regAccountDetailsControllerVm.accountNumberEnter = function(acNo,event){
            if(regAccountDetailsControllerVm.isEyeClose){
                regAccountDetailsControllerVm.hideCardInput = true;
            }else{
                regAccountDetailsControllerVm.hideCardInput = false;
            }
            regAccountDetailsControllerVm.isNotValidAccNum = true;
            
            if(regAccountDetailsControllerVm.accountNumber && regAccountDetailsControllerVm.accountNumber.length === 11 &&
            regAccountDetailsControllerVm.accountNumber != "00000000000"){
            	regAccountDetailsControllerVm.accNo = regAccountDetailsControllerVm.accountNumber;
                regAccountDetailsControllerVm.isNotValidAccNum = false;
                if(regAccountDetailsControllerVm.isEyeClose){
                    //document.getElementById("accNo").classList.add('reg_atm_disc');
                    regAccountDetailsControllerVm.accountNumber = acNo;//.replace(/[^0-9X]/g, '').replace(/\d{4}/g,"$& ").replace(/(^\s+|\s+$)/, '');//$filter('cardmask')(regAccountDetailsControllerVm.accountNumber,'X', '3', '', ' ');
                }
                if(regAccountDetailsControllerVm.dob){
                    regAccountDetailsControllerVm.getCustomerDetails();
                }
            }
        }

        regAccountDetailsControllerVm.validateFields = function(form){
            regAccountDetailsControllerVm.isSubmitted = true;
            if((regAccountDetailsControllerVm.accountNumber && !regAccountDetailsControllerVm.isNotValidAccNum) && regAccountDetailsControllerVm.dob && !regAccountDetailsControllerVm.invalidReferralCode){
                regAccountDetailsControllerVm.isSubmitted = false;
                regAccountDetailsControllerVm.accountDetailsValidate(form);
            }else{
                regAccountDetailsControllerVm.isSubmitted = true;
            }
        }

        regAccountDetailsControllerVm.accountDetailsValidate = function(accDetailsValidateForm){
            regAccountDetailsControllerVm.submitted = false;
            if(registerWithSimService.MLTCFAcc === 'Y') {
                registerWithSimService.MLTCFAcc = '';
                console.log("registerWithSimService.MLTCFAcc after killing",registerWithSimService.MLTCFAcc);
                $state.go('menu.userEligibility');
            }
            else {
                regProcessWithAccNoService.regReferralCode = regAccountDetailsControllerVm.inbReferralCode;
                var requestParams = {
                    "mobile":regProcessWithAccNoService.customerDetails.mobileNumber ? regProcessWithAccNoService.customerDetails.mobileNumber : "",
                    "email":regProcessWithAccNoService.customerDetails.email ? regProcessWithAccNoService.customerDetails.email : ""
                }
		regProcessWithAccNoService.sendOTP(requestParams).then(function (response) {
                    $state.go('menu.regOTP');
                }, function (error) {
                    $state.go('menu.regOTP');
                });
            }
        }

        regAccountDetailsControllerVm.currentDate = {
            callback: function (val) {
                var date = new Date(val);
                regAccountDetailsControllerVm.dob = date;
                regAccountDetailsControllerVm.disableEndDate = false;
                regAccountDetailsControllerVm.endDate = "to";
                regAccountDetailsControllerVm.selectedDate(date);
            },
            closeLabel: 'Close',
            dateFormat: 'dd MMM yyyy',
            monthsList: ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"],
            inputDate: new Date(),
            to: new Date(),
            mondayFirst: true,
            closeOnSelect: true,
            templateType: 'popup'
        }

        regAccountDetailsControllerVm.atmCurrentDate = {
            callback: function (val) {
                var date = new Date(val);
                regAccountDetailsControllerVm.dob = date;
                regAccountDetailsControllerVm.disableEndDate = false;
                regAccountDetailsControllerVm.endDate = "to";
                regAccountDetailsControllerVm.selectedDate(date);
            },
            closeLabel: 'Close',
            dateFormat: 'dd MMM yyyy',
            monthsList: ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"],
            inputDate: regAccountDetailsControllerVm.toDate,
            from: regAccountDetailsControllerVm.fromDate,
            to: regAccountDetailsControllerVm.toDate,
            mondayFirst: true,
            closeOnSelect: true,
            templateType: 'popup'
        }

        regAccountDetailsControllerVm.openCalender = function(){
            if(regAccountDetailsControllerVm.registerWithATM !== 'Y') {
                if (regAccountDetailsControllerVm.currentDate instanceof Date) {
                    regAccountDetailsControllerVm.currentDate = new Date(regAccountDetailsControllerVm.currentDate.getFullYear(), regAccountDetailsControllerVm.currentDate.getMonth(), regAccountDetailsControllerVm.currentDate.getDate());
                }

                ionicDatePicker.openDatePicker(regAccountDetailsControllerVm.currentDate);
            }
            else {
                if (regAccountDetailsControllerVm.atmCurrentDate instanceof Date) {
                    regAccountDetailsControllerVm.atmCurrentDate = new Date(regAccountDetailsControllerVm.atmCurrentDate.getFullYear(), regAccountDetailsControllerVm.atmCurrentDate.getMonth(), regAccountDetailsControllerVm.atmCurrentDate.getDate());
                }

                ionicDatePicker.openDatePicker(regAccountDetailsControllerVm.atmCurrentDate);
            }
        }

        regAccountDetailsControllerVm.selectedDate = function(selectedDate){
            regAccountDetailsControllerVm.dateSelection = selectedDate;
            regAccountDetailsControllerVm.dob = $filter('date')(selectedDate,'dd MMM yyyy');
            if(regAccountDetailsControllerVm.accountNumber && regAccountDetailsControllerVm.accountNumber.length === 11){
                regAccountDetailsControllerVm.getCustomerDetails();
            }else{
                regAccountDetailsControllerVm.isNotValidAccNum = true;
            }
        };

        regAccountDetailsControllerVm.getCustomerDetails = function(){
            document.getElementById("accNo").blur();//Throw out focus from input
            regAccountDetailsControllerVm.isNotValidAccNum = false;
            var date = $filter('date')(regAccountDetailsControllerVm.dateSelection,"ddMMyyyy");
            if(registerWithSimService.MLTCFAcc === 'Y') {
                var reqParams = {
                    accountNumber: regAccountDetailsControllerVm.validateenterAccNo(regAccountDetailsControllerVm.accountNumber).replace(/\s/g, ""),
                    dob: date
                };
                registerWithSimService.getAccountByMultipleCIF(reqParams).then(function (response) {
                    if(!response || response.type === null || response.type === "") {
                            $state.go("menu.selectSim");
                    }
                    else{
                        registerWithSimService.userRegFlag = response.type;
                    }
                }, function (error) {
                    regAccountDetailsControllerVm.accountNumber = "";
                    regAccountDetailsControllerVm.dob = "";
                    utilityService.showErrorMessage(error.responseMessage);
                });
            }
            else {
                var requestParams = {
                    "cif": regAccountDetailsControllerVm.validateenterAccNo(regAccountDetailsControllerVm.accountNumber).replace(/\s/g, ""),
                    "dob": date
                }

                regProcessWithAccNoService.getCustomerDetails(requestParams).then(function (response) {
                    regProcessWithAccNoService.customerDetails = response;
                    if (response.inbFacility === "YES") {
                        utilityService.showErrorMessage("You already have an internet banking User id. Please try registering using the same.");
                    } else {
                        //Select homebranch details
                        if (regAccountDetailsControllerVm.registerWithATM != 'Y')
                            regAccountDetailsControllerVm.branchDetails();
                    }
                }, function (error) {
                    regAccountDetailsControllerVm.accountNumber = "";
                    regAccountDetailsControllerVm.dob = "";
                    if (error.responseCode == "LTIIB5153" || error.responseCode == "LTIIB5154" || error.responseCode == "LTIIB5158" || error.responseCode == "LTIIB5157" || error.responseCode == "LTIIB5155") {
                        var message = error.responseMessage;
                        $ionicPopup.alert({
                            title: "",
                            template: '<div class="popup-padding font-dark-grey"><div><center><img class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="popUp-msg-color">'
                                + message + '</span></div></div></div>',
                            cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                        }).then(function (res) {
                            $state.go("menu.selectSim");
                        });
                    } else {
                        utilityService.showErrorMessage(error.responseMessage);
                    }
                });
            }
        }
        regAccountDetailsControllerVm.branchDetails = function(){
            var requestParams = {
                "branchCode":regProcessWithAccNoService.customerDetails.branchCode
            };
            regProcessWithAccNoService.getBranchDetails(requestParams).then(function (response) {
                regAccountDetailsControllerVm.isBranchLocatorHide = false;
                regAccountDetailsControllerVm.selectedBranch(response);
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }

        regAccountDetailsControllerVm.getBranchList = function($event){
        	//loic added for delete char do nothing
        	if(regAccountDetailsControllerVm.branch){
        		if(regAccountDetailsControllerVm.lastWordLength >= regAccountDetailsControllerVm.branch.length ){
                    regAccountDetailsControllerVm.lastWordLength = regAccountDetailsControllerVm.branch.length;
                    if(regAccountDetailsControllerVm.branch.length <= 3)
                        regAccountDetailsControllerVm.minCharacters = true;
        			return true;
        		}
                regAccountDetailsControllerVm.lastWordLength = regAccountDetailsControllerVm.branch.length;
                
        	}
        	//loic added for delete char do nothing Endssssssssss
                regAccountDetailsControllerVm.branchNotFound = false;
                if(regAccountDetailsControllerVm.branch && regAccountDetailsControllerVm.branch.length >= 4){
                    cordova.plugins.Keyboard.close();
                    regAccountDetailsControllerVm.minCharacters = false;
                    regAccountDetailsControllerVm.isBranchDisabled = true;
                    regAccountDetailsControllerVm.searchBranch = regAccountDetailsControllerVm.branch;
                    var requestParams = {
                        "locality":regAccountDetailsControllerVm.branch,
                    }
                    regProcessWithAccNoService.getBranchMasterData(requestParams).then(function (response) {
                        regAccountDetailsControllerVm.isBranchDisabled = false;
                        if(response && response.branches.length > 0){
                            regAccountDetailsControllerVm.branhList = response.branches;
                                regAccountDetailsControllerVm.myPopup ? regAccountDetailsControllerVm.myPopup.close() : '';
                                regAccountDetailsControllerVm.myPopup =  $ionicPopup.show({
                                    templateUrl: 'pages/preHomeLogin/registrationWithAccount/branchLocatorPopup.html',
                                    title: '',
                                    cssClass: 'dialog popupWidth90 reg-acc-popup',
                                    scope: $scope,
                            });
                        }else{
                            regAccountDetailsControllerVm.branchNotFound = true;
                        }
                    }, function (error) {
                        regAccountDetailsControllerVm.isBranchDisabled = false;
                        utilityService.showErrorMessage(error.responseMessage);
                    });
                }else{
                    regAccountDetailsControllerVm.minCharacters = true;
                }
            //}
        }

        regAccountDetailsControllerVm.selectedBranch = function(item){
            regProcessWithAccNoService.selectedBranchDetails = item;
            regAccountDetailsControllerVm.branch = item.branchName;
            regAccountDetailsControllerVm.myPopup ? regAccountDetailsControllerVm.myPopup.close() : "";
            regAccountDetailsControllerVm.lastWordLength = regAccountDetailsControllerVm.branch.length;
        }

        window.addEventListener("native.keyboardshow",function(){
            document.body.classList.add("keyboard-open");
        });

        regAccountDetailsControllerVm.offeyeClick = function(){
            regAccountDetailsControllerVm.hideCardInput = false;
            regAccountDetailsControllerVm.isEyeClose = false;
            regAccountDetailsControllerVm.accountNumber = regAccountDetailsControllerVm.accountNumber;//.replace(/[^0-9X]/g, '').replace(/\d{4}/g,"$& ").replace(/(^\s+|\s+$)/, '');
        }
        regAccountDetailsControllerVm.oneyeClick = function(){
            regAccountDetailsControllerVm.hideCardInput = true;
            regAccountDetailsControllerVm.isEyeClose = true;
            //if(regAccountDetailsControllerVm.accountNumber.length === 11){
            regAccountDetailsControllerVm.accountNumber = regAccountDetailsControllerVm.accountNumber;//.replace(/[^0-9X]/g, '').replace(/\d{4}/g,"$& ").replace(/(^\s+|\s+$)/, '');//$filter('cardmask')(regAccountDetailsControllerVm.accountNumber,'X', '3', '', ' ');
            //}
        }
        
        regAccountDetailsControllerVm.validateenterAccNo = function(prev){
           var num = prev;
           if(num.length != 11 || num.indexOf("X") != -1){
           	  num = regAccountDetailsControllerVm.accNo;
           }
           return num;
        }
        regAccountDetailsControllerVm.refCodeChanged = function(){
            if(regAccountDetailsControllerVm.inbReferralCode && (regAccountDetailsControllerVm.inbReferralCode.length < 10 || regAccountDetailsControllerVm.inbReferralCode.length > 0) && !validRefCodePattern.test(regAccountDetailsControllerVm.inbReferralCode)){
                regAccountDetailsControllerVm.invalidReferralCode = true;
            }
            else{
                regAccountDetailsControllerVm.invalidReferralCode = false;
            }
        }
        
}]);
