'use strict';

angularApp.controller('regReviewUserDetailsController',
    ["$timeout", 
    "$state", 
    "$scope", 
    "$translate", 
    "$ionicSideMenuDelegate", 
    "ionicToast", 
    "$ionicPopup", 
    "$ionicScrollDelegate",
    "utilityService",
    "$ionicHistory",
    "ionicDatePicker",
    "regProcessWithAccNoService",
    function (
        $timeout, 
        $state, 
        $scope, 
        $translate, 
        $ionicSideMenuDelegate, 
        ionicToast, 
        $ionicPopup, 
        $ionicScrollDelegate,
        utilityService,
        $ionicHistory,
        ionicDatePicker,
        regProcessWithAccNoService) {

        var regReviewUserDetailsControllerVm = this;
        regReviewUserDetailsControllerVm.customerDetails = regProcessWithAccNoService.customerDetails;
        regReviewUserDetailsControllerVm.cifNumber = regProcessWithAccNoService.registerWithATM == 'Y' ? regProcessWithAccNoService.customerDetails.cifNumber : regProcessWithAccNoService.customerDetails.cifNumber.substring(6);
        regReviewUserDetailsControllerVm.isTransactionRightNotSelected = false;

        regReviewUserDetailsControllerVm.close = function(){
            $state.go("menu.selectSim");
        }
        regReviewUserDetailsControllerVm.goBack = function(){
            $ionicHistory.goBack(); 
        }

        $scope.$watch('regReviewUserDetailsControllerVm.transType',function(newValue,oldValue){
            regReviewUserDetailsControllerVm.isTransactionRightNotSelected = false;
        });

        regReviewUserDetailsControllerVm.next = function(){
            regReviewUserDetailsControllerVm.submitted = true;
            if(regReviewUserDetailsControllerVm.transType){
                regReviewUserDetailsControllerVm.isTransactionRightNotSelected = false;
                regProcessWithAccNoService.transactionDetails = {
                    transType : regReviewUserDetailsControllerVm.transType
                };
                if(regProcessWithAccNoService.registerWithATM === 'Y')
                    $state.go('menu.atmCardNumber');
                else
                    $state.go("menu.setInternetBankingDetails");
            }else{
                regReviewUserDetailsControllerVm.isTransactionRightNotSelected = true;
            }
        }

        regReviewUserDetailsControllerVm.notyouClicked = function(){
            var confirmPopup = $ionicPopup.show({
                title: "Don't find your name?",
                template: "<div>Only primary account holder is eligible.</div>",
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn reg_notyou_popup',
                scope: $scope,
                buttons: [
                    {
                        text: 'OK',
                        onTap: function (e) {
                            $state.go("menu.selectSim");
                        }
                    }
                ]
            });
        }
        
}]);
