'use strict';
angularApp.controller('quickPayTransactionsController', [
    "$state",
    "$scope",
    "utilityService",
    "customerInfoService", "$filter", "quickPayService",
    function ($state, $scope, utilityService, customerInfoService, $filter, quickPayService) {

        var quickPayTransactionsVm = this;

        function initPage() {


        }
        quickPayTransactionsVm.goToQuickPayLanding = function(){
            $state.go('menu.quickPayLanding');
        }
        quickPayTransactionsVm.payFromTransList = function(transaction){
            quickPayService.payFromTransList = true;
            quickPayService.payFromTransListData = transaction;
            $state.go('menu.quickPayLanding');
        }
        quickPayTransactionsVm.goToTransaction = function () {
            var params = { "methodName": "getTransactionList" };
            quickPayService.addTofavorite(params).then(function (data) {
                quickPayService.transactionLists = data.beneficiaryList;
                quickPayTransactionsVm.transactionLists = quickPayService.transactionLists;
            }, function (error) {
                utilityService.showErrorMessage(error.responseMessage);
            });
        }
        $scope.$on('$ionicView.beforeEnter', function () {
            initPage();
            quickPayService.payFromTransListData = [];
            if (quickPayService.transactionLists.length > 0) {
                quickPayTransactionsVm.transactionLists = quickPayService.transactionLists;
            }
            else {
                quickPayTransactionsVm.goToTransaction();

            }
        });

        return this;
    }


]);


