'use strict';
angularApp.controller('viewBalanceSetUpController', [
		"$state",
		"$scope",
		"$translate",
		"$ionicHistory",
		"utilityService",
      "loggedInUserService",
      "cryptoService",
      "mPinLoginService",
      "quickPayService",
      "$ionicSlideBoxDelegate",
      "internetBankingService",
      "$ionicPopover",
      "$rootScope",
      "encryptionService",
      "AdapterUtils",
      "ConnectivityMonitorUtils",
      "constantConfig",
	  "mpassbookdetailsService",
    "clickStreamService",
    "registerWithSimService",
		function($state, 
         $scope,
          $translate, 
          $ionicHistory, 
          utilityService, 
          loggedInUserService, 
          cryptoService, 
          mPinLoginService, 
          quickPayService,
          $ionicSlideBoxDelegate,
          internetBankingService,
          $ionicPopover,
          $rootScope,
          encryptionService,
      AdapterUtils,
      ConnectivityMonitorUtils,
      constantConfig,
	  mpassbookdetailsService,
    clickStreamService,
    registerWithSimService
    ) {
			
			var viewBalanceSetUpVm = this;
			viewBalanceSetUpVm.keystoreValue = loggedInUserService.keystoreValue;
      viewBalanceSetUpVm.authFlag = "";
      viewBalanceSetUpVm.mpinErrorMsg = "";
      viewBalanceSetUpVm.mpinErrorMsgFlag = false;
			function initPage() {
            $translate(['BIOMETRIC_DISC','IGNORE','SET_UP','YQP_USERNAME', 'YQP_PASSWORD']).then(function (translations) {
               viewBalanceSetUpVm.BIOMETRIC_DISC = translations['BIOMETRIC_DISC'];
               viewBalanceSetUpVm.ignore_txt = translations['IGNORE'];
               viewBalanceSetUpVm.setup_up_txt = translations['SET_UP'];
               viewBalanceSetUpVm.usernameTxt = translations['YQP_USERNAME'];
                viewBalanceSetUpVm.passwordTxt = translations['YQP_PASSWORD'];
            });

            viewBalanceSetUpVm.isBiometricSet = localStorage.getItem("isBiometricSet");
            if(viewBalanceSetUpVm.isBiometricSet == undefined || viewBalanceSetUpVm.isBiometricSet == "false"){
        viewBalanceSetUpVm.isBiometricSet = false;
      }
      else{
        viewBalanceSetUpVm.isBiometricSet = true;
      }
      viewBalanceSetUpVm.toggle = {'checked':false};
      viewBalanceSetUpVm.isFingerprintAvl = quickPayService.isFingerprintAviFlag;
      viewBalanceSetUpVm.isMpinSet = loggedInUserService.mpinConsent;
				  if(!viewBalanceSetUpVm.isMpinSet){
            viewBalanceSetUpVm.toggle = {'checked':true};
          }
			};

         $scope.slideHasChanged = function(index){
          $scope.currentSlide = index;
		  //mpassbook related functionality added by GOC, Hyderabad
			mpassbookdetailsService.selectedACNo =viewBalanceSetUpVm.accountLists[index].accountNumber;
			mpassbookdetailsService.branchCode =viewBalanceSetUpVm.accountLists[index].branchCode;
		  //mpassbookdetailsService.goBackToState = "menu.viewBalanceSetUp";
		  // end of mpassbook functionality
         }
		 
		//mpassbook related functionality added by GOC, Hyderabad
		viewBalanceSetUpVm.goMpassbook = function (index) {
			mpassbookdetailsService.goBackToState = "menu.viewBalanceSetUp";
			$state.go('menu.mpassbookdetails');
		}
		// end of mpassbook functionality

		 
         $scope.pagerClick = function(index){
          $ionicSlideBoxDelegate.slide(index);
          $scope.$apply();
         }

         $scope.goNext = function(index){
          $ionicSlideBoxDelegate.next();
         }

         $scope.goPrev = function(index){
          $ionicSlideBoxDelegate.previous();
         }

			viewBalanceSetUpVm.goToUserLogin = function(){
				$state.go('menu.userLogin');
			}
      viewBalanceSetUpVm.goToUserLanding = function(){
        $state.go('menu.userLanding',{showViewBalance:true});
      }
			viewBalanceSetUpVm.skip = function(){
              $state.go('menu.userLanding',{showViewBalance:true});
           
         }
         viewBalanceSetUpVm.setBiometric = function(){
          $ionicHistory.clearCache().then(function(){
            $state.go('menu.quickPayBiometricSetUp',{goBackToState:1});
          });
          
          
         }

    

   function saveToken(){
      var random_str = utilityService.getRandomNumber(10);
      var fingerprint_token = cryptoService.encryptRSAWithPublicKey(random_str, cryptoService.rsaPublicKey);
      
      var obj = {'bioauthid':fingerprint_token};
      quickPayService.saveBiometricToken(obj).then(function(data) {
         localStorage.setItem("isBiometricSet", true);
         viewBalanceSetUpVm.isBiometricSet = true;
         cordova.plugins.SecureKeyStore.set(function (res) {
                       }, function (error) {
                        
                       }, loggedInUserService.deviceInfo, random_str);             
      },function(error){
         utilityService.showErrorMessage(error.responseMessage);
      });

   };

   viewBalanceSetUpVm.userAuthPopoverTemplate = quickPayService.userAuthPopoverTemplate("","viewBalanceSetUpVm");
         $scope.popover = $ionicPopover.fromTemplate(viewBalanceSetUpVm.userAuthPopoverTemplate,{
          scope:$scope
         });
         
         
         $scope.openPopover = function($event){
          $scope.popover.show($event);
         };

    

    $scope.closePopover = function ($event) {
      $scope.popover.hide();
    };

    $scope.$on('popover.hidden', function () {
      //execute action
    });


    $scope.$on('popover.removed', function () {
      //execute action
    });
    

    $scope.$on('$destroy', function () {
      $scope.popover.remove();
    });
   
  

         viewBalanceSetUpVm.editPrimaryAccount = function(){
            viewBalanceSetUpVm.isPrimarySet = false;
         }
         viewBalanceSetUpVm.setPrimary = function(){
            var obj = {"accountNumber":viewBalanceSetUpVm.sel_primary_account};
            quickPayService.setPrimary(obj).then(function(data) {
                        viewBalanceSetUpVm.isPrimarySet = true;
                        var message = 'You have changed your primary account from ' + viewBalanceSetUpVm.primary_account + ' to ' + viewBalanceSetUpVm.sel_primary_account;
                        
                        viewBalanceSetUpVm.customerInfo.customerInformation.accountNumber = viewBalanceSetUpVm.sel_primary_account;
                        viewBalanceSetUpVm.primary_account = viewBalanceSetUpVm.customerInfo.customerInformation.accountNumber;
                        
                        var ok_btn = "OK";
                        var onTapgo = '';
                        var onTapCancel = '';
                        quickPayService.showAlertPopup("success", message, onTapgo, onTapCancel, ok_btn, "", $scope);

                     
                     
                     },function(error){
                        utilityService.showErrorMessage(error.responseMessage);
                     });
         }

         viewBalanceSetUpVm.setMpin = function(){
            mPinLoginService.isSetMPIN = true;
            $state.go('menu.inbLogin', { previousPage: "UserLoginPage" });
         }
        viewBalanceSetUpVm.setup = function($event){
          //viewBalanceSetUpVm.isSetupClicked = true;
          
          $scope.openPopover($event);
          //dynamically adding background colour
          viewBalanceSetUpVm.popoverBbackdrop();

          //to auto enable biometric
          viewBalanceSetUpVm.isFingerprintAvl = false;
                  viewBalanceSetUpVm.isFingerprintAvlDevice = false;

            quickPayService.isFingerprintAvailable().then(function (response) {
                        viewBalanceSetUpVm.isFingerprintAvlDevice = true;

                        var fingerprintToken = "";
                        cordova.plugins.SecureKeyStore.get(function (res) {
                              fingerprintToken = res;
                              if (fingerprintToken == null || fingerprintToken == "null" || fingerprintToken == undefined || fingerprintToken == "undefined" || fingerprintToken == "") {
                                    viewBalanceSetUpVm.isFingerprintAvl = false;
                              }
                              else {
                                    viewBalanceSetUpVm.isFingerprintAvl = true;
                                    //to auto populate fingerprint option
                                    viewBalanceSetUpVm.checkBiometric();
                              }
                        }, function (error) {
    
                        }, loggedInUserService.deviceInfo);
                  }, function (error) {
                  });

        };

        viewBalanceSetUpVm.popoverBbackdrop = function(){
          var backDrop = document.getElementsByClassName("popover-backdrop");
          if(backDrop){
            for(var i=0;i<backDrop.length;i++){
              if(backDrop[i]["className"] == "popover-backdrop"){
                backDrop[i].setAttribute("style","background-color: rgba(0, 0, 0, 0.7) !important;");
              }
            }
          }
        }

    viewBalanceSetUpVm.authenticate = function () {
      if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (viewBalanceSetUpVm.isSimChanged || viewBalanceSetUpVm.simList == undefined || viewBalanceSetUpVm.simList.length == 0)) {
        if (viewBalanceSetUpVm.isSimChanged)
          registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
        else if (viewBalanceSetUpVm.simList == undefined || viewBalanceSetUpVm.simList.length == 0)
          utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
        return;
      }
      viewBalanceSetUpVm.userLoginErrorFlag = false;
      viewBalanceSetUpVm.isLoginBtnClicked = true;
      if (viewBalanceSetUpVm.userName && viewBalanceSetUpVm.password) {
        viewBalanceSetUpVm.isLoginBtnClicked = false;
        utilityService.showSpinner();
        internetBankingService.getServiceIdAndKey().then(function (data) {
          loggedInUserService.keyIdINB = data.keyId;
          loggedInUserService.serviceIdINB = data.serviceId;
          loggedInUserService.finalSHA512Val = loggedInUserService.generateINBSHA512Val(viewBalanceSetUpVm.userName, viewBalanceSetUpVm.password);
          utilityService.hideSpinner();
          viewBalanceSetUpVm.userloginStart();
        }, function (error) {
          viewBalanceSetUpVm.userName = '';
          viewBalanceSetUpVm.password = '';
          utilityService.hideSpinner();
          if (error.responseMessage) {
            utilityService.showErrorMessage(error.responseMessage);
          } else {
            utilityService.showErrorMessage(constantConfig.adapter.CANNOT_PROCESS_NOW);
          }
        });
      }
    }

    viewBalanceSetUpVm.userloginStart = function(){
      var hasedSimInfo = "";
				if(utilityService.isAndroidPlatform()){
					hasedSimInfo = viewBalanceSetUpVm.hasedSimInfo;
				}
      var requestParams = {
        "userName": viewBalanceSetUpVm.userName,
        "sha512Password": loggedInUserService.finalSHA512Val,
        "type" : "username",
        "simId": hasedSimInfo.toString()
      };
      quickPayService.userAuthentication(requestParams).then(function (data) {
          $scope.hideKeyboard();
          viewBalanceSetUpVm.userName = "";
          viewBalanceSetUpVm.password = "";
          $scope.popover.hide();
          afterUserAuthSuccess(data);
          clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYUSERNAMESUCCESS"));
      }, function (error) {
        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYUSERNAMEFAIL"));
        if(error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
            utilityService.showForcePasswordPopup(error.responseMessage,"");
        }else{
          utilityService.showErrorMessage(error.responseMessage);
        }
       });
    }

    function afterUserAuthSuccess(data){
      quickPayService.customerInfo = data;
      viewBalanceSetUpVm.isSetupClicked = true;
	  //mpassbook related functionality added by GOC, Hyderabad
		mpassbookdetailsService.selectedACNo ="";
		mpassbookdetailsService.branchCode ="";
		mpassbookdetailsService.goBackToState ="";
		mpassbookdetailsService.selectedACNo =viewBalanceSetUpVm.accountLists[0].accountNumber;
		mpassbookdetailsService.branchCode =viewBalanceSetUpVm.accountLists[0].branchCode;
	  //end of mpassbook functionality
    }

    viewBalanceSetUpVm.changeInput = function ($event, index) {

      cordova.plugins.Keyboard.close();
      /*login flow improvements*/
      if (loggedInUserService.isServerConnected) {
        viewBalanceSetUpVm.loginWithMpin();
      } else {
        //connectServer();
      }
 
    }

    viewBalanceSetUpVm.loginWithMpin = function () {
      if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (viewBalanceSetUpVm.isSimChanged || viewBalanceSetUpVm.simList == undefined || viewBalanceSetUpVm.simList.length == 0)) {
        if (viewBalanceSetUpVm.isSimChanged)
          registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
        else if (viewBalanceSetUpVm.simList == undefined || viewBalanceSetUpVm.simList.length == 0)
          utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
        return;
      }
      var newMpin = viewBalanceSetUpVm.first.trim() +
        viewBalanceSetUpVm.second.trim() +
        viewBalanceSetUpVm.third.trim() +
        viewBalanceSetUpVm.fourth.trim() +
        viewBalanceSetUpVm.fifth.trim() +
        viewBalanceSetUpVm.sixth.trim();
      //var newMpin = viewBalanceSetUpVm.setpassword;;
      if (newMpin.length == 6) {
        if (ConnectivityMonitorUtils.isOffline()) {
          viewBalanceSetUpVm.first = '';
          viewBalanceSetUpVm.second = '';
          viewBalanceSetUpVm.third = '';
          viewBalanceSetUpVm.fourth = '';
          viewBalanceSetUpVm.fifth = '';
          viewBalanceSetUpVm.sixth = '';
          $scope.clearMpin();
          //viewBalanceSetUpVm.enabledThisInput(1);
          /*login flow improvement*/
          var inputElement = document.getElementById('InputTxt1');
          inputElement.disabled = false;
          utilityService.offlineAlert();
          return;
        }
        var hasedSimInfo = "";
				if(utilityService.isAndroidPlatform()){
					hasedSimInfo = viewBalanceSetUpVm.hasedSimInfo;
				}
        var requestParams = {
          "mPinNumber": newMpin,
          "type" : "mpin",
          "simId": hasedSimInfo.toString(),
          "simSubId" : viewBalanceSetUpVm.simSubscriptionId
        };

        
        quickPayService.userAuthentication(requestParams).then(function (data) {
          $scope.hideKeyboard();
          $scope.popover.hide();
          afterUserAuthSuccess(data);
          viewBalanceSetUpVm.first = '';
        viewBalanceSetUpVm.second = '';
        viewBalanceSetUpVm.third = '';
        viewBalanceSetUpVm.fourth = '';
        viewBalanceSetUpVm.fifth = '';
        viewBalanceSetUpVm.sixth = '';
        $scope.clearMpin();
        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYMPINSUCCESS"));
        }, function (error) {
          viewBalanceSetUpVm.first = '';
        viewBalanceSetUpVm.second = '';
        viewBalanceSetUpVm.third = '';
        viewBalanceSetUpVm.fourth = '';
        viewBalanceSetUpVm.fifth = '';
        viewBalanceSetUpVm.sixth = '';
        $scope.clearMpin();
        viewBalanceSetUpVm.enabledThisInput(1);
        if(error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
            utilityService.showForcePasswordPopup(error.responseMessage,"");
        }else{
            utilityService.showErrorMessage(error.responseMessage);
        }
        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYMPINFAIL"));  
        });
        
      } else {
        viewBalanceSetUpVm.first = '';
        viewBalanceSetUpVm.second = '';
        viewBalanceSetUpVm.third = '';
        viewBalanceSetUpVm.fourth = '';
        viewBalanceSetUpVm.fifth = '';
        viewBalanceSetUpVm.sixth = '';
        $scope.clearMpin();
        viewBalanceSetUpVm.enabledThisInput(1);
        utilityService.showErrorMessage('Please Enter 6 digit valid MPIN');
      }
    };

    viewBalanceSetUpVm.enabledThisInput = function (index) {
      try {
        viewBalanceSetUpVm.mpinErrorMsgFlag = false;
        for (var i = 1; i <= 6; i++) {
          var inputElement = document.getElementById('InputTxt' + i);
          if (index == i) {
            inputElement.disabled = false;
            inputElement.style = "border-bottom:1px solid #0095da !important;"
          } else {
            inputElement.disabled = true;
            inputElement.style = "border-bottom:1px solid #bcbebf !important;"
          }
        }
      } catch (err) { }
    }

viewBalanceSetUpVm.checkBiometric = function () {
      if (quickPayService.isFingerprintAviFlag) {
        var encryptConfig = {
          clientId: "SBI YONO", //Android: Used for encryption. iOS: used for dialogue if no `localizedReason` is given.
          clientSecret: loggedInUserService.deviceInfo, //Necessary for Android encrpytion of keys. Use random secret key.
          disableBackup: true,

        };
        Fingerprint.show(encryptConfig, successCallback, errorCallback);
      }
    }

    function successCallback() {
      authByBiometric();
      /*if (result.withFingerprint) {
        //call service to Auth
        authByBiometric();
      } else if (result.withBackup) {
        //call service to retrieve token at adapter

      }
      else if (result == 'Success') {
        //call service to Auth
        authByBiometric();
      }*/
    }

    function authByBiometric() {
      if (utilityService.isAndroidPlatform() && registerWithSimService.isSimLogin && !registerWithSimService.userWithoutSimReg && (viewBalanceSetUpVm.isSimChanged || viewBalanceSetUpVm.simList == undefined || viewBalanceSetUpVm.simList.length == 0)) {
        if (viewBalanceSetUpVm.isSimChanged)
          registerWithSimService.reloadAppSimOk(registerWithSimService.changedSimMsg);
        else if (viewBalanceSetUpVm.simList == undefined || viewBalanceSetUpVm.simList.length == 0)
          utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
        return;
      }
      var hasedSimInfo = "";
				if(utilityService.isAndroidPlatform()){
					hasedSimInfo = viewBalanceSetUpVm.hasedSimInfo;
				}
      var params = { 'type': 'biometric', "simId": hasedSimInfo.toString()};
      //call service to retrieve token at adapter
      quickPayService.userAuthentication(params).then(function (data) {
        $scope.popover.hide();
        afterUserAuthSuccess(data);
        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYBIOSUCCESS"));
      }, function (error) {
          clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData($state.current.data.pageId + "_" + "YQP_AUTHBYBIOFAIL"));
          if(error.responseCode == "SB001" || error.responseCode == "F001"){
            registerWithSimService.reloadAppSimOk(error.responseMessage);
          }
          else if(error.responseCode == constantConfig.FORCE_PWD_ERROR_CODES.FP01){
              utilityService.showForcePasswordPopup(error.responseMessage,"");
          }
          else
          {
            utilityService.showErrorMessage(error.responseMessage);
          }
      });
    }
    function errorCallback(error) {
      
    }
    viewBalanceSetUpVm.comingSoon = function(){
      utilityService.showBhimUpiAlert("", 'Coming Soon');
    }
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
                viewBalanceSetUpVm.simSubscriptionId = "";
        viewBalanceSetUpVm.hasedSimInfo = "";
			  viewBalanceSetUpVm.simList = [];
        viewBalanceSetUpVm.isSimChanged = false;
        viewBalanceSetUpVm.keyguardValue = internetBankingService.checkKeyguardValue;
        //store skip count in localstorage
							var count = localStorage.getItem("viewBalSkipCount");
							if (!count) {
								count = 1;
							}
							else {
								count = count + 1;
							}
							localStorage.setItem("viewBalSkipCount", count);
				
            viewBalanceSetUpVm.viewbalAvl = true;
            viewBalanceSetUpVm.isBiometricSet = localStorage.getItem("isBiometricSet");
            if(viewBalanceSetUpVm.isBiometricSet == undefined || viewBalanceSetUpVm.isBiometricSet == "false"){
        viewBalanceSetUpVm.isBiometricSet = false;
      }
      else{
        viewBalanceSetUpVm.isBiometricSet = true;
      }
            viewBalanceSetUpVm.isMpinSet = loggedInUserService.mpinConsent;
            viewBalanceSetUpVm.customerInfo = quickPayService.customerInfo;
            viewBalanceSetUpVm.isSetupClicked = false;
            
				viewBalanceSetUpVm.accountLists = viewBalanceSetUpVm.customerInfo.accounts;
            if(viewBalanceSetUpVm.customerInfo.customerInformation.accountNumber != ''){
               viewBalanceSetUpVm.primary_account = viewBalanceSetUpVm.customerInfo.customerInformation.accountNumber;
               viewBalanceSetUpVm.sel_primary_account = viewBalanceSetUpVm.customerInfo.customerInformation.accountNumber;
               viewBalanceSetUpVm.isPrimarySet = true;
            }
            else{
               viewBalanceSetUpVm.primary_account = "";
               viewBalanceSetUpVm.isPrimarySet = false;
            }
            if (utilityService.isAndroidPlatform()) {
                            utilityService.showSpinner();
                            readSimcardInfo();
                        }
			});

function readSimcardInfo() {
                /*Sim card Info fetching - Start*/
                function simInfosuccessCallback(result) {
                    utilityService.hideSpinner();
                    
					var str = "";
          viewBalanceSetUpVm.isSimChanged = false;
					if(result.cards && result.cards.length > 0)
                    {
                        viewBalanceSetUpVm.simList = result.cards;
						var isAccountExists = -1;
						viewBalanceSetUpVm.simList.some(function (obj, i) {
							return obj.subscriptionId == registerWithSimService.simSubscriptionId ? isAccountExists = i : false;
						});
						if (isAccountExists !== -1) {
							str = device.uuid + registerWithSimService.simSubscriptionId;
							viewBalanceSetUpVm.simSubscriptionId = registerWithSimService.simSubscriptionId;
							viewBalanceSetUpVm.hasedSimInfo = cryptoService.getSHA512EncryptedData(str);
						}
						else{
							//either sim card is removed or slot changed or subscription id changed due to sim changes
              viewBalanceSetUpVm.isSimChanged = true;
							viewBalanceSetUpVm.simSubscriptionId = "";
						}
                    }
					if (viewBalanceSetUpVm.simList == undefined || viewBalanceSetUpVm.simList.length == 0) {
                        utilityService.showBhimUpiAlert("alert", registerWithSimService.noSimMsg);
                    }
                    
                    $scope.$apply();
                }

                function HasPerminionSuccessCallback(result) {
                    if (result) {
                        window.plugins.sim.getSimInfo(simInfosuccessCallback, errorCallbackSim);
                    } else {
                        requestReadPermission();
                    }
                }

                function errorCallbackSim(error) {
                    utilityService.hideSpinner();
                    utilityService.showBhimUpiAlert("Permission denied.");
                }

                function requestSuccessCallback(result) {
                    if (result) {
                        hasReadPermission();
                    }
                }
                // Android only: check permission
                function hasReadPermission() {
                    window.plugins.sim.hasReadPermission(HasPerminionSuccessCallback, errorCallbackSim);
                }
                // Android only: request permission
                function requestReadPermission() {
                    window.plugins.sim.requestReadPermission(requestSuccessCallback, errorCallbackSim);
                }
                hasReadPermission();
                /*Sim card Info fetching - End*/
            }
      /*Custom Keypad for MPIN*/
    


    $scope.password = '';
    $scope.canErase = false;
    $scope.pinDotVisible = {};
    $scope.success = null;
    $scope.keyboardVisible = false;
    $scope.pinArray = [];

    $scope.keyboardSettings = {
      // settings here
      action: function (number) {
        
        if ($scope.password.length < 6) {
          $scope.password += number;
          $scope.pinArray.push(number);
          $scope.pinDotVisible[$scope.password.length] = true;
          $scope.canErase = true;
          $scope.success = null;
          var pass = $scope.password;
          pass = pass.split("");
          try {
            viewBalanceSetUpVm.first = pass[0];
            viewBalanceSetUpVm.second = pass[1];
            viewBalanceSetUpVm.third = pass[2];
            viewBalanceSetUpVm.fourth = pass[3];
            viewBalanceSetUpVm.fifth = pass[4];
            viewBalanceSetUpVm.sixth = pass[5];
          } catch (err) { }

        }
        if ($scope.password && $scope.password.length === 6) {
          var e = {};
          $scope.newMpin = $scope.password;
          var pass = $scope.password;
          pass = pass.split("");
          try {
            viewBalanceSetUpVm.first = pass[0];
            viewBalanceSetUpVm.second = pass[1];
            viewBalanceSetUpVm.third = pass[2];
            viewBalanceSetUpVm.fourth = pass[3];
            viewBalanceSetUpVm.fifth = pass[4];
            viewBalanceSetUpVm.sixth = pass[5];
          } catch (err) { }
          var e = {};
          e.srcElement = {};
          e.srcElement.value = 2;
          viewBalanceSetUpVm.changeInput(e, 6);
        }
      },

      // Clear
      leftButton: {
        html: '<i class="icon ion-backspace"></i>',
        action: function () {
          $scope.doErase();
        },
        style: {
          bgColor: '#fff',
          activeBgColor: '#dfdfdf',
          borderColor: '#dfdfdf',
          fontSize: '20px'
        }
      },

      // Submit login
      rightButton: {
        html: '<i class="icon ion-eye"></i> <i class="icon ion-eye-disabled login-eye-btn" ></i>',
        //html: '<i id="eyeElement" class="icon ion-eye"></i>',
        action: function () {
          //$scope.hideKeyboard();
          if ($scope.isPassVisible) {
            var elementHide = document.getElementsByClassName("ion-eye-disabled")[0];
            elementHide.classList.add("login-eye-btn");
            var elementShow = document.getElementsByClassName("ion-eye")[0];
            elementShow.classList.remove("login-eye-btn");

            $scope.isPassVisible = false;
          } else {
            $scope.isPassVisible = true;
            var elementHide = document.getElementsByClassName("ion-eye")[0];
            elementHide.classList.add("login-eye-btn");
            var elementShow = document.getElementsByClassName("ion-eye-disabled")[0];
            elementShow.classList.remove("login-eye-btn");
          }
        },
        style: {
          bgColor: '#fff',
          activeBgColor: '#dfdfdf',
          borderColor: '#dfdfdf',
          fontSize: '30px'
        }
      }
    }

    $scope.doErase = function () {
      $scope.pinDotVisible[$scope.password.length] = false;
      $scope.password = $scope.password.slice(0, -1);
      if ($scope.password.length == 0) $scope.canErase = false;
      try {
        var pass = $scope.password;
        pass = pass.split("");
        viewBalanceSetUpVm.first = pass[0] ? pass[0] : "";
        viewBalanceSetUpVm.second = pass[1] ? pass[1] : "";
        viewBalanceSetUpVm.third = pass[2] ? pass[2] : "";
        viewBalanceSetUpVm.fourth = pass[3] ? pass[3] : "";
        viewBalanceSetUpVm.fifth = pass[4] ? pass[4] : "";
        viewBalanceSetUpVm.sixth = pass[5] ? pass[5] : "";
      } catch (err) { }
    }



    $scope.unmask = function () {

    }

    $scope.rightAction = function () {
      pinDotVisible[0] = false;
      pinDotVisible[1] = false;
      pinDotVisible[2] = false;
      pinDotVisible[3] = false;
      pinDotVisible[4] = false;
      pinDotVisible[5] = false;
    }

    $scope.showKeyboard = function () {
      $scope.keyboardVisible = true;
    }

    $rootScope.hidekeypad = function ($event) {
      switch ($event.target.className) {
        case "mpin1 activated":
        // code block

        case "digit-keyboard-key":
        // code block

        case "digit-keyboard-key-action ng-binding":
        // code block

        case "icon ion-record":
        // code block

        case "digit-keyboard-key activated":
        // code block

        case "icon ion-backspace":
        // code block

        case "mpin1 ng-pristine ng-untouched ng-valid ng-empty activated":
        // code block

        case "mpin1 ng-binding":
        // code block

        case "icon ion-eye-disabled login-eye-btn":
        // code block

        case "icon ion-eye login-eye-btn":
        // code block

        case "digit-keyboard-key-number":
          // code block
          if (!$scope.keyboardVisible) {
            $scope.showKeyboard();
          }
          break;
        default:
          // code block
          if ($scope.keyboardVisible) {
            $scope.hideKeyboard();
          }
          break;
      }
    }

    $scope.hideKeyboard = function () {
      $scope.keyboardVisible = false;
    }

    /*End of Custom Keypad for MPIN*/

			return this;
		}
]);


