'use strict';

angularApp.controller('nomineeDetailsController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "getAccountDetailsService",
    "utilityService",
    "homeScreenService",
    "$ionicPopup",
    "$rootScope",
    "$filter",
    "ionicDatePicker",
    "rrService",
    "cardsService",
    "generalInsurenceAccidentService",
    "mutualFundsService",
    "$stateParams",
    "validateService",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        getAccountDetailsService,
        utilityService,
        homeScreenService,
        $ionicPopup,
        $rootScope,
        $filter,
        ionicDatePicker,
        rrService,
        cardsService,
        generalInsurenceAccidentService,
        mutualFundsService,
        $stateParams,
        validateService
    ) {

        var nomineeDetailsVm = this;
        nomineeDetailsVm.isChallenged = false;
        nomineeDetailsVm.isValidAccount = false;
        nomineeDetailsVm.validAccountMessage = "";
        nomineeDetailsVm.disablenext = false;
        $scope.isINR = false;


        function initPage() {
            

             nomineeDetailsVm.isMaskedTotal = true;
             nomineeDetailsVm.rrNomineeDetailsForm = {};
             nomineeDetailsVm.rrNomineeAddForm = {};
             nomineeDetailsVm.rrAppointeeDetailsForm = {};

            if( rrService.saveData.application.app.nominee.isMinor){
                nomineeDetailsVm.minorFlag1 = 1;
            }else{
                nomineeDetailsVm.minorFlag1 = 0;
            }

            
            nomineeDetailsVm.validateService = validateService;
            nomineeDetailsVm.edit = $stateParams.termsObj;
            nomineeDetailsVm.ycchannel=requestYCService.ycchannel
            if(nomineeDetailsVm.edit == 'All'){
            nomineeDetailsVm.showBack = false;
            nomineeDetailsVm.showNext = false;
            nomineeDetailsVm.showSave = true;
            nomineeDetailsVm.showCancel = true;
            }else{
            nomineeDetailsVm.showBack = true;
            nomineeDetailsVm.showNext = true;
            nomineeDetailsVm.showSave = false;
            nomineeDetailsVm.showCancel = false;
            }
             
            nomineeDetailsVm.payingFrom = getAccountDetailsService.accountOverviewData.accounts;
            nomineeDetailsVm.accDetails = [];
            nomineeDetailsVm.accDetails = nomineeDetailsVm.payingFrom;
            nomineeDetailsVm.selectedAccount = requestYCService.selectedAccValue == null ? "" : JSON.stringify(requestYCService.selectedAccValue);
            nomineeDetailsVm.showSelect = true;
            nomineeDetailsVm.gonextPg = false;
            angular.forEach(nomineeDetailsVm.accDetails, function (value, key) {
                if (value.accountType) {
                    value.accountType =value.accountType.substr(0, value.accountType.length-1) + "C";
                }
            });
            nomineeDetailsVm.totPremAmt = rrService.premiumDetails.totPremAmt;
            //getMasterData();
            //nomineeDetailsVm.getTitle(); 				// get Title list
            //nomineeDetailsVm.getCityList(); 				// get City List
            //nomineeDetailsVm.getStateList(); 			//get State List
           
            nomineeDetailsVm.multipleOf100 = false;
            nomineeDetailsVm.multipleOf500 = false;
            nomineeDetailsVm.amountBound = false;
            nomineeDetailsVm.lessBal = false;

            nomineeDetailsVm.amountBoundAll = false;
            nomineeDetailsVm.amountBoundFiv = false;
            nomineeDetailsVm.amountBoundPOS = false;

            nomineeDetailsVm.flatNameErr = false;
            nomineeDetailsVm.streetNameErr = false;
            nomineeDetailsVm.landmarkNameErr = false;
            nomineeDetailsVm.pinCodeErr = false;
            nomineeDetailsVm.cityErr = false;
            nomineeDetailsVm.stateErr = false;
            nomineeDetailsVm.titleErr = false;
            nomineeDetailsVm.relApplicant = {key:"",value:""};
            nomineeDetailsVm.appointeeRelation = {key:"",value:""};
            nomineeDetailsVm.title = {key:"",value:""};
            nomineeDetailsVm.appointeeTitle = {key:"",value:""};
        

            
            nomineeDetailsVm.masterDropDownData = rrService.masterDropDownData;
            nomineeDetailsVm.customerInformation=getAccountDetailsService.accountOverviewData.customerInformation; 

            // if(rrService.saveData.application.app.nominee.firstName != ""){

            // }

            nomineeDetailsVm.titleCheck = rrService.saveData.application.app.nominee.title ? rrService.saveData.application.app.nominee.title : "";            
            nomineeDetailsVm.firstName = rrService.saveData.application.app.nominee.firstName ? rrService.saveData.application.app.nominee.firstName : "";
            nomineeDetailsVm.lastName = rrService.saveData.application.app.nominee.lastName ? rrService.saveData.application.app.nominee.lastName : "";
            nomineeDetailsVm.nomineeDob = rrService.saveData.application.app.nominee.dob ? rrService.saveData.application.app.nominee.dob : "";
            nomineeDetailsVm.minorFlag1 = rrService.saveData.application.app.nominee.isMinor ? rrService.saveData.application.app.nominee.isMinor : "";
            nomineeDetailsVm.isChecked = rrService.saveData.application.app.nominee.sameApplAddress ? rrService.saveData.application.app.nominee.sameApplAddress : "true";
            nomineeDetailsVm.isChecked = nomineeDetailsVm.isChecked == 'true' ? true : false;
            if(nomineeDetailsVm.isChecked){
                nomineeDetailsVm.getPinDataCust(nomineeDetailsVm.customerInformation.pinCode)
            }
            nomineeDetailsVm.relApplicantCheck = rrService.saveData.application.app.nominee.relation ? rrService.saveData.application.app.nominee.relation : "";   
            nomineeDetailsVm.flatName = rrService.saveData.application.app.nominee.address.building ? rrService.saveData.application.app.nominee.address.building : "";
            nomineeDetailsVm.landmarkName = rrService.saveData.application.app.nominee.address.landMark ? rrService.saveData.application.app.nominee.address.landMark : "";
            nomineeDetailsVm.streetName = rrService.saveData.application.app.nominee.address.locality ? rrService.saveData.application.app.nominee.address.locality : "";
            nomineeDetailsVm.pinCode = rrService.saveData.application.app.nominee.address.pincode ? rrService.saveData.application.app.nominee.address.pincode : "";
            if(nomineeDetailsVm.pinCode){
                nomineeDetailsVm.getPinData(nomineeDetailsVm.pinCode);
            }

            //nomineeDetailsVm.city = rrService.saveData.application.app.nominee.address.city ? rrService.saveData.application.app.nominee.address.city : "";
            //nomineeDetailsVm.state = rrService.saveData.application.app.nominee.address.state ? rrService.saveData.application.app.nominee.address.state : "";
            nomineeDetailsVm.appointeeTitleCheck = rrService.saveData.application.app.appointee.title ? rrService.saveData.application.app.appointee.title : "";
            nomineeDetailsVm.appointeefirstName = rrService.saveData.application.app.appointee.firstName ? rrService.saveData.application.app.appointee.firstName : "";
            nomineeDetailsVm.appointeelastName = rrService.saveData.application.app.appointee.lastName ? rrService.saveData.application.app.appointee.lastName : "";
            nomineeDetailsVm.appointeeDob1 = rrService.saveData.application.app.appointee.dob ? rrService.saveData.application.app.appointee.dob : "";
            nomineeDetailsVm.appointeeRelationCheck = rrService.saveData.application.app.appointee.relation ? rrService.saveData.application.app.appointee.relation : "";
            nomineeDetailsVm.ttlpremium = rrService.premiumDetails.totPremAmt;
            nomineeDetailsVm.basePremAmt = rrService.premiumDetails.basePremAmt;
            nomineeDetailsVm.quoteNo = rrService.premiumDetails.quoteNo;
            nomineeDetailsVm.taxAmt = rrService.premiumDetails.taxAmt;
            nomineeDetailsVm.getMaster();

            if( !rrService.saveData.application.app.nominee.firstName){
                nomineeDetailsVm.fetchNomineeDetails();
            }

        }

        


         nomineeDetailsVm.getMaster = function () {
            utilityService.showSpinner(); 
            rrService.getMedicalQuestions().then(function(data){        
                        utilityService.hideSpinner();                  
                        nomineeDetailsVm.masterDataList=JSON.parse(data.content).content.appMaster;  
                        if(nomineeDetailsVm.titleCheck){
                            angular.forEach(nomineeDetailsVm.masterDataList.salutations, function (value, key) {                                      
                                        if (value.value == nomineeDetailsVm.titleCheck) {
                                            nomineeDetailsVm.title.key = value.key;
                                            nomineeDetailsVm.title.value = value.value;
                                        }
                                    });
                        }
                        if(nomineeDetailsVm.title){
                            if(nomineeDetailsVm.title.value == "Mr."){
                                nomineeDetailsVm.masterDataList.relationshipsNominee = nomineeDetailsVm.masterDataList.relationshipMale
                            }else{
                                nomineeDetailsVm.masterDataList.relationshipsNominee = nomineeDetailsVm.masterDataList.relationshipFemale
                            }
                        }
                        

                        if(nomineeDetailsVm.relApplicantCheck){
                            angular.forEach(nomineeDetailsVm.masterDataList.relationshipsNominee, function (value, key) {
                                        if (value.key == nomineeDetailsVm.relApplicantCheck) {
                                            nomineeDetailsVm.relApplicant.key = value.key;
                                            nomineeDetailsVm.relApplicant.value = value.value
                                        }
                                    });
                        }
                        
                        if(nomineeDetailsVm.appointeeTitleCheck){
                            angular.forEach(nomineeDetailsVm.masterDataList.salutations, function (value, key) {                                        
                                        if (value.value == nomineeDetailsVm.appointeeTitleCheck) {
                                            nomineeDetailsVm.appointeeTitle.key = value.key;
                                            nomineeDetailsVm.appointeeTitle.value = value.value;
                                        }
                                    });
                        } 
                        if(nomineeDetailsVm.appointeeTitle){
                            if(nomineeDetailsVm.appointeeTitle.value == "Mr."){
                            nomineeDetailsVm.masterDataList.relationshipsAppointee = nomineeDetailsVm.masterDataList.relationshipMale
                            }else{
                                nomineeDetailsVm.masterDataList.relationshipsAppointee = nomineeDetailsVm.masterDataList.relationshipFemale
                            }
                        }
                          
                        if(nomineeDetailsVm.appointeeRelationCheck){
                            angular.forEach(nomineeDetailsVm.masterDataList.relationshipsAppointee, function (value, key) {
                                        if (value.key == nomineeDetailsVm.appointeeRelationCheck) {
                                            nomineeDetailsVm.appointeeRelation.key = value.key;
                                            nomineeDetailsVm.appointeeRelation.value = value.value
                                        }
                                    });
                        }                   
                        
                    },function(error){
                        utilityService.hideSpinner();  
                        nomineeDetailsVm.masterDataList=error.tabs;
                        utilityService.showErrorMessage(error.responseMessage);
                        
                    })
         } 

        

         nomineeDetailsVm.cngTitle = function (_title) {
             if (_title.value == "Mr.") {
                 nomineeDetailsVm.masterDataList.relationshipsNominee = nomineeDetailsVm.masterDataList.relationshipMale
             } else {
                 nomineeDetailsVm.masterDataList.relationshipsNominee = nomineeDetailsVm.masterDataList.relationshipFemale
             }
         }

         nomineeDetailsVm.cngTitleAppointee = function (_title) {

             if (_title.value == "Mr.") {
                 nomineeDetailsVm.masterDataList.relationshipsAppointee = nomineeDetailsVm.masterDataList.relationshipMale
             } else {
                 nomineeDetailsVm.masterDataList.relationshipsAppointee = nomineeDetailsVm.masterDataList.relationshipFemale
             }
         }



            nomineeDetailsVm.getPinData = function (pinCode) {
				
                if(pinCode.length == 6){
                    var inputparams = {
				    "pinCode" : pinCode
                    }                    
                    rrService.getPostalDetailByPincode(inputparams).then(function(data) {                        
                            nomineeDetailsVm.areaDetailsList = data;
                            nomineeDetailsVm.city =  nomineeDetailsVm.areaDetailsList[0].cityCode;
                            nomineeDetailsVm.state =  nomineeDetailsVm.areaDetailsList[0].stateCode;
                            if(rrService.saveData.application.app.nominee.address.pincode){
                                for (var i in nomineeDetailsVm.areaDetailsList) {
                                        if (nomineeDetailsVm.areaDetailsList[i].city == rrService.saveData.application.app.nominee.address.city) {
                                            nomineeDetailsVm.city = nomineeDetailsVm.areaDetailsList[i].cityCode
                                        }
                                        if (nomineeDetailsVm.areaDetailsList[i].state == rrService.saveData.application.app.nominee.address.state) {
                                            nomineeDetailsVm.state = nomineeDetailsVm.areaDetailsList[i].stateCode
                                        }
                                    }   
                            }
                            
                    }, function(error) {
                        nomineeDetailsVm.areaDetailsList='';
                        nomineeDetailsVm.city = '';
                        nomineeDetailsVm.state = '';
                        if(error.responseCode == '2001'){
                        utilityService.showErrorMessage("Invalid Pincode");    
                        }else{
                        utilityService.showErrorMessage(error.responseMessage);   
                        }
                        
                    });
                    
                }


			}


            nomineeDetailsVm.checkMinor = function () {
                    if (nomineeDetailsVm.nomineeDob) {
                        nomineeDetailsVm.noOfYearDiffernce = (new Date().getFullYear() - new Date(nomineeDetailsVm.nomineeDob).getFullYear()) * 12;
                        nomineeDetailsVm.noOfYearDiffernce -= new Date(nomineeDetailsVm.nomineeDob).getMonth() + 1;
                        nomineeDetailsVm.noOfYearDiffernce += (new Date().getMonth() + 1);
                        nomineeDetailsVm.noOfMonths = nomineeDetailsVm.noOfYearDiffernce;
                        if (nomineeDetailsVm.noOfMonths < 216) {
                            nomineeDetailsVm.minorFlag1 = 1;
                        } else {
                            nomineeDetailsVm.minorFlag1 = 0;
                        }
                    }
                }

            nomineeDetailsVm.hideshowTotal = function () {
            nomineeDetailsVm.isMaskedTotal == true ? (nomineeDetailsVm.isMaskedTotal = false) : (nomineeDetailsVm.isMaskedTotal = true);
            };



  

        

        

        nomineeDetailsVm.showPop = function(){
            nomineeDetailsVm.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                templateUrl: 'pages/yonoCash/landing/dropdownModal.html',
                scope: $scope
            });
        }

        nomineeDetailsVm.close = function(index){
                   
                    if(nomineeDetailsVm.popUp){
                    nomineeDetailsVm.popUp.close();
                    }
                    
                    nomineeDetailsVm.balance = nomineeDetailsVm.accDetails[index].accountBalance;
                    nomineeDetailsVm.accType = nomineeDetailsVm.accDetails[index].accountType;
                    nomineeDetailsVm.accountNumber = nomineeDetailsVm.accDetails[index].accountNumber;
                    nomineeDetailsVm.isActive = nomineeDetailsVm.accDetails[index].isActive;
                    nomineeDetailsVm.isTransactional = nomineeDetailsVm.accDetails[index].isTransactional;
                    requestYCService.selectedDetails.selIndex = index ;
                    requestYCService.selectedDetails.accountNumber = nomineeDetailsVm.accDetails[index].accountNumber;
                    requestYCService.selectedDetails.accountBalance = nomineeDetailsVm.accDetails[index].accountBalance;
                    nomineeDetailsVm.showSelect = false;
                }


            


        nomineeDetailsVm.openDatePickerForNominee = function () {

            if (nomineeDetailsVm.nomineeDob) {
                    nomineeDetailsVm.inputDate = new Date(nomineeDetailsVm.nomineeDob);
                } else {
                    var date = new Date();
                    nomineeDetailsVm.inputDate = new Date(date);
                }

             var monList = ["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"];
                
                nomineeDetailsVm.inputDate.setFullYear(nomineeDetailsVm.inputDate.getFullYear()-120);
                var toDate = new Date();
                toDate.setFullYear(toDate.getFullYear());
                nomineeDetailsVm.dateObj = {
                        callback: function (val) {
                            var dateOfBirth = new Date(val);
                            var setDate;
                            if(dateOfBirth.getDate() < 10){
                                setDate = "0" + dateOfBirth.getDate();
                            }else{
                                setDate = dateOfBirth.getDate();
                            }
                            nomineeDetailsVm.nomineeDob = setDate + " " + monList[dateOfBirth.getMonth()] + " " + dateOfBirth.getFullYear();
                            nomineeDetailsVm.checkMinor();                            
                        },
                        inputDate: toDate,
                        monthsList:monList,
                        from: nomineeDetailsVm.inputDate,
                        to: toDate,
                        mondayFirst: true,
                        closeOnSelect: false,
                        templateType: 'popup',
                        dateFormat: 'dd MMM yyyy'
                };
				

				ionicDatePicker.openDatePicker(nomineeDetailsVm.dateObj);
			};



            nomineeDetailsVm.openDatePickerForAppointeeDob1 = function () {
				if (nomineeDetailsVm.appointeeDob1) {
					nomineeDetailsVm.openDatePcDivAppointeeDob1 = new Date(nomineeDetailsVm.appointeeDob1);
				} else {
					nomineeDetailsVm.openDatePcDivAppointeeDob1 = new Date();
				}
                 var monList = ["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"];                
                nomineeDetailsVm.openDatePcDivAppointeeDob1.setFullYear(nomineeDetailsVm.openDatePcDivAppointeeDob1.getFullYear()-120);
                var toDate = new Date();
                toDate.setFullYear(toDate.getFullYear()-18);
                nomineeDetailsVm.dateObjforAppointee = {
                        callback: function (val) {
                            var dateOfBirth = new Date(val);
                            var setDate;
                            if(dateOfBirth.getDate() < 10){
                                 setDate = "0" + dateOfBirth.getDate();
                            }else{
                                setDate = dateOfBirth.getDate();
                            }
                            nomineeDetailsVm.appointeeDob1 = setDate + " " + monList[dateOfBirth.getMonth()] + " " + dateOfBirth.getFullYear();                                                       
                        },
                        inputDate: toDate,
                        monthsList:monList,
                        from: nomineeDetailsVm.openDatePcDivAppointeeDob1,
                        to: toDate,
                        mondayFirst: true,
                        closeOnSelect: false,
                        templateType: 'popup',
                        dateFormat: 'dd MMM yyyy'
                };
				ionicDatePicker.openDatePicker(nomineeDetailsVm.dateObjforAppointee);
			};

			nomineeDetailsVm.openDatePcDivAppointeeDob1 = {
				callback: function (val) {
					var date = $filter('date')(new Date(val), 'dd MMM yyyy');
					nomineeDetailsVm.appointeeDob1 = date;
				},

				dateFormat: 'dd MMM yyyy',
				closeOnSelect: false,
				templateType: 'popup',
				to: (new Date().setYear(new Date().getFullYear() - 18)),
				from: (new Date().setYear(new Date().getFullYear() - 120))
			};

        // nomineeDetailsVm.openDatePicker = {
		// 		callback: function (val) {
		// 			var date = $filter('date')(new Date(val), 'MM/dd/yyyy');
		// 			nomineeDetailsVm.nomineeDob = date;
		// 			nomineeDetailsVm.checkMinor();
		// 		},
		// 		dateFormat: 'MM/dd/yyyy',
		// 		closeOnSelect: false,
		// 		templateType: 'popup',
		// 		to: new Date(),
		// 		from: (new Date().setYear(new Date().getFullYear() - 120))
		// 	};


        function validateForm() {
            nomineeDetailsVm.rrNomineeDetailsForm = {};
            nomineeDetailsVm.rrNomineeAddForm = {};
            nomineeDetailsVm.rrAppointeeDetailsForm = {};

            if(nomineeDetailsVm.title){
                if(!nomineeDetailsVm.title.key){
                    nomineeDetailsVm.rrNomineeDetailsForm.title = 'Please select Title'
                }                 
            }
            if(!nomineeDetailsVm.firstName){
                nomineeDetailsVm.rrNomineeDetailsForm.firstName = 'Please enter First Name'
            }else if(nomineeDetailsVm.validateService.isValidName(nomineeDetailsVm.firstName)) {
                 nomineeDetailsVm.rrNomineeDetailsForm.firstName = nomineeDetailsVm.validateService.isValidName(nomineeDetailsVm.firstName);
            }
            if(!nomineeDetailsVm.lastName){
                nomineeDetailsVm.rrNomineeDetailsForm.lastName = 'Please enter Last Name'
            }else if (nomineeDetailsVm.validateService.isValidName(nomineeDetailsVm.lastName)) {
                 nomineeDetailsVm.rrNomineeDetailsForm.lastName = nomineeDetailsVm.validateService.isValidName(nomineeDetailsVm.lastName);
            }
            if(!nomineeDetailsVm.nomineeDob){
                nomineeDetailsVm.rrNomineeDetailsForm.nomineeDob = 'Please select Date of Birth'
            }else if(nomineeDetailsVm.validateService.isValidDateOfBirth(nomineeDetailsVm.nomineeDob)) {
                nomineeDetailsVm.rrNomineeDetailsForm.nomineeDob = nomineeDetailsVm.validateService.isValidDateOfBirth(nomineeDetailsVm.nomineeDob);
            } 
            if(nomineeDetailsVm.relApplicant){
                if(!nomineeDetailsVm.relApplicant.key){
                    nomineeDetailsVm.rrNomineeDetailsForm.relApplicant = 'Please select Relationship'
                }                
            }

            
            if(!nomineeDetailsVm.isChecked){
                if(!nomineeDetailsVm.flatName){
                    nomineeDetailsVm.rrNomineeAddForm.flatName = 'Please enter Flat/House No./Floor/Building'
                }
                if(!nomineeDetailsVm.streetName){
                    nomineeDetailsVm.rrNomineeAddForm.streetName = 'Please enter Colony/Street/Locality'
                }
                // if(!nomineeDetailsVm.landmarkName){
                //     nomineeDetailsVm.rrNomineeAddForm.landmarkName = 'Please enter Landmark'
                // }
                if(!nomineeDetailsVm.pinCode){
                    nomineeDetailsVm.rrNomineeAddForm.pinCode = 'Please enter Pin Code'
                }else if(nomineeDetailsVm.validateService.isValidPincode(nomineeDetailsVm.pinCode)){
                    nomineeDetailsVm.rrNomineeAddForm.pinCode = nomineeDetailsVm.validateService.isValidPincode(nomineeDetailsVm.pinCode);
                }

                if(!nomineeDetailsVm.city){
                    nomineeDetailsVm.rrNomineeAddForm.city = 'Please enter City'
                }
                if(!nomineeDetailsVm.state){
                    nomineeDetailsVm.rrNomineeAddForm.state = 'Please enter State'
                }
            }
                 
            if(nomineeDetailsVm.minorFlag1!=0){
                if(nomineeDetailsVm.appointeeTitle){
                    if(!nomineeDetailsVm.appointeeTitle.key){
                         nomineeDetailsVm.rrAppointeeDetailsForm.appointeeTitle = 'Please select Title'
                    }                    
                }

                if(!nomineeDetailsVm.appointeefirstName){
                    nomineeDetailsVm.rrAppointeeDetailsForm.appointeefirstName = 'Please enter First Name'
                }else if(nomineeDetailsVm.validateService.isValidName(nomineeDetailsVm.appointeefirstName)) {
                    nomineeDetailsVm.rrNomineeDetailsForm.appointeefirstName = nomineeDetailsVm.validateService.isValidName(nomineeDetailsVm.appointeefirstName);
                }

                if(!nomineeDetailsVm.appointeelastName){
                    nomineeDetailsVm.rrAppointeeDetailsForm.appointeelastName = 'Please enter Last Name'
                }else if(nomineeDetailsVm.validateService.isValidName(nomineeDetailsVm.appointeelastName)) {
                    nomineeDetailsVm.rrNomineeDetailsForm.appointeelastName = nomineeDetailsVm.validateService.isValidName(nomineeDetailsVm.appointeelastName);
                }

                if(!nomineeDetailsVm.appointeeDob1){
                    nomineeDetailsVm.rrAppointeeDetailsForm.appointeeDob1 = 'Please select Date of Birth'
                }else if(nomineeDetailsVm.validateService.isValidDateOfBirth(nomineeDetailsVm.appointeeDob1)) {
                    nomineeDetailsVm.rrNomineeDetailsForm.appointeeDob1 = nomineeDetailsVm.validateService.isValidDateOfBirth(nomineeDetailsVm.appointeeDob1);
                }

                if(nomineeDetailsVm.appointeeRelation){
                    if(!nomineeDetailsVm.appointeeRelation.key){
                         nomineeDetailsVm.rrAppointeeDetailsForm.appointeeRelation = 'Please select Relationship';
                    }
                }
            }

                nomineeDetailsVm.retValue1 =  (angular.equals({}, nomineeDetailsVm.rrAppointeeDetailsForm)) ? true : false;
                nomineeDetailsVm.retValue2 =  (angular.equals({}, nomineeDetailsVm.rrNomineeAddForm)) ? true : false;
                nomineeDetailsVm.retValue3 =  (angular.equals({}, nomineeDetailsVm.rrNomineeDetailsForm)) ? true : false;
                if(nomineeDetailsVm.retValue1 == true && nomineeDetailsVm.retValue2 == true && nomineeDetailsVm.retValue3 == true){
                    return true;
                }
            }

            

            nomineeDetailsVm.getPinDataCust = function (pinCode) {
                if(nomineeDetailsVm.isChecked){
                    if(pinCode.length == 6){
                    var inputparams = {
				    "pinCode" : pinCode
                    }                    
                    rrService.getPostalDetailByPincode(inputparams).then(function(data) {                        
                            nomineeDetailsVm.custAreaDetailsList = data[0];
                            nomineeDetailsVm.custCity =  nomineeDetailsVm.custAreaDetailsList.cityName;
                            nomineeDetailsVm.custCityCode =  nomineeDetailsVm.custAreaDetailsList.cityCode;
                            nomineeDetailsVm.custState =  nomineeDetailsVm.custAreaDetailsList.stateName;
                            nomineeDetailsVm.custStateCode =  nomineeDetailsVm.custAreaDetailsList.stateCode;
                            rrService.saveData.application.app.personal.address.state = nomineeDetailsVm.custStateCode; 
                            rrService.saveData.application.app.personal.address.city = nomineeDetailsVm.custCityCode;
                    }, function(error) {
                        if(error.responseCode == '2001'){
                        utilityService.showErrorMessage("Invalid Pincode");    
                        }else{
                        utilityService.showErrorMessage(error.responseMessage);    
                        }
                        
                    });
                    
                    }
                }
			}


        //Function for close view
        nomineeDetailsVm.closeView = function () {
          homeScreenService.ishamburgerMenuRO=false;
          homeScreenService.isInsuranceFlag = true;
          getAccountDetailsService.tabIndex.tabIndex=4;
          $state.go('menu.accountOverviewMyBalance');
        }

        nomineeDetailsVm.onKeyUp = function(){
            $scope.isINR = true;
        }

        //onclick of Back button
        nomineeDetailsVm.goBacktoPrevious = function () {
            if(nomineeDetailsVm.showSave == true){
                $state.go('menu.rrReviewDetails');
            }else{
                $state.go('menu.rrPersonalDetails');
            }
           
        };

        //onclick of next button
        nomineeDetailsVm.goToNextPage = function () {

             if(validateForm()){

                // if(nomineeDetailsVm.title){
                //     angular.forEach(nomineeDetailsVm.masterDataList.salutations, function (value, key) {
				// 			if (value == nomineeDetailsVm.title) {
				// 			rrService.saveData.application.app.nominee.title = key;	 
				// 			}
				// 		});
                // }else{
                //     rrService.saveData.application.app.nominee.title = '';
                // }
                // if(nomineeDetailsVm.appointeeTitle){
                //     angular.forEach(nomineeDetailsVm.masterDataList.salutations, function (value, key) {
				// 			if (value == nomineeDetailsVm.appointeeTitle) {
				// 			rrService.saveData.application.app.appointee.title = key;	 
				// 			}
				// 		});
                // }else{
                //     rrService.saveData.application.app.appointee.title = '';
                // }

                rrService.saveData.application.app.nominee.title = nomineeDetailsVm.title ? nomineeDetailsVm.title.value:"";	
                rrService.saveData.application.app.nominee.firstName = nomineeDetailsVm.firstName ? nomineeDetailsVm.firstName : "";
                rrService.saveData.application.app.nominee.lastName = nomineeDetailsVm.lastName ? nomineeDetailsVm.lastName : "";
                rrService.saveData.application.app.nominee.dob = nomineeDetailsVm.nomineeDob ? nomineeDetailsVm.nomineeDob :"";
                rrService.saveData.application.app.nominee.isMinor = nomineeDetailsVm.minorFlag1 ? nomineeDetailsVm.minorFlag1.toString() : "";
                rrService.saveData.application.app.nominee.sameApplAddress = nomineeDetailsVm.isChecked ? 'true' : 'false';
                rrService.saveData.application.app.nominee.relation = nomineeDetailsVm.relApplicant ? nomineeDetailsVm.relApplicant.key : "";
                if(rrService.saveData.application.app.nominee.sameApplAddress == 'true'){

                    if(nomineeDetailsVm.customerInformation.addressLine1){
                      rrService.saveData.application.app.nominee.address.building = nomineeDetailsVm.customerInformation.address.split(',')[0];
                    }else{
                         rrService.saveData.application.app.nominee.address.building = '';
                    }
                    rrService.saveData.application.app.nominee.address.landMark = nomineeDetailsVm.customerInformation.addressLine2 ? nomineeDetailsVm.customerInformation.address.split(',')[1] : "";
                    rrService.saveData.application.app.nominee.address.locality = nomineeDetailsVm.customerInformation.addressLine3 ? nomineeDetailsVm.customerInformation.address.split(',')[2] : "";
                    rrService.saveData.application.app.nominee.address.pincode = nomineeDetailsVm.customerInformation.pinCode ? nomineeDetailsVm.customerInformation.pinCode : "";
                    rrService.saveData.application.app.nominee.address.city = nomineeDetailsVm.custCityCode ? nomineeDetailsVm.custCityCode : "";
                    rrService.saveData.application.app.nominee.address.state =  nomineeDetailsVm.custStateCode ?  nomineeDetailsVm.custStateCode : "";
                }else{
                    rrService.saveData.application.app.nominee.address.building = nomineeDetailsVm.flatName ? nomineeDetailsVm.flatName : "";
                    rrService.saveData.application.app.nominee.address.landMark = nomineeDetailsVm.landmarkName ? nomineeDetailsVm.landmarkName : "";
                    rrService.saveData.application.app.nominee.address.locality = nomineeDetailsVm.streetName ? nomineeDetailsVm.streetName : "";
                    rrService.saveData.application.app.nominee.address.pincode = nomineeDetailsVm.pinCode ? nomineeDetailsVm.pinCode : "";
                    rrService.saveData.application.app.nominee.address.city = nomineeDetailsVm.city ? nomineeDetailsVm.city : "";
                    rrService.saveData.application.app.nominee.address.state = nomineeDetailsVm.state ? nomineeDetailsVm.state : "";
                }
                

                //rrService.saveData.application.app.appointee.title = nomineeDetailsVm.appointeeTitle ? nomineeDetailsVm.appointeeTitle : "";
                rrService.saveData.application.app.appointee.title = nomineeDetailsVm.appointeeTitle ? nomineeDetailsVm.appointeeTitle.value:"";
                rrService.saveData.application.app.appointee.firstName = nomineeDetailsVm.appointeefirstName ? nomineeDetailsVm.appointeefirstName : "";
                rrService.saveData.application.app.appointee.lastName = nomineeDetailsVm.appointeelastName ? nomineeDetailsVm.appointeelastName : "";
                rrService.saveData.application.app.appointee.dob = nomineeDetailsVm.appointeeDob1 ? nomineeDetailsVm.appointeeDob1 : "";
                rrService.saveData.application.app.appointee.relation = nomineeDetailsVm.appointeeRelation ? nomineeDetailsVm.appointeeRelation.key : "";
                
                if(nomineeDetailsVm.showSave == true){
                    rrService.saveData.application.app.pageNo = 5;
                }else{
                    rrService.saveData.application.app.pageNo = 3;
                }

                rrService.saveApplication().then(function (data) {
                        utilityService.hideSpinner();    
                        //$state.go('menu.rrReviewDetails');  
                        if(nomineeDetailsVm.showSave == true){
                            $state.go('menu.rrReviewDetails');
                        }else{
                            $state.go('menu.rinQuestionsAns');
                        }
                          
                    }, function (error) {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                    });  
                
            // $state.go('menu.rinQuestionsAns'); 
             }             
        }

         nomineeDetailsVm.getFormattedDate = function (input) {
                var pattern=/(.*?)\/(.*?)\/(.*?)$/;
                var result = input.replace(pattern,function(match,p2,p1,p3){
                    var months=["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"];
                    return (p2<10?"0"+p2:p2)+" "+months[(p1-1)]+" "+p3;
                });
                return result;
               
          }

        nomineeDetailsVm.fetchNomineeDetails = function () {
            utilityService.showSpinner(); 
            rrService.fetchNomineeDetails().then(function(data){   
                    utilityService.hideSpinner();       
                    if(data){
                        if(data.name){                      
                        nomineeDetailsVm.firstName = data.name.split(' ')[0];
                        nomineeDetailsVm.lastName = data.name.substring(nomineeDetailsVm.firstName.length).trim();
                        }  
                        if(data.dob){

                            nomineeDetailsVm.nomineeDob = nomineeDetailsVm.getFormattedDate(data.dob);

                        }                    
                        if(data.minor.toLowerCase() == 'y'){
                            nomineeDetailsVm.minorFlag1 = 1;
                        }  
                        //nomineeDetailsVm.relApplicantCheck = data.relationship ? data.relationship : "";      
                        if(data.guardianName){
                            nomineeDetailsVm.appointeefirstName = data.guardianName.split(' ')[0];
                            nomineeDetailsVm.appointeelastName = data.guardianName.substring(nomineeDetailsVm.appointeefirstName.length).trim();
                        }
                    }             
                    },function(error){
                        utilityService.hideSpinner();                          
                        utilityService.showErrorMessage(error.responseMessage);
                        
                    })
         } 

      

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
           
        });


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            // nomineeDetailsVm.getMaster();
            initPage();            
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
