'use strict';

angularApp.controller('personalDetailsController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "getAccountDetailsService",
    "utilityService",
    "homeScreenService",
    "$ionicPopup",
    "$rootScope",
    "$filter",
    "rrService",
    "validateService",
    "$stateParams",
    "$ionicScrollDelegate",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        getAccountDetailsService,
        utilityService,
        homeScreenService,
        $ionicPopup,
        $rootScope,
        $filter,
        rrService,
        validateService,
        $stateParams,
        $ionicScrollDelegate
    ) {

        var personalDetailsVm = this;
        personalDetailsVm.rrPersonalDetailsForm = {};
        personalDetailsVm.isChallenged = false;
        personalDetailsVm.isValidAccount = false;
        personalDetailsVm.validAccountMessage = "";
        personalDetailsVm.disablenext = false;
        $scope.isINR = false;
        personalDetailsVm.validateService = validateService;


        function initPage() {
            personalDetailsVm.edit = $stateParams.termsObj;            
            if(personalDetailsVm.edit == 'All'){
            personalDetailsVm.showBack = false;
            personalDetailsVm.showCancel = true;
            personalDetailsVm.showNext = false;
            personalDetailsVm.showSave = true;
            }else{
            personalDetailsVm.showBack = true;
            personalDetailsVm.showNext = true;
            personalDetailsVm.showSave = false;
            personalDetailsVm.showCancel = false;
            }
            personalDetailsVm.pdOccu={key:"", value:""};
            personalDetailsVm.PdNatureOfCompany={key:"", value:""};
            personalDetailsVm.title={key:"", value:""};
            personalDetailsVm.ycchannel=requestYCService.ycchannel
            personalDetailsVm.hideCompDesg = false;
            personalDetailsVm.disableOccu = false;
            // personalDetailsVm.showBack = true;
            // personalDetailsVm.showNext = true;
            personalDetailsVm.payingFrom = getAccountDetailsService.accountOverviewData.accounts;
            personalDetailsVm.accDetails = [];
            personalDetailsVm.accDetails = personalDetailsVm.payingFrom;
            personalDetailsVm.selectedAccount = requestYCService.selectedAccValue == null ? "" : JSON.stringify(requestYCService.selectedAccValue);
            personalDetailsVm.showSelect = true;
            personalDetailsVm.gonextPg = false;
            personalDetailsVm.isMasked = true;
            personalDetailsVm.isMaskedEmail = true;
            personalDetailsVm.isMaskedMob = true;
            personalDetailsVm.isMaskedDOB = true;
            personalDetailsVm.isEducationloan = false;
            
            personalDetailsVm.inputImg = "img/Visibility_off.svg";
            personalDetailsVm.inputImgMob = "img/Visibility_off.svg";
            personalDetailsVm.inputImgDOB = "img/Visibility_off.svg";
            
            personalDetailsVm.inputImgEmail = "img/Visibility_off.svg";
            personalDetailsVm.emailInputType = "password";
			personalDetailsVm.emailInputImg = "img/Visibility_off.svg";

            personalDetailsVm.professionalDetails = {};
            personalDetailsVm.occupation = rrService.getParams().occupation;
            personalDetailsVm.isMaskedTotal = true;           
        

            
            personalDetailsVm.customerInformation=getAccountDetailsService.accountOverviewData.customerInformation; 

            personalDetailsVm.maskedPersonalDOB = personalDetailsVm.customerInformation.dob.substring(0, personalDetailsVm.customerInformation.dob.length - 4)  + 'XXXX';
            //personalDetailsVm.customerInformation.emailID = 'anupamsarfare@gmail.com';
            //personalDetailsVm.email = personalDetailsVm.customerInformation.emailID;
            personalDetailsVm.totPremAmt = rrService.premiumDetails.totPremAmt;

            

            var professionalDetails = rrService.getParams().professionalDetails1;
            if (professionalDetails) {
                personalDetailsVm.professionalDetails = professionalDetails;
            }

            

             //personalDetailsVm.customerInformation.title = rrService.saveData.application.app.personal.title ? rrService.saveData.application.app.personal.title : personalDetailsVm.customerInformation.title;



             personalDetailsVm.customerInformation.firstName = rrService.saveData.application.app.personal.firstName ? rrService.saveData.application.app.personal.firstName : personalDetailsVm.customerInformation.firstName;
             personalDetailsVm.customerInformation.lastName = rrService.saveData.application.app.personal.lastName ? rrService.saveData.application.app.personal.lastName : personalDetailsVm.customerInformation.lastName;
             personalDetailsVm.customerInformation.dob = rrService.saveData.application.app.personal.dob ? rrService.saveData.application.app.personal.dob : personalDetailsVm.customerInformation.dob;
             personalDetailsVm.customerInformation.mobile = rrService.saveData.application.app.personal.mobile ? rrService.saveData.application.app.personal.mobile : personalDetailsVm.customerInformation.mobile;
             personalDetailsVm.customerInformation.panNumber = rrService.saveData.application.app.personal.pan ? rrService.saveData.application.app.personal.pan : personalDetailsVm.customerInformation.panNumber;


             personalDetailsVm.customerInformation.addressLine1 = rrService.saveData.application.app.personal.address.building ? rrService.saveData.application.app.personal.address.building : personalDetailsVm.customerInformation.addressLine1;
             personalDetailsVm.customerInformation.addressLine2 = rrService.saveData.application.app.personal.address.locality ? rrService.saveData.application.app.personal.address.locality : personalDetailsVm.customerInformation.addressLine2;
             personalDetailsVm.customerInformation.addressLine2 = rrService.saveData.application.app.personal.address.landMark ? rrService.saveData.application.app.personal.address.landMark : personalDetailsVm.customerInformation.addressLine3;
             personalDetailsVm.customerInformation.pinCode = rrService.saveData.application.app.personal.address.pinCode ? rrService.saveData.application.app.personal.address.pinCode : personalDetailsVm.customerInformation.pinCode;

             if(personalDetailsVm.customerInformation.pinCode){
                personalDetailsVm.getPinData(personalDetailsVm.customerInformation.pinCode);
            }

             //personalDetailsVm.email = rrService.saveData.application.app.personal.email ? rrService.saveData.application.app.personal.email : "";     

             if(personalDetailsVm.showSave){
                personalDetailsVm.email = rrService.saveData.application.app.personal.email 
                personalDetailsVm.showInputEmail = true;
             }else{
                if(rrService.saveData.application.app.personal.email){
                 personalDetailsVm.email = rrService.saveData.application.app.personal.email
                 personalDetailsVm.emailMaskCheck(personalDetailsVm.email)
                 personalDetailsVm.showInputEmail = false;
             }else if(personalDetailsVm.customerInformation.emailID){
                 personalDetailsVm.email = personalDetailsVm.customerInformation.emailID                 
                 personalDetailsVm.emailMaskCheck(personalDetailsVm.email)
                 personalDetailsVm.showInputEmail = false;
             }else{
                 personalDetailsVm.showInputEmail = true;
                 personalDetailsVm.email = ''
             } 

             }

                  
             personalDetailsVm.fatherName = rrService.saveData.application.app.personal.spouse ? rrService.saveData.application.app.personal.spouse : personalDetailsVm.customerInformation.fatherName;

             
             personalDetailsVm.pdOccuCheck = rrService.saveData.application.app.professional.occupation ? rrService.saveData.application.app.professional.occupation : "";
             personalDetailsVm.titleCheck = rrService.saveData.application.app.personal.title ? rrService.saveData.application.app.personal.title : ""; 


             
             
						

             personalDetailsVm.professionalDetails.companyName = rrService.saveData.application.app.professional.company ? rrService.saveData.application.app.professional.company : "";
             personalDetailsVm.professionalDetails.designation = rrService.saveData.application.app.professional.desig ? rrService.saveData.application.app.professional.desig : "";
             personalDetailsVm.PdNatureOfCompanyCheck = rrService.saveData.application.app.professional.companyNature ? rrService.saveData.application.app.professional.companyNature : "";
             if(rrService.saveData.application.app.professional.occupation == 'Student'){
                 rrService.loanTypeInfo = 'Education Loan';
             }  
             // check loan type
             //if loan



            personalDetailsVm.ttlpremium = rrService.premiumDetails.totPremAmt;
            personalDetailsVm.basePremAmt = rrService.premiumDetails.basePremAmt;
            personalDetailsVm.quoteNo = rrService.premiumDetails.quoteNo;
            personalDetailsVm.taxAmt = rrService.premiumDetails.taxAmt;
            if(rrService.loanTypeInfo == 'Education Loan'){                
                personalDetailsVm.isEducationloan = true;
            }  
            personalDetailsVm.getMaster();   

            


        }

        personalDetailsVm.maskUnmask = function () {
        if(personalDetailsVm.isMasked == true){
            personalDetailsVm.isMasked = false ;
            personalDetailsVm.inputImg = "img/Visibility_on.svg"
        }else{
            personalDetailsVm.isMasked = true ;
            personalDetailsVm.inputImg = "img/Visibility_off.svg";
        }

        };

        personalDetailsVm.maskUnmaskMob = function () {
        if(personalDetailsVm.isMaskedMob == true){
            personalDetailsVm.isMaskedMob = false ;
            personalDetailsVm.inputImgMob = "img/Visibility_on.svg";
        }else{
            personalDetailsVm.isMaskedMob = true ;
            personalDetailsVm.inputImgMob = "img/Visibility_off.svg";
        }
    };
    

    personalDetailsVm.maskUnmaskDOB = function () {        
        if(personalDetailsVm.isMaskedDOB == true){
            personalDetailsVm.isMaskedDOB = false ;
            personalDetailsVm.inputImgDOB = "img/Visibility_on.svg";
        }else{
            personalDetailsVm.isMaskedDOB = true ;
            personalDetailsVm.inputImgDOB = "img/Visibility_off.svg";
        }
        };
    
        personalDetailsVm.hideshowTotal = function () {
        personalDetailsVm.isMaskedTotal == true ? (personalDetailsVm.isMaskedTotal = false) : (personalDetailsVm.isMaskedTotal = true);
        $ionicScrollDelegate.$getByHandle('personalDetailsData').scrollBottom();
        };
    

        // personalDetailsVm.maskUnmaskEmail = function (emailid) {
            
        //  personalDetailsVm.isMaskedEmail == true ? (personalDetailsVm.isMaskedEmail = false , personalDetailsVm.inputImgEmail = "img/Visibility_on.svg") : (personalDetailsVm.isMaskedEmail = true , personalDetailsVm.inputImgEmail = "img/Visibility_off.svg");
        //     if(personalDetailsVm.isMaskedEmail == true){
        //     personalDetailsVm.emailMaskCheck(personalDetailsVm.customerInformation.emailID)
        //     }else{
        //     personalDetailsVm.email = personalDetailsVm.customerInformation.emailID;
        //     }
        // };

        personalDetailsVm.emailMaskUnmask = function (param) {
                    //personalDetailsVm.emailInputType == "password" ? (personalDetailsVm.emailInputType = "text" , personalDetailsVm.emailInputImg = "img/Visibility_on.svg") : (personalDetailsVm.emailInputType = "password" , personalDetailsVm.emailInputImg = "img/Visibility_off.svg");
                    //personalDetailsVm.emailInputType == "password" ? (personalDetailsVm.emailInputType = "text" , personalDetailsVm.emailInputImg = "img/Visibility_on.svg") : (personalDetailsVm.emailInputType = "password" , personalDetailsVm.emailInputImg = "img/Visibility_off.svg");
                    
                    if(personalDetailsVm.isMaskedEmail == true){
                        personalDetailsVm.isMaskedEmail = false ;
                        personalDetailsVm.emailInputImg = "img/Visibility_on.svg";         
                        personalDetailsVm.emailMask = personalDetailsVm.email;               
                    }else{
                        personalDetailsVm.isMaskedEmail = true ;
                        personalDetailsVm.emailInputImg = "img/Visibility_off.svg"
                        personalDetailsVm.emailMaskCheck(personalDetailsVm.email)
                        
                    }
                };
    

        personalDetailsVm.emailMaskCheck = function(email){
			var arr = email.split("@");
			var firstDotIndex = arr[1].indexOf('.');
 			var emailFirstPart = arr[1].substring(0, firstDotIndex);
 			var emailSecondPart = arr[1].substring(firstDotIndex + 1);
			 personalDetailsVm.emailMask=personalDetailsVm.maskEmail2(arr[0]) + "@" + personalDetailsVm.maskEmail(emailFirstPart)+"."+emailSecondPart;
		}

        personalDetailsVm.clearfields = function(){
			personalDetailsVm.professionalDetails.otherOccupation = '';
            personalDetailsVm.professionalDetails.companyName = '';
            personalDetailsVm.professionalDetails.designation = '';
            personalDetailsVm.PdNatureOfCompany = "";

            if(personalDetailsVm.pdOccu.value != 'Defence' && personalDetailsVm.pdOccu.value != 'Business'){
                angular.forEach(personalDetailsVm.masterDataList.natureOfOrg , function (value, key) {                                       
                                        if (value.key == 'Others') {                                            
                                            personalDetailsVm.masterDataList.natureOfOrgNew = value.value;
                                        }                                     
                                        
                                    }); 
            }else{
                angular.forEach(personalDetailsVm.masterDataList.natureOfOrg , function (value, key) {                 
                    if(value.key == personalDetailsVm.pdOccu.value ){
                        personalDetailsVm.masterDataList.natureOfOrgNew = value.value;
                    }                                       
                });   
            }

             
                
		}

        personalDetailsVm.maskEmail = function (str) {
		 return str[0] + "x".repeat(str.length - 2) + str.slice(-1);
		}
		personalDetailsVm.maskEmail2 = function (str) {
        return str[0] + "x".repeat(str.length - 2) + str[str.length - 1] ;  
		}

         personalDetailsVm.getMaster = function () {
            utilityService.showSpinner();    
            console.log("get master hit");           
            rrService.getMedicalQuestions().then(function(data){    
                        console.log("get master success");
                        utilityService.hideSpinner();                    
                        personalDetailsVm.masterDataList=JSON.parse(data.content).content.appMaster;    
                        console.log('master data det '+ JSON.stringify(personalDetailsVm.masterDataList));                   

                            angular.forEach(personalDetailsVm.masterDataList.natureOfOrg , function (value, key) {                                       
                                        if (value.key == 'Others') {                                            
                                            personalDetailsVm.masterDataList.natureOfOrgNew = value.value;
                                        }                                     
                                        
                                    });                    




                        if(personalDetailsVm.titleCheck){
                            angular.forEach(personalDetailsVm.masterDataList.salutations, function (value, key) {
                                        if (value.key == personalDetailsVm.titleCheck) {
                                            personalDetailsVm.title.key = value.key;
                                            personalDetailsVm.title.value = value.value;
                                        }
                                    });
                        }

                        if(rrService.saveData.application.app.personal.title){        
                           if(personalDetailsVm.titleCheck){
                             angular.forEach(personalDetailsVm.masterDataList.salutations, function (value, key) {                                      
                                        if (value.value == personalDetailsVm.titleCheck) {
                                            personalDetailsVm.title.key = value.key;
                                            personalDetailsVm.title.value = value.value;
                                        }
                                    });
                            }
                        }else{
                            if(personalDetailsVm.customerInformation.title){
                                angular.forEach(personalDetailsVm.masterDataList.salutations, function (value, key) {
                                    if (value.key == personalDetailsVm.customerInformation.title) {
                                        personalDetailsVm.title.key = value.key;
                                        personalDetailsVm.title.value = value.value;
                                    }
                                }); 
                            }
                        }

                        if(personalDetailsVm.pdOccuCheck){
                            angular.forEach(personalDetailsVm.masterDataList.occupations, function (value, key) {
                                        if (value.key == personalDetailsVm.pdOccuCheck) {
                                            personalDetailsVm.pdOccu.key = value.key;
                                            personalDetailsVm.pdOccu.value = value.value;
                                        }
                                    });


                            if(personalDetailsVm.pdOccu.value=="Others"){
                                personalDetailsVm.professionalDetails.otherOccupation = rrService.saveData.application.app.professional.otherOccupation;
                            }  
                            if(rrService.loanTypeInfo == 'Education Loan'){
                            personalDetailsVm.pdOccu.value = 'Student';
                            personalDetailsVm.pdOccu.key = 'Student';
                            }       
                        }
                        if(personalDetailsVm.PdNatureOfCompanyCheck){
                           

                            angular.forEach(personalDetailsVm.masterDataList.natureOfOrg , function (value, key) {                                       
                                if (value.key == personalDetailsVm.pdOccuCheck) {               
                                    personalDetailsVm.orgTempKey = value.key
                                    personalDetailsVm.masterDataList.natureOfOrgNew = value.value

                                }  
                            }); 
                            angular.forEach(personalDetailsVm.masterDataList.natureOfOrgNew , function (value, key) {                                       
                                if (value.key == personalDetailsVm.PdNatureOfCompanyCheck) {                                            
                                    personalDetailsVm.PdNatureOfCompany.key = value.key;
                                    personalDetailsVm.PdNatureOfCompany.value = value.value;
                                                                                
                                }                                               
                                
                            });           
                        }                                  
                        
                    },function(error){
                        console.log("get master fails");
                        utilityService.hideSpinner();
                        personalDetailsVm.dataList=error.tabs;
                        utilityService.showErrorMessage(error.responseMessage);
                        
                    })
         }        

   
		

        function validateForm() {
           
            personalDetailsVm.rrPersonalDetailsForm = {};     

            if(personalDetailsVm.email){
                if(personalDetailsVm.validateService.isValidEmail(personalDetailsVm.email)) {
                personalDetailsVm.rrPersonalDetailsForm.email = personalDetailsVm.validateService.isValidEmail(personalDetailsVm.email);
                }
            }
            if(!personalDetailsVm.fatherName){
                personalDetailsVm.rrPersonalDetailsForm.fatherName = "Please enter Father / Spouse Name";
            }else if (personalDetailsVm.validateService.isValidFatherName(personalDetailsVm.fatherName)) {
                personalDetailsVm.rrPersonalDetailsForm.fatherName = personalDetailsVm.validateService.isValidFatherName(personalDetailsVm.fatherName);
            }
            if(!personalDetailsVm.pdOccu.value){
                personalDetailsVm.rrPersonalDetailsForm.pdOccu = "Please select Occupation";
            }
            
            if(personalDetailsVm.showSave == true){
                if(!personalDetailsVm.title.value){
                personalDetailsVm.rrPersonalDetailsForm.title = "Please select Title";
                }
            }
            

            if(personalDetailsVm.pdOccu.value.toLowerCase() == 'salaried'){
                if(!personalDetailsVm.professionalDetails.companyName){
                personalDetailsVm.rrPersonalDetailsForm.companyName = "Please enter Company Name";
                }else if (personalDetailsVm.validateService.isValidCompanyName(personalDetailsVm.professionalDetails.companyName)) {
                    personalDetailsVm.rrPersonalDetailsForm.companyName = personalDetailsVm.validateService.isValidCompanyName(personalDetailsVm.professionalDetails.companyName);
                }
                if(!personalDetailsVm.professionalDetails.designation){
                    personalDetailsVm.rrPersonalDetailsForm.designation = "Please enter Designation";
                }else if(personalDetailsVm.validateService.isValidDesignation(personalDetailsVm.professionalDetails.designation)) {
                    personalDetailsVm.rrPersonalDetailsForm.designation = personalDetailsVm.validateService.isValidDesignation(personalDetailsVm.professionalDetails.designation);
                }
                if(!personalDetailsVm.PdNatureOfCompany.value){
                    personalDetailsVm.rrPersonalDetailsForm.PdNatureOfCompany = "Please select Nature Of Duties";
                } 

            }else if(personalDetailsVm.pdOccu.value.toLowerCase() == 'business'){
                if(!personalDetailsVm.professionalDetails.companyName){
                personalDetailsVm.rrPersonalDetailsForm.companyName = "Please enter Company Name";
                }else if (personalDetailsVm.validateService.isValidCompanyName(personalDetailsVm.professionalDetails.companyName)) {
                    personalDetailsVm.rrPersonalDetailsForm.companyName = personalDetailsVm.validateService.isValidCompanyName(personalDetailsVm.professionalDetails.companyName);
                }
                if(!personalDetailsVm.PdNatureOfCompany.value){
                    personalDetailsVm.rrPersonalDetailsForm.PdNatureOfCompany = "Please select Nature Of Duties";
                } 
            }

            if(personalDetailsVm.pdOccu){
                if(personalDetailsVm.pdOccu.value == "Others"){
                    if(!personalDetailsVm.professionalDetails.otherOccupation){
                        personalDetailsVm.rrPersonalDetailsForm.otherOccupation = "Please enter Others Description";
                        
                    }
                }
            }

            if(rrService.loanTypeInfo == 'Education Loan'){
                personalDetailsVm.pdOccu.value = 'Student';
                personalDetailsVm.pdOccu.key = 'Student';
                personalDetailsVm.professionalDetails.companyName = 'NA';
                personalDetailsVm.professionalDetails.designation = 'NA';
                personalDetailsVm.PdNatureOfCompany.value = ''
                personalDetailsVm.PdNatureOfCompany.key = '';
                if (personalDetailsVm.rrPersonalDetailsForm.pdOccu) {
                    delete personalDetailsVm.rrPersonalDetailsForm.pdOccu;
                }
                if (personalDetailsVm.rrPersonalDetailsForm.companyName) {
                    delete personalDetailsVm.rrPersonalDetailsForm.companyName;
                }
                if (personalDetailsVm.rrPersonalDetailsForm.designation) {
                    delete personalDetailsVm.rrPersonalDetailsForm.designation;
                }
                if (personalDetailsVm.rrPersonalDetailsForm.PdNatureOfCompany) {
                    delete personalDetailsVm.rrPersonalDetailsForm.PdNatureOfCompany;
                }
                
            }       

            
                       
            
                return (angular.equals({}, personalDetailsVm.rrPersonalDetailsForm)) ? true : false;
            }
      


        //Function for close view
        personalDetailsVm.closeView = function () {
          homeScreenService.ishamburgerMenuRO=false;
          homeScreenService.isInsuranceFlag = true;
          getAccountDetailsService.tabIndex.tabIndex=4;
          $state.go('menu.accountOverviewMyBalance');
        }

        personalDetailsVm.onKeyUp = function(){
            $scope.isINR = true;
        }

        //onclick of Back button
        personalDetailsVm.goBacktoPrevious = function () {            
            if(personalDetailsVm.showSave == true){
                $state.go('menu.rrReviewDetails');
            }else{
                $state.go('menu.rinnRaksha');
            }
        };

        //onclick of next button
        personalDetailsVm.goToNextPage = function () {
            if(validateForm()){ 

            //  if(rrService.saveData.application.app.personal.title){
            //     if(personalDetailsVm.title){
            //          rrService.saveData.application.app.professional.title = personalDetailsVm.title ? personalDetailsVm.title.value : "";
            //     }else{
            //         rrService.saveData.application.app.personal.title = '';
            //     } 
            //  }else{
            //     rrService.saveData.application.app.personal.title = personalDetailsVm.customerInformation.title ? personalDetailsVm.customerInformation.title : "";
            //  }   

             rrService.saveData.application.app.personal.title = personalDetailsVm.title ? personalDetailsVm.title.key : "";

               

             rrService.saveData.application.app.personal.firstName = personalDetailsVm.customerInformation.firstName ? personalDetailsVm.customerInformation.firstName : "";
             rrService.saveData.application.app.personal.lastName = personalDetailsVm.customerInformation.lastName ? personalDetailsVm.customerInformation.lastName : "";
             rrService.saveData.application.app.personal.dob = personalDetailsVm.customerInformation.dob ? personalDetailsVm.customerInformation.dob : "";
             rrService.saveData.application.app.personal.mobile = personalDetailsVm.customerInformation.mobile ? personalDetailsVm.customerInformation.mobile : "";
             rrService.saveData.application.app.personal.pan = personalDetailsVm.customerInformation.panNumber ? personalDetailsVm.customerInformation.panNumber : "";
             rrService.saveData.application.app.personal.gender = personalDetailsVm.customerInformation.gender ? personalDetailsVm.customerInformation.gender : "";
             rrService.saveData.application.app.personal.address.building = personalDetailsVm.customerInformation.addressLine1 ? personalDetailsVm.customerInformation.address.split(',')[0] : "";
             rrService.saveData.application.app.personal.address.locality = personalDetailsVm.customerInformation.addressLine2 ? personalDetailsVm.customerInformation.address.split(',')[1] : "";
             rrService.saveData.application.app.personal.address.landMark = personalDetailsVm.customerInformation.addressLine3 ? personalDetailsVm.customerInformation.address.split(',')[2] : "";

             rrService.saveData.application.app.personal.address.pincode = personalDetailsVm.customerInformation.pinCode ? personalDetailsVm.customerInformation.pinCode : "";
             rrService.saveData.application.app.personal.address.city = personalDetailsVm.city ? personalDetailsVm.city : "";
             rrService.saveData.application.app.personal.address.state =  personalDetailsVm.state ?  personalDetailsVm.state : "";

             rrService.saveData.application.app.personal.email = personalDetailsVm.email ? personalDetailsVm.email : ""; 
             rrService.saveData.application.app.personal.spouse = personalDetailsVm.fatherName ? personalDetailsVm.fatherName : "";
             rrService.saveData.application.app.professional.occupation = personalDetailsVm.pdOccu ? personalDetailsVm.pdOccu.key : "";
             rrService.saveData.application.app.professional.company = personalDetailsVm.professionalDetails.companyName ? personalDetailsVm.professionalDetails.companyName : "";
             rrService.saveData.application.app.professional.desig = personalDetailsVm.professionalDetails.designation ? personalDetailsVm.professionalDetails.designation : "";
             rrService.saveData.application.app.professional.companyNature = personalDetailsVm.PdNatureOfCompany ? personalDetailsVm.PdNatureOfCompany.value : "";
             rrService.saveData.application.app.professional.otherOccupation = personalDetailsVm.professionalDetails.otherOccupation ? personalDetailsVm.professionalDetails.otherOccupation : "";
            if(personalDetailsVm.showSave == true){
                    rrService.saveData.application.app.pageNo = 5;
                }else{
                    rrService.saveData.application.app.pageNo = 2;
                }
            
              rrService.saveApplication().then(function (data) {
                    utilityService.hideSpinner();    
                    console.log('Save Data Personal Details ' + JSON.stringify(data)); 
                    if(personalDetailsVm.showSave == true){
                         $state.go('menu.rrReviewDetails');
                    }else{
                        $state.go('menu.rrNomioneeDetails');
                    }
                    
                }, function (error) {
                    utilityService.hideSpinner();
                    utilityService.showErrorMessage(error.responseMessage);
                });  
            }

             //$state.go('menu.rinQuestionsAns');
             //$state.go('menu.rrNomioneeDetails');
        }
        
        personalDetailsVm.getPinData = function (pinCode) {
				
            if(pinCode.length == 6){
                var inputparams = {
                "pinCode" : pinCode
                }                    
                rrService.getPostalDetailByPincode(inputparams).then(function(data) {                        
                        personalDetailsVm.areaDetailsList = data;
                        personalDetailsVm.city =  personalDetailsVm.areaDetailsList[0].cityCode;
                        personalDetailsVm.state =  personalDetailsVm.areaDetailsList[0].stateCode;
                        if(rrService.saveData.application.app.personal.address.pincode){
                            for (var i in personalDetailsVm.areaDetailsList) {
                                    if (personalDetailsVm.areaDetailsList[i].city == rrService.saveData.application.app.personal.address.city) {
                                        personalDetailsVm.city = personalDetailsVm.areaDetailsList[i].cityCode
                                    }
                                    if (personalDetailsVm.areaDetailsList[i].state == rrService.saveData.application.app.personal.address.state) {
                                        personalDetailsVm.state = personalDetailsVm.areaDetailsList[i].stateCode
                                    }
                                }   
                        }
                        
                }, function(error) {
                    personalDetailsVm.areaDetailsList='';
                    personalDetailsVm.city = '';
                    personalDetailsVm.state = '';
                    if(error.responseCode == '2001'){
                    utilityService.showErrorMessage("Invalid Pincode");    
                    }else{
                    utilityService.showErrorMessage(error.responseMessage);   
                    }
                    
                });
                
            }


        }

        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            
        });
        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {   
                  
            initPage();                       
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
