'use strict';

angularApp.controller('rinQuestionsAnsController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "getAccountDetailsService",
    "utilityService",
    "homeScreenService",
    "$ionicPopup",
    "$rootScope",
    "$filter","rrService","$ionicSlideBoxDelegate","ionicDatePicker","$stateParams","validateService",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        getAccountDetailsService,
        utilityService,
        homeScreenService,
        $ionicPopup,
        $rootScope,
        $filter,
        rrService, $ionicSlideBoxDelegate,ionicDatePicker,$stateParams,validateService
    ) {       

        var rinQuestionsAnsVm = this;
        rinQuestionsAnsVm.natureOfIllnessContent = false;
        rinQuestionsAnsVm.testingYesClick=false;
        rinQuestionsAnsVm.femalesubContentYes = false;
        rinQuestionsAnsVm.saveTabed =false;
        rinQuestionsAnsVm.showBack = false;
        rinQuestionsAnsVm.showNext = false;
        rinQuestionsAnsVm.showSave = false; 
        rinQuestionsAnsVm.showCancel = false; 
        //$scope.slideIndex = 0;
               
        var questionsList = [];
        var reasonData = [];       
        function initPage() {
          rinQuestionsAnsVm.isMaskedTotal = true;
          rinQuestionsAnsVm.customerInformation=getAccountDetailsService.accountOverviewData.customerInformation; 
          rinQuestionsAnsVm.totPremAmt = rrService.premiumDetails.totPremAmt;

            rinQuestionsAnsVm.ttlpremium = rrService.premiumDetails.totPremAmt ? rrService.premiumDetails.totPremAmt:"";
            rinQuestionsAnsVm.basePremAmt = rrService.premiumDetails.basePremAmt ? rrService.premiumDetails.basePremAmt:"";
            rinQuestionsAnsVm.quoteNo = rrService.premiumDetails.quoteNo ? rrService.premiumDetails.quoteNo:"";
            rinQuestionsAnsVm.taxAmt = rrService.premiumDetails.taxAmt ? rrService.premiumDetails.taxAmt:"";

          rinQuestionsAnsVm.getMedicalQuestions();               
          rinQuestionsAnsVm.treatmenttxt = 'Have you suffered from / been treated / hospitalized for or diagnosed to have-';                  
            
               
        }
        function showBanner(index) {
          
          if (index > 0) {
            $scope.whatever = 'not-first-slide';
          }
          else {
            $scope.whatever = '';
          }
    }
    $scope.slideChanged = showBanner;
         rinQuestionsAnsVm.hideshowTotal = function () {
             rinQuestionsAnsVm.isMaskedTotal == true ? (rinQuestionsAnsVm.isMaskedTotal = false) : (rinQuestionsAnsVm.isMaskedTotal = true);
             //$ionicScrollDelegate.$getByHandle('medicalFooter').scrollBottom();
        };

        rinQuestionsAnsVm.getMedicalQuestions = function(){
         rrService.getMedicalQuestions().then(function(data){
                    rinQuestionsAnsVm.dataList=JSON.parse(data.content).content.healthQues;
                    rinQuestionsAnsVm.navigate();
                 },function(error){
                     rinQuestionsAnsVm.dataList=error.tabs;
                     rinQuestionsAnsVm.navigate();
                 })
         }
     
         rinQuestionsAnsVm.navigate = function(){
              if($stateParams.termsObj=='review_back'){
                  if(rinQuestionsAnsVm.customerInformation.gender.toLowerCase()!='female'){
                     rinQuestionsAnsVm.mainTab = 1;
                    rinQuestionsAnsVm.mainTabSub = 0;
                    rinQuestionsAnsVm.isEdit=false; 
                     rinQuestionsAnsVm.setActive('Habits');
                  }else{
                     rinQuestionsAnsVm.mainTab = 1;
                    rinQuestionsAnsVm.mainTabSub = 0;
                    rinQuestionsAnsVm.isEdit=false; 
                     rinQuestionsAnsVm.setActive('Female');
                   }
                }else if($stateParams.termsObj){
                    rinQuestionsAnsVm.mainTabSub = 1;
                    rinQuestionsAnsVm.mainTab = 0;
                    rinQuestionsAnsVm.isEdit=true;
                    rinQuestionsAnsVm.active=$stateParams.termsObj;
                    rinQuestionsAnsVm.setActive(rinQuestionsAnsVm.active);
                     
                }else if(rinQuestionsAnsVm.isTopBack){
                    rinQuestionsAnsVm.mainTab = 1;
                    rinQuestionsAnsVm.mainTabSub = 0;
                    rinQuestionsAnsVm.isEdit=false;                    
                     rinQuestionsAnsVm.setActive(rinQuestionsAnsVm.active);
                }else{
                    rinQuestionsAnsVm.mainTab = 1;
                    rinQuestionsAnsVm.mainTabSub = 0;
                    rinQuestionsAnsVm.isEdit=false;
                    rinQuestionsAnsVm.active = 'Medical';
                     rinQuestionsAnsVm.setActive(rinQuestionsAnsVm.active);
                }
                  if(rrService.saveData.application.app.medical.questions.length>0){
                      rinQuestionsAnsVm.fillQuestionAnsEditRetrieve();
                    }
            }

          
          rinQuestionsAnsVm.setActive = function(type) {
            switch(type){
                case "Medical":
                    rinQuestionsAnsVm.medicalTab=true;
                    rinQuestionsAnsVm.treatmentTab=false;
                    rinQuestionsAnsVm.medicationTab=false;
                    rinQuestionsAnsVm.testingTab=false;
                    rinQuestionsAnsVm.natureOfIllnessContent = false;
                    rinQuestionsAnsVm.testingYesClick=false;
                    rinQuestionsAnsVm.habitsTab=false;
                    rinQuestionsAnsVm.habitssubContentYes=false;                    
                    rinQuestionsAnsVm.femaleTab = false;
                    rinQuestionsAnsVm.scrollContentRight = false;
                    $scope.slideIndex =0;                     
                    rinQuestionsAnsVm.enableNxtBtn();
                    break;
                case "Treatment":
                    rinQuestionsAnsVm.treatmentTab=true;
                    rinQuestionsAnsVm.medicalTab=false;
                    rinQuestionsAnsVm.medicationTab=false;
                    rinQuestionsAnsVm.testingTab=false;
                    rinQuestionsAnsVm.natureOfIllnessContent = false;
                    rinQuestionsAnsVm.testingYesClick=false;
                    rinQuestionsAnsVm.habitsTab=false;
                    rinQuestionsAnsVm.habitssubContentYes=false;                    
                    rinQuestionsAnsVm.femaleTab = false;
                    rinQuestionsAnsVm.scrollContentRight = false;
                    $scope.slideIndex = 1;
                    rinQuestionsAnsVm.enableNxtBtn();
                    break;  
                case "Medication": 
                    rinQuestionsAnsVm.medicationTab=true;
                    rinQuestionsAnsVm.treatmentTab=false;
                    rinQuestionsAnsVm.medicalTab=false;
                     rinQuestionsAnsVm.testingTab=false;
                     rinQuestionsAnsVm.natureOfIllnessContent = false;
                    rinQuestionsAnsVm.testingYesClick=false;
                    rinQuestionsAnsVm.habitsTab=false;
                    rinQuestionsAnsVm.habitssubContentYes=false;                    
                    rinQuestionsAnsVm.femaleTab = false;
                    rinQuestionsAnsVm.scrollContentRight = false;
                    $scope.slideIndex = 1;
                    rinQuestionsAnsVm.enableNxtBtn();
                     break;
                case "Testing":
                     rinQuestionsAnsVm.testingTab=true;
                     rinQuestionsAnsVm.medicationTab=false;
                     rinQuestionsAnsVm.treatmentTab=false;
                     rinQuestionsAnsVm.medicalTab=false;
                     rinQuestionsAnsVm.natureOfIllnessContent = false;
                     rinQuestionsAnsVm.testingYesClick=false;
                      rinQuestionsAnsVm.habitsTab=false;
                      rinQuestionsAnsVm.habitssubContentYes=false;                      
                      rinQuestionsAnsVm.femaleTab = false;
                      rinQuestionsAnsVm.scrollContentRight = false;
                      $scope.slideIndex = 1;       
                      rinQuestionsAnsVm.enableNxtBtn();
                     //rinQuestionsAnsVm.testTabClicked(1);

                      break;
                case "Habits":
                     rinQuestionsAnsVm.habitsTab=true;
                     rinQuestionsAnsVm.testingTab=false;
                     rinQuestionsAnsVm.medicationTab=false;
                     rinQuestionsAnsVm.treatmentTab=false;
                     rinQuestionsAnsVm.medicalTab=false;
                     rinQuestionsAnsVm.natureOfIllnessContent = false;
                     rinQuestionsAnsVm.testingYesClick=false;
                     rinQuestionsAnsVm.habitssubContentYes=false;                     
                     rinQuestionsAnsVm.femaleTab = false;
                     rinQuestionsAnsVm.scrollContentRight = false;
                     $scope.slideIndex = 1;
                     rinQuestionsAnsVm.enableNxtBtn();
                     break;
                case "Female":
                     rinQuestionsAnsVm.femaleTab = true;
                     rinQuestionsAnsVm.habitsTab=false;
                     rinQuestionsAnsVm.testingTab=false;
                     rinQuestionsAnsVm.medicationTab=false;
                     rinQuestionsAnsVm.treatmentTab=false;
                     rinQuestionsAnsVm.medicalTab=false;
                     rinQuestionsAnsVm.natureOfIllnessContent = false;
                     rinQuestionsAnsVm.testingYesClick=false;
                     rinQuestionsAnsVm.habitssubContentYes=false;
                     rinQuestionsAnsVm.scrollContentRight = false; 
                     $scope.slideIndex = 1;                    
                     break;

            }

              rinQuestionsAnsVm.active = type;
          };
          

          rinQuestionsAnsVm.isActive = function(type) {
              return type === rinQuestionsAnsVm.active;
          };
          //  rinQuestionsAnsVm.femalesubContentYesClick = function($event) {            
          //     rinQuestionsAnsVm.femalesubContentYes = true;
          //     rinQuestionsAnsVm.femalesubContentNo = false;
              
          // };
          //  rinQuestionsAnsVm.femalesubContentNoClick = function($event) {            
          //     rinQuestionsAnsVm.femalesubContentYes = false; 
          //     rinQuestionsAnsVm.femalesubContentNo = true;                 
          // };
          

          rinQuestionsAnsVm.habitssubContentYesClick = function(){
            rinQuestionsAnsVm.habitssubContentYes=true;           
          }
          
          
          rinQuestionsAnsVm.habittsSubQuestions = function(id){            
                 rinQuestionsAnsVm.checkArrayValue(questionsList,id[0].id,rinQuestionsAnsVm.types);
                 rinQuestionsAnsVm.checkArrayValue(questionsList,id[1].id,rinQuestionsAnsVm.quantity);
                 rinQuestionsAnsVm.habitsSavebtn=true;
                 rinQuestionsAnsVm.enableNxtBtn('habits_nxt');                          
                  rinQuestionsAnsVm.slide();
            
           
          }
          rinQuestionsAnsVm.femalesSubQuestions = function(id){           
                rinQuestionsAnsVm.checkArrayValue(questionsList,id,rinQuestionsAnsVm.pregantMonths);
                rinQuestionsAnsVm.femalebtn = true;               
                rinQuestionsAnsVm.enableNxtBtn(0);
                rinQuestionsAnsVm.slide();
          }
          rinQuestionsAnsVm.medicalSaveDesease = function(){
            var diseaseList=[];
                     diseaseList.push({nature:rinQuestionsAnsVm.natureOfDisease,diagDate:rinQuestionsAnsVm.diagDate,recovered:rinQuestionsAnsVm.recovered,treatDetail:rinQuestionsAnsVm.treatDetail})
                     rrService.saveData.application.app.medical.diseases=diseaseList;                     
                     rinQuestionsAnsVm.medical3Ans = true;                    
                     rinQuestionsAnsVm.checkTabed('Medical');
          }
          rinQuestionsAnsVm.testingDataSave = function(value){ 
              rinQuestionsAnsVm.invalidreason = false;      

            if(value =='HD_ULTRA_SONO'){
                if(!rinQuestionsAnsVm.reason || rinQuestionsAnsVm.reason ==''){
                    rinQuestionsAnsVm.invalidreason=true
                }                
            }else{
                rinQuestionsAnsVm.invalidreason = false;
            }                   
            
            // if(reasonData.length>0){
            //          angular.forEach(reasonData, function (value, key) {
            //                 for (var i in value) {
            //                     if (value.id == value) {
            //                         delete questionsList[key];                                   
            //                         break;                                   
                                      
            //                     }
            //                 }
            //             });
            //          reasonData.push({id:value,reason:rinQuestionsAnsVm.reason});
            // }else{
            //     reasonData.push({id:value,reason:rinQuestionsAnsVm.reason});
            // }
            if(((rinQuestionsAnsVm.UltraSonography == true) || 
            (rinQuestionsAnsVm.isMRI == true ) || 
            (rinQuestionsAnsVm.isBiopsy == true) || 
            (rinQuestionsAnsVm.isAngioGraphy == true)) && (rinQuestionsAnsVm.reason)) {
				reasonData.push({id:value,reason:rinQuestionsAnsVm.reason});
                rinQuestionsAnsVm.checkTabed('TestingSub');
                rrService.saveData.application.app.medical.tests = reasonData;
				rinQuestionsAnsVm.testingSavebtn = true;				
				
            } else {
                rinQuestionsAnsVm.testingSavebtn = false;
            }
          }
          rinQuestionsAnsVm.femaleDataClear = function(){
            rinQuestionsAnsVm.pregantMonths='';
          }
          rinQuestionsAnsVm.femaleZeroClear = function(){
              if( rinQuestionsAnsVm.pregantMonths=='0' ||  rinQuestionsAnsVm.pregantMonths==0){
                 rinQuestionsAnsVm.pregantMonths='';
              }
           
          }
           rinQuestionsAnsVm.openDatePicker = function(){
                var monList = ["JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG","SEP","OCT","NOV","DEC"];
                var newDate = new Date();
                newDate.setFullYear(newDate.getFullYear() - 100);
                var toDate = new Date();
                toDate.setFullYear(toDate.getFullYear());
                rinQuestionsAnsVm.dateObj = {
                        callback: function (val) {
                            var dateOfBirth = new Date(val);
                            var setDate;
                            if(dateOfBirth.getDate() < 10){
                                 setDate = "0" + dateOfBirth.getDate();
                            }else{
                                setDate = dateOfBirth.getDate();
                            }
                            rinQuestionsAnsVm.diagDate = setDate + " " + monList[dateOfBirth.getMonth()] + " " + dateOfBirth.getFullYear();
                        },
                        inputDate: toDate,
                        monthsList:monList,
                        from: newDate,
                        to: toDate,
                        mondayFirst: true,
                        closeOnSelect: false,
                        templateType: 'popup',
                        dateFormat: 'dd MMM yyyy'
                };

                ionicDatePicker.openDatePicker(rinQuestionsAnsVm.dateObj);
        }

        rinQuestionsAnsVm.validateMedicalPage = function(){
          rinQuestionsAnsVm.errObj = {};
            if(validateService.isValidHeight(rinQuestionsAnsVm.heightFeet)){
                rinQuestionsAnsVm.errObj.error1 = validateService.isValidHeight(rinQuestionsAnsVm.heightFeet);
                return false;
            }
             if(validateService.isValidRinInches(rinQuestionsAnsVm.heightInches)){
                rinQuestionsAnsVm.errObj.error2 = validateService.isValidRinInches(rinQuestionsAnsVm.heightInches);
                return false;
            }            
            if(validateService.isValidWeight(rinQuestionsAnsVm.weight)){
                rinQuestionsAnsVm.errObj.error3 = validateService.isValidWeight(rinQuestionsAnsVm.weight);
                return false;
            }
            return true;
          }
          rinQuestionsAnsVm.questionsSave = function(value,id){
            if(value){
            switch(value){
                case "medical1":
                       if(rinQuestionsAnsVm.validateMedicalPage()){
                          rrService.saveData.application.app.medical.heightFeet=rinQuestionsAnsVm.heightFeet;
                          rrService.saveData.application.app.medical.heightInches=rinQuestionsAnsVm.heightInches;
                          rrService.saveData.application.app.medical.weight=rinQuestionsAnsVm.weight;
                          rinQuestionsAnsVm.saveTabed=true;
                          rinQuestionsAnsVm.selectedIndex1=0;
                          rinQuestionsAnsVm.slide();
                          rinQuestionsAnsVm.checkTabed('Medical');
                        }
                      break;
                case "medical3":
                      rinQuestionsAnsVm.natureOfIllnessContent=true;                     
                      break;
                              
            }
           }else{
                switch(id){ 
                //Medical Yes              
                case "HD_ADVICE_HOSPITAL_FUTURE":                      
                       rinQuestionsAnsVm.medical2Id = id; 
                       rinQuestionsAnsVm.medical2Ans = true;   
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.medical2Id,rinQuestionsAnsVm.medical2Ans);                   
                       rinQuestionsAnsVm.slide(); 
                       rinQuestionsAnsVm.checkTabed('Medical');
                       break; 
                case "HD_IS_ILLNESS_SURGICAL_OP": 
                       rinQuestionsAnsVm.medical3Id = id; 
                       rinQuestionsAnsVm.medical3Ans = true; 
                       rinQuestionsAnsVm.expandHeight();                                       
                      rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.medical3Id,rinQuestionsAnsVm.medical3Ans);
                       //rinQuestionsAnsVm.checkTabed('Medical');                                             
                       break;  //Treatment  Yes  
                case "HD_DIABETES_BP": 
                       rinQuestionsAnsVm.treatmentId0 = id; 
                       rinQuestionsAnsVm.treatmentAns0 = true;   
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId0,rinQuestionsAnsVm.treatmentAns0);                    
                       rinQuestionsAnsVm.slide();
                       rinQuestionsAnsVm.checkTabed('Treatment');
                       break;
                case "HD_CHESTPAIN_HEART_ATTACK": 
                       rinQuestionsAnsVm.treatmentId1 = id; 
                       rinQuestionsAnsVm.treatmentAns1 = true;   
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId1,rinQuestionsAnsVm.treatmentAns1);                 
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break;                           
                case "HD_STROKE_PARALYSIS": 
                       rinQuestionsAnsVm.treatmentId2 = id; 
                       rinQuestionsAnsVm.treatmentAns2 = true; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId2,rinQuestionsAnsVm.treatmentAns2);                      
                        rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break; 
                case "HD_HIV_INFECTION": 
                       rinQuestionsAnsVm.treatmentId3 = id; 
                       rinQuestionsAnsVm.treatmentAns3 = true;
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId3,rinQuestionsAnsVm.treatmentAns3);                       
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break;
                case "HD_CANCER_TUMOR": 
                       rinQuestionsAnsVm.treatmentId4 = id; 
                       rinQuestionsAnsVm.treatmentAns4 = true;
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId4,rinQuestionsAnsVm.treatmentAns4);                       
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break;
                case "HD_KIDNEY_DISORDER": 
                       rinQuestionsAnsVm.treatmentId5 = id; 
                       rinQuestionsAnsVm.treatmentAns5 = true;
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId5,rinQuestionsAnsVm.treatmentAns5);                       
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break; 
                case "HD_DIGESTIVE_DISORDER": 
                       rinQuestionsAnsVm.treatmentId6 = id; 
                       rinQuestionsAnsVm.treatmentAns6 = true; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId6,rinQuestionsAnsVm.treatmentAns6);                     
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break;
                case "HD_ASTHMA": 
                       rinQuestionsAnsVm.treatmentId7 = id; 
                       rinQuestionsAnsVm.treatmentAns7 = true; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId7,rinQuestionsAnsVm.treatmentAns7);                      
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break;
                case "HD_MENTAL_PSYCHIATRIC": 
                       rinQuestionsAnsVm.treatmentId8 = id; 
                       rinQuestionsAnsVm.treatmentAns8 = true;
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId8,rinQuestionsAnsVm.treatmentAns8);                       
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break; 
                case "HD_OTHER_DISEASE": 
                       rinQuestionsAnsVm.treatmentId9 = id; 
                       rinQuestionsAnsVm.treatmentAns9 = true;
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId9,rinQuestionsAnsVm.treatmentAns9);                       
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break; 
                case "HD_ANY_MEDICATION": //Medication Yes
                       rinQuestionsAnsVm.medicationId1 = id; 
                       rinQuestionsAnsVm.medicationAns1 = true; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.medicationId1,rinQuestionsAnsVm.medicationAns1);                      
                       rinQuestionsAnsVm.slide();
                       rinQuestionsAnsVm.checkTabed('Medication');
                       break;
                case "HD_PRAPOSAL_DECLI_POSTPOND":
                       rinQuestionsAnsVm.medicationId2 = id; 
                       rinQuestionsAnsVm.medicationAns2 = true; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.medicationId2,rinQuestionsAnsVm.medicationAns2);                      
                       rinQuestionsAnsVm.checkTabed('Medication');
                       break;
                case "HD_ADVISED_FOR_INVESTIGATION"://Testing Yes
                       rinQuestionsAnsVm.testingId1 = id; 
                       rinQuestionsAnsVm.testingAns1 = true;
                       rinQuestionsAnsVm.expandHeightTesting();
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.testingId1,rinQuestionsAnsVm.testingAns1);                    
                       //rinQuestionsAnsVm.checkTabed('Testing');
                       break;
                case "HD_CONSUME_CIGARETTES"://Habits Yes
                       rinQuestionsAnsVm.habitsId1 = id; 
                       rinQuestionsAnsVm.habitsAns1 = true; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.habitsId1,rinQuestionsAnsVm.habitsAns1);                      
                       rinQuestionsAnsVm.slide();
                       rinQuestionsAnsVm.checkTabed('Habits');
                       break;
                case "HD_CONSUME_ALCOLOL":
                       rinQuestionsAnsVm.habitsId2 = id; 
                       rinQuestionsAnsVm.habitsAns2 = true; 
                       rinQuestionsAnsVm.habitsTabClicked(1);
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.habitsId2,rinQuestionsAnsVm.habitsAns2);

                                          
                       //rinQuestionsAnsVm.slide();
                       //rinQuestionsAnsVm.checkTabed('Habits');
                       break;
                case "HD_NARCOTICS_GRUGS":
                       rinQuestionsAnsVm.habitsId3 = id; 
                       rinQuestionsAnsVm.habitsAns3 = true; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.habitsId3,rinQuestionsAnsVm.habitsAns3);                     
                       rinQuestionsAnsVm.checkTabed('Habits');
                       break;
                case "HD_IS_PREGNANT"://Female
                       rinQuestionsAnsVm.femaleId1 = id; 
                       rinQuestionsAnsVm.femaleAns1 = true; 
                        rinQuestionsAnsVm.femaleDataClear();
                         rinQuestionsAnsVm.femalebtn = false;  
                       rinQuestionsAnsVm.habitsTabClicked(1);                      
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.femaleId1,rinQuestionsAnsVm.femaleAns1);                      
                       break;   
                case "HD_GYNAECOLOGICAL_PROBLEM"://Female
                       rinQuestionsAnsVm.femaleId2 = id; 
                       rinQuestionsAnsVm.femaleAns2 = true;  
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.femaleId2,rinQuestionsAnsVm.femaleAns2);              
                       break;
                case "HD_ULTRA_SONO"://Testing subQuestion
                       rinQuestionsAnsVm.testingSubQId2 = id; 
                       rinQuestionsAnsVm.testingSubQAns2 = rinQuestionsAnsVm.UltraSonography;                           
                       if(!rinQuestionsAnsVm.isMRI){
                        rinQuestionsAnsVm.checkArrayValue(questionsList,"HD_CT_SCANMRI",false);
                       }
                       if(!rinQuestionsAnsVm.isBiopsy){
                        rinQuestionsAnsVm.checkArrayValue(questionsList,"HD_BIOPSY",false);
                       }  
                       if(!rinQuestionsAnsVm.isAngioGraphy){
                        rinQuestionsAnsVm.checkArrayValue(questionsList,"HD_ANGIOGRAPHY",false);       
                       }     
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.testingSubQId2,rinQuestionsAnsVm.testingSubQAns2); 
                       break;  
                case "HD_CT_SCANMRI"://Testing subQuestion
                       rinQuestionsAnsVm.testingSubQId3 = id; 
                       rinQuestionsAnsVm.testingSubQAns3 = rinQuestionsAnsVm.isMRI;                         
                       if(!rinQuestionsAnsVm.UltraSonography){
                        rinQuestionsAnsVm.checkArrayValue(questionsList,"HD_ULTRA_SONO",false);
                       }
                       if(!rinQuestionsAnsVm.isBiopsy){
                        rinQuestionsAnsVm.checkArrayValue(questionsList,"HD_BIOPSY",false);
                       }  
                       if(!rinQuestionsAnsVm.isAngioGraphy){
                        rinQuestionsAnsVm.checkArrayValue(questionsList,"HD_ANGIOGRAPHY",false);       
                       }      
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.testingSubQId3,rinQuestionsAnsVm.testingSubQAns3);         
                       break;
                case "HD_BIOPSY"://Testing subQuestion
                       rinQuestionsAnsVm.testingSubQId4 = id; 
                       rinQuestionsAnsVm.testingSubQAns4 = rinQuestionsAnsVm.isBiopsy;                        
                       if(!rinQuestionsAnsVm.UltraSonography){
                        rinQuestionsAnsVm.checkArrayValue(questionsList,"HD_ULTRA_SONO",false);
                       }
                       if(!rinQuestionsAnsVm.isMRI){
                        rinQuestionsAnsVm.checkArrayValue(questionsList,"HD_CT_SCANMRI",false);
                       }  
                       if(!rinQuestionsAnsVm.isAngioGraphy){
                        rinQuestionsAnsVm.checkArrayValue(questionsList,"HD_ANGIOGRAPHY",false);       
                       }     
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.testingSubQId4,rinQuestionsAnsVm.testingSubQAns4);           
                       break; 
                case "HD_ANGIOGRAPHY"://Testing subQuestion
                       rinQuestionsAnsVm.testingSubQId5 = id; 
                       rinQuestionsAnsVm.testingSubQAns5 = rinQuestionsAnsVm.isAngioGraphy;                         
                       if(!rinQuestionsAnsVm.UltraSonography){
                        rinQuestionsAnsVm.checkArrayValue(questionsList,"HD_ULTRA_SONO",false);
                       }
                       if(!rinQuestionsAnsVm.isMRI){
                        rinQuestionsAnsVm.checkArrayValue(questionsList,"HD_CT_SCANMRI",false);
                       }  
                       if(!rinQuestionsAnsVm.isBiopsy){
                        rinQuestionsAnsVm.checkArrayValue(questionsList,"HD_BIOPSY",false);       
                       }    
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.testingSubQId5,rinQuestionsAnsVm.testingSubQAns5);             
                       break;                                                                                               
             }
           }
          }

         rinQuestionsAnsVm.questionsNo = function(id){
             switch(id){  //Medical No              
                case "HD_ADVICE_HOSPITAL_FUTURE":                      
                       rinQuestionsAnsVm.medical2Id = id; 
                       rinQuestionsAnsVm.medical2Ans = false; 
                      rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.medical2Id,rinQuestionsAnsVm.medical2Ans);
                       // questionsList.push({id:rinQuestionsAnsVm.medical2Id,ans:rinQuestionsAnsVm.medical2Ans});                          
                       rinQuestionsAnsVm.slide(); 
                       rinQuestionsAnsVm.checkTabed('Medical');                     
                       break; 
                case "HD_IS_ILLNESS_SURGICAL_OP":                      
                       rinQuestionsAnsVm.medical3Id = id; 
                       rinQuestionsAnsVm.medical3Ans = false; 
                       rinQuestionsAnsVm.medicalsavebtn = false;
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.medical3Id,rinQuestionsAnsVm.medical3Ans);
                       // questionsList.push({id:rinQuestionsAnsVm.medical3Id,ans:rinQuestionsAnsVm.medical3Ans});  
                       rinQuestionsAnsVm.decreaseHeight();
                       rinQuestionsAnsVm.checkTabed('Medical');                                         
                       break; 
                case "HD_DIABETES_BP": //Treatment No
                       rinQuestionsAnsVm.treatmentId0 = id; 
                       rinQuestionsAnsVm.treatmentAns0 = false;
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId0,rinQuestionsAnsVm.treatmentAns0);                       
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break;
                case "HD_CHESTPAIN_HEART_ATTACK": 
                       rinQuestionsAnsVm.treatmentId1 = id; 
                       rinQuestionsAnsVm.treatmentAns1 = false;  
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId1,rinQuestionsAnsVm.treatmentAns1);                     
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break;                           
                case "HD_STROKE_PARALYSIS": 
                       rinQuestionsAnsVm.treatmentId2 = id; 
                       rinQuestionsAnsVm.treatmentAns2 = false;
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId2,rinQuestionsAnsVm.treatmentAns2);                        
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break; 
                case "HD_HIV_INFECTION": 
                       rinQuestionsAnsVm.treatmentId3 = id; 
                       rinQuestionsAnsVm.treatmentAns3 = false; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId3,rinQuestionsAnsVm.treatmentAns3);                       
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break;
                case "HD_CANCER_TUMOR": 
                       rinQuestionsAnsVm.treatmentId4 = id; 
                       rinQuestionsAnsVm.treatmentAns4 = false; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId4,rinQuestionsAnsVm.treatmentAns4);                       
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break;
                case "HD_KIDNEY_DISORDER": 
                       rinQuestionsAnsVm.treatmentId5 = id; 
                       rinQuestionsAnsVm.treatmentAns5 = false;  
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId5,rinQuestionsAnsVm.treatmentAns5);                      
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break; 
                case "HD_DIGESTIVE_DISORDER": 
                       rinQuestionsAnsVm.treatmentId6 = id; 
                       rinQuestionsAnsVm.treatmentAns6 = false; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId6,rinQuestionsAnsVm.treatmentAns6);                       
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break;
                case "HD_ASTHMA": 
                       rinQuestionsAnsVm.treatmentId7 = id; 
                       rinQuestionsAnsVm.treatmentAns7 = false; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId7,rinQuestionsAnsVm.treatmentAns7);                       
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break;
                case "HD_MENTAL_PSYCHIATRIC": 
                       rinQuestionsAnsVm.treatmentId8 = id; 
                       rinQuestionsAnsVm.treatmentAns8 = false; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId8,rinQuestionsAnsVm.treatmentAns8);                       
                       rinQuestionsAnsVm.slide();
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break; 
                case "HD_OTHER_DISEASE": 
                       rinQuestionsAnsVm.treatmentId9 = id; 
                       rinQuestionsAnsVm.treatmentAns9 = false; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId9,rinQuestionsAnsVm.treatmentAns9);                      
                        rinQuestionsAnsVm.checkTabed('Treatment');
                       break;  
                case "HD_ANY_MEDICATION": //Medication No
                       rinQuestionsAnsVm.medicationId1 = id; 
                       rinQuestionsAnsVm.medicationAns1 = false;
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.medicationId1,rinQuestionsAnsVm.medicationAns1);                       
                       rinQuestionsAnsVm.slide();
                       rinQuestionsAnsVm.checkTabed('Medication');
                       break;
                case "HD_PRAPOSAL_DECLI_POSTPOND":
                       rinQuestionsAnsVm.medicationId2 = id; 
                       rinQuestionsAnsVm.medicationAns2 = false; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.medicationId2,rinQuestionsAnsVm.medicationAns2);                      
                       rinQuestionsAnsVm.checkTabed('Medication');
                       break;  
                case "HD_ADVISED_FOR_INVESTIGATION"://Testing No
                       rinQuestionsAnsVm.testingId1 = id; 
                       rinQuestionsAnsVm.testingAns1 = false;
                       rinQuestionsAnsVm.testingYesClick =false;
                       rinQuestionsAnsVm.testingSavebtn=false;
                       rinQuestionsAnsVm.decreaseHeight();
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.testingId1,rinQuestionsAnsVm.testingAns1);
                       rinQuestionsAnsVm.checkTabed('Testing');
                       break;        
                case "HD_CONSUME_CIGARETTES"://Habits No
                       rinQuestionsAnsVm.habitsId1 = id; 
                       rinQuestionsAnsVm.habitsAns1 = false; 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.habitsId1,rinQuestionsAnsVm.habitsAns1);                      
                       rinQuestionsAnsVm.slide();
                       rinQuestionsAnsVm.checkTabed('Habits');
                       break;
                case "HD_CONSUME_ALCOLOL":
                       rinQuestionsAnsVm.habitsId2 = id; 
                       rinQuestionsAnsVm.habitsAns2 = false;
                       rinQuestionsAnsVm.habitsSavebtn=false;
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.habitsId2,rinQuestionsAnsVm.habitsAns2);
                       rinQuestionsAnsVm.enableNxtBtn('habits_nxt');                                                
                       rinQuestionsAnsVm.slide();
                       rinQuestionsAnsVm.checkTabed('Habits');
                       break;
                case "HD_NARCOTICS_GRUGS":
                       rinQuestionsAnsVm.habitsId3 = id; 
                       rinQuestionsAnsVm.habitsAns3 = false;
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.habitsId3,rinQuestionsAnsVm.habitsAns3);                        
                       rinQuestionsAnsVm.checkTabed('Habits');
                       break;           
                case "HD_IS_PREGNANT"://Female
                       rinQuestionsAnsVm.femaleId1 = id; 
                       rinQuestionsAnsVm.femaleAns1 = false;
                       rinQuestionsAnsVm.enableNxtBtn(0); 
                       rinQuestionsAnsVm.checkArrayValue(questionsList,"PREGNANT_MONTHS","");
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.femaleId1,rinQuestionsAnsVm.femaleAns1);                       
                        rinQuestionsAnsVm.slide();                
                       break; 
                case "HD_GYNAECOLOGICAL_PROBLEM"://Female
                       rinQuestionsAnsVm.femaleId2 = id; 
                       rinQuestionsAnsVm.femaleAns2 = false;  
                       rinQuestionsAnsVm.femalebtn = false;
                       rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.femaleId2,rinQuestionsAnsVm.femaleAns2);               
                       break;         
            }
         }

         rinQuestionsAnsVm.checkTabed =function(tabValue){
          rinQuestionsAnsVm.scrollContentRight = false;
            switch(tabValue){
                case "Medical" :
                    if(rinQuestionsAnsVm.selectedIndex1==0 && rinQuestionsAnsVm.medical2Id!=null && rinQuestionsAnsVm.medical3Id != null){                        
                        rinQuestionsAnsVm.editEnable('Treatment'); 
                    }
                    break;
                case "Treatment" :
                    if(rinQuestionsAnsVm.treatmentId0!=null && rinQuestionsAnsVm.treatmentId1 !=null && rinQuestionsAnsVm.treatmentId2 !=null && rinQuestionsAnsVm.treatmentId3 !=null && rinQuestionsAnsVm.treatmentId4 !=null && rinQuestionsAnsVm.treatmentId5 !=null && rinQuestionsAnsVm.treatmentId6 !=null && rinQuestionsAnsVm.treatmentId7 !=null && rinQuestionsAnsVm.treatmentId8 !=null && rinQuestionsAnsVm.treatmentId9!=null){
                       rinQuestionsAnsVm.editEnable('Medication');                        
                    }
                    break; 
                case "Medication" :
                    if(rinQuestionsAnsVm.medicationId1!=null && rinQuestionsAnsVm.medicationId2!=null){
                       rinQuestionsAnsVm.scrollContentRight = true; 
                        rinQuestionsAnsVm.editEnable('Testing');                        
                    }
                    break;
                case "Testing" :
                    if(rinQuestionsAnsVm.testingId1!=null){
                        rinQuestionsAnsVm.editEnable('Habits');                        
                    }
                    break; 
                case "TestingSub" :                  
                        rinQuestionsAnsVm.editEnable('Habits');                                      
                    break; 
                case "Habits" :
                    if(rinQuestionsAnsVm.habitsId1 !=null && rinQuestionsAnsVm.habitsId2!=null && rinQuestionsAnsVm.habitsId3!=null){
                        if(rinQuestionsAnsVm.customerInformation.gender.toLowerCase()=='female'){
                            rinQuestionsAnsVm.editEnable('Female');
                        }
                                                
                    }
                    break; 
                          

            }
            
         }
         
         rinQuestionsAnsVm.enableNxtBtn = function(value){
            if(rinQuestionsAnsVm.femaleTab == true || rinQuestionsAnsVm.habitsTab == true){
                if(value==0 || value == 'habits_nxt' && rinQuestionsAnsVm.customerInformation.gender.toLowerCase()!='female'){    
                    if(rinQuestionsAnsVm.customerInformation.gender.toLowerCase()=='male'){
                     rinQuestionsAnsVm.femaleAns2 = '10'   
                     rinQuestionsAnsVm.showBack = true;
                     rinQuestionsAnsVm.showNext = true;
                     rinQuestionsAnsVm.isEdit =true;
                    }else{
                     rinQuestionsAnsVm.showBack = true;
                     rinQuestionsAnsVm.showNext = true;
                     rinQuestionsAnsVm.isEdit =true;
                    }               
                     
                }else{
                    if(rinQuestionsAnsVm.habitsTab == true && $stateParams.termsObj!='review_back'){
                        rinQuestionsAnsVm.showBack = true;
                        if(rinQuestionsAnsVm.customerInformation.gender.toLowerCase() == 'female') {
                            rinQuestionsAnsVm.showNext = false;
                        } else{
                            rinQuestionsAnsVm.showNext = true;
                        }
                        rinQuestionsAnsVm.isEdit =true;
                    }else{
                         rinQuestionsAnsVm.showBack = false;
                         rinQuestionsAnsVm.showNext = false;
                         rinQuestionsAnsVm.isEdit =false;
                 }
                }
            }else{
                if(rinQuestionsAnsVm.mainTabSub == 1){
                    rinQuestionsAnsVm.showSave = true; 
                    rinQuestionsAnsVm.showCancel = true; 
                    rinQuestionsAnsVm.showNext = false;
                     rinQuestionsAnsVm.showBack = false;
                }else if(rinQuestionsAnsVm.testingTab==true){
                    rinQuestionsAnsVm.showBack = false;
                         rinQuestionsAnsVm.showNext = false;
                         rinQuestionsAnsVm.isEdit =false;
                }
                else{
                    rinQuestionsAnsVm.showBack = false;
                     rinQuestionsAnsVm.showNext = false;
                }
                
            }
         }
        rinQuestionsAnsVm.editEnable = function(value){
             if(rinQuestionsAnsVm.mainTabSub == 0){
                rinQuestionsAnsVm.setActive(value);
             }
        }
         rinQuestionsAnsVm.checkArrayValue = function(arrayValue,value1,value2){
            if(arrayValue.length>0){
                     angular.forEach(arrayValue, function (value, key) {
                               
                                if (value.id == value1) {
                                    questionsList.splice(key,1);
                                    //delete questionsList.splice(key,1);[key];    
                                    }
                               
                            
                        });
                     questionsList.push({id:value1,ans:value2});
            }else{
                questionsList.push({id:value1,ans:value2});
            }
            rrService.saveData.application.app.medical.questions = questionsList;
         }
         rinQuestionsAnsVm.slide = function(){
             $ionicSlideBoxDelegate.next();
         }
        
         rinQuestionsAnsVm.editGoBack = function() {
             if(rinQuestionsAnsVm.isEdit==false){
                 $state.go('menu.rrNomioneeDetails');
             }else{
                $state.go('menu.rrReviewDetails');
             }
                       
          }


        rinQuestionsAnsVm.goBack = function() {          
            rrService.saveApplication().then(function (data) {
                        rinQuestionsAnsVm.isTopBack = true;
                        utilityService.hideSpinner();       
                        homeScreenService.ishamburgerMenuRO=false;
                        homeScreenService.isInsuranceFlag = true;
                        getAccountDetailsService.tabIndex.tabIndex=4;
                        $state.go('menu.accountOverviewMyBalance');
                    }, function (error) {
                        rinQuestionsAnsVm.isTopBack = true;
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                        homeScreenService.ishamburgerMenuRO=false;
                        homeScreenService.isInsuranceFlag = true;
                        getAccountDetailsService.tabIndex.tabIndex=4;
                        $state.go('menu.accountOverviewMyBalance');
                    }); 
           
           
        }
        rinQuestionsAnsVm.goToNextPage = function(){
          rrService.saveData.application.app.pageNo = 4;
             rrService.saveApplication().then(function (data) {
                        utilityService.hideSpinner();        
                        $state.go('menu.rrReviewDetails');
                    }, function (error) {
                        utilityService.hideSpinner();
                        utilityService.showErrorMessage(error.responseMessage);
                        $state.go('menu.rrReviewDetails');
                    }); 
        }
        rinQuestionsAnsVm.fillQuestionAnsEditRetrieve = function(){
          var bindMedDetails = rrService.saveData.application.app.medical.questions;
           for (var i in bindMedDetails) {
                        if(bindMedDetails[i].id == 'HD_ADVICE_HOSPITAL_FUTURE'){                                
                                if(bindMedDetails[i].ans == 'true'){
                                    rinQuestionsAnsVm.medical2Id = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.medical2Ans = true;   
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.medical2Id = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.medical2Ans = false;   
                                }   
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.medical2Id,rinQuestionsAnsVm.medical2Ans);    
                            }
                            if(bindMedDetails[i].id == 'HD_IS_ILLNESS_SURGICAL_OP'){                                  
                                if(bindMedDetails[i].ans == 'true'){
                                      rinQuestionsAnsVm.medical3Id = bindMedDetails[i].id; 
                                      rinQuestionsAnsVm.medical3Ans = true; 
                                      rinQuestionsAnsVm.natureOfDisease=rrService.saveData.application.app.medical.diseases[0].nature;
                                      rinQuestionsAnsVm.diagDate=rrService.saveData.application.app.medical.diseases[0].diagDate;
                                      rinQuestionsAnsVm.recovered=rrService.saveData.application.app.medical.diseases[0].recovered;
                                      rinQuestionsAnsVm.treatDetail =rrService.saveData.application.app.medical.diseases[0].treatDetail; 
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.medical3Id = bindMedDetails[i].id; 
                                     rinQuestionsAnsVm.medical3Ans = false;  
                                }   
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.medical3Id,rinQuestionsAnsVm.medical3Ans);                           
                                
                            }
                            if(bindMedDetails[i].id == 'HD_DIABETES_BP'){                                   
                                if(bindMedDetails[i].ans == 'true'){
                                    rinQuestionsAnsVm.treatmentId0 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns0 = true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.treatmentId0 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns0 = false;
                                }                              
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId0,rinQuestionsAnsVm.treatmentAns0);
                            }
                            if(bindMedDetails[i].id == 'HD_CHESTPAIN_HEART_ATTACK'){                                         
                                if(bindMedDetails[i].ans == 'true'){
                                     rinQuestionsAnsVm.treatmentId1 = bindMedDetails[i].id; 
                                     rinQuestionsAnsVm.treatmentAns1 = true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.treatmentId1 = bindMedDetails[i].id; 
                                     rinQuestionsAnsVm.treatmentAns1 = false;
                                }                      
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId1,rinQuestionsAnsVm.treatmentAns1); 
                            }
                            if(bindMedDetails[i].id == 'HD_STROKE_PARALYSIS'){                                  
                                if(bindMedDetails[i].ans == 'true'){
                                    rinQuestionsAnsVm.treatmentId2 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns2 = true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.treatmentId2 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns2 = false;
                                }                              
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId2,rinQuestionsAnsVm.treatmentAns2);
                            }

                            if(bindMedDetails[i].id == 'HD_HIV_INFECTION'){                                     
                                if(bindMedDetails[i].ans == 'true'){
                                    rinQuestionsAnsVm.treatmentId3 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns3 = true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.treatmentId3 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns3 = false;
                                }                            
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId3,rinQuestionsAnsVm.treatmentAns3);
                            }
                            if(bindMedDetails[i].id == 'HD_CANCER_TUMOR'){                                                
                                 if(bindMedDetails[i].ans == 'true'){
                                     rinQuestionsAnsVm.treatmentId4 = bindMedDetails[i].id; 
                                     rinQuestionsAnsVm.treatmentAns4 = true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.treatmentId4 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns4 = false;
                                }              
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId4,rinQuestionsAnsVm.treatmentAns4); 
                            }
                            if(bindMedDetails[i].id == 'HD_KIDNEY_DISORDER'){                                    
                                 if(bindMedDetails[i].ans == 'true'){
                                    rinQuestionsAnsVm.treatmentId5 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns5 = true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.treatmentId5 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns5 = false;
                                }                          
                                 rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId5,rinQuestionsAnsVm.treatmentAns5);
                            }
                            if(bindMedDetails[i].id == 'HD_DIGESTIVE_DISORDER'){                                   
                                  if(bindMedDetails[i].ans == 'true'){
                                    rinQuestionsAnsVm.treatmentId6 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns6 = true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.treatmentId6 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns6 = false;
                                }                             
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId6,rinQuestionsAnsVm.treatmentAns6);
                            }
                            if(bindMedDetails[i].id == 'HD_ASTHMA'){                                                
                                 if(bindMedDetails[i].ans == 'true'){
                                      rinQuestionsAnsVm.treatmentId7 = bindMedDetails[i].id; 
                                      rinQuestionsAnsVm.treatmentAns7 = true; 
                                }else if(bindMedDetails[i].ans == 'false'){
                                      rinQuestionsAnsVm.treatmentId7 = bindMedDetails[i].id; 
                                      rinQuestionsAnsVm.treatmentAns7 = false; 
                                }               
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId7,rinQuestionsAnsVm.treatmentAns7); 
                            }
                            if(bindMedDetails[i].id == 'HD_MENTAL_PSYCHIATRIC'){             
                                if(bindMedDetails[i].ans == 'true'){
                                     rinQuestionsAnsVm.treatmentId8 = bindMedDetails[i].id; 
                                     rinQuestionsAnsVm.treatmentAns8 = true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                     rinQuestionsAnsVm.treatmentId8 = bindMedDetails[i].id; 
                                     rinQuestionsAnsVm.treatmentAns8 = false;
                                }                    
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId8,rinQuestionsAnsVm.treatmentAns8); 
                            }

                            if(bindMedDetails[i].id == 'HD_OTHER_DISEASE'){                                                 
                                 if(bindMedDetails[i].ans == 'true'){
                                    rinQuestionsAnsVm.treatmentId9 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns9 = true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.treatmentId9 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.treatmentAns9 = false;
                                }             
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.treatmentId9,rinQuestionsAnsVm.treatmentAns9);
                            }
                            if(bindMedDetails[i].id == 'HD_ANY_MEDICATION'){                              
                                 if(bindMedDetails[i].ans == 'true'){
                                      rinQuestionsAnsVm.medicationId1 = bindMedDetails[i].id; 
                                      rinQuestionsAnsVm.medicationAns1 = true; 
                                }else if(bindMedDetails[i].ans == 'false'){
                                      rinQuestionsAnsVm.medicationId1 = bindMedDetails[i].id; 
                                      rinQuestionsAnsVm.medicationAns1 = false; 
                                }
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.medicationId1,rinQuestionsAnsVm.medicationAns1);
                            }
                            if(bindMedDetails[i].id == 'HD_PRAPOSAL_DECLI_POSTPOND'){                                                   
                                 if(bindMedDetails[i].ans == 'true'){
                                     rinQuestionsAnsVm.medicationId2 = bindMedDetails[i].id; 
                                     rinQuestionsAnsVm.medicationAns2 = true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                      rinQuestionsAnsVm.medicationId2 = bindMedDetails[i].id; 
                                      rinQuestionsAnsVm.medicationAns2 = false;
                                }             
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.medicationId2,rinQuestionsAnsVm.medicationAns2);
                            }
                            if(bindMedDetails[i].id == 'HD_ADVISED_FOR_INVESTIGATION'){                    
                                if(bindMedDetails[i].ans == 'true'){
                                    rinQuestionsAnsVm.testingId1 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.testingAns1 = true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.testingId1 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.testingAns1 = false;
                                }            
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.testingId1,rinQuestionsAnsVm.testingAns1); 
                            }
                            if(bindMedDetails[i].id == 'HD_ULTRA_SONO'){                     
                                  if(bindMedDetails[i].ans == 'true'){
                                    rinQuestionsAnsVm.testingSubQId2 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.testingSubQAns2 = true;
                                    rinQuestionsAnsVm.UltraSonography=true;
                                    rinQuestionsAnsVm.reason=rrService.saveData.application.app.medical.tests[0].reason;
                                    rinQuestionsAnsVm.testingSavebtn=true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.testingSubQId2 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.testingSubQAns2 = false;
                                    rinQuestionsAnsVm.testingSavebtn=false;
                                    rinQuestionsAnsVm.UltraSonography=false;
                                }          
                               rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.testingSubQId2,rinQuestionsAnsVm.testingSubQAns2);
                            }
                            if(bindMedDetails[i].id == 'HD_CT_SCANMRI'){                                            
                                 if(bindMedDetails[i].ans == 'true'){
                                   rinQuestionsAnsVm.testingSubQId3 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.testingSubQAns3 = true;
                                    rinQuestionsAnsVm.isMRI=true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.testingSubQId3 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.testingSubQAns3 = false;
                                    rinQuestionsAnsVm.isMRI=false;
                                }                     
                                 rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.testingSubQId3,rinQuestionsAnsVm.testingSubQAns3);
                            }
                            if(bindMedDetails[i].id == 'HD_BIOPSY'){
                                if(bindMedDetails[i].ans == 'true'){
                                   rinQuestionsAnsVm.testingSubQId4 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.testingSubQAns4 = true;  
                                    rinQuestionsAnsVm.isBiopsy=true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                   rinQuestionsAnsVm.testingSubQId4 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.testingSubQAns4 = false;  
                                    rinQuestionsAnsVm.isBiopsy=false;
                                }   
                               rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.testingSubQId4,rinQuestionsAnsVm.testingSubQAns4);
                            }
                            if(bindMedDetails[i].id == 'HD_ANGIOGRAPHY'){
                                 if(bindMedDetails[i].ans == 'true'){
                                    rinQuestionsAnsVm.testingSubQId5 =  bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.testingSubQAns5 = true; 
                                    rinQuestionsAnsVm.isAngioGraphy=true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                     rinQuestionsAnsVm.testingSubQId5 =  bindMedDetails[i].id; 
                                     rinQuestionsAnsVm.testingSubQAns5 = false; 
                                     rinQuestionsAnsVm.isAngioGraphy=false;
                                }
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.testingSubQId5,rinQuestionsAnsVm.testingSubQAns5); 
                            }
                            if(bindMedDetails[i].id == 'HD_CONSUME_CIGARETTES'){
                                if(bindMedDetails[i].ans == 'true'){
                                      rinQuestionsAnsVm.habitsId1 =  bindMedDetails[i].id; 
                                      rinQuestionsAnsVm.habitsAns1 = true; 
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.habitsId1 =  bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.habitsAns1 = false; 
                                }
                               rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.habitsId1,rinQuestionsAnsVm.habitsAns1);
                            }
                            if(bindMedDetails[i].id == 'HD_CONSUME_ALCOLOL'){
                                 if(bindMedDetails[i].ans == 'true'){
                                     rinQuestionsAnsVm.habitsId2 = bindMedDetails[i].id; 
                                     rinQuestionsAnsVm.habitsAns2 = true;                                    
                                }else if(bindMedDetails[i].ans == 'false'){
                                     rinQuestionsAnsVm.habitsId2 = bindMedDetails[i].id; 
                                     rinQuestionsAnsVm.habitsAns2 = false; 
                                }
                                 rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.habitsId2,rinQuestionsAnsVm.habitsAns2);  
                            }
                            if(bindMedDetails[i].id == 'HD_ALCOHOL_TYPE'){
                                if(bindMedDetails[i].ans){
                                     rinQuestionsAnsVm.types = bindMedDetails[i].ans;                                    
                                     rinQuestionsAnsVm.habitsSavebtn=true;
                                }
                                
                            }
                            if(bindMedDetails[i].id == 'HD_ALCOHOL_QUANTITY'){ 
                                if(bindMedDetails[i].ans){
                                     rinQuestionsAnsVm.quantity =bindMedDetails[i].ans;
                                }
                                
                            }
                            if(bindMedDetails[i].id == 'HD_NARCOTICS_GRUGS'){
                                 if(bindMedDetails[i].ans == 'true'){
                                    rinQuestionsAnsVm.habitsId3 = bindMedDetails[i].id; 
                                     rinQuestionsAnsVm.habitsAns3 = true;
                                }else if(bindMedDetails[i].ans == 'false'){
                                   rinQuestionsAnsVm.habitsId3 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.habitsAns3 = false;
                                }
                               rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.habitsId3,rinQuestionsAnsVm.habitsAns3); 
                            }
                            if(bindMedDetails[i].id == 'HD_IS_PREGNANT'){
                                if(bindMedDetails[i].ans == 'true'){
                                   rinQuestionsAnsVm.femaleId1 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.femaleAns1 = true; 
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.femaleId1 = bindMedDetails[i].id; 
                                     rinQuestionsAnsVm.femaleAns1 = false; 
                                }
                                rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.femaleId1,rinQuestionsAnsVm.femaleAns1);
                            }
                            if(bindMedDetails[i].id == 'PREGNANT_MONTHS'){
                                 if(bindMedDetails[i].ans){
                                    rinQuestionsAnsVm.pregantMonths = bindMedDetails[i].ans;
                                     rinQuestionsAnsVm.femalebtn=true;
                                }else{
                                    rinQuestionsAnsVm.femalebtn=false;
                                }
                                
                            }

                            if(bindMedDetails[i].id == 'HD_GYNAECOLOGICAL_PROBLEM'){
                                if(bindMedDetails[i].ans == 'true'){
                                    rinQuestionsAnsVm.femaleId2 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.femaleAns2 = true;                                   
                                }else if(bindMedDetails[i].ans == 'false'){
                                    rinQuestionsAnsVm.femaleId2 = bindMedDetails[i].id; 
                                    rinQuestionsAnsVm.femaleAns2 = false;
                                    
                                }
                               rinQuestionsAnsVm.checkArrayValue(questionsList,rinQuestionsAnsVm.femaleId2,rinQuestionsAnsVm.femaleAns2); 
                            }
                              rinQuestionsAnsVm.heightFeet=rrService.saveData.application.app.medical.heightFeet;
                              rinQuestionsAnsVm.heightInches=rrService.saveData.application.app.medical.heightInches;
                              rinQuestionsAnsVm.weight=rrService.saveData.application.app.medical.weight;                            
                              rinQuestionsAnsVm.selectedIndex1=0;

                    }
        }
        // $scope.testingChanged = function(){
        //     var testingDivheight=document.getElementsByClassName('slider-slides')[0].clientWidth;      
        //     document.getElementsByClassName('slider-slides')[0].style.width=(testingDivheight + 0)+'px';
        // }
        // Called each time the slide changes
        $scope.slideChanged = function(index) {
          
          $scope.slideIndex = index;   
          if(rinQuestionsAnsVm.medical3Ans==true && index==2){
            rinQuestionsAnsVm.expandHeight();
          }else if(index==1){           
            //document.getElementsByClassName('slider-pager')[0].style.top = '350px';             
                rinQuestionsAnsVm.decreaseHeight();           
              
          }else if(index>0){           
            document.getElementsByClassName('slider-pager')[0].style.top = '350px'; 
            //rinQuestionsAnsVm.decreaseHeight();  
           // document.getElementsByClassName('rr_ttl_box_footer')[0].style.marginTop = '62px!important';               
              
          }else{            
             document.getElementsByClassName('slider-pager')[0].style.top = '350px';   
              document.getElementsByClassName('rr_ttl_box_footer')[0].style.marginTop = '0px';
          }       
        };

        rinQuestionsAnsVm.checkZeroFeet = function(){
           if(rinQuestionsAnsVm.heightFeet == 0 || rinQuestionsAnsVm.heightFeet == "0"){
            rinQuestionsAnsVm.heightFeet='';
           }
        }

        rinQuestionsAnsVm.expandHeight = function(){
           var divheight= document.getElementsByClassName('subcontent-slide');
            for(var i=0;i<divheight.length;i++){
            setHeight(divheight[i]);
        }
           // document.getElementsByClassName('subcontent-slide')[0].offsetHeight='561px!important'
        }
        rinQuestionsAnsVm.decreaseHeight = function(){
            var divheight= document.getElementsByClassName('subcontent-slide');
            for(var i=0;i<divheight.length;i++){
            setHeightReduce(divheight[i]);
        }
    }

        function setHeight(div) {
            div.style.height = '561px'; 
             document.getElementsByClassName('slider-pager')[0].style.top = '583px'; 
        }

         function setHeightReduce(div) {
            div.style.height = '307px';
            document.getElementsByClassName('slider-pager')[0].style.top = '350px'; 
            document.getElementsByClassName('rr_ttl_box_footer')[0].style.marginTop = '37px'; 

           
        }
         rinQuestionsAnsVm.habitsTabClicked = function(index) {
          
          $scope.slideIndex = index;   
          if(rinQuestionsAnsVm.habitsAns2==true && index==1 || rinQuestionsAnsVm.femaleAns1==true && index==1){
            rinQuestionsAnsVm.expandHeightTesting();
          }else{            
             rinQuestionsAnsVm.decreaseHeight(); 
          }       
        };

        $scope.habitsTabSwipe = function(index) {
                      
          if(rinQuestionsAnsVm.habitsAns2==true && index==1 || rinQuestionsAnsVm.femaleAns1==true && index==0){
            rinQuestionsAnsVm.expandHeightTesting();
          }else{
            rinQuestionsAnsVm.decreaseHeight();
          }       
        };
        rinQuestionsAnsVm.expandHeightTesting = function(){
           var divheight= document.getElementsByClassName('subcontent-slide');
            for(var i=0;i<divheight.length;i++){
            setHeightTesting(divheight[i]);
        }
    }
        function setHeightTesting(div) {
            div.style.height = '611px'; 
             document.getElementsByClassName('slider-pager')[0].style.top = '660px'; 
        }
        //one time initialization to be done when the controller is loaded +
        $scope.$on('$ionicView.loaded', function () {
            //premiumCalculatorVm.getAccountList();
            // if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
            //     getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
            //         getAccountDetailsService.accessRightsData = data;
            //     }, function (error) {
            //         // Failure block
            //     });
            // }
        });


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            initPage();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);