'use strict';

angularApp.controller('rrApplicationPendingController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "getAccountDetailsService",
    "utilityService",
    "homeScreenService",
    "$ionicPopup",
    "$rootScope",
    "$filter",
    "ionicDatePicker","$stateParams","rrService","$ionicHistory",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        getAccountDetailsService,
        utilityService,
        homeScreenService,
        $ionicPopup,
        $rootScope,
        $filter,
        ionicDatePicker,$stateParams,rrService,$ionicHistory
    ) {

        var rrApplicationPendingVm = this;
        
        function initPage() {
            rrApplicationPendingVm.loanType='';
            rrApplicationPendingVm.loanSubCat='';
            rrApplicationPendingVm.status={};
            rrApplicationPendingVm.TrackStatus='';
            rrApplicationPendingVm.status= rrService.termsObj;  
            rrService.termsObj = {};    
            rrApplicationPendingVm.errMsg = "Due to some technical reason we are unable to process your request, Please try again later.";
            rrApplicationPendingVm.trackApplicationDetails();
        }


        rrApplicationPendingVm.trackApplicationDetails = function () { 
            utilityService.showSpinner(); 
            var inputparams = {
				    "proposalNo" : rrApplicationPendingVm.status.mFormNo
                    }  
            rrService.getRrPolicyDetails(inputparams).then(function (data) {
                    utilityService.hideSpinner(); 
                    if(data[0]){
                        rrApplicationPendingVm.TrackStatus = data[0].status; 
                        rrApplicationPendingVm.loanType = data[0].loanType;
                        rrApplicationPendingVm.loanSubCat = data[0].loanSubCat;
                    }else{
                        rrService.displayPopUp("", "padBtm25 top-padding26", rrApplicationPendingVm.errMsg, "OK", function () {
                            //$ionicHistory.goBack();
                            $state.go('menu.homeScreen');
                        });
                    }

                                       
                }, function (error) {
                    utilityService.hideSpinner();
                    rrService.displayPopUp("","padBtm25 top-padding26",error.responseMessage,"OK",function(){
                                 $ionicHistory.goBack();
                            });
                    
                });         
           
        };

       
        
        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {           
            initPage();                  
        });       
    }
]);