/*File Name: dematAccountHomeController
Developer name: Shipra*/

'use strict';

angularApp.controller('dematAccountHomeController', 
	["$timeout",
	"$state",
	"$scope",
	"$translate",
	"$ionicPopup",
	"dematService",
	"utilityService","mySecurityProfileService","$sce",
	
	
	function ($timeout,
		$state,
		$scope,
		$translate,
		$ionicPopup,dematService,utilityService,mySecurityProfileService,$sce) {
	
		var dematVm = this;
		
		//Function to intialize variables ....
		function initPage(){
			dematVm.scriptDetails = true;
			dematVm.getDematList();
		}
		
		//Function to call demat list 
		
		dematVm.getDematList=function(){
			dematVm.reqParams={};
			dematVm.dpId=mySecurityProfileService.getDPId();
			dematVm.reqParams['dpAccountCode']=dematVm.dpId;
			dematService.getDematDetails(dematVm.reqParams).then(function(data){
				dematVm.data = data;
				dematVm.dpid = data.dpId;
				//dematVm.data.dpid = data.dpId;
				//$scope.dematScriptList = dematVm.dematScriptDetails;
				dematVm.accNumValue=$sce.trustAsHtml(data.totalAmount.replace("Rs.","&#8377; "));
				dematVm.dpid = data.dpId;
				dematVm.scriptDetails = data.dematScriptDetails.dematScriptList;
			}, function(error){
				dematVm.scriptDetails = false;
				//utilityService.showErrorMessage(error.responseMessage);
			});
			
		};	
		
		//function to go back to account overview page
		dematVm.goToHome = function(){
			$state.go('menu.accountOverviewMyBalance');
		}
		
		//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function() {
			
		});
		
		//actions to done everytime the view is shown
		$scope.$on('$ionicView.beforeEnter', function() {			
	    	initPage();
		
		});

		//actions to done everytime the view is hidden
		$scope.$on('$ionicView.afterLeave', function() {

		});

		
		
	}]);