'use strict';

angularApp.controller('linkAccountController', ["$timeout",
    "$state",
    "$scope",
    "$translate",
    "$ionicPopup", "linkAccountService", "$rootScope", "mySecurityProfileService",
    "utilityService","$ionicHistory","constantConfig","homeScreenService","getAccountDetailsService","clickStreamService",


    function($timeout,
        $state,
        $scope,
        $translate,
        $ionicPopup, linkAccountService, $rootScope, mySecurityProfileService,utilityService,
        $ionicHistory,constantConfig,homeScreenService,getAccountDetailsService,clickStreamService) {

        var linkAccountVm = this;

        //Initialize all variables here
        function initPage() {
            //linkAccountVm.showTermAndConditions();
            linkAccountVm.isBackCheck=homeScreenService.isBackCheck;
            homeScreenService.isBackCheck	=false;
			linkAccountVm.showLinkAccountSelection();
        }

        //Show link account selection  page
        linkAccountVm.showLinkAccountSelection = function() {
            linkAccountVm.linkAccount = 1;
            linkAccountVm.disclaimer = 0;
			$scope.accountList =[]; 
			$scope.accountListTemp=mySecurityProfileService.getDetails();
			$scope.accountListTemp=$scope.accountListTemp[0];
			

			for(linkAccountVm.list=0;linkAccountVm.list < $scope.accountListTemp.length ;linkAccountVm.list++){
				//if($scope.accountListTemp[linkAccountVm.list].accountType==constantConfig.mfAndsecConst.savingAccountInOpenAccount){
					$scope.accountList.push($scope.accountListTemp[linkAccountVm.list]);
				//}
			}
			
			
            $timeout(function() {
                linkAccountVm.linkAccountNumber = $scope.accountList[0].accountType + "_" + $scope.accountList[0].accountNumber + "_" + $scope.accountList[0].accountBalance;
            }, 400);
        }

        // function Show previous page
        linkAccountVm.goBacktoPrevious = function() {
            linkAccountVm.linkAccount = 1;
            linkAccountVm.disclaimer = 0;

        }

        // function to go to home page
        linkAccountVm.goToHome = function() {
          if(homeScreenService.ishamMenu===true){
            $ionicHistory.goBack();
            //$state.go("menu.homeScreen");
            homeScreenService.ishamMenu=false;
          }
          else{
                homeScreenService.isInvestmentFlag = true;
                getAccountDetailsService.tabIndex.tabIndex = 3;
                $state.go("menu.accountOverviewMyBalance");
            }       
        }
            //DataConsent message by service
        linkAccountVm.showTermAndConditions = function() {
            linkAccountVm.linkAccount = 0;
            linkAccountVm.disclaimer = 1;
            linkAccountVm.reqParams = {};
            linkAccountVm.reqParams['sourceType'] = "linkAccount";

            //Call service to fetch getDataConsent list
            linkAccountService.getDisclaimer(linkAccountVm.reqParams).then(function(data) {
              
                linkAccountVm.termsConditionsMessage = data.message;
               
            }, function(error) {
               utilityService.showErrorMessage(error.responseMessage);
            });
        }

        //call linkcustomer account service by invoking adapter
        linkAccountVm.onClickLink = function() {
                linkAccountVm.reqParams = {};
                linkAccountVm.reqParams['accountNumber'] = linkAccountVm.linkAccountNumber.split('_')[1];
                linkAccountService.linkCustomerAccount(linkAccountVm.reqParams).then(function(data) {
                        clickStreamService.sendClickStreamData(clickStreamService.setClickStreamData("SEC_OPNDEMATOTPAUTH" + "_" + "DM_END_NXT_BTN"));
                        linkAccountVm.SuccessPop = $ionicPopup.show({
                            template: '<img src="img/mf/bg-approved.svg" alt="Success Screen"><h2>SUCCESSFUL!</h2> <p class="padding-bottom-20">' + data.message + '</p>',
                            title: '',
                            cssClass: 'dialog',
                            scope: $scope,
                            buttons: [{
                                text: 'OK',
                                type: 'button-positive',
                                onTap: function(e) {
                                    $timeout(function() {
                                        linkAccountVm.SuccessPop.close(); //close the popup after 1 seconds 
                                    }, 100);
                                    $state.go('menu.accountOverviewMyBalance');
									e.preventDefault();
                                }
                            }]
                        });
                   
                           
                }, function(error) {
					utilityService.showErrorMessage(error.responseMessage);
				    $timeout(function() {
                        linkAccountVm.SuccessPop.close(); //close the popup after 1 seconds 
					}, 100);
					linkAccountVm.linkAccount = 1;
					linkAccountVm.disclaimer = 0;
                });


            }
            //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function() {});

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
            initPage();
        });

        //actions to done everytime the view is hidden
        $scope.$on('$ionicView.afterLeave', function() {

        });
        return this;


    }
]);