//Link account services
angularApp.service('linkAccountService',
	function ($q, AdapterUtils) {
		var linkAccountService = this;

		//Get terms and conditions data
		linkAccountService.getDisclaimer = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/getTermsAndConditions", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		//Get getDataConsent
		linkAccountService.getDataConsent = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/getDisclaimer", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		//linkCustomer Account
		linkAccountService.linkCustomerAccount = function (reqParams) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/linkCustomerAccount", reqParams, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		return linkAccountService;
	});










