

angularApp.service('dematService',
	function($q,AdapterUtils){
		var dematService =this;	
		dematService.trackStatusData = {};
		/******Get demat list from service start*****/
		dematService.getDematDetails = function(reqParams) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/getDematAccount", reqParams, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
		/******demat list function end*****/
		
		/******Set demat A/C request start*****/
		dematService.dematAccountOpenRequest = function(reqParams) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/saveDematAOApplication", reqParams, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};

		/******Check Demat account exist in SBI CAP*****/
		dematService.checkDematOpenedInSbicap = function(reqParams) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/checkDematOpenedInSbicap", reqParams, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
		/******Track Application*****/
		dematService.trackApplicationDematAO = function() {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/trackApplicationDematAO", {}, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
	
	
				
		return dematService;
	});  