/** Open acccout services ***/
angularApp.service('openAccountService',
	function($q,AdapterUtils,$ionicPopup){
		var openAccountService =this;	
		var statusOfOpenAccount ='';
		var dpListResponse = '';
		var accountDetailResponse = '';

		openAccountService.selectedDetails = {
			selIndex:'',
			accountType: '',
			accountNumber: '',
			accountBalance: '',
			intCategory: '',
			accountTypeCode: '',
			amount: '',
			pin: '',
			hashyc:'',
			encpin:''
		};

		openAccountService.customer = {
			selectedItem: '',
			indexId: 0
		}
		openAccountService.displayPopUp = function (heading, css, message, buttonText, callBack) {
			$ionicPopup.alert({
				title: heading,
				template: '<div class="popupTextBottomPadding  ss-popup-list fontSize-subHeading roboto-medium text-center ' + css + '">'
				+ message + '</div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
				buttons: [
					{
						text: buttonText,
						onTap: function (e) {
							callBack();
						}
					}
				],
			});
		};
		//get openAccount details
		openAccountService.getOpenAccountDetails = function(reqParams) {
			var q = $q.defer();	
				AdapterUtils.postData("adapters/SBISecuritiesAdapter/createCustomerAccount", reqParams, true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
			); 
			return q.promise;
		
		};
		
	    //get userConsent 
		openAccountService.userConcent= function(reqParams) {
			var q = $q.defer();	
				AdapterUtils.postData("adapters/SBISecuritiesAdapter/getDataConsent", reqParams, true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
			); 
			return q.promise;
		
		}; 
		 //get userConsent 
		//get getDematAcctOpeningUpsellAndCharges 
		openAccountService.getDematWcmData= function() {
			var q = $q.defer();	
				AdapterUtils.postData("adapters/SBISecuritiesAdapter/getDematAcctOpeningUpsellAndCharges",{}, true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
			); 
			return q.promise;
		
		}; 

		//get SBICapSec Url for navigation 
		openAccountService.getRedirectionToSbicapUrl= function() {
			var q = $q.defer();	
				AdapterUtils.postData("adapters/SBISecuritiesAdapter/getRedirectionToSbicap",{}, true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
			); 
			return q.promise;
		
		}; 
		//checkDematAppExits status 
		openAccountService.checkDematApplicationExists= function(reqParams) {
			var q = $q.defer();	
				AdapterUtils.postData("adapters/SBISecuritiesAdapter/checkDematApplicationExists",reqParams, false).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
			); 
			return q.promise;
		
		};
		//viewCustomerInformation  
		openAccountService.viewCustomerInformation= function(payLoad) {
			var q = $q.defer();	
				AdapterUtils.postData("adapters/SBISecuritiesAdapter/viewCustomerInformation", payLoad , true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
			); 
			return q.promise;
		
		};
		//checkAccountModeOfOperation  
		openAccountService.checkAccountModeOfOperation= function(reqParams) {
			var q = $q.defer();	
				AdapterUtils.postData("adapters/SBISecuritiesAdapter/checkAccountModeOfOperation",reqParams,true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
			); 
			return q.promise;
		
		}; 
		//customerHasEligibleSavingsAccount  
		openAccountService.customerHasEligibleSavingsAccount= function() {
			var q = $q.defer();	
				AdapterUtils.postData("adapters/SBISecuritiesAdapter/customerHasEligibleSavingsAccount",{},true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
			); 
			return q.promise;
		
		}; 
		openAccountService.getSBIBankAccounts = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/FSSCommonAdapter/getOwnAccounts", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		openAccountService.getToolTipContent= function(reqParams) {
			var q = $q.defer();	
				AdapterUtils.postData("adapters/SBISecuritiesAdapter/getInfoContent", reqParams, true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
			); 
			return q.promise;
		
		}; 
		//GET DEMAT A/C TnC
		 //Get terms and conditions data
		openAccountService.getDematAccopeningTermsAndConditions = function() {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/SBISecuritiesAdapter/getDematAccopeningTermsAndConditions",  true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
			); 
			return q.promise;
		};
		
		//Check Pin Service
		openAccountService.getCityAndStateByPinCode = function(reqParams) {
			var q = $q.defer();	
				AdapterUtils.postData("adapters/SBISecuritiesAdapter/getCityAndStateByPinCode", reqParams, true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
			); 
			return q.promise;
		
		};
		//Check Pin Service
		openAccountService.getAOApplication = function(reqParams) {
			var q = $q.defer();	
				AdapterUtils.postData("adapters/SBISecuritiesAdapter/getAOApplication", reqParams, true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
			); 
			return q.promise;
		
		};
		//Check Pin Service
		openAccountService.getGenerateLead = function(reqParams) {
			var q = $q.defer();	
				AdapterUtils.postData("adapters/SBISecuritiesAdapter/getLeadResponse", reqParams, true).then(
					function(response){
						q.resolve(response.data);
					},
					function(error){
						q.reject(error);
					}
			); 
			return q.promise;
		
		};
		openAccountService.getOTP = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", {}, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		openAccountService.validateOTP = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure",obj, true).then(
				function (response) {
					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};
		
		openAccountService.showError = function(message,url,buttonText,callback){
            var confirmPopupIonic = $ionicPopup.alert({
				title: "",
				template: '<div class="popup-padding font-dark-grey"><div><center><img alt="" class="approvedIconPosition" src="img/FT/BhimUpi/errorSymbol.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="arsa-pop-msg-color">'
				+ message + '</span></div></div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                buttons: [{
                    text: buttonText ? buttonText : 'OK',
                    type: 'button-positive',
                    onTap: function () {
                        url ? callback() : confirmPopupIonic.close();
                    }
                }]
			})

        }

        openAccountService.showErrorCaution = function(message,url,buttonText,callback){
            var confirmPopupIonic = $ionicPopup.alert({
				title: "",
				template: '<div class="popup-padding font-dark-grey"><div><center><img alt="" class="approvedIconPosition" src="img/yc_Group.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="arsa-pop-msg-color">'
				+ message + '</span></div></div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                buttons: [{
                    text: buttonText ? buttonText : 'OK',
                    type: 'button-positive',
                    onTap: function () {
                        url ? callback() : confirmPopupIonic.close();
                    }
                }]
			})

        }

        openAccountService.formPopUpTemplate = function(array,controllerName){
            var template = '<div class="font-dark-grey irctc">'+
            '<div ng-repeat="acc in '+ array + ' track by $index">'+
            '<div class="row  borderbtm" ng-click="'+controllerName + '.close($index)">'+
            '<div class="col las-p-t-2pt2per font-size-20 roboto-regular color545454">₹ {{acc.balance |INR}}</div>'+
            '<div class="col padTopBTM30 font-size-12 roboto-medium color545454">{{acc.benAccntType}} <br><span class="font-size-14 roboto-medium color545454">{{acc.benAccntNo  | cardmask:"X":4}}</span></div>'+
            '</div></div></div>';
            return template;
        }

        openAccountService.displayPopUp = function (heading, css, message, buttonText, callBack) {
			$ionicPopup.alert({
				title: heading,
				template: '<div class="popupTextBottomPadding  ss-popup-list fontSize-subHeading roboto-medium text-center ' + css + '">'
				+ message + '</div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite ss-popup',
				buttons: [
					{
						text: buttonText,
						onTap: function (e) {
							callBack();
						}
					}
				],
			});
		};

		openAccountService.showErrorCaution = function(heading, css, message, buttonText, callBack){
            $ionicPopup.alert({
				title: "",
				template: '<div class="popup-padding font-dark-grey"><div><center><img alt="" class="approvedIconPosition" src="img/yc_Group.svg"></center></div></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter marBtm20"><span class="demat-pop-msg-color">'
				+ message + '</span></div></div></div>',
				cssClass: 'removePopup-head popupWidth90 popupMargin popupBackgroundWhite inb-pop-btn ss-popup',
                buttons: [{
                    text: buttonText ? buttonText : 'OK',
                    type: 'button-positive',
                    onTap: function (e) {
							callBack();
						}
                }]
			});

        }

        openAccountService.showAlertModal = function (title, template, onTapgo, $scope, state, buttontext,minorForAO,accountOpeningHomeService) {
			var alertPopup = $ionicPopup.alert({
				title: title,
				template: template,
				scope: $scope,
				cssClass: 'arsa-alert-popup',
				buttons: [
					{
						text: buttontext,
						type: 'button-positive',
						onTap: function () {
							alertPopup.close();
						}
					}
				],
			});
			alertPopup.then(function (res) {
			});
		};
		//get set Status 
		openAccountService.setStatusOfOpenAccount= function(statusOfOA) {
			statusOfOpenAccount=statusOfOA;
		};
		//get getStatus 
		openAccountService.getStatusOfOpenAccount= function() {
			return statusOfOpenAccount;
		};
		//set dpList 
		openAccountService.setDpList= function(dpList) {
			dpListResponse=dpList;
		};
		//get dpList 
		openAccountService.getDpList= function() {
			return dpListResponse;
		};

		// set account details
		openAccountService.setAccountDetails= function(accountDetails) {
			accountDetailResponse = accountDetails;
		};
		//get account details 
		openAccountService.getAccountDetails= function() {
			return accountDetailResponse;
		};
		
		return openAccountService;
	});  
