/** ***** Introduction Mutual funds Controller ***** */
'use strict';

angularApp
		.controller(
				'securityKnowledgeSeriesController',
				[
						"$timeout",
						"$state",
						"$scope",
						"$translate",
						"$location",
						"$ionicScrollDelegate",
						"utilityService",
						"$sce",
						"introSecurityService",
						"homeScreenService",
						
						function($timeout, $state, $scope, $translate,
								$location, $ionicScrollDelegate,
							 utilityService, $sce,introSecurityService,homeScreenService) {
							 var securityKnowledgeSeriesVm=this;
							 
							
							function initPage() {
								securityKnowledgeSeriesVm.isBackCheck=homeScreenService.isBackCheck;
								homeScreenService.isBackCheck	=false;
								introSecurityService.getSecuritiesKnowledgeSeries().then(
												function(data) {
													
													securityKnowledgeSeriesVm.dataList = data.knowledgeList;
													securityKnowledgeSeriesVm.dataLoaded = true;
												},
												function(error) {
													
													utilityService.showErrorMessage(error.responseMessage);
												});
							}

							securityKnowledgeSeriesVm.redirectToDetailPage = function(answer,question) {
								introSecurityService.answer=answer;
								introSecurityService.question=question;
								$state.go('menu.securityKnowledgeSeriesDetail');
							};

							securityKnowledgeSeriesVm.redirectToFAQ = function() {
								
								$state.go('menu.FAQ');
							};
							$scope.$on('$ionicView.loaded', function() {
								initPage();
							});

							return this;
						} ]);
