

'use strict';
angularApp.controller('securityLandingController', 
	["$timeout",
	 "$state",
	 "$scope",
	 "$translate",
	 "$location",
	 "$ionicScrollDelegate","mutualFundsService","utilityService","$ionicSlideBoxDelegate","$rootScope","loggedInUserService","getAccountDetailsService","introSecurityService","homeScreenService","newCardService",
				 
function ($timeout,
		 $state,
		 $scope,
		 $translate,
		 $location,
		 $ionicScrollDelegate,mutualFundsService,utilityService,$ionicSlideBoxDelegate,$rootScope,loggedInUserService,getAccountDetailsService,introSecurityService,homeScreenService,newCardService) {
	
	var securityLandingControllerVm = this;    
	
	
	function initPage(){
		if(loggedInUserService.isLoggedInDetails.isLoggedIn){
			securityLandingControllerVm.isLoggedIn = true
		}else{
			securityLandingControllerVm.isLoggedIn = false
		}
		
    }
	
	
	securityLandingControllerVm.goToHome=function (){
		if(loggedInUserService.isLoggedInDetails.isLoggedIn){
			$state.go('menu.accountOverviewMyBalance');
		}else{
			$state.go('menu.leadGenerationInvestment');
		}
		
	}
	
	securityLandingControllerVm.introSecurities=function()
	{
		$state.go('menu.introSecurities');
		
		
	}
	
	securityLandingControllerVm.goToOverview=function()
	{
		if(newCardService.getPreLoginSelectedMenu() == 'linkOrOpenNewAcc'){
			loggedInUserService.productClicked = 'menu.termsAndConditionsOutboundAnalytics';
        	 $state.go('menu.userLogin');
		}
		else{
			getAccountDetailsService.tabIndex.tabIndex=3;
			homeScreenService.isInvestmentFlag = true;
			$state.go('menu.accountOverviewMyBalance');
		}
	}
	
	securityLandingControllerVm.knowledgeSeries=function()
	{
		$state.go('menu.securityKnowledgeSeries');
		
		
	}
	
	$scope.slideChanged=function(index)
	{
		
		$scope.slideInfo=securityLandingControllerVm.list[index].slideInfo;
	}
	
	$scope.$on('$ionicView.beforeEnter', function() {
		
		
		
		introSecurityService.getSecuritiesSlider().then(function(data){
			
			securityLandingControllerVm.list=data.slideList;
			$ionicSlideBoxDelegate.update();
			$scope.slideInfo=data.slideList[0].slideInfo;
		}, function(error){
			
			utilityService.showErrorMessage(error.responseMessage);
		});
	});
	
	 $scope.$on('$ionicView.loaded', function() {
        initPage();
    });

		$scope.$on('$ionicView.afterLeave', function() {
	});
	
	return this;
}]);

