'use strict';
angularApp.controller('manageEstatementSuccessController', [
		"$state",
		"$scope",		
		"utilityService",
		"$filter",
		"manageEstatementService",
		"$translate",
		function($state, $scope,utilityService,$filter,manageEstatementService,$translate) {
			
			var manageEstatementSuccessVm = this;
			//sbiQuickSuccessVm.reference = "1234567890";
			function initPage(){
				manageEstatementSuccessVm.successMsg = "";
				
				manageEstatementSuccessVm.refNumber = manageEstatementService.refNumber;
				if(manageEstatementService.checkRegOrDereg == 'register')
					{
						manageEstatementSuccessVm.accountNumber = manageEstatementService.registerData.accountNumber;
						$translate(['E_STMT_SUCCESS'],{status : 'registered for'}).then(function (translations) {
							manageEstatementSuccessVm.successMsg = translations['E_STMT_SUCCESS'];
					
						});
					}
					else{
						manageEstatementSuccessVm.accountNumber = manageEstatementService.DeRegisterData.accountNumber;
						$translate(['E_STMT_SUCCESS'], {status : 'de-registered'}).then(function (translations) {
							manageEstatementSuccessVm.successMsg = translations['E_STMT_SUCCESS'];
					
						});
					}
			}

			
			manageEstatementSuccessVm.goToNCMCLanding = function(){
				$state.go('menu.homeScreen');
			}
			manageEstatementSuccessVm.goToHomePage = function(){
				$state.go('menu.homeScreen');
			}
			$scope.$on('$ionicView.beforeEnter', function() {
				initPage();
			});
			
			return this;
		}

		
]);