angularApp.service('manageEstatementService',
	function ($q, utilityService, AdapterUtils, $state, $cordovaSms, $ionicPopup) {
		var MEService = this;
		MEService.myTab = 'Y';
		MEService.registerData = {
			"accountNumber" : "",
			"frequency" : "",
			"month" : "",
			"day" : ""
		};
		MEService.DeRegisterData = {
			"accountNumber" : ""
		};
		MEService.checkRegOrDereg = '';
		MEService.refNumber = '';
		MEService.custEmail = '';

		MEService.initializeValues = function(){
			MEService.registerData = {
			"accountNumber" : "",
			"frequency" : "",
			"month" : "",
			"day" : ""
		};
		MEService.checkRegOrDereg = '';
		MEService.refNumber = '';
		MEService.DeRegisterData = {
			"accountNumber" : ""
		};
		MEService.custEmail = '';
		MEService.myTab = 'Y';
		};

		MEService.accountListPopupTemplate = function(array,controllerName,type){
        var template = '<div class="font-dark-grey irctc">'+
                '<div ng-repeat="acc in '+ array + ' track by $index">'+
                    '<div class="row  borderbtm" ng-click="'+controllerName + '.close($index,'+controllerName+'.selTab)">'+
                    '<div class="col padtop10 font-size-12 roboto-regular color545454 ncmc-txt-left width55">{{acc.branchName}}-{{acc.branchCode}}</div>'+
                    '<div class="col padTopBTM30 font-size-12 roboto-medium color545454 ncmc-txt-right width45 txt-ovrflow-hide">{{acc.accountType}}<br><span class="font-size-14 roboto-medium color545454">{{acc.accountNumber | mask:"X":4}}</span></div>'+
                    '</div></div></div>';
        return template;
   }
	MEService.getOtp = function() {
	    var q = $q.defer();
	    AdapterUtils.postData("adapters/OTPAdapter/getOTPTokenSecure", {}, true).then(
		    function(response) {
		        q.resolve(response.data);
		    },
		    function(error) {
		        q.reject(error);
		    }
	    );
        return q.promise;
    };

    MEService.validateOtp = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/OTPAdapter/validateOTPTokenSecure", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };
    MEService.doRegistration = function(payLoad) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/EStatement/getRegistration", payLoad, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };
    MEService.getRegAccountList = function() {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/EStatement/getAccountList", {}, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };
    MEService.getAccountToCif = function(payload) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/EStatement/getAccountToCif", payload, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };

    MEService.getUnmaskData = function(payload) {
        var q = $q.defer();
        AdapterUtils.postData("adapters/ServiceRequestAdapter/EStatement/getUnmaskData", payload, true).then(
            function(response) {
                q.resolve(response.data);
            },
            function(error) {
                q.reject(error);
            }
        );
        return q.promise;
    };
   
		MEService.showAlertPopup = function (imageType, message, onTapgo, buttontext1, buttontext2, $scope) {
			var btn_array = [];
			if(buttontext1 != "" && buttontext2 != ""){
				btn_array = [
					{
						text: buttontext2 || "Cancel",
						type: 'button-negative',
						onTap: function () {
							
						}
					},
					{
						text: buttontext1 || "OK",
						type: 'button-positive',
						onTap: function () {
							if (onTapgo) {
								$state.go(onTapgo);
							}
						}
					}
				];
			}
			else{
				btn_array = [
					{
						text: buttontext1 || "OK",
						type: 'button-positive',
						onTap: function () {
							if (onTapgo) {
								$state.go(onTapgo);
							}
						}
					}
				];
			} 

			if(imageType && imageType.toLowerCase() == 'error'){
				imageType = 'img/FT/BhimUpi/errorSymbol.svg';
			} else if(imageType && imageType.toLowerCase() == 'success'){
				imageType = 'img/FT/BhimUpi/successSymbol.svg';
			}else{
				imageType = 'img/FT/BhimUpi/alertSymbol.svg';
			}
			var bhimErrorPopup = $ionicPopup.alert({
				template: '<div class="font-dark-grey"><div><img class="approvedIconPosition" src='+imageType+' /></div><div class="roboto-regular trans-popup fontSize-title errorColor"></div></div><div class="popupTextBottomPadding fontSize-subHeading"><div class="textAlignCenter"><span>'
				+ message + '</span></div></div></div>', //template,
				scope: $scope,
				cssClass: 'bhim-alert-popup',
				buttons: btn_array,
			});
			bhimErrorPopup.then(function (res) {
			});
		};



		
		return MEService;
	});  