'use strict';

angularApp.controller('scheduledInstaDetailsController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "utilityService",
    "$ionicPopup",
	"serviceRequestService",

    function($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        utilityService,
        $ionicPopup,
		serviceRequestService) {

        //functions, variables that can be accessed from the HTML template
        var scheduledInstaDetailsVm = this;    
         
        scheduledInstaDetailsVm.goBacktoPrevious = function() { 
	        $state.go('menu.scheduledRequests');
	    }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
			scheduledInstaDetailsVm.storeRefNumber = serviceRequestService.getRequestDetailData.serviceDetail.storeRefNumber;
			scheduledInstaDetailsVm.amount = (serviceRequestService.getRequestDetailData.serviceDetail.disbursedAmount ? serviceRequestService.getRequestDetailData.serviceDetail.disbursedAmount : '');
			scheduledInstaDetailsVm.rateofinterest = serviceRequestService.getRequestDetailData.serviceDetail.intRate;			   
			scheduledInstaDetailsVm.status = serviceRequestService.getRequestDetailData.serviceDetail.status;
			  
        });
        return this;
    }
]);