'use strict';

angularApp.controller('scheduledRDDetailsController', ["$timeout",
    "$state",
    "$location",
    "$scope",
    "$rootScope",
    "utilityService",
    "$ionicPopup",
	"serviceRequestService",

    function($timeout,
        $state,
        $location,
        $scope,
        $rootScope,
        utilityService,
        $ionicPopup,
		serviceRequestService) {

        //functions, variables that can be accessed from the HTML template
        var scheduledRDDetailsVm = this;    
         
        scheduledRDDetailsVm.goBacktoPrevious = function() { 
	        $state.go('menu.scheduledRequests');
	    }

        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function() {
			scheduledRDDetailsVm.storeRefNumber = serviceRequestService.getRequestDetailData.serviceDetail.storeRefNumber;
			scheduledRDDetailsVm.amount = serviceRequestService.getRequestDetailData.serviceDetail.amount;
			scheduledRDDetailsVm.rateofinterest = serviceRequestService.getRequestDetailData.serviceDetail.interestRate;			   
			scheduledRDDetailsVm.status = serviceRequestService.getRequestDetailData.serviceDetail.status;
			  
        });
        return this;
    }
]);