'use strict';

angularApp.controller('serviceRequestController', ["$timeout",
  "$state",
  "$location",
  "$scope",
  "$rootScope",
  "customerInfoService",
  "emaillDetailsService",
  "utilityService",

  "$ionicPopup", "serviceRequestService",
  "smsAlertActivationService",
  "homeScreenService",
  "getAccountDetailsService",
  "updateKYCService",
  function ($timeout,
      $state,
      $location,
      $scope,
      $rootScope,
      customerInfoService,
      emaillDetailsService,
      utilityService,

      $ionicPopup, serviceRequestService,
      smsAlertActivationService,
      homeScreenService,
      getAccountDetailsService,
      updateKYCService) {

      //functions, variables that can be accessed from the HTML template
      var serviceRequestVm = this;
      serviceRequestVm.serviceList =[];
      var accOverviewData = getAccountDetailsService.accountOverviewData;
      function isEmpty(obj) {
          return !Object.keys(obj).length > 0;
      }
        serviceRequestVm.innerPageEmergency = function (selectedItem) {
             if (selectedItem == "menu.smsAlertActivation") {
              var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
              if (isEmptyCustomerInfo == false) {
                  if (customerInfoService.customer.residentialStatus == "1") {
                      serviceRequestService.kycValidation().then(function (data) {
                          serviceRequestVm.kycValidation = data.flag;
                          if (serviceRequestVm.kycValidation == "TRUE") {
                        serviceRequestService.kycAndNightModeValidation().then(function (data) {

				serviceRequestService.isNightMode = data.isNightMode;

				if (serviceRequestService.isNightMode) {

					var NightModetxt = "Request can not be processed now. Please try between 08:00 Hrs(IST) to 20.00 Hrs(IST).";
					utilityService.showNfsAlertModal("", NightModetxt, "menu.homeScreen", $scope, $state, "OK", "errorImgTitle");
				} 
                
                else {
					$state.go(selectedItem)

				}

			}, function (error) {
				utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
			});
                          }else{
                               var errorText = "User is not KYC complaint,Can-not proceed.";
                      utilityService.showNfsAlertModal("", errorText, "menu.homeScreen", $scope, $state, "OK");
                          }
                      }, function (error) {
                           utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
                           
                      });
                     // KYC VALIDATION END here
                  } else {
                      var errorText = "Sorry, you cannot access SMS Alert Activation online.Please visit / contact your home branch.";
                      utilityService.showNfsAlertModal("", errorText, "menu.homeScreen", $scope, $state, "OK");
                  }

              } else {
                  var errorData = "Something went wrong. Please try again after sometime.";
                  utilityService.showNfsAlertModal("", errorData, "menu.homeScreen", $scope, $state, "OK");

              }

          }else if(selectedItem==="menu.settings"){
          $state.go(selectedItem);
        }else if (selectedItem==="menu.profilePwd"){

          serviceRequestService.innerpageHeader = "ATM/Debit Card";
          serviceRequestService.imageIcon='img/serviceRequest/Cards.svg';
          serviceRequestService.innerLinks=serviceRequestService.getDebitCardOptions();
          serviceRequestVm.checkProfilePasswordFlag(selectedItem);
          //$state.go(selectedItem);

         }

        else if (selectedItem==="menu.stopCheque"){
          serviceRequestService.backFlag="emergencyFlag";
          $state.go(selectedItem);
        } else if (selectedItem === "menu.updateKYCProfilePassword") {
            updateKYCService.checkEligibilityKYC().then(function (data) {
                $state.go(selectedItem);
            }, function (error) {
                if(error.responseMessage.indexOf('|') > -1){
                    let errorMsg = error.responseMessage.split('|')
                    if(errorMsg.length == 3){
                        updateKYCService.showAlertPopup("alert", errorMsg[0], errorMsg[1],errorMsg[2], "", "OK", "", "", "");
                    }else{
                        updateKYCService.showAlertPopup("alert", errorMsg[0], errorMsg[1],"", "", "OK", "", "", "");
                    }
                }else{
                    updateKYCService.showAlertPopup("alert", error.responseMessage, "", "", "", "OK", "", "", "");
                }
            });
        }
      };

      serviceRequestVm.checkProfilePasswordFlag = function(page){
            var profPassObj = {
                prevPage:"menu.serviceRequest",
                nextPage:page,
                goto:"menu.setProfilePassword",
                ionicPopup:$ionicPopup,
                accOverviewData:accOverviewData
            };
            getAccountDetailsService.commonfunForProfilePassCheck(profPassObj);
      }

      serviceRequestVm.innerPage = function (selectedObj) {


          serviceRequestVm.extURL = selectedObj;

           if (serviceRequestVm.extURL == "ATM/Debit card") {
              serviceRequestService.innerpageHeader = "ATM/Debit Card";
              serviceRequestService.imageIcon='img/serviceRequest/Cards.svg';
              serviceRequestService.innerLinks=serviceRequestService.getDebitCardOptions();
              serviceRequestVm.checkProfilePasswordFlag("menu.profilePwd");
              //$state.go('menu.profilePwd');
          } else if (serviceRequestVm.extURL == "Tax & Investments") {
             serviceRequestService.innerpageHeader = "Tax & Investments";
             serviceRequestService.imageIcon='img/serviceRequest/Tax.svg';
               serviceRequestService.innerLinks=serviceRequestService.getTaxInvOptions();
              $state.go('menu.innerPage');
          }  else if (serviceRequestVm.extURL == "Pension" ){
             serviceRequestService.innerpageHeader = "Pension";
              serviceRequestService.imageIcon='img/serviceRequest/Pension.svg';
              serviceRequestService.innerLinks=serviceRequestService.getPensionOptions();
              $state.go('menu.innerPage');

          } else if (serviceRequestVm.extURL == "Loans") {
              $state.go('menu.loans');
          } else if (serviceRequestVm.extURL == "Settings") {
              $state.go('menu.settings');
          }  else if (serviceRequestVm.extURL == "pending request") {
              $state.go('menu.pendingRequest');
            } 
			else if (serviceRequestVm.extURL == "Doorstep Services") {
                $state.go('menu.DSBSLanding');
          }  
          else if (serviceRequestVm.extURL == "Government Schemes") {
              $state.go('menu.governmentSchemesLanding');
          }
		  else if (serviceRequestVm.extURL == "Cheques") {
            serviceRequestService.backFlag="";
              var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
              if (isEmptyCustomerInfo == false) {

                 // if (customerInfoService.customer.residentialStatus == "1") {
                      serviceRequestService.innerpageHeader = "Cheques";
                      serviceRequestService.imageIcon='img/serviceRequest/Cheque.svg';
                      serviceRequestService.innerLinks=serviceRequestService.getChequeOptions();
                      $state.go('menu.innerPage');
                  /*} else {
                      var errorText = "Sorry, you cannot access cheque services online.Please visit / contact your home branch.";
                      utilityService.showNfsAlertModal("", errorText, "menu.homeScreen", $scope, $state, "OK");
                  }*/

                } else {
                    var errorData = "Something went wrong. Please try again after sometime.";
                    utilityService.showNfsAlertModal("", errorData, "menu.homeScreen", $scope, $state, "OK");

              }

          }
    else if (serviceRequestVm.extURL == "Account") {
              serviceRequestService.innerpageHeader = "Account";
              serviceRequestService.imageIcon='img/serviceRequest/Account.svg';
              serviceRequestService.innerLinks=serviceRequestService.getAccountOptions();
               $state.go('menu.innerPage');
          }
          else if (serviceRequestVm.extURL == "Profile") {
              var isEmptyCustomerInfo = isEmpty(customerInfoService.customer);
              if (isEmptyCustomerInfo == false) {

                    if (customerInfoService.customer.residentialStatus == "1") {

                        //KYC VALIDATION start here

                        serviceRequestService.kycValidation().then(function (data) {
                            serviceRequestVm.kycValidation = data.flag;

                            if (serviceRequestVm.kycValidation == "TRUE") {
           			    emaillDetailsService.clearAllData();
                                $state.go('menu.emailDetails');
                            }

                        }, function (error) {
                           // utilityService.showErrorMessage(error.responseMessage);
                             utilityService.showNfsAlertModal("", error.responseMessage, "menu.homeScreen", $scope, $state, "OK");
                        });

                        //KYC VALIDATION END here



                       
                    } else {
                        var errorText = "Sorry, you cannot access Personal Details services online.Please visit / contact your home branch.";
                        utilityService.showNfsAlertModal("", errorText, "menu.homeScreen", $scope, $state, "OK");
                    }

                } else {
                    var errorData = "Something went wrong. Please try again after sometime.";
                    utilityService.showNfsAlertModal("", errorData, "menu.homeScreen", $scope, $state, "OK");

                }
            }


            else {

                //$state.go('menu.innerPage');
            }

        };

        serviceRequestVm.scheduledRequest = function () {
        $state.go('menu.scheduledRequests');
        };

        serviceRequestVm.goBacktoPrevious = function () {
        $state.go('menu.homeScreen');
        }


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
        //serviceRequestVm.isBackCheck = homeScreenService.isBackCheck;
	     // homeScreenService.isBackCheck = false;
       if(homeScreenService.ishamburgerMenuSR){
         serviceRequestVm.isHamCheck = true;
         serviceRequestVm.isBackCheck = true;
       }else {
         serviceRequestVm.isBackCheck = false;
         serviceRequestVm.isHamCheck = false;
       }
      serviceRequestService.callCenterNo="1800 11 1101";
      });
      return this;
  }
]);
