'use strict';

angularApp.controller('updateKYCPersonalDetailsController',
    ["$timeout",
        "$state",
        "$scope",
        "$translate",
        "$ionicPopup",
        "utilityService",
        "$ionicHistory",
        "loggedInUserService",
        "fTReviewService",
        "constantConfig",
        "$ionicScrollDelegate",
        "updateKYCService",
        function ($timeout,
            $state,
            $scope,
            $translate,
            $ionicPopup,
            utilityService,
            $ionicHistory,
            loggedInUserService,
            fTReviewService,
            constantConfig,
            $ionicScrollDelegate,
            updateKYCService
        ) {

            var updateKYCPersonalDtlsVm = this;

            updateKYCPersonalDtlsVm.goToPrevious = function () {
                $state.go("menu.updateKYCProfilePassword")
            }

            updateKYCPersonalDtlsVm.goToNextPage = function () {
                if (updateKYCPersonalDtlsVm.changeAddress == "true") {
                    $state.go("menu.updateKYCAddress")
                } else {
                    if (!updateKYCPersonalDtlsVm.addChangeDeclaration) {
                        utilityService.showErrorMessage("Please check the checkbox.");
                    } else {
                        updateKYCService.getOtpSecure().then(function (data) {
                            $state.go("menu.updateKYCVerifyOtp")
                        }, function (error) {
                            utilityService.showErrorMessage(error.responseMessage);
                        });
                    }
                }
            }

            updateKYCPersonalDtlsVm.resizeContent = function () {
                $ionicScrollDelegate.$getByHandle('mainScroll').resize();
            }

            $scope.$on('$ionicView.beforeEnter', function () {
                updateKYCPersonalDtlsVm.customerDetails = updateKYCService.customerDetails;
                updateKYCPersonalDtlsVm.changeAddress = "false";
            });

            return this;
        }]);
