'use strict';

angularApp.controller('updateKYCSuccessController',
    ["$timeout",
        "$state",
        "$scope",
        "$translate",
        "$ionicPopup",
        "$filter",
        "utilityService",
        "$ionicHistory",
        "loggedInUserService",
        "fTReviewService",
        "constantConfig",
        "customerInfoService",
        "updateKYCService",
        function ($timeout,
            $state,
            $scope,
            $translate,
            $ionicPopup,
            $filter,
            utilityService,
            $ionicHistory,
            loggedInUserService,
            fTReviewService,
            constantConfig,
            customerInfoService,
            updateKYCService
        ) {

            var updateKYCSuccessVm = this;

            updateKYCSuccessVm.goToPrevious = function () {
                $ionicHistory.goBack();
            }

            updateKYCSuccessVm.goToNextPage = function () {
                $state.go("menu.homeScreen")
            }

            $scope.$on('$ionicView.beforeEnter', function () {
                updateKYCSuccessVm.cif = customerInfoService.customerInfo.cif;
                updateKYCSuccessVm.name = updateKYCService.customerDetails.firstName + ' ' + updateKYCService.customerDetails.lastName;
                updateKYCSuccessVm.currentDate = $filter('date')(new Date(), 'dd/MM/y')
            });

            return this;
        }]);
