angularApp.service('manageVpaService',
	function($q,AdapterUtils){
		var MVservice =this;	
		//this function is define to call service to get VPA list
		MVservice.getVPA = function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/SettingsAdapter/getVPA", reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
		//this function is define to call delete VPA service
		MVservice.deleteVPA = function(reqData) {
			var q = $q.defer();	
			
			AdapterUtils.postData("adapters/SettingsAdapter/deleteVPA", reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
		//this function is define to call service to check VPA availability
		MVservice.checkVPAAvailability = function(reqData) {
			var q = $q.defer();	
			AdapterUtils.postData("adapters/SettingsAdapter/checkVPAAvailability	", reqData, true).then(
				function(response){
					q.resolve(response.data);
				},
				function(error){
					q.reject(error);
				}
				); 
			return q.promise;
		};
		
		return MVservice;
	});  