'use strict';

angularApp.controller('FAQController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope",
						 "$ionicSideMenuDelegate",
						 "supportServices","utilityService","homeScreenService",

function ($timeout,
		 $state,
		 $location,
		 $scope,
		 $ionicSideMenuDelegate,
		 supportServices,utilityService,homeScreenService) {

	//functions, variables that can be accessed from the HTML come here
	var FAQVm = this;
	//private methods section start
	function initPage(){
		FAQVm.isBackCheck = homeScreenService.isBackCheck;
		homeScreenService.isBackCheck = false;
		FAQVm.showBack = false;
		FAQVm.showNext = true;
		getFaqCatList();
	}
	
	var getFaqCatList = function(){
		 /*************************submit faq categories start************************************/	
		var reqData = {
			"url": ""
		} 
		supportServices.getFAQCategories(reqData).then(function(data){	 	
			var resData = data;			
				FAQVm.faqCategoryLists = resData.getFAQCategoriesLists;
				
			},function(error){
					  utilityService.showErrorMessage(error.responseMessage);
 			});
        /*************************submit faq categories end************************************/				
		
	}
	  /*************************Go to Details page ************************************/	
		FAQVm.transQuery = function(faqData){
			if(faqData.sbiFAQCategoryName == "Service Request" || faqData.sbiFAQCategoryName == "General Banking" || faqData.sbiFAQCategoryName == "e-Taxes" || faqData.sbiFAQCategoryName == "E-Statement" || faqData.sbiFAQCategoryName.toLowerCase() == "upi" || faqData.sbiFAQCategoryName == "PPF Account"){
					supportServices.faqData=faqData;
					$state.go('menu.nfsFaq',{obj:faqData});
					supportServices.fromNFS=true;

			}else{
					$state.go('menu.FAQDetails',{obj:faqData});
					supportServices.fromNFS=false;
			}
		
			
		}
	
	//back to prev page
	FAQVm.goBacktoPrevious = function(){
		//To do
		if(homeScreenService.isRedirectionFromHomeScreen){
				homeScreenService.isRedirectionFromHomeScreen = false;
				$state.go('menu.homeScreen');
		}
		else{
				$state.go('menu.support');
		}
	}
	//one time initialization to be done when the controller is loaded
		$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false)

		initPage();
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(true)

	});
	return this;
}]);
