'use strict';

angularApp.controller('categoryWiseQueryController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope",
				         "$ionicPopup","supportServices","$stateParams","$rootScope","$ionicSideMenuDelegate","utilityService",
function ($timeout,
		 $state,
		 $location,
		 $scope,
		 $ionicPopup,supportServices,$stateParams,$rootScope,$ionicSideMenuDelegate,utilityService) {
	
	
	var categoryWiseQueryVm= this;
	
	//functions, variables that can be accessed from the HTML come here
	function initPage(){
		categoryWiseQueryVm.showBack = false;
		categoryWiseQueryVm.showNext = true;
		categoryWiseQueryVm.selectedsavings="";
		categoryWiseQueryVm.queryType = $stateParams.obj;
		
	
	
		/*************************Check Account Details start ************************************/	
		supportServices.getAccountDetails().then(function(data){
				if($stateParams.obj=="CARDS"){
					categoryWiseQueryVm.creditCardList=data.creditCards;
					categoryWiseQueryVm.currentAccountObj=data.creditCards;
					$timeout(function(){
						categoryWiseQueryVm.selectedsavings=categoryWiseQueryVm.currentAccountObj[0].type+"_"+categoryWiseQueryVm.currentAccountObj[0].creditCardNo+"_"+categoryWiseQueryVm.currentAccountObj[0].outstandingTotal;
					},200);
				}else{
					categoryWiseQueryVm.accountList=data.accounts;
					$timeout(function(){
						categoryWiseQueryVm.selectedsavings=categoryWiseQueryVm.accountList[0].accountType+"_"+categoryWiseQueryVm.accountList[0].accountNumber+"_"+categoryWiseQueryVm.accountList[0].accountBalance;
					},200);
					categoryWiseQueryVm.currentAccountObj=data.accounts;
				}
				categoryWiseQueryVm.callTransactionHistory();
				$timeout(function(){
					categoryWiseQueryVm.callTransactionHistory();
				},1000);
				
			
	    });	
		
	/*************************Check Account Details  end************************************/	
	}
	
	/*************************Check transaction history  start************************************/	
	categoryWiseQueryVm.callTransactionHistory=function(){
		categoryWiseQueryVm.reqParams={};
		categoryWiseQueryVm.reqParams['accountNumber']=categoryWiseQueryVm.selectedsavings.split('_')[0]; 
		supportServices.getRecentTransactions(categoryWiseQueryVm.reqParams).then(function(data){
			categoryWiseQueryVm.transactionHistory=data.transactions;
			},function(error){
			 utilityService.showErrorMessage('There is some technical issue. Please try after some time !');
			
		});
	}
	/*************************Check transaction history  end************************************/	
	//On change event of account drop down
	categoryWiseQueryVm.changeAccount=function(transactionDetails){
		categoryWiseQueryVm.callTransactionHistory();
		
	}
	
	//Function to click on transaction history and go to next page
	categoryWiseQueryVm.selectQueryOption=function(transactionDetails,index){
		categoryWiseQueryVm.Selected=index;
		categoryWiseQueryVm.currentTransactionDetails=transactionDetails;	
	}
	/*************************open popoup after click on transaction start************************************/	
	categoryWiseQueryVm.openSendQueryPage=function(transactionDetails){
		$rootScope.queryDescription = "";
		$scope.transactionDetails=transactionDetails;
		categoryWiseQueryVm.currentAccount=categoryWiseQueryVm.selectedsavings.split('_')[1];
		categoryWiseQueryVm.currentAccountType=categoryWiseQueryVm.selectedsavings.split('_')[0];
		categoryWiseQueryVm.currentAccountBalance=categoryWiseQueryVm.selectedsavings.split('_')[2];
		
		$scope.accountNumber=categoryWiseQueryVm.currentAccount;
		$scope.accountType=categoryWiseQueryVm.currentAccountType;
		$scope.accountBalance=categoryWiseQueryVm.currentAccountBalance;
		$scope.category= $stateParams.obj;	
		
		if(!categoryWiseQueryVm.currentAccount){
		
				categoryWiseQueryVm.currentAccount=categoryWiseQueryVm.selectedsavings.split('_')[1];
				$scope.account=categoryWiseQueryVm.currentAccount;
		}
		else{
			// $scope.account=JSON.parse(categoryWiseQueryVm.currentAccount); 
			$scope.account=categoryWiseQueryVm.currentAccount; 
		}
		if(transactionDetails!=undefined && transactionDetails!="")
		{    
			$scope.date='';
			$scope.time='';
			$scope.amount='';
			$scope.transactionReferenceNumber='';
			$scope.tranferredName = '';
			$scope.transactionReferenceNumber = '';
			$scope.date = transactionDetails.date;
			$scope.time = transactionDetails.time;
			$scope.amount =transactionDetails.paidAmount;
			$scope.tranferredBy = transactionDetails.comments;
			$scope.transactionReferenceNumber = transactionDetails.referenceId;
			  var alertPopup = $ionicPopup.alert({
				templateUrl:'pages/support/raiseQuery/queryOption.html',
				cssClass: 'dialog-query',
				scope: $scope,
				buttons:null,
			   });
			    
		           $rootScope.queryRequired = function()
				   {
									if($rootScope.queryDescription == "" || $rootScope.queryDescription == undefined)
							{
								 $rootScope.queryRequiredError = true;					 
							}				  
						else { categoryWiseQueryVm.showPopup($scope.category,$scope.transactionReferenceNumber,$scope.accountNumber,$rootScope.queryDescription);
						         alertPopup.close();
								 
							 }
					   
				   }
				   
				    $rootScope.closeQueryPopup = function()
				   {
					   alertPopup.close();
					   
				   }
		 }
		else {
			$scope.transactionReferenceNumber='';
			   var alertPopup = $ionicPopup.alert({
				title: '',
				templateUrl:'pages/support/raiseQuery/queryOption.html',
				scope: $scope,
				 cssClass: 'dialog',
				 buttons:null,
			});
			    $rootScope.queryRequired = function()
				   {
					   	if($rootScope.queryDescription == "" || $rootScope.queryDescription == undefined)
				{
					 $rootScope.queryRequiredError = true;
                     					 
				}				  
		      	else { categoryWiseQueryVm.showPopup($scope.category,$scope.transactionReferenceNumber,$scope.accountNumber,$rootScope.queryDescription);
				         alertPopup.close();
			     }
					   
				   }
				   
				    $rootScope.closeQueryPopup = function()
				   {
					   alertPopup.close();
					   
				   }
		}
	}
	  /*************************open popoup after click on transaction end************************************/	
	  
	  
	   /**************open popoup after click on previous popup ok button and generate query ref number - start*************/	
	categoryWiseQueryVm.showPopup = function(category,transactionReferenceNumber,accountNumber,queryDes){
		    $scope.queryNumber = "";
			var customerName = $rootScope.customerName;
			var reqParams={};
			reqParams['accountNumber'] =accountNumber;
			reqParams['name']= customerName; //Global variable come from account overview session
			reqParams['category'] = category;
			reqParams['transactionId'] =transactionReferenceNumber;
			reqParams['queryDescription'] =	queryDes;
                                    			
		    supportServices.submitQuery(reqParams).then(function(data){
				
					$scope.message=data.submitQuery.message;
					$scope.queryNumber=data.submitQuery.queryReferenceNumber;
					$ionicPopup.alert({
						title: '',
						templateUrl: 'pages/support/raiseQuery/showSuccessPopup.html',
						scope: $scope,
						cssClass: 'dialog',
						buttons: [
						{                                                                  
							text: 'Ok',
							onTap: function(e) {
								$state.go('menu.support');
							}
						}
						]
					});
			}); 
	   /*****************open popoup after click on previous popup ok button and generate query ref number - end********************/		
	}
	
	//back to prev page
	categoryWiseQueryVm.goBacktoPrevious = function(){
		$state.go('menu.raiseQuery');
	}
	
	//go to next page
	categoryWiseQueryVm.goToNextPage = function(){
		
	}
	
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false)

		initPage();
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(true)

	});
	return this;
}]);
