'use strict';

angularApp.controller('supportController', 
						["$state",
						 "$location",
						 "$scope",
						 "mPinLoginService","supportServices","utilityService","openUrlInAppbroswerService","homeScreenService",
				 
function ($state,
		 $location,
		 $scope,
		 mPinLoginService,supportServices,utilityService,openUrlInAppbroswerService,homeScreenService) {
	
	//functions, variables that can be accessed from the HTML come here
	var supportVm = this;
	
	
	$location.hash('SettingsView');
	
	//private methods section start
	function initPage(){
		supportVm.isLoggedIn=mPinLoginService.isLoggedIn;
		supportVm.showBack = false;
		supportVm.showNext = true;
	}
	
	  /**************Raise Query categories navigation - start*************/	
	supportVm.raiseQuery = function(){
		//$state.go('menu.raiseQuery');
		var reqParam = {};
		reqParam["linkType"] = "raise";
		supportServices.getCMSRedirectUrl(reqParam).then(function(data){
			var url= data.url;
		    openUrlInAppbroswerService.openUrl(url ,"");
		},function(error){
			utilityService.showErrorMessage(error.responseMessage);
		}); 
	}
	supportVm.trackQuery = function(){
		//$state.go('menu.trackQuery');
		var reqParam = {};
		reqParam["linkType"] = "track";
			supportServices.getCMSRedirectUrl(reqParam).then(function(data){
			 var url= data.url;
		    openUrlInAppbroswerService.openUrl(url ,"");
	    },function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});		
	}
	supportVm.discoverOurFeature = function(){
		$state.go('menu.discoverOurFeature');
	}
	supportVm.contactUs = function(){
		$state.go('menu.contactUs');
	}
	supportVm.FAQ = function(){
		homeScreenService.isBackCheck = true;
		$state.go('menu.FAQ');
	}
	
	supportVm.chatBot = function(){
		homeScreenService.isBackCheck = true;
		$state.go('menu.chatbotlanding');
	}

	supportVm.goBack = function(){
		if(supportVm.isLoggedIn===true)
		{
		$state.go('menu.homeScreen');
		}
		else{
		$state.go('menu.userLogin');	
		}
	}
	 /**************Raise Query categories navigation - end*************/			
	  
	//back to prev page
	supportVm.goBacktoPrevious = function(){
		//To do
	}
	
	//go to next page
	supportVm.goToNextPage = function(){
		$state.go('menu.accountOverviewPopup');
	}
	
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		
		initPage();
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
	
	});
	
	//actions to done everytime the view is hidden
	$scope.$on('$ionicView.afterLeave', function() {
		
		//any cleanup needs to be done here: executes everytime when page is left
	});
	return this;
}]);