'use strict';

angularApp.controller('trackQueryController', 
						["$timeout",
						 "$state",
						 "$location",
						 "$scope",
						 "$ionicSideMenuDelegate",
						 "supportServices","utilityService","$sce","$http",
				         
function ($timeout,
		 $state,
		 $location,
		 $scope,
		 $ionicSideMenuDelegate,
		 supportServices,utilityService,$sce,$http) {
	
	//functions, variables that can be accessed from the HTML come here
	var trackQueryVm = this;
	
	$location.hash('SettingsView');
	
	//private methods section start
 	function initPage(){
		trackQueryVm.getApiKey();
		trackQueryVm.showBack = false;
		trackQueryVm.showNext = true;
	}
	trackQueryVm.getApiKey =function(){
		var reqParam = {};
		reqParam["linkType"] = "track";
			supportServices.getCMSRedirectUrl(reqParam).then(function(data){
			trackQueryVm.dataUrl= data.url;
			
	    },function(error){
			utilityService.showErrorMessage(error.responseMessage);
		});	
	}
	trackQueryVm.queryDetails=function(queryObj){
		$state.go("menu.trackQueryDetails",{queryObj:queryObj});
	}	
	trackQueryVm.trackID = function(){
		$state.go('menu.trackID',{queryObj:queryObj});
	}
	
	//private methods section end
	
	//public functions start
	
	//public functions end
	
	//back to prev page
	trackQueryVm.goBacktoPrevious = function(){
		$state.go('menu.support');
	}
	
	//go to next page
	trackQueryVm.goToNextPage = function(){
		
	}
	
	
	//one time initialization to be done when the controller is loaded
	$scope.$on('$ionicView.loaded', function() {
		$ionicSideMenuDelegate.canDragContent(false)
	});
	
	//actions to done everytime the view is shown
	$scope.$on('$ionicView.beforeEnter', function() {
		$ionicSideMenuDelegate.canDragContent(false)

		initPage();
	});
	
	//any cleanup needs to be done here: executes everytime when page is left
	$scope.$on('$ionicView.afterLeave', function() {
		$ionicSideMenuDelegate.canDragContent(true)
	});
	return this;
}]);
