angularApp.service('wealthService',
	function ($q, utilityService, AdapterUtils, customerInfoService, fixedDepositService, $ionicPopup) {
		var Welathservice = this;
		// var Welathservice = this;

		Welathservice.wcmContentAppIntegration = "";
		Welathservice.wealthLinkToKnowMore = "";
		Welathservice.bannerFlag = true;
		Welathservice.inChromeBrowser = function (url) {
			cordova.ThemeableBrowser.open(url, '_system', {
			});
		};
		
		Welathservice.WealthRedirectUrl = function () {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/WealthRedirectUrl",{}, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		Welathservice.WealthEligibilityApply = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/HomeAdapter/WealthEligibilityApply",obj, false).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};

		Welathservice.WealthLinkToSbiExclusif = function (obj) {
			var q = $q.defer();
			AdapterUtils.postData("adapters/PreApprovedLoanAdapter/getTnC",obj, true).then(
				function (response) {

					q.resolve(response.data);
				},
				function (error) {
					q.reject(error);
				}
			);
			return q.promise;
		};


		return Welathservice;
	});  