'use strict';
angularApp.controller('xcCreatedSuccessController', [
		"$state",
		"$scope",
		"$ionicPopup",
		"$translate",
		"$ionicHistory",
		"utilityService",
		"ionicDatePicker",
		"$ionicSideMenuDelegate",
		"customerInfoService",
		"xpressCreditService",
		function($state, $scope, $ionicPopup, $translate, $ionicHistory, utilityService, ionicDatePicker, $ionicSideMenuDelegate, customerInfoService, xpressCreditService) {
			
			var xcCreatedSuccessVm = this;
			
			function initPage() {
				xcCreatedSuccessVm.applicationId = xpressCreditService.createXcData.applicationId;
				xcCreatedSuccessVm.amount = xpressCreditService.createXcData.finalAmount;
				xcCreatedSuccessVm.tenure = xpressCreditService.createXcData.finaltenure;
				xcCreatedSuccessVm.xcuser = customerInfoService.customer.name;
			};

			xcCreatedSuccessVm.goToAO = function () {
				xpressCreditService.initialValueStage();
				utilityService.setCsatJournies('xpressCredit');
				$state.go('menu.loans');
			}
			
			$scope.$on('$ionicView.loaded', function () {
				initPage();
			});

			$scope.$on('$ionicView.beforeEnter', function () {
			});

			return this;
		}
]);


