'use strict';

angularApp.service('cardlessAtmService',
    function($q, AdapterUtils, constantConfig) {

        var cardlessAtmService = this;


        cardlessAtmService.getCardlessAtm = function(params) {
            var q = $q.defer(); 
            AdapterUtils.postData(constantConfig.acOpeningAdapterUrl.getAtmForGeo, params, false).then(
                function(response){ 
                    q.resolve(response.data);
                },
                function(error){    
                    q.reject(error);
                }
            );
            return q.promise;
        };


        return cardlessAtmService;
    });
