'use strict';

angularApp.controller('requestYCController', ["$state",
    "$scope",
    "aoService",
    "$ionicSideMenuDelegate",
    "mPinLoginService",
    "$translate",
    "requestYCService",
    "getAccountDetailsService",
    "utilityService",
    "homeScreenService",
    "$ionicPopup",
    "$rootScope",
    "$filter",

    function ($state,
        $scope,
        aoService,
        $ionicSideMenuDelegate,
        mPinLoginService,
        $translate,
        requestYCService,
        getAccountDetailsService,
        utilityService,
        homeScreenService,
        $ionicPopup,
        $rootScope,
        $filter
    ) {

        var requestYCVm = this;
        requestYCVm.isChallenged = false;
        requestYCVm.isValidAccount = false;
        requestYCVm.validAccountMessage = "";
        requestYCVm.disablenext = false;
        $scope.isINR = false;


        function initPage() {
            requestYCVm.ycchannel = requestYCService.ycchannel
            requestYCVm.showBack = true;
            requestYCVm.showNext = true;
            requestYCVm.payingFrom = JSON.parse(JSON.stringify(getAccountDetailsService.accountOverviewData.accounts));
            requestYCVm.accDetails = [];
            if (requestYCVm.payingFrom != null && requestYCVm.payingFrom != undefined && requestYCVm.payingFrom.length > 0) {
                var filterAccDetails = requestYCVm.payingFrom.filter(function (el) {
                    return el.accountType != "Overdraft A/c";
                }
                );
                requestYCVm.accDetails = filterAccDetails;
            }
            requestYCVm.selectedAccount = requestYCService.selectedAccValue == null ? "" : JSON.stringify(requestYCService.selectedAccValue);
            requestYCVm.showSelect = true;
            requestYCVm.gonextPg = false;
            angular.forEach(requestYCVm.accDetails, function (value, key) {
                if (value.accountType) {
                    value.accountType = value.accountType.substr(0, value.accountType.length - 1) + "C";
                }
            });
            // if(requestYCVm.ycchannel == "ATM"){
            //     requestYCVm.multipleOf500 = false;
            // }else{
            //     requestYCVm.multipleOf100 = false;
            // }
            requestYCVm.multipleOf100 = false;
            requestYCVm.multipleOf500 = false;
            requestYCVm.amountBound = false;
            //requestYCVm.amountLimit = false;
            requestYCVm.lessBal = false;

            requestYCVm.amountBoundAll = false;
            requestYCVm.amountBoundFiv = false;
            requestYCVm.amountBoundPOS = false;


            var title = '';
            var onTap = '';
            if (requestYCVm.ycchannel == 'Merchant POS-Shopping') {
                $translate(['YC_MAX_AMOUNT']).then(function (translations) {
                    requestYCVm.amount = translations['YC_MAX_AMOUNT'];
                });
            } else {
                $translate(['AMOUNT']).then(function (translations) {
                    requestYCVm.amount = translations['AMOUNT'];
                });
            }
            $translate(['YC_AMOUNT_LIMIT']).then(function (translations) {
                requestYCVm.YC_AMOUNT_LIMIT = translations['YC_AMOUNT_LIMIT'];
            });







            // if (requestYCService.selectedDetails.accountType === '') {
            //     requestYCVm.selectedValue = requestYCVm.accDetails[0].accountType + "," + requestYCVm.accDetails[0].accountNumber + "," + requestYCVm.accDetails[0].accountBalance + "," + requestYCVm.accDetails[0].isActive + "," + requestYCVm.accDetails[0].isTransactional + "," + requestYCVm.accDetails[0].intCategory + "," + requestYCVm.accDetails[0].accountTypeCode + ",0";
            //     requestYCVm.indexId = 0;
            //     requestYCVm.isActive = requestYCVm.accDetails[0].isActive;
            //     requestYCVm.isTransactional = requestYCVm.accDetails[0].isTransactional;
            //     requestYCService.customer.selectedItem = requestYCVm.accDetails[0].accountNumber;
            //     requestYCVm.selectedAccountType = requestYCVm.accDetails[0].accountType;
            //     requestYCVm.selectedAccountNumber = requestYCVm.accDetails[0].accountNumber;
            //     requestYCVm.selectedAccountAmount = requestYCVm.accDetails[0].accountBalance;
            //     requestYCVm.selectedIntCategory = requestYCVm.accDetails[0].intCategory;
            //     requestYCVm.selectedAccountTypeCode = requestYCVm.accDetails[0].accountTypeCode;
            //     requestYCService.selectedDetails.accountType = requestYCVm.selectedAccountType;
            //     requestYCService.selectedDetails.accountNumber = requestYCVm.selectedAccountNumber;
            //     requestYCService.selectedDetails.accountBalance = requestYCVm.selectedAccountAmount;
            //     requestYCService.selectedDetails.intCategory = requestYCVm.selectedIntCategory;
            //     requestYCService.selectedDetails.accountTypeCode = requestYCVm.selectedAccountTypeCode;
            //     requestYCService.selectedDetails.amount = 0
            // }
            // else {
            //     requestYCVm.indexId = requestYCService.customer.indexId;
            //     requestYCVm.selectedAccountType = requestYCService.selectedDetails.accountType;
            //     requestYCVm.selectedAccountNumber = requestYCService.selectedDetails.accountNumber;
            //     requestYCVm.selectedAccountAmount = requestYCService.selectedDetails.accountBalance;
            //     requestYCVm.selectedIntCategory = requestYCService.selectedDetails.intCategory;
            //     requestYCVm.selectedAccountTypeCode = requestYCService.selectedDetails.accountTypeCode;
            //     requestYCVm.selectedValue = requestYCVm.selectedAccountType + "," + requestYCVm.selectedAccountNumber + "," + requestYCVm.selectedAccountAmount + "," + requestYCVm.accDetails[requestYCVm.indexId].isActive + "," + requestYCVm.accDetails[requestYCVm.indexId].isTransactional + "," + requestYCVm.selectedIntCategory + "," + requestYCVm.selectedAccountTypeCode + ",0";
            //     requestYCVm.amountData =  requestYCService.selectedDetails.amount ?  requestYCService.selectedDetails.amount : 0
            //     requestYCVm.amount = requestYCVm.amountData;
            // }

            // if (requestYCVm.isActive === "false" || requestYCVm.isActive === false) {
            //     requestYCVm.disablenext = true;
            //     var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SELECT_ACTIVE_ACC_DREAM"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="ACTIVE_OR"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="CONTACT_NEAREST"></div>';
            //     requestYCService.showAlertModal(title, template, onTap, $scope, $state);
            // }

            // if (requestYCVm.isTransactional === "false" || requestYCVm.isTransactional === false) {
            //     requestYCVm.disablenext = true;
            //     var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="USE_TRANS_RIGHTS"></div>';
            //     requestYCService.showAlertModal(title, template, onTap, $scope, $state);
            // }
            $translate(['ACC_TRANS_RIGHTS', 'FETCH_TRANS_RGTS', 'YC_ACC_TRANS_RIGHTS']).then(function (translations) {
                requestYCVm.accTransRights = translations['ACC_TRANS_RIGHTS'];
                requestYCVm.fetchTransRights = translations['FETCH_TRANS_RGTS'];
                requestYCVm.accYCTransRights = translations['YC_ACC_TRANS_RIGHTS'];
            });

        }


        requestYCVm.getAccountList = function () {




            if (!getAccountDetailsService.accountOverviewData) {
                utilityService.showSpinner();
                homeScreenService.getCustomerInfo().then(function (data) {
                    utilityService.hideSpinner();
                    getAccountDetailsService.accountOverviewData = data;
                    // requestYCService.accDetails = getAccountDetailsService.accountOverviewData.accounts
                    requestYCVm.accDetails = [];
                    if (getAccountDetailsService.accountOverviewData.accounts != null && getAccountDetailsService.accountOverviewData.accounts != undefined && getAccountDetailsService.accountOverviewData.accounts.length > 0) {
                        var filterAccDetails = getAccountDetailsService.accountOverviewData.accounts.filter(function (el) {
                            return el.accountType != "Overdraft A/c";
                        }
                        );
                        requestYCVm.accDetails = filterAccDetails;
                    }
                    if (requestYCVm.accDetails.length == 0) {
                        requestYCService.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                            $state.go('menu.homeScreen');
                        });
                    }
                    requestYCVm.setPrimaryAccount();
                    //requestYCVm.close(0);

                }, function (error) {
                    utilityService.hideSpinner();
                });
            } else {

                //requestYCService.accDetails = getAccountDetailsService.accountOverviewData.accounts
                requestYCVm.accDetails = [];
                if (getAccountDetailsService.accountOverviewData.accounts != null && getAccountDetailsService.accountOverviewData.accounts != undefined && getAccountDetailsService.accountOverviewData.accounts.length > 0) {
                    var filterAccDetails = getAccountDetailsService.accountOverviewData.accounts.filter(function (el) {
                        return el.accountType != "Overdraft A/c";
                    }
                    );
                    requestYCVm.accDetails = filterAccDetails;
                }
                if (requestYCVm.accDetails.length == 0) {
                    requestYCService.displayPopUp("", "padBtm25 top-padding26", "No Accounts available", "OK", function () {
                        $state.go('menu.homeScreen');
                    });
                }
                requestYCVm.showSelect = false;
                if (requestYCService.selectedDetails.selIndex == "") {
                    requestYCVm.setPrimaryAccount();
                } else {
                    //requestYCVm.setPrimaryAccount();
                    requestYCVm.close(requestYCService.selectedDetails.selIndex);
                    //requestYCVm.close(0);
                }

            }




        }

        requestYCVm.setPrimaryAccount = function () {

            if (getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                var arr = [];
                if (requestYCVm.accDetails != null && requestYCVm.accDetails != undefined && requestYCVm.accDetails.length > 0) {
                    var filterAccDetails = requestYCVm.accDetails.filter(function (el) {
                        return el.accountType != "Overdraft A/c";
                    }
                    );
                    arr = filterAccDetails;
                }

                var primaryFlag = true;
                for (var i = 0, j = arr.length; i < j; i++) {
                    if (arr[i].accountNumber == getAccountDetailsService.accountOverviewData.customerInformation.accountNumber) {
                        primaryFlag = false;
                        var topElement = requestYCVm.accDetails[i];
                        requestYCVm.close(i);
                        if (requestYCVm.accDetails.indexOf(topElement) > 0) {
                            requestYCVm.accDetails.splice(requestYCVm.accDetails.indexOf(topElement), 1);
                            requestYCVm.accDetails.unshift(topElement);
                        }
                    }
                }
                if (primaryFlag) {
                    for (var i = 0, j = arr.length; i < j; i++) {
                        var topElement = requestYCVm.accDetails[i];
                        if (requestYCVm.accDetails.indexOf(topElement) > 0) {
                            requestYCVm.accDetails.splice(requestYCVm.accDetails.indexOf(topElement), 1);
                            requestYCVm.accDetails.unshift(topElement);
                            requestYCVm.close(i);
                        }
                    }
                }
            } else {
                requestYCVm.close(0);
            }



        };



        requestYCVm.showPop = function () {
            requestYCVm.popUp = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin popupBackgroundWhite removePopup-head textAlignCenter edu-scroll',
                templateUrl: 'pages/yonoCash/landing/dropdownModal.html',
                scope: $scope
            });
        }

        requestYCVm.close = function (index) {
            var title = '';
            var onTap = '';
            if (requestYCVm.popUp) {
                requestYCVm.popUp.close();
            }

            requestYCVm.balance = requestYCVm.accDetails[index].accountBalance;
            requestYCVm.accType = requestYCVm.accDetails[index].accountType;
            requestYCVm.accountNumber = requestYCVm.accDetails[index].accountNumber;
            requestYCVm.isActive = requestYCVm.accDetails[index].isActive;
            requestYCVm.isTransactional = requestYCVm.accDetails[index].isTransactional;
            requestYCService.selectedDetails.selIndex = index;
            requestYCService.selectedDetails.accountNumber = requestYCVm.accDetails[index].accountNumber;
            requestYCService.selectedDetails.accountBalance = requestYCVm.accDetails[index].accountBalance;
            requestYCVm.showSelect = false;

            if (requestYCVm.isActive === "false" || requestYCVm.isActive === false) {
                requestYCVm.disablenext = true;
                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SELECT_ACTIVE_ACC_DREAM"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="ACTIVE_OR"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="CONTACT_NEAREST"></div>';
                requestYCService.showAlertModal(title, template, onTap, $scope, $state);
            }

            if (requestYCVm.isTransactional === "false" || requestYCVm.isTransactional === false) {
                requestYCVm.disablenext = true;
                var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="USE_TRANS_RIGHTS"></div>';
                requestYCService.showAlertModal(title, template, onTap, $scope, $state);
            }
            //requestYCVm.changeAmount();
            requestYCVm.isValidAccount = false;
        }

        /*New Access rights changes */
        requestYCVm.proceedNext = function () {
            if (requestYCVm.gonextPg == true) {
                requestYCService.fetchDailyLimit(requestYCService.selectedDetails.accountNumber).then(function (data) {
                    if (data > 0 && data >= parseFloat(requestYCVm.amountData.replace(",", ""))) {
                        //requestYCVm.amountLimit = false;
                        requestYCService.selectedDetails.amount = parseFloat(requestYCVm.amountData.replace(",", ""));
                        $state.go('menu.createPinYC')
                    } else {
                        utilityService.showErrorMessage(requestYCVm.YC_AMOUNT_LIMIT);
                    }

                }, function (error) {
                    utilityService.showErrorMessage(error.responseMessage);
                    //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
                });
            }
        }

        requestYCVm.validateAmount = function () {
            var isAccountTransactional = false;
            for (var i in getAccountDetailsService.accessRightsData.accounts) {
                if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === requestYCService.selectedDetails.accountNumber && parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) != 0) {
                    isAccountTransactional = true;
                }
            }
            if (isAccountTransactional) {
                requestYCVm.isAmtMoreThanBal = false;
                requestYCVm.isValidAccount = false;
                requestYCVm.amountBoundPOS = false;
                requestYCVm.amountBoundAll = false;
                requestYCVm.amountBoundFiv = false;

                requestYCVm.multipleOf100 = false;
                requestYCVm.multipleOf500 = false;
                if (getAccountDetailsService.accessRightsData.accounts) {
                    for (var i in getAccountDetailsService.accessRightsData.accounts) {
                        if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === requestYCService.selectedDetails.accountNumber && getAccountDetailsService.accessRightsData.accounts[i].modBalance) {
                            requestYCVm.sumModAccountAmount = parseFloat(requestYCService.selectedDetails.accountBalance) + parseFloat(getAccountDetailsService.accessRightsData.accounts[i].modBalance);
                            break;
                        }
                    }
                } else {
                    requestYCVm.sumModAccountAmount = parseFloat(requestYCService.selectedDetails.amount);
                }

                if (requestYCVm.amountData) {
                    if (requestYCVm.sumModAccountAmount >= parseFloat(requestYCVm.amountData.replace(",", ""))) {
                        //success     

                        if (requestYCVm.ycchannel == "ATM") {
                            if (parseFloat(requestYCVm.amountData.replace(",", "")) % 500 == 0) {
                                requestYCVm.multipleOf500 = false;

                                if (parseFloat(requestYCVm.amountData.replace(",", "")) >= 500 && parseFloat(requestYCVm.amountData.replace(",", "")) <= 20000) {
                                    //  requestYCVm.amountBound = false;
                                    requestYCVm.disablenext = false;
                                    requestYCVm.isAmtMoreThanBal = false;
                                    requestYCVm.gonextPg = true;
                                    //requestYCVm.amountBoundAll = false;
                                    requestYCVm.amountBoundFiv = false;
                                    //requestYCVm.amountBoundPOS = false;
                                } else {
                                    //   requestYCVm.amountBound = true;
                                    //requestYCVm.amountBoundAll = true;
                                    requestYCVm.amountBoundFiv = true;
                                    requestYCVm.disablenext = true
                                }


                            } else {
                                requestYCVm.amountBoundFiv = false;
                                requestYCVm.amountBoundPOS = false;
                                requestYCVm.amountBoundAll = false;
                                requestYCVm.multipleOf500 = true
                                requestYCVm.disablenext = true
                            }
                        } else {
                            if (parseFloat(requestYCVm.amountData.replace(",", "")) % 100 == 0) {
                                requestYCVm.multipleOf100 = false;

                                if ($rootScope.isMerchantPOS) {
                                    if (parseFloat(requestYCVm.amountData.replace(",", "")) >= 100 && parseFloat(requestYCVm.amountData.replace(",", "")) <= 2000) {
                                        //  requestYCVm.amountBound = false;
                                        requestYCVm.disablenext = false;
                                        requestYCVm.isAmtMoreThanBal = false;
                                        requestYCVm.gonextPg = true;
                                        //  requestYCVm.amountBoundAll = false;
                                        requestYCVm.amountBoundPOS = false;
                                        requestYCVm.amountBoundFiv = false;
                                    } else {
                                        // requestYCVm.amountBound = true;
                                        requestYCVm.amountBoundPOS = true;
                                        requestYCVm.disablenext = true
                                    }
                                } else {
                                    if (parseFloat(requestYCVm.amountData.replace(",", "")) >= 100 && parseFloat(requestYCVm.amountData.replace(",", "")) <= 10000) {
                                        //  requestYCVm.amountBound = false;
                                        requestYCVm.disablenext = false;
                                        requestYCVm.isAmtMoreThanBal = false;
                                        requestYCVm.gonextPg = true;
                                        requestYCVm.amountBoundAll = false;
                                        requestYCVm.amountBoundFiv = false;
                                        //requestYCVm.amountBoundPOS = false;
                                    } else {
                                        //   requestYCVm.amountBound = true;
                                        requestYCVm.amountBoundAll = true;
                                        requestYCVm.disablenext = true
                                    }
                                }

                            } else {
                                requestYCVm.amountBoundPOS = false;
                                requestYCVm.amountBoundAll = false;
                                requestYCVm.amountBoundFiv = false;
                                requestYCVm.multipleOf100 = true
                                requestYCVm.disablenext = true
                            }

                        }

                    } else {
                        requestYCVm.amountBoundPOS = false;
                        requestYCVm.amountBoundAll = false;
                        requestYCVm.amountBoundFiv = false;
                        requestYCVm.isAmtMoreThanBal = true
                        requestYCVm.disablenext = true;
                    }
                }

            } else {
                requestYCVm.amountBoundPOS = false;
                requestYCVm.amountBoundAll = false;
                requestYCVm.amountBoundFiv = false;
                requestYCVm.disablenext = true;
                requestYCVm.isValidAccount = true;
                requestYCVm.validAccountMessage = requestYCVm.accYCTransRights;
            }
            requestYCVm.proceedNext();
        }
        /*End of New Access rights changes */

        requestYCVm.changeAmount = function () {
            if (requestYCVm.amountData == '0') {
                requestYCVm.amountData = '';
            }
            // if(requestYCVm.amountData){
            //     requestYCVm.amountData =  parseFloat(requestYCVm.amountData);
            // }

            /*New Access rights changes */
            if (homeScreenService.isAccessRightsAvail) {
                var pleaseWaitPopUp = $ionicPopup.show({
                    title: null,
                    cssClass: 'my-custom-popup',
                    template: '<div class="button_fund fontSize-subHeading roboto-light font-dark-grey" translate="PLEASE_WAIT_ACCESSRIGHTS"></div>',
                    buttons: [{
                        text: 'OK',
                        type: 'button-assertive'
                    }]
                });
            } else {
                if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
                    getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
                        getAccountDetailsService.accessRightsData = data;
                        requestYCVm.validateAmount();

                    }, function (error) {
                        requestYCVm.disablenext = true;
                        requestYCVm.isValidAccount = true;
                        requestYCVm.validAccountMessage = requestYCVm.fetchTransRights;
                    })
                } else {
                    requestYCVm.validateAmount();
                }
            }
            /*End of New Access rights changes */

            // if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
            //         requestYCVm.disablenext = true;
            //         requestYCVm.isValidAccount = true;
            //         requestYCVm.validAccountMessage = requestYCVm.fetchTransRights;
            //     } else {
            //         var isAccountTransactional = false;
            //         for (var i in getAccountDetailsService.accessRightsData.accounts) {
            //             if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === requestYCService.selectedDetails.accountNumber && parseInt(getAccountDetailsService.accessRightsData.accounts[i].accessResponse) != 0) {
            //                 isAccountTransactional = true;
            //             }
            //         }
            //         if (isAccountTransactional) {
            //             requestYCVm.isAmtMoreThanBal = false;
            //             requestYCVm.isValidAccount = false;
            //             requestYCVm.amountBoundPOS =false;
            //             requestYCVm.amountBoundAll = false;
            //             requestYCVm.amountBoundFiv = false;

            //             requestYCVm.multipleOf100 = false;
            //             requestYCVm.multipleOf500 = false;
            //             if (getAccountDetailsService.accessRightsData.accounts) {
            //                 for (var i in getAccountDetailsService.accessRightsData.accounts) {
            //                     if (getAccountDetailsService.accessRightsData.accounts[i].accountNumber === requestYCService.selectedDetails.accountNumber && getAccountDetailsService.accessRightsData.accounts[i].modBalance) {
            //                         requestYCVm.sumModAccountAmount = parseFloat(requestYCService.selectedDetails.accountBalance) + parseFloat(getAccountDetailsService.accessRightsData.accounts[i].modBalance);
            //                         break;
            //                     }
            //                 }
            //             } else {
            //                 requestYCVm.sumModAccountAmount = parseFloat(requestYCService.selectedDetails.amount);
            //             }

            //             if(requestYCVm.amountData){
            //                  if (requestYCVm.sumModAccountAmount >= parseFloat(requestYCVm.amountData.replace(",", ""))) {
            //                 //success     

            //                     if(requestYCVm.ycchannel == "ATM"){
            //                         if (parseFloat(requestYCVm.amountData.replace(",", "")) % 500 == 0) {
            //                             requestYCVm.multipleOf500 = false;                                                   

            //                                 if (parseFloat(requestYCVm.amountData.replace(",", "")) >= 500 && parseFloat(requestYCVm.amountData.replace(",", "")) <= 20000) {                                                    
            //                                   //  requestYCVm.amountBound = false;
            //                                     requestYCVm.disablenext = false ;
            //                                     requestYCVm.isAmtMoreThanBal = false;
            //                                     requestYCVm.gonextPg = true;   
            //                                     //requestYCVm.amountBoundAll = false;
            //                                     requestYCVm.amountBoundFiv = false;
            //                                     //requestYCVm.amountBoundPOS = false;
            //                                 } else {
            //                                  //   requestYCVm.amountBound = true;
            //                                     //requestYCVm.amountBoundAll = true;
            //                                     requestYCVm.amountBoundFiv = true;
            //                                     requestYCVm.disablenext = true
            //                                 }


            //                         } else {
            //                             requestYCVm.amountBoundFiv = false;
            //                             requestYCVm.amountBoundPOS =false;
            //                             requestYCVm.amountBoundAll = false;
            //                             requestYCVm.multipleOf500 = true
            //                             requestYCVm.disablenext = true
            //                         }
            //                     }else{
            //                         if (parseFloat(requestYCVm.amountData.replace(",", "")) % 100 == 0) {
            //                             requestYCVm.multipleOf100 = false;

            //                             if($rootScope.isMerchantPOS){
            //                                 if (parseFloat(requestYCVm.amountData.replace(",", "")) >= 100 && parseFloat(requestYCVm.amountData.replace(",", "")) <= 2000) {                                                    
            //                                   //  requestYCVm.amountBound = false;
            //                                     requestYCVm.disablenext = false ;
            //                                     requestYCVm.isAmtMoreThanBal = false;
            //                                     requestYCVm.gonextPg = true;  
            //                                   //  requestYCVm.amountBoundAll = false;
            //                                     requestYCVm.amountBoundPOS = false;
            //                                     requestYCVm.amountBoundFiv = false;
            //                                 } else {
            //                                    // requestYCVm.amountBound = true;
            //                                     requestYCVm.amountBoundPOS =true;
            //                                     requestYCVm.disablenext = true
            //                                 }
            //                             }else{
            //                                 if (parseFloat(requestYCVm.amountData.replace(",", "")) >= 100 && parseFloat(requestYCVm.amountData.replace(",", "")) <= 10000) {                                                    
            //                                   //  requestYCVm.amountBound = false;
            //                                     requestYCVm.disablenext = false ;
            //                                     requestYCVm.isAmtMoreThanBal = false;
            //                                     requestYCVm.gonextPg = true;   
            //                                     requestYCVm.amountBoundAll = false;
            //                                     requestYCVm.amountBoundFiv = false;
            //                                     //requestYCVm.amountBoundPOS = false;
            //                                 } else {
            //                                  //   requestYCVm.amountBound = true;
            //                                     requestYCVm.amountBoundAll = true;
            //                                     requestYCVm.disablenext = true
            //                                 }
            //                             }

            //                         } else {
            //                             requestYCVm.amountBoundPOS =false;
            //                             requestYCVm.amountBoundAll = false;
            //                             requestYCVm.amountBoundFiv = false;
            //                             requestYCVm.multipleOf100 = true
            //                             requestYCVm.disablenext = true
            //                         }

            //                     }                                            

            //                 } else {
            //                     requestYCVm.amountBoundPOS =false;
            //                     requestYCVm.amountBoundAll = false;
            //                     requestYCVm.amountBoundFiv = false;
            //                     requestYCVm.isAmtMoreThanBal = true
            //                     requestYCVm.disablenext = true;
            //                 }
            //             }                               

            //         } else {
            //             requestYCVm.amountBoundPOS =false;
            //             requestYCVm.amountBoundAll = false;
            //             requestYCVm.amountBoundFiv = false;
            //             requestYCVm.disablenext = true;
            //             requestYCVm.isValidAccount = true;
            //             requestYCVm.validAccountMessage = requestYCVm.accTransRights;
            //         }
            //     }
        }

        /* change event for selecting account*/
        // requestYCVm.selectedAccountFun = function () {
        //     requestYCVm.gonextPg = false;
        //     var data = requestYCVm.selectedValue.split(",");
        //     var e = [];
        //     e.accountType = data[0];
        //     e.accountNumber = data[1];
        //     e.accountBalance = data[2];
        //     e.isActive = data[3];
        //     e.isTransactional = data[4];
        //     e.intCategory = data[5];
        //     e.accountTypeCode = data[6];
        //     e.indexId = data[7];
        //     requestYCVm.indexId = e.indexId;
        //     requestYCService.customer.indexId = requestYCVm.indexId;
        //     requestYCVm.isActive = e.isActive;
        //     requestYCVm.isTransactional = e.isTransactional;
        //     var title = '';
        //     var onTap = '';

        //     if (requestYCVm.isActive === "true" && requestYCVm.isTransactional === "true") {
        //         requestYCVm.selectedAccountType = e.accountType;
        //         requestYCVm.selectedAccountNumber = e.accountNumber;
        //         requestYCVm.selectedAccountAmount = e.accountBalance;
        //         requestYCService.customer.selectedItem = e.accountNumber;
        //         requestYCService.selectedDetails.accountType = e.accountType;
        //         requestYCService.selectedDetails.accountNumber = e.accountNumber;
        //         requestYCService.selectedDetails.accountBalance = e.accountBalance;
        //         requestYCService.selectedDetails.intCategory = e.intCategory;
        //         requestYCService.selectedDetails.accountTypeCode = e.accountTypeCode;
        //         requestYCVm.disablenext = false;

        //         if(requestYCVm.amountData){
        //             if(parseFloat(requestYCVm.amountData) > 0){
        //              requestYCVm.changeAmount();   
        //             }
        //         }
        //     } else {
        //         if (requestYCVm.isActive === "false" || requestYCVm.isActive === false) {
        //             requestYCVm.disablenext = true;
        //             var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="SELECT_ACTIVE_ACC_DREAM"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="ACTIVE_OR"></div><div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="CONTACT_NEAREST"></div>';
        //             requestYCService.showAlertModal(title, template, onTap, $scope, $state);
        //         }

        //         if (requestYCVm.isTransactional === "false" || requestYCVm.isTransactional === false) {
        //             requestYCVm.disablenext = true;
        //             var template = '<div class="amt_limit fontSize-subHeading roboto-light font-dark-grey" translate="USE_TRANS_RIGHTS"></div>';
        //             requestYCService.showAlertModal(title, template, onTap, $scope, $state);
        //         }
        //      requestYCVm.isValidAccount = false;
        //      requestYCVm.validAccountMessage = "";
        //     }
        //     if(!requestYCVm.amountData){
        //       requestYCVm.isValidAccount = false;  
        //     }

        // };




        //Function for close view
        requestYCVm.closeView = function () {
            $state.go('menu.homeScreen');
        }

        requestYCVm.onKeyUp = function () {
            $scope.isINR = true;
        }

        //onclick of Back button
        requestYCVm.goBacktoPrevious = function () {
            $state.go('menu.yonoCash');
        };

        //onclick of next button
        requestYCVm.goToNextPage = function () {
            requestYCVm.changeAmount();
            // if(requestYCVm.gonextPg == true){
            //     requestYCService.fetchDailyLimit(requestYCService.selectedDetails.accountNumber).then(function (data) {
            //         if (data > 0 && data >= parseFloat(requestYCVm.amountData.replace(",", ""))) {
            //             //requestYCVm.amountLimit = false;
            //             requestYCService.selectedDetails.amount = parseFloat(requestYCVm.amountData.replace(",", ""));
            //             $state.go('menu.createPinYC')
            //         } else {
            //             utilityService.showErrorMessage(requestYCVm.YC_AMOUNT_LIMIT);
            //         }

            //     }, function (error) {
            //         utilityService.showErrorMessage(error.responseMessage);
            //         //utilityService.showErrorMessage(utilityService.getServerExceptionMessage(error));
            //     });
            // }

        }


        //one time initialization to be done when the controller is loaded
        $scope.$on('$ionicView.loaded', function () {
            requestYCVm.getAccountList();
            // if (getAccountDetailsService.accessRightsData.accounts == null || getAccountDetailsService.accessRightsData.accounts == "") {
            //     getAccountDetailsService.getAccountsAccessRights('').then(function (data) {
            //         getAccountDetailsService.accessRightsData = data;
            //     }, function (error) {
            //         // Failure block
            //     });
            // }
        });


        //actions to done everytime the view is shown
        $scope.$on('$ionicView.beforeEnter', function () {
            initPage();
            $ionicSideMenuDelegate.canDragContent(mPinLoginService.isLoggedIn);
            if (requestYCService.selectedDetails.amount && requestYCService.selectedDetails.amount != "") {
                requestYCVm.amountData = $filter('INR')(requestYCService.selectedDetails.amount);
                //requestYCVm.amountData = requestYCService.selectedDetails.amount;
                //requestYCVm.changeAmount();
            }
        });

        $scope.$on('$ionicView.beforeLeave', function () {

        });

        return this;
    }
]);
