'use strict';

angularApp.controller('blockingWearableController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "wearableServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        wearableServices) {

        var blockingWearableControllerVM = this;
        blockingWearableControllerVM.blockingReason = "";
        $scope.wearableDisplayname = $rootScope.wearableDisplayname;
        blockingWearableControllerVM.disablebtn = true;
        blockingWearableControllerVM.isAndroid = false;

        blockingWearableControllerVM.goBack = function(){
            $ionicHistory.goBack();
        }


        blockingWearableControllerVM.gotoNext = function(){
            $state.go("menu.termsConditionsNPSView");
        }

        $scope.$watch("blockingWearableControllerVM.blockingReason",function(newValue,oldValue){
            newValue ? blockingWearableControllerVM.disablebtn = false : blockingWearableControllerVM.disablebtn = true;
        });

        $scope.$on('$ionicView.beforeEnter', function () {
            blockingWearableControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            var devicePlatform = device.platform;

            blockingWearableControllerVM.isAndroid = (devicePlatform.toLowerCase() == 'android') ? true : false;
            blockingWearableControllerVM.reasonList =[{val:"2",label:"Lost"},{val:"3",label:"Stolen"}];
        });

     /*   blockingWearableControllerVM.checkVal = function(reasonObj){
            console.log("reasonObj"+ JSON.stringify(reasonObj));
        }*/

        blockingWearableControllerVM.blockNow = function(){
             //utilityService.showSpinner();
             blockingWearableControllerVM.disablebtn = true;
            wearableServices.blockWearableRequest(wearableServices.cardNumber,blockingWearableControllerVM.blockingReason,'Permanent').then(function (data) {
               //utilityService.hideSpinner(); 
               

                if(data.responseCode == '0000'){
                
                blockingWearableControllerVM.blockReasonPopup = $ionicPopup.show({
                    title: '',
                    cssClass: 'popupWidth90 popupMargin ftpopup-body popupBackgroundWhite removePopup-head textAlignCenter yonoWeableBackdrop',
                    templateUrl: "pages/yonoWearable/blockingWearableReason/blockingSuccessPopup.html",
                    scope: $scope
                });

            }else{
                    blockingWearableControllerVM.disablebtn = false;
                    utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(data.responseMessage);
                    utilityService.disableShowErrorMessage();
                };

            }, function (error) {
                blockingWearableControllerVM.disablebtn = false;
                //utilityService.hideSpinner(); 
                utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
                    
            });
            
        }

        blockingWearableControllerVM.gotoLanding =function(){s
            blockingWearableControllerVM.blockReasonPopup.close();
            homeScreenService.ishamburgerMenuRO=false;
            homeScreenService.isMyWearableFlag = true;
            getAccountDetailsService.tabIndex.tabIndex=6;
            console.log("inside goToDeposits");
            $state.go('menu.accountOverviewMyBalance');
            //$state.go("menu.landingYonoWearable");
        }

        return this;
    }
]);
