'use strict';

angularApp.controller('landingWearableSuccessController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "$ionicViewSwitcher",
    "wearableServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        $ionicViewSwitcher,
        wearableServices) {

        var landingWearableSuccessControllerVM = this;

        landingWearableSuccessControllerVM.close = function () {
            $ionicViewSwitcher.nextDirection('back');
            homeScreenService.ishamburgerMenuRO = false;
            homeScreenService.isDepositsFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 6;
            console.log("inside goToDeposits");
            $state.go('menu.accountOverviewMyBalance');
            //$state.go('menu.homeScreen');
        }

        landingWearableSuccessControllerVM.goBack = function () {
            $ionicHistory.goBack();
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            landingWearableSuccessControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
        });



        landingWearableSuccessControllerVM.enableWearable = function () {

            landingWearableSuccessControllerVM.myEnablePopup = $ionicPopup.show({
                title: '',
                cssClass: 'popupWidth90 popupMargin ftpopup-body popupBackgroundWhite removePopup-head textAlignCenter yonoWeableBackdrop',
                templateUrl: "pages/yonoWearable/linkSuccess/enableSuccessPopup.html",
                scope: $scope
            });
        }

        landingWearableSuccessControllerVM.gotoyourWearables = function () {
            homeScreenService.ishamburgerMenuRO = false;
            homeScreenService.isDepositsFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 6;
            console.log("inside goToDeposits");
            $state.go('menu.accountOverviewMyBalance');
            // $state.go('menu.landingYonoWearable');
        }

        landingWearableSuccessControllerVM.gotoNext = function () {
            landingWearableSuccessControllerVM.myEnablePopup.close();
            homeScreenService.ishamburgerMenuRO = false;
            homeScreenService.isDepositsFlag = true;
            getAccountDetailsService.tabIndex.tabIndex = 6;
            console.log("inside goToDeposits");
            $state.go('menu.accountOverviewMyBalance');
            // $state.go('menu.landingYonoWearable');
        }

        return this;
    }
]);
