'use strict';

angularApp.controller('transactionListController', ["$timeout",
    "$ionicPopup",
    "$state",
    "$scope",
    "$rootScope",
    "$translate",
    "$location",
    "$ionicScrollDelegate",
    "getAccountDetailsService",
    "$ionicSlideBoxDelegate",
    "utilityService",
    "$ionicHistory",
    "homeScreenService",
    "wearableServices",
    function ($timeout,
        $ionicPopup,
        $state,
        $scope,
        $rootScope,
        $translate,
        $location,
        $ionicScrollDelegate,
        getAccountDetailsService,
        $ionicSlideBoxDelegate,
        utilityService,
        $ionicHistory,
        homeScreenService,
        wearableServices) {

        var transactionListControllerVM = this;
        transactionListControllerVM.transAccountNumber = wearableServices.selectedAccountNumber;
        console.log("transactionListControllerVM.transAccountNumber" + transactionListControllerVM.transAccountNumber)

        transactionListControllerVM.goBack = function(){
            $ionicHistory.goBack();
        }

        $scope.$on('$ionicView.beforeEnter', function () {
            transactionListControllerVM.isBackCheck = homeScreenService.isBackCheck;
            homeScreenService.isBackCheck = false;
            transactionListControllerVM.fetchTransactionDetails();

        });

        transactionListControllerVM.fetchTransactionDetails = function(){

            	wearableServices.getTransactions(transactionListControllerVM.transAccountNumber, "D").then(function (data) {

				if (!utilityService.isUndefined(data.transactions)) {
					transactionListControllerVM.transactionList = data.transactions;
				}
				

			},  function(error) {
                 utilityService.enableShowErrorMessage();
                    utilityService.showErrorMessage(error.responseMessage);
                    utilityService.disableShowErrorMessage();
            });
           
        }

        return this;
    }
]);
